# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class ACSE_1:

    _name_  = u'ACSE-1'
    _oid_   = [2, 2, 0, 0, 1]
    
    _obj_ = [
        u'acse-as-id',
        u'aCSE-id',
        u'ACSE-apdu',
        u'AARQ-apdu',
        u'AARE-apdu',
        u'RLRQ-apdu',
        u'RLRE-apdu',
        u'ABRT-apdu',
        u'ABRT-diagnostic',
        u'ABRT-source',
        u'ACSE-requirements',
        u'Application-context-name-list',
        u'Application-context-name',
        u'AP-title',
        u'AE-qualifier',
        u'AP-title-form1',
        u'AE-qualifier-form1',
        u'AP-title-form2',
        u'AE-qualifier-form2',
        u'AE-title',
        u'AE-title-form1',
        u'AE-title-form2',
        u'AE-invocation-identifier',
        u'AP-invocation-identifier',
        u'Associate-result',
        u'Associate-source-diagnostic',
        u'Association-information',
        u'Authentication-value',
        u'Implementation-data',
        u'Mechanism-name',
        u'MECHANISM-NAME',
        u'ObjectSet',
        u'Release-request-reason',
        u'Release-response-reason',
        ]
    _type_ = [
        u'ACSE-apdu',
        u'AARQ-apdu',
        u'AARE-apdu',
        u'RLRQ-apdu',
        u'RLRE-apdu',
        u'ABRT-apdu',
        u'ABRT-diagnostic',
        u'ABRT-source',
        u'ACSE-requirements',
        u'Application-context-name-list',
        u'Application-context-name',
        u'AP-title',
        u'AE-qualifier',
        u'AP-title-form1',
        u'AE-qualifier-form1',
        u'AP-title-form2',
        u'AE-qualifier-form2',
        u'AE-title',
        u'AE-title-form1',
        u'AE-title-form2',
        u'AE-invocation-identifier',
        u'AP-invocation-identifier',
        u'Associate-result',
        u'Associate-source-diagnostic',
        u'Association-information',
        u'Authentication-value',
        u'Implementation-data',
        u'Mechanism-name',
        u'MECHANISM-NAME',
        u'Release-request-reason',
        u'Release-response-reason',
        ]
    _set_ = [
        u'ObjectSet',
        ]
    _val_ = [
        u'acse-as-id',
        u'aCSE-id',
        ]
    _class_ = [
        u'MECHANISM-NAME',
        u'ObjectSet',
        ]
    _param_ = [
        ]
    
    #-----< acse-as-id >-----#
    acse_as_id = OID(name=u'acse-as-id', mode=MODE_VALUE)
    acse_as_id._val = (2, 2, 1, 0, 1)
    
    #-----< aCSE-id >-----#
    aCSE_id = OID(name=u'aCSE-id', mode=MODE_VALUE)
    aCSE_id._val = (2, 2, 3, 1, 1)
    
    #-----< ACSE-apdu >-----#
    ACSE_apdu = CHOICE(name=u'ACSE-apdu', mode=MODE_TYPE)
    _ACSE_apdu_aarq = SEQ(name=u'aarq', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AARQ-apdu')))
    _ACSE_apdu_aare = SEQ(name=u'aare', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AARE-apdu')))
    _ACSE_apdu_rlrq = SEQ(name=u'rlrq', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'RLRQ-apdu')))
    _ACSE_apdu_rlre = SEQ(name=u'rlre', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'RLRE-apdu')))
    _ACSE_apdu_abrt = SEQ(name=u'abrt', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'ABRT-apdu')))
    ACSE_apdu._cont = ASN1Dict([
        (u'aarq', _ACSE_apdu_aarq),
        (u'aare', _ACSE_apdu_aare),
        (u'rlrq', _ACSE_apdu_rlrq),
        (u'rlre', _ACSE_apdu_rlre),
        (u'abrt', _ACSE_apdu_abrt),
        ])
    ACSE_apdu._ext = []
    
    #-----< AARQ-apdu >-----#
    AARQ_apdu = SEQ(name=u'AARQ-apdu', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _AARQ_apdu_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AARQ_apdu_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _AARQ_apdu_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'Application-context-name')))
    _AARQ_apdu_called_AP_title = CHOICE(name=u'called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AP-title')), opt=True)
    _AARQ_apdu_called_AE_qualifier = CHOICE(name=u'called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-qualifier')), opt=True)
    _AARQ_apdu_called_AP_invocation_identifier = INT(name=u'called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AP-invocation-identifier')), opt=True)
    _AARQ_apdu_called_AE_invocation_identifier = INT(name=u'called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-invocation-identifier')), opt=True)
    _AARQ_apdu_calling_AP_title = CHOICE(name=u'calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AP-title')), opt=True)
    _AARQ_apdu_calling_AE_qualifier = CHOICE(name=u'calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-qualifier')), opt=True)
    _AARQ_apdu_calling_AP_invocation_identifier = INT(name=u'calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AP-invocation-identifier')), opt=True)
    _AARQ_apdu_calling_AE_invocation_identifier = INT(name=u'calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-invocation-identifier')), opt=True)
    _AARQ_apdu_sender_acse_requirements = BIT_STR(name=u'sender-acse-requirements', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'ACSE-requirements')), opt=True)
    _AARQ_apdu_mechanism_name = OID(name=u'mechanism-name', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Mechanism-name')), opt=True)
    _AARQ_apdu_calling_authentication_value = CHOICE(name=u'calling-authentication-value', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'Authentication-value')), opt=True)
    _AARQ_apdu_application_context_name_list = SEQ_OF(name=u'application-context-name-list', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Application-context-name-list')), opt=True)
    _AARQ_apdu_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Implementation-data')), opt=True)
    _AARQ_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Association-information')), opt=True)
    AARQ_apdu._cont = ASN1Dict([
        (u'protocol-version', _AARQ_apdu_protocol_version),
        (u'application-context-name', _AARQ_apdu_application_context_name),
        (u'called-AP-title', _AARQ_apdu_called_AP_title),
        (u'called-AE-qualifier', _AARQ_apdu_called_AE_qualifier),
        (u'called-AP-invocation-identifier', _AARQ_apdu_called_AP_invocation_identifier),
        (u'called-AE-invocation-identifier', _AARQ_apdu_called_AE_invocation_identifier),
        (u'calling-AP-title', _AARQ_apdu_calling_AP_title),
        (u'calling-AE-qualifier', _AARQ_apdu_calling_AE_qualifier),
        (u'calling-AP-invocation-identifier', _AARQ_apdu_calling_AP_invocation_identifier),
        (u'calling-AE-invocation-identifier', _AARQ_apdu_calling_AE_invocation_identifier),
        (u'sender-acse-requirements', _AARQ_apdu_sender_acse_requirements),
        (u'mechanism-name', _AARQ_apdu_mechanism_name),
        (u'calling-authentication-value', _AARQ_apdu_calling_authentication_value),
        (u'application-context-name-list', _AARQ_apdu_application_context_name_list),
        (u'implementation-information', _AARQ_apdu_implementation_information),
        (u'user-information', _AARQ_apdu_user_information),
        ])
    AARQ_apdu._ext = [u'user-information']
    
    #-----< AARE-apdu >-----#
    AARE_apdu = SEQ(name=u'AARE-apdu', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _AARE_apdu_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AARE_apdu_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _AARE_apdu_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'Application-context-name')))
    _AARE_apdu_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'Associate-result')))
    _AARE_apdu_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'Associate-source-diagnostic')))
    _AARE_apdu_responding_AP_title = CHOICE(name=u'responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AP-title')), opt=True)
    _AARE_apdu_responding_AE_qualifier = CHOICE(name=u'responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-qualifier')), opt=True)
    _AARE_apdu_responding_AP_invocation_identifier = INT(name=u'responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AP-invocation-identifier')), opt=True)
    _AARE_apdu_responding_AE_invocation_identifier = INT(name=u'responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-invocation-identifier')), opt=True)
    _AARE_apdu_responder_acse_requirements = BIT_STR(name=u'responder-acse-requirements', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'ACSE-requirements')), opt=True)
    _AARE_apdu_mechanism_name = OID(name=u'mechanism-name', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Mechanism-name')), opt=True)
    _AARE_apdu_responding_authentication_value = CHOICE(name=u'responding-authentication-value', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ACSE-1', 'Authentication-value')), opt=True)
    _AARE_apdu_application_context_name_list = SEQ_OF(name=u'application-context-name-list', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Application-context-name-list')), opt=True)
    _AARE_apdu_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Implementation-data')), opt=True)
    _AARE_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Association-information')), opt=True)
    AARE_apdu._cont = ASN1Dict([
        (u'protocol-version', _AARE_apdu_protocol_version),
        (u'application-context-name', _AARE_apdu_application_context_name),
        (u'result', _AARE_apdu_result),
        (u'result-source-diagnostic', _AARE_apdu_result_source_diagnostic),
        (u'responding-AP-title', _AARE_apdu_responding_AP_title),
        (u'responding-AE-qualifier', _AARE_apdu_responding_AE_qualifier),
        (u'responding-AP-invocation-identifier', _AARE_apdu_responding_AP_invocation_identifier),
        (u'responding-AE-invocation-identifier', _AARE_apdu_responding_AE_invocation_identifier),
        (u'responder-acse-requirements', _AARE_apdu_responder_acse_requirements),
        (u'mechanism-name', _AARE_apdu_mechanism_name),
        (u'responding-authentication-value', _AARE_apdu_responding_authentication_value),
        (u'application-context-name-list', _AARE_apdu_application_context_name_list),
        (u'implementation-information', _AARE_apdu_implementation_information),
        (u'user-information', _AARE_apdu_user_information),
        ])
    AARE_apdu._ext = [u'user-information']
    
    #-----< RLRQ-apdu >-----#
    RLRQ_apdu = SEQ(name=u'RLRQ-apdu', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT))
    _RLRQ_apdu_reason = INT(name=u'reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Release-request-reason')), opt=True)
    _RLRQ_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Association-information')), opt=True)
    RLRQ_apdu._cont = ASN1Dict([
        (u'reason', _RLRQ_apdu_reason),
        (u'user-information', _RLRQ_apdu_user_information),
        ])
    RLRQ_apdu._ext = [u'user-information']
    
    #-----< RLRE-apdu >-----#
    RLRE_apdu = SEQ(name=u'RLRE-apdu', mode=MODE_TYPE, tag=(3, TAG_APPLICATION, TAG_IMPLICIT))
    _RLRE_apdu_reason = INT(name=u'reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Release-response-reason')), opt=True)
    _RLRE_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Association-information')), opt=True)
    RLRE_apdu._cont = ASN1Dict([
        (u'reason', _RLRE_apdu_reason),
        (u'user-information', _RLRE_apdu_user_information),
        ])
    RLRE_apdu._ext = [u'user-information']
    
    #-----< ABRT-apdu >-----#
    ABRT_apdu = SEQ(name=u'ABRT-apdu', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT))
    _ABRT_apdu_abort_source = INT(name=u'abort-source', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'ABRT-source')))
    _ABRT_apdu_abort_diagnostic = ENUM(name=u'abort-diagnostic', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'ABRT-diagnostic')), opt=True)
    _ABRT_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'Association-information')), opt=True)
    ABRT_apdu._cont = ASN1Dict([
        (u'abort-source', _ABRT_apdu_abort_source),
        (u'abort-diagnostic', _ABRT_apdu_abort_diagnostic),
        (u'user-information', _ABRT_apdu_user_information),
        ])
    ABRT_apdu._ext = [u'user-information']
    
    #-----< ABRT-diagnostic >-----#
    ABRT_diagnostic = ENUM(name=u'ABRT-diagnostic', mode=MODE_TYPE)
    ABRT_diagnostic._cont = ASN1Dict([(u'no-reason-given', 1), (u'protocol-error', 2), (u'authentication-mechanism-name-not-recognized', 3), (u'authentication-mechanism-name-required', 4), (u'authentication-failure', 5), (u'authentication-required', 6)])
    ABRT_diagnostic._ext = []
    
    #-----< ABRT-source >-----#
    ABRT_source = INT(name=u'ABRT-source', mode=MODE_TYPE)
    ABRT_source._cont = ASN1Dict([(u'acse-service-user', 0), (u'acse-service-provider', 1)])
    ABRT_source._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=[], er=[])
    
    #-----< ACSE-requirements >-----#
    ACSE_requirements = BIT_STR(name=u'ACSE-requirements', mode=MODE_TYPE)
    ACSE_requirements._cont = ASN1Dict([(u'authentication', 0), (u'application-context-negotiation', 1)])
    
    #-----< Application-context-name-list >-----#
    Application_context_name_list = SEQ_OF(name=u'Application-context-name-list', mode=MODE_TYPE)
    _Application_context_name_list__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'Application-context-name')))
    Application_context_name_list._cont = _Application_context_name_list__item_
    
    #-----< Application-context-name >-----#
    Application_context_name = OID(name=u'Application-context-name', mode=MODE_TYPE)
    
    #-----< AP-title >-----#
    AP_title = CHOICE(name=u'AP-title', mode=MODE_TYPE)
    _AP_title_ap_title_form1 = CHOICE(name=u'ap-title-form1', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AP-title-form1')))
    _AP_title_ap_title_form2 = OID(name=u'ap-title-form2', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AP-title-form2')))
    AP_title._cont = ASN1Dict([
        (u'ap-title-form1', _AP_title_ap_title_form1),
        (u'ap-title-form2', _AP_title_ap_title_form2),
        ])
    AP_title._ext = []
    
    #-----< AE-qualifier >-----#
    AE_qualifier = CHOICE(name=u'AE-qualifier', mode=MODE_TYPE)
    _AE_qualifier_ae_qualifier_form1 = SET_OF(name=u'ae-qualifier-form1', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-qualifier-form1')))
    _AE_qualifier_ae_qualifier_form2 = INT(name=u'ae-qualifier-form2', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-qualifier-form2')))
    AE_qualifier._cont = ASN1Dict([
        (u'ae-qualifier-form1', _AE_qualifier_ae_qualifier_form1),
        (u'ae-qualifier-form2', _AE_qualifier_ae_qualifier_form2),
        ])
    AE_qualifier._ext = []
    
    #-----< AP-title-form1 >-----#
    AP_title_form1 = CHOICE(name=u'AP-title-form1', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    
    #-----< AE-qualifier-form1 >-----#
    AE_qualifier_form1 = SET_OF(name=u'AE-qualifier-form1', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    
    #-----< AP-title-form2 >-----#
    AP_title_form2 = OID(name=u'AP-title-form2', mode=MODE_TYPE)
    
    #-----< AE-qualifier-form2 >-----#
    AE_qualifier_form2 = INT(name=u'AE-qualifier-form2', mode=MODE_TYPE)
    
    #-----< AE-title >-----#
    AE_title = CHOICE(name=u'AE-title', mode=MODE_TYPE)
    _AE_title_ae_title_form1 = CHOICE(name=u'ae-title-form1', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-title-form1')))
    _AE_title_ae_title_form2 = OID(name=u'ae-title-form2', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-title-form2')))
    AE_title._cont = ASN1Dict([
        (u'ae-title-form1', _AE_title_ae_title_form1),
        (u'ae-title-form2', _AE_title_ae_title_form2),
        ])
    AE_title._ext = []
    
    #-----< AE-title-form1 >-----#
    AE_title_form1 = CHOICE(name=u'AE-title-form1', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    
    #-----< AE-title-form2 >-----#
    AE_title_form2 = OID(name=u'AE-title-form2', mode=MODE_TYPE)
    
    #-----< AE-invocation-identifier >-----#
    AE_invocation_identifier = INT(name=u'AE-invocation-identifier', mode=MODE_TYPE)
    
    #-----< AP-invocation-identifier >-----#
    AP_invocation_identifier = INT(name=u'AP-invocation-identifier', mode=MODE_TYPE)
    
    #-----< Associate-result >-----#
    Associate_result = INT(name=u'Associate-result', mode=MODE_TYPE)
    Associate_result._cont = ASN1Dict([(u'accepted', 0), (u'rejected-permanent', 1), (u'rejected-transient', 2)])
    Associate_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2)], ev=[], er=[])
    
    #-----< Associate-source-diagnostic >-----#
    Associate_source_diagnostic = CHOICE(name=u'Associate-source-diagnostic', mode=MODE_TYPE)
    _Associate_source_diagnostic_acse_service_user = INT(name=u'acse-service-user', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_acse_service_user._cont = ASN1Dict([(u'null', 0), (u'no-reason-given', 1), (u'application-context-name-not-supported', 2), (u'calling-AP-title-not-recognized', 3), (u'calling-AP-invocation-identifier-not-recognized', 4), (u'calling-AE-qualifier-not-recognized', 5), (u'calling-AE-invocation-identifier-not-recognized', 6), (u'called-AP-title-not-recognized', 7), (u'called-AP-invocation-identifier-not-recognized', 8), (u'called-AE-qualifier-not-recognized', 9), (u'called-AE-invocation-identifier-not-recognized', 10), (u'authentication-mechanism-name-not-recognized', 11), (u'authentication-mechanism-name-required', 12), (u'authentication-failure', 13), (u'authentication-required', 14)])
    _Associate_source_diagnostic_acse_service_user._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=[], er=[])
    _Associate_source_diagnostic_acse_service_provider = INT(name=u'acse-service-provider', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_acse_service_provider._cont = ASN1Dict([(u'null', 0), (u'no-reason-given', 1), (u'no-common-acse-version', 2)])
    _Associate_source_diagnostic_acse_service_provider._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2)], ev=[], er=[])
    Associate_source_diagnostic._cont = ASN1Dict([
        (u'acse-service-user', _Associate_source_diagnostic_acse_service_user),
        (u'acse-service-provider', _Associate_source_diagnostic_acse_service_provider),
        ])
    Associate_source_diagnostic._ext = None
    
    #-----< Association-information >-----#
    Association_information = SEQ_OF(name=u'Association-information', mode=MODE_TYPE)
    _Association_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    Association_information._cont = _Association_information__item_
    Association_information._const_sz = ASN1Set(rv=[1], rr=[], ev=[0], er=[ASN1RangeInt(lb=2, ub=None)])
    
    #-----< Authentication-value >-----#
    Authentication_value = CHOICE(name=u'Authentication-value', mode=MODE_TYPE)
    _Authentication_value_charstring = STR_GRAPH(name=u'charstring', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Authentication_value_bitstring = BIT_STR(name=u'bitstring', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Authentication_value_external = EXT(name=u'external', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _Authentication_value_other = SEQ(name=u'other', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Authentication_value_other_other_mechanism_name = OID(name=u'other-mechanism-name', mode=MODE_TYPE, typeref=ASN1RefClassField(('ACSE-1', 'MECHANISM-NAME'), [u'id']))
    ___Authentication_value_other_other_mechanism_name_tab = CLASS(name='_tab_MECHANISM-NAME', mode=MODE_SET, typeref=ASN1RefType(('ACSE-1', 'MECHANISM-NAME')))
    ___Authentication_value_other_other_mechanism_name_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Authentication_value_other_other_mechanism_name._const_tab = ___Authentication_value_other_other_mechanism_name_tab
    __Authentication_value_other_other_mechanism_name._const_tab_at = None
    __Authentication_value_other_other_mechanism_name._const_tab_id = u'id'
    __Authentication_value_other_other_mechanism_value = OPEN(name=u'other-mechanism-value', mode=MODE_TYPE, typeref=ASN1RefClassField(('ACSE-1', 'MECHANISM-NAME'), [u'Type']))
    ___Authentication_value_other_other_mechanism_value_tab = CLASS(name='_tab_MECHANISM-NAME', mode=MODE_SET, typeref=ASN1RefType(('ACSE-1', 'MECHANISM-NAME')))
    ___Authentication_value_other_other_mechanism_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Authentication_value_other_other_mechanism_value._const_tab = ___Authentication_value_other_other_mechanism_value_tab
    __Authentication_value_other_other_mechanism_value._const_tab_at = ('..', u'other-mechanism-name')
    __Authentication_value_other_other_mechanism_value._const_tab_id = u'Type'
    _Authentication_value_other._cont = ASN1Dict([
        (u'other-mechanism-name', __Authentication_value_other_other_mechanism_name),
        (u'other-mechanism-value', __Authentication_value_other_other_mechanism_value),
        ])
    _Authentication_value_other._ext = None
    Authentication_value._cont = ASN1Dict([
        (u'charstring', _Authentication_value_charstring),
        (u'bitstring', _Authentication_value_bitstring),
        (u'external', _Authentication_value_external),
        (u'other', _Authentication_value_other),
        ])
    Authentication_value._ext = None
    
    #-----< Implementation-data >-----#
    Implementation_data = STR_GRAPH(name=u'Implementation-data', mode=MODE_TYPE)
    
    #-----< Mechanism-name >-----#
    Mechanism_name = OID(name=u'Mechanism-name', mode=MODE_TYPE)
    
    #-----< MECHANISM-NAME >-----#
    MECHANISM_NAME = CLASS(name=u'MECHANISM-NAME', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', u'TYPE-IDENTIFIER'), []))
    
    #-----< ObjectSet >-----#
    ObjectSet = CLASS(name=u'ObjectSet', mode=MODE_SET, typeref=ASN1RefType(('ACSE-1', 'MECHANISM-NAME')))
    ObjectSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Release-request-reason >-----#
    Release_request_reason = INT(name=u'Release-request-reason', mode=MODE_TYPE)
    Release_request_reason._cont = ASN1Dict([(u'normal', 0), (u'urgent', 1), (u'user-defined', 30)])
    Release_request_reason._const_val = ASN1Set(rv=[0, 1, 30], rr=[], ev=[], er=[])
    
    #-----< Release-response-reason >-----#
    Release_response_reason = INT(name=u'Release-response-reason', mode=MODE_TYPE)
    Release_response_reason._cont = ASN1Dict([(u'normal', 0), (u'not-finished', 1), (u'user-defined', 30)])
    Release_response_reason._const_val = ASN1Set(rv=[0, 1, 30], rr=[], ev=[], er=[])
    
    _all_ = [
        acse_as_id,
        aCSE_id,
        _ACSE_apdu_aarq,
        _ACSE_apdu_aare,
        _ACSE_apdu_rlrq,
        _ACSE_apdu_rlre,
        _ACSE_apdu_abrt,
        ACSE_apdu,
        _AARQ_apdu_protocol_version,
        _AARQ_apdu_application_context_name,
        _AARQ_apdu_called_AP_title,
        _AARQ_apdu_called_AE_qualifier,
        _AARQ_apdu_called_AP_invocation_identifier,
        _AARQ_apdu_called_AE_invocation_identifier,
        _AARQ_apdu_calling_AP_title,
        _AARQ_apdu_calling_AE_qualifier,
        _AARQ_apdu_calling_AP_invocation_identifier,
        _AARQ_apdu_calling_AE_invocation_identifier,
        _AARQ_apdu_sender_acse_requirements,
        _AARQ_apdu_mechanism_name,
        _AARQ_apdu_calling_authentication_value,
        _AARQ_apdu_application_context_name_list,
        _AARQ_apdu_implementation_information,
        _AARQ_apdu_user_information,
        AARQ_apdu,
        _AARE_apdu_protocol_version,
        _AARE_apdu_application_context_name,
        _AARE_apdu_result,
        _AARE_apdu_result_source_diagnostic,
        _AARE_apdu_responding_AP_title,
        _AARE_apdu_responding_AE_qualifier,
        _AARE_apdu_responding_AP_invocation_identifier,
        _AARE_apdu_responding_AE_invocation_identifier,
        _AARE_apdu_responder_acse_requirements,
        _AARE_apdu_mechanism_name,
        _AARE_apdu_responding_authentication_value,
        _AARE_apdu_application_context_name_list,
        _AARE_apdu_implementation_information,
        _AARE_apdu_user_information,
        AARE_apdu,
        _RLRQ_apdu_reason,
        _RLRQ_apdu_user_information,
        RLRQ_apdu,
        _RLRE_apdu_reason,
        _RLRE_apdu_user_information,
        RLRE_apdu,
        _ABRT_apdu_abort_source,
        _ABRT_apdu_abort_diagnostic,
        _ABRT_apdu_user_information,
        ABRT_apdu,
        ABRT_diagnostic,
        ABRT_source,
        ACSE_requirements,
        _Application_context_name_list__item_,
        Application_context_name_list,
        Application_context_name,
        _AP_title_ap_title_form1,
        _AP_title_ap_title_form2,
        AP_title,
        _AE_qualifier_ae_qualifier_form1,
        _AE_qualifier_ae_qualifier_form2,
        AE_qualifier,
        AP_title_form1,
        AE_qualifier_form1,
        AP_title_form2,
        AE_qualifier_form2,
        _AE_title_ae_title_form1,
        _AE_title_ae_title_form2,
        AE_title,
        AE_title_form1,
        AE_title_form2,
        AE_invocation_identifier,
        AP_invocation_identifier,
        Associate_result,
        _Associate_source_diagnostic_acse_service_user,
        _Associate_source_diagnostic_acse_service_provider,
        Associate_source_diagnostic,
        _Association_information__item_,
        Association_information,
        _Authentication_value_charstring,
        _Authentication_value_bitstring,
        _Authentication_value_external,
        ___Authentication_value_other_other_mechanism_name_tab,
        __Authentication_value_other_other_mechanism_name,
        ___Authentication_value_other_other_mechanism_value_tab,
        __Authentication_value_other_other_mechanism_value,
        _Authentication_value_other,
        Authentication_value,
        Implementation_data,
        Mechanism_name,
        MECHANISM_NAME,
        ObjectSet,
        Release_request_reason,
        Release_response_reason,
    ]

class Attribute_ASN1Module:

    _name_  = u'Attribute-ASN1Module'
    _oid_   = [2, 9, 3, 2, 2, 1]
    
    _obj_ = [
        u'smi2AttributeID',
        u'smi2AttributeGroup',
        u'DMI-TYPE-IDENTIFIER',
        u'arfProbableCause',
        u'adapterError',
        u'applicationSubsystemFailure',
        u'bandwidthReduced',
        u'callEstablishmentError',
        u'communicationsProtocolError',
        u'communicationsSubsystemFailure',
        u'configurationOrCustomizationError',
        u'congestion',
        u'corruptData',
        u'cpuCyclesLimitExceeded',
        u'dataSetOrModemError',
        u'degradedSignal',
        u'dTE-DCEInterfaceError',
        u'enclosureDoorOpen',
        u'equipmentMalfunction',
        u'excessiveVibration',
        u'fileError',
        u'fireDetected',
        u'floodDetected',
        u'framingError',
        u'heatingOrVentilationOrCoolingSystemProblem',
        u'humidityUnacceptable',
        u'inputOutputDeviceError',
        u'inputDeviceError',
        u'lANError',
        u'leakDetected',
        u'localNodeTransmissionError',
        u'lossOfFrame',
        u'lossOfSignal',
        u'materialSupplyExhausted',
        u'multiplexerProblem',
        u'outOfMemory',
        u'ouputDeviceError',
        u'performanceDegraded',
        u'powerProblem',
        u'pressureUnacceptable',
        u'processorProblem',
        u'pumpFailure',
        u'queueSizeExceeded',
        u'receiveFailure',
        u'receiverFailure',
        u'remoteNodeTransmissionError',
        u'resourceAtOrNearingCapacity',
        u'responseTimeExcessive',
        u'retransmissionRateExcessive',
        u'softwareError',
        u'softwareProgramAbnormallyTerminated',
        u'softwareProgramError',
        u'storageCapacityProblem',
        u'temperatureUnacceptable',
        u'thresholdCrossed',
        u'timingProblem',
        u'toxicLeakDetected',
        u'transmitFailure',
        u'transmitterFailure',
        u'underlyingResourceUnavailable',
        u'versionMismatch',
        u'arfProposedRepairAction',
        u'noActionRequired',
        u'repairActionRequired',
        u'securityAlarmCause',
        u'authenticationFailure',
        u'breachOfConfidentiality',
        u'cableTamper',
        u'delayedInformation',
        u'denialOfService',
        u'duplicateInformation',
        u'informationMissing',
        u'informationModificationDetected',
        u'informationOutOfSequence',
        u'intrusionDetection',
        u'keyExpired',
        u'nonRepudiationFailure',
        u'outOfHoursActivity',
        u'outOfService',
        u'proceduralError',
        u'unauthorizedAccessAttempt',
        u'unexpectedInformation',
        u'unspecifiedReason',
        u'defaultIntervalsOfDay',
        u'defaultStopTime',
        u'defaultWeekMask',
        u'defaultDiscriminatorConstruct',
        u'ActiveDestination',
        u'AdditionalText',
        u'AdditionalInformation',
        u'Allomorphs',
        u'AdministrativeState',
        u'AttributeIdentifierList',
        u'AttributeList',
        u'AttributeValueChangeDefinition',
        u'AlarmStatus',
        u'AvailabilityStatus',
        u'BackedUpStatus',
        u'BackUpDestinationList',
        u'BackUpRelationshipObject',
        u'CapacityAlarmThreshold',
        u'ConfirmedMode',
        u'ControlStatus',
        u'Count',
        u'CounterThreshold',
        u'CorrelatedNotifications',
        u'CurrentLogSize',
        u'Destination',
        u'DiscriminatorConstruct',
        u'EventTime',
        u'GaugeThreshold',
        u'GaugeThresholdValue',
        u'GroupObjects',
        u'IntervalsOfDay',
        u'LifecycleState',
        u'LogAvailability',
        u'LogFullAction',
        u'LoggingTime',
        u'LogRecordId',
        u'MaxLogSize',
        u'DMI-EXTENSION',
        u'ManagementExtension',
        u'ManagementExtensionSet',
        u'MonitoredAttributes',
        u'NameBinding',
        u'NotificationIdentifier',
        u'NotifyThreshold',
        u'NumberOfRecords',
        u'ObservedValue',
        u'OperationalState',
        u'Packages',
        u'PerceivedSeverity',
        u'PrioritisedObject',
        u'ProbableCause',
        u'ProceduralStatus',
        u'ProposedRepairActions',
        u'SchedulingAvailability',
        u'SecurityAlarmCause',
        u'SecurityAlarmSeverity',
        u'SecurityAlarmDetector',
        u'ServiceProvider',
        u'DMI-SERVICEUSER',
        u'ServiceUser',
        u'ServiceUserSet',
        u'SimpleNameType',
        u'SpecificIdentifier',
        u'SourceIndicator',
        u'SpecificProblems',
        u'StandbyStatus',
        u'StartTime',
        u'StopTime',
        u'DMI-SUPPORTEDFEATURES',
        u'SupportedFeatures',
        u'SupportedFeaturesSet',
        u'SystemId',
        u'SystemTitle',
        u'TideMarkInfo',
        u'TideMark',
        u'Time24',
        u'ThresholdInfo',
        u'ThresholdLevelInd',
        u'TrendIndication',
        u'UnknownStatus',
        u'UnscheduledLogAvailability',
        u'UsageState',
        u'WeekMask',
        ]
    _type_ = [
        u'DMI-TYPE-IDENTIFIER',
        u'ActiveDestination',
        u'AdditionalText',
        u'AdditionalInformation',
        u'Allomorphs',
        u'AdministrativeState',
        u'AttributeIdentifierList',
        u'AttributeList',
        u'AttributeValueChangeDefinition',
        u'AlarmStatus',
        u'AvailabilityStatus',
        u'BackedUpStatus',
        u'BackUpDestinationList',
        u'BackUpRelationshipObject',
        u'CapacityAlarmThreshold',
        u'ConfirmedMode',
        u'ControlStatus',
        u'Count',
        u'CounterThreshold',
        u'CorrelatedNotifications',
        u'CurrentLogSize',
        u'Destination',
        u'DiscriminatorConstruct',
        u'EventTime',
        u'GaugeThreshold',
        u'GaugeThresholdValue',
        u'GroupObjects',
        u'IntervalsOfDay',
        u'LifecycleState',
        u'LogAvailability',
        u'LogFullAction',
        u'LoggingTime',
        u'LogRecordId',
        u'MaxLogSize',
        u'DMI-EXTENSION',
        u'ManagementExtension',
        u'MonitoredAttributes',
        u'NameBinding',
        u'NotificationIdentifier',
        u'NotifyThreshold',
        u'NumberOfRecords',
        u'ObservedValue',
        u'OperationalState',
        u'Packages',
        u'PerceivedSeverity',
        u'PrioritisedObject',
        u'ProbableCause',
        u'ProceduralStatus',
        u'ProposedRepairActions',
        u'SchedulingAvailability',
        u'SecurityAlarmCause',
        u'SecurityAlarmSeverity',
        u'SecurityAlarmDetector',
        u'ServiceProvider',
        u'DMI-SERVICEUSER',
        u'ServiceUser',
        u'SimpleNameType',
        u'SpecificIdentifier',
        u'SourceIndicator',
        u'SpecificProblems',
        u'StandbyStatus',
        u'StartTime',
        u'StopTime',
        u'DMI-SUPPORTEDFEATURES',
        u'SupportedFeatures',
        u'SystemId',
        u'SystemTitle',
        u'TideMarkInfo',
        u'TideMark',
        u'Time24',
        u'ThresholdInfo',
        u'ThresholdLevelInd',
        u'TrendIndication',
        u'UnknownStatus',
        u'UnscheduledLogAvailability',
        u'UsageState',
        u'WeekMask',
        ]
    _set_ = [
        u'ManagementExtensionSet',
        u'ServiceUserSet',
        u'SupportedFeaturesSet',
        ]
    _val_ = [
        u'smi2AttributeID',
        u'smi2AttributeGroup',
        u'arfProbableCause',
        u'adapterError',
        u'applicationSubsystemFailure',
        u'bandwidthReduced',
        u'callEstablishmentError',
        u'communicationsProtocolError',
        u'communicationsSubsystemFailure',
        u'configurationOrCustomizationError',
        u'congestion',
        u'corruptData',
        u'cpuCyclesLimitExceeded',
        u'dataSetOrModemError',
        u'degradedSignal',
        u'dTE-DCEInterfaceError',
        u'enclosureDoorOpen',
        u'equipmentMalfunction',
        u'excessiveVibration',
        u'fileError',
        u'fireDetected',
        u'floodDetected',
        u'framingError',
        u'heatingOrVentilationOrCoolingSystemProblem',
        u'humidityUnacceptable',
        u'inputOutputDeviceError',
        u'inputDeviceError',
        u'lANError',
        u'leakDetected',
        u'localNodeTransmissionError',
        u'lossOfFrame',
        u'lossOfSignal',
        u'materialSupplyExhausted',
        u'multiplexerProblem',
        u'outOfMemory',
        u'ouputDeviceError',
        u'performanceDegraded',
        u'powerProblem',
        u'pressureUnacceptable',
        u'processorProblem',
        u'pumpFailure',
        u'queueSizeExceeded',
        u'receiveFailure',
        u'receiverFailure',
        u'remoteNodeTransmissionError',
        u'resourceAtOrNearingCapacity',
        u'responseTimeExcessive',
        u'retransmissionRateExcessive',
        u'softwareError',
        u'softwareProgramAbnormallyTerminated',
        u'softwareProgramError',
        u'storageCapacityProblem',
        u'temperatureUnacceptable',
        u'thresholdCrossed',
        u'timingProblem',
        u'toxicLeakDetected',
        u'transmitFailure',
        u'transmitterFailure',
        u'underlyingResourceUnavailable',
        u'versionMismatch',
        u'arfProposedRepairAction',
        u'noActionRequired',
        u'repairActionRequired',
        u'securityAlarmCause',
        u'authenticationFailure',
        u'breachOfConfidentiality',
        u'cableTamper',
        u'delayedInformation',
        u'denialOfService',
        u'duplicateInformation',
        u'informationMissing',
        u'informationModificationDetected',
        u'informationOutOfSequence',
        u'intrusionDetection',
        u'keyExpired',
        u'nonRepudiationFailure',
        u'outOfHoursActivity',
        u'outOfService',
        u'proceduralError',
        u'unauthorizedAccessAttempt',
        u'unexpectedInformation',
        u'unspecifiedReason',
        u'defaultIntervalsOfDay',
        u'defaultStopTime',
        u'defaultWeekMask',
        u'defaultDiscriminatorConstruct',
        ]
    _class_ = [
        u'DMI-TYPE-IDENTIFIER',
        u'DMI-EXTENSION',
        u'ManagementExtensionSet',
        u'DMI-SERVICEUSER',
        u'ServiceUserSet',
        u'DMI-SUPPORTEDFEATURES',
        u'SupportedFeaturesSet',
        ]
    _param_ = [
        ]
    
    #-----< smi2AttributeID >-----#
    smi2AttributeID = OID(name=u'smi2AttributeID', mode=MODE_VALUE)
    smi2AttributeID._val = (2, 9, 3, 2, 7)
    
    #-----< smi2AttributeGroup >-----#
    smi2AttributeGroup = OID(name=u'smi2AttributeGroup', mode=MODE_VALUE)
    smi2AttributeGroup._val = (2, 9, 3, 2, 8)
    
    #-----< DMI-TYPE-IDENTIFIER >-----#
    DMI_TYPE_IDENTIFIER = CLASS(name=u'DMI-TYPE-IDENTIFIER', mode=MODE_TYPE)
    _DMI_TYPE_IDENTIFIER_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    _DMI_TYPE_IDENTIFIER_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    DMI_TYPE_IDENTIFIER._cont = ASN1Dict([
        (u'id', _DMI_TYPE_IDENTIFIER_id),
        (u'Value', _DMI_TYPE_IDENTIFIER_Value),
        ])
    
    #-----< arfProbableCause >-----#
    arfProbableCause = OID(name=u'arfProbableCause', mode=MODE_VALUE)
    arfProbableCause._val = (2, 9, 3, 2, 0, 0)
    
    #-----< adapterError >-----#
    adapterError = CHOICE(name=u'adapterError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    adapterError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 1))
    
    #-----< applicationSubsystemFailure >-----#
    applicationSubsystemFailure = CHOICE(name=u'applicationSubsystemFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    applicationSubsystemFailure._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 2))
    
    #-----< bandwidthReduced >-----#
    bandwidthReduced = CHOICE(name=u'bandwidthReduced', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    bandwidthReduced._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 3))
    
    #-----< callEstablishmentError >-----#
    callEstablishmentError = CHOICE(name=u'callEstablishmentError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    callEstablishmentError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 4))
    
    #-----< communicationsProtocolError >-----#
    communicationsProtocolError = CHOICE(name=u'communicationsProtocolError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    communicationsProtocolError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 5))
    
    #-----< communicationsSubsystemFailure >-----#
    communicationsSubsystemFailure = CHOICE(name=u'communicationsSubsystemFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    communicationsSubsystemFailure._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 6))
    
    #-----< configurationOrCustomizationError >-----#
    configurationOrCustomizationError = CHOICE(name=u'configurationOrCustomizationError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    configurationOrCustomizationError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 7))
    
    #-----< congestion >-----#
    congestion = CHOICE(name=u'congestion', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    congestion._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 8))
    
    #-----< corruptData >-----#
    corruptData = CHOICE(name=u'corruptData', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    corruptData._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 9))
    
    #-----< cpuCyclesLimitExceeded >-----#
    cpuCyclesLimitExceeded = CHOICE(name=u'cpuCyclesLimitExceeded', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    cpuCyclesLimitExceeded._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 10))
    
    #-----< dataSetOrModemError >-----#
    dataSetOrModemError = CHOICE(name=u'dataSetOrModemError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    dataSetOrModemError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 11))
    
    #-----< degradedSignal >-----#
    degradedSignal = CHOICE(name=u'degradedSignal', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    degradedSignal._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 12))
    
    #-----< dTE-DCEInterfaceError >-----#
    dTE_DCEInterfaceError = CHOICE(name=u'dTE-DCEInterfaceError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    dTE_DCEInterfaceError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 13))
    
    #-----< enclosureDoorOpen >-----#
    enclosureDoorOpen = CHOICE(name=u'enclosureDoorOpen', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    enclosureDoorOpen._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 14))
    
    #-----< equipmentMalfunction >-----#
    equipmentMalfunction = CHOICE(name=u'equipmentMalfunction', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    equipmentMalfunction._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 15))
    
    #-----< excessiveVibration >-----#
    excessiveVibration = CHOICE(name=u'excessiveVibration', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    excessiveVibration._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 16))
    
    #-----< fileError >-----#
    fileError = CHOICE(name=u'fileError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    fileError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 17))
    
    #-----< fireDetected >-----#
    fireDetected = CHOICE(name=u'fireDetected', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    fireDetected._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 18))
    
    #-----< floodDetected >-----#
    floodDetected = CHOICE(name=u'floodDetected', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    floodDetected._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 19))
    
    #-----< framingError >-----#
    framingError = CHOICE(name=u'framingError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    framingError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 20))
    
    #-----< heatingOrVentilationOrCoolingSystemProblem >-----#
    heatingOrVentilationOrCoolingSystemProblem = CHOICE(name=u'heatingOrVentilationOrCoolingSystemProblem', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    heatingOrVentilationOrCoolingSystemProblem._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 21))
    
    #-----< humidityUnacceptable >-----#
    humidityUnacceptable = CHOICE(name=u'humidityUnacceptable', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    humidityUnacceptable._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 22))
    
    #-----< inputOutputDeviceError >-----#
    inputOutputDeviceError = CHOICE(name=u'inputOutputDeviceError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    inputOutputDeviceError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 23))
    
    #-----< inputDeviceError >-----#
    inputDeviceError = CHOICE(name=u'inputDeviceError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    inputDeviceError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 24))
    
    #-----< lANError >-----#
    lANError = CHOICE(name=u'lANError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    lANError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 25))
    
    #-----< leakDetected >-----#
    leakDetected = CHOICE(name=u'leakDetected', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    leakDetected._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 26))
    
    #-----< localNodeTransmissionError >-----#
    localNodeTransmissionError = CHOICE(name=u'localNodeTransmissionError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    localNodeTransmissionError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 27))
    
    #-----< lossOfFrame >-----#
    lossOfFrame = CHOICE(name=u'lossOfFrame', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    lossOfFrame._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 28))
    
    #-----< lossOfSignal >-----#
    lossOfSignal = CHOICE(name=u'lossOfSignal', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    lossOfSignal._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 29))
    
    #-----< materialSupplyExhausted >-----#
    materialSupplyExhausted = CHOICE(name=u'materialSupplyExhausted', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    materialSupplyExhausted._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 30))
    
    #-----< multiplexerProblem >-----#
    multiplexerProblem = CHOICE(name=u'multiplexerProblem', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    multiplexerProblem._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 31))
    
    #-----< outOfMemory >-----#
    outOfMemory = CHOICE(name=u'outOfMemory', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    outOfMemory._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 32))
    
    #-----< ouputDeviceError >-----#
    ouputDeviceError = CHOICE(name=u'ouputDeviceError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    ouputDeviceError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 33))
    
    #-----< performanceDegraded >-----#
    performanceDegraded = CHOICE(name=u'performanceDegraded', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    performanceDegraded._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 34))
    
    #-----< powerProblem >-----#
    powerProblem = CHOICE(name=u'powerProblem', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    powerProblem._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 35))
    
    #-----< pressureUnacceptable >-----#
    pressureUnacceptable = CHOICE(name=u'pressureUnacceptable', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    pressureUnacceptable._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 36))
    
    #-----< processorProblem >-----#
    processorProblem = CHOICE(name=u'processorProblem', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    processorProblem._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 37))
    
    #-----< pumpFailure >-----#
    pumpFailure = CHOICE(name=u'pumpFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    pumpFailure._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 38))
    
    #-----< queueSizeExceeded >-----#
    queueSizeExceeded = CHOICE(name=u'queueSizeExceeded', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    queueSizeExceeded._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 39))
    
    #-----< receiveFailure >-----#
    receiveFailure = CHOICE(name=u'receiveFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    receiveFailure._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 40))
    
    #-----< receiverFailure >-----#
    receiverFailure = CHOICE(name=u'receiverFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    receiverFailure._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 41))
    
    #-----< remoteNodeTransmissionError >-----#
    remoteNodeTransmissionError = CHOICE(name=u'remoteNodeTransmissionError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    remoteNodeTransmissionError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 42))
    
    #-----< resourceAtOrNearingCapacity >-----#
    resourceAtOrNearingCapacity = CHOICE(name=u'resourceAtOrNearingCapacity', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    resourceAtOrNearingCapacity._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 43))
    
    #-----< responseTimeExcessive >-----#
    responseTimeExcessive = CHOICE(name=u'responseTimeExcessive', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    responseTimeExcessive._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 44))
    
    #-----< retransmissionRateExcessive >-----#
    retransmissionRateExcessive = CHOICE(name=u'retransmissionRateExcessive', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    retransmissionRateExcessive._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 45))
    
    #-----< softwareError >-----#
    softwareError = CHOICE(name=u'softwareError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    softwareError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 46))
    
    #-----< softwareProgramAbnormallyTerminated >-----#
    softwareProgramAbnormallyTerminated = CHOICE(name=u'softwareProgramAbnormallyTerminated', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    softwareProgramAbnormallyTerminated._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 47))
    
    #-----< softwareProgramError >-----#
    softwareProgramError = CHOICE(name=u'softwareProgramError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    softwareProgramError._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 48))
    
    #-----< storageCapacityProblem >-----#
    storageCapacityProblem = CHOICE(name=u'storageCapacityProblem', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    storageCapacityProblem._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 49))
    
    #-----< temperatureUnacceptable >-----#
    temperatureUnacceptable = CHOICE(name=u'temperatureUnacceptable', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    temperatureUnacceptable._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 50))
    
    #-----< thresholdCrossed >-----#
    thresholdCrossed = CHOICE(name=u'thresholdCrossed', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    thresholdCrossed._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 51))
    
    #-----< timingProblem >-----#
    timingProblem = CHOICE(name=u'timingProblem', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    timingProblem._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 52))
    
    #-----< toxicLeakDetected >-----#
    toxicLeakDetected = CHOICE(name=u'toxicLeakDetected', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    toxicLeakDetected._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 53))
    
    #-----< transmitFailure >-----#
    transmitFailure = CHOICE(name=u'transmitFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    transmitFailure._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 54))
    
    #-----< transmitterFailure >-----#
    transmitterFailure = CHOICE(name=u'transmitterFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    transmitterFailure._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 55))
    
    #-----< underlyingResourceUnavailable >-----#
    underlyingResourceUnavailable = CHOICE(name=u'underlyingResourceUnavailable', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    underlyingResourceUnavailable._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 56))
    
    #-----< versionMismatch >-----#
    versionMismatch = CHOICE(name=u'versionMismatch', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ProbableCause')))
    versionMismatch._val = (u'globalValue', (2, 9, 3, 2, 0, 0, 57))
    
    #-----< arfProposedRepairAction >-----#
    arfProposedRepairAction = OID(name=u'arfProposedRepairAction', mode=MODE_VALUE)
    arfProposedRepairAction._val = (2, 9, 3, 2, 0, 2)
    
    #-----< noActionRequired >-----#
    noActionRequired = OID(name=u'noActionRequired', mode=MODE_VALUE)
    noActionRequired._val = (2, 9, 3, 2, 0, 2, 1)
    
    #-----< repairActionRequired >-----#
    repairActionRequired = OID(name=u'repairActionRequired', mode=MODE_VALUE)
    repairActionRequired._val = (2, 9, 3, 2, 0, 2, 2)
    
    #-----< securityAlarmCause >-----#
    securityAlarmCause = OID(name=u'securityAlarmCause', mode=MODE_VALUE)
    securityAlarmCause._val = (2, 9, 3, 2, 0, 1)
    
    #-----< authenticationFailure >-----#
    authenticationFailure = OID(name=u'authenticationFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    authenticationFailure._val = (2, 9, 3, 2, 0, 1, 1)
    
    #-----< breachOfConfidentiality >-----#
    breachOfConfidentiality = OID(name=u'breachOfConfidentiality', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    breachOfConfidentiality._val = (2, 9, 3, 2, 0, 1, 2)
    
    #-----< cableTamper >-----#
    cableTamper = OID(name=u'cableTamper', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    cableTamper._val = (2, 9, 3, 2, 0, 1, 3)
    
    #-----< delayedInformation >-----#
    delayedInformation = OID(name=u'delayedInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    delayedInformation._val = (2, 9, 3, 2, 0, 1, 4)
    
    #-----< denialOfService >-----#
    denialOfService = OID(name=u'denialOfService', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    denialOfService._val = (2, 9, 3, 2, 0, 1, 5)
    
    #-----< duplicateInformation >-----#
    duplicateInformation = OID(name=u'duplicateInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    duplicateInformation._val = (2, 9, 3, 2, 0, 1, 6)
    
    #-----< informationMissing >-----#
    informationMissing = OID(name=u'informationMissing', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    informationMissing._val = (2, 9, 3, 2, 0, 1, 7)
    
    #-----< informationModificationDetected >-----#
    informationModificationDetected = OID(name=u'informationModificationDetected', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    informationModificationDetected._val = (2, 9, 3, 2, 0, 1, 8)
    
    #-----< informationOutOfSequence >-----#
    informationOutOfSequence = OID(name=u'informationOutOfSequence', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    informationOutOfSequence._val = (2, 9, 3, 2, 0, 1, 9)
    
    #-----< intrusionDetection >-----#
    intrusionDetection = OID(name=u'intrusionDetection', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    intrusionDetection._val = (2, 9, 3, 2, 0, 1, 10)
    
    #-----< keyExpired >-----#
    keyExpired = OID(name=u'keyExpired', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    keyExpired._val = (2, 9, 3, 2, 0, 1, 11)
    
    #-----< nonRepudiationFailure >-----#
    nonRepudiationFailure = OID(name=u'nonRepudiationFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    nonRepudiationFailure._val = (2, 9, 3, 2, 0, 1, 12)
    
    #-----< outOfHoursActivity >-----#
    outOfHoursActivity = OID(name=u'outOfHoursActivity', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    outOfHoursActivity._val = (2, 9, 3, 2, 0, 1, 13)
    
    #-----< outOfService >-----#
    outOfService = OID(name=u'outOfService', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    outOfService._val = (2, 9, 3, 2, 0, 1, 14)
    
    #-----< proceduralError >-----#
    proceduralError = OID(name=u'proceduralError', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    proceduralError._val = (2, 9, 3, 2, 0, 1, 15)
    
    #-----< unauthorizedAccessAttempt >-----#
    unauthorizedAccessAttempt = OID(name=u'unauthorizedAccessAttempt', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    unauthorizedAccessAttempt._val = (2, 9, 3, 2, 0, 1, 16)
    
    #-----< unexpectedInformation >-----#
    unexpectedInformation = OID(name=u'unexpectedInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    unexpectedInformation._val = (2, 9, 3, 2, 0, 1, 17)
    
    #-----< unspecifiedReason >-----#
    unspecifiedReason = OID(name=u'unspecifiedReason', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SecurityAlarmCause')))
    unspecifiedReason._val = (2, 9, 3, 2, 0, 1, 18)
    
    #-----< defaultIntervalsOfDay >-----#
    defaultIntervalsOfDay = SET_OF(name=u'defaultIntervalsOfDay', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'IntervalsOfDay')))
    defaultIntervalsOfDay._val = [dict([(u'intervalStart', dict([(u'hour', 0), (u'minute', 0)])), (u'intervalEnd', dict([(u'hour', 23), (u'minute', 59)]))])]
    
    #-----< defaultStopTime >-----#
    defaultStopTime = CHOICE(name=u'defaultStopTime', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'StopTime')))
    defaultStopTime._val = (u'continual', 0)
    
    #-----< defaultWeekMask >-----#
    defaultWeekMask = SET_OF(name=u'defaultWeekMask', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'WeekMask')))
    defaultWeekMask._val = [dict([(u'daysOfWeek', (127, 7)), (u'intervalsOfDay', [dict([(u'intervalStart', dict([(u'hour', 0), (u'minute', 0)])), (u'intervalEnd', dict([(u'hour', 23), (u'minute', 59)]))])])])]
    
    #-----< defaultDiscriminatorConstruct >-----#
    defaultDiscriminatorConstruct = CHOICE(name=u'defaultDiscriminatorConstruct', mode=MODE_VALUE, typeref=ASN1RefType(('Attribute-ASN1Module', 'DiscriminatorConstruct')))
    defaultDiscriminatorConstruct._val = (u'and', [])
    
    #-----< ActiveDestination >-----#
    ActiveDestination = CHOICE(name=u'ActiveDestination', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'Destination')))
    
    #-----< AdditionalText >-----#
    AdditionalText = STR_GRAPH(name=u'AdditionalText', mode=MODE_TYPE)
    
    #-----< AdditionalInformation >-----#
    AdditionalInformation = SET_OF(name=u'AdditionalInformation', mode=MODE_TYPE)
    _AdditionalInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ManagementExtension')))
    AdditionalInformation._cont = _AdditionalInformation__item_
    
    #-----< Allomorphs >-----#
    Allomorphs = SET_OF(name=u'Allomorphs', mode=MODE_TYPE)
    _Allomorphs__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    Allomorphs._cont = _Allomorphs__item_
    
    #-----< AdministrativeState >-----#
    AdministrativeState = ENUM(name=u'AdministrativeState', mode=MODE_TYPE)
    AdministrativeState._cont = ASN1Dict([(u'locked', 0), (u'unlocked', 1), (u'shuttingDown', 2)])
    AdministrativeState._ext = None
    
    #-----< AttributeIdentifierList >-----#
    AttributeIdentifierList = SET_OF(name=u'AttributeIdentifierList', mode=MODE_TYPE)
    _AttributeIdentifierList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    AttributeIdentifierList._cont = _AttributeIdentifierList__item_
    
    #-----< AttributeList >-----#
    AttributeList = SET_OF(name=u'AttributeList', mode=MODE_TYPE)
    _AttributeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    AttributeList._cont = _AttributeList__item_
    
    #-----< AttributeValueChangeDefinition >-----#
    AttributeValueChangeDefinition = SET_OF(name=u'AttributeValueChangeDefinition', mode=MODE_TYPE)
    _AttributeValueChangeDefinition__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __AttributeValueChangeDefinition__item__attributeId = CHOICE(name=u'attributeId', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), [u'id']))
    ___AttributeValueChangeDefinition__item__attributeId_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    ___AttributeValueChangeDefinition__item__attributeId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeValueChangeDefinition__item__attributeId._const_tab = ___AttributeValueChangeDefinition__item__attributeId_tab
    __AttributeValueChangeDefinition__item__attributeId._const_tab_at = None
    __AttributeValueChangeDefinition__item__attributeId._const_tab_id = u'id'
    __AttributeValueChangeDefinition__item__oldAttributeValue = OPEN(name=u'oldAttributeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), [u'Value']), opt=True)
    ___AttributeValueChangeDefinition__item__oldAttributeValue_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    ___AttributeValueChangeDefinition__item__oldAttributeValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeValueChangeDefinition__item__oldAttributeValue._const_tab = ___AttributeValueChangeDefinition__item__oldAttributeValue_tab
    __AttributeValueChangeDefinition__item__oldAttributeValue._const_tab_at = ('..', u'attributeId')
    __AttributeValueChangeDefinition__item__oldAttributeValue._const_tab_id = u'Value'
    __AttributeValueChangeDefinition__item__newAttributeValue = OPEN(name=u'newAttributeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), [u'Value']))
    ___AttributeValueChangeDefinition__item__newAttributeValue_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    ___AttributeValueChangeDefinition__item__newAttributeValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeValueChangeDefinition__item__newAttributeValue._const_tab = ___AttributeValueChangeDefinition__item__newAttributeValue_tab
    __AttributeValueChangeDefinition__item__newAttributeValue._const_tab_at = ('..', u'attributeId')
    __AttributeValueChangeDefinition__item__newAttributeValue._const_tab_id = u'Value'
    _AttributeValueChangeDefinition__item_._cont = ASN1Dict([
        (u'attributeId', __AttributeValueChangeDefinition__item__attributeId),
        (u'oldAttributeValue', __AttributeValueChangeDefinition__item__oldAttributeValue),
        (u'newAttributeValue', __AttributeValueChangeDefinition__item__newAttributeValue),
        ])
    _AttributeValueChangeDefinition__item_._ext = None
    AttributeValueChangeDefinition._cont = _AttributeValueChangeDefinition__item_
    
    #-----< AlarmStatus >-----#
    AlarmStatus = SET_OF(name=u'AlarmStatus', mode=MODE_TYPE)
    _AlarmStatus__item_ = INT(name='_item_', mode=MODE_TYPE)
    _AlarmStatus__item_._cont = ASN1Dict([(u'underRepair', 0), (u'critical', 1), (u'major', 2), (u'minor', 3), (u'alarmOutstanding', 4)])
    AlarmStatus._cont = _AlarmStatus__item_
    
    #-----< AvailabilityStatus >-----#
    AvailabilityStatus = SET_OF(name=u'AvailabilityStatus', mode=MODE_TYPE)
    _AvailabilityStatus__item_ = INT(name='_item_', mode=MODE_TYPE)
    _AvailabilityStatus__item_._cont = ASN1Dict([(u'inTest', 0), (u'failed', 1), (u'powerOff', 2), (u'offLine', 3), (u'offDuty', 4), (u'dependency', 5), (u'degraded', 6), (u'notInstalled', 7), (u'logFull', 8)])
    AvailabilityStatus._cont = _AvailabilityStatus__item_
    
    #-----< BackedUpStatus >-----#
    BackedUpStatus = BOOL(name=u'BackedUpStatus', mode=MODE_TYPE)
    
    #-----< BackUpDestinationList >-----#
    BackUpDestinationList = SEQ_OF(name=u'BackUpDestinationList', mode=MODE_TYPE)
    _BackUpDestinationList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-title')))
    BackUpDestinationList._cont = _BackUpDestinationList__item_
    
    #-----< BackUpRelationshipObject >-----#
    BackUpRelationshipObject = CHOICE(name=u'BackUpRelationshipObject', mode=MODE_TYPE)
    _BackUpRelationshipObject_objectName = CHOICE(name=u'objectName', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _BackUpRelationshipObject_noObject = NULL(name=u'noObject', mode=MODE_TYPE)
    BackUpRelationshipObject._cont = ASN1Dict([
        (u'objectName', _BackUpRelationshipObject_objectName),
        (u'noObject', _BackUpRelationshipObject_noObject),
        ])
    BackUpRelationshipObject._ext = None
    
    #-----< CapacityAlarmThreshold >-----#
    CapacityAlarmThreshold = SET_OF(name=u'CapacityAlarmThreshold', mode=MODE_TYPE)
    _CapacityAlarmThreshold__item_ = INT(name='_item_', mode=MODE_TYPE)
    _CapacityAlarmThreshold__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    CapacityAlarmThreshold._cont = _CapacityAlarmThreshold__item_
    
    #-----< ConfirmedMode >-----#
    ConfirmedMode = BOOL(name=u'ConfirmedMode', mode=MODE_TYPE)
    
    #-----< ControlStatus >-----#
    ControlStatus = SET_OF(name=u'ControlStatus', mode=MODE_TYPE)
    _ControlStatus__item_ = INT(name='_item_', mode=MODE_TYPE)
    _ControlStatus__item_._cont = ASN1Dict([(u'subjectToTest', 0), (u'partOfServicesLocked', 1), (u'reservedForTest', 2), (u'suspended', 3)])
    ControlStatus._cont = _ControlStatus__item_
    
    #-----< Count >-----#
    Count = INT(name=u'Count', mode=MODE_TYPE)
    
    #-----< CounterThreshold >-----#
    CounterThreshold = SET_OF(name=u'CounterThreshold', mode=MODE_TYPE)
    _CounterThreshold__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CounterThreshold__item__comparisonLevel = INT(name=u'comparisonLevel', mode=MODE_TYPE)
    __CounterThreshold__item__offsetValue = INT(name=u'offsetValue', mode=MODE_TYPE)
    __CounterThreshold__item__notificationOnOff = BOOL(name=u'notificationOnOff', mode=MODE_TYPE)
    _CounterThreshold__item_._cont = ASN1Dict([
        (u'comparisonLevel', __CounterThreshold__item__comparisonLevel),
        (u'offsetValue', __CounterThreshold__item__offsetValue),
        (u'notificationOnOff', __CounterThreshold__item__notificationOnOff),
        ])
    _CounterThreshold__item_._ext = None
    CounterThreshold._cont = _CounterThreshold__item_
    
    #-----< CorrelatedNotifications >-----#
    CorrelatedNotifications = SET_OF(name=u'CorrelatedNotifications', mode=MODE_TYPE)
    _CorrelatedNotifications__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CorrelatedNotifications__item__correlatedNotifications = SET_OF(name=u'correlatedNotifications', mode=MODE_TYPE)
    ___CorrelatedNotifications__item__correlatedNotifications__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'NotificationIdentifier')))
    __CorrelatedNotifications__item__correlatedNotifications._cont = ___CorrelatedNotifications__item__correlatedNotifications__item_
    __CorrelatedNotifications__item__sourceObjectInst = CHOICE(name=u'sourceObjectInst', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _CorrelatedNotifications__item_._cont = ASN1Dict([
        (u'correlatedNotifications', __CorrelatedNotifications__item__correlatedNotifications),
        (u'sourceObjectInst', __CorrelatedNotifications__item__sourceObjectInst),
        ])
    _CorrelatedNotifications__item_._ext = None
    CorrelatedNotifications._cont = _CorrelatedNotifications__item_
    
    #-----< CurrentLogSize >-----#
    CurrentLogSize = INT(name=u'CurrentLogSize', mode=MODE_TYPE)
    
    #-----< Destination >-----#
    Destination = CHOICE(name=u'Destination', mode=MODE_TYPE)
    _Destination_single = CHOICE(name=u'single', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-title')))
    _Destination_multiple = SET_OF(name=u'multiple', mode=MODE_TYPE)
    __Destination_multiple__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-title')))
    _Destination_multiple._cont = __Destination_multiple__item_
    Destination._cont = ASN1Dict([
        (u'single', _Destination_single),
        (u'multiple', _Destination_multiple),
        ])
    Destination._ext = None
    
    #-----< DiscriminatorConstruct >-----#
    DiscriminatorConstruct = CHOICE(name=u'DiscriminatorConstruct', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    
    #-----< EventTime >-----#
    EventTime = TIME_GEN(name=u'EventTime', mode=MODE_TYPE)
    
    #-----< GaugeThreshold >-----#
    GaugeThreshold = SET_OF(name=u'GaugeThreshold', mode=MODE_TYPE)
    _GaugeThreshold__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GaugeThreshold__item__notifyLow = SEQ(name=u'notifyLow', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'NotifyThreshold')))
    __GaugeThreshold__item__notifyHigh = SEQ(name=u'notifyHigh', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'NotifyThreshold')))
    _GaugeThreshold__item_._cont = ASN1Dict([
        (u'notifyLow', __GaugeThreshold__item__notifyLow),
        (u'notifyHigh', __GaugeThreshold__item__notifyHigh),
        ])
    _GaugeThreshold__item_._ext = None
    GaugeThreshold._cont = _GaugeThreshold__item_
    
    #-----< GaugeThresholdValue >-----#
    GaugeThresholdValue = CHOICE(name=u'GaugeThresholdValue', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    
    #-----< GroupObjects >-----#
    GroupObjects = SET_OF(name=u'GroupObjects', mode=MODE_TYPE)
    _GroupObjects__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    GroupObjects._cont = _GroupObjects__item_
    
    #-----< IntervalsOfDay >-----#
    IntervalsOfDay = SET_OF(name=u'IntervalsOfDay', mode=MODE_TYPE)
    _IntervalsOfDay__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __IntervalsOfDay__item__intervalStart = SEQ(name=u'intervalStart', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'Time24')))
    __IntervalsOfDay__item__intervalEnd = SEQ(name=u'intervalEnd', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'Time24')))
    _IntervalsOfDay__item_._cont = ASN1Dict([
        (u'intervalStart', __IntervalsOfDay__item__intervalStart),
        (u'intervalEnd', __IntervalsOfDay__item__intervalEnd),
        ])
    _IntervalsOfDay__item_._ext = None
    IntervalsOfDay._cont = _IntervalsOfDay__item_
    
    #-----< LifecycleState >-----#
    LifecycleState = ENUM(name=u'LifecycleState', mode=MODE_TYPE)
    LifecycleState._cont = ASN1Dict([(u'planned', 0), (u'installed', 1), (u'pendingRemoval', 2)])
    LifecycleState._ext = None
    
    #-----< LogAvailability >-----#
    LogAvailability = SET_OF(name=u'LogAvailability', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'AvailabilityStatus')))
    
    #-----< LogFullAction >-----#
    LogFullAction = ENUM(name=u'LogFullAction', mode=MODE_TYPE)
    LogFullAction._cont = ASN1Dict([(u'wrap', 0), (u'halt', 1)])
    LogFullAction._ext = None
    
    #-----< LoggingTime >-----#
    LoggingTime = TIME_GEN(name=u'LoggingTime', mode=MODE_TYPE)
    
    #-----< LogRecordId >-----#
    LogRecordId = CHOICE(name=u'LogRecordId', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SimpleNameType')))
    
    #-----< MaxLogSize >-----#
    MaxLogSize = INT(name=u'MaxLogSize', mode=MODE_TYPE)
    MaxLogSize._cont = ASN1Dict([(u'unlimited', 0)])
    
    #-----< DMI-EXTENSION >-----#
    DMI_EXTENSION = CLASS(name=u'DMI-EXTENSION', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-TYPE-IDENTIFIER')))
    
    #-----< ManagementExtension >-----#
    ManagementExtension = SEQ(name=u'ManagementExtension', mode=MODE_TYPE)
    _ManagementExtension_identifier = OID(name=u'identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('Attribute-ASN1Module', 'DMI-EXTENSION'), [u'id']))
    __ManagementExtension_identifier_tab = CLASS(name='_tab_DMI-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-EXTENSION')))
    __ManagementExtension_identifier_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ManagementExtension_identifier._const_tab = __ManagementExtension_identifier_tab
    _ManagementExtension_identifier._const_tab_at = None
    _ManagementExtension_identifier._const_tab_id = u'id'
    _ManagementExtension_significance = BOOL(name=u'significance', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ManagementExtension_information = OPEN(name=u'information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('Attribute-ASN1Module', 'DMI-EXTENSION'), [u'Value']))
    __ManagementExtension_information_tab = CLASS(name='_tab_DMI-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-EXTENSION')))
    __ManagementExtension_information_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ManagementExtension_information._const_tab = __ManagementExtension_information_tab
    _ManagementExtension_information._const_tab_at = ('..', u'identifier')
    _ManagementExtension_information._const_tab_id = u'Value'
    ManagementExtension._cont = ASN1Dict([
        (u'identifier', _ManagementExtension_identifier),
        (u'significance', _ManagementExtension_significance),
        (u'information', _ManagementExtension_information),
        ])
    ManagementExtension._ext = None
    
    #-----< ManagementExtensionSet >-----#
    ManagementExtensionSet = CLASS(name=u'ManagementExtensionSet', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-EXTENSION')))
    ManagementExtensionSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MonitoredAttributes >-----#
    MonitoredAttributes = SET_OF(name=u'MonitoredAttributes', mode=MODE_TYPE)
    _MonitoredAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    MonitoredAttributes._cont = _MonitoredAttributes__item_
    
    #-----< NameBinding >-----#
    NameBinding = OID(name=u'NameBinding', mode=MODE_TYPE)
    
    #-----< NotificationIdentifier >-----#
    NotificationIdentifier = INT(name=u'NotificationIdentifier', mode=MODE_TYPE)
    
    #-----< NotifyThreshold >-----#
    NotifyThreshold = SEQ(name=u'NotifyThreshold', mode=MODE_TYPE)
    _NotifyThreshold_threshold = CHOICE(name=u'threshold', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    _NotifyThreshold_notifyOnOff = BOOL(name=u'notifyOnOff', mode=MODE_TYPE)
    NotifyThreshold._cont = ASN1Dict([
        (u'threshold', _NotifyThreshold_threshold),
        (u'notifyOnOff', _NotifyThreshold_notifyOnOff),
        ])
    NotifyThreshold._ext = None
    
    #-----< NumberOfRecords >-----#
    NumberOfRecords = INT(name=u'NumberOfRecords', mode=MODE_TYPE)
    
    #-----< ObservedValue >-----#
    ObservedValue = CHOICE(name=u'ObservedValue', mode=MODE_TYPE)
    _ObservedValue_integer = INT(name=u'integer', mode=MODE_TYPE)
    _ObservedValue_real = REAL(name=u'real', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'REAL')))
    ObservedValue._cont = ASN1Dict([
        (u'integer', _ObservedValue_integer),
        (u'real', _ObservedValue_real),
        ])
    ObservedValue._ext = None
    
    #-----< OperationalState >-----#
    OperationalState = ENUM(name=u'OperationalState', mode=MODE_TYPE)
    OperationalState._cont = ASN1Dict([(u'disabled', 0), (u'enabled', 1)])
    OperationalState._ext = None
    
    #-----< Packages >-----#
    Packages = SET_OF(name=u'Packages', mode=MODE_TYPE)
    _Packages__item_ = OID(name='_item_', mode=MODE_TYPE)
    Packages._cont = _Packages__item_
    
    #-----< PerceivedSeverity >-----#
    PerceivedSeverity = ENUM(name=u'PerceivedSeverity', mode=MODE_TYPE)
    PerceivedSeverity._cont = ASN1Dict([(u'indeterminate', 0), (u'critical', 1), (u'major', 2), (u'minor', 3), (u'warning', 4), (u'cleared', 5)])
    PerceivedSeverity._ext = None
    
    #-----< PrioritisedObject >-----#
    PrioritisedObject = SET_OF(name=u'PrioritisedObject', mode=MODE_TYPE)
    _PrioritisedObject__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __PrioritisedObject__item__object = CHOICE(name=u'object', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    __PrioritisedObject__item__priority = INT(name=u'priority', mode=MODE_TYPE)
    __PrioritisedObject__item__priority._cont = ASN1Dict([(u'highest', 0), (u'lowest', 127)])
    _PrioritisedObject__item_._cont = ASN1Dict([
        (u'object', __PrioritisedObject__item__object),
        (u'priority', __PrioritisedObject__item__priority),
        ])
    _PrioritisedObject__item_._ext = None
    PrioritisedObject._cont = _PrioritisedObject__item_
    
    #-----< ProbableCause >-----#
    ProbableCause = CHOICE(name=u'ProbableCause', mode=MODE_TYPE)
    _ProbableCause_globalValue = OID(name=u'globalValue', mode=MODE_TYPE)
    _ProbableCause_localValue = INT(name=u'localValue', mode=MODE_TYPE)
    ProbableCause._cont = ASN1Dict([
        (u'globalValue', _ProbableCause_globalValue),
        (u'localValue', _ProbableCause_localValue),
        ])
    ProbableCause._ext = None
    
    #-----< ProceduralStatus >-----#
    ProceduralStatus = SET_OF(name=u'ProceduralStatus', mode=MODE_TYPE)
    _ProceduralStatus__item_ = INT(name='_item_', mode=MODE_TYPE)
    _ProceduralStatus__item_._cont = ASN1Dict([(u'initializationRequired', 0), (u'notInitialized', 1), (u'initializing', 2), (u'reporting', 3), (u'terminating', 4)])
    ProceduralStatus._cont = _ProceduralStatus__item_
    
    #-----< ProposedRepairActions >-----#
    ProposedRepairActions = SET_OF(name=u'ProposedRepairActions', mode=MODE_TYPE)
    _ProposedRepairActions__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SpecificIdentifier')))
    ProposedRepairActions._cont = _ProposedRepairActions__item_
    
    #-----< SchedulingAvailability >-----#
    SchedulingAvailability = SET_OF(name=u'SchedulingAvailability', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'AvailabilityStatus')))
    
    #-----< SecurityAlarmCause >-----#
    SecurityAlarmCause = OID(name=u'SecurityAlarmCause', mode=MODE_TYPE)
    
    #-----< SecurityAlarmSeverity >-----#
    SecurityAlarmSeverity = ENUM(name=u'SecurityAlarmSeverity', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'PerceivedSeverity')))
    SecurityAlarmSeverity._const_val = ASN1Set(rv=[u'indeterminate', u'critical', u'major', u'minor', u'warning'], rr=[], ev=None, er=[])
    
    #-----< SecurityAlarmDetector >-----#
    SecurityAlarmDetector = CHOICE(name=u'SecurityAlarmDetector', mode=MODE_TYPE)
    _SecurityAlarmDetector_mechanism = OID(name=u'mechanism', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SecurityAlarmDetector_object = CHOICE(name=u'object', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _SecurityAlarmDetector_application = CHOICE(name=u'application', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-title')))
    SecurityAlarmDetector._cont = ASN1Dict([
        (u'mechanism', _SecurityAlarmDetector_mechanism),
        (u'object', _SecurityAlarmDetector_object),
        (u'application', _SecurityAlarmDetector_application),
        ])
    SecurityAlarmDetector._ext = None
    
    #-----< ServiceProvider >-----#
    ServiceProvider = SEQ(name=u'ServiceProvider', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ServiceUser')))
    
    #-----< DMI-SERVICEUSER >-----#
    DMI_SERVICEUSER = CLASS(name=u'DMI-SERVICEUSER', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-TYPE-IDENTIFIER')))
    
    #-----< ServiceUser >-----#
    ServiceUser = SEQ(name=u'ServiceUser', mode=MODE_TYPE)
    _ServiceUser_identifier = OID(name=u'identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('Attribute-ASN1Module', 'DMI-SERVICEUSER'), [u'id']))
    __ServiceUser_identifier_tab = CLASS(name='_tab_DMI-SERVICEUSER', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-SERVICEUSER')))
    __ServiceUser_identifier_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ServiceUser_identifier._const_tab = __ServiceUser_identifier_tab
    _ServiceUser_identifier._const_tab_at = None
    _ServiceUser_identifier._const_tab_id = u'id'
    _ServiceUser_details = OPEN(name=u'details', mode=MODE_TYPE, typeref=ASN1RefClassField(('Attribute-ASN1Module', 'DMI-SERVICEUSER'), [u'Value']))
    __ServiceUser_details_tab = CLASS(name='_tab_DMI-SERVICEUSER', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-SERVICEUSER')))
    __ServiceUser_details_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ServiceUser_details._const_tab = __ServiceUser_details_tab
    _ServiceUser_details._const_tab_at = ('..', u'identifier')
    _ServiceUser_details._const_tab_id = u'Value'
    ServiceUser._cont = ASN1Dict([
        (u'identifier', _ServiceUser_identifier),
        (u'details', _ServiceUser_details),
        ])
    ServiceUser._ext = None
    
    #-----< ServiceUserSet >-----#
    ServiceUserSet = CLASS(name=u'ServiceUserSet', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-SERVICEUSER')))
    ServiceUserSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SimpleNameType >-----#
    SimpleNameType = CHOICE(name=u'SimpleNameType', mode=MODE_TYPE)
    _SimpleNameType_number = INT(name=u'number', mode=MODE_TYPE)
    _SimpleNameType_string = STR_GRAPH(name=u'string', mode=MODE_TYPE)
    SimpleNameType._cont = ASN1Dict([
        (u'number', _SimpleNameType_number),
        (u'string', _SimpleNameType_string),
        ])
    SimpleNameType._ext = None
    
    #-----< SpecificIdentifier >-----#
    SpecificIdentifier = CHOICE(name=u'SpecificIdentifier', mode=MODE_TYPE)
    _SpecificIdentifier_oi = OID(name=u'oi', mode=MODE_TYPE)
    _SpecificIdentifier_int = INT(name=u'int', mode=MODE_TYPE)
    SpecificIdentifier._cont = ASN1Dict([
        (u'oi', _SpecificIdentifier_oi),
        (u'int', _SpecificIdentifier_int),
        ])
    SpecificIdentifier._ext = None
    
    #-----< SourceIndicator >-----#
    SourceIndicator = ENUM(name=u'SourceIndicator', mode=MODE_TYPE)
    SourceIndicator._cont = ASN1Dict([(u'resourceOperation', 0), (u'managementOperation', 1), (u'unknown', 2)])
    SourceIndicator._ext = None
    
    #-----< SpecificProblems >-----#
    SpecificProblems = SET_OF(name=u'SpecificProblems', mode=MODE_TYPE)
    _SpecificProblems__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'SpecificIdentifier')))
    SpecificProblems._cont = _SpecificProblems__item_
    
    #-----< StandbyStatus >-----#
    StandbyStatus = INT(name=u'StandbyStatus', mode=MODE_TYPE)
    StandbyStatus._cont = ASN1Dict([(u'hotStandby', 0), (u'coldStandby', 1), (u'providingService', 2)])
    
    #-----< StartTime >-----#
    StartTime = TIME_GEN(name=u'StartTime', mode=MODE_TYPE)
    
    #-----< StopTime >-----#
    StopTime = CHOICE(name=u'StopTime', mode=MODE_TYPE)
    _StopTime_specific = TIME_GEN(name=u'specific', mode=MODE_TYPE)
    _StopTime_continual = NULL(name=u'continual', mode=MODE_TYPE)
    StopTime._cont = ASN1Dict([
        (u'specific', _StopTime_specific),
        (u'continual', _StopTime_continual),
        ])
    StopTime._ext = None
    
    #-----< DMI-SUPPORTEDFEATURES >-----#
    DMI_SUPPORTEDFEATURES = CLASS(name=u'DMI-SUPPORTEDFEATURES', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-TYPE-IDENTIFIER')))
    
    #-----< SupportedFeatures >-----#
    SupportedFeatures = SET_OF(name=u'SupportedFeatures', mode=MODE_TYPE)
    _SupportedFeatures__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __SupportedFeatures__item__featureIdentifier = OID(name=u'featureIdentifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('Attribute-ASN1Module', 'DMI-SUPPORTEDFEATURES'), [u'id']))
    ___SupportedFeatures__item__featureIdentifier_tab = CLASS(name='_tab_DMI-SUPPORTEDFEATURES', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-SUPPORTEDFEATURES')))
    ___SupportedFeatures__item__featureIdentifier_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SupportedFeatures__item__featureIdentifier._const_tab = ___SupportedFeatures__item__featureIdentifier_tab
    __SupportedFeatures__item__featureIdentifier._const_tab_at = None
    __SupportedFeatures__item__featureIdentifier._const_tab_id = u'id'
    __SupportedFeatures__item__featureInfo = OPEN(name=u'featureInfo', mode=MODE_TYPE, typeref=ASN1RefClassField(('Attribute-ASN1Module', 'DMI-SUPPORTEDFEATURES'), [u'Value']))
    ___SupportedFeatures__item__featureInfo_tab = CLASS(name='_tab_DMI-SUPPORTEDFEATURES', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-SUPPORTEDFEATURES')))
    ___SupportedFeatures__item__featureInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SupportedFeatures__item__featureInfo._const_tab = ___SupportedFeatures__item__featureInfo_tab
    __SupportedFeatures__item__featureInfo._const_tab_at = ('..', u'featureIdentifier')
    __SupportedFeatures__item__featureInfo._const_tab_id = u'Value'
    _SupportedFeatures__item_._cont = ASN1Dict([
        (u'featureIdentifier', __SupportedFeatures__item__featureIdentifier),
        (u'featureInfo', __SupportedFeatures__item__featureInfo),
        ])
    _SupportedFeatures__item_._ext = None
    SupportedFeatures._cont = _SupportedFeatures__item_
    
    #-----< SupportedFeaturesSet >-----#
    SupportedFeaturesSet = CLASS(name=u'SupportedFeaturesSet', mode=MODE_SET, typeref=ASN1RefType(('Attribute-ASN1Module', 'DMI-SUPPORTEDFEATURES')))
    SupportedFeaturesSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SystemId >-----#
    SystemId = CHOICE(name=u'SystemId', mode=MODE_TYPE)
    _SystemId_name = STR_GRAPH(name=u'name', mode=MODE_TYPE)
    _SystemId_number = INT(name=u'number', mode=MODE_TYPE)
    _SystemId_nothing = NULL(name=u'nothing', mode=MODE_TYPE)
    SystemId._cont = ASN1Dict([
        (u'name', _SystemId_name),
        (u'number', _SystemId_number),
        (u'nothing', _SystemId_nothing),
        ])
    SystemId._ext = None
    
    #-----< SystemTitle >-----#
    SystemTitle = CHOICE(name=u'SystemTitle', mode=MODE_TYPE)
    _SystemTitle_distinguishedName = SEQ_OF(name=u'distinguishedName', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DistinguishedName')))
    _SystemTitle_oid = OID(name=u'oid', mode=MODE_TYPE)
    _SystemTitle_nothing = NULL(name=u'nothing', mode=MODE_TYPE)
    SystemTitle._cont = ASN1Dict([
        (u'distinguishedName', _SystemTitle_distinguishedName),
        (u'oid', _SystemTitle_oid),
        (u'nothing', _SystemTitle_nothing),
        ])
    SystemTitle._ext = None
    
    #-----< TideMarkInfo >-----#
    TideMarkInfo = SEQ(name=u'TideMarkInfo', mode=MODE_TYPE)
    _TideMarkInfo_currentTideMark = CHOICE(name=u'currentTideMark', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'TideMark')))
    _TideMarkInfo_previousTideMark = CHOICE(name=u'previousTideMark', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'TideMark')))
    _TideMarkInfo_resetTime = TIME_GEN(name=u'resetTime', mode=MODE_TYPE)
    TideMarkInfo._cont = ASN1Dict([
        (u'currentTideMark', _TideMarkInfo_currentTideMark),
        (u'previousTideMark', _TideMarkInfo_previousTideMark),
        (u'resetTime', _TideMarkInfo_resetTime),
        ])
    TideMarkInfo._ext = None
    
    #-----< TideMark >-----#
    TideMark = CHOICE(name=u'TideMark', mode=MODE_TYPE)
    _TideMark_maxTideMar = CHOICE(name=u'maxTideMar', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    _TideMark_minTideMark = CHOICE(name=u'minTideMark', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    TideMark._cont = ASN1Dict([
        (u'maxTideMar', _TideMark_maxTideMar),
        (u'minTideMark', _TideMark_minTideMark),
        ])
    TideMark._ext = None
    
    #-----< Time24 >-----#
    Time24 = SEQ(name=u'Time24', mode=MODE_TYPE)
    _Time24_hour = INT(name=u'hour', mode=MODE_TYPE)
    _Time24_hour._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=23)], ev=None, er=[])
    _Time24_minute = INT(name=u'minute', mode=MODE_TYPE)
    _Time24_minute._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=None, er=[])
    Time24._cont = ASN1Dict([
        (u'hour', _Time24_hour),
        (u'minute', _Time24_minute),
        ])
    Time24._ext = None
    
    #-----< ThresholdInfo >-----#
    ThresholdInfo = SEQ(name=u'ThresholdInfo', mode=MODE_TYPE)
    _ThresholdInfo_triggeredThreshold = CHOICE(name=u'triggeredThreshold', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    _ThresholdInfo_observedValue = CHOICE(name=u'observedValue', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    _ThresholdInfo_thresholdLevel = CHOICE(name=u'thresholdLevel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Attribute-ASN1Module', 'ThresholdLevelInd')), opt=True)
    _ThresholdInfo_armTime = TIME_GEN(name=u'armTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ThresholdInfo._cont = ASN1Dict([
        (u'triggeredThreshold', _ThresholdInfo_triggeredThreshold),
        (u'observedValue', _ThresholdInfo_observedValue),
        (u'thresholdLevel', _ThresholdInfo_thresholdLevel),
        (u'armTime', _ThresholdInfo_armTime),
        ])
    ThresholdInfo._ext = None
    
    #-----< ThresholdLevelInd >-----#
    ThresholdLevelInd = CHOICE(name=u'ThresholdLevelInd', mode=MODE_TYPE)
    _ThresholdLevelInd_up = SEQ(name=u'up', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ThresholdLevelInd_up_high = CHOICE(name=u'high', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    __ThresholdLevelInd_up_low = CHOICE(name=u'low', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')), opt=True)
    _ThresholdLevelInd_up._cont = ASN1Dict([
        (u'high', __ThresholdLevelInd_up_high),
        (u'low', __ThresholdLevelInd_up_low),
        ])
    _ThresholdLevelInd_up._ext = None
    _ThresholdLevelInd_down = SEQ(name=u'down', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ThresholdLevelInd_down_high = CHOICE(name=u'high', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    __ThresholdLevelInd_down_low = CHOICE(name=u'low', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ObservedValue')))
    _ThresholdLevelInd_down._cont = ASN1Dict([
        (u'high', __ThresholdLevelInd_down_high),
        (u'low', __ThresholdLevelInd_down_low),
        ])
    _ThresholdLevelInd_down._ext = None
    ThresholdLevelInd._cont = ASN1Dict([
        (u'up', _ThresholdLevelInd_up),
        (u'down', _ThresholdLevelInd_down),
        ])
    ThresholdLevelInd._ext = None
    
    #-----< TrendIndication >-----#
    TrendIndication = ENUM(name=u'TrendIndication', mode=MODE_TYPE)
    TrendIndication._cont = ASN1Dict([(u'lessSevere', 0), (u'noChange', 1), (u'moreSevere', 2)])
    TrendIndication._ext = None
    
    #-----< UnknownStatus >-----#
    UnknownStatus = BOOL(name=u'UnknownStatus', mode=MODE_TYPE)
    
    #-----< UnscheduledLogAvailability >-----#
    UnscheduledLogAvailability = SET_OF(name=u'UnscheduledLogAvailability', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'AvailabilityStatus')))
    
    #-----< UsageState >-----#
    UsageState = ENUM(name=u'UsageState', mode=MODE_TYPE)
    UsageState._cont = ASN1Dict([(u'idle', 0), (u'active', 1), (u'busy', 2)])
    UsageState._ext = None
    
    #-----< WeekMask >-----#
    WeekMask = SET_OF(name=u'WeekMask', mode=MODE_TYPE)
    _WeekMask__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __WeekMask__item__daysOfWeek = BIT_STR(name=u'daysOfWeek', mode=MODE_TYPE)
    __WeekMask__item__daysOfWeek._cont = ASN1Dict([(u'sunday', 0), (u'monday', 1), (u'tuesday', 2), (u'wednesday', 3), (u'thursday', 4), (u'friday', 5), (u'saturday', 6)])
    __WeekMask__item__daysOfWeek._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    __WeekMask__item__intervalsOfDay = SET_OF(name=u'intervalsOfDay', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'IntervalsOfDay')))
    _WeekMask__item_._cont = ASN1Dict([
        (u'daysOfWeek', __WeekMask__item__daysOfWeek),
        (u'intervalsOfDay', __WeekMask__item__intervalsOfDay),
        ])
    _WeekMask__item_._ext = None
    WeekMask._cont = _WeekMask__item_
    
    _all_ = [
        smi2AttributeID,
        smi2AttributeGroup,
        _DMI_TYPE_IDENTIFIER_id,
        _DMI_TYPE_IDENTIFIER_Value,
        DMI_TYPE_IDENTIFIER,
        arfProbableCause,
        adapterError,
        applicationSubsystemFailure,
        bandwidthReduced,
        callEstablishmentError,
        communicationsProtocolError,
        communicationsSubsystemFailure,
        configurationOrCustomizationError,
        congestion,
        corruptData,
        cpuCyclesLimitExceeded,
        dataSetOrModemError,
        degradedSignal,
        dTE_DCEInterfaceError,
        enclosureDoorOpen,
        equipmentMalfunction,
        excessiveVibration,
        fileError,
        fireDetected,
        floodDetected,
        framingError,
        heatingOrVentilationOrCoolingSystemProblem,
        humidityUnacceptable,
        inputOutputDeviceError,
        inputDeviceError,
        lANError,
        leakDetected,
        localNodeTransmissionError,
        lossOfFrame,
        lossOfSignal,
        materialSupplyExhausted,
        multiplexerProblem,
        outOfMemory,
        ouputDeviceError,
        performanceDegraded,
        powerProblem,
        pressureUnacceptable,
        processorProblem,
        pumpFailure,
        queueSizeExceeded,
        receiveFailure,
        receiverFailure,
        remoteNodeTransmissionError,
        resourceAtOrNearingCapacity,
        responseTimeExcessive,
        retransmissionRateExcessive,
        softwareError,
        softwareProgramAbnormallyTerminated,
        softwareProgramError,
        storageCapacityProblem,
        temperatureUnacceptable,
        thresholdCrossed,
        timingProblem,
        toxicLeakDetected,
        transmitFailure,
        transmitterFailure,
        underlyingResourceUnavailable,
        versionMismatch,
        arfProposedRepairAction,
        noActionRequired,
        repairActionRequired,
        securityAlarmCause,
        authenticationFailure,
        breachOfConfidentiality,
        cableTamper,
        delayedInformation,
        denialOfService,
        duplicateInformation,
        informationMissing,
        informationModificationDetected,
        informationOutOfSequence,
        intrusionDetection,
        keyExpired,
        nonRepudiationFailure,
        outOfHoursActivity,
        outOfService,
        proceduralError,
        unauthorizedAccessAttempt,
        unexpectedInformation,
        unspecifiedReason,
        defaultIntervalsOfDay,
        defaultStopTime,
        defaultWeekMask,
        defaultDiscriminatorConstruct,
        ActiveDestination,
        AdditionalText,
        _AdditionalInformation__item_,
        AdditionalInformation,
        _Allomorphs__item_,
        Allomorphs,
        AdministrativeState,
        _AttributeIdentifierList__item_,
        AttributeIdentifierList,
        _AttributeList__item_,
        AttributeList,
        ___AttributeValueChangeDefinition__item__attributeId_tab,
        __AttributeValueChangeDefinition__item__attributeId,
        ___AttributeValueChangeDefinition__item__oldAttributeValue_tab,
        __AttributeValueChangeDefinition__item__oldAttributeValue,
        ___AttributeValueChangeDefinition__item__newAttributeValue_tab,
        __AttributeValueChangeDefinition__item__newAttributeValue,
        _AttributeValueChangeDefinition__item_,
        AttributeValueChangeDefinition,
        _AlarmStatus__item_,
        AlarmStatus,
        _AvailabilityStatus__item_,
        AvailabilityStatus,
        BackedUpStatus,
        _BackUpDestinationList__item_,
        BackUpDestinationList,
        _BackUpRelationshipObject_objectName,
        _BackUpRelationshipObject_noObject,
        BackUpRelationshipObject,
        _CapacityAlarmThreshold__item_,
        CapacityAlarmThreshold,
        ConfirmedMode,
        _ControlStatus__item_,
        ControlStatus,
        Count,
        __CounterThreshold__item__comparisonLevel,
        __CounterThreshold__item__offsetValue,
        __CounterThreshold__item__notificationOnOff,
        _CounterThreshold__item_,
        CounterThreshold,
        ___CorrelatedNotifications__item__correlatedNotifications__item_,
        __CorrelatedNotifications__item__correlatedNotifications,
        __CorrelatedNotifications__item__sourceObjectInst,
        _CorrelatedNotifications__item_,
        CorrelatedNotifications,
        CurrentLogSize,
        _Destination_single,
        __Destination_multiple__item_,
        _Destination_multiple,
        Destination,
        DiscriminatorConstruct,
        EventTime,
        __GaugeThreshold__item__notifyLow,
        __GaugeThreshold__item__notifyHigh,
        _GaugeThreshold__item_,
        GaugeThreshold,
        GaugeThresholdValue,
        _GroupObjects__item_,
        GroupObjects,
        __IntervalsOfDay__item__intervalStart,
        __IntervalsOfDay__item__intervalEnd,
        _IntervalsOfDay__item_,
        IntervalsOfDay,
        LifecycleState,
        LogAvailability,
        LogFullAction,
        LoggingTime,
        LogRecordId,
        MaxLogSize,
        DMI_EXTENSION,
        __ManagementExtension_identifier_tab,
        _ManagementExtension_identifier,
        _ManagementExtension_significance,
        __ManagementExtension_information_tab,
        _ManagementExtension_information,
        ManagementExtension,
        ManagementExtensionSet,
        _MonitoredAttributes__item_,
        MonitoredAttributes,
        NameBinding,
        NotificationIdentifier,
        _NotifyThreshold_threshold,
        _NotifyThreshold_notifyOnOff,
        NotifyThreshold,
        NumberOfRecords,
        _ObservedValue_integer,
        _ObservedValue_real,
        ObservedValue,
        OperationalState,
        _Packages__item_,
        Packages,
        PerceivedSeverity,
        __PrioritisedObject__item__object,
        __PrioritisedObject__item__priority,
        _PrioritisedObject__item_,
        PrioritisedObject,
        _ProbableCause_globalValue,
        _ProbableCause_localValue,
        ProbableCause,
        _ProceduralStatus__item_,
        ProceduralStatus,
        _ProposedRepairActions__item_,
        ProposedRepairActions,
        SchedulingAvailability,
        SecurityAlarmCause,
        SecurityAlarmSeverity,
        _SecurityAlarmDetector_mechanism,
        _SecurityAlarmDetector_object,
        _SecurityAlarmDetector_application,
        SecurityAlarmDetector,
        ServiceProvider,
        DMI_SERVICEUSER,
        __ServiceUser_identifier_tab,
        _ServiceUser_identifier,
        __ServiceUser_details_tab,
        _ServiceUser_details,
        ServiceUser,
        ServiceUserSet,
        _SimpleNameType_number,
        _SimpleNameType_string,
        SimpleNameType,
        _SpecificIdentifier_oi,
        _SpecificIdentifier_int,
        SpecificIdentifier,
        SourceIndicator,
        _SpecificProblems__item_,
        SpecificProblems,
        StandbyStatus,
        StartTime,
        _StopTime_specific,
        _StopTime_continual,
        StopTime,
        DMI_SUPPORTEDFEATURES,
        ___SupportedFeatures__item__featureIdentifier_tab,
        __SupportedFeatures__item__featureIdentifier,
        ___SupportedFeatures__item__featureInfo_tab,
        __SupportedFeatures__item__featureInfo,
        _SupportedFeatures__item_,
        SupportedFeatures,
        SupportedFeaturesSet,
        _SystemId_name,
        _SystemId_number,
        _SystemId_nothing,
        SystemId,
        _SystemTitle_distinguishedName,
        _SystemTitle_oid,
        _SystemTitle_nothing,
        SystemTitle,
        _TideMarkInfo_currentTideMark,
        _TideMarkInfo_previousTideMark,
        _TideMarkInfo_resetTime,
        TideMarkInfo,
        _TideMark_maxTideMar,
        _TideMark_minTideMark,
        TideMark,
        _Time24_hour,
        _Time24_minute,
        Time24,
        _ThresholdInfo_triggeredThreshold,
        _ThresholdInfo_observedValue,
        _ThresholdInfo_thresholdLevel,
        _ThresholdInfo_armTime,
        ThresholdInfo,
        __ThresholdLevelInd_up_high,
        __ThresholdLevelInd_up_low,
        _ThresholdLevelInd_up,
        __ThresholdLevelInd_down_high,
        __ThresholdLevelInd_down_low,
        _ThresholdLevelInd_down,
        ThresholdLevelInd,
        TrendIndication,
        UnknownStatus,
        UnscheduledLogAvailability,
        UsageState,
        __WeekMask__item__daysOfWeek,
        __WeekMask__item__intervalsOfDay,
        _WeekMask__item_,
        WeekMask,
    ]

class AttributeCertificateDefinitions:

    _name_  = u'AttributeCertificateDefinitions'
    _oid_   = [2, 5, 1, 32, 8]
    
    _obj_ = [
        u'AttributeCertificate',
        u'TBSAttributeCertificate',
        u'AttCertVersion',
        u'Holder',
        u'IssuerSerial',
        u'ObjectDigestInfo',
        u'AttCertIssuer',
        u'AttCertValidityPeriod',
        u'AttributeCertificationPath',
        u'ACPathData',
        u'PrivilegePolicy',
        u'role',
        u'RoleSyntax',
        u'xmlPrivilegeInfo',
        u'permission',
        u'DualStringSyntax',
        u'dualStringMatch',
        u'timeSpecification',
        u'timeSpecificationMatch',
        u'targetingInformation',
        u'Targets',
        u'Target',
        u'TargetCert',
        u'userNotice',
        u'acceptablePrivilegePolicies',
        u'AcceptablePrivilegePoliciesSyntax',
        u'singleUse',
        u'groupAC',
        u'noRevAvail',
        u'sOAIdentifier',
        u'sOAIdentifierMatch',
        u'attributeDescriptor',
        u'AttributeDescriptorSyntax',
        u'AttributeIdentifier',
        u'AttributeIDs',
        u'AttributeName',
        u'AttributeDescription',
        u'PrivilegePolicyIdentifier',
        u'attDescriptor',
        u'roleSpecCertIdentifier',
        u'RoleSpecCertIdentifierSyntax',
        u'RoleSpecCertIdentifier',
        u'roleSpecCertIdMatch',
        u'basicAttConstraints',
        u'BasicAttConstraintsSyntax',
        u'basicAttConstraintsMatch',
        u'delegatedNameConstraints',
        u'delegatedNameConstraintsMatch',
        u'acceptableCertPolicies',
        u'AcceptableCertPoliciesSyntax',
        u'CertPolicyId',
        u'acceptableCertPoliciesMatch',
        u'authorityAttributeIdentifier',
        u'AuthorityAttributeIdentifierSyntax',
        u'AuthAttId',
        u'authAttIdMatch',
        u'indirectIssuer',
        u'issuedOnBehalfOf',
        u'noAssertion',
        u'allowedAttributeAssignments',
        u'AllowedAttributeAssignments',
        u'attributeMappings',
        u'AttributeMappings',
        u'holderNameConstraints',
        u'HolderNameConstraintsSyntax',
        u'GeneralSubtrees',
        u'GeneralSubtree',
        u'BaseDistance',
        u'pmiUser',
        u'pmiAA',
        u'pmiSOA',
        u'attCertCRLDistributionPt',
        u'pmiDelegationPath',
        u'privilegePolicy',
        u'protectedPrivilegePolicy',
        u'attributeCertificateAttribute',
        u'aACertificate',
        u'attributeDescriptorCertificate',
        u'attributeCertificateRevocationList',
        u'eeAttrCertificateRevocationList',
        u'attributeAuthorityRevocationList',
        u'delegationPath',
        u'AttCertPath',
        u'privPolicy',
        u'protPrivPolicy',
        u'xmlPrivPolicy',
        u'attributeCertificateExactMatch',
        u'AttributeCertificateExactAssertion',
        u'attributeCertificateMatch',
        u'AttributeCertificateAssertion',
        u'holderIssuerMatch',
        u'HolderIssuerAssertion',
        u'delegationPathMatch',
        u'DelMatchSyntax',
        u'extensionPresenceMatch',
        u'id-oc-pmiUser',
        u'id-oc-pmiAA',
        u'id-oc-pmiSOA',
        u'id-oc-attCertCRLDistributionPts',
        u'id-oc-privilegePolicy',
        u'id-oc-pmiDelegationPath',
        u'id-oc-protectedPrivilegePolicy',
        u'id-at-attributeCertificate',
        u'id-at-attributeCertificateRevocationList',
        u'id-at-aACertificate',
        u'id-at-attributeDescriptorCertificate',
        u'id-at-attributeAuthorityRevocationList',
        u'id-at-privPolicy',
        u'id-at-role',
        u'id-at-delegationPath',
        u'id-at-protPrivPolicy',
        u'id-at-xMLPrivilegeInfo',
        u'id-at-xmlPrivPolicy',
        u'id-at-permission',
        u'id-at-eeAttrCertificateRevocationList',
        u'id-ce-authorityAttributeIdentifier',
        u'id-ce-roleSpecCertIdentifier',
        u'id-ce-basicAttConstraints',
        u'id-ce-delegatedNameConstraints',
        u'id-ce-timeSpecification',
        u'id-ce-attributeDescriptor',
        u'id-ce-userNotice',
        u'id-ce-sOAIdentifier',
        u'id-ce-acceptableCertPolicies',
        u'id-ce-targetingInformation',
        u'id-ce-noRevAvail',
        u'id-ce-acceptablePrivilegePolicies',
        u'id-ce-indirectIssuer',
        u'id-ce-noAssertion',
        u'id-ce-issuedOnBehalfOf',
        u'id-ce-singleUse',
        u'id-ce-groupAC',
        u'id-ce-allowedAttributeAssignments',
        u'id-ce-attributeMappings',
        u'id-ce-holderNameConstraints',
        u'id-mr-attributeCertificateMatch',
        u'id-mr-attributeCertificateExactMatch',
        u'id-mr-holderIssuerMatch',
        u'id-mr-authAttIdMatch',
        u'id-mr-roleSpecCertIdMatch',
        u'id-mr-basicAttConstraintsMatch',
        u'id-mr-delegatedNameConstraintsMatch',
        u'id-mr-timeSpecMatch',
        u'id-mr-attDescriptorMatch',
        u'id-mr-acceptableCertPoliciesMatch',
        u'id-mr-delegationPathMatch',
        u'id-mr-sOAIdentifierMatch',
        u'id-mr-extensionPresenceMatch',
        u'id-mr-dualStringMatch',
        ]
    _type_ = [
        u'AttributeCertificate',
        u'TBSAttributeCertificate',
        u'AttCertVersion',
        u'Holder',
        u'IssuerSerial',
        u'ObjectDigestInfo',
        u'AttCertIssuer',
        u'AttCertValidityPeriod',
        u'AttributeCertificationPath',
        u'ACPathData',
        u'PrivilegePolicy',
        u'RoleSyntax',
        u'DualStringSyntax',
        u'Targets',
        u'Target',
        u'TargetCert',
        u'AcceptablePrivilegePoliciesSyntax',
        u'AttributeDescriptorSyntax',
        u'AttributeIdentifier',
        u'AttributeName',
        u'AttributeDescription',
        u'PrivilegePolicyIdentifier',
        u'RoleSpecCertIdentifierSyntax',
        u'RoleSpecCertIdentifier',
        u'BasicAttConstraintsSyntax',
        u'AcceptableCertPoliciesSyntax',
        u'CertPolicyId',
        u'AuthorityAttributeIdentifierSyntax',
        u'AuthAttId',
        u'AllowedAttributeAssignments',
        u'AttributeMappings',
        u'HolderNameConstraintsSyntax',
        u'GeneralSubtrees',
        u'GeneralSubtree',
        u'BaseDistance',
        u'AttCertPath',
        u'AttributeCertificateExactAssertion',
        u'AttributeCertificateAssertion',
        u'HolderIssuerAssertion',
        u'DelMatchSyntax',
        ]
    _set_ = [
        u'AttributeIDs',
        ]
    _val_ = [
        u'role',
        u'xmlPrivilegeInfo',
        u'permission',
        u'dualStringMatch',
        u'timeSpecification',
        u'timeSpecificationMatch',
        u'targetingInformation',
        u'userNotice',
        u'acceptablePrivilegePolicies',
        u'singleUse',
        u'groupAC',
        u'noRevAvail',
        u'sOAIdentifier',
        u'sOAIdentifierMatch',
        u'attributeDescriptor',
        u'attDescriptor',
        u'roleSpecCertIdentifier',
        u'roleSpecCertIdMatch',
        u'basicAttConstraints',
        u'basicAttConstraintsMatch',
        u'delegatedNameConstraints',
        u'delegatedNameConstraintsMatch',
        u'acceptableCertPolicies',
        u'acceptableCertPoliciesMatch',
        u'authorityAttributeIdentifier',
        u'authAttIdMatch',
        u'indirectIssuer',
        u'issuedOnBehalfOf',
        u'noAssertion',
        u'allowedAttributeAssignments',
        u'attributeMappings',
        u'holderNameConstraints',
        u'pmiUser',
        u'pmiAA',
        u'pmiSOA',
        u'attCertCRLDistributionPt',
        u'pmiDelegationPath',
        u'privilegePolicy',
        u'protectedPrivilegePolicy',
        u'attributeCertificateAttribute',
        u'aACertificate',
        u'attributeDescriptorCertificate',
        u'attributeCertificateRevocationList',
        u'eeAttrCertificateRevocationList',
        u'attributeAuthorityRevocationList',
        u'delegationPath',
        u'privPolicy',
        u'protPrivPolicy',
        u'xmlPrivPolicy',
        u'attributeCertificateExactMatch',
        u'attributeCertificateMatch',
        u'holderIssuerMatch',
        u'delegationPathMatch',
        u'extensionPresenceMatch',
        u'id-oc-pmiUser',
        u'id-oc-pmiAA',
        u'id-oc-pmiSOA',
        u'id-oc-attCertCRLDistributionPts',
        u'id-oc-privilegePolicy',
        u'id-oc-pmiDelegationPath',
        u'id-oc-protectedPrivilegePolicy',
        u'id-at-attributeCertificate',
        u'id-at-attributeCertificateRevocationList',
        u'id-at-aACertificate',
        u'id-at-attributeDescriptorCertificate',
        u'id-at-attributeAuthorityRevocationList',
        u'id-at-privPolicy',
        u'id-at-role',
        u'id-at-delegationPath',
        u'id-at-protPrivPolicy',
        u'id-at-xMLPrivilegeInfo',
        u'id-at-xmlPrivPolicy',
        u'id-at-permission',
        u'id-at-eeAttrCertificateRevocationList',
        u'id-ce-authorityAttributeIdentifier',
        u'id-ce-roleSpecCertIdentifier',
        u'id-ce-basicAttConstraints',
        u'id-ce-delegatedNameConstraints',
        u'id-ce-timeSpecification',
        u'id-ce-attributeDescriptor',
        u'id-ce-userNotice',
        u'id-ce-sOAIdentifier',
        u'id-ce-acceptableCertPolicies',
        u'id-ce-targetingInformation',
        u'id-ce-noRevAvail',
        u'id-ce-acceptablePrivilegePolicies',
        u'id-ce-indirectIssuer',
        u'id-ce-noAssertion',
        u'id-ce-issuedOnBehalfOf',
        u'id-ce-singleUse',
        u'id-ce-groupAC',
        u'id-ce-allowedAttributeAssignments',
        u'id-ce-attributeMappings',
        u'id-ce-holderNameConstraints',
        u'id-mr-attributeCertificateMatch',
        u'id-mr-attributeCertificateExactMatch',
        u'id-mr-holderIssuerMatch',
        u'id-mr-authAttIdMatch',
        u'id-mr-roleSpecCertIdMatch',
        u'id-mr-basicAttConstraintsMatch',
        u'id-mr-delegatedNameConstraintsMatch',
        u'id-mr-timeSpecMatch',
        u'id-mr-attDescriptorMatch',
        u'id-mr-acceptableCertPoliciesMatch',
        u'id-mr-delegationPathMatch',
        u'id-mr-sOAIdentifierMatch',
        u'id-mr-extensionPresenceMatch',
        u'id-mr-dualStringMatch',
        ]
    _class_ = [
        u'role',
        u'xmlPrivilegeInfo',
        u'permission',
        u'dualStringMatch',
        u'timeSpecification',
        u'timeSpecificationMatch',
        u'targetingInformation',
        u'userNotice',
        u'acceptablePrivilegePolicies',
        u'singleUse',
        u'groupAC',
        u'noRevAvail',
        u'sOAIdentifier',
        u'sOAIdentifierMatch',
        u'attributeDescriptor',
        u'AttributeIDs',
        u'attDescriptor',
        u'roleSpecCertIdentifier',
        u'roleSpecCertIdMatch',
        u'basicAttConstraints',
        u'basicAttConstraintsMatch',
        u'delegatedNameConstraints',
        u'delegatedNameConstraintsMatch',
        u'acceptableCertPolicies',
        u'acceptableCertPoliciesMatch',
        u'authorityAttributeIdentifier',
        u'authAttIdMatch',
        u'indirectIssuer',
        u'issuedOnBehalfOf',
        u'noAssertion',
        u'allowedAttributeAssignments',
        u'attributeMappings',
        u'holderNameConstraints',
        u'pmiUser',
        u'pmiAA',
        u'pmiSOA',
        u'attCertCRLDistributionPt',
        u'pmiDelegationPath',
        u'privilegePolicy',
        u'protectedPrivilegePolicy',
        u'attributeCertificateAttribute',
        u'aACertificate',
        u'attributeDescriptorCertificate',
        u'attributeCertificateRevocationList',
        u'eeAttrCertificateRevocationList',
        u'attributeAuthorityRevocationList',
        u'delegationPath',
        u'privPolicy',
        u'protPrivPolicy',
        u'xmlPrivPolicy',
        u'attributeCertificateExactMatch',
        u'attributeCertificateMatch',
        u'holderIssuerMatch',
        u'delegationPathMatch',
        u'extensionPresenceMatch',
        ]
    _param_ = [
        ]
    
    #-----< AttributeCertificate >-----#
    AttributeCertificate = SEQ(name=u'AttributeCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _AttributeCertificate_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'TBSAttributeCertificate')))
    _AttributeCertificate_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AttributeCertificate_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___AttributeCertificate_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeCertificate_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeCertificate_algorithmIdentifier_algorithm._const_tab = ___AttributeCertificate_algorithmIdentifier_algorithm_tab
    __AttributeCertificate_algorithmIdentifier_algorithm._const_tab_at = None
    __AttributeCertificate_algorithmIdentifier_algorithm._const_tab_id = u'id'
    __AttributeCertificate_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___AttributeCertificate_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeCertificate_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeCertificate_algorithmIdentifier_parameters._const_tab = ___AttributeCertificate_algorithmIdentifier_parameters_tab
    __AttributeCertificate_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    __AttributeCertificate_algorithmIdentifier_parameters._const_tab_id = u'Type'
    _AttributeCertificate_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', __AttributeCertificate_algorithmIdentifier_algorithm),
        (u'parameters', __AttributeCertificate_algorithmIdentifier_parameters),
        ])
    _AttributeCertificate_algorithmIdentifier._ext = []
    _AttributeCertificate_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    AttributeCertificate._cont = ASN1Dict([
        (u'toBeSigned', _AttributeCertificate_toBeSigned),
        (u'algorithmIdentifier', _AttributeCertificate_algorithmIdentifier),
        (u'signature', _AttributeCertificate_signature),
        ])
    AttributeCertificate._ext = []
    
    #-----< TBSAttributeCertificate >-----#
    TBSAttributeCertificate = SEQ(name=u'TBSAttributeCertificate', mode=MODE_TYPE)
    _TBSAttributeCertificate_version = INT(name=u'version', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertVersion')))
    _TBSAttributeCertificate_holder = SEQ(name=u'holder', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'Holder')))
    _TBSAttributeCertificate_issuer = SEQ(name=u'issuer', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertIssuer')))
    _TBSAttributeCertificate_signature = SEQ(name=u'signature', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __TBSAttributeCertificate_signature_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___TBSAttributeCertificate_signature_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TBSAttributeCertificate_signature_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TBSAttributeCertificate_signature_algorithm._const_tab = ___TBSAttributeCertificate_signature_algorithm_tab
    __TBSAttributeCertificate_signature_algorithm._const_tab_at = None
    __TBSAttributeCertificate_signature_algorithm._const_tab_id = u'id'
    __TBSAttributeCertificate_signature_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___TBSAttributeCertificate_signature_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TBSAttributeCertificate_signature_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TBSAttributeCertificate_signature_parameters._const_tab = ___TBSAttributeCertificate_signature_parameters_tab
    __TBSAttributeCertificate_signature_parameters._const_tab_at = ('..', u'algorithm')
    __TBSAttributeCertificate_signature_parameters._const_tab_id = u'Type'
    _TBSAttributeCertificate_signature._cont = ASN1Dict([
        (u'algorithm', __TBSAttributeCertificate_signature_algorithm),
        (u'parameters', __TBSAttributeCertificate_signature_parameters),
        ])
    _TBSAttributeCertificate_signature._ext = []
    _TBSAttributeCertificate_serialNumber = INT(name=u'serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    _TBSAttributeCertificate_attrCertValidityPeriod = SEQ(name=u'attrCertValidityPeriod', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertValidityPeriod')))
    _TBSAttributeCertificate_attributes = SEQ_OF(name=u'attributes', mode=MODE_TYPE)
    __TBSAttributeCertificate_attributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___TBSAttributeCertificate_attributes__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____TBSAttributeCertificate_attributes__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____TBSAttributeCertificate_attributes__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    _____TBSAttributeCertificate_attributes__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____TBSAttributeCertificate_attributes__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____TBSAttributeCertificate_attributes__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____TBSAttributeCertificate_attributes__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___TBSAttributeCertificate_attributes__item__type._const_tab = ____TBSAttributeCertificate_attributes__item__type_tab
    ___TBSAttributeCertificate_attributes__item__type._const_tab_at = None
    ___TBSAttributeCertificate_attributes__item__type._const_tab_id = u'id'
    ___TBSAttributeCertificate_attributes__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____TBSAttributeCertificate_attributes__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____TBSAttributeCertificate_attributes__item__values__item_._const_tab = ____TBSAttributeCertificate_attributes__item__type_tab
    ____TBSAttributeCertificate_attributes__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____TBSAttributeCertificate_attributes__item__values__item_._const_tab_id = u'Type'
    ___TBSAttributeCertificate_attributes__item__values._cont = ____TBSAttributeCertificate_attributes__item__values__item_
    ___TBSAttributeCertificate_attributes__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___TBSAttributeCertificate_attributes__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____TBSAttributeCertificate_attributes__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__value._const_tab = ____TBSAttributeCertificate_attributes__item__type_tab
    _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList._cont = ______TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList__item_
    _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____TBSAttributeCertificate_attributes__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__value),
        (u'contextList', _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList),
        ])
    ____TBSAttributeCertificate_attributes__item__valuesWithContext__item_._ext = []
    ___TBSAttributeCertificate_attributes__item__valuesWithContext._cont = ____TBSAttributeCertificate_attributes__item__valuesWithContext__item_
    ___TBSAttributeCertificate_attributes__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __TBSAttributeCertificate_attributes__item_._cont = ASN1Dict([
        (u'type', ___TBSAttributeCertificate_attributes__item__type),
        (u'values', ___TBSAttributeCertificate_attributes__item__values),
        (u'valuesWithContext', ___TBSAttributeCertificate_attributes__item__valuesWithContext),
        ])
    __TBSAttributeCertificate_attributes__item_._ext = []
    _TBSAttributeCertificate_attributes._cont = __TBSAttributeCertificate_attributes__item_
    _TBSAttributeCertificate_issuerUniqueID = BIT_STR(name=u'issuerUniqueID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True)
    _TBSAttributeCertificate_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True)
    TBSAttributeCertificate._cont = ASN1Dict([
        (u'version', _TBSAttributeCertificate_version),
        (u'holder', _TBSAttributeCertificate_holder),
        (u'issuer', _TBSAttributeCertificate_issuer),
        (u'signature', _TBSAttributeCertificate_signature),
        (u'serialNumber', _TBSAttributeCertificate_serialNumber),
        (u'attrCertValidityPeriod', _TBSAttributeCertificate_attrCertValidityPeriod),
        (u'attributes', _TBSAttributeCertificate_attributes),
        (u'issuerUniqueID', _TBSAttributeCertificate_issuerUniqueID),
        (u'extensions', _TBSAttributeCertificate_extensions),
        ])
    TBSAttributeCertificate._ext = [u'extensions']
    
    #-----< AttCertVersion >-----#
    AttCertVersion = INT(name=u'AttCertVersion', mode=MODE_TYPE)
    AttCertVersion._cont = ASN1Dict([(u'v2', 1)])
    
    #-----< Holder >-----#
    Holder = SEQ(name=u'Holder', mode=MODE_TYPE)
    _Holder_baseCertificateID = SEQ(name=u'baseCertificateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'IssuerSerial')), opt=True)
    _Holder_entityName = SEQ_OF(name=u'entityName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _Holder_objectDigestInfo = SEQ(name=u'objectDigestInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'ObjectDigestInfo')), opt=True)
    Holder._cont = ASN1Dict([
        (u'baseCertificateID', _Holder_baseCertificateID),
        (u'entityName', _Holder_entityName),
        (u'objectDigestInfo', _Holder_objectDigestInfo),
        ])
    Holder._ext = None
    
    #-----< IssuerSerial >-----#
    IssuerSerial = SEQ(name=u'IssuerSerial', mode=MODE_TYPE)
    _IssuerSerial_issuer = SEQ_OF(name=u'issuer', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    _IssuerSerial_serial = INT(name=u'serial', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    _IssuerSerial_issuerUID = BIT_STR(name=u'issuerUID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True)
    IssuerSerial._cont = ASN1Dict([
        (u'issuer', _IssuerSerial_issuer),
        (u'serial', _IssuerSerial_serial),
        (u'issuerUID', _IssuerSerial_issuerUID),
        ])
    IssuerSerial._ext = []
    
    #-----< ObjectDigestInfo >-----#
    ObjectDigestInfo = SEQ(name=u'ObjectDigestInfo', mode=MODE_TYPE)
    _ObjectDigestInfo_digestedObjectType = ENUM(name=u'digestedObjectType', mode=MODE_TYPE)
    _ObjectDigestInfo_digestedObjectType._cont = ASN1Dict([(u'publicKey', 0), (u'publicKeyCert', 1), (u'otherObjectTypes', 2)])
    _ObjectDigestInfo_digestedObjectType._ext = None
    _ObjectDigestInfo_otherObjectTypeID = OID(name=u'otherObjectTypeID', mode=MODE_TYPE, opt=True)
    _ObjectDigestInfo_digestAlgorithm = SEQ(name=u'digestAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __ObjectDigestInfo_digestAlgorithm_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___ObjectDigestInfo_digestAlgorithm_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___ObjectDigestInfo_digestAlgorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ObjectDigestInfo_digestAlgorithm_algorithm._const_tab = ___ObjectDigestInfo_digestAlgorithm_algorithm_tab
    __ObjectDigestInfo_digestAlgorithm_algorithm._const_tab_at = None
    __ObjectDigestInfo_digestAlgorithm_algorithm._const_tab_id = u'id'
    __ObjectDigestInfo_digestAlgorithm_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___ObjectDigestInfo_digestAlgorithm_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___ObjectDigestInfo_digestAlgorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ObjectDigestInfo_digestAlgorithm_parameters._const_tab = ___ObjectDigestInfo_digestAlgorithm_parameters_tab
    __ObjectDigestInfo_digestAlgorithm_parameters._const_tab_at = ('..', u'algorithm')
    __ObjectDigestInfo_digestAlgorithm_parameters._const_tab_id = u'Type'
    _ObjectDigestInfo_digestAlgorithm._cont = ASN1Dict([
        (u'algorithm', __ObjectDigestInfo_digestAlgorithm_algorithm),
        (u'parameters', __ObjectDigestInfo_digestAlgorithm_parameters),
        ])
    _ObjectDigestInfo_digestAlgorithm._ext = []
    _ObjectDigestInfo_objectDigest = BIT_STR(name=u'objectDigest', mode=MODE_TYPE)
    ObjectDigestInfo._cont = ASN1Dict([
        (u'digestedObjectType', _ObjectDigestInfo_digestedObjectType),
        (u'otherObjectTypeID', _ObjectDigestInfo_otherObjectTypeID),
        (u'digestAlgorithm', _ObjectDigestInfo_digestAlgorithm),
        (u'objectDigest', _ObjectDigestInfo_objectDigest),
        ])
    ObjectDigestInfo._ext = []
    
    #-----< AttCertIssuer >-----#
    AttCertIssuer = SEQ(name=u'AttCertIssuer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AttCertIssuer_issuerName = SEQ_OF(name=u'issuerName', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _AttCertIssuer_baseCertificateID = SEQ(name=u'baseCertificateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'IssuerSerial')), opt=True)
    _AttCertIssuer_objectDigestInfo = SEQ(name=u'objectDigestInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'ObjectDigestInfo')), opt=True)
    AttCertIssuer._cont = ASN1Dict([
        (u'issuerName', _AttCertIssuer_issuerName),
        (u'baseCertificateID', _AttCertIssuer_baseCertificateID),
        (u'objectDigestInfo', _AttCertIssuer_objectDigestInfo),
        ])
    AttCertIssuer._ext = []
    
    #-----< AttCertValidityPeriod >-----#
    AttCertValidityPeriod = SEQ(name=u'AttCertValidityPeriod', mode=MODE_TYPE)
    _AttCertValidityPeriod_notBeforeTime = TIME_GEN(name=u'notBeforeTime', mode=MODE_TYPE)
    _AttCertValidityPeriod_notAfterTime = TIME_GEN(name=u'notAfterTime', mode=MODE_TYPE)
    AttCertValidityPeriod._cont = ASN1Dict([
        (u'notBeforeTime', _AttCertValidityPeriod_notBeforeTime),
        (u'notAfterTime', _AttCertValidityPeriod_notAfterTime),
        ])
    AttCertValidityPeriod._ext = []
    
    #-----< AttributeCertificationPath >-----#
    AttributeCertificationPath = SEQ(name=u'AttributeCertificationPath', mode=MODE_TYPE)
    _AttributeCertificationPath_attributeCertificate = SEQ(name=u'attributeCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    _AttributeCertificationPath_acPath = SEQ_OF(name=u'acPath', mode=MODE_TYPE, opt=True)
    __AttributeCertificationPath_acPath__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'ACPathData')))
    _AttributeCertificationPath_acPath._cont = __AttributeCertificationPath_acPath__item_
    AttributeCertificationPath._cont = ASN1Dict([
        (u'attributeCertificate', _AttributeCertificationPath_attributeCertificate),
        (u'acPath', _AttributeCertificationPath_acPath),
        ])
    AttributeCertificationPath._ext = []
    
    #-----< ACPathData >-----#
    ACPathData = SEQ(name=u'ACPathData', mode=MODE_TYPE)
    _ACPathData_certificate = SEQ(name=u'certificate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')), opt=True)
    _ACPathData_attributeCertificate = SEQ(name=u'attributeCertificate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')), opt=True)
    ACPathData._cont = ASN1Dict([
        (u'certificate', _ACPathData_certificate),
        (u'attributeCertificate', _ACPathData_attributeCertificate),
        ])
    ACPathData._ext = []
    
    #-----< PrivilegePolicy >-----#
    PrivilegePolicy = OID(name=u'PrivilegePolicy', mode=MODE_TYPE)
    
    #-----< role >-----#
    role = CLASS(name=u'role', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _role_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'RoleSyntax')))
    role._val = dict([(u'Type', _role_val_Type), (u'id', (2, 5, 4, 72))])
    
    #-----< RoleSyntax >-----#
    RoleSyntax = SEQ(name=u'RoleSyntax', mode=MODE_TYPE)
    _RoleSyntax_roleAuthority = SEQ_OF(name=u'roleAuthority', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _RoleSyntax_roleName = CHOICE(name=u'roleName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    RoleSyntax._cont = ASN1Dict([
        (u'roleAuthority', _RoleSyntax_roleAuthority),
        (u'roleName', _RoleSyntax_roleName),
        ])
    RoleSyntax._ext = []
    
    #-----< xmlPrivilegeInfo >-----#
    xmlPrivilegeInfo = CLASS(name=u'xmlPrivilegeInfo', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _xmlPrivilegeInfo_val_Type = STR_UTF8(name=u'Type', mode=MODE_TYPE)
    xmlPrivilegeInfo._val = dict([(u'Type', _xmlPrivilegeInfo_val_Type), (u'id', (2, 5, 4, 75))])
    
    #-----< permission >-----#
    permission = CLASS(name=u'permission', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _permission_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'DualStringSyntax')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1 = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'DualStringSyntax')))
    permission._val = dict([(u'Type', _permission_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'id', (2, 5, 13, 69))])), (u'id', (2, 5, 4, 82))])
    
    #-----< DualStringSyntax >-----#
    DualStringSyntax = SEQ(name=u'DualStringSyntax', mode=MODE_TYPE)
    _DualStringSyntax_operation = CHOICE(name=u'operation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _DualStringSyntax_object = CHOICE(name=u'object', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    DualStringSyntax._cont = ASN1Dict([
        (u'operation', _DualStringSyntax_operation),
        (u'object', _DualStringSyntax_object),
        ])
    DualStringSyntax._ext = []
    
    #-----< dualStringMatch >-----#
    dualStringMatch = CLASS(name=u'dualStringMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _dualStringMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'DualStringSyntax')))
    dualStringMatch._val = dict([(u'AssertionType', _dualStringMatch_val_AssertionType), (u'id', (2, 5, 13, 69))])
    
    #-----< timeSpecification >-----#
    timeSpecification = CLASS(name=u'timeSpecification', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _timeSpecification_val_ExtnType = SEQ(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TimeSpecification')))
    timeSpecification._val = dict([(u'ExtnType', _timeSpecification_val_ExtnType), (u'id', (2, 5, 29, 43))])
    
    #-----< timeSpecificationMatch >-----#
    timeSpecificationMatch = CLASS(name=u'timeSpecificationMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _timeSpecificationMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TimeSpecification')))
    timeSpecificationMatch._val = dict([(u'AssertionType', _timeSpecificationMatch_val_AssertionType), (u'id', (2, 5, 13, 57))])
    
    #-----< targetingInformation >-----#
    targetingInformation = CLASS(name=u'targetingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _targetingInformation_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE)
    __targetingInformation_val_ExtnType__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'Targets')))
    _targetingInformation_val_ExtnType._cont = __targetingInformation_val_ExtnType__item_
    _targetingInformation_val_ExtnType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    targetingInformation._val = dict([(u'ExtnType', _targetingInformation_val_ExtnType), (u'id', (2, 5, 29, 55))])
    
    #-----< Targets >-----#
    Targets = SEQ_OF(name=u'Targets', mode=MODE_TYPE)
    _Targets__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'Target')))
    Targets._cont = _Targets__item_
    Targets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< Target >-----#
    Target = CHOICE(name=u'Target', mode=MODE_TYPE)
    _Target_targetName = CHOICE(name=u'targetName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _Target_targetGroup = CHOICE(name=u'targetGroup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _Target_targetCert = SEQ(name=u'targetCert', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'TargetCert')))
    Target._cont = ASN1Dict([
        (u'targetName', _Target_targetName),
        (u'targetGroup', _Target_targetGroup),
        (u'targetCert', _Target_targetCert),
        ])
    Target._ext = []
    
    #-----< TargetCert >-----#
    TargetCert = SEQ(name=u'TargetCert', mode=MODE_TYPE)
    _TargetCert_targetCertificate = SEQ(name=u'targetCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'IssuerSerial')))
    _TargetCert_targetName = CHOICE(name=u'targetName', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _TargetCert_certDigestInfo = SEQ(name=u'certDigestInfo', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'ObjectDigestInfo')), opt=True)
    TargetCert._cont = ASN1Dict([
        (u'targetCertificate', _TargetCert_targetCertificate),
        (u'targetName', _TargetCert_targetName),
        (u'certDigestInfo', _TargetCert_certDigestInfo),
        ])
    TargetCert._ext = None
    
    #-----< userNotice >-----#
    userNotice = CLASS(name=u'userNotice', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _userNotice_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE)
    __userNotice_val_ExtnType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UserNotice')))
    _userNotice_val_ExtnType._cont = __userNotice_val_ExtnType__item_
    _userNotice_val_ExtnType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    userNotice._val = dict([(u'ExtnType', _userNotice_val_ExtnType), (u'id', (2, 5, 29, 49))])
    
    #-----< acceptablePrivilegePolicies >-----#
    acceptablePrivilegePolicies = CLASS(name=u'acceptablePrivilegePolicies', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _acceptablePrivilegePolicies_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AcceptablePrivilegePoliciesSyntax')))
    acceptablePrivilegePolicies._val = dict([(u'ExtnType', _acceptablePrivilegePolicies_val_ExtnType), (u'id', (2, 5, 29, 57))])
    
    #-----< AcceptablePrivilegePoliciesSyntax >-----#
    AcceptablePrivilegePoliciesSyntax = SEQ_OF(name=u'AcceptablePrivilegePoliciesSyntax', mode=MODE_TYPE)
    _AcceptablePrivilegePoliciesSyntax__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'PrivilegePolicy')))
    AcceptablePrivilegePoliciesSyntax._cont = _AcceptablePrivilegePoliciesSyntax__item_
    AcceptablePrivilegePoliciesSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< singleUse >-----#
    singleUse = CLASS(name=u'singleUse', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _singleUse_val_ExtnType = NULL(name=u'ExtnType', mode=MODE_TYPE)
    singleUse._val = dict([(u'ExtnType', _singleUse_val_ExtnType), (u'id', (2, 5, 29, 65))])
    
    #-----< groupAC >-----#
    groupAC = CLASS(name=u'groupAC', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _groupAC_val_ExtnType = NULL(name=u'ExtnType', mode=MODE_TYPE)
    groupAC._val = dict([(u'ExtnType', _groupAC_val_ExtnType), (u'id', (2, 5, 29, 66))])
    
    #-----< noRevAvail >-----#
    noRevAvail = CLASS(name=u'noRevAvail', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _noRevAvail_val_ExtnType = NULL(name=u'ExtnType', mode=MODE_TYPE)
    noRevAvail._val = dict([(u'ExtnType', _noRevAvail_val_ExtnType), (u'id', (2, 5, 29, 56))])
    
    #-----< sOAIdentifier >-----#
    sOAIdentifier = CLASS(name=u'sOAIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _sOAIdentifier_val_ExtnType = NULL(name=u'ExtnType', mode=MODE_TYPE)
    sOAIdentifier._val = dict([(u'ExtnType', _sOAIdentifier_val_ExtnType), (u'id', (2, 5, 29, 50))])
    
    #-----< sOAIdentifierMatch >-----#
    sOAIdentifierMatch = CLASS(name=u'sOAIdentifierMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _sOAIdentifierMatch_val_AssertionType = NULL(name=u'AssertionType', mode=MODE_TYPE)
    sOAIdentifierMatch._val = dict([(u'AssertionType', _sOAIdentifierMatch_val_AssertionType), (u'id', (2, 5, 13, 66))])
    
    #-----< attributeDescriptor >-----#
    attributeDescriptor = CLASS(name=u'attributeDescriptor', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _attributeDescriptor_val_ExtnType = SEQ(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeDescriptorSyntax')))
    attributeDescriptor._val = dict([(u'ExtnType', _attributeDescriptor_val_ExtnType), (u'id', (2, 5, 29, 48))])
    
    #-----< AttributeDescriptorSyntax >-----#
    AttributeDescriptorSyntax = SEQ(name=u'AttributeDescriptorSyntax', mode=MODE_TYPE)
    _AttributeDescriptorSyntax_identifier = OID(name=u'identifier', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeIdentifier')))
    _AttributeDescriptorSyntax_attributeSyntax = OCT_STR(name=u'attributeSyntax', mode=MODE_TYPE)
    _AttributeDescriptorSyntax_attributeSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AttributeDescriptorSyntax_name = STR_UTF8(name=u'name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeName')), opt=True)
    _AttributeDescriptorSyntax_description = STR_UTF8(name=u'description', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeDescription')), opt=True)
    _AttributeDescriptorSyntax_dominationRule = SEQ(name=u'dominationRule', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'PrivilegePolicyIdentifier')))
    AttributeDescriptorSyntax._cont = ASN1Dict([
        (u'identifier', _AttributeDescriptorSyntax_identifier),
        (u'attributeSyntax', _AttributeDescriptorSyntax_attributeSyntax),
        (u'name', _AttributeDescriptorSyntax_name),
        (u'description', _AttributeDescriptorSyntax_description),
        (u'dominationRule', _AttributeDescriptorSyntax_dominationRule),
        ])
    AttributeDescriptorSyntax._ext = []
    
    #-----< AttributeIdentifier >-----#
    AttributeIdentifier = OID(name=u'AttributeIdentifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _AttributeIdentifier_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _AttributeIdentifier_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    AttributeIdentifier._const_tab = _AttributeIdentifier_tab
    AttributeIdentifier._const_tab_at = None
    AttributeIdentifier._const_tab_id = u'id'
    
    #-----< AttributeIDs >-----#
    AttributeIDs = CLASS(name=u'AttributeIDs', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    AttributeIDs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AttributeName >-----#
    AttributeName = STR_UTF8(name=u'AttributeName', mode=MODE_TYPE)
    AttributeName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AttributeDescription >-----#
    AttributeDescription = STR_UTF8(name=u'AttributeDescription', mode=MODE_TYPE)
    AttributeDescription._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< PrivilegePolicyIdentifier >-----#
    PrivilegePolicyIdentifier = SEQ(name=u'PrivilegePolicyIdentifier', mode=MODE_TYPE)
    _PrivilegePolicyIdentifier_privilegePolicy = OID(name=u'privilegePolicy', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'PrivilegePolicy')))
    _PrivilegePolicyIdentifier_privPolSyntax = CHOICE(name=u'privPolSyntax', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'InfoSyntax')))
    PrivilegePolicyIdentifier._cont = ASN1Dict([
        (u'privilegePolicy', _PrivilegePolicyIdentifier_privilegePolicy),
        (u'privPolSyntax', _PrivilegePolicyIdentifier_privPolSyntax),
        ])
    PrivilegePolicyIdentifier._ext = []
    
    #-----< attDescriptor >-----#
    attDescriptor = CLASS(name=u'attDescriptor', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _attDescriptor_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeDescriptorSyntax')))
    attDescriptor._val = dict([(u'AssertionType', _attDescriptor_val_AssertionType), (u'id', (2, 5, 13, 58))])
    
    #-----< roleSpecCertIdentifier >-----#
    roleSpecCertIdentifier = CLASS(name=u'roleSpecCertIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _roleSpecCertIdentifier_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'RoleSpecCertIdentifierSyntax')))
    roleSpecCertIdentifier._val = dict([(u'ExtnType', _roleSpecCertIdentifier_val_ExtnType), (u'id', (2, 5, 29, 39))])
    
    #-----< RoleSpecCertIdentifierSyntax >-----#
    RoleSpecCertIdentifierSyntax = SEQ_OF(name=u'RoleSpecCertIdentifierSyntax', mode=MODE_TYPE)
    _RoleSpecCertIdentifierSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'RoleSpecCertIdentifier')))
    RoleSpecCertIdentifierSyntax._cont = _RoleSpecCertIdentifierSyntax__item_
    RoleSpecCertIdentifierSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< RoleSpecCertIdentifier >-----#
    RoleSpecCertIdentifier = SEQ(name=u'RoleSpecCertIdentifier', mode=MODE_TYPE)
    _RoleSpecCertIdentifier_roleName = CHOICE(name=u'roleName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _RoleSpecCertIdentifier_roleCertIssuer = CHOICE(name=u'roleCertIssuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _RoleSpecCertIdentifier_roleCertSerialNumber = INT(name=u'roleCertSerialNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')), opt=True)
    _RoleSpecCertIdentifier_roleCertLocator = SEQ_OF(name=u'roleCertLocator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    RoleSpecCertIdentifier._cont = ASN1Dict([
        (u'roleName', _RoleSpecCertIdentifier_roleName),
        (u'roleCertIssuer', _RoleSpecCertIdentifier_roleCertIssuer),
        (u'roleCertSerialNumber', _RoleSpecCertIdentifier_roleCertSerialNumber),
        (u'roleCertLocator', _RoleSpecCertIdentifier_roleCertLocator),
        ])
    RoleSpecCertIdentifier._ext = []
    
    #-----< roleSpecCertIdMatch >-----#
    roleSpecCertIdMatch = CLASS(name=u'roleSpecCertIdMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _roleSpecCertIdMatch_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'RoleSpecCertIdentifierSyntax')))
    roleSpecCertIdMatch._val = dict([(u'AssertionType', _roleSpecCertIdMatch_val_AssertionType), (u'id', (2, 5, 13, 54))])
    
    #-----< basicAttConstraints >-----#
    basicAttConstraints = CLASS(name=u'basicAttConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _basicAttConstraints_val_ExtnType = SEQ(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'BasicAttConstraintsSyntax')))
    basicAttConstraints._val = dict([(u'ExtnType', _basicAttConstraints_val_ExtnType), (u'id', (2, 5, 29, 41))])
    
    #-----< BasicAttConstraintsSyntax >-----#
    BasicAttConstraintsSyntax = SEQ(name=u'BasicAttConstraintsSyntax', mode=MODE_TYPE)
    _BasicAttConstraintsSyntax_authority = BOOL(name=u'authority', mode=MODE_TYPE, default=False)
    _BasicAttConstraintsSyntax_pathLenConstraint = INT(name=u'pathLenConstraint', mode=MODE_TYPE, opt=True)
    _BasicAttConstraintsSyntax_pathLenConstraint._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    BasicAttConstraintsSyntax._cont = ASN1Dict([
        (u'authority', _BasicAttConstraintsSyntax_authority),
        (u'pathLenConstraint', _BasicAttConstraintsSyntax_pathLenConstraint),
        ])
    BasicAttConstraintsSyntax._ext = []
    
    #-----< basicAttConstraintsMatch >-----#
    basicAttConstraintsMatch = CLASS(name=u'basicAttConstraintsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _basicAttConstraintsMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'BasicAttConstraintsSyntax')))
    basicAttConstraintsMatch._val = dict([(u'AssertionType', _basicAttConstraintsMatch_val_AssertionType), (u'id', (2, 5, 13, 55))])
    
    #-----< delegatedNameConstraints >-----#
    delegatedNameConstraints = CLASS(name=u'delegatedNameConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _delegatedNameConstraints_val_ExtnType = SEQ(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'NameConstraintsSyntax')))
    delegatedNameConstraints._val = dict([(u'ExtnType', _delegatedNameConstraints_val_ExtnType), (u'id', (2, 5, 29, 42))])
    
    #-----< delegatedNameConstraintsMatch >-----#
    delegatedNameConstraintsMatch = CLASS(name=u'delegatedNameConstraintsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _delegatedNameConstraintsMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'NameConstraintsSyntax')))
    delegatedNameConstraintsMatch._val = dict([(u'AssertionType', _delegatedNameConstraintsMatch_val_AssertionType), (u'id', (2, 5, 13, 56))])
    
    #-----< acceptableCertPolicies >-----#
    acceptableCertPolicies = CLASS(name=u'acceptableCertPolicies', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _acceptableCertPolicies_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AcceptableCertPoliciesSyntax')))
    acceptableCertPolicies._val = dict([(u'ExtnType', _acceptableCertPolicies_val_ExtnType), (u'id', (2, 5, 29, 52))])
    
    #-----< AcceptableCertPoliciesSyntax >-----#
    AcceptableCertPoliciesSyntax = SEQ_OF(name=u'AcceptableCertPoliciesSyntax', mode=MODE_TYPE)
    _AcceptableCertPoliciesSyntax__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'CertPolicyId')))
    AcceptableCertPoliciesSyntax._cont = _AcceptableCertPoliciesSyntax__item_
    AcceptableCertPoliciesSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< CertPolicyId >-----#
    CertPolicyId = OID(name=u'CertPolicyId', mode=MODE_TYPE)
    
    #-----< acceptableCertPoliciesMatch >-----#
    acceptableCertPoliciesMatch = CLASS(name=u'acceptableCertPoliciesMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _acceptableCertPoliciesMatch_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AcceptableCertPoliciesSyntax')))
    acceptableCertPoliciesMatch._val = dict([(u'AssertionType', _acceptableCertPoliciesMatch_val_AssertionType), (u'id', (2, 5, 13, 59))])
    
    #-----< authorityAttributeIdentifier >-----#
    authorityAttributeIdentifier = CLASS(name=u'authorityAttributeIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _authorityAttributeIdentifier_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AuthorityAttributeIdentifierSyntax')))
    authorityAttributeIdentifier._val = dict([(u'ExtnType', _authorityAttributeIdentifier_val_ExtnType), (u'id', (2, 5, 29, 38))])
    
    #-----< AuthorityAttributeIdentifierSyntax >-----#
    AuthorityAttributeIdentifierSyntax = SEQ_OF(name=u'AuthorityAttributeIdentifierSyntax', mode=MODE_TYPE)
    _AuthorityAttributeIdentifierSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AuthAttId')))
    AuthorityAttributeIdentifierSyntax._cont = _AuthorityAttributeIdentifierSyntax__item_
    AuthorityAttributeIdentifierSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AuthAttId >-----#
    AuthAttId = SEQ(name=u'AuthAttId', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'IssuerSerial')))
    
    #-----< authAttIdMatch >-----#
    authAttIdMatch = CLASS(name=u'authAttIdMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _authAttIdMatch_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AuthorityAttributeIdentifierSyntax')))
    authAttIdMatch._val = dict([(u'AssertionType', _authAttIdMatch_val_AssertionType), (u'id', (2, 5, 13, 53))])
    
    #-----< indirectIssuer >-----#
    indirectIssuer = CLASS(name=u'indirectIssuer', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _indirectIssuer_val_ExtnType = NULL(name=u'ExtnType', mode=MODE_TYPE)
    indirectIssuer._val = dict([(u'ExtnType', _indirectIssuer_val_ExtnType), (u'id', (2, 5, 29, 61))])
    
    #-----< issuedOnBehalfOf >-----#
    issuedOnBehalfOf = CLASS(name=u'issuedOnBehalfOf', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _issuedOnBehalfOf_val_ExtnType = CHOICE(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    issuedOnBehalfOf._val = dict([(u'ExtnType', _issuedOnBehalfOf_val_ExtnType), (u'id', (2, 5, 29, 64))])
    
    #-----< noAssertion >-----#
    noAssertion = CLASS(name=u'noAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _noAssertion_val_ExtnType = NULL(name=u'ExtnType', mode=MODE_TYPE)
    noAssertion._val = dict([(u'ExtnType', _noAssertion_val_ExtnType), (u'id', (2, 5, 29, 62))])
    
    #-----< allowedAttributeAssignments >-----#
    allowedAttributeAssignments = CLASS(name=u'allowedAttributeAssignments', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _allowedAttributeAssignments_val_ExtnType = SET_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AllowedAttributeAssignments')))
    allowedAttributeAssignments._val = dict([(u'ExtnType', _allowedAttributeAssignments_val_ExtnType), (u'id', (2, 5, 29, 67))])
    
    #-----< AllowedAttributeAssignments >-----#
    AllowedAttributeAssignments = SET_OF(name=u'AllowedAttributeAssignments', mode=MODE_TYPE)
    _AllowedAttributeAssignments__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __AllowedAttributeAssignments__item__attributes = SET_OF(name=u'attributes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AllowedAttributeAssignments__item__attributes__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ____AllowedAttributeAssignments__item__attributes__item__attributeType = OID(name=u'attributeType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues = SEQ(name=u'attributeTypeandValues', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab._val = ASN1Set(rv=[dict([(u'Type', _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type._const_tab = ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type._const_tab_at = None
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type._const_tab_id = u'id'
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values = SET_OF(name=u'values', mode=MODE_TYPE)
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_._const_tab = ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_._const_tab_at = ('..', '..', u'type')
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_._const_tab_id = u'Type'
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values._cont = ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value._const_tab = ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value._const_tab_id = u'Type'
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ________AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList._cont = ________AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList__item_
    _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value),
        (u'contextList', _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList),
        ])
    ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item_._ext = []
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext._cont = ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item_
    _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues._cont = ASN1Dict([
        (u'type', _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type),
        (u'values', _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values),
        (u'valuesWithContext', _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext),
        ])
    ____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues._ext = []
    ___AllowedAttributeAssignments__item__attributes__item_._cont = ASN1Dict([
        (u'attributeType', ____AllowedAttributeAssignments__item__attributes__item__attributeType),
        (u'attributeTypeandValues', ____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues),
        ])
    ___AllowedAttributeAssignments__item__attributes__item_._ext = []
    __AllowedAttributeAssignments__item__attributes._cont = ___AllowedAttributeAssignments__item__attributes__item_
    __AllowedAttributeAssignments__item__holderDomain = CHOICE(name=u'holderDomain', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _AllowedAttributeAssignments__item_._cont = ASN1Dict([
        (u'attributes', __AllowedAttributeAssignments__item__attributes),
        (u'holderDomain', __AllowedAttributeAssignments__item__holderDomain),
        ])
    _AllowedAttributeAssignments__item_._ext = []
    AllowedAttributeAssignments._cont = _AllowedAttributeAssignments__item_
    
    #-----< attributeMappings >-----#
    attributeMappings = CLASS(name=u'attributeMappings', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _attributeMappings_val_ExtnType = SET_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeMappings')))
    attributeMappings._val = dict([(u'ExtnType', _attributeMappings_val_ExtnType), (u'id', (2, 5, 29, 68))])
    
    #-----< AttributeMappings >-----#
    AttributeMappings = SET_OF(name=u'AttributeMappings', mode=MODE_TYPE)
    _AttributeMappings__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    __AttributeMappings__item__typeMappings = SEQ(name=u'typeMappings', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AttributeMappings__item__typeMappings_local = OID(name=u'local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___AttributeMappings__item__typeMappings_remote = OID(name=u'remote', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    __AttributeMappings__item__typeMappings._cont = ASN1Dict([
        (u'local', ___AttributeMappings__item__typeMappings_local),
        (u'remote', ___AttributeMappings__item__typeMappings_remote),
        ])
    __AttributeMappings__item__typeMappings._ext = []
    __AttributeMappings__item__typeValueMappings = SEQ(name=u'typeValueMappings', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AttributeMappings__item__typeValueMappings_local = SEQ(name=u'local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    ___AttributeMappings__item__typeValueMappings_remote = SEQ(name=u'remote', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    __AttributeMappings__item__typeValueMappings._cont = ASN1Dict([
        (u'local', ___AttributeMappings__item__typeValueMappings_local),
        (u'remote', ___AttributeMappings__item__typeValueMappings_remote),
        ])
    __AttributeMappings__item__typeValueMappings._ext = []
    _AttributeMappings__item_._cont = ASN1Dict([
        (u'typeMappings', __AttributeMappings__item__typeMappings),
        (u'typeValueMappings', __AttributeMappings__item__typeValueMappings),
        ])
    _AttributeMappings__item_._ext = None
    AttributeMappings._cont = _AttributeMappings__item_
    
    #-----< holderNameConstraints >-----#
    holderNameConstraints = CLASS(name=u'holderNameConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _holderNameConstraints_val_ExtnType = SEQ(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'HolderNameConstraintsSyntax')))
    holderNameConstraints._val = dict([(u'ExtnType', _holderNameConstraints_val_ExtnType), (u'id', (2, 5, 29, 69))])
    
    #-----< HolderNameConstraintsSyntax >-----#
    HolderNameConstraintsSyntax = SEQ(name=u'HolderNameConstraintsSyntax', mode=MODE_TYPE)
    _HolderNameConstraintsSyntax_permittedSubtrees = SEQ_OF(name=u'permittedSubtrees', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'GeneralSubtrees')))
    _HolderNameConstraintsSyntax_excludedSubtrees = SEQ_OF(name=u'excludedSubtrees', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'GeneralSubtrees')), opt=True)
    HolderNameConstraintsSyntax._cont = ASN1Dict([
        (u'permittedSubtrees', _HolderNameConstraintsSyntax_permittedSubtrees),
        (u'excludedSubtrees', _HolderNameConstraintsSyntax_excludedSubtrees),
        ])
    HolderNameConstraintsSyntax._ext = []
    
    #-----< GeneralSubtrees >-----#
    GeneralSubtrees = SEQ_OF(name=u'GeneralSubtrees', mode=MODE_TYPE)
    _GeneralSubtrees__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'GeneralSubtree')))
    GeneralSubtrees._cont = _GeneralSubtrees__item_
    GeneralSubtrees._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< GeneralSubtree >-----#
    GeneralSubtree = SEQ(name=u'GeneralSubtree', mode=MODE_TYPE)
    _GeneralSubtree_base = CHOICE(name=u'base', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _GeneralSubtree_minimum = INT(name=u'minimum', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'BaseDistance')), default=0)
    _GeneralSubtree_maximum = INT(name=u'maximum', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'BaseDistance')), opt=True)
    GeneralSubtree._cont = ASN1Dict([
        (u'base', _GeneralSubtree_base),
        (u'minimum', _GeneralSubtree_minimum),
        (u'maximum', _GeneralSubtree_maximum),
        ])
    GeneralSubtree._ext = []
    
    #-----< BaseDistance >-----#
    BaseDistance = INT(name=u'BaseDistance', mode=MODE_TYPE)
    BaseDistance._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< pmiUser >-----#
    pmiUser = CLASS(name=u'pmiUser', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    __pmiUser_OptionalAttributes_val_Type_0 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2 = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificateExactAssertion')))
    pmiUser._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'auxiliary'), (u'OptionalAttributes', ASN1Set(rv=[dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), (u'id', (2, 5, 13, 45))])), (u'id', (2, 5, 4, 58))])], rr=[], ev=None, er=[])), (u'id', (2, 5, 6, 24))])
    
    #-----< pmiAA >-----#
    pmiAA = CLASS(name=u'pmiAA', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_1 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3 = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListExactAssertion')))
    __pmiUser_OptionalAttributes_val_Type_2 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    pmiAA._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'auxiliary'), (u'OptionalAttributes', ASN1Set(rv=[dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), (u'id', (2, 5, 13, 45))])), (u'id', (2, 5, 4, 61))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'AttrCertificateRevocationList']), (u'ldapDesc', u'X.509 Attr certificate revocation list'), (u'id', (2, 5, 4, 59))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_2), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'AACertificateRevocationList']), (u'ldapDesc', u'X.509 AA certificate revocation list'), (u'id', (2, 5, 4, 63))])], rr=[], ev=None, er=[])), (u'id', (2, 5, 6, 25))])
    
    #-----< pmiSOA >-----#
    pmiSOA = CLASS(name=u'pmiSOA', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_0_0 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    __pmiUser_OptionalAttributes_val_Type_2_0 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    pmiSOA._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'auxiliary'), (u'OptionalAttributes', ASN1Set(rv=[dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_0_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'AttrCertificateRevocationList']), (u'ldapDesc', u'X.509 Attr certificate revocation list'), (u'id', (2, 5, 4, 59))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'AACertificateRevocationList']), (u'ldapDesc', u'X.509 AA certificate revocation list'), (u'id', (2, 5, 4, 63))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_2_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), (u'id', (2, 5, 13, 45))])), (u'id', (2, 5, 4, 62))])], rr=[], ev=None, er=[])), (u'id', (2, 5, 6, 26))])
    
    #-----< attCertCRLDistributionPt >-----#
    attCertCRLDistributionPt = CLASS(name=u'attCertCRLDistributionPt', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    attCertCRLDistributionPt._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'auxiliary'), (u'OptionalAttributes', ASN1Set(rv=[dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_0_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'AttrCertificateRevocationList']), (u'ldapDesc', u'X.509 Attr certificate revocation list'), (u'id', (2, 5, 4, 59))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'AACertificateRevocationList']), (u'ldapDesc', u'X.509 AA certificate revocation list'), (u'id', (2, 5, 4, 63))])], rr=[], ev=None, er=[])), (u'id', (2, 5, 6, 27))])
    
    #-----< pmiDelegationPath >-----#
    pmiDelegationPath = CLASS(name=u'pmiDelegationPath', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_0_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertPath')))
    pmiDelegationPath._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'auxiliary'), (u'OptionalAttributes', ASN1Set(rv=[dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_0_1), (u'id', (2, 5, 4, 73))])], rr=[], ev=None, er=[])), (u'id', (2, 5, 6, 33))])
    
    #-----< privilegePolicy >-----#
    privilegePolicy = CLASS(name=u'privilegePolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_0_2 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicySyntax')))
    privilegePolicy._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'auxiliary'), (u'OptionalAttributes', ASN1Set(rv=[dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_0_2), (u'id', (2, 5, 4, 71))])], rr=[], ev=None, er=[])), (u'id', (2, 5, 6, 32))])
    
    #-----< protectedPrivilegePolicy >-----#
    protectedPrivilegePolicy = CLASS(name=u'protectedPrivilegePolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    protectedPrivilegePolicy._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'auxiliary'), (u'OptionalAttributes', ASN1Set(rv=[dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), (u'id', (2, 5, 13, 45))])), (u'id', (2, 5, 4, 74))])], rr=[], ev=None, er=[])), (u'id', (2, 5, 6, 34))])
    
    #-----< attributeCertificateAttribute >-----#
    attributeCertificateAttribute = CLASS(name=u'attributeCertificateAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeCertificateAttribute_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    attributeCertificateAttribute._val = dict([(u'Type', _attributeCertificateAttribute_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), (u'id', (2, 5, 13, 45))])), (u'id', (2, 5, 4, 58))])
    
    #-----< aACertificate >-----#
    aACertificate = CLASS(name=u'aACertificate', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _aACertificate_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    aACertificate._val = dict([(u'Type', _aACertificate_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), (u'id', (2, 5, 13, 45))])), (u'id', (2, 5, 4, 61))])
    
    #-----< attributeDescriptorCertificate >-----#
    attributeDescriptorCertificate = CLASS(name=u'attributeDescriptorCertificate', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeDescriptorCertificate_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    attributeDescriptorCertificate._val = dict([(u'Type', _attributeDescriptorCertificate_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), (u'id', (2, 5, 13, 45))])), (u'id', (2, 5, 4, 62))])
    
    #-----< attributeCertificateRevocationList >-----#
    attributeCertificateRevocationList = CLASS(name=u'attributeCertificateRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeCertificateRevocationList_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    attributeCertificateRevocationList._val = dict([(u'Type', _attributeCertificateRevocationList_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'AttrCertificateRevocationList']), (u'ldapDesc', u'X.509 Attr certificate revocation list'), (u'id', (2, 5, 4, 59))])
    
    #-----< eeAttrCertificateRevocationList >-----#
    eeAttrCertificateRevocationList = CLASS(name=u'eeAttrCertificateRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _eeAttrCertificateRevocationList_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    eeAttrCertificateRevocationList._val = dict([(u'Type', _eeAttrCertificateRevocationList_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'EEAttrCertificateRevocationList']), (u'ldapDesc', u'X.509 EEAttr certificate revocation list'), (u'id', (2, 5, 4, 102))])
    
    #-----< attributeAuthorityRevocationList >-----#
    attributeAuthorityRevocationList = CLASS(name=u'attributeAuthorityRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeAuthorityRevocationList_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    attributeAuthorityRevocationList._val = dict([(u'Type', _attributeAuthorityRevocationList_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'AACertificateRevocationList']), (u'ldapDesc', u'X.509 AA certificate revocation list'), (u'id', (2, 5, 4, 63))])
    
    #-----< delegationPath >-----#
    delegationPath = CLASS(name=u'delegationPath', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _delegationPath_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertPath')))
    delegationPath._val = dict([(u'Type', _delegationPath_val_Type), (u'id', (2, 5, 4, 73))])
    
    #-----< AttCertPath >-----#
    AttCertPath = SEQ_OF(name=u'AttCertPath', mode=MODE_TYPE)
    _AttCertPath__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    AttCertPath._cont = _AttCertPath__item_
    
    #-----< privPolicy >-----#
    privPolicy = CLASS(name=u'privPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _privPolicy_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicySyntax')))
    privPolicy._val = dict([(u'Type', _privPolicy_val_Type), (u'id', (2, 5, 4, 71))])
    
    #-----< protPrivPolicy >-----#
    protPrivPolicy = CLASS(name=u'protPrivPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _protPrivPolicy_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificate')))
    protPrivPolicy._val = dict([(u'Type', _protPrivPolicy_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), (u'id', (2, 5, 13, 45))])), (u'id', (2, 5, 4, 74))])
    
    #-----< xmlPrivPolicy >-----#
    xmlPrivPolicy = CLASS(name=u'xmlPrivPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _xmlPrivPolicy_val_Type = STR_UTF8(name=u'Type', mode=MODE_TYPE)
    xmlPrivPolicy._val = dict([(u'Type', _xmlPrivPolicy_val_Type), (u'id', (2, 5, 4, 76))])
    
    #-----< attributeCertificateExactMatch >-----#
    attributeCertificateExactMatch = CLASS(name=u'attributeCertificateExactMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _attributeCertificateExactMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificateExactAssertion')))
    attributeCertificateExactMatch._val = dict([(u'AssertionType', _attributeCertificateExactMatch_val_AssertionType), (u'id', (2, 5, 13, 45))])
    
    #-----< AttributeCertificateExactAssertion >-----#
    AttributeCertificateExactAssertion = SEQ(name=u'AttributeCertificateExactAssertion', mode=MODE_TYPE)
    _AttributeCertificateExactAssertion_serialNumber = INT(name=u'serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    _AttributeCertificateExactAssertion_issuer = SEQ(name=u'issuer', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertIssuer')))
    AttributeCertificateExactAssertion._cont = ASN1Dict([
        (u'serialNumber', _AttributeCertificateExactAssertion_serialNumber),
        (u'issuer', _AttributeCertificateExactAssertion_issuer),
        ])
    AttributeCertificateExactAssertion._ext = []
    
    #-----< attributeCertificateMatch >-----#
    attributeCertificateMatch = CLASS(name=u'attributeCertificateMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _attributeCertificateMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificateAssertion')))
    attributeCertificateMatch._val = dict([(u'AssertionType', _attributeCertificateMatch_val_AssertionType), (u'id', (2, 5, 13, 42))])
    
    #-----< AttributeCertificateAssertion >-----#
    AttributeCertificateAssertion = SEQ(name=u'AttributeCertificateAssertion', mode=MODE_TYPE)
    _AttributeCertificateAssertion_holder = CHOICE(name=u'holder', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AttributeCertificateAssertion_holder_baseCertificateID = SEQ(name=u'baseCertificateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'IssuerSerial')))
    __AttributeCertificateAssertion_holder_holderName = SEQ_OF(name=u'holderName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    _AttributeCertificateAssertion_holder._cont = ASN1Dict([
        (u'baseCertificateID', __AttributeCertificateAssertion_holder_baseCertificateID),
        (u'holderName', __AttributeCertificateAssertion_holder_holderName),
        ])
    _AttributeCertificateAssertion_holder._ext = []
    _AttributeCertificateAssertion_issuer = SEQ_OF(name=u'issuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _AttributeCertificateAssertion_attCertValidity = TIME_GEN(name=u'attCertValidity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AttributeCertificateAssertion_attType = SET_OF(name=u'attType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AttributeCertificateAssertion_attType__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _AttributeCertificateAssertion_attType._cont = __AttributeCertificateAssertion_attType__item_
    AttributeCertificateAssertion._cont = ASN1Dict([
        (u'holder', _AttributeCertificateAssertion_holder),
        (u'issuer', _AttributeCertificateAssertion_issuer),
        (u'attCertValidity', _AttributeCertificateAssertion_attCertValidity),
        (u'attType', _AttributeCertificateAssertion_attType),
        ])
    AttributeCertificateAssertion._ext = []
    
    #-----< holderIssuerMatch >-----#
    holderIssuerMatch = CLASS(name=u'holderIssuerMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _holderIssuerMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'HolderIssuerAssertion')))
    holderIssuerMatch._val = dict([(u'AssertionType', _holderIssuerMatch_val_AssertionType), (u'id', (2, 5, 13, 46))])
    
    #-----< HolderIssuerAssertion >-----#
    HolderIssuerAssertion = SEQ(name=u'HolderIssuerAssertion', mode=MODE_TYPE)
    _HolderIssuerAssertion_holder = SEQ(name=u'holder', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'Holder')), opt=True)
    _HolderIssuerAssertion_issuer = SEQ(name=u'issuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertIssuer')), opt=True)
    HolderIssuerAssertion._cont = ASN1Dict([
        (u'holder', _HolderIssuerAssertion_holder),
        (u'issuer', _HolderIssuerAssertion_issuer),
        ])
    HolderIssuerAssertion._ext = []
    
    #-----< delegationPathMatch >-----#
    delegationPathMatch = CLASS(name=u'delegationPathMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _delegationPathMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'DelMatchSyntax')))
    delegationPathMatch._val = dict([(u'AssertionType', _delegationPathMatch_val_AssertionType), (u'id', (2, 5, 13, 61))])
    
    #-----< DelMatchSyntax >-----#
    DelMatchSyntax = SEQ(name=u'DelMatchSyntax', mode=MODE_TYPE)
    _DelMatchSyntax_firstIssuer = SEQ(name=u'firstIssuer', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttCertIssuer')))
    _DelMatchSyntax_lastHolder = SEQ(name=u'lastHolder', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateDefinitions', 'Holder')))
    DelMatchSyntax._cont = ASN1Dict([
        (u'firstIssuer', _DelMatchSyntax_firstIssuer),
        (u'lastHolder', _DelMatchSyntax_lastHolder),
        ])
    DelMatchSyntax._ext = []
    
    #-----< extensionPresenceMatch >-----#
    extensionPresenceMatch = CLASS(name=u'extensionPresenceMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _extensionPresenceMatch_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'EXTENSION'), [u'id']))
    extensionPresenceMatch._val = dict([(u'AssertionType', _extensionPresenceMatch_val_AssertionType), (u'id', (2, 5, 13, 67))])
    
    #-----< id-oc-pmiUser >-----#
    id_oc_pmiUser = OID(name=u'id-oc-pmiUser', mode=MODE_VALUE)
    id_oc_pmiUser._val = (2, 5, 6, 24)
    
    #-----< id-oc-pmiAA >-----#
    id_oc_pmiAA = OID(name=u'id-oc-pmiAA', mode=MODE_VALUE)
    id_oc_pmiAA._val = (2, 5, 6, 25)
    
    #-----< id-oc-pmiSOA >-----#
    id_oc_pmiSOA = OID(name=u'id-oc-pmiSOA', mode=MODE_VALUE)
    id_oc_pmiSOA._val = (2, 5, 6, 26)
    
    #-----< id-oc-attCertCRLDistributionPts >-----#
    id_oc_attCertCRLDistributionPts = OID(name=u'id-oc-attCertCRLDistributionPts', mode=MODE_VALUE)
    id_oc_attCertCRLDistributionPts._val = (2, 5, 6, 27)
    
    #-----< id-oc-privilegePolicy >-----#
    id_oc_privilegePolicy = OID(name=u'id-oc-privilegePolicy', mode=MODE_VALUE)
    id_oc_privilegePolicy._val = (2, 5, 6, 32)
    
    #-----< id-oc-pmiDelegationPath >-----#
    id_oc_pmiDelegationPath = OID(name=u'id-oc-pmiDelegationPath', mode=MODE_VALUE)
    id_oc_pmiDelegationPath._val = (2, 5, 6, 33)
    
    #-----< id-oc-protectedPrivilegePolicy >-----#
    id_oc_protectedPrivilegePolicy = OID(name=u'id-oc-protectedPrivilegePolicy', mode=MODE_VALUE)
    id_oc_protectedPrivilegePolicy._val = (2, 5, 6, 34)
    
    #-----< id-at-attributeCertificate >-----#
    id_at_attributeCertificate = OID(name=u'id-at-attributeCertificate', mode=MODE_VALUE)
    id_at_attributeCertificate._val = (2, 5, 4, 58)
    
    #-----< id-at-attributeCertificateRevocationList >-----#
    id_at_attributeCertificateRevocationList = OID(name=u'id-at-attributeCertificateRevocationList', mode=MODE_VALUE)
    id_at_attributeCertificateRevocationList._val = (2, 5, 4, 59)
    
    #-----< id-at-aACertificate >-----#
    id_at_aACertificate = OID(name=u'id-at-aACertificate', mode=MODE_VALUE)
    id_at_aACertificate._val = (2, 5, 4, 61)
    
    #-----< id-at-attributeDescriptorCertificate >-----#
    id_at_attributeDescriptorCertificate = OID(name=u'id-at-attributeDescriptorCertificate', mode=MODE_VALUE)
    id_at_attributeDescriptorCertificate._val = (2, 5, 4, 62)
    
    #-----< id-at-attributeAuthorityRevocationList >-----#
    id_at_attributeAuthorityRevocationList = OID(name=u'id-at-attributeAuthorityRevocationList', mode=MODE_VALUE)
    id_at_attributeAuthorityRevocationList._val = (2, 5, 4, 63)
    
    #-----< id-at-privPolicy >-----#
    id_at_privPolicy = OID(name=u'id-at-privPolicy', mode=MODE_VALUE)
    id_at_privPolicy._val = (2, 5, 4, 71)
    
    #-----< id-at-role >-----#
    id_at_role = OID(name=u'id-at-role', mode=MODE_VALUE)
    id_at_role._val = (2, 5, 4, 72)
    
    #-----< id-at-delegationPath >-----#
    id_at_delegationPath = OID(name=u'id-at-delegationPath', mode=MODE_VALUE)
    id_at_delegationPath._val = (2, 5, 4, 73)
    
    #-----< id-at-protPrivPolicy >-----#
    id_at_protPrivPolicy = OID(name=u'id-at-protPrivPolicy', mode=MODE_VALUE)
    id_at_protPrivPolicy._val = (2, 5, 4, 74)
    
    #-----< id-at-xMLPrivilegeInfo >-----#
    id_at_xMLPrivilegeInfo = OID(name=u'id-at-xMLPrivilegeInfo', mode=MODE_VALUE)
    id_at_xMLPrivilegeInfo._val = (2, 5, 4, 75)
    
    #-----< id-at-xmlPrivPolicy >-----#
    id_at_xmlPrivPolicy = OID(name=u'id-at-xmlPrivPolicy', mode=MODE_VALUE)
    id_at_xmlPrivPolicy._val = (2, 5, 4, 76)
    
    #-----< id-at-permission >-----#
    id_at_permission = OID(name=u'id-at-permission', mode=MODE_VALUE)
    id_at_permission._val = (2, 5, 4, 82)
    
    #-----< id-at-eeAttrCertificateRevocationList >-----#
    id_at_eeAttrCertificateRevocationList = OID(name=u'id-at-eeAttrCertificateRevocationList', mode=MODE_VALUE)
    id_at_eeAttrCertificateRevocationList._val = (2, 5, 4, 102)
    
    #-----< id-ce-authorityAttributeIdentifier >-----#
    id_ce_authorityAttributeIdentifier = OID(name=u'id-ce-authorityAttributeIdentifier', mode=MODE_VALUE)
    id_ce_authorityAttributeIdentifier._val = (2, 5, 29, 38)
    
    #-----< id-ce-roleSpecCertIdentifier >-----#
    id_ce_roleSpecCertIdentifier = OID(name=u'id-ce-roleSpecCertIdentifier', mode=MODE_VALUE)
    id_ce_roleSpecCertIdentifier._val = (2, 5, 29, 39)
    
    #-----< id-ce-basicAttConstraints >-----#
    id_ce_basicAttConstraints = OID(name=u'id-ce-basicAttConstraints', mode=MODE_VALUE)
    id_ce_basicAttConstraints._val = (2, 5, 29, 41)
    
    #-----< id-ce-delegatedNameConstraints >-----#
    id_ce_delegatedNameConstraints = OID(name=u'id-ce-delegatedNameConstraints', mode=MODE_VALUE)
    id_ce_delegatedNameConstraints._val = (2, 5, 29, 42)
    
    #-----< id-ce-timeSpecification >-----#
    id_ce_timeSpecification = OID(name=u'id-ce-timeSpecification', mode=MODE_VALUE)
    id_ce_timeSpecification._val = (2, 5, 29, 43)
    
    #-----< id-ce-attributeDescriptor >-----#
    id_ce_attributeDescriptor = OID(name=u'id-ce-attributeDescriptor', mode=MODE_VALUE)
    id_ce_attributeDescriptor._val = (2, 5, 29, 48)
    
    #-----< id-ce-userNotice >-----#
    id_ce_userNotice = OID(name=u'id-ce-userNotice', mode=MODE_VALUE)
    id_ce_userNotice._val = (2, 5, 29, 49)
    
    #-----< id-ce-sOAIdentifier >-----#
    id_ce_sOAIdentifier = OID(name=u'id-ce-sOAIdentifier', mode=MODE_VALUE)
    id_ce_sOAIdentifier._val = (2, 5, 29, 50)
    
    #-----< id-ce-acceptableCertPolicies >-----#
    id_ce_acceptableCertPolicies = OID(name=u'id-ce-acceptableCertPolicies', mode=MODE_VALUE)
    id_ce_acceptableCertPolicies._val = (2, 5, 29, 52)
    
    #-----< id-ce-targetingInformation >-----#
    id_ce_targetingInformation = OID(name=u'id-ce-targetingInformation', mode=MODE_VALUE)
    id_ce_targetingInformation._val = (2, 5, 29, 55)
    
    #-----< id-ce-noRevAvail >-----#
    id_ce_noRevAvail = OID(name=u'id-ce-noRevAvail', mode=MODE_VALUE)
    id_ce_noRevAvail._val = (2, 5, 29, 56)
    
    #-----< id-ce-acceptablePrivilegePolicies >-----#
    id_ce_acceptablePrivilegePolicies = OID(name=u'id-ce-acceptablePrivilegePolicies', mode=MODE_VALUE)
    id_ce_acceptablePrivilegePolicies._val = (2, 5, 29, 57)
    
    #-----< id-ce-indirectIssuer >-----#
    id_ce_indirectIssuer = OID(name=u'id-ce-indirectIssuer', mode=MODE_VALUE)
    id_ce_indirectIssuer._val = (2, 5, 29, 61)
    
    #-----< id-ce-noAssertion >-----#
    id_ce_noAssertion = OID(name=u'id-ce-noAssertion', mode=MODE_VALUE)
    id_ce_noAssertion._val = (2, 5, 29, 62)
    
    #-----< id-ce-issuedOnBehalfOf >-----#
    id_ce_issuedOnBehalfOf = OID(name=u'id-ce-issuedOnBehalfOf', mode=MODE_VALUE)
    id_ce_issuedOnBehalfOf._val = (2, 5, 29, 64)
    
    #-----< id-ce-singleUse >-----#
    id_ce_singleUse = OID(name=u'id-ce-singleUse', mode=MODE_VALUE)
    id_ce_singleUse._val = (2, 5, 29, 65)
    
    #-----< id-ce-groupAC >-----#
    id_ce_groupAC = OID(name=u'id-ce-groupAC', mode=MODE_VALUE)
    id_ce_groupAC._val = (2, 5, 29, 66)
    
    #-----< id-ce-allowedAttributeAssignments >-----#
    id_ce_allowedAttributeAssignments = OID(name=u'id-ce-allowedAttributeAssignments', mode=MODE_VALUE)
    id_ce_allowedAttributeAssignments._val = (2, 5, 29, 67)
    
    #-----< id-ce-attributeMappings >-----#
    id_ce_attributeMappings = OID(name=u'id-ce-attributeMappings', mode=MODE_VALUE)
    id_ce_attributeMappings._val = (2, 5, 29, 68)
    
    #-----< id-ce-holderNameConstraints >-----#
    id_ce_holderNameConstraints = OID(name=u'id-ce-holderNameConstraints', mode=MODE_VALUE)
    id_ce_holderNameConstraints._val = (2, 5, 29, 69)
    
    #-----< id-mr-attributeCertificateMatch >-----#
    id_mr_attributeCertificateMatch = OID(name=u'id-mr-attributeCertificateMatch', mode=MODE_VALUE)
    id_mr_attributeCertificateMatch._val = (2, 5, 13, 42)
    
    #-----< id-mr-attributeCertificateExactMatch >-----#
    id_mr_attributeCertificateExactMatch = OID(name=u'id-mr-attributeCertificateExactMatch', mode=MODE_VALUE)
    id_mr_attributeCertificateExactMatch._val = (2, 5, 13, 45)
    
    #-----< id-mr-holderIssuerMatch >-----#
    id_mr_holderIssuerMatch = OID(name=u'id-mr-holderIssuerMatch', mode=MODE_VALUE)
    id_mr_holderIssuerMatch._val = (2, 5, 13, 46)
    
    #-----< id-mr-authAttIdMatch >-----#
    id_mr_authAttIdMatch = OID(name=u'id-mr-authAttIdMatch', mode=MODE_VALUE)
    id_mr_authAttIdMatch._val = (2, 5, 13, 53)
    
    #-----< id-mr-roleSpecCertIdMatch >-----#
    id_mr_roleSpecCertIdMatch = OID(name=u'id-mr-roleSpecCertIdMatch', mode=MODE_VALUE)
    id_mr_roleSpecCertIdMatch._val = (2, 5, 13, 54)
    
    #-----< id-mr-basicAttConstraintsMatch >-----#
    id_mr_basicAttConstraintsMatch = OID(name=u'id-mr-basicAttConstraintsMatch', mode=MODE_VALUE)
    id_mr_basicAttConstraintsMatch._val = (2, 5, 13, 55)
    
    #-----< id-mr-delegatedNameConstraintsMatch >-----#
    id_mr_delegatedNameConstraintsMatch = OID(name=u'id-mr-delegatedNameConstraintsMatch', mode=MODE_VALUE)
    id_mr_delegatedNameConstraintsMatch._val = (2, 5, 13, 56)
    
    #-----< id-mr-timeSpecMatch >-----#
    id_mr_timeSpecMatch = OID(name=u'id-mr-timeSpecMatch', mode=MODE_VALUE)
    id_mr_timeSpecMatch._val = (2, 5, 13, 57)
    
    #-----< id-mr-attDescriptorMatch >-----#
    id_mr_attDescriptorMatch = OID(name=u'id-mr-attDescriptorMatch', mode=MODE_VALUE)
    id_mr_attDescriptorMatch._val = (2, 5, 13, 58)
    
    #-----< id-mr-acceptableCertPoliciesMatch >-----#
    id_mr_acceptableCertPoliciesMatch = OID(name=u'id-mr-acceptableCertPoliciesMatch', mode=MODE_VALUE)
    id_mr_acceptableCertPoliciesMatch._val = (2, 5, 13, 59)
    
    #-----< id-mr-delegationPathMatch >-----#
    id_mr_delegationPathMatch = OID(name=u'id-mr-delegationPathMatch', mode=MODE_VALUE)
    id_mr_delegationPathMatch._val = (2, 5, 13, 61)
    
    #-----< id-mr-sOAIdentifierMatch >-----#
    id_mr_sOAIdentifierMatch = OID(name=u'id-mr-sOAIdentifierMatch', mode=MODE_VALUE)
    id_mr_sOAIdentifierMatch._val = (2, 5, 13, 66)
    
    #-----< id-mr-extensionPresenceMatch >-----#
    id_mr_extensionPresenceMatch = OID(name=u'id-mr-extensionPresenceMatch', mode=MODE_VALUE)
    id_mr_extensionPresenceMatch._val = (2, 5, 13, 67)
    
    #-----< id-mr-dualStringMatch >-----#
    id_mr_dualStringMatch = OID(name=u'id-mr-dualStringMatch', mode=MODE_VALUE)
    id_mr_dualStringMatch._val = (2, 5, 13, 69)
    
    _all_ = [
        _AttributeCertificate_toBeSigned,
        ___AttributeCertificate_algorithmIdentifier_algorithm_tab,
        __AttributeCertificate_algorithmIdentifier_algorithm,
        ___AttributeCertificate_algorithmIdentifier_parameters_tab,
        __AttributeCertificate_algorithmIdentifier_parameters,
        _AttributeCertificate_algorithmIdentifier,
        _AttributeCertificate_signature,
        AttributeCertificate,
        _TBSAttributeCertificate_version,
        _TBSAttributeCertificate_holder,
        _TBSAttributeCertificate_issuer,
        ___TBSAttributeCertificate_signature_algorithm_tab,
        __TBSAttributeCertificate_signature_algorithm,
        ___TBSAttributeCertificate_signature_parameters_tab,
        __TBSAttributeCertificate_signature_parameters,
        _TBSAttributeCertificate_signature,
        _TBSAttributeCertificate_serialNumber,
        _TBSAttributeCertificate_attrCertValidityPeriod,
        ____TBSAttributeCertificate_attributes__item__type_tab,
        _____TBSAttributeCertificate_attributes__item__type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        _____TBSAttributeCertificate_attributes__item__type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        ___TBSAttributeCertificate_attributes__item__type,
        ____TBSAttributeCertificate_attributes__item__values__item_,
        ___TBSAttributeCertificate_attributes__item__values,
        _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__value,
        ______TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList__item_,
        _____TBSAttributeCertificate_attributes__item__valuesWithContext__item__contextList,
        ____TBSAttributeCertificate_attributes__item__valuesWithContext__item_,
        ___TBSAttributeCertificate_attributes__item__valuesWithContext,
        __TBSAttributeCertificate_attributes__item_,
        _TBSAttributeCertificate_attributes,
        _TBSAttributeCertificate_issuerUniqueID,
        _TBSAttributeCertificate_extensions,
        TBSAttributeCertificate,
        AttCertVersion,
        _Holder_baseCertificateID,
        _Holder_entityName,
        _Holder_objectDigestInfo,
        Holder,
        _IssuerSerial_issuer,
        _IssuerSerial_serial,
        _IssuerSerial_issuerUID,
        IssuerSerial,
        _ObjectDigestInfo_digestedObjectType,
        _ObjectDigestInfo_otherObjectTypeID,
        ___ObjectDigestInfo_digestAlgorithm_algorithm_tab,
        __ObjectDigestInfo_digestAlgorithm_algorithm,
        ___ObjectDigestInfo_digestAlgorithm_parameters_tab,
        __ObjectDigestInfo_digestAlgorithm_parameters,
        _ObjectDigestInfo_digestAlgorithm,
        _ObjectDigestInfo_objectDigest,
        ObjectDigestInfo,
        _AttCertIssuer_issuerName,
        _AttCertIssuer_baseCertificateID,
        _AttCertIssuer_objectDigestInfo,
        AttCertIssuer,
        _AttCertValidityPeriod_notBeforeTime,
        _AttCertValidityPeriod_notAfterTime,
        AttCertValidityPeriod,
        _AttributeCertificationPath_attributeCertificate,
        __AttributeCertificationPath_acPath__item_,
        _AttributeCertificationPath_acPath,
        AttributeCertificationPath,
        _ACPathData_certificate,
        _ACPathData_attributeCertificate,
        ACPathData,
        PrivilegePolicy,
        role,
        _role_val_Type,
        _RoleSyntax_roleAuthority,
        _RoleSyntax_roleName,
        RoleSyntax,
        xmlPrivilegeInfo,
        _xmlPrivilegeInfo_val_Type,
        permission,
        _permission_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1,
        _DualStringSyntax_operation,
        _DualStringSyntax_object,
        DualStringSyntax,
        dualStringMatch,
        _dualStringMatch_val_AssertionType,
        timeSpecification,
        _timeSpecification_val_ExtnType,
        timeSpecificationMatch,
        _timeSpecificationMatch_val_AssertionType,
        targetingInformation,
        __targetingInformation_val_ExtnType__item_,
        _targetingInformation_val_ExtnType,
        _Targets__item_,
        Targets,
        _Target_targetName,
        _Target_targetGroup,
        _Target_targetCert,
        Target,
        _TargetCert_targetCertificate,
        _TargetCert_targetName,
        _TargetCert_certDigestInfo,
        TargetCert,
        userNotice,
        __userNotice_val_ExtnType__item_,
        _userNotice_val_ExtnType,
        acceptablePrivilegePolicies,
        _acceptablePrivilegePolicies_val_ExtnType,
        _AcceptablePrivilegePoliciesSyntax__item_,
        AcceptablePrivilegePoliciesSyntax,
        singleUse,
        _singleUse_val_ExtnType,
        groupAC,
        _groupAC_val_ExtnType,
        noRevAvail,
        _noRevAvail_val_ExtnType,
        sOAIdentifier,
        _sOAIdentifier_val_ExtnType,
        sOAIdentifierMatch,
        _sOAIdentifierMatch_val_AssertionType,
        attributeDescriptor,
        _attributeDescriptor_val_ExtnType,
        _AttributeDescriptorSyntax_identifier,
        _AttributeDescriptorSyntax_attributeSyntax,
        _AttributeDescriptorSyntax_name,
        _AttributeDescriptorSyntax_description,
        _AttributeDescriptorSyntax_dominationRule,
        AttributeDescriptorSyntax,
        _AttributeIdentifier_tab,
        AttributeIdentifier,
        AttributeIDs,
        AttributeName,
        AttributeDescription,
        _PrivilegePolicyIdentifier_privilegePolicy,
        _PrivilegePolicyIdentifier_privPolSyntax,
        PrivilegePolicyIdentifier,
        attDescriptor,
        _attDescriptor_val_AssertionType,
        roleSpecCertIdentifier,
        _roleSpecCertIdentifier_val_ExtnType,
        _RoleSpecCertIdentifierSyntax__item_,
        RoleSpecCertIdentifierSyntax,
        _RoleSpecCertIdentifier_roleName,
        _RoleSpecCertIdentifier_roleCertIssuer,
        _RoleSpecCertIdentifier_roleCertSerialNumber,
        _RoleSpecCertIdentifier_roleCertLocator,
        RoleSpecCertIdentifier,
        roleSpecCertIdMatch,
        _roleSpecCertIdMatch_val_AssertionType,
        basicAttConstraints,
        _basicAttConstraints_val_ExtnType,
        _BasicAttConstraintsSyntax_authority,
        _BasicAttConstraintsSyntax_pathLenConstraint,
        BasicAttConstraintsSyntax,
        basicAttConstraintsMatch,
        _basicAttConstraintsMatch_val_AssertionType,
        delegatedNameConstraints,
        _delegatedNameConstraints_val_ExtnType,
        delegatedNameConstraintsMatch,
        _delegatedNameConstraintsMatch_val_AssertionType,
        acceptableCertPolicies,
        _acceptableCertPolicies_val_ExtnType,
        _AcceptableCertPoliciesSyntax__item_,
        AcceptableCertPoliciesSyntax,
        CertPolicyId,
        acceptableCertPoliciesMatch,
        _acceptableCertPoliciesMatch_val_AssertionType,
        authorityAttributeIdentifier,
        _authorityAttributeIdentifier_val_ExtnType,
        _AuthorityAttributeIdentifierSyntax__item_,
        AuthorityAttributeIdentifierSyntax,
        AuthAttId,
        authAttIdMatch,
        _authAttIdMatch_val_AssertionType,
        indirectIssuer,
        _indirectIssuer_val_ExtnType,
        issuedOnBehalfOf,
        _issuedOnBehalfOf_val_ExtnType,
        noAssertion,
        _noAssertion_val_ExtnType,
        allowedAttributeAssignments,
        _allowedAttributeAssignments_val_ExtnType,
        ____AllowedAttributeAssignments__item__attributes__item__attributeType,
        ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab,
        _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_0,
        _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type_tab_val_Type_1,
        _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_type,
        ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values__item_,
        _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_values,
        _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__value,
        ________AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList__item_,
        _______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item__contextList,
        ______AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext__item_,
        _____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues_valuesWithContext,
        ____AllowedAttributeAssignments__item__attributes__item__attributeTypeandValues,
        ___AllowedAttributeAssignments__item__attributes__item_,
        __AllowedAttributeAssignments__item__attributes,
        __AllowedAttributeAssignments__item__holderDomain,
        _AllowedAttributeAssignments__item_,
        AllowedAttributeAssignments,
        attributeMappings,
        _attributeMappings_val_ExtnType,
        ___AttributeMappings__item__typeMappings_local,
        ___AttributeMappings__item__typeMappings_remote,
        __AttributeMappings__item__typeMappings,
        ___AttributeMappings__item__typeValueMappings_local,
        ___AttributeMappings__item__typeValueMappings_remote,
        __AttributeMappings__item__typeValueMappings,
        _AttributeMappings__item_,
        AttributeMappings,
        holderNameConstraints,
        _holderNameConstraints_val_ExtnType,
        _HolderNameConstraintsSyntax_permittedSubtrees,
        _HolderNameConstraintsSyntax_excludedSubtrees,
        HolderNameConstraintsSyntax,
        _GeneralSubtrees__item_,
        GeneralSubtrees,
        _GeneralSubtree_base,
        _GeneralSubtree_minimum,
        _GeneralSubtree_maximum,
        GeneralSubtree,
        BaseDistance,
        pmiUser,
        ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0,
        __pmiUser_OptionalAttributes_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2,
        pmiAA,
        __pmiUser_OptionalAttributes_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3,
        __pmiUser_OptionalAttributes_val_Type_2,
        pmiSOA,
        __pmiUser_OptionalAttributes_val_Type_0_0,
        __pmiUser_OptionalAttributes_val_Type_2_0,
        attCertCRLDistributionPt,
        pmiDelegationPath,
        __pmiUser_OptionalAttributes_val_Type_0_1,
        privilegePolicy,
        __pmiUser_OptionalAttributes_val_Type_0_2,
        protectedPrivilegePolicy,
        attributeCertificateAttribute,
        _attributeCertificateAttribute_val_Type,
        aACertificate,
        _aACertificate_val_Type,
        attributeDescriptorCertificate,
        _attributeDescriptorCertificate_val_Type,
        attributeCertificateRevocationList,
        _attributeCertificateRevocationList_val_Type,
        eeAttrCertificateRevocationList,
        _eeAttrCertificateRevocationList_val_Type,
        attributeAuthorityRevocationList,
        _attributeAuthorityRevocationList_val_Type,
        delegationPath,
        _delegationPath_val_Type,
        _AttCertPath__item_,
        AttCertPath,
        privPolicy,
        _privPolicy_val_Type,
        protPrivPolicy,
        _protPrivPolicy_val_Type,
        xmlPrivPolicy,
        _xmlPrivPolicy_val_Type,
        attributeCertificateExactMatch,
        _attributeCertificateExactMatch_val_AssertionType,
        _AttributeCertificateExactAssertion_serialNumber,
        _AttributeCertificateExactAssertion_issuer,
        AttributeCertificateExactAssertion,
        attributeCertificateMatch,
        _attributeCertificateMatch_val_AssertionType,
        __AttributeCertificateAssertion_holder_baseCertificateID,
        __AttributeCertificateAssertion_holder_holderName,
        _AttributeCertificateAssertion_holder,
        _AttributeCertificateAssertion_issuer,
        _AttributeCertificateAssertion_attCertValidity,
        __AttributeCertificateAssertion_attType__item_,
        _AttributeCertificateAssertion_attType,
        AttributeCertificateAssertion,
        holderIssuerMatch,
        _holderIssuerMatch_val_AssertionType,
        _HolderIssuerAssertion_holder,
        _HolderIssuerAssertion_issuer,
        HolderIssuerAssertion,
        delegationPathMatch,
        _delegationPathMatch_val_AssertionType,
        _DelMatchSyntax_firstIssuer,
        _DelMatchSyntax_lastHolder,
        DelMatchSyntax,
        extensionPresenceMatch,
        _extensionPresenceMatch_val_AssertionType,
        id_oc_pmiUser,
        id_oc_pmiAA,
        id_oc_pmiSOA,
        id_oc_attCertCRLDistributionPts,
        id_oc_privilegePolicy,
        id_oc_pmiDelegationPath,
        id_oc_protectedPrivilegePolicy,
        id_at_attributeCertificate,
        id_at_attributeCertificateRevocationList,
        id_at_aACertificate,
        id_at_attributeDescriptorCertificate,
        id_at_attributeAuthorityRevocationList,
        id_at_privPolicy,
        id_at_role,
        id_at_delegationPath,
        id_at_protPrivPolicy,
        id_at_xMLPrivilegeInfo,
        id_at_xmlPrivPolicy,
        id_at_permission,
        id_at_eeAttrCertificateRevocationList,
        id_ce_authorityAttributeIdentifier,
        id_ce_roleSpecCertIdentifier,
        id_ce_basicAttConstraints,
        id_ce_delegatedNameConstraints,
        id_ce_timeSpecification,
        id_ce_attributeDescriptor,
        id_ce_userNotice,
        id_ce_sOAIdentifier,
        id_ce_acceptableCertPolicies,
        id_ce_targetingInformation,
        id_ce_noRevAvail,
        id_ce_acceptablePrivilegePolicies,
        id_ce_indirectIssuer,
        id_ce_noAssertion,
        id_ce_issuedOnBehalfOf,
        id_ce_singleUse,
        id_ce_groupAC,
        id_ce_allowedAttributeAssignments,
        id_ce_attributeMappings,
        id_ce_holderNameConstraints,
        id_mr_attributeCertificateMatch,
        id_mr_attributeCertificateExactMatch,
        id_mr_holderIssuerMatch,
        id_mr_authAttIdMatch,
        id_mr_roleSpecCertIdMatch,
        id_mr_basicAttConstraintsMatch,
        id_mr_delegatedNameConstraintsMatch,
        id_mr_timeSpecMatch,
        id_mr_attDescriptorMatch,
        id_mr_acceptableCertPoliciesMatch,
        id_mr_delegationPathMatch,
        id_mr_sOAIdentifierMatch,
        id_mr_extensionPresenceMatch,
        id_mr_dualStringMatch,
    ]

class AuthenticationFramework:

    _name_  = u'AuthenticationFramework'
    _oid_   = [2, 5, 1, 7, 8]
    
    _obj_ = [
        u'SIGNATURE',
        u'SIGNED',
        u'HASH',
        u'ENCRYPTED',
        u'ENCRYPTED-HASH',
        u'FINGERPRINT',
        u'ALGORITHM',
        u'AlgorithmIdentifier',
        u'SupportedAlgorithms',
        u'SupportedCurves',
        u'dummyCurv',
        u'Certificate',
        u'TBSCertificate',
        u'Version',
        u'CertificateSerialNumber',
        u'Validity',
        u'SubjectPublicKeyInfo',
        u'PublicKey',
        u'Time',
        u'Extensions',
        u'Extension',
        u'der',
        u'ExtensionSet',
        u'EXTENSION',
        u'Certificates',
        u'ForwardCertificationPath',
        u'CrossCertificates',
        u'CertificationPath',
        u'PkiPath',
        u'CertificateList',
        u'CertificateListContent',
        u'CertAVL',
        u'TBSCertAVL',
        u'AvlSerialNumber',
        u'PKCertIdentifier',
        u'IssuerSerialNumber',
        u'ScopeRestrictions',
        u'SCOPE-RESTRICTION',
        u'ScopeRestriction',
        u'protRestrict',
        u'ProtRestriction',
        u'pkiUser',
        u'pkiCA',
        u'cRLDistributionPoint',
        u'cRLDistPtNameForm',
        u'deltaCRL',
        u'cpCps',
        u'pkiCertPath',
        u'userCertificate',
        u'cACertificate',
        u'crossCertificatePair',
        u'CertificatePair',
        u'certificateRevocationList',
        u'eepkCertificateRevocationList',
        u'authorityRevocationList',
        u'deltaRevocationList',
        u'supportedAlgorithms',
        u'SupportedAlgorithm',
        u'certificationPracticeStmt',
        u'InfoSyntax',
        u'POLICY',
        u'HashedPolicyInfo',
        u'Policies',
        u'certificatePolicy',
        u'PolicySyntax',
        u'PolicyID',
        u'pkiPath',
        u'userPassword',
        u'x509Certificate',
        u'x509CertificateList',
        u'x509CertificatePair',
        u'x509SupportedAlgorithm',
        u'id-oc-cRLDistributionPoint',
        u'id-oc-pkiUser',
        u'id-oc-pkiCA',
        u'id-oc-deltaCRL',
        u'id-oc-cpCps',
        u'id-oc-pkiCertPath',
        u'id-nf-cRLDistPtNameForm',
        u'id-at-userPassword',
        u'id-at-userCertificate',
        u'id-at-cAcertificate',
        u'id-at-authorityRevocationList',
        u'id-at-certificateRevocationList',
        u'id-at-crossCertificatePair',
        u'id-at-supportedAlgorithms',
        u'id-at-deltaRevocationList',
        u'id-at-certificationPracticeStmt',
        u'id-at-certificatePolicy',
        u'id-at-pkiPath',
        u'id-at-eepkCertificateRevocationList',
        u'id-lsx-x509Certificate',
        u'id-lsx-x509CertificateList',
        u'id-lsx-x509CertificatePair',
        u'id-lsx-x509SupportedAlgorithm',
        u'id-protRestrict',
        ]
    _type_ = [
        u'SIGNATURE',
        u'SIGNED',
        u'HASH',
        u'ENCRYPTED',
        u'ENCRYPTED-HASH',
        u'FINGERPRINT',
        u'ALGORITHM',
        u'AlgorithmIdentifier',
        u'Certificate',
        u'TBSCertificate',
        u'Version',
        u'CertificateSerialNumber',
        u'Validity',
        u'SubjectPublicKeyInfo',
        u'PublicKey',
        u'Time',
        u'Extensions',
        u'Extension',
        u'EXTENSION',
        u'Certificates',
        u'ForwardCertificationPath',
        u'CrossCertificates',
        u'CertificationPath',
        u'PkiPath',
        u'CertificateList',
        u'CertificateListContent',
        u'CertAVL',
        u'TBSCertAVL',
        u'AvlSerialNumber',
        u'PKCertIdentifier',
        u'IssuerSerialNumber',
        u'ScopeRestrictions',
        u'SCOPE-RESTRICTION',
        u'ScopeRestriction',
        u'ProtRestriction',
        u'CertificatePair',
        u'SupportedAlgorithm',
        u'InfoSyntax',
        u'POLICY',
        u'HashedPolicyInfo',
        u'PolicySyntax',
        u'PolicyID',
        ]
    _set_ = [
        u'SupportedAlgorithms',
        u'SupportedCurves',
        u'ExtensionSet',
        u'Policies',
        ]
    _val_ = [
        u'dummyCurv',
        u'der',
        u'protRestrict',
        u'pkiUser',
        u'pkiCA',
        u'cRLDistributionPoint',
        u'cRLDistPtNameForm',
        u'deltaCRL',
        u'cpCps',
        u'pkiCertPath',
        u'userCertificate',
        u'cACertificate',
        u'crossCertificatePair',
        u'certificateRevocationList',
        u'eepkCertificateRevocationList',
        u'authorityRevocationList',
        u'deltaRevocationList',
        u'supportedAlgorithms',
        u'certificationPracticeStmt',
        u'certificatePolicy',
        u'pkiPath',
        u'userPassword',
        u'x509Certificate',
        u'x509CertificateList',
        u'x509CertificatePair',
        u'x509SupportedAlgorithm',
        u'id-oc-cRLDistributionPoint',
        u'id-oc-pkiUser',
        u'id-oc-pkiCA',
        u'id-oc-deltaCRL',
        u'id-oc-cpCps',
        u'id-oc-pkiCertPath',
        u'id-nf-cRLDistPtNameForm',
        u'id-at-userPassword',
        u'id-at-userCertificate',
        u'id-at-cAcertificate',
        u'id-at-authorityRevocationList',
        u'id-at-certificateRevocationList',
        u'id-at-crossCertificatePair',
        u'id-at-supportedAlgorithms',
        u'id-at-deltaRevocationList',
        u'id-at-certificationPracticeStmt',
        u'id-at-certificatePolicy',
        u'id-at-pkiPath',
        u'id-at-eepkCertificateRevocationList',
        u'id-lsx-x509Certificate',
        u'id-lsx-x509CertificateList',
        u'id-lsx-x509CertificatePair',
        u'id-lsx-x509SupportedAlgorithm',
        u'id-protRestrict',
        ]
    _class_ = [
        u'ALGORITHM',
        u'SupportedAlgorithms',
        u'ExtensionSet',
        u'EXTENSION',
        u'SCOPE-RESTRICTION',
        u'protRestrict',
        u'pkiUser',
        u'pkiCA',
        u'cRLDistributionPoint',
        u'cRLDistPtNameForm',
        u'deltaCRL',
        u'cpCps',
        u'pkiCertPath',
        u'userCertificate',
        u'cACertificate',
        u'crossCertificatePair',
        u'certificateRevocationList',
        u'eepkCertificateRevocationList',
        u'authorityRevocationList',
        u'deltaRevocationList',
        u'supportedAlgorithms',
        u'certificationPracticeStmt',
        u'POLICY',
        u'Policies',
        u'certificatePolicy',
        u'pkiPath',
        u'userPassword',
        u'x509Certificate',
        u'x509CertificateList',
        u'x509CertificatePair',
        u'x509SupportedAlgorithm',
        ]
    _param_ = [
        u'SIGNED',
        u'HASH',
        u'ENCRYPTED',
        u'ENCRYPTED-HASH',
        u'FINGERPRINT',
        u'AlgorithmIdentifier',
        ]
    
    #-----< SIGNATURE >-----#
    SIGNATURE = SEQ(name=u'SIGNATURE', mode=MODE_TYPE)
    _SIGNATURE_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SIGNATURE_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___SIGNATURE_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SIGNATURE_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SIGNATURE_algorithmIdentifier_algorithm._const_tab = ___SIGNATURE_algorithmIdentifier_algorithm_tab
    __SIGNATURE_algorithmIdentifier_algorithm._const_tab_at = None
    __SIGNATURE_algorithmIdentifier_algorithm._const_tab_id = u'id'
    __SIGNATURE_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___SIGNATURE_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SIGNATURE_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SIGNATURE_algorithmIdentifier_parameters._const_tab = ___SIGNATURE_algorithmIdentifier_parameters_tab
    __SIGNATURE_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    __SIGNATURE_algorithmIdentifier_parameters._const_tab_id = u'Type'
    _SIGNATURE_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', __SIGNATURE_algorithmIdentifier_algorithm),
        (u'parameters', __SIGNATURE_algorithmIdentifier_parameters),
        ])
    _SIGNATURE_algorithmIdentifier._ext = []
    _SIGNATURE_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    SIGNATURE._cont = ASN1Dict([
        (u'algorithmIdentifier', _SIGNATURE_algorithmIdentifier),
        (u'signature', _SIGNATURE_signature),
        ])
    SIGNATURE._ext = []
    
    #-----< SIGNED >-----#
    SIGNED = SEQ(name=u'SIGNED', mode=MODE_TYPE, param=True)
    
    #-----< HASH >-----#
    HASH = SEQ(name=u'HASH', mode=MODE_TYPE)
    _HASH_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __HASH_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___HASH_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___HASH_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __HASH_algorithmIdentifier_algorithm._const_tab = ___HASH_algorithmIdentifier_algorithm_tab
    __HASH_algorithmIdentifier_algorithm._const_tab_at = None
    __HASH_algorithmIdentifier_algorithm._const_tab_id = u'id'
    __HASH_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___HASH_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___HASH_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __HASH_algorithmIdentifier_parameters._const_tab = ___HASH_algorithmIdentifier_parameters_tab
    __HASH_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    __HASH_algorithmIdentifier_parameters._const_tab_id = u'Type'
    _HASH_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', __HASH_algorithmIdentifier_algorithm),
        (u'parameters', __HASH_algorithmIdentifier_parameters),
        ])
    _HASH_algorithmIdentifier._ext = []
    _HASH_hashValue = BIT_STR(name=u'hashValue', mode=MODE_TYPE)
    HASH._cont = ASN1Dict([
        (u'algorithmIdentifier', _HASH_algorithmIdentifier),
        (u'hashValue', _HASH_hashValue),
        ])
    HASH._ext = []
    
    #-----< ENCRYPTED >-----#
    ENCRYPTED = BIT_STR(name=u'ENCRYPTED', mode=MODE_TYPE)
    
    #-----< ENCRYPTED-HASH >-----#
    ENCRYPTED_HASH = BIT_STR(name=u'ENCRYPTED-HASH', mode=MODE_TYPE)
    
    #-----< FINGERPRINT >-----#
    FINGERPRINT = SEQ(name=u'FINGERPRINT', mode=MODE_TYPE)
    _FINGERPRINT_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __FINGERPRINT_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___FINGERPRINT_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___FINGERPRINT_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __FINGERPRINT_algorithmIdentifier_algorithm._const_tab = ___FINGERPRINT_algorithmIdentifier_algorithm_tab
    __FINGERPRINT_algorithmIdentifier_algorithm._const_tab_at = None
    __FINGERPRINT_algorithmIdentifier_algorithm._const_tab_id = u'id'
    __FINGERPRINT_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___FINGERPRINT_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___FINGERPRINT_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __FINGERPRINT_algorithmIdentifier_parameters._const_tab = ___FINGERPRINT_algorithmIdentifier_parameters_tab
    __FINGERPRINT_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    __FINGERPRINT_algorithmIdentifier_parameters._const_tab_id = u'Type'
    _FINGERPRINT_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', __FINGERPRINT_algorithmIdentifier_algorithm),
        (u'parameters', __FINGERPRINT_algorithmIdentifier_parameters),
        ])
    _FINGERPRINT_algorithmIdentifier._ext = []
    _FINGERPRINT_fingerprint = BIT_STR(name=u'fingerprint', mode=MODE_TYPE)
    FINGERPRINT._cont = ASN1Dict([
        (u'algorithmIdentifier', _FINGERPRINT_algorithmIdentifier),
        (u'fingerprint', _FINGERPRINT_fingerprint),
        ])
    FINGERPRINT._ext = []
    
    #-----< ALGORITHM >-----#
    ALGORITHM = CLASS(name=u'ALGORITHM', mode=MODE_TYPE)
    _ALGORITHM_Type = OPEN(name=u'Type', mode=MODE_TYPE, opt=True)
    _ALGORITHM_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    ALGORITHM._cont = ASN1Dict([
        (u'Type', _ALGORITHM_Type),
        (u'id', _ALGORITHM_id),
        ])
    
    #-----< AlgorithmIdentifier >-----#
    AlgorithmIdentifier = SEQ(name=u'AlgorithmIdentifier', mode=MODE_TYPE, param=True)
    
    #-----< SupportedAlgorithms >-----#
    SupportedAlgorithms = CLASS(name=u'SupportedAlgorithms', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    SupportedAlgorithms._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SupportedCurves >-----#
    SupportedCurves = OID(name=u'SupportedCurves', mode=MODE_SET)
    SupportedCurves._val = ASN1Set(rv=[(2, 5, 5)], rr=[], ev=[], er=[])
    
    #-----< dummyCurv >-----#
    dummyCurv = OID(name=u'dummyCurv', mode=MODE_VALUE)
    dummyCurv._val = (2, 5, 5)
    
    #-----< Certificate >-----#
    Certificate = SEQ(name=u'Certificate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _Certificate_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'TBSCertificate')))
    _Certificate_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __Certificate_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___Certificate_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Certificate_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Certificate_algorithmIdentifier_algorithm._const_tab = ___Certificate_algorithmIdentifier_algorithm_tab
    __Certificate_algorithmIdentifier_algorithm._const_tab_at = None
    __Certificate_algorithmIdentifier_algorithm._const_tab_id = u'id'
    __Certificate_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___Certificate_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Certificate_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Certificate_algorithmIdentifier_parameters._const_tab = ___Certificate_algorithmIdentifier_parameters_tab
    __Certificate_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    __Certificate_algorithmIdentifier_parameters._const_tab_id = u'Type'
    _Certificate_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', __Certificate_algorithmIdentifier_algorithm),
        (u'parameters', __Certificate_algorithmIdentifier_parameters),
        ])
    _Certificate_algorithmIdentifier._ext = []
    _Certificate_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    Certificate._cont = ASN1Dict([
        (u'toBeSigned', _Certificate_toBeSigned),
        (u'algorithmIdentifier', _Certificate_algorithmIdentifier),
        (u'signature', _Certificate_signature),
        ])
    Certificate._ext = []
    
    #-----< TBSCertificate >-----#
    TBSCertificate = SEQ(name=u'TBSCertificate', mode=MODE_TYPE)
    _TBSCertificate_version = INT(name=u'version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Version')), default=0)
    _TBSCertificate_serialNumber = INT(name=u'serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    _TBSCertificate_signature = SEQ(name=u'signature', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __TBSCertificate_signature_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___TBSCertificate_signature_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TBSCertificate_signature_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TBSCertificate_signature_algorithm._const_tab = ___TBSCertificate_signature_algorithm_tab
    __TBSCertificate_signature_algorithm._const_tab_at = None
    __TBSCertificate_signature_algorithm._const_tab_id = u'id'
    __TBSCertificate_signature_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___TBSCertificate_signature_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TBSCertificate_signature_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TBSCertificate_signature_parameters._const_tab = ___TBSCertificate_signature_parameters_tab
    __TBSCertificate_signature_parameters._const_tab_at = ('..', u'algorithm')
    __TBSCertificate_signature_parameters._const_tab_id = u'Type'
    _TBSCertificate_signature._cont = ASN1Dict([
        (u'algorithm', __TBSCertificate_signature_algorithm),
        (u'parameters', __TBSCertificate_signature_parameters),
        ])
    _TBSCertificate_signature._ext = []
    _TBSCertificate_issuer = CHOICE(name=u'issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _TBSCertificate_validity = SEQ(name=u'validity', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Validity')))
    _TBSCertificate_subject = CHOICE(name=u'subject', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _TBSCertificate_subjectPublicKeyInfo = SEQ(name=u'subjectPublicKeyInfo', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SubjectPublicKeyInfo')))
    _TBSCertificate_issuerUniqueIdentifier = BIT_STR(name=u'issuerUniqueIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True)
    _TBSCertificate_subjectUniqueIdentifier = BIT_STR(name=u'subjectUniqueIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True, group=0)
    _TBSCertificate_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True, group=1)
    TBSCertificate._cont = ASN1Dict([
        (u'version', _TBSCertificate_version),
        (u'serialNumber', _TBSCertificate_serialNumber),
        (u'signature', _TBSCertificate_signature),
        (u'issuer', _TBSCertificate_issuer),
        (u'validity', _TBSCertificate_validity),
        (u'subject', _TBSCertificate_subject),
        (u'subjectPublicKeyInfo', _TBSCertificate_subjectPublicKeyInfo),
        (u'issuerUniqueIdentifier', _TBSCertificate_issuerUniqueIdentifier),
        (u'subjectUniqueIdentifier', _TBSCertificate_subjectUniqueIdentifier),
        (u'extensions', _TBSCertificate_extensions),
        ])
    TBSCertificate._ext = [u'subjectUniqueIdentifier', u'extensions']
    
    #-----< Version >-----#
    Version = INT(name=u'Version', mode=MODE_TYPE)
    Version._cont = ASN1Dict([(u'v1', 0), (u'v2', 1), (u'v3', 2)])
    
    #-----< CertificateSerialNumber >-----#
    CertificateSerialNumber = INT(name=u'CertificateSerialNumber', mode=MODE_TYPE)
    
    #-----< Validity >-----#
    Validity = SEQ(name=u'Validity', mode=MODE_TYPE)
    _Validity_notBefore = CHOICE(name=u'notBefore', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')))
    _Validity_notAfter = CHOICE(name=u'notAfter', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')))
    Validity._cont = ASN1Dict([
        (u'notBefore', _Validity_notBefore),
        (u'notAfter', _Validity_notAfter),
        ])
    Validity._ext = []
    
    #-----< SubjectPublicKeyInfo >-----#
    SubjectPublicKeyInfo = SEQ(name=u'SubjectPublicKeyInfo', mode=MODE_TYPE)
    _SubjectPublicKeyInfo_algorithm = SEQ(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SubjectPublicKeyInfo_algorithm_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___SubjectPublicKeyInfo_algorithm_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SubjectPublicKeyInfo_algorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SubjectPublicKeyInfo_algorithm_algorithm._const_tab = ___SubjectPublicKeyInfo_algorithm_algorithm_tab
    __SubjectPublicKeyInfo_algorithm_algorithm._const_tab_at = None
    __SubjectPublicKeyInfo_algorithm_algorithm._const_tab_id = u'id'
    __SubjectPublicKeyInfo_algorithm_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___SubjectPublicKeyInfo_algorithm_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SubjectPublicKeyInfo_algorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SubjectPublicKeyInfo_algorithm_parameters._const_tab = ___SubjectPublicKeyInfo_algorithm_parameters_tab
    __SubjectPublicKeyInfo_algorithm_parameters._const_tab_at = ('..', u'algorithm')
    __SubjectPublicKeyInfo_algorithm_parameters._const_tab_id = u'Type'
    _SubjectPublicKeyInfo_algorithm._cont = ASN1Dict([
        (u'algorithm', __SubjectPublicKeyInfo_algorithm_algorithm),
        (u'parameters', __SubjectPublicKeyInfo_algorithm_parameters),
        ])
    _SubjectPublicKeyInfo_algorithm._ext = []
    _SubjectPublicKeyInfo_subjectPublicKey = BIT_STR(name=u'subjectPublicKey', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PublicKey')))
    SubjectPublicKeyInfo._cont = ASN1Dict([
        (u'algorithm', _SubjectPublicKeyInfo_algorithm),
        (u'subjectPublicKey', _SubjectPublicKeyInfo_subjectPublicKey),
        ])
    SubjectPublicKeyInfo._ext = []
    
    #-----< PublicKey >-----#
    PublicKey = BIT_STR(name=u'PublicKey', mode=MODE_TYPE)
    
    #-----< Time >-----#
    Time = CHOICE(name=u'Time', mode=MODE_TYPE)
    _Time_utcTime = TIME_UTC(name=u'utcTime', mode=MODE_TYPE)
    _Time_generalizedTime = TIME_GEN(name=u'generalizedTime', mode=MODE_TYPE)
    Time._cont = ASN1Dict([
        (u'utcTime', _Time_utcTime),
        (u'generalizedTime', _Time_generalizedTime),
        ])
    Time._ext = None
    
    #-----< Extensions >-----#
    Extensions = SEQ_OF(name=u'Extensions', mode=MODE_TYPE)
    _Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Extension')))
    Extensions._cont = _Extensions__item_
    Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< Extension >-----#
    Extension = SEQ(name=u'Extension', mode=MODE_TYPE)
    _Extension_extnId = OID(name=u'extnId', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'EXTENSION'), [u'id']))
    __Extension_extnId_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    __Extension_extnId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Extension_extnId._const_tab = __Extension_extnId_tab
    _Extension_extnId._const_tab_at = None
    _Extension_extnId._const_tab_id = u'id'
    _Extension_critical = BOOL(name=u'critical', mode=MODE_TYPE, default=False)
    _Extension_extnValue = OCT_STR(name=u'extnValue', mode=MODE_TYPE)
    _Extension_extnValue._const_cont_enc = (2, 1, 2, 1)
    Extension._cont = ASN1Dict([
        (u'extnId', _Extension_extnId),
        (u'critical', _Extension_critical),
        (u'extnValue', _Extension_extnValue),
        ])
    Extension._ext = []
    
    #-----< der >-----#
    der = OID(name=u'der', mode=MODE_VALUE)
    der._val = (2, 1, 2, 1)
    
    #-----< ExtensionSet >-----#
    ExtensionSet = CLASS(name=u'ExtensionSet', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    ExtensionSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EXTENSION >-----#
    EXTENSION = CLASS(name=u'EXTENSION', mode=MODE_TYPE)
    _EXTENSION_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    _EXTENSION_ExtnType = OPEN(name=u'ExtnType', mode=MODE_TYPE)
    EXTENSION._cont = ASN1Dict([
        (u'id', _EXTENSION_id),
        (u'ExtnType', _EXTENSION_ExtnType),
        ])
    
    #-----< Certificates >-----#
    Certificates = SEQ(name=u'Certificates', mode=MODE_TYPE)
    _Certificates_userCertificate = SEQ(name=u'userCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    _Certificates_certificationPath = SEQ_OF(name=u'certificationPath', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ForwardCertificationPath')), opt=True)
    Certificates._cont = ASN1Dict([
        (u'userCertificate', _Certificates_userCertificate),
        (u'certificationPath', _Certificates_certificationPath),
        ])
    Certificates._ext = []
    
    #-----< ForwardCertificationPath >-----#
    ForwardCertificationPath = SEQ_OF(name=u'ForwardCertificationPath', mode=MODE_TYPE)
    _ForwardCertificationPath__item_ = SET_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CrossCertificates')))
    ForwardCertificationPath._cont = _ForwardCertificationPath__item_
    ForwardCertificationPath._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< CrossCertificates >-----#
    CrossCertificates = SET_OF(name=u'CrossCertificates', mode=MODE_TYPE)
    _CrossCertificates__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    CrossCertificates._cont = _CrossCertificates__item_
    CrossCertificates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< CertificationPath >-----#
    CertificationPath = SEQ(name=u'CertificationPath', mode=MODE_TYPE)
    _CertificationPath_userCertificate = SEQ(name=u'userCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    _CertificationPath_theCACertificates = SEQ_OF(name=u'theCACertificates', mode=MODE_TYPE, opt=True)
    __CertificationPath_theCACertificates__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificatePair')))
    _CertificationPath_theCACertificates._cont = __CertificationPath_theCACertificates__item_
    _CertificationPath_theCACertificates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    CertificationPath._cont = ASN1Dict([
        (u'userCertificate', _CertificationPath_userCertificate),
        (u'theCACertificates', _CertificationPath_theCACertificates),
        ])
    CertificationPath._ext = []
    
    #-----< PkiPath >-----#
    PkiPath = SEQ_OF(name=u'PkiPath', mode=MODE_TYPE)
    _PkiPath__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    PkiPath._cont = _PkiPath__item_
    PkiPath._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< CertificateList >-----#
    CertificateList = SEQ(name=u'CertificateList', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _CertificateList_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateListContent')))
    _CertificateList_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __CertificateList_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___CertificateList_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertificateList_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertificateList_algorithmIdentifier_algorithm._const_tab = ___CertificateList_algorithmIdentifier_algorithm_tab
    __CertificateList_algorithmIdentifier_algorithm._const_tab_at = None
    __CertificateList_algorithmIdentifier_algorithm._const_tab_id = u'id'
    __CertificateList_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___CertificateList_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertificateList_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertificateList_algorithmIdentifier_parameters._const_tab = ___CertificateList_algorithmIdentifier_parameters_tab
    __CertificateList_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    __CertificateList_algorithmIdentifier_parameters._const_tab_id = u'Type'
    _CertificateList_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', __CertificateList_algorithmIdentifier_algorithm),
        (u'parameters', __CertificateList_algorithmIdentifier_parameters),
        ])
    _CertificateList_algorithmIdentifier._ext = []
    _CertificateList_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    CertificateList._cont = ASN1Dict([
        (u'toBeSigned', _CertificateList_toBeSigned),
        (u'algorithmIdentifier', _CertificateList_algorithmIdentifier),
        (u'signature', _CertificateList_signature),
        ])
    CertificateList._ext = []
    
    #-----< CertificateListContent >-----#
    CertificateListContent = SEQ(name=u'CertificateListContent', mode=MODE_TYPE)
    _CertificateListContent_version = INT(name=u'version', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Version')), opt=True)
    _CertificateListContent_signature = SEQ(name=u'signature', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __CertificateListContent_signature_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___CertificateListContent_signature_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertificateListContent_signature_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertificateListContent_signature_algorithm._const_tab = ___CertificateListContent_signature_algorithm_tab
    __CertificateListContent_signature_algorithm._const_tab_at = None
    __CertificateListContent_signature_algorithm._const_tab_id = u'id'
    __CertificateListContent_signature_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___CertificateListContent_signature_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertificateListContent_signature_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertificateListContent_signature_parameters._const_tab = ___CertificateListContent_signature_parameters_tab
    __CertificateListContent_signature_parameters._const_tab_at = ('..', u'algorithm')
    __CertificateListContent_signature_parameters._const_tab_id = u'Type'
    _CertificateListContent_signature._cont = ASN1Dict([
        (u'algorithm', __CertificateListContent_signature_algorithm),
        (u'parameters', __CertificateListContent_signature_parameters),
        ])
    _CertificateListContent_signature._ext = []
    _CertificateListContent_issuer = CHOICE(name=u'issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _CertificateListContent_thisUpdate = CHOICE(name=u'thisUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')))
    _CertificateListContent_nextUpdate = CHOICE(name=u'nextUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')), opt=True)
    _CertificateListContent_revokedCertificates = SEQ_OF(name=u'revokedCertificates', mode=MODE_TYPE, opt=True)
    __CertificateListContent_revokedCertificates__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___CertificateListContent_revokedCertificates__item__serialNumber = INT(name=u'serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    ___CertificateListContent_revokedCertificates__item__revocationDate = CHOICE(name=u'revocationDate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')))
    ___CertificateListContent_revokedCertificates__item__crlEntryExtensions = SEQ_OF(name=u'crlEntryExtensions', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True)
    __CertificateListContent_revokedCertificates__item_._cont = ASN1Dict([
        (u'serialNumber', ___CertificateListContent_revokedCertificates__item__serialNumber),
        (u'revocationDate', ___CertificateListContent_revokedCertificates__item__revocationDate),
        (u'crlEntryExtensions', ___CertificateListContent_revokedCertificates__item__crlEntryExtensions),
        ])
    __CertificateListContent_revokedCertificates__item_._ext = []
    _CertificateListContent_revokedCertificates._cont = __CertificateListContent_revokedCertificates__item_
    _CertificateListContent_crlExtensions = SEQ_OF(name=u'crlExtensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True)
    CertificateListContent._cont = ASN1Dict([
        (u'version', _CertificateListContent_version),
        (u'signature', _CertificateListContent_signature),
        (u'issuer', _CertificateListContent_issuer),
        (u'thisUpdate', _CertificateListContent_thisUpdate),
        (u'nextUpdate', _CertificateListContent_nextUpdate),
        (u'revokedCertificates', _CertificateListContent_revokedCertificates),
        (u'crlExtensions', _CertificateListContent_crlExtensions),
        ])
    CertificateListContent._ext = [u'crlExtensions']
    
    #-----< CertAVL >-----#
    CertAVL = SEQ(name=u'CertAVL', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _CertAVL_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'TBSCertAVL')))
    _CertAVL_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __CertAVL_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___CertAVL_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertAVL_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertAVL_algorithmIdentifier_algorithm._const_tab = ___CertAVL_algorithmIdentifier_algorithm_tab
    __CertAVL_algorithmIdentifier_algorithm._const_tab_at = None
    __CertAVL_algorithmIdentifier_algorithm._const_tab_id = u'id'
    __CertAVL_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___CertAVL_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___CertAVL_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertAVL_algorithmIdentifier_parameters._const_tab = ___CertAVL_algorithmIdentifier_parameters_tab
    __CertAVL_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    __CertAVL_algorithmIdentifier_parameters._const_tab_id = u'Type'
    _CertAVL_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', __CertAVL_algorithmIdentifier_algorithm),
        (u'parameters', __CertAVL_algorithmIdentifier_parameters),
        ])
    _CertAVL_algorithmIdentifier._ext = []
    _CertAVL_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    CertAVL._cont = ASN1Dict([
        (u'toBeSigned', _CertAVL_toBeSigned),
        (u'algorithmIdentifier', _CertAVL_algorithmIdentifier),
        (u'signature', _CertAVL_signature),
        ])
    CertAVL._ext = []
    
    #-----< TBSCertAVL >-----#
    TBSCertAVL = SEQ(name=u'TBSCertAVL', mode=MODE_TYPE)
    _TBSCertAVL_version = INT(name=u'version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Version')), default=0)
    _TBSCertAVL_serialNumber = INT(name=u'serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AvlSerialNumber')), opt=True)
    _TBSCertAVL_signature = SEQ(name=u'signature', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __TBSCertAVL_signature_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___TBSCertAVL_signature_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TBSCertAVL_signature_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TBSCertAVL_signature_algorithm._const_tab = ___TBSCertAVL_signature_algorithm_tab
    __TBSCertAVL_signature_algorithm._const_tab_at = None
    __TBSCertAVL_signature_algorithm._const_tab_id = u'id'
    __TBSCertAVL_signature_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___TBSCertAVL_signature_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TBSCertAVL_signature_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TBSCertAVL_signature_parameters._const_tab = ___TBSCertAVL_signature_parameters_tab
    __TBSCertAVL_signature_parameters._const_tab_at = ('..', u'algorithm')
    __TBSCertAVL_signature_parameters._const_tab_id = u'Type'
    _TBSCertAVL_signature._cont = ASN1Dict([
        (u'algorithm', __TBSCertAVL_signature_algorithm),
        (u'parameters', __TBSCertAVL_signature_parameters),
        ])
    _TBSCertAVL_signature._ext = []
    _TBSCertAVL_issuer = CHOICE(name=u'issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _TBSCertAVL_constrained = BOOL(name=u'constrained', mode=MODE_TYPE)
    _TBSCertAVL_entries = SEQ_OF(name=u'entries', mode=MODE_TYPE)
    __TBSCertAVL_entries__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___TBSCertAVL_entries__item__idType = CHOICE(name=u'idType', mode=MODE_TYPE)
    ____TBSCertAVL_entries__item__idType_certIdentifier = CHOICE(name=u'certIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'PKCertIdentifier')))
    ____TBSCertAVL_entries__item__idType_entityGroup = SEQ_OF(name=u'entityGroup', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ___TBSCertAVL_entries__item__idType._cont = ASN1Dict([
        (u'certIdentifier', ____TBSCertAVL_entries__item__idType_certIdentifier),
        (u'entityGroup', ____TBSCertAVL_entries__item__idType_entityGroup),
        ])
    ___TBSCertAVL_entries__item__idType._ext = []
    ___TBSCertAVL_entries__item__scope = SEQ_OF(name=u'scope', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'ScopeRestrictions')), opt=True)
    ___TBSCertAVL_entries__item__entryExtensions = SEQ_OF(name=u'entryExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True)
    __TBSCertAVL_entries__item_._cont = ASN1Dict([
        (u'idType', ___TBSCertAVL_entries__item__idType),
        (u'scope', ___TBSCertAVL_entries__item__scope),
        (u'entryExtensions', ___TBSCertAVL_entries__item__entryExtensions),
        ])
    __TBSCertAVL_entries__item_._ext = []
    _TBSCertAVL_entries._cont = __TBSCertAVL_entries__item_
    _TBSCertAVL_entries._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _TBSCertAVL_avlExtensions = SEQ_OF(name=u'avlExtensions', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Extensions')), opt=True)
    TBSCertAVL._cont = ASN1Dict([
        (u'version', _TBSCertAVL_version),
        (u'serialNumber', _TBSCertAVL_serialNumber),
        (u'signature', _TBSCertAVL_signature),
        (u'issuer', _TBSCertAVL_issuer),
        (u'constrained', _TBSCertAVL_constrained),
        (u'entries', _TBSCertAVL_entries),
        (u'avlExtensions', _TBSCertAVL_avlExtensions),
        ])
    TBSCertAVL._ext = [u'avlExtensions']
    
    #-----< AvlSerialNumber >-----#
    AvlSerialNumber = INT(name=u'AvlSerialNumber', mode=MODE_TYPE)
    AvlSerialNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< PKCertIdentifier >-----#
    PKCertIdentifier = CHOICE(name=u'PKCertIdentifier', mode=MODE_TYPE)
    _PKCertIdentifier_issuerSerialNumber = SEQ(name=u'issuerSerialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'IssuerSerialNumber')))
    _PKCertIdentifier_fingerprintPKC = SEQ(name=u'fingerprintPKC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'FINGERPRINT')))
    __PKCertIdentifier_fingerprintPKC_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm._const_tab = ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm_tab
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm._const_tab_at = None
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters._const_tab = ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters_tab
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __PKCertIdentifier_fingerprintPKC_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm),
        (u'parameters', ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters),
        ])
    __PKCertIdentifier_fingerprintPKC_algorithmIdentifier._ext = []
    __PKCertIdentifier_fingerprintPKC_fingerprint = BIT_STR(name=u'fingerprint', mode=MODE_TYPE)
    _PKCertIdentifier_fingerprintPKC._cont = ASN1Dict([
        (u'algorithmIdentifier', __PKCertIdentifier_fingerprintPKC_algorithmIdentifier),
        (u'fingerprint', __PKCertIdentifier_fingerprintPKC_fingerprint),
        ])
    _PKCertIdentifier_fingerprintPKC._ext = []
    _PKCertIdentifier_fingerprintPK = SEQ(name=u'fingerprintPK', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'FINGERPRINT')))
    __PKCertIdentifier_fingerprintPK_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm._const_tab = ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm_tab
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm._const_tab_at = None
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters._const_tab = ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters_tab
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __PKCertIdentifier_fingerprintPK_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm),
        (u'parameters', ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters),
        ])
    __PKCertIdentifier_fingerprintPK_algorithmIdentifier._ext = []
    __PKCertIdentifier_fingerprintPK_fingerprint = BIT_STR(name=u'fingerprint', mode=MODE_TYPE)
    _PKCertIdentifier_fingerprintPK._cont = ASN1Dict([
        (u'algorithmIdentifier', __PKCertIdentifier_fingerprintPK_algorithmIdentifier),
        (u'fingerprint', __PKCertIdentifier_fingerprintPK_fingerprint),
        ])
    _PKCertIdentifier_fingerprintPK._ext = []
    PKCertIdentifier._cont = ASN1Dict([
        (u'issuerSerialNumber', _PKCertIdentifier_issuerSerialNumber),
        (u'fingerprintPKC', _PKCertIdentifier_fingerprintPKC),
        (u'fingerprintPK', _PKCertIdentifier_fingerprintPK),
        ])
    PKCertIdentifier._ext = []
    
    #-----< IssuerSerialNumber >-----#
    IssuerSerialNumber = SEQ(name=u'IssuerSerialNumber', mode=MODE_TYPE)
    _IssuerSerialNumber_issuer = CHOICE(name=u'issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _IssuerSerialNumber_serialNumber = INT(name=u'serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    IssuerSerialNumber._cont = ASN1Dict([
        (u'issuer', _IssuerSerialNumber_issuer),
        (u'serialNumber', _IssuerSerialNumber_serialNumber),
        ])
    IssuerSerialNumber._ext = []
    
    #-----< ScopeRestrictions >-----#
    ScopeRestrictions = SEQ_OF(name=u'ScopeRestrictions', mode=MODE_TYPE)
    _ScopeRestrictions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ScopeRestriction')))
    ScopeRestrictions._cont = _ScopeRestrictions__item_
    
    #-----< SCOPE-RESTRICTION >-----#
    SCOPE_RESTRICTION = CLASS(name=u'SCOPE-RESTRICTION', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', u'TYPE-IDENTIFIER'), []))
    
    #-----< ScopeRestriction >-----#
    ScopeRestriction = SEQ(name=u'ScopeRestriction', mode=MODE_TYPE)
    _ScopeRestriction_id = OID(name=u'id', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'SCOPE-RESTRICTION'), [u'id']))
    _ScopeRestriction_restriction = OPEN(name=u'restriction', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'SCOPE-RESTRICTION'), [u'Type']))
    ScopeRestriction._cont = ASN1Dict([
        (u'id', _ScopeRestriction_id),
        (u'restriction', _ScopeRestriction_restriction),
        ])
    ScopeRestriction._ext = []
    
    #-----< protRestrict >-----#
    protRestrict = CLASS(name=u'protRestrict', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _protRestrict_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ProtRestriction')))
    protRestrict._val = dict([(u'ExtnType', _protRestrict_val_ExtnType), (u'id', (2, 5, 41, 1))])
    
    #-----< ProtRestriction >-----#
    ProtRestriction = SEQ_OF(name=u'ProtRestriction', mode=MODE_TYPE)
    _ProtRestriction__item_ = OID(name='_item_', mode=MODE_TYPE)
    ProtRestriction._cont = _ProtRestriction__item_
    ProtRestriction._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< pkiUser >-----#
    pkiUser = CLASS(name=u'pkiUser', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    __pmiUser_OptionalAttributes_val_Type_0 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateExactAssertion')))
    pkiUser._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'auxiliary'), (u'OptionalAttributes', ASN1Set(rv=[dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 1)), (u'ldapName', [u'certificateExactMatch']), (u'ldapDesc', u'X.509 Certificate Exact Match'), (u'id', (2, 5, 13, 34))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8)), (u'ldapName', [u'userCertificate']), (u'ldapDesc', u'X.509 user certificate'), (u'id', (2, 5, 4, 36))])], rr=[], ev=None, er=[])), (u'ldapName', [u'pkiUser']), (u'ldapDesc', u'X.509 PKI User'), (u'id', (2, 5, 6, 21))])
    
    #-----< pkiCA >-----#
    pkiCA = CLASS(name=u'pkiCA', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_1 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1 = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListExactAssertion')))
    __pmiUser_OptionalAttributes_val_Type_2 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    __pmiUser_OptionalAttributes_val_Type_3 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    __pmiUser_OptionalAttributes_val_Type_4 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificatePair')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2 = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePairExactAssertion')))
    pkiCA._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'auxiliary'), (u'OptionalAttributes', ASN1Set(rv=[dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 1)), (u'ldapName', [u'certificateExactMatch']), (u'ldapDesc', u'X.509 Certificate Exact Match'), (u'id', (2, 5, 13, 34))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8)), (u'ldapName', [u'cACertificate']), (u'ldapDesc', u'X.509 CA certificate'), (u'id', (2, 5, 4, 37))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'certificateRevocationList']), (u'ldapDesc', u'X.509 certificate revocation list'), (u'id', (2, 5, 4, 39))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_2), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'certificateRevocationList']), (u'ldapDesc', u'X.509 EEPK certificate revocation list'), (u'id', (2, 5, 4, 101))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_3), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'authorityRevocationList']), (u'ldapDesc', u'X.509 authority revocation list'), (u'id', (2, 5, 4, 38))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_4), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 3)), (u'ldapName', [u'certificatePairExactMatch']), (u'ldapDesc', u'X.509 Certificate Pair Exact Match'), (u'id', (2, 5, 13, 36))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 10)), (u'ldapName', [u'crossCertificatePair']), (u'ldapDesc', u'X.509 cross certificate pair'), (u'id', (2, 5, 4, 40))])], rr=[], ev=None, er=[])), (u'ldapName', [u'pkiCA']), (u'ldapDesc', u'X.509 PKI Certificate Authority'), (u'id', (2, 5, 6, 22))])
    
    #-----< cRLDistributionPoint >-----#
    cRLDistributionPoint = CLASS(name=u'cRLDistributionPoint', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3 = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _____pmiUser_Superclasses_MandatoryAttributes_derivation_substrings_match_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0 = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __pmiUser_OptionalAttributes_val_Type_0_0 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    cRLDistributionPoint._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'structural'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'derivation', dict([(u'Type', ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', _____pmiUser_Superclasses_MandatoryAttributes_derivation_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'cn', u'commonName']), (u'id', (2, 5, 4, 3))])], rr=[], ev=None, er=[])), (u'OptionalAttributes', ASN1Set(rv=[dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_0_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'certificateRevocationList']), (u'ldapDesc', u'X.509 certificate revocation list'), (u'id', (2, 5, 4, 39))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'certificateRevocationList']), (u'ldapDesc', u'X.509 EEPK certificate revocation list'), (u'id', (2, 5, 4, 101))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_2), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'authorityRevocationList']), (u'ldapDesc', u'X.509 authority revocation list'), (u'id', (2, 5, 4, 38))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_3), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'deltaRevocationList']), (u'ldapDesc', u'X.509 delta revocation list'), (u'id', (2, 5, 4, 53))])], rr=[], ev=None, er=[])), (u'ldapName', [u'cRLDistributionPoint']), (u'ldapDesc', u'X.509 CRL distribution point'), (u'id', (2, 5, 6, 19))])
    
    #-----< cRLDistPtNameForm >-----#
    cRLDistPtNameForm = CLASS(name=u'cRLDistPtNameForm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'NAME-FORM')))
    __cRLDistPtNameForm_MandatoryAttributes_val_Type_0 = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    cRLDistPtNameForm._val = dict([(u'namedObjectClass', dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'structural'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'derivation', dict([(u'Type', ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', _____pmiUser_Superclasses_MandatoryAttributes_derivation_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'cn', u'commonName']), (u'id', (2, 5, 4, 3))])], rr=[], ev=None, er=[])), (u'OptionalAttributes', ASN1Set(rv=[dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_0_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'certificateRevocationList']), (u'ldapDesc', u'X.509 certificate revocation list'), (u'id', (2, 5, 4, 39))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'certificateRevocationList']), (u'ldapDesc', u'X.509 EEPK certificate revocation list'), (u'id', (2, 5, 4, 101))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_2), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'authorityRevocationList']), (u'ldapDesc', u'X.509 authority revocation list'), (u'id', (2, 5, 4, 38))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_3), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'deltaRevocationList']), (u'ldapDesc', u'X.509 delta revocation list'), (u'id', (2, 5, 4, 53))])], rr=[], ev=None, er=[])), (u'ldapName', [u'cRLDistributionPoint']), (u'ldapDesc', u'X.509 CRL distribution point'), (u'id', (2, 5, 6, 19))])), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'derivation', dict([(u'Type', ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', _____pmiUser_Superclasses_MandatoryAttributes_derivation_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', __cRLDistPtNameForm_MandatoryAttributes_val_Type_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'cn', u'commonName']), (u'id', (2, 5, 4, 3))])], rr=[], ev=None, er=[])), (u'id', (2, 5, 15, 14))])
    
    #-----< deltaCRL >-----#
    deltaCRL = CLASS(name=u'deltaCRL', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    deltaCRL._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'auxiliary'), (u'OptionalAttributes', ASN1Set(rv=[dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_0_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'deltaRevocationList']), (u'ldapDesc', u'X.509 delta revocation list'), (u'id', (2, 5, 4, 53))])], rr=[], ev=None, er=[])), (u'ldapName', [u'deltaCRL']), (u'ldapDesc', u'X.509 delta CRL'), (u'id', (2, 5, 6, 23))])
    
    #-----< cpCps >-----#
    cpCps = CLASS(name=u'cpCps', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_0_1 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicySyntax')))
    __pmiUser_OptionalAttributes_val_Type_1_0 = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'InfoSyntax')))
    cpCps._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'auxiliary'), (u'OptionalAttributes', ASN1Set(rv=[dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_0_1), (u'id', (2, 5, 4, 69))]), dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_1_0), (u'id', (2, 5, 4, 68))])], rr=[], ev=None, er=[])), (u'ldapName', [u'cpCps']), (u'ldapDesc', u'Certificate Policy and Certification Practice Statement'), (u'id', (2, 5, 6, 30))])
    
    #-----< pkiCertPath >-----#
    pkiCertPath = CLASS(name=u'pkiCertPath', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __pmiUser_OptionalAttributes_val_Type_0_2 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PkiPath')))
    pkiCertPath._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'auxiliary'), (u'OptionalAttributes', ASN1Set(rv=[dict([(u'Type', __pmiUser_OptionalAttributes_val_Type_0_2), (u'id', (2, 5, 4, 70))])], rr=[], ev=None, er=[])), (u'ldapName', [u'pkiCertPath']), (u'ldapDesc', u'PKI Certification Path'), (u'id', (2, 5, 6, 31))])
    
    #-----< userCertificate >-----#
    userCertificate = CLASS(name=u'userCertificate', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _userCertificate_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    userCertificate._val = dict([(u'Type', _userCertificate_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 1)), (u'ldapName', [u'certificateExactMatch']), (u'ldapDesc', u'X.509 Certificate Exact Match'), (u'id', (2, 5, 13, 34))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8)), (u'ldapName', [u'userCertificate']), (u'ldapDesc', u'X.509 user certificate'), (u'id', (2, 5, 4, 36))])
    
    #-----< cACertificate >-----#
    cACertificate = CLASS(name=u'cACertificate', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _cACertificate_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    cACertificate._val = dict([(u'Type', _cACertificate_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 1)), (u'ldapName', [u'certificateExactMatch']), (u'ldapDesc', u'X.509 Certificate Exact Match'), (u'id', (2, 5, 13, 34))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8)), (u'ldapName', [u'cACertificate']), (u'ldapDesc', u'X.509 CA certificate'), (u'id', (2, 5, 4, 37))])
    
    #-----< crossCertificatePair >-----#
    crossCertificatePair = CLASS(name=u'crossCertificatePair', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _crossCertificatePair_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificatePair')))
    crossCertificatePair._val = dict([(u'Type', _crossCertificatePair_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 3)), (u'ldapName', [u'certificatePairExactMatch']), (u'ldapDesc', u'X.509 Certificate Pair Exact Match'), (u'id', (2, 5, 13, 36))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 10)), (u'ldapName', [u'crossCertificatePair']), (u'ldapDesc', u'X.509 cross certificate pair'), (u'id', (2, 5, 4, 40))])
    
    #-----< CertificatePair >-----#
    CertificatePair = SEQ(name=u'CertificatePair', mode=MODE_TYPE)
    _CertificatePair_issuedToThisCA = SEQ(name=u'issuedToThisCA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')), opt=True)
    _CertificatePair_issuedByThisCA = SEQ(name=u'issuedByThisCA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')), opt=True)
    CertificatePair._cont = ASN1Dict([
        (u'issuedToThisCA', _CertificatePair_issuedToThisCA),
        (u'issuedByThisCA', _CertificatePair_issuedByThisCA),
        ])
    CertificatePair._ext = []
    
    #-----< certificateRevocationList >-----#
    certificateRevocationList = CLASS(name=u'certificateRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _certificateRevocationList_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    certificateRevocationList._val = dict([(u'Type', _certificateRevocationList_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'certificateRevocationList']), (u'ldapDesc', u'X.509 certificate revocation list'), (u'id', (2, 5, 4, 39))])
    
    #-----< eepkCertificateRevocationList >-----#
    eepkCertificateRevocationList = CLASS(name=u'eepkCertificateRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _eepkCertificateRevocationList_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    eepkCertificateRevocationList._val = dict([(u'Type', _eepkCertificateRevocationList_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'certificateRevocationList']), (u'ldapDesc', u'X.509 EEPK certificate revocation list'), (u'id', (2, 5, 4, 101))])
    
    #-----< authorityRevocationList >-----#
    authorityRevocationList = CLASS(name=u'authorityRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _authorityRevocationList_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    authorityRevocationList._val = dict([(u'Type', _authorityRevocationList_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'authorityRevocationList']), (u'ldapDesc', u'X.509 authority revocation list'), (u'id', (2, 5, 4, 38))])
    
    #-----< deltaRevocationList >-----#
    deltaRevocationList = CLASS(name=u'deltaRevocationList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _deltaRevocationList_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    deltaRevocationList._val = dict([(u'Type', _deltaRevocationList_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)), (u'ldapName', [u'deltaRevocationList']), (u'ldapDesc', u'X.509 delta revocation list'), (u'id', (2, 5, 4, 53))])
    
    #-----< supportedAlgorithms >-----#
    supportedAlgorithms = CLASS(name=u'supportedAlgorithms', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedAlgorithms_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SupportedAlgorithm')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4 = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm._const_tab = ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm_tab
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm._const_tab_at = None
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm._const_tab_id = u'id'
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters._const_tab = ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters_tab
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters._const_tab_at = ('..', u'algorithm')
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters._const_tab_id = u'Type'
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4._cont = ASN1Dict([
        (u'algorithm', _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm),
        (u'parameters', _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters),
        ])
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4._ext = []
    supportedAlgorithms._val = dict([(u'Type', _supportedAlgorithms_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 7)), (u'ldapName', [u'algorithmIdentifierMatch']), (u'ldapDesc', u'X.509 Algorithm Identifier Match'), (u'id', (2, 5, 13, 40))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 49)), (u'ldapName', [u'supportedAlgorithms']), (u'ldapDesc', u'X.509 support algorithms'), (u'id', (2, 5, 4, 52))])
    
    #-----< SupportedAlgorithm >-----#
    SupportedAlgorithm = SEQ(name=u'SupportedAlgorithm', mode=MODE_TYPE)
    _SupportedAlgorithm_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SupportedAlgorithm_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___SupportedAlgorithm_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SupportedAlgorithm_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SupportedAlgorithm_algorithmIdentifier_algorithm._const_tab = ___SupportedAlgorithm_algorithmIdentifier_algorithm_tab
    __SupportedAlgorithm_algorithmIdentifier_algorithm._const_tab_at = None
    __SupportedAlgorithm_algorithmIdentifier_algorithm._const_tab_id = u'id'
    __SupportedAlgorithm_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___SupportedAlgorithm_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SupportedAlgorithm_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SupportedAlgorithm_algorithmIdentifier_parameters._const_tab = ___SupportedAlgorithm_algorithmIdentifier_parameters_tab
    __SupportedAlgorithm_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    __SupportedAlgorithm_algorithmIdentifier_parameters._const_tab_id = u'Type'
    _SupportedAlgorithm_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', __SupportedAlgorithm_algorithmIdentifier_algorithm),
        (u'parameters', __SupportedAlgorithm_algorithmIdentifier_parameters),
        ])
    _SupportedAlgorithm_algorithmIdentifier._ext = []
    _SupportedAlgorithm_intendedUsage = BIT_STR(name=u'intendedUsage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'KeyUsage')), opt=True)
    _SupportedAlgorithm_intendedCertificatePolicies = SEQ_OF(name=u'intendedCertificatePolicies', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificatePoliciesSyntax')), opt=True)
    SupportedAlgorithm._cont = ASN1Dict([
        (u'algorithmIdentifier', _SupportedAlgorithm_algorithmIdentifier),
        (u'intendedUsage', _SupportedAlgorithm_intendedUsage),
        (u'intendedCertificatePolicies', _SupportedAlgorithm_intendedCertificatePolicies),
        ])
    SupportedAlgorithm._ext = []
    
    #-----< certificationPracticeStmt >-----#
    certificationPracticeStmt = CLASS(name=u'certificationPracticeStmt', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _certificationPracticeStmt_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'InfoSyntax')))
    certificationPracticeStmt._val = dict([(u'Type', _certificationPracticeStmt_val_Type), (u'id', (2, 5, 4, 68))])
    
    #-----< InfoSyntax >-----#
    InfoSyntax = CHOICE(name=u'InfoSyntax', mode=MODE_TYPE)
    _InfoSyntax_content = CHOICE(name=u'content', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _InfoSyntax_pointer = SEQ(name=u'pointer', mode=MODE_TYPE)
    __InfoSyntax_pointer_name = SEQ_OF(name=u'name', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    __InfoSyntax_pointer_hash = SEQ(name=u'hash', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'HASH')), opt=True)
    ___InfoSyntax_pointer_hash_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm._const_tab = _____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm_tab
    ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm._const_tab_at = None
    ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____InfoSyntax_pointer_hash_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____InfoSyntax_pointer_hash_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters._const_tab = _____InfoSyntax_pointer_hash_algorithmIdentifier_parameters_tab
    ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___InfoSyntax_pointer_hash_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm),
        (u'parameters', ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters),
        ])
    ___InfoSyntax_pointer_hash_algorithmIdentifier._ext = []
    ___InfoSyntax_pointer_hash_hashValue = BIT_STR(name=u'hashValue', mode=MODE_TYPE)
    __InfoSyntax_pointer_hash._cont = ASN1Dict([
        (u'algorithmIdentifier', ___InfoSyntax_pointer_hash_algorithmIdentifier),
        (u'hashValue', ___InfoSyntax_pointer_hash_hashValue),
        ])
    __InfoSyntax_pointer_hash._ext = []
    _InfoSyntax_pointer._cont = ASN1Dict([
        (u'name', __InfoSyntax_pointer_name),
        (u'hash', __InfoSyntax_pointer_hash),
        ])
    _InfoSyntax_pointer._ext = []
    InfoSyntax._cont = ASN1Dict([
        (u'content', _InfoSyntax_content),
        (u'pointer', _InfoSyntax_pointer),
        ])
    InfoSyntax._ext = []
    
    #-----< POLICY >-----#
    POLICY = CLASS(name=u'POLICY', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', u'TYPE-IDENTIFIER'), []))
    
    #-----< HashedPolicyInfo >-----#
    HashedPolicyInfo = OPEN(name=u'HashedPolicyInfo', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'POLICY'), [u'Type']))
    _HashedPolicyInfo_tab = CLASS(name='_tab_POLICY', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'POLICY')))
    _HashedPolicyInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    HashedPolicyInfo._const_tab = _HashedPolicyInfo_tab
    HashedPolicyInfo._const_tab_at = None
    HashedPolicyInfo._const_tab_id = u'Type'
    
    #-----< Policies >-----#
    Policies = CLASS(name=u'Policies', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'POLICY')))
    Policies._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< certificatePolicy >-----#
    certificatePolicy = CLASS(name=u'certificatePolicy', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _certificatePolicy_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicySyntax')))
    certificatePolicy._val = dict([(u'Type', _certificatePolicy_val_Type), (u'id', (2, 5, 4, 69))])
    
    #-----< PolicySyntax >-----#
    PolicySyntax = SEQ(name=u'PolicySyntax', mode=MODE_TYPE)
    _PolicySyntax_policyIdentifier = OID(name=u'policyIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicyID')))
    _PolicySyntax_policySyntax = CHOICE(name=u'policySyntax', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'InfoSyntax')))
    PolicySyntax._cont = ASN1Dict([
        (u'policyIdentifier', _PolicySyntax_policyIdentifier),
        (u'policySyntax', _PolicySyntax_policySyntax),
        ])
    PolicySyntax._ext = []
    
    #-----< PolicyID >-----#
    PolicyID = OID(name=u'PolicyID', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertPolicyId')))
    
    #-----< pkiPath >-----#
    pkiPath = CLASS(name=u'pkiPath', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pkiPath_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PkiPath')))
    pkiPath._val = dict([(u'Type', _pkiPath_val_Type), (u'id', (2, 5, 4, 70))])
    
    #-----< userPassword >-----#
    userPassword = CLASS(name=u'userPassword', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _userPassword_val_Type = OCT_STR(name=u'Type', mode=MODE_TYPE)
    _userPassword_val_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_5 = OCT_STR(name=u'AssertionType', mode=MODE_TYPE)
    userPassword._val = dict([(u'Type', _userPassword_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_5), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), (u'ldapName', [u'octetStringMatch']), (u'id', (2, 5, 13, 17))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), (u'ldapName', [u'userPassword']), (u'id', (2, 5, 4, 35))])
    
    #-----< x509Certificate >-----#
    x509Certificate = CLASS(name=u'x509Certificate', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _x509Certificate_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')))
    x509Certificate._val = dict([(u'ldapDesc', u'X.509 Certificate'), (u'Type', _x509Certificate_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8))])
    
    #-----< x509CertificateList >-----#
    x509CertificateList = CLASS(name=u'x509CertificateList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _x509CertificateList_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')))
    x509CertificateList._val = dict([(u'ldapDesc', u'X.509 Certificate List'), (u'Type', _x509CertificateList_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9))])
    
    #-----< x509CertificatePair >-----#
    x509CertificatePair = CLASS(name=u'x509CertificatePair', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _x509CertificatePair_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificatePair')))
    x509CertificatePair._val = dict([(u'ldapDesc', u'X.509 Certificate Pair'), (u'Type', _x509CertificatePair_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 10))])
    
    #-----< x509SupportedAlgorithm >-----#
    x509SupportedAlgorithm = CLASS(name=u'x509SupportedAlgorithm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _x509SupportedAlgorithm_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SupportedAlgorithm')))
    x509SupportedAlgorithm._val = dict([(u'ldapDesc', u'X.509 Supported Algorithm'), (u'Type', _x509SupportedAlgorithm_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 49))])
    
    #-----< id-oc-cRLDistributionPoint >-----#
    id_oc_cRLDistributionPoint = OID(name=u'id-oc-cRLDistributionPoint', mode=MODE_VALUE)
    id_oc_cRLDistributionPoint._val = (2, 5, 6, 19)
    
    #-----< id-oc-pkiUser >-----#
    id_oc_pkiUser = OID(name=u'id-oc-pkiUser', mode=MODE_VALUE)
    id_oc_pkiUser._val = (2, 5, 6, 21)
    
    #-----< id-oc-pkiCA >-----#
    id_oc_pkiCA = OID(name=u'id-oc-pkiCA', mode=MODE_VALUE)
    id_oc_pkiCA._val = (2, 5, 6, 22)
    
    #-----< id-oc-deltaCRL >-----#
    id_oc_deltaCRL = OID(name=u'id-oc-deltaCRL', mode=MODE_VALUE)
    id_oc_deltaCRL._val = (2, 5, 6, 23)
    
    #-----< id-oc-cpCps >-----#
    id_oc_cpCps = OID(name=u'id-oc-cpCps', mode=MODE_VALUE)
    id_oc_cpCps._val = (2, 5, 6, 30)
    
    #-----< id-oc-pkiCertPath >-----#
    id_oc_pkiCertPath = OID(name=u'id-oc-pkiCertPath', mode=MODE_VALUE)
    id_oc_pkiCertPath._val = (2, 5, 6, 31)
    
    #-----< id-nf-cRLDistPtNameForm >-----#
    id_nf_cRLDistPtNameForm = OID(name=u'id-nf-cRLDistPtNameForm', mode=MODE_VALUE)
    id_nf_cRLDistPtNameForm._val = (2, 5, 15, 14)
    
    #-----< id-at-userPassword >-----#
    id_at_userPassword = OID(name=u'id-at-userPassword', mode=MODE_VALUE)
    id_at_userPassword._val = (2, 5, 4, 35)
    
    #-----< id-at-userCertificate >-----#
    id_at_userCertificate = OID(name=u'id-at-userCertificate', mode=MODE_VALUE)
    id_at_userCertificate._val = (2, 5, 4, 36)
    
    #-----< id-at-cAcertificate >-----#
    id_at_cAcertificate = OID(name=u'id-at-cAcertificate', mode=MODE_VALUE)
    id_at_cAcertificate._val = (2, 5, 4, 37)
    
    #-----< id-at-authorityRevocationList >-----#
    id_at_authorityRevocationList = OID(name=u'id-at-authorityRevocationList', mode=MODE_VALUE)
    id_at_authorityRevocationList._val = (2, 5, 4, 38)
    
    #-----< id-at-certificateRevocationList >-----#
    id_at_certificateRevocationList = OID(name=u'id-at-certificateRevocationList', mode=MODE_VALUE)
    id_at_certificateRevocationList._val = (2, 5, 4, 39)
    
    #-----< id-at-crossCertificatePair >-----#
    id_at_crossCertificatePair = OID(name=u'id-at-crossCertificatePair', mode=MODE_VALUE)
    id_at_crossCertificatePair._val = (2, 5, 4, 40)
    
    #-----< id-at-supportedAlgorithms >-----#
    id_at_supportedAlgorithms = OID(name=u'id-at-supportedAlgorithms', mode=MODE_VALUE)
    id_at_supportedAlgorithms._val = (2, 5, 4, 52)
    
    #-----< id-at-deltaRevocationList >-----#
    id_at_deltaRevocationList = OID(name=u'id-at-deltaRevocationList', mode=MODE_VALUE)
    id_at_deltaRevocationList._val = (2, 5, 4, 53)
    
    #-----< id-at-certificationPracticeStmt >-----#
    id_at_certificationPracticeStmt = OID(name=u'id-at-certificationPracticeStmt', mode=MODE_VALUE)
    id_at_certificationPracticeStmt._val = (2, 5, 4, 68)
    
    #-----< id-at-certificatePolicy >-----#
    id_at_certificatePolicy = OID(name=u'id-at-certificatePolicy', mode=MODE_VALUE)
    id_at_certificatePolicy._val = (2, 5, 4, 69)
    
    #-----< id-at-pkiPath >-----#
    id_at_pkiPath = OID(name=u'id-at-pkiPath', mode=MODE_VALUE)
    id_at_pkiPath._val = (2, 5, 4, 70)
    
    #-----< id-at-eepkCertificateRevocationList >-----#
    id_at_eepkCertificateRevocationList = OID(name=u'id-at-eepkCertificateRevocationList', mode=MODE_VALUE)
    id_at_eepkCertificateRevocationList._val = (2, 5, 4, 101)
    
    #-----< id-lsx-x509Certificate >-----#
    id_lsx_x509Certificate = OID(name=u'id-lsx-x509Certificate', mode=MODE_VALUE)
    id_lsx_x509Certificate._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 8)
    
    #-----< id-lsx-x509CertificateList >-----#
    id_lsx_x509CertificateList = OID(name=u'id-lsx-x509CertificateList', mode=MODE_VALUE)
    id_lsx_x509CertificateList._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 9)
    
    #-----< id-lsx-x509CertificatePair >-----#
    id_lsx_x509CertificatePair = OID(name=u'id-lsx-x509CertificatePair', mode=MODE_VALUE)
    id_lsx_x509CertificatePair._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 10)
    
    #-----< id-lsx-x509SupportedAlgorithm >-----#
    id_lsx_x509SupportedAlgorithm = OID(name=u'id-lsx-x509SupportedAlgorithm', mode=MODE_VALUE)
    id_lsx_x509SupportedAlgorithm._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 49)
    
    #-----< id-protRestrict >-----#
    id_protRestrict = OID(name=u'id-protRestrict', mode=MODE_VALUE)
    id_protRestrict._val = (2, 5, 41, 1)
    
    _all_ = [
        ___SIGNATURE_algorithmIdentifier_algorithm_tab,
        __SIGNATURE_algorithmIdentifier_algorithm,
        ___SIGNATURE_algorithmIdentifier_parameters_tab,
        __SIGNATURE_algorithmIdentifier_parameters,
        _SIGNATURE_algorithmIdentifier,
        _SIGNATURE_signature,
        SIGNATURE,
        ___HASH_algorithmIdentifier_algorithm_tab,
        __HASH_algorithmIdentifier_algorithm,
        ___HASH_algorithmIdentifier_parameters_tab,
        __HASH_algorithmIdentifier_parameters,
        _HASH_algorithmIdentifier,
        _HASH_hashValue,
        HASH,
        ENCRYPTED,
        ENCRYPTED_HASH,
        ___FINGERPRINT_algorithmIdentifier_algorithm_tab,
        __FINGERPRINT_algorithmIdentifier_algorithm,
        ___FINGERPRINT_algorithmIdentifier_parameters_tab,
        __FINGERPRINT_algorithmIdentifier_parameters,
        _FINGERPRINT_algorithmIdentifier,
        _FINGERPRINT_fingerprint,
        FINGERPRINT,
        _ALGORITHM_Type,
        _ALGORITHM_id,
        ALGORITHM,
        SupportedAlgorithms,
        SupportedCurves,
        dummyCurv,
        _Certificate_toBeSigned,
        ___Certificate_algorithmIdentifier_algorithm_tab,
        __Certificate_algorithmIdentifier_algorithm,
        ___Certificate_algorithmIdentifier_parameters_tab,
        __Certificate_algorithmIdentifier_parameters,
        _Certificate_algorithmIdentifier,
        _Certificate_signature,
        Certificate,
        _TBSCertificate_version,
        _TBSCertificate_serialNumber,
        ___TBSCertificate_signature_algorithm_tab,
        __TBSCertificate_signature_algorithm,
        ___TBSCertificate_signature_parameters_tab,
        __TBSCertificate_signature_parameters,
        _TBSCertificate_signature,
        _TBSCertificate_issuer,
        _TBSCertificate_validity,
        _TBSCertificate_subject,
        _TBSCertificate_subjectPublicKeyInfo,
        _TBSCertificate_issuerUniqueIdentifier,
        _TBSCertificate_subjectUniqueIdentifier,
        _TBSCertificate_extensions,
        TBSCertificate,
        Version,
        CertificateSerialNumber,
        _Validity_notBefore,
        _Validity_notAfter,
        Validity,
        ___SubjectPublicKeyInfo_algorithm_algorithm_tab,
        __SubjectPublicKeyInfo_algorithm_algorithm,
        ___SubjectPublicKeyInfo_algorithm_parameters_tab,
        __SubjectPublicKeyInfo_algorithm_parameters,
        _SubjectPublicKeyInfo_algorithm,
        _SubjectPublicKeyInfo_subjectPublicKey,
        SubjectPublicKeyInfo,
        PublicKey,
        _Time_utcTime,
        _Time_generalizedTime,
        Time,
        _Extensions__item_,
        Extensions,
        __Extension_extnId_tab,
        _Extension_extnId,
        _Extension_critical,
        _Extension_extnValue,
        Extension,
        der,
        ExtensionSet,
        _EXTENSION_id,
        _EXTENSION_ExtnType,
        EXTENSION,
        _Certificates_userCertificate,
        _Certificates_certificationPath,
        Certificates,
        _ForwardCertificationPath__item_,
        ForwardCertificationPath,
        _CrossCertificates__item_,
        CrossCertificates,
        _CertificationPath_userCertificate,
        __CertificationPath_theCACertificates__item_,
        _CertificationPath_theCACertificates,
        CertificationPath,
        _PkiPath__item_,
        PkiPath,
        _CertificateList_toBeSigned,
        ___CertificateList_algorithmIdentifier_algorithm_tab,
        __CertificateList_algorithmIdentifier_algorithm,
        ___CertificateList_algorithmIdentifier_parameters_tab,
        __CertificateList_algorithmIdentifier_parameters,
        _CertificateList_algorithmIdentifier,
        _CertificateList_signature,
        CertificateList,
        _CertificateListContent_version,
        ___CertificateListContent_signature_algorithm_tab,
        __CertificateListContent_signature_algorithm,
        ___CertificateListContent_signature_parameters_tab,
        __CertificateListContent_signature_parameters,
        _CertificateListContent_signature,
        _CertificateListContent_issuer,
        _CertificateListContent_thisUpdate,
        _CertificateListContent_nextUpdate,
        ___CertificateListContent_revokedCertificates__item__serialNumber,
        ___CertificateListContent_revokedCertificates__item__revocationDate,
        ___CertificateListContent_revokedCertificates__item__crlEntryExtensions,
        __CertificateListContent_revokedCertificates__item_,
        _CertificateListContent_revokedCertificates,
        _CertificateListContent_crlExtensions,
        CertificateListContent,
        _CertAVL_toBeSigned,
        ___CertAVL_algorithmIdentifier_algorithm_tab,
        __CertAVL_algorithmIdentifier_algorithm,
        ___CertAVL_algorithmIdentifier_parameters_tab,
        __CertAVL_algorithmIdentifier_parameters,
        _CertAVL_algorithmIdentifier,
        _CertAVL_signature,
        CertAVL,
        _TBSCertAVL_version,
        _TBSCertAVL_serialNumber,
        ___TBSCertAVL_signature_algorithm_tab,
        __TBSCertAVL_signature_algorithm,
        ___TBSCertAVL_signature_parameters_tab,
        __TBSCertAVL_signature_parameters,
        _TBSCertAVL_signature,
        _TBSCertAVL_issuer,
        _TBSCertAVL_constrained,
        ____TBSCertAVL_entries__item__idType_certIdentifier,
        ____TBSCertAVL_entries__item__idType_entityGroup,
        ___TBSCertAVL_entries__item__idType,
        ___TBSCertAVL_entries__item__scope,
        ___TBSCertAVL_entries__item__entryExtensions,
        __TBSCertAVL_entries__item_,
        _TBSCertAVL_entries,
        _TBSCertAVL_avlExtensions,
        TBSCertAVL,
        AvlSerialNumber,
        _PKCertIdentifier_issuerSerialNumber,
        ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm_tab,
        ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_algorithm,
        ____PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters_tab,
        ___PKCertIdentifier_fingerprintPKC_algorithmIdentifier_parameters,
        __PKCertIdentifier_fingerprintPKC_algorithmIdentifier,
        __PKCertIdentifier_fingerprintPKC_fingerprint,
        _PKCertIdentifier_fingerprintPKC,
        ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm_tab,
        ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_algorithm,
        ____PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters_tab,
        ___PKCertIdentifier_fingerprintPK_algorithmIdentifier_parameters,
        __PKCertIdentifier_fingerprintPK_algorithmIdentifier,
        __PKCertIdentifier_fingerprintPK_fingerprint,
        _PKCertIdentifier_fingerprintPK,
        PKCertIdentifier,
        _IssuerSerialNumber_issuer,
        _IssuerSerialNumber_serialNumber,
        IssuerSerialNumber,
        _ScopeRestrictions__item_,
        ScopeRestrictions,
        SCOPE_RESTRICTION,
        _ScopeRestriction_id,
        _ScopeRestriction_restriction,
        ScopeRestriction,
        protRestrict,
        _protRestrict_val_ExtnType,
        _ProtRestriction__item_,
        ProtRestriction,
        pkiUser,
        ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        __pmiUser_OptionalAttributes_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        pkiCA,
        __pmiUser_OptionalAttributes_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1,
        __pmiUser_OptionalAttributes_val_Type_2,
        __pmiUser_OptionalAttributes_val_Type_3,
        __pmiUser_OptionalAttributes_val_Type_4,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2,
        cRLDistributionPoint,
        ____pmiUser_Superclasses_MandatoryAttributes_derivation_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3,
        _____pmiUser_Superclasses_MandatoryAttributes_derivation_substrings_match_val_AssertionType,
        ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0,
        __pmiUser_OptionalAttributes_val_Type_0_0,
        cRLDistPtNameForm,
        __cRLDistPtNameForm_MandatoryAttributes_val_Type_0,
        deltaCRL,
        cpCps,
        __pmiUser_OptionalAttributes_val_Type_0_1,
        __pmiUser_OptionalAttributes_val_Type_1_0,
        pkiCertPath,
        __pmiUser_OptionalAttributes_val_Type_0_2,
        userCertificate,
        _userCertificate_val_Type,
        cACertificate,
        _cACertificate_val_Type,
        crossCertificatePair,
        _crossCertificatePair_val_Type,
        _CertificatePair_issuedToThisCA,
        _CertificatePair_issuedByThisCA,
        CertificatePair,
        certificateRevocationList,
        _certificateRevocationList_val_Type,
        eepkCertificateRevocationList,
        _eepkCertificateRevocationList_val_Type,
        authorityRevocationList,
        _authorityRevocationList_val_Type,
        deltaRevocationList,
        _deltaRevocationList_val_Type,
        supportedAlgorithms,
        _supportedAlgorithms_val_Type,
        ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm_tab,
        _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_algorithm,
        ________TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters_tab,
        _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4_parameters,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_4,
        ___SupportedAlgorithm_algorithmIdentifier_algorithm_tab,
        __SupportedAlgorithm_algorithmIdentifier_algorithm,
        ___SupportedAlgorithm_algorithmIdentifier_parameters_tab,
        __SupportedAlgorithm_algorithmIdentifier_parameters,
        _SupportedAlgorithm_algorithmIdentifier,
        _SupportedAlgorithm_intendedUsage,
        _SupportedAlgorithm_intendedCertificatePolicies,
        SupportedAlgorithm,
        certificationPracticeStmt,
        _certificationPracticeStmt_val_Type,
        _InfoSyntax_content,
        __InfoSyntax_pointer_name,
        _____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm_tab,
        ____InfoSyntax_pointer_hash_algorithmIdentifier_algorithm,
        _____InfoSyntax_pointer_hash_algorithmIdentifier_parameters_tab,
        ____InfoSyntax_pointer_hash_algorithmIdentifier_parameters,
        ___InfoSyntax_pointer_hash_algorithmIdentifier,
        ___InfoSyntax_pointer_hash_hashValue,
        __InfoSyntax_pointer_hash,
        _InfoSyntax_pointer,
        InfoSyntax,
        POLICY,
        _HashedPolicyInfo_tab,
        HashedPolicyInfo,
        Policies,
        certificatePolicy,
        _certificatePolicy_val_Type,
        _PolicySyntax_policyIdentifier,
        _PolicySyntax_policySyntax,
        PolicySyntax,
        PolicyID,
        pkiPath,
        _pkiPath_val_Type,
        userPassword,
        _userPassword_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_5,
        x509Certificate,
        _x509Certificate_val_Type,
        x509CertificateList,
        _x509CertificateList_val_Type,
        x509CertificatePair,
        _x509CertificatePair_val_Type,
        x509SupportedAlgorithm,
        _x509SupportedAlgorithm_val_Type,
        id_oc_cRLDistributionPoint,
        id_oc_pkiUser,
        id_oc_pkiCA,
        id_oc_deltaCRL,
        id_oc_cpCps,
        id_oc_pkiCertPath,
        id_nf_cRLDistPtNameForm,
        id_at_userPassword,
        id_at_userCertificate,
        id_at_cAcertificate,
        id_at_authorityRevocationList,
        id_at_certificateRevocationList,
        id_at_crossCertificatePair,
        id_at_supportedAlgorithms,
        id_at_deltaRevocationList,
        id_at_certificationPracticeStmt,
        id_at_certificatePolicy,
        id_at_pkiPath,
        id_at_eepkCertificateRevocationList,
        id_lsx_x509Certificate,
        id_lsx_x509CertificateList,
        id_lsx_x509CertificatePair,
        id_lsx_x509SupportedAlgorithm,
        id_protRestrict,
    ]

class BasicAccessControl:

    _name_  = u'BasicAccessControl'
    _oid_   = [2, 5, 1, 24, 8]
    
    _obj_ = [
        u'accessControlScheme',
        u'ACIItem',
        u'Precedence',
        u'ProtectedItems',
        u'MaxValueCount',
        u'RestrictedValue',
        u'UserClasses',
        u'ItemPermission',
        u'UserPermission',
        u'AuthenticationLevel',
        u'GrantsAndDenials',
        u'prescriptiveACI',
        u'entryACI',
        u'subentryACI',
        u'id-aca-accessControlScheme',
        u'id-aca-prescriptiveACI',
        u'id-aca-entryACI',
        u'id-aca-subentryACI',
        u'basicAccessControlScheme',
        u'simplifiedAccessControlScheme',
        u'rule-based-access-control',
        u'rule-and-basic-access-control',
        u'rule-and-simple-access-control',
        ]
    _type_ = [
        u'ACIItem',
        u'Precedence',
        u'ProtectedItems',
        u'MaxValueCount',
        u'RestrictedValue',
        u'UserClasses',
        u'ItemPermission',
        u'UserPermission',
        u'AuthenticationLevel',
        u'GrantsAndDenials',
        ]
    _set_ = [
        ]
    _val_ = [
        u'accessControlScheme',
        u'prescriptiveACI',
        u'entryACI',
        u'subentryACI',
        u'id-aca-accessControlScheme',
        u'id-aca-prescriptiveACI',
        u'id-aca-entryACI',
        u'id-aca-subentryACI',
        u'basicAccessControlScheme',
        u'simplifiedAccessControlScheme',
        u'rule-based-access-control',
        u'rule-and-basic-access-control',
        u'rule-and-simple-access-control',
        ]
    _class_ = [
        u'accessControlScheme',
        u'prescriptiveACI',
        u'entryACI',
        u'subentryACI',
        ]
    _param_ = [
        ]
    
    #-----< accessControlScheme >-----#
    accessControlScheme = CLASS(name=u'accessControlScheme', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _accessControlScheme_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    accessControlScheme._val = dict([(u'Type', _accessControlScheme_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'id', (2, 5, 24, 1))])
    
    #-----< ACIItem >-----#
    ACIItem = SEQ(name=u'ACIItem', mode=MODE_TYPE)
    _ACIItem_identificationTag = CHOICE(name=u'identificationTag', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _ACIItem_precedence = INT(name=u'precedence', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'Precedence')))
    _ACIItem_authenticationLevel = CHOICE(name=u'authenticationLevel', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'AuthenticationLevel')))
    _ACIItem_itemOrUserFirst = CHOICE(name=u'itemOrUserFirst', mode=MODE_TYPE)
    __ACIItem_itemOrUserFirst_itemFirst = SEQ(name=u'itemFirst', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___ACIItem_itemOrUserFirst_itemFirst_protectedItems = SEQ(name=u'protectedItems', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ProtectedItems')))
    ___ACIItem_itemOrUserFirst_itemFirst_itemPermissions = SET_OF(name=u'itemPermissions', mode=MODE_TYPE)
    ____ACIItem_itemOrUserFirst_itemFirst_itemPermissions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ItemPermission')))
    ___ACIItem_itemOrUserFirst_itemFirst_itemPermissions._cont = ____ACIItem_itemOrUserFirst_itemFirst_itemPermissions__item_
    __ACIItem_itemOrUserFirst_itemFirst._cont = ASN1Dict([
        (u'protectedItems', ___ACIItem_itemOrUserFirst_itemFirst_protectedItems),
        (u'itemPermissions', ___ACIItem_itemOrUserFirst_itemFirst_itemPermissions),
        ])
    __ACIItem_itemOrUserFirst_itemFirst._ext = []
    __ACIItem_itemOrUserFirst_userFirst = SEQ(name=u'userFirst', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___ACIItem_itemOrUserFirst_userFirst_userClasses = SEQ(name=u'userClasses', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'UserClasses')))
    ___ACIItem_itemOrUserFirst_userFirst_userPermissions = SET_OF(name=u'userPermissions', mode=MODE_TYPE)
    ____ACIItem_itemOrUserFirst_userFirst_userPermissions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'UserPermission')))
    ___ACIItem_itemOrUserFirst_userFirst_userPermissions._cont = ____ACIItem_itemOrUserFirst_userFirst_userPermissions__item_
    __ACIItem_itemOrUserFirst_userFirst._cont = ASN1Dict([
        (u'userClasses', ___ACIItem_itemOrUserFirst_userFirst_userClasses),
        (u'userPermissions', ___ACIItem_itemOrUserFirst_userFirst_userPermissions),
        ])
    __ACIItem_itemOrUserFirst_userFirst._ext = []
    _ACIItem_itemOrUserFirst._cont = ASN1Dict([
        (u'itemFirst', __ACIItem_itemOrUserFirst_itemFirst),
        (u'userFirst', __ACIItem_itemOrUserFirst_userFirst),
        ])
    _ACIItem_itemOrUserFirst._ext = []
    ACIItem._cont = ASN1Dict([
        (u'identificationTag', _ACIItem_identificationTag),
        (u'precedence', _ACIItem_precedence),
        (u'authenticationLevel', _ACIItem_authenticationLevel),
        (u'itemOrUserFirst', _ACIItem_itemOrUserFirst),
        ])
    ACIItem._ext = []
    
    #-----< Precedence >-----#
    Precedence = INT(name=u'Precedence', mode=MODE_TYPE)
    Precedence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=[], er=[])
    
    #-----< ProtectedItems >-----#
    ProtectedItems = SEQ(name=u'ProtectedItems', mode=MODE_TYPE)
    _ProtectedItems_entry = NULL(name=u'entry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ProtectedItems_allUserAttributeTypes = NULL(name=u'allUserAttributeTypes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ProtectedItems_attributeType = SET_OF(name=u'attributeType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_attributeType__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _ProtectedItems_attributeType._cont = __ProtectedItems_attributeType__item_
    _ProtectedItems_attributeType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_allAttributeValues = SET_OF(name=u'allAttributeValues', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_allAttributeValues__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _ProtectedItems_allAttributeValues._cont = __ProtectedItems_allAttributeValues__item_
    _ProtectedItems_allAttributeValues._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_allUserAttributeTypesAndValues = NULL(name=u'allUserAttributeTypesAndValues', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ProtectedItems_attributeValue = SET_OF(name=u'attributeValue', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_attributeValue__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    _ProtectedItems_attributeValue._cont = __ProtectedItems_attributeValue__item_
    _ProtectedItems_attributeValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_selfValue = SET_OF(name=u'selfValue', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_selfValue__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _ProtectedItems_selfValue._cont = __ProtectedItems_selfValue__item_
    _ProtectedItems_selfValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_rangeOfValues = CHOICE(name=u'rangeOfValues', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')), opt=True)
    _ProtectedItems_maxValueCount = SET_OF(name=u'maxValueCount', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_maxValueCount__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'MaxValueCount')))
    _ProtectedItems_maxValueCount._cont = __ProtectedItems_maxValueCount__item_
    _ProtectedItems_maxValueCount._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_maxImmSub = INT(name=u'maxImmSub', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ProtectedItems_restrictedBy = SET_OF(name=u'restrictedBy', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_restrictedBy__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'RestrictedValue')))
    _ProtectedItems_restrictedBy._cont = __ProtectedItems_restrictedBy__item_
    _ProtectedItems_restrictedBy._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_contexts = SET_OF(name=u'contexts', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ProtectedItems_contexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    _ProtectedItems_contexts._cont = __ProtectedItems_contexts__item_
    _ProtectedItems_contexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ProtectedItems_classes = CHOICE(name=u'classes', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Refinement')), opt=True)
    ProtectedItems._cont = ASN1Dict([
        (u'entry', _ProtectedItems_entry),
        (u'allUserAttributeTypes', _ProtectedItems_allUserAttributeTypes),
        (u'attributeType', _ProtectedItems_attributeType),
        (u'allAttributeValues', _ProtectedItems_allAttributeValues),
        (u'allUserAttributeTypesAndValues', _ProtectedItems_allUserAttributeTypesAndValues),
        (u'attributeValue', _ProtectedItems_attributeValue),
        (u'selfValue', _ProtectedItems_selfValue),
        (u'rangeOfValues', _ProtectedItems_rangeOfValues),
        (u'maxValueCount', _ProtectedItems_maxValueCount),
        (u'maxImmSub', _ProtectedItems_maxImmSub),
        (u'restrictedBy', _ProtectedItems_restrictedBy),
        (u'contexts', _ProtectedItems_contexts),
        (u'classes', _ProtectedItems_classes),
        ])
    ProtectedItems._ext = []
    
    #-----< MaxValueCount >-----#
    MaxValueCount = SEQ(name=u'MaxValueCount', mode=MODE_TYPE)
    _MaxValueCount_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _MaxValueCount_maxCount = INT(name=u'maxCount', mode=MODE_TYPE)
    MaxValueCount._cont = ASN1Dict([
        (u'type', _MaxValueCount_type),
        (u'maxCount', _MaxValueCount_maxCount),
        ])
    MaxValueCount._ext = []
    
    #-----< RestrictedValue >-----#
    RestrictedValue = SEQ(name=u'RestrictedValue', mode=MODE_TYPE)
    _RestrictedValue_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _RestrictedValue_valuesIn = OID(name=u'valuesIn', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    RestrictedValue._cont = ASN1Dict([
        (u'type', _RestrictedValue_type),
        (u'valuesIn', _RestrictedValue_valuesIn),
        ])
    RestrictedValue._ext = []
    
    #-----< UserClasses >-----#
    UserClasses = SEQ(name=u'UserClasses', mode=MODE_TYPE)
    _UserClasses_allUsers = NULL(name=u'allUsers', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _UserClasses_thisEntry = NULL(name=u'thisEntry', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _UserClasses_name = SET_OF(name=u'name', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UserClasses_name__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    _UserClasses_name._cont = __UserClasses_name__item_
    _UserClasses_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UserClasses_userGroup = SET_OF(name=u'userGroup', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UserClasses_userGroup__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    _UserClasses_userGroup._cont = __UserClasses_userGroup__item_
    _UserClasses_userGroup._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UserClasses_subtree = SET_OF(name=u'subtree', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UserClasses_subtree__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SubtreeSpecification')))
    _UserClasses_subtree._cont = __UserClasses_subtree__item_
    _UserClasses_subtree._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    UserClasses._cont = ASN1Dict([
        (u'allUsers', _UserClasses_allUsers),
        (u'thisEntry', _UserClasses_thisEntry),
        (u'name', _UserClasses_name),
        (u'userGroup', _UserClasses_userGroup),
        (u'subtree', _UserClasses_subtree),
        ])
    UserClasses._ext = []
    
    #-----< ItemPermission >-----#
    ItemPermission = SEQ(name=u'ItemPermission', mode=MODE_TYPE)
    _ItemPermission_precedence = INT(name=u'precedence', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'Precedence')), opt=True)
    _ItemPermission_userClasses = SEQ(name=u'userClasses', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'UserClasses')))
    _ItemPermission_grantsAndDenials = BIT_STR(name=u'grantsAndDenials', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'GrantsAndDenials')))
    ItemPermission._cont = ASN1Dict([
        (u'precedence', _ItemPermission_precedence),
        (u'userClasses', _ItemPermission_userClasses),
        (u'grantsAndDenials', _ItemPermission_grantsAndDenials),
        ])
    ItemPermission._ext = []
    
    #-----< UserPermission >-----#
    UserPermission = SEQ(name=u'UserPermission', mode=MODE_TYPE)
    _UserPermission_precedence = INT(name=u'precedence', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'Precedence')), opt=True)
    _UserPermission_protectedItems = SEQ(name=u'protectedItems', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ProtectedItems')))
    _UserPermission_grantsAndDenials = BIT_STR(name=u'grantsAndDenials', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'GrantsAndDenials')))
    UserPermission._cont = ASN1Dict([
        (u'precedence', _UserPermission_precedence),
        (u'protectedItems', _UserPermission_protectedItems),
        (u'grantsAndDenials', _UserPermission_grantsAndDenials),
        ])
    UserPermission._ext = []
    
    #-----< AuthenticationLevel >-----#
    AuthenticationLevel = CHOICE(name=u'AuthenticationLevel', mode=MODE_TYPE)
    _AuthenticationLevel_basicLevels = SEQ(name=u'basicLevels', mode=MODE_TYPE)
    __AuthenticationLevel_basicLevels_level = ENUM(name=u'level', mode=MODE_TYPE)
    __AuthenticationLevel_basicLevels_level._cont = ASN1Dict([(u'none', 0), (u'simple', 1), (u'strong', 2)])
    __AuthenticationLevel_basicLevels_level._ext = []
    __AuthenticationLevel_basicLevels_localQualifier = INT(name=u'localQualifier', mode=MODE_TYPE, opt=True)
    __AuthenticationLevel_basicLevels_signed = BOOL(name=u'signed', mode=MODE_TYPE, default=False)
    _AuthenticationLevel_basicLevels._cont = ASN1Dict([
        (u'level', __AuthenticationLevel_basicLevels_level),
        (u'localQualifier', __AuthenticationLevel_basicLevels_localQualifier),
        (u'signed', __AuthenticationLevel_basicLevels_signed),
        ])
    _AuthenticationLevel_basicLevels._ext = []
    _AuthenticationLevel_other = EXT(name=u'other', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    AuthenticationLevel._cont = ASN1Dict([
        (u'basicLevels', _AuthenticationLevel_basicLevels),
        (u'other', _AuthenticationLevel_other),
        ])
    AuthenticationLevel._ext = []
    
    #-----< GrantsAndDenials >-----#
    GrantsAndDenials = BIT_STR(name=u'GrantsAndDenials', mode=MODE_TYPE)
    GrantsAndDenials._cont = ASN1Dict([(u'grantAdd', 0), (u'denyAdd', 1), (u'grantDiscloseOnError', 2), (u'denyDiscloseOnError', 3), (u'grantRead', 4), (u'denyRead', 5), (u'grantRemove', 6), (u'denyRemove', 7), (u'grantBrowse', 8), (u'denyBrowse', 9), (u'grantExport', 10), (u'denyExport', 11), (u'grantImport', 12), (u'denyImport', 13), (u'grantModify', 14), (u'denyModify', 15), (u'grantRename', 16), (u'denyRename', 17), (u'grantReturnDN', 18), (u'denyReturnDN', 19), (u'grantCompare', 20), (u'denyCompare', 21), (u'grantFilterMatch', 22), (u'denyFilterMatch', 23), (u'grantInvoke', 24), (u'denyInvoke', 25)])
    
    #-----< prescriptiveACI >-----#
    prescriptiveACI = CLASS(name=u'prescriptiveACI', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _prescriptiveACI_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ACIItem')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    prescriptiveACI._val = dict([(u'Type', _prescriptiveACI_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'directoryStringFirstComponentMatch']), (u'id', (2, 5, 13, 31))])), (u'usage', u'directoryOperation'), (u'id', (2, 5, 24, 4))])
    
    #-----< entryACI >-----#
    entryACI = CLASS(name=u'entryACI', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _entryACI_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ACIItem')))
    entryACI._val = dict([(u'Type', _entryACI_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'directoryStringFirstComponentMatch']), (u'id', (2, 5, 13, 31))])), (u'usage', u'directoryOperation'), (u'id', (2, 5, 24, 5))])
    
    #-----< subentryACI >-----#
    subentryACI = CLASS(name=u'subentryACI', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _subentryACI_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('BasicAccessControl', 'ACIItem')))
    subentryACI._val = dict([(u'Type', _subentryACI_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'directoryStringFirstComponentMatch']), (u'id', (2, 5, 13, 31))])), (u'usage', u'directoryOperation'), (u'id', (2, 5, 24, 6))])
    
    #-----< id-aca-accessControlScheme >-----#
    id_aca_accessControlScheme = OID(name=u'id-aca-accessControlScheme', mode=MODE_VALUE)
    id_aca_accessControlScheme._val = (2, 5, 24, 1)
    
    #-----< id-aca-prescriptiveACI >-----#
    id_aca_prescriptiveACI = OID(name=u'id-aca-prescriptiveACI', mode=MODE_VALUE)
    id_aca_prescriptiveACI._val = (2, 5, 24, 4)
    
    #-----< id-aca-entryACI >-----#
    id_aca_entryACI = OID(name=u'id-aca-entryACI', mode=MODE_VALUE)
    id_aca_entryACI._val = (2, 5, 24, 5)
    
    #-----< id-aca-subentryACI >-----#
    id_aca_subentryACI = OID(name=u'id-aca-subentryACI', mode=MODE_VALUE)
    id_aca_subentryACI._val = (2, 5, 24, 6)
    
    #-----< basicAccessControlScheme >-----#
    basicAccessControlScheme = OID(name=u'basicAccessControlScheme', mode=MODE_VALUE)
    basicAccessControlScheme._val = (2, 5, 28, 1)
    
    #-----< simplifiedAccessControlScheme >-----#
    simplifiedAccessControlScheme = OID(name=u'simplifiedAccessControlScheme', mode=MODE_VALUE)
    simplifiedAccessControlScheme._val = (2, 5, 28, 2)
    
    #-----< rule-based-access-control >-----#
    rule_based_access_control = OID(name=u'rule-based-access-control', mode=MODE_VALUE)
    rule_based_access_control._val = (2, 5, 28, 3)
    
    #-----< rule-and-basic-access-control >-----#
    rule_and_basic_access_control = OID(name=u'rule-and-basic-access-control', mode=MODE_VALUE)
    rule_and_basic_access_control._val = (2, 5, 28, 4)
    
    #-----< rule-and-simple-access-control >-----#
    rule_and_simple_access_control = OID(name=u'rule-and-simple-access-control', mode=MODE_VALUE)
    rule_and_simple_access_control._val = (2, 5, 28, 5)
    
    _all_ = [
        accessControlScheme,
        _accessControlScheme_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        _ACIItem_identificationTag,
        _ACIItem_precedence,
        _ACIItem_authenticationLevel,
        ___ACIItem_itemOrUserFirst_itemFirst_protectedItems,
        ____ACIItem_itemOrUserFirst_itemFirst_itemPermissions__item_,
        ___ACIItem_itemOrUserFirst_itemFirst_itemPermissions,
        __ACIItem_itemOrUserFirst_itemFirst,
        ___ACIItem_itemOrUserFirst_userFirst_userClasses,
        ____ACIItem_itemOrUserFirst_userFirst_userPermissions__item_,
        ___ACIItem_itemOrUserFirst_userFirst_userPermissions,
        __ACIItem_itemOrUserFirst_userFirst,
        _ACIItem_itemOrUserFirst,
        ACIItem,
        Precedence,
        _ProtectedItems_entry,
        _ProtectedItems_allUserAttributeTypes,
        __ProtectedItems_attributeType__item_,
        _ProtectedItems_attributeType,
        __ProtectedItems_allAttributeValues__item_,
        _ProtectedItems_allAttributeValues,
        _ProtectedItems_allUserAttributeTypesAndValues,
        __ProtectedItems_attributeValue__item_,
        _ProtectedItems_attributeValue,
        __ProtectedItems_selfValue__item_,
        _ProtectedItems_selfValue,
        _ProtectedItems_rangeOfValues,
        __ProtectedItems_maxValueCount__item_,
        _ProtectedItems_maxValueCount,
        _ProtectedItems_maxImmSub,
        __ProtectedItems_restrictedBy__item_,
        _ProtectedItems_restrictedBy,
        __ProtectedItems_contexts__item_,
        _ProtectedItems_contexts,
        _ProtectedItems_classes,
        ProtectedItems,
        _MaxValueCount_type,
        _MaxValueCount_maxCount,
        MaxValueCount,
        _RestrictedValue_type,
        _RestrictedValue_valuesIn,
        RestrictedValue,
        _UserClasses_allUsers,
        _UserClasses_thisEntry,
        __UserClasses_name__item_,
        _UserClasses_name,
        __UserClasses_userGroup__item_,
        _UserClasses_userGroup,
        __UserClasses_subtree__item_,
        _UserClasses_subtree,
        UserClasses,
        _ItemPermission_precedence,
        _ItemPermission_userClasses,
        _ItemPermission_grantsAndDenials,
        ItemPermission,
        _UserPermission_precedence,
        _UserPermission_protectedItems,
        _UserPermission_grantsAndDenials,
        UserPermission,
        __AuthenticationLevel_basicLevels_level,
        __AuthenticationLevel_basicLevels_localQualifier,
        __AuthenticationLevel_basicLevels_signed,
        _AuthenticationLevel_basicLevels,
        _AuthenticationLevel_other,
        AuthenticationLevel,
        GrantsAndDenials,
        prescriptiveACI,
        _prescriptiveACI_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        entryACI,
        _entryACI_val_Type,
        subentryACI,
        _subentryACI_val_Type,
        id_aca_accessControlScheme,
        id_aca_prescriptiveACI,
        id_aca_entryACI,
        id_aca_subentryACI,
        basicAccessControlScheme,
        simplifiedAccessControlScheme,
        rule_based_access_control,
        rule_and_basic_access_control,
        rule_and_simple_access_control,
    ]

class Basic_Service_Elements:

    _name_  = u'Basic-Service-Elements'
    _oid_   = [0, 4, 0, 196, 8]
    
    _obj_ = [
        u'BasicService',
        ]
    _type_ = [
        u'BasicService',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< BasicService >-----#
    BasicService = ENUM(name=u'BasicService', mode=MODE_TYPE)
    BasicService._cont = ASN1Dict([(u'allServices', 0), (u'speech', 1), (u'unrestrictedDigitalInformation', 2), (u'audio3k1Hz', 3), (u'unrestrictedDigitalInformationWithTonesAndAnnouncements', 4), (u'multirate', 5), (u'telephony3k1Hz', 32), (u'teletex', 33), (u'telefaxGroup4Class1', 34), (u'videotexSyntaxBased', 35), (u'videotelephony', 36), (u'telefaxGroup2-3', 37), (u'telephony7kHz', 38), (u'euroFileTransfer', 39), (u'fileTransferAndAccessManagement', 40)])
    BasicService._ext = None
    
    _all_ = [
        BasicService,
    ]

class CAP_classes:

    _name_  = u'CAP-classes'
    _oid_   = [0, 4, 0, 0, 1, 3, 54, 7]
    
    _obj_ = [
        u'gsmSSF',
        u'gsmSRF',
        u'smsSSF-V3',
        u'smsSSF-V4',
        u'gprsSSF',
        u'EXTENSION',
        u'firstExtension',
        u'SupportedExtensions',
        u'PARAMETERS-BOUND',
        u'cAPSpecificBoundSet',
        ]
    _type_ = [
        u'EXTENSION',
        u'PARAMETERS-BOUND',
        ]
    _set_ = [
        u'SupportedExtensions',
        ]
    _val_ = [
        u'gsmSSF',
        u'gsmSRF',
        u'smsSSF-V3',
        u'smsSSF-V4',
        u'gprsSSF',
        u'firstExtension',
        u'cAPSpecificBoundSet',
        ]
    _class_ = [
        u'gsmSSF',
        u'gsmSRF',
        u'smsSSF-V3',
        u'smsSSF-V4',
        u'gprsSSF',
        u'EXTENSION',
        u'firstExtension',
        u'SupportedExtensions',
        u'PARAMETERS-BOUND',
        u'cAPSpecificBoundSet',
        ]
    _param_ = [
        ]
    
    #-----< gsmSSF >-----#
    gsmSSF = CLASS(name=u'gsmSSF', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID),
        (u'cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_legID),
        (u'cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        (u'callSegmentFailure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure),
        (u'bCSM-Failure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceKey),
        (u'calledPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber),
        (u'callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber),
        (u'callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysCategory),
        (u'cGEncountered', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cGEncountered),
        (u'iPSSPCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities),
        (u'locationNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber),
        (u'originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions),
        (u'highLayerCompatibility', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_highLayerCompatibility),
        (u'additionalCallingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber),
        (u'bearerCapability', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability),
        (u'eventTypeBCSM', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_eventTypeBCSM),
        (u'redirectingPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID),
        (u'redirectionInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectionInformation),
        (u'cause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier),
        (u'cug-Index', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Index),
        (u'cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Interlock),
        (u'cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess),
        (u'iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iMSI),
        (u'subscriberState', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_subscriberState),
        (u'locationInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationInformation),
        (u'ext-basicServiceCode', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_ext_basicServiceCode),
        (u'callReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callReferenceNumber),
        (u'mscAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_mscAddress),
        (u'calledPartyBCDNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber),
        (u'timeAndTimezone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone),
        (u'callForwardingSS-Pending', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending),
        (u'initialDPArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress),
        (u'correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID),
        (u'scfID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_naOliInfo),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber),
        (u'originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID),
        (u'callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode),
        (u'legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        (u'bcsmEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        (u'eventTypeBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM),
        (u'legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_legID),
        (u'miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo),
        (u'extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._cont = _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4._cont = ASN1Dict([
        (u'allCallSegments', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments),
        (u'allCallSegmentsWithExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        (u'requestedInformationTypeList', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_requestedInformationTypeList),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions),
        (u'legID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_legID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._cont = ASN1Dict([(u'unknownRequestedInfo', 1), (u'requestedInfoNotAvailable', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._ext = []
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'requestedInformationList', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList),
        (u'extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions),
        (u'legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_legID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID),
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        (u'invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_invokeID),
        (u'allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_allRequests),
        (u'callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0._cont = ASN1Dict([
        (u'problem', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem),
        (u'operation', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID),
        (u'srfConnection', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics),
        (u'partyToCharge', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_partyToCharge),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions),
        (u'aChChargingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8._cont = ASN1Dict([
        (u'destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress),
        (u'alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_alertingPattern),
        (u'originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier),
        (u'callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_callingPartysCategory),
        (u'redirectingPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID),
        (u'redirectionInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectionInformation),
        (u'genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber),
        (u'legToBeConnected', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_legToBeConnected),
        (u'cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_Interlock),
        (u'cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement),
        (u'oCSIApplicable', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_oCSIApplicable),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_naOliInfo),
        (u'bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested),
        (u'suppress-N-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppress_N_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8._ext = [u'suppress-N-CSI']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9._cont = ASN1Dict([
        (u'alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_alertingPattern),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_callingPartysCategory),
        (u'genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers),
        (u'cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_Interlock),
        (u'cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier),
        (u'suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_naOliInfo),
        (u'bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested),
        (u'suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1._cont = ASN1Dict([
        (u'legToBeReleased', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_legToBeReleased),
        (u'releaseCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2._cont = ASN1Dict([
        (u'legIDToMove', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_legIDToMove),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3._cont = ASN1Dict([
        (u'legToBeSplit', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_legToBeSplit),
        (u'newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0._cont = ASN1Dict([
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress),
        (u'none', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_none),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10._cont = ASN1Dict([
        (u'resourceAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID),
        (u'legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11._cont = ASN1Dict([
        (u'legOrCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment),
        (u'bursts', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_bursts),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics),
        (u'partyToCharge', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_partyToCharge),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13._cont = ASN1Dict([
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1._cont = ASN1Dict([
        (u'collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_collectedInfo),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden),
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1._cont = ASN1Dict([
        (u'digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14._cont = ASN1Dict([
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2._cont = ASN1Dict([
        (u'alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_alertingPattern),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_callingPartysCategory),
        (u'genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers),
        (u'cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_Interlock),
        (u'cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier),
        (u'suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_naOliInfo),
        (u'bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested),
        (u'suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15._cont = ASN1Dict([
        (u'timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timerID),
        (u'timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timervalue),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria = CHOICE(name=u'gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria = SEQ(name=u'compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria),
        (u'scfID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria),
        (u'compoundGapCriteria', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapIndicators = SEQ(name=u'gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_controlType = ENUM(name=u'controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment = CHOICE(name=u'gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration),
        (u'interval', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._ext = []
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo),
        (u'tone', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment._cont = ASN1Dict([
        (u'informationToSend', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend),
        (u'releaseCause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16._cont = ASN1Dict([
        (u'gapCriteria', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria),
        (u'gapIndicators', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapIndicators),
        (u'controlType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_controlType),
        (u'gapTreatment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17._cont = ASN1Dict([
        (u'destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions),
        (u'legToBeCreated', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_legToBeCreated),
        (u'newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment),
        (u'callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber),
        (u'callReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callReferenceNumber),
        (u'gsmSCFAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_gsmSCFAddress),
        (u'suppress-T-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_suppress_T_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0._cont = ASN1Dict([
        (u'supportedCamelPhases', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_supportedCamelPhases),
        (u'offeredCamel4Functionalities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_offeredCamel4Functionalities),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions),
        (u'releaseCallArgExtensionAllowed', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0._ext = [u'releaseCallArgExtensionAllowed']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18._cont = ASN1Dict([
        (u'correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID),
        (u'iPSSPCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID),
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19._cont = ASN1Dict([
        (u'invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_invokeID),
        (u'allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_allRequests),
        (u'callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3._cont = ASN1Dict([
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress),
        (u'none', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_none),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20._cont = ASN1Dict([
        (u'resourceAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21._cont = ASN1Dict([
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4._cont = ASN1Dict([
        (u'collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_collectedInfo),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden),
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0._cont = ASN1Dict([
        (u'digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22._cont = ASN1Dict([
        (u'timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timerID),
        (u'timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timervalue),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress),
        (u'correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID),
        (u'scfID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_naOliInfo),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber),
        (u'originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID),
        (u'callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode),
        (u'legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24._cont = ASN1Dict([
        (u'bcsmEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3._cont = ASN1Dict([
        (u'eventTypeBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM),
        (u'legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_legID),
        (u'miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_miscCallInfo),
        (u'extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._cont = _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26._cont = ASN1Dict([
        (u'allCallSegments', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments),
        (u'allCallSegmentsWithExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27._cont = ASN1Dict([
        (u'requestedInformationTypeList', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions),
        (u'legID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_legID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._ext = []
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4._cont = ASN1Dict([
        (u'requestedInformationList', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList),
        (u'extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions),
        (u'legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_legID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID),
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28._cont = ASN1Dict([
        (u'invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_invokeID),
        (u'allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_allRequests),
        (u'callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID),
        (u'srfConnection', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics),
        (u'partyToCharge', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_partyToCharge),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions),
        (u'aChChargingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30._cont = ASN1Dict([
        (u'destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress),
        (u'alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_alertingPattern),
        (u'originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier),
        (u'callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory),
        (u'redirectingPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID),
        (u'redirectionInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectionInformation),
        (u'genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber),
        (u'legToBeConnected', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_legToBeConnected),
        (u'cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_Interlock),
        (u'cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement),
        (u'oCSIApplicable', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_naOliInfo),
        (u'bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested),
        (u'suppress-N-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30._ext = [u'suppress-N-CSI']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31._cont = ASN1Dict([
        (u'alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_alertingPattern),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_callingPartysCategory),
        (u'genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers),
        (u'cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_Interlock),
        (u'cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier),
        (u'suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_naOliInfo),
        (u'bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested),
        (u'suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5._cont = ASN1Dict([
        (u'legToBeReleased', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_legToBeReleased),
        (u'releaseCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0._cont = ASN1Dict([
        (u'legIDToMove', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_legIDToMove),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0._cont = ASN1Dict([
        (u'legToBeSplit', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_legToBeSplit),
        (u'newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6._cont = ASN1Dict([
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress),
        (u'none', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32._cont = ASN1Dict([
        (u'resourceAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID),
        (u'legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33._cont = ASN1Dict([
        (u'legOrCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment),
        (u'bursts', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_bursts),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34._cont = ASN1Dict([
        (u'destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions),
        (u'legToBeCreated', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_legToBeCreated),
        (u'newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment),
        (u'callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber),
        (u'callReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber),
        (u'gsmSCFAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress),
        (u'suppress-T-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0._cont = ASN1Dict([
        (u'supportedCamelPhases', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_supportedCamelPhases),
        (u'offeredCamel4Functionalities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_offeredCamel4Functionalities),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions),
        (u'releaseCallArgExtensionAllowed', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0._ext = [u'releaseCallArgExtensionAllowed']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35._cont = ASN1Dict([
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7._cont = ASN1Dict([
        (u'collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_collectedInfo),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden),
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1._cont = ASN1Dict([
        (u'digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36._cont = ASN1Dict([
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8._cont = ASN1Dict([
        (u'alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_alertingPattern),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_callingPartysCategory),
        (u'genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers),
        (u'cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_Interlock),
        (u'cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier),
        (u'suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_naOliInfo),
        (u'bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested),
        (u'suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37._cont = ASN1Dict([
        (u'timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timerID),
        (u'timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timervalue),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID),
        (u'cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID),
        (u'cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38._cont = ASN1Dict([
        (u'callSegmentFailure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure),
        (u'bCSM-Failure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38._ext = None
    gsmSSF._val = dict([(u'Initiates', ASN1Set(rv=[dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 38))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 11))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 33))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 41))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 29))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 25))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 3))]), dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 5))])], rr=[], ev=None, er=[])), (u'Responds', ASN1Set(rv=[dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 25))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 38))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 6))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 25, 5))])
    
    #-----< gsmSRF >-----#
    gsmSRF = CLASS(name=u'gsmSRF', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39._cont = ASN1Dict([
        (u'correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_correlationID),
        (u'iPSSPCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40._cont = ASN1Dict([
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementCompleteNotification),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9._cont = ASN1Dict([
        (u'collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_collectedInfo),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_disconnectFromIPForbidden),
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2._cont = ASN1Dict([
        (u'digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_invokeID),
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41._cont = ASN1Dict([
        (u'invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_invokeID),
        (u'allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_allRequests),
        (u'callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41._ext = None
    gsmSRF._val = dict([(u'Initiates', ASN1Set(rv=[dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 43))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 13))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 25, 6))])
    
    #-----< smsSSF-V3 >-----#
    smsSSF_V3 = CLASS(name=u'smsSSF-V3', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42._cont = ASN1Dict([
        (u'serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_serviceKey),
        (u'destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber),
        (u'callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_callingPartyNumber),
        (u'eventTypeSMS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_eventTypeSMS),
        (u'iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_iMSI),
        (u'locationInformationMSC', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_locationInformationMSC),
        (u'locationInformationGPRS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_locationInformationGPRS),
        (u'sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_sMSCAddress),
        (u'timeAndTimezone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPProtocolIdentifier),
        (u'tPDataCodingScheme', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPDataCodingScheme),
        (u'tPValidityPeriod', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPValidityPeriod),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions),
        (u'smsReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_smsReferenceNumber),
        (u'mscAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_mscAddress),
        (u'sgsn-Number', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_sgsn_Number),
        (u'ms-Classmark2', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_ms_Classmark2),
        (u'gPRSMSClass', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_gPRSMSClass),
        (u'iMEI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_iMEI),
        (u'calledPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_calledPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43._cont = ASN1Dict([
        (u'callingPartysNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_callingPartysNumber),
        (u'destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber),
        (u'sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_sMSCAddress),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________44 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45._cont = ASN1Dict([
        (u'sMSEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_eventSpecificInformationSMS = CHOICE(name=u'eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6._cont = ASN1Dict([
        (u'eventTypeSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_eventTypeSMS),
        (u'eventSpecificInformationSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_eventSpecificInformationSMS),
        (u'miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_miscCallInfo),
        (u'extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46._cont = ASN1Dict([
        (u'timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_timerID),
        (u'timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_timervalue),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________47 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________47._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    smsSSF_V3._val = dict([(u'Initiates', ASN1Set(rv=[dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________44), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________47), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 20, 26, 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 25, 8))])
    
    #-----< smsSSF-V4 >-----#
    smsSSF_V4 = CLASS(name=u'smsSSF-V4', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48._cont = ASN1Dict([
        (u'serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_serviceKey),
        (u'destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber),
        (u'callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_callingPartyNumber),
        (u'eventTypeSMS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_eventTypeSMS),
        (u'iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_iMSI),
        (u'locationInformationMSC', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_locationInformationMSC),
        (u'locationInformationGPRS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_locationInformationGPRS),
        (u'sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_sMSCAddress),
        (u'timeAndTimezone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPProtocolIdentifier),
        (u'tPDataCodingScheme', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPDataCodingScheme),
        (u'tPValidityPeriod', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPValidityPeriod),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions),
        (u'smsReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_smsReferenceNumber),
        (u'mscAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_mscAddress),
        (u'sgsn-Number', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_sgsn_Number),
        (u'ms-Classmark2', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_ms_Classmark2),
        (u'gPRSMSClass', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_gPRSMSClass),
        (u'iMEI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_iMEI),
        (u'calledPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_calledPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49._cont = ASN1Dict([
        (u'callingPartysNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_callingPartysNumber),
        (u'destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber),
        (u'sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_sMSCAddress),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50._cont = ASN1Dict([
        (u'sMSEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_eventSpecificInformationSMS = CHOICE(name=u'eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7._cont = ASN1Dict([
        (u'eventTypeSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_eventTypeSMS),
        (u'eventSpecificInformationSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_eventSpecificInformationSMS),
        (u'miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_miscCallInfo),
        (u'extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51._cont = ASN1Dict([
        (u'timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_timerID),
        (u'timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_timervalue),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________52 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________52._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    smsSSF_V4._val = dict([(u'Initiates', ASN1Set(rv=[dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________44), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________52), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 25, 9))])
    
    #-----< gprsSSF >-----#
    gprsSSF = CLASS(name=u'gprsSSF', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53._cont = ASN1Dict([
        (u'serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_serviceKey),
        (u'gPRSEventType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gPRSEventType),
        (u'mSISDN', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_mSISDN),
        (u'iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_iMSI),
        (u'timeAndTimeZone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone),
        (u'gPRSMSClass', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gPRSMSClass),
        (u'endUserAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress),
        (u'qualityOfService', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_qualityOfService),
        (u'accessPointName', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_accessPointName),
        (u'routeingAreaIdentity', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_routeingAreaIdentity),
        (u'chargingID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_chargingID),
        (u'sGSNCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_sGSNCapabilities),
        (u'locationInformationGPRS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_locationInformationGPRS),
        (u'pDPInitiationType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_pDPInitiationType),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions),
        (u'gGSNAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gGSNAddress),
        (u'secondaryPDP-context', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_secondaryPDP_context),
        (u'iMEI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_iMEI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54._cont = ASN1Dict([
        (u'gPRSEvent', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8._cont = ASN1Dict([
        (u'gPRSEventType', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventType),
        (u'miscGPRSInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________55 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56._cont = ASN1Dict([
        (u'gPRSCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57._cont = ASN1Dict([
        (u'accessPointName', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57_accessPointName),
        (u'pdpID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57_pdpID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________58 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59._cont = ASN1Dict([
        (u'gprsCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60._cont = ASN1Dict([
        (u'gPRSEvent', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10._cont = ASN1Dict([
        (u'gPRSEventType', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventType),
        (u'miscGPRSInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________________61 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________________62 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________________62._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________________63 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65._cont = ASN1Dict([
        (u'gprsCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66._cont = ASN1Dict([
        (u'gPRSEvent', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11._cont = ASN1Dict([
        (u'gPRSEventType', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventType),
        (u'miscGPRSInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________________67 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________________67._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68._ext = []
    gprsSSF._val = dict([(u'Initiates', ASN1Set(rv=[dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 51))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________55), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_9), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 50))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 52))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________58), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 49))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________________61), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 55))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________________62), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________55), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_9), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________________63), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 14))])], rr=[], ev=None, er=[])), (u'Responds', ASN1Set(rv=[dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________________67), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________55), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_9), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 58))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________________63), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 15))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 25, 7))])
    
    #-----< EXTENSION >-----#
    EXTENSION = CLASS(name=u'EXTENSION', mode=MODE_TYPE)
    _EXTENSION_ExtensionType = OPEN(name=u'ExtensionType', mode=MODE_TYPE)
    _EXTENSION_criticality = ENUM(name=u'criticality', mode=MODE_VALUE, typeref=ASN1RefType(('CS2-datatypes', 'CriticalityType')), default=u'ignore')
    _EXTENSION_id = CHOICE(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    EXTENSION._cont = ASN1Dict([
        (u'ExtensionType', _EXTENSION_ExtensionType),
        (u'criticality', _EXTENSION_criticality),
        (u'id', _EXTENSION_id),
        ])
    
    #-----< firstExtension >-----#
    firstExtension = CLASS(name=u'firstExtension', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-classes', 'EXTENSION')))
    _firstExtension_val_ExtensionType = NULL(name=u'ExtensionType', mode=MODE_TYPE)
    firstExtension._val = dict([(u'ExtensionType', _firstExtension_val_ExtensionType), (u'criticality', u'ignore'), (u'id', (u'global', (0, 4, 0, 1, 2)))])
    
    #-----< SupportedExtensions >-----#
    SupportedExtensions = CLASS(name=u'SupportedExtensions', mode=MODE_SET, typeref=ASN1RefType(('CAP-classes', 'EXTENSION')))
    _SupportedExtensions_val_ExtensionType_0 = NULL(name=u'ExtensionType', mode=MODE_TYPE)
    SupportedExtensions._val = ASN1Set(rv=[dict([(u'ExtensionType', _SupportedExtensions_val_ExtensionType_0), (u'criticality', u'ignore'), (u'id', (u'global', (0, 4, 0, 1, 2)))])], rr=[], ev=[], er=[])
    
    #-----< PARAMETERS-BOUND >-----#
    PARAMETERS_BOUND = CLASS(name=u'PARAMETERS-BOUND', mode=MODE_TYPE)
    _PARAMETERS_BOUND_minAccessPointNameLength = INT(name=u'minAccessPointNameLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxAccessPointNameLength = INT(name=u'maxAccessPointNameLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minAChBillingChargingLength = INT(name=u'minAChBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxAChBillingChargingLength = INT(name=u'maxAChBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minAttributesLength = INT(name=u'minAttributesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxAttributesLength = INT(name=u'maxAttributesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxBearerCapabilityLength = INT(name=u'maxBearerCapabilityLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCalledPartyBCDNumberLength = INT(name=u'minCalledPartyBCDNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCalledPartyBCDNumberLength = INT(name=u'maxCalledPartyBCDNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCalledPartyNumberLength = INT(name=u'minCalledPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCalledPartyNumberLength = INT(name=u'maxCalledPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCallingPartyNumberLength = INT(name=u'minCallingPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCallingPartyNumberLength = INT(name=u'maxCallingPartyNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCallResultLength = INT(name=u'minCallResultLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCallResultLength = INT(name=u'maxCallResultLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCarrierLength = INT(name=u'minCarrierLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCarrierLength = INT(name=u'maxCarrierLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minCauseLength = INT(name=u'minCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxCauseLength = INT(name=u'maxCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minDigitsLength = INT(name=u'minDigitsLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxDigitsLength = INT(name=u'maxDigitsLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minFCIBillingChargingDataLength = INT(name=u'minFCIBillingChargingDataLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxFCIBillingChargingDataLength = INT(name=u'maxFCIBillingChargingDataLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minFCIBillingChargingLength = INT(name=u'minFCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxFCIBillingChargingLength = INT(name=u'maxFCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minGenericNumberLength = INT(name=u'minGenericNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxGenericNumberLength = INT(name=u'maxGenericNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minGPRSCauseLength = INT(name=u'minGPRSCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxGPRSCauseLength = INT(name=u'maxGPRSCauseLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minIPSSPCapabilitiesLength = INT(name=u'minIPSSPCapabilitiesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxIPSSPCapabilitiesLength = INT(name=u'maxIPSSPCapabilitiesLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minLocationNumberLength = INT(name=u'minLocationNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxLocationNumberLength = INT(name=u'maxLocationNumberLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minLowLayerCompatibilityLength = INT(name=u'minLowLayerCompatibilityLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxLowLayerCompatibilityLength = INT(name=u'maxLowLayerCompatibilityLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minMessageContentLength = INT(name=u'minMessageContentLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxMessageContentLength = INT(name=u'maxMessageContentLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minOriginalCalledPartyIDLength = INT(name=u'minOriginalCalledPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxOriginalCalledPartyIDLength = INT(name=u'maxOriginalCalledPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minPDPAddressLength = INT(name=u'minPDPAddressLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxPDPAddressLength = INT(name=u'maxPDPAddressLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minRedirectingPartyIDLength = INT(name=u'minRedirectingPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxRedirectingPartyIDLength = INT(name=u'maxRedirectingPartyIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minScfIDLength = INT(name=u'minScfIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxScfIDLength = INT(name=u'maxScfIDLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minSCIBillingChargingLength = INT(name=u'minSCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxSCIBillingChargingLength = INT(name=u'maxSCIBillingChargingLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_minTimeAndTimezoneLength = INT(name=u'minTimeAndTimezoneLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_maxTimeAndTimezoneLength = INT(name=u'maxTimeAndTimezoneLength', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfBCSMEvents = INT(name=u'numOfBCSMEvents', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfChangeOfPositionControlInfo = INT(name=u'numOfChangeOfPositionControlInfo', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfCSs = INT(name=u'numOfCSs', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfSMSEvents = INT(name=u'numOfSMSEvents', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfGPRSEvents = INT(name=u'numOfGPRSEvents', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfExtensions = INT(name=u'numOfExtensions', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfGenericNumbers = INT(name=u'numOfGenericNumbers', mode=MODE_VALUE)
    _PARAMETERS_BOUND_numOfMessageIDs = INT(name=u'numOfMessageIDs', mode=MODE_VALUE)
    PARAMETERS_BOUND._cont = ASN1Dict([
        (u'minAccessPointNameLength', _PARAMETERS_BOUND_minAccessPointNameLength),
        (u'maxAccessPointNameLength', _PARAMETERS_BOUND_maxAccessPointNameLength),
        (u'minAChBillingChargingLength', _PARAMETERS_BOUND_minAChBillingChargingLength),
        (u'maxAChBillingChargingLength', _PARAMETERS_BOUND_maxAChBillingChargingLength),
        (u'minAttributesLength', _PARAMETERS_BOUND_minAttributesLength),
        (u'maxAttributesLength', _PARAMETERS_BOUND_maxAttributesLength),
        (u'maxBearerCapabilityLength', _PARAMETERS_BOUND_maxBearerCapabilityLength),
        (u'minCalledPartyBCDNumberLength', _PARAMETERS_BOUND_minCalledPartyBCDNumberLength),
        (u'maxCalledPartyBCDNumberLength', _PARAMETERS_BOUND_maxCalledPartyBCDNumberLength),
        (u'minCalledPartyNumberLength', _PARAMETERS_BOUND_minCalledPartyNumberLength),
        (u'maxCalledPartyNumberLength', _PARAMETERS_BOUND_maxCalledPartyNumberLength),
        (u'minCallingPartyNumberLength', _PARAMETERS_BOUND_minCallingPartyNumberLength),
        (u'maxCallingPartyNumberLength', _PARAMETERS_BOUND_maxCallingPartyNumberLength),
        (u'minCallResultLength', _PARAMETERS_BOUND_minCallResultLength),
        (u'maxCallResultLength', _PARAMETERS_BOUND_maxCallResultLength),
        (u'minCarrierLength', _PARAMETERS_BOUND_minCarrierLength),
        (u'maxCarrierLength', _PARAMETERS_BOUND_maxCarrierLength),
        (u'minCauseLength', _PARAMETERS_BOUND_minCauseLength),
        (u'maxCauseLength', _PARAMETERS_BOUND_maxCauseLength),
        (u'minDigitsLength', _PARAMETERS_BOUND_minDigitsLength),
        (u'maxDigitsLength', _PARAMETERS_BOUND_maxDigitsLength),
        (u'minFCIBillingChargingDataLength', _PARAMETERS_BOUND_minFCIBillingChargingDataLength),
        (u'maxFCIBillingChargingDataLength', _PARAMETERS_BOUND_maxFCIBillingChargingDataLength),
        (u'minFCIBillingChargingLength', _PARAMETERS_BOUND_minFCIBillingChargingLength),
        (u'maxFCIBillingChargingLength', _PARAMETERS_BOUND_maxFCIBillingChargingLength),
        (u'minGenericNumberLength', _PARAMETERS_BOUND_minGenericNumberLength),
        (u'maxGenericNumberLength', _PARAMETERS_BOUND_maxGenericNumberLength),
        (u'minGPRSCauseLength', _PARAMETERS_BOUND_minGPRSCauseLength),
        (u'maxGPRSCauseLength', _PARAMETERS_BOUND_maxGPRSCauseLength),
        (u'minIPSSPCapabilitiesLength', _PARAMETERS_BOUND_minIPSSPCapabilitiesLength),
        (u'maxIPSSPCapabilitiesLength', _PARAMETERS_BOUND_maxIPSSPCapabilitiesLength),
        (u'minLocationNumberLength', _PARAMETERS_BOUND_minLocationNumberLength),
        (u'maxLocationNumberLength', _PARAMETERS_BOUND_maxLocationNumberLength),
        (u'minLowLayerCompatibilityLength', _PARAMETERS_BOUND_minLowLayerCompatibilityLength),
        (u'maxLowLayerCompatibilityLength', _PARAMETERS_BOUND_maxLowLayerCompatibilityLength),
        (u'minMessageContentLength', _PARAMETERS_BOUND_minMessageContentLength),
        (u'maxMessageContentLength', _PARAMETERS_BOUND_maxMessageContentLength),
        (u'minOriginalCalledPartyIDLength', _PARAMETERS_BOUND_minOriginalCalledPartyIDLength),
        (u'maxOriginalCalledPartyIDLength', _PARAMETERS_BOUND_maxOriginalCalledPartyIDLength),
        (u'minPDPAddressLength', _PARAMETERS_BOUND_minPDPAddressLength),
        (u'maxPDPAddressLength', _PARAMETERS_BOUND_maxPDPAddressLength),
        (u'minRedirectingPartyIDLength', _PARAMETERS_BOUND_minRedirectingPartyIDLength),
        (u'maxRedirectingPartyIDLength', _PARAMETERS_BOUND_maxRedirectingPartyIDLength),
        (u'minScfIDLength', _PARAMETERS_BOUND_minScfIDLength),
        (u'maxScfIDLength', _PARAMETERS_BOUND_maxScfIDLength),
        (u'minSCIBillingChargingLength', _PARAMETERS_BOUND_minSCIBillingChargingLength),
        (u'maxSCIBillingChargingLength', _PARAMETERS_BOUND_maxSCIBillingChargingLength),
        (u'minTimeAndTimezoneLength', _PARAMETERS_BOUND_minTimeAndTimezoneLength),
        (u'maxTimeAndTimezoneLength', _PARAMETERS_BOUND_maxTimeAndTimezoneLength),
        (u'numOfBCSMEvents', _PARAMETERS_BOUND_numOfBCSMEvents),
        (u'numOfChangeOfPositionControlInfo', _PARAMETERS_BOUND_numOfChangeOfPositionControlInfo),
        (u'numOfCSs', _PARAMETERS_BOUND_numOfCSs),
        (u'numOfSMSEvents', _PARAMETERS_BOUND_numOfSMSEvents),
        (u'numOfGPRSEvents', _PARAMETERS_BOUND_numOfGPRSEvents),
        (u'numOfExtensions', _PARAMETERS_BOUND_numOfExtensions),
        (u'numOfGenericNumbers', _PARAMETERS_BOUND_numOfGenericNumbers),
        (u'numOfMessageIDs', _PARAMETERS_BOUND_numOfMessageIDs),
        ])
    
    #-----< cAPSpecificBoundSet >-----#
    cAPSpecificBoundSet = CLASS(name=u'cAPSpecificBoundSet', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-classes', 'PARAMETERS-BOUND')))
    cAPSpecificBoundSet._val = dict([(u'minAccessPointNameLength', 1), (u'maxAccessPointNameLength', 100), (u'minAChBillingChargingLength', 5), (u'maxAChBillingChargingLength', 177), (u'minAttributesLength', 2), (u'maxAttributesLength', 10), (u'maxBearerCapabilityLength', 11), (u'minCalledPartyBCDNumberLength', 1), (u'maxCalledPartyBCDNumberLength', 41), (u'minCalledPartyNumberLength', 2), (u'maxCalledPartyNumberLength', 18), (u'minCallingPartyNumberLength', 2), (u'maxCallingPartyNumberLength', 10), (u'minCallResultLength', 12), (u'maxCallResultLength', 193), (u'minCarrierLength', 4), (u'maxCarrierLength', 4), (u'minCauseLength', 2), (u'maxCauseLength', 32), (u'minDigitsLength', 2), (u'maxDigitsLength', 16), (u'minFCIBillingChargingDataLength', 1), (u'maxFCIBillingChargingDataLength', 160), (u'minFCIBillingChargingLength', 5), (u'maxFCIBillingChargingLength', 225), (u'minGenericNumberLength', 3), (u'maxGenericNumberLength', 11), (u'minGPRSCauseLength', 1), (u'maxGPRSCauseLength', 1), (u'minIPSSPCapabilitiesLength', 1), (u'maxIPSSPCapabilitiesLength', 4), (u'minLocationNumberLength', 2), (u'maxLocationNumberLength', 10), (u'minLowLayerCompatibilityLength', 1), (u'maxLowLayerCompatibilityLength', 16), (u'minMessageContentLength', 1), (u'maxMessageContentLength', 127), (u'minOriginalCalledPartyIDLength', 2), (u'maxOriginalCalledPartyIDLength', 10), (u'minPDPAddressLength', 1), (u'maxPDPAddressLength', 63), (u'minRedirectingPartyIDLength', 2), (u'maxRedirectingPartyIDLength', 10), (u'minScfIDLength', 2), (u'maxScfIDLength', 25), (u'minSCIBillingChargingLength', 4), (u'maxSCIBillingChargingLength', 225), (u'minTimeAndTimezoneLength', 8), (u'maxTimeAndTimezoneLength', 8), (u'numOfBCSMEvents', 30), (u'numOfChangeOfPositionControlInfo', 10), (u'numOfCSs', 127), (u'numOfSMSEvents', 10), (u'numOfGPRSEvents', 10), (u'numOfExtensions', 10), (u'numOfGenericNumbers', 5), (u'numOfMessageIDs', 16)])
    
    _all_ = [
        gsmSSF,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysCategory,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cGEncountered,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_highLayerCompatibility,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_eventTypeBCSM,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectionInformation,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Index,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_subscriberState,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationInformation,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_ext_basicServiceCode,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_mscAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_legID,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_requestedInformationTypeList,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_legID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_legID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_partyToCharge,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_alertingPattern,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_callingPartysCategory,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectionInformation,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_legToBeConnected,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_oCSIApplicable,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppress_N_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_legToBeReleased,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_legIDToMove,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_legToBeSplit,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_none,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_bursts,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_partyToCharge,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapIndicators,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_controlType,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_legToBeCreated,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_gsmSCFAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_suppress_T_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_supportedCamelPhases,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_offeredCamel4Functionalities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_none,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_legID,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_legID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_legID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_partyToCharge,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_alertingPattern,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectionInformation,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_legToBeConnected,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_legToBeReleased,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_legIDToMove,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_legToBeSplit,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_bursts,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_legToBeCreated,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_supportedCamelPhases,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_offeredCamel4Functionalities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38,
        gsmSRF,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_iPSSPCapabilities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________39,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________40,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_9,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________41,
        smsSSF_V3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_locationInformationMSC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_locationInformationGPRS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_sMSCAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_timeAndTimezone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPShortMessageSpecificInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPProtocolIdentifier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPDataCodingScheme,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_tPValidityPeriod,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_smsReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_mscAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_sgsn_Number,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_ms_Classmark2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_gPRSMSClass,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_iMEI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42_calledPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________42,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_callingPartysNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_sMSCAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________43,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________44,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_sMSEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________45,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_eventSpecificInformationSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_6,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________46,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________47,
        smsSSF_V4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_locationInformationMSC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_locationInformationGPRS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_sMSCAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_timeAndTimezone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPShortMessageSpecificInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPProtocolIdentifier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPDataCodingScheme,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_tPValidityPeriod,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_smsReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_mscAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_sgsn_Number,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_ms_Classmark2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_gPRSMSClass,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_iMEI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48_calledPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________48,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_callingPartysNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_sMSCAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________49,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_sMSEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________50,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_eventSpecificInformationSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________51,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________52,
        gprsSSF,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_mSISDN,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_timeAndTimeZone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gPRSMSClass,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeOrganization,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPTypeNumber,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress_pDPAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_endUserAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_qualityOfService,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_accessPointName,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_routeingAreaIdentity,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_chargingID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_sGSNCapabilities,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_locationInformationGPRS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_pDPInitiationType,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_gGSNAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_secondaryPDP_context,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53_iMEI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________53,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_gPRSEvent,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________54,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_miscGPRSInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_detachSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_gPRSEventSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8_pDPID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_8,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________55,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_9,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56_gPRSCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________56,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57_accessPointName,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57_pdpID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________57,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________58,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59_gprsCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________59,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_gPRSEvent,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________60,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_miscGPRSInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_detachSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_gPRSEventSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10_pDPID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_10,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________________________________61,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________________________________62,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________________________________________63,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64_sCIGPRSBillingChargingCharacteristics,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________________________________________64,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65_gprsCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________________________________________65,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_gPRSEvent,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________________________________________66,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_miscGPRSInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_detachSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_gPRSEventSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11_pDPID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0__11,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________________________________________67,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68_sCIGPRSBillingChargingCharacteristics,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________________________________________68,
        _EXTENSION_ExtensionType,
        _EXTENSION_criticality,
        _EXTENSION_id,
        EXTENSION,
        firstExtension,
        _firstExtension_val_ExtensionType,
        SupportedExtensions,
        _SupportedExtensions_val_ExtensionType_0,
        _PARAMETERS_BOUND_minAccessPointNameLength,
        _PARAMETERS_BOUND_maxAccessPointNameLength,
        _PARAMETERS_BOUND_minAChBillingChargingLength,
        _PARAMETERS_BOUND_maxAChBillingChargingLength,
        _PARAMETERS_BOUND_minAttributesLength,
        _PARAMETERS_BOUND_maxAttributesLength,
        _PARAMETERS_BOUND_maxBearerCapabilityLength,
        _PARAMETERS_BOUND_minCalledPartyBCDNumberLength,
        _PARAMETERS_BOUND_maxCalledPartyBCDNumberLength,
        _PARAMETERS_BOUND_minCalledPartyNumberLength,
        _PARAMETERS_BOUND_maxCalledPartyNumberLength,
        _PARAMETERS_BOUND_minCallingPartyNumberLength,
        _PARAMETERS_BOUND_maxCallingPartyNumberLength,
        _PARAMETERS_BOUND_minCallResultLength,
        _PARAMETERS_BOUND_maxCallResultLength,
        _PARAMETERS_BOUND_minCarrierLength,
        _PARAMETERS_BOUND_maxCarrierLength,
        _PARAMETERS_BOUND_minCauseLength,
        _PARAMETERS_BOUND_maxCauseLength,
        _PARAMETERS_BOUND_minDigitsLength,
        _PARAMETERS_BOUND_maxDigitsLength,
        _PARAMETERS_BOUND_minFCIBillingChargingDataLength,
        _PARAMETERS_BOUND_maxFCIBillingChargingDataLength,
        _PARAMETERS_BOUND_minFCIBillingChargingLength,
        _PARAMETERS_BOUND_maxFCIBillingChargingLength,
        _PARAMETERS_BOUND_minGenericNumberLength,
        _PARAMETERS_BOUND_maxGenericNumberLength,
        _PARAMETERS_BOUND_minGPRSCauseLength,
        _PARAMETERS_BOUND_maxGPRSCauseLength,
        _PARAMETERS_BOUND_minIPSSPCapabilitiesLength,
        _PARAMETERS_BOUND_maxIPSSPCapabilitiesLength,
        _PARAMETERS_BOUND_minLocationNumberLength,
        _PARAMETERS_BOUND_maxLocationNumberLength,
        _PARAMETERS_BOUND_minLowLayerCompatibilityLength,
        _PARAMETERS_BOUND_maxLowLayerCompatibilityLength,
        _PARAMETERS_BOUND_minMessageContentLength,
        _PARAMETERS_BOUND_maxMessageContentLength,
        _PARAMETERS_BOUND_minOriginalCalledPartyIDLength,
        _PARAMETERS_BOUND_maxOriginalCalledPartyIDLength,
        _PARAMETERS_BOUND_minPDPAddressLength,
        _PARAMETERS_BOUND_maxPDPAddressLength,
        _PARAMETERS_BOUND_minRedirectingPartyIDLength,
        _PARAMETERS_BOUND_maxRedirectingPartyIDLength,
        _PARAMETERS_BOUND_minScfIDLength,
        _PARAMETERS_BOUND_maxScfIDLength,
        _PARAMETERS_BOUND_minSCIBillingChargingLength,
        _PARAMETERS_BOUND_maxSCIBillingChargingLength,
        _PARAMETERS_BOUND_minTimeAndTimezoneLength,
        _PARAMETERS_BOUND_maxTimeAndTimezoneLength,
        _PARAMETERS_BOUND_numOfBCSMEvents,
        _PARAMETERS_BOUND_numOfChangeOfPositionControlInfo,
        _PARAMETERS_BOUND_numOfCSs,
        _PARAMETERS_BOUND_numOfSMSEvents,
        _PARAMETERS_BOUND_numOfGPRSEvents,
        _PARAMETERS_BOUND_numOfExtensions,
        _PARAMETERS_BOUND_numOfGenericNumbers,
        _PARAMETERS_BOUND_numOfMessageIDs,
        PARAMETERS_BOUND,
        cAPSpecificBoundSet,
    ]

class CAP_datatypes:

    _name_  = u'CAP-datatypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 52, 7]
    
    _obj_ = [
        u'AccessPointName',
        u'AChBillingChargingCharacteristics',
        u'AChChargingAddress',
        u'AdditionalCallingPartyNumber',
        u'AlertingPattern',
        u'AOCBeforeAnswer',
        u'AOCGPRS',
        u'AOCSubsequent',
        u'AppendFreeFormatData',
        u'ApplicationTimer',
        u'AssistingSSPIPRoutingAddress',
        u'AudibleIndicator',
        u'BackwardServiceInteractionInd',
        u'BasicGapCriteria',
        u'BCSMEvent',
        u'BCSM-Failure',
        u'BearerCapability',
        u'Burst',
        u'BurstList',
        u'CAI-GSM0224',
        u'CalledPartyBCDNumber',
        u'CalledPartyNumber',
        u'CallingPartyNumber',
        u'CallResult',
        u'CallSegmentFailure',
        u'CallSegmentID',
        u'CallSegmentToCancel',
        u'CAMEL-AChBillingChargingCharacteristics',
        u'CAMEL-CallResult',
        u'CAMEL-FCIBillingChargingCharacteristics',
        u'CAMEL-FCIGPRSBillingChargingCharacteristics',
        u'CAMEL-FCISMSBillingChargingCharacteristics',
        u'CAMEL-SCIBillingChargingCharacteristics',
        u'CAMEL-SCIBillingChargingCharacteristicsAlt',
        u'CAMEL-SCIGPRSBillingChargingCharacteristics',
        u'Carrier',
        u'Cause',
        u'CGEncountered',
        u'ChangeOfPositionControlInfo',
        u'ChangeOfLocation',
        u'ChangeOfLocationAlt',
        u'ChargeIndicator',
        u'ChargeNumber',
        u'ChargingCharacteristics',
        u'ChargingResult',
        u'ChargingRollOver',
        u'CollectedDigits',
        u'CollectedInfo',
        u'ConnectedNumberTreatmentInd',
        u'ControlType',
        u'CompoundCriteria',
        u'CorrelationID',
        u'DateAndTime',
        u'DestinationRoutingAddress',
        u'Digits',
        u'DpSpecificCriteria',
        u'DpSpecificCriteriaAlt',
        u'DpSpecificInfoAlt',
        u'ElapsedTime',
        u'ElapsedTimeRollOver',
        u'EndUserAddress',
        u'ErrorTreatment',
        u'EventSpecificInformationBCSM',
        u'EventSpecificInformationSMS',
        u'EventTypeBCSM',
        u'EventTypeSMS',
        u'Extensions',
        u'ExtensionField',
        u'FCIBillingChargingCharacteristics',
        u'FCIGPRSBillingChargingCharacteristics',
        u'FCISMSBillingChargingCharacteristics',
        u'ForwardServiceInteractionInd',
        u'GapCriteria',
        u'GapIndicators',
        u'GapOnService',
        u'GapTreatment',
        u'GenericNumber',
        u'GenericNumbers',
        u'GPRS-QoS',
        u'GPRS-QoS-Extension',
        u'GPRSCause',
        u'GPRSEvent',
        u'GPRSEventSpecificInformation',
        u'GPRSEventType',
        u'InbandInfo',
        u'InformationToSend',
        u'InitiatingEntity',
        u'InitiatorOfServiceChange',
        u'InvokeID',
        u'IPRoutingAddress',
        u'IPSSPCapabilities',
        u'LegOrCallSegment',
        u'LegType',
        u'leg1',
        u'leg2',
        u'LocationInformationGPRS',
        u'LocationNumber',
        u'LowLayerCompatibility',
        u'MessageID',
        u'MetDPCriteriaList',
        u'MetDPCriterion',
        u'MetDPCriterionAlt',
        u'MidCallControlInfo',
        u'MonitorMode',
        u'MO-SMSCause',
        u'MT-SMSCause',
        u'NAOliInfo',
        u'NatureOfServiceChange',
        u'NumberOfDigits',
        u'OCSIApplicable',
        u'OriginalCalledPartyID',
        u'PDPID',
        u'PDPInitiationType',
        u'QualityOfService',
        u'ReceivingSideID',
        u'RedirectingPartyID',
        u'RequestedInformationList',
        u'RequestedInformationTypeList',
        u'RequestedInformation',
        u'RequestedInformationType',
        u'RequestedInformationValue',
        u'RPCause',
        u'ScfID',
        u'SCIBillingChargingCharacteristics',
        u'SCIGPRSBillingChargingCharacteristics',
        u'SendingSideID',
        u'ServiceInteractionIndicatorsTwo',
        u'SGSNCapabilities',
        u'SMS-AddressString',
        u'maxSMS-AddressStringLength',
        u'SMSEvent',
        u'TariffSwitchInterval',
        u'TimeAndTimezone',
        u'TimeIfNoTariffSwitch',
        u'TimeIfTariffSwitch',
        u'TimeInformation',
        u'TimerID',
        u'TimerValue',
        u'Tone',
        u'TPDataCodingScheme',
        u'TPProtocolIdentifier',
        u'TPShortMessageSpecificInfo',
        u'TPValidityPeriod',
        u'TransferredVolume',
        u'TransferredVolumeRollOver',
        u'UnavailableNetworkResource',
        u'VariablePart',
        u'numOfInfoItems',
        ]
    _type_ = [
        u'AccessPointName',
        u'AChBillingChargingCharacteristics',
        u'AChChargingAddress',
        u'AdditionalCallingPartyNumber',
        u'AlertingPattern',
        u'AOCBeforeAnswer',
        u'AOCGPRS',
        u'AOCSubsequent',
        u'AppendFreeFormatData',
        u'ApplicationTimer',
        u'AssistingSSPIPRoutingAddress',
        u'AudibleIndicator',
        u'BackwardServiceInteractionInd',
        u'BasicGapCriteria',
        u'BCSMEvent',
        u'BCSM-Failure',
        u'BearerCapability',
        u'Burst',
        u'BurstList',
        u'CAI-GSM0224',
        u'CalledPartyBCDNumber',
        u'CalledPartyNumber',
        u'CallingPartyNumber',
        u'CallResult',
        u'CallSegmentFailure',
        u'CallSegmentID',
        u'CallSegmentToCancel',
        u'CAMEL-AChBillingChargingCharacteristics',
        u'CAMEL-CallResult',
        u'CAMEL-FCIBillingChargingCharacteristics',
        u'CAMEL-FCIGPRSBillingChargingCharacteristics',
        u'CAMEL-FCISMSBillingChargingCharacteristics',
        u'CAMEL-SCIBillingChargingCharacteristics',
        u'CAMEL-SCIBillingChargingCharacteristicsAlt',
        u'CAMEL-SCIGPRSBillingChargingCharacteristics',
        u'Carrier',
        u'Cause',
        u'CGEncountered',
        u'ChangeOfPositionControlInfo',
        u'ChangeOfLocation',
        u'ChangeOfLocationAlt',
        u'ChargeIndicator',
        u'ChargeNumber',
        u'ChargingCharacteristics',
        u'ChargingResult',
        u'ChargingRollOver',
        u'CollectedDigits',
        u'CollectedInfo',
        u'ConnectedNumberTreatmentInd',
        u'ControlType',
        u'CompoundCriteria',
        u'CorrelationID',
        u'DateAndTime',
        u'DestinationRoutingAddress',
        u'Digits',
        u'DpSpecificCriteria',
        u'DpSpecificCriteriaAlt',
        u'DpSpecificInfoAlt',
        u'ElapsedTime',
        u'ElapsedTimeRollOver',
        u'EndUserAddress',
        u'ErrorTreatment',
        u'EventSpecificInformationBCSM',
        u'EventSpecificInformationSMS',
        u'EventTypeBCSM',
        u'EventTypeSMS',
        u'Extensions',
        u'ExtensionField',
        u'FCIBillingChargingCharacteristics',
        u'FCIGPRSBillingChargingCharacteristics',
        u'FCISMSBillingChargingCharacteristics',
        u'ForwardServiceInteractionInd',
        u'GapCriteria',
        u'GapIndicators',
        u'GapOnService',
        u'GapTreatment',
        u'GenericNumber',
        u'GenericNumbers',
        u'GPRS-QoS',
        u'GPRS-QoS-Extension',
        u'GPRSCause',
        u'GPRSEvent',
        u'GPRSEventSpecificInformation',
        u'GPRSEventType',
        u'InbandInfo',
        u'InformationToSend',
        u'InitiatingEntity',
        u'InitiatorOfServiceChange',
        u'InvokeID',
        u'IPRoutingAddress',
        u'IPSSPCapabilities',
        u'LegOrCallSegment',
        u'LegType',
        u'LocationInformationGPRS',
        u'LocationNumber',
        u'LowLayerCompatibility',
        u'MessageID',
        u'MetDPCriteriaList',
        u'MetDPCriterion',
        u'MetDPCriterionAlt',
        u'MidCallControlInfo',
        u'MonitorMode',
        u'MO-SMSCause',
        u'MT-SMSCause',
        u'NAOliInfo',
        u'NatureOfServiceChange',
        u'NumberOfDigits',
        u'OCSIApplicable',
        u'OriginalCalledPartyID',
        u'PDPID',
        u'PDPInitiationType',
        u'QualityOfService',
        u'ReceivingSideID',
        u'RedirectingPartyID',
        u'RequestedInformationList',
        u'RequestedInformationTypeList',
        u'RequestedInformation',
        u'RequestedInformationType',
        u'RequestedInformationValue',
        u'RPCause',
        u'ScfID',
        u'SCIBillingChargingCharacteristics',
        u'SCIGPRSBillingChargingCharacteristics',
        u'SendingSideID',
        u'ServiceInteractionIndicatorsTwo',
        u'SGSNCapabilities',
        u'SMS-AddressString',
        u'SMSEvent',
        u'TariffSwitchInterval',
        u'TimeAndTimezone',
        u'TimeIfNoTariffSwitch',
        u'TimeIfTariffSwitch',
        u'TimeInformation',
        u'TimerID',
        u'TimerValue',
        u'Tone',
        u'TPDataCodingScheme',
        u'TPProtocolIdentifier',
        u'TPShortMessageSpecificInfo',
        u'TPValidityPeriod',
        u'TransferredVolume',
        u'TransferredVolumeRollOver',
        u'UnavailableNetworkResource',
        u'VariablePart',
        ]
    _set_ = [
        ]
    _val_ = [
        u'leg1',
        u'leg2',
        u'maxSMS-AddressStringLength',
        u'numOfInfoItems',
        ]
    _class_ = [
        ]
    _param_ = [
        u'AccessPointName',
        u'AChBillingChargingCharacteristics',
        u'AChChargingAddress',
        u'AdditionalCallingPartyNumber',
        u'AssistingSSPIPRoutingAddress',
        u'BasicGapCriteria',
        u'BCSMEvent',
        u'BCSM-Failure',
        u'BearerCapability',
        u'CalledPartyBCDNumber',
        u'CalledPartyNumber',
        u'CallingPartyNumber',
        u'CallResult',
        u'CallSegmentFailure',
        u'CallSegmentID',
        u'CallSegmentToCancel',
        u'CAMEL-AChBillingChargingCharacteristics',
        u'CAMEL-CallResult',
        u'CAMEL-FCIBillingChargingCharacteristics',
        u'CAMEL-FCIGPRSBillingChargingCharacteristics',
        u'CAMEL-FCISMSBillingChargingCharacteristics',
        u'Carrier',
        u'Cause',
        u'ChangeOfPositionControlInfo',
        u'ChangeOfLocation',
        u'ChangeOfLocationAlt',
        u'ChargeNumber',
        u'CompoundCriteria',
        u'CorrelationID',
        u'DestinationRoutingAddress',
        u'Digits',
        u'DpSpecificCriteria',
        u'DpSpecificCriteriaAlt',
        u'DpSpecificInfoAlt',
        u'EndUserAddress',
        u'EventSpecificInformationBCSM',
        u'Extensions',
        u'FCIBillingChargingCharacteristics',
        u'FCIGPRSBillingChargingCharacteristics',
        u'FCISMSBillingChargingCharacteristics',
        u'GapCriteria',
        u'GapTreatment',
        u'GenericNumber',
        u'GenericNumbers',
        u'GPRSCause',
        u'GPRSEventSpecificInformation',
        u'InbandInfo',
        u'InformationToSend',
        u'IPRoutingAddress',
        u'IPSSPCapabilities',
        u'LegOrCallSegment',
        u'LocationNumber',
        u'LowLayerCompatibility',
        u'MessageID',
        u'MetDPCriteriaList',
        u'MetDPCriterion',
        u'MetDPCriterionAlt',
        u'OriginalCalledPartyID',
        u'RedirectingPartyID',
        u'RequestedInformationList',
        u'RequestedInformation',
        u'RequestedInformationValue',
        u'ScfID',
        u'SCIBillingChargingCharacteristics',
        u'SCIGPRSBillingChargingCharacteristics',
        u'TimeAndTimezone',
        u'VariablePart',
        ]
    
    #-----< AccessPointName >-----#
    AccessPointName = OCT_STR(name=u'AccessPointName', mode=MODE_TYPE, param=True)
    
    #-----< AChBillingChargingCharacteristics >-----#
    AChBillingChargingCharacteristics = OCT_STR(name=u'AChBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< AChChargingAddress >-----#
    AChChargingAddress = CHOICE(name=u'AChChargingAddress', mode=MODE_TYPE, param=True)
    
    #-----< AdditionalCallingPartyNumber >-----#
    AdditionalCallingPartyNumber = OCT_STR(name=u'AdditionalCallingPartyNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Digits')), param=True)
    
    #-----< AlertingPattern >-----#
    AlertingPattern = OCT_STR(name=u'AlertingPattern', mode=MODE_TYPE)
    AlertingPattern._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< AOCBeforeAnswer >-----#
    AOCBeforeAnswer = SEQ(name=u'AOCBeforeAnswer', mode=MODE_TYPE)
    _AOCBeforeAnswer_aOCInitial = SEQ(name=u'aOCInitial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAI-GSM0224')))
    _AOCBeforeAnswer_aOCSubsequent = SEQ(name=u'aOCSubsequent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCSubsequent')), opt=True)
    AOCBeforeAnswer._cont = ASN1Dict([
        (u'aOCInitial', _AOCBeforeAnswer_aOCInitial),
        (u'aOCSubsequent', _AOCBeforeAnswer_aOCSubsequent),
        ])
    AOCBeforeAnswer._ext = None
    
    #-----< AOCGPRS >-----#
    AOCGPRS = SEQ(name=u'AOCGPRS', mode=MODE_TYPE)
    _AOCGPRS_aOCInitial = SEQ(name=u'aOCInitial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAI-GSM0224')))
    _AOCGPRS_aOCSubsequent = SEQ(name=u'aOCSubsequent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCSubsequent')), opt=True)
    AOCGPRS._cont = ASN1Dict([
        (u'aOCInitial', _AOCGPRS_aOCInitial),
        (u'aOCSubsequent', _AOCGPRS_aOCSubsequent),
        ])
    AOCGPRS._ext = None
    
    #-----< AOCSubsequent >-----#
    AOCSubsequent = SEQ(name=u'AOCSubsequent', mode=MODE_TYPE)
    _AOCSubsequent_cAI_GSM0224 = SEQ(name=u'cAI-GSM0224', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAI-GSM0224')))
    _AOCSubsequent_tariffSwitchInterval = INT(name=u'tariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AOCSubsequent_tariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    AOCSubsequent._cont = ASN1Dict([
        (u'cAI-GSM0224', _AOCSubsequent_cAI_GSM0224),
        (u'tariffSwitchInterval', _AOCSubsequent_tariffSwitchInterval),
        ])
    AOCSubsequent._ext = None
    
    #-----< AppendFreeFormatData >-----#
    AppendFreeFormatData = ENUM(name=u'AppendFreeFormatData', mode=MODE_TYPE)
    AppendFreeFormatData._cont = ASN1Dict([(u'overwrite', 0), (u'append', 1)])
    AppendFreeFormatData._ext = None
    
    #-----< ApplicationTimer >-----#
    ApplicationTimer = INT(name=u'ApplicationTimer', mode=MODE_TYPE)
    ApplicationTimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    
    #-----< AssistingSSPIPRoutingAddress >-----#
    AssistingSSPIPRoutingAddress = OCT_STR(name=u'AssistingSSPIPRoutingAddress', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Digits')), param=True)
    
    #-----< AudibleIndicator >-----#
    AudibleIndicator = CHOICE(name=u'AudibleIndicator', mode=MODE_TYPE)
    _AudibleIndicator_tone = BOOL(name=u'tone', mode=MODE_TYPE)
    _AudibleIndicator_burstList = SEQ(name=u'burstList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BurstList')))
    AudibleIndicator._cont = ASN1Dict([
        (u'tone', _AudibleIndicator_tone),
        (u'burstList', _AudibleIndicator_burstList),
        ])
    AudibleIndicator._ext = None
    
    #-----< BackwardServiceInteractionInd >-----#
    BackwardServiceInteractionInd = SEQ(name=u'BackwardServiceInteractionInd', mode=MODE_TYPE)
    _BackwardServiceInteractionInd_conferenceTreatmentIndicator = OCT_STR(name=u'conferenceTreatmentIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BackwardServiceInteractionInd_conferenceTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _BackwardServiceInteractionInd_callCompletionTreatmentIndicator = OCT_STR(name=u'callCompletionTreatmentIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BackwardServiceInteractionInd_callCompletionTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    BackwardServiceInteractionInd._cont = ASN1Dict([
        (u'conferenceTreatmentIndicator', _BackwardServiceInteractionInd_conferenceTreatmentIndicator),
        (u'callCompletionTreatmentIndicator', _BackwardServiceInteractionInd_callCompletionTreatmentIndicator),
        ])
    BackwardServiceInteractionInd._ext = []
    
    #-----< BasicGapCriteria >-----#
    BasicGapCriteria = CHOICE(name=u'BasicGapCriteria', mode=MODE_TYPE, param=True)
    
    #-----< BCSMEvent >-----#
    BCSMEvent = SEQ(name=u'BCSMEvent', mode=MODE_TYPE, param=True)
    
    #-----< BCSM-Failure >-----#
    BCSM_Failure = SEQ(name=u'BCSM-Failure', mode=MODE_TYPE, param=True)
    
    #-----< BearerCapability >-----#
    BearerCapability = CHOICE(name=u'BearerCapability', mode=MODE_TYPE, param=True)
    
    #-----< Burst >-----#
    Burst = SEQ(name=u'Burst', mode=MODE_TYPE)
    _Burst_numberOfBursts = INT(name=u'numberOfBursts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=1)
    _Burst_numberOfBursts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _Burst_burstInterval = INT(name=u'burstInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=2)
    _Burst_burstInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1200)], ev=None, er=[])
    _Burst_numberOfTonesInBurst = INT(name=u'numberOfTonesInBurst', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=3)
    _Burst_numberOfTonesInBurst._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _Burst_toneDuration = INT(name=u'toneDuration', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=2)
    _Burst_toneDuration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    _Burst_toneInterval = INT(name=u'toneInterval', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=2)
    _Burst_toneInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    Burst._cont = ASN1Dict([
        (u'numberOfBursts', _Burst_numberOfBursts),
        (u'burstInterval', _Burst_burstInterval),
        (u'numberOfTonesInBurst', _Burst_numberOfTonesInBurst),
        (u'toneDuration', _Burst_toneDuration),
        (u'toneInterval', _Burst_toneInterval),
        ])
    Burst._ext = []
    
    #-----< BurstList >-----#
    BurstList = SEQ(name=u'BurstList', mode=MODE_TYPE)
    _BurstList_warningPeriod = INT(name=u'warningPeriod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=30)
    _BurstList_warningPeriod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1200)], ev=None, er=[])
    _BurstList_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    BurstList._cont = ASN1Dict([
        (u'warningPeriod', _BurstList_warningPeriod),
        (u'bursts', _BurstList_bursts),
        ])
    BurstList._ext = []
    
    #-----< CAI-GSM0224 >-----#
    CAI_GSM0224 = SEQ(name=u'CAI-GSM0224', mode=MODE_TYPE)
    _CAI_GSM0224_e1 = INT(name=u'e1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e2 = INT(name=u'e2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e3 = INT(name=u'e3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e4 = INT(name=u'e4', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e5 = INT(name=u'e5', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e6 = INT(name=u'e6', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e6._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _CAI_GSM0224_e7 = INT(name=u'e7', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAI_GSM0224_e7._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    CAI_GSM0224._cont = ASN1Dict([
        (u'e1', _CAI_GSM0224_e1),
        (u'e2', _CAI_GSM0224_e2),
        (u'e3', _CAI_GSM0224_e3),
        (u'e4', _CAI_GSM0224_e4),
        (u'e5', _CAI_GSM0224_e5),
        (u'e6', _CAI_GSM0224_e6),
        (u'e7', _CAI_GSM0224_e7),
        ])
    CAI_GSM0224._ext = None
    
    #-----< CalledPartyBCDNumber >-----#
    CalledPartyBCDNumber = OCT_STR(name=u'CalledPartyBCDNumber', mode=MODE_TYPE, param=True)
    
    #-----< CalledPartyNumber >-----#
    CalledPartyNumber = OCT_STR(name=u'CalledPartyNumber', mode=MODE_TYPE, param=True)
    
    #-----< CallingPartyNumber >-----#
    CallingPartyNumber = OCT_STR(name=u'CallingPartyNumber', mode=MODE_TYPE, param=True)
    
    #-----< CallResult >-----#
    CallResult = OCT_STR(name=u'CallResult', mode=MODE_TYPE, param=True)
    
    #-----< CallSegmentFailure >-----#
    CallSegmentFailure = SEQ(name=u'CallSegmentFailure', mode=MODE_TYPE, param=True)
    
    #-----< CallSegmentID >-----#
    CallSegmentID = INT(name=u'CallSegmentID', mode=MODE_TYPE, param=True)
    
    #-----< CallSegmentToCancel >-----#
    CallSegmentToCancel = SEQ(name=u'CallSegmentToCancel', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-AChBillingChargingCharacteristics >-----#
    CAMEL_AChBillingChargingCharacteristics = CHOICE(name=u'CAMEL-AChBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-CallResult >-----#
    CAMEL_CallResult = CHOICE(name=u'CAMEL-CallResult', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-FCIBillingChargingCharacteristics >-----#
    CAMEL_FCIBillingChargingCharacteristics = CHOICE(name=u'CAMEL-FCIBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-FCIGPRSBillingChargingCharacteristics >-----#
    CAMEL_FCIGPRSBillingChargingCharacteristics = SEQ(name=u'CAMEL-FCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-FCISMSBillingChargingCharacteristics >-----#
    CAMEL_FCISMSBillingChargingCharacteristics = CHOICE(name=u'CAMEL-FCISMSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< CAMEL-SCIBillingChargingCharacteristics >-----#
    CAMEL_SCIBillingChargingCharacteristics = CHOICE(name=u'CAMEL-SCIBillingChargingCharacteristics', mode=MODE_TYPE)
    _CAMEL_SCIBillingChargingCharacteristics_aOCBeforeAnswer = SEQ(name=u'aOCBeforeAnswer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCBeforeAnswer')))
    _CAMEL_SCIBillingChargingCharacteristics_aOCAfterAnswer = SEQ(name=u'aOCAfterAnswer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCSubsequent')))
    _CAMEL_SCIBillingChargingCharacteristics_aOC_extension = SEQ(name=u'aOC-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CAMEL-SCIBillingChargingCharacteristicsAlt')))
    CAMEL_SCIBillingChargingCharacteristics._cont = ASN1Dict([
        (u'aOCBeforeAnswer', _CAMEL_SCIBillingChargingCharacteristics_aOCBeforeAnswer),
        (u'aOCAfterAnswer', _CAMEL_SCIBillingChargingCharacteristics_aOCAfterAnswer),
        (u'aOC-extension', _CAMEL_SCIBillingChargingCharacteristics_aOC_extension),
        ])
    CAMEL_SCIBillingChargingCharacteristics._ext = None
    
    #-----< CAMEL-SCIBillingChargingCharacteristicsAlt >-----#
    CAMEL_SCIBillingChargingCharacteristicsAlt = SEQ(name=u'CAMEL-SCIBillingChargingCharacteristicsAlt', mode=MODE_TYPE)
    CAMEL_SCIBillingChargingCharacteristicsAlt._cont = ASN1Dict([
        ])
    CAMEL_SCIBillingChargingCharacteristicsAlt._ext = []
    
    #-----< CAMEL-SCIGPRSBillingChargingCharacteristics >-----#
    CAMEL_SCIGPRSBillingChargingCharacteristics = SEQ(name=u'CAMEL-SCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE)
    _CAMEL_SCIGPRSBillingChargingCharacteristics_aOCGPRS = SEQ(name=u'aOCGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AOCGPRS')))
    _CAMEL_SCIGPRSBillingChargingCharacteristics_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    CAMEL_SCIGPRSBillingChargingCharacteristics._cont = ASN1Dict([
        (u'aOCGPRS', _CAMEL_SCIGPRSBillingChargingCharacteristics_aOCGPRS),
        (u'pDPID', _CAMEL_SCIGPRSBillingChargingCharacteristics_pDPID),
        ])
    CAMEL_SCIGPRSBillingChargingCharacteristics._ext = []
    
    #-----< Carrier >-----#
    Carrier = OCT_STR(name=u'Carrier', mode=MODE_TYPE, param=True)
    
    #-----< Cause >-----#
    Cause = OCT_STR(name=u'Cause', mode=MODE_TYPE, param=True)
    
    #-----< CGEncountered >-----#
    CGEncountered = ENUM(name=u'CGEncountered', mode=MODE_TYPE)
    CGEncountered._cont = ASN1Dict([(u'noCGencountered', 0), (u'manualCGencountered', 1), (u'scpOverload', 2)])
    CGEncountered._ext = None
    
    #-----< ChangeOfPositionControlInfo >-----#
    ChangeOfPositionControlInfo = SEQ_OF(name=u'ChangeOfPositionControlInfo', mode=MODE_TYPE, param=True)
    
    #-----< ChangeOfLocation >-----#
    ChangeOfLocation = CHOICE(name=u'ChangeOfLocation', mode=MODE_TYPE)
    _ChangeOfLocation_cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _ChangeOfLocation_serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _ChangeOfLocation_locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _ChangeOfLocation_inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChangeOfLocation_inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChangeOfLocation_inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChangeOfLocation_changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _ChangeOfLocation_changeOfLocationAlt._cont = ASN1Dict([
        ])
    _ChangeOfLocation_changeOfLocationAlt._ext = []
    ChangeOfLocation._cont = ASN1Dict([
        (u'cellGlobalId', _ChangeOfLocation_cellGlobalId),
        (u'serviceAreaId', _ChangeOfLocation_serviceAreaId),
        (u'locationAreaId', _ChangeOfLocation_locationAreaId),
        (u'inter-SystemHandOver', _ChangeOfLocation_inter_SystemHandOver),
        (u'inter-PLMNHandOver', _ChangeOfLocation_inter_PLMNHandOver),
        (u'inter-MSCHandOver', _ChangeOfLocation_inter_MSCHandOver),
        (u'changeOfLocationAlt', _ChangeOfLocation_changeOfLocationAlt),
        ])
    ChangeOfLocation._ext = None
    
    #-----< ChangeOfLocationAlt >-----#
    ChangeOfLocationAlt = SEQ(name=u'ChangeOfLocationAlt', mode=MODE_TYPE)
    ChangeOfLocationAlt._cont = ASN1Dict([
        ])
    ChangeOfLocationAlt._ext = []
    
    #-----< ChargeIndicator >-----#
    ChargeIndicator = OCT_STR(name=u'ChargeIndicator', mode=MODE_TYPE)
    ChargeIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChargeNumber >-----#
    ChargeNumber = OCT_STR(name=u'ChargeNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), param=True)
    
    #-----< ChargingCharacteristics >-----#
    ChargingCharacteristics = CHOICE(name=u'ChargingCharacteristics', mode=MODE_TYPE)
    _ChargingCharacteristics_maxTransferredVolume = INT(name=u'maxTransferredVolume', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChargingCharacteristics_maxTransferredVolume._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4294967295)], ev=None, er=[])
    _ChargingCharacteristics_maxElapsedTime = INT(name=u'maxElapsedTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ChargingCharacteristics_maxElapsedTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    ChargingCharacteristics._cont = ASN1Dict([
        (u'maxTransferredVolume', _ChargingCharacteristics_maxTransferredVolume),
        (u'maxElapsedTime', _ChargingCharacteristics_maxElapsedTime),
        ])
    ChargingCharacteristics._ext = None
    
    #-----< ChargingResult >-----#
    ChargingResult = CHOICE(name=u'ChargingResult', mode=MODE_TYPE)
    _ChargingResult_transferredVolume = CHOICE(name=u'transferredVolume', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TransferredVolume')))
    _ChargingResult_elapsedTime = CHOICE(name=u'elapsedTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ElapsedTime')))
    ChargingResult._cont = ASN1Dict([
        (u'transferredVolume', _ChargingResult_transferredVolume),
        (u'elapsedTime', _ChargingResult_elapsedTime),
        ])
    ChargingResult._ext = None
    
    #-----< ChargingRollOver >-----#
    ChargingRollOver = CHOICE(name=u'ChargingRollOver', mode=MODE_TYPE)
    _ChargingRollOver_transferredVolumeRollOver = CHOICE(name=u'transferredVolumeRollOver', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TransferredVolumeRollOver')))
    _ChargingRollOver_elapsedTimeRollOver = CHOICE(name=u'elapsedTimeRollOver', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ElapsedTimeRollOver')))
    ChargingRollOver._cont = ASN1Dict([
        (u'transferredVolumeRollOver', _ChargingRollOver_transferredVolumeRollOver),
        (u'elapsedTimeRollOver', _ChargingRollOver_elapsedTimeRollOver),
        ])
    ChargingRollOver._ext = None
    
    #-----< CollectedDigits >-----#
    CollectedDigits = SEQ(name=u'CollectedDigits', mode=MODE_TYPE)
    _CollectedDigits_minimumNbOfDigits = INT(name=u'minimumNbOfDigits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=1)
    _CollectedDigits_minimumNbOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _CollectedDigits_maximumNbOfDigits = INT(name=u'maximumNbOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CollectedDigits_maximumNbOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _CollectedDigits_endOfReplyDigit = OCT_STR(name=u'endOfReplyDigit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_endOfReplyDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _CollectedDigits_cancelDigit = OCT_STR(name=u'cancelDigit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_cancelDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _CollectedDigits_startDigit = OCT_STR(name=u'startDigit', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_startDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _CollectedDigits_firstDigitTimeOut = INT(name=u'firstDigitTimeOut', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_firstDigitTimeOut._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _CollectedDigits_interDigitTimeOut = INT(name=u'interDigitTimeOut', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CollectedDigits_interDigitTimeOut._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _CollectedDigits_errorTreatment = ENUM(name=u'errorTreatment', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ErrorTreatment')), default=u'stdErrorAndInfo')
    _CollectedDigits_interruptableAnnInd = BOOL(name=u'interruptableAnnInd', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _CollectedDigits_voiceInformation = BOOL(name=u'voiceInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _CollectedDigits_voiceBack = BOOL(name=u'voiceBack', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    CollectedDigits._cont = ASN1Dict([
        (u'minimumNbOfDigits', _CollectedDigits_minimumNbOfDigits),
        (u'maximumNbOfDigits', _CollectedDigits_maximumNbOfDigits),
        (u'endOfReplyDigit', _CollectedDigits_endOfReplyDigit),
        (u'cancelDigit', _CollectedDigits_cancelDigit),
        (u'startDigit', _CollectedDigits_startDigit),
        (u'firstDigitTimeOut', _CollectedDigits_firstDigitTimeOut),
        (u'interDigitTimeOut', _CollectedDigits_interDigitTimeOut),
        (u'errorTreatment', _CollectedDigits_errorTreatment),
        (u'interruptableAnnInd', _CollectedDigits_interruptableAnnInd),
        (u'voiceInformation', _CollectedDigits_voiceInformation),
        (u'voiceBack', _CollectedDigits_voiceBack),
        ])
    CollectedDigits._ext = None
    
    #-----< CollectedInfo >-----#
    CollectedInfo = CHOICE(name=u'CollectedInfo', mode=MODE_TYPE)
    _CollectedInfo_collectedDigits = SEQ(name=u'collectedDigits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedDigits')))
    CollectedInfo._cont = ASN1Dict([
        (u'collectedDigits', _CollectedInfo_collectedDigits),
        ])
    CollectedInfo._ext = None
    
    #-----< ConnectedNumberTreatmentInd >-----#
    ConnectedNumberTreatmentInd = ENUM(name=u'ConnectedNumberTreatmentInd', mode=MODE_TYPE)
    ConnectedNumberTreatmentInd._cont = ASN1Dict([(u'noINImpact', 0), (u'presentationRestricted', 1), (u'presentCalledINNumber', 2), (u'presentCallINNumberRestricted', 3)])
    ConnectedNumberTreatmentInd._ext = None
    
    #-----< ControlType >-----#
    ControlType = ENUM(name=u'ControlType', mode=MODE_TYPE)
    ControlType._cont = ASN1Dict([(u'sCPOverloaded', 0), (u'manuallyInitiated', 1)])
    ControlType._ext = None
    
    #-----< CompoundCriteria >-----#
    CompoundCriteria = SEQ(name=u'CompoundCriteria', mode=MODE_TYPE, param=True)
    
    #-----< CorrelationID >-----#
    CorrelationID = OCT_STR(name=u'CorrelationID', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Digits')), param=True)
    
    #-----< DateAndTime >-----#
    DateAndTime = OCT_STR(name=u'DateAndTime', mode=MODE_TYPE)
    DateAndTime._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< DestinationRoutingAddress >-----#
    DestinationRoutingAddress = SEQ_OF(name=u'DestinationRoutingAddress', mode=MODE_TYPE, param=True)
    
    #-----< Digits >-----#
    Digits = OCT_STR(name=u'Digits', mode=MODE_TYPE, param=True)
    
    #-----< DpSpecificCriteria >-----#
    DpSpecificCriteria = CHOICE(name=u'DpSpecificCriteria', mode=MODE_TYPE, param=True)
    
    #-----< DpSpecificCriteriaAlt >-----#
    DpSpecificCriteriaAlt = SEQ(name=u'DpSpecificCriteriaAlt', mode=MODE_TYPE, param=True)
    
    #-----< DpSpecificInfoAlt >-----#
    DpSpecificInfoAlt = SEQ(name=u'DpSpecificInfoAlt', mode=MODE_TYPE, param=True)
    
    #-----< ElapsedTime >-----#
    ElapsedTime = CHOICE(name=u'ElapsedTime', mode=MODE_TYPE)
    _ElapsedTime_timeGPRSIfNoTariffSwitch = INT(name=u'timeGPRSIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ElapsedTime_timeGPRSIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86400)], ev=None, er=[])
    _ElapsedTime_timeGPRSIfTariffSwitch = SEQ(name=u'timeGPRSIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch = INT(name=u'timeGPRSSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86400)], ev=None, er=[])
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval = INT(name=u'timeGPRSTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86400)], ev=None, er=[])
    _ElapsedTime_timeGPRSIfTariffSwitch._cont = ASN1Dict([
        (u'timeGPRSSinceLastTariffSwitch', __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch),
        (u'timeGPRSTariffSwitchInterval', __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval),
        ])
    _ElapsedTime_timeGPRSIfTariffSwitch._ext = None
    ElapsedTime._cont = ASN1Dict([
        (u'timeGPRSIfNoTariffSwitch', _ElapsedTime_timeGPRSIfNoTariffSwitch),
        (u'timeGPRSIfTariffSwitch', _ElapsedTime_timeGPRSIfTariffSwitch),
        ])
    ElapsedTime._ext = None
    
    #-----< ElapsedTimeRollOver >-----#
    ElapsedTimeRollOver = CHOICE(name=u'ElapsedTimeRollOver', mode=MODE_TYPE)
    _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch = INT(name=u'rO-TimeGPRSIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch = SEQ(name=u'rO-TimeGPRSIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch = INT(name=u'rO-TimeGPRSSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval = INT(name=u'rO-TimeGPRSTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch._cont = ASN1Dict([
        (u'rO-TimeGPRSSinceLastTariffSwitch', __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch),
        (u'rO-TimeGPRSTariffSwitchInterval', __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval),
        ])
    _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch._ext = None
    ElapsedTimeRollOver._cont = ASN1Dict([
        (u'rO-TimeGPRSIfNoTariffSwitch', _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch),
        (u'rO-TimeGPRSIfTariffSwitch', _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch),
        ])
    ElapsedTimeRollOver._ext = None
    
    #-----< EndUserAddress >-----#
    EndUserAddress = SEQ(name=u'EndUserAddress', mode=MODE_TYPE, param=True)
    
    #-----< ErrorTreatment >-----#
    ErrorTreatment = ENUM(name=u'ErrorTreatment', mode=MODE_TYPE)
    ErrorTreatment._cont = ASN1Dict([(u'stdErrorAndInfo', 0), (u'help', 1), (u'repeatPrompt', 2)])
    ErrorTreatment._ext = None
    
    #-----< EventSpecificInformationBCSM >-----#
    EventSpecificInformationBCSM = CHOICE(name=u'EventSpecificInformationBCSM', mode=MODE_TYPE, param=True)
    
    #-----< EventSpecificInformationSMS >-----#
    EventSpecificInformationSMS = CHOICE(name=u'EventSpecificInformationSMS', mode=MODE_TYPE)
    _EventSpecificInformationSMS_o_smsFailureSpecificInfo = SEQ(name=u'o-smsFailureSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EventSpecificInformationSMS_o_smsFailureSpecificInfo_failureCause = ENUM(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MO-SMSCause')), opt=True)
    _EventSpecificInformationSMS_o_smsFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', __EventSpecificInformationSMS_o_smsFailureSpecificInfo_failureCause),
        ])
    _EventSpecificInformationSMS_o_smsFailureSpecificInfo._ext = []
    _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo = SEQ(name=u'o-smsSubmissionSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo._cont = ASN1Dict([
        ])
    _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo._ext = []
    _EventSpecificInformationSMS_t_smsFailureSpecificInfo = SEQ(name=u't-smsFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EventSpecificInformationSMS_t_smsFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MT-SMSCause')), opt=True)
    _EventSpecificInformationSMS_t_smsFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', __EventSpecificInformationSMS_t_smsFailureSpecificInfo_failureCause),
        ])
    _EventSpecificInformationSMS_t_smsFailureSpecificInfo._ext = []
    _EventSpecificInformationSMS_t_smsDeliverySpecificInfo = SEQ(name=u't-smsDeliverySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EventSpecificInformationSMS_t_smsDeliverySpecificInfo._cont = ASN1Dict([
        ])
    _EventSpecificInformationSMS_t_smsDeliverySpecificInfo._ext = []
    EventSpecificInformationSMS._cont = ASN1Dict([
        (u'o-smsFailureSpecificInfo', _EventSpecificInformationSMS_o_smsFailureSpecificInfo),
        (u'o-smsSubmissionSpecificInfo', _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo),
        (u't-smsFailureSpecificInfo', _EventSpecificInformationSMS_t_smsFailureSpecificInfo),
        (u't-smsDeliverySpecificInfo', _EventSpecificInformationSMS_t_smsDeliverySpecificInfo),
        ])
    EventSpecificInformationSMS._ext = None
    
    #-----< EventTypeBCSM >-----#
    EventTypeBCSM = ENUM(name=u'EventTypeBCSM', mode=MODE_TYPE)
    EventTypeBCSM._cont = ASN1Dict([(u'collectedInfo', 2), (u'analyzedInformation', 3), (u'routeSelectFailure', 4), (u'oCalledPartyBusy', 5), (u'oNoAnswer', 6), (u'oAnswer', 7), (u'oMidCall', 8), (u'oDisconnect', 9), (u'oAbandon', 10), (u'termAttemptAuthorized', 12), (u'tBusy', 13), (u'tNoAnswer', 14), (u'tAnswer', 15), (u'tMidCall', 16), (u'tDisconnect', 17), (u'tAbandon', 18), (u'oTermSeized', 19), (u'callAccepted', 27), (u'oChangeOfPosition', 50), (u'tChangeOfPosition', 51), (u'oServiceChange', 52), (u'tServiceChange', 53)])
    EventTypeBCSM._ext = [u'oServiceChange', u'tServiceChange']
    
    #-----< EventTypeSMS >-----#
    EventTypeSMS = ENUM(name=u'EventTypeSMS', mode=MODE_TYPE)
    EventTypeSMS._cont = ASN1Dict([(u'sms-CollectedInfo', 1), (u'o-smsFailure', 2), (u'o-smsSubmission', 3), (u'sms-DeliveryRequested', 11), (u't-smsFailure', 12), (u't-smsDelivery', 13)])
    EventTypeSMS._ext = None
    
    #-----< Extensions >-----#
    Extensions = SEQ_OF(name=u'Extensions', mode=MODE_TYPE, param=True)
    
    #-----< ExtensionField >-----#
    ExtensionField = SEQ(name=u'ExtensionField', mode=MODE_TYPE)
    _ExtensionField_type = CHOICE(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('CAP-classes', 'EXTENSION'), [u'id']))
    __ExtensionField_type_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('CAP-classes', 'EXTENSION')))
    ___ExtensionField_type_tab_val_ExtensionType_0 = NULL(name=u'ExtensionType', mode=MODE_TYPE)
    __ExtensionField_type_tab._val = ASN1Set(rv=[dict([(u'ExtensionType', ___ExtensionField_type_tab_val_ExtensionType_0), (u'criticality', u'ignore'), (u'id', (u'global', (0, 4, 0, 1, 2)))])], rr=[], ev=None, er=[])
    _ExtensionField_type._const_tab = __ExtensionField_type_tab
    _ExtensionField_type._const_tab_at = None
    _ExtensionField_type._const_tab_id = u'id'
    _ExtensionField_criticality = ENUM(name=u'criticality', mode=MODE_TYPE, typeref=ASN1RefType(('CS2-datatypes', 'CriticalityType')), default=u'ignore')
    _ExtensionField_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('CAP-classes', 'EXTENSION'), [u'ExtensionType']))
    _ExtensionField_value._const_tab = __ExtensionField_type_tab
    _ExtensionField_value._const_tab_at = ('..', u'type')
    _ExtensionField_value._const_tab_id = u'ExtensionType'
    ExtensionField._cont = ASN1Dict([
        (u'type', _ExtensionField_type),
        (u'criticality', _ExtensionField_criticality),
        (u'value', _ExtensionField_value),
        ])
    ExtensionField._ext = []
    
    #-----< FCIBillingChargingCharacteristics >-----#
    FCIBillingChargingCharacteristics = OCT_STR(name=u'FCIBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< FCIGPRSBillingChargingCharacteristics >-----#
    FCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'FCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< FCISMSBillingChargingCharacteristics >-----#
    FCISMSBillingChargingCharacteristics = OCT_STR(name=u'FCISMSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< ForwardServiceInteractionInd >-----#
    ForwardServiceInteractionInd = SEQ(name=u'ForwardServiceInteractionInd', mode=MODE_TYPE)
    _ForwardServiceInteractionInd_conferenceTreatmentIndicator = OCT_STR(name=u'conferenceTreatmentIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardServiceInteractionInd_conferenceTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ForwardServiceInteractionInd_callDiversionTreatmentIndicator = OCT_STR(name=u'callDiversionTreatmentIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardServiceInteractionInd_callDiversionTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ForwardServiceInteractionInd_callingPartyRestrictionIndicator = OCT_STR(name=u'callingPartyRestrictionIndicator', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardServiceInteractionInd_callingPartyRestrictionIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ForwardServiceInteractionInd._cont = ASN1Dict([
        (u'conferenceTreatmentIndicator', _ForwardServiceInteractionInd_conferenceTreatmentIndicator),
        (u'callDiversionTreatmentIndicator', _ForwardServiceInteractionInd_callDiversionTreatmentIndicator),
        (u'callingPartyRestrictionIndicator', _ForwardServiceInteractionInd_callingPartyRestrictionIndicator),
        ])
    ForwardServiceInteractionInd._ext = []
    
    #-----< GapCriteria >-----#
    GapCriteria = CHOICE(name=u'GapCriteria', mode=MODE_TYPE, param=True)
    
    #-----< GapIndicators >-----#
    GapIndicators = SEQ(name=u'GapIndicators', mode=MODE_TYPE)
    _GapIndicators_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Duration')))
    _GapIndicators_gapInterval = INT(name=u'gapInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Interval')))
    GapIndicators._cont = ASN1Dict([
        (u'duration', _GapIndicators_duration),
        (u'gapInterval', _GapIndicators_gapInterval),
        ])
    GapIndicators._ext = []
    
    #-----< GapOnService >-----#
    GapOnService = SEQ(name=u'GapOnService', mode=MODE_TYPE)
    _GapOnService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    GapOnService._cont = ASN1Dict([
        (u'serviceKey', _GapOnService_serviceKey),
        ])
    GapOnService._ext = []
    
    #-----< GapTreatment >-----#
    GapTreatment = CHOICE(name=u'GapTreatment', mode=MODE_TYPE, param=True)
    
    #-----< GenericNumber >-----#
    GenericNumber = OCT_STR(name=u'GenericNumber', mode=MODE_TYPE, param=True)
    
    #-----< GenericNumbers >-----#
    GenericNumbers = SET_OF(name=u'GenericNumbers', mode=MODE_TYPE, param=True)
    
    #-----< GPRS-QoS >-----#
    GPRS_QoS = CHOICE(name=u'GPRS-QoS', mode=MODE_TYPE)
    _GPRS_QoS_short_QoS_format = OCT_STR(name=u'short-QoS-format', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QoS-Subscribed')))
    _GPRS_QoS_long_QoS_format = OCT_STR(name=u'long-QoS-format', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')))
    GPRS_QoS._cont = ASN1Dict([
        (u'short-QoS-format', _GPRS_QoS_short_QoS_format),
        (u'long-QoS-format', _GPRS_QoS_long_QoS_format),
        ])
    GPRS_QoS._ext = None
    
    #-----< GPRS-QoS-Extension >-----#
    GPRS_QoS_Extension = SEQ(name=u'GPRS-QoS-Extension', mode=MODE_TYPE)
    _GPRS_QoS_Extension_supplement_to_long_QoS_format = OCT_STR(name=u'supplement-to-long-QoS-format', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')))
    _GPRS_QoS_Extension_additionalSupplement = OCT_STR(name=u'additionalSupplement', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    GPRS_QoS_Extension._cont = ASN1Dict([
        (u'supplement-to-long-QoS-format', _GPRS_QoS_Extension_supplement_to_long_QoS_format),
        (u'additionalSupplement', _GPRS_QoS_Extension_additionalSupplement),
        ])
    GPRS_QoS_Extension._ext = [u'additionalSupplement']
    
    #-----< GPRSCause >-----#
    GPRSCause = OCT_STR(name=u'GPRSCause', mode=MODE_TYPE, param=True)
    
    #-----< GPRSEvent >-----#
    GPRSEvent = SEQ(name=u'GPRSEvent', mode=MODE_TYPE)
    _GPRSEvent_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _GPRSEvent_monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    GPRSEvent._cont = ASN1Dict([
        (u'gPRSEventType', _GPRSEvent_gPRSEventType),
        (u'monitorMode', _GPRSEvent_monitorMode),
        ])
    GPRSEvent._ext = None
    
    #-----< GPRSEventSpecificInformation >-----#
    GPRSEventSpecificInformation = CHOICE(name=u'GPRSEventSpecificInformation', mode=MODE_TYPE, param=True)
    
    #-----< GPRSEventType >-----#
    GPRSEventType = ENUM(name=u'GPRSEventType', mode=MODE_TYPE)
    GPRSEventType._cont = ASN1Dict([(u'attach', 1), (u'attachChangeOfPosition', 2), (u'detached', 3), (u'pdp-ContextEstablishment', 11), (u'pdp-ContextEstablishmentAcknowledgement', 12), (u'disonnect', 13), (u'pdp-ContextChangeOfPosition', 14)])
    GPRSEventType._ext = None
    
    #-----< InbandInfo >-----#
    InbandInfo = SEQ(name=u'InbandInfo', mode=MODE_TYPE, param=True)
    
    #-----< InformationToSend >-----#
    InformationToSend = CHOICE(name=u'InformationToSend', mode=MODE_TYPE, param=True)
    
    #-----< InitiatingEntity >-----#
    InitiatingEntity = ENUM(name=u'InitiatingEntity', mode=MODE_TYPE)
    InitiatingEntity._cont = ASN1Dict([(u'mobileStation', 0), (u'sgsn', 1), (u'hlr', 2), (u'ggsn', 3)])
    InitiatingEntity._ext = None
    
    #-----< InitiatorOfServiceChange >-----#
    InitiatorOfServiceChange = ENUM(name=u'InitiatorOfServiceChange', mode=MODE_TYPE)
    InitiatorOfServiceChange._cont = ASN1Dict([(u'a-side', 0), (u'b-side', 1)])
    InitiatorOfServiceChange._ext = None
    
    #-----< InvokeID >-----#
    InvokeID = INT(name=u'InvokeID', mode=MODE_TYPE)
    InvokeID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    
    #-----< IPRoutingAddress >-----#
    IPRoutingAddress = OCT_STR(name=u'IPRoutingAddress', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), param=True)
    
    #-----< IPSSPCapabilities >-----#
    IPSSPCapabilities = OCT_STR(name=u'IPSSPCapabilities', mode=MODE_TYPE, param=True)
    
    #-----< LegOrCallSegment >-----#
    LegOrCallSegment = CHOICE(name=u'LegOrCallSegment', mode=MODE_TYPE, param=True)
    
    #-----< LegType >-----#
    LegType = OCT_STR(name=u'LegType', mode=MODE_TYPE)
    LegType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< leg1 >-----#
    leg1 = OCT_STR(name=u'leg1', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    leg1._val = b'\x01'
    
    #-----< leg2 >-----#
    leg2 = OCT_STR(name=u'leg2', mode=MODE_VALUE, typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    leg2._val = b'\x02'
    
    #-----< LocationInformationGPRS >-----#
    LocationInformationGPRS = SEQ(name=u'LocationInformationGPRS', mode=MODE_TYPE)
    _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI = OCT_STR(name=u'cellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=7)], ev=None, er=[])
    _LocationInformationGPRS_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _LocationInformationGPRS_geographicalInformation = OCT_STR(name=u'geographicalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformationGPRS_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformationGPRS_selectedLSAIdentity = OCT_STR(name=u'selectedLSAIdentity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')), opt=True)
    _LocationInformationGPRS_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformationGPRS_sai_Present = NULL(name=u'sai-Present', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UserCSGInformation')), opt=True)
    LocationInformationGPRS._cont = ASN1Dict([
        (u'cellGlobalIdOrServiceAreaIdOrLAI', _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI),
        (u'routeingAreaIdentity', _LocationInformationGPRS_routeingAreaIdentity),
        (u'geographicalInformation', _LocationInformationGPRS_geographicalInformation),
        (u'sgsn-Number', _LocationInformationGPRS_sgsn_Number),
        (u'selectedLSAIdentity', _LocationInformationGPRS_selectedLSAIdentity),
        (u'extensionContainer', _LocationInformationGPRS_extensionContainer),
        (u'sai-Present', _LocationInformationGPRS_sai_Present),
        (u'userCSGInformation', _LocationInformationGPRS_userCSGInformation),
        ])
    LocationInformationGPRS._ext = [u'sai-Present', u'userCSGInformation']
    
    #-----< LocationNumber >-----#
    LocationNumber = OCT_STR(name=u'LocationNumber', mode=MODE_TYPE, param=True)
    
    #-----< LowLayerCompatibility >-----#
    LowLayerCompatibility = OCT_STR(name=u'LowLayerCompatibility', mode=MODE_TYPE, param=True)
    
    #-----< MessageID >-----#
    MessageID = CHOICE(name=u'MessageID', mode=MODE_TYPE, param=True)
    
    #-----< MetDPCriteriaList >-----#
    MetDPCriteriaList = SEQ_OF(name=u'MetDPCriteriaList', mode=MODE_TYPE, param=True)
    
    #-----< MetDPCriterion >-----#
    MetDPCriterion = CHOICE(name=u'MetDPCriterion', mode=MODE_TYPE)
    _MetDPCriterion_enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _MetDPCriterion_enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _MetDPCriterion_leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _MetDPCriterion_inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MetDPCriterion_metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _MetDPCriterion_metDPCriterionAlt._cont = ASN1Dict([
        ])
    _MetDPCriterion_metDPCriterionAlt._ext = []
    MetDPCriterion._cont = ASN1Dict([
        (u'enteringCellGlobalId', _MetDPCriterion_enteringCellGlobalId),
        (u'leavingCellGlobalId', _MetDPCriterion_leavingCellGlobalId),
        (u'enteringServiceAreaId', _MetDPCriterion_enteringServiceAreaId),
        (u'leavingServiceAreaId', _MetDPCriterion_leavingServiceAreaId),
        (u'enteringLocationAreaId', _MetDPCriterion_enteringLocationAreaId),
        (u'leavingLocationAreaId', _MetDPCriterion_leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _MetDPCriterion_inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _MetDPCriterion_inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _MetDPCriterion_inter_PLMNHandOver),
        (u'inter-MSCHandOver', _MetDPCriterion_inter_MSCHandOver),
        (u'metDPCriterionAlt', _MetDPCriterion_metDPCriterionAlt),
        ])
    MetDPCriterion._ext = None
    
    #-----< MetDPCriterionAlt >-----#
    MetDPCriterionAlt = SEQ(name=u'MetDPCriterionAlt', mode=MODE_TYPE)
    MetDPCriterionAlt._cont = ASN1Dict([
        ])
    MetDPCriterionAlt._ext = []
    
    #-----< MidCallControlInfo >-----#
    MidCallControlInfo = SEQ(name=u'MidCallControlInfo', mode=MODE_TYPE)
    _MidCallControlInfo_minimumNumberOfDigits = INT(name=u'minimumNumberOfDigits', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=1)
    _MidCallControlInfo_minimumNumberOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _MidCallControlInfo_maximumNumberOfDigits = INT(name=u'maximumNumberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=30)
    _MidCallControlInfo_maximumNumberOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _MidCallControlInfo_endOfReplyDigit = OCT_STR(name=u'endOfReplyDigit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MidCallControlInfo_endOfReplyDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _MidCallControlInfo_cancelDigit = OCT_STR(name=u'cancelDigit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MidCallControlInfo_cancelDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _MidCallControlInfo_startDigit = OCT_STR(name=u'startDigit', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MidCallControlInfo_startDigit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _MidCallControlInfo_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=10)
    _MidCallControlInfo_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    MidCallControlInfo._cont = ASN1Dict([
        (u'minimumNumberOfDigits', _MidCallControlInfo_minimumNumberOfDigits),
        (u'maximumNumberOfDigits', _MidCallControlInfo_maximumNumberOfDigits),
        (u'endOfReplyDigit', _MidCallControlInfo_endOfReplyDigit),
        (u'cancelDigit', _MidCallControlInfo_cancelDigit),
        (u'startDigit', _MidCallControlInfo_startDigit),
        (u'interDigitTimeout', _MidCallControlInfo_interDigitTimeout),
        ])
    MidCallControlInfo._ext = []
    
    #-----< MonitorMode >-----#
    MonitorMode = ENUM(name=u'MonitorMode', mode=MODE_TYPE)
    MonitorMode._cont = ASN1Dict([(u'interrupted', 0), (u'notifyAndContinue', 1), (u'transparent', 2)])
    MonitorMode._ext = None
    
    #-----< MO-SMSCause >-----#
    MO_SMSCause = ENUM(name=u'MO-SMSCause', mode=MODE_TYPE)
    MO_SMSCause._cont = ASN1Dict([(u'systemFailure', 0), (u'unexpectedDataValue', 1), (u'facilityNotSupported', 2), (u'sM-DeliveryFailure', 3), (u'releaseFromRadioInterface', 4)])
    MO_SMSCause._ext = None
    
    #-----< MT-SMSCause >-----#
    MT_SMSCause = OCT_STR(name=u'MT-SMSCause', mode=MODE_TYPE)
    MT_SMSCause._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< NAOliInfo >-----#
    NAOliInfo = OCT_STR(name=u'NAOliInfo', mode=MODE_TYPE)
    NAOliInfo._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< NatureOfServiceChange >-----#
    NatureOfServiceChange = ENUM(name=u'NatureOfServiceChange', mode=MODE_TYPE)
    NatureOfServiceChange._cont = ASN1Dict([(u'userInitiated', 0), (u'networkInitiated', 1)])
    NatureOfServiceChange._ext = None
    
    #-----< NumberOfDigits >-----#
    NumberOfDigits = INT(name=u'NumberOfDigits', mode=MODE_TYPE)
    NumberOfDigits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< OCSIApplicable >-----#
    OCSIApplicable = NULL(name=u'OCSIApplicable', mode=MODE_TYPE)
    
    #-----< OriginalCalledPartyID >-----#
    OriginalCalledPartyID = OCT_STR(name=u'OriginalCalledPartyID', mode=MODE_TYPE, param=True)
    
    #-----< PDPID >-----#
    PDPID = OCT_STR(name=u'PDPID', mode=MODE_TYPE)
    PDPID._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< PDPInitiationType >-----#
    PDPInitiationType = ENUM(name=u'PDPInitiationType', mode=MODE_TYPE)
    PDPInitiationType._cont = ASN1Dict([(u'mSInitiated', 0), (u'networkInitiated', 1)])
    PDPInitiationType._ext = None
    
    #-----< QualityOfService >-----#
    QualityOfService = SEQ(name=u'QualityOfService', mode=MODE_TYPE)
    _QualityOfService_requested_QoS = CHOICE(name=u'requested-QoS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS')), opt=True)
    _QualityOfService_subscribed_QoS = CHOICE(name=u'subscribed-QoS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS')), opt=True)
    _QualityOfService_negotiated_QoS = CHOICE(name=u'negotiated-QoS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS')), opt=True)
    _QualityOfService_requested_QoS_Extension = SEQ(name=u'requested-QoS-Extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS-Extension')), opt=True)
    _QualityOfService_subscribed_QoS_Extension = SEQ(name=u'subscribed-QoS-Extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS-Extension')), opt=True)
    _QualityOfService_negotiated_QoS_Extension = SEQ(name=u'negotiated-QoS-Extension', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRS-QoS-Extension')), opt=True)
    QualityOfService._cont = ASN1Dict([
        (u'requested-QoS', _QualityOfService_requested_QoS),
        (u'subscribed-QoS', _QualityOfService_subscribed_QoS),
        (u'negotiated-QoS', _QualityOfService_negotiated_QoS),
        (u'requested-QoS-Extension', _QualityOfService_requested_QoS_Extension),
        (u'subscribed-QoS-Extension', _QualityOfService_subscribed_QoS_Extension),
        (u'negotiated-QoS-Extension', _QualityOfService_negotiated_QoS_Extension),
        ])
    QualityOfService._ext = [u'requested-QoS-Extension', u'subscribed-QoS-Extension', u'negotiated-QoS-Extension']
    
    #-----< ReceivingSideID >-----#
    ReceivingSideID = CHOICE(name=u'ReceivingSideID', mode=MODE_TYPE)
    _ReceivingSideID_receivingSideID = OCT_STR(name=u'receivingSideID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    ReceivingSideID._cont = ASN1Dict([
        (u'receivingSideID', _ReceivingSideID_receivingSideID),
        ])
    ReceivingSideID._ext = None
    
    #-----< RedirectingPartyID >-----#
    RedirectingPartyID = OCT_STR(name=u'RedirectingPartyID', mode=MODE_TYPE, param=True)
    
    #-----< RequestedInformationList >-----#
    RequestedInformationList = SEQ_OF(name=u'RequestedInformationList', mode=MODE_TYPE, param=True)
    
    #-----< RequestedInformationTypeList >-----#
    RequestedInformationTypeList = SEQ_OF(name=u'RequestedInformationTypeList', mode=MODE_TYPE)
    _RequestedInformationTypeList__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    RequestedInformationTypeList._cont = _RequestedInformationTypeList__item_
    RequestedInformationTypeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< RequestedInformation >-----#
    RequestedInformation = SEQ(name=u'RequestedInformation', mode=MODE_TYPE, param=True)
    
    #-----< RequestedInformationType >-----#
    RequestedInformationType = ENUM(name=u'RequestedInformationType', mode=MODE_TYPE)
    RequestedInformationType._cont = ASN1Dict([(u'callAttemptElapsedTime', 0), (u'callStopTime', 1), (u'callConnectedElapsedTime', 2), (u'releaseCause', 30)])
    RequestedInformationType._ext = None
    
    #-----< RequestedInformationValue >-----#
    RequestedInformationValue = CHOICE(name=u'RequestedInformationValue', mode=MODE_TYPE, param=True)
    
    #-----< RPCause >-----#
    RPCause = OCT_STR(name=u'RPCause', mode=MODE_TYPE)
    RPCause._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ScfID >-----#
    ScfID = OCT_STR(name=u'ScfID', mode=MODE_TYPE, param=True)
    
    #-----< SCIBillingChargingCharacteristics >-----#
    SCIBillingChargingCharacteristics = OCT_STR(name=u'SCIBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< SCIGPRSBillingChargingCharacteristics >-----#
    SCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'SCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, param=True)
    
    #-----< SendingSideID >-----#
    SendingSideID = CHOICE(name=u'SendingSideID', mode=MODE_TYPE)
    _SendingSideID_sendingSideID = OCT_STR(name=u'sendingSideID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegType')))
    SendingSideID._cont = ASN1Dict([
        (u'sendingSideID', _SendingSideID_sendingSideID),
        ])
    SendingSideID._ext = None
    
    #-----< ServiceInteractionIndicatorsTwo >-----#
    ServiceInteractionIndicatorsTwo = SEQ(name=u'ServiceInteractionIndicatorsTwo', mode=MODE_TYPE)
    _ServiceInteractionIndicatorsTwo_forwardServiceInteractionInd = SEQ(name=u'forwardServiceInteractionInd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ForwardServiceInteractionInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_backwardServiceInteractionInd = SEQ(name=u'backwardServiceInteractionInd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BackwardServiceInteractionInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_bothwayThroughConnectionInd = ENUM(name=u'bothwayThroughConnectionInd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'BothwayThroughConnectionInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_connectedNumberTreatmentInd = ENUM(name=u'connectedNumberTreatmentInd', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ConnectedNumberTreatmentInd')), opt=True)
    _ServiceInteractionIndicatorsTwo_nonCUGCall = NULL(name=u'nonCUGCall', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator = OCT_STR(name=u'holdTreatmentIndicator', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator = OCT_STR(name=u'cwTreatmentIndicator', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator = OCT_STR(name=u'ectTreatmentIndicator', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ServiceInteractionIndicatorsTwo._cont = ASN1Dict([
        (u'forwardServiceInteractionInd', _ServiceInteractionIndicatorsTwo_forwardServiceInteractionInd),
        (u'backwardServiceInteractionInd', _ServiceInteractionIndicatorsTwo_backwardServiceInteractionInd),
        (u'bothwayThroughConnectionInd', _ServiceInteractionIndicatorsTwo_bothwayThroughConnectionInd),
        (u'connectedNumberTreatmentInd', _ServiceInteractionIndicatorsTwo_connectedNumberTreatmentInd),
        (u'nonCUGCall', _ServiceInteractionIndicatorsTwo_nonCUGCall),
        (u'holdTreatmentIndicator', _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator),
        (u'cwTreatmentIndicator', _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator),
        (u'ectTreatmentIndicator', _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator),
        ])
    ServiceInteractionIndicatorsTwo._ext = []
    
    #-----< SGSNCapabilities >-----#
    SGSNCapabilities = OCT_STR(name=u'SGSNCapabilities', mode=MODE_TYPE)
    SGSNCapabilities._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SMS-AddressString >-----#
    SMS_AddressString = OCT_STR(name=u'SMS-AddressString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    SMS_AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=11)], ev=None, er=[])
    
    #-----< maxSMS-AddressStringLength >-----#
    maxSMS_AddressStringLength = INT(name=u'maxSMS-AddressStringLength', mode=MODE_VALUE)
    maxSMS_AddressStringLength._val = 11
    
    #-----< SMSEvent >-----#
    SMSEvent = SEQ(name=u'SMSEvent', mode=MODE_TYPE)
    _SMSEvent_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _SMSEvent_monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    SMSEvent._cont = ASN1Dict([
        (u'eventTypeSMS', _SMSEvent_eventTypeSMS),
        (u'monitorMode', _SMSEvent_monitorMode),
        ])
    SMSEvent._ext = None
    
    #-----< TariffSwitchInterval >-----#
    TariffSwitchInterval = INT(name=u'TariffSwitchInterval', mode=MODE_TYPE)
    TariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    
    #-----< TimeAndTimezone >-----#
    TimeAndTimezone = OCT_STR(name=u'TimeAndTimezone', mode=MODE_TYPE, param=True)
    
    #-----< TimeIfNoTariffSwitch >-----#
    TimeIfNoTariffSwitch = INT(name=u'TimeIfNoTariffSwitch', mode=MODE_TYPE)
    TimeIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=864000)], ev=None, er=[])
    
    #-----< TimeIfTariffSwitch >-----#
    TimeIfTariffSwitch = SEQ(name=u'TimeIfTariffSwitch', mode=MODE_TYPE)
    _TimeIfTariffSwitch_timeSinceTariffSwitch = INT(name=u'timeSinceTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeIfTariffSwitch_timeSinceTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=864000)], ev=None, er=[])
    _TimeIfTariffSwitch_tariffSwitchInterval = INT(name=u'tariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TimeIfTariffSwitch_tariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=864000)], ev=None, er=[])
    TimeIfTariffSwitch._cont = ASN1Dict([
        (u'timeSinceTariffSwitch', _TimeIfTariffSwitch_timeSinceTariffSwitch),
        (u'tariffSwitchInterval', _TimeIfTariffSwitch_tariffSwitchInterval),
        ])
    TimeIfTariffSwitch._ext = None
    
    #-----< TimeInformation >-----#
    TimeInformation = CHOICE(name=u'TimeInformation', mode=MODE_TYPE)
    _TimeInformation_timeIfNoTariffSwitch = INT(name=u'timeIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeIfNoTariffSwitch')))
    _TimeInformation_timeIfTariffSwitch = SEQ(name=u'timeIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeIfTariffSwitch')))
    TimeInformation._cont = ASN1Dict([
        (u'timeIfNoTariffSwitch', _TimeInformation_timeIfNoTariffSwitch),
        (u'timeIfTariffSwitch', _TimeInformation_timeIfTariffSwitch),
        ])
    TimeInformation._ext = None
    
    #-----< TimerID >-----#
    TimerID = ENUM(name=u'TimerID', mode=MODE_TYPE)
    TimerID._cont = ASN1Dict([(u'tssf', 0)])
    TimerID._ext = None
    
    #-----< TimerValue >-----#
    TimerValue = INT(name=u'TimerValue', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    
    #-----< Tone >-----#
    Tone = SEQ(name=u'Tone', mode=MODE_TYPE)
    _Tone_toneID = INT(name=u'toneID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _Tone_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')), opt=True)
    Tone._cont = ASN1Dict([
        (u'toneID', _Tone_toneID),
        (u'duration', _Tone_duration),
        ])
    Tone._ext = []
    
    #-----< TPDataCodingScheme >-----#
    TPDataCodingScheme = OCT_STR(name=u'TPDataCodingScheme', mode=MODE_TYPE)
    TPDataCodingScheme._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TPProtocolIdentifier >-----#
    TPProtocolIdentifier = OCT_STR(name=u'TPProtocolIdentifier', mode=MODE_TYPE)
    TPProtocolIdentifier._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TPShortMessageSpecificInfo >-----#
    TPShortMessageSpecificInfo = OCT_STR(name=u'TPShortMessageSpecificInfo', mode=MODE_TYPE)
    TPShortMessageSpecificInfo._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TPValidityPeriod >-----#
    TPValidityPeriod = OCT_STR(name=u'TPValidityPeriod', mode=MODE_TYPE)
    TPValidityPeriod._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< TransferredVolume >-----#
    TransferredVolume = CHOICE(name=u'TransferredVolume', mode=MODE_TYPE)
    _TransferredVolume_volumeIfNoTariffSwitch = INT(name=u'volumeIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransferredVolume_volumeIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _TransferredVolume_volumeIfTariffSwitch = SEQ(name=u'volumeIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch = INT(name=u'volumeSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval = INT(name=u'volumeTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _TransferredVolume_volumeIfTariffSwitch._cont = ASN1Dict([
        (u'volumeSinceLastTariffSwitch', __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch),
        (u'volumeTariffSwitchInterval', __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval),
        ])
    _TransferredVolume_volumeIfTariffSwitch._ext = None
    TransferredVolume._cont = ASN1Dict([
        (u'volumeIfNoTariffSwitch', _TransferredVolume_volumeIfNoTariffSwitch),
        (u'volumeIfTariffSwitch', _TransferredVolume_volumeIfTariffSwitch),
        ])
    TransferredVolume._ext = None
    
    #-----< TransferredVolumeRollOver >-----#
    TransferredVolumeRollOver = CHOICE(name=u'TransferredVolumeRollOver', mode=MODE_TYPE)
    _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch = INT(name=u'rO-VolumeIfNoTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch = SEQ(name=u'rO-VolumeIfTariffSwitch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch = INT(name=u'rO-VolumeSinceLastTariffSwitch', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval = INT(name=u'rO-VolumeTariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch._cont = ASN1Dict([
        (u'rO-VolumeSinceLastTariffSwitch', __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch),
        (u'rO-VolumeTariffSwitchInterval', __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval),
        ])
    _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch._ext = None
    TransferredVolumeRollOver._cont = ASN1Dict([
        (u'rO-VolumeIfNoTariffSwitch', _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch),
        (u'rO-VolumeIfTariffSwitch', _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch),
        ])
    TransferredVolumeRollOver._ext = None
    
    #-----< UnavailableNetworkResource >-----#
    UnavailableNetworkResource = ENUM(name=u'UnavailableNetworkResource', mode=MODE_TYPE)
    UnavailableNetworkResource._cont = ASN1Dict([(u'unavailableResources', 0), (u'componentFailure', 1), (u'basicCallProcessingException', 2), (u'resourceStatusFailure', 3), (u'endUserFailure', 4)])
    UnavailableNetworkResource._ext = None
    
    #-----< VariablePart >-----#
    VariablePart = CHOICE(name=u'VariablePart', mode=MODE_TYPE, param=True)
    
    #-----< numOfInfoItems >-----#
    numOfInfoItems = INT(name=u'numOfInfoItems', mode=MODE_VALUE)
    numOfInfoItems._val = 4
    
    _all_ = [
        AlertingPattern,
        _AOCBeforeAnswer_aOCInitial,
        _AOCBeforeAnswer_aOCSubsequent,
        AOCBeforeAnswer,
        _AOCGPRS_aOCInitial,
        _AOCGPRS_aOCSubsequent,
        AOCGPRS,
        _AOCSubsequent_cAI_GSM0224,
        _AOCSubsequent_tariffSwitchInterval,
        AOCSubsequent,
        AppendFreeFormatData,
        ApplicationTimer,
        _AudibleIndicator_tone,
        _AudibleIndicator_burstList,
        AudibleIndicator,
        _BackwardServiceInteractionInd_conferenceTreatmentIndicator,
        _BackwardServiceInteractionInd_callCompletionTreatmentIndicator,
        BackwardServiceInteractionInd,
        _Burst_numberOfBursts,
        _Burst_burstInterval,
        _Burst_numberOfTonesInBurst,
        _Burst_toneDuration,
        _Burst_toneInterval,
        Burst,
        _BurstList_warningPeriod,
        _BurstList_bursts,
        BurstList,
        _CAI_GSM0224_e1,
        _CAI_GSM0224_e2,
        _CAI_GSM0224_e3,
        _CAI_GSM0224_e4,
        _CAI_GSM0224_e5,
        _CAI_GSM0224_e6,
        _CAI_GSM0224_e7,
        CAI_GSM0224,
        _CAMEL_SCIBillingChargingCharacteristics_aOCBeforeAnswer,
        _CAMEL_SCIBillingChargingCharacteristics_aOCAfterAnswer,
        _CAMEL_SCIBillingChargingCharacteristics_aOC_extension,
        CAMEL_SCIBillingChargingCharacteristics,
        CAMEL_SCIBillingChargingCharacteristicsAlt,
        _CAMEL_SCIGPRSBillingChargingCharacteristics_aOCGPRS,
        _CAMEL_SCIGPRSBillingChargingCharacteristics_pDPID,
        CAMEL_SCIGPRSBillingChargingCharacteristics,
        CGEncountered,
        _ChangeOfLocation_cellGlobalId,
        _ChangeOfLocation_serviceAreaId,
        _ChangeOfLocation_locationAreaId,
        _ChangeOfLocation_inter_SystemHandOver,
        _ChangeOfLocation_inter_PLMNHandOver,
        _ChangeOfLocation_inter_MSCHandOver,
        _ChangeOfLocation_changeOfLocationAlt,
        ChangeOfLocation,
        ChangeOfLocationAlt,
        ChargeIndicator,
        _ChargingCharacteristics_maxTransferredVolume,
        _ChargingCharacteristics_maxElapsedTime,
        ChargingCharacteristics,
        _ChargingResult_transferredVolume,
        _ChargingResult_elapsedTime,
        ChargingResult,
        _ChargingRollOver_transferredVolumeRollOver,
        _ChargingRollOver_elapsedTimeRollOver,
        ChargingRollOver,
        _CollectedDigits_minimumNbOfDigits,
        _CollectedDigits_maximumNbOfDigits,
        _CollectedDigits_endOfReplyDigit,
        _CollectedDigits_cancelDigit,
        _CollectedDigits_startDigit,
        _CollectedDigits_firstDigitTimeOut,
        _CollectedDigits_interDigitTimeOut,
        _CollectedDigits_errorTreatment,
        _CollectedDigits_interruptableAnnInd,
        _CollectedDigits_voiceInformation,
        _CollectedDigits_voiceBack,
        CollectedDigits,
        _CollectedInfo_collectedDigits,
        CollectedInfo,
        ConnectedNumberTreatmentInd,
        ControlType,
        DateAndTime,
        _ElapsedTime_timeGPRSIfNoTariffSwitch,
        __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSSinceLastTariffSwitch,
        __ElapsedTime_timeGPRSIfTariffSwitch_timeGPRSTariffSwitchInterval,
        _ElapsedTime_timeGPRSIfTariffSwitch,
        ElapsedTime,
        _ElapsedTimeRollOver_rO_TimeGPRSIfNoTariffSwitch,
        __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSSinceLastTariffSwitch,
        __ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch_rO_TimeGPRSTariffSwitchInterval,
        _ElapsedTimeRollOver_rO_TimeGPRSIfTariffSwitch,
        ElapsedTimeRollOver,
        ErrorTreatment,
        __EventSpecificInformationSMS_o_smsFailureSpecificInfo_failureCause,
        _EventSpecificInformationSMS_o_smsFailureSpecificInfo,
        _EventSpecificInformationSMS_o_smsSubmissionSpecificInfo,
        __EventSpecificInformationSMS_t_smsFailureSpecificInfo_failureCause,
        _EventSpecificInformationSMS_t_smsFailureSpecificInfo,
        _EventSpecificInformationSMS_t_smsDeliverySpecificInfo,
        EventSpecificInformationSMS,
        EventTypeBCSM,
        EventTypeSMS,
        __ExtensionField_type_tab,
        ___ExtensionField_type_tab_val_ExtensionType_0,
        _ExtensionField_type,
        _ExtensionField_criticality,
        _ExtensionField_value,
        ExtensionField,
        _ForwardServiceInteractionInd_conferenceTreatmentIndicator,
        _ForwardServiceInteractionInd_callDiversionTreatmentIndicator,
        _ForwardServiceInteractionInd_callingPartyRestrictionIndicator,
        ForwardServiceInteractionInd,
        _GapIndicators_duration,
        _GapIndicators_gapInterval,
        GapIndicators,
        _GapOnService_serviceKey,
        GapOnService,
        _GPRS_QoS_short_QoS_format,
        _GPRS_QoS_long_QoS_format,
        GPRS_QoS,
        _GPRS_QoS_Extension_supplement_to_long_QoS_format,
        _GPRS_QoS_Extension_additionalSupplement,
        GPRS_QoS_Extension,
        _GPRSEvent_gPRSEventType,
        _GPRSEvent_monitorMode,
        GPRSEvent,
        GPRSEventType,
        InitiatingEntity,
        InitiatorOfServiceChange,
        InvokeID,
        LegType,
        leg1,
        leg2,
        _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI,
        _LocationInformationGPRS_routeingAreaIdentity,
        _LocationInformationGPRS_geographicalInformation,
        _LocationInformationGPRS_sgsn_Number,
        _LocationInformationGPRS_selectedLSAIdentity,
        _LocationInformationGPRS_extensionContainer,
        _LocationInformationGPRS_sai_Present,
        _LocationInformationGPRS_userCSGInformation,
        LocationInformationGPRS,
        _MetDPCriterion_enteringCellGlobalId,
        _MetDPCriterion_leavingCellGlobalId,
        _MetDPCriterion_enteringServiceAreaId,
        _MetDPCriterion_leavingServiceAreaId,
        _MetDPCriterion_enteringLocationAreaId,
        _MetDPCriterion_leavingLocationAreaId,
        _MetDPCriterion_inter_SystemHandOverToUMTS,
        _MetDPCriterion_inter_SystemHandOverToGSM,
        _MetDPCriterion_inter_PLMNHandOver,
        _MetDPCriterion_inter_MSCHandOver,
        _MetDPCriterion_metDPCriterionAlt,
        MetDPCriterion,
        MetDPCriterionAlt,
        _MidCallControlInfo_minimumNumberOfDigits,
        _MidCallControlInfo_maximumNumberOfDigits,
        _MidCallControlInfo_endOfReplyDigit,
        _MidCallControlInfo_cancelDigit,
        _MidCallControlInfo_startDigit,
        _MidCallControlInfo_interDigitTimeout,
        MidCallControlInfo,
        MonitorMode,
        MO_SMSCause,
        MT_SMSCause,
        NAOliInfo,
        NatureOfServiceChange,
        NumberOfDigits,
        OCSIApplicable,
        PDPID,
        PDPInitiationType,
        _QualityOfService_requested_QoS,
        _QualityOfService_subscribed_QoS,
        _QualityOfService_negotiated_QoS,
        _QualityOfService_requested_QoS_Extension,
        _QualityOfService_subscribed_QoS_Extension,
        _QualityOfService_negotiated_QoS_Extension,
        QualityOfService,
        _ReceivingSideID_receivingSideID,
        ReceivingSideID,
        _RequestedInformationTypeList__item_,
        RequestedInformationTypeList,
        RequestedInformationType,
        RPCause,
        _SendingSideID_sendingSideID,
        SendingSideID,
        _ServiceInteractionIndicatorsTwo_forwardServiceInteractionInd,
        _ServiceInteractionIndicatorsTwo_backwardServiceInteractionInd,
        _ServiceInteractionIndicatorsTwo_bothwayThroughConnectionInd,
        _ServiceInteractionIndicatorsTwo_connectedNumberTreatmentInd,
        _ServiceInteractionIndicatorsTwo_nonCUGCall,
        _ServiceInteractionIndicatorsTwo_holdTreatmentIndicator,
        _ServiceInteractionIndicatorsTwo_cwTreatmentIndicator,
        _ServiceInteractionIndicatorsTwo_ectTreatmentIndicator,
        ServiceInteractionIndicatorsTwo,
        SGSNCapabilities,
        SMS_AddressString,
        maxSMS_AddressStringLength,
        _SMSEvent_eventTypeSMS,
        _SMSEvent_monitorMode,
        SMSEvent,
        TariffSwitchInterval,
        TimeIfNoTariffSwitch,
        _TimeIfTariffSwitch_timeSinceTariffSwitch,
        _TimeIfTariffSwitch_tariffSwitchInterval,
        TimeIfTariffSwitch,
        _TimeInformation_timeIfNoTariffSwitch,
        _TimeInformation_timeIfTariffSwitch,
        TimeInformation,
        TimerID,
        TimerValue,
        _Tone_toneID,
        _Tone_duration,
        Tone,
        TPDataCodingScheme,
        TPProtocolIdentifier,
        TPShortMessageSpecificInfo,
        TPValidityPeriod,
        _TransferredVolume_volumeIfNoTariffSwitch,
        __TransferredVolume_volumeIfTariffSwitch_volumeSinceLastTariffSwitch,
        __TransferredVolume_volumeIfTariffSwitch_volumeTariffSwitchInterval,
        _TransferredVolume_volumeIfTariffSwitch,
        TransferredVolume,
        _TransferredVolumeRollOver_rO_VolumeIfNoTariffSwitch,
        __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeSinceLastTariffSwitch,
        __TransferredVolumeRollOver_rO_VolumeIfTariffSwitch_rO_VolumeTariffSwitchInterval,
        _TransferredVolumeRollOver_rO_VolumeIfTariffSwitch,
        TransferredVolumeRollOver,
        UnavailableNetworkResource,
        numOfInfoItems,
    ]

class CAP_errorcodes:

    _name_  = u'CAP-errorcodes'
    _oid_   = [0, 4, 0, 0, 1, 3, 57, 7]
    
    _obj_ = [
        u'errcode-canceled',
        u'errcode-cancelFailed',
        u'errcode-eTCFailed',
        u'errcode-improperCallerResponse',
        u'errcode-missingCustomerRecord',
        u'errcode-missingParameter',
        u'errcode-parameterOutOfRange',
        u'errcode-requestedInfoError',
        u'errcode-systemFailure',
        u'errcode-taskRefused',
        u'errcode-unavailableResource',
        u'errcode-unexpectedComponentSequence',
        u'errcode-unexpectedDataValue',
        u'errcode-unexpectedParameter',
        u'errcode-unknownLegID',
        u'errcode-unknownPDPID',
        u'errcode-unknownCSID',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'errcode-canceled',
        u'errcode-cancelFailed',
        u'errcode-eTCFailed',
        u'errcode-improperCallerResponse',
        u'errcode-missingCustomerRecord',
        u'errcode-missingParameter',
        u'errcode-parameterOutOfRange',
        u'errcode-requestedInfoError',
        u'errcode-systemFailure',
        u'errcode-taskRefused',
        u'errcode-unavailableResource',
        u'errcode-unexpectedComponentSequence',
        u'errcode-unexpectedDataValue',
        u'errcode-unexpectedParameter',
        u'errcode-unknownLegID',
        u'errcode-unknownPDPID',
        u'errcode-unknownCSID',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< errcode-canceled >-----#
    errcode_canceled = CHOICE(name=u'errcode-canceled', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_canceled._val = (u'local', 0)
    
    #-----< errcode-cancelFailed >-----#
    errcode_cancelFailed = CHOICE(name=u'errcode-cancelFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_cancelFailed._val = (u'local', 1)
    
    #-----< errcode-eTCFailed >-----#
    errcode_eTCFailed = CHOICE(name=u'errcode-eTCFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_eTCFailed._val = (u'local', 3)
    
    #-----< errcode-improperCallerResponse >-----#
    errcode_improperCallerResponse = CHOICE(name=u'errcode-improperCallerResponse', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_improperCallerResponse._val = (u'local', 4)
    
    #-----< errcode-missingCustomerRecord >-----#
    errcode_missingCustomerRecord = CHOICE(name=u'errcode-missingCustomerRecord', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_missingCustomerRecord._val = (u'local', 6)
    
    #-----< errcode-missingParameter >-----#
    errcode_missingParameter = CHOICE(name=u'errcode-missingParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_missingParameter._val = (u'local', 7)
    
    #-----< errcode-parameterOutOfRange >-----#
    errcode_parameterOutOfRange = CHOICE(name=u'errcode-parameterOutOfRange', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_parameterOutOfRange._val = (u'local', 8)
    
    #-----< errcode-requestedInfoError >-----#
    errcode_requestedInfoError = CHOICE(name=u'errcode-requestedInfoError', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_requestedInfoError._val = (u'local', 10)
    
    #-----< errcode-systemFailure >-----#
    errcode_systemFailure = CHOICE(name=u'errcode-systemFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_systemFailure._val = (u'local', 11)
    
    #-----< errcode-taskRefused >-----#
    errcode_taskRefused = CHOICE(name=u'errcode-taskRefused', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_taskRefused._val = (u'local', 12)
    
    #-----< errcode-unavailableResource >-----#
    errcode_unavailableResource = CHOICE(name=u'errcode-unavailableResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unavailableResource._val = (u'local', 13)
    
    #-----< errcode-unexpectedComponentSequence >-----#
    errcode_unexpectedComponentSequence = CHOICE(name=u'errcode-unexpectedComponentSequence', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unexpectedComponentSequence._val = (u'local', 14)
    
    #-----< errcode-unexpectedDataValue >-----#
    errcode_unexpectedDataValue = CHOICE(name=u'errcode-unexpectedDataValue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unexpectedDataValue._val = (u'local', 15)
    
    #-----< errcode-unexpectedParameter >-----#
    errcode_unexpectedParameter = CHOICE(name=u'errcode-unexpectedParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unexpectedParameter._val = (u'local', 16)
    
    #-----< errcode-unknownLegID >-----#
    errcode_unknownLegID = CHOICE(name=u'errcode-unknownLegID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unknownLegID._val = (u'local', 17)
    
    #-----< errcode-unknownPDPID >-----#
    errcode_unknownPDPID = CHOICE(name=u'errcode-unknownPDPID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unknownPDPID._val = (u'local', 50)
    
    #-----< errcode-unknownCSID >-----#
    errcode_unknownCSID = CHOICE(name=u'errcode-unknownCSID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    errcode_unknownCSID._val = (u'local', 51)
    
    _all_ = [
        errcode_canceled,
        errcode_cancelFailed,
        errcode_eTCFailed,
        errcode_improperCallerResponse,
        errcode_missingCustomerRecord,
        errcode_missingParameter,
        errcode_parameterOutOfRange,
        errcode_requestedInfoError,
        errcode_systemFailure,
        errcode_taskRefused,
        errcode_unavailableResource,
        errcode_unexpectedComponentSequence,
        errcode_unexpectedDataValue,
        errcode_unexpectedParameter,
        errcode_unknownLegID,
        errcode_unknownPDPID,
        errcode_unknownCSID,
    ]

class CAP_errortypes:

    _name_  = u'CAP-errortypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 51, 7]
    
    _obj_ = [
        u'canceled',
        u'cancelFailed',
        u'eTCFailed',
        u'improperCallerResponse',
        u'missingCustomerRecord',
        u'missingParameter',
        u'parameterOutOfRange',
        u'requestedInfoError',
        u'systemFailure',
        u'taskRefused',
        u'unavailableResource',
        u'unexpectedComponentSequence',
        u'unexpectedDataValue',
        u'unexpectedParameter',
        u'unknownLegID',
        u'unknownCSID',
        u'unknownPDPID',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'canceled',
        u'cancelFailed',
        u'eTCFailed',
        u'improperCallerResponse',
        u'missingCustomerRecord',
        u'missingParameter',
        u'parameterOutOfRange',
        u'requestedInfoError',
        u'systemFailure',
        u'taskRefused',
        u'unavailableResource',
        u'unexpectedComponentSequence',
        u'unexpectedDataValue',
        u'unexpectedParameter',
        u'unknownLegID',
        u'unknownCSID',
        u'unknownPDPID',
        ]
    _class_ = [
        u'canceled',
        u'cancelFailed',
        u'eTCFailed',
        u'improperCallerResponse',
        u'missingCustomerRecord',
        u'missingParameter',
        u'parameterOutOfRange',
        u'requestedInfoError',
        u'systemFailure',
        u'taskRefused',
        u'unavailableResource',
        u'unexpectedComponentSequence',
        u'unexpectedDataValue',
        u'unexpectedParameter',
        u'unknownLegID',
        u'unknownCSID',
        u'unknownPDPID',
        ]
    _param_ = [
        ]
    
    #-----< canceled >-----#
    canceled = CLASS(name=u'canceled', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    canceled._val = dict([(u'errorCode', (u'local', 0))])
    
    #-----< cancelFailed >-----#
    cancelFailed = CLASS(name=u'cancelFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _cancelFailed_val_ParameterType = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    __cancelFailed_val_ParameterType_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __cancelFailed_val_ParameterType_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    __cancelFailed_val_ParameterType_problem._ext = None
    __cancelFailed_val_ParameterType_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _cancelFailed_val_ParameterType._cont = ASN1Dict([
        (u'problem', __cancelFailed_val_ParameterType_problem),
        (u'operation', __cancelFailed_val_ParameterType_operation),
        ])
    _cancelFailed_val_ParameterType._ext = []
    cancelFailed._val = dict([(u'ParameterType', _cancelFailed_val_ParameterType), (u'errorCode', (u'local', 1))])
    
    #-----< eTCFailed >-----#
    eTCFailed = CLASS(name=u'eTCFailed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    eTCFailed._val = dict([(u'errorCode', (u'local', 3))])
    
    #-----< improperCallerResponse >-----#
    improperCallerResponse = CLASS(name=u'improperCallerResponse', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    improperCallerResponse._val = dict([(u'errorCode', (u'local', 4))])
    
    #-----< missingCustomerRecord >-----#
    missingCustomerRecord = CLASS(name=u'missingCustomerRecord', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    missingCustomerRecord._val = dict([(u'errorCode', (u'local', 6))])
    
    #-----< missingParameter >-----#
    missingParameter = CLASS(name=u'missingParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    missingParameter._val = dict([(u'errorCode', (u'local', 7))])
    
    #-----< parameterOutOfRange >-----#
    parameterOutOfRange = CLASS(name=u'parameterOutOfRange', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    parameterOutOfRange._val = dict([(u'errorCode', (u'local', 8))])
    
    #-----< requestedInfoError >-----#
    requestedInfoError = CLASS(name=u'requestedInfoError', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _requestedInfoError_val_ParameterType = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _requestedInfoError_val_ParameterType._cont = ASN1Dict([(u'unknownRequestedInfo', 1), (u'requestedInfoNotAvailable', 2)])
    _requestedInfoError_val_ParameterType._ext = None
    requestedInfoError._val = dict([(u'ParameterType', _requestedInfoError_val_ParameterType), (u'errorCode', (u'local', 10))])
    
    #-----< systemFailure >-----#
    systemFailure = CLASS(name=u'systemFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _systemFailure_val_ParameterType = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    systemFailure._val = dict([(u'ParameterType', _systemFailure_val_ParameterType), (u'errorCode', (u'local', 11))])
    
    #-----< taskRefused >-----#
    taskRefused = CLASS(name=u'taskRefused', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _taskRefused_val_ParameterType = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _taskRefused_val_ParameterType._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _taskRefused_val_ParameterType._ext = None
    taskRefused._val = dict([(u'ParameterType', _taskRefused_val_ParameterType), (u'errorCode', (u'local', 12))])
    
    #-----< unavailableResource >-----#
    unavailableResource = CLASS(name=u'unavailableResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unavailableResource._val = dict([(u'errorCode', (u'local', 13))])
    
    #-----< unexpectedComponentSequence >-----#
    unexpectedComponentSequence = CLASS(name=u'unexpectedComponentSequence', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unexpectedComponentSequence._val = dict([(u'errorCode', (u'local', 14))])
    
    #-----< unexpectedDataValue >-----#
    unexpectedDataValue = CLASS(name=u'unexpectedDataValue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unexpectedDataValue._val = dict([(u'errorCode', (u'local', 15))])
    
    #-----< unexpectedParameter >-----#
    unexpectedParameter = CLASS(name=u'unexpectedParameter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unexpectedParameter._val = dict([(u'errorCode', (u'local', 16))])
    
    #-----< unknownLegID >-----#
    unknownLegID = CLASS(name=u'unknownLegID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unknownLegID._val = dict([(u'errorCode', (u'local', 17))])
    
    #-----< unknownCSID >-----#
    unknownCSID = CLASS(name=u'unknownCSID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unknownCSID._val = dict([(u'errorCode', (u'local', 51))])
    
    #-----< unknownPDPID >-----#
    unknownPDPID = CLASS(name=u'unknownPDPID', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    unknownPDPID._val = dict([(u'errorCode', (u'local', 50))])
    
    _all_ = [
        canceled,
        cancelFailed,
        __cancelFailed_val_ParameterType_problem,
        __cancelFailed_val_ParameterType_operation,
        _cancelFailed_val_ParameterType,
        eTCFailed,
        improperCallerResponse,
        missingCustomerRecord,
        missingParameter,
        parameterOutOfRange,
        requestedInfoError,
        _requestedInfoError_val_ParameterType,
        systemFailure,
        _systemFailure_val_ParameterType,
        taskRefused,
        _taskRefused_val_ParameterType,
        unavailableResource,
        unexpectedComponentSequence,
        unexpectedDataValue,
        unexpectedParameter,
        unknownLegID,
        unknownCSID,
        unknownPDPID,
    ]

class CAP_gprsSSF_gsmSCF_ops_args:

    _name_  = u'CAP-gprsSSF-gsmSCF-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 107, 7]
    
    _obj_ = [
        u'activityTestGPRS',
        u'applyChargingGPRS',
        u'ApplyChargingGPRSArg',
        u'applyChargingReportGPRS',
        u'ApplyChargingReportGPRSArg',
        u'cancelGPRS',
        u'CancelGPRSArg',
        u'connectGPRS',
        u'ConnectGPRSArg',
        u'continueGPRS',
        u'ContinueGPRSArg',
        u'entityReleasedGPRS',
        u'EntityReleasedGPRSArg',
        u'eventReportGPRS',
        u'EventReportGPRSArg',
        u'furnishChargingInformationGPRS',
        u'FurnishChargingInformationGPRSArg',
        u'initialDPGPRS',
        u'InitialDPGPRSArg',
        u'releaseGPRS',
        u'ReleaseGPRSArg',
        u'requestReportGPRSEvent',
        u'RequestReportGPRSEventArg',
        u'resetTimerGPRS',
        u'ResetTimerGPRSArg',
        u'sendChargingInformationGPRS',
        u'SendChargingInformationGPRSArg',
        ]
    _type_ = [
        u'ApplyChargingGPRSArg',
        u'ApplyChargingReportGPRSArg',
        u'CancelGPRSArg',
        u'ConnectGPRSArg',
        u'ContinueGPRSArg',
        u'EntityReleasedGPRSArg',
        u'EventReportGPRSArg',
        u'FurnishChargingInformationGPRSArg',
        u'InitialDPGPRSArg',
        u'ReleaseGPRSArg',
        u'RequestReportGPRSEventArg',
        u'ResetTimerGPRSArg',
        u'SendChargingInformationGPRSArg',
        ]
    _set_ = [
        ]
    _val_ = [
        u'activityTestGPRS',
        u'applyChargingGPRS',
        u'applyChargingReportGPRS',
        u'cancelGPRS',
        u'connectGPRS',
        u'continueGPRS',
        u'entityReleasedGPRS',
        u'eventReportGPRS',
        u'furnishChargingInformationGPRS',
        u'initialDPGPRS',
        u'releaseGPRS',
        u'requestReportGPRSEvent',
        u'resetTimerGPRS',
        u'sendChargingInformationGPRS',
        ]
    _class_ = [
        u'activityTestGPRS',
        u'applyChargingGPRS',
        u'applyChargingReportGPRS',
        u'cancelGPRS',
        u'connectGPRS',
        u'continueGPRS',
        u'entityReleasedGPRS',
        u'eventReportGPRS',
        u'furnishChargingInformationGPRS',
        u'initialDPGPRS',
        u'releaseGPRS',
        u'requestReportGPRSEvent',
        u'resetTimerGPRS',
        u'sendChargingInformationGPRS',
        ]
    _param_ = [
        u'connectGPRS',
        u'ConnectGPRSArg',
        u'entityReleasedGPRS',
        u'EntityReleasedGPRSArg',
        u'eventReportGPRS',
        u'EventReportGPRSArg',
        u'furnishChargingInformationGPRS',
        u'FurnishChargingInformationGPRSArg',
        u'initialDPGPRS',
        u'InitialDPGPRSArg',
        u'releaseGPRS',
        u'ReleaseGPRSArg',
        u'requestReportGPRSEvent',
        u'RequestReportGPRSEventArg',
        u'sendChargingInformationGPRS',
        u'SendChargingInformationGPRSArg',
        ]
    
    #-----< activityTestGPRS >-----#
    activityTestGPRS = CLASS(name=u'activityTestGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    activityTestGPRS._val = dict([(u'returnResult', True), (u'operationCode', (u'local', 70))])
    
    #-----< applyChargingGPRS >-----#
    applyChargingGPRS = CLASS(name=u'applyChargingGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _applyChargingGPRS_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._ext = None
    applyChargingGPRS._val = dict([(u'ArgumentType', _applyChargingGPRS_val_ArgumentType), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])
    
    #-----< ApplyChargingGPRSArg >-----#
    ApplyChargingGPRSArg = SEQ(name=u'ApplyChargingGPRSArg', mode=MODE_TYPE)
    _ApplyChargingGPRSArg_chargingCharacteristics = CHOICE(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargingCharacteristics')))
    _ApplyChargingGPRSArg_tariffSwitchInterval = INT(name=u'tariffSwitchInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ApplyChargingGPRSArg_tariffSwitchInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    _ApplyChargingGPRSArg_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ApplyChargingGPRSArg._cont = ASN1Dict([
        (u'chargingCharacteristics', _ApplyChargingGPRSArg_chargingCharacteristics),
        (u'tariffSwitchInterval', _ApplyChargingGPRSArg_tariffSwitchInterval),
        (u'pDPID', _ApplyChargingGPRSArg_pDPID),
        ])
    ApplyChargingGPRSArg._ext = []
    
    #-----< applyChargingReportGPRS >-----#
    applyChargingReportGPRS = CLASS(name=u'applyChargingReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _applyChargingReportGPRS_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    applyChargingReportGPRS._val = dict([(u'ArgumentType', _applyChargingReportGPRS_val_ArgumentType), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])
    
    #-----< ApplyChargingReportGPRSArg >-----#
    ApplyChargingReportGPRSArg = SEQ(name=u'ApplyChargingReportGPRSArg', mode=MODE_TYPE)
    _ApplyChargingReportGPRSArg_chargingResult = CHOICE(name=u'chargingResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargingResult')))
    _ApplyChargingReportGPRSArg_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _ApplyChargingReportGPRSArg_active = BOOL(name=u'active', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _ApplyChargingReportGPRSArg_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _ApplyChargingReportGPRSArg_chargingRollOver = CHOICE(name=u'chargingRollOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargingRollOver')), opt=True)
    ApplyChargingReportGPRSArg._cont = ASN1Dict([
        (u'chargingResult', _ApplyChargingReportGPRSArg_chargingResult),
        (u'qualityOfService', _ApplyChargingReportGPRSArg_qualityOfService),
        (u'active', _ApplyChargingReportGPRSArg_active),
        (u'pDPID', _ApplyChargingReportGPRSArg_pDPID),
        (u'chargingRollOver', _ApplyChargingReportGPRSArg_chargingRollOver),
        ])
    ApplyChargingReportGPRSArg._ext = [u'chargingRollOver']
    
    #-----< cancelGPRS >-----#
    cancelGPRS = CLASS(name=u'cancelGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _cancelGPRS_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._ext = None
    cancelGPRS._val = dict([(u'ArgumentType', _cancelGPRS_val_ArgumentType), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])
    
    #-----< CancelGPRSArg >-----#
    CancelGPRSArg = SEQ(name=u'CancelGPRSArg', mode=MODE_TYPE)
    _CancelGPRSArg_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    CancelGPRSArg._cont = ASN1Dict([
        (u'pDPID', _CancelGPRSArg_pDPID),
        ])
    CancelGPRSArg._ext = []
    
    #-----< connectGPRS >-----#
    connectGPRS = CLASS(name=u'connectGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectGPRSArg >-----#
    ConnectGPRSArg = SEQ(name=u'ConnectGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< continueGPRS >-----#
    continueGPRS = CLASS(name=u'continueGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _continueGPRS_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    continueGPRS._val = dict([(u'ArgumentType', _continueGPRS_val_ArgumentType), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))])
    
    #-----< ContinueGPRSArg >-----#
    ContinueGPRSArg = SEQ(name=u'ContinueGPRSArg', mode=MODE_TYPE)
    _ContinueGPRSArg_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ContinueGPRSArg._cont = ASN1Dict([
        (u'pDPID', _ContinueGPRSArg_pDPID),
        ])
    ContinueGPRSArg._ext = []
    
    #-----< entityReleasedGPRS >-----#
    entityReleasedGPRS = CLASS(name=u'entityReleasedGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EntityReleasedGPRSArg >-----#
    EntityReleasedGPRSArg = SEQ(name=u'EntityReleasedGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< eventReportGPRS >-----#
    eventReportGPRS = CLASS(name=u'eventReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EventReportGPRSArg >-----#
    EventReportGPRSArg = SEQ(name=u'EventReportGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< furnishChargingInformationGPRS >-----#
    furnishChargingInformationGPRS = CLASS(name=u'furnishChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< FurnishChargingInformationGPRSArg >-----#
    FurnishChargingInformationGPRSArg = OCT_STR(name=u'FurnishChargingInformationGPRSArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'FCIGPRSBillingChargingCharacteristics')), param=True)
    
    #-----< initialDPGPRS >-----#
    initialDPGPRS = CLASS(name=u'initialDPGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitialDPGPRSArg >-----#
    InitialDPGPRSArg = SEQ(name=u'InitialDPGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< releaseGPRS >-----#
    releaseGPRS = CLASS(name=u'releaseGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ReleaseGPRSArg >-----#
    ReleaseGPRSArg = SEQ(name=u'ReleaseGPRSArg', mode=MODE_TYPE, param=True)
    
    #-----< requestReportGPRSEvent >-----#
    requestReportGPRSEvent = CLASS(name=u'requestReportGPRSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< RequestReportGPRSEventArg >-----#
    RequestReportGPRSEventArg = SEQ(name=u'RequestReportGPRSEventArg', mode=MODE_TYPE, param=True)
    
    #-----< resetTimerGPRS >-----#
    resetTimerGPRS = CLASS(name=u'resetTimerGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _resetTimerGPRS_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2._ext = None
    resetTimerGPRS._val = dict([(u'ArgumentType', _resetTimerGPRS_val_ArgumentType), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))])
    
    #-----< ResetTimerGPRSArg >-----#
    ResetTimerGPRSArg = SEQ(name=u'ResetTimerGPRSArg', mode=MODE_TYPE)
    _ResetTimerGPRSArg_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _ResetTimerGPRSArg_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    ResetTimerGPRSArg._cont = ASN1Dict([
        (u'timerID', _ResetTimerGPRSArg_timerID),
        (u'timervalue', _ResetTimerGPRSArg_timervalue),
        ])
    ResetTimerGPRSArg._ext = []
    
    #-----< sendChargingInformationGPRS >-----#
    sendChargingInformationGPRS = CLASS(name=u'sendChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SendChargingInformationGPRSArg >-----#
    SendChargingInformationGPRSArg = SEQ(name=u'SendChargingInformationGPRSArg', mode=MODE_TYPE, param=True)
    
    _all_ = [
        activityTestGPRS,
        applyChargingGPRS,
        _applyChargingGPRS_val_ArgumentType,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6,
        _ApplyChargingGPRSArg_chargingCharacteristics,
        _ApplyChargingGPRSArg_tariffSwitchInterval,
        _ApplyChargingGPRSArg_pDPID,
        ApplyChargingGPRSArg,
        applyChargingReportGPRS,
        _applyChargingReportGPRS_val_ArgumentType,
        _ApplyChargingReportGPRSArg_chargingResult,
        _ApplyChargingReportGPRSArg_qualityOfService,
        _ApplyChargingReportGPRSArg_active,
        _ApplyChargingReportGPRSArg_pDPID,
        _ApplyChargingReportGPRSArg_chargingRollOver,
        ApplyChargingReportGPRSArg,
        cancelGPRS,
        _cancelGPRS_val_ArgumentType,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1,
        _CancelGPRSArg_pDPID,
        CancelGPRSArg,
        continueGPRS,
        _continueGPRS_val_ArgumentType,
        _ContinueGPRSArg_pDPID,
        ContinueGPRSArg,
        resetTimerGPRS,
        _resetTimerGPRS_val_ArgumentType,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2,
        _ResetTimerGPRSArg_timerID,
        _ResetTimerGPRSArg_timervalue,
        ResetTimerGPRSArg,
    ]

class CAP_gprsSSF_gsmSCF_pkgs_contracts_acs:

    _name_  = u'CAP-gprsSSF-gsmSCF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 108, 7]
    
    _obj_ = [
        u'cap-gprssf-scfAC',
        u'cap-gsmscf-gprsssfAC',
        u'capGprsSsfToScf',
        u'capGsmScfToGprsSsf',
        u'gprsScfActivationPackage',
        u'gprsConnectPackage',
        u'gprsProcessingPackage',
        u'gprsReleasePackage',
        u'gprsEventHandlingPackage',
        u'gprsExceptionInformationPackage',
        u'gprsTimerPackage',
        u'gprsBillingPackage',
        u'gprsChargingPackage',
        u'gprsChargeAdvicePackage',
        u'gprsActivityTestPackage',
        u'gprsCancelPackage',
        u'gprsSSF-gsmSCFAbstractSyntax',
        u'GenericGprsSSF-gsmSCF-PDUs',
        u'GprsSsfToGsmScfInvokable',
        u'GprsSsfToGsmScfReturnable',
        u'gsmSCF-gprsSSFAbstractSyntax',
        u'GenericGsmSCF-gprsSSF-PDUs',
        u'GsmScfToGprsSsfInvokable',
        u'GsmScfToGprsSsfReturnable',
        ]
    _type_ = [
        u'GenericGprsSSF-gsmSCF-PDUs',
        u'GenericGsmSCF-gprsSSF-PDUs',
        ]
    _set_ = [
        u'GprsSsfToGsmScfInvokable',
        u'GprsSsfToGsmScfReturnable',
        u'GsmScfToGprsSsfInvokable',
        u'GsmScfToGprsSsfReturnable',
        ]
    _val_ = [
        u'cap-gprssf-scfAC',
        u'cap-gsmscf-gprsssfAC',
        u'capGprsSsfToScf',
        u'capGsmScfToGprsSsf',
        u'gprsScfActivationPackage',
        u'gprsConnectPackage',
        u'gprsProcessingPackage',
        u'gprsReleasePackage',
        u'gprsEventHandlingPackage',
        u'gprsExceptionInformationPackage',
        u'gprsTimerPackage',
        u'gprsBillingPackage',
        u'gprsChargingPackage',
        u'gprsChargeAdvicePackage',
        u'gprsActivityTestPackage',
        u'gprsCancelPackage',
        u'gprsSSF-gsmSCFAbstractSyntax',
        u'gsmSCF-gprsSSFAbstractSyntax',
        ]
    _class_ = [
        u'cap-gprssf-scfAC',
        u'cap-gsmscf-gprsssfAC',
        u'capGprsSsfToScf',
        u'capGsmScfToGprsSsf',
        u'gprsScfActivationPackage',
        u'gprsConnectPackage',
        u'gprsProcessingPackage',
        u'gprsReleasePackage',
        u'gprsEventHandlingPackage',
        u'gprsExceptionInformationPackage',
        u'gprsTimerPackage',
        u'gprsBillingPackage',
        u'gprsChargingPackage',
        u'gprsChargeAdvicePackage',
        u'gprsActivityTestPackage',
        u'gprsCancelPackage',
        u'gprsSSF-gsmSCFAbstractSyntax',
        u'GprsSsfToGsmScfInvokable',
        u'GprsSsfToGsmScfReturnable',
        u'gsmSCF-gprsSSFAbstractSyntax',
        u'GsmScfToGprsSsfInvokable',
        u'GsmScfToGprsSsfReturnable',
        ]
    _param_ = [
        u'gprsScfActivationPackage',
        u'gprsConnectPackage',
        u'gprsReleasePackage',
        u'gprsEventHandlingPackage',
        u'gprsExceptionInformationPackage',
        u'gprsBillingPackage',
        u'gprsChargeAdvicePackage',
        ]
    
    #-----< cap-gprssf-scfAC >-----#
    cap_gprssf_scfAC = CLASS(name=u'cap-gprssf-scfAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        (u'serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_serviceKey),
        (u'gPRSEventType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSEventType),
        (u'mSISDN', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_mSISDN),
        (u'iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMSI),
        (u'timeAndTimeZone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimeZone),
        (u'gPRSMSClass', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSMSClass),
        (u'endUserAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress),
        (u'qualityOfService', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_qualityOfService),
        (u'accessPointName', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_accessPointName),
        (u'routeingAreaIdentity', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_routeingAreaIdentity),
        (u'chargingID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_chargingID),
        (u'sGSNCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sGSNCapabilities),
        (u'locationInformationGPRS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationGPRS),
        (u'pDPInitiationType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_pDPInitiationType),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions),
        (u'gGSNAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gGSNAddress),
        (u'secondaryPDP-context', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_secondaryPDP_context),
        (u'iMEI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMEI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'gPRSEvent', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        (u'gPRSEventType', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventType),
        (u'miscGPRSInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        (u'gPRSCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_gPRSCause),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3._cont = ASN1Dict([
        (u'accessPointName', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_accessPointName),
        (u'pdpID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_pdpID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        (u'gprsCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_gprsCause),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        (u'gPRSEvent', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1._cont = ASN1Dict([
        (u'gPRSEventType', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventType),
        (u'miscGPRSInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0._ext = None
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGprsSSF-gsmSCF-PDUs')))
    cap_gprssf_scfAC._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 51))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 50))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 52))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 49))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 55))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 14))])), (u'dialogueMode', u'structured'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 50))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 21, 3, 50))])
    
    #-----< cap-gsmscf-gprsssfAC >-----#
    cap_gsmscf_gprsssfAC = CLASS(name=u'cap-gsmscf-gprsssfAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11._cont = ASN1Dict([
        (u'gprsCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_gprsCause),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12._cont = ASN1Dict([
        (u'gPRSEvent', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2._cont = ASN1Dict([
        (u'gPRSEventType', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventType),
        (u'miscGPRSInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation),
        (u'pDPID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_pDPID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14._ext = []
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGsmSCF-gprsSSF-PDUs')))
    cap_gsmscf_gprsssfAC._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 58))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 15))])), (u'dialogueMode', u'structured'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0), ('id', (0, 4, 0, 0, 1, 22, 5, 51))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 21, 3, 51))])
    
    #-----< capGprsSsfToScf >-----#
    capGprsSsfToScf = CLASS(name=u'capGprsSsfToScf', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capGprsSsfToScf._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 51))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 50))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 52))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 49))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 55))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 14))])
    
    #-----< capGsmScfToGprsSsf >-----#
    capGsmScfToGprsSsf = CLASS(name=u'capGsmScfToGprsSsf', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capGsmScfToGprsSsf._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 53))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 54))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 56))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 58))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 59))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 15))])
    
    #-----< gprsScfActivationPackage >-----#
    gprsScfActivationPackage = CLASS(name=u'gprsScfActivationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsConnectPackage >-----#
    gprsConnectPackage = CLASS(name=u'gprsConnectPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsProcessingPackage >-----#
    gprsProcessingPackage = CLASS(name=u'gprsProcessingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsProcessingPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 49))])
    
    #-----< gprsReleasePackage >-----#
    gprsReleasePackage = CLASS(name=u'gprsReleasePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsEventHandlingPackage >-----#
    gprsEventHandlingPackage = CLASS(name=u'gprsEventHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsExceptionInformationPackage >-----#
    gprsExceptionInformationPackage = CLASS(name=u'gprsExceptionInformationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsTimerPackage >-----#
    gprsTimerPackage = CLASS(name=u'gprsTimerPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsTimerPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 55))])
    
    #-----< gprsBillingPackage >-----#
    gprsBillingPackage = CLASS(name=u'gprsBillingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsChargingPackage >-----#
    gprsChargingPackage = CLASS(name=u'gprsChargingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsChargingPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 57))])
    
    #-----< gprsChargeAdvicePackage >-----#
    gprsChargeAdvicePackage = CLASS(name=u'gprsChargeAdvicePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gprsActivityTestPackage >-----#
    gprsActivityTestPackage = CLASS(name=u'gprsActivityTestPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsActivityTestPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 58))])
    
    #-----< gprsCancelPackage >-----#
    gprsCancelPackage = CLASS(name=u'gprsCancelPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    gprsCancelPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 59))])
    
    #-----< gprsSSF-gsmSCFAbstractSyntax >-----#
    gprsSSF_gsmSCFAbstractSyntax = CLASS(name=u'gprsSSF-gsmSCFAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _gprsSSF_gsmSCFAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGprsSSF-gsmSCF-PDUs')))
    gprsSSF_gsmSCFAbstractSyntax._val = dict([('Type', _gprsSSF_gsmSCFAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 50))])
    
    #-----< GenericGprsSSF-gsmSCF-PDUs >-----#
    GenericGprsSSF_gsmSCF_PDUs = CHOICE(name=u'GenericGprsSSF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericGprsSSF_gsmSCF_PDUs_unidirectional = SEQ(name=u'unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'accessPointName', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName),
        (u'pdpID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pdpID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'gPRSCause', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause),
        (u'pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation._ext = None
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'gPRSEventType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventType),
        (u'miscGPRSInfo', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation),
        (u'pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress._ext = None
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._cont = __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        (u'serviceKey', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceKey),
        (u'gPRSEventType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSEventType),
        (u'mSISDN', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_mSISDN),
        (u'iMSI', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMSI),
        (u'timeAndTimeZone', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone),
        (u'gPRSMSClass', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSMSClass),
        (u'endUserAddress', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress),
        (u'qualityOfService', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_qualityOfService),
        (u'accessPointName', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName),
        (u'routeingAreaIdentity', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_routeingAreaIdentity),
        (u'chargingID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_chargingID),
        (u'sGSNCapabilities', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_sGSNCapabilities),
        (u'locationInformationGPRS', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_locationInformationGPRS),
        (u'pDPInitiationType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_pDPInitiationType),
        (u'extensions', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions),
        (u'gGSNAddress', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gGSNAddress),
        (u'secondaryPDP-context', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_secondaryPDP_context),
        (u'iMEI', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMEI),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        (u'gprsCause', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause),
        (u'pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent._cont = __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent__item_
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        (u'gPRSEvent', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent),
        (u'pDPID', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_pDPID),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._ext = []
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))]), dict([(u'ArgumentType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'accessPointName', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName),
        (u'pdpID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pdpID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'gPRSCause', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause),
        (u'pDPID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_pDPID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress._ext = None
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._cont = ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        (u'serviceKey', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_serviceKey),
        (u'gPRSEventType', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSEventType),
        (u'mSISDN', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_mSISDN),
        (u'iMSI', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMSI),
        (u'timeAndTimeZone', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone),
        (u'gPRSMSClass', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSMSClass),
        (u'endUserAddress', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress),
        (u'qualityOfService', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_qualityOfService),
        (u'accessPointName', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName),
        (u'routeingAreaIdentity', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_routeingAreaIdentity),
        (u'chargingID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_chargingID),
        (u'sGSNCapabilities', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_sGSNCapabilities),
        (u'locationInformationGPRS', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_locationInformationGPRS),
        (u'pDPInitiationType', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_pDPInitiationType),
        (u'extensions', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions),
        (u'gGSNAddress', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gGSNAddress),
        (u'secondaryPDP-context', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_secondaryPDP_context),
        (u'iMEI', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMEI),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        (u'gprsCause', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause),
        (u'pDPID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_pDPID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent._cont = ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent__item_
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        (u'gPRSEvent', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent),
        (u'pDPID', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_pDPID),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._ext = []
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._ext = []
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))]), dict([(u'ArgumentType', _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        (u'returnResult', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        (u'returnError', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        (u'reject', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        (u'returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components._cont = ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_
    __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        (u'dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        (u'components', __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_unidirectional._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_begin = SEQ(name=u'begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericGprsSSF_gsmSCF_PDUs_begin_otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_begin_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_begin_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        (u'returnResult', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        (u'returnError', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        (u'reject', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS),
        (u'returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_begin_components._cont = ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_
    __GenericGprsSSF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        (u'otid', __GenericGprsSSF_gsmSCF_PDUs_begin_otid),
        (u'dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_begin_dialoguePortion),
        (u'components', __GenericGprsSSF_gsmSCF_PDUs_begin_components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_begin._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_end = SEQ(name=u'end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericGprsSSF_gsmSCF_PDUs_end_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_end_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_end_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        (u'returnResult', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        (u'returnError', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        (u'reject', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS),
        (u'returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_end_components._cont = ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_
    __GenericGprsSSF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_end._cont = ASN1Dict([
        (u'dtid', __GenericGprsSSF_gsmSCF_PDUs_end_dtid),
        (u'dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_end_dialoguePortion),
        (u'components', __GenericGprsSSF_gsmSCF_PDUs_end_components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_end._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_continue_ = SEQ(name=u'continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericGprsSSF_gsmSCF_PDUs_continue__otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_continue__dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGprsSSF_gsmSCF_PDUs_continue__dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGprsSSF_gsmSCF_PDUs_continue__components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        (u'returnResult', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        (u'returnError', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        (u'reject', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS),
        (u'returnResultNotLast', ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_._ext = None
    __GenericGprsSSF_gsmSCF_PDUs_continue__components._cont = ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_
    __GenericGprsSSF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGprsSSF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        (u'otid', __GenericGprsSSF_gsmSCF_PDUs_continue__otid),
        (u'dtid', __GenericGprsSSF_gsmSCF_PDUs_continue__dtid),
        (u'dialoguePortion', __GenericGprsSSF_gsmSCF_PDUs_continue__dialoguePortion),
        (u'components', __GenericGprsSSF_gsmSCF_PDUs_continue__components),
        ])
    _GenericGprsSSF_gsmSCF_PDUs_continue_._ext = None
    _GenericGprsSSF_gsmSCF_PDUs_abort = SEQ(name=u'abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericGprsSSF_gsmSCF_PDUs._cont = ASN1Dict([
        (u'unidirectional', _GenericGprsSSF_gsmSCF_PDUs_unidirectional),
        (u'begin', _GenericGprsSSF_gsmSCF_PDUs_begin),
        (u'end', _GenericGprsSSF_gsmSCF_PDUs_end),
        (u'continue', _GenericGprsSSF_gsmSCF_PDUs_continue_),
        (u'abort', _GenericGprsSSF_gsmSCF_PDUs_abort),
        ])
    GenericGprsSSF_gsmSCF_PDUs._ext = None
    
    #-----< GprsSsfToGsmScfInvokable >-----#
    GprsSsfToGsmScfInvokable = CLASS(name=u'GprsSsfToGsmScfInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_4_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_4._cont = ASN1Dict([
        (u'accessPointName', __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName),
        (u'pdpID', __GprsSsfToGsmScfInvokable_val_ArgumentType_4_pdpID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_4._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_5_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_5._cont = ASN1Dict([
        (u'gPRSCause', __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause),
        (u'pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_5_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_5._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EventReportGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_miscGPRSInfo = SEQ(name=u'miscGPRSInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation = CHOICE(name=u'gPRSEventSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventSpecificInformation')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation = SEQ(name=u'attachChangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation._ext = []
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation = SEQ(name=u'pdp-ContextchangeOfPositionSpecificInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress),
        ])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress._ext = None
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName),
        (u'chargingID', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID),
        (u'locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS),
        (u'endUserAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress),
        (u'qualityOfService', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService),
        (u'timeAndTimeZone', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation._ext = [u'gGSNAddress']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation = SEQ(name=u'detachSpecificInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation._ext = [u'routeingAreaUpdate']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation = SEQ(name=u'disconnectSpecificInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity = ENUM(name=u'initiatingEntity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatingEntity')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate = NULL(name=u'routeingAreaUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._cont = ASN1Dict([
        (u'initiatingEntity', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity),
        (u'routeingAreaUpdate', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation._ext = [u'routeingAreaUpdate']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation = SEQ(name=u'pDPContextEstablishmentSpecificInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress),
        ])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress._ext = None
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName),
        (u'endUserAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress),
        (u'qualityOfService', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone),
        (u'pDPInitiationType', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType),
        (u'secondaryPDP-context', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation._ext = [u'secondaryPDP-context']
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation = SEQ(name=u'pDPContextEstablishmentAcknowledgementSpecificInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress),
        ])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress._ext = None
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._cont = ASN1Dict([
        (u'accessPointName', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName),
        (u'chargingID', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID),
        (u'endUserAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress),
        (u'qualityOfService', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService),
        (u'locationInformationGPRS', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS),
        (u'timeAndTimeZone', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone),
        (u'gGSNAddress', ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress),
        ])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation._ext = [u'gGSNAddress']
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation._cont = ASN1Dict([
        (u'attachChangeOfPositionSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation),
        (u'pdp-ContextchangeOfPositionSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation),
        (u'detachSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation),
        (u'disconnectSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation),
        (u'pDPContextEstablishmentSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation),
        (u'pDPContextEstablishmentAcknowledgementSpecificInformation', ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation),
        ])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation._ext = None
    __GprsSsfToGsmScfInvokable_val_ArgumentType_6_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_6._cont = ASN1Dict([
        (u'gPRSEventType', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventType),
        (u'miscGPRSInfo', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_miscGPRSInfo),
        (u'gPRSEventSpecificInformation', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation),
        (u'pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_6_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_6._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_7 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress._ext = None
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions._cont = ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions__item_
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_8._cont = ASN1Dict([
        (u'serviceKey', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_serviceKey),
        (u'gPRSEventType', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSEventType),
        (u'mSISDN', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_mSISDN),
        (u'iMSI', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMSI),
        (u'timeAndTimeZone', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone),
        (u'gPRSMSClass', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSMSClass),
        (u'endUserAddress', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress),
        (u'qualityOfService', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_qualityOfService),
        (u'accessPointName', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName),
        (u'routeingAreaIdentity', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_routeingAreaIdentity),
        (u'chargingID', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_chargingID),
        (u'sGSNCapabilities', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_sGSNCapabilities),
        (u'locationInformationGPRS', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_locationInformationGPRS),
        (u'pDPInitiationType', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_pDPInitiationType),
        (u'extensions', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions),
        (u'gGSNAddress', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gGSNAddress),
        (u'secondaryPDP-context', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_secondaryPDP_context),
        (u'iMEI', __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMEI),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_8._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    _GprsSsfToGsmScfInvokable_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_9_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_9._cont = ASN1Dict([
        (u'gprsCause', __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause),
        (u'pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_9_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_9._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent._cont = ___GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent__item_
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfInvokable_val_ArgumentType_10_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfInvokable_val_ArgumentType_10._cont = ASN1Dict([
        (u'gPRSEvent', __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent),
        (u'pDPID', __GprsSsfToGsmScfInvokable_val_ArgumentType_10_pDPID),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_10._ext = []
    _GprsSsfToGsmScfInvokable_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _GprsSsfToGsmScfInvokable_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_12._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    _GprsSsfToGsmScfInvokable_val_ArgumentType_12._ext = []
    GprsSsfToGsmScfInvokable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_5), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_6), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 80))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))]), dict([(u'ArgumentType', _GprsSsfToGsmScfInvokable_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    
    #-----< GprsSsfToGsmScfReturnable >-----#
    GprsSsfToGsmScfReturnable = CLASS(name=u'GprsSsfToGsmScfReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingReportGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ConnectGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_4_pdpID = OCT_STR(name=u'pdpID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_4._cont = ASN1Dict([
        (u'accessPointName', __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName),
        (u'pdpID', __GprsSsfToGsmScfReturnable_val_ArgumentType_4_pdpID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_4._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ContinueGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'EntityReleasedGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause = OCT_STR(name=u'gPRSCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_6_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_6._cont = ASN1Dict([
        (u'gPRSCause', __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause),
        (u'pDPID', __GprsSsfToGsmScfReturnable_val_ArgumentType_6_pDPID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_6._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_7 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_7._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'InitialDPGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSEventType = ENUM(name=u'gPRSEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSEventType')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone = OCT_STR(name=u'timeAndTimeZone', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress = SEQ(name=u'endUserAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EndUserAddress')), opt=True)
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization = OCT_STR(name=u'pDPTypeOrganization', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber = OCT_STR(name=u'pDPTypeNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress = OCT_STR(name=u'pDPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress._cont = ASN1Dict([
        (u'pDPTypeOrganization', ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization),
        (u'pDPTypeNumber', ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber),
        (u'pDPAddress', ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress),
        ])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress._ext = None
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_qualityOfService = SEQ(name=u'qualityOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'QualityOfService')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName = OCT_STR(name=u'accessPointName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AccessPointName')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_chargingID = OCT_STR(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_sGSNCapabilities = OCT_STR(name=u'sGSNCapabilities', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SGSNCapabilities')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_pDPInitiationType = ENUM(name=u'pDPInitiationType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPInitiationType')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions._cont = ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions__item_
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gGSNAddress = OCT_STR(name=u'gGSNAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_secondaryPDP_context = NULL(name=u'secondaryPDP-context', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_8._cont = ASN1Dict([
        (u'serviceKey', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_serviceKey),
        (u'gPRSEventType', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSEventType),
        (u'mSISDN', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_mSISDN),
        (u'iMSI', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMSI),
        (u'timeAndTimeZone', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone),
        (u'gPRSMSClass', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSMSClass),
        (u'endUserAddress', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress),
        (u'qualityOfService', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_qualityOfService),
        (u'accessPointName', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName),
        (u'routeingAreaIdentity', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_routeingAreaIdentity),
        (u'chargingID', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_chargingID),
        (u'sGSNCapabilities', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_sGSNCapabilities),
        (u'locationInformationGPRS', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_locationInformationGPRS),
        (u'pDPInitiationType', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_pDPInitiationType),
        (u'extensions', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions),
        (u'gGSNAddress', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gGSNAddress),
        (u'secondaryPDP-context', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_secondaryPDP_context),
        (u'iMEI', __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMEI),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_8._ext = [u'gGSNAddress', u'secondaryPDP-context', u'iMEI']
    _GprsSsfToGsmScfReturnable_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_9_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_9._cont = ASN1Dict([
        (u'gprsCause', __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause),
        (u'pDPID', __GprsSsfToGsmScfReturnable_val_ArgumentType_9_pDPID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_9._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent._cont = ___GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent__item_
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GprsSsfToGsmScfReturnable_val_ArgumentType_10_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GprsSsfToGsmScfReturnable_val_ArgumentType_10._cont = ASN1Dict([
        (u'gPRSEvent', __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent),
        (u'pDPID', __GprsSsfToGsmScfReturnable_val_ArgumentType_10_pDPID),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_10._ext = []
    _GprsSsfToGsmScfReturnable_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ResetTimerGPRSArg')))
    _GprsSsfToGsmScfReturnable_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_12._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics),
        ])
    _GprsSsfToGsmScfReturnable_val_ArgumentType_12._ext = []
    GprsSsfToGsmScfReturnable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 72))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 74))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 50))]), dict([(u'errorCode', (u'local', 15))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 75))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_6), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 76))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 78))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 82))]), dict([(u'ArgumentType', _GprsSsfToGsmScfReturnable_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    
    #-----< gsmSCF-gprsSSFAbstractSyntax >-----#
    gsmSCF_gprsSSFAbstractSyntax = CLASS(name=u'gsmSCF-gprsSSFAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _gsmSCF_gprsSSFAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-pkgs-contracts-acs', 'GenericGsmSCF-gprsSSF-PDUs')))
    gsmSCF_gprsSSFAbstractSyntax._val = dict([('Type', _gsmSCF_gprsSSFAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 51))])
    
    #-----< GenericGsmSCF-gprsSSF-PDUs >-----#
    GenericGsmSCF_gprsSSF_PDUs = CHOICE(name=u'GenericGsmSCF-gprsSSF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericGsmSCF_gprsSSF_PDUs_unidirectional = SEQ(name=u'unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'gprsCause', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause),
        (u'pDPID', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pDPID),
        ])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent._cont = __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent__item_
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'gPRSEvent', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent),
        (u'pDPID', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID),
        ])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = []
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'gprsCause', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause),
        (u'pDPID', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pDPID),
        ])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent._cont = ___________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent__item_
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'gPRSEvent', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent),
        (u'pDPID', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_pDPID),
        ])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = []
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke),
        (u'returnResult', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult),
        (u'returnError', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError),
        (u'reject', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS),
        (u'returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components._cont = ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_
    __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_unidirectional._cont = ASN1Dict([
        (u'dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_unidirectional_dialoguePortion),
        (u'components', __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_unidirectional._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_begin = SEQ(name=u'begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericGsmSCF_gprsSSF_PDUs_begin_otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_begin_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_begin_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke),
        (u'returnResult', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult),
        (u'returnError', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError),
        (u'reject', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS),
        (u'returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_begin_components._cont = ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_
    __GenericGsmSCF_gprsSSF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_begin._cont = ASN1Dict([
        (u'otid', __GenericGsmSCF_gprsSSF_PDUs_begin_otid),
        (u'dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_begin_dialoguePortion),
        (u'components', __GenericGsmSCF_gprsSSF_PDUs_begin_components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_begin._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_end = SEQ(name=u'end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericGsmSCF_gprsSSF_PDUs_end_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_end_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_end_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke),
        (u'returnResult', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult),
        (u'returnError', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError),
        (u'reject', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS),
        (u'returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_end_components._cont = ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_
    __GenericGsmSCF_gprsSSF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_end._cont = ASN1Dict([
        (u'dtid', __GenericGsmSCF_gprsSSF_PDUs_end_dtid),
        (u'dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_end_dialoguePortion),
        (u'components', __GenericGsmSCF_gprsSSF_PDUs_end_components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_end._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_continue_ = SEQ(name=u'continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericGsmSCF_gprsSSF_PDUs_continue__otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_continue__dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericGsmSCF_gprsSSF_PDUs_continue__dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericGsmSCF_gprsSSF_PDUs_continue__components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke),
        (u'returnResult', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult),
        (u'returnError', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError),
        (u'reject', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS),
        (u'returnResultNotLast', ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_._ext = None
    __GenericGsmSCF_gprsSSF_PDUs_continue__components._cont = ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_
    __GenericGsmSCF_gprsSSF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericGsmSCF_gprsSSF_PDUs_continue_._cont = ASN1Dict([
        (u'otid', __GenericGsmSCF_gprsSSF_PDUs_continue__otid),
        (u'dtid', __GenericGsmSCF_gprsSSF_PDUs_continue__dtid),
        (u'dialoguePortion', __GenericGsmSCF_gprsSSF_PDUs_continue__dialoguePortion),
        (u'components', __GenericGsmSCF_gprsSSF_PDUs_continue__components),
        ])
    _GenericGsmSCF_gprsSSF_PDUs_continue_._ext = None
    _GenericGsmSCF_gprsSSF_PDUs_abort = SEQ(name=u'abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericGsmSCF_gprsSSF_PDUs._cont = ASN1Dict([
        (u'unidirectional', _GenericGsmSCF_gprsSSF_PDUs_unidirectional),
        (u'begin', _GenericGsmSCF_gprsSSF_PDUs_begin),
        (u'end', _GenericGsmSCF_gprsSSF_PDUs_end),
        (u'continue', _GenericGsmSCF_gprsSSF_PDUs_continue_),
        (u'abort', _GenericGsmSCF_gprsSSF_PDUs_abort),
        ])
    GenericGsmSCF_gprsSSF_PDUs._ext = None
    
    #-----< GsmScfToGprsSsfInvokable >-----#
    GsmScfToGprsSsfInvokable = CLASS(name=u'GsmScfToGprsSsfInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_3 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GsmScfToGprsSsfInvokable_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GsmScfToGprsSsfInvokable_val_ArgumentType_4_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfInvokable_val_ArgumentType_4._cont = ASN1Dict([
        (u'gprsCause', __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause),
        (u'pDPID', __GsmScfToGprsSsfInvokable_val_ArgumentType_4_pDPID),
        ])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_4._ext = []
    _GsmScfToGprsSsfInvokable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent._cont = ___GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent__item_
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmScfToGprsSsfInvokable_val_ArgumentType_5_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfInvokable_val_ArgumentType_5._cont = ASN1Dict([
        (u'gPRSEvent', __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent),
        (u'pDPID', __GsmScfToGprsSsfInvokable_val_ArgumentType_5_pDPID),
        ])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_5._ext = []
    _GsmScfToGprsSsfInvokable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_6._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    _GsmScfToGprsSsfInvokable_val_ArgumentType_6._ext = []
    GsmScfToGprsSsfInvokable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', _GsmScfToGprsSsfInvokable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    
    #-----< GsmScfToGprsSsfReturnable >-----#
    GsmScfToGprsSsfReturnable = CLASS(name=u'GsmScfToGprsSsfReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ApplyChargingGPRSArg')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'CancelGPRSArg')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_3 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'FurnishChargingInformationGPRSArg')))
    _GsmScfToGprsSsfReturnable_val_ArgumentType_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'ReleaseGPRSArg')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause = OCT_STR(name=u'gprsCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GPRSCause')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1)], ev=None, er=[])
    __GsmScfToGprsSsfReturnable_val_ArgumentType_4_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfReturnable_val_ArgumentType_4._cont = ASN1Dict([
        (u'gprsCause', __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause),
        (u'pDPID', __GsmScfToGprsSsfReturnable_val_ArgumentType_4_pDPID),
        ])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_4._ext = []
    _GsmScfToGprsSsfReturnable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'RequestReportGPRSEventArg')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent = SEQ_OF(name=u'gPRSEvent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GPRSEvent')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent._cont = ___GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent__item_
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmScfToGprsSsfReturnable_val_ArgumentType_5_pDPID = OCT_STR(name=u'pDPID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'PDPID')), opt=True)
    _GsmScfToGprsSsfReturnable_val_ArgumentType_5._cont = ASN1Dict([
        (u'gPRSEvent', __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent),
        (u'pDPID', __GsmScfToGprsSsfReturnable_val_ArgumentType_5_pDPID),
        ])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_5._ext = []
    _GsmScfToGprsSsfReturnable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gprsSSF-gsmSCF-ops-args', 'SendChargingInformationGPRSArg')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics = OCT_STR(name=u'sCIGPRSBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIGPRSBillingChargingCharacteristics')))
    __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_6._cont = ASN1Dict([
        (u'sCIGPRSBillingChargingCharacteristics', __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics),
        ])
    _GsmScfToGprsSsfReturnable_val_ArgumentType_6._ext = []
    GsmScfToGprsSsfReturnable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 70))]), dict([(u'ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 71))]), dict([(u'ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 73))]), dict([(u'ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 77))]), dict([(u'ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 79))]), dict([(u'ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 81))]), dict([(u'ArgumentType', _GsmScfToGprsSsfReturnable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 50))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 83))])], rr=[], ev=None, er=[])
    
    _all_ = [
        cap_gprssf_scfAC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_mSISDN,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimeZone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSMSClass,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeOrganization,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPTypeNumber,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress_pDPAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_endUserAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_qualityOfService,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_accessPointName,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_routeingAreaIdentity,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_chargingID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sGSNCapabilities,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationGPRS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_pDPInitiationType,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gGSNAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_secondaryPDP_context,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMEI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_gPRSEvent,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscGPRSInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_detachSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_gPRSEventSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_pDPID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_gPRSCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_accessPointName,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_pdpID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_gprsCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_gPRSEvent,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_miscGPRSInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_detachSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_gPRSEventSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1_pDPID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_sCIGPRSBillingChargingCharacteristics,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1,
        cap_gsmscf_gprsssfAC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_gprsCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_gPRSEvent,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_pDPID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventType,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_miscGPRSInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_detachSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_disconnectSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_gPRSEventSpecificInformation,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2_pDPID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_sCIGPRSBillingChargingCharacteristics,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0,
        capGprsSsfToScf,
        capGsmScfToGprsSsf,
        gprsProcessingPackage,
        gprsTimerPackage,
        gprsChargingPackage,
        gprsActivityTestPackage,
        gprsCancelPackage,
        gprsSSF_gsmSCFAbstractSyntax,
        _gprsSSF_gsmSCFAbstractSyntax_val_Type,
        __GenericGprsSSF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_accessPointName,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pdpID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSCause,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventType,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_miscGPRSInfo,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        ____________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_gPRSEventSpecificInformation,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceKey,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSEventType,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_mSISDN,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMSI,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_timeAndTimeZone,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gPRSMSClass,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_endUserAddress,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_qualityOfService,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_accessPointName,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_routeingAreaIdentity,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_chargingID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_sGSNCapabilities,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_locationInformationGPRS,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_pDPInitiationType,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_gGSNAddress,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_secondaryPDP_context,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_iMEI,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_gprsCause,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent__item_,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_gPRSEvent,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10_pDPID,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_10,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_accessPointName,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pdpID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_gPRSCause,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_pDPID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_serviceKey,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSEventType,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_mSISDN,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMSI,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_timeAndTimeZone,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gPRSMSClass,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress_pDPAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_endUserAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_qualityOfService,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_accessPointName,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_routeingAreaIdentity,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_chargingID,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_sGSNCapabilities,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_locationInformationGPRS,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_pDPInitiationType,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_gGSNAddress,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_secondaryPDP_context,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_iMEI,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_gprsCause,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_pDPID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9,
        ___________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent__item_,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_gPRSEvent,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_pDPID,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11,
        __________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        _________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_unidirectional_components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_unidirectional_components,
        _GenericGprsSSF_gsmSCF_PDUs_unidirectional,
        __GenericGprsSSF_gsmSCF_PDUs_begin_otid,
        __GenericGprsSSF_gsmSCF_PDUs_begin_dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_begin_components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_begin_components,
        _GenericGprsSSF_gsmSCF_PDUs_begin,
        __GenericGprsSSF_gsmSCF_PDUs_end_dtid,
        __GenericGprsSSF_gsmSCF_PDUs_end_dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_end_components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_end_components,
        _GenericGprsSSF_gsmSCF_PDUs_end,
        __GenericGprsSSF_gsmSCF_PDUs_continue__otid,
        __GenericGprsSSF_gsmSCF_PDUs_continue__dtid,
        __GenericGprsSSF_gsmSCF_PDUs_continue__dialoguePortion,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericGprsSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericGprsSSF_gsmSCF_PDUs_continue__components__item_,
        __GenericGprsSSF_gsmSCF_PDUs_continue__components,
        _GenericGprsSSF_gsmSCF_PDUs_continue_,
        _GenericGprsSSF_gsmSCF_PDUs_abort,
        GenericGprsSSF_gsmSCF_PDUs,
        GprsSsfToGsmScfInvokable,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_1,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_2,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_3,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_4_accessPointName,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_4_pdpID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_4,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_5_gPRSCause,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_5_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_5,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventType,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_miscGPRSInfo,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation_locationInformationGPRS,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_attachChangeOfPositionSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_accessPointName,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_chargingID,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_locationInformationGPRS,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeOrganization,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPTypeNumber,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress_pDPAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_endUserAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_qualityOfService,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_timeAndTimeZone,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation_gGSNAddress,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pdp_ContextchangeOfPositionSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_initiatingEntity,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation_routeingAreaUpdate,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_detachSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_initiatingEntity,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation_routeingAreaUpdate,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_disconnectSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_accessPointName,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeOrganization,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPTypeNumber,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress_pDPAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_endUserAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_qualityOfService,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_locationInformationGPRS,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_timeAndTimeZone,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_pDPInitiationType,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation_secondaryPDP_context,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentSpecificInformation,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_accessPointName,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_chargingID,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeOrganization,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPTypeNumber,
        _____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress_pDPAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_endUserAddress,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_qualityOfService,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_locationInformationGPRS,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_timeAndTimeZone,
        ____GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation_gGSNAddress,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation_pDPContextEstablishmentAcknowledgementSpecificInformation,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_gPRSEventSpecificInformation,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_6_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_6,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_7,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_serviceKey,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSEventType,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_mSISDN,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMSI,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_timeAndTimeZone,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gPRSMSClass,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress_pDPAddress,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_endUserAddress,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_qualityOfService,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_accessPointName,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_routeingAreaIdentity,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_chargingID,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_sGSNCapabilities,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_locationInformationGPRS,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_pDPInitiationType,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions__item_,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_extensions,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_gGSNAddress,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_secondaryPDP_context,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_8_iMEI,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_8,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_9_gprsCause,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_9_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_9,
        ___GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent__item_,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_10_gPRSEvent,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_10_pDPID,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_10,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_11,
        __GprsSsfToGsmScfInvokable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        _GprsSsfToGsmScfInvokable_val_ArgumentType_12,
        GprsSsfToGsmScfReturnable,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_1,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_2,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_3,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_4_accessPointName,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_4_pdpID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_4,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_5,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_6_gPRSCause,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_6_pDPID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_6,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_7,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_serviceKey,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSEventType,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_mSISDN,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMSI,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_timeAndTimeZone,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gPRSMSClass,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeOrganization,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPTypeNumber,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress_pDPAddress,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_endUserAddress,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_qualityOfService,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_accessPointName,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_routeingAreaIdentity,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_chargingID,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_sGSNCapabilities,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_locationInformationGPRS,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_pDPInitiationType,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions__item_,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_extensions,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_gGSNAddress,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_secondaryPDP_context,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_8_iMEI,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_8,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_9_gprsCause,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_9_pDPID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_9,
        ___GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent__item_,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_10_gPRSEvent,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_10_pDPID,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_10,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_11,
        __GprsSsfToGsmScfReturnable_val_ArgumentType_12_sCIGPRSBillingChargingCharacteristics,
        _GprsSsfToGsmScfReturnable_val_ArgumentType_12,
        gsmSCF_gprsSSFAbstractSyntax,
        _gsmSCF_gprsSSFAbstractSyntax_val_Type,
        __GenericGsmSCF_gprsSSF_PDUs_unidirectional_dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_gprsCause,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_pDPID,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent__item_,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_gPRSEvent,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_pDPID,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_gprsCause,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_pDPID,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        ___________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent__item_,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_gPRSEvent,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_pDPID,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        _________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_unidirectional_components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_unidirectional_components,
        _GenericGsmSCF_gprsSSF_PDUs_unidirectional,
        __GenericGsmSCF_gprsSSF_PDUs_begin_otid,
        __GenericGsmSCF_gprsSSF_PDUs_begin_dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_begin_components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_begin_components,
        _GenericGsmSCF_gprsSSF_PDUs_begin,
        __GenericGsmSCF_gprsSSF_PDUs_end_dtid,
        __GenericGsmSCF_gprsSSF_PDUs_end_dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_end_components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_end_components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_end_components,
        _GenericGsmSCF_gprsSSF_PDUs_end,
        __GenericGsmSCF_gprsSSF_PDUs_continue__otid,
        __GenericGsmSCF_gprsSSF_PDUs_continue__dtid,
        __GenericGsmSCF_gprsSSF_PDUs_continue__dialoguePortion,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS_reject,
        ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__basicROS,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericGsmSCF_gprsSSF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericGsmSCF_gprsSSF_PDUs_continue__components__item_,
        __GenericGsmSCF_gprsSSF_PDUs_continue__components,
        _GenericGsmSCF_gprsSSF_PDUs_continue_,
        _GenericGsmSCF_gprsSSF_PDUs_abort,
        GenericGsmSCF_gprsSSF_PDUs,
        GsmScfToGprsSsfInvokable,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_1,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_2,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_3,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_4_gprsCause,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_4_pDPID,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_4,
        ___GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent__item_,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_5_gPRSEvent,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_5_pDPID,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_5,
        __GsmScfToGprsSsfInvokable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        _GsmScfToGprsSsfInvokable_val_ArgumentType_6,
        GsmScfToGprsSsfReturnable,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_1,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_2,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_3,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_4_gprsCause,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_4_pDPID,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_4,
        ___GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent__item_,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_5_gPRSEvent,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_5_pDPID,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_5,
        __GsmScfToGprsSsfReturnable_val_ArgumentType_6_sCIGPRSBillingChargingCharacteristics,
        _GsmScfToGprsSsfReturnable_val_ArgumentType_6,
    ]

class CAP_gsmSCF_gsmSRF_ops_args:

    _name_  = u'CAP-gsmSCF-gsmSRF-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 103, 7]
    
    _obj_ = [
        u'playAnnouncement',
        u'PlayAnnouncementArg',
        u'promptAndCollectUserInformation',
        u'PromptAndCollectUserInformationArg',
        u'ReceivedInformationArg',
        u'specializedResourceReport',
        u'SpecializedResourceReportArg',
        ]
    _type_ = [
        u'PlayAnnouncementArg',
        u'PromptAndCollectUserInformationArg',
        u'ReceivedInformationArg',
        u'SpecializedResourceReportArg',
        ]
    _set_ = [
        ]
    _val_ = [
        u'playAnnouncement',
        u'promptAndCollectUserInformation',
        u'specializedResourceReport',
        ]
    _class_ = [
        u'playAnnouncement',
        u'promptAndCollectUserInformation',
        u'specializedResourceReport',
        ]
    _param_ = [
        u'playAnnouncement',
        u'PlayAnnouncementArg',
        u'promptAndCollectUserInformation',
        u'PromptAndCollectUserInformationArg',
        u'ReceivedInformationArg',
        ]
    
    #-----< playAnnouncement >-----#
    playAnnouncement = CLASS(name=u'playAnnouncement', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< PlayAnnouncementArg >-----#
    PlayAnnouncementArg = SEQ(name=u'PlayAnnouncementArg', mode=MODE_TYPE, param=True)
    
    #-----< promptAndCollectUserInformation >-----#
    promptAndCollectUserInformation = CLASS(name=u'promptAndCollectUserInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< PromptAndCollectUserInformationArg >-----#
    PromptAndCollectUserInformationArg = SEQ(name=u'PromptAndCollectUserInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< ReceivedInformationArg >-----#
    ReceivedInformationArg = CHOICE(name=u'ReceivedInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< specializedResourceReport >-----#
    specializedResourceReport = CLASS(name=u'specializedResourceReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _specializedResourceReport_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    specializedResourceReport._val = dict([(u'ArgumentType', _specializedResourceReport_val_ArgumentType), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])
    
    #-----< SpecializedResourceReportArg >-----#
    SpecializedResourceReportArg = CHOICE(name=u'SpecializedResourceReportArg', mode=MODE_TYPE)
    _SpecializedResourceReportArg_allAnnouncementsComplete = NULL(name=u'allAnnouncementsComplete', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SpecializedResourceReportArg_firstAnnouncementStarted = NULL(name=u'firstAnnouncementStarted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SpecializedResourceReportArg._cont = ASN1Dict([
        (u'allAnnouncementsComplete', _SpecializedResourceReportArg_allAnnouncementsComplete),
        (u'firstAnnouncementStarted', _SpecializedResourceReportArg_firstAnnouncementStarted),
        ])
    SpecializedResourceReportArg._ext = None
    
    _all_ = [
        specializedResourceReport,
        _specializedResourceReport_val_ArgumentType,
        _SpecializedResourceReportArg_allAnnouncementsComplete,
        _SpecializedResourceReportArg_firstAnnouncementStarted,
        SpecializedResourceReportArg,
    ]

class CAP_gsmSCF_gsmSRF_pkgs_contracts_acs:

    _name_  = u'CAP-gsmSCF-gsmSRF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 104, 7]
    
    _obj_ = [
        u'gsmSRF-gsmSCF-ac',
        u'gsmSRF-gsmSCF-contract',
        u'specializedResourceControlPackage',
        u'gsmSRF-scfCancelPackage',
        u'activityTestPackage',
        u'gsmSRF-gsmSCF-abstract-syntax',
        u'BASIC-gsmSRF-gsmSCF-PDUs',
        u'GsmSRFgsmSCFInvokable',
        u'GsmSRFgsmSCFReturnable',
        ]
    _type_ = [
        u'BASIC-gsmSRF-gsmSCF-PDUs',
        ]
    _set_ = [
        u'GsmSRFgsmSCFInvokable',
        u'GsmSRFgsmSCFReturnable',
        ]
    _val_ = [
        u'gsmSRF-gsmSCF-ac',
        u'gsmSRF-gsmSCF-contract',
        u'specializedResourceControlPackage',
        u'gsmSRF-scfCancelPackage',
        u'activityTestPackage',
        u'gsmSRF-gsmSCF-abstract-syntax',
        ]
    _class_ = [
        u'gsmSRF-gsmSCF-ac',
        u'gsmSRF-gsmSCF-contract',
        u'specializedResourceControlPackage',
        u'gsmSRF-scfCancelPackage',
        u'activityTestPackage',
        u'gsmSRF-gsmSCF-abstract-syntax',
        u'GsmSRFgsmSCFInvokable',
        u'GsmSRFgsmSCFReturnable',
        ]
    _param_ = [
        u'specializedResourceControlPackage',
        u'gsmSRF-scfCancelPackage',
        ]
    
    #-----< gsmSRF-gsmSCF-ac >-----#
    gsmSRF_gsmSCF_ac = CLASS(name=u'gsmSRF-gsmSCF-ac', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        (u'correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_correlationID),
        (u'iPSSPCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iPSSPCapabilities),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_requestAnnouncementCompleteNotification),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1._cont = ASN1Dict([
        (u'collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_collectedInfo),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_disconnectFromIPForbidden),
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1._cont = ASN1Dict([
        (u'digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel_invokeID),
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1._cont = ASN1Dict([
        (u'invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_invokeID),
        (u'allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_allRequests),
        (u'callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0._cont = ASN1Dict([
        (u'problem', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem),
        (u'operation', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._ext = None
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-pkgs-contracts-acs', 'BASIC-gsmSRF-gsmSCF-PDUs')))
    gsmSRF_gsmSCF_ac._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 43))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 13))])), (u'dialogueMode', u'structured'), (u'termination', u'basic'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 14))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 22, 3, 14))])
    
    #-----< gsmSRF-gsmSCF-contract >-----#
    gsmSRF_gsmSCF_contract = CLASS(name=u'gsmSRF-gsmSCF-contract', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    gsmSRF_gsmSCF_contract._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 43))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 13))])
    
    #-----< specializedResourceControlPackage >-----#
    specializedResourceControlPackage = CLASS(name=u'specializedResourceControlPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gsmSRF-scfCancelPackage >-----#
    gsmSRF_scfCancelPackage = CLASS(name=u'gsmSRF-scfCancelPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< activityTestPackage >-----#
    activityTestPackage = CLASS(name=u'activityTestPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    activityTestPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))])
    
    #-----< gsmSRF-gsmSCF-abstract-syntax >-----#
    gsmSRF_gsmSCF_abstract_syntax = CLASS(name=u'gsmSRF-gsmSCF-abstract-syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _gsmSRF_gsmSCF_abstract_syntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-pkgs-contracts-acs', 'BASIC-gsmSRF-gsmSCF-PDUs')))
    gsmSRF_gsmSCF_abstract_syntax._val = dict([('Type', _gsmSRF_gsmSCF_abstract_syntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 14))])
    
    #-----< BASIC-gsmSRF-gsmSCF-PDUs >-----#
    BASIC_gsmSRF_gsmSCF_PDUs = CHOICE(name=u'BASIC-gsmSRF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional = SEQ(name=u'unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID),
        (u'allRequests', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        (u'interval', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo),
        (u'tone', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_tone),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'informationToSend', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend),
        (u'disconnectFromIPForbidden', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        (u'extensions', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        (u'callSegmentID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        (u'interval', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo),
        (u'tone', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_tone),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._cont = __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'collectedInfo', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_collectedInfo),
        (u'disconnectFromIPForbidden', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden),
        (u'informationToSend', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend),
        (u'extensions', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions),
        (u'callSegmentID', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4._cont = ASN1Dict([
        (u'digitsResponse', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), (u'ResultType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        (u'argument', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID),
        (u'allRequests', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        (u'interval', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo),
        (u'tone', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_tone),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend._ext = None
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'informationToSend', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend),
        (u'disconnectFromIPForbidden', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        (u'extensions', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        (u'callSegmentID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        (u'interval', ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo),
        (u'tone', ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_tone),
        ])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend._ext = None
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._cont = ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'collectedInfo', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_collectedInfo),
        (u'disconnectFromIPForbidden', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden),
        (u'informationToSend', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend),
        (u'extensions', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions),
        (u'callSegmentID', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4._cont = ASN1Dict([
        (u'digitsResponse', __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse),
        ])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), (u'ResultType', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._ext = None
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._ext = None
    _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._cont = ASN1Dict([
        (u'problem', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem),
        (u'operation', _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation),
        ])
    ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._ext = []
    _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'ParameterType', ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 4))])], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        (u'parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        (u'returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        (u'returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        (u'reject', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        (u'result', _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        (u'basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        (u'returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        (u'dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        (u'components', __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_begin = SEQ(name=u'begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        (u'argument', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        (u'parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        (u'returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        (u'returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        (u'reject', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        (u'result', _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        (u'basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS),
        (u'returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        (u'otid', __BASIC_gsmSRF_gsmSCF_PDUs_begin_otid),
        (u'dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_begin_dialoguePortion),
        (u'components', __BASIC_gsmSRF_gsmSCF_PDUs_begin_components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_begin._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_end = SEQ(name=u'end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __BASIC_gsmSRF_gsmSCF_PDUs_end_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_end_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_end_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        (u'argument', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        (u'parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        (u'returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        (u'returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        (u'reject', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        (u'result', _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        (u'basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS),
        (u'returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_end_components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_end._cont = ASN1Dict([
        (u'dtid', __BASIC_gsmSRF_gsmSCF_PDUs_end_dtid),
        (u'dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_end_dialoguePortion),
        (u'components', __BASIC_gsmSRF_gsmSCF_PDUs_end_components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_end._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_continue_ = SEQ(name=u'continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        (u'argument', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        (u'result', _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        (u'errcode', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        (u'parameter', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        (u'returnResult', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        (u'returnError', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        (u'reject', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        (u'result', ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        (u'result', _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        (u'basicROS', ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS),
        (u'returnResultNotLast', ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_._ext = None
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__components._cont = ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_
    __BASIC_gsmSRF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _BASIC_gsmSRF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        (u'otid', __BASIC_gsmSRF_gsmSCF_PDUs_continue__otid),
        (u'dtid', __BASIC_gsmSRF_gsmSCF_PDUs_continue__dtid),
        (u'dialoguePortion', __BASIC_gsmSRF_gsmSCF_PDUs_continue__dialoguePortion),
        (u'components', __BASIC_gsmSRF_gsmSCF_PDUs_continue__components),
        ])
    _BASIC_gsmSRF_gsmSCF_PDUs_continue_._ext = None
    _BASIC_gsmSRF_gsmSCF_PDUs_abort = SEQ(name=u'abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    BASIC_gsmSRF_gsmSCF_PDUs._cont = ASN1Dict([
        (u'unidirectional', _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional),
        (u'begin', _BASIC_gsmSRF_gsmSCF_PDUs_begin),
        (u'end', _BASIC_gsmSRF_gsmSCF_PDUs_end),
        (u'continue', _BASIC_gsmSRF_gsmSCF_PDUs_continue_),
        (u'abort', _BASIC_gsmSRF_gsmSCF_PDUs_abort),
        ])
    BASIC_gsmSRF_gsmSCF_PDUs._ext = None
    
    #-----< GsmSRFgsmSCFInvokable >-----#
    GsmSRFgsmSCFInvokable = CLASS(name=u'GsmSRFgsmSCFInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmSRFgsmSCFInvokable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions._cont = ___GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions__item_
    __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_1._ext = []
    _GsmSRFgsmSCFInvokable_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _GsmSRFgsmSCFInvokable_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', __GsmSRFgsmSCFInvokable_val_ArgumentType_2_invokeID),
        (u'allRequests', __GsmSRFgsmSCFInvokable_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_2._ext = None
    _GsmSRFgsmSCFInvokable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        (u'interval', ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo),
        (u'tone', ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_tone),
        ])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend._ext = None
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions._cont = ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions__item_
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFInvokable_val_ArgumentType_3._cont = ASN1Dict([
        (u'informationToSend', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend),
        (u'disconnectFromIPForbidden', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        (u'extensions', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions),
        (u'callSegmentID', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID),
        (u'requestAnnouncementStartedNotification', __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_3._ext = []
    _GsmSRFgsmSCFInvokable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        (u'interval', ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo),
        (u'tone', ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_tone),
        ])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend._ext = None
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions._cont = ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions__item_
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFInvokable_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFInvokable_val_ArgumentType_4._cont = ASN1Dict([
        (u'collectedInfo', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_collectedInfo),
        (u'disconnectFromIPForbidden', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_disconnectFromIPForbidden),
        (u'informationToSend', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend),
        (u'extensions', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions),
        (u'callSegmentID', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID),
        (u'requestAnnouncementStartedNotification', __GsmSRFgsmSCFInvokable_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFInvokable_val_ArgumentType_4._ext = []
    _GsmSRFgsmSCFInvokable_val_ResultType_4 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _GsmSRFgsmSCFInvokable_val_ResultType_4._cont = ASN1Dict([
        (u'digitsResponse', __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse),
        ])
    _GsmSRFgsmSCFInvokable_val_ResultType_4._ext = None
    _GsmSRFgsmSCFInvokable_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    GsmSRFgsmSCFInvokable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_4), (u'ResultType', _GsmSRFgsmSCFInvokable_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _GsmSRFgsmSCFInvokable_val_ArgumentType_5), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    
    #-----< GsmSRFgsmSCFReturnable >-----#
    GsmSRFgsmSCFReturnable = CLASS(name=u'GsmSRFgsmSCFReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _GsmSRFgsmSCFReturnable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions._cont = ___GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions__item_
    __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_1._ext = []
    _GsmSRFgsmSCFReturnable_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _GsmSRFgsmSCFReturnable_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', __GsmSRFgsmSCFReturnable_val_ArgumentType_2_invokeID),
        (u'allRequests', __GsmSRFgsmSCFReturnable_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_2._ext = None
    _GsmSRFgsmSCFReturnable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration),
        (u'interval', ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo),
        (u'tone', ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_tone),
        ])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend._ext = None
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions._cont = ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions__item_
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFReturnable_val_ArgumentType_3._cont = ASN1Dict([
        (u'informationToSend', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend),
        (u'disconnectFromIPForbidden', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementCompleteNotification),
        (u'extensions', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions),
        (u'callSegmentID', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID),
        (u'requestAnnouncementStartedNotification', __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_3._ext = []
    _GsmSRFgsmSCFReturnable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text._ext = None
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID._ext = None
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration),
        (u'interval', ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval),
        ])
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo._ext = []
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo),
        (u'tone', ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_tone),
        ])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend._ext = None
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions._cont = ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions__item_
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __GsmSRFgsmSCFReturnable_val_ArgumentType_4_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _GsmSRFgsmSCFReturnable_val_ArgumentType_4._cont = ASN1Dict([
        (u'collectedInfo', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_collectedInfo),
        (u'disconnectFromIPForbidden', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_disconnectFromIPForbidden),
        (u'informationToSend', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend),
        (u'extensions', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions),
        (u'callSegmentID', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID),
        (u'requestAnnouncementStartedNotification', __GsmSRFgsmSCFReturnable_val_ArgumentType_4_requestAnnouncementStartedNotification),
        ])
    _GsmSRFgsmSCFReturnable_val_ArgumentType_4._ext = []
    _GsmSRFgsmSCFReturnable_val_ResultType_4 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _GsmSRFgsmSCFReturnable_val_ResultType_4._cont = ASN1Dict([
        (u'digitsResponse', __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse),
        ])
    _GsmSRFgsmSCFReturnable_val_ResultType_4._ext = None
    GsmSRFgsmSCFReturnable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _GsmSRFgsmSCFReturnable_val_ArgumentType_4), (u'ResultType', _GsmSRFgsmSCFReturnable_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])
    
    _all_ = [
        gsmSRF_gsmSCF_ac,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iPSSPCapabilities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1,
        gsmSRF_gsmSCF_contract,
        activityTestPackage,
        gsmSRF_gsmSCF_abstract_syntax,
        _gsmSRF_gsmSCF_abstract_syntax_val_Type,
        __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend_tone,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_informationToSend,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_collectedInfo,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend_tone,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_informationToSend,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentID,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4_digitsResponse,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_4,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_inbandInfo,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend_tone,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_informationToSend,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_disconnectFromIPForbidden,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestAnnouncementStartedNotification,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_collectedInfo,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_disconnectFromIPForbidden,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ____________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_inbandInfo,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend_tone,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_informationToSend,
        ___________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_callSegmentID,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestAnnouncementStartedNotification,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        __________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4_digitsResponse,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_4,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem,
        _________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation,
        ________BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_unidirectional_components,
        _BASIC_gsmSRF_gsmSCF_PDUs_unidirectional,
        __BASIC_gsmSRF_gsmSCF_PDUs_begin_otid,
        __BASIC_gsmSRF_gsmSCF_PDUs_begin_dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_begin_components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_begin_components,
        _BASIC_gsmSRF_gsmSCF_PDUs_begin,
        __BASIC_gsmSRF_gsmSCF_PDUs_end_dtid,
        __BASIC_gsmSRF_gsmSCF_PDUs_end_dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_end_components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_end_components,
        _BASIC_gsmSRF_gsmSCF_PDUs_end,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__otid,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__dtid,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__dialoguePortion,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___BASIC_gsmSRF_gsmSCF_PDUs_continue__components__item_,
        __BASIC_gsmSRF_gsmSCF_PDUs_continue__components,
        _BASIC_gsmSRF_gsmSCF_PDUs_continue_,
        _BASIC_gsmSRF_gsmSCF_PDUs_abort,
        BASIC_gsmSRF_gsmSCF_PDUs,
        GsmSRFgsmSCFInvokable,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_1_correlationID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_1_iPSSPCapabilities,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions__item_,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_1_extensions,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_1,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_2_invokeID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_2_allRequests,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_2_callSegmentToCancel,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_2,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend_tone,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_informationToSend,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_disconnectFromIPForbidden,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions__item_,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_extensions,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_callSegmentID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_3_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_3,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_collectedInfo,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_disconnectFromIPForbidden,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend_tone,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_informationToSend,
        ___GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions__item_,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_extensions,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_callSegmentID,
        __GsmSRFgsmSCFInvokable_val_ArgumentType_4_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_4,
        __GsmSRFgsmSCFInvokable_val_ResultType_4_digitsResponse,
        _GsmSRFgsmSCFInvokable_val_ResultType_4,
        _GsmSRFgsmSCFInvokable_val_ArgumentType_5,
        GsmSRFgsmSCFReturnable,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_1_correlationID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_1_iPSSPCapabilities,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions__item_,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_1_extensions,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_1,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_2_invokeID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_2_allRequests,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_2_callSegmentToCancel,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_2,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend_tone,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_informationToSend,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_disconnectFromIPForbidden,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementCompleteNotification,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions__item_,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_extensions,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_callSegmentID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_3_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_3,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_collectedInfo,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_disconnectFromIPForbidden,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_messageContent,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text_attributes,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_text,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID_variableMessage,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_messageID,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_numberOfRepetitions,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_duration,
        ____GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo_interval,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_inbandInfo,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend_tone,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_informationToSend,
        ___GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions__item_,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_extensions,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_callSegmentID,
        __GsmSRFgsmSCFReturnable_val_ArgumentType_4_requestAnnouncementStartedNotification,
        _GsmSRFgsmSCFReturnable_val_ArgumentType_4,
        __GsmSRFgsmSCFReturnable_val_ResultType_4_digitsResponse,
        _GsmSRFgsmSCFReturnable_val_ResultType_4,
    ]

class CAP_gsmSSF_gsmSCF_ops_args:

    _name_  = u'CAP-gsmSSF-gsmSCF-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 101, 7]
    
    _obj_ = [
        u'activityTest',
        u'applyCharging',
        u'ApplyChargingArg',
        u'applyChargingReport',
        u'ApplyChargingReportArg',
        u'assistRequestInstructions',
        u'AssistRequestInstructionsArg',
        u'callGap',
        u'CallGapArg',
        u'callInformationReport',
        u'CallInformationReportArg',
        u'callInformationRequest',
        u'CallInformationRequestArg',
        u'cancel',
        u'CancelArg',
        u'collectInformation',
        u'CollectInformationArg',
        u'connect',
        u'ConnectArg',
        u'connectToResource',
        u'ConnectToResourceArg',
        u'continue',
        u'continueWithArgument',
        u'ContinueWithArgumentArg',
        u'ContinueWithArgumentArgExtension',
        u'disconnectForwardConnection',
        u'disconnectForwardConnectionWithArgument',
        u'DisconnectForwardConnectionWithArgumentArg',
        u'disconnectLeg',
        u'DisconnectLegArg',
        u'entityReleased',
        u'EntityReleasedArg',
        u'establishTemporaryConnection',
        u'EstablishTemporaryConnectionArg',
        u'eventReportBCSM',
        u'EventReportBCSMArg',
        u'furnishChargingInformation',
        u'FurnishChargingInformationArg',
        u'initialDP',
        u'InitialDPArg',
        u'InitialDPArgExtension',
        u'initiateCallAttempt',
        u'InitiateCallAttemptArg',
        u'InitiateCallAttemptRes',
        u'moveLeg',
        u'MoveLegArg',
        u'playTone',
        u'PlayToneArg',
        u'releaseCall',
        u'ReleaseCallArg',
        u'AllCallSegments',
        u'AllCallSegmentsWithExtension',
        u'requestReportBCSMEvent',
        u'RequestReportBCSMEventArg',
        u'resetTimer',
        u'ResetTimerArg',
        u'sendChargingInformation',
        u'SendChargingInformationArg',
        u'splitLeg',
        u'SplitLegArg',
        ]
    _type_ = [
        u'ApplyChargingArg',
        u'ApplyChargingReportArg',
        u'AssistRequestInstructionsArg',
        u'CallGapArg',
        u'CallInformationReportArg',
        u'CallInformationRequestArg',
        u'CancelArg',
        u'CollectInformationArg',
        u'ConnectArg',
        u'ConnectToResourceArg',
        u'ContinueWithArgumentArg',
        u'ContinueWithArgumentArgExtension',
        u'DisconnectForwardConnectionWithArgumentArg',
        u'DisconnectLegArg',
        u'EntityReleasedArg',
        u'EstablishTemporaryConnectionArg',
        u'EventReportBCSMArg',
        u'FurnishChargingInformationArg',
        u'InitialDPArg',
        u'InitialDPArgExtension',
        u'InitiateCallAttemptArg',
        u'InitiateCallAttemptRes',
        u'MoveLegArg',
        u'PlayToneArg',
        u'ReleaseCallArg',
        u'AllCallSegments',
        u'AllCallSegmentsWithExtension',
        u'RequestReportBCSMEventArg',
        u'ResetTimerArg',
        u'SendChargingInformationArg',
        u'SplitLegArg',
        ]
    _set_ = [
        ]
    _val_ = [
        u'activityTest',
        u'applyCharging',
        u'applyChargingReport',
        u'assistRequestInstructions',
        u'callGap',
        u'callInformationReport',
        u'callInformationRequest',
        u'cancel',
        u'collectInformation',
        u'connect',
        u'connectToResource',
        u'continue',
        u'continueWithArgument',
        u'disconnectForwardConnection',
        u'disconnectForwardConnectionWithArgument',
        u'disconnectLeg',
        u'entityReleased',
        u'establishTemporaryConnection',
        u'eventReportBCSM',
        u'furnishChargingInformation',
        u'initialDP',
        u'initiateCallAttempt',
        u'moveLeg',
        u'playTone',
        u'releaseCall',
        u'requestReportBCSMEvent',
        u'resetTimer',
        u'sendChargingInformation',
        u'splitLeg',
        ]
    _class_ = [
        u'activityTest',
        u'applyCharging',
        u'applyChargingReport',
        u'assistRequestInstructions',
        u'callGap',
        u'callInformationReport',
        u'callInformationRequest',
        u'cancel',
        u'collectInformation',
        u'connect',
        u'connectToResource',
        u'continue',
        u'continueWithArgument',
        u'disconnectForwardConnection',
        u'disconnectForwardConnectionWithArgument',
        u'disconnectLeg',
        u'entityReleased',
        u'establishTemporaryConnection',
        u'eventReportBCSM',
        u'furnishChargingInformation',
        u'initialDP',
        u'initiateCallAttempt',
        u'moveLeg',
        u'playTone',
        u'releaseCall',
        u'requestReportBCSMEvent',
        u'resetTimer',
        u'sendChargingInformation',
        u'splitLeg',
        ]
    _param_ = [
        u'applyCharging',
        u'ApplyChargingArg',
        u'applyChargingReport',
        u'ApplyChargingReportArg',
        u'assistRequestInstructions',
        u'AssistRequestInstructionsArg',
        u'callGap',
        u'CallGapArg',
        u'callInformationReport',
        u'CallInformationReportArg',
        u'callInformationRequest',
        u'CallInformationRequestArg',
        u'cancel',
        u'CancelArg',
        u'collectInformation',
        u'CollectInformationArg',
        u'connect',
        u'ConnectArg',
        u'connectToResource',
        u'ConnectToResourceArg',
        u'continueWithArgument',
        u'ContinueWithArgumentArg',
        u'ContinueWithArgumentArgExtension',
        u'disconnectForwardConnectionWithArgument',
        u'DisconnectForwardConnectionWithArgumentArg',
        u'disconnectLeg',
        u'DisconnectLegArg',
        u'entityReleased',
        u'EntityReleasedArg',
        u'establishTemporaryConnection',
        u'EstablishTemporaryConnectionArg',
        u'eventReportBCSM',
        u'EventReportBCSMArg',
        u'furnishChargingInformation',
        u'FurnishChargingInformationArg',
        u'initialDP',
        u'InitialDPArg',
        u'InitialDPArgExtension',
        u'initiateCallAttempt',
        u'InitiateCallAttemptArg',
        u'InitiateCallAttemptRes',
        u'moveLeg',
        u'MoveLegArg',
        u'playTone',
        u'PlayToneArg',
        u'releaseCall',
        u'ReleaseCallArg',
        u'AllCallSegments',
        u'AllCallSegmentsWithExtension',
        u'requestReportBCSMEvent',
        u'RequestReportBCSMEventArg',
        u'resetTimer',
        u'ResetTimerArg',
        u'sendChargingInformation',
        u'SendChargingInformationArg',
        u'splitLeg',
        u'SplitLegArg',
        ]
    
    #-----< activityTest >-----#
    activityTest = CLASS(name=u'activityTest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    activityTest._val = dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])
    
    #-----< applyCharging >-----#
    applyCharging = CLASS(name=u'applyCharging', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ApplyChargingArg >-----#
    ApplyChargingArg = SEQ(name=u'ApplyChargingArg', mode=MODE_TYPE, param=True)
    
    #-----< applyChargingReport >-----#
    applyChargingReport = CLASS(name=u'applyChargingReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ApplyChargingReportArg >-----#
    ApplyChargingReportArg = OCT_STR(name=u'ApplyChargingReportArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CallResult')), param=True)
    
    #-----< assistRequestInstructions >-----#
    assistRequestInstructions = CLASS(name=u'assistRequestInstructions', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< AssistRequestInstructionsArg >-----#
    AssistRequestInstructionsArg = SEQ(name=u'AssistRequestInstructionsArg', mode=MODE_TYPE, param=True)
    
    #-----< callGap >-----#
    callGap = CLASS(name=u'callGap', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CallGapArg >-----#
    CallGapArg = SEQ(name=u'CallGapArg', mode=MODE_TYPE, param=True)
    
    #-----< callInformationReport >-----#
    callInformationReport = CLASS(name=u'callInformationReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CallInformationReportArg >-----#
    CallInformationReportArg = SEQ(name=u'CallInformationReportArg', mode=MODE_TYPE, param=True)
    
    #-----< callInformationRequest >-----#
    callInformationRequest = CLASS(name=u'callInformationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CallInformationRequestArg >-----#
    CallInformationRequestArg = SEQ(name=u'CallInformationRequestArg', mode=MODE_TYPE, param=True)
    
    #-----< cancel >-----#
    cancel = CLASS(name=u'cancel', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CancelArg >-----#
    CancelArg = CHOICE(name=u'CancelArg', mode=MODE_TYPE, param=True)
    
    #-----< collectInformation >-----#
    collectInformation = CLASS(name=u'collectInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< CollectInformationArg >-----#
    CollectInformationArg = SEQ(name=u'CollectInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< connect >-----#
    connect = CLASS(name=u'connect', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectArg >-----#
    ConnectArg = SEQ(name=u'ConnectArg', mode=MODE_TYPE, param=True)
    
    #-----< connectToResource >-----#
    connectToResource = CLASS(name=u'connectToResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectToResourceArg >-----#
    ConnectToResourceArg = SEQ(name=u'ConnectToResourceArg', mode=MODE_TYPE, param=True)
    
    #-----< continue >-----#
    continue_ = CLASS(name=u'continue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    continue_._val = dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))])
    
    #-----< continueWithArgument >-----#
    continueWithArgument = CLASS(name=u'continueWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ContinueWithArgumentArg >-----#
    ContinueWithArgumentArg = SEQ(name=u'ContinueWithArgumentArg', mode=MODE_TYPE, param=True)
    
    #-----< ContinueWithArgumentArgExtension >-----#
    ContinueWithArgumentArgExtension = SEQ(name=u'ContinueWithArgumentArgExtension', mode=MODE_TYPE, param=True)
    
    #-----< disconnectForwardConnection >-----#
    disconnectForwardConnection = CLASS(name=u'disconnectForwardConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._ext = None
    disconnectForwardConnection._val = dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))])
    
    #-----< disconnectForwardConnectionWithArgument >-----#
    disconnectForwardConnectionWithArgument = CLASS(name=u'disconnectForwardConnectionWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< DisconnectForwardConnectionWithArgumentArg >-----#
    DisconnectForwardConnectionWithArgumentArg = SEQ(name=u'DisconnectForwardConnectionWithArgumentArg', mode=MODE_TYPE, param=True)
    
    #-----< disconnectLeg >-----#
    disconnectLeg = CLASS(name=u'disconnectLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< DisconnectLegArg >-----#
    DisconnectLegArg = SEQ(name=u'DisconnectLegArg', mode=MODE_TYPE, param=True)
    
    #-----< entityReleased >-----#
    entityReleased = CLASS(name=u'entityReleased', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EntityReleasedArg >-----#
    EntityReleasedArg = CHOICE(name=u'EntityReleasedArg', mode=MODE_TYPE, param=True)
    
    #-----< establishTemporaryConnection >-----#
    establishTemporaryConnection = CLASS(name=u'establishTemporaryConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EstablishTemporaryConnectionArg >-----#
    EstablishTemporaryConnectionArg = SEQ(name=u'EstablishTemporaryConnectionArg', mode=MODE_TYPE, param=True)
    
    #-----< eventReportBCSM >-----#
    eventReportBCSM = CLASS(name=u'eventReportBCSM', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EventReportBCSMArg >-----#
    EventReportBCSMArg = SEQ(name=u'EventReportBCSMArg', mode=MODE_TYPE, param=True)
    
    #-----< furnishChargingInformation >-----#
    furnishChargingInformation = CLASS(name=u'furnishChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< FurnishChargingInformationArg >-----#
    FurnishChargingInformationArg = OCT_STR(name=u'FurnishChargingInformationArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'FCIBillingChargingCharacteristics')), param=True)
    
    #-----< initialDP >-----#
    initialDP = CLASS(name=u'initialDP', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitialDPArg >-----#
    InitialDPArg = SEQ(name=u'InitialDPArg', mode=MODE_TYPE, param=True)
    
    #-----< InitialDPArgExtension >-----#
    InitialDPArgExtension = SEQ(name=u'InitialDPArgExtension', mode=MODE_TYPE, param=True)
    
    #-----< initiateCallAttempt >-----#
    initiateCallAttempt = CLASS(name=u'initiateCallAttempt', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitiateCallAttemptArg >-----#
    InitiateCallAttemptArg = SEQ(name=u'InitiateCallAttemptArg', mode=MODE_TYPE, param=True)
    
    #-----< InitiateCallAttemptRes >-----#
    InitiateCallAttemptRes = SEQ(name=u'InitiateCallAttemptRes', mode=MODE_TYPE, param=True)
    
    #-----< moveLeg >-----#
    moveLeg = CLASS(name=u'moveLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< MoveLegArg >-----#
    MoveLegArg = SEQ(name=u'MoveLegArg', mode=MODE_TYPE, param=True)
    
    #-----< playTone >-----#
    playTone = CLASS(name=u'playTone', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< PlayToneArg >-----#
    PlayToneArg = SEQ(name=u'PlayToneArg', mode=MODE_TYPE, param=True)
    
    #-----< releaseCall >-----#
    releaseCall = CLASS(name=u'releaseCall', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ReleaseCallArg >-----#
    ReleaseCallArg = CHOICE(name=u'ReleaseCallArg', mode=MODE_TYPE, param=True)
    
    #-----< AllCallSegments >-----#
    AllCallSegments = OCT_STR(name=u'AllCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'Cause')), param=True)
    
    #-----< AllCallSegmentsWithExtension >-----#
    AllCallSegmentsWithExtension = SEQ(name=u'AllCallSegmentsWithExtension', mode=MODE_TYPE, param=True)
    
    #-----< requestReportBCSMEvent >-----#
    requestReportBCSMEvent = CLASS(name=u'requestReportBCSMEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< RequestReportBCSMEventArg >-----#
    RequestReportBCSMEventArg = SEQ(name=u'RequestReportBCSMEventArg', mode=MODE_TYPE, param=True)
    
    #-----< resetTimer >-----#
    resetTimer = CLASS(name=u'resetTimer', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ResetTimerArg >-----#
    ResetTimerArg = SEQ(name=u'ResetTimerArg', mode=MODE_TYPE, param=True)
    
    #-----< sendChargingInformation >-----#
    sendChargingInformation = CLASS(name=u'sendChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SendChargingInformationArg >-----#
    SendChargingInformationArg = SEQ(name=u'SendChargingInformationArg', mode=MODE_TYPE, param=True)
    
    #-----< splitLeg >-----#
    splitLeg = CLASS(name=u'splitLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SplitLegArg >-----#
    SplitLegArg = SEQ(name=u'SplitLegArg', mode=MODE_TYPE, param=True)
    
    _all_ = [
        activityTest,
        continue_,
        disconnectForwardConnection,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1,
    ]

class CAP_gsmSSF_gsmSCF_pkgs_contracts_acs:

    _name_  = u'CAP-gsmSSF-gsmSCF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 102, 7]
    
    _obj_ = [
        u'capssf-scfGenericAC',
        u'capssf-scfAssistHandoffAC',
        u'capscf-ssfGenericAC',
        u'capSsfToScfGeneric',
        u'capAssistHandoffssfToScf',
        u'capScfToSsfGeneric',
        u'scfActivationPackage',
        u'gsmSRF-scfActivationOfAssistPackage',
        u'assistConnectionEstablishmentPackage',
        u'genericDisconnectResourcePackage',
        u'nonAssistedConnectionEstablishmentPackage',
        u'connectPackage',
        u'callHandlingPackage',
        u'bcsmEventHandlingPackage',
        u'ssfCallProcessingPackage',
        u'scfCallInitiationPackage',
        u'timerPackage',
        u'billingPackage',
        u'chargingPackage',
        u'trafficManagementPackage',
        u'callReportPackage',
        u'signallingControlPackage',
        u'activityTestPackage',
        u'cancelPackage',
        u'cphResponsePackage',
        u'exceptionInformPackage',
        u'playTonePackage',
        u'gsmSSF-scfGenericAbstractSyntax',
        u'GenericSSF-gsmSCF-PDUs',
        u'SsfToScfGenericInvokable',
        u'SsfToScfGenericReturnable',
        u'assistHandoff-gsmSSF-scfAbstractSyntax',
        u'AssistHandoffsSF-gsmSCF-PDUs',
        u'AssistHandoffssfToScfInvokable',
        u'AssistHandoffssfToScfReturnable',
        u'scf-gsmSSFGenericAbstractSyntax',
        u'GenericSCF-gsmSSF-PDUs',
        u'ScfToSsfGenericInvokable',
        u'ScfToSsfGenericReturnable',
        ]
    _type_ = [
        u'GenericSSF-gsmSCF-PDUs',
        u'AssistHandoffsSF-gsmSCF-PDUs',
        u'GenericSCF-gsmSSF-PDUs',
        ]
    _set_ = [
        u'SsfToScfGenericInvokable',
        u'SsfToScfGenericReturnable',
        u'AssistHandoffssfToScfInvokable',
        u'AssistHandoffssfToScfReturnable',
        u'ScfToSsfGenericInvokable',
        u'ScfToSsfGenericReturnable',
        ]
    _val_ = [
        u'capssf-scfGenericAC',
        u'capssf-scfAssistHandoffAC',
        u'capscf-ssfGenericAC',
        u'capSsfToScfGeneric',
        u'capAssistHandoffssfToScf',
        u'capScfToSsfGeneric',
        u'scfActivationPackage',
        u'gsmSRF-scfActivationOfAssistPackage',
        u'assistConnectionEstablishmentPackage',
        u'genericDisconnectResourcePackage',
        u'nonAssistedConnectionEstablishmentPackage',
        u'connectPackage',
        u'callHandlingPackage',
        u'bcsmEventHandlingPackage',
        u'ssfCallProcessingPackage',
        u'scfCallInitiationPackage',
        u'timerPackage',
        u'billingPackage',
        u'chargingPackage',
        u'trafficManagementPackage',
        u'callReportPackage',
        u'signallingControlPackage',
        u'activityTestPackage',
        u'cancelPackage',
        u'cphResponsePackage',
        u'exceptionInformPackage',
        u'playTonePackage',
        u'gsmSSF-scfGenericAbstractSyntax',
        u'assistHandoff-gsmSSF-scfAbstractSyntax',
        u'scf-gsmSSFGenericAbstractSyntax',
        ]
    _class_ = [
        u'capssf-scfGenericAC',
        u'capssf-scfAssistHandoffAC',
        u'capscf-ssfGenericAC',
        u'capSsfToScfGeneric',
        u'capAssistHandoffssfToScf',
        u'capScfToSsfGeneric',
        u'scfActivationPackage',
        u'gsmSRF-scfActivationOfAssistPackage',
        u'assistConnectionEstablishmentPackage',
        u'genericDisconnectResourcePackage',
        u'nonAssistedConnectionEstablishmentPackage',
        u'connectPackage',
        u'callHandlingPackage',
        u'bcsmEventHandlingPackage',
        u'ssfCallProcessingPackage',
        u'scfCallInitiationPackage',
        u'timerPackage',
        u'billingPackage',
        u'chargingPackage',
        u'trafficManagementPackage',
        u'callReportPackage',
        u'signallingControlPackage',
        u'activityTestPackage',
        u'cancelPackage',
        u'cphResponsePackage',
        u'exceptionInformPackage',
        u'playTonePackage',
        u'gsmSSF-scfGenericAbstractSyntax',
        u'SsfToScfGenericInvokable',
        u'SsfToScfGenericReturnable',
        u'assistHandoff-gsmSSF-scfAbstractSyntax',
        u'AssistHandoffssfToScfInvokable',
        u'AssistHandoffssfToScfReturnable',
        u'scf-gsmSSFGenericAbstractSyntax',
        u'ScfToSsfGenericInvokable',
        u'ScfToSsfGenericReturnable',
        ]
    _param_ = [
        u'scfActivationPackage',
        u'gsmSRF-scfActivationOfAssistPackage',
        u'assistConnectionEstablishmentPackage',
        u'genericDisconnectResourcePackage',
        u'nonAssistedConnectionEstablishmentPackage',
        u'connectPackage',
        u'callHandlingPackage',
        u'bcsmEventHandlingPackage',
        u'ssfCallProcessingPackage',
        u'scfCallInitiationPackage',
        u'timerPackage',
        u'billingPackage',
        u'chargingPackage',
        u'trafficManagementPackage',
        u'callReportPackage',
        u'signallingControlPackage',
        u'cancelPackage',
        u'cphResponsePackage',
        u'exceptionInformPackage',
        u'playTonePackage',
        ]
    
    #-----< capssf-scfGenericAC >-----#
    capssf_scfGenericAC = CLASS(name=u'capssf-scfGenericAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID),
        (u'cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_legID),
        (u'cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        (u'callSegmentFailure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure),
        (u'bCSM-Failure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceKey),
        (u'calledPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber),
        (u'callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber),
        (u'callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysCategory),
        (u'cGEncountered', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cGEncountered),
        (u'iPSSPCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities),
        (u'locationNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber),
        (u'originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions),
        (u'highLayerCompatibility', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_highLayerCompatibility),
        (u'additionalCallingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber),
        (u'bearerCapability', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability),
        (u'eventTypeBCSM', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_eventTypeBCSM),
        (u'redirectingPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID),
        (u'redirectionInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectionInformation),
        (u'cause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier),
        (u'cug-Index', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Index),
        (u'cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Interlock),
        (u'cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess),
        (u'iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iMSI),
        (u'subscriberState', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_subscriberState),
        (u'locationInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationInformation),
        (u'ext-basicServiceCode', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_ext_basicServiceCode),
        (u'callReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callReferenceNumber),
        (u'mscAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_mscAddress),
        (u'calledPartyBCDNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber),
        (u'timeAndTimezone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone),
        (u'callForwardingSS-Pending', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending),
        (u'initialDPArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress),
        (u'correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID),
        (u'scfID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_naOliInfo),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber),
        (u'originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID),
        (u'callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode),
        (u'legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        (u'bcsmEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        (u'eventTypeBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM),
        (u'legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_legID),
        (u'miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo),
        (u'extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._cont = _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4._cont = ASN1Dict([
        (u'allCallSegments', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments),
        (u'allCallSegmentsWithExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        (u'requestedInformationTypeList', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_requestedInformationTypeList),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions),
        (u'legID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_legID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._cont = ASN1Dict([(u'unknownRequestedInfo', 1), (u'requestedInfoNotAvailable', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_._ext = []
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'requestedInformationList', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList),
        (u'extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions),
        (u'legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_legID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID),
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        (u'invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_invokeID),
        (u'allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_allRequests),
        (u'callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0._cont = ASN1Dict([
        (u'problem', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem),
        (u'operation', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID),
        (u'srfConnection', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics),
        (u'partyToCharge', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_partyToCharge),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions),
        (u'aChChargingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8._cont = ASN1Dict([
        (u'destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress),
        (u'alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_alertingPattern),
        (u'originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier),
        (u'callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_callingPartysCategory),
        (u'redirectingPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID),
        (u'redirectionInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectionInformation),
        (u'genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber),
        (u'legToBeConnected', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_legToBeConnected),
        (u'cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_Interlock),
        (u'cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement),
        (u'oCSIApplicable', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_oCSIApplicable),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_naOliInfo),
        (u'bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested),
        (u'suppress-N-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppress_N_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8._ext = [u'suppress-N-CSI']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9._cont = ASN1Dict([
        (u'alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_alertingPattern),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_callingPartysCategory),
        (u'genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers),
        (u'cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_Interlock),
        (u'cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier),
        (u'suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_naOliInfo),
        (u'bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested),
        (u'suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1._cont = ASN1Dict([
        (u'legToBeReleased', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_legToBeReleased),
        (u'releaseCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2._cont = ASN1Dict([
        (u'legIDToMove', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_legIDToMove),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3._cont = ASN1Dict([
        (u'legToBeSplit', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_legToBeSplit),
        (u'newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0._cont = ASN1Dict([
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress),
        (u'none', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_none),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10._cont = ASN1Dict([
        (u'resourceAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID),
        (u'legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11._cont = ASN1Dict([
        (u'legOrCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment),
        (u'bursts', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_bursts),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics),
        (u'partyToCharge', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_partyToCharge),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13._cont = ASN1Dict([
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1._cont = ASN1Dict([
        (u'collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_collectedInfo),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden),
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1._cont = ASN1Dict([
        (u'digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1._ext = None
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14._cont = ASN1Dict([
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2._cont = ASN1Dict([
        (u'alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_alertingPattern),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_callingPartysCategory),
        (u'genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers),
        (u'cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_Interlock),
        (u'cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier),
        (u'suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_naOliInfo),
        (u'bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested),
        (u'suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15._cont = ASN1Dict([
        (u'timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timerID),
        (u'timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timervalue),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria = CHOICE(name=u'gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria = SEQ(name=u'compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria),
        (u'scfID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria),
        (u'compoundGapCriteria', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapIndicators = SEQ(name=u'gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_controlType = ENUM(name=u'controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment = CHOICE(name=u'gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration),
        (u'interval', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo._ext = []
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo),
        (u'tone', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend._ext = None
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment._cont = ASN1Dict([
        (u'informationToSend', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend),
        (u'releaseCause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16._cont = ASN1Dict([
        (u'gapCriteria', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria),
        (u'gapIndicators', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapIndicators),
        (u'controlType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_controlType),
        (u'gapTreatment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17._cont = ASN1Dict([
        (u'destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions),
        (u'legToBeCreated', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_legToBeCreated),
        (u'newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment),
        (u'callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber),
        (u'callReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callReferenceNumber),
        (u'gsmSCFAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_gsmSCFAddress),
        (u'suppress-T-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_suppress_T_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0._cont = ASN1Dict([
        (u'supportedCamelPhases', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_supportedCamelPhases),
        (u'offeredCamel4Functionalities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_offeredCamel4Functionalities),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions),
        (u'releaseCallArgExtensionAllowed', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0._ext = [u'releaseCallArgExtensionAllowed']
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSSF-gsmSCF-PDUs')))
    capssf_scfGenericAC._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 38))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 11))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 33))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 41))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 29))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 25))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 3))])), (u'dialogueMode', u'structured'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 23, 5, 4))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 23, 3, 4))])
    
    #-----< capssf-scfAssistHandoffAC >-----#
    capssf_scfAssistHandoffAC = CLASS(name=u'capssf-scfAssistHandoffAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18._cont = ASN1Dict([
        (u'correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID),
        (u'iPSSPCapabilities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID),
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19._cont = ASN1Dict([
        (u'invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_invokeID),
        (u'allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_allRequests),
        (u'callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3._cont = ASN1Dict([
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress),
        (u'none', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_none),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20._cont = ASN1Dict([
        (u'resourceAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21._cont = ASN1Dict([
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4._cont = ASN1Dict([
        (u'collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_collectedInfo),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden),
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0._cont = ASN1Dict([
        (u'digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22._cont = ASN1Dict([
        (u'timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timerID),
        (u'timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timervalue),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22._ext = []
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'AssistHandoffsSF-gsmSCF-PDUs')))
    capssf_scfAssistHandoffAC._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 5))])), (u'dialogueMode', u'structured'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0), ('id', (0, 4, 0, 0, 1, 23, 5, 6))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 23, 3, 6))])
    
    #-----< capscf-ssfGenericAC >-----#
    capscf_ssfGenericAC = CLASS(name=u'capscf-ssfGenericAC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress),
        (u'correlationID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID),
        (u'scfID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_naOliInfo),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber),
        (u'originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID),
        (u'callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode),
        (u'legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24._cont = ASN1Dict([
        (u'bcsmEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM._ext = None
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3._cont = ASN1Dict([
        (u'eventTypeBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM),
        (u'legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_legID),
        (u'miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_miscCallInfo),
        (u'extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._cont = _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26._cont = ASN1Dict([
        (u'allCallSegments', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments),
        (u'allCallSegmentsWithExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27._cont = ASN1Dict([
        (u'requestedInformationTypeList', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions),
        (u'legID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_legID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue._ext = None
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue),
        ])
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_._ext = []
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4._cont = ASN1Dict([
        (u'requestedInformationList', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList),
        (u'extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions),
        (u'legID', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_legID),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID),
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28._cont = ASN1Dict([
        (u'invokeID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_invokeID),
        (u'allRequests', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_allRequests),
        (u'callSegmentToCancel', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID),
        (u'srfConnection', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics),
        (u'partyToCharge', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_partyToCharge),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions),
        (u'aChChargingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30._cont = ASN1Dict([
        (u'destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress),
        (u'alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_alertingPattern),
        (u'originalCalledPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier),
        (u'callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory),
        (u'redirectingPartyID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID),
        (u'redirectionInformation', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectionInformation),
        (u'genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber),
        (u'legToBeConnected', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_legToBeConnected),
        (u'cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_Interlock),
        (u'cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement),
        (u'oCSIApplicable', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_naOliInfo),
        (u'bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested),
        (u'suppress-N-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30._ext = [u'suppress-N-CSI']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31._cont = ASN1Dict([
        (u'alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_alertingPattern),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_callingPartysCategory),
        (u'genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers),
        (u'cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_Interlock),
        (u'cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier),
        (u'suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_naOliInfo),
        (u'bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested),
        (u'suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5._cont = ASN1Dict([
        (u'legToBeReleased', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_legToBeReleased),
        (u'releaseCause', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0._cont = ASN1Dict([
        (u'legIDToMove', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_legIDToMove),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0._cont = ASN1Dict([
        (u'legToBeSplit', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_legToBeSplit),
        (u'newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6._cont = ASN1Dict([
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress),
        (u'none', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32._cont = ASN1Dict([
        (u'resourceAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID),
        (u'legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33._cont = ASN1Dict([
        (u'legOrCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment),
        (u'bursts', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_bursts),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34._cont = ASN1Dict([
        (u'destinationRoutingAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions),
        (u'legToBeCreated', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_legToBeCreated),
        (u'newCallSegment', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment),
        (u'callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber),
        (u'callReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber),
        (u'gsmSCFAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress),
        (u'suppress-T-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0._cont = ASN1Dict([
        (u'supportedCamelPhases', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_supportedCamelPhases),
        (u'offeredCamel4Functionalities', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_offeredCamel4Functionalities),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions),
        (u'releaseCallArgExtensionAllowed', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0._ext = [u'releaseCallArgExtensionAllowed']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35._cont = ASN1Dict([
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text._ext = None
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID._ext = None
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration),
        (u'interval', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo._ext = []
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo),
        (u'tone', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_tone),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7._cont = ASN1Dict([
        (u'collectedInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_collectedInfo),
        (u'disconnectFromIPForbidden', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden),
        (u'informationToSend', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID),
        (u'requestAnnouncementStartedNotification', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1._cont = ASN1Dict([
        (u'digitsResponse', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36._cont = ASN1Dict([
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8._cont = ASN1Dict([
        (u'alertingPattern', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_alertingPattern),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions),
        (u'serviceInteractionIndicatorsTwo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_callingPartysCategory),
        (u'genericNumbers', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers),
        (u'cug-Interlock', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_Interlock),
        (u'cug-OutgoingAccess', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess),
        (u'chargeNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber),
        (u'carrier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier),
        (u'suppressionOfAnnouncement', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement),
        (u'naOliInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_naOliInfo),
        (u'bor-InterrogationRequested', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested),
        (u'suppress-O-CSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37._cont = ASN1Dict([
        (u'timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timerID),
        (u'timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timervalue),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions),
        (u'callSegmentID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID),
        (u'cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID),
        (u'cause', ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause),
        ])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38._cont = ASN1Dict([
        (u'callSegmentFailure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure),
        (u'bCSM-Failure', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38._ext = None
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSCF-gsmSSF-PDUs')))
    capscf_ssfGenericAC._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 25))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 38))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 6))])), (u'dialogueMode', u'structured'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_1), ('id', (0, 4, 0, 0, 1, 23, 5, 7))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 23, 3, 8))])
    
    #-----< capSsfToScfGeneric >-----#
    capSsfToScfGeneric = CLASS(name=u'capSsfToScfGeneric', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capSsfToScfGeneric._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 38))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 11))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 33))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 41))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 29))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 25))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 3))])
    
    #-----< capAssistHandoffssfToScf >-----#
    capAssistHandoffssfToScf = CLASS(name=u'capAssistHandoffssfToScf', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capAssistHandoffssfToScf._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 15))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 5))])
    
    #-----< capScfToSsfGeneric >-----#
    capScfToSsfGeneric = CLASS(name=u'capScfToSsfGeneric', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    capScfToSsfGeneric._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 16))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 21))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 27))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 20))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 32))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 36))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 28))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 19))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 37))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 17))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 18))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 39))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 25))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7), (u'ResultType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 42))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 27, 24))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 26))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 38))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 23, 26, 6))])
    
    #-----< scfActivationPackage >-----#
    scfActivationPackage = CLASS(name=u'scfActivationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gsmSRF-scfActivationOfAssistPackage >-----#
    gsmSRF_scfActivationOfAssistPackage = CLASS(name=u'gsmSRF-scfActivationOfAssistPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< assistConnectionEstablishmentPackage >-----#
    assistConnectionEstablishmentPackage = CLASS(name=u'assistConnectionEstablishmentPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< genericDisconnectResourcePackage >-----#
    genericDisconnectResourcePackage = CLASS(name=u'genericDisconnectResourcePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< nonAssistedConnectionEstablishmentPackage >-----#
    nonAssistedConnectionEstablishmentPackage = CLASS(name=u'nonAssistedConnectionEstablishmentPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< connectPackage >-----#
    connectPackage = CLASS(name=u'connectPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< callHandlingPackage >-----#
    callHandlingPackage = CLASS(name=u'callHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< bcsmEventHandlingPackage >-----#
    bcsmEventHandlingPackage = CLASS(name=u'bcsmEventHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< ssfCallProcessingPackage >-----#
    ssfCallProcessingPackage = CLASS(name=u'ssfCallProcessingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< scfCallInitiationPackage >-----#
    scfCallInitiationPackage = CLASS(name=u'scfCallInitiationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< timerPackage >-----#
    timerPackage = CLASS(name=u'timerPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< billingPackage >-----#
    billingPackage = CLASS(name=u'billingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< chargingPackage >-----#
    chargingPackage = CLASS(name=u'chargingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< trafficManagementPackage >-----#
    trafficManagementPackage = CLASS(name=u'trafficManagementPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< callReportPackage >-----#
    callReportPackage = CLASS(name=u'callReportPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< signallingControlPackage >-----#
    signallingControlPackage = CLASS(name=u'signallingControlPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< activityTestPackage >-----#
    activityTestPackage = CLASS(name=u'activityTestPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    activityTestPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 34))])
    
    #-----< cancelPackage >-----#
    cancelPackage = CLASS(name=u'cancelPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< cphResponsePackage >-----#
    cphResponsePackage = CLASS(name=u'cphResponsePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< exceptionInformPackage >-----#
    exceptionInformPackage = CLASS(name=u'exceptionInformPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< playTonePackage >-----#
    playTonePackage = CLASS(name=u'playTonePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< gsmSSF-scfGenericAbstractSyntax >-----#
    gsmSSF_scfGenericAbstractSyntax = CLASS(name=u'gsmSSF-scfGenericAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _gsmSSF_scfGenericAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSSF-gsmSCF-PDUs')))
    gsmSSF_scfGenericAbstractSyntax._val = dict([('Type', _gsmSSF_scfGenericAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 23, 5, 4))])
    
    #-----< GenericSSF-gsmSCF-PDUs >-----#
    GenericSSF_gsmSCF_PDUs = CHOICE(name=u'GenericSSF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericSSF_gsmSCF_PDUs_unidirectional = SEQ(name=u'unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericSSF_gsmSCF_PDUs_unidirectional_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'requestedInformationList', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        (u'legID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'requestedInformationTypeList', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestedInformationTypeList),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions),
        (u'legID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_legID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID),
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'invokeID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_invokeID),
        (u'allRequests', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_allRequests),
        (u'callSegmentToCancel', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions),
        (u'carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        (u'alertingPattern', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_alertingPattern),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callingPartysCategory),
        (u'genericNumbers', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers),
        (u'cug-Interlock', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_Interlock),
        (u'cug-OutgoingAccess', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_OutgoingAccess),
        (u'chargeNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber),
        (u'carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier),
        (u'suppressionOfAnnouncement', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppressionOfAnnouncement),
        (u'naOliInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_naOliInfo),
        (u'bor-InterrogationRequested', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_bor_InterrogationRequested),
        (u'suppress-O-CSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress),
        (u'none', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_none),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        (u'resourceAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions),
        (u'serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        (u'callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        (u'legToBeReleased', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased),
        (u'releaseCause', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID),
        (u'cause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure._cont = ASN1Dict([
        (u'legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_legID),
        (u'cause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        (u'callSegmentFailure', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure),
        (u'bCSM-Failure', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress),
        (u'correlationID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID),
        (u'scfID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions),
        (u'carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier),
        (u'serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID),
        (u'naOliInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_naOliInfo),
        (u'chargeNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber),
        (u'originalCalledPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID),
        (u'callingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        (u'eventTypeBCSM', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM),
        (u'legID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legID),
        (u'miscCallInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_miscCallInfo),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        (u'serviceKey', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceKey),
        (u'calledPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber),
        (u'callingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber),
        (u'callingPartysCategory', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartysCategory),
        (u'cGEncountered', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cGEncountered),
        (u'iPSSPCapabilities', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities),
        (u'locationNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber),
        (u'originalCalledPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions),
        (u'highLayerCompatibility', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_highLayerCompatibility),
        (u'additionalCallingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber),
        (u'bearerCapability', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability),
        (u'eventTypeBCSM', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_eventTypeBCSM),
        (u'redirectingPartyID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID),
        (u'redirectionInformation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectionInformation),
        (u'cause', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause),
        (u'serviceInteractionIndicatorsTwo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        (u'carrier', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier),
        (u'cug-Index', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Index),
        (u'cug-Interlock', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Interlock),
        (u'cug-OutgoingAccess', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess),
        (u'iMSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iMSI),
        (u'subscriberState', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_subscriberState),
        (u'locationInformation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationInformation),
        (u'ext-basicServiceCode', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_ext_basicServiceCode),
        (u'callReferenceNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callReferenceNumber),
        (u'mscAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_mscAddress),
        (u'calledPartyBCDNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber),
        (u'timeAndTimezone', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone),
        (u'callForwardingSS-Pending', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending),
        (u'initialDPArgExtension', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        (u'destinationRoutingAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions),
        (u'legToBeCreated', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_legToBeCreated),
        (u'newCallSegment', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment),
        (u'callingPartyNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber),
        (u'callReferenceNumber', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callReferenceNumber),
        (u'gsmSCFAddress', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_gsmSCFAddress),
        (u'suppress-T-CSI', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_suppress_T_CSI),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18._cont = ASN1Dict([
        (u'supportedCamelPhases', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_supportedCamelPhases),
        (u'offeredCamel4Functionalities', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_offeredCamel4Functionalities),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions),
        (u'releaseCallArgExtensionAllowed', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18._ext = [u'releaseCallArgExtensionAllowed']
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        (u'legIDToMove', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_legIDToMove),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        (u'allCallSegments', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments),
        (u'allCallSegmentsWithExtension', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        (u'legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        (u'bcsmEvents', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        (u'timerID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timerID),
        (u'timervalue', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timervalue),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions),
        (u'callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        (u'partyToCharge', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_partyToCharge),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._cont = ASN1Dict([
        (u'legToBeSplit', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_legToBeSplit),
        (u'newCallSegment', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        (u'interval', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo),
        (u'tone', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_tone),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25._cont = ASN1Dict([
        (u'informationToSend', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend),
        (u'disconnectFromIPForbidden', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions),
        (u'callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        (u'legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26._cont = ASN1Dict([
        (u'legOrCallSegment', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment),
        (u'bursts', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_bursts),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        (u'interval', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo),
        (u'tone', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_tone),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions._cont = __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions__item_
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27._cont = ASN1Dict([
        (u'collectedInfo', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_collectedInfo),
        (u'disconnectFromIPForbidden', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden),
        (u'informationToSend', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend),
        (u'extensions', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions),
        (u'callSegmentID', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27._ext = []
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27._cont = ASN1Dict([
        (u'digitsResponse', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18), (u'ResultType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27), (u'ResultType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria = CHOICE(name=u'gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria = SEQ(name=u'compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria),
        (u'scfID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria),
        (u'compoundGapCriteria', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapIndicators = SEQ(name=u'gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_controlType = ENUM(name=u'controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment = CHOICE(name=u'gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration),
        (u'interval', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._ext = []
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo),
        (u'tone', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_tone),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment._cont = ASN1Dict([
        (u'informationToSend', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend),
        (u'releaseCause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'gapCriteria', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria),
        (u'gapIndicators', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapIndicators),
        (u'controlType', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_controlType),
        (u'gapTreatment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'requestedInformationTypeList', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions),
        (u'legID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'invokeID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID),
        (u'allRequests', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests),
        (u'callSegmentToCancel', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        (u'carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        (u'none', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        (u'resourceAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        (u'alertingPattern', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_alertingPattern),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions),
        (u'serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callingPartysCategory),
        (u'genericNumbers', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers),
        (u'cug-Interlock', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_Interlock),
        (u'cug-OutgoingAccess', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_OutgoingAccess),
        (u'chargeNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber),
        (u'carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier),
        (u'suppressionOfAnnouncement', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppressionOfAnnouncement),
        (u'naOliInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_naOliInfo),
        (u'bor-InterrogationRequested', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_bor_InterrogationRequested),
        (u'suppress-O-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        (u'legToBeReleased', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legToBeReleased),
        (u'releaseCause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID),
        (u'cause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_legID),
        (u'cause', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14._cont = ASN1Dict([
        (u'callSegmentFailure', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure),
        (u'bCSM-Failure', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress),
        (u'correlationID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID),
        (u'scfID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions),
        (u'carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier),
        (u'serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID),
        (u'naOliInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_naOliInfo),
        (u'chargeNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber),
        (u'originalCalledPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID),
        (u'callingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        (u'serviceKey', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceKey),
        (u'calledPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber),
        (u'callingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber),
        (u'callingPartysCategory', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartysCategory),
        (u'cGEncountered', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cGEncountered),
        (u'iPSSPCapabilities', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities),
        (u'locationNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber),
        (u'originalCalledPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions),
        (u'highLayerCompatibility', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_highLayerCompatibility),
        (u'additionalCallingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber),
        (u'bearerCapability', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability),
        (u'eventTypeBCSM', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_eventTypeBCSM),
        (u'redirectingPartyID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID),
        (u'redirectionInformation', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectionInformation),
        (u'cause', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause),
        (u'serviceInteractionIndicatorsTwo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        (u'carrier', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier),
        (u'cug-Index', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Index),
        (u'cug-Interlock', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Interlock),
        (u'cug-OutgoingAccess', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess),
        (u'iMSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iMSI),
        (u'subscriberState', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_subscriberState),
        (u'locationInformation', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationInformation),
        (u'ext-basicServiceCode', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_ext_basicServiceCode),
        (u'callReferenceNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callReferenceNumber),
        (u'mscAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_mscAddress),
        (u'calledPartyBCDNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber),
        (u'timeAndTimezone', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone),
        (u'callForwardingSS-Pending', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending),
        (u'initialDPArgExtension', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        (u'destinationRoutingAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions),
        (u'legToBeCreated', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_legToBeCreated),
        (u'newCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment),
        (u'callingPartyNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber),
        (u'callReferenceNumber', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callReferenceNumber),
        (u'gsmSCFAddress', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_gsmSCFAddress),
        (u'suppress-T-CSI', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_suppress_T_CSI),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18._cont = ASN1Dict([
        (u'supportedCamelPhases', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_offeredCamel4Functionalities),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions),
        (u'releaseCallArgExtensionAllowed', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18._ext = [u'releaseCallArgExtensionAllowed']
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        (u'legIDToMove', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_legIDToMove),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        (u'allCallSegments', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments),
        (u'allCallSegmentsWithExtension', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        (u'legID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_._ext = []
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        (u'bcsmEvents', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        (u'timerID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timerID),
        (u'timervalue', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timervalue),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions),
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        (u'partyToCharge', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_partyToCharge),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24._cont = ASN1Dict([
        (u'legToBeSplit', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_legToBeSplit),
        (u'newCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        (u'interval', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo),
        (u'tone', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_tone),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25._cont = ASN1Dict([
        (u'informationToSend', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend),
        (u'disconnectFromIPForbidden', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions),
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        (u'legID', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26._cont = ASN1Dict([
        (u'legOrCallSegment', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment),
        (u'bursts', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_bursts),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        (u'interval', ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo),
        (u'tone', ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_tone),
        ])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend._ext = None
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions._cont = ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions__item_
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27._cont = ASN1Dict([
        (u'collectedInfo', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_collectedInfo),
        (u'disconnectFromIPForbidden', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden),
        (u'informationToSend', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend),
        (u'extensions', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions),
        (u'callSegmentID', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27._ext = []
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27._cont = ASN1Dict([
        (u'digitsResponse', __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse),
        ])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 41))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18), (u'ResultType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27), (u'ResultType', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._cont = ASN1Dict([(u'unknownRequestedInfo', 1), (u'requestedInfoNotAvailable', 2)])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._ext = None
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._ext = None
    _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._cont = ASN1Dict([
        (u'problem', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem),
        (u'operation', _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation),
        ])
    ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._ext = []
    _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 4))])], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        (u'returnResult', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        (u'returnError', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        (u'reject', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        (u'returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_unidirectional_components._cont = ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_
    __GenericSSF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        (u'dialoguePortion', __GenericSSF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        (u'components', __GenericSSF_gsmSCF_PDUs_unidirectional_components),
        ])
    _GenericSSF_gsmSCF_PDUs_unidirectional._ext = None
    _GenericSSF_gsmSCF_PDUs_begin = SEQ(name=u'begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericSSF_gsmSCF_PDUs_begin_otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSSF_gsmSCF_PDUs_begin_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_begin_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSSF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        (u'returnResult', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        (u'returnError', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        (u'reject', _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS),
        (u'returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_begin_components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_begin_components._cont = ___GenericSSF_gsmSCF_PDUs_begin_components__item_
    __GenericSSF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        (u'otid', __GenericSSF_gsmSCF_PDUs_begin_otid),
        (u'dialoguePortion', __GenericSSF_gsmSCF_PDUs_begin_dialoguePortion),
        (u'components', __GenericSSF_gsmSCF_PDUs_begin_components),
        ])
    _GenericSSF_gsmSCF_PDUs_begin._ext = None
    _GenericSSF_gsmSCF_PDUs_end = SEQ(name=u'end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericSSF_gsmSCF_PDUs_end_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSSF_gsmSCF_PDUs_end_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_end_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSSF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        (u'returnResult', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        (u'returnError', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        (u'reject', _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS),
        (u'returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_end_components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_end_components._cont = ___GenericSSF_gsmSCF_PDUs_end_components__item_
    __GenericSSF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_end._cont = ASN1Dict([
        (u'dtid', __GenericSSF_gsmSCF_PDUs_end_dtid),
        (u'dialoguePortion', __GenericSSF_gsmSCF_PDUs_end_dialoguePortion),
        (u'components', __GenericSSF_gsmSCF_PDUs_end_components),
        ])
    _GenericSSF_gsmSCF_PDUs_end._ext = None
    _GenericSSF_gsmSCF_PDUs_continue_ = SEQ(name=u'continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericSSF_gsmSCF_PDUs_continue__otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSSF_gsmSCF_PDUs_continue__dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSSF_gsmSCF_PDUs_continue__dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSSF_gsmSCF_PDUs_continue__components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSSF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        (u'returnResult', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        (u'returnError', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        (u'reject', _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericSSF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS),
        (u'returnResultNotLast', ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericSSF_gsmSCF_PDUs_continue__components__item_._ext = None
    __GenericSSF_gsmSCF_PDUs_continue__components._cont = ___GenericSSF_gsmSCF_PDUs_continue__components__item_
    __GenericSSF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSSF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        (u'otid', __GenericSSF_gsmSCF_PDUs_continue__otid),
        (u'dtid', __GenericSSF_gsmSCF_PDUs_continue__dtid),
        (u'dialoguePortion', __GenericSSF_gsmSCF_PDUs_continue__dialoguePortion),
        (u'components', __GenericSSF_gsmSCF_PDUs_continue__components),
        ])
    _GenericSSF_gsmSCF_PDUs_continue_._ext = None
    _GenericSSF_gsmSCF_PDUs_abort = SEQ(name=u'abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericSSF_gsmSCF_PDUs._cont = ASN1Dict([
        (u'unidirectional', _GenericSSF_gsmSCF_PDUs_unidirectional),
        (u'begin', _GenericSSF_gsmSCF_PDUs_begin),
        (u'end', _GenericSSF_gsmSCF_PDUs_end),
        (u'continue', _GenericSSF_gsmSCF_PDUs_continue_),
        (u'abort', _GenericSSF_gsmSCF_PDUs_abort),
        ])
    GenericSSF_gsmSCF_PDUs._ext = None
    
    #-----< SsfToScfGenericInvokable >-----#
    SsfToScfGenericInvokable = CLASS(name=u'SsfToScfGenericInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SsfToScfGenericInvokable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    __SsfToScfGenericInvokable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_1_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_1_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', __SsfToScfGenericInvokable_val_ArgumentType_1_partyToCharge),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_1._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _SsfToScfGenericInvokable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_._ext = []
    __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList._cont = ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_
    __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_3_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_3_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    _SsfToScfGenericInvokable_val_ArgumentType_3._cont = ASN1Dict([
        (u'requestedInformationList', __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_3_extensions),
        (u'legID', __SsfToScfGenericInvokable_val_ArgumentType_3_legID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_3._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __SsfToScfGenericInvokable_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_4_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_4_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    _SsfToScfGenericInvokable_val_ArgumentType_4._cont = ASN1Dict([
        (u'requestedInformationTypeList', __SsfToScfGenericInvokable_val_ArgumentType_4_requestedInformationTypeList),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_4_extensions),
        (u'legID', __SsfToScfGenericInvokable_val_ArgumentType_4_legID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_4._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_5_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __SsfToScfGenericInvokable_val_ArgumentType_5_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_5._cont = ASN1Dict([
        (u'invokeID', __SsfToScfGenericInvokable_val_ArgumentType_5_invokeID),
        (u'allRequests', __SsfToScfGenericInvokable_val_ArgumentType_5_allRequests),
        (u'callSegmentToCancel', __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_5._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._cont = ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_
    __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_6_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_6_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers._cont = ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_
    __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericInvokable_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', __SsfToScfGenericInvokable_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_6_extensions),
        (u'carrier', __SsfToScfGenericInvokable_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', __SsfToScfGenericInvokable_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', __SsfToScfGenericInvokable_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', __SsfToScfGenericInvokable_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', __SsfToScfGenericInvokable_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', __SsfToScfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', __SsfToScfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', __SsfToScfGenericInvokable_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', __SsfToScfGenericInvokable_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', __SsfToScfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', __SsfToScfGenericInvokable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    _SsfToScfGenericInvokable_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_7_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_7_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_7_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers._cont = ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_
    __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_7_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_7._cont = ASN1Dict([
        (u'alertingPattern', __SsfToScfGenericInvokable_val_ArgumentType_7_alertingPattern),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', __SsfToScfGenericInvokable_val_ArgumentType_7_callingPartysCategory),
        (u'genericNumbers', __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers),
        (u'cug-Interlock', __SsfToScfGenericInvokable_val_ArgumentType_7_cug_Interlock),
        (u'cug-OutgoingAccess', __SsfToScfGenericInvokable_val_ArgumentType_7_cug_OutgoingAccess),
        (u'chargeNumber', __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber),
        (u'carrier', __SsfToScfGenericInvokable_val_ArgumentType_7_carrier),
        (u'suppressionOfAnnouncement', __SsfToScfGenericInvokable_val_ArgumentType_7_suppressionOfAnnouncement),
        (u'naOliInfo', __SsfToScfGenericInvokable_val_ArgumentType_7_naOliInfo),
        (u'bor-InterrogationRequested', __SsfToScfGenericInvokable_val_ArgumentType_7_bor_InterrogationRequested),
        (u'suppress-O-CSI', __SsfToScfGenericInvokable_val_ArgumentType_7_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_7._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress),
        (u'none', ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_none),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_8_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_8_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_8_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_8._cont = ASN1Dict([
        (u'resourceAddress', __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_8_extensions),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_8_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_8._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_9_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_9_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_9._cont = ASN1Dict([
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_9_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_9._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_11_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_11_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_11_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_11._cont = ASN1Dict([
        (u'callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_11_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_11._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_12_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_12_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_12_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_12._cont = ASN1Dict([
        (u'legToBeReleased', __SsfToScfGenericInvokable_val_ArgumentType_12_legToBeReleased),
        (u'releaseCause', __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_12_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_12._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_13 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID),
        (u'cause', ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure._ext = []
    __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_legID),
        (u'cause', ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_13._cont = ASN1Dict([
        (u'callSegmentFailure', __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure),
        (u'bCSM-Failure', __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_13._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_14 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_14_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_14_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_14_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_14_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_14._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress),
        (u'correlationID', __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID),
        (u'scfID', __SsfToScfGenericInvokable_val_ArgumentType_14_scfID),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_14_extensions),
        (u'carrier', __SsfToScfGenericInvokable_val_ArgumentType_14_carrier),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_14_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID),
        (u'naOliInfo', __SsfToScfGenericInvokable_val_ArgumentType_14_naOliInfo),
        (u'chargeNumber', __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber),
        (u'originalCalledPartyID', __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID),
        (u'callingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_14._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _SsfToScfGenericInvokable_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_15_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_15_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    __SsfToScfGenericInvokable_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_15_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_15_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_15._cont = ASN1Dict([
        (u'eventTypeBCSM', __SsfToScfGenericInvokable_val_ArgumentType_15_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM),
        (u'legID', __SsfToScfGenericInvokable_val_ArgumentType_15_legID),
        (u'miscCallInfo', __SsfToScfGenericInvokable_val_ArgumentType_15_miscCallInfo),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_15_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_15._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_16 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _SsfToScfGenericInvokable_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_17_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_17_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_17_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_17_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_17_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    _SsfToScfGenericInvokable_val_ArgumentType_17._cont = ASN1Dict([
        (u'serviceKey', __SsfToScfGenericInvokable_val_ArgumentType_17_serviceKey),
        (u'calledPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber),
        (u'callingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber),
        (u'callingPartysCategory', __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartysCategory),
        (u'cGEncountered', __SsfToScfGenericInvokable_val_ArgumentType_17_cGEncountered),
        (u'iPSSPCapabilities', __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities),
        (u'locationNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber),
        (u'originalCalledPartyID', __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_17_extensions),
        (u'highLayerCompatibility', __SsfToScfGenericInvokable_val_ArgumentType_17_highLayerCompatibility),
        (u'additionalCallingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber),
        (u'bearerCapability', __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability),
        (u'eventTypeBCSM', __SsfToScfGenericInvokable_val_ArgumentType_17_eventTypeBCSM),
        (u'redirectingPartyID', __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID),
        (u'redirectionInformation', __SsfToScfGenericInvokable_val_ArgumentType_17_redirectionInformation),
        (u'cause', __SsfToScfGenericInvokable_val_ArgumentType_17_cause),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericInvokable_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        (u'carrier', __SsfToScfGenericInvokable_val_ArgumentType_17_carrier),
        (u'cug-Index', __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Index),
        (u'cug-Interlock', __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Interlock),
        (u'cug-OutgoingAccess', __SsfToScfGenericInvokable_val_ArgumentType_17_cug_OutgoingAccess),
        (u'iMSI', __SsfToScfGenericInvokable_val_ArgumentType_17_iMSI),
        (u'subscriberState', __SsfToScfGenericInvokable_val_ArgumentType_17_subscriberState),
        (u'locationInformation', __SsfToScfGenericInvokable_val_ArgumentType_17_locationInformation),
        (u'ext-basicServiceCode', __SsfToScfGenericInvokable_val_ArgumentType_17_ext_basicServiceCode),
        (u'callReferenceNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_callReferenceNumber),
        (u'mscAddress', __SsfToScfGenericInvokable_val_ArgumentType_17_mscAddress),
        (u'calledPartyBCDNumber', __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber),
        (u'timeAndTimezone', __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone),
        (u'callForwardingSS-Pending', __SsfToScfGenericInvokable_val_ArgumentType_17_callForwardingSS_Pending),
        (u'initialDPArgExtension', __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_17._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress._cont = ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_
    __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_18_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_18_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_18_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_18_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericInvokable_val_ArgumentType_18._cont = ASN1Dict([
        (u'destinationRoutingAddress', __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_18_extensions),
        (u'legToBeCreated', __SsfToScfGenericInvokable_val_ArgumentType_18_legToBeCreated),
        (u'newCallSegment', __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment),
        (u'callingPartyNumber', __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber),
        (u'callReferenceNumber', __SsfToScfGenericInvokable_val_ArgumentType_18_callReferenceNumber),
        (u'gsmSCFAddress', __SsfToScfGenericInvokable_val_ArgumentType_18_gsmSCFAddress),
        (u'suppress-T-CSI', __SsfToScfGenericInvokable_val_ArgumentType_18_suppress_T_CSI),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_18._ext = []
    _SsfToScfGenericInvokable_val_ResultType_18 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __SsfToScfGenericInvokable_val_ResultType_18_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __SsfToScfGenericInvokable_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __SsfToScfGenericInvokable_val_ResultType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ResultType_18_extensions._cont = ___SsfToScfGenericInvokable_val_ResultType_18_extensions__item_
    __SsfToScfGenericInvokable_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericInvokable_val_ResultType_18._cont = ASN1Dict([
        (u'supportedCamelPhases', __SsfToScfGenericInvokable_val_ResultType_18_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __SsfToScfGenericInvokable_val_ResultType_18_offeredCamel4Functionalities),
        (u'extensions', __SsfToScfGenericInvokable_val_ResultType_18_extensions),
        (u'releaseCallArgExtensionAllowed', __SsfToScfGenericInvokable_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    _SsfToScfGenericInvokable_val_ResultType_18._ext = [u'releaseCallArgExtensionAllowed']
    _SsfToScfGenericInvokable_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_19_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_19_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_19_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_19._cont = ASN1Dict([
        (u'legIDToMove', __SsfToScfGenericInvokable_val_ArgumentType_19_legIDToMove),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_19_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_19._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_20 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ____SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_20._cont = ASN1Dict([
        (u'allCallSegments', __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments),
        (u'allCallSegmentsWithExtension', __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_20._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        (u'legID', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_._ext = []
    __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents._cont = ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_
    __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_21_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_21_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_21._cont = ASN1Dict([
        (u'bcsmEvents', __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_21_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_21._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_22_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __SsfToScfGenericInvokable_val_ArgumentType_22_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SsfToScfGenericInvokable_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_22_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_22_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_22._cont = ASN1Dict([
        (u'timerID', __SsfToScfGenericInvokable_val_ArgumentType_22_timerID),
        (u'timervalue', __SsfToScfGenericInvokable_val_ArgumentType_22_timervalue),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_22_extensions),
        (u'callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_22._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_23_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_23_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_23_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_23._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        (u'partyToCharge', __SsfToScfGenericInvokable_val_ArgumentType_23_partyToCharge),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_23_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_23._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_24_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_24_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_24_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_24._cont = ASN1Dict([
        (u'legToBeSplit', __SsfToScfGenericInvokable_val_ArgumentType_24_legToBeSplit),
        (u'newCallSegment', __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_24_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_24._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_25 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        (u'interval', ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo),
        (u'tone', ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_tone),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericInvokable_val_ArgumentType_25_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_25_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_25_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericInvokable_val_ArgumentType_25._cont = ASN1Dict([
        (u'informationToSend', __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend),
        (u'disconnectFromIPForbidden', __SsfToScfGenericInvokable_val_ArgumentType_25_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_25_extensions),
        (u'callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID),
        (u'requestAnnouncementStartedNotification', __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_25._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_26 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        (u'legID', ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_26_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_26_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_26_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ArgumentType_26._cont = ASN1Dict([
        (u'legOrCallSegment', __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment),
        (u'bursts', __SsfToScfGenericInvokable_val_ArgumentType_26_bursts),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_26_extensions),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_26._ext = []
    _SsfToScfGenericInvokable_val_ArgumentType_27 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        (u'interval', ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo),
        (u'tone', ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_tone),
        ])
    __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend._ext = None
    __SsfToScfGenericInvokable_val_ArgumentType_27_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericInvokable_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericInvokable_val_ArgumentType_27_extensions._cont = ___SsfToScfGenericInvokable_val_ArgumentType_27_extensions__item_
    __SsfToScfGenericInvokable_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericInvokable_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericInvokable_val_ArgumentType_27._cont = ASN1Dict([
        (u'collectedInfo', __SsfToScfGenericInvokable_val_ArgumentType_27_collectedInfo),
        (u'disconnectFromIPForbidden', __SsfToScfGenericInvokable_val_ArgumentType_27_disconnectFromIPForbidden),
        (u'informationToSend', __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend),
        (u'extensions', __SsfToScfGenericInvokable_val_ArgumentType_27_extensions),
        (u'callSegmentID', __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID),
        (u'requestAnnouncementStartedNotification', __SsfToScfGenericInvokable_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericInvokable_val_ArgumentType_27._ext = []
    _SsfToScfGenericInvokable_val_ResultType_27 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _SsfToScfGenericInvokable_val_ResultType_27._cont = ASN1Dict([
        (u'digitsResponse', __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse),
        ])
    _SsfToScfGenericInvokable_val_ResultType_27._ext = None
    _SsfToScfGenericInvokable_val_ArgumentType_28 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    SsfToScfGenericInvokable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_12), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_13), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_15), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_16), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_18), (u'ResultType', _SsfToScfGenericInvokable_val_ResultType_18), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_19), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_20), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_24), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_25), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_26), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_27), (u'ResultType', _SsfToScfGenericInvokable_val_ResultType_27), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _SsfToScfGenericInvokable_val_ArgumentType_28), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    
    #-----< SsfToScfGenericReturnable >-----#
    SsfToScfGenericReturnable = CLASS(name=u'SsfToScfGenericReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SsfToScfGenericReturnable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    __SsfToScfGenericReturnable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_1_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_1_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', __SsfToScfGenericReturnable_val_ArgumentType_1_partyToCharge),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_1._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _SsfToScfGenericReturnable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallGapArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria = CHOICE(name=u'gapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapCriteria')))
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria._ext = None
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria = SEQ(name=u'compoundGapCriteria', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CompoundCriteria')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria = CHOICE(name=u'basicGapCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BasicGapCriteria')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService = SEQ(name=u'gapOnService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapOnService')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService = SEQ(name=u'calledAddressAndService', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue = OCT_STR(name=u'calledAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._cont = ASN1Dict([
        (u'calledAddressValue', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue),
        (u'serviceKey', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService._ext = []
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService = SEQ(name=u'callingAddressAndService', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue = OCT_STR(name=u'callingAddressValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._cont = ASN1Dict([
        (u'callingAddressValue', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue),
        (u'serviceKey', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService._ext = []
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._cont = ASN1Dict([
        (u'calledAddressValue', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue),
        (u'gapOnService', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService),
        (u'calledAddressAndService', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService),
        (u'callingAddressAndService', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria),
        (u'scfID', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria._cont = ASN1Dict([
        (u'basicGapCriteria', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria),
        (u'compoundGapCriteria', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapIndicators = SEQ(name=u'gapIndicators', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapIndicators')))
    __SsfToScfGenericReturnable_val_ArgumentType_3_controlType = ENUM(name=u'controlType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ControlType')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment = CHOICE(name=u'gapTreatment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GapTreatment')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration),
        (u'interval', _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo._ext = []
    ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo),
        (u'tone', ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_tone),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend._ext = None
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment._cont = ASN1Dict([
        (u'informationToSend', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend),
        (u'releaseCause', ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_3_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_3_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_3._cont = ASN1Dict([
        (u'gapCriteria', __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria),
        (u'gapIndicators', __SsfToScfGenericReturnable_val_ArgumentType_3_gapIndicators),
        (u'controlType', __SsfToScfGenericReturnable_val_ArgumentType_3_controlType),
        (u'gapTreatment', __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_3_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_3._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __SsfToScfGenericReturnable_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_4_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_4_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    _SsfToScfGenericReturnable_val_ArgumentType_4._cont = ASN1Dict([
        (u'requestedInformationTypeList', __SsfToScfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_4_extensions),
        (u'legID', __SsfToScfGenericReturnable_val_ArgumentType_4_legID),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_4._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_5_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __SsfToScfGenericReturnable_val_ArgumentType_5_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_5._cont = ASN1Dict([
        (u'invokeID', __SsfToScfGenericReturnable_val_ArgumentType_5_invokeID),
        (u'allRequests', __SsfToScfGenericReturnable_val_ArgumentType_5_allRequests),
        (u'callSegmentToCancel', __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_5._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._cont = ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_
    __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_6_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_6_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers._cont = ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_
    __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericReturnable_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', __SsfToScfGenericReturnable_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_6_extensions),
        (u'carrier', __SsfToScfGenericReturnable_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', __SsfToScfGenericReturnable_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', __SsfToScfGenericReturnable_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', __SsfToScfGenericReturnable_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', __SsfToScfGenericReturnable_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', __SsfToScfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', __SsfToScfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', __SsfToScfGenericReturnable_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', __SsfToScfGenericReturnable_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', __SsfToScfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', __SsfToScfGenericReturnable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    _SsfToScfGenericReturnable_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        (u'none', ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_none),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_7_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_7_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_7._cont = ASN1Dict([
        (u'resourceAddress', __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_7._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_8_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_8_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_8._cont = ASN1Dict([
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_8_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_8._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_10_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_10_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_10_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers._cont = ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_
    __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_10_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_10._cont = ASN1Dict([
        (u'alertingPattern', __SsfToScfGenericReturnable_val_ArgumentType_10_alertingPattern),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_10_extensions),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_10_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', __SsfToScfGenericReturnable_val_ArgumentType_10_callingPartysCategory),
        (u'genericNumbers', __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers),
        (u'cug-Interlock', __SsfToScfGenericReturnable_val_ArgumentType_10_cug_Interlock),
        (u'cug-OutgoingAccess', __SsfToScfGenericReturnable_val_ArgumentType_10_cug_OutgoingAccess),
        (u'chargeNumber', __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber),
        (u'carrier', __SsfToScfGenericReturnable_val_ArgumentType_10_carrier),
        (u'suppressionOfAnnouncement', __SsfToScfGenericReturnable_val_ArgumentType_10_suppressionOfAnnouncement),
        (u'naOliInfo', __SsfToScfGenericReturnable_val_ArgumentType_10_naOliInfo),
        (u'bor-InterrogationRequested', __SsfToScfGenericReturnable_val_ArgumentType_10_bor_InterrogationRequested),
        (u'suppress-O-CSI', __SsfToScfGenericReturnable_val_ArgumentType_10_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_10._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_12_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_12_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_12._cont = ASN1Dict([
        (u'callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_12_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_12._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_13_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_13_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_13_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_13._cont = ASN1Dict([
        (u'legToBeReleased', __SsfToScfGenericReturnable_val_ArgumentType_13_legToBeReleased),
        (u'releaseCause', __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_13_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_13._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_14 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID),
        (u'cause', ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure._ext = []
    __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_legID),
        (u'cause', ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_14._cont = ASN1Dict([
        (u'callSegmentFailure', __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure),
        (u'bCSM-Failure', __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_14._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_15_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_15_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_15._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress),
        (u'correlationID', __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID),
        (u'scfID', __SsfToScfGenericReturnable_val_ArgumentType_15_scfID),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_15_extensions),
        (u'carrier', __SsfToScfGenericReturnable_val_ArgumentType_15_carrier),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_15_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID),
        (u'naOliInfo', __SsfToScfGenericReturnable_val_ArgumentType_15_naOliInfo),
        (u'chargeNumber', __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber),
        (u'originalCalledPartyID', __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID),
        (u'callingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_15._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _SsfToScfGenericReturnable_val_ArgumentType_16 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _SsfToScfGenericReturnable_val_ArgumentType_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_17_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cGEncountered = ENUM(name=u'cGEncountered', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CGEncountered')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_17_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_17_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_highLayerCompatibility = OCT_STR(name=u'highLayerCompatibility', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber = OCT_STR(name=u'additionalCallingPartyNumber', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AdditionalCallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability = CHOICE(name=u'bearerCapability', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability._cont = ASN1Dict([
        (u'bearerCap', ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_17_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber = OCT_STR(name=u'calledPartyBCDNumber', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_17_callForwardingSS_Pending = NULL(name=u'callForwardingSS-Pending', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension = SEQ(name=u'initialDPArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitialDPArgExtension')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_gmscAddress = OCT_STR(name=u'gmscAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2 = CHOICE(name=u'bearerCapability2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BearerCapability')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap = OCT_STR(name=u'bearerCap', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=11)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._cont = ASN1Dict([
        (u'bearerCap', ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2._ext = None
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2 = OCT_STR(name=u'highLayerCompatibility2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'HighLayerCompatibility')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility = OCT_STR(name=u'lowLayerCompatibility', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2 = OCT_STR(name=u'lowLayerCompatibility2', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LowLayerCompatibility')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed = NULL(name=u'enhancedDialledServicesAllowed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed = NULL(name=u'collectInformationAllowed', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension._cont = ASN1Dict([
        (u'gmscAddress', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_gmscAddress),
        (u'forwardingDestinationNumber', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber),
        (u'ms-Classmark2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2),
        (u'iMEI', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_iMEI),
        (u'supportedCamelPhases', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases),
        (u'offeredCamel4Functionalities', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities),
        (u'bearerCapability2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2),
        (u'ext-basicServiceCode2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2),
        (u'highLayerCompatibility2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2),
        (u'lowLayerCompatibility', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility),
        (u'lowLayerCompatibility2', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2),
        (u'enhancedDialledServicesAllowed', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed),
        (u'uu-Data', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_uu_Data),
        (u'collectInformationAllowed', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed),
        (u'releaseCallArgExtensionAllowed', ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension._ext = [u'enhancedDialledServicesAllowed', u'uu-Data', u'collectInformationAllowed', u'releaseCallArgExtensionAllowed']
    _SsfToScfGenericReturnable_val_ArgumentType_17._cont = ASN1Dict([
        (u'serviceKey', __SsfToScfGenericReturnable_val_ArgumentType_17_serviceKey),
        (u'calledPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber),
        (u'callingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber),
        (u'callingPartysCategory', __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartysCategory),
        (u'cGEncountered', __SsfToScfGenericReturnable_val_ArgumentType_17_cGEncountered),
        (u'iPSSPCapabilities', __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities),
        (u'locationNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber),
        (u'originalCalledPartyID', __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_17_extensions),
        (u'highLayerCompatibility', __SsfToScfGenericReturnable_val_ArgumentType_17_highLayerCompatibility),
        (u'additionalCallingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber),
        (u'bearerCapability', __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability),
        (u'eventTypeBCSM', __SsfToScfGenericReturnable_val_ArgumentType_17_eventTypeBCSM),
        (u'redirectingPartyID', __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID),
        (u'redirectionInformation', __SsfToScfGenericReturnable_val_ArgumentType_17_redirectionInformation),
        (u'cause', __SsfToScfGenericReturnable_val_ArgumentType_17_cause),
        (u'serviceInteractionIndicatorsTwo', __SsfToScfGenericReturnable_val_ArgumentType_17_serviceInteractionIndicatorsTwo),
        (u'carrier', __SsfToScfGenericReturnable_val_ArgumentType_17_carrier),
        (u'cug-Index', __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Index),
        (u'cug-Interlock', __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Interlock),
        (u'cug-OutgoingAccess', __SsfToScfGenericReturnable_val_ArgumentType_17_cug_OutgoingAccess),
        (u'iMSI', __SsfToScfGenericReturnable_val_ArgumentType_17_iMSI),
        (u'subscriberState', __SsfToScfGenericReturnable_val_ArgumentType_17_subscriberState),
        (u'locationInformation', __SsfToScfGenericReturnable_val_ArgumentType_17_locationInformation),
        (u'ext-basicServiceCode', __SsfToScfGenericReturnable_val_ArgumentType_17_ext_basicServiceCode),
        (u'callReferenceNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_callReferenceNumber),
        (u'mscAddress', __SsfToScfGenericReturnable_val_ArgumentType_17_mscAddress),
        (u'calledPartyBCDNumber', __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber),
        (u'timeAndTimezone', __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone),
        (u'callForwardingSS-Pending', __SsfToScfGenericReturnable_val_ArgumentType_17_callForwardingSS_Pending),
        (u'initialDPArgExtension', __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_17._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress._cont = ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_
    __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_18_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_18_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_18_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_18_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericReturnable_val_ArgumentType_18._cont = ASN1Dict([
        (u'destinationRoutingAddress', __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_18_extensions),
        (u'legToBeCreated', __SsfToScfGenericReturnable_val_ArgumentType_18_legToBeCreated),
        (u'newCallSegment', __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment),
        (u'callingPartyNumber', __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber),
        (u'callReferenceNumber', __SsfToScfGenericReturnable_val_ArgumentType_18_callReferenceNumber),
        (u'gsmSCFAddress', __SsfToScfGenericReturnable_val_ArgumentType_18_gsmSCFAddress),
        (u'suppress-T-CSI', __SsfToScfGenericReturnable_val_ArgumentType_18_suppress_T_CSI),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_18._ext = []
    _SsfToScfGenericReturnable_val_ResultType_18 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __SsfToScfGenericReturnable_val_ResultType_18_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __SsfToScfGenericReturnable_val_ResultType_18_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __SsfToScfGenericReturnable_val_ResultType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ResultType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ResultType_18_extensions._cont = ___SsfToScfGenericReturnable_val_ResultType_18_extensions__item_
    __SsfToScfGenericReturnable_val_ResultType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ResultType_18_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SsfToScfGenericReturnable_val_ResultType_18._cont = ASN1Dict([
        (u'supportedCamelPhases', __SsfToScfGenericReturnable_val_ResultType_18_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __SsfToScfGenericReturnable_val_ResultType_18_offeredCamel4Functionalities),
        (u'extensions', __SsfToScfGenericReturnable_val_ResultType_18_extensions),
        (u'releaseCallArgExtensionAllowed', __SsfToScfGenericReturnable_val_ResultType_18_releaseCallArgExtensionAllowed),
        ])
    _SsfToScfGenericReturnable_val_ResultType_18._ext = [u'releaseCallArgExtensionAllowed']
    _SsfToScfGenericReturnable_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_19_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_19_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_19_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_19._cont = ASN1Dict([
        (u'legIDToMove', __SsfToScfGenericReturnable_val_ArgumentType_19_legIDToMove),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_19_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_19._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_20 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._cont = ____SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_
    ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_20._cont = ASN1Dict([
        (u'allCallSegments', __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments),
        (u'allCallSegmentsWithExtension', __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_20._ext = None
    _SsfToScfGenericReturnable_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__monitorMode),
        (u'legID', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__automaticRearm),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_._ext = []
    __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents._cont = ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_
    __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_21_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_21_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_21._cont = ASN1Dict([
        (u'bcsmEvents', __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_21_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_21._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_22_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __SsfToScfGenericReturnable_val_ArgumentType_22_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SsfToScfGenericReturnable_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_22_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_22_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_22._cont = ASN1Dict([
        (u'timerID', __SsfToScfGenericReturnable_val_ArgumentType_22_timerID),
        (u'timervalue', __SsfToScfGenericReturnable_val_ArgumentType_22_timervalue),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_22_extensions),
        (u'callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_22._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_23_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_23_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_23_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_23._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics),
        (u'partyToCharge', __SsfToScfGenericReturnable_val_ArgumentType_23_partyToCharge),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_23_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_23._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_24_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_24_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_24_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_24._cont = ASN1Dict([
        (u'legToBeSplit', __SsfToScfGenericReturnable_val_ArgumentType_24_legToBeSplit),
        (u'newCallSegment', __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_24_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_24._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_25 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration),
        (u'interval', ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo),
        (u'tone', ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_tone),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_25_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericReturnable_val_ArgumentType_25_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_25_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_25_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_25_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_25_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericReturnable_val_ArgumentType_25._cont = ASN1Dict([
        (u'informationToSend', __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend),
        (u'disconnectFromIPForbidden', __SsfToScfGenericReturnable_val_ArgumentType_25_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementCompleteNotification),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_25_extensions),
        (u'callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID),
        (u'requestAnnouncementStartedNotification', __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_25._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_26 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID),
        (u'legID', ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_legID),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_26_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_26_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_26_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_26_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_26_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ArgumentType_26._cont = ASN1Dict([
        (u'legOrCallSegment', __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment),
        (u'bursts', __SsfToScfGenericReturnable_val_ArgumentType_26_bursts),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_26_extensions),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_26._ext = []
    _SsfToScfGenericReturnable_val_ArgumentType_27 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text._ext = None
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID._ext = None
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration),
        (u'interval', ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval),
        ])
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo._ext = []
    ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo),
        (u'tone', ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_tone),
        ])
    __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend._ext = None
    __SsfToScfGenericReturnable_val_ArgumentType_27_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SsfToScfGenericReturnable_val_ArgumentType_27_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SsfToScfGenericReturnable_val_ArgumentType_27_extensions._cont = ___SsfToScfGenericReturnable_val_ArgumentType_27_extensions__item_
    __SsfToScfGenericReturnable_val_ArgumentType_27_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __SsfToScfGenericReturnable_val_ArgumentType_27_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SsfToScfGenericReturnable_val_ArgumentType_27._cont = ASN1Dict([
        (u'collectedInfo', __SsfToScfGenericReturnable_val_ArgumentType_27_collectedInfo),
        (u'disconnectFromIPForbidden', __SsfToScfGenericReturnable_val_ArgumentType_27_disconnectFromIPForbidden),
        (u'informationToSend', __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend),
        (u'extensions', __SsfToScfGenericReturnable_val_ArgumentType_27_extensions),
        (u'callSegmentID', __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID),
        (u'requestAnnouncementStartedNotification', __SsfToScfGenericReturnable_val_ArgumentType_27_requestAnnouncementStartedNotification),
        ])
    _SsfToScfGenericReturnable_val_ArgumentType_27._ext = []
    _SsfToScfGenericReturnable_val_ResultType_27 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _SsfToScfGenericReturnable_val_ResultType_27._cont = ASN1Dict([
        (u'digitsResponse', __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse),
        ])
    _SsfToScfGenericReturnable_val_ResultType_27._ext = None
    SsfToScfGenericReturnable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 41))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_10), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_13), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_14), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_15), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_16), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 0))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_18), (u'ResultType', _SsfToScfGenericReturnable_val_ResultType_18), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_19), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_20), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_24), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_25), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_26), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', _SsfToScfGenericReturnable_val_ArgumentType_27), (u'ResultType', _SsfToScfGenericReturnable_val_ResultType_27), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])
    
    #-----< assistHandoff-gsmSSF-scfAbstractSyntax >-----#
    assistHandoff_gsmSSF_scfAbstractSyntax = CLASS(name=u'assistHandoff-gsmSSF-scfAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _assistHandoff_gsmSSF_scfAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'AssistHandoffsSF-gsmSCF-PDUs')))
    assistHandoff_gsmSSF_scfAbstractSyntax._val = dict([('Type', _assistHandoff_gsmSSF_scfAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 23, 5, 6))])
    
    #-----< AssistHandoffsSF-gsmSCF-PDUs >-----#
    AssistHandoffsSF_gsmSCF_PDUs = CHOICE(name=u'AssistHandoffsSF-gsmSCF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _AssistHandoffsSF_gsmSCF_PDUs_unidirectional = SEQ(name=u'unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID),
        (u'allRequests', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._ext = None
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        (u'none', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_none),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'resourceAddress', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress),
        (u'extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        (u'serviceInteractionIndicatorsTwo', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        (u'interval', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo),
        (u'tone', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_tone),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'informationToSend', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend),
        (u'disconnectFromIPForbidden', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        (u'extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions),
        (u'callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        (u'interval', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo),
        (u'tone', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_tone),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'collectedInfo', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_collectedInfo),
        (u'disconnectFromIPForbidden', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden),
        (u'informationToSend', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend),
        (u'extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions),
        (u'callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6._cont = ASN1Dict([
        (u'digitsResponse', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6._ext = None
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._cont = __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        (u'timerID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timerID),
        (u'timervalue', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timervalue),
        (u'extensions', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions),
        (u'callSegmentID', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), (u'ResultType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        (u'argument', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID),
        (u'allRequests', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        (u'none', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_none),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress._ext = None
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'resourceAddress', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress),
        (u'extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        (u'serviceInteractionIndicatorsTwo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        (u'interval', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo),
        (u'tone', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_tone),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend._ext = None
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'informationToSend', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend),
        (u'disconnectFromIPForbidden', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        (u'extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions),
        (u'callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        (u'interval', ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo),
        (u'tone', ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_tone),
        ])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend._ext = None
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'collectedInfo', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_collectedInfo),
        (u'disconnectFromIPForbidden', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden),
        (u'informationToSend', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend),
        (u'extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        (u'callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6._cont = ASN1Dict([
        (u'digitsResponse', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._cont = ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        (u'timerID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timerID),
        (u'timervalue', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timervalue),
        (u'extensions', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions),
        (u'callSegmentID', __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._ext = []
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), (u'ResultType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._ext = None
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem._ext = None
    _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._cont = ASN1Dict([
        (u'problem', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem),
        (u'operation', _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation),
        ])
    ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7._ext = []
    _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'ParameterType', ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 4))])], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        (u'parameter', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke),
        (u'returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult),
        (u'returnError', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError),
        (u'reject', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        (u'result', _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        (u'basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS),
        (u'returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_unidirectional._cont = ASN1Dict([
        (u'dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_dialoguePortion),
        (u'components', __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_unidirectional._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_begin = SEQ(name=u'begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __AssistHandoffsSF_gsmSCF_PDUs_begin_otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_begin_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_begin_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode),
        (u'argument', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode),
        (u'parameter', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke),
        (u'returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult),
        (u'returnError', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError),
        (u'reject', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        (u'result', _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_._cont = ASN1Dict([
        (u'basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS),
        (u'returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_begin_components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_begin._cont = ASN1Dict([
        (u'otid', __AssistHandoffsSF_gsmSCF_PDUs_begin_otid),
        (u'dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_begin_dialoguePortion),
        (u'components', __AssistHandoffsSF_gsmSCF_PDUs_begin_components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_begin._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_end = SEQ(name=u'end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __AssistHandoffsSF_gsmSCF_PDUs_end_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_end_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_end_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode),
        (u'argument', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode),
        (u'parameter', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke),
        (u'returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult),
        (u'returnError', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError),
        (u'reject', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId),
        (u'result', _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_._cont = ASN1Dict([
        (u'basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS),
        (u'returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_end_components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_end._cont = ASN1Dict([
        (u'dtid', __AssistHandoffsSF_gsmSCF_PDUs_end_dtid),
        (u'dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_end_dialoguePortion),
        (u'components', __AssistHandoffsSF_gsmSCF_PDUs_end_components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_end._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_continue_ = SEQ(name=u'continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __AssistHandoffsSF_gsmSCF_PDUs_continue__otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_continue__dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __AssistHandoffsSF_gsmSCF_PDUs_continue__dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __AssistHandoffsSF_gsmSCF_PDUs_continue__components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode),
        (u'argument', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        (u'result', _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        (u'errcode', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode),
        (u'parameter', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke),
        (u'returnResult', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult),
        (u'returnError', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError),
        (u'reject', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        (u'result', ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        (u'result', _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_._cont = ASN1Dict([
        (u'basicROS', ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS),
        (u'returnResultNotLast', ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_._ext = None
    __AssistHandoffsSF_gsmSCF_PDUs_continue__components._cont = ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_
    __AssistHandoffsSF_gsmSCF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AssistHandoffsSF_gsmSCF_PDUs_continue_._cont = ASN1Dict([
        (u'otid', __AssistHandoffsSF_gsmSCF_PDUs_continue__otid),
        (u'dtid', __AssistHandoffsSF_gsmSCF_PDUs_continue__dtid),
        (u'dialoguePortion', __AssistHandoffsSF_gsmSCF_PDUs_continue__dialoguePortion),
        (u'components', __AssistHandoffsSF_gsmSCF_PDUs_continue__components),
        ])
    _AssistHandoffsSF_gsmSCF_PDUs_continue_._ext = None
    _AssistHandoffsSF_gsmSCF_PDUs_abort = SEQ(name=u'abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    AssistHandoffsSF_gsmSCF_PDUs._cont = ASN1Dict([
        (u'unidirectional', _AssistHandoffsSF_gsmSCF_PDUs_unidirectional),
        (u'begin', _AssistHandoffsSF_gsmSCF_PDUs_begin),
        (u'end', _AssistHandoffsSF_gsmSCF_PDUs_end),
        (u'continue', _AssistHandoffsSF_gsmSCF_PDUs_continue_),
        (u'abort', _AssistHandoffsSF_gsmSCF_PDUs_abort),
        ])
    AssistHandoffsSF_gsmSCF_PDUs._ext = None
    
    #-----< AssistHandoffssfToScfInvokable >-----#
    AssistHandoffssfToScfInvokable = CLASS(name=u'AssistHandoffssfToScfInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _AssistHandoffssfToScfInvokable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_1._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', __AssistHandoffssfToScfInvokable_val_ArgumentType_2_invokeID),
        (u'allRequests', __AssistHandoffssfToScfInvokable_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_2._ext = None
    _AssistHandoffssfToScfInvokable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        (u'none', ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_none),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress._ext = None
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_3._cont = ASN1Dict([
        (u'resourceAddress', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress),
        (u'extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions),
        (u'serviceInteractionIndicatorsTwo', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_3._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        (u'interval', ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo),
        (u'tone', ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_tone),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend._ext = None
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfInvokable_val_ArgumentType_5._cont = ASN1Dict([
        (u'informationToSend', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend),
        (u'disconnectFromIPForbidden', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        (u'extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions),
        (u'callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID),
        (u'requestAnnouncementStartedNotification', __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_5._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        (u'interval', ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo),
        (u'tone', ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_tone),
        ])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend._ext = None
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfInvokable_val_ArgumentType_6._cont = ASN1Dict([
        (u'collectedInfo', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_collectedInfo),
        (u'disconnectFromIPForbidden', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_disconnectFromIPForbidden),
        (u'informationToSend', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend),
        (u'extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions),
        (u'callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID),
        (u'requestAnnouncementStartedNotification', __AssistHandoffssfToScfInvokable_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_6._ext = []
    _AssistHandoffssfToScfInvokable_val_ResultType_6 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ResultType_6._cont = ASN1Dict([
        (u'digitsResponse', __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse),
        ])
    _AssistHandoffssfToScfInvokable_val_ResultType_6._ext = None
    _AssistHandoffssfToScfInvokable_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions._cont = ___AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions__item_
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_7._cont = ASN1Dict([
        (u'timerID', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timerID),
        (u'timervalue', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timervalue),
        (u'extensions', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions),
        (u'callSegmentID', __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID),
        ])
    _AssistHandoffssfToScfInvokable_val_ArgumentType_7._ext = []
    _AssistHandoffssfToScfInvokable_val_ArgumentType_8 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    AssistHandoffssfToScfInvokable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_6), (u'ResultType', _AssistHandoffssfToScfInvokable_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _AssistHandoffssfToScfInvokable_val_ArgumentType_8), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    
    #-----< AssistHandoffssfToScfReturnable >-----#
    AssistHandoffssfToScfReturnable = CLASS(name=u'AssistHandoffssfToScfReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _AssistHandoffssfToScfReturnable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AssistRequestInstructionsArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities = OCT_STR(name=u'iPSSPCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPSSPCapabilities')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_1._cont = ASN1Dict([
        (u'correlationID', __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID),
        (u'iPSSPCapabilities', __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities),
        (u'extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_1._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_2._cont = ASN1Dict([
        (u'invokeID', __AssistHandoffssfToScfReturnable_val_ArgumentType_2_invokeID),
        (u'allRequests', __AssistHandoffssfToScfReturnable_val_ArgumentType_2_allRequests),
        (u'callSegmentToCancel', __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_2._ext = None
    _AssistHandoffssfToScfReturnable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress),
        (u'none', ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_none),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress._ext = None
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_3._cont = ASN1Dict([
        (u'resourceAddress', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress),
        (u'extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions),
        (u'serviceInteractionIndicatorsTwo', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_3._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration),
        (u'interval', ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo),
        (u'tone', ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_tone),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend._ext = None
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfReturnable_val_ArgumentType_5._cont = ASN1Dict([
        (u'informationToSend', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend),
        (u'disconnectFromIPForbidden', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementCompleteNotification),
        (u'extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions),
        (u'callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID),
        (u'requestAnnouncementStartedNotification', __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_5._ext = []
    _AssistHandoffssfToScfReturnable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text._ext = None
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID._ext = None
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration),
        (u'interval', ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval),
        ])
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo._ext = []
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo),
        (u'tone', ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_tone),
        ])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend._ext = None
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_6_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AssistHandoffssfToScfReturnable_val_ArgumentType_6._cont = ASN1Dict([
        (u'collectedInfo', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_collectedInfo),
        (u'disconnectFromIPForbidden', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_disconnectFromIPForbidden),
        (u'informationToSend', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend),
        (u'extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions),
        (u'callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID),
        (u'requestAnnouncementStartedNotification', __AssistHandoffssfToScfReturnable_val_ArgumentType_6_requestAnnouncementStartedNotification),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_6._ext = []
    _AssistHandoffssfToScfReturnable_val_ResultType_6 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ResultType_6._cont = ASN1Dict([
        (u'digitsResponse', __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse),
        ])
    _AssistHandoffssfToScfReturnable_val_ResultType_6._ext = None
    _AssistHandoffssfToScfReturnable_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions._cont = ___AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions__item_
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_7._cont = ASN1Dict([
        (u'timerID', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timerID),
        (u'timervalue', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timervalue),
        (u'extensions', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions),
        (u'callSegmentID', __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID),
        ])
    _AssistHandoffssfToScfReturnable_val_ArgumentType_7._ext = []
    AssistHandoffssfToScfReturnable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 16))]), dict([(u'ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_6), (u'ResultType', _AssistHandoffssfToScfReturnable_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _AssistHandoffssfToScfReturnable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))])], rr=[], ev=None, er=[])
    
    #-----< scf-gsmSSFGenericAbstractSyntax >-----#
    scf_gsmSSFGenericAbstractSyntax = CLASS(name=u'scf-gsmSSFGenericAbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _scf_gsmSSFGenericAbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-pkgs-contracts-acs', 'GenericSCF-gsmSSF-PDUs')))
    scf_gsmSSFGenericAbstractSyntax._val = dict([('Type', _scf_gsmSSFGenericAbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 23, 5, 7))])
    
    #-----< GenericSCF-gsmSSF-PDUs >-----#
    GenericSCF_gsmSSF_PDUs = CHOICE(name=u'GenericSCF-gsmSSF-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _GenericSCF_gsmSSF_PDUs_unidirectional = SEQ(name=u'unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __GenericSCF_gsmSSF_PDUs_unidirectional_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_unidirectional_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'requestedInformationTypeList', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationTypeList),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        (u'legID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_invokeID),
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'invokeID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_invokeID),
        (u'allRequests', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_allRequests),
        (u'callSegmentToCancel', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions),
        (u'carrier', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        (u'none', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_none),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        (u'resourceAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        (u'alertingPattern', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_alertingPattern),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions),
        (u'serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callingPartysCategory),
        (u'genericNumbers', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers),
        (u'cug-Interlock', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_Interlock),
        (u'cug-OutgoingAccess', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_OutgoingAccess),
        (u'chargeNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber),
        (u'carrier', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier),
        (u'suppressionOfAnnouncement', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppressionOfAnnouncement),
        (u'naOliInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_naOliInfo),
        (u'bor-InterrogationRequested', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_bor_InterrogationRequested),
        (u'suppress-O-CSI', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        (u'callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        (u'legToBeReleased', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased),
        (u'releaseCause', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress),
        (u'correlationID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID),
        (u'scfID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions),
        (u'carrier', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier),
        (u'serviceInteractionIndicatorsTwo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID),
        (u'naOliInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_naOliInfo),
        (u'chargeNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber),
        (u'originalCalledPartyID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID),
        (u'callingPartyNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        (u'destinationRoutingAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions),
        (u'legToBeCreated', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legToBeCreated),
        (u'newCallSegment', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment),
        (u'callingPartyNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber),
        (u'callReferenceNumber', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callReferenceNumber),
        (u'gsmSCFAddress', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_gsmSCFAddress),
        (u'suppress-T-CSI', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_suppress_T_CSI),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15._cont = ASN1Dict([
        (u'supportedCamelPhases', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_supportedCamelPhases),
        (u'offeredCamel4Functionalities', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_offeredCamel4Functionalities),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions),
        (u'releaseCallArgExtensionAllowed', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15._ext = [u'releaseCallArgExtensionAllowed']
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16._cont = ASN1Dict([
        (u'legIDToMove', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_legIDToMove),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID),
        (u'legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_legID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        (u'legOrCallSegment', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment),
        (u'bursts', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bursts),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        (u'allCallSegments', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments),
        (u'allCallSegmentsWithExtension', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__monitorMode),
        (u'legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__automaticRearm),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        (u'bcsmEvents', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        (u'timerID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timerID),
        (u'timervalue', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timervalue),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions),
        (u'callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics),
        (u'partyToCharge', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_partyToCharge),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        (u'legToBeSplit', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_legToBeSplit),
        (u'newCallSegment', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        (u'interval', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo),
        (u'tone', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_tone),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        (u'informationToSend', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend),
        (u'disconnectFromIPForbidden', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementCompleteNotification),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions),
        (u'callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration),
        (u'interval', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo),
        (u'tone', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_tone),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._cont = __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._cont = ASN1Dict([
        (u'collectedInfo', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_collectedInfo),
        (u'disconnectFromIPForbidden', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_disconnectFromIPForbidden),
        (u'informationToSend', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend),
        (u'extensions', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions),
        (u'callSegmentID', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID),
        (u'requestAnnouncementStartedNotification', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_requestAnnouncementStartedNotification),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24._ext = []
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24._cont = ASN1Dict([
        (u'digitsResponse', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24._ext = None
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15), (u'ResultType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24), (u'ResultType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'requestedInformationList', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        (u'legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_legID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'requestedInformationTypeList', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions),
        (u'legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'invokeID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID),
        (u'allRequests', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests),
        (u'callSegmentToCancel', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        (u'carrier', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        (u'none', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        (u'resourceAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        (u'legToBeReleased', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_legToBeReleased),
        (u'releaseCause', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID),
        (u'cause', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_legID),
        (u'cause', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        (u'callSegmentFailure', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure),
        (u'bCSM-Failure', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress),
        (u'correlationID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID),
        (u'scfID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions),
        (u'carrier', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier),
        (u'serviceInteractionIndicatorsTwo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID),
        (u'naOliInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_naOliInfo),
        (u'chargeNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber),
        (u'originalCalledPartyID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID),
        (u'callingPartyNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._cont = ASN1Dict([
        (u'eventTypeBCSM', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM),
        (u'legID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legID),
        (u'miscCallInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_miscCallInfo),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._cont = ASN1Dict([
        (u'destinationRoutingAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions),
        (u'legToBeCreated', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_legToBeCreated),
        (u'newCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment),
        (u'callingPartyNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber),
        (u'callReferenceNumber', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callReferenceNumber),
        (u'gsmSCFAddress', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_gsmSCFAddress),
        (u'suppress-T-CSI', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_suppress_T_CSI),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15._cont = ASN1Dict([
        (u'supportedCamelPhases', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_offeredCamel4Functionalities),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions),
        (u'releaseCallArgExtensionAllowed', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15._ext = [u'releaseCallArgExtensionAllowed']
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16._cont = ASN1Dict([
        (u'legIDToMove', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_legIDToMove),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__monitorMode),
        (u'legID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__automaticRearm),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_._ext = []
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._cont = ASN1Dict([
        (u'bcsmEvents', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._cont = ASN1Dict([
        (u'timerID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timerID),
        (u'timervalue', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timervalue),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions),
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics),
        (u'partyToCharge', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_partyToCharge),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._cont = ASN1Dict([
        (u'legToBeSplit', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_legToBeSplit),
        (u'newCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration),
        (u'interval', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo),
        (u'tone', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_tone),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._cont = ASN1Dict([
        (u'informationToSend', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend),
        (u'disconnectFromIPForbidden', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementCompleteNotification),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions),
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementStartedNotification),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID),
        (u'legID', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_legID),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._cont = ASN1Dict([
        (u'legOrCallSegment', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment),
        (u'bursts', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_bursts),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        (u'interval', ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo),
        (u'tone', ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_tone),
        ])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend._ext = None
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._cont = ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._cont = ASN1Dict([
        (u'collectedInfo', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_collectedInfo),
        (u'disconnectFromIPForbidden', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden),
        (u'informationToSend', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend),
        (u'extensions', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions),
        (u'callSegmentID', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID),
        (u'requestAnnouncementStartedNotification', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23._ext = []
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23._cont = ASN1Dict([
        (u'digitsResponse', __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse),
        ])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15), (u'ResultType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23), (u'ResultType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._cont = ASN1Dict([(u'unknownRequestedInfo', 1), (u'requestedInfoNotAvailable', 2)])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9._ext = None
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10 = SEQ(name=u'ParameterType', mode=MODE_TYPE)
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._cont = ASN1Dict([(u'unknownOperation', 0), (u'tooLate', 1), (u'operationNotCancellable', 2)])
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem._ext = None
    _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation = INT(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._cont = ASN1Dict([
        (u'problem', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem),
        (u'operation', _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation),
        ])
    ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10._ext = []
    _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 4))])], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke),
        (u'returnResult', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult),
        (u'returnError', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError),
        (u'reject', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS),
        (u'returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_unidirectional_components._cont = ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_
    __GenericSCF_gsmSSF_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_unidirectional._cont = ASN1Dict([
        (u'dialoguePortion', __GenericSCF_gsmSSF_PDUs_unidirectional_dialoguePortion),
        (u'components', __GenericSCF_gsmSSF_PDUs_unidirectional_components),
        ])
    _GenericSCF_gsmSSF_PDUs_unidirectional._ext = None
    _GenericSCF_gsmSSF_PDUs_begin = SEQ(name=u'begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __GenericSCF_gsmSSF_PDUs_begin_otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSCF_gsmSSF_PDUs_begin_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_begin_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSCF_gsmSSF_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke),
        (u'returnResult', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult),
        (u'returnError', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError),
        (u'reject', _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_begin_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS),
        (u'returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_begin_components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_begin_components._cont = ___GenericSCF_gsmSSF_PDUs_begin_components__item_
    __GenericSCF_gsmSSF_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_begin._cont = ASN1Dict([
        (u'otid', __GenericSCF_gsmSSF_PDUs_begin_otid),
        (u'dialoguePortion', __GenericSCF_gsmSSF_PDUs_begin_dialoguePortion),
        (u'components', __GenericSCF_gsmSSF_PDUs_begin_components),
        ])
    _GenericSCF_gsmSSF_PDUs_begin._ext = None
    _GenericSCF_gsmSSF_PDUs_end = SEQ(name=u'end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __GenericSCF_gsmSSF_PDUs_end_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSCF_gsmSSF_PDUs_end_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_end_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSCF_gsmSSF_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke),
        (u'returnResult', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult),
        (u'returnError', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError),
        (u'reject', _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_end_components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS),
        (u'returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_end_components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_end_components._cont = ___GenericSCF_gsmSSF_PDUs_end_components__item_
    __GenericSCF_gsmSSF_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_end._cont = ASN1Dict([
        (u'dtid', __GenericSCF_gsmSSF_PDUs_end_dtid),
        (u'dialoguePortion', __GenericSCF_gsmSSF_PDUs_end_dialoguePortion),
        (u'components', __GenericSCF_gsmSSF_PDUs_end_components),
        ])
    _GenericSCF_gsmSSF_PDUs_end._ext = None
    _GenericSCF_gsmSSF_PDUs_continue_ = SEQ(name=u'continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __GenericSCF_gsmSSF_PDUs_continue__otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __GenericSCF_gsmSSF_PDUs_continue__dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __GenericSCF_gsmSSF_PDUs_continue__dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __GenericSCF_gsmSSF_PDUs_continue__components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___GenericSCF_gsmSSF_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId),
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode),
        (u'argument', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        (u'result', _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        (u'result', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_invokeId),
        (u'errcode', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode),
        (u'parameter', ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke),
        (u'returnResult', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult),
        (u'returnError', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError),
        (u'reject', _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_reject),
        ])
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS._ext = None
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        (u'result', ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_invokeId),
        (u'result', _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___GenericSCF_gsmSSF_PDUs_continue__components__item_._cont = ASN1Dict([
        (u'basicROS', ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS),
        (u'returnResultNotLast', ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___GenericSCF_gsmSSF_PDUs_continue__components__item_._ext = None
    __GenericSCF_gsmSSF_PDUs_continue__components._cont = ___GenericSCF_gsmSSF_PDUs_continue__components__item_
    __GenericSCF_gsmSSF_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _GenericSCF_gsmSSF_PDUs_continue_._cont = ASN1Dict([
        (u'otid', __GenericSCF_gsmSSF_PDUs_continue__otid),
        (u'dtid', __GenericSCF_gsmSSF_PDUs_continue__dtid),
        (u'dialoguePortion', __GenericSCF_gsmSSF_PDUs_continue__dialoguePortion),
        (u'components', __GenericSCF_gsmSSF_PDUs_continue__components),
        ])
    _GenericSCF_gsmSSF_PDUs_continue_._ext = None
    _GenericSCF_gsmSSF_PDUs_abort = SEQ(name=u'abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    GenericSCF_gsmSSF_PDUs._cont = ASN1Dict([
        (u'unidirectional', _GenericSCF_gsmSSF_PDUs_unidirectional),
        (u'begin', _GenericSCF_gsmSSF_PDUs_begin),
        (u'end', _GenericSCF_gsmSSF_PDUs_end),
        (u'continue', _GenericSCF_gsmSSF_PDUs_continue_),
        (u'abort', _GenericSCF_gsmSSF_PDUs_abort),
        ])
    GenericSCF_gsmSSF_PDUs._ext = None
    
    #-----< ScfToSsfGenericInvokable >-----#
    ScfToSsfGenericInvokable = CLASS(name=u'ScfToSsfGenericInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _ScfToSsfGenericInvokable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_1_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', __ScfToSsfGenericInvokable_val_ArgumentType_1_partyToCharge),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_1._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _ScfToSsfGenericInvokable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_3_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_3_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    _ScfToSsfGenericInvokable_val_ArgumentType_3._cont = ASN1Dict([
        (u'requestedInformationTypeList', __ScfToSsfGenericInvokable_val_ArgumentType_3_requestedInformationTypeList),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions),
        (u'legID', __ScfToSsfGenericInvokable_val_ArgumentType_3_legID),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_3._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_4 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_4_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_4_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_4._cont = ASN1Dict([
        (u'invokeID', __ScfToSsfGenericInvokable_val_ArgumentType_4_invokeID),
        (u'allRequests', __ScfToSsfGenericInvokable_val_ArgumentType_4_allRequests),
        (u'callSegmentToCancel', __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_4._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CollectInformationArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_5_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_5._cont = ASN1Dict([
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_5._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_6_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericInvokable_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', __ScfToSsfGenericInvokable_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions),
        (u'carrier', __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', __ScfToSsfGenericInvokable_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', __ScfToSsfGenericInvokable_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', __ScfToSsfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', __ScfToSsfGenericInvokable_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', __ScfToSsfGenericInvokable_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', __ScfToSsfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', __ScfToSsfGenericInvokable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    _ScfToSsfGenericInvokable_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        (u'none', ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_none),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_7_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_7._cont = ASN1Dict([
        (u'resourceAddress', __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_7._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_9_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_9_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_suppress_O_CSI = NULL(name=u'suppress-O-CSI', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension = SEQ(name=u'continueWithArgumentArgExtension', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ContinueWithArgumentArgExtension')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI = NULL(name=u'suppress-D-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring = NULL(name=u'suppressOutgoingCallBarring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID),
        (u'legID', ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension._cont = ASN1Dict([
        (u'suppress-D-CSI', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI),
        (u'suppress-N-CSI', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI),
        (u'suppressOutgoingCallBarring', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring),
        (u'legOrCallSegment', ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_9._cont = ASN1Dict([
        (u'alertingPattern', __ScfToSsfGenericInvokable_val_ArgumentType_9_alertingPattern),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions),
        (u'serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_9_serviceInteractionIndicatorsTwo),
        (u'callingPartysCategory', __ScfToSsfGenericInvokable_val_ArgumentType_9_callingPartysCategory),
        (u'genericNumbers', __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers),
        (u'cug-Interlock', __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_Interlock),
        (u'cug-OutgoingAccess', __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_OutgoingAccess),
        (u'chargeNumber', __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber),
        (u'carrier', __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier),
        (u'suppressionOfAnnouncement', __ScfToSsfGenericInvokable_val_ArgumentType_9_suppressionOfAnnouncement),
        (u'naOliInfo', __ScfToSsfGenericInvokable_val_ArgumentType_9_naOliInfo),
        (u'bor-InterrogationRequested', __ScfToSsfGenericInvokable_val_ArgumentType_9_bor_InterrogationRequested),
        (u'suppress-O-CSI', __ScfToSsfGenericInvokable_val_ArgumentType_9_suppress_O_CSI),
        (u'continueWithArgumentArgExtension', __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_9._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_11 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_11_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_11_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_11._cont = ASN1Dict([
        (u'callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_11._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_12_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_12_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_12._cont = ASN1Dict([
        (u'legToBeReleased', __ScfToSsfGenericInvokable_val_ArgumentType_12_legToBeReleased),
        (u'releaseCause', __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_12._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_13_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_13._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress),
        (u'correlationID', __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID),
        (u'scfID', __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions),
        (u'carrier', __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier),
        (u'serviceInteractionIndicatorsTwo', __ScfToSsfGenericInvokable_val_ArgumentType_13_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID),
        (u'naOliInfo', __ScfToSsfGenericInvokable_val_ArgumentType_13_naOliInfo),
        (u'chargeNumber', __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber),
        (u'originalCalledPartyID', __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID),
        (u'callingPartyNumber', __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_13._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _ScfToSsfGenericInvokable_val_ArgumentType_14 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _ScfToSsfGenericInvokable_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_15_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_15_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_15_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericInvokable_val_ArgumentType_15._cont = ASN1Dict([
        (u'destinationRoutingAddress', __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions),
        (u'legToBeCreated', __ScfToSsfGenericInvokable_val_ArgumentType_15_legToBeCreated),
        (u'newCallSegment', __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment),
        (u'callingPartyNumber', __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber),
        (u'callReferenceNumber', __ScfToSsfGenericInvokable_val_ArgumentType_15_callReferenceNumber),
        (u'gsmSCFAddress', __ScfToSsfGenericInvokable_val_ArgumentType_15_gsmSCFAddress),
        (u'suppress-T-CSI', __ScfToSsfGenericInvokable_val_ArgumentType_15_suppress_T_CSI),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_15._ext = []
    _ScfToSsfGenericInvokable_val_ResultType_15 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __ScfToSsfGenericInvokable_val_ResultType_15_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __ScfToSsfGenericInvokable_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __ScfToSsfGenericInvokable_val_ResultType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ResultType_15_extensions._cont = ___ScfToSsfGenericInvokable_val_ResultType_15_extensions__item_
    __ScfToSsfGenericInvokable_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericInvokable_val_ResultType_15._cont = ASN1Dict([
        (u'supportedCamelPhases', __ScfToSsfGenericInvokable_val_ResultType_15_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __ScfToSsfGenericInvokable_val_ResultType_15_offeredCamel4Functionalities),
        (u'extensions', __ScfToSsfGenericInvokable_val_ResultType_15_extensions),
        (u'releaseCallArgExtensionAllowed', __ScfToSsfGenericInvokable_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    _ScfToSsfGenericInvokable_val_ResultType_15._ext = [u'releaseCallArgExtensionAllowed']
    _ScfToSsfGenericInvokable_val_ArgumentType_16 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_16_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_16_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_16._cont = ASN1Dict([
        (u'legIDToMove', __ScfToSsfGenericInvokable_val_ArgumentType_16_legIDToMove),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_16._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID),
        (u'legID', ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_legID),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_17_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_17_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_17._cont = ASN1Dict([
        (u'legOrCallSegment', __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment),
        (u'bursts', __ScfToSsfGenericInvokable_val_ArgumentType_17_bursts),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_17._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_18 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ReleaseCallArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension = SEQ(name=u'allCallSegmentsWithExtension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegmentsWithExtension')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments = OCT_STR(name=u'allCallSegments', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'AllCallSegments')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._cont = ____ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_
    ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension._cont = ASN1Dict([
        (u'allCallSegments', ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments),
        (u'extensions', ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_18._cont = ASN1Dict([
        (u'allCallSegments', __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments),
        (u'allCallSegmentsWithExtension', __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_18._ext = None
    _ScfToSsfGenericInvokable_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__monitorMode),
        (u'legID', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__automaticRearm),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_._ext = []
    __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_19_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_19._cont = ASN1Dict([
        (u'bcsmEvents', __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_19._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_20_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __ScfToSsfGenericInvokable_val_ArgumentType_20_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_20_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_20._cont = ASN1Dict([
        (u'timerID', __ScfToSsfGenericInvokable_val_ArgumentType_20_timerID),
        (u'timervalue', __ScfToSsfGenericInvokable_val_ArgumentType_20_timervalue),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions),
        (u'callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_20._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_21_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_21_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_21._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics),
        (u'partyToCharge', __ScfToSsfGenericInvokable_val_ArgumentType_21_partyToCharge),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_21._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_22_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_22_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ArgumentType_22._cont = ASN1Dict([
        (u'legToBeSplit', __ScfToSsfGenericInvokable_val_ArgumentType_22_legToBeSplit),
        (u'newCallSegment', __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_22._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        (u'interval', ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo),
        (u'tone', ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_tone),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_23_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericInvokable_val_ArgumentType_23._cont = ASN1Dict([
        (u'informationToSend', __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend),
        (u'disconnectFromIPForbidden', __ScfToSsfGenericInvokable_val_ArgumentType_23_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementCompleteNotification),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions),
        (u'callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID),
        (u'requestAnnouncementStartedNotification', __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_23._ext = []
    _ScfToSsfGenericInvokable_val_ArgumentType_24 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration),
        (u'interval', ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo),
        (u'tone', ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_tone),
        ])
    __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend._ext = None
    __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericInvokable_val_ArgumentType_24_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions._cont = ___ScfToSsfGenericInvokable_val_ArgumentType_24_extensions__item_
    __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericInvokable_val_ArgumentType_24_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericInvokable_val_ArgumentType_24._cont = ASN1Dict([
        (u'collectedInfo', __ScfToSsfGenericInvokable_val_ArgumentType_24_collectedInfo),
        (u'disconnectFromIPForbidden', __ScfToSsfGenericInvokable_val_ArgumentType_24_disconnectFromIPForbidden),
        (u'informationToSend', __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend),
        (u'extensions', __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions),
        (u'callSegmentID', __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID),
        (u'requestAnnouncementStartedNotification', __ScfToSsfGenericInvokable_val_ArgumentType_24_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericInvokable_val_ArgumentType_24._ext = []
    _ScfToSsfGenericInvokable_val_ResultType_24 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _ScfToSsfGenericInvokable_val_ResultType_24._cont = ASN1Dict([
        (u'digitsResponse', __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse),
        ])
    _ScfToSsfGenericInvokable_val_ResultType_24._ext = None
    ScfToSsfGenericInvokable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 27))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 31))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 88))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_11), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_12), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_13), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_15), (u'ResultType', _ScfToSsfGenericInvokable_val_ResultType_15), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_16), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_18), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 22))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_20), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_22), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_23), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _ScfToSsfGenericInvokable_val_ArgumentType_24), (u'ResultType', _ScfToSsfGenericInvokable_val_ResultType_24), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))])], rr=[], ev=None, er=[])
    
    #-----< ScfToSsfGenericReturnable >-----#
    ScfToSsfGenericReturnable = CLASS(name=u'ScfToSsfGenericReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _ScfToSsfGenericReturnable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics = OCT_STR(name=u'aChBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChBillingChargingCharacteristics')))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=177)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x01'))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_1_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress = CHOICE(name=u'aChChargingAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AChChargingAddress')), default=(u'legID', (u'sendingSideID', b'\x01')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection = INT(name=u'srfConnection', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress._cont = ASN1Dict([
        (u'legID', ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID),
        (u'srfConnection', ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_1._cont = ASN1Dict([
        (u'aChBillingChargingCharacteristics', __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics),
        (u'partyToCharge', __ScfToSsfGenericReturnable_val_ArgumentType_1_partyToCharge),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions),
        (u'aChChargingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_1._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ApplyChargingReportArg')))
    _ScfToSsfGenericReturnable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=12, ub=193)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationReportArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList = SEQ_OF(name=u'requestedInformationList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationList')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformation')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType = ENUM(name=u'requestedInformationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationType')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue = CHOICE(name=u'requestedInformationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationValue')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue = INT(name=u'callAttemptElapsedTimeValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue = OCT_STR(name=u'callStopTimeValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DateAndTime')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue = INT(name=u'callConnectedElapsedTimeValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue = OCT_STR(name=u'releaseCauseValue', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._cont = ASN1Dict([
        (u'callAttemptElapsedTimeValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue),
        (u'callStopTimeValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue),
        (u'callConnectedElapsedTimeValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue),
        (u'releaseCauseValue', _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue._ext = None
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_._cont = ASN1Dict([
        (u'requestedInformationType', ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType),
        (u'requestedInformationValue', ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_._ext = []
    __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_3_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_3_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), default=(u'receivingSideID', b'\x02'))
    _ScfToSsfGenericReturnable_val_ArgumentType_3._cont = ASN1Dict([
        (u'requestedInformationList', __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions),
        (u'legID', __ScfToSsfGenericReturnable_val_ArgumentType_3_legID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_3._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CallInformationRequestArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList = SEQ_OF(name=u'requestedInformationTypeList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RequestedInformationTypeList')))
    __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_4_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_4_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')), default=(u'sendingSideID', b'\x02'))
    _ScfToSsfGenericReturnable_val_ArgumentType_4._cont = ASN1Dict([
        (u'requestedInformationTypeList', __ScfToSsfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions),
        (u'legID', __ScfToSsfGenericReturnable_val_ArgumentType_4_legID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_4._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'CancelArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_5_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_5_allRequests = NULL(name=u'allRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel = SEQ(name=u'callSegmentToCancel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentToCancel')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID = INT(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InvokeID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._cont = ASN1Dict([
        (u'invokeID', ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID),
        (u'callSegmentID', ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_5._cont = ASN1Dict([
        (u'invokeID', __ScfToSsfGenericReturnable_val_ArgumentType_5_invokeID),
        (u'allRequests', __ScfToSsfGenericReturnable_val_ArgumentType_5_allRequests),
        (u'callSegmentToCancel', __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_5._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AlertingPattern')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_6_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_callingPartysCategory = OCT_STR(name=u'callingPartysCategory', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'CallingPartysCategory')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID = OCT_STR(name=u'redirectingPartyID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'RedirectingPartyID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectionInformation = OCT_STR(name=u'redirectionInformation', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'RedirectionInformation')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'GenericNumbers')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'GenericNumber')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_6_legToBeConnected = CHOICE(name=u'legToBeConnected', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_oCSIApplicable = NULL(name=u'oCSIApplicable', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OCSIApplicable')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested = NULL(name=u'bor-InterrogationRequested', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_6_suppress_N_CSI = NULL(name=u'suppress-N-CSI', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericReturnable_val_ArgumentType_6._cont = ASN1Dict([
        (u'destinationRoutingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress),
        (u'alertingPattern', __ScfToSsfGenericReturnable_val_ArgumentType_6_alertingPattern),
        (u'originalCalledPartyID', __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions),
        (u'carrier', __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier),
        (u'callingPartysCategory', __ScfToSsfGenericReturnable_val_ArgumentType_6_callingPartysCategory),
        (u'redirectingPartyID', __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID),
        (u'redirectionInformation', __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectionInformation),
        (u'genericNumbers', __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers),
        (u'serviceInteractionIndicatorsTwo', __ScfToSsfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo),
        (u'chargeNumber', __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber),
        (u'legToBeConnected', __ScfToSsfGenericReturnable_val_ArgumentType_6_legToBeConnected),
        (u'cug-Interlock', __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_Interlock),
        (u'cug-OutgoingAccess', __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess),
        (u'suppressionOfAnnouncement', __ScfToSsfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement),
        (u'oCSIApplicable', __ScfToSsfGenericReturnable_val_ArgumentType_6_oCSIApplicable),
        (u'naOliInfo', __ScfToSsfGenericReturnable_val_ArgumentType_6_naOliInfo),
        (u'bor-InterrogationRequested', __ScfToSsfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested),
        (u'suppress-N-CSI', __ScfToSsfGenericReturnable_val_ArgumentType_6_suppress_N_CSI),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_6._ext = [u'suppress-N-CSI']
    _ScfToSsfGenericReturnable_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ConnectToResourceArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress = CHOICE(name=u'resourceAddress', mode=MODE_TYPE)
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress = OCT_STR(name=u'ipRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'IPRoutingAddress')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_none = NULL(name=u'none', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress._cont = ASN1Dict([
        (u'ipRoutingAddress', ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress),
        (u'none', ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_none),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_7_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_7._cont = ASN1Dict([
        (u'resourceAddress', __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions),
        (u'serviceInteractionIndicatorsTwo', __ScfToSsfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_7._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectForwardConnectionWithArgumentArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_9_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_9_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_9._cont = ASN1Dict([
        (u'callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_9._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'DisconnectLegArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_10_legToBeReleased = CHOICE(name=u'legToBeReleased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_10_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_10_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_10._cont = ASN1Dict([
        (u'legToBeReleased', __ScfToSsfGenericReturnable_val_ArgumentType_10_legToBeReleased),
        (u'releaseCause', __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_10._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_11 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EntityReleasedArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure = SEQ(name=u'callSegmentFailure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentFailure')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure._cont = ASN1Dict([
        (u'callSegmentID', ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID),
        (u'cause', ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure._ext = []
    __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure = SEQ(name=u'bCSM-Failure', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'BCSM-Failure')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause = OCT_STR(name=u'cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure._cont = ASN1Dict([
        (u'legID', ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_legID),
        (u'cause', ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_11._cont = ASN1Dict([
        (u'callSegmentFailure', __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure),
        (u'bCSM-Failure', __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_11._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_12 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EstablishTemporaryConnectionArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress = OCT_STR(name=u'assistingSSPIPRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'AssistingSSPIPRoutingAddress')))
    __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID = OCT_STR(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CorrelationID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID = OCT_STR(name=u'scfID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ScfID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=25)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_12_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_12_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier = OCT_STR(name=u'carrier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Carrier')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=4)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_serviceInteractionIndicatorsTwo = SEQ(name=u'serviceInteractionIndicatorsTwo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ServiceInteractionIndicatorsTwo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_naOliInfo = OCT_STR(name=u'naOliInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NAOliInfo')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber = OCT_STR(name=u'chargeNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID = OCT_STR(name=u'originalCalledPartyID', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'OriginalCalledPartyID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_12._cont = ASN1Dict([
        (u'assistingSSPIPRoutingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress),
        (u'correlationID', __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID),
        (u'scfID', __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions),
        (u'carrier', __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier),
        (u'serviceInteractionIndicatorsTwo', __ScfToSsfGenericReturnable_val_ArgumentType_12_serviceInteractionIndicatorsTwo),
        (u'callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID),
        (u'naOliInfo', __ScfToSsfGenericReturnable_val_ArgumentType_12_naOliInfo),
        (u'chargeNumber', __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber),
        (u'originalCalledPartyID', __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID),
        (u'callingPartyNumber', __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_12._ext = [u'originalCalledPartyID', u'callingPartyNumber']
    _ScfToSsfGenericReturnable_val_ArgumentType_13 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'EventReportBCSMArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM = CHOICE(name=u'eventSpecificInformationBCSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationBCSM')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo = SEQ(name=u'routeSelectFailureSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause = OCT_STR(name=u'failureCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._cont = ASN1Dict([
        (u'failureCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo = SEQ(name=u'oCalledPartyBusySpecificInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo = SEQ(name=u'oNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._cont = ASN1Dict([
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo = SEQ(name=u'oAnswerSpecificInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo = SEQ(name=u'oMidCallSpecificInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents._ext = None
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo = SEQ(name=u'oDisconnectSpecificInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo = SEQ(name=u'tBusySpecificInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause = OCT_STR(name=u'busyCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._cont = ASN1Dict([
        (u'busyCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause),
        (u'callForwarded', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded),
        (u'routeNotPermitted', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted),
        (u'forwardingDestinationNumber', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo = SEQ(name=u'tNoAnswerSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded = NULL(name=u'callForwarded', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber = OCT_STR(name=u'forwardingDestinationNumber', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._cont = ASN1Dict([
        (u'callForwarded', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded),
        (u'forwardingDestinationNumber', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo = SEQ(name=u'tAnswerSpecificInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress = OCT_STR(name=u'destinationAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call = NULL(name=u'or-Call', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall = NULL(name=u'forwardedCall', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator = OCT_STR(name=u'chargeIndicator', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChargeIndicator')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2 = CHOICE(name=u'ext-basicServiceCode2', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._cont = ASN1Dict([
        (u'destinationAddress', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress),
        (u'or-Call', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call),
        (u'forwardedCall', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall),
        (u'chargeIndicator', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator),
        (u'ext-basicServiceCode', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode),
        (u'ext-basicServiceCode2', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo = SEQ(name=u'tMidCallSpecificInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents = CHOICE(name=u'midCallEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted = OCT_STR(name=u'dTMFDigitsCompleted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut = OCT_STR(name=u'dTMFDigitsTimeOut', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._cont = ASN1Dict([
        (u'dTMFDigitsCompleted', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted),
        (u'dTMFDigitsTimeOut', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents._ext = None
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._cont = ASN1Dict([
        (u'midCallEvents', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo = SEQ(name=u'tDisconnectSpecificInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause = OCT_STR(name=u'releaseCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Cause')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._cont = ASN1Dict([
        (u'releaseCause', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo = SEQ(name=u'oTermSeizedSpecificInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo = SEQ(name=u'callAcceptedSpecificInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo = SEQ(name=u'oAbandonSpecificInfo', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted = NULL(name=u'routeNotPermitted', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._cont = ASN1Dict([
        (u'routeNotPermitted', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo = SEQ(name=u'oChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo = SEQ(name=u'tChangeOfPositionSpecificInfo', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList = SEQ_OF(name=u'metDPCriteriaList', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriteriaList')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterion')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId = OCT_STR(name=u'enteringCellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId = OCT_STR(name=u'leavingCellGlobalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId = OCT_STR(name=u'enteringServiceAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId = OCT_STR(name=u'leavingServiceAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId = OCT_STR(name=u'enteringLocationAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId = OCT_STR(name=u'leavingLocationAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS = NULL(name=u'inter-SystemHandOverToUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM = NULL(name=u'inter-SystemHandOverToGSM', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt = SEQ(name=u'metDPCriterionAlt', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MetDPCriterionAlt')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._cont = ASN1Dict([
        ])
    ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt._ext = []
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._cont = ASN1Dict([
        (u'enteringCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId),
        (u'leavingCellGlobalId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId),
        (u'enteringServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId),
        (u'leavingServiceAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId),
        (u'enteringLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId),
        (u'leavingLocationAreaId', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId),
        (u'inter-SystemHandOverToUMTS', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS),
        (u'inter-SystemHandOverToGSM', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM),
        (u'inter-PLMNHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver),
        (u'metDPCriterionAlt', ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._cont = _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._cont = ASN1Dict([
        (u'locationInformation', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation),
        (u'metDPCriteriaList', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo._ext = [u'metDPCriteriaList']
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt = SEQ(name=u'dpSpecificInfoAlt', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificInfoAlt')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo = SEQ(name=u'oServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo = SEQ(name=u'tServiceChangeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode = CHOICE(name=u'ext-basicServiceCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange = ENUM(name=u'initiatorOfServiceChange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InitiatorOfServiceChange')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange = ENUM(name=u'natureOfServiceChange', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NatureOfServiceChange')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._cont = ASN1Dict([
        (u'ext-basicServiceCode', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode),
        (u'initiatorOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange),
        (u'natureOfServiceChange', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo._ext = [u'initiatorOfServiceChange', u'natureOfServiceChange']
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo = SEQ(name=u'collectedInfoSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._cont = ASN1Dict([
        (u'calledPartyNumber', _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._cont = ASN1Dict([
        (u'oServiceChangeSpecificInfo', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo),
        (u'tServiceChangeSpecificInfo', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo),
        (u'collectedInfoSpecificInfo', ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt._ext = [u'oServiceChangeSpecificInfo', u'tServiceChangeSpecificInfo', u'collectedInfoSpecificInfo']
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM._cont = ASN1Dict([
        (u'routeSelectFailureSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo),
        (u'oCalledPartyBusySpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo),
        (u'oNoAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo),
        (u'oAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo),
        (u'oMidCallSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo),
        (u'oDisconnectSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo),
        (u'tBusySpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo),
        (u'tNoAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo),
        (u'tAnswerSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo),
        (u'tMidCallSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo),
        (u'tDisconnectSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo),
        (u'oTermSeizedSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo),
        (u'callAcceptedSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo),
        (u'oAbandonSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo),
        (u'oChangeOfPositionSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo),
        (u'tChangeOfPositionSpecificInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo),
        (u'dpSpecificInfoAlt', ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_13_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ReceivingSideID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_13_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_13_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_13_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_13._cont = ASN1Dict([
        (u'eventTypeBCSM', __ScfToSsfGenericReturnable_val_ArgumentType_13_eventTypeBCSM),
        (u'eventSpecificInformationBCSM', __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM),
        (u'legID', __ScfToSsfGenericReturnable_val_ArgumentType_13_legID),
        (u'miscCallInfo', __ScfToSsfGenericReturnable_val_ArgumentType_13_miscCallInfo),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_13._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_14 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'FurnishChargingInformationArg')))
    _ScfToSsfGenericReturnable_val_ArgumentType_14._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_15 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyNumber')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=18)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_15_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_legToBeCreated = CHOICE(name=u'legToBeCreated', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallingPartyNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_15_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_gsmSCFAddress = OCT_STR(name=u'gsmSCFAddress', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_15_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericReturnable_val_ArgumentType_15._cont = ASN1Dict([
        (u'destinationRoutingAddress', __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions),
        (u'legToBeCreated', __ScfToSsfGenericReturnable_val_ArgumentType_15_legToBeCreated),
        (u'newCallSegment', __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment),
        (u'callingPartyNumber', __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber),
        (u'callReferenceNumber', __ScfToSsfGenericReturnable_val_ArgumentType_15_callReferenceNumber),
        (u'gsmSCFAddress', __ScfToSsfGenericReturnable_val_ArgumentType_15_gsmSCFAddress),
        (u'suppress-T-CSI', __ScfToSsfGenericReturnable_val_ArgumentType_15_suppress_T_CSI),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_15._ext = []
    _ScfToSsfGenericReturnable_val_ResultType_15 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'InitiateCallAttemptRes')))
    __ScfToSsfGenericReturnable_val_ResultType_15_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    __ScfToSsfGenericReturnable_val_ResultType_15_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    __ScfToSsfGenericReturnable_val_ResultType_15_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ResultType_15_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ResultType_15_extensions._cont = ___ScfToSsfGenericReturnable_val_ResultType_15_extensions__item_
    __ScfToSsfGenericReturnable_val_ResultType_15_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ResultType_15_releaseCallArgExtensionAllowed = NULL(name=u'releaseCallArgExtensionAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ScfToSsfGenericReturnable_val_ResultType_15._cont = ASN1Dict([
        (u'supportedCamelPhases', __ScfToSsfGenericReturnable_val_ResultType_15_supportedCamelPhases),
        (u'offeredCamel4Functionalities', __ScfToSsfGenericReturnable_val_ResultType_15_offeredCamel4Functionalities),
        (u'extensions', __ScfToSsfGenericReturnable_val_ResultType_15_extensions),
        (u'releaseCallArgExtensionAllowed', __ScfToSsfGenericReturnable_val_ResultType_15_releaseCallArgExtensionAllowed),
        ])
    _ScfToSsfGenericReturnable_val_ResultType_15._ext = [u'releaseCallArgExtensionAllowed']
    _ScfToSsfGenericReturnable_val_ArgumentType_16 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'MoveLegArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_16_legIDToMove = CHOICE(name=u'legIDToMove', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_16_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_16_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_16._cont = ASN1Dict([
        (u'legIDToMove', __ScfToSsfGenericReturnable_val_ArgumentType_16_legIDToMove),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_16._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_17 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'RequestReportBCSMEventArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents = SEQ_OF(name=u'bcsmEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'BCSMEvent')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM = ENUM(name=u'eventTypeBCSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeBCSM')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__monitorMode = ENUM(name=u'monitorMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MonitorMode')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria = CHOICE(name=u'dpSpecificCriteria', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteria')), opt=True)
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer = INT(name=u'applicationTimer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ApplicationTimer')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo = SEQ(name=u'midCallControlInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MidCallControlInfo')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt = SEQ(name=u'dpSpecificCriteriaAlt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DpSpecificCriteriaAlt')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo = SEQ_OF(name=u'changeOfPositionControlInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfPositionControlInfo')))
    _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocation')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId = OCT_STR(name=u'cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId = OCT_STR(name=u'serviceAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId = OCT_STR(name=u'locationAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver = NULL(name=u'inter-SystemHandOver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver = NULL(name=u'inter-PLMNHandOver', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver = NULL(name=u'inter-MSCHandOver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt = SEQ(name=u'changeOfLocationAlt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'ChangeOfLocationAlt')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._cont = ASN1Dict([
        ])
    ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt._ext = []
    _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._cont = ASN1Dict([
        (u'cellGlobalId', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId),
        (u'serviceAreaId', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId),
        (u'locationAreaId', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId),
        (u'inter-SystemHandOver', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver),
        (u'inter-PLMNHandOver', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver),
        (u'inter-MSCHandOver', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver),
        (u'changeOfLocationAlt', ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt),
        ])
    _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_._ext = None
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._cont = _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits = INT(name=u'numberOfDigits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'NumberOfDigits')), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout = INT(name=u'interDigitTimeout', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._cont = ASN1Dict([
        (u'changeOfPositionControlInfo', ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo),
        (u'numberOfDigits', ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits),
        (u'interDigitTimeout', ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt._ext = [u'changeOfPositionControlInfo', u'numberOfDigits', u'interDigitTimeout']
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._cont = ASN1Dict([
        (u'applicationTimer', _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer),
        (u'midCallControlInfo', _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo),
        (u'dpSpecificCriteriaAlt', _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__automaticRearm = NULL(name=u'automaticRearm', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_._cont = ASN1Dict([
        (u'eventTypeBCSM', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM),
        (u'monitorMode', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__monitorMode),
        (u'legID', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__legID),
        (u'dpSpecificCriteria', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria),
        (u'automaticRearm', ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__automaticRearm),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_._ext = []
    __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_17_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_17_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_17._cont = ASN1Dict([
        (u'bcsmEvents', __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_17._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_18 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'ResetTimerArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_18_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __ScfToSsfGenericReturnable_val_ArgumentType_18_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_18_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_18_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_18._cont = ASN1Dict([
        (u'timerID', __ScfToSsfGenericReturnable_val_ArgumentType_18_timerID),
        (u'timervalue', __ScfToSsfGenericReturnable_val_ArgumentType_18_timervalue),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions),
        (u'callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_18._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_19 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SendChargingInformationArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics = OCT_STR(name=u'sCIBillingChargingCharacteristics', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SCIBillingChargingCharacteristics')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=225)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_19_partyToCharge = CHOICE(name=u'partyToCharge', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SendingSideID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_19_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_19_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_19._cont = ASN1Dict([
        (u'sCIBillingChargingCharacteristics', __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics),
        (u'partyToCharge', __ScfToSsfGenericReturnable_val_ArgumentType_19_partyToCharge),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_19._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_20 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'SplitLegArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_20_legToBeSplit = CHOICE(name=u'legToBeSplit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment = INT(name=u'newCallSegment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_20_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_20_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_20._cont = ASN1Dict([
        (u'legToBeSplit', __ScfToSsfGenericReturnable_val_ArgumentType_20_legToBeSplit),
        (u'newCallSegment', __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_20._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_21 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PlayAnnouncementArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration),
        (u'interval', ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo),
        (u'tone', ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_tone),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_21_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementCompleteNotification = BOOL(name=u'requestAnnouncementCompleteNotification', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_21_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_21_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericReturnable_val_ArgumentType_21._cont = ASN1Dict([
        (u'informationToSend', __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend),
        (u'disconnectFromIPForbidden', __ScfToSsfGenericReturnable_val_ArgumentType_21_disconnectFromIPForbidden),
        (u'requestAnnouncementCompleteNotification', __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementCompleteNotification),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions),
        (u'callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID),
        (u'requestAnnouncementStartedNotification', __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_21._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_22 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSSF-gsmSCF-ops-args', 'PlayToneArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment = CHOICE(name=u'legOrCallSegment', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LegOrCallSegment')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')))
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_legID = CHOICE(name=u'legID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegID')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment._cont = ASN1Dict([
        (u'callSegmentID', ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID),
        (u'legID', ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_legID),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_22_bursts = SEQ(name=u'bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Burst')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_22_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_22_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ArgumentType_22._cont = ASN1Dict([
        (u'legOrCallSegment', __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment),
        (u'bursts', __ScfToSsfGenericReturnable_val_ArgumentType_22_bursts),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_22._ext = []
    _ScfToSsfGenericReturnable_val_ArgumentType_23 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'PromptAndCollectUserInformationArg')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_collectedInfo = CHOICE(name=u'collectedInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CollectedInfo')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_disconnectFromIPForbidden = BOOL(name=u'disconnectFromIPForbidden', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend = CHOICE(name=u'informationToSend', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InformationToSend')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo = SEQ(name=u'inbandInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'InbandInfo')))
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID = CHOICE(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'MessageID')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text = SEQ(name=u'text', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent = STR_IA5(name=u'messageContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes = OCT_STR(name=u'attributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._cont = ASN1Dict([
        (u'messageContent', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent),
        (u'attributes', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text._ext = None
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs = SEQ_OF(name=u'elementaryMessageIDs', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._cont = ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage = SEQ(name=u'variableMessage', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID = INT(name=u'elementaryMessageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts = SEQ_OF(name=u'variableParts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'VariablePart')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer = INT(name=u'integer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number = OCT_STR(name=u'number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time = OCT_STR(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date = OCT_STR(name=u'date', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price = OCT_STR(name=u'price', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._cont = ASN1Dict([
        (u'integer', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer),
        (u'number', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number),
        (u'time', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time),
        (u'date', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date),
        (u'price', ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price),
        ])
    _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_._ext = None
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._cont = _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_
    ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._cont = ASN1Dict([
        (u'elementaryMessageID', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID),
        (u'variableParts', ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts),
        ])
    _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._cont = ASN1Dict([
        (u'elementaryMessageID', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID),
        (u'text', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text),
        (u'elementaryMessageIDs', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs),
        (u'variableMessage', _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage),
        ])
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID._ext = None
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions = INT(name=u'numberOfRepetitions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval = INT(name=u'interval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo._cont = ASN1Dict([
        (u'messageID', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID),
        (u'numberOfRepetitions', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions),
        (u'duration', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration),
        (u'interval', ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval),
        ])
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo._ext = []
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_tone = SEQ(name=u'tone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Tone')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend._cont = ASN1Dict([
        (u'inbandInfo', ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo),
        (u'tone', ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_tone),
        ])
    __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend._ext = None
    __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___ScfToSsfGenericReturnable_val_ArgumentType_23_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions._cont = ___ScfToSsfGenericReturnable_val_ArgumentType_23_extensions__item_
    __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID = INT(name=u'callSegmentID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CallSegmentID')), opt=True)
    __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    __ScfToSsfGenericReturnable_val_ArgumentType_23_requestAnnouncementStartedNotification = BOOL(name=u'requestAnnouncementStartedNotification', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ScfToSsfGenericReturnable_val_ArgumentType_23._cont = ASN1Dict([
        (u'collectedInfo', __ScfToSsfGenericReturnable_val_ArgumentType_23_collectedInfo),
        (u'disconnectFromIPForbidden', __ScfToSsfGenericReturnable_val_ArgumentType_23_disconnectFromIPForbidden),
        (u'informationToSend', __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend),
        (u'extensions', __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions),
        (u'callSegmentID', __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID),
        (u'requestAnnouncementStartedNotification', __ScfToSsfGenericReturnable_val_ArgumentType_23_requestAnnouncementStartedNotification),
        ])
    _ScfToSsfGenericReturnable_val_ArgumentType_23._ext = []
    _ScfToSsfGenericReturnable_val_ResultType_23 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'ReceivedInformationArg')))
    __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse = OCT_STR(name=u'digitsResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Digits')))
    __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    _ScfToSsfGenericReturnable_val_ResultType_23._cont = ASN1Dict([
        (u'digitsResponse', __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse),
        ])
    _ScfToSsfGenericReturnable_val_ResultType_23._ext = None
    _ScfToSsfGenericReturnable_val_ArgumentType_24 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-gsmSCF-gsmSRF-ops-args', 'SpecializedResourceReportArg')))
    ScfToSsfGenericReturnable._val = ASN1Set(rv=[dict([(u'returnResult', True), (u'operationCode', (u'local', 55))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_1), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 35))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 51))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'errorCode', (u'local', 12))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 36))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_3), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 44))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 45))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 53))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 20))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 19))]), dict([(u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 18))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 86))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_10), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 90))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_11), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 96))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_12), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 3))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 17))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_13), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 24))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_14), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 34))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_15), (u'ResultType', _ScfToSsfGenericReturnable_val_ResultType_15), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 32))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_16), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 93))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_17), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 23))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_18), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 33))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_19), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 46))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_20), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 17))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 95))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_21), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 47))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_22), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 17))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 97))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_23), (u'ResultType', _ScfToSsfGenericReturnable_val_ResultType_23), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 0))]), dict([(u'errorCode', (u'local', 4))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 13))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 51))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 48))]), dict([(u'ArgumentType', _ScfToSsfGenericReturnable_val_ArgumentType_24), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 49))])], rr=[], ev=None, er=[])
    
    _all_ = [
        capssf_scfGenericAC,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callSegmentFailure,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_bCSM_Failure,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysCategory,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cGEncountered,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iPSSPCapabilities,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_originalCalledPartyID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_highLayerCompatibility,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_additionalCallingPartyNumber,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability_bearerCap,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_bearerCapability,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_eventTypeBCSM,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectingPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_redirectionInformation,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Index,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_subscriberState,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_locationInformation,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_ext_basicServiceCode,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_mscAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_calledPartyBCDNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_timeAndTimezone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callForwardingSS_Pending,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_gmscAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ms_Classmark2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_iMEI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_supportedCamelPhases,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_offeredCamel4Functionalities,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2_bearerCap,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_bearerCapability2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_highLayerCompatibility2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_lowLayerCompatibility2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_enhancedDialledServicesAllowed,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_uu_Data,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_collectInformationAllowed,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension_releaseCallArgExtensionAllowed,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_initialDPArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_assistingSSPIPRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_scfID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_originalCalledPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1_callingPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__monitorMode,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__legID,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__dpSpecificCriteria,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item__automaticRearm,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_bcsmEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tBusySpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationBCSM,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_legID,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegments,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_allCallSegments,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions__item_,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4_allCallSegmentsWithExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_requestedInformationTypeList,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_legID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationType,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item__requestedInformationValue,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_requestedInformationList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_legID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_problem,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_operation,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChBillingChargingCharacteristics,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_partyToCharge,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress_srfConnection,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_aChChargingAddress,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_destinationRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_alertingPattern,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_originalCalledPartyID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_callingPartysCategory,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectingPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_redirectionInformation,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_legToBeConnected,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_oCSIApplicable,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_suppress_N_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_legToBeReleased,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_releaseCause,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_legIDToMove,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_legToBeSplit,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_newCallSegment,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_0,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_ipRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress_none,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_resourceAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_10,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment_legID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_bursts,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__11,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_sCIBillingChargingCharacteristics,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_partyToCharge,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___12,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____13,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_2,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____14,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______15,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressValue,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_gapOnService,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_calledAddressAndService,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria_callingAddressAndService,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_basicGapCriteria,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_basicGapCriteria,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria_scfID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria_compoundGapCriteria,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapCriteria,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapIndicators,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_controlType,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_text,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ____________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_messageID,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_duration,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo_interval,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_inbandInfo,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend_tone,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment_releaseCause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_gapTreatment,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______16,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_destinationRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_legToBeCreated,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_newCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_callReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_gsmSCFAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17_suppress_T_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________17,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_supportedCamelPhases,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_offeredCamel4Functionalities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_releaseCallArgExtensionAllowed,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1,
        capssf_scfAssistHandoffAC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_iPSSPCapabilities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________18,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________19,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_3,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_ipRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress_none,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_resourceAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________20,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________21,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________22,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_0,
        capscf_ssfGenericAC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_assistingSSPIPRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_correlationID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_scfID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_originalCalledPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23_callingPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________23,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__monitorMode,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__legID,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__dpSpecificCriteria,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item__automaticRearm,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_bcsmEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________24,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventTypeBCSM,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tBusySpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_eventSpecificInformationBCSM,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_legID,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_3,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________25,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegments,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_allCallSegments,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions__item_,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26_allCallSegmentsWithExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________26,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_requestedInformationTypeList,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27_legID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________27,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationType,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ________gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        _______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item__requestedInformationValue,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_requestedInformationList,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_extensions,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4_legID,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_invokeID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_allRequests,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_invokeID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28_callSegmentToCancel,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________28,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChBillingChargingCharacteristics,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_partyToCharge,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_extensions,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress_srfConnection,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29_aChChargingAddress,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________29,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_5,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_destinationRoutingAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_alertingPattern,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_originalCalledPartyID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_callingPartysCategory,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectingPartyID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_redirectionInformation,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_legToBeConnected,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_oCSIApplicable,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30_suppress_N_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________30,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0______________________31,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_legToBeReleased,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_releaseCause,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_legIDToMove,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_2_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_legToBeSplit,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_newCallSegment,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_3_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_6,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_ipRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress_none,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_resourceAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_______________________32,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment_legID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_bursts,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0________________________33,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_destinationRoutingAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_legToBeCreated,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_newCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_callReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_gsmSCFAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34_suppress_T_CSI,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_________________________34,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_supportedCamelPhases,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_offeredCamel4Functionalities,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0_releaseCallArgExtensionAllowed,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_0_0,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_informationToSend,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_disconnectFromIPForbidden,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementCompleteNotification,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0__________________________35,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_collectedInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_disconnectFromIPForbidden,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_messageContent,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text_attributes,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_text,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ___________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        __________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ________gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID_variableMessage,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_messageID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_numberOfRepetitions,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_duration,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo_interval,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_inbandInfo,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend_tone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_informationToSend,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_callSegmentID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7_requestAnnouncementStartedNotification,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1_digitsResponse,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ResultType_1_1,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0___________________________36,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_alertingPattern,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_serviceInteractionIndicatorsTwo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_callingPartysCategory,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_genericNumbers,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_Interlock,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_cug_OutgoingAccess,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_chargeNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_carrier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppressionOfAnnouncement,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_naOliInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_bor_InterrogationRequested,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_suppress_O_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_D_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppress_N_CSI,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        _______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension_legOrCallSegment,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8_continueWithArgumentArgExtension,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_1_8,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37_callSegmentID,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0____________________________37,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_callSegmentID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_callSegmentFailure,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_legID,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure_cause,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38_bCSM_Failure,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_____________________________38,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1_1,
        capSsfToScfGeneric,
        capAssistHandoffssfToScf,
        capScfToSsfGeneric,
        activityTestPackage,
        gsmSSF_scfGenericAbstractSyntax,
        _gsmSSF_scfGenericAbstractSyntax_val_Type,
        __GenericSSF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_requestedInformationTypeList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_legID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_invokeID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_allRequests,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentToCancel,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_alertingPattern,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callingPartysCategory,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_genericNumbers,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_Interlock,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_cug_OutgoingAccess,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_chargeNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppressionOfAnnouncement,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_naOliInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_bor_InterrogationRequested,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_suppress_O_CSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_continueWithArgumentArgExtension,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_ipRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress_none,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_resourceAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8_callSegmentID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure_cause,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentFailure,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure_cause,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_bCSM_Failure,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_assistingSSPIPRoutingAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_correlationID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_scfID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_naOliInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_chargeNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_originalCalledPartyID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14_callingPartyNumber,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventTypeBCSM,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_eventSpecificInformationBCSM,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_miscCallInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceKey,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callingPartysCategory,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cGEncountered,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iPSSPCapabilities,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_originalCalledPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_highLayerCompatibility,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bearerCapability,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_eventTypeBCSM,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectingPartyID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_redirectionInformation,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cause,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_carrier,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Index,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_Interlock,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_iMSI,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_subscriberState,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_locationInformation,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_ext_basicServiceCode,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callReferenceNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_mscAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_timeAndTimezone,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_initialDPArgExtension,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_destinationRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_legToBeCreated,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_newCallSegment,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callingPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_callReferenceNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_gsmSCFAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_suppress_T_CSI,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_supportedCamelPhases,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_offeredCamel4Functionalities,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_18,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_legIDToMove,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegments,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_bcsmEvents,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timerID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_timervalue,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_callSegmentID,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_partyToCharge,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_legToBeSplit,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_newCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend_tone,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_informationToSend,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_25,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_legOrCallSegment,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_bursts,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26_extensions,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_26,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_collectedInfo,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend_tone,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_informationToSend,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions__item_,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_27,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27_digitsResponse,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_27,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_28,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_basicGapCriteria,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria_compoundGapCriteria,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapCriteria,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapIndicators,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_controlType,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend_tone,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_informationToSend,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment_releaseCause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gapTreatment,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_8,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_alertingPattern,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_callingPartysCategory,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_genericNumbers,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_Interlock,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_cug_OutgoingAccess,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_chargeNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppressionOfAnnouncement,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_naOliInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_bor_InterrogationRequested,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_suppress_O_CSI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_continueWithArgumentArgExtension,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legToBeReleased,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_releaseCause,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure_cause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_callSegmentFailure,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_legID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure_cause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14_bCSM_Failure,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_assistingSSPIPRoutingAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_correlationID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_scfID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_naOliInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_chargeNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_originalCalledPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceKey,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callingPartysCategory,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cGEncountered,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iPSSPCapabilities,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_originalCalledPartyID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_highLayerCompatibility,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_additionalCallingPartyNumber,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability_bearerCap,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bearerCapability,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_eventTypeBCSM,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectingPartyID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_redirectionInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cause,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_carrier,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Index,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_Interlock,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_cug_OutgoingAccess,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_iMSI,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_subscriberState,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_locationInformation,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_ext_basicServiceCode,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callReferenceNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_mscAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_calledPartyBCDNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_timeAndTimezone,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_callForwardingSS_Pending,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_iMEI,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_initialDPArgExtension,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_destinationRoutingAddress,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_legToBeCreated,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_newCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callingPartyNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callReferenceNumber,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_gsmSCFAddress,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_suppress_T_CSI,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_supportedCamelPhases,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_offeredCamel4Functionalities,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18_releaseCallArgExtensionAllowed,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_18,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_legIDToMove,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegments,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_allCallSegmentsWithExtension,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__legID,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_bcsmEvents,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timerID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_timervalue,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_callSegmentID,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_partyToCharge,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_legToBeSplit,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_newCallSegment,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_inbandInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend_tone,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_informationToSend,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_disconnectFromIPForbidden,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25_requestAnnouncementStartedNotification,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_25,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment_legID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_legOrCallSegment,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_bursts,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26_extensions,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_26,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_collectedInfo,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_disconnectFromIPForbidden,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ____________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_inbandInfo,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend_tone,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_informationToSend,
        ___________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions__item_,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_extensions,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_callSegmentID,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27_requestAnnouncementStartedNotification,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_27,
        __________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27_digitsResponse,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_27,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem,
        _________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation,
        ________GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_unidirectional_components__item_,
        __GenericSSF_gsmSCF_PDUs_unidirectional_components,
        _GenericSSF_gsmSCF_PDUs_unidirectional,
        __GenericSSF_gsmSCF_PDUs_begin_otid,
        __GenericSSF_gsmSCF_PDUs_begin_dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_begin_components__item_,
        __GenericSSF_gsmSCF_PDUs_begin_components,
        _GenericSSF_gsmSCF_PDUs_begin,
        __GenericSSF_gsmSCF_PDUs_end_dtid,
        __GenericSSF_gsmSCF_PDUs_end_dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_end_components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_end_components__item_,
        __GenericSSF_gsmSCF_PDUs_end_components,
        _GenericSSF_gsmSCF_PDUs_end,
        __GenericSSF_gsmSCF_PDUs_continue__otid,
        __GenericSSF_gsmSCF_PDUs_continue__dtid,
        __GenericSSF_gsmSCF_PDUs_continue__dialoguePortion,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____GenericSSF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericSSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericSSF_gsmSCF_PDUs_continue__components__item_,
        __GenericSSF_gsmSCF_PDUs_continue__components,
        _GenericSSF_gsmSCF_PDUs_continue_,
        _GenericSSF_gsmSCF_PDUs_abort,
        GenericSSF_gsmSCF_PDUs,
        SsfToScfGenericInvokable,
        __SsfToScfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __SsfToScfGenericInvokable_val_ArgumentType_1_partyToCharge,
        ___SsfToScfGenericInvokable_val_ArgumentType_1_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_1_extensions,
        ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID,
        ___SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __SsfToScfGenericInvokable_val_ArgumentType_1_aChChargingAddress,
        _SsfToScfGenericInvokable_val_ArgumentType_1,
        _SsfToScfGenericInvokable_val_ArgumentType_2,
        ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        _____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ____SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        ___SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_3_requestedInformationList,
        ___SsfToScfGenericInvokable_val_ArgumentType_3_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_3_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_3_legID,
        _SsfToScfGenericInvokable_val_ArgumentType_3,
        __SsfToScfGenericInvokable_val_ArgumentType_4_requestedInformationTypeList,
        ___SsfToScfGenericInvokable_val_ArgumentType_4_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_4_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_4_legID,
        _SsfToScfGenericInvokable_val_ArgumentType_4,
        __SsfToScfGenericInvokable_val_ArgumentType_5_invokeID,
        __SsfToScfGenericInvokable_val_ArgumentType_5_allRequests,
        ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_5_callSegmentToCancel,
        _SsfToScfGenericInvokable_val_ArgumentType_5,
        ___SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_6_alertingPattern,
        __SsfToScfGenericInvokable_val_ArgumentType_6_originalCalledPartyID,
        ___SsfToScfGenericInvokable_val_ArgumentType_6_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_6_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_6_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_6_callingPartysCategory,
        __SsfToScfGenericInvokable_val_ArgumentType_6_redirectingPartyID,
        __SsfToScfGenericInvokable_val_ArgumentType_6_redirectionInformation,
        ___SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_6_genericNumbers,
        __SsfToScfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_6_chargeNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_6_legToBeConnected,
        __SsfToScfGenericInvokable_val_ArgumentType_6_cug_Interlock,
        __SsfToScfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess,
        __SsfToScfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement,
        __SsfToScfGenericInvokable_val_ArgumentType_6_oCSIApplicable,
        __SsfToScfGenericInvokable_val_ArgumentType_6_naOliInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested,
        __SsfToScfGenericInvokable_val_ArgumentType_6_suppress_N_CSI,
        _SsfToScfGenericInvokable_val_ArgumentType_6,
        __SsfToScfGenericInvokable_val_ArgumentType_7_alertingPattern,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_7_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_7_callingPartysCategory,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_7_genericNumbers,
        __SsfToScfGenericInvokable_val_ArgumentType_7_cug_Interlock,
        __SsfToScfGenericInvokable_val_ArgumentType_7_cug_OutgoingAccess,
        __SsfToScfGenericInvokable_val_ArgumentType_7_chargeNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_7_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_7_suppressionOfAnnouncement,
        __SsfToScfGenericInvokable_val_ArgumentType_7_naOliInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_7_bor_InterrogationRequested,
        __SsfToScfGenericInvokable_val_ArgumentType_7_suppress_O_CSI,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_D_CSI,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppress_N_CSI,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension_legOrCallSegment,
        __SsfToScfGenericInvokable_val_ArgumentType_7_continueWithArgumentArgExtension,
        _SsfToScfGenericInvokable_val_ArgumentType_7,
        ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_ipRoutingAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress_none,
        __SsfToScfGenericInvokable_val_ArgumentType_8_resourceAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_8_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_8_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_8_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_8_callSegmentID,
        _SsfToScfGenericInvokable_val_ArgumentType_8,
        ___SsfToScfGenericInvokable_val_ArgumentType_9_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_9_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_9,
        __SsfToScfGenericInvokable_val_ArgumentType_11_callSegmentID,
        ___SsfToScfGenericInvokable_val_ArgumentType_11_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_11_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_11,
        __SsfToScfGenericInvokable_val_ArgumentType_12_legToBeReleased,
        __SsfToScfGenericInvokable_val_ArgumentType_12_releaseCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_12_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_12_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_12,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_callSegmentID,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure_cause,
        __SsfToScfGenericInvokable_val_ArgumentType_13_callSegmentFailure,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_legID,
        ___SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure_cause,
        __SsfToScfGenericInvokable_val_ArgumentType_13_bCSM_Failure,
        _SsfToScfGenericInvokable_val_ArgumentType_13,
        __SsfToScfGenericInvokable_val_ArgumentType_14_assistingSSPIPRoutingAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_14_correlationID,
        __SsfToScfGenericInvokable_val_ArgumentType_14_scfID,
        ___SsfToScfGenericInvokable_val_ArgumentType_14_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_14_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_14_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_14_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_14_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_14_naOliInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_14_chargeNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_14_originalCalledPartyID,
        __SsfToScfGenericInvokable_val_ArgumentType_14_callingPartyNumber,
        _SsfToScfGenericInvokable_val_ArgumentType_14,
        __SsfToScfGenericInvokable_val_ArgumentType_15_eventTypeBCSM,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tBusySpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        _____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ____SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        __SsfToScfGenericInvokable_val_ArgumentType_15_eventSpecificInformationBCSM,
        __SsfToScfGenericInvokable_val_ArgumentType_15_legID,
        __SsfToScfGenericInvokable_val_ArgumentType_15_miscCallInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_15_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_15_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_15,
        _SsfToScfGenericInvokable_val_ArgumentType_16,
        __SsfToScfGenericInvokable_val_ArgumentType_17_serviceKey,
        __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartyNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callingPartysCategory,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cGEncountered,
        __SsfToScfGenericInvokable_val_ArgumentType_17_iPSSPCapabilities,
        __SsfToScfGenericInvokable_val_ArgumentType_17_locationNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_originalCalledPartyID,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_17_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_17_highLayerCompatibility,
        __SsfToScfGenericInvokable_val_ArgumentType_17_additionalCallingPartyNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability_bearerCap,
        __SsfToScfGenericInvokable_val_ArgumentType_17_bearerCapability,
        __SsfToScfGenericInvokable_val_ArgumentType_17_eventTypeBCSM,
        __SsfToScfGenericInvokable_val_ArgumentType_17_redirectingPartyID,
        __SsfToScfGenericInvokable_val_ArgumentType_17_redirectionInformation,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cause,
        __SsfToScfGenericInvokable_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericInvokable_val_ArgumentType_17_carrier,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Index,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cug_Interlock,
        __SsfToScfGenericInvokable_val_ArgumentType_17_cug_OutgoingAccess,
        __SsfToScfGenericInvokable_val_ArgumentType_17_iMSI,
        __SsfToScfGenericInvokable_val_ArgumentType_17_subscriberState,
        __SsfToScfGenericInvokable_val_ArgumentType_17_locationInformation,
        __SsfToScfGenericInvokable_val_ArgumentType_17_ext_basicServiceCode,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callReferenceNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_mscAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_17_calledPartyBCDNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_17_timeAndTimezone,
        __SsfToScfGenericInvokable_val_ArgumentType_17_callForwardingSS_Pending,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_iMEI,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ____SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        ___SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        __SsfToScfGenericInvokable_val_ArgumentType_17_initialDPArgExtension,
        _SsfToScfGenericInvokable_val_ArgumentType_17,
        ___SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_18_destinationRoutingAddress,
        ___SsfToScfGenericInvokable_val_ArgumentType_18_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_18_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_18_legToBeCreated,
        __SsfToScfGenericInvokable_val_ArgumentType_18_newCallSegment,
        __SsfToScfGenericInvokable_val_ArgumentType_18_callingPartyNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_18_callReferenceNumber,
        __SsfToScfGenericInvokable_val_ArgumentType_18_gsmSCFAddress,
        __SsfToScfGenericInvokable_val_ArgumentType_18_suppress_T_CSI,
        _SsfToScfGenericInvokable_val_ArgumentType_18,
        __SsfToScfGenericInvokable_val_ResultType_18_supportedCamelPhases,
        __SsfToScfGenericInvokable_val_ResultType_18_offeredCamel4Functionalities,
        ___SsfToScfGenericInvokable_val_ResultType_18_extensions__item_,
        __SsfToScfGenericInvokable_val_ResultType_18_extensions,
        __SsfToScfGenericInvokable_val_ResultType_18_releaseCallArgExtensionAllowed,
        _SsfToScfGenericInvokable_val_ResultType_18,
        __SsfToScfGenericInvokable_val_ArgumentType_19_legIDToMove,
        ___SsfToScfGenericInvokable_val_ArgumentType_19_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_19_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_19,
        __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegments,
        ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ____SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        ___SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_20_allCallSegmentsWithExtension,
        _SsfToScfGenericInvokable_val_ArgumentType_20,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__legID,
        _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ____SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        ___SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_21_bcsmEvents,
        ___SsfToScfGenericInvokable_val_ArgumentType_21_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_21_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_21,
        __SsfToScfGenericInvokable_val_ArgumentType_22_timerID,
        __SsfToScfGenericInvokable_val_ArgumentType_22_timervalue,
        ___SsfToScfGenericInvokable_val_ArgumentType_22_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_22_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_22_callSegmentID,
        _SsfToScfGenericInvokable_val_ArgumentType_22,
        __SsfToScfGenericInvokable_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        __SsfToScfGenericInvokable_val_ArgumentType_23_partyToCharge,
        ___SsfToScfGenericInvokable_val_ArgumentType_23_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_23_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_23,
        __SsfToScfGenericInvokable_val_ArgumentType_24_legToBeSplit,
        __SsfToScfGenericInvokable_val_ArgumentType_24_newCallSegment,
        ___SsfToScfGenericInvokable_val_ArgumentType_24_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_24_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_24,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_inbandInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend_tone,
        __SsfToScfGenericInvokable_val_ArgumentType_25_informationToSend,
        __SsfToScfGenericInvokable_val_ArgumentType_25_disconnectFromIPForbidden,
        __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        ___SsfToScfGenericInvokable_val_ArgumentType_25_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_25_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_25_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_25_requestAnnouncementStartedNotification,
        _SsfToScfGenericInvokable_val_ArgumentType_25,
        ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        ___SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment_legID,
        __SsfToScfGenericInvokable_val_ArgumentType_26_legOrCallSegment,
        __SsfToScfGenericInvokable_val_ArgumentType_26_bursts,
        ___SsfToScfGenericInvokable_val_ArgumentType_26_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_26_extensions,
        _SsfToScfGenericInvokable_val_ArgumentType_26,
        __SsfToScfGenericInvokable_val_ArgumentType_27_collectedInfo,
        __SsfToScfGenericInvokable_val_ArgumentType_27_disconnectFromIPForbidden,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_inbandInfo,
        ___SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend_tone,
        __SsfToScfGenericInvokable_val_ArgumentType_27_informationToSend,
        ___SsfToScfGenericInvokable_val_ArgumentType_27_extensions__item_,
        __SsfToScfGenericInvokable_val_ArgumentType_27_extensions,
        __SsfToScfGenericInvokable_val_ArgumentType_27_callSegmentID,
        __SsfToScfGenericInvokable_val_ArgumentType_27_requestAnnouncementStartedNotification,
        _SsfToScfGenericInvokable_val_ArgumentType_27,
        __SsfToScfGenericInvokable_val_ResultType_27_digitsResponse,
        _SsfToScfGenericInvokable_val_ResultType_27,
        _SsfToScfGenericInvokable_val_ArgumentType_28,
        SsfToScfGenericReturnable,
        __SsfToScfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __SsfToScfGenericReturnable_val_ArgumentType_1_partyToCharge,
        ___SsfToScfGenericReturnable_val_ArgumentType_1_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_1_extensions,
        ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID,
        ___SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __SsfToScfGenericReturnable_val_ArgumentType_1_aChChargingAddress,
        _SsfToScfGenericReturnable_val_ArgumentType_1,
        _SsfToScfGenericReturnable_val_ArgumentType_2,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressValue,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_gapOnService,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_calledAddressAndService,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria_callingAddressAndService,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_basicGapCriteria,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressValue,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_gapOnService,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_calledAddressValue,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService_serviceKey,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_calledAddressAndService,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_callingAddressValue,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService_serviceKey,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria_callingAddressAndService,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_basicGapCriteria,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria_scfID,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria_compoundGapCriteria,
        __SsfToScfGenericReturnable_val_ArgumentType_3_gapCriteria,
        __SsfToScfGenericReturnable_val_ArgumentType_3_gapIndicators,
        __SsfToScfGenericReturnable_val_ArgumentType_3_controlType,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_messageContent,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text_attributes,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_text,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ________SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ______SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID_variableMessage,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_messageID,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_numberOfRepetitions,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_duration,
        _____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo_interval,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_inbandInfo,
        ____SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend_tone,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_informationToSend,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment_releaseCause,
        __SsfToScfGenericReturnable_val_ArgumentType_3_gapTreatment,
        ___SsfToScfGenericReturnable_val_ArgumentType_3_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_3_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_3,
        __SsfToScfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList,
        ___SsfToScfGenericReturnable_val_ArgumentType_4_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_4_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_4_legID,
        _SsfToScfGenericReturnable_val_ArgumentType_4,
        __SsfToScfGenericReturnable_val_ArgumentType_5_invokeID,
        __SsfToScfGenericReturnable_val_ArgumentType_5_allRequests,
        ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_5_callSegmentToCancel,
        _SsfToScfGenericReturnable_val_ArgumentType_5,
        ___SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_6_alertingPattern,
        __SsfToScfGenericReturnable_val_ArgumentType_6_originalCalledPartyID,
        ___SsfToScfGenericReturnable_val_ArgumentType_6_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_6_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_6_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_6_callingPartysCategory,
        __SsfToScfGenericReturnable_val_ArgumentType_6_redirectingPartyID,
        __SsfToScfGenericReturnable_val_ArgumentType_6_redirectionInformation,
        ___SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_6_genericNumbers,
        __SsfToScfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_6_chargeNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_6_legToBeConnected,
        __SsfToScfGenericReturnable_val_ArgumentType_6_cug_Interlock,
        __SsfToScfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess,
        __SsfToScfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement,
        __SsfToScfGenericReturnable_val_ArgumentType_6_oCSIApplicable,
        __SsfToScfGenericReturnable_val_ArgumentType_6_naOliInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested,
        __SsfToScfGenericReturnable_val_ArgumentType_6_suppress_N_CSI,
        _SsfToScfGenericReturnable_val_ArgumentType_6,
        ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress_none,
        __SsfToScfGenericReturnable_val_ArgumentType_7_resourceAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_7_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_7_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_7_callSegmentID,
        _SsfToScfGenericReturnable_val_ArgumentType_7,
        ___SsfToScfGenericReturnable_val_ArgumentType_8_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_8_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_8,
        __SsfToScfGenericReturnable_val_ArgumentType_10_alertingPattern,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_10_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_10_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_10_callingPartysCategory,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_10_genericNumbers,
        __SsfToScfGenericReturnable_val_ArgumentType_10_cug_Interlock,
        __SsfToScfGenericReturnable_val_ArgumentType_10_cug_OutgoingAccess,
        __SsfToScfGenericReturnable_val_ArgumentType_10_chargeNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_10_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_10_suppressionOfAnnouncement,
        __SsfToScfGenericReturnable_val_ArgumentType_10_naOliInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_10_bor_InterrogationRequested,
        __SsfToScfGenericReturnable_val_ArgumentType_10_suppress_O_CSI,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_D_CSI,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppress_N_CSI,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension_legOrCallSegment,
        __SsfToScfGenericReturnable_val_ArgumentType_10_continueWithArgumentArgExtension,
        _SsfToScfGenericReturnable_val_ArgumentType_10,
        __SsfToScfGenericReturnable_val_ArgumentType_12_callSegmentID,
        ___SsfToScfGenericReturnable_val_ArgumentType_12_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_12_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_12,
        __SsfToScfGenericReturnable_val_ArgumentType_13_legToBeReleased,
        __SsfToScfGenericReturnable_val_ArgumentType_13_releaseCause,
        ___SsfToScfGenericReturnable_val_ArgumentType_13_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_13_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_13,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_callSegmentID,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure_cause,
        __SsfToScfGenericReturnable_val_ArgumentType_14_callSegmentFailure,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_legID,
        ___SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure_cause,
        __SsfToScfGenericReturnable_val_ArgumentType_14_bCSM_Failure,
        _SsfToScfGenericReturnable_val_ArgumentType_14,
        __SsfToScfGenericReturnable_val_ArgumentType_15_assistingSSPIPRoutingAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_15_correlationID,
        __SsfToScfGenericReturnable_val_ArgumentType_15_scfID,
        ___SsfToScfGenericReturnable_val_ArgumentType_15_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_15_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_15_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_15_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_15_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_15_naOliInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_15_chargeNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_15_originalCalledPartyID,
        __SsfToScfGenericReturnable_val_ArgumentType_15_callingPartyNumber,
        _SsfToScfGenericReturnable_val_ArgumentType_15,
        _SsfToScfGenericReturnable_val_ArgumentType_16,
        __SsfToScfGenericReturnable_val_ArgumentType_17_serviceKey,
        __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartyNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callingPartysCategory,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cGEncountered,
        __SsfToScfGenericReturnable_val_ArgumentType_17_iPSSPCapabilities,
        __SsfToScfGenericReturnable_val_ArgumentType_17_locationNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_originalCalledPartyID,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_17_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_17_highLayerCompatibility,
        __SsfToScfGenericReturnable_val_ArgumentType_17_additionalCallingPartyNumber,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability_bearerCap,
        __SsfToScfGenericReturnable_val_ArgumentType_17_bearerCapability,
        __SsfToScfGenericReturnable_val_ArgumentType_17_eventTypeBCSM,
        __SsfToScfGenericReturnable_val_ArgumentType_17_redirectingPartyID,
        __SsfToScfGenericReturnable_val_ArgumentType_17_redirectionInformation,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cause,
        __SsfToScfGenericReturnable_val_ArgumentType_17_serviceInteractionIndicatorsTwo,
        __SsfToScfGenericReturnable_val_ArgumentType_17_carrier,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Index,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cug_Interlock,
        __SsfToScfGenericReturnable_val_ArgumentType_17_cug_OutgoingAccess,
        __SsfToScfGenericReturnable_val_ArgumentType_17_iMSI,
        __SsfToScfGenericReturnable_val_ArgumentType_17_subscriberState,
        __SsfToScfGenericReturnable_val_ArgumentType_17_locationInformation,
        __SsfToScfGenericReturnable_val_ArgumentType_17_ext_basicServiceCode,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callReferenceNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_mscAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_17_calledPartyBCDNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_17_timeAndTimezone,
        __SsfToScfGenericReturnable_val_ArgumentType_17_callForwardingSS_Pending,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_gmscAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_forwardingDestinationNumber,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ms_Classmark2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_iMEI,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_supportedCamelPhases,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_offeredCamel4Functionalities,
        ____SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2_bearerCap,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_bearerCapability2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_ext_basicServiceCode2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_highLayerCompatibility2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_lowLayerCompatibility2,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_enhancedDialledServicesAllowed,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_uu_Data,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_collectInformationAllowed,
        ___SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension_releaseCallArgExtensionAllowed,
        __SsfToScfGenericReturnable_val_ArgumentType_17_initialDPArgExtension,
        _SsfToScfGenericReturnable_val_ArgumentType_17,
        ___SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_18_destinationRoutingAddress,
        ___SsfToScfGenericReturnable_val_ArgumentType_18_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_18_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_18_legToBeCreated,
        __SsfToScfGenericReturnable_val_ArgumentType_18_newCallSegment,
        __SsfToScfGenericReturnable_val_ArgumentType_18_callingPartyNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_18_callReferenceNumber,
        __SsfToScfGenericReturnable_val_ArgumentType_18_gsmSCFAddress,
        __SsfToScfGenericReturnable_val_ArgumentType_18_suppress_T_CSI,
        _SsfToScfGenericReturnable_val_ArgumentType_18,
        __SsfToScfGenericReturnable_val_ResultType_18_supportedCamelPhases,
        __SsfToScfGenericReturnable_val_ResultType_18_offeredCamel4Functionalities,
        ___SsfToScfGenericReturnable_val_ResultType_18_extensions__item_,
        __SsfToScfGenericReturnable_val_ResultType_18_extensions,
        __SsfToScfGenericReturnable_val_ResultType_18_releaseCallArgExtensionAllowed,
        _SsfToScfGenericReturnable_val_ResultType_18,
        __SsfToScfGenericReturnable_val_ArgumentType_19_legIDToMove,
        ___SsfToScfGenericReturnable_val_ArgumentType_19_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_19_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_19,
        __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegments,
        ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_allCallSegments,
        ____SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions__item_,
        ___SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_20_allCallSegmentsWithExtension,
        _SsfToScfGenericReturnable_val_ArgumentType_20,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__eventTypeBCSM,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__monitorMode,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__legID,
        _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__dpSpecificCriteria,
        ____SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item__automaticRearm,
        ___SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_21_bcsmEvents,
        ___SsfToScfGenericReturnable_val_ArgumentType_21_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_21_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_21,
        __SsfToScfGenericReturnable_val_ArgumentType_22_timerID,
        __SsfToScfGenericReturnable_val_ArgumentType_22_timervalue,
        ___SsfToScfGenericReturnable_val_ArgumentType_22_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_22_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_22_callSegmentID,
        _SsfToScfGenericReturnable_val_ArgumentType_22,
        __SsfToScfGenericReturnable_val_ArgumentType_23_sCIBillingChargingCharacteristics,
        __SsfToScfGenericReturnable_val_ArgumentType_23_partyToCharge,
        ___SsfToScfGenericReturnable_val_ArgumentType_23_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_23_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_23,
        __SsfToScfGenericReturnable_val_ArgumentType_24_legToBeSplit,
        __SsfToScfGenericReturnable_val_ArgumentType_24_newCallSegment,
        ___SsfToScfGenericReturnable_val_ArgumentType_24_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_24_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_24,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_inbandInfo,
        ___SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend_tone,
        __SsfToScfGenericReturnable_val_ArgumentType_25_informationToSend,
        __SsfToScfGenericReturnable_val_ArgumentType_25_disconnectFromIPForbidden,
        __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementCompleteNotification,
        ___SsfToScfGenericReturnable_val_ArgumentType_25_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_25_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_25_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_25_requestAnnouncementStartedNotification,
        _SsfToScfGenericReturnable_val_ArgumentType_25,
        ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_callSegmentID,
        ___SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment_legID,
        __SsfToScfGenericReturnable_val_ArgumentType_26_legOrCallSegment,
        __SsfToScfGenericReturnable_val_ArgumentType_26_bursts,
        ___SsfToScfGenericReturnable_val_ArgumentType_26_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_26_extensions,
        _SsfToScfGenericReturnable_val_ArgumentType_26,
        __SsfToScfGenericReturnable_val_ArgumentType_27_collectedInfo,
        __SsfToScfGenericReturnable_val_ArgumentType_27_disconnectFromIPForbidden,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_messageContent,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text_attributes,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_text,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID_variableMessage,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_messageID,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_numberOfRepetitions,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_duration,
        ____SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo_interval,
        ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_inbandInfo,
        ___SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend_tone,
        __SsfToScfGenericReturnable_val_ArgumentType_27_informationToSend,
        ___SsfToScfGenericReturnable_val_ArgumentType_27_extensions__item_,
        __SsfToScfGenericReturnable_val_ArgumentType_27_extensions,
        __SsfToScfGenericReturnable_val_ArgumentType_27_callSegmentID,
        __SsfToScfGenericReturnable_val_ArgumentType_27_requestAnnouncementStartedNotification,
        _SsfToScfGenericReturnable_val_ArgumentType_27,
        __SsfToScfGenericReturnable_val_ResultType_27_digitsResponse,
        _SsfToScfGenericReturnable_val_ResultType_27,
        assistHandoff_gsmSSF_scfAbstractSyntax,
        _assistHandoff_gsmSSF_scfAbstractSyntax_val_Type,
        __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_correlationID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_invokeID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_allRequests,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress_none,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_resourceAddress,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callSegmentID,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend_tone,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_informationToSend,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_collectedInfo,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend_tone,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_informationToSend,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6_digitsResponse,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_6,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timerID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_timervalue,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_8,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_correlationID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_iPSSPCapabilities,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_invokeID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_allRequests,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2_callSegmentToCancel,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress_none,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_resourceAddress,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_inbandInfo,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend_tone,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_informationToSend,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_disconnectFromIPForbidden,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_requestAnnouncementStartedNotification,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_collectedInfo,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_disconnectFromIPForbidden,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ____________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_inbandInfo,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend_tone,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_informationToSend,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callSegmentID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_requestAnnouncementStartedNotification,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6_digitsResponse,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_6,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timerID,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_timervalue,
        ___________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions,
        __________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_problem,
        _________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7_operation,
        ________AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_7,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_unidirectional_components,
        _AssistHandoffsSF_gsmSCF_PDUs_unidirectional,
        __AssistHandoffsSF_gsmSCF_PDUs_begin_otid,
        __AssistHandoffsSF_gsmSCF_PDUs_begin_dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_begin_components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_begin_components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_begin_components,
        _AssistHandoffsSF_gsmSCF_PDUs_begin,
        __AssistHandoffsSF_gsmSCF_PDUs_end_dtid,
        __AssistHandoffsSF_gsmSCF_PDUs_end_dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_end_components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_end_components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_end_components,
        _AssistHandoffsSF_gsmSCF_PDUs_end,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__otid,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__dtid,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__dialoguePortion,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_invoke,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnResult,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_returnError,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS_reject,
        ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__basicROS,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast_result,
        ____AssistHandoffsSF_gsmSCF_PDUs_continue__components__item__returnResultNotLast,
        ___AssistHandoffsSF_gsmSCF_PDUs_continue__components__item_,
        __AssistHandoffsSF_gsmSCF_PDUs_continue__components,
        _AssistHandoffsSF_gsmSCF_PDUs_continue_,
        _AssistHandoffsSF_gsmSCF_PDUs_abort,
        AssistHandoffsSF_gsmSCF_PDUs,
        AssistHandoffssfToScfInvokable,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_1_correlationID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_1_iPSSPCapabilities,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_1_extensions,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_1,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_2_invokeID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_2_allRequests,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_2_callSegmentToCancel,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_2,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress_none,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_resourceAddress,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_3_callSegmentID,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_3,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend_tone,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_informationToSend,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_disconnectFromIPForbidden,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_callSegmentID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_5_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_5,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_collectedInfo,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_disconnectFromIPForbidden,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend_tone,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_informationToSend,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_callSegmentID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_6_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_6,
        __AssistHandoffssfToScfInvokable_val_ResultType_6_digitsResponse,
        _AssistHandoffssfToScfInvokable_val_ResultType_6,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timerID,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_timervalue,
        ___AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions__item_,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_extensions,
        __AssistHandoffssfToScfInvokable_val_ArgumentType_7_callSegmentID,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_7,
        _AssistHandoffssfToScfInvokable_val_ArgumentType_8,
        AssistHandoffssfToScfReturnable,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_1_correlationID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_1_iPSSPCapabilities,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_1_extensions,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_1,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_2_invokeID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_2_allRequests,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_invokeID,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel_callSegmentID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_2_callSegmentToCancel,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_2,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_ipRoutingAddress,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress_none,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_resourceAddress,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_serviceInteractionIndicatorsTwo,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_3_callSegmentID,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_3,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend_tone,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_informationToSend,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_disconnectFromIPForbidden,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementCompleteNotification,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_callSegmentID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_5_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_5,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_collectedInfo,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_disconnectFromIPForbidden,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_messageContent,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text_attributes,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_text,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID_variableMessage,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_messageID,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_numberOfRepetitions,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_duration,
        ____AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo_interval,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_inbandInfo,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend_tone,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_informationToSend,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_callSegmentID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_6_requestAnnouncementStartedNotification,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_6,
        __AssistHandoffssfToScfReturnable_val_ResultType_6_digitsResponse,
        _AssistHandoffssfToScfReturnable_val_ResultType_6,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timerID,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_timervalue,
        ___AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions__item_,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_extensions,
        __AssistHandoffssfToScfReturnable_val_ArgumentType_7_callSegmentID,
        _AssistHandoffssfToScfReturnable_val_ArgumentType_7,
        scf_gsmSSFGenericAbstractSyntax,
        _scf_gsmSSFGenericAbstractSyntax_val_Type,
        __GenericSCF_gsmSSF_PDUs_unidirectional_dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_partyToCharge,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_requestedInformationTypeList,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_legID,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_invokeID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_allRequests,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_invokeID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_callSegmentToCancel,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_alertingPattern,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_carrier,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_redirectionInformation,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_genericNumbers,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_chargeNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_legToBeConnected,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_Interlock,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_naOliInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_6,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress_none,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_resourceAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7_callSegmentID,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_7,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_alertingPattern,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_callingPartysCategory,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_genericNumbers,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_Interlock,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_cug_OutgoingAccess,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_chargeNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_carrier,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppressionOfAnnouncement,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_naOliInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_bor_InterrogationRequested,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_suppress_O_CSI,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9_continueWithArgumentArgExtension,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_9,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_11,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_legToBeReleased,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_releaseCause,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_12,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_assistingSSPIPRoutingAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_correlationID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_scfID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_carrier,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_serviceInteractionIndicatorsTwo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_naOliInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_chargeNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_originalCalledPartyID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13_callingPartyNumber,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_13,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_14,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_destinationRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_legToBeCreated,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_newCallSegment,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callingPartyNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_callReferenceNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_gsmSCFAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15_suppress_T_CSI,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_15,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_supportedCamelPhases,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_offeredCamel4Functionalities,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_15,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_legIDToMove,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_16,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment_legID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_legOrCallSegment,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_bursts,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_17,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegments,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18_allCallSegmentsWithExtension,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_18,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__monitorMode,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__legID,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item__automaticRearm,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_bcsmEvents,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_19,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timerID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_timervalue,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20_callSegmentID,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_20,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_sCIBillingChargingCharacteristics,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_partyToCharge,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_21,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_legToBeSplit,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_newCallSegment,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22_extensions,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_22,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend_tone,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_informationToSend,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementCompleteNotification,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_23,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_collectedInfo,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_disconnectFromIPForbidden,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_messageID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_duration,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo_interval,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_inbandInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend_tone,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_informationToSend,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions__item_,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24_requestAnnouncementStartedNotification,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_24,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24_digitsResponse,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ResultType_24,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_partyToCharge,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_extensions,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_legID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1_aChChargingAddress,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_1,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_requestedInformationList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_legID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_requestedInformationTypeList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4_legID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_invokeID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_allRequests,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_callSegmentToCancel,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_destinationRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_alertingPattern,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_originalCalledPartyID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_carrier,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_callingPartysCategory,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectingPartyID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_redirectionInformation,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_genericNumbers,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_chargeNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_legToBeConnected,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_Interlock,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_cug_OutgoingAccess,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppressionOfAnnouncement,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_oCSIApplicable,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_naOliInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_bor_InterrogationRequested,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_suppress_N_CSI,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress_none,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_resourceAddress,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_7,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_9,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_legToBeReleased,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_releaseCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_10,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure_cause,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_callSegmentFailure,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_legID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure_cause,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11_bCSM_Failure,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_11,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_assistingSSPIPRoutingAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_correlationID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_scfID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_carrier,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_serviceInteractionIndicatorsTwo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_naOliInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_chargeNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_originalCalledPartyID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12_callingPartyNumber,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_12,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventTypeBCSM,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_eventSpecificInformationBCSM,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_miscCallInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_13,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_14,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_destinationRoutingAddress,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_legToBeCreated,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_newCallSegment,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callingPartyNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_callReferenceNumber,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_gsmSCFAddress,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15_suppress_T_CSI,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_15,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_supportedCamelPhases,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_offeredCamel4Functionalities,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15_releaseCallArgExtensionAllowed,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_15,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_legIDToMove,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_16,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__monitorMode,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__legID,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item__automaticRearm,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_bcsmEvents,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_17,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timerID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_timervalue,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18_callSegmentID,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_18,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_sCIBillingChargingCharacteristics,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_partyToCharge,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_19,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_legToBeSplit,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_newCallSegment,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_20,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_messageID,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_duration,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo_interval,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_inbandInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend_tone,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_informationToSend,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_disconnectFromIPForbidden,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementCompleteNotification,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21_requestAnnouncementStartedNotification,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_21,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_callSegmentID,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment_legID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_legOrCallSegment,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_bursts,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22_extensions,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_22,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_collectedInfo,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_disconnectFromIPForbidden,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ____________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_inbandInfo,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend_tone,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_informationToSend,
        ___________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions__item_,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_extensions,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_callSegmentID,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23_requestAnnouncementStartedNotification,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_23,
        __________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23_digitsResponse,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ResultType_23,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_24,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_5,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_6,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_9,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_problem,
        _________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10_operation,
        ________GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_10,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_unidirectional_components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_unidirectional_components__item_,
        __GenericSCF_gsmSSF_PDUs_unidirectional_components,
        _GenericSCF_gsmSSF_PDUs_unidirectional,
        __GenericSCF_gsmSSF_PDUs_begin_otid,
        __GenericSCF_gsmSSF_PDUs_begin_dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_begin_components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_begin_components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_begin_components__item_,
        __GenericSCF_gsmSSF_PDUs_begin_components,
        _GenericSCF_gsmSSF_PDUs_begin,
        __GenericSCF_gsmSSF_PDUs_end_dtid,
        __GenericSCF_gsmSSF_PDUs_end_dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_end_components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_end_components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_end_components__item_,
        __GenericSCF_gsmSSF_PDUs_end_components,
        _GenericSCF_gsmSSF_PDUs_end,
        __GenericSCF_gsmSSF_PDUs_continue__otid,
        __GenericSCF_gsmSSF_PDUs_continue__dtid,
        __GenericSCF_gsmSSF_PDUs_continue__dialoguePortion,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke_argument,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_invoke,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult_result,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnResult,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_returnError,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS_reject,
        ____GenericSCF_gsmSSF_PDUs_continue__components__item__basicROS,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast_result,
        ____GenericSCF_gsmSSF_PDUs_continue__components__item__returnResultNotLast,
        ___GenericSCF_gsmSSF_PDUs_continue__components__item_,
        __GenericSCF_gsmSSF_PDUs_continue__components,
        _GenericSCF_gsmSSF_PDUs_continue_,
        _GenericSCF_gsmSSF_PDUs_abort,
        GenericSCF_gsmSSF_PDUs,
        ScfToSsfGenericInvokable,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_partyToCharge,
        ___ScfToSsfGenericInvokable_val_ArgumentType_1_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_extensions,
        ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_legID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __ScfToSsfGenericInvokable_val_ArgumentType_1_aChChargingAddress,
        _ScfToSsfGenericInvokable_val_ArgumentType_1,
        _ScfToSsfGenericInvokable_val_ArgumentType_2,
        __ScfToSsfGenericInvokable_val_ArgumentType_3_requestedInformationTypeList,
        ___ScfToSsfGenericInvokable_val_ArgumentType_3_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_3_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_3_legID,
        _ScfToSsfGenericInvokable_val_ArgumentType_3,
        __ScfToSsfGenericInvokable_val_ArgumentType_4_invokeID,
        __ScfToSsfGenericInvokable_val_ArgumentType_4_allRequests,
        ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_invokeID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_4_callSegmentToCancel,
        _ScfToSsfGenericInvokable_val_ArgumentType_4,
        ___ScfToSsfGenericInvokable_val_ArgumentType_5_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_5_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_5,
        ___ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_destinationRoutingAddress,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_alertingPattern,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_originalCalledPartyID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_6_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_carrier,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_callingPartysCategory,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectingPartyID,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_redirectionInformation,
        ___ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_genericNumbers,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_chargeNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_legToBeConnected,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_Interlock,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_cug_OutgoingAccess,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_suppressionOfAnnouncement,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_oCSIApplicable,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_naOliInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_bor_InterrogationRequested,
        __ScfToSsfGenericInvokable_val_ArgumentType_6_suppress_N_CSI,
        _ScfToSsfGenericInvokable_val_ArgumentType_6,
        ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress_none,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_resourceAddress,
        ___ScfToSsfGenericInvokable_val_ArgumentType_7_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_7_callSegmentID,
        _ScfToSsfGenericInvokable_val_ArgumentType_7,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_alertingPattern,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_callingPartysCategory,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_genericNumbers,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_Interlock,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_cug_OutgoingAccess,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_chargeNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_carrier,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_suppressionOfAnnouncement,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_naOliInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_bor_InterrogationRequested,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_suppress_O_CSI,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_D_CSI,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppress_N_CSI,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_suppressOutgoingCallBarring,
        ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_callSegmentID,
        ____ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment_legID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension_legOrCallSegment,
        __ScfToSsfGenericInvokable_val_ArgumentType_9_continueWithArgumentArgExtension,
        _ScfToSsfGenericInvokable_val_ArgumentType_9,
        __ScfToSsfGenericInvokable_val_ArgumentType_11_callSegmentID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_11_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_11_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_11,
        __ScfToSsfGenericInvokable_val_ArgumentType_12_legToBeReleased,
        __ScfToSsfGenericInvokable_val_ArgumentType_12_releaseCause,
        ___ScfToSsfGenericInvokable_val_ArgumentType_12_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_12_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_12,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_assistingSSPIPRoutingAddress,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_correlationID,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_scfID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_13_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_carrier,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_naOliInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_chargeNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_originalCalledPartyID,
        __ScfToSsfGenericInvokable_val_ArgumentType_13_callingPartyNumber,
        _ScfToSsfGenericInvokable_val_ArgumentType_13,
        _ScfToSsfGenericInvokable_val_ArgumentType_14,
        ___ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_destinationRoutingAddress,
        ___ScfToSsfGenericInvokable_val_ArgumentType_15_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_legToBeCreated,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_newCallSegment,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_callingPartyNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_callReferenceNumber,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_gsmSCFAddress,
        __ScfToSsfGenericInvokable_val_ArgumentType_15_suppress_T_CSI,
        _ScfToSsfGenericInvokable_val_ArgumentType_15,
        __ScfToSsfGenericInvokable_val_ResultType_15_supportedCamelPhases,
        __ScfToSsfGenericInvokable_val_ResultType_15_offeredCamel4Functionalities,
        ___ScfToSsfGenericInvokable_val_ResultType_15_extensions__item_,
        __ScfToSsfGenericInvokable_val_ResultType_15_extensions,
        __ScfToSsfGenericInvokable_val_ResultType_15_releaseCallArgExtensionAllowed,
        _ScfToSsfGenericInvokable_val_ResultType_15,
        __ScfToSsfGenericInvokable_val_ArgumentType_16_legIDToMove,
        ___ScfToSsfGenericInvokable_val_ArgumentType_16_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_16_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_16,
        ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_callSegmentID,
        ___ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment_legID,
        __ScfToSsfGenericInvokable_val_ArgumentType_17_legOrCallSegment,
        __ScfToSsfGenericInvokable_val_ArgumentType_17_bursts,
        ___ScfToSsfGenericInvokable_val_ArgumentType_17_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_17_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_17,
        __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegments,
        ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_allCallSegments,
        ____ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions__item_,
        ___ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_18_allCallSegmentsWithExtension,
        _ScfToSsfGenericInvokable_val_ArgumentType_18,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__eventTypeBCSM,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__monitorMode,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__legID,
        _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__dpSpecificCriteria,
        ____ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item__automaticRearm,
        ___ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_19_bcsmEvents,
        ___ScfToSsfGenericInvokable_val_ArgumentType_19_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_19_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_19,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_timerID,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_timervalue,
        ___ScfToSsfGenericInvokable_val_ArgumentType_20_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_20_callSegmentID,
        _ScfToSsfGenericInvokable_val_ArgumentType_20,
        __ScfToSsfGenericInvokable_val_ArgumentType_21_sCIBillingChargingCharacteristics,
        __ScfToSsfGenericInvokable_val_ArgumentType_21_partyToCharge,
        ___ScfToSsfGenericInvokable_val_ArgumentType_21_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_21_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_21,
        __ScfToSsfGenericInvokable_val_ArgumentType_22_legToBeSplit,
        __ScfToSsfGenericInvokable_val_ArgumentType_22_newCallSegment,
        ___ScfToSsfGenericInvokable_val_ArgumentType_22_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_22_extensions,
        _ScfToSsfGenericInvokable_val_ArgumentType_22,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_inbandInfo,
        ___ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend_tone,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_informationToSend,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_disconnectFromIPForbidden,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementCompleteNotification,
        ___ScfToSsfGenericInvokable_val_ArgumentType_23_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_23_requestAnnouncementStartedNotification,
        _ScfToSsfGenericInvokable_val_ArgumentType_23,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_collectedInfo,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_disconnectFromIPForbidden,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_inbandInfo,
        ___ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend_tone,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_informationToSend,
        ___ScfToSsfGenericInvokable_val_ArgumentType_24_extensions__item_,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_extensions,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_callSegmentID,
        __ScfToSsfGenericInvokable_val_ArgumentType_24_requestAnnouncementStartedNotification,
        _ScfToSsfGenericInvokable_val_ArgumentType_24,
        __ScfToSsfGenericInvokable_val_ResultType_24_digitsResponse,
        _ScfToSsfGenericInvokable_val_ResultType_24,
        ScfToSsfGenericReturnable,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_aChBillingChargingCharacteristics,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_partyToCharge,
        ___ScfToSsfGenericReturnable_val_ArgumentType_1_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_extensions,
        ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_legID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress_srfConnection,
        __ScfToSsfGenericReturnable_val_ArgumentType_1_aChChargingAddress,
        _ScfToSsfGenericReturnable_val_ArgumentType_1,
        _ScfToSsfGenericReturnable_val_ArgumentType_2,
        ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationType,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callAttemptElapsedTimeValue,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callStopTimeValue,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_callConnectedElapsedTimeValue,
        _____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue_releaseCauseValue,
        ____ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item__requestedInformationValue,
        ___ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_3_requestedInformationList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_3_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_3_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_3_legID,
        _ScfToSsfGenericReturnable_val_ArgumentType_3,
        __ScfToSsfGenericReturnable_val_ArgumentType_4_requestedInformationTypeList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_4_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_4_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_4_legID,
        _ScfToSsfGenericReturnable_val_ArgumentType_4,
        __ScfToSsfGenericReturnable_val_ArgumentType_5_invokeID,
        __ScfToSsfGenericReturnable_val_ArgumentType_5_allRequests,
        ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_invokeID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_5_callSegmentToCancel,
        _ScfToSsfGenericReturnable_val_ArgumentType_5,
        ___ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_destinationRoutingAddress,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_alertingPattern,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_originalCalledPartyID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_6_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_carrier,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_callingPartysCategory,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectingPartyID,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_redirectionInformation,
        ___ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_genericNumbers,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_chargeNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_legToBeConnected,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_Interlock,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_cug_OutgoingAccess,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_suppressionOfAnnouncement,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_oCSIApplicable,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_naOliInfo,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_bor_InterrogationRequested,
        __ScfToSsfGenericReturnable_val_ArgumentType_6_suppress_N_CSI,
        _ScfToSsfGenericReturnable_val_ArgumentType_6,
        ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_ipRoutingAddress,
        ___ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress_none,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_resourceAddress,
        ___ScfToSsfGenericReturnable_val_ArgumentType_7_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericReturnable_val_ArgumentType_7_callSegmentID,
        _ScfToSsfGenericReturnable_val_ArgumentType_7,
        __ScfToSsfGenericReturnable_val_ArgumentType_9_callSegmentID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_9_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_9_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_9,
        __ScfToSsfGenericReturnable_val_ArgumentType_10_legToBeReleased,
        __ScfToSsfGenericReturnable_val_ArgumentType_10_releaseCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_10_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_10_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_10,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_callSegmentID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure_cause,
        __ScfToSsfGenericReturnable_val_ArgumentType_11_callSegmentFailure,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_legID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure_cause,
        __ScfToSsfGenericReturnable_val_ArgumentType_11_bCSM_Failure,
        _ScfToSsfGenericReturnable_val_ArgumentType_11,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_assistingSSPIPRoutingAddress,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_correlationID,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_scfID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_12_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_carrier,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_serviceInteractionIndicatorsTwo,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_naOliInfo,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_chargeNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_originalCalledPartyID,
        __ScfToSsfGenericReturnable_val_ArgumentType_12_callingPartyNumber,
        _ScfToSsfGenericReturnable_val_ArgumentType_12,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_eventTypeBCSM,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo_failureCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_routeSelectFailureSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo_busyCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oCalledPartyBusySpecificInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oNoAnswerSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_destinationAddress,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_or_Call,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_forwardedCall,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_chargeIndicator,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo_ext_basicServiceCode2,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAnswerSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo_midCallEvents,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oMidCallSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo_releaseCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oDisconnectSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_busyCause,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_callForwarded,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_routeNotPermitted,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo_forwardingDestinationNumber,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tBusySpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_callForwarded,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo_forwardingDestinationNumber,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tNoAnswerSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_destinationAddress,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_or_Call,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_forwardedCall,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_chargeIndicator,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo_ext_basicServiceCode2,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tAnswerSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsCompleted,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents_dTMFDigitsTimeOut,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo_midCallEvents,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tMidCallSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo_releaseCause,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tDisconnectSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo_locationInformation,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oTermSeizedSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo_locationInformation,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_callAcceptedSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo_routeNotPermitted,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oAbandonSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_locationInformation,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_oChangeOfPositionSpecificInfo,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_locationInformation,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingCellGlobalId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingServiceAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__enteringLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__leavingLocationAreaId,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToUMTS,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_SystemHandOverToGSM,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_PLMNHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__inter_MSCHandOver,
        ______ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item__metDPCriterionAlt,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList__item_,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo_metDPCriteriaList,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_tChangeOfPositionSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_ext_basicServiceCode,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo_natureOfServiceChange,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_oServiceChangeSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_ext_basicServiceCode,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_initiatorOfServiceChange,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo_natureOfServiceChange,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_tServiceChangeSpecificInfo,
        _____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo_calledPartyNumber,
        ____ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt_collectedInfoSpecificInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM_dpSpecificInfoAlt,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_eventSpecificInformationBCSM,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_legID,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_miscCallInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_13_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_13_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_13,
        _ScfToSsfGenericReturnable_val_ArgumentType_14,
        ___ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_destinationRoutingAddress,
        ___ScfToSsfGenericReturnable_val_ArgumentType_15_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_legToBeCreated,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_newCallSegment,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_callingPartyNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_callReferenceNumber,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_gsmSCFAddress,
        __ScfToSsfGenericReturnable_val_ArgumentType_15_suppress_T_CSI,
        _ScfToSsfGenericReturnable_val_ArgumentType_15,
        __ScfToSsfGenericReturnable_val_ResultType_15_supportedCamelPhases,
        __ScfToSsfGenericReturnable_val_ResultType_15_offeredCamel4Functionalities,
        ___ScfToSsfGenericReturnable_val_ResultType_15_extensions__item_,
        __ScfToSsfGenericReturnable_val_ResultType_15_extensions,
        __ScfToSsfGenericReturnable_val_ResultType_15_releaseCallArgExtensionAllowed,
        _ScfToSsfGenericReturnable_val_ResultType_15,
        __ScfToSsfGenericReturnable_val_ArgumentType_16_legIDToMove,
        ___ScfToSsfGenericReturnable_val_ArgumentType_16_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_16_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_16,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__eventTypeBCSM,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__monitorMode,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__legID,
        _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_applicationTimer,
        _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_midCallControlInfo,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__cellGlobalId,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__serviceAreaId,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__locationAreaId,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_SystemHandOver,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_PLMNHandOver,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__inter_MSCHandOver,
        ________ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item__changeOfLocationAlt,
        _______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo__item_,
        ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_changeOfPositionControlInfo,
        ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_numberOfDigits,
        ______ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt_interDigitTimeout,
        _____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria_dpSpecificCriteriaAlt,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__dpSpecificCriteria,
        ____ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item__automaticRearm,
        ___ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_17_bcsmEvents,
        ___ScfToSsfGenericReturnable_val_ArgumentType_17_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_17_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_17,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_timerID,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_timervalue,
        ___ScfToSsfGenericReturnable_val_ArgumentType_18_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_18_callSegmentID,
        _ScfToSsfGenericReturnable_val_ArgumentType_18,
        __ScfToSsfGenericReturnable_val_ArgumentType_19_sCIBillingChargingCharacteristics,
        __ScfToSsfGenericReturnable_val_ArgumentType_19_partyToCharge,
        ___ScfToSsfGenericReturnable_val_ArgumentType_19_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_19_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_19,
        __ScfToSsfGenericReturnable_val_ArgumentType_20_legToBeSplit,
        __ScfToSsfGenericReturnable_val_ArgumentType_20_newCallSegment,
        ___ScfToSsfGenericReturnable_val_ArgumentType_20_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_20_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_20,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_inbandInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend_tone,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_informationToSend,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_disconnectFromIPForbidden,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementCompleteNotification,
        ___ScfToSsfGenericReturnable_val_ArgumentType_21_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_21_requestAnnouncementStartedNotification,
        _ScfToSsfGenericReturnable_val_ArgumentType_21,
        ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_callSegmentID,
        ___ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment_legID,
        __ScfToSsfGenericReturnable_val_ArgumentType_22_legOrCallSegment,
        __ScfToSsfGenericReturnable_val_ArgumentType_22_bursts,
        ___ScfToSsfGenericReturnable_val_ArgumentType_22_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_22_extensions,
        _ScfToSsfGenericReturnable_val_ArgumentType_22,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_collectedInfo,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_disconnectFromIPForbidden,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageID,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_messageContent,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text_attributes,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_text,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs__item_,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_elementaryMessageIDs,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_elementaryMessageID,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__integer,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__number,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__time,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__date,
        ________ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item__price,
        _______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts__item_,
        ______ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage_variableParts,
        _____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID_variableMessage,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_messageID,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_numberOfRepetitions,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_duration,
        ____ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo_interval,
        ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_inbandInfo,
        ___ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend_tone,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_informationToSend,
        ___ScfToSsfGenericReturnable_val_ArgumentType_23_extensions__item_,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_extensions,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_callSegmentID,
        __ScfToSsfGenericReturnable_val_ArgumentType_23_requestAnnouncementStartedNotification,
        _ScfToSsfGenericReturnable_val_ArgumentType_23,
        __ScfToSsfGenericReturnable_val_ResultType_23_digitsResponse,
        _ScfToSsfGenericReturnable_val_ResultType_23,
        _ScfToSsfGenericReturnable_val_ArgumentType_24,
    ]

class CAP_object_identifiers:

    _name_  = u'CAP-object-identifiers'
    _oid_   = [0, 4, 0, 0, 1, 3, 100, 7]
    
    _obj_ = [
        u'tc-Messages',
        u'tc-NotationExtensions',
        u'ros-InformationObjects',
        u'datatypes',
        u'errortypes',
        u'operationcodes',
        u'errorcodes',
        u'classes',
        u'gsmSSF-gsmSCF-Operations',
        u'gsmSSF-gsmSCF-Protocol',
        u'gsmSCF-gsmSRF-Operations',
        u'gsmSCF-gsmSRF-Protocol',
        u'sms-Operations',
        u'smsSSF-gsmSCF-Protocol',
        u'gprsSSF-gsmSCF-Operations',
        u'gprsSSF-gsmSCF-Protocol',
        u'id-CAP',
        u'id-CAP3',
        u'id-CAPOE',
        u'id-CAP3OE',
        u'id-ac',
        u'id-acE',
        u'id-ac3E',
        u'id-as',
        u'id-asE',
        u'id-rosObject',
        u'id-contract',
        u'id-contract3',
        u'id-contractE',
        u'id-package',
        u'id-packageE',
        u'id-rosObject-gsmSCF',
        u'id-rosObject-gsmSSF',
        u'id-rosObject-gsmSRF',
        u'id-rosObject-gprsSSF',
        u'id-rosObject-smsSSF-V3',
        u'id-rosObject-smsSSF-V4',
        u'id-ac-CAP-gsmSSF-scfGenericAC',
        u'id-ac-CAP-gsmSSF-scfAssistHandoffAC',
        u'id-ac-CAP-scf-gsmSSFGenericAC',
        u'id-ac-gsmSRF-gsmSCF',
        u'id-ac-CAP-gprsSSF-gsmSCF-AC',
        u'id-ac-CAP-gsmSCF-gprsSSF-AC',
        u'id-ac-cap3-sms-AC',
        u'id-ac-cap4-sms-AC',
        u'id-CAPSsfToScfGeneric',
        u'id-CAPAssistHandoffssfToScf',
        u'id-CAPScfToSsfGeneric',
        u'id-contract-gsmSRF-gsmSCF',
        u'id-capGprsSsfTogsmScf',
        u'id-capGsmScfToGprsSsf',
        u'id-cap3SmsSsfTogsmScf',
        u'id-cap4SmsSsfTogsmScf',
        u'id-package-scfActivation',
        u'id-package-gsmSRF-scfActivationOfAssist',
        u'id-package-assistConnectionEstablishment',
        u'id-package-genericDisconnectResource',
        u'id-package-nonAssistedConnectionEstablishment',
        u'id-package-connect',
        u'id-package-callHandling',
        u'id-package-bcsmEventHandling',
        u'id-package-ssfCallProcessing',
        u'id-package-scfCallInitiation',
        u'id-package-timer',
        u'id-package-billing',
        u'id-package-charging',
        u'id-package-trafficManagement',
        u'id-package-callReport',
        u'id-package-signallingControl',
        u'id-package-activityTest',
        u'id-package-cancel',
        u'id-package-cphResponse',
        u'id-package-exceptionInform',
        u'id-package-playTone',
        u'id-package-specializedResourceControl',
        u'id-package-gsmSRF-scfCancel',
        u'id-package-gprsContinue',
        u'id-package-gprsExceptionInformation',
        u'id-package-gprsScfActivation',
        u'id-package-gprsConnect',
        u'id-package-gprsRelease',
        u'id-package-gprsEventHandling',
        u'id-package-gprsTimer',
        u'id-package-gprsBilling',
        u'id-package-gprsCharging',
        u'id-package-gprsActivityTest',
        u'id-package-gprsCancel',
        u'id-package-gprsChargeAdvice',
        u'id-package-smsActivation',
        u'id-package-smsConnect',
        u'id-package-smsContinue',
        u'id-package-smsRelease',
        u'id-package-smsEventHandling',
        u'id-package-smsBilling',
        u'id-package-smsTimer',
        u'id-as-gsmSSF-scfGenericAS',
        u'id-as-assistHandoff-gsmSSF-scfAS',
        u'id-as-scf-gsmSSFGenericAS',
        u'id-as-basic-gsmSRF-gsmSCF',
        u'id-as-gprsSSF-gsmSCF-AS',
        u'id-as-gsmSCF-gprsSSF-AS',
        u'id-as-smsSSF-gsmSCF-AS',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'tc-Messages',
        u'tc-NotationExtensions',
        u'ros-InformationObjects',
        u'datatypes',
        u'errortypes',
        u'operationcodes',
        u'errorcodes',
        u'classes',
        u'gsmSSF-gsmSCF-Operations',
        u'gsmSSF-gsmSCF-Protocol',
        u'gsmSCF-gsmSRF-Operations',
        u'gsmSCF-gsmSRF-Protocol',
        u'sms-Operations',
        u'smsSSF-gsmSCF-Protocol',
        u'gprsSSF-gsmSCF-Operations',
        u'gprsSSF-gsmSCF-Protocol',
        u'id-CAP',
        u'id-CAP3',
        u'id-CAPOE',
        u'id-CAP3OE',
        u'id-ac',
        u'id-acE',
        u'id-ac3E',
        u'id-as',
        u'id-asE',
        u'id-rosObject',
        u'id-contract',
        u'id-contract3',
        u'id-contractE',
        u'id-package',
        u'id-packageE',
        u'id-rosObject-gsmSCF',
        u'id-rosObject-gsmSSF',
        u'id-rosObject-gsmSRF',
        u'id-rosObject-gprsSSF',
        u'id-rosObject-smsSSF-V3',
        u'id-rosObject-smsSSF-V4',
        u'id-ac-CAP-gsmSSF-scfGenericAC',
        u'id-ac-CAP-gsmSSF-scfAssistHandoffAC',
        u'id-ac-CAP-scf-gsmSSFGenericAC',
        u'id-ac-gsmSRF-gsmSCF',
        u'id-ac-CAP-gprsSSF-gsmSCF-AC',
        u'id-ac-CAP-gsmSCF-gprsSSF-AC',
        u'id-ac-cap3-sms-AC',
        u'id-ac-cap4-sms-AC',
        u'id-CAPSsfToScfGeneric',
        u'id-CAPAssistHandoffssfToScf',
        u'id-CAPScfToSsfGeneric',
        u'id-contract-gsmSRF-gsmSCF',
        u'id-capGprsSsfTogsmScf',
        u'id-capGsmScfToGprsSsf',
        u'id-cap3SmsSsfTogsmScf',
        u'id-cap4SmsSsfTogsmScf',
        u'id-package-scfActivation',
        u'id-package-gsmSRF-scfActivationOfAssist',
        u'id-package-assistConnectionEstablishment',
        u'id-package-genericDisconnectResource',
        u'id-package-nonAssistedConnectionEstablishment',
        u'id-package-connect',
        u'id-package-callHandling',
        u'id-package-bcsmEventHandling',
        u'id-package-ssfCallProcessing',
        u'id-package-scfCallInitiation',
        u'id-package-timer',
        u'id-package-billing',
        u'id-package-charging',
        u'id-package-trafficManagement',
        u'id-package-callReport',
        u'id-package-signallingControl',
        u'id-package-activityTest',
        u'id-package-cancel',
        u'id-package-cphResponse',
        u'id-package-exceptionInform',
        u'id-package-playTone',
        u'id-package-specializedResourceControl',
        u'id-package-gsmSRF-scfCancel',
        u'id-package-gprsContinue',
        u'id-package-gprsExceptionInformation',
        u'id-package-gprsScfActivation',
        u'id-package-gprsConnect',
        u'id-package-gprsRelease',
        u'id-package-gprsEventHandling',
        u'id-package-gprsTimer',
        u'id-package-gprsBilling',
        u'id-package-gprsCharging',
        u'id-package-gprsActivityTest',
        u'id-package-gprsCancel',
        u'id-package-gprsChargeAdvice',
        u'id-package-smsActivation',
        u'id-package-smsConnect',
        u'id-package-smsContinue',
        u'id-package-smsRelease',
        u'id-package-smsEventHandling',
        u'id-package-smsBilling',
        u'id-package-smsTimer',
        u'id-as-gsmSSF-scfGenericAS',
        u'id-as-assistHandoff-gsmSSF-scfAS',
        u'id-as-scf-gsmSSFGenericAS',
        u'id-as-basic-gsmSRF-gsmSCF',
        u'id-as-gprsSSF-gsmSCF-AS',
        u'id-as-gsmSCF-gprsSSF-AS',
        u'id-as-smsSSF-gsmSCF-AS',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< tc-Messages >-----#
    tc_Messages = OID(name=u'tc-Messages', mode=MODE_VALUE)
    tc_Messages._val = (0, 0, 17, 773, 2, 1, 3)
    
    #-----< tc-NotationExtensions >-----#
    tc_NotationExtensions = OID(name=u'tc-NotationExtensions', mode=MODE_VALUE)
    tc_NotationExtensions._val = (0, 0, 17, 775, 2, 4, 1)
    
    #-----< ros-InformationObjects >-----#
    ros_InformationObjects = OID(name=u'ros-InformationObjects', mode=MODE_VALUE)
    ros_InformationObjects._val = (2, 4, 5, 0)
    
    #-----< datatypes >-----#
    datatypes = OID(name=u'datatypes', mode=MODE_VALUE)
    datatypes._val = (0, 4, 0, 0, 1, 3, 52, 7)
    
    #-----< errortypes >-----#
    errortypes = OID(name=u'errortypes', mode=MODE_VALUE)
    errortypes._val = (0, 4, 0, 0, 1, 3, 51, 7)
    
    #-----< operationcodes >-----#
    operationcodes = OID(name=u'operationcodes', mode=MODE_VALUE)
    operationcodes._val = (0, 4, 0, 0, 1, 3, 53, 7)
    
    #-----< errorcodes >-----#
    errorcodes = OID(name=u'errorcodes', mode=MODE_VALUE)
    errorcodes._val = (0, 4, 0, 0, 1, 3, 57, 7)
    
    #-----< classes >-----#
    classes = OID(name=u'classes', mode=MODE_VALUE)
    classes._val = (0, 4, 0, 0, 1, 3, 54, 7)
    
    #-----< gsmSSF-gsmSCF-Operations >-----#
    gsmSSF_gsmSCF_Operations = OID(name=u'gsmSSF-gsmSCF-Operations', mode=MODE_VALUE)
    gsmSSF_gsmSCF_Operations._val = (0, 4, 0, 0, 1, 3, 101, 7)
    
    #-----< gsmSSF-gsmSCF-Protocol >-----#
    gsmSSF_gsmSCF_Protocol = OID(name=u'gsmSSF-gsmSCF-Protocol', mode=MODE_VALUE)
    gsmSSF_gsmSCF_Protocol._val = (0, 4, 0, 0, 1, 3, 102, 7)
    
    #-----< gsmSCF-gsmSRF-Operations >-----#
    gsmSCF_gsmSRF_Operations = OID(name=u'gsmSCF-gsmSRF-Operations', mode=MODE_VALUE)
    gsmSCF_gsmSRF_Operations._val = (0, 4, 0, 0, 1, 3, 103, 7)
    
    #-----< gsmSCF-gsmSRF-Protocol >-----#
    gsmSCF_gsmSRF_Protocol = OID(name=u'gsmSCF-gsmSRF-Protocol', mode=MODE_VALUE)
    gsmSCF_gsmSRF_Protocol._val = (0, 4, 0, 0, 1, 3, 104, 7)
    
    #-----< sms-Operations >-----#
    sms_Operations = OID(name=u'sms-Operations', mode=MODE_VALUE)
    sms_Operations._val = (0, 4, 0, 0, 1, 3, 105, 7)
    
    #-----< smsSSF-gsmSCF-Protocol >-----#
    smsSSF_gsmSCF_Protocol = OID(name=u'smsSSF-gsmSCF-Protocol', mode=MODE_VALUE)
    smsSSF_gsmSCF_Protocol._val = (0, 4, 0, 0, 1, 3, 106, 7)
    
    #-----< gprsSSF-gsmSCF-Operations >-----#
    gprsSSF_gsmSCF_Operations = OID(name=u'gprsSSF-gsmSCF-Operations', mode=MODE_VALUE)
    gprsSSF_gsmSCF_Operations._val = (0, 4, 0, 0, 1, 3, 107, 7)
    
    #-----< gprsSSF-gsmSCF-Protocol >-----#
    gprsSSF_gsmSCF_Protocol = OID(name=u'gprsSSF-gsmSCF-Protocol', mode=MODE_VALUE)
    gprsSSF_gsmSCF_Protocol._val = (0, 4, 0, 0, 1, 3, 108, 7)
    
    #-----< id-CAP >-----#
    id_CAP = OID(name=u'id-CAP', mode=MODE_VALUE)
    id_CAP._val = (0, 4, 0, 0, 1, 22)
    
    #-----< id-CAP3 >-----#
    id_CAP3 = OID(name=u'id-CAP3', mode=MODE_VALUE)
    id_CAP3._val = (0, 4, 0, 0, 1, 20)
    
    #-----< id-CAPOE >-----#
    id_CAPOE = OID(name=u'id-CAPOE', mode=MODE_VALUE)
    id_CAPOE._val = (0, 4, 0, 0, 1, 23)
    
    #-----< id-CAP3OE >-----#
    id_CAP3OE = OID(name=u'id-CAP3OE', mode=MODE_VALUE)
    id_CAP3OE._val = (0, 4, 0, 0, 1, 21)
    
    #-----< id-ac >-----#
    id_ac = OID(name=u'id-ac', mode=MODE_VALUE)
    id_ac._val = (0, 4, 0, 0, 1, 22, 3)
    
    #-----< id-acE >-----#
    id_acE = OID(name=u'id-acE', mode=MODE_VALUE)
    id_acE._val = (0, 4, 0, 0, 1, 23, 3)
    
    #-----< id-ac3E >-----#
    id_ac3E = OID(name=u'id-ac3E', mode=MODE_VALUE)
    id_ac3E._val = (0, 4, 0, 0, 1, 21, 3)
    
    #-----< id-as >-----#
    id_as = OID(name=u'id-as', mode=MODE_VALUE)
    id_as._val = (0, 4, 0, 0, 1, 22, 5)
    
    #-----< id-asE >-----#
    id_asE = OID(name=u'id-asE', mode=MODE_VALUE)
    id_asE._val = (0, 4, 0, 0, 1, 23, 5)
    
    #-----< id-rosObject >-----#
    id_rosObject = OID(name=u'id-rosObject', mode=MODE_VALUE)
    id_rosObject._val = (0, 4, 0, 0, 1, 22, 25)
    
    #-----< id-contract >-----#
    id_contract = OID(name=u'id-contract', mode=MODE_VALUE)
    id_contract._val = (0, 4, 0, 0, 1, 22, 26)
    
    #-----< id-contract3 >-----#
    id_contract3 = OID(name=u'id-contract3', mode=MODE_VALUE)
    id_contract3._val = (0, 4, 0, 0, 1, 20, 26)
    
    #-----< id-contractE >-----#
    id_contractE = OID(name=u'id-contractE', mode=MODE_VALUE)
    id_contractE._val = (0, 4, 0, 0, 1, 23, 26)
    
    #-----< id-package >-----#
    id_package = OID(name=u'id-package', mode=MODE_VALUE)
    id_package._val = (0, 4, 0, 0, 1, 22, 27)
    
    #-----< id-packageE >-----#
    id_packageE = OID(name=u'id-packageE', mode=MODE_VALUE)
    id_packageE._val = (0, 4, 0, 0, 1, 23, 27)
    
    #-----< id-rosObject-gsmSCF >-----#
    id_rosObject_gsmSCF = OID(name=u'id-rosObject-gsmSCF', mode=MODE_VALUE)
    id_rosObject_gsmSCF._val = (0, 4, 0, 0, 1, 22, 25, 4)
    
    #-----< id-rosObject-gsmSSF >-----#
    id_rosObject_gsmSSF = OID(name=u'id-rosObject-gsmSSF', mode=MODE_VALUE)
    id_rosObject_gsmSSF._val = (0, 4, 0, 0, 1, 22, 25, 5)
    
    #-----< id-rosObject-gsmSRF >-----#
    id_rosObject_gsmSRF = OID(name=u'id-rosObject-gsmSRF', mode=MODE_VALUE)
    id_rosObject_gsmSRF._val = (0, 4, 0, 0, 1, 22, 25, 6)
    
    #-----< id-rosObject-gprsSSF >-----#
    id_rosObject_gprsSSF = OID(name=u'id-rosObject-gprsSSF', mode=MODE_VALUE)
    id_rosObject_gprsSSF._val = (0, 4, 0, 0, 1, 22, 25, 7)
    
    #-----< id-rosObject-smsSSF-V3 >-----#
    id_rosObject_smsSSF_V3 = OID(name=u'id-rosObject-smsSSF-V3', mode=MODE_VALUE)
    id_rosObject_smsSSF_V3._val = (0, 4, 0, 0, 1, 22, 25, 8)
    
    #-----< id-rosObject-smsSSF-V4 >-----#
    id_rosObject_smsSSF_V4 = OID(name=u'id-rosObject-smsSSF-V4', mode=MODE_VALUE)
    id_rosObject_smsSSF_V4._val = (0, 4, 0, 0, 1, 22, 25, 9)
    
    #-----< id-ac-CAP-gsmSSF-scfGenericAC >-----#
    id_ac_CAP_gsmSSF_scfGenericAC = OID(name=u'id-ac-CAP-gsmSSF-scfGenericAC', mode=MODE_VALUE)
    id_ac_CAP_gsmSSF_scfGenericAC._val = (0, 4, 0, 0, 1, 23, 3, 4)
    
    #-----< id-ac-CAP-gsmSSF-scfAssistHandoffAC >-----#
    id_ac_CAP_gsmSSF_scfAssistHandoffAC = OID(name=u'id-ac-CAP-gsmSSF-scfAssistHandoffAC', mode=MODE_VALUE)
    id_ac_CAP_gsmSSF_scfAssistHandoffAC._val = (0, 4, 0, 0, 1, 23, 3, 6)
    
    #-----< id-ac-CAP-scf-gsmSSFGenericAC >-----#
    id_ac_CAP_scf_gsmSSFGenericAC = OID(name=u'id-ac-CAP-scf-gsmSSFGenericAC', mode=MODE_VALUE)
    id_ac_CAP_scf_gsmSSFGenericAC._val = (0, 4, 0, 0, 1, 23, 3, 8)
    
    #-----< id-ac-gsmSRF-gsmSCF >-----#
    id_ac_gsmSRF_gsmSCF = OID(name=u'id-ac-gsmSRF-gsmSCF', mode=MODE_VALUE)
    id_ac_gsmSRF_gsmSCF._val = (0, 4, 0, 0, 1, 22, 3, 14)
    
    #-----< id-ac-CAP-gprsSSF-gsmSCF-AC >-----#
    id_ac_CAP_gprsSSF_gsmSCF_AC = OID(name=u'id-ac-CAP-gprsSSF-gsmSCF-AC', mode=MODE_VALUE)
    id_ac_CAP_gprsSSF_gsmSCF_AC._val = (0, 4, 0, 0, 1, 21, 3, 50)
    
    #-----< id-ac-CAP-gsmSCF-gprsSSF-AC >-----#
    id_ac_CAP_gsmSCF_gprsSSF_AC = OID(name=u'id-ac-CAP-gsmSCF-gprsSSF-AC', mode=MODE_VALUE)
    id_ac_CAP_gsmSCF_gprsSSF_AC._val = (0, 4, 0, 0, 1, 21, 3, 51)
    
    #-----< id-ac-cap3-sms-AC >-----#
    id_ac_cap3_sms_AC = OID(name=u'id-ac-cap3-sms-AC', mode=MODE_VALUE)
    id_ac_cap3_sms_AC._val = (0, 4, 0, 0, 1, 21, 3, 61)
    
    #-----< id-ac-cap4-sms-AC >-----#
    id_ac_cap4_sms_AC = OID(name=u'id-ac-cap4-sms-AC', mode=MODE_VALUE)
    id_ac_cap4_sms_AC._val = (0, 4, 0, 0, 1, 23, 3, 61)
    
    #-----< id-CAPSsfToScfGeneric >-----#
    id_CAPSsfToScfGeneric = OID(name=u'id-CAPSsfToScfGeneric', mode=MODE_VALUE)
    id_CAPSsfToScfGeneric._val = (0, 4, 0, 0, 1, 23, 26, 3)
    
    #-----< id-CAPAssistHandoffssfToScf >-----#
    id_CAPAssistHandoffssfToScf = OID(name=u'id-CAPAssistHandoffssfToScf', mode=MODE_VALUE)
    id_CAPAssistHandoffssfToScf._val = (0, 4, 0, 0, 1, 23, 26, 5)
    
    #-----< id-CAPScfToSsfGeneric >-----#
    id_CAPScfToSsfGeneric = OID(name=u'id-CAPScfToSsfGeneric', mode=MODE_VALUE)
    id_CAPScfToSsfGeneric._val = (0, 4, 0, 0, 1, 23, 26, 6)
    
    #-----< id-contract-gsmSRF-gsmSCF >-----#
    id_contract_gsmSRF_gsmSCF = OID(name=u'id-contract-gsmSRF-gsmSCF', mode=MODE_VALUE)
    id_contract_gsmSRF_gsmSCF._val = (0, 4, 0, 0, 1, 22, 26, 13)
    
    #-----< id-capGprsSsfTogsmScf >-----#
    id_capGprsSsfTogsmScf = OID(name=u'id-capGprsSsfTogsmScf', mode=MODE_VALUE)
    id_capGprsSsfTogsmScf._val = (0, 4, 0, 0, 1, 22, 26, 14)
    
    #-----< id-capGsmScfToGprsSsf >-----#
    id_capGsmScfToGprsSsf = OID(name=u'id-capGsmScfToGprsSsf', mode=MODE_VALUE)
    id_capGsmScfToGprsSsf._val = (0, 4, 0, 0, 1, 22, 26, 15)
    
    #-----< id-cap3SmsSsfTogsmScf >-----#
    id_cap3SmsSsfTogsmScf = OID(name=u'id-cap3SmsSsfTogsmScf', mode=MODE_VALUE)
    id_cap3SmsSsfTogsmScf._val = (0, 4, 0, 0, 1, 20, 26, 16)
    
    #-----< id-cap4SmsSsfTogsmScf >-----#
    id_cap4SmsSsfTogsmScf = OID(name=u'id-cap4SmsSsfTogsmScf', mode=MODE_VALUE)
    id_cap4SmsSsfTogsmScf._val = (0, 4, 0, 0, 1, 22, 26, 16)
    
    #-----< id-package-scfActivation >-----#
    id_package_scfActivation = OID(name=u'id-package-scfActivation', mode=MODE_VALUE)
    id_package_scfActivation._val = (0, 4, 0, 0, 1, 22, 27, 11)
    
    #-----< id-package-gsmSRF-scfActivationOfAssist >-----#
    id_package_gsmSRF_scfActivationOfAssist = OID(name=u'id-package-gsmSRF-scfActivationOfAssist', mode=MODE_VALUE)
    id_package_gsmSRF_scfActivationOfAssist._val = (0, 4, 0, 0, 1, 22, 27, 15)
    
    #-----< id-package-assistConnectionEstablishment >-----#
    id_package_assistConnectionEstablishment = OID(name=u'id-package-assistConnectionEstablishment', mode=MODE_VALUE)
    id_package_assistConnectionEstablishment._val = (0, 4, 0, 0, 1, 22, 27, 16)
    
    #-----< id-package-genericDisconnectResource >-----#
    id_package_genericDisconnectResource = OID(name=u'id-package-genericDisconnectResource', mode=MODE_VALUE)
    id_package_genericDisconnectResource._val = (0, 4, 0, 0, 1, 22, 27, 17)
    
    #-----< id-package-nonAssistedConnectionEstablishment >-----#
    id_package_nonAssistedConnectionEstablishment = OID(name=u'id-package-nonAssistedConnectionEstablishment', mode=MODE_VALUE)
    id_package_nonAssistedConnectionEstablishment._val = (0, 4, 0, 0, 1, 22, 27, 18)
    
    #-----< id-package-connect >-----#
    id_package_connect = OID(name=u'id-package-connect', mode=MODE_VALUE)
    id_package_connect._val = (0, 4, 0, 0, 1, 22, 27, 19)
    
    #-----< id-package-callHandling >-----#
    id_package_callHandling = OID(name=u'id-package-callHandling', mode=MODE_VALUE)
    id_package_callHandling._val = (0, 4, 0, 0, 1, 23, 27, 20)
    
    #-----< id-package-bcsmEventHandling >-----#
    id_package_bcsmEventHandling = OID(name=u'id-package-bcsmEventHandling', mode=MODE_VALUE)
    id_package_bcsmEventHandling._val = (0, 4, 0, 0, 1, 22, 27, 21)
    
    #-----< id-package-ssfCallProcessing >-----#
    id_package_ssfCallProcessing = OID(name=u'id-package-ssfCallProcessing', mode=MODE_VALUE)
    id_package_ssfCallProcessing._val = (0, 4, 0, 0, 1, 23, 27, 24)
    
    #-----< id-package-scfCallInitiation >-----#
    id_package_scfCallInitiation = OID(name=u'id-package-scfCallInitiation', mode=MODE_VALUE)
    id_package_scfCallInitiation._val = (0, 4, 0, 0, 1, 22, 27, 25)
    
    #-----< id-package-timer >-----#
    id_package_timer = OID(name=u'id-package-timer', mode=MODE_VALUE)
    id_package_timer._val = (0, 4, 0, 0, 1, 22, 27, 26)
    
    #-----< id-package-billing >-----#
    id_package_billing = OID(name=u'id-package-billing', mode=MODE_VALUE)
    id_package_billing._val = (0, 4, 0, 0, 1, 22, 27, 27)
    
    #-----< id-package-charging >-----#
    id_package_charging = OID(name=u'id-package-charging', mode=MODE_VALUE)
    id_package_charging._val = (0, 4, 0, 0, 1, 22, 27, 28)
    
    #-----< id-package-trafficManagement >-----#
    id_package_trafficManagement = OID(name=u'id-package-trafficManagement', mode=MODE_VALUE)
    id_package_trafficManagement._val = (0, 4, 0, 0, 1, 22, 27, 29)
    
    #-----< id-package-callReport >-----#
    id_package_callReport = OID(name=u'id-package-callReport', mode=MODE_VALUE)
    id_package_callReport._val = (0, 4, 0, 0, 1, 22, 27, 32)
    
    #-----< id-package-signallingControl >-----#
    id_package_signallingControl = OID(name=u'id-package-signallingControl', mode=MODE_VALUE)
    id_package_signallingControl._val = (0, 4, 0, 0, 1, 22, 27, 33)
    
    #-----< id-package-activityTest >-----#
    id_package_activityTest = OID(name=u'id-package-activityTest', mode=MODE_VALUE)
    id_package_activityTest._val = (0, 4, 0, 0, 1, 22, 27, 34)
    
    #-----< id-package-cancel >-----#
    id_package_cancel = OID(name=u'id-package-cancel', mode=MODE_VALUE)
    id_package_cancel._val = (0, 4, 0, 0, 1, 23, 27, 36)
    
    #-----< id-package-cphResponse >-----#
    id_package_cphResponse = OID(name=u'id-package-cphResponse', mode=MODE_VALUE)
    id_package_cphResponse._val = (0, 4, 0, 0, 1, 22, 27, 37)
    
    #-----< id-package-exceptionInform >-----#
    id_package_exceptionInform = OID(name=u'id-package-exceptionInform', mode=MODE_VALUE)
    id_package_exceptionInform._val = (0, 4, 0, 0, 1, 22, 27, 38)
    
    #-----< id-package-playTone >-----#
    id_package_playTone = OID(name=u'id-package-playTone', mode=MODE_VALUE)
    id_package_playTone._val = (0, 4, 0, 0, 1, 22, 27, 39)
    
    #-----< id-package-specializedResourceControl >-----#
    id_package_specializedResourceControl = OID(name=u'id-package-specializedResourceControl', mode=MODE_VALUE)
    id_package_specializedResourceControl._val = (0, 4, 0, 0, 1, 22, 27, 42)
    
    #-----< id-package-gsmSRF-scfCancel >-----#
    id_package_gsmSRF_scfCancel = OID(name=u'id-package-gsmSRF-scfCancel', mode=MODE_VALUE)
    id_package_gsmSRF_scfCancel._val = (0, 4, 0, 0, 1, 22, 27, 43)
    
    #-----< id-package-gprsContinue >-----#
    id_package_gprsContinue = OID(name=u'id-package-gprsContinue', mode=MODE_VALUE)
    id_package_gprsContinue._val = (0, 4, 0, 0, 1, 22, 27, 49)
    
    #-----< id-package-gprsExceptionInformation >-----#
    id_package_gprsExceptionInformation = OID(name=u'id-package-gprsExceptionInformation', mode=MODE_VALUE)
    id_package_gprsExceptionInformation._val = (0, 4, 0, 0, 1, 22, 27, 50)
    
    #-----< id-package-gprsScfActivation >-----#
    id_package_gprsScfActivation = OID(name=u'id-package-gprsScfActivation', mode=MODE_VALUE)
    id_package_gprsScfActivation._val = (0, 4, 0, 0, 1, 22, 27, 51)
    
    #-----< id-package-gprsConnect >-----#
    id_package_gprsConnect = OID(name=u'id-package-gprsConnect', mode=MODE_VALUE)
    id_package_gprsConnect._val = (0, 4, 0, 0, 1, 22, 27, 52)
    
    #-----< id-package-gprsRelease >-----#
    id_package_gprsRelease = OID(name=u'id-package-gprsRelease', mode=MODE_VALUE)
    id_package_gprsRelease._val = (0, 4, 0, 0, 1, 22, 27, 53)
    
    #-----< id-package-gprsEventHandling >-----#
    id_package_gprsEventHandling = OID(name=u'id-package-gprsEventHandling', mode=MODE_VALUE)
    id_package_gprsEventHandling._val = (0, 4, 0, 0, 1, 22, 27, 54)
    
    #-----< id-package-gprsTimer >-----#
    id_package_gprsTimer = OID(name=u'id-package-gprsTimer', mode=MODE_VALUE)
    id_package_gprsTimer._val = (0, 4, 0, 0, 1, 22, 27, 55)
    
    #-----< id-package-gprsBilling >-----#
    id_package_gprsBilling = OID(name=u'id-package-gprsBilling', mode=MODE_VALUE)
    id_package_gprsBilling._val = (0, 4, 0, 0, 1, 22, 27, 56)
    
    #-----< id-package-gprsCharging >-----#
    id_package_gprsCharging = OID(name=u'id-package-gprsCharging', mode=MODE_VALUE)
    id_package_gprsCharging._val = (0, 4, 0, 0, 1, 22, 27, 57)
    
    #-----< id-package-gprsActivityTest >-----#
    id_package_gprsActivityTest = OID(name=u'id-package-gprsActivityTest', mode=MODE_VALUE)
    id_package_gprsActivityTest._val = (0, 4, 0, 0, 1, 22, 27, 58)
    
    #-----< id-package-gprsCancel >-----#
    id_package_gprsCancel = OID(name=u'id-package-gprsCancel', mode=MODE_VALUE)
    id_package_gprsCancel._val = (0, 4, 0, 0, 1, 22, 27, 59)
    
    #-----< id-package-gprsChargeAdvice >-----#
    id_package_gprsChargeAdvice = OID(name=u'id-package-gprsChargeAdvice', mode=MODE_VALUE)
    id_package_gprsChargeAdvice._val = (0, 4, 0, 0, 1, 22, 27, 60)
    
    #-----< id-package-smsActivation >-----#
    id_package_smsActivation = OID(name=u'id-package-smsActivation', mode=MODE_VALUE)
    id_package_smsActivation._val = (0, 4, 0, 0, 1, 22, 27, 61)
    
    #-----< id-package-smsConnect >-----#
    id_package_smsConnect = OID(name=u'id-package-smsConnect', mode=MODE_VALUE)
    id_package_smsConnect._val = (0, 4, 0, 0, 1, 22, 27, 62)
    
    #-----< id-package-smsContinue >-----#
    id_package_smsContinue = OID(name=u'id-package-smsContinue', mode=MODE_VALUE)
    id_package_smsContinue._val = (0, 4, 0, 0, 1, 22, 27, 63)
    
    #-----< id-package-smsRelease >-----#
    id_package_smsRelease = OID(name=u'id-package-smsRelease', mode=MODE_VALUE)
    id_package_smsRelease._val = (0, 4, 0, 0, 1, 22, 27, 64)
    
    #-----< id-package-smsEventHandling >-----#
    id_package_smsEventHandling = OID(name=u'id-package-smsEventHandling', mode=MODE_VALUE)
    id_package_smsEventHandling._val = (0, 4, 0, 0, 1, 22, 27, 65)
    
    #-----< id-package-smsBilling >-----#
    id_package_smsBilling = OID(name=u'id-package-smsBilling', mode=MODE_VALUE)
    id_package_smsBilling._val = (0, 4, 0, 0, 1, 22, 27, 66)
    
    #-----< id-package-smsTimer >-----#
    id_package_smsTimer = OID(name=u'id-package-smsTimer', mode=MODE_VALUE)
    id_package_smsTimer._val = (0, 4, 0, 0, 1, 22, 27, 67)
    
    #-----< id-as-gsmSSF-scfGenericAS >-----#
    id_as_gsmSSF_scfGenericAS = OID(name=u'id-as-gsmSSF-scfGenericAS', mode=MODE_VALUE)
    id_as_gsmSSF_scfGenericAS._val = (0, 4, 0, 0, 1, 23, 5, 4)
    
    #-----< id-as-assistHandoff-gsmSSF-scfAS >-----#
    id_as_assistHandoff_gsmSSF_scfAS = OID(name=u'id-as-assistHandoff-gsmSSF-scfAS', mode=MODE_VALUE)
    id_as_assistHandoff_gsmSSF_scfAS._val = (0, 4, 0, 0, 1, 23, 5, 6)
    
    #-----< id-as-scf-gsmSSFGenericAS >-----#
    id_as_scf_gsmSSFGenericAS = OID(name=u'id-as-scf-gsmSSFGenericAS', mode=MODE_VALUE)
    id_as_scf_gsmSSFGenericAS._val = (0, 4, 0, 0, 1, 23, 5, 7)
    
    #-----< id-as-basic-gsmSRF-gsmSCF >-----#
    id_as_basic_gsmSRF_gsmSCF = OID(name=u'id-as-basic-gsmSRF-gsmSCF', mode=MODE_VALUE)
    id_as_basic_gsmSRF_gsmSCF._val = (0, 4, 0, 0, 1, 22, 5, 14)
    
    #-----< id-as-gprsSSF-gsmSCF-AS >-----#
    id_as_gprsSSF_gsmSCF_AS = OID(name=u'id-as-gprsSSF-gsmSCF-AS', mode=MODE_VALUE)
    id_as_gprsSSF_gsmSCF_AS._val = (0, 4, 0, 0, 1, 22, 5, 50)
    
    #-----< id-as-gsmSCF-gprsSSF-AS >-----#
    id_as_gsmSCF_gprsSSF_AS = OID(name=u'id-as-gsmSCF-gprsSSF-AS', mode=MODE_VALUE)
    id_as_gsmSCF_gprsSSF_AS._val = (0, 4, 0, 0, 1, 22, 5, 51)
    
    #-----< id-as-smsSSF-gsmSCF-AS >-----#
    id_as_smsSSF_gsmSCF_AS = OID(name=u'id-as-smsSSF-gsmSCF-AS', mode=MODE_VALUE)
    id_as_smsSSF_gsmSCF_AS._val = (0, 4, 0, 0, 1, 22, 5, 61)
    
    _all_ = [
        tc_Messages,
        tc_NotationExtensions,
        ros_InformationObjects,
        datatypes,
        errortypes,
        operationcodes,
        errorcodes,
        classes,
        gsmSSF_gsmSCF_Operations,
        gsmSSF_gsmSCF_Protocol,
        gsmSCF_gsmSRF_Operations,
        gsmSCF_gsmSRF_Protocol,
        sms_Operations,
        smsSSF_gsmSCF_Protocol,
        gprsSSF_gsmSCF_Operations,
        gprsSSF_gsmSCF_Protocol,
        id_CAP,
        id_CAP3,
        id_CAPOE,
        id_CAP3OE,
        id_ac,
        id_acE,
        id_ac3E,
        id_as,
        id_asE,
        id_rosObject,
        id_contract,
        id_contract3,
        id_contractE,
        id_package,
        id_packageE,
        id_rosObject_gsmSCF,
        id_rosObject_gsmSSF,
        id_rosObject_gsmSRF,
        id_rosObject_gprsSSF,
        id_rosObject_smsSSF_V3,
        id_rosObject_smsSSF_V4,
        id_ac_CAP_gsmSSF_scfGenericAC,
        id_ac_CAP_gsmSSF_scfAssistHandoffAC,
        id_ac_CAP_scf_gsmSSFGenericAC,
        id_ac_gsmSRF_gsmSCF,
        id_ac_CAP_gprsSSF_gsmSCF_AC,
        id_ac_CAP_gsmSCF_gprsSSF_AC,
        id_ac_cap3_sms_AC,
        id_ac_cap4_sms_AC,
        id_CAPSsfToScfGeneric,
        id_CAPAssistHandoffssfToScf,
        id_CAPScfToSsfGeneric,
        id_contract_gsmSRF_gsmSCF,
        id_capGprsSsfTogsmScf,
        id_capGsmScfToGprsSsf,
        id_cap3SmsSsfTogsmScf,
        id_cap4SmsSsfTogsmScf,
        id_package_scfActivation,
        id_package_gsmSRF_scfActivationOfAssist,
        id_package_assistConnectionEstablishment,
        id_package_genericDisconnectResource,
        id_package_nonAssistedConnectionEstablishment,
        id_package_connect,
        id_package_callHandling,
        id_package_bcsmEventHandling,
        id_package_ssfCallProcessing,
        id_package_scfCallInitiation,
        id_package_timer,
        id_package_billing,
        id_package_charging,
        id_package_trafficManagement,
        id_package_callReport,
        id_package_signallingControl,
        id_package_activityTest,
        id_package_cancel,
        id_package_cphResponse,
        id_package_exceptionInform,
        id_package_playTone,
        id_package_specializedResourceControl,
        id_package_gsmSRF_scfCancel,
        id_package_gprsContinue,
        id_package_gprsExceptionInformation,
        id_package_gprsScfActivation,
        id_package_gprsConnect,
        id_package_gprsRelease,
        id_package_gprsEventHandling,
        id_package_gprsTimer,
        id_package_gprsBilling,
        id_package_gprsCharging,
        id_package_gprsActivityTest,
        id_package_gprsCancel,
        id_package_gprsChargeAdvice,
        id_package_smsActivation,
        id_package_smsConnect,
        id_package_smsContinue,
        id_package_smsRelease,
        id_package_smsEventHandling,
        id_package_smsBilling,
        id_package_smsTimer,
        id_as_gsmSSF_scfGenericAS,
        id_as_assistHandoff_gsmSSF_scfAS,
        id_as_scf_gsmSSFGenericAS,
        id_as_basic_gsmSRF_gsmSCF,
        id_as_gprsSSF_gsmSCF_AS,
        id_as_gsmSCF_gprsSSF_AS,
        id_as_smsSSF_gsmSCF_AS,
    ]

class CAP_operationcodes:

    _name_  = u'CAP-operationcodes'
    _oid_   = [0, 4, 0, 0, 1, 3, 53, 7]
    
    _obj_ = [
        u'opcode-initialDP',
        u'opcode-assistRequestInstructions',
        u'opcode-establishTemporaryConnection',
        u'opcode-disconnectForwardConnection',
        u'opcode-dFCWithArgument',
        u'opcode-connectToResource',
        u'opcode-connect',
        u'opcode-releaseCall',
        u'opcode-requestReportBCSMEvent',
        u'opcode-eventReportBCSM',
        u'opcode-collectInformation',
        u'opcode-continue',
        u'opcode-initiateCallAttempt',
        u'opcode-resetTimer',
        u'opcode-furnishChargingInformation',
        u'opcode-applyCharging',
        u'opcode-applyChargingReport',
        u'opcode-callGap',
        u'opcode-callInformationReport',
        u'opcode-callInformationRequest',
        u'opcode-sendChargingInformation',
        u'opcode-playAnnouncement',
        u'opcode-promptAndCollectUserInformation',
        u'opcode-specializedResourceReport',
        u'opcode-cancel',
        u'opcode-activityTest',
        u'opcode-continueWithArgument',
        u'opcode-disconnectLeg',
        u'opcode-moveLeg',
        u'opcode-splitLeg',
        u'opcode-entityReleased',
        u'opcode-playTone',
        u'opcode-initialDPSMS',
        u'opcode-furnishChargingInformationSMS',
        u'opcode-connectSMS',
        u'opcode-requestReportSMSEvent',
        u'opcode-eventReportSMS',
        u'opcode-continueSMS',
        u'opcode-releaseSMS',
        u'opcode-resetTimerSMS',
        u'opcode-activityTestGPRS',
        u'opcode-applyChargingGPRS',
        u'opcode-applyChargingReportGPRS',
        u'opcode-cancelGPRS',
        u'opcode-connectGPRS',
        u'opcode-continueGPRS',
        u'opcode-entityReleasedGPRS',
        u'opcode-furnishChargingInformationGPRS',
        u'opcode-initialDPGPRS',
        u'opcode-releaseGPRS',
        u'opcode-eventReportGPRS',
        u'opcode-requestReportGPRSEvent',
        u'opcode-resetTimerGPRS',
        u'opcode-sendChargingInformationGPRS',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'opcode-initialDP',
        u'opcode-assistRequestInstructions',
        u'opcode-establishTemporaryConnection',
        u'opcode-disconnectForwardConnection',
        u'opcode-dFCWithArgument',
        u'opcode-connectToResource',
        u'opcode-connect',
        u'opcode-releaseCall',
        u'opcode-requestReportBCSMEvent',
        u'opcode-eventReportBCSM',
        u'opcode-collectInformation',
        u'opcode-continue',
        u'opcode-initiateCallAttempt',
        u'opcode-resetTimer',
        u'opcode-furnishChargingInformation',
        u'opcode-applyCharging',
        u'opcode-applyChargingReport',
        u'opcode-callGap',
        u'opcode-callInformationReport',
        u'opcode-callInformationRequest',
        u'opcode-sendChargingInformation',
        u'opcode-playAnnouncement',
        u'opcode-promptAndCollectUserInformation',
        u'opcode-specializedResourceReport',
        u'opcode-cancel',
        u'opcode-activityTest',
        u'opcode-continueWithArgument',
        u'opcode-disconnectLeg',
        u'opcode-moveLeg',
        u'opcode-splitLeg',
        u'opcode-entityReleased',
        u'opcode-playTone',
        u'opcode-initialDPSMS',
        u'opcode-furnishChargingInformationSMS',
        u'opcode-connectSMS',
        u'opcode-requestReportSMSEvent',
        u'opcode-eventReportSMS',
        u'opcode-continueSMS',
        u'opcode-releaseSMS',
        u'opcode-resetTimerSMS',
        u'opcode-activityTestGPRS',
        u'opcode-applyChargingGPRS',
        u'opcode-applyChargingReportGPRS',
        u'opcode-cancelGPRS',
        u'opcode-connectGPRS',
        u'opcode-continueGPRS',
        u'opcode-entityReleasedGPRS',
        u'opcode-furnishChargingInformationGPRS',
        u'opcode-initialDPGPRS',
        u'opcode-releaseGPRS',
        u'opcode-eventReportGPRS',
        u'opcode-requestReportGPRSEvent',
        u'opcode-resetTimerGPRS',
        u'opcode-sendChargingInformationGPRS',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< opcode-initialDP >-----#
    opcode_initialDP = CHOICE(name=u'opcode-initialDP', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initialDP._val = (u'local', 0)
    
    #-----< opcode-assistRequestInstructions >-----#
    opcode_assistRequestInstructions = CHOICE(name=u'opcode-assistRequestInstructions', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_assistRequestInstructions._val = (u'local', 16)
    
    #-----< opcode-establishTemporaryConnection >-----#
    opcode_establishTemporaryConnection = CHOICE(name=u'opcode-establishTemporaryConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_establishTemporaryConnection._val = (u'local', 17)
    
    #-----< opcode-disconnectForwardConnection >-----#
    opcode_disconnectForwardConnection = CHOICE(name=u'opcode-disconnectForwardConnection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_disconnectForwardConnection._val = (u'local', 18)
    
    #-----< opcode-dFCWithArgument >-----#
    opcode_dFCWithArgument = CHOICE(name=u'opcode-dFCWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_dFCWithArgument._val = (u'local', 86)
    
    #-----< opcode-connectToResource >-----#
    opcode_connectToResource = CHOICE(name=u'opcode-connectToResource', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connectToResource._val = (u'local', 19)
    
    #-----< opcode-connect >-----#
    opcode_connect = CHOICE(name=u'opcode-connect', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connect._val = (u'local', 20)
    
    #-----< opcode-releaseCall >-----#
    opcode_releaseCall = CHOICE(name=u'opcode-releaseCall', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_releaseCall._val = (u'local', 22)
    
    #-----< opcode-requestReportBCSMEvent >-----#
    opcode_requestReportBCSMEvent = CHOICE(name=u'opcode-requestReportBCSMEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_requestReportBCSMEvent._val = (u'local', 23)
    
    #-----< opcode-eventReportBCSM >-----#
    opcode_eventReportBCSM = CHOICE(name=u'opcode-eventReportBCSM', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_eventReportBCSM._val = (u'local', 24)
    
    #-----< opcode-collectInformation >-----#
    opcode_collectInformation = CHOICE(name=u'opcode-collectInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_collectInformation._val = (u'local', 27)
    
    #-----< opcode-continue >-----#
    opcode_continue = CHOICE(name=u'opcode-continue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continue._val = (u'local', 31)
    
    #-----< opcode-initiateCallAttempt >-----#
    opcode_initiateCallAttempt = CHOICE(name=u'opcode-initiateCallAttempt', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initiateCallAttempt._val = (u'local', 32)
    
    #-----< opcode-resetTimer >-----#
    opcode_resetTimer = CHOICE(name=u'opcode-resetTimer', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_resetTimer._val = (u'local', 33)
    
    #-----< opcode-furnishChargingInformation >-----#
    opcode_furnishChargingInformation = CHOICE(name=u'opcode-furnishChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_furnishChargingInformation._val = (u'local', 34)
    
    #-----< opcode-applyCharging >-----#
    opcode_applyCharging = CHOICE(name=u'opcode-applyCharging', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyCharging._val = (u'local', 35)
    
    #-----< opcode-applyChargingReport >-----#
    opcode_applyChargingReport = CHOICE(name=u'opcode-applyChargingReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyChargingReport._val = (u'local', 36)
    
    #-----< opcode-callGap >-----#
    opcode_callGap = CHOICE(name=u'opcode-callGap', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_callGap._val = (u'local', 41)
    
    #-----< opcode-callInformationReport >-----#
    opcode_callInformationReport = CHOICE(name=u'opcode-callInformationReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_callInformationReport._val = (u'local', 44)
    
    #-----< opcode-callInformationRequest >-----#
    opcode_callInformationRequest = CHOICE(name=u'opcode-callInformationRequest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_callInformationRequest._val = (u'local', 45)
    
    #-----< opcode-sendChargingInformation >-----#
    opcode_sendChargingInformation = CHOICE(name=u'opcode-sendChargingInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_sendChargingInformation._val = (u'local', 46)
    
    #-----< opcode-playAnnouncement >-----#
    opcode_playAnnouncement = CHOICE(name=u'opcode-playAnnouncement', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_playAnnouncement._val = (u'local', 47)
    
    #-----< opcode-promptAndCollectUserInformation >-----#
    opcode_promptAndCollectUserInformation = CHOICE(name=u'opcode-promptAndCollectUserInformation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_promptAndCollectUserInformation._val = (u'local', 48)
    
    #-----< opcode-specializedResourceReport >-----#
    opcode_specializedResourceReport = CHOICE(name=u'opcode-specializedResourceReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_specializedResourceReport._val = (u'local', 49)
    
    #-----< opcode-cancel >-----#
    opcode_cancel = CHOICE(name=u'opcode-cancel', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_cancel._val = (u'local', 53)
    
    #-----< opcode-activityTest >-----#
    opcode_activityTest = CHOICE(name=u'opcode-activityTest', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_activityTest._val = (u'local', 55)
    
    #-----< opcode-continueWithArgument >-----#
    opcode_continueWithArgument = CHOICE(name=u'opcode-continueWithArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continueWithArgument._val = (u'local', 88)
    
    #-----< opcode-disconnectLeg >-----#
    opcode_disconnectLeg = CHOICE(name=u'opcode-disconnectLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_disconnectLeg._val = (u'local', 90)
    
    #-----< opcode-moveLeg >-----#
    opcode_moveLeg = CHOICE(name=u'opcode-moveLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_moveLeg._val = (u'local', 93)
    
    #-----< opcode-splitLeg >-----#
    opcode_splitLeg = CHOICE(name=u'opcode-splitLeg', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_splitLeg._val = (u'local', 95)
    
    #-----< opcode-entityReleased >-----#
    opcode_entityReleased = CHOICE(name=u'opcode-entityReleased', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_entityReleased._val = (u'local', 96)
    
    #-----< opcode-playTone >-----#
    opcode_playTone = CHOICE(name=u'opcode-playTone', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_playTone._val = (u'local', 97)
    
    #-----< opcode-initialDPSMS >-----#
    opcode_initialDPSMS = CHOICE(name=u'opcode-initialDPSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initialDPSMS._val = (u'local', 60)
    
    #-----< opcode-furnishChargingInformationSMS >-----#
    opcode_furnishChargingInformationSMS = CHOICE(name=u'opcode-furnishChargingInformationSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_furnishChargingInformationSMS._val = (u'local', 61)
    
    #-----< opcode-connectSMS >-----#
    opcode_connectSMS = CHOICE(name=u'opcode-connectSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connectSMS._val = (u'local', 62)
    
    #-----< opcode-requestReportSMSEvent >-----#
    opcode_requestReportSMSEvent = CHOICE(name=u'opcode-requestReportSMSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_requestReportSMSEvent._val = (u'local', 63)
    
    #-----< opcode-eventReportSMS >-----#
    opcode_eventReportSMS = CHOICE(name=u'opcode-eventReportSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_eventReportSMS._val = (u'local', 64)
    
    #-----< opcode-continueSMS >-----#
    opcode_continueSMS = CHOICE(name=u'opcode-continueSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continueSMS._val = (u'local', 65)
    
    #-----< opcode-releaseSMS >-----#
    opcode_releaseSMS = CHOICE(name=u'opcode-releaseSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_releaseSMS._val = (u'local', 66)
    
    #-----< opcode-resetTimerSMS >-----#
    opcode_resetTimerSMS = CHOICE(name=u'opcode-resetTimerSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_resetTimerSMS._val = (u'local', 67)
    
    #-----< opcode-activityTestGPRS >-----#
    opcode_activityTestGPRS = CHOICE(name=u'opcode-activityTestGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_activityTestGPRS._val = (u'local', 70)
    
    #-----< opcode-applyChargingGPRS >-----#
    opcode_applyChargingGPRS = CHOICE(name=u'opcode-applyChargingGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyChargingGPRS._val = (u'local', 71)
    
    #-----< opcode-applyChargingReportGPRS >-----#
    opcode_applyChargingReportGPRS = CHOICE(name=u'opcode-applyChargingReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_applyChargingReportGPRS._val = (u'local', 72)
    
    #-----< opcode-cancelGPRS >-----#
    opcode_cancelGPRS = CHOICE(name=u'opcode-cancelGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_cancelGPRS._val = (u'local', 73)
    
    #-----< opcode-connectGPRS >-----#
    opcode_connectGPRS = CHOICE(name=u'opcode-connectGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_connectGPRS._val = (u'local', 74)
    
    #-----< opcode-continueGPRS >-----#
    opcode_continueGPRS = CHOICE(name=u'opcode-continueGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_continueGPRS._val = (u'local', 75)
    
    #-----< opcode-entityReleasedGPRS >-----#
    opcode_entityReleasedGPRS = CHOICE(name=u'opcode-entityReleasedGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_entityReleasedGPRS._val = (u'local', 76)
    
    #-----< opcode-furnishChargingInformationGPRS >-----#
    opcode_furnishChargingInformationGPRS = CHOICE(name=u'opcode-furnishChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_furnishChargingInformationGPRS._val = (u'local', 77)
    
    #-----< opcode-initialDPGPRS >-----#
    opcode_initialDPGPRS = CHOICE(name=u'opcode-initialDPGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_initialDPGPRS._val = (u'local', 78)
    
    #-----< opcode-releaseGPRS >-----#
    opcode_releaseGPRS = CHOICE(name=u'opcode-releaseGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_releaseGPRS._val = (u'local', 79)
    
    #-----< opcode-eventReportGPRS >-----#
    opcode_eventReportGPRS = CHOICE(name=u'opcode-eventReportGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_eventReportGPRS._val = (u'local', 80)
    
    #-----< opcode-requestReportGPRSEvent >-----#
    opcode_requestReportGPRSEvent = CHOICE(name=u'opcode-requestReportGPRSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_requestReportGPRSEvent._val = (u'local', 81)
    
    #-----< opcode-resetTimerGPRS >-----#
    opcode_resetTimerGPRS = CHOICE(name=u'opcode-resetTimerGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_resetTimerGPRS._val = (u'local', 82)
    
    #-----< opcode-sendChargingInformationGPRS >-----#
    opcode_sendChargingInformationGPRS = CHOICE(name=u'opcode-sendChargingInformationGPRS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')))
    opcode_sendChargingInformationGPRS._val = (u'local', 83)
    
    _all_ = [
        opcode_initialDP,
        opcode_assistRequestInstructions,
        opcode_establishTemporaryConnection,
        opcode_disconnectForwardConnection,
        opcode_dFCWithArgument,
        opcode_connectToResource,
        opcode_connect,
        opcode_releaseCall,
        opcode_requestReportBCSMEvent,
        opcode_eventReportBCSM,
        opcode_collectInformation,
        opcode_continue,
        opcode_initiateCallAttempt,
        opcode_resetTimer,
        opcode_furnishChargingInformation,
        opcode_applyCharging,
        opcode_applyChargingReport,
        opcode_callGap,
        opcode_callInformationReport,
        opcode_callInformationRequest,
        opcode_sendChargingInformation,
        opcode_playAnnouncement,
        opcode_promptAndCollectUserInformation,
        opcode_specializedResourceReport,
        opcode_cancel,
        opcode_activityTest,
        opcode_continueWithArgument,
        opcode_disconnectLeg,
        opcode_moveLeg,
        opcode_splitLeg,
        opcode_entityReleased,
        opcode_playTone,
        opcode_initialDPSMS,
        opcode_furnishChargingInformationSMS,
        opcode_connectSMS,
        opcode_requestReportSMSEvent,
        opcode_eventReportSMS,
        opcode_continueSMS,
        opcode_releaseSMS,
        opcode_resetTimerSMS,
        opcode_activityTestGPRS,
        opcode_applyChargingGPRS,
        opcode_applyChargingReportGPRS,
        opcode_cancelGPRS,
        opcode_connectGPRS,
        opcode_continueGPRS,
        opcode_entityReleasedGPRS,
        opcode_furnishChargingInformationGPRS,
        opcode_initialDPGPRS,
        opcode_releaseGPRS,
        opcode_eventReportGPRS,
        opcode_requestReportGPRSEvent,
        opcode_resetTimerGPRS,
        opcode_sendChargingInformationGPRS,
    ]

class CAP_SMS_ops_args:

    _name_  = u'CAP-SMS-ops-args'
    _oid_   = [0, 4, 0, 0, 1, 3, 105, 7]
    
    _obj_ = [
        u'connectSMS',
        u'ConnectSMSArg',
        u'continueSMS',
        u'eventReportSMS',
        u'EventReportSMSArg',
        u'furnishChargingInformationSMS',
        u'FurnishChargingInformationSMSArg',
        u'initialDPSMS',
        u'InitialDPSMSArg',
        u'releaseSMS',
        u'ReleaseSMSArg',
        u'requestReportSMSEvent',
        u'RequestReportSMSEventArg',
        u'resetTimerSMS',
        u'ResetTimerSMSArg',
        ]
    _type_ = [
        u'ConnectSMSArg',
        u'EventReportSMSArg',
        u'FurnishChargingInformationSMSArg',
        u'InitialDPSMSArg',
        u'ReleaseSMSArg',
        u'RequestReportSMSEventArg',
        u'ResetTimerSMSArg',
        ]
    _set_ = [
        ]
    _val_ = [
        u'connectSMS',
        u'continueSMS',
        u'eventReportSMS',
        u'furnishChargingInformationSMS',
        u'initialDPSMS',
        u'releaseSMS',
        u'requestReportSMSEvent',
        u'resetTimerSMS',
        ]
    _class_ = [
        u'connectSMS',
        u'continueSMS',
        u'eventReportSMS',
        u'furnishChargingInformationSMS',
        u'initialDPSMS',
        u'releaseSMS',
        u'requestReportSMSEvent',
        u'resetTimerSMS',
        ]
    _param_ = [
        u'connectSMS',
        u'ConnectSMSArg',
        u'eventReportSMS',
        u'EventReportSMSArg',
        u'furnishChargingInformationSMS',
        u'FurnishChargingInformationSMSArg',
        u'initialDPSMS',
        u'InitialDPSMSArg',
        u'requestReportSMSEvent',
        u'RequestReportSMSEventArg',
        u'resetTimerSMS',
        u'ResetTimerSMSArg',
        ]
    
    #-----< connectSMS >-----#
    connectSMS = CLASS(name=u'connectSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConnectSMSArg >-----#
    ConnectSMSArg = SEQ(name=u'ConnectSMSArg', mode=MODE_TYPE, param=True)
    
    #-----< continueSMS >-----#
    continueSMS = CLASS(name=u'continueSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    continueSMS._val = dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])
    
    #-----< eventReportSMS >-----#
    eventReportSMS = CLASS(name=u'eventReportSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< EventReportSMSArg >-----#
    EventReportSMSArg = SEQ(name=u'EventReportSMSArg', mode=MODE_TYPE, param=True)
    
    #-----< furnishChargingInformationSMS >-----#
    furnishChargingInformationSMS = CLASS(name=u'furnishChargingInformationSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< FurnishChargingInformationSMSArg >-----#
    FurnishChargingInformationSMSArg = OCT_STR(name=u'FurnishChargingInformationSMSArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'FCISMSBillingChargingCharacteristics')), param=True)
    
    #-----< initialDPSMS >-----#
    initialDPSMS = CLASS(name=u'initialDPSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< InitialDPSMSArg >-----#
    InitialDPSMSArg = SEQ(name=u'InitialDPSMSArg', mode=MODE_TYPE, param=True)
    
    #-----< releaseSMS >-----#
    releaseSMS = CLASS(name=u'releaseSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _releaseSMS_val_ArgumentType = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    releaseSMS._val = dict([(u'ArgumentType', _releaseSMS_val_ArgumentType), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])
    
    #-----< ReleaseSMSArg >-----#
    ReleaseSMSArg = OCT_STR(name=u'ReleaseSMSArg', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'RPCause')))
    
    #-----< requestReportSMSEvent >-----#
    requestReportSMSEvent = CLASS(name=u'requestReportSMSEvent', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< RequestReportSMSEventArg >-----#
    RequestReportSMSEventArg = SEQ(name=u'RequestReportSMSEventArg', mode=MODE_TYPE, param=True)
    
    #-----< resetTimerSMS >-----#
    resetTimerSMS = CLASS(name=u'resetTimerSMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ResetTimerSMSArg >-----#
    ResetTimerSMSArg = SEQ(name=u'ResetTimerSMSArg', mode=MODE_TYPE, param=True)
    
    _all_ = [
        continueSMS,
        releaseSMS,
        _releaseSMS_val_ArgumentType,
        ReleaseSMSArg,
    ]

class CAP_smsSSF_gsmSCF_pkgs_contracts_acs:

    _name_  = u'CAP-smsSSF-gsmSCF-pkgs-contracts-acs'
    _oid_   = [0, 4, 0, 0, 1, 3, 106, 7]
    
    _obj_ = [
        u'cap3-sms-AC',
        u'cap4-sms-AC',
        u'cap3SMS',
        u'cap4SMS',
        u'smsActivationPackage',
        u'smsConnectPackage',
        u'smsProcessingPackage',
        u'smsReleasePackage',
        u'smsEventHandlingPackage',
        u'smsBillingPackage',
        u'smsTimerPackage',
        u'sms-AbstractSyntax',
        u'Generic-sms-PDUs',
        u'SmsInvokable',
        u'SmsReturnable',
        ]
    _type_ = [
        u'Generic-sms-PDUs',
        ]
    _set_ = [
        u'SmsInvokable',
        u'SmsReturnable',
        ]
    _val_ = [
        u'cap3-sms-AC',
        u'cap4-sms-AC',
        u'cap3SMS',
        u'cap4SMS',
        u'smsActivationPackage',
        u'smsConnectPackage',
        u'smsProcessingPackage',
        u'smsReleasePackage',
        u'smsEventHandlingPackage',
        u'smsBillingPackage',
        u'smsTimerPackage',
        u'sms-AbstractSyntax',
        ]
    _class_ = [
        u'cap3-sms-AC',
        u'cap4-sms-AC',
        u'cap3SMS',
        u'cap4SMS',
        u'smsActivationPackage',
        u'smsConnectPackage',
        u'smsProcessingPackage',
        u'smsReleasePackage',
        u'smsEventHandlingPackage',
        u'smsBillingPackage',
        u'smsTimerPackage',
        u'sms-AbstractSyntax',
        u'SmsInvokable',
        u'SmsReturnable',
        ]
    _param_ = [
        u'smsActivationPackage',
        u'smsConnectPackage',
        u'smsEventHandlingPackage',
        u'smsBillingPackage',
        u'smsTimerPackage',
        ]
    
    #-----< cap3-sms-AC >-----#
    cap3_sms_AC = CLASS(name=u'cap3-sms-AC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._cont = ASN1Dict([
        (u'serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_serviceKey),
        (u'destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_destinationSubscriberNumber),
        (u'callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callingPartyNumber),
        (u'eventTypeSMS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_eventTypeSMS),
        (u'iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMSI),
        (u'locationInformationMSC', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationMSC),
        (u'locationInformationGPRS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationGPRS),
        (u'sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sMSCAddress),
        (u'timeAndTimezone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPProtocolIdentifier),
        (u'tPDataCodingScheme', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPDataCodingScheme),
        (u'tPValidityPeriod', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPValidityPeriod),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions),
        (u'smsReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_smsReferenceNumber),
        (u'mscAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_mscAddress),
        (u'sgsn-Number', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sgsn_Number),
        (u'ms-Classmark2', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_ms_Classmark2),
        (u'gPRSMSClass', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSMSClass),
        (u'iMEI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMEI),
        (u'calledPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_calledPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'callingPartysNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysNumber),
        (u'destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber),
        (u'sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_sMSCAddress),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._cont = ASN1Dict([
        (u'sMSEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationSMS = CHOICE(name=u'eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._cont = ASN1Dict([
        (u'eventTypeSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeSMS),
        (u'eventSpecificInformationSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationSMS),
        (u'miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo),
        (u'extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3._cont = ASN1Dict([
        (u'timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_timerID),
        (u'timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_timervalue),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3._ext = []
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0._ext = None
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1._ext = None
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-smsSSF-gsmSCF-pkgs-contracts-acs', 'Generic-sms-PDUs')))
    cap3_sms_AC._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 20, 26, 16))])), (u'dialogueMode', u'structured'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 61))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 21, 3, 61))])
    
    #-----< cap4-sms-AC >-----#
    cap4_sms_AC = CLASS(name=u'cap4-sms-AC', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'APPLICATION-CONTEXT')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._cont = ASN1Dict([
        (u'serviceKey', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_serviceKey),
        (u'destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber),
        (u'callingPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_callingPartyNumber),
        (u'eventTypeSMS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_eventTypeSMS),
        (u'iMSI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_iMSI),
        (u'locationInformationMSC', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_locationInformationMSC),
        (u'locationInformationGPRS', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_locationInformationGPRS),
        (u'sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_sMSCAddress),
        (u'timeAndTimezone', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPProtocolIdentifier),
        (u'tPDataCodingScheme', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPDataCodingScheme),
        (u'tPValidityPeriod', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPValidityPeriod),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions),
        (u'smsReferenceNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_smsReferenceNumber),
        (u'mscAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_mscAddress),
        (u'sgsn-Number', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_sgsn_Number),
        (u'ms-Classmark2', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_ms_Classmark2),
        (u'gPRSMSClass', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_gPRSMSClass),
        (u'iMEI', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_iMEI),
        (u'calledPartyNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_calledPartyNumber),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._cont = ASN1Dict([
        (u'callingPartysNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callingPartysNumber),
        (u'destinationSubscriberNumber', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber),
        (u'sMSCAddress', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_sMSCAddress),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7._cont = ASN1Dict([
        (u'sMSEvents', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7._ext = []
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_eventSpecificInformationSMS = CHOICE(name=u'eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions._cont = ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_
    _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'eventTypeSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_eventTypeSMS),
        (u'eventSpecificInformationSMS', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_eventSpecificInformationSMS),
        (u'miscCallInfo', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_miscCallInfo),
        (u'extensions', _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8._cont = ASN1Dict([
        (u'timerID', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_timerID),
        (u'timervalue', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_timervalue),
        (u'extensions', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions),
        ])
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8._ext = []
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    cap4_sms_AC._val = dict([(u'associationContract', dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 16))])), (u'dialogueMode', u'structured'), (u'AbstractSyntaxes', ASN1Set(rv=[dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0), ('id', (0, 0, 17, 773, 1, 1, 1))]), dict([('Type', __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1), ('id', (0, 4, 0, 0, 1, 22, 5, 61))])], rr=[], ev=None, er=[])), (u'applicationContextName', (0, 4, 0, 0, 1, 23, 3, 61))])
    
    #-----< cap3SMS >-----#
    cap3SMS = CLASS(name=u'cap3SMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    cap3SMS._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 20, 26, 16))])
    
    #-----< cap4SMS >-----#
    cap4SMS = CLASS(name=u'cap4SMS', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    cap4SMS._val = dict([(u'InitiatorConsumerOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 61))])], rr=[], ev=None, er=[])), (u'InitiatorSupplierOf', ASN1Set(rv=[dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 62))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 64))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))])], rr=[], ev=None, er=[])), (u'Consumer', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 65))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 67))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 66))]), dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 63))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 26, 16))])
    
    #-----< smsActivationPackage >-----#
    smsActivationPackage = CLASS(name=u'smsActivationPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsConnectPackage >-----#
    smsConnectPackage = CLASS(name=u'smsConnectPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsProcessingPackage >-----#
    smsProcessingPackage = CLASS(name=u'smsProcessingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    smsProcessingPackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 63))])
    
    #-----< smsReleasePackage >-----#
    smsReleasePackage = CLASS(name=u'smsReleasePackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')))
    smsReleasePackage._val = dict([(u'Supplier', ASN1Set(rv=[dict([(u'ArgumentType', ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))])], rr=[], ev=None, er=[])), (u'id', (0, 4, 0, 0, 1, 22, 27, 64))])
    
    #-----< smsEventHandlingPackage >-----#
    smsEventHandlingPackage = CLASS(name=u'smsEventHandlingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsBillingPackage >-----#
    smsBillingPackage = CLASS(name=u'smsBillingPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< smsTimerPackage >-----#
    smsTimerPackage = CLASS(name=u'smsTimerPackage', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< sms-AbstractSyntax >-----#
    sms_AbstractSyntax = CLASS(name=u'sms-AbstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _sms_AbstractSyntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-smsSSF-gsmSCF-pkgs-contracts-acs', 'Generic-sms-PDUs')))
    sms_AbstractSyntax._val = dict([('Type', _sms_AbstractSyntax_val_Type), ('id', (0, 4, 0, 0, 1, 22, 5, 61))])
    
    #-----< Generic-sms-PDUs >-----#
    Generic_sms_PDUs = CHOICE(name=u'Generic-sms-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')))
    _Generic_sms_PDUs_unidirectional = SEQ(name=u'unidirectional', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Unidirectional')))
    __Generic_sms_PDUs_unidirectional_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_unidirectional_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')))
    ___Generic_sms_PDUs_unidirectional_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_unidirectional_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0._cont = ASN1Dict([
        (u'callingPartysNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_callingPartysNumber),
        (u'destinationSubscriberNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber),
        (u'sMSCAddress', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_sMSCAddress),
        (u'extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventSpecificInformationSMS = CHOICE(name=u'eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'eventTypeSMS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventTypeSMS),
        (u'eventSpecificInformationSMS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventSpecificInformationSMS),
        (u'miscCallInfo', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_miscCallInfo),
        (u'extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'serviceKey', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceKey),
        (u'destinationSubscriberNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber),
        (u'callingPartyNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callingPartyNumber),
        (u'eventTypeSMS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_eventTypeSMS),
        (u'iMSI', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMSI),
        (u'locationInformationMSC', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationMSC),
        (u'locationInformationGPRS', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationGPRS),
        (u'sMSCAddress', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sMSCAddress),
        (u'timeAndTimezone', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier),
        (u'tPDataCodingScheme', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPDataCodingScheme),
        (u'tPValidityPeriod', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPValidityPeriod),
        (u'extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions),
        (u'smsReferenceNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_smsReferenceNumber),
        (u'mscAddress', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_mscAddress),
        (u'sgsn-Number', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sgsn_Number),
        (u'ms-Classmark2', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_ms_Classmark2),
        (u'gPRSMSClass', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_gPRSMSClass),
        (u'iMEI', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMEI),
        (u'calledPartyNumber', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_calledPartyNumber),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'sMSEvents', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents),
        (u'extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._cont = __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'timerID', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timerID),
        (u'timervalue', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timervalue),
        (u'extensions', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions),
        ])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5._ext = []
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))]), dict([(u'ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))]), dict([(u'ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))]), dict([(u'ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))]), dict([(u'ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))]), dict([(u'ArgumentType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode),
        (u'argument', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0._cont = ASN1Dict([
        (u'callingPartysNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_callingPartysNumber),
        (u'destinationSubscriberNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber),
        (u'sMSCAddress', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_sMSCAddress),
        (u'extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0._ext = []
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'serviceKey', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceKey),
        (u'destinationSubscriberNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber),
        (u'callingPartyNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callingPartyNumber),
        (u'eventTypeSMS', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_eventTypeSMS),
        (u'iMSI', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMSI),
        (u'locationInformationMSC', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationMSC),
        (u'locationInformationGPRS', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationGPRS),
        (u'sMSCAddress', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sMSCAddress),
        (u'timeAndTimezone', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier),
        (u'tPDataCodingScheme', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPDataCodingScheme),
        (u'tPValidityPeriod', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPValidityPeriod),
        (u'extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions),
        (u'smsReferenceNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_smsReferenceNumber),
        (u'mscAddress', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_mscAddress),
        (u'sgsn-Number', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sgsn_Number),
        (u'ms-Classmark2', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_ms_Classmark2),
        (u'gPRSMSClass', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gPRSMSClass),
        (u'iMEI', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMEI),
        (u'calledPartyNumber', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_calledPartyNumber),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'sMSEvents', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents),
        (u'extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5._ext = []
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._cont = ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_
    __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'timerID', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timerID),
        (u'timervalue', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timervalue),
        (u'extensions', __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions),
        ])
    _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6._ext = []
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))]), dict([(u'ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))]), dict([(u'ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))]), dict([(u'ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))]), dict([(u'ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))]), dict([(u'ArgumentType', _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId),
        (u'result', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'UnavailableNetworkResource')))
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3 = ENUM(name=u'ParameterType', mode=MODE_TYPE)
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._cont = ASN1Dict([(u'generic', 0), (u'unobtainable', 1), (u'congestion', 2)])
    ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3._ext = None
    _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))]), dict([(u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode),
        (u'parameter', ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_unidirectional_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_unidirectional_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke),
        (u'returnResult', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult),
        (u'returnError', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError),
        (u'reject', _____Generic_sms_PDUs_unidirectional_components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_unidirectional_components__item__basicROS._ext = None
    ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode),
        (u'result', ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_invokeId),
        (u'result', _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_unidirectional_components__item_._cont = ASN1Dict([
        (u'basicROS', ____Generic_sms_PDUs_unidirectional_components__item__basicROS),
        (u'returnResultNotLast', ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_unidirectional_components__item_._ext = None
    __Generic_sms_PDUs_unidirectional_components._cont = ___Generic_sms_PDUs_unidirectional_components__item_
    __Generic_sms_PDUs_unidirectional_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_unidirectional._cont = ASN1Dict([
        (u'dialoguePortion', __Generic_sms_PDUs_unidirectional_dialoguePortion),
        (u'components', __Generic_sms_PDUs_unidirectional_components),
        ])
    _Generic_sms_PDUs_unidirectional._ext = None
    _Generic_sms_PDUs_begin = SEQ(name=u'begin', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Begin')))
    __Generic_sms_PDUs_begin_otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __Generic_sms_PDUs_begin_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_begin_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___Generic_sms_PDUs_begin_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_begin_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_begin_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____Generic_sms_PDUs_begin_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode),
        (u'argument', ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_begin_components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_invokeId),
        (u'result', ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode),
        (u'parameter', ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_begin_components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_begin_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_begin_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____Generic_sms_PDUs_begin_components__item__basicROS_invoke),
        (u'returnResult', _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult),
        (u'returnError', _____Generic_sms_PDUs_begin_components__item__basicROS_returnError),
        (u'reject', _____Generic_sms_PDUs_begin_components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_begin_components__item__basicROS._ext = None
    ____Generic_sms_PDUs_begin_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode),
        (u'result', ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_begin_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_invokeId),
        (u'result', _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_begin_components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_begin_components__item_._cont = ASN1Dict([
        (u'basicROS', ____Generic_sms_PDUs_begin_components__item__basicROS),
        (u'returnResultNotLast', ____Generic_sms_PDUs_begin_components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_begin_components__item_._ext = None
    __Generic_sms_PDUs_begin_components._cont = ___Generic_sms_PDUs_begin_components__item_
    __Generic_sms_PDUs_begin_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_begin._cont = ASN1Dict([
        (u'otid', __Generic_sms_PDUs_begin_otid),
        (u'dialoguePortion', __Generic_sms_PDUs_begin_dialoguePortion),
        (u'components', __Generic_sms_PDUs_begin_components),
        ])
    _Generic_sms_PDUs_begin._ext = None
    _Generic_sms_PDUs_end = SEQ(name=u'end', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'End')))
    __Generic_sms_PDUs_end_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __Generic_sms_PDUs_end_dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_end_components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___Generic_sms_PDUs_end_components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_end_components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_end_components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____Generic_sms_PDUs_end_components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId),
        (u'opcode', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode),
        (u'argument', ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_end_components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode),
        (u'result', _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_invokeId),
        (u'result', ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_end_components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____Generic_sms_PDUs_end_components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_end_components__item__basicROS_returnError_invokeId),
        (u'errcode', ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode),
        (u'parameter', ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_end_components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_end_components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_end_components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____Generic_sms_PDUs_end_components__item__basicROS_invoke),
        (u'returnResult', _____Generic_sms_PDUs_end_components__item__basicROS_returnResult),
        (u'returnError', _____Generic_sms_PDUs_end_components__item__basicROS_returnError),
        (u'reject', _____Generic_sms_PDUs_end_components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_end_components__item__basicROS._ext = None
    ____Generic_sms_PDUs_end_components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode),
        (u'result', ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_end_components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____Generic_sms_PDUs_end_components__item__returnResultNotLast_invokeId),
        (u'result', _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_end_components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_end_components__item_._cont = ASN1Dict([
        (u'basicROS', ____Generic_sms_PDUs_end_components__item__basicROS),
        (u'returnResultNotLast', ____Generic_sms_PDUs_end_components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_end_components__item_._ext = None
    __Generic_sms_PDUs_end_components._cont = ___Generic_sms_PDUs_end_components__item_
    __Generic_sms_PDUs_end_components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_end._cont = ASN1Dict([
        (u'dtid', __Generic_sms_PDUs_end_dtid),
        (u'dialoguePortion', __Generic_sms_PDUs_end_dialoguePortion),
        (u'components', __Generic_sms_PDUs_end_components),
        ])
    _Generic_sms_PDUs_end._ext = None
    _Generic_sms_PDUs_continue_ = SEQ(name=u'continue', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Continue')))
    __Generic_sms_PDUs_continue__otid = OCT_STR(name=u'otid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'OrigTransactionID')))
    __Generic_sms_PDUs_continue__dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    __Generic_sms_PDUs_continue__dialoguePortion = EXT(name=u'dialoguePortion', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')), opt=True)
    __Generic_sms_PDUs_continue__components = SEQ_OF(name=u'components', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'ComponentPortion')), opt=True)
    ___Generic_sms_PDUs_continue__components__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'Component')))
    ____Generic_sms_PDUs_continue__components__item__basicROS = CHOICE(name=u'basicROS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _____Generic_sms_PDUs_continue__components__item__basicROS_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId._const_val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId._cont = ASN1Dict([
        (u'present', _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_present),
        (u'absent', _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_absent),
        ])
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId._ext = None
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_at = None
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument._const_tab_id = u'ArgumentType'
    _____Generic_sms_PDUs_continue__components__item__basicROS_invoke._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId),
        (u'linkedId', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId),
        (u'opcode', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode),
        (u'argument', ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument),
        ])
    _____Generic_sms_PDUs_continue__components__item__basicROS_invoke._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_at = None
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode._const_tab_id = u'operationCode'
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_at = ('..', u'opcode')
    _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result._const_tab_id = u'ResultType'
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result._cont = ASN1Dict([
        (u'opcode', _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode),
        (u'result', _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result),
        ])
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_invokeId),
        (u'result', ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result),
        ])
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_at = None
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode._const_tab_id = u'errorCode'
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab = _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_at = ('..', u'errcode')
    ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter._const_tab_id = u'ParameterType'
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnError._cont = ASN1Dict([
        (u'invokeId', ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_invokeId),
        (u'errcode', ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode),
        (u'parameter', ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter),
        ])
    _____Generic_sms_PDUs_continue__components__item__basicROS_returnError._ext = None
    _____Generic_sms_PDUs_continue__components__item__basicROS_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ____Generic_sms_PDUs_continue__components__item__basicROS._cont = ASN1Dict([
        (u'invoke', _____Generic_sms_PDUs_continue__components__item__basicROS_invoke),
        (u'returnResult', _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult),
        (u'returnError', _____Generic_sms_PDUs_continue__components__item__basicROS_returnError),
        (u'reject', _____Generic_sms_PDUs_continue__components__item__basicROS_reject),
        ])
    ____Generic_sms_PDUs_continue__components__item__basicROS._ext = None
    ____Generic_sms_PDUs_continue__components__item__returnResultNotLast = SEQ(name=u'returnResultNotLast', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'ROS'), [u'returnResult']))
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_at = None
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode._const_tab_id = u'operationCode'
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab = ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_at = ('..', u'opcode')
    ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result._const_tab_id = u'ResultType'
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result._cont = ASN1Dict([
        (u'opcode', ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode),
        (u'result', ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result),
        ])
    _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result._ext = None
    ____Generic_sms_PDUs_continue__components__item__returnResultNotLast._cont = ASN1Dict([
        (u'invokeId', _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_invokeId),
        (u'result', _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result),
        ])
    ____Generic_sms_PDUs_continue__components__item__returnResultNotLast._ext = None
    ___Generic_sms_PDUs_continue__components__item_._cont = ASN1Dict([
        (u'basicROS', ____Generic_sms_PDUs_continue__components__item__basicROS),
        (u'returnResultNotLast', ____Generic_sms_PDUs_continue__components__item__returnResultNotLast),
        ])
    ___Generic_sms_PDUs_continue__components__item_._ext = None
    __Generic_sms_PDUs_continue__components._cont = ___Generic_sms_PDUs_continue__components__item_
    __Generic_sms_PDUs_continue__components._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Generic_sms_PDUs_continue_._cont = ASN1Dict([
        (u'otid', __Generic_sms_PDUs_continue__otid),
        (u'dtid', __Generic_sms_PDUs_continue__dtid),
        (u'dialoguePortion', __Generic_sms_PDUs_continue__dialoguePortion),
        (u'components', __Generic_sms_PDUs_continue__components),
        ])
    _Generic_sms_PDUs_continue_._ext = None
    _Generic_sms_PDUs_abort = SEQ(name=u'abort', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('TCAPMessages', 'Abort')))
    Generic_sms_PDUs._cont = ASN1Dict([
        (u'unidirectional', _Generic_sms_PDUs_unidirectional),
        (u'begin', _Generic_sms_PDUs_begin),
        (u'end', _Generic_sms_PDUs_end),
        (u'continue', _Generic_sms_PDUs_continue_),
        (u'abort', _Generic_sms_PDUs_abort),
        ])
    Generic_sms_PDUs._ext = None
    
    #-----< SmsInvokable >-----#
    SmsInvokable = CLASS(name=u'SmsInvokable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SmsInvokable_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    __SmsInvokable_val_ArgumentType_0_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_0_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_0_extensions._cont = ___SmsInvokable_val_ArgumentType_0_extensions__item_
    __SmsInvokable_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_0._cont = ASN1Dict([
        (u'callingPartysNumber', __SmsInvokable_val_ArgumentType_0_callingPartysNumber),
        (u'destinationSubscriberNumber', __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber),
        (u'sMSCAddress', __SmsInvokable_val_ArgumentType_0_sMSCAddress),
        (u'extensions', __SmsInvokable_val_ArgumentType_0_extensions),
        ])
    _SmsInvokable_val_ArgumentType_0._ext = []
    _SmsInvokable_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'EventReportSMSArg')))
    __SmsInvokable_val_ArgumentType_1_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')))
    __SmsInvokable_val_ArgumentType_1_eventSpecificInformationSMS = CHOICE(name=u'eventSpecificInformationSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventSpecificInformationSMS')), opt=True)
    __SmsInvokable_val_ArgumentType_1_miscCallInfo = SEQ(name=u'miscCallInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS2-datatypes', 'MiscCallInfo')), default=dict([(u'messageType', u'request')]))
    __SmsInvokable_val_ArgumentType_1_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_1_extensions._cont = ___SmsInvokable_val_ArgumentType_1_extensions__item_
    __SmsInvokable_val_ArgumentType_1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_1._cont = ASN1Dict([
        (u'eventTypeSMS', __SmsInvokable_val_ArgumentType_1_eventTypeSMS),
        (u'eventSpecificInformationSMS', __SmsInvokable_val_ArgumentType_1_eventSpecificInformationSMS),
        (u'miscCallInfo', __SmsInvokable_val_ArgumentType_1_miscCallInfo),
        (u'extensions', __SmsInvokable_val_ArgumentType_1_extensions),
        ])
    _SmsInvokable_val_ArgumentType_1._ext = []
    _SmsInvokable_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    _SmsInvokable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    __SmsInvokable_val_ArgumentType_3_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_3_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    __SmsInvokable_val_ArgumentType_3_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SmsInvokable_val_ArgumentType_3_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SmsInvokable_val_ArgumentType_3_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __SmsInvokable_val_ArgumentType_3_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SmsInvokable_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    __SmsInvokable_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    __SmsInvokable_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    __SmsInvokable_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    __SmsInvokable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_3_extensions._cont = ___SmsInvokable_val_ArgumentType_3_extensions__item_
    __SmsInvokable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SmsInvokable_val_ArgumentType_3_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsInvokable_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __SmsInvokable_val_ArgumentType_3_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __SmsInvokable_val_ArgumentType_3_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __SmsInvokable_val_ArgumentType_3_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SmsInvokable_val_ArgumentType_3._cont = ASN1Dict([
        (u'serviceKey', __SmsInvokable_val_ArgumentType_3_serviceKey),
        (u'destinationSubscriberNumber', __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber),
        (u'callingPartyNumber', __SmsInvokable_val_ArgumentType_3_callingPartyNumber),
        (u'eventTypeSMS', __SmsInvokable_val_ArgumentType_3_eventTypeSMS),
        (u'iMSI', __SmsInvokable_val_ArgumentType_3_iMSI),
        (u'locationInformationMSC', __SmsInvokable_val_ArgumentType_3_locationInformationMSC),
        (u'locationInformationGPRS', __SmsInvokable_val_ArgumentType_3_locationInformationGPRS),
        (u'sMSCAddress', __SmsInvokable_val_ArgumentType_3_sMSCAddress),
        (u'timeAndTimezone', __SmsInvokable_val_ArgumentType_3_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', __SmsInvokable_val_ArgumentType_3_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', __SmsInvokable_val_ArgumentType_3_tPProtocolIdentifier),
        (u'tPDataCodingScheme', __SmsInvokable_val_ArgumentType_3_tPDataCodingScheme),
        (u'tPValidityPeriod', __SmsInvokable_val_ArgumentType_3_tPValidityPeriod),
        (u'extensions', __SmsInvokable_val_ArgumentType_3_extensions),
        (u'smsReferenceNumber', __SmsInvokable_val_ArgumentType_3_smsReferenceNumber),
        (u'mscAddress', __SmsInvokable_val_ArgumentType_3_mscAddress),
        (u'sgsn-Number', __SmsInvokable_val_ArgumentType_3_sgsn_Number),
        (u'ms-Classmark2', __SmsInvokable_val_ArgumentType_3_ms_Classmark2),
        (u'gPRSMSClass', __SmsInvokable_val_ArgumentType_3_gPRSMSClass),
        (u'iMEI', __SmsInvokable_val_ArgumentType_3_iMEI),
        (u'calledPartyNumber', __SmsInvokable_val_ArgumentType_3_calledPartyNumber),
        ])
    _SmsInvokable_val_ArgumentType_3._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    _SmsInvokable_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    __SmsInvokable_val_ArgumentType_4_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SmsInvokable_val_ArgumentType_4_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    __SmsInvokable_val_ArgumentType_4_sMSEvents._cont = ___SmsInvokable_val_ArgumentType_4_sMSEvents__item_
    __SmsInvokable_val_ArgumentType_4_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsInvokable_val_ArgumentType_4_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_4_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_4_extensions._cont = ___SmsInvokable_val_ArgumentType_4_extensions__item_
    __SmsInvokable_val_ArgumentType_4_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_4._cont = ASN1Dict([
        (u'sMSEvents', __SmsInvokable_val_ArgumentType_4_sMSEvents),
        (u'extensions', __SmsInvokable_val_ArgumentType_4_extensions),
        ])
    _SmsInvokable_val_ArgumentType_4._ext = []
    _SmsInvokable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    __SmsInvokable_val_ArgumentType_5_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __SmsInvokable_val_ArgumentType_5_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SmsInvokable_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsInvokable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsInvokable_val_ArgumentType_5_extensions._cont = ___SmsInvokable_val_ArgumentType_5_extensions__item_
    __SmsInvokable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsInvokable_val_ArgumentType_5._cont = ASN1Dict([
        (u'timerID', __SmsInvokable_val_ArgumentType_5_timerID),
        (u'timervalue', __SmsInvokable_val_ArgumentType_5_timervalue),
        (u'extensions', __SmsInvokable_val_ArgumentType_5_extensions),
        ])
    _SmsInvokable_val_ArgumentType_5._ext = []
    SmsInvokable._val = ASN1Set(rv=[dict([(u'ArgumentType', _SmsInvokable_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))]), dict([(u'ArgumentType', _SmsInvokable_val_ArgumentType_1), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 64))]), dict([(u'ArgumentType', _SmsInvokable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))]), dict([(u'ArgumentType', _SmsInvokable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))]), dict([(u'ArgumentType', _SmsInvokable_val_ArgumentType_4), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))]), dict([(u'ArgumentType', _SmsInvokable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])
    
    #-----< SmsReturnable >-----#
    SmsReturnable = CLASS(name=u'SmsReturnable', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _SmsReturnable_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ConnectSMSArg')))
    __SmsReturnable_val_ArgumentType_0_callingPartysNumber = OCT_STR(name=u'callingPartysNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_0_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_0_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_0_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_0_extensions._cont = ___SmsReturnable_val_ArgumentType_0_extensions__item_
    __SmsReturnable_val_ArgumentType_0_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_0._cont = ASN1Dict([
        (u'callingPartysNumber', __SmsReturnable_val_ArgumentType_0_callingPartysNumber),
        (u'destinationSubscriberNumber', __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber),
        (u'sMSCAddress', __SmsReturnable_val_ArgumentType_0_sMSCAddress),
        (u'extensions', __SmsReturnable_val_ArgumentType_0_extensions),
        ])
    _SmsReturnable_val_ArgumentType_0._ext = []
    _SmsReturnable_val_ArgumentType_2 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'FurnishChargingInformationSMSArg')))
    _SmsReturnable_val_ArgumentType_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=225)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'InitialDPSMSArg')))
    __SmsReturnable_val_ArgumentType_3_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'ServiceKey')))
    __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'CalledPartyBCDNumber')), opt=True)
    __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=41)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_3_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'SMS-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_eventTypeSMS = ENUM(name=u'eventTypeSMS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'EventTypeSMS')), opt=True)
    __SmsReturnable_val_ArgumentType_3_iMSI = OCT_STR(name=u'iMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    __SmsReturnable_val_ArgumentType_3_locationInformationMSC = SEQ(name=u'locationInformationMSC', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    __SmsReturnable_val_ArgumentType_3_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'LocationInformationGPRS')), opt=True)
    __SmsReturnable_val_ArgumentType_3_sMSCAddress = OCT_STR(name=u'sMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_timeAndTimezone = OCT_STR(name=u'timeAndTimezone', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimeAndTimezone')), opt=True)
    __SmsReturnable_val_ArgumentType_3_timeAndTimezone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=8)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_3_tPShortMessageSpecificInfo = OCT_STR(name=u'tPShortMessageSpecificInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPShortMessageSpecificInfo')), opt=True)
    __SmsReturnable_val_ArgumentType_3_tPProtocolIdentifier = OCT_STR(name=u'tPProtocolIdentifier', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPProtocolIdentifier')), opt=True)
    __SmsReturnable_val_ArgumentType_3_tPDataCodingScheme = OCT_STR(name=u'tPDataCodingScheme', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPDataCodingScheme')), opt=True)
    __SmsReturnable_val_ArgumentType_3_tPValidityPeriod = OCT_STR(name=u'tPValidityPeriod', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TPValidityPeriod')), opt=True)
    __SmsReturnable_val_ArgumentType_3_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_3_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_3_extensions._cont = ___SmsReturnable_val_ArgumentType_3_extensions__item_
    __SmsReturnable_val_ArgumentType_3_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_3_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    __SmsReturnable_val_ArgumentType_3_mscAddress = OCT_STR(name=u'mscAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    __SmsReturnable_val_ArgumentType_3_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    __SmsReturnable_val_ArgumentType_3_gPRSMSClass = SEQ(name=u'gPRSMSClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    __SmsReturnable_val_ArgumentType_3_iMEI = OCT_STR(name=u'iMEI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    __SmsReturnable_val_ArgumentType_3_calledPartyNumber = OCT_STR(name=u'calledPartyNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SmsReturnable_val_ArgumentType_3._cont = ASN1Dict([
        (u'serviceKey', __SmsReturnable_val_ArgumentType_3_serviceKey),
        (u'destinationSubscriberNumber', __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber),
        (u'callingPartyNumber', __SmsReturnable_val_ArgumentType_3_callingPartyNumber),
        (u'eventTypeSMS', __SmsReturnable_val_ArgumentType_3_eventTypeSMS),
        (u'iMSI', __SmsReturnable_val_ArgumentType_3_iMSI),
        (u'locationInformationMSC', __SmsReturnable_val_ArgumentType_3_locationInformationMSC),
        (u'locationInformationGPRS', __SmsReturnable_val_ArgumentType_3_locationInformationGPRS),
        (u'sMSCAddress', __SmsReturnable_val_ArgumentType_3_sMSCAddress),
        (u'timeAndTimezone', __SmsReturnable_val_ArgumentType_3_timeAndTimezone),
        (u'tPShortMessageSpecificInfo', __SmsReturnable_val_ArgumentType_3_tPShortMessageSpecificInfo),
        (u'tPProtocolIdentifier', __SmsReturnable_val_ArgumentType_3_tPProtocolIdentifier),
        (u'tPDataCodingScheme', __SmsReturnable_val_ArgumentType_3_tPDataCodingScheme),
        (u'tPValidityPeriod', __SmsReturnable_val_ArgumentType_3_tPValidityPeriod),
        (u'extensions', __SmsReturnable_val_ArgumentType_3_extensions),
        (u'smsReferenceNumber', __SmsReturnable_val_ArgumentType_3_smsReferenceNumber),
        (u'mscAddress', __SmsReturnable_val_ArgumentType_3_mscAddress),
        (u'sgsn-Number', __SmsReturnable_val_ArgumentType_3_sgsn_Number),
        (u'ms-Classmark2', __SmsReturnable_val_ArgumentType_3_ms_Classmark2),
        (u'gPRSMSClass', __SmsReturnable_val_ArgumentType_3_gPRSMSClass),
        (u'iMEI', __SmsReturnable_val_ArgumentType_3_iMEI),
        (u'calledPartyNumber', __SmsReturnable_val_ArgumentType_3_calledPartyNumber),
        ])
    _SmsReturnable_val_ArgumentType_3._ext = [u'smsReferenceNumber', u'mscAddress', u'sgsn-Number', u'ms-Classmark2', u'gPRSMSClass', u'iMEI', u'calledPartyNumber']
    _SmsReturnable_val_ArgumentType_4 = OCT_STR(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ReleaseSMSArg')))
    _SmsReturnable_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'RequestReportSMSEventArg')))
    __SmsReturnable_val_ArgumentType_5_sMSEvents = SEQ_OF(name=u'sMSEvents', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SmsReturnable_val_ArgumentType_5_sMSEvents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'SMSEvent')))
    __SmsReturnable_val_ArgumentType_5_sMSEvents._cont = ___SmsReturnable_val_ArgumentType_5_sMSEvents__item_
    __SmsReturnable_val_ArgumentType_5_sMSEvents._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    __SmsReturnable_val_ArgumentType_5_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_5_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_5_extensions._cont = ___SmsReturnable_val_ArgumentType_5_extensions__item_
    __SmsReturnable_val_ArgumentType_5_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_5._cont = ASN1Dict([
        (u'sMSEvents', __SmsReturnable_val_ArgumentType_5_sMSEvents),
        (u'extensions', __SmsReturnable_val_ArgumentType_5_extensions),
        ])
    _SmsReturnable_val_ArgumentType_5._ext = []
    _SmsReturnable_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-SMS-ops-args', 'ResetTimerSMSArg')))
    __SmsReturnable_val_ArgumentType_6_timerID = ENUM(name=u'timerID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerID')), default=u'tssf')
    __SmsReturnable_val_ArgumentType_6_timervalue = INT(name=u'timervalue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'TimerValue')))
    __SmsReturnable_val_ArgumentType_6_extensions = SEQ_OF(name=u'extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'Extensions')), opt=True)
    ___SmsReturnable_val_ArgumentType_6_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'ExtensionField')))
    __SmsReturnable_val_ArgumentType_6_extensions._cont = ___SmsReturnable_val_ArgumentType_6_extensions__item_
    __SmsReturnable_val_ArgumentType_6_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    _SmsReturnable_val_ArgumentType_6._cont = ASN1Dict([
        (u'timerID', __SmsReturnable_val_ArgumentType_6_timerID),
        (u'timervalue', __SmsReturnable_val_ArgumentType_6_timervalue),
        (u'extensions', __SmsReturnable_val_ArgumentType_6_extensions),
        ])
    _SmsReturnable_val_ArgumentType_6._ext = []
    SmsReturnable._val = ASN1Set(rv=[dict([(u'ArgumentType', _SmsReturnable_val_ArgumentType_0), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 62))]), dict([(u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 65))]), dict([(u'ArgumentType', _SmsReturnable_val_ArgumentType_2), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 61))]), dict([(u'ArgumentType', _SmsReturnable_val_ArgumentType_3), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 6))]), dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 60))]), dict([(u'ArgumentType', _SmsReturnable_val_ArgumentType_4), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 66))]), dict([(u'ArgumentType', _SmsReturnable_val_ArgumentType_5), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 63))]), dict([(u'ArgumentType', _SmsReturnable_val_ArgumentType_6), (u'returnResult', False), (u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', 7))]), dict([(u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 12))]), dict([(u'errorCode', (u'local', 14))]), dict([(u'errorCode', (u'local', 15))]), dict([(u'errorCode', (u'local', 16))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 67))])], rr=[], ev=None, er=[])
    
    _all_ = [
        cap3_sms_AC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationMSC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_locationInformationGPRS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sMSCAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_timeAndTimezone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPShortMessageSpecificInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPProtocolIdentifier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPDataCodingScheme,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_tPValidityPeriod,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_smsReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_mscAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_sgsn_Number,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_ms_Classmark2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_gPRSMSClass,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_iMEI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_calledPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_callingPartysNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_sMSCAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_1,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_sMSEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_2,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_eventSpecificInformationSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_0,
        __cap_gprssf_scfAC_AbstractSyntaxes_val_Type_1,
        cap4_sms_AC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_serviceKey,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_callingPartyNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_iMSI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_locationInformationMSC,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_locationInformationGPRS,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_sMSCAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_timeAndTimezone,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPShortMessageSpecificInfo,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPProtocolIdentifier,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPDataCodingScheme,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_tPValidityPeriod,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_extensions,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_smsReferenceNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_mscAddress,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_sgsn_Number,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_ms_Classmark2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_gPRSMSClass,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_iMEI,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5_calledPartyNumber,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_callingPartysNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_destinationSubscriberNumber,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_sMSCAddress,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_6,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_sMSEvents,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_7,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_eventTypeSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_eventSpecificInformationSMS,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_miscCallInfo,
        ______gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions__item_,
        _____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0_extensions,
        ____gsmSSF_Initiates_InitiatorSupplierOf_Consumer_val_ArgumentType_0_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_timerID,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_timervalue,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8_extensions,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_8,
        ____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_val_ArgumentType_0_9,
        cap3SMS,
        cap4SMS,
        smsProcessingPackage,
        smsReleasePackage,
        sms_AbstractSyntax,
        _sms_AbstractSyntax_val_Type,
        __Generic_sms_PDUs_unidirectional_dialoguePortion,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_linkedId,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_callingPartysNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_sMSCAddress,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_0,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventTypeSMS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_eventSpecificInformationSMS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_miscCallInfo,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_1,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_2,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_serviceKey,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_callingPartyNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_eventTypeSMS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMSI,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationMSC,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_locationInformationGPRS,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sMSCAddress,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_timeAndTimezone,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPDataCodingScheme,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_tPValidityPeriod,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_smsReferenceNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_mscAddress,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_sgsn_Number,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_ms_Classmark2,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_gPRSMSClass,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_iMEI,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3_calledPartyNumber,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_3,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_sMSEvents,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_4,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timerID,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_timervalue,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions__item_,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5_extensions,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode_tab_val_ArgumentType_5,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_invoke,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_invokeId,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_callingPartysNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_destinationSubscriberNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_sMSCAddress,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_0,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_2,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_serviceKey,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_destinationSubscriberNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_callingPartyNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_eventTypeSMS,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMSI,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationMSC,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_locationInformationGPRS,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sMSCAddress,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_timeAndTimezone,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPShortMessageSpecificInfo,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPProtocolIdentifier,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPDataCodingScheme,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_tPValidityPeriod,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_extensions,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_smsReferenceNumber,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_mscAddress,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_sgsn_Number,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_ms_Classmark2,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_gPRSMSClass,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_iMEI,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3_calledPartyNumber,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_3,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_4,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_sMSEvents,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_5,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timerID,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_timervalue,
        ___________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions__item_,
        __________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6_extensions,
        _________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode_tab_val_ArgumentType_6,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_invokeId,
        _______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_2,
        ________Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode_tab_val_ParameterType_3,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_returnError,
        _____Generic_sms_PDUs_unidirectional_components__item__basicROS_reject,
        ____Generic_sms_PDUs_unidirectional_components__item__basicROS,
        _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_unidirectional_components__item__returnResultNotLast,
        ___Generic_sms_PDUs_unidirectional_components__item_,
        __Generic_sms_PDUs_unidirectional_components,
        _Generic_sms_PDUs_unidirectional,
        __Generic_sms_PDUs_begin_otid,
        __Generic_sms_PDUs_begin_dialoguePortion,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_linkedId,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_begin_components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_begin_components__item__basicROS_invoke,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_invokeId,
        _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_begin_components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_invokeId,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_begin_components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_begin_components__item__basicROS_returnError,
        _____Generic_sms_PDUs_begin_components__item__basicROS_reject,
        ____Generic_sms_PDUs_begin_components__item__basicROS,
        _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_begin_components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_begin_components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_begin_components__item__returnResultNotLast,
        ___Generic_sms_PDUs_begin_components__item_,
        __Generic_sms_PDUs_begin_components,
        _Generic_sms_PDUs_begin,
        __Generic_sms_PDUs_end_dtid,
        __Generic_sms_PDUs_end_dialoguePortion,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_linkedId,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_end_components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_end_components__item__basicROS_invoke,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_invokeId,
        _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_end_components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnError_invokeId,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_end_components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_end_components__item__basicROS_returnError,
        _____Generic_sms_PDUs_end_components__item__basicROS_reject,
        ____Generic_sms_PDUs_end_components__item__basicROS,
        _____Generic_sms_PDUs_end_components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_end_components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_end_components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_end_components__item__returnResultNotLast,
        ___Generic_sms_PDUs_end_components__item_,
        __Generic_sms_PDUs_end_components,
        _Generic_sms_PDUs_end,
        __Generic_sms_PDUs_continue__otid,
        __Generic_sms_PDUs_continue__dtid,
        __Generic_sms_PDUs_continue__dialoguePortion,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_invokeId,
        _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_present,
        _______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId_absent,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_linkedId,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_opcode,
        ______Generic_sms_PDUs_continue__components__item__basicROS_invoke_argument,
        _____Generic_sms_PDUs_continue__components__item__basicROS_invoke,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_invokeId,
        _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_opcode,
        _______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result_result,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnResult_result,
        _____Generic_sms_PDUs_continue__components__item__basicROS_returnResult,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_invokeId,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_errcode,
        ______Generic_sms_PDUs_continue__components__item__basicROS_returnError_parameter,
        _____Generic_sms_PDUs_continue__components__item__basicROS_returnError,
        _____Generic_sms_PDUs_continue__components__item__basicROS_reject,
        ____Generic_sms_PDUs_continue__components__item__basicROS,
        _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_invokeId,
        ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_opcode,
        ______Generic_sms_PDUs_continue__components__item__returnResultNotLast_result_result,
        _____Generic_sms_PDUs_continue__components__item__returnResultNotLast_result,
        ____Generic_sms_PDUs_continue__components__item__returnResultNotLast,
        ___Generic_sms_PDUs_continue__components__item_,
        __Generic_sms_PDUs_continue__components,
        _Generic_sms_PDUs_continue_,
        _Generic_sms_PDUs_abort,
        Generic_sms_PDUs,
        SmsInvokable,
        __SmsInvokable_val_ArgumentType_0_callingPartysNumber,
        __SmsInvokable_val_ArgumentType_0_destinationSubscriberNumber,
        __SmsInvokable_val_ArgumentType_0_sMSCAddress,
        ___SmsInvokable_val_ArgumentType_0_extensions__item_,
        __SmsInvokable_val_ArgumentType_0_extensions,
        _SmsInvokable_val_ArgumentType_0,
        __SmsInvokable_val_ArgumentType_1_eventTypeSMS,
        __SmsInvokable_val_ArgumentType_1_eventSpecificInformationSMS,
        __SmsInvokable_val_ArgumentType_1_miscCallInfo,
        ___SmsInvokable_val_ArgumentType_1_extensions__item_,
        __SmsInvokable_val_ArgumentType_1_extensions,
        _SmsInvokable_val_ArgumentType_1,
        _SmsInvokable_val_ArgumentType_2,
        __SmsInvokable_val_ArgumentType_3_serviceKey,
        __SmsInvokable_val_ArgumentType_3_destinationSubscriberNumber,
        __SmsInvokable_val_ArgumentType_3_callingPartyNumber,
        __SmsInvokable_val_ArgumentType_3_eventTypeSMS,
        __SmsInvokable_val_ArgumentType_3_iMSI,
        __SmsInvokable_val_ArgumentType_3_locationInformationMSC,
        __SmsInvokable_val_ArgumentType_3_locationInformationGPRS,
        __SmsInvokable_val_ArgumentType_3_sMSCAddress,
        __SmsInvokable_val_ArgumentType_3_timeAndTimezone,
        __SmsInvokable_val_ArgumentType_3_tPShortMessageSpecificInfo,
        __SmsInvokable_val_ArgumentType_3_tPProtocolIdentifier,
        __SmsInvokable_val_ArgumentType_3_tPDataCodingScheme,
        __SmsInvokable_val_ArgumentType_3_tPValidityPeriod,
        ___SmsInvokable_val_ArgumentType_3_extensions__item_,
        __SmsInvokable_val_ArgumentType_3_extensions,
        __SmsInvokable_val_ArgumentType_3_smsReferenceNumber,
        __SmsInvokable_val_ArgumentType_3_mscAddress,
        __SmsInvokable_val_ArgumentType_3_sgsn_Number,
        __SmsInvokable_val_ArgumentType_3_ms_Classmark2,
        __SmsInvokable_val_ArgumentType_3_gPRSMSClass,
        __SmsInvokable_val_ArgumentType_3_iMEI,
        __SmsInvokable_val_ArgumentType_3_calledPartyNumber,
        _SmsInvokable_val_ArgumentType_3,
        ___SmsInvokable_val_ArgumentType_4_sMSEvents__item_,
        __SmsInvokable_val_ArgumentType_4_sMSEvents,
        ___SmsInvokable_val_ArgumentType_4_extensions__item_,
        __SmsInvokable_val_ArgumentType_4_extensions,
        _SmsInvokable_val_ArgumentType_4,
        __SmsInvokable_val_ArgumentType_5_timerID,
        __SmsInvokable_val_ArgumentType_5_timervalue,
        ___SmsInvokable_val_ArgumentType_5_extensions__item_,
        __SmsInvokable_val_ArgumentType_5_extensions,
        _SmsInvokable_val_ArgumentType_5,
        SmsReturnable,
        __SmsReturnable_val_ArgumentType_0_callingPartysNumber,
        __SmsReturnable_val_ArgumentType_0_destinationSubscriberNumber,
        __SmsReturnable_val_ArgumentType_0_sMSCAddress,
        ___SmsReturnable_val_ArgumentType_0_extensions__item_,
        __SmsReturnable_val_ArgumentType_0_extensions,
        _SmsReturnable_val_ArgumentType_0,
        _SmsReturnable_val_ArgumentType_2,
        __SmsReturnable_val_ArgumentType_3_serviceKey,
        __SmsReturnable_val_ArgumentType_3_destinationSubscriberNumber,
        __SmsReturnable_val_ArgumentType_3_callingPartyNumber,
        __SmsReturnable_val_ArgumentType_3_eventTypeSMS,
        __SmsReturnable_val_ArgumentType_3_iMSI,
        __SmsReturnable_val_ArgumentType_3_locationInformationMSC,
        __SmsReturnable_val_ArgumentType_3_locationInformationGPRS,
        __SmsReturnable_val_ArgumentType_3_sMSCAddress,
        __SmsReturnable_val_ArgumentType_3_timeAndTimezone,
        __SmsReturnable_val_ArgumentType_3_tPShortMessageSpecificInfo,
        __SmsReturnable_val_ArgumentType_3_tPProtocolIdentifier,
        __SmsReturnable_val_ArgumentType_3_tPDataCodingScheme,
        __SmsReturnable_val_ArgumentType_3_tPValidityPeriod,
        ___SmsReturnable_val_ArgumentType_3_extensions__item_,
        __SmsReturnable_val_ArgumentType_3_extensions,
        __SmsReturnable_val_ArgumentType_3_smsReferenceNumber,
        __SmsReturnable_val_ArgumentType_3_mscAddress,
        __SmsReturnable_val_ArgumentType_3_sgsn_Number,
        __SmsReturnable_val_ArgumentType_3_ms_Classmark2,
        __SmsReturnable_val_ArgumentType_3_gPRSMSClass,
        __SmsReturnable_val_ArgumentType_3_iMEI,
        __SmsReturnable_val_ArgumentType_3_calledPartyNumber,
        _SmsReturnable_val_ArgumentType_3,
        _SmsReturnable_val_ArgumentType_4,
        ___SmsReturnable_val_ArgumentType_5_sMSEvents__item_,
        __SmsReturnable_val_ArgumentType_5_sMSEvents,
        ___SmsReturnable_val_ArgumentType_5_extensions__item_,
        __SmsReturnable_val_ArgumentType_5_extensions,
        _SmsReturnable_val_ArgumentType_5,
        __SmsReturnable_val_ArgumentType_6_timerID,
        __SmsReturnable_val_ArgumentType_6_timervalue,
        ___SmsReturnable_val_ArgumentType_6_extensions__item_,
        __SmsReturnable_val_ArgumentType_6_extensions,
        _SmsReturnable_val_ArgumentType_6,
    ]

class CertificateExtensions:

    _name_  = u'CertificateExtensions'
    _oid_   = [2, 5, 1, 26, 8]
    
    _obj_ = [
        u'authorityKeyIdentifier',
        u'AuthorityKeyIdentifier',
        u'KeyIdentifier',
        u'subjectKeyIdentifier',
        u'SubjectKeyIdentifier',
        u'keyUsage',
        u'KeyUsage',
        u'extKeyUsage',
        u'KeyPurposeId',
        u'privateKeyUsagePeriod',
        u'PrivateKeyUsagePeriod',
        u'certificatePolicies',
        u'CertificatePoliciesSyntax',
        u'PolicyInformation',
        u'CertPolicyId',
        u'PolicyQualifierInfo',
        u'SupportedPolicyQualifiers',
        u'anyPolicy',
        u'CERT-POLICY-QUALIFIER',
        u'policyMappings',
        u'PolicyMappingsSyntax',
        u'authorizationValidation',
        u'AvlId',
        u'subjectAltName',
        u'GeneralNames',
        u'GeneralName',
        u'OTHER-NAME',
        u'EDIPartyName',
        u'issuerAltName',
        u'subjectDirectoryAttributes',
        u'AttributesSyntax',
        u'basicConstraints',
        u'BasicConstraintsSyntax',
        u'nameConstraints',
        u'NameConstraintsSyntax',
        u'GeneralSubtrees',
        u'GeneralSubtree',
        u'BaseDistance',
        u'policyConstraints',
        u'PolicyConstraintsSyntax',
        u'SkipCerts',
        u'inhibitAnyPolicy',
        u'cRLNumber',
        u'CRLNumber',
        u'crlScope',
        u'CRLScopeSyntax',
        u'PerAuthorityScope',
        u'OnlyCertificateTypes',
        u'NumberRange',
        u'BaseRevocationInfo',
        u'statusReferrals',
        u'StatusReferrals',
        u'StatusReferral',
        u'CRLReferral',
        u'DeltaRefInfo',
        u'OTHER-REFERRAL',
        u'cRLStreamIdentifier',
        u'CRLStreamIdentifier',
        u'orderedList',
        u'OrderedListSyntax',
        u'deltaInfo',
        u'DeltaInformation',
        u'toBeRevoked',
        u'ToBeRevokedSyntax',
        u'ToBeRevokedGroup',
        u'ReasonInfo',
        u'CertificateGroup',
        u'CertificateGroupNumberRange',
        u'CertificateSerialNumbers',
        u'revokedGroups',
        u'RevokedGroupsSyntax',
        u'RevokedGroup',
        u'RevokedCertificateGroup',
        u'expiredCertsOnCRL',
        u'ExpiredCertsOnCRL',
        u'reasonCode',
        u'CRLReason',
        u'holdInstructionCode',
        u'HoldInstruction',
        u'invalidityDate',
        u'cRLDistributionPoints',
        u'CRLDistPointsSyntax',
        u'DistributionPoint',
        u'DistributionPointName',
        u'ReasonFlags',
        u'issuingDistributionPoint',
        u'IssuingDistPointSyntax',
        u'certificateIssuer',
        u'deltaCRLIndicator',
        u'BaseCRLNumber',
        u'baseUpdateTime',
        u'freshestCRL',
        u'aAissuingDistributionPoint',
        u'AAIssuingDistPointSyntax',
        u'certificateExactMatch',
        u'CertificateExactAssertion',
        u'certificateMatch',
        u'CertificateAssertion',
        u'AltNameType',
        u'CertPolicySet',
        u'certificatePairExactMatch',
        u'CertificatePairExactAssertion',
        u'certificatePairMatch',
        u'CertificatePairAssertion',
        u'certificateListExactMatch',
        u'CertificateListExactAssertion',
        u'certificateListMatch',
        u'CertificateListAssertion',
        u'algorithmIdentifierMatch',
        u'policyMatch',
        u'pkiPathMatch',
        u'PkiPathMatchSyntax',
        u'enhancedCertificateMatch',
        u'EnhancedCertificateAssertion',
        u'AltName',
        u'certExactAssertion',
        u'certAssertion',
        u'certPairExactAssertion',
        u'certPairAssertion',
        u'certListExactAssertion',
        u'certListAssertion',
        u'algorithmIdentifier',
        u'id-ce-subjectDirectoryAttributes',
        u'id-ce-subjectKeyIdentifier',
        u'id-ce-keyUsage',
        u'id-ce-privateKeyUsagePeriod',
        u'id-ce-subjectAltName',
        u'id-ce-issuerAltName',
        u'id-ce-basicConstraints',
        u'id-ce-cRLNumber',
        u'id-ce-reasonCode',
        u'id-ce-holdInstructionCode',
        u'id-ce-invalidityDate',
        u'id-ce-deltaCRLIndicator',
        u'id-ce-issuingDistributionPoint',
        u'id-ce-certificateIssuer',
        u'id-ce-nameConstraints',
        u'id-ce-cRLDistributionPoints',
        u'id-ce-certificatePolicies',
        u'id-ce-policyMappings',
        u'id-ce-authorityKeyIdentifier',
        u'id-ce-policyConstraints',
        u'id-ce-extKeyUsage',
        u'id-ce-cRLStreamIdentifier',
        u'id-ce-cRLScope',
        u'id-ce-statusReferrals',
        u'id-ce-freshestCRL',
        u'id-ce-orderedList',
        u'id-ce-baseUpdateTime',
        u'id-ce-deltaInfo',
        u'id-ce-inhibitAnyPolicy',
        u'id-ce-toBeRevoked',
        u'id-ce-revokedGroups',
        u'id-ce-expiredCertsOnCRL',
        u'id-ce-aAissuingDistributionPoint',
        u'id-ce-authorizationValidation',
        u'id-mr-certificateExactMatch',
        u'id-mr-certificateMatch',
        u'id-mr-certificatePairExactMatch',
        u'id-mr-certificatePairMatch',
        u'id-mr-certificateListExactMatch',
        u'id-mr-certificateListMatch',
        u'id-mr-algorithmIdentifierMatch',
        u'id-mr-policyMatch',
        u'id-mr-pkiPathMatch',
        u'id-mr-enhancedCertificateMatch',
        u'id-ldx-certExactAssertion',
        u'id-ldx-certAssertion',
        u'id-ldx-certPairExactAssertion',
        u'id-ldx-certPairAssertion',
        u'id-ldx-certListExactAssertion',
        u'id-ldx-certListAssertion',
        u'id-ldx-algorithmIdentifier',
        ]
    _type_ = [
        u'AuthorityKeyIdentifier',
        u'KeyIdentifier',
        u'SubjectKeyIdentifier',
        u'KeyUsage',
        u'KeyPurposeId',
        u'PrivateKeyUsagePeriod',
        u'CertificatePoliciesSyntax',
        u'PolicyInformation',
        u'CertPolicyId',
        u'PolicyQualifierInfo',
        u'CERT-POLICY-QUALIFIER',
        u'PolicyMappingsSyntax',
        u'AvlId',
        u'GeneralNames',
        u'GeneralName',
        u'OTHER-NAME',
        u'EDIPartyName',
        u'AttributesSyntax',
        u'BasicConstraintsSyntax',
        u'NameConstraintsSyntax',
        u'GeneralSubtrees',
        u'GeneralSubtree',
        u'BaseDistance',
        u'PolicyConstraintsSyntax',
        u'SkipCerts',
        u'CRLNumber',
        u'CRLScopeSyntax',
        u'PerAuthorityScope',
        u'OnlyCertificateTypes',
        u'NumberRange',
        u'BaseRevocationInfo',
        u'StatusReferrals',
        u'StatusReferral',
        u'CRLReferral',
        u'DeltaRefInfo',
        u'OTHER-REFERRAL',
        u'CRLStreamIdentifier',
        u'OrderedListSyntax',
        u'DeltaInformation',
        u'ToBeRevokedSyntax',
        u'ToBeRevokedGroup',
        u'ReasonInfo',
        u'CertificateGroup',
        u'CertificateGroupNumberRange',
        u'CertificateSerialNumbers',
        u'RevokedGroupsSyntax',
        u'RevokedGroup',
        u'RevokedCertificateGroup',
        u'ExpiredCertsOnCRL',
        u'CRLReason',
        u'HoldInstruction',
        u'CRLDistPointsSyntax',
        u'DistributionPoint',
        u'DistributionPointName',
        u'ReasonFlags',
        u'IssuingDistPointSyntax',
        u'BaseCRLNumber',
        u'AAIssuingDistPointSyntax',
        u'CertificateExactAssertion',
        u'CertificateAssertion',
        u'AltNameType',
        u'CertPolicySet',
        u'CertificatePairExactAssertion',
        u'CertificatePairAssertion',
        u'CertificateListExactAssertion',
        u'CertificateListAssertion',
        u'PkiPathMatchSyntax',
        u'EnhancedCertificateAssertion',
        u'AltName',
        ]
    _set_ = [
        u'SupportedPolicyQualifiers',
        ]
    _val_ = [
        u'authorityKeyIdentifier',
        u'subjectKeyIdentifier',
        u'keyUsage',
        u'extKeyUsage',
        u'privateKeyUsagePeriod',
        u'certificatePolicies',
        u'anyPolicy',
        u'policyMappings',
        u'authorizationValidation',
        u'subjectAltName',
        u'issuerAltName',
        u'subjectDirectoryAttributes',
        u'basicConstraints',
        u'nameConstraints',
        u'policyConstraints',
        u'inhibitAnyPolicy',
        u'cRLNumber',
        u'crlScope',
        u'statusReferrals',
        u'cRLStreamIdentifier',
        u'orderedList',
        u'deltaInfo',
        u'toBeRevoked',
        u'revokedGroups',
        u'expiredCertsOnCRL',
        u'reasonCode',
        u'holdInstructionCode',
        u'invalidityDate',
        u'cRLDistributionPoints',
        u'issuingDistributionPoint',
        u'certificateIssuer',
        u'deltaCRLIndicator',
        u'baseUpdateTime',
        u'freshestCRL',
        u'aAissuingDistributionPoint',
        u'certificateExactMatch',
        u'certificateMatch',
        u'certificatePairExactMatch',
        u'certificatePairMatch',
        u'certificateListExactMatch',
        u'certificateListMatch',
        u'algorithmIdentifierMatch',
        u'policyMatch',
        u'pkiPathMatch',
        u'enhancedCertificateMatch',
        u'certExactAssertion',
        u'certAssertion',
        u'certPairExactAssertion',
        u'certPairAssertion',
        u'certListExactAssertion',
        u'certListAssertion',
        u'algorithmIdentifier',
        u'id-ce-subjectDirectoryAttributes',
        u'id-ce-subjectKeyIdentifier',
        u'id-ce-keyUsage',
        u'id-ce-privateKeyUsagePeriod',
        u'id-ce-subjectAltName',
        u'id-ce-issuerAltName',
        u'id-ce-basicConstraints',
        u'id-ce-cRLNumber',
        u'id-ce-reasonCode',
        u'id-ce-holdInstructionCode',
        u'id-ce-invalidityDate',
        u'id-ce-deltaCRLIndicator',
        u'id-ce-issuingDistributionPoint',
        u'id-ce-certificateIssuer',
        u'id-ce-nameConstraints',
        u'id-ce-cRLDistributionPoints',
        u'id-ce-certificatePolicies',
        u'id-ce-policyMappings',
        u'id-ce-authorityKeyIdentifier',
        u'id-ce-policyConstraints',
        u'id-ce-extKeyUsage',
        u'id-ce-cRLStreamIdentifier',
        u'id-ce-cRLScope',
        u'id-ce-statusReferrals',
        u'id-ce-freshestCRL',
        u'id-ce-orderedList',
        u'id-ce-baseUpdateTime',
        u'id-ce-deltaInfo',
        u'id-ce-inhibitAnyPolicy',
        u'id-ce-toBeRevoked',
        u'id-ce-revokedGroups',
        u'id-ce-expiredCertsOnCRL',
        u'id-ce-aAissuingDistributionPoint',
        u'id-ce-authorizationValidation',
        u'id-mr-certificateExactMatch',
        u'id-mr-certificateMatch',
        u'id-mr-certificatePairExactMatch',
        u'id-mr-certificatePairMatch',
        u'id-mr-certificateListExactMatch',
        u'id-mr-certificateListMatch',
        u'id-mr-algorithmIdentifierMatch',
        u'id-mr-policyMatch',
        u'id-mr-pkiPathMatch',
        u'id-mr-enhancedCertificateMatch',
        u'id-ldx-certExactAssertion',
        u'id-ldx-certAssertion',
        u'id-ldx-certPairExactAssertion',
        u'id-ldx-certPairAssertion',
        u'id-ldx-certListExactAssertion',
        u'id-ldx-certListAssertion',
        u'id-ldx-algorithmIdentifier',
        ]
    _class_ = [
        u'authorityKeyIdentifier',
        u'subjectKeyIdentifier',
        u'keyUsage',
        u'extKeyUsage',
        u'privateKeyUsagePeriod',
        u'certificatePolicies',
        u'SupportedPolicyQualifiers',
        u'CERT-POLICY-QUALIFIER',
        u'policyMappings',
        u'authorizationValidation',
        u'subjectAltName',
        u'OTHER-NAME',
        u'issuerAltName',
        u'subjectDirectoryAttributes',
        u'basicConstraints',
        u'nameConstraints',
        u'policyConstraints',
        u'inhibitAnyPolicy',
        u'cRLNumber',
        u'crlScope',
        u'statusReferrals',
        u'OTHER-REFERRAL',
        u'cRLStreamIdentifier',
        u'orderedList',
        u'deltaInfo',
        u'toBeRevoked',
        u'revokedGroups',
        u'expiredCertsOnCRL',
        u'reasonCode',
        u'holdInstructionCode',
        u'invalidityDate',
        u'cRLDistributionPoints',
        u'issuingDistributionPoint',
        u'certificateIssuer',
        u'deltaCRLIndicator',
        u'baseUpdateTime',
        u'freshestCRL',
        u'aAissuingDistributionPoint',
        u'certificateExactMatch',
        u'certificateMatch',
        u'certificatePairExactMatch',
        u'certificatePairMatch',
        u'certificateListExactMatch',
        u'certificateListMatch',
        u'algorithmIdentifierMatch',
        u'policyMatch',
        u'pkiPathMatch',
        u'enhancedCertificateMatch',
        u'certExactAssertion',
        u'certAssertion',
        u'certPairExactAssertion',
        u'certPairAssertion',
        u'certListExactAssertion',
        u'certListAssertion',
        u'algorithmIdentifier',
        ]
    _param_ = [
        ]
    
    #-----< authorityKeyIdentifier >-----#
    authorityKeyIdentifier = CLASS(name=u'authorityKeyIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _authorityKeyIdentifier_val_ExtnType = SEQ(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'AuthorityKeyIdentifier')))
    authorityKeyIdentifier._val = dict([(u'ExtnType', _authorityKeyIdentifier_val_ExtnType), (u'id', (2, 5, 29, 35))])
    
    #-----< AuthorityKeyIdentifier >-----#
    AuthorityKeyIdentifier = SEQ(name=u'AuthorityKeyIdentifier', mode=MODE_TYPE)
    _AuthorityKeyIdentifier_keyIdentifier = OCT_STR(name=u'keyIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'KeyIdentifier')), opt=True)
    _AuthorityKeyIdentifier_authorityCertIssuer = SEQ_OF(name=u'authorityCertIssuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _AuthorityKeyIdentifier_authorityCertSerialNumber = INT(name=u'authorityCertSerialNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')), opt=True)
    AuthorityKeyIdentifier._cont = ASN1Dict([
        (u'keyIdentifier', _AuthorityKeyIdentifier_keyIdentifier),
        (u'authorityCertIssuer', _AuthorityKeyIdentifier_authorityCertIssuer),
        (u'authorityCertSerialNumber', _AuthorityKeyIdentifier_authorityCertSerialNumber),
        ])
    AuthorityKeyIdentifier._ext = []
    
    #-----< KeyIdentifier >-----#
    KeyIdentifier = OCT_STR(name=u'KeyIdentifier', mode=MODE_TYPE)
    
    #-----< subjectKeyIdentifier >-----#
    subjectKeyIdentifier = CLASS(name=u'subjectKeyIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _subjectKeyIdentifier_val_ExtnType = OCT_STR(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'SubjectKeyIdentifier')))
    subjectKeyIdentifier._val = dict([(u'ExtnType', _subjectKeyIdentifier_val_ExtnType), (u'id', (2, 5, 29, 14))])
    
    #-----< SubjectKeyIdentifier >-----#
    SubjectKeyIdentifier = OCT_STR(name=u'SubjectKeyIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'KeyIdentifier')))
    
    #-----< keyUsage >-----#
    keyUsage = CLASS(name=u'keyUsage', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _keyUsage_val_ExtnType = BIT_STR(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'KeyUsage')))
    keyUsage._val = dict([(u'ExtnType', _keyUsage_val_ExtnType), (u'id', (2, 5, 29, 15))])
    
    #-----< KeyUsage >-----#
    KeyUsage = BIT_STR(name=u'KeyUsage', mode=MODE_TYPE)
    KeyUsage._cont = ASN1Dict([(u'digitalSignature', 0), (u'contentCommitment', 1), (u'keyEncipherment', 2), (u'dataEncipherment', 3), (u'keyAgreement', 4), (u'keyCertSign', 5), (u'cRLSign', 6), (u'encipherOnly', 7), (u'decipherOnly', 8)])
    
    #-----< extKeyUsage >-----#
    extKeyUsage = CLASS(name=u'extKeyUsage', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _extKeyUsage_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE)
    __extKeyUsage_val_ExtnType__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'KeyPurposeId')))
    _extKeyUsage_val_ExtnType._cont = __extKeyUsage_val_ExtnType__item_
    _extKeyUsage_val_ExtnType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    extKeyUsage._val = dict([(u'ExtnType', _extKeyUsage_val_ExtnType), (u'id', (2, 5, 29, 37))])
    
    #-----< KeyPurposeId >-----#
    KeyPurposeId = OID(name=u'KeyPurposeId', mode=MODE_TYPE)
    
    #-----< privateKeyUsagePeriod >-----#
    privateKeyUsagePeriod = CLASS(name=u'privateKeyUsagePeriod', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _privateKeyUsagePeriod_val_ExtnType = SEQ(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PrivateKeyUsagePeriod')))
    privateKeyUsagePeriod._val = dict([(u'ExtnType', _privateKeyUsagePeriod_val_ExtnType), (u'id', (2, 5, 29, 16))])
    
    #-----< PrivateKeyUsagePeriod >-----#
    PrivateKeyUsagePeriod = SEQ(name=u'PrivateKeyUsagePeriod', mode=MODE_TYPE)
    _PrivateKeyUsagePeriod_notBefore = TIME_GEN(name=u'notBefore', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PrivateKeyUsagePeriod_notAfter = TIME_GEN(name=u'notAfter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PrivateKeyUsagePeriod._cont = ASN1Dict([
        (u'notBefore', _PrivateKeyUsagePeriod_notBefore),
        (u'notAfter', _PrivateKeyUsagePeriod_notAfter),
        ])
    PrivateKeyUsagePeriod._ext = []
    
    #-----< certificatePolicies >-----#
    certificatePolicies = CLASS(name=u'certificatePolicies', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _certificatePolicies_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePoliciesSyntax')))
    certificatePolicies._val = dict([(u'ExtnType', _certificatePolicies_val_ExtnType), (u'id', (2, 5, 29, 32))])
    
    #-----< CertificatePoliciesSyntax >-----#
    CertificatePoliciesSyntax = SEQ_OF(name=u'CertificatePoliciesSyntax', mode=MODE_TYPE)
    _CertificatePoliciesSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PolicyInformation')))
    CertificatePoliciesSyntax._cont = _CertificatePoliciesSyntax__item_
    CertificatePoliciesSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< PolicyInformation >-----#
    PolicyInformation = SEQ(name=u'PolicyInformation', mode=MODE_TYPE)
    _PolicyInformation_policyIdentifier = OID(name=u'policyIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertPolicyId')))
    _PolicyInformation_policyQualifiers = SEQ_OF(name=u'policyQualifiers', mode=MODE_TYPE, opt=True)
    __PolicyInformation_policyQualifiers__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PolicyQualifierInfo')))
    _PolicyInformation_policyQualifiers._cont = __PolicyInformation_policyQualifiers__item_
    _PolicyInformation_policyQualifiers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    PolicyInformation._cont = ASN1Dict([
        (u'policyIdentifier', _PolicyInformation_policyIdentifier),
        (u'policyQualifiers', _PolicyInformation_policyQualifiers),
        ])
    PolicyInformation._ext = []
    
    #-----< CertPolicyId >-----#
    CertPolicyId = OID(name=u'CertPolicyId', mode=MODE_TYPE)
    
    #-----< PolicyQualifierInfo >-----#
    PolicyQualifierInfo = SEQ(name=u'PolicyQualifierInfo', mode=MODE_TYPE)
    _PolicyQualifierInfo_policyQualifierId = OID(name=u'policyQualifierId', mode=MODE_TYPE, typeref=ASN1RefClassField(('CertificateExtensions', 'CERT-POLICY-QUALIFIER'), [u'id']))
    __PolicyQualifierInfo_policyQualifierId_tab = CLASS(name='_tab_CERT-POLICY-QUALIFIER', mode=MODE_SET, typeref=ASN1RefType(('CertificateExtensions', 'CERT-POLICY-QUALIFIER')))
    __PolicyQualifierInfo_policyQualifierId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PolicyQualifierInfo_policyQualifierId._const_tab = __PolicyQualifierInfo_policyQualifierId_tab
    _PolicyQualifierInfo_policyQualifierId._const_tab_at = None
    _PolicyQualifierInfo_policyQualifierId._const_tab_id = u'id'
    _PolicyQualifierInfo_qualifier = OPEN(name=u'qualifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('CertificateExtensions', 'CERT-POLICY-QUALIFIER'), [u'Qualifier']), opt=True)
    __PolicyQualifierInfo_qualifier_tab = CLASS(name='_tab_CERT-POLICY-QUALIFIER', mode=MODE_SET, typeref=ASN1RefType(('CertificateExtensions', 'CERT-POLICY-QUALIFIER')))
    __PolicyQualifierInfo_qualifier_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PolicyQualifierInfo_qualifier._const_tab = __PolicyQualifierInfo_qualifier_tab
    _PolicyQualifierInfo_qualifier._const_tab_at = ('..', u'policyQualifierId')
    _PolicyQualifierInfo_qualifier._const_tab_id = u'Qualifier'
    PolicyQualifierInfo._cont = ASN1Dict([
        (u'policyQualifierId', _PolicyQualifierInfo_policyQualifierId),
        (u'qualifier', _PolicyQualifierInfo_qualifier),
        ])
    PolicyQualifierInfo._ext = []
    
    #-----< SupportedPolicyQualifiers >-----#
    SupportedPolicyQualifiers = CLASS(name=u'SupportedPolicyQualifiers', mode=MODE_SET, typeref=ASN1RefType(('CertificateExtensions', 'CERT-POLICY-QUALIFIER')))
    SupportedPolicyQualifiers._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< anyPolicy >-----#
    anyPolicy = OID(name=u'anyPolicy', mode=MODE_VALUE)
    anyPolicy._val = (2, 5, 29, 32, 0)
    
    #-----< CERT-POLICY-QUALIFIER >-----#
    CERT_POLICY_QUALIFIER = CLASS(name=u'CERT-POLICY-QUALIFIER', mode=MODE_TYPE)
    _CERT_POLICY_QUALIFIER_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    _CERT_POLICY_QUALIFIER_Qualifier = OPEN(name=u'Qualifier', mode=MODE_TYPE, opt=True)
    CERT_POLICY_QUALIFIER._cont = ASN1Dict([
        (u'id', _CERT_POLICY_QUALIFIER_id),
        (u'Qualifier', _CERT_POLICY_QUALIFIER_Qualifier),
        ])
    
    #-----< policyMappings >-----#
    policyMappings = CLASS(name=u'policyMappings', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _policyMappings_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PolicyMappingsSyntax')))
    policyMappings._val = dict([(u'ExtnType', _policyMappings_val_ExtnType), (u'id', (2, 5, 29, 33))])
    
    #-----< PolicyMappingsSyntax >-----#
    PolicyMappingsSyntax = SEQ_OF(name=u'PolicyMappingsSyntax', mode=MODE_TYPE)
    _PolicyMappingsSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __PolicyMappingsSyntax__item__issuerDomainPolicy = OID(name=u'issuerDomainPolicy', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertPolicyId')))
    __PolicyMappingsSyntax__item__subjectDomainPolicy = OID(name=u'subjectDomainPolicy', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertPolicyId')))
    _PolicyMappingsSyntax__item_._cont = ASN1Dict([
        (u'issuerDomainPolicy', __PolicyMappingsSyntax__item__issuerDomainPolicy),
        (u'subjectDomainPolicy', __PolicyMappingsSyntax__item__subjectDomainPolicy),
        ])
    _PolicyMappingsSyntax__item_._ext = []
    PolicyMappingsSyntax._cont = _PolicyMappingsSyntax__item_
    PolicyMappingsSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< authorizationValidation >-----#
    authorizationValidation = CLASS(name=u'authorizationValidation', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _authorizationValidation_val_ExtnType = SEQ(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'AvlId')))
    authorizationValidation._val = dict([(u'ExtnType', _authorizationValidation_val_ExtnType), (u'id', (2, 5, 29, 70))])
    
    #-----< AvlId >-----#
    AvlId = SEQ(name=u'AvlId', mode=MODE_TYPE)
    _AvlId_issuer = CHOICE(name=u'issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _AvlId_serialNumber = INT(name=u'serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AvlSerialNumber')), opt=True)
    AvlId._cont = ASN1Dict([
        (u'issuer', _AvlId_issuer),
        (u'serialNumber', _AvlId_serialNumber),
        ])
    AvlId._ext = []
    
    #-----< subjectAltName >-----#
    subjectAltName = CLASS(name=u'subjectAltName', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _subjectAltName_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    subjectAltName._val = dict([(u'ExtnType', _subjectAltName_val_ExtnType), (u'id', (2, 5, 29, 17))])
    
    #-----< GeneralNames >-----#
    GeneralNames = SEQ_OF(name=u'GeneralNames', mode=MODE_TYPE)
    _GeneralNames__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    GeneralNames._cont = _GeneralNames__item_
    GeneralNames._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< GeneralName >-----#
    GeneralName = CHOICE(name=u'GeneralName', mode=MODE_TYPE)
    _GeneralName_otherName = SEQ(name=u'otherName', mode=MODE_TYPE)
    __GeneralName_otherName_type_id = OID(name='type-id', mode=MODE_TYPE, typeref=ASN1RefClassField(('CertificateExtensions', 'OTHER-NAME'), ['id']))
    __GeneralName_otherName_value = OPEN(name='value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CertificateExtensions', 'OTHER-NAME'), ['Type']))
    _GeneralName_otherName._cont = ASN1Dict([
        ('type-id', __GeneralName_otherName_type_id),
        ('value', __GeneralName_otherName_value),
        ])
    _GeneralName_otherName._ext = None
    _GeneralName_otherName.TAG = 8
    _GeneralName_rfc822Name = STR_IA5(name=u'rfc822Name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_dNSName = STR_IA5(name=u'dNSName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_x400Address = SEQ(name=u'x400Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ORAddress')))
    _GeneralName_directoryName = CHOICE(name=u'directoryName', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _GeneralName_ediPartyName = SEQ(name=u'ediPartyName', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'EDIPartyName')))
    _GeneralName_uniformResourceIdentifier = STR_IA5(name=u'uniformResourceIdentifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_iPAddress = OCT_STR(name=u'iPAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_registeredID = OID(name=u'registeredID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GeneralName._cont = ASN1Dict([
        (u'otherName', _GeneralName_otherName),
        (u'rfc822Name', _GeneralName_rfc822Name),
        (u'dNSName', _GeneralName_dNSName),
        (u'x400Address', _GeneralName_x400Address),
        (u'directoryName', _GeneralName_directoryName),
        (u'ediPartyName', _GeneralName_ediPartyName),
        (u'uniformResourceIdentifier', _GeneralName_uniformResourceIdentifier),
        (u'iPAddress', _GeneralName_iPAddress),
        (u'registeredID', _GeneralName_registeredID),
        ])
    GeneralName._ext = []
    
    #-----< OTHER-NAME >-----#
    OTHER_NAME = CLASS(name=u'OTHER-NAME', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', u'TYPE-IDENTIFIER'), []))
    
    #-----< EDIPartyName >-----#
    EDIPartyName = SEQ(name=u'EDIPartyName', mode=MODE_TYPE)
    _EDIPartyName_nameAssigner = CHOICE(name=u'nameAssigner', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _EDIPartyName_partyName = CHOICE(name=u'partyName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    EDIPartyName._cont = ASN1Dict([
        (u'nameAssigner', _EDIPartyName_nameAssigner),
        (u'partyName', _EDIPartyName_partyName),
        ])
    EDIPartyName._ext = []
    
    #-----< issuerAltName >-----#
    issuerAltName = CLASS(name=u'issuerAltName', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _issuerAltName_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    issuerAltName._val = dict([(u'ExtnType', _issuerAltName_val_ExtnType), (u'id', (2, 5, 29, 18))])
    
    #-----< subjectDirectoryAttributes >-----#
    subjectDirectoryAttributes = CLASS(name=u'subjectDirectoryAttributes', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _subjectDirectoryAttributes_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'AttributesSyntax')))
    subjectDirectoryAttributes._val = dict([(u'ExtnType', _subjectDirectoryAttributes_val_ExtnType), (u'id', (2, 5, 29, 9))])
    
    #-----< AttributesSyntax >-----#
    AttributesSyntax = SEQ_OF(name=u'AttributesSyntax', mode=MODE_TYPE)
    _AttributesSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __AttributesSyntax__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ___AttributesSyntax__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ____AttributesSyntax__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    ____AttributesSyntax__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ___AttributesSyntax__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', ____AttributesSyntax__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ____AttributesSyntax__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    __AttributesSyntax__item__type._const_tab = ___AttributesSyntax__item__type_tab
    __AttributesSyntax__item__type._const_tab_at = None
    __AttributesSyntax__item__type._const_tab_id = u'id'
    __AttributesSyntax__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ___AttributesSyntax__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ___AttributesSyntax__item__values__item_._const_tab = ___AttributesSyntax__item__type_tab
    ___AttributesSyntax__item__values__item_._const_tab_at = ('..', '..', u'type')
    ___AttributesSyntax__item__values__item_._const_tab_id = u'Type'
    __AttributesSyntax__item__values._cont = ___AttributesSyntax__item__values__item_
    __AttributesSyntax__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __AttributesSyntax__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ___AttributesSyntax__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____AttributesSyntax__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____AttributesSyntax__item__valuesWithContext__item__value._const_tab = ___AttributesSyntax__item__type_tab
    ____AttributesSyntax__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    ____AttributesSyntax__item__valuesWithContext__item__value._const_tab_id = u'Type'
    ____AttributesSyntax__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    _____AttributesSyntax__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____AttributesSyntax__item__valuesWithContext__item__contextList._cont = _____AttributesSyntax__item__valuesWithContext__item__contextList__item_
    ____AttributesSyntax__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___AttributesSyntax__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', ____AttributesSyntax__item__valuesWithContext__item__value),
        (u'contextList', ____AttributesSyntax__item__valuesWithContext__item__contextList),
        ])
    ___AttributesSyntax__item__valuesWithContext__item_._ext = []
    __AttributesSyntax__item__valuesWithContext._cont = ___AttributesSyntax__item__valuesWithContext__item_
    __AttributesSyntax__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AttributesSyntax__item_._cont = ASN1Dict([
        (u'type', __AttributesSyntax__item__type),
        (u'values', __AttributesSyntax__item__values),
        (u'valuesWithContext', __AttributesSyntax__item__valuesWithContext),
        ])
    _AttributesSyntax__item_._ext = []
    AttributesSyntax._cont = _AttributesSyntax__item_
    AttributesSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< basicConstraints >-----#
    basicConstraints = CLASS(name=u'basicConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _basicConstraints_val_ExtnType = SEQ(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'BasicConstraintsSyntax')))
    basicConstraints._val = dict([(u'ExtnType', _basicConstraints_val_ExtnType), (u'id', (2, 5, 29, 19))])
    
    #-----< BasicConstraintsSyntax >-----#
    BasicConstraintsSyntax = SEQ(name=u'BasicConstraintsSyntax', mode=MODE_TYPE)
    _BasicConstraintsSyntax_cA = BOOL(name=u'cA', mode=MODE_TYPE, default=False)
    _BasicConstraintsSyntax_pathLenConstraint = INT(name=u'pathLenConstraint', mode=MODE_TYPE, opt=True)
    _BasicConstraintsSyntax_pathLenConstraint._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    BasicConstraintsSyntax._cont = ASN1Dict([
        (u'cA', _BasicConstraintsSyntax_cA),
        (u'pathLenConstraint', _BasicConstraintsSyntax_pathLenConstraint),
        ])
    BasicConstraintsSyntax._ext = []
    
    #-----< nameConstraints >-----#
    nameConstraints = CLASS(name=u'nameConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _nameConstraints_val_ExtnType = SEQ(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'NameConstraintsSyntax')))
    nameConstraints._val = dict([(u'ExtnType', _nameConstraints_val_ExtnType), (u'id', (2, 5, 29, 30))])
    
    #-----< NameConstraintsSyntax >-----#
    NameConstraintsSyntax = SEQ(name=u'NameConstraintsSyntax', mode=MODE_TYPE)
    _NameConstraintsSyntax_permittedSubtrees = SEQ_OF(name=u'permittedSubtrees', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralSubtrees')), opt=True)
    _NameConstraintsSyntax_excludedSubtrees = SEQ_OF(name=u'excludedSubtrees', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralSubtrees')), opt=True)
    NameConstraintsSyntax._cont = ASN1Dict([
        (u'permittedSubtrees', _NameConstraintsSyntax_permittedSubtrees),
        (u'excludedSubtrees', _NameConstraintsSyntax_excludedSubtrees),
        ])
    NameConstraintsSyntax._ext = []
    
    #-----< GeneralSubtrees >-----#
    GeneralSubtrees = SEQ_OF(name=u'GeneralSubtrees', mode=MODE_TYPE)
    _GeneralSubtrees__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralSubtree')))
    GeneralSubtrees._cont = _GeneralSubtrees__item_
    GeneralSubtrees._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< GeneralSubtree >-----#
    GeneralSubtree = SEQ(name=u'GeneralSubtree', mode=MODE_TYPE)
    _GeneralSubtree_base = CHOICE(name=u'base', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _GeneralSubtree_minimum = INT(name=u'minimum', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'BaseDistance')), default=0)
    _GeneralSubtree_maximum = INT(name=u'maximum', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'BaseDistance')), opt=True)
    GeneralSubtree._cont = ASN1Dict([
        (u'base', _GeneralSubtree_base),
        (u'minimum', _GeneralSubtree_minimum),
        (u'maximum', _GeneralSubtree_maximum),
        ])
    GeneralSubtree._ext = []
    
    #-----< BaseDistance >-----#
    BaseDistance = INT(name=u'BaseDistance', mode=MODE_TYPE)
    BaseDistance._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< policyConstraints >-----#
    policyConstraints = CLASS(name=u'policyConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _policyConstraints_val_ExtnType = SEQ(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PolicyConstraintsSyntax')))
    policyConstraints._val = dict([(u'ExtnType', _policyConstraints_val_ExtnType), (u'id', (2, 5, 29, 36))])
    
    #-----< PolicyConstraintsSyntax >-----#
    PolicyConstraintsSyntax = SEQ(name=u'PolicyConstraintsSyntax', mode=MODE_TYPE)
    _PolicyConstraintsSyntax_requireExplicitPolicy = INT(name=u'requireExplicitPolicy', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'SkipCerts')), opt=True)
    _PolicyConstraintsSyntax_inhibitPolicyMapping = INT(name=u'inhibitPolicyMapping', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'SkipCerts')), opt=True)
    PolicyConstraintsSyntax._cont = ASN1Dict([
        (u'requireExplicitPolicy', _PolicyConstraintsSyntax_requireExplicitPolicy),
        (u'inhibitPolicyMapping', _PolicyConstraintsSyntax_inhibitPolicyMapping),
        ])
    PolicyConstraintsSyntax._ext = []
    
    #-----< SkipCerts >-----#
    SkipCerts = INT(name=u'SkipCerts', mode=MODE_TYPE)
    SkipCerts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< inhibitAnyPolicy >-----#
    inhibitAnyPolicy = CLASS(name=u'inhibitAnyPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _inhibitAnyPolicy_val_ExtnType = INT(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'SkipCerts')))
    inhibitAnyPolicy._val = dict([(u'ExtnType', _inhibitAnyPolicy_val_ExtnType), (u'id', (2, 5, 29, 54))])
    
    #-----< cRLNumber >-----#
    cRLNumber = CLASS(name=u'cRLNumber', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _cRLNumber_val_ExtnType = INT(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLNumber')))
    cRLNumber._val = dict([(u'ExtnType', _cRLNumber_val_ExtnType), (u'id', (2, 5, 29, 20))])
    
    #-----< CRLNumber >-----#
    CRLNumber = INT(name=u'CRLNumber', mode=MODE_TYPE)
    CRLNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< crlScope >-----#
    crlScope = CLASS(name=u'crlScope', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _crlScope_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLScopeSyntax')))
    crlScope._val = dict([(u'ExtnType', _crlScope_val_ExtnType), (u'id', (2, 5, 29, 44))])
    
    #-----< CRLScopeSyntax >-----#
    CRLScopeSyntax = SEQ_OF(name=u'CRLScopeSyntax', mode=MODE_TYPE)
    _CRLScopeSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PerAuthorityScope')))
    CRLScopeSyntax._cont = _CRLScopeSyntax__item_
    CRLScopeSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< PerAuthorityScope >-----#
    PerAuthorityScope = SEQ(name=u'PerAuthorityScope', mode=MODE_TYPE)
    _PerAuthorityScope_authorityName = CHOICE(name=u'authorityName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _PerAuthorityScope_distributionPoint = CHOICE(name=u'distributionPoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    _PerAuthorityScope_onlyContains = BIT_STR(name=u'onlyContains', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'OnlyCertificateTypes')), opt=True)
    _PerAuthorityScope_onlySomeReasons = BIT_STR(name=u'onlySomeReasons', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonFlags')), opt=True)
    _PerAuthorityScope_serialNumberRange = SEQ(name=u'serialNumberRange', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'NumberRange')), opt=True)
    _PerAuthorityScope_subjectKeyIdRange = SEQ(name=u'subjectKeyIdRange', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'NumberRange')), opt=True)
    _PerAuthorityScope_nameSubtrees = SEQ_OF(name=u'nameSubtrees', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _PerAuthorityScope_baseRevocationInfo = SEQ(name=u'baseRevocationInfo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'BaseRevocationInfo')), opt=True)
    PerAuthorityScope._cont = ASN1Dict([
        (u'authorityName', _PerAuthorityScope_authorityName),
        (u'distributionPoint', _PerAuthorityScope_distributionPoint),
        (u'onlyContains', _PerAuthorityScope_onlyContains),
        (u'onlySomeReasons', _PerAuthorityScope_onlySomeReasons),
        (u'serialNumberRange', _PerAuthorityScope_serialNumberRange),
        (u'subjectKeyIdRange', _PerAuthorityScope_subjectKeyIdRange),
        (u'nameSubtrees', _PerAuthorityScope_nameSubtrees),
        (u'baseRevocationInfo', _PerAuthorityScope_baseRevocationInfo),
        ])
    PerAuthorityScope._ext = []
    
    #-----< OnlyCertificateTypes >-----#
    OnlyCertificateTypes = BIT_STR(name=u'OnlyCertificateTypes', mode=MODE_TYPE)
    OnlyCertificateTypes._cont = ASN1Dict([(u'user', 0), (u'authority', 1), (u'attribute', 2)])
    
    #-----< NumberRange >-----#
    NumberRange = SEQ(name=u'NumberRange', mode=MODE_TYPE)
    _NumberRange_startingNumber = INT(name=u'startingNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NumberRange_endingNumber = INT(name=u'endingNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NumberRange_modulus = INT(name=u'modulus', mode=MODE_TYPE, opt=True)
    NumberRange._cont = ASN1Dict([
        (u'startingNumber', _NumberRange_startingNumber),
        (u'endingNumber', _NumberRange_endingNumber),
        (u'modulus', _NumberRange_modulus),
        ])
    NumberRange._ext = []
    
    #-----< BaseRevocationInfo >-----#
    BaseRevocationInfo = SEQ(name=u'BaseRevocationInfo', mode=MODE_TYPE)
    _BaseRevocationInfo_cRLStreamIdentifier = INT(name=u'cRLStreamIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CRLStreamIdentifier')), opt=True)
    _BaseRevocationInfo_cRLNumber = INT(name=u'cRLNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CRLNumber')))
    _BaseRevocationInfo_baseThisUpdate = TIME_GEN(name=u'baseThisUpdate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    BaseRevocationInfo._cont = ASN1Dict([
        (u'cRLStreamIdentifier', _BaseRevocationInfo_cRLStreamIdentifier),
        (u'cRLNumber', _BaseRevocationInfo_cRLNumber),
        (u'baseThisUpdate', _BaseRevocationInfo_baseThisUpdate),
        ])
    BaseRevocationInfo._ext = []
    
    #-----< statusReferrals >-----#
    statusReferrals = CLASS(name=u'statusReferrals', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _statusReferrals_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'StatusReferrals')))
    statusReferrals._val = dict([(u'ExtnType', _statusReferrals_val_ExtnType), (u'id', (2, 5, 29, 45))])
    
    #-----< StatusReferrals >-----#
    StatusReferrals = SEQ_OF(name=u'StatusReferrals', mode=MODE_TYPE)
    _StatusReferrals__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'StatusReferral')))
    StatusReferrals._cont = _StatusReferrals__item_
    StatusReferrals._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< StatusReferral >-----#
    StatusReferral = CHOICE(name=u'StatusReferral', mode=MODE_TYPE)
    _StatusReferral_cRLReferral = SEQ(name=u'cRLReferral', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CRLReferral')))
    _StatusReferral_otherReferral = SEQ(name=u'otherReferral', mode=MODE_TYPE)
    __StatusReferral_otherReferral_type_id = OID(name='type-id', mode=MODE_TYPE, typeref=ASN1RefClassField(('CertificateExtensions', 'OTHER-REFERRAL'), ['id']))
    __StatusReferral_otherReferral_value = OPEN(name='value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CertificateExtensions', 'OTHER-REFERRAL'), ['Type']))
    _StatusReferral_otherReferral._cont = ASN1Dict([
        ('type-id', __StatusReferral_otherReferral_type_id),
        ('value', __StatusReferral_otherReferral_value),
        ])
    _StatusReferral_otherReferral._ext = None
    _StatusReferral_otherReferral.TAG = 8
    StatusReferral._cont = ASN1Dict([
        (u'cRLReferral', _StatusReferral_cRLReferral),
        (u'otherReferral', _StatusReferral_otherReferral),
        ])
    StatusReferral._ext = []
    
    #-----< CRLReferral >-----#
    CRLReferral = SEQ(name=u'CRLReferral', mode=MODE_TYPE)
    _CRLReferral_issuer = CHOICE(name=u'issuer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _CRLReferral_location = CHOICE(name=u'location', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _CRLReferral_deltaRefInfo = SEQ(name=u'deltaRefInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DeltaRefInfo')), opt=True)
    _CRLReferral_cRLScope = SEQ_OF(name=u'cRLScope', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLScopeSyntax')))
    _CRLReferral_lastUpdate = TIME_GEN(name=u'lastUpdate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CRLReferral_lastChangedCRL = TIME_GEN(name=u'lastChangedCRL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CRLReferral._cont = ASN1Dict([
        (u'issuer', _CRLReferral_issuer),
        (u'location', _CRLReferral_location),
        (u'deltaRefInfo', _CRLReferral_deltaRefInfo),
        (u'cRLScope', _CRLReferral_cRLScope),
        (u'lastUpdate', _CRLReferral_lastUpdate),
        (u'lastChangedCRL', _CRLReferral_lastChangedCRL),
        ])
    CRLReferral._ext = []
    
    #-----< DeltaRefInfo >-----#
    DeltaRefInfo = SEQ(name=u'DeltaRefInfo', mode=MODE_TYPE)
    _DeltaRefInfo_deltaLocation = CHOICE(name=u'deltaLocation', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _DeltaRefInfo_lastDelta = TIME_GEN(name=u'lastDelta', mode=MODE_TYPE, opt=True)
    DeltaRefInfo._cont = ASN1Dict([
        (u'deltaLocation', _DeltaRefInfo_deltaLocation),
        (u'lastDelta', _DeltaRefInfo_lastDelta),
        ])
    DeltaRefInfo._ext = []
    
    #-----< OTHER-REFERRAL >-----#
    OTHER_REFERRAL = CLASS(name=u'OTHER-REFERRAL', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', u'TYPE-IDENTIFIER'), []))
    
    #-----< cRLStreamIdentifier >-----#
    cRLStreamIdentifier = CLASS(name=u'cRLStreamIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _cRLStreamIdentifier_val_ExtnType = INT(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLStreamIdentifier')))
    cRLStreamIdentifier._val = dict([(u'ExtnType', _cRLStreamIdentifier_val_ExtnType), (u'id', (2, 5, 29, 40))])
    
    #-----< CRLStreamIdentifier >-----#
    CRLStreamIdentifier = INT(name=u'CRLStreamIdentifier', mode=MODE_TYPE)
    CRLStreamIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< orderedList >-----#
    orderedList = CLASS(name=u'orderedList', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _orderedList_val_ExtnType = ENUM(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'OrderedListSyntax')))
    orderedList._val = dict([(u'ExtnType', _orderedList_val_ExtnType), (u'id', (2, 5, 29, 47))])
    
    #-----< OrderedListSyntax >-----#
    OrderedListSyntax = ENUM(name=u'OrderedListSyntax', mode=MODE_TYPE)
    OrderedListSyntax._cont = ASN1Dict([(u'ascSerialNum', 0), (u'ascRevDate', 1)])
    OrderedListSyntax._ext = []
    
    #-----< deltaInfo >-----#
    deltaInfo = CLASS(name=u'deltaInfo', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _deltaInfo_val_ExtnType = SEQ(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'DeltaInformation')))
    deltaInfo._val = dict([(u'ExtnType', _deltaInfo_val_ExtnType), (u'id', (2, 5, 29, 53))])
    
    #-----< DeltaInformation >-----#
    DeltaInformation = SEQ(name=u'DeltaInformation', mode=MODE_TYPE)
    _DeltaInformation_deltaLocation = CHOICE(name=u'deltaLocation', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _DeltaInformation_nextDelta = TIME_GEN(name=u'nextDelta', mode=MODE_TYPE, opt=True)
    DeltaInformation._cont = ASN1Dict([
        (u'deltaLocation', _DeltaInformation_deltaLocation),
        (u'nextDelta', _DeltaInformation_nextDelta),
        ])
    DeltaInformation._ext = []
    
    #-----< toBeRevoked >-----#
    toBeRevoked = CLASS(name=u'toBeRevoked', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _toBeRevoked_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'ToBeRevokedSyntax')))
    toBeRevoked._val = dict([(u'ExtnType', _toBeRevoked_val_ExtnType), (u'id', (2, 5, 29, 58))])
    
    #-----< ToBeRevokedSyntax >-----#
    ToBeRevokedSyntax = SEQ_OF(name=u'ToBeRevokedSyntax', mode=MODE_TYPE)
    _ToBeRevokedSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'ToBeRevokedGroup')))
    ToBeRevokedSyntax._cont = _ToBeRevokedSyntax__item_
    ToBeRevokedSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< ToBeRevokedGroup >-----#
    ToBeRevokedGroup = SEQ(name=u'ToBeRevokedGroup', mode=MODE_TYPE)
    _ToBeRevokedGroup_certificateIssuer = CHOICE(name=u'certificateIssuer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _ToBeRevokedGroup_reasonInfo = SEQ(name=u'reasonInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonInfo')), opt=True)
    _ToBeRevokedGroup_revocationTime = TIME_GEN(name=u'revocationTime', mode=MODE_TYPE)
    _ToBeRevokedGroup_certificateGroup = CHOICE(name=u'certificateGroup', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateGroup')))
    ToBeRevokedGroup._cont = ASN1Dict([
        (u'certificateIssuer', _ToBeRevokedGroup_certificateIssuer),
        (u'reasonInfo', _ToBeRevokedGroup_reasonInfo),
        (u'revocationTime', _ToBeRevokedGroup_revocationTime),
        (u'certificateGroup', _ToBeRevokedGroup_certificateGroup),
        ])
    ToBeRevokedGroup._ext = []
    
    #-----< ReasonInfo >-----#
    ReasonInfo = SEQ(name=u'ReasonInfo', mode=MODE_TYPE)
    _ReasonInfo_reasonCode = ENUM(name=u'reasonCode', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLReason')))
    _ReasonInfo_holdInstructionCode = OID(name=u'holdInstructionCode', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'HoldInstruction')), opt=True)
    ReasonInfo._cont = ASN1Dict([
        (u'reasonCode', _ReasonInfo_reasonCode),
        (u'holdInstructionCode', _ReasonInfo_holdInstructionCode),
        ])
    ReasonInfo._ext = []
    
    #-----< CertificateGroup >-----#
    CertificateGroup = CHOICE(name=u'CertificateGroup', mode=MODE_TYPE)
    _CertificateGroup_serialNumbers = SEQ_OF(name=u'serialNumbers', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateSerialNumbers')))
    _CertificateGroup_serialNumberRange = SEQ(name=u'serialNumberRange', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateGroupNumberRange')))
    _CertificateGroup_nameSubtree = CHOICE(name=u'nameSubtree', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    CertificateGroup._cont = ASN1Dict([
        (u'serialNumbers', _CertificateGroup_serialNumbers),
        (u'serialNumberRange', _CertificateGroup_serialNumberRange),
        (u'nameSubtree', _CertificateGroup_nameSubtree),
        ])
    CertificateGroup._ext = []
    
    #-----< CertificateGroupNumberRange >-----#
    CertificateGroupNumberRange = SEQ(name=u'CertificateGroupNumberRange', mode=MODE_TYPE)
    _CertificateGroupNumberRange_startingNumber = INT(name=u'startingNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CertificateGroupNumberRange_endingNumber = INT(name=u'endingNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    CertificateGroupNumberRange._cont = ASN1Dict([
        (u'startingNumber', _CertificateGroupNumberRange_startingNumber),
        (u'endingNumber', _CertificateGroupNumberRange_endingNumber),
        ])
    CertificateGroupNumberRange._ext = []
    
    #-----< CertificateSerialNumbers >-----#
    CertificateSerialNumbers = SEQ_OF(name=u'CertificateSerialNumbers', mode=MODE_TYPE)
    _CertificateSerialNumbers__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    CertificateSerialNumbers._cont = _CertificateSerialNumbers__item_
    CertificateSerialNumbers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< revokedGroups >-----#
    revokedGroups = CLASS(name=u'revokedGroups', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _revokedGroups_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'RevokedGroupsSyntax')))
    revokedGroups._val = dict([(u'ExtnType', _revokedGroups_val_ExtnType), (u'id', (2, 5, 29, 59))])
    
    #-----< RevokedGroupsSyntax >-----#
    RevokedGroupsSyntax = SEQ_OF(name=u'RevokedGroupsSyntax', mode=MODE_TYPE)
    _RevokedGroupsSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'RevokedGroup')))
    RevokedGroupsSyntax._cont = _RevokedGroupsSyntax__item_
    RevokedGroupsSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< RevokedGroup >-----#
    RevokedGroup = SEQ(name=u'RevokedGroup', mode=MODE_TYPE)
    _RevokedGroup_certificateIssuer = CHOICE(name=u'certificateIssuer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _RevokedGroup_reasonInfo = SEQ(name=u'reasonInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonInfo')), opt=True)
    _RevokedGroup_invalidityDate = TIME_GEN(name=u'invalidityDate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RevokedGroup_revokedcertificateGroup = CHOICE(name=u'revokedcertificateGroup', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'RevokedCertificateGroup')))
    RevokedGroup._cont = ASN1Dict([
        (u'certificateIssuer', _RevokedGroup_certificateIssuer),
        (u'reasonInfo', _RevokedGroup_reasonInfo),
        (u'invalidityDate', _RevokedGroup_invalidityDate),
        (u'revokedcertificateGroup', _RevokedGroup_revokedcertificateGroup),
        ])
    RevokedGroup._ext = []
    
    #-----< RevokedCertificateGroup >-----#
    RevokedCertificateGroup = CHOICE(name=u'RevokedCertificateGroup', mode=MODE_TYPE)
    _RevokedCertificateGroup_serialNumberRange = SEQ(name=u'serialNumberRange', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'NumberRange')))
    _RevokedCertificateGroup_nameSubtree = CHOICE(name=u'nameSubtree', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    RevokedCertificateGroup._cont = ASN1Dict([
        (u'serialNumberRange', _RevokedCertificateGroup_serialNumberRange),
        (u'nameSubtree', _RevokedCertificateGroup_nameSubtree),
        ])
    RevokedCertificateGroup._ext = None
    
    #-----< expiredCertsOnCRL >-----#
    expiredCertsOnCRL = CLASS(name=u'expiredCertsOnCRL', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _expiredCertsOnCRL_val_ExtnType = TIME_GEN(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'ExpiredCertsOnCRL')))
    expiredCertsOnCRL._val = dict([(u'ExtnType', _expiredCertsOnCRL_val_ExtnType), (u'id', (2, 5, 29, 60))])
    
    #-----< ExpiredCertsOnCRL >-----#
    ExpiredCertsOnCRL = TIME_GEN(name=u'ExpiredCertsOnCRL', mode=MODE_TYPE)
    
    #-----< reasonCode >-----#
    reasonCode = CLASS(name=u'reasonCode', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _reasonCode_val_ExtnType = ENUM(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLReason')))
    reasonCode._val = dict([(u'ExtnType', _reasonCode_val_ExtnType), (u'id', (2, 5, 29, 21))])
    
    #-----< CRLReason >-----#
    CRLReason = ENUM(name=u'CRLReason', mode=MODE_TYPE)
    CRLReason._cont = ASN1Dict([(u'unspecified', 0), (u'keyCompromise', 1), (u'cACompromise', 2), (u'affiliationChanged', 3), (u'superseded', 4), (u'cessationOfOperation', 5), (u'certificateHold', 6), (u'removeFromCRL', 8), (u'privilegeWithdrawn', 9), (u'aACompromise', 10), (u'weakAlgorithmOrKey', 11)])
    CRLReason._ext = [u'weakAlgorithmOrKey']
    
    #-----< holdInstructionCode >-----#
    holdInstructionCode = CLASS(name=u'holdInstructionCode', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _holdInstructionCode_val_ExtnType = OID(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'HoldInstruction')))
    holdInstructionCode._val = dict([(u'ExtnType', _holdInstructionCode_val_ExtnType), (u'id', (2, 5, 29, 23))])
    
    #-----< HoldInstruction >-----#
    HoldInstruction = OID(name=u'HoldInstruction', mode=MODE_TYPE)
    
    #-----< invalidityDate >-----#
    invalidityDate = CLASS(name=u'invalidityDate', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _invalidityDate_val_ExtnType = TIME_GEN(name=u'ExtnType', mode=MODE_TYPE)
    invalidityDate._val = dict([(u'ExtnType', _invalidityDate_val_ExtnType), (u'id', (2, 5, 29, 24))])
    
    #-----< cRLDistributionPoints >-----#
    cRLDistributionPoints = CLASS(name=u'cRLDistributionPoints', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _cRLDistributionPoints_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLDistPointsSyntax')))
    cRLDistributionPoints._val = dict([(u'ExtnType', _cRLDistributionPoints_val_ExtnType), (u'id', (2, 5, 29, 31))])
    
    #-----< CRLDistPointsSyntax >-----#
    CRLDistPointsSyntax = SEQ_OF(name=u'CRLDistPointsSyntax', mode=MODE_TYPE)
    _CRLDistPointsSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'DistributionPoint')))
    CRLDistPointsSyntax._cont = _CRLDistPointsSyntax__item_
    CRLDistPointsSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< DistributionPoint >-----#
    DistributionPoint = SEQ(name=u'DistributionPoint', mode=MODE_TYPE)
    _DistributionPoint_distributionPoint = CHOICE(name=u'distributionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    _DistributionPoint_reasons = BIT_STR(name=u'reasons', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonFlags')), opt=True)
    _DistributionPoint_cRLIssuer = SEQ_OF(name=u'cRLIssuer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    DistributionPoint._cont = ASN1Dict([
        (u'distributionPoint', _DistributionPoint_distributionPoint),
        (u'reasons', _DistributionPoint_reasons),
        (u'cRLIssuer', _DistributionPoint_cRLIssuer),
        ])
    DistributionPoint._ext = []
    
    #-----< DistributionPointName >-----#
    DistributionPointName = CHOICE(name=u'DistributionPointName', mode=MODE_TYPE)
    _DistributionPointName_fullName = SEQ_OF(name=u'fullName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    _DistributionPointName_nameRelativeToCRLIssuer = SET_OF(name=u'nameRelativeToCRLIssuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    DistributionPointName._cont = ASN1Dict([
        (u'fullName', _DistributionPointName_fullName),
        (u'nameRelativeToCRLIssuer', _DistributionPointName_nameRelativeToCRLIssuer),
        ])
    DistributionPointName._ext = []
    
    #-----< ReasonFlags >-----#
    ReasonFlags = BIT_STR(name=u'ReasonFlags', mode=MODE_TYPE)
    ReasonFlags._cont = ASN1Dict([(u'unused', 0), (u'keyCompromise', 1), (u'cACompromise', 2), (u'affiliationChanged', 3), (u'superseded', 4), (u'cessationOfOperation', 5), (u'certificateHold', 6), (u'privilegeWithdrawn', 7), (u'aACompromise', 8), (u'weakAlgorithmOrKey', 9)])
    
    #-----< issuingDistributionPoint >-----#
    issuingDistributionPoint = CLASS(name=u'issuingDistributionPoint', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _issuingDistributionPoint_val_ExtnType = SEQ(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'IssuingDistPointSyntax')))
    issuingDistributionPoint._val = dict([(u'ExtnType', _issuingDistributionPoint_val_ExtnType), (u'id', (2, 5, 29, 28))])
    
    #-----< IssuingDistPointSyntax >-----#
    IssuingDistPointSyntax = SEQ(name=u'IssuingDistPointSyntax', mode=MODE_TYPE)
    _IssuingDistPointSyntax_distributionPoint = CHOICE(name=u'distributionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    _IssuingDistPointSyntax_onlyContainsUserPublicKeyCerts = BOOL(name=u'onlyContainsUserPublicKeyCerts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _IssuingDistPointSyntax_onlyContainsCACerts = BOOL(name=u'onlyContainsCACerts', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _IssuingDistPointSyntax_onlySomeReasons = BIT_STR(name=u'onlySomeReasons', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonFlags')), opt=True)
    _IssuingDistPointSyntax_indirectCRL = BOOL(name=u'indirectCRL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _IssuingDistPointSyntax_onlyContainsAttributeCerts = BOOL(name=u'onlyContainsAttributeCerts', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    IssuingDistPointSyntax._cont = ASN1Dict([
        (u'distributionPoint', _IssuingDistPointSyntax_distributionPoint),
        (u'onlyContainsUserPublicKeyCerts', _IssuingDistPointSyntax_onlyContainsUserPublicKeyCerts),
        (u'onlyContainsCACerts', _IssuingDistPointSyntax_onlyContainsCACerts),
        (u'onlySomeReasons', _IssuingDistPointSyntax_onlySomeReasons),
        (u'indirectCRL', _IssuingDistPointSyntax_indirectCRL),
        (u'onlyContainsAttributeCerts', _IssuingDistPointSyntax_onlyContainsAttributeCerts),
        ])
    IssuingDistPointSyntax._ext = []
    
    #-----< certificateIssuer >-----#
    certificateIssuer = CLASS(name=u'certificateIssuer', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _certificateIssuer_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')))
    certificateIssuer._val = dict([(u'ExtnType', _certificateIssuer_val_ExtnType), (u'id', (2, 5, 29, 29))])
    
    #-----< deltaCRLIndicator >-----#
    deltaCRLIndicator = CLASS(name=u'deltaCRLIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _deltaCRLIndicator_val_ExtnType = INT(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'BaseCRLNumber')))
    deltaCRLIndicator._val = dict([(u'ExtnType', _deltaCRLIndicator_val_ExtnType), (u'id', (2, 5, 29, 27))])
    
    #-----< BaseCRLNumber >-----#
    BaseCRLNumber = INT(name=u'BaseCRLNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLNumber')))
    
    #-----< baseUpdateTime >-----#
    baseUpdateTime = CLASS(name=u'baseUpdateTime', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _baseUpdateTime_val_ExtnType = TIME_GEN(name=u'ExtnType', mode=MODE_TYPE)
    baseUpdateTime._val = dict([(u'ExtnType', _baseUpdateTime_val_ExtnType), (u'id', (2, 5, 29, 51))])
    
    #-----< freshestCRL >-----#
    freshestCRL = CLASS(name=u'freshestCRL', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _freshestCRL_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CRLDistPointsSyntax')))
    freshestCRL._val = dict([(u'ExtnType', _freshestCRL_val_ExtnType), (u'id', (2, 5, 29, 46))])
    
    #-----< aAissuingDistributionPoint >-----#
    aAissuingDistributionPoint = CLASS(name=u'aAissuingDistributionPoint', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _aAissuingDistributionPoint_val_ExtnType = SEQ(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'AAIssuingDistPointSyntax')))
    aAissuingDistributionPoint._val = dict([(u'ExtnType', _aAissuingDistributionPoint_val_ExtnType), (u'id', (2, 5, 29, 63))])
    
    #-----< AAIssuingDistPointSyntax >-----#
    AAIssuingDistPointSyntax = SEQ(name=u'AAIssuingDistPointSyntax', mode=MODE_TYPE)
    _AAIssuingDistPointSyntax_distributionPoint = CHOICE(name=u'distributionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    _AAIssuingDistPointSyntax_onlySomeReasons = BIT_STR(name=u'onlySomeReasons', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'ReasonFlags')), opt=True)
    _AAIssuingDistPointSyntax_indirectCRL = BOOL(name=u'indirectCRL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _AAIssuingDistPointSyntax_containsUserAttributeCerts = BOOL(name=u'containsUserAttributeCerts', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _AAIssuingDistPointSyntax_containsAACerts = BOOL(name=u'containsAACerts', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _AAIssuingDistPointSyntax_containsSOAPublicKeyCerts = BOOL(name=u'containsSOAPublicKeyCerts', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    AAIssuingDistPointSyntax._cont = ASN1Dict([
        (u'distributionPoint', _AAIssuingDistPointSyntax_distributionPoint),
        (u'onlySomeReasons', _AAIssuingDistPointSyntax_onlySomeReasons),
        (u'indirectCRL', _AAIssuingDistPointSyntax_indirectCRL),
        (u'containsUserAttributeCerts', _AAIssuingDistPointSyntax_containsUserAttributeCerts),
        (u'containsAACerts', _AAIssuingDistPointSyntax_containsAACerts),
        (u'containsSOAPublicKeyCerts', _AAIssuingDistPointSyntax_containsSOAPublicKeyCerts),
        ])
    AAIssuingDistPointSyntax._ext = []
    
    #-----< certificateExactMatch >-----#
    certificateExactMatch = CLASS(name=u'certificateExactMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificateExactMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateExactAssertion')))
    certificateExactMatch._val = dict([(u'AssertionType', _certificateExactMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 1)), (u'ldapName', [u'certificateExactMatch']), (u'ldapDesc', u'X.509 Certificate Exact Match'), (u'id', (2, 5, 13, 34))])
    
    #-----< CertificateExactAssertion >-----#
    CertificateExactAssertion = SEQ(name=u'CertificateExactAssertion', mode=MODE_TYPE)
    _CertificateExactAssertion_serialNumber = INT(name=u'serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    _CertificateExactAssertion_issuer = CHOICE(name=u'issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    CertificateExactAssertion._cont = ASN1Dict([
        (u'serialNumber', _CertificateExactAssertion_serialNumber),
        (u'issuer', _CertificateExactAssertion_issuer),
        ])
    CertificateExactAssertion._ext = []
    
    #-----< certificateMatch >-----#
    certificateMatch = CLASS(name=u'certificateMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificateMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateAssertion')))
    certificateMatch._val = dict([(u'AssertionType', _certificateMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 2)), (u'ldapName', [u'certificateMatch']), (u'ldapDesc', u'X.509 Certificate Match'), (u'id', (2, 5, 13, 35))])
    
    #-----< CertificateAssertion >-----#
    CertificateAssertion = SEQ(name=u'CertificateAssertion', mode=MODE_TYPE)
    _CertificateAssertion_serialNumber = INT(name=u'serialNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')), opt=True)
    _CertificateAssertion_issuer = CHOICE(name=u'issuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _CertificateAssertion_subjectKeyIdentifier = OCT_STR(name=u'subjectKeyIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'SubjectKeyIdentifier')), opt=True)
    _CertificateAssertion_authorityKeyIdentifier = SEQ(name=u'authorityKeyIdentifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'AuthorityKeyIdentifier')), opt=True)
    _CertificateAssertion_certificateValid = CHOICE(name=u'certificateValid', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Time')), opt=True)
    _CertificateAssertion_privateKeyValid = TIME_GEN(name=u'privateKeyValid', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CertificateAssertion_subjectPublicKeyAlgID = OID(name=u'subjectPublicKeyAlgID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CertificateAssertion_keyUsage = BIT_STR(name=u'keyUsage', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'KeyUsage')), opt=True)
    _CertificateAssertion_subjectAltName = CHOICE(name=u'subjectAltName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'AltNameType')), opt=True)
    _CertificateAssertion_policy = SEQ_OF(name=u'policy', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertPolicySet')), opt=True)
    _CertificateAssertion_pathToName = CHOICE(name=u'pathToName', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _CertificateAssertion_subject = CHOICE(name=u'subject', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _CertificateAssertion_nameConstraints = SEQ(name=u'nameConstraints', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'NameConstraintsSyntax')), opt=True)
    CertificateAssertion._cont = ASN1Dict([
        (u'serialNumber', _CertificateAssertion_serialNumber),
        (u'issuer', _CertificateAssertion_issuer),
        (u'subjectKeyIdentifier', _CertificateAssertion_subjectKeyIdentifier),
        (u'authorityKeyIdentifier', _CertificateAssertion_authorityKeyIdentifier),
        (u'certificateValid', _CertificateAssertion_certificateValid),
        (u'privateKeyValid', _CertificateAssertion_privateKeyValid),
        (u'subjectPublicKeyAlgID', _CertificateAssertion_subjectPublicKeyAlgID),
        (u'keyUsage', _CertificateAssertion_keyUsage),
        (u'subjectAltName', _CertificateAssertion_subjectAltName),
        (u'policy', _CertificateAssertion_policy),
        (u'pathToName', _CertificateAssertion_pathToName),
        (u'subject', _CertificateAssertion_subject),
        (u'nameConstraints', _CertificateAssertion_nameConstraints),
        ])
    CertificateAssertion._ext = []
    
    #-----< AltNameType >-----#
    AltNameType = CHOICE(name=u'AltNameType', mode=MODE_TYPE)
    _AltNameType_builtinNameForm = ENUM(name=u'builtinNameForm', mode=MODE_TYPE)
    _AltNameType_builtinNameForm._cont = ASN1Dict([(u'rfc822Name', 1), (u'dNSName', 2), (u'x400Address', 3), (u'directoryName', 4), (u'ediPartyName', 5), (u'uniformResourceIdentifier', 6), (u'iPAddress', 7), (u'registeredId', 8)])
    _AltNameType_builtinNameForm._ext = []
    _AltNameType_otherNameForm = OID(name=u'otherNameForm', mode=MODE_TYPE)
    AltNameType._cont = ASN1Dict([
        (u'builtinNameForm', _AltNameType_builtinNameForm),
        (u'otherNameForm', _AltNameType_otherNameForm),
        ])
    AltNameType._ext = []
    
    #-----< CertPolicySet >-----#
    CertPolicySet = SEQ_OF(name=u'CertPolicySet', mode=MODE_TYPE)
    _CertPolicySet__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertPolicyId')))
    CertPolicySet._cont = _CertPolicySet__item_
    CertPolicySet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< certificatePairExactMatch >-----#
    certificatePairExactMatch = CLASS(name=u'certificatePairExactMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificatePairExactMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePairExactAssertion')))
    certificatePairExactMatch._val = dict([(u'AssertionType', _certificatePairExactMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 3)), (u'ldapName', [u'certificatePairExactMatch']), (u'ldapDesc', u'X.509 Certificate Pair Exact Match'), (u'id', (2, 5, 13, 36))])
    
    #-----< CertificatePairExactAssertion >-----#
    CertificatePairExactAssertion = SEQ(name=u'CertificatePairExactAssertion', mode=MODE_TYPE)
    _CertificatePairExactAssertion_issuedToThisCAAssertion = SEQ(name=u'issuedToThisCAAssertion', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateExactAssertion')), opt=True)
    _CertificatePairExactAssertion_issuedByThisCAAssertion = SEQ(name=u'issuedByThisCAAssertion', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateExactAssertion')), opt=True)
    CertificatePairExactAssertion._cont = ASN1Dict([
        (u'issuedToThisCAAssertion', _CertificatePairExactAssertion_issuedToThisCAAssertion),
        (u'issuedByThisCAAssertion', _CertificatePairExactAssertion_issuedByThisCAAssertion),
        ])
    CertificatePairExactAssertion._ext = []
    
    #-----< certificatePairMatch >-----#
    certificatePairMatch = CLASS(name=u'certificatePairMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificatePairMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePairAssertion')))
    certificatePairMatch._val = dict([(u'AssertionType', _certificatePairMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 4)), (u'ldapName', [u'certificatePairMatch']), (u'ldapDesc', u'X.509 Certificate Pair Match'), (u'id', (2, 5, 13, 37))])
    
    #-----< CertificatePairAssertion >-----#
    CertificatePairAssertion = SEQ(name=u'CertificatePairAssertion', mode=MODE_TYPE)
    _CertificatePairAssertion_issuedToThisCAAssertion = SEQ(name=u'issuedToThisCAAssertion', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateAssertion')), opt=True)
    _CertificatePairAssertion_issuedByThisCAAssertion = SEQ(name=u'issuedByThisCAAssertion', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertificateAssertion')), opt=True)
    CertificatePairAssertion._cont = ASN1Dict([
        (u'issuedToThisCAAssertion', _CertificatePairAssertion_issuedToThisCAAssertion),
        (u'issuedByThisCAAssertion', _CertificatePairAssertion_issuedByThisCAAssertion),
        ])
    CertificatePairAssertion._ext = []
    
    #-----< certificateListExactMatch >-----#
    certificateListExactMatch = CLASS(name=u'certificateListExactMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificateListExactMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListExactAssertion')))
    certificateListExactMatch._val = dict([(u'AssertionType', _certificateListExactMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 5)), (u'ldapName', [u'certificateListExactMatch']), (u'ldapDesc', u'X.509 Certificate List Exact Match'), (u'id', (2, 5, 13, 38))])
    
    #-----< CertificateListExactAssertion >-----#
    CertificateListExactAssertion = SEQ(name=u'CertificateListExactAssertion', mode=MODE_TYPE)
    _CertificateListExactAssertion_issuer = CHOICE(name=u'issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _CertificateListExactAssertion_thisUpdate = CHOICE(name=u'thisUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')))
    _CertificateListExactAssertion_distributionPoint = CHOICE(name=u'distributionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    CertificateListExactAssertion._cont = ASN1Dict([
        (u'issuer', _CertificateListExactAssertion_issuer),
        (u'thisUpdate', _CertificateListExactAssertion_thisUpdate),
        (u'distributionPoint', _CertificateListExactAssertion_distributionPoint),
        ])
    CertificateListExactAssertion._ext = None
    
    #-----< certificateListMatch >-----#
    certificateListMatch = CLASS(name=u'certificateListMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _certificateListMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListAssertion')))
    certificateListMatch._val = dict([(u'AssertionType', _certificateListMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 6)), (u'ldapName', [u'certificateListMatch']), (u'ldapDesc', u'X.509 Certificate List Match'), (u'id', (2, 5, 13, 39))])
    
    #-----< CertificateListAssertion >-----#
    CertificateListAssertion = SEQ(name=u'CertificateListAssertion', mode=MODE_TYPE)
    _CertificateListAssertion_issuer = CHOICE(name=u'issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _CertificateListAssertion_minCRLNumber = INT(name=u'minCRLNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CRLNumber')), opt=True)
    _CertificateListAssertion_maxCRLNumber = INT(name=u'maxCRLNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CRLNumber')), opt=True)
    _CertificateListAssertion_reasonFlags = BIT_STR(name=u'reasonFlags', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'ReasonFlags')), opt=True)
    _CertificateListAssertion_dateAndTime = CHOICE(name=u'dateAndTime', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'Time')), opt=True)
    _CertificateListAssertion_distributionPoint = CHOICE(name=u'distributionPoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'DistributionPointName')), opt=True)
    _CertificateListAssertion_authorityKeyIdentifier = SEQ(name=u'authorityKeyIdentifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'AuthorityKeyIdentifier')), opt=True)
    CertificateListAssertion._cont = ASN1Dict([
        (u'issuer', _CertificateListAssertion_issuer),
        (u'minCRLNumber', _CertificateListAssertion_minCRLNumber),
        (u'maxCRLNumber', _CertificateListAssertion_maxCRLNumber),
        (u'reasonFlags', _CertificateListAssertion_reasonFlags),
        (u'dateAndTime', _CertificateListAssertion_dateAndTime),
        (u'distributionPoint', _CertificateListAssertion_distributionPoint),
        (u'authorityKeyIdentifier', _CertificateListAssertion_authorityKeyIdentifier),
        ])
    CertificateListAssertion._ext = []
    
    #-----< algorithmIdentifierMatch >-----#
    algorithmIdentifierMatch = CLASS(name=u'algorithmIdentifierMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _algorithmIdentifierMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __algorithmIdentifierMatch_val_AssertionType_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___algorithmIdentifierMatch_val_AssertionType_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___algorithmIdentifierMatch_val_AssertionType_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __algorithmIdentifierMatch_val_AssertionType_algorithm._const_tab = ___algorithmIdentifierMatch_val_AssertionType_algorithm_tab
    __algorithmIdentifierMatch_val_AssertionType_algorithm._const_tab_at = None
    __algorithmIdentifierMatch_val_AssertionType_algorithm._const_tab_id = u'id'
    __algorithmIdentifierMatch_val_AssertionType_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___algorithmIdentifierMatch_val_AssertionType_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___algorithmIdentifierMatch_val_AssertionType_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __algorithmIdentifierMatch_val_AssertionType_parameters._const_tab = ___algorithmIdentifierMatch_val_AssertionType_parameters_tab
    __algorithmIdentifierMatch_val_AssertionType_parameters._const_tab_at = ('..', u'algorithm')
    __algorithmIdentifierMatch_val_AssertionType_parameters._const_tab_id = u'Type'
    _algorithmIdentifierMatch_val_AssertionType._cont = ASN1Dict([
        (u'algorithm', __algorithmIdentifierMatch_val_AssertionType_algorithm),
        (u'parameters', __algorithmIdentifierMatch_val_AssertionType_parameters),
        ])
    _algorithmIdentifierMatch_val_AssertionType._ext = []
    algorithmIdentifierMatch._val = dict([(u'AssertionType', _algorithmIdentifierMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 1, 15, 7)), (u'ldapName', [u'algorithmIdentifierMatch']), (u'ldapDesc', u'X.509 Algorithm Identifier Match'), (u'id', (2, 5, 13, 40))])
    
    #-----< policyMatch >-----#
    policyMatch = CLASS(name=u'policyMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _policyMatch_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'PolicyID')))
    policyMatch._val = dict([(u'AssertionType', _policyMatch_val_AssertionType), (u'id', (2, 5, 13, 60))])
    
    #-----< pkiPathMatch >-----#
    pkiPathMatch = CLASS(name=u'pkiPathMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _pkiPathMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'PkiPathMatchSyntax')))
    pkiPathMatch._val = dict([(u'AssertionType', _pkiPathMatch_val_AssertionType), (u'id', (2, 5, 13, 62))])
    
    #-----< PkiPathMatchSyntax >-----#
    PkiPathMatchSyntax = SEQ(name=u'PkiPathMatchSyntax', mode=MODE_TYPE)
    _PkiPathMatchSyntax_firstIssuer = CHOICE(name=u'firstIssuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _PkiPathMatchSyntax_lastSubject = CHOICE(name=u'lastSubject', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    PkiPathMatchSyntax._cont = ASN1Dict([
        (u'firstIssuer', _PkiPathMatchSyntax_firstIssuer),
        (u'lastSubject', _PkiPathMatchSyntax_lastSubject),
        ])
    PkiPathMatchSyntax._ext = []
    
    #-----< enhancedCertificateMatch >-----#
    enhancedCertificateMatch = CLASS(name=u'enhancedCertificateMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _enhancedCertificateMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'EnhancedCertificateAssertion')))
    enhancedCertificateMatch._val = dict([(u'AssertionType', _enhancedCertificateMatch_val_AssertionType), (u'id', (2, 5, 13, 65))])
    
    #-----< EnhancedCertificateAssertion >-----#
    EnhancedCertificateAssertion = SEQ(name=u'EnhancedCertificateAssertion', mode=MODE_TYPE)
    _EnhancedCertificateAssertion_serialNumber = INT(name=u'serialNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')), opt=True)
    _EnhancedCertificateAssertion_issuer = CHOICE(name=u'issuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _EnhancedCertificateAssertion_subjectKeyIdentifier = OCT_STR(name=u'subjectKeyIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'SubjectKeyIdentifier')), opt=True)
    _EnhancedCertificateAssertion_authorityKeyIdentifier = SEQ(name=u'authorityKeyIdentifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'AuthorityKeyIdentifier')), opt=True)
    _EnhancedCertificateAssertion_certificateValid = CHOICE(name=u'certificateValid', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Time')), opt=True)
    _EnhancedCertificateAssertion_privateKeyValid = TIME_GEN(name=u'privateKeyValid', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancedCertificateAssertion_subjectPublicKeyAlgID = OID(name=u'subjectPublicKeyAlgID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EnhancedCertificateAssertion_keyUsage = BIT_STR(name=u'keyUsage', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'KeyUsage')), opt=True)
    _EnhancedCertificateAssertion_subjectAltName = SEQ(name=u'subjectAltName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'AltName')), opt=True)
    _EnhancedCertificateAssertion_policy = SEQ_OF(name=u'policy', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'CertPolicySet')), opt=True)
    _EnhancedCertificateAssertion_pathToName = SEQ_OF(name=u'pathToName', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'GeneralNames')), opt=True)
    _EnhancedCertificateAssertion_subject = CHOICE(name=u'subject', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _EnhancedCertificateAssertion_nameConstraints = SEQ(name=u'nameConstraints', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CertificateExtensions', 'NameConstraintsSyntax')), opt=True)
    EnhancedCertificateAssertion._cont = ASN1Dict([
        (u'serialNumber', _EnhancedCertificateAssertion_serialNumber),
        (u'issuer', _EnhancedCertificateAssertion_issuer),
        (u'subjectKeyIdentifier', _EnhancedCertificateAssertion_subjectKeyIdentifier),
        (u'authorityKeyIdentifier', _EnhancedCertificateAssertion_authorityKeyIdentifier),
        (u'certificateValid', _EnhancedCertificateAssertion_certificateValid),
        (u'privateKeyValid', _EnhancedCertificateAssertion_privateKeyValid),
        (u'subjectPublicKeyAlgID', _EnhancedCertificateAssertion_subjectPublicKeyAlgID),
        (u'keyUsage', _EnhancedCertificateAssertion_keyUsage),
        (u'subjectAltName', _EnhancedCertificateAssertion_subjectAltName),
        (u'policy', _EnhancedCertificateAssertion_policy),
        (u'pathToName', _EnhancedCertificateAssertion_pathToName),
        (u'subject', _EnhancedCertificateAssertion_subject),
        (u'nameConstraints', _EnhancedCertificateAssertion_nameConstraints),
        ])
    EnhancedCertificateAssertion._ext = []
    
    #-----< AltName >-----#
    AltName = SEQ(name=u'AltName', mode=MODE_TYPE)
    _AltName_altnameType = CHOICE(name=u'altnameType', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'AltNameType')))
    _AltName_altNameValue = CHOICE(name=u'altNameValue', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    AltName._cont = ASN1Dict([
        (u'altnameType', _AltName_altnameType),
        (u'altNameValue', _AltName_altNameValue),
        ])
    AltName._ext = None
    
    #-----< certExactAssertion >-----#
    certExactAssertion = CLASS(name=u'certExactAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certExactAssertion_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateExactAssertion')))
    certExactAssertion._val = dict([(u'ldapDesc', u'X.509 Certificate Exact Assertion'), (u'Type', _certExactAssertion_val_Type), (u'id', (1, 3, 6, 1, 1, 15, 1))])
    
    #-----< certAssertion >-----#
    certAssertion = CLASS(name=u'certAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certAssertion_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateAssertion')))
    certAssertion._val = dict([(u'ldapDesc', u'X.509 Certificate Assertion'), (u'Type', _certAssertion_val_Type), (u'id', (1, 3, 6, 1, 1, 15, 2))])
    
    #-----< certPairExactAssertion >-----#
    certPairExactAssertion = CLASS(name=u'certPairExactAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certPairExactAssertion_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePairExactAssertion')))
    certPairExactAssertion._val = dict([(u'ldapDesc', u'X.509 Certificate Pair Exact Assertion'), (u'Type', _certPairExactAssertion_val_Type), (u'id', (1, 3, 6, 1, 1, 15, 3))])
    
    #-----< certPairAssertion >-----#
    certPairAssertion = CLASS(name=u'certPairAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certPairAssertion_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificatePairAssertion')))
    certPairAssertion._val = dict([(u'ldapDesc', u'X.509 Certificate Pair Assertion'), (u'Type', _certPairAssertion_val_Type), (u'id', (1, 3, 6, 1, 1, 15, 4))])
    
    #-----< certListExactAssertion >-----#
    certListExactAssertion = CLASS(name=u'certListExactAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certListExactAssertion_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListExactAssertion')))
    certListExactAssertion._val = dict([(u'ldapDesc', u'X.509 Certificate List Exact Assertion'), (u'Type', _certListExactAssertion_val_Type), (u'id', (1, 3, 6, 1, 1, 15, 5))])
    
    #-----< certListAssertion >-----#
    certListAssertion = CLASS(name=u'certListAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _certListAssertion_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'CertificateListAssertion')))
    certListAssertion._val = dict([(u'ldapDesc', u'X.509 Certificate List Assertion'), (u'Type', _certListAssertion_val_Type), (u'id', (1, 3, 6, 1, 1, 15, 6))])
    
    #-----< algorithmIdentifier >-----#
    algorithmIdentifier = CLASS(name=u'algorithmIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _algorithmIdentifier_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __algorithmIdentifier_val_Type_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___algorithmIdentifier_val_Type_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___algorithmIdentifier_val_Type_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __algorithmIdentifier_val_Type_algorithm._const_tab = ___algorithmIdentifier_val_Type_algorithm_tab
    __algorithmIdentifier_val_Type_algorithm._const_tab_at = None
    __algorithmIdentifier_val_Type_algorithm._const_tab_id = u'id'
    __algorithmIdentifier_val_Type_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___algorithmIdentifier_val_Type_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___algorithmIdentifier_val_Type_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __algorithmIdentifier_val_Type_parameters._const_tab = ___algorithmIdentifier_val_Type_parameters_tab
    __algorithmIdentifier_val_Type_parameters._const_tab_at = ('..', u'algorithm')
    __algorithmIdentifier_val_Type_parameters._const_tab_id = u'Type'
    _algorithmIdentifier_val_Type._cont = ASN1Dict([
        (u'algorithm', __algorithmIdentifier_val_Type_algorithm),
        (u'parameters', __algorithmIdentifier_val_Type_parameters),
        ])
    _algorithmIdentifier_val_Type._ext = []
    algorithmIdentifier._val = dict([(u'ldapDesc', u'X.509 Algorithm Identifier'), (u'Type', _algorithmIdentifier_val_Type), (u'id', (1, 3, 6, 1, 1, 15, 7))])
    
    #-----< id-ce-subjectDirectoryAttributes >-----#
    id_ce_subjectDirectoryAttributes = OID(name=u'id-ce-subjectDirectoryAttributes', mode=MODE_VALUE)
    id_ce_subjectDirectoryAttributes._val = (2, 5, 29, 9)
    
    #-----< id-ce-subjectKeyIdentifier >-----#
    id_ce_subjectKeyIdentifier = OID(name=u'id-ce-subjectKeyIdentifier', mode=MODE_VALUE)
    id_ce_subjectKeyIdentifier._val = (2, 5, 29, 14)
    
    #-----< id-ce-keyUsage >-----#
    id_ce_keyUsage = OID(name=u'id-ce-keyUsage', mode=MODE_VALUE)
    id_ce_keyUsage._val = (2, 5, 29, 15)
    
    #-----< id-ce-privateKeyUsagePeriod >-----#
    id_ce_privateKeyUsagePeriod = OID(name=u'id-ce-privateKeyUsagePeriod', mode=MODE_VALUE)
    id_ce_privateKeyUsagePeriod._val = (2, 5, 29, 16)
    
    #-----< id-ce-subjectAltName >-----#
    id_ce_subjectAltName = OID(name=u'id-ce-subjectAltName', mode=MODE_VALUE)
    id_ce_subjectAltName._val = (2, 5, 29, 17)
    
    #-----< id-ce-issuerAltName >-----#
    id_ce_issuerAltName = OID(name=u'id-ce-issuerAltName', mode=MODE_VALUE)
    id_ce_issuerAltName._val = (2, 5, 29, 18)
    
    #-----< id-ce-basicConstraints >-----#
    id_ce_basicConstraints = OID(name=u'id-ce-basicConstraints', mode=MODE_VALUE)
    id_ce_basicConstraints._val = (2, 5, 29, 19)
    
    #-----< id-ce-cRLNumber >-----#
    id_ce_cRLNumber = OID(name=u'id-ce-cRLNumber', mode=MODE_VALUE)
    id_ce_cRLNumber._val = (2, 5, 29, 20)
    
    #-----< id-ce-reasonCode >-----#
    id_ce_reasonCode = OID(name=u'id-ce-reasonCode', mode=MODE_VALUE)
    id_ce_reasonCode._val = (2, 5, 29, 21)
    
    #-----< id-ce-holdInstructionCode >-----#
    id_ce_holdInstructionCode = OID(name=u'id-ce-holdInstructionCode', mode=MODE_VALUE)
    id_ce_holdInstructionCode._val = (2, 5, 29, 23)
    
    #-----< id-ce-invalidityDate >-----#
    id_ce_invalidityDate = OID(name=u'id-ce-invalidityDate', mode=MODE_VALUE)
    id_ce_invalidityDate._val = (2, 5, 29, 24)
    
    #-----< id-ce-deltaCRLIndicator >-----#
    id_ce_deltaCRLIndicator = OID(name=u'id-ce-deltaCRLIndicator', mode=MODE_VALUE)
    id_ce_deltaCRLIndicator._val = (2, 5, 29, 27)
    
    #-----< id-ce-issuingDistributionPoint >-----#
    id_ce_issuingDistributionPoint = OID(name=u'id-ce-issuingDistributionPoint', mode=MODE_VALUE)
    id_ce_issuingDistributionPoint._val = (2, 5, 29, 28)
    
    #-----< id-ce-certificateIssuer >-----#
    id_ce_certificateIssuer = OID(name=u'id-ce-certificateIssuer', mode=MODE_VALUE)
    id_ce_certificateIssuer._val = (2, 5, 29, 29)
    
    #-----< id-ce-nameConstraints >-----#
    id_ce_nameConstraints = OID(name=u'id-ce-nameConstraints', mode=MODE_VALUE)
    id_ce_nameConstraints._val = (2, 5, 29, 30)
    
    #-----< id-ce-cRLDistributionPoints >-----#
    id_ce_cRLDistributionPoints = OID(name=u'id-ce-cRLDistributionPoints', mode=MODE_VALUE)
    id_ce_cRLDistributionPoints._val = (2, 5, 29, 31)
    
    #-----< id-ce-certificatePolicies >-----#
    id_ce_certificatePolicies = OID(name=u'id-ce-certificatePolicies', mode=MODE_VALUE)
    id_ce_certificatePolicies._val = (2, 5, 29, 32)
    
    #-----< id-ce-policyMappings >-----#
    id_ce_policyMappings = OID(name=u'id-ce-policyMappings', mode=MODE_VALUE)
    id_ce_policyMappings._val = (2, 5, 29, 33)
    
    #-----< id-ce-authorityKeyIdentifier >-----#
    id_ce_authorityKeyIdentifier = OID(name=u'id-ce-authorityKeyIdentifier', mode=MODE_VALUE)
    id_ce_authorityKeyIdentifier._val = (2, 5, 29, 35)
    
    #-----< id-ce-policyConstraints >-----#
    id_ce_policyConstraints = OID(name=u'id-ce-policyConstraints', mode=MODE_VALUE)
    id_ce_policyConstraints._val = (2, 5, 29, 36)
    
    #-----< id-ce-extKeyUsage >-----#
    id_ce_extKeyUsage = OID(name=u'id-ce-extKeyUsage', mode=MODE_VALUE)
    id_ce_extKeyUsage._val = (2, 5, 29, 37)
    
    #-----< id-ce-cRLStreamIdentifier >-----#
    id_ce_cRLStreamIdentifier = OID(name=u'id-ce-cRLStreamIdentifier', mode=MODE_VALUE)
    id_ce_cRLStreamIdentifier._val = (2, 5, 29, 40)
    
    #-----< id-ce-cRLScope >-----#
    id_ce_cRLScope = OID(name=u'id-ce-cRLScope', mode=MODE_VALUE)
    id_ce_cRLScope._val = (2, 5, 29, 44)
    
    #-----< id-ce-statusReferrals >-----#
    id_ce_statusReferrals = OID(name=u'id-ce-statusReferrals', mode=MODE_VALUE)
    id_ce_statusReferrals._val = (2, 5, 29, 45)
    
    #-----< id-ce-freshestCRL >-----#
    id_ce_freshestCRL = OID(name=u'id-ce-freshestCRL', mode=MODE_VALUE)
    id_ce_freshestCRL._val = (2, 5, 29, 46)
    
    #-----< id-ce-orderedList >-----#
    id_ce_orderedList = OID(name=u'id-ce-orderedList', mode=MODE_VALUE)
    id_ce_orderedList._val = (2, 5, 29, 47)
    
    #-----< id-ce-baseUpdateTime >-----#
    id_ce_baseUpdateTime = OID(name=u'id-ce-baseUpdateTime', mode=MODE_VALUE)
    id_ce_baseUpdateTime._val = (2, 5, 29, 51)
    
    #-----< id-ce-deltaInfo >-----#
    id_ce_deltaInfo = OID(name=u'id-ce-deltaInfo', mode=MODE_VALUE)
    id_ce_deltaInfo._val = (2, 5, 29, 53)
    
    #-----< id-ce-inhibitAnyPolicy >-----#
    id_ce_inhibitAnyPolicy = OID(name=u'id-ce-inhibitAnyPolicy', mode=MODE_VALUE)
    id_ce_inhibitAnyPolicy._val = (2, 5, 29, 54)
    
    #-----< id-ce-toBeRevoked >-----#
    id_ce_toBeRevoked = OID(name=u'id-ce-toBeRevoked', mode=MODE_VALUE)
    id_ce_toBeRevoked._val = (2, 5, 29, 58)
    
    #-----< id-ce-revokedGroups >-----#
    id_ce_revokedGroups = OID(name=u'id-ce-revokedGroups', mode=MODE_VALUE)
    id_ce_revokedGroups._val = (2, 5, 29, 59)
    
    #-----< id-ce-expiredCertsOnCRL >-----#
    id_ce_expiredCertsOnCRL = OID(name=u'id-ce-expiredCertsOnCRL', mode=MODE_VALUE)
    id_ce_expiredCertsOnCRL._val = (2, 5, 29, 60)
    
    #-----< id-ce-aAissuingDistributionPoint >-----#
    id_ce_aAissuingDistributionPoint = OID(name=u'id-ce-aAissuingDistributionPoint', mode=MODE_VALUE)
    id_ce_aAissuingDistributionPoint._val = (2, 5, 29, 63)
    
    #-----< id-ce-authorizationValidation >-----#
    id_ce_authorizationValidation = OID(name=u'id-ce-authorizationValidation', mode=MODE_VALUE)
    id_ce_authorizationValidation._val = (2, 5, 29, 70)
    
    #-----< id-mr-certificateExactMatch >-----#
    id_mr_certificateExactMatch = OID(name=u'id-mr-certificateExactMatch', mode=MODE_VALUE)
    id_mr_certificateExactMatch._val = (2, 5, 13, 34)
    
    #-----< id-mr-certificateMatch >-----#
    id_mr_certificateMatch = OID(name=u'id-mr-certificateMatch', mode=MODE_VALUE)
    id_mr_certificateMatch._val = (2, 5, 13, 35)
    
    #-----< id-mr-certificatePairExactMatch >-----#
    id_mr_certificatePairExactMatch = OID(name=u'id-mr-certificatePairExactMatch', mode=MODE_VALUE)
    id_mr_certificatePairExactMatch._val = (2, 5, 13, 36)
    
    #-----< id-mr-certificatePairMatch >-----#
    id_mr_certificatePairMatch = OID(name=u'id-mr-certificatePairMatch', mode=MODE_VALUE)
    id_mr_certificatePairMatch._val = (2, 5, 13, 37)
    
    #-----< id-mr-certificateListExactMatch >-----#
    id_mr_certificateListExactMatch = OID(name=u'id-mr-certificateListExactMatch', mode=MODE_VALUE)
    id_mr_certificateListExactMatch._val = (2, 5, 13, 38)
    
    #-----< id-mr-certificateListMatch >-----#
    id_mr_certificateListMatch = OID(name=u'id-mr-certificateListMatch', mode=MODE_VALUE)
    id_mr_certificateListMatch._val = (2, 5, 13, 39)
    
    #-----< id-mr-algorithmIdentifierMatch >-----#
    id_mr_algorithmIdentifierMatch = OID(name=u'id-mr-algorithmIdentifierMatch', mode=MODE_VALUE)
    id_mr_algorithmIdentifierMatch._val = (2, 5, 13, 40)
    
    #-----< id-mr-policyMatch >-----#
    id_mr_policyMatch = OID(name=u'id-mr-policyMatch', mode=MODE_VALUE)
    id_mr_policyMatch._val = (2, 5, 13, 60)
    
    #-----< id-mr-pkiPathMatch >-----#
    id_mr_pkiPathMatch = OID(name=u'id-mr-pkiPathMatch', mode=MODE_VALUE)
    id_mr_pkiPathMatch._val = (2, 5, 13, 62)
    
    #-----< id-mr-enhancedCertificateMatch >-----#
    id_mr_enhancedCertificateMatch = OID(name=u'id-mr-enhancedCertificateMatch', mode=MODE_VALUE)
    id_mr_enhancedCertificateMatch._val = (2, 5, 13, 65)
    
    #-----< id-ldx-certExactAssertion >-----#
    id_ldx_certExactAssertion = OID(name=u'id-ldx-certExactAssertion', mode=MODE_VALUE)
    id_ldx_certExactAssertion._val = (1, 3, 6, 1, 1, 15, 1)
    
    #-----< id-ldx-certAssertion >-----#
    id_ldx_certAssertion = OID(name=u'id-ldx-certAssertion', mode=MODE_VALUE)
    id_ldx_certAssertion._val = (1, 3, 6, 1, 1, 15, 2)
    
    #-----< id-ldx-certPairExactAssertion >-----#
    id_ldx_certPairExactAssertion = OID(name=u'id-ldx-certPairExactAssertion', mode=MODE_VALUE)
    id_ldx_certPairExactAssertion._val = (1, 3, 6, 1, 1, 15, 3)
    
    #-----< id-ldx-certPairAssertion >-----#
    id_ldx_certPairAssertion = OID(name=u'id-ldx-certPairAssertion', mode=MODE_VALUE)
    id_ldx_certPairAssertion._val = (1, 3, 6, 1, 1, 15, 4)
    
    #-----< id-ldx-certListExactAssertion >-----#
    id_ldx_certListExactAssertion = OID(name=u'id-ldx-certListExactAssertion', mode=MODE_VALUE)
    id_ldx_certListExactAssertion._val = (1, 3, 6, 1, 1, 15, 5)
    
    #-----< id-ldx-certListAssertion >-----#
    id_ldx_certListAssertion = OID(name=u'id-ldx-certListAssertion', mode=MODE_VALUE)
    id_ldx_certListAssertion._val = (1, 3, 6, 1, 1, 15, 6)
    
    #-----< id-ldx-algorithmIdentifier >-----#
    id_ldx_algorithmIdentifier = OID(name=u'id-ldx-algorithmIdentifier', mode=MODE_VALUE)
    id_ldx_algorithmIdentifier._val = (1, 3, 6, 1, 1, 15, 7)
    
    _all_ = [
        authorityKeyIdentifier,
        _authorityKeyIdentifier_val_ExtnType,
        _AuthorityKeyIdentifier_keyIdentifier,
        _AuthorityKeyIdentifier_authorityCertIssuer,
        _AuthorityKeyIdentifier_authorityCertSerialNumber,
        AuthorityKeyIdentifier,
        KeyIdentifier,
        subjectKeyIdentifier,
        _subjectKeyIdentifier_val_ExtnType,
        SubjectKeyIdentifier,
        keyUsage,
        _keyUsage_val_ExtnType,
        KeyUsage,
        extKeyUsage,
        __extKeyUsage_val_ExtnType__item_,
        _extKeyUsage_val_ExtnType,
        KeyPurposeId,
        privateKeyUsagePeriod,
        _privateKeyUsagePeriod_val_ExtnType,
        _PrivateKeyUsagePeriod_notBefore,
        _PrivateKeyUsagePeriod_notAfter,
        PrivateKeyUsagePeriod,
        certificatePolicies,
        _certificatePolicies_val_ExtnType,
        _CertificatePoliciesSyntax__item_,
        CertificatePoliciesSyntax,
        _PolicyInformation_policyIdentifier,
        __PolicyInformation_policyQualifiers__item_,
        _PolicyInformation_policyQualifiers,
        PolicyInformation,
        CertPolicyId,
        __PolicyQualifierInfo_policyQualifierId_tab,
        _PolicyQualifierInfo_policyQualifierId,
        __PolicyQualifierInfo_qualifier_tab,
        _PolicyQualifierInfo_qualifier,
        PolicyQualifierInfo,
        SupportedPolicyQualifiers,
        anyPolicy,
        _CERT_POLICY_QUALIFIER_id,
        _CERT_POLICY_QUALIFIER_Qualifier,
        CERT_POLICY_QUALIFIER,
        policyMappings,
        _policyMappings_val_ExtnType,
        __PolicyMappingsSyntax__item__issuerDomainPolicy,
        __PolicyMappingsSyntax__item__subjectDomainPolicy,
        _PolicyMappingsSyntax__item_,
        PolicyMappingsSyntax,
        authorizationValidation,
        _authorizationValidation_val_ExtnType,
        _AvlId_issuer,
        _AvlId_serialNumber,
        AvlId,
        subjectAltName,
        _subjectAltName_val_ExtnType,
        _GeneralNames__item_,
        GeneralNames,
        __GeneralName_otherName_type_id,
        __GeneralName_otherName_value,
        _GeneralName_otherName,
        _GeneralName_otherName,
        _GeneralName_rfc822Name,
        _GeneralName_dNSName,
        _GeneralName_x400Address,
        _GeneralName_directoryName,
        _GeneralName_ediPartyName,
        _GeneralName_uniformResourceIdentifier,
        _GeneralName_iPAddress,
        _GeneralName_registeredID,
        GeneralName,
        OTHER_NAME,
        _EDIPartyName_nameAssigner,
        _EDIPartyName_partyName,
        EDIPartyName,
        issuerAltName,
        _issuerAltName_val_ExtnType,
        subjectDirectoryAttributes,
        _subjectDirectoryAttributes_val_ExtnType,
        ___AttributesSyntax__item__type_tab,
        ____AttributesSyntax__item__type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        ____AttributesSyntax__item__type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        __AttributesSyntax__item__type,
        ___AttributesSyntax__item__values__item_,
        __AttributesSyntax__item__values,
        ____AttributesSyntax__item__valuesWithContext__item__value,
        _____AttributesSyntax__item__valuesWithContext__item__contextList__item_,
        ____AttributesSyntax__item__valuesWithContext__item__contextList,
        ___AttributesSyntax__item__valuesWithContext__item_,
        __AttributesSyntax__item__valuesWithContext,
        _AttributesSyntax__item_,
        AttributesSyntax,
        basicConstraints,
        _basicConstraints_val_ExtnType,
        _BasicConstraintsSyntax_cA,
        _BasicConstraintsSyntax_pathLenConstraint,
        BasicConstraintsSyntax,
        nameConstraints,
        _nameConstraints_val_ExtnType,
        _NameConstraintsSyntax_permittedSubtrees,
        _NameConstraintsSyntax_excludedSubtrees,
        NameConstraintsSyntax,
        _GeneralSubtrees__item_,
        GeneralSubtrees,
        _GeneralSubtree_base,
        _GeneralSubtree_minimum,
        _GeneralSubtree_maximum,
        GeneralSubtree,
        BaseDistance,
        policyConstraints,
        _policyConstraints_val_ExtnType,
        _PolicyConstraintsSyntax_requireExplicitPolicy,
        _PolicyConstraintsSyntax_inhibitPolicyMapping,
        PolicyConstraintsSyntax,
        SkipCerts,
        inhibitAnyPolicy,
        _inhibitAnyPolicy_val_ExtnType,
        cRLNumber,
        _cRLNumber_val_ExtnType,
        CRLNumber,
        crlScope,
        _crlScope_val_ExtnType,
        _CRLScopeSyntax__item_,
        CRLScopeSyntax,
        _PerAuthorityScope_authorityName,
        _PerAuthorityScope_distributionPoint,
        _PerAuthorityScope_onlyContains,
        _PerAuthorityScope_onlySomeReasons,
        _PerAuthorityScope_serialNumberRange,
        _PerAuthorityScope_subjectKeyIdRange,
        _PerAuthorityScope_nameSubtrees,
        _PerAuthorityScope_baseRevocationInfo,
        PerAuthorityScope,
        OnlyCertificateTypes,
        _NumberRange_startingNumber,
        _NumberRange_endingNumber,
        _NumberRange_modulus,
        NumberRange,
        _BaseRevocationInfo_cRLStreamIdentifier,
        _BaseRevocationInfo_cRLNumber,
        _BaseRevocationInfo_baseThisUpdate,
        BaseRevocationInfo,
        statusReferrals,
        _statusReferrals_val_ExtnType,
        _StatusReferrals__item_,
        StatusReferrals,
        _StatusReferral_cRLReferral,
        __StatusReferral_otherReferral_type_id,
        __StatusReferral_otherReferral_value,
        _StatusReferral_otherReferral,
        _StatusReferral_otherReferral,
        StatusReferral,
        _CRLReferral_issuer,
        _CRLReferral_location,
        _CRLReferral_deltaRefInfo,
        _CRLReferral_cRLScope,
        _CRLReferral_lastUpdate,
        _CRLReferral_lastChangedCRL,
        CRLReferral,
        _DeltaRefInfo_deltaLocation,
        _DeltaRefInfo_lastDelta,
        DeltaRefInfo,
        OTHER_REFERRAL,
        cRLStreamIdentifier,
        _cRLStreamIdentifier_val_ExtnType,
        CRLStreamIdentifier,
        orderedList,
        _orderedList_val_ExtnType,
        OrderedListSyntax,
        deltaInfo,
        _deltaInfo_val_ExtnType,
        _DeltaInformation_deltaLocation,
        _DeltaInformation_nextDelta,
        DeltaInformation,
        toBeRevoked,
        _toBeRevoked_val_ExtnType,
        _ToBeRevokedSyntax__item_,
        ToBeRevokedSyntax,
        _ToBeRevokedGroup_certificateIssuer,
        _ToBeRevokedGroup_reasonInfo,
        _ToBeRevokedGroup_revocationTime,
        _ToBeRevokedGroup_certificateGroup,
        ToBeRevokedGroup,
        _ReasonInfo_reasonCode,
        _ReasonInfo_holdInstructionCode,
        ReasonInfo,
        _CertificateGroup_serialNumbers,
        _CertificateGroup_serialNumberRange,
        _CertificateGroup_nameSubtree,
        CertificateGroup,
        _CertificateGroupNumberRange_startingNumber,
        _CertificateGroupNumberRange_endingNumber,
        CertificateGroupNumberRange,
        _CertificateSerialNumbers__item_,
        CertificateSerialNumbers,
        revokedGroups,
        _revokedGroups_val_ExtnType,
        _RevokedGroupsSyntax__item_,
        RevokedGroupsSyntax,
        _RevokedGroup_certificateIssuer,
        _RevokedGroup_reasonInfo,
        _RevokedGroup_invalidityDate,
        _RevokedGroup_revokedcertificateGroup,
        RevokedGroup,
        _RevokedCertificateGroup_serialNumberRange,
        _RevokedCertificateGroup_nameSubtree,
        RevokedCertificateGroup,
        expiredCertsOnCRL,
        _expiredCertsOnCRL_val_ExtnType,
        ExpiredCertsOnCRL,
        reasonCode,
        _reasonCode_val_ExtnType,
        CRLReason,
        holdInstructionCode,
        _holdInstructionCode_val_ExtnType,
        HoldInstruction,
        invalidityDate,
        _invalidityDate_val_ExtnType,
        cRLDistributionPoints,
        _cRLDistributionPoints_val_ExtnType,
        _CRLDistPointsSyntax__item_,
        CRLDistPointsSyntax,
        _DistributionPoint_distributionPoint,
        _DistributionPoint_reasons,
        _DistributionPoint_cRLIssuer,
        DistributionPoint,
        _DistributionPointName_fullName,
        _DistributionPointName_nameRelativeToCRLIssuer,
        DistributionPointName,
        ReasonFlags,
        issuingDistributionPoint,
        _issuingDistributionPoint_val_ExtnType,
        _IssuingDistPointSyntax_distributionPoint,
        _IssuingDistPointSyntax_onlyContainsUserPublicKeyCerts,
        _IssuingDistPointSyntax_onlyContainsCACerts,
        _IssuingDistPointSyntax_onlySomeReasons,
        _IssuingDistPointSyntax_indirectCRL,
        _IssuingDistPointSyntax_onlyContainsAttributeCerts,
        IssuingDistPointSyntax,
        certificateIssuer,
        _certificateIssuer_val_ExtnType,
        deltaCRLIndicator,
        _deltaCRLIndicator_val_ExtnType,
        BaseCRLNumber,
        baseUpdateTime,
        _baseUpdateTime_val_ExtnType,
        freshestCRL,
        _freshestCRL_val_ExtnType,
        aAissuingDistributionPoint,
        _aAissuingDistributionPoint_val_ExtnType,
        _AAIssuingDistPointSyntax_distributionPoint,
        _AAIssuingDistPointSyntax_onlySomeReasons,
        _AAIssuingDistPointSyntax_indirectCRL,
        _AAIssuingDistPointSyntax_containsUserAttributeCerts,
        _AAIssuingDistPointSyntax_containsAACerts,
        _AAIssuingDistPointSyntax_containsSOAPublicKeyCerts,
        AAIssuingDistPointSyntax,
        certificateExactMatch,
        _certificateExactMatch_val_AssertionType,
        _CertificateExactAssertion_serialNumber,
        _CertificateExactAssertion_issuer,
        CertificateExactAssertion,
        certificateMatch,
        _certificateMatch_val_AssertionType,
        _CertificateAssertion_serialNumber,
        _CertificateAssertion_issuer,
        _CertificateAssertion_subjectKeyIdentifier,
        _CertificateAssertion_authorityKeyIdentifier,
        _CertificateAssertion_certificateValid,
        _CertificateAssertion_privateKeyValid,
        _CertificateAssertion_subjectPublicKeyAlgID,
        _CertificateAssertion_keyUsage,
        _CertificateAssertion_subjectAltName,
        _CertificateAssertion_policy,
        _CertificateAssertion_pathToName,
        _CertificateAssertion_subject,
        _CertificateAssertion_nameConstraints,
        CertificateAssertion,
        _AltNameType_builtinNameForm,
        _AltNameType_otherNameForm,
        AltNameType,
        _CertPolicySet__item_,
        CertPolicySet,
        certificatePairExactMatch,
        _certificatePairExactMatch_val_AssertionType,
        _CertificatePairExactAssertion_issuedToThisCAAssertion,
        _CertificatePairExactAssertion_issuedByThisCAAssertion,
        CertificatePairExactAssertion,
        certificatePairMatch,
        _certificatePairMatch_val_AssertionType,
        _CertificatePairAssertion_issuedToThisCAAssertion,
        _CertificatePairAssertion_issuedByThisCAAssertion,
        CertificatePairAssertion,
        certificateListExactMatch,
        _certificateListExactMatch_val_AssertionType,
        _CertificateListExactAssertion_issuer,
        _CertificateListExactAssertion_thisUpdate,
        _CertificateListExactAssertion_distributionPoint,
        CertificateListExactAssertion,
        certificateListMatch,
        _certificateListMatch_val_AssertionType,
        _CertificateListAssertion_issuer,
        _CertificateListAssertion_minCRLNumber,
        _CertificateListAssertion_maxCRLNumber,
        _CertificateListAssertion_reasonFlags,
        _CertificateListAssertion_dateAndTime,
        _CertificateListAssertion_distributionPoint,
        _CertificateListAssertion_authorityKeyIdentifier,
        CertificateListAssertion,
        algorithmIdentifierMatch,
        ___algorithmIdentifierMatch_val_AssertionType_algorithm_tab,
        __algorithmIdentifierMatch_val_AssertionType_algorithm,
        ___algorithmIdentifierMatch_val_AssertionType_parameters_tab,
        __algorithmIdentifierMatch_val_AssertionType_parameters,
        _algorithmIdentifierMatch_val_AssertionType,
        policyMatch,
        _policyMatch_val_AssertionType,
        pkiPathMatch,
        _pkiPathMatch_val_AssertionType,
        _PkiPathMatchSyntax_firstIssuer,
        _PkiPathMatchSyntax_lastSubject,
        PkiPathMatchSyntax,
        enhancedCertificateMatch,
        _enhancedCertificateMatch_val_AssertionType,
        _EnhancedCertificateAssertion_serialNumber,
        _EnhancedCertificateAssertion_issuer,
        _EnhancedCertificateAssertion_subjectKeyIdentifier,
        _EnhancedCertificateAssertion_authorityKeyIdentifier,
        _EnhancedCertificateAssertion_certificateValid,
        _EnhancedCertificateAssertion_privateKeyValid,
        _EnhancedCertificateAssertion_subjectPublicKeyAlgID,
        _EnhancedCertificateAssertion_keyUsage,
        _EnhancedCertificateAssertion_subjectAltName,
        _EnhancedCertificateAssertion_policy,
        _EnhancedCertificateAssertion_pathToName,
        _EnhancedCertificateAssertion_subject,
        _EnhancedCertificateAssertion_nameConstraints,
        EnhancedCertificateAssertion,
        _AltName_altnameType,
        _AltName_altNameValue,
        AltName,
        certExactAssertion,
        _certExactAssertion_val_Type,
        certAssertion,
        _certAssertion_val_Type,
        certPairExactAssertion,
        _certPairExactAssertion_val_Type,
        certPairAssertion,
        _certPairAssertion_val_Type,
        certListExactAssertion,
        _certListExactAssertion_val_Type,
        certListAssertion,
        _certListAssertion_val_Type,
        algorithmIdentifier,
        ___algorithmIdentifier_val_Type_algorithm_tab,
        __algorithmIdentifier_val_Type_algorithm,
        ___algorithmIdentifier_val_Type_parameters_tab,
        __algorithmIdentifier_val_Type_parameters,
        _algorithmIdentifier_val_Type,
        id_ce_subjectDirectoryAttributes,
        id_ce_subjectKeyIdentifier,
        id_ce_keyUsage,
        id_ce_privateKeyUsagePeriod,
        id_ce_subjectAltName,
        id_ce_issuerAltName,
        id_ce_basicConstraints,
        id_ce_cRLNumber,
        id_ce_reasonCode,
        id_ce_holdInstructionCode,
        id_ce_invalidityDate,
        id_ce_deltaCRLIndicator,
        id_ce_issuingDistributionPoint,
        id_ce_certificateIssuer,
        id_ce_nameConstraints,
        id_ce_cRLDistributionPoints,
        id_ce_certificatePolicies,
        id_ce_policyMappings,
        id_ce_authorityKeyIdentifier,
        id_ce_policyConstraints,
        id_ce_extKeyUsage,
        id_ce_cRLStreamIdentifier,
        id_ce_cRLScope,
        id_ce_statusReferrals,
        id_ce_freshestCRL,
        id_ce_orderedList,
        id_ce_baseUpdateTime,
        id_ce_deltaInfo,
        id_ce_inhibitAnyPolicy,
        id_ce_toBeRevoked,
        id_ce_revokedGroups,
        id_ce_expiredCertsOnCRL,
        id_ce_aAissuingDistributionPoint,
        id_ce_authorizationValidation,
        id_mr_certificateExactMatch,
        id_mr_certificateMatch,
        id_mr_certificatePairExactMatch,
        id_mr_certificatePairMatch,
        id_mr_certificateListExactMatch,
        id_mr_certificateListMatch,
        id_mr_algorithmIdentifierMatch,
        id_mr_policyMatch,
        id_mr_pkiPathMatch,
        id_mr_enhancedCertificateMatch,
        id_ldx_certExactAssertion,
        id_ldx_certAssertion,
        id_ldx_certPairExactAssertion,
        id_ldx_certPairAssertion,
        id_ldx_certListExactAssertion,
        id_ldx_certListAssertion,
        id_ldx_algorithmIdentifier,
    ]

class CMIP_1:

    _name_  = u'CMIP-1'
    _oid_   = [2, 9, 1, 0, 3]
    
    _obj_ = [
        u'CMIP-Operations',
        u'CMIP-Confirmed-Operations',
        u'accessDenied',
        u'classInstanceConflict',
        u'complexityLimitation',
        u'duplicateManagedObjectInstance',
        u'getListError',
        u'invalidArgumentValue',
        u'invalidAttributeValue',
        u'invalidFilter',
        u'invalidObjectInstance',
        u'invalidScope',
        u'missingAttributeValue',
        u'mistypedOperation',
        u'noSuchAction',
        u'noSuchArgument',
        u'noSuchAttribute',
        u'noSuchEventType',
        u'noSuchInvokeId',
        u'noSuchObjectClass',
        u'noSuchObjectInstance',
        u'noSuchReferenceObject',
        u'operationCancelled',
        u'processingFailure',
        u'setListError',
        u'syncNotSupported',
        u'm-Action',
        u'm-Action-Confirmed',
        u'm-CancelGet',
        u'm-Create',
        u'm-Delete',
        u'm-EventReport',
        u'm-EventReport-Confirmed',
        u'm-Get',
        u'm-Linked-Reply',
        u'm-Set',
        u'm-Set-Confirmed',
        u'CMIP-ACTION',
        u'CMIP-ATTRIBUTE',
        u'CMIP-AVA',
        u'CMIP-EVENT',
        u'CMIP-SPECIFICERROR',
        u'AccessControl',
        u'ActionArgument',
        u'ActionError',
        u'ActionErrorInfo',
        u'ActionInfo',
        u'ActionReply',
        u'ActionResult',
        u'ActionSet',
        u'ActionTypeId',
        u'Attribute',
        u'AttributeError',
        u'AttributeId',
        u'AttributeIdError',
        u'AttributeSet',
        u'AttributeValueAssertion',
        u'AvaSet',
        u'BaseManagedObjectId',
        u'CMISFilter',
        u'CMISSync',
        u'ComplexityLimitation',
        u'CreateArgument',
        u'CreateResult',
        u'DeleteArgument',
        u'DeleteError',
        u'DeleteResult',
        u'DistinguishedName',
        u'EventReply',
        u'EventReportArgument',
        u'EventReportResult',
        u'EventSet',
        u'EventTypeId',
        u'FilterItem',
        u'GetArgument',
        u'GetInfoStatus',
        u'GetListError',
        u'GetResult',
        u'InvalidArgumentValue',
        u'InvokeIDType',
        u'LinkedReplyArgument',
        u'ModifyOperator',
        u'NoSuchAction',
        u'NoSuchArgument',
        u'NoSuchEventType',
        u'ObjectClass',
        u'ObjectInstance',
        u'ProcessingFailure',
        u'RDNSequence',
        u'RelativeDistinguishedName',
        u'Scope',
        u'SetArgument',
        u'SetInfoStatus',
        u'SetListError',
        u'SetResult',
        u'SpecificErrorInfo',
        u'SpecificErrorSet',
        u'ROSEapdus',
        ]
    _type_ = [
        u'CMIP-ACTION',
        u'CMIP-ATTRIBUTE',
        u'CMIP-AVA',
        u'CMIP-EVENT',
        u'CMIP-SPECIFICERROR',
        u'AccessControl',
        u'ActionArgument',
        u'ActionError',
        u'ActionErrorInfo',
        u'ActionInfo',
        u'ActionReply',
        u'ActionResult',
        u'ActionTypeId',
        u'Attribute',
        u'AttributeError',
        u'AttributeId',
        u'AttributeIdError',
        u'AttributeValueAssertion',
        u'BaseManagedObjectId',
        u'CMISFilter',
        u'CMISSync',
        u'ComplexityLimitation',
        u'CreateArgument',
        u'CreateResult',
        u'DeleteArgument',
        u'DeleteError',
        u'DeleteResult',
        u'DistinguishedName',
        u'EventReply',
        u'EventReportArgument',
        u'EventReportResult',
        u'EventTypeId',
        u'FilterItem',
        u'GetArgument',
        u'GetInfoStatus',
        u'GetListError',
        u'GetResult',
        u'InvalidArgumentValue',
        u'InvokeIDType',
        u'LinkedReplyArgument',
        u'ModifyOperator',
        u'NoSuchAction',
        u'NoSuchArgument',
        u'NoSuchEventType',
        u'ObjectClass',
        u'ObjectInstance',
        u'ProcessingFailure',
        u'RDNSequence',
        u'RelativeDistinguishedName',
        u'Scope',
        u'SetArgument',
        u'SetInfoStatus',
        u'SetListError',
        u'SetResult',
        u'SpecificErrorInfo',
        u'ROSEapdus',
        ]
    _set_ = [
        u'CMIP-Operations',
        u'CMIP-Confirmed-Operations',
        u'ActionSet',
        u'AttributeSet',
        u'AvaSet',
        u'EventSet',
        u'SpecificErrorSet',
        ]
    _val_ = [
        u'accessDenied',
        u'classInstanceConflict',
        u'complexityLimitation',
        u'duplicateManagedObjectInstance',
        u'getListError',
        u'invalidArgumentValue',
        u'invalidAttributeValue',
        u'invalidFilter',
        u'invalidObjectInstance',
        u'invalidScope',
        u'missingAttributeValue',
        u'mistypedOperation',
        u'noSuchAction',
        u'noSuchArgument',
        u'noSuchAttribute',
        u'noSuchEventType',
        u'noSuchInvokeId',
        u'noSuchObjectClass',
        u'noSuchObjectInstance',
        u'noSuchReferenceObject',
        u'operationCancelled',
        u'processingFailure',
        u'setListError',
        u'syncNotSupported',
        u'm-Action',
        u'm-Action-Confirmed',
        u'm-CancelGet',
        u'm-Create',
        u'm-Delete',
        u'm-EventReport',
        u'm-EventReport-Confirmed',
        u'm-Get',
        u'm-Linked-Reply',
        u'm-Set',
        u'm-Set-Confirmed',
        ]
    _class_ = [
        u'CMIP-Operations',
        u'CMIP-Confirmed-Operations',
        u'accessDenied',
        u'classInstanceConflict',
        u'complexityLimitation',
        u'duplicateManagedObjectInstance',
        u'getListError',
        u'invalidArgumentValue',
        u'invalidAttributeValue',
        u'invalidFilter',
        u'invalidObjectInstance',
        u'invalidScope',
        u'missingAttributeValue',
        u'mistypedOperation',
        u'noSuchAction',
        u'noSuchArgument',
        u'noSuchAttribute',
        u'noSuchEventType',
        u'noSuchInvokeId',
        u'noSuchObjectClass',
        u'noSuchObjectInstance',
        u'noSuchReferenceObject',
        u'operationCancelled',
        u'processingFailure',
        u'setListError',
        u'syncNotSupported',
        u'm-Action',
        u'm-Action-Confirmed',
        u'm-CancelGet',
        u'm-Create',
        u'm-Delete',
        u'm-EventReport',
        u'm-EventReport-Confirmed',
        u'm-Get',
        u'm-Linked-Reply',
        u'm-Set',
        u'm-Set-Confirmed',
        u'CMIP-ACTION',
        u'CMIP-ATTRIBUTE',
        u'CMIP-AVA',
        u'CMIP-EVENT',
        u'CMIP-SPECIFICERROR',
        u'ActionSet',
        u'AttributeSet',
        u'AvaSet',
        u'EventSet',
        u'SpecificErrorSet',
        ]
    _param_ = [
        ]
    
    #-----< CMIP-Operations >-----#
    CMIP_Operations = CLASS(name=u'CMIP-Operations', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _CMIP_Operations_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    _CMIP_Operations_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    _CMIP_Operations_val_ResultType_1 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionResult')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'BaseManagedObjectId')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2 = SET(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ComplexityLimitation')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Scope')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvalidArgumentValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchAction')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchArgument')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_11 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISSync')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'LinkedReplyArgument')))
    _CMIP_Operations_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    _CMIP_Operations_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateArgument')))
    _CMIP_Operations_val_ResultType_3 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateResult')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0 = SET_OF(name=u'ParameterType', mode=MODE_TYPE)
    ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0._cont = ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0__item_
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _CMIP_Operations_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteArgument')))
    _CMIP_Operations_val_ResultType_4 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteResult')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Scope')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISSync')))
    _CMIP_Operations_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    _CMIP_Operations_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    _CMIP_Operations_val_ResultType_6 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportResult')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvalidArgumentValue')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchArgument')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_2 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchEventType')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_2 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    _CMIP_Operations_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetArgument')))
    _CMIP_Operations_val_ResultType_7 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetResult')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_3 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetListError')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_3 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Scope')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_0 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10_0 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISSync')))
    _CMIP_Operations_val_ArgumentType_8 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'LinkedReplyArgument')))
    _CMIP_Operations_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    _CMIP_Operations_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    _CMIP_Operations_val_ResultType_10 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetResult')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_2 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetListError')))
    _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_1 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISSync')))
    CMIP_Operations._val = ASN1Set(rv=[dict([(u'ArgumentType', _CMIP_Operations_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', _CMIP_Operations_val_ArgumentType_1), (u'ResultType', _CMIP_Operations_val_ResultType_1), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 14))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_11), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', _CMIP_Operations_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 21))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 22))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', _CMIP_Operations_val_ArgumentType_3), (u'ResultType', _CMIP_Operations_val_ResultType_3), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 17))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 18))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 12))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', _CMIP_Operations_val_ArgumentType_4), (u'ResultType', _CMIP_Operations_val_ResultType_4), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', _CMIP_Operations_val_ArgumentType_5), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 0))]), dict([(u'ArgumentType', _CMIP_Operations_val_ArgumentType_6), (u'ResultType', _CMIP_Operations_val_ResultType_6), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 14))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 13))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', _CMIP_Operations_val_ArgumentType_7), (u'ResultType', _CMIP_Operations_val_ResultType_7), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 23))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_0), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', _CMIP_Operations_val_ArgumentType_8), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', _CMIP_Operations_val_ArgumentType_9), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', _CMIP_Operations_val_ArgumentType_10), (u'ResultType', _CMIP_Operations_val_ResultType_10), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))])], rr=[], ev=None, er=[])
    
    #-----< CMIP-Confirmed-Operations >-----#
    CMIP_Confirmed_Operations = CLASS(name=u'CMIP-Confirmed-Operations', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _CMIP_Confirmed_Operations_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    _CMIP_Confirmed_Operations_val_ResultType_0 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionResult')))
    _CMIP_Confirmed_Operations_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    _CMIP_Confirmed_Operations_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateArgument')))
    _CMIP_Confirmed_Operations_val_ResultType_2 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateResult')))
    _CMIP_Confirmed_Operations_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteArgument')))
    _CMIP_Confirmed_Operations_val_ResultType_3 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteResult')))
    _CMIP_Confirmed_Operations_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    _CMIP_Confirmed_Operations_val_ResultType_4 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportResult')))
    _CMIP_Confirmed_Operations_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetArgument')))
    _CMIP_Confirmed_Operations_val_ResultType_5 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetResult')))
    _CMIP_Confirmed_Operations_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    _CMIP_Confirmed_Operations_val_ResultType_6 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetResult')))
    CMIP_Confirmed_Operations._val = ASN1Set(rv=[dict([(u'ArgumentType', _CMIP_Confirmed_Operations_val_ArgumentType_0), (u'ResultType', _CMIP_Confirmed_Operations_val_ResultType_0), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 14))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_11), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', _CMIP_Confirmed_Operations_val_ArgumentType_1), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 21))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 22))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', _CMIP_Confirmed_Operations_val_ArgumentType_2), (u'ResultType', _CMIP_Confirmed_Operations_val_ResultType_2), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 17))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 18))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 12))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', _CMIP_Confirmed_Operations_val_ArgumentType_3), (u'ResultType', _CMIP_Confirmed_Operations_val_ResultType_3), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', _CMIP_Confirmed_Operations_val_ArgumentType_4), (u'ResultType', _CMIP_Confirmed_Operations_val_ResultType_4), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 14))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 13))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', _CMIP_Confirmed_Operations_val_ArgumentType_5), (u'ResultType', _CMIP_Confirmed_Operations_val_ResultType_5), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 23))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_0), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', _CMIP_Confirmed_Operations_val_ArgumentType_6), (u'ResultType', _CMIP_Confirmed_Operations_val_ResultType_6), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))])], rr=[], ev=None, er=[])
    
    #-----< accessDenied >-----#
    accessDenied = CLASS(name=u'accessDenied', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    accessDenied._val = dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))])
    
    #-----< classInstanceConflict >-----#
    classInstanceConflict = CLASS(name=u'classInstanceConflict', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _classInstanceConflict_val_ParameterType = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'BaseManagedObjectId')))
    classInstanceConflict._val = dict([(u'ParameterType', _classInstanceConflict_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))])
    
    #-----< complexityLimitation >-----#
    complexityLimitation = CLASS(name=u'complexityLimitation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _complexityLimitation_val_ParameterType = SET(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ComplexityLimitation')))
    complexityLimitation._val = dict([(u'ParameterType', _complexityLimitation_val_ParameterType), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))])
    
    #-----< duplicateManagedObjectInstance >-----#
    duplicateManagedObjectInstance = CLASS(name=u'duplicateManagedObjectInstance', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _duplicateManagedObjectInstance_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    duplicateManagedObjectInstance._val = dict([(u'ParameterType', _duplicateManagedObjectInstance_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 11))])
    
    #-----< getListError >-----#
    getListError = CLASS(name=u'getListError', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _getListError_val_ParameterType = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetListError')))
    getListError._val = dict([(u'ParameterType', _getListError_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 7))])
    
    #-----< invalidArgumentValue >-----#
    invalidArgumentValue = CLASS(name=u'invalidArgumentValue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _invalidArgumentValue_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvalidArgumentValue')))
    invalidArgumentValue._val = dict([(u'ParameterType', _invalidArgumentValue_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 15))])
    
    #-----< invalidAttributeValue >-----#
    invalidAttributeValue = CLASS(name=u'invalidAttributeValue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _invalidAttributeValue_val_ParameterType = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    invalidAttributeValue._val = dict([(u'ParameterType', _invalidAttributeValue_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 6))])
    
    #-----< invalidFilter >-----#
    invalidFilter = CLASS(name=u'invalidFilter', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _invalidFilter_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    invalidFilter._val = dict([(u'ParameterType', _invalidFilter_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))])
    
    #-----< invalidObjectInstance >-----#
    invalidObjectInstance = CLASS(name=u'invalidObjectInstance', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _invalidObjectInstance_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    invalidObjectInstance._val = dict([(u'ParameterType', _invalidObjectInstance_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 17))])
    
    #-----< invalidScope >-----#
    invalidScope = CLASS(name=u'invalidScope', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _invalidScope_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Scope')))
    invalidScope._val = dict([(u'ParameterType', _invalidScope_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))])
    
    #-----< missingAttributeValue >-----#
    missingAttributeValue = CLASS(name=u'missingAttributeValue', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _missingAttributeValue_val_ParameterType = SET_OF(name=u'ParameterType', mode=MODE_TYPE)
    __missingAttributeValue_val_ParameterType__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    _missingAttributeValue_val_ParameterType._cont = __missingAttributeValue_val_ParameterType__item_
    missingAttributeValue._val = dict([(u'ParameterType', _missingAttributeValue_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 18))])
    
    #-----< mistypedOperation >-----#
    mistypedOperation = CLASS(name=u'mistypedOperation', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    mistypedOperation._val = dict([(u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 21))])
    
    #-----< noSuchAction >-----#
    noSuchAction = CLASS(name=u'noSuchAction', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchAction_val_ParameterType = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchAction')))
    noSuchAction._val = dict([(u'ParameterType', _noSuchAction_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 9))])
    
    #-----< noSuchArgument >-----#
    noSuchArgument = CLASS(name=u'noSuchArgument', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchArgument_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchArgument')))
    noSuchArgument._val = dict([(u'ParameterType', _noSuchArgument_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 14))])
    
    #-----< noSuchAttribute >-----#
    noSuchAttribute = CLASS(name=u'noSuchAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchAttribute_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    noSuchAttribute._val = dict([(u'ParameterType', _noSuchAttribute_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 5))])
    
    #-----< noSuchEventType >-----#
    noSuchEventType = CLASS(name=u'noSuchEventType', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchEventType_val_ParameterType = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchEventType')))
    noSuchEventType._val = dict([(u'ParameterType', _noSuchEventType_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 13))])
    
    #-----< noSuchInvokeId >-----#
    noSuchInvokeId = CLASS(name=u'noSuchInvokeId', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchInvokeId_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    noSuchInvokeId._val = dict([(u'ParameterType', _noSuchInvokeId_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 22))])
    
    #-----< noSuchObjectClass >-----#
    noSuchObjectClass = CLASS(name=u'noSuchObjectClass', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchObjectClass_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    noSuchObjectClass._val = dict([(u'ParameterType', _noSuchObjectClass_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))])
    
    #-----< noSuchObjectInstance >-----#
    noSuchObjectInstance = CLASS(name=u'noSuchObjectInstance', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchObjectInstance_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    noSuchObjectInstance._val = dict([(u'ParameterType', _noSuchObjectInstance_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))])
    
    #-----< noSuchReferenceObject >-----#
    noSuchReferenceObject = CLASS(name=u'noSuchReferenceObject', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _noSuchReferenceObject_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    noSuchReferenceObject._val = dict([(u'ParameterType', _noSuchReferenceObject_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 12))])
    
    #-----< operationCancelled >-----#
    operationCancelled = CLASS(name=u'operationCancelled', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    operationCancelled._val = dict([(u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 23))])
    
    #-----< processingFailure >-----#
    processingFailure = CLASS(name=u'processingFailure', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _processingFailure_val_ParameterType = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    processingFailure._val = dict([(u'ParameterType', _processingFailure_val_ParameterType), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])
    
    #-----< setListError >-----#
    setListError = CLASS(name=u'setListError', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _setListError_val_ParameterType = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetListError')))
    setListError._val = dict([(u'ParameterType', _setListError_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 8))])
    
    #-----< syncNotSupported >-----#
    syncNotSupported = CLASS(name=u'syncNotSupported', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    _syncNotSupported_val_ParameterType = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISSync')))
    syncNotSupported._val = dict([(u'ParameterType', _syncNotSupported_val_ParameterType), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])
    
    #-----< m-Action >-----#
    m_Action = CLASS(name=u'm-Action', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Action_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    m_Action._val = dict([(u'ArgumentType', _m_Action_val_ArgumentType), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 6))])
    
    #-----< m-Action-Confirmed >-----#
    m_Action_Confirmed = CLASS(name=u'm-Action-Confirmed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Action_Confirmed_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    _m_Action_Confirmed_val_ResultType = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionResult')))
    m_Action_Confirmed._val = dict([(u'ArgumentType', _m_Action_Confirmed_val_ArgumentType), (u'ResultType', _m_Action_Confirmed_val_ResultType), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 14))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_11), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))])
    
    #-----< m-CancelGet >-----#
    m_CancelGet = CLASS(name=u'm-CancelGet', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_CancelGet_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    m_CancelGet._val = dict([(u'ArgumentType', _m_CancelGet_val_ArgumentType), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 21))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 22))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))])
    
    #-----< m-Create >-----#
    m_Create = CLASS(name=u'm-Create', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Create_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateArgument')))
    _m_Create_val_ResultType = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateResult')))
    m_Create._val = dict([(u'ArgumentType', _m_Create_val_ArgumentType), (u'ResultType', _m_Create_val_ResultType), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 17))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 18))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 12))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))])
    
    #-----< m-Delete >-----#
    m_Delete = CLASS(name=u'm-Delete', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Delete_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteArgument')))
    _m_Delete_val_ResultType = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteResult')))
    m_Delete._val = dict([(u'ArgumentType', _m_Delete_val_ArgumentType), (u'ResultType', _m_Delete_val_ResultType), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))])
    
    #-----< m-EventReport >-----#
    m_EventReport = CLASS(name=u'm-EventReport', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_EventReport_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    m_EventReport._val = dict([(u'ArgumentType', _m_EventReport_val_ArgumentType), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 0))])
    
    #-----< m-EventReport-Confirmed >-----#
    m_EventReport_Confirmed = CLASS(name=u'm-EventReport-Confirmed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_EventReport_Confirmed_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    _m_EventReport_Confirmed_val_ResultType = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportResult')))
    m_EventReport_Confirmed._val = dict([(u'ArgumentType', _m_EventReport_Confirmed_val_ArgumentType), (u'ResultType', _m_EventReport_Confirmed_val_ResultType), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 14))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 13))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))])
    
    #-----< m-Get >-----#
    m_Get = CLASS(name=u'm-Get', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Get_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetArgument')))
    _m_Get_val_ResultType = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetResult')))
    m_Get._val = dict([(u'ArgumentType', _m_Get_val_ArgumentType), (u'ResultType', _m_Get_val_ResultType), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 23))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_0), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])
    
    #-----< m-Linked-Reply >-----#
    m_Linked_Reply = CLASS(name=u'm-Linked-Reply', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Linked_Reply_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'LinkedReplyArgument')))
    m_Linked_Reply._val = dict([(u'ArgumentType', _m_Linked_Reply_val_ArgumentType), (u'operationCode', (u'local', 2))])
    
    #-----< m-Set >-----#
    m_Set = CLASS(name=u'm-Set', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Set_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    m_Set._val = dict([(u'ArgumentType', _m_Set_val_ArgumentType), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 4))])
    
    #-----< m-Set-Confirmed >-----#
    m_Set_Confirmed = CLASS(name=u'm-Set-Confirmed', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _m_Set_Confirmed_val_ArgumentType = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    _m_Set_Confirmed_val_ResultType = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetResult')))
    m_Set_Confirmed._val = dict([(u'ArgumentType', _m_Set_Confirmed_val_ArgumentType), (u'ResultType', _m_Set_Confirmed_val_ResultType), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))])
    
    #-----< CMIP-ACTION >-----#
    CMIP_ACTION = CLASS(name=u'CMIP-ACTION', mode=MODE_TYPE)
    _CMIP_ACTION_id = CHOICE(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('CMIP-1', 'ActionTypeId')), uniq=True)
    _CMIP_ACTION_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    CMIP_ACTION._cont = ASN1Dict([
        (u'id', _CMIP_ACTION_id),
        (u'Value', _CMIP_ACTION_Value),
        ])
    
    #-----< CMIP-ATTRIBUTE >-----#
    CMIP_ATTRIBUTE = CLASS(name=u'CMIP-ATTRIBUTE', mode=MODE_TYPE)
    _CMIP_ATTRIBUTE_id = CHOICE(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')), uniq=True)
    _CMIP_ATTRIBUTE_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    CMIP_ATTRIBUTE._cont = ASN1Dict([
        (u'id', _CMIP_ATTRIBUTE_id),
        (u'Value', _CMIP_ATTRIBUTE_Value),
        ])
    
    #-----< CMIP-AVA >-----#
    CMIP_AVA = CLASS(name=u'CMIP-AVA', mode=MODE_TYPE)
    _CMIP_AVA_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    _CMIP_AVA_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    CMIP_AVA._cont = ASN1Dict([
        (u'id', _CMIP_AVA_id),
        (u'Value', _CMIP_AVA_Value),
        ])
    
    #-----< CMIP-EVENT >-----#
    CMIP_EVENT = CLASS(name=u'CMIP-EVENT', mode=MODE_TYPE)
    _CMIP_EVENT_id = CHOICE(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('CMIP-1', 'EventTypeId')), uniq=True)
    _CMIP_EVENT_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    CMIP_EVENT._cont = ASN1Dict([
        (u'id', _CMIP_EVENT_id),
        (u'Value', _CMIP_EVENT_Value),
        ])
    
    #-----< CMIP-SPECIFICERROR >-----#
    CMIP_SPECIFICERROR = CLASS(name=u'CMIP-SPECIFICERROR', mode=MODE_TYPE)
    _CMIP_SPECIFICERROR_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    _CMIP_SPECIFICERROR_Value = OPEN(name=u'Value', mode=MODE_TYPE)
    CMIP_SPECIFICERROR._cont = ASN1Dict([
        (u'id', _CMIP_SPECIFICERROR_id),
        (u'Value', _CMIP_SPECIFICERROR_Value),
        ])
    
    #-----< AccessControl >-----#
    AccessControl = EXT(name=u'AccessControl', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    
    #-----< ActionArgument >-----#
    ActionArgument = SEQ(name=u'ActionArgument', mode=MODE_TYPE)
    _ActionArgument_baseManagedObjectClass = CHOICE(name=u'baseManagedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _ActionArgument_baseManagedObjectInstance = CHOICE(name=u'baseManagedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _ActionArgument_accessControl = EXT(name=u'accessControl', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'AccessControl')), opt=True)
    _ActionArgument_synchronization = ENUM(name=u'synchronization', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'CMISSync')), default=u'bestEffort')
    _ActionArgument_scope = CHOICE(name=u'scope', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'Scope')), default=(u'namedNumbers', 0))
    _ActionArgument_filter = CHOICE(name=u'filter', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')), default=(u'and', []))
    _ActionArgument_actionInfo = SEQ(name=u'actionInfo', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ActionInfo')))
    ActionArgument._cont = ASN1Dict([
        (u'baseManagedObjectClass', _ActionArgument_baseManagedObjectClass),
        (u'baseManagedObjectInstance', _ActionArgument_baseManagedObjectInstance),
        (u'accessControl', _ActionArgument_accessControl),
        (u'synchronization', _ActionArgument_synchronization),
        (u'scope', _ActionArgument_scope),
        (u'filter', _ActionArgument_filter),
        (u'actionInfo', _ActionArgument_actionInfo),
        ])
    ActionArgument._ext = []
    
    #-----< ActionError >-----#
    ActionError = SEQ(name=u'ActionError', mode=MODE_TYPE)
    _ActionError_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _ActionError_managedObjectInstance = CHOICE(name=u'managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _ActionError_currentTime = TIME_GEN(name=u'currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ActionError_actionErrorInfo = SEQ(name=u'actionErrorInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'ActionErrorInfo')))
    ActionError._cont = ASN1Dict([
        (u'managedObjectClass', _ActionError_managedObjectClass),
        (u'managedObjectInstance', _ActionError_managedObjectInstance),
        (u'currentTime', _ActionError_currentTime),
        (u'actionErrorInfo', _ActionError_actionErrorInfo),
        ])
    ActionError._ext = []
    
    #-----< ActionErrorInfo >-----#
    ActionErrorInfo = SEQ(name=u'ActionErrorInfo', mode=MODE_TYPE)
    _ActionErrorInfo_errorStatus = ENUM(name=u'errorStatus', mode=MODE_TYPE)
    _ActionErrorInfo_errorStatus._cont = ASN1Dict([(u'accessDenied', 2), (u'noSuchAction', 9), (u'noSuchArgument', 14), (u'invalidArgumentValue', 15)])
    _ActionErrorInfo_errorStatus._ext = []
    _ActionErrorInfo_errorInfo = CHOICE(name=u'errorInfo', mode=MODE_TYPE)
    __ActionErrorInfo_errorInfo_actionType = CHOICE(name=u'actionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ACTION'), [u'id']))
    ___ActionErrorInfo_errorInfo_actionType_tab = CLASS(name='_tab_CMIP-ACTION', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    ___ActionErrorInfo_errorInfo_actionType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ActionErrorInfo_errorInfo_actionType._const_tab = ___ActionErrorInfo_errorInfo_actionType_tab
    __ActionErrorInfo_errorInfo_actionType._const_tab_at = None
    __ActionErrorInfo_errorInfo_actionType._const_tab_id = u'id'
    __ActionErrorInfo_errorInfo_actionArgument = CHOICE(name=u'actionArgument', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'NoSuchArgument')))
    __ActionErrorInfo_errorInfo_argumentValue = CHOICE(name=u'argumentValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'InvalidArgumentValue')))
    _ActionErrorInfo_errorInfo._cont = ASN1Dict([
        (u'actionType', __ActionErrorInfo_errorInfo_actionType),
        (u'actionArgument', __ActionErrorInfo_errorInfo_actionArgument),
        (u'argumentValue', __ActionErrorInfo_errorInfo_argumentValue),
        ])
    _ActionErrorInfo_errorInfo._ext = None
    ActionErrorInfo._cont = ASN1Dict([
        (u'errorStatus', _ActionErrorInfo_errorStatus),
        (u'errorInfo', _ActionErrorInfo_errorInfo),
        ])
    ActionErrorInfo._ext = []
    
    #-----< ActionInfo >-----#
    ActionInfo = SEQ(name=u'ActionInfo', mode=MODE_TYPE)
    _ActionInfo_actionType = CHOICE(name=u'actionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ACTION'), [u'id']))
    __ActionInfo_actionType_tab = CLASS(name='_tab_CMIP-ACTION', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    __ActionInfo_actionType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ActionInfo_actionType._const_tab = __ActionInfo_actionType_tab
    _ActionInfo_actionType._const_tab_at = None
    _ActionInfo_actionType._const_tab_id = u'id'
    _ActionInfo_actionInfoArg = OPEN(name=u'actionInfoArg', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ACTION'), [u'Value']), opt=True)
    __ActionInfo_actionInfoArg_tab = CLASS(name='_tab_CMIP-ACTION', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    __ActionInfo_actionInfoArg_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ActionInfo_actionInfoArg._const_tab = __ActionInfo_actionInfoArg_tab
    _ActionInfo_actionInfoArg._const_tab_at = ('..', u'actionType')
    _ActionInfo_actionInfoArg._const_tab_id = u'Value'
    ActionInfo._cont = ASN1Dict([
        (u'actionType', _ActionInfo_actionType),
        (u'actionInfoArg', _ActionInfo_actionInfoArg),
        ])
    ActionInfo._ext = None
    
    #-----< ActionReply >-----#
    ActionReply = SEQ(name=u'ActionReply', mode=MODE_TYPE)
    _ActionReply_actionType = CHOICE(name=u'actionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ACTION'), [u'id']))
    __ActionReply_actionType_tab = CLASS(name='_tab_CMIP-ACTION', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    __ActionReply_actionType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ActionReply_actionType._const_tab = __ActionReply_actionType_tab
    _ActionReply_actionType._const_tab_at = None
    _ActionReply_actionType._const_tab_id = u'id'
    _ActionReply_actionReplyInfo = OPEN(name=u'actionReplyInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ACTION'), [u'Value']))
    __ActionReply_actionReplyInfo_tab = CLASS(name='_tab_CMIP-ACTION', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    __ActionReply_actionReplyInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ActionReply_actionReplyInfo._const_tab = __ActionReply_actionReplyInfo_tab
    _ActionReply_actionReplyInfo._const_tab_at = ('..', u'actionType')
    _ActionReply_actionReplyInfo._const_tab_id = u'Value'
    ActionReply._cont = ASN1Dict([
        (u'actionType', _ActionReply_actionType),
        (u'actionReplyInfo', _ActionReply_actionReplyInfo),
        ])
    ActionReply._ext = None
    
    #-----< ActionResult >-----#
    ActionResult = SEQ(name=u'ActionResult', mode=MODE_TYPE)
    _ActionResult_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _ActionResult_managedObjectInstance = CHOICE(name=u'managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _ActionResult_currentTime = TIME_GEN(name=u'currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ActionResult_actionReply = SEQ(name=u'actionReply', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ActionReply')), opt=True)
    ActionResult._cont = ASN1Dict([
        (u'managedObjectClass', _ActionResult_managedObjectClass),
        (u'managedObjectInstance', _ActionResult_managedObjectInstance),
        (u'currentTime', _ActionResult_currentTime),
        (u'actionReply', _ActionResult_actionReply),
        ])
    ActionResult._ext = []
    
    #-----< ActionSet >-----#
    ActionSet = CLASS(name=u'ActionSet', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    ActionSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ActionTypeId >-----#
    ActionTypeId = CHOICE(name=u'ActionTypeId', mode=MODE_TYPE)
    _ActionTypeId_globalForm = OID(name=u'globalForm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ActionTypeId_localForm = INT(name=u'localForm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ActionTypeId._cont = ASN1Dict([
        (u'globalForm', _ActionTypeId_globalForm),
        (u'localForm', _ActionTypeId_localForm),
        ])
    ActionTypeId._ext = None
    
    #-----< Attribute >-----#
    Attribute = SEQ(name=u'Attribute', mode=MODE_TYPE)
    _Attribute_id = CHOICE(name=u'id', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), [u'id']))
    __Attribute_id_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    __Attribute_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Attribute_id._const_tab = __Attribute_id_tab
    _Attribute_id._const_tab_at = None
    _Attribute_id._const_tab_id = u'id'
    _Attribute_value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), [u'Value']))
    __Attribute_value_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    __Attribute_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Attribute_value._const_tab = __Attribute_value_tab
    _Attribute_value._const_tab_at = ('..', u'id')
    _Attribute_value._const_tab_id = u'Value'
    Attribute._cont = ASN1Dict([
        (u'id', _Attribute_id),
        (u'value', _Attribute_value),
        ])
    Attribute._ext = None
    
    #-----< AttributeError >-----#
    AttributeError = SEQ(name=u'AttributeError', mode=MODE_TYPE)
    _AttributeError_errorStatus = ENUM(name=u'errorStatus', mode=MODE_TYPE)
    _AttributeError_errorStatus._cont = ASN1Dict([(u'accessDenied', 2), (u'noSuchAttribute', 5), (u'invalidAttributeValue', 6), (u'invalidOperation', 24), (u'invalidOperator', 25)])
    _AttributeError_errorStatus._ext = []
    _AttributeError_modifyOperator = INT(name=u'modifyOperator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ModifyOperator')), opt=True)
    _AttributeError_attributeId = CHOICE(name=u'attributeId', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), [u'id']))
    __AttributeError_attributeId_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    __AttributeError_attributeId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _AttributeError_attributeId._const_tab = __AttributeError_attributeId_tab
    _AttributeError_attributeId._const_tab_at = None
    _AttributeError_attributeId._const_tab_id = u'id'
    _AttributeError_attributeValue = OPEN(name=u'attributeValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), [u'Value']), opt=True)
    __AttributeError_attributeValue_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    __AttributeError_attributeValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _AttributeError_attributeValue._const_tab = __AttributeError_attributeValue_tab
    _AttributeError_attributeValue._const_tab_at = ('..', u'attributeId')
    _AttributeError_attributeValue._const_tab_id = u'Value'
    AttributeError._cont = ASN1Dict([
        (u'errorStatus', _AttributeError_errorStatus),
        (u'modifyOperator', _AttributeError_modifyOperator),
        (u'attributeId', _AttributeError_attributeId),
        (u'attributeValue', _AttributeError_attributeValue),
        ])
    AttributeError._ext = None
    
    #-----< AttributeId >-----#
    AttributeId = CHOICE(name=u'AttributeId', mode=MODE_TYPE)
    _AttributeId_globalForm = OID(name=u'globalForm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AttributeId_localForm = INT(name=u'localForm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    AttributeId._cont = ASN1Dict([
        (u'globalForm', _AttributeId_globalForm),
        (u'localForm', _AttributeId_localForm),
        ])
    AttributeId._ext = None
    
    #-----< AttributeIdError >-----#
    AttributeIdError = SEQ(name=u'AttributeIdError', mode=MODE_TYPE)
    _AttributeIdError_errorStatus = ENUM(name=u'errorStatus', mode=MODE_TYPE)
    _AttributeIdError_errorStatus._cont = ASN1Dict([(u'accessDenied', 2), (u'noSuchAttribute', 5)])
    _AttributeIdError_errorStatus._ext = []
    _AttributeIdError_attributeId = CHOICE(name=u'attributeId', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    AttributeIdError._cont = ASN1Dict([
        (u'errorStatus', _AttributeIdError_errorStatus),
        (u'attributeId', _AttributeIdError_attributeId),
        ])
    AttributeIdError._ext = []
    
    #-----< AttributeSet >-----#
    AttributeSet = CLASS(name=u'AttributeSet', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    AttributeSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AttributeValueAssertion >-----#
    AttributeValueAssertion = SEQ(name=u'AttributeValueAssertion', mode=MODE_TYPE)
    _AttributeValueAssertion_id = OID(name=u'id', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-AVA'), [u'id']))
    __AttributeValueAssertion_id_tab = CLASS(name='_tab_CMIP-AVA', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-AVA')))
    __AttributeValueAssertion_id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _AttributeValueAssertion_id._const_tab = __AttributeValueAssertion_id_tab
    _AttributeValueAssertion_id._const_tab_at = None
    _AttributeValueAssertion_id._const_tab_id = u'id'
    _AttributeValueAssertion_value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-AVA'), [u'Value']))
    __AttributeValueAssertion_value_tab = CLASS(name='_tab_CMIP-AVA', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-AVA')))
    __AttributeValueAssertion_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _AttributeValueAssertion_value._const_tab = __AttributeValueAssertion_value_tab
    _AttributeValueAssertion_value._const_tab_at = ('..', u'id')
    _AttributeValueAssertion_value._const_tab_id = u'Value'
    AttributeValueAssertion._cont = ASN1Dict([
        (u'id', _AttributeValueAssertion_id),
        (u'value', _AttributeValueAssertion_value),
        ])
    AttributeValueAssertion._ext = None
    
    #-----< AvaSet >-----#
    AvaSet = CLASS(name=u'AvaSet', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-AVA')))
    AvaSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BaseManagedObjectId >-----#
    BaseManagedObjectId = SEQ(name=u'BaseManagedObjectId', mode=MODE_TYPE)
    _BaseManagedObjectId_baseManagedObjectClass = CHOICE(name=u'baseManagedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _BaseManagedObjectId_baseManagedObjectInstance = CHOICE(name=u'baseManagedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    BaseManagedObjectId._cont = ASN1Dict([
        (u'baseManagedObjectClass', _BaseManagedObjectId_baseManagedObjectClass),
        (u'baseManagedObjectInstance', _BaseManagedObjectId_baseManagedObjectInstance),
        ])
    BaseManagedObjectId._ext = None
    
    #-----< CMISFilter >-----#
    CMISFilter = CHOICE(name=u'CMISFilter', mode=MODE_TYPE)
    _CMISFilter_item = CHOICE(name=u'item', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'FilterItem')))
    _CMISFilter_and_ = SET_OF(name=u'and', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CMISFilter_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    _CMISFilter_and_._cont = __CMISFilter_and___item_
    _CMISFilter_or_ = SET_OF(name=u'or', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CMISFilter_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    _CMISFilter_or_._cont = __CMISFilter_or___item_
    _CMISFilter_not_ = CHOICE(name=u'not', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    CMISFilter._cont = ASN1Dict([
        (u'item', _CMISFilter_item),
        (u'and', _CMISFilter_and_),
        (u'or', _CMISFilter_or_),
        (u'not', _CMISFilter_not_),
        ])
    CMISFilter._ext = None
    
    #-----< CMISSync >-----#
    CMISSync = ENUM(name=u'CMISSync', mode=MODE_TYPE)
    CMISSync._cont = ASN1Dict([(u'bestEffort', 0), (u'atomic', 1)])
    CMISSync._ext = None
    
    #-----< ComplexityLimitation >-----#
    ComplexityLimitation = SET(name=u'ComplexityLimitation', mode=MODE_TYPE)
    _ComplexityLimitation_scope = CHOICE(name=u'scope', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'Scope')), opt=True)
    _ComplexityLimitation_filter = CHOICE(name=u'filter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'CMISFilter')), opt=True)
    _ComplexityLimitation_sync = ENUM(name=u'sync', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'CMISSync')), opt=True)
    ComplexityLimitation._cont = ASN1Dict([
        (u'scope', _ComplexityLimitation_scope),
        (u'filter', _ComplexityLimitation_filter),
        (u'sync', _ComplexityLimitation_sync),
        ])
    ComplexityLimitation._ext = []
    
    #-----< CreateArgument >-----#
    CreateArgument = SEQ(name=u'CreateArgument', mode=MODE_TYPE)
    _CreateArgument_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _CreateArgument_managedOrSuperiorObjectInstance = CHOICE(name=u'managedOrSuperiorObjectInstance', mode=MODE_TYPE, opt=True)
    __CreateArgument_managedOrSuperiorObjectInstance_managedObjectInstance = CHOICE(name=u'managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    __CreateArgument_managedOrSuperiorObjectInstance_superiorObjectInstance = CHOICE(name=u'superiorObjectInstance', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _CreateArgument_managedOrSuperiorObjectInstance._cont = ASN1Dict([
        (u'managedObjectInstance', __CreateArgument_managedOrSuperiorObjectInstance_managedObjectInstance),
        (u'superiorObjectInstance', __CreateArgument_managedOrSuperiorObjectInstance_superiorObjectInstance),
        ])
    _CreateArgument_managedOrSuperiorObjectInstance._ext = None
    _CreateArgument_accessControl = EXT(name=u'accessControl', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'AccessControl')), opt=True)
    _CreateArgument_referenceObjectInstance = CHOICE(name=u'referenceObjectInstance', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _CreateArgument_attributeList = SET_OF(name=u'attributeList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CreateArgument_attributeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _CreateArgument_attributeList._cont = __CreateArgument_attributeList__item_
    CreateArgument._cont = ASN1Dict([
        (u'managedObjectClass', _CreateArgument_managedObjectClass),
        (u'managedOrSuperiorObjectInstance', _CreateArgument_managedOrSuperiorObjectInstance),
        (u'accessControl', _CreateArgument_accessControl),
        (u'referenceObjectInstance', _CreateArgument_referenceObjectInstance),
        (u'attributeList', _CreateArgument_attributeList),
        ])
    CreateArgument._ext = []
    
    #-----< CreateResult >-----#
    CreateResult = SEQ(name=u'CreateResult', mode=MODE_TYPE)
    _CreateResult_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _CreateResult_managedObjectInstance = CHOICE(name=u'managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _CreateResult_currentTime = TIME_GEN(name=u'currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CreateResult_attributeList = SET_OF(name=u'attributeList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CreateResult_attributeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _CreateResult_attributeList._cont = __CreateResult_attributeList__item_
    CreateResult._cont = ASN1Dict([
        (u'managedObjectClass', _CreateResult_managedObjectClass),
        (u'managedObjectInstance', _CreateResult_managedObjectInstance),
        (u'currentTime', _CreateResult_currentTime),
        (u'attributeList', _CreateResult_attributeList),
        ])
    CreateResult._ext = []
    
    #-----< DeleteArgument >-----#
    DeleteArgument = SEQ(name=u'DeleteArgument', mode=MODE_TYPE)
    _DeleteArgument_baseManagedObjectClass = CHOICE(name=u'baseManagedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _DeleteArgument_baseManagedObjectInstance = CHOICE(name=u'baseManagedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _DeleteArgument_accessControl = EXT(name=u'accessControl', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'AccessControl')), opt=True)
    _DeleteArgument_synchronization = ENUM(name=u'synchronization', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'CMISSync')), default=u'bestEffort')
    _DeleteArgument_scope = CHOICE(name=u'scope', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'Scope')), default=(u'namedNumbers', 0))
    _DeleteArgument_filter = CHOICE(name=u'filter', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')), default=(u'and', []))
    DeleteArgument._cont = ASN1Dict([
        (u'baseManagedObjectClass', _DeleteArgument_baseManagedObjectClass),
        (u'baseManagedObjectInstance', _DeleteArgument_baseManagedObjectInstance),
        (u'accessControl', _DeleteArgument_accessControl),
        (u'synchronization', _DeleteArgument_synchronization),
        (u'scope', _DeleteArgument_scope),
        (u'filter', _DeleteArgument_filter),
        ])
    DeleteArgument._ext = []
    
    #-----< DeleteError >-----#
    DeleteError = SEQ(name=u'DeleteError', mode=MODE_TYPE)
    _DeleteError_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _DeleteError_managedObjectInstance = CHOICE(name=u'managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _DeleteError_currentTime = TIME_GEN(name=u'currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteError_deleteErrorInfo = ENUM(name=u'deleteErrorInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _DeleteError_deleteErrorInfo._cont = ASN1Dict([(u'accessDenied', 2)])
    _DeleteError_deleteErrorInfo._ext = []
    DeleteError._cont = ASN1Dict([
        (u'managedObjectClass', _DeleteError_managedObjectClass),
        (u'managedObjectInstance', _DeleteError_managedObjectInstance),
        (u'currentTime', _DeleteError_currentTime),
        (u'deleteErrorInfo', _DeleteError_deleteErrorInfo),
        ])
    DeleteError._ext = []
    
    #-----< DeleteResult >-----#
    DeleteResult = SEQ(name=u'DeleteResult', mode=MODE_TYPE)
    _DeleteResult_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _DeleteResult_managedObjectInstance = CHOICE(name=u'managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _DeleteResult_currentTime = TIME_GEN(name=u'currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    DeleteResult._cont = ASN1Dict([
        (u'managedObjectClass', _DeleteResult_managedObjectClass),
        (u'managedObjectInstance', _DeleteResult_managedObjectInstance),
        (u'currentTime', _DeleteResult_currentTime),
        ])
    DeleteResult._ext = []
    
    #-----< DistinguishedName >-----#
    DistinguishedName = SEQ_OF(name=u'DistinguishedName', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'RDNSequence')))
    
    #-----< EventReply >-----#
    EventReply = SEQ(name=u'EventReply', mode=MODE_TYPE)
    _EventReply_eventType = CHOICE(name=u'eventType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), [u'id']))
    __EventReply_eventType_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    __EventReply_eventType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _EventReply_eventType._const_tab = __EventReply_eventType_tab
    _EventReply_eventType._const_tab_at = None
    _EventReply_eventType._const_tab_id = u'id'
    _EventReply_eventReplyInfo = OPEN(name=u'eventReplyInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), [u'Value']), opt=True)
    __EventReply_eventReplyInfo_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    __EventReply_eventReplyInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _EventReply_eventReplyInfo._const_tab = __EventReply_eventReplyInfo_tab
    _EventReply_eventReplyInfo._const_tab_at = ('..', u'eventType')
    _EventReply_eventReplyInfo._const_tab_id = u'Value'
    EventReply._cont = ASN1Dict([
        (u'eventType', _EventReply_eventType),
        (u'eventReplyInfo', _EventReply_eventReplyInfo),
        ])
    EventReply._ext = None
    
    #-----< EventReportArgument >-----#
    EventReportArgument = SEQ(name=u'EventReportArgument', mode=MODE_TYPE)
    _EventReportArgument_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _EventReportArgument_managedObjectInstance = CHOICE(name=u'managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _EventReportArgument_eventTime = TIME_GEN(name=u'eventTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EventReportArgument_eventType = CHOICE(name=u'eventType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), [u'id']))
    __EventReportArgument_eventType_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    __EventReportArgument_eventType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _EventReportArgument_eventType._const_tab = __EventReportArgument_eventType_tab
    _EventReportArgument_eventType._const_tab_at = None
    _EventReportArgument_eventType._const_tab_id = u'id'
    _EventReportArgument_eventInfo = OPEN(name=u'eventInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), [u'Value']), opt=True)
    __EventReportArgument_eventInfo_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    __EventReportArgument_eventInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _EventReportArgument_eventInfo._const_tab = __EventReportArgument_eventInfo_tab
    _EventReportArgument_eventInfo._const_tab_at = ('..', u'eventType')
    _EventReportArgument_eventInfo._const_tab_id = u'Value'
    EventReportArgument._cont = ASN1Dict([
        (u'managedObjectClass', _EventReportArgument_managedObjectClass),
        (u'managedObjectInstance', _EventReportArgument_managedObjectInstance),
        (u'eventTime', _EventReportArgument_eventTime),
        (u'eventType', _EventReportArgument_eventType),
        (u'eventInfo', _EventReportArgument_eventInfo),
        ])
    EventReportArgument._ext = []
    
    #-----< EventReportResult >-----#
    EventReportResult = SEQ(name=u'EventReportResult', mode=MODE_TYPE)
    _EventReportResult_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _EventReportResult_managedObjectInstance = CHOICE(name=u'managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _EventReportResult_currentTime = TIME_GEN(name=u'currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EventReportResult_eventReply = SEQ(name=u'eventReply', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReply')), opt=True)
    EventReportResult._cont = ASN1Dict([
        (u'managedObjectClass', _EventReportResult_managedObjectClass),
        (u'managedObjectInstance', _EventReportResult_managedObjectInstance),
        (u'currentTime', _EventReportResult_currentTime),
        (u'eventReply', _EventReportResult_eventReply),
        ])
    EventReportResult._ext = []
    
    #-----< EventSet >-----#
    EventSet = CLASS(name=u'EventSet', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    EventSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EventTypeId >-----#
    EventTypeId = CHOICE(name=u'EventTypeId', mode=MODE_TYPE)
    _EventTypeId_globalForm = OID(name=u'globalForm', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EventTypeId_localForm = INT(name=u'localForm', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    EventTypeId._cont = ASN1Dict([
        (u'globalForm', _EventTypeId_globalForm),
        (u'localForm', _EventTypeId_localForm),
        ])
    EventTypeId._ext = None
    
    #-----< FilterItem >-----#
    FilterItem = CHOICE(name=u'FilterItem', mode=MODE_TYPE)
    _FilterItem_equality = SEQ(name=u'equality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _FilterItem_substrings = SEQ_OF(name=u'substrings', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __FilterItem_substrings__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___FilterItem_substrings__item__initialString = SEQ(name=u'initialString', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    ___FilterItem_substrings__item__anyString = SEQ(name=u'anyString', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    ___FilterItem_substrings__item__finalString = SEQ(name=u'finalString', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    __FilterItem_substrings__item_._cont = ASN1Dict([
        (u'initialString', ___FilterItem_substrings__item__initialString),
        (u'anyString', ___FilterItem_substrings__item__anyString),
        (u'finalString', ___FilterItem_substrings__item__finalString),
        ])
    __FilterItem_substrings__item_._ext = None
    _FilterItem_substrings._cont = __FilterItem_substrings__item_
    _FilterItem_greaterOrEqual = SEQ(name=u'greaterOrEqual', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _FilterItem_lessOrEqual = SEQ(name=u'lessOrEqual', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _FilterItem_present = CHOICE(name=u'present', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    _FilterItem_subsetOf = SEQ(name=u'subsetOf', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _FilterItem_supersetOf = SEQ(name=u'supersetOf', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _FilterItem_nonNullSetIntersection = SEQ(name=u'nonNullSetIntersection', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    FilterItem._cont = ASN1Dict([
        (u'equality', _FilterItem_equality),
        (u'substrings', _FilterItem_substrings),
        (u'greaterOrEqual', _FilterItem_greaterOrEqual),
        (u'lessOrEqual', _FilterItem_lessOrEqual),
        (u'present', _FilterItem_present),
        (u'subsetOf', _FilterItem_subsetOf),
        (u'supersetOf', _FilterItem_supersetOf),
        (u'nonNullSetIntersection', _FilterItem_nonNullSetIntersection),
        ])
    FilterItem._ext = None
    
    #-----< GetArgument >-----#
    GetArgument = SEQ(name=u'GetArgument', mode=MODE_TYPE)
    _GetArgument_baseManagedObjectClass = CHOICE(name=u'baseManagedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _GetArgument_baseManagedObjectInstance = CHOICE(name=u'baseManagedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _GetArgument_accessControl = EXT(name=u'accessControl', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'AccessControl')), opt=True)
    _GetArgument_synchronization = ENUM(name=u'synchronization', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'CMISSync')), default=u'bestEffort')
    _GetArgument_scope = CHOICE(name=u'scope', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'Scope')), default=(u'namedNumbers', 0))
    _GetArgument_filter = CHOICE(name=u'filter', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')), default=(u'and', []))
    _GetArgument_attributeIdList = SET_OF(name=u'attributeIdList', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GetArgument_attributeIdList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    _GetArgument_attributeIdList._cont = __GetArgument_attributeIdList__item_
    GetArgument._cont = ASN1Dict([
        (u'baseManagedObjectClass', _GetArgument_baseManagedObjectClass),
        (u'baseManagedObjectInstance', _GetArgument_baseManagedObjectInstance),
        (u'accessControl', _GetArgument_accessControl),
        (u'synchronization', _GetArgument_synchronization),
        (u'scope', _GetArgument_scope),
        (u'filter', _GetArgument_filter),
        (u'attributeIdList', _GetArgument_attributeIdList),
        ])
    GetArgument._ext = []
    
    #-----< GetInfoStatus >-----#
    GetInfoStatus = CHOICE(name=u'GetInfoStatus', mode=MODE_TYPE)
    _GetInfoStatus_attributeIdError = SEQ(name=u'attributeIdError', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'AttributeIdError')))
    _GetInfoStatus_attribute = SEQ(name=u'attribute', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    GetInfoStatus._cont = ASN1Dict([
        (u'attributeIdError', _GetInfoStatus_attributeIdError),
        (u'attribute', _GetInfoStatus_attribute),
        ])
    GetInfoStatus._ext = None
    
    #-----< GetListError >-----#
    GetListError = SEQ(name=u'GetListError', mode=MODE_TYPE)
    _GetListError_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _GetListError_managedObjectInstance = CHOICE(name=u'managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _GetListError_currentTime = TIME_GEN(name=u'currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GetListError_getInfoList = SET_OF(name=u'getInfoList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GetListError_getInfoList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetInfoStatus')))
    _GetListError_getInfoList._cont = __GetListError_getInfoList__item_
    GetListError._cont = ASN1Dict([
        (u'managedObjectClass', _GetListError_managedObjectClass),
        (u'managedObjectInstance', _GetListError_managedObjectInstance),
        (u'currentTime', _GetListError_currentTime),
        (u'getInfoList', _GetListError_getInfoList),
        ])
    GetListError._ext = []
    
    #-----< GetResult >-----#
    GetResult = SEQ(name=u'GetResult', mode=MODE_TYPE)
    _GetResult_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _GetResult_managedObjectInstance = CHOICE(name=u'managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _GetResult_currentTime = TIME_GEN(name=u'currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GetResult_attributeList = SET_OF(name=u'attributeList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GetResult_attributeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _GetResult_attributeList._cont = __GetResult_attributeList__item_
    GetResult._cont = ASN1Dict([
        (u'managedObjectClass', _GetResult_managedObjectClass),
        (u'managedObjectInstance', _GetResult_managedObjectInstance),
        (u'currentTime', _GetResult_currentTime),
        (u'attributeList', _GetResult_attributeList),
        ])
    GetResult._ext = []
    
    #-----< InvalidArgumentValue >-----#
    InvalidArgumentValue = CHOICE(name=u'InvalidArgumentValue', mode=MODE_TYPE)
    _InvalidArgumentValue_actionValue = SEQ(name=u'actionValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ActionInfo')))
    _InvalidArgumentValue_eventValue = SEQ(name=u'eventValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __InvalidArgumentValue_eventValue_eventType = CHOICE(name=u'eventType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), [u'id']))
    ___InvalidArgumentValue_eventValue_eventType_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    ___InvalidArgumentValue_eventValue_eventType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __InvalidArgumentValue_eventValue_eventType._const_tab = ___InvalidArgumentValue_eventValue_eventType_tab
    __InvalidArgumentValue_eventValue_eventType._const_tab_at = None
    __InvalidArgumentValue_eventValue_eventType._const_tab_id = u'id'
    __InvalidArgumentValue_eventValue_eventInfo = OPEN(name=u'eventInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), [u'Value']), opt=True)
    ___InvalidArgumentValue_eventValue_eventInfo_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    ___InvalidArgumentValue_eventValue_eventInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __InvalidArgumentValue_eventValue_eventInfo._const_tab = ___InvalidArgumentValue_eventValue_eventInfo_tab
    __InvalidArgumentValue_eventValue_eventInfo._const_tab_at = ('..', u'eventType')
    __InvalidArgumentValue_eventValue_eventInfo._const_tab_id = u'Value'
    _InvalidArgumentValue_eventValue._cont = ASN1Dict([
        (u'eventType', __InvalidArgumentValue_eventValue_eventType),
        (u'eventInfo', __InvalidArgumentValue_eventValue_eventInfo),
        ])
    _InvalidArgumentValue_eventValue._ext = None
    InvalidArgumentValue._cont = ASN1Dict([
        (u'actionValue', _InvalidArgumentValue_actionValue),
        (u'eventValue', _InvalidArgumentValue_eventValue),
        ])
    InvalidArgumentValue._ext = None
    
    #-----< InvokeIDType >-----#
    InvokeIDType = CHOICE(name=u'InvokeIDType', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    
    #-----< LinkedReplyArgument >-----#
    LinkedReplyArgument = CHOICE(name=u'LinkedReplyArgument', mode=MODE_TYPE)
    _LinkedReplyArgument_getResult = SEQ(name=u'getResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'GetResult')))
    _LinkedReplyArgument_getListError = SEQ(name=u'getListError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'GetListError')))
    _LinkedReplyArgument_setResult = SEQ(name=u'setResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'SetResult')))
    _LinkedReplyArgument_setListError = SEQ(name=u'setListError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'SetListError')))
    _LinkedReplyArgument_actionResult = SEQ(name=u'actionResult', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ActionResult')))
    _LinkedReplyArgument_processingFailure = SEQ(name=u'processingFailure', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    _LinkedReplyArgument_deleteResult = SEQ(name=u'deleteResult', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'DeleteResult')))
    _LinkedReplyArgument_actionError = SEQ(name=u'actionError', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ActionError')))
    _LinkedReplyArgument_deleteError = SEQ(name=u'deleteError', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'DeleteError')))
    LinkedReplyArgument._cont = ASN1Dict([
        (u'getResult', _LinkedReplyArgument_getResult),
        (u'getListError', _LinkedReplyArgument_getListError),
        (u'setResult', _LinkedReplyArgument_setResult),
        (u'setListError', _LinkedReplyArgument_setListError),
        (u'actionResult', _LinkedReplyArgument_actionResult),
        (u'processingFailure', _LinkedReplyArgument_processingFailure),
        (u'deleteResult', _LinkedReplyArgument_deleteResult),
        (u'actionError', _LinkedReplyArgument_actionError),
        (u'deleteError', _LinkedReplyArgument_deleteError),
        ])
    LinkedReplyArgument._ext = None
    
    #-----< ModifyOperator >-----#
    ModifyOperator = INT(name=u'ModifyOperator', mode=MODE_TYPE)
    ModifyOperator._cont = ASN1Dict([(u'replace', 0), (u'addValues', 1), (u'removeValues', 2), (u'setToDefault', 3)])
    
    #-----< NoSuchAction >-----#
    NoSuchAction = SEQ(name=u'NoSuchAction', mode=MODE_TYPE)
    _NoSuchAction_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _NoSuchAction_actionType = CHOICE(name=u'actionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ACTION'), [u'id']))
    __NoSuchAction_actionType_tab = CLASS(name='_tab_CMIP-ACTION', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    __NoSuchAction_actionType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _NoSuchAction_actionType._const_tab = __NoSuchAction_actionType_tab
    _NoSuchAction_actionType._const_tab_at = None
    _NoSuchAction_actionType._const_tab_id = u'id'
    NoSuchAction._cont = ASN1Dict([
        (u'managedObjectClass', _NoSuchAction_managedObjectClass),
        (u'actionType', _NoSuchAction_actionType),
        ])
    NoSuchAction._ext = []
    
    #-----< NoSuchArgument >-----#
    NoSuchArgument = CHOICE(name=u'NoSuchArgument', mode=MODE_TYPE)
    _NoSuchArgument_actionId = SEQ(name=u'actionId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NoSuchArgument_actionId_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    __NoSuchArgument_actionId_actionType = CHOICE(name=u'actionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ACTION'), [u'id']))
    ___NoSuchArgument_actionId_actionType_tab = CLASS(name='_tab_CMIP-ACTION', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ACTION')))
    ___NoSuchArgument_actionId_actionType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NoSuchArgument_actionId_actionType._const_tab = ___NoSuchArgument_actionId_actionType_tab
    __NoSuchArgument_actionId_actionType._const_tab_at = None
    __NoSuchArgument_actionId_actionType._const_tab_id = u'id'
    _NoSuchArgument_actionId._cont = ASN1Dict([
        (u'managedObjectClass', __NoSuchArgument_actionId_managedObjectClass),
        (u'actionType', __NoSuchArgument_actionId_actionType),
        ])
    _NoSuchArgument_actionId._ext = None
    _NoSuchArgument_eventId = SEQ(name=u'eventId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NoSuchArgument_eventId_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    __NoSuchArgument_eventId_eventType = CHOICE(name=u'eventType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), [u'id']))
    ___NoSuchArgument_eventId_eventType_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    ___NoSuchArgument_eventId_eventType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __NoSuchArgument_eventId_eventType._const_tab = ___NoSuchArgument_eventId_eventType_tab
    __NoSuchArgument_eventId_eventType._const_tab_at = None
    __NoSuchArgument_eventId_eventType._const_tab_id = u'id'
    _NoSuchArgument_eventId._cont = ASN1Dict([
        (u'managedObjectClass', __NoSuchArgument_eventId_managedObjectClass),
        (u'eventType', __NoSuchArgument_eventId_eventType),
        ])
    _NoSuchArgument_eventId._ext = None
    NoSuchArgument._cont = ASN1Dict([
        (u'actionId', _NoSuchArgument_actionId),
        (u'eventId', _NoSuchArgument_eventId),
        ])
    NoSuchArgument._ext = None
    
    #-----< NoSuchEventType >-----#
    NoSuchEventType = SEQ(name=u'NoSuchEventType', mode=MODE_TYPE)
    _NoSuchEventType_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _NoSuchEventType_eventType = CHOICE(name=u'eventType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-EVENT'), [u'id']))
    __NoSuchEventType_eventType_tab = CLASS(name='_tab_CMIP-EVENT', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-EVENT')))
    __NoSuchEventType_eventType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _NoSuchEventType_eventType._const_tab = __NoSuchEventType_eventType_tab
    _NoSuchEventType_eventType._const_tab_at = None
    _NoSuchEventType_eventType._const_tab_id = u'id'
    NoSuchEventType._cont = ASN1Dict([
        (u'managedObjectClass', _NoSuchEventType_managedObjectClass),
        (u'eventType', _NoSuchEventType_eventType),
        ])
    NoSuchEventType._ext = []
    
    #-----< ObjectClass >-----#
    ObjectClass = CHOICE(name=u'ObjectClass', mode=MODE_TYPE)
    _ObjectClass_globalForm = OID(name=u'globalForm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ObjectClass_localForm = INT(name=u'localForm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ObjectClass._cont = ASN1Dict([
        (u'globalForm', _ObjectClass_globalForm),
        (u'localForm', _ObjectClass_localForm),
        ])
    ObjectClass._ext = None
    
    #-----< ObjectInstance >-----#
    ObjectInstance = CHOICE(name=u'ObjectInstance', mode=MODE_TYPE)
    _ObjectInstance_distinguishedName = SEQ_OF(name=u'distinguishedName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'DistinguishedName')))
    _ObjectInstance_nonSpecificForm = OCT_STR(name=u'nonSpecificForm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ObjectInstance_localDistinguishedName = SEQ_OF(name=u'localDistinguishedName', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'RDNSequence')))
    ObjectInstance._cont = ASN1Dict([
        (u'distinguishedName', _ObjectInstance_distinguishedName),
        (u'nonSpecificForm', _ObjectInstance_nonSpecificForm),
        (u'localDistinguishedName', _ObjectInstance_localDistinguishedName),
        ])
    ObjectInstance._ext = None
    
    #-----< ProcessingFailure >-----#
    ProcessingFailure = SEQ(name=u'ProcessingFailure', mode=MODE_TYPE)
    _ProcessingFailure_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _ProcessingFailure_managedObjectInstance = CHOICE(name=u'managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _ProcessingFailure_specificErrorInfo = SEQ(name=u'specificErrorInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'SpecificErrorInfo')))
    ProcessingFailure._cont = ASN1Dict([
        (u'managedObjectClass', _ProcessingFailure_managedObjectClass),
        (u'managedObjectInstance', _ProcessingFailure_managedObjectInstance),
        (u'specificErrorInfo', _ProcessingFailure_specificErrorInfo),
        ])
    ProcessingFailure._ext = []
    
    #-----< RDNSequence >-----#
    RDNSequence = SEQ_OF(name=u'RDNSequence', mode=MODE_TYPE)
    _RDNSequence__item_ = SET_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'RelativeDistinguishedName')))
    RDNSequence._cont = _RDNSequence__item_
    
    #-----< RelativeDistinguishedName >-----#
    RelativeDistinguishedName = SET_OF(name=u'RelativeDistinguishedName', mode=MODE_TYPE)
    _RelativeDistinguishedName__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeValueAssertion')))
    RelativeDistinguishedName._cont = _RelativeDistinguishedName__item_
    
    #-----< Scope >-----#
    Scope = CHOICE(name=u'Scope', mode=MODE_TYPE)
    _Scope_namedNumbers = INT(name=u'namedNumbers', mode=MODE_TYPE)
    _Scope_namedNumbers._cont = ASN1Dict([(u'baseObject', 0), (u'firstLevelOnly', 1), (u'wholeSubtree', 2)])
    _Scope_individualLevels = INT(name=u'individualLevels', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Scope_baseToNthLevel = INT(name=u'baseToNthLevel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Scope._cont = ASN1Dict([
        (u'namedNumbers', _Scope_namedNumbers),
        (u'individualLevels', _Scope_individualLevels),
        (u'baseToNthLevel', _Scope_baseToNthLevel),
        ])
    Scope._ext = None
    
    #-----< SetArgument >-----#
    SetArgument = SEQ(name=u'SetArgument', mode=MODE_TYPE)
    _SetArgument_baseManagedObjectClass = CHOICE(name=u'baseManagedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    _SetArgument_baseManagedObjectInstance = CHOICE(name=u'baseManagedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    _SetArgument_accessControl = EXT(name=u'accessControl', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'AccessControl')), opt=True)
    _SetArgument_synchronization = ENUM(name=u'synchronization', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'CMISSync')), default=u'bestEffort')
    _SetArgument_scope = CHOICE(name=u'scope', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CMIP-1', 'Scope')), default=(u'namedNumbers', 0))
    _SetArgument_filter = CHOICE(name=u'filter', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')), default=(u'and', []))
    _SetArgument_modificationList = SET_OF(name=u'modificationList', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SetArgument_modificationList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___SetArgument_modificationList__item__modifyOperator = INT(name=u'modifyOperator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ModifyOperator')), default=0)
    ___SetArgument_modificationList__item__attributeId = CHOICE(name=u'attributeId', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), [u'id']))
    ____SetArgument_modificationList__item__attributeId_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    ____SetArgument_modificationList__item__attributeId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SetArgument_modificationList__item__attributeId._const_tab = ____SetArgument_modificationList__item__attributeId_tab
    ___SetArgument_modificationList__item__attributeId._const_tab_at = None
    ___SetArgument_modificationList__item__attributeId._const_tab_id = u'id'
    ___SetArgument_modificationList__item__attributeValue = OPEN(name=u'attributeValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-ATTRIBUTE'), [u'Value']), opt=True)
    ____SetArgument_modificationList__item__attributeValue_tab = CLASS(name='_tab_CMIP-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-ATTRIBUTE')))
    ____SetArgument_modificationList__item__attributeValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SetArgument_modificationList__item__attributeValue._const_tab = ____SetArgument_modificationList__item__attributeValue_tab
    ___SetArgument_modificationList__item__attributeValue._const_tab_at = ('..', u'attributeId')
    ___SetArgument_modificationList__item__attributeValue._const_tab_id = u'Value'
    __SetArgument_modificationList__item_._cont = ASN1Dict([
        (u'modifyOperator', ___SetArgument_modificationList__item__modifyOperator),
        (u'attributeId', ___SetArgument_modificationList__item__attributeId),
        (u'attributeValue', ___SetArgument_modificationList__item__attributeValue),
        ])
    __SetArgument_modificationList__item_._ext = None
    _SetArgument_modificationList._cont = __SetArgument_modificationList__item_
    SetArgument._cont = ASN1Dict([
        (u'baseManagedObjectClass', _SetArgument_baseManagedObjectClass),
        (u'baseManagedObjectInstance', _SetArgument_baseManagedObjectInstance),
        (u'accessControl', _SetArgument_accessControl),
        (u'synchronization', _SetArgument_synchronization),
        (u'scope', _SetArgument_scope),
        (u'filter', _SetArgument_filter),
        (u'modificationList', _SetArgument_modificationList),
        ])
    SetArgument._ext = []
    
    #-----< SetInfoStatus >-----#
    SetInfoStatus = CHOICE(name=u'SetInfoStatus', mode=MODE_TYPE)
    _SetInfoStatus_attributeError = SEQ(name=u'attributeError', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'AttributeError')))
    _SetInfoStatus_attribute = SEQ(name=u'attribute', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    SetInfoStatus._cont = ASN1Dict([
        (u'attributeError', _SetInfoStatus_attributeError),
        (u'attribute', _SetInfoStatus_attribute),
        ])
    SetInfoStatus._ext = None
    
    #-----< SetListError >-----#
    SetListError = SEQ(name=u'SetListError', mode=MODE_TYPE)
    _SetListError_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _SetListError_managedObjectInstance = CHOICE(name=u'managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _SetListError_currentTime = TIME_GEN(name=u'currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SetListError_setInfoList = SET_OF(name=u'setInfoList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SetListError_setInfoList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetInfoStatus')))
    _SetListError_setInfoList._cont = __SetListError_setInfoList__item_
    SetListError._cont = ASN1Dict([
        (u'managedObjectClass', _SetListError_managedObjectClass),
        (u'managedObjectInstance', _SetListError_managedObjectInstance),
        (u'currentTime', _SetListError_currentTime),
        (u'setInfoList', _SetListError_setInfoList),
        ])
    SetListError._ext = []
    
    #-----< SetResult >-----#
    SetResult = SEQ(name=u'SetResult', mode=MODE_TYPE)
    _SetResult_managedObjectClass = CHOICE(name=u'managedObjectClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')), opt=True)
    _SetResult_managedObjectInstance = CHOICE(name=u'managedObjectInstance', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')), opt=True)
    _SetResult_currentTime = TIME_GEN(name=u'currentTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SetResult_attributeList = SET_OF(name=u'attributeList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SetResult_attributeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    _SetResult_attributeList._cont = __SetResult_attributeList__item_
    SetResult._cont = ASN1Dict([
        (u'managedObjectClass', _SetResult_managedObjectClass),
        (u'managedObjectInstance', _SetResult_managedObjectInstance),
        (u'currentTime', _SetResult_currentTime),
        (u'attributeList', _SetResult_attributeList),
        ])
    SetResult._ext = []
    
    #-----< SpecificErrorInfo >-----#
    SpecificErrorInfo = SEQ(name=u'SpecificErrorInfo', mode=MODE_TYPE)
    _SpecificErrorInfo_errorId = OID(name=u'errorId', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-SPECIFICERROR'), [u'id']))
    __SpecificErrorInfo_errorId_tab = CLASS(name='_tab_CMIP-SPECIFICERROR', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-SPECIFICERROR')))
    __SpecificErrorInfo_errorId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SpecificErrorInfo_errorId._const_tab = __SpecificErrorInfo_errorId_tab
    _SpecificErrorInfo_errorId._const_tab_at = None
    _SpecificErrorInfo_errorId._const_tab_id = u'id'
    _SpecificErrorInfo_errorInfo = OPEN(name=u'errorInfo', mode=MODE_TYPE, typeref=ASN1RefClassField(('CMIP-1', 'CMIP-SPECIFICERROR'), [u'Value']))
    __SpecificErrorInfo_errorInfo_tab = CLASS(name='_tab_CMIP-SPECIFICERROR', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-SPECIFICERROR')))
    __SpecificErrorInfo_errorInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SpecificErrorInfo_errorInfo._const_tab = __SpecificErrorInfo_errorInfo_tab
    _SpecificErrorInfo_errorInfo._const_tab_at = ('..', u'errorId')
    _SpecificErrorInfo_errorInfo._const_tab_id = u'Value'
    SpecificErrorInfo._cont = ASN1Dict([
        (u'errorId', _SpecificErrorInfo_errorId),
        (u'errorInfo', _SpecificErrorInfo_errorInfo),
        ])
    SpecificErrorInfo._ext = None
    
    #-----< SpecificErrorSet >-----#
    SpecificErrorSet = CLASS(name=u'SpecificErrorSet', mode=MODE_SET, typeref=ASN1RefType(('CMIP-1', 'CMIP-SPECIFICERROR')))
    SpecificErrorSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ROSEapdus >-----#
    ROSEapdus = CHOICE(name=u'ROSEapdus', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')))
    _ROSEapdus_invoke = SEQ(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Invoke')))
    __ROSEapdus_invoke_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    __ROSEapdus_invoke_invokeId._const_val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ROSEapdus_invoke_linkedId = CHOICE(name=u'linkedId', mode=MODE_TYPE, opt=True)
    ___ROSEapdus_invoke_linkedId_present = INT(name=u'present', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefChoiceComp(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId'), [u'present']))
    ___ROSEapdus_invoke_linkedId_absent = NULL(name=u'absent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ROSEapdus_invoke_linkedId._cont = ASN1Dict([
        (u'present', ___ROSEapdus_invoke_linkedId_present),
        (u'absent', ___ROSEapdus_invoke_linkedId_absent),
        ])
    __ROSEapdus_invoke_linkedId._ext = None
    __ROSEapdus_invoke_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ___ROSEapdus_invoke_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_1 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ResultType_1 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionResult')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ResultType_3 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateResult')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ResultType_4 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteResult')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ResultType_6 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportResult')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_7 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ResultType_7 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetResult')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_8 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'LinkedReplyArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_9 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_10 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    ____ROSEapdus_invoke_opcode_tab_val_ResultType_10 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetResult')))
    ___ROSEapdus_invoke_opcode_tab._val = ASN1Set(rv=[dict([(u'ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_0), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_1), (u'ResultType', ____ROSEapdus_invoke_opcode_tab_val_ResultType_1), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 14))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_11), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_2), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 21))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 22))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_3), (u'ResultType', ____ROSEapdus_invoke_opcode_tab_val_ResultType_3), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 17))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 18))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 12))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_4), (u'ResultType', ____ROSEapdus_invoke_opcode_tab_val_ResultType_4), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_5), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 0))]), dict([(u'ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_6), (u'ResultType', ____ROSEapdus_invoke_opcode_tab_val_ResultType_6), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 14))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 13))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_7), (u'ResultType', ____ROSEapdus_invoke_opcode_tab_val_ResultType_7), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 23))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_0), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_8), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_9), (u'returnResult', False), (u'alwaysReturns', False), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_10), (u'ResultType', ____ROSEapdus_invoke_opcode_tab_val_ResultType_10), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))])], rr=[], ev=None, er=[])
    __ROSEapdus_invoke_opcode._const_tab = ___ROSEapdus_invoke_opcode_tab
    __ROSEapdus_invoke_opcode._const_tab_at = None
    __ROSEapdus_invoke_opcode._const_tab_id = u'operationCode'
    __ROSEapdus_invoke_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ArgumentType']), opt=True)
    __ROSEapdus_invoke_argument._const_tab = ___ROSEapdus_invoke_opcode_tab
    __ROSEapdus_invoke_argument._const_tab_at = ('..', u'opcode')
    __ROSEapdus_invoke_argument._const_tab_id = u'ArgumentType'
    _ROSEapdus_invoke._cont = ASN1Dict([
        (u'invokeId', __ROSEapdus_invoke_invokeId),
        (u'linkedId', __ROSEapdus_invoke_linkedId),
        (u'opcode', __ROSEapdus_invoke_opcode),
        (u'argument', __ROSEapdus_invoke_argument),
        ])
    _ROSEapdus_invoke._ext = None
    _ROSEapdus_returnResult = SEQ(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResult')))
    __ROSEapdus_returnResult_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    __ROSEapdus_returnResult_result = SEQ(name=u'result', mode=MODE_TYPE, opt=True)
    ___ROSEapdus_returnResult_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'operationCode']))
    ____ROSEapdus_returnResult_result_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_0 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionArgument')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_0 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ActionResult')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_2 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateArgument')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_2 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CreateResult')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_3 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteArgument')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_3 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'DeleteResult')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_4 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportArgument')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_4 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'EventReportResult')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_5 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetArgument')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_5 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetResult')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_6 = SEQ(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetArgument')))
    _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_6 = SEQ(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetResult')))
    ____ROSEapdus_returnResult_result_opcode_tab._val = ASN1Set(rv=[dict([(u'ArgumentType', _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_0), (u'ResultType', _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_0), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 14))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_11), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_1), (u'returnResult', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 21))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 22))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_2), (u'ResultType', _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_2), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 17))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 18))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 12))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_3), (u'ResultType', _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_3), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_4), (u'ResultType', _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_4), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 15))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 14))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 13))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_5), (u'ResultType', _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_5), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 23))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_0), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10_0), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_6), (u'ResultType', _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_6), (u'resultTypeOptional', True), (u'Errors', ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_2), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 8))]), dict([(u'ParameterType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'Linked', ASN1Set(rv=[dict([(u'ArgumentType', _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))])], rr=[], ev=None, er=[])
    ___ROSEapdus_returnResult_result_opcode._const_tab = ____ROSEapdus_returnResult_result_opcode_tab
    ___ROSEapdus_returnResult_result_opcode._const_tab_at = None
    ___ROSEapdus_returnResult_result_opcode._const_tab_id = u'operationCode'
    ___ROSEapdus_returnResult_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'OPERATION'), [u'ResultType']))
    ___ROSEapdus_returnResult_result_result._const_tab = ____ROSEapdus_returnResult_result_opcode_tab
    ___ROSEapdus_returnResult_result_result._const_tab_at = ('..', u'opcode')
    ___ROSEapdus_returnResult_result_result._const_tab_id = u'ResultType'
    __ROSEapdus_returnResult_result._cont = ASN1Dict([
        (u'opcode', ___ROSEapdus_returnResult_result_opcode),
        (u'result', ___ROSEapdus_returnResult_result_result),
        ])
    __ROSEapdus_returnResult_result._ext = None
    _ROSEapdus_returnResult._cont = ASN1Dict([
        (u'invokeId', __ROSEapdus_returnResult_invokeId),
        (u'result', __ROSEapdus_returnResult_result),
        ])
    _ROSEapdus_returnResult._ext = None
    _ROSEapdus_returnError = SEQ(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnError')))
    __ROSEapdus_returnError_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    __ROSEapdus_returnError_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'errorCode']))
    ___ROSEapdus_returnError_errcode_tab = CLASS(name='_tab_ERROR', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_1 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'BaseManagedObjectId')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_2 = SET(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ComplexityLimitation')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_3 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Scope')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_4 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvalidArgumentValue')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_5 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISFilter')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_6 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchAction')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_7 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchArgument')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_8 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectClass')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_9 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_10 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ProcessingFailure')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_11 = ENUM(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'CMISSync')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_13 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'InvokeIDType')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_14 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_15 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'Attribute')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_16 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_17 = SET_OF(name=u'ParameterType', mode=MODE_TYPE)
    _____ROSEapdus_returnError_errcode_tab_val_ParameterType_17__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_17._cont = _____ROSEapdus_returnError_errcode_tab_val_ParameterType_17__item_
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_18 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'AttributeId')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_19 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_20 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'NoSuchEventType')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_21 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'GetListError')))
    ____ROSEapdus_returnError_errcode_tab_val_ParameterType_23 = SEQ(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'SetListError')))
    ___ROSEapdus_returnError_errcode_tab._val = ASN1Set(rv=[dict([(u'ErrorPriority', ASN1Set(rv=[0], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_1), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 19))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_2), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 20))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_3), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 16))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_4), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 15))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_5), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_6), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_7), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 14))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_8), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 0))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_9), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_10), (u'parameterTypeOptional', True), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 10))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_11), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 3))]), dict([(u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 21))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_13), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 22))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_14), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 11))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_15), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_16), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 17))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_17), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 18))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_18), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_19), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 12))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_20), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 13))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_21), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 7))]), dict([(u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 23))]), dict([(u'ParameterType', ____ROSEapdus_returnError_errcode_tab_val_ParameterType_23), (u'ErrorPriority', ASN1Set(rv=[1], rr=[], ev=None, er=[])), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])
    __ROSEapdus_returnError_errcode._const_tab = ___ROSEapdus_returnError_errcode_tab
    __ROSEapdus_returnError_errcode._const_tab_at = None
    __ROSEapdus_returnError_errcode._const_tab_id = u'errorCode'
    __ROSEapdus_returnError_parameter = OPEN(name=u'parameter', mode=MODE_TYPE, typeref=ASN1RefClassField(('Remote-Operations-Information-Objects', 'ERROR'), [u'ParameterType']), opt=True)
    __ROSEapdus_returnError_parameter._const_tab = ___ROSEapdus_returnError_errcode_tab
    __ROSEapdus_returnError_parameter._const_tab_at = ('..', u'errcode')
    __ROSEapdus_returnError_parameter._const_tab_id = u'ParameterType'
    _ROSEapdus_returnError._cont = ASN1Dict([
        (u'invokeId', __ROSEapdus_returnError_invokeId),
        (u'errcode', __ROSEapdus_returnError_errcode),
        (u'parameter', __ROSEapdus_returnError_parameter),
        ])
    _ROSEapdus_returnError._ext = None
    _ROSEapdus_reject = SEQ(name=u'reject', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'Reject')))
    ROSEapdus._cont = ASN1Dict([
        (u'invoke', _ROSEapdus_invoke),
        (u'returnResult', _ROSEapdus_returnResult),
        (u'returnError', _ROSEapdus_returnError),
        (u'reject', _ROSEapdus_reject),
        ])
    ROSEapdus._ext = None
    
    _all_ = [
        CMIP_Operations,
        _CMIP_Operations_val_ArgumentType_0,
        _CMIP_Operations_val_ArgumentType_1,
        _CMIP_Operations_val_ResultType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_11,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Linked_val_ArgumentType_0,
        _CMIP_Operations_val_ArgumentType_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_0,
        _CMIP_Operations_val_ArgumentType_3,
        _CMIP_Operations_val_ResultType_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_0,
        ______gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0__item_,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_0,
        _CMIP_Operations_val_ArgumentType_4,
        _CMIP_Operations_val_ResultType_4,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_1,
        _CMIP_Operations_val_ArgumentType_5,
        _CMIP_Operations_val_ArgumentType_6,
        _CMIP_Operations_val_ResultType_6,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_1_1,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_2_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_2,
        _CMIP_Operations_val_ArgumentType_7,
        _CMIP_Operations_val_ResultType_7,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_3_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_4_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_5_3,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_6_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_7_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_0,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_10_0,
        _CMIP_Operations_val_ArgumentType_8,
        _CMIP_Operations_val_ArgumentType_9,
        _CMIP_Operations_val_ArgumentType_10,
        _CMIP_Operations_val_ResultType_10,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_8_2,
        _____gsmSSF_Initiates_InitiatorConsumerOf_Supplier_Errors_val_ParameterType_9_1,
        CMIP_Confirmed_Operations,
        _CMIP_Confirmed_Operations_val_ArgumentType_0,
        _CMIP_Confirmed_Operations_val_ResultType_0,
        _CMIP_Confirmed_Operations_val_ArgumentType_1,
        _CMIP_Confirmed_Operations_val_ArgumentType_2,
        _CMIP_Confirmed_Operations_val_ResultType_2,
        _CMIP_Confirmed_Operations_val_ArgumentType_3,
        _CMIP_Confirmed_Operations_val_ResultType_3,
        _CMIP_Confirmed_Operations_val_ArgumentType_4,
        _CMIP_Confirmed_Operations_val_ResultType_4,
        _CMIP_Confirmed_Operations_val_ArgumentType_5,
        _CMIP_Confirmed_Operations_val_ResultType_5,
        _CMIP_Confirmed_Operations_val_ArgumentType_6,
        _CMIP_Confirmed_Operations_val_ResultType_6,
        accessDenied,
        classInstanceConflict,
        _classInstanceConflict_val_ParameterType,
        complexityLimitation,
        _complexityLimitation_val_ParameterType,
        duplicateManagedObjectInstance,
        _duplicateManagedObjectInstance_val_ParameterType,
        getListError,
        _getListError_val_ParameterType,
        invalidArgumentValue,
        _invalidArgumentValue_val_ParameterType,
        invalidAttributeValue,
        _invalidAttributeValue_val_ParameterType,
        invalidFilter,
        _invalidFilter_val_ParameterType,
        invalidObjectInstance,
        _invalidObjectInstance_val_ParameterType,
        invalidScope,
        _invalidScope_val_ParameterType,
        missingAttributeValue,
        __missingAttributeValue_val_ParameterType__item_,
        _missingAttributeValue_val_ParameterType,
        mistypedOperation,
        noSuchAction,
        _noSuchAction_val_ParameterType,
        noSuchArgument,
        _noSuchArgument_val_ParameterType,
        noSuchAttribute,
        _noSuchAttribute_val_ParameterType,
        noSuchEventType,
        _noSuchEventType_val_ParameterType,
        noSuchInvokeId,
        _noSuchInvokeId_val_ParameterType,
        noSuchObjectClass,
        _noSuchObjectClass_val_ParameterType,
        noSuchObjectInstance,
        _noSuchObjectInstance_val_ParameterType,
        noSuchReferenceObject,
        _noSuchReferenceObject_val_ParameterType,
        operationCancelled,
        processingFailure,
        _processingFailure_val_ParameterType,
        setListError,
        _setListError_val_ParameterType,
        syncNotSupported,
        _syncNotSupported_val_ParameterType,
        m_Action,
        _m_Action_val_ArgumentType,
        m_Action_Confirmed,
        _m_Action_Confirmed_val_ArgumentType,
        _m_Action_Confirmed_val_ResultType,
        m_CancelGet,
        _m_CancelGet_val_ArgumentType,
        m_Create,
        _m_Create_val_ArgumentType,
        _m_Create_val_ResultType,
        m_Delete,
        _m_Delete_val_ArgumentType,
        _m_Delete_val_ResultType,
        m_EventReport,
        _m_EventReport_val_ArgumentType,
        m_EventReport_Confirmed,
        _m_EventReport_Confirmed_val_ArgumentType,
        _m_EventReport_Confirmed_val_ResultType,
        m_Get,
        _m_Get_val_ArgumentType,
        _m_Get_val_ResultType,
        m_Linked_Reply,
        _m_Linked_Reply_val_ArgumentType,
        m_Set,
        _m_Set_val_ArgumentType,
        m_Set_Confirmed,
        _m_Set_Confirmed_val_ArgumentType,
        _m_Set_Confirmed_val_ResultType,
        _CMIP_ACTION_id,
        _CMIP_ACTION_Value,
        CMIP_ACTION,
        _CMIP_ATTRIBUTE_id,
        _CMIP_ATTRIBUTE_Value,
        CMIP_ATTRIBUTE,
        _CMIP_AVA_id,
        _CMIP_AVA_Value,
        CMIP_AVA,
        _CMIP_EVENT_id,
        _CMIP_EVENT_Value,
        CMIP_EVENT,
        _CMIP_SPECIFICERROR_id,
        _CMIP_SPECIFICERROR_Value,
        CMIP_SPECIFICERROR,
        AccessControl,
        _ActionArgument_baseManagedObjectClass,
        _ActionArgument_baseManagedObjectInstance,
        _ActionArgument_accessControl,
        _ActionArgument_synchronization,
        _ActionArgument_scope,
        _ActionArgument_filter,
        _ActionArgument_actionInfo,
        ActionArgument,
        _ActionError_managedObjectClass,
        _ActionError_managedObjectInstance,
        _ActionError_currentTime,
        _ActionError_actionErrorInfo,
        ActionError,
        _ActionErrorInfo_errorStatus,
        ___ActionErrorInfo_errorInfo_actionType_tab,
        __ActionErrorInfo_errorInfo_actionType,
        __ActionErrorInfo_errorInfo_actionArgument,
        __ActionErrorInfo_errorInfo_argumentValue,
        _ActionErrorInfo_errorInfo,
        ActionErrorInfo,
        __ActionInfo_actionType_tab,
        _ActionInfo_actionType,
        __ActionInfo_actionInfoArg_tab,
        _ActionInfo_actionInfoArg,
        ActionInfo,
        __ActionReply_actionType_tab,
        _ActionReply_actionType,
        __ActionReply_actionReplyInfo_tab,
        _ActionReply_actionReplyInfo,
        ActionReply,
        _ActionResult_managedObjectClass,
        _ActionResult_managedObjectInstance,
        _ActionResult_currentTime,
        _ActionResult_actionReply,
        ActionResult,
        ActionSet,
        _ActionTypeId_globalForm,
        _ActionTypeId_localForm,
        ActionTypeId,
        __Attribute_id_tab,
        _Attribute_id,
        __Attribute_value_tab,
        _Attribute_value,
        Attribute,
        _AttributeError_errorStatus,
        _AttributeError_modifyOperator,
        __AttributeError_attributeId_tab,
        _AttributeError_attributeId,
        __AttributeError_attributeValue_tab,
        _AttributeError_attributeValue,
        AttributeError,
        _AttributeId_globalForm,
        _AttributeId_localForm,
        AttributeId,
        _AttributeIdError_errorStatus,
        _AttributeIdError_attributeId,
        AttributeIdError,
        AttributeSet,
        __AttributeValueAssertion_id_tab,
        _AttributeValueAssertion_id,
        __AttributeValueAssertion_value_tab,
        _AttributeValueAssertion_value,
        AttributeValueAssertion,
        AvaSet,
        _BaseManagedObjectId_baseManagedObjectClass,
        _BaseManagedObjectId_baseManagedObjectInstance,
        BaseManagedObjectId,
        _CMISFilter_item,
        __CMISFilter_and___item_,
        _CMISFilter_and_,
        __CMISFilter_or___item_,
        _CMISFilter_or_,
        _CMISFilter_not_,
        CMISFilter,
        CMISSync,
        _ComplexityLimitation_scope,
        _ComplexityLimitation_filter,
        _ComplexityLimitation_sync,
        ComplexityLimitation,
        _CreateArgument_managedObjectClass,
        __CreateArgument_managedOrSuperiorObjectInstance_managedObjectInstance,
        __CreateArgument_managedOrSuperiorObjectInstance_superiorObjectInstance,
        _CreateArgument_managedOrSuperiorObjectInstance,
        _CreateArgument_accessControl,
        _CreateArgument_referenceObjectInstance,
        __CreateArgument_attributeList__item_,
        _CreateArgument_attributeList,
        CreateArgument,
        _CreateResult_managedObjectClass,
        _CreateResult_managedObjectInstance,
        _CreateResult_currentTime,
        __CreateResult_attributeList__item_,
        _CreateResult_attributeList,
        CreateResult,
        _DeleteArgument_baseManagedObjectClass,
        _DeleteArgument_baseManagedObjectInstance,
        _DeleteArgument_accessControl,
        _DeleteArgument_synchronization,
        _DeleteArgument_scope,
        _DeleteArgument_filter,
        DeleteArgument,
        _DeleteError_managedObjectClass,
        _DeleteError_managedObjectInstance,
        _DeleteError_currentTime,
        _DeleteError_deleteErrorInfo,
        DeleteError,
        _DeleteResult_managedObjectClass,
        _DeleteResult_managedObjectInstance,
        _DeleteResult_currentTime,
        DeleteResult,
        DistinguishedName,
        __EventReply_eventType_tab,
        _EventReply_eventType,
        __EventReply_eventReplyInfo_tab,
        _EventReply_eventReplyInfo,
        EventReply,
        _EventReportArgument_managedObjectClass,
        _EventReportArgument_managedObjectInstance,
        _EventReportArgument_eventTime,
        __EventReportArgument_eventType_tab,
        _EventReportArgument_eventType,
        __EventReportArgument_eventInfo_tab,
        _EventReportArgument_eventInfo,
        EventReportArgument,
        _EventReportResult_managedObjectClass,
        _EventReportResult_managedObjectInstance,
        _EventReportResult_currentTime,
        _EventReportResult_eventReply,
        EventReportResult,
        EventSet,
        _EventTypeId_globalForm,
        _EventTypeId_localForm,
        EventTypeId,
        _FilterItem_equality,
        ___FilterItem_substrings__item__initialString,
        ___FilterItem_substrings__item__anyString,
        ___FilterItem_substrings__item__finalString,
        __FilterItem_substrings__item_,
        _FilterItem_substrings,
        _FilterItem_greaterOrEqual,
        _FilterItem_lessOrEqual,
        _FilterItem_present,
        _FilterItem_subsetOf,
        _FilterItem_supersetOf,
        _FilterItem_nonNullSetIntersection,
        FilterItem,
        _GetArgument_baseManagedObjectClass,
        _GetArgument_baseManagedObjectInstance,
        _GetArgument_accessControl,
        _GetArgument_synchronization,
        _GetArgument_scope,
        _GetArgument_filter,
        __GetArgument_attributeIdList__item_,
        _GetArgument_attributeIdList,
        GetArgument,
        _GetInfoStatus_attributeIdError,
        _GetInfoStatus_attribute,
        GetInfoStatus,
        _GetListError_managedObjectClass,
        _GetListError_managedObjectInstance,
        _GetListError_currentTime,
        __GetListError_getInfoList__item_,
        _GetListError_getInfoList,
        GetListError,
        _GetResult_managedObjectClass,
        _GetResult_managedObjectInstance,
        _GetResult_currentTime,
        __GetResult_attributeList__item_,
        _GetResult_attributeList,
        GetResult,
        _InvalidArgumentValue_actionValue,
        ___InvalidArgumentValue_eventValue_eventType_tab,
        __InvalidArgumentValue_eventValue_eventType,
        ___InvalidArgumentValue_eventValue_eventInfo_tab,
        __InvalidArgumentValue_eventValue_eventInfo,
        _InvalidArgumentValue_eventValue,
        InvalidArgumentValue,
        InvokeIDType,
        _LinkedReplyArgument_getResult,
        _LinkedReplyArgument_getListError,
        _LinkedReplyArgument_setResult,
        _LinkedReplyArgument_setListError,
        _LinkedReplyArgument_actionResult,
        _LinkedReplyArgument_processingFailure,
        _LinkedReplyArgument_deleteResult,
        _LinkedReplyArgument_actionError,
        _LinkedReplyArgument_deleteError,
        LinkedReplyArgument,
        ModifyOperator,
        _NoSuchAction_managedObjectClass,
        __NoSuchAction_actionType_tab,
        _NoSuchAction_actionType,
        NoSuchAction,
        __NoSuchArgument_actionId_managedObjectClass,
        ___NoSuchArgument_actionId_actionType_tab,
        __NoSuchArgument_actionId_actionType,
        _NoSuchArgument_actionId,
        __NoSuchArgument_eventId_managedObjectClass,
        ___NoSuchArgument_eventId_eventType_tab,
        __NoSuchArgument_eventId_eventType,
        _NoSuchArgument_eventId,
        NoSuchArgument,
        _NoSuchEventType_managedObjectClass,
        __NoSuchEventType_eventType_tab,
        _NoSuchEventType_eventType,
        NoSuchEventType,
        _ObjectClass_globalForm,
        _ObjectClass_localForm,
        ObjectClass,
        _ObjectInstance_distinguishedName,
        _ObjectInstance_nonSpecificForm,
        _ObjectInstance_localDistinguishedName,
        ObjectInstance,
        _ProcessingFailure_managedObjectClass,
        _ProcessingFailure_managedObjectInstance,
        _ProcessingFailure_specificErrorInfo,
        ProcessingFailure,
        _RDNSequence__item_,
        RDNSequence,
        _RelativeDistinguishedName__item_,
        RelativeDistinguishedName,
        _Scope_namedNumbers,
        _Scope_individualLevels,
        _Scope_baseToNthLevel,
        Scope,
        _SetArgument_baseManagedObjectClass,
        _SetArgument_baseManagedObjectInstance,
        _SetArgument_accessControl,
        _SetArgument_synchronization,
        _SetArgument_scope,
        _SetArgument_filter,
        ___SetArgument_modificationList__item__modifyOperator,
        ____SetArgument_modificationList__item__attributeId_tab,
        ___SetArgument_modificationList__item__attributeId,
        ____SetArgument_modificationList__item__attributeValue_tab,
        ___SetArgument_modificationList__item__attributeValue,
        __SetArgument_modificationList__item_,
        _SetArgument_modificationList,
        SetArgument,
        _SetInfoStatus_attributeError,
        _SetInfoStatus_attribute,
        SetInfoStatus,
        _SetListError_managedObjectClass,
        _SetListError_managedObjectInstance,
        _SetListError_currentTime,
        __SetListError_setInfoList__item_,
        _SetListError_setInfoList,
        SetListError,
        _SetResult_managedObjectClass,
        _SetResult_managedObjectInstance,
        _SetResult_currentTime,
        __SetResult_attributeList__item_,
        _SetResult_attributeList,
        SetResult,
        __SpecificErrorInfo_errorId_tab,
        _SpecificErrorInfo_errorId,
        __SpecificErrorInfo_errorInfo_tab,
        _SpecificErrorInfo_errorInfo,
        SpecificErrorInfo,
        SpecificErrorSet,
        __ROSEapdus_invoke_invokeId,
        ___ROSEapdus_invoke_linkedId_present,
        ___ROSEapdus_invoke_linkedId_absent,
        __ROSEapdus_invoke_linkedId,
        ___ROSEapdus_invoke_opcode_tab,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_0,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_1,
        ____ROSEapdus_invoke_opcode_tab_val_ResultType_1,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_2,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_3,
        ____ROSEapdus_invoke_opcode_tab_val_ResultType_3,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_4,
        ____ROSEapdus_invoke_opcode_tab_val_ResultType_4,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_5,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_6,
        ____ROSEapdus_invoke_opcode_tab_val_ResultType_6,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_7,
        ____ROSEapdus_invoke_opcode_tab_val_ResultType_7,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_8,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_9,
        ____ROSEapdus_invoke_opcode_tab_val_ArgumentType_10,
        ____ROSEapdus_invoke_opcode_tab_val_ResultType_10,
        __ROSEapdus_invoke_opcode,
        __ROSEapdus_invoke_argument,
        _ROSEapdus_invoke,
        __ROSEapdus_returnResult_invokeId,
        ____ROSEapdus_returnResult_result_opcode_tab,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_0,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_0,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_1,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_2,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_2,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_3,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_3,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_4,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_4,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_5,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_5,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ArgumentType_6,
        _____ROSEapdus_returnResult_result_opcode_tab_val_ResultType_6,
        ___ROSEapdus_returnResult_result_opcode,
        ___ROSEapdus_returnResult_result_result,
        __ROSEapdus_returnResult_result,
        _ROSEapdus_returnResult,
        __ROSEapdus_returnError_invokeId,
        ___ROSEapdus_returnError_errcode_tab,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_1,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_2,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_3,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_4,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_5,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_6,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_7,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_8,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_9,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_10,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_11,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_13,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_14,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_15,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_16,
        _____ROSEapdus_returnError_errcode_tab_val_ParameterType_17__item_,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_17,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_18,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_19,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_20,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_21,
        ____ROSEapdus_returnError_errcode_tab_val_ParameterType_23,
        __ROSEapdus_returnError_errcode,
        __ROSEapdus_returnError_parameter,
        _ROSEapdus_returnError,
        _ROSEapdus_reject,
        ROSEapdus,
    ]

class CommonProtocolSpecification:

    _name_  = u'CommonProtocolSpecification'
    _oid_   = [2, 5, 1, 35, 8]
    
    _obj_ = [
        u'OPERATION',
        u'ERROR',
        u'Code',
        u'InvokeId',
        u'id-opcode-read',
        u'id-opcode-compare',
        u'id-opcode-abandon',
        u'id-opcode-list',
        u'id-opcode-search',
        u'id-opcode-addEntry',
        u'id-opcode-removeEntry',
        u'id-opcode-modifyEntry',
        u'id-opcode-modifyDN',
        u'id-opcode-changePassword',
        u'id-opcode-administerPassword',
        u'id-opcode-ldapTransport',
        u'id-opcode-linkedLDAP',
        u'id-opcode-requestShadowUpdate',
        u'id-opcode-updateShadow',
        u'id-opcode-coordinateShadowUpdate',
        u'id-op-establishOperationalBinding',
        u'id-op-modifyOperationalBinding',
        u'id-op-terminateOperationalBinding',
        u'id-errcode-attributeError',
        u'id-errcode-nameError',
        u'id-errcode-serviceError',
        u'id-errcode-referral',
        u'id-errcode-abandoned',
        u'id-errcode-securityError',
        u'id-errcode-abandonFailed',
        u'id-errcode-updateError',
        u'id-errcode-dsaReferral',
        u'id-errcode-shadowError',
        u'id-err-operationalBindingError',
        u'DOP-Invokable',
        u'DOP-Returnable',
        ]
    _type_ = [
        u'OPERATION',
        u'ERROR',
        u'Code',
        u'InvokeId',
        ]
    _set_ = [
        u'DOP-Invokable',
        u'DOP-Returnable',
        ]
    _val_ = [
        u'id-opcode-read',
        u'id-opcode-compare',
        u'id-opcode-abandon',
        u'id-opcode-list',
        u'id-opcode-search',
        u'id-opcode-addEntry',
        u'id-opcode-removeEntry',
        u'id-opcode-modifyEntry',
        u'id-opcode-modifyDN',
        u'id-opcode-changePassword',
        u'id-opcode-administerPassword',
        u'id-opcode-ldapTransport',
        u'id-opcode-linkedLDAP',
        u'id-opcode-requestShadowUpdate',
        u'id-opcode-updateShadow',
        u'id-opcode-coordinateShadowUpdate',
        u'id-op-establishOperationalBinding',
        u'id-op-modifyOperationalBinding',
        u'id-op-terminateOperationalBinding',
        u'id-errcode-attributeError',
        u'id-errcode-nameError',
        u'id-errcode-serviceError',
        u'id-errcode-referral',
        u'id-errcode-abandoned',
        u'id-errcode-securityError',
        u'id-errcode-abandonFailed',
        u'id-errcode-updateError',
        u'id-errcode-dsaReferral',
        u'id-errcode-shadowError',
        u'id-err-operationalBindingError',
        ]
    _class_ = [
        u'OPERATION',
        u'ERROR',
        u'DOP-Invokable',
        u'DOP-Returnable',
        ]
    _param_ = [
        ]
    
    #-----< OPERATION >-----#
    OPERATION = CLASS(name=u'OPERATION', mode=MODE_TYPE)
    _OPERATION_ArgumentType = OPEN(name=u'ArgumentType', mode=MODE_TYPE, opt=True)
    _OPERATION_ResultType = OPEN(name=u'ResultType', mode=MODE_TYPE, opt=True)
    _OPERATION_Errors = CLASS(name=u'Errors', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')), opt=True)
    _OPERATION_operationCode = CHOICE(name=u'operationCode', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')), opt=True, uniq=True)
    OPERATION._cont = ASN1Dict([
        (u'ArgumentType', _OPERATION_ArgumentType),
        (u'ResultType', _OPERATION_ResultType),
        (u'Errors', _OPERATION_Errors),
        (u'operationCode', _OPERATION_operationCode),
        ])
    
    #-----< ERROR >-----#
    ERROR = CLASS(name=u'ERROR', mode=MODE_TYPE)
    _ERROR_ParameterType = OPEN(name=u'ParameterType', mode=MODE_TYPE)
    _ERROR_errorCode = CHOICE(name=u'errorCode', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')), opt=True, uniq=True)
    ERROR._cont = ASN1Dict([
        (u'ParameterType', _ERROR_ParameterType),
        (u'errorCode', _ERROR_errorCode),
        ])
    
    #-----< Code >-----#
    Code = CHOICE(name=u'Code', mode=MODE_TYPE)
    _Code_local = INT(name=u'local', mode=MODE_TYPE)
    _Code_global_ = OID(name=u'global', mode=MODE_TYPE)
    Code._cont = ASN1Dict([
        (u'local', _Code_local),
        (u'global', _Code_global_),
        ])
    Code._ext = []
    
    #-----< InvokeId >-----#
    InvokeId = CHOICE(name=u'InvokeId', mode=MODE_TYPE)
    _InvokeId_present = INT(name=u'present', mode=MODE_TYPE)
    _InvokeId_absent = NULL(name=u'absent', mode=MODE_TYPE)
    InvokeId._cont = ASN1Dict([
        (u'present', _InvokeId_present),
        (u'absent', _InvokeId_absent),
        ])
    InvokeId._ext = []
    
    #-----< id-opcode-read >-----#
    id_opcode_read = CHOICE(name=u'id-opcode-read', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_read._val = (u'local', 1)
    
    #-----< id-opcode-compare >-----#
    id_opcode_compare = CHOICE(name=u'id-opcode-compare', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_compare._val = (u'local', 2)
    
    #-----< id-opcode-abandon >-----#
    id_opcode_abandon = CHOICE(name=u'id-opcode-abandon', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_abandon._val = (u'local', 3)
    
    #-----< id-opcode-list >-----#
    id_opcode_list = CHOICE(name=u'id-opcode-list', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_list._val = (u'local', 4)
    
    #-----< id-opcode-search >-----#
    id_opcode_search = CHOICE(name=u'id-opcode-search', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_search._val = (u'local', 5)
    
    #-----< id-opcode-addEntry >-----#
    id_opcode_addEntry = CHOICE(name=u'id-opcode-addEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_addEntry._val = (u'local', 6)
    
    #-----< id-opcode-removeEntry >-----#
    id_opcode_removeEntry = CHOICE(name=u'id-opcode-removeEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_removeEntry._val = (u'local', 7)
    
    #-----< id-opcode-modifyEntry >-----#
    id_opcode_modifyEntry = CHOICE(name=u'id-opcode-modifyEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_modifyEntry._val = (u'local', 8)
    
    #-----< id-opcode-modifyDN >-----#
    id_opcode_modifyDN = CHOICE(name=u'id-opcode-modifyDN', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_modifyDN._val = (u'local', 9)
    
    #-----< id-opcode-changePassword >-----#
    id_opcode_changePassword = CHOICE(name=u'id-opcode-changePassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_changePassword._val = (u'local', 10)
    
    #-----< id-opcode-administerPassword >-----#
    id_opcode_administerPassword = CHOICE(name=u'id-opcode-administerPassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_administerPassword._val = (u'local', 11)
    
    #-----< id-opcode-ldapTransport >-----#
    id_opcode_ldapTransport = CHOICE(name=u'id-opcode-ldapTransport', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_ldapTransport._val = (u'local', 12)
    
    #-----< id-opcode-linkedLDAP >-----#
    id_opcode_linkedLDAP = CHOICE(name=u'id-opcode-linkedLDAP', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_linkedLDAP._val = (u'local', 13)
    
    #-----< id-opcode-requestShadowUpdate >-----#
    id_opcode_requestShadowUpdate = CHOICE(name=u'id-opcode-requestShadowUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_requestShadowUpdate._val = (u'local', 1)
    
    #-----< id-opcode-updateShadow >-----#
    id_opcode_updateShadow = CHOICE(name=u'id-opcode-updateShadow', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_updateShadow._val = (u'local', 2)
    
    #-----< id-opcode-coordinateShadowUpdate >-----#
    id_opcode_coordinateShadowUpdate = CHOICE(name=u'id-opcode-coordinateShadowUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_opcode_coordinateShadowUpdate._val = (u'local', 3)
    
    #-----< id-op-establishOperationalBinding >-----#
    id_op_establishOperationalBinding = CHOICE(name=u'id-op-establishOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_op_establishOperationalBinding._val = (u'local', 100)
    
    #-----< id-op-modifyOperationalBinding >-----#
    id_op_modifyOperationalBinding = CHOICE(name=u'id-op-modifyOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_op_modifyOperationalBinding._val = (u'local', 102)
    
    #-----< id-op-terminateOperationalBinding >-----#
    id_op_terminateOperationalBinding = CHOICE(name=u'id-op-terminateOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_op_terminateOperationalBinding._val = (u'local', 101)
    
    #-----< id-errcode-attributeError >-----#
    id_errcode_attributeError = CHOICE(name=u'id-errcode-attributeError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_attributeError._val = (u'local', 1)
    
    #-----< id-errcode-nameError >-----#
    id_errcode_nameError = CHOICE(name=u'id-errcode-nameError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_nameError._val = (u'local', 2)
    
    #-----< id-errcode-serviceError >-----#
    id_errcode_serviceError = CHOICE(name=u'id-errcode-serviceError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_serviceError._val = (u'local', 3)
    
    #-----< id-errcode-referral >-----#
    id_errcode_referral = CHOICE(name=u'id-errcode-referral', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_referral._val = (u'local', 4)
    
    #-----< id-errcode-abandoned >-----#
    id_errcode_abandoned = CHOICE(name=u'id-errcode-abandoned', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_abandoned._val = (u'local', 5)
    
    #-----< id-errcode-securityError >-----#
    id_errcode_securityError = CHOICE(name=u'id-errcode-securityError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_securityError._val = (u'local', 6)
    
    #-----< id-errcode-abandonFailed >-----#
    id_errcode_abandonFailed = CHOICE(name=u'id-errcode-abandonFailed', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_abandonFailed._val = (u'local', 7)
    
    #-----< id-errcode-updateError >-----#
    id_errcode_updateError = CHOICE(name=u'id-errcode-updateError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_updateError._val = (u'local', 8)
    
    #-----< id-errcode-dsaReferral >-----#
    id_errcode_dsaReferral = CHOICE(name=u'id-errcode-dsaReferral', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_dsaReferral._val = (u'local', 9)
    
    #-----< id-errcode-shadowError >-----#
    id_errcode_shadowError = CHOICE(name=u'id-errcode-shadowError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_errcode_shadowError._val = (u'local', 1)
    
    #-----< id-err-operationalBindingError >-----#
    id_err_operationalBindingError = CHOICE(name=u'id-err-operationalBindingError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')))
    id_err_operationalBindingError._val = (u'local', 100)
    
    #-----< DOP-Invokable >-----#
    DOP_Invokable = CLASS(name=u'DOP-Invokable', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _DOP_Invokable_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgument')))
    _DOP_Invokable_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    _DOP_Invokable_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgument')))
    _DOP_Invokable_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResult')))
    _DOP_Invokable_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgument')))
    _DOP_Invokable_val_ResultType_2 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResult')))
    DOP_Invokable._val = ASN1Set(rv=[dict([(u'ArgumentType', _DOP_Invokable_val_ArgumentType_0), (u'ResultType', _DOP_Invokable_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 100))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 100))]), dict([(u'ArgumentType', _DOP_Invokable_val_ArgumentType_1), (u'ResultType', _DOP_Invokable_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 100))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 102))]), dict([(u'ArgumentType', _DOP_Invokable_val_ArgumentType_2), (u'ResultType', _DOP_Invokable_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 100))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 101))])], rr=[], ev=None, er=[])
    
    #-----< DOP-Returnable >-----#
    DOP_Returnable = CLASS(name=u'DOP-Returnable', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _DOP_Returnable_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgument')))
    _DOP_Returnable_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResult')))
    _DOP_Returnable_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgument')))
    _DOP_Returnable_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResult')))
    _DOP_Returnable_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgument')))
    _DOP_Returnable_val_ResultType_2 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResult')))
    DOP_Returnable._val = ASN1Set(rv=[dict([(u'ArgumentType', _DOP_Returnable_val_ArgumentType_0), (u'ResultType', _DOP_Returnable_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 100))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 100))]), dict([(u'ArgumentType', _DOP_Returnable_val_ArgumentType_1), (u'ResultType', _DOP_Returnable_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 100))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 102))]), dict([(u'ArgumentType', _DOP_Returnable_val_ArgumentType_2), (u'ResultType', _DOP_Returnable_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 100))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 101))])], rr=[], ev=None, er=[])
    
    _all_ = [
        _OPERATION_ArgumentType,
        _OPERATION_ResultType,
        _OPERATION_Errors,
        _OPERATION_operationCode,
        OPERATION,
        _ERROR_ParameterType,
        _ERROR_errorCode,
        ERROR,
        _Code_local,
        _Code_global_,
        Code,
        _InvokeId_present,
        _InvokeId_absent,
        InvokeId,
        id_opcode_read,
        id_opcode_compare,
        id_opcode_abandon,
        id_opcode_list,
        id_opcode_search,
        id_opcode_addEntry,
        id_opcode_removeEntry,
        id_opcode_modifyEntry,
        id_opcode_modifyDN,
        id_opcode_changePassword,
        id_opcode_administerPassword,
        id_opcode_ldapTransport,
        id_opcode_linkedLDAP,
        id_opcode_requestShadowUpdate,
        id_opcode_updateShadow,
        id_opcode_coordinateShadowUpdate,
        id_op_establishOperationalBinding,
        id_op_modifyOperationalBinding,
        id_op_terminateOperationalBinding,
        id_errcode_attributeError,
        id_errcode_nameError,
        id_errcode_serviceError,
        id_errcode_referral,
        id_errcode_abandoned,
        id_errcode_securityError,
        id_errcode_abandonFailed,
        id_errcode_updateError,
        id_errcode_dsaReferral,
        id_errcode_shadowError,
        id_err_operationalBindingError,
        DOP_Invokable,
        _DOP_Invokable_val_ArgumentType_0,
        _DOP_Invokable_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        _DOP_Invokable_val_ArgumentType_1,
        _DOP_Invokable_val_ResultType_1,
        _DOP_Invokable_val_ArgumentType_2,
        _DOP_Invokable_val_ResultType_2,
        DOP_Returnable,
        _DOP_Returnable_val_ArgumentType_0,
        _DOP_Returnable_val_ResultType_0,
        _DOP_Returnable_val_ArgumentType_1,
        _DOP_Returnable_val_ResultType_1,
        _DOP_Returnable_val_ArgumentType_2,
        _DOP_Returnable_val_ResultType_2,
    ]

class CPDTChargingDataTypes:

    _name_  = u'CPDTChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 13, 0, 1]
    
    _obj_ = [
        u'CPDTRecord',
        u'CPDTSCERecord',
        u'CPDTSNNRecord',
        u'CPCauseForRecClosing',
        u'NIDDsubmission',
        u'ServiceChangeCondition',
        u'SubmissionResultCode',
        ]
    _type_ = [
        u'CPDTRecord',
        u'CPDTSCERecord',
        u'CPDTSNNRecord',
        u'CPCauseForRecClosing',
        u'NIDDsubmission',
        u'ServiceChangeCondition',
        u'SubmissionResultCode',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< CPDTRecord >-----#
    CPDTRecord = CHOICE(name=u'CPDTRecord', mode=MODE_TYPE)
    _CPDTRecord_cPDTSCERecord = SET(name=u'cPDTSCERecord', mode=MODE_TYPE, tag=(105, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CPDTChargingDataTypes', 'CPDTSCERecord')))
    _CPDTRecord_cPDTSNNRecord = SET(name=u'cPDTSNNRecord', mode=MODE_TYPE, tag=(106, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CPDTChargingDataTypes', 'CPDTSNNRecord')))
    CPDTRecord._cont = ASN1Dict([
        (u'cPDTSCERecord', _CPDTRecord_cPDTSCERecord),
        (u'cPDTSNNRecord', _CPDTRecord_cPDTSNNRecord),
        ])
    CPDTRecord._ext = None
    
    #-----< CPDTSCERecord >-----#
    CPDTSCERecord = SET(name=u'CPDTSCERecord', mode=MODE_TYPE)
    _CPDTSCERecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _CPDTSCERecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPDTSCERecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _CPDTSCERecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _CPDTSCERecord_chargingID = INT(name=u'chargingID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _CPDTSCERecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _CPDTSCERecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _CPDTSCERecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _CPDTSCERecord_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _CPDTSCERecord_accessPointNameNI = STR_IA5(name=u'accessPointNameNI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _CPDTSCERecord_sCEFID = OCT_STR(name=u'sCEFID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _CPDTSCERecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _CPDTSCERecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _CPDTSCERecord_servingNodeIdentity = OCT_STR(name=u'servingNodeIdentity', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _CPDTSCERecord_servingPLMNRateControl = SEQ(name=u'servingPLMNRateControl', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingPLMNRateControl')), opt=True)
    _CPDTSCERecord_listOfNIDDsubmission = SEQ_OF(name=u'listOfNIDDsubmission', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CPDTSCERecord_listOfNIDDsubmission__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CPDTChargingDataTypes', 'NIDDsubmission')))
    _CPDTSCERecord_listOfNIDDsubmission._cont = __CPDTSCERecord_listOfNIDDsubmission__item_
    _CPDTSCERecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CPDTChargingDataTypes', 'CPCauseForRecClosing')))
    _CPDTSCERecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _CPDTSCERecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _CPDTSCERecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPDTSCERecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _CPDTSCERecord_externalIdentifier = SET(name=u'externalIdentifier', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')), opt=True)
    _CPDTSCERecord_aPNRateControl = SEQ(name=u'aPNRateControl', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNRateControl')), opt=True)
    _CPDTSCERecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _CPDTSCERecord_servingNodePLMNIdentifier = OCT_STR(name=u'servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _CPDTSCERecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    CPDTSCERecord._cont = ASN1Dict([
        (u'recordType', _CPDTSCERecord_recordType),
        (u'retransmission', _CPDTSCERecord_retransmission),
        (u'servedIMSI', _CPDTSCERecord_servedIMSI),
        (u'servedMSISDN', _CPDTSCERecord_servedMSISDN),
        (u'chargingID', _CPDTSCERecord_chargingID),
        (u'serviceContextID', _CPDTSCERecord_serviceContextID),
        (u'nodeID', _CPDTSCERecord_nodeID),
        (u'recordOpeningTime', _CPDTSCERecord_recordOpeningTime),
        (u'duration', _CPDTSCERecord_duration),
        (u'accessPointNameNI', _CPDTSCERecord_accessPointNameNI),
        (u'sCEFID', _CPDTSCERecord_sCEFID),
        (u'chargingCharacteristics', _CPDTSCERecord_chargingCharacteristics),
        (u'chChSelectionMode', _CPDTSCERecord_chChSelectionMode),
        (u'servingNodeIdentity', _CPDTSCERecord_servingNodeIdentity),
        (u'servingPLMNRateControl', _CPDTSCERecord_servingPLMNRateControl),
        (u'listOfNIDDsubmission', _CPDTSCERecord_listOfNIDDsubmission),
        (u'causeForRecClosing', _CPDTSCERecord_causeForRecClosing),
        (u'diagnostics', _CPDTSCERecord_diagnostics),
        (u'localSequenceNumber', _CPDTSCERecord_localSequenceNumber),
        (u'recordSequenceNumber', _CPDTSCERecord_recordSequenceNumber),
        (u'recordExtensions', _CPDTSCERecord_recordExtensions),
        (u'externalIdentifier', _CPDTSCERecord_externalIdentifier),
        (u'aPNRateControl', _CPDTSCERecord_aPNRateControl),
        (u'rATType', _CPDTSCERecord_rATType),
        (u'servingNodePLMNIdentifier', _CPDTSCERecord_servingNodePLMNIdentifier),
        (u'servedIMEI', _CPDTSCERecord_servedIMEI),
        ])
    CPDTSCERecord._ext = None
    
    #-----< CPDTSNNRecord >-----#
    CPDTSNNRecord = SET(name=u'CPDTSNNRecord', mode=MODE_TYPE)
    _CPDTSNNRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _CPDTSNNRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPDTSNNRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _CPDTSNNRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _CPDTSNNRecord_chargingID = INT(name=u'chargingID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _CPDTSNNRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _CPDTSNNRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _CPDTSNNRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _CPDTSNNRecord_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _CPDTSNNRecord_accessPointNameNI = STR_IA5(name=u'accessPointNameNI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _CPDTSNNRecord_sCEFID = OCT_STR(name=u'sCEFID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _CPDTSNNRecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _CPDTSNNRecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _CPDTSNNRecord_servingNodeIdentity = OCT_STR(name=u'servingNodeIdentity', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _CPDTSNNRecord_servingPLMNRateControl = SEQ(name=u'servingPLMNRateControl', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingPLMNRateControl')), opt=True)
    _CPDTSNNRecord_listOfNIDDsubmission = SEQ_OF(name=u'listOfNIDDsubmission', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CPDTSNNRecord_listOfNIDDsubmission__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CPDTChargingDataTypes', 'NIDDsubmission')))
    _CPDTSNNRecord_listOfNIDDsubmission._cont = __CPDTSNNRecord_listOfNIDDsubmission__item_
    _CPDTSNNRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CPDTChargingDataTypes', 'CPCauseForRecClosing')))
    _CPDTSNNRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _CPDTSNNRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _CPDTSNNRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPDTSNNRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _CPDTSNNRecord_externalIdentifier = SET(name=u'externalIdentifier', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')), opt=True)
    _CPDTSNNRecord_aPNRateControl = SEQ(name=u'aPNRateControl', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNRateControl')), opt=True)
    _CPDTSNNRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _CPDTSNNRecord_servingNodePLMNIdentifier = OCT_STR(name=u'servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _CPDTSNNRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    CPDTSNNRecord._cont = ASN1Dict([
        (u'recordType', _CPDTSNNRecord_recordType),
        (u'retransmission', _CPDTSNNRecord_retransmission),
        (u'servedIMSI', _CPDTSNNRecord_servedIMSI),
        (u'servedMSISDN', _CPDTSNNRecord_servedMSISDN),
        (u'chargingID', _CPDTSNNRecord_chargingID),
        (u'serviceContextID', _CPDTSNNRecord_serviceContextID),
        (u'nodeID', _CPDTSNNRecord_nodeID),
        (u'recordOpeningTime', _CPDTSNNRecord_recordOpeningTime),
        (u'duration', _CPDTSNNRecord_duration),
        (u'accessPointNameNI', _CPDTSNNRecord_accessPointNameNI),
        (u'sCEFID', _CPDTSNNRecord_sCEFID),
        (u'chargingCharacteristics', _CPDTSNNRecord_chargingCharacteristics),
        (u'chChSelectionMode', _CPDTSNNRecord_chChSelectionMode),
        (u'servingNodeIdentity', _CPDTSNNRecord_servingNodeIdentity),
        (u'servingPLMNRateControl', _CPDTSNNRecord_servingPLMNRateControl),
        (u'listOfNIDDsubmission', _CPDTSNNRecord_listOfNIDDsubmission),
        (u'causeForRecClosing', _CPDTSNNRecord_causeForRecClosing),
        (u'diagnostics', _CPDTSNNRecord_diagnostics),
        (u'localSequenceNumber', _CPDTSNNRecord_localSequenceNumber),
        (u'recordSequenceNumber', _CPDTSNNRecord_recordSequenceNumber),
        (u'recordExtensions', _CPDTSNNRecord_recordExtensions),
        (u'externalIdentifier', _CPDTSNNRecord_externalIdentifier),
        (u'aPNRateControl', _CPDTSNNRecord_aPNRateControl),
        (u'rATType', _CPDTSNNRecord_rATType),
        (u'servingNodePLMNIdentifier', _CPDTSNNRecord_servingNodePLMNIdentifier),
        (u'servedIMEI', _CPDTSNNRecord_servedIMEI),
        ])
    CPDTSNNRecord._ext = None
    
    #-----< CPCauseForRecClosing >-----#
    CPCauseForRecClosing = INT(name=u'CPCauseForRecClosing', mode=MODE_TYPE)
    CPCauseForRecClosing._cont = ASN1Dict([(u'normalRelease', 0), (u'abnormalRelease', 1), (u'volumeLimit', 2), (u'timeLimit', 3), (u'maxNIDDsubmissions', 4), (u'servingNodeChange', 5), (u'pLMNChange', 6), (u'servingPLMNRateControlChange', 7), (u'aPNRateControlChange', 8), (u'rATTypeChange', 9), (u'managementIntervention', 10)])
    
    #-----< NIDDsubmission >-----#
    NIDDsubmission = SEQ(name=u'NIDDsubmission', mode=MODE_TYPE)
    _NIDDsubmission_submissionTimestamp = OCT_STR(name=u'submissionTimestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _NIDDsubmission_eventTimestamp = OCT_STR(name=u'eventTimestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _NIDDsubmission_dataVolumeGPRSUplink = INT(name=u'dataVolumeGPRSUplink', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _NIDDsubmission_dataVolumeGPRSDownlink = INT(name=u'dataVolumeGPRSDownlink', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _NIDDsubmission_submissionResultCode = INT(name=u'submissionResultCode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CPDTChargingDataTypes', 'SubmissionResultCode')), opt=True)
    _NIDDsubmission_serviceChangeCondition = BIT_STR(name=u'serviceChangeCondition', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CPDTChargingDataTypes', 'ServiceChangeCondition')), opt=True)
    NIDDsubmission._cont = ASN1Dict([
        (u'submissionTimestamp', _NIDDsubmission_submissionTimestamp),
        (u'eventTimestamp', _NIDDsubmission_eventTimestamp),
        (u'dataVolumeGPRSUplink', _NIDDsubmission_dataVolumeGPRSUplink),
        (u'dataVolumeGPRSDownlink', _NIDDsubmission_dataVolumeGPRSDownlink),
        (u'submissionResultCode', _NIDDsubmission_submissionResultCode),
        (u'serviceChangeCondition', _NIDDsubmission_serviceChangeCondition),
        ])
    NIDDsubmission._ext = None
    
    #-----< ServiceChangeCondition >-----#
    ServiceChangeCondition = BIT_STR(name=u'ServiceChangeCondition', mode=MODE_TYPE)
    ServiceChangeCondition._cont = ASN1Dict([(u'nIDDsubmissionResponseReceipt', 0), (u'nIDDsubmissionResponseSending', 1), (u'nIDDdeliveryToUE', 2), (u'nIDDdeliveryFromUEerror', 3), (u'nIDDsubmissionTimeout', 4)])
    
    #-----< SubmissionResultCode >-----#
    SubmissionResultCode = INT(name=u'SubmissionResultCode', mode=MODE_TYPE)
    
    _all_ = [
        _CPDTRecord_cPDTSCERecord,
        _CPDTRecord_cPDTSNNRecord,
        CPDTRecord,
        _CPDTSCERecord_recordType,
        _CPDTSCERecord_retransmission,
        _CPDTSCERecord_servedIMSI,
        _CPDTSCERecord_servedMSISDN,
        _CPDTSCERecord_chargingID,
        _CPDTSCERecord_serviceContextID,
        _CPDTSCERecord_nodeID,
        _CPDTSCERecord_recordOpeningTime,
        _CPDTSCERecord_duration,
        _CPDTSCERecord_accessPointNameNI,
        _CPDTSCERecord_sCEFID,
        _CPDTSCERecord_chargingCharacteristics,
        _CPDTSCERecord_chChSelectionMode,
        _CPDTSCERecord_servingNodeIdentity,
        _CPDTSCERecord_servingPLMNRateControl,
        __CPDTSCERecord_listOfNIDDsubmission__item_,
        _CPDTSCERecord_listOfNIDDsubmission,
        _CPDTSCERecord_causeForRecClosing,
        _CPDTSCERecord_diagnostics,
        _CPDTSCERecord_localSequenceNumber,
        _CPDTSCERecord_recordSequenceNumber,
        _CPDTSCERecord_recordExtensions,
        _CPDTSCERecord_externalIdentifier,
        _CPDTSCERecord_aPNRateControl,
        _CPDTSCERecord_rATType,
        _CPDTSCERecord_servingNodePLMNIdentifier,
        _CPDTSCERecord_servedIMEI,
        CPDTSCERecord,
        _CPDTSNNRecord_recordType,
        _CPDTSNNRecord_retransmission,
        _CPDTSNNRecord_servedIMSI,
        _CPDTSNNRecord_servedMSISDN,
        _CPDTSNNRecord_chargingID,
        _CPDTSNNRecord_serviceContextID,
        _CPDTSNNRecord_nodeID,
        _CPDTSNNRecord_recordOpeningTime,
        _CPDTSNNRecord_duration,
        _CPDTSNNRecord_accessPointNameNI,
        _CPDTSNNRecord_sCEFID,
        _CPDTSNNRecord_chargingCharacteristics,
        _CPDTSNNRecord_chChSelectionMode,
        _CPDTSNNRecord_servingNodeIdentity,
        _CPDTSNNRecord_servingPLMNRateControl,
        __CPDTSNNRecord_listOfNIDDsubmission__item_,
        _CPDTSNNRecord_listOfNIDDsubmission,
        _CPDTSNNRecord_causeForRecClosing,
        _CPDTSNNRecord_diagnostics,
        _CPDTSNNRecord_localSequenceNumber,
        _CPDTSNNRecord_recordSequenceNumber,
        _CPDTSNNRecord_recordExtensions,
        _CPDTSNNRecord_externalIdentifier,
        _CPDTSNNRecord_aPNRateControl,
        _CPDTSNNRecord_rATType,
        _CPDTSNNRecord_servingNodePLMNIdentifier,
        _CPDTSNNRecord_servedIMEI,
        CPDTSNNRecord,
        CPCauseForRecClosing,
        _NIDDsubmission_submissionTimestamp,
        _NIDDsubmission_eventTimestamp,
        _NIDDsubmission_dataVolumeGPRSUplink,
        _NIDDsubmission_dataVolumeGPRSDownlink,
        _NIDDsubmission_submissionResultCode,
        _NIDDsubmission_serviceChangeCondition,
        NIDDsubmission,
        ServiceChangeCondition,
        SubmissionResultCode,
    ]

class CS1_DataTypes:

    _name_  = u'CS1-DataTypes'
    _oid_   = []
    
    _obj_ = [
        u'Duration',
        u'Integer4',
        u'Interval',
        u'LegID',
        u'LegType',
        u'ServiceKey',
        u'CallingPartysCategory',
        u'HighLayerCompatibility',
        u'highLayerCompatibilityLength',
        u'RedirectionInformation',
        ]
    _type_ = [
        u'Duration',
        u'Integer4',
        u'Interval',
        u'LegID',
        u'LegType',
        u'ServiceKey',
        u'CallingPartysCategory',
        u'HighLayerCompatibility',
        u'RedirectionInformation',
        ]
    _set_ = [
        ]
    _val_ = [
        u'highLayerCompatibilityLength',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Duration >-----#
    Duration = INT(name=u'Duration', mode=MODE_TYPE)
    Duration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2, ub=86400)], ev=None, er=[])
    
    #-----< Integer4 >-----#
    Integer4 = INT(name=u'Integer4', mode=MODE_TYPE)
    Integer4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    
    #-----< Interval >-----#
    Interval = INT(name=u'Interval', mode=MODE_TYPE)
    Interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1, ub=60000)], ev=None, er=[])
    
    #-----< LegID >-----#
    LegID = CHOICE(name=u'LegID', mode=MODE_TYPE)
    _LegID_sendingSideID = OCT_STR(name=u'sendingSideID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegType')))
    _LegID_receivingSideID = OCT_STR(name=u'receivingSideID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CS1-DataTypes', 'LegType')))
    LegID._cont = ASN1Dict([
        (u'sendingSideID', _LegID_sendingSideID),
        (u'receivingSideID', _LegID_receivingSideID),
        ])
    LegID._ext = None
    
    #-----< LegType >-----#
    LegType = OCT_STR(name=u'LegType', mode=MODE_TYPE)
    LegType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ServiceKey >-----#
    ServiceKey = INT(name=u'ServiceKey', mode=MODE_TYPE, typeref=ASN1RefType(('CS1-DataTypes', 'Integer4')))
    
    #-----< CallingPartysCategory >-----#
    CallingPartysCategory = OCT_STR(name=u'CallingPartysCategory', mode=MODE_TYPE)
    CallingPartysCategory._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< HighLayerCompatibility >-----#
    HighLayerCompatibility = OCT_STR(name=u'HighLayerCompatibility', mode=MODE_TYPE)
    HighLayerCompatibility._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< highLayerCompatibilityLength >-----#
    highLayerCompatibilityLength = INT(name=u'highLayerCompatibilityLength', mode=MODE_VALUE)
    highLayerCompatibilityLength._val = 2
    
    #-----< RedirectionInformation >-----#
    RedirectionInformation = OCT_STR(name=u'RedirectionInformation', mode=MODE_TYPE)
    RedirectionInformation._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    _all_ = [
        Duration,
        Integer4,
        Interval,
        _LegID_sendingSideID,
        _LegID_receivingSideID,
        LegID,
        LegType,
        ServiceKey,
        CallingPartysCategory,
        HighLayerCompatibility,
        highLayerCompatibilityLength,
        RedirectionInformation,
    ]

class CS2_datatypes:

    _name_  = u'CS2-datatypes'
    _oid_   = []
    
    _obj_ = [
        u'CriticalityType',
        u'BothwayThroughConnectionInd',
        u'MiscCallInfo',
        ]
    _type_ = [
        u'CriticalityType',
        u'BothwayThroughConnectionInd',
        u'MiscCallInfo',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< CriticalityType >-----#
    CriticalityType = ENUM(name=u'CriticalityType', mode=MODE_TYPE)
    CriticalityType._cont = ASN1Dict([(u'ignore', 0), (u'abort', 1)])
    CriticalityType._ext = None
    
    #-----< BothwayThroughConnectionInd >-----#
    BothwayThroughConnectionInd = ENUM(name=u'BothwayThroughConnectionInd', mode=MODE_TYPE)
    BothwayThroughConnectionInd._cont = ASN1Dict([(u'bothwayPathRequired', 0), (u'bothwayPathNotRequired', 1)])
    BothwayThroughConnectionInd._ext = None
    
    #-----< MiscCallInfo >-----#
    MiscCallInfo = SEQ(name=u'MiscCallInfo', mode=MODE_TYPE)
    _MiscCallInfo_messageType = ENUM(name=u'messageType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MiscCallInfo_messageType._cont = ASN1Dict([(u'request', 0), (u'notification', 1)])
    _MiscCallInfo_messageType._ext = None
    _MiscCallInfo_dpAssignment = ENUM(name=u'dpAssignment', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MiscCallInfo_dpAssignment._cont = ASN1Dict([(u'individualLine', 0), (u'groupBased', 1), (u'officeBased', 2)])
    _MiscCallInfo_dpAssignment._ext = None
    MiscCallInfo._cont = ASN1Dict([
        (u'messageType', _MiscCallInfo_messageType),
        (u'dpAssignment', _MiscCallInfo_dpAssignment),
        ])
    MiscCallInfo._ext = None
    
    _all_ = [
        CriticalityType,
        BothwayThroughConnectionInd,
        _MiscCallInfo_messageType,
        _MiscCallInfo_dpAssignment,
        MiscCallInfo,
    ]

class CSChargingDataTypes:

    _name_  = u'CSChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 1, 0, 1]
    
    _obj_ = [
        u'CSRecord',
        u'MOCallRecord',
        u'MTCallRecord',
        u'RoamingRecord',
        u'TermCAMELRecord',
        u'IncGatewayRecord',
        u'OutGatewayRecord',
        u'TransitCallRecord',
        u'MOSMSRecord',
        u'MTSMSRecord',
        u'MOSMSIWRecord',
        u'MTSMSGWRecord',
        u'SSActionRecord',
        u'HLRIntRecord',
        u'LocUpdateHLRRecord',
        u'LocUpdateVLRRecord',
        u'CommonEquipRecord',
        u'ObservedIMEITicket',
        u'MTLCSRecord',
        u'MOLCSRecord',
        u'NILCSRecord',
        u'MSCsRVCCRecord',
        u'MTRFRecord',
        u'ICSregisterRecord',
        u'LocationRoutingNumber',
        u'LocationRoutingNumberSourceIndicator',
        u'LocationRoutingNumberQueryStatus',
        u'JurisdictionInformationParameter',
        u'JurisdictionInformationParameterSourceIndicator',
        u'JurisdictionInformationParameterQueryStatus',
        u'AdditionalChgInfo',
        u'AiurRequested',
        u'AOCParameters',
        u'AOCParmChange',
        u'BasicServices',
        u'CallingPartyCategory',
        u'CallType',
        u'CallTypes',
        u'CAMELDestinationNumber',
        u'CAMELInformation',
        u'CAMELInitCFIndicator',
        u'CAMELModificationParameters',
        u'CAMELSMSInformation',
        u'Category',
        u'ChangedParameters',
        u'ChangeFlags',
        u'ChangeOfClassmark',
        u'ChangeOfRadioChannel',
        u'ChangeOfService',
        u'ChannelCoding',
        u'Classmark',
        u'ConnectedNumber',
        u'DataVolume',
        u'Day',
        u'DayClass',
        u'DayClasses',
        u'DayDefinition',
        u'DayDefinitions',
        u'DateDefinition',
        u'DateDefinitions',
        u'DayOfTheWeek',
        u'Destinations',
        u'EmergencyCallIndEnable',
        u'EmergencyCallIndication',
        u'EParameter',
        u'EquipmentId',
        u'EquipmentType',
        u'FileType',
        u'Fnur',
        u'ForwardToNumber',
        u'FreeFormatData',
        u'GenericNumber',
        u'GenericNumbers',
        u'Gsm-SCFAddress',
        u'GuaranteedBitRate',
        u'HLRIntResult',
        u'HSCSDParmsChange',
        u'IMEICheckEvent',
        u'IMEIStatus',
        u'IMSIorIMEI',
        u'InitiatingParty',
        u'LocationCellExtension',
        u'LocationChange',
        u'Location-info',
        u'LocUpdResult',
        u'MaximumBitRate',
        u'Month',
        u'MSPowerClasses',
        u'NetworkCallReference',
        u'NetworkSpecificCode',
        u'NetworkSpecificServices',
        u'NumOfHSCSDChanRequested',
        u'NumOfHSCSDChanAllocated',
        u'ObservedIMEITicketEnable',
        u'OriginalCalledNumber',
        u'OriginDestCombinations',
        u'OriginDestCombination',
        u'PartialRecordTimer',
        u'PartialRecordType',
        u'PartialRecordTypes',
        u'RadioChannelsRequested',
        u'RadioChanRequested',
        u'RateIndication',
        u'ReasonForServiceChange',
        u'RecordClassDestination',
        u'RecordClassDestinations',
        u'RecordingMethod',
        u'RedirectingNumber',
        u'RFPowerCapability',
        u'RoamingNumber',
        u'RoutingNumber',
        u'Service',
        u'ServiceDistanceDependencies',
        u'ServiceDistanceDependency',
        u'SimpleIntegerName',
        u'SimpleStringName',
        u'SpeechVersionIdentifier',
        u'SSActionResult',
        u'SSActionType',
        u'SSParameters',
        u'SupplServices',
        u'SuppServiceUsed',
        u'SwitchoverTime',
        u'TariffId',
        u'TariffPeriod',
        u'TariffPeriods',
        u'TariffSystemStatus',
        u'TrafficChannel',
        u'TranslatedNumber',
        u'TransparencyInd',
        u'TrunkGroup',
        u'TSChangeover',
        u'TSCheckError',
        u'TSCheckErrorId',
        u'TSCheckResult',
        u'TSCopyTariffSystem',
        u'TSNextChange',
        u'TypeOfSubscribers',
        u'TypeOfTransaction',
        u'Visited-Location-info',
        u'VlrNo',
        ]
    _type_ = [
        u'CSRecord',
        u'MOCallRecord',
        u'MTCallRecord',
        u'RoamingRecord',
        u'TermCAMELRecord',
        u'IncGatewayRecord',
        u'OutGatewayRecord',
        u'TransitCallRecord',
        u'MOSMSRecord',
        u'MTSMSRecord',
        u'MOSMSIWRecord',
        u'MTSMSGWRecord',
        u'SSActionRecord',
        u'HLRIntRecord',
        u'LocUpdateHLRRecord',
        u'LocUpdateVLRRecord',
        u'CommonEquipRecord',
        u'ObservedIMEITicket',
        u'MTLCSRecord',
        u'MOLCSRecord',
        u'NILCSRecord',
        u'MSCsRVCCRecord',
        u'MTRFRecord',
        u'ICSregisterRecord',
        u'LocationRoutingNumber',
        u'LocationRoutingNumberSourceIndicator',
        u'LocationRoutingNumberQueryStatus',
        u'JurisdictionInformationParameter',
        u'JurisdictionInformationParameterSourceIndicator',
        u'JurisdictionInformationParameterQueryStatus',
        u'AdditionalChgInfo',
        u'AiurRequested',
        u'AOCParameters',
        u'AOCParmChange',
        u'BasicServices',
        u'CallingPartyCategory',
        u'CallType',
        u'CallTypes',
        u'CAMELDestinationNumber',
        u'CAMELInformation',
        u'CAMELInitCFIndicator',
        u'CAMELModificationParameters',
        u'CAMELSMSInformation',
        u'Category',
        u'ChangedParameters',
        u'ChangeFlags',
        u'ChangeOfClassmark',
        u'ChangeOfRadioChannel',
        u'ChangeOfService',
        u'ChannelCoding',
        u'Classmark',
        u'ConnectedNumber',
        u'DataVolume',
        u'Day',
        u'DayClass',
        u'DayClasses',
        u'DayDefinition',
        u'DayDefinitions',
        u'DateDefinition',
        u'DateDefinitions',
        u'DayOfTheWeek',
        u'Destinations',
        u'EmergencyCallIndEnable',
        u'EmergencyCallIndication',
        u'EParameter',
        u'EquipmentId',
        u'EquipmentType',
        u'FileType',
        u'Fnur',
        u'ForwardToNumber',
        u'FreeFormatData',
        u'GenericNumber',
        u'GenericNumbers',
        u'Gsm-SCFAddress',
        u'GuaranteedBitRate',
        u'HLRIntResult',
        u'HSCSDParmsChange',
        u'IMEICheckEvent',
        u'IMEIStatus',
        u'IMSIorIMEI',
        u'InitiatingParty',
        u'LocationCellExtension',
        u'LocationChange',
        u'Location-info',
        u'LocUpdResult',
        u'MaximumBitRate',
        u'Month',
        u'MSPowerClasses',
        u'NetworkCallReference',
        u'NetworkSpecificCode',
        u'NetworkSpecificServices',
        u'NumOfHSCSDChanRequested',
        u'NumOfHSCSDChanAllocated',
        u'ObservedIMEITicketEnable',
        u'OriginalCalledNumber',
        u'OriginDestCombinations',
        u'OriginDestCombination',
        u'PartialRecordTimer',
        u'PartialRecordType',
        u'PartialRecordTypes',
        u'RadioChannelsRequested',
        u'RadioChanRequested',
        u'RateIndication',
        u'ReasonForServiceChange',
        u'RecordClassDestination',
        u'RecordClassDestinations',
        u'RecordingMethod',
        u'RedirectingNumber',
        u'RFPowerCapability',
        u'RoamingNumber',
        u'RoutingNumber',
        u'Service',
        u'ServiceDistanceDependencies',
        u'ServiceDistanceDependency',
        u'SimpleIntegerName',
        u'SimpleStringName',
        u'SpeechVersionIdentifier',
        u'SSActionResult',
        u'SSActionType',
        u'SSParameters',
        u'SupplServices',
        u'SuppServiceUsed',
        u'SwitchoverTime',
        u'TariffId',
        u'TariffPeriod',
        u'TariffPeriods',
        u'TariffSystemStatus',
        u'TrafficChannel',
        u'TranslatedNumber',
        u'TransparencyInd',
        u'TrunkGroup',
        u'TSChangeover',
        u'TSCheckError',
        u'TSCheckErrorId',
        u'TSCheckResult',
        u'TSCopyTariffSystem',
        u'TSNextChange',
        u'TypeOfSubscribers',
        u'TypeOfTransaction',
        u'Visited-Location-info',
        u'VlrNo',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< CSRecord >-----#
    CSRecord = CHOICE(name=u'CSRecord', mode=MODE_TYPE)
    _CSRecord_moCallRecord = SET(name=u'moCallRecord', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MOCallRecord')))
    _CSRecord_mtCallRecord = SET(name=u'mtCallRecord', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MTCallRecord')))
    _CSRecord_roamingRecord = SET(name=u'roamingRecord', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RoamingRecord')))
    _CSRecord_incGatewayRecord = SET(name=u'incGatewayRecord', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'IncGatewayRecord')))
    _CSRecord_outGatewayRecord = SET(name=u'outGatewayRecord', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'OutGatewayRecord')))
    _CSRecord_transitRecord = SET(name=u'transitRecord', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TransitCallRecord')))
    _CSRecord_moSMSRecord = SET(name=u'moSMSRecord', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MOSMSRecord')))
    _CSRecord_mtSMSRecord = SET(name=u'mtSMSRecord', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MTSMSRecord')))
    _CSRecord_moSMSIWRecord = SET(name=u'moSMSIWRecord', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MOSMSIWRecord')))
    _CSRecord_mtSMSGWRecord = SET(name=u'mtSMSGWRecord', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MTSMSGWRecord')))
    _CSRecord_ssActionRecord = SET(name=u'ssActionRecord', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SSActionRecord')))
    _CSRecord_hlrIntRecord = SET(name=u'hlrIntRecord', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'HLRIntRecord')))
    _CSRecord_locUpdateHLRRecord = SET(name=u'locUpdateHLRRecord', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocUpdateHLRRecord')))
    _CSRecord_locUpdateVLRRecord = SET(name=u'locUpdateVLRRecord', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocUpdateVLRRecord')))
    _CSRecord_commonEquipRecord = SET(name=u'commonEquipRecord', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CommonEquipRecord')))
    _CSRecord_recTypeExtensions = SET_OF(name=u'recTypeExtensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')))
    _CSRecord_termCAMELRecord = SET(name=u'termCAMELRecord', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TermCAMELRecord')))
    _CSRecord_mtLCSRecord = SET(name=u'mtLCSRecord', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MTLCSRecord')))
    _CSRecord_moLCSRecord = SET(name=u'moLCSRecord', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MOLCSRecord')))
    _CSRecord_niLCSRecord = SET(name=u'niLCSRecord', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NILCSRecord')))
    _CSRecord_mSCsRVCCRecord = SET(name=u'mSCsRVCCRecord', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MSCsRVCCRecord')))
    _CSRecord_mMTRFRecord = SET(name=u'mMTRFRecord', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MTRFRecord')))
    _CSRecord_iCSRegisterRecord = SET(name=u'iCSRegisterRecord', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ICSregisterRecord')))
    CSRecord._cont = ASN1Dict([
        (u'moCallRecord', _CSRecord_moCallRecord),
        (u'mtCallRecord', _CSRecord_mtCallRecord),
        (u'roamingRecord', _CSRecord_roamingRecord),
        (u'incGatewayRecord', _CSRecord_incGatewayRecord),
        (u'outGatewayRecord', _CSRecord_outGatewayRecord),
        (u'transitRecord', _CSRecord_transitRecord),
        (u'moSMSRecord', _CSRecord_moSMSRecord),
        (u'mtSMSRecord', _CSRecord_mtSMSRecord),
        (u'moSMSIWRecord', _CSRecord_moSMSIWRecord),
        (u'mtSMSGWRecord', _CSRecord_mtSMSGWRecord),
        (u'ssActionRecord', _CSRecord_ssActionRecord),
        (u'hlrIntRecord', _CSRecord_hlrIntRecord),
        (u'locUpdateHLRRecord', _CSRecord_locUpdateHLRRecord),
        (u'locUpdateVLRRecord', _CSRecord_locUpdateVLRRecord),
        (u'commonEquipRecord', _CSRecord_commonEquipRecord),
        (u'recTypeExtensions', _CSRecord_recTypeExtensions),
        (u'termCAMELRecord', _CSRecord_termCAMELRecord),
        (u'mtLCSRecord', _CSRecord_mtLCSRecord),
        (u'moLCSRecord', _CSRecord_moLCSRecord),
        (u'niLCSRecord', _CSRecord_niLCSRecord),
        (u'mSCsRVCCRecord', _CSRecord_mSCsRVCCRecord),
        (u'mMTRFRecord', _CSRecord_mMTRFRecord),
        (u'iCSRegisterRecord', _CSRecord_iCSRegisterRecord),
        ])
    CSRecord._ext = None
    
    #-----< MOCallRecord >-----#
    MOCallRecord = SET(name=u'MOCallRecord', mode=MODE_TYPE)
    _MOCallRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MOCallRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MOCallRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _MOCallRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _MOCallRecord_callingNumber = OCT_STR(name=u'callingNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _MOCallRecord_calledNumber = OCT_STR(name=u'calledNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')), opt=True)
    _MOCallRecord_translatedNumber = OCT_STR(name=u'translatedNumber', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TranslatedNumber')), opt=True)
    _MOCallRecord_connectedNumber = OCT_STR(name=u'connectedNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ConnectedNumber')), opt=True)
    _MOCallRecord_roamingNumber = OCT_STR(name=u'roamingNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RoamingNumber')), opt=True)
    _MOCallRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MOCallRecord_mscIncomingTKGP = CHOICE(name=u'mscIncomingTKGP', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _MOCallRecord_mscOutgoingTKGP = CHOICE(name=u'mscOutgoingTKGP', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _MOCallRecord_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _MOCallRecord_changeOfLocation = SEQ_OF(name=u'changeOfLocation', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MOCallRecord_changeOfLocation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'LocationChange')))
    _MOCallRecord_changeOfLocation._cont = __MOCallRecord_changeOfLocation__item_
    _MOCallRecord_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _MOCallRecord_transparencyIndicator = ENUM(name=u'transparencyIndicator', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TransparencyInd')), opt=True)
    _MOCallRecord_changeOfService = SEQ_OF(name=u'changeOfService', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MOCallRecord_changeOfService__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfService')))
    _MOCallRecord_changeOfService._cont = __MOCallRecord_changeOfService__item_
    _MOCallRecord_supplServicesUsed = SEQ_OF(name=u'supplServicesUsed', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MOCallRecord_supplServicesUsed__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'SuppServiceUsed')))
    _MOCallRecord_supplServicesUsed._cont = __MOCallRecord_supplServicesUsed__item_
    _MOCallRecord_aocParameters = SEQ(name=u'aocParameters', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AOCParameters')), opt=True)
    _MOCallRecord_changeOfAOCParms = SEQ_OF(name=u'changeOfAOCParms', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MOCallRecord_changeOfAOCParms__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'AOCParmChange')))
    _MOCallRecord_changeOfAOCParms._cont = __MOCallRecord_changeOfAOCParms__item_
    _MOCallRecord_msClassmark = OCT_STR(name=u'msClassmark', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')), opt=True)
    _MOCallRecord_changeOfClassmark = SEQ(name=u'changeOfClassmark', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfClassmark')), opt=True)
    _MOCallRecord_seizureTime = OCT_STR(name=u'seizureTime', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MOCallRecord_answerTime = OCT_STR(name=u'answerTime', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MOCallRecord_releaseTime = OCT_STR(name=u'releaseTime', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MOCallRecord_callDuration = INT(name=u'callDuration', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _MOCallRecord_dataVolume = INT(name=u'dataVolume', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _MOCallRecord_radioChanRequested = ENUM(name=u'radioChanRequested', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RadioChanRequested')), opt=True)
    _MOCallRecord_radioChanUsed = ENUM(name=u'radioChanUsed', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrafficChannel')), opt=True)
    _MOCallRecord_changeOfRadioChan = SEQ(name=u'changeOfRadioChan', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfRadioChannel')), opt=True)
    _MOCallRecord_causeForTerm = INT(name=u'causeForTerm', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _MOCallRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _MOCallRecord_callReference = OCT_STR(name=u'callReference', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _MOCallRecord_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MOCallRecord_additionalChgInfo = SEQ(name=u'additionalChgInfo', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AdditionalChgInfo')), opt=True)
    _MOCallRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MOCallRecord_gsm_SCFAddress = OCT_STR(name=u'gsm-SCFAddress', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Gsm-SCFAddress')), opt=True)
    _MOCallRecord_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _MOCallRecord_networkCallReference = OCT_STR(name=u'networkCallReference', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NetworkCallReference')), opt=True)
    _MOCallRecord_mSCAddress = OCT_STR(name=u'mSCAddress', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSCAddress')), opt=True)
    _MOCallRecord_cAMELInitCFIndicator = ENUM(name=u'cAMELInitCFIndicator', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELInitCFIndicator')), opt=True)
    _MOCallRecord_defaultCallHandling = ENUM(name=u'defaultCallHandling', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')), opt=True)
    _MOCallRecord_hSCSDChanRequested = INT(name=u'hSCSDChanRequested', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NumOfHSCSDChanRequested')), opt=True)
    _MOCallRecord_hSCSDChanAllocated = INT(name=u'hSCSDChanAllocated', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NumOfHSCSDChanAllocated')), opt=True)
    _MOCallRecord_changeOfHSCSDParms = SEQ_OF(name=u'changeOfHSCSDParms', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MOCallRecord_changeOfHSCSDParms__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'HSCSDParmsChange')))
    _MOCallRecord_changeOfHSCSDParms._cont = __MOCallRecord_changeOfHSCSDParms__item_
    _MOCallRecord_fnur = ENUM(name=u'fnur', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Fnur')), opt=True)
    _MOCallRecord_aiurRequested = ENUM(name=u'aiurRequested', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AiurRequested')), opt=True)
    _MOCallRecord_chanCodingsAcceptable = SEQ_OF(name=u'chanCodingsAcceptable', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MOCallRecord_chanCodingsAcceptable__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'ChannelCoding')))
    _MOCallRecord_chanCodingsAcceptable._cont = __MOCallRecord_chanCodingsAcceptable__item_
    _MOCallRecord_chanCodingUsed = ENUM(name=u'chanCodingUsed', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChannelCoding')), opt=True)
    _MOCallRecord_speechVersionSupported = OCT_STR(name=u'speechVersionSupported', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SpeechVersionIdentifier')), opt=True)
    _MOCallRecord_speechVersionUsed = OCT_STR(name=u'speechVersionUsed', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SpeechVersionIdentifier')), opt=True)
    _MOCallRecord_numberOfDPEncountered = INT(name=u'numberOfDPEncountered', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MOCallRecord_levelOfCAMELService = BIT_STR(name=u'levelOfCAMELService', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LevelOfCAMELService')), opt=True)
    _MOCallRecord_freeFormatData = OCT_STR(name=u'freeFormatData', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FreeFormatData')), opt=True)
    _MOCallRecord_cAMELCallLegInformation = SEQ_OF(name=u'cAMELCallLegInformation', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MOCallRecord_cAMELCallLegInformation__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELInformation')))
    _MOCallRecord_cAMELCallLegInformation._cont = __MOCallRecord_cAMELCallLegInformation__item_
    _MOCallRecord_freeFormatDataAppend = BOOL(name=u'freeFormatDataAppend', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MOCallRecord_defaultCallHandling_2 = ENUM(name=u'defaultCallHandling-2', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')), opt=True)
    _MOCallRecord_gsm_SCFAddress_2 = OCT_STR(name=u'gsm-SCFAddress-2', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Gsm-SCFAddress')), opt=True)
    _MOCallRecord_serviceKey_2 = INT(name=u'serviceKey-2', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _MOCallRecord_freeFormatData_2 = OCT_STR(name=u'freeFormatData-2', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FreeFormatData')), opt=True)
    _MOCallRecord_freeFormatDataAppend_2 = BOOL(name=u'freeFormatDataAppend-2', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MOCallRecord_systemType = ENUM(name=u'systemType', mode=MODE_TYPE, tag=(61, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _MOCallRecord_rateIndication = OCT_STR(name=u'rateIndication', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RateIndication')), opt=True)
    _MOCallRecord_locationRoutNum = OCT_STR(name=u'locationRoutNum', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumber')), opt=True)
    _MOCallRecord_lrnSoInd = INT(name=u'lrnSoInd', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberSourceIndicator')), opt=True)
    _MOCallRecord_lrnQuryStatus = INT(name=u'lrnQuryStatus', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberQueryStatus')), opt=True)
    _MOCallRecord_jIPPara = OCT_STR(name=u'jIPPara', mode=MODE_TYPE, tag=(66, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameter')), opt=True)
    _MOCallRecord_jIPSoInd = INT(name=u'jIPSoInd', mode=MODE_TYPE, tag=(67, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterSourceIndicator')), opt=True)
    _MOCallRecord_jIPQuryStatus = INT(name=u'jIPQuryStatus', mode=MODE_TYPE, tag=(68, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterQueryStatus')), opt=True)
    _MOCallRecord_partialRecordType = ENUM(name=u'partialRecordType', mode=MODE_TYPE, tag=(69, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'PartialRecordType')), opt=True)
    _MOCallRecord_guaranteedBitRate = ENUM(name=u'guaranteedBitRate', mode=MODE_TYPE, tag=(70, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'GuaranteedBitRate')), opt=True)
    _MOCallRecord_maximumBitRate = ENUM(name=u'maximumBitRate', mode=MODE_TYPE, tag=(71, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MaximumBitRate')), opt=True)
    _MOCallRecord_redial = BOOL(name=u'redial', mode=MODE_TYPE, tag=(72, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MOCallRecord_reasonForServiceChange = ENUM(name=u'reasonForServiceChange', mode=MODE_TYPE, tag=(73, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ReasonForServiceChange')), opt=True)
    _MOCallRecord_serviceChangeInitiator = BOOL(name=u'serviceChangeInitiator', mode=MODE_TYPE, tag=(74, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MOCallRecord_iCSI2ActiveFlag = NULL(name=u'iCSI2ActiveFlag', mode=MODE_TYPE, tag=(75, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MOCallRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(76, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _MOCallRecord_privateUserID = STR_GRAPH(name=u'privateUserID', mode=MODE_TYPE, tag=(77, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    MOCallRecord._cont = ASN1Dict([
        (u'recordType', _MOCallRecord_recordType),
        (u'servedIMSI', _MOCallRecord_servedIMSI),
        (u'servedIMEI', _MOCallRecord_servedIMEI),
        (u'servedMSISDN', _MOCallRecord_servedMSISDN),
        (u'callingNumber', _MOCallRecord_callingNumber),
        (u'calledNumber', _MOCallRecord_calledNumber),
        (u'translatedNumber', _MOCallRecord_translatedNumber),
        (u'connectedNumber', _MOCallRecord_connectedNumber),
        (u'roamingNumber', _MOCallRecord_roamingNumber),
        (u'recordingEntity', _MOCallRecord_recordingEntity),
        (u'mscIncomingTKGP', _MOCallRecord_mscIncomingTKGP),
        (u'mscOutgoingTKGP', _MOCallRecord_mscOutgoingTKGP),
        (u'location', _MOCallRecord_location),
        (u'changeOfLocation', _MOCallRecord_changeOfLocation),
        (u'basicService', _MOCallRecord_basicService),
        (u'transparencyIndicator', _MOCallRecord_transparencyIndicator),
        (u'changeOfService', _MOCallRecord_changeOfService),
        (u'supplServicesUsed', _MOCallRecord_supplServicesUsed),
        (u'aocParameters', _MOCallRecord_aocParameters),
        (u'changeOfAOCParms', _MOCallRecord_changeOfAOCParms),
        (u'msClassmark', _MOCallRecord_msClassmark),
        (u'changeOfClassmark', _MOCallRecord_changeOfClassmark),
        (u'seizureTime', _MOCallRecord_seizureTime),
        (u'answerTime', _MOCallRecord_answerTime),
        (u'releaseTime', _MOCallRecord_releaseTime),
        (u'callDuration', _MOCallRecord_callDuration),
        (u'dataVolume', _MOCallRecord_dataVolume),
        (u'radioChanRequested', _MOCallRecord_radioChanRequested),
        (u'radioChanUsed', _MOCallRecord_radioChanUsed),
        (u'changeOfRadioChan', _MOCallRecord_changeOfRadioChan),
        (u'causeForTerm', _MOCallRecord_causeForTerm),
        (u'diagnostics', _MOCallRecord_diagnostics),
        (u'callReference', _MOCallRecord_callReference),
        (u'sequenceNumber', _MOCallRecord_sequenceNumber),
        (u'additionalChgInfo', _MOCallRecord_additionalChgInfo),
        (u'recordExtensions', _MOCallRecord_recordExtensions),
        (u'gsm-SCFAddress', _MOCallRecord_gsm_SCFAddress),
        (u'serviceKey', _MOCallRecord_serviceKey),
        (u'networkCallReference', _MOCallRecord_networkCallReference),
        (u'mSCAddress', _MOCallRecord_mSCAddress),
        (u'cAMELInitCFIndicator', _MOCallRecord_cAMELInitCFIndicator),
        (u'defaultCallHandling', _MOCallRecord_defaultCallHandling),
        (u'hSCSDChanRequested', _MOCallRecord_hSCSDChanRequested),
        (u'hSCSDChanAllocated', _MOCallRecord_hSCSDChanAllocated),
        (u'changeOfHSCSDParms', _MOCallRecord_changeOfHSCSDParms),
        (u'fnur', _MOCallRecord_fnur),
        (u'aiurRequested', _MOCallRecord_aiurRequested),
        (u'chanCodingsAcceptable', _MOCallRecord_chanCodingsAcceptable),
        (u'chanCodingUsed', _MOCallRecord_chanCodingUsed),
        (u'speechVersionSupported', _MOCallRecord_speechVersionSupported),
        (u'speechVersionUsed', _MOCallRecord_speechVersionUsed),
        (u'numberOfDPEncountered', _MOCallRecord_numberOfDPEncountered),
        (u'levelOfCAMELService', _MOCallRecord_levelOfCAMELService),
        (u'freeFormatData', _MOCallRecord_freeFormatData),
        (u'cAMELCallLegInformation', _MOCallRecord_cAMELCallLegInformation),
        (u'freeFormatDataAppend', _MOCallRecord_freeFormatDataAppend),
        (u'defaultCallHandling-2', _MOCallRecord_defaultCallHandling_2),
        (u'gsm-SCFAddress-2', _MOCallRecord_gsm_SCFAddress_2),
        (u'serviceKey-2', _MOCallRecord_serviceKey_2),
        (u'freeFormatData-2', _MOCallRecord_freeFormatData_2),
        (u'freeFormatDataAppend-2', _MOCallRecord_freeFormatDataAppend_2),
        (u'systemType', _MOCallRecord_systemType),
        (u'rateIndication', _MOCallRecord_rateIndication),
        (u'locationRoutNum', _MOCallRecord_locationRoutNum),
        (u'lrnSoInd', _MOCallRecord_lrnSoInd),
        (u'lrnQuryStatus', _MOCallRecord_lrnQuryStatus),
        (u'jIPPara', _MOCallRecord_jIPPara),
        (u'jIPSoInd', _MOCallRecord_jIPSoInd),
        (u'jIPQuryStatus', _MOCallRecord_jIPQuryStatus),
        (u'partialRecordType', _MOCallRecord_partialRecordType),
        (u'guaranteedBitRate', _MOCallRecord_guaranteedBitRate),
        (u'maximumBitRate', _MOCallRecord_maximumBitRate),
        (u'redial', _MOCallRecord_redial),
        (u'reasonForServiceChange', _MOCallRecord_reasonForServiceChange),
        (u'serviceChangeInitiator', _MOCallRecord_serviceChangeInitiator),
        (u'iCSI2ActiveFlag', _MOCallRecord_iCSI2ActiveFlag),
        (u'iMS-Charging-Identifier', _MOCallRecord_iMS_Charging_Identifier),
        (u'privateUserID', _MOCallRecord_privateUserID),
        ])
    MOCallRecord._ext = None
    
    #-----< MTCallRecord >-----#
    MTCallRecord = SET(name=u'MTCallRecord', mode=MODE_TYPE)
    _MTCallRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MTCallRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _MTCallRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _MTCallRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')), opt=True)
    _MTCallRecord_callingNumber = OCT_STR(name=u'callingNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _MTCallRecord_connectedNumber = OCT_STR(name=u'connectedNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ConnectedNumber')), opt=True)
    _MTCallRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MTCallRecord_mscIncomingTKGP = CHOICE(name=u'mscIncomingTKGP', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _MTCallRecord_mscOutgoingTKGP = CHOICE(name=u'mscOutgoingTKGP', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _MTCallRecord_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _MTCallRecord_changeOfLocation = SEQ_OF(name=u'changeOfLocation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MTCallRecord_changeOfLocation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'LocationChange')))
    _MTCallRecord_changeOfLocation._cont = __MTCallRecord_changeOfLocation__item_
    _MTCallRecord_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _MTCallRecord_transparencyIndicator = ENUM(name=u'transparencyIndicator', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TransparencyInd')), opt=True)
    _MTCallRecord_changeOfService = SEQ_OF(name=u'changeOfService', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MTCallRecord_changeOfService__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfService')))
    _MTCallRecord_changeOfService._cont = __MTCallRecord_changeOfService__item_
    _MTCallRecord_supplServicesUsed = SEQ_OF(name=u'supplServicesUsed', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MTCallRecord_supplServicesUsed__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'SuppServiceUsed')))
    _MTCallRecord_supplServicesUsed._cont = __MTCallRecord_supplServicesUsed__item_
    _MTCallRecord_aocParameters = SEQ(name=u'aocParameters', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AOCParameters')), opt=True)
    _MTCallRecord_changeOfAOCParms = SEQ_OF(name=u'changeOfAOCParms', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MTCallRecord_changeOfAOCParms__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'AOCParmChange')))
    _MTCallRecord_changeOfAOCParms._cont = __MTCallRecord_changeOfAOCParms__item_
    _MTCallRecord_msClassmark = OCT_STR(name=u'msClassmark', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')), opt=True)
    _MTCallRecord_changeOfClassmark = SEQ(name=u'changeOfClassmark', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfClassmark')), opt=True)
    _MTCallRecord_seizureTime = OCT_STR(name=u'seizureTime', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MTCallRecord_answerTime = OCT_STR(name=u'answerTime', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MTCallRecord_releaseTime = OCT_STR(name=u'releaseTime', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MTCallRecord_callDuration = INT(name=u'callDuration', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _MTCallRecord_dataVolume = INT(name=u'dataVolume', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _MTCallRecord_radioChanRequested = ENUM(name=u'radioChanRequested', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RadioChanRequested')), opt=True)
    _MTCallRecord_radioChanUsed = ENUM(name=u'radioChanUsed', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrafficChannel')), opt=True)
    _MTCallRecord_changeOfRadioChan = SEQ(name=u'changeOfRadioChan', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfRadioChannel')), opt=True)
    _MTCallRecord_causeForTerm = INT(name=u'causeForTerm', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _MTCallRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _MTCallRecord_callReference = OCT_STR(name=u'callReference', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _MTCallRecord_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MTCallRecord_additionalChgInfo = SEQ(name=u'additionalChgInfo', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AdditionalChgInfo')), opt=True)
    _MTCallRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MTCallRecord_networkCallReference = OCT_STR(name=u'networkCallReference', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NetworkCallReference')), opt=True)
    _MTCallRecord_mSCAddress = OCT_STR(name=u'mSCAddress', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSCAddress')), opt=True)
    _MTCallRecord_hSCSDChanRequested = INT(name=u'hSCSDChanRequested', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NumOfHSCSDChanRequested')), opt=True)
    _MTCallRecord_hSCSDChanAllocated = INT(name=u'hSCSDChanAllocated', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NumOfHSCSDChanAllocated')), opt=True)
    _MTCallRecord_changeOfHSCSDParms = SEQ_OF(name=u'changeOfHSCSDParms', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MTCallRecord_changeOfHSCSDParms__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'HSCSDParmsChange')))
    _MTCallRecord_changeOfHSCSDParms._cont = __MTCallRecord_changeOfHSCSDParms__item_
    _MTCallRecord_fnur = ENUM(name=u'fnur', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Fnur')), opt=True)
    _MTCallRecord_aiurRequested = ENUM(name=u'aiurRequested', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AiurRequested')), opt=True)
    _MTCallRecord_chanCodingsAcceptable = SEQ_OF(name=u'chanCodingsAcceptable', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MTCallRecord_chanCodingsAcceptable__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'ChannelCoding')))
    _MTCallRecord_chanCodingsAcceptable._cont = __MTCallRecord_chanCodingsAcceptable__item_
    _MTCallRecord_chanCodingUsed = ENUM(name=u'chanCodingUsed', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChannelCoding')), opt=True)
    _MTCallRecord_speechVersionSupported = OCT_STR(name=u'speechVersionSupported', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SpeechVersionIdentifier')), opt=True)
    _MTCallRecord_speechVersionUsed = OCT_STR(name=u'speechVersionUsed', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SpeechVersionIdentifier')), opt=True)
    _MTCallRecord_gsm_SCFAddress = OCT_STR(name=u'gsm-SCFAddress', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Gsm-SCFAddress')), opt=True)
    _MTCallRecord_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _MTCallRecord_systemType = ENUM(name=u'systemType', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _MTCallRecord_rateIndication = OCT_STR(name=u'rateIndication', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RateIndication')), opt=True)
    _MTCallRecord_locationRoutNum = OCT_STR(name=u'locationRoutNum', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumber')), opt=True)
    _MTCallRecord_lrnSoInd = INT(name=u'lrnSoInd', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberSourceIndicator')), opt=True)
    _MTCallRecord_lrnQuryStatus = INT(name=u'lrnQuryStatus', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberQueryStatus')), opt=True)
    _MTCallRecord_jIPPara = OCT_STR(name=u'jIPPara', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameter')), opt=True)
    _MTCallRecord_jIPSoInd = INT(name=u'jIPSoInd', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterSourceIndicator')), opt=True)
    _MTCallRecord_jIPQuryStatus = INT(name=u'jIPQuryStatus', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterQueryStatus')), opt=True)
    _MTCallRecord_partialRecordType = ENUM(name=u'partialRecordType', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'PartialRecordType')), opt=True)
    _MTCallRecord_guaranteedBitRate = ENUM(name=u'guaranteedBitRate', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'GuaranteedBitRate')), opt=True)
    _MTCallRecord_maximumBitRate = ENUM(name=u'maximumBitRate', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'MaximumBitRate')), opt=True)
    _MTCallRecord_reasonForServiceChange = ENUM(name=u'reasonForServiceChange', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ReasonForServiceChange')), opt=True)
    _MTCallRecord_serviceChangeInitiator = BOOL(name=u'serviceChangeInitiator', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MTCallRecord_iCSI2ActiveFlag = NULL(name=u'iCSI2ActiveFlag', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MTCallRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _MTCallRecord_privateUserID = STR_GRAPH(name=u'privateUserID', mode=MODE_TYPE, tag=(61, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    MTCallRecord._cont = ASN1Dict([
        (u'recordType', _MTCallRecord_recordType),
        (u'servedIMSI', _MTCallRecord_servedIMSI),
        (u'servedIMEI', _MTCallRecord_servedIMEI),
        (u'servedMSISDN', _MTCallRecord_servedMSISDN),
        (u'callingNumber', _MTCallRecord_callingNumber),
        (u'connectedNumber', _MTCallRecord_connectedNumber),
        (u'recordingEntity', _MTCallRecord_recordingEntity),
        (u'mscIncomingTKGP', _MTCallRecord_mscIncomingTKGP),
        (u'mscOutgoingTKGP', _MTCallRecord_mscOutgoingTKGP),
        (u'location', _MTCallRecord_location),
        (u'changeOfLocation', _MTCallRecord_changeOfLocation),
        (u'basicService', _MTCallRecord_basicService),
        (u'transparencyIndicator', _MTCallRecord_transparencyIndicator),
        (u'changeOfService', _MTCallRecord_changeOfService),
        (u'supplServicesUsed', _MTCallRecord_supplServicesUsed),
        (u'aocParameters', _MTCallRecord_aocParameters),
        (u'changeOfAOCParms', _MTCallRecord_changeOfAOCParms),
        (u'msClassmark', _MTCallRecord_msClassmark),
        (u'changeOfClassmark', _MTCallRecord_changeOfClassmark),
        (u'seizureTime', _MTCallRecord_seizureTime),
        (u'answerTime', _MTCallRecord_answerTime),
        (u'releaseTime', _MTCallRecord_releaseTime),
        (u'callDuration', _MTCallRecord_callDuration),
        (u'dataVolume', _MTCallRecord_dataVolume),
        (u'radioChanRequested', _MTCallRecord_radioChanRequested),
        (u'radioChanUsed', _MTCallRecord_radioChanUsed),
        (u'changeOfRadioChan', _MTCallRecord_changeOfRadioChan),
        (u'causeForTerm', _MTCallRecord_causeForTerm),
        (u'diagnostics', _MTCallRecord_diagnostics),
        (u'callReference', _MTCallRecord_callReference),
        (u'sequenceNumber', _MTCallRecord_sequenceNumber),
        (u'additionalChgInfo', _MTCallRecord_additionalChgInfo),
        (u'recordExtensions', _MTCallRecord_recordExtensions),
        (u'networkCallReference', _MTCallRecord_networkCallReference),
        (u'mSCAddress', _MTCallRecord_mSCAddress),
        (u'hSCSDChanRequested', _MTCallRecord_hSCSDChanRequested),
        (u'hSCSDChanAllocated', _MTCallRecord_hSCSDChanAllocated),
        (u'changeOfHSCSDParms', _MTCallRecord_changeOfHSCSDParms),
        (u'fnur', _MTCallRecord_fnur),
        (u'aiurRequested', _MTCallRecord_aiurRequested),
        (u'chanCodingsAcceptable', _MTCallRecord_chanCodingsAcceptable),
        (u'chanCodingUsed', _MTCallRecord_chanCodingUsed),
        (u'speechVersionSupported', _MTCallRecord_speechVersionSupported),
        (u'speechVersionUsed', _MTCallRecord_speechVersionUsed),
        (u'gsm-SCFAddress', _MTCallRecord_gsm_SCFAddress),
        (u'serviceKey', _MTCallRecord_serviceKey),
        (u'systemType', _MTCallRecord_systemType),
        (u'rateIndication', _MTCallRecord_rateIndication),
        (u'locationRoutNum', _MTCallRecord_locationRoutNum),
        (u'lrnSoInd', _MTCallRecord_lrnSoInd),
        (u'lrnQuryStatus', _MTCallRecord_lrnQuryStatus),
        (u'jIPPara', _MTCallRecord_jIPPara),
        (u'jIPSoInd', _MTCallRecord_jIPSoInd),
        (u'jIPQuryStatus', _MTCallRecord_jIPQuryStatus),
        (u'partialRecordType', _MTCallRecord_partialRecordType),
        (u'guaranteedBitRate', _MTCallRecord_guaranteedBitRate),
        (u'maximumBitRate', _MTCallRecord_maximumBitRate),
        (u'reasonForServiceChange', _MTCallRecord_reasonForServiceChange),
        (u'serviceChangeInitiator', _MTCallRecord_serviceChangeInitiator),
        (u'iCSI2ActiveFlag', _MTCallRecord_iCSI2ActiveFlag),
        (u'iMS-Charging-Identifier', _MTCallRecord_iMS_Charging_Identifier),
        (u'privateUserID', _MTCallRecord_privateUserID),
        ])
    MTCallRecord._ext = None
    
    #-----< RoamingRecord >-----#
    RoamingRecord = SET(name=u'RoamingRecord', mode=MODE_TYPE)
    _RoamingRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _RoamingRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _RoamingRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _RoamingRecord_callingNumber = OCT_STR(name=u'callingNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _RoamingRecord_roamingNumber = OCT_STR(name=u'roamingNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RoamingNumber')), opt=True)
    _RoamingRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _RoamingRecord_mscIncomingTKGP = CHOICE(name=u'mscIncomingTKGP', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _RoamingRecord_mscOutgoingTKGP = CHOICE(name=u'mscOutgoingTKGP', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _RoamingRecord_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _RoamingRecord_transparencyIndicator = ENUM(name=u'transparencyIndicator', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TransparencyInd')), opt=True)
    _RoamingRecord_changeOfService = SEQ_OF(name=u'changeOfService', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RoamingRecord_changeOfService__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfService')))
    _RoamingRecord_changeOfService._cont = __RoamingRecord_changeOfService__item_
    _RoamingRecord_supplServicesUsed = SEQ_OF(name=u'supplServicesUsed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RoamingRecord_supplServicesUsed__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'SuppServiceUsed')))
    _RoamingRecord_supplServicesUsed._cont = __RoamingRecord_supplServicesUsed__item_
    _RoamingRecord_seizureTime = OCT_STR(name=u'seizureTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _RoamingRecord_answerTime = OCT_STR(name=u'answerTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _RoamingRecord_releaseTime = OCT_STR(name=u'releaseTime', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _RoamingRecord_callDuration = INT(name=u'callDuration', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _RoamingRecord_dataVolume = INT(name=u'dataVolume', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _RoamingRecord_causeForTerm = INT(name=u'causeForTerm', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _RoamingRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _RoamingRecord_callReference = OCT_STR(name=u'callReference', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _RoamingRecord_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RoamingRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _RoamingRecord_networkCallReference = OCT_STR(name=u'networkCallReference', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NetworkCallReference')), opt=True)
    _RoamingRecord_mSCAddress = OCT_STR(name=u'mSCAddress', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSCAddress')), opt=True)
    _RoamingRecord_locationRoutNum = OCT_STR(name=u'locationRoutNum', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumber')), opt=True)
    _RoamingRecord_lrnSoInd = INT(name=u'lrnSoInd', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberSourceIndicator')), opt=True)
    _RoamingRecord_lrnQuryStatus = INT(name=u'lrnQuryStatus', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberQueryStatus')), opt=True)
    _RoamingRecord_jIPPara = OCT_STR(name=u'jIPPara', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameter')), opt=True)
    _RoamingRecord_jIPSoInd = INT(name=u'jIPSoInd', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterSourceIndicator')), opt=True)
    _RoamingRecord_jIPQuryStatus = INT(name=u'jIPQuryStatus', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterQueryStatus')), opt=True)
    _RoamingRecord_partialRecordType = ENUM(name=u'partialRecordType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'PartialRecordType')), opt=True)
    RoamingRecord._cont = ASN1Dict([
        (u'recordType', _RoamingRecord_recordType),
        (u'servedIMSI', _RoamingRecord_servedIMSI),
        (u'servedMSISDN', _RoamingRecord_servedMSISDN),
        (u'callingNumber', _RoamingRecord_callingNumber),
        (u'roamingNumber', _RoamingRecord_roamingNumber),
        (u'recordingEntity', _RoamingRecord_recordingEntity),
        (u'mscIncomingTKGP', _RoamingRecord_mscIncomingTKGP),
        (u'mscOutgoingTKGP', _RoamingRecord_mscOutgoingTKGP),
        (u'basicService', _RoamingRecord_basicService),
        (u'transparencyIndicator', _RoamingRecord_transparencyIndicator),
        (u'changeOfService', _RoamingRecord_changeOfService),
        (u'supplServicesUsed', _RoamingRecord_supplServicesUsed),
        (u'seizureTime', _RoamingRecord_seizureTime),
        (u'answerTime', _RoamingRecord_answerTime),
        (u'releaseTime', _RoamingRecord_releaseTime),
        (u'callDuration', _RoamingRecord_callDuration),
        (u'dataVolume', _RoamingRecord_dataVolume),
        (u'causeForTerm', _RoamingRecord_causeForTerm),
        (u'diagnostics', _RoamingRecord_diagnostics),
        (u'callReference', _RoamingRecord_callReference),
        (u'sequenceNumber', _RoamingRecord_sequenceNumber),
        (u'recordExtensions', _RoamingRecord_recordExtensions),
        (u'networkCallReference', _RoamingRecord_networkCallReference),
        (u'mSCAddress', _RoamingRecord_mSCAddress),
        (u'locationRoutNum', _RoamingRecord_locationRoutNum),
        (u'lrnSoInd', _RoamingRecord_lrnSoInd),
        (u'lrnQuryStatus', _RoamingRecord_lrnQuryStatus),
        (u'jIPPara', _RoamingRecord_jIPPara),
        (u'jIPSoInd', _RoamingRecord_jIPSoInd),
        (u'jIPQuryStatus', _RoamingRecord_jIPQuryStatus),
        (u'partialRecordType', _RoamingRecord_partialRecordType),
        ])
    RoamingRecord._ext = None
    
    #-----< TermCAMELRecord >-----#
    TermCAMELRecord = SET(name=u'TermCAMELRecord', mode=MODE_TYPE)
    _TermCAMELRecord_recordtype = INT(name=u'recordtype', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _TermCAMELRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _TermCAMELRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _TermCAMELRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _TermCAMELRecord_interrogationTime = OCT_STR(name=u'interrogationTime', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _TermCAMELRecord_destinationRoutingAddress = SEQ_OF(name=u'destinationRoutingAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    _TermCAMELRecord_gsm_SCFAddress = OCT_STR(name=u'gsm-SCFAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Gsm-SCFAddress')))
    _TermCAMELRecord_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _TermCAMELRecord_networkCallReference = OCT_STR(name=u'networkCallReference', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NetworkCallReference')), opt=True)
    _TermCAMELRecord_mSCAddress = OCT_STR(name=u'mSCAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSCAddress')), opt=True)
    _TermCAMELRecord_defaultCallHandling = ENUM(name=u'defaultCallHandling', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')), opt=True)
    _TermCAMELRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _TermCAMELRecord_calledNumber = OCT_STR(name=u'calledNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')))
    _TermCAMELRecord_callingNumber = OCT_STR(name=u'callingNumber', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _TermCAMELRecord_mscIncomingTKGP = CHOICE(name=u'mscIncomingTKGP', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _TermCAMELRecord_mscOutgoingTKGP = CHOICE(name=u'mscOutgoingTKGP', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _TermCAMELRecord_seizureTime = OCT_STR(name=u'seizureTime', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TermCAMELRecord_answerTime = OCT_STR(name=u'answerTime', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TermCAMELRecord_releaseTime = OCT_STR(name=u'releaseTime', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TermCAMELRecord_callDuration = INT(name=u'callDuration', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _TermCAMELRecord_dataVolume = INT(name=u'dataVolume', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _TermCAMELRecord_causeForTerm = INT(name=u'causeForTerm', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _TermCAMELRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _TermCAMELRecord_callReference = OCT_STR(name=u'callReference', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _TermCAMELRecord_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TermCAMELRecord_numberOfDPEncountered = INT(name=u'numberOfDPEncountered', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TermCAMELRecord_levelOfCAMELService = BIT_STR(name=u'levelOfCAMELService', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LevelOfCAMELService')), opt=True)
    _TermCAMELRecord_freeFormatData = OCT_STR(name=u'freeFormatData', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FreeFormatData')), opt=True)
    _TermCAMELRecord_cAMELCallLegInformation = SEQ_OF(name=u'cAMELCallLegInformation', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TermCAMELRecord_cAMELCallLegInformation__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELInformation')))
    _TermCAMELRecord_cAMELCallLegInformation._cont = __TermCAMELRecord_cAMELCallLegInformation__item_
    _TermCAMELRecord_freeFormatDataAppend = BOOL(name=u'freeFormatDataAppend', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TermCAMELRecord_defaultCallHandling_2 = ENUM(name=u'defaultCallHandling-2', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')), opt=True)
    _TermCAMELRecord_gsm_SCFAddress_2 = OCT_STR(name=u'gsm-SCFAddress-2', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Gsm-SCFAddress')), opt=True)
    _TermCAMELRecord_serviceKey_2 = INT(name=u'serviceKey-2', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _TermCAMELRecord_freeFormatData_2 = OCT_STR(name=u'freeFormatData-2', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FreeFormatData')), opt=True)
    _TermCAMELRecord_freeFormatDataAppend_2 = BOOL(name=u'freeFormatDataAppend-2', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TermCAMELRecord_mscServerIndication = BOOL(name=u'mscServerIndication', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TermCAMELRecord_locationRoutNum = OCT_STR(name=u'locationRoutNum', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumber')), opt=True)
    _TermCAMELRecord_lrnSoInd = INT(name=u'lrnSoInd', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberSourceIndicator')), opt=True)
    _TermCAMELRecord_lrnQuryStatus = INT(name=u'lrnQuryStatus', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberQueryStatus')), opt=True)
    _TermCAMELRecord_jIPPara = OCT_STR(name=u'jIPPara', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameter')), opt=True)
    _TermCAMELRecord_jIPSoInd = INT(name=u'jIPSoInd', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterSourceIndicator')), opt=True)
    _TermCAMELRecord_jIPQuryStatus = INT(name=u'jIPQuryStatus', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterQueryStatus')), opt=True)
    _TermCAMELRecord_partialRecordType = ENUM(name=u'partialRecordType', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'PartialRecordType')), opt=True)
    TermCAMELRecord._cont = ASN1Dict([
        (u'recordtype', _TermCAMELRecord_recordtype),
        (u'servedIMSI', _TermCAMELRecord_servedIMSI),
        (u'servedMSISDN', _TermCAMELRecord_servedMSISDN),
        (u'recordingEntity', _TermCAMELRecord_recordingEntity),
        (u'interrogationTime', _TermCAMELRecord_interrogationTime),
        (u'destinationRoutingAddress', _TermCAMELRecord_destinationRoutingAddress),
        (u'gsm-SCFAddress', _TermCAMELRecord_gsm_SCFAddress),
        (u'serviceKey', _TermCAMELRecord_serviceKey),
        (u'networkCallReference', _TermCAMELRecord_networkCallReference),
        (u'mSCAddress', _TermCAMELRecord_mSCAddress),
        (u'defaultCallHandling', _TermCAMELRecord_defaultCallHandling),
        (u'recordExtensions', _TermCAMELRecord_recordExtensions),
        (u'calledNumber', _TermCAMELRecord_calledNumber),
        (u'callingNumber', _TermCAMELRecord_callingNumber),
        (u'mscIncomingTKGP', _TermCAMELRecord_mscIncomingTKGP),
        (u'mscOutgoingTKGP', _TermCAMELRecord_mscOutgoingTKGP),
        (u'seizureTime', _TermCAMELRecord_seizureTime),
        (u'answerTime', _TermCAMELRecord_answerTime),
        (u'releaseTime', _TermCAMELRecord_releaseTime),
        (u'callDuration', _TermCAMELRecord_callDuration),
        (u'dataVolume', _TermCAMELRecord_dataVolume),
        (u'causeForTerm', _TermCAMELRecord_causeForTerm),
        (u'diagnostics', _TermCAMELRecord_diagnostics),
        (u'callReference', _TermCAMELRecord_callReference),
        (u'sequenceNumber', _TermCAMELRecord_sequenceNumber),
        (u'numberOfDPEncountered', _TermCAMELRecord_numberOfDPEncountered),
        (u'levelOfCAMELService', _TermCAMELRecord_levelOfCAMELService),
        (u'freeFormatData', _TermCAMELRecord_freeFormatData),
        (u'cAMELCallLegInformation', _TermCAMELRecord_cAMELCallLegInformation),
        (u'freeFormatDataAppend', _TermCAMELRecord_freeFormatDataAppend),
        (u'defaultCallHandling-2', _TermCAMELRecord_defaultCallHandling_2),
        (u'gsm-SCFAddress-2', _TermCAMELRecord_gsm_SCFAddress_2),
        (u'serviceKey-2', _TermCAMELRecord_serviceKey_2),
        (u'freeFormatData-2', _TermCAMELRecord_freeFormatData_2),
        (u'freeFormatDataAppend-2', _TermCAMELRecord_freeFormatDataAppend_2),
        (u'mscServerIndication', _TermCAMELRecord_mscServerIndication),
        (u'locationRoutNum', _TermCAMELRecord_locationRoutNum),
        (u'lrnSoInd', _TermCAMELRecord_lrnSoInd),
        (u'lrnQuryStatus', _TermCAMELRecord_lrnQuryStatus),
        (u'jIPPara', _TermCAMELRecord_jIPPara),
        (u'jIPSoInd', _TermCAMELRecord_jIPSoInd),
        (u'jIPQuryStatus', _TermCAMELRecord_jIPQuryStatus),
        (u'partialRecordType', _TermCAMELRecord_partialRecordType),
        ])
    TermCAMELRecord._ext = None
    
    #-----< IncGatewayRecord >-----#
    IncGatewayRecord = SET(name=u'IncGatewayRecord', mode=MODE_TYPE)
    _IncGatewayRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _IncGatewayRecord_callingNumber = OCT_STR(name=u'callingNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _IncGatewayRecord_calledNumber = OCT_STR(name=u'calledNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')))
    _IncGatewayRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _IncGatewayRecord_mscIncomingTKGP = CHOICE(name=u'mscIncomingTKGP', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _IncGatewayRecord_mscOutgoingTKGP = CHOICE(name=u'mscOutgoingTKGP', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _IncGatewayRecord_seizureTime = OCT_STR(name=u'seizureTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IncGatewayRecord_answerTime = OCT_STR(name=u'answerTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IncGatewayRecord_releaseTime = OCT_STR(name=u'releaseTime', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IncGatewayRecord_callDuration = INT(name=u'callDuration', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _IncGatewayRecord_dataVolume = INT(name=u'dataVolume', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _IncGatewayRecord_causeForTerm = INT(name=u'causeForTerm', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _IncGatewayRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _IncGatewayRecord_callReference = OCT_STR(name=u'callReference', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _IncGatewayRecord_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IncGatewayRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _IncGatewayRecord_locationRoutNum = OCT_STR(name=u'locationRoutNum', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumber')), opt=True)
    _IncGatewayRecord_lrnSoInd = INT(name=u'lrnSoInd', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberSourceIndicator')), opt=True)
    _IncGatewayRecord_lrnQuryStatus = INT(name=u'lrnQuryStatus', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberQueryStatus')), opt=True)
    _IncGatewayRecord_jIPPara = OCT_STR(name=u'jIPPara', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameter')), opt=True)
    _IncGatewayRecord_jIPSoInd = INT(name=u'jIPSoInd', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterSourceIndicator')), opt=True)
    _IncGatewayRecord_jIPQuryStatus = INT(name=u'jIPQuryStatus', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterQueryStatus')), opt=True)
    _IncGatewayRecord_reasonForServiceChange = ENUM(name=u'reasonForServiceChange', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ReasonForServiceChange')), opt=True)
    _IncGatewayRecord_serviceChangeInitiator = BOOL(name=u'serviceChangeInitiator', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    IncGatewayRecord._cont = ASN1Dict([
        (u'recordType', _IncGatewayRecord_recordType),
        (u'callingNumber', _IncGatewayRecord_callingNumber),
        (u'calledNumber', _IncGatewayRecord_calledNumber),
        (u'recordingEntity', _IncGatewayRecord_recordingEntity),
        (u'mscIncomingTKGP', _IncGatewayRecord_mscIncomingTKGP),
        (u'mscOutgoingTKGP', _IncGatewayRecord_mscOutgoingTKGP),
        (u'seizureTime', _IncGatewayRecord_seizureTime),
        (u'answerTime', _IncGatewayRecord_answerTime),
        (u'releaseTime', _IncGatewayRecord_releaseTime),
        (u'callDuration', _IncGatewayRecord_callDuration),
        (u'dataVolume', _IncGatewayRecord_dataVolume),
        (u'causeForTerm', _IncGatewayRecord_causeForTerm),
        (u'diagnostics', _IncGatewayRecord_diagnostics),
        (u'callReference', _IncGatewayRecord_callReference),
        (u'sequenceNumber', _IncGatewayRecord_sequenceNumber),
        (u'recordExtensions', _IncGatewayRecord_recordExtensions),
        (u'locationRoutNum', _IncGatewayRecord_locationRoutNum),
        (u'lrnSoInd', _IncGatewayRecord_lrnSoInd),
        (u'lrnQuryStatus', _IncGatewayRecord_lrnQuryStatus),
        (u'jIPPara', _IncGatewayRecord_jIPPara),
        (u'jIPSoInd', _IncGatewayRecord_jIPSoInd),
        (u'jIPQuryStatus', _IncGatewayRecord_jIPQuryStatus),
        (u'reasonForServiceChange', _IncGatewayRecord_reasonForServiceChange),
        (u'serviceChangeInitiator', _IncGatewayRecord_serviceChangeInitiator),
        ])
    IncGatewayRecord._ext = None
    
    #-----< OutGatewayRecord >-----#
    OutGatewayRecord = SET(name=u'OutGatewayRecord', mode=MODE_TYPE)
    _OutGatewayRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _OutGatewayRecord_callingNumber = OCT_STR(name=u'callingNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _OutGatewayRecord_calledNumber = OCT_STR(name=u'calledNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')))
    _OutGatewayRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _OutGatewayRecord_mscIncomingTKGP = CHOICE(name=u'mscIncomingTKGP', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _OutGatewayRecord_mscOutgoingTKGP = CHOICE(name=u'mscOutgoingTKGP', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _OutGatewayRecord_seizureTime = OCT_STR(name=u'seizureTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _OutGatewayRecord_answerTime = OCT_STR(name=u'answerTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _OutGatewayRecord_releaseTime = OCT_STR(name=u'releaseTime', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _OutGatewayRecord_callDuration = INT(name=u'callDuration', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _OutGatewayRecord_dataVolume = INT(name=u'dataVolume', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _OutGatewayRecord_causeForTerm = INT(name=u'causeForTerm', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _OutGatewayRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _OutGatewayRecord_callReference = OCT_STR(name=u'callReference', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _OutGatewayRecord_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OutGatewayRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _OutGatewayRecord_locationRoutNum = OCT_STR(name=u'locationRoutNum', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumber')), opt=True)
    _OutGatewayRecord_lrnSoInd = INT(name=u'lrnSoInd', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberSourceIndicator')), opt=True)
    _OutGatewayRecord_lrnQuryStatus = INT(name=u'lrnQuryStatus', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberQueryStatus')), opt=True)
    _OutGatewayRecord_jIPPara = OCT_STR(name=u'jIPPara', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameter')), opt=True)
    _OutGatewayRecord_jIPSoInd = INT(name=u'jIPSoInd', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterSourceIndicator')), opt=True)
    _OutGatewayRecord_jIPQuryStatus = INT(name=u'jIPQuryStatus', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterQueryStatus')), opt=True)
    _OutGatewayRecord_reasonForServiceChange = ENUM(name=u'reasonForServiceChange', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ReasonForServiceChange')), opt=True)
    _OutGatewayRecord_serviceChangeInitiator = BOOL(name=u'serviceChangeInitiator', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OutGatewayRecord._cont = ASN1Dict([
        (u'recordType', _OutGatewayRecord_recordType),
        (u'callingNumber', _OutGatewayRecord_callingNumber),
        (u'calledNumber', _OutGatewayRecord_calledNumber),
        (u'recordingEntity', _OutGatewayRecord_recordingEntity),
        (u'mscIncomingTKGP', _OutGatewayRecord_mscIncomingTKGP),
        (u'mscOutgoingTKGP', _OutGatewayRecord_mscOutgoingTKGP),
        (u'seizureTime', _OutGatewayRecord_seizureTime),
        (u'answerTime', _OutGatewayRecord_answerTime),
        (u'releaseTime', _OutGatewayRecord_releaseTime),
        (u'callDuration', _OutGatewayRecord_callDuration),
        (u'dataVolume', _OutGatewayRecord_dataVolume),
        (u'causeForTerm', _OutGatewayRecord_causeForTerm),
        (u'diagnostics', _OutGatewayRecord_diagnostics),
        (u'callReference', _OutGatewayRecord_callReference),
        (u'sequenceNumber', _OutGatewayRecord_sequenceNumber),
        (u'recordExtensions', _OutGatewayRecord_recordExtensions),
        (u'locationRoutNum', _OutGatewayRecord_locationRoutNum),
        (u'lrnSoInd', _OutGatewayRecord_lrnSoInd),
        (u'lrnQuryStatus', _OutGatewayRecord_lrnQuryStatus),
        (u'jIPPara', _OutGatewayRecord_jIPPara),
        (u'jIPSoInd', _OutGatewayRecord_jIPSoInd),
        (u'jIPQuryStatus', _OutGatewayRecord_jIPQuryStatus),
        (u'reasonForServiceChange', _OutGatewayRecord_reasonForServiceChange),
        (u'serviceChangeInitiator', _OutGatewayRecord_serviceChangeInitiator),
        ])
    OutGatewayRecord._ext = None
    
    #-----< TransitCallRecord >-----#
    TransitCallRecord = SET(name=u'TransitCallRecord', mode=MODE_TYPE)
    _TransitCallRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _TransitCallRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _TransitCallRecord_mscIncomingTKGP = CHOICE(name=u'mscIncomingTKGP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _TransitCallRecord_mscOutgoingTKGP = CHOICE(name=u'mscOutgoingTKGP', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _TransitCallRecord_callingNumber = OCT_STR(name=u'callingNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _TransitCallRecord_calledNumber = OCT_STR(name=u'calledNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')))
    _TransitCallRecord_isdnBasicService = ENUM(name=u'isdnBasicService', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Basic-Service-Elements', 'BasicService')), opt=True)
    _TransitCallRecord_seizureTimestamp = OCT_STR(name=u'seizureTimestamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TransitCallRecord_answerTimestamp = OCT_STR(name=u'answerTimestamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TransitCallRecord_releaseTimestamp = OCT_STR(name=u'releaseTimestamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TransitCallRecord_callDuration = INT(name=u'callDuration', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _TransitCallRecord_dataVolume = INT(name=u'dataVolume', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _TransitCallRecord_causeForTerm = INT(name=u'causeForTerm', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _TransitCallRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _TransitCallRecord_callReference = OCT_STR(name=u'callReference', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _TransitCallRecord_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TransitCallRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _TransitCallRecord_locationRoutNum = OCT_STR(name=u'locationRoutNum', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumber')), opt=True)
    _TransitCallRecord_lrnSoInd = INT(name=u'lrnSoInd', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberSourceIndicator')), opt=True)
    _TransitCallRecord_lrnQuryStatus = INT(name=u'lrnQuryStatus', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationRoutingNumberQueryStatus')), opt=True)
    _TransitCallRecord_jIPPara = OCT_STR(name=u'jIPPara', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameter')), opt=True)
    _TransitCallRecord_jIPSoInd = INT(name=u'jIPSoInd', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterSourceIndicator')), opt=True)
    _TransitCallRecord_jIPQuryStatus = INT(name=u'jIPQuryStatus', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'JurisdictionInformationParameterQueryStatus')), opt=True)
    TransitCallRecord._cont = ASN1Dict([
        (u'recordType', _TransitCallRecord_recordType),
        (u'recordingEntity', _TransitCallRecord_recordingEntity),
        (u'mscIncomingTKGP', _TransitCallRecord_mscIncomingTKGP),
        (u'mscOutgoingTKGP', _TransitCallRecord_mscOutgoingTKGP),
        (u'callingNumber', _TransitCallRecord_callingNumber),
        (u'calledNumber', _TransitCallRecord_calledNumber),
        (u'isdnBasicService', _TransitCallRecord_isdnBasicService),
        (u'seizureTimestamp', _TransitCallRecord_seizureTimestamp),
        (u'answerTimestamp', _TransitCallRecord_answerTimestamp),
        (u'releaseTimestamp', _TransitCallRecord_releaseTimestamp),
        (u'callDuration', _TransitCallRecord_callDuration),
        (u'dataVolume', _TransitCallRecord_dataVolume),
        (u'causeForTerm', _TransitCallRecord_causeForTerm),
        (u'diagnostics', _TransitCallRecord_diagnostics),
        (u'callReference', _TransitCallRecord_callReference),
        (u'sequenceNumber', _TransitCallRecord_sequenceNumber),
        (u'recordExtensions', _TransitCallRecord_recordExtensions),
        (u'locationRoutNum', _TransitCallRecord_locationRoutNum),
        (u'lrnSoInd', _TransitCallRecord_lrnSoInd),
        (u'lrnQuryStatus', _TransitCallRecord_lrnQuryStatus),
        (u'jIPPara', _TransitCallRecord_jIPPara),
        (u'jIPSoInd', _TransitCallRecord_jIPSoInd),
        (u'jIPQuryStatus', _TransitCallRecord_jIPQuryStatus),
        ])
    TransitCallRecord._ext = None
    
    #-----< MOSMSRecord >-----#
    MOSMSRecord = SET(name=u'MOSMSRecord', mode=MODE_TYPE)
    _MOSMSRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MOSMSRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _MOSMSRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _MOSMSRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _MOSMSRecord_msClassmark = OCT_STR(name=u'msClassmark', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')))
    _MOSMSRecord_serviceCentre = OCT_STR(name=u'serviceCentre', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _MOSMSRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MOSMSRecord_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _MOSMSRecord_messageReference = OCT_STR(name=u'messageReference', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageReference')))
    _MOSMSRecord_originationTime = OCT_STR(name=u'originationTime', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MOSMSRecord_smsResult = CHOICE(name=u'smsResult', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _MOSMSRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MOSMSRecord_destinationNumber = OCT_STR(name=u'destinationNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SmsTpDestinationNumber')), opt=True)
    _MOSMSRecord_cAMELSMSInformation = SET(name=u'cAMELSMSInformation', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELSMSInformation')), opt=True)
    _MOSMSRecord_systemType = ENUM(name=u'systemType', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _MOSMSRecord_locationExtension = BIT_STR(name=u'locationExtension', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationCellExtension')), opt=True)
    MOSMSRecord._cont = ASN1Dict([
        (u'recordType', _MOSMSRecord_recordType),
        (u'servedIMSI', _MOSMSRecord_servedIMSI),
        (u'servedIMEI', _MOSMSRecord_servedIMEI),
        (u'servedMSISDN', _MOSMSRecord_servedMSISDN),
        (u'msClassmark', _MOSMSRecord_msClassmark),
        (u'serviceCentre', _MOSMSRecord_serviceCentre),
        (u'recordingEntity', _MOSMSRecord_recordingEntity),
        (u'location', _MOSMSRecord_location),
        (u'messageReference', _MOSMSRecord_messageReference),
        (u'originationTime', _MOSMSRecord_originationTime),
        (u'smsResult', _MOSMSRecord_smsResult),
        (u'recordExtensions', _MOSMSRecord_recordExtensions),
        (u'destinationNumber', _MOSMSRecord_destinationNumber),
        (u'cAMELSMSInformation', _MOSMSRecord_cAMELSMSInformation),
        (u'systemType', _MOSMSRecord_systemType),
        (u'locationExtension', _MOSMSRecord_locationExtension),
        ])
    MOSMSRecord._ext = None
    
    #-----< MTSMSRecord >-----#
    MTSMSRecord = SET(name=u'MTSMSRecord', mode=MODE_TYPE)
    _MTSMSRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MTSMSRecord_serviceCentre = OCT_STR(name=u'serviceCentre', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _MTSMSRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _MTSMSRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _MTSMSRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _MTSMSRecord_msClassmark = OCT_STR(name=u'msClassmark', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')))
    _MTSMSRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MTSMSRecord_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _MTSMSRecord_deliveryTime = OCT_STR(name=u'deliveryTime', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MTSMSRecord_smsResult = CHOICE(name=u'smsResult', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _MTSMSRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MTSMSRecord_systemType = ENUM(name=u'systemType', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _MTSMSRecord_cAMELSMSInformation = SET(name=u'cAMELSMSInformation', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELSMSInformation')), opt=True)
    _MTSMSRecord_locationExtension = BIT_STR(name=u'locationExtension', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationCellExtension')), opt=True)
    MTSMSRecord._cont = ASN1Dict([
        (u'recordType', _MTSMSRecord_recordType),
        (u'serviceCentre', _MTSMSRecord_serviceCentre),
        (u'servedIMSI', _MTSMSRecord_servedIMSI),
        (u'servedIMEI', _MTSMSRecord_servedIMEI),
        (u'servedMSISDN', _MTSMSRecord_servedMSISDN),
        (u'msClassmark', _MTSMSRecord_msClassmark),
        (u'recordingEntity', _MTSMSRecord_recordingEntity),
        (u'location', _MTSMSRecord_location),
        (u'deliveryTime', _MTSMSRecord_deliveryTime),
        (u'smsResult', _MTSMSRecord_smsResult),
        (u'recordExtensions', _MTSMSRecord_recordExtensions),
        (u'systemType', _MTSMSRecord_systemType),
        (u'cAMELSMSInformation', _MTSMSRecord_cAMELSMSInformation),
        (u'locationExtension', _MTSMSRecord_locationExtension),
        ])
    MTSMSRecord._ext = None
    
    #-----< MOSMSIWRecord >-----#
    MOSMSIWRecord = SET(name=u'MOSMSIWRecord', mode=MODE_TYPE)
    _MOSMSIWRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MOSMSIWRecord_serviceCentre = OCT_STR(name=u'serviceCentre', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _MOSMSIWRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _MOSMSIWRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MOSMSIWRecord_eventTime = OCT_STR(name=u'eventTime', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MOSMSIWRecord_smsResult = CHOICE(name=u'smsResult', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _MOSMSIWRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MOSMSIWRecord._cont = ASN1Dict([
        (u'recordType', _MOSMSIWRecord_recordType),
        (u'serviceCentre', _MOSMSIWRecord_serviceCentre),
        (u'servedIMSI', _MOSMSIWRecord_servedIMSI),
        (u'recordingEntity', _MOSMSIWRecord_recordingEntity),
        (u'eventTime', _MOSMSIWRecord_eventTime),
        (u'smsResult', _MOSMSIWRecord_smsResult),
        (u'recordExtensions', _MOSMSIWRecord_recordExtensions),
        ])
    MOSMSIWRecord._ext = None
    
    #-----< MTSMSGWRecord >-----#
    MTSMSGWRecord = SET(name=u'MTSMSGWRecord', mode=MODE_TYPE)
    _MTSMSGWRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MTSMSGWRecord_serviceCentre = OCT_STR(name=u'serviceCentre', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _MTSMSGWRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _MTSMSGWRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _MTSMSGWRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MTSMSGWRecord_eventTime = OCT_STR(name=u'eventTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MTSMSGWRecord_smsResult = CHOICE(name=u'smsResult', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _MTSMSGWRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MTSMSGWRecord._cont = ASN1Dict([
        (u'recordType', _MTSMSGWRecord_recordType),
        (u'serviceCentre', _MTSMSGWRecord_serviceCentre),
        (u'servedIMSI', _MTSMSGWRecord_servedIMSI),
        (u'servedMSISDN', _MTSMSGWRecord_servedMSISDN),
        (u'recordingEntity', _MTSMSGWRecord_recordingEntity),
        (u'eventTime', _MTSMSGWRecord_eventTime),
        (u'smsResult', _MTSMSGWRecord_smsResult),
        (u'recordExtensions', _MTSMSGWRecord_recordExtensions),
        ])
    MTSMSGWRecord._ext = None
    
    #-----< SSActionRecord >-----#
    SSActionRecord = SET(name=u'SSActionRecord', mode=MODE_TYPE)
    _SSActionRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SSActionRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SSActionRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SSActionRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SSActionRecord_msClassmark = OCT_STR(name=u'msClassmark', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')))
    _SSActionRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _SSActionRecord_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _SSActionRecord_basicServices = SET_OF(name=u'basicServices', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'BasicServices')), opt=True)
    _SSActionRecord_supplService = OCT_STR(name=u'supplService', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _SSActionRecord_ssAction = ENUM(name=u'ssAction', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SSActionType')), opt=True)
    _SSActionRecord_ssActionTime = OCT_STR(name=u'ssActionTime', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SSActionRecord_ssParameters = CHOICE(name=u'ssParameters', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SSParameters')), opt=True)
    _SSActionRecord_ssActionResult = CHOICE(name=u'ssActionResult', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SSActionResult')), opt=True)
    _SSActionRecord_callReference = OCT_STR(name=u'callReference', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _SSActionRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SSActionRecord_systemType = ENUM(name=u'systemType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    SSActionRecord._cont = ASN1Dict([
        (u'recordType', _SSActionRecord_recordType),
        (u'servedIMSI', _SSActionRecord_servedIMSI),
        (u'servedIMEI', _SSActionRecord_servedIMEI),
        (u'servedMSISDN', _SSActionRecord_servedMSISDN),
        (u'msClassmark', _SSActionRecord_msClassmark),
        (u'recordingEntity', _SSActionRecord_recordingEntity),
        (u'location', _SSActionRecord_location),
        (u'basicServices', _SSActionRecord_basicServices),
        (u'supplService', _SSActionRecord_supplService),
        (u'ssAction', _SSActionRecord_ssAction),
        (u'ssActionTime', _SSActionRecord_ssActionTime),
        (u'ssParameters', _SSActionRecord_ssParameters),
        (u'ssActionResult', _SSActionRecord_ssActionResult),
        (u'callReference', _SSActionRecord_callReference),
        (u'recordExtensions', _SSActionRecord_recordExtensions),
        (u'systemType', _SSActionRecord_systemType),
        ])
    SSActionRecord._ext = None
    
    #-----< HLRIntRecord >-----#
    HLRIntRecord = SET(name=u'HLRIntRecord', mode=MODE_TYPE)
    _HLRIntRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _HLRIntRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _HLRIntRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')))
    _HLRIntRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _HLRIntRecord_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _HLRIntRecord_routingNumber = CHOICE(name=u'routingNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RoutingNumber')))
    _HLRIntRecord_interrogationTime = OCT_STR(name=u'interrogationTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _HLRIntRecord_numberOfForwarding = INT(name=u'numberOfForwarding', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'NumberOfForwarding')), opt=True)
    _HLRIntRecord_interrogationResult = CHOICE(name=u'interrogationResult', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'HLRIntResult')), opt=True)
    _HLRIntRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    HLRIntRecord._cont = ASN1Dict([
        (u'recordType', _HLRIntRecord_recordType),
        (u'servedIMSI', _HLRIntRecord_servedIMSI),
        (u'servedMSISDN', _HLRIntRecord_servedMSISDN),
        (u'recordingEntity', _HLRIntRecord_recordingEntity),
        (u'basicService', _HLRIntRecord_basicService),
        (u'routingNumber', _HLRIntRecord_routingNumber),
        (u'interrogationTime', _HLRIntRecord_interrogationTime),
        (u'numberOfForwarding', _HLRIntRecord_numberOfForwarding),
        (u'interrogationResult', _HLRIntRecord_interrogationResult),
        (u'recordExtensions', _HLRIntRecord_recordExtensions),
        ])
    HLRIntRecord._ext = None
    
    #-----< LocUpdateHLRRecord >-----#
    LocUpdateHLRRecord = SET(name=u'LocUpdateHLRRecord', mode=MODE_TYPE)
    _LocUpdateHLRRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _LocUpdateHLRRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _LocUpdateHLRRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _LocUpdateHLRRecord_oldLocation = SEQ(name=u'oldLocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Visited-Location-info')), opt=True)
    _LocUpdateHLRRecord_newLocation = SEQ(name=u'newLocation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Visited-Location-info')))
    _LocUpdateHLRRecord_updateTime = OCT_STR(name=u'updateTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _LocUpdateHLRRecord_updateResult = CHOICE(name=u'updateResult', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocUpdResult')), opt=True)
    _LocUpdateHLRRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    LocUpdateHLRRecord._cont = ASN1Dict([
        (u'recordType', _LocUpdateHLRRecord_recordType),
        (u'servedIMSI', _LocUpdateHLRRecord_servedIMSI),
        (u'recordingEntity', _LocUpdateHLRRecord_recordingEntity),
        (u'oldLocation', _LocUpdateHLRRecord_oldLocation),
        (u'newLocation', _LocUpdateHLRRecord_newLocation),
        (u'updateTime', _LocUpdateHLRRecord_updateTime),
        (u'updateResult', _LocUpdateHLRRecord_updateResult),
        (u'recordExtensions', _LocUpdateHLRRecord_recordExtensions),
        ])
    LocUpdateHLRRecord._ext = None
    
    #-----< LocUpdateVLRRecord >-----#
    LocUpdateVLRRecord = SET(name=u'LocUpdateVLRRecord', mode=MODE_TYPE)
    _LocUpdateVLRRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _LocUpdateVLRRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _LocUpdateVLRRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _LocUpdateVLRRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _LocUpdateVLRRecord_oldLocation = SEQ(name=u'oldLocation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Location-info')), opt=True)
    _LocUpdateVLRRecord_newLocation = SEQ(name=u'newLocation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Location-info')))
    _LocUpdateVLRRecord_msClassmark = OCT_STR(name=u'msClassmark', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')))
    _LocUpdateVLRRecord_updateTime = OCT_STR(name=u'updateTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _LocUpdateVLRRecord_updateResult = CHOICE(name=u'updateResult', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocUpdResult')), opt=True)
    _LocUpdateVLRRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _LocUpdateVLRRecord_locationExtension = BIT_STR(name=u'locationExtension', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationCellExtension')), opt=True)
    LocUpdateVLRRecord._cont = ASN1Dict([
        (u'recordType', _LocUpdateVLRRecord_recordType),
        (u'servedIMSI', _LocUpdateVLRRecord_servedIMSI),
        (u'servedMSISDN', _LocUpdateVLRRecord_servedMSISDN),
        (u'recordingEntity', _LocUpdateVLRRecord_recordingEntity),
        (u'oldLocation', _LocUpdateVLRRecord_oldLocation),
        (u'newLocation', _LocUpdateVLRRecord_newLocation),
        (u'msClassmark', _LocUpdateVLRRecord_msClassmark),
        (u'updateTime', _LocUpdateVLRRecord_updateTime),
        (u'updateResult', _LocUpdateVLRRecord_updateResult),
        (u'recordExtensions', _LocUpdateVLRRecord_recordExtensions),
        (u'locationExtension', _LocUpdateVLRRecord_locationExtension),
        ])
    LocUpdateVLRRecord._ext = None
    
    #-----< CommonEquipRecord >-----#
    CommonEquipRecord = SET(name=u'CommonEquipRecord', mode=MODE_TYPE)
    _CommonEquipRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _CommonEquipRecord_equipmentType = INT(name=u'equipmentType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EquipmentType')))
    _CommonEquipRecord_equipmentId = INT(name=u'equipmentId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EquipmentId')))
    _CommonEquipRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _CommonEquipRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _CommonEquipRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _CommonEquipRecord_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _CommonEquipRecord_changeOfService = SEQ_OF(name=u'changeOfService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CommonEquipRecord_changeOfService__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeOfService')))
    _CommonEquipRecord_changeOfService._cont = __CommonEquipRecord_changeOfService__item_
    _CommonEquipRecord_supplServicesUsed = SEQ_OF(name=u'supplServicesUsed', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CommonEquipRecord_supplServicesUsed__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'SuppServiceUsed')))
    _CommonEquipRecord_supplServicesUsed._cont = __CommonEquipRecord_supplServicesUsed__item_
    _CommonEquipRecord_seizureTime = OCT_STR(name=u'seizureTime', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _CommonEquipRecord_releaseTime = OCT_STR(name=u'releaseTime', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CommonEquipRecord_callDuration = INT(name=u'callDuration', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _CommonEquipRecord_callReference = OCT_STR(name=u'callReference', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _CommonEquipRecord_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CommonEquipRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _CommonEquipRecord_systemType = ENUM(name=u'systemType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _CommonEquipRecord_rateIndication = OCT_STR(name=u'rateIndication', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RateIndication')), opt=True)
    _CommonEquipRecord_fnur = ENUM(name=u'fnur', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Fnur')), opt=True)
    CommonEquipRecord._cont = ASN1Dict([
        (u'recordType', _CommonEquipRecord_recordType),
        (u'equipmentType', _CommonEquipRecord_equipmentType),
        (u'equipmentId', _CommonEquipRecord_equipmentId),
        (u'servedIMSI', _CommonEquipRecord_servedIMSI),
        (u'servedMSISDN', _CommonEquipRecord_servedMSISDN),
        (u'recordingEntity', _CommonEquipRecord_recordingEntity),
        (u'basicService', _CommonEquipRecord_basicService),
        (u'changeOfService', _CommonEquipRecord_changeOfService),
        (u'supplServicesUsed', _CommonEquipRecord_supplServicesUsed),
        (u'seizureTime', _CommonEquipRecord_seizureTime),
        (u'releaseTime', _CommonEquipRecord_releaseTime),
        (u'callDuration', _CommonEquipRecord_callDuration),
        (u'callReference', _CommonEquipRecord_callReference),
        (u'sequenceNumber', _CommonEquipRecord_sequenceNumber),
        (u'recordExtensions', _CommonEquipRecord_recordExtensions),
        (u'systemType', _CommonEquipRecord_systemType),
        (u'rateIndication', _CommonEquipRecord_rateIndication),
        (u'fnur', _CommonEquipRecord_fnur),
        ])
    CommonEquipRecord._ext = None
    
    #-----< ObservedIMEITicket >-----#
    ObservedIMEITicket = SET(name=u'ObservedIMEITicket', mode=MODE_TYPE)
    _ObservedIMEITicket_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')))
    _ObservedIMEITicket_imeiStatus = ENUM(name=u'imeiStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'IMEIStatus')))
    _ObservedIMEITicket_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _ObservedIMEITicket_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _ObservedIMEITicket_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _ObservedIMEITicket_eventTime = OCT_STR(name=u'eventTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ObservedIMEITicket_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')))
    _ObservedIMEITicket_imeiCheckEvent = INT(name=u'imeiCheckEvent', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'IMEICheckEvent')), opt=True)
    _ObservedIMEITicket_callReference = OCT_STR(name=u'callReference', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _ObservedIMEITicket_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    ObservedIMEITicket._cont = ASN1Dict([
        (u'servedIMEI', _ObservedIMEITicket_servedIMEI),
        (u'imeiStatus', _ObservedIMEITicket_imeiStatus),
        (u'servedIMSI', _ObservedIMEITicket_servedIMSI),
        (u'servedMSISDN', _ObservedIMEITicket_servedMSISDN),
        (u'recordingEntity', _ObservedIMEITicket_recordingEntity),
        (u'eventTime', _ObservedIMEITicket_eventTime),
        (u'location', _ObservedIMEITicket_location),
        (u'imeiCheckEvent', _ObservedIMEITicket_imeiCheckEvent),
        (u'callReference', _ObservedIMEITicket_callReference),
        (u'recordExtensions', _ObservedIMEITicket_recordExtensions),
        ])
    ObservedIMEITicket._ext = None
    
    #-----< MTLCSRecord >-----#
    MTLCSRecord = SET(name=u'MTLCSRecord', mode=MODE_TYPE)
    _MTLCSRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MTLCSRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MTLCSRecord_lcsClientType = ENUM(name=u'lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')))
    _MTLCSRecord_lcsClientIdentity = SEQ(name=u'lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')))
    _MTLCSRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MTLCSRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _MTLCSRecord_locationType = SEQ(name=u'locationType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')))
    _MTLCSRecord_lcsQos = OCT_STR(name=u'lcsQos', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSQoSInfo')), opt=True)
    _MTLCSRecord_lcsPriority = OCT_STR(name=u'lcsPriority', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _MTLCSRecord_mlc_Number = OCT_STR(name=u'mlc-Number', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _MTLCSRecord_eventTimeStamp = OCT_STR(name=u'eventTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MTLCSRecord_measureDuration = INT(name=u'measureDuration', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _MTLCSRecord_notificationToMSUser = ENUM(name=u'notificationToMSUser', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _MTLCSRecord_privacyOverride = NULL(name=u'privacyOverride', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MTLCSRecord_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _MTLCSRecord_locationEstimate = OCT_STR(name=u'locationEstimate', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _MTLCSRecord_positioningData = OCT_STR(name=u'positioningData', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PositioningData')), opt=True)
    _MTLCSRecord_lcsCause = OCT_STR(name=u'lcsCause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSCause')), opt=True)
    _MTLCSRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _MTLCSRecord_systemType = ENUM(name=u'systemType', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _MTLCSRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MTLCSRecord_causeForTerm = INT(name=u'causeForTerm', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _MTLCSRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    MTLCSRecord._cont = ASN1Dict([
        (u'recordType', _MTLCSRecord_recordType),
        (u'recordingEntity', _MTLCSRecord_recordingEntity),
        (u'lcsClientType', _MTLCSRecord_lcsClientType),
        (u'lcsClientIdentity', _MTLCSRecord_lcsClientIdentity),
        (u'servedIMSI', _MTLCSRecord_servedIMSI),
        (u'servedMSISDN', _MTLCSRecord_servedMSISDN),
        (u'locationType', _MTLCSRecord_locationType),
        (u'lcsQos', _MTLCSRecord_lcsQos),
        (u'lcsPriority', _MTLCSRecord_lcsPriority),
        (u'mlc-Number', _MTLCSRecord_mlc_Number),
        (u'eventTimeStamp', _MTLCSRecord_eventTimeStamp),
        (u'measureDuration', _MTLCSRecord_measureDuration),
        (u'notificationToMSUser', _MTLCSRecord_notificationToMSUser),
        (u'privacyOverride', _MTLCSRecord_privacyOverride),
        (u'location', _MTLCSRecord_location),
        (u'locationEstimate', _MTLCSRecord_locationEstimate),
        (u'positioningData', _MTLCSRecord_positioningData),
        (u'lcsCause', _MTLCSRecord_lcsCause),
        (u'diagnostics', _MTLCSRecord_diagnostics),
        (u'systemType', _MTLCSRecord_systemType),
        (u'recordExtensions', _MTLCSRecord_recordExtensions),
        (u'causeForTerm', _MTLCSRecord_causeForTerm),
        (u'servedIMEI', _MTLCSRecord_servedIMEI),
        ])
    MTLCSRecord._ext = None
    
    #-----< MOLCSRecord >-----#
    MOLCSRecord = SET(name=u'MOLCSRecord', mode=MODE_TYPE)
    _MOLCSRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MOLCSRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MOLCSRecord_lcsClientType = ENUM(name=u'lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _MOLCSRecord_lcsClientIdentity = SEQ(name=u'lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _MOLCSRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _MOLCSRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _MOLCSRecord_molr_Type = ENUM(name=u'molr-Type', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'MOLR-Type')))
    _MOLCSRecord_lcsQos = OCT_STR(name=u'lcsQos', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSQoSInfo')), opt=True)
    _MOLCSRecord_lcsPriority = OCT_STR(name=u'lcsPriority', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _MOLCSRecord_mlc_Number = OCT_STR(name=u'mlc-Number', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _MOLCSRecord_eventTimeStamp = OCT_STR(name=u'eventTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MOLCSRecord_measureDuration = INT(name=u'measureDuration', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _MOLCSRecord_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _MOLCSRecord_locationEstimate = OCT_STR(name=u'locationEstimate', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _MOLCSRecord_positioningData = OCT_STR(name=u'positioningData', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PositioningData')), opt=True)
    _MOLCSRecord_lcsCause = OCT_STR(name=u'lcsCause', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSCause')), opt=True)
    _MOLCSRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _MOLCSRecord_systemType = ENUM(name=u'systemType', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _MOLCSRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MOLCSRecord_causeForTerm = INT(name=u'causeForTerm', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    MOLCSRecord._cont = ASN1Dict([
        (u'recordType', _MOLCSRecord_recordType),
        (u'recordingEntity', _MOLCSRecord_recordingEntity),
        (u'lcsClientType', _MOLCSRecord_lcsClientType),
        (u'lcsClientIdentity', _MOLCSRecord_lcsClientIdentity),
        (u'servedIMSI', _MOLCSRecord_servedIMSI),
        (u'servedMSISDN', _MOLCSRecord_servedMSISDN),
        (u'molr-Type', _MOLCSRecord_molr_Type),
        (u'lcsQos', _MOLCSRecord_lcsQos),
        (u'lcsPriority', _MOLCSRecord_lcsPriority),
        (u'mlc-Number', _MOLCSRecord_mlc_Number),
        (u'eventTimeStamp', _MOLCSRecord_eventTimeStamp),
        (u'measureDuration', _MOLCSRecord_measureDuration),
        (u'location', _MOLCSRecord_location),
        (u'locationEstimate', _MOLCSRecord_locationEstimate),
        (u'positioningData', _MOLCSRecord_positioningData),
        (u'lcsCause', _MOLCSRecord_lcsCause),
        (u'diagnostics', _MOLCSRecord_diagnostics),
        (u'systemType', _MOLCSRecord_systemType),
        (u'recordExtensions', _MOLCSRecord_recordExtensions),
        (u'causeForTerm', _MOLCSRecord_causeForTerm),
        ])
    MOLCSRecord._ext = None
    
    #-----< NILCSRecord >-----#
    NILCSRecord = SET(name=u'NILCSRecord', mode=MODE_TYPE)
    _NILCSRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _NILCSRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _NILCSRecord_lcsClientType = ENUM(name=u'lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _NILCSRecord_lcsClientIdentity = SEQ(name=u'lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _NILCSRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _NILCSRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _NILCSRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _NILCSRecord_emsDigits = OCT_STR(name=u'emsDigits', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _NILCSRecord_emsKey = OCT_STR(name=u'emsKey', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _NILCSRecord_lcsQos = OCT_STR(name=u'lcsQos', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSQoSInfo')), opt=True)
    _NILCSRecord_lcsPriority = OCT_STR(name=u'lcsPriority', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _NILCSRecord_mlc_Number = OCT_STR(name=u'mlc-Number', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _NILCSRecord_eventTimeStamp = OCT_STR(name=u'eventTimeStamp', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _NILCSRecord_measureDuration = INT(name=u'measureDuration', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _NILCSRecord_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _NILCSRecord_locationEstimate = OCT_STR(name=u'locationEstimate', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _NILCSRecord_positioningData = OCT_STR(name=u'positioningData', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PositioningData')), opt=True)
    _NILCSRecord_lcsCause = OCT_STR(name=u'lcsCause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSCause')), opt=True)
    _NILCSRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _NILCSRecord_systemType = ENUM(name=u'systemType', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SystemType')), opt=True)
    _NILCSRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _NILCSRecord_causeForTerm = INT(name=u'causeForTerm', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    NILCSRecord._cont = ASN1Dict([
        (u'recordType', _NILCSRecord_recordType),
        (u'recordingEntity', _NILCSRecord_recordingEntity),
        (u'lcsClientType', _NILCSRecord_lcsClientType),
        (u'lcsClientIdentity', _NILCSRecord_lcsClientIdentity),
        (u'servedIMSI', _NILCSRecord_servedIMSI),
        (u'servedMSISDN', _NILCSRecord_servedMSISDN),
        (u'servedIMEI', _NILCSRecord_servedIMEI),
        (u'emsDigits', _NILCSRecord_emsDigits),
        (u'emsKey', _NILCSRecord_emsKey),
        (u'lcsQos', _NILCSRecord_lcsQos),
        (u'lcsPriority', _NILCSRecord_lcsPriority),
        (u'mlc-Number', _NILCSRecord_mlc_Number),
        (u'eventTimeStamp', _NILCSRecord_eventTimeStamp),
        (u'measureDuration', _NILCSRecord_measureDuration),
        (u'location', _NILCSRecord_location),
        (u'locationEstimate', _NILCSRecord_locationEstimate),
        (u'positioningData', _NILCSRecord_positioningData),
        (u'lcsCause', _NILCSRecord_lcsCause),
        (u'diagnostics', _NILCSRecord_diagnostics),
        (u'systemType', _NILCSRecord_systemType),
        (u'recordExtensions', _NILCSRecord_recordExtensions),
        (u'causeForTerm', _NILCSRecord_causeForTerm),
        ])
    NILCSRecord._ext = None
    
    #-----< MSCsRVCCRecord >-----#
    MSCsRVCCRecord = SET(name=u'MSCsRVCCRecord', mode=MODE_TYPE)
    _MSCsRVCCRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MSCsRVCCRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MSCsRVCCRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _MSCsRVCCRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _MSCsRVCCRecord_calledNumber = OCT_STR(name=u'calledNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')))
    _MSCsRVCCRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MSCsRVCCRecord_mscOutgoingTKGP = CHOICE(name=u'mscOutgoingTKGP', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _MSCsRVCCRecord_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')))
    _MSCsRVCCRecord_changeOfLocation = SEQ_OF(name=u'changeOfLocation', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MSCsRVCCRecord_changeOfLocation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'LocationChange')))
    _MSCsRVCCRecord_changeOfLocation._cont = __MSCsRVCCRecord_changeOfLocation__item_
    _MSCsRVCCRecord_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')))
    _MSCsRVCCRecord_supplServicesUsed = SEQ_OF(name=u'supplServicesUsed', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MSCsRVCCRecord_supplServicesUsed__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'SuppServiceUsed')))
    _MSCsRVCCRecord_supplServicesUsed._cont = __MSCsRVCCRecord_supplServicesUsed__item_
    _MSCsRVCCRecord_msClassmark = OCT_STR(name=u'msClassmark', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')), opt=True)
    _MSCsRVCCRecord_seizureTime = OCT_STR(name=u'seizureTime', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MSCsRVCCRecord_answerTime = OCT_STR(name=u'answerTime', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MSCsRVCCRecord_releaseTime = OCT_STR(name=u'releaseTime', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MSCsRVCCRecord_callDuration = INT(name=u'callDuration', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _MSCsRVCCRecord_causeForTerm = INT(name=u'causeForTerm', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _MSCsRVCCRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _MSCsRVCCRecord_callReference = OCT_STR(name=u'callReference', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _MSCsRVCCRecord_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MSCsRVCCRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MSCsRVCCRecord_partialRecordType = ENUM(name=u'partialRecordType', mode=MODE_TYPE, tag=(69, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'PartialRecordType')), opt=True)
    _MSCsRVCCRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(75, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _MSCsRVCCRecord_iCSI2ActiveFlag = NULL(name=u'iCSI2ActiveFlag', mode=MODE_TYPE, tag=(76, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MSCsRVCCRecord_relatedICID = OCT_STR(name=u'relatedICID', mode=MODE_TYPE, tag=(77, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _MSCsRVCCRecord_relatedICIDGenerationNode = CHOICE(name=u'relatedICIDGenerationNode', mode=MODE_TYPE, tag=(78, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    MSCsRVCCRecord._cont = ASN1Dict([
        (u'recordType', _MSCsRVCCRecord_recordType),
        (u'servedIMSI', _MSCsRVCCRecord_servedIMSI),
        (u'servedIMEI', _MSCsRVCCRecord_servedIMEI),
        (u'servedMSISDN', _MSCsRVCCRecord_servedMSISDN),
        (u'calledNumber', _MSCsRVCCRecord_calledNumber),
        (u'recordingEntity', _MSCsRVCCRecord_recordingEntity),
        (u'mscOutgoingTKGP', _MSCsRVCCRecord_mscOutgoingTKGP),
        (u'location', _MSCsRVCCRecord_location),
        (u'changeOfLocation', _MSCsRVCCRecord_changeOfLocation),
        (u'basicService', _MSCsRVCCRecord_basicService),
        (u'supplServicesUsed', _MSCsRVCCRecord_supplServicesUsed),
        (u'msClassmark', _MSCsRVCCRecord_msClassmark),
        (u'seizureTime', _MSCsRVCCRecord_seizureTime),
        (u'answerTime', _MSCsRVCCRecord_answerTime),
        (u'releaseTime', _MSCsRVCCRecord_releaseTime),
        (u'callDuration', _MSCsRVCCRecord_callDuration),
        (u'causeForTerm', _MSCsRVCCRecord_causeForTerm),
        (u'diagnostics', _MSCsRVCCRecord_diagnostics),
        (u'callReference', _MSCsRVCCRecord_callReference),
        (u'sequenceNumber', _MSCsRVCCRecord_sequenceNumber),
        (u'recordExtensions', _MSCsRVCCRecord_recordExtensions),
        (u'partialRecordType', _MSCsRVCCRecord_partialRecordType),
        (u'iMS-Charging-Identifier', _MSCsRVCCRecord_iMS_Charging_Identifier),
        (u'iCSI2ActiveFlag', _MSCsRVCCRecord_iCSI2ActiveFlag),
        (u'relatedICID', _MSCsRVCCRecord_relatedICID),
        (u'relatedICIDGenerationNode', _MSCsRVCCRecord_relatedICIDGenerationNode),
        ])
    MSCsRVCCRecord._ext = None
    
    #-----< MTRFRecord >-----#
    MTRFRecord = SET(name=u'MTRFRecord', mode=MODE_TYPE)
    _MTRFRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MTRFRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _MTRFRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _MTRFRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CalledNumber')), opt=True)
    _MTRFRecord_callingNumber = OCT_STR(name=u'callingNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _MTRFRecord_roamingNumber = OCT_STR(name=u'roamingNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RoamingNumber')), opt=True)
    _MTRFRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _MTRFRecord_mscIncomingTKGP = CHOICE(name=u'mscIncomingTKGP', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _MTRFRecord_mscOutgoingTKGP = CHOICE(name=u'mscOutgoingTKGP', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _MTRFRecord_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _MTRFRecord_seizureTime = OCT_STR(name=u'seizureTime', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MTRFRecord_answerTime = OCT_STR(name=u'answerTime', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MTRFRecord_releaseTime = OCT_STR(name=u'releaseTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MTRFRecord_callDuration = INT(name=u'callDuration', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _MTRFRecord_causeForTerm = INT(name=u'causeForTerm', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')))
    _MTRFRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _MTRFRecord_callReference = OCT_STR(name=u'callReference', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    _MTRFRecord_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MTRFRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MTRFRecord_partialRecordType = ENUM(name=u'partialRecordType', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'PartialRecordType')), opt=True)
    MTRFRecord._cont = ASN1Dict([
        (u'recordType', _MTRFRecord_recordType),
        (u'servedIMSI', _MTRFRecord_servedIMSI),
        (u'servedIMEI', _MTRFRecord_servedIMEI),
        (u'servedMSISDN', _MTRFRecord_servedMSISDN),
        (u'callingNumber', _MTRFRecord_callingNumber),
        (u'roamingNumber', _MTRFRecord_roamingNumber),
        (u'recordingEntity', _MTRFRecord_recordingEntity),
        (u'mscIncomingTKGP', _MTRFRecord_mscIncomingTKGP),
        (u'mscOutgoingTKGP', _MTRFRecord_mscOutgoingTKGP),
        (u'basicService', _MTRFRecord_basicService),
        (u'seizureTime', _MTRFRecord_seizureTime),
        (u'answerTime', _MTRFRecord_answerTime),
        (u'releaseTime', _MTRFRecord_releaseTime),
        (u'callDuration', _MTRFRecord_callDuration),
        (u'causeForTerm', _MTRFRecord_causeForTerm),
        (u'diagnostics', _MTRFRecord_diagnostics),
        (u'callReference', _MTRFRecord_callReference),
        (u'sequenceNumber', _MTRFRecord_sequenceNumber),
        (u'recordExtensions', _MTRFRecord_recordExtensions),
        (u'partialRecordType', _MTRFRecord_partialRecordType),
        ])
    MTRFRecord._ext = None
    
    #-----< ICSregisterRecord >-----#
    ICSregisterRecord = SET(name=u'ICSregisterRecord', mode=MODE_TYPE)
    _ICSregisterRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _ICSregisterRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _ICSregisterRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')))
    _ICSregisterRecord_privateUserID = STR_GRAPH(name=u'privateUserID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSregisterRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _ICSregisterRecord_newLocation = SEQ(name=u'newLocation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Location-info')))
    _ICSregisterRecord_locationExtension = BIT_STR(name=u'locationExtension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocationCellExtension')), opt=True)
    _ICSregisterRecord_updateTime = OCT_STR(name=u'updateTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ICSregisterRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _ICSregisterRecord_interOperatorIdentifiers = SEQ_OF(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifierList')), opt=True)
    _ICSregisterRecord_transit_IOI_Lists = SEQ_OF(name=u'transit-IOI-Lists', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _ICSregisterRecord_updateResult = CHOICE(name=u'updateResult', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'LocUpdResult')), opt=True)
    _ICSregisterRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    ICSregisterRecord._cont = ASN1Dict([
        (u'recordType', _ICSregisterRecord_recordType),
        (u'servedIMSI', _ICSregisterRecord_servedIMSI),
        (u'servedMSISDN', _ICSregisterRecord_servedMSISDN),
        (u'privateUserID', _ICSregisterRecord_privateUserID),
        (u'recordingEntity', _ICSregisterRecord_recordingEntity),
        (u'newLocation', _ICSregisterRecord_newLocation),
        (u'locationExtension', _ICSregisterRecord_locationExtension),
        (u'updateTime', _ICSregisterRecord_updateTime),
        (u'iMS-Charging-Identifier', _ICSregisterRecord_iMS_Charging_Identifier),
        (u'interOperatorIdentifiers', _ICSregisterRecord_interOperatorIdentifiers),
        (u'transit-IOI-Lists', _ICSregisterRecord_transit_IOI_Lists),
        (u'updateResult', _ICSregisterRecord_updateResult),
        (u'recordExtensions', _ICSregisterRecord_recordExtensions),
        ])
    ICSregisterRecord._ext = None
    
    #-----< LocationRoutingNumber >-----#
    LocationRoutingNumber = OCT_STR(name=u'LocationRoutingNumber', mode=MODE_TYPE)
    LocationRoutingNumber._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< LocationRoutingNumberSourceIndicator >-----#
    LocationRoutingNumberSourceIndicator = INT(name=u'LocationRoutingNumberSourceIndicator', mode=MODE_TYPE)
    LocationRoutingNumberSourceIndicator._cont = ASN1Dict([(u'lRN-NP-Database', 1), (u'switchingSystemData', 2), (u'incomingsignaling', 3), (u'unknown', 9)])
    
    #-----< LocationRoutingNumberQueryStatus >-----#
    LocationRoutingNumberQueryStatus = INT(name=u'LocationRoutingNumberQueryStatus', mode=MODE_TYPE)
    LocationRoutingNumberQueryStatus._cont = ASN1Dict([(u'successfulQuery', 1), (u'noQueryResponseMsg', 2), (u'queryProtocolErr', 4), (u'queryResponseDataErr', 5), (u'queryRejected', 6), (u'queryNotPerformed', 9), (u'queryUnsuccessful', 99)])
    
    #-----< JurisdictionInformationParameter >-----#
    JurisdictionInformationParameter = OCT_STR(name=u'JurisdictionInformationParameter', mode=MODE_TYPE)
    JurisdictionInformationParameter._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< JurisdictionInformationParameterSourceIndicator >-----#
    JurisdictionInformationParameterSourceIndicator = INT(name=u'JurisdictionInformationParameterSourceIndicator', mode=MODE_TYPE)
    JurisdictionInformationParameterSourceIndicator._cont = ASN1Dict([(u'lRN-NP-Database', 1), (u'switchingSystemData', 2), (u'incomingsignaling', 3), (u'unknown', 9)])
    
    #-----< JurisdictionInformationParameterQueryStatus >-----#
    JurisdictionInformationParameterQueryStatus = INT(name=u'JurisdictionInformationParameterQueryStatus', mode=MODE_TYPE)
    JurisdictionInformationParameterQueryStatus._cont = ASN1Dict([(u'successfulQuery', 1), (u'noQueryResponseMsg', 2), (u'queryProtocolErr', 4), (u'queryResponseDataErr', 5), (u'queryRejected', 6), (u'queryNotPerformed', 9), (u'queryUnsuccessful', 99)])
    
    #-----< AdditionalChgInfo >-----#
    AdditionalChgInfo = SEQ(name=u'AdditionalChgInfo', mode=MODE_TYPE)
    _AdditionalChgInfo_chargeIndicator = INT(name=u'chargeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargeIndicator')), opt=True)
    _AdditionalChgInfo_chargeParameters = OCT_STR(name=u'chargeParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    AdditionalChgInfo._cont = ASN1Dict([
        (u'chargeIndicator', _AdditionalChgInfo_chargeIndicator),
        (u'chargeParameters', _AdditionalChgInfo_chargeParameters),
        ])
    AdditionalChgInfo._ext = None
    
    #-----< AiurRequested >-----#
    AiurRequested = ENUM(name=u'AiurRequested', mode=MODE_TYPE)
    AiurRequested._cont = ASN1Dict([(u'aiur09600BitsPerSecond', 1), (u'aiur14400BitsPerSecond', 2), (u'aiur19200BitsPerSecond', 3), (u'aiur28800BitsPerSecond', 5), (u'aiur38400BitsPerSecond', 6), (u'aiur43200BitsPerSecond', 7), (u'aiur57600BitsPerSecond', 8), (u'aiur38400BitsPerSecond1', 9), (u'aiur38400BitsPerSecond2', 10), (u'aiur38400BitsPerSecond3', 11), (u'aiur38400BitsPerSecond4', 12)])
    AiurRequested._ext = None
    
    #-----< AOCParameters >-----#
    AOCParameters = SEQ(name=u'AOCParameters', mode=MODE_TYPE)
    _AOCParameters_e1 = INT(name=u'e1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EParameter')), opt=True)
    _AOCParameters_e2 = INT(name=u'e2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EParameter')), opt=True)
    _AOCParameters_e3 = INT(name=u'e3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EParameter')), opt=True)
    _AOCParameters_e4 = INT(name=u'e4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EParameter')), opt=True)
    _AOCParameters_e5 = INT(name=u'e5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EParameter')), opt=True)
    _AOCParameters_e6 = INT(name=u'e6', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EParameter')), opt=True)
    _AOCParameters_e7 = INT(name=u'e7', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'EParameter')), opt=True)
    AOCParameters._cont = ASN1Dict([
        (u'e1', _AOCParameters_e1),
        (u'e2', _AOCParameters_e2),
        (u'e3', _AOCParameters_e3),
        (u'e4', _AOCParameters_e4),
        (u'e5', _AOCParameters_e5),
        (u'e6', _AOCParameters_e6),
        (u'e7', _AOCParameters_e7),
        ])
    AOCParameters._ext = None
    
    #-----< AOCParmChange >-----#
    AOCParmChange = SEQ(name=u'AOCParmChange', mode=MODE_TYPE)
    _AOCParmChange_changeTime = OCT_STR(name=u'changeTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _AOCParmChange_newParameters = SEQ(name=u'newParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AOCParameters')))
    AOCParmChange._cont = ASN1Dict([
        (u'changeTime', _AOCParmChange_changeTime),
        (u'newParameters', _AOCParmChange_newParameters),
        ])
    AOCParmChange._ext = None
    
    #-----< BasicServices >-----#
    BasicServices = SET_OF(name=u'BasicServices', mode=MODE_TYPE)
    _BasicServices__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')))
    BasicServices._cont = _BasicServices__item_
    
    #-----< CallingPartyCategory >-----#
    CallingPartyCategory = OCT_STR(name=u'CallingPartyCategory', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'Category')))
    
    #-----< CallType >-----#
    CallType = INT(name=u'CallType', mode=MODE_TYPE)
    CallType._cont = ASN1Dict([(u'mobileOriginated', 0), (u'mobileTerminated', 1)])
    
    #-----< CallTypes >-----#
    CallTypes = SET_OF(name=u'CallTypes', mode=MODE_TYPE)
    _CallTypes__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'CallType')))
    CallTypes._cont = _CallTypes__item_
    
    #-----< CAMELDestinationNumber >-----#
    CAMELDestinationNumber = SEQ_OF(name=u'CAMELDestinationNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CAP-datatypes', 'DestinationRoutingAddress')))
    
    #-----< CAMELInformation >-----#
    CAMELInformation = SET(name=u'CAMELInformation', mode=MODE_TYPE)
    _CAMELInformation_cAMELDestinationNumber = SEQ_OF(name=u'cAMELDestinationNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELDestinationNumber')), opt=True)
    _CAMELInformation_connectedNumber = OCT_STR(name=u'connectedNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ConnectedNumber')), opt=True)
    _CAMELInformation_roamingNumber = OCT_STR(name=u'roamingNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RoamingNumber')), opt=True)
    _CAMELInformation_mscOutgoingTKGP = CHOICE(name=u'mscOutgoingTKGP', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrunkGroup')), opt=True)
    _CAMELInformation_seizureTime = OCT_STR(name=u'seizureTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CAMELInformation_answerTime = OCT_STR(name=u'answerTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CAMELInformation_releaseTime = OCT_STR(name=u'releaseTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CAMELInformation_callDuration = INT(name=u'callDuration', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _CAMELInformation_dataVolume = INT(name=u'dataVolume', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _CAMELInformation_cAMELInitCFIndicator = ENUM(name=u'cAMELInitCFIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELInitCFIndicator')), opt=True)
    _CAMELInformation_causeForTerm = INT(name=u'causeForTerm', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForTerm')), opt=True)
    _CAMELInformation_cAMELModification = SET(name=u'cAMELModification', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChangedParameters')), opt=True)
    _CAMELInformation_freeFormatData = OCT_STR(name=u'freeFormatData', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FreeFormatData')), opt=True)
    _CAMELInformation_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _CAMELInformation_freeFormatDataAppend = BOOL(name=u'freeFormatDataAppend', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAMELInformation_freeFormatData_2 = OCT_STR(name=u'freeFormatData-2', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FreeFormatData')), opt=True)
    _CAMELInformation_freeFormatDataAppend_2 = BOOL(name=u'freeFormatDataAppend-2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CAMELInformation._cont = ASN1Dict([
        (u'cAMELDestinationNumber', _CAMELInformation_cAMELDestinationNumber),
        (u'connectedNumber', _CAMELInformation_connectedNumber),
        (u'roamingNumber', _CAMELInformation_roamingNumber),
        (u'mscOutgoingTKGP', _CAMELInformation_mscOutgoingTKGP),
        (u'seizureTime', _CAMELInformation_seizureTime),
        (u'answerTime', _CAMELInformation_answerTime),
        (u'releaseTime', _CAMELInformation_releaseTime),
        (u'callDuration', _CAMELInformation_callDuration),
        (u'dataVolume', _CAMELInformation_dataVolume),
        (u'cAMELInitCFIndicator', _CAMELInformation_cAMELInitCFIndicator),
        (u'causeForTerm', _CAMELInformation_causeForTerm),
        (u'cAMELModification', _CAMELInformation_cAMELModification),
        (u'freeFormatData', _CAMELInformation_freeFormatData),
        (u'diagnostics', _CAMELInformation_diagnostics),
        (u'freeFormatDataAppend', _CAMELInformation_freeFormatDataAppend),
        (u'freeFormatData-2', _CAMELInformation_freeFormatData_2),
        (u'freeFormatDataAppend-2', _CAMELInformation_freeFormatDataAppend_2),
        ])
    CAMELInformation._ext = None
    
    #-----< CAMELInitCFIndicator >-----#
    CAMELInitCFIndicator = ENUM(name=u'CAMELInitCFIndicator', mode=MODE_TYPE)
    CAMELInitCFIndicator._cont = ASN1Dict([(u'noCAMELCallForwarding', 0), (u'cAMELCallForwarding', 1)])
    CAMELInitCFIndicator._ext = None
    
    #-----< CAMELModificationParameters >-----#
    CAMELModificationParameters = SET(name=u'CAMELModificationParameters', mode=MODE_TYPE)
    _CAMELModificationParameters_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _CAMELModificationParameters_callingPartyCategory = OCT_STR(name=u'callingPartyCategory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CallingPartyCategory')), opt=True)
    _CAMELModificationParameters_originalCalledPartyNumber = OCT_STR(name=u'originalCalledPartyNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'OriginalCalledNumber')), opt=True)
    _CAMELModificationParameters_genericNumbers = SET_OF(name=u'genericNumbers', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'GenericNumbers')), opt=True)
    _CAMELModificationParameters_redirectingPartyNumber = OCT_STR(name=u'redirectingPartyNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RedirectingNumber')), opt=True)
    _CAMELModificationParameters_redirectionCounter = INT(name=u'redirectionCounter', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'NumberOfForwarding')), opt=True)
    CAMELModificationParameters._cont = ASN1Dict([
        (u'callingPartyNumber', _CAMELModificationParameters_callingPartyNumber),
        (u'callingPartyCategory', _CAMELModificationParameters_callingPartyCategory),
        (u'originalCalledPartyNumber', _CAMELModificationParameters_originalCalledPartyNumber),
        (u'genericNumbers', _CAMELModificationParameters_genericNumbers),
        (u'redirectingPartyNumber', _CAMELModificationParameters_redirectingPartyNumber),
        (u'redirectionCounter', _CAMELModificationParameters_redirectionCounter),
        ])
    CAMELModificationParameters._ext = None
    
    #-----< CAMELSMSInformation >-----#
    CAMELSMSInformation = SET(name=u'CAMELSMSInformation', mode=MODE_TYPE)
    _CAMELSMSInformation_gsm_SCFAddress = OCT_STR(name=u'gsm-SCFAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Gsm-SCFAddress')), opt=True)
    _CAMELSMSInformation_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _CAMELSMSInformation_defaultSMSHandling = ENUM(name=u'defaultSMSHandling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultSMS-Handling')), opt=True)
    _CAMELSMSInformation_freeFormatData = OCT_STR(name=u'freeFormatData', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FreeFormatData')), opt=True)
    _CAMELSMSInformation_callingPartyNumber = OCT_STR(name=u'callingPartyNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _CAMELSMSInformation_destinationSubscriberNumber = OCT_STR(name=u'destinationSubscriberNumber', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SmsTpDestinationNumber')), opt=True)
    _CAMELSMSInformation_cAMELSMSCAddress = OCT_STR(name=u'cAMELSMSCAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _CAMELSMSInformation_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    CAMELSMSInformation._cont = ASN1Dict([
        (u'gsm-SCFAddress', _CAMELSMSInformation_gsm_SCFAddress),
        (u'serviceKey', _CAMELSMSInformation_serviceKey),
        (u'defaultSMSHandling', _CAMELSMSInformation_defaultSMSHandling),
        (u'freeFormatData', _CAMELSMSInformation_freeFormatData),
        (u'callingPartyNumber', _CAMELSMSInformation_callingPartyNumber),
        (u'destinationSubscriberNumber', _CAMELSMSInformation_destinationSubscriberNumber),
        (u'cAMELSMSCAddress', _CAMELSMSInformation_cAMELSMSCAddress),
        (u'smsReferenceNumber', _CAMELSMSInformation_smsReferenceNumber),
        ])
    CAMELSMSInformation._ext = None
    
    #-----< Category >-----#
    Category = OCT_STR(name=u'Category', mode=MODE_TYPE)
    Category._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChangedParameters >-----#
    ChangedParameters = SET(name=u'ChangedParameters', mode=MODE_TYPE)
    _ChangedParameters_changeFlags = BIT_STR(name=u'changeFlags', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChangeFlags')))
    _ChangedParameters_changeList = SET(name=u'changeList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'CAMELModificationParameters')), opt=True)
    ChangedParameters._cont = ASN1Dict([
        (u'changeFlags', _ChangedParameters_changeFlags),
        (u'changeList', _ChangedParameters_changeList),
        ])
    ChangedParameters._ext = None
    
    #-----< ChangeFlags >-----#
    ChangeFlags = BIT_STR(name=u'ChangeFlags', mode=MODE_TYPE)
    ChangeFlags._cont = ASN1Dict([(u'callingPartyNumberModified', 0), (u'callingPartyCategoryModified', 1), (u'originalCalledPartyNumberModified', 2), (u'genericNumbersModified', 3), (u'redirectingPartyNumberModified', 4), (u'redirectionCounterModified', 5)])
    
    #-----< ChangeOfClassmark >-----#
    ChangeOfClassmark = SEQ(name=u'ChangeOfClassmark', mode=MODE_TYPE)
    _ChangeOfClassmark_classmark = OCT_STR(name=u'classmark', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Classmark')))
    _ChangeOfClassmark_changeTime = OCT_STR(name=u'changeTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    ChangeOfClassmark._cont = ASN1Dict([
        (u'classmark', _ChangeOfClassmark_classmark),
        (u'changeTime', _ChangeOfClassmark_changeTime),
        ])
    ChangeOfClassmark._ext = None
    
    #-----< ChangeOfRadioChannel >-----#
    ChangeOfRadioChannel = SEQ(name=u'ChangeOfRadioChannel', mode=MODE_TYPE)
    _ChangeOfRadioChannel_radioChannel = ENUM(name=u'radioChannel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TrafficChannel')))
    _ChangeOfRadioChannel_changeTime = OCT_STR(name=u'changeTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ChangeOfRadioChannel_speechVersionUsed = OCT_STR(name=u'speechVersionUsed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SpeechVersionIdentifier')), opt=True)
    ChangeOfRadioChannel._cont = ASN1Dict([
        (u'radioChannel', _ChangeOfRadioChannel_radioChannel),
        (u'changeTime', _ChangeOfRadioChannel_changeTime),
        (u'speechVersionUsed', _ChangeOfRadioChannel_speechVersionUsed),
        ])
    ChangeOfRadioChannel._ext = None
    
    #-----< ChangeOfService >-----#
    ChangeOfService = SEQ(name=u'ChangeOfService', mode=MODE_TYPE)
    _ChangeOfService_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')))
    _ChangeOfService_transparencyInd = ENUM(name=u'transparencyInd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TransparencyInd')), opt=True)
    _ChangeOfService_changeTime = OCT_STR(name=u'changeTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ChangeOfService_rateIndication = OCT_STR(name=u'rateIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RateIndication')), opt=True)
    _ChangeOfService_fnur = ENUM(name=u'fnur', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Fnur')), opt=True)
    ChangeOfService._cont = ASN1Dict([
        (u'basicService', _ChangeOfService_basicService),
        (u'transparencyInd', _ChangeOfService_transparencyInd),
        (u'changeTime', _ChangeOfService_changeTime),
        (u'rateIndication', _ChangeOfService_rateIndication),
        (u'fnur', _ChangeOfService_fnur),
        ])
    ChangeOfService._ext = None
    
    #-----< ChannelCoding >-----#
    ChannelCoding = ENUM(name=u'ChannelCoding', mode=MODE_TYPE)
    ChannelCoding._cont = ASN1Dict([(u'tchF4800', 1), (u'tchF9600', 2), (u'tchF14400', 3)])
    ChannelCoding._ext = None
    
    #-----< Classmark >-----#
    Classmark = OCT_STR(name=u'Classmark', mode=MODE_TYPE)
    
    #-----< ConnectedNumber >-----#
    ConnectedNumber = OCT_STR(name=u'ConnectedNumber', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'BCDDirectoryNumber')))
    
    #-----< DataVolume >-----#
    DataVolume = INT(name=u'DataVolume', mode=MODE_TYPE)
    
    #-----< Day >-----#
    Day = INT(name=u'Day', mode=MODE_TYPE)
    Day._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=31)], ev=None, er=[])
    
    #-----< DayClass >-----#
    DayClass = CHOICE(name=u'DayClass', mode=MODE_TYPE, typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    
    #-----< DayClasses >-----#
    DayClasses = SET_OF(name=u'DayClasses', mode=MODE_TYPE)
    _DayClasses__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'DayClass')))
    DayClasses._cont = _DayClasses__item_
    
    #-----< DayDefinition >-----#
    DayDefinition = SEQ(name=u'DayDefinition', mode=MODE_TYPE)
    _DayDefinition_day = ENUM(name=u'day', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DayOfTheWeek')))
    _DayDefinition_dayClass = CHOICE(name=u'dayClass', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    DayDefinition._cont = ASN1Dict([
        (u'day', _DayDefinition_day),
        (u'dayClass', _DayDefinition_dayClass),
        ])
    DayDefinition._ext = None
    
    #-----< DayDefinitions >-----#
    DayDefinitions = SET_OF(name=u'DayDefinitions', mode=MODE_TYPE)
    _DayDefinitions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'DayDefinition')))
    DayDefinitions._cont = _DayDefinitions__item_
    
    #-----< DateDefinition >-----#
    DateDefinition = SEQ(name=u'DateDefinition', mode=MODE_TYPE)
    _DateDefinition_month = INT(name=u'month', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Month')))
    _DateDefinition_day = INT(name=u'day', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'Day')))
    _DateDefinition_dayClass = CHOICE(name=u'dayClass', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CMIP-1', 'ObjectInstance')))
    DateDefinition._cont = ASN1Dict([
        (u'month', _DateDefinition_month),
        (u'day', _DateDefinition_day),
        (u'dayClass', _DateDefinition_dayClass),
        ])
    DateDefinition._ext = None
    
    #-----< DateDefinitions >-----#
    DateDefinitions = SET_OF(name=u'DateDefinitions', mode=MODE_TYPE)
    _DateDefinitions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'DateDefinition')))
    DateDefinitions._cont = _DateDefinitions__item_
    
    #-----< DayOfTheWeek >-----#
    DayOfTheWeek = ENUM(name=u'DayOfTheWeek', mode=MODE_TYPE)
    DayOfTheWeek._cont = ASN1Dict([(u'allDays', 0), (u'sunday', 1), (u'monday', 2), (u'tuesday', 3), (u'wednesday', 4), (u'thursday', 5), (u'friday', 6), (u'saturday', 7)])
    DayOfTheWeek._ext = None
    
    #-----< Destinations >-----#
    Destinations = SET_OF(name=u'Destinations', mode=MODE_TYPE)
    _Destinations__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ACSE-1', 'AE-title')))
    Destinations._cont = _Destinations__item_
    
    #-----< EmergencyCallIndEnable >-----#
    EmergencyCallIndEnable = BOOL(name=u'EmergencyCallIndEnable', mode=MODE_TYPE)
    
    #-----< EmergencyCallIndication >-----#
    EmergencyCallIndication = SEQ(name=u'EmergencyCallIndication', mode=MODE_TYPE)
    _EmergencyCallIndication_cellId = OCT_STR(name=u'cellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')))
    _EmergencyCallIndication_callerId = CHOICE(name=u'callerId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'IMSIorIMEI')))
    EmergencyCallIndication._cont = ASN1Dict([
        (u'cellId', _EmergencyCallIndication_cellId),
        (u'callerId', _EmergencyCallIndication_callerId),
        ])
    EmergencyCallIndication._ext = None
    
    #-----< EParameter >-----#
    EParameter = INT(name=u'EParameter', mode=MODE_TYPE)
    
    #-----< EquipmentId >-----#
    EquipmentId = INT(name=u'EquipmentId', mode=MODE_TYPE)
    
    #-----< EquipmentType >-----#
    EquipmentType = INT(name=u'EquipmentType', mode=MODE_TYPE)
    EquipmentType._cont = ASN1Dict([(u'conferenceBridge', 0)])
    
    #-----< FileType >-----#
    FileType = INT(name=u'FileType', mode=MODE_TYPE)
    FileType._cont = ASN1Dict([(u'callRecords', 1), (u'traceRecords', 9), (u'observedIMEITicket', 14)])
    
    #-----< Fnur >-----#
    Fnur = ENUM(name=u'Fnur', mode=MODE_TYPE)
    Fnur._cont = ASN1Dict([(u'fnurNotApplicable', 0), (u'fnur9600-BitsPerSecond', 1), (u'fnur14400BitsPerSecond', 2), (u'fnur19200BitsPerSecond', 3), (u'fnur28800BitsPerSecond', 4), (u'fnur38400BitsPerSecond', 5), (u'fnur48000BitsPerSecond', 6), (u'fnur56000BitsPerSecond', 7), (u'fnur64000BitsPerSecond', 8), (u'fnur33600BitsPerSecond', 9), (u'fnur32000BitsPerSecond', 10), (u'fnur31200BitsPerSecond', 11)])
    Fnur._ext = None
    
    #-----< ForwardToNumber >-----#
    ForwardToNumber = OCT_STR(name=u'ForwardToNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    
    #-----< FreeFormatData >-----#
    FreeFormatData = OCT_STR(name=u'FreeFormatData', mode=MODE_TYPE)
    FreeFormatData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=None, er=[])
    
    #-----< GenericNumber >-----#
    GenericNumber = OCT_STR(name=u'GenericNumber', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'BCDDirectoryNumber')))
    
    #-----< GenericNumbers >-----#
    GenericNumbers = SET_OF(name=u'GenericNumbers', mode=MODE_TYPE)
    _GenericNumbers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'GenericNumber')))
    GenericNumbers._cont = _GenericNumbers__item_
    
    #-----< Gsm-SCFAddress >-----#
    Gsm_SCFAddress = OCT_STR(name=u'Gsm-SCFAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    
    #-----< GuaranteedBitRate >-----#
    GuaranteedBitRate = ENUM(name=u'GuaranteedBitRate', mode=MODE_TYPE)
    GuaranteedBitRate._cont = ASN1Dict([(u'gbr14400BitsPerSecond', 1), (u'gbr28800BitsPerSecond', 2), (u'gbr32000BitsPerSecond', 3), (u'gbr33600BitsPerSecond', 4), (u'gbr56000BitsPerSecond', 5), (u'gbr57600BitsPerSecond', 6), (u'gbr64000BitsPerSecond', 7)])
    GuaranteedBitRate._ext = None
    
    #-----< HLRIntResult >-----#
    HLRIntResult = CHOICE(name=u'HLRIntResult', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')))
    
    #-----< HSCSDParmsChange >-----#
    HSCSDParmsChange = SEQ(name=u'HSCSDParmsChange', mode=MODE_TYPE)
    _HSCSDParmsChange_changeTime = OCT_STR(name=u'changeTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _HSCSDParmsChange_hSCSDChanAllocated = INT(name=u'hSCSDChanAllocated', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NumOfHSCSDChanAllocated')))
    _HSCSDParmsChange_initiatingParty = ENUM(name=u'initiatingParty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'InitiatingParty')), opt=True)
    _HSCSDParmsChange_aiurRequested = ENUM(name=u'aiurRequested', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'AiurRequested')), opt=True)
    _HSCSDParmsChange_chanCodingUsed = ENUM(name=u'chanCodingUsed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ChannelCoding')))
    _HSCSDParmsChange_hSCSDChanRequested = INT(name=u'hSCSDChanRequested', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NumOfHSCSDChanRequested')), opt=True)
    HSCSDParmsChange._cont = ASN1Dict([
        (u'changeTime', _HSCSDParmsChange_changeTime),
        (u'hSCSDChanAllocated', _HSCSDParmsChange_hSCSDChanAllocated),
        (u'initiatingParty', _HSCSDParmsChange_initiatingParty),
        (u'aiurRequested', _HSCSDParmsChange_aiurRequested),
        (u'chanCodingUsed', _HSCSDParmsChange_chanCodingUsed),
        (u'hSCSDChanRequested', _HSCSDParmsChange_hSCSDChanRequested),
        ])
    HSCSDParmsChange._ext = None
    
    #-----< IMEICheckEvent >-----#
    IMEICheckEvent = INT(name=u'IMEICheckEvent', mode=MODE_TYPE)
    IMEICheckEvent._cont = ASN1Dict([(u'mobileOriginatedCall', 0), (u'mobileTerminatedCall', 1), (u'smsMobileOriginating', 2), (u'smsMobileTerminating', 3), (u'ssAction', 4), (u'locationUpdate', 5)])
    
    #-----< IMEIStatus >-----#
    IMEIStatus = ENUM(name=u'IMEIStatus', mode=MODE_TYPE)
    IMEIStatus._cont = ASN1Dict([(u'greyListedMobileEquipment', 0), (u'blackListedMobileEquipment', 1), (u'nonWhiteListedMobileEquipment', 2)])
    IMEIStatus._ext = None
    
    #-----< IMSIorIMEI >-----#
    IMSIorIMEI = CHOICE(name=u'IMSIorIMEI', mode=MODE_TYPE)
    _IMSIorIMEI_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _IMSIorIMEI_imei = OCT_STR(name=u'imei', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')))
    IMSIorIMEI._cont = ASN1Dict([
        (u'imsi', _IMSIorIMEI_imsi),
        (u'imei', _IMSIorIMEI_imei),
        ])
    IMSIorIMEI._ext = None
    
    #-----< InitiatingParty >-----#
    InitiatingParty = ENUM(name=u'InitiatingParty', mode=MODE_TYPE)
    InitiatingParty._cont = ASN1Dict([(u'network', 0), (u'subscriber', 1)])
    InitiatingParty._ext = None
    
    #-----< LocationCellExtension >-----#
    LocationCellExtension = BIT_STR(name=u'LocationCellExtension', mode=MODE_TYPE)
    LocationCellExtension._const_sz = ASN1Set(rv=[12], rr=[], ev=None, er=[])
    
    #-----< LocationChange >-----#
    LocationChange = SEQ(name=u'LocationChange', mode=MODE_TYPE)
    _LocationChange_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')))
    _LocationChange_changeTime = OCT_STR(name=u'changeTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    LocationChange._cont = ASN1Dict([
        (u'location', _LocationChange_location),
        (u'changeTime', _LocationChange_changeTime),
        ])
    LocationChange._ext = None
    
    #-----< Location-info >-----#
    Location_info = SEQ(name=u'Location-info', mode=MODE_TYPE)
    _Location_info_mscNumber = OCT_STR(name=u'mscNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MscNo')), opt=True)
    _Location_info_location_area = OCT_STR(name=u'location-area', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaCode')))
    _Location_info_cell_identification = OCT_STR(name=u'cell-identification', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')), opt=True)
    _Location_info_mCC_MNC = OCT_STR(name=u'mCC-MNC', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MCC-MNC')), opt=True)
    Location_info._cont = ASN1Dict([
        (u'mscNumber', _Location_info_mscNumber),
        (u'location-area', _Location_info_location_area),
        (u'cell-identification', _Location_info_cell_identification),
        (u'mCC-MNC', _Location_info_mCC_MNC),
        ])
    Location_info._ext = None
    
    #-----< LocUpdResult >-----#
    LocUpdResult = CHOICE(name=u'LocUpdResult', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')))
    
    #-----< MaximumBitRate >-----#
    MaximumBitRate = ENUM(name=u'MaximumBitRate', mode=MODE_TYPE)
    MaximumBitRate._cont = ASN1Dict([(u'mbr14400BitsPerSecond', 1), (u'mbr28800BitsPerSecond', 2), (u'mbr32000BitsPerSecond', 3), (u'mbr33600BitsPerSecond', 4), (u'mbr56000BitsPerSecond', 5), (u'mbr57600BitsPerSecond', 6)])
    MaximumBitRate._ext = None
    
    #-----< Month >-----#
    Month = INT(name=u'Month', mode=MODE_TYPE)
    Month._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< MSPowerClasses >-----#
    MSPowerClasses = SET_OF(name=u'MSPowerClasses', mode=MODE_TYPE)
    _MSPowerClasses__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'RFPowerCapability')))
    MSPowerClasses._cont = _MSPowerClasses__item_
    
    #-----< NetworkCallReference >-----#
    NetworkCallReference = OCT_STR(name=u'NetworkCallReference', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    
    #-----< NetworkSpecificCode >-----#
    NetworkSpecificCode = INT(name=u'NetworkSpecificCode', mode=MODE_TYPE)
    
    #-----< NetworkSpecificServices >-----#
    NetworkSpecificServices = SET_OF(name=u'NetworkSpecificServices', mode=MODE_TYPE)
    _NetworkSpecificServices__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'NetworkSpecificCode')))
    NetworkSpecificServices._cont = _NetworkSpecificServices__item_
    
    #-----< NumOfHSCSDChanRequested >-----#
    NumOfHSCSDChanRequested = INT(name=u'NumOfHSCSDChanRequested', mode=MODE_TYPE)
    
    #-----< NumOfHSCSDChanAllocated >-----#
    NumOfHSCSDChanAllocated = INT(name=u'NumOfHSCSDChanAllocated', mode=MODE_TYPE)
    
    #-----< ObservedIMEITicketEnable >-----#
    ObservedIMEITicketEnable = BOOL(name=u'ObservedIMEITicketEnable', mode=MODE_TYPE)
    
    #-----< OriginalCalledNumber >-----#
    OriginalCalledNumber = OCT_STR(name=u'OriginalCalledNumber', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'BCDDirectoryNumber')))
    
    #-----< OriginDestCombinations >-----#
    OriginDestCombinations = SET_OF(name=u'OriginDestCombinations', mode=MODE_TYPE)
    _OriginDestCombinations__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'OriginDestCombination')))
    OriginDestCombinations._cont = _OriginDestCombinations__item_
    
    #-----< OriginDestCombination >-----#
    OriginDestCombination = SEQ(name=u'OriginDestCombination', mode=MODE_TYPE)
    _OriginDestCombination_origin = INT(name=u'origin', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OriginDestCombination_destination = INT(name=u'destination', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    OriginDestCombination._cont = ASN1Dict([
        (u'origin', _OriginDestCombination_origin),
        (u'destination', _OriginDestCombination_destination),
        ])
    OriginDestCombination._ext = None
    
    #-----< PartialRecordTimer >-----#
    PartialRecordTimer = INT(name=u'PartialRecordTimer', mode=MODE_TYPE)
    
    #-----< PartialRecordType >-----#
    PartialRecordType = ENUM(name=u'PartialRecordType', mode=MODE_TYPE)
    PartialRecordType._cont = ASN1Dict([(u'timeLimit', 0), (u'serviceChange', 1), (u'locationChange', 2), (u'classmarkChange', 3), (u'aocParmChange', 4), (u'radioChannelChange', 5), (u'hSCSDParmChange', 6), (u'changeOfCAMELDestination', 7)])
    PartialRecordType._ext = None
    
    #-----< PartialRecordTypes >-----#
    PartialRecordTypes = SET_OF(name=u'PartialRecordTypes', mode=MODE_TYPE)
    _PartialRecordTypes__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'PartialRecordType')))
    PartialRecordTypes._cont = _PartialRecordTypes__item_
    
    #-----< RadioChannelsRequested >-----#
    RadioChannelsRequested = SET_OF(name=u'RadioChannelsRequested', mode=MODE_TYPE)
    _RadioChannelsRequested__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'RadioChanRequested')))
    RadioChannelsRequested._cont = _RadioChannelsRequested__item_
    
    #-----< RadioChanRequested >-----#
    RadioChanRequested = ENUM(name=u'RadioChanRequested', mode=MODE_TYPE)
    RadioChanRequested._cont = ASN1Dict([(u'halfRateChannel', 0), (u'fullRateChannel', 1), (u'dualHalfRatePreferred', 2), (u'dualFullRatePreferred', 3)])
    RadioChanRequested._ext = None
    
    #-----< RateIndication >-----#
    RateIndication = OCT_STR(name=u'RateIndication', mode=MODE_TYPE)
    RateIndication._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ReasonForServiceChange >-----#
    ReasonForServiceChange = ENUM(name=u'ReasonForServiceChange', mode=MODE_TYPE)
    ReasonForServiceChange._cont = ASN1Dict([(u'msubInitiated', 0), (u'mscInitiated', 1), (u'callSetupFallBack', 2), (u'callSetupChangeOrder', 3)])
    ReasonForServiceChange._ext = None
    
    #-----< RecordClassDestination >-----#
    RecordClassDestination = CHOICE(name=u'RecordClassDestination', mode=MODE_TYPE)
    _RecordClassDestination_osApplication = CHOICE(name=u'osApplication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ACSE-1', 'AE-title')))
    _RecordClassDestination_fileType = INT(name=u'fileType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'FileType')))
    RecordClassDestination._cont = ASN1Dict([
        (u'osApplication', _RecordClassDestination_osApplication),
        (u'fileType', _RecordClassDestination_fileType),
        ])
    RecordClassDestination._ext = None
    
    #-----< RecordClassDestinations >-----#
    RecordClassDestinations = SET_OF(name=u'RecordClassDestinations', mode=MODE_TYPE)
    _RecordClassDestinations__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'RecordClassDestination')))
    RecordClassDestinations._cont = _RecordClassDestinations__item_
    
    #-----< RecordingMethod >-----#
    RecordingMethod = ENUM(name=u'RecordingMethod', mode=MODE_TYPE)
    RecordingMethod._cont = ASN1Dict([(u'inCallRecord', 0), (u'inSSRecord', 1)])
    RecordingMethod._ext = None
    
    #-----< RedirectingNumber >-----#
    RedirectingNumber = OCT_STR(name=u'RedirectingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'BCDDirectoryNumber')))
    
    #-----< RFPowerCapability >-----#
    RFPowerCapability = INT(name=u'RFPowerCapability', mode=MODE_TYPE)
    
    #-----< RoamingNumber >-----#
    RoamingNumber = OCT_STR(name=u'RoamingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    
    #-----< RoutingNumber >-----#
    RoutingNumber = CHOICE(name=u'RoutingNumber', mode=MODE_TYPE)
    _RoutingNumber_roaming = OCT_STR(name=u'roaming', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'RoamingNumber')))
    _RoutingNumber_forwarded = OCT_STR(name=u'forwarded', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ForwardToNumber')))
    RoutingNumber._cont = ASN1Dict([
        (u'roaming', _RoutingNumber_roaming),
        (u'forwarded', _RoutingNumber_forwarded),
        ])
    RoutingNumber._ext = None
    
    #-----< Service >-----#
    Service = CHOICE(name=u'Service', mode=MODE_TYPE)
    _Service_teleservice = OCT_STR(name=u'teleservice', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    _Service_bearerService = OCT_STR(name=u'bearerService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    _Service_supplementaryService = OCT_STR(name=u'supplementaryService', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Service_networkSpecificService = INT(name=u'networkSpecificService', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'NetworkSpecificCode')))
    Service._cont = ASN1Dict([
        (u'teleservice', _Service_teleservice),
        (u'bearerService', _Service_bearerService),
        (u'supplementaryService', _Service_supplementaryService),
        (u'networkSpecificService', _Service_networkSpecificService),
        ])
    Service._ext = None
    
    #-----< ServiceDistanceDependencies >-----#
    ServiceDistanceDependencies = SET_OF(name=u'ServiceDistanceDependencies', mode=MODE_TYPE)
    _ServiceDistanceDependencies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'ServiceDistanceDependency')))
    ServiceDistanceDependencies._cont = _ServiceDistanceDependencies__item_
    
    #-----< ServiceDistanceDependency >-----#
    ServiceDistanceDependency = SEQ(name=u'ServiceDistanceDependency', mode=MODE_TYPE)
    _ServiceDistanceDependency_aocService = INT(name=u'aocService', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ServiceDistanceDependency_chargingZone = INT(name=u'chargingZone', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ServiceDistanceDependency._cont = ASN1Dict([
        (u'aocService', _ServiceDistanceDependency_aocService),
        (u'chargingZone', _ServiceDistanceDependency_chargingZone),
        ])
    ServiceDistanceDependency._ext = None
    
    #-----< SimpleIntegerName >-----#
    SimpleIntegerName = INT(name=u'SimpleIntegerName', mode=MODE_TYPE)
    
    #-----< SimpleStringName >-----#
    SimpleStringName = STR_GRAPH(name=u'SimpleStringName', mode=MODE_TYPE)
    
    #-----< SpeechVersionIdentifier >-----#
    SpeechVersionIdentifier = OCT_STR(name=u'SpeechVersionIdentifier', mode=MODE_TYPE)
    SpeechVersionIdentifier._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SSActionResult >-----#
    SSActionResult = CHOICE(name=u'SSActionResult', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')))
    
    #-----< SSActionType >-----#
    SSActionType = ENUM(name=u'SSActionType', mode=MODE_TYPE)
    SSActionType._cont = ASN1Dict([(u'registration', 0), (u'erasure', 1), (u'activation', 2), (u'deactivation', 3), (u'interrogation', 4), (u'invocation', 5), (u'passwordRegistration', 6)])
    SSActionType._ext = None
    
    #-----< SSParameters >-----#
    SSParameters = CHOICE(name=u'SSParameters', mode=MODE_TYPE)
    _SSParameters_forwardedToNumber = OCT_STR(name=u'forwardedToNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'ForwardToNumber')))
    _SSParameters_unstructuredData = OCT_STR(name=u'unstructuredData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SSParameters._cont = ASN1Dict([
        (u'forwardedToNumber', _SSParameters_forwardedToNumber),
        (u'unstructuredData', _SSParameters_unstructuredData),
        ])
    SSParameters._ext = None
    
    #-----< SupplServices >-----#
    SupplServices = SET_OF(name=u'SupplServices', mode=MODE_TYPE)
    _SupplServices__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    SupplServices._cont = _SupplServices__item_
    
    #-----< SuppServiceUsed >-----#
    SuppServiceUsed = SEQ(name=u'SuppServiceUsed', mode=MODE_TYPE)
    _SuppServiceUsed_ssCode = OCT_STR(name=u'ssCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _SuppServiceUsed_ssTime = OCT_STR(name=u'ssTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    SuppServiceUsed._cont = ASN1Dict([
        (u'ssCode', _SuppServiceUsed_ssCode),
        (u'ssTime', _SuppServiceUsed_ssTime),
        ])
    SuppServiceUsed._ext = None
    
    #-----< SwitchoverTime >-----#
    SwitchoverTime = SEQ(name=u'SwitchoverTime', mode=MODE_TYPE)
    _SwitchoverTime_hour = INT(name=u'hour', mode=MODE_TYPE)
    _SwitchoverTime_hour._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=23)], ev=None, er=[])
    _SwitchoverTime_minute = INT(name=u'minute', mode=MODE_TYPE)
    _SwitchoverTime_minute._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=None, er=[])
    _SwitchoverTime_second = INT(name=u'second', mode=MODE_TYPE)
    _SwitchoverTime_second._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=None, er=[])
    SwitchoverTime._cont = ASN1Dict([
        (u'hour', _SwitchoverTime_hour),
        (u'minute', _SwitchoverTime_minute),
        (u'second', _SwitchoverTime_second),
        ])
    SwitchoverTime._ext = None
    
    #-----< TariffId >-----#
    TariffId = INT(name=u'TariffId', mode=MODE_TYPE)
    
    #-----< TariffPeriod >-----#
    TariffPeriod = SEQ(name=u'TariffPeriod', mode=MODE_TYPE)
    _TariffPeriod_switchoverTime = SEQ(name=u'switchoverTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'SwitchoverTime')))
    _TariffPeriod_tariffId = INT(name=u'tariffId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TariffPeriod._cont = ASN1Dict([
        (u'switchoverTime', _TariffPeriod_switchoverTime),
        (u'tariffId', _TariffPeriod_tariffId),
        ])
    TariffPeriod._ext = None
    
    #-----< TariffPeriods >-----#
    TariffPeriods = SET_OF(name=u'TariffPeriods', mode=MODE_TYPE)
    _TariffPeriods__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'TariffPeriod')))
    TariffPeriods._cont = _TariffPeriods__item_
    
    #-----< TariffSystemStatus >-----#
    TariffSystemStatus = ENUM(name=u'TariffSystemStatus', mode=MODE_TYPE)
    TariffSystemStatus._cont = ASN1Dict([(u'available', 0), (u'checked', 1), (u'standby', 2), (u'active', 3)])
    TariffSystemStatus._ext = None
    
    #-----< TrafficChannel >-----#
    TrafficChannel = ENUM(name=u'TrafficChannel', mode=MODE_TYPE)
    TrafficChannel._cont = ASN1Dict([(u'fullRate', 0), (u'halfRate', 1)])
    TrafficChannel._ext = None
    
    #-----< TranslatedNumber >-----#
    TranslatedNumber = OCT_STR(name=u'TranslatedNumber', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'BCDDirectoryNumber')))
    
    #-----< TransparencyInd >-----#
    TransparencyInd = ENUM(name=u'TransparencyInd', mode=MODE_TYPE)
    TransparencyInd._cont = ASN1Dict([(u'transparent', 0), (u'nonTransparent', 1)])
    TransparencyInd._ext = None
    
    #-----< TrunkGroup >-----#
    TrunkGroup = CHOICE(name=u'TrunkGroup', mode=MODE_TYPE)
    _TrunkGroup_tkgpNumber = INT(name=u'tkgpNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TrunkGroup_tkgpName = STR_GRAPH(name=u'tkgpName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TrunkGroup._cont = ASN1Dict([
        (u'tkgpNumber', _TrunkGroup_tkgpNumber),
        (u'tkgpName', _TrunkGroup_tkgpName),
        ])
    TrunkGroup._ext = None
    
    #-----< TSChangeover >-----#
    TSChangeover = SEQ(name=u'TSChangeover', mode=MODE_TYPE)
    _TSChangeover_newActiveTS = INT(name=u'newActiveTS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TSChangeover_newStandbyTS = INT(name=u'newStandbyTS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TSChangeover_changeoverTime = TIME_GEN(name=u'changeoverTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TSChangeover_authkey = OCT_STR(name=u'authkey', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TSChangeover_checksum = OCT_STR(name=u'checksum', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TSChangeover_versionNumber = OCT_STR(name=u'versionNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    TSChangeover._cont = ASN1Dict([
        (u'newActiveTS', _TSChangeover_newActiveTS),
        (u'newStandbyTS', _TSChangeover_newStandbyTS),
        (u'changeoverTime', _TSChangeover_changeoverTime),
        (u'authkey', _TSChangeover_authkey),
        (u'checksum', _TSChangeover_checksum),
        (u'versionNumber', _TSChangeover_versionNumber),
        ])
    TSChangeover._ext = None
    
    #-----< TSCheckError >-----#
    TSCheckError = SEQ(name=u'TSCheckError', mode=MODE_TYPE)
    _TSCheckError_errorId = CHOICE(name=u'errorId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TSCheckErrorId')))
    _TSCheckError_fail = ANY(name=u'fail', mode=MODE_TYPE, opt=True, defby=u'errorId')
    TSCheckError._cont = ASN1Dict([
        (u'errorId', _TSCheckError_errorId),
        (u'fail', _TSCheckError_fail),
        ])
    TSCheckError._ext = None
    
    #-----< TSCheckErrorId >-----#
    TSCheckErrorId = CHOICE(name=u'TSCheckErrorId', mode=MODE_TYPE)
    _TSCheckErrorId_globalForm = OID(name=u'globalForm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TSCheckErrorId_localForm = INT(name=u'localForm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TSCheckErrorId._cont = ASN1Dict([
        (u'globalForm', _TSCheckErrorId_globalForm),
        (u'localForm', _TSCheckErrorId_localForm),
        ])
    TSCheckErrorId._ext = None
    
    #-----< TSCheckResult >-----#
    TSCheckResult = CHOICE(name=u'TSCheckResult', mode=MODE_TYPE)
    _TSCheckResult_success = NULL(name=u'success', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TSCheckResult_fail = SET_OF(name=u'fail', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TSCheckResult_fail__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CSChargingDataTypes', 'TSCheckError')))
    _TSCheckResult_fail._cont = __TSCheckResult_fail__item_
    TSCheckResult._cont = ASN1Dict([
        (u'success', _TSCheckResult_success),
        (u'fail', _TSCheckResult_fail),
        ])
    TSCheckResult._ext = None
    
    #-----< TSCopyTariffSystem >-----#
    TSCopyTariffSystem = SEQ(name=u'TSCopyTariffSystem', mode=MODE_TYPE)
    _TSCopyTariffSystem_oldTS = INT(name=u'oldTS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TSCopyTariffSystem_newTS = INT(name=u'newTS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TSCopyTariffSystem._cont = ASN1Dict([
        (u'oldTS', _TSCopyTariffSystem_oldTS),
        (u'newTS', _TSCopyTariffSystem_newTS),
        ])
    TSCopyTariffSystem._ext = None
    
    #-----< TSNextChange >-----#
    TSNextChange = CHOICE(name=u'TSNextChange', mode=MODE_TYPE)
    _TSNextChange_noChangeover = NULL(name=u'noChangeover', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TSNextChange_tsChangeover = SEQ(name=u'tsChangeover', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'TSChangeover')))
    TSNextChange._cont = ASN1Dict([
        (u'noChangeover', _TSNextChange_noChangeover),
        (u'tsChangeover', _TSNextChange_tsChangeover),
        ])
    TSNextChange._ext = None
    
    #-----< TypeOfSubscribers >-----#
    TypeOfSubscribers = ENUM(name=u'TypeOfSubscribers', mode=MODE_TYPE)
    TypeOfSubscribers._cont = ASN1Dict([(u'home', 0), (u'visiting', 1), (u'all', 2)])
    TypeOfSubscribers._ext = None
    
    #-----< TypeOfTransaction >-----#
    TypeOfTransaction = ENUM(name=u'TypeOfTransaction', mode=MODE_TYPE)
    TypeOfTransaction._cont = ASN1Dict([(u'successful', 0), (u'unsuccessful', 1), (u'all', 2)])
    TypeOfTransaction._ext = None
    
    #-----< Visited-Location-info >-----#
    Visited_Location_info = SEQ(name=u'Visited-Location-info', mode=MODE_TYPE)
    _Visited_Location_info_mscNumber = OCT_STR(name=u'mscNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MscNo')))
    _Visited_Location_info_vlrNumber = OCT_STR(name=u'vlrNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'VlrNo')))
    Visited_Location_info._cont = ASN1Dict([
        (u'mscNumber', _Visited_Location_info_mscNumber),
        (u'vlrNumber', _Visited_Location_info_vlrNumber),
        ])
    Visited_Location_info._ext = None
    
    #-----< VlrNo >-----#
    VlrNo = OCT_STR(name=u'VlrNo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    
    _all_ = [
        _CSRecord_moCallRecord,
        _CSRecord_mtCallRecord,
        _CSRecord_roamingRecord,
        _CSRecord_incGatewayRecord,
        _CSRecord_outGatewayRecord,
        _CSRecord_transitRecord,
        _CSRecord_moSMSRecord,
        _CSRecord_mtSMSRecord,
        _CSRecord_moSMSIWRecord,
        _CSRecord_mtSMSGWRecord,
        _CSRecord_ssActionRecord,
        _CSRecord_hlrIntRecord,
        _CSRecord_locUpdateHLRRecord,
        _CSRecord_locUpdateVLRRecord,
        _CSRecord_commonEquipRecord,
        _CSRecord_recTypeExtensions,
        _CSRecord_termCAMELRecord,
        _CSRecord_mtLCSRecord,
        _CSRecord_moLCSRecord,
        _CSRecord_niLCSRecord,
        _CSRecord_mSCsRVCCRecord,
        _CSRecord_mMTRFRecord,
        _CSRecord_iCSRegisterRecord,
        CSRecord,
        _MOCallRecord_recordType,
        _MOCallRecord_servedIMSI,
        _MOCallRecord_servedIMEI,
        _MOCallRecord_servedMSISDN,
        _MOCallRecord_callingNumber,
        _MOCallRecord_calledNumber,
        _MOCallRecord_translatedNumber,
        _MOCallRecord_connectedNumber,
        _MOCallRecord_roamingNumber,
        _MOCallRecord_recordingEntity,
        _MOCallRecord_mscIncomingTKGP,
        _MOCallRecord_mscOutgoingTKGP,
        _MOCallRecord_location,
        __MOCallRecord_changeOfLocation__item_,
        _MOCallRecord_changeOfLocation,
        _MOCallRecord_basicService,
        _MOCallRecord_transparencyIndicator,
        __MOCallRecord_changeOfService__item_,
        _MOCallRecord_changeOfService,
        __MOCallRecord_supplServicesUsed__item_,
        _MOCallRecord_supplServicesUsed,
        _MOCallRecord_aocParameters,
        __MOCallRecord_changeOfAOCParms__item_,
        _MOCallRecord_changeOfAOCParms,
        _MOCallRecord_msClassmark,
        _MOCallRecord_changeOfClassmark,
        _MOCallRecord_seizureTime,
        _MOCallRecord_answerTime,
        _MOCallRecord_releaseTime,
        _MOCallRecord_callDuration,
        _MOCallRecord_dataVolume,
        _MOCallRecord_radioChanRequested,
        _MOCallRecord_radioChanUsed,
        _MOCallRecord_changeOfRadioChan,
        _MOCallRecord_causeForTerm,
        _MOCallRecord_diagnostics,
        _MOCallRecord_callReference,
        _MOCallRecord_sequenceNumber,
        _MOCallRecord_additionalChgInfo,
        _MOCallRecord_recordExtensions,
        _MOCallRecord_gsm_SCFAddress,
        _MOCallRecord_serviceKey,
        _MOCallRecord_networkCallReference,
        _MOCallRecord_mSCAddress,
        _MOCallRecord_cAMELInitCFIndicator,
        _MOCallRecord_defaultCallHandling,
        _MOCallRecord_hSCSDChanRequested,
        _MOCallRecord_hSCSDChanAllocated,
        __MOCallRecord_changeOfHSCSDParms__item_,
        _MOCallRecord_changeOfHSCSDParms,
        _MOCallRecord_fnur,
        _MOCallRecord_aiurRequested,
        __MOCallRecord_chanCodingsAcceptable__item_,
        _MOCallRecord_chanCodingsAcceptable,
        _MOCallRecord_chanCodingUsed,
        _MOCallRecord_speechVersionSupported,
        _MOCallRecord_speechVersionUsed,
        _MOCallRecord_numberOfDPEncountered,
        _MOCallRecord_levelOfCAMELService,
        _MOCallRecord_freeFormatData,
        __MOCallRecord_cAMELCallLegInformation__item_,
        _MOCallRecord_cAMELCallLegInformation,
        _MOCallRecord_freeFormatDataAppend,
        _MOCallRecord_defaultCallHandling_2,
        _MOCallRecord_gsm_SCFAddress_2,
        _MOCallRecord_serviceKey_2,
        _MOCallRecord_freeFormatData_2,
        _MOCallRecord_freeFormatDataAppend_2,
        _MOCallRecord_systemType,
        _MOCallRecord_rateIndication,
        _MOCallRecord_locationRoutNum,
        _MOCallRecord_lrnSoInd,
        _MOCallRecord_lrnQuryStatus,
        _MOCallRecord_jIPPara,
        _MOCallRecord_jIPSoInd,
        _MOCallRecord_jIPQuryStatus,
        _MOCallRecord_partialRecordType,
        _MOCallRecord_guaranteedBitRate,
        _MOCallRecord_maximumBitRate,
        _MOCallRecord_redial,
        _MOCallRecord_reasonForServiceChange,
        _MOCallRecord_serviceChangeInitiator,
        _MOCallRecord_iCSI2ActiveFlag,
        _MOCallRecord_iMS_Charging_Identifier,
        _MOCallRecord_privateUserID,
        MOCallRecord,
        _MTCallRecord_recordType,
        _MTCallRecord_servedIMSI,
        _MTCallRecord_servedIMEI,
        _MTCallRecord_servedMSISDN,
        _MTCallRecord_callingNumber,
        _MTCallRecord_connectedNumber,
        _MTCallRecord_recordingEntity,
        _MTCallRecord_mscIncomingTKGP,
        _MTCallRecord_mscOutgoingTKGP,
        _MTCallRecord_location,
        __MTCallRecord_changeOfLocation__item_,
        _MTCallRecord_changeOfLocation,
        _MTCallRecord_basicService,
        _MTCallRecord_transparencyIndicator,
        __MTCallRecord_changeOfService__item_,
        _MTCallRecord_changeOfService,
        __MTCallRecord_supplServicesUsed__item_,
        _MTCallRecord_supplServicesUsed,
        _MTCallRecord_aocParameters,
        __MTCallRecord_changeOfAOCParms__item_,
        _MTCallRecord_changeOfAOCParms,
        _MTCallRecord_msClassmark,
        _MTCallRecord_changeOfClassmark,
        _MTCallRecord_seizureTime,
        _MTCallRecord_answerTime,
        _MTCallRecord_releaseTime,
        _MTCallRecord_callDuration,
        _MTCallRecord_dataVolume,
        _MTCallRecord_radioChanRequested,
        _MTCallRecord_radioChanUsed,
        _MTCallRecord_changeOfRadioChan,
        _MTCallRecord_causeForTerm,
        _MTCallRecord_diagnostics,
        _MTCallRecord_callReference,
        _MTCallRecord_sequenceNumber,
        _MTCallRecord_additionalChgInfo,
        _MTCallRecord_recordExtensions,
        _MTCallRecord_networkCallReference,
        _MTCallRecord_mSCAddress,
        _MTCallRecord_hSCSDChanRequested,
        _MTCallRecord_hSCSDChanAllocated,
        __MTCallRecord_changeOfHSCSDParms__item_,
        _MTCallRecord_changeOfHSCSDParms,
        _MTCallRecord_fnur,
        _MTCallRecord_aiurRequested,
        __MTCallRecord_chanCodingsAcceptable__item_,
        _MTCallRecord_chanCodingsAcceptable,
        _MTCallRecord_chanCodingUsed,
        _MTCallRecord_speechVersionSupported,
        _MTCallRecord_speechVersionUsed,
        _MTCallRecord_gsm_SCFAddress,
        _MTCallRecord_serviceKey,
        _MTCallRecord_systemType,
        _MTCallRecord_rateIndication,
        _MTCallRecord_locationRoutNum,
        _MTCallRecord_lrnSoInd,
        _MTCallRecord_lrnQuryStatus,
        _MTCallRecord_jIPPara,
        _MTCallRecord_jIPSoInd,
        _MTCallRecord_jIPQuryStatus,
        _MTCallRecord_partialRecordType,
        _MTCallRecord_guaranteedBitRate,
        _MTCallRecord_maximumBitRate,
        _MTCallRecord_reasonForServiceChange,
        _MTCallRecord_serviceChangeInitiator,
        _MTCallRecord_iCSI2ActiveFlag,
        _MTCallRecord_iMS_Charging_Identifier,
        _MTCallRecord_privateUserID,
        MTCallRecord,
        _RoamingRecord_recordType,
        _RoamingRecord_servedIMSI,
        _RoamingRecord_servedMSISDN,
        _RoamingRecord_callingNumber,
        _RoamingRecord_roamingNumber,
        _RoamingRecord_recordingEntity,
        _RoamingRecord_mscIncomingTKGP,
        _RoamingRecord_mscOutgoingTKGP,
        _RoamingRecord_basicService,
        _RoamingRecord_transparencyIndicator,
        __RoamingRecord_changeOfService__item_,
        _RoamingRecord_changeOfService,
        __RoamingRecord_supplServicesUsed__item_,
        _RoamingRecord_supplServicesUsed,
        _RoamingRecord_seizureTime,
        _RoamingRecord_answerTime,
        _RoamingRecord_releaseTime,
        _RoamingRecord_callDuration,
        _RoamingRecord_dataVolume,
        _RoamingRecord_causeForTerm,
        _RoamingRecord_diagnostics,
        _RoamingRecord_callReference,
        _RoamingRecord_sequenceNumber,
        _RoamingRecord_recordExtensions,
        _RoamingRecord_networkCallReference,
        _RoamingRecord_mSCAddress,
        _RoamingRecord_locationRoutNum,
        _RoamingRecord_lrnSoInd,
        _RoamingRecord_lrnQuryStatus,
        _RoamingRecord_jIPPara,
        _RoamingRecord_jIPSoInd,
        _RoamingRecord_jIPQuryStatus,
        _RoamingRecord_partialRecordType,
        RoamingRecord,
        _TermCAMELRecord_recordtype,
        _TermCAMELRecord_servedIMSI,
        _TermCAMELRecord_servedMSISDN,
        _TermCAMELRecord_recordingEntity,
        _TermCAMELRecord_interrogationTime,
        _TermCAMELRecord_destinationRoutingAddress,
        _TermCAMELRecord_gsm_SCFAddress,
        _TermCAMELRecord_serviceKey,
        _TermCAMELRecord_networkCallReference,
        _TermCAMELRecord_mSCAddress,
        _TermCAMELRecord_defaultCallHandling,
        _TermCAMELRecord_recordExtensions,
        _TermCAMELRecord_calledNumber,
        _TermCAMELRecord_callingNumber,
        _TermCAMELRecord_mscIncomingTKGP,
        _TermCAMELRecord_mscOutgoingTKGP,
        _TermCAMELRecord_seizureTime,
        _TermCAMELRecord_answerTime,
        _TermCAMELRecord_releaseTime,
        _TermCAMELRecord_callDuration,
        _TermCAMELRecord_dataVolume,
        _TermCAMELRecord_causeForTerm,
        _TermCAMELRecord_diagnostics,
        _TermCAMELRecord_callReference,
        _TermCAMELRecord_sequenceNumber,
        _TermCAMELRecord_numberOfDPEncountered,
        _TermCAMELRecord_levelOfCAMELService,
        _TermCAMELRecord_freeFormatData,
        __TermCAMELRecord_cAMELCallLegInformation__item_,
        _TermCAMELRecord_cAMELCallLegInformation,
        _TermCAMELRecord_freeFormatDataAppend,
        _TermCAMELRecord_defaultCallHandling_2,
        _TermCAMELRecord_gsm_SCFAddress_2,
        _TermCAMELRecord_serviceKey_2,
        _TermCAMELRecord_freeFormatData_2,
        _TermCAMELRecord_freeFormatDataAppend_2,
        _TermCAMELRecord_mscServerIndication,
        _TermCAMELRecord_locationRoutNum,
        _TermCAMELRecord_lrnSoInd,
        _TermCAMELRecord_lrnQuryStatus,
        _TermCAMELRecord_jIPPara,
        _TermCAMELRecord_jIPSoInd,
        _TermCAMELRecord_jIPQuryStatus,
        _TermCAMELRecord_partialRecordType,
        TermCAMELRecord,
        _IncGatewayRecord_recordType,
        _IncGatewayRecord_callingNumber,
        _IncGatewayRecord_calledNumber,
        _IncGatewayRecord_recordingEntity,
        _IncGatewayRecord_mscIncomingTKGP,
        _IncGatewayRecord_mscOutgoingTKGP,
        _IncGatewayRecord_seizureTime,
        _IncGatewayRecord_answerTime,
        _IncGatewayRecord_releaseTime,
        _IncGatewayRecord_callDuration,
        _IncGatewayRecord_dataVolume,
        _IncGatewayRecord_causeForTerm,
        _IncGatewayRecord_diagnostics,
        _IncGatewayRecord_callReference,
        _IncGatewayRecord_sequenceNumber,
        _IncGatewayRecord_recordExtensions,
        _IncGatewayRecord_locationRoutNum,
        _IncGatewayRecord_lrnSoInd,
        _IncGatewayRecord_lrnQuryStatus,
        _IncGatewayRecord_jIPPara,
        _IncGatewayRecord_jIPSoInd,
        _IncGatewayRecord_jIPQuryStatus,
        _IncGatewayRecord_reasonForServiceChange,
        _IncGatewayRecord_serviceChangeInitiator,
        IncGatewayRecord,
        _OutGatewayRecord_recordType,
        _OutGatewayRecord_callingNumber,
        _OutGatewayRecord_calledNumber,
        _OutGatewayRecord_recordingEntity,
        _OutGatewayRecord_mscIncomingTKGP,
        _OutGatewayRecord_mscOutgoingTKGP,
        _OutGatewayRecord_seizureTime,
        _OutGatewayRecord_answerTime,
        _OutGatewayRecord_releaseTime,
        _OutGatewayRecord_callDuration,
        _OutGatewayRecord_dataVolume,
        _OutGatewayRecord_causeForTerm,
        _OutGatewayRecord_diagnostics,
        _OutGatewayRecord_callReference,
        _OutGatewayRecord_sequenceNumber,
        _OutGatewayRecord_recordExtensions,
        _OutGatewayRecord_locationRoutNum,
        _OutGatewayRecord_lrnSoInd,
        _OutGatewayRecord_lrnQuryStatus,
        _OutGatewayRecord_jIPPara,
        _OutGatewayRecord_jIPSoInd,
        _OutGatewayRecord_jIPQuryStatus,
        _OutGatewayRecord_reasonForServiceChange,
        _OutGatewayRecord_serviceChangeInitiator,
        OutGatewayRecord,
        _TransitCallRecord_recordType,
        _TransitCallRecord_recordingEntity,
        _TransitCallRecord_mscIncomingTKGP,
        _TransitCallRecord_mscOutgoingTKGP,
        _TransitCallRecord_callingNumber,
        _TransitCallRecord_calledNumber,
        _TransitCallRecord_isdnBasicService,
        _TransitCallRecord_seizureTimestamp,
        _TransitCallRecord_answerTimestamp,
        _TransitCallRecord_releaseTimestamp,
        _TransitCallRecord_callDuration,
        _TransitCallRecord_dataVolume,
        _TransitCallRecord_causeForTerm,
        _TransitCallRecord_diagnostics,
        _TransitCallRecord_callReference,
        _TransitCallRecord_sequenceNumber,
        _TransitCallRecord_recordExtensions,
        _TransitCallRecord_locationRoutNum,
        _TransitCallRecord_lrnSoInd,
        _TransitCallRecord_lrnQuryStatus,
        _TransitCallRecord_jIPPara,
        _TransitCallRecord_jIPSoInd,
        _TransitCallRecord_jIPQuryStatus,
        TransitCallRecord,
        _MOSMSRecord_recordType,
        _MOSMSRecord_servedIMSI,
        _MOSMSRecord_servedIMEI,
        _MOSMSRecord_servedMSISDN,
        _MOSMSRecord_msClassmark,
        _MOSMSRecord_serviceCentre,
        _MOSMSRecord_recordingEntity,
        _MOSMSRecord_location,
        _MOSMSRecord_messageReference,
        _MOSMSRecord_originationTime,
        _MOSMSRecord_smsResult,
        _MOSMSRecord_recordExtensions,
        _MOSMSRecord_destinationNumber,
        _MOSMSRecord_cAMELSMSInformation,
        _MOSMSRecord_systemType,
        _MOSMSRecord_locationExtension,
        MOSMSRecord,
        _MTSMSRecord_recordType,
        _MTSMSRecord_serviceCentre,
        _MTSMSRecord_servedIMSI,
        _MTSMSRecord_servedIMEI,
        _MTSMSRecord_servedMSISDN,
        _MTSMSRecord_msClassmark,
        _MTSMSRecord_recordingEntity,
        _MTSMSRecord_location,
        _MTSMSRecord_deliveryTime,
        _MTSMSRecord_smsResult,
        _MTSMSRecord_recordExtensions,
        _MTSMSRecord_systemType,
        _MTSMSRecord_cAMELSMSInformation,
        _MTSMSRecord_locationExtension,
        MTSMSRecord,
        _MOSMSIWRecord_recordType,
        _MOSMSIWRecord_serviceCentre,
        _MOSMSIWRecord_servedIMSI,
        _MOSMSIWRecord_recordingEntity,
        _MOSMSIWRecord_eventTime,
        _MOSMSIWRecord_smsResult,
        _MOSMSIWRecord_recordExtensions,
        MOSMSIWRecord,
        _MTSMSGWRecord_recordType,
        _MTSMSGWRecord_serviceCentre,
        _MTSMSGWRecord_servedIMSI,
        _MTSMSGWRecord_servedMSISDN,
        _MTSMSGWRecord_recordingEntity,
        _MTSMSGWRecord_eventTime,
        _MTSMSGWRecord_smsResult,
        _MTSMSGWRecord_recordExtensions,
        MTSMSGWRecord,
        _SSActionRecord_recordType,
        _SSActionRecord_servedIMSI,
        _SSActionRecord_servedIMEI,
        _SSActionRecord_servedMSISDN,
        _SSActionRecord_msClassmark,
        _SSActionRecord_recordingEntity,
        _SSActionRecord_location,
        _SSActionRecord_basicServices,
        _SSActionRecord_supplService,
        _SSActionRecord_ssAction,
        _SSActionRecord_ssActionTime,
        _SSActionRecord_ssParameters,
        _SSActionRecord_ssActionResult,
        _SSActionRecord_callReference,
        _SSActionRecord_recordExtensions,
        _SSActionRecord_systemType,
        SSActionRecord,
        _HLRIntRecord_recordType,
        _HLRIntRecord_servedIMSI,
        _HLRIntRecord_servedMSISDN,
        _HLRIntRecord_recordingEntity,
        _HLRIntRecord_basicService,
        _HLRIntRecord_routingNumber,
        _HLRIntRecord_interrogationTime,
        _HLRIntRecord_numberOfForwarding,
        _HLRIntRecord_interrogationResult,
        _HLRIntRecord_recordExtensions,
        HLRIntRecord,
        _LocUpdateHLRRecord_recordType,
        _LocUpdateHLRRecord_servedIMSI,
        _LocUpdateHLRRecord_recordingEntity,
        _LocUpdateHLRRecord_oldLocation,
        _LocUpdateHLRRecord_newLocation,
        _LocUpdateHLRRecord_updateTime,
        _LocUpdateHLRRecord_updateResult,
        _LocUpdateHLRRecord_recordExtensions,
        LocUpdateHLRRecord,
        _LocUpdateVLRRecord_recordType,
        _LocUpdateVLRRecord_servedIMSI,
        _LocUpdateVLRRecord_servedMSISDN,
        _LocUpdateVLRRecord_recordingEntity,
        _LocUpdateVLRRecord_oldLocation,
        _LocUpdateVLRRecord_newLocation,
        _LocUpdateVLRRecord_msClassmark,
        _LocUpdateVLRRecord_updateTime,
        _LocUpdateVLRRecord_updateResult,
        _LocUpdateVLRRecord_recordExtensions,
        _LocUpdateVLRRecord_locationExtension,
        LocUpdateVLRRecord,
        _CommonEquipRecord_recordType,
        _CommonEquipRecord_equipmentType,
        _CommonEquipRecord_equipmentId,
        _CommonEquipRecord_servedIMSI,
        _CommonEquipRecord_servedMSISDN,
        _CommonEquipRecord_recordingEntity,
        _CommonEquipRecord_basicService,
        __CommonEquipRecord_changeOfService__item_,
        _CommonEquipRecord_changeOfService,
        __CommonEquipRecord_supplServicesUsed__item_,
        _CommonEquipRecord_supplServicesUsed,
        _CommonEquipRecord_seizureTime,
        _CommonEquipRecord_releaseTime,
        _CommonEquipRecord_callDuration,
        _CommonEquipRecord_callReference,
        _CommonEquipRecord_sequenceNumber,
        _CommonEquipRecord_recordExtensions,
        _CommonEquipRecord_systemType,
        _CommonEquipRecord_rateIndication,
        _CommonEquipRecord_fnur,
        CommonEquipRecord,
        _ObservedIMEITicket_servedIMEI,
        _ObservedIMEITicket_imeiStatus,
        _ObservedIMEITicket_servedIMSI,
        _ObservedIMEITicket_servedMSISDN,
        _ObservedIMEITicket_recordingEntity,
        _ObservedIMEITicket_eventTime,
        _ObservedIMEITicket_location,
        _ObservedIMEITicket_imeiCheckEvent,
        _ObservedIMEITicket_callReference,
        _ObservedIMEITicket_recordExtensions,
        ObservedIMEITicket,
        _MTLCSRecord_recordType,
        _MTLCSRecord_recordingEntity,
        _MTLCSRecord_lcsClientType,
        _MTLCSRecord_lcsClientIdentity,
        _MTLCSRecord_servedIMSI,
        _MTLCSRecord_servedMSISDN,
        _MTLCSRecord_locationType,
        _MTLCSRecord_lcsQos,
        _MTLCSRecord_lcsPriority,
        _MTLCSRecord_mlc_Number,
        _MTLCSRecord_eventTimeStamp,
        _MTLCSRecord_measureDuration,
        _MTLCSRecord_notificationToMSUser,
        _MTLCSRecord_privacyOverride,
        _MTLCSRecord_location,
        _MTLCSRecord_locationEstimate,
        _MTLCSRecord_positioningData,
        _MTLCSRecord_lcsCause,
        _MTLCSRecord_diagnostics,
        _MTLCSRecord_systemType,
        _MTLCSRecord_recordExtensions,
        _MTLCSRecord_causeForTerm,
        _MTLCSRecord_servedIMEI,
        MTLCSRecord,
        _MOLCSRecord_recordType,
        _MOLCSRecord_recordingEntity,
        _MOLCSRecord_lcsClientType,
        _MOLCSRecord_lcsClientIdentity,
        _MOLCSRecord_servedIMSI,
        _MOLCSRecord_servedMSISDN,
        _MOLCSRecord_molr_Type,
        _MOLCSRecord_lcsQos,
        _MOLCSRecord_lcsPriority,
        _MOLCSRecord_mlc_Number,
        _MOLCSRecord_eventTimeStamp,
        _MOLCSRecord_measureDuration,
        _MOLCSRecord_location,
        _MOLCSRecord_locationEstimate,
        _MOLCSRecord_positioningData,
        _MOLCSRecord_lcsCause,
        _MOLCSRecord_diagnostics,
        _MOLCSRecord_systemType,
        _MOLCSRecord_recordExtensions,
        _MOLCSRecord_causeForTerm,
        MOLCSRecord,
        _NILCSRecord_recordType,
        _NILCSRecord_recordingEntity,
        _NILCSRecord_lcsClientType,
        _NILCSRecord_lcsClientIdentity,
        _NILCSRecord_servedIMSI,
        _NILCSRecord_servedMSISDN,
        _NILCSRecord_servedIMEI,
        _NILCSRecord_emsDigits,
        _NILCSRecord_emsKey,
        _NILCSRecord_lcsQos,
        _NILCSRecord_lcsPriority,
        _NILCSRecord_mlc_Number,
        _NILCSRecord_eventTimeStamp,
        _NILCSRecord_measureDuration,
        _NILCSRecord_location,
        _NILCSRecord_locationEstimate,
        _NILCSRecord_positioningData,
        _NILCSRecord_lcsCause,
        _NILCSRecord_diagnostics,
        _NILCSRecord_systemType,
        _NILCSRecord_recordExtensions,
        _NILCSRecord_causeForTerm,
        NILCSRecord,
        _MSCsRVCCRecord_recordType,
        _MSCsRVCCRecord_servedIMSI,
        _MSCsRVCCRecord_servedIMEI,
        _MSCsRVCCRecord_servedMSISDN,
        _MSCsRVCCRecord_calledNumber,
        _MSCsRVCCRecord_recordingEntity,
        _MSCsRVCCRecord_mscOutgoingTKGP,
        _MSCsRVCCRecord_location,
        __MSCsRVCCRecord_changeOfLocation__item_,
        _MSCsRVCCRecord_changeOfLocation,
        _MSCsRVCCRecord_basicService,
        __MSCsRVCCRecord_supplServicesUsed__item_,
        _MSCsRVCCRecord_supplServicesUsed,
        _MSCsRVCCRecord_msClassmark,
        _MSCsRVCCRecord_seizureTime,
        _MSCsRVCCRecord_answerTime,
        _MSCsRVCCRecord_releaseTime,
        _MSCsRVCCRecord_callDuration,
        _MSCsRVCCRecord_causeForTerm,
        _MSCsRVCCRecord_diagnostics,
        _MSCsRVCCRecord_callReference,
        _MSCsRVCCRecord_sequenceNumber,
        _MSCsRVCCRecord_recordExtensions,
        _MSCsRVCCRecord_partialRecordType,
        _MSCsRVCCRecord_iMS_Charging_Identifier,
        _MSCsRVCCRecord_iCSI2ActiveFlag,
        _MSCsRVCCRecord_relatedICID,
        _MSCsRVCCRecord_relatedICIDGenerationNode,
        MSCsRVCCRecord,
        _MTRFRecord_recordType,
        _MTRFRecord_servedIMSI,
        _MTRFRecord_servedIMEI,
        _MTRFRecord_servedMSISDN,
        _MTRFRecord_callingNumber,
        _MTRFRecord_roamingNumber,
        _MTRFRecord_recordingEntity,
        _MTRFRecord_mscIncomingTKGP,
        _MTRFRecord_mscOutgoingTKGP,
        _MTRFRecord_basicService,
        _MTRFRecord_seizureTime,
        _MTRFRecord_answerTime,
        _MTRFRecord_releaseTime,
        _MTRFRecord_callDuration,
        _MTRFRecord_causeForTerm,
        _MTRFRecord_diagnostics,
        _MTRFRecord_callReference,
        _MTRFRecord_sequenceNumber,
        _MTRFRecord_recordExtensions,
        _MTRFRecord_partialRecordType,
        MTRFRecord,
        _ICSregisterRecord_recordType,
        _ICSregisterRecord_servedIMSI,
        _ICSregisterRecord_servedMSISDN,
        _ICSregisterRecord_privateUserID,
        _ICSregisterRecord_recordingEntity,
        _ICSregisterRecord_newLocation,
        _ICSregisterRecord_locationExtension,
        _ICSregisterRecord_updateTime,
        _ICSregisterRecord_iMS_Charging_Identifier,
        _ICSregisterRecord_interOperatorIdentifiers,
        _ICSregisterRecord_transit_IOI_Lists,
        _ICSregisterRecord_updateResult,
        _ICSregisterRecord_recordExtensions,
        ICSregisterRecord,
        LocationRoutingNumber,
        LocationRoutingNumberSourceIndicator,
        LocationRoutingNumberQueryStatus,
        JurisdictionInformationParameter,
        JurisdictionInformationParameterSourceIndicator,
        JurisdictionInformationParameterQueryStatus,
        _AdditionalChgInfo_chargeIndicator,
        _AdditionalChgInfo_chargeParameters,
        AdditionalChgInfo,
        AiurRequested,
        _AOCParameters_e1,
        _AOCParameters_e2,
        _AOCParameters_e3,
        _AOCParameters_e4,
        _AOCParameters_e5,
        _AOCParameters_e6,
        _AOCParameters_e7,
        AOCParameters,
        _AOCParmChange_changeTime,
        _AOCParmChange_newParameters,
        AOCParmChange,
        _BasicServices__item_,
        BasicServices,
        CallingPartyCategory,
        CallType,
        _CallTypes__item_,
        CallTypes,
        CAMELDestinationNumber,
        _CAMELInformation_cAMELDestinationNumber,
        _CAMELInformation_connectedNumber,
        _CAMELInformation_roamingNumber,
        _CAMELInformation_mscOutgoingTKGP,
        _CAMELInformation_seizureTime,
        _CAMELInformation_answerTime,
        _CAMELInformation_releaseTime,
        _CAMELInformation_callDuration,
        _CAMELInformation_dataVolume,
        _CAMELInformation_cAMELInitCFIndicator,
        _CAMELInformation_causeForTerm,
        _CAMELInformation_cAMELModification,
        _CAMELInformation_freeFormatData,
        _CAMELInformation_diagnostics,
        _CAMELInformation_freeFormatDataAppend,
        _CAMELInformation_freeFormatData_2,
        _CAMELInformation_freeFormatDataAppend_2,
        CAMELInformation,
        CAMELInitCFIndicator,
        _CAMELModificationParameters_callingPartyNumber,
        _CAMELModificationParameters_callingPartyCategory,
        _CAMELModificationParameters_originalCalledPartyNumber,
        _CAMELModificationParameters_genericNumbers,
        _CAMELModificationParameters_redirectingPartyNumber,
        _CAMELModificationParameters_redirectionCounter,
        CAMELModificationParameters,
        _CAMELSMSInformation_gsm_SCFAddress,
        _CAMELSMSInformation_serviceKey,
        _CAMELSMSInformation_defaultSMSHandling,
        _CAMELSMSInformation_freeFormatData,
        _CAMELSMSInformation_callingPartyNumber,
        _CAMELSMSInformation_destinationSubscriberNumber,
        _CAMELSMSInformation_cAMELSMSCAddress,
        _CAMELSMSInformation_smsReferenceNumber,
        CAMELSMSInformation,
        Category,
        _ChangedParameters_changeFlags,
        _ChangedParameters_changeList,
        ChangedParameters,
        ChangeFlags,
        _ChangeOfClassmark_classmark,
        _ChangeOfClassmark_changeTime,
        ChangeOfClassmark,
        _ChangeOfRadioChannel_radioChannel,
        _ChangeOfRadioChannel_changeTime,
        _ChangeOfRadioChannel_speechVersionUsed,
        ChangeOfRadioChannel,
        _ChangeOfService_basicService,
        _ChangeOfService_transparencyInd,
        _ChangeOfService_changeTime,
        _ChangeOfService_rateIndication,
        _ChangeOfService_fnur,
        ChangeOfService,
        ChannelCoding,
        Classmark,
        ConnectedNumber,
        DataVolume,
        Day,
        DayClass,
        _DayClasses__item_,
        DayClasses,
        _DayDefinition_day,
        _DayDefinition_dayClass,
        DayDefinition,
        _DayDefinitions__item_,
        DayDefinitions,
        _DateDefinition_month,
        _DateDefinition_day,
        _DateDefinition_dayClass,
        DateDefinition,
        _DateDefinitions__item_,
        DateDefinitions,
        DayOfTheWeek,
        _Destinations__item_,
        Destinations,
        EmergencyCallIndEnable,
        _EmergencyCallIndication_cellId,
        _EmergencyCallIndication_callerId,
        EmergencyCallIndication,
        EParameter,
        EquipmentId,
        EquipmentType,
        FileType,
        Fnur,
        ForwardToNumber,
        FreeFormatData,
        GenericNumber,
        _GenericNumbers__item_,
        GenericNumbers,
        Gsm_SCFAddress,
        GuaranteedBitRate,
        HLRIntResult,
        _HSCSDParmsChange_changeTime,
        _HSCSDParmsChange_hSCSDChanAllocated,
        _HSCSDParmsChange_initiatingParty,
        _HSCSDParmsChange_aiurRequested,
        _HSCSDParmsChange_chanCodingUsed,
        _HSCSDParmsChange_hSCSDChanRequested,
        HSCSDParmsChange,
        IMEICheckEvent,
        IMEIStatus,
        _IMSIorIMEI_imsi,
        _IMSIorIMEI_imei,
        IMSIorIMEI,
        InitiatingParty,
        LocationCellExtension,
        _LocationChange_location,
        _LocationChange_changeTime,
        LocationChange,
        _Location_info_mscNumber,
        _Location_info_location_area,
        _Location_info_cell_identification,
        _Location_info_mCC_MNC,
        Location_info,
        LocUpdResult,
        MaximumBitRate,
        Month,
        _MSPowerClasses__item_,
        MSPowerClasses,
        NetworkCallReference,
        NetworkSpecificCode,
        _NetworkSpecificServices__item_,
        NetworkSpecificServices,
        NumOfHSCSDChanRequested,
        NumOfHSCSDChanAllocated,
        ObservedIMEITicketEnable,
        OriginalCalledNumber,
        _OriginDestCombinations__item_,
        OriginDestCombinations,
        _OriginDestCombination_origin,
        _OriginDestCombination_destination,
        OriginDestCombination,
        PartialRecordTimer,
        PartialRecordType,
        _PartialRecordTypes__item_,
        PartialRecordTypes,
        _RadioChannelsRequested__item_,
        RadioChannelsRequested,
        RadioChanRequested,
        RateIndication,
        ReasonForServiceChange,
        _RecordClassDestination_osApplication,
        _RecordClassDestination_fileType,
        RecordClassDestination,
        _RecordClassDestinations__item_,
        RecordClassDestinations,
        RecordingMethod,
        RedirectingNumber,
        RFPowerCapability,
        RoamingNumber,
        _RoutingNumber_roaming,
        _RoutingNumber_forwarded,
        RoutingNumber,
        _Service_teleservice,
        _Service_bearerService,
        _Service_supplementaryService,
        _Service_networkSpecificService,
        Service,
        _ServiceDistanceDependencies__item_,
        ServiceDistanceDependencies,
        _ServiceDistanceDependency_aocService,
        _ServiceDistanceDependency_chargingZone,
        ServiceDistanceDependency,
        SimpleIntegerName,
        SimpleStringName,
        SpeechVersionIdentifier,
        SSActionResult,
        SSActionType,
        _SSParameters_forwardedToNumber,
        _SSParameters_unstructuredData,
        SSParameters,
        _SupplServices__item_,
        SupplServices,
        _SuppServiceUsed_ssCode,
        _SuppServiceUsed_ssTime,
        SuppServiceUsed,
        _SwitchoverTime_hour,
        _SwitchoverTime_minute,
        _SwitchoverTime_second,
        SwitchoverTime,
        TariffId,
        _TariffPeriod_switchoverTime,
        _TariffPeriod_tariffId,
        TariffPeriod,
        _TariffPeriods__item_,
        TariffPeriods,
        TariffSystemStatus,
        TrafficChannel,
        TranslatedNumber,
        TransparencyInd,
        _TrunkGroup_tkgpNumber,
        _TrunkGroup_tkgpName,
        TrunkGroup,
        _TSChangeover_newActiveTS,
        _TSChangeover_newStandbyTS,
        _TSChangeover_changeoverTime,
        _TSChangeover_authkey,
        _TSChangeover_checksum,
        _TSChangeover_versionNumber,
        TSChangeover,
        _TSCheckError_errorId,
        _TSCheckError_fail,
        TSCheckError,
        _TSCheckErrorId_globalForm,
        _TSCheckErrorId_localForm,
        TSCheckErrorId,
        _TSCheckResult_success,
        __TSCheckResult_fail__item_,
        _TSCheckResult_fail,
        TSCheckResult,
        _TSCopyTariffSystem_oldTS,
        _TSCopyTariffSystem_newTS,
        TSCopyTariffSystem,
        _TSNextChange_noChangeover,
        _TSNextChange_tsChangeover,
        TSNextChange,
        TypeOfSubscribers,
        TypeOfTransaction,
        _Visited_Location_info_mscNumber,
        _Visited_Location_info_vlrNumber,
        Visited_Location_info,
        VlrNo,
    ]

class DialoguePDUs:

    _name_  = u'DialoguePDUs'
    _oid_   = [0, 0, 17, 773, 2, 2, 1]
    
    _obj_ = [
        u'dialogue-as-id',
        u'DialoguePDU',
        u'AARQ-apdu',
        u'AARE-apdu',
        u'RLRQ-apdu',
        u'RLRE-apdu',
        u'ABRT-apdu',
        u'ABRT-source',
        u'Associate-result',
        u'Associate-source-diagnostic',
        u'Release-request-reason',
        u'Release-response-reason',
        ]
    _type_ = [
        u'DialoguePDU',
        u'AARQ-apdu',
        u'AARE-apdu',
        u'RLRQ-apdu',
        u'RLRE-apdu',
        u'ABRT-apdu',
        u'ABRT-source',
        u'Associate-result',
        u'Associate-source-diagnostic',
        u'Release-request-reason',
        u'Release-response-reason',
        ]
    _set_ = [
        ]
    _val_ = [
        u'dialogue-as-id',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< dialogue-as-id >-----#
    dialogue_as_id = OID(name=u'dialogue-as-id', mode=MODE_VALUE)
    dialogue_as_id._val = (0, 0, 17, 773, 1, 1, 1)
    
    #-----< DialoguePDU >-----#
    DialoguePDU = CHOICE(name=u'DialoguePDU', mode=MODE_TYPE)
    _DialoguePDU_dialogueRequest = SEQ(name=u'dialogueRequest', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'AARQ-apdu')))
    _DialoguePDU_dialogueResponse = SEQ(name=u'dialogueResponse', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'AARE-apdu')))
    _DialoguePDU_dialogueAbort = SEQ(name=u'dialogueAbort', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'ABRT-apdu')))
    DialoguePDU._cont = ASN1Dict([
        (u'dialogueRequest', _DialoguePDU_dialogueRequest),
        (u'dialogueResponse', _DialoguePDU_dialogueResponse),
        (u'dialogueAbort', _DialoguePDU_dialogueAbort),
        ])
    DialoguePDU._ext = None
    
    #-----< AARQ-apdu >-----#
    AARQ_apdu = SEQ(name=u'AARQ-apdu', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _AARQ_apdu_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AARQ_apdu_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _AARQ_apdu_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _AARQ_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AARQ_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _AARQ_apdu_user_information._cont = __AARQ_apdu_user_information__item_
    AARQ_apdu._cont = ASN1Dict([
        (u'protocol-version', _AARQ_apdu_protocol_version),
        (u'application-context-name', _AARQ_apdu_application_context_name),
        (u'user-information', _AARQ_apdu_user_information),
        ])
    AARQ_apdu._ext = None
    
    #-----< AARE-apdu >-----#
    AARE_apdu = SEQ(name=u'AARE-apdu', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _AARE_apdu_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AARE_apdu_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _AARE_apdu_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _AARE_apdu_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Associate-result')))
    _AARE_apdu_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Associate-source-diagnostic')))
    _AARE_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AARE_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _AARE_apdu_user_information._cont = __AARE_apdu_user_information__item_
    AARE_apdu._cont = ASN1Dict([
        (u'protocol-version', _AARE_apdu_protocol_version),
        (u'application-context-name', _AARE_apdu_application_context_name),
        (u'result', _AARE_apdu_result),
        (u'result-source-diagnostic', _AARE_apdu_result_source_diagnostic),
        (u'user-information', _AARE_apdu_user_information),
        ])
    AARE_apdu._ext = None
    
    #-----< RLRQ-apdu >-----#
    RLRQ_apdu = SEQ(name=u'RLRQ-apdu', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT))
    _RLRQ_apdu_reason = INT(name=u'reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Release-request-reason')), opt=True)
    _RLRQ_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RLRQ_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _RLRQ_apdu_user_information._cont = __RLRQ_apdu_user_information__item_
    RLRQ_apdu._cont = ASN1Dict([
        (u'reason', _RLRQ_apdu_reason),
        (u'user-information', _RLRQ_apdu_user_information),
        ])
    RLRQ_apdu._ext = None
    
    #-----< RLRE-apdu >-----#
    RLRE_apdu = SEQ(name=u'RLRE-apdu', mode=MODE_TYPE, tag=(3, TAG_APPLICATION, TAG_IMPLICIT))
    _RLRE_apdu_reason = INT(name=u'reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'Release-response-reason')), opt=True)
    _RLRE_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RLRE_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _RLRE_apdu_user_information._cont = __RLRE_apdu_user_information__item_
    RLRE_apdu._cont = ASN1Dict([
        (u'reason', _RLRE_apdu_reason),
        (u'user-information', _RLRE_apdu_user_information),
        ])
    RLRE_apdu._ext = None
    
    #-----< ABRT-apdu >-----#
    ABRT_apdu = SEQ(name=u'ABRT-apdu', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT))
    _ABRT_apdu_abort_source = INT(name=u'abort-source', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DialoguePDUs', 'ABRT-source')))
    _ABRT_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ABRT_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _ABRT_apdu_user_information._cont = __ABRT_apdu_user_information__item_
    ABRT_apdu._cont = ASN1Dict([
        (u'abort-source', _ABRT_apdu_abort_source),
        (u'user-information', _ABRT_apdu_user_information),
        ])
    ABRT_apdu._ext = None
    
    #-----< ABRT-source >-----#
    ABRT_source = INT(name=u'ABRT-source', mode=MODE_TYPE)
    ABRT_source._cont = ASN1Dict([(u'dialogue-service-user', 0), (u'dialogue-service-provider', 1)])
    
    #-----< Associate-result >-----#
    Associate_result = INT(name=u'Associate-result', mode=MODE_TYPE)
    Associate_result._cont = ASN1Dict([(u'accepted', 0), (u'reject-permanent', 1)])
    
    #-----< Associate-source-diagnostic >-----#
    Associate_source_diagnostic = CHOICE(name=u'Associate-source-diagnostic', mode=MODE_TYPE)
    _Associate_source_diagnostic_dialogue_service_user = INT(name=u'dialogue-service-user', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_dialogue_service_user._cont = ASN1Dict([(u'null', 0), (u'no-reason-given', 1), (u'application-context-name-not-supported', 2)])
    _Associate_source_diagnostic_dialogue_service_provider = INT(name=u'dialogue-service-provider', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_dialogue_service_provider._cont = ASN1Dict([(u'null', 0), (u'no-reason-given', 1), (u'no-common-dialogue-portion', 2)])
    Associate_source_diagnostic._cont = ASN1Dict([
        (u'dialogue-service-user', _Associate_source_diagnostic_dialogue_service_user),
        (u'dialogue-service-provider', _Associate_source_diagnostic_dialogue_service_provider),
        ])
    Associate_source_diagnostic._ext = None
    
    #-----< Release-request-reason >-----#
    Release_request_reason = INT(name=u'Release-request-reason', mode=MODE_TYPE)
    Release_request_reason._cont = ASN1Dict([(u'normal', 0), (u'urgent', 1), (u'user-defined', 30)])
    
    #-----< Release-response-reason >-----#
    Release_response_reason = INT(name=u'Release-response-reason', mode=MODE_TYPE)
    Release_response_reason._cont = ASN1Dict([(u'normal', 0), (u'not-finished', 1), (u'user-defined', 30)])
    
    _all_ = [
        dialogue_as_id,
        _DialoguePDU_dialogueRequest,
        _DialoguePDU_dialogueResponse,
        _DialoguePDU_dialogueAbort,
        DialoguePDU,
        _AARQ_apdu_protocol_version,
        _AARQ_apdu_application_context_name,
        __AARQ_apdu_user_information__item_,
        _AARQ_apdu_user_information,
        AARQ_apdu,
        _AARE_apdu_protocol_version,
        _AARE_apdu_application_context_name,
        _AARE_apdu_result,
        _AARE_apdu_result_source_diagnostic,
        __AARE_apdu_user_information__item_,
        _AARE_apdu_user_information,
        AARE_apdu,
        _RLRQ_apdu_reason,
        __RLRQ_apdu_user_information__item_,
        _RLRQ_apdu_user_information,
        RLRQ_apdu,
        _RLRE_apdu_reason,
        __RLRE_apdu_user_information__item_,
        _RLRE_apdu_user_information,
        RLRE_apdu,
        _ABRT_apdu_abort_source,
        __ABRT_apdu_user_information__item_,
        _ABRT_apdu_user_information,
        ABRT_apdu,
        ABRT_source,
        Associate_result,
        _Associate_source_diagnostic_dialogue_service_user,
        _Associate_source_diagnostic_dialogue_service_provider,
        Associate_source_diagnostic,
        Release_request_reason,
        Release_response_reason,
    ]

class DirectoryAbstractService:

    _name_  = u'DirectoryAbstractService'
    _oid_   = [2, 5, 1, 2, 8]
    
    _obj_ = [
        u'CommonArguments',
        u'CommonArgumentsSeq',
        u'FamilyGrouping',
        u'CommonResults',
        u'CommonResultsSeq',
        u'ServiceControls',
        u'ServiceControlOptions',
        u'EntryInformationSelection',
        u'ContextSelection',
        u'TypeAndContextAssertion',
        u'FamilyReturn',
        u'EntryInformation',
        u'family-information',
        u'FamilyEntries',
        u'FamilyEntry',
        u'Filter',
        u'FilterItem',
        u'MatchingRuleAssertion',
        u'PagedResultsRequest',
        u'SortKey',
        u'SecurityParameters',
        u'ProtectionRequest',
        u'Time',
        u'ErrorProtectionRequest',
        u'directoryBind',
        u'DirectoryBindArgument',
        u'Credentials',
        u'SimpleCredentials',
        u'StrongCredentials',
        u'SpkmCredentials',
        u'SaslCredentials',
        u'ub-saslMechanism',
        u'Token',
        u'TokenContent',
        u'Versions',
        u'DirectoryBindResult',
        u'PwdResponseValue',
        u'directoryBindError',
        u'BindKeyInfo',
        u'read',
        u'ReadArgument',
        u'ReadArgumentData',
        u'ReadResult',
        u'ReadResultData',
        u'ModifyRights',
        u'compare',
        u'CompareArgument',
        u'CompareArgumentData',
        u'CompareResult',
        u'CompareResultData',
        u'abandon',
        u'AbandonArgument',
        u'AbandonArgumentData',
        u'AbandonResult',
        u'AbandonResultData',
        u'list',
        u'ListArgument',
        u'ListArgumentData',
        u'ListResult',
        u'ListResultData',
        u'PartialOutcomeQualifier',
        u'LimitProblem',
        u'search',
        u'SearchArgument',
        u'SearchArgumentData',
        u'HierarchySelections',
        u'SearchControlOptions',
        u'JoinArgument',
        u'DomainLocalID',
        u'JoinAttPair',
        u'JoinContextType',
        u'SearchResult',
        u'SearchResultData',
        u'addEntry',
        u'AddEntryArgument',
        u'AddEntryArgumentData',
        u'AddEntryResult',
        u'AddEntryResultData',
        u'removeEntry',
        u'RemoveEntryArgument',
        u'RemoveEntryArgumentData',
        u'RemoveEntryResult',
        u'RemoveEntryResultData',
        u'modifyEntry',
        u'ModifyEntryArgument',
        u'ModifyEntryArgumentData',
        u'ModifyEntryResult',
        u'ModifyEntryResultData',
        u'EntryModification',
        u'modifyDN',
        u'ModifyDNArgument',
        u'ModifyDNArgumentData',
        u'ModifyDNResult',
        u'ModifyDNResultData',
        u'changePassword',
        u'ChangePasswordArgument',
        u'ChangePasswordArgumentData',
        u'ChangePasswordResult',
        u'ChangePasswordResultData',
        u'administerPassword',
        u'AdministerPasswordArgument',
        u'AdministerPasswordArgumentData',
        u'AdministerPasswordResult',
        u'AdministerPasswordResultData',
        u'ldapTransport',
        u'LdapArgument',
        u'LdapArgumentData',
        u'LinkId',
        u'LdapResult',
        u'LdapResultData',
        u'linkedLDAP',
        u'LinkedArgument',
        u'LinkedArgumentData',
        u'LinkedResult',
        u'abandoned',
        u'AbandonedData',
        u'AbandonedProblem',
        u'abandonFailed',
        u'AbandonFailedData',
        u'AbandonProblem',
        u'attributeError',
        u'AttributeErrorData',
        u'AttributeProblem',
        u'nameError',
        u'NameErrorData',
        u'NameProblem',
        u'referral',
        u'ReferralData',
        u'securityError',
        u'SecurityErrorData',
        u'SecurityProblem',
        u'EncPwdInfo',
        u'serviceError',
        u'ServiceErrorData',
        u'ServiceProblem',
        u'updateError',
        u'UpdateErrorData',
        u'UpdateProblem',
        u'id-at-family-information',
        ]
    _type_ = [
        u'CommonArguments',
        u'CommonArgumentsSeq',
        u'FamilyGrouping',
        u'CommonResults',
        u'CommonResultsSeq',
        u'ServiceControls',
        u'ServiceControlOptions',
        u'EntryInformationSelection',
        u'ContextSelection',
        u'TypeAndContextAssertion',
        u'FamilyReturn',
        u'EntryInformation',
        u'FamilyEntries',
        u'FamilyEntry',
        u'Filter',
        u'FilterItem',
        u'MatchingRuleAssertion',
        u'PagedResultsRequest',
        u'SortKey',
        u'SecurityParameters',
        u'ProtectionRequest',
        u'Time',
        u'ErrorProtectionRequest',
        u'DirectoryBindArgument',
        u'Credentials',
        u'SimpleCredentials',
        u'StrongCredentials',
        u'SpkmCredentials',
        u'SaslCredentials',
        u'Token',
        u'TokenContent',
        u'Versions',
        u'DirectoryBindResult',
        u'PwdResponseValue',
        u'BindKeyInfo',
        u'ReadArgument',
        u'ReadArgumentData',
        u'ReadResult',
        u'ReadResultData',
        u'ModifyRights',
        u'CompareArgument',
        u'CompareArgumentData',
        u'CompareResult',
        u'CompareResultData',
        u'AbandonArgument',
        u'AbandonArgumentData',
        u'AbandonResult',
        u'AbandonResultData',
        u'ListArgument',
        u'ListArgumentData',
        u'ListResult',
        u'ListResultData',
        u'PartialOutcomeQualifier',
        u'LimitProblem',
        u'SearchArgument',
        u'SearchArgumentData',
        u'HierarchySelections',
        u'SearchControlOptions',
        u'JoinArgument',
        u'DomainLocalID',
        u'JoinAttPair',
        u'JoinContextType',
        u'SearchResult',
        u'SearchResultData',
        u'AddEntryArgument',
        u'AddEntryArgumentData',
        u'AddEntryResult',
        u'AddEntryResultData',
        u'RemoveEntryArgument',
        u'RemoveEntryArgumentData',
        u'RemoveEntryResult',
        u'RemoveEntryResultData',
        u'ModifyEntryArgument',
        u'ModifyEntryArgumentData',
        u'ModifyEntryResult',
        u'ModifyEntryResultData',
        u'EntryModification',
        u'ModifyDNArgument',
        u'ModifyDNArgumentData',
        u'ModifyDNResult',
        u'ModifyDNResultData',
        u'ChangePasswordArgument',
        u'ChangePasswordArgumentData',
        u'ChangePasswordResult',
        u'ChangePasswordResultData',
        u'AdministerPasswordArgument',
        u'AdministerPasswordArgumentData',
        u'AdministerPasswordResult',
        u'AdministerPasswordResultData',
        u'LdapArgument',
        u'LdapArgumentData',
        u'LinkId',
        u'LdapResult',
        u'LdapResultData',
        u'LinkedArgument',
        u'LinkedArgumentData',
        u'LinkedResult',
        u'AbandonedData',
        u'AbandonedProblem',
        u'AbandonFailedData',
        u'AbandonProblem',
        u'AttributeErrorData',
        u'AttributeProblem',
        u'NameErrorData',
        u'NameProblem',
        u'ReferralData',
        u'SecurityErrorData',
        u'SecurityProblem',
        u'EncPwdInfo',
        u'ServiceErrorData',
        u'ServiceProblem',
        u'UpdateErrorData',
        u'UpdateProblem',
        ]
    _set_ = [
        ]
    _val_ = [
        u'family-information',
        u'directoryBind',
        u'ub-saslMechanism',
        u'directoryBindError',
        u'read',
        u'compare',
        u'abandon',
        u'list',
        u'search',
        u'addEntry',
        u'removeEntry',
        u'modifyEntry',
        u'modifyDN',
        u'changePassword',
        u'administerPassword',
        u'ldapTransport',
        u'linkedLDAP',
        u'abandoned',
        u'abandonFailed',
        u'attributeError',
        u'nameError',
        u'referral',
        u'securityError',
        u'serviceError',
        u'updateError',
        u'id-at-family-information',
        ]
    _class_ = [
        u'family-information',
        u'directoryBind',
        u'directoryBindError',
        u'read',
        u'compare',
        u'abandon',
        u'list',
        u'search',
        u'addEntry',
        u'removeEntry',
        u'modifyEntry',
        u'modifyDN',
        u'changePassword',
        u'administerPassword',
        u'ldapTransport',
        u'linkedLDAP',
        u'abandoned',
        u'abandonFailed',
        u'attributeError',
        u'nameError',
        u'referral',
        u'securityError',
        u'serviceError',
        u'updateError',
        ]
    _param_ = [
        ]
    
    #-----< CommonArguments >-----#
    CommonArguments = SET(name=u'CommonArguments', mode=MODE_TYPE)
    _CommonArguments_serviceControls = SET(name=u'serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _CommonArguments_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CommonArguments_requestor = SEQ_OF(name=u'requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CommonArguments_operationProgress = SET(name=u'operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([(u'nameResolutionPhase', u'notStarted')]))
    _CommonArguments_aliasedRDNs = INT(name=u'aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CommonArguments_criticalExtensions = BIT_STR(name=u'criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CommonArguments_referenceType = ENUM(name=u'referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _CommonArguments_entryOnly = BOOL(name=u'entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _CommonArguments_exclusions = SET_OF(name=u'exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _CommonArguments_nameResolveOnMaster = BOOL(name=u'nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CommonArguments_operationContexts = CHOICE(name=u'operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _CommonArguments_familyGrouping = ENUM(name=u'familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default=u'entryOnly')
    CommonArguments._cont = ASN1Dict([
        (u'serviceControls', _CommonArguments_serviceControls),
        (u'securityParameters', _CommonArguments_securityParameters),
        (u'requestor', _CommonArguments_requestor),
        (u'operationProgress', _CommonArguments_operationProgress),
        (u'aliasedRDNs', _CommonArguments_aliasedRDNs),
        (u'criticalExtensions', _CommonArguments_criticalExtensions),
        (u'referenceType', _CommonArguments_referenceType),
        (u'entryOnly', _CommonArguments_entryOnly),
        (u'exclusions', _CommonArguments_exclusions),
        (u'nameResolveOnMaster', _CommonArguments_nameResolveOnMaster),
        (u'operationContexts', _CommonArguments_operationContexts),
        (u'familyGrouping', _CommonArguments_familyGrouping),
        ])
    CommonArguments._ext = []
    
    #-----< CommonArgumentsSeq >-----#
    CommonArgumentsSeq = SEQ(name=u'CommonArgumentsSeq', mode=MODE_TYPE)
    _CommonArgumentsSeq_serviceControls = SET(name=u'serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _CommonArgumentsSeq_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CommonArgumentsSeq_requestor = SEQ_OF(name=u'requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CommonArgumentsSeq_operationProgress = SET(name=u'operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([(u'nameResolutionPhase', u'notStarted')]))
    _CommonArgumentsSeq_aliasedRDNs = INT(name=u'aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CommonArgumentsSeq_criticalExtensions = BIT_STR(name=u'criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CommonArgumentsSeq_referenceType = ENUM(name=u'referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _CommonArgumentsSeq_entryOnly = BOOL(name=u'entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _CommonArgumentsSeq_exclusions = SET_OF(name=u'exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _CommonArgumentsSeq_nameResolveOnMaster = BOOL(name=u'nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CommonArgumentsSeq_operationContexts = CHOICE(name=u'operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _CommonArgumentsSeq_familyGrouping = ENUM(name=u'familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default=u'entryOnly')
    CommonArgumentsSeq._cont = ASN1Dict([
        (u'serviceControls', _CommonArgumentsSeq_serviceControls),
        (u'securityParameters', _CommonArgumentsSeq_securityParameters),
        (u'requestor', _CommonArgumentsSeq_requestor),
        (u'operationProgress', _CommonArgumentsSeq_operationProgress),
        (u'aliasedRDNs', _CommonArgumentsSeq_aliasedRDNs),
        (u'criticalExtensions', _CommonArgumentsSeq_criticalExtensions),
        (u'referenceType', _CommonArgumentsSeq_referenceType),
        (u'entryOnly', _CommonArgumentsSeq_entryOnly),
        (u'exclusions', _CommonArgumentsSeq_exclusions),
        (u'nameResolveOnMaster', _CommonArgumentsSeq_nameResolveOnMaster),
        (u'operationContexts', _CommonArgumentsSeq_operationContexts),
        (u'familyGrouping', _CommonArgumentsSeq_familyGrouping),
        ])
    CommonArgumentsSeq._ext = []
    
    #-----< FamilyGrouping >-----#
    FamilyGrouping = ENUM(name=u'FamilyGrouping', mode=MODE_TYPE)
    FamilyGrouping._cont = ASN1Dict([(u'entryOnly', 1), (u'compoundEntry', 2), (u'strands', 3), (u'multiStrand', 4)])
    FamilyGrouping._ext = []
    
    #-----< CommonResults >-----#
    CommonResults = SET(name=u'CommonResults', mode=MODE_TYPE)
    _CommonResults_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CommonResults_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CommonResults_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CommonResults_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __CommonResults_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___CommonResults_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____CommonResults_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____CommonResults_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    _____CommonResults_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____CommonResults_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____CommonResults_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____CommonResults_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___CommonResults_notification__item__type._const_tab = ____CommonResults_notification__item__type_tab
    ___CommonResults_notification__item__type._const_tab_at = None
    ___CommonResults_notification__item__type._const_tab_id = u'id'
    ___CommonResults_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____CommonResults_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____CommonResults_notification__item__values__item_._const_tab = ____CommonResults_notification__item__type_tab
    ____CommonResults_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____CommonResults_notification__item__values__item_._const_tab_id = u'Type'
    ___CommonResults_notification__item__values._cont = ____CommonResults_notification__item__values__item_
    ___CommonResults_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___CommonResults_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____CommonResults_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____CommonResults_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____CommonResults_notification__item__valuesWithContext__item__value._const_tab = ____CommonResults_notification__item__type_tab
    _____CommonResults_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____CommonResults_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____CommonResults_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______CommonResults_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____CommonResults_notification__item__valuesWithContext__item__contextList._cont = ______CommonResults_notification__item__valuesWithContext__item__contextList__item_
    _____CommonResults_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____CommonResults_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____CommonResults_notification__item__valuesWithContext__item__value),
        (u'contextList', _____CommonResults_notification__item__valuesWithContext__item__contextList),
        ])
    ____CommonResults_notification__item__valuesWithContext__item_._ext = []
    ___CommonResults_notification__item__valuesWithContext._cont = ____CommonResults_notification__item__valuesWithContext__item_
    ___CommonResults_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __CommonResults_notification__item_._cont = ASN1Dict([
        (u'type', ___CommonResults_notification__item__type),
        (u'values', ___CommonResults_notification__item__values),
        (u'valuesWithContext', ___CommonResults_notification__item__valuesWithContext),
        ])
    __CommonResults_notification__item_._ext = []
    _CommonResults_notification._cont = __CommonResults_notification__item_
    _CommonResults_notification._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    CommonResults._cont = ASN1Dict([
        (u'securityParameters', _CommonResults_securityParameters),
        (u'performer', _CommonResults_performer),
        (u'aliasDereferenced', _CommonResults_aliasDereferenced),
        (u'notification', _CommonResults_notification),
        ])
    CommonResults._ext = []
    
    #-----< CommonResultsSeq >-----#
    CommonResultsSeq = SEQ(name=u'CommonResultsSeq', mode=MODE_TYPE)
    _CommonResultsSeq_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CommonResultsSeq_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CommonResultsSeq_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CommonResultsSeq_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __CommonResultsSeq_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___CommonResultsSeq_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____CommonResultsSeq_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____CommonResultsSeq_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____CommonResultsSeq_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____CommonResultsSeq_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____CommonResultsSeq_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____CommonResultsSeq_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___CommonResultsSeq_notification__item__type._const_tab = ____CommonResultsSeq_notification__item__type_tab
    ___CommonResultsSeq_notification__item__type._const_tab_at = None
    ___CommonResultsSeq_notification__item__type._const_tab_id = u'id'
    ___CommonResultsSeq_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____CommonResultsSeq_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____CommonResultsSeq_notification__item__values__item_._const_tab = ____CommonResultsSeq_notification__item__type_tab
    ____CommonResultsSeq_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____CommonResultsSeq_notification__item__values__item_._const_tab_id = u'Type'
    ___CommonResultsSeq_notification__item__values._cont = ____CommonResultsSeq_notification__item__values__item_
    ___CommonResultsSeq_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___CommonResultsSeq_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____CommonResultsSeq_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____CommonResultsSeq_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____CommonResultsSeq_notification__item__valuesWithContext__item__value._const_tab = ____CommonResultsSeq_notification__item__type_tab
    _____CommonResultsSeq_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____CommonResultsSeq_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____CommonResultsSeq_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______CommonResultsSeq_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____CommonResultsSeq_notification__item__valuesWithContext__item__contextList._cont = ______CommonResultsSeq_notification__item__valuesWithContext__item__contextList__item_
    _____CommonResultsSeq_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____CommonResultsSeq_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____CommonResultsSeq_notification__item__valuesWithContext__item__value),
        (u'contextList', _____CommonResultsSeq_notification__item__valuesWithContext__item__contextList),
        ])
    ____CommonResultsSeq_notification__item__valuesWithContext__item_._ext = []
    ___CommonResultsSeq_notification__item__valuesWithContext._cont = ____CommonResultsSeq_notification__item__valuesWithContext__item_
    ___CommonResultsSeq_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __CommonResultsSeq_notification__item_._cont = ASN1Dict([
        (u'type', ___CommonResultsSeq_notification__item__type),
        (u'values', ___CommonResultsSeq_notification__item__values),
        (u'valuesWithContext', ___CommonResultsSeq_notification__item__valuesWithContext),
        ])
    __CommonResultsSeq_notification__item_._ext = []
    _CommonResultsSeq_notification._cont = __CommonResultsSeq_notification__item_
    _CommonResultsSeq_notification._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    CommonResultsSeq._cont = ASN1Dict([
        (u'securityParameters', _CommonResultsSeq_securityParameters),
        (u'performer', _CommonResultsSeq_performer),
        (u'aliasDereferenced', _CommonResultsSeq_aliasDereferenced),
        (u'notification', _CommonResultsSeq_notification),
        ])
    CommonResultsSeq._ext = []
    
    #-----< ServiceControls >-----#
    ServiceControls = SET(name=u'ServiceControls', mode=MODE_TYPE)
    _ServiceControls_options = BIT_STR(name=u'options', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControlOptions')), default=(0, 0))
    _ServiceControls_priority = INT(name=u'priority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=1)
    _ServiceControls_priority._cont = ASN1Dict([(u'low', 0), (u'medium', 1), (u'high', 2)])
    _ServiceControls_timeLimit = INT(name=u'timeLimit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ServiceControls_sizeLimit = INT(name=u'sizeLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ServiceControls_scopeOfReferral = INT(name=u'scopeOfReferral', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ServiceControls_scopeOfReferral._cont = ASN1Dict([(u'dmd', 0), (u'country', 1)])
    _ServiceControls_attributeSizeLimit = INT(name=u'attributeSizeLimit', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ServiceControls_manageDSAITPlaneRef = SEQ(name=u'manageDSAITPlaneRef', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ServiceControls_manageDSAITPlaneRef_dsaName = CHOICE(name=u'dsaName', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    __ServiceControls_manageDSAITPlaneRef_agreementID = SEQ(name=u'agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _ServiceControls_manageDSAITPlaneRef._cont = ASN1Dict([
        (u'dsaName', __ServiceControls_manageDSAITPlaneRef_dsaName),
        (u'agreementID', __ServiceControls_manageDSAITPlaneRef_agreementID),
        ])
    _ServiceControls_manageDSAITPlaneRef._ext = []
    _ServiceControls_serviceType = OID(name=u'serviceType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ServiceControls_userClass = INT(name=u'userClass', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ServiceControls._cont = ASN1Dict([
        (u'options', _ServiceControls_options),
        (u'priority', _ServiceControls_priority),
        (u'timeLimit', _ServiceControls_timeLimit),
        (u'sizeLimit', _ServiceControls_sizeLimit),
        (u'scopeOfReferral', _ServiceControls_scopeOfReferral),
        (u'attributeSizeLimit', _ServiceControls_attributeSizeLimit),
        (u'manageDSAITPlaneRef', _ServiceControls_manageDSAITPlaneRef),
        (u'serviceType', _ServiceControls_serviceType),
        (u'userClass', _ServiceControls_userClass),
        ])
    ServiceControls._ext = []
    
    #-----< ServiceControlOptions >-----#
    ServiceControlOptions = BIT_STR(name=u'ServiceControlOptions', mode=MODE_TYPE)
    ServiceControlOptions._cont = ASN1Dict([(u'preferChaining', 0), (u'chainingProhibited', 1), (u'localScope', 2), (u'dontUseCopy', 3), (u'dontDereferenceAliases', 4), (u'subentries', 5), (u'copyShallDo', 6), (u'partialNameResolution', 7), (u'manageDSAIT', 8), (u'noSubtypeMatch', 9), (u'noSubtypeSelection', 10), (u'countFamily', 11), (u'dontSelectFriends', 12), (u'dontMatchFriends', 13), (u'allowWriteableCopy', 14)])
    
    #-----< EntryInformationSelection >-----#
    EntryInformationSelection = SET(name=u'EntryInformationSelection', mode=MODE_TYPE)
    _EntryInformationSelection_attributes = CHOICE(name=u'attributes', mode=MODE_TYPE, default=(u'allUserAttributes', 0))
    __EntryInformationSelection_attributes_allUserAttributes = NULL(name=u'allUserAttributes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EntryInformationSelection_attributes_select = SET_OF(name=u'select', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EntryInformationSelection_attributes_select__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    __EntryInformationSelection_attributes_select._cont = ___EntryInformationSelection_attributes_select__item_
    _EntryInformationSelection_attributes._cont = ASN1Dict([
        (u'allUserAttributes', __EntryInformationSelection_attributes_allUserAttributes),
        (u'select', __EntryInformationSelection_attributes_select),
        ])
    _EntryInformationSelection_attributes._ext = None
    _EntryInformationSelection_infoTypes = INT(name=u'infoTypes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=1)
    _EntryInformationSelection_infoTypes._cont = ASN1Dict([(u'attributeTypesOnly', 0), (u'attributeTypesAndValues', 1)])
    _EntryInformationSelection_extraAttributes = CHOICE(name=u'extraAttributes', mode=MODE_TYPE, opt=True)
    __EntryInformationSelection_extraAttributes_allOperationalAttributes = NULL(name=u'allOperationalAttributes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EntryInformationSelection_extraAttributes_select = SET_OF(name=u'select', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EntryInformationSelection_extraAttributes_select__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    __EntryInformationSelection_extraAttributes_select._cont = ___EntryInformationSelection_extraAttributes_select__item_
    __EntryInformationSelection_extraAttributes_select._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryInformationSelection_extraAttributes._cont = ASN1Dict([
        (u'allOperationalAttributes', __EntryInformationSelection_extraAttributes_allOperationalAttributes),
        (u'select', __EntryInformationSelection_extraAttributes_select),
        ])
    _EntryInformationSelection_extraAttributes._ext = None
    _EntryInformationSelection_contextSelection = CHOICE(name=u'contextSelection', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _EntryInformationSelection_returnContexts = BOOL(name=u'returnContexts', mode=MODE_TYPE, default=False)
    _EntryInformationSelection_familyReturn = SEQ(name=u'familyReturn', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyReturn')), default=dict([(u'memberSelect', u'contributingEntriesOnly')]))
    EntryInformationSelection._cont = ASN1Dict([
        (u'attributes', _EntryInformationSelection_attributes),
        (u'infoTypes', _EntryInformationSelection_infoTypes),
        (u'extraAttributes', _EntryInformationSelection_extraAttributes),
        (u'contextSelection', _EntryInformationSelection_contextSelection),
        (u'returnContexts', _EntryInformationSelection_returnContexts),
        (u'familyReturn', _EntryInformationSelection_familyReturn),
        ])
    EntryInformationSelection._ext = None
    
    #-----< ContextSelection >-----#
    ContextSelection = CHOICE(name=u'ContextSelection', mode=MODE_TYPE)
    _ContextSelection_allContexts = NULL(name=u'allContexts', mode=MODE_TYPE)
    _ContextSelection_selectedContexts = SET_OF(name=u'selectedContexts', mode=MODE_TYPE)
    __ContextSelection_selectedContexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'TypeAndContextAssertion')))
    _ContextSelection_selectedContexts._cont = __ContextSelection_selectedContexts__item_
    _ContextSelection_selectedContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ContextSelection._cont = ASN1Dict([
        (u'allContexts', _ContextSelection_allContexts),
        (u'selectedContexts', _ContextSelection_selectedContexts),
        ])
    ContextSelection._ext = []
    
    #-----< TypeAndContextAssertion >-----#
    TypeAndContextAssertion = SEQ(name=u'TypeAndContextAssertion', mode=MODE_TYPE)
    _TypeAndContextAssertion_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _TypeAndContextAssertion_contextAssertions = CHOICE(name=u'contextAssertions', mode=MODE_TYPE)
    __TypeAndContextAssertion_contextAssertions_preference = SEQ_OF(name=u'preference', mode=MODE_TYPE)
    ___TypeAndContextAssertion_contextAssertions_preference__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    __TypeAndContextAssertion_contextAssertions_preference._cont = ___TypeAndContextAssertion_contextAssertions_preference__item_
    __TypeAndContextAssertion_contextAssertions_all = SET_OF(name=u'all', mode=MODE_TYPE)
    ___TypeAndContextAssertion_contextAssertions_all__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    __TypeAndContextAssertion_contextAssertions_all._cont = ___TypeAndContextAssertion_contextAssertions_all__item_
    _TypeAndContextAssertion_contextAssertions._cont = ASN1Dict([
        (u'preference', __TypeAndContextAssertion_contextAssertions_preference),
        (u'all', __TypeAndContextAssertion_contextAssertions_all),
        ])
    _TypeAndContextAssertion_contextAssertions._ext = []
    TypeAndContextAssertion._cont = ASN1Dict([
        (u'type', _TypeAndContextAssertion_type),
        (u'contextAssertions', _TypeAndContextAssertion_contextAssertions),
        ])
    TypeAndContextAssertion._ext = []
    
    #-----< FamilyReturn >-----#
    FamilyReturn = SEQ(name=u'FamilyReturn', mode=MODE_TYPE)
    _FamilyReturn_memberSelect = ENUM(name=u'memberSelect', mode=MODE_TYPE)
    _FamilyReturn_memberSelect._cont = ASN1Dict([(u'contributingEntriesOnly', 1), (u'participatingEntriesOnly', 2), (u'compoundEntry', 3)])
    _FamilyReturn_memberSelect._ext = []
    _FamilyReturn_familySelect = SEQ_OF(name=u'familySelect', mode=MODE_TYPE, opt=True)
    __FamilyReturn_familySelect__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']))
    _FamilyReturn_familySelect._cont = __FamilyReturn_familySelect__item_
    _FamilyReturn_familySelect._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    FamilyReturn._cont = ASN1Dict([
        (u'memberSelect', _FamilyReturn_memberSelect),
        (u'familySelect', _FamilyReturn_familySelect),
        ])
    FamilyReturn._ext = []
    
    #-----< EntryInformation >-----#
    EntryInformation = SEQ(name=u'EntryInformation', mode=MODE_TYPE)
    _EntryInformation_name = CHOICE(name=u'name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _EntryInformation_fromEntry = BOOL(name=u'fromEntry', mode=MODE_TYPE, default=True)
    _EntryInformation_information = SET_OF(name=u'information', mode=MODE_TYPE, opt=True)
    __EntryInformation_information__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___EntryInformation_information__item__attributeType = OID(name=u'attributeType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___EntryInformation_information__item__attribute = SEQ(name=u'attribute', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____EntryInformation_information__item__attribute_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _____EntryInformation_information__item__attribute_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______EntryInformation_information__item__attribute_type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ______EntryInformation_information__item__attribute_type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____EntryInformation_information__item__attribute_type_tab._val = ASN1Set(rv=[dict([(u'Type', ______EntryInformation_information__item__attribute_type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ______EntryInformation_information__item__attribute_type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____EntryInformation_information__item__attribute_type._const_tab = _____EntryInformation_information__item__attribute_type_tab
    ____EntryInformation_information__item__attribute_type._const_tab_at = None
    ____EntryInformation_information__item__attribute_type._const_tab_id = u'id'
    ____EntryInformation_information__item__attribute_values = SET_OF(name=u'values', mode=MODE_TYPE)
    _____EntryInformation_information__item__attribute_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____EntryInformation_information__item__attribute_values__item_._const_tab = _____EntryInformation_information__item__attribute_type_tab
    _____EntryInformation_information__item__attribute_values__item_._const_tab_at = ('..', '..', u'type')
    _____EntryInformation_information__item__attribute_values__item_._const_tab_id = u'Type'
    ____EntryInformation_information__item__attribute_values._cont = _____EntryInformation_information__item__attribute_values__item_
    ____EntryInformation_information__item__attribute_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____EntryInformation_information__item__attribute_valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    _____EntryInformation_information__item__attribute_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______EntryInformation_information__item__attribute_valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ______EntryInformation_information__item__attribute_valuesWithContext__item__value._const_tab = _____EntryInformation_information__item__attribute_type_tab
    ______EntryInformation_information__item__attribute_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    ______EntryInformation_information__item__attribute_valuesWithContext__item__value._const_tab_id = u'Type'
    ______EntryInformation_information__item__attribute_valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    _______EntryInformation_information__item__attribute_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______EntryInformation_information__item__attribute_valuesWithContext__item__contextList._cont = _______EntryInformation_information__item__attribute_valuesWithContext__item__contextList__item_
    ______EntryInformation_information__item__attribute_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____EntryInformation_information__item__attribute_valuesWithContext__item_._cont = ASN1Dict([
        (u'value', ______EntryInformation_information__item__attribute_valuesWithContext__item__value),
        (u'contextList', ______EntryInformation_information__item__attribute_valuesWithContext__item__contextList),
        ])
    _____EntryInformation_information__item__attribute_valuesWithContext__item_._ext = []
    ____EntryInformation_information__item__attribute_valuesWithContext._cont = _____EntryInformation_information__item__attribute_valuesWithContext__item_
    ____EntryInformation_information__item__attribute_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___EntryInformation_information__item__attribute._cont = ASN1Dict([
        (u'type', ____EntryInformation_information__item__attribute_type),
        (u'values', ____EntryInformation_information__item__attribute_values),
        (u'valuesWithContext', ____EntryInformation_information__item__attribute_valuesWithContext),
        ])
    ___EntryInformation_information__item__attribute._ext = []
    __EntryInformation_information__item_._cont = ASN1Dict([
        (u'attributeType', ___EntryInformation_information__item__attributeType),
        (u'attribute', ___EntryInformation_information__item__attribute),
        ])
    __EntryInformation_information__item_._ext = []
    _EntryInformation_information._cont = __EntryInformation_information__item_
    _EntryInformation_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryInformation_incompleteEntry = BOOL(name=u'incompleteEntry', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _EntryInformation_partialName = BOOL(name=u'partialName', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _EntryInformation_derivedEntry = BOOL(name=u'derivedEntry', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    EntryInformation._cont = ASN1Dict([
        (u'name', _EntryInformation_name),
        (u'fromEntry', _EntryInformation_fromEntry),
        (u'information', _EntryInformation_information),
        (u'incompleteEntry', _EntryInformation_incompleteEntry),
        (u'partialName', _EntryInformation_partialName),
        (u'derivedEntry', _EntryInformation_derivedEntry),
        ])
    EntryInformation._ext = []
    
    #-----< family-information >-----#
    family_information = CLASS(name=u'family-information', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _family_information_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyEntries')))
    family_information._val = dict([(u'Type', _family_information_val_Type), (u'usage', u'directoryOperation'), (u'id', (2, 5, 4, 64))])
    
    #-----< FamilyEntries >-----#
    FamilyEntries = SEQ(name=u'FamilyEntries', mode=MODE_TYPE)
    _FamilyEntries_family_class = OID(name=u'family-class', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']))
    _FamilyEntries_familyEntries = SEQ_OF(name=u'familyEntries', mode=MODE_TYPE)
    __FamilyEntries_familyEntries__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyEntry')))
    _FamilyEntries_familyEntries._cont = __FamilyEntries_familyEntries__item_
    FamilyEntries._cont = ASN1Dict([
        (u'family-class', _FamilyEntries_family_class),
        (u'familyEntries', _FamilyEntries_familyEntries),
        ])
    FamilyEntries._ext = []
    
    #-----< FamilyEntry >-----#
    FamilyEntry = SEQ(name=u'FamilyEntry', mode=MODE_TYPE)
    _FamilyEntry_rdn = SET_OF(name=u'rdn', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _FamilyEntry_information = SEQ_OF(name=u'information', mode=MODE_TYPE)
    __FamilyEntry_information__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___FamilyEntry_information__item__attributeType = OID(name=u'attributeType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___FamilyEntry_information__item__attribute = SEQ(name=u'attribute', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____FamilyEntry_information__item__attribute_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _____FamilyEntry_information__item__attribute_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______FamilyEntry_information__item__attribute_type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ______FamilyEntry_information__item__attribute_type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____FamilyEntry_information__item__attribute_type_tab._val = ASN1Set(rv=[dict([(u'Type', ______FamilyEntry_information__item__attribute_type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ______FamilyEntry_information__item__attribute_type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____FamilyEntry_information__item__attribute_type._const_tab = _____FamilyEntry_information__item__attribute_type_tab
    ____FamilyEntry_information__item__attribute_type._const_tab_at = None
    ____FamilyEntry_information__item__attribute_type._const_tab_id = u'id'
    ____FamilyEntry_information__item__attribute_values = SET_OF(name=u'values', mode=MODE_TYPE)
    _____FamilyEntry_information__item__attribute_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____FamilyEntry_information__item__attribute_values__item_._const_tab = _____FamilyEntry_information__item__attribute_type_tab
    _____FamilyEntry_information__item__attribute_values__item_._const_tab_at = ('..', '..', u'type')
    _____FamilyEntry_information__item__attribute_values__item_._const_tab_id = u'Type'
    ____FamilyEntry_information__item__attribute_values._cont = _____FamilyEntry_information__item__attribute_values__item_
    ____FamilyEntry_information__item__attribute_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____FamilyEntry_information__item__attribute_valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    _____FamilyEntry_information__item__attribute_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__value._const_tab = _____FamilyEntry_information__item__attribute_type_tab
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__value._const_tab_id = u'Type'
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    _______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList._cont = _______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList__item_
    ______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____FamilyEntry_information__item__attribute_valuesWithContext__item_._cont = ASN1Dict([
        (u'value', ______FamilyEntry_information__item__attribute_valuesWithContext__item__value),
        (u'contextList', ______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList),
        ])
    _____FamilyEntry_information__item__attribute_valuesWithContext__item_._ext = []
    ____FamilyEntry_information__item__attribute_valuesWithContext._cont = _____FamilyEntry_information__item__attribute_valuesWithContext__item_
    ____FamilyEntry_information__item__attribute_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___FamilyEntry_information__item__attribute._cont = ASN1Dict([
        (u'type', ____FamilyEntry_information__item__attribute_type),
        (u'values', ____FamilyEntry_information__item__attribute_values),
        (u'valuesWithContext', ____FamilyEntry_information__item__attribute_valuesWithContext),
        ])
    ___FamilyEntry_information__item__attribute._ext = []
    __FamilyEntry_information__item_._cont = ASN1Dict([
        (u'attributeType', ___FamilyEntry_information__item__attributeType),
        (u'attribute', ___FamilyEntry_information__item__attribute),
        ])
    __FamilyEntry_information__item_._ext = []
    _FamilyEntry_information._cont = __FamilyEntry_information__item_
    _FamilyEntry_family_info = SEQ_OF(name=u'family-info', mode=MODE_TYPE, opt=True)
    __FamilyEntry_family_info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyEntries')))
    _FamilyEntry_family_info._cont = __FamilyEntry_family_info__item_
    _FamilyEntry_family_info._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    FamilyEntry._cont = ASN1Dict([
        (u'rdn', _FamilyEntry_rdn),
        (u'information', _FamilyEntry_information),
        (u'family-info', _FamilyEntry_family_info),
        ])
    FamilyEntry._ext = []
    
    #-----< Filter >-----#
    Filter = CHOICE(name=u'Filter', mode=MODE_TYPE)
    _Filter_item = CHOICE(name=u'item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FilterItem')))
    _Filter_and_ = SET_OF(name=u'and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Filter_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')))
    _Filter_and_._cont = __Filter_and___item_
    _Filter_or_ = SET_OF(name=u'or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Filter_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')))
    _Filter_or_._cont = __Filter_or___item_
    _Filter_not_ = CHOICE(name=u'not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')))
    Filter._cont = ASN1Dict([
        (u'item', _Filter_item),
        (u'and', _Filter_and_),
        (u'or', _Filter_or_),
        (u'not', _Filter_not_),
        ])
    Filter._ext = []
    
    #-----< FilterItem >-----#
    FilterItem = CHOICE(name=u'FilterItem', mode=MODE_TYPE)
    _FilterItem_equality = SEQ(name=u'equality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _FilterItem_substrings = SEQ(name=u'substrings', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __FilterItem_substrings_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ___FilterItem_substrings_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ____FilterItem_substrings_type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ____FilterItem_substrings_type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ___FilterItem_substrings_type_tab._val = ASN1Set(rv=[dict([(u'Type', ____FilterItem_substrings_type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ____FilterItem_substrings_type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    __FilterItem_substrings_type._const_tab = ___FilterItem_substrings_type_tab
    __FilterItem_substrings_type._const_tab_at = None
    __FilterItem_substrings_type._const_tab_id = u'id'
    __FilterItem_substrings_strings = SEQ_OF(name=u'strings', mode=MODE_TYPE)
    ___FilterItem_substrings_strings__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ____FilterItem_substrings_strings__item__initial = OPEN(name=u'initial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____FilterItem_substrings_strings__item__initial._const_tab = ___FilterItem_substrings_type_tab
    ____FilterItem_substrings_strings__item__initial._const_tab_at = ('..', '..', '..', '..', u'substrings', u'type')
    ____FilterItem_substrings_strings__item__initial._const_tab_id = u'Type'
    ____FilterItem_substrings_strings__item__any = OPEN(name=u'any', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____FilterItem_substrings_strings__item__any._const_tab = ___FilterItem_substrings_type_tab
    ____FilterItem_substrings_strings__item__any._const_tab_at = ('..', '..', '..', '..', u'substrings', u'type')
    ____FilterItem_substrings_strings__item__any._const_tab_id = u'Type'
    ____FilterItem_substrings_strings__item__final = OPEN(name=u'final', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____FilterItem_substrings_strings__item__final._const_tab = ___FilterItem_substrings_type_tab
    ____FilterItem_substrings_strings__item__final._const_tab_at = ('..', '..', '..', '..', u'substrings', u'type')
    ____FilterItem_substrings_strings__item__final._const_tab_id = u'Type'
    ____FilterItem_substrings_strings__item__control = SEQ(name=u'control', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    _____FilterItem_substrings_strings__item__control_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _____FilterItem_substrings_strings__item__control_type._const_tab = ___FilterItem_substrings_type_tab
    _____FilterItem_substrings_strings__item__control_type._const_tab_at = None
    _____FilterItem_substrings_strings__item__control_type._const_tab_id = u'id'
    _____FilterItem_substrings_strings__item__control_values = SET_OF(name=u'values', mode=MODE_TYPE)
    ______FilterItem_substrings_strings__item__control_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ______FilterItem_substrings_strings__item__control_values__item_._const_tab = ___FilterItem_substrings_type_tab
    ______FilterItem_substrings_strings__item__control_values__item_._const_tab_at = ('..', '..', u'type')
    ______FilterItem_substrings_strings__item__control_values__item_._const_tab_id = u'Type'
    _____FilterItem_substrings_strings__item__control_values._cont = ______FilterItem_substrings_strings__item__control_values__item_
    _____FilterItem_substrings_strings__item__control_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _____FilterItem_substrings_strings__item__control_valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ______FilterItem_substrings_strings__item__control_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value._const_tab = ___FilterItem_substrings_type_tab
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value._const_tab_id = u'Type'
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ________FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList._cont = ________FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList__item_
    _______FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ______FilterItem_substrings_strings__item__control_valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value),
        (u'contextList', _______FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList),
        ])
    ______FilterItem_substrings_strings__item__control_valuesWithContext__item_._ext = []
    _____FilterItem_substrings_strings__item__control_valuesWithContext._cont = ______FilterItem_substrings_strings__item__control_valuesWithContext__item_
    _____FilterItem_substrings_strings__item__control_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____FilterItem_substrings_strings__item__control._cont = ASN1Dict([
        (u'type', _____FilterItem_substrings_strings__item__control_type),
        (u'values', _____FilterItem_substrings_strings__item__control_values),
        (u'valuesWithContext', _____FilterItem_substrings_strings__item__control_valuesWithContext),
        ])
    ____FilterItem_substrings_strings__item__control._ext = []
    ___FilterItem_substrings_strings__item_._cont = ASN1Dict([
        (u'initial', ____FilterItem_substrings_strings__item__initial),
        (u'any', ____FilterItem_substrings_strings__item__any),
        (u'final', ____FilterItem_substrings_strings__item__final),
        (u'control', ____FilterItem_substrings_strings__item__control),
        ])
    ___FilterItem_substrings_strings__item_._ext = []
    __FilterItem_substrings_strings._cont = ___FilterItem_substrings_strings__item_
    _FilterItem_substrings._cont = ASN1Dict([
        (u'type', __FilterItem_substrings_type),
        (u'strings', __FilterItem_substrings_strings),
        ])
    _FilterItem_substrings._ext = []
    _FilterItem_greaterOrEqual = SEQ(name=u'greaterOrEqual', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _FilterItem_lessOrEqual = SEQ(name=u'lessOrEqual', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _FilterItem_present = OID(name=u'present', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _FilterItem_approximateMatch = SEQ(name=u'approximateMatch', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _FilterItem_extensibleMatch = SEQ(name=u'extensibleMatch', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'MatchingRuleAssertion')))
    _FilterItem_contextPresent = SEQ(name=u'contextPresent', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAssertion')))
    FilterItem._cont = ASN1Dict([
        (u'equality', _FilterItem_equality),
        (u'substrings', _FilterItem_substrings),
        (u'greaterOrEqual', _FilterItem_greaterOrEqual),
        (u'lessOrEqual', _FilterItem_lessOrEqual),
        (u'present', _FilterItem_present),
        (u'approximateMatch', _FilterItem_approximateMatch),
        (u'extensibleMatch', _FilterItem_extensibleMatch),
        (u'contextPresent', _FilterItem_contextPresent),
        ])
    FilterItem._ext = []
    
    #-----< MatchingRuleAssertion >-----#
    MatchingRuleAssertion = SEQ(name=u'MatchingRuleAssertion', mode=MODE_TYPE)
    _MatchingRuleAssertion_matchingRule = SET_OF(name=u'matchingRule', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MatchingRuleAssertion_matchingRule__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), [u'id']))
    _MatchingRuleAssertion_matchingRule._cont = __MatchingRuleAssertion_matchingRule__item_
    _MatchingRuleAssertion_matchingRule._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _MatchingRuleAssertion_type = OID(name=u'type', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')), opt=True)
    _MatchingRuleAssertion_matchValue = OPEN(name=u'matchValue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), [u'AssertionType']))
    _MatchingRuleAssertion_dnAttributes = BOOL(name=u'dnAttributes', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    MatchingRuleAssertion._cont = ASN1Dict([
        (u'matchingRule', _MatchingRuleAssertion_matchingRule),
        (u'type', _MatchingRuleAssertion_type),
        (u'matchValue', _MatchingRuleAssertion_matchValue),
        (u'dnAttributes', _MatchingRuleAssertion_dnAttributes),
        ])
    MatchingRuleAssertion._ext = []
    
    #-----< PagedResultsRequest >-----#
    PagedResultsRequest = CHOICE(name=u'PagedResultsRequest', mode=MODE_TYPE)
    _PagedResultsRequest_newRequest = SEQ(name=u'newRequest', mode=MODE_TYPE)
    __PagedResultsRequest_newRequest_pageSize = INT(name=u'pageSize', mode=MODE_TYPE)
    __PagedResultsRequest_newRequest_sortKeys = SEQ_OF(name=u'sortKeys', mode=MODE_TYPE, opt=True)
    ___PagedResultsRequest_newRequest_sortKeys__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SortKey')))
    __PagedResultsRequest_newRequest_sortKeys._cont = ___PagedResultsRequest_newRequest_sortKeys__item_
    __PagedResultsRequest_newRequest_sortKeys._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __PagedResultsRequest_newRequest_reverse = BOOL(name=u'reverse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    __PagedResultsRequest_newRequest_unmerged = BOOL(name=u'unmerged', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    __PagedResultsRequest_newRequest_pageNumber = INT(name=u'pageNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PagedResultsRequest_newRequest._cont = ASN1Dict([
        (u'pageSize', __PagedResultsRequest_newRequest_pageSize),
        (u'sortKeys', __PagedResultsRequest_newRequest_sortKeys),
        (u'reverse', __PagedResultsRequest_newRequest_reverse),
        (u'unmerged', __PagedResultsRequest_newRequest_unmerged),
        (u'pageNumber', __PagedResultsRequest_newRequest_pageNumber),
        ])
    _PagedResultsRequest_newRequest._ext = []
    _PagedResultsRequest_queryReference = OCT_STR(name=u'queryReference', mode=MODE_TYPE)
    _PagedResultsRequest_abandonQuery = OCT_STR(name=u'abandonQuery', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    PagedResultsRequest._cont = ASN1Dict([
        (u'newRequest', _PagedResultsRequest_newRequest),
        (u'queryReference', _PagedResultsRequest_queryReference),
        (u'abandonQuery', _PagedResultsRequest_abandonQuery),
        ])
    PagedResultsRequest._ext = []
    
    #-----< SortKey >-----#
    SortKey = SEQ(name=u'SortKey', mode=MODE_TYPE)
    _SortKey_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _SortKey_orderingRule = OID(name=u'orderingRule', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), [u'id']), opt=True)
    SortKey._cont = ASN1Dict([
        (u'type', _SortKey_type),
        (u'orderingRule', _SortKey_orderingRule),
        ])
    SortKey._ext = []
    
    #-----< SecurityParameters >-----#
    SecurityParameters = SET(name=u'SecurityParameters', mode=MODE_TYPE)
    _SecurityParameters_certification_path = SEQ(name=u'certification-path', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificationPath')), opt=True)
    _SecurityParameters_name = SEQ_OF(name=u'name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _SecurityParameters_time = CHOICE(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Time')), opt=True)
    _SecurityParameters_random = BIT_STR(name=u'random', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SecurityParameters_target = INT(name=u'target', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ProtectionRequest')), opt=True)
    _SecurityParameters_operationCode = CHOICE(name=u'operationCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')), opt=True)
    _SecurityParameters_errorProtection = INT(name=u'errorProtection', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ErrorProtectionRequest')), opt=True)
    _SecurityParameters_errorCode = CHOICE(name=u'errorCode', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CommonProtocolSpecification', 'Code')), opt=True)
    SecurityParameters._cont = ASN1Dict([
        (u'certification-path', _SecurityParameters_certification_path),
        (u'name', _SecurityParameters_name),
        (u'time', _SecurityParameters_time),
        (u'random', _SecurityParameters_random),
        (u'target', _SecurityParameters_target),
        (u'operationCode', _SecurityParameters_operationCode),
        (u'errorProtection', _SecurityParameters_errorProtection),
        (u'errorCode', _SecurityParameters_errorCode),
        ])
    SecurityParameters._ext = []
    
    #-----< ProtectionRequest >-----#
    ProtectionRequest = INT(name=u'ProtectionRequest', mode=MODE_TYPE)
    ProtectionRequest._cont = ASN1Dict([(u'none', 0), (u'signed', 1)])
    
    #-----< Time >-----#
    Time = CHOICE(name=u'Time', mode=MODE_TYPE)
    _Time_utcTime = TIME_UTC(name=u'utcTime', mode=MODE_TYPE)
    _Time_generalizedTime = TIME_GEN(name=u'generalizedTime', mode=MODE_TYPE)
    Time._cont = ASN1Dict([
        (u'utcTime', _Time_utcTime),
        (u'generalizedTime', _Time_generalizedTime),
        ])
    Time._ext = []
    
    #-----< ErrorProtectionRequest >-----#
    ErrorProtectionRequest = INT(name=u'ErrorProtectionRequest', mode=MODE_TYPE)
    ErrorProtectionRequest._cont = ASN1Dict([(u'none', 0), (u'signed', 1)])
    
    #-----< directoryBind >-----#
    directoryBind = CLASS(name=u'directoryBind', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _directoryBind_val_ArgumentType = SET(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'DirectoryBindArgument')))
    _directoryBind_val_ResultType = SET(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'DirectoryBindResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_unsigned_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error = CHOICE(name=u'error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError = INT(name=u'serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError = INT(name=u'securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._cont = ASN1Dict([
        (u'serviceError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError),
        (u'securityError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_unsigned._cont = ASN1Dict([
        (u'versions', ____OPERATION_Errors_val_ParameterType_0_unsigned_versions),
        (u'error', ____OPERATION_Errors_val_ParameterType_0_unsigned_error),
        (u'securityParameters', ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error = CHOICE(name=u'error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError = INT(name=u'serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError = INT(name=u'securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._cont = ASN1Dict([
        (u'serviceError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError),
        (u'securityError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._cont = ASN1Dict([
        (u'versions', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions),
        (u'error', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error),
        (u'securityParameters', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    directoryBind._val = dict([(u'ArgumentType', _directoryBind_val_ArgumentType), (u'ResultType', _directoryBind_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])
    
    #-----< DirectoryBindArgument >-----#
    DirectoryBindArgument = SET(name=u'DirectoryBindArgument', mode=MODE_TYPE)
    _DirectoryBindArgument_credentials = CHOICE(name=u'credentials', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Credentials')), opt=True)
    _DirectoryBindArgument_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    DirectoryBindArgument._cont = ASN1Dict([
        (u'credentials', _DirectoryBindArgument_credentials),
        (u'versions', _DirectoryBindArgument_versions),
        ])
    DirectoryBindArgument._ext = []
    
    #-----< Credentials >-----#
    Credentials = CHOICE(name=u'Credentials', mode=MODE_TYPE)
    _Credentials_simple = SEQ(name=u'simple', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SimpleCredentials')))
    _Credentials_strong = SET(name=u'strong', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'StrongCredentials')))
    _Credentials_externalProcedure = EXT(name=u'externalProcedure', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _Credentials_spkm = CHOICE(name=u'spkm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SpkmCredentials')))
    _Credentials_sasl = SEQ(name=u'sasl', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SaslCredentials')))
    Credentials._cont = ASN1Dict([
        (u'simple', _Credentials_simple),
        (u'strong', _Credentials_strong),
        (u'externalProcedure', _Credentials_externalProcedure),
        (u'spkm', _Credentials_spkm),
        (u'sasl', _Credentials_sasl),
        ])
    Credentials._ext = []
    
    #-----< SimpleCredentials >-----#
    SimpleCredentials = SEQ(name=u'SimpleCredentials', mode=MODE_TYPE)
    _SimpleCredentials_name = SEQ_OF(name=u'name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _SimpleCredentials_validity = SET(name=u'validity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SimpleCredentials_validity_time1 = CHOICE(name=u'time1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___SimpleCredentials_validity_time1_utc = TIME_UTC(name=u'utc', mode=MODE_TYPE)
    ___SimpleCredentials_validity_time1_gt = TIME_GEN(name=u'gt', mode=MODE_TYPE)
    __SimpleCredentials_validity_time1._cont = ASN1Dict([
        (u'utc', ___SimpleCredentials_validity_time1_utc),
        (u'gt', ___SimpleCredentials_validity_time1_gt),
        ])
    __SimpleCredentials_validity_time1._ext = None
    __SimpleCredentials_validity_time2 = CHOICE(name=u'time2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___SimpleCredentials_validity_time2_utc = TIME_UTC(name=u'utc', mode=MODE_TYPE)
    ___SimpleCredentials_validity_time2_gt = TIME_GEN(name=u'gt', mode=MODE_TYPE)
    __SimpleCredentials_validity_time2._cont = ASN1Dict([
        (u'utc', ___SimpleCredentials_validity_time2_utc),
        (u'gt', ___SimpleCredentials_validity_time2_gt),
        ])
    __SimpleCredentials_validity_time2._ext = None
    __SimpleCredentials_validity_random1 = BIT_STR(name=u'random1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SimpleCredentials_validity_random2 = BIT_STR(name=u'random2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SimpleCredentials_validity._cont = ASN1Dict([
        (u'time1', __SimpleCredentials_validity_time1),
        (u'time2', __SimpleCredentials_validity_time2),
        (u'random1', __SimpleCredentials_validity_random1),
        (u'random2', __SimpleCredentials_validity_random2),
        ])
    _SimpleCredentials_validity._ext = None
    _SimpleCredentials_password = CHOICE(name=u'password', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SimpleCredentials_password_unprotected = OCT_STR(name=u'unprotected', mode=MODE_TYPE)
    __SimpleCredentials_password_protected = SEQ(name=u'protected', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'HASH')))
    ___SimpleCredentials_password_protected_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____SimpleCredentials_password_protected_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____SimpleCredentials_password_protected_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm._const_tab = _____SimpleCredentials_password_protected_algorithmIdentifier_algorithm_tab
    ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm._const_tab_at = None
    ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____SimpleCredentials_password_protected_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____SimpleCredentials_password_protected_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____SimpleCredentials_password_protected_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SimpleCredentials_password_protected_algorithmIdentifier_parameters._const_tab = _____SimpleCredentials_password_protected_algorithmIdentifier_parameters_tab
    ____SimpleCredentials_password_protected_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____SimpleCredentials_password_protected_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___SimpleCredentials_password_protected_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm),
        (u'parameters', ____SimpleCredentials_password_protected_algorithmIdentifier_parameters),
        ])
    ___SimpleCredentials_password_protected_algorithmIdentifier._ext = []
    ___SimpleCredentials_password_protected_hashValue = BIT_STR(name=u'hashValue', mode=MODE_TYPE)
    __SimpleCredentials_password_protected._cont = ASN1Dict([
        (u'algorithmIdentifier', ___SimpleCredentials_password_protected_algorithmIdentifier),
        (u'hashValue', ___SimpleCredentials_password_protected_hashValue),
        ])
    __SimpleCredentials_password_protected._ext = []
    __SimpleCredentials_password_userPwd = CHOICE(name=u'userPwd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    _SimpleCredentials_password._cont = ASN1Dict([
        (u'unprotected', __SimpleCredentials_password_unprotected),
        (u'protected', __SimpleCredentials_password_protected),
        (u'userPwd', __SimpleCredentials_password_userPwd),
        ])
    _SimpleCredentials_password._ext = [u'userPwd']
    SimpleCredentials._cont = ASN1Dict([
        (u'name', _SimpleCredentials_name),
        (u'validity', _SimpleCredentials_validity),
        (u'password', _SimpleCredentials_password),
        ])
    SimpleCredentials._ext = None
    
    #-----< StrongCredentials >-----#
    StrongCredentials = SET(name=u'StrongCredentials', mode=MODE_TYPE)
    _StrongCredentials_certification_path = SEQ(name=u'certification-path', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificationPath')), opt=True)
    _StrongCredentials_bind_token = SEQ(name=u'bind-token', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Token')))
    _StrongCredentials_name = SEQ_OF(name=u'name', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _StrongCredentials_attributeCertificationPath = SEQ(name=u'attributeCertificationPath', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AttributeCertificateDefinitions', 'AttributeCertificationPath')), opt=True)
    StrongCredentials._cont = ASN1Dict([
        (u'certification-path', _StrongCredentials_certification_path),
        (u'bind-token', _StrongCredentials_bind_token),
        (u'name', _StrongCredentials_name),
        (u'attributeCertificationPath', _StrongCredentials_attributeCertificationPath),
        ])
    StrongCredentials._ext = []
    
    #-----< SpkmCredentials >-----#
    SpkmCredentials = CHOICE(name=u'SpkmCredentials', mode=MODE_TYPE)
    _SpkmCredentials_req = SEQ(name=u'req', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-REQ')))
    _SpkmCredentials_rep = SEQ(name=u'rep', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-REP-TI')))
    SpkmCredentials._cont = ASN1Dict([
        (u'req', _SpkmCredentials_req),
        (u'rep', _SpkmCredentials_rep),
        ])
    SpkmCredentials._ext = []
    
    #-----< SaslCredentials >-----#
    SaslCredentials = SEQ(name=u'SaslCredentials', mode=MODE_TYPE)
    _SaslCredentials_mechanism = CHOICE(name=u'mechanism', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'DirectoryString')))
    __SaslCredentials_mechanism_teletexString = STR_TELE(name=u'teletexString', mode=MODE_TYPE)
    __SaslCredentials_mechanism_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __SaslCredentials_mechanism_printableString = STR_PRINT(name=u'printableString', mode=MODE_TYPE)
    __SaslCredentials_mechanism_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __SaslCredentials_mechanism_bmpString = STR_BMP(name=u'bmpString', mode=MODE_TYPE)
    __SaslCredentials_mechanism_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __SaslCredentials_mechanism_universalString = STR_UNIV(name=u'universalString', mode=MODE_TYPE)
    __SaslCredentials_mechanism_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __SaslCredentials_mechanism_uTF8String = STR_UTF8(name=u'uTF8String', mode=MODE_TYPE)
    __SaslCredentials_mechanism_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    _SaslCredentials_mechanism._cont = ASN1Dict([
        (u'teletexString', __SaslCredentials_mechanism_teletexString),
        (u'printableString', __SaslCredentials_mechanism_printableString),
        (u'bmpString', __SaslCredentials_mechanism_bmpString),
        (u'universalString', __SaslCredentials_mechanism_universalString),
        (u'uTF8String', __SaslCredentials_mechanism_uTF8String),
        ])
    _SaslCredentials_mechanism._ext = None
    _SaslCredentials_credentials = OCT_STR(name=u'credentials', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SaslCredentials_saslAbort = BOOL(name=u'saslAbort', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    SaslCredentials._cont = ASN1Dict([
        (u'mechanism', _SaslCredentials_mechanism),
        (u'credentials', _SaslCredentials_credentials),
        (u'saslAbort', _SaslCredentials_saslAbort),
        ])
    SaslCredentials._ext = []
    
    #-----< ub-saslMechanism >-----#
    ub_saslMechanism = INT(name=u'ub-saslMechanism', mode=MODE_VALUE)
    ub_saslMechanism._val = 20
    
    #-----< Token >-----#
    Token = SEQ(name=u'Token', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _Token_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'TokenContent')))
    _Token_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __Token_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___Token_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Token_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Token_algorithmIdentifier_algorithm._const_tab = ___Token_algorithmIdentifier_algorithm_tab
    __Token_algorithmIdentifier_algorithm._const_tab_at = None
    __Token_algorithmIdentifier_algorithm._const_tab_id = u'id'
    __Token_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___Token_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Token_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Token_algorithmIdentifier_parameters._const_tab = ___Token_algorithmIdentifier_parameters_tab
    __Token_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    __Token_algorithmIdentifier_parameters._const_tab_id = u'Type'
    _Token_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', __Token_algorithmIdentifier_algorithm),
        (u'parameters', __Token_algorithmIdentifier_parameters),
        ])
    _Token_algorithmIdentifier._ext = []
    _Token_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    Token._cont = ASN1Dict([
        (u'toBeSigned', _Token_toBeSigned),
        (u'algorithmIdentifier', _Token_algorithmIdentifier),
        (u'signature', _Token_signature),
        ])
    Token._ext = []
    
    #-----< TokenContent >-----#
    TokenContent = SEQ(name=u'TokenContent', mode=MODE_TYPE)
    _TokenContent_algorithm = SEQ(name=u'algorithm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __TokenContent_algorithm_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___TokenContent_algorithm_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TokenContent_algorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TokenContent_algorithm_algorithm._const_tab = ___TokenContent_algorithm_algorithm_tab
    __TokenContent_algorithm_algorithm._const_tab_at = None
    __TokenContent_algorithm_algorithm._const_tab_id = u'id'
    __TokenContent_algorithm_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___TokenContent_algorithm_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___TokenContent_algorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TokenContent_algorithm_parameters._const_tab = ___TokenContent_algorithm_parameters_tab
    __TokenContent_algorithm_parameters._const_tab_at = ('..', u'algorithm')
    __TokenContent_algorithm_parameters._const_tab_id = u'Type'
    _TokenContent_algorithm._cont = ASN1Dict([
        (u'algorithm', __TokenContent_algorithm_algorithm),
        (u'parameters', __TokenContent_algorithm_parameters),
        ])
    _TokenContent_algorithm._ext = []
    _TokenContent_name = SEQ_OF(name=u'name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _TokenContent_time = CHOICE(name=u'time', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Time')))
    _TokenContent_random = BIT_STR(name=u'random', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _TokenContent_response = BIT_STR(name=u'response', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    TokenContent._cont = ASN1Dict([
        (u'algorithm', _TokenContent_algorithm),
        (u'name', _TokenContent_name),
        (u'time', _TokenContent_time),
        (u'random', _TokenContent_random),
        (u'response', _TokenContent_response),
        ])
    TokenContent._ext = []
    
    #-----< Versions >-----#
    Versions = BIT_STR(name=u'Versions', mode=MODE_TYPE)
    Versions._cont = ASN1Dict([(u'v1', 0), (u'v2', 1)])
    
    #-----< DirectoryBindResult >-----#
    DirectoryBindResult = SET(name=u'DirectoryBindResult', mode=MODE_TYPE)
    _DirectoryBindResult_credentials = CHOICE(name=u'credentials', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Credentials')), opt=True)
    _DirectoryBindResult_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _DirectoryBindResult_pwdResponseValue = SEQ(name=u'pwdResponseValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'PwdResponseValue')), opt=True)
    DirectoryBindResult._cont = ASN1Dict([
        (u'credentials', _DirectoryBindResult_credentials),
        (u'versions', _DirectoryBindResult_versions),
        (u'pwdResponseValue', _DirectoryBindResult_pwdResponseValue),
        ])
    DirectoryBindResult._ext = [u'pwdResponseValue']
    
    #-----< PwdResponseValue >-----#
    PwdResponseValue = SEQ(name=u'PwdResponseValue', mode=MODE_TYPE)
    _PwdResponseValue_warning = CHOICE(name=u'warning', mode=MODE_TYPE, opt=True)
    __PwdResponseValue_warning_timeLeft = INT(name=u'timeLeft', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PwdResponseValue_warning_timeLeft._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __PwdResponseValue_warning_graceRemaining = INT(name=u'graceRemaining', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PwdResponseValue_warning_graceRemaining._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _PwdResponseValue_warning._cont = ASN1Dict([
        (u'timeLeft', __PwdResponseValue_warning_timeLeft),
        (u'graceRemaining', __PwdResponseValue_warning_graceRemaining),
        ])
    _PwdResponseValue_warning._ext = []
    _PwdResponseValue_error = ENUM(name=u'error', mode=MODE_TYPE, opt=True)
    _PwdResponseValue_error._cont = ASN1Dict([(u'passwordExpired', 0), (u'changeAfterReset', 1)])
    _PwdResponseValue_error._ext = []
    PwdResponseValue._cont = ASN1Dict([
        (u'warning', _PwdResponseValue_warning),
        (u'error', _PwdResponseValue_error),
        ])
    PwdResponseValue._ext = None
    
    #-----< directoryBindError >-----#
    directoryBindError = CLASS(name=u'directoryBindError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _directoryBindError_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __directoryBindError_val_ParameterType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___directoryBindError_val_ParameterType_unsigned_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ___directoryBindError_val_ParameterType_unsigned_error = CHOICE(name=u'error', mode=MODE_TYPE)
    ____directoryBindError_val_ParameterType_unsigned_error_serviceError = INT(name=u'serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ____directoryBindError_val_ParameterType_unsigned_error_securityError = INT(name=u'securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ___directoryBindError_val_ParameterType_unsigned_error._cont = ASN1Dict([
        (u'serviceError', ____directoryBindError_val_ParameterType_unsigned_error_serviceError),
        (u'securityError', ____directoryBindError_val_ParameterType_unsigned_error_securityError),
        ])
    ___directoryBindError_val_ParameterType_unsigned_error._ext = []
    ___directoryBindError_val_ParameterType_unsigned_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    __directoryBindError_val_ParameterType_unsigned._cont = ASN1Dict([
        (u'versions', ___directoryBindError_val_ParameterType_unsigned_versions),
        (u'error', ___directoryBindError_val_ParameterType_unsigned_error),
        (u'securityParameters', ___directoryBindError_val_ParameterType_unsigned_securityParameters),
        ])
    __directoryBindError_val_ParameterType_unsigned._ext = None
    __directoryBindError_val_ParameterType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___directoryBindError_val_ParameterType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____directoryBindError_val_ParameterType_signed_toBeSigned_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____directoryBindError_val_ParameterType_signed_toBeSigned_error = CHOICE(name=u'error', mode=MODE_TYPE)
    _____directoryBindError_val_ParameterType_signed_toBeSigned_error_serviceError = INT(name=u'serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____directoryBindError_val_ParameterType_signed_toBeSigned_error_securityError = INT(name=u'securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____directoryBindError_val_ParameterType_signed_toBeSigned_error._cont = ASN1Dict([
        (u'serviceError', _____directoryBindError_val_ParameterType_signed_toBeSigned_error_serviceError),
        (u'securityError', _____directoryBindError_val_ParameterType_signed_toBeSigned_error_securityError),
        ])
    ____directoryBindError_val_ParameterType_signed_toBeSigned_error._ext = []
    ____directoryBindError_val_ParameterType_signed_toBeSigned_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___directoryBindError_val_ParameterType_signed_toBeSigned._cont = ASN1Dict([
        (u'versions', ____directoryBindError_val_ParameterType_signed_toBeSigned_versions),
        (u'error', ____directoryBindError_val_ParameterType_signed_toBeSigned_error),
        (u'securityParameters', ____directoryBindError_val_ParameterType_signed_toBeSigned_securityParameters),
        ])
    ___directoryBindError_val_ParameterType_signed_toBeSigned._ext = None
    ___directoryBindError_val_ParameterType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___directoryBindError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___directoryBindError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___directoryBindError_val_ParameterType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __directoryBindError_val_ParameterType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___directoryBindError_val_ParameterType_signed_toBeSigned),
        (u'algorithmIdentifier', ___directoryBindError_val_ParameterType_signed_algorithmIdentifier),
        (u'signature', ___directoryBindError_val_ParameterType_signed_signature),
        ])
    __directoryBindError_val_ParameterType_signed._ext = []
    _directoryBindError_val_ParameterType._cont = ASN1Dict([
        (u'unsigned', __directoryBindError_val_ParameterType_unsigned),
        (u'signed', __directoryBindError_val_ParameterType_signed),
        ])
    _directoryBindError_val_ParameterType._ext = None
    directoryBindError._val = dict([(u'ParameterType', _directoryBindError_val_ParameterType)])
    
    #-----< BindKeyInfo >-----#
    BindKeyInfo = BIT_STR(name=u'BindKeyInfo', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'ENCRYPTED')))
    
    #-----< read >-----#
    read = CLASS(name=u'read', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _read_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    _read_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_Errors_val_ParameterType_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    __OPERATION_Errors_val_ParameterType_3 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_3_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_Errors_val_ParameterType_4 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_4_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Errors_val_ParameterType_5 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_5_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_5_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    read._val = dict([(u'ArgumentType', _read_val_ArgumentType), (u'ResultType', _read_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))])
    
    #-----< ReadArgument >-----#
    ReadArgument = CHOICE(name=u'ReadArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ReadArgument_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgumentData')))
    _ReadArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ReadArgument_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgumentData')))
    __ReadArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ReadArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____ReadArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ReadArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReadArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ReadArgument_signed_algorithmIdentifier_algorithm_tab
    ___ReadArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ReadArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___ReadArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____ReadArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ReadArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReadArgument_signed_algorithmIdentifier_parameters._const_tab = ____ReadArgument_signed_algorithmIdentifier_parameters_tab
    ___ReadArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___ReadArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __ReadArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___ReadArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___ReadArgument_signed_algorithmIdentifier_parameters),
        ])
    __ReadArgument_signed_algorithmIdentifier._ext = []
    __ReadArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _ReadArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __ReadArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __ReadArgument_signed_algorithmIdentifier),
        (u'signature', __ReadArgument_signed_signature),
        ])
    _ReadArgument_signed._ext = []
    ReadArgument._cont = ASN1Dict([
        (u'unsigned', _ReadArgument_unsigned),
        (u'signed', _ReadArgument_signed),
        ])
    ReadArgument._ext = None
    
    #-----< ReadArgumentData >-----#
    ReadArgumentData = SET(name=u'ReadArgumentData', mode=MODE_TYPE)
    _ReadArgumentData_object = CHOICE(name=u'object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _ReadArgumentData_selection = SET(name=u'selection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformationSelection')), default=dict([]))
    _ReadArgumentData_modifyRightsRequest = BOOL(name=u'modifyRightsRequest', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ReadArgumentData_serviceControls = SET(name=u'serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _ReadArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ReadArgumentData_requestor = SEQ_OF(name=u'requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ReadArgumentData_operationProgress = SET(name=u'operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([(u'nameResolutionPhase', u'notStarted')]))
    _ReadArgumentData_aliasedRDNs = INT(name=u'aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ReadArgumentData_criticalExtensions = BIT_STR(name=u'criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ReadArgumentData_referenceType = ENUM(name=u'referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _ReadArgumentData_entryOnly = BOOL(name=u'entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _ReadArgumentData_exclusions = SET_OF(name=u'exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ReadArgumentData_nameResolveOnMaster = BOOL(name=u'nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ReadArgumentData_operationContexts = CHOICE(name=u'operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _ReadArgumentData_familyGrouping = ENUM(name=u'familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default=u'entryOnly')
    ReadArgumentData._cont = ASN1Dict([
        (u'object', _ReadArgumentData_object),
        (u'selection', _ReadArgumentData_selection),
        (u'modifyRightsRequest', _ReadArgumentData_modifyRightsRequest),
        (u'serviceControls', _ReadArgumentData_serviceControls),
        (u'securityParameters', _ReadArgumentData_securityParameters),
        (u'requestor', _ReadArgumentData_requestor),
        (u'operationProgress', _ReadArgumentData_operationProgress),
        (u'aliasedRDNs', _ReadArgumentData_aliasedRDNs),
        (u'criticalExtensions', _ReadArgumentData_criticalExtensions),
        (u'referenceType', _ReadArgumentData_referenceType),
        (u'entryOnly', _ReadArgumentData_entryOnly),
        (u'exclusions', _ReadArgumentData_exclusions),
        (u'nameResolveOnMaster', _ReadArgumentData_nameResolveOnMaster),
        (u'operationContexts', _ReadArgumentData_operationContexts),
        (u'familyGrouping', _ReadArgumentData_familyGrouping),
        ])
    ReadArgumentData._ext = [u'serviceControls', u'securityParameters', u'requestor', u'operationProgress', u'aliasedRDNs', u'criticalExtensions', u'referenceType', u'entryOnly', u'exclusions', u'nameResolveOnMaster', u'operationContexts', u'familyGrouping']
    
    #-----< ReadResult >-----#
    ReadResult = CHOICE(name=u'ReadResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ReadResult_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResultData')))
    _ReadResult_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ReadResult_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResultData')))
    __ReadResult_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ReadResult_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____ReadResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ReadResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReadResult_signed_algorithmIdentifier_algorithm._const_tab = ____ReadResult_signed_algorithmIdentifier_algorithm_tab
    ___ReadResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ReadResult_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___ReadResult_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____ReadResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ReadResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReadResult_signed_algorithmIdentifier_parameters._const_tab = ____ReadResult_signed_algorithmIdentifier_parameters_tab
    ___ReadResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___ReadResult_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __ReadResult_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___ReadResult_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___ReadResult_signed_algorithmIdentifier_parameters),
        ])
    __ReadResult_signed_algorithmIdentifier._ext = []
    __ReadResult_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _ReadResult_signed._cont = ASN1Dict([
        (u'toBeSigned', __ReadResult_signed_toBeSigned),
        (u'algorithmIdentifier', __ReadResult_signed_algorithmIdentifier),
        (u'signature', __ReadResult_signed_signature),
        ])
    _ReadResult_signed._ext = []
    ReadResult._cont = ASN1Dict([
        (u'unsigned', _ReadResult_unsigned),
        (u'signed', _ReadResult_signed),
        ])
    ReadResult._ext = None
    
    #-----< ReadResultData >-----#
    ReadResultData = SET(name=u'ReadResultData', mode=MODE_TYPE)
    _ReadResultData_entry = SEQ(name=u'entry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformation')))
    _ReadResultData_modifyRights = SET_OF(name=u'modifyRights', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyRights')), opt=True)
    _ReadResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ReadResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ReadResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ReadResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ReadResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ReadResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____ReadResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ReadResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____ReadResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ReadResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____ReadResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____ReadResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ReadResultData_notification__item__type._const_tab = ____ReadResultData_notification__item__type_tab
    ___ReadResultData_notification__item__type._const_tab_at = None
    ___ReadResultData_notification__item__type._const_tab_id = u'id'
    ___ReadResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____ReadResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____ReadResultData_notification__item__values__item_._const_tab = ____ReadResultData_notification__item__type_tab
    ____ReadResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____ReadResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___ReadResultData_notification__item__values._cont = ____ReadResultData_notification__item__values__item_
    ___ReadResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ReadResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ReadResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ReadResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____ReadResultData_notification__item__valuesWithContext__item__value._const_tab = ____ReadResultData_notification__item__type_tab
    _____ReadResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____ReadResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____ReadResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______ReadResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ReadResultData_notification__item__valuesWithContext__item__contextList._cont = ______ReadResultData_notification__item__valuesWithContext__item__contextList__item_
    _____ReadResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ReadResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____ReadResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____ReadResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ReadResultData_notification__item__valuesWithContext__item_._ext = []
    ___ReadResultData_notification__item__valuesWithContext._cont = ____ReadResultData_notification__item__valuesWithContext__item_
    ___ReadResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ReadResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___ReadResultData_notification__item__type),
        (u'values', ___ReadResultData_notification__item__values),
        (u'valuesWithContext', ___ReadResultData_notification__item__valuesWithContext),
        ])
    __ReadResultData_notification__item_._ext = []
    _ReadResultData_notification._cont = __ReadResultData_notification__item_
    ReadResultData._cont = ASN1Dict([
        (u'entry', _ReadResultData_entry),
        (u'modifyRights', _ReadResultData_modifyRights),
        (u'securityParameters', _ReadResultData_securityParameters),
        (u'performer', _ReadResultData_performer),
        (u'aliasDereferenced', _ReadResultData_aliasDereferenced),
        (u'notification', _ReadResultData_notification),
        ])
    ReadResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< ModifyRights >-----#
    ModifyRights = SET_OF(name=u'ModifyRights', mode=MODE_TYPE)
    _ModifyRights__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __ModifyRights__item__item = CHOICE(name=u'item', mode=MODE_TYPE)
    ___ModifyRights__item__item_entry = NULL(name=u'entry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___ModifyRights__item__item_attribute = OID(name=u'attribute', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___ModifyRights__item__item_value = SEQ(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    __ModifyRights__item__item._cont = ASN1Dict([
        (u'entry', ___ModifyRights__item__item_entry),
        (u'attribute', ___ModifyRights__item__item_attribute),
        (u'value', ___ModifyRights__item__item_value),
        ])
    __ModifyRights__item__item._ext = []
    __ModifyRights__item__permission = BIT_STR(name=u'permission', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ModifyRights__item__permission._cont = ASN1Dict([(u'add', 0), (u'remove', 1), (u'rename', 2), (u'move', 3)])
    _ModifyRights__item_._cont = ASN1Dict([
        (u'item', __ModifyRights__item__item),
        (u'permission', __ModifyRights__item__permission),
        ])
    _ModifyRights__item_._ext = []
    ModifyRights._cont = _ModifyRights__item_
    
    #-----< compare >-----#
    compare = CLASS(name=u'compare', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _compare_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    _compare_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    compare._val = dict([(u'ArgumentType', _compare_val_ArgumentType), (u'ResultType', _compare_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])
    
    #-----< CompareArgument >-----#
    CompareArgument = CHOICE(name=u'CompareArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _CompareArgument_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgumentData')))
    _CompareArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __CompareArgument_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgumentData')))
    __CompareArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___CompareArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____CompareArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CompareArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompareArgument_signed_algorithmIdentifier_algorithm._const_tab = ____CompareArgument_signed_algorithmIdentifier_algorithm_tab
    ___CompareArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___CompareArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___CompareArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____CompareArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CompareArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompareArgument_signed_algorithmIdentifier_parameters._const_tab = ____CompareArgument_signed_algorithmIdentifier_parameters_tab
    ___CompareArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___CompareArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __CompareArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___CompareArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___CompareArgument_signed_algorithmIdentifier_parameters),
        ])
    __CompareArgument_signed_algorithmIdentifier._ext = []
    __CompareArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _CompareArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __CompareArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __CompareArgument_signed_algorithmIdentifier),
        (u'signature', __CompareArgument_signed_signature),
        ])
    _CompareArgument_signed._ext = []
    CompareArgument._cont = ASN1Dict([
        (u'unsigned', _CompareArgument_unsigned),
        (u'signed', _CompareArgument_signed),
        ])
    CompareArgument._ext = None
    
    #-----< CompareArgumentData >-----#
    CompareArgumentData = SET(name=u'CompareArgumentData', mode=MODE_TYPE)
    _CompareArgumentData_object = CHOICE(name=u'object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _CompareArgumentData_purported = SEQ(name=u'purported', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _CompareArgumentData_serviceControls = SET(name=u'serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _CompareArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CompareArgumentData_requestor = SEQ_OF(name=u'requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CompareArgumentData_operationProgress = SET(name=u'operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([(u'nameResolutionPhase', u'notStarted')]))
    _CompareArgumentData_aliasedRDNs = INT(name=u'aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CompareArgumentData_criticalExtensions = BIT_STR(name=u'criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CompareArgumentData_referenceType = ENUM(name=u'referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _CompareArgumentData_entryOnly = BOOL(name=u'entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _CompareArgumentData_exclusions = SET_OF(name=u'exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _CompareArgumentData_nameResolveOnMaster = BOOL(name=u'nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CompareArgumentData_operationContexts = CHOICE(name=u'operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _CompareArgumentData_familyGrouping = ENUM(name=u'familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default=u'entryOnly')
    CompareArgumentData._cont = ASN1Dict([
        (u'object', _CompareArgumentData_object),
        (u'purported', _CompareArgumentData_purported),
        (u'serviceControls', _CompareArgumentData_serviceControls),
        (u'securityParameters', _CompareArgumentData_securityParameters),
        (u'requestor', _CompareArgumentData_requestor),
        (u'operationProgress', _CompareArgumentData_operationProgress),
        (u'aliasedRDNs', _CompareArgumentData_aliasedRDNs),
        (u'criticalExtensions', _CompareArgumentData_criticalExtensions),
        (u'referenceType', _CompareArgumentData_referenceType),
        (u'entryOnly', _CompareArgumentData_entryOnly),
        (u'exclusions', _CompareArgumentData_exclusions),
        (u'nameResolveOnMaster', _CompareArgumentData_nameResolveOnMaster),
        (u'operationContexts', _CompareArgumentData_operationContexts),
        (u'familyGrouping', _CompareArgumentData_familyGrouping),
        ])
    CompareArgumentData._ext = [u'serviceControls', u'securityParameters', u'requestor', u'operationProgress', u'aliasedRDNs', u'criticalExtensions', u'referenceType', u'entryOnly', u'exclusions', u'nameResolveOnMaster', u'operationContexts', u'familyGrouping']
    
    #-----< CompareResult >-----#
    CompareResult = CHOICE(name=u'CompareResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _CompareResult_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResultData')))
    _CompareResult_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __CompareResult_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResultData')))
    __CompareResult_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___CompareResult_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____CompareResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CompareResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompareResult_signed_algorithmIdentifier_algorithm._const_tab = ____CompareResult_signed_algorithmIdentifier_algorithm_tab
    ___CompareResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___CompareResult_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___CompareResult_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____CompareResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CompareResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CompareResult_signed_algorithmIdentifier_parameters._const_tab = ____CompareResult_signed_algorithmIdentifier_parameters_tab
    ___CompareResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___CompareResult_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __CompareResult_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___CompareResult_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___CompareResult_signed_algorithmIdentifier_parameters),
        ])
    __CompareResult_signed_algorithmIdentifier._ext = []
    __CompareResult_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _CompareResult_signed._cont = ASN1Dict([
        (u'toBeSigned', __CompareResult_signed_toBeSigned),
        (u'algorithmIdentifier', __CompareResult_signed_algorithmIdentifier),
        (u'signature', __CompareResult_signed_signature),
        ])
    _CompareResult_signed._ext = []
    CompareResult._cont = ASN1Dict([
        (u'unsigned', _CompareResult_unsigned),
        (u'signed', _CompareResult_signed),
        ])
    CompareResult._ext = None
    
    #-----< CompareResultData >-----#
    CompareResultData = SET(name=u'CompareResultData', mode=MODE_TYPE)
    _CompareResultData_name = CHOICE(name=u'name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _CompareResultData_matched = BOOL(name=u'matched', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _CompareResultData_fromEntry = BOOL(name=u'fromEntry', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _CompareResultData_matchedSubtype = OID(name=u'matchedSubtype', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')), opt=True)
    _CompareResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CompareResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CompareResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CompareResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __CompareResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___CompareResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____CompareResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____CompareResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____CompareResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____CompareResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____CompareResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____CompareResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___CompareResultData_notification__item__type._const_tab = ____CompareResultData_notification__item__type_tab
    ___CompareResultData_notification__item__type._const_tab_at = None
    ___CompareResultData_notification__item__type._const_tab_id = u'id'
    ___CompareResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____CompareResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____CompareResultData_notification__item__values__item_._const_tab = ____CompareResultData_notification__item__type_tab
    ____CompareResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____CompareResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___CompareResultData_notification__item__values._cont = ____CompareResultData_notification__item__values__item_
    ___CompareResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___CompareResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____CompareResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____CompareResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____CompareResultData_notification__item__valuesWithContext__item__value._const_tab = ____CompareResultData_notification__item__type_tab
    _____CompareResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____CompareResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____CompareResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______CompareResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____CompareResultData_notification__item__valuesWithContext__item__contextList._cont = ______CompareResultData_notification__item__valuesWithContext__item__contextList__item_
    _____CompareResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____CompareResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____CompareResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____CompareResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____CompareResultData_notification__item__valuesWithContext__item_._ext = []
    ___CompareResultData_notification__item__valuesWithContext._cont = ____CompareResultData_notification__item__valuesWithContext__item_
    ___CompareResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __CompareResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___CompareResultData_notification__item__type),
        (u'values', ___CompareResultData_notification__item__values),
        (u'valuesWithContext', ___CompareResultData_notification__item__valuesWithContext),
        ])
    __CompareResultData_notification__item_._ext = []
    _CompareResultData_notification._cont = __CompareResultData_notification__item_
    CompareResultData._cont = ASN1Dict([
        (u'name', _CompareResultData_name),
        (u'matched', _CompareResultData_matched),
        (u'fromEntry', _CompareResultData_fromEntry),
        (u'matchedSubtype', _CompareResultData_matchedSubtype),
        (u'securityParameters', _CompareResultData_securityParameters),
        (u'performer', _CompareResultData_performer),
        (u'aliasDereferenced', _CompareResultData_aliasDereferenced),
        (u'notification', _CompareResultData_notification),
        ])
    CompareResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< abandon >-----#
    abandon = CLASS(name=u'abandon', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _abandon_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    _abandon_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __OPERATION_Errors_val_ParameterType_0_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_1._ext = None
    abandon._val = dict([(u'ArgumentType', _abandon_val_ArgumentType), (u'ResultType', _abandon_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])
    
    #-----< AbandonArgument >-----#
    AbandonArgument = CHOICE(name=u'AbandonArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _AbandonArgument_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgumentData')))
    _AbandonArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __AbandonArgument_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgumentData')))
    __AbandonArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___AbandonArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____AbandonArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AbandonArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AbandonArgument_signed_algorithmIdentifier_algorithm._const_tab = ____AbandonArgument_signed_algorithmIdentifier_algorithm_tab
    ___AbandonArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___AbandonArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___AbandonArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____AbandonArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AbandonArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AbandonArgument_signed_algorithmIdentifier_parameters._const_tab = ____AbandonArgument_signed_algorithmIdentifier_parameters_tab
    ___AbandonArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___AbandonArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __AbandonArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___AbandonArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___AbandonArgument_signed_algorithmIdentifier_parameters),
        ])
    __AbandonArgument_signed_algorithmIdentifier._ext = []
    __AbandonArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _AbandonArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __AbandonArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __AbandonArgument_signed_algorithmIdentifier),
        (u'signature', __AbandonArgument_signed_signature),
        ])
    _AbandonArgument_signed._ext = []
    AbandonArgument._cont = ASN1Dict([
        (u'unsigned', _AbandonArgument_unsigned),
        (u'signed', _AbandonArgument_signed),
        ])
    AbandonArgument._ext = None
    
    #-----< AbandonArgumentData >-----#
    AbandonArgumentData = SEQ(name=u'AbandonArgumentData', mode=MODE_TYPE)
    _AbandonArgumentData_invokeID = CHOICE(name=u'invokeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    AbandonArgumentData._cont = ASN1Dict([
        (u'invokeID', _AbandonArgumentData_invokeID),
        ])
    AbandonArgumentData._ext = []
    
    #-----< AbandonResult >-----#
    AbandonResult = CHOICE(name=u'AbandonResult', mode=MODE_TYPE)
    _AbandonResult_null = NULL(name=u'null', mode=MODE_TYPE)
    _AbandonResult_information = CHOICE(name=u'information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __AbandonResult_information_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResultData')))
    __AbandonResult_information_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___AbandonResult_information_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResultData')))
    ___AbandonResult_information_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____AbandonResult_information_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____AbandonResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AbandonResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AbandonResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____AbandonResult_information_signed_algorithmIdentifier_algorithm_tab
    ____AbandonResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____AbandonResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____AbandonResult_information_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____AbandonResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AbandonResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AbandonResult_information_signed_algorithmIdentifier_parameters._const_tab = _____AbandonResult_information_signed_algorithmIdentifier_parameters_tab
    ____AbandonResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____AbandonResult_information_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___AbandonResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____AbandonResult_information_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____AbandonResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___AbandonResult_information_signed_algorithmIdentifier._ext = []
    ___AbandonResult_information_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __AbandonResult_information_signed._cont = ASN1Dict([
        (u'toBeSigned', ___AbandonResult_information_signed_toBeSigned),
        (u'algorithmIdentifier', ___AbandonResult_information_signed_algorithmIdentifier),
        (u'signature', ___AbandonResult_information_signed_signature),
        ])
    __AbandonResult_information_signed._ext = []
    _AbandonResult_information._cont = ASN1Dict([
        (u'unsigned', __AbandonResult_information_unsigned),
        (u'signed', __AbandonResult_information_signed),
        ])
    _AbandonResult_information._ext = None
    AbandonResult._cont = ASN1Dict([
        (u'null', _AbandonResult_null),
        (u'information', _AbandonResult_information),
        ])
    AbandonResult._ext = []
    
    #-----< AbandonResultData >-----#
    AbandonResultData = SEQ(name=u'AbandonResultData', mode=MODE_TYPE)
    _AbandonResultData_invokeID = CHOICE(name=u'invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    _AbandonResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AbandonResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AbandonResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AbandonResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AbandonResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AbandonResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____AbandonResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AbandonResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____AbandonResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AbandonResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____AbandonResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____AbandonResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AbandonResultData_notification__item__type._const_tab = ____AbandonResultData_notification__item__type_tab
    ___AbandonResultData_notification__item__type._const_tab_at = None
    ___AbandonResultData_notification__item__type._const_tab_id = u'id'
    ___AbandonResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____AbandonResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____AbandonResultData_notification__item__values__item_._const_tab = ____AbandonResultData_notification__item__type_tab
    ____AbandonResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____AbandonResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___AbandonResultData_notification__item__values._cont = ____AbandonResultData_notification__item__values__item_
    ___AbandonResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AbandonResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AbandonResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AbandonResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____AbandonResultData_notification__item__valuesWithContext__item__value._const_tab = ____AbandonResultData_notification__item__type_tab
    _____AbandonResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____AbandonResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____AbandonResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______AbandonResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AbandonResultData_notification__item__valuesWithContext__item__contextList._cont = ______AbandonResultData_notification__item__valuesWithContext__item__contextList__item_
    _____AbandonResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AbandonResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____AbandonResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____AbandonResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AbandonResultData_notification__item__valuesWithContext__item_._ext = []
    ___AbandonResultData_notification__item__valuesWithContext._cont = ____AbandonResultData_notification__item__valuesWithContext__item_
    ___AbandonResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AbandonResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___AbandonResultData_notification__item__type),
        (u'values', ___AbandonResultData_notification__item__values),
        (u'valuesWithContext', ___AbandonResultData_notification__item__valuesWithContext),
        ])
    __AbandonResultData_notification__item_._ext = []
    _AbandonResultData_notification._cont = __AbandonResultData_notification__item_
    AbandonResultData._cont = ASN1Dict([
        (u'invokeID', _AbandonResultData_invokeID),
        (u'securityParameters', _AbandonResultData_securityParameters),
        (u'performer', _AbandonResultData_performer),
        (u'aliasDereferenced', _AbandonResultData_aliasDereferenced),
        (u'notification', _AbandonResultData_notification),
        ])
    AbandonResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< list >-----#
    list = CLASS(name=u'list', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _list_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    _list_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    __OPERATION_Errors_val_ParameterType_0_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_2._ext = None
    __OPERATION_Errors_val_ParameterType_1_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_0._ext = None
    __OPERATION_Errors_val_ParameterType_2_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_3_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_3_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_3_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_0._ext = None
    list._val = dict([(u'ArgumentType', _list_val_ArgumentType), (u'ResultType', _list_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))])
    
    #-----< ListArgument >-----#
    ListArgument = CHOICE(name=u'ListArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ListArgument_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgumentData')))
    _ListArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ListArgument_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgumentData')))
    __ListArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ListArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____ListArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ListArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ListArgument_signed_algorithmIdentifier_algorithm_tab
    ___ListArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ListArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___ListArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____ListArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ListArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListArgument_signed_algorithmIdentifier_parameters._const_tab = ____ListArgument_signed_algorithmIdentifier_parameters_tab
    ___ListArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___ListArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __ListArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___ListArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___ListArgument_signed_algorithmIdentifier_parameters),
        ])
    __ListArgument_signed_algorithmIdentifier._ext = []
    __ListArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _ListArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __ListArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __ListArgument_signed_algorithmIdentifier),
        (u'signature', __ListArgument_signed_signature),
        ])
    _ListArgument_signed._ext = []
    ListArgument._cont = ASN1Dict([
        (u'unsigned', _ListArgument_unsigned),
        (u'signed', _ListArgument_signed),
        ])
    ListArgument._ext = None
    
    #-----< ListArgumentData >-----#
    ListArgumentData = SET(name=u'ListArgumentData', mode=MODE_TYPE)
    _ListArgumentData_object = CHOICE(name=u'object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _ListArgumentData_pagedResults = CHOICE(name=u'pagedResults', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'PagedResultsRequest')), opt=True)
    _ListArgumentData_listFamily = BOOL(name=u'listFamily', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ListArgumentData_serviceControls = SET(name=u'serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _ListArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ListArgumentData_requestor = SEQ_OF(name=u'requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ListArgumentData_operationProgress = SET(name=u'operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([(u'nameResolutionPhase', u'notStarted')]))
    _ListArgumentData_aliasedRDNs = INT(name=u'aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ListArgumentData_criticalExtensions = BIT_STR(name=u'criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ListArgumentData_referenceType = ENUM(name=u'referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _ListArgumentData_entryOnly = BOOL(name=u'entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _ListArgumentData_exclusions = SET_OF(name=u'exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ListArgumentData_nameResolveOnMaster = BOOL(name=u'nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ListArgumentData_operationContexts = CHOICE(name=u'operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _ListArgumentData_familyGrouping = ENUM(name=u'familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default=u'entryOnly')
    ListArgumentData._cont = ASN1Dict([
        (u'object', _ListArgumentData_object),
        (u'pagedResults', _ListArgumentData_pagedResults),
        (u'listFamily', _ListArgumentData_listFamily),
        (u'serviceControls', _ListArgumentData_serviceControls),
        (u'securityParameters', _ListArgumentData_securityParameters),
        (u'requestor', _ListArgumentData_requestor),
        (u'operationProgress', _ListArgumentData_operationProgress),
        (u'aliasedRDNs', _ListArgumentData_aliasedRDNs),
        (u'criticalExtensions', _ListArgumentData_criticalExtensions),
        (u'referenceType', _ListArgumentData_referenceType),
        (u'entryOnly', _ListArgumentData_entryOnly),
        (u'exclusions', _ListArgumentData_exclusions),
        (u'nameResolveOnMaster', _ListArgumentData_nameResolveOnMaster),
        (u'operationContexts', _ListArgumentData_operationContexts),
        (u'familyGrouping', _ListArgumentData_familyGrouping),
        ])
    ListArgumentData._ext = [u'serviceControls', u'securityParameters', u'requestor', u'operationProgress', u'aliasedRDNs', u'criticalExtensions', u'referenceType', u'entryOnly', u'exclusions', u'nameResolveOnMaster', u'operationContexts', u'familyGrouping']
    
    #-----< ListResult >-----#
    ListResult = CHOICE(name=u'ListResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ListResult_unsigned = CHOICE(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResultData')))
    _ListResult_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ListResult_signed_toBeSigned = CHOICE(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResultData')))
    __ListResult_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ListResult_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____ListResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ListResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListResult_signed_algorithmIdentifier_algorithm._const_tab = ____ListResult_signed_algorithmIdentifier_algorithm_tab
    ___ListResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ListResult_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___ListResult_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____ListResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ListResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ListResult_signed_algorithmIdentifier_parameters._const_tab = ____ListResult_signed_algorithmIdentifier_parameters_tab
    ___ListResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___ListResult_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __ListResult_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___ListResult_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___ListResult_signed_algorithmIdentifier_parameters),
        ])
    __ListResult_signed_algorithmIdentifier._ext = []
    __ListResult_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _ListResult_signed._cont = ASN1Dict([
        (u'toBeSigned', __ListResult_signed_toBeSigned),
        (u'algorithmIdentifier', __ListResult_signed_algorithmIdentifier),
        (u'signature', __ListResult_signed_signature),
        ])
    _ListResult_signed._ext = []
    ListResult._cont = ASN1Dict([
        (u'unsigned', _ListResult_unsigned),
        (u'signed', _ListResult_signed),
        ])
    ListResult._ext = None
    
    #-----< ListResultData >-----#
    ListResultData = CHOICE(name=u'ListResultData', mode=MODE_TYPE)
    _ListResultData_listInfo = SET(name=u'listInfo', mode=MODE_TYPE)
    __ListResultData_listInfo_name = CHOICE(name=u'name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    __ListResultData_listInfo_subordinates = SET_OF(name=u'subordinates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___ListResultData_listInfo_subordinates__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____ListResultData_listInfo_subordinates__item__rdn = SET_OF(name=u'rdn', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    ____ListResultData_listInfo_subordinates__item__aliasEntry = BOOL(name=u'aliasEntry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    ____ListResultData_listInfo_subordinates__item__fromEntry = BOOL(name=u'fromEntry', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    ___ListResultData_listInfo_subordinates__item_._cont = ASN1Dict([
        (u'rdn', ____ListResultData_listInfo_subordinates__item__rdn),
        (u'aliasEntry', ____ListResultData_listInfo_subordinates__item__aliasEntry),
        (u'fromEntry', ____ListResultData_listInfo_subordinates__item__fromEntry),
        ])
    ___ListResultData_listInfo_subordinates__item_._ext = []
    __ListResultData_listInfo_subordinates._cont = ___ListResultData_listInfo_subordinates__item_
    __ListResultData_listInfo_partialOutcomeQualifier = SET(name=u'partialOutcomeQualifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'PartialOutcomeQualifier')), opt=True)
    __ListResultData_listInfo_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    __ListResultData_listInfo_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    __ListResultData_listInfo_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    __ListResultData_listInfo_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___ListResultData_listInfo_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____ListResultData_listInfo_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _____ListResultData_listInfo_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______ListResultData_listInfo_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ______ListResultData_listInfo_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____ListResultData_listInfo_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', ______ListResultData_listInfo_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ______ListResultData_listInfo_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____ListResultData_listInfo_notification__item__type._const_tab = _____ListResultData_listInfo_notification__item__type_tab
    ____ListResultData_listInfo_notification__item__type._const_tab_at = None
    ____ListResultData_listInfo_notification__item__type._const_tab_id = u'id'
    ____ListResultData_listInfo_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    _____ListResultData_listInfo_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____ListResultData_listInfo_notification__item__values__item_._const_tab = _____ListResultData_listInfo_notification__item__type_tab
    _____ListResultData_listInfo_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    _____ListResultData_listInfo_notification__item__values__item_._const_tab_id = u'Type'
    ____ListResultData_listInfo_notification__item__values._cont = _____ListResultData_listInfo_notification__item__values__item_
    ____ListResultData_listInfo_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____ListResultData_listInfo_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    _____ListResultData_listInfo_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__value._const_tab = _____ListResultData_listInfo_notification__item__type_tab
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    _______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList._cont = _______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList__item_
    ______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____ListResultData_listInfo_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', ______ListResultData_listInfo_notification__item__valuesWithContext__item__value),
        (u'contextList', ______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList),
        ])
    _____ListResultData_listInfo_notification__item__valuesWithContext__item_._ext = []
    ____ListResultData_listInfo_notification__item__valuesWithContext._cont = _____ListResultData_listInfo_notification__item__valuesWithContext__item_
    ____ListResultData_listInfo_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___ListResultData_listInfo_notification__item_._cont = ASN1Dict([
        (u'type', ____ListResultData_listInfo_notification__item__type),
        (u'values', ____ListResultData_listInfo_notification__item__values),
        (u'valuesWithContext', ____ListResultData_listInfo_notification__item__valuesWithContext),
        ])
    ___ListResultData_listInfo_notification__item_._ext = []
    __ListResultData_listInfo_notification._cont = ___ListResultData_listInfo_notification__item_
    _ListResultData_listInfo._cont = ASN1Dict([
        (u'name', __ListResultData_listInfo_name),
        (u'subordinates', __ListResultData_listInfo_subordinates),
        (u'partialOutcomeQualifier', __ListResultData_listInfo_partialOutcomeQualifier),
        (u'securityParameters', __ListResultData_listInfo_securityParameters),
        (u'performer', __ListResultData_listInfo_performer),
        (u'aliasDereferenced', __ListResultData_listInfo_aliasDereferenced),
        (u'notification', __ListResultData_listInfo_notification),
        ])
    _ListResultData_listInfo._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    _ListResultData_uncorrelatedListInfo = SET_OF(name=u'uncorrelatedListInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ListResultData_uncorrelatedListInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    _ListResultData_uncorrelatedListInfo._cont = __ListResultData_uncorrelatedListInfo__item_
    ListResultData._cont = ASN1Dict([
        (u'listInfo', _ListResultData_listInfo),
        (u'uncorrelatedListInfo', _ListResultData_uncorrelatedListInfo),
        ])
    ListResultData._ext = []
    
    #-----< PartialOutcomeQualifier >-----#
    PartialOutcomeQualifier = SET(name=u'PartialOutcomeQualifier', mode=MODE_TYPE)
    _PartialOutcomeQualifier_limitProblem = INT(name=u'limitProblem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LimitProblem')), opt=True)
    _PartialOutcomeQualifier_unexplored = SET_OF(name=u'unexplored', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __PartialOutcomeQualifier_unexplored__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ContinuationReference')))
    _PartialOutcomeQualifier_unexplored._cont = __PartialOutcomeQualifier_unexplored__item_
    _PartialOutcomeQualifier_unexplored._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _PartialOutcomeQualifier_unavailableCriticalExtensions = BOOL(name=u'unavailableCriticalExtensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _PartialOutcomeQualifier_unknownErrors = SET_OF(name=u'unknownErrors', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __PartialOutcomeQualifier_unknownErrors__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    _PartialOutcomeQualifier_unknownErrors._cont = __PartialOutcomeQualifier_unknownErrors__item_
    _PartialOutcomeQualifier_unknownErrors._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _PartialOutcomeQualifier_queryReference = OCT_STR(name=u'queryReference', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PartialOutcomeQualifier_overspecFilter = CHOICE(name=u'overspecFilter', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')), opt=True)
    _PartialOutcomeQualifier_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __PartialOutcomeQualifier_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___PartialOutcomeQualifier_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____PartialOutcomeQualifier_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____PartialOutcomeQualifier_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___PartialOutcomeQualifier_notification__item__type._const_tab = ____PartialOutcomeQualifier_notification__item__type_tab
    ___PartialOutcomeQualifier_notification__item__type._const_tab_at = None
    ___PartialOutcomeQualifier_notification__item__type._const_tab_id = u'id'
    ___PartialOutcomeQualifier_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____PartialOutcomeQualifier_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____PartialOutcomeQualifier_notification__item__values__item_._const_tab = ____PartialOutcomeQualifier_notification__item__type_tab
    ____PartialOutcomeQualifier_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____PartialOutcomeQualifier_notification__item__values__item_._const_tab_id = u'Type'
    ___PartialOutcomeQualifier_notification__item__values._cont = ____PartialOutcomeQualifier_notification__item__values__item_
    ___PartialOutcomeQualifier_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___PartialOutcomeQualifier_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____PartialOutcomeQualifier_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value._const_tab = ____PartialOutcomeQualifier_notification__item__type_tab
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList._cont = ______PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList__item_
    _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____PartialOutcomeQualifier_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value),
        (u'contextList', _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList),
        ])
    ____PartialOutcomeQualifier_notification__item__valuesWithContext__item_._ext = []
    ___PartialOutcomeQualifier_notification__item__valuesWithContext._cont = ____PartialOutcomeQualifier_notification__item__valuesWithContext__item_
    ___PartialOutcomeQualifier_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __PartialOutcomeQualifier_notification__item_._cont = ASN1Dict([
        (u'type', ___PartialOutcomeQualifier_notification__item__type),
        (u'values', ___PartialOutcomeQualifier_notification__item__values),
        (u'valuesWithContext', ___PartialOutcomeQualifier_notification__item__valuesWithContext),
        ])
    __PartialOutcomeQualifier_notification__item_._ext = []
    _PartialOutcomeQualifier_notification._cont = __PartialOutcomeQualifier_notification__item_
    _PartialOutcomeQualifier_notification._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _PartialOutcomeQualifier_entryCount = CHOICE(name=u'entryCount', mode=MODE_TYPE, opt=True)
    __PartialOutcomeQualifier_entryCount_bestEstimate = INT(name=u'bestEstimate', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PartialOutcomeQualifier_entryCount_lowEstimate = INT(name=u'lowEstimate', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PartialOutcomeQualifier_entryCount_exact = INT(name=u'exact', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _PartialOutcomeQualifier_entryCount._cont = ASN1Dict([
        (u'bestEstimate', __PartialOutcomeQualifier_entryCount_bestEstimate),
        (u'lowEstimate', __PartialOutcomeQualifier_entryCount_lowEstimate),
        (u'exact', __PartialOutcomeQualifier_entryCount_exact),
        ])
    _PartialOutcomeQualifier_entryCount._ext = []
    PartialOutcomeQualifier._cont = ASN1Dict([
        (u'limitProblem', _PartialOutcomeQualifier_limitProblem),
        (u'unexplored', _PartialOutcomeQualifier_unexplored),
        (u'unavailableCriticalExtensions', _PartialOutcomeQualifier_unavailableCriticalExtensions),
        (u'unknownErrors', _PartialOutcomeQualifier_unknownErrors),
        (u'queryReference', _PartialOutcomeQualifier_queryReference),
        (u'overspecFilter', _PartialOutcomeQualifier_overspecFilter),
        (u'notification', _PartialOutcomeQualifier_notification),
        (u'entryCount', _PartialOutcomeQualifier_entryCount),
        ])
    PartialOutcomeQualifier._ext = None
    
    #-----< LimitProblem >-----#
    LimitProblem = INT(name=u'LimitProblem', mode=MODE_TYPE)
    LimitProblem._cont = ASN1Dict([(u'timeLimitExceeded', 0), (u'sizeLimitExceeded', 1), (u'administrativeLimitExceeded', 2)])
    
    #-----< search >-----#
    search = CLASS(name=u'search', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _search_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    _search_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    search._val = dict([(u'ArgumentType', _search_val_ArgumentType), (u'ResultType', _search_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))])
    
    #-----< SearchArgument >-----#
    SearchArgument = CHOICE(name=u'SearchArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _SearchArgument_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgumentData')))
    _SearchArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __SearchArgument_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgumentData')))
    __SearchArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___SearchArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____SearchArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SearchArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SearchArgument_signed_algorithmIdentifier_algorithm._const_tab = ____SearchArgument_signed_algorithmIdentifier_algorithm_tab
    ___SearchArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___SearchArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___SearchArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____SearchArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SearchArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SearchArgument_signed_algorithmIdentifier_parameters._const_tab = ____SearchArgument_signed_algorithmIdentifier_parameters_tab
    ___SearchArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___SearchArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __SearchArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___SearchArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___SearchArgument_signed_algorithmIdentifier_parameters),
        ])
    __SearchArgument_signed_algorithmIdentifier._ext = []
    __SearchArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _SearchArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __SearchArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __SearchArgument_signed_algorithmIdentifier),
        (u'signature', __SearchArgument_signed_signature),
        ])
    _SearchArgument_signed._ext = []
    SearchArgument._cont = ASN1Dict([
        (u'unsigned', _SearchArgument_unsigned),
        (u'signed', _SearchArgument_signed),
        ])
    SearchArgument._ext = None
    
    #-----< SearchArgumentData >-----#
    SearchArgumentData = SET(name=u'SearchArgumentData', mode=MODE_TYPE)
    _SearchArgumentData_baseObject = CHOICE(name=u'baseObject', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _SearchArgumentData_subset = INT(name=u'subset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=0)
    _SearchArgumentData_subset._cont = ASN1Dict([(u'baseObject', 0), (u'oneLevel', 1), (u'wholeSubtree', 2)])
    _SearchArgumentData_filter = CHOICE(name=u'filter', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')), default=(u'and', []))
    _SearchArgumentData_searchAliases = BOOL(name=u'searchAliases', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _SearchArgumentData_selection = SET(name=u'selection', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformationSelection')), default=dict([]))
    _SearchArgumentData_pagedResults = CHOICE(name=u'pagedResults', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'PagedResultsRequest')), opt=True)
    _SearchArgumentData_matchedValuesOnly = BOOL(name=u'matchedValuesOnly', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _SearchArgumentData_extendedFilter = CHOICE(name=u'extendedFilter', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')), opt=True)
    _SearchArgumentData_checkOverspecified = BOOL(name=u'checkOverspecified', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _SearchArgumentData_relaxation = SEQ(name=u'relaxation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'RelaxationPolicy')), opt=True)
    _SearchArgumentData_extendedArea = INT(name=u'extendedArea', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchArgumentData_hierarchySelections = BIT_STR(name=u'hierarchySelections', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'HierarchySelections')), default=(1, 1))
    _SearchArgumentData_searchControlOptions = BIT_STR(name=u'searchControlOptions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchControlOptions')), default=(1, 1))
    _SearchArgumentData_joinArguments = SEQ_OF(name=u'joinArguments', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchArgumentData_joinArguments__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'JoinArgument')))
    _SearchArgumentData_joinArguments._cont = __SearchArgumentData_joinArguments__item_
    _SearchArgumentData_joinArguments._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SearchArgumentData_joinType = ENUM(name=u'joinType', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=u'leftOuterJoin')
    _SearchArgumentData_joinType._cont = ASN1Dict([(u'innerJoin', 0), (u'leftOuterJoin', 1), (u'fullOuterJoin', 2)])
    _SearchArgumentData_joinType._ext = None
    _SearchArgumentData_serviceControls = SET(name=u'serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _SearchArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _SearchArgumentData_requestor = SEQ_OF(name=u'requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _SearchArgumentData_operationProgress = SET(name=u'operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([(u'nameResolutionPhase', u'notStarted')]))
    _SearchArgumentData_aliasedRDNs = INT(name=u'aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchArgumentData_criticalExtensions = BIT_STR(name=u'criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchArgumentData_referenceType = ENUM(name=u'referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _SearchArgumentData_entryOnly = BOOL(name=u'entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _SearchArgumentData_exclusions = SET_OF(name=u'exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _SearchArgumentData_nameResolveOnMaster = BOOL(name=u'nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _SearchArgumentData_operationContexts = CHOICE(name=u'operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _SearchArgumentData_familyGrouping = ENUM(name=u'familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default=u'entryOnly')
    SearchArgumentData._cont = ASN1Dict([
        (u'baseObject', _SearchArgumentData_baseObject),
        (u'subset', _SearchArgumentData_subset),
        (u'filter', _SearchArgumentData_filter),
        (u'searchAliases', _SearchArgumentData_searchAliases),
        (u'selection', _SearchArgumentData_selection),
        (u'pagedResults', _SearchArgumentData_pagedResults),
        (u'matchedValuesOnly', _SearchArgumentData_matchedValuesOnly),
        (u'extendedFilter', _SearchArgumentData_extendedFilter),
        (u'checkOverspecified', _SearchArgumentData_checkOverspecified),
        (u'relaxation', _SearchArgumentData_relaxation),
        (u'extendedArea', _SearchArgumentData_extendedArea),
        (u'hierarchySelections', _SearchArgumentData_hierarchySelections),
        (u'searchControlOptions', _SearchArgumentData_searchControlOptions),
        (u'joinArguments', _SearchArgumentData_joinArguments),
        (u'joinType', _SearchArgumentData_joinType),
        (u'serviceControls', _SearchArgumentData_serviceControls),
        (u'securityParameters', _SearchArgumentData_securityParameters),
        (u'requestor', _SearchArgumentData_requestor),
        (u'operationProgress', _SearchArgumentData_operationProgress),
        (u'aliasedRDNs', _SearchArgumentData_aliasedRDNs),
        (u'criticalExtensions', _SearchArgumentData_criticalExtensions),
        (u'referenceType', _SearchArgumentData_referenceType),
        (u'entryOnly', _SearchArgumentData_entryOnly),
        (u'exclusions', _SearchArgumentData_exclusions),
        (u'nameResolveOnMaster', _SearchArgumentData_nameResolveOnMaster),
        (u'operationContexts', _SearchArgumentData_operationContexts),
        (u'familyGrouping', _SearchArgumentData_familyGrouping),
        ])
    SearchArgumentData._ext = [u'serviceControls', u'securityParameters', u'requestor', u'operationProgress', u'aliasedRDNs', u'criticalExtensions', u'referenceType', u'entryOnly', u'exclusions', u'nameResolveOnMaster', u'operationContexts', u'familyGrouping']
    
    #-----< HierarchySelections >-----#
    HierarchySelections = BIT_STR(name=u'HierarchySelections', mode=MODE_TYPE)
    HierarchySelections._cont = ASN1Dict([(u'self', 0), (u'children', 1), (u'parent', 2), (u'hierarchy', 3), (u'top', 4), (u'subtree', 5), (u'siblings', 6), (u'siblingChildren', 7), (u'siblingSubtree', 8), (u'all', 9)])
    
    #-----< SearchControlOptions >-----#
    SearchControlOptions = BIT_STR(name=u'SearchControlOptions', mode=MODE_TYPE)
    SearchControlOptions._cont = ASN1Dict([(u'searchAliases', 0), (u'matchedValuesOnly', 1), (u'checkOverspecified', 2), (u'performExactly', 3), (u'includeAllAreas', 4), (u'noSystemRelaxation', 5), (u'dnAttribute', 6), (u'matchOnResidualName', 7), (u'entryCount', 8), (u'useSubset', 9), (u'separateFamilyMembers', 10), (u'searchFamily', 11)])
    
    #-----< JoinArgument >-----#
    JoinArgument = SEQ(name=u'JoinArgument', mode=MODE_TYPE)
    _JoinArgument_joinBaseObject = CHOICE(name=u'joinBaseObject', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _JoinArgument_domainLocalID = CHOICE(name=u'domainLocalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'DomainLocalID')), opt=True)
    _JoinArgument_joinSubset = ENUM(name=u'joinSubset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=u'baseObject')
    _JoinArgument_joinSubset._cont = ASN1Dict([(u'baseObject', 0), (u'oneLevel', 1), (u'wholeSubtree', 2)])
    _JoinArgument_joinSubset._ext = []
    _JoinArgument_joinFilter = CHOICE(name=u'joinFilter', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Filter')), opt=True)
    _JoinArgument_joinAttributes = SEQ_OF(name=u'joinAttributes', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __JoinArgument_joinAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'JoinAttPair')))
    _JoinArgument_joinAttributes._cont = __JoinArgument_joinAttributes__item_
    _JoinArgument_joinAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _JoinArgument_joinSelection = SET(name=u'joinSelection', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformationSelection')))
    JoinArgument._cont = ASN1Dict([
        (u'joinBaseObject', _JoinArgument_joinBaseObject),
        (u'domainLocalID', _JoinArgument_domainLocalID),
        (u'joinSubset', _JoinArgument_joinSubset),
        (u'joinFilter', _JoinArgument_joinFilter),
        (u'joinAttributes', _JoinArgument_joinAttributes),
        (u'joinSelection', _JoinArgument_joinSelection),
        ])
    JoinArgument._ext = []
    
    #-----< DomainLocalID >-----#
    DomainLocalID = CHOICE(name=u'DomainLocalID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    
    #-----< JoinAttPair >-----#
    JoinAttPair = SEQ(name=u'JoinAttPair', mode=MODE_TYPE)
    _JoinAttPair_baseAtt = OID(name=u'baseAtt', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _JoinAttPair_joinAtt = OID(name=u'joinAtt', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _JoinAttPair_joinContext = SEQ_OF(name=u'joinContext', mode=MODE_TYPE, opt=True)
    __JoinAttPair_joinContext__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'JoinContextType')))
    _JoinAttPair_joinContext._cont = __JoinAttPair_joinContext__item_
    _JoinAttPair_joinContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    JoinAttPair._cont = ASN1Dict([
        (u'baseAtt', _JoinAttPair_baseAtt),
        (u'joinAtt', _JoinAttPair_joinAtt),
        (u'joinContext', _JoinAttPair_joinContext),
        ])
    JoinAttPair._ext = []
    
    #-----< JoinContextType >-----#
    JoinContextType = OID(name=u'JoinContextType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), [u'id']))
    _JoinContextType_tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _JoinContextType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    JoinContextType._const_tab = _JoinContextType_tab
    JoinContextType._const_tab_at = None
    JoinContextType._const_tab_id = u'id'
    
    #-----< SearchResult >-----#
    SearchResult = CHOICE(name=u'SearchResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _SearchResult_unsigned = CHOICE(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResultData')))
    _SearchResult_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __SearchResult_signed_toBeSigned = CHOICE(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResultData')))
    __SearchResult_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___SearchResult_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____SearchResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SearchResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SearchResult_signed_algorithmIdentifier_algorithm._const_tab = ____SearchResult_signed_algorithmIdentifier_algorithm_tab
    ___SearchResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___SearchResult_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___SearchResult_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____SearchResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SearchResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SearchResult_signed_algorithmIdentifier_parameters._const_tab = ____SearchResult_signed_algorithmIdentifier_parameters_tab
    ___SearchResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___SearchResult_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __SearchResult_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___SearchResult_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___SearchResult_signed_algorithmIdentifier_parameters),
        ])
    __SearchResult_signed_algorithmIdentifier._ext = []
    __SearchResult_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _SearchResult_signed._cont = ASN1Dict([
        (u'toBeSigned', __SearchResult_signed_toBeSigned),
        (u'algorithmIdentifier', __SearchResult_signed_algorithmIdentifier),
        (u'signature', __SearchResult_signed_signature),
        ])
    _SearchResult_signed._ext = []
    SearchResult._cont = ASN1Dict([
        (u'unsigned', _SearchResult_unsigned),
        (u'signed', _SearchResult_signed),
        ])
    SearchResult._ext = None
    
    #-----< SearchResultData >-----#
    SearchResultData = CHOICE(name=u'SearchResultData', mode=MODE_TYPE)
    _SearchResultData_searchInfo = SET(name=u'searchInfo', mode=MODE_TYPE)
    __SearchResultData_searchInfo_name = CHOICE(name=u'name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    __SearchResultData_searchInfo_entries = SET_OF(name=u'entries', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___SearchResultData_searchInfo_entries__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformation')))
    __SearchResultData_searchInfo_entries._cont = ___SearchResultData_searchInfo_entries__item_
    __SearchResultData_searchInfo_partialOutcomeQualifier = SET(name=u'partialOutcomeQualifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'PartialOutcomeQualifier')), opt=True)
    __SearchResultData_searchInfo_altMatching = BOOL(name=u'altMatching', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    __SearchResultData_searchInfo_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    __SearchResultData_searchInfo_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    __SearchResultData_searchInfo_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    __SearchResultData_searchInfo_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___SearchResultData_searchInfo_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____SearchResultData_searchInfo_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _____SearchResultData_searchInfo_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____SearchResultData_searchInfo_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____SearchResultData_searchInfo_notification__item__type._const_tab = _____SearchResultData_searchInfo_notification__item__type_tab
    ____SearchResultData_searchInfo_notification__item__type._const_tab_at = None
    ____SearchResultData_searchInfo_notification__item__type._const_tab_id = u'id'
    ____SearchResultData_searchInfo_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    _____SearchResultData_searchInfo_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____SearchResultData_searchInfo_notification__item__values__item_._const_tab = _____SearchResultData_searchInfo_notification__item__type_tab
    _____SearchResultData_searchInfo_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    _____SearchResultData_searchInfo_notification__item__values__item_._const_tab_id = u'Type'
    ____SearchResultData_searchInfo_notification__item__values._cont = _____SearchResultData_searchInfo_notification__item__values__item_
    ____SearchResultData_searchInfo_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____SearchResultData_searchInfo_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    _____SearchResultData_searchInfo_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value._const_tab = _____SearchResultData_searchInfo_notification__item__type_tab
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    _______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList._cont = _______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList__item_
    ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____SearchResultData_searchInfo_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value),
        (u'contextList', ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList),
        ])
    _____SearchResultData_searchInfo_notification__item__valuesWithContext__item_._ext = []
    ____SearchResultData_searchInfo_notification__item__valuesWithContext._cont = _____SearchResultData_searchInfo_notification__item__valuesWithContext__item_
    ____SearchResultData_searchInfo_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___SearchResultData_searchInfo_notification__item_._cont = ASN1Dict([
        (u'type', ____SearchResultData_searchInfo_notification__item__type),
        (u'values', ____SearchResultData_searchInfo_notification__item__values),
        (u'valuesWithContext', ____SearchResultData_searchInfo_notification__item__valuesWithContext),
        ])
    ___SearchResultData_searchInfo_notification__item_._ext = []
    __SearchResultData_searchInfo_notification._cont = ___SearchResultData_searchInfo_notification__item_
    _SearchResultData_searchInfo._cont = ASN1Dict([
        (u'name', __SearchResultData_searchInfo_name),
        (u'entries', __SearchResultData_searchInfo_entries),
        (u'partialOutcomeQualifier', __SearchResultData_searchInfo_partialOutcomeQualifier),
        (u'altMatching', __SearchResultData_searchInfo_altMatching),
        (u'securityParameters', __SearchResultData_searchInfo_securityParameters),
        (u'performer', __SearchResultData_searchInfo_performer),
        (u'aliasDereferenced', __SearchResultData_searchInfo_aliasDereferenced),
        (u'notification', __SearchResultData_searchInfo_notification),
        ])
    _SearchResultData_searchInfo._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    _SearchResultData_uncorrelatedSearchInfo = SET_OF(name=u'uncorrelatedSearchInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __SearchResultData_uncorrelatedSearchInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    _SearchResultData_uncorrelatedSearchInfo._cont = __SearchResultData_uncorrelatedSearchInfo__item_
    SearchResultData._cont = ASN1Dict([
        (u'searchInfo', _SearchResultData_searchInfo),
        (u'uncorrelatedSearchInfo', _SearchResultData_uncorrelatedSearchInfo),
        ])
    SearchResultData._ext = []
    
    #-----< addEntry >-----#
    addEntry = CLASS(name=u'addEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _addEntry_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    _addEntry_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    __OPERATION_Errors_val_ParameterType_5_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_5_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_5_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_5_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    addEntry._val = dict([(u'ArgumentType', _addEntry_val_ArgumentType), (u'ResultType', _addEntry_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))])
    
    #-----< AddEntryArgument >-----#
    AddEntryArgument = CHOICE(name=u'AddEntryArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _AddEntryArgument_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgumentData')))
    _AddEntryArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __AddEntryArgument_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgumentData')))
    __AddEntryArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___AddEntryArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____AddEntryArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AddEntryArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AddEntryArgument_signed_algorithmIdentifier_algorithm._const_tab = ____AddEntryArgument_signed_algorithmIdentifier_algorithm_tab
    ___AddEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___AddEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___AddEntryArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____AddEntryArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AddEntryArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AddEntryArgument_signed_algorithmIdentifier_parameters._const_tab = ____AddEntryArgument_signed_algorithmIdentifier_parameters_tab
    ___AddEntryArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___AddEntryArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __AddEntryArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___AddEntryArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___AddEntryArgument_signed_algorithmIdentifier_parameters),
        ])
    __AddEntryArgument_signed_algorithmIdentifier._ext = []
    __AddEntryArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _AddEntryArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __AddEntryArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __AddEntryArgument_signed_algorithmIdentifier),
        (u'signature', __AddEntryArgument_signed_signature),
        ])
    _AddEntryArgument_signed._ext = []
    AddEntryArgument._cont = ASN1Dict([
        (u'unsigned', _AddEntryArgument_unsigned),
        (u'signed', _AddEntryArgument_signed),
        ])
    AddEntryArgument._ext = None
    
    #-----< AddEntryArgumentData >-----#
    AddEntryArgumentData = SET(name=u'AddEntryArgumentData', mode=MODE_TYPE)
    _AddEntryArgumentData_object = CHOICE(name=u'object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _AddEntryArgumentData_entry = SET_OF(name=u'entry', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AddEntryArgumentData_entry__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AddEntryArgumentData_entry__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____AddEntryArgumentData_entry__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AddEntryArgumentData_entry__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____AddEntryArgumentData_entry__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AddEntryArgumentData_entry__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____AddEntryArgumentData_entry__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____AddEntryArgumentData_entry__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AddEntryArgumentData_entry__item__type._const_tab = ____AddEntryArgumentData_entry__item__type_tab
    ___AddEntryArgumentData_entry__item__type._const_tab_at = None
    ___AddEntryArgumentData_entry__item__type._const_tab_id = u'id'
    ___AddEntryArgumentData_entry__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____AddEntryArgumentData_entry__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____AddEntryArgumentData_entry__item__values__item_._const_tab = ____AddEntryArgumentData_entry__item__type_tab
    ____AddEntryArgumentData_entry__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____AddEntryArgumentData_entry__item__values__item_._const_tab_id = u'Type'
    ___AddEntryArgumentData_entry__item__values._cont = ____AddEntryArgumentData_entry__item__values__item_
    ___AddEntryArgumentData_entry__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AddEntryArgumentData_entry__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AddEntryArgumentData_entry__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__value._const_tab = ____AddEntryArgumentData_entry__item__type_tab
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______AddEntryArgumentData_entry__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__contextList._cont = ______AddEntryArgumentData_entry__item__valuesWithContext__item__contextList__item_
    _____AddEntryArgumentData_entry__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AddEntryArgumentData_entry__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____AddEntryArgumentData_entry__item__valuesWithContext__item__value),
        (u'contextList', _____AddEntryArgumentData_entry__item__valuesWithContext__item__contextList),
        ])
    ____AddEntryArgumentData_entry__item__valuesWithContext__item_._ext = []
    ___AddEntryArgumentData_entry__item__valuesWithContext._cont = ____AddEntryArgumentData_entry__item__valuesWithContext__item_
    ___AddEntryArgumentData_entry__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AddEntryArgumentData_entry__item_._cont = ASN1Dict([
        (u'type', ___AddEntryArgumentData_entry__item__type),
        (u'values', ___AddEntryArgumentData_entry__item__values),
        (u'valuesWithContext', ___AddEntryArgumentData_entry__item__valuesWithContext),
        ])
    __AddEntryArgumentData_entry__item_._ext = []
    _AddEntryArgumentData_entry._cont = __AddEntryArgumentData_entry__item_
    _AddEntryArgumentData_targetSystem = SET(name=u'targetSystem', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')), opt=True)
    _AddEntryArgumentData_serviceControls = SET(name=u'serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _AddEntryArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AddEntryArgumentData_requestor = SEQ_OF(name=u'requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AddEntryArgumentData_operationProgress = SET(name=u'operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([(u'nameResolutionPhase', u'notStarted')]))
    _AddEntryArgumentData_aliasedRDNs = INT(name=u'aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _AddEntryArgumentData_criticalExtensions = BIT_STR(name=u'criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _AddEntryArgumentData_referenceType = ENUM(name=u'referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _AddEntryArgumentData_entryOnly = BOOL(name=u'entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _AddEntryArgumentData_exclusions = SET_OF(name=u'exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _AddEntryArgumentData_nameResolveOnMaster = BOOL(name=u'nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AddEntryArgumentData_operationContexts = CHOICE(name=u'operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _AddEntryArgumentData_familyGrouping = ENUM(name=u'familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default=u'entryOnly')
    AddEntryArgumentData._cont = ASN1Dict([
        (u'object', _AddEntryArgumentData_object),
        (u'entry', _AddEntryArgumentData_entry),
        (u'targetSystem', _AddEntryArgumentData_targetSystem),
        (u'serviceControls', _AddEntryArgumentData_serviceControls),
        (u'securityParameters', _AddEntryArgumentData_securityParameters),
        (u'requestor', _AddEntryArgumentData_requestor),
        (u'operationProgress', _AddEntryArgumentData_operationProgress),
        (u'aliasedRDNs', _AddEntryArgumentData_aliasedRDNs),
        (u'criticalExtensions', _AddEntryArgumentData_criticalExtensions),
        (u'referenceType', _AddEntryArgumentData_referenceType),
        (u'entryOnly', _AddEntryArgumentData_entryOnly),
        (u'exclusions', _AddEntryArgumentData_exclusions),
        (u'nameResolveOnMaster', _AddEntryArgumentData_nameResolveOnMaster),
        (u'operationContexts', _AddEntryArgumentData_operationContexts),
        (u'familyGrouping', _AddEntryArgumentData_familyGrouping),
        ])
    AddEntryArgumentData._ext = [u'serviceControls', u'securityParameters', u'requestor', u'operationProgress', u'aliasedRDNs', u'criticalExtensions', u'referenceType', u'entryOnly', u'exclusions', u'nameResolveOnMaster', u'operationContexts', u'familyGrouping']
    
    #-----< AddEntryResult >-----#
    AddEntryResult = CHOICE(name=u'AddEntryResult', mode=MODE_TYPE)
    _AddEntryResult_null = NULL(name=u'null', mode=MODE_TYPE)
    _AddEntryResult_information = CHOICE(name=u'information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __AddEntryResult_information_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResultData')))
    __AddEntryResult_information_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___AddEntryResult_information_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResultData')))
    ___AddEntryResult_information_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____AddEntryResult_information_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____AddEntryResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AddEntryResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AddEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____AddEntryResult_information_signed_algorithmIdentifier_algorithm_tab
    ____AddEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____AddEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____AddEntryResult_information_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____AddEntryResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AddEntryResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AddEntryResult_information_signed_algorithmIdentifier_parameters._const_tab = _____AddEntryResult_information_signed_algorithmIdentifier_parameters_tab
    ____AddEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____AddEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___AddEntryResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____AddEntryResult_information_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____AddEntryResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___AddEntryResult_information_signed_algorithmIdentifier._ext = []
    ___AddEntryResult_information_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __AddEntryResult_information_signed._cont = ASN1Dict([
        (u'toBeSigned', ___AddEntryResult_information_signed_toBeSigned),
        (u'algorithmIdentifier', ___AddEntryResult_information_signed_algorithmIdentifier),
        (u'signature', ___AddEntryResult_information_signed_signature),
        ])
    __AddEntryResult_information_signed._ext = []
    _AddEntryResult_information._cont = ASN1Dict([
        (u'unsigned', __AddEntryResult_information_unsigned),
        (u'signed', __AddEntryResult_information_signed),
        ])
    _AddEntryResult_information._ext = None
    AddEntryResult._cont = ASN1Dict([
        (u'null', _AddEntryResult_null),
        (u'information', _AddEntryResult_information),
        ])
    AddEntryResult._ext = []
    
    #-----< AddEntryResultData >-----#
    AddEntryResultData = SEQ(name=u'AddEntryResultData', mode=MODE_TYPE)
    _AddEntryResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AddEntryResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AddEntryResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AddEntryResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AddEntryResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AddEntryResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____AddEntryResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AddEntryResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____AddEntryResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AddEntryResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____AddEntryResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____AddEntryResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AddEntryResultData_notification__item__type._const_tab = ____AddEntryResultData_notification__item__type_tab
    ___AddEntryResultData_notification__item__type._const_tab_at = None
    ___AddEntryResultData_notification__item__type._const_tab_id = u'id'
    ___AddEntryResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____AddEntryResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____AddEntryResultData_notification__item__values__item_._const_tab = ____AddEntryResultData_notification__item__type_tab
    ____AddEntryResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____AddEntryResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___AddEntryResultData_notification__item__values._cont = ____AddEntryResultData_notification__item__values__item_
    ___AddEntryResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AddEntryResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AddEntryResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AddEntryResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____AddEntryResultData_notification__item__valuesWithContext__item__value._const_tab = ____AddEntryResultData_notification__item__type_tab
    _____AddEntryResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____AddEntryResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____AddEntryResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______AddEntryResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AddEntryResultData_notification__item__valuesWithContext__item__contextList._cont = ______AddEntryResultData_notification__item__valuesWithContext__item__contextList__item_
    _____AddEntryResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AddEntryResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____AddEntryResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____AddEntryResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AddEntryResultData_notification__item__valuesWithContext__item_._ext = []
    ___AddEntryResultData_notification__item__valuesWithContext._cont = ____AddEntryResultData_notification__item__valuesWithContext__item_
    ___AddEntryResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AddEntryResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___AddEntryResultData_notification__item__type),
        (u'values', ___AddEntryResultData_notification__item__values),
        (u'valuesWithContext', ___AddEntryResultData_notification__item__valuesWithContext),
        ])
    __AddEntryResultData_notification__item_._ext = []
    _AddEntryResultData_notification._cont = __AddEntryResultData_notification__item_
    AddEntryResultData._cont = ASN1Dict([
        (u'securityParameters', _AddEntryResultData_securityParameters),
        (u'performer', _AddEntryResultData_performer),
        (u'aliasDereferenced', _AddEntryResultData_aliasDereferenced),
        (u'notification', _AddEntryResultData_notification),
        ])
    AddEntryResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< removeEntry >-----#
    removeEntry = CLASS(name=u'removeEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _removeEntry_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    _removeEntry_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    __OPERATION_Errors_val_ParameterType_3_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_3_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_3_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_3_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_1._ext = None
    __OPERATION_Errors_val_ParameterType_4_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_1._ext = None
    removeEntry._val = dict([(u'ArgumentType', _removeEntry_val_ArgumentType), (u'ResultType', _removeEntry_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))])
    
    #-----< RemoveEntryArgument >-----#
    RemoveEntryArgument = CHOICE(name=u'RemoveEntryArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _RemoveEntryArgument_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgumentData')))
    _RemoveEntryArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __RemoveEntryArgument_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgumentData')))
    __RemoveEntryArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____RemoveEntryArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____RemoveEntryArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm._const_tab = ____RemoveEntryArgument_signed_algorithmIdentifier_algorithm_tab
    ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___RemoveEntryArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____RemoveEntryArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____RemoveEntryArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RemoveEntryArgument_signed_algorithmIdentifier_parameters._const_tab = ____RemoveEntryArgument_signed_algorithmIdentifier_parameters_tab
    ___RemoveEntryArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___RemoveEntryArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __RemoveEntryArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___RemoveEntryArgument_signed_algorithmIdentifier_parameters),
        ])
    __RemoveEntryArgument_signed_algorithmIdentifier._ext = []
    __RemoveEntryArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _RemoveEntryArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __RemoveEntryArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __RemoveEntryArgument_signed_algorithmIdentifier),
        (u'signature', __RemoveEntryArgument_signed_signature),
        ])
    _RemoveEntryArgument_signed._ext = []
    RemoveEntryArgument._cont = ASN1Dict([
        (u'unsigned', _RemoveEntryArgument_unsigned),
        (u'signed', _RemoveEntryArgument_signed),
        ])
    RemoveEntryArgument._ext = None
    
    #-----< RemoveEntryArgumentData >-----#
    RemoveEntryArgumentData = SET(name=u'RemoveEntryArgumentData', mode=MODE_TYPE)
    _RemoveEntryArgumentData_object = CHOICE(name=u'object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _RemoveEntryArgumentData_serviceControls = SET(name=u'serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _RemoveEntryArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _RemoveEntryArgumentData_requestor = SEQ_OF(name=u'requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _RemoveEntryArgumentData_operationProgress = SET(name=u'operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([(u'nameResolutionPhase', u'notStarted')]))
    _RemoveEntryArgumentData_aliasedRDNs = INT(name=u'aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _RemoveEntryArgumentData_criticalExtensions = BIT_STR(name=u'criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _RemoveEntryArgumentData_referenceType = ENUM(name=u'referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _RemoveEntryArgumentData_entryOnly = BOOL(name=u'entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _RemoveEntryArgumentData_exclusions = SET_OF(name=u'exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _RemoveEntryArgumentData_nameResolveOnMaster = BOOL(name=u'nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _RemoveEntryArgumentData_operationContexts = CHOICE(name=u'operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _RemoveEntryArgumentData_familyGrouping = ENUM(name=u'familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default=u'entryOnly')
    RemoveEntryArgumentData._cont = ASN1Dict([
        (u'object', _RemoveEntryArgumentData_object),
        (u'serviceControls', _RemoveEntryArgumentData_serviceControls),
        (u'securityParameters', _RemoveEntryArgumentData_securityParameters),
        (u'requestor', _RemoveEntryArgumentData_requestor),
        (u'operationProgress', _RemoveEntryArgumentData_operationProgress),
        (u'aliasedRDNs', _RemoveEntryArgumentData_aliasedRDNs),
        (u'criticalExtensions', _RemoveEntryArgumentData_criticalExtensions),
        (u'referenceType', _RemoveEntryArgumentData_referenceType),
        (u'entryOnly', _RemoveEntryArgumentData_entryOnly),
        (u'exclusions', _RemoveEntryArgumentData_exclusions),
        (u'nameResolveOnMaster', _RemoveEntryArgumentData_nameResolveOnMaster),
        (u'operationContexts', _RemoveEntryArgumentData_operationContexts),
        (u'familyGrouping', _RemoveEntryArgumentData_familyGrouping),
        ])
    RemoveEntryArgumentData._ext = [u'serviceControls', u'securityParameters', u'requestor', u'operationProgress', u'aliasedRDNs', u'criticalExtensions', u'referenceType', u'entryOnly', u'exclusions', u'nameResolveOnMaster', u'operationContexts', u'familyGrouping']
    
    #-----< RemoveEntryResult >-----#
    RemoveEntryResult = CHOICE(name=u'RemoveEntryResult', mode=MODE_TYPE)
    _RemoveEntryResult_null = NULL(name=u'null', mode=MODE_TYPE)
    _RemoveEntryResult_information = CHOICE(name=u'information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __RemoveEntryResult_information_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResultData')))
    __RemoveEntryResult_information_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___RemoveEntryResult_information_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResultData')))
    ___RemoveEntryResult_information_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm_tab
    ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____RemoveEntryResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____RemoveEntryResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters._const_tab = _____RemoveEntryResult_information_signed_algorithmIdentifier_parameters_tab
    ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___RemoveEntryResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___RemoveEntryResult_information_signed_algorithmIdentifier._ext = []
    ___RemoveEntryResult_information_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __RemoveEntryResult_information_signed._cont = ASN1Dict([
        (u'toBeSigned', ___RemoveEntryResult_information_signed_toBeSigned),
        (u'algorithmIdentifier', ___RemoveEntryResult_information_signed_algorithmIdentifier),
        (u'signature', ___RemoveEntryResult_information_signed_signature),
        ])
    __RemoveEntryResult_information_signed._ext = []
    _RemoveEntryResult_information._cont = ASN1Dict([
        (u'unsigned', __RemoveEntryResult_information_unsigned),
        (u'signed', __RemoveEntryResult_information_signed),
        ])
    _RemoveEntryResult_information._ext = None
    RemoveEntryResult._cont = ASN1Dict([
        (u'null', _RemoveEntryResult_null),
        (u'information', _RemoveEntryResult_information),
        ])
    RemoveEntryResult._ext = []
    
    #-----< RemoveEntryResultData >-----#
    RemoveEntryResultData = SEQ(name=u'RemoveEntryResultData', mode=MODE_TYPE)
    _RemoveEntryResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _RemoveEntryResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _RemoveEntryResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _RemoveEntryResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RemoveEntryResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___RemoveEntryResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____RemoveEntryResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____RemoveEntryResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____RemoveEntryResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____RemoveEntryResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____RemoveEntryResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____RemoveEntryResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___RemoveEntryResultData_notification__item__type._const_tab = ____RemoveEntryResultData_notification__item__type_tab
    ___RemoveEntryResultData_notification__item__type._const_tab_at = None
    ___RemoveEntryResultData_notification__item__type._const_tab_id = u'id'
    ___RemoveEntryResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____RemoveEntryResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____RemoveEntryResultData_notification__item__values__item_._const_tab = ____RemoveEntryResultData_notification__item__type_tab
    ____RemoveEntryResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____RemoveEntryResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___RemoveEntryResultData_notification__item__values._cont = ____RemoveEntryResultData_notification__item__values__item_
    ___RemoveEntryResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___RemoveEntryResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____RemoveEntryResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__value._const_tab = ____RemoveEntryResultData_notification__item__type_tab
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______RemoveEntryResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__contextList._cont = ______RemoveEntryResultData_notification__item__valuesWithContext__item__contextList__item_
    _____RemoveEntryResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____RemoveEntryResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____RemoveEntryResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____RemoveEntryResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____RemoveEntryResultData_notification__item__valuesWithContext__item_._ext = []
    ___RemoveEntryResultData_notification__item__valuesWithContext._cont = ____RemoveEntryResultData_notification__item__valuesWithContext__item_
    ___RemoveEntryResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __RemoveEntryResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___RemoveEntryResultData_notification__item__type),
        (u'values', ___RemoveEntryResultData_notification__item__values),
        (u'valuesWithContext', ___RemoveEntryResultData_notification__item__valuesWithContext),
        ])
    __RemoveEntryResultData_notification__item_._ext = []
    _RemoveEntryResultData_notification._cont = __RemoveEntryResultData_notification__item_
    RemoveEntryResultData._cont = ASN1Dict([
        (u'securityParameters', _RemoveEntryResultData_securityParameters),
        (u'performer', _RemoveEntryResultData_performer),
        (u'aliasDereferenced', _RemoveEntryResultData_aliasDereferenced),
        (u'notification', _RemoveEntryResultData_notification),
        ])
    RemoveEntryResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< modifyEntry >-----#
    modifyEntry = CLASS(name=u'modifyEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _modifyEntry_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    _modifyEntry_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    modifyEntry._val = dict([(u'ArgumentType', _modifyEntry_val_ArgumentType), (u'ResultType', _modifyEntry_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))])
    
    #-----< ModifyEntryArgument >-----#
    ModifyEntryArgument = CHOICE(name=u'ModifyEntryArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ModifyEntryArgument_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgumentData')))
    _ModifyEntryArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ModifyEntryArgument_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgumentData')))
    __ModifyEntryArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____ModifyEntryArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyEntryArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ModifyEntryArgument_signed_algorithmIdentifier_algorithm_tab
    ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___ModifyEntryArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____ModifyEntryArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyEntryArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyEntryArgument_signed_algorithmIdentifier_parameters._const_tab = ____ModifyEntryArgument_signed_algorithmIdentifier_parameters_tab
    ___ModifyEntryArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___ModifyEntryArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __ModifyEntryArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___ModifyEntryArgument_signed_algorithmIdentifier_parameters),
        ])
    __ModifyEntryArgument_signed_algorithmIdentifier._ext = []
    __ModifyEntryArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _ModifyEntryArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __ModifyEntryArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __ModifyEntryArgument_signed_algorithmIdentifier),
        (u'signature', __ModifyEntryArgument_signed_signature),
        ])
    _ModifyEntryArgument_signed._ext = []
    ModifyEntryArgument._cont = ASN1Dict([
        (u'unsigned', _ModifyEntryArgument_unsigned),
        (u'signed', _ModifyEntryArgument_signed),
        ])
    ModifyEntryArgument._ext = None
    
    #-----< ModifyEntryArgumentData >-----#
    ModifyEntryArgumentData = SET(name=u'ModifyEntryArgumentData', mode=MODE_TYPE)
    _ModifyEntryArgumentData_object = CHOICE(name=u'object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _ModifyEntryArgumentData_changes = SEQ_OF(name=u'changes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ModifyEntryArgumentData_changes__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'EntryModification')))
    _ModifyEntryArgumentData_changes._cont = __ModifyEntryArgumentData_changes__item_
    _ModifyEntryArgumentData_selection = SET(name=u'selection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformationSelection')), opt=True)
    _ModifyEntryArgumentData_serviceControls = SET(name=u'serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _ModifyEntryArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ModifyEntryArgumentData_requestor = SEQ_OF(name=u'requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyEntryArgumentData_operationProgress = SET(name=u'operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([(u'nameResolutionPhase', u'notStarted')]))
    _ModifyEntryArgumentData_aliasedRDNs = INT(name=u'aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ModifyEntryArgumentData_criticalExtensions = BIT_STR(name=u'criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ModifyEntryArgumentData_referenceType = ENUM(name=u'referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _ModifyEntryArgumentData_entryOnly = BOOL(name=u'entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _ModifyEntryArgumentData_exclusions = SET_OF(name=u'exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ModifyEntryArgumentData_nameResolveOnMaster = BOOL(name=u'nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyEntryArgumentData_operationContexts = CHOICE(name=u'operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _ModifyEntryArgumentData_familyGrouping = ENUM(name=u'familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default=u'entryOnly')
    ModifyEntryArgumentData._cont = ASN1Dict([
        (u'object', _ModifyEntryArgumentData_object),
        (u'changes', _ModifyEntryArgumentData_changes),
        (u'selection', _ModifyEntryArgumentData_selection),
        (u'serviceControls', _ModifyEntryArgumentData_serviceControls),
        (u'securityParameters', _ModifyEntryArgumentData_securityParameters),
        (u'requestor', _ModifyEntryArgumentData_requestor),
        (u'operationProgress', _ModifyEntryArgumentData_operationProgress),
        (u'aliasedRDNs', _ModifyEntryArgumentData_aliasedRDNs),
        (u'criticalExtensions', _ModifyEntryArgumentData_criticalExtensions),
        (u'referenceType', _ModifyEntryArgumentData_referenceType),
        (u'entryOnly', _ModifyEntryArgumentData_entryOnly),
        (u'exclusions', _ModifyEntryArgumentData_exclusions),
        (u'nameResolveOnMaster', _ModifyEntryArgumentData_nameResolveOnMaster),
        (u'operationContexts', _ModifyEntryArgumentData_operationContexts),
        (u'familyGrouping', _ModifyEntryArgumentData_familyGrouping),
        ])
    ModifyEntryArgumentData._ext = [u'serviceControls', u'securityParameters', u'requestor', u'operationProgress', u'aliasedRDNs', u'criticalExtensions', u'referenceType', u'entryOnly', u'exclusions', u'nameResolveOnMaster', u'operationContexts', u'familyGrouping']
    
    #-----< ModifyEntryResult >-----#
    ModifyEntryResult = CHOICE(name=u'ModifyEntryResult', mode=MODE_TYPE)
    _ModifyEntryResult_null = NULL(name=u'null', mode=MODE_TYPE)
    _ModifyEntryResult_information = CHOICE(name=u'information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __ModifyEntryResult_information_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResultData')))
    __ModifyEntryResult_information_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___ModifyEntryResult_information_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResultData')))
    ___ModifyEntryResult_information_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm_tab
    ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____ModifyEntryResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyEntryResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters._const_tab = _____ModifyEntryResult_information_signed_algorithmIdentifier_parameters_tab
    ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___ModifyEntryResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___ModifyEntryResult_information_signed_algorithmIdentifier._ext = []
    ___ModifyEntryResult_information_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __ModifyEntryResult_information_signed._cont = ASN1Dict([
        (u'toBeSigned', ___ModifyEntryResult_information_signed_toBeSigned),
        (u'algorithmIdentifier', ___ModifyEntryResult_information_signed_algorithmIdentifier),
        (u'signature', ___ModifyEntryResult_information_signed_signature),
        ])
    __ModifyEntryResult_information_signed._ext = []
    _ModifyEntryResult_information._cont = ASN1Dict([
        (u'unsigned', __ModifyEntryResult_information_unsigned),
        (u'signed', __ModifyEntryResult_information_signed),
        ])
    _ModifyEntryResult_information._ext = None
    ModifyEntryResult._cont = ASN1Dict([
        (u'null', _ModifyEntryResult_null),
        (u'information', _ModifyEntryResult_information),
        ])
    ModifyEntryResult._ext = []
    
    #-----< ModifyEntryResultData >-----#
    ModifyEntryResultData = SEQ(name=u'ModifyEntryResultData', mode=MODE_TYPE)
    _ModifyEntryResultData_entry = SEQ(name=u'entry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EntryInformation')), opt=True)
    _ModifyEntryResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ModifyEntryResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyEntryResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyEntryResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ModifyEntryResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ModifyEntryResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____ModifyEntryResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ModifyEntryResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____ModifyEntryResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ModifyEntryResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____ModifyEntryResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____ModifyEntryResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ModifyEntryResultData_notification__item__type._const_tab = ____ModifyEntryResultData_notification__item__type_tab
    ___ModifyEntryResultData_notification__item__type._const_tab_at = None
    ___ModifyEntryResultData_notification__item__type._const_tab_id = u'id'
    ___ModifyEntryResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____ModifyEntryResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____ModifyEntryResultData_notification__item__values__item_._const_tab = ____ModifyEntryResultData_notification__item__type_tab
    ____ModifyEntryResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____ModifyEntryResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___ModifyEntryResultData_notification__item__values._cont = ____ModifyEntryResultData_notification__item__values__item_
    ___ModifyEntryResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ModifyEntryResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ModifyEntryResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__value._const_tab = ____ModifyEntryResultData_notification__item__type_tab
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______ModifyEntryResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__contextList._cont = ______ModifyEntryResultData_notification__item__valuesWithContext__item__contextList__item_
    _____ModifyEntryResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ModifyEntryResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____ModifyEntryResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____ModifyEntryResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ModifyEntryResultData_notification__item__valuesWithContext__item_._ext = []
    ___ModifyEntryResultData_notification__item__valuesWithContext._cont = ____ModifyEntryResultData_notification__item__valuesWithContext__item_
    ___ModifyEntryResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ModifyEntryResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___ModifyEntryResultData_notification__item__type),
        (u'values', ___ModifyEntryResultData_notification__item__values),
        (u'valuesWithContext', ___ModifyEntryResultData_notification__item__valuesWithContext),
        ])
    __ModifyEntryResultData_notification__item_._ext = []
    _ModifyEntryResultData_notification._cont = __ModifyEntryResultData_notification__item_
    ModifyEntryResultData._cont = ASN1Dict([
        (u'entry', _ModifyEntryResultData_entry),
        (u'securityParameters', _ModifyEntryResultData_securityParameters),
        (u'performer', _ModifyEntryResultData_performer),
        (u'aliasDereferenced', _ModifyEntryResultData_aliasDereferenced),
        (u'notification', _ModifyEntryResultData_notification),
        ])
    ModifyEntryResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< EntryModification >-----#
    EntryModification = CHOICE(name=u'EntryModification', mode=MODE_TYPE)
    _EntryModification_addAttribute = SEQ(name=u'addAttribute', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __EntryModification_addAttribute_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ___EntryModification_addAttribute_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ____EntryModification_addAttribute_type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ____EntryModification_addAttribute_type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ___EntryModification_addAttribute_type_tab._val = ASN1Set(rv=[dict([(u'Type', ____EntryModification_addAttribute_type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ____EntryModification_addAttribute_type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    __EntryModification_addAttribute_type._const_tab = ___EntryModification_addAttribute_type_tab
    __EntryModification_addAttribute_type._const_tab_at = None
    __EntryModification_addAttribute_type._const_tab_id = u'id'
    __EntryModification_addAttribute_values = SET_OF(name=u'values', mode=MODE_TYPE)
    ___EntryModification_addAttribute_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ___EntryModification_addAttribute_values__item_._const_tab = ___EntryModification_addAttribute_type_tab
    ___EntryModification_addAttribute_values__item_._const_tab_at = ('..', '..', u'type')
    ___EntryModification_addAttribute_values__item_._const_tab_id = u'Type'
    __EntryModification_addAttribute_values._cont = ___EntryModification_addAttribute_values__item_
    __EntryModification_addAttribute_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __EntryModification_addAttribute_valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ___EntryModification_addAttribute_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____EntryModification_addAttribute_valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____EntryModification_addAttribute_valuesWithContext__item__value._const_tab = ___EntryModification_addAttribute_type_tab
    ____EntryModification_addAttribute_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    ____EntryModification_addAttribute_valuesWithContext__item__value._const_tab_id = u'Type'
    ____EntryModification_addAttribute_valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    _____EntryModification_addAttribute_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____EntryModification_addAttribute_valuesWithContext__item__contextList._cont = _____EntryModification_addAttribute_valuesWithContext__item__contextList__item_
    ____EntryModification_addAttribute_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___EntryModification_addAttribute_valuesWithContext__item_._cont = ASN1Dict([
        (u'value', ____EntryModification_addAttribute_valuesWithContext__item__value),
        (u'contextList', ____EntryModification_addAttribute_valuesWithContext__item__contextList),
        ])
    ___EntryModification_addAttribute_valuesWithContext__item_._ext = []
    __EntryModification_addAttribute_valuesWithContext._cont = ___EntryModification_addAttribute_valuesWithContext__item_
    __EntryModification_addAttribute_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryModification_addAttribute._cont = ASN1Dict([
        (u'type', __EntryModification_addAttribute_type),
        (u'values', __EntryModification_addAttribute_values),
        (u'valuesWithContext', __EntryModification_addAttribute_valuesWithContext),
        ])
    _EntryModification_addAttribute._ext = []
    _EntryModification_removeAttribute = OID(name=u'removeAttribute', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _EntryModification_addValues = SEQ(name=u'addValues', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __EntryModification_addValues_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    __EntryModification_addValues_type._const_tab = ___EntryModification_addAttribute_type_tab
    __EntryModification_addValues_type._const_tab_at = None
    __EntryModification_addValues_type._const_tab_id = u'id'
    __EntryModification_addValues_values = SET_OF(name=u'values', mode=MODE_TYPE)
    ___EntryModification_addValues_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ___EntryModification_addValues_values__item_._const_tab = ___EntryModification_addAttribute_type_tab
    ___EntryModification_addValues_values__item_._const_tab_at = ('..', '..', u'type')
    ___EntryModification_addValues_values__item_._const_tab_id = u'Type'
    __EntryModification_addValues_values._cont = ___EntryModification_addValues_values__item_
    __EntryModification_addValues_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __EntryModification_addValues_valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ___EntryModification_addValues_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____EntryModification_addValues_valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____EntryModification_addValues_valuesWithContext__item__value._const_tab = ___EntryModification_addAttribute_type_tab
    ____EntryModification_addValues_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    ____EntryModification_addValues_valuesWithContext__item__value._const_tab_id = u'Type'
    ____EntryModification_addValues_valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    _____EntryModification_addValues_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____EntryModification_addValues_valuesWithContext__item__contextList._cont = _____EntryModification_addValues_valuesWithContext__item__contextList__item_
    ____EntryModification_addValues_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___EntryModification_addValues_valuesWithContext__item_._cont = ASN1Dict([
        (u'value', ____EntryModification_addValues_valuesWithContext__item__value),
        (u'contextList', ____EntryModification_addValues_valuesWithContext__item__contextList),
        ])
    ___EntryModification_addValues_valuesWithContext__item_._ext = []
    __EntryModification_addValues_valuesWithContext._cont = ___EntryModification_addValues_valuesWithContext__item_
    __EntryModification_addValues_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryModification_addValues._cont = ASN1Dict([
        (u'type', __EntryModification_addValues_type),
        (u'values', __EntryModification_addValues_values),
        (u'valuesWithContext', __EntryModification_addValues_valuesWithContext),
        ])
    _EntryModification_addValues._ext = []
    _EntryModification_removeValues = SEQ(name=u'removeValues', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __EntryModification_removeValues_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    __EntryModification_removeValues_type._const_tab = ___EntryModification_addAttribute_type_tab
    __EntryModification_removeValues_type._const_tab_at = None
    __EntryModification_removeValues_type._const_tab_id = u'id'
    __EntryModification_removeValues_values = SET_OF(name=u'values', mode=MODE_TYPE)
    ___EntryModification_removeValues_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ___EntryModification_removeValues_values__item_._const_tab = ___EntryModification_addAttribute_type_tab
    ___EntryModification_removeValues_values__item_._const_tab_at = ('..', '..', u'type')
    ___EntryModification_removeValues_values__item_._const_tab_id = u'Type'
    __EntryModification_removeValues_values._cont = ___EntryModification_removeValues_values__item_
    __EntryModification_removeValues_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __EntryModification_removeValues_valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ___EntryModification_removeValues_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____EntryModification_removeValues_valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____EntryModification_removeValues_valuesWithContext__item__value._const_tab = ___EntryModification_addAttribute_type_tab
    ____EntryModification_removeValues_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    ____EntryModification_removeValues_valuesWithContext__item__value._const_tab_id = u'Type'
    ____EntryModification_removeValues_valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    _____EntryModification_removeValues_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____EntryModification_removeValues_valuesWithContext__item__contextList._cont = _____EntryModification_removeValues_valuesWithContext__item__contextList__item_
    ____EntryModification_removeValues_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___EntryModification_removeValues_valuesWithContext__item_._cont = ASN1Dict([
        (u'value', ____EntryModification_removeValues_valuesWithContext__item__value),
        (u'contextList', ____EntryModification_removeValues_valuesWithContext__item__contextList),
        ])
    ___EntryModification_removeValues_valuesWithContext__item_._ext = []
    __EntryModification_removeValues_valuesWithContext._cont = ___EntryModification_removeValues_valuesWithContext__item_
    __EntryModification_removeValues_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryModification_removeValues._cont = ASN1Dict([
        (u'type', __EntryModification_removeValues_type),
        (u'values', __EntryModification_removeValues_values),
        (u'valuesWithContext', __EntryModification_removeValues_valuesWithContext),
        ])
    _EntryModification_removeValues._ext = []
    _EntryModification_alterValues = SEQ(name=u'alterValues', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    _EntryModification_resetValue = OID(name=u'resetValue', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _EntryModification_replaceValues = SEQ(name=u'replaceValues', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __EntryModification_replaceValues_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    __EntryModification_replaceValues_type._const_tab = ___EntryModification_addAttribute_type_tab
    __EntryModification_replaceValues_type._const_tab_at = None
    __EntryModification_replaceValues_type._const_tab_id = u'id'
    __EntryModification_replaceValues_values = SET_OF(name=u'values', mode=MODE_TYPE)
    ___EntryModification_replaceValues_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ___EntryModification_replaceValues_values__item_._const_tab = ___EntryModification_addAttribute_type_tab
    ___EntryModification_replaceValues_values__item_._const_tab_at = ('..', '..', u'type')
    ___EntryModification_replaceValues_values__item_._const_tab_id = u'Type'
    __EntryModification_replaceValues_values._cont = ___EntryModification_replaceValues_values__item_
    __EntryModification_replaceValues_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __EntryModification_replaceValues_valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ___EntryModification_replaceValues_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____EntryModification_replaceValues_valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____EntryModification_replaceValues_valuesWithContext__item__value._const_tab = ___EntryModification_addAttribute_type_tab
    ____EntryModification_replaceValues_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    ____EntryModification_replaceValues_valuesWithContext__item__value._const_tab_id = u'Type'
    ____EntryModification_replaceValues_valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    _____EntryModification_replaceValues_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____EntryModification_replaceValues_valuesWithContext__item__contextList._cont = _____EntryModification_replaceValues_valuesWithContext__item__contextList__item_
    ____EntryModification_replaceValues_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___EntryModification_replaceValues_valuesWithContext__item_._cont = ASN1Dict([
        (u'value', ____EntryModification_replaceValues_valuesWithContext__item__value),
        (u'contextList', ____EntryModification_replaceValues_valuesWithContext__item__contextList),
        ])
    ___EntryModification_replaceValues_valuesWithContext__item_._ext = []
    __EntryModification_replaceValues_valuesWithContext._cont = ___EntryModification_replaceValues_valuesWithContext__item_
    __EntryModification_replaceValues_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EntryModification_replaceValues._cont = ASN1Dict([
        (u'type', __EntryModification_replaceValues_type),
        (u'values', __EntryModification_replaceValues_values),
        (u'valuesWithContext', __EntryModification_replaceValues_valuesWithContext),
        ])
    _EntryModification_replaceValues._ext = []
    EntryModification._cont = ASN1Dict([
        (u'addAttribute', _EntryModification_addAttribute),
        (u'removeAttribute', _EntryModification_removeAttribute),
        (u'addValues', _EntryModification_addValues),
        (u'removeValues', _EntryModification_removeValues),
        (u'alterValues', _EntryModification_alterValues),
        (u'resetValue', _EntryModification_resetValue),
        (u'replaceValues', _EntryModification_replaceValues),
        ])
    EntryModification._ext = []
    
    #-----< modifyDN >-----#
    modifyDN = CLASS(name=u'modifyDN', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _modifyDN_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    _modifyDN_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    modifyDN._val = dict([(u'ArgumentType', _modifyDN_val_ArgumentType), (u'ResultType', _modifyDN_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))])
    
    #-----< ModifyDNArgument >-----#
    ModifyDNArgument = CHOICE(name=u'ModifyDNArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _ModifyDNArgument_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgumentData')))
    _ModifyDNArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ModifyDNArgument_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgumentData')))
    __ModifyDNArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ModifyDNArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____ModifyDNArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyDNArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyDNArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ModifyDNArgument_signed_algorithmIdentifier_algorithm_tab
    ___ModifyDNArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ModifyDNArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___ModifyDNArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____ModifyDNArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyDNArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyDNArgument_signed_algorithmIdentifier_parameters._const_tab = ____ModifyDNArgument_signed_algorithmIdentifier_parameters_tab
    ___ModifyDNArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___ModifyDNArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __ModifyDNArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___ModifyDNArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___ModifyDNArgument_signed_algorithmIdentifier_parameters),
        ])
    __ModifyDNArgument_signed_algorithmIdentifier._ext = []
    __ModifyDNArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _ModifyDNArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __ModifyDNArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __ModifyDNArgument_signed_algorithmIdentifier),
        (u'signature', __ModifyDNArgument_signed_signature),
        ])
    _ModifyDNArgument_signed._ext = []
    ModifyDNArgument._cont = ASN1Dict([
        (u'unsigned', _ModifyDNArgument_unsigned),
        (u'signed', _ModifyDNArgument_signed),
        ])
    ModifyDNArgument._ext = None
    
    #-----< ModifyDNArgumentData >-----#
    ModifyDNArgumentData = SET(name=u'ModifyDNArgumentData', mode=MODE_TYPE)
    _ModifyDNArgumentData_object = SEQ_OF(name=u'object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _ModifyDNArgumentData_newRDN = SET_OF(name=u'newRDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _ModifyDNArgumentData_deleteOldRDN = BOOL(name=u'deleteOldRDN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyDNArgumentData_newSuperior = SEQ_OF(name=u'newSuperior', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyDNArgumentData_serviceControls = SET(name=u'serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _ModifyDNArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ModifyDNArgumentData_requestor = SEQ_OF(name=u'requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyDNArgumentData_operationProgress = SET(name=u'operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([(u'nameResolutionPhase', u'notStarted')]))
    _ModifyDNArgumentData_aliasedRDNs = INT(name=u'aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ModifyDNArgumentData_criticalExtensions = BIT_STR(name=u'criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ModifyDNArgumentData_referenceType = ENUM(name=u'referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _ModifyDNArgumentData_entryOnly = BOOL(name=u'entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _ModifyDNArgumentData_exclusions = SET_OF(name=u'exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ModifyDNArgumentData_nameResolveOnMaster = BOOL(name=u'nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyDNArgumentData_operationContexts = CHOICE(name=u'operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _ModifyDNArgumentData_familyGrouping = ENUM(name=u'familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default=u'entryOnly')
    ModifyDNArgumentData._cont = ASN1Dict([
        (u'object', _ModifyDNArgumentData_object),
        (u'newRDN', _ModifyDNArgumentData_newRDN),
        (u'deleteOldRDN', _ModifyDNArgumentData_deleteOldRDN),
        (u'newSuperior', _ModifyDNArgumentData_newSuperior),
        (u'serviceControls', _ModifyDNArgumentData_serviceControls),
        (u'securityParameters', _ModifyDNArgumentData_securityParameters),
        (u'requestor', _ModifyDNArgumentData_requestor),
        (u'operationProgress', _ModifyDNArgumentData_operationProgress),
        (u'aliasedRDNs', _ModifyDNArgumentData_aliasedRDNs),
        (u'criticalExtensions', _ModifyDNArgumentData_criticalExtensions),
        (u'referenceType', _ModifyDNArgumentData_referenceType),
        (u'entryOnly', _ModifyDNArgumentData_entryOnly),
        (u'exclusions', _ModifyDNArgumentData_exclusions),
        (u'nameResolveOnMaster', _ModifyDNArgumentData_nameResolveOnMaster),
        (u'operationContexts', _ModifyDNArgumentData_operationContexts),
        (u'familyGrouping', _ModifyDNArgumentData_familyGrouping),
        ])
    ModifyDNArgumentData._ext = [u'serviceControls', u'securityParameters', u'requestor', u'operationProgress', u'aliasedRDNs', u'criticalExtensions', u'referenceType', u'entryOnly', u'exclusions', u'nameResolveOnMaster', u'operationContexts', u'familyGrouping']
    
    #-----< ModifyDNResult >-----#
    ModifyDNResult = CHOICE(name=u'ModifyDNResult', mode=MODE_TYPE)
    _ModifyDNResult_null = NULL(name=u'null', mode=MODE_TYPE)
    _ModifyDNResult_information = CHOICE(name=u'information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __ModifyDNResult_information_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResultData')))
    __ModifyDNResult_information_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___ModifyDNResult_information_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResultData')))
    ___ModifyDNResult_information_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____ModifyDNResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyDNResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____ModifyDNResult_information_signed_algorithmIdentifier_algorithm_tab
    ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____ModifyDNResult_information_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____ModifyDNResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyDNResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyDNResult_information_signed_algorithmIdentifier_parameters._const_tab = _____ModifyDNResult_information_signed_algorithmIdentifier_parameters_tab
    ____ModifyDNResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____ModifyDNResult_information_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___ModifyDNResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____ModifyDNResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___ModifyDNResult_information_signed_algorithmIdentifier._ext = []
    ___ModifyDNResult_information_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __ModifyDNResult_information_signed._cont = ASN1Dict([
        (u'toBeSigned', ___ModifyDNResult_information_signed_toBeSigned),
        (u'algorithmIdentifier', ___ModifyDNResult_information_signed_algorithmIdentifier),
        (u'signature', ___ModifyDNResult_information_signed_signature),
        ])
    __ModifyDNResult_information_signed._ext = []
    _ModifyDNResult_information._cont = ASN1Dict([
        (u'unsigned', __ModifyDNResult_information_unsigned),
        (u'signed', __ModifyDNResult_information_signed),
        ])
    _ModifyDNResult_information._ext = None
    ModifyDNResult._cont = ASN1Dict([
        (u'null', _ModifyDNResult_null),
        (u'information', _ModifyDNResult_information),
        ])
    ModifyDNResult._ext = []
    
    #-----< ModifyDNResultData >-----#
    ModifyDNResultData = SEQ(name=u'ModifyDNResultData', mode=MODE_TYPE)
    _ModifyDNResultData_newRDN = SET_OF(name=u'newRDN', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _ModifyDNResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ModifyDNResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyDNResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyDNResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ModifyDNResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ModifyDNResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____ModifyDNResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ModifyDNResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____ModifyDNResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ModifyDNResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____ModifyDNResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____ModifyDNResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ModifyDNResultData_notification__item__type._const_tab = ____ModifyDNResultData_notification__item__type_tab
    ___ModifyDNResultData_notification__item__type._const_tab_at = None
    ___ModifyDNResultData_notification__item__type._const_tab_id = u'id'
    ___ModifyDNResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____ModifyDNResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____ModifyDNResultData_notification__item__values__item_._const_tab = ____ModifyDNResultData_notification__item__type_tab
    ____ModifyDNResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____ModifyDNResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___ModifyDNResultData_notification__item__values._cont = ____ModifyDNResultData_notification__item__values__item_
    ___ModifyDNResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ModifyDNResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ModifyDNResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ModifyDNResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____ModifyDNResultData_notification__item__valuesWithContext__item__value._const_tab = ____ModifyDNResultData_notification__item__type_tab
    _____ModifyDNResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____ModifyDNResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____ModifyDNResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______ModifyDNResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ModifyDNResultData_notification__item__valuesWithContext__item__contextList._cont = ______ModifyDNResultData_notification__item__valuesWithContext__item__contextList__item_
    _____ModifyDNResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ModifyDNResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____ModifyDNResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____ModifyDNResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ModifyDNResultData_notification__item__valuesWithContext__item_._ext = []
    ___ModifyDNResultData_notification__item__valuesWithContext._cont = ____ModifyDNResultData_notification__item__valuesWithContext__item_
    ___ModifyDNResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ModifyDNResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___ModifyDNResultData_notification__item__type),
        (u'values', ___ModifyDNResultData_notification__item__values),
        (u'valuesWithContext', ___ModifyDNResultData_notification__item__valuesWithContext),
        ])
    __ModifyDNResultData_notification__item_._ext = []
    _ModifyDNResultData_notification._cont = __ModifyDNResultData_notification__item_
    ModifyDNResultData._cont = ASN1Dict([
        (u'newRDN', _ModifyDNResultData_newRDN),
        (u'securityParameters', _ModifyDNResultData_securityParameters),
        (u'performer', _ModifyDNResultData_performer),
        (u'aliasDereferenced', _ModifyDNResultData_aliasDereferenced),
        (u'notification', _ModifyDNResultData_notification),
        ])
    ModifyDNResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< changePassword >-----#
    changePassword = CLASS(name=u'changePassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _changePassword_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    _changePassword_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    __OPERATION_Errors_val_ParameterType_0_3 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_3._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_3_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_3._ext = None
    __OPERATION_Errors_val_ParameterType_1_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_1._ext = None
    changePassword._val = dict([(u'ArgumentType', _changePassword_val_ArgumentType), (u'ResultType', _changePassword_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))])
    
    #-----< ChangePasswordArgument >-----#
    ChangePasswordArgument = CHOICE(name=u'ChangePasswordArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _ChangePasswordArgument_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgumentData')))
    _ChangePasswordArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ChangePasswordArgument_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgumentData')))
    __ChangePasswordArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____ChangePasswordArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ChangePasswordArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ChangePasswordArgument_signed_algorithmIdentifier_algorithm_tab
    ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___ChangePasswordArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____ChangePasswordArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ChangePasswordArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ChangePasswordArgument_signed_algorithmIdentifier_parameters._const_tab = ____ChangePasswordArgument_signed_algorithmIdentifier_parameters_tab
    ___ChangePasswordArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___ChangePasswordArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __ChangePasswordArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___ChangePasswordArgument_signed_algorithmIdentifier_parameters),
        ])
    __ChangePasswordArgument_signed_algorithmIdentifier._ext = []
    __ChangePasswordArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _ChangePasswordArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __ChangePasswordArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __ChangePasswordArgument_signed_algorithmIdentifier),
        (u'signature', __ChangePasswordArgument_signed_signature),
        ])
    _ChangePasswordArgument_signed._ext = []
    ChangePasswordArgument._cont = ASN1Dict([
        (u'unsigned', _ChangePasswordArgument_unsigned),
        (u'signed', _ChangePasswordArgument_signed),
        ])
    ChangePasswordArgument._ext = None
    
    #-----< ChangePasswordArgumentData >-----#
    ChangePasswordArgumentData = SEQ(name=u'ChangePasswordArgumentData', mode=MODE_TYPE)
    _ChangePasswordArgumentData_object = SEQ_OF(name=u'object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _ChangePasswordArgumentData_oldPwd = CHOICE(name=u'oldPwd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    _ChangePasswordArgumentData_newPwd = CHOICE(name=u'newPwd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    ChangePasswordArgumentData._cont = ASN1Dict([
        (u'object', _ChangePasswordArgumentData_object),
        (u'oldPwd', _ChangePasswordArgumentData_oldPwd),
        (u'newPwd', _ChangePasswordArgumentData_newPwd),
        ])
    ChangePasswordArgumentData._ext = []
    
    #-----< ChangePasswordResult >-----#
    ChangePasswordResult = CHOICE(name=u'ChangePasswordResult', mode=MODE_TYPE)
    _ChangePasswordResult_null = NULL(name=u'null', mode=MODE_TYPE)
    _ChangePasswordResult_information = CHOICE(name=u'information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __ChangePasswordResult_information_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResultData')))
    __ChangePasswordResult_information_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___ChangePasswordResult_information_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResultData')))
    ___ChangePasswordResult_information_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm_tab
    ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____ChangePasswordResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ChangePasswordResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters._const_tab = _____ChangePasswordResult_information_signed_algorithmIdentifier_parameters_tab
    ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___ChangePasswordResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___ChangePasswordResult_information_signed_algorithmIdentifier._ext = []
    ___ChangePasswordResult_information_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __ChangePasswordResult_information_signed._cont = ASN1Dict([
        (u'toBeSigned', ___ChangePasswordResult_information_signed_toBeSigned),
        (u'algorithmIdentifier', ___ChangePasswordResult_information_signed_algorithmIdentifier),
        (u'signature', ___ChangePasswordResult_information_signed_signature),
        ])
    __ChangePasswordResult_information_signed._ext = []
    _ChangePasswordResult_information._cont = ASN1Dict([
        (u'unsigned', __ChangePasswordResult_information_unsigned),
        (u'signed', __ChangePasswordResult_information_signed),
        ])
    _ChangePasswordResult_information._ext = None
    ChangePasswordResult._cont = ASN1Dict([
        (u'null', _ChangePasswordResult_null),
        (u'information', _ChangePasswordResult_information),
        ])
    ChangePasswordResult._ext = []
    
    #-----< ChangePasswordResultData >-----#
    ChangePasswordResultData = SEQ(name=u'ChangePasswordResultData', mode=MODE_TYPE)
    _ChangePasswordResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ChangePasswordResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ChangePasswordResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChangePasswordResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ChangePasswordResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ChangePasswordResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____ChangePasswordResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ChangePasswordResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____ChangePasswordResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ChangePasswordResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____ChangePasswordResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____ChangePasswordResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ChangePasswordResultData_notification__item__type._const_tab = ____ChangePasswordResultData_notification__item__type_tab
    ___ChangePasswordResultData_notification__item__type._const_tab_at = None
    ___ChangePasswordResultData_notification__item__type._const_tab_id = u'id'
    ___ChangePasswordResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____ChangePasswordResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____ChangePasswordResultData_notification__item__values__item_._const_tab = ____ChangePasswordResultData_notification__item__type_tab
    ____ChangePasswordResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____ChangePasswordResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___ChangePasswordResultData_notification__item__values._cont = ____ChangePasswordResultData_notification__item__values__item_
    ___ChangePasswordResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ChangePasswordResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ChangePasswordResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__value._const_tab = ____ChangePasswordResultData_notification__item__type_tab
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______ChangePasswordResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__contextList._cont = ______ChangePasswordResultData_notification__item__valuesWithContext__item__contextList__item_
    _____ChangePasswordResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ChangePasswordResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____ChangePasswordResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____ChangePasswordResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ChangePasswordResultData_notification__item__valuesWithContext__item_._ext = []
    ___ChangePasswordResultData_notification__item__valuesWithContext._cont = ____ChangePasswordResultData_notification__item__valuesWithContext__item_
    ___ChangePasswordResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ChangePasswordResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___ChangePasswordResultData_notification__item__type),
        (u'values', ___ChangePasswordResultData_notification__item__values),
        (u'valuesWithContext', ___ChangePasswordResultData_notification__item__valuesWithContext),
        ])
    __ChangePasswordResultData_notification__item_._ext = []
    _ChangePasswordResultData_notification._cont = __ChangePasswordResultData_notification__item_
    ChangePasswordResultData._cont = ASN1Dict([
        (u'securityParameters', _ChangePasswordResultData_securityParameters),
        (u'performer', _ChangePasswordResultData_performer),
        (u'aliasDereferenced', _ChangePasswordResultData_aliasDereferenced),
        (u'notification', _ChangePasswordResultData_notification),
        ])
    ChangePasswordResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< administerPassword >-----#
    administerPassword = CLASS(name=u'administerPassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _administerPassword_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    _administerPassword_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    administerPassword._val = dict([(u'ArgumentType', _administerPassword_val_ArgumentType), (u'ResultType', _administerPassword_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))])
    
    #-----< AdministerPasswordArgument >-----#
    AdministerPasswordArgument = CHOICE(name=u'AdministerPasswordArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _AdministerPasswordArgument_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgumentData')))
    _AdministerPasswordArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __AdministerPasswordArgument_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgumentData')))
    __AdministerPasswordArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____AdministerPasswordArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AdministerPasswordArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm._const_tab = ____AdministerPasswordArgument_signed_algorithmIdentifier_algorithm_tab
    ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____AdministerPasswordArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____AdministerPasswordArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters._const_tab = ____AdministerPasswordArgument_signed_algorithmIdentifier_parameters_tab
    ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __AdministerPasswordArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters),
        ])
    __AdministerPasswordArgument_signed_algorithmIdentifier._ext = []
    __AdministerPasswordArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _AdministerPasswordArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __AdministerPasswordArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __AdministerPasswordArgument_signed_algorithmIdentifier),
        (u'signature', __AdministerPasswordArgument_signed_signature),
        ])
    _AdministerPasswordArgument_signed._ext = []
    AdministerPasswordArgument._cont = ASN1Dict([
        (u'unsigned', _AdministerPasswordArgument_unsigned),
        (u'signed', _AdministerPasswordArgument_signed),
        ])
    AdministerPasswordArgument._ext = None
    
    #-----< AdministerPasswordArgumentData >-----#
    AdministerPasswordArgumentData = SEQ(name=u'AdministerPasswordArgumentData', mode=MODE_TYPE)
    _AdministerPasswordArgumentData_object = SEQ_OF(name=u'object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _AdministerPasswordArgumentData_newPwd = CHOICE(name=u'newPwd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    AdministerPasswordArgumentData._cont = ASN1Dict([
        (u'object', _AdministerPasswordArgumentData_object),
        (u'newPwd', _AdministerPasswordArgumentData_newPwd),
        ])
    AdministerPasswordArgumentData._ext = []
    
    #-----< AdministerPasswordResult >-----#
    AdministerPasswordResult = CHOICE(name=u'AdministerPasswordResult', mode=MODE_TYPE)
    _AdministerPasswordResult_null = NULL(name=u'null', mode=MODE_TYPE)
    _AdministerPasswordResult_information = CHOICE(name=u'information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __AdministerPasswordResult_information_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResultData')))
    __AdministerPasswordResult_information_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___AdministerPasswordResult_information_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResultData')))
    ___AdministerPasswordResult_information_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm_tab
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters._const_tab = _____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters_tab
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___AdministerPasswordResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___AdministerPasswordResult_information_signed_algorithmIdentifier._ext = []
    ___AdministerPasswordResult_information_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __AdministerPasswordResult_information_signed._cont = ASN1Dict([
        (u'toBeSigned', ___AdministerPasswordResult_information_signed_toBeSigned),
        (u'algorithmIdentifier', ___AdministerPasswordResult_information_signed_algorithmIdentifier),
        (u'signature', ___AdministerPasswordResult_information_signed_signature),
        ])
    __AdministerPasswordResult_information_signed._ext = []
    _AdministerPasswordResult_information._cont = ASN1Dict([
        (u'unsigned', __AdministerPasswordResult_information_unsigned),
        (u'signed', __AdministerPasswordResult_information_signed),
        ])
    _AdministerPasswordResult_information._ext = None
    AdministerPasswordResult._cont = ASN1Dict([
        (u'null', _AdministerPasswordResult_null),
        (u'information', _AdministerPasswordResult_information),
        ])
    AdministerPasswordResult._ext = []
    
    #-----< AdministerPasswordResultData >-----#
    AdministerPasswordResultData = SEQ(name=u'AdministerPasswordResultData', mode=MODE_TYPE)
    _AdministerPasswordResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AdministerPasswordResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AdministerPasswordResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AdministerPasswordResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AdministerPasswordResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AdministerPasswordResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____AdministerPasswordResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AdministerPasswordResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____AdministerPasswordResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AdministerPasswordResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____AdministerPasswordResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____AdministerPasswordResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AdministerPasswordResultData_notification__item__type._const_tab = ____AdministerPasswordResultData_notification__item__type_tab
    ___AdministerPasswordResultData_notification__item__type._const_tab_at = None
    ___AdministerPasswordResultData_notification__item__type._const_tab_id = u'id'
    ___AdministerPasswordResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____AdministerPasswordResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____AdministerPasswordResultData_notification__item__values__item_._const_tab = ____AdministerPasswordResultData_notification__item__type_tab
    ____AdministerPasswordResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____AdministerPasswordResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___AdministerPasswordResultData_notification__item__values._cont = ____AdministerPasswordResultData_notification__item__values__item_
    ___AdministerPasswordResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AdministerPasswordResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AdministerPasswordResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value._const_tab = ____AdministerPasswordResultData_notification__item__type_tab
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList._cont = ______AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList__item_
    _____AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AdministerPasswordResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AdministerPasswordResultData_notification__item__valuesWithContext__item_._ext = []
    ___AdministerPasswordResultData_notification__item__valuesWithContext._cont = ____AdministerPasswordResultData_notification__item__valuesWithContext__item_
    ___AdministerPasswordResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AdministerPasswordResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___AdministerPasswordResultData_notification__item__type),
        (u'values', ___AdministerPasswordResultData_notification__item__values),
        (u'valuesWithContext', ___AdministerPasswordResultData_notification__item__valuesWithContext),
        ])
    __AdministerPasswordResultData_notification__item_._ext = []
    _AdministerPasswordResultData_notification._cont = __AdministerPasswordResultData_notification__item_
    AdministerPasswordResultData._cont = ASN1Dict([
        (u'securityParameters', _AdministerPasswordResultData_securityParameters),
        (u'performer', _AdministerPasswordResultData_performer),
        (u'aliasDereferenced', _AdministerPasswordResultData_aliasDereferenced),
        (u'notification', _AdministerPasswordResultData_notification),
        ])
    AdministerPasswordResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< ldapTransport >-----#
    ldapTransport = CLASS(name=u'ldapTransport', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _ldapTransport_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    _ldapTransport_val_ResultType = SEQ_OF(name=u'ResultType', mode=MODE_TYPE)
    __ldapTransport_val_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _ldapTransport_val_ResultType._cont = __ldapTransport_val_ResultType__item_
    __OPERATION_Errors_val_ParameterType_1_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_2._ext = None
    ldapTransport._val = dict([(u'ArgumentType', _ldapTransport_val_ArgumentType), (u'ResultType', _ldapTransport_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))])
    
    #-----< LdapArgument >-----#
    LdapArgument = CHOICE(name=u'LdapArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _LdapArgument_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgumentData')))
    _LdapArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __LdapArgument_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgumentData')))
    __LdapArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___LdapArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____LdapArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LdapArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LdapArgument_signed_algorithmIdentifier_algorithm._const_tab = ____LdapArgument_signed_algorithmIdentifier_algorithm_tab
    ___LdapArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___LdapArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___LdapArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____LdapArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LdapArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LdapArgument_signed_algorithmIdentifier_parameters._const_tab = ____LdapArgument_signed_algorithmIdentifier_parameters_tab
    ___LdapArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___LdapArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __LdapArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___LdapArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___LdapArgument_signed_algorithmIdentifier_parameters),
        ])
    __LdapArgument_signed_algorithmIdentifier._ext = []
    __LdapArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _LdapArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __LdapArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __LdapArgument_signed_algorithmIdentifier),
        (u'signature', __LdapArgument_signed_signature),
        ])
    _LdapArgument_signed._ext = []
    LdapArgument._cont = ASN1Dict([
        (u'unsigned', _LdapArgument_unsigned),
        (u'signed', _LdapArgument_signed),
        ])
    LdapArgument._ext = None
    
    #-----< LdapArgumentData >-----#
    LdapArgumentData = SEQ(name=u'LdapArgumentData', mode=MODE_TYPE)
    _LdapArgumentData_object = SEQ_OF(name=u'object', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _LdapArgumentData_ldapMessage = SEQ(name=u'ldapMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _LdapArgumentData_linkId = INT(name=u'linkId', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkId')), opt=True)
    _LdapArgumentData_serviceControls = SET(name=u'serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _LdapArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _LdapArgumentData_requestor = SEQ_OF(name=u'requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _LdapArgumentData_operationProgress = SET(name=u'operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([(u'nameResolutionPhase', u'notStarted')]))
    _LdapArgumentData_aliasedRDNs = INT(name=u'aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _LdapArgumentData_criticalExtensions = BIT_STR(name=u'criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _LdapArgumentData_referenceType = ENUM(name=u'referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _LdapArgumentData_entryOnly = BOOL(name=u'entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _LdapArgumentData_exclusions = SET_OF(name=u'exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _LdapArgumentData_nameResolveOnMaster = BOOL(name=u'nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _LdapArgumentData_operationContexts = CHOICE(name=u'operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _LdapArgumentData_familyGrouping = ENUM(name=u'familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default=u'entryOnly')
    LdapArgumentData._cont = ASN1Dict([
        (u'object', _LdapArgumentData_object),
        (u'ldapMessage', _LdapArgumentData_ldapMessage),
        (u'linkId', _LdapArgumentData_linkId),
        (u'serviceControls', _LdapArgumentData_serviceControls),
        (u'securityParameters', _LdapArgumentData_securityParameters),
        (u'requestor', _LdapArgumentData_requestor),
        (u'operationProgress', _LdapArgumentData_operationProgress),
        (u'aliasedRDNs', _LdapArgumentData_aliasedRDNs),
        (u'criticalExtensions', _LdapArgumentData_criticalExtensions),
        (u'referenceType', _LdapArgumentData_referenceType),
        (u'entryOnly', _LdapArgumentData_entryOnly),
        (u'exclusions', _LdapArgumentData_exclusions),
        (u'nameResolveOnMaster', _LdapArgumentData_nameResolveOnMaster),
        (u'operationContexts', _LdapArgumentData_operationContexts),
        (u'familyGrouping', _LdapArgumentData_familyGrouping),
        ])
    LdapArgumentData._ext = [u'serviceControls', u'securityParameters', u'requestor', u'operationProgress', u'aliasedRDNs', u'criticalExtensions', u'referenceType', u'entryOnly', u'exclusions', u'nameResolveOnMaster', u'operationContexts', u'familyGrouping']
    
    #-----< LinkId >-----#
    LinkId = INT(name=u'LinkId', mode=MODE_TYPE)
    
    #-----< LdapResult >-----#
    LdapResult = CHOICE(name=u'LdapResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _LdapResult_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LdapResultData')))
    _LdapResult_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __LdapResult_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LdapResultData')))
    __LdapResult_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___LdapResult_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____LdapResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LdapResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LdapResult_signed_algorithmIdentifier_algorithm._const_tab = ____LdapResult_signed_algorithmIdentifier_algorithm_tab
    ___LdapResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___LdapResult_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___LdapResult_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____LdapResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LdapResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LdapResult_signed_algorithmIdentifier_parameters._const_tab = ____LdapResult_signed_algorithmIdentifier_parameters_tab
    ___LdapResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___LdapResult_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __LdapResult_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___LdapResult_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___LdapResult_signed_algorithmIdentifier_parameters),
        ])
    __LdapResult_signed_algorithmIdentifier._ext = []
    __LdapResult_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _LdapResult_signed._cont = ASN1Dict([
        (u'toBeSigned', __LdapResult_signed_toBeSigned),
        (u'algorithmIdentifier', __LdapResult_signed_algorithmIdentifier),
        (u'signature', __LdapResult_signed_signature),
        ])
    _LdapResult_signed._ext = []
    LdapResult._cont = ASN1Dict([
        (u'unsigned', _LdapResult_unsigned),
        (u'signed', _LdapResult_signed),
        ])
    LdapResult._ext = None
    
    #-----< LdapResultData >-----#
    LdapResultData = SEQ(name=u'LdapResultData', mode=MODE_TYPE)
    _LdapResultData_ldapMessages = SEQ_OF(name=u'ldapMessages', mode=MODE_TYPE, opt=True)
    __LdapResultData_ldapMessages__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _LdapResultData_ldapMessages._cont = __LdapResultData_ldapMessages__item_
    _LdapResultData_ldapMessages._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _LdapResultData_returnToClient = BOOL(name=u'returnToClient', mode=MODE_TYPE, default=False)
    _LdapResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _LdapResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _LdapResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _LdapResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __LdapResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___LdapResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____LdapResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____LdapResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____LdapResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____LdapResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____LdapResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____LdapResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___LdapResultData_notification__item__type._const_tab = ____LdapResultData_notification__item__type_tab
    ___LdapResultData_notification__item__type._const_tab_at = None
    ___LdapResultData_notification__item__type._const_tab_id = u'id'
    ___LdapResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____LdapResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____LdapResultData_notification__item__values__item_._const_tab = ____LdapResultData_notification__item__type_tab
    ____LdapResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____LdapResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___LdapResultData_notification__item__values._cont = ____LdapResultData_notification__item__values__item_
    ___LdapResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___LdapResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____LdapResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____LdapResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____LdapResultData_notification__item__valuesWithContext__item__value._const_tab = ____LdapResultData_notification__item__type_tab
    _____LdapResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____LdapResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____LdapResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______LdapResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____LdapResultData_notification__item__valuesWithContext__item__contextList._cont = ______LdapResultData_notification__item__valuesWithContext__item__contextList__item_
    _____LdapResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____LdapResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____LdapResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____LdapResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____LdapResultData_notification__item__valuesWithContext__item_._ext = []
    ___LdapResultData_notification__item__valuesWithContext._cont = ____LdapResultData_notification__item__valuesWithContext__item_
    ___LdapResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __LdapResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___LdapResultData_notification__item__type),
        (u'values', ___LdapResultData_notification__item__values),
        (u'valuesWithContext', ___LdapResultData_notification__item__valuesWithContext),
        ])
    __LdapResultData_notification__item_._ext = []
    _LdapResultData_notification._cont = __LdapResultData_notification__item_
    LdapResultData._cont = ASN1Dict([
        (u'ldapMessages', _LdapResultData_ldapMessages),
        (u'returnToClient', _LdapResultData_returnToClient),
        (u'securityParameters', _LdapResultData_securityParameters),
        (u'performer', _LdapResultData_performer),
        (u'aliasDereferenced', _LdapResultData_aliasDereferenced),
        (u'notification', _LdapResultData_notification),
        ])
    LdapResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< linkedLDAP >-----#
    linkedLDAP = CLASS(name=u'linkedLDAP', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _linkedLDAP_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    _linkedLDAP_val_ResultType = NULL(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    linkedLDAP._val = dict([(u'ArgumentType', _linkedLDAP_val_ArgumentType), (u'ResultType', _linkedLDAP_val_ResultType), (u'operationCode', (u'local', 13))])
    
    #-----< LinkedArgument >-----#
    LinkedArgument = CHOICE(name=u'LinkedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _LinkedArgument_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgumentData')))
    _LinkedArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __LinkedArgument_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgumentData')))
    __LinkedArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___LinkedArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____LinkedArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LinkedArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LinkedArgument_signed_algorithmIdentifier_algorithm._const_tab = ____LinkedArgument_signed_algorithmIdentifier_algorithm_tab
    ___LinkedArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___LinkedArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___LinkedArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____LinkedArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____LinkedArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LinkedArgument_signed_algorithmIdentifier_parameters._const_tab = ____LinkedArgument_signed_algorithmIdentifier_parameters_tab
    ___LinkedArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___LinkedArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __LinkedArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___LinkedArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___LinkedArgument_signed_algorithmIdentifier_parameters),
        ])
    __LinkedArgument_signed_algorithmIdentifier._ext = []
    __LinkedArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _LinkedArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __LinkedArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __LinkedArgument_signed_algorithmIdentifier),
        (u'signature', __LinkedArgument_signed_signature),
        ])
    _LinkedArgument_signed._ext = []
    LinkedArgument._cont = ASN1Dict([
        (u'unsigned', _LinkedArgument_unsigned),
        (u'signed', _LinkedArgument_signed),
        ])
    LinkedArgument._ext = None
    
    #-----< LinkedArgumentData >-----#
    LinkedArgumentData = SEQ(name=u'LinkedArgumentData', mode=MODE_TYPE)
    _LinkedArgumentData_object = SEQ_OF(name=u'object', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _LinkedArgumentData_ldapMessage = SEQ(name=u'ldapMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _LinkedArgumentData_linkId = INT(name=u'linkId', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'LinkId')))
    _LinkedArgumentData_returnToClient = BOOL(name=u'returnToClient', mode=MODE_TYPE, default=False)
    _LinkedArgumentData_serviceControls = SET(name=u'serviceControls', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControls')), default=dict([]))
    _LinkedArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _LinkedArgumentData_requestor = SEQ_OF(name=u'requestor', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _LinkedArgumentData_operationProgress = SET(name=u'operationProgress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([(u'nameResolutionPhase', u'notStarted')]))
    _LinkedArgumentData_aliasedRDNs = INT(name=u'aliasedRDNs', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _LinkedArgumentData_criticalExtensions = BIT_STR(name=u'criticalExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _LinkedArgumentData_referenceType = ENUM(name=u'referenceType', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), opt=True)
    _LinkedArgumentData_entryOnly = BOOL(name=u'entryOnly', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _LinkedArgumentData_exclusions = SET_OF(name=u'exclusions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _LinkedArgumentData_nameResolveOnMaster = BOOL(name=u'nameResolveOnMaster', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _LinkedArgumentData_operationContexts = CHOICE(name=u'operationContexts', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _LinkedArgumentData_familyGrouping = ENUM(name=u'familyGrouping', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), default=u'entryOnly')
    LinkedArgumentData._cont = ASN1Dict([
        (u'object', _LinkedArgumentData_object),
        (u'ldapMessage', _LinkedArgumentData_ldapMessage),
        (u'linkId', _LinkedArgumentData_linkId),
        (u'returnToClient', _LinkedArgumentData_returnToClient),
        (u'serviceControls', _LinkedArgumentData_serviceControls),
        (u'securityParameters', _LinkedArgumentData_securityParameters),
        (u'requestor', _LinkedArgumentData_requestor),
        (u'operationProgress', _LinkedArgumentData_operationProgress),
        (u'aliasedRDNs', _LinkedArgumentData_aliasedRDNs),
        (u'criticalExtensions', _LinkedArgumentData_criticalExtensions),
        (u'referenceType', _LinkedArgumentData_referenceType),
        (u'entryOnly', _LinkedArgumentData_entryOnly),
        (u'exclusions', _LinkedArgumentData_exclusions),
        (u'nameResolveOnMaster', _LinkedArgumentData_nameResolveOnMaster),
        (u'operationContexts', _LinkedArgumentData_operationContexts),
        (u'familyGrouping', _LinkedArgumentData_familyGrouping),
        ])
    LinkedArgumentData._ext = [u'serviceControls', u'securityParameters', u'requestor', u'operationProgress', u'aliasedRDNs', u'criticalExtensions', u'referenceType', u'entryOnly', u'exclusions', u'nameResolveOnMaster', u'operationContexts', u'familyGrouping']
    
    #-----< LinkedResult >-----#
    LinkedResult = NULL(name=u'LinkedResult', mode=MODE_TYPE)
    
    #-----< abandoned >-----#
    abandoned = CLASS(name=u'abandoned', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _abandoned_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __abandoned_val_ParameterType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    __abandoned_val_ParameterType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___abandoned_val_ParameterType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___abandoned_val_ParameterType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___abandoned_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___abandoned_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___abandoned_val_ParameterType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __abandoned_val_ParameterType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___abandoned_val_ParameterType_signed_toBeSigned),
        (u'algorithmIdentifier', ___abandoned_val_ParameterType_signed_algorithmIdentifier),
        (u'signature', ___abandoned_val_ParameterType_signed_signature),
        ])
    __abandoned_val_ParameterType_signed._ext = []
    _abandoned_val_ParameterType._cont = ASN1Dict([
        (u'unsigned', __abandoned_val_ParameterType_unsigned),
        (u'signed', __abandoned_val_ParameterType_signed),
        ])
    _abandoned_val_ParameterType._ext = None
    abandoned._val = dict([(u'ParameterType', _abandoned_val_ParameterType), (u'errorCode', (u'local', 5))])
    
    #-----< AbandonedData >-----#
    AbandonedData = SET(name=u'AbandonedData', mode=MODE_TYPE)
    _AbandonedData_problem = ENUM(name=u'problem', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedProblem')), opt=True)
    _AbandonedData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AbandonedData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AbandonedData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AbandonedData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AbandonedData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AbandonedData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____AbandonedData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AbandonedData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____AbandonedData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AbandonedData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____AbandonedData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____AbandonedData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AbandonedData_notification__item__type._const_tab = ____AbandonedData_notification__item__type_tab
    ___AbandonedData_notification__item__type._const_tab_at = None
    ___AbandonedData_notification__item__type._const_tab_id = u'id'
    ___AbandonedData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____AbandonedData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____AbandonedData_notification__item__values__item_._const_tab = ____AbandonedData_notification__item__type_tab
    ____AbandonedData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____AbandonedData_notification__item__values__item_._const_tab_id = u'Type'
    ___AbandonedData_notification__item__values._cont = ____AbandonedData_notification__item__values__item_
    ___AbandonedData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AbandonedData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AbandonedData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AbandonedData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____AbandonedData_notification__item__valuesWithContext__item__value._const_tab = ____AbandonedData_notification__item__type_tab
    _____AbandonedData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____AbandonedData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____AbandonedData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______AbandonedData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AbandonedData_notification__item__valuesWithContext__item__contextList._cont = ______AbandonedData_notification__item__valuesWithContext__item__contextList__item_
    _____AbandonedData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AbandonedData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____AbandonedData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____AbandonedData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AbandonedData_notification__item__valuesWithContext__item_._ext = []
    ___AbandonedData_notification__item__valuesWithContext._cont = ____AbandonedData_notification__item__valuesWithContext__item_
    ___AbandonedData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AbandonedData_notification__item_._cont = ASN1Dict([
        (u'type', ___AbandonedData_notification__item__type),
        (u'values', ___AbandonedData_notification__item__values),
        (u'valuesWithContext', ___AbandonedData_notification__item__valuesWithContext),
        ])
    __AbandonedData_notification__item_._ext = []
    _AbandonedData_notification._cont = __AbandonedData_notification__item_
    AbandonedData._cont = ASN1Dict([
        (u'problem', _AbandonedData_problem),
        (u'securityParameters', _AbandonedData_securityParameters),
        (u'performer', _AbandonedData_performer),
        (u'aliasDereferenced', _AbandonedData_aliasDereferenced),
        (u'notification', _AbandonedData_notification),
        ])
    AbandonedData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< AbandonedProblem >-----#
    AbandonedProblem = ENUM(name=u'AbandonedProblem', mode=MODE_TYPE)
    AbandonedProblem._cont = ASN1Dict([(u'pagingAbandoned', 0)])
    AbandonedProblem._ext = None
    
    #-----< abandonFailed >-----#
    abandonFailed = CLASS(name=u'abandonFailed', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _abandonFailed_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __abandonFailed_val_ParameterType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    __abandonFailed_val_ParameterType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___abandonFailed_val_ParameterType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___abandonFailed_val_ParameterType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___abandonFailed_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___abandonFailed_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___abandonFailed_val_ParameterType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __abandonFailed_val_ParameterType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___abandonFailed_val_ParameterType_signed_toBeSigned),
        (u'algorithmIdentifier', ___abandonFailed_val_ParameterType_signed_algorithmIdentifier),
        (u'signature', ___abandonFailed_val_ParameterType_signed_signature),
        ])
    __abandonFailed_val_ParameterType_signed._ext = []
    _abandonFailed_val_ParameterType._cont = ASN1Dict([
        (u'unsigned', __abandonFailed_val_ParameterType_unsigned),
        (u'signed', __abandonFailed_val_ParameterType_signed),
        ])
    _abandonFailed_val_ParameterType._ext = None
    abandonFailed._val = dict([(u'ParameterType', _abandonFailed_val_ParameterType), (u'errorCode', (u'local', 7))])
    
    #-----< AbandonFailedData >-----#
    AbandonFailedData = SET(name=u'AbandonFailedData', mode=MODE_TYPE)
    _AbandonFailedData_problem = INT(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonProblem')))
    _AbandonFailedData_operation = CHOICE(name=u'operation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    _AbandonFailedData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AbandonFailedData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AbandonFailedData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AbandonFailedData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AbandonFailedData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AbandonFailedData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____AbandonFailedData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AbandonFailedData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____AbandonFailedData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AbandonFailedData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____AbandonFailedData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____AbandonFailedData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AbandonFailedData_notification__item__type._const_tab = ____AbandonFailedData_notification__item__type_tab
    ___AbandonFailedData_notification__item__type._const_tab_at = None
    ___AbandonFailedData_notification__item__type._const_tab_id = u'id'
    ___AbandonFailedData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____AbandonFailedData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____AbandonFailedData_notification__item__values__item_._const_tab = ____AbandonFailedData_notification__item__type_tab
    ____AbandonFailedData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____AbandonFailedData_notification__item__values__item_._const_tab_id = u'Type'
    ___AbandonFailedData_notification__item__values._cont = ____AbandonFailedData_notification__item__values__item_
    ___AbandonFailedData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AbandonFailedData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AbandonFailedData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AbandonFailedData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____AbandonFailedData_notification__item__valuesWithContext__item__value._const_tab = ____AbandonFailedData_notification__item__type_tab
    _____AbandonFailedData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____AbandonFailedData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____AbandonFailedData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______AbandonFailedData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AbandonFailedData_notification__item__valuesWithContext__item__contextList._cont = ______AbandonFailedData_notification__item__valuesWithContext__item__contextList__item_
    _____AbandonFailedData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AbandonFailedData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____AbandonFailedData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____AbandonFailedData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AbandonFailedData_notification__item__valuesWithContext__item_._ext = []
    ___AbandonFailedData_notification__item__valuesWithContext._cont = ____AbandonFailedData_notification__item__valuesWithContext__item_
    ___AbandonFailedData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AbandonFailedData_notification__item_._cont = ASN1Dict([
        (u'type', ___AbandonFailedData_notification__item__type),
        (u'values', ___AbandonFailedData_notification__item__values),
        (u'valuesWithContext', ___AbandonFailedData_notification__item__valuesWithContext),
        ])
    __AbandonFailedData_notification__item_._ext = []
    _AbandonFailedData_notification._cont = __AbandonFailedData_notification__item_
    AbandonFailedData._cont = ASN1Dict([
        (u'problem', _AbandonFailedData_problem),
        (u'operation', _AbandonFailedData_operation),
        (u'securityParameters', _AbandonFailedData_securityParameters),
        (u'performer', _AbandonFailedData_performer),
        (u'aliasDereferenced', _AbandonFailedData_aliasDereferenced),
        (u'notification', _AbandonFailedData_notification),
        ])
    AbandonFailedData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< AbandonProblem >-----#
    AbandonProblem = INT(name=u'AbandonProblem', mode=MODE_TYPE)
    AbandonProblem._cont = ASN1Dict([(u'noSuchOperation', 1), (u'tooLate', 2), (u'cannotAbandon', 3)])
    
    #-----< attributeError >-----#
    attributeError = CLASS(name=u'attributeError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _attributeError_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __attributeError_val_ParameterType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    __attributeError_val_ParameterType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___attributeError_val_ParameterType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___attributeError_val_ParameterType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___attributeError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___attributeError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___attributeError_val_ParameterType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __attributeError_val_ParameterType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___attributeError_val_ParameterType_signed_toBeSigned),
        (u'algorithmIdentifier', ___attributeError_val_ParameterType_signed_algorithmIdentifier),
        (u'signature', ___attributeError_val_ParameterType_signed_signature),
        ])
    __attributeError_val_ParameterType_signed._ext = []
    _attributeError_val_ParameterType._cont = ASN1Dict([
        (u'unsigned', __attributeError_val_ParameterType_unsigned),
        (u'signed', __attributeError_val_ParameterType_signed),
        ])
    _attributeError_val_ParameterType._ext = None
    attributeError._val = dict([(u'ParameterType', _attributeError_val_ParameterType), (u'errorCode', (u'local', 1))])
    
    #-----< AttributeErrorData >-----#
    AttributeErrorData = SET(name=u'AttributeErrorData', mode=MODE_TYPE)
    _AttributeErrorData_object = CHOICE(name=u'object', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _AttributeErrorData_problems = SET_OF(name=u'problems', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AttributeErrorData_problems__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___AttributeErrorData_problems__item__problem = INT(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeProblem')))
    ___AttributeErrorData_problems__item__type = OID(name=u'type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___AttributeErrorData_problems__item__value = OPEN(name=u'value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeValue')), opt=True)
    __AttributeErrorData_problems__item_._cont = ASN1Dict([
        (u'problem', ___AttributeErrorData_problems__item__problem),
        (u'type', ___AttributeErrorData_problems__item__type),
        (u'value', ___AttributeErrorData_problems__item__value),
        ])
    __AttributeErrorData_problems__item_._ext = []
    _AttributeErrorData_problems._cont = __AttributeErrorData_problems__item_
    _AttributeErrorData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _AttributeErrorData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _AttributeErrorData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AttributeErrorData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AttributeErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___AttributeErrorData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____AttributeErrorData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____AttributeErrorData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____AttributeErrorData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____AttributeErrorData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____AttributeErrorData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____AttributeErrorData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___AttributeErrorData_notification__item__type._const_tab = ____AttributeErrorData_notification__item__type_tab
    ___AttributeErrorData_notification__item__type._const_tab_at = None
    ___AttributeErrorData_notification__item__type._const_tab_id = u'id'
    ___AttributeErrorData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____AttributeErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____AttributeErrorData_notification__item__values__item_._const_tab = ____AttributeErrorData_notification__item__type_tab
    ____AttributeErrorData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____AttributeErrorData_notification__item__values__item_._const_tab_id = u'Type'
    ___AttributeErrorData_notification__item__values._cont = ____AttributeErrorData_notification__item__values__item_
    ___AttributeErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___AttributeErrorData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____AttributeErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____AttributeErrorData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____AttributeErrorData_notification__item__valuesWithContext__item__value._const_tab = ____AttributeErrorData_notification__item__type_tab
    _____AttributeErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____AttributeErrorData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____AttributeErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______AttributeErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____AttributeErrorData_notification__item__valuesWithContext__item__contextList._cont = ______AttributeErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____AttributeErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____AttributeErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____AttributeErrorData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____AttributeErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____AttributeErrorData_notification__item__valuesWithContext__item_._ext = []
    ___AttributeErrorData_notification__item__valuesWithContext._cont = ____AttributeErrorData_notification__item__valuesWithContext__item_
    ___AttributeErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AttributeErrorData_notification__item_._cont = ASN1Dict([
        (u'type', ___AttributeErrorData_notification__item__type),
        (u'values', ___AttributeErrorData_notification__item__values),
        (u'valuesWithContext', ___AttributeErrorData_notification__item__valuesWithContext),
        ])
    __AttributeErrorData_notification__item_._ext = []
    _AttributeErrorData_notification._cont = __AttributeErrorData_notification__item_
    AttributeErrorData._cont = ASN1Dict([
        (u'object', _AttributeErrorData_object),
        (u'problems', _AttributeErrorData_problems),
        (u'securityParameters', _AttributeErrorData_securityParameters),
        (u'performer', _AttributeErrorData_performer),
        (u'aliasDereferenced', _AttributeErrorData_aliasDereferenced),
        (u'notification', _AttributeErrorData_notification),
        ])
    AttributeErrorData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< AttributeProblem >-----#
    AttributeProblem = INT(name=u'AttributeProblem', mode=MODE_TYPE)
    AttributeProblem._cont = ASN1Dict([(u'noSuchAttributeOrValue', 1), (u'invalidAttributeSyntax', 2), (u'undefinedAttributeType', 3), (u'inappropriateMatching', 4), (u'constraintViolation', 5), (u'attributeOrValueAlreadyExists', 6), (u'contextViolation', 7)])
    
    #-----< nameError >-----#
    nameError = CLASS(name=u'nameError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _nameError_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __nameError_val_ParameterType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    __nameError_val_ParameterType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___nameError_val_ParameterType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___nameError_val_ParameterType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____nameError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____nameError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____nameError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___nameError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___nameError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___nameError_val_ParameterType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __nameError_val_ParameterType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___nameError_val_ParameterType_signed_toBeSigned),
        (u'algorithmIdentifier', ___nameError_val_ParameterType_signed_algorithmIdentifier),
        (u'signature', ___nameError_val_ParameterType_signed_signature),
        ])
    __nameError_val_ParameterType_signed._ext = []
    _nameError_val_ParameterType._cont = ASN1Dict([
        (u'unsigned', __nameError_val_ParameterType_unsigned),
        (u'signed', __nameError_val_ParameterType_signed),
        ])
    _nameError_val_ParameterType._ext = None
    nameError._val = dict([(u'ParameterType', _nameError_val_ParameterType), (u'errorCode', (u'local', 2))])
    
    #-----< NameErrorData >-----#
    NameErrorData = SET(name=u'NameErrorData', mode=MODE_TYPE)
    _NameErrorData_problem = INT(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'NameProblem')))
    _NameErrorData_matched = CHOICE(name=u'matched', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _NameErrorData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _NameErrorData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _NameErrorData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _NameErrorData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __NameErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___NameErrorData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____NameErrorData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____NameErrorData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____NameErrorData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____NameErrorData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____NameErrorData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____NameErrorData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___NameErrorData_notification__item__type._const_tab = ____NameErrorData_notification__item__type_tab
    ___NameErrorData_notification__item__type._const_tab_at = None
    ___NameErrorData_notification__item__type._const_tab_id = u'id'
    ___NameErrorData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____NameErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____NameErrorData_notification__item__values__item_._const_tab = ____NameErrorData_notification__item__type_tab
    ____NameErrorData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____NameErrorData_notification__item__values__item_._const_tab_id = u'Type'
    ___NameErrorData_notification__item__values._cont = ____NameErrorData_notification__item__values__item_
    ___NameErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___NameErrorData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____NameErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____NameErrorData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____NameErrorData_notification__item__valuesWithContext__item__value._const_tab = ____NameErrorData_notification__item__type_tab
    _____NameErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____NameErrorData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____NameErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______NameErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____NameErrorData_notification__item__valuesWithContext__item__contextList._cont = ______NameErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____NameErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____NameErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____NameErrorData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____NameErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____NameErrorData_notification__item__valuesWithContext__item_._ext = []
    ___NameErrorData_notification__item__valuesWithContext._cont = ____NameErrorData_notification__item__valuesWithContext__item_
    ___NameErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __NameErrorData_notification__item_._cont = ASN1Dict([
        (u'type', ___NameErrorData_notification__item__type),
        (u'values', ___NameErrorData_notification__item__values),
        (u'valuesWithContext', ___NameErrorData_notification__item__valuesWithContext),
        ])
    __NameErrorData_notification__item_._ext = []
    _NameErrorData_notification._cont = __NameErrorData_notification__item_
    NameErrorData._cont = ASN1Dict([
        (u'problem', _NameErrorData_problem),
        (u'matched', _NameErrorData_matched),
        (u'securityParameters', _NameErrorData_securityParameters),
        (u'performer', _NameErrorData_performer),
        (u'aliasDereferenced', _NameErrorData_aliasDereferenced),
        (u'notification', _NameErrorData_notification),
        ])
    NameErrorData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< NameProblem >-----#
    NameProblem = INT(name=u'NameProblem', mode=MODE_TYPE)
    NameProblem._cont = ASN1Dict([(u'noSuchObject', 1), (u'aliasProblem', 2), (u'invalidAttributeSyntax', 3), (u'aliasDereferencingProblem', 4)])
    
    #-----< referral >-----#
    referral = CLASS(name=u'referral', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _referral_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __referral_val_ParameterType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    __referral_val_ParameterType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___referral_val_ParameterType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___referral_val_ParameterType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____referral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____referral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____referral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____referral_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____referral_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____referral_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____referral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____referral_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____referral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____referral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___referral_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____referral_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___referral_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___referral_val_ParameterType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __referral_val_ParameterType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___referral_val_ParameterType_signed_toBeSigned),
        (u'algorithmIdentifier', ___referral_val_ParameterType_signed_algorithmIdentifier),
        (u'signature', ___referral_val_ParameterType_signed_signature),
        ])
    __referral_val_ParameterType_signed._ext = []
    _referral_val_ParameterType._cont = ASN1Dict([
        (u'unsigned', __referral_val_ParameterType_unsigned),
        (u'signed', __referral_val_ParameterType_signed),
        ])
    _referral_val_ParameterType._ext = None
    referral._val = dict([(u'ParameterType', _referral_val_ParameterType), (u'errorCode', (u'local', 4))])
    
    #-----< ReferralData >-----#
    ReferralData = SET(name=u'ReferralData', mode=MODE_TYPE)
    _ReferralData_candidate = SET(name=u'candidate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ContinuationReference')))
    _ReferralData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ReferralData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ReferralData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ReferralData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ReferralData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ReferralData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____ReferralData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ReferralData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____ReferralData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ReferralData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____ReferralData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____ReferralData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ReferralData_notification__item__type._const_tab = ____ReferralData_notification__item__type_tab
    ___ReferralData_notification__item__type._const_tab_at = None
    ___ReferralData_notification__item__type._const_tab_id = u'id'
    ___ReferralData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____ReferralData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____ReferralData_notification__item__values__item_._const_tab = ____ReferralData_notification__item__type_tab
    ____ReferralData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____ReferralData_notification__item__values__item_._const_tab_id = u'Type'
    ___ReferralData_notification__item__values._cont = ____ReferralData_notification__item__values__item_
    ___ReferralData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ReferralData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ReferralData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ReferralData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____ReferralData_notification__item__valuesWithContext__item__value._const_tab = ____ReferralData_notification__item__type_tab
    _____ReferralData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____ReferralData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____ReferralData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______ReferralData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ReferralData_notification__item__valuesWithContext__item__contextList._cont = ______ReferralData_notification__item__valuesWithContext__item__contextList__item_
    _____ReferralData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ReferralData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____ReferralData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____ReferralData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ReferralData_notification__item__valuesWithContext__item_._ext = []
    ___ReferralData_notification__item__valuesWithContext._cont = ____ReferralData_notification__item__valuesWithContext__item_
    ___ReferralData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ReferralData_notification__item_._cont = ASN1Dict([
        (u'type', ___ReferralData_notification__item__type),
        (u'values', ___ReferralData_notification__item__values),
        (u'valuesWithContext', ___ReferralData_notification__item__valuesWithContext),
        ])
    __ReferralData_notification__item_._ext = []
    _ReferralData_notification._cont = __ReferralData_notification__item_
    ReferralData._cont = ASN1Dict([
        (u'candidate', _ReferralData_candidate),
        (u'securityParameters', _ReferralData_securityParameters),
        (u'performer', _ReferralData_performer),
        (u'aliasDereferenced', _ReferralData_aliasDereferenced),
        (u'notification', _ReferralData_notification),
        ])
    ReferralData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< securityError >-----#
    securityError = CLASS(name=u'securityError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _securityError_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __securityError_val_ParameterType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    __securityError_val_ParameterType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___securityError_val_ParameterType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___securityError_val_ParameterType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____securityError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____securityError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____securityError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___securityError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___securityError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___securityError_val_ParameterType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __securityError_val_ParameterType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___securityError_val_ParameterType_signed_toBeSigned),
        (u'algorithmIdentifier', ___securityError_val_ParameterType_signed_algorithmIdentifier),
        (u'signature', ___securityError_val_ParameterType_signed_signature),
        ])
    __securityError_val_ParameterType_signed._ext = []
    _securityError_val_ParameterType._cont = ASN1Dict([
        (u'unsigned', __securityError_val_ParameterType_unsigned),
        (u'signed', __securityError_val_ParameterType_signed),
        ])
    _securityError_val_ParameterType._ext = None
    securityError._val = dict([(u'ParameterType', _securityError_val_ParameterType), (u'errorCode', (u'local', 6))])
    
    #-----< SecurityErrorData >-----#
    SecurityErrorData = SET(name=u'SecurityErrorData', mode=MODE_TYPE)
    _SecurityErrorData_problem = INT(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _SecurityErrorData_spkmInfo = SEQ(name=u'spkmInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-ERROR')), opt=True)
    _SecurityErrorData_encPwdInfo = SEQ(name=u'encPwdInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'EncPwdInfo')), opt=True)
    _SecurityErrorData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _SecurityErrorData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _SecurityErrorData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _SecurityErrorData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SecurityErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SecurityErrorData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____SecurityErrorData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SecurityErrorData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____SecurityErrorData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SecurityErrorData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____SecurityErrorData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____SecurityErrorData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SecurityErrorData_notification__item__type._const_tab = ____SecurityErrorData_notification__item__type_tab
    ___SecurityErrorData_notification__item__type._const_tab_at = None
    ___SecurityErrorData_notification__item__type._const_tab_id = u'id'
    ___SecurityErrorData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____SecurityErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____SecurityErrorData_notification__item__values__item_._const_tab = ____SecurityErrorData_notification__item__type_tab
    ____SecurityErrorData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____SecurityErrorData_notification__item__values__item_._const_tab_id = u'Type'
    ___SecurityErrorData_notification__item__values._cont = ____SecurityErrorData_notification__item__values__item_
    ___SecurityErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SecurityErrorData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SecurityErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SecurityErrorData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____SecurityErrorData_notification__item__valuesWithContext__item__value._const_tab = ____SecurityErrorData_notification__item__type_tab
    _____SecurityErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____SecurityErrorData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____SecurityErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______SecurityErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SecurityErrorData_notification__item__valuesWithContext__item__contextList._cont = ______SecurityErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____SecurityErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SecurityErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____SecurityErrorData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____SecurityErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____SecurityErrorData_notification__item__valuesWithContext__item_._ext = []
    ___SecurityErrorData_notification__item__valuesWithContext._cont = ____SecurityErrorData_notification__item__valuesWithContext__item_
    ___SecurityErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SecurityErrorData_notification__item_._cont = ASN1Dict([
        (u'type', ___SecurityErrorData_notification__item__type),
        (u'values', ___SecurityErrorData_notification__item__values),
        (u'valuesWithContext', ___SecurityErrorData_notification__item__valuesWithContext),
        ])
    __SecurityErrorData_notification__item_._ext = []
    _SecurityErrorData_notification._cont = __SecurityErrorData_notification__item_
    SecurityErrorData._cont = ASN1Dict([
        (u'problem', _SecurityErrorData_problem),
        (u'spkmInfo', _SecurityErrorData_spkmInfo),
        (u'encPwdInfo', _SecurityErrorData_encPwdInfo),
        (u'securityParameters', _SecurityErrorData_securityParameters),
        (u'performer', _SecurityErrorData_performer),
        (u'aliasDereferenced', _SecurityErrorData_aliasDereferenced),
        (u'notification', _SecurityErrorData_notification),
        ])
    SecurityErrorData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< SecurityProblem >-----#
    SecurityProblem = INT(name=u'SecurityProblem', mode=MODE_TYPE)
    SecurityProblem._cont = ASN1Dict([(u'inappropriateAuthentication', 1), (u'invalidCredentials', 2), (u'insufficientAccessRights', 3), (u'invalidSignature', 4), (u'protectionRequired', 5), (u'noInformation', 6), (u'blockedCredentials', 7), (u'spkmError', 9), (u'unsupportedAuthenticationMethod', 10), (u'passwordExpired', 11), (u'inappropriateAlgorithms', 12)])
    
    #-----< EncPwdInfo >-----#
    EncPwdInfo = SEQ(name=u'EncPwdInfo', mode=MODE_TYPE)
    _EncPwdInfo_algorithms = SEQ_OF(name=u'algorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __EncPwdInfo_algorithms__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___EncPwdInfo_algorithms__item__algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____EncPwdInfo_algorithms__item__algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EncPwdInfo_algorithms__item__algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EncPwdInfo_algorithms__item__algorithm._const_tab = ____EncPwdInfo_algorithms__item__algorithm_tab
    ___EncPwdInfo_algorithms__item__algorithm._const_tab_at = None
    ___EncPwdInfo_algorithms__item__algorithm._const_tab_id = u'id'
    ___EncPwdInfo_algorithms__item__parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____EncPwdInfo_algorithms__item__parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EncPwdInfo_algorithms__item__parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EncPwdInfo_algorithms__item__parameters._const_tab = ____EncPwdInfo_algorithms__item__parameters_tab
    ___EncPwdInfo_algorithms__item__parameters._const_tab_at = ('..', u'algorithm')
    ___EncPwdInfo_algorithms__item__parameters._const_tab_id = u'Type'
    __EncPwdInfo_algorithms__item_._cont = ASN1Dict([
        (u'algorithm', ___EncPwdInfo_algorithms__item__algorithm),
        (u'parameters', ___EncPwdInfo_algorithms__item__parameters),
        ])
    __EncPwdInfo_algorithms__item_._ext = []
    _EncPwdInfo_algorithms._cont = __EncPwdInfo_algorithms__item_
    _EncPwdInfo_pwdQualityRule = SEQ_OF(name=u'pwdQualityRule', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __EncPwdInfo_pwdQualityRule__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    _EncPwdInfo_pwdQualityRule._cont = __EncPwdInfo_pwdQualityRule__item_
    EncPwdInfo._cont = ASN1Dict([
        (u'algorithms', _EncPwdInfo_algorithms),
        (u'pwdQualityRule', _EncPwdInfo_pwdQualityRule),
        ])
    EncPwdInfo._ext = []
    
    #-----< serviceError >-----#
    serviceError = CLASS(name=u'serviceError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _serviceError_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __serviceError_val_ParameterType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    __serviceError_val_ParameterType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___serviceError_val_ParameterType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___serviceError_val_ParameterType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___serviceError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___serviceError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___serviceError_val_ParameterType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __serviceError_val_ParameterType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___serviceError_val_ParameterType_signed_toBeSigned),
        (u'algorithmIdentifier', ___serviceError_val_ParameterType_signed_algorithmIdentifier),
        (u'signature', ___serviceError_val_ParameterType_signed_signature),
        ])
    __serviceError_val_ParameterType_signed._ext = []
    _serviceError_val_ParameterType._cont = ASN1Dict([
        (u'unsigned', __serviceError_val_ParameterType_unsigned),
        (u'signed', __serviceError_val_ParameterType_signed),
        ])
    _serviceError_val_ParameterType._ext = None
    serviceError._val = dict([(u'ParameterType', _serviceError_val_ParameterType), (u'errorCode', (u'local', 3))])
    
    #-----< ServiceErrorData >-----#
    ServiceErrorData = SET(name=u'ServiceErrorData', mode=MODE_TYPE)
    _ServiceErrorData_problem = INT(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _ServiceErrorData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ServiceErrorData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ServiceErrorData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ServiceErrorData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ServiceErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ServiceErrorData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____ServiceErrorData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ServiceErrorData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____ServiceErrorData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ServiceErrorData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____ServiceErrorData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____ServiceErrorData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ServiceErrorData_notification__item__type._const_tab = ____ServiceErrorData_notification__item__type_tab
    ___ServiceErrorData_notification__item__type._const_tab_at = None
    ___ServiceErrorData_notification__item__type._const_tab_id = u'id'
    ___ServiceErrorData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____ServiceErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____ServiceErrorData_notification__item__values__item_._const_tab = ____ServiceErrorData_notification__item__type_tab
    ____ServiceErrorData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____ServiceErrorData_notification__item__values__item_._const_tab_id = u'Type'
    ___ServiceErrorData_notification__item__values._cont = ____ServiceErrorData_notification__item__values__item_
    ___ServiceErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ServiceErrorData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ServiceErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ServiceErrorData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____ServiceErrorData_notification__item__valuesWithContext__item__value._const_tab = ____ServiceErrorData_notification__item__type_tab
    _____ServiceErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____ServiceErrorData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____ServiceErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______ServiceErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ServiceErrorData_notification__item__valuesWithContext__item__contextList._cont = ______ServiceErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____ServiceErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ServiceErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____ServiceErrorData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____ServiceErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ServiceErrorData_notification__item__valuesWithContext__item_._ext = []
    ___ServiceErrorData_notification__item__valuesWithContext._cont = ____ServiceErrorData_notification__item__valuesWithContext__item_
    ___ServiceErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ServiceErrorData_notification__item_._cont = ASN1Dict([
        (u'type', ___ServiceErrorData_notification__item__type),
        (u'values', ___ServiceErrorData_notification__item__values),
        (u'valuesWithContext', ___ServiceErrorData_notification__item__valuesWithContext),
        ])
    __ServiceErrorData_notification__item_._ext = []
    _ServiceErrorData_notification._cont = __ServiceErrorData_notification__item_
    ServiceErrorData._cont = ASN1Dict([
        (u'problem', _ServiceErrorData_problem),
        (u'securityParameters', _ServiceErrorData_securityParameters),
        (u'performer', _ServiceErrorData_performer),
        (u'aliasDereferenced', _ServiceErrorData_aliasDereferenced),
        (u'notification', _ServiceErrorData_notification),
        ])
    ServiceErrorData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< ServiceProblem >-----#
    ServiceProblem = INT(name=u'ServiceProblem', mode=MODE_TYPE)
    ServiceProblem._cont = ASN1Dict([(u'busy', 1), (u'unavailable', 2), (u'unwillingToPerform', 3), (u'chainingRequired', 4), (u'unableToProceed', 5), (u'invalidReference', 6), (u'timeLimitExceeded', 7), (u'administrativeLimitExceeded', 8), (u'loopDetected', 9), (u'unavailableCriticalExtension', 10), (u'outOfScope', 11), (u'ditError', 12), (u'invalidQueryReference', 13), (u'requestedServiceNotAvailable', 14), (u'unsupportedMatchingUse', 15), (u'ambiguousKeyAttributes', 16), (u'saslBindInProgress', 17), (u'notSupportedByLDAP', 18)])
    
    #-----< updateError >-----#
    updateError = CLASS(name=u'updateError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _updateError_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __updateError_val_ParameterType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    __updateError_val_ParameterType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___updateError_val_ParameterType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___updateError_val_ParameterType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____updateError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____updateError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____updateError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___updateError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___updateError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___updateError_val_ParameterType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __updateError_val_ParameterType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___updateError_val_ParameterType_signed_toBeSigned),
        (u'algorithmIdentifier', ___updateError_val_ParameterType_signed_algorithmIdentifier),
        (u'signature', ___updateError_val_ParameterType_signed_signature),
        ])
    __updateError_val_ParameterType_signed._ext = []
    _updateError_val_ParameterType._cont = ASN1Dict([
        (u'unsigned', __updateError_val_ParameterType_unsigned),
        (u'signed', __updateError_val_ParameterType_signed),
        ])
    _updateError_val_ParameterType._ext = None
    updateError._val = dict([(u'ParameterType', _updateError_val_ParameterType), (u'errorCode', (u'local', 8))])
    
    #-----< UpdateErrorData >-----#
    UpdateErrorData = SET(name=u'UpdateErrorData', mode=MODE_TYPE)
    _UpdateErrorData_problem = INT(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateProblem')))
    _UpdateErrorData_attributeInfo = SET_OF(name=u'attributeInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UpdateErrorData_attributeInfo__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___UpdateErrorData_attributeInfo__item__attributeType = OID(name=u'attributeType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ___UpdateErrorData_attributeInfo__item__attribute = SEQ(name=u'attribute', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____UpdateErrorData_attributeInfo__item__attribute_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _____UpdateErrorData_attributeInfo__item__attribute_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____UpdateErrorData_attributeInfo__item__attribute_type_tab._val = ASN1Set(rv=[dict([(u'Type', ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____UpdateErrorData_attributeInfo__item__attribute_type._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    ____UpdateErrorData_attributeInfo__item__attribute_type._const_tab_at = None
    ____UpdateErrorData_attributeInfo__item__attribute_type._const_tab_id = u'id'
    ____UpdateErrorData_attributeInfo__item__attribute_values = SET_OF(name=u'values', mode=MODE_TYPE)
    _____UpdateErrorData_attributeInfo__item__attribute_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____UpdateErrorData_attributeInfo__item__attribute_values__item_._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    _____UpdateErrorData_attributeInfo__item__attribute_values__item_._const_tab_at = ('..', '..', u'type')
    _____UpdateErrorData_attributeInfo__item__attribute_values__item_._const_tab_id = u'Type'
    ____UpdateErrorData_attributeInfo__item__attribute_values._cont = _____UpdateErrorData_attributeInfo__item__attribute_values__item_
    ____UpdateErrorData_attributeInfo__item__attribute_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    _____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value._const_tab_id = u'Type'
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    _______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList._cont = _______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList__item_
    ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item_._cont = ASN1Dict([
        (u'value', ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value),
        (u'contextList', ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList),
        ])
    _____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item_._ext = []
    ____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext._cont = _____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item_
    ____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___UpdateErrorData_attributeInfo__item__attribute._cont = ASN1Dict([
        (u'type', ____UpdateErrorData_attributeInfo__item__attribute_type),
        (u'values', ____UpdateErrorData_attributeInfo__item__attribute_values),
        (u'valuesWithContext', ____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext),
        ])
    ___UpdateErrorData_attributeInfo__item__attribute._ext = []
    __UpdateErrorData_attributeInfo__item_._cont = ASN1Dict([
        (u'attributeType', ___UpdateErrorData_attributeInfo__item__attributeType),
        (u'attribute', ___UpdateErrorData_attributeInfo__item__attribute),
        ])
    __UpdateErrorData_attributeInfo__item_._ext = []
    _UpdateErrorData_attributeInfo._cont = __UpdateErrorData_attributeInfo__item_
    _UpdateErrorData_attributeInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UpdateErrorData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _UpdateErrorData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _UpdateErrorData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _UpdateErrorData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UpdateErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___UpdateErrorData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ___UpdateErrorData_notification__item__type._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    ___UpdateErrorData_notification__item__type._const_tab_at = None
    ___UpdateErrorData_notification__item__type._const_tab_id = u'id'
    ___UpdateErrorData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____UpdateErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____UpdateErrorData_notification__item__values__item_._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    ____UpdateErrorData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____UpdateErrorData_notification__item__values__item_._const_tab_id = u'Type'
    ___UpdateErrorData_notification__item__values._cont = ____UpdateErrorData_notification__item__values__item_
    ___UpdateErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___UpdateErrorData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____UpdateErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____UpdateErrorData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____UpdateErrorData_notification__item__valuesWithContext__item__value._const_tab = _____UpdateErrorData_attributeInfo__item__attribute_type_tab
    _____UpdateErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____UpdateErrorData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____UpdateErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______UpdateErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____UpdateErrorData_notification__item__valuesWithContext__item__contextList._cont = ______UpdateErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____UpdateErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____UpdateErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____UpdateErrorData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____UpdateErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____UpdateErrorData_notification__item__valuesWithContext__item_._ext = []
    ___UpdateErrorData_notification__item__valuesWithContext._cont = ____UpdateErrorData_notification__item__valuesWithContext__item_
    ___UpdateErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __UpdateErrorData_notification__item_._cont = ASN1Dict([
        (u'type', ___UpdateErrorData_notification__item__type),
        (u'values', ___UpdateErrorData_notification__item__values),
        (u'valuesWithContext', ___UpdateErrorData_notification__item__valuesWithContext),
        ])
    __UpdateErrorData_notification__item_._ext = []
    _UpdateErrorData_notification._cont = __UpdateErrorData_notification__item_
    UpdateErrorData._cont = ASN1Dict([
        (u'problem', _UpdateErrorData_problem),
        (u'attributeInfo', _UpdateErrorData_attributeInfo),
        (u'securityParameters', _UpdateErrorData_securityParameters),
        (u'performer', _UpdateErrorData_performer),
        (u'aliasDereferenced', _UpdateErrorData_aliasDereferenced),
        (u'notification', _UpdateErrorData_notification),
        ])
    UpdateErrorData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< UpdateProblem >-----#
    UpdateProblem = INT(name=u'UpdateProblem', mode=MODE_TYPE)
    UpdateProblem._cont = ASN1Dict([(u'namingViolation', 1), (u'objectClassViolation', 2), (u'notAllowedOnNonLeaf', 3), (u'notAllowedOnRDN', 4), (u'entryAlreadyExists', 5), (u'affectsMultipleDSAs', 6), (u'objectClassModificationProhibited', 7), (u'noSuchSuperior', 8), (u'notAncestor', 9), (u'parentNotAncestor', 10), (u'hierarchyRuleViolation', 11), (u'familyRuleViolation', 12), (u'insufficientPasswordQuality', 13), (u'passwordInHistory', 14), (u'noPasswordSlot', 15)])
    
    #-----< id-at-family-information >-----#
    id_at_family_information = OID(name=u'id-at-family-information', mode=MODE_VALUE)
    id_at_family_information._val = (2, 5, 4, 64)
    
    _all_ = [
        _CommonArguments_serviceControls,
        _CommonArguments_securityParameters,
        _CommonArguments_requestor,
        _CommonArguments_operationProgress,
        _CommonArguments_aliasedRDNs,
        _CommonArguments_criticalExtensions,
        _CommonArguments_referenceType,
        _CommonArguments_entryOnly,
        _CommonArguments_exclusions,
        _CommonArguments_nameResolveOnMaster,
        _CommonArguments_operationContexts,
        _CommonArguments_familyGrouping,
        CommonArguments,
        _CommonArgumentsSeq_serviceControls,
        _CommonArgumentsSeq_securityParameters,
        _CommonArgumentsSeq_requestor,
        _CommonArgumentsSeq_operationProgress,
        _CommonArgumentsSeq_aliasedRDNs,
        _CommonArgumentsSeq_criticalExtensions,
        _CommonArgumentsSeq_referenceType,
        _CommonArgumentsSeq_entryOnly,
        _CommonArgumentsSeq_exclusions,
        _CommonArgumentsSeq_nameResolveOnMaster,
        _CommonArgumentsSeq_operationContexts,
        _CommonArgumentsSeq_familyGrouping,
        CommonArgumentsSeq,
        FamilyGrouping,
        _CommonResults_securityParameters,
        _CommonResults_performer,
        _CommonResults_aliasDereferenced,
        ____CommonResults_notification__item__type_tab,
        _____CommonResults_notification__item__type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        _____CommonResults_notification__item__type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        ___CommonResults_notification__item__type,
        ____CommonResults_notification__item__values__item_,
        ___CommonResults_notification__item__values,
        _____CommonResults_notification__item__valuesWithContext__item__value,
        ______CommonResults_notification__item__valuesWithContext__item__contextList__item_,
        _____CommonResults_notification__item__valuesWithContext__item__contextList,
        ____CommonResults_notification__item__valuesWithContext__item_,
        ___CommonResults_notification__item__valuesWithContext,
        __CommonResults_notification__item_,
        _CommonResults_notification,
        CommonResults,
        _CommonResultsSeq_securityParameters,
        _CommonResultsSeq_performer,
        _CommonResultsSeq_aliasDereferenced,
        ____CommonResultsSeq_notification__item__type_tab,
        _____CommonResultsSeq_notification__item__type_tab_val_Type_0,
        _____CommonResultsSeq_notification__item__type_tab_val_Type_1,
        ___CommonResultsSeq_notification__item__type,
        ____CommonResultsSeq_notification__item__values__item_,
        ___CommonResultsSeq_notification__item__values,
        _____CommonResultsSeq_notification__item__valuesWithContext__item__value,
        ______CommonResultsSeq_notification__item__valuesWithContext__item__contextList__item_,
        _____CommonResultsSeq_notification__item__valuesWithContext__item__contextList,
        ____CommonResultsSeq_notification__item__valuesWithContext__item_,
        ___CommonResultsSeq_notification__item__valuesWithContext,
        __CommonResultsSeq_notification__item_,
        _CommonResultsSeq_notification,
        CommonResultsSeq,
        _ServiceControls_options,
        _ServiceControls_priority,
        _ServiceControls_timeLimit,
        _ServiceControls_sizeLimit,
        _ServiceControls_scopeOfReferral,
        _ServiceControls_attributeSizeLimit,
        __ServiceControls_manageDSAITPlaneRef_dsaName,
        __ServiceControls_manageDSAITPlaneRef_agreementID,
        _ServiceControls_manageDSAITPlaneRef,
        _ServiceControls_serviceType,
        _ServiceControls_userClass,
        ServiceControls,
        ServiceControlOptions,
        __EntryInformationSelection_attributes_allUserAttributes,
        ___EntryInformationSelection_attributes_select__item_,
        __EntryInformationSelection_attributes_select,
        _EntryInformationSelection_attributes,
        _EntryInformationSelection_infoTypes,
        __EntryInformationSelection_extraAttributes_allOperationalAttributes,
        ___EntryInformationSelection_extraAttributes_select__item_,
        __EntryInformationSelection_extraAttributes_select,
        _EntryInformationSelection_extraAttributes,
        _EntryInformationSelection_contextSelection,
        _EntryInformationSelection_returnContexts,
        _EntryInformationSelection_familyReturn,
        EntryInformationSelection,
        _ContextSelection_allContexts,
        __ContextSelection_selectedContexts__item_,
        _ContextSelection_selectedContexts,
        ContextSelection,
        _TypeAndContextAssertion_type,
        ___TypeAndContextAssertion_contextAssertions_preference__item_,
        __TypeAndContextAssertion_contextAssertions_preference,
        ___TypeAndContextAssertion_contextAssertions_all__item_,
        __TypeAndContextAssertion_contextAssertions_all,
        _TypeAndContextAssertion_contextAssertions,
        TypeAndContextAssertion,
        _FamilyReturn_memberSelect,
        __FamilyReturn_familySelect__item_,
        _FamilyReturn_familySelect,
        FamilyReturn,
        _EntryInformation_name,
        _EntryInformation_fromEntry,
        ___EntryInformation_information__item__attributeType,
        _____EntryInformation_information__item__attribute_type_tab,
        ______EntryInformation_information__item__attribute_type_tab_val_Type_0,
        ______EntryInformation_information__item__attribute_type_tab_val_Type_1,
        ____EntryInformation_information__item__attribute_type,
        _____EntryInformation_information__item__attribute_values__item_,
        ____EntryInformation_information__item__attribute_values,
        ______EntryInformation_information__item__attribute_valuesWithContext__item__value,
        _______EntryInformation_information__item__attribute_valuesWithContext__item__contextList__item_,
        ______EntryInformation_information__item__attribute_valuesWithContext__item__contextList,
        _____EntryInformation_information__item__attribute_valuesWithContext__item_,
        ____EntryInformation_information__item__attribute_valuesWithContext,
        ___EntryInformation_information__item__attribute,
        __EntryInformation_information__item_,
        _EntryInformation_information,
        _EntryInformation_incompleteEntry,
        _EntryInformation_partialName,
        _EntryInformation_derivedEntry,
        EntryInformation,
        family_information,
        _family_information_val_Type,
        _FamilyEntries_family_class,
        __FamilyEntries_familyEntries__item_,
        _FamilyEntries_familyEntries,
        FamilyEntries,
        _FamilyEntry_rdn,
        ___FamilyEntry_information__item__attributeType,
        _____FamilyEntry_information__item__attribute_type_tab,
        ______FamilyEntry_information__item__attribute_type_tab_val_Type_0,
        ______FamilyEntry_information__item__attribute_type_tab_val_Type_1,
        ____FamilyEntry_information__item__attribute_type,
        _____FamilyEntry_information__item__attribute_values__item_,
        ____FamilyEntry_information__item__attribute_values,
        ______FamilyEntry_information__item__attribute_valuesWithContext__item__value,
        _______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList__item_,
        ______FamilyEntry_information__item__attribute_valuesWithContext__item__contextList,
        _____FamilyEntry_information__item__attribute_valuesWithContext__item_,
        ____FamilyEntry_information__item__attribute_valuesWithContext,
        ___FamilyEntry_information__item__attribute,
        __FamilyEntry_information__item_,
        _FamilyEntry_information,
        __FamilyEntry_family_info__item_,
        _FamilyEntry_family_info,
        FamilyEntry,
        _Filter_item,
        __Filter_and___item_,
        _Filter_and_,
        __Filter_or___item_,
        _Filter_or_,
        _Filter_not_,
        Filter,
        _FilterItem_equality,
        ___FilterItem_substrings_type_tab,
        ____FilterItem_substrings_type_tab_val_Type_0,
        ____FilterItem_substrings_type_tab_val_Type_1,
        __FilterItem_substrings_type,
        ____FilterItem_substrings_strings__item__initial,
        ____FilterItem_substrings_strings__item__any,
        ____FilterItem_substrings_strings__item__final,
        _____FilterItem_substrings_strings__item__control_type,
        ______FilterItem_substrings_strings__item__control_values__item_,
        _____FilterItem_substrings_strings__item__control_values,
        _______FilterItem_substrings_strings__item__control_valuesWithContext__item__value,
        ________FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList__item_,
        _______FilterItem_substrings_strings__item__control_valuesWithContext__item__contextList,
        ______FilterItem_substrings_strings__item__control_valuesWithContext__item_,
        _____FilterItem_substrings_strings__item__control_valuesWithContext,
        ____FilterItem_substrings_strings__item__control,
        ___FilterItem_substrings_strings__item_,
        __FilterItem_substrings_strings,
        _FilterItem_substrings,
        _FilterItem_greaterOrEqual,
        _FilterItem_lessOrEqual,
        _FilterItem_present,
        _FilterItem_approximateMatch,
        _FilterItem_extensibleMatch,
        _FilterItem_contextPresent,
        FilterItem,
        __MatchingRuleAssertion_matchingRule__item_,
        _MatchingRuleAssertion_matchingRule,
        _MatchingRuleAssertion_type,
        _MatchingRuleAssertion_matchValue,
        _MatchingRuleAssertion_dnAttributes,
        MatchingRuleAssertion,
        __PagedResultsRequest_newRequest_pageSize,
        ___PagedResultsRequest_newRequest_sortKeys__item_,
        __PagedResultsRequest_newRequest_sortKeys,
        __PagedResultsRequest_newRequest_reverse,
        __PagedResultsRequest_newRequest_unmerged,
        __PagedResultsRequest_newRequest_pageNumber,
        _PagedResultsRequest_newRequest,
        _PagedResultsRequest_queryReference,
        _PagedResultsRequest_abandonQuery,
        PagedResultsRequest,
        _SortKey_type,
        _SortKey_orderingRule,
        SortKey,
        _SecurityParameters_certification_path,
        _SecurityParameters_name,
        _SecurityParameters_time,
        _SecurityParameters_random,
        _SecurityParameters_target,
        _SecurityParameters_operationCode,
        _SecurityParameters_errorProtection,
        _SecurityParameters_errorCode,
        SecurityParameters,
        ProtectionRequest,
        _Time_utcTime,
        _Time_generalizedTime,
        Time,
        ErrorProtectionRequest,
        directoryBind,
        _directoryBind_val_ArgumentType,
        _directoryBind_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        _DirectoryBindArgument_credentials,
        _DirectoryBindArgument_versions,
        DirectoryBindArgument,
        _Credentials_simple,
        _Credentials_strong,
        _Credentials_externalProcedure,
        _Credentials_spkm,
        _Credentials_sasl,
        Credentials,
        _SimpleCredentials_name,
        ___SimpleCredentials_validity_time1_utc,
        ___SimpleCredentials_validity_time1_gt,
        __SimpleCredentials_validity_time1,
        ___SimpleCredentials_validity_time2_utc,
        ___SimpleCredentials_validity_time2_gt,
        __SimpleCredentials_validity_time2,
        __SimpleCredentials_validity_random1,
        __SimpleCredentials_validity_random2,
        _SimpleCredentials_validity,
        __SimpleCredentials_password_unprotected,
        _____SimpleCredentials_password_protected_algorithmIdentifier_algorithm_tab,
        ____SimpleCredentials_password_protected_algorithmIdentifier_algorithm,
        _____SimpleCredentials_password_protected_algorithmIdentifier_parameters_tab,
        ____SimpleCredentials_password_protected_algorithmIdentifier_parameters,
        ___SimpleCredentials_password_protected_algorithmIdentifier,
        ___SimpleCredentials_password_protected_hashValue,
        __SimpleCredentials_password_protected,
        __SimpleCredentials_password_userPwd,
        _SimpleCredentials_password,
        SimpleCredentials,
        _StrongCredentials_certification_path,
        _StrongCredentials_bind_token,
        _StrongCredentials_name,
        _StrongCredentials_attributeCertificationPath,
        StrongCredentials,
        _SpkmCredentials_req,
        _SpkmCredentials_rep,
        SpkmCredentials,
        __SaslCredentials_mechanism_teletexString,
        __SaslCredentials_mechanism_printableString,
        __SaslCredentials_mechanism_bmpString,
        __SaslCredentials_mechanism_universalString,
        __SaslCredentials_mechanism_uTF8String,
        _SaslCredentials_mechanism,
        _SaslCredentials_credentials,
        _SaslCredentials_saslAbort,
        SaslCredentials,
        ub_saslMechanism,
        _Token_toBeSigned,
        ___Token_algorithmIdentifier_algorithm_tab,
        __Token_algorithmIdentifier_algorithm,
        ___Token_algorithmIdentifier_parameters_tab,
        __Token_algorithmIdentifier_parameters,
        _Token_algorithmIdentifier,
        _Token_signature,
        Token,
        ___TokenContent_algorithm_algorithm_tab,
        __TokenContent_algorithm_algorithm,
        ___TokenContent_algorithm_parameters_tab,
        __TokenContent_algorithm_parameters,
        _TokenContent_algorithm,
        _TokenContent_name,
        _TokenContent_time,
        _TokenContent_random,
        _TokenContent_response,
        TokenContent,
        Versions,
        _DirectoryBindResult_credentials,
        _DirectoryBindResult_versions,
        _DirectoryBindResult_pwdResponseValue,
        DirectoryBindResult,
        __PwdResponseValue_warning_timeLeft,
        __PwdResponseValue_warning_graceRemaining,
        _PwdResponseValue_warning,
        _PwdResponseValue_error,
        PwdResponseValue,
        directoryBindError,
        ___directoryBindError_val_ParameterType_unsigned_versions,
        ____directoryBindError_val_ParameterType_unsigned_error_serviceError,
        ____directoryBindError_val_ParameterType_unsigned_error_securityError,
        ___directoryBindError_val_ParameterType_unsigned_error,
        ___directoryBindError_val_ParameterType_unsigned_securityParameters,
        __directoryBindError_val_ParameterType_unsigned,
        ____directoryBindError_val_ParameterType_signed_toBeSigned_versions,
        _____directoryBindError_val_ParameterType_signed_toBeSigned_error_serviceError,
        _____directoryBindError_val_ParameterType_signed_toBeSigned_error_securityError,
        ____directoryBindError_val_ParameterType_signed_toBeSigned_error,
        ____directoryBindError_val_ParameterType_signed_toBeSigned_securityParameters,
        ___directoryBindError_val_ParameterType_signed_toBeSigned,
        _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____directoryBindError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___directoryBindError_val_ParameterType_signed_algorithmIdentifier,
        ___directoryBindError_val_ParameterType_signed_signature,
        __directoryBindError_val_ParameterType_signed,
        _directoryBindError_val_ParameterType,
        BindKeyInfo,
        read,
        _read_val_ArgumentType,
        _read_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_Errors_val_ParameterType_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_signed,
        __OPERATION_Errors_val_ParameterType_2,
        ___OPERATION_Errors_val_ParameterType_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_signed,
        __OPERATION_Errors_val_ParameterType_3,
        ___OPERATION_Errors_val_ParameterType_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_signed,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_Errors_val_ParameterType_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_signed,
        __OPERATION_Errors_val_ParameterType_5,
        _ReadArgument_unsigned,
        __ReadArgument_signed_toBeSigned,
        ____ReadArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ReadArgument_signed_algorithmIdentifier_algorithm,
        ____ReadArgument_signed_algorithmIdentifier_parameters_tab,
        ___ReadArgument_signed_algorithmIdentifier_parameters,
        __ReadArgument_signed_algorithmIdentifier,
        __ReadArgument_signed_signature,
        _ReadArgument_signed,
        ReadArgument,
        _ReadArgumentData_object,
        _ReadArgumentData_selection,
        _ReadArgumentData_modifyRightsRequest,
        _ReadArgumentData_serviceControls,
        _ReadArgumentData_securityParameters,
        _ReadArgumentData_requestor,
        _ReadArgumentData_operationProgress,
        _ReadArgumentData_aliasedRDNs,
        _ReadArgumentData_criticalExtensions,
        _ReadArgumentData_referenceType,
        _ReadArgumentData_entryOnly,
        _ReadArgumentData_exclusions,
        _ReadArgumentData_nameResolveOnMaster,
        _ReadArgumentData_operationContexts,
        _ReadArgumentData_familyGrouping,
        ReadArgumentData,
        _ReadResult_unsigned,
        __ReadResult_signed_toBeSigned,
        ____ReadResult_signed_algorithmIdentifier_algorithm_tab,
        ___ReadResult_signed_algorithmIdentifier_algorithm,
        ____ReadResult_signed_algorithmIdentifier_parameters_tab,
        ___ReadResult_signed_algorithmIdentifier_parameters,
        __ReadResult_signed_algorithmIdentifier,
        __ReadResult_signed_signature,
        _ReadResult_signed,
        ReadResult,
        _ReadResultData_entry,
        _ReadResultData_modifyRights,
        _ReadResultData_securityParameters,
        _ReadResultData_performer,
        _ReadResultData_aliasDereferenced,
        ____ReadResultData_notification__item__type_tab,
        _____ReadResultData_notification__item__type_tab_val_Type_0,
        _____ReadResultData_notification__item__type_tab_val_Type_1,
        ___ReadResultData_notification__item__type,
        ____ReadResultData_notification__item__values__item_,
        ___ReadResultData_notification__item__values,
        _____ReadResultData_notification__item__valuesWithContext__item__value,
        ______ReadResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____ReadResultData_notification__item__valuesWithContext__item__contextList,
        ____ReadResultData_notification__item__valuesWithContext__item_,
        ___ReadResultData_notification__item__valuesWithContext,
        __ReadResultData_notification__item_,
        _ReadResultData_notification,
        ReadResultData,
        ___ModifyRights__item__item_entry,
        ___ModifyRights__item__item_attribute,
        ___ModifyRights__item__item_value,
        __ModifyRights__item__item,
        __ModifyRights__item__permission,
        _ModifyRights__item_,
        ModifyRights,
        compare,
        _compare_val_ArgumentType,
        _compare_val_ResultType,
        _CompareArgument_unsigned,
        __CompareArgument_signed_toBeSigned,
        ____CompareArgument_signed_algorithmIdentifier_algorithm_tab,
        ___CompareArgument_signed_algorithmIdentifier_algorithm,
        ____CompareArgument_signed_algorithmIdentifier_parameters_tab,
        ___CompareArgument_signed_algorithmIdentifier_parameters,
        __CompareArgument_signed_algorithmIdentifier,
        __CompareArgument_signed_signature,
        _CompareArgument_signed,
        CompareArgument,
        _CompareArgumentData_object,
        _CompareArgumentData_purported,
        _CompareArgumentData_serviceControls,
        _CompareArgumentData_securityParameters,
        _CompareArgumentData_requestor,
        _CompareArgumentData_operationProgress,
        _CompareArgumentData_aliasedRDNs,
        _CompareArgumentData_criticalExtensions,
        _CompareArgumentData_referenceType,
        _CompareArgumentData_entryOnly,
        _CompareArgumentData_exclusions,
        _CompareArgumentData_nameResolveOnMaster,
        _CompareArgumentData_operationContexts,
        _CompareArgumentData_familyGrouping,
        CompareArgumentData,
        _CompareResult_unsigned,
        __CompareResult_signed_toBeSigned,
        ____CompareResult_signed_algorithmIdentifier_algorithm_tab,
        ___CompareResult_signed_algorithmIdentifier_algorithm,
        ____CompareResult_signed_algorithmIdentifier_parameters_tab,
        ___CompareResult_signed_algorithmIdentifier_parameters,
        __CompareResult_signed_algorithmIdentifier,
        __CompareResult_signed_signature,
        _CompareResult_signed,
        CompareResult,
        _CompareResultData_name,
        _CompareResultData_matched,
        _CompareResultData_fromEntry,
        _CompareResultData_matchedSubtype,
        _CompareResultData_securityParameters,
        _CompareResultData_performer,
        _CompareResultData_aliasDereferenced,
        ____CompareResultData_notification__item__type_tab,
        _____CompareResultData_notification__item__type_tab_val_Type_0,
        _____CompareResultData_notification__item__type_tab_val_Type_1,
        ___CompareResultData_notification__item__type,
        ____CompareResultData_notification__item__values__item_,
        ___CompareResultData_notification__item__values,
        _____CompareResultData_notification__item__valuesWithContext__item__value,
        ______CompareResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____CompareResultData_notification__item__valuesWithContext__item__contextList,
        ____CompareResultData_notification__item__valuesWithContext__item_,
        ___CompareResultData_notification__item__valuesWithContext,
        __CompareResultData_notification__item_,
        _CompareResultData_notification,
        CompareResultData,
        abandon,
        _abandon_val_ArgumentType,
        _abandon_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_1_signed,
        __OPERATION_Errors_val_ParameterType_0_1,
        _AbandonArgument_unsigned,
        __AbandonArgument_signed_toBeSigned,
        ____AbandonArgument_signed_algorithmIdentifier_algorithm_tab,
        ___AbandonArgument_signed_algorithmIdentifier_algorithm,
        ____AbandonArgument_signed_algorithmIdentifier_parameters_tab,
        ___AbandonArgument_signed_algorithmIdentifier_parameters,
        __AbandonArgument_signed_algorithmIdentifier,
        __AbandonArgument_signed_signature,
        _AbandonArgument_signed,
        AbandonArgument,
        _AbandonArgumentData_invokeID,
        AbandonArgumentData,
        _AbandonResult_null,
        __AbandonResult_information_unsigned,
        ___AbandonResult_information_signed_toBeSigned,
        _____AbandonResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____AbandonResult_information_signed_algorithmIdentifier_algorithm,
        _____AbandonResult_information_signed_algorithmIdentifier_parameters_tab,
        ____AbandonResult_information_signed_algorithmIdentifier_parameters,
        ___AbandonResult_information_signed_algorithmIdentifier,
        ___AbandonResult_information_signed_signature,
        __AbandonResult_information_signed,
        _AbandonResult_information,
        AbandonResult,
        _AbandonResultData_invokeID,
        _AbandonResultData_securityParameters,
        _AbandonResultData_performer,
        _AbandonResultData_aliasDereferenced,
        ____AbandonResultData_notification__item__type_tab,
        _____AbandonResultData_notification__item__type_tab_val_Type_0,
        _____AbandonResultData_notification__item__type_tab_val_Type_1,
        ___AbandonResultData_notification__item__type,
        ____AbandonResultData_notification__item__values__item_,
        ___AbandonResultData_notification__item__values,
        _____AbandonResultData_notification__item__valuesWithContext__item__value,
        ______AbandonResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____AbandonResultData_notification__item__valuesWithContext__item__contextList,
        ____AbandonResultData_notification__item__valuesWithContext__item_,
        ___AbandonResultData_notification__item__valuesWithContext,
        __AbandonResultData_notification__item_,
        _AbandonResultData_notification,
        AbandonResultData,
        list,
        _list_val_ArgumentType,
        _list_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_2_signed,
        __OPERATION_Errors_val_ParameterType_0_2,
        ___OPERATION_Errors_val_ParameterType_1_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_0_signed,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_Errors_val_ParameterType_2_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_0_signed,
        __OPERATION_Errors_val_ParameterType_2_0,
        ___OPERATION_Errors_val_ParameterType_3_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_0_signed,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_Errors_val_ParameterType_4_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_0_signed,
        __OPERATION_Errors_val_ParameterType_4_0,
        _ListArgument_unsigned,
        __ListArgument_signed_toBeSigned,
        ____ListArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ListArgument_signed_algorithmIdentifier_algorithm,
        ____ListArgument_signed_algorithmIdentifier_parameters_tab,
        ___ListArgument_signed_algorithmIdentifier_parameters,
        __ListArgument_signed_algorithmIdentifier,
        __ListArgument_signed_signature,
        _ListArgument_signed,
        ListArgument,
        _ListArgumentData_object,
        _ListArgumentData_pagedResults,
        _ListArgumentData_listFamily,
        _ListArgumentData_serviceControls,
        _ListArgumentData_securityParameters,
        _ListArgumentData_requestor,
        _ListArgumentData_operationProgress,
        _ListArgumentData_aliasedRDNs,
        _ListArgumentData_criticalExtensions,
        _ListArgumentData_referenceType,
        _ListArgumentData_entryOnly,
        _ListArgumentData_exclusions,
        _ListArgumentData_nameResolveOnMaster,
        _ListArgumentData_operationContexts,
        _ListArgumentData_familyGrouping,
        ListArgumentData,
        _ListResult_unsigned,
        __ListResult_signed_toBeSigned,
        ____ListResult_signed_algorithmIdentifier_algorithm_tab,
        ___ListResult_signed_algorithmIdentifier_algorithm,
        ____ListResult_signed_algorithmIdentifier_parameters_tab,
        ___ListResult_signed_algorithmIdentifier_parameters,
        __ListResult_signed_algorithmIdentifier,
        __ListResult_signed_signature,
        _ListResult_signed,
        ListResult,
        __ListResultData_listInfo_name,
        ____ListResultData_listInfo_subordinates__item__rdn,
        ____ListResultData_listInfo_subordinates__item__aliasEntry,
        ____ListResultData_listInfo_subordinates__item__fromEntry,
        ___ListResultData_listInfo_subordinates__item_,
        __ListResultData_listInfo_subordinates,
        __ListResultData_listInfo_partialOutcomeQualifier,
        __ListResultData_listInfo_securityParameters,
        __ListResultData_listInfo_performer,
        __ListResultData_listInfo_aliasDereferenced,
        _____ListResultData_listInfo_notification__item__type_tab,
        ______ListResultData_listInfo_notification__item__type_tab_val_Type_0,
        ______ListResultData_listInfo_notification__item__type_tab_val_Type_1,
        ____ListResultData_listInfo_notification__item__type,
        _____ListResultData_listInfo_notification__item__values__item_,
        ____ListResultData_listInfo_notification__item__values,
        ______ListResultData_listInfo_notification__item__valuesWithContext__item__value,
        _______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList__item_,
        ______ListResultData_listInfo_notification__item__valuesWithContext__item__contextList,
        _____ListResultData_listInfo_notification__item__valuesWithContext__item_,
        ____ListResultData_listInfo_notification__item__valuesWithContext,
        ___ListResultData_listInfo_notification__item_,
        __ListResultData_listInfo_notification,
        _ListResultData_listInfo,
        __ListResultData_uncorrelatedListInfo__item_,
        _ListResultData_uncorrelatedListInfo,
        ListResultData,
        _PartialOutcomeQualifier_limitProblem,
        __PartialOutcomeQualifier_unexplored__item_,
        _PartialOutcomeQualifier_unexplored,
        _PartialOutcomeQualifier_unavailableCriticalExtensions,
        __PartialOutcomeQualifier_unknownErrors__item_,
        _PartialOutcomeQualifier_unknownErrors,
        _PartialOutcomeQualifier_queryReference,
        _PartialOutcomeQualifier_overspecFilter,
        ____PartialOutcomeQualifier_notification__item__type_tab,
        _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_0,
        _____PartialOutcomeQualifier_notification__item__type_tab_val_Type_1,
        ___PartialOutcomeQualifier_notification__item__type,
        ____PartialOutcomeQualifier_notification__item__values__item_,
        ___PartialOutcomeQualifier_notification__item__values,
        _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__value,
        ______PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList__item_,
        _____PartialOutcomeQualifier_notification__item__valuesWithContext__item__contextList,
        ____PartialOutcomeQualifier_notification__item__valuesWithContext__item_,
        ___PartialOutcomeQualifier_notification__item__valuesWithContext,
        __PartialOutcomeQualifier_notification__item_,
        _PartialOutcomeQualifier_notification,
        __PartialOutcomeQualifier_entryCount_bestEstimate,
        __PartialOutcomeQualifier_entryCount_lowEstimate,
        __PartialOutcomeQualifier_entryCount_exact,
        _PartialOutcomeQualifier_entryCount,
        PartialOutcomeQualifier,
        LimitProblem,
        search,
        _search_val_ArgumentType,
        _search_val_ResultType,
        _SearchArgument_unsigned,
        __SearchArgument_signed_toBeSigned,
        ____SearchArgument_signed_algorithmIdentifier_algorithm_tab,
        ___SearchArgument_signed_algorithmIdentifier_algorithm,
        ____SearchArgument_signed_algorithmIdentifier_parameters_tab,
        ___SearchArgument_signed_algorithmIdentifier_parameters,
        __SearchArgument_signed_algorithmIdentifier,
        __SearchArgument_signed_signature,
        _SearchArgument_signed,
        SearchArgument,
        _SearchArgumentData_baseObject,
        _SearchArgumentData_subset,
        _SearchArgumentData_filter,
        _SearchArgumentData_searchAliases,
        _SearchArgumentData_selection,
        _SearchArgumentData_pagedResults,
        _SearchArgumentData_matchedValuesOnly,
        _SearchArgumentData_extendedFilter,
        _SearchArgumentData_checkOverspecified,
        _SearchArgumentData_relaxation,
        _SearchArgumentData_extendedArea,
        _SearchArgumentData_hierarchySelections,
        _SearchArgumentData_searchControlOptions,
        __SearchArgumentData_joinArguments__item_,
        _SearchArgumentData_joinArguments,
        _SearchArgumentData_joinType,
        _SearchArgumentData_serviceControls,
        _SearchArgumentData_securityParameters,
        _SearchArgumentData_requestor,
        _SearchArgumentData_operationProgress,
        _SearchArgumentData_aliasedRDNs,
        _SearchArgumentData_criticalExtensions,
        _SearchArgumentData_referenceType,
        _SearchArgumentData_entryOnly,
        _SearchArgumentData_exclusions,
        _SearchArgumentData_nameResolveOnMaster,
        _SearchArgumentData_operationContexts,
        _SearchArgumentData_familyGrouping,
        SearchArgumentData,
        HierarchySelections,
        SearchControlOptions,
        _JoinArgument_joinBaseObject,
        _JoinArgument_domainLocalID,
        _JoinArgument_joinSubset,
        _JoinArgument_joinFilter,
        __JoinArgument_joinAttributes__item_,
        _JoinArgument_joinAttributes,
        _JoinArgument_joinSelection,
        JoinArgument,
        DomainLocalID,
        _JoinAttPair_baseAtt,
        _JoinAttPair_joinAtt,
        __JoinAttPair_joinContext__item_,
        _JoinAttPair_joinContext,
        JoinAttPair,
        _JoinContextType_tab,
        JoinContextType,
        _SearchResult_unsigned,
        __SearchResult_signed_toBeSigned,
        ____SearchResult_signed_algorithmIdentifier_algorithm_tab,
        ___SearchResult_signed_algorithmIdentifier_algorithm,
        ____SearchResult_signed_algorithmIdentifier_parameters_tab,
        ___SearchResult_signed_algorithmIdentifier_parameters,
        __SearchResult_signed_algorithmIdentifier,
        __SearchResult_signed_signature,
        _SearchResult_signed,
        SearchResult,
        __SearchResultData_searchInfo_name,
        ___SearchResultData_searchInfo_entries__item_,
        __SearchResultData_searchInfo_entries,
        __SearchResultData_searchInfo_partialOutcomeQualifier,
        __SearchResultData_searchInfo_altMatching,
        __SearchResultData_searchInfo_securityParameters,
        __SearchResultData_searchInfo_performer,
        __SearchResultData_searchInfo_aliasDereferenced,
        _____SearchResultData_searchInfo_notification__item__type_tab,
        ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_0,
        ______SearchResultData_searchInfo_notification__item__type_tab_val_Type_1,
        ____SearchResultData_searchInfo_notification__item__type,
        _____SearchResultData_searchInfo_notification__item__values__item_,
        ____SearchResultData_searchInfo_notification__item__values,
        ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__value,
        _______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList__item_,
        ______SearchResultData_searchInfo_notification__item__valuesWithContext__item__contextList,
        _____SearchResultData_searchInfo_notification__item__valuesWithContext__item_,
        ____SearchResultData_searchInfo_notification__item__valuesWithContext,
        ___SearchResultData_searchInfo_notification__item_,
        __SearchResultData_searchInfo_notification,
        _SearchResultData_searchInfo,
        __SearchResultData_uncorrelatedSearchInfo__item_,
        _SearchResultData_uncorrelatedSearchInfo,
        SearchResultData,
        addEntry,
        _addEntry_val_ArgumentType,
        _addEntry_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_5_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_0_signed,
        __OPERATION_Errors_val_ParameterType_5_0,
        _AddEntryArgument_unsigned,
        __AddEntryArgument_signed_toBeSigned,
        ____AddEntryArgument_signed_algorithmIdentifier_algorithm_tab,
        ___AddEntryArgument_signed_algorithmIdentifier_algorithm,
        ____AddEntryArgument_signed_algorithmIdentifier_parameters_tab,
        ___AddEntryArgument_signed_algorithmIdentifier_parameters,
        __AddEntryArgument_signed_algorithmIdentifier,
        __AddEntryArgument_signed_signature,
        _AddEntryArgument_signed,
        AddEntryArgument,
        _AddEntryArgumentData_object,
        ____AddEntryArgumentData_entry__item__type_tab,
        _____AddEntryArgumentData_entry__item__type_tab_val_Type_0,
        _____AddEntryArgumentData_entry__item__type_tab_val_Type_1,
        ___AddEntryArgumentData_entry__item__type,
        ____AddEntryArgumentData_entry__item__values__item_,
        ___AddEntryArgumentData_entry__item__values,
        _____AddEntryArgumentData_entry__item__valuesWithContext__item__value,
        ______AddEntryArgumentData_entry__item__valuesWithContext__item__contextList__item_,
        _____AddEntryArgumentData_entry__item__valuesWithContext__item__contextList,
        ____AddEntryArgumentData_entry__item__valuesWithContext__item_,
        ___AddEntryArgumentData_entry__item__valuesWithContext,
        __AddEntryArgumentData_entry__item_,
        _AddEntryArgumentData_entry,
        _AddEntryArgumentData_targetSystem,
        _AddEntryArgumentData_serviceControls,
        _AddEntryArgumentData_securityParameters,
        _AddEntryArgumentData_requestor,
        _AddEntryArgumentData_operationProgress,
        _AddEntryArgumentData_aliasedRDNs,
        _AddEntryArgumentData_criticalExtensions,
        _AddEntryArgumentData_referenceType,
        _AddEntryArgumentData_entryOnly,
        _AddEntryArgumentData_exclusions,
        _AddEntryArgumentData_nameResolveOnMaster,
        _AddEntryArgumentData_operationContexts,
        _AddEntryArgumentData_familyGrouping,
        AddEntryArgumentData,
        _AddEntryResult_null,
        __AddEntryResult_information_unsigned,
        ___AddEntryResult_information_signed_toBeSigned,
        _____AddEntryResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____AddEntryResult_information_signed_algorithmIdentifier_algorithm,
        _____AddEntryResult_information_signed_algorithmIdentifier_parameters_tab,
        ____AddEntryResult_information_signed_algorithmIdentifier_parameters,
        ___AddEntryResult_information_signed_algorithmIdentifier,
        ___AddEntryResult_information_signed_signature,
        __AddEntryResult_information_signed,
        _AddEntryResult_information,
        AddEntryResult,
        _AddEntryResultData_securityParameters,
        _AddEntryResultData_performer,
        _AddEntryResultData_aliasDereferenced,
        ____AddEntryResultData_notification__item__type_tab,
        _____AddEntryResultData_notification__item__type_tab_val_Type_0,
        _____AddEntryResultData_notification__item__type_tab_val_Type_1,
        ___AddEntryResultData_notification__item__type,
        ____AddEntryResultData_notification__item__values__item_,
        ___AddEntryResultData_notification__item__values,
        _____AddEntryResultData_notification__item__valuesWithContext__item__value,
        ______AddEntryResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____AddEntryResultData_notification__item__valuesWithContext__item__contextList,
        ____AddEntryResultData_notification__item__valuesWithContext__item_,
        ___AddEntryResultData_notification__item__valuesWithContext,
        __AddEntryResultData_notification__item_,
        _AddEntryResultData_notification,
        AddEntryResultData,
        removeEntry,
        _removeEntry_val_ArgumentType,
        _removeEntry_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_3_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_1_signed,
        __OPERATION_Errors_val_ParameterType_3_1,
        ___OPERATION_Errors_val_ParameterType_4_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_1_signed,
        __OPERATION_Errors_val_ParameterType_4_1,
        _RemoveEntryArgument_unsigned,
        __RemoveEntryArgument_signed_toBeSigned,
        ____RemoveEntryArgument_signed_algorithmIdentifier_algorithm_tab,
        ___RemoveEntryArgument_signed_algorithmIdentifier_algorithm,
        ____RemoveEntryArgument_signed_algorithmIdentifier_parameters_tab,
        ___RemoveEntryArgument_signed_algorithmIdentifier_parameters,
        __RemoveEntryArgument_signed_algorithmIdentifier,
        __RemoveEntryArgument_signed_signature,
        _RemoveEntryArgument_signed,
        RemoveEntryArgument,
        _RemoveEntryArgumentData_object,
        _RemoveEntryArgumentData_serviceControls,
        _RemoveEntryArgumentData_securityParameters,
        _RemoveEntryArgumentData_requestor,
        _RemoveEntryArgumentData_operationProgress,
        _RemoveEntryArgumentData_aliasedRDNs,
        _RemoveEntryArgumentData_criticalExtensions,
        _RemoveEntryArgumentData_referenceType,
        _RemoveEntryArgumentData_entryOnly,
        _RemoveEntryArgumentData_exclusions,
        _RemoveEntryArgumentData_nameResolveOnMaster,
        _RemoveEntryArgumentData_operationContexts,
        _RemoveEntryArgumentData_familyGrouping,
        RemoveEntryArgumentData,
        _RemoveEntryResult_null,
        __RemoveEntryResult_information_unsigned,
        ___RemoveEntryResult_information_signed_toBeSigned,
        _____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____RemoveEntryResult_information_signed_algorithmIdentifier_algorithm,
        _____RemoveEntryResult_information_signed_algorithmIdentifier_parameters_tab,
        ____RemoveEntryResult_information_signed_algorithmIdentifier_parameters,
        ___RemoveEntryResult_information_signed_algorithmIdentifier,
        ___RemoveEntryResult_information_signed_signature,
        __RemoveEntryResult_information_signed,
        _RemoveEntryResult_information,
        RemoveEntryResult,
        _RemoveEntryResultData_securityParameters,
        _RemoveEntryResultData_performer,
        _RemoveEntryResultData_aliasDereferenced,
        ____RemoveEntryResultData_notification__item__type_tab,
        _____RemoveEntryResultData_notification__item__type_tab_val_Type_0,
        _____RemoveEntryResultData_notification__item__type_tab_val_Type_1,
        ___RemoveEntryResultData_notification__item__type,
        ____RemoveEntryResultData_notification__item__values__item_,
        ___RemoveEntryResultData_notification__item__values,
        _____RemoveEntryResultData_notification__item__valuesWithContext__item__value,
        ______RemoveEntryResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____RemoveEntryResultData_notification__item__valuesWithContext__item__contextList,
        ____RemoveEntryResultData_notification__item__valuesWithContext__item_,
        ___RemoveEntryResultData_notification__item__valuesWithContext,
        __RemoveEntryResultData_notification__item_,
        _RemoveEntryResultData_notification,
        RemoveEntryResultData,
        modifyEntry,
        _modifyEntry_val_ArgumentType,
        _modifyEntry_val_ResultType,
        _ModifyEntryArgument_unsigned,
        __ModifyEntryArgument_signed_toBeSigned,
        ____ModifyEntryArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ModifyEntryArgument_signed_algorithmIdentifier_algorithm,
        ____ModifyEntryArgument_signed_algorithmIdentifier_parameters_tab,
        ___ModifyEntryArgument_signed_algorithmIdentifier_parameters,
        __ModifyEntryArgument_signed_algorithmIdentifier,
        __ModifyEntryArgument_signed_signature,
        _ModifyEntryArgument_signed,
        ModifyEntryArgument,
        _ModifyEntryArgumentData_object,
        __ModifyEntryArgumentData_changes__item_,
        _ModifyEntryArgumentData_changes,
        _ModifyEntryArgumentData_selection,
        _ModifyEntryArgumentData_serviceControls,
        _ModifyEntryArgumentData_securityParameters,
        _ModifyEntryArgumentData_requestor,
        _ModifyEntryArgumentData_operationProgress,
        _ModifyEntryArgumentData_aliasedRDNs,
        _ModifyEntryArgumentData_criticalExtensions,
        _ModifyEntryArgumentData_referenceType,
        _ModifyEntryArgumentData_entryOnly,
        _ModifyEntryArgumentData_exclusions,
        _ModifyEntryArgumentData_nameResolveOnMaster,
        _ModifyEntryArgumentData_operationContexts,
        _ModifyEntryArgumentData_familyGrouping,
        ModifyEntryArgumentData,
        _ModifyEntryResult_null,
        __ModifyEntryResult_information_unsigned,
        ___ModifyEntryResult_information_signed_toBeSigned,
        _____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____ModifyEntryResult_information_signed_algorithmIdentifier_algorithm,
        _____ModifyEntryResult_information_signed_algorithmIdentifier_parameters_tab,
        ____ModifyEntryResult_information_signed_algorithmIdentifier_parameters,
        ___ModifyEntryResult_information_signed_algorithmIdentifier,
        ___ModifyEntryResult_information_signed_signature,
        __ModifyEntryResult_information_signed,
        _ModifyEntryResult_information,
        ModifyEntryResult,
        _ModifyEntryResultData_entry,
        _ModifyEntryResultData_securityParameters,
        _ModifyEntryResultData_performer,
        _ModifyEntryResultData_aliasDereferenced,
        ____ModifyEntryResultData_notification__item__type_tab,
        _____ModifyEntryResultData_notification__item__type_tab_val_Type_0,
        _____ModifyEntryResultData_notification__item__type_tab_val_Type_1,
        ___ModifyEntryResultData_notification__item__type,
        ____ModifyEntryResultData_notification__item__values__item_,
        ___ModifyEntryResultData_notification__item__values,
        _____ModifyEntryResultData_notification__item__valuesWithContext__item__value,
        ______ModifyEntryResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____ModifyEntryResultData_notification__item__valuesWithContext__item__contextList,
        ____ModifyEntryResultData_notification__item__valuesWithContext__item_,
        ___ModifyEntryResultData_notification__item__valuesWithContext,
        __ModifyEntryResultData_notification__item_,
        _ModifyEntryResultData_notification,
        ModifyEntryResultData,
        ___EntryModification_addAttribute_type_tab,
        ____EntryModification_addAttribute_type_tab_val_Type_0,
        ____EntryModification_addAttribute_type_tab_val_Type_1,
        __EntryModification_addAttribute_type,
        ___EntryModification_addAttribute_values__item_,
        __EntryModification_addAttribute_values,
        ____EntryModification_addAttribute_valuesWithContext__item__value,
        _____EntryModification_addAttribute_valuesWithContext__item__contextList__item_,
        ____EntryModification_addAttribute_valuesWithContext__item__contextList,
        ___EntryModification_addAttribute_valuesWithContext__item_,
        __EntryModification_addAttribute_valuesWithContext,
        _EntryModification_addAttribute,
        _EntryModification_removeAttribute,
        __EntryModification_addValues_type,
        ___EntryModification_addValues_values__item_,
        __EntryModification_addValues_values,
        ____EntryModification_addValues_valuesWithContext__item__value,
        _____EntryModification_addValues_valuesWithContext__item__contextList__item_,
        ____EntryModification_addValues_valuesWithContext__item__contextList,
        ___EntryModification_addValues_valuesWithContext__item_,
        __EntryModification_addValues_valuesWithContext,
        _EntryModification_addValues,
        __EntryModification_removeValues_type,
        ___EntryModification_removeValues_values__item_,
        __EntryModification_removeValues_values,
        ____EntryModification_removeValues_valuesWithContext__item__value,
        _____EntryModification_removeValues_valuesWithContext__item__contextList__item_,
        ____EntryModification_removeValues_valuesWithContext__item__contextList,
        ___EntryModification_removeValues_valuesWithContext__item_,
        __EntryModification_removeValues_valuesWithContext,
        _EntryModification_removeValues,
        _EntryModification_alterValues,
        _EntryModification_resetValue,
        __EntryModification_replaceValues_type,
        ___EntryModification_replaceValues_values__item_,
        __EntryModification_replaceValues_values,
        ____EntryModification_replaceValues_valuesWithContext__item__value,
        _____EntryModification_replaceValues_valuesWithContext__item__contextList__item_,
        ____EntryModification_replaceValues_valuesWithContext__item__contextList,
        ___EntryModification_replaceValues_valuesWithContext__item_,
        __EntryModification_replaceValues_valuesWithContext,
        _EntryModification_replaceValues,
        EntryModification,
        modifyDN,
        _modifyDN_val_ArgumentType,
        _modifyDN_val_ResultType,
        _ModifyDNArgument_unsigned,
        __ModifyDNArgument_signed_toBeSigned,
        ____ModifyDNArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ModifyDNArgument_signed_algorithmIdentifier_algorithm,
        ____ModifyDNArgument_signed_algorithmIdentifier_parameters_tab,
        ___ModifyDNArgument_signed_algorithmIdentifier_parameters,
        __ModifyDNArgument_signed_algorithmIdentifier,
        __ModifyDNArgument_signed_signature,
        _ModifyDNArgument_signed,
        ModifyDNArgument,
        _ModifyDNArgumentData_object,
        _ModifyDNArgumentData_newRDN,
        _ModifyDNArgumentData_deleteOldRDN,
        _ModifyDNArgumentData_newSuperior,
        _ModifyDNArgumentData_serviceControls,
        _ModifyDNArgumentData_securityParameters,
        _ModifyDNArgumentData_requestor,
        _ModifyDNArgumentData_operationProgress,
        _ModifyDNArgumentData_aliasedRDNs,
        _ModifyDNArgumentData_criticalExtensions,
        _ModifyDNArgumentData_referenceType,
        _ModifyDNArgumentData_entryOnly,
        _ModifyDNArgumentData_exclusions,
        _ModifyDNArgumentData_nameResolveOnMaster,
        _ModifyDNArgumentData_operationContexts,
        _ModifyDNArgumentData_familyGrouping,
        ModifyDNArgumentData,
        _ModifyDNResult_null,
        __ModifyDNResult_information_unsigned,
        ___ModifyDNResult_information_signed_toBeSigned,
        _____ModifyDNResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____ModifyDNResult_information_signed_algorithmIdentifier_algorithm,
        _____ModifyDNResult_information_signed_algorithmIdentifier_parameters_tab,
        ____ModifyDNResult_information_signed_algorithmIdentifier_parameters,
        ___ModifyDNResult_information_signed_algorithmIdentifier,
        ___ModifyDNResult_information_signed_signature,
        __ModifyDNResult_information_signed,
        _ModifyDNResult_information,
        ModifyDNResult,
        _ModifyDNResultData_newRDN,
        _ModifyDNResultData_securityParameters,
        _ModifyDNResultData_performer,
        _ModifyDNResultData_aliasDereferenced,
        ____ModifyDNResultData_notification__item__type_tab,
        _____ModifyDNResultData_notification__item__type_tab_val_Type_0,
        _____ModifyDNResultData_notification__item__type_tab_val_Type_1,
        ___ModifyDNResultData_notification__item__type,
        ____ModifyDNResultData_notification__item__values__item_,
        ___ModifyDNResultData_notification__item__values,
        _____ModifyDNResultData_notification__item__valuesWithContext__item__value,
        ______ModifyDNResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____ModifyDNResultData_notification__item__valuesWithContext__item__contextList,
        ____ModifyDNResultData_notification__item__valuesWithContext__item_,
        ___ModifyDNResultData_notification__item__valuesWithContext,
        __ModifyDNResultData_notification__item_,
        _ModifyDNResultData_notification,
        ModifyDNResultData,
        changePassword,
        _changePassword_val_ArgumentType,
        _changePassword_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_3_signed,
        __OPERATION_Errors_val_ParameterType_0_3,
        ___OPERATION_Errors_val_ParameterType_1_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_1_signed,
        __OPERATION_Errors_val_ParameterType_1_1,
        _ChangePasswordArgument_unsigned,
        __ChangePasswordArgument_signed_toBeSigned,
        ____ChangePasswordArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ChangePasswordArgument_signed_algorithmIdentifier_algorithm,
        ____ChangePasswordArgument_signed_algorithmIdentifier_parameters_tab,
        ___ChangePasswordArgument_signed_algorithmIdentifier_parameters,
        __ChangePasswordArgument_signed_algorithmIdentifier,
        __ChangePasswordArgument_signed_signature,
        _ChangePasswordArgument_signed,
        ChangePasswordArgument,
        _ChangePasswordArgumentData_object,
        _ChangePasswordArgumentData_oldPwd,
        _ChangePasswordArgumentData_newPwd,
        ChangePasswordArgumentData,
        _ChangePasswordResult_null,
        __ChangePasswordResult_information_unsigned,
        ___ChangePasswordResult_information_signed_toBeSigned,
        _____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____ChangePasswordResult_information_signed_algorithmIdentifier_algorithm,
        _____ChangePasswordResult_information_signed_algorithmIdentifier_parameters_tab,
        ____ChangePasswordResult_information_signed_algorithmIdentifier_parameters,
        ___ChangePasswordResult_information_signed_algorithmIdentifier,
        ___ChangePasswordResult_information_signed_signature,
        __ChangePasswordResult_information_signed,
        _ChangePasswordResult_information,
        ChangePasswordResult,
        _ChangePasswordResultData_securityParameters,
        _ChangePasswordResultData_performer,
        _ChangePasswordResultData_aliasDereferenced,
        ____ChangePasswordResultData_notification__item__type_tab,
        _____ChangePasswordResultData_notification__item__type_tab_val_Type_0,
        _____ChangePasswordResultData_notification__item__type_tab_val_Type_1,
        ___ChangePasswordResultData_notification__item__type,
        ____ChangePasswordResultData_notification__item__values__item_,
        ___ChangePasswordResultData_notification__item__values,
        _____ChangePasswordResultData_notification__item__valuesWithContext__item__value,
        ______ChangePasswordResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____ChangePasswordResultData_notification__item__valuesWithContext__item__contextList,
        ____ChangePasswordResultData_notification__item__valuesWithContext__item_,
        ___ChangePasswordResultData_notification__item__valuesWithContext,
        __ChangePasswordResultData_notification__item_,
        _ChangePasswordResultData_notification,
        ChangePasswordResultData,
        administerPassword,
        _administerPassword_val_ArgumentType,
        _administerPassword_val_ResultType,
        _AdministerPasswordArgument_unsigned,
        __AdministerPasswordArgument_signed_toBeSigned,
        ____AdministerPasswordArgument_signed_algorithmIdentifier_algorithm_tab,
        ___AdministerPasswordArgument_signed_algorithmIdentifier_algorithm,
        ____AdministerPasswordArgument_signed_algorithmIdentifier_parameters_tab,
        ___AdministerPasswordArgument_signed_algorithmIdentifier_parameters,
        __AdministerPasswordArgument_signed_algorithmIdentifier,
        __AdministerPasswordArgument_signed_signature,
        _AdministerPasswordArgument_signed,
        AdministerPasswordArgument,
        _AdministerPasswordArgumentData_object,
        _AdministerPasswordArgumentData_newPwd,
        AdministerPasswordArgumentData,
        _AdministerPasswordResult_null,
        __AdministerPasswordResult_information_unsigned,
        ___AdministerPasswordResult_information_signed_toBeSigned,
        _____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____AdministerPasswordResult_information_signed_algorithmIdentifier_algorithm,
        _____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters_tab,
        ____AdministerPasswordResult_information_signed_algorithmIdentifier_parameters,
        ___AdministerPasswordResult_information_signed_algorithmIdentifier,
        ___AdministerPasswordResult_information_signed_signature,
        __AdministerPasswordResult_information_signed,
        _AdministerPasswordResult_information,
        AdministerPasswordResult,
        _AdministerPasswordResultData_securityParameters,
        _AdministerPasswordResultData_performer,
        _AdministerPasswordResultData_aliasDereferenced,
        ____AdministerPasswordResultData_notification__item__type_tab,
        _____AdministerPasswordResultData_notification__item__type_tab_val_Type_0,
        _____AdministerPasswordResultData_notification__item__type_tab_val_Type_1,
        ___AdministerPasswordResultData_notification__item__type,
        ____AdministerPasswordResultData_notification__item__values__item_,
        ___AdministerPasswordResultData_notification__item__values,
        _____AdministerPasswordResultData_notification__item__valuesWithContext__item__value,
        ______AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____AdministerPasswordResultData_notification__item__valuesWithContext__item__contextList,
        ____AdministerPasswordResultData_notification__item__valuesWithContext__item_,
        ___AdministerPasswordResultData_notification__item__valuesWithContext,
        __AdministerPasswordResultData_notification__item_,
        _AdministerPasswordResultData_notification,
        AdministerPasswordResultData,
        ldapTransport,
        _ldapTransport_val_ArgumentType,
        __ldapTransport_val_ResultType__item_,
        _ldapTransport_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_1_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_2_signed,
        __OPERATION_Errors_val_ParameterType_1_2,
        _LdapArgument_unsigned,
        __LdapArgument_signed_toBeSigned,
        ____LdapArgument_signed_algorithmIdentifier_algorithm_tab,
        ___LdapArgument_signed_algorithmIdentifier_algorithm,
        ____LdapArgument_signed_algorithmIdentifier_parameters_tab,
        ___LdapArgument_signed_algorithmIdentifier_parameters,
        __LdapArgument_signed_algorithmIdentifier,
        __LdapArgument_signed_signature,
        _LdapArgument_signed,
        LdapArgument,
        _LdapArgumentData_object,
        _LdapArgumentData_ldapMessage,
        _LdapArgumentData_linkId,
        _LdapArgumentData_serviceControls,
        _LdapArgumentData_securityParameters,
        _LdapArgumentData_requestor,
        _LdapArgumentData_operationProgress,
        _LdapArgumentData_aliasedRDNs,
        _LdapArgumentData_criticalExtensions,
        _LdapArgumentData_referenceType,
        _LdapArgumentData_entryOnly,
        _LdapArgumentData_exclusions,
        _LdapArgumentData_nameResolveOnMaster,
        _LdapArgumentData_operationContexts,
        _LdapArgumentData_familyGrouping,
        LdapArgumentData,
        LinkId,
        _LdapResult_unsigned,
        __LdapResult_signed_toBeSigned,
        ____LdapResult_signed_algorithmIdentifier_algorithm_tab,
        ___LdapResult_signed_algorithmIdentifier_algorithm,
        ____LdapResult_signed_algorithmIdentifier_parameters_tab,
        ___LdapResult_signed_algorithmIdentifier_parameters,
        __LdapResult_signed_algorithmIdentifier,
        __LdapResult_signed_signature,
        _LdapResult_signed,
        LdapResult,
        __LdapResultData_ldapMessages__item_,
        _LdapResultData_ldapMessages,
        _LdapResultData_returnToClient,
        _LdapResultData_securityParameters,
        _LdapResultData_performer,
        _LdapResultData_aliasDereferenced,
        ____LdapResultData_notification__item__type_tab,
        _____LdapResultData_notification__item__type_tab_val_Type_0,
        _____LdapResultData_notification__item__type_tab_val_Type_1,
        ___LdapResultData_notification__item__type,
        ____LdapResultData_notification__item__values__item_,
        ___LdapResultData_notification__item__values,
        _____LdapResultData_notification__item__valuesWithContext__item__value,
        ______LdapResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____LdapResultData_notification__item__valuesWithContext__item__contextList,
        ____LdapResultData_notification__item__valuesWithContext__item_,
        ___LdapResultData_notification__item__valuesWithContext,
        __LdapResultData_notification__item_,
        _LdapResultData_notification,
        LdapResultData,
        linkedLDAP,
        _linkedLDAP_val_ArgumentType,
        _linkedLDAP_val_ResultType,
        _LinkedArgument_unsigned,
        __LinkedArgument_signed_toBeSigned,
        ____LinkedArgument_signed_algorithmIdentifier_algorithm_tab,
        ___LinkedArgument_signed_algorithmIdentifier_algorithm,
        ____LinkedArgument_signed_algorithmIdentifier_parameters_tab,
        ___LinkedArgument_signed_algorithmIdentifier_parameters,
        __LinkedArgument_signed_algorithmIdentifier,
        __LinkedArgument_signed_signature,
        _LinkedArgument_signed,
        LinkedArgument,
        _LinkedArgumentData_object,
        _LinkedArgumentData_ldapMessage,
        _LinkedArgumentData_linkId,
        _LinkedArgumentData_returnToClient,
        _LinkedArgumentData_serviceControls,
        _LinkedArgumentData_securityParameters,
        _LinkedArgumentData_requestor,
        _LinkedArgumentData_operationProgress,
        _LinkedArgumentData_aliasedRDNs,
        _LinkedArgumentData_criticalExtensions,
        _LinkedArgumentData_referenceType,
        _LinkedArgumentData_entryOnly,
        _LinkedArgumentData_exclusions,
        _LinkedArgumentData_nameResolveOnMaster,
        _LinkedArgumentData_operationContexts,
        _LinkedArgumentData_familyGrouping,
        LinkedArgumentData,
        LinkedResult,
        abandoned,
        __abandoned_val_ParameterType_unsigned,
        ___abandoned_val_ParameterType_signed_toBeSigned,
        _____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____abandoned_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____abandoned_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___abandoned_val_ParameterType_signed_algorithmIdentifier,
        ___abandoned_val_ParameterType_signed_signature,
        __abandoned_val_ParameterType_signed,
        _abandoned_val_ParameterType,
        _AbandonedData_problem,
        _AbandonedData_securityParameters,
        _AbandonedData_performer,
        _AbandonedData_aliasDereferenced,
        ____AbandonedData_notification__item__type_tab,
        _____AbandonedData_notification__item__type_tab_val_Type_0,
        _____AbandonedData_notification__item__type_tab_val_Type_1,
        ___AbandonedData_notification__item__type,
        ____AbandonedData_notification__item__values__item_,
        ___AbandonedData_notification__item__values,
        _____AbandonedData_notification__item__valuesWithContext__item__value,
        ______AbandonedData_notification__item__valuesWithContext__item__contextList__item_,
        _____AbandonedData_notification__item__valuesWithContext__item__contextList,
        ____AbandonedData_notification__item__valuesWithContext__item_,
        ___AbandonedData_notification__item__valuesWithContext,
        __AbandonedData_notification__item_,
        _AbandonedData_notification,
        AbandonedData,
        AbandonedProblem,
        abandonFailed,
        __abandonFailed_val_ParameterType_unsigned,
        ___abandonFailed_val_ParameterType_signed_toBeSigned,
        _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____abandonFailed_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___abandonFailed_val_ParameterType_signed_algorithmIdentifier,
        ___abandonFailed_val_ParameterType_signed_signature,
        __abandonFailed_val_ParameterType_signed,
        _abandonFailed_val_ParameterType,
        _AbandonFailedData_problem,
        _AbandonFailedData_operation,
        _AbandonFailedData_securityParameters,
        _AbandonFailedData_performer,
        _AbandonFailedData_aliasDereferenced,
        ____AbandonFailedData_notification__item__type_tab,
        _____AbandonFailedData_notification__item__type_tab_val_Type_0,
        _____AbandonFailedData_notification__item__type_tab_val_Type_1,
        ___AbandonFailedData_notification__item__type,
        ____AbandonFailedData_notification__item__values__item_,
        ___AbandonFailedData_notification__item__values,
        _____AbandonFailedData_notification__item__valuesWithContext__item__value,
        ______AbandonFailedData_notification__item__valuesWithContext__item__contextList__item_,
        _____AbandonFailedData_notification__item__valuesWithContext__item__contextList,
        ____AbandonFailedData_notification__item__valuesWithContext__item_,
        ___AbandonFailedData_notification__item__valuesWithContext,
        __AbandonFailedData_notification__item_,
        _AbandonFailedData_notification,
        AbandonFailedData,
        AbandonProblem,
        attributeError,
        __attributeError_val_ParameterType_unsigned,
        ___attributeError_val_ParameterType_signed_toBeSigned,
        _____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____attributeError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____attributeError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___attributeError_val_ParameterType_signed_algorithmIdentifier,
        ___attributeError_val_ParameterType_signed_signature,
        __attributeError_val_ParameterType_signed,
        _attributeError_val_ParameterType,
        _AttributeErrorData_object,
        ___AttributeErrorData_problems__item__problem,
        ___AttributeErrorData_problems__item__type,
        ___AttributeErrorData_problems__item__value,
        __AttributeErrorData_problems__item_,
        _AttributeErrorData_problems,
        _AttributeErrorData_securityParameters,
        _AttributeErrorData_performer,
        _AttributeErrorData_aliasDereferenced,
        ____AttributeErrorData_notification__item__type_tab,
        _____AttributeErrorData_notification__item__type_tab_val_Type_0,
        _____AttributeErrorData_notification__item__type_tab_val_Type_1,
        ___AttributeErrorData_notification__item__type,
        ____AttributeErrorData_notification__item__values__item_,
        ___AttributeErrorData_notification__item__values,
        _____AttributeErrorData_notification__item__valuesWithContext__item__value,
        ______AttributeErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____AttributeErrorData_notification__item__valuesWithContext__item__contextList,
        ____AttributeErrorData_notification__item__valuesWithContext__item_,
        ___AttributeErrorData_notification__item__valuesWithContext,
        __AttributeErrorData_notification__item_,
        _AttributeErrorData_notification,
        AttributeErrorData,
        AttributeProblem,
        nameError,
        __nameError_val_ParameterType_unsigned,
        ___nameError_val_ParameterType_signed_toBeSigned,
        _____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____nameError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____nameError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____nameError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___nameError_val_ParameterType_signed_algorithmIdentifier,
        ___nameError_val_ParameterType_signed_signature,
        __nameError_val_ParameterType_signed,
        _nameError_val_ParameterType,
        _NameErrorData_problem,
        _NameErrorData_matched,
        _NameErrorData_securityParameters,
        _NameErrorData_performer,
        _NameErrorData_aliasDereferenced,
        ____NameErrorData_notification__item__type_tab,
        _____NameErrorData_notification__item__type_tab_val_Type_0,
        _____NameErrorData_notification__item__type_tab_val_Type_1,
        ___NameErrorData_notification__item__type,
        ____NameErrorData_notification__item__values__item_,
        ___NameErrorData_notification__item__values,
        _____NameErrorData_notification__item__valuesWithContext__item__value,
        ______NameErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____NameErrorData_notification__item__valuesWithContext__item__contextList,
        ____NameErrorData_notification__item__valuesWithContext__item_,
        ___NameErrorData_notification__item__valuesWithContext,
        __NameErrorData_notification__item_,
        _NameErrorData_notification,
        NameErrorData,
        NameProblem,
        referral,
        __referral_val_ParameterType_unsigned,
        ___referral_val_ParameterType_signed_toBeSigned,
        _____referral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____referral_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____referral_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____referral_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___referral_val_ParameterType_signed_algorithmIdentifier,
        ___referral_val_ParameterType_signed_signature,
        __referral_val_ParameterType_signed,
        _referral_val_ParameterType,
        _ReferralData_candidate,
        _ReferralData_securityParameters,
        _ReferralData_performer,
        _ReferralData_aliasDereferenced,
        ____ReferralData_notification__item__type_tab,
        _____ReferralData_notification__item__type_tab_val_Type_0,
        _____ReferralData_notification__item__type_tab_val_Type_1,
        ___ReferralData_notification__item__type,
        ____ReferralData_notification__item__values__item_,
        ___ReferralData_notification__item__values,
        _____ReferralData_notification__item__valuesWithContext__item__value,
        ______ReferralData_notification__item__valuesWithContext__item__contextList__item_,
        _____ReferralData_notification__item__valuesWithContext__item__contextList,
        ____ReferralData_notification__item__valuesWithContext__item_,
        ___ReferralData_notification__item__valuesWithContext,
        __ReferralData_notification__item_,
        _ReferralData_notification,
        ReferralData,
        securityError,
        __securityError_val_ParameterType_unsigned,
        ___securityError_val_ParameterType_signed_toBeSigned,
        _____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____securityError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____securityError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____securityError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___securityError_val_ParameterType_signed_algorithmIdentifier,
        ___securityError_val_ParameterType_signed_signature,
        __securityError_val_ParameterType_signed,
        _securityError_val_ParameterType,
        _SecurityErrorData_problem,
        _SecurityErrorData_spkmInfo,
        _SecurityErrorData_encPwdInfo,
        _SecurityErrorData_securityParameters,
        _SecurityErrorData_performer,
        _SecurityErrorData_aliasDereferenced,
        ____SecurityErrorData_notification__item__type_tab,
        _____SecurityErrorData_notification__item__type_tab_val_Type_0,
        _____SecurityErrorData_notification__item__type_tab_val_Type_1,
        ___SecurityErrorData_notification__item__type,
        ____SecurityErrorData_notification__item__values__item_,
        ___SecurityErrorData_notification__item__values,
        _____SecurityErrorData_notification__item__valuesWithContext__item__value,
        ______SecurityErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____SecurityErrorData_notification__item__valuesWithContext__item__contextList,
        ____SecurityErrorData_notification__item__valuesWithContext__item_,
        ___SecurityErrorData_notification__item__valuesWithContext,
        __SecurityErrorData_notification__item_,
        _SecurityErrorData_notification,
        SecurityErrorData,
        SecurityProblem,
        ____EncPwdInfo_algorithms__item__algorithm_tab,
        ___EncPwdInfo_algorithms__item__algorithm,
        ____EncPwdInfo_algorithms__item__parameters_tab,
        ___EncPwdInfo_algorithms__item__parameters,
        __EncPwdInfo_algorithms__item_,
        _EncPwdInfo_algorithms,
        __EncPwdInfo_pwdQualityRule__item_,
        _EncPwdInfo_pwdQualityRule,
        EncPwdInfo,
        serviceError,
        __serviceError_val_ParameterType_unsigned,
        ___serviceError_val_ParameterType_signed_toBeSigned,
        _____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____serviceError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____serviceError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___serviceError_val_ParameterType_signed_algorithmIdentifier,
        ___serviceError_val_ParameterType_signed_signature,
        __serviceError_val_ParameterType_signed,
        _serviceError_val_ParameterType,
        _ServiceErrorData_problem,
        _ServiceErrorData_securityParameters,
        _ServiceErrorData_performer,
        _ServiceErrorData_aliasDereferenced,
        ____ServiceErrorData_notification__item__type_tab,
        _____ServiceErrorData_notification__item__type_tab_val_Type_0,
        _____ServiceErrorData_notification__item__type_tab_val_Type_1,
        ___ServiceErrorData_notification__item__type,
        ____ServiceErrorData_notification__item__values__item_,
        ___ServiceErrorData_notification__item__values,
        _____ServiceErrorData_notification__item__valuesWithContext__item__value,
        ______ServiceErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____ServiceErrorData_notification__item__valuesWithContext__item__contextList,
        ____ServiceErrorData_notification__item__valuesWithContext__item_,
        ___ServiceErrorData_notification__item__valuesWithContext,
        __ServiceErrorData_notification__item_,
        _ServiceErrorData_notification,
        ServiceErrorData,
        ServiceProblem,
        updateError,
        __updateError_val_ParameterType_unsigned,
        ___updateError_val_ParameterType_signed_toBeSigned,
        _____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____updateError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____updateError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____updateError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___updateError_val_ParameterType_signed_algorithmIdentifier,
        ___updateError_val_ParameterType_signed_signature,
        __updateError_val_ParameterType_signed,
        _updateError_val_ParameterType,
        _UpdateErrorData_problem,
        ___UpdateErrorData_attributeInfo__item__attributeType,
        _____UpdateErrorData_attributeInfo__item__attribute_type_tab,
        ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_0,
        ______UpdateErrorData_attributeInfo__item__attribute_type_tab_val_Type_1,
        ____UpdateErrorData_attributeInfo__item__attribute_type,
        _____UpdateErrorData_attributeInfo__item__attribute_values__item_,
        ____UpdateErrorData_attributeInfo__item__attribute_values,
        ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__value,
        _______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList__item_,
        ______UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item__contextList,
        _____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext__item_,
        ____UpdateErrorData_attributeInfo__item__attribute_valuesWithContext,
        ___UpdateErrorData_attributeInfo__item__attribute,
        __UpdateErrorData_attributeInfo__item_,
        _UpdateErrorData_attributeInfo,
        _UpdateErrorData_securityParameters,
        _UpdateErrorData_performer,
        _UpdateErrorData_aliasDereferenced,
        ___UpdateErrorData_notification__item__type,
        ____UpdateErrorData_notification__item__values__item_,
        ___UpdateErrorData_notification__item__values,
        _____UpdateErrorData_notification__item__valuesWithContext__item__value,
        ______UpdateErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____UpdateErrorData_notification__item__valuesWithContext__item__contextList,
        ____UpdateErrorData_notification__item__valuesWithContext__item_,
        ___UpdateErrorData_notification__item__valuesWithContext,
        __UpdateErrorData_notification__item_,
        _UpdateErrorData_notification,
        UpdateErrorData,
        UpdateProblem,
        id_at_family_information,
    ]

class DirectoryOperationalBindingTypes:

    _name_  = u'DirectoryOperationalBindingTypes'
    _oid_   = [2, 5, 1, 25, 8]
    
    _obj_ = [
        u'id-op-binding-shadow',
        u'id-op-binding-hierarchical',
        u'id-op-binding-non-specific-hierarchical',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        u'id-op-binding-shadow',
        u'id-op-binding-hierarchical',
        u'id-op-binding-non-specific-hierarchical',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-op-binding-shadow >-----#
    id_op_binding_shadow = OID(name=u'id-op-binding-shadow', mode=MODE_VALUE)
    id_op_binding_shadow._val = (2, 5, 19, 1)
    
    #-----< id-op-binding-hierarchical >-----#
    id_op_binding_hierarchical = OID(name=u'id-op-binding-hierarchical', mode=MODE_VALUE)
    id_op_binding_hierarchical._val = (2, 5, 19, 2)
    
    #-----< id-op-binding-non-specific-hierarchical >-----#
    id_op_binding_non_specific_hierarchical = OID(name=u'id-op-binding-non-specific-hierarchical', mode=MODE_VALUE)
    id_op_binding_non_specific_hierarchical._val = (2, 5, 19, 3)
    
    _all_ = [
        id_op_binding_shadow,
        id_op_binding_hierarchical,
        id_op_binding_non_specific_hierarchical,
    ]

class DirectoryOSIProtocols:

    _name_  = u'DirectoryOSIProtocols'
    _oid_   = [2, 5, 1, 37, 8]
    
    _obj_ = [
        u'DAP-OSI-PDUs',
        u'DSP-OSI-PDUs',
        u'DOP-OSI-PDUs',
        u'ShadowSupplierInitiatedDISP-OSI-PDUs',
        u'ShadowSupplierInitiatedAsynchronousDISP-OSI-PDUs',
        u'ShadowConsumerInitiatedDISP-OSI-PDUs',
        u'ShadowConsumerInitiatedAsynchronousDISP-OSI-PDUs',
        u'APPLICATION-CONTEXT',
        u'directoryAccessAC',
        u'directorySystemAC',
        u'shadowSupplierInitiatedAC',
        u'shadowConsumerInitiatedAC',
        u'shadowSupplierInitiatedAsynchronousAC',
        u'shadowConsumerInitiatedAsynchronousAC',
        u'directoryOperationalBindingManagementAC',
        u'id-as-directoryAccessAS',
        u'id-as-directorySystemAS',
        u'id-as-directoryShadowAS',
        u'id-as-directoryOperationalBindingManagementAS',
        u'id-acseAS',
        u'id-ac-directoryAccessAC',
        u'id-ac-directorySystemAC',
        u'id-ac-directoryOperationalBindingManagementAC',
        u'id-ac-shadowConsumerInitiatedAC',
        u'id-ac-shadowSupplierInitiatedAC',
        u'id-ac-shadowSupplierInitiatedAsynchronousAC',
        u'id-ac-shadowConsumerInitiatedAsynchronousAC',
        ]
    _type_ = [
        u'DAP-OSI-PDUs',
        u'DSP-OSI-PDUs',
        u'DOP-OSI-PDUs',
        u'ShadowSupplierInitiatedDISP-OSI-PDUs',
        u'ShadowSupplierInitiatedAsynchronousDISP-OSI-PDUs',
        u'ShadowConsumerInitiatedDISP-OSI-PDUs',
        u'ShadowConsumerInitiatedAsynchronousDISP-OSI-PDUs',
        u'APPLICATION-CONTEXT',
        ]
    _set_ = [
        ]
    _val_ = [
        u'directoryAccessAC',
        u'directorySystemAC',
        u'shadowSupplierInitiatedAC',
        u'shadowConsumerInitiatedAC',
        u'shadowSupplierInitiatedAsynchronousAC',
        u'shadowConsumerInitiatedAsynchronousAC',
        u'directoryOperationalBindingManagementAC',
        u'id-as-directoryAccessAS',
        u'id-as-directorySystemAS',
        u'id-as-directoryShadowAS',
        u'id-as-directoryOperationalBindingManagementAS',
        u'id-acseAS',
        u'id-ac-directoryAccessAC',
        u'id-ac-directorySystemAC',
        u'id-ac-directoryOperationalBindingManagementAC',
        u'id-ac-shadowConsumerInitiatedAC',
        u'id-ac-shadowSupplierInitiatedAC',
        u'id-ac-shadowSupplierInitiatedAsynchronousAC',
        u'id-ac-shadowConsumerInitiatedAsynchronousAC',
        ]
    _class_ = [
        u'APPLICATION-CONTEXT',
        u'directoryAccessAC',
        u'directorySystemAC',
        u'shadowSupplierInitiatedAC',
        u'shadowConsumerInitiatedAC',
        u'shadowSupplierInitiatedAsynchronousAC',
        u'shadowConsumerInitiatedAsynchronousAC',
        u'directoryOperationalBindingManagementAC',
        ]
    _param_ = [
        ]
    
    #-----< DAP-OSI-PDUs >-----#
    DAP_OSI_PDUs = OPEN(name=u'DAP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _DAP_OSI_PDUs_val_0 = SET(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __DAP_OSI_PDUs_val_0_mode_selector = SET(name=u'mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name=u'mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DAP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        (u'mode-value', ___DAP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __DAP_OSI_PDUs_val_0_mode_selector._ext = None
    __DAP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name=u'calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name=u'called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name=u'presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE)
    ____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name=u'called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name=u'called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name=u'called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name=u'called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name=u'calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name=u'calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name=u'calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name=u'calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'called-AP-title', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        (u'called-AE-qualifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        (u'called-AP-invocation-identifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        (u'called-AE-invocation-identifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        (u'calling-AP-title', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        (u'calling-AE-qualifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        (u'calling-AP-invocation-identifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        (u'calling-AE-invocation-identifier', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        (u'implementation-information', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __DAP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___DAP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        (u'calling-presentation-selector', ___DAP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        (u'called-presentation-selector', ___DAP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        (u'presentation-context-definition-list', ___DAP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        (u'user-data', ___DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __DAP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _DAP_OSI_PDUs_val_0._cont = ASN1Dict([
        (u'mode-selector', __DAP_OSI_PDUs_val_0_mode_selector),
        (u'normal-mode-parameters', __DAP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _DAP_OSI_PDUs_val_0._ext = None
    _DAP_OSI_PDUs_val_1 = SET(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __DAP_OSI_PDUs_val_1_mode_selector = SET(name=u'mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name=u'mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DAP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        (u'mode-value', ___DAP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __DAP_OSI_PDUs_val_1_mode_selector._ext = None
    __DAP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name=u'responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name=u'presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name=u'result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        (u'result', _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        (u'transfer-syntax-name', _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE)
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name=u'responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name=u'responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name=u'responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name=u'responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'result', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'result-source-diagnostic', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        (u'responding-AP-title', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        (u'responding-AE-qualifier', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        (u'responding-AP-invocation-identifier', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        (u'responding-AE-invocation-identifier', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        (u'implementation-information', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __DAP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___DAP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        (u'responding-presentation-selector', ___DAP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        (u'presentation-context-definition-result-list', ___DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        (u'user-data', ___DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __DAP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _DAP_OSI_PDUs_val_1._cont = ASN1Dict([
        (u'mode-selector', __DAP_OSI_PDUs_val_1_mode_selector),
        (u'normal-mode-parameters', __DAP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _DAP_OSI_PDUs_val_1._ext = None
    _DAP_OSI_PDUs_val_2 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __DAP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE)
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name=u'responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name=u'presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name=u'provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE, opt=True)
    ____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name=u'responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name=u'responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name=u'responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name=u'responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'result', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'result-source-diagnostic', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        (u'responding-AP-title', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        (u'responding-AE-qualifier', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        (u'responding-AP-invocation-identifier', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        (u'responding-AE-invocation-identifier', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        (u'implementation-information', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __DAP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___DAP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        (u'responding-presentation-selector', ___DAP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        (u'presentation-context-definition-result-list', ___DAP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        (u'provider-reason', ___DAP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        (u'user-data', ___DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __DAP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _DAP_OSI_PDUs_val_2._cont = ASN1Dict([
        (u'normal-mode-parameters', __DAP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _DAP_OSI_PDUs_val_2._ext = None
    _DAP_OSI_PDUs_val_3 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __DAP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___DAP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name=u'single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name=u'request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'operationCode']))
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_Errors_val_ParameterType_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    __OPERATION_Errors_val_ParameterType_3 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_3_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_Errors_val_ParameterType_4 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_4_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Errors_val_ParameterType_5 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_5_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_5_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    __OPERATION_Errors_val_ParameterType_0_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_1._ext = None
    __OPERATION_Errors_val_ParameterType_1_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_0._ext = None
    __OPERATION_Errors_val_ParameterType_2_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_3_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_3_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_3_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_0._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    __OPERATION_Errors_val_ParameterType_5_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_5_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_5_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_5_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    __OPERATION_Errors_val_ParameterType_3_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_3_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_3_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_3_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_1._ext = None
    __OPERATION_Errors_val_ParameterType_4_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_1._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    __OPERATION_Errors_val_ParameterType_0_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_2._ext = None
    __OPERATION_Errors_val_ParameterType_1_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_1._ext = None
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([(u'ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), (u'ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), (u'ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2), (u'ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3), (u'ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4), (u'ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5), (u'ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6), (u'ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7), (u'ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8), (u'ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9), (u'ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10), (u'ResultType', __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))])], rr=[], ev=None, er=[])
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = u'operationCode'
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'ArgumentType']))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', u'opcode')
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = u'ArgumentType'
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        (u'invokeId', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        (u'opcode', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        (u'argument', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name=u'result', mode=MODE_TYPE)
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'operationCode']))
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = u'operationCode'
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'ResultType']))
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', u'opcode')
    _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = u'ResultType'
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        (u'opcode', _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        (u'result', _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        (u'invokeId', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        (u'result', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name=u'error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name=u'invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'Errors', u'errorCode']))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = u'errorCode'
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name=u'error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'Errors', u'ParameterType']))
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', u'errcode')
    ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = u'ParameterType'
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        (u'invokeID', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        (u'errcode', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        (u'error', ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name=u'reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'request', _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        (u'result', _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'error', _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        (u'reject', _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___DAP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        (u'presentation-context-identifier', ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___DAP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __DAP_OSI_PDUs_val_3_fully_encoded_data._cont = ___DAP_OSI_PDUs_val_3_fully_encoded_data__item_
    __DAP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _DAP_OSI_PDUs_val_3._cont = ASN1Dict([
        (u'fully-encoded-data', __DAP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _DAP_OSI_PDUs_val_3._ext = None
    _DAP_OSI_PDUs_val_4 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _DAP_OSI_PDUs_val_5 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    DAP_OSI_PDUs._const_val = ASN1Set(rv=[_DAP_OSI_PDUs_val_0, _DAP_OSI_PDUs_val_1, _DAP_OSI_PDUs_val_2, _DAP_OSI_PDUs_val_3, _DAP_OSI_PDUs_val_4, _DAP_OSI_PDUs_val_5], ev=None)
    
    #-----< DSP-OSI-PDUs >-----#
    DSP_OSI_PDUs = OPEN(name=u'DSP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _DSP_OSI_PDUs_val_0 = SET(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __DSP_OSI_PDUs_val_0_mode_selector = SET(name=u'mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name=u'mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DSP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        (u'mode-value', ___DSP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __DSP_OSI_PDUs_val_0_mode_selector._ext = None
    __DSP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name=u'calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name=u'called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name=u'presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE)
    ____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name=u'called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name=u'called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name=u'called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name=u'called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name=u'calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name=u'calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name=u'calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name=u'calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'called-AP-title', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        (u'called-AE-qualifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        (u'called-AP-invocation-identifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        (u'called-AE-invocation-identifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        (u'calling-AP-title', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        (u'calling-AE-qualifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        (u'calling-AP-invocation-identifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        (u'calling-AE-invocation-identifier', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        (u'implementation-information', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __DSP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___DSP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        (u'calling-presentation-selector', ___DSP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        (u'called-presentation-selector', ___DSP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        (u'presentation-context-definition-list', ___DSP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        (u'user-data', ___DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __DSP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _DSP_OSI_PDUs_val_0._cont = ASN1Dict([
        (u'mode-selector', __DSP_OSI_PDUs_val_0_mode_selector),
        (u'normal-mode-parameters', __DSP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _DSP_OSI_PDUs_val_0._ext = None
    _DSP_OSI_PDUs_val_1 = SET(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __DSP_OSI_PDUs_val_1_mode_selector = SET(name=u'mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name=u'mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DSP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        (u'mode-value', ___DSP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __DSP_OSI_PDUs_val_1_mode_selector._ext = None
    __DSP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name=u'responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name=u'presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name=u'result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        (u'result', _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        (u'transfer-syntax-name', _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE)
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name=u'responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name=u'responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name=u'responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name=u'responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'result', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'result-source-diagnostic', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        (u'responding-AP-title', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        (u'responding-AE-qualifier', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        (u'responding-AP-invocation-identifier', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        (u'responding-AE-invocation-identifier', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        (u'implementation-information', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __DSP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___DSP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        (u'responding-presentation-selector', ___DSP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        (u'presentation-context-definition-result-list', ___DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        (u'user-data', ___DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __DSP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _DSP_OSI_PDUs_val_1._cont = ASN1Dict([
        (u'mode-selector', __DSP_OSI_PDUs_val_1_mode_selector),
        (u'normal-mode-parameters', __DSP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _DSP_OSI_PDUs_val_1._ext = None
    _DSP_OSI_PDUs_val_2 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __DSP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE)
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name=u'responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name=u'presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name=u'provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE, opt=True)
    ____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name=u'responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name=u'responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name=u'responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name=u'responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'result', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'result-source-diagnostic', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        (u'responding-AP-title', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        (u'responding-AE-qualifier', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        (u'responding-AP-invocation-identifier', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        (u'responding-AE-invocation-identifier', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        (u'implementation-information', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __DSP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___DSP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        (u'responding-presentation-selector', ___DSP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        (u'presentation-context-definition-result-list', ___DSP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        (u'provider-reason', ___DSP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        (u'user-data', ___DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __DSP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _DSP_OSI_PDUs_val_2._cont = ASN1Dict([
        (u'normal-mode-parameters', __DSP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _DSP_OSI_PDUs_val_2._ext = None
    _DSP_OSI_PDUs_val_3 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __DSP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___DSP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name=u'single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name=u'request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'operationCode']))
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_chainedArgument),
        (u'argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_chainedArgument),
        (u'argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_chainedResult),
        (u'result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_chainedResult),
        (u'result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0._ext = None
    __OPERATION_Errors_val_ParameterType_0_3 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ___OPERATION_Errors_val_ParameterType_0_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_3._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_3_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_3._ext = None
    __OPERATION_Errors_val_ParameterType_1_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_2._ext = None
    __OPERATION_Errors_val_ParameterType_2_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    __OPERATION_Errors_val_ParameterType_3_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_3_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_3_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_3_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_3_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_2._ext = None
    __OPERATION_Errors_val_ParameterType_4_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_4_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_2._ext = None
    __OPERATION_Errors_val_ParameterType_5_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_5_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_5_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_5_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_1._ext = None
    __OPERATION_Errors_val_ParameterType_6 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_6_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_6_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_6_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_chainedArgument),
        (u'argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_chainedArgument),
        (u'argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_chainedResult),
        (u'result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_chainedResult),
        (u'result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_chainedArgument),
        (u'argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_chainedArgument),
        (u'argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_chainedResult),
        (u'result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_chainedResult),
        (u'result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_chainedArgument),
        (u'argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_chainedArgument),
        (u'argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_chainedResult),
        (u'result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_chainedResult),
        (u'result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_chainedArgument),
        (u'argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_chainedArgument),
        (u'argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_chainedResult),
        (u'result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_chainedResult),
        (u'result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_6_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_6_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_6_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6_0._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_chainedArgument),
        (u'argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_chainedArgument),
        (u'argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_chainedResult),
        (u'result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_chainedResult),
        (u'result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_chainedArgument),
        (u'argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_chainedArgument),
        (u'argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_chainedResult),
        (u'result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_chainedResult),
        (u'result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_chainedArgument),
        (u'argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_chainedArgument),
        (u'argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_chainedResult),
        (u'result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_chainedResult),
        (u'result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_chainedArgument),
        (u'argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_chainedArgument),
        (u'argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_chainedResult),
        (u'result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_chainedResult),
        (u'result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9._ext = None
    __OPERATION_Errors_val_ParameterType_1_3 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_3._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_3_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_3._ext = None
    __OPERATION_Errors_val_ParameterType_2_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_2._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_chainedArgument),
        (u'argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_chainedArgument),
        (u'argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_chainedResult),
        (u'result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_chainedResult),
        (u'result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_chainedArgument),
        (u'argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_chainedArgument),
        (u'argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType = SEQ_OF(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType._cont = _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType__item_
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_chainedResult),
        (u'result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType = SEQ_OF(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType._cont = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType__item_
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_chainedResult),
        (u'result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11._ext = None
    __OPERATION_Errors_val_ParameterType_1_4 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_4_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_1_4_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_4_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_4_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_4_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_4_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_4_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_4._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_4_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_4._ext = None
    __OPERATION_Errors_val_ParameterType_2_3 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_2_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_3._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_3_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_3._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_chainedArgument),
        (u'argument', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_ArgumentType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_chainedArgument),
        (u'argument', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_ArgumentType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12._ext = None
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_ResultType = NULL(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_chainedResult),
        (u'result', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_ResultType),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned._ext = None
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_ResultType = NULL(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_chainedResult),
        (u'result', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_ResultType),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned._ext = None
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab = ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters_tab
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters),
        ])
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier._ext = []
    ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed._cont = ASN1Dict([
        (u'toBeSigned', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned),
        (u'algorithmIdentifier', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier),
        (u'signature', ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_signature),
        ])
    ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed._ext = []
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12._cont = ASN1Dict([
        (u'unsigned', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned),
        (u'signed', ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed),
        ])
    __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12._ext = None
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([(u'ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), (u'ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_2), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), (u'ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_2), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2), (u'ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3), (u'ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4), (u'ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_2), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5), (u'ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_2), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6), (u'ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7), (u'ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_2), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8), (u'ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9), (u'ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_3), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10), (u'ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_3), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11), (u'ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_4), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_3), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12), (u'ResultType', __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = u'operationCode'
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'ArgumentType']))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', u'opcode')
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = u'ArgumentType'
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        (u'invokeId', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        (u'opcode', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        (u'argument', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name=u'result', mode=MODE_TYPE)
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'operationCode']))
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = u'operationCode'
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'ResultType']))
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', u'opcode')
    _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = u'ResultType'
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        (u'opcode', _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        (u'result', _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        (u'invokeId', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        (u'result', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name=u'error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name=u'invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'Errors', u'errorCode']))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = u'errorCode'
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name=u'error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'Errors', u'ParameterType']))
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', u'errcode')
    ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = u'ParameterType'
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        (u'invokeID', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        (u'errcode', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        (u'error', ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name=u'reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'request', _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        (u'result', _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'error', _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        (u'reject', _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___DSP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        (u'presentation-context-identifier', ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___DSP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __DSP_OSI_PDUs_val_3_fully_encoded_data._cont = ___DSP_OSI_PDUs_val_3_fully_encoded_data__item_
    __DSP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _DSP_OSI_PDUs_val_3._cont = ASN1Dict([
        (u'fully-encoded-data', __DSP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _DSP_OSI_PDUs_val_3._ext = None
    _DSP_OSI_PDUs_val_4 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _DSP_OSI_PDUs_val_5 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    DSP_OSI_PDUs._const_val = ASN1Set(rv=[_DSP_OSI_PDUs_val_0, _DSP_OSI_PDUs_val_1, _DSP_OSI_PDUs_val_2, _DSP_OSI_PDUs_val_3, _DSP_OSI_PDUs_val_4, _DSP_OSI_PDUs_val_5], ev=None)
    
    #-----< DOP-OSI-PDUs >-----#
    DOP_OSI_PDUs = OPEN(name=u'DOP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _DOP_OSI_PDUs_val_0 = SET(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __DOP_OSI_PDUs_val_0_mode_selector = SET(name=u'mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name=u'mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DOP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        (u'mode-value', ___DOP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __DOP_OSI_PDUs_val_0_mode_selector._ext = None
    __DOP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name=u'calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name=u'called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name=u'presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE)
    ____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name=u'called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name=u'called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name=u'called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name=u'called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name=u'calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name=u'calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name=u'calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name=u'calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'called-AP-title', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        (u'called-AE-qualifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        (u'called-AP-invocation-identifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        (u'called-AE-invocation-identifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        (u'calling-AP-title', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        (u'calling-AE-qualifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        (u'calling-AP-invocation-identifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        (u'calling-AE-invocation-identifier', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        (u'implementation-information', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __DOP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___DOP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        (u'calling-presentation-selector', ___DOP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        (u'called-presentation-selector', ___DOP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        (u'presentation-context-definition-list', ___DOP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        (u'user-data', ___DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __DOP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _DOP_OSI_PDUs_val_0._cont = ASN1Dict([
        (u'mode-selector', __DOP_OSI_PDUs_val_0_mode_selector),
        (u'normal-mode-parameters', __DOP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _DOP_OSI_PDUs_val_0._ext = None
    _DOP_OSI_PDUs_val_1 = SET(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __DOP_OSI_PDUs_val_1_mode_selector = SET(name=u'mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name=u'mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __DOP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        (u'mode-value', ___DOP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __DOP_OSI_PDUs_val_1_mode_selector._ext = None
    __DOP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name=u'responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name=u'presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name=u'result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        (u'result', _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        (u'transfer-syntax-name', _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE)
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name=u'responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name=u'responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name=u'responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name=u'responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'result', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'result-source-diagnostic', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        (u'responding-AP-title', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        (u'responding-AE-qualifier', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        (u'responding-AP-invocation-identifier', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        (u'responding-AE-invocation-identifier', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        (u'implementation-information', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __DOP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___DOP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        (u'responding-presentation-selector', ___DOP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        (u'presentation-context-definition-result-list', ___DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        (u'user-data', ___DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __DOP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _DOP_OSI_PDUs_val_1._cont = ASN1Dict([
        (u'mode-selector', __DOP_OSI_PDUs_val_1_mode_selector),
        (u'normal-mode-parameters', __DOP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _DOP_OSI_PDUs_val_1._ext = None
    _DOP_OSI_PDUs_val_2 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __DOP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE)
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name=u'responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name=u'presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name=u'provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE, opt=True)
    ____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name=u'responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name=u'responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name=u'responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name=u'responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'result', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'result-source-diagnostic', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        (u'responding-AP-title', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        (u'responding-AE-qualifier', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        (u'responding-AP-invocation-identifier', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        (u'responding-AE-invocation-identifier', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        (u'implementation-information', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __DOP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___DOP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        (u'responding-presentation-selector', ___DOP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        (u'presentation-context-definition-result-list', ___DOP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        (u'provider-reason', ___DOP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        (u'user-data', ___DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __DOP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _DOP_OSI_PDUs_val_2._cont = ASN1Dict([
        (u'normal-mode-parameters', __DOP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _DOP_OSI_PDUs_val_2._ext = None
    _DOP_OSI_PDUs_val_3 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __DOP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___DOP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name=u'single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name=u'request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'operationCode']))
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgument')))
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResult')))
    __OPERATION_Errors_val_ParameterType_0_4 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_4_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ___OPERATION_Errors_val_ParameterType_0_4_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_4_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_4_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_4_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_4_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_4_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_4._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_4_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_4._ext = None
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgument')))
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResult')))
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgument')))
    __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResult')))
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([(u'ArgumentType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), (u'ResultType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_4), (u'errorCode', (u'local', 100))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_3), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 100))]), dict([(u'ArgumentType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), (u'ResultType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_4), (u'errorCode', (u'local', 100))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_3), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 102))]), dict([(u'ArgumentType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2), (u'ResultType', __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_4), (u'errorCode', (u'local', 100))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_3), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 101))])], rr=[], ev=None, er=[])
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = u'operationCode'
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'ArgumentType']))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', u'opcode')
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = u'ArgumentType'
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        (u'invokeId', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        (u'opcode', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        (u'argument', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name=u'result', mode=MODE_TYPE)
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'operationCode']))
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = u'operationCode'
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'ResultType']))
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', u'opcode')
    _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = u'ResultType'
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        (u'opcode', _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        (u'result', _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        (u'invokeId', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        (u'result', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name=u'error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name=u'invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'Errors', u'errorCode']))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = u'errorCode'
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name=u'error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'Errors', u'ParameterType']))
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', u'errcode')
    ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = u'ParameterType'
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        (u'invokeID', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        (u'errcode', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        (u'error', ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name=u'reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'request', _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        (u'result', _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'error', _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        (u'reject', _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___DOP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        (u'presentation-context-identifier', ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___DOP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __DOP_OSI_PDUs_val_3_fully_encoded_data._cont = ___DOP_OSI_PDUs_val_3_fully_encoded_data__item_
    __DOP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _DOP_OSI_PDUs_val_3._cont = ASN1Dict([
        (u'fully-encoded-data', __DOP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _DOP_OSI_PDUs_val_3._ext = None
    _DOP_OSI_PDUs_val_4 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _DOP_OSI_PDUs_val_5 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    DOP_OSI_PDUs._const_val = ASN1Set(rv=[_DOP_OSI_PDUs_val_0, _DOP_OSI_PDUs_val_1, _DOP_OSI_PDUs_val_2, _DOP_OSI_PDUs_val_3, _DOP_OSI_PDUs_val_4, _DOP_OSI_PDUs_val_5], ev=None)
    
    #-----< ShadowSupplierInitiatedDISP-OSI-PDUs >-----#
    ShadowSupplierInitiatedDISP_OSI_PDUs = OPEN(name=u'ShadowSupplierInitiatedDISP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_0 = SET(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector = SET(name=u'mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name=u'mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        (u'mode-value', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name=u'calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name=u'called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name=u'presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name=u'called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name=u'called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name=u'called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name=u'called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name=u'calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name=u'calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name=u'calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name=u'calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'called-AP-title', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        (u'called-AE-qualifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        (u'called-AP-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        (u'called-AE-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        (u'calling-AP-title', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        (u'calling-AE-qualifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        (u'calling-AP-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        (u'calling-AE-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        (u'implementation-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        (u'calling-presentation-selector', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        (u'called-presentation-selector', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        (u'presentation-context-definition-list', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        (u'user-data', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_0._cont = ASN1Dict([
        (u'mode-selector', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector),
        (u'normal-mode-parameters', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_0._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_1 = SET(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector = SET(name=u'mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name=u'mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        (u'mode-value', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name=u'responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name=u'presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name=u'result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        (u'result', _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        (u'transfer-syntax-name', _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name=u'responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name=u'responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name=u'responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name=u'responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'result', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'result-source-diagnostic', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        (u'responding-AP-title', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        (u'responding-AE-qualifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        (u'responding-AP-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        (u'responding-AE-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        (u'implementation-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        (u'responding-presentation-selector', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        (u'presentation-context-definition-result-list', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        (u'user-data', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_1._cont = ASN1Dict([
        (u'mode-selector', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector),
        (u'normal-mode-parameters', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_1._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_2 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name=u'responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name=u'presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name=u'provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE, opt=True)
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name=u'responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name=u'responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name=u'responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name=u'responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'result', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'result-source-diagnostic', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        (u'responding-AP-title', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        (u'responding-AE-qualifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        (u'responding-AP-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        (u'responding-AE-invocation-identifier', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        (u'implementation-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        (u'responding-presentation-selector', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        (u'presentation-context-definition-result-list', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        (u'provider-reason', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        (u'user-data', ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_2._cont = ASN1Dict([
        (u'normal-mode-parameters', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_2._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_3 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name=u'single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name=u'request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'operationCode']))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __OPERATION_Errors_val_ParameterType_0_5 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_5_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_5_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_5_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_5_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_5_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_5_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_5_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_5._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_5_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_5._ext = None
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([(u'ArgumentType', __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), (u'ResultType', __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), (u'ResultType', __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = u'operationCode'
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'ArgumentType']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', u'opcode')
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = u'ArgumentType'
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        (u'invokeId', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        (u'opcode', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        (u'argument', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name=u'result', mode=MODE_TYPE)
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'operationCode']))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = u'operationCode'
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'ResultType']))
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', u'opcode')
    _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = u'ResultType'
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        (u'opcode', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        (u'result', _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        (u'invokeId', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        (u'result', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name=u'error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name=u'invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'Errors', u'errorCode']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = u'errorCode'
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name=u'error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'Errors', u'ParameterType']))
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', u'errcode')
    ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = u'ParameterType'
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        (u'invokeID', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        (u'errcode', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        (u'error', ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name=u'reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'request', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        (u'result', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'error', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        (u'reject', _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        (u'presentation-context-identifier', ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data._cont = ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_
    __ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_3._cont = ASN1Dict([
        (u'fully-encoded-data', __ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_3._ext = None
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_4 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _ShadowSupplierInitiatedDISP_OSI_PDUs_val_5 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    ShadowSupplierInitiatedDISP_OSI_PDUs._const_val = ASN1Set(rv=[_ShadowSupplierInitiatedDISP_OSI_PDUs_val_0, _ShadowSupplierInitiatedDISP_OSI_PDUs_val_1, _ShadowSupplierInitiatedDISP_OSI_PDUs_val_2, _ShadowSupplierInitiatedDISP_OSI_PDUs_val_3, _ShadowSupplierInitiatedDISP_OSI_PDUs_val_4, _ShadowSupplierInitiatedDISP_OSI_PDUs_val_5], ev=None)
    
    #-----< ShadowSupplierInitiatedAsynchronousDISP-OSI-PDUs >-----#
    ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs = OPEN(name=u'ShadowSupplierInitiatedAsynchronousDISP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0 = SET(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector = SET(name=u'mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name=u'mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        (u'mode-value', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name=u'calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name=u'called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name=u'presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name=u'called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name=u'called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name=u'called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name=u'called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name=u'calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name=u'calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name=u'calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name=u'calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'called-AP-title', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        (u'called-AE-qualifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        (u'called-AP-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        (u'called-AE-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        (u'calling-AP-title', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        (u'calling-AE-qualifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        (u'calling-AP-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        (u'calling-AE-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        (u'implementation-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        (u'calling-presentation-selector', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        (u'called-presentation-selector', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        (u'presentation-context-definition-list', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        (u'user-data', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0._cont = ASN1Dict([
        (u'mode-selector', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector),
        (u'normal-mode-parameters', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1 = SET(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector = SET(name=u'mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name=u'mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        (u'mode-value', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name=u'responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name=u'presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name=u'result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        (u'result', _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        (u'transfer-syntax-name', _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name=u'responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name=u'responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name=u'responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name=u'responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'result', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'result-source-diagnostic', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        (u'responding-AP-title', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        (u'responding-AE-qualifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        (u'responding-AP-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        (u'responding-AE-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        (u'implementation-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        (u'responding-presentation-selector', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        (u'presentation-context-definition-result-list', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        (u'user-data', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1._cont = ASN1Dict([
        (u'mode-selector', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector),
        (u'normal-mode-parameters', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name=u'responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name=u'presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name=u'provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE, opt=True)
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name=u'responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name=u'responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name=u'responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name=u'responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'result', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'result-source-diagnostic', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        (u'responding-AP-title', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        (u'responding-AE-qualifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        (u'responding-AP-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        (u'responding-AE-invocation-identifier', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        (u'implementation-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        (u'responding-presentation-selector', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        (u'presentation-context-definition-result-list', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        (u'provider-reason', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        (u'user-data', ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2._cont = ASN1Dict([
        (u'normal-mode-parameters', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name=u'single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name=u'request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'operationCode']))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([(u'ArgumentType', __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), (u'ResultType', __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), (u'ResultType', __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])], rr=[], ev=None, er=[])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = u'operationCode'
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'ArgumentType']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', u'opcode')
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = u'ArgumentType'
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        (u'invokeId', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        (u'opcode', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        (u'argument', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name=u'result', mode=MODE_TYPE)
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'operationCode']))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = u'operationCode'
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'ResultType']))
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', u'opcode')
    _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = u'ResultType'
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        (u'opcode', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        (u'result', _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        (u'invokeId', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        (u'result', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name=u'error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name=u'invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'Errors', u'errorCode']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = u'errorCode'
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name=u'error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'Errors', u'ParameterType']))
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', u'errcode')
    ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = u'ParameterType'
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        (u'invokeID', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        (u'errcode', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        (u'error', ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name=u'reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'request', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        (u'result', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'error', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        (u'reject', _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        (u'presentation-context-identifier', ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data._cont = ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_
    __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3._cont = ASN1Dict([
        (u'fully-encoded-data', __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3._ext = None
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_4 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_5 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs._const_val = ASN1Set(rv=[_ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0, _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1, _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2, _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3, _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_4, _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_5], ev=None)
    
    #-----< ShadowConsumerInitiatedDISP-OSI-PDUs >-----#
    ShadowConsumerInitiatedDISP_OSI_PDUs = OPEN(name=u'ShadowConsumerInitiatedDISP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_0 = SET(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector = SET(name=u'mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name=u'mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        (u'mode-value', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name=u'calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name=u'called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name=u'presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name=u'called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name=u'called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name=u'called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name=u'called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name=u'calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name=u'calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name=u'calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name=u'calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'called-AP-title', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        (u'called-AE-qualifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        (u'called-AP-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        (u'called-AE-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        (u'calling-AP-title', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        (u'calling-AE-qualifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        (u'calling-AP-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        (u'calling-AE-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        (u'implementation-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        (u'calling-presentation-selector', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        (u'called-presentation-selector', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        (u'presentation-context-definition-list', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        (u'user-data', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_0._cont = ASN1Dict([
        (u'mode-selector', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector),
        (u'normal-mode-parameters', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_0._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_1 = SET(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector = SET(name=u'mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name=u'mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        (u'mode-value', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name=u'responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name=u'presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name=u'result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        (u'result', _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        (u'transfer-syntax-name', _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name=u'responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name=u'responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name=u'responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name=u'responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'result', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'result-source-diagnostic', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        (u'responding-AP-title', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        (u'responding-AE-qualifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        (u'responding-AP-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        (u'responding-AE-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        (u'implementation-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        (u'responding-presentation-selector', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        (u'presentation-context-definition-result-list', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        (u'user-data', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_1._cont = ASN1Dict([
        (u'mode-selector', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector),
        (u'normal-mode-parameters', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_1._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_2 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name=u'responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name=u'presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name=u'provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE, opt=True)
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name=u'responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name=u'responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name=u'responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name=u'responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'result', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'result-source-diagnostic', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        (u'responding-AP-title', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        (u'responding-AE-qualifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        (u'responding-AP-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        (u'responding-AE-invocation-identifier', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        (u'implementation-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        (u'responding-presentation-selector', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        (u'presentation-context-definition-result-list', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        (u'provider-reason', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        (u'user-data', ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_2._cont = ASN1Dict([
        (u'normal-mode-parameters', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_2._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_3 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name=u'single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name=u'request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'operationCode']))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([(u'ArgumentType', __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), (u'ResultType', __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), (u'ResultType', __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = u'operationCode'
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'ArgumentType']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', u'opcode')
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = u'ArgumentType'
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        (u'invokeId', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        (u'opcode', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        (u'argument', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name=u'result', mode=MODE_TYPE)
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'operationCode']))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = u'operationCode'
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'ResultType']))
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', u'opcode')
    _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = u'ResultType'
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        (u'opcode', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        (u'result', _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        (u'invokeId', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        (u'result', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name=u'error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name=u'invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'Errors', u'errorCode']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = u'errorCode'
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name=u'error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'Errors', u'ParameterType']))
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', u'errcode')
    ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = u'ParameterType'
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        (u'invokeID', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        (u'errcode', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        (u'error', ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name=u'reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'request', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        (u'result', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'error', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        (u'reject', _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        (u'presentation-context-identifier', ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data._cont = ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_
    __ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_3._cont = ASN1Dict([
        (u'fully-encoded-data', __ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_3._ext = None
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_4 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _ShadowConsumerInitiatedDISP_OSI_PDUs_val_5 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    ShadowConsumerInitiatedDISP_OSI_PDUs._const_val = ASN1Set(rv=[_ShadowConsumerInitiatedDISP_OSI_PDUs_val_0, _ShadowConsumerInitiatedDISP_OSI_PDUs_val_1, _ShadowConsumerInitiatedDISP_OSI_PDUs_val_2, _ShadowConsumerInitiatedDISP_OSI_PDUs_val_3, _ShadowConsumerInitiatedDISP_OSI_PDUs_val_4, _ShadowConsumerInitiatedDISP_OSI_PDUs_val_5], ev=None)
    
    #-----< ShadowConsumerInitiatedAsynchronousDISP-OSI-PDUs >-----#
    ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs = OPEN(name=u'ShadowConsumerInitiatedAsynchronousDISP-OSI-PDUs', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OSI-PDU')))
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0 = SET(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBind')))
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector = SET(name=u'mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value = INT(name=u'mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector._cont = ASN1Dict([
        (u'mode-value', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value),
        ])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector = OCT_STR(name=u'calling-presentation-selector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector = OCT_STR(name=u'called-presentation-selector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list = SEQ_OF(name=u'presentation-context-definition-list', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Context-list')))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARQ-apdu')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title = CHOICE(name=u'called-AP-title', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier = SET_OF(name=u'called-AE-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier = INT(name=u'called-AP-invocation-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier = INT(name=u'called-AE-invocation-identifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title = CHOICE(name=u'calling-AP-title', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier = SET_OF(name=u'calling-AE-qualifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier = INT(name=u'calling-AP-invocation-identifier', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier = INT(name=u'calling-AE-invocation-identifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBind')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'called-AP-title', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title),
        (u'called-AE-qualifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier),
        (u'called-AP-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier),
        (u'called-AE-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier),
        (u'calling-AP-title', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title),
        (u'calling-AE-qualifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier),
        (u'calling-AP-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier),
        (u'calling-AE-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier),
        (u'implementation-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version),
        (u'calling-presentation-selector', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector),
        (u'called-presentation-selector', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector),
        (u'presentation-context-definition-list', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list),
        (u'user-data', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0._cont = ASN1Dict([
        (u'mode-selector', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector),
        (u'normal-mode-parameters', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1 = SET(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindResult')))
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector = SET(name=u'mode-selector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value = INT(name=u'mode-value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value._const_val = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector._cont = ASN1Dict([
        (u'mode-value', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value),
        ])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector = OCT_STR(name=u'responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name=u'presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result = INT(name=u'result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._cont = ASN1Dict([
        (u'result', _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result),
        (u'transfer-syntax-name', _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name),
        ])
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_._ext = None
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._cont = ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AARE-apdu')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[0], rr=[], ev=None, er=[])
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name=u'responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name=u'responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name=u'responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name=u'responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindRes')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'result', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'result-source-diagnostic', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        (u'responding-AP-title', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        (u'responding-AE-qualifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        (u'responding-AP-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        (u'responding-AE-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        (u'implementation-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version),
        (u'responding-presentation-selector', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector),
        (u'presentation-context-definition-result-list', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list),
        (u'user-data', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1._cont = ASN1Dict([
        (u'mode-selector', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector),
        (u'normal-mode-parameters', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiBindError')))
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version._cont = ASN1Dict([(u'version-1', 0)])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector = OCT_STR(name=u'responding-presentation-selector', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-selector')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list = SEQ_OF(name=u'presentation-context-definition-result-list', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result-list')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason = INT(name=u'provider-reason', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Provider-reason')), opt=True)
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE, opt=True)
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AAREerr-apdu')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Application-context-name')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = INT(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-result')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic = CHOICE(name=u'result-source-diagnostic', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Associate-source-diagnostic')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title = CHOICE(name=u'responding-AP-title', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier = SET_OF(name=u'responding-AE-qualifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier = INT(name=u'responding-AP-invocation-identifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AP-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier = INT(name=u'responding-AE-invocation-identifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'AE-invocation-identifier')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information = STR_GRAPH(name=u'implementation-information', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Implementation-data')), opt=True)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Association-informationBindErr')), opt=True)
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._cont = __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'protocol-version', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version),
        (u'application-context-name', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name),
        (u'result', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'result-source-diagnostic', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic),
        (u'responding-AP-title', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title),
        (u'responding-AE-qualifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier),
        (u'responding-AP-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier),
        (u'responding-AE-invocation-identifier', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier),
        (u'implementation-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information),
        (u'user-information', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information),
        ])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'transfer-syntax-name', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name),
        (u'presentation-context-identifier', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._cont = _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters._cont = ASN1Dict([
        (u'protocol-version', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version),
        (u'responding-presentation-selector', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector),
        (u'presentation-context-definition-result-list', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list),
        (u'provider-reason', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason),
        (u'user-data', ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data),
        ])
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2._cont = ASN1Dict([
        (u'normal-mode-parameters', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters),
        ])
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiOperation')))
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = CHOICE(name=u'single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiDirectoryOperation')))
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request = SEQ(name=u'request', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiReq')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'operationCode']))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab = CLASS(name='_tab_OPERATION', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab._val = ASN1Set(rv=[dict([(u'ArgumentType', __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0), (u'ResultType', __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1), (u'ResultType', __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_at = None
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode._const_tab_id = u'operationCode'
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument = OPEN(name=u'argument', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'ArgumentType']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_at = ('..', u'opcode')
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument._const_tab_id = u'ArgumentType'
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._cont = ASN1Dict([
        (u'invokeId', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId),
        (u'opcode', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode),
        (u'argument', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument),
        ])
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result = SEQ(name=u'result', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRes')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result = SEQ(name=u'result', mode=MODE_TYPE)
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode = CHOICE(name=u'opcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'operationCode']))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_at = None
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode._const_tab_id = u'operationCode'
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result = OPEN(name=u'result', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'ResultType']))
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_at = ('..', u'opcode')
    _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result._const_tab_id = u'ResultType'
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._cont = ASN1Dict([
        (u'opcode', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode),
        (u'result', _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result),
        ])
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._cont = ASN1Dict([
        (u'invokeId', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId),
        (u'result', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result),
        ])
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error = SEQ(name=u'error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiErr')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID = CHOICE(name=u'invokeID', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode = CHOICE(name=u'errcode', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'Errors', u'errorCode']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_at = None
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode._const_tab_id = u'errorCode'
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error = OPEN(name=u'error', mode=MODE_TYPE, typeref=ASN1RefClassField(('CommonProtocolSpecification', 'OPERATION'), [u'Errors', u'ParameterType']))
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab = _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_at = ('..', u'errcode')
    ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error._const_tab_id = u'ParameterType'
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._cont = ASN1Dict([
        (u'invokeID', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID),
        (u'errcode', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode),
        (u'error', ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error),
        ])
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error._ext = None
    _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject = SEQ(name=u'reject', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiRej')))
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._cont = ASN1Dict([
        (u'request', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request),
        (u'result', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result),
        (u'error', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error),
        (u'reject', _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject),
        ])
    ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0._ext = None
    _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values._ext = None
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_._cont = ASN1Dict([
        (u'presentation-context-identifier', ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values),
        ])
    ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_._ext = None
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data._cont = ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_
    __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3._cont = ASN1Dict([
        (u'fully-encoded-data', __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data),
        ])
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3._ext = None
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_4 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'OsiUnbind')))
    _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_5 = CHOICE(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'PresentationAbort')))
    ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs._const_val = ASN1Set(rv=[_ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0, _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1, _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2, _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3, _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_4, _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_5], ev=None)
    
    #-----< APPLICATION-CONTEXT >-----#
    APPLICATION_CONTEXT = CLASS(name=u'APPLICATION-CONTEXT', mode=MODE_TYPE)
    _APPLICATION_CONTEXT_bind_operation = CLASS(name=u'bind-operation', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _APPLICATION_CONTEXT_Operations = CLASS(name=u'Operations', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _APPLICATION_CONTEXT_applicationContextName = OID(name=u'applicationContextName', mode=MODE_VALUE, uniq=True)
    APPLICATION_CONTEXT._cont = ASN1Dict([
        (u'bind-operation', _APPLICATION_CONTEXT_bind_operation),
        (u'Operations', _APPLICATION_CONTEXT_Operations),
        (u'applicationContextName', _APPLICATION_CONTEXT_applicationContextName),
        ])
    
    #-----< directoryAccessAC >-----#
    directoryAccessAC = CLASS(name=u'directoryAccessAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    __APPLICATION_CONTEXT_bind_operation_val_ArgumentType = SET(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'DirectoryBindArgument')))
    __APPLICATION_CONTEXT_bind_operation_val_ResultType = SET(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'DirectoryBindResult')))
    __OPERATION_Errors_val_ParameterType_0_6 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_6_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_6_unsigned_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_6_unsigned_error = CHOICE(name=u'error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_serviceError = INT(name=u'serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_securityError = INT(name=u'securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_6_unsigned_error._cont = ASN1Dict([
        (u'serviceError', _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_serviceError),
        (u'securityError', _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_6_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_6_unsigned_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_6_unsigned._cont = ASN1Dict([
        (u'versions', ____OPERATION_Errors_val_ParameterType_0_6_unsigned_versions),
        (u'error', ____OPERATION_Errors_val_ParameterType_0_6_unsigned_error),
        (u'securityParameters', ____OPERATION_Errors_val_ParameterType_0_6_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_6_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_6_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error = CHOICE(name=u'error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_serviceError = INT(name=u'serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_securityError = INT(name=u'securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error._cont = ASN1Dict([
        (u'serviceError', ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_serviceError),
        (u'securityError', ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned._cont = ASN1Dict([
        (u'versions', _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_versions),
        (u'error', _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error),
        (u'securityParameters', _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_6_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_6_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_6_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_6_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_6._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_6_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_6_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_6._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_2 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_3 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_4 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_5 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_6 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_7 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_8 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_9 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_10 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    directoryAccessAC._val = dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 1))])
    
    #-----< directorySystemAC >-----#
    directorySystemAC = CLASS(name=u'directorySystemAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0 = SET(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    __APPLICATION_CONTEXT_bind_operation_val_ResultType_0 = SET(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_3_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_3_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_3_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_4_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_4_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_4_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_5_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_5_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_5_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_6_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_6_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_6_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_7_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_7_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_7_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_8_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_8_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_8_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_9_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_9_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_9_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_10_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_10_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_10_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_11 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType = SEQ_OF(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType._cont = _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType = SEQ_OF(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType._cont = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_12 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType = NULL(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType = NULL(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._ext = None
    directorySystemAC._val = dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_2), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_2), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_2), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_2), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_2), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_3), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_3), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_4), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_3), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))])
    
    #-----< shadowSupplierInitiatedAC >-----#
    shadowSupplierInitiatedAC = CLASS(name=u'shadowSupplierInitiatedAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    shadowSupplierInitiatedAC._val = dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 5))])
    
    #-----< shadowConsumerInitiatedAC >-----#
    shadowConsumerInitiatedAC = CLASS(name=u'shadowConsumerInitiatedAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_2 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_2 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    shadowConsumerInitiatedAC._val = dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 4))])
    
    #-----< shadowSupplierInitiatedAsynchronousAC >-----#
    shadowSupplierInitiatedAsynchronousAC = CLASS(name=u'shadowSupplierInitiatedAsynchronousAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    shadowSupplierInitiatedAsynchronousAC._val = dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 8))])
    
    #-----< shadowConsumerInitiatedAsynchronousAC >-----#
    shadowConsumerInitiatedAsynchronousAC = CLASS(name=u'shadowConsumerInitiatedAsynchronousAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    shadowConsumerInitiatedAsynchronousAC._val = dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_5), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 9))])
    
    #-----< directoryOperationalBindingManagementAC >-----#
    directoryOperationalBindingManagementAC = CLASS(name=u'directoryOperationalBindingManagementAC', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_3 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_3 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_3 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_3 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_2_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_2_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResult')))
    directoryOperationalBindingManagementAC._val = dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_6)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_4), (u'errorCode', (u'local', 100))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_3), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 100))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_4), (u'errorCode', (u'local', 100))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_3), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 102))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_4), (u'errorCode', (u'local', 100))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_3), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 101))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 3))])
    
    #-----< id-as-directoryAccessAS >-----#
    id_as_directoryAccessAS = OID(name=u'id-as-directoryAccessAS', mode=MODE_VALUE)
    id_as_directoryAccessAS._val = (2, 5, 9, 1)
    
    #-----< id-as-directorySystemAS >-----#
    id_as_directorySystemAS = OID(name=u'id-as-directorySystemAS', mode=MODE_VALUE)
    id_as_directorySystemAS._val = (2, 5, 9, 2)
    
    #-----< id-as-directoryShadowAS >-----#
    id_as_directoryShadowAS = OID(name=u'id-as-directoryShadowAS', mode=MODE_VALUE)
    id_as_directoryShadowAS._val = (2, 5, 9, 3)
    
    #-----< id-as-directoryOperationalBindingManagementAS >-----#
    id_as_directoryOperationalBindingManagementAS = OID(name=u'id-as-directoryOperationalBindingManagementAS', mode=MODE_VALUE)
    id_as_directoryOperationalBindingManagementAS._val = (2, 5, 9, 4)
    
    #-----< id-acseAS >-----#
    id_acseAS = OID(name=u'id-acseAS', mode=MODE_VALUE)
    id_acseAS._val = (2, 2, 1, 0, 1)
    
    #-----< id-ac-directoryAccessAC >-----#
    id_ac_directoryAccessAC = OID(name=u'id-ac-directoryAccessAC', mode=MODE_VALUE)
    id_ac_directoryAccessAC._val = (2, 5, 3, 1)
    
    #-----< id-ac-directorySystemAC >-----#
    id_ac_directorySystemAC = OID(name=u'id-ac-directorySystemAC', mode=MODE_VALUE)
    id_ac_directorySystemAC._val = (2, 5, 3, 2)
    
    #-----< id-ac-directoryOperationalBindingManagementAC >-----#
    id_ac_directoryOperationalBindingManagementAC = OID(name=u'id-ac-directoryOperationalBindingManagementAC', mode=MODE_VALUE)
    id_ac_directoryOperationalBindingManagementAC._val = (2, 5, 3, 3)
    
    #-----< id-ac-shadowConsumerInitiatedAC >-----#
    id_ac_shadowConsumerInitiatedAC = OID(name=u'id-ac-shadowConsumerInitiatedAC', mode=MODE_VALUE)
    id_ac_shadowConsumerInitiatedAC._val = (2, 5, 3, 4)
    
    #-----< id-ac-shadowSupplierInitiatedAC >-----#
    id_ac_shadowSupplierInitiatedAC = OID(name=u'id-ac-shadowSupplierInitiatedAC', mode=MODE_VALUE)
    id_ac_shadowSupplierInitiatedAC._val = (2, 5, 3, 5)
    
    #-----< id-ac-shadowSupplierInitiatedAsynchronousAC >-----#
    id_ac_shadowSupplierInitiatedAsynchronousAC = OID(name=u'id-ac-shadowSupplierInitiatedAsynchronousAC', mode=MODE_VALUE)
    id_ac_shadowSupplierInitiatedAsynchronousAC._val = (2, 5, 3, 8)
    
    #-----< id-ac-shadowConsumerInitiatedAsynchronousAC >-----#
    id_ac_shadowConsumerInitiatedAsynchronousAC = OID(name=u'id-ac-shadowConsumerInitiatedAsynchronousAC', mode=MODE_VALUE)
    id_ac_shadowConsumerInitiatedAsynchronousAC._val = (2, 5, 3, 9)
    
    _all_ = [
        ___DAP_OSI_PDUs_val_0_mode_selector_mode_value,
        __DAP_OSI_PDUs_val_0_mode_selector,
        ___DAP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___DAP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___DAP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___DAP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___DAP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __DAP_OSI_PDUs_val_0_normal_mode_parameters,
        _DAP_OSI_PDUs_val_0,
        ___DAP_OSI_PDUs_val_1_mode_selector_mode_value,
        __DAP_OSI_PDUs_val_1_mode_selector,
        ___DAP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___DAP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___DAP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___DAP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __DAP_OSI_PDUs_val_1_normal_mode_parameters,
        _DAP_OSI_PDUs_val_1,
        ___DAP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___DAP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___DAP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___DAP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___DAP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __DAP_OSI_PDUs_val_2_normal_mode_parameters,
        _DAP_OSI_PDUs_val_2,
        ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_Errors_val_ParameterType_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_signed,
        __OPERATION_Errors_val_ParameterType_2,
        ___OPERATION_Errors_val_ParameterType_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_signed,
        __OPERATION_Errors_val_ParameterType_3,
        ___OPERATION_Errors_val_ParameterType_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_signed,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_Errors_val_ParameterType_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_signed,
        __OPERATION_Errors_val_ParameterType_5,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3,
        ___OPERATION_Errors_val_ParameterType_0_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_1_signed,
        __OPERATION_Errors_val_ParameterType_0_1,
        ___OPERATION_Errors_val_ParameterType_1_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_0_signed,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_Errors_val_ParameterType_2_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_0_signed,
        __OPERATION_Errors_val_ParameterType_2_0,
        ___OPERATION_Errors_val_ParameterType_3_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_0_signed,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_Errors_val_ParameterType_4_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_0_signed,
        __OPERATION_Errors_val_ParameterType_4_0,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5,
        ___OPERATION_Errors_val_ParameterType_5_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_0_signed,
        __OPERATION_Errors_val_ParameterType_5_0,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6,
        ___OPERATION_Errors_val_ParameterType_3_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_1_signed,
        __OPERATION_Errors_val_ParameterType_3_1,
        ___OPERATION_Errors_val_ParameterType_4_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_1_signed,
        __OPERATION_Errors_val_ParameterType_4_1,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9,
        ___OPERATION_Errors_val_ParameterType_0_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_2_signed,
        __OPERATION_Errors_val_ParameterType_0_2,
        ___OPERATION_Errors_val_ParameterType_1_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_1_signed,
        __OPERATION_Errors_val_ParameterType_1_1,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10,
        __________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____DAP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___DAP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __DAP_OSI_PDUs_val_3_fully_encoded_data,
        _DAP_OSI_PDUs_val_3,
        _DAP_OSI_PDUs_val_4,
        _DAP_OSI_PDUs_val_5,
        DAP_OSI_PDUs,
        ___DSP_OSI_PDUs_val_0_mode_selector_mode_value,
        __DSP_OSI_PDUs_val_0_mode_selector,
        ___DSP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___DSP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___DSP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___DSP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___DSP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __DSP_OSI_PDUs_val_0_normal_mode_parameters,
        _DSP_OSI_PDUs_val_0,
        ___DSP_OSI_PDUs_val_1_mode_selector_mode_value,
        __DSP_OSI_PDUs_val_1_mode_selector,
        ___DSP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___DSP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___DSP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___DSP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __DSP_OSI_PDUs_val_1_normal_mode_parameters,
        _DSP_OSI_PDUs_val_1,
        ___DSP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___DSP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___DSP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___DSP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___DSP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __DSP_OSI_PDUs_val_2_normal_mode_parameters,
        _DSP_OSI_PDUs_val_2,
        ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_3_signed,
        __OPERATION_Errors_val_ParameterType_0_3,
        ___OPERATION_Errors_val_ParameterType_1_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_2_signed,
        __OPERATION_Errors_val_ParameterType_1_2,
        ___OPERATION_Errors_val_ParameterType_2_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_1_signed,
        __OPERATION_Errors_val_ParameterType_2_1,
        ___OPERATION_Errors_val_ParameterType_3_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_2_signed,
        __OPERATION_Errors_val_ParameterType_3_2,
        ___OPERATION_Errors_val_ParameterType_4_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_2_signed,
        __OPERATION_Errors_val_ParameterType_4_2,
        ___OPERATION_Errors_val_ParameterType_5_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_1_signed,
        __OPERATION_Errors_val_ParameterType_5_1,
        ___OPERATION_Errors_val_ParameterType_6_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_signed,
        __OPERATION_Errors_val_ParameterType_6,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_3,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_3,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_4,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_4,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_5,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_5,
        ___OPERATION_Errors_val_ParameterType_6_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_0_signed,
        __OPERATION_Errors_val_ParameterType_6_0,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_6,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_6,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_7,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_7,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_8,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_8,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_9,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_9,
        ___OPERATION_Errors_val_ParameterType_1_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_3_signed,
        __OPERATION_Errors_val_ParameterType_1_3,
        ___OPERATION_Errors_val_ParameterType_2_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_2_signed,
        __OPERATION_Errors_val_ParameterType_2_2,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_10,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_10,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_11,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType__item_,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_chainedResult,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType__item_,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_11,
        ___OPERATION_Errors_val_ParameterType_1_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_4_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_4_signed,
        __OPERATION_Errors_val_ParameterType_1_4,
        ___OPERATION_Errors_val_ParameterType_2_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_3_signed,
        __OPERATION_Errors_val_ParameterType_2_3,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_chainedArgument,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned_ArgumentType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_chainedArgument,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned_ArgumentType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_12,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_chainedResult,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned_ResultType,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_unsigned,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_chainedResult,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned_ResultType,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_toBeSigned,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_algorithm,
        ______________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters_tab,
        _____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier_parameters,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_algorithmIdentifier,
        ____________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed_signature,
        ___________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12_signed,
        __________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_12,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____DSP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___DSP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __DSP_OSI_PDUs_val_3_fully_encoded_data,
        _DSP_OSI_PDUs_val_3,
        _DSP_OSI_PDUs_val_4,
        _DSP_OSI_PDUs_val_5,
        DSP_OSI_PDUs,
        ___DOP_OSI_PDUs_val_0_mode_selector_mode_value,
        __DOP_OSI_PDUs_val_0_mode_selector,
        ___DOP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___DOP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___DOP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___DOP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___DOP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __DOP_OSI_PDUs_val_0_normal_mode_parameters,
        _DOP_OSI_PDUs_val_0,
        ___DOP_OSI_PDUs_val_1_mode_selector_mode_value,
        __DOP_OSI_PDUs_val_1_mode_selector,
        ___DOP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___DOP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___DOP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___DOP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __DOP_OSI_PDUs_val_1_normal_mode_parameters,
        _DOP_OSI_PDUs_val_1,
        ___DOP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___DOP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___DOP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___DOP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___DOP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __DOP_OSI_PDUs_val_2_normal_mode_parameters,
        _DOP_OSI_PDUs_val_2,
        ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_4_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_4_signed,
        __OPERATION_Errors_val_ParameterType_0_4,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_2,
        __________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_2,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____DOP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___DOP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __DOP_OSI_PDUs_val_3_fully_encoded_data,
        _DOP_OSI_PDUs_val_3,
        _DOP_OSI_PDUs_val_4,
        _DOP_OSI_PDUs_val_5,
        DOP_OSI_PDUs,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_mode_selector,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_0,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_mode_selector,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_1,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_2,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_5_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_5_signed,
        __OPERATION_Errors_val_ParameterType_0_5,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __ShadowSupplierInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_3,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_4,
        _ShadowSupplierInitiatedDISP_OSI_PDUs_val_5,
        ShadowSupplierInitiatedDISP_OSI_PDUs,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_0,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_1,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_2,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_3,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_4,
        _ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs_val_5,
        ShadowSupplierInitiatedAsynchronousDISP_OSI_PDUs,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector_mode_value,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_mode_selector,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_0_normal_mode_parameters,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_0,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector_mode_value,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_mode_selector,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_1_normal_mode_parameters,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_1,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_2_normal_mode_parameters,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_2,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __ShadowConsumerInitiatedDISP_OSI_PDUs_val_3_fully_encoded_data,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_3,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_4,
        _ShadowConsumerInitiatedDISP_OSI_PDUs_val_5,
        ShadowConsumerInitiatedDISP_OSI_PDUs,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector_mode_value,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_mode_selector,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_calling_presentation_selector,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_called_presentation_selector,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_presentation_context_definition_list,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_title,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_qualifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AP_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_called_AE_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_title,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_qualifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AP_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_calling_AE_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0_normal_mode_parameters,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_0,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector_mode_value,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_mode_selector,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_responding_presentation_selector,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__result,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item__transfer_syntax_name,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list__item_,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_presentation_context_definition_result_list,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1_normal_mode_parameters,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_1,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_protocol_version,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_responding_presentation_selector,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_presentation_context_definition_result_list,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_provider_reason,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__transfer_syntax_name,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_protocol_version,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_application_context_name,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_source_diagnostic,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_title,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_qualifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AP_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_responding_AE_invocation_identifier,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_implementation_information,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information__item_,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_user_information,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data_fully_encoded_data,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters_user_data,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2_normal_mode_parameters,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_2,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_context_identifier,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_invokeId,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_0,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_0,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ArgumentType_1,
        __________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode_tab_val_ResultType_1,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_opcode,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request_argument,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_request,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_invokeId,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_opcode,
        _________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result_result,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result_result,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_result,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_invokeID,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_errcode,
        ________ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error_error,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_error,
        _______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0_reject,
        ______ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        _____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ____ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item__presentation_data_values,
        ___ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data__item_,
        __ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3_fully_encoded_data,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_3,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_4,
        _ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs_val_5,
        ShadowConsumerInitiatedAsynchronousDISP_OSI_PDUs,
        _APPLICATION_CONTEXT_bind_operation,
        _APPLICATION_CONTEXT_Operations,
        _APPLICATION_CONTEXT_applicationContextName,
        APPLICATION_CONTEXT,
        directoryAccessAC,
        __APPLICATION_CONTEXT_bind_operation_val_ArgumentType,
        __APPLICATION_CONTEXT_bind_operation_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_6_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_6_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_6_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_6_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_6_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_6_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_6_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_6_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_6_signed,
        __OPERATION_Errors_val_ParameterType_0_6,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_2,
        __APPLICATION_CONTEXT_Operations_val_ResultType_2,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_3,
        __APPLICATION_CONTEXT_Operations_val_ResultType_3,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_4,
        __APPLICATION_CONTEXT_Operations_val_ResultType_4,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_5,
        __APPLICATION_CONTEXT_Operations_val_ResultType_5,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_6,
        __APPLICATION_CONTEXT_Operations_val_ResultType_6,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_7,
        __APPLICATION_CONTEXT_Operations_val_ResultType_7,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_8,
        __APPLICATION_CONTEXT_Operations_val_ResultType_8,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_9,
        __APPLICATION_CONTEXT_Operations_val_ResultType_9,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_10,
        __APPLICATION_CONTEXT_Operations_val_ResultType_10,
        directorySystemAC,
        __APPLICATION_CONTEXT_bind_operation_val_ArgumentType_0,
        __APPLICATION_CONTEXT_bind_operation_val_ResultType_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_3_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_3_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_4_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_4_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_5_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_5_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_6_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_6_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_7_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_7_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_8_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_8_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_9_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_9_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_10_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_10_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_11,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_11,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_12,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_12,
        shadowSupplierInitiatedAC,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_1,
        shadowConsumerInitiatedAC,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_2,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_2,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_2,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_2,
        shadowSupplierInitiatedAsynchronousAC,
        shadowConsumerInitiatedAsynchronousAC,
        directoryOperationalBindingManagementAC,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_3,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_3,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_3,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_3,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_2_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_2_0,
        id_as_directoryAccessAS,
        id_as_directorySystemAS,
        id_as_directoryShadowAS,
        id_as_directoryOperationalBindingManagementAS,
        id_acseAS,
        id_ac_directoryAccessAC,
        id_ac_directorySystemAC,
        id_ac_directoryOperationalBindingManagementAC,
        id_ac_shadowConsumerInitiatedAC,
        id_ac_shadowSupplierInitiatedAC,
        id_ac_shadowSupplierInitiatedAsynchronousAC,
        id_ac_shadowConsumerInitiatedAsynchronousAC,
    ]

class DirectoryShadowAbstractService:

    _name_  = u'DirectoryShadowAbstractService'
    _oid_   = [2, 5, 1, 15, 8]
    
    _obj_ = [
        u'dSAShadowBind',
        u'shadowOperationalBinding',
        u'ModificationParameter',
        u'AgreementID',
        u'ShadowingAgreementInfo',
        u'UnitOfReplication',
        u'AreaSpecification',
        u'Knowledge',
        u'AttributeSelection',
        u'ClassAttributeSelection',
        u'ClassAttributes',
        u'AttributeTypes',
        u'UpdateMode',
        u'SupplierUpdateMode',
        u'ConsumerUpdateMode',
        u'SchedulingParameters',
        u'PeriodicStrategy',
        u'Time',
        u'All-operations-consumer-initiated',
        u'All-operations-supplier-initiated',
        u'coordinateShadowUpdate',
        u'CoordinateShadowUpdateArgument',
        u'CoordinateShadowUpdateArgumentData',
        u'CoordinateShadowUpdateResult',
        u'CoordinateShadowUpdateResultData',
        u'requestShadowUpdate',
        u'RequestShadowUpdateArgument',
        u'RequestShadowUpdateArgumentData',
        u'RequestShadowUpdateResult',
        u'RequestShadowUpdateResultData',
        u'updateShadow',
        u'UpdateShadowArgument',
        u'UpdateShadowArgumentData',
        u'UpdateShadowResult',
        u'UpdateShadowResultData',
        u'UpdateWindow',
        u'RefreshInformation',
        u'TotalRefresh',
        u'SDSEContent',
        u'SDSEType',
        u'Subtree',
        u'IncrementalRefresh',
        u'IncrementalStepRefresh',
        u'ContentChange',
        u'SubordinateChanges',
        u'shadowError',
        u'ShadowErrorData',
        u'ShadowProblem',
        ]
    _type_ = [
        u'ModificationParameter',
        u'AgreementID',
        u'ShadowingAgreementInfo',
        u'UnitOfReplication',
        u'AreaSpecification',
        u'Knowledge',
        u'AttributeSelection',
        u'ClassAttributeSelection',
        u'ClassAttributes',
        u'AttributeTypes',
        u'UpdateMode',
        u'SupplierUpdateMode',
        u'ConsumerUpdateMode',
        u'SchedulingParameters',
        u'PeriodicStrategy',
        u'Time',
        u'CoordinateShadowUpdateArgument',
        u'CoordinateShadowUpdateArgumentData',
        u'CoordinateShadowUpdateResult',
        u'CoordinateShadowUpdateResultData',
        u'RequestShadowUpdateArgument',
        u'RequestShadowUpdateArgumentData',
        u'RequestShadowUpdateResult',
        u'RequestShadowUpdateResultData',
        u'UpdateShadowArgument',
        u'UpdateShadowArgumentData',
        u'UpdateShadowResult',
        u'UpdateShadowResultData',
        u'UpdateWindow',
        u'RefreshInformation',
        u'TotalRefresh',
        u'SDSEContent',
        u'SDSEType',
        u'Subtree',
        u'IncrementalRefresh',
        u'IncrementalStepRefresh',
        u'ContentChange',
        u'SubordinateChanges',
        u'ShadowErrorData',
        u'ShadowProblem',
        ]
    _set_ = [
        u'All-operations-consumer-initiated',
        u'All-operations-supplier-initiated',
        ]
    _val_ = [
        u'dSAShadowBind',
        u'shadowOperationalBinding',
        u'coordinateShadowUpdate',
        u'requestShadowUpdate',
        u'updateShadow',
        u'shadowError',
        ]
    _class_ = [
        u'dSAShadowBind',
        u'shadowOperationalBinding',
        u'All-operations-consumer-initiated',
        u'All-operations-supplier-initiated',
        u'coordinateShadowUpdate',
        u'requestShadowUpdate',
        u'updateShadow',
        u'shadowError',
        ]
    _param_ = [
        ]
    
    #-----< dSAShadowBind >-----#
    dSAShadowBind = CLASS(name=u'dSAShadowBind', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _dSAShadowBind_val_ArgumentType = SET(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    _dSAShadowBind_val_ResultType = SET(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_unsigned_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error = CHOICE(name=u'error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError = INT(name=u'serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError = INT(name=u'securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._cont = ASN1Dict([
        (u'serviceError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError),
        (u'securityError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_unsigned._cont = ASN1Dict([
        (u'versions', ____OPERATION_Errors_val_ParameterType_0_unsigned_versions),
        (u'error', ____OPERATION_Errors_val_ParameterType_0_unsigned_error),
        (u'securityParameters', ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error = CHOICE(name=u'error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError = INT(name=u'serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError = INT(name=u'securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._cont = ASN1Dict([
        (u'serviceError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError),
        (u'securityError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._cont = ASN1Dict([
        (u'versions', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions),
        (u'error', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error),
        (u'securityParameters', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    dSAShadowBind._val = dict([(u'ArgumentType', _dSAShadowBind_val_ArgumentType), (u'ResultType', _dSAShadowBind_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])
    
    #-----< shadowOperationalBinding >-----#
    shadowOperationalBinding = CLASS(name=u'shadowOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    _shadowOperationalBinding_val_Agreement = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    __APPLICATION_CONTEXT_bind_operation_val_ArgumentType = SET(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    __APPLICATION_CONTEXT_bind_operation_val_ResultType = SET(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __shadowOperationalBinding_roleA_val_EstablishParam = NULL(name=u'EstablishParam', mode=MODE_TYPE)
    __shadowOperationalBinding_roleB_val_EstablishParam = NULL(name=u'EstablishParam', mode=MODE_TYPE)
    __shadowOperationalBinding_roleB_val_ModifyParam = SEQ(name=u'ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ModificationParameter')))
    shadowOperationalBinding._val = dict([(u'Agreement', _shadowOperationalBinding_val_Agreement), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 5))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0), (u'ResultType', ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_1), (u'ResultType', ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))]), dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 4))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0_0), (u'ResultType', ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_1), (u'ResultType', ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __shadowOperationalBinding_roleA_val_EstablishParam), (u'modify', True), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __shadowOperationalBinding_roleB_val_EstablishParam), (u'modify', True), (u'ModifyParam', __shadowOperationalBinding_roleB_val_ModifyParam), (u'terminate', True)])), (u'id', (2, 5, 19, 1))])
    
    #-----< ModificationParameter >-----#
    ModificationParameter = SEQ(name=u'ModificationParameter', mode=MODE_TYPE)
    _ModificationParameter_secondaryShadows = SET_OF(name=u'secondaryShadows', mode=MODE_TYPE)
    __ModificationParameter_secondaryShadows__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'SupplierAndConsumers')))
    _ModificationParameter_secondaryShadows._cont = __ModificationParameter_secondaryShadows__item_
    ModificationParameter._cont = ASN1Dict([
        (u'secondaryShadows', _ModificationParameter_secondaryShadows),
        ])
    ModificationParameter._ext = []
    
    #-----< AgreementID >-----#
    AgreementID = SEQ(name=u'AgreementID', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    
    #-----< ShadowingAgreementInfo >-----#
    ShadowingAgreementInfo = SEQ(name=u'ShadowingAgreementInfo', mode=MODE_TYPE)
    _ShadowingAgreementInfo_shadowSubject = SEQ(name=u'shadowSubject', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UnitOfReplication')))
    _ShadowingAgreementInfo_updateMode = CHOICE(name=u'updateMode', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateMode')), default=(u'supplierInitiated', (u'onChange', True)))
    _ShadowingAgreementInfo_master = SET(name=u'master', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')), opt=True)
    _ShadowingAgreementInfo_secondaryShadows = BOOL(name=u'secondaryShadows', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    ShadowingAgreementInfo._cont = ASN1Dict([
        (u'shadowSubject', _ShadowingAgreementInfo_shadowSubject),
        (u'updateMode', _ShadowingAgreementInfo_updateMode),
        (u'master', _ShadowingAgreementInfo_master),
        (u'secondaryShadows', _ShadowingAgreementInfo_secondaryShadows),
        ])
    ShadowingAgreementInfo._ext = None
    
    #-----< UnitOfReplication >-----#
    UnitOfReplication = SEQ(name=u'UnitOfReplication', mode=MODE_TYPE)
    _UnitOfReplication_area = SEQ(name=u'area', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AreaSpecification')))
    _UnitOfReplication_attributes = SET_OF(name=u'attributes', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AttributeSelection')))
    _UnitOfReplication_knowledge = SEQ(name=u'knowledge', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Knowledge')), opt=True)
    _UnitOfReplication_subordinates = BOOL(name=u'subordinates', mode=MODE_TYPE, default=False)
    _UnitOfReplication_contextSelection = CHOICE(name=u'contextSelection', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ContextSelection')), opt=True)
    _UnitOfReplication_supplyContexts = CHOICE(name=u'supplyContexts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __UnitOfReplication_supplyContexts_allContexts = NULL(name=u'allContexts', mode=MODE_TYPE)
    __UnitOfReplication_supplyContexts_selectedContexts = SET_OF(name=u'selectedContexts', mode=MODE_TYPE)
    ___UnitOfReplication_supplyContexts_selectedContexts__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), [u'id']))
    __UnitOfReplication_supplyContexts_selectedContexts._cont = ___UnitOfReplication_supplyContexts_selectedContexts__item_
    __UnitOfReplication_supplyContexts_selectedContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UnitOfReplication_supplyContexts._cont = ASN1Dict([
        (u'allContexts', __UnitOfReplication_supplyContexts_allContexts),
        (u'selectedContexts', __UnitOfReplication_supplyContexts_selectedContexts),
        ])
    _UnitOfReplication_supplyContexts._ext = []
    UnitOfReplication._cont = ASN1Dict([
        (u'area', _UnitOfReplication_area),
        (u'attributes', _UnitOfReplication_attributes),
        (u'knowledge', _UnitOfReplication_knowledge),
        (u'subordinates', _UnitOfReplication_subordinates),
        (u'contextSelection', _UnitOfReplication_contextSelection),
        (u'supplyContexts', _UnitOfReplication_supplyContexts),
        ])
    UnitOfReplication._ext = None
    
    #-----< AreaSpecification >-----#
    AreaSpecification = SEQ(name=u'AreaSpecification', mode=MODE_TYPE)
    _AreaSpecification_contextPrefix = SEQ_OF(name=u'contextPrefix', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _AreaSpecification_replicationArea = SEQ(name=u'replicationArea', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SubtreeSpecification')))
    AreaSpecification._cont = ASN1Dict([
        (u'contextPrefix', _AreaSpecification_contextPrefix),
        (u'replicationArea', _AreaSpecification_replicationArea),
        ])
    AreaSpecification._ext = []
    
    #-----< Knowledge >-----#
    Knowledge = SEQ(name=u'Knowledge', mode=MODE_TYPE)
    _Knowledge_knowledgeType = ENUM(name=u'knowledgeType', mode=MODE_TYPE)
    _Knowledge_knowledgeType._cont = ASN1Dict([(u'master', 0), (u'shadow', 1), (u'both', 2)])
    _Knowledge_knowledgeType._ext = None
    _Knowledge_extendedKnowledge = BOOL(name=u'extendedKnowledge', mode=MODE_TYPE, default=False)
    Knowledge._cont = ASN1Dict([
        (u'knowledgeType', _Knowledge_knowledgeType),
        (u'extendedKnowledge', _Knowledge_extendedKnowledge),
        ])
    Knowledge._ext = []
    
    #-----< AttributeSelection >-----#
    AttributeSelection = SET_OF(name=u'AttributeSelection', mode=MODE_TYPE)
    _AttributeSelection__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ClassAttributeSelection')))
    AttributeSelection._cont = _AttributeSelection__item_
    
    #-----< ClassAttributeSelection >-----#
    ClassAttributeSelection = SEQ(name=u'ClassAttributeSelection', mode=MODE_TYPE)
    _ClassAttributeSelection_class_ = OID(name=u'class', mode=MODE_TYPE, opt=True)
    _ClassAttributeSelection_classAttributes = CHOICE(name=u'classAttributes', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ClassAttributes')), default=(u'allAttributes', 0))
    ClassAttributeSelection._cont = ASN1Dict([
        (u'class', _ClassAttributeSelection_class_),
        (u'classAttributes', _ClassAttributeSelection_classAttributes),
        ])
    ClassAttributeSelection._ext = None
    
    #-----< ClassAttributes >-----#
    ClassAttributes = CHOICE(name=u'ClassAttributes', mode=MODE_TYPE)
    _ClassAttributes_allAttributes = NULL(name=u'allAttributes', mode=MODE_TYPE)
    _ClassAttributes_include = SET_OF(name=u'include', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AttributeTypes')))
    _ClassAttributes_exclude = SET_OF(name=u'exclude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AttributeTypes')))
    ClassAttributes._cont = ASN1Dict([
        (u'allAttributes', _ClassAttributes_allAttributes),
        (u'include', _ClassAttributes_include),
        (u'exclude', _ClassAttributes_exclude),
        ])
    ClassAttributes._ext = []
    
    #-----< AttributeTypes >-----#
    AttributeTypes = SET_OF(name=u'AttributeTypes', mode=MODE_TYPE)
    _AttributeTypes__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    AttributeTypes._cont = _AttributeTypes__item_
    
    #-----< UpdateMode >-----#
    UpdateMode = CHOICE(name=u'UpdateMode', mode=MODE_TYPE)
    _UpdateMode_supplierInitiated = CHOICE(name=u'supplierInitiated', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SupplierUpdateMode')))
    _UpdateMode_consumerInitiated = SEQ(name=u'consumerInitiated', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ConsumerUpdateMode')))
    UpdateMode._cont = ASN1Dict([
        (u'supplierInitiated', _UpdateMode_supplierInitiated),
        (u'consumerInitiated', _UpdateMode_consumerInitiated),
        ])
    UpdateMode._ext = []
    
    #-----< SupplierUpdateMode >-----#
    SupplierUpdateMode = CHOICE(name=u'SupplierUpdateMode', mode=MODE_TYPE)
    _SupplierUpdateMode_onChange = BOOL(name=u'onChange', mode=MODE_TYPE)
    _SupplierUpdateMode_scheduled = SEQ(name=u'scheduled', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SchedulingParameters')))
    SupplierUpdateMode._cont = ASN1Dict([
        (u'onChange', _SupplierUpdateMode_onChange),
        (u'scheduled', _SupplierUpdateMode_scheduled),
        ])
    SupplierUpdateMode._ext = []
    
    #-----< ConsumerUpdateMode >-----#
    ConsumerUpdateMode = SEQ(name=u'ConsumerUpdateMode', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SchedulingParameters')))
    
    #-----< SchedulingParameters >-----#
    SchedulingParameters = SEQ(name=u'SchedulingParameters', mode=MODE_TYPE)
    _SchedulingParameters_periodic = SEQ(name=u'periodic', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'PeriodicStrategy')), opt=True)
    _SchedulingParameters_othertimes = BOOL(name=u'othertimes', mode=MODE_TYPE, default=False)
    SchedulingParameters._cont = ASN1Dict([
        (u'periodic', _SchedulingParameters_periodic),
        (u'othertimes', _SchedulingParameters_othertimes),
        ])
    SchedulingParameters._ext = []
    
    #-----< PeriodicStrategy >-----#
    PeriodicStrategy = SEQ(name=u'PeriodicStrategy', mode=MODE_TYPE)
    _PeriodicStrategy_beginTime = TIME_GEN(name=u'beginTime', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _PeriodicStrategy_windowSize = INT(name=u'windowSize', mode=MODE_TYPE)
    _PeriodicStrategy_updateInterval = INT(name=u'updateInterval', mode=MODE_TYPE)
    PeriodicStrategy._cont = ASN1Dict([
        (u'beginTime', _PeriodicStrategy_beginTime),
        (u'windowSize', _PeriodicStrategy_windowSize),
        (u'updateInterval', _PeriodicStrategy_updateInterval),
        ])
    PeriodicStrategy._ext = []
    
    #-----< Time >-----#
    Time = TIME_GEN(name=u'Time', mode=MODE_TYPE)
    
    #-----< All-operations-consumer-initiated >-----#
    All_operations_consumer_initiated = CLASS(name=u'All-operations-consumer-initiated', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _All_operations_consumer_initiated_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    _All_operations_consumer_initiated_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    _All_operations_consumer_initiated_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    _All_operations_consumer_initiated_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    All_operations_consumer_initiated._val = ASN1Set(rv=[dict([(u'ArgumentType', _All_operations_consumer_initiated_val_ArgumentType_0), (u'ResultType', _All_operations_consumer_initiated_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', _All_operations_consumer_initiated_val_ArgumentType_1), (u'ResultType', _All_operations_consumer_initiated_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])
    
    #-----< All-operations-supplier-initiated >-----#
    All_operations_supplier_initiated = CLASS(name=u'All-operations-supplier-initiated', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _All_operations_supplier_initiated_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    _All_operations_supplier_initiated_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    _All_operations_supplier_initiated_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    _All_operations_supplier_initiated_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    All_operations_supplier_initiated._val = ASN1Set(rv=[dict([(u'ArgumentType', _All_operations_supplier_initiated_val_ArgumentType_0), (u'ResultType', _All_operations_supplier_initiated_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', _All_operations_supplier_initiated_val_ArgumentType_1), (u'ResultType', _All_operations_supplier_initiated_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])
    
    #-----< coordinateShadowUpdate >-----#
    coordinateShadowUpdate = CLASS(name=u'coordinateShadowUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _coordinateShadowUpdate_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    _coordinateShadowUpdate_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    coordinateShadowUpdate._val = dict([(u'ArgumentType', _coordinateShadowUpdate_val_ArgumentType), (u'ResultType', _coordinateShadowUpdate_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])
    
    #-----< CoordinateShadowUpdateArgument >-----#
    CoordinateShadowUpdateArgument = CHOICE(name=u'CoordinateShadowUpdateArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _CoordinateShadowUpdateArgument_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgumentData')))
    _CoordinateShadowUpdateArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __CoordinateShadowUpdateArgument_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgumentData')))
    __CoordinateShadowUpdateArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab = ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab = ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __CoordinateShadowUpdateArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters),
        ])
    __CoordinateShadowUpdateArgument_signed_algorithmIdentifier._ext = []
    __CoordinateShadowUpdateArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _CoordinateShadowUpdateArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __CoordinateShadowUpdateArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __CoordinateShadowUpdateArgument_signed_algorithmIdentifier),
        (u'signature', __CoordinateShadowUpdateArgument_signed_signature),
        ])
    _CoordinateShadowUpdateArgument_signed._ext = []
    CoordinateShadowUpdateArgument._cont = ASN1Dict([
        (u'unsigned', _CoordinateShadowUpdateArgument_unsigned),
        (u'signed', _CoordinateShadowUpdateArgument_signed),
        ])
    CoordinateShadowUpdateArgument._ext = None
    
    #-----< CoordinateShadowUpdateArgumentData >-----#
    CoordinateShadowUpdateArgumentData = SEQ(name=u'CoordinateShadowUpdateArgumentData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CoordinateShadowUpdateArgumentData_agreementID = SEQ(name=u'agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _CoordinateShadowUpdateArgumentData_lastUpdate = TIME_GEN(name=u'lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _CoordinateShadowUpdateArgumentData_updateStrategy = CHOICE(name=u'updateStrategy', mode=MODE_TYPE)
    __CoordinateShadowUpdateArgumentData_updateStrategy_standard = ENUM(name=u'standard', mode=MODE_TYPE)
    __CoordinateShadowUpdateArgumentData_updateStrategy_standard._cont = ASN1Dict([(u'noChanges', 0), (u'incremental', 1), (u'total', 2)])
    __CoordinateShadowUpdateArgumentData_updateStrategy_standard._ext = []
    __CoordinateShadowUpdateArgumentData_updateStrategy_other = EXT(name=u'other', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _CoordinateShadowUpdateArgumentData_updateStrategy._cont = ASN1Dict([
        (u'standard', __CoordinateShadowUpdateArgumentData_updateStrategy_standard),
        (u'other', __CoordinateShadowUpdateArgumentData_updateStrategy_other),
        ])
    _CoordinateShadowUpdateArgumentData_updateStrategy._ext = []
    _CoordinateShadowUpdateArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    CoordinateShadowUpdateArgumentData._cont = ASN1Dict([
        (u'agreementID', _CoordinateShadowUpdateArgumentData_agreementID),
        (u'lastUpdate', _CoordinateShadowUpdateArgumentData_lastUpdate),
        (u'updateStrategy', _CoordinateShadowUpdateArgumentData_updateStrategy),
        (u'securityParameters', _CoordinateShadowUpdateArgumentData_securityParameters),
        ])
    CoordinateShadowUpdateArgumentData._ext = []
    
    #-----< CoordinateShadowUpdateResult >-----#
    CoordinateShadowUpdateResult = CHOICE(name=u'CoordinateShadowUpdateResult', mode=MODE_TYPE)
    _CoordinateShadowUpdateResult_null = NULL(name=u'null', mode=MODE_TYPE)
    _CoordinateShadowUpdateResult_information = CHOICE(name=u'information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __CoordinateShadowUpdateResult_information_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResultData')))
    __CoordinateShadowUpdateResult_information_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___CoordinateShadowUpdateResult_information_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResultData')))
    ___CoordinateShadowUpdateResult_information_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab = _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___CoordinateShadowUpdateResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___CoordinateShadowUpdateResult_information_signed_algorithmIdentifier._ext = []
    ___CoordinateShadowUpdateResult_information_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __CoordinateShadowUpdateResult_information_signed._cont = ASN1Dict([
        (u'toBeSigned', ___CoordinateShadowUpdateResult_information_signed_toBeSigned),
        (u'algorithmIdentifier', ___CoordinateShadowUpdateResult_information_signed_algorithmIdentifier),
        (u'signature', ___CoordinateShadowUpdateResult_information_signed_signature),
        ])
    __CoordinateShadowUpdateResult_information_signed._ext = []
    _CoordinateShadowUpdateResult_information._cont = ASN1Dict([
        (u'unsigned', __CoordinateShadowUpdateResult_information_unsigned),
        (u'signed', __CoordinateShadowUpdateResult_information_signed),
        ])
    _CoordinateShadowUpdateResult_information._ext = None
    CoordinateShadowUpdateResult._cont = ASN1Dict([
        (u'null', _CoordinateShadowUpdateResult_null),
        (u'information', _CoordinateShadowUpdateResult_information),
        ])
    CoordinateShadowUpdateResult._ext = []
    
    #-----< CoordinateShadowUpdateResultData >-----#
    CoordinateShadowUpdateResultData = SEQ(name=u'CoordinateShadowUpdateResultData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CoordinateShadowUpdateResultData_agreementID = SEQ(name=u'agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _CoordinateShadowUpdateResultData_lastUpdate = TIME_GEN(name=u'lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _CoordinateShadowUpdateResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _CoordinateShadowUpdateResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _CoordinateShadowUpdateResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _CoordinateShadowUpdateResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __CoordinateShadowUpdateResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___CoordinateShadowUpdateResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____CoordinateShadowUpdateResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____CoordinateShadowUpdateResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___CoordinateShadowUpdateResultData_notification__item__type._const_tab = ____CoordinateShadowUpdateResultData_notification__item__type_tab
    ___CoordinateShadowUpdateResultData_notification__item__type._const_tab_at = None
    ___CoordinateShadowUpdateResultData_notification__item__type._const_tab_id = u'id'
    ___CoordinateShadowUpdateResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____CoordinateShadowUpdateResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____CoordinateShadowUpdateResultData_notification__item__values__item_._const_tab = ____CoordinateShadowUpdateResultData_notification__item__type_tab
    ____CoordinateShadowUpdateResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____CoordinateShadowUpdateResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___CoordinateShadowUpdateResultData_notification__item__values._cont = ____CoordinateShadowUpdateResultData_notification__item__values__item_
    ___CoordinateShadowUpdateResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___CoordinateShadowUpdateResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab = ____CoordinateShadowUpdateResultData_notification__item__type_tab
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList._cont = ______CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_
    _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item_._ext = []
    ___CoordinateShadowUpdateResultData_notification__item__valuesWithContext._cont = ____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item_
    ___CoordinateShadowUpdateResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __CoordinateShadowUpdateResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___CoordinateShadowUpdateResultData_notification__item__type),
        (u'values', ___CoordinateShadowUpdateResultData_notification__item__values),
        (u'valuesWithContext', ___CoordinateShadowUpdateResultData_notification__item__valuesWithContext),
        ])
    __CoordinateShadowUpdateResultData_notification__item_._ext = []
    _CoordinateShadowUpdateResultData_notification._cont = __CoordinateShadowUpdateResultData_notification__item_
    CoordinateShadowUpdateResultData._cont = ASN1Dict([
        (u'agreementID', _CoordinateShadowUpdateResultData_agreementID),
        (u'lastUpdate', _CoordinateShadowUpdateResultData_lastUpdate),
        (u'securityParameters', _CoordinateShadowUpdateResultData_securityParameters),
        (u'performer', _CoordinateShadowUpdateResultData_performer),
        (u'aliasDereferenced', _CoordinateShadowUpdateResultData_aliasDereferenced),
        (u'notification', _CoordinateShadowUpdateResultData_notification),
        ])
    CoordinateShadowUpdateResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< requestShadowUpdate >-----#
    requestShadowUpdate = CLASS(name=u'requestShadowUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _requestShadowUpdate_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    _requestShadowUpdate_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    requestShadowUpdate._val = dict([(u'ArgumentType', _requestShadowUpdate_val_ArgumentType), (u'ResultType', _requestShadowUpdate_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))])
    
    #-----< RequestShadowUpdateArgument >-----#
    RequestShadowUpdateArgument = CHOICE(name=u'RequestShadowUpdateArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _RequestShadowUpdateArgument_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgumentData')))
    _RequestShadowUpdateArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __RequestShadowUpdateArgument_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgumentData')))
    __RequestShadowUpdateArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab = ____RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab = ____RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __RequestShadowUpdateArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters),
        ])
    __RequestShadowUpdateArgument_signed_algorithmIdentifier._ext = []
    __RequestShadowUpdateArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _RequestShadowUpdateArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __RequestShadowUpdateArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __RequestShadowUpdateArgument_signed_algorithmIdentifier),
        (u'signature', __RequestShadowUpdateArgument_signed_signature),
        ])
    _RequestShadowUpdateArgument_signed._ext = []
    RequestShadowUpdateArgument._cont = ASN1Dict([
        (u'unsigned', _RequestShadowUpdateArgument_unsigned),
        (u'signed', _RequestShadowUpdateArgument_signed),
        ])
    RequestShadowUpdateArgument._ext = None
    
    #-----< RequestShadowUpdateArgumentData >-----#
    RequestShadowUpdateArgumentData = SEQ(name=u'RequestShadowUpdateArgumentData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestShadowUpdateArgumentData_agreementID = SEQ(name=u'agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _RequestShadowUpdateArgumentData_lastUpdate = TIME_GEN(name=u'lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _RequestShadowUpdateArgumentData_requestedStrategy = CHOICE(name=u'requestedStrategy', mode=MODE_TYPE)
    __RequestShadowUpdateArgumentData_requestedStrategy_standard = ENUM(name=u'standard', mode=MODE_TYPE)
    __RequestShadowUpdateArgumentData_requestedStrategy_standard._cont = ASN1Dict([(u'incremental', 1), (u'total', 2)])
    __RequestShadowUpdateArgumentData_requestedStrategy_standard._ext = []
    __RequestShadowUpdateArgumentData_requestedStrategy_other = EXT(name=u'other', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _RequestShadowUpdateArgumentData_requestedStrategy._cont = ASN1Dict([
        (u'standard', __RequestShadowUpdateArgumentData_requestedStrategy_standard),
        (u'other', __RequestShadowUpdateArgumentData_requestedStrategy_other),
        ])
    _RequestShadowUpdateArgumentData_requestedStrategy._ext = []
    _RequestShadowUpdateArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    RequestShadowUpdateArgumentData._cont = ASN1Dict([
        (u'agreementID', _RequestShadowUpdateArgumentData_agreementID),
        (u'lastUpdate', _RequestShadowUpdateArgumentData_lastUpdate),
        (u'requestedStrategy', _RequestShadowUpdateArgumentData_requestedStrategy),
        (u'securityParameters', _RequestShadowUpdateArgumentData_securityParameters),
        ])
    RequestShadowUpdateArgumentData._ext = []
    
    #-----< RequestShadowUpdateResult >-----#
    RequestShadowUpdateResult = CHOICE(name=u'RequestShadowUpdateResult', mode=MODE_TYPE)
    _RequestShadowUpdateResult_null = NULL(name=u'null', mode=MODE_TYPE)
    _RequestShadowUpdateResult_information = CHOICE(name=u'information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __RequestShadowUpdateResult_information_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResultData')))
    __RequestShadowUpdateResult_information_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___RequestShadowUpdateResult_information_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResultData')))
    ___RequestShadowUpdateResult_information_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab = _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___RequestShadowUpdateResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___RequestShadowUpdateResult_information_signed_algorithmIdentifier._ext = []
    ___RequestShadowUpdateResult_information_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __RequestShadowUpdateResult_information_signed._cont = ASN1Dict([
        (u'toBeSigned', ___RequestShadowUpdateResult_information_signed_toBeSigned),
        (u'algorithmIdentifier', ___RequestShadowUpdateResult_information_signed_algorithmIdentifier),
        (u'signature', ___RequestShadowUpdateResult_information_signed_signature),
        ])
    __RequestShadowUpdateResult_information_signed._ext = []
    _RequestShadowUpdateResult_information._cont = ASN1Dict([
        (u'unsigned', __RequestShadowUpdateResult_information_unsigned),
        (u'signed', __RequestShadowUpdateResult_information_signed),
        ])
    _RequestShadowUpdateResult_information._ext = None
    RequestShadowUpdateResult._cont = ASN1Dict([
        (u'null', _RequestShadowUpdateResult_null),
        (u'information', _RequestShadowUpdateResult_information),
        ])
    RequestShadowUpdateResult._ext = []
    
    #-----< RequestShadowUpdateResultData >-----#
    RequestShadowUpdateResultData = SEQ(name=u'RequestShadowUpdateResultData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestShadowUpdateResultData_agreementID = SEQ(name=u'agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _RequestShadowUpdateResultData_lastUpdate = TIME_GEN(name=u'lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _RequestShadowUpdateResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _RequestShadowUpdateResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _RequestShadowUpdateResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _RequestShadowUpdateResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RequestShadowUpdateResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___RequestShadowUpdateResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____RequestShadowUpdateResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____RequestShadowUpdateResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___RequestShadowUpdateResultData_notification__item__type._const_tab = ____RequestShadowUpdateResultData_notification__item__type_tab
    ___RequestShadowUpdateResultData_notification__item__type._const_tab_at = None
    ___RequestShadowUpdateResultData_notification__item__type._const_tab_id = u'id'
    ___RequestShadowUpdateResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____RequestShadowUpdateResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____RequestShadowUpdateResultData_notification__item__values__item_._const_tab = ____RequestShadowUpdateResultData_notification__item__type_tab
    ____RequestShadowUpdateResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____RequestShadowUpdateResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___RequestShadowUpdateResultData_notification__item__values._cont = ____RequestShadowUpdateResultData_notification__item__values__item_
    ___RequestShadowUpdateResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___RequestShadowUpdateResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____RequestShadowUpdateResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab = ____RequestShadowUpdateResultData_notification__item__type_tab
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList._cont = ______RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_
    _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____RequestShadowUpdateResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____RequestShadowUpdateResultData_notification__item__valuesWithContext__item_._ext = []
    ___RequestShadowUpdateResultData_notification__item__valuesWithContext._cont = ____RequestShadowUpdateResultData_notification__item__valuesWithContext__item_
    ___RequestShadowUpdateResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __RequestShadowUpdateResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___RequestShadowUpdateResultData_notification__item__type),
        (u'values', ___RequestShadowUpdateResultData_notification__item__values),
        (u'valuesWithContext', ___RequestShadowUpdateResultData_notification__item__valuesWithContext),
        ])
    __RequestShadowUpdateResultData_notification__item_._ext = []
    _RequestShadowUpdateResultData_notification._cont = __RequestShadowUpdateResultData_notification__item_
    RequestShadowUpdateResultData._cont = ASN1Dict([
        (u'agreementID', _RequestShadowUpdateResultData_agreementID),
        (u'lastUpdate', _RequestShadowUpdateResultData_lastUpdate),
        (u'securityParameters', _RequestShadowUpdateResultData_securityParameters),
        (u'performer', _RequestShadowUpdateResultData_performer),
        (u'aliasDereferenced', _RequestShadowUpdateResultData_aliasDereferenced),
        (u'notification', _RequestShadowUpdateResultData_notification),
        ])
    RequestShadowUpdateResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< updateShadow >-----#
    updateShadow = CLASS(name=u'updateShadow', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _updateShadow_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    _updateShadow_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    updateShadow._val = dict([(u'ArgumentType', _updateShadow_val_ArgumentType), (u'ResultType', _updateShadow_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])
    
    #-----< UpdateShadowArgument >-----#
    UpdateShadowArgument = CHOICE(name=u'UpdateShadowArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    _UpdateShadowArgument_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgumentData')))
    _UpdateShadowArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __UpdateShadowArgument_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgumentData')))
    __UpdateShadowArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____UpdateShadowArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____UpdateShadowArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm._const_tab = ____UpdateShadowArgument_signed_algorithmIdentifier_algorithm_tab
    ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___UpdateShadowArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____UpdateShadowArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____UpdateShadowArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UpdateShadowArgument_signed_algorithmIdentifier_parameters._const_tab = ____UpdateShadowArgument_signed_algorithmIdentifier_parameters_tab
    ___UpdateShadowArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___UpdateShadowArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __UpdateShadowArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___UpdateShadowArgument_signed_algorithmIdentifier_parameters),
        ])
    __UpdateShadowArgument_signed_algorithmIdentifier._ext = []
    __UpdateShadowArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _UpdateShadowArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __UpdateShadowArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __UpdateShadowArgument_signed_algorithmIdentifier),
        (u'signature', __UpdateShadowArgument_signed_signature),
        ])
    _UpdateShadowArgument_signed._ext = []
    UpdateShadowArgument._cont = ASN1Dict([
        (u'unsigned', _UpdateShadowArgument_unsigned),
        (u'signed', _UpdateShadowArgument_signed),
        ])
    UpdateShadowArgument._ext = None
    
    #-----< UpdateShadowArgumentData >-----#
    UpdateShadowArgumentData = SEQ(name=u'UpdateShadowArgumentData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UpdateShadowArgumentData_agreementID = SEQ(name=u'agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _UpdateShadowArgumentData_updateTime = TIME_GEN(name=u'updateTime', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')))
    _UpdateShadowArgumentData_updateWindow = SEQ(name=u'updateWindow', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateWindow')), opt=True)
    _UpdateShadowArgumentData_updatedInfo = CHOICE(name=u'updatedInfo', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RefreshInformation')))
    _UpdateShadowArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    UpdateShadowArgumentData._cont = ASN1Dict([
        (u'agreementID', _UpdateShadowArgumentData_agreementID),
        (u'updateTime', _UpdateShadowArgumentData_updateTime),
        (u'updateWindow', _UpdateShadowArgumentData_updateWindow),
        (u'updatedInfo', _UpdateShadowArgumentData_updatedInfo),
        (u'securityParameters', _UpdateShadowArgumentData_securityParameters),
        ])
    UpdateShadowArgumentData._ext = []
    
    #-----< UpdateShadowResult >-----#
    UpdateShadowResult = CHOICE(name=u'UpdateShadowResult', mode=MODE_TYPE)
    _UpdateShadowResult_null = NULL(name=u'null', mode=MODE_TYPE)
    _UpdateShadowResult_information = CHOICE(name=u'information', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __UpdateShadowResult_information_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResultData')))
    __UpdateShadowResult_information_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___UpdateShadowResult_information_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResultData')))
    ___UpdateShadowResult_information_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm._const_tab = _____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm_tab
    ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____UpdateShadowResult_information_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____UpdateShadowResult_information_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters._const_tab = _____UpdateShadowResult_information_signed_algorithmIdentifier_parameters_tab
    ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___UpdateShadowResult_information_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters),
        ])
    ___UpdateShadowResult_information_signed_algorithmIdentifier._ext = []
    ___UpdateShadowResult_information_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __UpdateShadowResult_information_signed._cont = ASN1Dict([
        (u'toBeSigned', ___UpdateShadowResult_information_signed_toBeSigned),
        (u'algorithmIdentifier', ___UpdateShadowResult_information_signed_algorithmIdentifier),
        (u'signature', ___UpdateShadowResult_information_signed_signature),
        ])
    __UpdateShadowResult_information_signed._ext = []
    _UpdateShadowResult_information._cont = ASN1Dict([
        (u'unsigned', __UpdateShadowResult_information_unsigned),
        (u'signed', __UpdateShadowResult_information_signed),
        ])
    _UpdateShadowResult_information._ext = None
    UpdateShadowResult._cont = ASN1Dict([
        (u'null', _UpdateShadowResult_null),
        (u'information', _UpdateShadowResult_information),
        ])
    UpdateShadowResult._ext = []
    
    #-----< UpdateShadowResultData >-----#
    UpdateShadowResultData = SEQ(name=u'UpdateShadowResultData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UpdateShadowResultData_agreementID = SEQ(name=u'agreementID', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'AgreementID')))
    _UpdateShadowResultData_lastUpdate = TIME_GEN(name=u'lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _UpdateShadowResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _UpdateShadowResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _UpdateShadowResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _UpdateShadowResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UpdateShadowResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___UpdateShadowResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____UpdateShadowResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____UpdateShadowResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____UpdateShadowResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____UpdateShadowResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____UpdateShadowResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____UpdateShadowResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___UpdateShadowResultData_notification__item__type._const_tab = ____UpdateShadowResultData_notification__item__type_tab
    ___UpdateShadowResultData_notification__item__type._const_tab_at = None
    ___UpdateShadowResultData_notification__item__type._const_tab_id = u'id'
    ___UpdateShadowResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____UpdateShadowResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____UpdateShadowResultData_notification__item__values__item_._const_tab = ____UpdateShadowResultData_notification__item__type_tab
    ____UpdateShadowResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____UpdateShadowResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___UpdateShadowResultData_notification__item__values._cont = ____UpdateShadowResultData_notification__item__values__item_
    ___UpdateShadowResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___UpdateShadowResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____UpdateShadowResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__value._const_tab = ____UpdateShadowResultData_notification__item__type_tab
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______UpdateShadowResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__contextList._cont = ______UpdateShadowResultData_notification__item__valuesWithContext__item__contextList__item_
    _____UpdateShadowResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____UpdateShadowResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____UpdateShadowResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____UpdateShadowResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____UpdateShadowResultData_notification__item__valuesWithContext__item_._ext = []
    ___UpdateShadowResultData_notification__item__valuesWithContext._cont = ____UpdateShadowResultData_notification__item__valuesWithContext__item_
    ___UpdateShadowResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __UpdateShadowResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___UpdateShadowResultData_notification__item__type),
        (u'values', ___UpdateShadowResultData_notification__item__values),
        (u'valuesWithContext', ___UpdateShadowResultData_notification__item__valuesWithContext),
        ])
    __UpdateShadowResultData_notification__item_._ext = []
    _UpdateShadowResultData_notification._cont = __UpdateShadowResultData_notification__item_
    UpdateShadowResultData._cont = ASN1Dict([
        (u'agreementID', _UpdateShadowResultData_agreementID),
        (u'lastUpdate', _UpdateShadowResultData_lastUpdate),
        (u'securityParameters', _UpdateShadowResultData_securityParameters),
        (u'performer', _UpdateShadowResultData_performer),
        (u'aliasDereferenced', _UpdateShadowResultData_aliasDereferenced),
        (u'notification', _UpdateShadowResultData_notification),
        ])
    UpdateShadowResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< UpdateWindow >-----#
    UpdateWindow = SEQ(name=u'UpdateWindow', mode=MODE_TYPE)
    _UpdateWindow_start = TIME_GEN(name=u'start', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')))
    _UpdateWindow_stop = TIME_GEN(name=u'stop', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')))
    UpdateWindow._cont = ASN1Dict([
        (u'start', _UpdateWindow_start),
        (u'stop', _UpdateWindow_stop),
        ])
    UpdateWindow._ext = []
    
    #-----< RefreshInformation >-----#
    RefreshInformation = CHOICE(name=u'RefreshInformation', mode=MODE_TYPE)
    _RefreshInformation_noRefresh = NULL(name=u'noRefresh', mode=MODE_TYPE)
    _RefreshInformation_total = SEQ(name=u'total', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'TotalRefresh')))
    _RefreshInformation_incremental = SEQ_OF(name=u'incremental', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'IncrementalRefresh')))
    _RefreshInformation_otherStrategy = EXT(name=u'otherStrategy', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    RefreshInformation._cont = ASN1Dict([
        (u'noRefresh', _RefreshInformation_noRefresh),
        (u'total', _RefreshInformation_total),
        (u'incremental', _RefreshInformation_incremental),
        (u'otherStrategy', _RefreshInformation_otherStrategy),
        ])
    RefreshInformation._ext = []
    
    #-----< TotalRefresh >-----#
    TotalRefresh = SEQ(name=u'TotalRefresh', mode=MODE_TYPE)
    _TotalRefresh_sDSE = SEQ(name=u'sDSE', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SDSEContent')), opt=True)
    _TotalRefresh_subtree = SET_OF(name=u'subtree', mode=MODE_TYPE, opt=True)
    __TotalRefresh_subtree__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Subtree')))
    _TotalRefresh_subtree._cont = __TotalRefresh_subtree__item_
    _TotalRefresh_subtree._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    TotalRefresh._cont = ASN1Dict([
        (u'sDSE', _TotalRefresh_sDSE),
        (u'subtree', _TotalRefresh_subtree),
        ])
    TotalRefresh._ext = []
    
    #-----< SDSEContent >-----#
    SDSEContent = SEQ(name=u'SDSEContent', mode=MODE_TYPE)
    _SDSEContent_sDSEType = BIT_STR(name=u'sDSEType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SDSEType')))
    _SDSEContent_subComplete = BOOL(name=u'subComplete', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _SDSEContent_attComplete = BOOL(name=u'attComplete', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SDSEContent_attributes = SET_OF(name=u'attributes', mode=MODE_TYPE)
    __SDSEContent_attributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SDSEContent_attributes__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____SDSEContent_attributes__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SDSEContent_attributes__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____SDSEContent_attributes__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SDSEContent_attributes__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____SDSEContent_attributes__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____SDSEContent_attributes__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SDSEContent_attributes__item__type._const_tab = ____SDSEContent_attributes__item__type_tab
    ___SDSEContent_attributes__item__type._const_tab_at = None
    ___SDSEContent_attributes__item__type._const_tab_id = u'id'
    ___SDSEContent_attributes__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____SDSEContent_attributes__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____SDSEContent_attributes__item__values__item_._const_tab = ____SDSEContent_attributes__item__type_tab
    ____SDSEContent_attributes__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____SDSEContent_attributes__item__values__item_._const_tab_id = u'Type'
    ___SDSEContent_attributes__item__values._cont = ____SDSEContent_attributes__item__values__item_
    ___SDSEContent_attributes__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SDSEContent_attributes__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SDSEContent_attributes__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SDSEContent_attributes__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____SDSEContent_attributes__item__valuesWithContext__item__value._const_tab = ____SDSEContent_attributes__item__type_tab
    _____SDSEContent_attributes__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____SDSEContent_attributes__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____SDSEContent_attributes__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______SDSEContent_attributes__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SDSEContent_attributes__item__valuesWithContext__item__contextList._cont = ______SDSEContent_attributes__item__valuesWithContext__item__contextList__item_
    _____SDSEContent_attributes__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SDSEContent_attributes__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____SDSEContent_attributes__item__valuesWithContext__item__value),
        (u'contextList', _____SDSEContent_attributes__item__valuesWithContext__item__contextList),
        ])
    ____SDSEContent_attributes__item__valuesWithContext__item_._ext = []
    ___SDSEContent_attributes__item__valuesWithContext._cont = ____SDSEContent_attributes__item__valuesWithContext__item_
    ___SDSEContent_attributes__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SDSEContent_attributes__item_._cont = ASN1Dict([
        (u'type', ___SDSEContent_attributes__item__type),
        (u'values', ___SDSEContent_attributes__item__values),
        (u'valuesWithContext', ___SDSEContent_attributes__item__valuesWithContext),
        ])
    __SDSEContent_attributes__item_._ext = []
    _SDSEContent_attributes._cont = __SDSEContent_attributes__item_
    _SDSEContent_attValIncomplete = SET_OF(name=u'attValIncomplete', mode=MODE_TYPE, default=[])
    __SDSEContent_attValIncomplete__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _SDSEContent_attValIncomplete._cont = __SDSEContent_attValIncomplete__item_
    SDSEContent._cont = ASN1Dict([
        (u'sDSEType', _SDSEContent_sDSEType),
        (u'subComplete', _SDSEContent_subComplete),
        (u'attComplete', _SDSEContent_attComplete),
        (u'attributes', _SDSEContent_attributes),
        (u'attValIncomplete', _SDSEContent_attValIncomplete),
        ])
    SDSEContent._ext = []
    
    #-----< SDSEType >-----#
    SDSEType = BIT_STR(name=u'SDSEType', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'DSEType')))
    
    #-----< Subtree >-----#
    Subtree = SEQ(name=u'Subtree', mode=MODE_TYPE)
    _Subtree_rdn = SET_OF(name=u'rdn', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _Subtree_sDSE = SEQ(name=u'sDSE', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SDSEContent')), opt=True)
    _Subtree_subtree = SET_OF(name=u'subtree', mode=MODE_TYPE, opt=True)
    __Subtree_subtree__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Subtree')))
    _Subtree_subtree._cont = __Subtree_subtree__item_
    Subtree._cont = ASN1Dict([
        (u'rdn', _Subtree_rdn),
        (u'sDSE', _Subtree_sDSE),
        (u'subtree', _Subtree_subtree),
        ])
    Subtree._ext = []
    
    #-----< IncrementalRefresh >-----#
    IncrementalRefresh = SEQ_OF(name=u'IncrementalRefresh', mode=MODE_TYPE)
    _IncrementalRefresh__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'IncrementalStepRefresh')))
    IncrementalRefresh._cont = _IncrementalRefresh__item_
    
    #-----< IncrementalStepRefresh >-----#
    IncrementalStepRefresh = SEQ(name=u'IncrementalStepRefresh', mode=MODE_TYPE)
    _IncrementalStepRefresh_sDSEChanges = CHOICE(name=u'sDSEChanges', mode=MODE_TYPE, opt=True)
    __IncrementalStepRefresh_sDSEChanges_add = SEQ(name=u'add', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SDSEContent')))
    __IncrementalStepRefresh_sDSEChanges_remove = NULL(name=u'remove', mode=MODE_TYPE)
    __IncrementalStepRefresh_sDSEChanges_modify = SEQ(name=u'modify', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ContentChange')))
    _IncrementalStepRefresh_sDSEChanges._cont = ASN1Dict([
        (u'add', __IncrementalStepRefresh_sDSEChanges_add),
        (u'remove', __IncrementalStepRefresh_sDSEChanges_remove),
        (u'modify', __IncrementalStepRefresh_sDSEChanges_modify),
        ])
    _IncrementalStepRefresh_sDSEChanges._ext = []
    _IncrementalStepRefresh_subordinateUpdates = SEQ_OF(name=u'subordinateUpdates', mode=MODE_TYPE, opt=True)
    __IncrementalStepRefresh_subordinateUpdates__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SubordinateChanges')))
    _IncrementalStepRefresh_subordinateUpdates._cont = __IncrementalStepRefresh_subordinateUpdates__item_
    _IncrementalStepRefresh_subordinateUpdates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    IncrementalStepRefresh._cont = ASN1Dict([
        (u'sDSEChanges', _IncrementalStepRefresh_sDSEChanges),
        (u'subordinateUpdates', _IncrementalStepRefresh_subordinateUpdates),
        ])
    IncrementalStepRefresh._ext = None
    
    #-----< ContentChange >-----#
    ContentChange = SEQ(name=u'ContentChange', mode=MODE_TYPE)
    _ContentChange_rename = CHOICE(name=u'rename', mode=MODE_TYPE, opt=True)
    __ContentChange_rename_newRDN = SET_OF(name=u'newRDN', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    __ContentChange_rename_newDN = SEQ_OF(name=u'newDN', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _ContentChange_rename._cont = ASN1Dict([
        (u'newRDN', __ContentChange_rename_newRDN),
        (u'newDN', __ContentChange_rename_newDN),
        ])
    _ContentChange_rename._ext = None
    _ContentChange_attributeChanges = CHOICE(name=u'attributeChanges', mode=MODE_TYPE, opt=True)
    __ContentChange_attributeChanges_replace = SET_OF(name=u'replace', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ContentChange_attributeChanges_replace__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ____ContentChange_attributeChanges_replace__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _____ContentChange_attributeChanges_replace__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _____ContentChange_attributeChanges_replace__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ____ContentChange_attributeChanges_replace__item__type._const_tab = _____ContentChange_attributeChanges_replace__item__type_tab
    ____ContentChange_attributeChanges_replace__item__type._const_tab_at = None
    ____ContentChange_attributeChanges_replace__item__type._const_tab_id = u'id'
    ____ContentChange_attributeChanges_replace__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    _____ContentChange_attributeChanges_replace__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____ContentChange_attributeChanges_replace__item__values__item_._const_tab = _____ContentChange_attributeChanges_replace__item__type_tab
    _____ContentChange_attributeChanges_replace__item__values__item_._const_tab_at = ('..', '..', u'type')
    _____ContentChange_attributeChanges_replace__item__values__item_._const_tab_id = u'Type'
    ____ContentChange_attributeChanges_replace__item__values._cont = _____ContentChange_attributeChanges_replace__item__values__item_
    ____ContentChange_attributeChanges_replace__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ____ContentChange_attributeChanges_replace__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    _____ContentChange_attributeChanges_replace__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value._const_tab = _____ContentChange_attributeChanges_replace__item__type_tab
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value._const_tab_id = u'Type'
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    _______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList._cont = _______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList__item_
    ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _____ContentChange_attributeChanges_replace__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value),
        (u'contextList', ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList),
        ])
    _____ContentChange_attributeChanges_replace__item__valuesWithContext__item_._ext = []
    ____ContentChange_attributeChanges_replace__item__valuesWithContext._cont = _____ContentChange_attributeChanges_replace__item__valuesWithContext__item_
    ____ContentChange_attributeChanges_replace__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___ContentChange_attributeChanges_replace__item_._cont = ASN1Dict([
        (u'type', ____ContentChange_attributeChanges_replace__item__type),
        (u'values', ____ContentChange_attributeChanges_replace__item__values),
        (u'valuesWithContext', ____ContentChange_attributeChanges_replace__item__valuesWithContext),
        ])
    ___ContentChange_attributeChanges_replace__item_._ext = []
    __ContentChange_attributeChanges_replace._cont = ___ContentChange_attributeChanges_replace__item_
    __ContentChange_attributeChanges_replace._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ContentChange_attributeChanges_changes = SEQ_OF(name=u'changes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ContentChange_attributeChanges_changes__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'EntryModification')))
    __ContentChange_attributeChanges_changes._cont = ___ContentChange_attributeChanges_changes__item_
    __ContentChange_attributeChanges_changes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ContentChange_attributeChanges._cont = ASN1Dict([
        (u'replace', __ContentChange_attributeChanges_replace),
        (u'changes', __ContentChange_attributeChanges_changes),
        ])
    _ContentChange_attributeChanges._ext = None
    _ContentChange_sDSEType = BIT_STR(name=u'sDSEType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'SDSEType')))
    _ContentChange_subComplete = BOOL(name=u'subComplete', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ContentChange_attComplete = BOOL(name=u'attComplete', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ContentChange_attValIncomplete = SET_OF(name=u'attValIncomplete', mode=MODE_TYPE, default=[])
    __ContentChange_attValIncomplete__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _ContentChange_attValIncomplete._cont = __ContentChange_attValIncomplete__item_
    ContentChange._cont = ASN1Dict([
        (u'rename', _ContentChange_rename),
        (u'attributeChanges', _ContentChange_attributeChanges),
        (u'sDSEType', _ContentChange_sDSEType),
        (u'subComplete', _ContentChange_subComplete),
        (u'attComplete', _ContentChange_attComplete),
        (u'attValIncomplete', _ContentChange_attValIncomplete),
        ])
    ContentChange._ext = []
    
    #-----< SubordinateChanges >-----#
    SubordinateChanges = SEQ(name=u'SubordinateChanges', mode=MODE_TYPE)
    _SubordinateChanges_subordinate = SET_OF(name=u'subordinate', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _SubordinateChanges_changes = SEQ(name=u'changes', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'IncrementalStepRefresh')))
    SubordinateChanges._cont = ASN1Dict([
        (u'subordinate', _SubordinateChanges_subordinate),
        (u'changes', _SubordinateChanges_changes),
        ])
    SubordinateChanges._ext = []
    
    #-----< shadowError >-----#
    shadowError = CLASS(name=u'shadowError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _shadowError_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __shadowError_val_ParameterType_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    __shadowError_val_ParameterType_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___shadowError_val_ParameterType_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ___shadowError_val_ParameterType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___shadowError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___shadowError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___shadowError_val_ParameterType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __shadowError_val_ParameterType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___shadowError_val_ParameterType_signed_toBeSigned),
        (u'algorithmIdentifier', ___shadowError_val_ParameterType_signed_algorithmIdentifier),
        (u'signature', ___shadowError_val_ParameterType_signed_signature),
        ])
    __shadowError_val_ParameterType_signed._ext = []
    _shadowError_val_ParameterType._cont = ASN1Dict([
        (u'unsigned', __shadowError_val_ParameterType_unsigned),
        (u'signed', __shadowError_val_ParameterType_signed),
        ])
    _shadowError_val_ParameterType._ext = None
    shadowError._val = dict([(u'ParameterType', _shadowError_val_ParameterType), (u'errorCode', (u'local', 1))])
    
    #-----< ShadowErrorData >-----#
    ShadowErrorData = SEQ(name=u'ShadowErrorData', mode=MODE_TYPE)
    _ShadowErrorData_problem = INT(name=u'problem', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowProblem')))
    _ShadowErrorData_lastUpdate = TIME_GEN(name=u'lastUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'Time')), opt=True)
    _ShadowErrorData_updateWindow = SEQ(name=u'updateWindow', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateWindow')), opt=True)
    _ShadowErrorData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ShadowErrorData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ShadowErrorData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ShadowErrorData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ShadowErrorData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ShadowErrorData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____ShadowErrorData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ShadowErrorData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____ShadowErrorData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ShadowErrorData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____ShadowErrorData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____ShadowErrorData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ShadowErrorData_notification__item__type._const_tab = ____ShadowErrorData_notification__item__type_tab
    ___ShadowErrorData_notification__item__type._const_tab_at = None
    ___ShadowErrorData_notification__item__type._const_tab_id = u'id'
    ___ShadowErrorData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____ShadowErrorData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____ShadowErrorData_notification__item__values__item_._const_tab = ____ShadowErrorData_notification__item__type_tab
    ____ShadowErrorData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____ShadowErrorData_notification__item__values__item_._const_tab_id = u'Type'
    ___ShadowErrorData_notification__item__values._cont = ____ShadowErrorData_notification__item__values__item_
    ___ShadowErrorData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ShadowErrorData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ShadowErrorData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ShadowErrorData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____ShadowErrorData_notification__item__valuesWithContext__item__value._const_tab = ____ShadowErrorData_notification__item__type_tab
    _____ShadowErrorData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____ShadowErrorData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____ShadowErrorData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______ShadowErrorData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ShadowErrorData_notification__item__valuesWithContext__item__contextList._cont = ______ShadowErrorData_notification__item__valuesWithContext__item__contextList__item_
    _____ShadowErrorData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ShadowErrorData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____ShadowErrorData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____ShadowErrorData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ShadowErrorData_notification__item__valuesWithContext__item_._ext = []
    ___ShadowErrorData_notification__item__valuesWithContext._cont = ____ShadowErrorData_notification__item__valuesWithContext__item_
    ___ShadowErrorData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ShadowErrorData_notification__item_._cont = ASN1Dict([
        (u'type', ___ShadowErrorData_notification__item__type),
        (u'values', ___ShadowErrorData_notification__item__values),
        (u'valuesWithContext', ___ShadowErrorData_notification__item__valuesWithContext),
        ])
    __ShadowErrorData_notification__item_._ext = []
    _ShadowErrorData_notification._cont = __ShadowErrorData_notification__item_
    ShadowErrorData._cont = ASN1Dict([
        (u'problem', _ShadowErrorData_problem),
        (u'lastUpdate', _ShadowErrorData_lastUpdate),
        (u'updateWindow', _ShadowErrorData_updateWindow),
        (u'securityParameters', _ShadowErrorData_securityParameters),
        (u'performer', _ShadowErrorData_performer),
        (u'aliasDereferenced', _ShadowErrorData_aliasDereferenced),
        (u'notification', _ShadowErrorData_notification),
        ])
    ShadowErrorData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< ShadowProblem >-----#
    ShadowProblem = INT(name=u'ShadowProblem', mode=MODE_TYPE)
    ShadowProblem._cont = ASN1Dict([(u'invalidAgreementID', 1), (u'inactiveAgreement', 2), (u'invalidInformationReceived', 3), (u'unsupportedStrategy', 4), (u'missedPrevious', 5), (u'fullUpdateRequired', 6), (u'unwillingToPerform', 7), (u'unsuitableTiming', 8), (u'updateAlreadyReceived', 9), (u'invalidSequencing', 10), (u'insufficientResources', 11)])
    
    _all_ = [
        dSAShadowBind,
        _dSAShadowBind_val_ArgumentType,
        _dSAShadowBind_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        shadowOperationalBinding,
        _shadowOperationalBinding_val_Agreement,
        __APPLICATION_CONTEXT_bind_operation_val_ArgumentType,
        __APPLICATION_CONTEXT_bind_operation_val_ResultType,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1,
        ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0,
        ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0,
        ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_1,
        ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_0,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_0,
        ___shadowOperationalBinding_Cooperation_Operations_val_ArgumentType_0_0,
        ___shadowOperationalBinding_Cooperation_Operations_val_ResultType_0_0,
        __shadowOperationalBinding_roleA_val_EstablishParam,
        __shadowOperationalBinding_roleB_val_EstablishParam,
        __shadowOperationalBinding_roleB_val_ModifyParam,
        __ModificationParameter_secondaryShadows__item_,
        _ModificationParameter_secondaryShadows,
        ModificationParameter,
        AgreementID,
        _ShadowingAgreementInfo_shadowSubject,
        _ShadowingAgreementInfo_updateMode,
        _ShadowingAgreementInfo_master,
        _ShadowingAgreementInfo_secondaryShadows,
        ShadowingAgreementInfo,
        _UnitOfReplication_area,
        _UnitOfReplication_attributes,
        _UnitOfReplication_knowledge,
        _UnitOfReplication_subordinates,
        _UnitOfReplication_contextSelection,
        __UnitOfReplication_supplyContexts_allContexts,
        ___UnitOfReplication_supplyContexts_selectedContexts__item_,
        __UnitOfReplication_supplyContexts_selectedContexts,
        _UnitOfReplication_supplyContexts,
        UnitOfReplication,
        _AreaSpecification_contextPrefix,
        _AreaSpecification_replicationArea,
        AreaSpecification,
        _Knowledge_knowledgeType,
        _Knowledge_extendedKnowledge,
        Knowledge,
        _AttributeSelection__item_,
        AttributeSelection,
        _ClassAttributeSelection_class_,
        _ClassAttributeSelection_classAttributes,
        ClassAttributeSelection,
        _ClassAttributes_allAttributes,
        _ClassAttributes_include,
        _ClassAttributes_exclude,
        ClassAttributes,
        _AttributeTypes__item_,
        AttributeTypes,
        _UpdateMode_supplierInitiated,
        _UpdateMode_consumerInitiated,
        UpdateMode,
        _SupplierUpdateMode_onChange,
        _SupplierUpdateMode_scheduled,
        SupplierUpdateMode,
        ConsumerUpdateMode,
        _SchedulingParameters_periodic,
        _SchedulingParameters_othertimes,
        SchedulingParameters,
        _PeriodicStrategy_beginTime,
        _PeriodicStrategy_windowSize,
        _PeriodicStrategy_updateInterval,
        PeriodicStrategy,
        Time,
        All_operations_consumer_initiated,
        _All_operations_consumer_initiated_val_ArgumentType_0,
        _All_operations_consumer_initiated_val_ResultType_0,
        _All_operations_consumer_initiated_val_ArgumentType_1,
        _All_operations_consumer_initiated_val_ResultType_1,
        All_operations_supplier_initiated,
        _All_operations_supplier_initiated_val_ArgumentType_0,
        _All_operations_supplier_initiated_val_ResultType_0,
        _All_operations_supplier_initiated_val_ArgumentType_1,
        _All_operations_supplier_initiated_val_ResultType_1,
        coordinateShadowUpdate,
        _coordinateShadowUpdate_val_ArgumentType,
        _coordinateShadowUpdate_val_ResultType,
        _CoordinateShadowUpdateArgument_unsigned,
        __CoordinateShadowUpdateArgument_signed_toBeSigned,
        ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab,
        ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_algorithm,
        ____CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab,
        ___CoordinateShadowUpdateArgument_signed_algorithmIdentifier_parameters,
        __CoordinateShadowUpdateArgument_signed_algorithmIdentifier,
        __CoordinateShadowUpdateArgument_signed_signature,
        _CoordinateShadowUpdateArgument_signed,
        CoordinateShadowUpdateArgument,
        _CoordinateShadowUpdateArgumentData_agreementID,
        _CoordinateShadowUpdateArgumentData_lastUpdate,
        __CoordinateShadowUpdateArgumentData_updateStrategy_standard,
        __CoordinateShadowUpdateArgumentData_updateStrategy_other,
        _CoordinateShadowUpdateArgumentData_updateStrategy,
        _CoordinateShadowUpdateArgumentData_securityParameters,
        CoordinateShadowUpdateArgumentData,
        _CoordinateShadowUpdateResult_null,
        __CoordinateShadowUpdateResult_information_unsigned,
        ___CoordinateShadowUpdateResult_information_signed_toBeSigned,
        _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_algorithm,
        _____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab,
        ____CoordinateShadowUpdateResult_information_signed_algorithmIdentifier_parameters,
        ___CoordinateShadowUpdateResult_information_signed_algorithmIdentifier,
        ___CoordinateShadowUpdateResult_information_signed_signature,
        __CoordinateShadowUpdateResult_information_signed,
        _CoordinateShadowUpdateResult_information,
        CoordinateShadowUpdateResult,
        _CoordinateShadowUpdateResultData_agreementID,
        _CoordinateShadowUpdateResultData_lastUpdate,
        _CoordinateShadowUpdateResultData_securityParameters,
        _CoordinateShadowUpdateResultData_performer,
        _CoordinateShadowUpdateResultData_aliasDereferenced,
        ____CoordinateShadowUpdateResultData_notification__item__type_tab,
        _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        _____CoordinateShadowUpdateResultData_notification__item__type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        ___CoordinateShadowUpdateResultData_notification__item__type,
        ____CoordinateShadowUpdateResultData_notification__item__values__item_,
        ___CoordinateShadowUpdateResultData_notification__item__values,
        _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__value,
        ______CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item__contextList,
        ____CoordinateShadowUpdateResultData_notification__item__valuesWithContext__item_,
        ___CoordinateShadowUpdateResultData_notification__item__valuesWithContext,
        __CoordinateShadowUpdateResultData_notification__item_,
        _CoordinateShadowUpdateResultData_notification,
        CoordinateShadowUpdateResultData,
        requestShadowUpdate,
        _requestShadowUpdate_val_ArgumentType,
        _requestShadowUpdate_val_ResultType,
        _RequestShadowUpdateArgument_unsigned,
        __RequestShadowUpdateArgument_signed_toBeSigned,
        ____RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm_tab,
        ___RequestShadowUpdateArgument_signed_algorithmIdentifier_algorithm,
        ____RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters_tab,
        ___RequestShadowUpdateArgument_signed_algorithmIdentifier_parameters,
        __RequestShadowUpdateArgument_signed_algorithmIdentifier,
        __RequestShadowUpdateArgument_signed_signature,
        _RequestShadowUpdateArgument_signed,
        RequestShadowUpdateArgument,
        _RequestShadowUpdateArgumentData_agreementID,
        _RequestShadowUpdateArgumentData_lastUpdate,
        __RequestShadowUpdateArgumentData_requestedStrategy_standard,
        __RequestShadowUpdateArgumentData_requestedStrategy_other,
        _RequestShadowUpdateArgumentData_requestedStrategy,
        _RequestShadowUpdateArgumentData_securityParameters,
        RequestShadowUpdateArgumentData,
        _RequestShadowUpdateResult_null,
        __RequestShadowUpdateResult_information_unsigned,
        ___RequestShadowUpdateResult_information_signed_toBeSigned,
        _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_algorithm,
        _____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters_tab,
        ____RequestShadowUpdateResult_information_signed_algorithmIdentifier_parameters,
        ___RequestShadowUpdateResult_information_signed_algorithmIdentifier,
        ___RequestShadowUpdateResult_information_signed_signature,
        __RequestShadowUpdateResult_information_signed,
        _RequestShadowUpdateResult_information,
        RequestShadowUpdateResult,
        _RequestShadowUpdateResultData_agreementID,
        _RequestShadowUpdateResultData_lastUpdate,
        _RequestShadowUpdateResultData_securityParameters,
        _RequestShadowUpdateResultData_performer,
        _RequestShadowUpdateResultData_aliasDereferenced,
        ____RequestShadowUpdateResultData_notification__item__type_tab,
        _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_0,
        _____RequestShadowUpdateResultData_notification__item__type_tab_val_Type_1,
        ___RequestShadowUpdateResultData_notification__item__type,
        ____RequestShadowUpdateResultData_notification__item__values__item_,
        ___RequestShadowUpdateResultData_notification__item__values,
        _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__value,
        ______RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____RequestShadowUpdateResultData_notification__item__valuesWithContext__item__contextList,
        ____RequestShadowUpdateResultData_notification__item__valuesWithContext__item_,
        ___RequestShadowUpdateResultData_notification__item__valuesWithContext,
        __RequestShadowUpdateResultData_notification__item_,
        _RequestShadowUpdateResultData_notification,
        RequestShadowUpdateResultData,
        updateShadow,
        _updateShadow_val_ArgumentType,
        _updateShadow_val_ResultType,
        _UpdateShadowArgument_unsigned,
        __UpdateShadowArgument_signed_toBeSigned,
        ____UpdateShadowArgument_signed_algorithmIdentifier_algorithm_tab,
        ___UpdateShadowArgument_signed_algorithmIdentifier_algorithm,
        ____UpdateShadowArgument_signed_algorithmIdentifier_parameters_tab,
        ___UpdateShadowArgument_signed_algorithmIdentifier_parameters,
        __UpdateShadowArgument_signed_algorithmIdentifier,
        __UpdateShadowArgument_signed_signature,
        _UpdateShadowArgument_signed,
        UpdateShadowArgument,
        _UpdateShadowArgumentData_agreementID,
        _UpdateShadowArgumentData_updateTime,
        _UpdateShadowArgumentData_updateWindow,
        _UpdateShadowArgumentData_updatedInfo,
        _UpdateShadowArgumentData_securityParameters,
        UpdateShadowArgumentData,
        _UpdateShadowResult_null,
        __UpdateShadowResult_information_unsigned,
        ___UpdateShadowResult_information_signed_toBeSigned,
        _____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm_tab,
        ____UpdateShadowResult_information_signed_algorithmIdentifier_algorithm,
        _____UpdateShadowResult_information_signed_algorithmIdentifier_parameters_tab,
        ____UpdateShadowResult_information_signed_algorithmIdentifier_parameters,
        ___UpdateShadowResult_information_signed_algorithmIdentifier,
        ___UpdateShadowResult_information_signed_signature,
        __UpdateShadowResult_information_signed,
        _UpdateShadowResult_information,
        UpdateShadowResult,
        _UpdateShadowResultData_agreementID,
        _UpdateShadowResultData_lastUpdate,
        _UpdateShadowResultData_securityParameters,
        _UpdateShadowResultData_performer,
        _UpdateShadowResultData_aliasDereferenced,
        ____UpdateShadowResultData_notification__item__type_tab,
        _____UpdateShadowResultData_notification__item__type_tab_val_Type_0,
        _____UpdateShadowResultData_notification__item__type_tab_val_Type_1,
        ___UpdateShadowResultData_notification__item__type,
        ____UpdateShadowResultData_notification__item__values__item_,
        ___UpdateShadowResultData_notification__item__values,
        _____UpdateShadowResultData_notification__item__valuesWithContext__item__value,
        ______UpdateShadowResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____UpdateShadowResultData_notification__item__valuesWithContext__item__contextList,
        ____UpdateShadowResultData_notification__item__valuesWithContext__item_,
        ___UpdateShadowResultData_notification__item__valuesWithContext,
        __UpdateShadowResultData_notification__item_,
        _UpdateShadowResultData_notification,
        UpdateShadowResultData,
        _UpdateWindow_start,
        _UpdateWindow_stop,
        UpdateWindow,
        _RefreshInformation_noRefresh,
        _RefreshInformation_total,
        _RefreshInformation_incremental,
        _RefreshInformation_otherStrategy,
        RefreshInformation,
        _TotalRefresh_sDSE,
        __TotalRefresh_subtree__item_,
        _TotalRefresh_subtree,
        TotalRefresh,
        _SDSEContent_sDSEType,
        _SDSEContent_subComplete,
        _SDSEContent_attComplete,
        ____SDSEContent_attributes__item__type_tab,
        _____SDSEContent_attributes__item__type_tab_val_Type_0,
        _____SDSEContent_attributes__item__type_tab_val_Type_1,
        ___SDSEContent_attributes__item__type,
        ____SDSEContent_attributes__item__values__item_,
        ___SDSEContent_attributes__item__values,
        _____SDSEContent_attributes__item__valuesWithContext__item__value,
        ______SDSEContent_attributes__item__valuesWithContext__item__contextList__item_,
        _____SDSEContent_attributes__item__valuesWithContext__item__contextList,
        ____SDSEContent_attributes__item__valuesWithContext__item_,
        ___SDSEContent_attributes__item__valuesWithContext,
        __SDSEContent_attributes__item_,
        _SDSEContent_attributes,
        __SDSEContent_attValIncomplete__item_,
        _SDSEContent_attValIncomplete,
        SDSEContent,
        SDSEType,
        _Subtree_rdn,
        _Subtree_sDSE,
        __Subtree_subtree__item_,
        _Subtree_subtree,
        Subtree,
        _IncrementalRefresh__item_,
        IncrementalRefresh,
        __IncrementalStepRefresh_sDSEChanges_add,
        __IncrementalStepRefresh_sDSEChanges_remove,
        __IncrementalStepRefresh_sDSEChanges_modify,
        _IncrementalStepRefresh_sDSEChanges,
        __IncrementalStepRefresh_subordinateUpdates__item_,
        _IncrementalStepRefresh_subordinateUpdates,
        IncrementalStepRefresh,
        __ContentChange_rename_newRDN,
        __ContentChange_rename_newDN,
        _ContentChange_rename,
        _____ContentChange_attributeChanges_replace__item__type_tab,
        ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_0,
        ______ContentChange_attributeChanges_replace__item__type_tab_val_Type_1,
        ____ContentChange_attributeChanges_replace__item__type,
        _____ContentChange_attributeChanges_replace__item__values__item_,
        ____ContentChange_attributeChanges_replace__item__values,
        ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__value,
        _______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList__item_,
        ______ContentChange_attributeChanges_replace__item__valuesWithContext__item__contextList,
        _____ContentChange_attributeChanges_replace__item__valuesWithContext__item_,
        ____ContentChange_attributeChanges_replace__item__valuesWithContext,
        ___ContentChange_attributeChanges_replace__item_,
        __ContentChange_attributeChanges_replace,
        ___ContentChange_attributeChanges_changes__item_,
        __ContentChange_attributeChanges_changes,
        _ContentChange_attributeChanges,
        _ContentChange_sDSEType,
        _ContentChange_subComplete,
        _ContentChange_attComplete,
        __ContentChange_attValIncomplete__item_,
        _ContentChange_attValIncomplete,
        ContentChange,
        _SubordinateChanges_subordinate,
        _SubordinateChanges_changes,
        SubordinateChanges,
        shadowError,
        __shadowError_val_ParameterType_unsigned,
        ___shadowError_val_ParameterType_signed_toBeSigned,
        _____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____shadowError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____shadowError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___shadowError_val_ParameterType_signed_algorithmIdentifier,
        ___shadowError_val_ParameterType_signed_signature,
        __shadowError_val_ParameterType_signed,
        _shadowError_val_ParameterType,
        _ShadowErrorData_problem,
        _ShadowErrorData_lastUpdate,
        _ShadowErrorData_updateWindow,
        _ShadowErrorData_securityParameters,
        _ShadowErrorData_performer,
        _ShadowErrorData_aliasDereferenced,
        ____ShadowErrorData_notification__item__type_tab,
        _____ShadowErrorData_notification__item__type_tab_val_Type_0,
        _____ShadowErrorData_notification__item__type_tab_val_Type_1,
        ___ShadowErrorData_notification__item__type,
        ____ShadowErrorData_notification__item__values__item_,
        ___ShadowErrorData_notification__item__values,
        _____ShadowErrorData_notification__item__valuesWithContext__item__value,
        ______ShadowErrorData_notification__item__valuesWithContext__item__contextList__item_,
        _____ShadowErrorData_notification__item__valuesWithContext__item__contextList,
        ____ShadowErrorData_notification__item__valuesWithContext__item_,
        ___ShadowErrorData_notification__item__valuesWithContext,
        __ShadowErrorData_notification__item_,
        _ShadowErrorData_notification,
        ShadowErrorData,
        ShadowProblem,
    ]

class DistributedOperations:

    _name_  = u'DistributedOperations'
    _oid_   = [2, 5, 1, 3, 8]
    
    _obj_ = [
        u'dsaReferral',
        u'DsaReferralData',
        u'ChainingArguments',
        u'Time',
        u'DomainInfo',
        u'ChainingResults',
        u'CrossReference',
        u'OperationProgress',
        u'TraceInformation',
        u'TraceItem',
        u'ReferenceType',
        u'AccessPoint',
        u'MasterOrShadowAccessPoint',
        u'MasterAndShadowAccessPoints',
        u'AccessPointInformation',
        u'DitBridgeKnowledge',
        u'Exclusions',
        u'ContinuationReference',
        u'dSABind',
        u'DSABindArgument',
        u'DSACredentials',
        u'DSABindResult',
        u'chained',
        u'chainedRead',
        u'chainedCompare',
        u'chainedAbandon',
        u'chainedList',
        u'chainedSearch',
        u'chainedAddEntry',
        u'chainedRemoveEntry',
        u'chainedModifyEntry',
        u'chainedModifyDN',
        u'chainedChangePassword',
        u'chainedAdministerPassword',
        u'chainedLdapTransport',
        u'chainedLinkedLDAP',
        ]
    _type_ = [
        u'DsaReferralData',
        u'ChainingArguments',
        u'Time',
        u'DomainInfo',
        u'ChainingResults',
        u'CrossReference',
        u'OperationProgress',
        u'TraceInformation',
        u'TraceItem',
        u'ReferenceType',
        u'AccessPoint',
        u'MasterOrShadowAccessPoint',
        u'MasterAndShadowAccessPoints',
        u'AccessPointInformation',
        u'DitBridgeKnowledge',
        u'Exclusions',
        u'ContinuationReference',
        u'DSABindArgument',
        u'DSACredentials',
        u'DSABindResult',
        ]
    _set_ = [
        ]
    _val_ = [
        u'dsaReferral',
        u'dSABind',
        u'chained',
        u'chainedRead',
        u'chainedCompare',
        u'chainedAbandon',
        u'chainedList',
        u'chainedSearch',
        u'chainedAddEntry',
        u'chainedRemoveEntry',
        u'chainedModifyEntry',
        u'chainedModifyDN',
        u'chainedChangePassword',
        u'chainedAdministerPassword',
        u'chainedLdapTransport',
        u'chainedLinkedLDAP',
        ]
    _class_ = [
        u'dsaReferral',
        u'dSABind',
        u'chained',
        u'chainedRead',
        u'chainedCompare',
        u'chainedAbandon',
        u'chainedList',
        u'chainedSearch',
        u'chainedAddEntry',
        u'chainedRemoveEntry',
        u'chainedModifyEntry',
        u'chainedModifyDN',
        u'chainedChangePassword',
        u'chainedAdministerPassword',
        u'chainedLdapTransport',
        u'chainedLinkedLDAP',
        ]
    _param_ = [
        u'chained',
        ]
    
    #-----< dsaReferral >-----#
    dsaReferral = CLASS(name=u'dsaReferral', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _dsaReferral_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __dsaReferral_val_ParameterType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    __dsaReferral_val_ParameterType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___dsaReferral_val_ParameterType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ___dsaReferral_val_ParameterType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___dsaReferral_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___dsaReferral_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___dsaReferral_val_ParameterType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __dsaReferral_val_ParameterType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___dsaReferral_val_ParameterType_signed_toBeSigned),
        (u'algorithmIdentifier', ___dsaReferral_val_ParameterType_signed_algorithmIdentifier),
        (u'signature', ___dsaReferral_val_ParameterType_signed_signature),
        ])
    __dsaReferral_val_ParameterType_signed._ext = []
    _dsaReferral_val_ParameterType._cont = ASN1Dict([
        (u'unsigned', __dsaReferral_val_ParameterType_unsigned),
        (u'signed', __dsaReferral_val_ParameterType_signed),
        ])
    _dsaReferral_val_ParameterType._ext = None
    dsaReferral._val = dict([(u'ParameterType', _dsaReferral_val_ParameterType), (u'errorCode', (u'local', 9))])
    
    #-----< DsaReferralData >-----#
    DsaReferralData = SET(name=u'DsaReferralData', mode=MODE_TYPE)
    _DsaReferralData_reference = SET(name=u'reference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ContinuationReference')))
    _DsaReferralData_contextPrefix = SEQ_OF(name=u'contextPrefix', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _DsaReferralData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _DsaReferralData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _DsaReferralData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _DsaReferralData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DsaReferralData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___DsaReferralData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____DsaReferralData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____DsaReferralData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    _____DsaReferralData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____DsaReferralData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____DsaReferralData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____DsaReferralData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___DsaReferralData_notification__item__type._const_tab = ____DsaReferralData_notification__item__type_tab
    ___DsaReferralData_notification__item__type._const_tab_at = None
    ___DsaReferralData_notification__item__type._const_tab_id = u'id'
    ___DsaReferralData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____DsaReferralData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____DsaReferralData_notification__item__values__item_._const_tab = ____DsaReferralData_notification__item__type_tab
    ____DsaReferralData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____DsaReferralData_notification__item__values__item_._const_tab_id = u'Type'
    ___DsaReferralData_notification__item__values._cont = ____DsaReferralData_notification__item__values__item_
    ___DsaReferralData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___DsaReferralData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____DsaReferralData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____DsaReferralData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____DsaReferralData_notification__item__valuesWithContext__item__value._const_tab = ____DsaReferralData_notification__item__type_tab
    _____DsaReferralData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____DsaReferralData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____DsaReferralData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______DsaReferralData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____DsaReferralData_notification__item__valuesWithContext__item__contextList._cont = ______DsaReferralData_notification__item__valuesWithContext__item__contextList__item_
    _____DsaReferralData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____DsaReferralData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____DsaReferralData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____DsaReferralData_notification__item__valuesWithContext__item__contextList),
        ])
    ____DsaReferralData_notification__item__valuesWithContext__item_._ext = []
    ___DsaReferralData_notification__item__valuesWithContext._cont = ____DsaReferralData_notification__item__valuesWithContext__item_
    ___DsaReferralData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __DsaReferralData_notification__item_._cont = ASN1Dict([
        (u'type', ___DsaReferralData_notification__item__type),
        (u'values', ___DsaReferralData_notification__item__values),
        (u'valuesWithContext', ___DsaReferralData_notification__item__valuesWithContext),
        ])
    __DsaReferralData_notification__item_._ext = []
    _DsaReferralData_notification._cont = __DsaReferralData_notification__item_
    DsaReferralData._cont = ASN1Dict([
        (u'reference', _DsaReferralData_reference),
        (u'contextPrefix', _DsaReferralData_contextPrefix),
        (u'securityParameters', _DsaReferralData_securityParameters),
        (u'performer', _DsaReferralData_performer),
        (u'aliasDereferenced', _DsaReferralData_aliasDereferenced),
        (u'notification', _DsaReferralData_notification),
        ])
    DsaReferralData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< ChainingArguments >-----#
    ChainingArguments = SET(name=u'ChainingArguments', mode=MODE_TYPE)
    _ChainingArguments_originator = SEQ_OF(name=u'originator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ChainingArguments_targetObject = SEQ_OF(name=u'targetObject', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ChainingArguments_operationProgress = SET(name=u'operationProgress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')), default=dict([(u'nameResolutionPhase', u'notStarted')]))
    _ChainingArguments_traceInformation = SEQ_OF(name=u'traceInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'TraceInformation')))
    _ChainingArguments_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_aliasedRDNs = INT(name=u'aliasedRDNs', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ChainingArguments_returnCrossRefs = BOOL(name=u'returnCrossRefs', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_referenceType = ENUM(name=u'referenceType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')), default=u'superior')
    _ChainingArguments_info = OPEN(name=u'info', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'DomainInfo')), opt=True)
    _ChainingArguments_timeLimit = CHOICE(name=u'timeLimit', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Time')), opt=True)
    _ChainingArguments_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), default=dict([]))
    _ChainingArguments_entryOnly = BOOL(name=u'entryOnly', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_uniqueIdentifier = BIT_STR(name=u'uniqueIdentifier', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True)
    _ChainingArguments_authenticationLevel = CHOICE(name=u'authenticationLevel', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('BasicAccessControl', 'AuthenticationLevel')), opt=True)
    _ChainingArguments_exclusions = SET_OF(name=u'exclusions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ChainingArguments_excludeShadows = BOOL(name=u'excludeShadows', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_nameResolveOnMaster = BOOL(name=u'nameResolveOnMaster', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_operationIdentifier = INT(name=u'operationIdentifier', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ChainingArguments_searchRuleId = SEQ(name=u'searchRuleId', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'SearchRuleId')), opt=True)
    _ChainingArguments_chainedRelaxation = SEQ(name=u'chainedRelaxation', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'MRMapping')), opt=True)
    _ChainingArguments_relatedEntry = INT(name=u'relatedEntry', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ChainingArguments_dspPaging = BOOL(name=u'dspPaging', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ChainingArguments_excludeWriteableCopies = BOOL(name=u'excludeWriteableCopies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    ChainingArguments._cont = ASN1Dict([
        (u'originator', _ChainingArguments_originator),
        (u'targetObject', _ChainingArguments_targetObject),
        (u'operationProgress', _ChainingArguments_operationProgress),
        (u'traceInformation', _ChainingArguments_traceInformation),
        (u'aliasDereferenced', _ChainingArguments_aliasDereferenced),
        (u'aliasedRDNs', _ChainingArguments_aliasedRDNs),
        (u'returnCrossRefs', _ChainingArguments_returnCrossRefs),
        (u'referenceType', _ChainingArguments_referenceType),
        (u'info', _ChainingArguments_info),
        (u'timeLimit', _ChainingArguments_timeLimit),
        (u'securityParameters', _ChainingArguments_securityParameters),
        (u'entryOnly', _ChainingArguments_entryOnly),
        (u'uniqueIdentifier', _ChainingArguments_uniqueIdentifier),
        (u'authenticationLevel', _ChainingArguments_authenticationLevel),
        (u'exclusions', _ChainingArguments_exclusions),
        (u'excludeShadows', _ChainingArguments_excludeShadows),
        (u'nameResolveOnMaster', _ChainingArguments_nameResolveOnMaster),
        (u'operationIdentifier', _ChainingArguments_operationIdentifier),
        (u'searchRuleId', _ChainingArguments_searchRuleId),
        (u'chainedRelaxation', _ChainingArguments_chainedRelaxation),
        (u'relatedEntry', _ChainingArguments_relatedEntry),
        (u'dspPaging', _ChainingArguments_dspPaging),
        (u'excludeWriteableCopies', _ChainingArguments_excludeWriteableCopies),
        ])
    ChainingArguments._ext = []
    
    #-----< Time >-----#
    Time = CHOICE(name=u'Time', mode=MODE_TYPE)
    _Time_utcTime = TIME_UTC(name=u'utcTime', mode=MODE_TYPE)
    _Time_generalizedTime = TIME_GEN(name=u'generalizedTime', mode=MODE_TYPE)
    Time._cont = ASN1Dict([
        (u'utcTime', _Time_utcTime),
        (u'generalizedTime', _Time_generalizedTime),
        ])
    Time._ext = []
    
    #-----< DomainInfo >-----#
    DomainInfo = OPEN(name=u'DomainInfo', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    
    #-----< ChainingResults >-----#
    ChainingResults = SET(name=u'ChainingResults', mode=MODE_TYPE)
    _ChainingResults_info = OPEN(name=u'info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'DomainInfo')), opt=True)
    _ChainingResults_crossReferences = SEQ_OF(name=u'crossReferences', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ChainingResults_crossReferences__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'CrossReference')))
    _ChainingResults_crossReferences._cont = __ChainingResults_crossReferences__item_
    _ChainingResults_crossReferences._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ChainingResults_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), default=dict([]))
    _ChainingResults_alreadySearched = SET_OF(name=u'alreadySearched', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    ChainingResults._cont = ASN1Dict([
        (u'info', _ChainingResults_info),
        (u'crossReferences', _ChainingResults_crossReferences),
        (u'securityParameters', _ChainingResults_securityParameters),
        (u'alreadySearched', _ChainingResults_alreadySearched),
        ])
    ChainingResults._ext = []
    
    #-----< CrossReference >-----#
    CrossReference = SET(name=u'CrossReference', mode=MODE_TYPE)
    _CrossReference_contextPrefix = SEQ_OF(name=u'contextPrefix', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _CrossReference_accessPoint = SET(name=u'accessPoint', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPointInformation')))
    CrossReference._cont = ASN1Dict([
        (u'contextPrefix', _CrossReference_contextPrefix),
        (u'accessPoint', _CrossReference_accessPoint),
        ])
    CrossReference._ext = []
    
    #-----< OperationProgress >-----#
    OperationProgress = SET(name=u'OperationProgress', mode=MODE_TYPE)
    _OperationProgress_nameResolutionPhase = ENUM(name=u'nameResolutionPhase', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _OperationProgress_nameResolutionPhase._cont = ASN1Dict([(u'notStarted', 1), (u'proceeding', 2), (u'completed', 3)])
    _OperationProgress_nameResolutionPhase._ext = []
    _OperationProgress_nextRDNToBeResolved = INT(name=u'nextRDNToBeResolved', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    OperationProgress._cont = ASN1Dict([
        (u'nameResolutionPhase', _OperationProgress_nameResolutionPhase),
        (u'nextRDNToBeResolved', _OperationProgress_nextRDNToBeResolved),
        ])
    OperationProgress._ext = []
    
    #-----< TraceInformation >-----#
    TraceInformation = SEQ_OF(name=u'TraceInformation', mode=MODE_TYPE)
    _TraceInformation__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'TraceItem')))
    TraceInformation._cont = _TraceInformation__item_
    
    #-----< TraceItem >-----#
    TraceItem = SET(name=u'TraceItem', mode=MODE_TYPE)
    _TraceItem_dsa = CHOICE(name=u'dsa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _TraceItem_targetObject = CHOICE(name=u'targetObject', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _TraceItem_operationProgress = SET(name=u'operationProgress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')))
    TraceItem._cont = ASN1Dict([
        (u'dsa', _TraceItem_dsa),
        (u'targetObject', _TraceItem_targetObject),
        (u'operationProgress', _TraceItem_operationProgress),
        ])
    TraceItem._ext = []
    
    #-----< ReferenceType >-----#
    ReferenceType = ENUM(name=u'ReferenceType', mode=MODE_TYPE)
    ReferenceType._cont = ASN1Dict([(u'superior', 1), (u'subordinate', 2), (u'cross', 3), (u'nonSpecificSubordinate', 4), (u'supplier', 5), (u'master', 6), (u'immediateSuperior', 7), (u'self', 8), (u'ditBridge', 9)])
    ReferenceType._ext = []
    
    #-----< AccessPoint >-----#
    AccessPoint = SET(name=u'AccessPoint', mode=MODE_TYPE)
    _AccessPoint_ae_title = CHOICE(name=u'ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _AccessPoint_address = SEQ(name=u'address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _AccessPoint_protocolInformation = SET_OF(name=u'protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AccessPoint_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _AccessPoint_protocolInformation._cont = __AccessPoint_protocolInformation__item_
    _AccessPoint_protocolInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    AccessPoint._cont = ASN1Dict([
        (u'ae-title', _AccessPoint_ae_title),
        (u'address', _AccessPoint_address),
        (u'protocolInformation', _AccessPoint_protocolInformation),
        ])
    AccessPoint._ext = []
    
    #-----< MasterOrShadowAccessPoint >-----#
    MasterOrShadowAccessPoint = SET(name=u'MasterOrShadowAccessPoint', mode=MODE_TYPE)
    _MasterOrShadowAccessPoint_ae_title = CHOICE(name=u'ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _MasterOrShadowAccessPoint_address = SEQ(name=u'address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _MasterOrShadowAccessPoint_protocolInformation = SET_OF(name=u'protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __MasterOrShadowAccessPoint_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _MasterOrShadowAccessPoint_protocolInformation._cont = __MasterOrShadowAccessPoint_protocolInformation__item_
    _MasterOrShadowAccessPoint_category = ENUM(name=u'category', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=u'master')
    _MasterOrShadowAccessPoint_category._cont = ASN1Dict([(u'master', 0), (u'shadow', 1), (u'writeableCopy', 2)])
    _MasterOrShadowAccessPoint_category._ext = []
    _MasterOrShadowAccessPoint_chainingRequired = BOOL(name=u'chainingRequired', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    MasterOrShadowAccessPoint._cont = ASN1Dict([
        (u'ae-title', _MasterOrShadowAccessPoint_ae_title),
        (u'address', _MasterOrShadowAccessPoint_address),
        (u'protocolInformation', _MasterOrShadowAccessPoint_protocolInformation),
        (u'category', _MasterOrShadowAccessPoint_category),
        (u'chainingRequired', _MasterOrShadowAccessPoint_chainingRequired),
        ])
    MasterOrShadowAccessPoint._ext = []
    
    #-----< MasterAndShadowAccessPoints >-----#
    MasterAndShadowAccessPoints = SET_OF(name=u'MasterAndShadowAccessPoints', mode=MODE_TYPE)
    _MasterAndShadowAccessPoints__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'MasterOrShadowAccessPoint')))
    MasterAndShadowAccessPoints._cont = _MasterAndShadowAccessPoints__item_
    MasterAndShadowAccessPoints._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AccessPointInformation >-----#
    AccessPointInformation = SET(name=u'AccessPointInformation', mode=MODE_TYPE)
    _AccessPointInformation_ae_title = CHOICE(name=u'ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _AccessPointInformation_address = SEQ(name=u'address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _AccessPointInformation_protocolInformation = SET_OF(name=u'protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __AccessPointInformation_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _AccessPointInformation_protocolInformation._cont = __AccessPointInformation_protocolInformation__item_
    _AccessPointInformation_category = ENUM(name=u'category', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=u'master')
    _AccessPointInformation_category._cont = ASN1Dict([(u'master', 0), (u'shadow', 1), (u'writeableCopy', 2)])
    _AccessPointInformation_category._ext = []
    _AccessPointInformation_chainingRequired = BOOL(name=u'chainingRequired', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AccessPointInformation_additionalPoints = SET_OF(name=u'additionalPoints', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')), opt=True)
    AccessPointInformation._cont = ASN1Dict([
        (u'ae-title', _AccessPointInformation_ae_title),
        (u'address', _AccessPointInformation_address),
        (u'protocolInformation', _AccessPointInformation_protocolInformation),
        (u'category', _AccessPointInformation_category),
        (u'chainingRequired', _AccessPointInformation_chainingRequired),
        (u'additionalPoints', _AccessPointInformation_additionalPoints),
        ])
    AccessPointInformation._ext = []
    
    #-----< DitBridgeKnowledge >-----#
    DitBridgeKnowledge = SEQ(name=u'DitBridgeKnowledge', mode=MODE_TYPE)
    _DitBridgeKnowledge_domainLocalID = CHOICE(name=u'domainLocalID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _DitBridgeKnowledge_accessPoints = SET_OF(name=u'accessPoints', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')))
    DitBridgeKnowledge._cont = ASN1Dict([
        (u'domainLocalID', _DitBridgeKnowledge_domainLocalID),
        (u'accessPoints', _DitBridgeKnowledge_accessPoints),
        ])
    DitBridgeKnowledge._ext = []
    
    #-----< Exclusions >-----#
    Exclusions = SET_OF(name=u'Exclusions', mode=MODE_TYPE)
    _Exclusions__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RDNSequence')))
    Exclusions._cont = _Exclusions__item_
    Exclusions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< ContinuationReference >-----#
    ContinuationReference = SET(name=u'ContinuationReference', mode=MODE_TYPE)
    _ContinuationReference_targetObject = CHOICE(name=u'targetObject', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _ContinuationReference_aliasedRDNs = INT(name=u'aliasedRDNs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ContinuationReference_operationProgress = SET(name=u'operationProgress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'OperationProgress')))
    _ContinuationReference_rdnsResolved = INT(name=u'rdnsResolved', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _ContinuationReference_referenceType = ENUM(name=u'referenceType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'ReferenceType')))
    _ContinuationReference_accessPoints = SET_OF(name=u'accessPoints', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ContinuationReference_accessPoints__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'AccessPointInformation')))
    _ContinuationReference_accessPoints._cont = __ContinuationReference_accessPoints__item_
    _ContinuationReference_entryOnly = BOOL(name=u'entryOnly', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ContinuationReference_exclusions = SET_OF(name=u'exclusions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'Exclusions')), opt=True)
    _ContinuationReference_returnToDUA = BOOL(name=u'returnToDUA', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ContinuationReference_nameResolveOnMaster = BOOL(name=u'nameResolveOnMaster', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    ContinuationReference._cont = ASN1Dict([
        (u'targetObject', _ContinuationReference_targetObject),
        (u'aliasedRDNs', _ContinuationReference_aliasedRDNs),
        (u'operationProgress', _ContinuationReference_operationProgress),
        (u'rdnsResolved', _ContinuationReference_rdnsResolved),
        (u'referenceType', _ContinuationReference_referenceType),
        (u'accessPoints', _ContinuationReference_accessPoints),
        (u'entryOnly', _ContinuationReference_entryOnly),
        (u'exclusions', _ContinuationReference_exclusions),
        (u'returnToDUA', _ContinuationReference_returnToDUA),
        (u'nameResolveOnMaster', _ContinuationReference_nameResolveOnMaster),
        ])
    ContinuationReference._ext = []
    
    #-----< dSABind >-----#
    dSABind = CLASS(name=u'dSABind', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _dSABind_val_ArgumentType = SET(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    _dSABind_val_ResultType = SET(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_unsigned_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error = CHOICE(name=u'error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError = INT(name=u'serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError = INT(name=u'securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._cont = ASN1Dict([
        (u'serviceError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError),
        (u'securityError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_unsigned._cont = ASN1Dict([
        (u'versions', ____OPERATION_Errors_val_ParameterType_0_unsigned_versions),
        (u'error', ____OPERATION_Errors_val_ParameterType_0_unsigned_error),
        (u'securityParameters', ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error = CHOICE(name=u'error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError = INT(name=u'serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError = INT(name=u'securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._cont = ASN1Dict([
        (u'serviceError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError),
        (u'securityError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._cont = ASN1Dict([
        (u'versions', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions),
        (u'error', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error),
        (u'securityParameters', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    dSABind._val = dict([(u'ArgumentType', _dSABind_val_ArgumentType), (u'ResultType', _dSABind_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])
    
    #-----< DSABindArgument >-----#
    DSABindArgument = SET(name=u'DSABindArgument', mode=MODE_TYPE)
    _DSABindArgument_credentials = CHOICE(name=u'credentials', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'DSACredentials')), opt=True)
    _DSABindArgument_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    DSABindArgument._cont = ASN1Dict([
        (u'credentials', _DSABindArgument_credentials),
        (u'versions', _DSABindArgument_versions),
        ])
    DSABindArgument._ext = []
    
    #-----< DSACredentials >-----#
    DSACredentials = CHOICE(name=u'DSACredentials', mode=MODE_TYPE)
    _DSACredentials_simple = SEQ(name=u'simple', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SimpleCredentials')))
    _DSACredentials_strong = SET(name=u'strong', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'StrongCredentials')))
    _DSACredentials_externalProcedure = EXT(name=u'externalProcedure', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _DSACredentials_spkm = CHOICE(name=u'spkm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SpkmCredentials')))
    DSACredentials._cont = ASN1Dict([
        (u'simple', _DSACredentials_simple),
        (u'strong', _DSACredentials_strong),
        (u'externalProcedure', _DSACredentials_externalProcedure),
        (u'spkm', _DSACredentials_spkm),
        ])
    DSACredentials._ext = []
    
    #-----< DSABindResult >-----#
    DSABindResult = SET(name=u'DSABindResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    
    #-----< chained >-----#
    chained = CLASS(name=u'chained', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')), param=True)
    
    #-----< chainedRead >-----#
    chainedRead = CLASS(name=u'chainedRead', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedRead_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedRead_val_ArgumentType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedRead_val_ArgumentType_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedRead_val_ArgumentType_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    __chainedRead_val_ArgumentType_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ___chainedRead_val_ArgumentType_unsigned_chainedArgument),
        (u'argument', ___chainedRead_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedRead_val_ArgumentType_unsigned._ext = None
    __chainedRead_val_ArgumentType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedRead_val_ArgumentType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedRead_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedRead_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ___chainedRead_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', ____chainedRead_val_ArgumentType_signed_toBeSigned_chainedArgument),
        (u'argument', ____chainedRead_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedRead_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedRead_val_ArgumentType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedRead_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedRead_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedRead_val_ArgumentType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedRead_val_ArgumentType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedRead_val_ArgumentType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedRead_val_ArgumentType_signed_algorithmIdentifier),
        (u'signature', ___chainedRead_val_ArgumentType_signed_signature),
        ])
    __chainedRead_val_ArgumentType_signed._ext = []
    _chainedRead_val_ArgumentType._cont = ASN1Dict([
        (u'unsigned', __chainedRead_val_ArgumentType_unsigned),
        (u'signed', __chainedRead_val_ArgumentType_signed),
        ])
    _chainedRead_val_ArgumentType._ext = None
    _chainedRead_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedRead_val_ResultType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedRead_val_ResultType_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedRead_val_ResultType_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    __chainedRead_val_ResultType_unsigned._cont = ASN1Dict([
        (u'chainedResult', ___chainedRead_val_ResultType_unsigned_chainedResult),
        (u'result', ___chainedRead_val_ResultType_unsigned_ResultType),
        ])
    __chainedRead_val_ResultType_unsigned._ext = None
    __chainedRead_val_ResultType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedRead_val_ResultType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedRead_val_ResultType_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedRead_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ___chainedRead_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', ____chainedRead_val_ResultType_signed_toBeSigned_chainedResult),
        (u'result', ____chainedRead_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedRead_val_ResultType_signed_toBeSigned._ext = None
    ___chainedRead_val_ResultType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedRead_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedRead_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedRead_val_ResultType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedRead_val_ResultType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedRead_val_ResultType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedRead_val_ResultType_signed_algorithmIdentifier),
        (u'signature', ___chainedRead_val_ResultType_signed_signature),
        ])
    __chainedRead_val_ResultType_signed._ext = []
    _chainedRead_val_ResultType._cont = ASN1Dict([
        (u'unsigned', __chainedRead_val_ResultType_unsigned),
        (u'signed', __chainedRead_val_ResultType_signed),
        ])
    _chainedRead_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_Errors_val_ParameterType_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    __OPERATION_Errors_val_ParameterType_3 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_3_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_Errors_val_ParameterType_4 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_4_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Errors_val_ParameterType_5 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_5_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_5_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_5_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_6_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_6_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_6_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    chainedRead._val = dict([(u'ArgumentType', _chainedRead_val_ArgumentType), (u'ResultType', _chainedRead_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))])
    
    #-----< chainedCompare >-----#
    chainedCompare = CLASS(name=u'chainedCompare', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedCompare_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedCompare_val_ArgumentType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedCompare_val_ArgumentType_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedCompare_val_ArgumentType_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    __chainedCompare_val_ArgumentType_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ___chainedCompare_val_ArgumentType_unsigned_chainedArgument),
        (u'argument', ___chainedCompare_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedCompare_val_ArgumentType_unsigned._ext = None
    __chainedCompare_val_ArgumentType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedCompare_val_ArgumentType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedCompare_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedCompare_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ___chainedCompare_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', ____chainedCompare_val_ArgumentType_signed_toBeSigned_chainedArgument),
        (u'argument', ____chainedCompare_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedCompare_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedCompare_val_ArgumentType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedCompare_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedCompare_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedCompare_val_ArgumentType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedCompare_val_ArgumentType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedCompare_val_ArgumentType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedCompare_val_ArgumentType_signed_algorithmIdentifier),
        (u'signature', ___chainedCompare_val_ArgumentType_signed_signature),
        ])
    __chainedCompare_val_ArgumentType_signed._ext = []
    _chainedCompare_val_ArgumentType._cont = ASN1Dict([
        (u'unsigned', __chainedCompare_val_ArgumentType_unsigned),
        (u'signed', __chainedCompare_val_ArgumentType_signed),
        ])
    _chainedCompare_val_ArgumentType._ext = None
    _chainedCompare_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedCompare_val_ResultType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedCompare_val_ResultType_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedCompare_val_ResultType_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    __chainedCompare_val_ResultType_unsigned._cont = ASN1Dict([
        (u'chainedResult', ___chainedCompare_val_ResultType_unsigned_chainedResult),
        (u'result', ___chainedCompare_val_ResultType_unsigned_ResultType),
        ])
    __chainedCompare_val_ResultType_unsigned._ext = None
    __chainedCompare_val_ResultType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedCompare_val_ResultType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedCompare_val_ResultType_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedCompare_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ___chainedCompare_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', ____chainedCompare_val_ResultType_signed_toBeSigned_chainedResult),
        (u'result', ____chainedCompare_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedCompare_val_ResultType_signed_toBeSigned._ext = None
    ___chainedCompare_val_ResultType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedCompare_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedCompare_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedCompare_val_ResultType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedCompare_val_ResultType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedCompare_val_ResultType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedCompare_val_ResultType_signed_algorithmIdentifier),
        (u'signature', ___chainedCompare_val_ResultType_signed_signature),
        ])
    __chainedCompare_val_ResultType_signed._ext = []
    _chainedCompare_val_ResultType._cont = ASN1Dict([
        (u'unsigned', __chainedCompare_val_ResultType_unsigned),
        (u'signed', __chainedCompare_val_ResultType_signed),
        ])
    _chainedCompare_val_ResultType._ext = None
    chainedCompare._val = dict([(u'ArgumentType', _chainedCompare_val_ArgumentType), (u'ResultType', _chainedCompare_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])
    
    #-----< chainedAbandon >-----#
    chainedAbandon = CLASS(name=u'chainedAbandon', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedAbandon_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    _chainedAbandon_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __OPERATION_Errors_val_ParameterType_0_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_1._ext = None
    chainedAbandon._val = dict([(u'ArgumentType', _chainedAbandon_val_ArgumentType), (u'ResultType', _chainedAbandon_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])
    
    #-----< chainedList >-----#
    chainedList = CLASS(name=u'chainedList', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedList_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedList_val_ArgumentType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedList_val_ArgumentType_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedList_val_ArgumentType_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    __chainedList_val_ArgumentType_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ___chainedList_val_ArgumentType_unsigned_chainedArgument),
        (u'argument', ___chainedList_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedList_val_ArgumentType_unsigned._ext = None
    __chainedList_val_ArgumentType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedList_val_ArgumentType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedList_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedList_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ___chainedList_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', ____chainedList_val_ArgumentType_signed_toBeSigned_chainedArgument),
        (u'argument', ____chainedList_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedList_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedList_val_ArgumentType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedList_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedList_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedList_val_ArgumentType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedList_val_ArgumentType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedList_val_ArgumentType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedList_val_ArgumentType_signed_algorithmIdentifier),
        (u'signature', ___chainedList_val_ArgumentType_signed_signature),
        ])
    __chainedList_val_ArgumentType_signed._ext = []
    _chainedList_val_ArgumentType._cont = ASN1Dict([
        (u'unsigned', __chainedList_val_ArgumentType_unsigned),
        (u'signed', __chainedList_val_ArgumentType_signed),
        ])
    _chainedList_val_ArgumentType._ext = None
    _chainedList_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedList_val_ResultType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedList_val_ResultType_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedList_val_ResultType_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    __chainedList_val_ResultType_unsigned._cont = ASN1Dict([
        (u'chainedResult', ___chainedList_val_ResultType_unsigned_chainedResult),
        (u'result', ___chainedList_val_ResultType_unsigned_ResultType),
        ])
    __chainedList_val_ResultType_unsigned._ext = None
    __chainedList_val_ResultType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedList_val_ResultType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedList_val_ResultType_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedList_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ___chainedList_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', ____chainedList_val_ResultType_signed_toBeSigned_chainedResult),
        (u'result', ____chainedList_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedList_val_ResultType_signed_toBeSigned._ext = None
    ___chainedList_val_ResultType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedList_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedList_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedList_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedList_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedList_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedList_val_ResultType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedList_val_ResultType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedList_val_ResultType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedList_val_ResultType_signed_algorithmIdentifier),
        (u'signature', ___chainedList_val_ResultType_signed_signature),
        ])
    __chainedList_val_ResultType_signed._ext = []
    _chainedList_val_ResultType._cont = ASN1Dict([
        (u'unsigned', __chainedList_val_ResultType_unsigned),
        (u'signed', __chainedList_val_ResultType_signed),
        ])
    _chainedList_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_1_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_0._ext = None
    __OPERATION_Errors_val_ParameterType_2_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_3_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_3_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_3_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_0._ext = None
    __OPERATION_Errors_val_ParameterType_5_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_5_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_5_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_5_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    chainedList._val = dict([(u'ArgumentType', _chainedList_val_ArgumentType), (u'ResultType', _chainedList_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))])
    
    #-----< chainedSearch >-----#
    chainedSearch = CLASS(name=u'chainedSearch', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedSearch_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedSearch_val_ArgumentType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedSearch_val_ArgumentType_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedSearch_val_ArgumentType_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    __chainedSearch_val_ArgumentType_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ___chainedSearch_val_ArgumentType_unsigned_chainedArgument),
        (u'argument', ___chainedSearch_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedSearch_val_ArgumentType_unsigned._ext = None
    __chainedSearch_val_ArgumentType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedSearch_val_ArgumentType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedSearch_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedSearch_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ___chainedSearch_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', ____chainedSearch_val_ArgumentType_signed_toBeSigned_chainedArgument),
        (u'argument', ____chainedSearch_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedSearch_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedSearch_val_ArgumentType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedSearch_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedSearch_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedSearch_val_ArgumentType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedSearch_val_ArgumentType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedSearch_val_ArgumentType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedSearch_val_ArgumentType_signed_algorithmIdentifier),
        (u'signature', ___chainedSearch_val_ArgumentType_signed_signature),
        ])
    __chainedSearch_val_ArgumentType_signed._ext = []
    _chainedSearch_val_ArgumentType._cont = ASN1Dict([
        (u'unsigned', __chainedSearch_val_ArgumentType_unsigned),
        (u'signed', __chainedSearch_val_ArgumentType_signed),
        ])
    _chainedSearch_val_ArgumentType._ext = None
    _chainedSearch_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedSearch_val_ResultType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedSearch_val_ResultType_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedSearch_val_ResultType_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    __chainedSearch_val_ResultType_unsigned._cont = ASN1Dict([
        (u'chainedResult', ___chainedSearch_val_ResultType_unsigned_chainedResult),
        (u'result', ___chainedSearch_val_ResultType_unsigned_ResultType),
        ])
    __chainedSearch_val_ResultType_unsigned._ext = None
    __chainedSearch_val_ResultType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedSearch_val_ResultType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedSearch_val_ResultType_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedSearch_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ___chainedSearch_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', ____chainedSearch_val_ResultType_signed_toBeSigned_chainedResult),
        (u'result', ____chainedSearch_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedSearch_val_ResultType_signed_toBeSigned._ext = None
    ___chainedSearch_val_ResultType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedSearch_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedSearch_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedSearch_val_ResultType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedSearch_val_ResultType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedSearch_val_ResultType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedSearch_val_ResultType_signed_algorithmIdentifier),
        (u'signature', ___chainedSearch_val_ResultType_signed_signature),
        ])
    __chainedSearch_val_ResultType_signed._ext = []
    _chainedSearch_val_ResultType._cont = ASN1Dict([
        (u'unsigned', __chainedSearch_val_ResultType_unsigned),
        (u'signed', __chainedSearch_val_ResultType_signed),
        ])
    _chainedSearch_val_ResultType._ext = None
    chainedSearch._val = dict([(u'ArgumentType', _chainedSearch_val_ArgumentType), (u'ResultType', _chainedSearch_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))])
    
    #-----< chainedAddEntry >-----#
    chainedAddEntry = CLASS(name=u'chainedAddEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedAddEntry_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedAddEntry_val_ArgumentType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedAddEntry_val_ArgumentType_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedAddEntry_val_ArgumentType_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    __chainedAddEntry_val_ArgumentType_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ___chainedAddEntry_val_ArgumentType_unsigned_chainedArgument),
        (u'argument', ___chainedAddEntry_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedAddEntry_val_ArgumentType_unsigned._ext = None
    __chainedAddEntry_val_ArgumentType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedAddEntry_val_ArgumentType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ___chainedAddEntry_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_chainedArgument),
        (u'argument', ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedAddEntry_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedAddEntry_val_ArgumentType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedAddEntry_val_ArgumentType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedAddEntry_val_ArgumentType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier),
        (u'signature', ___chainedAddEntry_val_ArgumentType_signed_signature),
        ])
    __chainedAddEntry_val_ArgumentType_signed._ext = []
    _chainedAddEntry_val_ArgumentType._cont = ASN1Dict([
        (u'unsigned', __chainedAddEntry_val_ArgumentType_unsigned),
        (u'signed', __chainedAddEntry_val_ArgumentType_signed),
        ])
    _chainedAddEntry_val_ArgumentType._ext = None
    _chainedAddEntry_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedAddEntry_val_ResultType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedAddEntry_val_ResultType_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedAddEntry_val_ResultType_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    __chainedAddEntry_val_ResultType_unsigned._cont = ASN1Dict([
        (u'chainedResult', ___chainedAddEntry_val_ResultType_unsigned_chainedResult),
        (u'result', ___chainedAddEntry_val_ResultType_unsigned_ResultType),
        ])
    __chainedAddEntry_val_ResultType_unsigned._ext = None
    __chainedAddEntry_val_ResultType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedAddEntry_val_ResultType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedAddEntry_val_ResultType_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedAddEntry_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ___chainedAddEntry_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', ____chainedAddEntry_val_ResultType_signed_toBeSigned_chainedResult),
        (u'result', ____chainedAddEntry_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedAddEntry_val_ResultType_signed_toBeSigned._ext = None
    ___chainedAddEntry_val_ResultType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedAddEntry_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedAddEntry_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedAddEntry_val_ResultType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedAddEntry_val_ResultType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedAddEntry_val_ResultType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedAddEntry_val_ResultType_signed_algorithmIdentifier),
        (u'signature', ___chainedAddEntry_val_ResultType_signed_signature),
        ])
    __chainedAddEntry_val_ResultType_signed._ext = []
    _chainedAddEntry_val_ResultType._cont = ASN1Dict([
        (u'unsigned', __chainedAddEntry_val_ResultType_unsigned),
        (u'signed', __chainedAddEntry_val_ResultType_signed),
        ])
    _chainedAddEntry_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_6_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_6_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_6_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_6_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6_0._ext = None
    chainedAddEntry._val = dict([(u'ArgumentType', _chainedAddEntry_val_ArgumentType), (u'ResultType', _chainedAddEntry_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))])
    
    #-----< chainedRemoveEntry >-----#
    chainedRemoveEntry = CLASS(name=u'chainedRemoveEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedRemoveEntry_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedRemoveEntry_val_ArgumentType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedRemoveEntry_val_ArgumentType_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedRemoveEntry_val_ArgumentType_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    __chainedRemoveEntry_val_ArgumentType_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ___chainedRemoveEntry_val_ArgumentType_unsigned_chainedArgument),
        (u'argument', ___chainedRemoveEntry_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedRemoveEntry_val_ArgumentType_unsigned._ext = None
    __chainedRemoveEntry_val_ArgumentType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedRemoveEntry_val_ArgumentType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ___chainedRemoveEntry_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_chainedArgument),
        (u'argument', ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedRemoveEntry_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedRemoveEntry_val_ArgumentType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedRemoveEntry_val_ArgumentType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedRemoveEntry_val_ArgumentType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier),
        (u'signature', ___chainedRemoveEntry_val_ArgumentType_signed_signature),
        ])
    __chainedRemoveEntry_val_ArgumentType_signed._ext = []
    _chainedRemoveEntry_val_ArgumentType._cont = ASN1Dict([
        (u'unsigned', __chainedRemoveEntry_val_ArgumentType_unsigned),
        (u'signed', __chainedRemoveEntry_val_ArgumentType_signed),
        ])
    _chainedRemoveEntry_val_ArgumentType._ext = None
    _chainedRemoveEntry_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedRemoveEntry_val_ResultType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedRemoveEntry_val_ResultType_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedRemoveEntry_val_ResultType_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    __chainedRemoveEntry_val_ResultType_unsigned._cont = ASN1Dict([
        (u'chainedResult', ___chainedRemoveEntry_val_ResultType_unsigned_chainedResult),
        (u'result', ___chainedRemoveEntry_val_ResultType_unsigned_ResultType),
        ])
    __chainedRemoveEntry_val_ResultType_unsigned._ext = None
    __chainedRemoveEntry_val_ResultType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedRemoveEntry_val_ResultType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ___chainedRemoveEntry_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_chainedResult),
        (u'result', ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedRemoveEntry_val_ResultType_signed_toBeSigned._ext = None
    ___chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedRemoveEntry_val_ResultType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedRemoveEntry_val_ResultType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedRemoveEntry_val_ResultType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier),
        (u'signature', ___chainedRemoveEntry_val_ResultType_signed_signature),
        ])
    __chainedRemoveEntry_val_ResultType_signed._ext = []
    _chainedRemoveEntry_val_ResultType._cont = ASN1Dict([
        (u'unsigned', __chainedRemoveEntry_val_ResultType_unsigned),
        (u'signed', __chainedRemoveEntry_val_ResultType_signed),
        ])
    _chainedRemoveEntry_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_4_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_1._ext = None
    __OPERATION_Errors_val_ParameterType_5_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_5_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_5_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_5_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_1._ext = None
    chainedRemoveEntry._val = dict([(u'ArgumentType', _chainedRemoveEntry_val_ArgumentType), (u'ResultType', _chainedRemoveEntry_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))])
    
    #-----< chainedModifyEntry >-----#
    chainedModifyEntry = CLASS(name=u'chainedModifyEntry', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedModifyEntry_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedModifyEntry_val_ArgumentType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedModifyEntry_val_ArgumentType_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedModifyEntry_val_ArgumentType_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    __chainedModifyEntry_val_ArgumentType_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ___chainedModifyEntry_val_ArgumentType_unsigned_chainedArgument),
        (u'argument', ___chainedModifyEntry_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedModifyEntry_val_ArgumentType_unsigned._ext = None
    __chainedModifyEntry_val_ArgumentType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedModifyEntry_val_ArgumentType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ___chainedModifyEntry_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_chainedArgument),
        (u'argument', ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedModifyEntry_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedModifyEntry_val_ArgumentType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedModifyEntry_val_ArgumentType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedModifyEntry_val_ArgumentType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier),
        (u'signature', ___chainedModifyEntry_val_ArgumentType_signed_signature),
        ])
    __chainedModifyEntry_val_ArgumentType_signed._ext = []
    _chainedModifyEntry_val_ArgumentType._cont = ASN1Dict([
        (u'unsigned', __chainedModifyEntry_val_ArgumentType_unsigned),
        (u'signed', __chainedModifyEntry_val_ArgumentType_signed),
        ])
    _chainedModifyEntry_val_ArgumentType._ext = None
    _chainedModifyEntry_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedModifyEntry_val_ResultType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedModifyEntry_val_ResultType_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedModifyEntry_val_ResultType_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    __chainedModifyEntry_val_ResultType_unsigned._cont = ASN1Dict([
        (u'chainedResult', ___chainedModifyEntry_val_ResultType_unsigned_chainedResult),
        (u'result', ___chainedModifyEntry_val_ResultType_unsigned_ResultType),
        ])
    __chainedModifyEntry_val_ResultType_unsigned._ext = None
    __chainedModifyEntry_val_ResultType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedModifyEntry_val_ResultType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedModifyEntry_val_ResultType_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedModifyEntry_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ___chainedModifyEntry_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', ____chainedModifyEntry_val_ResultType_signed_toBeSigned_chainedResult),
        (u'result', ____chainedModifyEntry_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedModifyEntry_val_ResultType_signed_toBeSigned._ext = None
    ___chainedModifyEntry_val_ResultType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedModifyEntry_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedModifyEntry_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedModifyEntry_val_ResultType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedModifyEntry_val_ResultType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedModifyEntry_val_ResultType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedModifyEntry_val_ResultType_signed_algorithmIdentifier),
        (u'signature', ___chainedModifyEntry_val_ResultType_signed_signature),
        ])
    __chainedModifyEntry_val_ResultType_signed._ext = []
    _chainedModifyEntry_val_ResultType._cont = ASN1Dict([
        (u'unsigned', __chainedModifyEntry_val_ResultType_unsigned),
        (u'signed', __chainedModifyEntry_val_ResultType_signed),
        ])
    _chainedModifyEntry_val_ResultType._ext = None
    chainedModifyEntry._val = dict([(u'ArgumentType', _chainedModifyEntry_val_ArgumentType), (u'ResultType', _chainedModifyEntry_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))])
    
    #-----< chainedModifyDN >-----#
    chainedModifyDN = CLASS(name=u'chainedModifyDN', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedModifyDN_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedModifyDN_val_ArgumentType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedModifyDN_val_ArgumentType_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedModifyDN_val_ArgumentType_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    __chainedModifyDN_val_ArgumentType_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ___chainedModifyDN_val_ArgumentType_unsigned_chainedArgument),
        (u'argument', ___chainedModifyDN_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedModifyDN_val_ArgumentType_unsigned._ext = None
    __chainedModifyDN_val_ArgumentType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedModifyDN_val_ArgumentType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ___chainedModifyDN_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_chainedArgument),
        (u'argument', ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedModifyDN_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedModifyDN_val_ArgumentType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedModifyDN_val_ArgumentType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedModifyDN_val_ArgumentType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier),
        (u'signature', ___chainedModifyDN_val_ArgumentType_signed_signature),
        ])
    __chainedModifyDN_val_ArgumentType_signed._ext = []
    _chainedModifyDN_val_ArgumentType._cont = ASN1Dict([
        (u'unsigned', __chainedModifyDN_val_ArgumentType_unsigned),
        (u'signed', __chainedModifyDN_val_ArgumentType_signed),
        ])
    _chainedModifyDN_val_ArgumentType._ext = None
    _chainedModifyDN_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedModifyDN_val_ResultType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedModifyDN_val_ResultType_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedModifyDN_val_ResultType_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    __chainedModifyDN_val_ResultType_unsigned._cont = ASN1Dict([
        (u'chainedResult', ___chainedModifyDN_val_ResultType_unsigned_chainedResult),
        (u'result', ___chainedModifyDN_val_ResultType_unsigned_ResultType),
        ])
    __chainedModifyDN_val_ResultType_unsigned._ext = None
    __chainedModifyDN_val_ResultType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedModifyDN_val_ResultType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedModifyDN_val_ResultType_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedModifyDN_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ___chainedModifyDN_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', ____chainedModifyDN_val_ResultType_signed_toBeSigned_chainedResult),
        (u'result', ____chainedModifyDN_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedModifyDN_val_ResultType_signed_toBeSigned._ext = None
    ___chainedModifyDN_val_ResultType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedModifyDN_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedModifyDN_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedModifyDN_val_ResultType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedModifyDN_val_ResultType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedModifyDN_val_ResultType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedModifyDN_val_ResultType_signed_algorithmIdentifier),
        (u'signature', ___chainedModifyDN_val_ResultType_signed_signature),
        ])
    __chainedModifyDN_val_ResultType_signed._ext = []
    _chainedModifyDN_val_ResultType._cont = ASN1Dict([
        (u'unsigned', __chainedModifyDN_val_ResultType_unsigned),
        (u'signed', __chainedModifyDN_val_ResultType_signed),
        ])
    _chainedModifyDN_val_ResultType._ext = None
    chainedModifyDN._val = dict([(u'ArgumentType', _chainedModifyDN_val_ArgumentType), (u'ResultType', _chainedModifyDN_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))])
    
    #-----< chainedChangePassword >-----#
    chainedChangePassword = CLASS(name=u'chainedChangePassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedChangePassword_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedChangePassword_val_ArgumentType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedChangePassword_val_ArgumentType_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedChangePassword_val_ArgumentType_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    __chainedChangePassword_val_ArgumentType_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ___chainedChangePassword_val_ArgumentType_unsigned_chainedArgument),
        (u'argument', ___chainedChangePassword_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedChangePassword_val_ArgumentType_unsigned._ext = None
    __chainedChangePassword_val_ArgumentType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedChangePassword_val_ArgumentType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ___chainedChangePassword_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_chainedArgument),
        (u'argument', ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedChangePassword_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedChangePassword_val_ArgumentType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedChangePassword_val_ArgumentType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedChangePassword_val_ArgumentType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier),
        (u'signature', ___chainedChangePassword_val_ArgumentType_signed_signature),
        ])
    __chainedChangePassword_val_ArgumentType_signed._ext = []
    _chainedChangePassword_val_ArgumentType._cont = ASN1Dict([
        (u'unsigned', __chainedChangePassword_val_ArgumentType_unsigned),
        (u'signed', __chainedChangePassword_val_ArgumentType_signed),
        ])
    _chainedChangePassword_val_ArgumentType._ext = None
    _chainedChangePassword_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedChangePassword_val_ResultType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedChangePassword_val_ResultType_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedChangePassword_val_ResultType_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    __chainedChangePassword_val_ResultType_unsigned._cont = ASN1Dict([
        (u'chainedResult', ___chainedChangePassword_val_ResultType_unsigned_chainedResult),
        (u'result', ___chainedChangePassword_val_ResultType_unsigned_ResultType),
        ])
    __chainedChangePassword_val_ResultType_unsigned._ext = None
    __chainedChangePassword_val_ResultType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedChangePassword_val_ResultType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedChangePassword_val_ResultType_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedChangePassword_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ___chainedChangePassword_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', ____chainedChangePassword_val_ResultType_signed_toBeSigned_chainedResult),
        (u'result', ____chainedChangePassword_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedChangePassword_val_ResultType_signed_toBeSigned._ext = None
    ___chainedChangePassword_val_ResultType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedChangePassword_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedChangePassword_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedChangePassword_val_ResultType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedChangePassword_val_ResultType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedChangePassword_val_ResultType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedChangePassword_val_ResultType_signed_algorithmIdentifier),
        (u'signature', ___chainedChangePassword_val_ResultType_signed_signature),
        ])
    __chainedChangePassword_val_ResultType_signed._ext = []
    _chainedChangePassword_val_ResultType._cont = ASN1Dict([
        (u'unsigned', __chainedChangePassword_val_ResultType_unsigned),
        (u'signed', __chainedChangePassword_val_ResultType_signed),
        ])
    _chainedChangePassword_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_1_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_1._ext = None
    __OPERATION_Errors_val_ParameterType_2_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    chainedChangePassword._val = dict([(u'ArgumentType', _chainedChangePassword_val_ArgumentType), (u'ResultType', _chainedChangePassword_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))])
    
    #-----< chainedAdministerPassword >-----#
    chainedAdministerPassword = CLASS(name=u'chainedAdministerPassword', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedAdministerPassword_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedAdministerPassword_val_ArgumentType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedAdministerPassword_val_ArgumentType_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedAdministerPassword_val_ArgumentType_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    __chainedAdministerPassword_val_ArgumentType_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ___chainedAdministerPassword_val_ArgumentType_unsigned_chainedArgument),
        (u'argument', ___chainedAdministerPassword_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedAdministerPassword_val_ArgumentType_unsigned._ext = None
    __chainedAdministerPassword_val_ArgumentType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedAdministerPassword_val_ArgumentType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ___chainedAdministerPassword_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_chainedArgument),
        (u'argument', ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedAdministerPassword_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedAdministerPassword_val_ArgumentType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedAdministerPassword_val_ArgumentType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedAdministerPassword_val_ArgumentType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier),
        (u'signature', ___chainedAdministerPassword_val_ArgumentType_signed_signature),
        ])
    __chainedAdministerPassword_val_ArgumentType_signed._ext = []
    _chainedAdministerPassword_val_ArgumentType._cont = ASN1Dict([
        (u'unsigned', __chainedAdministerPassword_val_ArgumentType_unsigned),
        (u'signed', __chainedAdministerPassword_val_ArgumentType_signed),
        ])
    _chainedAdministerPassword_val_ArgumentType._ext = None
    _chainedAdministerPassword_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedAdministerPassword_val_ResultType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedAdministerPassword_val_ResultType_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedAdministerPassword_val_ResultType_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    __chainedAdministerPassword_val_ResultType_unsigned._cont = ASN1Dict([
        (u'chainedResult', ___chainedAdministerPassword_val_ResultType_unsigned_chainedResult),
        (u'result', ___chainedAdministerPassword_val_ResultType_unsigned_ResultType),
        ])
    __chainedAdministerPassword_val_ResultType_unsigned._ext = None
    __chainedAdministerPassword_val_ResultType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedAdministerPassword_val_ResultType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ___chainedAdministerPassword_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_chainedResult),
        (u'result', ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedAdministerPassword_val_ResultType_signed_toBeSigned._ext = None
    ___chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedAdministerPassword_val_ResultType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedAdministerPassword_val_ResultType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedAdministerPassword_val_ResultType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier),
        (u'signature', ___chainedAdministerPassword_val_ResultType_signed_signature),
        ])
    __chainedAdministerPassword_val_ResultType_signed._ext = []
    _chainedAdministerPassword_val_ResultType._cont = ASN1Dict([
        (u'unsigned', __chainedAdministerPassword_val_ResultType_unsigned),
        (u'signed', __chainedAdministerPassword_val_ResultType_signed),
        ])
    _chainedAdministerPassword_val_ResultType._ext = None
    chainedAdministerPassword._val = dict([(u'ArgumentType', _chainedAdministerPassword_val_ArgumentType), (u'ResultType', _chainedAdministerPassword_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))])
    
    #-----< chainedLdapTransport >-----#
    chainedLdapTransport = CLASS(name=u'chainedLdapTransport', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedLdapTransport_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedLdapTransport_val_ArgumentType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedLdapTransport_val_ArgumentType_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedLdapTransport_val_ArgumentType_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    __chainedLdapTransport_val_ArgumentType_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ___chainedLdapTransport_val_ArgumentType_unsigned_chainedArgument),
        (u'argument', ___chainedLdapTransport_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedLdapTransport_val_ArgumentType_unsigned._ext = None
    __chainedLdapTransport_val_ArgumentType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedLdapTransport_val_ArgumentType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ___chainedLdapTransport_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_chainedArgument),
        (u'argument', ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedLdapTransport_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedLdapTransport_val_ArgumentType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedLdapTransport_val_ArgumentType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedLdapTransport_val_ArgumentType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier),
        (u'signature', ___chainedLdapTransport_val_ArgumentType_signed_signature),
        ])
    __chainedLdapTransport_val_ArgumentType_signed._ext = []
    _chainedLdapTransport_val_ArgumentType._cont = ASN1Dict([
        (u'unsigned', __chainedLdapTransport_val_ArgumentType_unsigned),
        (u'signed', __chainedLdapTransport_val_ArgumentType_signed),
        ])
    _chainedLdapTransport_val_ArgumentType._ext = None
    _chainedLdapTransport_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedLdapTransport_val_ResultType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedLdapTransport_val_ResultType_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedLdapTransport_val_ResultType_unsigned_ResultType = SEQ_OF(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____chainedLdapTransport_val_ResultType_unsigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ___chainedLdapTransport_val_ResultType_unsigned_ResultType._cont = ____chainedLdapTransport_val_ResultType_unsigned_ResultType__item_
    __chainedLdapTransport_val_ResultType_unsigned._cont = ASN1Dict([
        (u'chainedResult', ___chainedLdapTransport_val_ResultType_unsigned_chainedResult),
        (u'result', ___chainedLdapTransport_val_ResultType_unsigned_ResultType),
        ])
    __chainedLdapTransport_val_ResultType_unsigned._ext = None
    __chainedLdapTransport_val_ResultType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedLdapTransport_val_ResultType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedLdapTransport_val_ResultType_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType = SEQ_OF(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType._cont = _____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType__item_
    ___chainedLdapTransport_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', ____chainedLdapTransport_val_ResultType_signed_toBeSigned_chainedResult),
        (u'result', ____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedLdapTransport_val_ResultType_signed_toBeSigned._ext = None
    ___chainedLdapTransport_val_ResultType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedLdapTransport_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedLdapTransport_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedLdapTransport_val_ResultType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedLdapTransport_val_ResultType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedLdapTransport_val_ResultType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedLdapTransport_val_ResultType_signed_algorithmIdentifier),
        (u'signature', ___chainedLdapTransport_val_ResultType_signed_signature),
        ])
    __chainedLdapTransport_val_ResultType_signed._ext = []
    _chainedLdapTransport_val_ResultType._cont = ASN1Dict([
        (u'unsigned', __chainedLdapTransport_val_ResultType_unsigned),
        (u'signed', __chainedLdapTransport_val_ResultType_signed),
        ])
    _chainedLdapTransport_val_ResultType._ext = None
    __OPERATION_Errors_val_ParameterType_1_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_2._ext = None
    __OPERATION_Errors_val_ParameterType_2_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_2._ext = None
    chainedLdapTransport._val = dict([(u'ArgumentType', _chainedLdapTransport_val_ArgumentType), (u'ResultType', _chainedLdapTransport_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))])
    
    #-----< chainedLinkedLDAP >-----#
    chainedLinkedLDAP = CLASS(name=u'chainedLinkedLDAP', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _chainedLinkedLDAP_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedLinkedLDAP_val_ArgumentType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedLinkedLDAP_val_ArgumentType_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ___chainedLinkedLDAP_val_ArgumentType_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    __chainedLinkedLDAP_val_ArgumentType_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ___chainedLinkedLDAP_val_ArgumentType_unsigned_chainedArgument),
        (u'argument', ___chainedLinkedLDAP_val_ArgumentType_unsigned_ArgumentType),
        ])
    __chainedLinkedLDAP_val_ArgumentType_unsigned._ext = None
    __chainedLinkedLDAP_val_ArgumentType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ___chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_chainedArgument),
        (u'argument', ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_ArgumentType),
        ])
    ___chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned._ext = None
    ___chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab = _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters_tab
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier._ext = []
    ___chainedLinkedLDAP_val_ArgumentType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedLinkedLDAP_val_ArgumentType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier),
        (u'signature', ___chainedLinkedLDAP_val_ArgumentType_signed_signature),
        ])
    __chainedLinkedLDAP_val_ArgumentType_signed._ext = []
    _chainedLinkedLDAP_val_ArgumentType._cont = ASN1Dict([
        (u'unsigned', __chainedLinkedLDAP_val_ArgumentType_unsigned),
        (u'signed', __chainedLinkedLDAP_val_ArgumentType_signed),
        ])
    _chainedLinkedLDAP_val_ArgumentType._ext = None
    _chainedLinkedLDAP_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    __chainedLinkedLDAP_val_ResultType_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ___chainedLinkedLDAP_val_ResultType_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ___chainedLinkedLDAP_val_ResultType_unsigned_ResultType = NULL(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    __chainedLinkedLDAP_val_ResultType_unsigned._cont = ASN1Dict([
        (u'chainedResult', ___chainedLinkedLDAP_val_ResultType_unsigned_chainedResult),
        (u'result', ___chainedLinkedLDAP_val_ResultType_unsigned_ResultType),
        ])
    __chainedLinkedLDAP_val_ResultType_unsigned._ext = None
    __chainedLinkedLDAP_val_ResultType_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___chainedLinkedLDAP_val_ResultType_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_ResultType = NULL(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ___chainedLinkedLDAP_val_ResultType_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_chainedResult),
        (u'result', ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_ResultType),
        ])
    ___chainedLinkedLDAP_val_ResultType_signed_toBeSigned._ext = None
    ___chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab = _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm_tab
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters._const_tab = _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters_tab
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters),
        ])
    ___chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier._ext = []
    ___chainedLinkedLDAP_val_ResultType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __chainedLinkedLDAP_val_ResultType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___chainedLinkedLDAP_val_ResultType_signed_toBeSigned),
        (u'algorithmIdentifier', ___chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier),
        (u'signature', ___chainedLinkedLDAP_val_ResultType_signed_signature),
        ])
    __chainedLinkedLDAP_val_ResultType_signed._ext = []
    _chainedLinkedLDAP_val_ResultType._cont = ASN1Dict([
        (u'unsigned', __chainedLinkedLDAP_val_ResultType_unsigned),
        (u'signed', __chainedLinkedLDAP_val_ResultType_signed),
        ])
    _chainedLinkedLDAP_val_ResultType._ext = None
    chainedLinkedLDAP._val = dict([(u'ArgumentType', _chainedLinkedLDAP_val_ArgumentType), (u'ResultType', _chainedLinkedLDAP_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])
    
    _all_ = [
        dsaReferral,
        __dsaReferral_val_ParameterType_unsigned,
        ___dsaReferral_val_ParameterType_signed_toBeSigned,
        _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____dsaReferral_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___dsaReferral_val_ParameterType_signed_algorithmIdentifier,
        ___dsaReferral_val_ParameterType_signed_signature,
        __dsaReferral_val_ParameterType_signed,
        _dsaReferral_val_ParameterType,
        _DsaReferralData_reference,
        _DsaReferralData_contextPrefix,
        _DsaReferralData_securityParameters,
        _DsaReferralData_performer,
        _DsaReferralData_aliasDereferenced,
        ____DsaReferralData_notification__item__type_tab,
        _____DsaReferralData_notification__item__type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        _____DsaReferralData_notification__item__type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        ___DsaReferralData_notification__item__type,
        ____DsaReferralData_notification__item__values__item_,
        ___DsaReferralData_notification__item__values,
        _____DsaReferralData_notification__item__valuesWithContext__item__value,
        ______DsaReferralData_notification__item__valuesWithContext__item__contextList__item_,
        _____DsaReferralData_notification__item__valuesWithContext__item__contextList,
        ____DsaReferralData_notification__item__valuesWithContext__item_,
        ___DsaReferralData_notification__item__valuesWithContext,
        __DsaReferralData_notification__item_,
        _DsaReferralData_notification,
        DsaReferralData,
        _ChainingArguments_originator,
        _ChainingArguments_targetObject,
        _ChainingArguments_operationProgress,
        _ChainingArguments_traceInformation,
        _ChainingArguments_aliasDereferenced,
        _ChainingArguments_aliasedRDNs,
        _ChainingArguments_returnCrossRefs,
        _ChainingArguments_referenceType,
        _ChainingArguments_info,
        _ChainingArguments_timeLimit,
        _ChainingArguments_securityParameters,
        _ChainingArguments_entryOnly,
        _ChainingArguments_uniqueIdentifier,
        _ChainingArguments_authenticationLevel,
        _ChainingArguments_exclusions,
        _ChainingArguments_excludeShadows,
        _ChainingArguments_nameResolveOnMaster,
        _ChainingArguments_operationIdentifier,
        _ChainingArguments_searchRuleId,
        _ChainingArguments_chainedRelaxation,
        _ChainingArguments_relatedEntry,
        _ChainingArguments_dspPaging,
        _ChainingArguments_excludeWriteableCopies,
        ChainingArguments,
        _Time_utcTime,
        _Time_generalizedTime,
        Time,
        DomainInfo,
        _ChainingResults_info,
        __ChainingResults_crossReferences__item_,
        _ChainingResults_crossReferences,
        _ChainingResults_securityParameters,
        _ChainingResults_alreadySearched,
        ChainingResults,
        _CrossReference_contextPrefix,
        _CrossReference_accessPoint,
        CrossReference,
        _OperationProgress_nameResolutionPhase,
        _OperationProgress_nextRDNToBeResolved,
        OperationProgress,
        _TraceInformation__item_,
        TraceInformation,
        _TraceItem_dsa,
        _TraceItem_targetObject,
        _TraceItem_operationProgress,
        TraceItem,
        ReferenceType,
        _AccessPoint_ae_title,
        _AccessPoint_address,
        __AccessPoint_protocolInformation__item_,
        _AccessPoint_protocolInformation,
        AccessPoint,
        _MasterOrShadowAccessPoint_ae_title,
        _MasterOrShadowAccessPoint_address,
        __MasterOrShadowAccessPoint_protocolInformation__item_,
        _MasterOrShadowAccessPoint_protocolInformation,
        _MasterOrShadowAccessPoint_category,
        _MasterOrShadowAccessPoint_chainingRequired,
        MasterOrShadowAccessPoint,
        _MasterAndShadowAccessPoints__item_,
        MasterAndShadowAccessPoints,
        _AccessPointInformation_ae_title,
        _AccessPointInformation_address,
        __AccessPointInformation_protocolInformation__item_,
        _AccessPointInformation_protocolInformation,
        _AccessPointInformation_category,
        _AccessPointInformation_chainingRequired,
        _AccessPointInformation_additionalPoints,
        AccessPointInformation,
        _DitBridgeKnowledge_domainLocalID,
        _DitBridgeKnowledge_accessPoints,
        DitBridgeKnowledge,
        _Exclusions__item_,
        Exclusions,
        _ContinuationReference_targetObject,
        _ContinuationReference_aliasedRDNs,
        _ContinuationReference_operationProgress,
        _ContinuationReference_rdnsResolved,
        _ContinuationReference_referenceType,
        __ContinuationReference_accessPoints__item_,
        _ContinuationReference_accessPoints,
        _ContinuationReference_entryOnly,
        _ContinuationReference_exclusions,
        _ContinuationReference_returnToDUA,
        _ContinuationReference_nameResolveOnMaster,
        ContinuationReference,
        dSABind,
        _dSABind_val_ArgumentType,
        _dSABind_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        _DSABindArgument_credentials,
        _DSABindArgument_versions,
        DSABindArgument,
        _DSACredentials_simple,
        _DSACredentials_strong,
        _DSACredentials_externalProcedure,
        _DSACredentials_spkm,
        DSACredentials,
        DSABindResult,
        chainedRead,
        ___chainedRead_val_ArgumentType_unsigned_chainedArgument,
        ___chainedRead_val_ArgumentType_unsigned_ArgumentType,
        __chainedRead_val_ArgumentType_unsigned,
        ____chainedRead_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedRead_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedRead_val_ArgumentType_signed_toBeSigned,
        _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedRead_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedRead_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedRead_val_ArgumentType_signed_signature,
        __chainedRead_val_ArgumentType_signed,
        _chainedRead_val_ArgumentType,
        ___chainedRead_val_ResultType_unsigned_chainedResult,
        ___chainedRead_val_ResultType_unsigned_ResultType,
        __chainedRead_val_ResultType_unsigned,
        ____chainedRead_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedRead_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedRead_val_ResultType_signed_toBeSigned,
        _____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedRead_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedRead_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedRead_val_ResultType_signed_algorithmIdentifier,
        ___chainedRead_val_ResultType_signed_signature,
        __chainedRead_val_ResultType_signed,
        _chainedRead_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_Errors_val_ParameterType_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_signed,
        __OPERATION_Errors_val_ParameterType_2,
        ___OPERATION_Errors_val_ParameterType_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_signed,
        __OPERATION_Errors_val_ParameterType_3,
        ___OPERATION_Errors_val_ParameterType_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_signed,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_Errors_val_ParameterType_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_signed,
        __OPERATION_Errors_val_ParameterType_5,
        ___OPERATION_Errors_val_ParameterType_6_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_signed,
        __OPERATION_Errors_val_ParameterType_6,
        chainedCompare,
        ___chainedCompare_val_ArgumentType_unsigned_chainedArgument,
        ___chainedCompare_val_ArgumentType_unsigned_ArgumentType,
        __chainedCompare_val_ArgumentType_unsigned,
        ____chainedCompare_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedCompare_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedCompare_val_ArgumentType_signed_toBeSigned,
        _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedCompare_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedCompare_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedCompare_val_ArgumentType_signed_signature,
        __chainedCompare_val_ArgumentType_signed,
        _chainedCompare_val_ArgumentType,
        ___chainedCompare_val_ResultType_unsigned_chainedResult,
        ___chainedCompare_val_ResultType_unsigned_ResultType,
        __chainedCompare_val_ResultType_unsigned,
        ____chainedCompare_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedCompare_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedCompare_val_ResultType_signed_toBeSigned,
        _____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedCompare_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedCompare_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedCompare_val_ResultType_signed_algorithmIdentifier,
        ___chainedCompare_val_ResultType_signed_signature,
        __chainedCompare_val_ResultType_signed,
        _chainedCompare_val_ResultType,
        chainedAbandon,
        _chainedAbandon_val_ArgumentType,
        _chainedAbandon_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_1_signed,
        __OPERATION_Errors_val_ParameterType_0_1,
        chainedList,
        ___chainedList_val_ArgumentType_unsigned_chainedArgument,
        ___chainedList_val_ArgumentType_unsigned_ArgumentType,
        __chainedList_val_ArgumentType_unsigned,
        ____chainedList_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedList_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedList_val_ArgumentType_signed_toBeSigned,
        _____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedList_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedList_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedList_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedList_val_ArgumentType_signed_signature,
        __chainedList_val_ArgumentType_signed,
        _chainedList_val_ArgumentType,
        ___chainedList_val_ResultType_unsigned_chainedResult,
        ___chainedList_val_ResultType_unsigned_ResultType,
        __chainedList_val_ResultType_unsigned,
        ____chainedList_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedList_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedList_val_ResultType_signed_toBeSigned,
        _____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedList_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedList_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedList_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedList_val_ResultType_signed_algorithmIdentifier,
        ___chainedList_val_ResultType_signed_signature,
        __chainedList_val_ResultType_signed,
        _chainedList_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_1_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_0_signed,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_Errors_val_ParameterType_2_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_0_signed,
        __OPERATION_Errors_val_ParameterType_2_0,
        ___OPERATION_Errors_val_ParameterType_3_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_0_signed,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_Errors_val_ParameterType_4_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_0_signed,
        __OPERATION_Errors_val_ParameterType_4_0,
        ___OPERATION_Errors_val_ParameterType_5_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_0_signed,
        __OPERATION_Errors_val_ParameterType_5_0,
        chainedSearch,
        ___chainedSearch_val_ArgumentType_unsigned_chainedArgument,
        ___chainedSearch_val_ArgumentType_unsigned_ArgumentType,
        __chainedSearch_val_ArgumentType_unsigned,
        ____chainedSearch_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedSearch_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedSearch_val_ArgumentType_signed_toBeSigned,
        _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedSearch_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedSearch_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedSearch_val_ArgumentType_signed_signature,
        __chainedSearch_val_ArgumentType_signed,
        _chainedSearch_val_ArgumentType,
        ___chainedSearch_val_ResultType_unsigned_chainedResult,
        ___chainedSearch_val_ResultType_unsigned_ResultType,
        __chainedSearch_val_ResultType_unsigned,
        ____chainedSearch_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedSearch_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedSearch_val_ResultType_signed_toBeSigned,
        _____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedSearch_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedSearch_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedSearch_val_ResultType_signed_algorithmIdentifier,
        ___chainedSearch_val_ResultType_signed_signature,
        __chainedSearch_val_ResultType_signed,
        _chainedSearch_val_ResultType,
        chainedAddEntry,
        ___chainedAddEntry_val_ArgumentType_unsigned_chainedArgument,
        ___chainedAddEntry_val_ArgumentType_unsigned_ArgumentType,
        __chainedAddEntry_val_ArgumentType_unsigned,
        ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedAddEntry_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedAddEntry_val_ArgumentType_signed_toBeSigned,
        _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedAddEntry_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedAddEntry_val_ArgumentType_signed_signature,
        __chainedAddEntry_val_ArgumentType_signed,
        _chainedAddEntry_val_ArgumentType,
        ___chainedAddEntry_val_ResultType_unsigned_chainedResult,
        ___chainedAddEntry_val_ResultType_unsigned_ResultType,
        __chainedAddEntry_val_ResultType_unsigned,
        ____chainedAddEntry_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedAddEntry_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedAddEntry_val_ResultType_signed_toBeSigned,
        _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedAddEntry_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedAddEntry_val_ResultType_signed_algorithmIdentifier,
        ___chainedAddEntry_val_ResultType_signed_signature,
        __chainedAddEntry_val_ResultType_signed,
        _chainedAddEntry_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_6_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_0_signed,
        __OPERATION_Errors_val_ParameterType_6_0,
        chainedRemoveEntry,
        ___chainedRemoveEntry_val_ArgumentType_unsigned_chainedArgument,
        ___chainedRemoveEntry_val_ArgumentType_unsigned_ArgumentType,
        __chainedRemoveEntry_val_ArgumentType_unsigned,
        ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedRemoveEntry_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedRemoveEntry_val_ArgumentType_signed_toBeSigned,
        _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedRemoveEntry_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedRemoveEntry_val_ArgumentType_signed_signature,
        __chainedRemoveEntry_val_ArgumentType_signed,
        _chainedRemoveEntry_val_ArgumentType,
        ___chainedRemoveEntry_val_ResultType_unsigned_chainedResult,
        ___chainedRemoveEntry_val_ResultType_unsigned_ResultType,
        __chainedRemoveEntry_val_ResultType_unsigned,
        ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedRemoveEntry_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedRemoveEntry_val_ResultType_signed_toBeSigned,
        _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedRemoveEntry_val_ResultType_signed_algorithmIdentifier,
        ___chainedRemoveEntry_val_ResultType_signed_signature,
        __chainedRemoveEntry_val_ResultType_signed,
        _chainedRemoveEntry_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_4_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_1_signed,
        __OPERATION_Errors_val_ParameterType_4_1,
        ___OPERATION_Errors_val_ParameterType_5_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_1_signed,
        __OPERATION_Errors_val_ParameterType_5_1,
        chainedModifyEntry,
        ___chainedModifyEntry_val_ArgumentType_unsigned_chainedArgument,
        ___chainedModifyEntry_val_ArgumentType_unsigned_ArgumentType,
        __chainedModifyEntry_val_ArgumentType_unsigned,
        ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedModifyEntry_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedModifyEntry_val_ArgumentType_signed_toBeSigned,
        _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedModifyEntry_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedModifyEntry_val_ArgumentType_signed_signature,
        __chainedModifyEntry_val_ArgumentType_signed,
        _chainedModifyEntry_val_ArgumentType,
        ___chainedModifyEntry_val_ResultType_unsigned_chainedResult,
        ___chainedModifyEntry_val_ResultType_unsigned_ResultType,
        __chainedModifyEntry_val_ResultType_unsigned,
        ____chainedModifyEntry_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedModifyEntry_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedModifyEntry_val_ResultType_signed_toBeSigned,
        _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedModifyEntry_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedModifyEntry_val_ResultType_signed_algorithmIdentifier,
        ___chainedModifyEntry_val_ResultType_signed_signature,
        __chainedModifyEntry_val_ResultType_signed,
        _chainedModifyEntry_val_ResultType,
        chainedModifyDN,
        ___chainedModifyDN_val_ArgumentType_unsigned_chainedArgument,
        ___chainedModifyDN_val_ArgumentType_unsigned_ArgumentType,
        __chainedModifyDN_val_ArgumentType_unsigned,
        ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedModifyDN_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedModifyDN_val_ArgumentType_signed_toBeSigned,
        _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedModifyDN_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedModifyDN_val_ArgumentType_signed_signature,
        __chainedModifyDN_val_ArgumentType_signed,
        _chainedModifyDN_val_ArgumentType,
        ___chainedModifyDN_val_ResultType_unsigned_chainedResult,
        ___chainedModifyDN_val_ResultType_unsigned_ResultType,
        __chainedModifyDN_val_ResultType_unsigned,
        ____chainedModifyDN_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedModifyDN_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedModifyDN_val_ResultType_signed_toBeSigned,
        _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedModifyDN_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedModifyDN_val_ResultType_signed_algorithmIdentifier,
        ___chainedModifyDN_val_ResultType_signed_signature,
        __chainedModifyDN_val_ResultType_signed,
        _chainedModifyDN_val_ResultType,
        chainedChangePassword,
        ___chainedChangePassword_val_ArgumentType_unsigned_chainedArgument,
        ___chainedChangePassword_val_ArgumentType_unsigned_ArgumentType,
        __chainedChangePassword_val_ArgumentType_unsigned,
        ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedChangePassword_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedChangePassword_val_ArgumentType_signed_toBeSigned,
        _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedChangePassword_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedChangePassword_val_ArgumentType_signed_signature,
        __chainedChangePassword_val_ArgumentType_signed,
        _chainedChangePassword_val_ArgumentType,
        ___chainedChangePassword_val_ResultType_unsigned_chainedResult,
        ___chainedChangePassword_val_ResultType_unsigned_ResultType,
        __chainedChangePassword_val_ResultType_unsigned,
        ____chainedChangePassword_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedChangePassword_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedChangePassword_val_ResultType_signed_toBeSigned,
        _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedChangePassword_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedChangePassword_val_ResultType_signed_algorithmIdentifier,
        ___chainedChangePassword_val_ResultType_signed_signature,
        __chainedChangePassword_val_ResultType_signed,
        _chainedChangePassword_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_1_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_1_signed,
        __OPERATION_Errors_val_ParameterType_1_1,
        ___OPERATION_Errors_val_ParameterType_2_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_1_signed,
        __OPERATION_Errors_val_ParameterType_2_1,
        chainedAdministerPassword,
        ___chainedAdministerPassword_val_ArgumentType_unsigned_chainedArgument,
        ___chainedAdministerPassword_val_ArgumentType_unsigned_ArgumentType,
        __chainedAdministerPassword_val_ArgumentType_unsigned,
        ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedAdministerPassword_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedAdministerPassword_val_ArgumentType_signed_toBeSigned,
        _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedAdministerPassword_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedAdministerPassword_val_ArgumentType_signed_signature,
        __chainedAdministerPassword_val_ArgumentType_signed,
        _chainedAdministerPassword_val_ArgumentType,
        ___chainedAdministerPassword_val_ResultType_unsigned_chainedResult,
        ___chainedAdministerPassword_val_ResultType_unsigned_ResultType,
        __chainedAdministerPassword_val_ResultType_unsigned,
        ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedAdministerPassword_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedAdministerPassword_val_ResultType_signed_toBeSigned,
        _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedAdministerPassword_val_ResultType_signed_algorithmIdentifier,
        ___chainedAdministerPassword_val_ResultType_signed_signature,
        __chainedAdministerPassword_val_ResultType_signed,
        _chainedAdministerPassword_val_ResultType,
        chainedLdapTransport,
        ___chainedLdapTransport_val_ArgumentType_unsigned_chainedArgument,
        ___chainedLdapTransport_val_ArgumentType_unsigned_ArgumentType,
        __chainedLdapTransport_val_ArgumentType_unsigned,
        ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedLdapTransport_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedLdapTransport_val_ArgumentType_signed_toBeSigned,
        _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedLdapTransport_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedLdapTransport_val_ArgumentType_signed_signature,
        __chainedLdapTransport_val_ArgumentType_signed,
        _chainedLdapTransport_val_ArgumentType,
        ___chainedLdapTransport_val_ResultType_unsigned_chainedResult,
        ____chainedLdapTransport_val_ResultType_unsigned_ResultType__item_,
        ___chainedLdapTransport_val_ResultType_unsigned_ResultType,
        __chainedLdapTransport_val_ResultType_unsigned,
        ____chainedLdapTransport_val_ResultType_signed_toBeSigned_chainedResult,
        _____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType__item_,
        ____chainedLdapTransport_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedLdapTransport_val_ResultType_signed_toBeSigned,
        _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedLdapTransport_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedLdapTransport_val_ResultType_signed_algorithmIdentifier,
        ___chainedLdapTransport_val_ResultType_signed_signature,
        __chainedLdapTransport_val_ResultType_signed,
        _chainedLdapTransport_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_1_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_2_signed,
        __OPERATION_Errors_val_ParameterType_1_2,
        ___OPERATION_Errors_val_ParameterType_2_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_2_signed,
        __OPERATION_Errors_val_ParameterType_2_2,
        chainedLinkedLDAP,
        ___chainedLinkedLDAP_val_ArgumentType_unsigned_chainedArgument,
        ___chainedLinkedLDAP_val_ArgumentType_unsigned_ArgumentType,
        __chainedLinkedLDAP_val_ArgumentType_unsigned,
        ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_chainedArgument,
        ____chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned_ArgumentType,
        ___chainedLinkedLDAP_val_ArgumentType_signed_toBeSigned,
        _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_algorithm,
        _____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters_tab,
        ____chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier_parameters,
        ___chainedLinkedLDAP_val_ArgumentType_signed_algorithmIdentifier,
        ___chainedLinkedLDAP_val_ArgumentType_signed_signature,
        __chainedLinkedLDAP_val_ArgumentType_signed,
        _chainedLinkedLDAP_val_ArgumentType,
        ___chainedLinkedLDAP_val_ResultType_unsigned_chainedResult,
        ___chainedLinkedLDAP_val_ResultType_unsigned_ResultType,
        __chainedLinkedLDAP_val_ResultType_unsigned,
        ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_chainedResult,
        ____chainedLinkedLDAP_val_ResultType_signed_toBeSigned_ResultType,
        ___chainedLinkedLDAP_val_ResultType_signed_toBeSigned,
        _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm_tab,
        ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_algorithm,
        _____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters_tab,
        ____chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier_parameters,
        ___chainedLinkedLDAP_val_ResultType_signed_algorithmIdentifier,
        ___chainedLinkedLDAP_val_ResultType_signed_signature,
        __chainedLinkedLDAP_val_ResultType_signed,
        _chainedLinkedLDAP_val_ResultType,
    ]

class DSAOperationalAttributeTypes:

    _name_  = u'DSAOperationalAttributeTypes'
    _oid_   = [2, 5, 1, 22, 8]
    
    _obj_ = [
        u'dseType',
        u'DSEType',
        u'myAccessPoint',
        u'superiorKnowledge',
        u'specificKnowledge',
        u'nonSpecificKnowledge',
        u'SupplierOrConsumer',
        u'SupplierInformation',
        u'supplierKnowledge',
        u'ConsumerInformation',
        u'consumerKnowledge',
        u'SupplierAndConsumers',
        u'secondaryShadows',
        u'ditBridgeKnowledge',
        u'accessPointMatch',
        u'masterAndShadowAccessPointsMatch',
        u'supplierOrConsumerInformationMatch',
        u'supplierAndConsumersMatch',
        u'id-doa-dseType',
        u'id-doa-myAccessPoint',
        u'id-doa-superiorKnowledge',
        u'id-doa-specificKnowledge',
        u'id-doa-nonSpecificKnowledge',
        u'id-doa-supplierKnowledge',
        u'id-doa-consumerKnowledge',
        u'id-doa-secondaryShadows',
        u'id-doa-ditBridgeKnowledge',
        u'id-kmr-accessPointMatch',
        u'id-kmr-masterShadowMatch',
        u'id-kmr-supplierConsumerMatch',
        u'id-kmr-supplierConsumersMatch',
        ]
    _type_ = [
        u'DSEType',
        u'SupplierOrConsumer',
        u'SupplierInformation',
        u'ConsumerInformation',
        u'SupplierAndConsumers',
        ]
    _set_ = [
        ]
    _val_ = [
        u'dseType',
        u'myAccessPoint',
        u'superiorKnowledge',
        u'specificKnowledge',
        u'nonSpecificKnowledge',
        u'supplierKnowledge',
        u'consumerKnowledge',
        u'secondaryShadows',
        u'ditBridgeKnowledge',
        u'accessPointMatch',
        u'masterAndShadowAccessPointsMatch',
        u'supplierOrConsumerInformationMatch',
        u'supplierAndConsumersMatch',
        u'id-doa-dseType',
        u'id-doa-myAccessPoint',
        u'id-doa-superiorKnowledge',
        u'id-doa-specificKnowledge',
        u'id-doa-nonSpecificKnowledge',
        u'id-doa-supplierKnowledge',
        u'id-doa-consumerKnowledge',
        u'id-doa-secondaryShadows',
        u'id-doa-ditBridgeKnowledge',
        u'id-kmr-accessPointMatch',
        u'id-kmr-masterShadowMatch',
        u'id-kmr-supplierConsumerMatch',
        u'id-kmr-supplierConsumersMatch',
        ]
    _class_ = [
        u'dseType',
        u'myAccessPoint',
        u'superiorKnowledge',
        u'specificKnowledge',
        u'nonSpecificKnowledge',
        u'supplierKnowledge',
        u'consumerKnowledge',
        u'secondaryShadows',
        u'ditBridgeKnowledge',
        u'accessPointMatch',
        u'masterAndShadowAccessPointsMatch',
        u'supplierOrConsumerInformationMatch',
        u'supplierAndConsumersMatch',
        ]
    _param_ = [
        ]
    
    #-----< dseType >-----#
    dseType = CLASS(name=u'dseType', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dseType_val_Type = BIT_STR(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'DSEType')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = BIT_STR(name=u'AssertionType', mode=MODE_TYPE)
    dseType._val = dict([(u'Type', _dseType_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), (u'ldapName', [u'bitStringMatch']), (u'id', (2, 5, 13, 16))])), (u'single-valued', True), (u'no-user-modification', True), (u'usage', u'dSAOperation'), (u'id', (2, 5, 12, 0))])
    
    #-----< DSEType >-----#
    DSEType = BIT_STR(name=u'DSEType', mode=MODE_TYPE)
    DSEType._cont = ASN1Dict([(u'root', 0), (u'glue', 1), (u'cp', 2), (u'entry', 3), (u'alias', 4), (u'subr', 5), (u'nssr', 6), (u'supr', 7), (u'xr', 8), (u'admPoint', 9), (u'subentry', 10), (u'shadow', 11), (u'immSupr', 13), (u'rhob', 14), (u'sa', 15), (u'dsSubentry', 16), (u'familyMember', 17), (u'ditBridge', 18)])
    
    #-----< myAccessPoint >-----#
    myAccessPoint = CLASS(name=u'myAccessPoint', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _myAccessPoint_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    myAccessPoint._val = dict([(u'Type', _myAccessPoint_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'id', (2, 5, 14, 0))])), (u'single-valued', True), (u'no-user-modification', True), (u'usage', u'dSAOperation'), (u'id', (2, 5, 12, 1))])
    
    #-----< superiorKnowledge >-----#
    superiorKnowledge = CLASS(name=u'superiorKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _superiorKnowledge_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')))
    superiorKnowledge._val = dict([(u'Type', _superiorKnowledge_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'id', (2, 5, 14, 0))])), (u'no-user-modification', True), (u'usage', u'dSAOperation'), (u'id', (2, 5, 12, 2))])
    
    #-----< specificKnowledge >-----#
    specificKnowledge = CLASS(name=u'specificKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _specificKnowledge_val_Type = SET_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1 = SET_OF(name=u'AssertionType', mode=MODE_TYPE)
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1._cont = _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1__item_
    specificKnowledge._val = dict([(u'Type', _specificKnowledge_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'id', (2, 5, 14, 1))])), (u'single-valued', True), (u'no-user-modification', True), (u'usage', u'distributedOperation'), (u'id', (2, 5, 12, 3))])
    
    #-----< nonSpecificKnowledge >-----#
    nonSpecificKnowledge = CLASS(name=u'nonSpecificKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _nonSpecificKnowledge_val_Type = SET_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')))
    nonSpecificKnowledge._val = dict([(u'Type', _nonSpecificKnowledge_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1), (u'id', (2, 5, 14, 1))])), (u'no-user-modification', True), (u'usage', u'distributedOperation'), (u'id', (2, 5, 12, 4))])
    
    #-----< SupplierOrConsumer >-----#
    SupplierOrConsumer = SET(name=u'SupplierOrConsumer', mode=MODE_TYPE)
    _SupplierOrConsumer_ae_title = CHOICE(name=u'ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _SupplierOrConsumer_address = SEQ(name=u'address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _SupplierOrConsumer_protocolInformation = SET_OF(name=u'protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SupplierOrConsumer_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _SupplierOrConsumer_protocolInformation._cont = __SupplierOrConsumer_protocolInformation__item_
    _SupplierOrConsumer_agreementID = SEQ(name=u'agreementID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    SupplierOrConsumer._cont = ASN1Dict([
        (u'ae-title', _SupplierOrConsumer_ae_title),
        (u'address', _SupplierOrConsumer_address),
        (u'protocolInformation', _SupplierOrConsumer_protocolInformation),
        (u'agreementID', _SupplierOrConsumer_agreementID),
        ])
    SupplierOrConsumer._ext = []
    
    #-----< SupplierInformation >-----#
    SupplierInformation = SET(name=u'SupplierInformation', mode=MODE_TYPE)
    _SupplierInformation_ae_title = CHOICE(name=u'ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _SupplierInformation_address = SEQ(name=u'address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _SupplierInformation_protocolInformation = SET_OF(name=u'protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SupplierInformation_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _SupplierInformation_protocolInformation._cont = __SupplierInformation_protocolInformation__item_
    _SupplierInformation_agreementID = SEQ(name=u'agreementID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _SupplierInformation_supplier_is_master = BOOL(name=u'supplier-is-master', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _SupplierInformation_non_supplying_master = SET(name=u'non-supplying-master', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')), opt=True)
    SupplierInformation._cont = ASN1Dict([
        (u'ae-title', _SupplierInformation_ae_title),
        (u'address', _SupplierInformation_address),
        (u'protocolInformation', _SupplierInformation_protocolInformation),
        (u'agreementID', _SupplierInformation_agreementID),
        (u'supplier-is-master', _SupplierInformation_supplier_is_master),
        (u'non-supplying-master', _SupplierInformation_non_supplying_master),
        ])
    SupplierInformation._ext = []
    
    #-----< supplierKnowledge >-----#
    supplierKnowledge = CLASS(name=u'supplierKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supplierKnowledge_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'SupplierInformation')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2 = SET(name=u'AssertionType', mode=MODE_TYPE)
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2_ae_title = CHOICE(name=u'ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2_agreement_identifier = INT(name=u'agreement-identifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2._cont = ASN1Dict([
        (u'ae-title', _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2_ae_title),
        (u'agreement-identifier', _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2_agreement_identifier),
        ])
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2._ext = None
    supplierKnowledge._val = dict([(u'Type', _supplierKnowledge_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), (u'id', (2, 5, 14, 2))])), (u'no-user-modification', True), (u'usage', u'dSAOperation'), (u'id', (2, 5, 12, 5))])
    
    #-----< ConsumerInformation >-----#
    ConsumerInformation = SET(name=u'ConsumerInformation', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'SupplierOrConsumer')))
    
    #-----< consumerKnowledge >-----#
    consumerKnowledge = CLASS(name=u'consumerKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _consumerKnowledge_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'ConsumerInformation')))
    consumerKnowledge._val = dict([(u'Type', _consumerKnowledge_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2), (u'id', (2, 5, 14, 2))])), (u'no-user-modification', True), (u'usage', u'dSAOperation'), (u'id', (2, 5, 12, 6))])
    
    #-----< SupplierAndConsumers >-----#
    SupplierAndConsumers = SET(name=u'SupplierAndConsumers', mode=MODE_TYPE)
    _SupplierAndConsumers_ae_title = CHOICE(name=u'ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    _SupplierAndConsumers_address = SEQ(name=u'address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    _SupplierAndConsumers_protocolInformation = SET_OF(name=u'protocolInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SupplierAndConsumers_protocolInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    _SupplierAndConsumers_protocolInformation._cont = __SupplierAndConsumers_protocolInformation__item_
    _SupplierAndConsumers_consumers = SET_OF(name=u'consumers', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __SupplierAndConsumers_consumers__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')))
    _SupplierAndConsumers_consumers._cont = __SupplierAndConsumers_consumers__item_
    SupplierAndConsumers._cont = ASN1Dict([
        (u'ae-title', _SupplierAndConsumers_ae_title),
        (u'address', _SupplierAndConsumers_address),
        (u'protocolInformation', _SupplierAndConsumers_protocolInformation),
        (u'consumers', _SupplierAndConsumers_consumers),
        ])
    SupplierAndConsumers._ext = []
    
    #-----< secondaryShadows >-----#
    secondaryShadows = CLASS(name=u'secondaryShadows', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _secondaryShadows_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DSAOperationalAttributeTypes', 'SupplierAndConsumers')))
    secondaryShadows._val = dict([(u'Type', _secondaryShadows_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'id', (2, 5, 14, 3))])), (u'no-user-modification', True), (u'usage', u'dSAOperation'), (u'id', (2, 5, 12, 7))])
    
    #-----< ditBridgeKnowledge >-----#
    ditBridgeKnowledge = CLASS(name=u'ditBridgeKnowledge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _ditBridgeKnowledge_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DitBridgeKnowledge')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3 = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    ditBridgeKnowledge._val = dict([(u'Type', _ditBridgeKnowledge_val_Type), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'directoryStringFirstComponentMatch']), (u'id', (2, 5, 13, 31))])), (u'no-user-modification', True), (u'usage', u'dSAOperation'), (u'id', (2, 5, 12, 8))])
    
    #-----< accessPointMatch >-----#
    accessPointMatch = CLASS(name=u'accessPointMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _accessPointMatch_val_AssertionType = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    accessPointMatch._val = dict([(u'AssertionType', _accessPointMatch_val_AssertionType), (u'id', (2, 5, 14, 0))])
    
    #-----< masterAndShadowAccessPointsMatch >-----#
    masterAndShadowAccessPointsMatch = CLASS(name=u'masterAndShadowAccessPointsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _masterAndShadowAccessPointsMatch_val_AssertionType = SET_OF(name=u'AssertionType', mode=MODE_TYPE)
    __masterAndShadowAccessPointsMatch_val_AssertionType__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _masterAndShadowAccessPointsMatch_val_AssertionType._cont = __masterAndShadowAccessPointsMatch_val_AssertionType__item_
    masterAndShadowAccessPointsMatch._val = dict([(u'AssertionType', _masterAndShadowAccessPointsMatch_val_AssertionType), (u'id', (2, 5, 14, 1))])
    
    #-----< supplierOrConsumerInformationMatch >-----#
    supplierOrConsumerInformationMatch = CLASS(name=u'supplierOrConsumerInformationMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _supplierOrConsumerInformationMatch_val_AssertionType = SET(name=u'AssertionType', mode=MODE_TYPE)
    __supplierOrConsumerInformationMatch_val_AssertionType_ae_title = CHOICE(name=u'ae-title', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')))
    __supplierOrConsumerInformationMatch_val_AssertionType_agreement_identifier = INT(name=u'agreement-identifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _supplierOrConsumerInformationMatch_val_AssertionType._cont = ASN1Dict([
        (u'ae-title', __supplierOrConsumerInformationMatch_val_AssertionType_ae_title),
        (u'agreement-identifier', __supplierOrConsumerInformationMatch_val_AssertionType_agreement_identifier),
        ])
    _supplierOrConsumerInformationMatch_val_AssertionType._ext = None
    supplierOrConsumerInformationMatch._val = dict([(u'AssertionType', _supplierOrConsumerInformationMatch_val_AssertionType), (u'id', (2, 5, 14, 2))])
    
    #-----< supplierAndConsumersMatch >-----#
    supplierAndConsumersMatch = CLASS(name=u'supplierAndConsumersMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _supplierAndConsumersMatch_val_AssertionType = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    supplierAndConsumersMatch._val = dict([(u'AssertionType', _supplierAndConsumersMatch_val_AssertionType), (u'id', (2, 5, 14, 3))])
    
    #-----< id-doa-dseType >-----#
    id_doa_dseType = OID(name=u'id-doa-dseType', mode=MODE_VALUE)
    id_doa_dseType._val = (2, 5, 12, 0)
    
    #-----< id-doa-myAccessPoint >-----#
    id_doa_myAccessPoint = OID(name=u'id-doa-myAccessPoint', mode=MODE_VALUE)
    id_doa_myAccessPoint._val = (2, 5, 12, 1)
    
    #-----< id-doa-superiorKnowledge >-----#
    id_doa_superiorKnowledge = OID(name=u'id-doa-superiorKnowledge', mode=MODE_VALUE)
    id_doa_superiorKnowledge._val = (2, 5, 12, 2)
    
    #-----< id-doa-specificKnowledge >-----#
    id_doa_specificKnowledge = OID(name=u'id-doa-specificKnowledge', mode=MODE_VALUE)
    id_doa_specificKnowledge._val = (2, 5, 12, 3)
    
    #-----< id-doa-nonSpecificKnowledge >-----#
    id_doa_nonSpecificKnowledge = OID(name=u'id-doa-nonSpecificKnowledge', mode=MODE_VALUE)
    id_doa_nonSpecificKnowledge._val = (2, 5, 12, 4)
    
    #-----< id-doa-supplierKnowledge >-----#
    id_doa_supplierKnowledge = OID(name=u'id-doa-supplierKnowledge', mode=MODE_VALUE)
    id_doa_supplierKnowledge._val = (2, 5, 12, 5)
    
    #-----< id-doa-consumerKnowledge >-----#
    id_doa_consumerKnowledge = OID(name=u'id-doa-consumerKnowledge', mode=MODE_VALUE)
    id_doa_consumerKnowledge._val = (2, 5, 12, 6)
    
    #-----< id-doa-secondaryShadows >-----#
    id_doa_secondaryShadows = OID(name=u'id-doa-secondaryShadows', mode=MODE_VALUE)
    id_doa_secondaryShadows._val = (2, 5, 12, 7)
    
    #-----< id-doa-ditBridgeKnowledge >-----#
    id_doa_ditBridgeKnowledge = OID(name=u'id-doa-ditBridgeKnowledge', mode=MODE_VALUE)
    id_doa_ditBridgeKnowledge._val = (2, 5, 12, 8)
    
    #-----< id-kmr-accessPointMatch >-----#
    id_kmr_accessPointMatch = OID(name=u'id-kmr-accessPointMatch', mode=MODE_VALUE)
    id_kmr_accessPointMatch._val = (2, 5, 14, 0)
    
    #-----< id-kmr-masterShadowMatch >-----#
    id_kmr_masterShadowMatch = OID(name=u'id-kmr-masterShadowMatch', mode=MODE_VALUE)
    id_kmr_masterShadowMatch._val = (2, 5, 14, 1)
    
    #-----< id-kmr-supplierConsumerMatch >-----#
    id_kmr_supplierConsumerMatch = OID(name=u'id-kmr-supplierConsumerMatch', mode=MODE_VALUE)
    id_kmr_supplierConsumerMatch._val = (2, 5, 14, 2)
    
    #-----< id-kmr-supplierConsumersMatch >-----#
    id_kmr_supplierConsumersMatch = OID(name=u'id-kmr-supplierConsumersMatch', mode=MODE_VALUE)
    id_kmr_supplierConsumersMatch._val = (2, 5, 14, 3)
    
    _all_ = [
        dseType,
        _dseType_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        DSEType,
        myAccessPoint,
        _myAccessPoint_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        superiorKnowledge,
        _superiorKnowledge_val_Type,
        specificKnowledge,
        _specificKnowledge_val_Type,
        _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1__item_,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_1,
        nonSpecificKnowledge,
        _nonSpecificKnowledge_val_Type,
        _SupplierOrConsumer_ae_title,
        _SupplierOrConsumer_address,
        __SupplierOrConsumer_protocolInformation__item_,
        _SupplierOrConsumer_protocolInformation,
        _SupplierOrConsumer_agreementID,
        SupplierOrConsumer,
        _SupplierInformation_ae_title,
        _SupplierInformation_address,
        __SupplierInformation_protocolInformation__item_,
        _SupplierInformation_protocolInformation,
        _SupplierInformation_agreementID,
        _SupplierInformation_supplier_is_master,
        _SupplierInformation_non_supplying_master,
        SupplierInformation,
        supplierKnowledge,
        _supplierKnowledge_val_Type,
        _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2_ae_title,
        _______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2_agreement_identifier,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_2,
        ConsumerInformation,
        consumerKnowledge,
        _consumerKnowledge_val_Type,
        _SupplierAndConsumers_ae_title,
        _SupplierAndConsumers_address,
        __SupplierAndConsumers_protocolInformation__item_,
        _SupplierAndConsumers_protocolInformation,
        __SupplierAndConsumers_consumers__item_,
        _SupplierAndConsumers_consumers,
        SupplierAndConsumers,
        secondaryShadows,
        _secondaryShadows_val_Type,
        ditBridgeKnowledge,
        _ditBridgeKnowledge_val_Type,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_3,
        accessPointMatch,
        _accessPointMatch_val_AssertionType,
        masterAndShadowAccessPointsMatch,
        __masterAndShadowAccessPointsMatch_val_AssertionType__item_,
        _masterAndShadowAccessPointsMatch_val_AssertionType,
        supplierOrConsumerInformationMatch,
        __supplierOrConsumerInformationMatch_val_AssertionType_ae_title,
        __supplierOrConsumerInformationMatch_val_AssertionType_agreement_identifier,
        _supplierOrConsumerInformationMatch_val_AssertionType,
        supplierAndConsumersMatch,
        _supplierAndConsumersMatch_val_AssertionType,
        id_doa_dseType,
        id_doa_myAccessPoint,
        id_doa_superiorKnowledge,
        id_doa_specificKnowledge,
        id_doa_nonSpecificKnowledge,
        id_doa_supplierKnowledge,
        id_doa_consumerKnowledge,
        id_doa_secondaryShadows,
        id_doa_ditBridgeKnowledge,
        id_kmr_accessPointMatch,
        id_kmr_masterShadowMatch,
        id_kmr_supplierConsumerMatch,
        id_kmr_supplierConsumersMatch,
    ]

class EnhancedSecurity:

    _name_  = u'EnhancedSecurity'
    _oid_   = [2, 5, 1, 28, 8]
    
    _obj_ = [
        u'OPTIONALLY-PROTECTED',
        u'OPTIONALLY-PROTECTED-SEQ',
        u'attributeValueSecurityLabelContext',
        u'SignedSecurityLabel',
        u'SignedSecurityLabelContent',
        u'SecurityLabel',
        u'SecurityPolicyIdentifier',
        u'SecurityClassification',
        u'PrivacyMark',
        u'SecurityCategories',
        u'clearance',
        u'Clearance',
        u'ClassList',
        u'SecurityCategory',
        u'SECURITY-CATEGORY',
        u'SecurityCategoriesTable',
        u'attributeIntegrityInfo',
        u'AttributeIntegrityInfo',
        u'AttributeIntegrityInfoContent',
        u'Signer',
        u'ThisEntry',
        u'IssuerAndSerialNumber',
        u'SpecificallyIdentified',
        u'Scope',
        u'SelectedTypes',
        u'AttribsHash',
        u'HashedAttributes',
        u'integrityInfo',
        u'attributeValueIntegrityInfoContext',
        u'AttributeValueIntegrityInfo',
        u'AttributeValueIntegrityInfoContent',
        u'AVIHash',
        u'AttributeTypeValueContexts',
        u'id-oc-integrityInfo',
        u'id-at-clearance',
        u'id-at-attributeIntegrityInfo',
        u'id-avc-attributeValueSecurityLabelContext',
        u'id-avc-attributeValueIntegrityInfoContext',
        ]
    _type_ = [
        u'OPTIONALLY-PROTECTED',
        u'OPTIONALLY-PROTECTED-SEQ',
        u'SignedSecurityLabel',
        u'SignedSecurityLabelContent',
        u'SecurityLabel',
        u'SecurityPolicyIdentifier',
        u'SecurityClassification',
        u'PrivacyMark',
        u'SecurityCategories',
        u'Clearance',
        u'ClassList',
        u'SecurityCategory',
        u'SECURITY-CATEGORY',
        u'AttributeIntegrityInfo',
        u'AttributeIntegrityInfoContent',
        u'Signer',
        u'ThisEntry',
        u'IssuerAndSerialNumber',
        u'SpecificallyIdentified',
        u'Scope',
        u'SelectedTypes',
        u'AttribsHash',
        u'HashedAttributes',
        u'AttributeValueIntegrityInfo',
        u'AttributeValueIntegrityInfoContent',
        u'AVIHash',
        u'AttributeTypeValueContexts',
        ]
    _set_ = [
        u'SecurityCategoriesTable',
        ]
    _val_ = [
        u'attributeValueSecurityLabelContext',
        u'clearance',
        u'attributeIntegrityInfo',
        u'integrityInfo',
        u'attributeValueIntegrityInfoContext',
        u'id-oc-integrityInfo',
        u'id-at-clearance',
        u'id-at-attributeIntegrityInfo',
        u'id-avc-attributeValueSecurityLabelContext',
        u'id-avc-attributeValueIntegrityInfoContext',
        ]
    _class_ = [
        u'attributeValueSecurityLabelContext',
        u'clearance',
        u'SECURITY-CATEGORY',
        u'SecurityCategoriesTable',
        u'attributeIntegrityInfo',
        u'integrityInfo',
        u'attributeValueIntegrityInfoContext',
        ]
    _param_ = [
        u'OPTIONALLY-PROTECTED',
        u'OPTIONALLY-PROTECTED-SEQ',
        ]
    
    #-----< OPTIONALLY-PROTECTED >-----#
    OPTIONALLY_PROTECTED = CHOICE(name=u'OPTIONALLY-PROTECTED', mode=MODE_TYPE, param=True)
    
    #-----< OPTIONALLY-PROTECTED-SEQ >-----#
    OPTIONALLY_PROTECTED_SEQ = CHOICE(name=u'OPTIONALLY-PROTECTED-SEQ', mode=MODE_TYPE, param=True)
    
    #-----< attributeValueSecurityLabelContext >-----#
    attributeValueSecurityLabelContext = CLASS(name=u'attributeValueSecurityLabelContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _attributeValueSecurityLabelContext_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SignedSecurityLabel')))
    attributeValueSecurityLabelContext._val = dict([(u'Type', _attributeValueSecurityLabelContext_val_Type), (u'id', (2, 5, 31, 3))])
    
    #-----< SignedSecurityLabel >-----#
    SignedSecurityLabel = SEQ(name=u'SignedSecurityLabel', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _SignedSecurityLabel_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SignedSecurityLabelContent')))
    _SignedSecurityLabel_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SignedSecurityLabel_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___SignedSecurityLabel_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SignedSecurityLabel_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SignedSecurityLabel_algorithmIdentifier_algorithm._const_tab = ___SignedSecurityLabel_algorithmIdentifier_algorithm_tab
    __SignedSecurityLabel_algorithmIdentifier_algorithm._const_tab_at = None
    __SignedSecurityLabel_algorithmIdentifier_algorithm._const_tab_id = u'id'
    __SignedSecurityLabel_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___SignedSecurityLabel_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SignedSecurityLabel_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SignedSecurityLabel_algorithmIdentifier_parameters._const_tab = ___SignedSecurityLabel_algorithmIdentifier_parameters_tab
    __SignedSecurityLabel_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    __SignedSecurityLabel_algorithmIdentifier_parameters._const_tab_id = u'Type'
    _SignedSecurityLabel_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', __SignedSecurityLabel_algorithmIdentifier_algorithm),
        (u'parameters', __SignedSecurityLabel_algorithmIdentifier_parameters),
        ])
    _SignedSecurityLabel_algorithmIdentifier._ext = []
    _SignedSecurityLabel_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    SignedSecurityLabel._cont = ASN1Dict([
        (u'toBeSigned', _SignedSecurityLabel_toBeSigned),
        (u'algorithmIdentifier', _SignedSecurityLabel_algorithmIdentifier),
        (u'signature', _SignedSecurityLabel_signature),
        ])
    SignedSecurityLabel._ext = []
    
    #-----< SignedSecurityLabelContent >-----#
    SignedSecurityLabelContent = SEQ(name=u'SignedSecurityLabelContent', mode=MODE_TYPE)
    _SignedSecurityLabelContent_attHash = SEQ(name=u'attHash', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'HASH')))
    __SignedSecurityLabelContent_attHash_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm._const_tab = ____SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm_tab
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm._const_tab_at = None
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters._const_tab = ____SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters_tab
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __SignedSecurityLabelContent_attHash_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm),
        (u'parameters', ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters),
        ])
    __SignedSecurityLabelContent_attHash_algorithmIdentifier._ext = []
    __SignedSecurityLabelContent_attHash_hashValue = BIT_STR(name=u'hashValue', mode=MODE_TYPE)
    _SignedSecurityLabelContent_attHash._cont = ASN1Dict([
        (u'algorithmIdentifier', __SignedSecurityLabelContent_attHash_algorithmIdentifier),
        (u'hashValue', __SignedSecurityLabelContent_attHash_hashValue),
        ])
    _SignedSecurityLabelContent_attHash._ext = []
    _SignedSecurityLabelContent_issuer = CHOICE(name=u'issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _SignedSecurityLabelContent_keyIdentifier = OCT_STR(name=u'keyIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'KeyIdentifier')), opt=True)
    _SignedSecurityLabelContent_securityLabel = SET(name=u'securityLabel', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityLabel')))
    SignedSecurityLabelContent._cont = ASN1Dict([
        (u'attHash', _SignedSecurityLabelContent_attHash),
        (u'issuer', _SignedSecurityLabelContent_issuer),
        (u'keyIdentifier', _SignedSecurityLabelContent_keyIdentifier),
        (u'securityLabel', _SignedSecurityLabelContent_securityLabel),
        ])
    SignedSecurityLabelContent._ext = []
    
    #-----< SecurityLabel >-----#
    SecurityLabel = SET(name=u'SecurityLabel', mode=MODE_TYPE)
    _SecurityLabel_security_policy_identifier = OID(name=u'security-policy-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityPolicyIdentifier')), opt=True)
    _SecurityLabel_security_classification = INT(name=u'security-classification', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityClassification')), opt=True)
    _SecurityLabel_privacy_mark = STR_PRINT(name=u'privacy-mark', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'PrivacyMark')), opt=True)
    _SecurityLabel_security_categories = SET_OF(name=u'security-categories', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityCategories')), opt=True)
    SecurityLabel._cont = ASN1Dict([
        (u'security-policy-identifier', _SecurityLabel_security_policy_identifier),
        (u'security-classification', _SecurityLabel_security_classification),
        (u'privacy-mark', _SecurityLabel_privacy_mark),
        (u'security-categories', _SecurityLabel_security_categories),
        ])
    SecurityLabel._ext = []
    
    #-----< SecurityPolicyIdentifier >-----#
    SecurityPolicyIdentifier = OID(name=u'SecurityPolicyIdentifier', mode=MODE_TYPE)
    
    #-----< SecurityClassification >-----#
    SecurityClassification = INT(name=u'SecurityClassification', mode=MODE_TYPE)
    SecurityClassification._cont = ASN1Dict([(u'unmarked', 0), (u'unclassified', 1), (u'restricted', 2), (u'confidential', 3), (u'secret', 4), (u'top-secret', 5)])
    
    #-----< PrivacyMark >-----#
    PrivacyMark = STR_PRINT(name=u'PrivacyMark', mode=MODE_TYPE)
    PrivacyMark._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< SecurityCategories >-----#
    SecurityCategories = SET_OF(name=u'SecurityCategories', mode=MODE_TYPE)
    _SecurityCategories__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityCategory')))
    SecurityCategories._cont = _SecurityCategories__item_
    SecurityCategories._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< clearance >-----#
    clearance = CLASS(name=u'clearance', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _clearance_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'Clearance')))
    clearance._val = dict([(u'Type', _clearance_val_Type), (u'id', (2, 5, 4, 55))])
    
    #-----< Clearance >-----#
    Clearance = SEQ(name=u'Clearance', mode=MODE_TYPE)
    _Clearance_policyId = OID(name=u'policyId', mode=MODE_TYPE)
    _Clearance_classList = BIT_STR(name=u'classList', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'ClassList')), default=(1, 2))
    _Clearance_securityCategories = SET_OF(name=u'securityCategories', mode=MODE_TYPE, opt=True)
    __Clearance_securityCategories__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'SecurityCategory')))
    _Clearance_securityCategories._cont = __Clearance_securityCategories__item_
    _Clearance_securityCategories._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    Clearance._cont = ASN1Dict([
        (u'policyId', _Clearance_policyId),
        (u'classList', _Clearance_classList),
        (u'securityCategories', _Clearance_securityCategories),
        ])
    Clearance._ext = []
    
    #-----< ClassList >-----#
    ClassList = BIT_STR(name=u'ClassList', mode=MODE_TYPE)
    ClassList._cont = ASN1Dict([(u'unmarked', 0), (u'unclassified', 1), (u'restricted', 2), (u'confidential', 3), (u'secret', 4), (u'topSecret', 5)])
    
    #-----< SecurityCategory >-----#
    SecurityCategory = SEQ(name=u'SecurityCategory', mode=MODE_TYPE)
    _SecurityCategory_type = OID(name=u'type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('EnhancedSecurity', 'SECURITY-CATEGORY'), [u'id']))
    __SecurityCategory_type_tab = CLASS(name='_tab_SECURITY-CATEGORY', mode=MODE_SET, typeref=ASN1RefType(('EnhancedSecurity', 'SECURITY-CATEGORY')))
    __SecurityCategory_type_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SecurityCategory_type._const_tab = __SecurityCategory_type_tab
    _SecurityCategory_type._const_tab_at = None
    _SecurityCategory_type._const_tab_id = u'id'
    _SecurityCategory_value = OPEN(name=u'value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('EnhancedSecurity', 'SECURITY-CATEGORY'), [u'Type']))
    __SecurityCategory_value_tab = CLASS(name='_tab_SECURITY-CATEGORY', mode=MODE_SET, typeref=ASN1RefType(('EnhancedSecurity', 'SECURITY-CATEGORY')))
    __SecurityCategory_value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SecurityCategory_value._const_tab = __SecurityCategory_value_tab
    _SecurityCategory_value._const_tab_at = ('..', u'type')
    _SecurityCategory_value._const_tab_id = u'Type'
    SecurityCategory._cont = ASN1Dict([
        (u'type', _SecurityCategory_type),
        (u'value', _SecurityCategory_value),
        ])
    SecurityCategory._ext = []
    
    #-----< SECURITY-CATEGORY >-----#
    SECURITY_CATEGORY = CLASS(name=u'SECURITY-CATEGORY', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', u'TYPE-IDENTIFIER'), []))
    
    #-----< SecurityCategoriesTable >-----#
    SecurityCategoriesTable = CLASS(name=u'SecurityCategoriesTable', mode=MODE_SET, typeref=ASN1RefType(('EnhancedSecurity', 'SECURITY-CATEGORY')))
    SecurityCategoriesTable._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< attributeIntegrityInfo >-----#
    attributeIntegrityInfo = CLASS(name=u'attributeIntegrityInfo', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeIntegrityInfo_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttributeIntegrityInfo')))
    attributeIntegrityInfo._val = dict([(u'Type', _attributeIntegrityInfo_val_Type), (u'single-valued', True), (u'id', (2, 5, 4, 57))])
    
    #-----< AttributeIntegrityInfo >-----#
    AttributeIntegrityInfo = SEQ(name=u'AttributeIntegrityInfo', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _AttributeIntegrityInfo_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttributeIntegrityInfoContent')))
    _AttributeIntegrityInfo_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AttributeIntegrityInfo_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___AttributeIntegrityInfo_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeIntegrityInfo_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeIntegrityInfo_algorithmIdentifier_algorithm._const_tab = ___AttributeIntegrityInfo_algorithmIdentifier_algorithm_tab
    __AttributeIntegrityInfo_algorithmIdentifier_algorithm._const_tab_at = None
    __AttributeIntegrityInfo_algorithmIdentifier_algorithm._const_tab_id = u'id'
    __AttributeIntegrityInfo_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___AttributeIntegrityInfo_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeIntegrityInfo_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeIntegrityInfo_algorithmIdentifier_parameters._const_tab = ___AttributeIntegrityInfo_algorithmIdentifier_parameters_tab
    __AttributeIntegrityInfo_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    __AttributeIntegrityInfo_algorithmIdentifier_parameters._const_tab_id = u'Type'
    _AttributeIntegrityInfo_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', __AttributeIntegrityInfo_algorithmIdentifier_algorithm),
        (u'parameters', __AttributeIntegrityInfo_algorithmIdentifier_parameters),
        ])
    _AttributeIntegrityInfo_algorithmIdentifier._ext = []
    _AttributeIntegrityInfo_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    AttributeIntegrityInfo._cont = ASN1Dict([
        (u'toBeSigned', _AttributeIntegrityInfo_toBeSigned),
        (u'algorithmIdentifier', _AttributeIntegrityInfo_algorithmIdentifier),
        (u'signature', _AttributeIntegrityInfo_signature),
        ])
    AttributeIntegrityInfo._ext = []
    
    #-----< AttributeIntegrityInfoContent >-----#
    AttributeIntegrityInfoContent = SEQ(name=u'AttributeIntegrityInfoContent', mode=MODE_TYPE)
    _AttributeIntegrityInfoContent_scope = CHOICE(name=u'scope', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'Scope')))
    _AttributeIntegrityInfoContent_signer = CHOICE(name=u'signer', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'Signer')), opt=True)
    _AttributeIntegrityInfoContent_attribsHash = SEQ(name=u'attribsHash', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttribsHash')))
    AttributeIntegrityInfoContent._cont = ASN1Dict([
        (u'scope', _AttributeIntegrityInfoContent_scope),
        (u'signer', _AttributeIntegrityInfoContent_signer),
        (u'attribsHash', _AttributeIntegrityInfoContent_attribsHash),
        ])
    AttributeIntegrityInfoContent._ext = []
    
    #-----< Signer >-----#
    Signer = CHOICE(name=u'Signer', mode=MODE_TYPE)
    _Signer_thisEntry = CHOICE(name=u'thisEntry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('EnhancedSecurity', 'ThisEntry')))
    _Signer_thirdParty = SEQ(name=u'thirdParty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EnhancedSecurity', 'SpecificallyIdentified')))
    Signer._cont = ASN1Dict([
        (u'thisEntry', _Signer_thisEntry),
        (u'thirdParty', _Signer_thirdParty),
        ])
    Signer._ext = []
    
    #-----< ThisEntry >-----#
    ThisEntry = CHOICE(name=u'ThisEntry', mode=MODE_TYPE)
    _ThisEntry_onlyOne = NULL(name=u'onlyOne', mode=MODE_TYPE)
    _ThisEntry_specific = SEQ(name=u'specific', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'IssuerAndSerialNumber')))
    ThisEntry._cont = ASN1Dict([
        (u'onlyOne', _ThisEntry_onlyOne),
        (u'specific', _ThisEntry_specific),
        ])
    ThisEntry._ext = []
    
    #-----< IssuerAndSerialNumber >-----#
    IssuerAndSerialNumber = SEQ(name=u'IssuerAndSerialNumber', mode=MODE_TYPE)
    _IssuerAndSerialNumber_issuer = CHOICE(name=u'issuer', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _IssuerAndSerialNumber_serial = INT(name=u'serial', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')))
    IssuerAndSerialNumber._cont = ASN1Dict([
        (u'issuer', _IssuerAndSerialNumber_issuer),
        (u'serial', _IssuerAndSerialNumber_serial),
        ])
    IssuerAndSerialNumber._ext = []
    
    #-----< SpecificallyIdentified >-----#
    SpecificallyIdentified = SEQ(name=u'SpecificallyIdentified', mode=MODE_TYPE)
    _SpecificallyIdentified_name = CHOICE(name=u'name', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    _SpecificallyIdentified_issuer = CHOICE(name=u'issuer', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')), opt=True)
    _SpecificallyIdentified_serial = INT(name=u'serial', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificateSerialNumber')), opt=True)
    SpecificallyIdentified._cont = ASN1Dict([
        (u'name', _SpecificallyIdentified_name),
        (u'issuer', _SpecificallyIdentified_issuer),
        (u'serial', _SpecificallyIdentified_serial),
        ])
    SpecificallyIdentified._ext = None
    
    #-----< Scope >-----#
    Scope = CHOICE(name=u'Scope', mode=MODE_TYPE)
    _Scope_wholeEntry = NULL(name=u'wholeEntry', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Scope_selectedTypes = SEQ_OF(name=u'selectedTypes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EnhancedSecurity', 'SelectedTypes')))
    Scope._cont = ASN1Dict([
        (u'wholeEntry', _Scope_wholeEntry),
        (u'selectedTypes', _Scope_selectedTypes),
        ])
    Scope._ext = []
    
    #-----< SelectedTypes >-----#
    SelectedTypes = SEQ_OF(name=u'SelectedTypes', mode=MODE_TYPE)
    _SelectedTypes__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    SelectedTypes._cont = _SelectedTypes__item_
    SelectedTypes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AttribsHash >-----#
    AttribsHash = SEQ(name=u'AttribsHash', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'HASH')))
    _AttribsHash_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AttribsHash_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___AttribsHash_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttribsHash_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttribsHash_algorithmIdentifier_algorithm._const_tab = ___AttribsHash_algorithmIdentifier_algorithm_tab
    __AttribsHash_algorithmIdentifier_algorithm._const_tab_at = None
    __AttribsHash_algorithmIdentifier_algorithm._const_tab_id = u'id'
    __AttribsHash_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___AttribsHash_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttribsHash_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttribsHash_algorithmIdentifier_parameters._const_tab = ___AttribsHash_algorithmIdentifier_parameters_tab
    __AttribsHash_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    __AttribsHash_algorithmIdentifier_parameters._const_tab_id = u'Type'
    _AttribsHash_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', __AttribsHash_algorithmIdentifier_algorithm),
        (u'parameters', __AttribsHash_algorithmIdentifier_parameters),
        ])
    _AttribsHash_algorithmIdentifier._ext = []
    _AttribsHash_hashValue = BIT_STR(name=u'hashValue', mode=MODE_TYPE)
    AttribsHash._cont = ASN1Dict([
        (u'algorithmIdentifier', _AttribsHash_algorithmIdentifier),
        (u'hashValue', _AttribsHash_hashValue),
        ])
    AttribsHash._ext = []
    
    #-----< HashedAttributes >-----#
    HashedAttributes = SEQ_OF(name=u'HashedAttributes', mode=MODE_TYPE)
    _HashedAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    __HashedAttributes__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ___HashedAttributes__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ____HashedAttributes__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    ____HashedAttributes__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ___HashedAttributes__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', ____HashedAttributes__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ____HashedAttributes__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    __HashedAttributes__item__type._const_tab = ___HashedAttributes__item__type_tab
    __HashedAttributes__item__type._const_tab_at = None
    __HashedAttributes__item__type._const_tab_id = u'id'
    __HashedAttributes__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ___HashedAttributes__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ___HashedAttributes__item__values__item_._const_tab = ___HashedAttributes__item__type_tab
    ___HashedAttributes__item__values__item_._const_tab_at = ('..', '..', u'type')
    ___HashedAttributes__item__values__item_._const_tab_id = u'Type'
    __HashedAttributes__item__values._cont = ___HashedAttributes__item__values__item_
    __HashedAttributes__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __HashedAttributes__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ___HashedAttributes__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ____HashedAttributes__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____HashedAttributes__item__valuesWithContext__item__value._const_tab = ___HashedAttributes__item__type_tab
    ____HashedAttributes__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    ____HashedAttributes__item__valuesWithContext__item__value._const_tab_id = u'Type'
    ____HashedAttributes__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    _____HashedAttributes__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    ____HashedAttributes__item__valuesWithContext__item__contextList._cont = _____HashedAttributes__item__valuesWithContext__item__contextList__item_
    ____HashedAttributes__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___HashedAttributes__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', ____HashedAttributes__item__valuesWithContext__item__value),
        (u'contextList', ____HashedAttributes__item__valuesWithContext__item__contextList),
        ])
    ___HashedAttributes__item__valuesWithContext__item_._ext = []
    __HashedAttributes__item__valuesWithContext._cont = ___HashedAttributes__item__valuesWithContext__item_
    __HashedAttributes__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _HashedAttributes__item_._cont = ASN1Dict([
        (u'type', __HashedAttributes__item__type),
        (u'values', __HashedAttributes__item__values),
        (u'valuesWithContext', __HashedAttributes__item__valuesWithContext),
        ])
    _HashedAttributes__item_._ext = []
    HashedAttributes._cont = _HashedAttributes__item_
    HashedAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< integrityInfo >-----#
    integrityInfo = CLASS(name=u'integrityInfo', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttributeIntegrityInfo')))
    integrityInfo._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'auxiliary'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0), (u'single-valued', True), (u'id', (2, 5, 4, 57))])], rr=[], ev=None, er=[])), (u'id', (2, 5, 6, 40))])
    
    #-----< attributeValueIntegrityInfoContext >-----#
    attributeValueIntegrityInfoContext = CLASS(name=u'attributeValueIntegrityInfoContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _attributeValueIntegrityInfoContext_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttributeValueIntegrityInfo')))
    attributeValueIntegrityInfoContext._val = dict([(u'Type', _attributeValueIntegrityInfoContext_val_Type), (u'id', (2, 5, 31, 4))])
    
    #-----< AttributeValueIntegrityInfo >-----#
    AttributeValueIntegrityInfo = SEQ(name=u'AttributeValueIntegrityInfo', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    _AttributeValueIntegrityInfo_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AttributeValueIntegrityInfoContent')))
    _AttributeValueIntegrityInfo_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___AttributeValueIntegrityInfo_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeValueIntegrityInfo_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm._const_tab = ___AttributeValueIntegrityInfo_algorithmIdentifier_algorithm_tab
    __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm._const_tab_at = None
    __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm._const_tab_id = u'id'
    __AttributeValueIntegrityInfo_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___AttributeValueIntegrityInfo_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AttributeValueIntegrityInfo_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AttributeValueIntegrityInfo_algorithmIdentifier_parameters._const_tab = ___AttributeValueIntegrityInfo_algorithmIdentifier_parameters_tab
    __AttributeValueIntegrityInfo_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    __AttributeValueIntegrityInfo_algorithmIdentifier_parameters._const_tab_id = u'Type'
    _AttributeValueIntegrityInfo_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm),
        (u'parameters', __AttributeValueIntegrityInfo_algorithmIdentifier_parameters),
        ])
    _AttributeValueIntegrityInfo_algorithmIdentifier._ext = []
    _AttributeValueIntegrityInfo_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    AttributeValueIntegrityInfo._cont = ASN1Dict([
        (u'toBeSigned', _AttributeValueIntegrityInfo_toBeSigned),
        (u'algorithmIdentifier', _AttributeValueIntegrityInfo_algorithmIdentifier),
        (u'signature', _AttributeValueIntegrityInfo_signature),
        ])
    AttributeValueIntegrityInfo._ext = []
    
    #-----< AttributeValueIntegrityInfoContent >-----#
    AttributeValueIntegrityInfoContent = SEQ(name=u'AttributeValueIntegrityInfoContent', mode=MODE_TYPE)
    _AttributeValueIntegrityInfoContent_signer = CHOICE(name=u'signer', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'Signer')), opt=True)
    _AttributeValueIntegrityInfoContent_aVIHash = SEQ(name=u'aVIHash', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'AVIHash')))
    AttributeValueIntegrityInfoContent._cont = ASN1Dict([
        (u'signer', _AttributeValueIntegrityInfoContent_signer),
        (u'aVIHash', _AttributeValueIntegrityInfoContent_aVIHash),
        ])
    AttributeValueIntegrityInfoContent._ext = []
    
    #-----< AVIHash >-----#
    AVIHash = SEQ(name=u'AVIHash', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'HASH')))
    _AVIHash_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __AVIHash_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___AVIHash_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AVIHash_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AVIHash_algorithmIdentifier_algorithm._const_tab = ___AVIHash_algorithmIdentifier_algorithm_tab
    __AVIHash_algorithmIdentifier_algorithm._const_tab_at = None
    __AVIHash_algorithmIdentifier_algorithm._const_tab_id = u'id'
    __AVIHash_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___AVIHash_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___AVIHash_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __AVIHash_algorithmIdentifier_parameters._const_tab = ___AVIHash_algorithmIdentifier_parameters_tab
    __AVIHash_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    __AVIHash_algorithmIdentifier_parameters._const_tab_id = u'Type'
    _AVIHash_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', __AVIHash_algorithmIdentifier_algorithm),
        (u'parameters', __AVIHash_algorithmIdentifier_parameters),
        ])
    _AVIHash_algorithmIdentifier._ext = []
    _AVIHash_hashValue = BIT_STR(name=u'hashValue', mode=MODE_TYPE)
    AVIHash._cont = ASN1Dict([
        (u'algorithmIdentifier', _AVIHash_algorithmIdentifier),
        (u'hashValue', _AVIHash_hashValue),
        ])
    AVIHash._ext = []
    
    #-----< AttributeTypeValueContexts >-----#
    AttributeTypeValueContexts = SEQ(name=u'AttributeTypeValueContexts', mode=MODE_TYPE)
    _AttributeTypeValueContexts_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    __AttributeTypeValueContexts_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___AttributeTypeValueContexts_type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ___AttributeTypeValueContexts_type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __AttributeTypeValueContexts_type_tab._val = ASN1Set(rv=[dict([(u'Type', ___AttributeTypeValueContexts_type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ___AttributeTypeValueContexts_type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _AttributeTypeValueContexts_type._const_tab = __AttributeTypeValueContexts_type_tab
    _AttributeTypeValueContexts_type._const_tab_at = None
    _AttributeTypeValueContexts_type._const_tab_id = u'id'
    _AttributeTypeValueContexts_value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _AttributeTypeValueContexts_value._const_tab = __AttributeTypeValueContexts_type_tab
    _AttributeTypeValueContexts_value._const_tab_at = ('..', u'type')
    _AttributeTypeValueContexts_value._const_tab_id = u'Type'
    _AttributeTypeValueContexts_contextList = SET_OF(name=u'contextList', mode=MODE_TYPE, opt=True)
    __AttributeTypeValueContexts_contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _AttributeTypeValueContexts_contextList._cont = __AttributeTypeValueContexts_contextList__item_
    _AttributeTypeValueContexts_contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    AttributeTypeValueContexts._cont = ASN1Dict([
        (u'type', _AttributeTypeValueContexts_type),
        (u'value', _AttributeTypeValueContexts_value),
        (u'contextList', _AttributeTypeValueContexts_contextList),
        ])
    AttributeTypeValueContexts._ext = []
    
    #-----< id-oc-integrityInfo >-----#
    id_oc_integrityInfo = OID(name=u'id-oc-integrityInfo', mode=MODE_VALUE)
    id_oc_integrityInfo._val = (2, 5, 6, 40)
    
    #-----< id-at-clearance >-----#
    id_at_clearance = OID(name=u'id-at-clearance', mode=MODE_VALUE)
    id_at_clearance._val = (2, 5, 4, 55)
    
    #-----< id-at-attributeIntegrityInfo >-----#
    id_at_attributeIntegrityInfo = OID(name=u'id-at-attributeIntegrityInfo', mode=MODE_VALUE)
    id_at_attributeIntegrityInfo._val = (2, 5, 4, 57)
    
    #-----< id-avc-attributeValueSecurityLabelContext >-----#
    id_avc_attributeValueSecurityLabelContext = OID(name=u'id-avc-attributeValueSecurityLabelContext', mode=MODE_VALUE)
    id_avc_attributeValueSecurityLabelContext._val = (2, 5, 31, 3)
    
    #-----< id-avc-attributeValueIntegrityInfoContext >-----#
    id_avc_attributeValueIntegrityInfoContext = OID(name=u'id-avc-attributeValueIntegrityInfoContext', mode=MODE_VALUE)
    id_avc_attributeValueIntegrityInfoContext._val = (2, 5, 31, 4)
    
    _all_ = [
        attributeValueSecurityLabelContext,
        _attributeValueSecurityLabelContext_val_Type,
        _SignedSecurityLabel_toBeSigned,
        ___SignedSecurityLabel_algorithmIdentifier_algorithm_tab,
        __SignedSecurityLabel_algorithmIdentifier_algorithm,
        ___SignedSecurityLabel_algorithmIdentifier_parameters_tab,
        __SignedSecurityLabel_algorithmIdentifier_parameters,
        _SignedSecurityLabel_algorithmIdentifier,
        _SignedSecurityLabel_signature,
        SignedSecurityLabel,
        ____SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm_tab,
        ___SignedSecurityLabelContent_attHash_algorithmIdentifier_algorithm,
        ____SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters_tab,
        ___SignedSecurityLabelContent_attHash_algorithmIdentifier_parameters,
        __SignedSecurityLabelContent_attHash_algorithmIdentifier,
        __SignedSecurityLabelContent_attHash_hashValue,
        _SignedSecurityLabelContent_attHash,
        _SignedSecurityLabelContent_issuer,
        _SignedSecurityLabelContent_keyIdentifier,
        _SignedSecurityLabelContent_securityLabel,
        SignedSecurityLabelContent,
        _SecurityLabel_security_policy_identifier,
        _SecurityLabel_security_classification,
        _SecurityLabel_privacy_mark,
        _SecurityLabel_security_categories,
        SecurityLabel,
        SecurityPolicyIdentifier,
        SecurityClassification,
        PrivacyMark,
        _SecurityCategories__item_,
        SecurityCategories,
        clearance,
        _clearance_val_Type,
        _Clearance_policyId,
        _Clearance_classList,
        __Clearance_securityCategories__item_,
        _Clearance_securityCategories,
        Clearance,
        ClassList,
        __SecurityCategory_type_tab,
        _SecurityCategory_type,
        __SecurityCategory_value_tab,
        _SecurityCategory_value,
        SecurityCategory,
        SECURITY_CATEGORY,
        SecurityCategoriesTable,
        attributeIntegrityInfo,
        _attributeIntegrityInfo_val_Type,
        _AttributeIntegrityInfo_toBeSigned,
        ___AttributeIntegrityInfo_algorithmIdentifier_algorithm_tab,
        __AttributeIntegrityInfo_algorithmIdentifier_algorithm,
        ___AttributeIntegrityInfo_algorithmIdentifier_parameters_tab,
        __AttributeIntegrityInfo_algorithmIdentifier_parameters,
        _AttributeIntegrityInfo_algorithmIdentifier,
        _AttributeIntegrityInfo_signature,
        AttributeIntegrityInfo,
        _AttributeIntegrityInfoContent_scope,
        _AttributeIntegrityInfoContent_signer,
        _AttributeIntegrityInfoContent_attribsHash,
        AttributeIntegrityInfoContent,
        _Signer_thisEntry,
        _Signer_thirdParty,
        Signer,
        _ThisEntry_onlyOne,
        _ThisEntry_specific,
        ThisEntry,
        _IssuerAndSerialNumber_issuer,
        _IssuerAndSerialNumber_serial,
        IssuerAndSerialNumber,
        _SpecificallyIdentified_name,
        _SpecificallyIdentified_issuer,
        _SpecificallyIdentified_serial,
        SpecificallyIdentified,
        _Scope_wholeEntry,
        _Scope_selectedTypes,
        Scope,
        _SelectedTypes__item_,
        SelectedTypes,
        ___AttribsHash_algorithmIdentifier_algorithm_tab,
        __AttribsHash_algorithmIdentifier_algorithm,
        ___AttribsHash_algorithmIdentifier_parameters_tab,
        __AttribsHash_algorithmIdentifier_parameters,
        _AttribsHash_algorithmIdentifier,
        _AttribsHash_hashValue,
        AttribsHash,
        ___HashedAttributes__item__type_tab,
        ____HashedAttributes__item__type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        ____HashedAttributes__item__type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        __HashedAttributes__item__type,
        ___HashedAttributes__item__values__item_,
        __HashedAttributes__item__values,
        ____HashedAttributes__item__valuesWithContext__item__value,
        _____HashedAttributes__item__valuesWithContext__item__contextList__item_,
        ____HashedAttributes__item__valuesWithContext__item__contextList,
        ___HashedAttributes__item__valuesWithContext__item_,
        __HashedAttributes__item__valuesWithContext,
        _HashedAttributes__item_,
        HashedAttributes,
        integrityInfo,
        ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0,
        ___pmiUser_Superclasses_MandatoryAttributes_val_Type_0_0,
        attributeValueIntegrityInfoContext,
        _attributeValueIntegrityInfoContext_val_Type,
        _AttributeValueIntegrityInfo_toBeSigned,
        ___AttributeValueIntegrityInfo_algorithmIdentifier_algorithm_tab,
        __AttributeValueIntegrityInfo_algorithmIdentifier_algorithm,
        ___AttributeValueIntegrityInfo_algorithmIdentifier_parameters_tab,
        __AttributeValueIntegrityInfo_algorithmIdentifier_parameters,
        _AttributeValueIntegrityInfo_algorithmIdentifier,
        _AttributeValueIntegrityInfo_signature,
        AttributeValueIntegrityInfo,
        _AttributeValueIntegrityInfoContent_signer,
        _AttributeValueIntegrityInfoContent_aVIHash,
        AttributeValueIntegrityInfoContent,
        ___AVIHash_algorithmIdentifier_algorithm_tab,
        __AVIHash_algorithmIdentifier_algorithm,
        ___AVIHash_algorithmIdentifier_parameters_tab,
        __AVIHash_algorithmIdentifier_parameters,
        _AVIHash_algorithmIdentifier,
        _AVIHash_hashValue,
        AVIHash,
        __AttributeTypeValueContexts_type_tab,
        ___AttributeTypeValueContexts_type_tab_val_Type_0,
        ___AttributeTypeValueContexts_type_tab_val_Type_1,
        _AttributeTypeValueContexts_type,
        _AttributeTypeValueContexts_value,
        __AttributeTypeValueContexts_contextList__item_,
        _AttributeTypeValueContexts_contextList,
        AttributeTypeValueContexts,
        id_oc_integrityInfo,
        id_at_clearance,
        id_at_attributeIntegrityInfo,
        id_avc_attributeValueSecurityLabelContext,
        id_avc_attributeValueIntegrityInfoContext,
    ]

class GenericChargingDataTypes:

    _name_  = u'GenericChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 0, 0, 1]
    
    _obj_ = [
        u'BCDDirectoryNumber',
        u'CallDuration',
        u'CalledNumber',
        u'CallingNumber',
        u'CellId',
        u'ChargeIndicator',
        u'CauseForRecClosing',
        u'CauseForTerm',
        u'ChargingID',
        u'CivicAddressInformation',
        u'CNIPMulticastDistribution',
        u'DataVolumeOctets',
        u'DynamicAddressFlag',
        u'Diagnostics',
        u'DiameterIdentity',
        u'EnhancedDiagnostics',
        u'GSNAddress',
        u'InvolvedParty',
        u'IPAddress',
        u'IPBinaryAddress',
        u'IPBinV4Address',
        u'IPBinV6Address',
        u'IPBinV6AddressWithOrWithoutPrefixLength',
        u'IPBinV6AddressWithPrefixLength',
        u'IPTextRepresentedAddress',
        u'LCSCause',
        u'LCSClientIdentity',
        u'LCSQoSInfo',
        u'LevelOfCAMELService',
        u'LocalSequenceNumber',
        u'LocationAreaAndCell',
        u'LocationAreaCode',
        u'ManagementExtensions',
        u'MBMS2G3GIndicator',
        u'MBMSInformation',
        u'MBMSServiceArea',
        u'MBMSServiceType',
        u'MBMSSessionIdentity',
        u'MBMSTime',
        u'MBMSUserServiceType',
        u'MCC-MNC',
        u'MessageClass',
        u'MessageReference',
        u'MSCAddress',
        u'MscNo',
        u'MSISDN',
        u'MSTimeZone',
        u'NodeID',
        u'NodeAddress',
        u'PDPAddressPrefixLength',
        u'PDPAddress',
        u'PLMN-Id',
        u'PositioningData',
        u'PriorityType',
        u'RANNASCause',
        u'RATType',
        u'RecordingEntity',
        u'RecordType',
        u'RequiredMBMSBearerCapabilities',
        u'RoutingAreaCode',
        u'SCSASAddress',
        u'Session-Id',
        u'ServiceContextID',
        u'ServiceSpecificInfo',
        u'SMSResult',
        u'SmsTpDestinationNumber',
        u'SubscriberEquipmentNumber',
        u'SubscriberEquipmentType',
        u'SubscriptionID',
        u'SubscriptionIDType',
        u'SystemType',
        u'ThreeGPPPSDataOffStatus',
        u'TimeStamp',
        u'TMGI',
        ]
    _type_ = [
        u'BCDDirectoryNumber',
        u'CallDuration',
        u'CalledNumber',
        u'CallingNumber',
        u'CellId',
        u'ChargeIndicator',
        u'CauseForRecClosing',
        u'CauseForTerm',
        u'ChargingID',
        u'CivicAddressInformation',
        u'CNIPMulticastDistribution',
        u'DataVolumeOctets',
        u'DynamicAddressFlag',
        u'Diagnostics',
        u'DiameterIdentity',
        u'EnhancedDiagnostics',
        u'GSNAddress',
        u'InvolvedParty',
        u'IPAddress',
        u'IPBinaryAddress',
        u'IPBinV4Address',
        u'IPBinV6Address',
        u'IPBinV6AddressWithOrWithoutPrefixLength',
        u'IPBinV6AddressWithPrefixLength',
        u'IPTextRepresentedAddress',
        u'LCSCause',
        u'LCSClientIdentity',
        u'LCSQoSInfo',
        u'LevelOfCAMELService',
        u'LocalSequenceNumber',
        u'LocationAreaAndCell',
        u'LocationAreaCode',
        u'ManagementExtensions',
        u'MBMS2G3GIndicator',
        u'MBMSInformation',
        u'MBMSServiceArea',
        u'MBMSServiceType',
        u'MBMSSessionIdentity',
        u'MBMSTime',
        u'MBMSUserServiceType',
        u'MCC-MNC',
        u'MessageClass',
        u'MessageReference',
        u'MSCAddress',
        u'MscNo',
        u'MSISDN',
        u'MSTimeZone',
        u'NodeID',
        u'NodeAddress',
        u'PDPAddressPrefixLength',
        u'PDPAddress',
        u'PLMN-Id',
        u'PositioningData',
        u'PriorityType',
        u'RANNASCause',
        u'RATType',
        u'RecordingEntity',
        u'RecordType',
        u'RequiredMBMSBearerCapabilities',
        u'RoutingAreaCode',
        u'SCSASAddress',
        u'Session-Id',
        u'ServiceContextID',
        u'ServiceSpecificInfo',
        u'SMSResult',
        u'SmsTpDestinationNumber',
        u'SubscriberEquipmentNumber',
        u'SubscriberEquipmentType',
        u'SubscriptionID',
        u'SubscriptionIDType',
        u'SystemType',
        u'ThreeGPPPSDataOffStatus',
        u'TimeStamp',
        u'TMGI',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< BCDDirectoryNumber >-----#
    BCDDirectoryNumber = OCT_STR(name=u'BCDDirectoryNumber', mode=MODE_TYPE)
    
    #-----< CallDuration >-----#
    CallDuration = INT(name=u'CallDuration', mode=MODE_TYPE)
    
    #-----< CalledNumber >-----#
    CalledNumber = OCT_STR(name=u'CalledNumber', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'BCDDirectoryNumber')))
    
    #-----< CallingNumber >-----#
    CallingNumber = OCT_STR(name=u'CallingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'BCDDirectoryNumber')))
    
    #-----< CellId >-----#
    CellId = OCT_STR(name=u'CellId', mode=MODE_TYPE)
    CellId._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< ChargeIndicator >-----#
    ChargeIndicator = INT(name=u'ChargeIndicator', mode=MODE_TYPE)
    ChargeIndicator._cont = ASN1Dict([(u'noCharge', 0), (u'charge', 1)])
    
    #-----< CauseForRecClosing >-----#
    CauseForRecClosing = INT(name=u'CauseForRecClosing', mode=MODE_TYPE)
    CauseForRecClosing._cont = ASN1Dict([(u'normalRelease', 0), (u'partialRecord', 1), (u'abnormalRelease', 4), (u'cAMELInitCallRelease', 5), (u'volumeLimit', 16), (u'timeLimit', 17), (u'servingNodeChange', 18), (u'maxChangeCond', 19), (u'managementIntervention', 20), (u'intraSGSNIntersystemChange', 21), (u'rATChange', 22), (u'mSTimeZoneChange', 23), (u'sGSNPLMNIDChange', 24), (u'sGWChange', 25), (u'aPNAMBRChange', 26), (u'mOExceptionDataCounterReceipt', 27), (u'unauthorizedRequestingNetwork', 52), (u'unauthorizedLCSClient', 53), (u'positionMethodFailure', 54), (u'unknownOrUnreachableLCSClient', 58), (u'listofDownstreamNodeChange', 59)])
    
    #-----< CauseForTerm >-----#
    CauseForTerm = INT(name=u'CauseForTerm', mode=MODE_TYPE)
    CauseForTerm._cont = ASN1Dict([(u'normalRelease', 0), (u'partialRecord', 1), (u'partialRecordCallReestablishment', 2), (u'unsuccessfulCallAttempt', 3), (u'abnormalRelease', 4), (u'cAMELInitCallRelease', 5), (u'unauthorizedRequestingNetwork', 52), (u'unauthorizedLCSClient', 53), (u'positionMethodFailure', 54), (u'unknownOrUnreachableLCSClient', 58)])
    
    #-----< ChargingID >-----#
    ChargingID = INT(name=u'ChargingID', mode=MODE_TYPE)
    ChargingID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< CivicAddressInformation >-----#
    CivicAddressInformation = OCT_STR(name=u'CivicAddressInformation', mode=MODE_TYPE)
    
    #-----< CNIPMulticastDistribution >-----#
    CNIPMulticastDistribution = ENUM(name=u'CNIPMulticastDistribution', mode=MODE_TYPE)
    CNIPMulticastDistribution._cont = ASN1Dict([(u'nO-IP-MULTICAST', 0), (u'iP-MULTICAST', 1)])
    CNIPMulticastDistribution._ext = None
    
    #-----< DataVolumeOctets >-----#
    DataVolumeOctets = INT(name=u'DataVolumeOctets', mode=MODE_TYPE)
    
    #-----< DynamicAddressFlag >-----#
    DynamicAddressFlag = BOOL(name=u'DynamicAddressFlag', mode=MODE_TYPE)
    
    #-----< Diagnostics >-----#
    Diagnostics = CHOICE(name=u'Diagnostics', mode=MODE_TYPE)
    _Diagnostics_gsm0408Cause = INT(name=u'gsm0408Cause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Diagnostics_gsm0902MapErrorValue = INT(name=u'gsm0902MapErrorValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Diagnostics_itu_tQ767Cause = INT(name=u'itu-tQ767Cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Diagnostics_networkSpecificCause = SEQ(name=u'networkSpecificCause', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Attribute-ASN1Module', 'ManagementExtension')))
    _Diagnostics_manufacturerSpecificCause = SEQ(name=u'manufacturerSpecificCause', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Attribute-ASN1Module', 'ManagementExtension')))
    _Diagnostics_positionMethodFailureCause = ENUM(name=u'positionMethodFailureCause', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'PositionMethodFailure-Diagnostic')))
    _Diagnostics_unauthorizedLCSClientCause = ENUM(name=u'unauthorizedLCSClientCause', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'UnauthorizedLCSClient-Diagnostic')))
    _Diagnostics_diameterResultCodeAndExperimentalResult = INT(name=u'diameterResultCodeAndExperimentalResult', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Diagnostics._cont = ASN1Dict([
        (u'gsm0408Cause', _Diagnostics_gsm0408Cause),
        (u'gsm0902MapErrorValue', _Diagnostics_gsm0902MapErrorValue),
        (u'itu-tQ767Cause', _Diagnostics_itu_tQ767Cause),
        (u'networkSpecificCause', _Diagnostics_networkSpecificCause),
        (u'manufacturerSpecificCause', _Diagnostics_manufacturerSpecificCause),
        (u'positionMethodFailureCause', _Diagnostics_positionMethodFailureCause),
        (u'unauthorizedLCSClientCause', _Diagnostics_unauthorizedLCSClientCause),
        (u'diameterResultCodeAndExperimentalResult', _Diagnostics_diameterResultCodeAndExperimentalResult),
        ])
    Diagnostics._ext = None
    
    #-----< DiameterIdentity >-----#
    DiameterIdentity = OCT_STR(name=u'DiameterIdentity', mode=MODE_TYPE)
    
    #-----< EnhancedDiagnostics >-----#
    EnhancedDiagnostics = SEQ(name=u'EnhancedDiagnostics', mode=MODE_TYPE)
    _EnhancedDiagnostics_rANNASCause = SEQ_OF(name=u'rANNASCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EnhancedDiagnostics_rANNASCause__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'RANNASCause')))
    _EnhancedDiagnostics_rANNASCause._cont = __EnhancedDiagnostics_rANNASCause__item_
    EnhancedDiagnostics._cont = ASN1Dict([
        (u'rANNASCause', _EnhancedDiagnostics_rANNASCause),
        ])
    EnhancedDiagnostics._ext = None
    
    #-----< GSNAddress >-----#
    GSNAddress = CHOICE(name=u'GSNAddress', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    
    #-----< InvolvedParty >-----#
    InvolvedParty = CHOICE(name=u'InvolvedParty', mode=MODE_TYPE)
    _InvolvedParty_sIP_URI = STR_GRAPH(name=u'sIP-URI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InvolvedParty_tEL_URI = STR_GRAPH(name=u'tEL-URI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InvolvedParty_uRN = STR_GRAPH(name=u'uRN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InvolvedParty_iSDN_E164 = STR_GRAPH(name=u'iSDN-E164', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InvolvedParty_externalId = STR_UTF8(name=u'externalId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    InvolvedParty._cont = ASN1Dict([
        (u'sIP-URI', _InvolvedParty_sIP_URI),
        (u'tEL-URI', _InvolvedParty_tEL_URI),
        (u'uRN', _InvolvedParty_uRN),
        (u'iSDN-E164', _InvolvedParty_iSDN_E164),
        (u'externalId', _InvolvedParty_externalId),
        ])
    InvolvedParty._ext = None
    
    #-----< IPAddress >-----#
    IPAddress = CHOICE(name=u'IPAddress', mode=MODE_TYPE)
    _IPAddress_iPBinaryAddress = CHOICE(name=u'iPBinaryAddress', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'IPBinaryAddress')))
    _IPAddress_iPTextRepresentedAddress = CHOICE(name=u'iPTextRepresentedAddress', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'IPTextRepresentedAddress')))
    IPAddress._cont = ASN1Dict([
        (u'iPBinaryAddress', _IPAddress_iPBinaryAddress),
        (u'iPTextRepresentedAddress', _IPAddress_iPTextRepresentedAddress),
        ])
    IPAddress._ext = None
    
    #-----< IPBinaryAddress >-----#
    IPBinaryAddress = CHOICE(name=u'IPBinaryAddress', mode=MODE_TYPE)
    _IPBinaryAddress_iPBinV4Address = OCT_STR(name=u'iPBinV4Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPBinV4Address')))
    _IPBinaryAddress_iPBinV6Address = CHOICE(name=u'iPBinV6Address', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'IPBinV6AddressWithOrWithoutPrefixLength')))
    IPBinaryAddress._cont = ASN1Dict([
        (u'iPBinV4Address', _IPBinaryAddress_iPBinV4Address),
        (u'iPBinV6Address', _IPBinaryAddress_iPBinV6Address),
        ])
    IPBinaryAddress._ext = None
    
    #-----< IPBinV4Address >-----#
    IPBinV4Address = OCT_STR(name=u'IPBinV4Address', mode=MODE_TYPE)
    IPBinV4Address._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< IPBinV6Address >-----#
    IPBinV6Address = OCT_STR(name=u'IPBinV6Address', mode=MODE_TYPE)
    IPBinV6Address._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< IPBinV6AddressWithOrWithoutPrefixLength >-----#
    IPBinV6AddressWithOrWithoutPrefixLength = CHOICE(name=u'IPBinV6AddressWithOrWithoutPrefixLength', mode=MODE_TYPE)
    _IPBinV6AddressWithOrWithoutPrefixLength_iPBinV6Address = OCT_STR(name=u'iPBinV6Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPBinV6Address')))
    _IPBinV6AddressWithOrWithoutPrefixLength_iPBinV6AddressWithPrefix = SEQ(name=u'iPBinV6AddressWithPrefix', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPBinV6AddressWithPrefixLength')))
    IPBinV6AddressWithOrWithoutPrefixLength._cont = ASN1Dict([
        (u'iPBinV6Address', _IPBinV6AddressWithOrWithoutPrefixLength_iPBinV6Address),
        (u'iPBinV6AddressWithPrefix', _IPBinV6AddressWithOrWithoutPrefixLength_iPBinV6AddressWithPrefix),
        ])
    IPBinV6AddressWithOrWithoutPrefixLength._ext = None
    
    #-----< IPBinV6AddressWithPrefixLength >-----#
    IPBinV6AddressWithPrefixLength = SEQ(name=u'IPBinV6AddressWithPrefixLength', mode=MODE_TYPE)
    _IPBinV6AddressWithPrefixLength_iPBinV6Address = OCT_STR(name=u'iPBinV6Address', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'IPBinV6Address')))
    _IPBinV6AddressWithPrefixLength_pDPAddressPrefixLength = INT(name=u'pDPAddressPrefixLength', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddressPrefixLength')), default=64)
    IPBinV6AddressWithPrefixLength._cont = ASN1Dict([
        (u'iPBinV6Address', _IPBinV6AddressWithPrefixLength_iPBinV6Address),
        (u'pDPAddressPrefixLength', _IPBinV6AddressWithPrefixLength_pDPAddressPrefixLength),
        ])
    IPBinV6AddressWithPrefixLength._ext = None
    
    #-----< IPTextRepresentedAddress >-----#
    IPTextRepresentedAddress = CHOICE(name=u'IPTextRepresentedAddress', mode=MODE_TYPE)
    _IPTextRepresentedAddress_iPTextV4Address = STR_IA5(name=u'iPTextV4Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPTextRepresentedAddress_iPTextV4Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=7, ub=15)], ev=None, er=[])
    _IPTextRepresentedAddress_iPTextV6Address = STR_IA5(name=u'iPTextV6Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPTextRepresentedAddress_iPTextV6Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=15, ub=45)], ev=None, er=[])
    IPTextRepresentedAddress._cont = ASN1Dict([
        (u'iPTextV4Address', _IPTextRepresentedAddress_iPTextV4Address),
        (u'iPTextV6Address', _IPTextRepresentedAddress_iPTextV6Address),
        ])
    IPTextRepresentedAddress._ext = None
    
    #-----< LCSCause >-----#
    LCSCause = OCT_STR(name=u'LCSCause', mode=MODE_TYPE)
    LCSCause._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< LCSClientIdentity >-----#
    LCSClientIdentity = SEQ(name=u'LCSClientIdentity', mode=MODE_TYPE)
    _LCSClientIdentity_lcsClientExternalID = SEQ(name=u'lcsClientExternalID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientExternalID')), opt=True)
    _LCSClientIdentity_lcsClientDialedByMS = OCT_STR(name=u'lcsClientDialedByMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _LCSClientIdentity_lcsClientInternalID = ENUM(name=u'lcsClientInternalID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientInternalID')), opt=True)
    LCSClientIdentity._cont = ASN1Dict([
        (u'lcsClientExternalID', _LCSClientIdentity_lcsClientExternalID),
        (u'lcsClientDialedByMS', _LCSClientIdentity_lcsClientDialedByMS),
        (u'lcsClientInternalID', _LCSClientIdentity_lcsClientInternalID),
        ])
    LCSClientIdentity._ext = None
    
    #-----< LCSQoSInfo >-----#
    LCSQoSInfo = OCT_STR(name=u'LCSQoSInfo', mode=MODE_TYPE)
    LCSQoSInfo._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< LevelOfCAMELService >-----#
    LevelOfCAMELService = BIT_STR(name=u'LevelOfCAMELService', mode=MODE_TYPE)
    LevelOfCAMELService._cont = ASN1Dict([(u'basic', 0), (u'callDurationSupervision', 1), (u'onlineCharging', 2)])
    
    #-----< LocalSequenceNumber >-----#
    LocalSequenceNumber = INT(name=u'LocalSequenceNumber', mode=MODE_TYPE)
    LocalSequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< LocationAreaAndCell >-----#
    LocationAreaAndCell = SEQ(name=u'LocationAreaAndCell', mode=MODE_TYPE)
    _LocationAreaAndCell_locationAreaCode = OCT_STR(name=u'locationAreaCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaCode')))
    _LocationAreaAndCell_cellId = OCT_STR(name=u'cellId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')))
    _LocationAreaAndCell_mCC_MNC = OCT_STR(name=u'mCC-MNC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MCC-MNC')), opt=True)
    LocationAreaAndCell._cont = ASN1Dict([
        (u'locationAreaCode', _LocationAreaAndCell_locationAreaCode),
        (u'cellId', _LocationAreaAndCell_cellId),
        (u'mCC-MNC', _LocationAreaAndCell_mCC_MNC),
        ])
    LocationAreaAndCell._ext = None
    
    #-----< LocationAreaCode >-----#
    LocationAreaCode = OCT_STR(name=u'LocationAreaCode', mode=MODE_TYPE)
    LocationAreaCode._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< ManagementExtensions >-----#
    ManagementExtensions = SET_OF(name=u'ManagementExtensions', mode=MODE_TYPE)
    _ManagementExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Attribute-ASN1Module', 'ManagementExtension')))
    ManagementExtensions._cont = _ManagementExtensions__item_
    
    #-----< MBMS2G3GIndicator >-----#
    MBMS2G3GIndicator = ENUM(name=u'MBMS2G3GIndicator', mode=MODE_TYPE)
    MBMS2G3GIndicator._cont = ASN1Dict([(u'twoG', 0), (u'threeG', 1), (u'twoG-AND-threeG', 2)])
    MBMS2G3GIndicator._ext = None
    
    #-----< MBMSInformation >-----#
    MBMSInformation = SET(name=u'MBMSInformation', mode=MODE_TYPE)
    _MBMSInformation_tMGI = OCT_STR(name=u'tMGI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TMGI')), opt=True)
    _MBMSInformation_mBMSSessionIdentity = OCT_STR(name=u'mBMSSessionIdentity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSSessionIdentity')), opt=True)
    _MBMSInformation_mBMSServiceType = ENUM(name=u'mBMSServiceType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSServiceType')), opt=True)
    _MBMSInformation_mBMSUserServiceType = ENUM(name=u'mBMSUserServiceType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSUserServiceType')), opt=True)
    _MBMSInformation_mBMS2G3GIndicator = ENUM(name=u'mBMS2G3GIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMS2G3GIndicator')), opt=True)
    _MBMSInformation_fileRepairSupported = BOOL(name=u'fileRepairSupported', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MBMSInformation_rAI = OCT_STR(name=u'rAI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _MBMSInformation_mBMSServiceArea = OCT_STR(name=u'mBMSServiceArea', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSServiceArea')), opt=True)
    _MBMSInformation_requiredMBMSBearerCaps = OCT_STR(name=u'requiredMBMSBearerCaps', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RequiredMBMSBearerCapabilities')), opt=True)
    _MBMSInformation_mBMSGWAddress = CHOICE(name=u'mBMSGWAddress', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _MBMSInformation_cNIPMulticastDistribution = ENUM(name=u'cNIPMulticastDistribution', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CNIPMulticastDistribution')), opt=True)
    _MBMSInformation_mBMSDataTransferStart = OCT_STR(name=u'mBMSDataTransferStart', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSTime')), opt=True)
    _MBMSInformation_mBMSDataTransferStop = OCT_STR(name=u'mBMSDataTransferStop', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSTime')), opt=True)
    MBMSInformation._cont = ASN1Dict([
        (u'tMGI', _MBMSInformation_tMGI),
        (u'mBMSSessionIdentity', _MBMSInformation_mBMSSessionIdentity),
        (u'mBMSServiceType', _MBMSInformation_mBMSServiceType),
        (u'mBMSUserServiceType', _MBMSInformation_mBMSUserServiceType),
        (u'mBMS2G3GIndicator', _MBMSInformation_mBMS2G3GIndicator),
        (u'fileRepairSupported', _MBMSInformation_fileRepairSupported),
        (u'rAI', _MBMSInformation_rAI),
        (u'mBMSServiceArea', _MBMSInformation_mBMSServiceArea),
        (u'requiredMBMSBearerCaps', _MBMSInformation_requiredMBMSBearerCaps),
        (u'mBMSGWAddress', _MBMSInformation_mBMSGWAddress),
        (u'cNIPMulticastDistribution', _MBMSInformation_cNIPMulticastDistribution),
        (u'mBMSDataTransferStart', _MBMSInformation_mBMSDataTransferStart),
        (u'mBMSDataTransferStop', _MBMSInformation_mBMSDataTransferStop),
        ])
    MBMSInformation._ext = None
    
    #-----< MBMSServiceArea >-----#
    MBMSServiceArea = OCT_STR(name=u'MBMSServiceArea', mode=MODE_TYPE)
    
    #-----< MBMSServiceType >-----#
    MBMSServiceType = ENUM(name=u'MBMSServiceType', mode=MODE_TYPE)
    MBMSServiceType._cont = ASN1Dict([(u'mULTICAST', 0), (u'bROADCAST', 1)])
    MBMSServiceType._ext = None
    
    #-----< MBMSSessionIdentity >-----#
    MBMSSessionIdentity = OCT_STR(name=u'MBMSSessionIdentity', mode=MODE_TYPE)
    MBMSSessionIdentity._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< MBMSTime >-----#
    MBMSTime = OCT_STR(name=u'MBMSTime', mode=MODE_TYPE)
    MBMSTime._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MBMSUserServiceType >-----#
    MBMSUserServiceType = ENUM(name=u'MBMSUserServiceType', mode=MODE_TYPE)
    MBMSUserServiceType._cont = ASN1Dict([(u'dOWNLOAD', 0), (u'sTREAMING', 1)])
    MBMSUserServiceType._ext = None
    
    #-----< MCC-MNC >-----#
    MCC_MNC = OCT_STR(name=u'MCC-MNC', mode=MODE_TYPE)
    MCC_MNC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< MessageClass >-----#
    MessageClass = ENUM(name=u'MessageClass', mode=MODE_TYPE)
    MessageClass._cont = ASN1Dict([(u'personal', 0), (u'advertisement', 1), (u'information-service', 2), (u'auto', 3)])
    MessageClass._ext = None
    
    #-----< MessageReference >-----#
    MessageReference = OCT_STR(name=u'MessageReference', mode=MODE_TYPE)
    
    #-----< MSCAddress >-----#
    MSCAddress = OCT_STR(name=u'MSCAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    
    #-----< MscNo >-----#
    MscNo = OCT_STR(name=u'MscNo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    
    #-----< MSISDN >-----#
    MSISDN = OCT_STR(name=u'MSISDN', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    
    #-----< MSTimeZone >-----#
    MSTimeZone = OCT_STR(name=u'MSTimeZone', mode=MODE_TYPE)
    MSTimeZone._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< NodeID >-----#
    NodeID = STR_IA5(name=u'NodeID', mode=MODE_TYPE)
    NodeID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< NodeAddress >-----#
    NodeAddress = CHOICE(name=u'NodeAddress', mode=MODE_TYPE)
    _NodeAddress_iPAddress = CHOICE(name=u'iPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _NodeAddress_domainName = STR_GRAPH(name=u'domainName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    NodeAddress._cont = ASN1Dict([
        (u'iPAddress', _NodeAddress_iPAddress),
        (u'domainName', _NodeAddress_domainName),
        ])
    NodeAddress._ext = None
    
    #-----< PDPAddressPrefixLength >-----#
    PDPAddressPrefixLength = INT(name=u'PDPAddressPrefixLength', mode=MODE_TYPE)
    PDPAddressPrefixLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< PDPAddress >-----#
    PDPAddress = CHOICE(name=u'PDPAddress', mode=MODE_TYPE)
    _PDPAddress_iPAddress = CHOICE(name=u'iPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    PDPAddress._cont = ASN1Dict([
        (u'iPAddress', _PDPAddress_iPAddress),
        ])
    PDPAddress._ext = None
    
    #-----< PLMN-Id >-----#
    PLMN_Id = OCT_STR(name=u'PLMN-Id', mode=MODE_TYPE)
    PLMN_Id._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< PositioningData >-----#
    PositioningData = OCT_STR(name=u'PositioningData', mode=MODE_TYPE)
    PositioningData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=33)], ev=None, er=[])
    
    #-----< PriorityType >-----#
    PriorityType = ENUM(name=u'PriorityType', mode=MODE_TYPE)
    PriorityType._cont = ASN1Dict([(u'low', 0), (u'normal', 1), (u'high', 2)])
    PriorityType._ext = None
    
    #-----< RANNASCause >-----#
    RANNASCause = OCT_STR(name=u'RANNASCause', mode=MODE_TYPE)
    
    #-----< RATType >-----#
    RATType = INT(name=u'RATType', mode=MODE_TYPE)
    RATType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< RecordingEntity >-----#
    RecordingEntity = OCT_STR(name=u'RecordingEntity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    
    #-----< RecordType >-----#
    RecordType = INT(name=u'RecordType', mode=MODE_TYPE)
    RecordType._cont = ASN1Dict([(u'moCallRecord', 0), (u'mtCallRecord', 1), (u'roamingRecord', 2), (u'incGatewayRecord', 3), (u'outGatewayRecord', 4), (u'transitCallRecord', 5), (u'moSMSRecord', 6), (u'mtSMSRecord', 7), (u'moSMSIWRecord', 8), (u'mtSMSGWRecord', 9), (u'ssActionRecord', 10), (u'hlrIntRecord', 11), (u'locUpdateHLRRecord', 12), (u'locUpdateVLRRecord', 13), (u'commonEquipRecord', 14), (u'moTraceRecord', 15), (u'mtTraceRecord', 16), (u'termCAMELRecord', 17), (u'sgsnPDPRecord', 18), (u'sgsnMMRecord', 20), (u'sgsnSMORecord', 21), (u'sgsnSMTRecord', 22), (u'mtLCSRecord', 23), (u'moLCSRecord', 24), (u'niLCSRecord', 25), (u'sgsnMTLCSRecord', 26), (u'sgsnMOLCSRecord', 27), (u'sgsnNILCSRecord', 28), (u'mMO1SRecord', 30), (u'mMO4FRqRecord', 31), (u'mMO4FRsRecord', 32), (u'mMO4DRecord', 33), (u'mMO1DRecord', 34), (u'mMO4RRecord', 35), (u'mMO1RRecord', 36), (u'mMOMDRecord', 37), (u'mMR4FRecord', 38), (u'mMR1NRqRecord', 39), (u'mMR1NRsRecord', 40), (u'mMR1RtRecord', 41), (u'mMR1AFRecord', 42), (u'mMR4DRqRecord', 43), (u'mMR4DRsRecord', 44), (u'mMR1RRRecord', 45), (u'mMR4RRqRecord', 46), (u'mMR4RRsRecord', 47), (u'mMRMDRecord', 48), (u'mMFRecord', 49), (u'mMBx1SRecord', 50), (u'mMBx1VRecord', 51), (u'mMBx1URecord', 52), (u'mMBx1DRecord', 53), (u'mM7SRecord', 54), (u'mM7DRqRecord', 55), (u'mM7DRsRecord', 56), (u'mM7CRecord', 57), (u'mM7RRecord', 58), (u'mM7DRRqRecord', 59), (u'mM7DRRsRecord', 60), (u'mM7RRqRecord', 61), (u'mM7RRsRecord', 62), (u'sCSCFRecord', 63), (u'pCSCFRecord', 64), (u'iCSCFRecord', 65), (u'mRFCRecord', 66), (u'mGCFRecord', 67), (u'bGCFRecord', 68), (u'aSRecord', 69), (u'eCSCFRecord', 70), (u'iBCFRecord', 82), (u'tRFRecord', 89), (u'tFRecord', 90), (u'aTCFRecord', 91), (u'lCSGMORecord', 71), (u'lCSRGMTRecord', 72), (u'lCSHGMTRecord', 73), (u'lCSVGMTRecord', 74), (u'lCSGNIRecord', 75), (u'sgsnMBMSRecord', 76), (u'ggsnMBMSRecord', 77), (u'gwMBMSRecord', 86), (u'sUBBMSCRecord', 78), (u'cONTENTBMSCRecord', 79), (u'pPFRecord', 80), (u'cPFRecord', 81), (u'sGWRecord', 84), (u'pGWRecord', 85), (u'tDFRecord', 92), (u'iPERecord', 95), (u'ePDGRecord', 96), (u'tWAGRecord', 97), (u'mMTelRecord', 83), (u'mSCsRVCCRecord', 87), (u'mMTRFRecord', 88), (u'iCSRegisterRecord', 99), (u'sCSMORecord', 93), (u'sCSMTRecord', 94), (u'pFDDRecord', 100), (u'pFEDRecord', 101), (u'pFDCRecord', 102), (u'mECORecord', 103), (u'mERERecord', 104), (u'cPDTSCERecord', 105), (u'cPDTSNNRecord', 106), (u'sCDVTT4Record', 110), (u'sCSMOT4Record', 111), (u'iSMSMORecord', 112), (u'iSMSMTRecord', 113), (u'eASCERecord', 120), (u'chargingFunctionRecord', 200)])
    
    #-----< RequiredMBMSBearerCapabilities >-----#
    RequiredMBMSBearerCapabilities = OCT_STR(name=u'RequiredMBMSBearerCapabilities', mode=MODE_TYPE)
    RequiredMBMSBearerCapabilities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=14)], ev=None, er=[])
    
    #-----< RoutingAreaCode >-----#
    RoutingAreaCode = OCT_STR(name=u'RoutingAreaCode', mode=MODE_TYPE)
    RoutingAreaCode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SCSASAddress >-----#
    SCSASAddress = SET(name=u'SCSASAddress', mode=MODE_TYPE)
    _SCSASAddress_sCSAddress = CHOICE(name=u'sCSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _SCSASAddress_sCSRealm = OCT_STR(name=u'sCSRealm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')))
    SCSASAddress._cont = ASN1Dict([
        (u'sCSAddress', _SCSASAddress_sCSAddress),
        (u'sCSRealm', _SCSASAddress_sCSRealm),
        ])
    SCSASAddress._ext = None
    
    #-----< Session-Id >-----#
    Session_Id = STR_GRAPH(name=u'Session-Id', mode=MODE_TYPE)
    
    #-----< ServiceContextID >-----#
    ServiceContextID = STR_UTF8(name=u'ServiceContextID', mode=MODE_TYPE)
    
    #-----< ServiceSpecificInfo >-----#
    ServiceSpecificInfo = SEQ(name=u'ServiceSpecificInfo', mode=MODE_TYPE)
    _ServiceSpecificInfo_serviceSpecificData = STR_GRAPH(name=u'serviceSpecificData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceSpecificInfo_serviceSpecificType = INT(name=u'serviceSpecificType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ServiceSpecificInfo._cont = ASN1Dict([
        (u'serviceSpecificData', _ServiceSpecificInfo_serviceSpecificData),
        (u'serviceSpecificType', _ServiceSpecificInfo_serviceSpecificType),
        ])
    ServiceSpecificInfo._ext = None
    
    #-----< SMSResult >-----#
    SMSResult = CHOICE(name=u'SMSResult', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')))
    
    #-----< SmsTpDestinationNumber >-----#
    SmsTpDestinationNumber = OCT_STR(name=u'SmsTpDestinationNumber', mode=MODE_TYPE)
    
    #-----< SubscriberEquipmentNumber >-----#
    SubscriberEquipmentNumber = SET(name=u'SubscriberEquipmentNumber', mode=MODE_TYPE)
    _SubscriberEquipmentNumber_subscriberEquipmentNumberType = ENUM(name=u'subscriberEquipmentNumberType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentType')))
    _SubscriberEquipmentNumber_subscriberEquipmentNumberData = OCT_STR(name=u'subscriberEquipmentNumberData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SubscriberEquipmentNumber._cont = ASN1Dict([
        (u'subscriberEquipmentNumberType', _SubscriberEquipmentNumber_subscriberEquipmentNumberType),
        (u'subscriberEquipmentNumberData', _SubscriberEquipmentNumber_subscriberEquipmentNumberData),
        ])
    SubscriberEquipmentNumber._ext = None
    
    #-----< SubscriberEquipmentType >-----#
    SubscriberEquipmentType = ENUM(name=u'SubscriberEquipmentType', mode=MODE_TYPE)
    SubscriberEquipmentType._cont = ASN1Dict([(u'iMEISV', 0), (u'mAC', 1), (u'eUI64', 2), (u'modifiedEUI64', 3)])
    SubscriberEquipmentType._ext = None
    
    #-----< SubscriptionID >-----#
    SubscriptionID = SET(name=u'SubscriptionID', mode=MODE_TYPE)
    _SubscriptionID_subscriptionIDType = ENUM(name=u'subscriptionIDType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionIDType')))
    _SubscriptionID_subscriptionIDData = STR_UTF8(name=u'subscriptionIDData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SubscriptionID._cont = ASN1Dict([
        (u'subscriptionIDType', _SubscriptionID_subscriptionIDType),
        (u'subscriptionIDData', _SubscriptionID_subscriptionIDData),
        ])
    SubscriptionID._ext = None
    
    #-----< SubscriptionIDType >-----#
    SubscriptionIDType = ENUM(name=u'SubscriptionIDType', mode=MODE_TYPE)
    SubscriptionIDType._cont = ASN1Dict([(u'eND-USER-E164', 0), (u'eND-USER-IMSI', 1), (u'eND-USER-SIP-URI', 2), (u'eND-USER-NAI', 3), (u'eND-USER-PRIVATE', 4)])
    SubscriptionIDType._ext = None
    
    #-----< SystemType >-----#
    SystemType = ENUM(name=u'SystemType', mode=MODE_TYPE)
    SystemType._cont = ASN1Dict([(u'unknown', 0), (u'iuUTRAN', 1), (u'gERAN', 2)])
    SystemType._ext = None
    
    #-----< ThreeGPPPSDataOffStatus >-----#
    ThreeGPPPSDataOffStatus = ENUM(name=u'ThreeGPPPSDataOffStatus', mode=MODE_TYPE)
    ThreeGPPPSDataOffStatus._cont = ASN1Dict([(u'active', 0), (u'inactive', 1)])
    ThreeGPPPSDataOffStatus._ext = None
    
    #-----< TimeStamp >-----#
    TimeStamp = OCT_STR(name=u'TimeStamp', mode=MODE_TYPE)
    TimeStamp._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    
    #-----< TMGI >-----#
    TMGI = OCT_STR(name=u'TMGI', mode=MODE_TYPE)
    
    _all_ = [
        BCDDirectoryNumber,
        CallDuration,
        CalledNumber,
        CallingNumber,
        CellId,
        ChargeIndicator,
        CauseForRecClosing,
        CauseForTerm,
        ChargingID,
        CivicAddressInformation,
        CNIPMulticastDistribution,
        DataVolumeOctets,
        DynamicAddressFlag,
        _Diagnostics_gsm0408Cause,
        _Diagnostics_gsm0902MapErrorValue,
        _Diagnostics_itu_tQ767Cause,
        _Diagnostics_networkSpecificCause,
        _Diagnostics_manufacturerSpecificCause,
        _Diagnostics_positionMethodFailureCause,
        _Diagnostics_unauthorizedLCSClientCause,
        _Diagnostics_diameterResultCodeAndExperimentalResult,
        Diagnostics,
        DiameterIdentity,
        __EnhancedDiagnostics_rANNASCause__item_,
        _EnhancedDiagnostics_rANNASCause,
        EnhancedDiagnostics,
        GSNAddress,
        _InvolvedParty_sIP_URI,
        _InvolvedParty_tEL_URI,
        _InvolvedParty_uRN,
        _InvolvedParty_iSDN_E164,
        _InvolvedParty_externalId,
        InvolvedParty,
        _IPAddress_iPBinaryAddress,
        _IPAddress_iPTextRepresentedAddress,
        IPAddress,
        _IPBinaryAddress_iPBinV4Address,
        _IPBinaryAddress_iPBinV6Address,
        IPBinaryAddress,
        IPBinV4Address,
        IPBinV6Address,
        _IPBinV6AddressWithOrWithoutPrefixLength_iPBinV6Address,
        _IPBinV6AddressWithOrWithoutPrefixLength_iPBinV6AddressWithPrefix,
        IPBinV6AddressWithOrWithoutPrefixLength,
        _IPBinV6AddressWithPrefixLength_iPBinV6Address,
        _IPBinV6AddressWithPrefixLength_pDPAddressPrefixLength,
        IPBinV6AddressWithPrefixLength,
        _IPTextRepresentedAddress_iPTextV4Address,
        _IPTextRepresentedAddress_iPTextV6Address,
        IPTextRepresentedAddress,
        LCSCause,
        _LCSClientIdentity_lcsClientExternalID,
        _LCSClientIdentity_lcsClientDialedByMS,
        _LCSClientIdentity_lcsClientInternalID,
        LCSClientIdentity,
        LCSQoSInfo,
        LevelOfCAMELService,
        LocalSequenceNumber,
        _LocationAreaAndCell_locationAreaCode,
        _LocationAreaAndCell_cellId,
        _LocationAreaAndCell_mCC_MNC,
        LocationAreaAndCell,
        LocationAreaCode,
        _ManagementExtensions__item_,
        ManagementExtensions,
        MBMS2G3GIndicator,
        _MBMSInformation_tMGI,
        _MBMSInformation_mBMSSessionIdentity,
        _MBMSInformation_mBMSServiceType,
        _MBMSInformation_mBMSUserServiceType,
        _MBMSInformation_mBMS2G3GIndicator,
        _MBMSInformation_fileRepairSupported,
        _MBMSInformation_rAI,
        _MBMSInformation_mBMSServiceArea,
        _MBMSInformation_requiredMBMSBearerCaps,
        _MBMSInformation_mBMSGWAddress,
        _MBMSInformation_cNIPMulticastDistribution,
        _MBMSInformation_mBMSDataTransferStart,
        _MBMSInformation_mBMSDataTransferStop,
        MBMSInformation,
        MBMSServiceArea,
        MBMSServiceType,
        MBMSSessionIdentity,
        MBMSTime,
        MBMSUserServiceType,
        MCC_MNC,
        MessageClass,
        MessageReference,
        MSCAddress,
        MscNo,
        MSISDN,
        MSTimeZone,
        NodeID,
        _NodeAddress_iPAddress,
        _NodeAddress_domainName,
        NodeAddress,
        PDPAddressPrefixLength,
        _PDPAddress_iPAddress,
        PDPAddress,
        PLMN_Id,
        PositioningData,
        PriorityType,
        RANNASCause,
        RATType,
        RecordingEntity,
        RecordType,
        RequiredMBMSBearerCapabilities,
        RoutingAreaCode,
        _SCSASAddress_sCSAddress,
        _SCSASAddress_sCSRealm,
        SCSASAddress,
        Session_Id,
        ServiceContextID,
        _ServiceSpecificInfo_serviceSpecificData,
        _ServiceSpecificInfo_serviceSpecificType,
        ServiceSpecificInfo,
        SMSResult,
        SmsTpDestinationNumber,
        _SubscriberEquipmentNumber_subscriberEquipmentNumberType,
        _SubscriberEquipmentNumber_subscriberEquipmentNumberData,
        SubscriberEquipmentNumber,
        SubscriberEquipmentType,
        _SubscriptionID_subscriptionIDType,
        _SubscriptionID_subscriptionIDData,
        SubscriptionID,
        SubscriptionIDType,
        SystemType,
        ThreeGPPPSDataOffStatus,
        TimeStamp,
        TMGI,
    ]

class GPRSChargingDataTypes:

    _name_  = u'GPRSChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 2, 0, 1]
    
    _obj_ = [
        u'GPRSRecord',
        u'SGWRecord',
        u'PGWRecord',
        u'TDFRecord',
        u'IPERecord',
        u'EPDGRecord',
        u'TWAGRecord',
        u'SGSNMMRecord',
        u'SGSNPDPRecord',
        u'SGSNSMORecord',
        u'SGSNSMTRecord',
        u'SGSNMTLCSRecord',
        u'SGSNMOLCSRecord',
        u'SGSNNILCSRecord',
        u'SGSNMBMSRecord',
        u'GGSNMBMSRecord',
        u'GWMBMSRecord',
        u'AccessAvailabilityChangeReason',
        u'AccessLineIdentifier',
        u'AccessPointNameNI',
        u'AccessPointNameOI',
        u'ADCRuleBaseName',
        u'AdditionalExceptionReports',
        u'AFChargingIdentifier',
        u'AFRecordInformation',
        u'APNRateControl',
        u'APNRateControlParameters',
        u'APNSelectionMode',
        u'CalleePartyInformation',
        u'CAMELAccessPointNameNI',
        u'CAMELAccessPointNameOI',
        u'CAMELInformationMM',
        u'CAMELInformationPDP',
        u'CAMELInformationSMS',
        u'ChangeCondition',
        u'ChangeOfCharCondition',
        u'ChangeOfMBMSCondition',
        u'ChangeOfServiceCondition',
        u'ChangeLocation',
        u'ChargingCharacteristics',
        u'ChargingPerIPCANSessionIndicator',
        u'ChargingRuleBaseName',
        u'ChChSelectionMode',
        u'CNOperatorSelectionEntity',
        u'CPCIoTEPSOptimisationIndicator',
        u'CSGAccessMode',
        u'CSGId',
        u'CTEID',
        u'DataVolumeGPRS',
        u'DataVolumeMBMS',
        u'EPCQoSInformation',
        u'EventBasedChargingInformation',
        u'FailureHandlingContinue',
        u'FFDAppendIndicator',
        u'FixedSubsID',
        u'FixedUserLocationInformation',
        u'Flows',
        u'FreeFormatData',
        u'MOExceptionDataCounter',
        u'MSNetworkCapability',
        u'NBIFOMMode',
        u'NBIFOMSupport',
        u'NetworkInitiatedPDPContext',
        u'NumberOfDPEncountered',
        u'PDPType',
        u'PDPPDNTypeExtension',
        u'PresenceReportingAreaElementsList',
        u'PresenceReportingAreaInfo',
        u'PresenceReportingAreaNode',
        u'PresenceReportingAreaStatus',
        u'PSFurnishChargingInformation',
        u'QoSInformation',
        u'RANSecondaryRATUsageReport',
        u'RateControlTimeUnit',
        u'RatingGroupId',
        u'RelatedChangeOfCharCondition',
        u'RelatedChangeOfServiceCondition',
        u'ResultCode',
        u'SecondaryRATType',
        u'ServiceConditionChange',
        u'SCFAddress',
        u'ServiceIdentifier',
        u'ServingNodeType',
        u'ServingPLMNRateControl',
        u'SGiPtPTunnellingMethod',
        u'SGSNChange',
        u'SGWChange',
        u'TimeQuotaMechanism',
        u'TimeQuotaType',
        u'TrafficSteeringPolicyIDDownlink',
        u'TrafficSteeringPolicyIDUplink',
        u'TWANUserLocationInfo',
        u'UNIPDUCPOnlyFlag',
        u'UserCSGInformation',
        u'UWANUserLocationInfo',
        u'VoLTEInformation',
        u'WLANOperatorId',
        ]
    _type_ = [
        u'GPRSRecord',
        u'SGWRecord',
        u'PGWRecord',
        u'TDFRecord',
        u'IPERecord',
        u'EPDGRecord',
        u'TWAGRecord',
        u'SGSNMMRecord',
        u'SGSNPDPRecord',
        u'SGSNSMORecord',
        u'SGSNSMTRecord',
        u'SGSNMTLCSRecord',
        u'SGSNMOLCSRecord',
        u'SGSNNILCSRecord',
        u'SGSNMBMSRecord',
        u'GGSNMBMSRecord',
        u'GWMBMSRecord',
        u'AccessAvailabilityChangeReason',
        u'AccessLineIdentifier',
        u'AccessPointNameNI',
        u'AccessPointNameOI',
        u'ADCRuleBaseName',
        u'AdditionalExceptionReports',
        u'AFChargingIdentifier',
        u'AFRecordInformation',
        u'APNRateControl',
        u'APNRateControlParameters',
        u'APNSelectionMode',
        u'CalleePartyInformation',
        u'CAMELAccessPointNameNI',
        u'CAMELAccessPointNameOI',
        u'CAMELInformationMM',
        u'CAMELInformationPDP',
        u'CAMELInformationSMS',
        u'ChangeCondition',
        u'ChangeOfCharCondition',
        u'ChangeOfMBMSCondition',
        u'ChangeOfServiceCondition',
        u'ChangeLocation',
        u'ChargingCharacteristics',
        u'ChargingPerIPCANSessionIndicator',
        u'ChargingRuleBaseName',
        u'ChChSelectionMode',
        u'CNOperatorSelectionEntity',
        u'CPCIoTEPSOptimisationIndicator',
        u'CSGAccessMode',
        u'CSGId',
        u'CTEID',
        u'DataVolumeGPRS',
        u'DataVolumeMBMS',
        u'EPCQoSInformation',
        u'EventBasedChargingInformation',
        u'FailureHandlingContinue',
        u'FFDAppendIndicator',
        u'FixedSubsID',
        u'FixedUserLocationInformation',
        u'Flows',
        u'FreeFormatData',
        u'MOExceptionDataCounter',
        u'MSNetworkCapability',
        u'NBIFOMMode',
        u'NBIFOMSupport',
        u'NetworkInitiatedPDPContext',
        u'NumberOfDPEncountered',
        u'PDPType',
        u'PDPPDNTypeExtension',
        u'PresenceReportingAreaElementsList',
        u'PresenceReportingAreaInfo',
        u'PresenceReportingAreaNode',
        u'PresenceReportingAreaStatus',
        u'PSFurnishChargingInformation',
        u'QoSInformation',
        u'RANSecondaryRATUsageReport',
        u'RateControlTimeUnit',
        u'RatingGroupId',
        u'RelatedChangeOfCharCondition',
        u'RelatedChangeOfServiceCondition',
        u'ResultCode',
        u'SecondaryRATType',
        u'ServiceConditionChange',
        u'SCFAddress',
        u'ServiceIdentifier',
        u'ServingNodeType',
        u'ServingPLMNRateControl',
        u'SGiPtPTunnellingMethod',
        u'SGSNChange',
        u'SGWChange',
        u'TimeQuotaMechanism',
        u'TimeQuotaType',
        u'TrafficSteeringPolicyIDDownlink',
        u'TrafficSteeringPolicyIDUplink',
        u'TWANUserLocationInfo',
        u'UNIPDUCPOnlyFlag',
        u'UserCSGInformation',
        u'UWANUserLocationInfo',
        u'VoLTEInformation',
        u'WLANOperatorId',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< GPRSRecord >-----#
    GPRSRecord = CHOICE(name=u'GPRSRecord', mode=MODE_TYPE)
    _GPRSRecord_sgsnPDPRecord = SET(name=u'sgsnPDPRecord', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNPDPRecord')))
    _GPRSRecord_sgsnMMRecord = SET(name=u'sgsnMMRecord', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNMMRecord')))
    _GPRSRecord_sgsnSMORecord = SET(name=u'sgsnSMORecord', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNSMORecord')))
    _GPRSRecord_sgsnSMTRecord = SET(name=u'sgsnSMTRecord', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNSMTRecord')))
    _GPRSRecord_sgsnMTLCSRecord = SET(name=u'sgsnMTLCSRecord', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNMTLCSRecord')))
    _GPRSRecord_sgsnMOLCSRecord = SET(name=u'sgsnMOLCSRecord', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNMOLCSRecord')))
    _GPRSRecord_sgsnNILCSRecord = SET(name=u'sgsnNILCSRecord', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNNILCSRecord')))
    _GPRSRecord_sgsnMBMSRecord = SET(name=u'sgsnMBMSRecord', mode=MODE_TYPE, tag=(76, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNMBMSRecord')))
    _GPRSRecord_ggsnMBMSRecord = SET(name=u'ggsnMBMSRecord', mode=MODE_TYPE, tag=(77, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'GGSNMBMSRecord')))
    _GPRSRecord_sGWRecord = SET(name=u'sGWRecord', mode=MODE_TYPE, tag=(78, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGWRecord')))
    _GPRSRecord_pGWRecord = SET(name=u'pGWRecord', mode=MODE_TYPE, tag=(79, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PGWRecord')))
    _GPRSRecord_gwMBMSRecord = SET(name=u'gwMBMSRecord', mode=MODE_TYPE, tag=(86, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'GWMBMSRecord')))
    _GPRSRecord_tDFRecord = SET(name=u'tDFRecord', mode=MODE_TYPE, tag=(92, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TDFRecord')))
    _GPRSRecord_iPERecord = SET(name=u'iPERecord', mode=MODE_TYPE, tag=(95, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'IPERecord')))
    _GPRSRecord_ePDGRecord = SET(name=u'ePDGRecord', mode=MODE_TYPE, tag=(96, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'EPDGRecord')))
    _GPRSRecord_tWAGRecord = SET(name=u'tWAGRecord', mode=MODE_TYPE, tag=(97, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TWAGRecord')))
    GPRSRecord._cont = ASN1Dict([
        (u'sgsnPDPRecord', _GPRSRecord_sgsnPDPRecord),
        (u'sgsnMMRecord', _GPRSRecord_sgsnMMRecord),
        (u'sgsnSMORecord', _GPRSRecord_sgsnSMORecord),
        (u'sgsnSMTRecord', _GPRSRecord_sgsnSMTRecord),
        (u'sgsnMTLCSRecord', _GPRSRecord_sgsnMTLCSRecord),
        (u'sgsnMOLCSRecord', _GPRSRecord_sgsnMOLCSRecord),
        (u'sgsnNILCSRecord', _GPRSRecord_sgsnNILCSRecord),
        (u'sgsnMBMSRecord', _GPRSRecord_sgsnMBMSRecord),
        (u'ggsnMBMSRecord', _GPRSRecord_ggsnMBMSRecord),
        (u'sGWRecord', _GPRSRecord_sGWRecord),
        (u'pGWRecord', _GPRSRecord_pGWRecord),
        (u'gwMBMSRecord', _GPRSRecord_gwMBMSRecord),
        (u'tDFRecord', _GPRSRecord_tDFRecord),
        (u'iPERecord', _GPRSRecord_iPERecord),
        (u'ePDGRecord', _GPRSRecord_ePDGRecord),
        (u'tWAGRecord', _GPRSRecord_tWAGRecord),
        ])
    GPRSRecord._ext = None
    
    #-----< SGWRecord >-----#
    SGWRecord = SET(name=u'SGWRecord', mode=MODE_TYPE)
    _SGWRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGWRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SGWRecord_s_GWAddress = CHOICE(name=u's-GWAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _SGWRecord_chargingID = INT(name=u'chargingID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _SGWRecord_servingNodeAddress = SEQ_OF(name=u'servingNodeAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SGWRecord_servingNodeAddress__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _SGWRecord_servingNodeAddress._cont = __SGWRecord_servingNodeAddress__item_
    _SGWRecord_accessPointNameNI = STR_IA5(name=u'accessPointNameNI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _SGWRecord_pdpPDNType = OCT_STR(name=u'pdpPDNType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _SGWRecord_servedPDPPDNAddress = CHOICE(name=u'servedPDPPDNAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _SGWRecord_dynamicAddressFlag = BOOL(name=u'dynamicAddressFlag', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _SGWRecord_listOfTrafficVolumes = SEQ_OF(name=u'listOfTrafficVolumes', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SGWRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfCharCondition')))
    _SGWRecord_listOfTrafficVolumes._cont = __SGWRecord_listOfTrafficVolumes__item_
    _SGWRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGWRecord_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _SGWRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _SGWRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SGWRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGWRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGWRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGWRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGWRecord_apnSelectionMode = ENUM(name=u'apnSelectionMode', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNSelectionMode')), opt=True)
    _SGWRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGWRecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGWRecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGWRecord_iMSsignalingContext = NULL(name=u'iMSsignalingContext', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGWRecord_servingNodePLMNIdentifier = OCT_STR(name=u'servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGWRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SGWRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGWRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _SGWRecord_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGWRecord_sGWChange = BOOL(name=u'sGWChange', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGWChange')), opt=True)
    _SGWRecord_servingNodeType = SEQ_OF(name=u'servingNodeType', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SGWRecord_servingNodeType__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingNodeType')))
    _SGWRecord_servingNodeType._cont = __SGWRecord_servingNodeType__item_
    _SGWRecord_p_GWAddressUsed = CHOICE(name=u'p-GWAddressUsed', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGWRecord_p_GWPLMNIdentifier = OCT_STR(name=u'p-GWPLMNIdentifier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGWRecord_startTime = OCT_STR(name=u'startTime', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SGWRecord_stopTime = OCT_STR(name=u'stopTime', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SGWRecord_pDNConnectionChargingID = INT(name=u'pDNConnectionChargingID', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')), opt=True)
    _SGWRecord_iMSIunauthenticatedFlag = NULL(name=u'iMSIunauthenticatedFlag', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGWRecord_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _SGWRecord_servedPDPPDNAddressExt = CHOICE(name=u'servedPDPPDNAddressExt', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _SGWRecord_lowPriorityIndicator = NULL(name=u'lowPriorityIndicator', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGWRecord_dynamicAddressFlagExt = BOOL(name=u'dynamicAddressFlagExt', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _SGWRecord_s_GWiPv6Address = CHOICE(name=u's-GWiPv6Address', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGWRecord_servingNodeiPv6Address = SEQ_OF(name=u'servingNodeiPv6Address', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SGWRecord_servingNodeiPv6Address__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _SGWRecord_servingNodeiPv6Address._cont = __SGWRecord_servingNodeiPv6Address__item_
    _SGWRecord_p_GWiPv6AddressUsed = CHOICE(name=u'p-GWiPv6AddressUsed', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGWRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGWRecord_userLocationInfoTime = OCT_STR(name=u'userLocationInfoTime', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SGWRecord_cNOperatorSelectionEnt = ENUM(name=u'cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    _SGWRecord_presenceReportingAreaInfo = SEQ(name=u'presenceReportingAreaInfo', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaInfo')), opt=True)
    _SGWRecord_lastUserLocationInformation = OCT_STR(name=u'lastUserLocationInformation', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGWRecord_lastMSTimeZone = OCT_STR(name=u'lastMSTimeZone', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _SGWRecord_enhancedDiagnostics = SEQ(name=u'enhancedDiagnostics', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'EnhancedDiagnostics')), opt=True)
    _SGWRecord_cPCIoTEPSOptimisationIndicator = BOOL(name=u'cPCIoTEPSOptimisationIndicator', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CPCIoTEPSOptimisationIndicator')), opt=True)
    _SGWRecord_uNIPDUCPOnlyFlag = BOOL(name=u'uNIPDUCPOnlyFlag', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UNIPDUCPOnlyFlag')), opt=True)
    _SGWRecord_servingPLMNRateControl = SEQ(name=u'servingPLMNRateControl', mode=MODE_TYPE, tag=(61, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingPLMNRateControl')), opt=True)
    _SGWRecord_pDPPDNTypeExtension = INT(name=u'pDPPDNTypeExtension', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPPDNTypeExtension')), opt=True)
    _SGWRecord_mOExceptionDataCounter = SEQ(name=u'mOExceptionDataCounter', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'MOExceptionDataCounter')), opt=True)
    _SGWRecord_listOfRANSecondaryRATUsageReports = SEQ_OF(name=u'listOfRANSecondaryRATUsageReports', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SGWRecord_listOfRANSecondaryRATUsageReports__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'RANSecondaryRATUsageReport')))
    _SGWRecord_listOfRANSecondaryRATUsageReports._cont = __SGWRecord_listOfRANSecondaryRATUsageReports__item_
    SGWRecord._cont = ASN1Dict([
        (u'recordType', _SGWRecord_recordType),
        (u'servedIMSI', _SGWRecord_servedIMSI),
        (u's-GWAddress', _SGWRecord_s_GWAddress),
        (u'chargingID', _SGWRecord_chargingID),
        (u'servingNodeAddress', _SGWRecord_servingNodeAddress),
        (u'accessPointNameNI', _SGWRecord_accessPointNameNI),
        (u'pdpPDNType', _SGWRecord_pdpPDNType),
        (u'servedPDPPDNAddress', _SGWRecord_servedPDPPDNAddress),
        (u'dynamicAddressFlag', _SGWRecord_dynamicAddressFlag),
        (u'listOfTrafficVolumes', _SGWRecord_listOfTrafficVolumes),
        (u'recordOpeningTime', _SGWRecord_recordOpeningTime),
        (u'duration', _SGWRecord_duration),
        (u'causeForRecClosing', _SGWRecord_causeForRecClosing),
        (u'diagnostics', _SGWRecord_diagnostics),
        (u'recordSequenceNumber', _SGWRecord_recordSequenceNumber),
        (u'nodeID', _SGWRecord_nodeID),
        (u'recordExtensions', _SGWRecord_recordExtensions),
        (u'localSequenceNumber', _SGWRecord_localSequenceNumber),
        (u'apnSelectionMode', _SGWRecord_apnSelectionMode),
        (u'servedMSISDN', _SGWRecord_servedMSISDN),
        (u'chargingCharacteristics', _SGWRecord_chargingCharacteristics),
        (u'chChSelectionMode', _SGWRecord_chChSelectionMode),
        (u'iMSsignalingContext', _SGWRecord_iMSsignalingContext),
        (u'servingNodePLMNIdentifier', _SGWRecord_servingNodePLMNIdentifier),
        (u'servedIMEI', _SGWRecord_servedIMEI),
        (u'rATType', _SGWRecord_rATType),
        (u'mSTimeZone', _SGWRecord_mSTimeZone),
        (u'userLocationInformation', _SGWRecord_userLocationInformation),
        (u'sGWChange', _SGWRecord_sGWChange),
        (u'servingNodeType', _SGWRecord_servingNodeType),
        (u'p-GWAddressUsed', _SGWRecord_p_GWAddressUsed),
        (u'p-GWPLMNIdentifier', _SGWRecord_p_GWPLMNIdentifier),
        (u'startTime', _SGWRecord_startTime),
        (u'stopTime', _SGWRecord_stopTime),
        (u'pDNConnectionChargingID', _SGWRecord_pDNConnectionChargingID),
        (u'iMSIunauthenticatedFlag', _SGWRecord_iMSIunauthenticatedFlag),
        (u'userCSGInformation', _SGWRecord_userCSGInformation),
        (u'servedPDPPDNAddressExt', _SGWRecord_servedPDPPDNAddressExt),
        (u'lowPriorityIndicator', _SGWRecord_lowPriorityIndicator),
        (u'dynamicAddressFlagExt', _SGWRecord_dynamicAddressFlagExt),
        (u's-GWiPv6Address', _SGWRecord_s_GWiPv6Address),
        (u'servingNodeiPv6Address', _SGWRecord_servingNodeiPv6Address),
        (u'p-GWiPv6AddressUsed', _SGWRecord_p_GWiPv6AddressUsed),
        (u'retransmission', _SGWRecord_retransmission),
        (u'userLocationInfoTime', _SGWRecord_userLocationInfoTime),
        (u'cNOperatorSelectionEnt', _SGWRecord_cNOperatorSelectionEnt),
        (u'presenceReportingAreaInfo', _SGWRecord_presenceReportingAreaInfo),
        (u'lastUserLocationInformation', _SGWRecord_lastUserLocationInformation),
        (u'lastMSTimeZone', _SGWRecord_lastMSTimeZone),
        (u'enhancedDiagnostics', _SGWRecord_enhancedDiagnostics),
        (u'cPCIoTEPSOptimisationIndicator', _SGWRecord_cPCIoTEPSOptimisationIndicator),
        (u'uNIPDUCPOnlyFlag', _SGWRecord_uNIPDUCPOnlyFlag),
        (u'servingPLMNRateControl', _SGWRecord_servingPLMNRateControl),
        (u'pDPPDNTypeExtension', _SGWRecord_pDPPDNTypeExtension),
        (u'mOExceptionDataCounter', _SGWRecord_mOExceptionDataCounter),
        (u'listOfRANSecondaryRATUsageReports', _SGWRecord_listOfRANSecondaryRATUsageReports),
        ])
    SGWRecord._ext = None
    
    #-----< PGWRecord >-----#
    PGWRecord = SET(name=u'PGWRecord', mode=MODE_TYPE)
    _PGWRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _PGWRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _PGWRecord_p_GWAddress = CHOICE(name=u'p-GWAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _PGWRecord_chargingID = INT(name=u'chargingID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _PGWRecord_servingNodeAddress = SEQ_OF(name=u'servingNodeAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PGWRecord_servingNodeAddress__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _PGWRecord_servingNodeAddress._cont = __PGWRecord_servingNodeAddress__item_
    _PGWRecord_accessPointNameNI = STR_IA5(name=u'accessPointNameNI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _PGWRecord_pdpPDNType = OCT_STR(name=u'pdpPDNType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _PGWRecord_servedPDPPDNAddress = CHOICE(name=u'servedPDPPDNAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _PGWRecord_dynamicAddressFlag = BOOL(name=u'dynamicAddressFlag', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _PGWRecord_listOfTrafficVolumes = SEQ_OF(name=u'listOfTrafficVolumes', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PGWRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfCharCondition')))
    _PGWRecord_listOfTrafficVolumes._cont = __PGWRecord_listOfTrafficVolumes__item_
    _PGWRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _PGWRecord_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _PGWRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _PGWRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _PGWRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _PGWRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _PGWRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _PGWRecord_apnSelectionMode = ENUM(name=u'apnSelectionMode', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNSelectionMode')), opt=True)
    _PGWRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _PGWRecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _PGWRecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _PGWRecord_iMSsignalingContext = NULL(name=u'iMSsignalingContext', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_servingNodePLMNIdentifier = OCT_STR(name=u'servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PGWRecord_pSFurnishChargingInformation = SEQ(name=u'pSFurnishChargingInformation', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PSFurnishChargingInformation')), opt=True)
    _PGWRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _PGWRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _PGWRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _PGWRecord_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_cAMELChargingInformation = OCT_STR(name=u'cAMELChargingInformation', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_listOfServiceData = SEQ_OF(name=u'listOfServiceData', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PGWRecord_listOfServiceData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfServiceCondition')))
    _PGWRecord_listOfServiceData._cont = __PGWRecord_listOfServiceData__item_
    _PGWRecord_servingNodeType = SEQ_OF(name=u'servingNodeType', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PGWRecord_servingNodeType__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingNodeType')))
    _PGWRecord_servingNodeType._cont = __PGWRecord_servingNodeType__item_
    _PGWRecord_servedMNNAI = SET(name=u'servedMNNAI', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')), opt=True)
    _PGWRecord_p_GWPLMNIdentifier = OCT_STR(name=u'p-GWPLMNIdentifier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PGWRecord_startTime = OCT_STR(name=u'startTime', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PGWRecord_stopTime = OCT_STR(name=u'stopTime', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PGWRecord_served3gpp2MEID = OCT_STR(name=u'served3gpp2MEID', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_pDNConnectionChargingID = INT(name=u'pDNConnectionChargingID', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')), opt=True)
    _PGWRecord_iMSIunauthenticatedFlag = NULL(name=u'iMSIunauthenticatedFlag', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _PGWRecord_threeGPP2UserLocationInformation = OCT_STR(name=u'threeGPP2UserLocationInformation', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_servedPDPPDNAddressExt = CHOICE(name=u'servedPDPPDNAddressExt', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _PGWRecord_lowPriorityIndicator = NULL(name=u'lowPriorityIndicator', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_dynamicAddressFlagExt = BOOL(name=u'dynamicAddressFlagExt', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _PGWRecord_servingNodeiPv6Address = SEQ_OF(name=u'servingNodeiPv6Address', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PGWRecord_servingNodeiPv6Address__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _PGWRecord_servingNodeiPv6Address._cont = __PGWRecord_servingNodeiPv6Address__item_
    _PGWRecord_p_GWiPv6AddressUsed = CHOICE(name=u'p-GWiPv6AddressUsed', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _PGWRecord_tWANUserLocationInformation = SEQ(name=u'tWANUserLocationInformation', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TWANUserLocationInfo')), opt=True)
    _PGWRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_userLocationInfoTime = OCT_STR(name=u'userLocationInfoTime', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PGWRecord_cNOperatorSelectionEnt = ENUM(name=u'cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    _PGWRecord_ePCQoSInformation = SEQ(name=u'ePCQoSInformation', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'EPCQoSInformation')), opt=True)
    _PGWRecord_presenceReportingAreaInfo = SEQ(name=u'presenceReportingAreaInfo', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaInfo')), opt=True)
    _PGWRecord_lastUserLocationInformation = OCT_STR(name=u'lastUserLocationInformation', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PGWRecord_lastMSTimeZone = OCT_STR(name=u'lastMSTimeZone', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _PGWRecord_enhancedDiagnostics = SEQ(name=u'enhancedDiagnostics', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'EnhancedDiagnostics')), opt=True)
    _PGWRecord_nBIFOMMode = ENUM(name=u'nBIFOMMode', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'NBIFOMMode')), opt=True)
    _PGWRecord_nBIFOMSupport = ENUM(name=u'nBIFOMSupport', mode=MODE_TYPE, tag=(61, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'NBIFOMSupport')), opt=True)
    _PGWRecord_uWANUserLocationInformation = SEQ(name=u'uWANUserLocationInformation', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UWANUserLocationInfo')), opt=True)
    _PGWRecord_sGiPtPTunnellingMethod = ENUM(name=u'sGiPtPTunnellingMethod', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGiPtPTunnellingMethod')), opt=True)
    _PGWRecord_uNIPDUCPOnlyFlag = BOOL(name=u'uNIPDUCPOnlyFlag', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UNIPDUCPOnlyFlag')), opt=True)
    _PGWRecord_servingPLMNRateControl = SEQ(name=u'servingPLMNRateControl', mode=MODE_TYPE, tag=(66, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingPLMNRateControl')), opt=True)
    _PGWRecord_aPNRateControl = SEQ(name=u'aPNRateControl', mode=MODE_TYPE, tag=(67, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNRateControl')), opt=True)
    _PGWRecord_pDPPDNTypeExtension = INT(name=u'pDPPDNTypeExtension', mode=MODE_TYPE, tag=(68, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPPDNTypeExtension')), opt=True)
    _PGWRecord_mOExceptionDataCounter = SEQ(name=u'mOExceptionDataCounter', mode=MODE_TYPE, tag=(69, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'MOExceptionDataCounter')), opt=True)
    _PGWRecord_chargingPerIPCANSessionIndicator = ENUM(name=u'chargingPerIPCANSessionIndicator', mode=MODE_TYPE, tag=(70, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingPerIPCANSessionIndicator')), opt=True)
    _PGWRecord_threeGPPPSDataOffStatus = ENUM(name=u'threeGPPPSDataOffStatus', mode=MODE_TYPE, tag=(71, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ThreeGPPPSDataOffStatus')), opt=True)
    _PGWRecord_sCSASAddress = SET(name=u'sCSASAddress', mode=MODE_TYPE, tag=(72, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SCSASAddress')), opt=True)
    _PGWRecord_listOfRANSecondaryRATUsageReports = SEQ_OF(name=u'listOfRANSecondaryRATUsageReports', mode=MODE_TYPE, tag=(73, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PGWRecord_listOfRANSecondaryRATUsageReports__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'RANSecondaryRATUsageReport')))
    _PGWRecord_listOfRANSecondaryRATUsageReports._cont = __PGWRecord_listOfRANSecondaryRATUsageReports__item_
    PGWRecord._cont = ASN1Dict([
        (u'recordType', _PGWRecord_recordType),
        (u'servedIMSI', _PGWRecord_servedIMSI),
        (u'p-GWAddress', _PGWRecord_p_GWAddress),
        (u'chargingID', _PGWRecord_chargingID),
        (u'servingNodeAddress', _PGWRecord_servingNodeAddress),
        (u'accessPointNameNI', _PGWRecord_accessPointNameNI),
        (u'pdpPDNType', _PGWRecord_pdpPDNType),
        (u'servedPDPPDNAddress', _PGWRecord_servedPDPPDNAddress),
        (u'dynamicAddressFlag', _PGWRecord_dynamicAddressFlag),
        (u'listOfTrafficVolumes', _PGWRecord_listOfTrafficVolumes),
        (u'recordOpeningTime', _PGWRecord_recordOpeningTime),
        (u'duration', _PGWRecord_duration),
        (u'causeForRecClosing', _PGWRecord_causeForRecClosing),
        (u'diagnostics', _PGWRecord_diagnostics),
        (u'recordSequenceNumber', _PGWRecord_recordSequenceNumber),
        (u'nodeID', _PGWRecord_nodeID),
        (u'recordExtensions', _PGWRecord_recordExtensions),
        (u'localSequenceNumber', _PGWRecord_localSequenceNumber),
        (u'apnSelectionMode', _PGWRecord_apnSelectionMode),
        (u'servedMSISDN', _PGWRecord_servedMSISDN),
        (u'chargingCharacteristics', _PGWRecord_chargingCharacteristics),
        (u'chChSelectionMode', _PGWRecord_chChSelectionMode),
        (u'iMSsignalingContext', _PGWRecord_iMSsignalingContext),
        (u'servingNodePLMNIdentifier', _PGWRecord_servingNodePLMNIdentifier),
        (u'pSFurnishChargingInformation', _PGWRecord_pSFurnishChargingInformation),
        (u'servedIMEI', _PGWRecord_servedIMEI),
        (u'rATType', _PGWRecord_rATType),
        (u'mSTimeZone', _PGWRecord_mSTimeZone),
        (u'userLocationInformation', _PGWRecord_userLocationInformation),
        (u'cAMELChargingInformation', _PGWRecord_cAMELChargingInformation),
        (u'listOfServiceData', _PGWRecord_listOfServiceData),
        (u'servingNodeType', _PGWRecord_servingNodeType),
        (u'servedMNNAI', _PGWRecord_servedMNNAI),
        (u'p-GWPLMNIdentifier', _PGWRecord_p_GWPLMNIdentifier),
        (u'startTime', _PGWRecord_startTime),
        (u'stopTime', _PGWRecord_stopTime),
        (u'served3gpp2MEID', _PGWRecord_served3gpp2MEID),
        (u'pDNConnectionChargingID', _PGWRecord_pDNConnectionChargingID),
        (u'iMSIunauthenticatedFlag', _PGWRecord_iMSIunauthenticatedFlag),
        (u'userCSGInformation', _PGWRecord_userCSGInformation),
        (u'threeGPP2UserLocationInformation', _PGWRecord_threeGPP2UserLocationInformation),
        (u'servedPDPPDNAddressExt', _PGWRecord_servedPDPPDNAddressExt),
        (u'lowPriorityIndicator', _PGWRecord_lowPriorityIndicator),
        (u'dynamicAddressFlagExt', _PGWRecord_dynamicAddressFlagExt),
        (u'servingNodeiPv6Address', _PGWRecord_servingNodeiPv6Address),
        (u'p-GWiPv6AddressUsed', _PGWRecord_p_GWiPv6AddressUsed),
        (u'tWANUserLocationInformation', _PGWRecord_tWANUserLocationInformation),
        (u'retransmission', _PGWRecord_retransmission),
        (u'userLocationInfoTime', _PGWRecord_userLocationInfoTime),
        (u'cNOperatorSelectionEnt', _PGWRecord_cNOperatorSelectionEnt),
        (u'ePCQoSInformation', _PGWRecord_ePCQoSInformation),
        (u'presenceReportingAreaInfo', _PGWRecord_presenceReportingAreaInfo),
        (u'lastUserLocationInformation', _PGWRecord_lastUserLocationInformation),
        (u'lastMSTimeZone', _PGWRecord_lastMSTimeZone),
        (u'enhancedDiagnostics', _PGWRecord_enhancedDiagnostics),
        (u'nBIFOMMode', _PGWRecord_nBIFOMMode),
        (u'nBIFOMSupport', _PGWRecord_nBIFOMSupport),
        (u'uWANUserLocationInformation', _PGWRecord_uWANUserLocationInformation),
        (u'sGiPtPTunnellingMethod', _PGWRecord_sGiPtPTunnellingMethod),
        (u'uNIPDUCPOnlyFlag', _PGWRecord_uNIPDUCPOnlyFlag),
        (u'servingPLMNRateControl', _PGWRecord_servingPLMNRateControl),
        (u'aPNRateControl', _PGWRecord_aPNRateControl),
        (u'pDPPDNTypeExtension', _PGWRecord_pDPPDNTypeExtension),
        (u'mOExceptionDataCounter', _PGWRecord_mOExceptionDataCounter),
        (u'chargingPerIPCANSessionIndicator', _PGWRecord_chargingPerIPCANSessionIndicator),
        (u'threeGPPPSDataOffStatus', _PGWRecord_threeGPPPSDataOffStatus),
        (u'sCSASAddress', _PGWRecord_sCSASAddress),
        (u'listOfRANSecondaryRATUsageReports', _PGWRecord_listOfRANSecondaryRATUsageReports),
        ])
    PGWRecord._ext = None
    
    #-----< TDFRecord >-----#
    TDFRecord = SET(name=u'TDFRecord', mode=MODE_TYPE)
    _TDFRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _TDFRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _TDFRecord_p_GWAddress = CHOICE(name=u'p-GWAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _TDFRecord_servingNodeAddress = SEQ_OF(name=u'servingNodeAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TDFRecord_servingNodeAddress__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _TDFRecord_servingNodeAddress._cont = __TDFRecord_servingNodeAddress__item_
    _TDFRecord_accessPointNameNI = STR_IA5(name=u'accessPointNameNI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _TDFRecord_pdpPDNType = OCT_STR(name=u'pdpPDNType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _TDFRecord_servedPDPPDNAddress = CHOICE(name=u'servedPDPPDNAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _TDFRecord_dynamicAddressFlag = BOOL(name=u'dynamicAddressFlag', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _TDFRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _TDFRecord_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _TDFRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _TDFRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _TDFRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TDFRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _TDFRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _TDFRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _TDFRecord_apnSelectionMode = ENUM(name=u'apnSelectionMode', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNSelectionMode')), opt=True)
    _TDFRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _TDFRecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _TDFRecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _TDFRecord_servingNodePLMNIdentifier = OCT_STR(name=u'servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _TDFRecord_pSFurnishChargingInformation = SEQ(name=u'pSFurnishChargingInformation', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PSFurnishChargingInformation')), opt=True)
    _TDFRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _TDFRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _TDFRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _TDFRecord_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TDFRecord_listOfServiceData = SEQ_OF(name=u'listOfServiceData', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TDFRecord_listOfServiceData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfServiceCondition')))
    _TDFRecord_listOfServiceData._cont = __TDFRecord_listOfServiceData__item_
    _TDFRecord_servingNodeType = SEQ_OF(name=u'servingNodeType', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TDFRecord_servingNodeType__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingNodeType')))
    _TDFRecord_servingNodeType._cont = __TDFRecord_servingNodeType__item_
    _TDFRecord_servedMNNAI = SET(name=u'servedMNNAI', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')), opt=True)
    _TDFRecord_p_GWPLMNIdentifier = OCT_STR(name=u'p-GWPLMNIdentifier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _TDFRecord_startTime = OCT_STR(name=u'startTime', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TDFRecord_stopTime = OCT_STR(name=u'stopTime', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TDFRecord_served3gpp2MEID = OCT_STR(name=u'served3gpp2MEID', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TDFRecord_pDNConnectionChargingID = INT(name=u'pDNConnectionChargingID', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _TDFRecord_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _TDFRecord_threeGPP2UserLocationInformation = OCT_STR(name=u'threeGPP2UserLocationInformation', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TDFRecord_servedPDPPDNAddressExt = CHOICE(name=u'servedPDPPDNAddressExt', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _TDFRecord_dynamicAddressFlagExt = BOOL(name=u'dynamicAddressFlagExt', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _TDFRecord_servingNodeiPv6Address = SEQ_OF(name=u'servingNodeiPv6Address', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TDFRecord_servingNodeiPv6Address__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _TDFRecord_servingNodeiPv6Address._cont = __TDFRecord_servingNodeiPv6Address__item_
    _TDFRecord_p_GWiPv6AddressUsed = CHOICE(name=u'p-GWiPv6AddressUsed', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _TDFRecord_tWANUserLocationInformation = SEQ(name=u'tWANUserLocationInformation', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TWANUserLocationInfo')), opt=True)
    _TDFRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TDFRecord_tDFAddress = CHOICE(name=u'tDFAddress', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _TDFRecord_tDFiPv6AddressUsed = CHOICE(name=u'tDFiPv6AddressUsed', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _TDFRecord_tDFPLMNIdentifier = OCT_STR(name=u'tDFPLMNIdentifier', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _TDFRecord_servedFixedSubsID = OCT_STR(name=u'servedFixedSubsID', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FixedSubsID')), opt=True)
    _TDFRecord_accessLineIdentifier = SEQ(name=u'accessLineIdentifier', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessLineIdentifier')), opt=True)
    _TDFRecord_fixedUserLocationInformation = SEQ(name=u'fixedUserLocationInformation', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FixedUserLocationInformation')), opt=True)
    TDFRecord._cont = ASN1Dict([
        (u'recordType', _TDFRecord_recordType),
        (u'servedIMSI', _TDFRecord_servedIMSI),
        (u'p-GWAddress', _TDFRecord_p_GWAddress),
        (u'servingNodeAddress', _TDFRecord_servingNodeAddress),
        (u'accessPointNameNI', _TDFRecord_accessPointNameNI),
        (u'pdpPDNType', _TDFRecord_pdpPDNType),
        (u'servedPDPPDNAddress', _TDFRecord_servedPDPPDNAddress),
        (u'dynamicAddressFlag', _TDFRecord_dynamicAddressFlag),
        (u'recordOpeningTime', _TDFRecord_recordOpeningTime),
        (u'duration', _TDFRecord_duration),
        (u'causeForRecClosing', _TDFRecord_causeForRecClosing),
        (u'diagnostics', _TDFRecord_diagnostics),
        (u'recordSequenceNumber', _TDFRecord_recordSequenceNumber),
        (u'nodeID', _TDFRecord_nodeID),
        (u'recordExtensions', _TDFRecord_recordExtensions),
        (u'localSequenceNumber', _TDFRecord_localSequenceNumber),
        (u'apnSelectionMode', _TDFRecord_apnSelectionMode),
        (u'servedMSISDN', _TDFRecord_servedMSISDN),
        (u'chargingCharacteristics', _TDFRecord_chargingCharacteristics),
        (u'chChSelectionMode', _TDFRecord_chChSelectionMode),
        (u'servingNodePLMNIdentifier', _TDFRecord_servingNodePLMNIdentifier),
        (u'pSFurnishChargingInformation', _TDFRecord_pSFurnishChargingInformation),
        (u'servedIMEI', _TDFRecord_servedIMEI),
        (u'rATType', _TDFRecord_rATType),
        (u'mSTimeZone', _TDFRecord_mSTimeZone),
        (u'userLocationInformation', _TDFRecord_userLocationInformation),
        (u'listOfServiceData', _TDFRecord_listOfServiceData),
        (u'servingNodeType', _TDFRecord_servingNodeType),
        (u'servedMNNAI', _TDFRecord_servedMNNAI),
        (u'p-GWPLMNIdentifier', _TDFRecord_p_GWPLMNIdentifier),
        (u'startTime', _TDFRecord_startTime),
        (u'stopTime', _TDFRecord_stopTime),
        (u'served3gpp2MEID', _TDFRecord_served3gpp2MEID),
        (u'pDNConnectionChargingID', _TDFRecord_pDNConnectionChargingID),
        (u'userCSGInformation', _TDFRecord_userCSGInformation),
        (u'threeGPP2UserLocationInformation', _TDFRecord_threeGPP2UserLocationInformation),
        (u'servedPDPPDNAddressExt', _TDFRecord_servedPDPPDNAddressExt),
        (u'dynamicAddressFlagExt', _TDFRecord_dynamicAddressFlagExt),
        (u'servingNodeiPv6Address', _TDFRecord_servingNodeiPv6Address),
        (u'p-GWiPv6AddressUsed', _TDFRecord_p_GWiPv6AddressUsed),
        (u'tWANUserLocationInformation', _TDFRecord_tWANUserLocationInformation),
        (u'retransmission', _TDFRecord_retransmission),
        (u'tDFAddress', _TDFRecord_tDFAddress),
        (u'tDFiPv6AddressUsed', _TDFRecord_tDFiPv6AddressUsed),
        (u'tDFPLMNIdentifier', _TDFRecord_tDFPLMNIdentifier),
        (u'servedFixedSubsID', _TDFRecord_servedFixedSubsID),
        (u'accessLineIdentifier', _TDFRecord_accessLineIdentifier),
        (u'fixedUserLocationInformation', _TDFRecord_fixedUserLocationInformation),
        ])
    TDFRecord._ext = None
    
    #-----< IPERecord >-----#
    IPERecord = SET(name=u'IPERecord', mode=MODE_TYPE)
    _IPERecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _IPERecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _IPERecord_iPEdgeAddress = CHOICE(name=u'iPEdgeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _IPERecord_chargingID = INT(name=u'chargingID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _IPERecord_accessPointNameNI = STR_IA5(name=u'accessPointNameNI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _IPERecord_iPCANsessionType = OCT_STR(name=u'iPCANsessionType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _IPERecord_servedIPCANsessionAddress = CHOICE(name=u'servedIPCANsessionAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _IPERecord_dynamicAddressFlag = BOOL(name=u'dynamicAddressFlag', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _IPERecord_listOfTrafficVolumes = SEQ_OF(name=u'listOfTrafficVolumes', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IPERecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfCharCondition')))
    _IPERecord_listOfTrafficVolumes._cont = __IPERecord_listOfTrafficVolumes__item_
    _IPERecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _IPERecord_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _IPERecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _IPERecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _IPERecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IPERecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _IPERecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _IPERecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _IPERecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _IPERecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _IPERecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _IPERecord_pSFurnishChargingInformation = SEQ(name=u'pSFurnishChargingInformation', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PSFurnishChargingInformation')), opt=True)
    _IPERecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _IPERecord_listOfServiceData = SEQ_OF(name=u'listOfServiceData', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IPERecord_listOfServiceData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfServiceCondition')))
    _IPERecord_listOfServiceData._cont = __IPERecord_listOfServiceData__item_
    _IPERecord_servedMNNAI = SET(name=u'servedMNNAI', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')), opt=True)
    _IPERecord_iPEdgeOperatorIdentifier = OCT_STR(name=u'iPEdgeOperatorIdentifier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _IPERecord_startTime = OCT_STR(name=u'startTime', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IPERecord_stopTime = OCT_STR(name=u'stopTime', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IPERecord_servedIPCANsessionAddressExt = CHOICE(name=u'servedIPCANsessionAddressExt', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _IPERecord_dynamicAddressFlagExt = BOOL(name=u'dynamicAddressFlagExt', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _IPERecord_iPEdgeiPv6AddressUsed = CHOICE(name=u'iPEdgeiPv6AddressUsed', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _IPERecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IPERecord_servedFixedSubsID = OCT_STR(name=u'servedFixedSubsID', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FixedSubsID')), opt=True)
    _IPERecord_accessLineIdentifier = SEQ(name=u'accessLineIdentifier', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessLineIdentifier')), opt=True)
    _IPERecord_fixedUserLocationInformation = SEQ(name=u'fixedUserLocationInformation', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FixedUserLocationInformation')), opt=True)
    IPERecord._cont = ASN1Dict([
        (u'recordType', _IPERecord_recordType),
        (u'servedIMSI', _IPERecord_servedIMSI),
        (u'iPEdgeAddress', _IPERecord_iPEdgeAddress),
        (u'chargingID', _IPERecord_chargingID),
        (u'accessPointNameNI', _IPERecord_accessPointNameNI),
        (u'iPCANsessionType', _IPERecord_iPCANsessionType),
        (u'servedIPCANsessionAddress', _IPERecord_servedIPCANsessionAddress),
        (u'dynamicAddressFlag', _IPERecord_dynamicAddressFlag),
        (u'listOfTrafficVolumes', _IPERecord_listOfTrafficVolumes),
        (u'recordOpeningTime', _IPERecord_recordOpeningTime),
        (u'duration', _IPERecord_duration),
        (u'causeForRecClosing', _IPERecord_causeForRecClosing),
        (u'diagnostics', _IPERecord_diagnostics),
        (u'recordSequenceNumber', _IPERecord_recordSequenceNumber),
        (u'nodeID', _IPERecord_nodeID),
        (u'recordExtensions', _IPERecord_recordExtensions),
        (u'localSequenceNumber', _IPERecord_localSequenceNumber),
        (u'servedMSISDN', _IPERecord_servedMSISDN),
        (u'chargingCharacteristics', _IPERecord_chargingCharacteristics),
        (u'chChSelectionMode', _IPERecord_chChSelectionMode),
        (u'pSFurnishChargingInformation', _IPERecord_pSFurnishChargingInformation),
        (u'servedIMEI', _IPERecord_servedIMEI),
        (u'listOfServiceData', _IPERecord_listOfServiceData),
        (u'servedMNNAI', _IPERecord_servedMNNAI),
        (u'iPEdgeOperatorIdentifier', _IPERecord_iPEdgeOperatorIdentifier),
        (u'startTime', _IPERecord_startTime),
        (u'stopTime', _IPERecord_stopTime),
        (u'servedIPCANsessionAddressExt', _IPERecord_servedIPCANsessionAddressExt),
        (u'dynamicAddressFlagExt', _IPERecord_dynamicAddressFlagExt),
        (u'iPEdgeiPv6AddressUsed', _IPERecord_iPEdgeiPv6AddressUsed),
        (u'retransmission', _IPERecord_retransmission),
        (u'servedFixedSubsID', _IPERecord_servedFixedSubsID),
        (u'accessLineIdentifier', _IPERecord_accessLineIdentifier),
        (u'fixedUserLocationInformation', _IPERecord_fixedUserLocationInformation),
        ])
    IPERecord._ext = None
    
    #-----< EPDGRecord >-----#
    EPDGRecord = SET(name=u'EPDGRecord', mode=MODE_TYPE)
    _EPDGRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _EPDGRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _EPDGRecord_ePDGAddressUsed = CHOICE(name=u'ePDGAddressUsed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _EPDGRecord_chargingID = INT(name=u'chargingID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _EPDGRecord_accessPointNameNI = STR_IA5(name=u'accessPointNameNI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _EPDGRecord_pdpPDNType = OCT_STR(name=u'pdpPDNType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _EPDGRecord_servedPDPPDNAddress = CHOICE(name=u'servedPDPPDNAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _EPDGRecord_dynamicAddressFlag = BOOL(name=u'dynamicAddressFlag', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _EPDGRecord_listOfTrafficVolumes = SEQ_OF(name=u'listOfTrafficVolumes', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __EPDGRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfCharCondition')))
    _EPDGRecord_listOfTrafficVolumes._cont = __EPDGRecord_listOfTrafficVolumes__item_
    _EPDGRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _EPDGRecord_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _EPDGRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _EPDGRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _EPDGRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPDGRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _EPDGRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _EPDGRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _EPDGRecord_apnSelectionMode = ENUM(name=u'apnSelectionMode', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNSelectionMode')), opt=True)
    _EPDGRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _EPDGRecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _EPDGRecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _EPDGRecord_iMSsignalingContext = NULL(name=u'iMSsignalingContext', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPDGRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _EPDGRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _EPDGRecord_sGWChange = BOOL(name=u'sGWChange', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGWChange')), opt=True)
    _EPDGRecord_p_GWAddressUsed = CHOICE(name=u'p-GWAddressUsed', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _EPDGRecord_p_GWPLMNIdentifier = OCT_STR(name=u'p-GWPLMNIdentifier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _EPDGRecord_startTime = OCT_STR(name=u'startTime', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _EPDGRecord_stopTime = OCT_STR(name=u'stopTime', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _EPDGRecord_pDNConnectionChargingID = INT(name=u'pDNConnectionChargingID', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')), opt=True)
    _EPDGRecord_servedPDPPDNAddressExt = CHOICE(name=u'servedPDPPDNAddressExt', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _EPDGRecord_dynamicAddressFlagExt = BOOL(name=u'dynamicAddressFlagExt', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _EPDGRecord_ePDGiPv6AddressUsed = CHOICE(name=u'ePDGiPv6AddressUsed', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _EPDGRecord_p_GWiPv6AddressUsed = CHOICE(name=u'p-GWiPv6AddressUsed', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _EPDGRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPDGRecord_enhancedDiagnostics = SEQ(name=u'enhancedDiagnostics', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'EnhancedDiagnostics')), opt=True)
    _EPDGRecord_uWANUserLocationInformation = SEQ(name=u'uWANUserLocationInformation', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UWANUserLocationInfo')), opt=True)
    _EPDGRecord_userLocationInfoTime = OCT_STR(name=u'userLocationInfoTime', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _EPDGRecord_iMSIunauthenticatedFlag = NULL(name=u'iMSIunauthenticatedFlag', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    EPDGRecord._cont = ASN1Dict([
        (u'recordType', _EPDGRecord_recordType),
        (u'servedIMSI', _EPDGRecord_servedIMSI),
        (u'ePDGAddressUsed', _EPDGRecord_ePDGAddressUsed),
        (u'chargingID', _EPDGRecord_chargingID),
        (u'accessPointNameNI', _EPDGRecord_accessPointNameNI),
        (u'pdpPDNType', _EPDGRecord_pdpPDNType),
        (u'servedPDPPDNAddress', _EPDGRecord_servedPDPPDNAddress),
        (u'dynamicAddressFlag', _EPDGRecord_dynamicAddressFlag),
        (u'listOfTrafficVolumes', _EPDGRecord_listOfTrafficVolumes),
        (u'recordOpeningTime', _EPDGRecord_recordOpeningTime),
        (u'duration', _EPDGRecord_duration),
        (u'causeForRecClosing', _EPDGRecord_causeForRecClosing),
        (u'diagnostics', _EPDGRecord_diagnostics),
        (u'recordSequenceNumber', _EPDGRecord_recordSequenceNumber),
        (u'nodeID', _EPDGRecord_nodeID),
        (u'recordExtensions', _EPDGRecord_recordExtensions),
        (u'localSequenceNumber', _EPDGRecord_localSequenceNumber),
        (u'apnSelectionMode', _EPDGRecord_apnSelectionMode),
        (u'servedMSISDN', _EPDGRecord_servedMSISDN),
        (u'chargingCharacteristics', _EPDGRecord_chargingCharacteristics),
        (u'chChSelectionMode', _EPDGRecord_chChSelectionMode),
        (u'iMSsignalingContext', _EPDGRecord_iMSsignalingContext),
        (u'servedIMEI', _EPDGRecord_servedIMEI),
        (u'rATType', _EPDGRecord_rATType),
        (u'sGWChange', _EPDGRecord_sGWChange),
        (u'p-GWAddressUsed', _EPDGRecord_p_GWAddressUsed),
        (u'p-GWPLMNIdentifier', _EPDGRecord_p_GWPLMNIdentifier),
        (u'startTime', _EPDGRecord_startTime),
        (u'stopTime', _EPDGRecord_stopTime),
        (u'pDNConnectionChargingID', _EPDGRecord_pDNConnectionChargingID),
        (u'servedPDPPDNAddressExt', _EPDGRecord_servedPDPPDNAddressExt),
        (u'dynamicAddressFlagExt', _EPDGRecord_dynamicAddressFlagExt),
        (u'ePDGiPv6AddressUsed', _EPDGRecord_ePDGiPv6AddressUsed),
        (u'p-GWiPv6AddressUsed', _EPDGRecord_p_GWiPv6AddressUsed),
        (u'retransmission', _EPDGRecord_retransmission),
        (u'enhancedDiagnostics', _EPDGRecord_enhancedDiagnostics),
        (u'uWANUserLocationInformation', _EPDGRecord_uWANUserLocationInformation),
        (u'userLocationInfoTime', _EPDGRecord_userLocationInfoTime),
        (u'iMSIunauthenticatedFlag', _EPDGRecord_iMSIunauthenticatedFlag),
        ])
    EPDGRecord._ext = None
    
    #-----< TWAGRecord >-----#
    TWAGRecord = SET(name=u'TWAGRecord', mode=MODE_TYPE)
    _TWAGRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _TWAGRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _TWAGRecord_tWAGAddressUsed = CHOICE(name=u'tWAGAddressUsed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _TWAGRecord_chargingID = INT(name=u'chargingID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _TWAGRecord_accessPointNameNI = STR_IA5(name=u'accessPointNameNI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _TWAGRecord_pdpPDNType = OCT_STR(name=u'pdpPDNType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _TWAGRecord_servedPDPPDNAddress = CHOICE(name=u'servedPDPPDNAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _TWAGRecord_dynamicAddressFlag = BOOL(name=u'dynamicAddressFlag', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _TWAGRecord_listOfTrafficVolumes = SEQ_OF(name=u'listOfTrafficVolumes', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TWAGRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfCharCondition')))
    _TWAGRecord_listOfTrafficVolumes._cont = __TWAGRecord_listOfTrafficVolumes__item_
    _TWAGRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _TWAGRecord_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _TWAGRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _TWAGRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _TWAGRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TWAGRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _TWAGRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _TWAGRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _TWAGRecord_apnSelectionMode = ENUM(name=u'apnSelectionMode', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNSelectionMode')), opt=True)
    _TWAGRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _TWAGRecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _TWAGRecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _TWAGRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _TWAGRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _TWAGRecord_sGWChange = BOOL(name=u'sGWChange', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGWChange')), opt=True)
    _TWAGRecord_p_GWAddressUsed = CHOICE(name=u'p-GWAddressUsed', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _TWAGRecord_p_GWPLMNIdentifier = OCT_STR(name=u'p-GWPLMNIdentifier', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _TWAGRecord_startTime = OCT_STR(name=u'startTime', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TWAGRecord_stopTime = OCT_STR(name=u'stopTime', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TWAGRecord_pDNConnectionChargingID = INT(name=u'pDNConnectionChargingID', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')), opt=True)
    _TWAGRecord_servedPDPPDNAddressExt = CHOICE(name=u'servedPDPPDNAddressExt', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _TWAGRecord_dynamicAddressFlagExt = BOOL(name=u'dynamicAddressFlagExt', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _TWAGRecord_tWAGiPv6AddressUsed = CHOICE(name=u'tWAGiPv6AddressUsed', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _TWAGRecord_p_GWiPv6AddressUsed = CHOICE(name=u'p-GWiPv6AddressUsed', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _TWAGRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TWAGRecord_enhancedDiagnostics = SEQ(name=u'enhancedDiagnostics', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'EnhancedDiagnostics')), opt=True)
    _TWAGRecord_tWANUserLocationInformation = SEQ(name=u'tWANUserLocationInformation', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TWANUserLocationInfo')), opt=True)
    _TWAGRecord_iMSIunauthenticatedFlag = NULL(name=u'iMSIunauthenticatedFlag', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    TWAGRecord._cont = ASN1Dict([
        (u'recordType', _TWAGRecord_recordType),
        (u'servedIMSI', _TWAGRecord_servedIMSI),
        (u'tWAGAddressUsed', _TWAGRecord_tWAGAddressUsed),
        (u'chargingID', _TWAGRecord_chargingID),
        (u'accessPointNameNI', _TWAGRecord_accessPointNameNI),
        (u'pdpPDNType', _TWAGRecord_pdpPDNType),
        (u'servedPDPPDNAddress', _TWAGRecord_servedPDPPDNAddress),
        (u'dynamicAddressFlag', _TWAGRecord_dynamicAddressFlag),
        (u'listOfTrafficVolumes', _TWAGRecord_listOfTrafficVolumes),
        (u'recordOpeningTime', _TWAGRecord_recordOpeningTime),
        (u'duration', _TWAGRecord_duration),
        (u'causeForRecClosing', _TWAGRecord_causeForRecClosing),
        (u'diagnostics', _TWAGRecord_diagnostics),
        (u'recordSequenceNumber', _TWAGRecord_recordSequenceNumber),
        (u'nodeID', _TWAGRecord_nodeID),
        (u'recordExtensions', _TWAGRecord_recordExtensions),
        (u'localSequenceNumber', _TWAGRecord_localSequenceNumber),
        (u'apnSelectionMode', _TWAGRecord_apnSelectionMode),
        (u'servedMSISDN', _TWAGRecord_servedMSISDN),
        (u'chargingCharacteristics', _TWAGRecord_chargingCharacteristics),
        (u'chChSelectionMode', _TWAGRecord_chChSelectionMode),
        (u'servedIMEI', _TWAGRecord_servedIMEI),
        (u'rATType', _TWAGRecord_rATType),
        (u'sGWChange', _TWAGRecord_sGWChange),
        (u'p-GWAddressUsed', _TWAGRecord_p_GWAddressUsed),
        (u'p-GWPLMNIdentifier', _TWAGRecord_p_GWPLMNIdentifier),
        (u'startTime', _TWAGRecord_startTime),
        (u'stopTime', _TWAGRecord_stopTime),
        (u'pDNConnectionChargingID', _TWAGRecord_pDNConnectionChargingID),
        (u'servedPDPPDNAddressExt', _TWAGRecord_servedPDPPDNAddressExt),
        (u'dynamicAddressFlagExt', _TWAGRecord_dynamicAddressFlagExt),
        (u'tWAGiPv6AddressUsed', _TWAGRecord_tWAGiPv6AddressUsed),
        (u'p-GWiPv6AddressUsed', _TWAGRecord_p_GWiPv6AddressUsed),
        (u'retransmission', _TWAGRecord_retransmission),
        (u'enhancedDiagnostics', _TWAGRecord_enhancedDiagnostics),
        (u'tWANUserLocationInformation', _TWAGRecord_tWANUserLocationInformation),
        (u'iMSIunauthenticatedFlag', _TWAGRecord_iMSIunauthenticatedFlag),
        ])
    TWAGRecord._ext = None
    
    #-----< SGSNMMRecord >-----#
    SGSNMMRecord = SET(name=u'SGSNMMRecord', mode=MODE_TYPE)
    _SGSNMMRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNMMRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SGSNMMRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SGSNMMRecord_sgsnAddress = CHOICE(name=u'sgsnAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNMMRecord_msNetworkCapability = OCT_STR(name=u'msNetworkCapability', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'MSNetworkCapability')), opt=True)
    _SGSNMMRecord_routingArea = OCT_STR(name=u'routingArea', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _SGSNMMRecord_locationAreaCode = OCT_STR(name=u'locationAreaCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaCode')), opt=True)
    _SGSNMMRecord_cellIdentifier = OCT_STR(name=u'cellIdentifier', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')), opt=True)
    _SGSNMMRecord_changeLocation = SEQ_OF(name=u'changeLocation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SGSNMMRecord_changeLocation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeLocation')))
    _SGSNMMRecord_changeLocation._cont = __SGSNMMRecord_changeLocation__item_
    _SGSNMMRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNMMRecord_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _SGSNMMRecord_sgsnChange = BOOL(name=u'sgsnChange', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNChange')), opt=True)
    _SGSNMMRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _SGSNMMRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SGSNMMRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNMMRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNMMRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNMMRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNMMRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGSNMMRecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGSNMMRecord_cAMELInformationMM = SET(name=u'cAMELInformationMM', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CAMELInformationMM')), opt=True)
    _SGSNMMRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGSNMMRecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGSNMMRecord_cellPLMNId = OCT_STR(name=u'cellPLMNId', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNMMRecord_servingNodePLMNIdentifier = OCT_STR(name=u'servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNMMRecord_cNOperatorSelectionEnt = ENUM(name=u'cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    SGSNMMRecord._cont = ASN1Dict([
        (u'recordType', _SGSNMMRecord_recordType),
        (u'servedIMSI', _SGSNMMRecord_servedIMSI),
        (u'servedIMEI', _SGSNMMRecord_servedIMEI),
        (u'sgsnAddress', _SGSNMMRecord_sgsnAddress),
        (u'msNetworkCapability', _SGSNMMRecord_msNetworkCapability),
        (u'routingArea', _SGSNMMRecord_routingArea),
        (u'locationAreaCode', _SGSNMMRecord_locationAreaCode),
        (u'cellIdentifier', _SGSNMMRecord_cellIdentifier),
        (u'changeLocation', _SGSNMMRecord_changeLocation),
        (u'recordOpeningTime', _SGSNMMRecord_recordOpeningTime),
        (u'duration', _SGSNMMRecord_duration),
        (u'sgsnChange', _SGSNMMRecord_sgsnChange),
        (u'causeForRecClosing', _SGSNMMRecord_causeForRecClosing),
        (u'diagnostics', _SGSNMMRecord_diagnostics),
        (u'recordSequenceNumber', _SGSNMMRecord_recordSequenceNumber),
        (u'nodeID', _SGSNMMRecord_nodeID),
        (u'recordExtensions', _SGSNMMRecord_recordExtensions),
        (u'localSequenceNumber', _SGSNMMRecord_localSequenceNumber),
        (u'servedMSISDN', _SGSNMMRecord_servedMSISDN),
        (u'chargingCharacteristics', _SGSNMMRecord_chargingCharacteristics),
        (u'cAMELInformationMM', _SGSNMMRecord_cAMELInformationMM),
        (u'rATType', _SGSNMMRecord_rATType),
        (u'chChSelectionMode', _SGSNMMRecord_chChSelectionMode),
        (u'cellPLMNId', _SGSNMMRecord_cellPLMNId),
        (u'servingNodePLMNIdentifier', _SGSNMMRecord_servingNodePLMNIdentifier),
        (u'cNOperatorSelectionEnt', _SGSNMMRecord_cNOperatorSelectionEnt),
        ])
    SGSNMMRecord._ext = None
    
    #-----< SGSNPDPRecord >-----#
    SGSNPDPRecord = SET(name=u'SGSNPDPRecord', mode=MODE_TYPE)
    _SGSNPDPRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNPDPRecord_networkInitiation = BOOL(name=u'networkInitiation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'NetworkInitiatedPDPContext')), opt=True)
    _SGSNPDPRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SGSNPDPRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SGSNPDPRecord_sgsnAddress = CHOICE(name=u'sgsnAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNPDPRecord_msNetworkCapability = OCT_STR(name=u'msNetworkCapability', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'MSNetworkCapability')), opt=True)
    _SGSNPDPRecord_routingArea = OCT_STR(name=u'routingArea', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _SGSNPDPRecord_locationAreaCode = OCT_STR(name=u'locationAreaCode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaCode')), opt=True)
    _SGSNPDPRecord_cellIdentifier = OCT_STR(name=u'cellIdentifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')), opt=True)
    _SGSNPDPRecord_chargingID = INT(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _SGSNPDPRecord_ggsnAddressUsed = CHOICE(name=u'ggsnAddressUsed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _SGSNPDPRecord_accessPointNameNI = STR_IA5(name=u'accessPointNameNI', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _SGSNPDPRecord_pdpType = OCT_STR(name=u'pdpType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _SGSNPDPRecord_servedPDPAddress = CHOICE(name=u'servedPDPAddress', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _SGSNPDPRecord_listOfTrafficVolumes = SEQ_OF(name=u'listOfTrafficVolumes', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SGSNPDPRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfCharCondition')))
    _SGSNPDPRecord_listOfTrafficVolumes._cont = __SGSNPDPRecord_listOfTrafficVolumes__item_
    _SGSNPDPRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNPDPRecord_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _SGSNPDPRecord_sgsnChange = BOOL(name=u'sgsnChange', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SGSNChange')), opt=True)
    _SGSNPDPRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _SGSNPDPRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SGSNPDPRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNPDPRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNPDPRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNPDPRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNPDPRecord_apnSelectionMode = ENUM(name=u'apnSelectionMode', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNSelectionMode')), opt=True)
    _SGSNPDPRecord_accessPointNameOI = STR_IA5(name=u'accessPointNameOI', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameOI')), opt=True)
    _SGSNPDPRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGSNPDPRecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGSNPDPRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGSNPDPRecord_cAMELInformationPDP = SET(name=u'cAMELInformationPDP', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CAMELInformationPDP')), opt=True)
    _SGSNPDPRecord_rNCUnsentDownlinkVolume = INT(name=u'rNCUnsentDownlinkVolume', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _SGSNPDPRecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGSNPDPRecord_dynamicAddressFlag = BOOL(name=u'dynamicAddressFlag', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DynamicAddressFlag')), opt=True)
    _SGSNPDPRecord_iMSIunauthenticatedFlag = NULL(name=u'iMSIunauthenticatedFlag', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNPDPRecord_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _SGSNPDPRecord_servedPDPPDNAddressExt = CHOICE(name=u'servedPDPPDNAddressExt', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _SGSNPDPRecord_lowPriorityIndicator = NULL(name=u'lowPriorityIndicator', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNPDPRecord_servingNodePLMNIdentifier = OCT_STR(name=u'servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNPDPRecord_cNOperatorSelectionEnt = ENUM(name=u'cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    SGSNPDPRecord._cont = ASN1Dict([
        (u'recordType', _SGSNPDPRecord_recordType),
        (u'networkInitiation', _SGSNPDPRecord_networkInitiation),
        (u'servedIMSI', _SGSNPDPRecord_servedIMSI),
        (u'servedIMEI', _SGSNPDPRecord_servedIMEI),
        (u'sgsnAddress', _SGSNPDPRecord_sgsnAddress),
        (u'msNetworkCapability', _SGSNPDPRecord_msNetworkCapability),
        (u'routingArea', _SGSNPDPRecord_routingArea),
        (u'locationAreaCode', _SGSNPDPRecord_locationAreaCode),
        (u'cellIdentifier', _SGSNPDPRecord_cellIdentifier),
        (u'chargingID', _SGSNPDPRecord_chargingID),
        (u'ggsnAddressUsed', _SGSNPDPRecord_ggsnAddressUsed),
        (u'accessPointNameNI', _SGSNPDPRecord_accessPointNameNI),
        (u'pdpType', _SGSNPDPRecord_pdpType),
        (u'servedPDPAddress', _SGSNPDPRecord_servedPDPAddress),
        (u'listOfTrafficVolumes', _SGSNPDPRecord_listOfTrafficVolumes),
        (u'recordOpeningTime', _SGSNPDPRecord_recordOpeningTime),
        (u'duration', _SGSNPDPRecord_duration),
        (u'sgsnChange', _SGSNPDPRecord_sgsnChange),
        (u'causeForRecClosing', _SGSNPDPRecord_causeForRecClosing),
        (u'diagnostics', _SGSNPDPRecord_diagnostics),
        (u'recordSequenceNumber', _SGSNPDPRecord_recordSequenceNumber),
        (u'nodeID', _SGSNPDPRecord_nodeID),
        (u'recordExtensions', _SGSNPDPRecord_recordExtensions),
        (u'localSequenceNumber', _SGSNPDPRecord_localSequenceNumber),
        (u'apnSelectionMode', _SGSNPDPRecord_apnSelectionMode),
        (u'accessPointNameOI', _SGSNPDPRecord_accessPointNameOI),
        (u'servedMSISDN', _SGSNPDPRecord_servedMSISDN),
        (u'chargingCharacteristics', _SGSNPDPRecord_chargingCharacteristics),
        (u'rATType', _SGSNPDPRecord_rATType),
        (u'cAMELInformationPDP', _SGSNPDPRecord_cAMELInformationPDP),
        (u'rNCUnsentDownlinkVolume', _SGSNPDPRecord_rNCUnsentDownlinkVolume),
        (u'chChSelectionMode', _SGSNPDPRecord_chChSelectionMode),
        (u'dynamicAddressFlag', _SGSNPDPRecord_dynamicAddressFlag),
        (u'iMSIunauthenticatedFlag', _SGSNPDPRecord_iMSIunauthenticatedFlag),
        (u'userCSGInformation', _SGSNPDPRecord_userCSGInformation),
        (u'servedPDPPDNAddressExt', _SGSNPDPRecord_servedPDPPDNAddressExt),
        (u'lowPriorityIndicator', _SGSNPDPRecord_lowPriorityIndicator),
        (u'servingNodePLMNIdentifier', _SGSNPDPRecord_servingNodePLMNIdentifier),
        (u'cNOperatorSelectionEnt', _SGSNPDPRecord_cNOperatorSelectionEnt),
        ])
    SGSNPDPRecord._ext = None
    
    #-----< SGSNSMORecord >-----#
    SGSNSMORecord = SET(name=u'SGSNSMORecord', mode=MODE_TYPE)
    _SGSNSMORecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNSMORecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SGSNSMORecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SGSNSMORecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGSNSMORecord_msNetworkCapability = OCT_STR(name=u'msNetworkCapability', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'MSNetworkCapability')), opt=True)
    _SGSNSMORecord_serviceCentre = OCT_STR(name=u'serviceCentre', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _SGSNSMORecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')), opt=True)
    _SGSNSMORecord_locationArea = OCT_STR(name=u'locationArea', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaCode')), opt=True)
    _SGSNSMORecord_routingArea = OCT_STR(name=u'routingArea', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _SGSNSMORecord_cellIdentifier = OCT_STR(name=u'cellIdentifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')), opt=True)
    _SGSNSMORecord_messageReference = OCT_STR(name=u'messageReference', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageReference')))
    _SGSNSMORecord_eventTimeStamp = OCT_STR(name=u'eventTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNSMORecord_smsResult = CHOICE(name=u'smsResult', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _SGSNSMORecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNSMORecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNSMORecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNSMORecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGSNSMORecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGSNSMORecord_destinationNumber = OCT_STR(name=u'destinationNumber', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SmsTpDestinationNumber')), opt=True)
    _SGSNSMORecord_cAMELInformationSMS = SET(name=u'cAMELInformationSMS', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CAMELInformationSMS')), opt=True)
    _SGSNSMORecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGSNSMORecord_servingNodeType = ENUM(name=u'servingNodeType', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingNodeType')))
    _SGSNSMORecord_servingNodeAddress = CHOICE(name=u'servingNodeAddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNSMORecord_servingNodeiPv6Address = CHOICE(name=u'servingNodeiPv6Address', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNSMORecord_mMEName = OCT_STR(name=u'mMEName', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SGSNSMORecord_mMERealm = OCT_STR(name=u'mMERealm', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SGSNSMORecord_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNSMORecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNSMORecord_servingNodePLMNIdentifier = OCT_STR(name=u'servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNSMORecord_userLocationInfoTime = OCT_STR(name=u'userLocationInfoTime', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SGSNSMORecord_cNOperatorSelectionEnt = ENUM(name=u'cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    SGSNSMORecord._cont = ASN1Dict([
        (u'recordType', _SGSNSMORecord_recordType),
        (u'servedIMSI', _SGSNSMORecord_servedIMSI),
        (u'servedIMEI', _SGSNSMORecord_servedIMEI),
        (u'servedMSISDN', _SGSNSMORecord_servedMSISDN),
        (u'msNetworkCapability', _SGSNSMORecord_msNetworkCapability),
        (u'serviceCentre', _SGSNSMORecord_serviceCentre),
        (u'recordingEntity', _SGSNSMORecord_recordingEntity),
        (u'locationArea', _SGSNSMORecord_locationArea),
        (u'routingArea', _SGSNSMORecord_routingArea),
        (u'cellIdentifier', _SGSNSMORecord_cellIdentifier),
        (u'messageReference', _SGSNSMORecord_messageReference),
        (u'eventTimeStamp', _SGSNSMORecord_eventTimeStamp),
        (u'smsResult', _SGSNSMORecord_smsResult),
        (u'recordExtensions', _SGSNSMORecord_recordExtensions),
        (u'nodeID', _SGSNSMORecord_nodeID),
        (u'localSequenceNumber', _SGSNSMORecord_localSequenceNumber),
        (u'chargingCharacteristics', _SGSNSMORecord_chargingCharacteristics),
        (u'rATType', _SGSNSMORecord_rATType),
        (u'destinationNumber', _SGSNSMORecord_destinationNumber),
        (u'cAMELInformationSMS', _SGSNSMORecord_cAMELInformationSMS),
        (u'chChSelectionMode', _SGSNSMORecord_chChSelectionMode),
        (u'servingNodeType', _SGSNSMORecord_servingNodeType),
        (u'servingNodeAddress', _SGSNSMORecord_servingNodeAddress),
        (u'servingNodeiPv6Address', _SGSNSMORecord_servingNodeiPv6Address),
        (u'mMEName', _SGSNSMORecord_mMEName),
        (u'mMERealm', _SGSNSMORecord_mMERealm),
        (u'userLocationInformation', _SGSNSMORecord_userLocationInformation),
        (u'retransmission', _SGSNSMORecord_retransmission),
        (u'servingNodePLMNIdentifier', _SGSNSMORecord_servingNodePLMNIdentifier),
        (u'userLocationInfoTime', _SGSNSMORecord_userLocationInfoTime),
        (u'cNOperatorSelectionEnt', _SGSNSMORecord_cNOperatorSelectionEnt),
        ])
    SGSNSMORecord._ext = None
    
    #-----< SGSNSMTRecord >-----#
    SGSNSMTRecord = SET(name=u'SGSNSMTRecord', mode=MODE_TYPE)
    _SGSNSMTRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNSMTRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SGSNSMTRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SGSNSMTRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGSNSMTRecord_msNetworkCapability = OCT_STR(name=u'msNetworkCapability', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'MSNetworkCapability')), opt=True)
    _SGSNSMTRecord_serviceCentre = OCT_STR(name=u'serviceCentre', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _SGSNSMTRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')), opt=True)
    _SGSNSMTRecord_locationArea = OCT_STR(name=u'locationArea', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaCode')), opt=True)
    _SGSNSMTRecord_routingArea = OCT_STR(name=u'routingArea', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _SGSNSMTRecord_cellIdentifier = OCT_STR(name=u'cellIdentifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')), opt=True)
    _SGSNSMTRecord_eventTimeStamp = OCT_STR(name=u'eventTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNSMTRecord_smsResult = CHOICE(name=u'smsResult', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _SGSNSMTRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNSMTRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNSMTRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNSMTRecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGSNSMTRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGSNSMTRecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGSNSMTRecord_cAMELInformationSMS = SET(name=u'cAMELInformationSMS', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CAMELInformationSMS')), opt=True)
    _SGSNSMTRecord_originatingAddress = OCT_STR(name=u'originatingAddress', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _SGSNSMTRecord_servingNodeType = ENUM(name=u'servingNodeType', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingNodeType')))
    _SGSNSMTRecord_servingNodeAddress = CHOICE(name=u'servingNodeAddress', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNSMTRecord_servingNodeiPv6Address = CHOICE(name=u'servingNodeiPv6Address', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNSMTRecord_mMEName = OCT_STR(name=u'mMEName', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SGSNSMTRecord_mMERealm = OCT_STR(name=u'mMERealm', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SGSNSMTRecord_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNSMTRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNSMTRecord_servingNodePLMNIdentifier = OCT_STR(name=u'servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNSMTRecord_userLocationInfoTime = OCT_STR(name=u'userLocationInfoTime', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SGSNSMTRecord_cNOperatorSelectionEnt = ENUM(name=u'cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    SGSNSMTRecord._cont = ASN1Dict([
        (u'recordType', _SGSNSMTRecord_recordType),
        (u'servedIMSI', _SGSNSMTRecord_servedIMSI),
        (u'servedIMEI', _SGSNSMTRecord_servedIMEI),
        (u'servedMSISDN', _SGSNSMTRecord_servedMSISDN),
        (u'msNetworkCapability', _SGSNSMTRecord_msNetworkCapability),
        (u'serviceCentre', _SGSNSMTRecord_serviceCentre),
        (u'recordingEntity', _SGSNSMTRecord_recordingEntity),
        (u'locationArea', _SGSNSMTRecord_locationArea),
        (u'routingArea', _SGSNSMTRecord_routingArea),
        (u'cellIdentifier', _SGSNSMTRecord_cellIdentifier),
        (u'eventTimeStamp', _SGSNSMTRecord_eventTimeStamp),
        (u'smsResult', _SGSNSMTRecord_smsResult),
        (u'recordExtensions', _SGSNSMTRecord_recordExtensions),
        (u'nodeID', _SGSNSMTRecord_nodeID),
        (u'localSequenceNumber', _SGSNSMTRecord_localSequenceNumber),
        (u'chargingCharacteristics', _SGSNSMTRecord_chargingCharacteristics),
        (u'rATType', _SGSNSMTRecord_rATType),
        (u'chChSelectionMode', _SGSNSMTRecord_chChSelectionMode),
        (u'cAMELInformationSMS', _SGSNSMTRecord_cAMELInformationSMS),
        (u'originatingAddress', _SGSNSMTRecord_originatingAddress),
        (u'servingNodeType', _SGSNSMTRecord_servingNodeType),
        (u'servingNodeAddress', _SGSNSMTRecord_servingNodeAddress),
        (u'servingNodeiPv6Address', _SGSNSMTRecord_servingNodeiPv6Address),
        (u'mMEName', _SGSNSMTRecord_mMEName),
        (u'mMERealm', _SGSNSMTRecord_mMERealm),
        (u'userLocationInformation', _SGSNSMTRecord_userLocationInformation),
        (u'retransmission', _SGSNSMTRecord_retransmission),
        (u'servingNodePLMNIdentifier', _SGSNSMTRecord_servingNodePLMNIdentifier),
        (u'userLocationInfoTime', _SGSNSMTRecord_userLocationInfoTime),
        (u'cNOperatorSelectionEnt', _SGSNSMTRecord_cNOperatorSelectionEnt),
        ])
    SGSNSMTRecord._ext = None
    
    #-----< SGSNMTLCSRecord >-----#
    SGSNMTLCSRecord = SET(name=u'SGSNMTLCSRecord', mode=MODE_TYPE)
    _SGSNMTLCSRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNMTLCSRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _SGSNMTLCSRecord_lcsClientType = ENUM(name=u'lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')))
    _SGSNMTLCSRecord_lcsClientIdentity = SEQ(name=u'lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')))
    _SGSNMTLCSRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SGSNMTLCSRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGSNMTLCSRecord_sgsnAddress = CHOICE(name=u'sgsnAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNMTLCSRecord_locationType = SEQ(name=u'locationType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')))
    _SGSNMTLCSRecord_lcsQos = OCT_STR(name=u'lcsQos', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSQoSInfo')), opt=True)
    _SGSNMTLCSRecord_lcsPriority = OCT_STR(name=u'lcsPriority', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _SGSNMTLCSRecord_mlcNumber = OCT_STR(name=u'mlcNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SGSNMTLCSRecord_eventTimeStamp = OCT_STR(name=u'eventTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNMTLCSRecord_measurementDuration = INT(name=u'measurementDuration', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _SGSNMTLCSRecord_notificationToMSUser = ENUM(name=u'notificationToMSUser', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _SGSNMTLCSRecord_privacyOverride = NULL(name=u'privacyOverride', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNMTLCSRecord_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _SGSNMTLCSRecord_routingArea = OCT_STR(name=u'routingArea', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _SGSNMTLCSRecord_locationEstimate = OCT_STR(name=u'locationEstimate', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _SGSNMTLCSRecord_positioningData = OCT_STR(name=u'positioningData', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PositioningData')), opt=True)
    _SGSNMTLCSRecord_lcsCause = OCT_STR(name=u'lcsCause', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSCause')), opt=True)
    _SGSNMTLCSRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SGSNMTLCSRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNMTLCSRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNMTLCSRecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGSNMTLCSRecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGSNMTLCSRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGSNMTLCSRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNMTLCSRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _SGSNMTLCSRecord_servingNodePLMNIdentifier = OCT_STR(name=u'servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNMTLCSRecord_cNOperatorSelectionEnt = ENUM(name=u'cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    SGSNMTLCSRecord._cont = ASN1Dict([
        (u'recordType', _SGSNMTLCSRecord_recordType),
        (u'recordingEntity', _SGSNMTLCSRecord_recordingEntity),
        (u'lcsClientType', _SGSNMTLCSRecord_lcsClientType),
        (u'lcsClientIdentity', _SGSNMTLCSRecord_lcsClientIdentity),
        (u'servedIMSI', _SGSNMTLCSRecord_servedIMSI),
        (u'servedMSISDN', _SGSNMTLCSRecord_servedMSISDN),
        (u'sgsnAddress', _SGSNMTLCSRecord_sgsnAddress),
        (u'locationType', _SGSNMTLCSRecord_locationType),
        (u'lcsQos', _SGSNMTLCSRecord_lcsQos),
        (u'lcsPriority', _SGSNMTLCSRecord_lcsPriority),
        (u'mlcNumber', _SGSNMTLCSRecord_mlcNumber),
        (u'eventTimeStamp', _SGSNMTLCSRecord_eventTimeStamp),
        (u'measurementDuration', _SGSNMTLCSRecord_measurementDuration),
        (u'notificationToMSUser', _SGSNMTLCSRecord_notificationToMSUser),
        (u'privacyOverride', _SGSNMTLCSRecord_privacyOverride),
        (u'location', _SGSNMTLCSRecord_location),
        (u'routingArea', _SGSNMTLCSRecord_routingArea),
        (u'locationEstimate', _SGSNMTLCSRecord_locationEstimate),
        (u'positioningData', _SGSNMTLCSRecord_positioningData),
        (u'lcsCause', _SGSNMTLCSRecord_lcsCause),
        (u'diagnostics', _SGSNMTLCSRecord_diagnostics),
        (u'nodeID', _SGSNMTLCSRecord_nodeID),
        (u'localSequenceNumber', _SGSNMTLCSRecord_localSequenceNumber),
        (u'chargingCharacteristics', _SGSNMTLCSRecord_chargingCharacteristics),
        (u'chChSelectionMode', _SGSNMTLCSRecord_chChSelectionMode),
        (u'rATType', _SGSNMTLCSRecord_rATType),
        (u'recordExtensions', _SGSNMTLCSRecord_recordExtensions),
        (u'causeForRecClosing', _SGSNMTLCSRecord_causeForRecClosing),
        (u'servingNodePLMNIdentifier', _SGSNMTLCSRecord_servingNodePLMNIdentifier),
        (u'cNOperatorSelectionEnt', _SGSNMTLCSRecord_cNOperatorSelectionEnt),
        ])
    SGSNMTLCSRecord._ext = None
    
    #-----< SGSNMOLCSRecord >-----#
    SGSNMOLCSRecord = SET(name=u'SGSNMOLCSRecord', mode=MODE_TYPE)
    _SGSNMOLCSRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNMOLCSRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _SGSNMOLCSRecord_lcsClientType = ENUM(name=u'lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _SGSNMOLCSRecord_lcsClientIdentity = SEQ(name=u'lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _SGSNMOLCSRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SGSNMOLCSRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGSNMOLCSRecord_sgsnAddress = CHOICE(name=u'sgsnAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNMOLCSRecord_locationMethod = ENUM(name=u'locationMethod', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'LocationMethod')))
    _SGSNMOLCSRecord_lcsQos = OCT_STR(name=u'lcsQos', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSQoSInfo')), opt=True)
    _SGSNMOLCSRecord_lcsPriority = OCT_STR(name=u'lcsPriority', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _SGSNMOLCSRecord_mlcNumber = OCT_STR(name=u'mlcNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SGSNMOLCSRecord_eventTimeStamp = OCT_STR(name=u'eventTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNMOLCSRecord_measurementDuration = INT(name=u'measurementDuration', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _SGSNMOLCSRecord_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _SGSNMOLCSRecord_routingArea = OCT_STR(name=u'routingArea', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _SGSNMOLCSRecord_locationEstimate = OCT_STR(name=u'locationEstimate', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _SGSNMOLCSRecord_positioningData = OCT_STR(name=u'positioningData', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PositioningData')), opt=True)
    _SGSNMOLCSRecord_lcsCause = OCT_STR(name=u'lcsCause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSCause')), opt=True)
    _SGSNMOLCSRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SGSNMOLCSRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNMOLCSRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNMOLCSRecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGSNMOLCSRecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGSNMOLCSRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGSNMOLCSRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNMOLCSRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _SGSNMOLCSRecord_servingNodePLMNIdentifier = OCT_STR(name=u'servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNMOLCSRecord_cNOperatorSelectionEnt = ENUM(name=u'cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    SGSNMOLCSRecord._cont = ASN1Dict([
        (u'recordType', _SGSNMOLCSRecord_recordType),
        (u'recordingEntity', _SGSNMOLCSRecord_recordingEntity),
        (u'lcsClientType', _SGSNMOLCSRecord_lcsClientType),
        (u'lcsClientIdentity', _SGSNMOLCSRecord_lcsClientIdentity),
        (u'servedIMSI', _SGSNMOLCSRecord_servedIMSI),
        (u'servedMSISDN', _SGSNMOLCSRecord_servedMSISDN),
        (u'sgsnAddress', _SGSNMOLCSRecord_sgsnAddress),
        (u'locationMethod', _SGSNMOLCSRecord_locationMethod),
        (u'lcsQos', _SGSNMOLCSRecord_lcsQos),
        (u'lcsPriority', _SGSNMOLCSRecord_lcsPriority),
        (u'mlcNumber', _SGSNMOLCSRecord_mlcNumber),
        (u'eventTimeStamp', _SGSNMOLCSRecord_eventTimeStamp),
        (u'measurementDuration', _SGSNMOLCSRecord_measurementDuration),
        (u'location', _SGSNMOLCSRecord_location),
        (u'routingArea', _SGSNMOLCSRecord_routingArea),
        (u'locationEstimate', _SGSNMOLCSRecord_locationEstimate),
        (u'positioningData', _SGSNMOLCSRecord_positioningData),
        (u'lcsCause', _SGSNMOLCSRecord_lcsCause),
        (u'diagnostics', _SGSNMOLCSRecord_diagnostics),
        (u'nodeID', _SGSNMOLCSRecord_nodeID),
        (u'localSequenceNumber', _SGSNMOLCSRecord_localSequenceNumber),
        (u'chargingCharacteristics', _SGSNMOLCSRecord_chargingCharacteristics),
        (u'chChSelectionMode', _SGSNMOLCSRecord_chChSelectionMode),
        (u'rATType', _SGSNMOLCSRecord_rATType),
        (u'recordExtensions', _SGSNMOLCSRecord_recordExtensions),
        (u'causeForRecClosing', _SGSNMOLCSRecord_causeForRecClosing),
        (u'servingNodePLMNIdentifier', _SGSNMOLCSRecord_servingNodePLMNIdentifier),
        (u'cNOperatorSelectionEnt', _SGSNMOLCSRecord_cNOperatorSelectionEnt),
        ])
    SGSNMOLCSRecord._ext = None
    
    #-----< SGSNNILCSRecord >-----#
    SGSNNILCSRecord = SET(name=u'SGSNNILCSRecord', mode=MODE_TYPE)
    _SGSNNILCSRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNNILCSRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _SGSNNILCSRecord_lcsClientType = ENUM(name=u'lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _SGSNNILCSRecord_lcsClientIdentity = SEQ(name=u'lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _SGSNNILCSRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SGSNNILCSRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SGSNNILCSRecord_sgsnAddress = CHOICE(name=u'sgsnAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SGSNNILCSRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SGSNNILCSRecord_lcsQos = OCT_STR(name=u'lcsQos', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSQoSInfo')), opt=True)
    _SGSNNILCSRecord_lcsPriority = OCT_STR(name=u'lcsPriority', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _SGSNNILCSRecord_mlcNumber = OCT_STR(name=u'mlcNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SGSNNILCSRecord_eventTimeStamp = OCT_STR(name=u'eventTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNNILCSRecord_measurementDuration = INT(name=u'measurementDuration', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _SGSNNILCSRecord_location = SEQ(name=u'location', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaAndCell')), opt=True)
    _SGSNNILCSRecord_routingArea = OCT_STR(name=u'routingArea', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')), opt=True)
    _SGSNNILCSRecord_locationEstimate = OCT_STR(name=u'locationEstimate', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _SGSNNILCSRecord_positioningData = OCT_STR(name=u'positioningData', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PositioningData')), opt=True)
    _SGSNNILCSRecord_lcsCause = OCT_STR(name=u'lcsCause', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSCause')), opt=True)
    _SGSNNILCSRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SGSNNILCSRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNNILCSRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNNILCSRecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _SGSNNILCSRecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _SGSNNILCSRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SGSNNILCSRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNNILCSRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _SGSNNILCSRecord_servingNodePLMNIdentifier = OCT_STR(name=u'servingNodePLMNIdentifier', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNNILCSRecord_cNOperatorSelectionEnt = ENUM(name=u'cNOperatorSelectionEnt', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CNOperatorSelectionEntity')), opt=True)
    SGSNNILCSRecord._cont = ASN1Dict([
        (u'recordType', _SGSNNILCSRecord_recordType),
        (u'recordingEntity', _SGSNNILCSRecord_recordingEntity),
        (u'lcsClientType', _SGSNNILCSRecord_lcsClientType),
        (u'lcsClientIdentity', _SGSNNILCSRecord_lcsClientIdentity),
        (u'servedIMSI', _SGSNNILCSRecord_servedIMSI),
        (u'servedMSISDN', _SGSNNILCSRecord_servedMSISDN),
        (u'sgsnAddress', _SGSNNILCSRecord_sgsnAddress),
        (u'servedIMEI', _SGSNNILCSRecord_servedIMEI),
        (u'lcsQos', _SGSNNILCSRecord_lcsQos),
        (u'lcsPriority', _SGSNNILCSRecord_lcsPriority),
        (u'mlcNumber', _SGSNNILCSRecord_mlcNumber),
        (u'eventTimeStamp', _SGSNNILCSRecord_eventTimeStamp),
        (u'measurementDuration', _SGSNNILCSRecord_measurementDuration),
        (u'location', _SGSNNILCSRecord_location),
        (u'routingArea', _SGSNNILCSRecord_routingArea),
        (u'locationEstimate', _SGSNNILCSRecord_locationEstimate),
        (u'positioningData', _SGSNNILCSRecord_positioningData),
        (u'lcsCause', _SGSNNILCSRecord_lcsCause),
        (u'diagnostics', _SGSNNILCSRecord_diagnostics),
        (u'nodeID', _SGSNNILCSRecord_nodeID),
        (u'localSequenceNumber', _SGSNNILCSRecord_localSequenceNumber),
        (u'chargingCharacteristics', _SGSNNILCSRecord_chargingCharacteristics),
        (u'chChSelectionMode', _SGSNNILCSRecord_chChSelectionMode),
        (u'rATType', _SGSNNILCSRecord_rATType),
        (u'recordExtensions', _SGSNNILCSRecord_recordExtensions),
        (u'causeForRecClosing', _SGSNNILCSRecord_causeForRecClosing),
        (u'servingNodePLMNIdentifier', _SGSNNILCSRecord_servingNodePLMNIdentifier),
        (u'cNOperatorSelectionEnt', _SGSNNILCSRecord_cNOperatorSelectionEnt),
        ])
    SGSNNILCSRecord._ext = None
    
    #-----< SGSNMBMSRecord >-----#
    SGSNMBMSRecord = SET(name=u'SGSNMBMSRecord', mode=MODE_TYPE)
    _SGSNMBMSRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SGSNMBMSRecord_ggsnAddress = CHOICE(name=u'ggsnAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _SGSNMBMSRecord_chargingID = INT(name=u'chargingID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _SGSNMBMSRecord_listofRAs = SEQ_OF(name=u'listofRAs', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SGSNMBMSRecord_listofRAs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')))
    _SGSNMBMSRecord_listofRAs._cont = __SGSNMBMSRecord_listofRAs__item_
    _SGSNMBMSRecord_accessPointNameNI = STR_IA5(name=u'accessPointNameNI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _SGSNMBMSRecord_servedPDPAddress = CHOICE(name=u'servedPDPAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _SGSNMBMSRecord_listOfTrafficVolumes = SEQ_OF(name=u'listOfTrafficVolumes', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SGSNMBMSRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfMBMSCondition')))
    _SGSNMBMSRecord_listOfTrafficVolumes._cont = __SGSNMBMSRecord_listOfTrafficVolumes__item_
    _SGSNMBMSRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SGSNMBMSRecord_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _SGSNMBMSRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _SGSNMBMSRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SGSNMBMSRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNMBMSRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SGSNMBMSRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SGSNMBMSRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SGSNMBMSRecord_sgsnPLMNIdentifier = OCT_STR(name=u'sgsnPLMNIdentifier', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _SGSNMBMSRecord_numberofReceivingUE = INT(name=u'numberofReceivingUE', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNMBMSRecord_mbmsInformation = SET(name=u'mbmsInformation', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSInformation')), opt=True)
    SGSNMBMSRecord._cont = ASN1Dict([
        (u'recordType', _SGSNMBMSRecord_recordType),
        (u'ggsnAddress', _SGSNMBMSRecord_ggsnAddress),
        (u'chargingID', _SGSNMBMSRecord_chargingID),
        (u'listofRAs', _SGSNMBMSRecord_listofRAs),
        (u'accessPointNameNI', _SGSNMBMSRecord_accessPointNameNI),
        (u'servedPDPAddress', _SGSNMBMSRecord_servedPDPAddress),
        (u'listOfTrafficVolumes', _SGSNMBMSRecord_listOfTrafficVolumes),
        (u'recordOpeningTime', _SGSNMBMSRecord_recordOpeningTime),
        (u'duration', _SGSNMBMSRecord_duration),
        (u'causeForRecClosing', _SGSNMBMSRecord_causeForRecClosing),
        (u'diagnostics', _SGSNMBMSRecord_diagnostics),
        (u'recordSequenceNumber', _SGSNMBMSRecord_recordSequenceNumber),
        (u'nodeID', _SGSNMBMSRecord_nodeID),
        (u'recordExtensions', _SGSNMBMSRecord_recordExtensions),
        (u'localSequenceNumber', _SGSNMBMSRecord_localSequenceNumber),
        (u'sgsnPLMNIdentifier', _SGSNMBMSRecord_sgsnPLMNIdentifier),
        (u'numberofReceivingUE', _SGSNMBMSRecord_numberofReceivingUE),
        (u'mbmsInformation', _SGSNMBMSRecord_mbmsInformation),
        ])
    SGSNMBMSRecord._ext = None
    
    #-----< GGSNMBMSRecord >-----#
    GGSNMBMSRecord = SET(name=u'GGSNMBMSRecord', mode=MODE_TYPE)
    _GGSNMBMSRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _GGSNMBMSRecord_ggsnAddress = CHOICE(name=u'ggsnAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _GGSNMBMSRecord_chargingID = INT(name=u'chargingID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _GGSNMBMSRecord_listofDownstreamNodes = SEQ_OF(name=u'listofDownstreamNodes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GGSNMBMSRecord_listofDownstreamNodes__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _GGSNMBMSRecord_listofDownstreamNodes._cont = __GGSNMBMSRecord_listofDownstreamNodes__item_
    _GGSNMBMSRecord_accessPointNameNI = STR_IA5(name=u'accessPointNameNI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _GGSNMBMSRecord_servedPDPAddress = CHOICE(name=u'servedPDPAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _GGSNMBMSRecord_listOfTrafficVolumes = SEQ_OF(name=u'listOfTrafficVolumes', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GGSNMBMSRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfMBMSCondition')))
    _GGSNMBMSRecord_listOfTrafficVolumes._cont = __GGSNMBMSRecord_listOfTrafficVolumes__item_
    _GGSNMBMSRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _GGSNMBMSRecord_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _GGSNMBMSRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _GGSNMBMSRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _GGSNMBMSRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GGSNMBMSRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _GGSNMBMSRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _GGSNMBMSRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _GGSNMBMSRecord_mbmsInformation = SET(name=u'mbmsInformation', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSInformation')), opt=True)
    GGSNMBMSRecord._cont = ASN1Dict([
        (u'recordType', _GGSNMBMSRecord_recordType),
        (u'ggsnAddress', _GGSNMBMSRecord_ggsnAddress),
        (u'chargingID', _GGSNMBMSRecord_chargingID),
        (u'listofDownstreamNodes', _GGSNMBMSRecord_listofDownstreamNodes),
        (u'accessPointNameNI', _GGSNMBMSRecord_accessPointNameNI),
        (u'servedPDPAddress', _GGSNMBMSRecord_servedPDPAddress),
        (u'listOfTrafficVolumes', _GGSNMBMSRecord_listOfTrafficVolumes),
        (u'recordOpeningTime', _GGSNMBMSRecord_recordOpeningTime),
        (u'duration', _GGSNMBMSRecord_duration),
        (u'causeForRecClosing', _GGSNMBMSRecord_causeForRecClosing),
        (u'diagnostics', _GGSNMBMSRecord_diagnostics),
        (u'recordSequenceNumber', _GGSNMBMSRecord_recordSequenceNumber),
        (u'nodeID', _GGSNMBMSRecord_nodeID),
        (u'recordExtensions', _GGSNMBMSRecord_recordExtensions),
        (u'localSequenceNumber', _GGSNMBMSRecord_localSequenceNumber),
        (u'mbmsInformation', _GGSNMBMSRecord_mbmsInformation),
        ])
    GGSNMBMSRecord._ext = None
    
    #-----< GWMBMSRecord >-----#
    GWMBMSRecord = SET(name=u'GWMBMSRecord', mode=MODE_TYPE)
    _GWMBMSRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _GWMBMSRecord_mbmsGWAddress = CHOICE(name=u'mbmsGWAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _GWMBMSRecord_chargingID = INT(name=u'chargingID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    _GWMBMSRecord_listofDownstreamNodes = SEQ_OF(name=u'listofDownstreamNodes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GWMBMSRecord_listofDownstreamNodes__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _GWMBMSRecord_listofDownstreamNodes._cont = __GWMBMSRecord_listofDownstreamNodes__item_
    _GWMBMSRecord_accessPointNameNI = STR_IA5(name=u'accessPointNameNI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _GWMBMSRecord_pdpPDNType = OCT_STR(name=u'pdpPDNType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    _GWMBMSRecord_servedPDPPDNAddress = CHOICE(name=u'servedPDPPDNAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _GWMBMSRecord_listOfTrafficVolumes = SEQ_OF(name=u'listOfTrafficVolumes', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GWMBMSRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfMBMSCondition')))
    _GWMBMSRecord_listOfTrafficVolumes._cont = __GWMBMSRecord_listOfTrafficVolumes__item_
    _GWMBMSRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _GWMBMSRecord_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _GWMBMSRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CauseForRecClosing')))
    _GWMBMSRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _GWMBMSRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GWMBMSRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _GWMBMSRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _GWMBMSRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _GWMBMSRecord_mbmsInformation = SET(name=u'mbmsInformation', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSInformation')), opt=True)
    _GWMBMSRecord_commonTeid = OCT_STR(name=u'commonTeid', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CTEID')), opt=True)
    _GWMBMSRecord_iPMulticastSourceAddress = CHOICE(name=u'iPMulticastSourceAddress', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    GWMBMSRecord._cont = ASN1Dict([
        (u'recordType', _GWMBMSRecord_recordType),
        (u'mbmsGWAddress', _GWMBMSRecord_mbmsGWAddress),
        (u'chargingID', _GWMBMSRecord_chargingID),
        (u'listofDownstreamNodes', _GWMBMSRecord_listofDownstreamNodes),
        (u'accessPointNameNI', _GWMBMSRecord_accessPointNameNI),
        (u'pdpPDNType', _GWMBMSRecord_pdpPDNType),
        (u'servedPDPPDNAddress', _GWMBMSRecord_servedPDPPDNAddress),
        (u'listOfTrafficVolumes', _GWMBMSRecord_listOfTrafficVolumes),
        (u'recordOpeningTime', _GWMBMSRecord_recordOpeningTime),
        (u'duration', _GWMBMSRecord_duration),
        (u'causeForRecClosing', _GWMBMSRecord_causeForRecClosing),
        (u'diagnostics', _GWMBMSRecord_diagnostics),
        (u'recordSequenceNumber', _GWMBMSRecord_recordSequenceNumber),
        (u'nodeID', _GWMBMSRecord_nodeID),
        (u'recordExtensions', _GWMBMSRecord_recordExtensions),
        (u'localSequenceNumber', _GWMBMSRecord_localSequenceNumber),
        (u'mbmsInformation', _GWMBMSRecord_mbmsInformation),
        (u'commonTeid', _GWMBMSRecord_commonTeid),
        (u'iPMulticastSourceAddress', _GWMBMSRecord_iPMulticastSourceAddress),
        ])
    GWMBMSRecord._ext = None
    
    #-----< AccessAvailabilityChangeReason >-----#
    AccessAvailabilityChangeReason = INT(name=u'AccessAvailabilityChangeReason', mode=MODE_TYPE)
    AccessAvailabilityChangeReason._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< AccessLineIdentifier >-----#
    AccessLineIdentifier = SEQ(name=u'AccessLineIdentifier', mode=MODE_TYPE)
    _AccessLineIdentifier_physicalAccessID = STR_UTF8(name=u'physicalAccessID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AccessLineIdentifier_logicalAccessID = OCT_STR(name=u'logicalAccessID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    AccessLineIdentifier._cont = ASN1Dict([
        (u'physicalAccessID', _AccessLineIdentifier_physicalAccessID),
        (u'logicalAccessID', _AccessLineIdentifier_logicalAccessID),
        ])
    AccessLineIdentifier._ext = None
    
    #-----< AccessPointNameNI >-----#
    AccessPointNameNI = STR_IA5(name=u'AccessPointNameNI', mode=MODE_TYPE)
    AccessPointNameNI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    
    #-----< AccessPointNameOI >-----#
    AccessPointNameOI = STR_IA5(name=u'AccessPointNameOI', mode=MODE_TYPE)
    AccessPointNameOI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=37)], ev=None, er=[])
    
    #-----< ADCRuleBaseName >-----#
    ADCRuleBaseName = STR_IA5(name=u'ADCRuleBaseName', mode=MODE_TYPE)
    
    #-----< AdditionalExceptionReports >-----#
    AdditionalExceptionReports = ENUM(name=u'AdditionalExceptionReports', mode=MODE_TYPE)
    AdditionalExceptionReports._cont = ASN1Dict([(u'notAllowed', 0), (u'allowed', 1)])
    AdditionalExceptionReports._ext = None
    
    #-----< AFChargingIdentifier >-----#
    AFChargingIdentifier = OCT_STR(name=u'AFChargingIdentifier', mode=MODE_TYPE)
    
    #-----< AFRecordInformation >-----#
    AFRecordInformation = SEQ(name=u'AFRecordInformation', mode=MODE_TYPE)
    _AFRecordInformation_aFChargingIdentifier = OCT_STR(name=u'aFChargingIdentifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AFChargingIdentifier')))
    _AFRecordInformation_flows = SEQ(name=u'flows', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'Flows')), opt=True)
    AFRecordInformation._cont = ASN1Dict([
        (u'aFChargingIdentifier', _AFRecordInformation_aFChargingIdentifier),
        (u'flows', _AFRecordInformation_flows),
        ])
    AFRecordInformation._ext = None
    
    #-----< APNRateControl >-----#
    APNRateControl = SEQ(name=u'APNRateControl', mode=MODE_TYPE)
    _APNRateControl_aPNRateControlUplink = SEQ(name=u'aPNRateControlUplink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNRateControlParameters')), opt=True)
    _APNRateControl_aPNRateControlDownlink = SEQ(name=u'aPNRateControlDownlink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNRateControlParameters')), opt=True)
    APNRateControl._cont = ASN1Dict([
        (u'aPNRateControlUplink', _APNRateControl_aPNRateControlUplink),
        (u'aPNRateControlDownlink', _APNRateControl_aPNRateControlDownlink),
        ])
    APNRateControl._ext = None
    
    #-----< APNRateControlParameters >-----#
    APNRateControlParameters = SEQ(name=u'APNRateControlParameters', mode=MODE_TYPE)
    _APNRateControlParameters_additionalExceptionReports = ENUM(name=u'additionalExceptionReports', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AdditionalExceptionReports')), opt=True)
    _APNRateControlParameters_rateControlTimeUnit = INT(name=u'rateControlTimeUnit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'RateControlTimeUnit')), opt=True)
    _APNRateControlParameters_rateControlMaxRate = INT(name=u'rateControlMaxRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _APNRateControlParameters_rateControlMaxMessageSize = INT(name=u'rateControlMaxMessageSize', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    APNRateControlParameters._cont = ASN1Dict([
        (u'additionalExceptionReports', _APNRateControlParameters_additionalExceptionReports),
        (u'rateControlTimeUnit', _APNRateControlParameters_rateControlTimeUnit),
        (u'rateControlMaxRate', _APNRateControlParameters_rateControlMaxRate),
        (u'rateControlMaxMessageSize', _APNRateControlParameters_rateControlMaxMessageSize),
        ])
    APNRateControlParameters._ext = None
    
    #-----< APNSelectionMode >-----#
    APNSelectionMode = ENUM(name=u'APNSelectionMode', mode=MODE_TYPE)
    APNSelectionMode._cont = ASN1Dict([(u'mSorNetworkProvidedSubscriptionVerified', 0), (u'mSProvidedSubscriptionNotVerified', 1), (u'networkProvidedSubscriptionNotVerified', 2)])
    APNSelectionMode._ext = None
    
    #-----< CalleePartyInformation >-----#
    CalleePartyInformation = SEQ(name=u'CalleePartyInformation', mode=MODE_TYPE)
    _CalleePartyInformation_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _CalleePartyInformation_requested_Party_Address = CHOICE(name=u'requested-Party-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _CalleePartyInformation_list_Of_Called_Asserted_Identity = SEQ_OF(name=u'list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CalleePartyInformation_list_Of_Called_Asserted_Identity__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')))
    _CalleePartyInformation_list_Of_Called_Asserted_Identity._cont = __CalleePartyInformation_list_Of_Called_Asserted_Identity__item_
    CalleePartyInformation._cont = ASN1Dict([
        (u'called-Party-Address', _CalleePartyInformation_called_Party_Address),
        (u'requested-Party-Address', _CalleePartyInformation_requested_Party_Address),
        (u'list-Of-Called-Asserted-Identity', _CalleePartyInformation_list_Of_Called_Asserted_Identity),
        ])
    CalleePartyInformation._ext = None
    
    #-----< CAMELAccessPointNameNI >-----#
    CAMELAccessPointNameNI = STR_IA5(name=u'CAMELAccessPointNameNI', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')))
    
    #-----< CAMELAccessPointNameOI >-----#
    CAMELAccessPointNameOI = STR_IA5(name=u'CAMELAccessPointNameOI', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameOI')))
    
    #-----< CAMELInformationMM >-----#
    CAMELInformationMM = SET(name=u'CAMELInformationMM', mode=MODE_TYPE)
    _CAMELInformationMM_sCFAddress = OCT_STR(name=u'sCFAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SCFAddress')), opt=True)
    _CAMELInformationMM_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _CAMELInformationMM_defaultTransactionHandling = ENUM(name=u'defaultTransactionHandling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultGPRS-Handling')), opt=True)
    _CAMELInformationMM_numberOfDPEncountered = INT(name=u'numberOfDPEncountered', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'NumberOfDPEncountered')), opt=True)
    _CAMELInformationMM_levelOfCAMELService = BIT_STR(name=u'levelOfCAMELService', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LevelOfCAMELService')), opt=True)
    _CAMELInformationMM_freeFormatData = OCT_STR(name=u'freeFormatData', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FreeFormatData')), opt=True)
    _CAMELInformationMM_fFDAppendIndicator = BOOL(name=u'fFDAppendIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FFDAppendIndicator')), opt=True)
    CAMELInformationMM._cont = ASN1Dict([
        (u'sCFAddress', _CAMELInformationMM_sCFAddress),
        (u'serviceKey', _CAMELInformationMM_serviceKey),
        (u'defaultTransactionHandling', _CAMELInformationMM_defaultTransactionHandling),
        (u'numberOfDPEncountered', _CAMELInformationMM_numberOfDPEncountered),
        (u'levelOfCAMELService', _CAMELInformationMM_levelOfCAMELService),
        (u'freeFormatData', _CAMELInformationMM_freeFormatData),
        (u'fFDAppendIndicator', _CAMELInformationMM_fFDAppendIndicator),
        ])
    CAMELInformationMM._ext = None
    
    #-----< CAMELInformationPDP >-----#
    CAMELInformationPDP = SET(name=u'CAMELInformationPDP', mode=MODE_TYPE)
    _CAMELInformationPDP_sCFAddress = OCT_STR(name=u'sCFAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SCFAddress')), opt=True)
    _CAMELInformationPDP_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _CAMELInformationPDP_defaultTransactionHandling = ENUM(name=u'defaultTransactionHandling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultGPRS-Handling')), opt=True)
    _CAMELInformationPDP_cAMELAccessPointNameNI = STR_IA5(name=u'cAMELAccessPointNameNI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CAMELAccessPointNameNI')), opt=True)
    _CAMELInformationPDP_cAMELAccessPointNameOI = STR_IA5(name=u'cAMELAccessPointNameOI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CAMELAccessPointNameOI')), opt=True)
    _CAMELInformationPDP_numberOfDPEncountered = INT(name=u'numberOfDPEncountered', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'NumberOfDPEncountered')), opt=True)
    _CAMELInformationPDP_levelOfCAMELService = BIT_STR(name=u'levelOfCAMELService', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LevelOfCAMELService')), opt=True)
    _CAMELInformationPDP_freeFormatData = OCT_STR(name=u'freeFormatData', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FreeFormatData')), opt=True)
    _CAMELInformationPDP_fFDAppendIndicator = BOOL(name=u'fFDAppendIndicator', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FFDAppendIndicator')), opt=True)
    CAMELInformationPDP._cont = ASN1Dict([
        (u'sCFAddress', _CAMELInformationPDP_sCFAddress),
        (u'serviceKey', _CAMELInformationPDP_serviceKey),
        (u'defaultTransactionHandling', _CAMELInformationPDP_defaultTransactionHandling),
        (u'cAMELAccessPointNameNI', _CAMELInformationPDP_cAMELAccessPointNameNI),
        (u'cAMELAccessPointNameOI', _CAMELInformationPDP_cAMELAccessPointNameOI),
        (u'numberOfDPEncountered', _CAMELInformationPDP_numberOfDPEncountered),
        (u'levelOfCAMELService', _CAMELInformationPDP_levelOfCAMELService),
        (u'freeFormatData', _CAMELInformationPDP_freeFormatData),
        (u'fFDAppendIndicator', _CAMELInformationPDP_fFDAppendIndicator),
        ])
    CAMELInformationPDP._ext = None
    
    #-----< CAMELInformationSMS >-----#
    CAMELInformationSMS = SET(name=u'CAMELInformationSMS', mode=MODE_TYPE)
    _CAMELInformationSMS_sCFAddress = OCT_STR(name=u'sCFAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SCFAddress')), opt=True)
    _CAMELInformationSMS_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')), opt=True)
    _CAMELInformationSMS_defaultSMSHandling = ENUM(name=u'defaultSMSHandling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultSMS-Handling')), opt=True)
    _CAMELInformationSMS_cAMELCallingPartyNumber = OCT_STR(name=u'cAMELCallingPartyNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallingNumber')), opt=True)
    _CAMELInformationSMS_cAMELDestinationSubscriberNumber = OCT_STR(name=u'cAMELDestinationSubscriberNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SmsTpDestinationNumber')), opt=True)
    _CAMELInformationSMS_cAMELSMSCAddress = OCT_STR(name=u'cAMELSMSCAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _CAMELInformationSMS_freeFormatData = OCT_STR(name=u'freeFormatData', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FreeFormatData')), opt=True)
    _CAMELInformationSMS_smsReferenceNumber = OCT_STR(name=u'smsReferenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    CAMELInformationSMS._cont = ASN1Dict([
        (u'sCFAddress', _CAMELInformationSMS_sCFAddress),
        (u'serviceKey', _CAMELInformationSMS_serviceKey),
        (u'defaultSMSHandling', _CAMELInformationSMS_defaultSMSHandling),
        (u'cAMELCallingPartyNumber', _CAMELInformationSMS_cAMELCallingPartyNumber),
        (u'cAMELDestinationSubscriberNumber', _CAMELInformationSMS_cAMELDestinationSubscriberNumber),
        (u'cAMELSMSCAddress', _CAMELInformationSMS_cAMELSMSCAddress),
        (u'freeFormatData', _CAMELInformationSMS_freeFormatData),
        (u'smsReferenceNumber', _CAMELInformationSMS_smsReferenceNumber),
        ])
    CAMELInformationSMS._ext = None
    
    #-----< ChangeCondition >-----#
    ChangeCondition = ENUM(name=u'ChangeCondition', mode=MODE_TYPE)
    ChangeCondition._cont = ASN1Dict([(u'qoSChange', 0), (u'tariffTime', 1), (u'recordClosure', 2), (u'cGI-SAICHange', 6), (u'rAIChange', 7), (u'dT-Establishment', 8), (u'dT-Removal', 9), (u'eCGIChange', 10), (u'tAIChange', 11), (u'userLocationChange', 12), (u'userCSGInformationChange', 13), (u'presenceInPRAChange', 14), (u'removalOfAccess', 15), (u'unusabilityOfAccess', 16), (u'indirectChangeCondition', 17), (u'userPlaneToUEChange', 18), (u'servingPLMNRateControlChange', 19), (u'threeGPPPSDataOffStatusChange', 20), (u'aPNRateControlChange', 21)])
    ChangeCondition._ext = None
    
    #-----< ChangeOfCharCondition >-----#
    ChangeOfCharCondition = SEQ(name=u'ChangeOfCharCondition', mode=MODE_TYPE)
    _ChangeOfCharCondition_qosRequested = OCT_STR(name=u'qosRequested', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'QoSInformation')), opt=True)
    _ChangeOfCharCondition_qosNegotiated = OCT_STR(name=u'qosNegotiated', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'QoSInformation')), opt=True)
    _ChangeOfCharCondition_dataVolumeGPRSUplink = INT(name=u'dataVolumeGPRSUplink', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _ChangeOfCharCondition_dataVolumeGPRSDownlink = INT(name=u'dataVolumeGPRSDownlink', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _ChangeOfCharCondition_changeCondition = ENUM(name=u'changeCondition', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeCondition')))
    _ChangeOfCharCondition_changeTime = OCT_STR(name=u'changeTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ChangeOfCharCondition_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ChangeOfCharCondition_ePCQoSInformation = SEQ(name=u'ePCQoSInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'EPCQoSInformation')), opt=True)
    _ChangeOfCharCondition_chargingID = INT(name=u'chargingID', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')), opt=True)
    _ChangeOfCharCondition_presenceReportingAreaStatus = ENUM(name=u'presenceReportingAreaStatus', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaStatus')), opt=True)
    _ChangeOfCharCondition_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _ChangeOfCharCondition_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _ChangeOfCharCondition_enhancedDiagnostics = SEQ(name=u'enhancedDiagnostics', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'EnhancedDiagnostics')), opt=True)
    _ChangeOfCharCondition_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _ChangeOfCharCondition_accessAvailabilityChangeReason = INT(name=u'accessAvailabilityChangeReason', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessAvailabilityChangeReason')), opt=True)
    _ChangeOfCharCondition_uWANUserLocationInformation = SEQ(name=u'uWANUserLocationInformation', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UWANUserLocationInfo')), opt=True)
    _ChangeOfCharCondition_relatedChangeOfCharCondition = SEQ(name=u'relatedChangeOfCharCondition', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'RelatedChangeOfCharCondition')), opt=True)
    _ChangeOfCharCondition_cPCIoTEPSOptimisationIndicator = BOOL(name=u'cPCIoTEPSOptimisationIndicator', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CPCIoTEPSOptimisationIndicator')), opt=True)
    _ChangeOfCharCondition_servingPLMNRateControl = SEQ(name=u'servingPLMNRateControl', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingPLMNRateControl')), opt=True)
    _ChangeOfCharCondition_threeGPPPSDataOffStatus = ENUM(name=u'threeGPPPSDataOffStatus', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ThreeGPPPSDataOffStatus')), opt=True)
    _ChangeOfCharCondition_listOfPresenceReportingAreaInformation = SEQ_OF(name=u'listOfPresenceReportingAreaInformation', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ChangeOfCharCondition_listOfPresenceReportingAreaInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaInfo')))
    _ChangeOfCharCondition_listOfPresenceReportingAreaInformation._cont = __ChangeOfCharCondition_listOfPresenceReportingAreaInformation__item_
    _ChangeOfCharCondition_aPNRateControl = SEQ(name=u'aPNRateControl', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNRateControl')), opt=True)
    ChangeOfCharCondition._cont = ASN1Dict([
        (u'qosRequested', _ChangeOfCharCondition_qosRequested),
        (u'qosNegotiated', _ChangeOfCharCondition_qosNegotiated),
        (u'dataVolumeGPRSUplink', _ChangeOfCharCondition_dataVolumeGPRSUplink),
        (u'dataVolumeGPRSDownlink', _ChangeOfCharCondition_dataVolumeGPRSDownlink),
        (u'changeCondition', _ChangeOfCharCondition_changeCondition),
        (u'changeTime', _ChangeOfCharCondition_changeTime),
        (u'userLocationInformation', _ChangeOfCharCondition_userLocationInformation),
        (u'ePCQoSInformation', _ChangeOfCharCondition_ePCQoSInformation),
        (u'chargingID', _ChangeOfCharCondition_chargingID),
        (u'presenceReportingAreaStatus', _ChangeOfCharCondition_presenceReportingAreaStatus),
        (u'userCSGInformation', _ChangeOfCharCondition_userCSGInformation),
        (u'diagnostics', _ChangeOfCharCondition_diagnostics),
        (u'enhancedDiagnostics', _ChangeOfCharCondition_enhancedDiagnostics),
        (u'rATType', _ChangeOfCharCondition_rATType),
        (u'accessAvailabilityChangeReason', _ChangeOfCharCondition_accessAvailabilityChangeReason),
        (u'uWANUserLocationInformation', _ChangeOfCharCondition_uWANUserLocationInformation),
        (u'relatedChangeOfCharCondition', _ChangeOfCharCondition_relatedChangeOfCharCondition),
        (u'cPCIoTEPSOptimisationIndicator', _ChangeOfCharCondition_cPCIoTEPSOptimisationIndicator),
        (u'servingPLMNRateControl', _ChangeOfCharCondition_servingPLMNRateControl),
        (u'threeGPPPSDataOffStatus', _ChangeOfCharCondition_threeGPPPSDataOffStatus),
        (u'listOfPresenceReportingAreaInformation', _ChangeOfCharCondition_listOfPresenceReportingAreaInformation),
        (u'aPNRateControl', _ChangeOfCharCondition_aPNRateControl),
        ])
    ChangeOfCharCondition._ext = None
    
    #-----< ChangeOfMBMSCondition >-----#
    ChangeOfMBMSCondition = SEQ(name=u'ChangeOfMBMSCondition', mode=MODE_TYPE)
    _ChangeOfMBMSCondition_qosRequested = OCT_STR(name=u'qosRequested', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'QoSInformation')), opt=True)
    _ChangeOfMBMSCondition_qosNegotiated = OCT_STR(name=u'qosNegotiated', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'QoSInformation')), opt=True)
    _ChangeOfMBMSCondition_dataVolumeMBMSUplink = INT(name=u'dataVolumeMBMSUplink', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeMBMS')), opt=True)
    _ChangeOfMBMSCondition_dataVolumeMBMSDownlink = INT(name=u'dataVolumeMBMSDownlink', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeMBMS')))
    _ChangeOfMBMSCondition_changeCondition = ENUM(name=u'changeCondition', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeCondition')))
    _ChangeOfMBMSCondition_changeTime = OCT_STR(name=u'changeTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ChangeOfMBMSCondition_failureHandlingContinue = BOOL(name=u'failureHandlingContinue', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FailureHandlingContinue')), opt=True)
    ChangeOfMBMSCondition._cont = ASN1Dict([
        (u'qosRequested', _ChangeOfMBMSCondition_qosRequested),
        (u'qosNegotiated', _ChangeOfMBMSCondition_qosNegotiated),
        (u'dataVolumeMBMSUplink', _ChangeOfMBMSCondition_dataVolumeMBMSUplink),
        (u'dataVolumeMBMSDownlink', _ChangeOfMBMSCondition_dataVolumeMBMSDownlink),
        (u'changeCondition', _ChangeOfMBMSCondition_changeCondition),
        (u'changeTime', _ChangeOfMBMSCondition_changeTime),
        (u'failureHandlingContinue', _ChangeOfMBMSCondition_failureHandlingContinue),
        ])
    ChangeOfMBMSCondition._ext = None
    
    #-----< ChangeOfServiceCondition >-----#
    ChangeOfServiceCondition = SEQ(name=u'ChangeOfServiceCondition', mode=MODE_TYPE)
    _ChangeOfServiceCondition_ratingGroup = INT(name=u'ratingGroup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'RatingGroupId')))
    _ChangeOfServiceCondition_chargingRuleBaseName = STR_IA5(name=u'chargingRuleBaseName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingRuleBaseName')), opt=True)
    _ChangeOfServiceCondition_resultCode = INT(name=u'resultCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ResultCode')), opt=True)
    _ChangeOfServiceCondition_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ChangeOfServiceCondition_timeOfFirstUsage = OCT_STR(name=u'timeOfFirstUsage', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ChangeOfServiceCondition_timeOfLastUsage = OCT_STR(name=u'timeOfLastUsage', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ChangeOfServiceCondition_timeUsage = INT(name=u'timeUsage', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _ChangeOfServiceCondition_serviceConditionChange = BIT_STR(name=u'serviceConditionChange', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServiceConditionChange')))
    _ChangeOfServiceCondition_qoSInformationNeg = SEQ(name=u'qoSInformationNeg', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'EPCQoSInformation')), opt=True)
    _ChangeOfServiceCondition_servingNodeAddress = CHOICE(name=u'servingNodeAddress', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _ChangeOfServiceCondition_datavolumeFBCUplink = INT(name=u'datavolumeFBCUplink', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _ChangeOfServiceCondition_datavolumeFBCDownlink = INT(name=u'datavolumeFBCDownlink', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _ChangeOfServiceCondition_timeOfReport = OCT_STR(name=u'timeOfReport', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ChangeOfServiceCondition_failureHandlingContinue = BOOL(name=u'failureHandlingContinue', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FailureHandlingContinue')), opt=True)
    _ChangeOfServiceCondition_serviceIdentifier = INT(name=u'serviceIdentifier', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServiceIdentifier')), opt=True)
    _ChangeOfServiceCondition_pSFurnishChargingInformation = SEQ(name=u'pSFurnishChargingInformation', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PSFurnishChargingInformation')), opt=True)
    _ChangeOfServiceCondition_aFRecordInformation = SEQ_OF(name=u'aFRecordInformation', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ChangeOfServiceCondition_aFRecordInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'AFRecordInformation')))
    _ChangeOfServiceCondition_aFRecordInformation._cont = __ChangeOfServiceCondition_aFRecordInformation__item_
    _ChangeOfServiceCondition_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ChangeOfServiceCondition_eventBasedChargingInformation = SEQ(name=u'eventBasedChargingInformation', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'EventBasedChargingInformation')), opt=True)
    _ChangeOfServiceCondition_timeQuotaMechanism = SEQ(name=u'timeQuotaMechanism', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TimeQuotaMechanism')), opt=True)
    _ChangeOfServiceCondition_serviceSpecificInfo = SEQ_OF(name=u'serviceSpecificInfo', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ChangeOfServiceCondition_serviceSpecificInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceSpecificInfo')))
    _ChangeOfServiceCondition_serviceSpecificInfo._cont = __ChangeOfServiceCondition_serviceSpecificInfo__item_
    _ChangeOfServiceCondition_threeGPP2UserLocationInformation = OCT_STR(name=u'threeGPP2UserLocationInformation', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ChangeOfServiceCondition_sponsorIdentity = OCT_STR(name=u'sponsorIdentity', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ChangeOfServiceCondition_applicationServiceProviderIdentity = OCT_STR(name=u'applicationServiceProviderIdentity', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ChangeOfServiceCondition_aDCRuleBaseName = STR_IA5(name=u'aDCRuleBaseName', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ADCRuleBaseName')), opt=True)
    _ChangeOfServiceCondition_presenceReportingAreaStatus = ENUM(name=u'presenceReportingAreaStatus', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaStatus')), opt=True)
    _ChangeOfServiceCondition_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _ChangeOfServiceCondition_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _ChangeOfServiceCondition_uWANUserLocationInformation = SEQ(name=u'uWANUserLocationInformation', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UWANUserLocationInfo')), opt=True)
    _ChangeOfServiceCondition_relatedChangeOfServiceCondition = SEQ(name=u'relatedChangeOfServiceCondition', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'RelatedChangeOfServiceCondition')), opt=True)
    _ChangeOfServiceCondition_servingPLMNRateControl = SEQ(name=u'servingPLMNRateControl', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServingPLMNRateControl')), opt=True)
    _ChangeOfServiceCondition_aPNRateControl = SEQ(name=u'aPNRateControl', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'APNRateControl')), opt=True)
    _ChangeOfServiceCondition_threeGPPPSDataOffStatus = ENUM(name=u'threeGPPPSDataOffStatus', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ThreeGPPPSDataOffStatus')), opt=True)
    _ChangeOfServiceCondition_trafficSteeringPolicyIDDownlink = OCT_STR(name=u'trafficSteeringPolicyIDDownlink', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TrafficSteeringPolicyIDDownlink')), opt=True)
    _ChangeOfServiceCondition_trafficSteeringPolicyIDUplink = OCT_STR(name=u'trafficSteeringPolicyIDUplink', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TrafficSteeringPolicyIDUplink')), opt=True)
    _ChangeOfServiceCondition_tWANUserLocationInformation = SEQ(name=u'tWANUserLocationInformation', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TWANUserLocationInfo')), opt=True)
    _ChangeOfServiceCondition_listOfPresenceReportingAreaInformation = SEQ_OF(name=u'listOfPresenceReportingAreaInformation', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ChangeOfServiceCondition_listOfPresenceReportingAreaInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaInfo')))
    _ChangeOfServiceCondition_listOfPresenceReportingAreaInformation._cont = __ChangeOfServiceCondition_listOfPresenceReportingAreaInformation__item_
    _ChangeOfServiceCondition_voLTEInformation = SEQ(name=u'voLTEInformation', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'VoLTEInformation')), opt=True)
    ChangeOfServiceCondition._cont = ASN1Dict([
        (u'ratingGroup', _ChangeOfServiceCondition_ratingGroup),
        (u'chargingRuleBaseName', _ChangeOfServiceCondition_chargingRuleBaseName),
        (u'resultCode', _ChangeOfServiceCondition_resultCode),
        (u'localSequenceNumber', _ChangeOfServiceCondition_localSequenceNumber),
        (u'timeOfFirstUsage', _ChangeOfServiceCondition_timeOfFirstUsage),
        (u'timeOfLastUsage', _ChangeOfServiceCondition_timeOfLastUsage),
        (u'timeUsage', _ChangeOfServiceCondition_timeUsage),
        (u'serviceConditionChange', _ChangeOfServiceCondition_serviceConditionChange),
        (u'qoSInformationNeg', _ChangeOfServiceCondition_qoSInformationNeg),
        (u'servingNodeAddress', _ChangeOfServiceCondition_servingNodeAddress),
        (u'datavolumeFBCUplink', _ChangeOfServiceCondition_datavolumeFBCUplink),
        (u'datavolumeFBCDownlink', _ChangeOfServiceCondition_datavolumeFBCDownlink),
        (u'timeOfReport', _ChangeOfServiceCondition_timeOfReport),
        (u'failureHandlingContinue', _ChangeOfServiceCondition_failureHandlingContinue),
        (u'serviceIdentifier', _ChangeOfServiceCondition_serviceIdentifier),
        (u'pSFurnishChargingInformation', _ChangeOfServiceCondition_pSFurnishChargingInformation),
        (u'aFRecordInformation', _ChangeOfServiceCondition_aFRecordInformation),
        (u'userLocationInformation', _ChangeOfServiceCondition_userLocationInformation),
        (u'eventBasedChargingInformation', _ChangeOfServiceCondition_eventBasedChargingInformation),
        (u'timeQuotaMechanism', _ChangeOfServiceCondition_timeQuotaMechanism),
        (u'serviceSpecificInfo', _ChangeOfServiceCondition_serviceSpecificInfo),
        (u'threeGPP2UserLocationInformation', _ChangeOfServiceCondition_threeGPP2UserLocationInformation),
        (u'sponsorIdentity', _ChangeOfServiceCondition_sponsorIdentity),
        (u'applicationServiceProviderIdentity', _ChangeOfServiceCondition_applicationServiceProviderIdentity),
        (u'aDCRuleBaseName', _ChangeOfServiceCondition_aDCRuleBaseName),
        (u'presenceReportingAreaStatus', _ChangeOfServiceCondition_presenceReportingAreaStatus),
        (u'userCSGInformation', _ChangeOfServiceCondition_userCSGInformation),
        (u'rATType', _ChangeOfServiceCondition_rATType),
        (u'uWANUserLocationInformation', _ChangeOfServiceCondition_uWANUserLocationInformation),
        (u'relatedChangeOfServiceCondition', _ChangeOfServiceCondition_relatedChangeOfServiceCondition),
        (u'servingPLMNRateControl', _ChangeOfServiceCondition_servingPLMNRateControl),
        (u'aPNRateControl', _ChangeOfServiceCondition_aPNRateControl),
        (u'threeGPPPSDataOffStatus', _ChangeOfServiceCondition_threeGPPPSDataOffStatus),
        (u'trafficSteeringPolicyIDDownlink', _ChangeOfServiceCondition_trafficSteeringPolicyIDDownlink),
        (u'trafficSteeringPolicyIDUplink', _ChangeOfServiceCondition_trafficSteeringPolicyIDUplink),
        (u'tWANUserLocationInformation', _ChangeOfServiceCondition_tWANUserLocationInformation),
        (u'listOfPresenceReportingAreaInformation', _ChangeOfServiceCondition_listOfPresenceReportingAreaInformation),
        (u'voLTEInformation', _ChangeOfServiceCondition_voLTEInformation),
        ])
    ChangeOfServiceCondition._ext = None
    
    #-----< ChangeLocation >-----#
    ChangeLocation = SEQ(name=u'ChangeLocation', mode=MODE_TYPE)
    _ChangeLocation_locationAreaCode = OCT_STR(name=u'locationAreaCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocationAreaCode')))
    _ChangeLocation_routingAreaCode = OCT_STR(name=u'routingAreaCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RoutingAreaCode')))
    _ChangeLocation_cellId = OCT_STR(name=u'cellId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CellId')), opt=True)
    _ChangeLocation_changeTime = OCT_STR(name=u'changeTime', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ChangeLocation_mCC_MNC = OCT_STR(name=u'mCC-MNC', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    ChangeLocation._cont = ASN1Dict([
        (u'locationAreaCode', _ChangeLocation_locationAreaCode),
        (u'routingAreaCode', _ChangeLocation_routingAreaCode),
        (u'cellId', _ChangeLocation_cellId),
        (u'changeTime', _ChangeLocation_changeTime),
        (u'mCC-MNC', _ChangeLocation_mCC_MNC),
        ])
    ChangeLocation._ext = None
    
    #-----< ChargingCharacteristics >-----#
    ChargingCharacteristics = OCT_STR(name=u'ChargingCharacteristics', mode=MODE_TYPE)
    ChargingCharacteristics._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< ChargingPerIPCANSessionIndicator >-----#
    ChargingPerIPCANSessionIndicator = ENUM(name=u'ChargingPerIPCANSessionIndicator', mode=MODE_TYPE)
    ChargingPerIPCANSessionIndicator._cont = ASN1Dict([(u'inactive', 0), (u'active', 1)])
    ChargingPerIPCANSessionIndicator._ext = None
    
    #-----< ChargingRuleBaseName >-----#
    ChargingRuleBaseName = STR_IA5(name=u'ChargingRuleBaseName', mode=MODE_TYPE)
    
    #-----< ChChSelectionMode >-----#
    ChChSelectionMode = ENUM(name=u'ChChSelectionMode', mode=MODE_TYPE)
    ChChSelectionMode._cont = ASN1Dict([(u'servingNodeSupplied', 0), (u'subscriptionSpecific', 1), (u'aPNSpecific', 2), (u'homeDefault', 3), (u'roamingDefault', 4), (u'visitingDefault', 5), (u'fixedDefault', 6)])
    ChChSelectionMode._ext = None
    
    #-----< CNOperatorSelectionEntity >-----#
    CNOperatorSelectionEntity = ENUM(name=u'CNOperatorSelectionEntity', mode=MODE_TYPE)
    CNOperatorSelectionEntity._cont = ASN1Dict([(u'servCNSelectedbyUE', 0), (u'servCNSelectedbyNtw', 1)])
    CNOperatorSelectionEntity._ext = None
    
    #-----< CPCIoTEPSOptimisationIndicator >-----#
    CPCIoTEPSOptimisationIndicator = BOOL(name=u'CPCIoTEPSOptimisationIndicator', mode=MODE_TYPE)
    
    #-----< CSGAccessMode >-----#
    CSGAccessMode = ENUM(name=u'CSGAccessMode', mode=MODE_TYPE)
    CSGAccessMode._cont = ASN1Dict([(u'closedMode', 0), (u'hybridMode', 1)])
    CSGAccessMode._ext = None
    
    #-----< CSGId >-----#
    CSGId = OCT_STR(name=u'CSGId', mode=MODE_TYPE)
    CSGId._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< CTEID >-----#
    CTEID = OCT_STR(name=u'CTEID', mode=MODE_TYPE)
    CTEID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< DataVolumeGPRS >-----#
    DataVolumeGPRS = INT(name=u'DataVolumeGPRS', mode=MODE_TYPE)
    
    #-----< DataVolumeMBMS >-----#
    DataVolumeMBMS = INT(name=u'DataVolumeMBMS', mode=MODE_TYPE)
    
    #-----< EPCQoSInformation >-----#
    EPCQoSInformation = SEQ(name=u'EPCQoSInformation', mode=MODE_TYPE)
    _EPCQoSInformation_qCI = INT(name=u'qCI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EPCQoSInformation_maxRequestedBandwithUL = INT(name=u'maxRequestedBandwithUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_maxRequestedBandwithDL = INT(name=u'maxRequestedBandwithDL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_guaranteedBitrateUL = INT(name=u'guaranteedBitrateUL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_guaranteedBitrateDL = INT(name=u'guaranteedBitrateDL', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_aRP = INT(name=u'aRP', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_aPNAggregateMaxBitrateUL = INT(name=u'aPNAggregateMaxBitrateUL', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_aPNAggregateMaxBitrateDL = INT(name=u'aPNAggregateMaxBitrateDL', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_extendedMaxRequestedBWUL = INT(name=u'extendedMaxRequestedBWUL', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_extendedMaxRequestedBWDL = INT(name=u'extendedMaxRequestedBWDL', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_extendedGBRUL = INT(name=u'extendedGBRUL', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_extendedGBRDL = INT(name=u'extendedGBRDL', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_extendedAPNAMBRUL = INT(name=u'extendedAPNAMBRUL', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPCQoSInformation_extendedAPNAMBRDL = INT(name=u'extendedAPNAMBRDL', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    EPCQoSInformation._cont = ASN1Dict([
        (u'qCI', _EPCQoSInformation_qCI),
        (u'maxRequestedBandwithUL', _EPCQoSInformation_maxRequestedBandwithUL),
        (u'maxRequestedBandwithDL', _EPCQoSInformation_maxRequestedBandwithDL),
        (u'guaranteedBitrateUL', _EPCQoSInformation_guaranteedBitrateUL),
        (u'guaranteedBitrateDL', _EPCQoSInformation_guaranteedBitrateDL),
        (u'aRP', _EPCQoSInformation_aRP),
        (u'aPNAggregateMaxBitrateUL', _EPCQoSInformation_aPNAggregateMaxBitrateUL),
        (u'aPNAggregateMaxBitrateDL', _EPCQoSInformation_aPNAggregateMaxBitrateDL),
        (u'extendedMaxRequestedBWUL', _EPCQoSInformation_extendedMaxRequestedBWUL),
        (u'extendedMaxRequestedBWDL', _EPCQoSInformation_extendedMaxRequestedBWDL),
        (u'extendedGBRUL', _EPCQoSInformation_extendedGBRUL),
        (u'extendedGBRDL', _EPCQoSInformation_extendedGBRDL),
        (u'extendedAPNAMBRUL', _EPCQoSInformation_extendedAPNAMBRUL),
        (u'extendedAPNAMBRDL', _EPCQoSInformation_extendedAPNAMBRDL),
        ])
    EPCQoSInformation._ext = None
    
    #-----< EventBasedChargingInformation >-----#
    EventBasedChargingInformation = SEQ(name=u'EventBasedChargingInformation', mode=MODE_TYPE)
    _EventBasedChargingInformation_numberOfEvents = INT(name=u'numberOfEvents', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EventBasedChargingInformation_eventTimeStamps = SEQ_OF(name=u'eventTimeStamps', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __EventBasedChargingInformation_eventTimeStamps__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _EventBasedChargingInformation_eventTimeStamps._cont = __EventBasedChargingInformation_eventTimeStamps__item_
    EventBasedChargingInformation._cont = ASN1Dict([
        (u'numberOfEvents', _EventBasedChargingInformation_numberOfEvents),
        (u'eventTimeStamps', _EventBasedChargingInformation_eventTimeStamps),
        ])
    EventBasedChargingInformation._ext = None
    
    #-----< FailureHandlingContinue >-----#
    FailureHandlingContinue = BOOL(name=u'FailureHandlingContinue', mode=MODE_TYPE)
    
    #-----< FFDAppendIndicator >-----#
    FFDAppendIndicator = BOOL(name=u'FFDAppendIndicator', mode=MODE_TYPE)
    
    #-----< FixedSubsID >-----#
    FixedSubsID = OCT_STR(name=u'FixedSubsID', mode=MODE_TYPE)
    
    #-----< FixedUserLocationInformation >-----#
    FixedUserLocationInformation = SEQ(name=u'FixedUserLocationInformation', mode=MODE_TYPE)
    _FixedUserLocationInformation_sSID = OCT_STR(name=u'sSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _FixedUserLocationInformation_bSSID = OCT_STR(name=u'bSSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _FixedUserLocationInformation_accessLineIdentifier = SEQ(name=u'accessLineIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessLineIdentifier')), opt=True)
    FixedUserLocationInformation._cont = ASN1Dict([
        (u'sSID', _FixedUserLocationInformation_sSID),
        (u'bSSID', _FixedUserLocationInformation_bSSID),
        (u'accessLineIdentifier', _FixedUserLocationInformation_accessLineIdentifier),
        ])
    FixedUserLocationInformation._ext = None
    
    #-----< Flows >-----#
    Flows = SEQ(name=u'Flows', mode=MODE_TYPE)
    _Flows_mediaComponentNumber = INT(name=u'mediaComponentNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Flows_flowNumber = SEQ_OF(name=u'flowNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Flows_flowNumber__item_ = INT(name='_item_', mode=MODE_TYPE)
    _Flows_flowNumber._cont = __Flows_flowNumber__item_
    Flows._cont = ASN1Dict([
        (u'mediaComponentNumber', _Flows_mediaComponentNumber),
        (u'flowNumber', _Flows_flowNumber),
        ])
    Flows._ext = None
    
    #-----< FreeFormatData >-----#
    FreeFormatData = OCT_STR(name=u'FreeFormatData', mode=MODE_TYPE)
    FreeFormatData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=None, er=[])
    
    #-----< MOExceptionDataCounter >-----#
    MOExceptionDataCounter = SEQ(name=u'MOExceptionDataCounter', mode=MODE_TYPE)
    _MOExceptionDataCounter_counterValue = INT(name=u'counterValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MOExceptionDataCounter_counterTimestamp = OCT_STR(name=u'counterTimestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    MOExceptionDataCounter._cont = ASN1Dict([
        (u'counterValue', _MOExceptionDataCounter_counterValue),
        (u'counterTimestamp', _MOExceptionDataCounter_counterTimestamp),
        ])
    MOExceptionDataCounter._ext = None
    
    #-----< MSNetworkCapability >-----#
    MSNetworkCapability = OCT_STR(name=u'MSNetworkCapability', mode=MODE_TYPE)
    MSNetworkCapability._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< NBIFOMMode >-----#
    NBIFOMMode = ENUM(name=u'NBIFOMMode', mode=MODE_TYPE)
    NBIFOMMode._cont = ASN1Dict([(u'uEINITIATED', 0), (u'nETWORKINITIATED', 1)])
    NBIFOMMode._ext = None
    
    #-----< NBIFOMSupport >-----#
    NBIFOMSupport = ENUM(name=u'NBIFOMSupport', mode=MODE_TYPE)
    NBIFOMSupport._cont = ASN1Dict([(u'nBIFOMNotSupported', 0), (u'nBIFOMSupported', 1)])
    NBIFOMSupport._ext = None
    
    #-----< NetworkInitiatedPDPContext >-----#
    NetworkInitiatedPDPContext = BOOL(name=u'NetworkInitiatedPDPContext', mode=MODE_TYPE)
    
    #-----< NumberOfDPEncountered >-----#
    NumberOfDPEncountered = INT(name=u'NumberOfDPEncountered', mode=MODE_TYPE)
    
    #-----< PDPType >-----#
    PDPType = OCT_STR(name=u'PDPType', mode=MODE_TYPE)
    PDPType._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< PDPPDNTypeExtension >-----#
    PDPPDNTypeExtension = INT(name=u'PDPPDNTypeExtension', mode=MODE_TYPE)
    
    #-----< PresenceReportingAreaElementsList >-----#
    PresenceReportingAreaElementsList = OCT_STR(name=u'PresenceReportingAreaElementsList', mode=MODE_TYPE)
    
    #-----< PresenceReportingAreaInfo >-----#
    PresenceReportingAreaInfo = SEQ(name=u'PresenceReportingAreaInfo', mode=MODE_TYPE)
    _PresenceReportingAreaInfo_presenceReportingAreaIdentifier = OCT_STR(name=u'presenceReportingAreaIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PresenceReportingAreaInfo_presenceReportingAreaStatus = ENUM(name=u'presenceReportingAreaStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaStatus')), opt=True)
    _PresenceReportingAreaInfo_presenceReportingAreaElementsList = OCT_STR(name=u'presenceReportingAreaElementsList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaElementsList')), opt=True)
    _PresenceReportingAreaInfo_presenceReportingAreaNode = BIT_STR(name=u'presenceReportingAreaNode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaNode')), opt=True)
    PresenceReportingAreaInfo._cont = ASN1Dict([
        (u'presenceReportingAreaIdentifier', _PresenceReportingAreaInfo_presenceReportingAreaIdentifier),
        (u'presenceReportingAreaStatus', _PresenceReportingAreaInfo_presenceReportingAreaStatus),
        (u'presenceReportingAreaElementsList', _PresenceReportingAreaInfo_presenceReportingAreaElementsList),
        (u'presenceReportingAreaNode', _PresenceReportingAreaInfo_presenceReportingAreaNode),
        ])
    PresenceReportingAreaInfo._ext = None
    
    #-----< PresenceReportingAreaNode >-----#
    PresenceReportingAreaNode = BIT_STR(name=u'PresenceReportingAreaNode', mode=MODE_TYPE)
    PresenceReportingAreaNode._cont = ASN1Dict([(u'oCS', 0), (u'pCRF', 1)])
    
    #-----< PresenceReportingAreaStatus >-----#
    PresenceReportingAreaStatus = ENUM(name=u'PresenceReportingAreaStatus', mode=MODE_TYPE)
    PresenceReportingAreaStatus._cont = ASN1Dict([(u'insideArea', 0), (u'outsideArea', 1), (u'inactive', 2), (u'unknown', 3)])
    PresenceReportingAreaStatus._ext = None
    
    #-----< PSFurnishChargingInformation >-----#
    PSFurnishChargingInformation = SEQ(name=u'PSFurnishChargingInformation', mode=MODE_TYPE)
    _PSFurnishChargingInformation_pSFreeFormatData = OCT_STR(name=u'pSFreeFormatData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FreeFormatData')))
    _PSFurnishChargingInformation_pSFFDAppendIndicator = BOOL(name=u'pSFFDAppendIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'FFDAppendIndicator')), opt=True)
    PSFurnishChargingInformation._cont = ASN1Dict([
        (u'pSFreeFormatData', _PSFurnishChargingInformation_pSFreeFormatData),
        (u'pSFFDAppendIndicator', _PSFurnishChargingInformation_pSFFDAppendIndicator),
        ])
    PSFurnishChargingInformation._ext = None
    
    #-----< QoSInformation >-----#
    QoSInformation = OCT_STR(name=u'QoSInformation', mode=MODE_TYPE)
    QoSInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=255)], ev=None, er=[])
    
    #-----< RANSecondaryRATUsageReport >-----#
    RANSecondaryRATUsageReport = SEQ(name=u'RANSecondaryRATUsageReport', mode=MODE_TYPE)
    _RANSecondaryRATUsageReport_dataVolumeUplink = INT(name=u'dataVolumeUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')))
    _RANSecondaryRATUsageReport_dataVolumeDownlink = INT(name=u'dataVolumeDownlink', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')))
    _RANSecondaryRATUsageReport_rANStartTime = OCT_STR(name=u'rANStartTime', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _RANSecondaryRATUsageReport_rANEndTime = OCT_STR(name=u'rANEndTime', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _RANSecondaryRATUsageReport_secondaryRATType = INT(name=u'secondaryRATType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'SecondaryRATType')), opt=True)
    _RANSecondaryRATUsageReport_chargingID = INT(name=u'chargingID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')), opt=True)
    RANSecondaryRATUsageReport._cont = ASN1Dict([
        (u'dataVolumeUplink', _RANSecondaryRATUsageReport_dataVolumeUplink),
        (u'dataVolumeDownlink', _RANSecondaryRATUsageReport_dataVolumeDownlink),
        (u'rANStartTime', _RANSecondaryRATUsageReport_rANStartTime),
        (u'rANEndTime', _RANSecondaryRATUsageReport_rANEndTime),
        (u'secondaryRATType', _RANSecondaryRATUsageReport_secondaryRATType),
        (u'chargingID', _RANSecondaryRATUsageReport_chargingID),
        ])
    RANSecondaryRATUsageReport._ext = None
    
    #-----< RateControlTimeUnit >-----#
    RateControlTimeUnit = INT(name=u'RateControlTimeUnit', mode=MODE_TYPE)
    RateControlTimeUnit._cont = ASN1Dict([(u'unrestricted', 0), (u'minute', 1), (u'hour', 2), (u'day', 3), (u'week', 4)])
    
    #-----< RatingGroupId >-----#
    RatingGroupId = INT(name=u'RatingGroupId', mode=MODE_TYPE)
    
    #-----< RelatedChangeOfCharCondition >-----#
    RelatedChangeOfCharCondition = SEQ(name=u'RelatedChangeOfCharCondition', mode=MODE_TYPE)
    _RelatedChangeOfCharCondition_changeCondition = ENUM(name=u'changeCondition', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeCondition')))
    _RelatedChangeOfCharCondition_changeTime = OCT_STR(name=u'changeTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _RelatedChangeOfCharCondition_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RelatedChangeOfCharCondition_presenceReportingAreaStatus = ENUM(name=u'presenceReportingAreaStatus', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaStatus')), opt=True)
    _RelatedChangeOfCharCondition_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _RelatedChangeOfCharCondition_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _RelatedChangeOfCharCondition_uWANUserLocationInformation = SEQ(name=u'uWANUserLocationInformation', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UWANUserLocationInfo')), opt=True)
    RelatedChangeOfCharCondition._cont = ASN1Dict([
        (u'changeCondition', _RelatedChangeOfCharCondition_changeCondition),
        (u'changeTime', _RelatedChangeOfCharCondition_changeTime),
        (u'userLocationInformation', _RelatedChangeOfCharCondition_userLocationInformation),
        (u'presenceReportingAreaStatus', _RelatedChangeOfCharCondition_presenceReportingAreaStatus),
        (u'userCSGInformation', _RelatedChangeOfCharCondition_userCSGInformation),
        (u'rATType', _RelatedChangeOfCharCondition_rATType),
        (u'uWANUserLocationInformation', _RelatedChangeOfCharCondition_uWANUserLocationInformation),
        ])
    RelatedChangeOfCharCondition._ext = None
    
    #-----< RelatedChangeOfServiceCondition >-----#
    RelatedChangeOfServiceCondition = SEQ(name=u'RelatedChangeOfServiceCondition', mode=MODE_TYPE)
    _RelatedChangeOfServiceCondition_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RelatedChangeOfServiceCondition_threeGPP2UserLocationInformation = OCT_STR(name=u'threeGPP2UserLocationInformation', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RelatedChangeOfServiceCondition_presenceReportingAreaStatus = ENUM(name=u'presenceReportingAreaStatus', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PresenceReportingAreaStatus')), opt=True)
    _RelatedChangeOfServiceCondition_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _RelatedChangeOfServiceCondition_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _RelatedChangeOfServiceCondition_uWANUserLocationInformation = SEQ(name=u'uWANUserLocationInformation', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UWANUserLocationInfo')), opt=True)
    _RelatedChangeOfServiceCondition_relatedServiceConditionChange = BIT_STR(name=u'relatedServiceConditionChange', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ServiceConditionChange')), opt=True)
    RelatedChangeOfServiceCondition._cont = ASN1Dict([
        (u'userLocationInformation', _RelatedChangeOfServiceCondition_userLocationInformation),
        (u'threeGPP2UserLocationInformation', _RelatedChangeOfServiceCondition_threeGPP2UserLocationInformation),
        (u'presenceReportingAreaStatus', _RelatedChangeOfServiceCondition_presenceReportingAreaStatus),
        (u'userCSGInformation', _RelatedChangeOfServiceCondition_userCSGInformation),
        (u'rATType', _RelatedChangeOfServiceCondition_rATType),
        (u'uWANUserLocationInformation', _RelatedChangeOfServiceCondition_uWANUserLocationInformation),
        (u'relatedServiceConditionChange', _RelatedChangeOfServiceCondition_relatedServiceConditionChange),
        ])
    RelatedChangeOfServiceCondition._ext = None
    
    #-----< ResultCode >-----#
    ResultCode = INT(name=u'ResultCode', mode=MODE_TYPE)
    
    #-----< SecondaryRATType >-----#
    SecondaryRATType = INT(name=u'SecondaryRATType', mode=MODE_TYPE)
    SecondaryRATType._cont = ASN1Dict([(u'nR', 0)])
    
    #-----< ServiceConditionChange >-----#
    ServiceConditionChange = BIT_STR(name=u'ServiceConditionChange', mode=MODE_TYPE)
    ServiceConditionChange._cont = ASN1Dict([(u'qoSChange', 0), (u'sGSNChange', 1), (u'sGSNPLMNIDChange', 2), (u'tariffTimeSwitch', 3), (u'pDPContextRelease', 4), (u'rATChange', 5), (u'serviceIdledOut', 6), (u'reserved', 7), (u'configurationChange', 8), (u'serviceStop', 9), (u'dCCATimeThresholdReached', 10), (u'dCCAVolumeThresholdReached', 11), (u'dCCAServiceSpecificUnitThresholdReached', 12), (u'dCCATimeExhausted', 13), (u'dCCAVolumeExhausted', 14), (u'dCCAValidityTimeout', 15), (u'reserved1', 16), (u'dCCAReauthorisationRequest', 17), (u'dCCAContinueOngoingSession', 18), (u'dCCARetryAndTerminateOngoingSession', 19), (u'dCCATerminateOngoingSession', 20), (u'cGI-SAIChange', 21), (u'rAIChange', 22), (u'dCCAServiceSpecificUnitExhausted', 23), (u'recordClosure', 24), (u'timeLimit', 25), (u'volumeLimit', 26), (u'serviceSpecificUnitLimit', 27), (u'envelopeClosure', 28), (u'eCGIChange', 29), (u'tAIChange', 30), (u'userLocationChange', 31), (u'userCSGInformationChange', 32), (u'presenceInPRAChange', 33), (u'accessChangeOfSDF', 34), (u'indirectServiceConditionChange', 35), (u'servingPLMNRateControlChange', 36), (u'aPNRateControlChange', 37)])
    
    #-----< SCFAddress >-----#
    SCFAddress = OCT_STR(name=u'SCFAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    
    #-----< ServiceIdentifier >-----#
    ServiceIdentifier = INT(name=u'ServiceIdentifier', mode=MODE_TYPE)
    ServiceIdentifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< ServingNodeType >-----#
    ServingNodeType = ENUM(name=u'ServingNodeType', mode=MODE_TYPE)
    ServingNodeType._cont = ASN1Dict([(u'sGSN', 0), (u'pMIPSGW', 1), (u'gTPSGW', 2), (u'ePDG', 3), (u'hSGW', 4), (u'mME', 5), (u'tWAN', 6)])
    ServingNodeType._ext = None
    
    #-----< ServingPLMNRateControl >-----#
    ServingPLMNRateControl = SEQ(name=u'ServingPLMNRateControl', mode=MODE_TYPE)
    _ServingPLMNRateControl_sPLMNDLRateControlValue = INT(name=u'sPLMNDLRateControlValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ServingPLMNRateControl_sPLMNULRateControlValue = INT(name=u'sPLMNULRateControlValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ServingPLMNRateControl._cont = ASN1Dict([
        (u'sPLMNDLRateControlValue', _ServingPLMNRateControl_sPLMNDLRateControlValue),
        (u'sPLMNULRateControlValue', _ServingPLMNRateControl_sPLMNULRateControlValue),
        ])
    ServingPLMNRateControl._ext = None
    
    #-----< SGiPtPTunnellingMethod >-----#
    SGiPtPTunnellingMethod = ENUM(name=u'SGiPtPTunnellingMethod', mode=MODE_TYPE)
    SGiPtPTunnellingMethod._cont = ASN1Dict([(u'uDPIPbased', 0), (u'others', 1)])
    SGiPtPTunnellingMethod._ext = None
    
    #-----< SGSNChange >-----#
    SGSNChange = BOOL(name=u'SGSNChange', mode=MODE_TYPE)
    
    #-----< SGWChange >-----#
    SGWChange = BOOL(name=u'SGWChange', mode=MODE_TYPE)
    
    #-----< TimeQuotaMechanism >-----#
    TimeQuotaMechanism = SEQ(name=u'TimeQuotaMechanism', mode=MODE_TYPE)
    _TimeQuotaMechanism_timeQuotaType = ENUM(name=u'timeQuotaType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'TimeQuotaType')))
    _TimeQuotaMechanism_baseTimeInterval = INT(name=u'baseTimeInterval', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TimeQuotaMechanism._cont = ASN1Dict([
        (u'timeQuotaType', _TimeQuotaMechanism_timeQuotaType),
        (u'baseTimeInterval', _TimeQuotaMechanism_baseTimeInterval),
        ])
    TimeQuotaMechanism._ext = None
    
    #-----< TimeQuotaType >-----#
    TimeQuotaType = ENUM(name=u'TimeQuotaType', mode=MODE_TYPE)
    TimeQuotaType._cont = ASN1Dict([(u'dISCRETETIMEPERIOD', 0), (u'cONTINUOUSTIMEPERIOD', 1)])
    TimeQuotaType._ext = None
    
    #-----< TrafficSteeringPolicyIDDownlink >-----#
    TrafficSteeringPolicyIDDownlink = OCT_STR(name=u'TrafficSteeringPolicyIDDownlink', mode=MODE_TYPE)
    
    #-----< TrafficSteeringPolicyIDUplink >-----#
    TrafficSteeringPolicyIDUplink = OCT_STR(name=u'TrafficSteeringPolicyIDUplink', mode=MODE_TYPE)
    
    #-----< TWANUserLocationInfo >-----#
    TWANUserLocationInfo = SEQ(name=u'TWANUserLocationInfo', mode=MODE_TYPE)
    _TWANUserLocationInfo_sSID = OCT_STR(name=u'sSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TWANUserLocationInfo_bSSID = OCT_STR(name=u'bSSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TWANUserLocationInfo_civicAddressInformation = OCT_STR(name=u'civicAddressInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CivicAddressInformation')), opt=True)
    _TWANUserLocationInfo_wLANOperatorId = SEQ(name=u'wLANOperatorId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'WLANOperatorId')), opt=True)
    _TWANUserLocationInfo_logicalAccessID = OCT_STR(name=u'logicalAccessID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    TWANUserLocationInfo._cont = ASN1Dict([
        (u'sSID', _TWANUserLocationInfo_sSID),
        (u'bSSID', _TWANUserLocationInfo_bSSID),
        (u'civicAddressInformation', _TWANUserLocationInfo_civicAddressInformation),
        (u'wLANOperatorId', _TWANUserLocationInfo_wLANOperatorId),
        (u'logicalAccessID', _TWANUserLocationInfo_logicalAccessID),
        ])
    TWANUserLocationInfo._ext = None
    
    #-----< UNIPDUCPOnlyFlag >-----#
    UNIPDUCPOnlyFlag = BOOL(name=u'UNIPDUCPOnlyFlag', mode=MODE_TYPE)
    
    #-----< UserCSGInformation >-----#
    UserCSGInformation = SEQ(name=u'UserCSGInformation', mode=MODE_TYPE)
    _UserCSGInformation_cSGId = OCT_STR(name=u'cSGId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CSGId')))
    _UserCSGInformation_cSGAccessMode = ENUM(name=u'cSGAccessMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CSGAccessMode')))
    _UserCSGInformation_cSGMembershipIndication = NULL(name=u'cSGMembershipIndication', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UserCSGInformation._cont = ASN1Dict([
        (u'cSGId', _UserCSGInformation_cSGId),
        (u'cSGAccessMode', _UserCSGInformation_cSGAccessMode),
        (u'cSGMembershipIndication', _UserCSGInformation_cSGMembershipIndication),
        ])
    UserCSGInformation._ext = None
    
    #-----< UWANUserLocationInfo >-----#
    UWANUserLocationInfo = SEQ(name=u'UWANUserLocationInfo', mode=MODE_TYPE)
    _UWANUserLocationInfo_uELocalIPAddress = CHOICE(name=u'uELocalIPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _UWANUserLocationInfo_uDPSourcePort = OCT_STR(name=u'uDPSourcePort', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UWANUserLocationInfo_uDPSourcePort._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _UWANUserLocationInfo_sSID = OCT_STR(name=u'sSID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UWANUserLocationInfo_bSSID = OCT_STR(name=u'bSSID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UWANUserLocationInfo_tCPSourcePort = OCT_STR(name=u'tCPSourcePort', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UWANUserLocationInfo_tCPSourcePort._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _UWANUserLocationInfo_civicAddressInformation = OCT_STR(name=u'civicAddressInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CivicAddressInformation')), opt=True)
    _UWANUserLocationInfo_wLANOperatorId = SEQ(name=u'wLANOperatorId', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'WLANOperatorId')), opt=True)
    _UWANUserLocationInfo_logicalAccessID = OCT_STR(name=u'logicalAccessID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UWANUserLocationInfo._cont = ASN1Dict([
        (u'uELocalIPAddress', _UWANUserLocationInfo_uELocalIPAddress),
        (u'uDPSourcePort', _UWANUserLocationInfo_uDPSourcePort),
        (u'sSID', _UWANUserLocationInfo_sSID),
        (u'bSSID', _UWANUserLocationInfo_bSSID),
        (u'tCPSourcePort', _UWANUserLocationInfo_tCPSourcePort),
        (u'civicAddressInformation', _UWANUserLocationInfo_civicAddressInformation),
        (u'wLANOperatorId', _UWANUserLocationInfo_wLANOperatorId),
        (u'logicalAccessID', _UWANUserLocationInfo_logicalAccessID),
        ])
    UWANUserLocationInfo._ext = None
    
    #-----< VoLTEInformation >-----#
    VoLTEInformation = SEQ(name=u'VoLTEInformation', mode=MODE_TYPE)
    _VoLTEInformation_callerInformation = SEQ_OF(name=u'callerInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __VoLTEInformation_callerInformation__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')))
    _VoLTEInformation_callerInformation._cont = __VoLTEInformation_callerInformation__item_
    _VoLTEInformation_calleeInformation = SEQ(name=u'calleeInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'CalleePartyInformation')), opt=True)
    VoLTEInformation._cont = ASN1Dict([
        (u'callerInformation', _VoLTEInformation_callerInformation),
        (u'calleeInformation', _VoLTEInformation_calleeInformation),
        ])
    VoLTEInformation._ext = None
    
    #-----< WLANOperatorId >-----#
    WLANOperatorId = SEQ(name=u'WLANOperatorId', mode=MODE_TYPE)
    _WLANOperatorId_wLANOperatorName = OCT_STR(name=u'wLANOperatorName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WLANOperatorId_wLANPLMNId = OCT_STR(name=u'wLANPLMNId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')))
    WLANOperatorId._cont = ASN1Dict([
        (u'wLANOperatorName', _WLANOperatorId_wLANOperatorName),
        (u'wLANPLMNId', _WLANOperatorId_wLANPLMNId),
        ])
    WLANOperatorId._ext = None
    
    _all_ = [
        _GPRSRecord_sgsnPDPRecord,
        _GPRSRecord_sgsnMMRecord,
        _GPRSRecord_sgsnSMORecord,
        _GPRSRecord_sgsnSMTRecord,
        _GPRSRecord_sgsnMTLCSRecord,
        _GPRSRecord_sgsnMOLCSRecord,
        _GPRSRecord_sgsnNILCSRecord,
        _GPRSRecord_sgsnMBMSRecord,
        _GPRSRecord_ggsnMBMSRecord,
        _GPRSRecord_sGWRecord,
        _GPRSRecord_pGWRecord,
        _GPRSRecord_gwMBMSRecord,
        _GPRSRecord_tDFRecord,
        _GPRSRecord_iPERecord,
        _GPRSRecord_ePDGRecord,
        _GPRSRecord_tWAGRecord,
        GPRSRecord,
        _SGWRecord_recordType,
        _SGWRecord_servedIMSI,
        _SGWRecord_s_GWAddress,
        _SGWRecord_chargingID,
        __SGWRecord_servingNodeAddress__item_,
        _SGWRecord_servingNodeAddress,
        _SGWRecord_accessPointNameNI,
        _SGWRecord_pdpPDNType,
        _SGWRecord_servedPDPPDNAddress,
        _SGWRecord_dynamicAddressFlag,
        __SGWRecord_listOfTrafficVolumes__item_,
        _SGWRecord_listOfTrafficVolumes,
        _SGWRecord_recordOpeningTime,
        _SGWRecord_duration,
        _SGWRecord_causeForRecClosing,
        _SGWRecord_diagnostics,
        _SGWRecord_recordSequenceNumber,
        _SGWRecord_nodeID,
        _SGWRecord_recordExtensions,
        _SGWRecord_localSequenceNumber,
        _SGWRecord_apnSelectionMode,
        _SGWRecord_servedMSISDN,
        _SGWRecord_chargingCharacteristics,
        _SGWRecord_chChSelectionMode,
        _SGWRecord_iMSsignalingContext,
        _SGWRecord_servingNodePLMNIdentifier,
        _SGWRecord_servedIMEI,
        _SGWRecord_rATType,
        _SGWRecord_mSTimeZone,
        _SGWRecord_userLocationInformation,
        _SGWRecord_sGWChange,
        __SGWRecord_servingNodeType__item_,
        _SGWRecord_servingNodeType,
        _SGWRecord_p_GWAddressUsed,
        _SGWRecord_p_GWPLMNIdentifier,
        _SGWRecord_startTime,
        _SGWRecord_stopTime,
        _SGWRecord_pDNConnectionChargingID,
        _SGWRecord_iMSIunauthenticatedFlag,
        _SGWRecord_userCSGInformation,
        _SGWRecord_servedPDPPDNAddressExt,
        _SGWRecord_lowPriorityIndicator,
        _SGWRecord_dynamicAddressFlagExt,
        _SGWRecord_s_GWiPv6Address,
        __SGWRecord_servingNodeiPv6Address__item_,
        _SGWRecord_servingNodeiPv6Address,
        _SGWRecord_p_GWiPv6AddressUsed,
        _SGWRecord_retransmission,
        _SGWRecord_userLocationInfoTime,
        _SGWRecord_cNOperatorSelectionEnt,
        _SGWRecord_presenceReportingAreaInfo,
        _SGWRecord_lastUserLocationInformation,
        _SGWRecord_lastMSTimeZone,
        _SGWRecord_enhancedDiagnostics,
        _SGWRecord_cPCIoTEPSOptimisationIndicator,
        _SGWRecord_uNIPDUCPOnlyFlag,
        _SGWRecord_servingPLMNRateControl,
        _SGWRecord_pDPPDNTypeExtension,
        _SGWRecord_mOExceptionDataCounter,
        __SGWRecord_listOfRANSecondaryRATUsageReports__item_,
        _SGWRecord_listOfRANSecondaryRATUsageReports,
        SGWRecord,
        _PGWRecord_recordType,
        _PGWRecord_servedIMSI,
        _PGWRecord_p_GWAddress,
        _PGWRecord_chargingID,
        __PGWRecord_servingNodeAddress__item_,
        _PGWRecord_servingNodeAddress,
        _PGWRecord_accessPointNameNI,
        _PGWRecord_pdpPDNType,
        _PGWRecord_servedPDPPDNAddress,
        _PGWRecord_dynamicAddressFlag,
        __PGWRecord_listOfTrafficVolumes__item_,
        _PGWRecord_listOfTrafficVolumes,
        _PGWRecord_recordOpeningTime,
        _PGWRecord_duration,
        _PGWRecord_causeForRecClosing,
        _PGWRecord_diagnostics,
        _PGWRecord_recordSequenceNumber,
        _PGWRecord_nodeID,
        _PGWRecord_recordExtensions,
        _PGWRecord_localSequenceNumber,
        _PGWRecord_apnSelectionMode,
        _PGWRecord_servedMSISDN,
        _PGWRecord_chargingCharacteristics,
        _PGWRecord_chChSelectionMode,
        _PGWRecord_iMSsignalingContext,
        _PGWRecord_servingNodePLMNIdentifier,
        _PGWRecord_pSFurnishChargingInformation,
        _PGWRecord_servedIMEI,
        _PGWRecord_rATType,
        _PGWRecord_mSTimeZone,
        _PGWRecord_userLocationInformation,
        _PGWRecord_cAMELChargingInformation,
        __PGWRecord_listOfServiceData__item_,
        _PGWRecord_listOfServiceData,
        __PGWRecord_servingNodeType__item_,
        _PGWRecord_servingNodeType,
        _PGWRecord_servedMNNAI,
        _PGWRecord_p_GWPLMNIdentifier,
        _PGWRecord_startTime,
        _PGWRecord_stopTime,
        _PGWRecord_served3gpp2MEID,
        _PGWRecord_pDNConnectionChargingID,
        _PGWRecord_iMSIunauthenticatedFlag,
        _PGWRecord_userCSGInformation,
        _PGWRecord_threeGPP2UserLocationInformation,
        _PGWRecord_servedPDPPDNAddressExt,
        _PGWRecord_lowPriorityIndicator,
        _PGWRecord_dynamicAddressFlagExt,
        __PGWRecord_servingNodeiPv6Address__item_,
        _PGWRecord_servingNodeiPv6Address,
        _PGWRecord_p_GWiPv6AddressUsed,
        _PGWRecord_tWANUserLocationInformation,
        _PGWRecord_retransmission,
        _PGWRecord_userLocationInfoTime,
        _PGWRecord_cNOperatorSelectionEnt,
        _PGWRecord_ePCQoSInformation,
        _PGWRecord_presenceReportingAreaInfo,
        _PGWRecord_lastUserLocationInformation,
        _PGWRecord_lastMSTimeZone,
        _PGWRecord_enhancedDiagnostics,
        _PGWRecord_nBIFOMMode,
        _PGWRecord_nBIFOMSupport,
        _PGWRecord_uWANUserLocationInformation,
        _PGWRecord_sGiPtPTunnellingMethod,
        _PGWRecord_uNIPDUCPOnlyFlag,
        _PGWRecord_servingPLMNRateControl,
        _PGWRecord_aPNRateControl,
        _PGWRecord_pDPPDNTypeExtension,
        _PGWRecord_mOExceptionDataCounter,
        _PGWRecord_chargingPerIPCANSessionIndicator,
        _PGWRecord_threeGPPPSDataOffStatus,
        _PGWRecord_sCSASAddress,
        __PGWRecord_listOfRANSecondaryRATUsageReports__item_,
        _PGWRecord_listOfRANSecondaryRATUsageReports,
        PGWRecord,
        _TDFRecord_recordType,
        _TDFRecord_servedIMSI,
        _TDFRecord_p_GWAddress,
        __TDFRecord_servingNodeAddress__item_,
        _TDFRecord_servingNodeAddress,
        _TDFRecord_accessPointNameNI,
        _TDFRecord_pdpPDNType,
        _TDFRecord_servedPDPPDNAddress,
        _TDFRecord_dynamicAddressFlag,
        _TDFRecord_recordOpeningTime,
        _TDFRecord_duration,
        _TDFRecord_causeForRecClosing,
        _TDFRecord_diagnostics,
        _TDFRecord_recordSequenceNumber,
        _TDFRecord_nodeID,
        _TDFRecord_recordExtensions,
        _TDFRecord_localSequenceNumber,
        _TDFRecord_apnSelectionMode,
        _TDFRecord_servedMSISDN,
        _TDFRecord_chargingCharacteristics,
        _TDFRecord_chChSelectionMode,
        _TDFRecord_servingNodePLMNIdentifier,
        _TDFRecord_pSFurnishChargingInformation,
        _TDFRecord_servedIMEI,
        _TDFRecord_rATType,
        _TDFRecord_mSTimeZone,
        _TDFRecord_userLocationInformation,
        __TDFRecord_listOfServiceData__item_,
        _TDFRecord_listOfServiceData,
        __TDFRecord_servingNodeType__item_,
        _TDFRecord_servingNodeType,
        _TDFRecord_servedMNNAI,
        _TDFRecord_p_GWPLMNIdentifier,
        _TDFRecord_startTime,
        _TDFRecord_stopTime,
        _TDFRecord_served3gpp2MEID,
        _TDFRecord_pDNConnectionChargingID,
        _TDFRecord_userCSGInformation,
        _TDFRecord_threeGPP2UserLocationInformation,
        _TDFRecord_servedPDPPDNAddressExt,
        _TDFRecord_dynamicAddressFlagExt,
        __TDFRecord_servingNodeiPv6Address__item_,
        _TDFRecord_servingNodeiPv6Address,
        _TDFRecord_p_GWiPv6AddressUsed,
        _TDFRecord_tWANUserLocationInformation,
        _TDFRecord_retransmission,
        _TDFRecord_tDFAddress,
        _TDFRecord_tDFiPv6AddressUsed,
        _TDFRecord_tDFPLMNIdentifier,
        _TDFRecord_servedFixedSubsID,
        _TDFRecord_accessLineIdentifier,
        _TDFRecord_fixedUserLocationInformation,
        TDFRecord,
        _IPERecord_recordType,
        _IPERecord_servedIMSI,
        _IPERecord_iPEdgeAddress,
        _IPERecord_chargingID,
        _IPERecord_accessPointNameNI,
        _IPERecord_iPCANsessionType,
        _IPERecord_servedIPCANsessionAddress,
        _IPERecord_dynamicAddressFlag,
        __IPERecord_listOfTrafficVolumes__item_,
        _IPERecord_listOfTrafficVolumes,
        _IPERecord_recordOpeningTime,
        _IPERecord_duration,
        _IPERecord_causeForRecClosing,
        _IPERecord_diagnostics,
        _IPERecord_recordSequenceNumber,
        _IPERecord_nodeID,
        _IPERecord_recordExtensions,
        _IPERecord_localSequenceNumber,
        _IPERecord_servedMSISDN,
        _IPERecord_chargingCharacteristics,
        _IPERecord_chChSelectionMode,
        _IPERecord_pSFurnishChargingInformation,
        _IPERecord_servedIMEI,
        __IPERecord_listOfServiceData__item_,
        _IPERecord_listOfServiceData,
        _IPERecord_servedMNNAI,
        _IPERecord_iPEdgeOperatorIdentifier,
        _IPERecord_startTime,
        _IPERecord_stopTime,
        _IPERecord_servedIPCANsessionAddressExt,
        _IPERecord_dynamicAddressFlagExt,
        _IPERecord_iPEdgeiPv6AddressUsed,
        _IPERecord_retransmission,
        _IPERecord_servedFixedSubsID,
        _IPERecord_accessLineIdentifier,
        _IPERecord_fixedUserLocationInformation,
        IPERecord,
        _EPDGRecord_recordType,
        _EPDGRecord_servedIMSI,
        _EPDGRecord_ePDGAddressUsed,
        _EPDGRecord_chargingID,
        _EPDGRecord_accessPointNameNI,
        _EPDGRecord_pdpPDNType,
        _EPDGRecord_servedPDPPDNAddress,
        _EPDGRecord_dynamicAddressFlag,
        __EPDGRecord_listOfTrafficVolumes__item_,
        _EPDGRecord_listOfTrafficVolumes,
        _EPDGRecord_recordOpeningTime,
        _EPDGRecord_duration,
        _EPDGRecord_causeForRecClosing,
        _EPDGRecord_diagnostics,
        _EPDGRecord_recordSequenceNumber,
        _EPDGRecord_nodeID,
        _EPDGRecord_recordExtensions,
        _EPDGRecord_localSequenceNumber,
        _EPDGRecord_apnSelectionMode,
        _EPDGRecord_servedMSISDN,
        _EPDGRecord_chargingCharacteristics,
        _EPDGRecord_chChSelectionMode,
        _EPDGRecord_iMSsignalingContext,
        _EPDGRecord_servedIMEI,
        _EPDGRecord_rATType,
        _EPDGRecord_sGWChange,
        _EPDGRecord_p_GWAddressUsed,
        _EPDGRecord_p_GWPLMNIdentifier,
        _EPDGRecord_startTime,
        _EPDGRecord_stopTime,
        _EPDGRecord_pDNConnectionChargingID,
        _EPDGRecord_servedPDPPDNAddressExt,
        _EPDGRecord_dynamicAddressFlagExt,
        _EPDGRecord_ePDGiPv6AddressUsed,
        _EPDGRecord_p_GWiPv6AddressUsed,
        _EPDGRecord_retransmission,
        _EPDGRecord_enhancedDiagnostics,
        _EPDGRecord_uWANUserLocationInformation,
        _EPDGRecord_userLocationInfoTime,
        _EPDGRecord_iMSIunauthenticatedFlag,
        EPDGRecord,
        _TWAGRecord_recordType,
        _TWAGRecord_servedIMSI,
        _TWAGRecord_tWAGAddressUsed,
        _TWAGRecord_chargingID,
        _TWAGRecord_accessPointNameNI,
        _TWAGRecord_pdpPDNType,
        _TWAGRecord_servedPDPPDNAddress,
        _TWAGRecord_dynamicAddressFlag,
        __TWAGRecord_listOfTrafficVolumes__item_,
        _TWAGRecord_listOfTrafficVolumes,
        _TWAGRecord_recordOpeningTime,
        _TWAGRecord_duration,
        _TWAGRecord_causeForRecClosing,
        _TWAGRecord_diagnostics,
        _TWAGRecord_recordSequenceNumber,
        _TWAGRecord_nodeID,
        _TWAGRecord_recordExtensions,
        _TWAGRecord_localSequenceNumber,
        _TWAGRecord_apnSelectionMode,
        _TWAGRecord_servedMSISDN,
        _TWAGRecord_chargingCharacteristics,
        _TWAGRecord_chChSelectionMode,
        _TWAGRecord_servedIMEI,
        _TWAGRecord_rATType,
        _TWAGRecord_sGWChange,
        _TWAGRecord_p_GWAddressUsed,
        _TWAGRecord_p_GWPLMNIdentifier,
        _TWAGRecord_startTime,
        _TWAGRecord_stopTime,
        _TWAGRecord_pDNConnectionChargingID,
        _TWAGRecord_servedPDPPDNAddressExt,
        _TWAGRecord_dynamicAddressFlagExt,
        _TWAGRecord_tWAGiPv6AddressUsed,
        _TWAGRecord_p_GWiPv6AddressUsed,
        _TWAGRecord_retransmission,
        _TWAGRecord_enhancedDiagnostics,
        _TWAGRecord_tWANUserLocationInformation,
        _TWAGRecord_iMSIunauthenticatedFlag,
        TWAGRecord,
        _SGSNMMRecord_recordType,
        _SGSNMMRecord_servedIMSI,
        _SGSNMMRecord_servedIMEI,
        _SGSNMMRecord_sgsnAddress,
        _SGSNMMRecord_msNetworkCapability,
        _SGSNMMRecord_routingArea,
        _SGSNMMRecord_locationAreaCode,
        _SGSNMMRecord_cellIdentifier,
        __SGSNMMRecord_changeLocation__item_,
        _SGSNMMRecord_changeLocation,
        _SGSNMMRecord_recordOpeningTime,
        _SGSNMMRecord_duration,
        _SGSNMMRecord_sgsnChange,
        _SGSNMMRecord_causeForRecClosing,
        _SGSNMMRecord_diagnostics,
        _SGSNMMRecord_recordSequenceNumber,
        _SGSNMMRecord_nodeID,
        _SGSNMMRecord_recordExtensions,
        _SGSNMMRecord_localSequenceNumber,
        _SGSNMMRecord_servedMSISDN,
        _SGSNMMRecord_chargingCharacteristics,
        _SGSNMMRecord_cAMELInformationMM,
        _SGSNMMRecord_rATType,
        _SGSNMMRecord_chChSelectionMode,
        _SGSNMMRecord_cellPLMNId,
        _SGSNMMRecord_servingNodePLMNIdentifier,
        _SGSNMMRecord_cNOperatorSelectionEnt,
        SGSNMMRecord,
        _SGSNPDPRecord_recordType,
        _SGSNPDPRecord_networkInitiation,
        _SGSNPDPRecord_servedIMSI,
        _SGSNPDPRecord_servedIMEI,
        _SGSNPDPRecord_sgsnAddress,
        _SGSNPDPRecord_msNetworkCapability,
        _SGSNPDPRecord_routingArea,
        _SGSNPDPRecord_locationAreaCode,
        _SGSNPDPRecord_cellIdentifier,
        _SGSNPDPRecord_chargingID,
        _SGSNPDPRecord_ggsnAddressUsed,
        _SGSNPDPRecord_accessPointNameNI,
        _SGSNPDPRecord_pdpType,
        _SGSNPDPRecord_servedPDPAddress,
        __SGSNPDPRecord_listOfTrafficVolumes__item_,
        _SGSNPDPRecord_listOfTrafficVolumes,
        _SGSNPDPRecord_recordOpeningTime,
        _SGSNPDPRecord_duration,
        _SGSNPDPRecord_sgsnChange,
        _SGSNPDPRecord_causeForRecClosing,
        _SGSNPDPRecord_diagnostics,
        _SGSNPDPRecord_recordSequenceNumber,
        _SGSNPDPRecord_nodeID,
        _SGSNPDPRecord_recordExtensions,
        _SGSNPDPRecord_localSequenceNumber,
        _SGSNPDPRecord_apnSelectionMode,
        _SGSNPDPRecord_accessPointNameOI,
        _SGSNPDPRecord_servedMSISDN,
        _SGSNPDPRecord_chargingCharacteristics,
        _SGSNPDPRecord_rATType,
        _SGSNPDPRecord_cAMELInformationPDP,
        _SGSNPDPRecord_rNCUnsentDownlinkVolume,
        _SGSNPDPRecord_chChSelectionMode,
        _SGSNPDPRecord_dynamicAddressFlag,
        _SGSNPDPRecord_iMSIunauthenticatedFlag,
        _SGSNPDPRecord_userCSGInformation,
        _SGSNPDPRecord_servedPDPPDNAddressExt,
        _SGSNPDPRecord_lowPriorityIndicator,
        _SGSNPDPRecord_servingNodePLMNIdentifier,
        _SGSNPDPRecord_cNOperatorSelectionEnt,
        SGSNPDPRecord,
        _SGSNSMORecord_recordType,
        _SGSNSMORecord_servedIMSI,
        _SGSNSMORecord_servedIMEI,
        _SGSNSMORecord_servedMSISDN,
        _SGSNSMORecord_msNetworkCapability,
        _SGSNSMORecord_serviceCentre,
        _SGSNSMORecord_recordingEntity,
        _SGSNSMORecord_locationArea,
        _SGSNSMORecord_routingArea,
        _SGSNSMORecord_cellIdentifier,
        _SGSNSMORecord_messageReference,
        _SGSNSMORecord_eventTimeStamp,
        _SGSNSMORecord_smsResult,
        _SGSNSMORecord_recordExtensions,
        _SGSNSMORecord_nodeID,
        _SGSNSMORecord_localSequenceNumber,
        _SGSNSMORecord_chargingCharacteristics,
        _SGSNSMORecord_rATType,
        _SGSNSMORecord_destinationNumber,
        _SGSNSMORecord_cAMELInformationSMS,
        _SGSNSMORecord_chChSelectionMode,
        _SGSNSMORecord_servingNodeType,
        _SGSNSMORecord_servingNodeAddress,
        _SGSNSMORecord_servingNodeiPv6Address,
        _SGSNSMORecord_mMEName,
        _SGSNSMORecord_mMERealm,
        _SGSNSMORecord_userLocationInformation,
        _SGSNSMORecord_retransmission,
        _SGSNSMORecord_servingNodePLMNIdentifier,
        _SGSNSMORecord_userLocationInfoTime,
        _SGSNSMORecord_cNOperatorSelectionEnt,
        SGSNSMORecord,
        _SGSNSMTRecord_recordType,
        _SGSNSMTRecord_servedIMSI,
        _SGSNSMTRecord_servedIMEI,
        _SGSNSMTRecord_servedMSISDN,
        _SGSNSMTRecord_msNetworkCapability,
        _SGSNSMTRecord_serviceCentre,
        _SGSNSMTRecord_recordingEntity,
        _SGSNSMTRecord_locationArea,
        _SGSNSMTRecord_routingArea,
        _SGSNSMTRecord_cellIdentifier,
        _SGSNSMTRecord_eventTimeStamp,
        _SGSNSMTRecord_smsResult,
        _SGSNSMTRecord_recordExtensions,
        _SGSNSMTRecord_nodeID,
        _SGSNSMTRecord_localSequenceNumber,
        _SGSNSMTRecord_chargingCharacteristics,
        _SGSNSMTRecord_rATType,
        _SGSNSMTRecord_chChSelectionMode,
        _SGSNSMTRecord_cAMELInformationSMS,
        _SGSNSMTRecord_originatingAddress,
        _SGSNSMTRecord_servingNodeType,
        _SGSNSMTRecord_servingNodeAddress,
        _SGSNSMTRecord_servingNodeiPv6Address,
        _SGSNSMTRecord_mMEName,
        _SGSNSMTRecord_mMERealm,
        _SGSNSMTRecord_userLocationInformation,
        _SGSNSMTRecord_retransmission,
        _SGSNSMTRecord_servingNodePLMNIdentifier,
        _SGSNSMTRecord_userLocationInfoTime,
        _SGSNSMTRecord_cNOperatorSelectionEnt,
        SGSNSMTRecord,
        _SGSNMTLCSRecord_recordType,
        _SGSNMTLCSRecord_recordingEntity,
        _SGSNMTLCSRecord_lcsClientType,
        _SGSNMTLCSRecord_lcsClientIdentity,
        _SGSNMTLCSRecord_servedIMSI,
        _SGSNMTLCSRecord_servedMSISDN,
        _SGSNMTLCSRecord_sgsnAddress,
        _SGSNMTLCSRecord_locationType,
        _SGSNMTLCSRecord_lcsQos,
        _SGSNMTLCSRecord_lcsPriority,
        _SGSNMTLCSRecord_mlcNumber,
        _SGSNMTLCSRecord_eventTimeStamp,
        _SGSNMTLCSRecord_measurementDuration,
        _SGSNMTLCSRecord_notificationToMSUser,
        _SGSNMTLCSRecord_privacyOverride,
        _SGSNMTLCSRecord_location,
        _SGSNMTLCSRecord_routingArea,
        _SGSNMTLCSRecord_locationEstimate,
        _SGSNMTLCSRecord_positioningData,
        _SGSNMTLCSRecord_lcsCause,
        _SGSNMTLCSRecord_diagnostics,
        _SGSNMTLCSRecord_nodeID,
        _SGSNMTLCSRecord_localSequenceNumber,
        _SGSNMTLCSRecord_chargingCharacteristics,
        _SGSNMTLCSRecord_chChSelectionMode,
        _SGSNMTLCSRecord_rATType,
        _SGSNMTLCSRecord_recordExtensions,
        _SGSNMTLCSRecord_causeForRecClosing,
        _SGSNMTLCSRecord_servingNodePLMNIdentifier,
        _SGSNMTLCSRecord_cNOperatorSelectionEnt,
        SGSNMTLCSRecord,
        _SGSNMOLCSRecord_recordType,
        _SGSNMOLCSRecord_recordingEntity,
        _SGSNMOLCSRecord_lcsClientType,
        _SGSNMOLCSRecord_lcsClientIdentity,
        _SGSNMOLCSRecord_servedIMSI,
        _SGSNMOLCSRecord_servedMSISDN,
        _SGSNMOLCSRecord_sgsnAddress,
        _SGSNMOLCSRecord_locationMethod,
        _SGSNMOLCSRecord_lcsQos,
        _SGSNMOLCSRecord_lcsPriority,
        _SGSNMOLCSRecord_mlcNumber,
        _SGSNMOLCSRecord_eventTimeStamp,
        _SGSNMOLCSRecord_measurementDuration,
        _SGSNMOLCSRecord_location,
        _SGSNMOLCSRecord_routingArea,
        _SGSNMOLCSRecord_locationEstimate,
        _SGSNMOLCSRecord_positioningData,
        _SGSNMOLCSRecord_lcsCause,
        _SGSNMOLCSRecord_diagnostics,
        _SGSNMOLCSRecord_nodeID,
        _SGSNMOLCSRecord_localSequenceNumber,
        _SGSNMOLCSRecord_chargingCharacteristics,
        _SGSNMOLCSRecord_chChSelectionMode,
        _SGSNMOLCSRecord_rATType,
        _SGSNMOLCSRecord_recordExtensions,
        _SGSNMOLCSRecord_causeForRecClosing,
        _SGSNMOLCSRecord_servingNodePLMNIdentifier,
        _SGSNMOLCSRecord_cNOperatorSelectionEnt,
        SGSNMOLCSRecord,
        _SGSNNILCSRecord_recordType,
        _SGSNNILCSRecord_recordingEntity,
        _SGSNNILCSRecord_lcsClientType,
        _SGSNNILCSRecord_lcsClientIdentity,
        _SGSNNILCSRecord_servedIMSI,
        _SGSNNILCSRecord_servedMSISDN,
        _SGSNNILCSRecord_sgsnAddress,
        _SGSNNILCSRecord_servedIMEI,
        _SGSNNILCSRecord_lcsQos,
        _SGSNNILCSRecord_lcsPriority,
        _SGSNNILCSRecord_mlcNumber,
        _SGSNNILCSRecord_eventTimeStamp,
        _SGSNNILCSRecord_measurementDuration,
        _SGSNNILCSRecord_location,
        _SGSNNILCSRecord_routingArea,
        _SGSNNILCSRecord_locationEstimate,
        _SGSNNILCSRecord_positioningData,
        _SGSNNILCSRecord_lcsCause,
        _SGSNNILCSRecord_diagnostics,
        _SGSNNILCSRecord_nodeID,
        _SGSNNILCSRecord_localSequenceNumber,
        _SGSNNILCSRecord_chargingCharacteristics,
        _SGSNNILCSRecord_chChSelectionMode,
        _SGSNNILCSRecord_rATType,
        _SGSNNILCSRecord_recordExtensions,
        _SGSNNILCSRecord_causeForRecClosing,
        _SGSNNILCSRecord_servingNodePLMNIdentifier,
        _SGSNNILCSRecord_cNOperatorSelectionEnt,
        SGSNNILCSRecord,
        _SGSNMBMSRecord_recordType,
        _SGSNMBMSRecord_ggsnAddress,
        _SGSNMBMSRecord_chargingID,
        __SGSNMBMSRecord_listofRAs__item_,
        _SGSNMBMSRecord_listofRAs,
        _SGSNMBMSRecord_accessPointNameNI,
        _SGSNMBMSRecord_servedPDPAddress,
        __SGSNMBMSRecord_listOfTrafficVolumes__item_,
        _SGSNMBMSRecord_listOfTrafficVolumes,
        _SGSNMBMSRecord_recordOpeningTime,
        _SGSNMBMSRecord_duration,
        _SGSNMBMSRecord_causeForRecClosing,
        _SGSNMBMSRecord_diagnostics,
        _SGSNMBMSRecord_recordSequenceNumber,
        _SGSNMBMSRecord_nodeID,
        _SGSNMBMSRecord_recordExtensions,
        _SGSNMBMSRecord_localSequenceNumber,
        _SGSNMBMSRecord_sgsnPLMNIdentifier,
        _SGSNMBMSRecord_numberofReceivingUE,
        _SGSNMBMSRecord_mbmsInformation,
        SGSNMBMSRecord,
        _GGSNMBMSRecord_recordType,
        _GGSNMBMSRecord_ggsnAddress,
        _GGSNMBMSRecord_chargingID,
        __GGSNMBMSRecord_listofDownstreamNodes__item_,
        _GGSNMBMSRecord_listofDownstreamNodes,
        _GGSNMBMSRecord_accessPointNameNI,
        _GGSNMBMSRecord_servedPDPAddress,
        __GGSNMBMSRecord_listOfTrafficVolumes__item_,
        _GGSNMBMSRecord_listOfTrafficVolumes,
        _GGSNMBMSRecord_recordOpeningTime,
        _GGSNMBMSRecord_duration,
        _GGSNMBMSRecord_causeForRecClosing,
        _GGSNMBMSRecord_diagnostics,
        _GGSNMBMSRecord_recordSequenceNumber,
        _GGSNMBMSRecord_nodeID,
        _GGSNMBMSRecord_recordExtensions,
        _GGSNMBMSRecord_localSequenceNumber,
        _GGSNMBMSRecord_mbmsInformation,
        GGSNMBMSRecord,
        _GWMBMSRecord_recordType,
        _GWMBMSRecord_mbmsGWAddress,
        _GWMBMSRecord_chargingID,
        __GWMBMSRecord_listofDownstreamNodes__item_,
        _GWMBMSRecord_listofDownstreamNodes,
        _GWMBMSRecord_accessPointNameNI,
        _GWMBMSRecord_pdpPDNType,
        _GWMBMSRecord_servedPDPPDNAddress,
        __GWMBMSRecord_listOfTrafficVolumes__item_,
        _GWMBMSRecord_listOfTrafficVolumes,
        _GWMBMSRecord_recordOpeningTime,
        _GWMBMSRecord_duration,
        _GWMBMSRecord_causeForRecClosing,
        _GWMBMSRecord_diagnostics,
        _GWMBMSRecord_recordSequenceNumber,
        _GWMBMSRecord_nodeID,
        _GWMBMSRecord_recordExtensions,
        _GWMBMSRecord_localSequenceNumber,
        _GWMBMSRecord_mbmsInformation,
        _GWMBMSRecord_commonTeid,
        _GWMBMSRecord_iPMulticastSourceAddress,
        GWMBMSRecord,
        AccessAvailabilityChangeReason,
        _AccessLineIdentifier_physicalAccessID,
        _AccessLineIdentifier_logicalAccessID,
        AccessLineIdentifier,
        AccessPointNameNI,
        AccessPointNameOI,
        ADCRuleBaseName,
        AdditionalExceptionReports,
        AFChargingIdentifier,
        _AFRecordInformation_aFChargingIdentifier,
        _AFRecordInformation_flows,
        AFRecordInformation,
        _APNRateControl_aPNRateControlUplink,
        _APNRateControl_aPNRateControlDownlink,
        APNRateControl,
        _APNRateControlParameters_additionalExceptionReports,
        _APNRateControlParameters_rateControlTimeUnit,
        _APNRateControlParameters_rateControlMaxRate,
        _APNRateControlParameters_rateControlMaxMessageSize,
        APNRateControlParameters,
        APNSelectionMode,
        _CalleePartyInformation_called_Party_Address,
        _CalleePartyInformation_requested_Party_Address,
        __CalleePartyInformation_list_Of_Called_Asserted_Identity__item_,
        _CalleePartyInformation_list_Of_Called_Asserted_Identity,
        CalleePartyInformation,
        CAMELAccessPointNameNI,
        CAMELAccessPointNameOI,
        _CAMELInformationMM_sCFAddress,
        _CAMELInformationMM_serviceKey,
        _CAMELInformationMM_defaultTransactionHandling,
        _CAMELInformationMM_numberOfDPEncountered,
        _CAMELInformationMM_levelOfCAMELService,
        _CAMELInformationMM_freeFormatData,
        _CAMELInformationMM_fFDAppendIndicator,
        CAMELInformationMM,
        _CAMELInformationPDP_sCFAddress,
        _CAMELInformationPDP_serviceKey,
        _CAMELInformationPDP_defaultTransactionHandling,
        _CAMELInformationPDP_cAMELAccessPointNameNI,
        _CAMELInformationPDP_cAMELAccessPointNameOI,
        _CAMELInformationPDP_numberOfDPEncountered,
        _CAMELInformationPDP_levelOfCAMELService,
        _CAMELInformationPDP_freeFormatData,
        _CAMELInformationPDP_fFDAppendIndicator,
        CAMELInformationPDP,
        _CAMELInformationSMS_sCFAddress,
        _CAMELInformationSMS_serviceKey,
        _CAMELInformationSMS_defaultSMSHandling,
        _CAMELInformationSMS_cAMELCallingPartyNumber,
        _CAMELInformationSMS_cAMELDestinationSubscriberNumber,
        _CAMELInformationSMS_cAMELSMSCAddress,
        _CAMELInformationSMS_freeFormatData,
        _CAMELInformationSMS_smsReferenceNumber,
        CAMELInformationSMS,
        ChangeCondition,
        _ChangeOfCharCondition_qosRequested,
        _ChangeOfCharCondition_qosNegotiated,
        _ChangeOfCharCondition_dataVolumeGPRSUplink,
        _ChangeOfCharCondition_dataVolumeGPRSDownlink,
        _ChangeOfCharCondition_changeCondition,
        _ChangeOfCharCondition_changeTime,
        _ChangeOfCharCondition_userLocationInformation,
        _ChangeOfCharCondition_ePCQoSInformation,
        _ChangeOfCharCondition_chargingID,
        _ChangeOfCharCondition_presenceReportingAreaStatus,
        _ChangeOfCharCondition_userCSGInformation,
        _ChangeOfCharCondition_diagnostics,
        _ChangeOfCharCondition_enhancedDiagnostics,
        _ChangeOfCharCondition_rATType,
        _ChangeOfCharCondition_accessAvailabilityChangeReason,
        _ChangeOfCharCondition_uWANUserLocationInformation,
        _ChangeOfCharCondition_relatedChangeOfCharCondition,
        _ChangeOfCharCondition_cPCIoTEPSOptimisationIndicator,
        _ChangeOfCharCondition_servingPLMNRateControl,
        _ChangeOfCharCondition_threeGPPPSDataOffStatus,
        __ChangeOfCharCondition_listOfPresenceReportingAreaInformation__item_,
        _ChangeOfCharCondition_listOfPresenceReportingAreaInformation,
        _ChangeOfCharCondition_aPNRateControl,
        ChangeOfCharCondition,
        _ChangeOfMBMSCondition_qosRequested,
        _ChangeOfMBMSCondition_qosNegotiated,
        _ChangeOfMBMSCondition_dataVolumeMBMSUplink,
        _ChangeOfMBMSCondition_dataVolumeMBMSDownlink,
        _ChangeOfMBMSCondition_changeCondition,
        _ChangeOfMBMSCondition_changeTime,
        _ChangeOfMBMSCondition_failureHandlingContinue,
        ChangeOfMBMSCondition,
        _ChangeOfServiceCondition_ratingGroup,
        _ChangeOfServiceCondition_chargingRuleBaseName,
        _ChangeOfServiceCondition_resultCode,
        _ChangeOfServiceCondition_localSequenceNumber,
        _ChangeOfServiceCondition_timeOfFirstUsage,
        _ChangeOfServiceCondition_timeOfLastUsage,
        _ChangeOfServiceCondition_timeUsage,
        _ChangeOfServiceCondition_serviceConditionChange,
        _ChangeOfServiceCondition_qoSInformationNeg,
        _ChangeOfServiceCondition_servingNodeAddress,
        _ChangeOfServiceCondition_datavolumeFBCUplink,
        _ChangeOfServiceCondition_datavolumeFBCDownlink,
        _ChangeOfServiceCondition_timeOfReport,
        _ChangeOfServiceCondition_failureHandlingContinue,
        _ChangeOfServiceCondition_serviceIdentifier,
        _ChangeOfServiceCondition_pSFurnishChargingInformation,
        __ChangeOfServiceCondition_aFRecordInformation__item_,
        _ChangeOfServiceCondition_aFRecordInformation,
        _ChangeOfServiceCondition_userLocationInformation,
        _ChangeOfServiceCondition_eventBasedChargingInformation,
        _ChangeOfServiceCondition_timeQuotaMechanism,
        __ChangeOfServiceCondition_serviceSpecificInfo__item_,
        _ChangeOfServiceCondition_serviceSpecificInfo,
        _ChangeOfServiceCondition_threeGPP2UserLocationInformation,
        _ChangeOfServiceCondition_sponsorIdentity,
        _ChangeOfServiceCondition_applicationServiceProviderIdentity,
        _ChangeOfServiceCondition_aDCRuleBaseName,
        _ChangeOfServiceCondition_presenceReportingAreaStatus,
        _ChangeOfServiceCondition_userCSGInformation,
        _ChangeOfServiceCondition_rATType,
        _ChangeOfServiceCondition_uWANUserLocationInformation,
        _ChangeOfServiceCondition_relatedChangeOfServiceCondition,
        _ChangeOfServiceCondition_servingPLMNRateControl,
        _ChangeOfServiceCondition_aPNRateControl,
        _ChangeOfServiceCondition_threeGPPPSDataOffStatus,
        _ChangeOfServiceCondition_trafficSteeringPolicyIDDownlink,
        _ChangeOfServiceCondition_trafficSteeringPolicyIDUplink,
        _ChangeOfServiceCondition_tWANUserLocationInformation,
        __ChangeOfServiceCondition_listOfPresenceReportingAreaInformation__item_,
        _ChangeOfServiceCondition_listOfPresenceReportingAreaInformation,
        _ChangeOfServiceCondition_voLTEInformation,
        ChangeOfServiceCondition,
        _ChangeLocation_locationAreaCode,
        _ChangeLocation_routingAreaCode,
        _ChangeLocation_cellId,
        _ChangeLocation_changeTime,
        _ChangeLocation_mCC_MNC,
        ChangeLocation,
        ChargingCharacteristics,
        ChargingPerIPCANSessionIndicator,
        ChargingRuleBaseName,
        ChChSelectionMode,
        CNOperatorSelectionEntity,
        CPCIoTEPSOptimisationIndicator,
        CSGAccessMode,
        CSGId,
        CTEID,
        DataVolumeGPRS,
        DataVolumeMBMS,
        _EPCQoSInformation_qCI,
        _EPCQoSInformation_maxRequestedBandwithUL,
        _EPCQoSInformation_maxRequestedBandwithDL,
        _EPCQoSInformation_guaranteedBitrateUL,
        _EPCQoSInformation_guaranteedBitrateDL,
        _EPCQoSInformation_aRP,
        _EPCQoSInformation_aPNAggregateMaxBitrateUL,
        _EPCQoSInformation_aPNAggregateMaxBitrateDL,
        _EPCQoSInformation_extendedMaxRequestedBWUL,
        _EPCQoSInformation_extendedMaxRequestedBWDL,
        _EPCQoSInformation_extendedGBRUL,
        _EPCQoSInformation_extendedGBRDL,
        _EPCQoSInformation_extendedAPNAMBRUL,
        _EPCQoSInformation_extendedAPNAMBRDL,
        EPCQoSInformation,
        _EventBasedChargingInformation_numberOfEvents,
        __EventBasedChargingInformation_eventTimeStamps__item_,
        _EventBasedChargingInformation_eventTimeStamps,
        EventBasedChargingInformation,
        FailureHandlingContinue,
        FFDAppendIndicator,
        FixedSubsID,
        _FixedUserLocationInformation_sSID,
        _FixedUserLocationInformation_bSSID,
        _FixedUserLocationInformation_accessLineIdentifier,
        FixedUserLocationInformation,
        _Flows_mediaComponentNumber,
        __Flows_flowNumber__item_,
        _Flows_flowNumber,
        Flows,
        FreeFormatData,
        _MOExceptionDataCounter_counterValue,
        _MOExceptionDataCounter_counterTimestamp,
        MOExceptionDataCounter,
        MSNetworkCapability,
        NBIFOMMode,
        NBIFOMSupport,
        NetworkInitiatedPDPContext,
        NumberOfDPEncountered,
        PDPType,
        PDPPDNTypeExtension,
        PresenceReportingAreaElementsList,
        _PresenceReportingAreaInfo_presenceReportingAreaIdentifier,
        _PresenceReportingAreaInfo_presenceReportingAreaStatus,
        _PresenceReportingAreaInfo_presenceReportingAreaElementsList,
        _PresenceReportingAreaInfo_presenceReportingAreaNode,
        PresenceReportingAreaInfo,
        PresenceReportingAreaNode,
        PresenceReportingAreaStatus,
        _PSFurnishChargingInformation_pSFreeFormatData,
        _PSFurnishChargingInformation_pSFFDAppendIndicator,
        PSFurnishChargingInformation,
        QoSInformation,
        _RANSecondaryRATUsageReport_dataVolumeUplink,
        _RANSecondaryRATUsageReport_dataVolumeDownlink,
        _RANSecondaryRATUsageReport_rANStartTime,
        _RANSecondaryRATUsageReport_rANEndTime,
        _RANSecondaryRATUsageReport_secondaryRATType,
        _RANSecondaryRATUsageReport_chargingID,
        RANSecondaryRATUsageReport,
        RateControlTimeUnit,
        RatingGroupId,
        _RelatedChangeOfCharCondition_changeCondition,
        _RelatedChangeOfCharCondition_changeTime,
        _RelatedChangeOfCharCondition_userLocationInformation,
        _RelatedChangeOfCharCondition_presenceReportingAreaStatus,
        _RelatedChangeOfCharCondition_userCSGInformation,
        _RelatedChangeOfCharCondition_rATType,
        _RelatedChangeOfCharCondition_uWANUserLocationInformation,
        RelatedChangeOfCharCondition,
        _RelatedChangeOfServiceCondition_userLocationInformation,
        _RelatedChangeOfServiceCondition_threeGPP2UserLocationInformation,
        _RelatedChangeOfServiceCondition_presenceReportingAreaStatus,
        _RelatedChangeOfServiceCondition_userCSGInformation,
        _RelatedChangeOfServiceCondition_rATType,
        _RelatedChangeOfServiceCondition_uWANUserLocationInformation,
        _RelatedChangeOfServiceCondition_relatedServiceConditionChange,
        RelatedChangeOfServiceCondition,
        ResultCode,
        SecondaryRATType,
        ServiceConditionChange,
        SCFAddress,
        ServiceIdentifier,
        ServingNodeType,
        _ServingPLMNRateControl_sPLMNDLRateControlValue,
        _ServingPLMNRateControl_sPLMNULRateControlValue,
        ServingPLMNRateControl,
        SGiPtPTunnellingMethod,
        SGSNChange,
        SGWChange,
        _TimeQuotaMechanism_timeQuotaType,
        _TimeQuotaMechanism_baseTimeInterval,
        TimeQuotaMechanism,
        TimeQuotaType,
        TrafficSteeringPolicyIDDownlink,
        TrafficSteeringPolicyIDUplink,
        _TWANUserLocationInfo_sSID,
        _TWANUserLocationInfo_bSSID,
        _TWANUserLocationInfo_civicAddressInformation,
        _TWANUserLocationInfo_wLANOperatorId,
        _TWANUserLocationInfo_logicalAccessID,
        TWANUserLocationInfo,
        UNIPDUCPOnlyFlag,
        _UserCSGInformation_cSGId,
        _UserCSGInformation_cSGAccessMode,
        _UserCSGInformation_cSGMembershipIndication,
        UserCSGInformation,
        _UWANUserLocationInfo_uELocalIPAddress,
        _UWANUserLocationInfo_uDPSourcePort,
        _UWANUserLocationInfo_sSID,
        _UWANUserLocationInfo_bSSID,
        _UWANUserLocationInfo_tCPSourcePort,
        _UWANUserLocationInfo_civicAddressInformation,
        _UWANUserLocationInfo_wLANOperatorId,
        _UWANUserLocationInfo_logicalAccessID,
        UWANUserLocationInfo,
        __VoLTEInformation_callerInformation__item_,
        _VoLTEInformation_callerInformation,
        _VoLTEInformation_calleeInformation,
        VoLTEInformation,
        _WLANOperatorId_wLANOperatorName,
        _WLANOperatorId_wLANPLMNId,
        WLANOperatorId,
    ]

class HierarchicalOperationalBindings:

    _name_  = u'HierarchicalOperationalBindings'
    _oid_   = [2, 5, 1, 20, 8]
    
    _obj_ = [
        u'HierarchicalAgreement',
        u'SuperiorToSubordinate',
        u'DITcontext',
        u'Vertex',
        u'SubentryInfo',
        u'SubordinateToSuperior',
        u'SuperiorToSubordinateModification',
        u'NonSpecificHierarchicalAgreement',
        u'NHOBSuperiorToSubordinate',
        u'NHOBSubordinateToSuperior',
        u'hierarchicalOperationalBinding',
        u'nonSpecificHierarchicalOperationalBinding',
        ]
    _type_ = [
        u'HierarchicalAgreement',
        u'SuperiorToSubordinate',
        u'DITcontext',
        u'Vertex',
        u'SubentryInfo',
        u'SubordinateToSuperior',
        u'SuperiorToSubordinateModification',
        u'NonSpecificHierarchicalAgreement',
        u'NHOBSuperiorToSubordinate',
        u'NHOBSubordinateToSuperior',
        ]
    _set_ = [
        ]
    _val_ = [
        u'hierarchicalOperationalBinding',
        u'nonSpecificHierarchicalOperationalBinding',
        ]
    _class_ = [
        u'hierarchicalOperationalBinding',
        u'nonSpecificHierarchicalOperationalBinding',
        ]
    _param_ = [
        ]
    
    #-----< HierarchicalAgreement >-----#
    HierarchicalAgreement = SEQ(name=u'HierarchicalAgreement', mode=MODE_TYPE)
    _HierarchicalAgreement_rdn = SET_OF(name=u'rdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _HierarchicalAgreement_immediateSuperior = SEQ_OF(name=u'immediateSuperior', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    HierarchicalAgreement._cont = ASN1Dict([
        (u'rdn', _HierarchicalAgreement_rdn),
        (u'immediateSuperior', _HierarchicalAgreement_immediateSuperior),
        ])
    HierarchicalAgreement._ext = []
    
    #-----< SuperiorToSubordinate >-----#
    SuperiorToSubordinate = SEQ(name=u'SuperiorToSubordinate', mode=MODE_TYPE)
    _SuperiorToSubordinate_contextPrefixInfo = SEQ_OF(name=u'contextPrefixInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('HierarchicalOperationalBindings', 'DITcontext')))
    _SuperiorToSubordinate_entryInfo = SET_OF(name=u'entryInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SuperiorToSubordinate_entryInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SuperiorToSubordinate_entryInfo__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____SuperiorToSubordinate_entryInfo__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SuperiorToSubordinate_entryInfo__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SuperiorToSubordinate_entryInfo__item__type._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    ___SuperiorToSubordinate_entryInfo__item__type._const_tab_at = None
    ___SuperiorToSubordinate_entryInfo__item__type._const_tab_id = u'id'
    ___SuperiorToSubordinate_entryInfo__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____SuperiorToSubordinate_entryInfo__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____SuperiorToSubordinate_entryInfo__item__values__item_._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    ____SuperiorToSubordinate_entryInfo__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____SuperiorToSubordinate_entryInfo__item__values__item_._const_tab_id = u'Type'
    ___SuperiorToSubordinate_entryInfo__item__values._cont = ____SuperiorToSubordinate_entryInfo__item__values__item_
    ___SuperiorToSubordinate_entryInfo__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SuperiorToSubordinate_entryInfo__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList._cont = ______SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList__item_
    _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value),
        (u'contextList', _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList),
        ])
    ____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item_._ext = []
    ___SuperiorToSubordinate_entryInfo__item__valuesWithContext._cont = ____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item_
    ___SuperiorToSubordinate_entryInfo__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SuperiorToSubordinate_entryInfo__item_._cont = ASN1Dict([
        (u'type', ___SuperiorToSubordinate_entryInfo__item__type),
        (u'values', ___SuperiorToSubordinate_entryInfo__item__values),
        (u'valuesWithContext', ___SuperiorToSubordinate_entryInfo__item__valuesWithContext),
        ])
    __SuperiorToSubordinate_entryInfo__item_._ext = []
    _SuperiorToSubordinate_entryInfo._cont = __SuperiorToSubordinate_entryInfo__item_
    _SuperiorToSubordinate_entryInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SuperiorToSubordinate_immediateSuperiorInfo = SET_OF(name=u'immediateSuperiorInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SuperiorToSubordinate_immediateSuperiorInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__type._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__type._const_tab_at = None
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__type._const_tab_id = u'id'
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_._const_tab_id = u'Type'
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__values._cont = ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value._const_tab = ____SuperiorToSubordinate_entryInfo__item__type_tab
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList._cont = ______SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList__item_
    _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value),
        (u'contextList', _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList),
        ])
    ____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item_._ext = []
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext._cont = ____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item_
    ___SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SuperiorToSubordinate_immediateSuperiorInfo__item_._cont = ASN1Dict([
        (u'type', ___SuperiorToSubordinate_immediateSuperiorInfo__item__type),
        (u'values', ___SuperiorToSubordinate_immediateSuperiorInfo__item__values),
        (u'valuesWithContext', ___SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext),
        ])
    __SuperiorToSubordinate_immediateSuperiorInfo__item_._ext = []
    _SuperiorToSubordinate_immediateSuperiorInfo._cont = __SuperiorToSubordinate_immediateSuperiorInfo__item_
    _SuperiorToSubordinate_immediateSuperiorInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    SuperiorToSubordinate._cont = ASN1Dict([
        (u'contextPrefixInfo', _SuperiorToSubordinate_contextPrefixInfo),
        (u'entryInfo', _SuperiorToSubordinate_entryInfo),
        (u'immediateSuperiorInfo', _SuperiorToSubordinate_immediateSuperiorInfo),
        ])
    SuperiorToSubordinate._ext = []
    
    #-----< DITcontext >-----#
    DITcontext = SEQ_OF(name=u'DITcontext', mode=MODE_TYPE)
    _DITcontext__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'Vertex')))
    DITcontext._cont = _DITcontext__item_
    
    #-----< Vertex >-----#
    Vertex = SEQ(name=u'Vertex', mode=MODE_TYPE)
    _Vertex_rdn = SET_OF(name=u'rdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _Vertex_admPointInfo = SET_OF(name=u'admPointInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Vertex_admPointInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___Vertex_admPointInfo__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____Vertex_admPointInfo__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____Vertex_admPointInfo__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____Vertex_admPointInfo__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____Vertex_admPointInfo__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____Vertex_admPointInfo__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____Vertex_admPointInfo__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___Vertex_admPointInfo__item__type._const_tab = ____Vertex_admPointInfo__item__type_tab
    ___Vertex_admPointInfo__item__type._const_tab_at = None
    ___Vertex_admPointInfo__item__type._const_tab_id = u'id'
    ___Vertex_admPointInfo__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____Vertex_admPointInfo__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____Vertex_admPointInfo__item__values__item_._const_tab = ____Vertex_admPointInfo__item__type_tab
    ____Vertex_admPointInfo__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____Vertex_admPointInfo__item__values__item_._const_tab_id = u'Type'
    ___Vertex_admPointInfo__item__values._cont = ____Vertex_admPointInfo__item__values__item_
    ___Vertex_admPointInfo__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___Vertex_admPointInfo__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____Vertex_admPointInfo__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____Vertex_admPointInfo__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____Vertex_admPointInfo__item__valuesWithContext__item__value._const_tab = ____Vertex_admPointInfo__item__type_tab
    _____Vertex_admPointInfo__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____Vertex_admPointInfo__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____Vertex_admPointInfo__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______Vertex_admPointInfo__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____Vertex_admPointInfo__item__valuesWithContext__item__contextList._cont = ______Vertex_admPointInfo__item__valuesWithContext__item__contextList__item_
    _____Vertex_admPointInfo__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____Vertex_admPointInfo__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____Vertex_admPointInfo__item__valuesWithContext__item__value),
        (u'contextList', _____Vertex_admPointInfo__item__valuesWithContext__item__contextList),
        ])
    ____Vertex_admPointInfo__item__valuesWithContext__item_._ext = []
    ___Vertex_admPointInfo__item__valuesWithContext._cont = ____Vertex_admPointInfo__item__valuesWithContext__item_
    ___Vertex_admPointInfo__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __Vertex_admPointInfo__item_._cont = ASN1Dict([
        (u'type', ___Vertex_admPointInfo__item__type),
        (u'values', ___Vertex_admPointInfo__item__values),
        (u'valuesWithContext', ___Vertex_admPointInfo__item__valuesWithContext),
        ])
    __Vertex_admPointInfo__item_._ext = []
    _Vertex_admPointInfo._cont = __Vertex_admPointInfo__item_
    _Vertex_admPointInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Vertex_subentries = SET_OF(name=u'subentries', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Vertex_subentries__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubentryInfo')))
    _Vertex_subentries._cont = __Vertex_subentries__item_
    _Vertex_subentries._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Vertex_accessPoints = SET_OF(name=u'accessPoints', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')), opt=True)
    Vertex._cont = ASN1Dict([
        (u'rdn', _Vertex_rdn),
        (u'admPointInfo', _Vertex_admPointInfo),
        (u'subentries', _Vertex_subentries),
        (u'accessPoints', _Vertex_accessPoints),
        ])
    Vertex._ext = []
    
    #-----< SubentryInfo >-----#
    SubentryInfo = SEQ(name=u'SubentryInfo', mode=MODE_TYPE)
    _SubentryInfo_rdn = SET_OF(name=u'rdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    _SubentryInfo_info = SET_OF(name=u'info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __SubentryInfo_info__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SubentryInfo_info__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____SubentryInfo_info__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SubentryInfo_info__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____SubentryInfo_info__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SubentryInfo_info__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____SubentryInfo_info__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____SubentryInfo_info__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SubentryInfo_info__item__type._const_tab = ____SubentryInfo_info__item__type_tab
    ___SubentryInfo_info__item__type._const_tab_at = None
    ___SubentryInfo_info__item__type._const_tab_id = u'id'
    ___SubentryInfo_info__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____SubentryInfo_info__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____SubentryInfo_info__item__values__item_._const_tab = ____SubentryInfo_info__item__type_tab
    ____SubentryInfo_info__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____SubentryInfo_info__item__values__item_._const_tab_id = u'Type'
    ___SubentryInfo_info__item__values._cont = ____SubentryInfo_info__item__values__item_
    ___SubentryInfo_info__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SubentryInfo_info__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SubentryInfo_info__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SubentryInfo_info__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____SubentryInfo_info__item__valuesWithContext__item__value._const_tab = ____SubentryInfo_info__item__type_tab
    _____SubentryInfo_info__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____SubentryInfo_info__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____SubentryInfo_info__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______SubentryInfo_info__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SubentryInfo_info__item__valuesWithContext__item__contextList._cont = ______SubentryInfo_info__item__valuesWithContext__item__contextList__item_
    _____SubentryInfo_info__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SubentryInfo_info__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____SubentryInfo_info__item__valuesWithContext__item__value),
        (u'contextList', _____SubentryInfo_info__item__valuesWithContext__item__contextList),
        ])
    ____SubentryInfo_info__item__valuesWithContext__item_._ext = []
    ___SubentryInfo_info__item__valuesWithContext._cont = ____SubentryInfo_info__item__valuesWithContext__item_
    ___SubentryInfo_info__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SubentryInfo_info__item_._cont = ASN1Dict([
        (u'type', ___SubentryInfo_info__item__type),
        (u'values', ___SubentryInfo_info__item__values),
        (u'valuesWithContext', ___SubentryInfo_info__item__valuesWithContext),
        ])
    __SubentryInfo_info__item_._ext = []
    _SubentryInfo_info._cont = __SubentryInfo_info__item_
    SubentryInfo._cont = ASN1Dict([
        (u'rdn', _SubentryInfo_rdn),
        (u'info', _SubentryInfo_info),
        ])
    SubentryInfo._ext = []
    
    #-----< SubordinateToSuperior >-----#
    SubordinateToSuperior = SEQ(name=u'SubordinateToSuperior', mode=MODE_TYPE)
    _SubordinateToSuperior_accessPoints = SET_OF(name=u'accessPoints', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')), opt=True)
    _SubordinateToSuperior_alias = BOOL(name=u'alias', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _SubordinateToSuperior_entryInfo = SET_OF(name=u'entryInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SubordinateToSuperior_entryInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SubordinateToSuperior_entryInfo__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____SubordinateToSuperior_entryInfo__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SubordinateToSuperior_entryInfo__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SubordinateToSuperior_entryInfo__item__type._const_tab = ____SubordinateToSuperior_entryInfo__item__type_tab
    ___SubordinateToSuperior_entryInfo__item__type._const_tab_at = None
    ___SubordinateToSuperior_entryInfo__item__type._const_tab_id = u'id'
    ___SubordinateToSuperior_entryInfo__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____SubordinateToSuperior_entryInfo__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____SubordinateToSuperior_entryInfo__item__values__item_._const_tab = ____SubordinateToSuperior_entryInfo__item__type_tab
    ____SubordinateToSuperior_entryInfo__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____SubordinateToSuperior_entryInfo__item__values__item_._const_tab_id = u'Type'
    ___SubordinateToSuperior_entryInfo__item__values._cont = ____SubordinateToSuperior_entryInfo__item__values__item_
    ___SubordinateToSuperior_entryInfo__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SubordinateToSuperior_entryInfo__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SubordinateToSuperior_entryInfo__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value._const_tab = ____SubordinateToSuperior_entryInfo__item__type_tab
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList._cont = ______SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList__item_
    _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SubordinateToSuperior_entryInfo__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value),
        (u'contextList', _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList),
        ])
    ____SubordinateToSuperior_entryInfo__item__valuesWithContext__item_._ext = []
    ___SubordinateToSuperior_entryInfo__item__valuesWithContext._cont = ____SubordinateToSuperior_entryInfo__item__valuesWithContext__item_
    ___SubordinateToSuperior_entryInfo__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SubordinateToSuperior_entryInfo__item_._cont = ASN1Dict([
        (u'type', ___SubordinateToSuperior_entryInfo__item__type),
        (u'values', ___SubordinateToSuperior_entryInfo__item__values),
        (u'valuesWithContext', ___SubordinateToSuperior_entryInfo__item__valuesWithContext),
        ])
    __SubordinateToSuperior_entryInfo__item_._ext = []
    _SubordinateToSuperior_entryInfo._cont = __SubordinateToSuperior_entryInfo__item_
    _SubordinateToSuperior_entryInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SubordinateToSuperior_subentries = SET_OF(name=u'subentries', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SubordinateToSuperior_subentries__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubentryInfo')))
    _SubordinateToSuperior_subentries._cont = __SubordinateToSuperior_subentries__item_
    _SubordinateToSuperior_subentries._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    SubordinateToSuperior._cont = ASN1Dict([
        (u'accessPoints', _SubordinateToSuperior_accessPoints),
        (u'alias', _SubordinateToSuperior_alias),
        (u'entryInfo', _SubordinateToSuperior_entryInfo),
        (u'subentries', _SubordinateToSuperior_subentries),
        ])
    SubordinateToSuperior._ext = []
    
    #-----< SuperiorToSubordinateModification >-----#
    SuperiorToSubordinateModification = SEQ(name=u'SuperiorToSubordinateModification', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinate')))
    
    #-----< NonSpecificHierarchicalAgreement >-----#
    NonSpecificHierarchicalAgreement = SEQ(name=u'NonSpecificHierarchicalAgreement', mode=MODE_TYPE)
    _NonSpecificHierarchicalAgreement_immediateSuperior = SEQ_OF(name=u'immediateSuperior', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    NonSpecificHierarchicalAgreement._cont = ASN1Dict([
        (u'immediateSuperior', _NonSpecificHierarchicalAgreement_immediateSuperior),
        ])
    NonSpecificHierarchicalAgreement._ext = []
    
    #-----< NHOBSuperiorToSubordinate >-----#
    NHOBSuperiorToSubordinate = SEQ(name=u'NHOBSuperiorToSubordinate', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinate')))
    
    #-----< NHOBSubordinateToSuperior >-----#
    NHOBSubordinateToSuperior = SEQ(name=u'NHOBSubordinateToSuperior', mode=MODE_TYPE)
    _NHOBSubordinateToSuperior_accessPoints = SET_OF(name=u'accessPoints', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'MasterAndShadowAccessPoints')), opt=True)
    _NHOBSubordinateToSuperior_subentries = SET_OF(name=u'subentries', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __NHOBSubordinateToSuperior_subentries__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubentryInfo')))
    _NHOBSubordinateToSuperior_subentries._cont = __NHOBSubordinateToSuperior_subentries__item_
    _NHOBSubordinateToSuperior_subentries._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    NHOBSubordinateToSuperior._cont = ASN1Dict([
        (u'accessPoints', _NHOBSubordinateToSuperior_accessPoints),
        (u'subentries', _NHOBSubordinateToSuperior_subentries),
        ])
    NHOBSubordinateToSuperior._ext = []
    
    #-----< hierarchicalOperationalBinding >-----#
    hierarchicalOperationalBinding = CLASS(name=u'hierarchicalOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    _hierarchicalOperationalBinding_val_Agreement = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    __APPLICATION_CONTEXT_bind_operation_val_ArgumentType = SET(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    __APPLICATION_CONTEXT_bind_operation_val_ResultType = SET(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_unsigned_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error = CHOICE(name=u'error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError = INT(name=u'serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError = INT(name=u'securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._cont = ASN1Dict([
        (u'serviceError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError),
        (u'securityError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_unsigned._cont = ASN1Dict([
        (u'versions', ____OPERATION_Errors_val_ParameterType_0_unsigned_versions),
        (u'error', ____OPERATION_Errors_val_ParameterType_0_unsigned_error),
        (u'securityParameters', ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error = CHOICE(name=u'error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError = INT(name=u'serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError = INT(name=u'securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._cont = ASN1Dict([
        (u'serviceError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError),
        (u'securityError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._cont = ASN1Dict([
        (u'versions', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions),
        (u'error', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error),
        (u'securityParameters', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_0._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_0._ext = None
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    __OPERATION_Errors_val_ParameterType_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    __OPERATION_Errors_val_ParameterType_3 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_3_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_Errors_val_ParameterType_4 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_4_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Errors_val_ParameterType_5 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_5_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_5_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_5_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_6_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_6_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_6_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_1._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_2 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __OPERATION_Errors_val_ParameterType_0_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_3 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_3._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_3._ext = None
    __OPERATION_Errors_val_ParameterType_1_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_0._ext = None
    __OPERATION_Errors_val_ParameterType_2_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_3_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_3_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_3_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_0._ext = None
    __OPERATION_Errors_val_ParameterType_5_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_5_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_5_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_5_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_4 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_4._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_4._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_5 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_5._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_6_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_6_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_6_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_6 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_6._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_6._ext = None
    __OPERATION_Errors_val_ParameterType_4_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_1._ext = None
    __OPERATION_Errors_val_ParameterType_5_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_5_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_5_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_5_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_7 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_7._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_7._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_8 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_8._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_8._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_9 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_9._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_9._ext = None
    __OPERATION_Errors_val_ParameterType_1_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_1._ext = None
    __OPERATION_Errors_val_ParameterType_2_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_10 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_10._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_10._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_11 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType = SEQ_OF(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType._cont = _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType = SEQ_OF(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType._cont = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._ext = None
    __OPERATION_Errors_val_ParameterType_1_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_2._ext = None
    __OPERATION_Errors_val_ParameterType_2_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_2._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_12 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType = NULL(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType = NULL(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._ext = None
    __shadowOperationalBinding_roleA_val_EstablishParam = SEQ(name=u'EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinate')))
    __shadowOperationalBinding_roleA_val_ModifyParam = SEQ(name=u'ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinateModification')))
    __shadowOperationalBinding_roleB_val_EstablishParam = SEQ(name=u'EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubordinateToSuperior')))
    __shadowOperationalBinding_roleB_val_ModifyParam = SEQ(name=u'ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubordinateToSuperior')))
    hierarchicalOperationalBinding._val = dict([(u'Agreement', _hierarchicalOperationalBinding_val_Agreement), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __shadowOperationalBinding_roleA_val_EstablishParam), (u'modify', True), (u'ModifyParam', __shadowOperationalBinding_roleA_val_ModifyParam), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __shadowOperationalBinding_roleB_val_EstablishParam), (u'modify', True), (u'ModifyParam', __shadowOperationalBinding_roleB_val_ModifyParam), (u'terminate', True)])), (u'id', (2, 5, 19, 2))])
    
    #-----< nonSpecificHierarchicalOperationalBinding >-----#
    nonSpecificHierarchicalOperationalBinding = CLASS(name=u'nonSpecificHierarchicalOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    _nonSpecificHierarchicalOperationalBinding_val_Agreement = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __shadowOperationalBinding_roleA_val_EstablishParam_0 = SEQ(name=u'EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSuperiorToSubordinate')))
    __shadowOperationalBinding_roleA_val_ModifyParam_0 = SEQ(name=u'ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSuperiorToSubordinate')))
    __shadowOperationalBinding_roleB_val_EstablishParam_0 = SEQ(name=u'EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSubordinateToSuperior')))
    __shadowOperationalBinding_roleB_val_ModifyParam_0 = SEQ(name=u'ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSubordinateToSuperior')))
    nonSpecificHierarchicalOperationalBinding._val = dict([(u'Agreement', _nonSpecificHierarchicalOperationalBinding_val_Agreement), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'EstablishParam', __shadowOperationalBinding_roleA_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __shadowOperationalBinding_roleA_val_ModifyParam_0), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __shadowOperationalBinding_roleB_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __shadowOperationalBinding_roleB_val_ModifyParam_0), (u'terminate', True)])), (u'id', (2, 5, 19, 3))])
    
    _all_ = [
        _HierarchicalAgreement_rdn,
        _HierarchicalAgreement_immediateSuperior,
        HierarchicalAgreement,
        _SuperiorToSubordinate_contextPrefixInfo,
        ____SuperiorToSubordinate_entryInfo__item__type_tab,
        _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        _____SuperiorToSubordinate_entryInfo__item__type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        ___SuperiorToSubordinate_entryInfo__item__type,
        ____SuperiorToSubordinate_entryInfo__item__values__item_,
        ___SuperiorToSubordinate_entryInfo__item__values,
        _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__value,
        ______SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList__item_,
        _____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item__contextList,
        ____SuperiorToSubordinate_entryInfo__item__valuesWithContext__item_,
        ___SuperiorToSubordinate_entryInfo__item__valuesWithContext,
        __SuperiorToSubordinate_entryInfo__item_,
        _SuperiorToSubordinate_entryInfo,
        ___SuperiorToSubordinate_immediateSuperiorInfo__item__type,
        ____SuperiorToSubordinate_immediateSuperiorInfo__item__values__item_,
        ___SuperiorToSubordinate_immediateSuperiorInfo__item__values,
        _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__value,
        ______SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList__item_,
        _____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item__contextList,
        ____SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext__item_,
        ___SuperiorToSubordinate_immediateSuperiorInfo__item__valuesWithContext,
        __SuperiorToSubordinate_immediateSuperiorInfo__item_,
        _SuperiorToSubordinate_immediateSuperiorInfo,
        SuperiorToSubordinate,
        _DITcontext__item_,
        DITcontext,
        _Vertex_rdn,
        ____Vertex_admPointInfo__item__type_tab,
        _____Vertex_admPointInfo__item__type_tab_val_Type_0,
        _____Vertex_admPointInfo__item__type_tab_val_Type_1,
        ___Vertex_admPointInfo__item__type,
        ____Vertex_admPointInfo__item__values__item_,
        ___Vertex_admPointInfo__item__values,
        _____Vertex_admPointInfo__item__valuesWithContext__item__value,
        ______Vertex_admPointInfo__item__valuesWithContext__item__contextList__item_,
        _____Vertex_admPointInfo__item__valuesWithContext__item__contextList,
        ____Vertex_admPointInfo__item__valuesWithContext__item_,
        ___Vertex_admPointInfo__item__valuesWithContext,
        __Vertex_admPointInfo__item_,
        _Vertex_admPointInfo,
        __Vertex_subentries__item_,
        _Vertex_subentries,
        _Vertex_accessPoints,
        Vertex,
        _SubentryInfo_rdn,
        ____SubentryInfo_info__item__type_tab,
        _____SubentryInfo_info__item__type_tab_val_Type_0,
        _____SubentryInfo_info__item__type_tab_val_Type_1,
        ___SubentryInfo_info__item__type,
        ____SubentryInfo_info__item__values__item_,
        ___SubentryInfo_info__item__values,
        _____SubentryInfo_info__item__valuesWithContext__item__value,
        ______SubentryInfo_info__item__valuesWithContext__item__contextList__item_,
        _____SubentryInfo_info__item__valuesWithContext__item__contextList,
        ____SubentryInfo_info__item__valuesWithContext__item_,
        ___SubentryInfo_info__item__valuesWithContext,
        __SubentryInfo_info__item_,
        _SubentryInfo_info,
        SubentryInfo,
        _SubordinateToSuperior_accessPoints,
        _SubordinateToSuperior_alias,
        ____SubordinateToSuperior_entryInfo__item__type_tab,
        _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_0,
        _____SubordinateToSuperior_entryInfo__item__type_tab_val_Type_1,
        ___SubordinateToSuperior_entryInfo__item__type,
        ____SubordinateToSuperior_entryInfo__item__values__item_,
        ___SubordinateToSuperior_entryInfo__item__values,
        _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__value,
        ______SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList__item_,
        _____SubordinateToSuperior_entryInfo__item__valuesWithContext__item__contextList,
        ____SubordinateToSuperior_entryInfo__item__valuesWithContext__item_,
        ___SubordinateToSuperior_entryInfo__item__valuesWithContext,
        __SubordinateToSuperior_entryInfo__item_,
        _SubordinateToSuperior_entryInfo,
        __SubordinateToSuperior_subentries__item_,
        _SubordinateToSuperior_subentries,
        SubordinateToSuperior,
        SuperiorToSubordinateModification,
        _NonSpecificHierarchicalAgreement_immediateSuperior,
        NonSpecificHierarchicalAgreement,
        NHOBSuperiorToSubordinate,
        _NHOBSubordinateToSuperior_accessPoints,
        __NHOBSubordinateToSuperior_subentries__item_,
        _NHOBSubordinateToSuperior_subentries,
        NHOBSubordinateToSuperior,
        hierarchicalOperationalBinding,
        _hierarchicalOperationalBinding_val_Agreement,
        __APPLICATION_CONTEXT_bind_operation_val_ArgumentType,
        __APPLICATION_CONTEXT_bind_operation_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        ___OPERATION_Errors_val_ParameterType_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_signed,
        __OPERATION_Errors_val_ParameterType_2,
        ___OPERATION_Errors_val_ParameterType_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_signed,
        __OPERATION_Errors_val_ParameterType_3,
        ___OPERATION_Errors_val_ParameterType_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_signed,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_Errors_val_ParameterType_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_signed,
        __OPERATION_Errors_val_ParameterType_5,
        ___OPERATION_Errors_val_ParameterType_6_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_signed,
        __OPERATION_Errors_val_ParameterType_6,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_2,
        __APPLICATION_CONTEXT_Operations_val_ResultType_2,
        ___OPERATION_Errors_val_ParameterType_0_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_1_signed,
        __OPERATION_Errors_val_ParameterType_0_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_3,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_3,
        ___OPERATION_Errors_val_ParameterType_1_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_0_signed,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_Errors_val_ParameterType_2_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_0_signed,
        __OPERATION_Errors_val_ParameterType_2_0,
        ___OPERATION_Errors_val_ParameterType_3_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_0_signed,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_Errors_val_ParameterType_4_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_0_signed,
        __OPERATION_Errors_val_ParameterType_4_0,
        ___OPERATION_Errors_val_ParameterType_5_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_0_signed,
        __OPERATION_Errors_val_ParameterType_5_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_4,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_4,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_5,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_5,
        ___OPERATION_Errors_val_ParameterType_6_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_0_signed,
        __OPERATION_Errors_val_ParameterType_6_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_6,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_6,
        ___OPERATION_Errors_val_ParameterType_4_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_1_signed,
        __OPERATION_Errors_val_ParameterType_4_1,
        ___OPERATION_Errors_val_ParameterType_5_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_1_signed,
        __OPERATION_Errors_val_ParameterType_5_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_7,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_7,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_8,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_8,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_9,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_9,
        ___OPERATION_Errors_val_ParameterType_1_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_1_signed,
        __OPERATION_Errors_val_ParameterType_1_1,
        ___OPERATION_Errors_val_ParameterType_2_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_1_signed,
        __OPERATION_Errors_val_ParameterType_2_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_10,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_10,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_11,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_11,
        ___OPERATION_Errors_val_ParameterType_1_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_2_signed,
        __OPERATION_Errors_val_ParameterType_1_2,
        ___OPERATION_Errors_val_ParameterType_2_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_2_signed,
        __OPERATION_Errors_val_ParameterType_2_2,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_12,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_12,
        __shadowOperationalBinding_roleA_val_EstablishParam,
        __shadowOperationalBinding_roleA_val_ModifyParam,
        __shadowOperationalBinding_roleB_val_EstablishParam,
        __shadowOperationalBinding_roleB_val_ModifyParam,
        nonSpecificHierarchicalOperationalBinding,
        _nonSpecificHierarchicalOperationalBinding_val_Agreement,
        __shadowOperationalBinding_roleA_val_EstablishParam_0,
        __shadowOperationalBinding_roleA_val_ModifyParam_0,
        __shadowOperationalBinding_roleB_val_EstablishParam_0,
        __shadowOperationalBinding_roleB_val_ModifyParam_0,
    ]

class IMSChargingDataTypes:

    _name_  = u'IMSChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 4, 0, 1]
    
    _obj_ = [
        u'IMSRecord',
        u'SCSCFRecord',
        u'PCSCFRecord',
        u'ICSCFRecord',
        u'MRFCRecord',
        u'MGCFRecord',
        u'BGCFRecord',
        u'ASRecord',
        u'ECSCFRecord',
        u'IBCFRecord',
        u'TRFRecord',
        u'ATCFRecord',
        u'TFRecord',
        u'AccessCorrelationID',
        u'AccessNetworkInfoChange',
        u'AccessTransferType',
        u'AccessTransferInformation',
        u'ACRInterimLost',
        u'AoCCostInformation',
        u'AoCInformation',
        u'ApplicationServersInformation',
        u'CalledIdentityChange',
        u'CarrierSelectRouting',
        u'CauseForRecordClosing',
        u'Early-Media-Components-List',
        u'FEIdentifierList',
        u'IMS-Charging-Identifier',
        u'IMSCommunicationServiceIdentifier',
        u'Incomplete-CDR-Indication',
        u'InterOperatorIdentifierList',
        u'InterOperatorIdentifiers',
        u'ISUPCause',
        u'ListOfInvolvedParties',
        u'ListOfReasonHeader',
        u'Media-Components-List',
        u'MessageBody',
        u'Milliseconds',
        u'NNI-Information',
        u'NNIType',
        u'NumberPortabilityRouting',
        u'RateElement',
        u'RealTimeTariffInformation',
        u'ReasonHeaderInformation',
        u'RelationshipMode',
        u'Role-of-Node',
        u'S-CSCF-Information',
        u'SDP-Media-Component',
        u'SDP-Media-Description',
        u'ServedPartyIPAddress',
        u'Service-Id',
        u'SessionDirection',
        u'SessionPriority',
        u'SIP-Method',
        u'SDP-Type',
        u'Status',
        u'TADIdentifier',
        u'TariffInformation',
        u'TransitIOILists',
        u'TransmissionMedium',
        u'TrunkGroupID',
        ]
    _type_ = [
        u'IMSRecord',
        u'SCSCFRecord',
        u'PCSCFRecord',
        u'ICSCFRecord',
        u'MRFCRecord',
        u'MGCFRecord',
        u'BGCFRecord',
        u'ASRecord',
        u'ECSCFRecord',
        u'IBCFRecord',
        u'TRFRecord',
        u'ATCFRecord',
        u'TFRecord',
        u'AccessCorrelationID',
        u'AccessNetworkInfoChange',
        u'AccessTransferType',
        u'AccessTransferInformation',
        u'ACRInterimLost',
        u'AoCCostInformation',
        u'AoCInformation',
        u'ApplicationServersInformation',
        u'CalledIdentityChange',
        u'CarrierSelectRouting',
        u'CauseForRecordClosing',
        u'Early-Media-Components-List',
        u'FEIdentifierList',
        u'IMS-Charging-Identifier',
        u'IMSCommunicationServiceIdentifier',
        u'Incomplete-CDR-Indication',
        u'InterOperatorIdentifierList',
        u'InterOperatorIdentifiers',
        u'ISUPCause',
        u'ListOfInvolvedParties',
        u'ListOfReasonHeader',
        u'Media-Components-List',
        u'MessageBody',
        u'Milliseconds',
        u'NNI-Information',
        u'NNIType',
        u'NumberPortabilityRouting',
        u'RateElement',
        u'RealTimeTariffInformation',
        u'ReasonHeaderInformation',
        u'RelationshipMode',
        u'Role-of-Node',
        u'S-CSCF-Information',
        u'SDP-Media-Component',
        u'SDP-Media-Description',
        u'ServedPartyIPAddress',
        u'Service-Id',
        u'SessionDirection',
        u'SessionPriority',
        u'SIP-Method',
        u'SDP-Type',
        u'Status',
        u'TADIdentifier',
        u'TariffInformation',
        u'TransitIOILists',
        u'TransmissionMedium',
        u'TrunkGroupID',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< IMSRecord >-----#
    IMSRecord = CHOICE(name=u'IMSRecord', mode=MODE_TYPE)
    _IMSRecord_sCSCFRecord = SET(name=u'sCSCFRecord', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SCSCFRecord')))
    _IMSRecord_pCSCFRecord = SET(name=u'pCSCFRecord', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'PCSCFRecord')))
    _IMSRecord_iCSCFRecord = SET(name=u'iCSCFRecord', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ICSCFRecord')))
    _IMSRecord_mRFCRecord = SET(name=u'mRFCRecord', mode=MODE_TYPE, tag=(66, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'MRFCRecord')))
    _IMSRecord_mGCFRecord = SET(name=u'mGCFRecord', mode=MODE_TYPE, tag=(67, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'MGCFRecord')))
    _IMSRecord_bGCFRecord = SET(name=u'bGCFRecord', mode=MODE_TYPE, tag=(68, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'BGCFRecord')))
    _IMSRecord_aSRecord = SET(name=u'aSRecord', mode=MODE_TYPE, tag=(69, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ASRecord')))
    _IMSRecord_eCSCFRecord = SET(name=u'eCSCFRecord', mode=MODE_TYPE, tag=(70, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ECSCFRecord')))
    _IMSRecord_iBCFRecord = SET(name=u'iBCFRecord', mode=MODE_TYPE, tag=(82, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IBCFRecord')))
    _IMSRecord_tRFRecord = SET(name=u'tRFRecord', mode=MODE_TYPE, tag=(89, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TRFRecord')))
    _IMSRecord_tFRecord = SET(name=u'tFRecord', mode=MODE_TYPE, tag=(90, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TFRecord')))
    _IMSRecord_aTCFRecord = SET(name=u'aTCFRecord', mode=MODE_TYPE, tag=(91, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ATCFRecord')))
    IMSRecord._cont = ASN1Dict([
        (u'sCSCFRecord', _IMSRecord_sCSCFRecord),
        (u'pCSCFRecord', _IMSRecord_pCSCFRecord),
        (u'iCSCFRecord', _IMSRecord_iCSCFRecord),
        (u'mRFCRecord', _IMSRecord_mRFCRecord),
        (u'mGCFRecord', _IMSRecord_mGCFRecord),
        (u'bGCFRecord', _IMSRecord_bGCFRecord),
        (u'aSRecord', _IMSRecord_aSRecord),
        (u'eCSCFRecord', _IMSRecord_eCSCFRecord),
        (u'iBCFRecord', _IMSRecord_iBCFRecord),
        (u'tRFRecord', _IMSRecord_tRFRecord),
        (u'tFRecord', _IMSRecord_tFRecord),
        (u'aTCFRecord', _IMSRecord_aTCFRecord),
        ])
    IMSRecord._ext = None
    
    #-----< SCSCFRecord >-----#
    SCSCFRecord = SET(name=u'SCSCFRecord', mode=MODE_TYPE)
    _SCSCFRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SCSCFRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_sIP_Method = STR_GRAPH(name=u'sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _SCSCFRecord_role_of_Node = ENUM(name=u'role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _SCSCFRecord_nodeAddress = CHOICE(name=u'nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _SCSCFRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _SCSCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name=u'list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _SCSCFRecord_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _SCSCFRecord_privateUserID = STR_GRAPH(name=u'privateUserID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_serviceRequestTimeStamp = OCT_STR(name=u'serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SCSCFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name=u'serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SCSCFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name=u'serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SCSCFRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SCSCFRecord_recordClosureTime = OCT_STR(name=u'recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SCSCFRecord_interOperatorIdentifiers = SEQ_OF(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifierList')), opt=True)
    _SCSCFRecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SCSCFRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_causeForRecordClosing = ENUM(name=u'causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _SCSCFRecord_incomplete_CDR_Indication = SET(name=u'incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _SCSCFRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _SCSCFRecord_list_Of_SDP_Media_Components = SEQ_OF(name=u'list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _SCSCFRecord_list_Of_SDP_Media_Components._cont = __SCSCFRecord_list_Of_SDP_Media_Components__item_
    _SCSCFRecord_gGSNaddress = CHOICE(name=u'gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _SCSCFRecord_serviceReasonReturnCode = STR_UTF8(name=u'serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_list_Of_Message_Bodies = SEQ_OF(name=u'list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _SCSCFRecord_list_Of_Message_Bodies._cont = __SCSCFRecord_list_Of_Message_Bodies__item_
    _SCSCFRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SCSCFRecord_expiresInformation = INT(name=u'expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_list_Of_Associated_URI = SEQ_OF(name=u'list-Of-Associated-URI', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _SCSCFRecord_event = STR_UTF8(name=u'event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_accessNetworkInformation = OCT_STR(name=u'accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _SCSCFRecord_list_of_subscription_ID = SEQ_OF(name=u'list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _SCSCFRecord_list_of_subscription_ID._cont = __SCSCFRecord_list_of_subscription_ID__item_
    _SCSCFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name=u'list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _SCSCFRecord_list_Of_Early_SDP_Media_Components._cont = __SCSCFRecord_list_Of_Early_SDP_Media_Components__item_
    _SCSCFRecord_iMSCommunicationServiceIdentifier = OCT_STR(name=u'iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _SCSCFRecord_numberPortabilityRouting = STR_GRAPH(name=u'numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _SCSCFRecord_carrierSelectRouting = STR_GRAPH(name=u'carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _SCSCFRecord_sessionPriority = ENUM(name=u'sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _SCSCFRecord_serviceRequestTimeStampFraction = INT(name=u'serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _SCSCFRecord_serviceDeliveryStartTimeStampFraction = INT(name=u'serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _SCSCFRecord_serviceDeliveryEndTimeStampFraction = INT(name=u'serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _SCSCFRecord_applicationServersInformation = SEQ_OF(name=u'applicationServersInformation', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_applicationServersInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'ApplicationServersInformation')))
    _SCSCFRecord_applicationServersInformation._cont = __SCSCFRecord_applicationServersInformation__item_
    _SCSCFRecord_requested_Party_Address = CHOICE(name=u'requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _SCSCFRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name=u'list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _SCSCFRecord_online_charging_flag = NULL(name=u'online-charging-flag', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_realTimeTariffInformation = SEQ_OF(name=u'realTimeTariffInformation', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_realTimeTariffInformation__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'RealTimeTariffInformation')))
    _SCSCFRecord_realTimeTariffInformation._cont = __SCSCFRecord_realTimeTariffInformation__item_
    _SCSCFRecord_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _SCSCFRecord_nNI_Information = SEQ(name=u'nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')), opt=True)
    _SCSCFRecord_fromAddress = OCT_STR(name=u'fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_iMSEmergencyIndicator = NULL(name=u'iMSEmergencyIndicator', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_transit_IOI_Lists = SEQ_OF(name=u'transit-IOI-Lists', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _SCSCFRecord_iMSVisitedNetworkIdentifier = OCT_STR(name=u'iMSVisitedNetworkIdentifier', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_listOfReasonHeader = SEQ_OF(name=u'listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _SCSCFRecord_additionalAccessNetworkInformation = OCT_STR(name=u'additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_instanceId = OCT_STR(name=u'instanceId', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_subscriberEquipmentNumber = SET(name=u'subscriberEquipmentNumber', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentNumber')), opt=True)
    _SCSCFRecord_routeHeaderReceived = OCT_STR(name=u'routeHeaderReceived', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_routeHeaderTransmitted = OCT_STR(name=u'routeHeaderTransmitted', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name=u'list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _SCSCFRecord_list_Of_AccessNetworkInfoChange._cont = __SCSCFRecord_list_Of_AccessNetworkInfoChange__item_
    _SCSCFRecord_listOfCalledIdentityChanges = SEQ_OF(name=u'listOfCalledIdentityChanges', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSCFRecord_listOfCalledIdentityChanges__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'CalledIdentityChange')))
    _SCSCFRecord_listOfCalledIdentityChanges._cont = __SCSCFRecord_listOfCalledIdentityChanges__item_
    _SCSCFRecord_cellularNetworkInformation = OCT_STR(name=u'cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSCFRecord_fEIdentifierList = SEQ_OF(name=u'fEIdentifierList', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    SCSCFRecord._cont = ASN1Dict([
        (u'recordType', _SCSCFRecord_recordType),
        (u'retransmission', _SCSCFRecord_retransmission),
        (u'sIP-Method', _SCSCFRecord_sIP_Method),
        (u'role-of-Node', _SCSCFRecord_role_of_Node),
        (u'nodeAddress', _SCSCFRecord_nodeAddress),
        (u'session-Id', _SCSCFRecord_session_Id),
        (u'list-Of-Calling-Party-Address', _SCSCFRecord_list_Of_Calling_Party_Address),
        (u'called-Party-Address', _SCSCFRecord_called_Party_Address),
        (u'privateUserID', _SCSCFRecord_privateUserID),
        (u'serviceRequestTimeStamp', _SCSCFRecord_serviceRequestTimeStamp),
        (u'serviceDeliveryStartTimeStamp', _SCSCFRecord_serviceDeliveryStartTimeStamp),
        (u'serviceDeliveryEndTimeStamp', _SCSCFRecord_serviceDeliveryEndTimeStamp),
        (u'recordOpeningTime', _SCSCFRecord_recordOpeningTime),
        (u'recordClosureTime', _SCSCFRecord_recordClosureTime),
        (u'interOperatorIdentifiers', _SCSCFRecord_interOperatorIdentifiers),
        (u'localRecordSequenceNumber', _SCSCFRecord_localRecordSequenceNumber),
        (u'recordSequenceNumber', _SCSCFRecord_recordSequenceNumber),
        (u'causeForRecordClosing', _SCSCFRecord_causeForRecordClosing),
        (u'incomplete-CDR-Indication', _SCSCFRecord_incomplete_CDR_Indication),
        (u'iMS-Charging-Identifier', _SCSCFRecord_iMS_Charging_Identifier),
        (u'list-Of-SDP-Media-Components', _SCSCFRecord_list_Of_SDP_Media_Components),
        (u'gGSNaddress', _SCSCFRecord_gGSNaddress),
        (u'serviceReasonReturnCode', _SCSCFRecord_serviceReasonReturnCode),
        (u'list-Of-Message-Bodies', _SCSCFRecord_list_Of_Message_Bodies),
        (u'recordExtensions', _SCSCFRecord_recordExtensions),
        (u'expiresInformation', _SCSCFRecord_expiresInformation),
        (u'list-Of-Associated-URI', _SCSCFRecord_list_Of_Associated_URI),
        (u'event', _SCSCFRecord_event),
        (u'accessNetworkInformation', _SCSCFRecord_accessNetworkInformation),
        (u'serviceContextID', _SCSCFRecord_serviceContextID),
        (u'list-of-subscription-ID', _SCSCFRecord_list_of_subscription_ID),
        (u'list-Of-Early-SDP-Media-Components', _SCSCFRecord_list_Of_Early_SDP_Media_Components),
        (u'iMSCommunicationServiceIdentifier', _SCSCFRecord_iMSCommunicationServiceIdentifier),
        (u'numberPortabilityRouting', _SCSCFRecord_numberPortabilityRouting),
        (u'carrierSelectRouting', _SCSCFRecord_carrierSelectRouting),
        (u'sessionPriority', _SCSCFRecord_sessionPriority),
        (u'serviceRequestTimeStampFraction', _SCSCFRecord_serviceRequestTimeStampFraction),
        (u'serviceDeliveryStartTimeStampFraction', _SCSCFRecord_serviceDeliveryStartTimeStampFraction),
        (u'serviceDeliveryEndTimeStampFraction', _SCSCFRecord_serviceDeliveryEndTimeStampFraction),
        (u'applicationServersInformation', _SCSCFRecord_applicationServersInformation),
        (u'requested-Party-Address', _SCSCFRecord_requested_Party_Address),
        (u'list-Of-Called-Asserted-Identity', _SCSCFRecord_list_Of_Called_Asserted_Identity),
        (u'online-charging-flag', _SCSCFRecord_online_charging_flag),
        (u'realTimeTariffInformation', _SCSCFRecord_realTimeTariffInformation),
        (u'userLocationInformation', _SCSCFRecord_userLocationInformation),
        (u'mSTimeZone', _SCSCFRecord_mSTimeZone),
        (u'nNI-Information', _SCSCFRecord_nNI_Information),
        (u'fromAddress', _SCSCFRecord_fromAddress),
        (u'iMSEmergencyIndicator', _SCSCFRecord_iMSEmergencyIndicator),
        (u'transit-IOI-Lists', _SCSCFRecord_transit_IOI_Lists),
        (u'iMSVisitedNetworkIdentifier', _SCSCFRecord_iMSVisitedNetworkIdentifier),
        (u'listOfReasonHeader', _SCSCFRecord_listOfReasonHeader),
        (u'additionalAccessNetworkInformation', _SCSCFRecord_additionalAccessNetworkInformation),
        (u'instanceId', _SCSCFRecord_instanceId),
        (u'subscriberEquipmentNumber', _SCSCFRecord_subscriberEquipmentNumber),
        (u'routeHeaderReceived', _SCSCFRecord_routeHeaderReceived),
        (u'routeHeaderTransmitted', _SCSCFRecord_routeHeaderTransmitted),
        (u'list-Of-AccessNetworkInfoChange', _SCSCFRecord_list_Of_AccessNetworkInfoChange),
        (u'listOfCalledIdentityChanges', _SCSCFRecord_listOfCalledIdentityChanges),
        (u'cellularNetworkInformation', _SCSCFRecord_cellularNetworkInformation),
        (u'fEIdentifierList', _SCSCFRecord_fEIdentifierList),
        ])
    SCSCFRecord._ext = None
    
    #-----< PCSCFRecord >-----#
    PCSCFRecord = SET(name=u'PCSCFRecord', mode=MODE_TYPE)
    _PCSCFRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _PCSCFRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_sIP_Method = STR_GRAPH(name=u'sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _PCSCFRecord_role_of_Node = ENUM(name=u'role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _PCSCFRecord_nodeAddress = CHOICE(name=u'nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _PCSCFRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _PCSCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name=u'list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _PCSCFRecord_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _PCSCFRecord_privateUserID = STR_GRAPH(name=u'privateUserID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_serviceRequestTimeStamp = OCT_STR(name=u'serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PCSCFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name=u'serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PCSCFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name=u'serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PCSCFRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PCSCFRecord_recordClosureTime = OCT_STR(name=u'recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PCSCFRecord_interOperatorIdentifiers = SEQ(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _PCSCFRecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _PCSCFRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_causeForRecordClosing = ENUM(name=u'causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _PCSCFRecord_incomplete_CDR_Indication = SET(name=u'incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _PCSCFRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _PCSCFRecord_list_Of_SDP_Media_Components = SEQ_OF(name=u'list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PCSCFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _PCSCFRecord_list_Of_SDP_Media_Components._cont = __PCSCFRecord_list_Of_SDP_Media_Components__item_
    _PCSCFRecord_gGSNaddress = CHOICE(name=u'gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _PCSCFRecord_serviceReasonReturnCode = STR_UTF8(name=u'serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_list_Of_Message_Bodies = SEQ_OF(name=u'list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PCSCFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _PCSCFRecord_list_Of_Message_Bodies._cont = __PCSCFRecord_list_Of_Message_Bodies__item_
    _PCSCFRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _PCSCFRecord_expiresInformation = INT(name=u'expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_list_Of_Associated_URI = SEQ_OF(name=u'list-Of-Associated-URI', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _PCSCFRecord_event = STR_UTF8(name=u'event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_accessNetworkInformation = OCT_STR(name=u'accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _PCSCFRecord_list_of_subscription_ID = SEQ_OF(name=u'list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PCSCFRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _PCSCFRecord_list_of_subscription_ID._cont = __PCSCFRecord_list_of_subscription_ID__item_
    _PCSCFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name=u'list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PCSCFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _PCSCFRecord_list_Of_Early_SDP_Media_Components._cont = __PCSCFRecord_list_Of_Early_SDP_Media_Components__item_
    _PCSCFRecord_iMSCommunicationServiceIdentifier = OCT_STR(name=u'iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _PCSCFRecord_sessionPriority = ENUM(name=u'sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _PCSCFRecord_serviceRequestTimeStampFraction = INT(name=u'serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _PCSCFRecord_serviceDeliveryStartTimeStampFraction = INT(name=u'serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _PCSCFRecord_serviceDeliveryEndTimeStampFraction = INT(name=u'serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _PCSCFRecord_list_of_Requested_Party_Address = SEQ_OF(name=u'list-of-Requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _PCSCFRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name=u'list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _PCSCFRecord_nNI_Information = SEQ(name=u'nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')), opt=True)
    _PCSCFRecord_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _PCSCFRecord_servedPartyIPAddress = CHOICE(name=u'servedPartyIPAddress', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ServedPartyIPAddress')), opt=True)
    _PCSCFRecord_fromAddress = OCT_STR(name=u'fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_iMSEmergencyIndicator = NULL(name=u'iMSEmergencyIndicator', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_transit_IOI_Lists = SEQ_OF(name=u'transit-IOI-Lists', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _PCSCFRecord_iMSVisitedNetworkIdentifier = OCT_STR(name=u'iMSVisitedNetworkIdentifier', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_listOfReasonHeader = SEQ_OF(name=u'listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _PCSCFRecord_additionalAccessNetworkInformation = OCT_STR(name=u'additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_instanceId = OCT_STR(name=u'instanceId', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_subscriberEquipmentNumber = SET(name=u'subscriberEquipmentNumber', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentNumber')), opt=True)
    _PCSCFRecord_routeHeaderReceived = OCT_STR(name=u'routeHeaderReceived', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_routeHeaderTransmitted = OCT_STR(name=u'routeHeaderTransmitted', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name=u'list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PCSCFRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _PCSCFRecord_list_Of_AccessNetworkInfoChange._cont = __PCSCFRecord_list_Of_AccessNetworkInfoChange__item_
    _PCSCFRecord_listOfCalledIdentityChanges = SEQ_OF(name=u'listOfCalledIdentityChanges', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PCSCFRecord_listOfCalledIdentityChanges__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'CalledIdentityChange')))
    _PCSCFRecord_listOfCalledIdentityChanges._cont = __PCSCFRecord_listOfCalledIdentityChanges__item_
    _PCSCFRecord_cellularNetworkInformation = OCT_STR(name=u'cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PCSCFRecord_initialIMS_Charging_Identifier = OCT_STR(name=u'initialIMS-Charging-Identifier', mode=MODE_TYPE, tag=(105, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _PCSCFRecord_list_Of_AccessTransferInformation = SEQ_OF(name=u'list-Of-AccessTransferInformation', mode=MODE_TYPE, tag=(106, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PCSCFRecord_list_Of_AccessTransferInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessTransferInformation')))
    _PCSCFRecord_list_Of_AccessTransferInformation._cont = __PCSCFRecord_list_Of_AccessTransferInformation__item_
    _PCSCFRecord_relatedICID = OCT_STR(name=u'relatedICID', mode=MODE_TYPE, tag=(107, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _PCSCFRecord_relatedICIDGenerationNode = CHOICE(name=u'relatedICIDGenerationNode', mode=MODE_TYPE, tag=(108, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _PCSCFRecord_fEIdentifierList = SEQ_OF(name=u'fEIdentifierList', mode=MODE_TYPE, tag=(109, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    PCSCFRecord._cont = ASN1Dict([
        (u'recordType', _PCSCFRecord_recordType),
        (u'retransmission', _PCSCFRecord_retransmission),
        (u'sIP-Method', _PCSCFRecord_sIP_Method),
        (u'role-of-Node', _PCSCFRecord_role_of_Node),
        (u'nodeAddress', _PCSCFRecord_nodeAddress),
        (u'session-Id', _PCSCFRecord_session_Id),
        (u'list-Of-Calling-Party-Address', _PCSCFRecord_list_Of_Calling_Party_Address),
        (u'called-Party-Address', _PCSCFRecord_called_Party_Address),
        (u'privateUserID', _PCSCFRecord_privateUserID),
        (u'serviceRequestTimeStamp', _PCSCFRecord_serviceRequestTimeStamp),
        (u'serviceDeliveryStartTimeStamp', _PCSCFRecord_serviceDeliveryStartTimeStamp),
        (u'serviceDeliveryEndTimeStamp', _PCSCFRecord_serviceDeliveryEndTimeStamp),
        (u'recordOpeningTime', _PCSCFRecord_recordOpeningTime),
        (u'recordClosureTime', _PCSCFRecord_recordClosureTime),
        (u'interOperatorIdentifiers', _PCSCFRecord_interOperatorIdentifiers),
        (u'localRecordSequenceNumber', _PCSCFRecord_localRecordSequenceNumber),
        (u'recordSequenceNumber', _PCSCFRecord_recordSequenceNumber),
        (u'causeForRecordClosing', _PCSCFRecord_causeForRecordClosing),
        (u'incomplete-CDR-Indication', _PCSCFRecord_incomplete_CDR_Indication),
        (u'iMS-Charging-Identifier', _PCSCFRecord_iMS_Charging_Identifier),
        (u'list-Of-SDP-Media-Components', _PCSCFRecord_list_Of_SDP_Media_Components),
        (u'gGSNaddress', _PCSCFRecord_gGSNaddress),
        (u'serviceReasonReturnCode', _PCSCFRecord_serviceReasonReturnCode),
        (u'list-Of-Message-Bodies', _PCSCFRecord_list_Of_Message_Bodies),
        (u'recordExtensions', _PCSCFRecord_recordExtensions),
        (u'expiresInformation', _PCSCFRecord_expiresInformation),
        (u'list-Of-Associated-URI', _PCSCFRecord_list_Of_Associated_URI),
        (u'event', _PCSCFRecord_event),
        (u'accessNetworkInformation', _PCSCFRecord_accessNetworkInformation),
        (u'serviceContextID', _PCSCFRecord_serviceContextID),
        (u'list-of-subscription-ID', _PCSCFRecord_list_of_subscription_ID),
        (u'list-Of-Early-SDP-Media-Components', _PCSCFRecord_list_Of_Early_SDP_Media_Components),
        (u'iMSCommunicationServiceIdentifier', _PCSCFRecord_iMSCommunicationServiceIdentifier),
        (u'sessionPriority', _PCSCFRecord_sessionPriority),
        (u'serviceRequestTimeStampFraction', _PCSCFRecord_serviceRequestTimeStampFraction),
        (u'serviceDeliveryStartTimeStampFraction', _PCSCFRecord_serviceDeliveryStartTimeStampFraction),
        (u'serviceDeliveryEndTimeStampFraction', _PCSCFRecord_serviceDeliveryEndTimeStampFraction),
        (u'list-of-Requested-Party-Address', _PCSCFRecord_list_of_Requested_Party_Address),
        (u'list-Of-Called-Asserted-Identity', _PCSCFRecord_list_Of_Called_Asserted_Identity),
        (u'nNI-Information', _PCSCFRecord_nNI_Information),
        (u'userLocationInformation', _PCSCFRecord_userLocationInformation),
        (u'mSTimeZone', _PCSCFRecord_mSTimeZone),
        (u'servedPartyIPAddress', _PCSCFRecord_servedPartyIPAddress),
        (u'fromAddress', _PCSCFRecord_fromAddress),
        (u'iMSEmergencyIndicator', _PCSCFRecord_iMSEmergencyIndicator),
        (u'transit-IOI-Lists', _PCSCFRecord_transit_IOI_Lists),
        (u'iMSVisitedNetworkIdentifier', _PCSCFRecord_iMSVisitedNetworkIdentifier),
        (u'listOfReasonHeader', _PCSCFRecord_listOfReasonHeader),
        (u'additionalAccessNetworkInformation', _PCSCFRecord_additionalAccessNetworkInformation),
        (u'instanceId', _PCSCFRecord_instanceId),
        (u'subscriberEquipmentNumber', _PCSCFRecord_subscriberEquipmentNumber),
        (u'routeHeaderReceived', _PCSCFRecord_routeHeaderReceived),
        (u'routeHeaderTransmitted', _PCSCFRecord_routeHeaderTransmitted),
        (u'list-Of-AccessNetworkInfoChange', _PCSCFRecord_list_Of_AccessNetworkInfoChange),
        (u'listOfCalledIdentityChanges', _PCSCFRecord_listOfCalledIdentityChanges),
        (u'cellularNetworkInformation', _PCSCFRecord_cellularNetworkInformation),
        (u'initialIMS-Charging-Identifier', _PCSCFRecord_initialIMS_Charging_Identifier),
        (u'list-Of-AccessTransferInformation', _PCSCFRecord_list_Of_AccessTransferInformation),
        (u'relatedICID', _PCSCFRecord_relatedICID),
        (u'relatedICIDGenerationNode', _PCSCFRecord_relatedICIDGenerationNode),
        (u'fEIdentifierList', _PCSCFRecord_fEIdentifierList),
        ])
    PCSCFRecord._ext = None
    
    #-----< ICSCFRecord >-----#
    ICSCFRecord = SET(name=u'ICSCFRecord', mode=MODE_TYPE)
    _ICSCFRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _ICSCFRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_sIP_Method = STR_GRAPH(name=u'sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _ICSCFRecord_role_of_Node = ENUM(name=u'role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _ICSCFRecord_nodeAddress = CHOICE(name=u'nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ICSCFRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _ICSCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name=u'list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ICSCFRecord_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _ICSCFRecord_serviceRequestTimeStamp = OCT_STR(name=u'serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ICSCFRecord_interOperatorIdentifiers = SEQ(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _ICSCFRecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ICSCFRecord_causeForRecordClosing = ENUM(name=u'causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _ICSCFRecord_incomplete_CDR_Indication = SET(name=u'incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _ICSCFRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _ICSCFRecord_serviceReasonReturnCode = STR_UTF8(name=u'serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _ICSCFRecord_expiresInformation = INT(name=u'expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_list_Of_Associated_URI = SEQ_OF(name=u'list-Of-Associated-URI', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ICSCFRecord_event = STR_UTF8(name=u'event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_accessNetworkInformation = OCT_STR(name=u'accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _ICSCFRecord_numberPortabilityRouting = STR_GRAPH(name=u'numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _ICSCFRecord_carrierSelectRouting = STR_GRAPH(name=u'carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _ICSCFRecord_sessionPriority = ENUM(name=u'sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _ICSCFRecord_serviceRequestTimeStampFraction = INT(name=u'serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ICSCFRecord_transit_IOI_List = STR_GRAPH(name=u'transit-IOI-List', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _ICSCFRecord_fromAddress = OCT_STR(name=u'fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_iMSEmergencyIndicator = NULL(name=u'iMSEmergencyIndicator', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_listOfReasonHeader = SEQ_OF(name=u'listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _ICSCFRecord_additionalAccessNetworkInformation = OCT_STR(name=u'additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_routeHeaderTransmitted = OCT_STR(name=u'routeHeaderTransmitted', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_s_CSCF_Information = SEQ(name=u's-CSCF-Information', mode=MODE_TYPE, tag=(61, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'S-CSCF-Information')), opt=True)
    _ICSCFRecord_cellularNetworkInformation = OCT_STR(name=u'cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ICSCFRecord_fEIdentifierList = SEQ_OF(name=u'fEIdentifierList', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    ICSCFRecord._cont = ASN1Dict([
        (u'recordType', _ICSCFRecord_recordType),
        (u'retransmission', _ICSCFRecord_retransmission),
        (u'sIP-Method', _ICSCFRecord_sIP_Method),
        (u'role-of-Node', _ICSCFRecord_role_of_Node),
        (u'nodeAddress', _ICSCFRecord_nodeAddress),
        (u'session-Id', _ICSCFRecord_session_Id),
        (u'list-Of-Calling-Party-Address', _ICSCFRecord_list_Of_Calling_Party_Address),
        (u'called-Party-Address', _ICSCFRecord_called_Party_Address),
        (u'serviceRequestTimeStamp', _ICSCFRecord_serviceRequestTimeStamp),
        (u'interOperatorIdentifiers', _ICSCFRecord_interOperatorIdentifiers),
        (u'localRecordSequenceNumber', _ICSCFRecord_localRecordSequenceNumber),
        (u'causeForRecordClosing', _ICSCFRecord_causeForRecordClosing),
        (u'incomplete-CDR-Indication', _ICSCFRecord_incomplete_CDR_Indication),
        (u'iMS-Charging-Identifier', _ICSCFRecord_iMS_Charging_Identifier),
        (u'serviceReasonReturnCode', _ICSCFRecord_serviceReasonReturnCode),
        (u'recordExtensions', _ICSCFRecord_recordExtensions),
        (u'expiresInformation', _ICSCFRecord_expiresInformation),
        (u'list-Of-Associated-URI', _ICSCFRecord_list_Of_Associated_URI),
        (u'event', _ICSCFRecord_event),
        (u'accessNetworkInformation', _ICSCFRecord_accessNetworkInformation),
        (u'serviceContextID', _ICSCFRecord_serviceContextID),
        (u'numberPortabilityRouting', _ICSCFRecord_numberPortabilityRouting),
        (u'carrierSelectRouting', _ICSCFRecord_carrierSelectRouting),
        (u'sessionPriority', _ICSCFRecord_sessionPriority),
        (u'serviceRequestTimeStampFraction', _ICSCFRecord_serviceRequestTimeStampFraction),
        (u'transit-IOI-List', _ICSCFRecord_transit_IOI_List),
        (u'userLocationInformation', _ICSCFRecord_userLocationInformation),
        (u'mSTimeZone', _ICSCFRecord_mSTimeZone),
        (u'fromAddress', _ICSCFRecord_fromAddress),
        (u'iMSEmergencyIndicator', _ICSCFRecord_iMSEmergencyIndicator),
        (u'listOfReasonHeader', _ICSCFRecord_listOfReasonHeader),
        (u'additionalAccessNetworkInformation', _ICSCFRecord_additionalAccessNetworkInformation),
        (u'routeHeaderTransmitted', _ICSCFRecord_routeHeaderTransmitted),
        (u's-CSCF-Information', _ICSCFRecord_s_CSCF_Information),
        (u'cellularNetworkInformation', _ICSCFRecord_cellularNetworkInformation),
        (u'fEIdentifierList', _ICSCFRecord_fEIdentifierList),
        ])
    ICSCFRecord._ext = None
    
    #-----< MRFCRecord >-----#
    MRFCRecord = SET(name=u'MRFCRecord', mode=MODE_TYPE)
    _MRFCRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MRFCRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_sIP_Method = STR_GRAPH(name=u'sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _MRFCRecord_nodeAddress = CHOICE(name=u'nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _MRFCRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _MRFCRecord_list_Of_Calling_Party_Address = SEQ_OF(name=u'list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _MRFCRecord_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _MRFCRecord_serviceRequestTimeStamp = OCT_STR(name=u'serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MRFCRecord_serviceDeliveryStartTimeStamp = OCT_STR(name=u'serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MRFCRecord_serviceDeliveryEndTimeStamp = OCT_STR(name=u'serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MRFCRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MRFCRecord_recordClosureTime = OCT_STR(name=u'recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MRFCRecord_interOperatorIdentifiers = SEQ(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _MRFCRecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MRFCRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_causeForRecordClosing = ENUM(name=u'causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _MRFCRecord_incomplete_CDR_Indication = SET(name=u'incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _MRFCRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _MRFCRecord_list_Of_SDP_Media_Components = SEQ_OF(name=u'list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MRFCRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _MRFCRecord_list_Of_SDP_Media_Components._cont = __MRFCRecord_list_Of_SDP_Media_Components__item_
    _MRFCRecord_gGSNaddress = CHOICE(name=u'gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _MRFCRecord_serviceReasonReturnCode = STR_UTF8(name=u'serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MRFCRecord_expiresInformation = INT(name=u'expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_event = STR_UTF8(name=u'event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_accessNetworkInformation = OCT_STR(name=u'accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _MRFCRecord_list_of_subscription_ID = SEQ_OF(name=u'list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MRFCRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _MRFCRecord_list_of_subscription_ID._cont = __MRFCRecord_list_of_subscription_ID__item_
    _MRFCRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name=u'list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MRFCRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _MRFCRecord_list_Of_Early_SDP_Media_Components._cont = __MRFCRecord_list_Of_Early_SDP_Media_Components__item_
    _MRFCRecord_sessionPriority = ENUM(name=u'sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _MRFCRecord_serviceRequestTimeStampFraction = INT(name=u'serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MRFCRecord_serviceDeliveryStartTimeStampFraction = INT(name=u'serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MRFCRecord_serviceDeliveryEndTimeStampFraction = INT(name=u'serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MRFCRecord_applicationServersInformation = SEQ_OF(name=u'applicationServersInformation', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MRFCRecord_applicationServersInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'ApplicationServersInformation')))
    _MRFCRecord_applicationServersInformation._cont = __MRFCRecord_applicationServersInformation__item_
    _MRFCRecord_online_charging_flag = NULL(name=u'online-charging-flag', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_transit_IOI_List = STR_GRAPH(name=u'transit-IOI-List', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _MRFCRecord_fromAddress = OCT_STR(name=u'fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_listOfReasonHeader = SEQ_OF(name=u'listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _MRFCRecord_additionalAccessNetworkInformation = OCT_STR(name=u'additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name=u'list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MRFCRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _MRFCRecord_list_Of_AccessNetworkInfoChange._cont = __MRFCRecord_list_Of_AccessNetworkInfoChange__item_
    _MRFCRecord_cellularNetworkInformation = OCT_STR(name=u'cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MRFCRecord_service_Id = STR_GRAPH(name=u'service-Id', mode=MODE_TYPE, tag=(70, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Service-Id')), opt=True)
    _MRFCRecord_requested_Party_Address = CHOICE(name=u'requested-Party-Address', mode=MODE_TYPE, tag=(71, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _MRFCRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name=u'list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(72, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _MRFCRecord_fEIdentifierList = SEQ_OF(name=u'fEIdentifierList', mode=MODE_TYPE, tag=(73, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    MRFCRecord._cont = ASN1Dict([
        (u'recordType', _MRFCRecord_recordType),
        (u'retransmission', _MRFCRecord_retransmission),
        (u'sIP-Method', _MRFCRecord_sIP_Method),
        (u'nodeAddress', _MRFCRecord_nodeAddress),
        (u'session-Id', _MRFCRecord_session_Id),
        (u'list-Of-Calling-Party-Address', _MRFCRecord_list_Of_Calling_Party_Address),
        (u'called-Party-Address', _MRFCRecord_called_Party_Address),
        (u'serviceRequestTimeStamp', _MRFCRecord_serviceRequestTimeStamp),
        (u'serviceDeliveryStartTimeStamp', _MRFCRecord_serviceDeliveryStartTimeStamp),
        (u'serviceDeliveryEndTimeStamp', _MRFCRecord_serviceDeliveryEndTimeStamp),
        (u'recordOpeningTime', _MRFCRecord_recordOpeningTime),
        (u'recordClosureTime', _MRFCRecord_recordClosureTime),
        (u'interOperatorIdentifiers', _MRFCRecord_interOperatorIdentifiers),
        (u'localRecordSequenceNumber', _MRFCRecord_localRecordSequenceNumber),
        (u'recordSequenceNumber', _MRFCRecord_recordSequenceNumber),
        (u'causeForRecordClosing', _MRFCRecord_causeForRecordClosing),
        (u'incomplete-CDR-Indication', _MRFCRecord_incomplete_CDR_Indication),
        (u'iMS-Charging-Identifier', _MRFCRecord_iMS_Charging_Identifier),
        (u'list-Of-SDP-Media-Components', _MRFCRecord_list_Of_SDP_Media_Components),
        (u'gGSNaddress', _MRFCRecord_gGSNaddress),
        (u'serviceReasonReturnCode', _MRFCRecord_serviceReasonReturnCode),
        (u'recordExtensions', _MRFCRecord_recordExtensions),
        (u'expiresInformation', _MRFCRecord_expiresInformation),
        (u'event', _MRFCRecord_event),
        (u'accessNetworkInformation', _MRFCRecord_accessNetworkInformation),
        (u'serviceContextID', _MRFCRecord_serviceContextID),
        (u'list-of-subscription-ID', _MRFCRecord_list_of_subscription_ID),
        (u'list-Of-Early-SDP-Media-Components', _MRFCRecord_list_Of_Early_SDP_Media_Components),
        (u'sessionPriority', _MRFCRecord_sessionPriority),
        (u'serviceRequestTimeStampFraction', _MRFCRecord_serviceRequestTimeStampFraction),
        (u'serviceDeliveryStartTimeStampFraction', _MRFCRecord_serviceDeliveryStartTimeStampFraction),
        (u'serviceDeliveryEndTimeStampFraction', _MRFCRecord_serviceDeliveryEndTimeStampFraction),
        (u'applicationServersInformation', _MRFCRecord_applicationServersInformation),
        (u'online-charging-flag', _MRFCRecord_online_charging_flag),
        (u'transit-IOI-List', _MRFCRecord_transit_IOI_List),
        (u'userLocationInformation', _MRFCRecord_userLocationInformation),
        (u'mSTimeZone', _MRFCRecord_mSTimeZone),
        (u'fromAddress', _MRFCRecord_fromAddress),
        (u'listOfReasonHeader', _MRFCRecord_listOfReasonHeader),
        (u'additionalAccessNetworkInformation', _MRFCRecord_additionalAccessNetworkInformation),
        (u'list-Of-AccessNetworkInfoChange', _MRFCRecord_list_Of_AccessNetworkInfoChange),
        (u'cellularNetworkInformation', _MRFCRecord_cellularNetworkInformation),
        (u'service-Id', _MRFCRecord_service_Id),
        (u'requested-Party-Address', _MRFCRecord_requested_Party_Address),
        (u'list-Of-Called-Asserted-Identity', _MRFCRecord_list_Of_Called_Asserted_Identity),
        (u'fEIdentifierList', _MRFCRecord_fEIdentifierList),
        ])
    MRFCRecord._ext = None
    
    #-----< MGCFRecord >-----#
    MGCFRecord = SET(name=u'MGCFRecord', mode=MODE_TYPE)
    _MGCFRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MGCFRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_sIP_Method = STR_GRAPH(name=u'sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _MGCFRecord_role_of_Node = ENUM(name=u'role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _MGCFRecord_nodeAddress = CHOICE(name=u'nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _MGCFRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _MGCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name=u'list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _MGCFRecord_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _MGCFRecord_serviceRequestTimeStamp = OCT_STR(name=u'serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MGCFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name=u'serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MGCFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name=u'serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MGCFRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MGCFRecord_recordClosureTime = OCT_STR(name=u'recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MGCFRecord_interOperatorIdentifiers = SEQ(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _MGCFRecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MGCFRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_causeForRecordClosing = ENUM(name=u'causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _MGCFRecord_incomplete_CDR_Indication = SET(name=u'incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _MGCFRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _MGCFRecord_list_Of_SDP_Media_Components = SEQ_OF(name=u'list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MGCFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _MGCFRecord_list_Of_SDP_Media_Components._cont = __MGCFRecord_list_Of_SDP_Media_Components__item_
    _MGCFRecord_serviceReasonReturnCode = STR_UTF8(name=u'serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MGCFRecord_expiresInformation = INT(name=u'expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_event = STR_UTF8(name=u'event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_accessNetworkInformation = OCT_STR(name=u'accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _MGCFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name=u'list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MGCFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _MGCFRecord_list_Of_Early_SDP_Media_Components._cont = __MGCFRecord_list_Of_Early_SDP_Media_Components__item_
    _MGCFRecord_numberPortabilityRouting = STR_GRAPH(name=u'numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _MGCFRecord_carrierSelectRouting = STR_GRAPH(name=u'carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _MGCFRecord_sessionPriority = ENUM(name=u'sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _MGCFRecord_serviceRequestTimeStampFraction = INT(name=u'serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MGCFRecord_serviceDeliveryStartTimeStampFraction = INT(name=u'serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MGCFRecord_serviceDeliveryEndTimeStampFraction = INT(name=u'serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MGCFRecord_realTimeTariffInformation = SEQ_OF(name=u'realTimeTariffInformation', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MGCFRecord_realTimeTariffInformation__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'RealTimeTariffInformation')))
    _MGCFRecord_realTimeTariffInformation._cont = __MGCFRecord_realTimeTariffInformation__item_
    _MGCFRecord_transit_IOI_List = STR_GRAPH(name=u'transit-IOI-List', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_fromAddress = OCT_STR(name=u'fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_listOfReasonHeader = SEQ_OF(name=u'listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _MGCFRecord_additionalAccessNetworkInformation = OCT_STR(name=u'additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name=u'list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MGCFRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _MGCFRecord_list_Of_AccessNetworkInfoChange._cont = __MGCFRecord_list_Of_AccessNetworkInfoChange__item_
    _MGCFRecord_cellularNetworkInformation = OCT_STR(name=u'cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MGCFRecord_trunkGroupID = CHOICE(name=u'trunkGroupID', mode=MODE_TYPE, tag=(80, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TrunkGroupID')), opt=True)
    _MGCFRecord_bearerService = SEQ(name=u'bearerService', mode=MODE_TYPE, tag=(81, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransmissionMedium')), opt=True)
    _MGCFRecord_iSUPCause = SEQ(name=u'iSUPCause', mode=MODE_TYPE, tag=(82, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ISUPCause')), opt=True)
    _MGCFRecord_fEIdentifierList = SEQ_OF(name=u'fEIdentifierList', mode=MODE_TYPE, tag=(83, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    MGCFRecord._cont = ASN1Dict([
        (u'recordType', _MGCFRecord_recordType),
        (u'retransmission', _MGCFRecord_retransmission),
        (u'sIP-Method', _MGCFRecord_sIP_Method),
        (u'role-of-Node', _MGCFRecord_role_of_Node),
        (u'nodeAddress', _MGCFRecord_nodeAddress),
        (u'session-Id', _MGCFRecord_session_Id),
        (u'list-Of-Calling-Party-Address', _MGCFRecord_list_Of_Calling_Party_Address),
        (u'called-Party-Address', _MGCFRecord_called_Party_Address),
        (u'serviceRequestTimeStamp', _MGCFRecord_serviceRequestTimeStamp),
        (u'serviceDeliveryStartTimeStamp', _MGCFRecord_serviceDeliveryStartTimeStamp),
        (u'serviceDeliveryEndTimeStamp', _MGCFRecord_serviceDeliveryEndTimeStamp),
        (u'recordOpeningTime', _MGCFRecord_recordOpeningTime),
        (u'recordClosureTime', _MGCFRecord_recordClosureTime),
        (u'interOperatorIdentifiers', _MGCFRecord_interOperatorIdentifiers),
        (u'localRecordSequenceNumber', _MGCFRecord_localRecordSequenceNumber),
        (u'recordSequenceNumber', _MGCFRecord_recordSequenceNumber),
        (u'causeForRecordClosing', _MGCFRecord_causeForRecordClosing),
        (u'incomplete-CDR-Indication', _MGCFRecord_incomplete_CDR_Indication),
        (u'iMS-Charging-Identifier', _MGCFRecord_iMS_Charging_Identifier),
        (u'list-Of-SDP-Media-Components', _MGCFRecord_list_Of_SDP_Media_Components),
        (u'serviceReasonReturnCode', _MGCFRecord_serviceReasonReturnCode),
        (u'recordExtensions', _MGCFRecord_recordExtensions),
        (u'expiresInformation', _MGCFRecord_expiresInformation),
        (u'event', _MGCFRecord_event),
        (u'accessNetworkInformation', _MGCFRecord_accessNetworkInformation),
        (u'serviceContextID', _MGCFRecord_serviceContextID),
        (u'list-Of-Early-SDP-Media-Components', _MGCFRecord_list_Of_Early_SDP_Media_Components),
        (u'numberPortabilityRouting', _MGCFRecord_numberPortabilityRouting),
        (u'carrierSelectRouting', _MGCFRecord_carrierSelectRouting),
        (u'sessionPriority', _MGCFRecord_sessionPriority),
        (u'serviceRequestTimeStampFraction', _MGCFRecord_serviceRequestTimeStampFraction),
        (u'serviceDeliveryStartTimeStampFraction', _MGCFRecord_serviceDeliveryStartTimeStampFraction),
        (u'serviceDeliveryEndTimeStampFraction', _MGCFRecord_serviceDeliveryEndTimeStampFraction),
        (u'realTimeTariffInformation', _MGCFRecord_realTimeTariffInformation),
        (u'transit-IOI-List', _MGCFRecord_transit_IOI_List),
        (u'fromAddress', _MGCFRecord_fromAddress),
        (u'listOfReasonHeader', _MGCFRecord_listOfReasonHeader),
        (u'additionalAccessNetworkInformation', _MGCFRecord_additionalAccessNetworkInformation),
        (u'list-Of-AccessNetworkInfoChange', _MGCFRecord_list_Of_AccessNetworkInfoChange),
        (u'cellularNetworkInformation', _MGCFRecord_cellularNetworkInformation),
        (u'trunkGroupID', _MGCFRecord_trunkGroupID),
        (u'bearerService', _MGCFRecord_bearerService),
        (u'iSUPCause', _MGCFRecord_iSUPCause),
        (u'fEIdentifierList', _MGCFRecord_fEIdentifierList),
        ])
    MGCFRecord._ext = None
    
    #-----< BGCFRecord >-----#
    BGCFRecord = SET(name=u'BGCFRecord', mode=MODE_TYPE)
    _BGCFRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _BGCFRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_sIP_Method = STR_GRAPH(name=u'sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _BGCFRecord_role_of_Node = ENUM(name=u'role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _BGCFRecord_nodeAddress = CHOICE(name=u'nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _BGCFRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _BGCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name=u'list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _BGCFRecord_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _BGCFRecord_serviceRequestTimeStamp = OCT_STR(name=u'serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _BGCFRecord_interOperatorIdentifiers = SEQ(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _BGCFRecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _BGCFRecord_causeForRecordClosing = ENUM(name=u'causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _BGCFRecord_incomplete_CDR_Indication = SET(name=u'incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _BGCFRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _BGCFRecord_serviceReasonReturnCode = STR_UTF8(name=u'serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _BGCFRecord_expiresInformation = INT(name=u'expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_event = STR_UTF8(name=u'event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_accessNetworkInformation = OCT_STR(name=u'accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _BGCFRecord_numberPortabilityRouting = STR_GRAPH(name=u'numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _BGCFRecord_carrierSelectRouting = STR_GRAPH(name=u'carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _BGCFRecord_sessionPriority = ENUM(name=u'sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _BGCFRecord_serviceRequestTimeStampFraction = INT(name=u'serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _BGCFRecord_serviceDeliveryStartTimeStampFraction = INT(name=u'serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _BGCFRecord_serviceDeliveryEndTimeStampFraction = INT(name=u'serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _BGCFRecord_transit_IOI_List = STR_GRAPH(name=u'transit-IOI-List', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_nNI_Information = SEQ(name=u'nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')), opt=True)
    _BGCFRecord_fromAddress = OCT_STR(name=u'fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_listOfReasonHeader = SEQ_OF(name=u'listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _BGCFRecord_additionalAccessNetworkInformation = OCT_STR(name=u'additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_cellularNetworkInformation = OCT_STR(name=u'cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BGCFRecord_fEIdentifierList = SEQ_OF(name=u'fEIdentifierList', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    BGCFRecord._cont = ASN1Dict([
        (u'recordType', _BGCFRecord_recordType),
        (u'retransmission', _BGCFRecord_retransmission),
        (u'sIP-Method', _BGCFRecord_sIP_Method),
        (u'role-of-Node', _BGCFRecord_role_of_Node),
        (u'nodeAddress', _BGCFRecord_nodeAddress),
        (u'session-Id', _BGCFRecord_session_Id),
        (u'list-Of-Calling-Party-Address', _BGCFRecord_list_Of_Calling_Party_Address),
        (u'called-Party-Address', _BGCFRecord_called_Party_Address),
        (u'serviceRequestTimeStamp', _BGCFRecord_serviceRequestTimeStamp),
        (u'interOperatorIdentifiers', _BGCFRecord_interOperatorIdentifiers),
        (u'localRecordSequenceNumber', _BGCFRecord_localRecordSequenceNumber),
        (u'causeForRecordClosing', _BGCFRecord_causeForRecordClosing),
        (u'incomplete-CDR-Indication', _BGCFRecord_incomplete_CDR_Indication),
        (u'iMS-Charging-Identifier', _BGCFRecord_iMS_Charging_Identifier),
        (u'serviceReasonReturnCode', _BGCFRecord_serviceReasonReturnCode),
        (u'recordExtensions', _BGCFRecord_recordExtensions),
        (u'expiresInformation', _BGCFRecord_expiresInformation),
        (u'event', _BGCFRecord_event),
        (u'accessNetworkInformation', _BGCFRecord_accessNetworkInformation),
        (u'serviceContextID', _BGCFRecord_serviceContextID),
        (u'numberPortabilityRouting', _BGCFRecord_numberPortabilityRouting),
        (u'carrierSelectRouting', _BGCFRecord_carrierSelectRouting),
        (u'sessionPriority', _BGCFRecord_sessionPriority),
        (u'serviceRequestTimeStampFraction', _BGCFRecord_serviceRequestTimeStampFraction),
        (u'serviceDeliveryStartTimeStampFraction', _BGCFRecord_serviceDeliveryStartTimeStampFraction),
        (u'serviceDeliveryEndTimeStampFraction', _BGCFRecord_serviceDeliveryEndTimeStampFraction),
        (u'transit-IOI-List', _BGCFRecord_transit_IOI_List),
        (u'nNI-Information', _BGCFRecord_nNI_Information),
        (u'fromAddress', _BGCFRecord_fromAddress),
        (u'listOfReasonHeader', _BGCFRecord_listOfReasonHeader),
        (u'additionalAccessNetworkInformation', _BGCFRecord_additionalAccessNetworkInformation),
        (u'cellularNetworkInformation', _BGCFRecord_cellularNetworkInformation),
        (u'fEIdentifierList', _BGCFRecord_fEIdentifierList),
        ])
    BGCFRecord._ext = None
    
    #-----< ASRecord >-----#
    ASRecord = SET(name=u'ASRecord', mode=MODE_TYPE)
    _ASRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _ASRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_sIP_Method = STR_GRAPH(name=u'sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _ASRecord_role_of_Node = ENUM(name=u'role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _ASRecord_nodeAddress = CHOICE(name=u'nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ASRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _ASRecord_list_Of_Calling_Party_Address = SEQ_OF(name=u'list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ASRecord_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _ASRecord_privateUserID = STR_GRAPH(name=u'privateUserID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_serviceRequestTimeStamp = OCT_STR(name=u'serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ASRecord_serviceDeliveryStartTimeStamp = OCT_STR(name=u'serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ASRecord_serviceDeliveryEndTimeStamp = OCT_STR(name=u'serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ASRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ASRecord_recordClosureTime = OCT_STR(name=u'recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ASRecord_interOperatorIdentifiers = SEQ(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _ASRecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ASRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_causeForRecordClosing = ENUM(name=u'causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _ASRecord_incomplete_CDR_Indication = SET(name=u'incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _ASRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _ASRecord_list_Of_SDP_Media_Components = SEQ_OF(name=u'list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _ASRecord_list_Of_SDP_Media_Components._cont = __ASRecord_list_Of_SDP_Media_Components__item_
    _ASRecord_gGSNaddress = CHOICE(name=u'gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ASRecord_serviceReasonReturnCode = STR_UTF8(name=u'serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_list_Of_Message_Bodies = SEQ_OF(name=u'list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _ASRecord_list_Of_Message_Bodies._cont = __ASRecord_list_Of_Message_Bodies__item_
    _ASRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _ASRecord_expiresInformation = INT(name=u'expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_event = STR_UTF8(name=u'event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_accessNetworkInformation = OCT_STR(name=u'accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _ASRecord_list_of_subscription_ID = SEQ_OF(name=u'list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _ASRecord_list_of_subscription_ID._cont = __ASRecord_list_of_subscription_ID__item_
    _ASRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name=u'list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _ASRecord_list_Of_Early_SDP_Media_Components._cont = __ASRecord_list_Of_Early_SDP_Media_Components__item_
    _ASRecord_iMSCommunicationServiceIdentifier = OCT_STR(name=u'iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _ASRecord_numberPortabilityRouting = STR_GRAPH(name=u'numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _ASRecord_carrierSelectRouting = STR_GRAPH(name=u'carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _ASRecord_sessionPriority = ENUM(name=u'sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _ASRecord_serviceRequestTimeStampFraction = INT(name=u'serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ASRecord_serviceDeliveryStartTimeStampFraction = INT(name=u'serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ASRecord_serviceDeliveryEndTimeStampFraction = INT(name=u'serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ASRecord_list_of_Requested_Party_Address = SEQ_OF(name=u'list-of-Requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ASRecord_online_charging_flag = NULL(name=u'online-charging-flag', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_realTimeTariffInformation = SEQ_OF(name=u'realTimeTariffInformation', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_realTimeTariffInformation__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'RealTimeTariffInformation')))
    _ASRecord_realTimeTariffInformation._cont = __ASRecord_realTimeTariffInformation__item_
    _ASRecord_nNI_Information = SEQ(name=u'nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')), opt=True)
    _ASRecord_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _ASRecord_fromAddress = OCT_STR(name=u'fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_transit_IOI_Lists = SEQ_OF(name=u'transit-IOI-Lists', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _ASRecord_iMSVisitedNetworkIdentifier = OCT_STR(name=u'iMSVisitedNetworkIdentifier', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_listOfReasonHeader = SEQ_OF(name=u'listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _ASRecord_additionalAccessNetworkInformation = OCT_STR(name=u'additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_instanceId = OCT_STR(name=u'instanceId', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_subscriberEquipmentNumber = SET(name=u'subscriberEquipmentNumber', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentNumber')), opt=True)
    _ASRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name=u'list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _ASRecord_list_Of_AccessNetworkInfoChange._cont = __ASRecord_list_Of_AccessNetworkInfoChange__item_
    _ASRecord_listOfCalledIdentityChanges = SEQ_OF(name=u'listOfCalledIdentityChanges', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_listOfCalledIdentityChanges__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'CalledIdentityChange')))
    _ASRecord_listOfCalledIdentityChanges._cont = __ASRecord_listOfCalledIdentityChanges__item_
    _ASRecord_cellularNetworkInformation = OCT_STR(name=u'cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_serviceSpecificInfo = SEQ_OF(name=u'serviceSpecificInfo', mode=MODE_TYPE, tag=(100, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_serviceSpecificInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceSpecificInfo')))
    _ASRecord_serviceSpecificInfo._cont = __ASRecord_serviceSpecificInfo__item_
    _ASRecord_requested_Party_Address = CHOICE(name=u'requested-Party-Address', mode=MODE_TYPE, tag=(101, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _ASRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name=u'list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(102, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ASRecord_alternateChargedPartyAddress = STR_UTF8(name=u'alternateChargedPartyAddress', mode=MODE_TYPE, tag=(103, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ASRecord_outgoingSessionId = STR_GRAPH(name=u'outgoingSessionId', mode=MODE_TYPE, tag=(104, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _ASRecord_initialIMS_Charging_Identifier = OCT_STR(name=u'initialIMS-Charging-Identifier', mode=MODE_TYPE, tag=(105, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _ASRecord_list_Of_AccessTransferInformation = SEQ_OF(name=u'list-Of-AccessTransferInformation', mode=MODE_TYPE, tag=(106, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ASRecord_list_Of_AccessTransferInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessTransferInformation')))
    _ASRecord_list_Of_AccessTransferInformation._cont = __ASRecord_list_Of_AccessTransferInformation__item_
    _ASRecord_tADS_Identifier = ENUM(name=u'tADS-Identifier', mode=MODE_TYPE, tag=(109, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TADIdentifier')), opt=True)
    _ASRecord_vlr_Number = OCT_STR(name=u'vlr-Number', mode=MODE_TYPE, tag=(110, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSCAddress')), opt=True)
    _ASRecord_msc_Address = OCT_STR(name=u'msc-Address', mode=MODE_TYPE, tag=(111, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSCAddress')), opt=True)
    _ASRecord_threeGPPPSDataOffStatus = ENUM(name=u'threeGPPPSDataOffStatus', mode=MODE_TYPE, tag=(112, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ThreeGPPPSDataOffStatus')), opt=True)
    _ASRecord_fEIdentifierList = SEQ_OF(name=u'fEIdentifierList', mode=MODE_TYPE, tag=(113, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    ASRecord._cont = ASN1Dict([
        (u'recordType', _ASRecord_recordType),
        (u'retransmission', _ASRecord_retransmission),
        (u'sIP-Method', _ASRecord_sIP_Method),
        (u'role-of-Node', _ASRecord_role_of_Node),
        (u'nodeAddress', _ASRecord_nodeAddress),
        (u'session-Id', _ASRecord_session_Id),
        (u'list-Of-Calling-Party-Address', _ASRecord_list_Of_Calling_Party_Address),
        (u'called-Party-Address', _ASRecord_called_Party_Address),
        (u'privateUserID', _ASRecord_privateUserID),
        (u'serviceRequestTimeStamp', _ASRecord_serviceRequestTimeStamp),
        (u'serviceDeliveryStartTimeStamp', _ASRecord_serviceDeliveryStartTimeStamp),
        (u'serviceDeliveryEndTimeStamp', _ASRecord_serviceDeliveryEndTimeStamp),
        (u'recordOpeningTime', _ASRecord_recordOpeningTime),
        (u'recordClosureTime', _ASRecord_recordClosureTime),
        (u'interOperatorIdentifiers', _ASRecord_interOperatorIdentifiers),
        (u'localRecordSequenceNumber', _ASRecord_localRecordSequenceNumber),
        (u'recordSequenceNumber', _ASRecord_recordSequenceNumber),
        (u'causeForRecordClosing', _ASRecord_causeForRecordClosing),
        (u'incomplete-CDR-Indication', _ASRecord_incomplete_CDR_Indication),
        (u'iMS-Charging-Identifier', _ASRecord_iMS_Charging_Identifier),
        (u'list-Of-SDP-Media-Components', _ASRecord_list_Of_SDP_Media_Components),
        (u'gGSNaddress', _ASRecord_gGSNaddress),
        (u'serviceReasonReturnCode', _ASRecord_serviceReasonReturnCode),
        (u'list-Of-Message-Bodies', _ASRecord_list_Of_Message_Bodies),
        (u'recordExtensions', _ASRecord_recordExtensions),
        (u'expiresInformation', _ASRecord_expiresInformation),
        (u'event', _ASRecord_event),
        (u'accessNetworkInformation', _ASRecord_accessNetworkInformation),
        (u'serviceContextID', _ASRecord_serviceContextID),
        (u'list-of-subscription-ID', _ASRecord_list_of_subscription_ID),
        (u'list-Of-Early-SDP-Media-Components', _ASRecord_list_Of_Early_SDP_Media_Components),
        (u'iMSCommunicationServiceIdentifier', _ASRecord_iMSCommunicationServiceIdentifier),
        (u'numberPortabilityRouting', _ASRecord_numberPortabilityRouting),
        (u'carrierSelectRouting', _ASRecord_carrierSelectRouting),
        (u'sessionPriority', _ASRecord_sessionPriority),
        (u'serviceRequestTimeStampFraction', _ASRecord_serviceRequestTimeStampFraction),
        (u'serviceDeliveryStartTimeStampFraction', _ASRecord_serviceDeliveryStartTimeStampFraction),
        (u'serviceDeliveryEndTimeStampFraction', _ASRecord_serviceDeliveryEndTimeStampFraction),
        (u'list-of-Requested-Party-Address', _ASRecord_list_of_Requested_Party_Address),
        (u'online-charging-flag', _ASRecord_online_charging_flag),
        (u'realTimeTariffInformation', _ASRecord_realTimeTariffInformation),
        (u'nNI-Information', _ASRecord_nNI_Information),
        (u'userLocationInformation', _ASRecord_userLocationInformation),
        (u'mSTimeZone', _ASRecord_mSTimeZone),
        (u'fromAddress', _ASRecord_fromAddress),
        (u'transit-IOI-Lists', _ASRecord_transit_IOI_Lists),
        (u'iMSVisitedNetworkIdentifier', _ASRecord_iMSVisitedNetworkIdentifier),
        (u'listOfReasonHeader', _ASRecord_listOfReasonHeader),
        (u'additionalAccessNetworkInformation', _ASRecord_additionalAccessNetworkInformation),
        (u'instanceId', _ASRecord_instanceId),
        (u'subscriberEquipmentNumber', _ASRecord_subscriberEquipmentNumber),
        (u'list-Of-AccessNetworkInfoChange', _ASRecord_list_Of_AccessNetworkInfoChange),
        (u'listOfCalledIdentityChanges', _ASRecord_listOfCalledIdentityChanges),
        (u'cellularNetworkInformation', _ASRecord_cellularNetworkInformation),
        (u'serviceSpecificInfo', _ASRecord_serviceSpecificInfo),
        (u'requested-Party-Address', _ASRecord_requested_Party_Address),
        (u'list-Of-Called-Asserted-Identity', _ASRecord_list_Of_Called_Asserted_Identity),
        (u'alternateChargedPartyAddress', _ASRecord_alternateChargedPartyAddress),
        (u'outgoingSessionId', _ASRecord_outgoingSessionId),
        (u'initialIMS-Charging-Identifier', _ASRecord_initialIMS_Charging_Identifier),
        (u'list-Of-AccessTransferInformation', _ASRecord_list_Of_AccessTransferInformation),
        (u'tADS-Identifier', _ASRecord_tADS_Identifier),
        (u'vlr-Number', _ASRecord_vlr_Number),
        (u'msc-Address', _ASRecord_msc_Address),
        (u'threeGPPPSDataOffStatus', _ASRecord_threeGPPPSDataOffStatus),
        (u'fEIdentifierList', _ASRecord_fEIdentifierList),
        ])
    ASRecord._ext = None
    
    #-----< ECSCFRecord >-----#
    ECSCFRecord = SET(name=u'ECSCFRecord', mode=MODE_TYPE)
    _ECSCFRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _ECSCFRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_sIP_Method = STR_GRAPH(name=u'sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _ECSCFRecord_role_of_Node = ENUM(name=u'role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _ECSCFRecord_nodeAddress = CHOICE(name=u'nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ECSCFRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _ECSCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name=u'list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ECSCFRecord_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _ECSCFRecord_serviceRequestTimeStamp = OCT_STR(name=u'serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ECSCFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name=u'serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ECSCFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name=u'serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ECSCFRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ECSCFRecord_recordClosureTime = OCT_STR(name=u'recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ECSCFRecord_interOperatorIdentifiers = SEQ_OF(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifierList')), opt=True)
    _ECSCFRecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ECSCFRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_causeForRecordClosing = ENUM(name=u'causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _ECSCFRecord_incomplete_CDR_Indication = SET(name=u'incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _ECSCFRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _ECSCFRecord_list_Of_SDP_Media_Components = SEQ_OF(name=u'list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ECSCFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _ECSCFRecord_list_Of_SDP_Media_Components._cont = __ECSCFRecord_list_Of_SDP_Media_Components__item_
    _ECSCFRecord_gGSNaddress = CHOICE(name=u'gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ECSCFRecord_serviceReasonReturnCode = STR_UTF8(name=u'serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_list_Of_Message_Bodies = SEQ_OF(name=u'list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ECSCFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _ECSCFRecord_list_Of_Message_Bodies._cont = __ECSCFRecord_list_Of_Message_Bodies__item_
    _ECSCFRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _ECSCFRecord_expiresInformation = INT(name=u'expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_event = STR_UTF8(name=u'event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_accessNetworkInformation = OCT_STR(name=u'accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _ECSCFRecord_list_of_subscription_ID = SEQ_OF(name=u'list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ECSCFRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _ECSCFRecord_list_of_subscription_ID._cont = __ECSCFRecord_list_of_subscription_ID__item_
    _ECSCFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name=u'list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ECSCFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _ECSCFRecord_list_Of_Early_SDP_Media_Components._cont = __ECSCFRecord_list_Of_Early_SDP_Media_Components__item_
    _ECSCFRecord_iMSCommunicationServiceIdentifier = OCT_STR(name=u'iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _ECSCFRecord_sessionPriority = ENUM(name=u'sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _ECSCFRecord_serviceRequestTimeStampFraction = INT(name=u'serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ECSCFRecord_serviceDeliveryStartTimeStampFraction = INT(name=u'serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ECSCFRecord_serviceDeliveryEndTimeStampFraction = INT(name=u'serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ECSCFRecord_applicationServersInformation = SEQ_OF(name=u'applicationServersInformation', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ECSCFRecord_applicationServersInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'ApplicationServersInformation')))
    _ECSCFRecord_applicationServersInformation._cont = __ECSCFRecord_applicationServersInformation__item_
    _ECSCFRecord_requested_Party_Address = CHOICE(name=u'requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _ECSCFRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name=u'list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ECSCFRecord_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _ECSCFRecord_fromAddress = OCT_STR(name=u'fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_transit_IOI_Lists = SEQ_OF(name=u'transit-IOI-Lists', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _ECSCFRecord_listOfReasonHeader = SEQ_OF(name=u'listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _ECSCFRecord_additionalAccessNetworkInformation = OCT_STR(name=u'additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name=u'list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ECSCFRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _ECSCFRecord_list_Of_AccessNetworkInfoChange._cont = __ECSCFRecord_list_Of_AccessNetworkInfoChange__item_
    _ECSCFRecord_listOfCalledIdentityChanges = SEQ_OF(name=u'listOfCalledIdentityChanges', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ECSCFRecord_listOfCalledIdentityChanges__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'CalledIdentityChange')))
    _ECSCFRecord_listOfCalledIdentityChanges._cont = __ECSCFRecord_listOfCalledIdentityChanges__item_
    _ECSCFRecord_cellularNetworkInformation = OCT_STR(name=u'cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ECSCFRecord_fEIdentifierList = SEQ_OF(name=u'fEIdentifierList', mode=MODE_TYPE, tag=(65, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    ECSCFRecord._cont = ASN1Dict([
        (u'recordType', _ECSCFRecord_recordType),
        (u'retransmission', _ECSCFRecord_retransmission),
        (u'sIP-Method', _ECSCFRecord_sIP_Method),
        (u'role-of-Node', _ECSCFRecord_role_of_Node),
        (u'nodeAddress', _ECSCFRecord_nodeAddress),
        (u'session-Id', _ECSCFRecord_session_Id),
        (u'list-Of-Calling-Party-Address', _ECSCFRecord_list_Of_Calling_Party_Address),
        (u'called-Party-Address', _ECSCFRecord_called_Party_Address),
        (u'serviceRequestTimeStamp', _ECSCFRecord_serviceRequestTimeStamp),
        (u'serviceDeliveryStartTimeStamp', _ECSCFRecord_serviceDeliveryStartTimeStamp),
        (u'serviceDeliveryEndTimeStamp', _ECSCFRecord_serviceDeliveryEndTimeStamp),
        (u'recordOpeningTime', _ECSCFRecord_recordOpeningTime),
        (u'recordClosureTime', _ECSCFRecord_recordClosureTime),
        (u'interOperatorIdentifiers', _ECSCFRecord_interOperatorIdentifiers),
        (u'localRecordSequenceNumber', _ECSCFRecord_localRecordSequenceNumber),
        (u'recordSequenceNumber', _ECSCFRecord_recordSequenceNumber),
        (u'causeForRecordClosing', _ECSCFRecord_causeForRecordClosing),
        (u'incomplete-CDR-Indication', _ECSCFRecord_incomplete_CDR_Indication),
        (u'iMS-Charging-Identifier', _ECSCFRecord_iMS_Charging_Identifier),
        (u'list-Of-SDP-Media-Components', _ECSCFRecord_list_Of_SDP_Media_Components),
        (u'gGSNaddress', _ECSCFRecord_gGSNaddress),
        (u'serviceReasonReturnCode', _ECSCFRecord_serviceReasonReturnCode),
        (u'list-Of-Message-Bodies', _ECSCFRecord_list_Of_Message_Bodies),
        (u'recordExtensions', _ECSCFRecord_recordExtensions),
        (u'expiresInformation', _ECSCFRecord_expiresInformation),
        (u'event', _ECSCFRecord_event),
        (u'accessNetworkInformation', _ECSCFRecord_accessNetworkInformation),
        (u'serviceContextID', _ECSCFRecord_serviceContextID),
        (u'list-of-subscription-ID', _ECSCFRecord_list_of_subscription_ID),
        (u'list-Of-Early-SDP-Media-Components', _ECSCFRecord_list_Of_Early_SDP_Media_Components),
        (u'iMSCommunicationServiceIdentifier', _ECSCFRecord_iMSCommunicationServiceIdentifier),
        (u'sessionPriority', _ECSCFRecord_sessionPriority),
        (u'serviceRequestTimeStampFraction', _ECSCFRecord_serviceRequestTimeStampFraction),
        (u'serviceDeliveryStartTimeStampFraction', _ECSCFRecord_serviceDeliveryStartTimeStampFraction),
        (u'serviceDeliveryEndTimeStampFraction', _ECSCFRecord_serviceDeliveryEndTimeStampFraction),
        (u'applicationServersInformation', _ECSCFRecord_applicationServersInformation),
        (u'requested-Party-Address', _ECSCFRecord_requested_Party_Address),
        (u'list-Of-Called-Asserted-Identity', _ECSCFRecord_list_Of_Called_Asserted_Identity),
        (u'userLocationInformation', _ECSCFRecord_userLocationInformation),
        (u'mSTimeZone', _ECSCFRecord_mSTimeZone),
        (u'fromAddress', _ECSCFRecord_fromAddress),
        (u'transit-IOI-Lists', _ECSCFRecord_transit_IOI_Lists),
        (u'listOfReasonHeader', _ECSCFRecord_listOfReasonHeader),
        (u'additionalAccessNetworkInformation', _ECSCFRecord_additionalAccessNetworkInformation),
        (u'list-Of-AccessNetworkInfoChange', _ECSCFRecord_list_Of_AccessNetworkInfoChange),
        (u'listOfCalledIdentityChanges', _ECSCFRecord_listOfCalledIdentityChanges),
        (u'cellularNetworkInformation', _ECSCFRecord_cellularNetworkInformation),
        (u'fEIdentifierList', _ECSCFRecord_fEIdentifierList),
        ])
    ECSCFRecord._ext = None
    
    #-----< IBCFRecord >-----#
    IBCFRecord = SET(name=u'IBCFRecord', mode=MODE_TYPE)
    _IBCFRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _IBCFRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_sIP_Method = STR_GRAPH(name=u'sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _IBCFRecord_role_of_Node = ENUM(name=u'role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _IBCFRecord_nodeAddress = CHOICE(name=u'nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _IBCFRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _IBCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name=u'list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _IBCFRecord_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _IBCFRecord_privateUserID = STR_GRAPH(name=u'privateUserID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_serviceRequestTimeStamp = OCT_STR(name=u'serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IBCFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name=u'serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IBCFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name=u'serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IBCFRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IBCFRecord_recordClosureTime = OCT_STR(name=u'recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _IBCFRecord_interOperatorIdentifiers = SEQ(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _IBCFRecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _IBCFRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_causeForRecordClosing = ENUM(name=u'causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _IBCFRecord_incomplete_CDR_Indication = SET(name=u'incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _IBCFRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _IBCFRecord_list_Of_SDP_Media_Components = SEQ_OF(name=u'list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IBCFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _IBCFRecord_list_Of_SDP_Media_Components._cont = __IBCFRecord_list_Of_SDP_Media_Components__item_
    _IBCFRecord_gGSNaddress = CHOICE(name=u'gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _IBCFRecord_serviceReasonReturnCode = STR_UTF8(name=u'serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_list_Of_Message_Bodies = SEQ_OF(name=u'list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IBCFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _IBCFRecord_list_Of_Message_Bodies._cont = __IBCFRecord_list_Of_Message_Bodies__item_
    _IBCFRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _IBCFRecord_expiresInformation = INT(name=u'expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_event = STR_UTF8(name=u'event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_accessNetworkInformation = OCT_STR(name=u'accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _IBCFRecord_list_of_subscription_ID = SEQ_OF(name=u'list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IBCFRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _IBCFRecord_list_of_subscription_ID._cont = __IBCFRecord_list_of_subscription_ID__item_
    _IBCFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name=u'list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IBCFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _IBCFRecord_list_Of_Early_SDP_Media_Components._cont = __IBCFRecord_list_Of_Early_SDP_Media_Components__item_
    _IBCFRecord_iMSCommunicationServiceIdentifier = OCT_STR(name=u'iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _IBCFRecord_sessionPriority = ENUM(name=u'sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _IBCFRecord_serviceRequestTimeStampFraction = INT(name=u'serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _IBCFRecord_serviceDeliveryStartTimeStampFraction = INT(name=u'serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _IBCFRecord_serviceDeliveryEndTimeStampFraction = INT(name=u'serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _IBCFRecord_list_of_Requested_Party_Address = SEQ_OF(name=u'list-of-Requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _IBCFRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name=u'list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _IBCFRecord_transit_IOI_List = STR_GRAPH(name=u'transit-IOI-List', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_nNI_Information = SEQ_OF(name=u'nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IBCFRecord_nNI_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')))
    _IBCFRecord_nNI_Information._cont = __IBCFRecord_nNI_Information__item_
    _IBCFRecord_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _IBCFRecord_fromAddress = OCT_STR(name=u'fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_listOfReasonHeader = SEQ_OF(name=u'listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _IBCFRecord_additionalAccessNetworkInformation = OCT_STR(name=u'additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_routeHeaderReceived = OCT_STR(name=u'routeHeaderReceived', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name=u'list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IBCFRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _IBCFRecord_list_Of_AccessNetworkInfoChange._cont = __IBCFRecord_list_Of_AccessNetworkInfoChange__item_
    _IBCFRecord_cellularNetworkInformation = OCT_STR(name=u'cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IBCFRecord_initialIMS_Charging_Identifier = OCT_STR(name=u'initialIMS-Charging-Identifier', mode=MODE_TYPE, tag=(105, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _IBCFRecord_list_Of_AccessTransferInformation = SEQ_OF(name=u'list-Of-AccessTransferInformation', mode=MODE_TYPE, tag=(106, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __IBCFRecord_list_Of_AccessTransferInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessTransferInformation')))
    _IBCFRecord_list_Of_AccessTransferInformation._cont = __IBCFRecord_list_Of_AccessTransferInformation__item_
    _IBCFRecord_fEIdentifierList = SEQ_OF(name=u'fEIdentifierList', mode=MODE_TYPE, tag=(107, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    IBCFRecord._cont = ASN1Dict([
        (u'recordType', _IBCFRecord_recordType),
        (u'retransmission', _IBCFRecord_retransmission),
        (u'sIP-Method', _IBCFRecord_sIP_Method),
        (u'role-of-Node', _IBCFRecord_role_of_Node),
        (u'nodeAddress', _IBCFRecord_nodeAddress),
        (u'session-Id', _IBCFRecord_session_Id),
        (u'list-Of-Calling-Party-Address', _IBCFRecord_list_Of_Calling_Party_Address),
        (u'called-Party-Address', _IBCFRecord_called_Party_Address),
        (u'privateUserID', _IBCFRecord_privateUserID),
        (u'serviceRequestTimeStamp', _IBCFRecord_serviceRequestTimeStamp),
        (u'serviceDeliveryStartTimeStamp', _IBCFRecord_serviceDeliveryStartTimeStamp),
        (u'serviceDeliveryEndTimeStamp', _IBCFRecord_serviceDeliveryEndTimeStamp),
        (u'recordOpeningTime', _IBCFRecord_recordOpeningTime),
        (u'recordClosureTime', _IBCFRecord_recordClosureTime),
        (u'interOperatorIdentifiers', _IBCFRecord_interOperatorIdentifiers),
        (u'localRecordSequenceNumber', _IBCFRecord_localRecordSequenceNumber),
        (u'recordSequenceNumber', _IBCFRecord_recordSequenceNumber),
        (u'causeForRecordClosing', _IBCFRecord_causeForRecordClosing),
        (u'incomplete-CDR-Indication', _IBCFRecord_incomplete_CDR_Indication),
        (u'iMS-Charging-Identifier', _IBCFRecord_iMS_Charging_Identifier),
        (u'list-Of-SDP-Media-Components', _IBCFRecord_list_Of_SDP_Media_Components),
        (u'gGSNaddress', _IBCFRecord_gGSNaddress),
        (u'serviceReasonReturnCode', _IBCFRecord_serviceReasonReturnCode),
        (u'list-Of-Message-Bodies', _IBCFRecord_list_Of_Message_Bodies),
        (u'recordExtensions', _IBCFRecord_recordExtensions),
        (u'expiresInformation', _IBCFRecord_expiresInformation),
        (u'event', _IBCFRecord_event),
        (u'accessNetworkInformation', _IBCFRecord_accessNetworkInformation),
        (u'serviceContextID', _IBCFRecord_serviceContextID),
        (u'list-of-subscription-ID', _IBCFRecord_list_of_subscription_ID),
        (u'list-Of-Early-SDP-Media-Components', _IBCFRecord_list_Of_Early_SDP_Media_Components),
        (u'iMSCommunicationServiceIdentifier', _IBCFRecord_iMSCommunicationServiceIdentifier),
        (u'sessionPriority', _IBCFRecord_sessionPriority),
        (u'serviceRequestTimeStampFraction', _IBCFRecord_serviceRequestTimeStampFraction),
        (u'serviceDeliveryStartTimeStampFraction', _IBCFRecord_serviceDeliveryStartTimeStampFraction),
        (u'serviceDeliveryEndTimeStampFraction', _IBCFRecord_serviceDeliveryEndTimeStampFraction),
        (u'list-of-Requested-Party-Address', _IBCFRecord_list_of_Requested_Party_Address),
        (u'list-Of-Called-Asserted-Identity', _IBCFRecord_list_Of_Called_Asserted_Identity),
        (u'transit-IOI-List', _IBCFRecord_transit_IOI_List),
        (u'nNI-Information', _IBCFRecord_nNI_Information),
        (u'userLocationInformation', _IBCFRecord_userLocationInformation),
        (u'mSTimeZone', _IBCFRecord_mSTimeZone),
        (u'fromAddress', _IBCFRecord_fromAddress),
        (u'listOfReasonHeader', _IBCFRecord_listOfReasonHeader),
        (u'additionalAccessNetworkInformation', _IBCFRecord_additionalAccessNetworkInformation),
        (u'routeHeaderReceived', _IBCFRecord_routeHeaderReceived),
        (u'list-Of-AccessNetworkInfoChange', _IBCFRecord_list_Of_AccessNetworkInfoChange),
        (u'cellularNetworkInformation', _IBCFRecord_cellularNetworkInformation),
        (u'initialIMS-Charging-Identifier', _IBCFRecord_initialIMS_Charging_Identifier),
        (u'list-Of-AccessTransferInformation', _IBCFRecord_list_Of_AccessTransferInformation),
        (u'fEIdentifierList', _IBCFRecord_fEIdentifierList),
        ])
    IBCFRecord._ext = None
    
    #-----< TRFRecord >-----#
    TRFRecord = SET(name=u'TRFRecord', mode=MODE_TYPE)
    _TRFRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _TRFRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRFRecord_sIP_Method = STR_GRAPH(name=u'sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _TRFRecord_role_of_Node = ENUM(name=u'role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _TRFRecord_nodeAddress = CHOICE(name=u'nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _TRFRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _TRFRecord_list_Of_Calling_Party_Address = SEQ_OF(name=u'list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _TRFRecord_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _TRFRecord_serviceRequestTimeStamp = OCT_STR(name=u'serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TRFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name=u'serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TRFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name=u'serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TRFRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TRFRecord_recordClosureTime = OCT_STR(name=u'recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TRFRecord_interOperatorIdentifiers = SEQ_OF(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifierList')), opt=True)
    _TRFRecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _TRFRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRFRecord_causeForRecordClosing = ENUM(name=u'causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _TRFRecord_incomplete_CDR_Indication = SET(name=u'incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _TRFRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _TRFRecord_list_Of_SDP_Media_Components = SEQ_OF(name=u'list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _TRFRecord_list_Of_SDP_Media_Components._cont = __TRFRecord_list_Of_SDP_Media_Components__item_
    _TRFRecord_serviceReasonReturnCode = STR_UTF8(name=u'serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRFRecord_list_Of_Message_Bodies = SEQ_OF(name=u'list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _TRFRecord_list_Of_Message_Bodies._cont = __TRFRecord_list_Of_Message_Bodies__item_
    _TRFRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _TRFRecord_expiresInformation = INT(name=u'expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRFRecord_event = STR_UTF8(name=u'event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRFRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _TRFRecord_list_of_subscription_ID = SEQ_OF(name=u'list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRFRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _TRFRecord_list_of_subscription_ID._cont = __TRFRecord_list_of_subscription_ID__item_
    _TRFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name=u'list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _TRFRecord_list_Of_Early_SDP_Media_Components._cont = __TRFRecord_list_Of_Early_SDP_Media_Components__item_
    _TRFRecord_iMSCommunicationServiceIdentifier = OCT_STR(name=u'iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _TRFRecord_numberPortabilityRouting = STR_GRAPH(name=u'numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _TRFRecord_carrierSelectRouting = STR_GRAPH(name=u'carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _TRFRecord_sessionPriority = ENUM(name=u'sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _TRFRecord_serviceRequestTimeStampFraction = INT(name=u'serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _TRFRecord_serviceDeliveryStartTimeStampFraction = INT(name=u'serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _TRFRecord_serviceDeliveryEndTimeStampFraction = INT(name=u'serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _TRFRecord_applicationServersInformation = SEQ_OF(name=u'applicationServersInformation', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRFRecord_applicationServersInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'ApplicationServersInformation')))
    _TRFRecord_applicationServersInformation._cont = __TRFRecord_applicationServersInformation__item_
    _TRFRecord_requested_Party_Address = CHOICE(name=u'requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _TRFRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name=u'list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _TRFRecord_nNI_Information = SEQ_OF(name=u'nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRFRecord_nNI_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')))
    _TRFRecord_nNI_Information._cont = __TRFRecord_nNI_Information__item_
    _TRFRecord_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRFRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _TRFRecord_transit_IOI_Lists = SEQ_OF(name=u'transit-IOI-Lists', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _TRFRecord_listOfReasonHeader = SEQ_OF(name=u'listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _TRFRecord_routeHeaderReceived = OCT_STR(name=u'routeHeaderReceived', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TRFRecord_listOfCalledIdentityChanges = SEQ_OF(name=u'listOfCalledIdentityChanges', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TRFRecord_listOfCalledIdentityChanges__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'CalledIdentityChange')))
    _TRFRecord_listOfCalledIdentityChanges._cont = __TRFRecord_listOfCalledIdentityChanges__item_
    _TRFRecord_fEIdentifierList = SEQ_OF(name=u'fEIdentifierList', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    TRFRecord._cont = ASN1Dict([
        (u'recordType', _TRFRecord_recordType),
        (u'retransmission', _TRFRecord_retransmission),
        (u'sIP-Method', _TRFRecord_sIP_Method),
        (u'role-of-Node', _TRFRecord_role_of_Node),
        (u'nodeAddress', _TRFRecord_nodeAddress),
        (u'session-Id', _TRFRecord_session_Id),
        (u'list-Of-Calling-Party-Address', _TRFRecord_list_Of_Calling_Party_Address),
        (u'called-Party-Address', _TRFRecord_called_Party_Address),
        (u'serviceRequestTimeStamp', _TRFRecord_serviceRequestTimeStamp),
        (u'serviceDeliveryStartTimeStamp', _TRFRecord_serviceDeliveryStartTimeStamp),
        (u'serviceDeliveryEndTimeStamp', _TRFRecord_serviceDeliveryEndTimeStamp),
        (u'recordOpeningTime', _TRFRecord_recordOpeningTime),
        (u'recordClosureTime', _TRFRecord_recordClosureTime),
        (u'interOperatorIdentifiers', _TRFRecord_interOperatorIdentifiers),
        (u'localRecordSequenceNumber', _TRFRecord_localRecordSequenceNumber),
        (u'recordSequenceNumber', _TRFRecord_recordSequenceNumber),
        (u'causeForRecordClosing', _TRFRecord_causeForRecordClosing),
        (u'incomplete-CDR-Indication', _TRFRecord_incomplete_CDR_Indication),
        (u'iMS-Charging-Identifier', _TRFRecord_iMS_Charging_Identifier),
        (u'list-Of-SDP-Media-Components', _TRFRecord_list_Of_SDP_Media_Components),
        (u'serviceReasonReturnCode', _TRFRecord_serviceReasonReturnCode),
        (u'list-Of-Message-Bodies', _TRFRecord_list_Of_Message_Bodies),
        (u'recordExtensions', _TRFRecord_recordExtensions),
        (u'expiresInformation', _TRFRecord_expiresInformation),
        (u'event', _TRFRecord_event),
        (u'serviceContextID', _TRFRecord_serviceContextID),
        (u'list-of-subscription-ID', _TRFRecord_list_of_subscription_ID),
        (u'list-Of-Early-SDP-Media-Components', _TRFRecord_list_Of_Early_SDP_Media_Components),
        (u'iMSCommunicationServiceIdentifier', _TRFRecord_iMSCommunicationServiceIdentifier),
        (u'numberPortabilityRouting', _TRFRecord_numberPortabilityRouting),
        (u'carrierSelectRouting', _TRFRecord_carrierSelectRouting),
        (u'sessionPriority', _TRFRecord_sessionPriority),
        (u'serviceRequestTimeStampFraction', _TRFRecord_serviceRequestTimeStampFraction),
        (u'serviceDeliveryStartTimeStampFraction', _TRFRecord_serviceDeliveryStartTimeStampFraction),
        (u'serviceDeliveryEndTimeStampFraction', _TRFRecord_serviceDeliveryEndTimeStampFraction),
        (u'applicationServersInformation', _TRFRecord_applicationServersInformation),
        (u'requested-Party-Address', _TRFRecord_requested_Party_Address),
        (u'list-Of-Called-Asserted-Identity', _TRFRecord_list_Of_Called_Asserted_Identity),
        (u'nNI-Information', _TRFRecord_nNI_Information),
        (u'userLocationInformation', _TRFRecord_userLocationInformation),
        (u'mSTimeZone', _TRFRecord_mSTimeZone),
        (u'transit-IOI-Lists', _TRFRecord_transit_IOI_Lists),
        (u'listOfReasonHeader', _TRFRecord_listOfReasonHeader),
        (u'routeHeaderReceived', _TRFRecord_routeHeaderReceived),
        (u'listOfCalledIdentityChanges', _TRFRecord_listOfCalledIdentityChanges),
        (u'fEIdentifierList', _TRFRecord_fEIdentifierList),
        ])
    TRFRecord._ext = None
    
    #-----< ATCFRecord >-----#
    ATCFRecord = SET(name=u'ATCFRecord', mode=MODE_TYPE)
    _ATCFRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _ATCFRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_sIP_Method = STR_GRAPH(name=u'sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _ATCFRecord_role_of_Node = ENUM(name=u'role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _ATCFRecord_nodeAddress = CHOICE(name=u'nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ATCFRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _ATCFRecord_list_Of_Calling_Party_Address = SEQ_OF(name=u'list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ATCFRecord_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _ATCFRecord_privateUserID = STR_GRAPH(name=u'privateUserID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_serviceRequestTimeStamp = OCT_STR(name=u'serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ATCFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name=u'serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ATCFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name=u'serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ATCFRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ATCFRecord_recordClosureTime = OCT_STR(name=u'recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ATCFRecord_interOperatorIdentifiers = SEQ(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _ATCFRecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ATCFRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_causeForRecordClosing = ENUM(name=u'causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _ATCFRecord_incomplete_CDR_Indication = SET(name=u'incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _ATCFRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _ATCFRecord_list_Of_SDP_Media_Components = SEQ_OF(name=u'list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ATCFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _ATCFRecord_list_Of_SDP_Media_Components._cont = __ATCFRecord_list_Of_SDP_Media_Components__item_
    _ATCFRecord_gGSNaddress = CHOICE(name=u'gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ATCFRecord_serviceReasonReturnCode = STR_UTF8(name=u'serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_list_Of_Message_Bodies = SEQ_OF(name=u'list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ATCFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _ATCFRecord_list_Of_Message_Bodies._cont = __ATCFRecord_list_Of_Message_Bodies__item_
    _ATCFRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _ATCFRecord_expiresInformation = INT(name=u'expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_event = STR_UTF8(name=u'event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_accessNetworkInformation = OCT_STR(name=u'accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _ATCFRecord_list_of_subscription_ID = SEQ_OF(name=u'list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ATCFRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _ATCFRecord_list_of_subscription_ID._cont = __ATCFRecord_list_of_subscription_ID__item_
    _ATCFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name=u'list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ATCFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _ATCFRecord_list_Of_Early_SDP_Media_Components._cont = __ATCFRecord_list_Of_Early_SDP_Media_Components__item_
    _ATCFRecord_iMSCommunicationServiceIdentifier = OCT_STR(name=u'iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _ATCFRecord_sessionPriority = ENUM(name=u'sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _ATCFRecord_serviceRequestTimeStampFraction = INT(name=u'serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ATCFRecord_serviceDeliveryStartTimeStampFraction = INT(name=u'serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ATCFRecord_serviceDeliveryEndTimeStampFraction = INT(name=u'serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _ATCFRecord_list_of_Requested_Party_Address = SEQ_OF(name=u'list-of-Requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ATCFRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name=u'list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _ATCFRecord_nNI_Information = SEQ(name=u'nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')), opt=True)
    _ATCFRecord_userLocationInformation = OCT_STR(name=u'userLocationInformation', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _ATCFRecord_fromAddress = OCT_STR(name=u'fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_listOfReasonHeader = SEQ_OF(name=u'listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _ATCFRecord_additionalAccessNetworkInformation = OCT_STR(name=u'additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_routeHeaderReceived = OCT_STR(name=u'routeHeaderReceived', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_routeHeaderTransmitted = OCT_STR(name=u'routeHeaderTransmitted', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_list_Of_AccessNetworkInfoChange = SEQ_OF(name=u'list-Of-AccessNetworkInfoChange', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ATCFRecord_list_Of_AccessNetworkInfoChange__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessNetworkInfoChange')))
    _ATCFRecord_list_Of_AccessNetworkInfoChange._cont = __ATCFRecord_list_Of_AccessNetworkInfoChange__item_
    _ATCFRecord_listOfCalledIdentityChanges = SEQ_OF(name=u'listOfCalledIdentityChanges', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ATCFRecord_listOfCalledIdentityChanges__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'CalledIdentityChange')))
    _ATCFRecord_listOfCalledIdentityChanges._cont = __ATCFRecord_listOfCalledIdentityChanges__item_
    _ATCFRecord_cellularNetworkInformation = OCT_STR(name=u'cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ATCFRecord_initialIMS_Charging_Identifier = OCT_STR(name=u'initialIMS-Charging-Identifier', mode=MODE_TYPE, tag=(105, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _ATCFRecord_list_Of_AccessTransferInformation = SEQ_OF(name=u'list-Of-AccessTransferInformation', mode=MODE_TYPE, tag=(106, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ATCFRecord_list_Of_AccessTransferInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessTransferInformation')))
    _ATCFRecord_list_Of_AccessTransferInformation._cont = __ATCFRecord_list_Of_AccessTransferInformation__item_
    _ATCFRecord_fEIdentifierList = SEQ_OF(name=u'fEIdentifierList', mode=MODE_TYPE, tag=(107, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    ATCFRecord._cont = ASN1Dict([
        (u'recordType', _ATCFRecord_recordType),
        (u'retransmission', _ATCFRecord_retransmission),
        (u'sIP-Method', _ATCFRecord_sIP_Method),
        (u'role-of-Node', _ATCFRecord_role_of_Node),
        (u'nodeAddress', _ATCFRecord_nodeAddress),
        (u'session-Id', _ATCFRecord_session_Id),
        (u'list-Of-Calling-Party-Address', _ATCFRecord_list_Of_Calling_Party_Address),
        (u'called-Party-Address', _ATCFRecord_called_Party_Address),
        (u'privateUserID', _ATCFRecord_privateUserID),
        (u'serviceRequestTimeStamp', _ATCFRecord_serviceRequestTimeStamp),
        (u'serviceDeliveryStartTimeStamp', _ATCFRecord_serviceDeliveryStartTimeStamp),
        (u'serviceDeliveryEndTimeStamp', _ATCFRecord_serviceDeliveryEndTimeStamp),
        (u'recordOpeningTime', _ATCFRecord_recordOpeningTime),
        (u'recordClosureTime', _ATCFRecord_recordClosureTime),
        (u'interOperatorIdentifiers', _ATCFRecord_interOperatorIdentifiers),
        (u'localRecordSequenceNumber', _ATCFRecord_localRecordSequenceNumber),
        (u'recordSequenceNumber', _ATCFRecord_recordSequenceNumber),
        (u'causeForRecordClosing', _ATCFRecord_causeForRecordClosing),
        (u'incomplete-CDR-Indication', _ATCFRecord_incomplete_CDR_Indication),
        (u'iMS-Charging-Identifier', _ATCFRecord_iMS_Charging_Identifier),
        (u'list-Of-SDP-Media-Components', _ATCFRecord_list_Of_SDP_Media_Components),
        (u'gGSNaddress', _ATCFRecord_gGSNaddress),
        (u'serviceReasonReturnCode', _ATCFRecord_serviceReasonReturnCode),
        (u'list-Of-Message-Bodies', _ATCFRecord_list_Of_Message_Bodies),
        (u'recordExtensions', _ATCFRecord_recordExtensions),
        (u'expiresInformation', _ATCFRecord_expiresInformation),
        (u'event', _ATCFRecord_event),
        (u'accessNetworkInformation', _ATCFRecord_accessNetworkInformation),
        (u'serviceContextID', _ATCFRecord_serviceContextID),
        (u'list-of-subscription-ID', _ATCFRecord_list_of_subscription_ID),
        (u'list-Of-Early-SDP-Media-Components', _ATCFRecord_list_Of_Early_SDP_Media_Components),
        (u'iMSCommunicationServiceIdentifier', _ATCFRecord_iMSCommunicationServiceIdentifier),
        (u'sessionPriority', _ATCFRecord_sessionPriority),
        (u'serviceRequestTimeStampFraction', _ATCFRecord_serviceRequestTimeStampFraction),
        (u'serviceDeliveryStartTimeStampFraction', _ATCFRecord_serviceDeliveryStartTimeStampFraction),
        (u'serviceDeliveryEndTimeStampFraction', _ATCFRecord_serviceDeliveryEndTimeStampFraction),
        (u'list-of-Requested-Party-Address', _ATCFRecord_list_of_Requested_Party_Address),
        (u'list-Of-Called-Asserted-Identity', _ATCFRecord_list_Of_Called_Asserted_Identity),
        (u'nNI-Information', _ATCFRecord_nNI_Information),
        (u'userLocationInformation', _ATCFRecord_userLocationInformation),
        (u'mSTimeZone', _ATCFRecord_mSTimeZone),
        (u'fromAddress', _ATCFRecord_fromAddress),
        (u'listOfReasonHeader', _ATCFRecord_listOfReasonHeader),
        (u'additionalAccessNetworkInformation', _ATCFRecord_additionalAccessNetworkInformation),
        (u'routeHeaderReceived', _ATCFRecord_routeHeaderReceived),
        (u'routeHeaderTransmitted', _ATCFRecord_routeHeaderTransmitted),
        (u'list-Of-AccessNetworkInfoChange', _ATCFRecord_list_Of_AccessNetworkInfoChange),
        (u'listOfCalledIdentityChanges', _ATCFRecord_listOfCalledIdentityChanges),
        (u'cellularNetworkInformation', _ATCFRecord_cellularNetworkInformation),
        (u'initialIMS-Charging-Identifier', _ATCFRecord_initialIMS_Charging_Identifier),
        (u'list-Of-AccessTransferInformation', _ATCFRecord_list_Of_AccessTransferInformation),
        (u'fEIdentifierList', _ATCFRecord_fEIdentifierList),
        ])
    ATCFRecord._ext = None
    
    #-----< TFRecord >-----#
    TFRecord = SET(name=u'TFRecord', mode=MODE_TYPE)
    _TFRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _TFRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_sIP_Method = STR_GRAPH(name=u'sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _TFRecord_role_of_Node = ENUM(name=u'role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _TFRecord_nodeAddress = CHOICE(name=u'nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _TFRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _TFRecord_list_Of_Calling_Party_Address = SEQ_OF(name=u'list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _TFRecord_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _TFRecord_serviceRequestTimeStamp = OCT_STR(name=u'serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name=u'serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name=u'serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TFRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TFRecord_recordClosureTime = OCT_STR(name=u'recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _TFRecord_interOperatorIdentifiers = SEQ_OF(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifierList')), opt=True)
    _TFRecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _TFRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_causeForRecordClosing = ENUM(name=u'causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _TFRecord_incomplete_CDR_Indication = SET(name=u'incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _TFRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _TFRecord_list_Of_SDP_Media_Components = SEQ_OF(name=u'list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _TFRecord_list_Of_SDP_Media_Components._cont = __TFRecord_list_Of_SDP_Media_Components__item_
    _TFRecord_serviceReasonReturnCode = STR_UTF8(name=u'serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_list_Of_Message_Bodies = SEQ_OF(name=u'list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _TFRecord_list_Of_Message_Bodies._cont = __TFRecord_list_Of_Message_Bodies__item_
    _TFRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _TFRecord_expiresInformation = INT(name=u'expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_event = STR_UTF8(name=u'event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _TFRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name=u'list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TFRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _TFRecord_list_Of_Early_SDP_Media_Components._cont = __TFRecord_list_Of_Early_SDP_Media_Components__item_
    _TFRecord_iMSCommunicationServiceIdentifier = OCT_STR(name=u'iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _TFRecord_numberPortabilityRouting = STR_GRAPH(name=u'numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _TFRecord_carrierSelectRouting = STR_GRAPH(name=u'carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _TFRecord_sessionPriority = ENUM(name=u'sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _TFRecord_serviceRequestTimeStampFraction = INT(name=u'serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _TFRecord_serviceDeliveryStartTimeStampFraction = INT(name=u'serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _TFRecord_serviceDeliveryEndTimeStampFraction = INT(name=u'serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _TFRecord_applicationServersInformation = SEQ_OF(name=u'applicationServersInformation', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TFRecord_applicationServersInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'ApplicationServersInformation')))
    _TFRecord_applicationServersInformation._cont = __TFRecord_applicationServersInformation__item_
    _TFRecord_requested_Party_Address = CHOICE(name=u'requested-Party-Address', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _TFRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name=u'list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _TFRecord_nNI_Information = SEQ(name=u'nNI-Information', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NNI-Information')), opt=True)
    _TFRecord_fromAddress = OCT_STR(name=u'fromAddress', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_transit_IOI_Lists = SEQ_OF(name=u'transit-IOI-Lists', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _TFRecord_listOfReasonHeader = SEQ_OF(name=u'listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _TFRecord_routeHeaderReceived = OCT_STR(name=u'routeHeaderReceived', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_routeHeaderTransmitted = OCT_STR(name=u'routeHeaderTransmitted', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TFRecord_listOfCalledIdentityChanges = SEQ_OF(name=u'listOfCalledIdentityChanges', mode=MODE_TYPE, tag=(63, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TFRecord_listOfCalledIdentityChanges__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'CalledIdentityChange')))
    _TFRecord_listOfCalledIdentityChanges._cont = __TFRecord_listOfCalledIdentityChanges__item_
    _TFRecord_fEIdentifierList = SEQ_OF(name=u'fEIdentifierList', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    TFRecord._cont = ASN1Dict([
        (u'recordType', _TFRecord_recordType),
        (u'retransmission', _TFRecord_retransmission),
        (u'sIP-Method', _TFRecord_sIP_Method),
        (u'role-of-Node', _TFRecord_role_of_Node),
        (u'nodeAddress', _TFRecord_nodeAddress),
        (u'session-Id', _TFRecord_session_Id),
        (u'list-Of-Calling-Party-Address', _TFRecord_list_Of_Calling_Party_Address),
        (u'called-Party-Address', _TFRecord_called_Party_Address),
        (u'serviceRequestTimeStamp', _TFRecord_serviceRequestTimeStamp),
        (u'serviceDeliveryStartTimeStamp', _TFRecord_serviceDeliveryStartTimeStamp),
        (u'serviceDeliveryEndTimeStamp', _TFRecord_serviceDeliveryEndTimeStamp),
        (u'recordOpeningTime', _TFRecord_recordOpeningTime),
        (u'recordClosureTime', _TFRecord_recordClosureTime),
        (u'interOperatorIdentifiers', _TFRecord_interOperatorIdentifiers),
        (u'localRecordSequenceNumber', _TFRecord_localRecordSequenceNumber),
        (u'recordSequenceNumber', _TFRecord_recordSequenceNumber),
        (u'causeForRecordClosing', _TFRecord_causeForRecordClosing),
        (u'incomplete-CDR-Indication', _TFRecord_incomplete_CDR_Indication),
        (u'iMS-Charging-Identifier', _TFRecord_iMS_Charging_Identifier),
        (u'list-Of-SDP-Media-Components', _TFRecord_list_Of_SDP_Media_Components),
        (u'serviceReasonReturnCode', _TFRecord_serviceReasonReturnCode),
        (u'list-Of-Message-Bodies', _TFRecord_list_Of_Message_Bodies),
        (u'recordExtensions', _TFRecord_recordExtensions),
        (u'expiresInformation', _TFRecord_expiresInformation),
        (u'event', _TFRecord_event),
        (u'serviceContextID', _TFRecord_serviceContextID),
        (u'list-Of-Early-SDP-Media-Components', _TFRecord_list_Of_Early_SDP_Media_Components),
        (u'iMSCommunicationServiceIdentifier', _TFRecord_iMSCommunicationServiceIdentifier),
        (u'numberPortabilityRouting', _TFRecord_numberPortabilityRouting),
        (u'carrierSelectRouting', _TFRecord_carrierSelectRouting),
        (u'sessionPriority', _TFRecord_sessionPriority),
        (u'serviceRequestTimeStampFraction', _TFRecord_serviceRequestTimeStampFraction),
        (u'serviceDeliveryStartTimeStampFraction', _TFRecord_serviceDeliveryStartTimeStampFraction),
        (u'serviceDeliveryEndTimeStampFraction', _TFRecord_serviceDeliveryEndTimeStampFraction),
        (u'applicationServersInformation', _TFRecord_applicationServersInformation),
        (u'requested-Party-Address', _TFRecord_requested_Party_Address),
        (u'list-Of-Called-Asserted-Identity', _TFRecord_list_Of_Called_Asserted_Identity),
        (u'nNI-Information', _TFRecord_nNI_Information),
        (u'fromAddress', _TFRecord_fromAddress),
        (u'transit-IOI-Lists', _TFRecord_transit_IOI_Lists),
        (u'listOfReasonHeader', _TFRecord_listOfReasonHeader),
        (u'routeHeaderReceived', _TFRecord_routeHeaderReceived),
        (u'routeHeaderTransmitted', _TFRecord_routeHeaderTransmitted),
        (u'listOfCalledIdentityChanges', _TFRecord_listOfCalledIdentityChanges),
        (u'fEIdentifierList', _TFRecord_fEIdentifierList),
        ])
    TFRecord._ext = None
    
    #-----< AccessCorrelationID >-----#
    AccessCorrelationID = CHOICE(name=u'AccessCorrelationID', mode=MODE_TYPE)
    _AccessCorrelationID_gPRS_Charging_Id = INT(name=u'gPRS-Charging-Id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AccessCorrelationID_gPRS_Charging_Id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _AccessCorrelationID_accessNetworkChargingIdentifier = STR_GRAPH(name=u'accessNetworkChargingIdentifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    AccessCorrelationID._cont = ASN1Dict([
        (u'gPRS-Charging-Id', _AccessCorrelationID_gPRS_Charging_Id),
        (u'accessNetworkChargingIdentifier', _AccessCorrelationID_accessNetworkChargingIdentifier),
        ])
    AccessCorrelationID._ext = None
    
    #-----< AccessNetworkInfoChange >-----#
    AccessNetworkInfoChange = SEQ(name=u'AccessNetworkInfoChange', mode=MODE_TYPE)
    _AccessNetworkInfoChange_accessNetworkInformation = OCT_STR(name=u'accessNetworkInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AccessNetworkInfoChange_additionalAccessNetworkInformation = OCT_STR(name=u'additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AccessNetworkInfoChange_accessChangeTime = OCT_STR(name=u'accessChangeTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _AccessNetworkInfoChange_cellularNetworkInformation = OCT_STR(name=u'cellularNetworkInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    AccessNetworkInfoChange._cont = ASN1Dict([
        (u'accessNetworkInformation', _AccessNetworkInfoChange_accessNetworkInformation),
        (u'additionalAccessNetworkInformation', _AccessNetworkInfoChange_additionalAccessNetworkInformation),
        (u'accessChangeTime', _AccessNetworkInfoChange_accessChangeTime),
        (u'cellularNetworkInformation', _AccessNetworkInfoChange_cellularNetworkInformation),
        ])
    AccessNetworkInfoChange._ext = None
    
    #-----< AccessTransferType >-----#
    AccessTransferType = ENUM(name=u'AccessTransferType', mode=MODE_TYPE)
    AccessTransferType._cont = ASN1Dict([(u'pSToCS', 0), (u'cSToPS', 1), (u'pSToPS', 2), (u'cSToCS', 3)])
    AccessTransferType._ext = None
    
    #-----< AccessTransferInformation >-----#
    AccessTransferInformation = SEQ(name=u'AccessTransferInformation', mode=MODE_TYPE)
    _AccessTransferInformation_accessTransferType = ENUM(name=u'accessTransferType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessTransferType')), opt=True)
    _AccessTransferInformation_accessNetworkInformation = OCT_STR(name=u'accessNetworkInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AccessTransferInformation_additionalAccessNetworkInformation = OCT_STR(name=u'additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AccessTransferInformation_inter_UE_Transfer = NULL(name=u'inter-UE-Transfer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AccessTransferInformation_relatedICID = OCT_STR(name=u'relatedICID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _AccessTransferInformation_relatedICIDGenerationNode = CHOICE(name=u'relatedICIDGenerationNode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _AccessTransferInformation_accessTransferTime = OCT_STR(name=u'accessTransferTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _AccessTransferInformation_subscriberEquipmentNumber = SET(name=u'subscriberEquipmentNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentNumber')), opt=True)
    _AccessTransferInformation_instanceId = OCT_STR(name=u'instanceId', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AccessTransferInformation_cellularNetworkInformation = OCT_STR(name=u'cellularNetworkInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    AccessTransferInformation._cont = ASN1Dict([
        (u'accessTransferType', _AccessTransferInformation_accessTransferType),
        (u'accessNetworkInformation', _AccessTransferInformation_accessNetworkInformation),
        (u'additionalAccessNetworkInformation', _AccessTransferInformation_additionalAccessNetworkInformation),
        (u'inter-UE-Transfer', _AccessTransferInformation_inter_UE_Transfer),
        (u'relatedICID', _AccessTransferInformation_relatedICID),
        (u'relatedICIDGenerationNode', _AccessTransferInformation_relatedICIDGenerationNode),
        (u'accessTransferTime', _AccessTransferInformation_accessTransferTime),
        (u'subscriberEquipmentNumber', _AccessTransferInformation_subscriberEquipmentNumber),
        (u'instanceId', _AccessTransferInformation_instanceId),
        (u'cellularNetworkInformation', _AccessTransferInformation_cellularNetworkInformation),
        ])
    AccessTransferInformation._ext = None
    
    #-----< ACRInterimLost >-----#
    ACRInterimLost = ENUM(name=u'ACRInterimLost', mode=MODE_TYPE)
    ACRInterimLost._cont = ASN1Dict([(u'no', 0), (u'yes', 1), (u'unknown', 2)])
    ACRInterimLost._ext = None
    
    #-----< AoCCostInformation >-----#
    AoCCostInformation = SEQ(name=u'AoCCostInformation', mode=MODE_TYPE)
    _AoCCostInformation_accumulatedCost = REAL(name=u'accumulatedCost', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('_IMPL_', 'REAL')))
    _AoCCostInformation_incrementalCost = REAL(name=u'incrementalCost', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('_IMPL_', 'REAL')))
    _AoCCostInformation_currencyCode = INT(name=u'currencyCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    AoCCostInformation._cont = ASN1Dict([
        (u'accumulatedCost', _AoCCostInformation_accumulatedCost),
        (u'incrementalCost', _AoCCostInformation_incrementalCost),
        (u'currencyCode', _AoCCostInformation_currencyCode),
        ])
    AoCCostInformation._ext = None
    
    #-----< AoCInformation >-----#
    AoCInformation = SET(name=u'AoCInformation', mode=MODE_TYPE)
    _AoCInformation_tariffInformation = SEQ(name=u'tariffInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TariffInformation')), opt=True)
    _AoCInformation_aoCCostInformation = SEQ(name=u'aoCCostInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'AoCCostInformation')), opt=True)
    AoCInformation._cont = ASN1Dict([
        (u'tariffInformation', _AoCInformation_tariffInformation),
        (u'aoCCostInformation', _AoCInformation_aoCCostInformation),
        ])
    AoCInformation._ext = None
    
    #-----< ApplicationServersInformation >-----#
    ApplicationServersInformation = SEQ(name=u'ApplicationServersInformation', mode=MODE_TYPE)
    _ApplicationServersInformation_applicationServersInvolved = CHOICE(name=u'applicationServersInvolved', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _ApplicationServersInformation_applicationProvidedCalledParties = SEQ_OF(name=u'applicationProvidedCalledParties', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ApplicationServersInformation_applicationProvidedCalledParties__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')))
    _ApplicationServersInformation_applicationProvidedCalledParties._cont = __ApplicationServersInformation_applicationProvidedCalledParties__item_
    _ApplicationServersInformation_sTatus = ENUM(name=u'sTatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Status')), opt=True)
    ApplicationServersInformation._cont = ASN1Dict([
        (u'applicationServersInvolved', _ApplicationServersInformation_applicationServersInvolved),
        (u'applicationProvidedCalledParties', _ApplicationServersInformation_applicationProvidedCalledParties),
        (u'sTatus', _ApplicationServersInformation_sTatus),
        ])
    ApplicationServersInformation._ext = None
    
    #-----< CalledIdentityChange >-----#
    CalledIdentityChange = SEQ(name=u'CalledIdentityChange', mode=MODE_TYPE)
    _CalledIdentityChange_calledIdentity = CHOICE(name=u'calledIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _CalledIdentityChange_changeTime = OCT_STR(name=u'changeTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    CalledIdentityChange._cont = ASN1Dict([
        (u'calledIdentity', _CalledIdentityChange_calledIdentity),
        (u'changeTime', _CalledIdentityChange_changeTime),
        ])
    CalledIdentityChange._ext = None
    
    #-----< CarrierSelectRouting >-----#
    CarrierSelectRouting = STR_GRAPH(name=u'CarrierSelectRouting', mode=MODE_TYPE)
    
    #-----< CauseForRecordClosing >-----#
    CauseForRecordClosing = ENUM(name=u'CauseForRecordClosing', mode=MODE_TYPE)
    CauseForRecordClosing._cont = ASN1Dict([(u'serviceDeliveryEndSuccessfully', 0), (u'unSuccessfulServiceDelivery', 1), (u'timeLimit', 3), (u'serviceChange', 4), (u'managementIntervention', 5)])
    CauseForRecordClosing._ext = None
    
    #-----< Early-Media-Components-List >-----#
    Early_Media_Components_List = SEQ(name=u'Early-Media-Components-List', mode=MODE_TYPE)
    _Early_Media_Components_List_sDP_Offer_Timestamp = OCT_STR(name=u'sDP-Offer-Timestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _Early_Media_Components_List_sDP_Answer_Timestamp = OCT_STR(name=u'sDP-Answer-Timestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _Early_Media_Components_List_sDP_Media_Components = SEQ_OF(name=u'sDP-Media-Components', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Early_Media_Components_List_sDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'SDP-Media-Component')))
    _Early_Media_Components_List_sDP_Media_Components._cont = __Early_Media_Components_List_sDP_Media_Components__item_
    _Early_Media_Components_List_mediaInitiatorFlag = NULL(name=u'mediaInitiatorFlag', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Early_Media_Components_List_sDP_Session_Description = SEQ_OF(name=u'sDP-Session-Description', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Early_Media_Components_List_sDP_Session_Description__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE)
    _Early_Media_Components_List_sDP_Session_Description._cont = __Early_Media_Components_List_sDP_Session_Description__item_
    _Early_Media_Components_List_sDP_Type = ENUM(name=u'sDP-Type', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SDP-Type')), opt=True)
    Early_Media_Components_List._cont = ASN1Dict([
        (u'sDP-Offer-Timestamp', _Early_Media_Components_List_sDP_Offer_Timestamp),
        (u'sDP-Answer-Timestamp', _Early_Media_Components_List_sDP_Answer_Timestamp),
        (u'sDP-Media-Components', _Early_Media_Components_List_sDP_Media_Components),
        (u'mediaInitiatorFlag', _Early_Media_Components_List_mediaInitiatorFlag),
        (u'sDP-Session-Description', _Early_Media_Components_List_sDP_Session_Description),
        (u'sDP-Type', _Early_Media_Components_List_sDP_Type),
        ])
    Early_Media_Components_List._ext = None
    
    #-----< FEIdentifierList >-----#
    FEIdentifierList = SEQ_OF(name=u'FEIdentifierList', mode=MODE_TYPE)
    _FEIdentifierList__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE)
    FEIdentifierList._cont = _FEIdentifierList__item_
    
    #-----< IMS-Charging-Identifier >-----#
    IMS_Charging_Identifier = OCT_STR(name=u'IMS-Charging-Identifier', mode=MODE_TYPE)
    
    #-----< IMSCommunicationServiceIdentifier >-----#
    IMSCommunicationServiceIdentifier = OCT_STR(name=u'IMSCommunicationServiceIdentifier', mode=MODE_TYPE)
    
    #-----< Incomplete-CDR-Indication >-----#
    Incomplete_CDR_Indication = SET(name=u'Incomplete-CDR-Indication', mode=MODE_TYPE)
    _Incomplete_CDR_Indication_aCRStartLost = BOOL(name=u'aCRStartLost', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Incomplete_CDR_Indication_aCRInterimLost = ENUM(name=u'aCRInterimLost', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ACRInterimLost')))
    _Incomplete_CDR_Indication_aCRStopLost = BOOL(name=u'aCRStopLost', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Incomplete_CDR_Indication._cont = ASN1Dict([
        (u'aCRStartLost', _Incomplete_CDR_Indication_aCRStartLost),
        (u'aCRInterimLost', _Incomplete_CDR_Indication_aCRInterimLost),
        (u'aCRStopLost', _Incomplete_CDR_Indication_aCRStopLost),
        ])
    Incomplete_CDR_Indication._ext = None
    
    #-----< InterOperatorIdentifierList >-----#
    InterOperatorIdentifierList = SEQ_OF(name=u'InterOperatorIdentifierList', mode=MODE_TYPE)
    _InterOperatorIdentifierList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')))
    InterOperatorIdentifierList._cont = _InterOperatorIdentifierList__item_
    
    #-----< InterOperatorIdentifiers >-----#
    InterOperatorIdentifiers = SEQ(name=u'InterOperatorIdentifiers', mode=MODE_TYPE)
    _InterOperatorIdentifiers_originatingIOI = STR_GRAPH(name=u'originatingIOI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InterOperatorIdentifiers_terminatingIOI = STR_GRAPH(name=u'terminatingIOI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    InterOperatorIdentifiers._cont = ASN1Dict([
        (u'originatingIOI', _InterOperatorIdentifiers_originatingIOI),
        (u'terminatingIOI', _InterOperatorIdentifiers_terminatingIOI),
        ])
    InterOperatorIdentifiers._ext = None
    
    #-----< ISUPCause >-----#
    ISUPCause = SEQ(name=u'ISUPCause', mode=MODE_TYPE)
    _ISUPCause_iSUPCauseLocation = INT(name=u'iSUPCauseLocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISUPCause_iSUPCauseValue = INT(name=u'iSUPCauseValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISUPCause_iSUPCauseDiagnostics = OCT_STR(name=u'iSUPCauseDiagnostics', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ISUPCause._cont = ASN1Dict([
        (u'iSUPCauseLocation', _ISUPCause_iSUPCauseLocation),
        (u'iSUPCauseValue', _ISUPCause_iSUPCauseValue),
        (u'iSUPCauseDiagnostics', _ISUPCause_iSUPCauseDiagnostics),
        ])
    ISUPCause._ext = None
    
    #-----< ListOfInvolvedParties >-----#
    ListOfInvolvedParties = SEQ_OF(name=u'ListOfInvolvedParties', mode=MODE_TYPE)
    _ListOfInvolvedParties__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')))
    ListOfInvolvedParties._cont = _ListOfInvolvedParties__item_
    
    #-----< ListOfReasonHeader >-----#
    ListOfReasonHeader = SEQ_OF(name=u'ListOfReasonHeader', mode=MODE_TYPE)
    _ListOfReasonHeader__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'ReasonHeaderInformation')))
    ListOfReasonHeader._cont = _ListOfReasonHeader__item_
    
    #-----< Media-Components-List >-----#
    Media_Components_List = SEQ(name=u'Media-Components-List', mode=MODE_TYPE)
    _Media_Components_List_sIP_Request_Timestamp = OCT_STR(name=u'sIP-Request-Timestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _Media_Components_List_sIP_Response_Timestamp = OCT_STR(name=u'sIP-Response-Timestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _Media_Components_List_sDP_Media_Components = SEQ_OF(name=u'sDP-Media-Components', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Media_Components_List_sDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'SDP-Media-Component')))
    _Media_Components_List_sDP_Media_Components._cont = __Media_Components_List_sDP_Media_Components__item_
    _Media_Components_List_mediaInitiatorFlag = NULL(name=u'mediaInitiatorFlag', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Media_Components_List_sDP_Session_Description = SEQ_OF(name=u'sDP-Session-Description', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Media_Components_List_sDP_Session_Description__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE)
    _Media_Components_List_sDP_Session_Description._cont = __Media_Components_List_sDP_Session_Description__item_
    _Media_Components_List_mediaInitiatorParty = CHOICE(name=u'mediaInitiatorParty', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _Media_Components_List_sIP_Request_Timestamp_Fraction = INT(name=u'sIP-Request-Timestamp-Fraction', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _Media_Components_List_sIP_Response_Timestamp_Fraction = INT(name=u'sIP-Response-Timestamp-Fraction', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _Media_Components_List_sDP_Type = ENUM(name=u'sDP-Type', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SDP-Type')), opt=True)
    Media_Components_List._cont = ASN1Dict([
        (u'sIP-Request-Timestamp', _Media_Components_List_sIP_Request_Timestamp),
        (u'sIP-Response-Timestamp', _Media_Components_List_sIP_Response_Timestamp),
        (u'sDP-Media-Components', _Media_Components_List_sDP_Media_Components),
        (u'mediaInitiatorFlag', _Media_Components_List_mediaInitiatorFlag),
        (u'sDP-Session-Description', _Media_Components_List_sDP_Session_Description),
        (u'mediaInitiatorParty', _Media_Components_List_mediaInitiatorParty),
        (u'sIP-Request-Timestamp-Fraction', _Media_Components_List_sIP_Request_Timestamp_Fraction),
        (u'sIP-Response-Timestamp-Fraction', _Media_Components_List_sIP_Response_Timestamp_Fraction),
        (u'sDP-Type', _Media_Components_List_sDP_Type),
        ])
    Media_Components_List._ext = None
    
    #-----< MessageBody >-----#
    MessageBody = SEQ(name=u'MessageBody', mode=MODE_TYPE)
    _MessageBody_content_Type = STR_GRAPH(name=u'content-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MessageBody_content_Disposition = STR_GRAPH(name=u'content-Disposition', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MessageBody_content_Length = INT(name=u'content-Length', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MessageBody_originator = CHOICE(name=u'originator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    MessageBody._cont = ASN1Dict([
        (u'content-Type', _MessageBody_content_Type),
        (u'content-Disposition', _MessageBody_content_Disposition),
        (u'content-Length', _MessageBody_content_Length),
        (u'originator', _MessageBody_originator),
        ])
    MessageBody._ext = None
    
    #-----< Milliseconds >-----#
    Milliseconds = INT(name=u'Milliseconds', mode=MODE_TYPE)
    Milliseconds._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    
    #-----< NNI-Information >-----#
    NNI_Information = SEQ(name=u'NNI-Information', mode=MODE_TYPE)
    _NNI_Information_sessionDirection = ENUM(name=u'sessionDirection', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionDirection')), opt=True)
    _NNI_Information_nNIType = ENUM(name=u'nNIType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NNIType')), opt=True)
    _NNI_Information_relationshipMode = ENUM(name=u'relationshipMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'RelationshipMode')), opt=True)
    _NNI_Information_neighbourNodeAddress = CHOICE(name=u'neighbourNodeAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    NNI_Information._cont = ASN1Dict([
        (u'sessionDirection', _NNI_Information_sessionDirection),
        (u'nNIType', _NNI_Information_nNIType),
        (u'relationshipMode', _NNI_Information_relationshipMode),
        (u'neighbourNodeAddress', _NNI_Information_neighbourNodeAddress),
        ])
    NNI_Information._ext = None
    
    #-----< NNIType >-----#
    NNIType = ENUM(name=u'NNIType', mode=MODE_TYPE)
    NNIType._cont = ASN1Dict([(u'non-roaming', 0), (u'roaming-without-loopback', 1), (u'roaming-with-loopback', 2)])
    NNIType._ext = None
    
    #-----< NumberPortabilityRouting >-----#
    NumberPortabilityRouting = STR_GRAPH(name=u'NumberPortabilityRouting', mode=MODE_TYPE)
    
    #-----< RateElement >-----#
    RateElement = SEQ(name=u'RateElement', mode=MODE_TYPE)
    _RateElement_unitType = INT(name=u'unitType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RateElement_unitValue = REAL(name=u'unitValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('_IMPL_', 'REAL')))
    _RateElement_unitCost = REAL(name=u'unitCost', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('_IMPL_', 'REAL')))
    _RateElement_unitQuotaThreshold = REAL(name=u'unitQuotaThreshold', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('_IMPL_', 'REAL')))
    RateElement._cont = ASN1Dict([
        (u'unitType', _RateElement_unitType),
        (u'unitValue', _RateElement_unitValue),
        (u'unitCost', _RateElement_unitCost),
        (u'unitQuotaThreshold', _RateElement_unitQuotaThreshold),
        ])
    RateElement._ext = None
    
    #-----< RealTimeTariffInformation >-----#
    RealTimeTariffInformation = CHOICE(name=u'RealTimeTariffInformation', mode=MODE_TYPE)
    _RealTimeTariffInformation_tariffInformation = SEQ(name=u'tariffInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TariffInformation')))
    _RealTimeTariffInformation_tariffXml = STR_UTF8(name=u'tariffXml', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    RealTimeTariffInformation._cont = ASN1Dict([
        (u'tariffInformation', _RealTimeTariffInformation_tariffInformation),
        (u'tariffXml', _RealTimeTariffInformation_tariffXml),
        ])
    RealTimeTariffInformation._ext = None
    
    #-----< ReasonHeaderInformation >-----#
    ReasonHeaderInformation = STR_GRAPH(name=u'ReasonHeaderInformation', mode=MODE_TYPE)
    
    #-----< RelationshipMode >-----#
    RelationshipMode = ENUM(name=u'RelationshipMode', mode=MODE_TYPE)
    RelationshipMode._cont = ASN1Dict([(u'trusted', 0), (u'non-trusted', 1)])
    RelationshipMode._ext = None
    
    #-----< Role-of-Node >-----#
    Role_of_Node = ENUM(name=u'Role-of-Node', mode=MODE_TYPE)
    Role_of_Node._cont = ASN1Dict([(u'originating', 0), (u'terminating', 1)])
    Role_of_Node._ext = None
    
    #-----< S-CSCF-Information >-----#
    S_CSCF_Information = SEQ(name=u'S-CSCF-Information', mode=MODE_TYPE)
    _S_CSCF_Information_mandatoryCapabilities = SEQ_OF(name=u'mandatoryCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __S_CSCF_Information_mandatoryCapabilities__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE)
    _S_CSCF_Information_mandatoryCapabilities._cont = __S_CSCF_Information_mandatoryCapabilities__item_
    _S_CSCF_Information_optionalCapabilities = SEQ_OF(name=u'optionalCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __S_CSCF_Information_optionalCapabilities__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE)
    _S_CSCF_Information_optionalCapabilities._cont = __S_CSCF_Information_optionalCapabilities__item_
    _S_CSCF_Information_serverName = STR_GRAPH(name=u'serverName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    S_CSCF_Information._cont = ASN1Dict([
        (u'mandatoryCapabilities', _S_CSCF_Information_mandatoryCapabilities),
        (u'optionalCapabilities', _S_CSCF_Information_optionalCapabilities),
        (u'serverName', _S_CSCF_Information_serverName),
        ])
    S_CSCF_Information._ext = None
    
    #-----< SDP-Media-Component >-----#
    SDP_Media_Component = SEQ(name=u'SDP-Media-Component', mode=MODE_TYPE)
    _SDP_Media_Component_sDP_Media_Name = STR_GRAPH(name=u'sDP-Media-Name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SDP_Media_Component_sDP_Media_Descriptions = SEQ_OF(name=u'sDP-Media-Descriptions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SDP-Media-Description')), opt=True)
    _SDP_Media_Component_accessCorrelationID = CHOICE(name=u'accessCorrelationID', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AccessCorrelationID')), opt=True)
    _SDP_Media_Component_localGWInsertedIndication = BOOL(name=u'localGWInsertedIndication', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SDP_Media_Component_iPRealmDefaultIndication = BOOL(name=u'iPRealmDefaultIndication', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SDP_Media_Component_transcoderInsertedIndication = BOOL(name=u'transcoderInsertedIndication', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SDP_Media_Component._cont = ASN1Dict([
        (u'sDP-Media-Name', _SDP_Media_Component_sDP_Media_Name),
        (u'sDP-Media-Descriptions', _SDP_Media_Component_sDP_Media_Descriptions),
        (u'accessCorrelationID', _SDP_Media_Component_accessCorrelationID),
        (u'localGWInsertedIndication', _SDP_Media_Component_localGWInsertedIndication),
        (u'iPRealmDefaultIndication', _SDP_Media_Component_iPRealmDefaultIndication),
        (u'transcoderInsertedIndication', _SDP_Media_Component_transcoderInsertedIndication),
        ])
    SDP_Media_Component._ext = None
    
    #-----< SDP-Media-Description >-----#
    SDP_Media_Description = SEQ_OF(name=u'SDP-Media-Description', mode=MODE_TYPE)
    _SDP_Media_Description__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE)
    SDP_Media_Description._cont = _SDP_Media_Description__item_
    
    #-----< ServedPartyIPAddress >-----#
    ServedPartyIPAddress = CHOICE(name=u'ServedPartyIPAddress', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    
    #-----< Service-Id >-----#
    Service_Id = STR_GRAPH(name=u'Service-Id', mode=MODE_TYPE)
    
    #-----< SessionDirection >-----#
    SessionDirection = ENUM(name=u'SessionDirection', mode=MODE_TYPE)
    SessionDirection._cont = ASN1Dict([(u'inbound', 0), (u'outbound', 1)])
    SessionDirection._ext = None
    
    #-----< SessionPriority >-----#
    SessionPriority = ENUM(name=u'SessionPriority', mode=MODE_TYPE)
    SessionPriority._cont = ASN1Dict([(u'pRIORITY-0', 0), (u'pRIORITY-1', 1), (u'pRIORITY-2', 2), (u'pRIORITY-3', 3), (u'pRIORITY-4', 4)])
    SessionPriority._ext = None
    
    #-----< SIP-Method >-----#
    SIP_Method = STR_GRAPH(name=u'SIP-Method', mode=MODE_TYPE)
    
    #-----< SDP-Type >-----#
    SDP_Type = ENUM(name=u'SDP-Type', mode=MODE_TYPE)
    SDP_Type._cont = ASN1Dict([(u'sDP-offer', 0), (u'sDP-answer', 1)])
    SDP_Type._ext = None
    
    #-----< Status >-----#
    Status = ENUM(name=u'Status', mode=MODE_TYPE)
    Status._cont = ASN1Dict([(u'fourxx', 0), (u'fivexx', 1), (u'time-out', 2)])
    Status._ext = None
    
    #-----< TADIdentifier >-----#
    TADIdentifier = ENUM(name=u'TADIdentifier', mode=MODE_TYPE)
    TADIdentifier._cont = ASN1Dict([(u'cS', 0), (u'pS', 1)])
    TADIdentifier._ext = None
    
    #-----< TariffInformation >-----#
    TariffInformation = SEQ(name=u'TariffInformation', mode=MODE_TYPE)
    _TariffInformation_currencyCode = INT(name=u'currencyCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TariffInformation_scaleFactor = REAL(name=u'scaleFactor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('_IMPL_', 'REAL')))
    _TariffInformation_rateElements = SEQ_OF(name=u'rateElements', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __TariffInformation_rateElements__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'RateElement')))
    _TariffInformation_rateElements._cont = __TariffInformation_rateElements__item_
    TariffInformation._cont = ASN1Dict([
        (u'currencyCode', _TariffInformation_currencyCode),
        (u'scaleFactor', _TariffInformation_scaleFactor),
        (u'rateElements', _TariffInformation_rateElements),
        ])
    TariffInformation._ext = None
    
    #-----< TransitIOILists >-----#
    TransitIOILists = SEQ_OF(name=u'TransitIOILists', mode=MODE_TYPE)
    _TransitIOILists__item_ = STR_GRAPH(name='_item_', mode=MODE_TYPE)
    TransitIOILists._cont = _TransitIOILists__item_
    
    #-----< TransmissionMedium >-----#
    TransmissionMedium = SEQ(name=u'TransmissionMedium', mode=MODE_TYPE)
    _TransmissionMedium_tMR = OCT_STR(name=u'tMR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TransmissionMedium_tMR._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _TransmissionMedium_tMU = OCT_STR(name=u'tMU', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TransmissionMedium_tMU._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    TransmissionMedium._cont = ASN1Dict([
        (u'tMR', _TransmissionMedium_tMR),
        (u'tMU', _TransmissionMedium_tMU),
        ])
    TransmissionMedium._ext = None
    
    #-----< TrunkGroupID >-----#
    TrunkGroupID = CHOICE(name=u'TrunkGroupID', mode=MODE_TYPE)
    _TrunkGroupID_incoming = STR_GRAPH(name=u'incoming', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TrunkGroupID_outgoing = STR_GRAPH(name=u'outgoing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TrunkGroupID._cont = ASN1Dict([
        (u'incoming', _TrunkGroupID_incoming),
        (u'outgoing', _TrunkGroupID_outgoing),
        ])
    TrunkGroupID._ext = None
    
    _all_ = [
        _IMSRecord_sCSCFRecord,
        _IMSRecord_pCSCFRecord,
        _IMSRecord_iCSCFRecord,
        _IMSRecord_mRFCRecord,
        _IMSRecord_mGCFRecord,
        _IMSRecord_bGCFRecord,
        _IMSRecord_aSRecord,
        _IMSRecord_eCSCFRecord,
        _IMSRecord_iBCFRecord,
        _IMSRecord_tRFRecord,
        _IMSRecord_tFRecord,
        _IMSRecord_aTCFRecord,
        IMSRecord,
        _SCSCFRecord_recordType,
        _SCSCFRecord_retransmission,
        _SCSCFRecord_sIP_Method,
        _SCSCFRecord_role_of_Node,
        _SCSCFRecord_nodeAddress,
        _SCSCFRecord_session_Id,
        _SCSCFRecord_list_Of_Calling_Party_Address,
        _SCSCFRecord_called_Party_Address,
        _SCSCFRecord_privateUserID,
        _SCSCFRecord_serviceRequestTimeStamp,
        _SCSCFRecord_serviceDeliveryStartTimeStamp,
        _SCSCFRecord_serviceDeliveryEndTimeStamp,
        _SCSCFRecord_recordOpeningTime,
        _SCSCFRecord_recordClosureTime,
        _SCSCFRecord_interOperatorIdentifiers,
        _SCSCFRecord_localRecordSequenceNumber,
        _SCSCFRecord_recordSequenceNumber,
        _SCSCFRecord_causeForRecordClosing,
        _SCSCFRecord_incomplete_CDR_Indication,
        _SCSCFRecord_iMS_Charging_Identifier,
        __SCSCFRecord_list_Of_SDP_Media_Components__item_,
        _SCSCFRecord_list_Of_SDP_Media_Components,
        _SCSCFRecord_gGSNaddress,
        _SCSCFRecord_serviceReasonReturnCode,
        __SCSCFRecord_list_Of_Message_Bodies__item_,
        _SCSCFRecord_list_Of_Message_Bodies,
        _SCSCFRecord_recordExtensions,
        _SCSCFRecord_expiresInformation,
        _SCSCFRecord_list_Of_Associated_URI,
        _SCSCFRecord_event,
        _SCSCFRecord_accessNetworkInformation,
        _SCSCFRecord_serviceContextID,
        __SCSCFRecord_list_of_subscription_ID__item_,
        _SCSCFRecord_list_of_subscription_ID,
        __SCSCFRecord_list_Of_Early_SDP_Media_Components__item_,
        _SCSCFRecord_list_Of_Early_SDP_Media_Components,
        _SCSCFRecord_iMSCommunicationServiceIdentifier,
        _SCSCFRecord_numberPortabilityRouting,
        _SCSCFRecord_carrierSelectRouting,
        _SCSCFRecord_sessionPriority,
        _SCSCFRecord_serviceRequestTimeStampFraction,
        _SCSCFRecord_serviceDeliveryStartTimeStampFraction,
        _SCSCFRecord_serviceDeliveryEndTimeStampFraction,
        __SCSCFRecord_applicationServersInformation__item_,
        _SCSCFRecord_applicationServersInformation,
        _SCSCFRecord_requested_Party_Address,
        _SCSCFRecord_list_Of_Called_Asserted_Identity,
        _SCSCFRecord_online_charging_flag,
        __SCSCFRecord_realTimeTariffInformation__item_,
        _SCSCFRecord_realTimeTariffInformation,
        _SCSCFRecord_userLocationInformation,
        _SCSCFRecord_mSTimeZone,
        _SCSCFRecord_nNI_Information,
        _SCSCFRecord_fromAddress,
        _SCSCFRecord_iMSEmergencyIndicator,
        _SCSCFRecord_transit_IOI_Lists,
        _SCSCFRecord_iMSVisitedNetworkIdentifier,
        _SCSCFRecord_listOfReasonHeader,
        _SCSCFRecord_additionalAccessNetworkInformation,
        _SCSCFRecord_instanceId,
        _SCSCFRecord_subscriberEquipmentNumber,
        _SCSCFRecord_routeHeaderReceived,
        _SCSCFRecord_routeHeaderTransmitted,
        __SCSCFRecord_list_Of_AccessNetworkInfoChange__item_,
        _SCSCFRecord_list_Of_AccessNetworkInfoChange,
        __SCSCFRecord_listOfCalledIdentityChanges__item_,
        _SCSCFRecord_listOfCalledIdentityChanges,
        _SCSCFRecord_cellularNetworkInformation,
        _SCSCFRecord_fEIdentifierList,
        SCSCFRecord,
        _PCSCFRecord_recordType,
        _PCSCFRecord_retransmission,
        _PCSCFRecord_sIP_Method,
        _PCSCFRecord_role_of_Node,
        _PCSCFRecord_nodeAddress,
        _PCSCFRecord_session_Id,
        _PCSCFRecord_list_Of_Calling_Party_Address,
        _PCSCFRecord_called_Party_Address,
        _PCSCFRecord_privateUserID,
        _PCSCFRecord_serviceRequestTimeStamp,
        _PCSCFRecord_serviceDeliveryStartTimeStamp,
        _PCSCFRecord_serviceDeliveryEndTimeStamp,
        _PCSCFRecord_recordOpeningTime,
        _PCSCFRecord_recordClosureTime,
        _PCSCFRecord_interOperatorIdentifiers,
        _PCSCFRecord_localRecordSequenceNumber,
        _PCSCFRecord_recordSequenceNumber,
        _PCSCFRecord_causeForRecordClosing,
        _PCSCFRecord_incomplete_CDR_Indication,
        _PCSCFRecord_iMS_Charging_Identifier,
        __PCSCFRecord_list_Of_SDP_Media_Components__item_,
        _PCSCFRecord_list_Of_SDP_Media_Components,
        _PCSCFRecord_gGSNaddress,
        _PCSCFRecord_serviceReasonReturnCode,
        __PCSCFRecord_list_Of_Message_Bodies__item_,
        _PCSCFRecord_list_Of_Message_Bodies,
        _PCSCFRecord_recordExtensions,
        _PCSCFRecord_expiresInformation,
        _PCSCFRecord_list_Of_Associated_URI,
        _PCSCFRecord_event,
        _PCSCFRecord_accessNetworkInformation,
        _PCSCFRecord_serviceContextID,
        __PCSCFRecord_list_of_subscription_ID__item_,
        _PCSCFRecord_list_of_subscription_ID,
        __PCSCFRecord_list_Of_Early_SDP_Media_Components__item_,
        _PCSCFRecord_list_Of_Early_SDP_Media_Components,
        _PCSCFRecord_iMSCommunicationServiceIdentifier,
        _PCSCFRecord_sessionPriority,
        _PCSCFRecord_serviceRequestTimeStampFraction,
        _PCSCFRecord_serviceDeliveryStartTimeStampFraction,
        _PCSCFRecord_serviceDeliveryEndTimeStampFraction,
        _PCSCFRecord_list_of_Requested_Party_Address,
        _PCSCFRecord_list_Of_Called_Asserted_Identity,
        _PCSCFRecord_nNI_Information,
        _PCSCFRecord_userLocationInformation,
        _PCSCFRecord_mSTimeZone,
        _PCSCFRecord_servedPartyIPAddress,
        _PCSCFRecord_fromAddress,
        _PCSCFRecord_iMSEmergencyIndicator,
        _PCSCFRecord_transit_IOI_Lists,
        _PCSCFRecord_iMSVisitedNetworkIdentifier,
        _PCSCFRecord_listOfReasonHeader,
        _PCSCFRecord_additionalAccessNetworkInformation,
        _PCSCFRecord_instanceId,
        _PCSCFRecord_subscriberEquipmentNumber,
        _PCSCFRecord_routeHeaderReceived,
        _PCSCFRecord_routeHeaderTransmitted,
        __PCSCFRecord_list_Of_AccessNetworkInfoChange__item_,
        _PCSCFRecord_list_Of_AccessNetworkInfoChange,
        __PCSCFRecord_listOfCalledIdentityChanges__item_,
        _PCSCFRecord_listOfCalledIdentityChanges,
        _PCSCFRecord_cellularNetworkInformation,
        _PCSCFRecord_initialIMS_Charging_Identifier,
        __PCSCFRecord_list_Of_AccessTransferInformation__item_,
        _PCSCFRecord_list_Of_AccessTransferInformation,
        _PCSCFRecord_relatedICID,
        _PCSCFRecord_relatedICIDGenerationNode,
        _PCSCFRecord_fEIdentifierList,
        PCSCFRecord,
        _ICSCFRecord_recordType,
        _ICSCFRecord_retransmission,
        _ICSCFRecord_sIP_Method,
        _ICSCFRecord_role_of_Node,
        _ICSCFRecord_nodeAddress,
        _ICSCFRecord_session_Id,
        _ICSCFRecord_list_Of_Calling_Party_Address,
        _ICSCFRecord_called_Party_Address,
        _ICSCFRecord_serviceRequestTimeStamp,
        _ICSCFRecord_interOperatorIdentifiers,
        _ICSCFRecord_localRecordSequenceNumber,
        _ICSCFRecord_causeForRecordClosing,
        _ICSCFRecord_incomplete_CDR_Indication,
        _ICSCFRecord_iMS_Charging_Identifier,
        _ICSCFRecord_serviceReasonReturnCode,
        _ICSCFRecord_recordExtensions,
        _ICSCFRecord_expiresInformation,
        _ICSCFRecord_list_Of_Associated_URI,
        _ICSCFRecord_event,
        _ICSCFRecord_accessNetworkInformation,
        _ICSCFRecord_serviceContextID,
        _ICSCFRecord_numberPortabilityRouting,
        _ICSCFRecord_carrierSelectRouting,
        _ICSCFRecord_sessionPriority,
        _ICSCFRecord_serviceRequestTimeStampFraction,
        _ICSCFRecord_transit_IOI_List,
        _ICSCFRecord_userLocationInformation,
        _ICSCFRecord_mSTimeZone,
        _ICSCFRecord_fromAddress,
        _ICSCFRecord_iMSEmergencyIndicator,
        _ICSCFRecord_listOfReasonHeader,
        _ICSCFRecord_additionalAccessNetworkInformation,
        _ICSCFRecord_routeHeaderTransmitted,
        _ICSCFRecord_s_CSCF_Information,
        _ICSCFRecord_cellularNetworkInformation,
        _ICSCFRecord_fEIdentifierList,
        ICSCFRecord,
        _MRFCRecord_recordType,
        _MRFCRecord_retransmission,
        _MRFCRecord_sIP_Method,
        _MRFCRecord_nodeAddress,
        _MRFCRecord_session_Id,
        _MRFCRecord_list_Of_Calling_Party_Address,
        _MRFCRecord_called_Party_Address,
        _MRFCRecord_serviceRequestTimeStamp,
        _MRFCRecord_serviceDeliveryStartTimeStamp,
        _MRFCRecord_serviceDeliveryEndTimeStamp,
        _MRFCRecord_recordOpeningTime,
        _MRFCRecord_recordClosureTime,
        _MRFCRecord_interOperatorIdentifiers,
        _MRFCRecord_localRecordSequenceNumber,
        _MRFCRecord_recordSequenceNumber,
        _MRFCRecord_causeForRecordClosing,
        _MRFCRecord_incomplete_CDR_Indication,
        _MRFCRecord_iMS_Charging_Identifier,
        __MRFCRecord_list_Of_SDP_Media_Components__item_,
        _MRFCRecord_list_Of_SDP_Media_Components,
        _MRFCRecord_gGSNaddress,
        _MRFCRecord_serviceReasonReturnCode,
        _MRFCRecord_recordExtensions,
        _MRFCRecord_expiresInformation,
        _MRFCRecord_event,
        _MRFCRecord_accessNetworkInformation,
        _MRFCRecord_serviceContextID,
        __MRFCRecord_list_of_subscription_ID__item_,
        _MRFCRecord_list_of_subscription_ID,
        __MRFCRecord_list_Of_Early_SDP_Media_Components__item_,
        _MRFCRecord_list_Of_Early_SDP_Media_Components,
        _MRFCRecord_sessionPriority,
        _MRFCRecord_serviceRequestTimeStampFraction,
        _MRFCRecord_serviceDeliveryStartTimeStampFraction,
        _MRFCRecord_serviceDeliveryEndTimeStampFraction,
        __MRFCRecord_applicationServersInformation__item_,
        _MRFCRecord_applicationServersInformation,
        _MRFCRecord_online_charging_flag,
        _MRFCRecord_transit_IOI_List,
        _MRFCRecord_userLocationInformation,
        _MRFCRecord_mSTimeZone,
        _MRFCRecord_fromAddress,
        _MRFCRecord_listOfReasonHeader,
        _MRFCRecord_additionalAccessNetworkInformation,
        __MRFCRecord_list_Of_AccessNetworkInfoChange__item_,
        _MRFCRecord_list_Of_AccessNetworkInfoChange,
        _MRFCRecord_cellularNetworkInformation,
        _MRFCRecord_service_Id,
        _MRFCRecord_requested_Party_Address,
        _MRFCRecord_list_Of_Called_Asserted_Identity,
        _MRFCRecord_fEIdentifierList,
        MRFCRecord,
        _MGCFRecord_recordType,
        _MGCFRecord_retransmission,
        _MGCFRecord_sIP_Method,
        _MGCFRecord_role_of_Node,
        _MGCFRecord_nodeAddress,
        _MGCFRecord_session_Id,
        _MGCFRecord_list_Of_Calling_Party_Address,
        _MGCFRecord_called_Party_Address,
        _MGCFRecord_serviceRequestTimeStamp,
        _MGCFRecord_serviceDeliveryStartTimeStamp,
        _MGCFRecord_serviceDeliveryEndTimeStamp,
        _MGCFRecord_recordOpeningTime,
        _MGCFRecord_recordClosureTime,
        _MGCFRecord_interOperatorIdentifiers,
        _MGCFRecord_localRecordSequenceNumber,
        _MGCFRecord_recordSequenceNumber,
        _MGCFRecord_causeForRecordClosing,
        _MGCFRecord_incomplete_CDR_Indication,
        _MGCFRecord_iMS_Charging_Identifier,
        __MGCFRecord_list_Of_SDP_Media_Components__item_,
        _MGCFRecord_list_Of_SDP_Media_Components,
        _MGCFRecord_serviceReasonReturnCode,
        _MGCFRecord_recordExtensions,
        _MGCFRecord_expiresInformation,
        _MGCFRecord_event,
        _MGCFRecord_accessNetworkInformation,
        _MGCFRecord_serviceContextID,
        __MGCFRecord_list_Of_Early_SDP_Media_Components__item_,
        _MGCFRecord_list_Of_Early_SDP_Media_Components,
        _MGCFRecord_numberPortabilityRouting,
        _MGCFRecord_carrierSelectRouting,
        _MGCFRecord_sessionPriority,
        _MGCFRecord_serviceRequestTimeStampFraction,
        _MGCFRecord_serviceDeliveryStartTimeStampFraction,
        _MGCFRecord_serviceDeliveryEndTimeStampFraction,
        __MGCFRecord_realTimeTariffInformation__item_,
        _MGCFRecord_realTimeTariffInformation,
        _MGCFRecord_transit_IOI_List,
        _MGCFRecord_fromAddress,
        _MGCFRecord_listOfReasonHeader,
        _MGCFRecord_additionalAccessNetworkInformation,
        __MGCFRecord_list_Of_AccessNetworkInfoChange__item_,
        _MGCFRecord_list_Of_AccessNetworkInfoChange,
        _MGCFRecord_cellularNetworkInformation,
        _MGCFRecord_trunkGroupID,
        _MGCFRecord_bearerService,
        _MGCFRecord_iSUPCause,
        _MGCFRecord_fEIdentifierList,
        MGCFRecord,
        _BGCFRecord_recordType,
        _BGCFRecord_retransmission,
        _BGCFRecord_sIP_Method,
        _BGCFRecord_role_of_Node,
        _BGCFRecord_nodeAddress,
        _BGCFRecord_session_Id,
        _BGCFRecord_list_Of_Calling_Party_Address,
        _BGCFRecord_called_Party_Address,
        _BGCFRecord_serviceRequestTimeStamp,
        _BGCFRecord_interOperatorIdentifiers,
        _BGCFRecord_localRecordSequenceNumber,
        _BGCFRecord_causeForRecordClosing,
        _BGCFRecord_incomplete_CDR_Indication,
        _BGCFRecord_iMS_Charging_Identifier,
        _BGCFRecord_serviceReasonReturnCode,
        _BGCFRecord_recordExtensions,
        _BGCFRecord_expiresInformation,
        _BGCFRecord_event,
        _BGCFRecord_accessNetworkInformation,
        _BGCFRecord_serviceContextID,
        _BGCFRecord_numberPortabilityRouting,
        _BGCFRecord_carrierSelectRouting,
        _BGCFRecord_sessionPriority,
        _BGCFRecord_serviceRequestTimeStampFraction,
        _BGCFRecord_serviceDeliveryStartTimeStampFraction,
        _BGCFRecord_serviceDeliveryEndTimeStampFraction,
        _BGCFRecord_transit_IOI_List,
        _BGCFRecord_nNI_Information,
        _BGCFRecord_fromAddress,
        _BGCFRecord_listOfReasonHeader,
        _BGCFRecord_additionalAccessNetworkInformation,
        _BGCFRecord_cellularNetworkInformation,
        _BGCFRecord_fEIdentifierList,
        BGCFRecord,
        _ASRecord_recordType,
        _ASRecord_retransmission,
        _ASRecord_sIP_Method,
        _ASRecord_role_of_Node,
        _ASRecord_nodeAddress,
        _ASRecord_session_Id,
        _ASRecord_list_Of_Calling_Party_Address,
        _ASRecord_called_Party_Address,
        _ASRecord_privateUserID,
        _ASRecord_serviceRequestTimeStamp,
        _ASRecord_serviceDeliveryStartTimeStamp,
        _ASRecord_serviceDeliveryEndTimeStamp,
        _ASRecord_recordOpeningTime,
        _ASRecord_recordClosureTime,
        _ASRecord_interOperatorIdentifiers,
        _ASRecord_localRecordSequenceNumber,
        _ASRecord_recordSequenceNumber,
        _ASRecord_causeForRecordClosing,
        _ASRecord_incomplete_CDR_Indication,
        _ASRecord_iMS_Charging_Identifier,
        __ASRecord_list_Of_SDP_Media_Components__item_,
        _ASRecord_list_Of_SDP_Media_Components,
        _ASRecord_gGSNaddress,
        _ASRecord_serviceReasonReturnCode,
        __ASRecord_list_Of_Message_Bodies__item_,
        _ASRecord_list_Of_Message_Bodies,
        _ASRecord_recordExtensions,
        _ASRecord_expiresInformation,
        _ASRecord_event,
        _ASRecord_accessNetworkInformation,
        _ASRecord_serviceContextID,
        __ASRecord_list_of_subscription_ID__item_,
        _ASRecord_list_of_subscription_ID,
        __ASRecord_list_Of_Early_SDP_Media_Components__item_,
        _ASRecord_list_Of_Early_SDP_Media_Components,
        _ASRecord_iMSCommunicationServiceIdentifier,
        _ASRecord_numberPortabilityRouting,
        _ASRecord_carrierSelectRouting,
        _ASRecord_sessionPriority,
        _ASRecord_serviceRequestTimeStampFraction,
        _ASRecord_serviceDeliveryStartTimeStampFraction,
        _ASRecord_serviceDeliveryEndTimeStampFraction,
        _ASRecord_list_of_Requested_Party_Address,
        _ASRecord_online_charging_flag,
        __ASRecord_realTimeTariffInformation__item_,
        _ASRecord_realTimeTariffInformation,
        _ASRecord_nNI_Information,
        _ASRecord_userLocationInformation,
        _ASRecord_mSTimeZone,
        _ASRecord_fromAddress,
        _ASRecord_transit_IOI_Lists,
        _ASRecord_iMSVisitedNetworkIdentifier,
        _ASRecord_listOfReasonHeader,
        _ASRecord_additionalAccessNetworkInformation,
        _ASRecord_instanceId,
        _ASRecord_subscriberEquipmentNumber,
        __ASRecord_list_Of_AccessNetworkInfoChange__item_,
        _ASRecord_list_Of_AccessNetworkInfoChange,
        __ASRecord_listOfCalledIdentityChanges__item_,
        _ASRecord_listOfCalledIdentityChanges,
        _ASRecord_cellularNetworkInformation,
        __ASRecord_serviceSpecificInfo__item_,
        _ASRecord_serviceSpecificInfo,
        _ASRecord_requested_Party_Address,
        _ASRecord_list_Of_Called_Asserted_Identity,
        _ASRecord_alternateChargedPartyAddress,
        _ASRecord_outgoingSessionId,
        _ASRecord_initialIMS_Charging_Identifier,
        __ASRecord_list_Of_AccessTransferInformation__item_,
        _ASRecord_list_Of_AccessTransferInformation,
        _ASRecord_tADS_Identifier,
        _ASRecord_vlr_Number,
        _ASRecord_msc_Address,
        _ASRecord_threeGPPPSDataOffStatus,
        _ASRecord_fEIdentifierList,
        ASRecord,
        _ECSCFRecord_recordType,
        _ECSCFRecord_retransmission,
        _ECSCFRecord_sIP_Method,
        _ECSCFRecord_role_of_Node,
        _ECSCFRecord_nodeAddress,
        _ECSCFRecord_session_Id,
        _ECSCFRecord_list_Of_Calling_Party_Address,
        _ECSCFRecord_called_Party_Address,
        _ECSCFRecord_serviceRequestTimeStamp,
        _ECSCFRecord_serviceDeliveryStartTimeStamp,
        _ECSCFRecord_serviceDeliveryEndTimeStamp,
        _ECSCFRecord_recordOpeningTime,
        _ECSCFRecord_recordClosureTime,
        _ECSCFRecord_interOperatorIdentifiers,
        _ECSCFRecord_localRecordSequenceNumber,
        _ECSCFRecord_recordSequenceNumber,
        _ECSCFRecord_causeForRecordClosing,
        _ECSCFRecord_incomplete_CDR_Indication,
        _ECSCFRecord_iMS_Charging_Identifier,
        __ECSCFRecord_list_Of_SDP_Media_Components__item_,
        _ECSCFRecord_list_Of_SDP_Media_Components,
        _ECSCFRecord_gGSNaddress,
        _ECSCFRecord_serviceReasonReturnCode,
        __ECSCFRecord_list_Of_Message_Bodies__item_,
        _ECSCFRecord_list_Of_Message_Bodies,
        _ECSCFRecord_recordExtensions,
        _ECSCFRecord_expiresInformation,
        _ECSCFRecord_event,
        _ECSCFRecord_accessNetworkInformation,
        _ECSCFRecord_serviceContextID,
        __ECSCFRecord_list_of_subscription_ID__item_,
        _ECSCFRecord_list_of_subscription_ID,
        __ECSCFRecord_list_Of_Early_SDP_Media_Components__item_,
        _ECSCFRecord_list_Of_Early_SDP_Media_Components,
        _ECSCFRecord_iMSCommunicationServiceIdentifier,
        _ECSCFRecord_sessionPriority,
        _ECSCFRecord_serviceRequestTimeStampFraction,
        _ECSCFRecord_serviceDeliveryStartTimeStampFraction,
        _ECSCFRecord_serviceDeliveryEndTimeStampFraction,
        __ECSCFRecord_applicationServersInformation__item_,
        _ECSCFRecord_applicationServersInformation,
        _ECSCFRecord_requested_Party_Address,
        _ECSCFRecord_list_Of_Called_Asserted_Identity,
        _ECSCFRecord_userLocationInformation,
        _ECSCFRecord_mSTimeZone,
        _ECSCFRecord_fromAddress,
        _ECSCFRecord_transit_IOI_Lists,
        _ECSCFRecord_listOfReasonHeader,
        _ECSCFRecord_additionalAccessNetworkInformation,
        __ECSCFRecord_list_Of_AccessNetworkInfoChange__item_,
        _ECSCFRecord_list_Of_AccessNetworkInfoChange,
        __ECSCFRecord_listOfCalledIdentityChanges__item_,
        _ECSCFRecord_listOfCalledIdentityChanges,
        _ECSCFRecord_cellularNetworkInformation,
        _ECSCFRecord_fEIdentifierList,
        ECSCFRecord,
        _IBCFRecord_recordType,
        _IBCFRecord_retransmission,
        _IBCFRecord_sIP_Method,
        _IBCFRecord_role_of_Node,
        _IBCFRecord_nodeAddress,
        _IBCFRecord_session_Id,
        _IBCFRecord_list_Of_Calling_Party_Address,
        _IBCFRecord_called_Party_Address,
        _IBCFRecord_privateUserID,
        _IBCFRecord_serviceRequestTimeStamp,
        _IBCFRecord_serviceDeliveryStartTimeStamp,
        _IBCFRecord_serviceDeliveryEndTimeStamp,
        _IBCFRecord_recordOpeningTime,
        _IBCFRecord_recordClosureTime,
        _IBCFRecord_interOperatorIdentifiers,
        _IBCFRecord_localRecordSequenceNumber,
        _IBCFRecord_recordSequenceNumber,
        _IBCFRecord_causeForRecordClosing,
        _IBCFRecord_incomplete_CDR_Indication,
        _IBCFRecord_iMS_Charging_Identifier,
        __IBCFRecord_list_Of_SDP_Media_Components__item_,
        _IBCFRecord_list_Of_SDP_Media_Components,
        _IBCFRecord_gGSNaddress,
        _IBCFRecord_serviceReasonReturnCode,
        __IBCFRecord_list_Of_Message_Bodies__item_,
        _IBCFRecord_list_Of_Message_Bodies,
        _IBCFRecord_recordExtensions,
        _IBCFRecord_expiresInformation,
        _IBCFRecord_event,
        _IBCFRecord_accessNetworkInformation,
        _IBCFRecord_serviceContextID,
        __IBCFRecord_list_of_subscription_ID__item_,
        _IBCFRecord_list_of_subscription_ID,
        __IBCFRecord_list_Of_Early_SDP_Media_Components__item_,
        _IBCFRecord_list_Of_Early_SDP_Media_Components,
        _IBCFRecord_iMSCommunicationServiceIdentifier,
        _IBCFRecord_sessionPriority,
        _IBCFRecord_serviceRequestTimeStampFraction,
        _IBCFRecord_serviceDeliveryStartTimeStampFraction,
        _IBCFRecord_serviceDeliveryEndTimeStampFraction,
        _IBCFRecord_list_of_Requested_Party_Address,
        _IBCFRecord_list_Of_Called_Asserted_Identity,
        _IBCFRecord_transit_IOI_List,
        __IBCFRecord_nNI_Information__item_,
        _IBCFRecord_nNI_Information,
        _IBCFRecord_userLocationInformation,
        _IBCFRecord_mSTimeZone,
        _IBCFRecord_fromAddress,
        _IBCFRecord_listOfReasonHeader,
        _IBCFRecord_additionalAccessNetworkInformation,
        _IBCFRecord_routeHeaderReceived,
        __IBCFRecord_list_Of_AccessNetworkInfoChange__item_,
        _IBCFRecord_list_Of_AccessNetworkInfoChange,
        _IBCFRecord_cellularNetworkInformation,
        _IBCFRecord_initialIMS_Charging_Identifier,
        __IBCFRecord_list_Of_AccessTransferInformation__item_,
        _IBCFRecord_list_Of_AccessTransferInformation,
        _IBCFRecord_fEIdentifierList,
        IBCFRecord,
        _TRFRecord_recordType,
        _TRFRecord_retransmission,
        _TRFRecord_sIP_Method,
        _TRFRecord_role_of_Node,
        _TRFRecord_nodeAddress,
        _TRFRecord_session_Id,
        _TRFRecord_list_Of_Calling_Party_Address,
        _TRFRecord_called_Party_Address,
        _TRFRecord_serviceRequestTimeStamp,
        _TRFRecord_serviceDeliveryStartTimeStamp,
        _TRFRecord_serviceDeliveryEndTimeStamp,
        _TRFRecord_recordOpeningTime,
        _TRFRecord_recordClosureTime,
        _TRFRecord_interOperatorIdentifiers,
        _TRFRecord_localRecordSequenceNumber,
        _TRFRecord_recordSequenceNumber,
        _TRFRecord_causeForRecordClosing,
        _TRFRecord_incomplete_CDR_Indication,
        _TRFRecord_iMS_Charging_Identifier,
        __TRFRecord_list_Of_SDP_Media_Components__item_,
        _TRFRecord_list_Of_SDP_Media_Components,
        _TRFRecord_serviceReasonReturnCode,
        __TRFRecord_list_Of_Message_Bodies__item_,
        _TRFRecord_list_Of_Message_Bodies,
        _TRFRecord_recordExtensions,
        _TRFRecord_expiresInformation,
        _TRFRecord_event,
        _TRFRecord_serviceContextID,
        __TRFRecord_list_of_subscription_ID__item_,
        _TRFRecord_list_of_subscription_ID,
        __TRFRecord_list_Of_Early_SDP_Media_Components__item_,
        _TRFRecord_list_Of_Early_SDP_Media_Components,
        _TRFRecord_iMSCommunicationServiceIdentifier,
        _TRFRecord_numberPortabilityRouting,
        _TRFRecord_carrierSelectRouting,
        _TRFRecord_sessionPriority,
        _TRFRecord_serviceRequestTimeStampFraction,
        _TRFRecord_serviceDeliveryStartTimeStampFraction,
        _TRFRecord_serviceDeliveryEndTimeStampFraction,
        __TRFRecord_applicationServersInformation__item_,
        _TRFRecord_applicationServersInformation,
        _TRFRecord_requested_Party_Address,
        _TRFRecord_list_Of_Called_Asserted_Identity,
        __TRFRecord_nNI_Information__item_,
        _TRFRecord_nNI_Information,
        _TRFRecord_userLocationInformation,
        _TRFRecord_mSTimeZone,
        _TRFRecord_transit_IOI_Lists,
        _TRFRecord_listOfReasonHeader,
        _TRFRecord_routeHeaderReceived,
        __TRFRecord_listOfCalledIdentityChanges__item_,
        _TRFRecord_listOfCalledIdentityChanges,
        _TRFRecord_fEIdentifierList,
        TRFRecord,
        _ATCFRecord_recordType,
        _ATCFRecord_retransmission,
        _ATCFRecord_sIP_Method,
        _ATCFRecord_role_of_Node,
        _ATCFRecord_nodeAddress,
        _ATCFRecord_session_Id,
        _ATCFRecord_list_Of_Calling_Party_Address,
        _ATCFRecord_called_Party_Address,
        _ATCFRecord_privateUserID,
        _ATCFRecord_serviceRequestTimeStamp,
        _ATCFRecord_serviceDeliveryStartTimeStamp,
        _ATCFRecord_serviceDeliveryEndTimeStamp,
        _ATCFRecord_recordOpeningTime,
        _ATCFRecord_recordClosureTime,
        _ATCFRecord_interOperatorIdentifiers,
        _ATCFRecord_localRecordSequenceNumber,
        _ATCFRecord_recordSequenceNumber,
        _ATCFRecord_causeForRecordClosing,
        _ATCFRecord_incomplete_CDR_Indication,
        _ATCFRecord_iMS_Charging_Identifier,
        __ATCFRecord_list_Of_SDP_Media_Components__item_,
        _ATCFRecord_list_Of_SDP_Media_Components,
        _ATCFRecord_gGSNaddress,
        _ATCFRecord_serviceReasonReturnCode,
        __ATCFRecord_list_Of_Message_Bodies__item_,
        _ATCFRecord_list_Of_Message_Bodies,
        _ATCFRecord_recordExtensions,
        _ATCFRecord_expiresInformation,
        _ATCFRecord_event,
        _ATCFRecord_accessNetworkInformation,
        _ATCFRecord_serviceContextID,
        __ATCFRecord_list_of_subscription_ID__item_,
        _ATCFRecord_list_of_subscription_ID,
        __ATCFRecord_list_Of_Early_SDP_Media_Components__item_,
        _ATCFRecord_list_Of_Early_SDP_Media_Components,
        _ATCFRecord_iMSCommunicationServiceIdentifier,
        _ATCFRecord_sessionPriority,
        _ATCFRecord_serviceRequestTimeStampFraction,
        _ATCFRecord_serviceDeliveryStartTimeStampFraction,
        _ATCFRecord_serviceDeliveryEndTimeStampFraction,
        _ATCFRecord_list_of_Requested_Party_Address,
        _ATCFRecord_list_Of_Called_Asserted_Identity,
        _ATCFRecord_nNI_Information,
        _ATCFRecord_userLocationInformation,
        _ATCFRecord_mSTimeZone,
        _ATCFRecord_fromAddress,
        _ATCFRecord_listOfReasonHeader,
        _ATCFRecord_additionalAccessNetworkInformation,
        _ATCFRecord_routeHeaderReceived,
        _ATCFRecord_routeHeaderTransmitted,
        __ATCFRecord_list_Of_AccessNetworkInfoChange__item_,
        _ATCFRecord_list_Of_AccessNetworkInfoChange,
        __ATCFRecord_listOfCalledIdentityChanges__item_,
        _ATCFRecord_listOfCalledIdentityChanges,
        _ATCFRecord_cellularNetworkInformation,
        _ATCFRecord_initialIMS_Charging_Identifier,
        __ATCFRecord_list_Of_AccessTransferInformation__item_,
        _ATCFRecord_list_Of_AccessTransferInformation,
        _ATCFRecord_fEIdentifierList,
        ATCFRecord,
        _TFRecord_recordType,
        _TFRecord_retransmission,
        _TFRecord_sIP_Method,
        _TFRecord_role_of_Node,
        _TFRecord_nodeAddress,
        _TFRecord_session_Id,
        _TFRecord_list_Of_Calling_Party_Address,
        _TFRecord_called_Party_Address,
        _TFRecord_serviceRequestTimeStamp,
        _TFRecord_serviceDeliveryStartTimeStamp,
        _TFRecord_serviceDeliveryEndTimeStamp,
        _TFRecord_recordOpeningTime,
        _TFRecord_recordClosureTime,
        _TFRecord_interOperatorIdentifiers,
        _TFRecord_localRecordSequenceNumber,
        _TFRecord_recordSequenceNumber,
        _TFRecord_causeForRecordClosing,
        _TFRecord_incomplete_CDR_Indication,
        _TFRecord_iMS_Charging_Identifier,
        __TFRecord_list_Of_SDP_Media_Components__item_,
        _TFRecord_list_Of_SDP_Media_Components,
        _TFRecord_serviceReasonReturnCode,
        __TFRecord_list_Of_Message_Bodies__item_,
        _TFRecord_list_Of_Message_Bodies,
        _TFRecord_recordExtensions,
        _TFRecord_expiresInformation,
        _TFRecord_event,
        _TFRecord_serviceContextID,
        __TFRecord_list_Of_Early_SDP_Media_Components__item_,
        _TFRecord_list_Of_Early_SDP_Media_Components,
        _TFRecord_iMSCommunicationServiceIdentifier,
        _TFRecord_numberPortabilityRouting,
        _TFRecord_carrierSelectRouting,
        _TFRecord_sessionPriority,
        _TFRecord_serviceRequestTimeStampFraction,
        _TFRecord_serviceDeliveryStartTimeStampFraction,
        _TFRecord_serviceDeliveryEndTimeStampFraction,
        __TFRecord_applicationServersInformation__item_,
        _TFRecord_applicationServersInformation,
        _TFRecord_requested_Party_Address,
        _TFRecord_list_Of_Called_Asserted_Identity,
        _TFRecord_nNI_Information,
        _TFRecord_fromAddress,
        _TFRecord_transit_IOI_Lists,
        _TFRecord_listOfReasonHeader,
        _TFRecord_routeHeaderReceived,
        _TFRecord_routeHeaderTransmitted,
        __TFRecord_listOfCalledIdentityChanges__item_,
        _TFRecord_listOfCalledIdentityChanges,
        _TFRecord_fEIdentifierList,
        TFRecord,
        _AccessCorrelationID_gPRS_Charging_Id,
        _AccessCorrelationID_accessNetworkChargingIdentifier,
        AccessCorrelationID,
        _AccessNetworkInfoChange_accessNetworkInformation,
        _AccessNetworkInfoChange_additionalAccessNetworkInformation,
        _AccessNetworkInfoChange_accessChangeTime,
        _AccessNetworkInfoChange_cellularNetworkInformation,
        AccessNetworkInfoChange,
        AccessTransferType,
        _AccessTransferInformation_accessTransferType,
        _AccessTransferInformation_accessNetworkInformation,
        _AccessTransferInformation_additionalAccessNetworkInformation,
        _AccessTransferInformation_inter_UE_Transfer,
        _AccessTransferInformation_relatedICID,
        _AccessTransferInformation_relatedICIDGenerationNode,
        _AccessTransferInformation_accessTransferTime,
        _AccessTransferInformation_subscriberEquipmentNumber,
        _AccessTransferInformation_instanceId,
        _AccessTransferInformation_cellularNetworkInformation,
        AccessTransferInformation,
        ACRInterimLost,
        _AoCCostInformation_accumulatedCost,
        _AoCCostInformation_incrementalCost,
        _AoCCostInformation_currencyCode,
        AoCCostInformation,
        _AoCInformation_tariffInformation,
        _AoCInformation_aoCCostInformation,
        AoCInformation,
        _ApplicationServersInformation_applicationServersInvolved,
        __ApplicationServersInformation_applicationProvidedCalledParties__item_,
        _ApplicationServersInformation_applicationProvidedCalledParties,
        _ApplicationServersInformation_sTatus,
        ApplicationServersInformation,
        _CalledIdentityChange_calledIdentity,
        _CalledIdentityChange_changeTime,
        CalledIdentityChange,
        CarrierSelectRouting,
        CauseForRecordClosing,
        _Early_Media_Components_List_sDP_Offer_Timestamp,
        _Early_Media_Components_List_sDP_Answer_Timestamp,
        __Early_Media_Components_List_sDP_Media_Components__item_,
        _Early_Media_Components_List_sDP_Media_Components,
        _Early_Media_Components_List_mediaInitiatorFlag,
        __Early_Media_Components_List_sDP_Session_Description__item_,
        _Early_Media_Components_List_sDP_Session_Description,
        _Early_Media_Components_List_sDP_Type,
        Early_Media_Components_List,
        _FEIdentifierList__item_,
        FEIdentifierList,
        IMS_Charging_Identifier,
        IMSCommunicationServiceIdentifier,
        _Incomplete_CDR_Indication_aCRStartLost,
        _Incomplete_CDR_Indication_aCRInterimLost,
        _Incomplete_CDR_Indication_aCRStopLost,
        Incomplete_CDR_Indication,
        _InterOperatorIdentifierList__item_,
        InterOperatorIdentifierList,
        _InterOperatorIdentifiers_originatingIOI,
        _InterOperatorIdentifiers_terminatingIOI,
        InterOperatorIdentifiers,
        _ISUPCause_iSUPCauseLocation,
        _ISUPCause_iSUPCauseValue,
        _ISUPCause_iSUPCauseDiagnostics,
        ISUPCause,
        _ListOfInvolvedParties__item_,
        ListOfInvolvedParties,
        _ListOfReasonHeader__item_,
        ListOfReasonHeader,
        _Media_Components_List_sIP_Request_Timestamp,
        _Media_Components_List_sIP_Response_Timestamp,
        __Media_Components_List_sDP_Media_Components__item_,
        _Media_Components_List_sDP_Media_Components,
        _Media_Components_List_mediaInitiatorFlag,
        __Media_Components_List_sDP_Session_Description__item_,
        _Media_Components_List_sDP_Session_Description,
        _Media_Components_List_mediaInitiatorParty,
        _Media_Components_List_sIP_Request_Timestamp_Fraction,
        _Media_Components_List_sIP_Response_Timestamp_Fraction,
        _Media_Components_List_sDP_Type,
        Media_Components_List,
        _MessageBody_content_Type,
        _MessageBody_content_Disposition,
        _MessageBody_content_Length,
        _MessageBody_originator,
        MessageBody,
        Milliseconds,
        _NNI_Information_sessionDirection,
        _NNI_Information_nNIType,
        _NNI_Information_relationshipMode,
        _NNI_Information_neighbourNodeAddress,
        NNI_Information,
        NNIType,
        NumberPortabilityRouting,
        _RateElement_unitType,
        _RateElement_unitValue,
        _RateElement_unitCost,
        _RateElement_unitQuotaThreshold,
        RateElement,
        _RealTimeTariffInformation_tariffInformation,
        _RealTimeTariffInformation_tariffXml,
        RealTimeTariffInformation,
        ReasonHeaderInformation,
        RelationshipMode,
        Role_of_Node,
        __S_CSCF_Information_mandatoryCapabilities__item_,
        _S_CSCF_Information_mandatoryCapabilities,
        __S_CSCF_Information_optionalCapabilities__item_,
        _S_CSCF_Information_optionalCapabilities,
        _S_CSCF_Information_serverName,
        S_CSCF_Information,
        _SDP_Media_Component_sDP_Media_Name,
        _SDP_Media_Component_sDP_Media_Descriptions,
        _SDP_Media_Component_accessCorrelationID,
        _SDP_Media_Component_localGWInsertedIndication,
        _SDP_Media_Component_iPRealmDefaultIndication,
        _SDP_Media_Component_transcoderInsertedIndication,
        SDP_Media_Component,
        _SDP_Media_Description__item_,
        SDP_Media_Description,
        ServedPartyIPAddress,
        Service_Id,
        SessionDirection,
        SessionPriority,
        SIP_Method,
        SDP_Type,
        Status,
        TADIdentifier,
        _TariffInformation_currencyCode,
        _TariffInformation_scaleFactor,
        __TariffInformation_rateElements__item_,
        _TariffInformation_rateElements,
        TariffInformation,
        _TransitIOILists__item_,
        TransitIOILists,
        _TransmissionMedium_tMR,
        _TransmissionMedium_tMU,
        TransmissionMedium,
        _TrunkGroupID_incoming,
        _TrunkGroupID_outgoing,
        TrunkGroupID,
    ]

class InformationFramework:

    _name_  = u'InformationFramework'
    _oid_   = [2, 5, 1, 1, 8]
    
    _obj_ = [
        u'Attribute',
        u'AttributeType',
        u'AttributeValue',
        u'Context',
        u'AttributeValueAssertion',
        u'ContextAssertion',
        u'AttributeTypeAssertion',
        u'SupportedAttributes',
        u'SupportedContexts',
        u'Name',
        u'RDNSequence',
        u'DistinguishedName',
        u'RelativeDistinguishedName',
        u'AttributeTypeAndValue',
        u'SubtreeSpecification',
        u'LocalName',
        u'ChopSpecification',
        u'BaseDistance',
        u'Refinement',
        u'OBJECT-CLASS',
        u'ObjectClassKind',
        u'top',
        u'alias',
        u'parent',
        u'child',
        u'ATTRIBUTE',
        u'AttributeUsage',
        u'objectClass',
        u'aliasedEntryName',
        u'MATCHING-RULE',
        u'objectIdentifierMatch',
        u'distinguishedNameMatch',
        u'MAPPING-BASED-MATCHING',
        u'NAME-FORM',
        u'DITStructureRule',
        u'RuleIdentifier',
        u'STRUCTURE-RULE',
        u'DITContentRule',
        u'CONTENT-RULE',
        u'CONTEXT',
        u'DITContextUse',
        u'DIT-CONTEXT-USE-RULE',
        u'FRIENDS',
        u'SYNTAX-NAME',
        u'subentry',
        u'subentryNameForm',
        u'subtreeSpecification',
        u'administrativeRole',
        u'createTimestamp',
        u'modifyTimestamp',
        u'subschemaTimestamp',
        u'creatorsName',
        u'modifiersName',
        u'subschemaSubentryList',
        u'accessControlSubentryList',
        u'collectiveAttributeSubentryList',
        u'contextDefaultSubentryList',
        u'serviceAdminSubentryList',
        u'pwdAdminSubentryList',
        u'hasSubordinates',
        u'accessControlSubentry',
        u'collectiveAttributeSubentry',
        u'collectiveExclusions',
        u'contextAssertionSubentry',
        u'contextAssertionDefaults',
        u'serviceAdminSubentry',
        u'searchRules',
        u'SearchRuleDescription',
        u'pwdAdminSubentry',
        u'pwdAttribute',
        u'pwdHistory',
        u'PwdHistory',
        u'pwdRecentlyExpired',
        u'pwdHistoryMatch',
        u'hierarchyLevel',
        u'HierarchyLevel',
        u'hierarchyBelow',
        u'HierarchyBelow',
        u'hierarchyParent',
        u'hierarchyTop',
        u'id-oc-top',
        u'id-oc-alias',
        u'id-oc-parent',
        u'id-oc-child',
        u'id-at-objectClass',
        u'id-at-aliasedEntryName',
        u'id-at-pwdAttribute',
        u'id-mr-objectIdentifierMatch',
        u'id-mr-distinguishedNameMatch',
        u'id-oa-excludeAllCollectiveAttributes',
        u'id-oa-createTimestamp',
        u'id-oa-modifyTimestamp',
        u'id-oa-creatorsName',
        u'id-oa-modifiersName',
        u'id-oa-administrativeRole',
        u'id-oa-subtreeSpecification',
        u'id-oa-collectiveExclusions',
        u'id-oa-subschemaTimestamp',
        u'id-oa-hasSubordinates',
        u'id-oa-subschemaSubentryList',
        u'id-oa-accessControlSubentryList',
        u'id-oa-collectiveAttributeSubentryList',
        u'id-oa-contextDefaultSubentryList',
        u'id-oa-contextAssertionDefault',
        u'id-oa-serviceAdminSubentryList',
        u'id-oa-searchRules',
        u'id-oa-hierarchyLevel',
        u'id-oa-hierarchyBelow',
        u'id-oa-hierarchyParent',
        u'id-oa-hierarchyTop',
        u'id-oa-pwdAdminSubentryList',
        u'id-oa-allAttributeTypes',
        u'id-sc-subentry',
        u'id-sc-accessControlSubentry',
        u'id-sc-collectiveAttributeSubentry',
        u'id-sc-contextAssertionSubentry',
        u'id-sc-serviceAdminSubentry',
        u'id-sc-pwdAdminSubentry',
        u'id-nf-subentryNameForm',
        u'id-ar-autonomousArea',
        u'id-ar-accessControlSpecificArea',
        u'id-ar-accessControlInnerArea',
        u'id-ar-subschemaAdminSpecificArea',
        u'id-ar-collectiveAttributeSpecificArea',
        u'id-ar-collectiveAttributeInnerArea',
        u'id-ar-contextDefaultSpecificArea',
        u'id-ar-serviceSpecificArea',
        u'id-ar-pwdAdminSpecificArea',
        ]
    _type_ = [
        u'Attribute',
        u'AttributeType',
        u'AttributeValue',
        u'Context',
        u'AttributeValueAssertion',
        u'ContextAssertion',
        u'AttributeTypeAssertion',
        u'Name',
        u'RDNSequence',
        u'DistinguishedName',
        u'RelativeDistinguishedName',
        u'AttributeTypeAndValue',
        u'SubtreeSpecification',
        u'LocalName',
        u'ChopSpecification',
        u'BaseDistance',
        u'Refinement',
        u'OBJECT-CLASS',
        u'ObjectClassKind',
        u'ATTRIBUTE',
        u'AttributeUsage',
        u'MATCHING-RULE',
        u'MAPPING-BASED-MATCHING',
        u'NAME-FORM',
        u'DITStructureRule',
        u'RuleIdentifier',
        u'STRUCTURE-RULE',
        u'DITContentRule',
        u'CONTENT-RULE',
        u'CONTEXT',
        u'DITContextUse',
        u'DIT-CONTEXT-USE-RULE',
        u'FRIENDS',
        u'SYNTAX-NAME',
        u'SearchRuleDescription',
        u'PwdHistory',
        u'HierarchyLevel',
        u'HierarchyBelow',
        ]
    _set_ = [
        u'SupportedAttributes',
        u'SupportedContexts',
        ]
    _val_ = [
        u'top',
        u'alias',
        u'parent',
        u'child',
        u'objectClass',
        u'aliasedEntryName',
        u'objectIdentifierMatch',
        u'distinguishedNameMatch',
        u'subentry',
        u'subentryNameForm',
        u'subtreeSpecification',
        u'administrativeRole',
        u'createTimestamp',
        u'modifyTimestamp',
        u'subschemaTimestamp',
        u'creatorsName',
        u'modifiersName',
        u'subschemaSubentryList',
        u'accessControlSubentryList',
        u'collectiveAttributeSubentryList',
        u'contextDefaultSubentryList',
        u'serviceAdminSubentryList',
        u'pwdAdminSubentryList',
        u'hasSubordinates',
        u'accessControlSubentry',
        u'collectiveAttributeSubentry',
        u'collectiveExclusions',
        u'contextAssertionSubentry',
        u'contextAssertionDefaults',
        u'serviceAdminSubentry',
        u'searchRules',
        u'pwdAdminSubentry',
        u'pwdAttribute',
        u'pwdHistory',
        u'pwdRecentlyExpired',
        u'pwdHistoryMatch',
        u'hierarchyLevel',
        u'hierarchyBelow',
        u'hierarchyParent',
        u'hierarchyTop',
        u'id-oc-top',
        u'id-oc-alias',
        u'id-oc-parent',
        u'id-oc-child',
        u'id-at-objectClass',
        u'id-at-aliasedEntryName',
        u'id-at-pwdAttribute',
        u'id-mr-objectIdentifierMatch',
        u'id-mr-distinguishedNameMatch',
        u'id-oa-excludeAllCollectiveAttributes',
        u'id-oa-createTimestamp',
        u'id-oa-modifyTimestamp',
        u'id-oa-creatorsName',
        u'id-oa-modifiersName',
        u'id-oa-administrativeRole',
        u'id-oa-subtreeSpecification',
        u'id-oa-collectiveExclusions',
        u'id-oa-subschemaTimestamp',
        u'id-oa-hasSubordinates',
        u'id-oa-subschemaSubentryList',
        u'id-oa-accessControlSubentryList',
        u'id-oa-collectiveAttributeSubentryList',
        u'id-oa-contextDefaultSubentryList',
        u'id-oa-contextAssertionDefault',
        u'id-oa-serviceAdminSubentryList',
        u'id-oa-searchRules',
        u'id-oa-hierarchyLevel',
        u'id-oa-hierarchyBelow',
        u'id-oa-hierarchyParent',
        u'id-oa-hierarchyTop',
        u'id-oa-pwdAdminSubentryList',
        u'id-oa-allAttributeTypes',
        u'id-sc-subentry',
        u'id-sc-accessControlSubentry',
        u'id-sc-collectiveAttributeSubentry',
        u'id-sc-contextAssertionSubentry',
        u'id-sc-serviceAdminSubentry',
        u'id-sc-pwdAdminSubentry',
        u'id-nf-subentryNameForm',
        u'id-ar-autonomousArea',
        u'id-ar-accessControlSpecificArea',
        u'id-ar-accessControlInnerArea',
        u'id-ar-subschemaAdminSpecificArea',
        u'id-ar-collectiveAttributeSpecificArea',
        u'id-ar-collectiveAttributeInnerArea',
        u'id-ar-contextDefaultSpecificArea',
        u'id-ar-serviceSpecificArea',
        u'id-ar-pwdAdminSpecificArea',
        ]
    _class_ = [
        u'SupportedAttributes',
        u'SupportedContexts',
        u'OBJECT-CLASS',
        u'top',
        u'alias',
        u'parent',
        u'child',
        u'ATTRIBUTE',
        u'objectClass',
        u'aliasedEntryName',
        u'MATCHING-RULE',
        u'objectIdentifierMatch',
        u'distinguishedNameMatch',
        u'MAPPING-BASED-MATCHING',
        u'NAME-FORM',
        u'STRUCTURE-RULE',
        u'CONTENT-RULE',
        u'CONTEXT',
        u'DIT-CONTEXT-USE-RULE',
        u'FRIENDS',
        u'SYNTAX-NAME',
        u'subentry',
        u'subentryNameForm',
        u'subtreeSpecification',
        u'administrativeRole',
        u'createTimestamp',
        u'modifyTimestamp',
        u'subschemaTimestamp',
        u'creatorsName',
        u'modifiersName',
        u'subschemaSubentryList',
        u'accessControlSubentryList',
        u'collectiveAttributeSubentryList',
        u'contextDefaultSubentryList',
        u'serviceAdminSubentryList',
        u'pwdAdminSubentryList',
        u'hasSubordinates',
        u'accessControlSubentry',
        u'collectiveAttributeSubentry',
        u'collectiveExclusions',
        u'contextAssertionSubentry',
        u'contextAssertionDefaults',
        u'serviceAdminSubentry',
        u'searchRules',
        u'pwdAdminSubentry',
        u'pwdAttribute',
        u'pwdHistory',
        u'pwdRecentlyExpired',
        u'pwdHistoryMatch',
        u'hierarchyLevel',
        u'hierarchyBelow',
        u'hierarchyParent',
        u'hierarchyTop',
        ]
    _param_ = [
        u'Attribute',
        u'MAPPING-BASED-MATCHING',
        u'pwdHistory',
        u'PwdHistory',
        u'pwdRecentlyExpired',
        u'pwdHistoryMatch',
        ]
    
    #-----< Attribute >-----#
    Attribute = SEQ(name=u'Attribute', mode=MODE_TYPE, param=True)
    
    #-----< AttributeType >-----#
    AttributeType = OID(name=u'AttributeType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    
    #-----< AttributeValue >-----#
    AttributeValue = OPEN(name=u'AttributeValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    
    #-----< Context >-----#
    Context = SEQ(name=u'Context', mode=MODE_TYPE)
    _Context_contextType = OID(name=u'contextType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), [u'id']))
    __Context_contextType_tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    __Context_contextType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _Context_contextType._const_tab = __Context_contextType_tab
    _Context_contextType._const_tab_at = None
    _Context_contextType._const_tab_id = u'id'
    _Context_contextValues = SET_OF(name=u'contextValues', mode=MODE_TYPE)
    __Context_contextValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), [u'Type']))
    ___Context_contextValues__item__tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    ___Context_contextValues__item__tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Context_contextValues__item_._const_tab = ___Context_contextValues__item__tab
    __Context_contextValues__item_._const_tab_at = ('..', '..', u'contextType')
    __Context_contextValues__item_._const_tab_id = u'Type'
    _Context_contextValues._cont = __Context_contextValues__item_
    _Context_contextValues._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Context_fallback = BOOL(name=u'fallback', mode=MODE_TYPE, default=False)
    Context._cont = ASN1Dict([
        (u'contextType', _Context_contextType),
        (u'contextValues', _Context_contextValues),
        (u'fallback', _Context_fallback),
        ])
    Context._ext = []
    
    #-----< AttributeValueAssertion >-----#
    AttributeValueAssertion = SEQ(name=u'AttributeValueAssertion', mode=MODE_TYPE)
    _AttributeValueAssertion_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    __AttributeValueAssertion_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___AttributeValueAssertion_type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    ___AttributeValueAssertion_type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0 = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __AttributeValueAssertion_type_tab._val = ASN1Set(rv=[dict([(u'Type', ___AttributeValueAssertion_type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ___AttributeValueAssertion_type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _AttributeValueAssertion_type._const_tab = __AttributeValueAssertion_type_tab
    _AttributeValueAssertion_type._const_tab_at = None
    _AttributeValueAssertion_type._const_tab_id = u'id'
    _AttributeValueAssertion_assertion = OPEN(name=u'assertion', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'equality-match', u'AssertionType']))
    _AttributeValueAssertion_assertion._const_tab = __AttributeValueAssertion_type_tab
    _AttributeValueAssertion_assertion._const_tab_at = ('..', u'type')
    _AttributeValueAssertion_assertion._const_tab_id = u'AssertionType'
    _AttributeValueAssertion_assertedContexts = CHOICE(name=u'assertedContexts', mode=MODE_TYPE, opt=True)
    __AttributeValueAssertion_assertedContexts_allContexts = NULL(name=u'allContexts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AttributeValueAssertion_assertedContexts_selectedContexts = SET_OF(name=u'selectedContexts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___AttributeValueAssertion_assertedContexts_selectedContexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    __AttributeValueAssertion_assertedContexts_selectedContexts._cont = ___AttributeValueAssertion_assertedContexts_selectedContexts__item_
    __AttributeValueAssertion_assertedContexts_selectedContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AttributeValueAssertion_assertedContexts._cont = ASN1Dict([
        (u'allContexts', __AttributeValueAssertion_assertedContexts_allContexts),
        (u'selectedContexts', __AttributeValueAssertion_assertedContexts_selectedContexts),
        ])
    _AttributeValueAssertion_assertedContexts._ext = None
    AttributeValueAssertion._cont = ASN1Dict([
        (u'type', _AttributeValueAssertion_type),
        (u'assertion', _AttributeValueAssertion_assertion),
        (u'assertedContexts', _AttributeValueAssertion_assertedContexts),
        ])
    AttributeValueAssertion._ext = []
    
    #-----< ContextAssertion >-----#
    ContextAssertion = SEQ(name=u'ContextAssertion', mode=MODE_TYPE)
    _ContextAssertion_contextType = OID(name=u'contextType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), [u'id']))
    __ContextAssertion_contextType_tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    __ContextAssertion_contextType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ContextAssertion_contextType._const_tab = __ContextAssertion_contextType_tab
    _ContextAssertion_contextType._const_tab_at = None
    _ContextAssertion_contextType._const_tab_id = u'id'
    _ContextAssertion_contextValues = SET_OF(name=u'contextValues', mode=MODE_TYPE)
    __ContextAssertion_contextValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), [u'Assertion']))
    ___ContextAssertion_contextValues__item__tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    ___ContextAssertion_contextValues__item__tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ContextAssertion_contextValues__item_._const_tab = ___ContextAssertion_contextValues__item__tab
    __ContextAssertion_contextValues__item_._const_tab_at = ('..', '..', u'contextType')
    __ContextAssertion_contextValues__item_._const_tab_id = u'Assertion'
    _ContextAssertion_contextValues._cont = __ContextAssertion_contextValues__item_
    _ContextAssertion_contextValues._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ContextAssertion._cont = ASN1Dict([
        (u'contextType', _ContextAssertion_contextType),
        (u'contextValues', _ContextAssertion_contextValues),
        ])
    ContextAssertion._ext = []
    
    #-----< AttributeTypeAssertion >-----#
    AttributeTypeAssertion = SEQ(name=u'AttributeTypeAssertion', mode=MODE_TYPE)
    _AttributeTypeAssertion_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    __AttributeTypeAssertion_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___AttributeTypeAssertion_type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ___AttributeTypeAssertion_type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __AttributeTypeAssertion_type_tab._val = ASN1Set(rv=[dict([(u'Type', ___AttributeTypeAssertion_type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ___AttributeTypeAssertion_type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _AttributeTypeAssertion_type._const_tab = __AttributeTypeAssertion_type_tab
    _AttributeTypeAssertion_type._const_tab_at = None
    _AttributeTypeAssertion_type._const_tab_id = u'id'
    _AttributeTypeAssertion_assertedContexts = SEQ_OF(name=u'assertedContexts', mode=MODE_TYPE, opt=True)
    __AttributeTypeAssertion_assertedContexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    _AttributeTypeAssertion_assertedContexts._cont = __AttributeTypeAssertion_assertedContexts__item_
    _AttributeTypeAssertion_assertedContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    AttributeTypeAssertion._cont = ASN1Dict([
        (u'type', _AttributeTypeAssertion_type),
        (u'assertedContexts', _AttributeTypeAssertion_assertedContexts),
        ])
    AttributeTypeAssertion._ext = []
    
    #-----< SupportedAttributes >-----#
    SupportedAttributes = CLASS(name=u'SupportedAttributes', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _SupportedAttributes_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _SupportedAttributes_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    SupportedAttributes._val = ASN1Set(rv=[dict([(u'Type', _SupportedAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _SupportedAttributes_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=[], er=[])
    
    #-----< SupportedContexts >-----#
    SupportedContexts = CLASS(name=u'SupportedContexts', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    SupportedContexts._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Name >-----#
    Name = CHOICE(name=u'Name', mode=MODE_TYPE)
    _Name_rdnSequence = SEQ_OF(name=u'rdnSequence', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RDNSequence')))
    Name._cont = ASN1Dict([
        (u'rdnSequence', _Name_rdnSequence),
        ])
    Name._ext = None
    
    #-----< RDNSequence >-----#
    RDNSequence = SEQ_OF(name=u'RDNSequence', mode=MODE_TYPE)
    _RDNSequence__item_ = SET_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RelativeDistinguishedName')))
    RDNSequence._cont = _RDNSequence__item_
    
    #-----< DistinguishedName >-----#
    DistinguishedName = SEQ_OF(name=u'DistinguishedName', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RDNSequence')))
    
    #-----< RelativeDistinguishedName >-----#
    RelativeDistinguishedName = SET_OF(name=u'RelativeDistinguishedName', mode=MODE_TYPE)
    _RelativeDistinguishedName__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeTypeAndValue')))
    RelativeDistinguishedName._cont = _RelativeDistinguishedName__item_
    RelativeDistinguishedName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AttributeTypeAndValue >-----#
    AttributeTypeAndValue = SEQ(name=u'AttributeTypeAndValue', mode=MODE_TYPE)
    _AttributeTypeAndValue_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    __AttributeTypeAndValue_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___AttributeTypeAndValue_type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ___AttributeTypeAndValue_type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __AttributeTypeAndValue_type_tab._val = ASN1Set(rv=[dict([(u'Type', ___AttributeTypeAndValue_type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ___AttributeTypeAndValue_type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _AttributeTypeAndValue_type._const_tab = __AttributeTypeAndValue_type_tab
    _AttributeTypeAndValue_type._const_tab_at = None
    _AttributeTypeAndValue_type._const_tab_id = u'id'
    _AttributeTypeAndValue_value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _AttributeTypeAndValue_value._const_tab = __AttributeTypeAndValue_type_tab
    _AttributeTypeAndValue_value._const_tab_at = ('..', u'type')
    _AttributeTypeAndValue_value._const_tab_id = u'Type'
    AttributeTypeAndValue._cont = ASN1Dict([
        (u'type', _AttributeTypeAndValue_type),
        (u'value', _AttributeTypeAndValue_value),
        ])
    AttributeTypeAndValue._ext = []
    
    #-----< SubtreeSpecification >-----#
    SubtreeSpecification = SEQ(name=u'SubtreeSpecification', mode=MODE_TYPE)
    _SubtreeSpecification_base = SEQ_OF(name=u'base', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'LocalName')), default=[])
    _SubtreeSpecification_specificExclusions = SET_OF(name=u'specificExclusions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SubtreeSpecification_specificExclusions__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___SubtreeSpecification_specificExclusions__item__chopBefore = SEQ_OF(name=u'chopBefore', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'LocalName')))
    ___SubtreeSpecification_specificExclusions__item__chopAfter = SEQ_OF(name=u'chopAfter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'LocalName')))
    __SubtreeSpecification_specificExclusions__item_._cont = ASN1Dict([
        (u'chopBefore', ___SubtreeSpecification_specificExclusions__item__chopBefore),
        (u'chopAfter', ___SubtreeSpecification_specificExclusions__item__chopAfter),
        ])
    __SubtreeSpecification_specificExclusions__item_._ext = []
    _SubtreeSpecification_specificExclusions._cont = __SubtreeSpecification_specificExclusions__item_
    _SubtreeSpecification_minimum = INT(name=u'minimum', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'BaseDistance')), default=0)
    _SubtreeSpecification_maximum = INT(name=u'maximum', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'BaseDistance')), opt=True)
    _SubtreeSpecification_specificationFilter = CHOICE(name=u'specificationFilter', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Refinement')), opt=True)
    SubtreeSpecification._cont = ASN1Dict([
        (u'base', _SubtreeSpecification_base),
        (u'specificExclusions', _SubtreeSpecification_specificExclusions),
        (u'minimum', _SubtreeSpecification_minimum),
        (u'maximum', _SubtreeSpecification_maximum),
        (u'specificationFilter', _SubtreeSpecification_specificationFilter),
        ])
    SubtreeSpecification._ext = []
    
    #-----< LocalName >-----#
    LocalName = SEQ_OF(name=u'LocalName', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RDNSequence')))
    
    #-----< ChopSpecification >-----#
    ChopSpecification = SEQ(name=u'ChopSpecification', mode=MODE_TYPE)
    _ChopSpecification_specificExclusions = SET_OF(name=u'specificExclusions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ChopSpecification_specificExclusions__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___ChopSpecification_specificExclusions__item__chopBefore = SEQ_OF(name=u'chopBefore', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'LocalName')))
    ___ChopSpecification_specificExclusions__item__chopAfter = SEQ_OF(name=u'chopAfter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'LocalName')))
    __ChopSpecification_specificExclusions__item_._cont = ASN1Dict([
        (u'chopBefore', ___ChopSpecification_specificExclusions__item__chopBefore),
        (u'chopAfter', ___ChopSpecification_specificExclusions__item__chopAfter),
        ])
    __ChopSpecification_specificExclusions__item_._ext = []
    _ChopSpecification_specificExclusions._cont = __ChopSpecification_specificExclusions__item_
    _ChopSpecification_specificExclusions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ChopSpecification_minimum = INT(name=u'minimum', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'BaseDistance')), default=0)
    _ChopSpecification_maximum = INT(name=u'maximum', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'BaseDistance')), opt=True)
    ChopSpecification._cont = ASN1Dict([
        (u'specificExclusions', _ChopSpecification_specificExclusions),
        (u'minimum', _ChopSpecification_minimum),
        (u'maximum', _ChopSpecification_maximum),
        ])
    ChopSpecification._ext = []
    
    #-----< BaseDistance >-----#
    BaseDistance = INT(name=u'BaseDistance', mode=MODE_TYPE)
    BaseDistance._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< Refinement >-----#
    Refinement = CHOICE(name=u'Refinement', mode=MODE_TYPE)
    _Refinement_item = OID(name=u'item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']))
    _Refinement_and_ = SET_OF(name=u'and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Refinement_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Refinement')))
    _Refinement_and_._cont = __Refinement_and___item_
    _Refinement_and_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Refinement_or_ = SET_OF(name=u'or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Refinement_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Refinement')))
    _Refinement_or_._cont = __Refinement_or___item_
    _Refinement_or_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Refinement_not_ = CHOICE(name=u'not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'Refinement')))
    Refinement._cont = ASN1Dict([
        (u'item', _Refinement_item),
        (u'and', _Refinement_and_),
        (u'or', _Refinement_or_),
        (u'not', _Refinement_not_),
        ])
    Refinement._ext = []
    
    #-----< OBJECT-CLASS >-----#
    OBJECT_CLASS = CLASS(name=u'OBJECT-CLASS', mode=MODE_TYPE)
    _OBJECT_CLASS_Superclasses = CLASS(name=u'Superclasses', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')), opt=True)
    _OBJECT_CLASS_kind = ENUM(name=u'kind', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ObjectClassKind')), default=u'structural')
    _OBJECT_CLASS_MandatoryAttributes = CLASS(name=u'MandatoryAttributes', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _OBJECT_CLASS_OptionalAttributes = CLASS(name=u'OptionalAttributes', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _OBJECT_CLASS_ldapName = SEQ_OF(name=u'ldapName', mode=MODE_VALUE, opt=True)
    __OBJECT_CLASS_ldapName__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    _OBJECT_CLASS_ldapName._cont = __OBJECT_CLASS_ldapName__item_
    _OBJECT_CLASS_ldapName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _OBJECT_CLASS_ldapDesc = STR_UTF8(name=u'ldapDesc', mode=MODE_VALUE, opt=True)
    _OBJECT_CLASS_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    OBJECT_CLASS._cont = ASN1Dict([
        (u'Superclasses', _OBJECT_CLASS_Superclasses),
        (u'kind', _OBJECT_CLASS_kind),
        (u'MandatoryAttributes', _OBJECT_CLASS_MandatoryAttributes),
        (u'OptionalAttributes', _OBJECT_CLASS_OptionalAttributes),
        (u'ldapName', _OBJECT_CLASS_ldapName),
        (u'ldapDesc', _OBJECT_CLASS_ldapDesc),
        (u'id', _OBJECT_CLASS_id),
        ])
    
    #-----< ObjectClassKind >-----#
    ObjectClassKind = ENUM(name=u'ObjectClassKind', mode=MODE_TYPE)
    ObjectClassKind._cont = ASN1Dict([(u'abstract', 0), (u'structural', 1), (u'auxiliary', 2)])
    ObjectClassKind._ext = None
    
    #-----< top >-----#
    top = CLASS(name=u'top', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    top._val = dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])
    
    #-----< alias >-----#
    alias = CLASS(name=u'alias', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0_0 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    alias._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_0), (u'equality-match', dict([(u'AssertionType', ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])), (u'ldapName', [u'alias']), (u'id', (2, 5, 6, 1))])
    
    #-----< parent >-----#
    parent = CLASS(name=u'parent', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    parent._val = dict([(u'kind', u'abstract'), (u'id', (2, 5, 6, 28))])
    
    #-----< child >-----#
    child = CLASS(name=u'child', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    child._val = dict([(u'kind', u'auxiliary'), (u'id', (2, 5, 6, 29))])
    
    #-----< ATTRIBUTE >-----#
    ATTRIBUTE = CLASS(name=u'ATTRIBUTE', mode=MODE_TYPE)
    _ATTRIBUTE_derivation = CLASS(name=u'derivation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _ATTRIBUTE_Type = OPEN(name=u'Type', mode=MODE_TYPE, opt=True)
    _ATTRIBUTE_equality_match = CLASS(name=u'equality-match', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')), opt=True)
    _ATTRIBUTE_ordering_match = CLASS(name=u'ordering-match', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')), opt=True)
    _ATTRIBUTE_substrings_match = CLASS(name=u'substrings-match', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')), opt=True)
    _ATTRIBUTE_single_valued = BOOL(name=u'single-valued', mode=MODE_VALUE, default=False)
    _ATTRIBUTE_collective = BOOL(name=u'collective', mode=MODE_VALUE, default=False)
    _ATTRIBUTE_dummy = BOOL(name=u'dummy', mode=MODE_VALUE, default=False)
    _ATTRIBUTE_no_user_modification = BOOL(name=u'no-user-modification', mode=MODE_VALUE, default=False)
    _ATTRIBUTE_usage = ENUM(name=u'usage', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'AttributeUsage')), default=u'userApplications')
    _ATTRIBUTE_ldapSyntax = OID(name=u'ldapSyntax', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'SYNTAX-NAME'), [u'id']), opt=True)
    _ATTRIBUTE_ldapName = SEQ_OF(name=u'ldapName', mode=MODE_VALUE, opt=True)
    __ATTRIBUTE_ldapName__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    _ATTRIBUTE_ldapName._cont = __ATTRIBUTE_ldapName__item_
    _ATTRIBUTE_ldapName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ATTRIBUTE_ldapDesc = STR_UTF8(name=u'ldapDesc', mode=MODE_VALUE, opt=True)
    _ATTRIBUTE_obsolete = BOOL(name=u'obsolete', mode=MODE_VALUE, default=False)
    _ATTRIBUTE_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    ATTRIBUTE._cont = ASN1Dict([
        (u'derivation', _ATTRIBUTE_derivation),
        (u'Type', _ATTRIBUTE_Type),
        (u'equality-match', _ATTRIBUTE_equality_match),
        (u'ordering-match', _ATTRIBUTE_ordering_match),
        (u'substrings-match', _ATTRIBUTE_substrings_match),
        (u'single-valued', _ATTRIBUTE_single_valued),
        (u'collective', _ATTRIBUTE_collective),
        (u'dummy', _ATTRIBUTE_dummy),
        (u'no-user-modification', _ATTRIBUTE_no_user_modification),
        (u'usage', _ATTRIBUTE_usage),
        (u'ldapSyntax', _ATTRIBUTE_ldapSyntax),
        (u'ldapName', _ATTRIBUTE_ldapName),
        (u'ldapDesc', _ATTRIBUTE_ldapDesc),
        (u'obsolete', _ATTRIBUTE_obsolete),
        (u'id', _ATTRIBUTE_id),
        ])
    
    #-----< AttributeUsage >-----#
    AttributeUsage = ENUM(name=u'AttributeUsage', mode=MODE_TYPE)
    AttributeUsage._cont = ASN1Dict([(u'userApplications', 0), (u'directoryOperation', 1), (u'distributedOperation', 2), (u'dSAOperation', 3)])
    AttributeUsage._ext = []
    
    #-----< objectClass >-----#
    objectClass = CLASS(name=u'objectClass', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _objectClass_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    objectClass._val = dict([(u'Type', _objectClass_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])
    
    #-----< aliasedEntryName >-----#
    aliasedEntryName = CLASS(name=u'aliasedEntryName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _aliasedEntryName_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __ATTRIBUTE_equality_match_val_AssertionType_0 = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    aliasedEntryName._val = dict([(u'Type', _aliasedEntryName_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])
    
    #-----< MATCHING-RULE >-----#
    MATCHING_RULE = CLASS(name=u'MATCHING-RULE', mode=MODE_TYPE)
    _MATCHING_RULE_ParentMatchingRules = CLASS(name=u'ParentMatchingRules', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')), opt=True)
    _MATCHING_RULE_AssertionType = OPEN(name=u'AssertionType', mode=MODE_TYPE, opt=True)
    _MATCHING_RULE_uniqueMatchIndicator = CLASS(name=u'uniqueMatchIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _MATCHING_RULE_ldapSyntax = OID(name=u'ldapSyntax', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'SYNTAX-NAME'), [u'id']), opt=True)
    _MATCHING_RULE_ldapName = SEQ_OF(name=u'ldapName', mode=MODE_VALUE, opt=True)
    __MATCHING_RULE_ldapName__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    _MATCHING_RULE_ldapName._cont = __MATCHING_RULE_ldapName__item_
    _MATCHING_RULE_ldapName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _MATCHING_RULE_ldapDesc = STR_UTF8(name=u'ldapDesc', mode=MODE_VALUE, opt=True)
    _MATCHING_RULE_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    MATCHING_RULE._cont = ASN1Dict([
        (u'ParentMatchingRules', _MATCHING_RULE_ParentMatchingRules),
        (u'AssertionType', _MATCHING_RULE_AssertionType),
        (u'uniqueMatchIndicator', _MATCHING_RULE_uniqueMatchIndicator),
        (u'ldapSyntax', _MATCHING_RULE_ldapSyntax),
        (u'ldapName', _MATCHING_RULE_ldapName),
        (u'ldapDesc', _MATCHING_RULE_ldapDesc),
        (u'id', _MATCHING_RULE_id),
        ])
    
    #-----< objectIdentifierMatch >-----#
    objectIdentifierMatch = CLASS(name=u'objectIdentifierMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _objectIdentifierMatch_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    objectIdentifierMatch._val = dict([(u'AssertionType', _objectIdentifierMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])
    
    #-----< distinguishedNameMatch >-----#
    distinguishedNameMatch = CLASS(name=u'distinguishedNameMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _distinguishedNameMatch_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    distinguishedNameMatch._val = dict([(u'AssertionType', _distinguishedNameMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])
    
    #-----< MAPPING-BASED-MATCHING >-----#
    MAPPING_BASED_MATCHING = CLASS(name=u'MAPPING-BASED-MATCHING', mode=MODE_TYPE, param=True)
    
    #-----< NAME-FORM >-----#
    NAME_FORM = CLASS(name=u'NAME-FORM', mode=MODE_TYPE)
    _NAME_FORM_namedObjectClass = CLASS(name=u'namedObjectClass', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    _NAME_FORM_MandatoryAttributes = CLASS(name=u'MandatoryAttributes', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _NAME_FORM_OptionalAttributes = CLASS(name=u'OptionalAttributes', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _NAME_FORM_ldapName = SEQ_OF(name=u'ldapName', mode=MODE_VALUE, opt=True)
    __NAME_FORM_ldapName__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    _NAME_FORM_ldapName._cont = __NAME_FORM_ldapName__item_
    _NAME_FORM_ldapName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _NAME_FORM_ldapDesc = STR_UTF8(name=u'ldapDesc', mode=MODE_VALUE, opt=True)
    _NAME_FORM_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    NAME_FORM._cont = ASN1Dict([
        (u'namedObjectClass', _NAME_FORM_namedObjectClass),
        (u'MandatoryAttributes', _NAME_FORM_MandatoryAttributes),
        (u'OptionalAttributes', _NAME_FORM_OptionalAttributes),
        (u'ldapName', _NAME_FORM_ldapName),
        (u'ldapDesc', _NAME_FORM_ldapDesc),
        (u'id', _NAME_FORM_id),
        ])
    
    #-----< DITStructureRule >-----#
    DITStructureRule = SEQ(name=u'DITStructureRule', mode=MODE_TYPE)
    _DITStructureRule_ruleIdentifier = INT(name=u'ruleIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RuleIdentifier')))
    _DITStructureRule_nameForm = OID(name=u'nameForm', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'NAME-FORM'), [u'id']))
    _DITStructureRule_superiorStructureRules = SET_OF(name=u'superiorStructureRules', mode=MODE_TYPE, opt=True)
    __DITStructureRule_superiorStructureRules__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RuleIdentifier')))
    _DITStructureRule_superiorStructureRules._cont = __DITStructureRule_superiorStructureRules__item_
    _DITStructureRule_superiorStructureRules._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    DITStructureRule._cont = ASN1Dict([
        (u'ruleIdentifier', _DITStructureRule_ruleIdentifier),
        (u'nameForm', _DITStructureRule_nameForm),
        (u'superiorStructureRules', _DITStructureRule_superiorStructureRules),
        ])
    DITStructureRule._ext = []
    
    #-----< RuleIdentifier >-----#
    RuleIdentifier = INT(name=u'RuleIdentifier', mode=MODE_TYPE)
    
    #-----< STRUCTURE-RULE >-----#
    STRUCTURE_RULE = CLASS(name=u'STRUCTURE-RULE', mode=MODE_TYPE)
    _STRUCTURE_RULE_nameForm = CLASS(name=u'nameForm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'NAME-FORM')))
    _STRUCTURE_RULE_SuperiorStructureRules = INT(name=u'SuperiorStructureRules', mode=MODE_SET, typeref=ASN1RefClassField(('InformationFramework', 'STRUCTURE-RULE'), [u'id']), opt=True)
    _STRUCTURE_RULE_id = INT(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'RuleIdentifier')))
    STRUCTURE_RULE._cont = ASN1Dict([
        (u'nameForm', _STRUCTURE_RULE_nameForm),
        (u'SuperiorStructureRules', _STRUCTURE_RULE_SuperiorStructureRules),
        (u'id', _STRUCTURE_RULE_id),
        ])
    
    #-----< DITContentRule >-----#
    DITContentRule = SEQ(name=u'DITContentRule', mode=MODE_TYPE)
    _DITContentRule_structuralObjectClass = OID(name=u'structuralObjectClass', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']))
    _DITContentRule_auxiliaries = SET_OF(name=u'auxiliaries', mode=MODE_TYPE, opt=True)
    __DITContentRule_auxiliaries__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']))
    _DITContentRule_auxiliaries._cont = __DITContentRule_auxiliaries__item_
    _DITContentRule_auxiliaries._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContentRule_mandatory = SET_OF(name=u'mandatory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRule_mandatory__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _DITContentRule_mandatory._cont = __DITContentRule_mandatory__item_
    _DITContentRule_mandatory._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContentRule_optional = SET_OF(name=u'optional', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRule_optional__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _DITContentRule_optional._cont = __DITContentRule_optional__item_
    _DITContentRule_optional._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContentRule_precluded = SET_OF(name=u'precluded', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRule_precluded__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _DITContentRule_precluded._cont = __DITContentRule_precluded__item_
    _DITContentRule_precluded._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    DITContentRule._cont = ASN1Dict([
        (u'structuralObjectClass', _DITContentRule_structuralObjectClass),
        (u'auxiliaries', _DITContentRule_auxiliaries),
        (u'mandatory', _DITContentRule_mandatory),
        (u'optional', _DITContentRule_optional),
        (u'precluded', _DITContentRule_precluded),
        ])
    DITContentRule._ext = []
    
    #-----< CONTENT-RULE >-----#
    CONTENT_RULE = CLASS(name=u'CONTENT-RULE', mode=MODE_TYPE)
    _CONTENT_RULE_structuralClass = OID(name=u'structuralClass', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']), uniq=True)
    _CONTENT_RULE_Auxiliaries = CLASS(name=u'Auxiliaries', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')), opt=True)
    _CONTENT_RULE_Mandatory = CLASS(name=u'Mandatory', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _CONTENT_RULE_Optional = CLASS(name=u'Optional', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    _CONTENT_RULE_Precluded = CLASS(name=u'Precluded', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), opt=True)
    CONTENT_RULE._cont = ASN1Dict([
        (u'structuralClass', _CONTENT_RULE_structuralClass),
        (u'Auxiliaries', _CONTENT_RULE_Auxiliaries),
        (u'Mandatory', _CONTENT_RULE_Mandatory),
        (u'Optional', _CONTENT_RULE_Optional),
        (u'Precluded', _CONTENT_RULE_Precluded),
        ])
    
    #-----< CONTEXT >-----#
    CONTEXT = CLASS(name=u'CONTEXT', mode=MODE_TYPE)
    _CONTEXT_Type = OPEN(name=u'Type', mode=MODE_TYPE)
    _CONTEXT_defaultValue = OPEN(name=u'defaultValue', mode=MODE_VALUE, opt=True)
    _CONTEXT_Assertion = OPEN(name=u'Assertion', mode=MODE_TYPE, opt=True)
    _CONTEXT_absentMatch = BOOL(name=u'absentMatch', mode=MODE_VALUE, default=True)
    _CONTEXT_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    CONTEXT._cont = ASN1Dict([
        (u'Type', _CONTEXT_Type),
        (u'defaultValue', _CONTEXT_defaultValue),
        (u'Assertion', _CONTEXT_Assertion),
        (u'absentMatch', _CONTEXT_absentMatch),
        (u'id', _CONTEXT_id),
        ])
    
    #-----< DITContextUse >-----#
    DITContextUse = SEQ(name=u'DITContextUse', mode=MODE_TYPE)
    _DITContextUse_attributeType = OID(name=u'attributeType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _DITContextUse_mandatoryContexts = SET_OF(name=u'mandatoryContexts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContextUse_mandatoryContexts__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), [u'id']))
    _DITContextUse_mandatoryContexts._cont = __DITContextUse_mandatoryContexts__item_
    _DITContextUse_mandatoryContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContextUse_optionalContexts = SET_OF(name=u'optionalContexts', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContextUse_optionalContexts__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), [u'id']))
    _DITContextUse_optionalContexts._cont = __DITContextUse_optionalContexts__item_
    _DITContextUse_optionalContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    DITContextUse._cont = ASN1Dict([
        (u'attributeType', _DITContextUse_attributeType),
        (u'mandatoryContexts', _DITContextUse_mandatoryContexts),
        (u'optionalContexts', _DITContextUse_optionalContexts),
        ])
    DITContextUse._ext = []
    
    #-----< DIT-CONTEXT-USE-RULE >-----#
    DIT_CONTEXT_USE_RULE = CLASS(name=u'DIT-CONTEXT-USE-RULE', mode=MODE_TYPE)
    _DIT_CONTEXT_USE_RULE_attributeType = OID(name=u'attributeType', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']), uniq=True)
    _DIT_CONTEXT_USE_RULE_Mandatory = CLASS(name=u'Mandatory', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')), opt=True)
    _DIT_CONTEXT_USE_RULE_Optional = CLASS(name=u'Optional', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')), opt=True)
    DIT_CONTEXT_USE_RULE._cont = ASN1Dict([
        (u'attributeType', _DIT_CONTEXT_USE_RULE_attributeType),
        (u'Mandatory', _DIT_CONTEXT_USE_RULE_Mandatory),
        (u'Optional', _DIT_CONTEXT_USE_RULE_Optional),
        ])
    
    #-----< FRIENDS >-----#
    FRIENDS = CLASS(name=u'FRIENDS', mode=MODE_TYPE)
    _FRIENDS_anchor = OID(name=u'anchor', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']), uniq=True)
    _FRIENDS_Friends = CLASS(name=u'Friends', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    FRIENDS._cont = ASN1Dict([
        (u'anchor', _FRIENDS_anchor),
        (u'Friends', _FRIENDS_Friends),
        ])
    
    #-----< SYNTAX-NAME >-----#
    SYNTAX_NAME = CLASS(name=u'SYNTAX-NAME', mode=MODE_TYPE)
    _SYNTAX_NAME_ldapDesc = STR_UTF8(name=u'ldapDesc', mode=MODE_VALUE)
    _SYNTAX_NAME_Type = OPEN(name=u'Type', mode=MODE_TYPE, opt=True)
    _SYNTAX_NAME_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    SYNTAX_NAME._cont = ASN1Dict([
        (u'ldapDesc', _SYNTAX_NAME_ldapDesc),
        (u'Type', _SYNTAX_NAME_Type),
        (u'id', _SYNTAX_NAME_id),
        ])
    
    #-----< subentry >-----#
    subentry = CLASS(name=u'subentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __ATTRIBUTE_derivation_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __ATTRIBUTE_equality_match_val_AssertionType_1 = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __ATTRIBUTE_substrings_match_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0_1 = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_1 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SubtreeSpecification')))
    subentry._val = dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'structural'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'cn', u'commonName']), (u'id', (2, 5, 4, 3))]), dict([(u'Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_1), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 45)), (u'ldapName', [u'subtreeSpecification']), (u'id', (2, 5, 18, 6))])], rr=[], ev=None, er=[])), (u'ldapName', [u'subentry']), (u'id', (2, 5, 17, 0))])
    
    #-----< subentryNameForm >-----#
    subentryNameForm = CLASS(name=u'subentryNameForm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'NAME-FORM')))
    __NAME_FORM_MandatoryAttributes_val_Type_0 = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    subentryNameForm._val = dict([(u'namedObjectClass', dict([(u'Superclasses', ASN1Set(rv=[dict([(u'kind', u'abstract'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))])], rr=[], ev=None, er=[])), (u'ldapName', [u'top']), (u'id', (2, 5, 6, 0))])], rr=[], ev=None, er=[])), (u'kind', u'structural'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'cn', u'commonName']), (u'id', (2, 5, 4, 3))]), dict([(u'Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_1), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 45)), (u'ldapName', [u'subtreeSpecification']), (u'id', (2, 5, 18, 6))])], rr=[], ev=None, er=[])), (u'ldapName', [u'subentry']), (u'id', (2, 5, 17, 0))])), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', __NAME_FORM_MandatoryAttributes_val_Type_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'cn', u'commonName']), (u'id', (2, 5, 4, 3))])], rr=[], ev=None, er=[])), (u'id', (2, 5, 15, 16))])
    
    #-----< subtreeSpecification >-----#
    subtreeSpecification = CLASS(name=u'subtreeSpecification', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _subtreeSpecification_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SubtreeSpecification')))
    subtreeSpecification._val = dict([(u'Type', _subtreeSpecification_val_Type), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 45)), (u'ldapName', [u'subtreeSpecification']), (u'id', (2, 5, 18, 6))])
    
    #-----< administrativeRole >-----#
    administrativeRole = CLASS(name=u'administrativeRole', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _administrativeRole_val_Type = OID(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']))
    administrativeRole._val = dict([(u'Type', _administrativeRole_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'administrativeRole']), (u'id', (2, 5, 18, 5))])
    
    #-----< createTimestamp >-----#
    createTimestamp = CLASS(name=u'createTimestamp', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _createTimestamp_val_Type = TIME_GEN(name=u'Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType_2 = TIME_GEN(name=u'AssertionType', mode=MODE_TYPE)
    __ATTRIBUTE_ordering_match_val_AssertionType = TIME_GEN(name=u'AssertionType', mode=MODE_TYPE)
    createTimestamp._val = dict([(u'Type', _createTimestamp_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeMatch']), (u'id', (2, 5, 13, 27))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeOrderingMatch']), (u'id', (2, 5, 13, 28))])), (u'single-valued', True), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'createTimestamp']), (u'id', (2, 5, 18, 1))])
    
    #-----< modifyTimestamp >-----#
    modifyTimestamp = CLASS(name=u'modifyTimestamp', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _modifyTimestamp_val_Type = TIME_GEN(name=u'Type', mode=MODE_TYPE)
    modifyTimestamp._val = dict([(u'Type', _modifyTimestamp_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeMatch']), (u'id', (2, 5, 13, 27))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeOrderingMatch']), (u'id', (2, 5, 13, 28))])), (u'single-valued', True), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'modifyTimestamp']), (u'id', (2, 5, 18, 2))])
    
    #-----< subschemaTimestamp >-----#
    subschemaTimestamp = CLASS(name=u'subschemaTimestamp', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _subschemaTimestamp_val_Type = TIME_GEN(name=u'Type', mode=MODE_TYPE)
    subschemaTimestamp._val = dict([(u'Type', _subschemaTimestamp_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeMatch']), (u'id', (2, 5, 13, 27))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeOrderingMatch']), (u'id', (2, 5, 13, 28))])), (u'single-valued', True), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 8))])
    
    #-----< creatorsName >-----#
    creatorsName = CLASS(name=u'creatorsName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _creatorsName_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    creatorsName._val = dict([(u'Type', _creatorsName_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'creatorsName']), (u'id', (2, 5, 18, 3))])
    
    #-----< modifiersName >-----#
    modifiersName = CLASS(name=u'modifiersName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _modifiersName_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    modifiersName._val = dict([(u'Type', _modifiersName_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'modifiersName']), (u'id', (2, 5, 18, 4))])
    
    #-----< subschemaSubentryList >-----#
    subschemaSubentryList = CLASS(name=u'subschemaSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _subschemaSubentryList_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    subschemaSubentryList._val = dict([(u'Type', _subschemaSubentryList_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'subschemaSubentry']), (u'id', (2, 5, 18, 10))])
    
    #-----< accessControlSubentryList >-----#
    accessControlSubentryList = CLASS(name=u'accessControlSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _accessControlSubentryList_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    accessControlSubentryList._val = dict([(u'Type', _accessControlSubentryList_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 11))])
    
    #-----< collectiveAttributeSubentryList >-----#
    collectiveAttributeSubentryList = CLASS(name=u'collectiveAttributeSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _collectiveAttributeSubentryList_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    collectiveAttributeSubentryList._val = dict([(u'Type', _collectiveAttributeSubentryList_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 12))])
    
    #-----< contextDefaultSubentryList >-----#
    contextDefaultSubentryList = CLASS(name=u'contextDefaultSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextDefaultSubentryList_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    contextDefaultSubentryList._val = dict([(u'Type', _contextDefaultSubentryList_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 13))])
    
    #-----< serviceAdminSubentryList >-----#
    serviceAdminSubentryList = CLASS(name=u'serviceAdminSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _serviceAdminSubentryList_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    serviceAdminSubentryList._val = dict([(u'Type', _serviceAdminSubentryList_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 15))])
    
    #-----< pwdAdminSubentryList >-----#
    pwdAdminSubentryList = CLASS(name=u'pwdAdminSubentryList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdAdminSubentryList_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    pwdAdminSubentryList._val = dict([(u'Type', _pwdAdminSubentryList_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'pwdAdminSubentryList']), (u'id', (2, 5, 18, 21))])
    
    #-----< hasSubordinates >-----#
    hasSubordinates = CLASS(name=u'hasSubordinates', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hasSubordinates_val_Type = BOOL(name=u'Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType_3 = BOOL(name=u'AssertionType', mode=MODE_TYPE)
    hasSubordinates._val = dict([(u'Type', _hasSubordinates_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), (u'ldapName', [u'booleanMatch']), (u'id', (2, 5, 13, 13))])), (u'single-valued', True), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 9))])
    
    #-----< accessControlSubentry >-----#
    accessControlSubentry = CLASS(name=u'accessControlSubentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    accessControlSubentry._val = dict([(u'kind', u'auxiliary'), (u'id', (2, 5, 17, 1))])
    
    #-----< collectiveAttributeSubentry >-----#
    collectiveAttributeSubentry = CLASS(name=u'collectiveAttributeSubentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    collectiveAttributeSubentry._val = dict([(u'kind', u'auxiliary'), (u'id', (2, 5, 17, 2))])
    
    #-----< collectiveExclusions >-----#
    collectiveExclusions = CLASS(name=u'collectiveExclusions', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _collectiveExclusions_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    collectiveExclusions._val = dict([(u'Type', _collectiveExclusions_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 7))])
    
    #-----< contextAssertionSubentry >-----#
    contextAssertionSubentry = CLASS(name=u'contextAssertionSubentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0_2 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'TypeAndContextAssertion')))
    contextAssertionSubentry._val = dict([(u'kind', u'auxiliary'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_2), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 14))])], rr=[], ev=None, er=[])), (u'id', (2, 5, 17, 3))])
    
    #-----< contextAssertionDefaults >-----#
    contextAssertionDefaults = CLASS(name=u'contextAssertionDefaults', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextAssertionDefaults_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'TypeAndContextAssertion')))
    contextAssertionDefaults._val = dict([(u'Type', _contextAssertionDefaults_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 14))])
    
    #-----< serviceAdminSubentry >-----#
    serviceAdminSubentry = CLASS(name=u'serviceAdminSubentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0_3 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SearchRuleDescription')))
    __ATTRIBUTE_equality_match_val_AssertionType_4 = INT(name=u'AssertionType', mode=MODE_TYPE)
    serviceAdminSubentry._val = dict([(u'kind', u'auxiliary'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_3), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerFirstComponentMatch']), (u'id', (2, 5, 13, 29))])), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 16))])], rr=[], ev=None, er=[])), (u'id', (2, 5, 17, 4))])
    
    #-----< searchRules >-----#
    searchRules = CLASS(name=u'searchRules', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _searchRules_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SearchRuleDescription')))
    searchRules._val = dict([(u'Type', _searchRules_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerFirstComponentMatch']), (u'id', (2, 5, 13, 29))])), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 16))])
    
    #-----< SearchRuleDescription >-----#
    SearchRuleDescription = SEQ(name=u'SearchRuleDescription', mode=MODE_TYPE)
    _SearchRuleDescription_id = INT(name=u'id', mode=MODE_TYPE)
    _SearchRuleDescription_dmdId = OID(name=u'dmdId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _SearchRuleDescription_serviceType = OID(name=u'serviceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchRuleDescription_userClass = INT(name=u'userClass', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchRuleDescription_inputAttributeTypes = SEQ_OF(name=u'inputAttributeTypes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRuleDescription_inputAttributeTypes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'RequestAttribute')))
    _SearchRuleDescription_inputAttributeTypes._cont = __SearchRuleDescription_inputAttributeTypes__item_
    _SearchRuleDescription_attributeCombination = CHOICE(name=u'attributeCombination', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')), default=(u'and', []))
    _SearchRuleDescription_outputAttributeTypes = SEQ_OF(name=u'outputAttributeTypes', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRuleDescription_outputAttributeTypes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ResultAttribute')))
    _SearchRuleDescription_outputAttributeTypes._cont = __SearchRuleDescription_outputAttributeTypes__item_
    _SearchRuleDescription_defaultControls = SEQ(name=u'defaultControls', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRuleDescription_mandatoryControls = SEQ(name=u'mandatoryControls', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRuleDescription_searchRuleControls = SEQ(name=u'searchRuleControls', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRuleDescription_familyGrouping = ENUM(name=u'familyGrouping', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), opt=True)
    _SearchRuleDescription_familyReturn = SEQ(name=u'familyReturn', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyReturn')), opt=True)
    _SearchRuleDescription_relaxation = SEQ(name=u'relaxation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'RelaxationPolicy')), opt=True)
    _SearchRuleDescription_additionalControl = SEQ_OF(name=u'additionalControl', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRuleDescription_additionalControl__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _SearchRuleDescription_additionalControl._cont = __SearchRuleDescription_additionalControl__item_
    _SearchRuleDescription_allowedSubset = BIT_STR(name=u'allowedSubset', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'AllowedSubset')), default=(7, 3))
    _SearchRuleDescription_imposedSubset = ENUM(name=u'imposedSubset', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ImposedSubset')), opt=True)
    _SearchRuleDescription_entryLimit = SEQ(name=u'entryLimit', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'EntryLimit')), opt=True)
    _SearchRuleDescription_name = SET_OF(name=u'name', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRuleDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _SearchRuleDescription_name._cont = __SearchRuleDescription_name__item_
    _SearchRuleDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SearchRuleDescription_description = CHOICE(name=u'description', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    SearchRuleDescription._cont = ASN1Dict([
        (u'id', _SearchRuleDescription_id),
        (u'dmdId', _SearchRuleDescription_dmdId),
        (u'serviceType', _SearchRuleDescription_serviceType),
        (u'userClass', _SearchRuleDescription_userClass),
        (u'inputAttributeTypes', _SearchRuleDescription_inputAttributeTypes),
        (u'attributeCombination', _SearchRuleDescription_attributeCombination),
        (u'outputAttributeTypes', _SearchRuleDescription_outputAttributeTypes),
        (u'defaultControls', _SearchRuleDescription_defaultControls),
        (u'mandatoryControls', _SearchRuleDescription_mandatoryControls),
        (u'searchRuleControls', _SearchRuleDescription_searchRuleControls),
        (u'familyGrouping', _SearchRuleDescription_familyGrouping),
        (u'familyReturn', _SearchRuleDescription_familyReturn),
        (u'relaxation', _SearchRuleDescription_relaxation),
        (u'additionalControl', _SearchRuleDescription_additionalControl),
        (u'allowedSubset', _SearchRuleDescription_allowedSubset),
        (u'imposedSubset', _SearchRuleDescription_imposedSubset),
        (u'entryLimit', _SearchRuleDescription_entryLimit),
        (u'name', _SearchRuleDescription_name),
        (u'description', _SearchRuleDescription_description),
        ])
    SearchRuleDescription._ext = []
    
    #-----< pwdAdminSubentry >-----#
    pwdAdminSubentry = CLASS(name=u'pwdAdminSubentry', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_MandatoryAttributes_val_Type_0_4 = OID(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    pwdAdminSubentry._val = dict([(u'kind', u'auxiliary'), (u'MandatoryAttributes', ASN1Set(rv=[dict([(u'Type', __OBJECT_CLASS_MandatoryAttributes_val_Type_0_4), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'pwdAttribute']), (u'id', (2, 5, 4, 84))])], rr=[], ev=None, er=[])), (u'ldapName', [u'pwdAdminSubentry']), (u'id', (2, 5, 17, 5))])
    
    #-----< pwdAttribute >-----#
    pwdAttribute = CLASS(name=u'pwdAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdAttribute_val_Type = OID(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    pwdAttribute._val = dict([(u'Type', _pwdAttribute_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'pwdAttribute']), (u'id', (2, 5, 4, 84))])
    
    #-----< pwdHistory >-----#
    pwdHistory = CLASS(name=u'pwdHistory', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), param=True)
    
    #-----< PwdHistory >-----#
    PwdHistory = SEQ(name=u'PwdHistory', mode=MODE_TYPE, param=True)
    
    #-----< pwdRecentlyExpired >-----#
    pwdRecentlyExpired = CLASS(name=u'pwdRecentlyExpired', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')), param=True)
    
    #-----< pwdHistoryMatch >-----#
    pwdHistoryMatch = CLASS(name=u'pwdHistoryMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')), param=True)
    
    #-----< hierarchyLevel >-----#
    hierarchyLevel = CLASS(name=u'hierarchyLevel', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hierarchyLevel_val_Type = INT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'HierarchyLevel')))
    __ATTRIBUTE_ordering_match_val_AssertionType_0 = INT(name=u'AssertionType', mode=MODE_TYPE)
    hierarchyLevel._val = dict([(u'Type', _hierarchyLevel_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerOrderingMatch']), (u'id', (2, 5, 13, 15))])), (u'single-valued', True), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 17))])
    
    #-----< HierarchyLevel >-----#
    HierarchyLevel = INT(name=u'HierarchyLevel', mode=MODE_TYPE)
    
    #-----< hierarchyBelow >-----#
    hierarchyBelow = CLASS(name=u'hierarchyBelow', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hierarchyBelow_val_Type = BOOL(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'HierarchyBelow')))
    hierarchyBelow._val = dict([(u'Type', _hierarchyBelow_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), (u'ldapName', [u'booleanMatch']), (u'id', (2, 5, 13, 13))])), (u'single-valued', True), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 18))])
    
    #-----< HierarchyBelow >-----#
    HierarchyBelow = BOOL(name=u'HierarchyBelow', mode=MODE_TYPE)
    
    #-----< hierarchyParent >-----#
    hierarchyParent = CLASS(name=u'hierarchyParent', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hierarchyParent_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    hierarchyParent._val = dict([(u'Type', _hierarchyParent_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 19))])
    
    #-----< hierarchyTop >-----#
    hierarchyTop = CLASS(name=u'hierarchyTop', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hierarchyTop_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    hierarchyTop._val = dict([(u'Type', _hierarchyTop_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 20))])
    
    #-----< id-oc-top >-----#
    id_oc_top = OID(name=u'id-oc-top', mode=MODE_VALUE)
    id_oc_top._val = (2, 5, 6, 0)
    
    #-----< id-oc-alias >-----#
    id_oc_alias = OID(name=u'id-oc-alias', mode=MODE_VALUE)
    id_oc_alias._val = (2, 5, 6, 1)
    
    #-----< id-oc-parent >-----#
    id_oc_parent = OID(name=u'id-oc-parent', mode=MODE_VALUE)
    id_oc_parent._val = (2, 5, 6, 28)
    
    #-----< id-oc-child >-----#
    id_oc_child = OID(name=u'id-oc-child', mode=MODE_VALUE)
    id_oc_child._val = (2, 5, 6, 29)
    
    #-----< id-at-objectClass >-----#
    id_at_objectClass = OID(name=u'id-at-objectClass', mode=MODE_VALUE)
    id_at_objectClass._val = (2, 5, 4, 0)
    
    #-----< id-at-aliasedEntryName >-----#
    id_at_aliasedEntryName = OID(name=u'id-at-aliasedEntryName', mode=MODE_VALUE)
    id_at_aliasedEntryName._val = (2, 5, 4, 1)
    
    #-----< id-at-pwdAttribute >-----#
    id_at_pwdAttribute = OID(name=u'id-at-pwdAttribute', mode=MODE_VALUE)
    id_at_pwdAttribute._val = (2, 5, 4, 84)
    
    #-----< id-mr-objectIdentifierMatch >-----#
    id_mr_objectIdentifierMatch = OID(name=u'id-mr-objectIdentifierMatch', mode=MODE_VALUE)
    id_mr_objectIdentifierMatch._val = (2, 5, 13, 0)
    
    #-----< id-mr-distinguishedNameMatch >-----#
    id_mr_distinguishedNameMatch = OID(name=u'id-mr-distinguishedNameMatch', mode=MODE_VALUE)
    id_mr_distinguishedNameMatch._val = (2, 5, 13, 1)
    
    #-----< id-oa-excludeAllCollectiveAttributes >-----#
    id_oa_excludeAllCollectiveAttributes = OID(name=u'id-oa-excludeAllCollectiveAttributes', mode=MODE_VALUE)
    id_oa_excludeAllCollectiveAttributes._val = (2, 5, 18, 0)
    
    #-----< id-oa-createTimestamp >-----#
    id_oa_createTimestamp = OID(name=u'id-oa-createTimestamp', mode=MODE_VALUE)
    id_oa_createTimestamp._val = (2, 5, 18, 1)
    
    #-----< id-oa-modifyTimestamp >-----#
    id_oa_modifyTimestamp = OID(name=u'id-oa-modifyTimestamp', mode=MODE_VALUE)
    id_oa_modifyTimestamp._val = (2, 5, 18, 2)
    
    #-----< id-oa-creatorsName >-----#
    id_oa_creatorsName = OID(name=u'id-oa-creatorsName', mode=MODE_VALUE)
    id_oa_creatorsName._val = (2, 5, 18, 3)
    
    #-----< id-oa-modifiersName >-----#
    id_oa_modifiersName = OID(name=u'id-oa-modifiersName', mode=MODE_VALUE)
    id_oa_modifiersName._val = (2, 5, 18, 4)
    
    #-----< id-oa-administrativeRole >-----#
    id_oa_administrativeRole = OID(name=u'id-oa-administrativeRole', mode=MODE_VALUE)
    id_oa_administrativeRole._val = (2, 5, 18, 5)
    
    #-----< id-oa-subtreeSpecification >-----#
    id_oa_subtreeSpecification = OID(name=u'id-oa-subtreeSpecification', mode=MODE_VALUE)
    id_oa_subtreeSpecification._val = (2, 5, 18, 6)
    
    #-----< id-oa-collectiveExclusions >-----#
    id_oa_collectiveExclusions = OID(name=u'id-oa-collectiveExclusions', mode=MODE_VALUE)
    id_oa_collectiveExclusions._val = (2, 5, 18, 7)
    
    #-----< id-oa-subschemaTimestamp >-----#
    id_oa_subschemaTimestamp = OID(name=u'id-oa-subschemaTimestamp', mode=MODE_VALUE)
    id_oa_subschemaTimestamp._val = (2, 5, 18, 8)
    
    #-----< id-oa-hasSubordinates >-----#
    id_oa_hasSubordinates = OID(name=u'id-oa-hasSubordinates', mode=MODE_VALUE)
    id_oa_hasSubordinates._val = (2, 5, 18, 9)
    
    #-----< id-oa-subschemaSubentryList >-----#
    id_oa_subschemaSubentryList = OID(name=u'id-oa-subschemaSubentryList', mode=MODE_VALUE)
    id_oa_subschemaSubentryList._val = (2, 5, 18, 10)
    
    #-----< id-oa-accessControlSubentryList >-----#
    id_oa_accessControlSubentryList = OID(name=u'id-oa-accessControlSubentryList', mode=MODE_VALUE)
    id_oa_accessControlSubentryList._val = (2, 5, 18, 11)
    
    #-----< id-oa-collectiveAttributeSubentryList >-----#
    id_oa_collectiveAttributeSubentryList = OID(name=u'id-oa-collectiveAttributeSubentryList', mode=MODE_VALUE)
    id_oa_collectiveAttributeSubentryList._val = (2, 5, 18, 12)
    
    #-----< id-oa-contextDefaultSubentryList >-----#
    id_oa_contextDefaultSubentryList = OID(name=u'id-oa-contextDefaultSubentryList', mode=MODE_VALUE)
    id_oa_contextDefaultSubentryList._val = (2, 5, 18, 13)
    
    #-----< id-oa-contextAssertionDefault >-----#
    id_oa_contextAssertionDefault = OID(name=u'id-oa-contextAssertionDefault', mode=MODE_VALUE)
    id_oa_contextAssertionDefault._val = (2, 5, 18, 14)
    
    #-----< id-oa-serviceAdminSubentryList >-----#
    id_oa_serviceAdminSubentryList = OID(name=u'id-oa-serviceAdminSubentryList', mode=MODE_VALUE)
    id_oa_serviceAdminSubentryList._val = (2, 5, 18, 15)
    
    #-----< id-oa-searchRules >-----#
    id_oa_searchRules = OID(name=u'id-oa-searchRules', mode=MODE_VALUE)
    id_oa_searchRules._val = (2, 5, 18, 16)
    
    #-----< id-oa-hierarchyLevel >-----#
    id_oa_hierarchyLevel = OID(name=u'id-oa-hierarchyLevel', mode=MODE_VALUE)
    id_oa_hierarchyLevel._val = (2, 5, 18, 17)
    
    #-----< id-oa-hierarchyBelow >-----#
    id_oa_hierarchyBelow = OID(name=u'id-oa-hierarchyBelow', mode=MODE_VALUE)
    id_oa_hierarchyBelow._val = (2, 5, 18, 18)
    
    #-----< id-oa-hierarchyParent >-----#
    id_oa_hierarchyParent = OID(name=u'id-oa-hierarchyParent', mode=MODE_VALUE)
    id_oa_hierarchyParent._val = (2, 5, 18, 19)
    
    #-----< id-oa-hierarchyTop >-----#
    id_oa_hierarchyTop = OID(name=u'id-oa-hierarchyTop', mode=MODE_VALUE)
    id_oa_hierarchyTop._val = (2, 5, 18, 20)
    
    #-----< id-oa-pwdAdminSubentryList >-----#
    id_oa_pwdAdminSubentryList = OID(name=u'id-oa-pwdAdminSubentryList', mode=MODE_VALUE)
    id_oa_pwdAdminSubentryList._val = (2, 5, 18, 21)
    
    #-----< id-oa-allAttributeTypes >-----#
    id_oa_allAttributeTypes = OID(name=u'id-oa-allAttributeTypes', mode=MODE_VALUE)
    id_oa_allAttributeTypes._val = (2, 5, 18, 48)
    
    #-----< id-sc-subentry >-----#
    id_sc_subentry = OID(name=u'id-sc-subentry', mode=MODE_VALUE)
    id_sc_subentry._val = (2, 5, 17, 0)
    
    #-----< id-sc-accessControlSubentry >-----#
    id_sc_accessControlSubentry = OID(name=u'id-sc-accessControlSubentry', mode=MODE_VALUE)
    id_sc_accessControlSubentry._val = (2, 5, 17, 1)
    
    #-----< id-sc-collectiveAttributeSubentry >-----#
    id_sc_collectiveAttributeSubentry = OID(name=u'id-sc-collectiveAttributeSubentry', mode=MODE_VALUE)
    id_sc_collectiveAttributeSubentry._val = (2, 5, 17, 2)
    
    #-----< id-sc-contextAssertionSubentry >-----#
    id_sc_contextAssertionSubentry = OID(name=u'id-sc-contextAssertionSubentry', mode=MODE_VALUE)
    id_sc_contextAssertionSubentry._val = (2, 5, 17, 3)
    
    #-----< id-sc-serviceAdminSubentry >-----#
    id_sc_serviceAdminSubentry = OID(name=u'id-sc-serviceAdminSubentry', mode=MODE_VALUE)
    id_sc_serviceAdminSubentry._val = (2, 5, 17, 4)
    
    #-----< id-sc-pwdAdminSubentry >-----#
    id_sc_pwdAdminSubentry = OID(name=u'id-sc-pwdAdminSubentry', mode=MODE_VALUE)
    id_sc_pwdAdminSubentry._val = (2, 5, 17, 5)
    
    #-----< id-nf-subentryNameForm >-----#
    id_nf_subentryNameForm = OID(name=u'id-nf-subentryNameForm', mode=MODE_VALUE)
    id_nf_subentryNameForm._val = (2, 5, 15, 16)
    
    #-----< id-ar-autonomousArea >-----#
    id_ar_autonomousArea = OID(name=u'id-ar-autonomousArea', mode=MODE_VALUE)
    id_ar_autonomousArea._val = (2, 5, 23, 1)
    
    #-----< id-ar-accessControlSpecificArea >-----#
    id_ar_accessControlSpecificArea = OID(name=u'id-ar-accessControlSpecificArea', mode=MODE_VALUE)
    id_ar_accessControlSpecificArea._val = (2, 5, 23, 2)
    
    #-----< id-ar-accessControlInnerArea >-----#
    id_ar_accessControlInnerArea = OID(name=u'id-ar-accessControlInnerArea', mode=MODE_VALUE)
    id_ar_accessControlInnerArea._val = (2, 5, 23, 3)
    
    #-----< id-ar-subschemaAdminSpecificArea >-----#
    id_ar_subschemaAdminSpecificArea = OID(name=u'id-ar-subschemaAdminSpecificArea', mode=MODE_VALUE)
    id_ar_subschemaAdminSpecificArea._val = (2, 5, 23, 4)
    
    #-----< id-ar-collectiveAttributeSpecificArea >-----#
    id_ar_collectiveAttributeSpecificArea = OID(name=u'id-ar-collectiveAttributeSpecificArea', mode=MODE_VALUE)
    id_ar_collectiveAttributeSpecificArea._val = (2, 5, 23, 5)
    
    #-----< id-ar-collectiveAttributeInnerArea >-----#
    id_ar_collectiveAttributeInnerArea = OID(name=u'id-ar-collectiveAttributeInnerArea', mode=MODE_VALUE)
    id_ar_collectiveAttributeInnerArea._val = (2, 5, 23, 6)
    
    #-----< id-ar-contextDefaultSpecificArea >-----#
    id_ar_contextDefaultSpecificArea = OID(name=u'id-ar-contextDefaultSpecificArea', mode=MODE_VALUE)
    id_ar_contextDefaultSpecificArea._val = (2, 5, 23, 7)
    
    #-----< id-ar-serviceSpecificArea >-----#
    id_ar_serviceSpecificArea = OID(name=u'id-ar-serviceSpecificArea', mode=MODE_VALUE)
    id_ar_serviceSpecificArea._val = (2, 5, 23, 8)
    
    #-----< id-ar-pwdAdminSpecificArea >-----#
    id_ar_pwdAdminSpecificArea = OID(name=u'id-ar-pwdAdminSpecificArea', mode=MODE_VALUE)
    id_ar_pwdAdminSpecificArea._val = (2, 5, 23, 9)
    
    _all_ = [
        AttributeType,
        AttributeValue,
        __Context_contextType_tab,
        _Context_contextType,
        ___Context_contextValues__item__tab,
        __Context_contextValues__item_,
        _Context_contextValues,
        _Context_fallback,
        Context,
        __AttributeValueAssertion_type_tab,
        ___AttributeValueAssertion_type_tab_val_Type_0,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType,
        ___AttributeValueAssertion_type_tab_val_Type_1,
        ______TBSAttributeCertificate_attributes__item__type_tab_equality_match_val_AssertionType_0,
        _AttributeValueAssertion_type,
        _AttributeValueAssertion_assertion,
        __AttributeValueAssertion_assertedContexts_allContexts,
        ___AttributeValueAssertion_assertedContexts_selectedContexts__item_,
        __AttributeValueAssertion_assertedContexts_selectedContexts,
        _AttributeValueAssertion_assertedContexts,
        AttributeValueAssertion,
        __ContextAssertion_contextType_tab,
        _ContextAssertion_contextType,
        ___ContextAssertion_contextValues__item__tab,
        __ContextAssertion_contextValues__item_,
        _ContextAssertion_contextValues,
        ContextAssertion,
        __AttributeTypeAssertion_type_tab,
        ___AttributeTypeAssertion_type_tab_val_Type_0,
        ___AttributeTypeAssertion_type_tab_val_Type_1,
        _AttributeTypeAssertion_type,
        __AttributeTypeAssertion_assertedContexts__item_,
        _AttributeTypeAssertion_assertedContexts,
        AttributeTypeAssertion,
        SupportedAttributes,
        _SupportedAttributes_val_Type_0,
        _SupportedAttributes_val_Type_1,
        SupportedContexts,
        _Name_rdnSequence,
        Name,
        _RDNSequence__item_,
        RDNSequence,
        DistinguishedName,
        _RelativeDistinguishedName__item_,
        RelativeDistinguishedName,
        __AttributeTypeAndValue_type_tab,
        ___AttributeTypeAndValue_type_tab_val_Type_0,
        ___AttributeTypeAndValue_type_tab_val_Type_1,
        _AttributeTypeAndValue_type,
        _AttributeTypeAndValue_value,
        AttributeTypeAndValue,
        _SubtreeSpecification_base,
        ___SubtreeSpecification_specificExclusions__item__chopBefore,
        ___SubtreeSpecification_specificExclusions__item__chopAfter,
        __SubtreeSpecification_specificExclusions__item_,
        _SubtreeSpecification_specificExclusions,
        _SubtreeSpecification_minimum,
        _SubtreeSpecification_maximum,
        _SubtreeSpecification_specificationFilter,
        SubtreeSpecification,
        LocalName,
        ___ChopSpecification_specificExclusions__item__chopBefore,
        ___ChopSpecification_specificExclusions__item__chopAfter,
        __ChopSpecification_specificExclusions__item_,
        _ChopSpecification_specificExclusions,
        _ChopSpecification_minimum,
        _ChopSpecification_maximum,
        ChopSpecification,
        BaseDistance,
        _Refinement_item,
        __Refinement_and___item_,
        _Refinement_and_,
        __Refinement_or___item_,
        _Refinement_or_,
        _Refinement_not_,
        Refinement,
        _OBJECT_CLASS_Superclasses,
        _OBJECT_CLASS_kind,
        _OBJECT_CLASS_MandatoryAttributes,
        _OBJECT_CLASS_OptionalAttributes,
        __OBJECT_CLASS_ldapName__item_,
        _OBJECT_CLASS_ldapName,
        _OBJECT_CLASS_ldapDesc,
        _OBJECT_CLASS_id,
        OBJECT_CLASS,
        ObjectClassKind,
        top,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0,
        alias,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0_0,
        parent,
        child,
        _ATTRIBUTE_derivation,
        _ATTRIBUTE_Type,
        _ATTRIBUTE_equality_match,
        _ATTRIBUTE_ordering_match,
        _ATTRIBUTE_substrings_match,
        _ATTRIBUTE_single_valued,
        _ATTRIBUTE_collective,
        _ATTRIBUTE_dummy,
        _ATTRIBUTE_no_user_modification,
        _ATTRIBUTE_usage,
        _ATTRIBUTE_ldapSyntax,
        __ATTRIBUTE_ldapName__item_,
        _ATTRIBUTE_ldapName,
        _ATTRIBUTE_ldapDesc,
        _ATTRIBUTE_obsolete,
        _ATTRIBUTE_id,
        ATTRIBUTE,
        AttributeUsage,
        objectClass,
        _objectClass_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType,
        aliasedEntryName,
        _aliasedEntryName_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        _MATCHING_RULE_ParentMatchingRules,
        _MATCHING_RULE_AssertionType,
        _MATCHING_RULE_uniqueMatchIndicator,
        _MATCHING_RULE_ldapSyntax,
        __MATCHING_RULE_ldapName__item_,
        _MATCHING_RULE_ldapName,
        _MATCHING_RULE_ldapDesc,
        _MATCHING_RULE_id,
        MATCHING_RULE,
        objectIdentifierMatch,
        _objectIdentifierMatch_val_AssertionType,
        distinguishedNameMatch,
        _distinguishedNameMatch_val_AssertionType,
        _NAME_FORM_namedObjectClass,
        _NAME_FORM_MandatoryAttributes,
        _NAME_FORM_OptionalAttributes,
        __NAME_FORM_ldapName__item_,
        _NAME_FORM_ldapName,
        _NAME_FORM_ldapDesc,
        _NAME_FORM_id,
        NAME_FORM,
        _DITStructureRule_ruleIdentifier,
        _DITStructureRule_nameForm,
        __DITStructureRule_superiorStructureRules__item_,
        _DITStructureRule_superiorStructureRules,
        DITStructureRule,
        RuleIdentifier,
        _STRUCTURE_RULE_nameForm,
        _STRUCTURE_RULE_SuperiorStructureRules,
        _STRUCTURE_RULE_id,
        STRUCTURE_RULE,
        _DITContentRule_structuralObjectClass,
        __DITContentRule_auxiliaries__item_,
        _DITContentRule_auxiliaries,
        __DITContentRule_mandatory__item_,
        _DITContentRule_mandatory,
        __DITContentRule_optional__item_,
        _DITContentRule_optional,
        __DITContentRule_precluded__item_,
        _DITContentRule_precluded,
        DITContentRule,
        _CONTENT_RULE_structuralClass,
        _CONTENT_RULE_Auxiliaries,
        _CONTENT_RULE_Mandatory,
        _CONTENT_RULE_Optional,
        _CONTENT_RULE_Precluded,
        CONTENT_RULE,
        _CONTEXT_Type,
        _CONTEXT_defaultValue,
        _CONTEXT_Assertion,
        _CONTEXT_absentMatch,
        _CONTEXT_id,
        CONTEXT,
        _DITContextUse_attributeType,
        __DITContextUse_mandatoryContexts__item_,
        _DITContextUse_mandatoryContexts,
        __DITContextUse_optionalContexts__item_,
        _DITContextUse_optionalContexts,
        DITContextUse,
        _DIT_CONTEXT_USE_RULE_attributeType,
        _DIT_CONTEXT_USE_RULE_Mandatory,
        _DIT_CONTEXT_USE_RULE_Optional,
        DIT_CONTEXT_USE_RULE,
        _FRIENDS_anchor,
        _FRIENDS_Friends,
        FRIENDS,
        _SYNTAX_NAME_ldapDesc,
        _SYNTAX_NAME_Type,
        _SYNTAX_NAME_id,
        SYNTAX_NAME,
        subentry,
        __ATTRIBUTE_derivation_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_1,
        __ATTRIBUTE_substrings_match_val_AssertionType,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0_1,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_1,
        subentryNameForm,
        __NAME_FORM_MandatoryAttributes_val_Type_0,
        subtreeSpecification,
        _subtreeSpecification_val_Type,
        administrativeRole,
        _administrativeRole_val_Type,
        createTimestamp,
        _createTimestamp_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_2,
        __ATTRIBUTE_ordering_match_val_AssertionType,
        modifyTimestamp,
        _modifyTimestamp_val_Type,
        subschemaTimestamp,
        _subschemaTimestamp_val_Type,
        creatorsName,
        _creatorsName_val_Type,
        modifiersName,
        _modifiersName_val_Type,
        subschemaSubentryList,
        _subschemaSubentryList_val_Type,
        accessControlSubentryList,
        _accessControlSubentryList_val_Type,
        collectiveAttributeSubentryList,
        _collectiveAttributeSubentryList_val_Type,
        contextDefaultSubentryList,
        _contextDefaultSubentryList_val_Type,
        serviceAdminSubentryList,
        _serviceAdminSubentryList_val_Type,
        pwdAdminSubentryList,
        _pwdAdminSubentryList_val_Type,
        hasSubordinates,
        _hasSubordinates_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_3,
        accessControlSubentry,
        collectiveAttributeSubentry,
        collectiveExclusions,
        _collectiveExclusions_val_Type,
        contextAssertionSubentry,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0_2,
        contextAssertionDefaults,
        _contextAssertionDefaults_val_Type,
        serviceAdminSubentry,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0_3,
        __ATTRIBUTE_equality_match_val_AssertionType_4,
        searchRules,
        _searchRules_val_Type,
        _SearchRuleDescription_id,
        _SearchRuleDescription_dmdId,
        _SearchRuleDescription_serviceType,
        _SearchRuleDescription_userClass,
        __SearchRuleDescription_inputAttributeTypes__item_,
        _SearchRuleDescription_inputAttributeTypes,
        _SearchRuleDescription_attributeCombination,
        __SearchRuleDescription_outputAttributeTypes__item_,
        _SearchRuleDescription_outputAttributeTypes,
        _SearchRuleDescription_defaultControls,
        _SearchRuleDescription_mandatoryControls,
        _SearchRuleDescription_searchRuleControls,
        _SearchRuleDescription_familyGrouping,
        _SearchRuleDescription_familyReturn,
        _SearchRuleDescription_relaxation,
        __SearchRuleDescription_additionalControl__item_,
        _SearchRuleDescription_additionalControl,
        _SearchRuleDescription_allowedSubset,
        _SearchRuleDescription_imposedSubset,
        _SearchRuleDescription_entryLimit,
        __SearchRuleDescription_name__item_,
        _SearchRuleDescription_name,
        _SearchRuleDescription_description,
        SearchRuleDescription,
        pwdAdminSubentry,
        __OBJECT_CLASS_MandatoryAttributes_val_Type_0_4,
        pwdAttribute,
        _pwdAttribute_val_Type,
        hierarchyLevel,
        _hierarchyLevel_val_Type,
        __ATTRIBUTE_ordering_match_val_AssertionType_0,
        HierarchyLevel,
        hierarchyBelow,
        _hierarchyBelow_val_Type,
        HierarchyBelow,
        hierarchyParent,
        _hierarchyParent_val_Type,
        hierarchyTop,
        _hierarchyTop_val_Type,
        id_oc_top,
        id_oc_alias,
        id_oc_parent,
        id_oc_child,
        id_at_objectClass,
        id_at_aliasedEntryName,
        id_at_pwdAttribute,
        id_mr_objectIdentifierMatch,
        id_mr_distinguishedNameMatch,
        id_oa_excludeAllCollectiveAttributes,
        id_oa_createTimestamp,
        id_oa_modifyTimestamp,
        id_oa_creatorsName,
        id_oa_modifiersName,
        id_oa_administrativeRole,
        id_oa_subtreeSpecification,
        id_oa_collectiveExclusions,
        id_oa_subschemaTimestamp,
        id_oa_hasSubordinates,
        id_oa_subschemaSubentryList,
        id_oa_accessControlSubentryList,
        id_oa_collectiveAttributeSubentryList,
        id_oa_contextDefaultSubentryList,
        id_oa_contextAssertionDefault,
        id_oa_serviceAdminSubentryList,
        id_oa_searchRules,
        id_oa_hierarchyLevel,
        id_oa_hierarchyBelow,
        id_oa_hierarchyParent,
        id_oa_hierarchyTop,
        id_oa_pwdAdminSubentryList,
        id_oa_allAttributeTypes,
        id_sc_subentry,
        id_sc_accessControlSubentry,
        id_sc_collectiveAttributeSubentry,
        id_sc_contextAssertionSubentry,
        id_sc_serviceAdminSubentry,
        id_sc_pwdAdminSubentry,
        id_nf_subentryNameForm,
        id_ar_autonomousArea,
        id_ar_accessControlSpecificArea,
        id_ar_accessControlInnerArea,
        id_ar_subschemaAdminSpecificArea,
        id_ar_collectiveAttributeSpecificArea,
        id_ar_collectiveAttributeInnerArea,
        id_ar_contextDefaultSpecificArea,
        id_ar_serviceSpecificArea,
        id_ar_pwdAdminSpecificArea,
    ]

class LCSChargingDataTypes:

    _name_  = u'LCSChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 6, 0, 1]
    
    _obj_ = [
        u'LCSRecord',
        u'LCSGMORecord',
        u'LCSRGMTRecord',
        u'LCSHGMTRecord',
        u'LCSVGMTRecord',
        u'LCSGNIRecord',
        u'ProviderError',
        u'ResultCodeType',
        u'ServingEntity',
        u'UserError',
        ]
    _type_ = [
        u'LCSRecord',
        u'LCSGMORecord',
        u'LCSRGMTRecord',
        u'LCSHGMTRecord',
        u'LCSVGMTRecord',
        u'LCSGNIRecord',
        u'ProviderError',
        u'ResultCodeType',
        u'ServingEntity',
        u'UserError',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< LCSRecord >-----#
    LCSRecord = CHOICE(name=u'LCSRecord', mode=MODE_TYPE)
    _LCSRecord_lCSGMORecord = SET(name=u'lCSGMORecord', mode=MODE_TYPE, tag=(71, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'LCSGMORecord')))
    _LCSRecord_lCSRGMTRecord = SET(name=u'lCSRGMTRecord', mode=MODE_TYPE, tag=(72, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'LCSRGMTRecord')))
    _LCSRecord_lCSHGMTRecord = SET(name=u'lCSHGMTRecord', mode=MODE_TYPE, tag=(73, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'LCSHGMTRecord')))
    _LCSRecord_lCSVGMTRecord = SET(name=u'lCSVGMTRecord', mode=MODE_TYPE, tag=(74, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'LCSVGMTRecord')))
    _LCSRecord_lCSGNIRecord = SET(name=u'lCSGNIRecord', mode=MODE_TYPE, tag=(75, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'LCSGNIRecord')))
    LCSRecord._cont = ASN1Dict([
        (u'lCSGMORecord', _LCSRecord_lCSGMORecord),
        (u'lCSRGMTRecord', _LCSRecord_lCSRGMTRecord),
        (u'lCSHGMTRecord', _LCSRecord_lCSHGMTRecord),
        (u'lCSVGMTRecord', _LCSRecord_lCSVGMTRecord),
        (u'lCSGNIRecord', _LCSRecord_lCSGNIRecord),
        ])
    LCSRecord._ext = None
    
    #-----< LCSGMORecord >-----#
    LCSGMORecord = SET(name=u'LCSGMORecord', mode=MODE_TYPE)
    _LCSGMORecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _LCSGMORecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _LCSGMORecord_lcsClientType = ENUM(name=u'lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _LCSGMORecord_lcsClientIdentity = SEQ(name=u'lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _LCSGMORecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _LCSGMORecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _LCSGMORecord_servingEntity = OCT_STR(name=u'servingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'ServingEntity')), opt=True)
    _LCSGMORecord_locationEstimate = OCT_STR(name=u'locationEstimate', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _LCSGMORecord_positioningData = OCT_STR(name=u'positioningData', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PositioningData')), opt=True)
    _LCSGMORecord_userError = OCT_STR(name=u'userError', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'UserError')), opt=True)
    _LCSGMORecord_providerError = INT(name=u'providerError', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'ProviderError')), opt=True)
    _LCSGMORecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _LCSGMORecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _LCSGMORecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    LCSGMORecord._cont = ASN1Dict([
        (u'recordType', _LCSGMORecord_recordType),
        (u'recordingEntity', _LCSGMORecord_recordingEntity),
        (u'lcsClientType', _LCSGMORecord_lcsClientType),
        (u'lcsClientIdentity', _LCSGMORecord_lcsClientIdentity),
        (u'servedIMSI', _LCSGMORecord_servedIMSI),
        (u'servedMSISDN', _LCSGMORecord_servedMSISDN),
        (u'servingEntity', _LCSGMORecord_servingEntity),
        (u'locationEstimate', _LCSGMORecord_locationEstimate),
        (u'positioningData', _LCSGMORecord_positioningData),
        (u'userError', _LCSGMORecord_userError),
        (u'providerError', _LCSGMORecord_providerError),
        (u'recordTimeStamp', _LCSGMORecord_recordTimeStamp),
        (u'localSequenceNumber', _LCSGMORecord_localSequenceNumber),
        (u'recordExtensions', _LCSGMORecord_recordExtensions),
        ])
    LCSGMORecord._ext = None
    
    #-----< LCSRGMTRecord >-----#
    LCSRGMTRecord = SET(name=u'LCSRGMTRecord', mode=MODE_TYPE)
    _LCSRGMTRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _LCSRGMTRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _LCSRGMTRecord_lcsClientType = ENUM(name=u'lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _LCSRGMTRecord_lcsClientIdentity = SEQ(name=u'lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _LCSRGMTRecord_targetIMSI = OCT_STR(name=u'targetIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _LCSRGMTRecord_targetMSISDN = OCT_STR(name=u'targetMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _LCSRGMTRecord_locationType = SEQ(name=u'locationType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')))
    _LCSRGMTRecord_lCSPriority = OCT_STR(name=u'lCSPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _LCSRGMTRecord_resultCode = INT(name=u'resultCode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'ResultCodeType')), opt=True)
    _LCSRGMTRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _LCSRGMTRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _LCSRGMTRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _LCSRGMTRecord_homeGMLCIdentity = CHOICE(name=u'homeGMLCIdentity', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    LCSRGMTRecord._cont = ASN1Dict([
        (u'recordType', _LCSRGMTRecord_recordType),
        (u'recordingEntity', _LCSRGMTRecord_recordingEntity),
        (u'lcsClientType', _LCSRGMTRecord_lcsClientType),
        (u'lcsClientIdentity', _LCSRGMTRecord_lcsClientIdentity),
        (u'targetIMSI', _LCSRGMTRecord_targetIMSI),
        (u'targetMSISDN', _LCSRGMTRecord_targetMSISDN),
        (u'locationType', _LCSRGMTRecord_locationType),
        (u'lCSPriority', _LCSRGMTRecord_lCSPriority),
        (u'resultCode', _LCSRGMTRecord_resultCode),
        (u'recordTimeStamp', _LCSRGMTRecord_recordTimeStamp),
        (u'localSequenceNumber', _LCSRGMTRecord_localSequenceNumber),
        (u'recordExtensions', _LCSRGMTRecord_recordExtensions),
        (u'homeGMLCIdentity', _LCSRGMTRecord_homeGMLCIdentity),
        ])
    LCSRGMTRecord._ext = None
    
    #-----< LCSHGMTRecord >-----#
    LCSHGMTRecord = SET(name=u'LCSHGMTRecord', mode=MODE_TYPE)
    _LCSHGMTRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _LCSHGMTRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _LCSHGMTRecord_lcsClientType = ENUM(name=u'lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _LCSHGMTRecord_lcsClientIdentity = SEQ(name=u'lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _LCSHGMTRecord_targetIMSI = OCT_STR(name=u'targetIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _LCSHGMTRecord_targetMSISDN = OCT_STR(name=u'targetMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _LCSHGMTRecord_locationType = SEQ(name=u'locationType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')))
    _LCSHGMTRecord_lCSPriority = OCT_STR(name=u'lCSPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _LCSHGMTRecord_resultCode = INT(name=u'resultCode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'ResultCodeType')), opt=True)
    _LCSHGMTRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _LCSHGMTRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _LCSHGMTRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _LCSHGMTRecord_requestingGMLCIdentity = CHOICE(name=u'requestingGMLCIdentity', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _LCSHGMTRecord_visitedGMLCIdentity = CHOICE(name=u'visitedGMLCIdentity', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _LCSHGMTRecord_servingNetworkIdentity = OCT_STR(name=u'servingNetworkIdentity', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    LCSHGMTRecord._cont = ASN1Dict([
        (u'recordType', _LCSHGMTRecord_recordType),
        (u'recordingEntity', _LCSHGMTRecord_recordingEntity),
        (u'lcsClientType', _LCSHGMTRecord_lcsClientType),
        (u'lcsClientIdentity', _LCSHGMTRecord_lcsClientIdentity),
        (u'targetIMSI', _LCSHGMTRecord_targetIMSI),
        (u'targetMSISDN', _LCSHGMTRecord_targetMSISDN),
        (u'locationType', _LCSHGMTRecord_locationType),
        (u'lCSPriority', _LCSHGMTRecord_lCSPriority),
        (u'resultCode', _LCSHGMTRecord_resultCode),
        (u'recordTimeStamp', _LCSHGMTRecord_recordTimeStamp),
        (u'localSequenceNumber', _LCSHGMTRecord_localSequenceNumber),
        (u'recordExtensions', _LCSHGMTRecord_recordExtensions),
        (u'requestingGMLCIdentity', _LCSHGMTRecord_requestingGMLCIdentity),
        (u'visitedGMLCIdentity', _LCSHGMTRecord_visitedGMLCIdentity),
        (u'servingNetworkIdentity', _LCSHGMTRecord_servingNetworkIdentity),
        ])
    LCSHGMTRecord._ext = None
    
    #-----< LCSVGMTRecord >-----#
    LCSVGMTRecord = SET(name=u'LCSVGMTRecord', mode=MODE_TYPE)
    _LCSVGMTRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _LCSVGMTRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _LCSVGMTRecord_lcsClientType = ENUM(name=u'lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _LCSVGMTRecord_lcsClientIdentity = SEQ(name=u'lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _LCSVGMTRecord_targetIMSI = OCT_STR(name=u'targetIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _LCSVGMTRecord_targetMSISDN = OCT_STR(name=u'targetMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _LCSVGMTRecord_locationType = SEQ(name=u'locationType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')))
    _LCSVGMTRecord_lCSPriority = OCT_STR(name=u'lCSPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _LCSVGMTRecord_resultCode = INT(name=u'resultCode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'ResultCodeType')), opt=True)
    _LCSVGMTRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _LCSVGMTRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _LCSVGMTRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _LCSVGMTRecord_homeGMLCIdentity = CHOICE(name=u'homeGMLCIdentity', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    LCSVGMTRecord._cont = ASN1Dict([
        (u'recordType', _LCSVGMTRecord_recordType),
        (u'recordingEntity', _LCSVGMTRecord_recordingEntity),
        (u'lcsClientType', _LCSVGMTRecord_lcsClientType),
        (u'lcsClientIdentity', _LCSVGMTRecord_lcsClientIdentity),
        (u'targetIMSI', _LCSVGMTRecord_targetIMSI),
        (u'targetMSISDN', _LCSVGMTRecord_targetMSISDN),
        (u'locationType', _LCSVGMTRecord_locationType),
        (u'lCSPriority', _LCSVGMTRecord_lCSPriority),
        (u'resultCode', _LCSVGMTRecord_resultCode),
        (u'recordTimeStamp', _LCSVGMTRecord_recordTimeStamp),
        (u'localSequenceNumber', _LCSVGMTRecord_localSequenceNumber),
        (u'recordExtensions', _LCSVGMTRecord_recordExtensions),
        (u'homeGMLCIdentity', _LCSVGMTRecord_homeGMLCIdentity),
        ])
    LCSVGMTRecord._ext = None
    
    #-----< LCSGNIRecord >-----#
    LCSGNIRecord = SET(name=u'LCSGNIRecord', mode=MODE_TYPE)
    _LCSGNIRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _LCSGNIRecord_recordingEntity = OCT_STR(name=u'recordingEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordingEntity')))
    _LCSGNIRecord_lcsClientType = ENUM(name=u'lcsClientType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')), opt=True)
    _LCSGNIRecord_lcsClientIdentity = SEQ(name=u'lcsClientIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LCSClientIdentity')), opt=True)
    _LCSGNIRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _LCSGNIRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _LCSGNIRecord_servingEntity = OCT_STR(name=u'servingEntity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'ServingEntity')), opt=True)
    _LCSGNIRecord_resultCode = INT(name=u'resultCode', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('LCSChargingDataTypes', 'ResultCodeType')), opt=True)
    _LCSGNIRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _LCSGNIRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _LCSGNIRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    LCSGNIRecord._cont = ASN1Dict([
        (u'recordType', _LCSGNIRecord_recordType),
        (u'recordingEntity', _LCSGNIRecord_recordingEntity),
        (u'lcsClientType', _LCSGNIRecord_lcsClientType),
        (u'lcsClientIdentity', _LCSGNIRecord_lcsClientIdentity),
        (u'servedIMSI', _LCSGNIRecord_servedIMSI),
        (u'servedMSISDN', _LCSGNIRecord_servedMSISDN),
        (u'servingEntity', _LCSGNIRecord_servingEntity),
        (u'resultCode', _LCSGNIRecord_resultCode),
        (u'recordTimeStamp', _LCSGNIRecord_recordTimeStamp),
        (u'localSequenceNumber', _LCSGNIRecord_localSequenceNumber),
        (u'recordExtensions', _LCSGNIRecord_recordExtensions),
        ])
    LCSGNIRecord._ext = None
    
    #-----< ProviderError >-----#
    ProviderError = INT(name=u'ProviderError', mode=MODE_TYPE)
    
    #-----< ResultCodeType >-----#
    ResultCodeType = INT(name=u'ResultCodeType', mode=MODE_TYPE)
    ResultCodeType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< ServingEntity >-----#
    ServingEntity = OCT_STR(name=u'ServingEntity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    
    #-----< UserError >-----#
    UserError = OCT_STR(name=u'UserError', mode=MODE_TYPE)
    UserError._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    _all_ = [
        _LCSRecord_lCSGMORecord,
        _LCSRecord_lCSRGMTRecord,
        _LCSRecord_lCSHGMTRecord,
        _LCSRecord_lCSVGMTRecord,
        _LCSRecord_lCSGNIRecord,
        LCSRecord,
        _LCSGMORecord_recordType,
        _LCSGMORecord_recordingEntity,
        _LCSGMORecord_lcsClientType,
        _LCSGMORecord_lcsClientIdentity,
        _LCSGMORecord_servedIMSI,
        _LCSGMORecord_servedMSISDN,
        _LCSGMORecord_servingEntity,
        _LCSGMORecord_locationEstimate,
        _LCSGMORecord_positioningData,
        _LCSGMORecord_userError,
        _LCSGMORecord_providerError,
        _LCSGMORecord_recordTimeStamp,
        _LCSGMORecord_localSequenceNumber,
        _LCSGMORecord_recordExtensions,
        LCSGMORecord,
        _LCSRGMTRecord_recordType,
        _LCSRGMTRecord_recordingEntity,
        _LCSRGMTRecord_lcsClientType,
        _LCSRGMTRecord_lcsClientIdentity,
        _LCSRGMTRecord_targetIMSI,
        _LCSRGMTRecord_targetMSISDN,
        _LCSRGMTRecord_locationType,
        _LCSRGMTRecord_lCSPriority,
        _LCSRGMTRecord_resultCode,
        _LCSRGMTRecord_recordTimeStamp,
        _LCSRGMTRecord_localSequenceNumber,
        _LCSRGMTRecord_recordExtensions,
        _LCSRGMTRecord_homeGMLCIdentity,
        LCSRGMTRecord,
        _LCSHGMTRecord_recordType,
        _LCSHGMTRecord_recordingEntity,
        _LCSHGMTRecord_lcsClientType,
        _LCSHGMTRecord_lcsClientIdentity,
        _LCSHGMTRecord_targetIMSI,
        _LCSHGMTRecord_targetMSISDN,
        _LCSHGMTRecord_locationType,
        _LCSHGMTRecord_lCSPriority,
        _LCSHGMTRecord_resultCode,
        _LCSHGMTRecord_recordTimeStamp,
        _LCSHGMTRecord_localSequenceNumber,
        _LCSHGMTRecord_recordExtensions,
        _LCSHGMTRecord_requestingGMLCIdentity,
        _LCSHGMTRecord_visitedGMLCIdentity,
        _LCSHGMTRecord_servingNetworkIdentity,
        LCSHGMTRecord,
        _LCSVGMTRecord_recordType,
        _LCSVGMTRecord_recordingEntity,
        _LCSVGMTRecord_lcsClientType,
        _LCSVGMTRecord_lcsClientIdentity,
        _LCSVGMTRecord_targetIMSI,
        _LCSVGMTRecord_targetMSISDN,
        _LCSVGMTRecord_locationType,
        _LCSVGMTRecord_lCSPriority,
        _LCSVGMTRecord_resultCode,
        _LCSVGMTRecord_recordTimeStamp,
        _LCSVGMTRecord_localSequenceNumber,
        _LCSVGMTRecord_recordExtensions,
        _LCSVGMTRecord_homeGMLCIdentity,
        LCSVGMTRecord,
        _LCSGNIRecord_recordType,
        _LCSGNIRecord_recordingEntity,
        _LCSGNIRecord_lcsClientType,
        _LCSGNIRecord_lcsClientIdentity,
        _LCSGNIRecord_servedIMSI,
        _LCSGNIRecord_servedMSISDN,
        _LCSGNIRecord_servingEntity,
        _LCSGNIRecord_resultCode,
        _LCSGNIRecord_recordTimeStamp,
        _LCSGNIRecord_localSequenceNumber,
        _LCSGNIRecord_recordExtensions,
        LCSGNIRecord,
        ProviderError,
        ResultCodeType,
        ServingEntity,
        UserError,
    ]

class LdapSystemSchema:

    _name_  = u'LdapSystemSchema'
    _oid_   = [2, 5, 1, 38, 8]
    
    _obj_ = [
        u'namingContexts',
        u'altServer',
        u'supportedExtension',
        u'supportedControl',
        u'supportedSASLMechanisms',
        u'supportedLDAPVersion',
        u'supportedFeatures',
        u'ldapSyntaxes',
        u'LdapSyntaxDescription',
        u'id-lat-namingContexts',
        u'id-lat-altServer',
        u'id-lat-supportedExtension',
        u'id-lat-supportedControl',
        u'id-lat-supportedSASLMechanisms',
        u'id-lat-supportedLDAPVersion',
        u'id-soa-ldapSyntaxes',
        u'id-oat-supportedFeatures',
        ]
    _type_ = [
        u'LdapSyntaxDescription',
        ]
    _set_ = [
        ]
    _val_ = [
        u'namingContexts',
        u'altServer',
        u'supportedExtension',
        u'supportedControl',
        u'supportedSASLMechanisms',
        u'supportedLDAPVersion',
        u'supportedFeatures',
        u'ldapSyntaxes',
        u'id-lat-namingContexts',
        u'id-lat-altServer',
        u'id-lat-supportedExtension',
        u'id-lat-supportedControl',
        u'id-lat-supportedSASLMechanisms',
        u'id-lat-supportedLDAPVersion',
        u'id-soa-ldapSyntaxes',
        u'id-oat-supportedFeatures',
        ]
    _class_ = [
        u'namingContexts',
        u'altServer',
        u'supportedExtension',
        u'supportedControl',
        u'supportedSASLMechanisms',
        u'supportedLDAPVersion',
        u'supportedFeatures',
        u'ldapSyntaxes',
        ]
    _param_ = [
        ]
    
    #-----< namingContexts >-----#
    namingContexts = CLASS(name=u'namingContexts', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _namingContexts_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    namingContexts._val = dict([(u'Type', _namingContexts_val_Type), (u'usage', u'dSAOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'namingContexts']), (u'id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 5))])
    
    #-----< altServer >-----#
    altServer = CLASS(name=u'altServer', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _altServer_val_Type = STR_IA5(name=u'Type', mode=MODE_TYPE)
    altServer._val = dict([(u'Type', _altServer_val_Type), (u'usage', u'dSAOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26)), (u'ldapName', [u'altServer']), (u'id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 6))])
    
    #-----< supportedExtension >-----#
    supportedExtension = CLASS(name=u'supportedExtension', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedExtension_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    supportedExtension._val = dict([(u'Type', _supportedExtension_val_Type), (u'usage', u'dSAOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'supportedExtension']), (u'id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 7))])
    
    #-----< supportedControl >-----#
    supportedControl = CLASS(name=u'supportedControl', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedControl_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    supportedControl._val = dict([(u'Type', _supportedControl_val_Type), (u'usage', u'dSAOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'supportedControl']), (u'id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 13))])
    
    #-----< supportedSASLMechanisms >-----#
    supportedSASLMechanisms = CLASS(name=u'supportedSASLMechanisms', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedSASLMechanisms_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DirectoryString')))
    __supportedSASLMechanisms_val_Type_teletexString = STR_TELE(name=u'teletexString', mode=MODE_TYPE)
    __supportedSASLMechanisms_val_Type_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __supportedSASLMechanisms_val_Type_printableString = STR_PRINT(name=u'printableString', mode=MODE_TYPE)
    __supportedSASLMechanisms_val_Type_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __supportedSASLMechanisms_val_Type_bmpString = STR_BMP(name=u'bmpString', mode=MODE_TYPE)
    __supportedSASLMechanisms_val_Type_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __supportedSASLMechanisms_val_Type_universalString = STR_UNIV(name=u'universalString', mode=MODE_TYPE)
    __supportedSASLMechanisms_val_Type_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    __supportedSASLMechanisms_val_Type_uTF8String = STR_UTF8(name=u'uTF8String', mode=MODE_TYPE)
    __supportedSASLMechanisms_val_Type_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=[], er=[])
    _supportedSASLMechanisms_val_Type._cont = ASN1Dict([
        (u'teletexString', __supportedSASLMechanisms_val_Type_teletexString),
        (u'printableString', __supportedSASLMechanisms_val_Type_printableString),
        (u'bmpString', __supportedSASLMechanisms_val_Type_bmpString),
        (u'universalString', __supportedSASLMechanisms_val_Type_universalString),
        (u'uTF8String', __supportedSASLMechanisms_val_Type_uTF8String),
        ])
    _supportedSASLMechanisms_val_Type._ext = None
    supportedSASLMechanisms._val = dict([(u'Type', _supportedSASLMechanisms_val_Type), (u'usage', u'dSAOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'supportedSASLMechanisms']), (u'id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 14))])
    
    #-----< supportedLDAPVersion >-----#
    supportedLDAPVersion = CLASS(name=u'supportedLDAPVersion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedLDAPVersion_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    supportedLDAPVersion._val = dict([(u'Type', _supportedLDAPVersion_val_Type), (u'usage', u'dSAOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'supportedLDAPVersion']), (u'id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 15))])
    
    #-----< supportedFeatures >-----#
    supportedFeatures = CLASS(name=u'supportedFeatures', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedFeatures_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    supportedFeatures._val = dict([(u'Type', _supportedFeatures_val_Type), (u'usage', u'dSAOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'supportedFeatures']), (u'id', (1, 3, 6, 1, 4, 1, 4203, 1, 3, 5))])
    
    #-----< ldapSyntaxes >-----#
    ldapSyntaxes = CLASS(name=u'ldapSyntaxes', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _ldapSyntaxes_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('LdapSystemSchema', 'LdapSyntaxDescription')))
    __ATTRIBUTE_equality_match_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    ldapSyntaxes._val = dict([(u'Type', _ldapSyntaxes_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 54)), (u'ldapName', [u'ldapSyntax']), (u'id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 16))])
    
    #-----< LdapSyntaxDescription >-----#
    LdapSyntaxDescription = SEQ(name=u'LdapSyntaxDescription', mode=MODE_TYPE)
    _LdapSyntaxDescription_identifier = OID(name=u'identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'SYNTAX-NAME'), [u'id']))
    _LdapSyntaxDescription_description = CHOICE(name=u'description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    LdapSyntaxDescription._cont = ASN1Dict([
        (u'identifier', _LdapSyntaxDescription_identifier),
        (u'description', _LdapSyntaxDescription_description),
        ])
    LdapSyntaxDescription._ext = []
    
    #-----< id-lat-namingContexts >-----#
    id_lat_namingContexts = OID(name=u'id-lat-namingContexts', mode=MODE_VALUE)
    id_lat_namingContexts._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 5)
    
    #-----< id-lat-altServer >-----#
    id_lat_altServer = OID(name=u'id-lat-altServer', mode=MODE_VALUE)
    id_lat_altServer._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 6)
    
    #-----< id-lat-supportedExtension >-----#
    id_lat_supportedExtension = OID(name=u'id-lat-supportedExtension', mode=MODE_VALUE)
    id_lat_supportedExtension._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 7)
    
    #-----< id-lat-supportedControl >-----#
    id_lat_supportedControl = OID(name=u'id-lat-supportedControl', mode=MODE_VALUE)
    id_lat_supportedControl._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 13)
    
    #-----< id-lat-supportedSASLMechanisms >-----#
    id_lat_supportedSASLMechanisms = OID(name=u'id-lat-supportedSASLMechanisms', mode=MODE_VALUE)
    id_lat_supportedSASLMechanisms._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 14)
    
    #-----< id-lat-supportedLDAPVersion >-----#
    id_lat_supportedLDAPVersion = OID(name=u'id-lat-supportedLDAPVersion', mode=MODE_VALUE)
    id_lat_supportedLDAPVersion._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 15)
    
    #-----< id-soa-ldapSyntaxes >-----#
    id_soa_ldapSyntaxes = OID(name=u'id-soa-ldapSyntaxes', mode=MODE_VALUE)
    id_soa_ldapSyntaxes._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120, 16)
    
    #-----< id-oat-supportedFeatures >-----#
    id_oat_supportedFeatures = OID(name=u'id-oat-supportedFeatures', mode=MODE_VALUE)
    id_oat_supportedFeatures._val = (1, 3, 6, 1, 4, 1, 4203, 1, 3, 5)
    
    _all_ = [
        namingContexts,
        _namingContexts_val_Type,
        altServer,
        _altServer_val_Type,
        supportedExtension,
        _supportedExtension_val_Type,
        supportedControl,
        _supportedControl_val_Type,
        supportedSASLMechanisms,
        __supportedSASLMechanisms_val_Type_teletexString,
        __supportedSASLMechanisms_val_Type_printableString,
        __supportedSASLMechanisms_val_Type_bmpString,
        __supportedSASLMechanisms_val_Type_universalString,
        __supportedSASLMechanisms_val_Type_uTF8String,
        _supportedSASLMechanisms_val_Type,
        supportedLDAPVersion,
        _supportedLDAPVersion_val_Type,
        supportedFeatures,
        _supportedFeatures_val_Type,
        ldapSyntaxes,
        _ldapSyntaxes_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType,
        _LdapSyntaxDescription_identifier,
        _LdapSyntaxDescription_description,
        LdapSyntaxDescription,
        id_lat_namingContexts,
        id_lat_altServer,
        id_lat_supportedExtension,
        id_lat_supportedControl,
        id_lat_supportedSASLMechanisms,
        id_lat_supportedLDAPVersion,
        id_soa_ldapSyntaxes,
        id_oat_supportedFeatures,
    ]

class Lightweight_Directory_Access_Protocol_V3:

    _name_  = u'Lightweight-Directory-Access-Protocol-V3'
    _oid_   = [1, 3, 6, 1, 1, 18]
    
    _obj_ = [
        u'LDAPMessage',
        u'MessageID',
        u'maxInt',
        u'LDAPString',
        u'LDAPOID',
        u'LDAPDN',
        u'RelativeLDAPDN',
        u'AttributeDescription',
        u'AttributeValue',
        u'AttributeValueAssertion',
        u'AssertionValue',
        u'PartialAttribute',
        u'Attribute',
        u'MatchingRuleId',
        u'LDAPResult',
        u'Referral',
        u'URI',
        u'Controls',
        u'Control',
        u'BindRequest',
        u'AuthenticationChoice',
        u'SaslCredentials',
        u'BindResponse',
        u'UnbindRequest',
        u'SearchRequest',
        u'AttributeSelection',
        u'Filter',
        u'SubstringFilter',
        u'MatchingRuleAssertion',
        u'SearchResultEntry',
        u'PartialAttributeList',
        u'SearchResultReference',
        u'SearchResultDone',
        u'ModifyRequest',
        u'ModifyResponse',
        u'AddRequest',
        u'AttributeList',
        u'AddResponse',
        u'DelRequest',
        u'DelResponse',
        u'ModifyDNRequest',
        u'ModifyDNResponse',
        u'CompareRequest',
        u'CompareResponse',
        u'AbandonRequest',
        u'ExtendedRequest',
        u'ExtendedResponse',
        u'IntermediateResponse',
        ]
    _type_ = [
        u'LDAPMessage',
        u'MessageID',
        u'LDAPString',
        u'LDAPOID',
        u'LDAPDN',
        u'RelativeLDAPDN',
        u'AttributeDescription',
        u'AttributeValue',
        u'AttributeValueAssertion',
        u'AssertionValue',
        u'PartialAttribute',
        u'Attribute',
        u'MatchingRuleId',
        u'LDAPResult',
        u'Referral',
        u'URI',
        u'Controls',
        u'Control',
        u'BindRequest',
        u'AuthenticationChoice',
        u'SaslCredentials',
        u'BindResponse',
        u'UnbindRequest',
        u'SearchRequest',
        u'AttributeSelection',
        u'Filter',
        u'SubstringFilter',
        u'MatchingRuleAssertion',
        u'SearchResultEntry',
        u'PartialAttributeList',
        u'SearchResultReference',
        u'SearchResultDone',
        u'ModifyRequest',
        u'ModifyResponse',
        u'AddRequest',
        u'AttributeList',
        u'AddResponse',
        u'DelRequest',
        u'DelResponse',
        u'ModifyDNRequest',
        u'ModifyDNResponse',
        u'CompareRequest',
        u'CompareResponse',
        u'AbandonRequest',
        u'ExtendedRequest',
        u'ExtendedResponse',
        u'IntermediateResponse',
        ]
    _set_ = [
        ]
    _val_ = [
        u'maxInt',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< LDAPMessage >-----#
    LDAPMessage = SEQ(name=u'LDAPMessage', mode=MODE_TYPE)
    _LDAPMessage_messageID = INT(name=u'messageID', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MessageID')))
    _LDAPMessage_protocolOp = CHOICE(name=u'protocolOp', mode=MODE_TYPE)
    __LDAPMessage_protocolOp_bindRequest = SEQ(name=u'bindRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'BindRequest')))
    __LDAPMessage_protocolOp_bindResponse = SEQ(name=u'bindResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'BindResponse')))
    __LDAPMessage_protocolOp_unbindRequest = NULL(name=u'unbindRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'UnbindRequest')))
    __LDAPMessage_protocolOp_searchRequest = SEQ(name=u'searchRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchRequest')))
    __LDAPMessage_protocolOp_searchResEntry = SEQ(name=u'searchResEntry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchResultEntry')))
    __LDAPMessage_protocolOp_searchResDone = SEQ(name=u'searchResDone', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchResultDone')))
    __LDAPMessage_protocolOp_searchResRef = SEQ_OF(name=u'searchResRef', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SearchResultReference')))
    __LDAPMessage_protocolOp_modifyRequest = SEQ(name=u'modifyRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyRequest')))
    __LDAPMessage_protocolOp_modifyResponse = SEQ(name=u'modifyResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyResponse')))
    __LDAPMessage_protocolOp_addRequest = SEQ(name=u'addRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AddRequest')))
    __LDAPMessage_protocolOp_addResponse = SEQ(name=u'addResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AddResponse')))
    __LDAPMessage_protocolOp_delRequest = OCT_STR(name=u'delRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'DelRequest')))
    __LDAPMessage_protocolOp_delResponse = SEQ(name=u'delResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'DelResponse')))
    __LDAPMessage_protocolOp_modDNRequest = SEQ(name=u'modDNRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyDNRequest')))
    __LDAPMessage_protocolOp_modDNResponse = SEQ(name=u'modDNResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ModifyDNResponse')))
    __LDAPMessage_protocolOp_compareRequest = SEQ(name=u'compareRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'CompareRequest')))
    __LDAPMessage_protocolOp_compareResponse = SEQ(name=u'compareResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'CompareResponse')))
    __LDAPMessage_protocolOp_abandonRequest = INT(name=u'abandonRequest', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AbandonRequest')))
    __LDAPMessage_protocolOp_extendedReq = SEQ(name=u'extendedReq', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ExtendedRequest')))
    __LDAPMessage_protocolOp_extendedResp = SEQ(name=u'extendedResp', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'ExtendedResponse')))
    __LDAPMessage_protocolOp_intermediateResponse = SEQ(name=u'intermediateResponse', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'IntermediateResponse')))
    _LDAPMessage_protocolOp._cont = ASN1Dict([
        (u'bindRequest', __LDAPMessage_protocolOp_bindRequest),
        (u'bindResponse', __LDAPMessage_protocolOp_bindResponse),
        (u'unbindRequest', __LDAPMessage_protocolOp_unbindRequest),
        (u'searchRequest', __LDAPMessage_protocolOp_searchRequest),
        (u'searchResEntry', __LDAPMessage_protocolOp_searchResEntry),
        (u'searchResDone', __LDAPMessage_protocolOp_searchResDone),
        (u'searchResRef', __LDAPMessage_protocolOp_searchResRef),
        (u'modifyRequest', __LDAPMessage_protocolOp_modifyRequest),
        (u'modifyResponse', __LDAPMessage_protocolOp_modifyResponse),
        (u'addRequest', __LDAPMessage_protocolOp_addRequest),
        (u'addResponse', __LDAPMessage_protocolOp_addResponse),
        (u'delRequest', __LDAPMessage_protocolOp_delRequest),
        (u'delResponse', __LDAPMessage_protocolOp_delResponse),
        (u'modDNRequest', __LDAPMessage_protocolOp_modDNRequest),
        (u'modDNResponse', __LDAPMessage_protocolOp_modDNResponse),
        (u'compareRequest', __LDAPMessage_protocolOp_compareRequest),
        (u'compareResponse', __LDAPMessage_protocolOp_compareResponse),
        (u'abandonRequest', __LDAPMessage_protocolOp_abandonRequest),
        (u'extendedReq', __LDAPMessage_protocolOp_extendedReq),
        (u'extendedResp', __LDAPMessage_protocolOp_extendedResp),
        (u'intermediateResponse', __LDAPMessage_protocolOp_intermediateResponse),
        ])
    _LDAPMessage_protocolOp._ext = [u'intermediateResponse']
    _LDAPMessage_controls = SEQ_OF(name=u'controls', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Controls')), opt=True)
    LDAPMessage._cont = ASN1Dict([
        (u'messageID', _LDAPMessage_messageID),
        (u'protocolOp', _LDAPMessage_protocolOp),
        (u'controls', _LDAPMessage_controls),
        ])
    LDAPMessage._ext = []
    
    #-----< MessageID >-----#
    MessageID = INT(name=u'MessageID', mode=MODE_TYPE)
    MessageID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    
    #-----< maxInt >-----#
    maxInt = INT(name=u'maxInt', mode=MODE_VALUE)
    maxInt._val = 2147483647
    
    #-----< LDAPString >-----#
    LDAPString = OCT_STR(name=u'LDAPString', mode=MODE_TYPE)
    
    #-----< LDAPOID >-----#
    LDAPOID = OCT_STR(name=u'LDAPOID', mode=MODE_TYPE)
    
    #-----< LDAPDN >-----#
    LDAPDN = OCT_STR(name=u'LDAPDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< RelativeLDAPDN >-----#
    RelativeLDAPDN = OCT_STR(name=u'RelativeLDAPDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< AttributeDescription >-----#
    AttributeDescription = OCT_STR(name=u'AttributeDescription', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< AttributeValue >-----#
    AttributeValue = OCT_STR(name=u'AttributeValue', mode=MODE_TYPE)
    
    #-----< AttributeValueAssertion >-----#
    AttributeValueAssertion = SEQ(name=u'AttributeValueAssertion', mode=MODE_TYPE)
    _AttributeValueAssertion_attributeDesc = OCT_STR(name=u'attributeDesc', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _AttributeValueAssertion_assertionValue = OCT_STR(name=u'assertionValue', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    AttributeValueAssertion._cont = ASN1Dict([
        (u'attributeDesc', _AttributeValueAssertion_attributeDesc),
        (u'assertionValue', _AttributeValueAssertion_assertionValue),
        ])
    AttributeValueAssertion._ext = []
    
    #-----< AssertionValue >-----#
    AssertionValue = OCT_STR(name=u'AssertionValue', mode=MODE_TYPE)
    
    #-----< PartialAttribute >-----#
    PartialAttribute = SEQ(name=u'PartialAttribute', mode=MODE_TYPE)
    _PartialAttribute_type = OCT_STR(name=u'type', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _PartialAttribute_vals = SET_OF(name=u'vals', mode=MODE_TYPE)
    __PartialAttribute_vals_value = OCT_STR(name=u'value', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValue')))
    _PartialAttribute_vals._cont = __PartialAttribute_vals_value
    PartialAttribute._cont = ASN1Dict([
        (u'type', _PartialAttribute_type),
        (u'vals', _PartialAttribute_vals),
        ])
    PartialAttribute._ext = []
    
    #-----< Attribute >-----#
    Attribute = SEQ(name=u'Attribute', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttribute')))
    
    #-----< MatchingRuleId >-----#
    MatchingRuleId = OCT_STR(name=u'MatchingRuleId', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< LDAPResult >-----#
    LDAPResult = SEQ(name=u'LDAPResult', mode=MODE_TYPE)
    _LDAPResult_resultCode = ENUM(name=u'resultCode', mode=MODE_TYPE)
    _LDAPResult_resultCode._cont = ASN1Dict([(u'success', 0), (u'operationsError', 1), (u'protocolError', 2), (u'timeLimitExceeded', 3), (u'sizeLimitExceeded', 4), (u'compareFalse', 5), (u'compareTrue', 6), (u'authMethodNotSupported', 7), (u'strongerAuthRequired', 8), (u'referral', 10), (u'adminLimitExceeded', 11), (u'unavailableCriticalExtension', 12), (u'confidentialityRequired', 13), (u'saslBindInProgress', 14), (u'noSuchAttribute', 16), (u'undefinedAttributeType', 17), (u'inappropriateMatching', 18), (u'constraintViolation', 19), (u'attributeOrValueExists', 20), (u'invalidAttributeSyntax', 21), (u'noSuchObject', 32), (u'aliasProblem', 33), (u'invalidDNSyntax', 34), (u'aliasDereferencingProblem', 36), (u'inappropriateAuthentication', 48), (u'invalidCredentials', 49), (u'insufficientAccessRights', 50), (u'busy', 51), (u'unavailable', 52), (u'unwillingToPerform', 53), (u'loopDetect', 54), (u'namingViolation', 64), (u'objectClassViolation', 65), (u'notAllowedOnNonLeaf', 66), (u'notAllowedOnRDN', 67), (u'entryAlreadyExists', 68), (u'objectClassModsProhibited', 69), (u'affectsMultipleDSAs', 71), (u'other', 80)])
    _LDAPResult_resultCode._ext = []
    _LDAPResult_matchedDN = OCT_STR(name=u'matchedDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _LDAPResult_diagnosticMessage = OCT_STR(name=u'diagnosticMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _LDAPResult_referral = SEQ_OF(name=u'referral', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Referral')), opt=True)
    LDAPResult._cont = ASN1Dict([
        (u'resultCode', _LDAPResult_resultCode),
        (u'matchedDN', _LDAPResult_matchedDN),
        (u'diagnosticMessage', _LDAPResult_diagnosticMessage),
        (u'referral', _LDAPResult_referral),
        ])
    LDAPResult._ext = []
    
    #-----< Referral >-----#
    Referral = SEQ_OF(name=u'Referral', mode=MODE_TYPE)
    _Referral_uri = OCT_STR(name=u'uri', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'URI')))
    Referral._cont = _Referral_uri
    Referral._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< URI >-----#
    URI = OCT_STR(name=u'URI', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    
    #-----< Controls >-----#
    Controls = SEQ_OF(name=u'Controls', mode=MODE_TYPE)
    _Controls_control = SEQ(name=u'control', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Control')))
    Controls._cont = _Controls_control
    
    #-----< Control >-----#
    Control = SEQ(name=u'Control', mode=MODE_TYPE)
    _Control_controlType = OCT_STR(name=u'controlType', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')))
    _Control_criticality = BOOL(name=u'criticality', mode=MODE_TYPE, default=False)
    _Control_controlValue = OCT_STR(name=u'controlValue', mode=MODE_TYPE, opt=True)
    Control._cont = ASN1Dict([
        (u'controlType', _Control_controlType),
        (u'criticality', _Control_criticality),
        (u'controlValue', _Control_controlValue),
        ])
    Control._ext = []
    
    #-----< BindRequest >-----#
    BindRequest = SEQ(name=u'BindRequest', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _BindRequest_version = INT(name=u'version', mode=MODE_TYPE)
    _BindRequest_version._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    _BindRequest_name = OCT_STR(name=u'name', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _BindRequest_authentication = CHOICE(name=u'authentication', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AuthenticationChoice')))
    BindRequest._cont = ASN1Dict([
        (u'version', _BindRequest_version),
        (u'name', _BindRequest_name),
        (u'authentication', _BindRequest_authentication),
        ])
    BindRequest._ext = []
    
    #-----< AuthenticationChoice >-----#
    AuthenticationChoice = CHOICE(name=u'AuthenticationChoice', mode=MODE_TYPE)
    _AuthenticationChoice_simple = OCT_STR(name=u'simple', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuthenticationChoice_sasl = SEQ(name=u'sasl', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SaslCredentials')))
    AuthenticationChoice._cont = ASN1Dict([
        (u'simple', _AuthenticationChoice_simple),
        (u'sasl', _AuthenticationChoice_sasl),
        ])
    AuthenticationChoice._ext = []
    
    #-----< SaslCredentials >-----#
    SaslCredentials = SEQ(name=u'SaslCredentials', mode=MODE_TYPE)
    _SaslCredentials_mechanism = OCT_STR(name=u'mechanism', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _SaslCredentials_credentials = OCT_STR(name=u'credentials', mode=MODE_TYPE, opt=True)
    SaslCredentials._cont = ASN1Dict([
        (u'mechanism', _SaslCredentials_mechanism),
        (u'credentials', _SaslCredentials_credentials),
        ])
    SaslCredentials._ext = []
    
    #-----< BindResponse >-----#
    BindResponse = SEQ(name=u'BindResponse', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    _BindResponse_resultCode = ENUM(name=u'resultCode', mode=MODE_TYPE)
    _BindResponse_resultCode._cont = ASN1Dict([(u'success', 0), (u'operationsError', 1), (u'protocolError', 2), (u'timeLimitExceeded', 3), (u'sizeLimitExceeded', 4), (u'compareFalse', 5), (u'compareTrue', 6), (u'authMethodNotSupported', 7), (u'strongerAuthRequired', 8), (u'referral', 10), (u'adminLimitExceeded', 11), (u'unavailableCriticalExtension', 12), (u'confidentialityRequired', 13), (u'saslBindInProgress', 14), (u'noSuchAttribute', 16), (u'undefinedAttributeType', 17), (u'inappropriateMatching', 18), (u'constraintViolation', 19), (u'attributeOrValueExists', 20), (u'invalidAttributeSyntax', 21), (u'noSuchObject', 32), (u'aliasProblem', 33), (u'invalidDNSyntax', 34), (u'aliasDereferencingProblem', 36), (u'inappropriateAuthentication', 48), (u'invalidCredentials', 49), (u'insufficientAccessRights', 50), (u'busy', 51), (u'unavailable', 52), (u'unwillingToPerform', 53), (u'loopDetect', 54), (u'namingViolation', 64), (u'objectClassViolation', 65), (u'notAllowedOnNonLeaf', 66), (u'notAllowedOnRDN', 67), (u'entryAlreadyExists', 68), (u'objectClassModsProhibited', 69), (u'affectsMultipleDSAs', 71), (u'other', 80)])
    _BindResponse_resultCode._ext = []
    _BindResponse_matchedDN = OCT_STR(name=u'matchedDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _BindResponse_diagnosticMessage = OCT_STR(name=u'diagnosticMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _BindResponse_referral = SEQ_OF(name=u'referral', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Referral')), opt=True)
    _BindResponse_serverSaslCreds = OCT_STR(name=u'serverSaslCreds', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    BindResponse._cont = ASN1Dict([
        (u'resultCode', _BindResponse_resultCode),
        (u'matchedDN', _BindResponse_matchedDN),
        (u'diagnosticMessage', _BindResponse_diagnosticMessage),
        (u'referral', _BindResponse_referral),
        (u'serverSaslCreds', _BindResponse_serverSaslCreds),
        ])
    BindResponse._ext = []
    
    #-----< UnbindRequest >-----#
    UnbindRequest = NULL(name=u'UnbindRequest', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT))
    
    #-----< SearchRequest >-----#
    SearchRequest = SEQ(name=u'SearchRequest', mode=MODE_TYPE, tag=(3, TAG_APPLICATION, TAG_IMPLICIT))
    _SearchRequest_baseObject = OCT_STR(name=u'baseObject', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _SearchRequest_scope = ENUM(name=u'scope', mode=MODE_TYPE)
    _SearchRequest_scope._cont = ASN1Dict([(u'baseObject', 0), (u'singleLevel', 1), (u'wholeSubtree', 2)])
    _SearchRequest_scope._ext = []
    _SearchRequest_derefAliases = ENUM(name=u'derefAliases', mode=MODE_TYPE)
    _SearchRequest_derefAliases._cont = ASN1Dict([(u'neverDerefAliases', 0), (u'derefInSearching', 1), (u'derefFindingBaseObj', 2), (u'derefAlways', 3)])
    _SearchRequest_derefAliases._ext = []
    _SearchRequest_sizeLimit = INT(name=u'sizeLimit', mode=MODE_TYPE)
    _SearchRequest_sizeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    _SearchRequest_timeLimit = INT(name=u'timeLimit', mode=MODE_TYPE)
    _SearchRequest_timeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    _SearchRequest_typesOnly = BOOL(name=u'typesOnly', mode=MODE_TYPE)
    _SearchRequest_filter = CHOICE(name=u'filter', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _SearchRequest_attributes = SEQ_OF(name=u'attributes', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeSelection')))
    SearchRequest._cont = ASN1Dict([
        (u'baseObject', _SearchRequest_baseObject),
        (u'scope', _SearchRequest_scope),
        (u'derefAliases', _SearchRequest_derefAliases),
        (u'sizeLimit', _SearchRequest_sizeLimit),
        (u'timeLimit', _SearchRequest_timeLimit),
        (u'typesOnly', _SearchRequest_typesOnly),
        (u'filter', _SearchRequest_filter),
        (u'attributes', _SearchRequest_attributes),
        ])
    SearchRequest._ext = []
    
    #-----< AttributeSelection >-----#
    AttributeSelection = SEQ_OF(name=u'AttributeSelection', mode=MODE_TYPE)
    _AttributeSelection_selector = OCT_STR(name=u'selector', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    AttributeSelection._cont = _AttributeSelection_selector
    
    #-----< Filter >-----#
    Filter = CHOICE(name=u'Filter', mode=MODE_TYPE)
    _Filter_and_ = SET_OF(name=u'and', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Filter_and__filter = CHOICE(name=u'filter', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _Filter_and_._cont = __Filter_and__filter
    _Filter_and_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Filter_or_ = SET_OF(name=u'or', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Filter_or__filter = CHOICE(name=u'filter', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _Filter_or_._cont = __Filter_or__filter
    _Filter_or_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Filter_not_ = CHOICE(name=u'not', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Filter')))
    _Filter_equalityMatch = SEQ(name=u'equalityMatch', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_substrings = SEQ(name=u'substrings', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'SubstringFilter')))
    _Filter_greaterOrEqual = SEQ(name=u'greaterOrEqual', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_lessOrEqual = SEQ(name=u'lessOrEqual', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_present = OCT_STR(name=u'present', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _Filter_approxMatch = SEQ(name=u'approxMatch', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    _Filter_extensibleMatch = SEQ(name=u'extensibleMatch', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MatchingRuleAssertion')))
    Filter._cont = ASN1Dict([
        (u'and', _Filter_and_),
        (u'or', _Filter_or_),
        (u'not', _Filter_not_),
        (u'equalityMatch', _Filter_equalityMatch),
        (u'substrings', _Filter_substrings),
        (u'greaterOrEqual', _Filter_greaterOrEqual),
        (u'lessOrEqual', _Filter_lessOrEqual),
        (u'present', _Filter_present),
        (u'approxMatch', _Filter_approxMatch),
        (u'extensibleMatch', _Filter_extensibleMatch),
        ])
    Filter._ext = []
    
    #-----< SubstringFilter >-----#
    SubstringFilter = SEQ(name=u'SubstringFilter', mode=MODE_TYPE)
    _SubstringFilter_type = OCT_STR(name=u'type', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')))
    _SubstringFilter_substrings = SEQ_OF(name=u'substrings', mode=MODE_TYPE)
    __SubstringFilter_substrings_substring = CHOICE(name=u'substring', mode=MODE_TYPE)
    ___SubstringFilter_substrings_substring_initial = OCT_STR(name=u'initial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    ___SubstringFilter_substrings_substring_any = OCT_STR(name=u'any', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    ___SubstringFilter_substrings_substring_final = OCT_STR(name=u'final', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    __SubstringFilter_substrings_substring._cont = ASN1Dict([
        (u'initial', ___SubstringFilter_substrings_substring_initial),
        (u'any', ___SubstringFilter_substrings_substring_any),
        (u'final', ___SubstringFilter_substrings_substring_final),
        ])
    __SubstringFilter_substrings_substring._ext = []
    _SubstringFilter_substrings._cont = __SubstringFilter_substrings_substring
    _SubstringFilter_substrings._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    SubstringFilter._cont = ASN1Dict([
        (u'type', _SubstringFilter_type),
        (u'substrings', _SubstringFilter_substrings),
        ])
    SubstringFilter._ext = []
    
    #-----< MatchingRuleAssertion >-----#
    MatchingRuleAssertion = SEQ(name=u'MatchingRuleAssertion', mode=MODE_TYPE)
    _MatchingRuleAssertion_matchingRule = OCT_STR(name=u'matchingRule', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MatchingRuleId')), opt=True)
    _MatchingRuleAssertion_type = OCT_STR(name=u'type', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeDescription')), opt=True)
    _MatchingRuleAssertion_matchValue = OCT_STR(name=u'matchValue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AssertionValue')))
    _MatchingRuleAssertion_dnAttributes = BOOL(name=u'dnAttributes', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    MatchingRuleAssertion._cont = ASN1Dict([
        (u'matchingRule', _MatchingRuleAssertion_matchingRule),
        (u'type', _MatchingRuleAssertion_type),
        (u'matchValue', _MatchingRuleAssertion_matchValue),
        (u'dnAttributes', _MatchingRuleAssertion_dnAttributes),
        ])
    MatchingRuleAssertion._ext = []
    
    #-----< SearchResultEntry >-----#
    SearchResultEntry = SEQ(name=u'SearchResultEntry', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT))
    _SearchResultEntry_objectName = OCT_STR(name=u'objectName', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _SearchResultEntry_attributes = SEQ_OF(name=u'attributes', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttributeList')))
    SearchResultEntry._cont = ASN1Dict([
        (u'objectName', _SearchResultEntry_objectName),
        (u'attributes', _SearchResultEntry_attributes),
        ])
    SearchResultEntry._ext = []
    
    #-----< PartialAttributeList >-----#
    PartialAttributeList = SEQ_OF(name=u'PartialAttributeList', mode=MODE_TYPE)
    _PartialAttributeList_partialAttribute = SEQ(name=u'partialAttribute', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttribute')))
    PartialAttributeList._cont = _PartialAttributeList_partialAttribute
    
    #-----< SearchResultReference >-----#
    SearchResultReference = SEQ_OF(name=u'SearchResultReference', mode=MODE_TYPE, tag=(19, TAG_APPLICATION, TAG_IMPLICIT))
    _SearchResultReference_uri = OCT_STR(name=u'uri', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'URI')))
    SearchResultReference._cont = _SearchResultReference_uri
    SearchResultReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< SearchResultDone >-----#
    SearchResultDone = SEQ(name=u'SearchResultDone', mode=MODE_TYPE, tag=(5, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< ModifyRequest >-----#
    ModifyRequest = SEQ(name=u'ModifyRequest', mode=MODE_TYPE, tag=(6, TAG_APPLICATION, TAG_IMPLICIT))
    _ModifyRequest_object = OCT_STR(name=u'object', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _ModifyRequest_changes = SEQ_OF(name=u'changes', mode=MODE_TYPE)
    __ModifyRequest_changes_change = SEQ(name=u'change', mode=MODE_TYPE)
    ___ModifyRequest_changes_change_operation = ENUM(name=u'operation', mode=MODE_TYPE)
    ___ModifyRequest_changes_change_operation._cont = ASN1Dict([(u'add', 0), (u'delete', 1), (u'replace', 2)])
    ___ModifyRequest_changes_change_operation._ext = []
    ___ModifyRequest_changes_change_modification = SEQ(name=u'modification', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'PartialAttribute')))
    __ModifyRequest_changes_change._cont = ASN1Dict([
        (u'operation', ___ModifyRequest_changes_change_operation),
        (u'modification', ___ModifyRequest_changes_change_modification),
        ])
    __ModifyRequest_changes_change._ext = []
    _ModifyRequest_changes._cont = __ModifyRequest_changes_change
    ModifyRequest._cont = ASN1Dict([
        (u'object', _ModifyRequest_object),
        (u'changes', _ModifyRequest_changes),
        ])
    ModifyRequest._ext = []
    
    #-----< ModifyResponse >-----#
    ModifyResponse = SEQ(name=u'ModifyResponse', mode=MODE_TYPE, tag=(7, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< AddRequest >-----#
    AddRequest = SEQ(name=u'AddRequest', mode=MODE_TYPE, tag=(8, TAG_APPLICATION, TAG_IMPLICIT))
    _AddRequest_entry = OCT_STR(name=u'entry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _AddRequest_attributes = SEQ_OF(name=u'attributes', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeList')))
    AddRequest._cont = ASN1Dict([
        (u'entry', _AddRequest_entry),
        (u'attributes', _AddRequest_attributes),
        ])
    AddRequest._ext = []
    
    #-----< AttributeList >-----#
    AttributeList = SEQ_OF(name=u'AttributeList', mode=MODE_TYPE)
    _AttributeList_attribute = SEQ(name=u'attribute', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Attribute')))
    AttributeList._cont = _AttributeList_attribute
    
    #-----< AddResponse >-----#
    AddResponse = SEQ(name=u'AddResponse', mode=MODE_TYPE, tag=(9, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< DelRequest >-----#
    DelRequest = OCT_STR(name=u'DelRequest', mode=MODE_TYPE, tag=(10, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    
    #-----< DelResponse >-----#
    DelResponse = SEQ(name=u'DelResponse', mode=MODE_TYPE, tag=(11, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< ModifyDNRequest >-----#
    ModifyDNRequest = SEQ(name=u'ModifyDNRequest', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT))
    _ModifyDNRequest_entry = OCT_STR(name=u'entry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _ModifyDNRequest_newrdn = OCT_STR(name=u'newrdn', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'RelativeLDAPDN')))
    _ModifyDNRequest_deleteoldrdn = BOOL(name=u'deleteoldrdn', mode=MODE_TYPE)
    _ModifyDNRequest_newSuperior = OCT_STR(name=u'newSuperior', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')), opt=True)
    ModifyDNRequest._cont = ASN1Dict([
        (u'entry', _ModifyDNRequest_entry),
        (u'newrdn', _ModifyDNRequest_newrdn),
        (u'deleteoldrdn', _ModifyDNRequest_deleteoldrdn),
        (u'newSuperior', _ModifyDNRequest_newSuperior),
        ])
    ModifyDNRequest._ext = []
    
    #-----< ModifyDNResponse >-----#
    ModifyDNResponse = SEQ(name=u'ModifyDNResponse', mode=MODE_TYPE, tag=(13, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< CompareRequest >-----#
    CompareRequest = SEQ(name=u'CompareRequest', mode=MODE_TYPE, tag=(14, TAG_APPLICATION, TAG_IMPLICIT))
    _CompareRequest_entry = OCT_STR(name=u'entry', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _CompareRequest_ava = SEQ(name=u'ava', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'AttributeValueAssertion')))
    CompareRequest._cont = ASN1Dict([
        (u'entry', _CompareRequest_entry),
        (u'ava', _CompareRequest_ava),
        ])
    CompareRequest._ext = []
    
    #-----< CompareResponse >-----#
    CompareResponse = SEQ(name=u'CompareResponse', mode=MODE_TYPE, tag=(15, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPResult')))
    
    #-----< AbandonRequest >-----#
    AbandonRequest = INT(name=u'AbandonRequest', mode=MODE_TYPE, tag=(16, TAG_APPLICATION, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'MessageID')))
    
    #-----< ExtendedRequest >-----#
    ExtendedRequest = SEQ(name=u'ExtendedRequest', mode=MODE_TYPE, tag=(23, TAG_APPLICATION, TAG_IMPLICIT))
    _ExtendedRequest_requestName = OCT_STR(name=u'requestName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')))
    _ExtendedRequest_requestValue = OCT_STR(name=u'requestValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ExtendedRequest._cont = ASN1Dict([
        (u'requestName', _ExtendedRequest_requestName),
        (u'requestValue', _ExtendedRequest_requestValue),
        ])
    ExtendedRequest._ext = []
    
    #-----< ExtendedResponse >-----#
    ExtendedResponse = SEQ(name=u'ExtendedResponse', mode=MODE_TYPE, tag=(24, TAG_APPLICATION, TAG_IMPLICIT))
    _ExtendedResponse_resultCode = ENUM(name=u'resultCode', mode=MODE_TYPE)
    _ExtendedResponse_resultCode._cont = ASN1Dict([(u'success', 0), (u'operationsError', 1), (u'protocolError', 2), (u'timeLimitExceeded', 3), (u'sizeLimitExceeded', 4), (u'compareFalse', 5), (u'compareTrue', 6), (u'authMethodNotSupported', 7), (u'strongerAuthRequired', 8), (u'referral', 10), (u'adminLimitExceeded', 11), (u'unavailableCriticalExtension', 12), (u'confidentialityRequired', 13), (u'saslBindInProgress', 14), (u'noSuchAttribute', 16), (u'undefinedAttributeType', 17), (u'inappropriateMatching', 18), (u'constraintViolation', 19), (u'attributeOrValueExists', 20), (u'invalidAttributeSyntax', 21), (u'noSuchObject', 32), (u'aliasProblem', 33), (u'invalidDNSyntax', 34), (u'aliasDereferencingProblem', 36), (u'inappropriateAuthentication', 48), (u'invalidCredentials', 49), (u'insufficientAccessRights', 50), (u'busy', 51), (u'unavailable', 52), (u'unwillingToPerform', 53), (u'loopDetect', 54), (u'namingViolation', 64), (u'objectClassViolation', 65), (u'notAllowedOnNonLeaf', 66), (u'notAllowedOnRDN', 67), (u'entryAlreadyExists', 68), (u'objectClassModsProhibited', 69), (u'affectsMultipleDSAs', 71), (u'other', 80)])
    _ExtendedResponse_resultCode._ext = []
    _ExtendedResponse_matchedDN = OCT_STR(name=u'matchedDN', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPDN')))
    _ExtendedResponse_diagnosticMessage = OCT_STR(name=u'diagnosticMessage', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPString')))
    _ExtendedResponse_referral = SEQ_OF(name=u'referral', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'Referral')), opt=True)
    _ExtendedResponse_responseName = OCT_STR(name=u'responseName', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')), opt=True)
    _ExtendedResponse_responseValue = OCT_STR(name=u'responseValue', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ExtendedResponse._cont = ASN1Dict([
        (u'resultCode', _ExtendedResponse_resultCode),
        (u'matchedDN', _ExtendedResponse_matchedDN),
        (u'diagnosticMessage', _ExtendedResponse_diagnosticMessage),
        (u'referral', _ExtendedResponse_referral),
        (u'responseName', _ExtendedResponse_responseName),
        (u'responseValue', _ExtendedResponse_responseValue),
        ])
    ExtendedResponse._ext = []
    
    #-----< IntermediateResponse >-----#
    IntermediateResponse = SEQ(name=u'IntermediateResponse', mode=MODE_TYPE, tag=(25, TAG_APPLICATION, TAG_IMPLICIT))
    _IntermediateResponse_responseName = OCT_STR(name=u'responseName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPOID')), opt=True)
    _IntermediateResponse_responseValue = OCT_STR(name=u'responseValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    IntermediateResponse._cont = ASN1Dict([
        (u'responseName', _IntermediateResponse_responseName),
        (u'responseValue', _IntermediateResponse_responseValue),
        ])
    IntermediateResponse._ext = []
    
    _all_ = [
        _LDAPMessage_messageID,
        __LDAPMessage_protocolOp_bindRequest,
        __LDAPMessage_protocolOp_bindResponse,
        __LDAPMessage_protocolOp_unbindRequest,
        __LDAPMessage_protocolOp_searchRequest,
        __LDAPMessage_protocolOp_searchResEntry,
        __LDAPMessage_protocolOp_searchResDone,
        __LDAPMessage_protocolOp_searchResRef,
        __LDAPMessage_protocolOp_modifyRequest,
        __LDAPMessage_protocolOp_modifyResponse,
        __LDAPMessage_protocolOp_addRequest,
        __LDAPMessage_protocolOp_addResponse,
        __LDAPMessage_protocolOp_delRequest,
        __LDAPMessage_protocolOp_delResponse,
        __LDAPMessage_protocolOp_modDNRequest,
        __LDAPMessage_protocolOp_modDNResponse,
        __LDAPMessage_protocolOp_compareRequest,
        __LDAPMessage_protocolOp_compareResponse,
        __LDAPMessage_protocolOp_abandonRequest,
        __LDAPMessage_protocolOp_extendedReq,
        __LDAPMessage_protocolOp_extendedResp,
        __LDAPMessage_protocolOp_intermediateResponse,
        _LDAPMessage_protocolOp,
        _LDAPMessage_controls,
        LDAPMessage,
        MessageID,
        maxInt,
        LDAPString,
        LDAPOID,
        LDAPDN,
        RelativeLDAPDN,
        AttributeDescription,
        AttributeValue,
        _AttributeValueAssertion_attributeDesc,
        _AttributeValueAssertion_assertionValue,
        AttributeValueAssertion,
        AssertionValue,
        _PartialAttribute_type,
        __PartialAttribute_vals_value,
        _PartialAttribute_vals,
        PartialAttribute,
        Attribute,
        MatchingRuleId,
        _LDAPResult_resultCode,
        _LDAPResult_matchedDN,
        _LDAPResult_diagnosticMessage,
        _LDAPResult_referral,
        LDAPResult,
        _Referral_uri,
        Referral,
        URI,
        _Controls_control,
        Controls,
        _Control_controlType,
        _Control_criticality,
        _Control_controlValue,
        Control,
        _BindRequest_version,
        _BindRequest_name,
        _BindRequest_authentication,
        BindRequest,
        _AuthenticationChoice_simple,
        _AuthenticationChoice_sasl,
        AuthenticationChoice,
        _SaslCredentials_mechanism,
        _SaslCredentials_credentials,
        SaslCredentials,
        _BindResponse_resultCode,
        _BindResponse_matchedDN,
        _BindResponse_diagnosticMessage,
        _BindResponse_referral,
        _BindResponse_serverSaslCreds,
        BindResponse,
        UnbindRequest,
        _SearchRequest_baseObject,
        _SearchRequest_scope,
        _SearchRequest_derefAliases,
        _SearchRequest_sizeLimit,
        _SearchRequest_timeLimit,
        _SearchRequest_typesOnly,
        _SearchRequest_filter,
        _SearchRequest_attributes,
        SearchRequest,
        _AttributeSelection_selector,
        AttributeSelection,
        __Filter_and__filter,
        _Filter_and_,
        __Filter_or__filter,
        _Filter_or_,
        _Filter_not_,
        _Filter_equalityMatch,
        _Filter_substrings,
        _Filter_greaterOrEqual,
        _Filter_lessOrEqual,
        _Filter_present,
        _Filter_approxMatch,
        _Filter_extensibleMatch,
        Filter,
        _SubstringFilter_type,
        ___SubstringFilter_substrings_substring_initial,
        ___SubstringFilter_substrings_substring_any,
        ___SubstringFilter_substrings_substring_final,
        __SubstringFilter_substrings_substring,
        _SubstringFilter_substrings,
        SubstringFilter,
        _MatchingRuleAssertion_matchingRule,
        _MatchingRuleAssertion_type,
        _MatchingRuleAssertion_matchValue,
        _MatchingRuleAssertion_dnAttributes,
        MatchingRuleAssertion,
        _SearchResultEntry_objectName,
        _SearchResultEntry_attributes,
        SearchResultEntry,
        _PartialAttributeList_partialAttribute,
        PartialAttributeList,
        _SearchResultReference_uri,
        SearchResultReference,
        SearchResultDone,
        _ModifyRequest_object,
        ___ModifyRequest_changes_change_operation,
        ___ModifyRequest_changes_change_modification,
        __ModifyRequest_changes_change,
        _ModifyRequest_changes,
        ModifyRequest,
        ModifyResponse,
        _AddRequest_entry,
        _AddRequest_attributes,
        AddRequest,
        _AttributeList_attribute,
        AttributeList,
        AddResponse,
        DelRequest,
        DelResponse,
        _ModifyDNRequest_entry,
        _ModifyDNRequest_newrdn,
        _ModifyDNRequest_deleteoldrdn,
        _ModifyDNRequest_newSuperior,
        ModifyDNRequest,
        ModifyDNResponse,
        _CompareRequest_entry,
        _CompareRequest_ava,
        CompareRequest,
        CompareResponse,
        AbandonRequest,
        _ExtendedRequest_requestName,
        _ExtendedRequest_requestValue,
        ExtendedRequest,
        _ExtendedResponse_resultCode,
        _ExtendedResponse_matchedDN,
        _ExtendedResponse_diagnosticMessage,
        _ExtendedResponse_referral,
        _ExtendedResponse_responseName,
        _ExtendedResponse_responseValue,
        ExtendedResponse,
        _IntermediateResponse_responseName,
        _IntermediateResponse_responseValue,
        IntermediateResponse,
    ]

class MAP_BS_Code:

    _name_  = u'MAP-BS-Code'
    _oid_   = [0, 4, 0, 0, 1, 3, 20, 19]
    
    _obj_ = [
        u'BearerServiceCode',
        u'Ext-BearerServiceCode',
        u'allBearerServices',
        u'allDataCDA-Services',
        u'dataCDA-300bps',
        u'dataCDA-1200bps',
        u'dataCDA-1200-75bps',
        u'dataCDA-2400bps',
        u'dataCDA-4800bps',
        u'dataCDA-9600bps',
        u'general-dataCDA',
        u'allDataCDS-Services',
        u'dataCDS-1200bps',
        u'dataCDS-2400bps',
        u'dataCDS-4800bps',
        u'dataCDS-9600bps',
        u'general-dataCDS',
        u'allPadAccessCA-Services',
        u'padAccessCA-300bps',
        u'padAccessCA-1200bps',
        u'padAccessCA-1200-75bps',
        u'padAccessCA-2400bps',
        u'padAccessCA-4800bps',
        u'padAccessCA-9600bps',
        u'general-padAccessCA',
        u'allDataPDS-Services',
        u'dataPDS-2400bps',
        u'dataPDS-4800bps',
        u'dataPDS-9600bps',
        u'general-dataPDS',
        u'allAlternateSpeech-DataCDA',
        u'allAlternateSpeech-DataCDS',
        u'allSpeechFollowedByDataCDA',
        u'allSpeechFollowedByDataCDS',
        u'allDataCircuitAsynchronous',
        u'allAsynchronousServices',
        u'allDataCircuitSynchronous',
        u'allSynchronousServices',
        u'allPLMN-specificBS',
        u'plmn-specificBS-1',
        u'plmn-specificBS-2',
        u'plmn-specificBS-3',
        u'plmn-specificBS-4',
        u'plmn-specificBS-5',
        u'plmn-specificBS-6',
        u'plmn-specificBS-7',
        u'plmn-specificBS-8',
        u'plmn-specificBS-9',
        u'plmn-specificBS-A',
        u'plmn-specificBS-B',
        u'plmn-specificBS-C',
        u'plmn-specificBS-D',
        u'plmn-specificBS-E',
        u'plmn-specificBS-F',
        ]
    _type_ = [
        u'BearerServiceCode',
        u'Ext-BearerServiceCode',
        ]
    _set_ = [
        ]
    _val_ = [
        u'allBearerServices',
        u'allDataCDA-Services',
        u'dataCDA-300bps',
        u'dataCDA-1200bps',
        u'dataCDA-1200-75bps',
        u'dataCDA-2400bps',
        u'dataCDA-4800bps',
        u'dataCDA-9600bps',
        u'general-dataCDA',
        u'allDataCDS-Services',
        u'dataCDS-1200bps',
        u'dataCDS-2400bps',
        u'dataCDS-4800bps',
        u'dataCDS-9600bps',
        u'general-dataCDS',
        u'allPadAccessCA-Services',
        u'padAccessCA-300bps',
        u'padAccessCA-1200bps',
        u'padAccessCA-1200-75bps',
        u'padAccessCA-2400bps',
        u'padAccessCA-4800bps',
        u'padAccessCA-9600bps',
        u'general-padAccessCA',
        u'allDataPDS-Services',
        u'dataPDS-2400bps',
        u'dataPDS-4800bps',
        u'dataPDS-9600bps',
        u'general-dataPDS',
        u'allAlternateSpeech-DataCDA',
        u'allAlternateSpeech-DataCDS',
        u'allSpeechFollowedByDataCDA',
        u'allSpeechFollowedByDataCDS',
        u'allDataCircuitAsynchronous',
        u'allAsynchronousServices',
        u'allDataCircuitSynchronous',
        u'allSynchronousServices',
        u'allPLMN-specificBS',
        u'plmn-specificBS-1',
        u'plmn-specificBS-2',
        u'plmn-specificBS-3',
        u'plmn-specificBS-4',
        u'plmn-specificBS-5',
        u'plmn-specificBS-6',
        u'plmn-specificBS-7',
        u'plmn-specificBS-8',
        u'plmn-specificBS-9',
        u'plmn-specificBS-A',
        u'plmn-specificBS-B',
        u'plmn-specificBS-C',
        u'plmn-specificBS-D',
        u'plmn-specificBS-E',
        u'plmn-specificBS-F',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< BearerServiceCode >-----#
    BearerServiceCode = OCT_STR(name=u'BearerServiceCode', mode=MODE_TYPE)
    BearerServiceCode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Ext-BearerServiceCode >-----#
    Ext_BearerServiceCode = OCT_STR(name=u'Ext-BearerServiceCode', mode=MODE_TYPE)
    Ext_BearerServiceCode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< allBearerServices >-----#
    allBearerServices = OCT_STR(name=u'allBearerServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allBearerServices._val = b'\x00'
    
    #-----< allDataCDA-Services >-----#
    allDataCDA_Services = OCT_STR(name=u'allDataCDA-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCDA_Services._val = b'\x10'
    
    #-----< dataCDA-300bps >-----#
    dataCDA_300bps = OCT_STR(name=u'dataCDA-300bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_300bps._val = b'\x11'
    
    #-----< dataCDA-1200bps >-----#
    dataCDA_1200bps = OCT_STR(name=u'dataCDA-1200bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_1200bps._val = b'\x12'
    
    #-----< dataCDA-1200-75bps >-----#
    dataCDA_1200_75bps = OCT_STR(name=u'dataCDA-1200-75bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_1200_75bps._val = b'\x13'
    
    #-----< dataCDA-2400bps >-----#
    dataCDA_2400bps = OCT_STR(name=u'dataCDA-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_2400bps._val = b'\x14'
    
    #-----< dataCDA-4800bps >-----#
    dataCDA_4800bps = OCT_STR(name=u'dataCDA-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_4800bps._val = b'\x15'
    
    #-----< dataCDA-9600bps >-----#
    dataCDA_9600bps = OCT_STR(name=u'dataCDA-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDA_9600bps._val = b'\x16'
    
    #-----< general-dataCDA >-----#
    general_dataCDA = OCT_STR(name=u'general-dataCDA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_dataCDA._val = b'\x17'
    
    #-----< allDataCDS-Services >-----#
    allDataCDS_Services = OCT_STR(name=u'allDataCDS-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCDS_Services._val = b'\x18'
    
    #-----< dataCDS-1200bps >-----#
    dataCDS_1200bps = OCT_STR(name=u'dataCDS-1200bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_1200bps._val = b'\x1a'
    
    #-----< dataCDS-2400bps >-----#
    dataCDS_2400bps = OCT_STR(name=u'dataCDS-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_2400bps._val = b'\x1c'
    
    #-----< dataCDS-4800bps >-----#
    dataCDS_4800bps = OCT_STR(name=u'dataCDS-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_4800bps._val = b'\x1d'
    
    #-----< dataCDS-9600bps >-----#
    dataCDS_9600bps = OCT_STR(name=u'dataCDS-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataCDS_9600bps._val = b'\x1e'
    
    #-----< general-dataCDS >-----#
    general_dataCDS = OCT_STR(name=u'general-dataCDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_dataCDS._val = b'\x1f'
    
    #-----< allPadAccessCA-Services >-----#
    allPadAccessCA_Services = OCT_STR(name=u'allPadAccessCA-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allPadAccessCA_Services._val = b' '
    
    #-----< padAccessCA-300bps >-----#
    padAccessCA_300bps = OCT_STR(name=u'padAccessCA-300bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_300bps._val = b'!'
    
    #-----< padAccessCA-1200bps >-----#
    padAccessCA_1200bps = OCT_STR(name=u'padAccessCA-1200bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_1200bps._val = b'"'
    
    #-----< padAccessCA-1200-75bps >-----#
    padAccessCA_1200_75bps = OCT_STR(name=u'padAccessCA-1200-75bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_1200_75bps._val = b'#'
    
    #-----< padAccessCA-2400bps >-----#
    padAccessCA_2400bps = OCT_STR(name=u'padAccessCA-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_2400bps._val = b'$'
    
    #-----< padAccessCA-4800bps >-----#
    padAccessCA_4800bps = OCT_STR(name=u'padAccessCA-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_4800bps._val = b'%'
    
    #-----< padAccessCA-9600bps >-----#
    padAccessCA_9600bps = OCT_STR(name=u'padAccessCA-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    padAccessCA_9600bps._val = b'&'
    
    #-----< general-padAccessCA >-----#
    general_padAccessCA = OCT_STR(name=u'general-padAccessCA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_padAccessCA._val = b"'"
    
    #-----< allDataPDS-Services >-----#
    allDataPDS_Services = OCT_STR(name=u'allDataPDS-Services', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataPDS_Services._val = b'('
    
    #-----< dataPDS-2400bps >-----#
    dataPDS_2400bps = OCT_STR(name=u'dataPDS-2400bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataPDS_2400bps._val = b','
    
    #-----< dataPDS-4800bps >-----#
    dataPDS_4800bps = OCT_STR(name=u'dataPDS-4800bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataPDS_4800bps._val = b'-'
    
    #-----< dataPDS-9600bps >-----#
    dataPDS_9600bps = OCT_STR(name=u'dataPDS-9600bps', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    dataPDS_9600bps._val = b'.'
    
    #-----< general-dataPDS >-----#
    general_dataPDS = OCT_STR(name=u'general-dataPDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    general_dataPDS._val = b'/'
    
    #-----< allAlternateSpeech-DataCDA >-----#
    allAlternateSpeech_DataCDA = OCT_STR(name=u'allAlternateSpeech-DataCDA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allAlternateSpeech_DataCDA._val = b'0'
    
    #-----< allAlternateSpeech-DataCDS >-----#
    allAlternateSpeech_DataCDS = OCT_STR(name=u'allAlternateSpeech-DataCDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allAlternateSpeech_DataCDS._val = b'8'
    
    #-----< allSpeechFollowedByDataCDA >-----#
    allSpeechFollowedByDataCDA = OCT_STR(name=u'allSpeechFollowedByDataCDA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allSpeechFollowedByDataCDA._val = b'@'
    
    #-----< allSpeechFollowedByDataCDS >-----#
    allSpeechFollowedByDataCDS = OCT_STR(name=u'allSpeechFollowedByDataCDS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allSpeechFollowedByDataCDS._val = b'H'
    
    #-----< allDataCircuitAsynchronous >-----#
    allDataCircuitAsynchronous = OCT_STR(name=u'allDataCircuitAsynchronous', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCircuitAsynchronous._val = b'P'
    
    #-----< allAsynchronousServices >-----#
    allAsynchronousServices = OCT_STR(name=u'allAsynchronousServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allAsynchronousServices._val = b'`'
    
    #-----< allDataCircuitSynchronous >-----#
    allDataCircuitSynchronous = OCT_STR(name=u'allDataCircuitSynchronous', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allDataCircuitSynchronous._val = b'X'
    
    #-----< allSynchronousServices >-----#
    allSynchronousServices = OCT_STR(name=u'allSynchronousServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allSynchronousServices._val = b'h'
    
    #-----< allPLMN-specificBS >-----#
    allPLMN_specificBS = OCT_STR(name=u'allPLMN-specificBS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    allPLMN_specificBS._val = b'\xd0'
    
    #-----< plmn-specificBS-1 >-----#
    plmn_specificBS_1 = OCT_STR(name=u'plmn-specificBS-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_1._val = b'\xd1'
    
    #-----< plmn-specificBS-2 >-----#
    plmn_specificBS_2 = OCT_STR(name=u'plmn-specificBS-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_2._val = b'\xd2'
    
    #-----< plmn-specificBS-3 >-----#
    plmn_specificBS_3 = OCT_STR(name=u'plmn-specificBS-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_3._val = b'\xd3'
    
    #-----< plmn-specificBS-4 >-----#
    plmn_specificBS_4 = OCT_STR(name=u'plmn-specificBS-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_4._val = b'\xd4'
    
    #-----< plmn-specificBS-5 >-----#
    plmn_specificBS_5 = OCT_STR(name=u'plmn-specificBS-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_5._val = b'\xd5'
    
    #-----< plmn-specificBS-6 >-----#
    plmn_specificBS_6 = OCT_STR(name=u'plmn-specificBS-6', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_6._val = b'\xd6'
    
    #-----< plmn-specificBS-7 >-----#
    plmn_specificBS_7 = OCT_STR(name=u'plmn-specificBS-7', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_7._val = b'\xd7'
    
    #-----< plmn-specificBS-8 >-----#
    plmn_specificBS_8 = OCT_STR(name=u'plmn-specificBS-8', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_8._val = b'\xd8'
    
    #-----< plmn-specificBS-9 >-----#
    plmn_specificBS_9 = OCT_STR(name=u'plmn-specificBS-9', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_9._val = b'\xd9'
    
    #-----< plmn-specificBS-A >-----#
    plmn_specificBS_A = OCT_STR(name=u'plmn-specificBS-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_A._val = b'\xda'
    
    #-----< plmn-specificBS-B >-----#
    plmn_specificBS_B = OCT_STR(name=u'plmn-specificBS-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_B._val = b'\xdb'
    
    #-----< plmn-specificBS-C >-----#
    plmn_specificBS_C = OCT_STR(name=u'plmn-specificBS-C', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_C._val = b'\xdc'
    
    #-----< plmn-specificBS-D >-----#
    plmn_specificBS_D = OCT_STR(name=u'plmn-specificBS-D', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_D._val = b'\xdd'
    
    #-----< plmn-specificBS-E >-----#
    plmn_specificBS_E = OCT_STR(name=u'plmn-specificBS-E', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_E._val = b'\xde'
    
    #-----< plmn-specificBS-F >-----#
    plmn_specificBS_F = OCT_STR(name=u'plmn-specificBS-F', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    plmn_specificBS_F._val = b'\xdf'
    
    _all_ = [
        BearerServiceCode,
        Ext_BearerServiceCode,
        allBearerServices,
        allDataCDA_Services,
        dataCDA_300bps,
        dataCDA_1200bps,
        dataCDA_1200_75bps,
        dataCDA_2400bps,
        dataCDA_4800bps,
        dataCDA_9600bps,
        general_dataCDA,
        allDataCDS_Services,
        dataCDS_1200bps,
        dataCDS_2400bps,
        dataCDS_4800bps,
        dataCDS_9600bps,
        general_dataCDS,
        allPadAccessCA_Services,
        padAccessCA_300bps,
        padAccessCA_1200bps,
        padAccessCA_1200_75bps,
        padAccessCA_2400bps,
        padAccessCA_4800bps,
        padAccessCA_9600bps,
        general_padAccessCA,
        allDataPDS_Services,
        dataPDS_2400bps,
        dataPDS_4800bps,
        dataPDS_9600bps,
        general_dataPDS,
        allAlternateSpeech_DataCDA,
        allAlternateSpeech_DataCDS,
        allSpeechFollowedByDataCDA,
        allSpeechFollowedByDataCDS,
        allDataCircuitAsynchronous,
        allAsynchronousServices,
        allDataCircuitSynchronous,
        allSynchronousServices,
        allPLMN_specificBS,
        plmn_specificBS_1,
        plmn_specificBS_2,
        plmn_specificBS_3,
        plmn_specificBS_4,
        plmn_specificBS_5,
        plmn_specificBS_6,
        plmn_specificBS_7,
        plmn_specificBS_8,
        plmn_specificBS_9,
        plmn_specificBS_A,
        plmn_specificBS_B,
        plmn_specificBS_C,
        plmn_specificBS_D,
        plmn_specificBS_E,
        plmn_specificBS_F,
    ]

class MAP_CH_DataTypes:

    _name_  = u'MAP-CH-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 13, 19]
    
    _obj_ = [
        u'CUG-CheckInfo',
        u'NumberOfForwarding',
        u'SendRoutingInfoArg',
        u'SuppressionOfAnnouncement',
        u'SuppressMTSS',
        u'InterrogationType',
        u'OR-Phase',
        u'CallReferenceNumber',
        u'ForwardingReason',
        u'SupportedCCBS-Phase',
        u'CallDiversionTreatmentIndicator',
        u'SendRoutingInfoRes',
        u'AllowedServices',
        u'UnavailabilityCause',
        u'CCBS-Indicators',
        u'RoutingInfo',
        u'ForwardingData',
        u'ProvideRoamingNumberArg',
        u'ProvideRoamingNumberRes',
        u'ResumeCallHandlingArg',
        u'UU-Data',
        u'UUIndicator',
        u'UUI',
        u'ResumeCallHandlingRes',
        u'CamelInfo',
        u'ExtendedRoutingInfo',
        u'CamelRoutingInfo',
        u'GmscCamelSubscriptionInfo',
        u'SetReportingStateArg',
        u'ReportingState',
        u'SetReportingStateRes',
        u'CCBS-SubscriberStatus',
        u'StatusReportArg',
        u'EventReportData',
        u'CallReportData',
        u'MonitoringMode',
        u'CallOutcome',
        u'StatusReportRes',
        u'RemoteUserFreeArg',
        u'RemoteUserFreeRes',
        u'RUF-Outcome',
        u'IST-AlertArg',
        u'IST-AlertRes',
        u'IST-CommandArg',
        u'IST-CommandRes',
        u'CallTerminationIndicator',
        u'ReleaseResourcesArg',
        u'ReleaseResourcesRes',
        ]
    _type_ = [
        u'CUG-CheckInfo',
        u'NumberOfForwarding',
        u'SendRoutingInfoArg',
        u'SuppressionOfAnnouncement',
        u'SuppressMTSS',
        u'InterrogationType',
        u'OR-Phase',
        u'CallReferenceNumber',
        u'ForwardingReason',
        u'SupportedCCBS-Phase',
        u'CallDiversionTreatmentIndicator',
        u'SendRoutingInfoRes',
        u'AllowedServices',
        u'UnavailabilityCause',
        u'CCBS-Indicators',
        u'RoutingInfo',
        u'ForwardingData',
        u'ProvideRoamingNumberArg',
        u'ProvideRoamingNumberRes',
        u'ResumeCallHandlingArg',
        u'UU-Data',
        u'UUIndicator',
        u'UUI',
        u'ResumeCallHandlingRes',
        u'CamelInfo',
        u'ExtendedRoutingInfo',
        u'CamelRoutingInfo',
        u'GmscCamelSubscriptionInfo',
        u'SetReportingStateArg',
        u'ReportingState',
        u'SetReportingStateRes',
        u'CCBS-SubscriberStatus',
        u'StatusReportArg',
        u'EventReportData',
        u'CallReportData',
        u'MonitoringMode',
        u'CallOutcome',
        u'StatusReportRes',
        u'RemoteUserFreeArg',
        u'RemoteUserFreeRes',
        u'RUF-Outcome',
        u'IST-AlertArg',
        u'IST-AlertRes',
        u'IST-CommandArg',
        u'IST-CommandRes',
        u'CallTerminationIndicator',
        u'ReleaseResourcesArg',
        u'ReleaseResourcesRes',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< CUG-CheckInfo >-----#
    CUG_CheckInfo = SEQ(name=u'CUG-CheckInfo', mode=MODE_TYPE)
    _CUG_CheckInfo_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')))
    _CUG_CheckInfo_cug_OutgoingAccess = NULL(name=u'cug-OutgoingAccess', mode=MODE_TYPE, opt=True)
    _CUG_CheckInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_CheckInfo._cont = ASN1Dict([
        (u'cug-Interlock', _CUG_CheckInfo_cug_Interlock),
        (u'cug-OutgoingAccess', _CUG_CheckInfo_cug_OutgoingAccess),
        (u'extensionContainer', _CUG_CheckInfo_extensionContainer),
        ])
    CUG_CheckInfo._ext = []
    
    #-----< NumberOfForwarding >-----#
    NumberOfForwarding = INT(name=u'NumberOfForwarding', mode=MODE_TYPE)
    NumberOfForwarding._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< SendRoutingInfoArg >-----#
    SendRoutingInfoArg = SEQ(name=u'SendRoutingInfoArg', mode=MODE_TYPE)
    _SendRoutingInfoArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendRoutingInfoArg_cug_CheckInfo = SEQ(name=u'cug-CheckInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CUG-CheckInfo')), opt=True)
    _SendRoutingInfoArg_numberOfForwarding = INT(name=u'numberOfForwarding', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'NumberOfForwarding')), opt=True)
    _SendRoutingInfoArg_interrogationType = ENUM(name=u'interrogationType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'InterrogationType')))
    _SendRoutingInfoArg_or_Interrogation = NULL(name=u'or-Interrogation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_or_Capability = INT(name=u'or-Capability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'OR-Phase')), opt=True)
    _SendRoutingInfoArg_gmsc_OrGsmSCF_Address = OCT_STR(name=u'gmsc-OrGsmSCF-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendRoutingInfoArg_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _SendRoutingInfoArg_forwardingReason = ENUM(name=u'forwardingReason', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingReason')), opt=True)
    _SendRoutingInfoArg_basicServiceGroup = CHOICE(name=u'basicServiceGroup', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoArg_networkSignalInfo = SEQ(name=u'networkSignalInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _SendRoutingInfoArg_camelInfo = SEQ(name=u'camelInfo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CamelInfo')), opt=True)
    _SendRoutingInfoArg_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _SendRoutingInfoArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendRoutingInfoArg_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _SendRoutingInfoArg_ccbs_Call = NULL(name=u'ccbs-Call', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_supportedCCBS_Phase = INT(name=u'supportedCCBS-Phase', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SupportedCCBS-Phase')), opt=True)
    _SendRoutingInfoArg_additionalSignalInfo = SEQ(name=u'additionalSignalInfo', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-ExternalSignalInfo')), opt=True)
    _SendRoutingInfoArg_istSupportIndicator = ENUM(name=u'istSupportIndicator', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-SupportIndicator')), opt=True)
    _SendRoutingInfoArg_pre_pagingSupported = NULL(name=u'pre-pagingSupported', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_callDiversionTreatmentIndicator = OCT_STR(name=u'callDiversionTreatmentIndicator', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallDiversionTreatmentIndicator')), opt=True)
    _SendRoutingInfoArg_longFTN_Supported = NULL(name=u'longFTN-Supported', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_suppress_VT_CSI = NULL(name=u'suppress-VT-CSI', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_suppressIncomingCallBarring = NULL(name=u'suppressIncomingCallBarring', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_gsmSCF_InitiatedCall = NULL(name=u'gsmSCF-InitiatedCall', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_basicServiceGroup2 = CHOICE(name=u'basicServiceGroup2', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoArg_networkSignalInfo2 = SEQ(name=u'networkSignalInfo2', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _SendRoutingInfoArg_suppressMTSS = BIT_STR(name=u'suppressMTSS', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressMTSS')), opt=True)
    _SendRoutingInfoArg_mtRoamingRetrySupported = NULL(name=u'mtRoamingRetrySupported', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoArg_callPriority = INT(name=u'callPriority', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    SendRoutingInfoArg._cont = ASN1Dict([
        (u'msisdn', _SendRoutingInfoArg_msisdn),
        (u'cug-CheckInfo', _SendRoutingInfoArg_cug_CheckInfo),
        (u'numberOfForwarding', _SendRoutingInfoArg_numberOfForwarding),
        (u'interrogationType', _SendRoutingInfoArg_interrogationType),
        (u'or-Interrogation', _SendRoutingInfoArg_or_Interrogation),
        (u'or-Capability', _SendRoutingInfoArg_or_Capability),
        (u'gmsc-OrGsmSCF-Address', _SendRoutingInfoArg_gmsc_OrGsmSCF_Address),
        (u'callReferenceNumber', _SendRoutingInfoArg_callReferenceNumber),
        (u'forwardingReason', _SendRoutingInfoArg_forwardingReason),
        (u'basicServiceGroup', _SendRoutingInfoArg_basicServiceGroup),
        (u'networkSignalInfo', _SendRoutingInfoArg_networkSignalInfo),
        (u'camelInfo', _SendRoutingInfoArg_camelInfo),
        (u'suppressionOfAnnouncement', _SendRoutingInfoArg_suppressionOfAnnouncement),
        (u'extensionContainer', _SendRoutingInfoArg_extensionContainer),
        (u'alertingPattern', _SendRoutingInfoArg_alertingPattern),
        (u'ccbs-Call', _SendRoutingInfoArg_ccbs_Call),
        (u'supportedCCBS-Phase', _SendRoutingInfoArg_supportedCCBS_Phase),
        (u'additionalSignalInfo', _SendRoutingInfoArg_additionalSignalInfo),
        (u'istSupportIndicator', _SendRoutingInfoArg_istSupportIndicator),
        (u'pre-pagingSupported', _SendRoutingInfoArg_pre_pagingSupported),
        (u'callDiversionTreatmentIndicator', _SendRoutingInfoArg_callDiversionTreatmentIndicator),
        (u'longFTN-Supported', _SendRoutingInfoArg_longFTN_Supported),
        (u'suppress-VT-CSI', _SendRoutingInfoArg_suppress_VT_CSI),
        (u'suppressIncomingCallBarring', _SendRoutingInfoArg_suppressIncomingCallBarring),
        (u'gsmSCF-InitiatedCall', _SendRoutingInfoArg_gsmSCF_InitiatedCall),
        (u'basicServiceGroup2', _SendRoutingInfoArg_basicServiceGroup2),
        (u'networkSignalInfo2', _SendRoutingInfoArg_networkSignalInfo2),
        (u'suppressMTSS', _SendRoutingInfoArg_suppressMTSS),
        (u'mtRoamingRetrySupported', _SendRoutingInfoArg_mtRoamingRetrySupported),
        (u'callPriority', _SendRoutingInfoArg_callPriority),
        ])
    SendRoutingInfoArg._ext = [u'alertingPattern', u'ccbs-Call', u'supportedCCBS-Phase', u'additionalSignalInfo', u'istSupportIndicator', u'pre-pagingSupported', u'callDiversionTreatmentIndicator', u'longFTN-Supported', u'suppress-VT-CSI', u'suppressIncomingCallBarring', u'gsmSCF-InitiatedCall', u'basicServiceGroup2', u'networkSignalInfo2', u'suppressMTSS', u'mtRoamingRetrySupported', u'callPriority']
    
    #-----< SuppressionOfAnnouncement >-----#
    SuppressionOfAnnouncement = NULL(name=u'SuppressionOfAnnouncement', mode=MODE_TYPE)
    
    #-----< SuppressMTSS >-----#
    SuppressMTSS = BIT_STR(name=u'SuppressMTSS', mode=MODE_TYPE)
    SuppressMTSS._cont = ASN1Dict([(u'suppressCUG', 0), (u'suppressCCBS', 1)])
    SuppressMTSS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    
    #-----< InterrogationType >-----#
    InterrogationType = ENUM(name=u'InterrogationType', mode=MODE_TYPE)
    InterrogationType._cont = ASN1Dict([(u'basicCall', 0), (u'forwarding', 1)])
    InterrogationType._ext = None
    
    #-----< OR-Phase >-----#
    OR_Phase = INT(name=u'OR-Phase', mode=MODE_TYPE)
    OR_Phase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    
    #-----< CallReferenceNumber >-----#
    CallReferenceNumber = OCT_STR(name=u'CallReferenceNumber', mode=MODE_TYPE)
    CallReferenceNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ForwardingReason >-----#
    ForwardingReason = ENUM(name=u'ForwardingReason', mode=MODE_TYPE)
    ForwardingReason._cont = ASN1Dict([(u'notReachable', 0), (u'busy', 1), (u'noReply', 2)])
    ForwardingReason._ext = None
    
    #-----< SupportedCCBS-Phase >-----#
    SupportedCCBS_Phase = INT(name=u'SupportedCCBS-Phase', mode=MODE_TYPE)
    SupportedCCBS_Phase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=None, er=[])
    
    #-----< CallDiversionTreatmentIndicator >-----#
    CallDiversionTreatmentIndicator = OCT_STR(name=u'CallDiversionTreatmentIndicator', mode=MODE_TYPE)
    CallDiversionTreatmentIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SendRoutingInfoRes >-----#
    SendRoutingInfoRes = SEQ(name=u'SendRoutingInfoRes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendRoutingInfoRes_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SendRoutingInfoRes_extendedRoutingInfo = CHOICE(name=u'extendedRoutingInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'ExtendedRoutingInfo')), opt=True)
    _SendRoutingInfoRes_cug_CheckInfo = SEQ(name=u'cug-CheckInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CUG-CheckInfo')), opt=True)
    _SendRoutingInfoRes_cugSubscriptionFlag = NULL(name=u'cugSubscriptionFlag', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoRes_subscriberInfo = SEQ(name=u'subscriberInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberInfo')), opt=True)
    _SendRoutingInfoRes_ss_List = SEQ_OF(name=u'ss-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _SendRoutingInfoRes_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoRes_forwardingInterrogationRequired = NULL(name=u'forwardingInterrogationRequired', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoRes_vmsc_Address = OCT_STR(name=u'vmsc-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendRoutingInfoRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendRoutingInfoRes_naea_PreferredCI = SEQ(name=u'naea-PreferredCI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NAEA-PreferredCI')), opt=True)
    _SendRoutingInfoRes_ccbs_Indicators = SEQ(name=u'ccbs-Indicators', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CCBS-Indicators')), opt=True)
    _SendRoutingInfoRes_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendRoutingInfoRes_numberPortabilityStatus = ENUM(name=u'numberPortabilityStatus', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberPortabilityStatus')), opt=True)
    _SendRoutingInfoRes_istAlertTimer = INT(name=u'istAlertTimer', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-AlertTimerValue')), opt=True)
    _SendRoutingInfoRes_supportedCamelPhasesInVMSC = BIT_STR(name=u'supportedCamelPhasesInVMSC', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _SendRoutingInfoRes_offeredCamel4CSIsInVMSC = BIT_STR(name=u'offeredCamel4CSIsInVMSC', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _SendRoutingInfoRes_routingInfo2 = CHOICE(name=u'routingInfo2', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'RoutingInfo')), opt=True)
    _SendRoutingInfoRes_ss_List2 = SEQ_OF(name=u'ss-List2', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _SendRoutingInfoRes_basicService2 = CHOICE(name=u'basicService2', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _SendRoutingInfoRes_allowedServices = BIT_STR(name=u'allowedServices', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'AllowedServices')), opt=True)
    _SendRoutingInfoRes_unavailabilityCause = ENUM(name=u'unavailabilityCause', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UnavailabilityCause')), opt=True)
    _SendRoutingInfoRes_releaseResourcesSupported = NULL(name=u'releaseResourcesSupported', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendRoutingInfoRes_gsm_BearerCapability = SEQ(name=u'gsm-BearerCapability', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    SendRoutingInfoRes._cont = ASN1Dict([
        (u'imsi', _SendRoutingInfoRes_imsi),
        (u'extendedRoutingInfo', _SendRoutingInfoRes_extendedRoutingInfo),
        (u'cug-CheckInfo', _SendRoutingInfoRes_cug_CheckInfo),
        (u'cugSubscriptionFlag', _SendRoutingInfoRes_cugSubscriptionFlag),
        (u'subscriberInfo', _SendRoutingInfoRes_subscriberInfo),
        (u'ss-List', _SendRoutingInfoRes_ss_List),
        (u'basicService', _SendRoutingInfoRes_basicService),
        (u'forwardingInterrogationRequired', _SendRoutingInfoRes_forwardingInterrogationRequired),
        (u'vmsc-Address', _SendRoutingInfoRes_vmsc_Address),
        (u'extensionContainer', _SendRoutingInfoRes_extensionContainer),
        (u'naea-PreferredCI', _SendRoutingInfoRes_naea_PreferredCI),
        (u'ccbs-Indicators', _SendRoutingInfoRes_ccbs_Indicators),
        (u'msisdn', _SendRoutingInfoRes_msisdn),
        (u'numberPortabilityStatus', _SendRoutingInfoRes_numberPortabilityStatus),
        (u'istAlertTimer', _SendRoutingInfoRes_istAlertTimer),
        (u'supportedCamelPhasesInVMSC', _SendRoutingInfoRes_supportedCamelPhasesInVMSC),
        (u'offeredCamel4CSIsInVMSC', _SendRoutingInfoRes_offeredCamel4CSIsInVMSC),
        (u'routingInfo2', _SendRoutingInfoRes_routingInfo2),
        (u'ss-List2', _SendRoutingInfoRes_ss_List2),
        (u'basicService2', _SendRoutingInfoRes_basicService2),
        (u'allowedServices', _SendRoutingInfoRes_allowedServices),
        (u'unavailabilityCause', _SendRoutingInfoRes_unavailabilityCause),
        (u'releaseResourcesSupported', _SendRoutingInfoRes_releaseResourcesSupported),
        (u'gsm-BearerCapability', _SendRoutingInfoRes_gsm_BearerCapability),
        ])
    SendRoutingInfoRes._ext = [u'naea-PreferredCI', u'ccbs-Indicators', u'msisdn', u'numberPortabilityStatus', u'istAlertTimer', u'supportedCamelPhasesInVMSC', u'offeredCamel4CSIsInVMSC', u'routingInfo2', u'ss-List2', u'basicService2', u'allowedServices', u'unavailabilityCause', u'releaseResourcesSupported', u'gsm-BearerCapability']
    
    #-----< AllowedServices >-----#
    AllowedServices = BIT_STR(name=u'AllowedServices', mode=MODE_TYPE)
    AllowedServices._cont = ASN1Dict([(u'firstServiceAllowed', 0), (u'secondServiceAllowed', 1)])
    AllowedServices._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< UnavailabilityCause >-----#
    UnavailabilityCause = ENUM(name=u'UnavailabilityCause', mode=MODE_TYPE)
    UnavailabilityCause._cont = ASN1Dict([(u'bearerServiceNotProvisioned', 1), (u'teleserviceNotProvisioned', 2), (u'absentSubscriber', 3), (u'busySubscriber', 4), (u'callBarred', 5), (u'cug-Reject', 6)])
    UnavailabilityCause._ext = []
    
    #-----< CCBS-Indicators >-----#
    CCBS_Indicators = SEQ(name=u'CCBS-Indicators', mode=MODE_TYPE)
    _CCBS_Indicators_ccbs_Possible = NULL(name=u'ccbs-Possible', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CCBS_Indicators_keepCCBS_CallIndicator = NULL(name=u'keepCCBS-CallIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CCBS_Indicators_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CCBS_Indicators._cont = ASN1Dict([
        (u'ccbs-Possible', _CCBS_Indicators_ccbs_Possible),
        (u'keepCCBS-CallIndicator', _CCBS_Indicators_keepCCBS_CallIndicator),
        (u'extensionContainer', _CCBS_Indicators_extensionContainer),
        ])
    CCBS_Indicators._ext = []
    
    #-----< RoutingInfo >-----#
    RoutingInfo = CHOICE(name=u'RoutingInfo', mode=MODE_TYPE)
    _RoutingInfo_roamingNumber = OCT_STR(name=u'roamingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RoutingInfo_forwardingData = SEQ(name=u'forwardingData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingData')))
    RoutingInfo._cont = ASN1Dict([
        (u'roamingNumber', _RoutingInfo_roamingNumber),
        (u'forwardingData', _RoutingInfo_forwardingData),
        ])
    RoutingInfo._ext = None
    
    #-----< ForwardingData >-----#
    ForwardingData = SEQ(name=u'ForwardingData', mode=MODE_TYPE)
    _ForwardingData_forwardedToNumber = OCT_STR(name=u'forwardedToNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ForwardingData_forwardedToSubaddress = OCT_STR(name=u'forwardedToSubaddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _ForwardingData_forwardingOptions = OCT_STR(name=u'forwardingOptions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingOptions')), opt=True)
    _ForwardingData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ForwardingData_longForwardedToNumber = OCT_STR(name=u'longForwardedToNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'FTN-AddressString')), opt=True)
    ForwardingData._cont = ASN1Dict([
        (u'forwardedToNumber', _ForwardingData_forwardedToNumber),
        (u'forwardedToSubaddress', _ForwardingData_forwardedToSubaddress),
        (u'forwardingOptions', _ForwardingData_forwardingOptions),
        (u'extensionContainer', _ForwardingData_extensionContainer),
        (u'longForwardedToNumber', _ForwardingData_longForwardedToNumber),
        ])
    ForwardingData._ext = [u'longForwardedToNumber']
    
    #-----< ProvideRoamingNumberArg >-----#
    ProvideRoamingNumberArg = SEQ(name=u'ProvideRoamingNumberArg', mode=MODE_TYPE)
    _ProvideRoamingNumberArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _ProvideRoamingNumberArg_msc_Number = OCT_STR(name=u'msc-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ProvideRoamingNumberArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ProvideRoamingNumberArg_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _ProvideRoamingNumberArg_gsm_BearerCapability = SEQ(name=u'gsm-BearerCapability', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _ProvideRoamingNumberArg_networkSignalInfo = SEQ(name=u'networkSignalInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')), opt=True)
    _ProvideRoamingNumberArg_suppressionOfAnnouncement = NULL(name=u'suppressionOfAnnouncement', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'SuppressionOfAnnouncement')), opt=True)
    _ProvideRoamingNumberArg_gmsc_Address = OCT_STR(name=u'gmsc-Address', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ProvideRoamingNumberArg_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _ProvideRoamingNumberArg_or_Interrogation = NULL(name=u'or-Interrogation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideRoamingNumberArg_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _ProvideRoamingNumberArg_ccbs_Call = NULL(name=u'ccbs-Call', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_supportedCamelPhasesInInterrogatingNode = BIT_STR(name=u'supportedCamelPhasesInInterrogatingNode', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _ProvideRoamingNumberArg_additionalSignalInfo = SEQ(name=u'additionalSignalInfo', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-ExternalSignalInfo')), opt=True)
    _ProvideRoamingNumberArg_orNotSupportedInGMSC = NULL(name=u'orNotSupportedInGMSC', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_pre_pagingSupported = NULL(name=u'pre-pagingSupported', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_longFTN_Supported = NULL(name=u'longFTN-Supported', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_suppress_VT_CSI = NULL(name=u'suppress-VT-CSI', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_offeredCamel4CSIsInInterrogatingNode = BIT_STR(name=u'offeredCamel4CSIsInInterrogatingNode', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _ProvideRoamingNumberArg_mtRoamingRetrySupported = NULL(name=u'mtRoamingRetrySupported', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_pagingArea = SEQ_OF(name=u'pagingArea', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PagingArea')), opt=True)
    _ProvideRoamingNumberArg_callPriority = INT(name=u'callPriority', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _ProvideRoamingNumberArg_mtrf_Indicator = NULL(name=u'mtrf-Indicator', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideRoamingNumberArg_oldMSC_Number = OCT_STR(name=u'oldMSC-Number', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ProvideRoamingNumberArg_lastUsedLtePLMN_Id = OCT_STR(name=u'lastUsedLtePLMN-Id', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    ProvideRoamingNumberArg._cont = ASN1Dict([
        (u'imsi', _ProvideRoamingNumberArg_imsi),
        (u'msc-Number', _ProvideRoamingNumberArg_msc_Number),
        (u'msisdn', _ProvideRoamingNumberArg_msisdn),
        (u'lmsi', _ProvideRoamingNumberArg_lmsi),
        (u'gsm-BearerCapability', _ProvideRoamingNumberArg_gsm_BearerCapability),
        (u'networkSignalInfo', _ProvideRoamingNumberArg_networkSignalInfo),
        (u'suppressionOfAnnouncement', _ProvideRoamingNumberArg_suppressionOfAnnouncement),
        (u'gmsc-Address', _ProvideRoamingNumberArg_gmsc_Address),
        (u'callReferenceNumber', _ProvideRoamingNumberArg_callReferenceNumber),
        (u'or-Interrogation', _ProvideRoamingNumberArg_or_Interrogation),
        (u'extensionContainer', _ProvideRoamingNumberArg_extensionContainer),
        (u'alertingPattern', _ProvideRoamingNumberArg_alertingPattern),
        (u'ccbs-Call', _ProvideRoamingNumberArg_ccbs_Call),
        (u'supportedCamelPhasesInInterrogatingNode', _ProvideRoamingNumberArg_supportedCamelPhasesInInterrogatingNode),
        (u'additionalSignalInfo', _ProvideRoamingNumberArg_additionalSignalInfo),
        (u'orNotSupportedInGMSC', _ProvideRoamingNumberArg_orNotSupportedInGMSC),
        (u'pre-pagingSupported', _ProvideRoamingNumberArg_pre_pagingSupported),
        (u'longFTN-Supported', _ProvideRoamingNumberArg_longFTN_Supported),
        (u'suppress-VT-CSI', _ProvideRoamingNumberArg_suppress_VT_CSI),
        (u'offeredCamel4CSIsInInterrogatingNode', _ProvideRoamingNumberArg_offeredCamel4CSIsInInterrogatingNode),
        (u'mtRoamingRetrySupported', _ProvideRoamingNumberArg_mtRoamingRetrySupported),
        (u'pagingArea', _ProvideRoamingNumberArg_pagingArea),
        (u'callPriority', _ProvideRoamingNumberArg_callPriority),
        (u'mtrf-Indicator', _ProvideRoamingNumberArg_mtrf_Indicator),
        (u'oldMSC-Number', _ProvideRoamingNumberArg_oldMSC_Number),
        (u'lastUsedLtePLMN-Id', _ProvideRoamingNumberArg_lastUsedLtePLMN_Id),
        ])
    ProvideRoamingNumberArg._ext = [u'alertingPattern', u'ccbs-Call', u'supportedCamelPhasesInInterrogatingNode', u'additionalSignalInfo', u'orNotSupportedInGMSC', u'pre-pagingSupported', u'longFTN-Supported', u'suppress-VT-CSI', u'offeredCamel4CSIsInInterrogatingNode', u'mtRoamingRetrySupported', u'pagingArea', u'callPriority', u'mtrf-Indicator', u'oldMSC-Number', u'lastUsedLtePLMN-Id']
    
    #-----< ProvideRoamingNumberRes >-----#
    ProvideRoamingNumberRes = SEQ(name=u'ProvideRoamingNumberRes', mode=MODE_TYPE)
    _ProvideRoamingNumberRes_roamingNumber = OCT_STR(name=u'roamingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ProvideRoamingNumberRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideRoamingNumberRes_releaseResourcesSupported = NULL(name=u'releaseResourcesSupported', mode=MODE_TYPE, opt=True)
    _ProvideRoamingNumberRes_vmsc_Address = OCT_STR(name=u'vmsc-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    ProvideRoamingNumberRes._cont = ASN1Dict([
        (u'roamingNumber', _ProvideRoamingNumberRes_roamingNumber),
        (u'extensionContainer', _ProvideRoamingNumberRes_extensionContainer),
        (u'releaseResourcesSupported', _ProvideRoamingNumberRes_releaseResourcesSupported),
        (u'vmsc-Address', _ProvideRoamingNumberRes_vmsc_Address),
        ])
    ProvideRoamingNumberRes._ext = [u'releaseResourcesSupported', u'vmsc-Address']
    
    #-----< ResumeCallHandlingArg >-----#
    ResumeCallHandlingArg = SEQ(name=u'ResumeCallHandlingArg', mode=MODE_TYPE)
    _ResumeCallHandlingArg_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')), opt=True)
    _ResumeCallHandlingArg_basicServiceGroup = CHOICE(name=u'basicServiceGroup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ResumeCallHandlingArg_forwardingData = SEQ(name=u'forwardingData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingData')), opt=True)
    _ResumeCallHandlingArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _ResumeCallHandlingArg_cug_CheckInfo = SEQ(name=u'cug-CheckInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CUG-CheckInfo')), opt=True)
    _ResumeCallHandlingArg_o_CSI = SEQ(name=u'o-CSI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _ResumeCallHandlingArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ResumeCallHandlingArg_ccbs_Possible = NULL(name=u'ccbs-Possible', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ResumeCallHandlingArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ResumeCallHandlingArg_uu_Data = SEQ(name=u'uu-Data', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UU-Data')), opt=True)
    _ResumeCallHandlingArg_allInformationSent = NULL(name=u'allInformationSent', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ResumeCallHandlingArg_d_csi = SEQ(name=u'd-csi', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _ResumeCallHandlingArg_o_BcsmCamelTDPCriteriaList = SEQ_OF(name=u'o-BcsmCamelTDPCriteriaList', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _ResumeCallHandlingArg_basicServiceGroup2 = CHOICE(name=u'basicServiceGroup2', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ResumeCallHandlingArg_mtRoamingRetry = NULL(name=u'mtRoamingRetry', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ResumeCallHandlingArg._cont = ASN1Dict([
        (u'callReferenceNumber', _ResumeCallHandlingArg_callReferenceNumber),
        (u'basicServiceGroup', _ResumeCallHandlingArg_basicServiceGroup),
        (u'forwardingData', _ResumeCallHandlingArg_forwardingData),
        (u'imsi', _ResumeCallHandlingArg_imsi),
        (u'cug-CheckInfo', _ResumeCallHandlingArg_cug_CheckInfo),
        (u'o-CSI', _ResumeCallHandlingArg_o_CSI),
        (u'extensionContainer', _ResumeCallHandlingArg_extensionContainer),
        (u'ccbs-Possible', _ResumeCallHandlingArg_ccbs_Possible),
        (u'msisdn', _ResumeCallHandlingArg_msisdn),
        (u'uu-Data', _ResumeCallHandlingArg_uu_Data),
        (u'allInformationSent', _ResumeCallHandlingArg_allInformationSent),
        (u'd-csi', _ResumeCallHandlingArg_d_csi),
        (u'o-BcsmCamelTDPCriteriaList', _ResumeCallHandlingArg_o_BcsmCamelTDPCriteriaList),
        (u'basicServiceGroup2', _ResumeCallHandlingArg_basicServiceGroup2),
        (u'mtRoamingRetry', _ResumeCallHandlingArg_mtRoamingRetry),
        ])
    ResumeCallHandlingArg._ext = [u'd-csi', u'o-BcsmCamelTDPCriteriaList', u'basicServiceGroup2', u'mtRoamingRetry']
    
    #-----< UU-Data >-----#
    UU_Data = SEQ(name=u'UU-Data', mode=MODE_TYPE)
    _UU_Data_uuIndicator = OCT_STR(name=u'uuIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UUIndicator')), opt=True)
    _UU_Data_uui = OCT_STR(name=u'uui', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'UUI')), opt=True)
    _UU_Data_uusCFInteraction = NULL(name=u'uusCFInteraction', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UU_Data_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UU_Data._cont = ASN1Dict([
        (u'uuIndicator', _UU_Data_uuIndicator),
        (u'uui', _UU_Data_uui),
        (u'uusCFInteraction', _UU_Data_uusCFInteraction),
        (u'extensionContainer', _UU_Data_extensionContainer),
        ])
    UU_Data._ext = []
    
    #-----< UUIndicator >-----#
    UUIndicator = OCT_STR(name=u'UUIndicator', mode=MODE_TYPE)
    UUIndicator._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< UUI >-----#
    UUI = OCT_STR(name=u'UUI', mode=MODE_TYPE)
    UUI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=131)], ev=None, er=[])
    
    #-----< ResumeCallHandlingRes >-----#
    ResumeCallHandlingRes = SEQ(name=u'ResumeCallHandlingRes', mode=MODE_TYPE)
    _ResumeCallHandlingRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ResumeCallHandlingRes._cont = ASN1Dict([
        (u'extensionContainer', _ResumeCallHandlingRes_extensionContainer),
        ])
    ResumeCallHandlingRes._ext = []
    
    #-----< CamelInfo >-----#
    CamelInfo = SEQ(name=u'CamelInfo', mode=MODE_TYPE)
    _CamelInfo_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')))
    _CamelInfo_suppress_T_CSI = NULL(name=u'suppress-T-CSI', mode=MODE_TYPE, opt=True)
    _CamelInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CamelInfo_offeredCamel4CSIs = BIT_STR(name=u'offeredCamel4CSIs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    CamelInfo._cont = ASN1Dict([
        (u'supportedCamelPhases', _CamelInfo_supportedCamelPhases),
        (u'suppress-T-CSI', _CamelInfo_suppress_T_CSI),
        (u'extensionContainer', _CamelInfo_extensionContainer),
        (u'offeredCamel4CSIs', _CamelInfo_offeredCamel4CSIs),
        ])
    CamelInfo._ext = [u'offeredCamel4CSIs']
    
    #-----< ExtendedRoutingInfo >-----#
    ExtendedRoutingInfo = CHOICE(name=u'ExtendedRoutingInfo', mode=MODE_TYPE)
    _ExtendedRoutingInfo_routingInfo = CHOICE(name=u'routingInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'RoutingInfo')))
    _ExtendedRoutingInfo_camelRoutingInfo = SEQ(name=u'camelRoutingInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CamelRoutingInfo')))
    ExtendedRoutingInfo._cont = ASN1Dict([
        (u'routingInfo', _ExtendedRoutingInfo_routingInfo),
        (u'camelRoutingInfo', _ExtendedRoutingInfo_camelRoutingInfo),
        ])
    ExtendedRoutingInfo._ext = None
    
    #-----< CamelRoutingInfo >-----#
    CamelRoutingInfo = SEQ(name=u'CamelRoutingInfo', mode=MODE_TYPE)
    _CamelRoutingInfo_forwardingData = SEQ(name=u'forwardingData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CH-DataTypes', 'ForwardingData')), opt=True)
    _CamelRoutingInfo_gmscCamelSubscriptionInfo = SEQ(name=u'gmscCamelSubscriptionInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'GmscCamelSubscriptionInfo')))
    _CamelRoutingInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CamelRoutingInfo._cont = ASN1Dict([
        (u'forwardingData', _CamelRoutingInfo_forwardingData),
        (u'gmscCamelSubscriptionInfo', _CamelRoutingInfo_gmscCamelSubscriptionInfo),
        (u'extensionContainer', _CamelRoutingInfo_extensionContainer),
        ])
    CamelRoutingInfo._ext = []
    
    #-----< GmscCamelSubscriptionInfo >-----#
    GmscCamelSubscriptionInfo = SEQ(name=u'GmscCamelSubscriptionInfo', mode=MODE_TYPE)
    _GmscCamelSubscriptionInfo_t_CSI = SEQ(name=u't-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _GmscCamelSubscriptionInfo_o_CSI = SEQ(name=u'o-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _GmscCamelSubscriptionInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _GmscCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList = SEQ_OF(name=u'o-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _GmscCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name=u't-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _GmscCamelSubscriptionInfo_d_csi = SEQ(name=u'd-csi', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    GmscCamelSubscriptionInfo._cont = ASN1Dict([
        (u't-CSI', _GmscCamelSubscriptionInfo_t_CSI),
        (u'o-CSI', _GmscCamelSubscriptionInfo_o_CSI),
        (u'extensionContainer', _GmscCamelSubscriptionInfo_extensionContainer),
        (u'o-BcsmCamelTDP-CriteriaList', _GmscCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList),
        (u't-BCSM-CAMEL-TDP-CriteriaList', _GmscCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList),
        (u'd-csi', _GmscCamelSubscriptionInfo_d_csi),
        ])
    GmscCamelSubscriptionInfo._ext = [u'o-BcsmCamelTDP-CriteriaList', u't-BCSM-CAMEL-TDP-CriteriaList', u'd-csi']
    
    #-----< SetReportingStateArg >-----#
    SetReportingStateArg = SEQ(name=u'SetReportingStateArg', mode=MODE_TYPE)
    _SetReportingStateArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SetReportingStateArg_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _SetReportingStateArg_ccbs_Monitoring = ENUM(name=u'ccbs-Monitoring', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'ReportingState')), opt=True)
    _SetReportingStateArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SetReportingStateArg._cont = ASN1Dict([
        (u'imsi', _SetReportingStateArg_imsi),
        (u'lmsi', _SetReportingStateArg_lmsi),
        (u'ccbs-Monitoring', _SetReportingStateArg_ccbs_Monitoring),
        (u'extensionContainer', _SetReportingStateArg_extensionContainer),
        ])
    SetReportingStateArg._ext = []
    
    #-----< ReportingState >-----#
    ReportingState = ENUM(name=u'ReportingState', mode=MODE_TYPE)
    ReportingState._cont = ASN1Dict([(u'stopMonitoring', 0), (u'startMonitoring', 1)])
    ReportingState._ext = []
    
    #-----< SetReportingStateRes >-----#
    SetReportingStateRes = SEQ(name=u'SetReportingStateRes', mode=MODE_TYPE)
    _SetReportingStateRes_ccbs_SubscriberStatus = ENUM(name=u'ccbs-SubscriberStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CCBS-SubscriberStatus')), opt=True)
    _SetReportingStateRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SetReportingStateRes._cont = ASN1Dict([
        (u'ccbs-SubscriberStatus', _SetReportingStateRes_ccbs_SubscriberStatus),
        (u'extensionContainer', _SetReportingStateRes_extensionContainer),
        ])
    SetReportingStateRes._ext = []
    
    #-----< CCBS-SubscriberStatus >-----#
    CCBS_SubscriberStatus = ENUM(name=u'CCBS-SubscriberStatus', mode=MODE_TYPE)
    CCBS_SubscriberStatus._cont = ASN1Dict([(u'ccbsNotIdle', 0), (u'ccbsIdle', 1), (u'ccbsNotReachable', 2)])
    CCBS_SubscriberStatus._ext = []
    
    #-----< StatusReportArg >-----#
    StatusReportArg = SEQ(name=u'StatusReportArg', mode=MODE_TYPE)
    _StatusReportArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _StatusReportArg_eventReportData = SEQ(name=u'eventReportData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'EventReportData')), opt=True)
    _StatusReportArg_callReportdata = SEQ(name=u'callReportdata', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReportData')), opt=True)
    _StatusReportArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    StatusReportArg._cont = ASN1Dict([
        (u'imsi', _StatusReportArg_imsi),
        (u'eventReportData', _StatusReportArg_eventReportData),
        (u'callReportdata', _StatusReportArg_callReportdata),
        (u'extensionContainer', _StatusReportArg_extensionContainer),
        ])
    StatusReportArg._ext = []
    
    #-----< EventReportData >-----#
    EventReportData = SEQ(name=u'EventReportData', mode=MODE_TYPE)
    _EventReportData_ccbs_SubscriberStatus = ENUM(name=u'ccbs-SubscriberStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CCBS-SubscriberStatus')), opt=True)
    _EventReportData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EventReportData._cont = ASN1Dict([
        (u'ccbs-SubscriberStatus', _EventReportData_ccbs_SubscriberStatus),
        (u'extensionContainer', _EventReportData_extensionContainer),
        ])
    EventReportData._ext = []
    
    #-----< CallReportData >-----#
    CallReportData = SEQ(name=u'CallReportData', mode=MODE_TYPE)
    _CallReportData_monitoringMode = ENUM(name=u'monitoringMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'MonitoringMode')), opt=True)
    _CallReportData_callOutcome = ENUM(name=u'callOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallOutcome')), opt=True)
    _CallReportData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CallReportData._cont = ASN1Dict([
        (u'monitoringMode', _CallReportData_monitoringMode),
        (u'callOutcome', _CallReportData_callOutcome),
        (u'extensionContainer', _CallReportData_extensionContainer),
        ])
    CallReportData._ext = []
    
    #-----< MonitoringMode >-----#
    MonitoringMode = ENUM(name=u'MonitoringMode', mode=MODE_TYPE)
    MonitoringMode._cont = ASN1Dict([(u'a-side', 0), (u'b-side', 1)])
    MonitoringMode._ext = []
    
    #-----< CallOutcome >-----#
    CallOutcome = ENUM(name=u'CallOutcome', mode=MODE_TYPE)
    CallOutcome._cont = ASN1Dict([(u'success', 0), (u'failure', 1), (u'busy', 2)])
    CallOutcome._ext = []
    
    #-----< StatusReportRes >-----#
    StatusReportRes = SEQ(name=u'StatusReportRes', mode=MODE_TYPE)
    _StatusReportRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    StatusReportRes._cont = ASN1Dict([
        (u'extensionContainer', _StatusReportRes_extensionContainer),
        ])
    StatusReportRes._ext = []
    
    #-----< RemoteUserFreeArg >-----#
    RemoteUserFreeArg = SEQ(name=u'RemoteUserFreeArg', mode=MODE_TYPE)
    _RemoteUserFreeArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _RemoteUserFreeArg_callInfo = SEQ(name=u'callInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')))
    _RemoteUserFreeArg_ccbs_Feature = SEQ(name=u'ccbs-Feature', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')))
    _RemoteUserFreeArg_translatedB_Number = OCT_STR(name=u'translatedB-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RemoteUserFreeArg_replaceB_Number = NULL(name=u'replaceB-Number', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RemoteUserFreeArg_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _RemoteUserFreeArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    RemoteUserFreeArg._cont = ASN1Dict([
        (u'imsi', _RemoteUserFreeArg_imsi),
        (u'callInfo', _RemoteUserFreeArg_callInfo),
        (u'ccbs-Feature', _RemoteUserFreeArg_ccbs_Feature),
        (u'translatedB-Number', _RemoteUserFreeArg_translatedB_Number),
        (u'replaceB-Number', _RemoteUserFreeArg_replaceB_Number),
        (u'alertingPattern', _RemoteUserFreeArg_alertingPattern),
        (u'extensionContainer', _RemoteUserFreeArg_extensionContainer),
        ])
    RemoteUserFreeArg._ext = []
    
    #-----< RemoteUserFreeRes >-----#
    RemoteUserFreeRes = SEQ(name=u'RemoteUserFreeRes', mode=MODE_TYPE)
    _RemoteUserFreeRes_ruf_Outcome = ENUM(name=u'ruf-Outcome', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'RUF-Outcome')))
    _RemoteUserFreeRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    RemoteUserFreeRes._cont = ASN1Dict([
        (u'ruf-Outcome', _RemoteUserFreeRes_ruf_Outcome),
        (u'extensionContainer', _RemoteUserFreeRes_extensionContainer),
        ])
    RemoteUserFreeRes._ext = []
    
    #-----< RUF-Outcome >-----#
    RUF_Outcome = ENUM(name=u'RUF-Outcome', mode=MODE_TYPE)
    RUF_Outcome._cont = ASN1Dict([(u'accepted', 0), (u'rejected', 1), (u'noResponseFromFreeMS', 2), (u'noResponseFromBusyMS', 3), (u'udubFromFreeMS', 4), (u'udubFromBusyMS', 5)])
    RUF_Outcome._ext = []
    
    #-----< IST-AlertArg >-----#
    IST_AlertArg = SEQ(name=u'IST-AlertArg', mode=MODE_TYPE)
    _IST_AlertArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _IST_AlertArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_AlertArg._cont = ASN1Dict([
        (u'imsi', _IST_AlertArg_imsi),
        (u'extensionContainer', _IST_AlertArg_extensionContainer),
        ])
    IST_AlertArg._ext = []
    
    #-----< IST-AlertRes >-----#
    IST_AlertRes = SEQ(name=u'IST-AlertRes', mode=MODE_TYPE)
    _IST_AlertRes_istAlertTimer = INT(name=u'istAlertTimer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-AlertTimerValue')), opt=True)
    _IST_AlertRes_istInformationWithdraw = NULL(name=u'istInformationWithdraw', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IST_AlertRes_callTerminationIndicator = ENUM(name=u'callTerminationIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallTerminationIndicator')), opt=True)
    _IST_AlertRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_AlertRes._cont = ASN1Dict([
        (u'istAlertTimer', _IST_AlertRes_istAlertTimer),
        (u'istInformationWithdraw', _IST_AlertRes_istInformationWithdraw),
        (u'callTerminationIndicator', _IST_AlertRes_callTerminationIndicator),
        (u'extensionContainer', _IST_AlertRes_extensionContainer),
        ])
    IST_AlertRes._ext = []
    
    #-----< IST-CommandArg >-----#
    IST_CommandArg = SEQ(name=u'IST-CommandArg', mode=MODE_TYPE)
    _IST_CommandArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _IST_CommandArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_CommandArg._cont = ASN1Dict([
        (u'imsi', _IST_CommandArg_imsi),
        (u'extensionContainer', _IST_CommandArg_extensionContainer),
        ])
    IST_CommandArg._ext = []
    
    #-----< IST-CommandRes >-----#
    IST_CommandRes = SEQ(name=u'IST-CommandRes', mode=MODE_TYPE)
    _IST_CommandRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IST_CommandRes._cont = ASN1Dict([
        (u'extensionContainer', _IST_CommandRes_extensionContainer),
        ])
    IST_CommandRes._ext = []
    
    #-----< CallTerminationIndicator >-----#
    CallTerminationIndicator = ENUM(name=u'CallTerminationIndicator', mode=MODE_TYPE)
    CallTerminationIndicator._cont = ASN1Dict([(u'terminateCallActivityReferred', 0), (u'terminateAllCallActivities', 1)])
    CallTerminationIndicator._ext = []
    
    #-----< ReleaseResourcesArg >-----#
    ReleaseResourcesArg = SEQ(name=u'ReleaseResourcesArg', mode=MODE_TYPE)
    _ReleaseResourcesArg_msrn = OCT_STR(name=u'msrn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ReleaseResourcesArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ReleaseResourcesArg._cont = ASN1Dict([
        (u'msrn', _ReleaseResourcesArg_msrn),
        (u'extensionContainer', _ReleaseResourcesArg_extensionContainer),
        ])
    ReleaseResourcesArg._ext = []
    
    #-----< ReleaseResourcesRes >-----#
    ReleaseResourcesRes = SEQ(name=u'ReleaseResourcesRes', mode=MODE_TYPE)
    _ReleaseResourcesRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ReleaseResourcesRes._cont = ASN1Dict([
        (u'extensionContainer', _ReleaseResourcesRes_extensionContainer),
        ])
    ReleaseResourcesRes._ext = []
    
    _all_ = [
        _CUG_CheckInfo_cug_Interlock,
        _CUG_CheckInfo_cug_OutgoingAccess,
        _CUG_CheckInfo_extensionContainer,
        CUG_CheckInfo,
        NumberOfForwarding,
        _SendRoutingInfoArg_msisdn,
        _SendRoutingInfoArg_cug_CheckInfo,
        _SendRoutingInfoArg_numberOfForwarding,
        _SendRoutingInfoArg_interrogationType,
        _SendRoutingInfoArg_or_Interrogation,
        _SendRoutingInfoArg_or_Capability,
        _SendRoutingInfoArg_gmsc_OrGsmSCF_Address,
        _SendRoutingInfoArg_callReferenceNumber,
        _SendRoutingInfoArg_forwardingReason,
        _SendRoutingInfoArg_basicServiceGroup,
        _SendRoutingInfoArg_networkSignalInfo,
        _SendRoutingInfoArg_camelInfo,
        _SendRoutingInfoArg_suppressionOfAnnouncement,
        _SendRoutingInfoArg_extensionContainer,
        _SendRoutingInfoArg_alertingPattern,
        _SendRoutingInfoArg_ccbs_Call,
        _SendRoutingInfoArg_supportedCCBS_Phase,
        _SendRoutingInfoArg_additionalSignalInfo,
        _SendRoutingInfoArg_istSupportIndicator,
        _SendRoutingInfoArg_pre_pagingSupported,
        _SendRoutingInfoArg_callDiversionTreatmentIndicator,
        _SendRoutingInfoArg_longFTN_Supported,
        _SendRoutingInfoArg_suppress_VT_CSI,
        _SendRoutingInfoArg_suppressIncomingCallBarring,
        _SendRoutingInfoArg_gsmSCF_InitiatedCall,
        _SendRoutingInfoArg_basicServiceGroup2,
        _SendRoutingInfoArg_networkSignalInfo2,
        _SendRoutingInfoArg_suppressMTSS,
        _SendRoutingInfoArg_mtRoamingRetrySupported,
        _SendRoutingInfoArg_callPriority,
        SendRoutingInfoArg,
        SuppressionOfAnnouncement,
        SuppressMTSS,
        InterrogationType,
        OR_Phase,
        CallReferenceNumber,
        ForwardingReason,
        SupportedCCBS_Phase,
        CallDiversionTreatmentIndicator,
        _SendRoutingInfoRes_imsi,
        _SendRoutingInfoRes_extendedRoutingInfo,
        _SendRoutingInfoRes_cug_CheckInfo,
        _SendRoutingInfoRes_cugSubscriptionFlag,
        _SendRoutingInfoRes_subscriberInfo,
        _SendRoutingInfoRes_ss_List,
        _SendRoutingInfoRes_basicService,
        _SendRoutingInfoRes_forwardingInterrogationRequired,
        _SendRoutingInfoRes_vmsc_Address,
        _SendRoutingInfoRes_extensionContainer,
        _SendRoutingInfoRes_naea_PreferredCI,
        _SendRoutingInfoRes_ccbs_Indicators,
        _SendRoutingInfoRes_msisdn,
        _SendRoutingInfoRes_numberPortabilityStatus,
        _SendRoutingInfoRes_istAlertTimer,
        _SendRoutingInfoRes_supportedCamelPhasesInVMSC,
        _SendRoutingInfoRes_offeredCamel4CSIsInVMSC,
        _SendRoutingInfoRes_routingInfo2,
        _SendRoutingInfoRes_ss_List2,
        _SendRoutingInfoRes_basicService2,
        _SendRoutingInfoRes_allowedServices,
        _SendRoutingInfoRes_unavailabilityCause,
        _SendRoutingInfoRes_releaseResourcesSupported,
        _SendRoutingInfoRes_gsm_BearerCapability,
        SendRoutingInfoRes,
        AllowedServices,
        UnavailabilityCause,
        _CCBS_Indicators_ccbs_Possible,
        _CCBS_Indicators_keepCCBS_CallIndicator,
        _CCBS_Indicators_extensionContainer,
        CCBS_Indicators,
        _RoutingInfo_roamingNumber,
        _RoutingInfo_forwardingData,
        RoutingInfo,
        _ForwardingData_forwardedToNumber,
        _ForwardingData_forwardedToSubaddress,
        _ForwardingData_forwardingOptions,
        _ForwardingData_extensionContainer,
        _ForwardingData_longForwardedToNumber,
        ForwardingData,
        _ProvideRoamingNumberArg_imsi,
        _ProvideRoamingNumberArg_msc_Number,
        _ProvideRoamingNumberArg_msisdn,
        _ProvideRoamingNumberArg_lmsi,
        _ProvideRoamingNumberArg_gsm_BearerCapability,
        _ProvideRoamingNumberArg_networkSignalInfo,
        _ProvideRoamingNumberArg_suppressionOfAnnouncement,
        _ProvideRoamingNumberArg_gmsc_Address,
        _ProvideRoamingNumberArg_callReferenceNumber,
        _ProvideRoamingNumberArg_or_Interrogation,
        _ProvideRoamingNumberArg_extensionContainer,
        _ProvideRoamingNumberArg_alertingPattern,
        _ProvideRoamingNumberArg_ccbs_Call,
        _ProvideRoamingNumberArg_supportedCamelPhasesInInterrogatingNode,
        _ProvideRoamingNumberArg_additionalSignalInfo,
        _ProvideRoamingNumberArg_orNotSupportedInGMSC,
        _ProvideRoamingNumberArg_pre_pagingSupported,
        _ProvideRoamingNumberArg_longFTN_Supported,
        _ProvideRoamingNumberArg_suppress_VT_CSI,
        _ProvideRoamingNumberArg_offeredCamel4CSIsInInterrogatingNode,
        _ProvideRoamingNumberArg_mtRoamingRetrySupported,
        _ProvideRoamingNumberArg_pagingArea,
        _ProvideRoamingNumberArg_callPriority,
        _ProvideRoamingNumberArg_mtrf_Indicator,
        _ProvideRoamingNumberArg_oldMSC_Number,
        _ProvideRoamingNumberArg_lastUsedLtePLMN_Id,
        ProvideRoamingNumberArg,
        _ProvideRoamingNumberRes_roamingNumber,
        _ProvideRoamingNumberRes_extensionContainer,
        _ProvideRoamingNumberRes_releaseResourcesSupported,
        _ProvideRoamingNumberRes_vmsc_Address,
        ProvideRoamingNumberRes,
        _ResumeCallHandlingArg_callReferenceNumber,
        _ResumeCallHandlingArg_basicServiceGroup,
        _ResumeCallHandlingArg_forwardingData,
        _ResumeCallHandlingArg_imsi,
        _ResumeCallHandlingArg_cug_CheckInfo,
        _ResumeCallHandlingArg_o_CSI,
        _ResumeCallHandlingArg_extensionContainer,
        _ResumeCallHandlingArg_ccbs_Possible,
        _ResumeCallHandlingArg_msisdn,
        _ResumeCallHandlingArg_uu_Data,
        _ResumeCallHandlingArg_allInformationSent,
        _ResumeCallHandlingArg_d_csi,
        _ResumeCallHandlingArg_o_BcsmCamelTDPCriteriaList,
        _ResumeCallHandlingArg_basicServiceGroup2,
        _ResumeCallHandlingArg_mtRoamingRetry,
        ResumeCallHandlingArg,
        _UU_Data_uuIndicator,
        _UU_Data_uui,
        _UU_Data_uusCFInteraction,
        _UU_Data_extensionContainer,
        UU_Data,
        UUIndicator,
        UUI,
        _ResumeCallHandlingRes_extensionContainer,
        ResumeCallHandlingRes,
        _CamelInfo_supportedCamelPhases,
        _CamelInfo_suppress_T_CSI,
        _CamelInfo_extensionContainer,
        _CamelInfo_offeredCamel4CSIs,
        CamelInfo,
        _ExtendedRoutingInfo_routingInfo,
        _ExtendedRoutingInfo_camelRoutingInfo,
        ExtendedRoutingInfo,
        _CamelRoutingInfo_forwardingData,
        _CamelRoutingInfo_gmscCamelSubscriptionInfo,
        _CamelRoutingInfo_extensionContainer,
        CamelRoutingInfo,
        _GmscCamelSubscriptionInfo_t_CSI,
        _GmscCamelSubscriptionInfo_o_CSI,
        _GmscCamelSubscriptionInfo_extensionContainer,
        _GmscCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList,
        _GmscCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList,
        _GmscCamelSubscriptionInfo_d_csi,
        GmscCamelSubscriptionInfo,
        _SetReportingStateArg_imsi,
        _SetReportingStateArg_lmsi,
        _SetReportingStateArg_ccbs_Monitoring,
        _SetReportingStateArg_extensionContainer,
        SetReportingStateArg,
        ReportingState,
        _SetReportingStateRes_ccbs_SubscriberStatus,
        _SetReportingStateRes_extensionContainer,
        SetReportingStateRes,
        CCBS_SubscriberStatus,
        _StatusReportArg_imsi,
        _StatusReportArg_eventReportData,
        _StatusReportArg_callReportdata,
        _StatusReportArg_extensionContainer,
        StatusReportArg,
        _EventReportData_ccbs_SubscriberStatus,
        _EventReportData_extensionContainer,
        EventReportData,
        _CallReportData_monitoringMode,
        _CallReportData_callOutcome,
        _CallReportData_extensionContainer,
        CallReportData,
        MonitoringMode,
        CallOutcome,
        _StatusReportRes_extensionContainer,
        StatusReportRes,
        _RemoteUserFreeArg_imsi,
        _RemoteUserFreeArg_callInfo,
        _RemoteUserFreeArg_ccbs_Feature,
        _RemoteUserFreeArg_translatedB_Number,
        _RemoteUserFreeArg_replaceB_Number,
        _RemoteUserFreeArg_alertingPattern,
        _RemoteUserFreeArg_extensionContainer,
        RemoteUserFreeArg,
        _RemoteUserFreeRes_ruf_Outcome,
        _RemoteUserFreeRes_extensionContainer,
        RemoteUserFreeRes,
        RUF_Outcome,
        _IST_AlertArg_imsi,
        _IST_AlertArg_extensionContainer,
        IST_AlertArg,
        _IST_AlertRes_istAlertTimer,
        _IST_AlertRes_istInformationWithdraw,
        _IST_AlertRes_callTerminationIndicator,
        _IST_AlertRes_extensionContainer,
        IST_AlertRes,
        _IST_CommandArg_imsi,
        _IST_CommandArg_extensionContainer,
        IST_CommandArg,
        _IST_CommandRes_extensionContainer,
        IST_CommandRes,
        CallTerminationIndicator,
        _ReleaseResourcesArg_msrn,
        _ReleaseResourcesArg_extensionContainer,
        ReleaseResourcesArg,
        _ReleaseResourcesRes_extensionContainer,
        ReleaseResourcesRes,
    ]

class MAP_CommonDataTypes:

    _name_  = u'MAP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 18, 19]
    
    _obj_ = [
        u'TBCD-STRING',
        u'DiameterIdentity',
        u'AddressString',
        u'maxAddressLength',
        u'ISDN-AddressString',
        u'maxISDN-AddressLength',
        u'FTN-AddressString',
        u'maxFTN-AddressLength',
        u'ISDN-SubaddressString',
        u'maxISDN-SubaddressLength',
        u'ExternalSignalInfo',
        u'SignalInfo',
        u'maxSignalInfoLength',
        u'ProtocolId',
        u'Ext-ExternalSignalInfo',
        u'Ext-ProtocolId',
        u'AccessNetworkSignalInfo',
        u'LongSignalInfo',
        u'maxLongSignalInfoLength',
        u'AccessNetworkProtocolId',
        u'AlertingPattern',
        u'alertingLevel-0',
        u'alertingLevel-1',
        u'alertingLevel-2',
        u'alertingCategory-1',
        u'alertingCategory-2',
        u'alertingCategory-3',
        u'alertingCategory-4',
        u'alertingCategory-5',
        u'GSN-Address',
        u'Time',
        u'IMSI',
        u'Identity',
        u'IMSI-WithLMSI',
        u'ASCI-CallReference',
        u'TMSI',
        u'SubscriberId',
        u'IMEI',
        u'HLR-Id',
        u'HLR-List',
        u'maxNumOfHLR-Id',
        u'LMSI',
        u'GlobalCellId',
        u'NetworkResource',
        u'AdditionalNetworkResource',
        u'NAEA-PreferredCI',
        u'NAEA-CIC',
        u'SubscriberIdentity',
        u'LCSClientExternalID',
        u'LCSClientInternalID',
        u'LCSServiceTypeID',
        u'emergencyServices',
        u'emergencyAlertServices',
        u'personTracking',
        u'fleetManagement',
        u'assetManagement',
        u'trafficCongestionReporting',
        u'roadsideAssistance',
        u'routingToNearestCommercialEnterprise',
        u'navigation',
        u'citySightseeing',
        u'localizedAdvertising',
        u'mobileYellowPages',
        u'trafficAndPublicTransportationInfo',
        u'weather',
        u'assetAndServiceFinding',
        u'gaming',
        u'findYourFriend',
        u'dating',
        u'chatting',
        u'routeFinding',
        u'whereAmI',
        u'serv64',
        u'serv65',
        u'serv66',
        u'serv67',
        u'serv68',
        u'serv69',
        u'serv70',
        u'serv71',
        u'serv72',
        u'serv73',
        u'serv74',
        u'serv75',
        u'serv76',
        u'serv77',
        u'serv78',
        u'serv79',
        u'serv80',
        u'serv81',
        u'serv82',
        u'serv83',
        u'serv84',
        u'serv85',
        u'serv86',
        u'serv87',
        u'serv88',
        u'serv89',
        u'serv90',
        u'serv91',
        u'serv92',
        u'serv93',
        u'serv94',
        u'serv95',
        u'serv96',
        u'serv97',
        u'serv98',
        u'serv99',
        u'serv100',
        u'serv101',
        u'serv102',
        u'serv103',
        u'serv104',
        u'serv105',
        u'serv106',
        u'serv107',
        u'serv108',
        u'serv109',
        u'serv110',
        u'serv111',
        u'serv112',
        u'serv113',
        u'serv114',
        u'serv115',
        u'serv116',
        u'serv117',
        u'serv118',
        u'serv119',
        u'serv120',
        u'serv121',
        u'serv122',
        u'serv123',
        u'serv124',
        u'serv125',
        u'serv126',
        u'serv127',
        u'PLMN-Id',
        u'E-UTRAN-CGI',
        u'NR-CGI',
        u'TA-Id',
        u'NR-TA-Id',
        u'RAIdentity',
        u'NetworkNodeDiameterAddress',
        u'CellGlobalIdOrServiceAreaIdOrLAI',
        u'CellGlobalIdOrServiceAreaIdFixedLength',
        u'LAIFixedLength',
        u'BasicServiceCode',
        u'Ext-BasicServiceCode',
        u'EMLPP-Info',
        u'EMLPP-Priority',
        u'priorityLevelA',
        u'priorityLevelB',
        u'priorityLevel0',
        u'priorityLevel1',
        u'priorityLevel2',
        u'priorityLevel3',
        u'priorityLevel4',
        u'MC-SS-Info',
        u'MaxMC-Bearers',
        u'MC-Bearers',
        u'maxNumOfMC-Bearers',
        u'Ext-SS-Status',
        u'AgeOfLocationInformation',
        ]
    _type_ = [
        u'TBCD-STRING',
        u'DiameterIdentity',
        u'AddressString',
        u'ISDN-AddressString',
        u'FTN-AddressString',
        u'ISDN-SubaddressString',
        u'ExternalSignalInfo',
        u'SignalInfo',
        u'ProtocolId',
        u'Ext-ExternalSignalInfo',
        u'Ext-ProtocolId',
        u'AccessNetworkSignalInfo',
        u'LongSignalInfo',
        u'AccessNetworkProtocolId',
        u'AlertingPattern',
        u'GSN-Address',
        u'Time',
        u'IMSI',
        u'Identity',
        u'IMSI-WithLMSI',
        u'ASCI-CallReference',
        u'TMSI',
        u'SubscriberId',
        u'IMEI',
        u'HLR-Id',
        u'HLR-List',
        u'LMSI',
        u'GlobalCellId',
        u'NetworkResource',
        u'AdditionalNetworkResource',
        u'NAEA-PreferredCI',
        u'NAEA-CIC',
        u'SubscriberIdentity',
        u'LCSClientExternalID',
        u'LCSClientInternalID',
        u'LCSServiceTypeID',
        u'PLMN-Id',
        u'E-UTRAN-CGI',
        u'NR-CGI',
        u'TA-Id',
        u'NR-TA-Id',
        u'RAIdentity',
        u'NetworkNodeDiameterAddress',
        u'CellGlobalIdOrServiceAreaIdOrLAI',
        u'CellGlobalIdOrServiceAreaIdFixedLength',
        u'LAIFixedLength',
        u'BasicServiceCode',
        u'Ext-BasicServiceCode',
        u'EMLPP-Info',
        u'EMLPP-Priority',
        u'MC-SS-Info',
        u'MaxMC-Bearers',
        u'MC-Bearers',
        u'Ext-SS-Status',
        u'AgeOfLocationInformation',
        ]
    _set_ = [
        ]
    _val_ = [
        u'maxAddressLength',
        u'maxISDN-AddressLength',
        u'maxFTN-AddressLength',
        u'maxISDN-SubaddressLength',
        u'maxSignalInfoLength',
        u'maxLongSignalInfoLength',
        u'alertingLevel-0',
        u'alertingLevel-1',
        u'alertingLevel-2',
        u'alertingCategory-1',
        u'alertingCategory-2',
        u'alertingCategory-3',
        u'alertingCategory-4',
        u'alertingCategory-5',
        u'maxNumOfHLR-Id',
        u'emergencyServices',
        u'emergencyAlertServices',
        u'personTracking',
        u'fleetManagement',
        u'assetManagement',
        u'trafficCongestionReporting',
        u'roadsideAssistance',
        u'routingToNearestCommercialEnterprise',
        u'navigation',
        u'citySightseeing',
        u'localizedAdvertising',
        u'mobileYellowPages',
        u'trafficAndPublicTransportationInfo',
        u'weather',
        u'assetAndServiceFinding',
        u'gaming',
        u'findYourFriend',
        u'dating',
        u'chatting',
        u'routeFinding',
        u'whereAmI',
        u'serv64',
        u'serv65',
        u'serv66',
        u'serv67',
        u'serv68',
        u'serv69',
        u'serv70',
        u'serv71',
        u'serv72',
        u'serv73',
        u'serv74',
        u'serv75',
        u'serv76',
        u'serv77',
        u'serv78',
        u'serv79',
        u'serv80',
        u'serv81',
        u'serv82',
        u'serv83',
        u'serv84',
        u'serv85',
        u'serv86',
        u'serv87',
        u'serv88',
        u'serv89',
        u'serv90',
        u'serv91',
        u'serv92',
        u'serv93',
        u'serv94',
        u'serv95',
        u'serv96',
        u'serv97',
        u'serv98',
        u'serv99',
        u'serv100',
        u'serv101',
        u'serv102',
        u'serv103',
        u'serv104',
        u'serv105',
        u'serv106',
        u'serv107',
        u'serv108',
        u'serv109',
        u'serv110',
        u'serv111',
        u'serv112',
        u'serv113',
        u'serv114',
        u'serv115',
        u'serv116',
        u'serv117',
        u'serv118',
        u'serv119',
        u'serv120',
        u'serv121',
        u'serv122',
        u'serv123',
        u'serv124',
        u'serv125',
        u'serv126',
        u'serv127',
        u'priorityLevelA',
        u'priorityLevelB',
        u'priorityLevel0',
        u'priorityLevel1',
        u'priorityLevel2',
        u'priorityLevel3',
        u'priorityLevel4',
        u'maxNumOfMC-Bearers',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< TBCD-STRING >-----#
    TBCD_STRING = OCT_STR(name=u'TBCD-STRING', mode=MODE_TYPE)
    
    #-----< DiameterIdentity >-----#
    DiameterIdentity = OCT_STR(name=u'DiameterIdentity', mode=MODE_TYPE)
    DiameterIdentity._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=9, ub=255)], ev=None, er=[])
    
    #-----< AddressString >-----#
    AddressString = OCT_STR(name=u'AddressString', mode=MODE_TYPE)
    AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxAddressLength >-----#
    maxAddressLength = INT(name=u'maxAddressLength', mode=MODE_VALUE)
    maxAddressLength._val = 20
    
    #-----< ISDN-AddressString >-----#
    ISDN_AddressString = OCT_STR(name=u'ISDN-AddressString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    ISDN_AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< maxISDN-AddressLength >-----#
    maxISDN_AddressLength = INT(name=u'maxISDN-AddressLength', mode=MODE_VALUE)
    maxISDN_AddressLength._val = 9
    
    #-----< FTN-AddressString >-----#
    FTN_AddressString = OCT_STR(name=u'FTN-AddressString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    FTN_AddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< maxFTN-AddressLength >-----#
    maxFTN_AddressLength = INT(name=u'maxFTN-AddressLength', mode=MODE_VALUE)
    maxFTN_AddressLength._val = 15
    
    #-----< ISDN-SubaddressString >-----#
    ISDN_SubaddressString = OCT_STR(name=u'ISDN-SubaddressString', mode=MODE_TYPE)
    ISDN_SubaddressString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=21)], ev=None, er=[])
    
    #-----< maxISDN-SubaddressLength >-----#
    maxISDN_SubaddressLength = INT(name=u'maxISDN-SubaddressLength', mode=MODE_VALUE)
    maxISDN_SubaddressLength._val = 21
    
    #-----< ExternalSignalInfo >-----#
    ExternalSignalInfo = SEQ(name=u'ExternalSignalInfo', mode=MODE_TYPE)
    _ExternalSignalInfo_protocolId = ENUM(name=u'protocolId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ProtocolId')))
    _ExternalSignalInfo_signalInfo = OCT_STR(name=u'signalInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')))
    _ExternalSignalInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ExternalSignalInfo._cont = ASN1Dict([
        (u'protocolId', _ExternalSignalInfo_protocolId),
        (u'signalInfo', _ExternalSignalInfo_signalInfo),
        (u'extensionContainer', _ExternalSignalInfo_extensionContainer),
        ])
    ExternalSignalInfo._ext = []
    
    #-----< SignalInfo >-----#
    SignalInfo = OCT_STR(name=u'SignalInfo', mode=MODE_TYPE)
    SignalInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    
    #-----< maxSignalInfoLength >-----#
    maxSignalInfoLength = INT(name=u'maxSignalInfoLength', mode=MODE_VALUE)
    maxSignalInfoLength._val = 200
    
    #-----< ProtocolId >-----#
    ProtocolId = ENUM(name=u'ProtocolId', mode=MODE_TYPE)
    ProtocolId._cont = ASN1Dict([(u'gsm-0408', 1), (u'gsm-0806', 2), (u'gsm-BSSMAP', 3), (u'ets-300102-1', 4)])
    ProtocolId._ext = None
    
    #-----< Ext-ExternalSignalInfo >-----#
    Ext_ExternalSignalInfo = SEQ(name=u'Ext-ExternalSignalInfo', mode=MODE_TYPE)
    _Ext_ExternalSignalInfo_ext_ProtocolId = ENUM(name=u'ext-ProtocolId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-ProtocolId')))
    _Ext_ExternalSignalInfo_signalInfo = OCT_STR(name=u'signalInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')))
    _Ext_ExternalSignalInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_ExternalSignalInfo._cont = ASN1Dict([
        (u'ext-ProtocolId', _Ext_ExternalSignalInfo_ext_ProtocolId),
        (u'signalInfo', _Ext_ExternalSignalInfo_signalInfo),
        (u'extensionContainer', _Ext_ExternalSignalInfo_extensionContainer),
        ])
    Ext_ExternalSignalInfo._ext = []
    
    #-----< Ext-ProtocolId >-----#
    Ext_ProtocolId = ENUM(name=u'Ext-ProtocolId', mode=MODE_TYPE)
    Ext_ProtocolId._cont = ASN1Dict([(u'ets-300356', 1)])
    Ext_ProtocolId._ext = []
    
    #-----< AccessNetworkSignalInfo >-----#
    AccessNetworkSignalInfo = SEQ(name=u'AccessNetworkSignalInfo', mode=MODE_TYPE)
    _AccessNetworkSignalInfo_accessNetworkProtocolId = ENUM(name=u'accessNetworkProtocolId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkProtocolId')))
    _AccessNetworkSignalInfo_signalInfo = OCT_STR(name=u'signalInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LongSignalInfo')))
    _AccessNetworkSignalInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AccessNetworkSignalInfo._cont = ASN1Dict([
        (u'accessNetworkProtocolId', _AccessNetworkSignalInfo_accessNetworkProtocolId),
        (u'signalInfo', _AccessNetworkSignalInfo_signalInfo),
        (u'extensionContainer', _AccessNetworkSignalInfo_extensionContainer),
        ])
    AccessNetworkSignalInfo._ext = []
    
    #-----< LongSignalInfo >-----#
    LongSignalInfo = OCT_STR(name=u'LongSignalInfo', mode=MODE_TYPE)
    LongSignalInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2560)], ev=None, er=[])
    
    #-----< maxLongSignalInfoLength >-----#
    maxLongSignalInfoLength = INT(name=u'maxLongSignalInfoLength', mode=MODE_VALUE)
    maxLongSignalInfoLength._val = 2560
    
    #-----< AccessNetworkProtocolId >-----#
    AccessNetworkProtocolId = ENUM(name=u'AccessNetworkProtocolId', mode=MODE_TYPE)
    AccessNetworkProtocolId._cont = ASN1Dict([(u'ts3G-48006', 1), (u'ts3G-25413', 2)])
    AccessNetworkProtocolId._ext = []
    
    #-----< AlertingPattern >-----#
    AlertingPattern = OCT_STR(name=u'AlertingPattern', mode=MODE_TYPE)
    AlertingPattern._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< alertingLevel-0 >-----#
    alertingLevel_0 = OCT_STR(name=u'alertingLevel-0', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingLevel_0._val = b'\x00'
    
    #-----< alertingLevel-1 >-----#
    alertingLevel_1 = OCT_STR(name=u'alertingLevel-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingLevel_1._val = b'\x01'
    
    #-----< alertingLevel-2 >-----#
    alertingLevel_2 = OCT_STR(name=u'alertingLevel-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingLevel_2._val = b'\x02'
    
    #-----< alertingCategory-1 >-----#
    alertingCategory_1 = OCT_STR(name=u'alertingCategory-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_1._val = b'\x04'
    
    #-----< alertingCategory-2 >-----#
    alertingCategory_2 = OCT_STR(name=u'alertingCategory-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_2._val = b'\x05'
    
    #-----< alertingCategory-3 >-----#
    alertingCategory_3 = OCT_STR(name=u'alertingCategory-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_3._val = b'\x06'
    
    #-----< alertingCategory-4 >-----#
    alertingCategory_4 = OCT_STR(name=u'alertingCategory-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_4._val = b'\x07'
    
    #-----< alertingCategory-5 >-----#
    alertingCategory_5 = OCT_STR(name=u'alertingCategory-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')))
    alertingCategory_5._val = b'\x08'
    
    #-----< GSN-Address >-----#
    GSN_Address = OCT_STR(name=u'GSN-Address', mode=MODE_TYPE)
    GSN_Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=17)], ev=None, er=[])
    
    #-----< Time >-----#
    Time = OCT_STR(name=u'Time', mode=MODE_TYPE)
    Time._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< IMSI >-----#
    IMSI = OCT_STR(name=u'IMSI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    IMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< Identity >-----#
    Identity = CHOICE(name=u'Identity', mode=MODE_TYPE)
    _Identity_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _Identity_imsi_WithLMSI = SEQ(name=u'imsi-WithLMSI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI-WithLMSI')))
    Identity._cont = ASN1Dict([
        (u'imsi', _Identity_imsi),
        (u'imsi-WithLMSI', _Identity_imsi_WithLMSI),
        ])
    Identity._ext = None
    
    #-----< IMSI-WithLMSI >-----#
    IMSI_WithLMSI = SEQ(name=u'IMSI-WithLMSI', mode=MODE_TYPE)
    _IMSI_WithLMSI_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _IMSI_WithLMSI_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')))
    IMSI_WithLMSI._cont = ASN1Dict([
        (u'imsi', _IMSI_WithLMSI_imsi),
        (u'lmsi', _IMSI_WithLMSI_lmsi),
        ])
    IMSI_WithLMSI._ext = []
    
    #-----< ASCI-CallReference >-----#
    ASCI_CallReference = OCT_STR(name=u'ASCI-CallReference', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    ASCI_CallReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TMSI >-----#
    TMSI = OCT_STR(name=u'TMSI', mode=MODE_TYPE)
    TMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< SubscriberId >-----#
    SubscriberId = CHOICE(name=u'SubscriberId', mode=MODE_TYPE)
    _SubscriberId_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SubscriberId_tmsi = OCT_STR(name=u'tmsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'TMSI')))
    SubscriberId._cont = ASN1Dict([
        (u'imsi', _SubscriberId_imsi),
        (u'tmsi', _SubscriberId_tmsi),
        ])
    SubscriberId._ext = None
    
    #-----< IMEI >-----#
    IMEI = OCT_STR(name=u'IMEI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    IMEI._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< HLR-Id >-----#
    HLR_Id = OCT_STR(name=u'HLR-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    
    #-----< HLR-List >-----#
    HLR_List = SEQ_OF(name=u'HLR-List', mode=MODE_TYPE)
    _HLR_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'HLR-Id')))
    HLR_List._cont = _HLR_List__item_
    HLR_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfHLR-Id >-----#
    maxNumOfHLR_Id = INT(name=u'maxNumOfHLR-Id', mode=MODE_VALUE)
    maxNumOfHLR_Id._val = 50
    
    #-----< LMSI >-----#
    LMSI = OCT_STR(name=u'LMSI', mode=MODE_TYPE)
    LMSI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GlobalCellId >-----#
    GlobalCellId = OCT_STR(name=u'GlobalCellId', mode=MODE_TYPE)
    GlobalCellId._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=7)], ev=None, er=[])
    
    #-----< NetworkResource >-----#
    NetworkResource = ENUM(name=u'NetworkResource', mode=MODE_TYPE)
    NetworkResource._cont = ASN1Dict([(u'plmn', 0), (u'hlr', 1), (u'vlr', 2), (u'pvlr', 3), (u'controllingMSC', 4), (u'vmsc', 5), (u'eir', 6), (u'rss', 7)])
    NetworkResource._ext = None
    
    #-----< AdditionalNetworkResource >-----#
    AdditionalNetworkResource = ENUM(name=u'AdditionalNetworkResource', mode=MODE_TYPE)
    AdditionalNetworkResource._cont = ASN1Dict([(u'sgsn', 0), (u'ggsn', 1), (u'gmlc', 2), (u'gsmSCF', 3), (u'nplr', 4), (u'auc', 5), (u'ue', 6), (u'mme', 7)])
    AdditionalNetworkResource._ext = [u'ue', u'mme']
    
    #-----< NAEA-PreferredCI >-----#
    NAEA_PreferredCI = SEQ(name=u'NAEA-PreferredCI', mode=MODE_TYPE)
    _NAEA_PreferredCI_naea_PreferredCIC = OCT_STR(name=u'naea-PreferredCIC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NAEA-CIC')))
    _NAEA_PreferredCI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NAEA_PreferredCI._cont = ASN1Dict([
        (u'naea-PreferredCIC', _NAEA_PreferredCI_naea_PreferredCIC),
        (u'extensionContainer', _NAEA_PreferredCI_extensionContainer),
        ])
    NAEA_PreferredCI._ext = []
    
    #-----< NAEA-CIC >-----#
    NAEA_CIC = OCT_STR(name=u'NAEA-CIC', mode=MODE_TYPE)
    NAEA_CIC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< SubscriberIdentity >-----#
    SubscriberIdentity = CHOICE(name=u'SubscriberIdentity', mode=MODE_TYPE)
    _SubscriberIdentity_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SubscriberIdentity_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    SubscriberIdentity._cont = ASN1Dict([
        (u'imsi', _SubscriberIdentity_imsi),
        (u'msisdn', _SubscriberIdentity_msisdn),
        ])
    SubscriberIdentity._ext = None
    
    #-----< LCSClientExternalID >-----#
    LCSClientExternalID = SEQ(name=u'LCSClientExternalID', mode=MODE_TYPE)
    _LCSClientExternalID_externalAddress = OCT_STR(name=u'externalAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LCSClientExternalID_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    LCSClientExternalID._cont = ASN1Dict([
        (u'externalAddress', _LCSClientExternalID_externalAddress),
        (u'extensionContainer', _LCSClientExternalID_extensionContainer),
        ])
    LCSClientExternalID._ext = []
    
    #-----< LCSClientInternalID >-----#
    LCSClientInternalID = ENUM(name=u'LCSClientInternalID', mode=MODE_TYPE)
    LCSClientInternalID._cont = ASN1Dict([(u'broadcastService', 0), (u'o-andM-HPLMN', 1), (u'o-andM-VPLMN', 2), (u'anonymousLocation', 3), (u'targetMSsubscribedService', 4)])
    LCSClientInternalID._ext = []
    
    #-----< LCSServiceTypeID >-----#
    LCSServiceTypeID = INT(name=u'LCSServiceTypeID', mode=MODE_TYPE)
    LCSServiceTypeID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< emergencyServices >-----#
    emergencyServices = INT(name=u'emergencyServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    emergencyServices._val = 0
    
    #-----< emergencyAlertServices >-----#
    emergencyAlertServices = INT(name=u'emergencyAlertServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    emergencyAlertServices._val = 1
    
    #-----< personTracking >-----#
    personTracking = INT(name=u'personTracking', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    personTracking._val = 2
    
    #-----< fleetManagement >-----#
    fleetManagement = INT(name=u'fleetManagement', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    fleetManagement._val = 3
    
    #-----< assetManagement >-----#
    assetManagement = INT(name=u'assetManagement', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    assetManagement._val = 4
    
    #-----< trafficCongestionReporting >-----#
    trafficCongestionReporting = INT(name=u'trafficCongestionReporting', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    trafficCongestionReporting._val = 5
    
    #-----< roadsideAssistance >-----#
    roadsideAssistance = INT(name=u'roadsideAssistance', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    roadsideAssistance._val = 6
    
    #-----< routingToNearestCommercialEnterprise >-----#
    routingToNearestCommercialEnterprise = INT(name=u'routingToNearestCommercialEnterprise', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    routingToNearestCommercialEnterprise._val = 7
    
    #-----< navigation >-----#
    navigation = INT(name=u'navigation', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    navigation._val = 8
    
    #-----< citySightseeing >-----#
    citySightseeing = INT(name=u'citySightseeing', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    citySightseeing._val = 9
    
    #-----< localizedAdvertising >-----#
    localizedAdvertising = INT(name=u'localizedAdvertising', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    localizedAdvertising._val = 10
    
    #-----< mobileYellowPages >-----#
    mobileYellowPages = INT(name=u'mobileYellowPages', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    mobileYellowPages._val = 11
    
    #-----< trafficAndPublicTransportationInfo >-----#
    trafficAndPublicTransportationInfo = INT(name=u'trafficAndPublicTransportationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    trafficAndPublicTransportationInfo._val = 12
    
    #-----< weather >-----#
    weather = INT(name=u'weather', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    weather._val = 13
    
    #-----< assetAndServiceFinding >-----#
    assetAndServiceFinding = INT(name=u'assetAndServiceFinding', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    assetAndServiceFinding._val = 14
    
    #-----< gaming >-----#
    gaming = INT(name=u'gaming', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    gaming._val = 15
    
    #-----< findYourFriend >-----#
    findYourFriend = INT(name=u'findYourFriend', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    findYourFriend._val = 16
    
    #-----< dating >-----#
    dating = INT(name=u'dating', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    dating._val = 17
    
    #-----< chatting >-----#
    chatting = INT(name=u'chatting', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    chatting._val = 18
    
    #-----< routeFinding >-----#
    routeFinding = INT(name=u'routeFinding', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    routeFinding._val = 19
    
    #-----< whereAmI >-----#
    whereAmI = INT(name=u'whereAmI', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    whereAmI._val = 20
    
    #-----< serv64 >-----#
    serv64 = INT(name=u'serv64', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv64._val = 64
    
    #-----< serv65 >-----#
    serv65 = INT(name=u'serv65', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv65._val = 65
    
    #-----< serv66 >-----#
    serv66 = INT(name=u'serv66', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv66._val = 66
    
    #-----< serv67 >-----#
    serv67 = INT(name=u'serv67', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv67._val = 67
    
    #-----< serv68 >-----#
    serv68 = INT(name=u'serv68', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv68._val = 68
    
    #-----< serv69 >-----#
    serv69 = INT(name=u'serv69', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv69._val = 69
    
    #-----< serv70 >-----#
    serv70 = INT(name=u'serv70', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv70._val = 70
    
    #-----< serv71 >-----#
    serv71 = INT(name=u'serv71', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv71._val = 71
    
    #-----< serv72 >-----#
    serv72 = INT(name=u'serv72', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv72._val = 72
    
    #-----< serv73 >-----#
    serv73 = INT(name=u'serv73', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv73._val = 73
    
    #-----< serv74 >-----#
    serv74 = INT(name=u'serv74', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv74._val = 74
    
    #-----< serv75 >-----#
    serv75 = INT(name=u'serv75', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv75._val = 75
    
    #-----< serv76 >-----#
    serv76 = INT(name=u'serv76', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv76._val = 76
    
    #-----< serv77 >-----#
    serv77 = INT(name=u'serv77', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv77._val = 77
    
    #-----< serv78 >-----#
    serv78 = INT(name=u'serv78', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv78._val = 78
    
    #-----< serv79 >-----#
    serv79 = INT(name=u'serv79', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv79._val = 79
    
    #-----< serv80 >-----#
    serv80 = INT(name=u'serv80', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv80._val = 80
    
    #-----< serv81 >-----#
    serv81 = INT(name=u'serv81', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv81._val = 81
    
    #-----< serv82 >-----#
    serv82 = INT(name=u'serv82', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv82._val = 82
    
    #-----< serv83 >-----#
    serv83 = INT(name=u'serv83', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv83._val = 83
    
    #-----< serv84 >-----#
    serv84 = INT(name=u'serv84', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv84._val = 84
    
    #-----< serv85 >-----#
    serv85 = INT(name=u'serv85', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv85._val = 85
    
    #-----< serv86 >-----#
    serv86 = INT(name=u'serv86', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv86._val = 86
    
    #-----< serv87 >-----#
    serv87 = INT(name=u'serv87', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv87._val = 87
    
    #-----< serv88 >-----#
    serv88 = INT(name=u'serv88', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv88._val = 88
    
    #-----< serv89 >-----#
    serv89 = INT(name=u'serv89', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv89._val = 89
    
    #-----< serv90 >-----#
    serv90 = INT(name=u'serv90', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv90._val = 90
    
    #-----< serv91 >-----#
    serv91 = INT(name=u'serv91', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv91._val = 91
    
    #-----< serv92 >-----#
    serv92 = INT(name=u'serv92', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv92._val = 92
    
    #-----< serv93 >-----#
    serv93 = INT(name=u'serv93', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv93._val = 93
    
    #-----< serv94 >-----#
    serv94 = INT(name=u'serv94', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv94._val = 94
    
    #-----< serv95 >-----#
    serv95 = INT(name=u'serv95', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv95._val = 95
    
    #-----< serv96 >-----#
    serv96 = INT(name=u'serv96', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv96._val = 96
    
    #-----< serv97 >-----#
    serv97 = INT(name=u'serv97', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv97._val = 97
    
    #-----< serv98 >-----#
    serv98 = INT(name=u'serv98', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv98._val = 98
    
    #-----< serv99 >-----#
    serv99 = INT(name=u'serv99', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv99._val = 99
    
    #-----< serv100 >-----#
    serv100 = INT(name=u'serv100', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv100._val = 100
    
    #-----< serv101 >-----#
    serv101 = INT(name=u'serv101', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv101._val = 101
    
    #-----< serv102 >-----#
    serv102 = INT(name=u'serv102', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv102._val = 102
    
    #-----< serv103 >-----#
    serv103 = INT(name=u'serv103', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv103._val = 103
    
    #-----< serv104 >-----#
    serv104 = INT(name=u'serv104', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv104._val = 104
    
    #-----< serv105 >-----#
    serv105 = INT(name=u'serv105', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv105._val = 105
    
    #-----< serv106 >-----#
    serv106 = INT(name=u'serv106', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv106._val = 106
    
    #-----< serv107 >-----#
    serv107 = INT(name=u'serv107', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv107._val = 107
    
    #-----< serv108 >-----#
    serv108 = INT(name=u'serv108', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv108._val = 108
    
    #-----< serv109 >-----#
    serv109 = INT(name=u'serv109', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv109._val = 109
    
    #-----< serv110 >-----#
    serv110 = INT(name=u'serv110', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv110._val = 110
    
    #-----< serv111 >-----#
    serv111 = INT(name=u'serv111', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv111._val = 111
    
    #-----< serv112 >-----#
    serv112 = INT(name=u'serv112', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv112._val = 112
    
    #-----< serv113 >-----#
    serv113 = INT(name=u'serv113', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv113._val = 113
    
    #-----< serv114 >-----#
    serv114 = INT(name=u'serv114', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv114._val = 114
    
    #-----< serv115 >-----#
    serv115 = INT(name=u'serv115', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv115._val = 115
    
    #-----< serv116 >-----#
    serv116 = INT(name=u'serv116', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv116._val = 116
    
    #-----< serv117 >-----#
    serv117 = INT(name=u'serv117', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv117._val = 117
    
    #-----< serv118 >-----#
    serv118 = INT(name=u'serv118', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv118._val = 118
    
    #-----< serv119 >-----#
    serv119 = INT(name=u'serv119', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv119._val = 119
    
    #-----< serv120 >-----#
    serv120 = INT(name=u'serv120', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv120._val = 120
    
    #-----< serv121 >-----#
    serv121 = INT(name=u'serv121', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv121._val = 121
    
    #-----< serv122 >-----#
    serv122 = INT(name=u'serv122', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv122._val = 122
    
    #-----< serv123 >-----#
    serv123 = INT(name=u'serv123', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv123._val = 123
    
    #-----< serv124 >-----#
    serv124 = INT(name=u'serv124', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv124._val = 124
    
    #-----< serv125 >-----#
    serv125 = INT(name=u'serv125', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv125._val = 125
    
    #-----< serv126 >-----#
    serv126 = INT(name=u'serv126', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv126._val = 126
    
    #-----< serv127 >-----#
    serv127 = INT(name=u'serv127', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    serv127._val = 127
    
    #-----< PLMN-Id >-----#
    PLMN_Id = OCT_STR(name=u'PLMN-Id', mode=MODE_TYPE)
    PLMN_Id._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< E-UTRAN-CGI >-----#
    E_UTRAN_CGI = OCT_STR(name=u'E-UTRAN-CGI', mode=MODE_TYPE)
    E_UTRAN_CGI._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< NR-CGI >-----#
    NR_CGI = OCT_STR(name=u'NR-CGI', mode=MODE_TYPE)
    NR_CGI._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< TA-Id >-----#
    TA_Id = OCT_STR(name=u'TA-Id', mode=MODE_TYPE)
    TA_Id._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< NR-TA-Id >-----#
    NR_TA_Id = OCT_STR(name=u'NR-TA-Id', mode=MODE_TYPE)
    NR_TA_Id._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< RAIdentity >-----#
    RAIdentity = OCT_STR(name=u'RAIdentity', mode=MODE_TYPE)
    RAIdentity._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    
    #-----< NetworkNodeDiameterAddress >-----#
    NetworkNodeDiameterAddress = SEQ(name=u'NetworkNodeDiameterAddress', mode=MODE_TYPE)
    _NetworkNodeDiameterAddress_diameter_Name = OCT_STR(name=u'diameter-Name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')))
    _NetworkNodeDiameterAddress_diameter_Realm = OCT_STR(name=u'diameter-Realm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')))
    NetworkNodeDiameterAddress._cont = ASN1Dict([
        (u'diameter-Name', _NetworkNodeDiameterAddress_diameter_Name),
        (u'diameter-Realm', _NetworkNodeDiameterAddress_diameter_Realm),
        ])
    NetworkNodeDiameterAddress._ext = None
    
    #-----< CellGlobalIdOrServiceAreaIdOrLAI >-----#
    CellGlobalIdOrServiceAreaIdOrLAI = CHOICE(name=u'CellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE)
    _CellGlobalIdOrServiceAreaIdOrLAI_cellGlobalIdOrServiceAreaIdFixedLength = OCT_STR(name=u'cellGlobalIdOrServiceAreaIdFixedLength', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdFixedLength')))
    _CellGlobalIdOrServiceAreaIdOrLAI_laiFixedLength = OCT_STR(name=u'laiFixedLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    CellGlobalIdOrServiceAreaIdOrLAI._cont = ASN1Dict([
        (u'cellGlobalIdOrServiceAreaIdFixedLength', _CellGlobalIdOrServiceAreaIdOrLAI_cellGlobalIdOrServiceAreaIdFixedLength),
        (u'laiFixedLength', _CellGlobalIdOrServiceAreaIdOrLAI_laiFixedLength),
        ])
    CellGlobalIdOrServiceAreaIdOrLAI._ext = None
    
    #-----< CellGlobalIdOrServiceAreaIdFixedLength >-----#
    CellGlobalIdOrServiceAreaIdFixedLength = OCT_STR(name=u'CellGlobalIdOrServiceAreaIdFixedLength', mode=MODE_TYPE)
    CellGlobalIdOrServiceAreaIdFixedLength._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< LAIFixedLength >-----#
    LAIFixedLength = OCT_STR(name=u'LAIFixedLength', mode=MODE_TYPE)
    LAIFixedLength._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    
    #-----< BasicServiceCode >-----#
    BasicServiceCode = CHOICE(name=u'BasicServiceCode', mode=MODE_TYPE)
    _BasicServiceCode_bearerService = OCT_STR(name=u'bearerService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-BS-Code', 'BearerServiceCode')))
    _BasicServiceCode_teleservice = OCT_STR(name=u'teleservice', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    BasicServiceCode._cont = ASN1Dict([
        (u'bearerService', _BasicServiceCode_bearerService),
        (u'teleservice', _BasicServiceCode_teleservice),
        ])
    BasicServiceCode._ext = None
    
    #-----< Ext-BasicServiceCode >-----#
    Ext_BasicServiceCode = CHOICE(name=u'Ext-BasicServiceCode', mode=MODE_TYPE)
    _Ext_BasicServiceCode_ext_BearerService = OCT_STR(name=u'ext-BearerService', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-BS-Code', 'Ext-BearerServiceCode')))
    _Ext_BasicServiceCode_ext_Teleservice = OCT_STR(name=u'ext-Teleservice', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-TS-Code', 'Ext-TeleserviceCode')))
    Ext_BasicServiceCode._cont = ASN1Dict([
        (u'ext-BearerService', _Ext_BasicServiceCode_ext_BearerService),
        (u'ext-Teleservice', _Ext_BasicServiceCode_ext_Teleservice),
        ])
    Ext_BasicServiceCode._ext = None
    
    #-----< EMLPP-Info >-----#
    EMLPP_Info = SEQ(name=u'EMLPP-Info', mode=MODE_TYPE)
    _EMLPP_Info_maximumentitledPriority = INT(name=u'maximumentitledPriority', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    _EMLPP_Info_defaultPriority = INT(name=u'defaultPriority', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    _EMLPP_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EMLPP_Info._cont = ASN1Dict([
        (u'maximumentitledPriority', _EMLPP_Info_maximumentitledPriority),
        (u'defaultPriority', _EMLPP_Info_defaultPriority),
        (u'extensionContainer', _EMLPP_Info_extensionContainer),
        ])
    EMLPP_Info._ext = []
    
    #-----< EMLPP-Priority >-----#
    EMLPP_Priority = INT(name=u'EMLPP-Priority', mode=MODE_TYPE)
    EMLPP_Priority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< priorityLevelA >-----#
    priorityLevelA = INT(name=u'priorityLevelA', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevelA._val = 6
    
    #-----< priorityLevelB >-----#
    priorityLevelB = INT(name=u'priorityLevelB', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevelB._val = 5
    
    #-----< priorityLevel0 >-----#
    priorityLevel0 = INT(name=u'priorityLevel0', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel0._val = 0
    
    #-----< priorityLevel1 >-----#
    priorityLevel1 = INT(name=u'priorityLevel1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel1._val = 1
    
    #-----< priorityLevel2 >-----#
    priorityLevel2 = INT(name=u'priorityLevel2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel2._val = 2
    
    #-----< priorityLevel3 >-----#
    priorityLevel3 = INT(name=u'priorityLevel3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel3._val = 3
    
    #-----< priorityLevel4 >-----#
    priorityLevel4 = INT(name=u'priorityLevel4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')))
    priorityLevel4._val = 4
    
    #-----< MC-SS-Info >-----#
    MC_SS_Info = SEQ(name=u'MC-SS-Info', mode=MODE_TYPE)
    _MC_SS_Info_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _MC_SS_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _MC_SS_Info_nbrSB = INT(name=u'nbrSB', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MaxMC-Bearers')))
    _MC_SS_Info_nbrUser = INT(name=u'nbrUser', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')))
    _MC_SS_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MC_SS_Info._cont = ASN1Dict([
        (u'ss-Code', _MC_SS_Info_ss_Code),
        (u'ss-Status', _MC_SS_Info_ss_Status),
        (u'nbrSB', _MC_SS_Info_nbrSB),
        (u'nbrUser', _MC_SS_Info_nbrUser),
        (u'extensionContainer', _MC_SS_Info_extensionContainer),
        ])
    MC_SS_Info._ext = []
    
    #-----< MaxMC-Bearers >-----#
    MaxMC_Bearers = INT(name=u'MaxMC-Bearers', mode=MODE_TYPE)
    MaxMC_Bearers._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=7)], ev=None, er=[])
    
    #-----< MC-Bearers >-----#
    MC_Bearers = INT(name=u'MC-Bearers', mode=MODE_TYPE)
    MC_Bearers._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< maxNumOfMC-Bearers >-----#
    maxNumOfMC_Bearers = INT(name=u'maxNumOfMC-Bearers', mode=MODE_VALUE)
    maxNumOfMC_Bearers._val = 7
    
    #-----< Ext-SS-Status >-----#
    Ext_SS_Status = OCT_STR(name=u'Ext-SS-Status', mode=MODE_TYPE)
    Ext_SS_Status._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< AgeOfLocationInformation >-----#
    AgeOfLocationInformation = INT(name=u'AgeOfLocationInformation', mode=MODE_TYPE)
    AgeOfLocationInformation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    _all_ = [
        TBCD_STRING,
        DiameterIdentity,
        AddressString,
        maxAddressLength,
        ISDN_AddressString,
        maxISDN_AddressLength,
        FTN_AddressString,
        maxFTN_AddressLength,
        ISDN_SubaddressString,
        maxISDN_SubaddressLength,
        _ExternalSignalInfo_protocolId,
        _ExternalSignalInfo_signalInfo,
        _ExternalSignalInfo_extensionContainer,
        ExternalSignalInfo,
        SignalInfo,
        maxSignalInfoLength,
        ProtocolId,
        _Ext_ExternalSignalInfo_ext_ProtocolId,
        _Ext_ExternalSignalInfo_signalInfo,
        _Ext_ExternalSignalInfo_extensionContainer,
        Ext_ExternalSignalInfo,
        Ext_ProtocolId,
        _AccessNetworkSignalInfo_accessNetworkProtocolId,
        _AccessNetworkSignalInfo_signalInfo,
        _AccessNetworkSignalInfo_extensionContainer,
        AccessNetworkSignalInfo,
        LongSignalInfo,
        maxLongSignalInfoLength,
        AccessNetworkProtocolId,
        AlertingPattern,
        alertingLevel_0,
        alertingLevel_1,
        alertingLevel_2,
        alertingCategory_1,
        alertingCategory_2,
        alertingCategory_3,
        alertingCategory_4,
        alertingCategory_5,
        GSN_Address,
        Time,
        IMSI,
        _Identity_imsi,
        _Identity_imsi_WithLMSI,
        Identity,
        _IMSI_WithLMSI_imsi,
        _IMSI_WithLMSI_lmsi,
        IMSI_WithLMSI,
        ASCI_CallReference,
        TMSI,
        _SubscriberId_imsi,
        _SubscriberId_tmsi,
        SubscriberId,
        IMEI,
        HLR_Id,
        _HLR_List__item_,
        HLR_List,
        maxNumOfHLR_Id,
        LMSI,
        GlobalCellId,
        NetworkResource,
        AdditionalNetworkResource,
        _NAEA_PreferredCI_naea_PreferredCIC,
        _NAEA_PreferredCI_extensionContainer,
        NAEA_PreferredCI,
        NAEA_CIC,
        _SubscriberIdentity_imsi,
        _SubscriberIdentity_msisdn,
        SubscriberIdentity,
        _LCSClientExternalID_externalAddress,
        _LCSClientExternalID_extensionContainer,
        LCSClientExternalID,
        LCSClientInternalID,
        LCSServiceTypeID,
        emergencyServices,
        emergencyAlertServices,
        personTracking,
        fleetManagement,
        assetManagement,
        trafficCongestionReporting,
        roadsideAssistance,
        routingToNearestCommercialEnterprise,
        navigation,
        citySightseeing,
        localizedAdvertising,
        mobileYellowPages,
        trafficAndPublicTransportationInfo,
        weather,
        assetAndServiceFinding,
        gaming,
        findYourFriend,
        dating,
        chatting,
        routeFinding,
        whereAmI,
        serv64,
        serv65,
        serv66,
        serv67,
        serv68,
        serv69,
        serv70,
        serv71,
        serv72,
        serv73,
        serv74,
        serv75,
        serv76,
        serv77,
        serv78,
        serv79,
        serv80,
        serv81,
        serv82,
        serv83,
        serv84,
        serv85,
        serv86,
        serv87,
        serv88,
        serv89,
        serv90,
        serv91,
        serv92,
        serv93,
        serv94,
        serv95,
        serv96,
        serv97,
        serv98,
        serv99,
        serv100,
        serv101,
        serv102,
        serv103,
        serv104,
        serv105,
        serv106,
        serv107,
        serv108,
        serv109,
        serv110,
        serv111,
        serv112,
        serv113,
        serv114,
        serv115,
        serv116,
        serv117,
        serv118,
        serv119,
        serv120,
        serv121,
        serv122,
        serv123,
        serv124,
        serv125,
        serv126,
        serv127,
        PLMN_Id,
        E_UTRAN_CGI,
        NR_CGI,
        TA_Id,
        NR_TA_Id,
        RAIdentity,
        _NetworkNodeDiameterAddress_diameter_Name,
        _NetworkNodeDiameterAddress_diameter_Realm,
        NetworkNodeDiameterAddress,
        _CellGlobalIdOrServiceAreaIdOrLAI_cellGlobalIdOrServiceAreaIdFixedLength,
        _CellGlobalIdOrServiceAreaIdOrLAI_laiFixedLength,
        CellGlobalIdOrServiceAreaIdOrLAI,
        CellGlobalIdOrServiceAreaIdFixedLength,
        LAIFixedLength,
        _BasicServiceCode_bearerService,
        _BasicServiceCode_teleservice,
        BasicServiceCode,
        _Ext_BasicServiceCode_ext_BearerService,
        _Ext_BasicServiceCode_ext_Teleservice,
        Ext_BasicServiceCode,
        _EMLPP_Info_maximumentitledPriority,
        _EMLPP_Info_defaultPriority,
        _EMLPP_Info_extensionContainer,
        EMLPP_Info,
        EMLPP_Priority,
        priorityLevelA,
        priorityLevelB,
        priorityLevel0,
        priorityLevel1,
        priorityLevel2,
        priorityLevel3,
        priorityLevel4,
        _MC_SS_Info_ss_Code,
        _MC_SS_Info_ss_Status,
        _MC_SS_Info_nbrSB,
        _MC_SS_Info_nbrUser,
        _MC_SS_Info_extensionContainer,
        MC_SS_Info,
        MaxMC_Bearers,
        MC_Bearers,
        maxNumOfMC_Bearers,
        Ext_SS_Status,
        AgeOfLocationInformation,
    ]

class MAP_ER_DataTypes:

    _name_  = u'MAP-ER-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 17, 19]
    
    _obj_ = [
        u'RoamingNotAllowedParam',
        u'AdditionalRoamingNotAllowedCause',
        u'RoamingNotAllowedCause',
        u'CallBarredParam',
        u'CallBarringCause',
        u'ExtensibleCallBarredParam',
        u'CUG-RejectParam',
        u'CUG-RejectCause',
        u'SS-IncompatibilityCause',
        u'PW-RegistrationFailureCause',
        u'SM-EnumeratedDeliveryFailureCause',
        u'SM-DeliveryFailureCause',
        u'AbsentSubscriberSM-Param',
        u'AbsentSubscriberDiagnosticSM',
        u'SystemFailureParam',
        u'ExtensibleSystemFailureParam',
        u'FailureCauseParam',
        u'DataMissingParam',
        u'UnexpectedDataParam',
        u'FacilityNotSupParam',
        u'OR-NotAllowedParam',
        u'UnknownSubscriberParam',
        u'UnknownSubscriberDiagnostic',
        u'NumberChangedParam',
        u'UnidentifiedSubParam',
        u'IllegalSubscriberParam',
        u'IllegalEquipmentParam',
        u'BearerServNotProvParam',
        u'TeleservNotProvParam',
        u'TracingBufferFullParam',
        u'NoRoamingNbParam',
        u'AbsentSubscriberParam',
        u'AbsentSubscriberReason',
        u'BusySubscriberParam',
        u'NoSubscriberReplyParam',
        u'ForwardingViolationParam',
        u'ForwardingFailedParam',
        u'ATI-NotAllowedParam',
        u'ATSI-NotAllowedParam',
        u'ATM-NotAllowedParam',
        u'IllegalSS-OperationParam',
        u'SS-NotAvailableParam',
        u'SS-SubscriptionViolationParam',
        u'InformationNotAvailableParam',
        u'SubBusyForMT-SMS-Param',
        u'MessageWaitListFullParam',
        u'ResourceLimitationParam',
        u'NoGroupCallNbParam',
        u'IncompatibleTerminalParam',
        u'ShortTermDenialParam',
        u'LongTermDenialParam',
        u'UnauthorizedRequestingNetwork-Param',
        u'UnauthorizedLCSClient-Param',
        u'UnauthorizedLCSClient-Diagnostic',
        u'PositionMethodFailure-Param',
        u'PositionMethodFailure-Diagnostic',
        u'UnknownOrUnreachableLCSClient-Param',
        u'MM-EventNotSupported-Param',
        u'TargetCellOutsideGCA-Param',
        u'OngoingGroupCallParam',
        ]
    _type_ = [
        u'RoamingNotAllowedParam',
        u'AdditionalRoamingNotAllowedCause',
        u'RoamingNotAllowedCause',
        u'CallBarredParam',
        u'CallBarringCause',
        u'ExtensibleCallBarredParam',
        u'CUG-RejectParam',
        u'CUG-RejectCause',
        u'SS-IncompatibilityCause',
        u'PW-RegistrationFailureCause',
        u'SM-EnumeratedDeliveryFailureCause',
        u'SM-DeliveryFailureCause',
        u'AbsentSubscriberSM-Param',
        u'AbsentSubscriberDiagnosticSM',
        u'SystemFailureParam',
        u'ExtensibleSystemFailureParam',
        u'FailureCauseParam',
        u'DataMissingParam',
        u'UnexpectedDataParam',
        u'FacilityNotSupParam',
        u'OR-NotAllowedParam',
        u'UnknownSubscriberParam',
        u'UnknownSubscriberDiagnostic',
        u'NumberChangedParam',
        u'UnidentifiedSubParam',
        u'IllegalSubscriberParam',
        u'IllegalEquipmentParam',
        u'BearerServNotProvParam',
        u'TeleservNotProvParam',
        u'TracingBufferFullParam',
        u'NoRoamingNbParam',
        u'AbsentSubscriberParam',
        u'AbsentSubscriberReason',
        u'BusySubscriberParam',
        u'NoSubscriberReplyParam',
        u'ForwardingViolationParam',
        u'ForwardingFailedParam',
        u'ATI-NotAllowedParam',
        u'ATSI-NotAllowedParam',
        u'ATM-NotAllowedParam',
        u'IllegalSS-OperationParam',
        u'SS-NotAvailableParam',
        u'SS-SubscriptionViolationParam',
        u'InformationNotAvailableParam',
        u'SubBusyForMT-SMS-Param',
        u'MessageWaitListFullParam',
        u'ResourceLimitationParam',
        u'NoGroupCallNbParam',
        u'IncompatibleTerminalParam',
        u'ShortTermDenialParam',
        u'LongTermDenialParam',
        u'UnauthorizedRequestingNetwork-Param',
        u'UnauthorizedLCSClient-Param',
        u'UnauthorizedLCSClient-Diagnostic',
        u'PositionMethodFailure-Param',
        u'PositionMethodFailure-Diagnostic',
        u'UnknownOrUnreachableLCSClient-Param',
        u'MM-EventNotSupported-Param',
        u'TargetCellOutsideGCA-Param',
        u'OngoingGroupCallParam',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< RoamingNotAllowedParam >-----#
    RoamingNotAllowedParam = SEQ(name=u'RoamingNotAllowedParam', mode=MODE_TYPE)
    _RoamingNotAllowedParam_roamingNotAllowedCause = ENUM(name=u'roamingNotAllowedCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'RoamingNotAllowedCause')))
    _RoamingNotAllowedParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RoamingNotAllowedParam_additionalRoamingNotAllowedCause = ENUM(name=u'additionalRoamingNotAllowedCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AdditionalRoamingNotAllowedCause')), opt=True)
    RoamingNotAllowedParam._cont = ASN1Dict([
        (u'roamingNotAllowedCause', _RoamingNotAllowedParam_roamingNotAllowedCause),
        (u'extensionContainer', _RoamingNotAllowedParam_extensionContainer),
        (u'additionalRoamingNotAllowedCause', _RoamingNotAllowedParam_additionalRoamingNotAllowedCause),
        ])
    RoamingNotAllowedParam._ext = [u'additionalRoamingNotAllowedCause']
    
    #-----< AdditionalRoamingNotAllowedCause >-----#
    AdditionalRoamingNotAllowedCause = ENUM(name=u'AdditionalRoamingNotAllowedCause', mode=MODE_TYPE)
    AdditionalRoamingNotAllowedCause._cont = ASN1Dict([(u'supportedRAT-TypesNotAllowed', 0)])
    AdditionalRoamingNotAllowedCause._ext = []
    
    #-----< RoamingNotAllowedCause >-----#
    RoamingNotAllowedCause = ENUM(name=u'RoamingNotAllowedCause', mode=MODE_TYPE)
    RoamingNotAllowedCause._cont = ASN1Dict([(u'plmnRoamingNotAllowed', 0), (u'operatorDeterminedBarring', 3)])
    RoamingNotAllowedCause._ext = None
    
    #-----< CallBarredParam >-----#
    CallBarredParam = CHOICE(name=u'CallBarredParam', mode=MODE_TYPE)
    _CallBarredParam_callBarringCause = ENUM(name=u'callBarringCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'CallBarringCause')))
    _CallBarredParam_extensibleCallBarredParam = SEQ(name=u'extensibleCallBarredParam', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'ExtensibleCallBarredParam')))
    CallBarredParam._cont = ASN1Dict([
        (u'callBarringCause', _CallBarredParam_callBarringCause),
        (u'extensibleCallBarredParam', _CallBarredParam_extensibleCallBarredParam),
        ])
    CallBarredParam._ext = None
    
    #-----< CallBarringCause >-----#
    CallBarringCause = ENUM(name=u'CallBarringCause', mode=MODE_TYPE)
    CallBarringCause._cont = ASN1Dict([(u'barringServiceActive', 0), (u'operatorBarring', 1)])
    CallBarringCause._ext = None
    
    #-----< ExtensibleCallBarredParam >-----#
    ExtensibleCallBarredParam = SEQ(name=u'ExtensibleCallBarredParam', mode=MODE_TYPE)
    _ExtensibleCallBarredParam_callBarringCause = ENUM(name=u'callBarringCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'CallBarringCause')), opt=True)
    _ExtensibleCallBarredParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ExtensibleCallBarredParam_unauthorisedMessageOriginator = NULL(name=u'unauthorisedMessageOriginator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ExtensibleCallBarredParam_anonymousCallRejection = NULL(name=u'anonymousCallRejection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ExtensibleCallBarredParam._cont = ASN1Dict([
        (u'callBarringCause', _ExtensibleCallBarredParam_callBarringCause),
        (u'extensionContainer', _ExtensibleCallBarredParam_extensionContainer),
        (u'unauthorisedMessageOriginator', _ExtensibleCallBarredParam_unauthorisedMessageOriginator),
        (u'anonymousCallRejection', _ExtensibleCallBarredParam_anonymousCallRejection),
        ])
    ExtensibleCallBarredParam._ext = [u'unauthorisedMessageOriginator', u'anonymousCallRejection']
    
    #-----< CUG-RejectParam >-----#
    CUG_RejectParam = SEQ(name=u'CUG-RejectParam', mode=MODE_TYPE)
    _CUG_RejectParam_cug_RejectCause = ENUM(name=u'cug-RejectCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'CUG-RejectCause')), opt=True)
    _CUG_RejectParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_RejectParam._cont = ASN1Dict([
        (u'cug-RejectCause', _CUG_RejectParam_cug_RejectCause),
        (u'extensionContainer', _CUG_RejectParam_extensionContainer),
        ])
    CUG_RejectParam._ext = []
    
    #-----< CUG-RejectCause >-----#
    CUG_RejectCause = ENUM(name=u'CUG-RejectCause', mode=MODE_TYPE)
    CUG_RejectCause._cont = ASN1Dict([(u'incomingCallsBarredWithinCUG', 0), (u'subscriberNotMemberOfCUG', 1), (u'requestedBasicServiceViolatesCUG-Constraints', 5), (u'calledPartySS-InteractionViolation', 7)])
    CUG_RejectCause._ext = None
    
    #-----< SS-IncompatibilityCause >-----#
    SS_IncompatibilityCause = SEQ(name=u'SS-IncompatibilityCause', mode=MODE_TYPE)
    _SS_IncompatibilityCause_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _SS_IncompatibilityCause_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _SS_IncompatibilityCause_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    SS_IncompatibilityCause._cont = ASN1Dict([
        (u'ss-Code', _SS_IncompatibilityCause_ss_Code),
        (u'basicService', _SS_IncompatibilityCause_basicService),
        (u'ss-Status', _SS_IncompatibilityCause_ss_Status),
        ])
    SS_IncompatibilityCause._ext = []
    
    #-----< PW-RegistrationFailureCause >-----#
    PW_RegistrationFailureCause = ENUM(name=u'PW-RegistrationFailureCause', mode=MODE_TYPE)
    PW_RegistrationFailureCause._cont = ASN1Dict([(u'undetermined', 0), (u'invalidFormat', 1), (u'newPasswordsMismatch', 2)])
    PW_RegistrationFailureCause._ext = None
    
    #-----< SM-EnumeratedDeliveryFailureCause >-----#
    SM_EnumeratedDeliveryFailureCause = ENUM(name=u'SM-EnumeratedDeliveryFailureCause', mode=MODE_TYPE)
    SM_EnumeratedDeliveryFailureCause._cont = ASN1Dict([(u'memoryCapacityExceeded', 0), (u'equipmentProtocolError', 1), (u'equipmentNotSM-Equipped', 2), (u'unknownServiceCentre', 3), (u'sc-Congestion', 4), (u'invalidSME-Address', 5), (u'subscriberNotSC-Subscriber', 6)])
    SM_EnumeratedDeliveryFailureCause._ext = None
    
    #-----< SM-DeliveryFailureCause >-----#
    SM_DeliveryFailureCause = SEQ(name=u'SM-DeliveryFailureCause', mode=MODE_TYPE)
    _SM_DeliveryFailureCause_sm_EnumeratedDeliveryFailureCause = ENUM(name=u'sm-EnumeratedDeliveryFailureCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'SM-EnumeratedDeliveryFailureCause')))
    _SM_DeliveryFailureCause_diagnosticInfo = OCT_STR(name=u'diagnosticInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')), opt=True)
    _SM_DeliveryFailureCause_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SM_DeliveryFailureCause._cont = ASN1Dict([
        (u'sm-EnumeratedDeliveryFailureCause', _SM_DeliveryFailureCause_sm_EnumeratedDeliveryFailureCause),
        (u'diagnosticInfo', _SM_DeliveryFailureCause_diagnosticInfo),
        (u'extensionContainer', _SM_DeliveryFailureCause_extensionContainer),
        ])
    SM_DeliveryFailureCause._ext = []
    
    #-----< AbsentSubscriberSM-Param >-----#
    AbsentSubscriberSM_Param = SEQ(name=u'AbsentSubscriberSM-Param', mode=MODE_TYPE)
    _AbsentSubscriberSM_Param_absentSubscriberDiagnosticSM = INT(name=u'absentSubscriberDiagnosticSM', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _AbsentSubscriberSM_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AbsentSubscriberSM_Param_additionalAbsentSubscriberDiagnosticSM = INT(name=u'additionalAbsentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _AbsentSubscriberSM_Param_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _AbsentSubscriberSM_Param_requestedRetransmissionTime = OCT_STR(name=u'requestedRetransmissionTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _AbsentSubscriberSM_Param_userIdentifierAlert = OCT_STR(name=u'userIdentifierAlert', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    AbsentSubscriberSM_Param._cont = ASN1Dict([
        (u'absentSubscriberDiagnosticSM', _AbsentSubscriberSM_Param_absentSubscriberDiagnosticSM),
        (u'extensionContainer', _AbsentSubscriberSM_Param_extensionContainer),
        (u'additionalAbsentSubscriberDiagnosticSM', _AbsentSubscriberSM_Param_additionalAbsentSubscriberDiagnosticSM),
        (u'imsi', _AbsentSubscriberSM_Param_imsi),
        (u'requestedRetransmissionTime', _AbsentSubscriberSM_Param_requestedRetransmissionTime),
        (u'userIdentifierAlert', _AbsentSubscriberSM_Param_userIdentifierAlert),
        ])
    AbsentSubscriberSM_Param._ext = [u'additionalAbsentSubscriberDiagnosticSM', u'imsi', u'requestedRetransmissionTime', u'userIdentifierAlert']
    
    #-----< AbsentSubscriberDiagnosticSM >-----#
    AbsentSubscriberDiagnosticSM = INT(name=u'AbsentSubscriberDiagnosticSM', mode=MODE_TYPE)
    AbsentSubscriberDiagnosticSM._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< SystemFailureParam >-----#
    SystemFailureParam = CHOICE(name=u'SystemFailureParam', mode=MODE_TYPE)
    _SystemFailureParam_networkResource = ENUM(name=u'networkResource', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkResource')))
    _SystemFailureParam_extensibleSystemFailureParam = SEQ(name=u'extensibleSystemFailureParam', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'ExtensibleSystemFailureParam')))
    SystemFailureParam._cont = ASN1Dict([
        (u'networkResource', _SystemFailureParam_networkResource),
        (u'extensibleSystemFailureParam', _SystemFailureParam_extensibleSystemFailureParam),
        ])
    SystemFailureParam._ext = None
    
    #-----< ExtensibleSystemFailureParam >-----#
    ExtensibleSystemFailureParam = SEQ(name=u'ExtensibleSystemFailureParam', mode=MODE_TYPE)
    _ExtensibleSystemFailureParam_networkResource = ENUM(name=u'networkResource', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkResource')), opt=True)
    _ExtensibleSystemFailureParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ExtensibleSystemFailureParam_additionalNetworkResource = ENUM(name=u'additionalNetworkResource', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AdditionalNetworkResource')), opt=True)
    _ExtensibleSystemFailureParam_failureCauseParam = ENUM(name=u'failureCauseParam', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'FailureCauseParam')), opt=True)
    ExtensibleSystemFailureParam._cont = ASN1Dict([
        (u'networkResource', _ExtensibleSystemFailureParam_networkResource),
        (u'extensionContainer', _ExtensibleSystemFailureParam_extensionContainer),
        (u'additionalNetworkResource', _ExtensibleSystemFailureParam_additionalNetworkResource),
        (u'failureCauseParam', _ExtensibleSystemFailureParam_failureCauseParam),
        ])
    ExtensibleSystemFailureParam._ext = [u'additionalNetworkResource', u'failureCauseParam']
    
    #-----< FailureCauseParam >-----#
    FailureCauseParam = ENUM(name=u'FailureCauseParam', mode=MODE_TYPE)
    FailureCauseParam._cont = ASN1Dict([(u'limitReachedOnNumberOfConcurrentLocationRequests', 0)])
    FailureCauseParam._ext = []
    
    #-----< DataMissingParam >-----#
    DataMissingParam = SEQ(name=u'DataMissingParam', mode=MODE_TYPE)
    _DataMissingParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DataMissingParam._cont = ASN1Dict([
        (u'extensionContainer', _DataMissingParam_extensionContainer),
        ])
    DataMissingParam._ext = []
    
    #-----< UnexpectedDataParam >-----#
    UnexpectedDataParam = SEQ(name=u'UnexpectedDataParam', mode=MODE_TYPE)
    _UnexpectedDataParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UnexpectedDataParam_unexpectedSubscriber = NULL(name=u'unexpectedSubscriber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UnexpectedDataParam._cont = ASN1Dict([
        (u'extensionContainer', _UnexpectedDataParam_extensionContainer),
        (u'unexpectedSubscriber', _UnexpectedDataParam_unexpectedSubscriber),
        ])
    UnexpectedDataParam._ext = [u'unexpectedSubscriber']
    
    #-----< FacilityNotSupParam >-----#
    FacilityNotSupParam = SEQ(name=u'FacilityNotSupParam', mode=MODE_TYPE)
    _FacilityNotSupParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _FacilityNotSupParam_shapeOfLocationEstimateNotSupported = NULL(name=u'shapeOfLocationEstimateNotSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _FacilityNotSupParam_neededLcsCapabilityNotSupportedInServingNode = NULL(name=u'neededLcsCapabilityNotSupportedInServingNode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    FacilityNotSupParam._cont = ASN1Dict([
        (u'extensionContainer', _FacilityNotSupParam_extensionContainer),
        (u'shapeOfLocationEstimateNotSupported', _FacilityNotSupParam_shapeOfLocationEstimateNotSupported),
        (u'neededLcsCapabilityNotSupportedInServingNode', _FacilityNotSupParam_neededLcsCapabilityNotSupportedInServingNode),
        ])
    FacilityNotSupParam._ext = [u'shapeOfLocationEstimateNotSupported', u'neededLcsCapabilityNotSupportedInServingNode']
    
    #-----< OR-NotAllowedParam >-----#
    OR_NotAllowedParam = SEQ(name=u'OR-NotAllowedParam', mode=MODE_TYPE)
    _OR_NotAllowedParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    OR_NotAllowedParam._cont = ASN1Dict([
        (u'extensionContainer', _OR_NotAllowedParam_extensionContainer),
        ])
    OR_NotAllowedParam._ext = []
    
    #-----< UnknownSubscriberParam >-----#
    UnknownSubscriberParam = SEQ(name=u'UnknownSubscriberParam', mode=MODE_TYPE)
    _UnknownSubscriberParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UnknownSubscriberParam_unknownSubscriberDiagnostic = ENUM(name=u'unknownSubscriberDiagnostic', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'UnknownSubscriberDiagnostic')), opt=True)
    UnknownSubscriberParam._cont = ASN1Dict([
        (u'extensionContainer', _UnknownSubscriberParam_extensionContainer),
        (u'unknownSubscriberDiagnostic', _UnknownSubscriberParam_unknownSubscriberDiagnostic),
        ])
    UnknownSubscriberParam._ext = [u'unknownSubscriberDiagnostic']
    
    #-----< UnknownSubscriberDiagnostic >-----#
    UnknownSubscriberDiagnostic = ENUM(name=u'UnknownSubscriberDiagnostic', mode=MODE_TYPE)
    UnknownSubscriberDiagnostic._cont = ASN1Dict([(u'imsiUnknown', 0), (u'gprs-eps-SubscriptionUnknown', 1), (u'npdbMismatch', 2)])
    UnknownSubscriberDiagnostic._ext = [u'npdbMismatch']
    
    #-----< NumberChangedParam >-----#
    NumberChangedParam = SEQ(name=u'NumberChangedParam', mode=MODE_TYPE)
    _NumberChangedParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NumberChangedParam._cont = ASN1Dict([
        (u'extensionContainer', _NumberChangedParam_extensionContainer),
        ])
    NumberChangedParam._ext = []
    
    #-----< UnidentifiedSubParam >-----#
    UnidentifiedSubParam = SEQ(name=u'UnidentifiedSubParam', mode=MODE_TYPE)
    _UnidentifiedSubParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnidentifiedSubParam._cont = ASN1Dict([
        (u'extensionContainer', _UnidentifiedSubParam_extensionContainer),
        ])
    UnidentifiedSubParam._ext = []
    
    #-----< IllegalSubscriberParam >-----#
    IllegalSubscriberParam = SEQ(name=u'IllegalSubscriberParam', mode=MODE_TYPE)
    _IllegalSubscriberParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IllegalSubscriberParam._cont = ASN1Dict([
        (u'extensionContainer', _IllegalSubscriberParam_extensionContainer),
        ])
    IllegalSubscriberParam._ext = []
    
    #-----< IllegalEquipmentParam >-----#
    IllegalEquipmentParam = SEQ(name=u'IllegalEquipmentParam', mode=MODE_TYPE)
    _IllegalEquipmentParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IllegalEquipmentParam._cont = ASN1Dict([
        (u'extensionContainer', _IllegalEquipmentParam_extensionContainer),
        ])
    IllegalEquipmentParam._ext = []
    
    #-----< BearerServNotProvParam >-----#
    BearerServNotProvParam = SEQ(name=u'BearerServNotProvParam', mode=MODE_TYPE)
    _BearerServNotProvParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    BearerServNotProvParam._cont = ASN1Dict([
        (u'extensionContainer', _BearerServNotProvParam_extensionContainer),
        ])
    BearerServNotProvParam._ext = []
    
    #-----< TeleservNotProvParam >-----#
    TeleservNotProvParam = SEQ(name=u'TeleservNotProvParam', mode=MODE_TYPE)
    _TeleservNotProvParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    TeleservNotProvParam._cont = ASN1Dict([
        (u'extensionContainer', _TeleservNotProvParam_extensionContainer),
        ])
    TeleservNotProvParam._ext = []
    
    #-----< TracingBufferFullParam >-----#
    TracingBufferFullParam = SEQ(name=u'TracingBufferFullParam', mode=MODE_TYPE)
    _TracingBufferFullParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    TracingBufferFullParam._cont = ASN1Dict([
        (u'extensionContainer', _TracingBufferFullParam_extensionContainer),
        ])
    TracingBufferFullParam._ext = []
    
    #-----< NoRoamingNbParam >-----#
    NoRoamingNbParam = SEQ(name=u'NoRoamingNbParam', mode=MODE_TYPE)
    _NoRoamingNbParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoRoamingNbParam._cont = ASN1Dict([
        (u'extensionContainer', _NoRoamingNbParam_extensionContainer),
        ])
    NoRoamingNbParam._ext = []
    
    #-----< AbsentSubscriberParam >-----#
    AbsentSubscriberParam = SEQ(name=u'AbsentSubscriberParam', mode=MODE_TYPE)
    _AbsentSubscriberParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AbsentSubscriberParam_absentSubscriberReason = ENUM(name=u'absentSubscriberReason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberReason')), opt=True)
    AbsentSubscriberParam._cont = ASN1Dict([
        (u'extensionContainer', _AbsentSubscriberParam_extensionContainer),
        (u'absentSubscriberReason', _AbsentSubscriberParam_absentSubscriberReason),
        ])
    AbsentSubscriberParam._ext = [u'absentSubscriberReason']
    
    #-----< AbsentSubscriberReason >-----#
    AbsentSubscriberReason = ENUM(name=u'AbsentSubscriberReason', mode=MODE_TYPE)
    AbsentSubscriberReason._cont = ASN1Dict([(u'imsiDetach', 0), (u'restrictedArea', 1), (u'noPageResponse', 2), (u'purgedMS', 3), (u'mtRoamingRetry', 4), (u'busySubscriber', 5)])
    AbsentSubscriberReason._ext = [u'purgedMS', u'mtRoamingRetry', u'busySubscriber']
    
    #-----< BusySubscriberParam >-----#
    BusySubscriberParam = SEQ(name=u'BusySubscriberParam', mode=MODE_TYPE)
    _BusySubscriberParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _BusySubscriberParam_ccbs_Possible = NULL(name=u'ccbs-Possible', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BusySubscriberParam_ccbs_Busy = NULL(name=u'ccbs-Busy', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    BusySubscriberParam._cont = ASN1Dict([
        (u'extensionContainer', _BusySubscriberParam_extensionContainer),
        (u'ccbs-Possible', _BusySubscriberParam_ccbs_Possible),
        (u'ccbs-Busy', _BusySubscriberParam_ccbs_Busy),
        ])
    BusySubscriberParam._ext = [u'ccbs-Possible', u'ccbs-Busy']
    
    #-----< NoSubscriberReplyParam >-----#
    NoSubscriberReplyParam = SEQ(name=u'NoSubscriberReplyParam', mode=MODE_TYPE)
    _NoSubscriberReplyParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoSubscriberReplyParam._cont = ASN1Dict([
        (u'extensionContainer', _NoSubscriberReplyParam_extensionContainer),
        ])
    NoSubscriberReplyParam._ext = []
    
    #-----< ForwardingViolationParam >-----#
    ForwardingViolationParam = SEQ(name=u'ForwardingViolationParam', mode=MODE_TYPE)
    _ForwardingViolationParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ForwardingViolationParam._cont = ASN1Dict([
        (u'extensionContainer', _ForwardingViolationParam_extensionContainer),
        ])
    ForwardingViolationParam._ext = []
    
    #-----< ForwardingFailedParam >-----#
    ForwardingFailedParam = SEQ(name=u'ForwardingFailedParam', mode=MODE_TYPE)
    _ForwardingFailedParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ForwardingFailedParam._cont = ASN1Dict([
        (u'extensionContainer', _ForwardingFailedParam_extensionContainer),
        ])
    ForwardingFailedParam._ext = []
    
    #-----< ATI-NotAllowedParam >-----#
    ATI_NotAllowedParam = SEQ(name=u'ATI-NotAllowedParam', mode=MODE_TYPE)
    _ATI_NotAllowedParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ATI_NotAllowedParam._cont = ASN1Dict([
        (u'extensionContainer', _ATI_NotAllowedParam_extensionContainer),
        ])
    ATI_NotAllowedParam._ext = []
    
    #-----< ATSI-NotAllowedParam >-----#
    ATSI_NotAllowedParam = SEQ(name=u'ATSI-NotAllowedParam', mode=MODE_TYPE)
    _ATSI_NotAllowedParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ATSI_NotAllowedParam._cont = ASN1Dict([
        (u'extensionContainer', _ATSI_NotAllowedParam_extensionContainer),
        ])
    ATSI_NotAllowedParam._ext = []
    
    #-----< ATM-NotAllowedParam >-----#
    ATM_NotAllowedParam = SEQ(name=u'ATM-NotAllowedParam', mode=MODE_TYPE)
    _ATM_NotAllowedParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ATM_NotAllowedParam._cont = ASN1Dict([
        (u'extensionContainer', _ATM_NotAllowedParam_extensionContainer),
        ])
    ATM_NotAllowedParam._ext = []
    
    #-----< IllegalSS-OperationParam >-----#
    IllegalSS_OperationParam = SEQ(name=u'IllegalSS-OperationParam', mode=MODE_TYPE)
    _IllegalSS_OperationParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IllegalSS_OperationParam._cont = ASN1Dict([
        (u'extensionContainer', _IllegalSS_OperationParam_extensionContainer),
        ])
    IllegalSS_OperationParam._ext = []
    
    #-----< SS-NotAvailableParam >-----#
    SS_NotAvailableParam = SEQ(name=u'SS-NotAvailableParam', mode=MODE_TYPE)
    _SS_NotAvailableParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_NotAvailableParam._cont = ASN1Dict([
        (u'extensionContainer', _SS_NotAvailableParam_extensionContainer),
        ])
    SS_NotAvailableParam._ext = []
    
    #-----< SS-SubscriptionViolationParam >-----#
    SS_SubscriptionViolationParam = SEQ(name=u'SS-SubscriptionViolationParam', mode=MODE_TYPE)
    _SS_SubscriptionViolationParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_SubscriptionViolationParam._cont = ASN1Dict([
        (u'extensionContainer', _SS_SubscriptionViolationParam_extensionContainer),
        ])
    SS_SubscriptionViolationParam._ext = []
    
    #-----< InformationNotAvailableParam >-----#
    InformationNotAvailableParam = SEQ(name=u'InformationNotAvailableParam', mode=MODE_TYPE)
    _InformationNotAvailableParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    InformationNotAvailableParam._cont = ASN1Dict([
        (u'extensionContainer', _InformationNotAvailableParam_extensionContainer),
        ])
    InformationNotAvailableParam._ext = []
    
    #-----< SubBusyForMT-SMS-Param >-----#
    SubBusyForMT_SMS_Param = SEQ(name=u'SubBusyForMT-SMS-Param', mode=MODE_TYPE)
    _SubBusyForMT_SMS_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SubBusyForMT_SMS_Param_gprsConnectionSuspended = NULL(name=u'gprsConnectionSuspended', mode=MODE_TYPE, opt=True)
    SubBusyForMT_SMS_Param._cont = ASN1Dict([
        (u'extensionContainer', _SubBusyForMT_SMS_Param_extensionContainer),
        (u'gprsConnectionSuspended', _SubBusyForMT_SMS_Param_gprsConnectionSuspended),
        ])
    SubBusyForMT_SMS_Param._ext = [u'gprsConnectionSuspended']
    
    #-----< MessageWaitListFullParam >-----#
    MessageWaitListFullParam = SEQ(name=u'MessageWaitListFullParam', mode=MODE_TYPE)
    _MessageWaitListFullParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MessageWaitListFullParam._cont = ASN1Dict([
        (u'extensionContainer', _MessageWaitListFullParam_extensionContainer),
        ])
    MessageWaitListFullParam._ext = []
    
    #-----< ResourceLimitationParam >-----#
    ResourceLimitationParam = SEQ(name=u'ResourceLimitationParam', mode=MODE_TYPE)
    _ResourceLimitationParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ResourceLimitationParam._cont = ASN1Dict([
        (u'extensionContainer', _ResourceLimitationParam_extensionContainer),
        ])
    ResourceLimitationParam._ext = []
    
    #-----< NoGroupCallNbParam >-----#
    NoGroupCallNbParam = SEQ(name=u'NoGroupCallNbParam', mode=MODE_TYPE)
    _NoGroupCallNbParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoGroupCallNbParam._cont = ASN1Dict([
        (u'extensionContainer', _NoGroupCallNbParam_extensionContainer),
        ])
    NoGroupCallNbParam._ext = []
    
    #-----< IncompatibleTerminalParam >-----#
    IncompatibleTerminalParam = SEQ(name=u'IncompatibleTerminalParam', mode=MODE_TYPE)
    _IncompatibleTerminalParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IncompatibleTerminalParam._cont = ASN1Dict([
        (u'extensionContainer', _IncompatibleTerminalParam_extensionContainer),
        ])
    IncompatibleTerminalParam._ext = []
    
    #-----< ShortTermDenialParam >-----#
    ShortTermDenialParam = SEQ(name=u'ShortTermDenialParam', mode=MODE_TYPE)
    ShortTermDenialParam._cont = ASN1Dict([
        ])
    ShortTermDenialParam._ext = []
    
    #-----< LongTermDenialParam >-----#
    LongTermDenialParam = SEQ(name=u'LongTermDenialParam', mode=MODE_TYPE)
    LongTermDenialParam._cont = ASN1Dict([
        ])
    LongTermDenialParam._ext = []
    
    #-----< UnauthorizedRequestingNetwork-Param >-----#
    UnauthorizedRequestingNetwork_Param = SEQ(name=u'UnauthorizedRequestingNetwork-Param', mode=MODE_TYPE)
    _UnauthorizedRequestingNetwork_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnauthorizedRequestingNetwork_Param._cont = ASN1Dict([
        (u'extensionContainer', _UnauthorizedRequestingNetwork_Param_extensionContainer),
        ])
    UnauthorizedRequestingNetwork_Param._ext = []
    
    #-----< UnauthorizedLCSClient-Param >-----#
    UnauthorizedLCSClient_Param = SEQ(name=u'UnauthorizedLCSClient-Param', mode=MODE_TYPE)
    _UnauthorizedLCSClient_Param_unauthorizedLCSClient_Diagnostic = ENUM(name=u'unauthorizedLCSClient-Diagnostic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'UnauthorizedLCSClient-Diagnostic')), opt=True)
    _UnauthorizedLCSClient_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnauthorizedLCSClient_Param._cont = ASN1Dict([
        (u'unauthorizedLCSClient-Diagnostic', _UnauthorizedLCSClient_Param_unauthorizedLCSClient_Diagnostic),
        (u'extensionContainer', _UnauthorizedLCSClient_Param_extensionContainer),
        ])
    UnauthorizedLCSClient_Param._ext = []
    
    #-----< UnauthorizedLCSClient-Diagnostic >-----#
    UnauthorizedLCSClient_Diagnostic = ENUM(name=u'UnauthorizedLCSClient-Diagnostic', mode=MODE_TYPE)
    UnauthorizedLCSClient_Diagnostic._cont = ASN1Dict([(u'noAdditionalInformation', 0), (u'clientNotInMSPrivacyExceptionList', 1), (u'callToClientNotSetup', 2), (u'privacyOverrideNotApplicable', 3), (u'disallowedByLocalRegulatoryRequirements', 4), (u'unauthorizedPrivacyClass', 5), (u'unauthorizedCallSessionUnrelatedExternalClient', 6), (u'unauthorizedCallSessionRelatedExternalClient', 7)])
    UnauthorizedLCSClient_Diagnostic._ext = [u'unauthorizedPrivacyClass', u'unauthorizedCallSessionUnrelatedExternalClient', u'unauthorizedCallSessionRelatedExternalClient']
    
    #-----< PositionMethodFailure-Param >-----#
    PositionMethodFailure_Param = SEQ(name=u'PositionMethodFailure-Param', mode=MODE_TYPE)
    _PositionMethodFailure_Param_positionMethodFailure_Diagnostic = ENUM(name=u'positionMethodFailure-Diagnostic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'PositionMethodFailure-Diagnostic')), opt=True)
    _PositionMethodFailure_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PositionMethodFailure_Param._cont = ASN1Dict([
        (u'positionMethodFailure-Diagnostic', _PositionMethodFailure_Param_positionMethodFailure_Diagnostic),
        (u'extensionContainer', _PositionMethodFailure_Param_extensionContainer),
        ])
    PositionMethodFailure_Param._ext = []
    
    #-----< PositionMethodFailure-Diagnostic >-----#
    PositionMethodFailure_Diagnostic = ENUM(name=u'PositionMethodFailure-Diagnostic', mode=MODE_TYPE)
    PositionMethodFailure_Diagnostic._cont = ASN1Dict([(u'congestion', 0), (u'insufficientResources', 1), (u'insufficientMeasurementData', 2), (u'inconsistentMeasurementData', 3), (u'locationProcedureNotCompleted', 4), (u'locationProcedureNotSupportedByTargetMS', 5), (u'qoSNotAttainable', 6), (u'positionMethodNotAvailableInNetwork', 7), (u'positionMethodNotAvailableInLocationArea', 8)])
    PositionMethodFailure_Diagnostic._ext = []
    
    #-----< UnknownOrUnreachableLCSClient-Param >-----#
    UnknownOrUnreachableLCSClient_Param = SEQ(name=u'UnknownOrUnreachableLCSClient-Param', mode=MODE_TYPE)
    _UnknownOrUnreachableLCSClient_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UnknownOrUnreachableLCSClient_Param._cont = ASN1Dict([
        (u'extensionContainer', _UnknownOrUnreachableLCSClient_Param_extensionContainer),
        ])
    UnknownOrUnreachableLCSClient_Param._ext = []
    
    #-----< MM-EventNotSupported-Param >-----#
    MM_EventNotSupported_Param = SEQ(name=u'MM-EventNotSupported-Param', mode=MODE_TYPE)
    _MM_EventNotSupported_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MM_EventNotSupported_Param._cont = ASN1Dict([
        (u'extensionContainer', _MM_EventNotSupported_Param_extensionContainer),
        ])
    MM_EventNotSupported_Param._ext = []
    
    #-----< TargetCellOutsideGCA-Param >-----#
    TargetCellOutsideGCA_Param = SEQ(name=u'TargetCellOutsideGCA-Param', mode=MODE_TYPE)
    _TargetCellOutsideGCA_Param_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    TargetCellOutsideGCA_Param._cont = ASN1Dict([
        (u'extensionContainer', _TargetCellOutsideGCA_Param_extensionContainer),
        ])
    TargetCellOutsideGCA_Param._ext = []
    
    #-----< OngoingGroupCallParam >-----#
    OngoingGroupCallParam = SEQ(name=u'OngoingGroupCallParam', mode=MODE_TYPE)
    _OngoingGroupCallParam_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    OngoingGroupCallParam._cont = ASN1Dict([
        (u'extensionContainer', _OngoingGroupCallParam_extensionContainer),
        ])
    OngoingGroupCallParam._ext = []
    
    _all_ = [
        _RoamingNotAllowedParam_roamingNotAllowedCause,
        _RoamingNotAllowedParam_extensionContainer,
        _RoamingNotAllowedParam_additionalRoamingNotAllowedCause,
        RoamingNotAllowedParam,
        AdditionalRoamingNotAllowedCause,
        RoamingNotAllowedCause,
        _CallBarredParam_callBarringCause,
        _CallBarredParam_extensibleCallBarredParam,
        CallBarredParam,
        CallBarringCause,
        _ExtensibleCallBarredParam_callBarringCause,
        _ExtensibleCallBarredParam_extensionContainer,
        _ExtensibleCallBarredParam_unauthorisedMessageOriginator,
        _ExtensibleCallBarredParam_anonymousCallRejection,
        ExtensibleCallBarredParam,
        _CUG_RejectParam_cug_RejectCause,
        _CUG_RejectParam_extensionContainer,
        CUG_RejectParam,
        CUG_RejectCause,
        _SS_IncompatibilityCause_ss_Code,
        _SS_IncompatibilityCause_basicService,
        _SS_IncompatibilityCause_ss_Status,
        SS_IncompatibilityCause,
        PW_RegistrationFailureCause,
        SM_EnumeratedDeliveryFailureCause,
        _SM_DeliveryFailureCause_sm_EnumeratedDeliveryFailureCause,
        _SM_DeliveryFailureCause_diagnosticInfo,
        _SM_DeliveryFailureCause_extensionContainer,
        SM_DeliveryFailureCause,
        _AbsentSubscriberSM_Param_absentSubscriberDiagnosticSM,
        _AbsentSubscriberSM_Param_extensionContainer,
        _AbsentSubscriberSM_Param_additionalAbsentSubscriberDiagnosticSM,
        _AbsentSubscriberSM_Param_imsi,
        _AbsentSubscriberSM_Param_requestedRetransmissionTime,
        _AbsentSubscriberSM_Param_userIdentifierAlert,
        AbsentSubscriberSM_Param,
        AbsentSubscriberDiagnosticSM,
        _SystemFailureParam_networkResource,
        _SystemFailureParam_extensibleSystemFailureParam,
        SystemFailureParam,
        _ExtensibleSystemFailureParam_networkResource,
        _ExtensibleSystemFailureParam_extensionContainer,
        _ExtensibleSystemFailureParam_additionalNetworkResource,
        _ExtensibleSystemFailureParam_failureCauseParam,
        ExtensibleSystemFailureParam,
        FailureCauseParam,
        _DataMissingParam_extensionContainer,
        DataMissingParam,
        _UnexpectedDataParam_extensionContainer,
        _UnexpectedDataParam_unexpectedSubscriber,
        UnexpectedDataParam,
        _FacilityNotSupParam_extensionContainer,
        _FacilityNotSupParam_shapeOfLocationEstimateNotSupported,
        _FacilityNotSupParam_neededLcsCapabilityNotSupportedInServingNode,
        FacilityNotSupParam,
        _OR_NotAllowedParam_extensionContainer,
        OR_NotAllowedParam,
        _UnknownSubscriberParam_extensionContainer,
        _UnknownSubscriberParam_unknownSubscriberDiagnostic,
        UnknownSubscriberParam,
        UnknownSubscriberDiagnostic,
        _NumberChangedParam_extensionContainer,
        NumberChangedParam,
        _UnidentifiedSubParam_extensionContainer,
        UnidentifiedSubParam,
        _IllegalSubscriberParam_extensionContainer,
        IllegalSubscriberParam,
        _IllegalEquipmentParam_extensionContainer,
        IllegalEquipmentParam,
        _BearerServNotProvParam_extensionContainer,
        BearerServNotProvParam,
        _TeleservNotProvParam_extensionContainer,
        TeleservNotProvParam,
        _TracingBufferFullParam_extensionContainer,
        TracingBufferFullParam,
        _NoRoamingNbParam_extensionContainer,
        NoRoamingNbParam,
        _AbsentSubscriberParam_extensionContainer,
        _AbsentSubscriberParam_absentSubscriberReason,
        AbsentSubscriberParam,
        AbsentSubscriberReason,
        _BusySubscriberParam_extensionContainer,
        _BusySubscriberParam_ccbs_Possible,
        _BusySubscriberParam_ccbs_Busy,
        BusySubscriberParam,
        _NoSubscriberReplyParam_extensionContainer,
        NoSubscriberReplyParam,
        _ForwardingViolationParam_extensionContainer,
        ForwardingViolationParam,
        _ForwardingFailedParam_extensionContainer,
        ForwardingFailedParam,
        _ATI_NotAllowedParam_extensionContainer,
        ATI_NotAllowedParam,
        _ATSI_NotAllowedParam_extensionContainer,
        ATSI_NotAllowedParam,
        _ATM_NotAllowedParam_extensionContainer,
        ATM_NotAllowedParam,
        _IllegalSS_OperationParam_extensionContainer,
        IllegalSS_OperationParam,
        _SS_NotAvailableParam_extensionContainer,
        SS_NotAvailableParam,
        _SS_SubscriptionViolationParam_extensionContainer,
        SS_SubscriptionViolationParam,
        _InformationNotAvailableParam_extensionContainer,
        InformationNotAvailableParam,
        _SubBusyForMT_SMS_Param_extensionContainer,
        _SubBusyForMT_SMS_Param_gprsConnectionSuspended,
        SubBusyForMT_SMS_Param,
        _MessageWaitListFullParam_extensionContainer,
        MessageWaitListFullParam,
        _ResourceLimitationParam_extensionContainer,
        ResourceLimitationParam,
        _NoGroupCallNbParam_extensionContainer,
        NoGroupCallNbParam,
        _IncompatibleTerminalParam_extensionContainer,
        IncompatibleTerminalParam,
        ShortTermDenialParam,
        LongTermDenialParam,
        _UnauthorizedRequestingNetwork_Param_extensionContainer,
        UnauthorizedRequestingNetwork_Param,
        _UnauthorizedLCSClient_Param_unauthorizedLCSClient_Diagnostic,
        _UnauthorizedLCSClient_Param_extensionContainer,
        UnauthorizedLCSClient_Param,
        UnauthorizedLCSClient_Diagnostic,
        _PositionMethodFailure_Param_positionMethodFailure_Diagnostic,
        _PositionMethodFailure_Param_extensionContainer,
        PositionMethodFailure_Param,
        PositionMethodFailure_Diagnostic,
        _UnknownOrUnreachableLCSClient_Param_extensionContainer,
        UnknownOrUnreachableLCSClient_Param,
        _MM_EventNotSupported_Param_extensionContainer,
        MM_EventNotSupported_Param,
        _TargetCellOutsideGCA_Param_extensionContainer,
        TargetCellOutsideGCA_Param,
        _OngoingGroupCallParam_extensionContainer,
        OngoingGroupCallParam,
    ]

class MAP_ExtensionDataTypes:

    _name_  = u'MAP-ExtensionDataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 21, 19]
    
    _obj_ = [
        u'MAP-EXTENSION',
        u'ExtensionContainer',
        u'SLR-ArgExtensionContainer',
        u'PrivateExtensionList',
        u'PrivateExtension',
        u'maxNumOfPrivateExtensions',
        u'ExtensionSet',
        u'PCS-Extensions',
        u'SLR-Arg-PCS-Extensions',
        ]
    _type_ = [
        u'MAP-EXTENSION',
        u'ExtensionContainer',
        u'SLR-ArgExtensionContainer',
        u'PrivateExtensionList',
        u'PrivateExtension',
        u'PCS-Extensions',
        u'SLR-Arg-PCS-Extensions',
        ]
    _set_ = [
        u'ExtensionSet',
        ]
    _val_ = [
        u'maxNumOfPrivateExtensions',
        ]
    _class_ = [
        u'MAP-EXTENSION',
        u'ExtensionSet',
        ]
    _param_ = [
        ]
    
    #-----< MAP-EXTENSION >-----#
    MAP_EXTENSION = CLASS(name=u'MAP-EXTENSION', mode=MODE_TYPE)
    _MAP_EXTENSION_ExtensionType = OPEN(name=u'ExtensionType', mode=MODE_TYPE, opt=True)
    _MAP_EXTENSION_extensionId = OID(name=u'extensionId', mode=MODE_VALUE)
    MAP_EXTENSION._cont = ASN1Dict([
        (u'ExtensionType', _MAP_EXTENSION_ExtensionType),
        (u'extensionId', _MAP_EXTENSION_extensionId),
        ])
    
    #-----< ExtensionContainer >-----#
    ExtensionContainer = SEQ(name=u'ExtensionContainer', mode=MODE_TYPE)
    _ExtensionContainer_privateExtensionList = SEQ_OF(name=u'privateExtensionList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PrivateExtensionList')), opt=True)
    _ExtensionContainer_pcs_Extensions = SEQ(name=u'pcs-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PCS-Extensions')), opt=True)
    ExtensionContainer._cont = ASN1Dict([
        (u'privateExtensionList', _ExtensionContainer_privateExtensionList),
        (u'pcs-Extensions', _ExtensionContainer_pcs_Extensions),
        ])
    ExtensionContainer._ext = []
    
    #-----< SLR-ArgExtensionContainer >-----#
    SLR_ArgExtensionContainer = SEQ(name=u'SLR-ArgExtensionContainer', mode=MODE_TYPE)
    _SLR_ArgExtensionContainer_privateExtensionList = SEQ_OF(name=u'privateExtensionList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PrivateExtensionList')), opt=True)
    _SLR_ArgExtensionContainer_slr_Arg_PCS_Extensions = SEQ(name=u'slr-Arg-PCS-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'SLR-Arg-PCS-Extensions')), opt=True)
    SLR_ArgExtensionContainer._cont = ASN1Dict([
        (u'privateExtensionList', _SLR_ArgExtensionContainer_privateExtensionList),
        (u'slr-Arg-PCS-Extensions', _SLR_ArgExtensionContainer_slr_Arg_PCS_Extensions),
        ])
    SLR_ArgExtensionContainer._ext = []
    
    #-----< PrivateExtensionList >-----#
    PrivateExtensionList = SEQ_OF(name=u'PrivateExtensionList', mode=MODE_TYPE)
    _PrivateExtensionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'PrivateExtension')))
    PrivateExtensionList._cont = _PrivateExtensionList__item_
    PrivateExtensionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< PrivateExtension >-----#
    PrivateExtension = SEQ(name=u'PrivateExtension', mode=MODE_TYPE)
    _PrivateExtension_extId = OID(name=u'extId', mode=MODE_TYPE, typeref=ASN1RefClassField(('MAP-ExtensionDataTypes', 'MAP-EXTENSION'), [u'extensionId']))
    __PrivateExtension_extId_tab = CLASS(name='_tab_MAP-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'MAP-EXTENSION')))
    __PrivateExtension_extId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PrivateExtension_extId._const_tab = __PrivateExtension_extId_tab
    _PrivateExtension_extId._const_tab_at = None
    _PrivateExtension_extId._const_tab_id = u'extensionId'
    _PrivateExtension_extType = OPEN(name=u'extType', mode=MODE_TYPE, typeref=ASN1RefClassField(('MAP-ExtensionDataTypes', 'MAP-EXTENSION'), [u'ExtensionType']), opt=True)
    __PrivateExtension_extType_tab = CLASS(name='_tab_MAP-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'MAP-EXTENSION')))
    __PrivateExtension_extType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PrivateExtension_extType._const_tab = __PrivateExtension_extType_tab
    _PrivateExtension_extType._const_tab_at = ('..', u'extId')
    _PrivateExtension_extType._const_tab_id = u'ExtensionType'
    PrivateExtension._cont = ASN1Dict([
        (u'extId', _PrivateExtension_extId),
        (u'extType', _PrivateExtension_extType),
        ])
    PrivateExtension._ext = None
    
    #-----< maxNumOfPrivateExtensions >-----#
    maxNumOfPrivateExtensions = INT(name=u'maxNumOfPrivateExtensions', mode=MODE_VALUE)
    maxNumOfPrivateExtensions._val = 10
    
    #-----< ExtensionSet >-----#
    ExtensionSet = CLASS(name=u'ExtensionSet', mode=MODE_SET, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'MAP-EXTENSION')))
    ExtensionSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PCS-Extensions >-----#
    PCS_Extensions = SEQ(name=u'PCS-Extensions', mode=MODE_TYPE)
    PCS_Extensions._cont = ASN1Dict([
        ])
    PCS_Extensions._ext = []
    
    #-----< SLR-Arg-PCS-Extensions >-----#
    SLR_Arg_PCS_Extensions = SEQ(name=u'SLR-Arg-PCS-Extensions', mode=MODE_TYPE)
    _SLR_Arg_PCS_Extensions_na_ESRK_Request = NULL(name=u'na-ESRK-Request', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SLR_Arg_PCS_Extensions._cont = ASN1Dict([
        (u'na-ESRK-Request', _SLR_Arg_PCS_Extensions_na_ESRK_Request),
        ])
    SLR_Arg_PCS_Extensions._ext = [u'na-ESRK-Request']
    
    _all_ = [
        _MAP_EXTENSION_ExtensionType,
        _MAP_EXTENSION_extensionId,
        MAP_EXTENSION,
        _ExtensionContainer_privateExtensionList,
        _ExtensionContainer_pcs_Extensions,
        ExtensionContainer,
        _SLR_ArgExtensionContainer_privateExtensionList,
        _SLR_ArgExtensionContainer_slr_Arg_PCS_Extensions,
        SLR_ArgExtensionContainer,
        _PrivateExtensionList__item_,
        PrivateExtensionList,
        __PrivateExtension_extId_tab,
        _PrivateExtension_extId,
        __PrivateExtension_extType_tab,
        _PrivateExtension_extType,
        PrivateExtension,
        maxNumOfPrivateExtensions,
        ExtensionSet,
        PCS_Extensions,
        _SLR_Arg_PCS_Extensions_na_ESRK_Request,
        SLR_Arg_PCS_Extensions,
    ]

class MAP_LCS_DataTypes:

    _name_  = u'MAP-LCS-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 25, 19]
    
    _obj_ = [
        u'RoutingInfoForLCS-Arg',
        u'RoutingInfoForLCS-Res',
        u'LCSLocationInfo',
        u'ProvideSubscriberLocation-Arg',
        u'LocationType',
        u'LocationEstimateType',
        u'DeferredLocationEventType',
        u'LCS-ClientID',
        u'LCSClientType',
        u'LCSClientName',
        u'NameString',
        u'maxNameStringLength',
        u'LCSRequestorID',
        u'RequestorIDString',
        u'maxRequestorIDStringLength',
        u'LCS-FormatIndicator',
        u'LCS-Priority',
        u'LCS-QoS',
        u'Horizontal-Accuracy',
        u'Vertical-Accuracy',
        u'ResponseTime',
        u'ResponseTimeCategory',
        u'SupportedGADShapes',
        u'LCS-ReferenceNumber',
        u'LCSCodeword',
        u'LCSCodewordString',
        u'maxLCSCodewordStringLength',
        u'LCS-PrivacyCheck',
        u'PrivacyCheckRelatedAction',
        u'AreaEventInfo',
        u'AreaDefinition',
        u'AreaList',
        u'maxNumOfAreas',
        u'Area',
        u'AreaType',
        u'AreaIdentification',
        u'OccurrenceInfo',
        u'IntervalTime',
        u'PeriodicLDRInfo',
        u'ReportingAmount',
        u'maxReportingAmount',
        u'ReportingInterval',
        u'maxReportingInterval',
        u'ReportingPLMNList',
        u'PLMNList',
        u'maxNumOfReportingPLMN',
        u'ReportingPLMN',
        u'RAN-Technology',
        u'ProvideSubscriberLocation-Res',
        u'AccuracyFulfilmentIndicator',
        u'Ext-GeographicalInformation',
        u'maxExt-GeographicalInformation',
        u'VelocityEstimate',
        u'PositioningDataInformation',
        u'maxPositioningDataInformation',
        u'UtranPositioningDataInfo',
        u'maxUtranPositioningDataInfo',
        u'GeranGANSSpositioningData',
        u'maxGeranGANSSpositioningData',
        u'UtranGANSSpositioningData',
        u'maxUtranGANSSpositioningData',
        u'UtranAdditionalPositioningData',
        u'maxUtranAdditionalPositioningData',
        u'UtranBaroPressureMeas',
        u'UtranCivicAddress',
        u'Add-GeographicalInformation',
        u'maxAdd-GeographicalInformation',
        u'SubscriberLocationReport-Arg',
        u'Deferredmt-lrData',
        u'LCS-Event',
        u'TerminationCause',
        u'SequenceNumber',
        u'ServingNodeAddress',
        u'SubscriberLocationReport-Res',
        ]
    _type_ = [
        u'RoutingInfoForLCS-Arg',
        u'RoutingInfoForLCS-Res',
        u'LCSLocationInfo',
        u'ProvideSubscriberLocation-Arg',
        u'LocationType',
        u'LocationEstimateType',
        u'DeferredLocationEventType',
        u'LCS-ClientID',
        u'LCSClientType',
        u'LCSClientName',
        u'NameString',
        u'LCSRequestorID',
        u'RequestorIDString',
        u'LCS-FormatIndicator',
        u'LCS-Priority',
        u'LCS-QoS',
        u'Horizontal-Accuracy',
        u'Vertical-Accuracy',
        u'ResponseTime',
        u'ResponseTimeCategory',
        u'SupportedGADShapes',
        u'LCS-ReferenceNumber',
        u'LCSCodeword',
        u'LCSCodewordString',
        u'LCS-PrivacyCheck',
        u'PrivacyCheckRelatedAction',
        u'AreaEventInfo',
        u'AreaDefinition',
        u'AreaList',
        u'Area',
        u'AreaType',
        u'AreaIdentification',
        u'OccurrenceInfo',
        u'IntervalTime',
        u'PeriodicLDRInfo',
        u'ReportingAmount',
        u'ReportingInterval',
        u'ReportingPLMNList',
        u'PLMNList',
        u'ReportingPLMN',
        u'RAN-Technology',
        u'ProvideSubscriberLocation-Res',
        u'AccuracyFulfilmentIndicator',
        u'Ext-GeographicalInformation',
        u'VelocityEstimate',
        u'PositioningDataInformation',
        u'UtranPositioningDataInfo',
        u'GeranGANSSpositioningData',
        u'UtranGANSSpositioningData',
        u'UtranAdditionalPositioningData',
        u'UtranBaroPressureMeas',
        u'UtranCivicAddress',
        u'Add-GeographicalInformation',
        u'SubscriberLocationReport-Arg',
        u'Deferredmt-lrData',
        u'LCS-Event',
        u'TerminationCause',
        u'SequenceNumber',
        u'ServingNodeAddress',
        u'SubscriberLocationReport-Res',
        ]
    _set_ = [
        ]
    _val_ = [
        u'maxNameStringLength',
        u'maxRequestorIDStringLength',
        u'maxLCSCodewordStringLength',
        u'maxNumOfAreas',
        u'maxReportingAmount',
        u'maxReportingInterval',
        u'maxNumOfReportingPLMN',
        u'maxExt-GeographicalInformation',
        u'maxPositioningDataInformation',
        u'maxUtranPositioningDataInfo',
        u'maxGeranGANSSpositioningData',
        u'maxUtranGANSSpositioningData',
        u'maxUtranAdditionalPositioningData',
        u'maxAdd-GeographicalInformation',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< RoutingInfoForLCS-Arg >-----#
    RoutingInfoForLCS_Arg = SEQ(name=u'RoutingInfoForLCS-Arg', mode=MODE_TYPE)
    _RoutingInfoForLCS_Arg_mlcNumber = OCT_STR(name=u'mlcNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RoutingInfoForLCS_Arg_targetMS = CHOICE(name=u'targetMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _RoutingInfoForLCS_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    RoutingInfoForLCS_Arg._cont = ASN1Dict([
        (u'mlcNumber', _RoutingInfoForLCS_Arg_mlcNumber),
        (u'targetMS', _RoutingInfoForLCS_Arg_targetMS),
        (u'extensionContainer', _RoutingInfoForLCS_Arg_extensionContainer),
        ])
    RoutingInfoForLCS_Arg._ext = []
    
    #-----< RoutingInfoForLCS-Res >-----#
    RoutingInfoForLCS_Res = SEQ(name=u'RoutingInfoForLCS-Res', mode=MODE_TYPE)
    _RoutingInfoForLCS_Res_targetMS = CHOICE(name=u'targetMS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _RoutingInfoForLCS_Res_lcsLocationInfo = SEQ(name=u'lcsLocationInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSLocationInfo')))
    _RoutingInfoForLCS_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RoutingInfoForLCS_Res_v_gmlc_Address = OCT_STR(name=u'v-gmlc-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _RoutingInfoForLCS_Res_h_gmlc_Address = OCT_STR(name=u'h-gmlc-Address', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _RoutingInfoForLCS_Res_ppr_Address = OCT_STR(name=u'ppr-Address', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _RoutingInfoForLCS_Res_additional_v_gmlc_Address = OCT_STR(name=u'additional-v-gmlc-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    RoutingInfoForLCS_Res._cont = ASN1Dict([
        (u'targetMS', _RoutingInfoForLCS_Res_targetMS),
        (u'lcsLocationInfo', _RoutingInfoForLCS_Res_lcsLocationInfo),
        (u'extensionContainer', _RoutingInfoForLCS_Res_extensionContainer),
        (u'v-gmlc-Address', _RoutingInfoForLCS_Res_v_gmlc_Address),
        (u'h-gmlc-Address', _RoutingInfoForLCS_Res_h_gmlc_Address),
        (u'ppr-Address', _RoutingInfoForLCS_Res_ppr_Address),
        (u'additional-v-gmlc-Address', _RoutingInfoForLCS_Res_additional_v_gmlc_Address),
        ])
    RoutingInfoForLCS_Res._ext = [u'v-gmlc-Address', u'h-gmlc-Address', u'ppr-Address', u'additional-v-gmlc-Address']
    
    #-----< LCSLocationInfo >-----#
    LCSLocationInfo = SEQ(name=u'LCSLocationInfo', mode=MODE_TYPE)
    _LCSLocationInfo_networkNode_Number = OCT_STR(name=u'networkNode-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _LCSLocationInfo_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _LCSLocationInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LCSLocationInfo_gprsNodeIndicator = NULL(name=u'gprsNodeIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCSLocationInfo_additional_Number = CHOICE(name=u'additional-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'Additional-Number')), opt=True)
    _LCSLocationInfo_supportedLCS_CapabilitySets = BIT_STR(name=u'supportedLCS-CapabilitySets', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedLCS-CapabilitySets')), opt=True)
    _LCSLocationInfo_additional_LCS_CapabilitySets = BIT_STR(name=u'additional-LCS-CapabilitySets', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedLCS-CapabilitySets')), opt=True)
    _LCSLocationInfo_mme_Name = OCT_STR(name=u'mme-Name', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _LCSLocationInfo_aaa_Server_Name = OCT_STR(name=u'aaa-Server-Name', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _LCSLocationInfo_sgsn_Name = OCT_STR(name=u'sgsn-Name', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _LCSLocationInfo_sgsn_Realm = OCT_STR(name=u'sgsn-Realm', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    LCSLocationInfo._cont = ASN1Dict([
        (u'networkNode-Number', _LCSLocationInfo_networkNode_Number),
        (u'lmsi', _LCSLocationInfo_lmsi),
        (u'extensionContainer', _LCSLocationInfo_extensionContainer),
        (u'gprsNodeIndicator', _LCSLocationInfo_gprsNodeIndicator),
        (u'additional-Number', _LCSLocationInfo_additional_Number),
        (u'supportedLCS-CapabilitySets', _LCSLocationInfo_supportedLCS_CapabilitySets),
        (u'additional-LCS-CapabilitySets', _LCSLocationInfo_additional_LCS_CapabilitySets),
        (u'mme-Name', _LCSLocationInfo_mme_Name),
        (u'aaa-Server-Name', _LCSLocationInfo_aaa_Server_Name),
        (u'sgsn-Name', _LCSLocationInfo_sgsn_Name),
        (u'sgsn-Realm', _LCSLocationInfo_sgsn_Realm),
        ])
    LCSLocationInfo._ext = [u'gprsNodeIndicator', u'additional-Number', u'supportedLCS-CapabilitySets', u'additional-LCS-CapabilitySets', u'mme-Name', u'aaa-Server-Name', u'sgsn-Name', u'sgsn-Realm']
    
    #-----< ProvideSubscriberLocation-Arg >-----#
    ProvideSubscriberLocation_Arg = SEQ(name=u'ProvideSubscriberLocation-Arg', mode=MODE_TYPE)
    _ProvideSubscriberLocation_Arg_locationType = SEQ(name=u'locationType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')))
    _ProvideSubscriberLocation_Arg_mlc_Number = OCT_STR(name=u'mlc-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ProvideSubscriberLocation_Arg_lcs_ClientID = SEQ(name=u'lcs-ClientID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ClientID')), opt=True)
    _ProvideSubscriberLocation_Arg_privacyOverride = NULL(name=u'privacyOverride', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideSubscriberLocation_Arg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _ProvideSubscriberLocation_Arg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ProvideSubscriberLocation_Arg_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _ProvideSubscriberLocation_Arg_imei = OCT_STR(name=u'imei', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _ProvideSubscriberLocation_Arg_lcs_Priority = OCT_STR(name=u'lcs-Priority', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Priority')), opt=True)
    _ProvideSubscriberLocation_Arg_lcs_QoS = SEQ(name=u'lcs-QoS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-QoS')), opt=True)
    _ProvideSubscriberLocation_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideSubscriberLocation_Arg_supportedGADShapes = BIT_STR(name=u'supportedGADShapes', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'SupportedGADShapes')), opt=True)
    _ProvideSubscriberLocation_Arg_lcs_ReferenceNumber = OCT_STR(name=u'lcs-ReferenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')), opt=True)
    _ProvideSubscriberLocation_Arg_lcsServiceTypeID = INT(name=u'lcsServiceTypeID', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')), opt=True)
    _ProvideSubscriberLocation_Arg_lcsCodeword = SEQ(name=u'lcsCodeword', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSCodeword')), opt=True)
    _ProvideSubscriberLocation_Arg_lcs_PrivacyCheck = SEQ(name=u'lcs-PrivacyCheck', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-PrivacyCheck')), opt=True)
    _ProvideSubscriberLocation_Arg_areaEventInfo = SEQ(name=u'areaEventInfo', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AreaEventInfo')), opt=True)
    _ProvideSubscriberLocation_Arg_h_gmlc_Address = OCT_STR(name=u'h-gmlc-Address', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _ProvideSubscriberLocation_Arg_mo_lrShortCircuitIndicator = NULL(name=u'mo-lrShortCircuitIndicator', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideSubscriberLocation_Arg_periodicLDRInfo = SEQ(name=u'periodicLDRInfo', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PeriodicLDRInfo')), opt=True)
    _ProvideSubscriberLocation_Arg_reportingPLMNList = SEQ(name=u'reportingPLMNList', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ReportingPLMNList')), opt=True)
    ProvideSubscriberLocation_Arg._cont = ASN1Dict([
        (u'locationType', _ProvideSubscriberLocation_Arg_locationType),
        (u'mlc-Number', _ProvideSubscriberLocation_Arg_mlc_Number),
        (u'lcs-ClientID', _ProvideSubscriberLocation_Arg_lcs_ClientID),
        (u'privacyOverride', _ProvideSubscriberLocation_Arg_privacyOverride),
        (u'imsi', _ProvideSubscriberLocation_Arg_imsi),
        (u'msisdn', _ProvideSubscriberLocation_Arg_msisdn),
        (u'lmsi', _ProvideSubscriberLocation_Arg_lmsi),
        (u'imei', _ProvideSubscriberLocation_Arg_imei),
        (u'lcs-Priority', _ProvideSubscriberLocation_Arg_lcs_Priority),
        (u'lcs-QoS', _ProvideSubscriberLocation_Arg_lcs_QoS),
        (u'extensionContainer', _ProvideSubscriberLocation_Arg_extensionContainer),
        (u'supportedGADShapes', _ProvideSubscriberLocation_Arg_supportedGADShapes),
        (u'lcs-ReferenceNumber', _ProvideSubscriberLocation_Arg_lcs_ReferenceNumber),
        (u'lcsServiceTypeID', _ProvideSubscriberLocation_Arg_lcsServiceTypeID),
        (u'lcsCodeword', _ProvideSubscriberLocation_Arg_lcsCodeword),
        (u'lcs-PrivacyCheck', _ProvideSubscriberLocation_Arg_lcs_PrivacyCheck),
        (u'areaEventInfo', _ProvideSubscriberLocation_Arg_areaEventInfo),
        (u'h-gmlc-Address', _ProvideSubscriberLocation_Arg_h_gmlc_Address),
        (u'mo-lrShortCircuitIndicator', _ProvideSubscriberLocation_Arg_mo_lrShortCircuitIndicator),
        (u'periodicLDRInfo', _ProvideSubscriberLocation_Arg_periodicLDRInfo),
        (u'reportingPLMNList', _ProvideSubscriberLocation_Arg_reportingPLMNList),
        ])
    ProvideSubscriberLocation_Arg._ext = [u'supportedGADShapes', u'lcs-ReferenceNumber', u'lcsServiceTypeID', u'lcsCodeword', u'lcs-PrivacyCheck', u'areaEventInfo', u'h-gmlc-Address', u'mo-lrShortCircuitIndicator', u'periodicLDRInfo', u'reportingPLMNList']
    
    #-----< LocationType >-----#
    LocationType = SEQ(name=u'LocationType', mode=MODE_TYPE)
    _LocationType_locationEstimateType = ENUM(name=u'locationEstimateType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationEstimateType')))
    _LocationType_deferredLocationEventType = BIT_STR(name=u'deferredLocationEventType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'DeferredLocationEventType')), opt=True)
    LocationType._cont = ASN1Dict([
        (u'locationEstimateType', _LocationType_locationEstimateType),
        (u'deferredLocationEventType', _LocationType_deferredLocationEventType),
        ])
    LocationType._ext = [u'deferredLocationEventType']
    
    #-----< LocationEstimateType >-----#
    LocationEstimateType = ENUM(name=u'LocationEstimateType', mode=MODE_TYPE)
    LocationEstimateType._cont = ASN1Dict([(u'currentLocation', 0), (u'currentOrLastKnownLocation', 1), (u'initialLocation', 2), (u'activateDeferredLocation', 3), (u'cancelDeferredLocation', 4), (u'notificationVerificationOnly', 5)])
    LocationEstimateType._ext = [u'activateDeferredLocation', u'cancelDeferredLocation', u'notificationVerificationOnly']
    
    #-----< DeferredLocationEventType >-----#
    DeferredLocationEventType = BIT_STR(name=u'DeferredLocationEventType', mode=MODE_TYPE)
    DeferredLocationEventType._cont = ASN1Dict([(u'msAvailable', 0), (u'enteringIntoArea', 1), (u'leavingFromArea', 2), (u'beingInsideArea', 3), (u'periodicLDR', 4)])
    DeferredLocationEventType._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< LCS-ClientID >-----#
    LCS_ClientID = SEQ(name=u'LCS-ClientID', mode=MODE_TYPE)
    _LCS_ClientID_lcsClientType = ENUM(name=u'lcsClientType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientType')))
    _LCS_ClientID_lcsClientExternalID = SEQ(name=u'lcsClientExternalID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientExternalID')), opt=True)
    _LCS_ClientID_lcsClientDialedByMS = OCT_STR(name=u'lcsClientDialedByMS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _LCS_ClientID_lcsClientInternalID = ENUM(name=u'lcsClientInternalID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientInternalID')), opt=True)
    _LCS_ClientID_lcsClientName = SEQ(name=u'lcsClientName', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientName')), opt=True)
    _LCS_ClientID_lcsAPN = OCT_STR(name=u'lcsAPN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')), opt=True)
    _LCS_ClientID_lcsRequestorID = SEQ(name=u'lcsRequestorID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSRequestorID')), opt=True)
    LCS_ClientID._cont = ASN1Dict([
        (u'lcsClientType', _LCS_ClientID_lcsClientType),
        (u'lcsClientExternalID', _LCS_ClientID_lcsClientExternalID),
        (u'lcsClientDialedByMS', _LCS_ClientID_lcsClientDialedByMS),
        (u'lcsClientInternalID', _LCS_ClientID_lcsClientInternalID),
        (u'lcsClientName', _LCS_ClientID_lcsClientName),
        (u'lcsAPN', _LCS_ClientID_lcsAPN),
        (u'lcsRequestorID', _LCS_ClientID_lcsRequestorID),
        ])
    LCS_ClientID._ext = [u'lcsAPN', u'lcsRequestorID']
    
    #-----< LCSClientType >-----#
    LCSClientType = ENUM(name=u'LCSClientType', mode=MODE_TYPE)
    LCSClientType._cont = ASN1Dict([(u'emergencyServices', 0), (u'valueAddedServices', 1), (u'plmnOperatorServices', 2), (u'lawfulInterceptServices', 3)])
    LCSClientType._ext = []
    
    #-----< LCSClientName >-----#
    LCSClientName = SEQ(name=u'LCSClientName', mode=MODE_TYPE)
    _LCSClientName_dataCodingScheme = OCT_STR(name=u'dataCodingScheme', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _LCSClientName_nameString = OCT_STR(name=u'nameString', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'NameString')))
    _LCSClientName_lcs_FormatIndicator = ENUM(name=u'lcs-FormatIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-FormatIndicator')), opt=True)
    LCSClientName._cont = ASN1Dict([
        (u'dataCodingScheme', _LCSClientName_dataCodingScheme),
        (u'nameString', _LCSClientName_nameString),
        (u'lcs-FormatIndicator', _LCSClientName_lcs_FormatIndicator),
        ])
    LCSClientName._ext = [u'lcs-FormatIndicator']
    
    #-----< NameString >-----#
    NameString = OCT_STR(name=u'NameString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    NameString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    
    #-----< maxNameStringLength >-----#
    maxNameStringLength = INT(name=u'maxNameStringLength', mode=MODE_VALUE)
    maxNameStringLength._val = 63
    
    #-----< LCSRequestorID >-----#
    LCSRequestorID = SEQ(name=u'LCSRequestorID', mode=MODE_TYPE)
    _LCSRequestorID_dataCodingScheme = OCT_STR(name=u'dataCodingScheme', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _LCSRequestorID_requestorIDString = OCT_STR(name=u'requestorIDString', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'RequestorIDString')))
    _LCSRequestorID_lcs_FormatIndicator = ENUM(name=u'lcs-FormatIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-FormatIndicator')), opt=True)
    LCSRequestorID._cont = ASN1Dict([
        (u'dataCodingScheme', _LCSRequestorID_dataCodingScheme),
        (u'requestorIDString', _LCSRequestorID_requestorIDString),
        (u'lcs-FormatIndicator', _LCSRequestorID_lcs_FormatIndicator),
        ])
    LCSRequestorID._ext = [u'lcs-FormatIndicator']
    
    #-----< RequestorIDString >-----#
    RequestorIDString = OCT_STR(name=u'RequestorIDString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    RequestorIDString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    
    #-----< maxRequestorIDStringLength >-----#
    maxRequestorIDStringLength = INT(name=u'maxRequestorIDStringLength', mode=MODE_VALUE)
    maxRequestorIDStringLength._val = 63
    
    #-----< LCS-FormatIndicator >-----#
    LCS_FormatIndicator = ENUM(name=u'LCS-FormatIndicator', mode=MODE_TYPE)
    LCS_FormatIndicator._cont = ASN1Dict([(u'logicalName', 0), (u'e-mailAddress', 1), (u'msisdn', 2), (u'url', 3), (u'sipUrl', 4)])
    LCS_FormatIndicator._ext = []
    
    #-----< LCS-Priority >-----#
    LCS_Priority = OCT_STR(name=u'LCS-Priority', mode=MODE_TYPE)
    LCS_Priority._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< LCS-QoS >-----#
    LCS_QoS = SEQ(name=u'LCS-QoS', mode=MODE_TYPE)
    _LCS_QoS_horizontal_accuracy = OCT_STR(name=u'horizontal-accuracy', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Horizontal-Accuracy')), opt=True)
    _LCS_QoS_verticalCoordinateRequest = NULL(name=u'verticalCoordinateRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_QoS_vertical_accuracy = OCT_STR(name=u'vertical-accuracy', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Vertical-Accuracy')), opt=True)
    _LCS_QoS_responseTime = SEQ(name=u'responseTime', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ResponseTime')), opt=True)
    _LCS_QoS_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LCS_QoS_velocityRequest = NULL(name=u'velocityRequest', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    LCS_QoS._cont = ASN1Dict([
        (u'horizontal-accuracy', _LCS_QoS_horizontal_accuracy),
        (u'verticalCoordinateRequest', _LCS_QoS_verticalCoordinateRequest),
        (u'vertical-accuracy', _LCS_QoS_vertical_accuracy),
        (u'responseTime', _LCS_QoS_responseTime),
        (u'extensionContainer', _LCS_QoS_extensionContainer),
        (u'velocityRequest', _LCS_QoS_velocityRequest),
        ])
    LCS_QoS._ext = [u'velocityRequest']
    
    #-----< Horizontal-Accuracy >-----#
    Horizontal_Accuracy = OCT_STR(name=u'Horizontal-Accuracy', mode=MODE_TYPE)
    Horizontal_Accuracy._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Vertical-Accuracy >-----#
    Vertical_Accuracy = OCT_STR(name=u'Vertical-Accuracy', mode=MODE_TYPE)
    Vertical_Accuracy._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ResponseTime >-----#
    ResponseTime = SEQ(name=u'ResponseTime', mode=MODE_TYPE)
    _ResponseTime_responseTimeCategory = ENUM(name=u'responseTimeCategory', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ResponseTimeCategory')))
    ResponseTime._cont = ASN1Dict([
        (u'responseTimeCategory', _ResponseTime_responseTimeCategory),
        ])
    ResponseTime._ext = []
    
    #-----< ResponseTimeCategory >-----#
    ResponseTimeCategory = ENUM(name=u'ResponseTimeCategory', mode=MODE_TYPE)
    ResponseTimeCategory._cont = ASN1Dict([(u'lowdelay', 0), (u'delaytolerant', 1)])
    ResponseTimeCategory._ext = []
    
    #-----< SupportedGADShapes >-----#
    SupportedGADShapes = BIT_STR(name=u'SupportedGADShapes', mode=MODE_TYPE)
    SupportedGADShapes._cont = ASN1Dict([(u'ellipsoidPoint', 0), (u'ellipsoidPointWithUncertaintyCircle', 1), (u'ellipsoidPointWithUncertaintyEllipse', 2), (u'polygon', 3), (u'ellipsoidPointWithAltitude', 4), (u'ellipsoidPointWithAltitudeAndUncertaintyElipsoid', 5), (u'ellipsoidArc', 6)])
    SupportedGADShapes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=7, ub=16)], ev=None, er=[])
    
    #-----< LCS-ReferenceNumber >-----#
    LCS_ReferenceNumber = OCT_STR(name=u'LCS-ReferenceNumber', mode=MODE_TYPE)
    LCS_ReferenceNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< LCSCodeword >-----#
    LCSCodeword = SEQ(name=u'LCSCodeword', mode=MODE_TYPE)
    _LCSCodeword_dataCodingScheme = OCT_STR(name=u'dataCodingScheme', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _LCSCodeword_lcsCodewordString = OCT_STR(name=u'lcsCodewordString', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSCodewordString')))
    LCSCodeword._cont = ASN1Dict([
        (u'dataCodingScheme', _LCSCodeword_dataCodingScheme),
        (u'lcsCodewordString', _LCSCodeword_lcsCodewordString),
        ])
    LCSCodeword._ext = []
    
    #-----< LCSCodewordString >-----#
    LCSCodewordString = OCT_STR(name=u'LCSCodewordString', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    LCSCodewordString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxLCSCodewordStringLength >-----#
    maxLCSCodewordStringLength = INT(name=u'maxLCSCodewordStringLength', mode=MODE_VALUE)
    maxLCSCodewordStringLength._val = 20
    
    #-----< LCS-PrivacyCheck >-----#
    LCS_PrivacyCheck = SEQ(name=u'LCS-PrivacyCheck', mode=MODE_TYPE)
    _LCS_PrivacyCheck_callSessionUnrelated = ENUM(name=u'callSessionUnrelated', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PrivacyCheckRelatedAction')))
    _LCS_PrivacyCheck_callSessionRelated = ENUM(name=u'callSessionRelated', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PrivacyCheckRelatedAction')), opt=True)
    LCS_PrivacyCheck._cont = ASN1Dict([
        (u'callSessionUnrelated', _LCS_PrivacyCheck_callSessionUnrelated),
        (u'callSessionRelated', _LCS_PrivacyCheck_callSessionRelated),
        ])
    LCS_PrivacyCheck._ext = []
    
    #-----< PrivacyCheckRelatedAction >-----#
    PrivacyCheckRelatedAction = ENUM(name=u'PrivacyCheckRelatedAction', mode=MODE_TYPE)
    PrivacyCheckRelatedAction._cont = ASN1Dict([(u'allowedWithoutNotification', 0), (u'allowedWithNotification', 1), (u'allowedIfNoResponse', 2), (u'restrictedIfNoResponse', 3), (u'notAllowed', 4)])
    PrivacyCheckRelatedAction._ext = []
    
    #-----< AreaEventInfo >-----#
    AreaEventInfo = SEQ(name=u'AreaEventInfo', mode=MODE_TYPE)
    _AreaEventInfo_areaDefinition = SEQ(name=u'areaDefinition', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AreaDefinition')))
    _AreaEventInfo_occurrenceInfo = ENUM(name=u'occurrenceInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'OccurrenceInfo')), opt=True)
    _AreaEventInfo_intervalTime = INT(name=u'intervalTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'IntervalTime')), opt=True)
    AreaEventInfo._cont = ASN1Dict([
        (u'areaDefinition', _AreaEventInfo_areaDefinition),
        (u'occurrenceInfo', _AreaEventInfo_occurrenceInfo),
        (u'intervalTime', _AreaEventInfo_intervalTime),
        ])
    AreaEventInfo._ext = []
    
    #-----< AreaDefinition >-----#
    AreaDefinition = SEQ(name=u'AreaDefinition', mode=MODE_TYPE)
    _AreaDefinition_areaList = SEQ_OF(name=u'areaList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AreaList')))
    AreaDefinition._cont = ASN1Dict([
        (u'areaList', _AreaDefinition_areaList),
        ])
    AreaDefinition._ext = []
    
    #-----< AreaList >-----#
    AreaList = SEQ_OF(name=u'AreaList', mode=MODE_TYPE)
    _AreaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Area')))
    AreaList._cont = _AreaList__item_
    AreaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfAreas >-----#
    maxNumOfAreas = INT(name=u'maxNumOfAreas', mode=MODE_VALUE)
    maxNumOfAreas._val = 10
    
    #-----< Area >-----#
    Area = SEQ(name=u'Area', mode=MODE_TYPE)
    _Area_areaType = ENUM(name=u'areaType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AreaType')))
    _Area_areaIdentification = OCT_STR(name=u'areaIdentification', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AreaIdentification')))
    Area._cont = ASN1Dict([
        (u'areaType', _Area_areaType),
        (u'areaIdentification', _Area_areaIdentification),
        ])
    Area._ext = []
    
    #-----< AreaType >-----#
    AreaType = ENUM(name=u'AreaType', mode=MODE_TYPE)
    AreaType._cont = ASN1Dict([(u'countryCode', 0), (u'plmnId', 1), (u'locationAreaId', 2), (u'routingAreaId', 3), (u'cellGlobalId', 4), (u'utranCellId', 5)])
    AreaType._ext = [u'utranCellId']
    
    #-----< AreaIdentification >-----#
    AreaIdentification = OCT_STR(name=u'AreaIdentification', mode=MODE_TYPE)
    AreaIdentification._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=7)], ev=None, er=[])
    
    #-----< OccurrenceInfo >-----#
    OccurrenceInfo = ENUM(name=u'OccurrenceInfo', mode=MODE_TYPE)
    OccurrenceInfo._cont = ASN1Dict([(u'oneTimeEvent', 0), (u'multipleTimeEvent', 1)])
    OccurrenceInfo._ext = []
    
    #-----< IntervalTime >-----#
    IntervalTime = INT(name=u'IntervalTime', mode=MODE_TYPE)
    IntervalTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32767)], ev=None, er=[])
    
    #-----< PeriodicLDRInfo >-----#
    PeriodicLDRInfo = SEQ(name=u'PeriodicLDRInfo', mode=MODE_TYPE)
    _PeriodicLDRInfo_reportingAmount = INT(name=u'reportingAmount', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ReportingAmount')))
    _PeriodicLDRInfo_reportingInterval = INT(name=u'reportingInterval', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ReportingInterval')))
    PeriodicLDRInfo._cont = ASN1Dict([
        (u'reportingAmount', _PeriodicLDRInfo_reportingAmount),
        (u'reportingInterval', _PeriodicLDRInfo_reportingInterval),
        ])
    PeriodicLDRInfo._ext = []
    
    #-----< ReportingAmount >-----#
    ReportingAmount = INT(name=u'ReportingAmount', mode=MODE_TYPE)
    ReportingAmount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=None, er=[])
    
    #-----< maxReportingAmount >-----#
    maxReportingAmount = INT(name=u'maxReportingAmount', mode=MODE_VALUE)
    maxReportingAmount._val = 8639999
    
    #-----< ReportingInterval >-----#
    ReportingInterval = INT(name=u'ReportingInterval', mode=MODE_TYPE)
    ReportingInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=None, er=[])
    
    #-----< maxReportingInterval >-----#
    maxReportingInterval = INT(name=u'maxReportingInterval', mode=MODE_VALUE)
    maxReportingInterval._val = 8639999
    
    #-----< ReportingPLMNList >-----#
    ReportingPLMNList = SEQ(name=u'ReportingPLMNList', mode=MODE_TYPE)
    _ReportingPLMNList_plmn_ListPrioritized = NULL(name=u'plmn-ListPrioritized', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportingPLMNList_plmn_List = SEQ_OF(name=u'plmn-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PLMNList')))
    ReportingPLMNList._cont = ASN1Dict([
        (u'plmn-ListPrioritized', _ReportingPLMNList_plmn_ListPrioritized),
        (u'plmn-List', _ReportingPLMNList_plmn_List),
        ])
    ReportingPLMNList._ext = []
    
    #-----< PLMNList >-----#
    PLMNList = SEQ_OF(name=u'PLMNList', mode=MODE_TYPE)
    _PLMNList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ReportingPLMN')))
    PLMNList._cont = _PLMNList__item_
    PLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxNumOfReportingPLMN >-----#
    maxNumOfReportingPLMN = INT(name=u'maxNumOfReportingPLMN', mode=MODE_VALUE)
    maxNumOfReportingPLMN._val = 20
    
    #-----< ReportingPLMN >-----#
    ReportingPLMN = SEQ(name=u'ReportingPLMN', mode=MODE_TYPE)
    _ReportingPLMN_plmn_Id = OCT_STR(name=u'plmn-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    _ReportingPLMN_ran_Technology = ENUM(name=u'ran-Technology', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'RAN-Technology')), opt=True)
    _ReportingPLMN_ran_PeriodicLocationSupport = NULL(name=u'ran-PeriodicLocationSupport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ReportingPLMN._cont = ASN1Dict([
        (u'plmn-Id', _ReportingPLMN_plmn_Id),
        (u'ran-Technology', _ReportingPLMN_ran_Technology),
        (u'ran-PeriodicLocationSupport', _ReportingPLMN_ran_PeriodicLocationSupport),
        ])
    ReportingPLMN._ext = []
    
    #-----< RAN-Technology >-----#
    RAN_Technology = ENUM(name=u'RAN-Technology', mode=MODE_TYPE)
    RAN_Technology._cont = ASN1Dict([(u'gsm', 0), (u'umts', 1)])
    RAN_Technology._ext = []
    
    #-----< ProvideSubscriberLocation-Res >-----#
    ProvideSubscriberLocation_Res = SEQ(name=u'ProvideSubscriberLocation-Res', mode=MODE_TYPE)
    _ProvideSubscriberLocation_Res_locationEstimate = OCT_STR(name=u'locationEstimate', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')))
    _ProvideSubscriberLocation_Res_ageOfLocationEstimate = INT(name=u'ageOfLocationEstimate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _ProvideSubscriberLocation_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideSubscriberLocation_Res_add_LocationEstimate = OCT_STR(name=u'add-LocationEstimate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Add-GeographicalInformation')), opt=True)
    _ProvideSubscriberLocation_Res_deferredmt_lrResponseIndicator = NULL(name=u'deferredmt-lrResponseIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideSubscriberLocation_Res_geranPositioningData = OCT_STR(name=u'geranPositioningData', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PositioningDataInformation')), opt=True)
    _ProvideSubscriberLocation_Res_utranPositioningData = OCT_STR(name=u'utranPositioningData', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranPositioningDataInfo')), opt=True)
    _ProvideSubscriberLocation_Res_cellIdOrSai = CHOICE(name=u'cellIdOrSai', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdOrLAI')), opt=True)
    _ProvideSubscriberLocation_Res_sai_Present = NULL(name=u'sai-Present', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideSubscriberLocation_Res_accuracyFulfilmentIndicator = ENUM(name=u'accuracyFulfilmentIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AccuracyFulfilmentIndicator')), opt=True)
    _ProvideSubscriberLocation_Res_velocityEstimate = OCT_STR(name=u'velocityEstimate', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'VelocityEstimate')), opt=True)
    _ProvideSubscriberLocation_Res_mo_lrShortCircuitIndicator = NULL(name=u'mo-lrShortCircuitIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProvideSubscriberLocation_Res_geranGANSSpositioningData = OCT_STR(name=u'geranGANSSpositioningData', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'GeranGANSSpositioningData')), opt=True)
    _ProvideSubscriberLocation_Res_utranGANSSpositioningData = OCT_STR(name=u'utranGANSSpositioningData', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranGANSSpositioningData')), opt=True)
    _ProvideSubscriberLocation_Res_targetServingNodeForHandover = CHOICE(name=u'targetServingNodeForHandover', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ServingNodeAddress')), opt=True)
    _ProvideSubscriberLocation_Res_utranAdditionalPositioningData = OCT_STR(name=u'utranAdditionalPositioningData', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranAdditionalPositioningData')), opt=True)
    _ProvideSubscriberLocation_Res_utranBaroPressureMeas = INT(name=u'utranBaroPressureMeas', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranBaroPressureMeas')), opt=True)
    _ProvideSubscriberLocation_Res_utranCivicAddress = OCT_STR(name=u'utranCivicAddress', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranCivicAddress')), opt=True)
    ProvideSubscriberLocation_Res._cont = ASN1Dict([
        (u'locationEstimate', _ProvideSubscriberLocation_Res_locationEstimate),
        (u'ageOfLocationEstimate', _ProvideSubscriberLocation_Res_ageOfLocationEstimate),
        (u'extensionContainer', _ProvideSubscriberLocation_Res_extensionContainer),
        (u'add-LocationEstimate', _ProvideSubscriberLocation_Res_add_LocationEstimate),
        (u'deferredmt-lrResponseIndicator', _ProvideSubscriberLocation_Res_deferredmt_lrResponseIndicator),
        (u'geranPositioningData', _ProvideSubscriberLocation_Res_geranPositioningData),
        (u'utranPositioningData', _ProvideSubscriberLocation_Res_utranPositioningData),
        (u'cellIdOrSai', _ProvideSubscriberLocation_Res_cellIdOrSai),
        (u'sai-Present', _ProvideSubscriberLocation_Res_sai_Present),
        (u'accuracyFulfilmentIndicator', _ProvideSubscriberLocation_Res_accuracyFulfilmentIndicator),
        (u'velocityEstimate', _ProvideSubscriberLocation_Res_velocityEstimate),
        (u'mo-lrShortCircuitIndicator', _ProvideSubscriberLocation_Res_mo_lrShortCircuitIndicator),
        (u'geranGANSSpositioningData', _ProvideSubscriberLocation_Res_geranGANSSpositioningData),
        (u'utranGANSSpositioningData', _ProvideSubscriberLocation_Res_utranGANSSpositioningData),
        (u'targetServingNodeForHandover', _ProvideSubscriberLocation_Res_targetServingNodeForHandover),
        (u'utranAdditionalPositioningData', _ProvideSubscriberLocation_Res_utranAdditionalPositioningData),
        (u'utranBaroPressureMeas', _ProvideSubscriberLocation_Res_utranBaroPressureMeas),
        (u'utranCivicAddress', _ProvideSubscriberLocation_Res_utranCivicAddress),
        ])
    ProvideSubscriberLocation_Res._ext = [u'add-LocationEstimate', u'deferredmt-lrResponseIndicator', u'geranPositioningData', u'utranPositioningData', u'cellIdOrSai', u'sai-Present', u'accuracyFulfilmentIndicator', u'velocityEstimate', u'mo-lrShortCircuitIndicator', u'geranGANSSpositioningData', u'utranGANSSpositioningData', u'targetServingNodeForHandover', u'utranAdditionalPositioningData', u'utranBaroPressureMeas', u'utranCivicAddress']
    
    #-----< AccuracyFulfilmentIndicator >-----#
    AccuracyFulfilmentIndicator = ENUM(name=u'AccuracyFulfilmentIndicator', mode=MODE_TYPE)
    AccuracyFulfilmentIndicator._cont = ASN1Dict([(u'requestedAccuracyFulfilled', 0), (u'requestedAccuracyNotFulfilled', 1)])
    AccuracyFulfilmentIndicator._ext = []
    
    #-----< Ext-GeographicalInformation >-----#
    Ext_GeographicalInformation = OCT_STR(name=u'Ext-GeographicalInformation', mode=MODE_TYPE)
    Ext_GeographicalInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxExt-GeographicalInformation >-----#
    maxExt_GeographicalInformation = INT(name=u'maxExt-GeographicalInformation', mode=MODE_VALUE)
    maxExt_GeographicalInformation._val = 20
    
    #-----< VelocityEstimate >-----#
    VelocityEstimate = OCT_STR(name=u'VelocityEstimate', mode=MODE_TYPE)
    VelocityEstimate._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=7)], ev=None, er=[])
    
    #-----< PositioningDataInformation >-----#
    PositioningDataInformation = OCT_STR(name=u'PositioningDataInformation', mode=MODE_TYPE)
    PositioningDataInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    
    #-----< maxPositioningDataInformation >-----#
    maxPositioningDataInformation = INT(name=u'maxPositioningDataInformation', mode=MODE_VALUE)
    maxPositioningDataInformation._val = 10
    
    #-----< UtranPositioningDataInfo >-----#
    UtranPositioningDataInfo = OCT_STR(name=u'UtranPositioningDataInfo', mode=MODE_TYPE)
    UtranPositioningDataInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=11)], ev=None, er=[])
    
    #-----< maxUtranPositioningDataInfo >-----#
    maxUtranPositioningDataInfo = INT(name=u'maxUtranPositioningDataInfo', mode=MODE_VALUE)
    maxUtranPositioningDataInfo._val = 11
    
    #-----< GeranGANSSpositioningData >-----#
    GeranGANSSpositioningData = OCT_STR(name=u'GeranGANSSpositioningData', mode=MODE_TYPE)
    GeranGANSSpositioningData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    
    #-----< maxGeranGANSSpositioningData >-----#
    maxGeranGANSSpositioningData = INT(name=u'maxGeranGANSSpositioningData', mode=MODE_VALUE)
    maxGeranGANSSpositioningData._val = 10
    
    #-----< UtranGANSSpositioningData >-----#
    UtranGANSSpositioningData = OCT_STR(name=u'UtranGANSSpositioningData', mode=MODE_TYPE)
    UtranGANSSpositioningData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< maxUtranGANSSpositioningData >-----#
    maxUtranGANSSpositioningData = INT(name=u'maxUtranGANSSpositioningData', mode=MODE_VALUE)
    maxUtranGANSSpositioningData._val = 9
    
    #-----< UtranAdditionalPositioningData >-----#
    UtranAdditionalPositioningData = OCT_STR(name=u'UtranAdditionalPositioningData', mode=MODE_TYPE)
    UtranAdditionalPositioningData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< maxUtranAdditionalPositioningData >-----#
    maxUtranAdditionalPositioningData = INT(name=u'maxUtranAdditionalPositioningData', mode=MODE_VALUE)
    maxUtranAdditionalPositioningData._val = 8
    
    #-----< UtranBaroPressureMeas >-----#
    UtranBaroPressureMeas = INT(name=u'UtranBaroPressureMeas', mode=MODE_TYPE)
    UtranBaroPressureMeas._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=30000, ub=115000)], ev=None, er=[])
    
    #-----< UtranCivicAddress >-----#
    UtranCivicAddress = OCT_STR(name=u'UtranCivicAddress', mode=MODE_TYPE)
    
    #-----< Add-GeographicalInformation >-----#
    Add_GeographicalInformation = OCT_STR(name=u'Add-GeographicalInformation', mode=MODE_TYPE)
    Add_GeographicalInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=91)], ev=None, er=[])
    
    #-----< maxAdd-GeographicalInformation >-----#
    maxAdd_GeographicalInformation = INT(name=u'maxAdd-GeographicalInformation', mode=MODE_VALUE)
    maxAdd_GeographicalInformation._val = 91
    
    #-----< SubscriberLocationReport-Arg >-----#
    SubscriberLocationReport_Arg = SEQ(name=u'SubscriberLocationReport-Arg', mode=MODE_TYPE)
    _SubscriberLocationReport_Arg_lcs_Event = ENUM(name=u'lcs-Event', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-Event')))
    _SubscriberLocationReport_Arg_lcs_ClientID = SEQ(name=u'lcs-ClientID', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ClientID')))
    _SubscriberLocationReport_Arg_lcsLocationInfo = SEQ(name=u'lcsLocationInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSLocationInfo')))
    _SubscriberLocationReport_Arg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SubscriberLocationReport_Arg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SubscriberLocationReport_Arg_imei = OCT_STR(name=u'imei', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SubscriberLocationReport_Arg_na_ESRD = OCT_STR(name=u'na-ESRD', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SubscriberLocationReport_Arg_na_ESRK = OCT_STR(name=u'na-ESRK', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SubscriberLocationReport_Arg_locationEstimate = OCT_STR(name=u'locationEstimate', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _SubscriberLocationReport_Arg_ageOfLocationEstimate = INT(name=u'ageOfLocationEstimate', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _SubscriberLocationReport_Arg_slr_ArgExtensionContainer = SEQ(name=u'slr-ArgExtensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'SLR-ArgExtensionContainer')), opt=True)
    _SubscriberLocationReport_Arg_add_LocationEstimate = OCT_STR(name=u'add-LocationEstimate', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Add-GeographicalInformation')), opt=True)
    _SubscriberLocationReport_Arg_deferredmt_lrData = SEQ(name=u'deferredmt-lrData', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Deferredmt-lrData')), opt=True)
    _SubscriberLocationReport_Arg_lcs_ReferenceNumber = OCT_STR(name=u'lcs-ReferenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')), opt=True)
    _SubscriberLocationReport_Arg_geranPositioningData = OCT_STR(name=u'geranPositioningData', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PositioningDataInformation')), opt=True)
    _SubscriberLocationReport_Arg_utranPositioningData = OCT_STR(name=u'utranPositioningData', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranPositioningDataInfo')), opt=True)
    _SubscriberLocationReport_Arg_cellIdOrSai = CHOICE(name=u'cellIdOrSai', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdOrLAI')), opt=True)
    _SubscriberLocationReport_Arg_h_gmlc_Address = OCT_STR(name=u'h-gmlc-Address', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _SubscriberLocationReport_Arg_lcsServiceTypeID = INT(name=u'lcsServiceTypeID', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')), opt=True)
    _SubscriberLocationReport_Arg_sai_Present = NULL(name=u'sai-Present', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SubscriberLocationReport_Arg_pseudonymIndicator = NULL(name=u'pseudonymIndicator', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SubscriberLocationReport_Arg_accuracyFulfilmentIndicator = ENUM(name=u'accuracyFulfilmentIndicator', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AccuracyFulfilmentIndicator')), opt=True)
    _SubscriberLocationReport_Arg_velocityEstimate = OCT_STR(name=u'velocityEstimate', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'VelocityEstimate')), opt=True)
    _SubscriberLocationReport_Arg_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'SequenceNumber')), opt=True)
    _SubscriberLocationReport_Arg_periodicLDRInfo = SEQ(name=u'periodicLDRInfo', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PeriodicLDRInfo')), opt=True)
    _SubscriberLocationReport_Arg_mo_lrShortCircuitIndicator = NULL(name=u'mo-lrShortCircuitIndicator', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SubscriberLocationReport_Arg_geranGANSSpositioningData = OCT_STR(name=u'geranGANSSpositioningData', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'GeranGANSSpositioningData')), opt=True)
    _SubscriberLocationReport_Arg_utranGANSSpositioningData = OCT_STR(name=u'utranGANSSpositioningData', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranGANSSpositioningData')), opt=True)
    _SubscriberLocationReport_Arg_targetServingNodeForHandover = CHOICE(name=u'targetServingNodeForHandover', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ServingNodeAddress')), opt=True)
    _SubscriberLocationReport_Arg_utranAdditionalPositioningData = OCT_STR(name=u'utranAdditionalPositioningData', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranAdditionalPositioningData')), opt=True)
    _SubscriberLocationReport_Arg_utranBaroPressureMeas = INT(name=u'utranBaroPressureMeas', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranBaroPressureMeas')), opt=True)
    _SubscriberLocationReport_Arg_utranCivicAddress = OCT_STR(name=u'utranCivicAddress', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'UtranCivicAddress')), opt=True)
    SubscriberLocationReport_Arg._cont = ASN1Dict([
        (u'lcs-Event', _SubscriberLocationReport_Arg_lcs_Event),
        (u'lcs-ClientID', _SubscriberLocationReport_Arg_lcs_ClientID),
        (u'lcsLocationInfo', _SubscriberLocationReport_Arg_lcsLocationInfo),
        (u'msisdn', _SubscriberLocationReport_Arg_msisdn),
        (u'imsi', _SubscriberLocationReport_Arg_imsi),
        (u'imei', _SubscriberLocationReport_Arg_imei),
        (u'na-ESRD', _SubscriberLocationReport_Arg_na_ESRD),
        (u'na-ESRK', _SubscriberLocationReport_Arg_na_ESRK),
        (u'locationEstimate', _SubscriberLocationReport_Arg_locationEstimate),
        (u'ageOfLocationEstimate', _SubscriberLocationReport_Arg_ageOfLocationEstimate),
        (u'slr-ArgExtensionContainer', _SubscriberLocationReport_Arg_slr_ArgExtensionContainer),
        (u'add-LocationEstimate', _SubscriberLocationReport_Arg_add_LocationEstimate),
        (u'deferredmt-lrData', _SubscriberLocationReport_Arg_deferredmt_lrData),
        (u'lcs-ReferenceNumber', _SubscriberLocationReport_Arg_lcs_ReferenceNumber),
        (u'geranPositioningData', _SubscriberLocationReport_Arg_geranPositioningData),
        (u'utranPositioningData', _SubscriberLocationReport_Arg_utranPositioningData),
        (u'cellIdOrSai', _SubscriberLocationReport_Arg_cellIdOrSai),
        (u'h-gmlc-Address', _SubscriberLocationReport_Arg_h_gmlc_Address),
        (u'lcsServiceTypeID', _SubscriberLocationReport_Arg_lcsServiceTypeID),
        (u'sai-Present', _SubscriberLocationReport_Arg_sai_Present),
        (u'pseudonymIndicator', _SubscriberLocationReport_Arg_pseudonymIndicator),
        (u'accuracyFulfilmentIndicator', _SubscriberLocationReport_Arg_accuracyFulfilmentIndicator),
        (u'velocityEstimate', _SubscriberLocationReport_Arg_velocityEstimate),
        (u'sequenceNumber', _SubscriberLocationReport_Arg_sequenceNumber),
        (u'periodicLDRInfo', _SubscriberLocationReport_Arg_periodicLDRInfo),
        (u'mo-lrShortCircuitIndicator', _SubscriberLocationReport_Arg_mo_lrShortCircuitIndicator),
        (u'geranGANSSpositioningData', _SubscriberLocationReport_Arg_geranGANSSpositioningData),
        (u'utranGANSSpositioningData', _SubscriberLocationReport_Arg_utranGANSSpositioningData),
        (u'targetServingNodeForHandover', _SubscriberLocationReport_Arg_targetServingNodeForHandover),
        (u'utranAdditionalPositioningData', _SubscriberLocationReport_Arg_utranAdditionalPositioningData),
        (u'utranBaroPressureMeas', _SubscriberLocationReport_Arg_utranBaroPressureMeas),
        (u'utranCivicAddress', _SubscriberLocationReport_Arg_utranCivicAddress),
        ])
    SubscriberLocationReport_Arg._ext = [u'add-LocationEstimate', u'deferredmt-lrData', u'lcs-ReferenceNumber', u'geranPositioningData', u'utranPositioningData', u'cellIdOrSai', u'h-gmlc-Address', u'lcsServiceTypeID', u'sai-Present', u'pseudonymIndicator', u'accuracyFulfilmentIndicator', u'velocityEstimate', u'sequenceNumber', u'periodicLDRInfo', u'mo-lrShortCircuitIndicator', u'geranGANSSpositioningData', u'utranGANSSpositioningData', u'targetServingNodeForHandover', u'utranAdditionalPositioningData', u'utranBaroPressureMeas', u'utranCivicAddress']
    
    #-----< Deferredmt-lrData >-----#
    Deferredmt_lrData = SEQ(name=u'Deferredmt-lrData', mode=MODE_TYPE)
    _Deferredmt_lrData_deferredLocationEventType = BIT_STR(name=u'deferredLocationEventType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-LCS-DataTypes', 'DeferredLocationEventType')))
    _Deferredmt_lrData_terminationCause = ENUM(name=u'terminationCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'TerminationCause')), opt=True)
    _Deferredmt_lrData_lcsLocationInfo = SEQ(name=u'lcsLocationInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSLocationInfo')), opt=True)
    Deferredmt_lrData._cont = ASN1Dict([
        (u'deferredLocationEventType', _Deferredmt_lrData_deferredLocationEventType),
        (u'terminationCause', _Deferredmt_lrData_terminationCause),
        (u'lcsLocationInfo', _Deferredmt_lrData_lcsLocationInfo),
        ])
    Deferredmt_lrData._ext = []
    
    #-----< LCS-Event >-----#
    LCS_Event = ENUM(name=u'LCS-Event', mode=MODE_TYPE)
    LCS_Event._cont = ASN1Dict([(u'emergencyCallOrigination', 0), (u'emergencyCallRelease', 1), (u'mo-lr', 2), (u'deferredmt-lrResponse', 3), (u'deferredmo-lrTTTPInitiation', 4), (u'emergencyCallHandover', 5)])
    LCS_Event._ext = [u'deferredmt-lrResponse', u'deferredmo-lrTTTPInitiation', u'emergencyCallHandover']
    
    #-----< TerminationCause >-----#
    TerminationCause = ENUM(name=u'TerminationCause', mode=MODE_TYPE)
    TerminationCause._cont = ASN1Dict([(u'normal', 0), (u'errorundefined', 1), (u'internalTimeout', 2), (u'congestion', 3), (u'mt-lrRestart', 4), (u'privacyViolation', 5), (u'shapeOfLocationEstimateNotSupported', 6), (u'subscriberTermination', 7), (u'uETermination', 8), (u'networkTermination', 9)])
    TerminationCause._ext = [u'shapeOfLocationEstimateNotSupported', u'subscriberTermination', u'uETermination', u'networkTermination']
    
    #-----< SequenceNumber >-----#
    SequenceNumber = INT(name=u'SequenceNumber', mode=MODE_TYPE)
    SequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=None, er=[])
    
    #-----< ServingNodeAddress >-----#
    ServingNodeAddress = CHOICE(name=u'ServingNodeAddress', mode=MODE_TYPE)
    _ServingNodeAddress_msc_Number = OCT_STR(name=u'msc-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ServingNodeAddress_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ServingNodeAddress_mme_Number = OCT_STR(name=u'mme-Number', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')))
    ServingNodeAddress._cont = ASN1Dict([
        (u'msc-Number', _ServingNodeAddress_msc_Number),
        (u'sgsn-Number', _ServingNodeAddress_sgsn_Number),
        (u'mme-Number', _ServingNodeAddress_mme_Number),
        ])
    ServingNodeAddress._ext = None
    
    #-----< SubscriberLocationReport-Res >-----#
    SubscriberLocationReport_Res = SEQ(name=u'SubscriberLocationReport-Res', mode=MODE_TYPE)
    _SubscriberLocationReport_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SubscriberLocationReport_Res_na_ESRK = OCT_STR(name=u'na-ESRK', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SubscriberLocationReport_Res_na_ESRD = OCT_STR(name=u'na-ESRD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SubscriberLocationReport_Res_h_gmlc_Address = OCT_STR(name=u'h-gmlc-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _SubscriberLocationReport_Res_mo_lrShortCircuitIndicator = NULL(name=u'mo-lrShortCircuitIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SubscriberLocationReport_Res_reportingPLMNList = SEQ(name=u'reportingPLMNList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ReportingPLMNList')), opt=True)
    _SubscriberLocationReport_Res_lcs_ReferenceNumber = OCT_STR(name=u'lcs-ReferenceNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')), opt=True)
    SubscriberLocationReport_Res._cont = ASN1Dict([
        (u'extensionContainer', _SubscriberLocationReport_Res_extensionContainer),
        (u'na-ESRK', _SubscriberLocationReport_Res_na_ESRK),
        (u'na-ESRD', _SubscriberLocationReport_Res_na_ESRD),
        (u'h-gmlc-Address', _SubscriberLocationReport_Res_h_gmlc_Address),
        (u'mo-lrShortCircuitIndicator', _SubscriberLocationReport_Res_mo_lrShortCircuitIndicator),
        (u'reportingPLMNList', _SubscriberLocationReport_Res_reportingPLMNList),
        (u'lcs-ReferenceNumber', _SubscriberLocationReport_Res_lcs_ReferenceNumber),
        ])
    SubscriberLocationReport_Res._ext = [u'na-ESRK', u'na-ESRD', u'h-gmlc-Address', u'mo-lrShortCircuitIndicator', u'reportingPLMNList', u'lcs-ReferenceNumber']
    
    _all_ = [
        _RoutingInfoForLCS_Arg_mlcNumber,
        _RoutingInfoForLCS_Arg_targetMS,
        _RoutingInfoForLCS_Arg_extensionContainer,
        RoutingInfoForLCS_Arg,
        _RoutingInfoForLCS_Res_targetMS,
        _RoutingInfoForLCS_Res_lcsLocationInfo,
        _RoutingInfoForLCS_Res_extensionContainer,
        _RoutingInfoForLCS_Res_v_gmlc_Address,
        _RoutingInfoForLCS_Res_h_gmlc_Address,
        _RoutingInfoForLCS_Res_ppr_Address,
        _RoutingInfoForLCS_Res_additional_v_gmlc_Address,
        RoutingInfoForLCS_Res,
        _LCSLocationInfo_networkNode_Number,
        _LCSLocationInfo_lmsi,
        _LCSLocationInfo_extensionContainer,
        _LCSLocationInfo_gprsNodeIndicator,
        _LCSLocationInfo_additional_Number,
        _LCSLocationInfo_supportedLCS_CapabilitySets,
        _LCSLocationInfo_additional_LCS_CapabilitySets,
        _LCSLocationInfo_mme_Name,
        _LCSLocationInfo_aaa_Server_Name,
        _LCSLocationInfo_sgsn_Name,
        _LCSLocationInfo_sgsn_Realm,
        LCSLocationInfo,
        _ProvideSubscriberLocation_Arg_locationType,
        _ProvideSubscriberLocation_Arg_mlc_Number,
        _ProvideSubscriberLocation_Arg_lcs_ClientID,
        _ProvideSubscriberLocation_Arg_privacyOverride,
        _ProvideSubscriberLocation_Arg_imsi,
        _ProvideSubscriberLocation_Arg_msisdn,
        _ProvideSubscriberLocation_Arg_lmsi,
        _ProvideSubscriberLocation_Arg_imei,
        _ProvideSubscriberLocation_Arg_lcs_Priority,
        _ProvideSubscriberLocation_Arg_lcs_QoS,
        _ProvideSubscriberLocation_Arg_extensionContainer,
        _ProvideSubscriberLocation_Arg_supportedGADShapes,
        _ProvideSubscriberLocation_Arg_lcs_ReferenceNumber,
        _ProvideSubscriberLocation_Arg_lcsServiceTypeID,
        _ProvideSubscriberLocation_Arg_lcsCodeword,
        _ProvideSubscriberLocation_Arg_lcs_PrivacyCheck,
        _ProvideSubscriberLocation_Arg_areaEventInfo,
        _ProvideSubscriberLocation_Arg_h_gmlc_Address,
        _ProvideSubscriberLocation_Arg_mo_lrShortCircuitIndicator,
        _ProvideSubscriberLocation_Arg_periodicLDRInfo,
        _ProvideSubscriberLocation_Arg_reportingPLMNList,
        ProvideSubscriberLocation_Arg,
        _LocationType_locationEstimateType,
        _LocationType_deferredLocationEventType,
        LocationType,
        LocationEstimateType,
        DeferredLocationEventType,
        _LCS_ClientID_lcsClientType,
        _LCS_ClientID_lcsClientExternalID,
        _LCS_ClientID_lcsClientDialedByMS,
        _LCS_ClientID_lcsClientInternalID,
        _LCS_ClientID_lcsClientName,
        _LCS_ClientID_lcsAPN,
        _LCS_ClientID_lcsRequestorID,
        LCS_ClientID,
        LCSClientType,
        _LCSClientName_dataCodingScheme,
        _LCSClientName_nameString,
        _LCSClientName_lcs_FormatIndicator,
        LCSClientName,
        NameString,
        maxNameStringLength,
        _LCSRequestorID_dataCodingScheme,
        _LCSRequestorID_requestorIDString,
        _LCSRequestorID_lcs_FormatIndicator,
        LCSRequestorID,
        RequestorIDString,
        maxRequestorIDStringLength,
        LCS_FormatIndicator,
        LCS_Priority,
        _LCS_QoS_horizontal_accuracy,
        _LCS_QoS_verticalCoordinateRequest,
        _LCS_QoS_vertical_accuracy,
        _LCS_QoS_responseTime,
        _LCS_QoS_extensionContainer,
        _LCS_QoS_velocityRequest,
        LCS_QoS,
        Horizontal_Accuracy,
        Vertical_Accuracy,
        _ResponseTime_responseTimeCategory,
        ResponseTime,
        ResponseTimeCategory,
        SupportedGADShapes,
        LCS_ReferenceNumber,
        _LCSCodeword_dataCodingScheme,
        _LCSCodeword_lcsCodewordString,
        LCSCodeword,
        LCSCodewordString,
        maxLCSCodewordStringLength,
        _LCS_PrivacyCheck_callSessionUnrelated,
        _LCS_PrivacyCheck_callSessionRelated,
        LCS_PrivacyCheck,
        PrivacyCheckRelatedAction,
        _AreaEventInfo_areaDefinition,
        _AreaEventInfo_occurrenceInfo,
        _AreaEventInfo_intervalTime,
        AreaEventInfo,
        _AreaDefinition_areaList,
        AreaDefinition,
        _AreaList__item_,
        AreaList,
        maxNumOfAreas,
        _Area_areaType,
        _Area_areaIdentification,
        Area,
        AreaType,
        AreaIdentification,
        OccurrenceInfo,
        IntervalTime,
        _PeriodicLDRInfo_reportingAmount,
        _PeriodicLDRInfo_reportingInterval,
        PeriodicLDRInfo,
        ReportingAmount,
        maxReportingAmount,
        ReportingInterval,
        maxReportingInterval,
        _ReportingPLMNList_plmn_ListPrioritized,
        _ReportingPLMNList_plmn_List,
        ReportingPLMNList,
        _PLMNList__item_,
        PLMNList,
        maxNumOfReportingPLMN,
        _ReportingPLMN_plmn_Id,
        _ReportingPLMN_ran_Technology,
        _ReportingPLMN_ran_PeriodicLocationSupport,
        ReportingPLMN,
        RAN_Technology,
        _ProvideSubscriberLocation_Res_locationEstimate,
        _ProvideSubscriberLocation_Res_ageOfLocationEstimate,
        _ProvideSubscriberLocation_Res_extensionContainer,
        _ProvideSubscriberLocation_Res_add_LocationEstimate,
        _ProvideSubscriberLocation_Res_deferredmt_lrResponseIndicator,
        _ProvideSubscriberLocation_Res_geranPositioningData,
        _ProvideSubscriberLocation_Res_utranPositioningData,
        _ProvideSubscriberLocation_Res_cellIdOrSai,
        _ProvideSubscriberLocation_Res_sai_Present,
        _ProvideSubscriberLocation_Res_accuracyFulfilmentIndicator,
        _ProvideSubscriberLocation_Res_velocityEstimate,
        _ProvideSubscriberLocation_Res_mo_lrShortCircuitIndicator,
        _ProvideSubscriberLocation_Res_geranGANSSpositioningData,
        _ProvideSubscriberLocation_Res_utranGANSSpositioningData,
        _ProvideSubscriberLocation_Res_targetServingNodeForHandover,
        _ProvideSubscriberLocation_Res_utranAdditionalPositioningData,
        _ProvideSubscriberLocation_Res_utranBaroPressureMeas,
        _ProvideSubscriberLocation_Res_utranCivicAddress,
        ProvideSubscriberLocation_Res,
        AccuracyFulfilmentIndicator,
        Ext_GeographicalInformation,
        maxExt_GeographicalInformation,
        VelocityEstimate,
        PositioningDataInformation,
        maxPositioningDataInformation,
        UtranPositioningDataInfo,
        maxUtranPositioningDataInfo,
        GeranGANSSpositioningData,
        maxGeranGANSSpositioningData,
        UtranGANSSpositioningData,
        maxUtranGANSSpositioningData,
        UtranAdditionalPositioningData,
        maxUtranAdditionalPositioningData,
        UtranBaroPressureMeas,
        UtranCivicAddress,
        Add_GeographicalInformation,
        maxAdd_GeographicalInformation,
        _SubscriberLocationReport_Arg_lcs_Event,
        _SubscriberLocationReport_Arg_lcs_ClientID,
        _SubscriberLocationReport_Arg_lcsLocationInfo,
        _SubscriberLocationReport_Arg_msisdn,
        _SubscriberLocationReport_Arg_imsi,
        _SubscriberLocationReport_Arg_imei,
        _SubscriberLocationReport_Arg_na_ESRD,
        _SubscriberLocationReport_Arg_na_ESRK,
        _SubscriberLocationReport_Arg_locationEstimate,
        _SubscriberLocationReport_Arg_ageOfLocationEstimate,
        _SubscriberLocationReport_Arg_slr_ArgExtensionContainer,
        _SubscriberLocationReport_Arg_add_LocationEstimate,
        _SubscriberLocationReport_Arg_deferredmt_lrData,
        _SubscriberLocationReport_Arg_lcs_ReferenceNumber,
        _SubscriberLocationReport_Arg_geranPositioningData,
        _SubscriberLocationReport_Arg_utranPositioningData,
        _SubscriberLocationReport_Arg_cellIdOrSai,
        _SubscriberLocationReport_Arg_h_gmlc_Address,
        _SubscriberLocationReport_Arg_lcsServiceTypeID,
        _SubscriberLocationReport_Arg_sai_Present,
        _SubscriberLocationReport_Arg_pseudonymIndicator,
        _SubscriberLocationReport_Arg_accuracyFulfilmentIndicator,
        _SubscriberLocationReport_Arg_velocityEstimate,
        _SubscriberLocationReport_Arg_sequenceNumber,
        _SubscriberLocationReport_Arg_periodicLDRInfo,
        _SubscriberLocationReport_Arg_mo_lrShortCircuitIndicator,
        _SubscriberLocationReport_Arg_geranGANSSpositioningData,
        _SubscriberLocationReport_Arg_utranGANSSpositioningData,
        _SubscriberLocationReport_Arg_targetServingNodeForHandover,
        _SubscriberLocationReport_Arg_utranAdditionalPositioningData,
        _SubscriberLocationReport_Arg_utranBaroPressureMeas,
        _SubscriberLocationReport_Arg_utranCivicAddress,
        SubscriberLocationReport_Arg,
        _Deferredmt_lrData_deferredLocationEventType,
        _Deferredmt_lrData_terminationCause,
        _Deferredmt_lrData_lcsLocationInfo,
        Deferredmt_lrData,
        LCS_Event,
        TerminationCause,
        SequenceNumber,
        _ServingNodeAddress_msc_Number,
        _ServingNodeAddress_sgsn_Number,
        _ServingNodeAddress_mme_Number,
        ServingNodeAddress,
        _SubscriberLocationReport_Res_extensionContainer,
        _SubscriberLocationReport_Res_na_ESRK,
        _SubscriberLocationReport_Res_na_ESRD,
        _SubscriberLocationReport_Res_h_gmlc_Address,
        _SubscriberLocationReport_Res_mo_lrShortCircuitIndicator,
        _SubscriberLocationReport_Res_reportingPLMNList,
        _SubscriberLocationReport_Res_lcs_ReferenceNumber,
        SubscriberLocationReport_Res,
    ]

class MAP_MS_DataTypes:

    _name_  = u'MAP-MS-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 11, 19]
    
    _obj_ = [
        u'UpdateLocationArg',
        u'VLR-Capability',
        u'SupportedRAT-Types',
        u'SuperChargerInfo',
        u'AgeIndicator',
        u'IST-SupportIndicator',
        u'SupportedLCS-CapabilitySets',
        u'UpdateLocationRes',
        u'ADD-Info',
        u'PagingArea',
        u'LocationArea',
        u'LAC',
        u'CancelLocationArg',
        u'TypeOfUpdate',
        u'CancellationType',
        u'CancelLocationRes',
        u'PurgeMS-Arg',
        u'PurgeMS-Res',
        u'SendIdentificationArg',
        u'HopCounter',
        u'SendIdentificationRes',
        u'AuthenticationSetList',
        u'TripletList',
        u'QuintupletList',
        u'AuthenticationTriplet',
        u'AuthenticationQuintuplet',
        u'CurrentSecurityContext',
        u'GSM-SecurityContextData',
        u'UMTS-SecurityContextData',
        u'RAND',
        u'SRES',
        u'Kc',
        u'XRES',
        u'CK',
        u'IK',
        u'AUTN',
        u'AUTS',
        u'Cksn',
        u'KSI',
        u'AuthenticationFailureReportArg',
        u'AccessType',
        u'AuthenticationFailureReportRes',
        u'FailureCause',
        u'UpdateGprsLocationArg',
        u'SMSRegisterRequest',
        u'Used-RAT-Type',
        u'EPS-Info',
        u'PDN-GW-Update',
        u'ISR-Information',
        u'SGSN-Capability',
        u'SupportedFeatures',
        u'Ext-SupportedFeatures',
        u'UE-SRVCC-Capability',
        u'UpdateGprsLocationRes',
        u'EPLMN-List',
        u'AdjacentPLMN-List',
        u'ForwardAccessSignalling-Arg',
        u'AllowedGSM-Algorithms',
        u'AllowedUMTS-Algorithms',
        u'PermittedIntegrityProtectionAlgorithms',
        u'maxPermittedIntegrityProtectionAlgorithmsLength',
        u'PermittedEncryptionAlgorithms',
        u'maxPermittedEncryptionAlgorithmsLength',
        u'KeyStatus',
        u'PrepareHO-Arg',
        u'LCLS-GlobalCallReference',
        u'LCLS-Negotiation',
        u'LCLS-ConfigurationPreference',
        u'BSSMAP-ServiceHandoverList',
        u'BSSMAP-ServiceHandoverInfo',
        u'maxNumOfServiceHandovers',
        u'BSSMAP-ServiceHandover',
        u'RANAP-ServiceHandover',
        u'RadioResourceList',
        u'RadioResource',
        u'maxNumOfRadioResources',
        u'PrepareHO-Res',
        u'SelectedUMTS-Algorithms',
        u'ChosenIntegrityProtectionAlgorithm',
        u'ChosenEncryptionAlgorithm',
        u'ChosenRadioResourceInformation',
        u'ChosenChannelInfo',
        u'ChosenSpeechVersion',
        u'PrepareSubsequentHO-Arg',
        u'PrepareSubsequentHO-Res',
        u'ProcessAccessSignalling-Arg',
        u'AoIPCodecsList',
        u'AoIPCodec',
        u'SupportedCodecsList',
        u'CodecList',
        u'Codec',
        u'GERAN-Classmark',
        u'SelectedGSM-Algorithm',
        u'SendEndSignal-Arg',
        u'SendEndSignal-Res',
        u'RNCId',
        u'RelocationNumberList',
        u'MulticallBearerInfo',
        u'RelocationNumber',
        u'RAB-Id',
        u'maxNrOfRABs',
        u'maxNumOfRelocationNumber',
        u'RadioResourceInformation',
        u'IntegrityProtectionInformation',
        u'maxNumOfIntegrityInfo',
        u'EncryptionInformation',
        u'maxNumOfEncryptionInfo',
        u'SendAuthenticationInfoArg',
        u'NumberOfRequestedVectors',
        u'Re-synchronisationInfo',
        u'SendAuthenticationInfoRes',
        u'EPS-AuthenticationSetList',
        u'UE-UsageType',
        u'EPC-AV',
        u'KASME',
        u'RequestingNodeType',
        u'CheckIMEI-Arg',
        u'CheckIMEI-Res',
        u'RequestedEquipmentInfo',
        u'UESBI-Iu',
        u'UESBI-IuA',
        u'UESBI-IuB',
        u'EquipmentStatus',
        u'InsertSubscriberDataArg',
        u'EDRX-Cycle-Length-List',
        u'EDRX-Cycle-Length',
        u'EDRX-Cycle-Length-Value',
        u'Reset-Id-List',
        u'Reset-Id',
        u'DL-Buffering-Suggested-Packet-Count',
        u'Group-Service-ID',
        u'Local-GroupID',
        u'IMSI-GroupIdList',
        u'IMSI-GroupId',
        u'SubscribedPeriodicRAUTAUtimer',
        u'SubscribedPeriodicLAUtimer',
        u'CSG-SubscriptionDataList',
        u'CSG-SubscriptionData',
        u'VPLMN-CSG-SubscriptionDataList',
        u'CSG-Id',
        u'LIPA-AllowedAPNList',
        u'maxNumOfLIPAAllowedAPN',
        u'EPS-SubscriptionData',
        u'APN-OI-Replacement',
        u'RFSP-ID',
        u'APN-ConfigurationProfile',
        u'EPS-DataList',
        u'maxNumOfAPN-Configurations',
        u'APN-Configuration',
        u'PDN-ConnectionContinuity',
        u'NIDD-Mechanism',
        u'PDN-Type',
        u'EPS-QoS-Subscribed',
        u'AMBR',
        u'SpecificAPNInfoList',
        u'maxNumOfSpecificAPNInfos',
        u'SpecificAPNInfo',
        u'Bandwidth',
        u'BandwidthExt',
        u'QoS-Class-Identifier',
        u'Allocation-Retention-Priority',
        u'PDN-GW-Identity',
        u'FQDN',
        u'PDN-GW-AllocationType',
        u'WLAN-Offloadability',
        u'WLAN-Offloadability-Indication',
        u'AccessRestrictionData',
        u'Ext-AccessRestrictionData',
        u'AdjacentAccessRestrictionDataList',
        u'AdjacentAccessRestrictionData',
        u'CS-AllocationRetentionPriority',
        u'IST-AlertTimerValue',
        u'LCSInformation',
        u'GMLC-List',
        u'maxNumOfGMLC',
        u'NetworkAccessMode',
        u'GPRSDataList',
        u'maxNumOfPDP-Contexts',
        u'PDP-Context',
        u'Restoration-Priority',
        u'SIPTO-Permission',
        u'SIPTO-Local-Network-Permission',
        u'LIPA-Permission',
        u'ContextId',
        u'GPRSSubscriptionData',
        u'SGSN-CAMEL-SubscriptionInfo',
        u'GPRS-CSI',
        u'GPRS-CamelTDPDataList',
        u'GPRS-CamelTDPData',
        u'DefaultGPRS-Handling',
        u'GPRS-TriggerDetectionPoint',
        u'APN',
        u'PDP-Type',
        u'Ext-PDP-Type',
        u'PDP-Address',
        u'QoS-Subscribed',
        u'Ext-QoS-Subscribed',
        u'Ext2-QoS-Subscribed',
        u'Ext3-QoS-Subscribed',
        u'Ext4-QoS-Subscribed',
        u'ChargingCharacteristics',
        u'LSAOnlyAccessIndicator',
        u'LSADataList',
        u'maxNumOfLSAs',
        u'LSAData',
        u'LSAInformation',
        u'LSAIdentity',
        u'LSAAttributes',
        u'SubscriberData',
        u'Category',
        u'SubscriberStatus',
        u'BearerServiceList',
        u'maxNumOfBearerServices',
        u'TeleserviceList',
        u'maxNumOfTeleservices',
        u'ODB-Data',
        u'ODB-GeneralData',
        u'ODB-HPLMN-Data',
        u'Ext-SS-InfoList',
        u'Ext-SS-Info',
        u'Ext-ForwInfo',
        u'Ext-ForwFeatureList',
        u'Ext-ForwFeature',
        u'Ext-ForwOptions',
        u'Ext-NoRepCondTime',
        u'Ext-CallBarInfo',
        u'Ext-CallBarFeatureList',
        u'Ext-CallBarringFeature',
        u'CUG-Info',
        u'CUG-SubscriptionList',
        u'CUG-Subscription',
        u'CUG-Index',
        u'CUG-Interlock',
        u'IntraCUG-Options',
        u'maxNumOfCUG',
        u'CUG-FeatureList',
        u'Ext-BasicServiceGroupList',
        u'maxNumOfExt-BasicServiceGroups',
        u'CUG-Feature',
        u'InterCUG-Restrictions',
        u'Ext-SS-Data',
        u'LCS-PrivacyExceptionList',
        u'maxNumOfPrivacyClass',
        u'LCS-PrivacyClass',
        u'ExternalClientList',
        u'maxNumOfExternalClient',
        u'PLMNClientList',
        u'maxNumOfPLMNClient',
        u'Ext-ExternalClientList',
        u'maxNumOfExt-ExternalClient',
        u'ExternalClient',
        u'GMLC-Restriction',
        u'NotificationToMSUser',
        u'ServiceTypeList',
        u'maxNumOfServiceType',
        u'ServiceType',
        u'MOLR-List',
        u'maxNumOfMOLR-Class',
        u'MOLR-Class',
        u'ZoneCodeList',
        u'ZoneCode',
        u'maxNumOfZoneCodes',
        u'InsertSubscriberDataRes',
        u'RegionalSubscriptionResponse',
        u'DeleteSubscriberDataArg',
        u'SpecificCSI-Withdraw',
        u'GPRSSubscriptionDataWithdraw',
        u'EPS-SubscriptionDataWithdraw',
        u'ContextIdList',
        u'LSAInformationWithdraw',
        u'LSAIdentityList',
        u'BasicServiceList',
        u'maxNumOfBasicServices',
        u'DeleteSubscriberDataRes',
        u'VlrCamelSubscriptionInfo',
        u'MT-smsCAMELTDP-CriteriaList',
        u'MT-smsCAMELTDP-Criteria',
        u'TPDU-TypeCriterion',
        u'maxNumOfTPDUTypes',
        u'MT-SMS-TPDU-Type',
        u'D-CSI',
        u'DP-AnalysedInfoCriteriaList',
        u'maxNumOfDP-AnalysedInfoCriteria',
        u'DP-AnalysedInfoCriterium',
        u'SS-CSI',
        u'SS-CamelData',
        u'SS-EventList',
        u'maxNumOfCamelSSEvents',
        u'O-CSI',
        u'O-BcsmCamelTDPDataList',
        u'maxNumOfCamelTDPData',
        u'O-BcsmCamelTDPData',
        u'ServiceKey',
        u'O-BcsmTriggerDetectionPoint',
        u'O-BcsmCamelTDPCriteriaList',
        u'T-BCSM-CAMEL-TDP-CriteriaList',
        u'O-BcsmCamelTDP-Criteria',
        u'T-BCSM-CAMEL-TDP-Criteria',
        u'DestinationNumberCriteria',
        u'DestinationNumberList',
        u'DestinationNumberLengthList',
        u'BasicServiceCriteria',
        u'maxNumOfISDN-AddressDigits',
        u'maxNumOfCamelDestinationNumbers',
        u'maxNumOfCamelDestinationNumberLengths',
        u'maxNumOfCamelBasicServiceCriteria',
        u'CallTypeCriteria',
        u'MatchType',
        u'O-CauseValueCriteria',
        u'T-CauseValueCriteria',
        u'maxNumOfCAMEL-O-CauseValueCriteria',
        u'maxNumOfCAMEL-T-CauseValueCriteria',
        u'CauseValue',
        u'DefaultCallHandling',
        u'CamelCapabilityHandling',
        u'SupportedCamelPhases',
        u'OfferedCamel4CSIs',
        u'OfferedCamel4Functionalities',
        u'SMS-CSI',
        u'SMS-CAMEL-TDP-DataList',
        u'SMS-CAMEL-TDP-Data',
        u'SMS-TriggerDetectionPoint',
        u'DefaultSMS-Handling',
        u'M-CSI',
        u'MG-CSI',
        u'MobilityTriggers',
        u'maxNumOfMobilityTriggers',
        u'MM-Code',
        u'T-CSI',
        u'T-BcsmCamelTDPDataList',
        u'T-BcsmCamelTDPData',
        u'T-BcsmTriggerDetectionPoint',
        u'SendRoutingInfoForGprsArg',
        u'SendRoutingInfoForGprsRes',
        u'FailureReportArg',
        u'FailureReportRes',
        u'NoteMsPresentForGprsArg',
        u'NoteMsPresentForGprsRes',
        u'ResetArg',
        u'SendingNode-Number',
        u'RestoreDataArg',
        u'RestoreDataRes',
        u'VBSDataList',
        u'VGCSDataList',
        u'maxNumOfVBSGroupIds',
        u'maxNumOfVGCSGroupIds',
        u'VoiceGroupCallData',
        u'AdditionalInfo',
        u'AdditionalSubscriptions',
        u'VoiceBroadcastData',
        u'GroupId',
        u'Long-GroupId',
        u'ProvideSubscriberInfoArg',
        u'ProvideSubscriberInfoRes',
        u'SubscriberInfo',
        u'IMS-VoiceOverPS-SessionsInd',
        u'TimeZone',
        u'DaylightSavingTime',
        u'MNPInfoRes',
        u'RouteingNumber',
        u'NumberPortabilityStatus',
        u'MS-Classmark2',
        u'GPRSMSClass',
        u'MSNetworkCapability',
        u'MSRadioAccessCapability',
        u'RequestedInfo',
        u'DomainType',
        u'RequestedNodes',
        u'LocationInformation',
        u'LocationInformationEPS',
        u'LocationInformationGPRS',
        u'LocationInformation5GS',
        u'UserCSGInformation',
        u'GeographicalInformation',
        u'GeodeticInformation',
        u'LocationNumber',
        u'SubscriberState',
        u'PS-SubscriberState',
        u'PDP-ContextInfoList',
        u'PDP-ContextInfo',
        u'NSAPI',
        u'TransactionId',
        u'TEID',
        u'GPRSChargingID',
        u'NotReachableReason',
        u'AnyTimeInterrogationArg',
        u'AnyTimeInterrogationRes',
        u'AnyTimeSubscriptionInterrogationArg',
        u'AnyTimeSubscriptionInterrogationRes',
        u'CallWaitingData',
        u'Ext-CwFeatureList',
        u'Ext-CwFeature',
        u'ClipData',
        u'ClirData',
        u'CallHoldData',
        u'EctData',
        u'RequestedSubscriptionInfo',
        u'MSISDN-BS-List',
        u'maxNumOfMSISDN',
        u'MSISDN-BS',
        u'RequestedCAMEL-SubscriptionInfo',
        u'AdditionalRequestedCAMEL-SubscriptionInfo',
        u'CallForwardingData',
        u'CallBarringData',
        u'WrongPasswordAttemptsCounter',
        u'ODB-Info',
        u'CAMEL-SubscriptionInfo',
        u'AnyTimeModificationArg',
        u'ModificationRequestFor-CW-Info',
        u'ModificationRequestFor-CH-Info',
        u'ModificationRequestFor-ECT-Info',
        u'ModificationRequestFor-CLIR-Info',
        u'ModificationRequestFor-CLIP-Info',
        u'ModificationRequestFor-CSG',
        u'RequestedServingNode',
        u'ServingNode',
        u'AnyTimeModificationRes',
        u'ModificationRequestFor-CF-Info',
        u'ModificationRequestFor-CB-Info',
        u'ModificationRequestFor-ODB-data',
        u'ModificationRequestFor-CSI',
        u'ModificationRequestFor-IP-SM-GW-Data',
        u'ModificationInstruction',
        u'NoteSubscriberDataModifiedArg',
        u'NoteSubscriberDataModifiedRes',
        u'NoteMM-EventArg',
        u'NoteMM-EventRes',
        u'Ext-SS-InfoFor-CSE',
        u'Ext-ForwardingInfoFor-CSE',
        u'Ext-CallBarringInfoFor-CSE',
        u'UpdateVcsgLocationArg',
        u'UpdateVcsgLocationRes',
        u'CancelVcsgLocationArg',
        u'CancelVcsgLocationRes',
        ]
    _type_ = [
        u'UpdateLocationArg',
        u'VLR-Capability',
        u'SupportedRAT-Types',
        u'SuperChargerInfo',
        u'AgeIndicator',
        u'IST-SupportIndicator',
        u'SupportedLCS-CapabilitySets',
        u'UpdateLocationRes',
        u'ADD-Info',
        u'PagingArea',
        u'LocationArea',
        u'LAC',
        u'CancelLocationArg',
        u'TypeOfUpdate',
        u'CancellationType',
        u'CancelLocationRes',
        u'PurgeMS-Arg',
        u'PurgeMS-Res',
        u'SendIdentificationArg',
        u'HopCounter',
        u'SendIdentificationRes',
        u'AuthenticationSetList',
        u'TripletList',
        u'QuintupletList',
        u'AuthenticationTriplet',
        u'AuthenticationQuintuplet',
        u'CurrentSecurityContext',
        u'GSM-SecurityContextData',
        u'UMTS-SecurityContextData',
        u'RAND',
        u'SRES',
        u'Kc',
        u'XRES',
        u'CK',
        u'IK',
        u'AUTN',
        u'AUTS',
        u'Cksn',
        u'KSI',
        u'AuthenticationFailureReportArg',
        u'AccessType',
        u'AuthenticationFailureReportRes',
        u'FailureCause',
        u'UpdateGprsLocationArg',
        u'SMSRegisterRequest',
        u'Used-RAT-Type',
        u'EPS-Info',
        u'PDN-GW-Update',
        u'ISR-Information',
        u'SGSN-Capability',
        u'SupportedFeatures',
        u'Ext-SupportedFeatures',
        u'UE-SRVCC-Capability',
        u'UpdateGprsLocationRes',
        u'EPLMN-List',
        u'AdjacentPLMN-List',
        u'ForwardAccessSignalling-Arg',
        u'AllowedGSM-Algorithms',
        u'AllowedUMTS-Algorithms',
        u'PermittedIntegrityProtectionAlgorithms',
        u'PermittedEncryptionAlgorithms',
        u'KeyStatus',
        u'PrepareHO-Arg',
        u'LCLS-GlobalCallReference',
        u'LCLS-Negotiation',
        u'LCLS-ConfigurationPreference',
        u'BSSMAP-ServiceHandoverList',
        u'BSSMAP-ServiceHandoverInfo',
        u'BSSMAP-ServiceHandover',
        u'RANAP-ServiceHandover',
        u'RadioResourceList',
        u'RadioResource',
        u'PrepareHO-Res',
        u'SelectedUMTS-Algorithms',
        u'ChosenIntegrityProtectionAlgorithm',
        u'ChosenEncryptionAlgorithm',
        u'ChosenRadioResourceInformation',
        u'ChosenChannelInfo',
        u'ChosenSpeechVersion',
        u'PrepareSubsequentHO-Arg',
        u'PrepareSubsequentHO-Res',
        u'ProcessAccessSignalling-Arg',
        u'AoIPCodecsList',
        u'AoIPCodec',
        u'SupportedCodecsList',
        u'CodecList',
        u'Codec',
        u'GERAN-Classmark',
        u'SelectedGSM-Algorithm',
        u'SendEndSignal-Arg',
        u'SendEndSignal-Res',
        u'RNCId',
        u'RelocationNumberList',
        u'MulticallBearerInfo',
        u'RelocationNumber',
        u'RAB-Id',
        u'RadioResourceInformation',
        u'IntegrityProtectionInformation',
        u'EncryptionInformation',
        u'SendAuthenticationInfoArg',
        u'NumberOfRequestedVectors',
        u'Re-synchronisationInfo',
        u'SendAuthenticationInfoRes',
        u'EPS-AuthenticationSetList',
        u'UE-UsageType',
        u'EPC-AV',
        u'KASME',
        u'RequestingNodeType',
        u'CheckIMEI-Arg',
        u'CheckIMEI-Res',
        u'RequestedEquipmentInfo',
        u'UESBI-Iu',
        u'UESBI-IuA',
        u'UESBI-IuB',
        u'EquipmentStatus',
        u'InsertSubscriberDataArg',
        u'EDRX-Cycle-Length-List',
        u'EDRX-Cycle-Length',
        u'EDRX-Cycle-Length-Value',
        u'Reset-Id-List',
        u'Reset-Id',
        u'DL-Buffering-Suggested-Packet-Count',
        u'Group-Service-ID',
        u'Local-GroupID',
        u'IMSI-GroupIdList',
        u'IMSI-GroupId',
        u'SubscribedPeriodicRAUTAUtimer',
        u'SubscribedPeriodicLAUtimer',
        u'CSG-SubscriptionDataList',
        u'CSG-SubscriptionData',
        u'VPLMN-CSG-SubscriptionDataList',
        u'CSG-Id',
        u'LIPA-AllowedAPNList',
        u'EPS-SubscriptionData',
        u'APN-OI-Replacement',
        u'RFSP-ID',
        u'APN-ConfigurationProfile',
        u'EPS-DataList',
        u'APN-Configuration',
        u'PDN-ConnectionContinuity',
        u'NIDD-Mechanism',
        u'PDN-Type',
        u'EPS-QoS-Subscribed',
        u'AMBR',
        u'SpecificAPNInfoList',
        u'SpecificAPNInfo',
        u'Bandwidth',
        u'BandwidthExt',
        u'QoS-Class-Identifier',
        u'Allocation-Retention-Priority',
        u'PDN-GW-Identity',
        u'FQDN',
        u'PDN-GW-AllocationType',
        u'WLAN-Offloadability',
        u'WLAN-Offloadability-Indication',
        u'AccessRestrictionData',
        u'Ext-AccessRestrictionData',
        u'AdjacentAccessRestrictionDataList',
        u'AdjacentAccessRestrictionData',
        u'CS-AllocationRetentionPriority',
        u'IST-AlertTimerValue',
        u'LCSInformation',
        u'GMLC-List',
        u'NetworkAccessMode',
        u'GPRSDataList',
        u'PDP-Context',
        u'Restoration-Priority',
        u'SIPTO-Permission',
        u'SIPTO-Local-Network-Permission',
        u'LIPA-Permission',
        u'ContextId',
        u'GPRSSubscriptionData',
        u'SGSN-CAMEL-SubscriptionInfo',
        u'GPRS-CSI',
        u'GPRS-CamelTDPDataList',
        u'GPRS-CamelTDPData',
        u'DefaultGPRS-Handling',
        u'GPRS-TriggerDetectionPoint',
        u'APN',
        u'PDP-Type',
        u'Ext-PDP-Type',
        u'PDP-Address',
        u'QoS-Subscribed',
        u'Ext-QoS-Subscribed',
        u'Ext2-QoS-Subscribed',
        u'Ext3-QoS-Subscribed',
        u'Ext4-QoS-Subscribed',
        u'ChargingCharacteristics',
        u'LSAOnlyAccessIndicator',
        u'LSADataList',
        u'LSAData',
        u'LSAInformation',
        u'LSAIdentity',
        u'LSAAttributes',
        u'SubscriberData',
        u'Category',
        u'SubscriberStatus',
        u'BearerServiceList',
        u'TeleserviceList',
        u'ODB-Data',
        u'ODB-GeneralData',
        u'ODB-HPLMN-Data',
        u'Ext-SS-InfoList',
        u'Ext-SS-Info',
        u'Ext-ForwInfo',
        u'Ext-ForwFeatureList',
        u'Ext-ForwFeature',
        u'Ext-ForwOptions',
        u'Ext-NoRepCondTime',
        u'Ext-CallBarInfo',
        u'Ext-CallBarFeatureList',
        u'Ext-CallBarringFeature',
        u'CUG-Info',
        u'CUG-SubscriptionList',
        u'CUG-Subscription',
        u'CUG-Index',
        u'CUG-Interlock',
        u'IntraCUG-Options',
        u'CUG-FeatureList',
        u'Ext-BasicServiceGroupList',
        u'CUG-Feature',
        u'InterCUG-Restrictions',
        u'Ext-SS-Data',
        u'LCS-PrivacyExceptionList',
        u'LCS-PrivacyClass',
        u'ExternalClientList',
        u'PLMNClientList',
        u'Ext-ExternalClientList',
        u'ExternalClient',
        u'GMLC-Restriction',
        u'NotificationToMSUser',
        u'ServiceTypeList',
        u'ServiceType',
        u'MOLR-List',
        u'MOLR-Class',
        u'ZoneCodeList',
        u'ZoneCode',
        u'InsertSubscriberDataRes',
        u'RegionalSubscriptionResponse',
        u'DeleteSubscriberDataArg',
        u'SpecificCSI-Withdraw',
        u'GPRSSubscriptionDataWithdraw',
        u'EPS-SubscriptionDataWithdraw',
        u'ContextIdList',
        u'LSAInformationWithdraw',
        u'LSAIdentityList',
        u'BasicServiceList',
        u'DeleteSubscriberDataRes',
        u'VlrCamelSubscriptionInfo',
        u'MT-smsCAMELTDP-CriteriaList',
        u'MT-smsCAMELTDP-Criteria',
        u'TPDU-TypeCriterion',
        u'MT-SMS-TPDU-Type',
        u'D-CSI',
        u'DP-AnalysedInfoCriteriaList',
        u'DP-AnalysedInfoCriterium',
        u'SS-CSI',
        u'SS-CamelData',
        u'SS-EventList',
        u'O-CSI',
        u'O-BcsmCamelTDPDataList',
        u'O-BcsmCamelTDPData',
        u'ServiceKey',
        u'O-BcsmTriggerDetectionPoint',
        u'O-BcsmCamelTDPCriteriaList',
        u'T-BCSM-CAMEL-TDP-CriteriaList',
        u'O-BcsmCamelTDP-Criteria',
        u'T-BCSM-CAMEL-TDP-Criteria',
        u'DestinationNumberCriteria',
        u'DestinationNumberList',
        u'DestinationNumberLengthList',
        u'BasicServiceCriteria',
        u'CallTypeCriteria',
        u'MatchType',
        u'O-CauseValueCriteria',
        u'T-CauseValueCriteria',
        u'CauseValue',
        u'DefaultCallHandling',
        u'CamelCapabilityHandling',
        u'SupportedCamelPhases',
        u'OfferedCamel4CSIs',
        u'OfferedCamel4Functionalities',
        u'SMS-CSI',
        u'SMS-CAMEL-TDP-DataList',
        u'SMS-CAMEL-TDP-Data',
        u'SMS-TriggerDetectionPoint',
        u'DefaultSMS-Handling',
        u'M-CSI',
        u'MG-CSI',
        u'MobilityTriggers',
        u'MM-Code',
        u'T-CSI',
        u'T-BcsmCamelTDPDataList',
        u'T-BcsmCamelTDPData',
        u'T-BcsmTriggerDetectionPoint',
        u'SendRoutingInfoForGprsArg',
        u'SendRoutingInfoForGprsRes',
        u'FailureReportArg',
        u'FailureReportRes',
        u'NoteMsPresentForGprsArg',
        u'NoteMsPresentForGprsRes',
        u'ResetArg',
        u'SendingNode-Number',
        u'RestoreDataArg',
        u'RestoreDataRes',
        u'VBSDataList',
        u'VGCSDataList',
        u'VoiceGroupCallData',
        u'AdditionalInfo',
        u'AdditionalSubscriptions',
        u'VoiceBroadcastData',
        u'GroupId',
        u'Long-GroupId',
        u'ProvideSubscriberInfoArg',
        u'ProvideSubscriberInfoRes',
        u'SubscriberInfo',
        u'IMS-VoiceOverPS-SessionsInd',
        u'TimeZone',
        u'DaylightSavingTime',
        u'MNPInfoRes',
        u'RouteingNumber',
        u'NumberPortabilityStatus',
        u'MS-Classmark2',
        u'GPRSMSClass',
        u'MSNetworkCapability',
        u'MSRadioAccessCapability',
        u'RequestedInfo',
        u'DomainType',
        u'RequestedNodes',
        u'LocationInformation',
        u'LocationInformationEPS',
        u'LocationInformationGPRS',
        u'LocationInformation5GS',
        u'UserCSGInformation',
        u'GeographicalInformation',
        u'GeodeticInformation',
        u'LocationNumber',
        u'SubscriberState',
        u'PS-SubscriberState',
        u'PDP-ContextInfoList',
        u'PDP-ContextInfo',
        u'NSAPI',
        u'TransactionId',
        u'TEID',
        u'GPRSChargingID',
        u'NotReachableReason',
        u'AnyTimeInterrogationArg',
        u'AnyTimeInterrogationRes',
        u'AnyTimeSubscriptionInterrogationArg',
        u'AnyTimeSubscriptionInterrogationRes',
        u'CallWaitingData',
        u'Ext-CwFeatureList',
        u'Ext-CwFeature',
        u'ClipData',
        u'ClirData',
        u'CallHoldData',
        u'EctData',
        u'RequestedSubscriptionInfo',
        u'MSISDN-BS-List',
        u'MSISDN-BS',
        u'RequestedCAMEL-SubscriptionInfo',
        u'AdditionalRequestedCAMEL-SubscriptionInfo',
        u'CallForwardingData',
        u'CallBarringData',
        u'WrongPasswordAttemptsCounter',
        u'ODB-Info',
        u'CAMEL-SubscriptionInfo',
        u'AnyTimeModificationArg',
        u'ModificationRequestFor-CW-Info',
        u'ModificationRequestFor-CH-Info',
        u'ModificationRequestFor-ECT-Info',
        u'ModificationRequestFor-CLIR-Info',
        u'ModificationRequestFor-CLIP-Info',
        u'ModificationRequestFor-CSG',
        u'RequestedServingNode',
        u'ServingNode',
        u'AnyTimeModificationRes',
        u'ModificationRequestFor-CF-Info',
        u'ModificationRequestFor-CB-Info',
        u'ModificationRequestFor-ODB-data',
        u'ModificationRequestFor-CSI',
        u'ModificationRequestFor-IP-SM-GW-Data',
        u'ModificationInstruction',
        u'NoteSubscriberDataModifiedArg',
        u'NoteSubscriberDataModifiedRes',
        u'NoteMM-EventArg',
        u'NoteMM-EventRes',
        u'Ext-SS-InfoFor-CSE',
        u'Ext-ForwardingInfoFor-CSE',
        u'Ext-CallBarringInfoFor-CSE',
        u'UpdateVcsgLocationArg',
        u'UpdateVcsgLocationRes',
        u'CancelVcsgLocationArg',
        u'CancelVcsgLocationRes',
        ]
    _set_ = [
        ]
    _val_ = [
        u'maxPermittedIntegrityProtectionAlgorithmsLength',
        u'maxPermittedEncryptionAlgorithmsLength',
        u'maxNumOfServiceHandovers',
        u'maxNumOfRadioResources',
        u'maxNrOfRABs',
        u'maxNumOfRelocationNumber',
        u'maxNumOfIntegrityInfo',
        u'maxNumOfEncryptionInfo',
        u'maxNumOfLIPAAllowedAPN',
        u'maxNumOfAPN-Configurations',
        u'maxNumOfSpecificAPNInfos',
        u'maxNumOfGMLC',
        u'maxNumOfPDP-Contexts',
        u'maxNumOfLSAs',
        u'maxNumOfBearerServices',
        u'maxNumOfTeleservices',
        u'maxNumOfCUG',
        u'maxNumOfExt-BasicServiceGroups',
        u'maxNumOfPrivacyClass',
        u'maxNumOfExternalClient',
        u'maxNumOfPLMNClient',
        u'maxNumOfExt-ExternalClient',
        u'maxNumOfServiceType',
        u'maxNumOfMOLR-Class',
        u'maxNumOfZoneCodes',
        u'maxNumOfBasicServices',
        u'maxNumOfTPDUTypes',
        u'maxNumOfDP-AnalysedInfoCriteria',
        u'maxNumOfCamelSSEvents',
        u'maxNumOfCamelTDPData',
        u'maxNumOfISDN-AddressDigits',
        u'maxNumOfCamelDestinationNumbers',
        u'maxNumOfCamelDestinationNumberLengths',
        u'maxNumOfCamelBasicServiceCriteria',
        u'maxNumOfCAMEL-O-CauseValueCriteria',
        u'maxNumOfCAMEL-T-CauseValueCriteria',
        u'maxNumOfMobilityTriggers',
        u'maxNumOfVBSGroupIds',
        u'maxNumOfVGCSGroupIds',
        u'maxNumOfMSISDN',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< UpdateLocationArg >-----#
    UpdateLocationArg = SEQ(name=u'UpdateLocationArg', mode=MODE_TYPE)
    _UpdateLocationArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _UpdateLocationArg_msc_Number = OCT_STR(name=u'msc-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateLocationArg_vlr_Number = OCT_STR(name=u'vlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateLocationArg_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _UpdateLocationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateLocationArg_vlr_Capability = SEQ(name=u'vlr-Capability', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VLR-Capability')), opt=True)
    _UpdateLocationArg_informPreviousNetworkEntity = NULL(name=u'informPreviousNetworkEntity', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_cs_LCS_NotSupportedByUE = NULL(name=u'cs-LCS-NotSupportedByUE', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_v_gmlc_Address = OCT_STR(name=u'v-gmlc-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _UpdateLocationArg_add_info = SEQ(name=u'add-info', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ADD-Info')), opt=True)
    _UpdateLocationArg_pagingArea = SEQ_OF(name=u'pagingArea', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PagingArea')), opt=True)
    _UpdateLocationArg_skipSubscriberDataUpdate = NULL(name=u'skipSubscriberDataUpdate', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_restorationIndicator = NULL(name=u'restorationIndicator', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateLocationArg_eplmn_List = SEQ_OF(name=u'eplmn-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPLMN-List')), opt=True)
    _UpdateLocationArg_mme_DiameterAddress = SEQ(name=u'mme-DiameterAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    UpdateLocationArg._cont = ASN1Dict([
        (u'imsi', _UpdateLocationArg_imsi),
        (u'msc-Number', _UpdateLocationArg_msc_Number),
        (u'vlr-Number', _UpdateLocationArg_vlr_Number),
        (u'lmsi', _UpdateLocationArg_lmsi),
        (u'extensionContainer', _UpdateLocationArg_extensionContainer),
        (u'vlr-Capability', _UpdateLocationArg_vlr_Capability),
        (u'informPreviousNetworkEntity', _UpdateLocationArg_informPreviousNetworkEntity),
        (u'cs-LCS-NotSupportedByUE', _UpdateLocationArg_cs_LCS_NotSupportedByUE),
        (u'v-gmlc-Address', _UpdateLocationArg_v_gmlc_Address),
        (u'add-info', _UpdateLocationArg_add_info),
        (u'pagingArea', _UpdateLocationArg_pagingArea),
        (u'skipSubscriberDataUpdate', _UpdateLocationArg_skipSubscriberDataUpdate),
        (u'restorationIndicator', _UpdateLocationArg_restorationIndicator),
        (u'eplmn-List', _UpdateLocationArg_eplmn_List),
        (u'mme-DiameterAddress', _UpdateLocationArg_mme_DiameterAddress),
        ])
    UpdateLocationArg._ext = [u'vlr-Capability', u'informPreviousNetworkEntity', u'cs-LCS-NotSupportedByUE', u'v-gmlc-Address', u'add-info', u'pagingArea', u'skipSubscriberDataUpdate', u'restorationIndicator', u'eplmn-List', u'mme-DiameterAddress']
    
    #-----< VLR-Capability >-----#
    VLR_Capability = SEQ(name=u'VLR-Capability', mode=MODE_TYPE)
    _VLR_Capability_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _VLR_Capability_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VLR_Capability_solsaSupportIndicator = NULL(name=u'solsaSupportIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_istSupportIndicator = ENUM(name=u'istSupportIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-SupportIndicator')), opt=True)
    _VLR_Capability_superChargerSupportedInServingNetworkEntity = CHOICE(name=u'superChargerSupportedInServingNetworkEntity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SuperChargerInfo')), opt=True)
    _VLR_Capability_longFTN_Supported = NULL(name=u'longFTN-Supported', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_supportedLCS_CapabilitySets = BIT_STR(name=u'supportedLCS-CapabilitySets', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedLCS-CapabilitySets')), opt=True)
    _VLR_Capability_offeredCamel4CSIs = BIT_STR(name=u'offeredCamel4CSIs', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _VLR_Capability_supportedRAT_TypesIndicator = BIT_STR(name=u'supportedRAT-TypesIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedRAT-Types')), opt=True)
    _VLR_Capability_longGroupID_Supported = NULL(name=u'longGroupID-Supported', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_mtRoamingForwardingSupported = NULL(name=u'mtRoamingForwardingSupported', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_msisdn_lessOperation_Supported = NULL(name=u'msisdn-lessOperation-Supported', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VLR_Capability_reset_ids_Supported = NULL(name=u'reset-ids-Supported', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    VLR_Capability._cont = ASN1Dict([
        (u'supportedCamelPhases', _VLR_Capability_supportedCamelPhases),
        (u'extensionContainer', _VLR_Capability_extensionContainer),
        (u'solsaSupportIndicator', _VLR_Capability_solsaSupportIndicator),
        (u'istSupportIndicator', _VLR_Capability_istSupportIndicator),
        (u'superChargerSupportedInServingNetworkEntity', _VLR_Capability_superChargerSupportedInServingNetworkEntity),
        (u'longFTN-Supported', _VLR_Capability_longFTN_Supported),
        (u'supportedLCS-CapabilitySets', _VLR_Capability_supportedLCS_CapabilitySets),
        (u'offeredCamel4CSIs', _VLR_Capability_offeredCamel4CSIs),
        (u'supportedRAT-TypesIndicator', _VLR_Capability_supportedRAT_TypesIndicator),
        (u'longGroupID-Supported', _VLR_Capability_longGroupID_Supported),
        (u'mtRoamingForwardingSupported', _VLR_Capability_mtRoamingForwardingSupported),
        (u'msisdn-lessOperation-Supported', _VLR_Capability_msisdn_lessOperation_Supported),
        (u'reset-ids-Supported', _VLR_Capability_reset_ids_Supported),
        ])
    VLR_Capability._ext = [u'solsaSupportIndicator', u'istSupportIndicator', u'superChargerSupportedInServingNetworkEntity', u'longFTN-Supported', u'supportedLCS-CapabilitySets', u'offeredCamel4CSIs', u'supportedRAT-TypesIndicator', u'longGroupID-Supported', u'mtRoamingForwardingSupported', u'msisdn-lessOperation-Supported', u'reset-ids-Supported']
    
    #-----< SupportedRAT-Types >-----#
    SupportedRAT_Types = BIT_STR(name=u'SupportedRAT-Types', mode=MODE_TYPE)
    SupportedRAT_Types._cont = ASN1Dict([(u'utran', 0), (u'geran', 1), (u'gan', 2), (u'i-hspa-evolution', 3), (u'e-utran', 4), (u'nb-iot', 5)])
    SupportedRAT_Types._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< SuperChargerInfo >-----#
    SuperChargerInfo = CHOICE(name=u'SuperChargerInfo', mode=MODE_TYPE)
    _SuperChargerInfo_sendSubscriberData = NULL(name=u'sendSubscriberData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SuperChargerInfo_subscriberDataStored = OCT_STR(name=u'subscriberDataStored', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AgeIndicator')))
    SuperChargerInfo._cont = ASN1Dict([
        (u'sendSubscriberData', _SuperChargerInfo_sendSubscriberData),
        (u'subscriberDataStored', _SuperChargerInfo_subscriberDataStored),
        ])
    SuperChargerInfo._ext = None
    
    #-----< AgeIndicator >-----#
    AgeIndicator = OCT_STR(name=u'AgeIndicator', mode=MODE_TYPE)
    AgeIndicator._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< IST-SupportIndicator >-----#
    IST_SupportIndicator = ENUM(name=u'IST-SupportIndicator', mode=MODE_TYPE)
    IST_SupportIndicator._cont = ASN1Dict([(u'basicISTSupported', 0), (u'istCommandSupported', 1)])
    IST_SupportIndicator._ext = []
    
    #-----< SupportedLCS-CapabilitySets >-----#
    SupportedLCS_CapabilitySets = BIT_STR(name=u'SupportedLCS-CapabilitySets', mode=MODE_TYPE)
    SupportedLCS_CapabilitySets._cont = ASN1Dict([(u'lcsCapabilitySet1', 0), (u'lcsCapabilitySet2', 1), (u'lcsCapabilitySet3', 2), (u'lcsCapabilitySet4', 3), (u'lcsCapabilitySet5', 4)])
    SupportedLCS_CapabilitySets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=16)], ev=None, er=[])
    
    #-----< UpdateLocationRes >-----#
    UpdateLocationRes = SEQ(name=u'UpdateLocationRes', mode=MODE_TYPE)
    _UpdateLocationRes_hlr_Number = OCT_STR(name=u'hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateLocationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateLocationRes_add_Capability = NULL(name=u'add-Capability', mode=MODE_TYPE, opt=True)
    _UpdateLocationRes_pagingArea_Capability = NULL(name=u'pagingArea-Capability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UpdateLocationRes._cont = ASN1Dict([
        (u'hlr-Number', _UpdateLocationRes_hlr_Number),
        (u'extensionContainer', _UpdateLocationRes_extensionContainer),
        (u'add-Capability', _UpdateLocationRes_add_Capability),
        (u'pagingArea-Capability', _UpdateLocationRes_pagingArea_Capability),
        ])
    UpdateLocationRes._ext = [u'add-Capability', u'pagingArea-Capability']
    
    #-----< ADD-Info >-----#
    ADD_Info = SEQ(name=u'ADD-Info', mode=MODE_TYPE)
    _ADD_Info_imeisv = OCT_STR(name=u'imeisv', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')))
    _ADD_Info_skipSubscriberDataUpdate = NULL(name=u'skipSubscriberDataUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ADD_Info._cont = ASN1Dict([
        (u'imeisv', _ADD_Info_imeisv),
        (u'skipSubscriberDataUpdate', _ADD_Info_skipSubscriberDataUpdate),
        ])
    ADD_Info._ext = []
    
    #-----< PagingArea >-----#
    PagingArea = SEQ_OF(name=u'PagingArea', mode=MODE_TYPE)
    _PagingArea__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationArea')))
    PagingArea._cont = _PagingArea__item_
    PagingArea._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< LocationArea >-----#
    LocationArea = CHOICE(name=u'LocationArea', mode=MODE_TYPE)
    _LocationArea_laiFixedLength = OCT_STR(name=u'laiFixedLength', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    _LocationArea_lac = OCT_STR(name=u'lac', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LAC')))
    LocationArea._cont = ASN1Dict([
        (u'laiFixedLength', _LocationArea_laiFixedLength),
        (u'lac', _LocationArea_lac),
        ])
    LocationArea._ext = None
    
    #-----< LAC >-----#
    LAC = OCT_STR(name=u'LAC', mode=MODE_TYPE)
    LAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< CancelLocationArg >-----#
    CancelLocationArg = SEQ(name=u'CancelLocationArg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CancelLocationArg_identity = CHOICE(name=u'identity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Identity')))
    _CancelLocationArg_cancellationType = ENUM(name=u'cancellationType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CancellationType')), opt=True)
    _CancelLocationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CancelLocationArg_typeOfUpdate = ENUM(name=u'typeOfUpdate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TypeOfUpdate')), opt=True)
    _CancelLocationArg_mtrf_SupportedAndAuthorized = NULL(name=u'mtrf-SupportedAndAuthorized', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CancelLocationArg_mtrf_SupportedAndNotAuthorized = NULL(name=u'mtrf-SupportedAndNotAuthorized', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CancelLocationArg_newMSC_Number = OCT_STR(name=u'newMSC-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _CancelLocationArg_newVLR_Number = OCT_STR(name=u'newVLR-Number', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _CancelLocationArg_new_lmsi = OCT_STR(name=u'new-lmsi', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _CancelLocationArg_reattach_Required = NULL(name=u'reattach-Required', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CancelLocationArg._cont = ASN1Dict([
        (u'identity', _CancelLocationArg_identity),
        (u'cancellationType', _CancelLocationArg_cancellationType),
        (u'extensionContainer', _CancelLocationArg_extensionContainer),
        (u'typeOfUpdate', _CancelLocationArg_typeOfUpdate),
        (u'mtrf-SupportedAndAuthorized', _CancelLocationArg_mtrf_SupportedAndAuthorized),
        (u'mtrf-SupportedAndNotAuthorized', _CancelLocationArg_mtrf_SupportedAndNotAuthorized),
        (u'newMSC-Number', _CancelLocationArg_newMSC_Number),
        (u'newVLR-Number', _CancelLocationArg_newVLR_Number),
        (u'new-lmsi', _CancelLocationArg_new_lmsi),
        (u'reattach-Required', _CancelLocationArg_reattach_Required),
        ])
    CancelLocationArg._ext = [u'typeOfUpdate', u'mtrf-SupportedAndAuthorized', u'mtrf-SupportedAndNotAuthorized', u'newMSC-Number', u'newVLR-Number', u'new-lmsi', u'reattach-Required']
    
    #-----< TypeOfUpdate >-----#
    TypeOfUpdate = ENUM(name=u'TypeOfUpdate', mode=MODE_TYPE)
    TypeOfUpdate._cont = ASN1Dict([(u'sgsn-change', 0), (u'mme-change', 1)])
    TypeOfUpdate._ext = []
    
    #-----< CancellationType >-----#
    CancellationType = ENUM(name=u'CancellationType', mode=MODE_TYPE)
    CancellationType._cont = ASN1Dict([(u'updateProcedure', 0), (u'subscriptionWithdraw', 1), (u'initialAttachProcedure', 2)])
    CancellationType._ext = [u'initialAttachProcedure']
    
    #-----< CancelLocationRes >-----#
    CancelLocationRes = SEQ(name=u'CancelLocationRes', mode=MODE_TYPE)
    _CancelLocationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CancelLocationRes._cont = ASN1Dict([
        (u'extensionContainer', _CancelLocationRes_extensionContainer),
        ])
    CancelLocationRes._ext = []
    
    #-----< PurgeMS-Arg >-----#
    PurgeMS_Arg = SEQ(name=u'PurgeMS-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PurgeMS_Arg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _PurgeMS_Arg_vlr_Number = OCT_STR(name=u'vlr-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _PurgeMS_Arg_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _PurgeMS_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PurgeMS_Arg_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _PurgeMS_Arg_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationGPRS')), opt=True)
    _PurgeMS_Arg_locationInformationEPS = SEQ(name=u'locationInformationEPS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationEPS')), opt=True)
    PurgeMS_Arg._cont = ASN1Dict([
        (u'imsi', _PurgeMS_Arg_imsi),
        (u'vlr-Number', _PurgeMS_Arg_vlr_Number),
        (u'sgsn-Number', _PurgeMS_Arg_sgsn_Number),
        (u'extensionContainer', _PurgeMS_Arg_extensionContainer),
        (u'locationInformation', _PurgeMS_Arg_locationInformation),
        (u'locationInformationGPRS', _PurgeMS_Arg_locationInformationGPRS),
        (u'locationInformationEPS', _PurgeMS_Arg_locationInformationEPS),
        ])
    PurgeMS_Arg._ext = [u'locationInformation', u'locationInformationGPRS', u'locationInformationEPS']
    
    #-----< PurgeMS-Res >-----#
    PurgeMS_Res = SEQ(name=u'PurgeMS-Res', mode=MODE_TYPE)
    _PurgeMS_Res_freezeTMSI = NULL(name=u'freezeTMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PurgeMS_Res_freezeP_TMSI = NULL(name=u'freezeP-TMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PurgeMS_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PurgeMS_Res_freezeM_TMSI = NULL(name=u'freezeM-TMSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PurgeMS_Res._cont = ASN1Dict([
        (u'freezeTMSI', _PurgeMS_Res_freezeTMSI),
        (u'freezeP-TMSI', _PurgeMS_Res_freezeP_TMSI),
        (u'extensionContainer', _PurgeMS_Res_extensionContainer),
        (u'freezeM-TMSI', _PurgeMS_Res_freezeM_TMSI),
        ])
    PurgeMS_Res._ext = [u'freezeM-TMSI']
    
    #-----< SendIdentificationArg >-----#
    SendIdentificationArg = SEQ(name=u'SendIdentificationArg', mode=MODE_TYPE)
    _SendIdentificationArg_tmsi = OCT_STR(name=u'tmsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TMSI')))
    _SendIdentificationArg_numberOfRequestedVectors = INT(name=u'numberOfRequestedVectors', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberOfRequestedVectors')), opt=True)
    _SendIdentificationArg_segmentationProhibited = NULL(name=u'segmentationProhibited', mode=MODE_TYPE, opt=True)
    _SendIdentificationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendIdentificationArg_msc_Number = OCT_STR(name=u'msc-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendIdentificationArg_previous_LAI = OCT_STR(name=u'previous-LAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')), opt=True)
    _SendIdentificationArg_hopCounter = INT(name=u'hopCounter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'HopCounter')), opt=True)
    _SendIdentificationArg_mtRoamingForwardingSupported = NULL(name=u'mtRoamingForwardingSupported', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendIdentificationArg_newVLR_Number = OCT_STR(name=u'newVLR-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SendIdentificationArg_new_lmsi = OCT_STR(name=u'new-lmsi', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    SendIdentificationArg._cont = ASN1Dict([
        (u'tmsi', _SendIdentificationArg_tmsi),
        (u'numberOfRequestedVectors', _SendIdentificationArg_numberOfRequestedVectors),
        (u'segmentationProhibited', _SendIdentificationArg_segmentationProhibited),
        (u'extensionContainer', _SendIdentificationArg_extensionContainer),
        (u'msc-Number', _SendIdentificationArg_msc_Number),
        (u'previous-LAI', _SendIdentificationArg_previous_LAI),
        (u'hopCounter', _SendIdentificationArg_hopCounter),
        (u'mtRoamingForwardingSupported', _SendIdentificationArg_mtRoamingForwardingSupported),
        (u'newVLR-Number', _SendIdentificationArg_newVLR_Number),
        (u'new-lmsi', _SendIdentificationArg_new_lmsi),
        ])
    SendIdentificationArg._ext = [u'msc-Number', u'previous-LAI', u'hopCounter', u'mtRoamingForwardingSupported', u'newVLR-Number', u'new-lmsi']
    
    #-----< HopCounter >-----#
    HopCounter = INT(name=u'HopCounter', mode=MODE_TYPE)
    HopCounter._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< SendIdentificationRes >-----#
    SendIdentificationRes = SEQ(name=u'SendIdentificationRes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendIdentificationRes_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _SendIdentificationRes_authenticationSetList = CHOICE(name=u'authenticationSetList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationSetList')), opt=True)
    _SendIdentificationRes_currentSecurityContext = CHOICE(name=u'currentSecurityContext', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CurrentSecurityContext')), opt=True)
    _SendIdentificationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendIdentificationRes_lastUsedLtePLMN_Id = OCT_STR(name=u'lastUsedLtePLMN-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    _SendIdentificationRes_mtCallPendingFlag = NULL(name=u'mtCallPendingFlag', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SendIdentificationRes._cont = ASN1Dict([
        (u'imsi', _SendIdentificationRes_imsi),
        (u'authenticationSetList', _SendIdentificationRes_authenticationSetList),
        (u'currentSecurityContext', _SendIdentificationRes_currentSecurityContext),
        (u'extensionContainer', _SendIdentificationRes_extensionContainer),
        (u'lastUsedLtePLMN-Id', _SendIdentificationRes_lastUsedLtePLMN_Id),
        (u'mtCallPendingFlag', _SendIdentificationRes_mtCallPendingFlag),
        ])
    SendIdentificationRes._ext = [u'lastUsedLtePLMN-Id', u'mtCallPendingFlag']
    
    #-----< AuthenticationSetList >-----#
    AuthenticationSetList = CHOICE(name=u'AuthenticationSetList', mode=MODE_TYPE)
    _AuthenticationSetList_tripletList = SEQ_OF(name=u'tripletList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TripletList')))
    _AuthenticationSetList_quintupletList = SEQ_OF(name=u'quintupletList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QuintupletList')))
    AuthenticationSetList._cont = ASN1Dict([
        (u'tripletList', _AuthenticationSetList_tripletList),
        (u'quintupletList', _AuthenticationSetList_quintupletList),
        ])
    AuthenticationSetList._ext = None
    
    #-----< TripletList >-----#
    TripletList = SEQ_OF(name=u'TripletList', mode=MODE_TYPE)
    _TripletList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationTriplet')))
    TripletList._cont = _TripletList__item_
    TripletList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< QuintupletList >-----#
    QuintupletList = SEQ_OF(name=u'QuintupletList', mode=MODE_TYPE)
    _QuintupletList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationQuintuplet')))
    QuintupletList._cont = _QuintupletList__item_
    QuintupletList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< AuthenticationTriplet >-----#
    AuthenticationTriplet = SEQ(name=u'AuthenticationTriplet', mode=MODE_TYPE)
    _AuthenticationTriplet_rand = OCT_STR(name=u'rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _AuthenticationTriplet_sres = OCT_STR(name=u'sres', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SRES')))
    _AuthenticationTriplet_kc = OCT_STR(name=u'kc', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Kc')))
    AuthenticationTriplet._cont = ASN1Dict([
        (u'rand', _AuthenticationTriplet_rand),
        (u'sres', _AuthenticationTriplet_sres),
        (u'kc', _AuthenticationTriplet_kc),
        ])
    AuthenticationTriplet._ext = []
    
    #-----< AuthenticationQuintuplet >-----#
    AuthenticationQuintuplet = SEQ(name=u'AuthenticationQuintuplet', mode=MODE_TYPE)
    _AuthenticationQuintuplet_rand = OCT_STR(name=u'rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _AuthenticationQuintuplet_xres = OCT_STR(name=u'xres', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'XRES')))
    _AuthenticationQuintuplet_ck = OCT_STR(name=u'ck', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CK')))
    _AuthenticationQuintuplet_ik = OCT_STR(name=u'ik', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IK')))
    _AuthenticationQuintuplet_autn = OCT_STR(name=u'autn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AUTN')))
    AuthenticationQuintuplet._cont = ASN1Dict([
        (u'rand', _AuthenticationQuintuplet_rand),
        (u'xres', _AuthenticationQuintuplet_xres),
        (u'ck', _AuthenticationQuintuplet_ck),
        (u'ik', _AuthenticationQuintuplet_ik),
        (u'autn', _AuthenticationQuintuplet_autn),
        ])
    AuthenticationQuintuplet._ext = []
    
    #-----< CurrentSecurityContext >-----#
    CurrentSecurityContext = CHOICE(name=u'CurrentSecurityContext', mode=MODE_TYPE)
    _CurrentSecurityContext_gsm_SecurityContextData = SEQ(name=u'gsm-SecurityContextData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GSM-SecurityContextData')))
    _CurrentSecurityContext_umts_SecurityContextData = SEQ(name=u'umts-SecurityContextData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UMTS-SecurityContextData')))
    CurrentSecurityContext._cont = ASN1Dict([
        (u'gsm-SecurityContextData', _CurrentSecurityContext_gsm_SecurityContextData),
        (u'umts-SecurityContextData', _CurrentSecurityContext_umts_SecurityContextData),
        ])
    CurrentSecurityContext._ext = None
    
    #-----< GSM-SecurityContextData >-----#
    GSM_SecurityContextData = SEQ(name=u'GSM-SecurityContextData', mode=MODE_TYPE)
    _GSM_SecurityContextData_kc = OCT_STR(name=u'kc', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Kc')))
    _GSM_SecurityContextData_cksn = OCT_STR(name=u'cksn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Cksn')))
    GSM_SecurityContextData._cont = ASN1Dict([
        (u'kc', _GSM_SecurityContextData_kc),
        (u'cksn', _GSM_SecurityContextData_cksn),
        ])
    GSM_SecurityContextData._ext = []
    
    #-----< UMTS-SecurityContextData >-----#
    UMTS_SecurityContextData = SEQ(name=u'UMTS-SecurityContextData', mode=MODE_TYPE)
    _UMTS_SecurityContextData_ck = OCT_STR(name=u'ck', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CK')))
    _UMTS_SecurityContextData_ik = OCT_STR(name=u'ik', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IK')))
    _UMTS_SecurityContextData_ksi = OCT_STR(name=u'ksi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'KSI')))
    UMTS_SecurityContextData._cont = ASN1Dict([
        (u'ck', _UMTS_SecurityContextData_ck),
        (u'ik', _UMTS_SecurityContextData_ik),
        (u'ksi', _UMTS_SecurityContextData_ksi),
        ])
    UMTS_SecurityContextData._ext = []
    
    #-----< RAND >-----#
    RAND = OCT_STR(name=u'RAND', mode=MODE_TYPE)
    RAND._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< SRES >-----#
    SRES = OCT_STR(name=u'SRES', mode=MODE_TYPE)
    SRES._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< Kc >-----#
    Kc = OCT_STR(name=u'Kc', mode=MODE_TYPE)
    Kc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< XRES >-----#
    XRES = OCT_STR(name=u'XRES', mode=MODE_TYPE)
    XRES._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=16)], ev=None, er=[])
    
    #-----< CK >-----#
    CK = OCT_STR(name=u'CK', mode=MODE_TYPE)
    CK._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< IK >-----#
    IK = OCT_STR(name=u'IK', mode=MODE_TYPE)
    IK._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< AUTN >-----#
    AUTN = OCT_STR(name=u'AUTN', mode=MODE_TYPE)
    AUTN._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< AUTS >-----#
    AUTS = OCT_STR(name=u'AUTS', mode=MODE_TYPE)
    AUTS._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    
    #-----< Cksn >-----#
    Cksn = OCT_STR(name=u'Cksn', mode=MODE_TYPE)
    Cksn._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< KSI >-----#
    KSI = OCT_STR(name=u'KSI', mode=MODE_TYPE)
    KSI._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< AuthenticationFailureReportArg >-----#
    AuthenticationFailureReportArg = SEQ(name=u'AuthenticationFailureReportArg', mode=MODE_TYPE)
    _AuthenticationFailureReportArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _AuthenticationFailureReportArg_failureCause = ENUM(name=u'failureCause', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'FailureCause')))
    _AuthenticationFailureReportArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AuthenticationFailureReportArg_re_attempt = BOOL(name=u're-attempt', mode=MODE_TYPE, opt=True)
    _AuthenticationFailureReportArg_accessType = ENUM(name=u'accessType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AccessType')), opt=True)
    _AuthenticationFailureReportArg_rand = OCT_STR(name=u'rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')), opt=True)
    _AuthenticationFailureReportArg_vlr_Number = OCT_STR(name=u'vlr-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _AuthenticationFailureReportArg_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    AuthenticationFailureReportArg._cont = ASN1Dict([
        (u'imsi', _AuthenticationFailureReportArg_imsi),
        (u'failureCause', _AuthenticationFailureReportArg_failureCause),
        (u'extensionContainer', _AuthenticationFailureReportArg_extensionContainer),
        (u're-attempt', _AuthenticationFailureReportArg_re_attempt),
        (u'accessType', _AuthenticationFailureReportArg_accessType),
        (u'rand', _AuthenticationFailureReportArg_rand),
        (u'vlr-Number', _AuthenticationFailureReportArg_vlr_Number),
        (u'sgsn-Number', _AuthenticationFailureReportArg_sgsn_Number),
        ])
    AuthenticationFailureReportArg._ext = [u're-attempt', u'accessType', u'rand', u'vlr-Number', u'sgsn-Number']
    
    #-----< AccessType >-----#
    AccessType = ENUM(name=u'AccessType', mode=MODE_TYPE)
    AccessType._cont = ASN1Dict([(u'call', 0), (u'emergencyCall', 1), (u'locationUpdating', 2), (u'supplementaryService', 3), (u'shortMessage', 4), (u'gprsAttach', 5), (u'routingAreaUpdating', 6), (u'serviceRequest', 7), (u'pdpContextActivation', 8), (u'pdpContextDeactivation', 9), (u'gprsDetach', 10)])
    AccessType._ext = [u'gprsDetach']
    
    #-----< AuthenticationFailureReportRes >-----#
    AuthenticationFailureReportRes = SEQ(name=u'AuthenticationFailureReportRes', mode=MODE_TYPE)
    _AuthenticationFailureReportRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AuthenticationFailureReportRes._cont = ASN1Dict([
        (u'extensionContainer', _AuthenticationFailureReportRes_extensionContainer),
        ])
    AuthenticationFailureReportRes._ext = []
    
    #-----< FailureCause >-----#
    FailureCause = ENUM(name=u'FailureCause', mode=MODE_TYPE)
    FailureCause._cont = ASN1Dict([(u'wrongUserResponse', 0), (u'wrongNetworkSignature', 1)])
    FailureCause._ext = None
    
    #-----< UpdateGprsLocationArg >-----#
    UpdateGprsLocationArg = SEQ(name=u'UpdateGprsLocationArg', mode=MODE_TYPE)
    _UpdateGprsLocationArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _UpdateGprsLocationArg_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateGprsLocationArg_sgsn_Address = OCT_STR(name=u'sgsn-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    _UpdateGprsLocationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateGprsLocationArg_sgsn_Capability = SEQ(name=u'sgsn-Capability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SGSN-Capability')), opt=True)
    _UpdateGprsLocationArg_informPreviousNetworkEntity = NULL(name=u'informPreviousNetworkEntity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_ps_LCS_NotSupportedByUE = NULL(name=u'ps-LCS-NotSupportedByUE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_v_gmlc_Address = OCT_STR(name=u'v-gmlc-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _UpdateGprsLocationArg_add_info = SEQ(name=u'add-info', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ADD-Info')), opt=True)
    _UpdateGprsLocationArg_eps_info = CHOICE(name=u'eps-info', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-Info')), opt=True)
    _UpdateGprsLocationArg_servingNodeTypeIndicator = NULL(name=u'servingNodeTypeIndicator', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_skipSubscriberDataUpdate = NULL(name=u'skipSubscriberDataUpdate', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_usedRAT_Type = ENUM(name=u'usedRAT-Type', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')), opt=True)
    _UpdateGprsLocationArg_gprsSubscriptionDataNotNeeded = NULL(name=u'gprsSubscriptionDataNotNeeded', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_nodeTypeIndicator = NULL(name=u'nodeTypeIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_areaRestricted = NULL(name=u'areaRestricted', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_ue_reachableIndicator = NULL(name=u'ue-reachableIndicator', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_epsSubscriptionDataNotNeeded = NULL(name=u'epsSubscriptionDataNotNeeded', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_ue_srvcc_Capability = ENUM(name=u'ue-srvcc-Capability', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UE-SRVCC-Capability')), opt=True)
    _UpdateGprsLocationArg_eplmn_List = SEQ_OF(name=u'eplmn-List', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPLMN-List')), opt=True)
    _UpdateGprsLocationArg_mmeNumberforMTSMS = OCT_STR(name=u'mmeNumberforMTSMS', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateGprsLocationArg_smsRegisterRequest = ENUM(name=u'smsRegisterRequest', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMSRegisterRequest')), opt=True)
    _UpdateGprsLocationArg_sms_Only = NULL(name=u'sms-Only', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_removalofMMERegistrationforSMS = NULL(name=u'removalofMMERegistrationforSMS', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_sgsn_Name = OCT_STR(name=u'sgsn-Name', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _UpdateGprsLocationArg_sgsn_Realm = OCT_STR(name=u'sgsn-Realm', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _UpdateGprsLocationArg_lgd_supportIndicator = NULL(name=u'lgd-supportIndicator', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationArg_adjacentPLMN_List = SEQ_OF(name=u'adjacentPLMN-List', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdjacentPLMN-List')), opt=True)
    UpdateGprsLocationArg._cont = ASN1Dict([
        (u'imsi', _UpdateGprsLocationArg_imsi),
        (u'sgsn-Number', _UpdateGprsLocationArg_sgsn_Number),
        (u'sgsn-Address', _UpdateGprsLocationArg_sgsn_Address),
        (u'extensionContainer', _UpdateGprsLocationArg_extensionContainer),
        (u'sgsn-Capability', _UpdateGprsLocationArg_sgsn_Capability),
        (u'informPreviousNetworkEntity', _UpdateGprsLocationArg_informPreviousNetworkEntity),
        (u'ps-LCS-NotSupportedByUE', _UpdateGprsLocationArg_ps_LCS_NotSupportedByUE),
        (u'v-gmlc-Address', _UpdateGprsLocationArg_v_gmlc_Address),
        (u'add-info', _UpdateGprsLocationArg_add_info),
        (u'eps-info', _UpdateGprsLocationArg_eps_info),
        (u'servingNodeTypeIndicator', _UpdateGprsLocationArg_servingNodeTypeIndicator),
        (u'skipSubscriberDataUpdate', _UpdateGprsLocationArg_skipSubscriberDataUpdate),
        (u'usedRAT-Type', _UpdateGprsLocationArg_usedRAT_Type),
        (u'gprsSubscriptionDataNotNeeded', _UpdateGprsLocationArg_gprsSubscriptionDataNotNeeded),
        (u'nodeTypeIndicator', _UpdateGprsLocationArg_nodeTypeIndicator),
        (u'areaRestricted', _UpdateGprsLocationArg_areaRestricted),
        (u'ue-reachableIndicator', _UpdateGprsLocationArg_ue_reachableIndicator),
        (u'epsSubscriptionDataNotNeeded', _UpdateGprsLocationArg_epsSubscriptionDataNotNeeded),
        (u'ue-srvcc-Capability', _UpdateGprsLocationArg_ue_srvcc_Capability),
        (u'eplmn-List', _UpdateGprsLocationArg_eplmn_List),
        (u'mmeNumberforMTSMS', _UpdateGprsLocationArg_mmeNumberforMTSMS),
        (u'smsRegisterRequest', _UpdateGprsLocationArg_smsRegisterRequest),
        (u'sms-Only', _UpdateGprsLocationArg_sms_Only),
        (u'removalofMMERegistrationforSMS', _UpdateGprsLocationArg_removalofMMERegistrationforSMS),
        (u'sgsn-Name', _UpdateGprsLocationArg_sgsn_Name),
        (u'sgsn-Realm', _UpdateGprsLocationArg_sgsn_Realm),
        (u'lgd-supportIndicator', _UpdateGprsLocationArg_lgd_supportIndicator),
        (u'adjacentPLMN-List', _UpdateGprsLocationArg_adjacentPLMN_List),
        ])
    UpdateGprsLocationArg._ext = [u'sgsn-Capability', u'informPreviousNetworkEntity', u'ps-LCS-NotSupportedByUE', u'v-gmlc-Address', u'add-info', u'eps-info', u'servingNodeTypeIndicator', u'skipSubscriberDataUpdate', u'usedRAT-Type', u'gprsSubscriptionDataNotNeeded', u'nodeTypeIndicator', u'areaRestricted', u'ue-reachableIndicator', u'epsSubscriptionDataNotNeeded', u'ue-srvcc-Capability', u'eplmn-List', u'mmeNumberforMTSMS', u'smsRegisterRequest', u'sms-Only', u'removalofMMERegistrationforSMS', u'sgsn-Name', u'sgsn-Realm', u'lgd-supportIndicator', u'adjacentPLMN-List']
    
    #-----< SMSRegisterRequest >-----#
    SMSRegisterRequest = ENUM(name=u'SMSRegisterRequest', mode=MODE_TYPE)
    SMSRegisterRequest._cont = ASN1Dict([(u'sms-registration-required', 0), (u'sms-registration-not-preferred', 1), (u'no-preference', 2)])
    SMSRegisterRequest._ext = []
    
    #-----< Used-RAT-Type >-----#
    Used_RAT_Type = ENUM(name=u'Used-RAT-Type', mode=MODE_TYPE)
    Used_RAT_Type._cont = ASN1Dict([(u'utran', 0), (u'geran', 1), (u'gan', 2), (u'i-hspa-evolution', 3), (u'e-utran', 4), (u'nb-iot', 5)])
    Used_RAT_Type._ext = [u'nb-iot']
    
    #-----< EPS-Info >-----#
    EPS_Info = CHOICE(name=u'EPS-Info', mode=MODE_TYPE)
    _EPS_Info_pdn_gw_update = SEQ(name=u'pdn-gw-update', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Update')))
    _EPS_Info_isr_Information = BIT_STR(name=u'isr-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ISR-Information')))
    EPS_Info._cont = ASN1Dict([
        (u'pdn-gw-update', _EPS_Info_pdn_gw_update),
        (u'isr-Information', _EPS_Info_isr_Information),
        ])
    EPS_Info._ext = None
    
    #-----< PDN-GW-Update >-----#
    PDN_GW_Update = SEQ(name=u'PDN-GW-Update', mode=MODE_TYPE)
    _PDN_GW_Update_apn = OCT_STR(name=u'apn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')), opt=True)
    _PDN_GW_Update_pdn_gw_Identity = SEQ(name=u'pdn-gw-Identity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Identity')), opt=True)
    _PDN_GW_Update_contextId = INT(name=u'contextId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')), opt=True)
    _PDN_GW_Update_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PDN_GW_Update._cont = ASN1Dict([
        (u'apn', _PDN_GW_Update_apn),
        (u'pdn-gw-Identity', _PDN_GW_Update_pdn_gw_Identity),
        (u'contextId', _PDN_GW_Update_contextId),
        (u'extensionContainer', _PDN_GW_Update_extensionContainer),
        ])
    PDN_GW_Update._ext = []
    
    #-----< ISR-Information >-----#
    ISR_Information = BIT_STR(name=u'ISR-Information', mode=MODE_TYPE)
    ISR_Information._cont = ASN1Dict([(u'updateLocation', 0), (u'cancelSGSN', 1), (u'initialAttachIndicator', 2)])
    ISR_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< SGSN-Capability >-----#
    SGSN_Capability = SEQ(name=u'SGSN-Capability', mode=MODE_TYPE)
    _SGSN_Capability_solsaSupportIndicator = NULL(name=u'solsaSupportIndicator', mode=MODE_TYPE, opt=True)
    _SGSN_Capability_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SGSN_Capability_superChargerSupportedInServingNetworkEntity = CHOICE(name=u'superChargerSupportedInServingNetworkEntity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SuperChargerInfo')), opt=True)
    _SGSN_Capability_gprsEnhancementsSupportIndicator = NULL(name=u'gprsEnhancementsSupportIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _SGSN_Capability_supportedLCS_CapabilitySets = BIT_STR(name=u'supportedLCS-CapabilitySets', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedLCS-CapabilitySets')), opt=True)
    _SGSN_Capability_offeredCamel4CSIs = BIT_STR(name=u'offeredCamel4CSIs', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _SGSN_Capability_smsCallBarringSupportIndicator = NULL(name=u'smsCallBarringSupportIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_supportedRAT_TypesIndicator = BIT_STR(name=u'supportedRAT-TypesIndicator', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedRAT-Types')), opt=True)
    _SGSN_Capability_supportedFeatures = BIT_STR(name=u'supportedFeatures', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedFeatures')), opt=True)
    _SGSN_Capability_t_adsDataRetrieval = NULL(name=u't-adsDataRetrieval', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_homogeneousSupportOfIMSVoiceOverPSSessions = BOOL(name=u'homogeneousSupportOfIMSVoiceOverPSSessions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_cancellationTypeInitialAttach = NULL(name=u'cancellationTypeInitialAttach', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_msisdn_lessOperation_Supported = NULL(name=u'msisdn-lessOperation-Supported', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_updateofHomogeneousSupportOfIMSVoiceOverPSSessions = NULL(name=u'updateofHomogeneousSupportOfIMSVoiceOverPSSessions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_reset_ids_Supported = NULL(name=u'reset-ids-Supported', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSN_Capability_ext_SupportedFeatures = BIT_STR(name=u'ext-SupportedFeatures', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SupportedFeatures')), opt=True)
    SGSN_Capability._cont = ASN1Dict([
        (u'solsaSupportIndicator', _SGSN_Capability_solsaSupportIndicator),
        (u'extensionContainer', _SGSN_Capability_extensionContainer),
        (u'superChargerSupportedInServingNetworkEntity', _SGSN_Capability_superChargerSupportedInServingNetworkEntity),
        (u'gprsEnhancementsSupportIndicator', _SGSN_Capability_gprsEnhancementsSupportIndicator),
        (u'supportedCamelPhases', _SGSN_Capability_supportedCamelPhases),
        (u'supportedLCS-CapabilitySets', _SGSN_Capability_supportedLCS_CapabilitySets),
        (u'offeredCamel4CSIs', _SGSN_Capability_offeredCamel4CSIs),
        (u'smsCallBarringSupportIndicator', _SGSN_Capability_smsCallBarringSupportIndicator),
        (u'supportedRAT-TypesIndicator', _SGSN_Capability_supportedRAT_TypesIndicator),
        (u'supportedFeatures', _SGSN_Capability_supportedFeatures),
        (u't-adsDataRetrieval', _SGSN_Capability_t_adsDataRetrieval),
        (u'homogeneousSupportOfIMSVoiceOverPSSessions', _SGSN_Capability_homogeneousSupportOfIMSVoiceOverPSSessions),
        (u'cancellationTypeInitialAttach', _SGSN_Capability_cancellationTypeInitialAttach),
        (u'msisdn-lessOperation-Supported', _SGSN_Capability_msisdn_lessOperation_Supported),
        (u'updateofHomogeneousSupportOfIMSVoiceOverPSSessions', _SGSN_Capability_updateofHomogeneousSupportOfIMSVoiceOverPSSessions),
        (u'reset-ids-Supported', _SGSN_Capability_reset_ids_Supported),
        (u'ext-SupportedFeatures', _SGSN_Capability_ext_SupportedFeatures),
        ])
    SGSN_Capability._ext = [u'superChargerSupportedInServingNetworkEntity', u'gprsEnhancementsSupportIndicator', u'supportedCamelPhases', u'supportedLCS-CapabilitySets', u'offeredCamel4CSIs', u'smsCallBarringSupportIndicator', u'supportedRAT-TypesIndicator', u'supportedFeatures', u't-adsDataRetrieval', u'homogeneousSupportOfIMSVoiceOverPSSessions', u'cancellationTypeInitialAttach', u'msisdn-lessOperation-Supported', u'updateofHomogeneousSupportOfIMSVoiceOverPSSessions', u'reset-ids-Supported', u'ext-SupportedFeatures']
    
    #-----< SupportedFeatures >-----#
    SupportedFeatures = BIT_STR(name=u'SupportedFeatures', mode=MODE_TYPE)
    SupportedFeatures._cont = ASN1Dict([(u'odb-all-apn', 0), (u'odb-HPLMN-APN', 1), (u'odb-VPLMN-APN', 2), (u'odb-all-og', 3), (u'odb-all-international-og', 4), (u'odb-all-int-og-not-to-HPLMN-country', 5), (u'odb-all-interzonal-og', 6), (u'odb-all-interzonal-og-not-to-HPLMN-country', 7), (u'odb-all-interzonal-og-and-internat-og-not-to-HPLMN-country', 8), (u'regSub', 9), (u'trace', 10), (u'lcs-all-PrivExcep', 11), (u'lcs-universal', 12), (u'lcs-CallSessionRelated', 13), (u'lcs-CallSessionUnrelated', 14), (u'lcs-PLMN-operator', 15), (u'lcs-ServiceType', 16), (u'lcs-all-MOLR-SS', 17), (u'lcs-basicSelfLocation', 18), (u'lcs-autonomousSelfLocation', 19), (u'lcs-transferToThirdParty', 20), (u'sm-mo-pp', 21), (u'barring-OutgoingCalls', 22), (u'baoc', 23), (u'boic', 24), (u'boicExHC', 25), (u'localTimeZoneRetrieval', 26), (u'additionalMsisdn', 27), (u'smsInMME', 28), (u'smsInSGSN', 29), (u'ue-Reachability-Notification', 30), (u'state-Location-Information-Retrieval', 31), (u'partialPurge', 32), (u'gddInSGSN', 33), (u'sgsnCAMELCapability', 34), (u'pcscf-Restoration', 35), (u'dedicatedCoreNetworks', 36), (u'non-IP-PDN-Type-APNs', 37), (u'non-IP-PDP-Type-APNs', 38), (u'nrAsSecondaryRAT', 39)])
    SupportedFeatures._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=26, ub=40)], ev=None, er=[])
    
    #-----< Ext-SupportedFeatures >-----#
    Ext_SupportedFeatures = BIT_STR(name=u'Ext-SupportedFeatures', mode=MODE_TYPE)
    Ext_SupportedFeatures._cont = ASN1Dict([(u'unlicensedSpectrumAsSecondaryRAT', 0)])
    Ext_SupportedFeatures._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    
    #-----< UE-SRVCC-Capability >-----#
    UE_SRVCC_Capability = ENUM(name=u'UE-SRVCC-Capability', mode=MODE_TYPE)
    UE_SRVCC_Capability._cont = ASN1Dict([(u'ue-srvcc-not-supported', 0), (u'ue-srvcc-supported', 1)])
    UE_SRVCC_Capability._ext = []
    
    #-----< UpdateGprsLocationRes >-----#
    UpdateGprsLocationRes = SEQ(name=u'UpdateGprsLocationRes', mode=MODE_TYPE)
    _UpdateGprsLocationRes_hlr_Number = OCT_STR(name=u'hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _UpdateGprsLocationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UpdateGprsLocationRes_add_Capability = NULL(name=u'add-Capability', mode=MODE_TYPE, opt=True)
    _UpdateGprsLocationRes_sgsn_mmeSeparationSupported = NULL(name=u'sgsn-mmeSeparationSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UpdateGprsLocationRes_mmeRegisteredforSMS = NULL(name=u'mmeRegisteredforSMS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    UpdateGprsLocationRes._cont = ASN1Dict([
        (u'hlr-Number', _UpdateGprsLocationRes_hlr_Number),
        (u'extensionContainer', _UpdateGprsLocationRes_extensionContainer),
        (u'add-Capability', _UpdateGprsLocationRes_add_Capability),
        (u'sgsn-mmeSeparationSupported', _UpdateGprsLocationRes_sgsn_mmeSeparationSupported),
        (u'mmeRegisteredforSMS', _UpdateGprsLocationRes_mmeRegisteredforSMS),
        ])
    UpdateGprsLocationRes._ext = [u'add-Capability', u'sgsn-mmeSeparationSupported', u'mmeRegisteredforSMS']
    
    #-----< EPLMN-List >-----#
    EPLMN_List = SEQ_OF(name=u'EPLMN-List', mode=MODE_TYPE)
    _EPLMN_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    EPLMN_List._cont = _EPLMN_List__item_
    EPLMN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< AdjacentPLMN-List >-----#
    AdjacentPLMN_List = SEQ_OF(name=u'AdjacentPLMN-List', mode=MODE_TYPE)
    _AdjacentPLMN_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    AdjacentPLMN_List._cont = _AdjacentPLMN_List__item_
    AdjacentPLMN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< ForwardAccessSignalling-Arg >-----#
    ForwardAccessSignalling_Arg = SEQ(name=u'ForwardAccessSignalling-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ForwardAccessSignalling_Arg_an_APDU = SEQ(name=u'an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _ForwardAccessSignalling_Arg_integrityProtectionInfo = OCT_STR(name=u'integrityProtectionInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IntegrityProtectionInformation')), opt=True)
    _ForwardAccessSignalling_Arg_encryptionInfo = OCT_STR(name=u'encryptionInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EncryptionInformation')), opt=True)
    _ForwardAccessSignalling_Arg_keyStatus = ENUM(name=u'keyStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'KeyStatus')), opt=True)
    _ForwardAccessSignalling_Arg_allowedGSM_Algorithms = OCT_STR(name=u'allowedGSM-Algorithms', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedGSM-Algorithms')), opt=True)
    _ForwardAccessSignalling_Arg_allowedUMTS_Algorithms = SEQ(name=u'allowedUMTS-Algorithms', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedUMTS-Algorithms')), opt=True)
    _ForwardAccessSignalling_Arg_radioResourceInformation = OCT_STR(name=u'radioResourceInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _ForwardAccessSignalling_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ForwardAccessSignalling_Arg_radioResourceList = SEQ_OF(name=u'radioResourceList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceList')), opt=True)
    _ForwardAccessSignalling_Arg_bssmap_ServiceHandover = OCT_STR(name=u'bssmap-ServiceHandover', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandover')), opt=True)
    _ForwardAccessSignalling_Arg_ranap_ServiceHandover = OCT_STR(name=u'ranap-ServiceHandover', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RANAP-ServiceHandover')), opt=True)
    _ForwardAccessSignalling_Arg_bssmap_ServiceHandoverList = SEQ_OF(name=u'bssmap-ServiceHandoverList', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandoverList')), opt=True)
    _ForwardAccessSignalling_Arg_currentlyUsedCodec = OCT_STR(name=u'currentlyUsedCodec', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _ForwardAccessSignalling_Arg_iuSupportedCodecsList = SEQ(name=u'iuSupportedCodecsList', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCodecsList')), opt=True)
    _ForwardAccessSignalling_Arg_rab_ConfigurationIndicator = NULL(name=u'rab-ConfigurationIndicator', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardAccessSignalling_Arg_iuSelectedCodec = OCT_STR(name=u'iuSelectedCodec', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _ForwardAccessSignalling_Arg_alternativeChannelType = OCT_STR(name=u'alternativeChannelType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _ForwardAccessSignalling_Arg_tracePropagationList = SEQ(name=u'tracePropagationList', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TracePropagationList')), opt=True)
    _ForwardAccessSignalling_Arg_aoipSupportedCodecsListAnchor = SEQ(name=u'aoipSupportedCodecsListAnchor', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    _ForwardAccessSignalling_Arg_aoipSelectedCodecTarget = OCT_STR(name=u'aoipSelectedCodecTarget', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _ForwardAccessSignalling_Arg_uesbi_Iu = SEQ(name=u'uesbi-Iu', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-Iu')), opt=True)
    _ForwardAccessSignalling_Arg_imeisv = OCT_STR(name=u'imeisv', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    ForwardAccessSignalling_Arg._cont = ASN1Dict([
        (u'an-APDU', _ForwardAccessSignalling_Arg_an_APDU),
        (u'integrityProtectionInfo', _ForwardAccessSignalling_Arg_integrityProtectionInfo),
        (u'encryptionInfo', _ForwardAccessSignalling_Arg_encryptionInfo),
        (u'keyStatus', _ForwardAccessSignalling_Arg_keyStatus),
        (u'allowedGSM-Algorithms', _ForwardAccessSignalling_Arg_allowedGSM_Algorithms),
        (u'allowedUMTS-Algorithms', _ForwardAccessSignalling_Arg_allowedUMTS_Algorithms),
        (u'radioResourceInformation', _ForwardAccessSignalling_Arg_radioResourceInformation),
        (u'extensionContainer', _ForwardAccessSignalling_Arg_extensionContainer),
        (u'radioResourceList', _ForwardAccessSignalling_Arg_radioResourceList),
        (u'bssmap-ServiceHandover', _ForwardAccessSignalling_Arg_bssmap_ServiceHandover),
        (u'ranap-ServiceHandover', _ForwardAccessSignalling_Arg_ranap_ServiceHandover),
        (u'bssmap-ServiceHandoverList', _ForwardAccessSignalling_Arg_bssmap_ServiceHandoverList),
        (u'currentlyUsedCodec', _ForwardAccessSignalling_Arg_currentlyUsedCodec),
        (u'iuSupportedCodecsList', _ForwardAccessSignalling_Arg_iuSupportedCodecsList),
        (u'rab-ConfigurationIndicator', _ForwardAccessSignalling_Arg_rab_ConfigurationIndicator),
        (u'iuSelectedCodec', _ForwardAccessSignalling_Arg_iuSelectedCodec),
        (u'alternativeChannelType', _ForwardAccessSignalling_Arg_alternativeChannelType),
        (u'tracePropagationList', _ForwardAccessSignalling_Arg_tracePropagationList),
        (u'aoipSupportedCodecsListAnchor', _ForwardAccessSignalling_Arg_aoipSupportedCodecsListAnchor),
        (u'aoipSelectedCodecTarget', _ForwardAccessSignalling_Arg_aoipSelectedCodecTarget),
        (u'uesbi-Iu', _ForwardAccessSignalling_Arg_uesbi_Iu),
        (u'imeisv', _ForwardAccessSignalling_Arg_imeisv),
        ])
    ForwardAccessSignalling_Arg._ext = [u'radioResourceList', u'bssmap-ServiceHandover', u'ranap-ServiceHandover', u'bssmap-ServiceHandoverList', u'currentlyUsedCodec', u'iuSupportedCodecsList', u'rab-ConfigurationIndicator', u'iuSelectedCodec', u'alternativeChannelType', u'tracePropagationList', u'aoipSupportedCodecsListAnchor', u'aoipSelectedCodecTarget', u'uesbi-Iu', u'imeisv']
    
    #-----< AllowedGSM-Algorithms >-----#
    AllowedGSM_Algorithms = OCT_STR(name=u'AllowedGSM-Algorithms', mode=MODE_TYPE)
    AllowedGSM_Algorithms._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< AllowedUMTS-Algorithms >-----#
    AllowedUMTS_Algorithms = SEQ(name=u'AllowedUMTS-Algorithms', mode=MODE_TYPE)
    _AllowedUMTS_Algorithms_integrityProtectionAlgorithms = OCT_STR(name=u'integrityProtectionAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PermittedIntegrityProtectionAlgorithms')), opt=True)
    _AllowedUMTS_Algorithms_encryptionAlgorithms = OCT_STR(name=u'encryptionAlgorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PermittedEncryptionAlgorithms')), opt=True)
    _AllowedUMTS_Algorithms_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AllowedUMTS_Algorithms._cont = ASN1Dict([
        (u'integrityProtectionAlgorithms', _AllowedUMTS_Algorithms_integrityProtectionAlgorithms),
        (u'encryptionAlgorithms', _AllowedUMTS_Algorithms_encryptionAlgorithms),
        (u'extensionContainer', _AllowedUMTS_Algorithms_extensionContainer),
        ])
    AllowedUMTS_Algorithms._ext = []
    
    #-----< PermittedIntegrityProtectionAlgorithms >-----#
    PermittedIntegrityProtectionAlgorithms = OCT_STR(name=u'PermittedIntegrityProtectionAlgorithms', mode=MODE_TYPE)
    PermittedIntegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< maxPermittedIntegrityProtectionAlgorithmsLength >-----#
    maxPermittedIntegrityProtectionAlgorithmsLength = INT(name=u'maxPermittedIntegrityProtectionAlgorithmsLength', mode=MODE_VALUE)
    maxPermittedIntegrityProtectionAlgorithmsLength._val = 9
    
    #-----< PermittedEncryptionAlgorithms >-----#
    PermittedEncryptionAlgorithms = OCT_STR(name=u'PermittedEncryptionAlgorithms', mode=MODE_TYPE)
    PermittedEncryptionAlgorithms._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< maxPermittedEncryptionAlgorithmsLength >-----#
    maxPermittedEncryptionAlgorithmsLength = INT(name=u'maxPermittedEncryptionAlgorithmsLength', mode=MODE_VALUE)
    maxPermittedEncryptionAlgorithmsLength._val = 9
    
    #-----< KeyStatus >-----#
    KeyStatus = ENUM(name=u'KeyStatus', mode=MODE_TYPE)
    KeyStatus._cont = ASN1Dict([(u'old', 0), (u'new', 1)])
    KeyStatus._ext = []
    
    #-----< PrepareHO-Arg >-----#
    PrepareHO_Arg = SEQ(name=u'PrepareHO-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareHO_Arg_targetCellId = OCT_STR(name=u'targetCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GlobalCellId')), opt=True)
    _PrepareHO_Arg_ho_NumberNotRequired = NULL(name=u'ho-NumberNotRequired', mode=MODE_TYPE, opt=True)
    _PrepareHO_Arg_targetRNCId = OCT_STR(name=u'targetRNCId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RNCId')), opt=True)
    _PrepareHO_Arg_an_APDU = SEQ(name=u'an-APDU', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')), opt=True)
    _PrepareHO_Arg_multipleBearerRequested = NULL(name=u'multipleBearerRequested', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PrepareHO_Arg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _PrepareHO_Arg_integrityProtectionInfo = OCT_STR(name=u'integrityProtectionInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IntegrityProtectionInformation')), opt=True)
    _PrepareHO_Arg_encryptionInfo = OCT_STR(name=u'encryptionInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EncryptionInformation')), opt=True)
    _PrepareHO_Arg_radioResourceInformation = OCT_STR(name=u'radioResourceInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _PrepareHO_Arg_allowedGSM_Algorithms = OCT_STR(name=u'allowedGSM-Algorithms', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedGSM-Algorithms')), opt=True)
    _PrepareHO_Arg_allowedUMTS_Algorithms = SEQ(name=u'allowedUMTS-Algorithms', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AllowedUMTS-Algorithms')), opt=True)
    _PrepareHO_Arg_radioResourceList = SEQ_OF(name=u'radioResourceList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceList')), opt=True)
    _PrepareHO_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PrepareHO_Arg_rab_Id = INT(name=u'rab-Id', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')), opt=True)
    _PrepareHO_Arg_bssmap_ServiceHandover = OCT_STR(name=u'bssmap-ServiceHandover', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandover')), opt=True)
    _PrepareHO_Arg_ranap_ServiceHandover = OCT_STR(name=u'ranap-ServiceHandover', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RANAP-ServiceHandover')), opt=True)
    _PrepareHO_Arg_bssmap_ServiceHandoverList = SEQ_OF(name=u'bssmap-ServiceHandoverList', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandoverList')), opt=True)
    _PrepareHO_Arg_asciCallReference = OCT_STR(name=u'asciCallReference', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ASCI-CallReference')), opt=True)
    _PrepareHO_Arg_geran_classmark = OCT_STR(name=u'geran-classmark', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GERAN-Classmark')), opt=True)
    _PrepareHO_Arg_iuCurrentlyUsedCodec = OCT_STR(name=u'iuCurrentlyUsedCodec', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _PrepareHO_Arg_iuSupportedCodecsList = SEQ(name=u'iuSupportedCodecsList', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCodecsList')), opt=True)
    _PrepareHO_Arg_rab_ConfigurationIndicator = NULL(name=u'rab-ConfigurationIndicator', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PrepareHO_Arg_uesbi_Iu = SEQ(name=u'uesbi-Iu', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-Iu')), opt=True)
    _PrepareHO_Arg_imeisv = OCT_STR(name=u'imeisv', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _PrepareHO_Arg_alternativeChannelType = OCT_STR(name=u'alternativeChannelType', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')), opt=True)
    _PrepareHO_Arg_tracePropagationList = SEQ(name=u'tracePropagationList', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TracePropagationList')), opt=True)
    _PrepareHO_Arg_aoipSupportedCodecsListAnchor = SEQ(name=u'aoipSupportedCodecsListAnchor', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    _PrepareHO_Arg_regionalSubscriptionData = SEQ_OF(name=u'regionalSubscriptionData', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCodeList')), opt=True)
    _PrepareHO_Arg_lclsGlobalCallReference = OCT_STR(name=u'lclsGlobalCallReference', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCLS-GlobalCallReference')), opt=True)
    _PrepareHO_Arg_lcls_Negotiation = BIT_STR(name=u'lcls-Negotiation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCLS-Negotiation')), opt=True)
    _PrepareHO_Arg_lcls_Configuration_Preference = BIT_STR(name=u'lcls-Configuration-Preference', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCLS-ConfigurationPreference')), opt=True)
    _PrepareHO_Arg_csg_SubscriptionDataList = SEQ_OF(name=u'csg-SubscriptionDataList', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    PrepareHO_Arg._cont = ASN1Dict([
        (u'targetCellId', _PrepareHO_Arg_targetCellId),
        (u'ho-NumberNotRequired', _PrepareHO_Arg_ho_NumberNotRequired),
        (u'targetRNCId', _PrepareHO_Arg_targetRNCId),
        (u'an-APDU', _PrepareHO_Arg_an_APDU),
        (u'multipleBearerRequested', _PrepareHO_Arg_multipleBearerRequested),
        (u'imsi', _PrepareHO_Arg_imsi),
        (u'integrityProtectionInfo', _PrepareHO_Arg_integrityProtectionInfo),
        (u'encryptionInfo', _PrepareHO_Arg_encryptionInfo),
        (u'radioResourceInformation', _PrepareHO_Arg_radioResourceInformation),
        (u'allowedGSM-Algorithms', _PrepareHO_Arg_allowedGSM_Algorithms),
        (u'allowedUMTS-Algorithms', _PrepareHO_Arg_allowedUMTS_Algorithms),
        (u'radioResourceList', _PrepareHO_Arg_radioResourceList),
        (u'extensionContainer', _PrepareHO_Arg_extensionContainer),
        (u'rab-Id', _PrepareHO_Arg_rab_Id),
        (u'bssmap-ServiceHandover', _PrepareHO_Arg_bssmap_ServiceHandover),
        (u'ranap-ServiceHandover', _PrepareHO_Arg_ranap_ServiceHandover),
        (u'bssmap-ServiceHandoverList', _PrepareHO_Arg_bssmap_ServiceHandoverList),
        (u'asciCallReference', _PrepareHO_Arg_asciCallReference),
        (u'geran-classmark', _PrepareHO_Arg_geran_classmark),
        (u'iuCurrentlyUsedCodec', _PrepareHO_Arg_iuCurrentlyUsedCodec),
        (u'iuSupportedCodecsList', _PrepareHO_Arg_iuSupportedCodecsList),
        (u'rab-ConfigurationIndicator', _PrepareHO_Arg_rab_ConfigurationIndicator),
        (u'uesbi-Iu', _PrepareHO_Arg_uesbi_Iu),
        (u'imeisv', _PrepareHO_Arg_imeisv),
        (u'alternativeChannelType', _PrepareHO_Arg_alternativeChannelType),
        (u'tracePropagationList', _PrepareHO_Arg_tracePropagationList),
        (u'aoipSupportedCodecsListAnchor', _PrepareHO_Arg_aoipSupportedCodecsListAnchor),
        (u'regionalSubscriptionData', _PrepareHO_Arg_regionalSubscriptionData),
        (u'lclsGlobalCallReference', _PrepareHO_Arg_lclsGlobalCallReference),
        (u'lcls-Negotiation', _PrepareHO_Arg_lcls_Negotiation),
        (u'lcls-Configuration-Preference', _PrepareHO_Arg_lcls_Configuration_Preference),
        (u'csg-SubscriptionDataList', _PrepareHO_Arg_csg_SubscriptionDataList),
        ])
    PrepareHO_Arg._ext = [u'rab-Id', u'bssmap-ServiceHandover', u'ranap-ServiceHandover', u'bssmap-ServiceHandoverList', u'asciCallReference', u'geran-classmark', u'iuCurrentlyUsedCodec', u'iuSupportedCodecsList', u'rab-ConfigurationIndicator', u'uesbi-Iu', u'imeisv', u'alternativeChannelType', u'tracePropagationList', u'aoipSupportedCodecsListAnchor', u'regionalSubscriptionData', u'lclsGlobalCallReference', u'lcls-Negotiation', u'lcls-Configuration-Preference', u'csg-SubscriptionDataList']
    
    #-----< LCLS-GlobalCallReference >-----#
    LCLS_GlobalCallReference = OCT_STR(name=u'LCLS-GlobalCallReference', mode=MODE_TYPE)
    LCLS_GlobalCallReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=13, ub=15)], ev=None, er=[])
    
    #-----< LCLS-Negotiation >-----#
    LCLS_Negotiation = BIT_STR(name=u'LCLS-Negotiation', mode=MODE_TYPE)
    LCLS_Negotiation._cont = ASN1Dict([(u'permission-indicator-not-allowed-bit', 0), (u'permission-indicator-spare-bit', 1)])
    LCLS_Negotiation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< LCLS-ConfigurationPreference >-----#
    LCLS_ConfigurationPreference = BIT_STR(name=u'LCLS-ConfigurationPreference', mode=MODE_TYPE)
    LCLS_ConfigurationPreference._cont = ASN1Dict([(u'forward-data-sending-indicator', 0), (u'backward-data-sending-indicator', 1), (u'forward-data-reception-indicator', 2), (u'backward-data-reception-indicator', 3)])
    LCLS_ConfigurationPreference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=8)], ev=None, er=[])
    
    #-----< BSSMAP-ServiceHandoverList >-----#
    BSSMAP_ServiceHandoverList = SEQ_OF(name=u'BSSMAP-ServiceHandoverList', mode=MODE_TYPE)
    _BSSMAP_ServiceHandoverList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandoverInfo')))
    BSSMAP_ServiceHandoverList._cont = _BSSMAP_ServiceHandoverList__item_
    BSSMAP_ServiceHandoverList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< BSSMAP-ServiceHandoverInfo >-----#
    BSSMAP_ServiceHandoverInfo = SEQ(name=u'BSSMAP-ServiceHandoverInfo', mode=MODE_TYPE)
    _BSSMAP_ServiceHandoverInfo_bssmap_ServiceHandover = OCT_STR(name=u'bssmap-ServiceHandover', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'BSSMAP-ServiceHandover')))
    _BSSMAP_ServiceHandoverInfo_rab_Id = INT(name=u'rab-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')))
    BSSMAP_ServiceHandoverInfo._cont = ASN1Dict([
        (u'bssmap-ServiceHandover', _BSSMAP_ServiceHandoverInfo_bssmap_ServiceHandover),
        (u'rab-Id', _BSSMAP_ServiceHandoverInfo_rab_Id),
        ])
    BSSMAP_ServiceHandoverInfo._ext = []
    
    #-----< maxNumOfServiceHandovers >-----#
    maxNumOfServiceHandovers = INT(name=u'maxNumOfServiceHandovers', mode=MODE_VALUE)
    maxNumOfServiceHandovers._val = 7
    
    #-----< BSSMAP-ServiceHandover >-----#
    BSSMAP_ServiceHandover = OCT_STR(name=u'BSSMAP-ServiceHandover', mode=MODE_TYPE)
    BSSMAP_ServiceHandover._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< RANAP-ServiceHandover >-----#
    RANAP_ServiceHandover = OCT_STR(name=u'RANAP-ServiceHandover', mode=MODE_TYPE)
    RANAP_ServiceHandover._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< RadioResourceList >-----#
    RadioResourceList = SEQ_OF(name=u'RadioResourceList', mode=MODE_TYPE)
    _RadioResourceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResource')))
    RadioResourceList._cont = _RadioResourceList__item_
    RadioResourceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< RadioResource >-----#
    RadioResource = SEQ(name=u'RadioResource', mode=MODE_TYPE)
    _RadioResource_radioResourceInformation = OCT_STR(name=u'radioResourceInformation', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RadioResourceInformation')))
    _RadioResource_rab_Id = INT(name=u'rab-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')))
    RadioResource._cont = ASN1Dict([
        (u'radioResourceInformation', _RadioResource_radioResourceInformation),
        (u'rab-Id', _RadioResource_rab_Id),
        ])
    RadioResource._ext = []
    
    #-----< maxNumOfRadioResources >-----#
    maxNumOfRadioResources = INT(name=u'maxNumOfRadioResources', mode=MODE_VALUE)
    maxNumOfRadioResources._val = 7
    
    #-----< PrepareHO-Res >-----#
    PrepareHO_Res = SEQ(name=u'PrepareHO-Res', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareHO_Res_handoverNumber = OCT_STR(name=u'handoverNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _PrepareHO_Res_relocationNumberList = SEQ_OF(name=u'relocationNumberList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RelocationNumberList')), opt=True)
    _PrepareHO_Res_an_APDU = SEQ(name=u'an-APDU', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')), opt=True)
    _PrepareHO_Res_multicallBearerInfo = INT(name=u'multicallBearerInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MulticallBearerInfo')), opt=True)
    _PrepareHO_Res_multipleBearerNotSupported = NULL(name=u'multipleBearerNotSupported', mode=MODE_TYPE, opt=True)
    _PrepareHO_Res_selectedUMTS_Algorithms = SEQ(name=u'selectedUMTS-Algorithms', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SelectedUMTS-Algorithms')), opt=True)
    _PrepareHO_Res_chosenRadioResourceInformation = SEQ(name=u'chosenRadioResourceInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenRadioResourceInformation')), opt=True)
    _PrepareHO_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PrepareHO_Res_iuSelectedCodec = OCT_STR(name=u'iuSelectedCodec', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _PrepareHO_Res_iuAvailableCodecsList = SEQ(name=u'iuAvailableCodecsList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _PrepareHO_Res_aoipSelectedCodecTarget = OCT_STR(name=u'aoipSelectedCodecTarget', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _PrepareHO_Res_aoipAvailableCodecsListMap = SEQ(name=u'aoipAvailableCodecsListMap', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    PrepareHO_Res._cont = ASN1Dict([
        (u'handoverNumber', _PrepareHO_Res_handoverNumber),
        (u'relocationNumberList', _PrepareHO_Res_relocationNumberList),
        (u'an-APDU', _PrepareHO_Res_an_APDU),
        (u'multicallBearerInfo', _PrepareHO_Res_multicallBearerInfo),
        (u'multipleBearerNotSupported', _PrepareHO_Res_multipleBearerNotSupported),
        (u'selectedUMTS-Algorithms', _PrepareHO_Res_selectedUMTS_Algorithms),
        (u'chosenRadioResourceInformation', _PrepareHO_Res_chosenRadioResourceInformation),
        (u'extensionContainer', _PrepareHO_Res_extensionContainer),
        (u'iuSelectedCodec', _PrepareHO_Res_iuSelectedCodec),
        (u'iuAvailableCodecsList', _PrepareHO_Res_iuAvailableCodecsList),
        (u'aoipSelectedCodecTarget', _PrepareHO_Res_aoipSelectedCodecTarget),
        (u'aoipAvailableCodecsListMap', _PrepareHO_Res_aoipAvailableCodecsListMap),
        ])
    PrepareHO_Res._ext = [u'iuSelectedCodec', u'iuAvailableCodecsList', u'aoipSelectedCodecTarget', u'aoipAvailableCodecsListMap']
    
    #-----< SelectedUMTS-Algorithms >-----#
    SelectedUMTS_Algorithms = SEQ(name=u'SelectedUMTS-Algorithms', mode=MODE_TYPE)
    _SelectedUMTS_Algorithms_integrityProtectionAlgorithm = OCT_STR(name=u'integrityProtectionAlgorithm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenIntegrityProtectionAlgorithm')), opt=True)
    _SelectedUMTS_Algorithms_encryptionAlgorithm = OCT_STR(name=u'encryptionAlgorithm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenEncryptionAlgorithm')), opt=True)
    _SelectedUMTS_Algorithms_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SelectedUMTS_Algorithms._cont = ASN1Dict([
        (u'integrityProtectionAlgorithm', _SelectedUMTS_Algorithms_integrityProtectionAlgorithm),
        (u'encryptionAlgorithm', _SelectedUMTS_Algorithms_encryptionAlgorithm),
        (u'extensionContainer', _SelectedUMTS_Algorithms_extensionContainer),
        ])
    SelectedUMTS_Algorithms._ext = []
    
    #-----< ChosenIntegrityProtectionAlgorithm >-----#
    ChosenIntegrityProtectionAlgorithm = OCT_STR(name=u'ChosenIntegrityProtectionAlgorithm', mode=MODE_TYPE)
    ChosenIntegrityProtectionAlgorithm._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChosenEncryptionAlgorithm >-----#
    ChosenEncryptionAlgorithm = OCT_STR(name=u'ChosenEncryptionAlgorithm', mode=MODE_TYPE)
    ChosenEncryptionAlgorithm._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChosenRadioResourceInformation >-----#
    ChosenRadioResourceInformation = SEQ(name=u'ChosenRadioResourceInformation', mode=MODE_TYPE)
    _ChosenRadioResourceInformation_chosenChannelInfo = OCT_STR(name=u'chosenChannelInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenChannelInfo')), opt=True)
    _ChosenRadioResourceInformation_chosenSpeechVersion = OCT_STR(name=u'chosenSpeechVersion', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenSpeechVersion')), opt=True)
    ChosenRadioResourceInformation._cont = ASN1Dict([
        (u'chosenChannelInfo', _ChosenRadioResourceInformation_chosenChannelInfo),
        (u'chosenSpeechVersion', _ChosenRadioResourceInformation_chosenSpeechVersion),
        ])
    ChosenRadioResourceInformation._ext = []
    
    #-----< ChosenChannelInfo >-----#
    ChosenChannelInfo = OCT_STR(name=u'ChosenChannelInfo', mode=MODE_TYPE)
    ChosenChannelInfo._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChosenSpeechVersion >-----#
    ChosenSpeechVersion = OCT_STR(name=u'ChosenSpeechVersion', mode=MODE_TYPE)
    ChosenSpeechVersion._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< PrepareSubsequentHO-Arg >-----#
    PrepareSubsequentHO_Arg = SEQ(name=u'PrepareSubsequentHO-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareSubsequentHO_Arg_targetCellId = OCT_STR(name=u'targetCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GlobalCellId')), opt=True)
    _PrepareSubsequentHO_Arg_targetMSC_Number = OCT_STR(name=u'targetMSC-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _PrepareSubsequentHO_Arg_targetRNCId = OCT_STR(name=u'targetRNCId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RNCId')), opt=True)
    _PrepareSubsequentHO_Arg_an_APDU = SEQ(name=u'an-APDU', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')), opt=True)
    _PrepareSubsequentHO_Arg_selectedRab_Id = INT(name=u'selectedRab-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')), opt=True)
    _PrepareSubsequentHO_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PrepareSubsequentHO_Arg_geran_classmark = OCT_STR(name=u'geran-classmark', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GERAN-Classmark')), opt=True)
    _PrepareSubsequentHO_Arg_rab_ConfigurationIndicator = NULL(name=u'rab-ConfigurationIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PrepareSubsequentHO_Arg._cont = ASN1Dict([
        (u'targetCellId', _PrepareSubsequentHO_Arg_targetCellId),
        (u'targetMSC-Number', _PrepareSubsequentHO_Arg_targetMSC_Number),
        (u'targetRNCId', _PrepareSubsequentHO_Arg_targetRNCId),
        (u'an-APDU', _PrepareSubsequentHO_Arg_an_APDU),
        (u'selectedRab-Id', _PrepareSubsequentHO_Arg_selectedRab_Id),
        (u'extensionContainer', _PrepareSubsequentHO_Arg_extensionContainer),
        (u'geran-classmark', _PrepareSubsequentHO_Arg_geran_classmark),
        (u'rab-ConfigurationIndicator', _PrepareSubsequentHO_Arg_rab_ConfigurationIndicator),
        ])
    PrepareSubsequentHO_Arg._ext = [u'geran-classmark', u'rab-ConfigurationIndicator']
    
    #-----< PrepareSubsequentHO-Res >-----#
    PrepareSubsequentHO_Res = SEQ(name=u'PrepareSubsequentHO-Res', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrepareSubsequentHO_Res_an_APDU = SEQ(name=u'an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _PrepareSubsequentHO_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PrepareSubsequentHO_Res._cont = ASN1Dict([
        (u'an-APDU', _PrepareSubsequentHO_Res_an_APDU),
        (u'extensionContainer', _PrepareSubsequentHO_Res_extensionContainer),
        ])
    PrepareSubsequentHO_Res._ext = []
    
    #-----< ProcessAccessSignalling-Arg >-----#
    ProcessAccessSignalling_Arg = SEQ(name=u'ProcessAccessSignalling-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ProcessAccessSignalling_Arg_an_APDU = SEQ(name=u'an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _ProcessAccessSignalling_Arg_selectedUMTS_Algorithms = SEQ(name=u'selectedUMTS-Algorithms', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SelectedUMTS-Algorithms')), opt=True)
    _ProcessAccessSignalling_Arg_selectedGSM_Algorithm = OCT_STR(name=u'selectedGSM-Algorithm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SelectedGSM-Algorithm')), opt=True)
    _ProcessAccessSignalling_Arg_chosenRadioResourceInformation = SEQ(name=u'chosenRadioResourceInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChosenRadioResourceInformation')), opt=True)
    _ProcessAccessSignalling_Arg_selectedRab_Id = INT(name=u'selectedRab-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')), opt=True)
    _ProcessAccessSignalling_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProcessAccessSignalling_Arg_iUSelectedCodec = OCT_STR(name=u'iUSelectedCodec', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _ProcessAccessSignalling_Arg_iuAvailableCodecsList = SEQ(name=u'iuAvailableCodecsList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _ProcessAccessSignalling_Arg_aoipSelectedCodecTarget = OCT_STR(name=u'aoipSelectedCodecTarget', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _ProcessAccessSignalling_Arg_aoipAvailableCodecsListMap = SEQ(name=u'aoipAvailableCodecsListMap', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodecsList')), opt=True)
    ProcessAccessSignalling_Arg._cont = ASN1Dict([
        (u'an-APDU', _ProcessAccessSignalling_Arg_an_APDU),
        (u'selectedUMTS-Algorithms', _ProcessAccessSignalling_Arg_selectedUMTS_Algorithms),
        (u'selectedGSM-Algorithm', _ProcessAccessSignalling_Arg_selectedGSM_Algorithm),
        (u'chosenRadioResourceInformation', _ProcessAccessSignalling_Arg_chosenRadioResourceInformation),
        (u'selectedRab-Id', _ProcessAccessSignalling_Arg_selectedRab_Id),
        (u'extensionContainer', _ProcessAccessSignalling_Arg_extensionContainer),
        (u'iUSelectedCodec', _ProcessAccessSignalling_Arg_iUSelectedCodec),
        (u'iuAvailableCodecsList', _ProcessAccessSignalling_Arg_iuAvailableCodecsList),
        (u'aoipSelectedCodecTarget', _ProcessAccessSignalling_Arg_aoipSelectedCodecTarget),
        (u'aoipAvailableCodecsListMap', _ProcessAccessSignalling_Arg_aoipAvailableCodecsListMap),
        ])
    ProcessAccessSignalling_Arg._ext = [u'iUSelectedCodec', u'iuAvailableCodecsList', u'aoipSelectedCodecTarget', u'aoipAvailableCodecsListMap']
    
    #-----< AoIPCodecsList >-----#
    AoIPCodecsList = SEQ(name=u'AoIPCodecsList', mode=MODE_TYPE)
    _AoIPCodecsList_codec1 = OCT_STR(name=u'codec1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')))
    _AoIPCodecsList_codec2 = OCT_STR(name=u'codec2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec3 = OCT_STR(name=u'codec3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec4 = OCT_STR(name=u'codec4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec5 = OCT_STR(name=u'codec5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec6 = OCT_STR(name=u'codec6', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec7 = OCT_STR(name=u'codec7', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_codec8 = OCT_STR(name=u'codec8', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AoIPCodec')), opt=True)
    _AoIPCodecsList_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AoIPCodecsList._cont = ASN1Dict([
        (u'codec1', _AoIPCodecsList_codec1),
        (u'codec2', _AoIPCodecsList_codec2),
        (u'codec3', _AoIPCodecsList_codec3),
        (u'codec4', _AoIPCodecsList_codec4),
        (u'codec5', _AoIPCodecsList_codec5),
        (u'codec6', _AoIPCodecsList_codec6),
        (u'codec7', _AoIPCodecsList_codec7),
        (u'codec8', _AoIPCodecsList_codec8),
        (u'extensionContainer', _AoIPCodecsList_extensionContainer),
        ])
    AoIPCodecsList._ext = []
    
    #-----< AoIPCodec >-----#
    AoIPCodec = OCT_STR(name=u'AoIPCodec', mode=MODE_TYPE)
    AoIPCodec._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< SupportedCodecsList >-----#
    SupportedCodecsList = SEQ(name=u'SupportedCodecsList', mode=MODE_TYPE)
    _SupportedCodecsList_utranCodecList = SEQ(name=u'utranCodecList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _SupportedCodecsList_geranCodecList = SEQ(name=u'geranCodecList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CodecList')), opt=True)
    _SupportedCodecsList_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SupportedCodecsList._cont = ASN1Dict([
        (u'utranCodecList', _SupportedCodecsList_utranCodecList),
        (u'geranCodecList', _SupportedCodecsList_geranCodecList),
        (u'extensionContainer', _SupportedCodecsList_extensionContainer),
        ])
    SupportedCodecsList._ext = []
    
    #-----< CodecList >-----#
    CodecList = SEQ(name=u'CodecList', mode=MODE_TYPE)
    _CodecList_codec1 = OCT_STR(name=u'codec1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')))
    _CodecList_codec2 = OCT_STR(name=u'codec2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec3 = OCT_STR(name=u'codec3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec4 = OCT_STR(name=u'codec4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec5 = OCT_STR(name=u'codec5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec6 = OCT_STR(name=u'codec6', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec7 = OCT_STR(name=u'codec7', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_codec8 = OCT_STR(name=u'codec8', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Codec')), opt=True)
    _CodecList_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CodecList._cont = ASN1Dict([
        (u'codec1', _CodecList_codec1),
        (u'codec2', _CodecList_codec2),
        (u'codec3', _CodecList_codec3),
        (u'codec4', _CodecList_codec4),
        (u'codec5', _CodecList_codec5),
        (u'codec6', _CodecList_codec6),
        (u'codec7', _CodecList_codec7),
        (u'codec8', _CodecList_codec8),
        (u'extensionContainer', _CodecList_extensionContainer),
        ])
    CodecList._ext = []
    
    #-----< Codec >-----#
    Codec = OCT_STR(name=u'Codec', mode=MODE_TYPE)
    Codec._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< GERAN-Classmark >-----#
    GERAN_Classmark = OCT_STR(name=u'GERAN-Classmark', mode=MODE_TYPE)
    GERAN_Classmark._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=87)], ev=None, er=[])
    
    #-----< SelectedGSM-Algorithm >-----#
    SelectedGSM_Algorithm = OCT_STR(name=u'SelectedGSM-Algorithm', mode=MODE_TYPE)
    SelectedGSM_Algorithm._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SendEndSignal-Arg >-----#
    SendEndSignal_Arg = SEQ(name=u'SendEndSignal-Arg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendEndSignal_Arg_an_APDU = SEQ(name=u'an-APDU', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AccessNetworkSignalInfo')))
    _SendEndSignal_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendEndSignal_Arg._cont = ASN1Dict([
        (u'an-APDU', _SendEndSignal_Arg_an_APDU),
        (u'extensionContainer', _SendEndSignal_Arg_extensionContainer),
        ])
    SendEndSignal_Arg._ext = []
    
    #-----< SendEndSignal-Res >-----#
    SendEndSignal_Res = SEQ(name=u'SendEndSignal-Res', mode=MODE_TYPE)
    _SendEndSignal_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendEndSignal_Res._cont = ASN1Dict([
        (u'extensionContainer', _SendEndSignal_Res_extensionContainer),
        ])
    SendEndSignal_Res._ext = []
    
    #-----< RNCId >-----#
    RNCId = OCT_STR(name=u'RNCId', mode=MODE_TYPE)
    RNCId._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    
    #-----< RelocationNumberList >-----#
    RelocationNumberList = SEQ_OF(name=u'RelocationNumberList', mode=MODE_TYPE)
    _RelocationNumberList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RelocationNumber')))
    RelocationNumberList._cont = _RelocationNumberList__item_
    RelocationNumberList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< MulticallBearerInfo >-----#
    MulticallBearerInfo = INT(name=u'MulticallBearerInfo', mode=MODE_TYPE)
    MulticallBearerInfo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< RelocationNumber >-----#
    RelocationNumber = SEQ(name=u'RelocationNumber', mode=MODE_TYPE)
    _RelocationNumber_handoverNumber = OCT_STR(name=u'handoverNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RelocationNumber_rab_Id = INT(name=u'rab-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAB-Id')))
    RelocationNumber._cont = ASN1Dict([
        (u'handoverNumber', _RelocationNumber_handoverNumber),
        (u'rab-Id', _RelocationNumber_rab_Id),
        ])
    RelocationNumber._ext = []
    
    #-----< RAB-Id >-----#
    RAB_Id = INT(name=u'RAB-Id', mode=MODE_TYPE)
    RAB_Id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< maxNrOfRABs >-----#
    maxNrOfRABs = INT(name=u'maxNrOfRABs', mode=MODE_VALUE)
    maxNrOfRABs._val = 255
    
    #-----< maxNumOfRelocationNumber >-----#
    maxNumOfRelocationNumber = INT(name=u'maxNumOfRelocationNumber', mode=MODE_VALUE)
    maxNumOfRelocationNumber._val = 7
    
    #-----< RadioResourceInformation >-----#
    RadioResourceInformation = OCT_STR(name=u'RadioResourceInformation', mode=MODE_TYPE)
    RadioResourceInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=13)], ev=None, er=[])
    
    #-----< IntegrityProtectionInformation >-----#
    IntegrityProtectionInformation = OCT_STR(name=u'IntegrityProtectionInformation', mode=MODE_TYPE)
    IntegrityProtectionInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=18, ub=100)], ev=None, er=[])
    
    #-----< maxNumOfIntegrityInfo >-----#
    maxNumOfIntegrityInfo = INT(name=u'maxNumOfIntegrityInfo', mode=MODE_VALUE)
    maxNumOfIntegrityInfo._val = 100
    
    #-----< EncryptionInformation >-----#
    EncryptionInformation = OCT_STR(name=u'EncryptionInformation', mode=MODE_TYPE)
    EncryptionInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=18, ub=100)], ev=None, er=[])
    
    #-----< maxNumOfEncryptionInfo >-----#
    maxNumOfEncryptionInfo = INT(name=u'maxNumOfEncryptionInfo', mode=MODE_VALUE)
    maxNumOfEncryptionInfo._val = 100
    
    #-----< SendAuthenticationInfoArg >-----#
    SendAuthenticationInfoArg = SEQ(name=u'SendAuthenticationInfoArg', mode=MODE_TYPE)
    _SendAuthenticationInfoArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SendAuthenticationInfoArg_numberOfRequestedVectors = INT(name=u'numberOfRequestedVectors', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberOfRequestedVectors')))
    _SendAuthenticationInfoArg_segmentationProhibited = NULL(name=u'segmentationProhibited', mode=MODE_TYPE, opt=True)
    _SendAuthenticationInfoArg_immediateResponsePreferred = NULL(name=u'immediateResponsePreferred', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendAuthenticationInfoArg_re_synchronisationInfo = SEQ(name=u're-synchronisationInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Re-synchronisationInfo')), opt=True)
    _SendAuthenticationInfoArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendAuthenticationInfoArg_requestingNodeType = ENUM(name=u'requestingNodeType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestingNodeType')), opt=True)
    _SendAuthenticationInfoArg_requestingPLMN_Id = OCT_STR(name=u'requestingPLMN-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    _SendAuthenticationInfoArg_numberOfRequestedAdditional_Vectors = INT(name=u'numberOfRequestedAdditional-Vectors', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberOfRequestedVectors')), opt=True)
    _SendAuthenticationInfoArg_additionalVectorsAreForEPS = NULL(name=u'additionalVectorsAreForEPS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SendAuthenticationInfoArg_ueUsageTypeRequestIndication = NULL(name=u'ueUsageTypeRequestIndication', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SendAuthenticationInfoArg._cont = ASN1Dict([
        (u'imsi', _SendAuthenticationInfoArg_imsi),
        (u'numberOfRequestedVectors', _SendAuthenticationInfoArg_numberOfRequestedVectors),
        (u'segmentationProhibited', _SendAuthenticationInfoArg_segmentationProhibited),
        (u'immediateResponsePreferred', _SendAuthenticationInfoArg_immediateResponsePreferred),
        (u're-synchronisationInfo', _SendAuthenticationInfoArg_re_synchronisationInfo),
        (u'extensionContainer', _SendAuthenticationInfoArg_extensionContainer),
        (u'requestingNodeType', _SendAuthenticationInfoArg_requestingNodeType),
        (u'requestingPLMN-Id', _SendAuthenticationInfoArg_requestingPLMN_Id),
        (u'numberOfRequestedAdditional-Vectors', _SendAuthenticationInfoArg_numberOfRequestedAdditional_Vectors),
        (u'additionalVectorsAreForEPS', _SendAuthenticationInfoArg_additionalVectorsAreForEPS),
        (u'ueUsageTypeRequestIndication', _SendAuthenticationInfoArg_ueUsageTypeRequestIndication),
        ])
    SendAuthenticationInfoArg._ext = [u'requestingNodeType', u'requestingPLMN-Id', u'numberOfRequestedAdditional-Vectors', u'additionalVectorsAreForEPS', u'ueUsageTypeRequestIndication']
    
    #-----< NumberOfRequestedVectors >-----#
    NumberOfRequestedVectors = INT(name=u'NumberOfRequestedVectors', mode=MODE_TYPE)
    NumberOfRequestedVectors._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Re-synchronisationInfo >-----#
    Re_synchronisationInfo = SEQ(name=u'Re-synchronisationInfo', mode=MODE_TYPE)
    _Re_synchronisationInfo_rand = OCT_STR(name=u'rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _Re_synchronisationInfo_auts = OCT_STR(name=u'auts', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AUTS')))
    Re_synchronisationInfo._cont = ASN1Dict([
        (u'rand', _Re_synchronisationInfo_rand),
        (u'auts', _Re_synchronisationInfo_auts),
        ])
    Re_synchronisationInfo._ext = []
    
    #-----< SendAuthenticationInfoRes >-----#
    SendAuthenticationInfoRes = SEQ(name=u'SendAuthenticationInfoRes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SendAuthenticationInfoRes_authenticationSetList = CHOICE(name=u'authenticationSetList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AuthenticationSetList')), opt=True)
    _SendAuthenticationInfoRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SendAuthenticationInfoRes_eps_AuthenticationSetList = SEQ_OF(name=u'eps-AuthenticationSetList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-AuthenticationSetList')), opt=True)
    _SendAuthenticationInfoRes_ueUsageType = OCT_STR(name=u'ueUsageType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UE-UsageType')), opt=True)
    SendAuthenticationInfoRes._cont = ASN1Dict([
        (u'authenticationSetList', _SendAuthenticationInfoRes_authenticationSetList),
        (u'extensionContainer', _SendAuthenticationInfoRes_extensionContainer),
        (u'eps-AuthenticationSetList', _SendAuthenticationInfoRes_eps_AuthenticationSetList),
        (u'ueUsageType', _SendAuthenticationInfoRes_ueUsageType),
        ])
    SendAuthenticationInfoRes._ext = [u'eps-AuthenticationSetList', u'ueUsageType']
    
    #-----< EPS-AuthenticationSetList >-----#
    EPS_AuthenticationSetList = SEQ_OF(name=u'EPS-AuthenticationSetList', mode=MODE_TYPE)
    _EPS_AuthenticationSetList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPC-AV')))
    EPS_AuthenticationSetList._cont = _EPS_AuthenticationSetList__item_
    EPS_AuthenticationSetList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< UE-UsageType >-----#
    UE_UsageType = OCT_STR(name=u'UE-UsageType', mode=MODE_TYPE)
    UE_UsageType._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< EPC-AV >-----#
    EPC_AV = SEQ(name=u'EPC-AV', mode=MODE_TYPE)
    _EPC_AV_rand = OCT_STR(name=u'rand', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RAND')))
    _EPC_AV_xres = OCT_STR(name=u'xres', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'XRES')))
    _EPC_AV_autn = OCT_STR(name=u'autn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AUTN')))
    _EPC_AV_kasme = OCT_STR(name=u'kasme', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'KASME')))
    _EPC_AV_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EPC_AV._cont = ASN1Dict([
        (u'rand', _EPC_AV_rand),
        (u'xres', _EPC_AV_xres),
        (u'autn', _EPC_AV_autn),
        (u'kasme', _EPC_AV_kasme),
        (u'extensionContainer', _EPC_AV_extensionContainer),
        ])
    EPC_AV._ext = []
    
    #-----< KASME >-----#
    KASME = OCT_STR(name=u'KASME', mode=MODE_TYPE)
    KASME._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    
    #-----< RequestingNodeType >-----#
    RequestingNodeType = ENUM(name=u'RequestingNodeType', mode=MODE_TYPE)
    RequestingNodeType._cont = ASN1Dict([(u'vlr', 0), (u'sgsn', 1), (u's-cscf', 2), (u'bsf', 3), (u'gan-aaa-server', 4), (u'wlan-aaa-server', 5), (u'mme', 16), (u'mme-sgsn', 17)])
    RequestingNodeType._ext = [u's-cscf', u'bsf', u'gan-aaa-server', u'wlan-aaa-server', u'mme', u'mme-sgsn']
    
    #-----< CheckIMEI-Arg >-----#
    CheckIMEI_Arg = SEQ(name=u'CheckIMEI-Arg', mode=MODE_TYPE)
    _CheckIMEI_Arg_imei = OCT_STR(name=u'imei', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')))
    _CheckIMEI_Arg_requestedEquipmentInfo = BIT_STR(name=u'requestedEquipmentInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedEquipmentInfo')))
    _CheckIMEI_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CheckIMEI_Arg._cont = ASN1Dict([
        (u'imei', _CheckIMEI_Arg_imei),
        (u'requestedEquipmentInfo', _CheckIMEI_Arg_requestedEquipmentInfo),
        (u'extensionContainer', _CheckIMEI_Arg_extensionContainer),
        ])
    CheckIMEI_Arg._ext = []
    
    #-----< CheckIMEI-Res >-----#
    CheckIMEI_Res = SEQ(name=u'CheckIMEI-Res', mode=MODE_TYPE)
    _CheckIMEI_Res_equipmentStatus = ENUM(name=u'equipmentStatus', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'EquipmentStatus')), opt=True)
    _CheckIMEI_Res_bmuef = SEQ(name=u'bmuef', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-Iu')), opt=True)
    _CheckIMEI_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CheckIMEI_Res._cont = ASN1Dict([
        (u'equipmentStatus', _CheckIMEI_Res_equipmentStatus),
        (u'bmuef', _CheckIMEI_Res_bmuef),
        (u'extensionContainer', _CheckIMEI_Res_extensionContainer),
        ])
    CheckIMEI_Res._ext = []
    
    #-----< RequestedEquipmentInfo >-----#
    RequestedEquipmentInfo = BIT_STR(name=u'RequestedEquipmentInfo', mode=MODE_TYPE)
    RequestedEquipmentInfo._cont = ASN1Dict([(u'equipmentStatus', 0), (u'bmuef', 1)])
    RequestedEquipmentInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< UESBI-Iu >-----#
    UESBI_Iu = SEQ(name=u'UESBI-Iu', mode=MODE_TYPE)
    _UESBI_Iu_uesbi_IuA = BIT_STR(name=u'uesbi-IuA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-IuA')), opt=True)
    _UESBI_Iu_uesbi_IuB = BIT_STR(name=u'uesbi-IuB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UESBI-IuB')), opt=True)
    UESBI_Iu._cont = ASN1Dict([
        (u'uesbi-IuA', _UESBI_Iu_uesbi_IuA),
        (u'uesbi-IuB', _UESBI_Iu_uesbi_IuB),
        ])
    UESBI_Iu._ext = []
    
    #-----< UESBI-IuA >-----#
    UESBI_IuA = BIT_STR(name=u'UESBI-IuA', mode=MODE_TYPE)
    UESBI_IuA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< UESBI-IuB >-----#
    UESBI_IuB = BIT_STR(name=u'UESBI-IuB', mode=MODE_TYPE)
    UESBI_IuB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< EquipmentStatus >-----#
    EquipmentStatus = ENUM(name=u'EquipmentStatus', mode=MODE_TYPE)
    EquipmentStatus._cont = ASN1Dict([(u'whiteListed', 0), (u'blackListed', 1), (u'greyListed', 2)])
    EquipmentStatus._ext = None
    
    #-----< InsertSubscriberDataArg >-----#
    InsertSubscriberDataArg = SEQ(name=u'InsertSubscriberDataArg', mode=MODE_TYPE)
    _InsertSubscriberDataArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _InsertSubscriberDataArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _InsertSubscriberDataArg_category = OCT_STR(name=u'category', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Category')), opt=True)
    _InsertSubscriberDataArg_subscriberStatus = ENUM(name=u'subscriberStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberStatus')), opt=True)
    _InsertSubscriberDataArg_bearerServiceList = SEQ_OF(name=u'bearerServiceList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BearerServiceList')), opt=True)
    _InsertSubscriberDataArg_teleserviceList = SEQ_OF(name=u'teleserviceList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TeleserviceList')), opt=True)
    _InsertSubscriberDataArg_provisionedSS = SEQ_OF(name=u'provisionedSS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-InfoList')), opt=True)
    _InsertSubscriberDataArg_odb_Data = SEQ(name=u'odb-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')), opt=True)
    _InsertSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature = NULL(name=u'roamingRestrictionDueToUnsupportedFeature', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_regionalSubscriptionData = SEQ_OF(name=u'regionalSubscriptionData', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCodeList')), opt=True)
    _InsertSubscriberDataArg_vbsSubscriptionData = SEQ_OF(name=u'vbsSubscriptionData', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VBSDataList')), opt=True)
    _InsertSubscriberDataArg_vgcsSubscriptionData = SEQ_OF(name=u'vgcsSubscriptionData', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VGCSDataList')), opt=True)
    _InsertSubscriberDataArg_vlrCamelSubscriptionInfo = SEQ(name=u'vlrCamelSubscriptionInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VlrCamelSubscriptionInfo')), opt=True)
    _InsertSubscriberDataArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _InsertSubscriberDataArg_naea_PreferredCI = SEQ(name=u'naea-PreferredCI', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NAEA-PreferredCI')), opt=True)
    _InsertSubscriberDataArg_gprsSubscriptionData = SEQ(name=u'gprsSubscriptionData', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSSubscriptionData')), opt=True)
    _InsertSubscriberDataArg_roamingRestrictedInSgsnDueToUnsupportedFeature = NULL(name=u'roamingRestrictedInSgsnDueToUnsupportedFeature', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_networkAccessMode = ENUM(name=u'networkAccessMode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NetworkAccessMode')), opt=True)
    _InsertSubscriberDataArg_lsaInformation = SEQ(name=u'lsaInformation', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAInformation')), opt=True)
    _InsertSubscriberDataArg_lmu_Indicator = NULL(name=u'lmu-Indicator', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_lcsInformation = SEQ(name=u'lcsInformation', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCSInformation')), opt=True)
    _InsertSubscriberDataArg_istAlertTimer = INT(name=u'istAlertTimer', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IST-AlertTimerValue')), opt=True)
    _InsertSubscriberDataArg_superChargerSupportedInHLR = OCT_STR(name=u'superChargerSupportedInHLR', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AgeIndicator')), opt=True)
    _InsertSubscriberDataArg_mc_SS_Info = SEQ(name=u'mc-SS-Info', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-SS-Info')), opt=True)
    _InsertSubscriberDataArg_cs_AllocationRetentionPriority = OCT_STR(name=u'cs-AllocationRetentionPriority', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CS-AllocationRetentionPriority')), opt=True)
    _InsertSubscriberDataArg_sgsn_CAMEL_SubscriptionInfo = SEQ(name=u'sgsn-CAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SGSN-CAMEL-SubscriptionInfo')), opt=True)
    _InsertSubscriberDataArg_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _InsertSubscriberDataArg_accessRestrictionData = BIT_STR(name=u'accessRestrictionData', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AccessRestrictionData')), opt=True)
    _InsertSubscriberDataArg_ics_Indicator = BOOL(name=u'ics-Indicator', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_eps_SubscriptionData = SEQ(name=u'eps-SubscriptionData', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-SubscriptionData')), opt=True)
    _InsertSubscriberDataArg_csg_SubscriptionDataList = SEQ_OF(name=u'csg-SubscriptionDataList', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    _InsertSubscriberDataArg_ue_ReachabilityRequestIndicator = NULL(name=u'ue-ReachabilityRequestIndicator', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _InsertSubscriberDataArg_mme_Name = OCT_STR(name=u'mme-Name', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    _InsertSubscriberDataArg_subscribedPeriodicRAUTAUtimer = INT(name=u'subscribedPeriodicRAUTAUtimer', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscribedPeriodicRAUTAUtimer')), opt=True)
    _InsertSubscriberDataArg_vplmnLIPAAllowed = NULL(name=u'vplmnLIPAAllowed', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_mdtUserConsent = BOOL(name=u'mdtUserConsent', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_subscribedPeriodicLAUtimer = INT(name=u'subscribedPeriodicLAUtimer', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscribedPeriodicLAUtimer')), opt=True)
    _InsertSubscriberDataArg_vplmn_Csg_SubscriptionDataList = SEQ_OF(name=u'vplmn-Csg-SubscriptionDataList', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VPLMN-CSG-SubscriptionDataList')), opt=True)
    _InsertSubscriberDataArg_additionalMSISDN = OCT_STR(name=u'additionalMSISDN', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _InsertSubscriberDataArg_psAndSMS_OnlyServiceProvision = NULL(name=u'psAndSMS-OnlyServiceProvision', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_smsInSGSNAllowed = NULL(name=u'smsInSGSNAllowed', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_cs_to_ps_SRVCC_Allowed_Indicator = NULL(name=u'cs-to-ps-SRVCC-Allowed-Indicator', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_pcscf_Restoration_Request = NULL(name=u'pcscf-Restoration-Request', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_adjacentAccessRestrictionDataList = SEQ_OF(name=u'adjacentAccessRestrictionDataList', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdjacentAccessRestrictionDataList')), opt=True)
    _InsertSubscriberDataArg_imsi_Group_Id_List = SEQ_OF(name=u'imsi-Group-Id-List', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IMSI-GroupIdList')), opt=True)
    _InsertSubscriberDataArg_ueUsageType = OCT_STR(name=u'ueUsageType', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UE-UsageType')), opt=True)
    _InsertSubscriberDataArg_userPlaneIntegrityProtectionIndicator = NULL(name=u'userPlaneIntegrityProtectionIndicator', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _InsertSubscriberDataArg_dl_Buffering_Suggested_Packet_Count = INT(name=u'dl-Buffering-Suggested-Packet-Count', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DL-Buffering-Suggested-Packet-Count')), opt=True)
    _InsertSubscriberDataArg_reset_Id_List = SEQ_OF(name=u'reset-Id-List', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Reset-Id-List')), opt=True)
    _InsertSubscriberDataArg_eDRX_Cycle_Length_List = SEQ_OF(name=u'eDRX-Cycle-Length-List', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EDRX-Cycle-Length-List')), opt=True)
    _InsertSubscriberDataArg_ext_AccessRestrictionData = BIT_STR(name=u'ext-AccessRestrictionData', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-AccessRestrictionData')), opt=True)
    _InsertSubscriberDataArg_iab_Operation_Allowed_Indicator = NULL(name=u'iab-Operation-Allowed-Indicator', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    InsertSubscriberDataArg._cont = ASN1Dict([
        (u'imsi', _InsertSubscriberDataArg_imsi),
        (u'msisdn', _InsertSubscriberDataArg_msisdn),
        (u'category', _InsertSubscriberDataArg_category),
        (u'subscriberStatus', _InsertSubscriberDataArg_subscriberStatus),
        (u'bearerServiceList', _InsertSubscriberDataArg_bearerServiceList),
        (u'teleserviceList', _InsertSubscriberDataArg_teleserviceList),
        (u'provisionedSS', _InsertSubscriberDataArg_provisionedSS),
        (u'odb-Data', _InsertSubscriberDataArg_odb_Data),
        (u'roamingRestrictionDueToUnsupportedFeature', _InsertSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature),
        (u'regionalSubscriptionData', _InsertSubscriberDataArg_regionalSubscriptionData),
        (u'vbsSubscriptionData', _InsertSubscriberDataArg_vbsSubscriptionData),
        (u'vgcsSubscriptionData', _InsertSubscriberDataArg_vgcsSubscriptionData),
        (u'vlrCamelSubscriptionInfo', _InsertSubscriberDataArg_vlrCamelSubscriptionInfo),
        (u'extensionContainer', _InsertSubscriberDataArg_extensionContainer),
        (u'naea-PreferredCI', _InsertSubscriberDataArg_naea_PreferredCI),
        (u'gprsSubscriptionData', _InsertSubscriberDataArg_gprsSubscriptionData),
        (u'roamingRestrictedInSgsnDueToUnsupportedFeature', _InsertSubscriberDataArg_roamingRestrictedInSgsnDueToUnsupportedFeature),
        (u'networkAccessMode', _InsertSubscriberDataArg_networkAccessMode),
        (u'lsaInformation', _InsertSubscriberDataArg_lsaInformation),
        (u'lmu-Indicator', _InsertSubscriberDataArg_lmu_Indicator),
        (u'lcsInformation', _InsertSubscriberDataArg_lcsInformation),
        (u'istAlertTimer', _InsertSubscriberDataArg_istAlertTimer),
        (u'superChargerSupportedInHLR', _InsertSubscriberDataArg_superChargerSupportedInHLR),
        (u'mc-SS-Info', _InsertSubscriberDataArg_mc_SS_Info),
        (u'cs-AllocationRetentionPriority', _InsertSubscriberDataArg_cs_AllocationRetentionPriority),
        (u'sgsn-CAMEL-SubscriptionInfo', _InsertSubscriberDataArg_sgsn_CAMEL_SubscriptionInfo),
        (u'chargingCharacteristics', _InsertSubscriberDataArg_chargingCharacteristics),
        (u'accessRestrictionData', _InsertSubscriberDataArg_accessRestrictionData),
        (u'ics-Indicator', _InsertSubscriberDataArg_ics_Indicator),
        (u'eps-SubscriptionData', _InsertSubscriberDataArg_eps_SubscriptionData),
        (u'csg-SubscriptionDataList', _InsertSubscriberDataArg_csg_SubscriptionDataList),
        (u'ue-ReachabilityRequestIndicator', _InsertSubscriberDataArg_ue_ReachabilityRequestIndicator),
        (u'sgsn-Number', _InsertSubscriberDataArg_sgsn_Number),
        (u'mme-Name', _InsertSubscriberDataArg_mme_Name),
        (u'subscribedPeriodicRAUTAUtimer', _InsertSubscriberDataArg_subscribedPeriodicRAUTAUtimer),
        (u'vplmnLIPAAllowed', _InsertSubscriberDataArg_vplmnLIPAAllowed),
        (u'mdtUserConsent', _InsertSubscriberDataArg_mdtUserConsent),
        (u'subscribedPeriodicLAUtimer', _InsertSubscriberDataArg_subscribedPeriodicLAUtimer),
        (u'vplmn-Csg-SubscriptionDataList', _InsertSubscriberDataArg_vplmn_Csg_SubscriptionDataList),
        (u'additionalMSISDN', _InsertSubscriberDataArg_additionalMSISDN),
        (u'psAndSMS-OnlyServiceProvision', _InsertSubscriberDataArg_psAndSMS_OnlyServiceProvision),
        (u'smsInSGSNAllowed', _InsertSubscriberDataArg_smsInSGSNAllowed),
        (u'cs-to-ps-SRVCC-Allowed-Indicator', _InsertSubscriberDataArg_cs_to_ps_SRVCC_Allowed_Indicator),
        (u'pcscf-Restoration-Request', _InsertSubscriberDataArg_pcscf_Restoration_Request),
        (u'adjacentAccessRestrictionDataList', _InsertSubscriberDataArg_adjacentAccessRestrictionDataList),
        (u'imsi-Group-Id-List', _InsertSubscriberDataArg_imsi_Group_Id_List),
        (u'ueUsageType', _InsertSubscriberDataArg_ueUsageType),
        (u'userPlaneIntegrityProtectionIndicator', _InsertSubscriberDataArg_userPlaneIntegrityProtectionIndicator),
        (u'dl-Buffering-Suggested-Packet-Count', _InsertSubscriberDataArg_dl_Buffering_Suggested_Packet_Count),
        (u'reset-Id-List', _InsertSubscriberDataArg_reset_Id_List),
        (u'eDRX-Cycle-Length-List', _InsertSubscriberDataArg_eDRX_Cycle_Length_List),
        (u'ext-AccessRestrictionData', _InsertSubscriberDataArg_ext_AccessRestrictionData),
        (u'iab-Operation-Allowed-Indicator', _InsertSubscriberDataArg_iab_Operation_Allowed_Indicator),
        ])
    InsertSubscriberDataArg._ext = [u'naea-PreferredCI', u'gprsSubscriptionData', u'roamingRestrictedInSgsnDueToUnsupportedFeature', u'networkAccessMode', u'lsaInformation', u'lmu-Indicator', u'lcsInformation', u'istAlertTimer', u'superChargerSupportedInHLR', u'mc-SS-Info', u'cs-AllocationRetentionPriority', u'sgsn-CAMEL-SubscriptionInfo', u'chargingCharacteristics', u'accessRestrictionData', u'ics-Indicator', u'eps-SubscriptionData', u'csg-SubscriptionDataList', u'ue-ReachabilityRequestIndicator', u'sgsn-Number', u'mme-Name', u'subscribedPeriodicRAUTAUtimer', u'vplmnLIPAAllowed', u'mdtUserConsent', u'subscribedPeriodicLAUtimer', u'vplmn-Csg-SubscriptionDataList', u'additionalMSISDN', u'psAndSMS-OnlyServiceProvision', u'smsInSGSNAllowed', u'cs-to-ps-SRVCC-Allowed-Indicator', u'pcscf-Restoration-Request', u'adjacentAccessRestrictionDataList', u'imsi-Group-Id-List', u'ueUsageType', u'userPlaneIntegrityProtectionIndicator', u'dl-Buffering-Suggested-Packet-Count', u'reset-Id-List', u'eDRX-Cycle-Length-List', u'ext-AccessRestrictionData', u'iab-Operation-Allowed-Indicator']
    
    #-----< EDRX-Cycle-Length-List >-----#
    EDRX_Cycle_Length_List = SEQ_OF(name=u'EDRX-Cycle-Length-List', mode=MODE_TYPE)
    _EDRX_Cycle_Length_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'EDRX-Cycle-Length')))
    EDRX_Cycle_Length_List._cont = _EDRX_Cycle_Length_List__item_
    EDRX_Cycle_Length_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< EDRX-Cycle-Length >-----#
    EDRX_Cycle_Length = SEQ(name=u'EDRX-Cycle-Length', mode=MODE_TYPE)
    _EDRX_Cycle_Length_rat_Type = ENUM(name=u'rat-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')))
    _EDRX_Cycle_Length_eDRX_Cycle_Length_Value = OCT_STR(name=u'eDRX-Cycle-Length-Value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EDRX-Cycle-Length-Value')))
    EDRX_Cycle_Length._cont = ASN1Dict([
        (u'rat-Type', _EDRX_Cycle_Length_rat_Type),
        (u'eDRX-Cycle-Length-Value', _EDRX_Cycle_Length_eDRX_Cycle_Length_Value),
        ])
    EDRX_Cycle_Length._ext = []
    
    #-----< EDRX-Cycle-Length-Value >-----#
    EDRX_Cycle_Length_Value = OCT_STR(name=u'EDRX-Cycle-Length-Value', mode=MODE_TYPE)
    EDRX_Cycle_Length_Value._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Reset-Id-List >-----#
    Reset_Id_List = SEQ_OF(name=u'Reset-Id-List', mode=MODE_TYPE)
    _Reset_Id_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Reset-Id')))
    Reset_Id_List._cont = _Reset_Id_List__item_
    Reset_Id_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< Reset-Id >-----#
    Reset_Id = OCT_STR(name=u'Reset-Id', mode=MODE_TYPE)
    Reset_Id._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< DL-Buffering-Suggested-Packet-Count >-----#
    DL_Buffering_Suggested_Packet_Count = INT(name=u'DL-Buffering-Suggested-Packet-Count', mode=MODE_TYPE)
    DL_Buffering_Suggested_Packet_Count._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-1, ub=2147483647)], ev=None, er=[])
    
    #-----< Group-Service-ID >-----#
    Group_Service_ID = INT(name=u'Group-Service-ID', mode=MODE_TYPE)
    Group_Service_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< Local-GroupID >-----#
    Local_GroupID = OCT_STR(name=u'Local-GroupID', mode=MODE_TYPE)
    Local_GroupID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< IMSI-GroupIdList >-----#
    IMSI_GroupIdList = SEQ_OF(name=u'IMSI-GroupIdList', mode=MODE_TYPE)
    _IMSI_GroupIdList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IMSI-GroupId')))
    IMSI_GroupIdList._cont = _IMSI_GroupIdList__item_
    IMSI_GroupIdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< IMSI-GroupId >-----#
    IMSI_GroupId = SEQ(name=u'IMSI-GroupId', mode=MODE_TYPE)
    _IMSI_GroupId_group_Service_Id = INT(name=u'group-Service-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Group-Service-ID')))
    _IMSI_GroupId_plmnId = OCT_STR(name=u'plmnId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    _IMSI_GroupId_local_Group_ID = OCT_STR(name=u'local-Group-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Local-GroupID')))
    IMSI_GroupId._cont = ASN1Dict([
        (u'group-Service-Id', _IMSI_GroupId_group_Service_Id),
        (u'plmnId', _IMSI_GroupId_plmnId),
        (u'local-Group-ID', _IMSI_GroupId_local_Group_ID),
        ])
    IMSI_GroupId._ext = []
    
    #-----< SubscribedPeriodicRAUTAUtimer >-----#
    SubscribedPeriodicRAUTAUtimer = INT(name=u'SubscribedPeriodicRAUTAUtimer', mode=MODE_TYPE)
    SubscribedPeriodicRAUTAUtimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< SubscribedPeriodicLAUtimer >-----#
    SubscribedPeriodicLAUtimer = INT(name=u'SubscribedPeriodicLAUtimer', mode=MODE_TYPE)
    SubscribedPeriodicLAUtimer._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< CSG-SubscriptionDataList >-----#
    CSG_SubscriptionDataList = SEQ_OF(name=u'CSG-SubscriptionDataList', mode=MODE_TYPE)
    _CSG_SubscriptionDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionData')))
    CSG_SubscriptionDataList._cont = _CSG_SubscriptionDataList__item_
    CSG_SubscriptionDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< CSG-SubscriptionData >-----#
    CSG_SubscriptionData = SEQ(name=u'CSG-SubscriptionData', mode=MODE_TYPE)
    _CSG_SubscriptionData_csg_Id = BIT_STR(name=u'csg-Id', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-Id')))
    _CSG_SubscriptionData_expirationDate = OCT_STR(name=u'expirationDate', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _CSG_SubscriptionData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CSG_SubscriptionData_lipa_AllowedAPNList = SEQ_OF(name=u'lipa-AllowedAPNList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LIPA-AllowedAPNList')), opt=True)
    _CSG_SubscriptionData_plmn_Id = OCT_STR(name=u'plmn-Id', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    CSG_SubscriptionData._cont = ASN1Dict([
        (u'csg-Id', _CSG_SubscriptionData_csg_Id),
        (u'expirationDate', _CSG_SubscriptionData_expirationDate),
        (u'extensionContainer', _CSG_SubscriptionData_extensionContainer),
        (u'lipa-AllowedAPNList', _CSG_SubscriptionData_lipa_AllowedAPNList),
        (u'plmn-Id', _CSG_SubscriptionData_plmn_Id),
        ])
    CSG_SubscriptionData._ext = [u'lipa-AllowedAPNList', u'plmn-Id']
    
    #-----< VPLMN-CSG-SubscriptionDataList >-----#
    VPLMN_CSG_SubscriptionDataList = SEQ_OF(name=u'VPLMN-CSG-SubscriptionDataList', mode=MODE_TYPE)
    _VPLMN_CSG_SubscriptionDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionData')))
    VPLMN_CSG_SubscriptionDataList._cont = _VPLMN_CSG_SubscriptionDataList__item_
    VPLMN_CSG_SubscriptionDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< CSG-Id >-----#
    CSG_Id = BIT_STR(name=u'CSG-Id', mode=MODE_TYPE)
    CSG_Id._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    
    #-----< LIPA-AllowedAPNList >-----#
    LIPA_AllowedAPNList = SEQ_OF(name=u'LIPA-AllowedAPNList', mode=MODE_TYPE)
    _LIPA_AllowedAPNList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    LIPA_AllowedAPNList._cont = _LIPA_AllowedAPNList__item_
    LIPA_AllowedAPNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfLIPAAllowedAPN >-----#
    maxNumOfLIPAAllowedAPN = INT(name=u'maxNumOfLIPAAllowedAPN', mode=MODE_VALUE)
    maxNumOfLIPAAllowedAPN._val = 50
    
    #-----< EPS-SubscriptionData >-----#
    EPS_SubscriptionData = SEQ(name=u'EPS-SubscriptionData', mode=MODE_TYPE)
    _EPS_SubscriptionData_apn_oi_Replacement = OCT_STR(name=u'apn-oi-Replacement', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    _EPS_SubscriptionData_rfsp_id = INT(name=u'rfsp-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RFSP-ID')), opt=True)
    _EPS_SubscriptionData_ambr = SEQ(name=u'ambr', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AMBR')), opt=True)
    _EPS_SubscriptionData_apn_ConfigurationProfile = SEQ(name=u'apn-ConfigurationProfile', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-ConfigurationProfile')), opt=True)
    _EPS_SubscriptionData_stn_sr = OCT_STR(name=u'stn-sr', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _EPS_SubscriptionData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _EPS_SubscriptionData_mps_CSPriority = NULL(name=u'mps-CSPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_SubscriptionData_mps_EPSPriority = NULL(name=u'mps-EPSPriority', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EPS_SubscriptionData_subscribed_vsrvcc = NULL(name=u'subscribed-vsrvcc', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    EPS_SubscriptionData._cont = ASN1Dict([
        (u'apn-oi-Replacement', _EPS_SubscriptionData_apn_oi_Replacement),
        (u'rfsp-id', _EPS_SubscriptionData_rfsp_id),
        (u'ambr', _EPS_SubscriptionData_ambr),
        (u'apn-ConfigurationProfile', _EPS_SubscriptionData_apn_ConfigurationProfile),
        (u'stn-sr', _EPS_SubscriptionData_stn_sr),
        (u'extensionContainer', _EPS_SubscriptionData_extensionContainer),
        (u'mps-CSPriority', _EPS_SubscriptionData_mps_CSPriority),
        (u'mps-EPSPriority', _EPS_SubscriptionData_mps_EPSPriority),
        (u'subscribed-vsrvcc', _EPS_SubscriptionData_subscribed_vsrvcc),
        ])
    EPS_SubscriptionData._ext = [u'mps-CSPriority', u'mps-EPSPriority', u'subscribed-vsrvcc']
    
    #-----< APN-OI-Replacement >-----#
    APN_OI_Replacement = OCT_STR(name=u'APN-OI-Replacement', mode=MODE_TYPE)
    APN_OI_Replacement._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=9, ub=100)], ev=None, er=[])
    
    #-----< RFSP-ID >-----#
    RFSP_ID = INT(name=u'RFSP-ID', mode=MODE_TYPE)
    RFSP_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< APN-ConfigurationProfile >-----#
    APN_ConfigurationProfile = SEQ(name=u'APN-ConfigurationProfile', mode=MODE_TYPE)
    _APN_ConfigurationProfile_defaultContext = INT(name=u'defaultContext', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _APN_ConfigurationProfile_completeDataListIncluded = NULL(name=u'completeDataListIncluded', mode=MODE_TYPE, opt=True)
    _APN_ConfigurationProfile_epsDataList = SEQ_OF(name=u'epsDataList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-DataList')))
    _APN_ConfigurationProfile_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _APN_ConfigurationProfile_additionalDefaultContext = INT(name=u'additionalDefaultContext', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')), opt=True)
    APN_ConfigurationProfile._cont = ASN1Dict([
        (u'defaultContext', _APN_ConfigurationProfile_defaultContext),
        (u'completeDataListIncluded', _APN_ConfigurationProfile_completeDataListIncluded),
        (u'epsDataList', _APN_ConfigurationProfile_epsDataList),
        (u'extensionContainer', _APN_ConfigurationProfile_extensionContainer),
        (u'additionalDefaultContext', _APN_ConfigurationProfile_additionalDefaultContext),
        ])
    APN_ConfigurationProfile._ext = [u'additionalDefaultContext']
    
    #-----< EPS-DataList >-----#
    EPS_DataList = SEQ_OF(name=u'EPS-DataList', mode=MODE_TYPE)
    _EPS_DataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-Configuration')))
    EPS_DataList._cont = _EPS_DataList__item_
    EPS_DataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfAPN-Configurations >-----#
    maxNumOfAPN_Configurations = INT(name=u'maxNumOfAPN-Configurations', mode=MODE_VALUE)
    maxNumOfAPN_Configurations._val = 50
    
    #-----< APN-Configuration >-----#
    APN_Configuration = SEQ(name=u'APN-Configuration', mode=MODE_TYPE)
    _APN_Configuration_contextId = INT(name=u'contextId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _APN_Configuration_pdn_Type = OCT_STR(name=u'pdn-Type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-Type')))
    _APN_Configuration_servedPartyIP_IPv4_Address = OCT_STR(name=u'servedPartyIP-IPv4-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _APN_Configuration_apn = OCT_STR(name=u'apn', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    _APN_Configuration_eps_qos_Subscribed = SEQ(name=u'eps-qos-Subscribed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-QoS-Subscribed')))
    _APN_Configuration_pdn_gw_Identity = SEQ(name=u'pdn-gw-Identity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Identity')), opt=True)
    _APN_Configuration_pdn_gw_AllocationType = ENUM(name=u'pdn-gw-AllocationType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-AllocationType')), opt=True)
    _APN_Configuration_vplmnAddressAllowed = NULL(name=u'vplmnAddressAllowed', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _APN_Configuration_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _APN_Configuration_ambr = SEQ(name=u'ambr', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AMBR')), opt=True)
    _APN_Configuration_specificAPNInfoList = SEQ_OF(name=u'specificAPNInfoList', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificAPNInfoList')), opt=True)
    _APN_Configuration_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _APN_Configuration_servedPartyIP_IPv6_Address = OCT_STR(name=u'servedPartyIP-IPv6-Address', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _APN_Configuration_apn_oi_Replacement = OCT_STR(name=u'apn-oi-Replacement', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    _APN_Configuration_sipto_Permission = ENUM(name=u'sipto-Permission', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Permission')), opt=True)
    _APN_Configuration_lipa_Permission = ENUM(name=u'lipa-Permission', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LIPA-Permission')), opt=True)
    _APN_Configuration_restoration_Priority = OCT_STR(name=u'restoration-Priority', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Restoration-Priority')), opt=True)
    _APN_Configuration_sipto_local_network_Permission = ENUM(name=u'sipto-local-network-Permission', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Local-Network-Permission')), opt=True)
    _APN_Configuration_wlan_offloadability = SEQ(name=u'wlan-offloadability', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WLAN-Offloadability')), opt=True)
    _APN_Configuration_non_IP_PDN_Type_Indicator = NULL(name=u'non-IP-PDN-Type-Indicator', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _APN_Configuration_nIDD_Mechanism = ENUM(name=u'nIDD-Mechanism', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NIDD-Mechanism')), opt=True)
    _APN_Configuration_sCEF_ID = OCT_STR(name=u'sCEF-ID', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    _APN_Configuration_pdn_ConnectionContinuity = ENUM(name=u'pdn-ConnectionContinuity', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-ConnectionContinuity')), opt=True)
    APN_Configuration._cont = ASN1Dict([
        (u'contextId', _APN_Configuration_contextId),
        (u'pdn-Type', _APN_Configuration_pdn_Type),
        (u'servedPartyIP-IPv4-Address', _APN_Configuration_servedPartyIP_IPv4_Address),
        (u'apn', _APN_Configuration_apn),
        (u'eps-qos-Subscribed', _APN_Configuration_eps_qos_Subscribed),
        (u'pdn-gw-Identity', _APN_Configuration_pdn_gw_Identity),
        (u'pdn-gw-AllocationType', _APN_Configuration_pdn_gw_AllocationType),
        (u'vplmnAddressAllowed', _APN_Configuration_vplmnAddressAllowed),
        (u'chargingCharacteristics', _APN_Configuration_chargingCharacteristics),
        (u'ambr', _APN_Configuration_ambr),
        (u'specificAPNInfoList', _APN_Configuration_specificAPNInfoList),
        (u'extensionContainer', _APN_Configuration_extensionContainer),
        (u'servedPartyIP-IPv6-Address', _APN_Configuration_servedPartyIP_IPv6_Address),
        (u'apn-oi-Replacement', _APN_Configuration_apn_oi_Replacement),
        (u'sipto-Permission', _APN_Configuration_sipto_Permission),
        (u'lipa-Permission', _APN_Configuration_lipa_Permission),
        (u'restoration-Priority', _APN_Configuration_restoration_Priority),
        (u'sipto-local-network-Permission', _APN_Configuration_sipto_local_network_Permission),
        (u'wlan-offloadability', _APN_Configuration_wlan_offloadability),
        (u'non-IP-PDN-Type-Indicator', _APN_Configuration_non_IP_PDN_Type_Indicator),
        (u'nIDD-Mechanism', _APN_Configuration_nIDD_Mechanism),
        (u'sCEF-ID', _APN_Configuration_sCEF_ID),
        (u'pdn-ConnectionContinuity', _APN_Configuration_pdn_ConnectionContinuity),
        ])
    APN_Configuration._ext = [u'apn-oi-Replacement', u'sipto-Permission', u'lipa-Permission', u'restoration-Priority', u'sipto-local-network-Permission', u'wlan-offloadability', u'non-IP-PDN-Type-Indicator', u'nIDD-Mechanism', u'sCEF-ID', u'pdn-ConnectionContinuity']
    
    #-----< PDN-ConnectionContinuity >-----#
    PDN_ConnectionContinuity = ENUM(name=u'PDN-ConnectionContinuity', mode=MODE_TYPE)
    PDN_ConnectionContinuity._cont = ASN1Dict([(u'maintainPDN-Connection', 0), (u'disconnectPDN-ConnectionWithReactivationRequest', 1), (u'disconnectPDN-ConnectionWithoutReactivationRequest', 2)])
    PDN_ConnectionContinuity._ext = None
    
    #-----< NIDD-Mechanism >-----#
    NIDD_Mechanism = ENUM(name=u'NIDD-Mechanism', mode=MODE_TYPE)
    NIDD_Mechanism._cont = ASN1Dict([(u'sGi-based-data-delivery', 0), (u'sCEF-based-data-delivery', 1)])
    NIDD_Mechanism._ext = None
    
    #-----< PDN-Type >-----#
    PDN_Type = OCT_STR(name=u'PDN-Type', mode=MODE_TYPE)
    PDN_Type._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< EPS-QoS-Subscribed >-----#
    EPS_QoS_Subscribed = SEQ(name=u'EPS-QoS-Subscribed', mode=MODE_TYPE)
    _EPS_QoS_Subscribed_qos_Class_Identifier = INT(name=u'qos-Class-Identifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QoS-Class-Identifier')))
    _EPS_QoS_Subscribed_allocation_Retention_Priority = SEQ(name=u'allocation-Retention-Priority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Allocation-Retention-Priority')))
    _EPS_QoS_Subscribed_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    EPS_QoS_Subscribed._cont = ASN1Dict([
        (u'qos-Class-Identifier', _EPS_QoS_Subscribed_qos_Class_Identifier),
        (u'allocation-Retention-Priority', _EPS_QoS_Subscribed_allocation_Retention_Priority),
        (u'extensionContainer', _EPS_QoS_Subscribed_extensionContainer),
        ])
    EPS_QoS_Subscribed._ext = []
    
    #-----< AMBR >-----#
    AMBR = SEQ(name=u'AMBR', mode=MODE_TYPE)
    _AMBR_max_RequestedBandwidth_UL = INT(name=u'max-RequestedBandwidth-UL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Bandwidth')))
    _AMBR_max_RequestedBandwidth_DL = INT(name=u'max-RequestedBandwidth-DL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Bandwidth')))
    _AMBR_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AMBR_extended_Max_RequestedBandwidth_UL = INT(name=u'extended-Max-RequestedBandwidth-UL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BandwidthExt')), opt=True)
    _AMBR_extended_Max_RequestedBandwidth_DL = INT(name=u'extended-Max-RequestedBandwidth-DL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BandwidthExt')), opt=True)
    AMBR._cont = ASN1Dict([
        (u'max-RequestedBandwidth-UL', _AMBR_max_RequestedBandwidth_UL),
        (u'max-RequestedBandwidth-DL', _AMBR_max_RequestedBandwidth_DL),
        (u'extensionContainer', _AMBR_extensionContainer),
        (u'extended-Max-RequestedBandwidth-UL', _AMBR_extended_Max_RequestedBandwidth_UL),
        (u'extended-Max-RequestedBandwidth-DL', _AMBR_extended_Max_RequestedBandwidth_DL),
        ])
    AMBR._ext = [u'extended-Max-RequestedBandwidth-UL', u'extended-Max-RequestedBandwidth-DL']
    
    #-----< SpecificAPNInfoList >-----#
    SpecificAPNInfoList = SEQ_OF(name=u'SpecificAPNInfoList', mode=MODE_TYPE)
    _SpecificAPNInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificAPNInfo')))
    SpecificAPNInfoList._cont = _SpecificAPNInfoList__item_
    SpecificAPNInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfSpecificAPNInfos >-----#
    maxNumOfSpecificAPNInfos = INT(name=u'maxNumOfSpecificAPNInfos', mode=MODE_VALUE)
    maxNumOfSpecificAPNInfos._val = 50
    
    #-----< SpecificAPNInfo >-----#
    SpecificAPNInfo = SEQ(name=u'SpecificAPNInfo', mode=MODE_TYPE)
    _SpecificAPNInfo_apn = OCT_STR(name=u'apn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    _SpecificAPNInfo_pdn_gw_Identity = SEQ(name=u'pdn-gw-Identity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDN-GW-Identity')))
    _SpecificAPNInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SpecificAPNInfo._cont = ASN1Dict([
        (u'apn', _SpecificAPNInfo_apn),
        (u'pdn-gw-Identity', _SpecificAPNInfo_pdn_gw_Identity),
        (u'extensionContainer', _SpecificAPNInfo_extensionContainer),
        ])
    SpecificAPNInfo._ext = []
    
    #-----< Bandwidth >-----#
    Bandwidth = INT(name=u'Bandwidth', mode=MODE_TYPE)
    
    #-----< BandwidthExt >-----#
    BandwidthExt = INT(name=u'BandwidthExt', mode=MODE_TYPE)
    
    #-----< QoS-Class-Identifier >-----#
    QoS_Class_Identifier = INT(name=u'QoS-Class-Identifier', mode=MODE_TYPE)
    QoS_Class_Identifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< Allocation-Retention-Priority >-----#
    Allocation_Retention_Priority = SEQ(name=u'Allocation-Retention-Priority', mode=MODE_TYPE)
    _Allocation_Retention_Priority_priority_level = INT(name=u'priority-level', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Allocation_Retention_Priority_pre_emption_capability = BOOL(name=u'pre-emption-capability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Allocation_Retention_Priority_pre_emption_vulnerability = BOOL(name=u'pre-emption-vulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Allocation_Retention_Priority_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Allocation_Retention_Priority._cont = ASN1Dict([
        (u'priority-level', _Allocation_Retention_Priority_priority_level),
        (u'pre-emption-capability', _Allocation_Retention_Priority_pre_emption_capability),
        (u'pre-emption-vulnerability', _Allocation_Retention_Priority_pre_emption_vulnerability),
        (u'extensionContainer', _Allocation_Retention_Priority_extensionContainer),
        ])
    Allocation_Retention_Priority._ext = []
    
    #-----< PDN-GW-Identity >-----#
    PDN_GW_Identity = SEQ(name=u'PDN-GW-Identity', mode=MODE_TYPE)
    _PDN_GW_Identity_pdn_gw_ipv4_Address = OCT_STR(name=u'pdn-gw-ipv4-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDN_GW_Identity_pdn_gw_ipv6_Address = OCT_STR(name=u'pdn-gw-ipv6-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDN_GW_Identity_pdn_gw_name = OCT_STR(name=u'pdn-gw-name', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    _PDN_GW_Identity_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    PDN_GW_Identity._cont = ASN1Dict([
        (u'pdn-gw-ipv4-Address', _PDN_GW_Identity_pdn_gw_ipv4_Address),
        (u'pdn-gw-ipv6-Address', _PDN_GW_Identity_pdn_gw_ipv6_Address),
        (u'pdn-gw-name', _PDN_GW_Identity_pdn_gw_name),
        (u'extensionContainer', _PDN_GW_Identity_extensionContainer),
        ])
    PDN_GW_Identity._ext = []
    
    #-----< FQDN >-----#
    FQDN = OCT_STR(name=u'FQDN', mode=MODE_TYPE)
    FQDN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=9, ub=255)], ev=None, er=[])
    
    #-----< PDN-GW-AllocationType >-----#
    PDN_GW_AllocationType = ENUM(name=u'PDN-GW-AllocationType', mode=MODE_TYPE)
    PDN_GW_AllocationType._cont = ASN1Dict([(u'static', 0), (u'dynamic', 1)])
    PDN_GW_AllocationType._ext = None
    
    #-----< WLAN-Offloadability >-----#
    WLAN_Offloadability = SEQ(name=u'WLAN-Offloadability', mode=MODE_TYPE)
    _WLAN_Offloadability_wlan_offloadability_EUTRAN = ENUM(name=u'wlan-offloadability-EUTRAN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WLAN-Offloadability-Indication')), opt=True)
    _WLAN_Offloadability_wlan_offloadability_UTRAN = ENUM(name=u'wlan-offloadability-UTRAN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WLAN-Offloadability-Indication')), opt=True)
    _WLAN_Offloadability_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    WLAN_Offloadability._cont = ASN1Dict([
        (u'wlan-offloadability-EUTRAN', _WLAN_Offloadability_wlan_offloadability_EUTRAN),
        (u'wlan-offloadability-UTRAN', _WLAN_Offloadability_wlan_offloadability_UTRAN),
        (u'extensionContainer', _WLAN_Offloadability_extensionContainer),
        ])
    WLAN_Offloadability._ext = []
    
    #-----< WLAN-Offloadability-Indication >-----#
    WLAN_Offloadability_Indication = ENUM(name=u'WLAN-Offloadability-Indication', mode=MODE_TYPE)
    WLAN_Offloadability_Indication._cont = ASN1Dict([(u'notAllowed', 0), (u'allowed', 1)])
    WLAN_Offloadability_Indication._ext = None
    
    #-----< AccessRestrictionData >-----#
    AccessRestrictionData = BIT_STR(name=u'AccessRestrictionData', mode=MODE_TYPE)
    AccessRestrictionData._cont = ASN1Dict([(u'utranNotAllowed', 0), (u'geranNotAllowed', 1), (u'ganNotAllowed', 2), (u'i-hspa-evolutionNotAllowed', 3), (u'wb-e-utranNotAllowed', 4), (u'ho-toNon3GPP-AccessNotAllowed', 5), (u'nb-iotNotAllowed', 6), (u'enhancedCoverageNotAllowed', 7)])
    AccessRestrictionData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< Ext-AccessRestrictionData >-----#
    Ext_AccessRestrictionData = BIT_STR(name=u'Ext-AccessRestrictionData', mode=MODE_TYPE)
    Ext_AccessRestrictionData._cont = ASN1Dict([(u'nrAsSecondaryRATNotAllowed', 0), (u'unlicensedSpectrumAsSecondaryRATNotAllowed', 1)])
    Ext_AccessRestrictionData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AdjacentAccessRestrictionDataList >-----#
    AdjacentAccessRestrictionDataList = SEQ_OF(name=u'AdjacentAccessRestrictionDataList', mode=MODE_TYPE)
    _AdjacentAccessRestrictionDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdjacentAccessRestrictionData')))
    AdjacentAccessRestrictionDataList._cont = _AdjacentAccessRestrictionDataList__item_
    AdjacentAccessRestrictionDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< AdjacentAccessRestrictionData >-----#
    AdjacentAccessRestrictionData = SEQ(name=u'AdjacentAccessRestrictionData', mode=MODE_TYPE)
    _AdjacentAccessRestrictionData_plmnId = OCT_STR(name=u'plmnId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    _AdjacentAccessRestrictionData_accessRestrictionData = BIT_STR(name=u'accessRestrictionData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AccessRestrictionData')))
    _AdjacentAccessRestrictionData_ext_AccessRestrictionData = BIT_STR(name=u'ext-AccessRestrictionData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-AccessRestrictionData')), opt=True)
    AdjacentAccessRestrictionData._cont = ASN1Dict([
        (u'plmnId', _AdjacentAccessRestrictionData_plmnId),
        (u'accessRestrictionData', _AdjacentAccessRestrictionData_accessRestrictionData),
        (u'ext-AccessRestrictionData', _AdjacentAccessRestrictionData_ext_AccessRestrictionData),
        ])
    AdjacentAccessRestrictionData._ext = [u'ext-AccessRestrictionData']
    
    #-----< CS-AllocationRetentionPriority >-----#
    CS_AllocationRetentionPriority = OCT_STR(name=u'CS-AllocationRetentionPriority', mode=MODE_TYPE)
    CS_AllocationRetentionPriority._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< IST-AlertTimerValue >-----#
    IST_AlertTimerValue = INT(name=u'IST-AlertTimerValue', mode=MODE_TYPE)
    IST_AlertTimerValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=15, ub=255)], ev=None, er=[])
    
    #-----< LCSInformation >-----#
    LCSInformation = SEQ(name=u'LCSInformation', mode=MODE_TYPE)
    _LCSInformation_gmlc_List = SEQ_OF(name=u'gmlc-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GMLC-List')), opt=True)
    _LCSInformation_lcs_PrivacyExceptionList = SEQ_OF(name=u'lcs-PrivacyExceptionList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCS-PrivacyExceptionList')), opt=True)
    _LCSInformation_molr_List = SEQ_OF(name=u'molr-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MOLR-List')), opt=True)
    _LCSInformation_add_lcs_PrivacyExceptionList = SEQ_OF(name=u'add-lcs-PrivacyExceptionList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCS-PrivacyExceptionList')), opt=True)
    LCSInformation._cont = ASN1Dict([
        (u'gmlc-List', _LCSInformation_gmlc_List),
        (u'lcs-PrivacyExceptionList', _LCSInformation_lcs_PrivacyExceptionList),
        (u'molr-List', _LCSInformation_molr_List),
        (u'add-lcs-PrivacyExceptionList', _LCSInformation_add_lcs_PrivacyExceptionList),
        ])
    LCSInformation._ext = [u'add-lcs-PrivacyExceptionList']
    
    #-----< GMLC-List >-----#
    GMLC_List = SEQ_OF(name=u'GMLC-List', mode=MODE_TYPE)
    _GMLC_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    GMLC_List._cont = _GMLC_List__item_
    GMLC_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfGMLC >-----#
    maxNumOfGMLC = INT(name=u'maxNumOfGMLC', mode=MODE_VALUE)
    maxNumOfGMLC._val = 5
    
    #-----< NetworkAccessMode >-----#
    NetworkAccessMode = ENUM(name=u'NetworkAccessMode', mode=MODE_TYPE)
    NetworkAccessMode._cont = ASN1Dict([(u'packetAndCircuit', 0), (u'onlyCircuit', 1), (u'onlyPacket', 2)])
    NetworkAccessMode._ext = []
    
    #-----< GPRSDataList >-----#
    GPRSDataList = SEQ_OF(name=u'GPRSDataList', mode=MODE_TYPE)
    _GPRSDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Context')))
    GPRSDataList._cont = _GPRSDataList__item_
    GPRSDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfPDP-Contexts >-----#
    maxNumOfPDP_Contexts = INT(name=u'maxNumOfPDP-Contexts', mode=MODE_VALUE)
    maxNumOfPDP_Contexts._val = 50
    
    #-----< PDP-Context >-----#
    PDP_Context = SEQ(name=u'PDP-Context', mode=MODE_TYPE)
    _PDP_Context_pdp_ContextId = INT(name=u'pdp-ContextId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _PDP_Context_pdp_Type = OCT_STR(name=u'pdp-Type', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Type')))
    _PDP_Context_pdp_Address = OCT_STR(name=u'pdp-Address', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDP_Context_qos_Subscribed = OCT_STR(name=u'qos-Subscribed', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'QoS-Subscribed')))
    _PDP_Context_vplmnAddressAllowed = NULL(name=u'vplmnAddressAllowed', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PDP_Context_apn = OCT_STR(name=u'apn', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')))
    _PDP_Context_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PDP_Context_ext_QoS_Subscribed = OCT_STR(name=u'ext-QoS-Subscribed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_Context_pdp_ChargingCharacteristics = OCT_STR(name=u'pdp-ChargingCharacteristics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _PDP_Context_ext2_QoS_Subscribed = OCT_STR(name=u'ext2-QoS-Subscribed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_Context_ext3_QoS_Subscribed = OCT_STR(name=u'ext3-QoS-Subscribed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_Context_ext4_QoS_Subscribed = OCT_STR(name=u'ext4-QoS-Subscribed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_Context_apn_oi_Replacement = OCT_STR(name=u'apn-oi-Replacement', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    _PDP_Context_ext_pdp_Type = OCT_STR(name=u'ext-pdp-Type', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-PDP-Type')), opt=True)
    _PDP_Context_ext_pdp_Address = OCT_STR(name=u'ext-pdp-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDP_Context_ambr = SEQ(name=u'ambr', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AMBR')), opt=True)
    _PDP_Context_sipto_Permission = ENUM(name=u'sipto-Permission', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Permission')), opt=True)
    _PDP_Context_lipa_Permission = ENUM(name=u'lipa-Permission', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LIPA-Permission')), opt=True)
    _PDP_Context_restoration_Priority = OCT_STR(name=u'restoration-Priority', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Restoration-Priority')), opt=True)
    _PDP_Context_sipto_local_network_Permission = ENUM(name=u'sipto-local-network-Permission', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SIPTO-Local-Network-Permission')), opt=True)
    _PDP_Context_nIDD_Mechanism = ENUM(name=u'nIDD-Mechanism', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NIDD-Mechanism')), opt=True)
    _PDP_Context_sCEF_ID = OCT_STR(name=u'sCEF-ID', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    PDP_Context._cont = ASN1Dict([
        (u'pdp-ContextId', _PDP_Context_pdp_ContextId),
        (u'pdp-Type', _PDP_Context_pdp_Type),
        (u'pdp-Address', _PDP_Context_pdp_Address),
        (u'qos-Subscribed', _PDP_Context_qos_Subscribed),
        (u'vplmnAddressAllowed', _PDP_Context_vplmnAddressAllowed),
        (u'apn', _PDP_Context_apn),
        (u'extensionContainer', _PDP_Context_extensionContainer),
        (u'ext-QoS-Subscribed', _PDP_Context_ext_QoS_Subscribed),
        (u'pdp-ChargingCharacteristics', _PDP_Context_pdp_ChargingCharacteristics),
        (u'ext2-QoS-Subscribed', _PDP_Context_ext2_QoS_Subscribed),
        (u'ext3-QoS-Subscribed', _PDP_Context_ext3_QoS_Subscribed),
        (u'ext4-QoS-Subscribed', _PDP_Context_ext4_QoS_Subscribed),
        (u'apn-oi-Replacement', _PDP_Context_apn_oi_Replacement),
        (u'ext-pdp-Type', _PDP_Context_ext_pdp_Type),
        (u'ext-pdp-Address', _PDP_Context_ext_pdp_Address),
        (u'ambr', _PDP_Context_ambr),
        (u'sipto-Permission', _PDP_Context_sipto_Permission),
        (u'lipa-Permission', _PDP_Context_lipa_Permission),
        (u'restoration-Priority', _PDP_Context_restoration_Priority),
        (u'sipto-local-network-Permission', _PDP_Context_sipto_local_network_Permission),
        (u'nIDD-Mechanism', _PDP_Context_nIDD_Mechanism),
        (u'sCEF-ID', _PDP_Context_sCEF_ID),
        ])
    PDP_Context._ext = [u'ext-QoS-Subscribed', u'pdp-ChargingCharacteristics', u'ext2-QoS-Subscribed', u'ext3-QoS-Subscribed', u'ext4-QoS-Subscribed', u'apn-oi-Replacement', u'ext-pdp-Type', u'ext-pdp-Address', u'ambr', u'sipto-Permission', u'lipa-Permission', u'restoration-Priority', u'sipto-local-network-Permission', u'nIDD-Mechanism', u'sCEF-ID']
    
    #-----< Restoration-Priority >-----#
    Restoration_Priority = OCT_STR(name=u'Restoration-Priority', mode=MODE_TYPE)
    Restoration_Priority._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SIPTO-Permission >-----#
    SIPTO_Permission = ENUM(name=u'SIPTO-Permission', mode=MODE_TYPE)
    SIPTO_Permission._cont = ASN1Dict([(u'siptoAboveRanAllowed', 0), (u'siptoAboveRanNotAllowed', 1)])
    SIPTO_Permission._ext = None
    
    #-----< SIPTO-Local-Network-Permission >-----#
    SIPTO_Local_Network_Permission = ENUM(name=u'SIPTO-Local-Network-Permission', mode=MODE_TYPE)
    SIPTO_Local_Network_Permission._cont = ASN1Dict([(u'siptoAtLocalNetworkAllowed', 0), (u'siptoAtLocalNetworkNotAllowed', 1)])
    SIPTO_Local_Network_Permission._ext = None
    
    #-----< LIPA-Permission >-----#
    LIPA_Permission = ENUM(name=u'LIPA-Permission', mode=MODE_TYPE)
    LIPA_Permission._cont = ASN1Dict([(u'lipaProhibited', 0), (u'lipaOnly', 1), (u'lipaConditional', 2)])
    LIPA_Permission._ext = None
    
    #-----< ContextId >-----#
    ContextId = INT(name=u'ContextId', mode=MODE_TYPE)
    ContextId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< GPRSSubscriptionData >-----#
    GPRSSubscriptionData = SEQ(name=u'GPRSSubscriptionData', mode=MODE_TYPE)
    _GPRSSubscriptionData_completeDataListIncluded = NULL(name=u'completeDataListIncluded', mode=MODE_TYPE, opt=True)
    _GPRSSubscriptionData_gprsDataList = SEQ_OF(name=u'gprsDataList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSDataList')))
    _GPRSSubscriptionData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _GPRSSubscriptionData_apn_oi_Replacement = OCT_STR(name=u'apn-oi-Replacement', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN-OI-Replacement')), opt=True)
    GPRSSubscriptionData._cont = ASN1Dict([
        (u'completeDataListIncluded', _GPRSSubscriptionData_completeDataListIncluded),
        (u'gprsDataList', _GPRSSubscriptionData_gprsDataList),
        (u'extensionContainer', _GPRSSubscriptionData_extensionContainer),
        (u'apn-oi-Replacement', _GPRSSubscriptionData_apn_oi_Replacement),
        ])
    GPRSSubscriptionData._ext = [u'apn-oi-Replacement']
    
    #-----< SGSN-CAMEL-SubscriptionInfo >-----#
    SGSN_CAMEL_SubscriptionInfo = SEQ(name=u'SGSN-CAMEL-SubscriptionInfo', mode=MODE_TYPE)
    _SGSN_CAMEL_SubscriptionInfo_gprs_CSI = SEQ(name=u'gprs-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CSI')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mo_sms_CSI = SEQ(name=u'mo-sms-CSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mt_sms_CSI = SEQ(name=u'mt-sms-CSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList = SEQ_OF(name=u'mt-smsCAMELTDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-CriteriaList')), opt=True)
    _SGSN_CAMEL_SubscriptionInfo_mg_csi = SEQ(name=u'mg-csi', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MG-CSI')), opt=True)
    SGSN_CAMEL_SubscriptionInfo._cont = ASN1Dict([
        (u'gprs-CSI', _SGSN_CAMEL_SubscriptionInfo_gprs_CSI),
        (u'mo-sms-CSI', _SGSN_CAMEL_SubscriptionInfo_mo_sms_CSI),
        (u'extensionContainer', _SGSN_CAMEL_SubscriptionInfo_extensionContainer),
        (u'mt-sms-CSI', _SGSN_CAMEL_SubscriptionInfo_mt_sms_CSI),
        (u'mt-smsCAMELTDP-CriteriaList', _SGSN_CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList),
        (u'mg-csi', _SGSN_CAMEL_SubscriptionInfo_mg_csi),
        ])
    SGSN_CAMEL_SubscriptionInfo._ext = [u'mt-sms-CSI', u'mt-smsCAMELTDP-CriteriaList', u'mg-csi']
    
    #-----< GPRS-CSI >-----#
    GPRS_CSI = SEQ(name=u'GPRS-CSI', mode=MODE_TYPE)
    _GPRS_CSI_gprs_CamelTDPDataList = SEQ_OF(name=u'gprs-CamelTDPDataList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CamelTDPDataList')), opt=True)
    _GPRS_CSI_camelCapabilityHandling = INT(name=u'camelCapabilityHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _GPRS_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _GPRS_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPRS_CSI_csi_Active = NULL(name=u'csi-Active', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    GPRS_CSI._cont = ASN1Dict([
        (u'gprs-CamelTDPDataList', _GPRS_CSI_gprs_CamelTDPDataList),
        (u'camelCapabilityHandling', _GPRS_CSI_camelCapabilityHandling),
        (u'extensionContainer', _GPRS_CSI_extensionContainer),
        (u'notificationToCSE', _GPRS_CSI_notificationToCSE),
        (u'csi-Active', _GPRS_CSI_csi_Active),
        ])
    GPRS_CSI._ext = []
    
    #-----< GPRS-CamelTDPDataList >-----#
    GPRS_CamelTDPDataList = SEQ_OF(name=u'GPRS-CamelTDPDataList', mode=MODE_TYPE)
    _GPRS_CamelTDPDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CamelTDPData')))
    GPRS_CamelTDPDataList._cont = _GPRS_CamelTDPDataList__item_
    GPRS_CamelTDPDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< GPRS-CamelTDPData >-----#
    GPRS_CamelTDPData = SEQ(name=u'GPRS-CamelTDPData', mode=MODE_TYPE)
    _GPRS_CamelTDPData_gprs_TriggerDetectionPoint = ENUM(name=u'gprs-TriggerDetectionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-TriggerDetectionPoint')))
    _GPRS_CamelTDPData_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _GPRS_CamelTDPData_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _GPRS_CamelTDPData_defaultSessionHandling = ENUM(name=u'defaultSessionHandling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultGPRS-Handling')))
    _GPRS_CamelTDPData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    GPRS_CamelTDPData._cont = ASN1Dict([
        (u'gprs-TriggerDetectionPoint', _GPRS_CamelTDPData_gprs_TriggerDetectionPoint),
        (u'serviceKey', _GPRS_CamelTDPData_serviceKey),
        (u'gsmSCF-Address', _GPRS_CamelTDPData_gsmSCF_Address),
        (u'defaultSessionHandling', _GPRS_CamelTDPData_defaultSessionHandling),
        (u'extensionContainer', _GPRS_CamelTDPData_extensionContainer),
        ])
    GPRS_CamelTDPData._ext = []
    
    #-----< DefaultGPRS-Handling >-----#
    DefaultGPRS_Handling = ENUM(name=u'DefaultGPRS-Handling', mode=MODE_TYPE)
    DefaultGPRS_Handling._cont = ASN1Dict([(u'continueTransaction', 0), (u'releaseTransaction', 1)])
    DefaultGPRS_Handling._ext = []
    
    #-----< GPRS-TriggerDetectionPoint >-----#
    GPRS_TriggerDetectionPoint = ENUM(name=u'GPRS-TriggerDetectionPoint', mode=MODE_TYPE)
    GPRS_TriggerDetectionPoint._cont = ASN1Dict([(u'attach', 1), (u'attachChangeOfPosition', 2), (u'pdp-ContextEstablishment', 11), (u'pdp-ContextEstablishmentAcknowledgement', 12), (u'pdp-ContextChangeOfPosition', 14)])
    GPRS_TriggerDetectionPoint._ext = []
    
    #-----< APN >-----#
    APN = OCT_STR(name=u'APN', mode=MODE_TYPE)
    APN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=63)], ev=None, er=[])
    
    #-----< PDP-Type >-----#
    PDP_Type = OCT_STR(name=u'PDP-Type', mode=MODE_TYPE)
    PDP_Type._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< Ext-PDP-Type >-----#
    Ext_PDP_Type = OCT_STR(name=u'Ext-PDP-Type', mode=MODE_TYPE)
    Ext_PDP_Type._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< PDP-Address >-----#
    PDP_Address = OCT_STR(name=u'PDP-Address', mode=MODE_TYPE)
    PDP_Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< QoS-Subscribed >-----#
    QoS_Subscribed = OCT_STR(name=u'QoS-Subscribed', mode=MODE_TYPE)
    QoS_Subscribed._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< Ext-QoS-Subscribed >-----#
    Ext_QoS_Subscribed = OCT_STR(name=u'Ext-QoS-Subscribed', mode=MODE_TYPE)
    Ext_QoS_Subscribed._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< Ext2-QoS-Subscribed >-----#
    Ext2_QoS_Subscribed = OCT_STR(name=u'Ext2-QoS-Subscribed', mode=MODE_TYPE)
    Ext2_QoS_Subscribed._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< Ext3-QoS-Subscribed >-----#
    Ext3_QoS_Subscribed = OCT_STR(name=u'Ext3-QoS-Subscribed', mode=MODE_TYPE)
    Ext3_QoS_Subscribed._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Ext4-QoS-Subscribed >-----#
    Ext4_QoS_Subscribed = OCT_STR(name=u'Ext4-QoS-Subscribed', mode=MODE_TYPE)
    Ext4_QoS_Subscribed._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChargingCharacteristics >-----#
    ChargingCharacteristics = OCT_STR(name=u'ChargingCharacteristics', mode=MODE_TYPE)
    ChargingCharacteristics._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< LSAOnlyAccessIndicator >-----#
    LSAOnlyAccessIndicator = ENUM(name=u'LSAOnlyAccessIndicator', mode=MODE_TYPE)
    LSAOnlyAccessIndicator._cont = ASN1Dict([(u'accessOutsideLSAsAllowed', 0), (u'accessOutsideLSAsRestricted', 1)])
    LSAOnlyAccessIndicator._ext = None
    
    #-----< LSADataList >-----#
    LSADataList = SEQ_OF(name=u'LSADataList', mode=MODE_TYPE)
    _LSADataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAData')))
    LSADataList._cont = _LSADataList__item_
    LSADataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxNumOfLSAs >-----#
    maxNumOfLSAs = INT(name=u'maxNumOfLSAs', mode=MODE_VALUE)
    maxNumOfLSAs._val = 20
    
    #-----< LSAData >-----#
    LSAData = SEQ(name=u'LSAData', mode=MODE_TYPE)
    _LSAData_lsaIdentity = OCT_STR(name=u'lsaIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')))
    _LSAData_lsaAttributes = OCT_STR(name=u'lsaAttributes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAAttributes')))
    _LSAData_lsaActiveModeIndicator = NULL(name=u'lsaActiveModeIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LSAData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    LSAData._cont = ASN1Dict([
        (u'lsaIdentity', _LSAData_lsaIdentity),
        (u'lsaAttributes', _LSAData_lsaAttributes),
        (u'lsaActiveModeIndicator', _LSAData_lsaActiveModeIndicator),
        (u'extensionContainer', _LSAData_extensionContainer),
        ])
    LSAData._ext = []
    
    #-----< LSAInformation >-----#
    LSAInformation = SEQ(name=u'LSAInformation', mode=MODE_TYPE)
    _LSAInformation_completeDataListIncluded = NULL(name=u'completeDataListIncluded', mode=MODE_TYPE, opt=True)
    _LSAInformation_lsaOnlyAccessIndicator = ENUM(name=u'lsaOnlyAccessIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAOnlyAccessIndicator')), opt=True)
    _LSAInformation_lsaDataList = SEQ_OF(name=u'lsaDataList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSADataList')), opt=True)
    _LSAInformation_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    LSAInformation._cont = ASN1Dict([
        (u'completeDataListIncluded', _LSAInformation_completeDataListIncluded),
        (u'lsaOnlyAccessIndicator', _LSAInformation_lsaOnlyAccessIndicator),
        (u'lsaDataList', _LSAInformation_lsaDataList),
        (u'extensionContainer', _LSAInformation_extensionContainer),
        ])
    LSAInformation._ext = []
    
    #-----< LSAIdentity >-----#
    LSAIdentity = OCT_STR(name=u'LSAIdentity', mode=MODE_TYPE)
    LSAIdentity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< LSAAttributes >-----#
    LSAAttributes = OCT_STR(name=u'LSAAttributes', mode=MODE_TYPE)
    LSAAttributes._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SubscriberData >-----#
    SubscriberData = SEQ(name=u'SubscriberData', mode=MODE_TYPE)
    _SubscriberData_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SubscriberData_category = OCT_STR(name=u'category', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Category')), opt=True)
    _SubscriberData_subscriberStatus = ENUM(name=u'subscriberStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberStatus')), opt=True)
    _SubscriberData_bearerServiceList = SEQ_OF(name=u'bearerServiceList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BearerServiceList')), opt=True)
    _SubscriberData_teleserviceList = SEQ_OF(name=u'teleserviceList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TeleserviceList')), opt=True)
    _SubscriberData_provisionedSS = SEQ_OF(name=u'provisionedSS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-InfoList')), opt=True)
    _SubscriberData_odb_Data = SEQ(name=u'odb-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')), opt=True)
    _SubscriberData_roamingRestrictionDueToUnsupportedFeature = NULL(name=u'roamingRestrictionDueToUnsupportedFeature', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SubscriberData_regionalSubscriptionData = SEQ_OF(name=u'regionalSubscriptionData', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCodeList')), opt=True)
    _SubscriberData_vbsSubscriptionData = SEQ_OF(name=u'vbsSubscriptionData', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VBSDataList')), opt=True)
    _SubscriberData_vgcsSubscriptionData = SEQ_OF(name=u'vgcsSubscriptionData', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VGCSDataList')), opt=True)
    _SubscriberData_vlrCamelSubscriptionInfo = SEQ(name=u'vlrCamelSubscriptionInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VlrCamelSubscriptionInfo')), opt=True)
    SubscriberData._cont = ASN1Dict([
        (u'msisdn', _SubscriberData_msisdn),
        (u'category', _SubscriberData_category),
        (u'subscriberStatus', _SubscriberData_subscriberStatus),
        (u'bearerServiceList', _SubscriberData_bearerServiceList),
        (u'teleserviceList', _SubscriberData_teleserviceList),
        (u'provisionedSS', _SubscriberData_provisionedSS),
        (u'odb-Data', _SubscriberData_odb_Data),
        (u'roamingRestrictionDueToUnsupportedFeature', _SubscriberData_roamingRestrictionDueToUnsupportedFeature),
        (u'regionalSubscriptionData', _SubscriberData_regionalSubscriptionData),
        (u'vbsSubscriptionData', _SubscriberData_vbsSubscriptionData),
        (u'vgcsSubscriptionData', _SubscriberData_vgcsSubscriptionData),
        (u'vlrCamelSubscriptionInfo', _SubscriberData_vlrCamelSubscriptionInfo),
        ])
    SubscriberData._ext = None
    
    #-----< Category >-----#
    Category = OCT_STR(name=u'Category', mode=MODE_TYPE)
    Category._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< SubscriberStatus >-----#
    SubscriberStatus = ENUM(name=u'SubscriberStatus', mode=MODE_TYPE)
    SubscriberStatus._cont = ASN1Dict([(u'serviceGranted', 0), (u'operatorDeterminedBarring', 1)])
    SubscriberStatus._ext = None
    
    #-----< BearerServiceList >-----#
    BearerServiceList = SEQ_OF(name=u'BearerServiceList', mode=MODE_TYPE)
    _BearerServiceList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-BS-Code', 'Ext-BearerServiceCode')))
    BearerServiceList._cont = _BearerServiceList__item_
    BearerServiceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfBearerServices >-----#
    maxNumOfBearerServices = INT(name=u'maxNumOfBearerServices', mode=MODE_VALUE)
    maxNumOfBearerServices._val = 50
    
    #-----< TeleserviceList >-----#
    TeleserviceList = SEQ_OF(name=u'TeleserviceList', mode=MODE_TYPE)
    _TeleserviceList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-TS-Code', 'Ext-TeleserviceCode')))
    TeleserviceList._cont = _TeleserviceList__item_
    TeleserviceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< maxNumOfTeleservices >-----#
    maxNumOfTeleservices = INT(name=u'maxNumOfTeleservices', mode=MODE_VALUE)
    maxNumOfTeleservices._val = 20
    
    #-----< ODB-Data >-----#
    ODB_Data = SEQ(name=u'ODB-Data', mode=MODE_TYPE)
    _ODB_Data_odb_GeneralData = BIT_STR(name=u'odb-GeneralData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-GeneralData')))
    _ODB_Data_odb_HPLMN_Data = BIT_STR(name=u'odb-HPLMN-Data', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-HPLMN-Data')), opt=True)
    _ODB_Data_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ODB_Data._cont = ASN1Dict([
        (u'odb-GeneralData', _ODB_Data_odb_GeneralData),
        (u'odb-HPLMN-Data', _ODB_Data_odb_HPLMN_Data),
        (u'extensionContainer', _ODB_Data_extensionContainer),
        ])
    ODB_Data._ext = []
    
    #-----< ODB-GeneralData >-----#
    ODB_GeneralData = BIT_STR(name=u'ODB-GeneralData', mode=MODE_TYPE)
    ODB_GeneralData._cont = ASN1Dict([(u'allOG-CallsBarred', 0), (u'internationalOGCallsBarred', 1), (u'internationalOGCallsNotToHPLMN-CountryBarred', 2), (u'interzonalOGCallsBarred', 6), (u'interzonalOGCallsNotToHPLMN-CountryBarred', 7), (u'interzonalOGCallsAndInternationalOGCallsNotToHPLMN-CountryBarred', 8), (u'premiumRateInformationOGCallsBarred', 3), (u'premiumRateEntertainementOGCallsBarred', 4), (u'ss-AccessBarred', 5), (u'allECT-Barred', 9), (u'chargeableECT-Barred', 10), (u'internationalECT-Barred', 11), (u'interzonalECT-Barred', 12), (u'doublyChargeableECT-Barred', 13), (u'multipleECT-Barred', 14), (u'allPacketOrientedServicesBarred', 15), (u'roamerAccessToHPLMN-AP-Barred', 16), (u'roamerAccessToVPLMN-AP-Barred', 17), (u'roamingOutsidePLMNOG-CallsBarred', 18), (u'allIC-CallsBarred', 19), (u'roamingOutsidePLMNIC-CallsBarred', 20), (u'roamingOutsidePLMNICountryIC-CallsBarred', 21), (u'roamingOutsidePLMN-Barred', 22), (u'roamingOutsidePLMN-CountryBarred', 23), (u'registrationAllCF-Barred', 24), (u'registrationCFNotToHPLMN-Barred', 25), (u'registrationInterzonalCF-Barred', 26), (u'registrationInterzonalCFNotToHPLMN-Barred', 27), (u'registrationInternationalCF-Barred', 28)])
    ODB_GeneralData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=15, ub=32)], ev=None, er=[])
    
    #-----< ODB-HPLMN-Data >-----#
    ODB_HPLMN_Data = BIT_STR(name=u'ODB-HPLMN-Data', mode=MODE_TYPE)
    ODB_HPLMN_Data._cont = ASN1Dict([(u'plmn-SpecificBarringType1', 0), (u'plmn-SpecificBarringType2', 1), (u'plmn-SpecificBarringType3', 2), (u'plmn-SpecificBarringType4', 3)])
    ODB_HPLMN_Data._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=32)], ev=None, er=[])
    
    #-----< Ext-SS-InfoList >-----#
    Ext_SS_InfoList = SEQ_OF(name=u'Ext-SS-InfoList', mode=MODE_TYPE)
    _Ext_SS_InfoList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-Info')))
    Ext_SS_InfoList._cont = _Ext_SS_InfoList__item_
    Ext_SS_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    
    #-----< Ext-SS-Info >-----#
    Ext_SS_Info = CHOICE(name=u'Ext-SS-Info', mode=MODE_TYPE)
    _Ext_SS_Info_forwardingInfo = SEQ(name=u'forwardingInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwInfo')))
    _Ext_SS_Info_callBarringInfo = SEQ(name=u'callBarringInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarInfo')))
    _Ext_SS_Info_cug_Info = SEQ(name=u'cug-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Info')))
    _Ext_SS_Info_ss_Data = SEQ(name=u'ss-Data', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-Data')))
    _Ext_SS_Info_emlpp_Info = SEQ(name=u'emlpp-Info', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Info')))
    Ext_SS_Info._cont = ASN1Dict([
        (u'forwardingInfo', _Ext_SS_Info_forwardingInfo),
        (u'callBarringInfo', _Ext_SS_Info_callBarringInfo),
        (u'cug-Info', _Ext_SS_Info_cug_Info),
        (u'ss-Data', _Ext_SS_Info_ss_Data),
        (u'emlpp-Info', _Ext_SS_Info_emlpp_Info),
        ])
    Ext_SS_Info._ext = None
    
    #-----< Ext-ForwInfo >-----#
    Ext_ForwInfo = SEQ(name=u'Ext-ForwInfo', mode=MODE_TYPE)
    _Ext_ForwInfo_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_ForwInfo_forwardingFeatureList = SEQ_OF(name=u'forwardingFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeatureList')))
    _Ext_ForwInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_ForwInfo._cont = ASN1Dict([
        (u'ss-Code', _Ext_ForwInfo_ss_Code),
        (u'forwardingFeatureList', _Ext_ForwInfo_forwardingFeatureList),
        (u'extensionContainer', _Ext_ForwInfo_extensionContainer),
        ])
    Ext_ForwInfo._ext = []
    
    #-----< Ext-ForwFeatureList >-----#
    Ext_ForwFeatureList = SEQ_OF(name=u'Ext-ForwFeatureList', mode=MODE_TYPE)
    _Ext_ForwFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeature')))
    Ext_ForwFeatureList._cont = _Ext_ForwFeatureList__item_
    Ext_ForwFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-ForwFeature >-----#
    Ext_ForwFeature = SEQ(name=u'Ext-ForwFeature', mode=MODE_TYPE)
    _Ext_ForwFeature_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _Ext_ForwFeature_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _Ext_ForwFeature_forwardedToNumber = OCT_STR(name=u'forwardedToNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _Ext_ForwFeature_forwardedToSubaddress = OCT_STR(name=u'forwardedToSubaddress', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _Ext_ForwFeature_forwardingOptions = OCT_STR(name=u'forwardingOptions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwOptions')), opt=True)
    _Ext_ForwFeature_noReplyConditionTime = INT(name=u'noReplyConditionTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-NoRepCondTime')), opt=True)
    _Ext_ForwFeature_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _Ext_ForwFeature_longForwardedToNumber = OCT_STR(name=u'longForwardedToNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'FTN-AddressString')), opt=True)
    Ext_ForwFeature._cont = ASN1Dict([
        (u'basicService', _Ext_ForwFeature_basicService),
        (u'ss-Status', _Ext_ForwFeature_ss_Status),
        (u'forwardedToNumber', _Ext_ForwFeature_forwardedToNumber),
        (u'forwardedToSubaddress', _Ext_ForwFeature_forwardedToSubaddress),
        (u'forwardingOptions', _Ext_ForwFeature_forwardingOptions),
        (u'noReplyConditionTime', _Ext_ForwFeature_noReplyConditionTime),
        (u'extensionContainer', _Ext_ForwFeature_extensionContainer),
        (u'longForwardedToNumber', _Ext_ForwFeature_longForwardedToNumber),
        ])
    Ext_ForwFeature._ext = [u'longForwardedToNumber']
    
    #-----< Ext-ForwOptions >-----#
    Ext_ForwOptions = OCT_STR(name=u'Ext-ForwOptions', mode=MODE_TYPE)
    Ext_ForwOptions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< Ext-NoRepCondTime >-----#
    Ext_NoRepCondTime = INT(name=u'Ext-NoRepCondTime', mode=MODE_TYPE)
    Ext_NoRepCondTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    
    #-----< Ext-CallBarInfo >-----#
    Ext_CallBarInfo = SEQ(name=u'Ext-CallBarInfo', mode=MODE_TYPE)
    _Ext_CallBarInfo_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_CallBarInfo_callBarringFeatureList = SEQ_OF(name=u'callBarringFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarFeatureList')))
    _Ext_CallBarInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_CallBarInfo._cont = ASN1Dict([
        (u'ss-Code', _Ext_CallBarInfo_ss_Code),
        (u'callBarringFeatureList', _Ext_CallBarInfo_callBarringFeatureList),
        (u'extensionContainer', _Ext_CallBarInfo_extensionContainer),
        ])
    Ext_CallBarInfo._ext = []
    
    #-----< Ext-CallBarFeatureList >-----#
    Ext_CallBarFeatureList = SEQ_OF(name=u'Ext-CallBarFeatureList', mode=MODE_TYPE)
    _Ext_CallBarFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarringFeature')))
    Ext_CallBarFeatureList._cont = _Ext_CallBarFeatureList__item_
    Ext_CallBarFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-CallBarringFeature >-----#
    Ext_CallBarringFeature = SEQ(name=u'Ext-CallBarringFeature', mode=MODE_TYPE)
    _Ext_CallBarringFeature_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _Ext_CallBarringFeature_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _Ext_CallBarringFeature_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_CallBarringFeature._cont = ASN1Dict([
        (u'basicService', _Ext_CallBarringFeature_basicService),
        (u'ss-Status', _Ext_CallBarringFeature_ss_Status),
        (u'extensionContainer', _Ext_CallBarringFeature_extensionContainer),
        ])
    Ext_CallBarringFeature._ext = []
    
    #-----< CUG-Info >-----#
    CUG_Info = SEQ(name=u'CUG-Info', mode=MODE_TYPE)
    _CUG_Info_cug_SubscriptionList = SEQ_OF(name=u'cug-SubscriptionList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-SubscriptionList')))
    _CUG_Info_cug_FeatureList = SEQ_OF(name=u'cug-FeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-FeatureList')), opt=True)
    _CUG_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_Info._cont = ASN1Dict([
        (u'cug-SubscriptionList', _CUG_Info_cug_SubscriptionList),
        (u'cug-FeatureList', _CUG_Info_cug_FeatureList),
        (u'extensionContainer', _CUG_Info_extensionContainer),
        ])
    CUG_Info._ext = []
    
    #-----< CUG-SubscriptionList >-----#
    CUG_SubscriptionList = SEQ_OF(name=u'CUG-SubscriptionList', mode=MODE_TYPE)
    _CUG_SubscriptionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Subscription')))
    CUG_SubscriptionList._cont = _CUG_SubscriptionList__item_
    CUG_SubscriptionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< CUG-Subscription >-----#
    CUG_Subscription = SEQ(name=u'CUG-Subscription', mode=MODE_TYPE)
    _CUG_Subscription_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')))
    _CUG_Subscription_cug_Interlock = OCT_STR(name=u'cug-Interlock', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Interlock')))
    _CUG_Subscription_intraCUG_Options = ENUM(name=u'intraCUG-Options', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'IntraCUG-Options')))
    _CUG_Subscription_basicServiceGroupList = SEQ_OF(name=u'basicServiceGroupList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-BasicServiceGroupList')), opt=True)
    _CUG_Subscription_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_Subscription._cont = ASN1Dict([
        (u'cug-Index', _CUG_Subscription_cug_Index),
        (u'cug-Interlock', _CUG_Subscription_cug_Interlock),
        (u'intraCUG-Options', _CUG_Subscription_intraCUG_Options),
        (u'basicServiceGroupList', _CUG_Subscription_basicServiceGroupList),
        (u'extensionContainer', _CUG_Subscription_extensionContainer),
        ])
    CUG_Subscription._ext = []
    
    #-----< CUG-Index >-----#
    CUG_Index = INT(name=u'CUG-Index', mode=MODE_TYPE)
    CUG_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    #-----< CUG-Interlock >-----#
    CUG_Interlock = OCT_STR(name=u'CUG-Interlock', mode=MODE_TYPE)
    CUG_Interlock._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< IntraCUG-Options >-----#
    IntraCUG_Options = ENUM(name=u'IntraCUG-Options', mode=MODE_TYPE)
    IntraCUG_Options._cont = ASN1Dict([(u'noCUG-Restrictions', 0), (u'cugIC-CallBarred', 1), (u'cugOG-CallBarred', 2)])
    IntraCUG_Options._ext = None
    
    #-----< maxNumOfCUG >-----#
    maxNumOfCUG = INT(name=u'maxNumOfCUG', mode=MODE_VALUE)
    maxNumOfCUG._val = 10
    
    #-----< CUG-FeatureList >-----#
    CUG_FeatureList = SEQ_OF(name=u'CUG-FeatureList', mode=MODE_TYPE)
    _CUG_FeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Feature')))
    CUG_FeatureList._cont = _CUG_FeatureList__item_
    CUG_FeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-BasicServiceGroupList >-----#
    Ext_BasicServiceGroupList = SEQ_OF(name=u'Ext-BasicServiceGroupList', mode=MODE_TYPE)
    _Ext_BasicServiceGroupList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    Ext_BasicServiceGroupList._cont = _Ext_BasicServiceGroupList__item_
    Ext_BasicServiceGroupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< maxNumOfExt-BasicServiceGroups >-----#
    maxNumOfExt_BasicServiceGroups = INT(name=u'maxNumOfExt-BasicServiceGroups', mode=MODE_VALUE)
    maxNumOfExt_BasicServiceGroups._val = 32
    
    #-----< CUG-Feature >-----#
    CUG_Feature = SEQ(name=u'CUG-Feature', mode=MODE_TYPE)
    _CUG_Feature_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _CUG_Feature_preferentialCUG_Indicator = INT(name=u'preferentialCUG-Indicator', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _CUG_Feature_interCUG_Restrictions = OCT_STR(name=u'interCUG-Restrictions', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'InterCUG-Restrictions')))
    _CUG_Feature_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CUG_Feature._cont = ASN1Dict([
        (u'basicService', _CUG_Feature_basicService),
        (u'preferentialCUG-Indicator', _CUG_Feature_preferentialCUG_Indicator),
        (u'interCUG-Restrictions', _CUG_Feature_interCUG_Restrictions),
        (u'extensionContainer', _CUG_Feature_extensionContainer),
        ])
    CUG_Feature._ext = []
    
    #-----< InterCUG-Restrictions >-----#
    InterCUG_Restrictions = OCT_STR(name=u'InterCUG-Restrictions', mode=MODE_TYPE)
    InterCUG_Restrictions._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Ext-SS-Data >-----#
    Ext_SS_Data = SEQ(name=u'Ext-SS-Data', mode=MODE_TYPE)
    _Ext_SS_Data_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_SS_Data_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _Ext_SS_Data_ss_SubscriptionOption = CHOICE(name=u'ss-SubscriptionOption', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-SubscriptionOption')), opt=True)
    _Ext_SS_Data_basicServiceGroupList = SEQ_OF(name=u'basicServiceGroupList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-BasicServiceGroupList')), opt=True)
    _Ext_SS_Data_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_SS_Data._cont = ASN1Dict([
        (u'ss-Code', _Ext_SS_Data_ss_Code),
        (u'ss-Status', _Ext_SS_Data_ss_Status),
        (u'ss-SubscriptionOption', _Ext_SS_Data_ss_SubscriptionOption),
        (u'basicServiceGroupList', _Ext_SS_Data_basicServiceGroupList),
        (u'extensionContainer', _Ext_SS_Data_extensionContainer),
        ])
    Ext_SS_Data._ext = []
    
    #-----< LCS-PrivacyExceptionList >-----#
    LCS_PrivacyExceptionList = SEQ_OF(name=u'LCS-PrivacyExceptionList', mode=MODE_TYPE)
    _LCS_PrivacyExceptionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LCS-PrivacyClass')))
    LCS_PrivacyExceptionList._cont = _LCS_PrivacyExceptionList__item_
    LCS_PrivacyExceptionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< maxNumOfPrivacyClass >-----#
    maxNumOfPrivacyClass = INT(name=u'maxNumOfPrivacyClass', mode=MODE_VALUE)
    maxNumOfPrivacyClass._val = 4
    
    #-----< LCS-PrivacyClass >-----#
    LCS_PrivacyClass = SEQ(name=u'LCS-PrivacyClass', mode=MODE_TYPE)
    _LCS_PrivacyClass_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _LCS_PrivacyClass_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _LCS_PrivacyClass_notificationToMSUser = ENUM(name=u'notificationToMSUser', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _LCS_PrivacyClass_externalClientList = SEQ_OF(name=u'externalClientList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ExternalClientList')), opt=True)
    _LCS_PrivacyClass_plmnClientList = SEQ_OF(name=u'plmnClientList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PLMNClientList')), opt=True)
    _LCS_PrivacyClass_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LCS_PrivacyClass_ext_externalClientList = SEQ_OF(name=u'ext-externalClientList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ExternalClientList')), opt=True)
    _LCS_PrivacyClass_serviceTypeList = SEQ_OF(name=u'serviceTypeList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceTypeList')), opt=True)
    LCS_PrivacyClass._cont = ASN1Dict([
        (u'ss-Code', _LCS_PrivacyClass_ss_Code),
        (u'ss-Status', _LCS_PrivacyClass_ss_Status),
        (u'notificationToMSUser', _LCS_PrivacyClass_notificationToMSUser),
        (u'externalClientList', _LCS_PrivacyClass_externalClientList),
        (u'plmnClientList', _LCS_PrivacyClass_plmnClientList),
        (u'extensionContainer', _LCS_PrivacyClass_extensionContainer),
        (u'ext-externalClientList', _LCS_PrivacyClass_ext_externalClientList),
        (u'serviceTypeList', _LCS_PrivacyClass_serviceTypeList),
        ])
    LCS_PrivacyClass._ext = [u'ext-externalClientList', u'serviceTypeList']
    
    #-----< ExternalClientList >-----#
    ExternalClientList = SEQ_OF(name=u'ExternalClientList', mode=MODE_TYPE)
    _ExternalClientList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ExternalClient')))
    ExternalClientList._cont = _ExternalClientList__item_
    ExternalClientList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfExternalClient >-----#
    maxNumOfExternalClient = INT(name=u'maxNumOfExternalClient', mode=MODE_VALUE)
    maxNumOfExternalClient._val = 5
    
    #-----< PLMNClientList >-----#
    PLMNClientList = SEQ_OF(name=u'PLMNClientList', mode=MODE_TYPE)
    _PLMNClientList__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientInternalID')))
    PLMNClientList._cont = _PLMNClientList__item_
    PLMNClientList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfPLMNClient >-----#
    maxNumOfPLMNClient = INT(name=u'maxNumOfPLMNClient', mode=MODE_VALUE)
    maxNumOfPLMNClient._val = 5
    
    #-----< Ext-ExternalClientList >-----#
    Ext_ExternalClientList = SEQ_OF(name=u'Ext-ExternalClientList', mode=MODE_TYPE)
    _Ext_ExternalClientList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ExternalClient')))
    Ext_ExternalClientList._cont = _Ext_ExternalClientList__item_
    Ext_ExternalClientList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=35)], ev=None, er=[])
    
    #-----< maxNumOfExt-ExternalClient >-----#
    maxNumOfExt_ExternalClient = INT(name=u'maxNumOfExt-ExternalClient', mode=MODE_VALUE)
    maxNumOfExt_ExternalClient._val = 35
    
    #-----< ExternalClient >-----#
    ExternalClient = SEQ(name=u'ExternalClient', mode=MODE_TYPE)
    _ExternalClient_clientIdentity = SEQ(name=u'clientIdentity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientExternalID')))
    _ExternalClient_gmlc_Restriction = ENUM(name=u'gmlc-Restriction', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GMLC-Restriction')), opt=True)
    _ExternalClient_notificationToMSUser = ENUM(name=u'notificationToMSUser', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _ExternalClient_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ExternalClient._cont = ASN1Dict([
        (u'clientIdentity', _ExternalClient_clientIdentity),
        (u'gmlc-Restriction', _ExternalClient_gmlc_Restriction),
        (u'notificationToMSUser', _ExternalClient_notificationToMSUser),
        (u'extensionContainer', _ExternalClient_extensionContainer),
        ])
    ExternalClient._ext = []
    
    #-----< GMLC-Restriction >-----#
    GMLC_Restriction = ENUM(name=u'GMLC-Restriction', mode=MODE_TYPE)
    GMLC_Restriction._cont = ASN1Dict([(u'gmlc-List', 0), (u'home-Country', 1)])
    GMLC_Restriction._ext = []
    
    #-----< NotificationToMSUser >-----#
    NotificationToMSUser = ENUM(name=u'NotificationToMSUser', mode=MODE_TYPE)
    NotificationToMSUser._cont = ASN1Dict([(u'notifyLocationAllowed', 0), (u'notifyAndVerify-LocationAllowedIfNoResponse', 1), (u'notifyAndVerify-LocationNotAllowedIfNoResponse', 2), (u'locationNotAllowed', 3)])
    NotificationToMSUser._ext = [u'locationNotAllowed']
    
    #-----< ServiceTypeList >-----#
    ServiceTypeList = SEQ_OF(name=u'ServiceTypeList', mode=MODE_TYPE)
    _ServiceTypeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceType')))
    ServiceTypeList._cont = _ServiceTypeList__item_
    ServiceTypeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< maxNumOfServiceType >-----#
    maxNumOfServiceType = INT(name=u'maxNumOfServiceType', mode=MODE_VALUE)
    maxNumOfServiceType._val = 32
    
    #-----< ServiceType >-----#
    ServiceType = SEQ(name=u'ServiceType', mode=MODE_TYPE)
    _ServiceType_serviceTypeIdentity = INT(name=u'serviceTypeIdentity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')))
    _ServiceType_gmlc_Restriction = ENUM(name=u'gmlc-Restriction', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GMLC-Restriction')), opt=True)
    _ServiceType_notificationToMSUser = ENUM(name=u'notificationToMSUser', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')), opt=True)
    _ServiceType_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ServiceType._cont = ASN1Dict([
        (u'serviceTypeIdentity', _ServiceType_serviceTypeIdentity),
        (u'gmlc-Restriction', _ServiceType_gmlc_Restriction),
        (u'notificationToMSUser', _ServiceType_notificationToMSUser),
        (u'extensionContainer', _ServiceType_extensionContainer),
        ])
    ServiceType._ext = []
    
    #-----< MOLR-List >-----#
    MOLR_List = SEQ_OF(name=u'MOLR-List', mode=MODE_TYPE)
    _MOLR_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MOLR-Class')))
    MOLR_List._cont = _MOLR_List__item_
    MOLR_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< maxNumOfMOLR-Class >-----#
    maxNumOfMOLR_Class = INT(name=u'maxNumOfMOLR-Class', mode=MODE_VALUE)
    maxNumOfMOLR_Class._val = 3
    
    #-----< MOLR-Class >-----#
    MOLR_Class = SEQ(name=u'MOLR-Class', mode=MODE_TYPE)
    _MOLR_Class_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _MOLR_Class_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _MOLR_Class_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MOLR_Class._cont = ASN1Dict([
        (u'ss-Code', _MOLR_Class_ss_Code),
        (u'ss-Status', _MOLR_Class_ss_Status),
        (u'extensionContainer', _MOLR_Class_extensionContainer),
        ])
    MOLR_Class._ext = []
    
    #-----< ZoneCodeList >-----#
    ZoneCodeList = SEQ_OF(name=u'ZoneCodeList', mode=MODE_TYPE)
    _ZoneCodeList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCode')))
    ZoneCodeList._cont = _ZoneCodeList__item_
    ZoneCodeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< ZoneCode >-----#
    ZoneCode = OCT_STR(name=u'ZoneCode', mode=MODE_TYPE)
    ZoneCode._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< maxNumOfZoneCodes >-----#
    maxNumOfZoneCodes = INT(name=u'maxNumOfZoneCodes', mode=MODE_VALUE)
    maxNumOfZoneCodes._val = 10
    
    #-----< InsertSubscriberDataRes >-----#
    InsertSubscriberDataRes = SEQ(name=u'InsertSubscriberDataRes', mode=MODE_TYPE)
    _InsertSubscriberDataRes_teleserviceList = SEQ_OF(name=u'teleserviceList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TeleserviceList')), opt=True)
    _InsertSubscriberDataRes_bearerServiceList = SEQ_OF(name=u'bearerServiceList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BearerServiceList')), opt=True)
    _InsertSubscriberDataRes_ss_List = SEQ_OF(name=u'ss-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _InsertSubscriberDataRes_odb_GeneralData = BIT_STR(name=u'odb-GeneralData', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-GeneralData')), opt=True)
    _InsertSubscriberDataRes_regionalSubscriptionResponse = ENUM(name=u'regionalSubscriptionResponse', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RegionalSubscriptionResponse')), opt=True)
    _InsertSubscriberDataRes_supportedCamelPhases = BIT_STR(name=u'supportedCamelPhases', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _InsertSubscriberDataRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _InsertSubscriberDataRes_offeredCamel4CSIs = BIT_STR(name=u'offeredCamel4CSIs', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _InsertSubscriberDataRes_supportedFeatures = BIT_STR(name=u'supportedFeatures', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedFeatures')), opt=True)
    _InsertSubscriberDataRes_ext_SupportedFeatures = BIT_STR(name=u'ext-SupportedFeatures', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SupportedFeatures')), opt=True)
    InsertSubscriberDataRes._cont = ASN1Dict([
        (u'teleserviceList', _InsertSubscriberDataRes_teleserviceList),
        (u'bearerServiceList', _InsertSubscriberDataRes_bearerServiceList),
        (u'ss-List', _InsertSubscriberDataRes_ss_List),
        (u'odb-GeneralData', _InsertSubscriberDataRes_odb_GeneralData),
        (u'regionalSubscriptionResponse', _InsertSubscriberDataRes_regionalSubscriptionResponse),
        (u'supportedCamelPhases', _InsertSubscriberDataRes_supportedCamelPhases),
        (u'extensionContainer', _InsertSubscriberDataRes_extensionContainer),
        (u'offeredCamel4CSIs', _InsertSubscriberDataRes_offeredCamel4CSIs),
        (u'supportedFeatures', _InsertSubscriberDataRes_supportedFeatures),
        (u'ext-SupportedFeatures', _InsertSubscriberDataRes_ext_SupportedFeatures),
        ])
    InsertSubscriberDataRes._ext = [u'offeredCamel4CSIs', u'supportedFeatures', u'ext-SupportedFeatures']
    
    #-----< RegionalSubscriptionResponse >-----#
    RegionalSubscriptionResponse = ENUM(name=u'RegionalSubscriptionResponse', mode=MODE_TYPE)
    RegionalSubscriptionResponse._cont = ASN1Dict([(u'networkNode-AreaRestricted', 0), (u'tooManyZoneCodes', 1), (u'zoneCodesConflict', 2), (u'regionalSubscNotSupported', 3)])
    RegionalSubscriptionResponse._ext = None
    
    #-----< DeleteSubscriberDataArg >-----#
    DeleteSubscriberDataArg = SEQ(name=u'DeleteSubscriberDataArg', mode=MODE_TYPE)
    _DeleteSubscriberDataArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _DeleteSubscriberDataArg_basicServiceList = SEQ_OF(name=u'basicServiceList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceList')), opt=True)
    _DeleteSubscriberDataArg_ss_List = SEQ_OF(name=u'ss-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-List')), opt=True)
    _DeleteSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature = NULL(name=u'roamingRestrictionDueToUnsupportedFeature', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_regionalSubscriptionIdentifier = OCT_STR(name=u'regionalSubscriptionIdentifier', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ZoneCode')), opt=True)
    _DeleteSubscriberDataArg_vbsGroupIndication = NULL(name=u'vbsGroupIndication', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_vgcsGroupIndication = NULL(name=u'vgcsGroupIndication', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_camelSubscriptionInfoWithdraw = NULL(name=u'camelSubscriptionInfoWithdraw', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _DeleteSubscriberDataArg_gprsSubscriptionDataWithdraw = CHOICE(name=u'gprsSubscriptionDataWithdraw', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSSubscriptionDataWithdraw')), opt=True)
    _DeleteSubscriberDataArg_roamingRestrictedInSgsnDueToUnsuppportedFeature = NULL(name=u'roamingRestrictedInSgsnDueToUnsuppportedFeature', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_lsaInformationWithdraw = CHOICE(name=u'lsaInformationWithdraw', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAInformationWithdraw')), opt=True)
    _DeleteSubscriberDataArg_gmlc_ListWithdraw = NULL(name=u'gmlc-ListWithdraw', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_istInformationWithdraw = NULL(name=u'istInformationWithdraw', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_specificCSI_Withdraw = BIT_STR(name=u'specificCSI-Withdraw', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificCSI-Withdraw')), opt=True)
    _DeleteSubscriberDataArg_chargingCharacteristicsWithdraw = NULL(name=u'chargingCharacteristicsWithdraw', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_stn_srWithdraw = NULL(name=u'stn-srWithdraw', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_epsSubscriptionDataWithdraw = CHOICE(name=u'epsSubscriptionDataWithdraw', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EPS-SubscriptionDataWithdraw')), opt=True)
    _DeleteSubscriberDataArg_apn_oi_replacementWithdraw = NULL(name=u'apn-oi-replacementWithdraw', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_csg_SubscriptionDeleted = NULL(name=u'csg-SubscriptionDeleted', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_subscribedPeriodicTAU_RAU_TimerWithdraw = NULL(name=u'subscribedPeriodicTAU-RAU-TimerWithdraw', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_subscribedPeriodicLAU_TimerWithdraw = NULL(name=u'subscribedPeriodicLAU-TimerWithdraw', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_subscribed_vsrvccWithdraw = NULL(name=u'subscribed-vsrvccWithdraw', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_vplmn_Csg_SubscriptionDeleted = NULL(name=u'vplmn-Csg-SubscriptionDeleted', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_additionalMSISDN_Withdraw = NULL(name=u'additionalMSISDN-Withdraw', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_cs_to_ps_SRVCC_Withdraw = NULL(name=u'cs-to-ps-SRVCC-Withdraw', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_imsiGroupIdList_Withdraw = NULL(name=u'imsiGroupIdList-Withdraw', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_userPlaneIntegrityProtectionWithdraw = NULL(name=u'userPlaneIntegrityProtectionWithdraw', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_dl_Buffering_Suggested_Packet_Count_Withdraw = NULL(name=u'dl-Buffering-Suggested-Packet-Count-Withdraw', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_ue_UsageTypeWithdraw = NULL(name=u'ue-UsageTypeWithdraw', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_reset_idsWithdraw = NULL(name=u'reset-idsWithdraw', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _DeleteSubscriberDataArg_iab_OperationWithdraw = NULL(name=u'iab-OperationWithdraw', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    DeleteSubscriberDataArg._cont = ASN1Dict([
        (u'imsi', _DeleteSubscriberDataArg_imsi),
        (u'basicServiceList', _DeleteSubscriberDataArg_basicServiceList),
        (u'ss-List', _DeleteSubscriberDataArg_ss_List),
        (u'roamingRestrictionDueToUnsupportedFeature', _DeleteSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature),
        (u'regionalSubscriptionIdentifier', _DeleteSubscriberDataArg_regionalSubscriptionIdentifier),
        (u'vbsGroupIndication', _DeleteSubscriberDataArg_vbsGroupIndication),
        (u'vgcsGroupIndication', _DeleteSubscriberDataArg_vgcsGroupIndication),
        (u'camelSubscriptionInfoWithdraw', _DeleteSubscriberDataArg_camelSubscriptionInfoWithdraw),
        (u'extensionContainer', _DeleteSubscriberDataArg_extensionContainer),
        (u'gprsSubscriptionDataWithdraw', _DeleteSubscriberDataArg_gprsSubscriptionDataWithdraw),
        (u'roamingRestrictedInSgsnDueToUnsuppportedFeature', _DeleteSubscriberDataArg_roamingRestrictedInSgsnDueToUnsuppportedFeature),
        (u'lsaInformationWithdraw', _DeleteSubscriberDataArg_lsaInformationWithdraw),
        (u'gmlc-ListWithdraw', _DeleteSubscriberDataArg_gmlc_ListWithdraw),
        (u'istInformationWithdraw', _DeleteSubscriberDataArg_istInformationWithdraw),
        (u'specificCSI-Withdraw', _DeleteSubscriberDataArg_specificCSI_Withdraw),
        (u'chargingCharacteristicsWithdraw', _DeleteSubscriberDataArg_chargingCharacteristicsWithdraw),
        (u'stn-srWithdraw', _DeleteSubscriberDataArg_stn_srWithdraw),
        (u'epsSubscriptionDataWithdraw', _DeleteSubscriberDataArg_epsSubscriptionDataWithdraw),
        (u'apn-oi-replacementWithdraw', _DeleteSubscriberDataArg_apn_oi_replacementWithdraw),
        (u'csg-SubscriptionDeleted', _DeleteSubscriberDataArg_csg_SubscriptionDeleted),
        (u'subscribedPeriodicTAU-RAU-TimerWithdraw', _DeleteSubscriberDataArg_subscribedPeriodicTAU_RAU_TimerWithdraw),
        (u'subscribedPeriodicLAU-TimerWithdraw', _DeleteSubscriberDataArg_subscribedPeriodicLAU_TimerWithdraw),
        (u'subscribed-vsrvccWithdraw', _DeleteSubscriberDataArg_subscribed_vsrvccWithdraw),
        (u'vplmn-Csg-SubscriptionDeleted', _DeleteSubscriberDataArg_vplmn_Csg_SubscriptionDeleted),
        (u'additionalMSISDN-Withdraw', _DeleteSubscriberDataArg_additionalMSISDN_Withdraw),
        (u'cs-to-ps-SRVCC-Withdraw', _DeleteSubscriberDataArg_cs_to_ps_SRVCC_Withdraw),
        (u'imsiGroupIdList-Withdraw', _DeleteSubscriberDataArg_imsiGroupIdList_Withdraw),
        (u'userPlaneIntegrityProtectionWithdraw', _DeleteSubscriberDataArg_userPlaneIntegrityProtectionWithdraw),
        (u'dl-Buffering-Suggested-Packet-Count-Withdraw', _DeleteSubscriberDataArg_dl_Buffering_Suggested_Packet_Count_Withdraw),
        (u'ue-UsageTypeWithdraw', _DeleteSubscriberDataArg_ue_UsageTypeWithdraw),
        (u'reset-idsWithdraw', _DeleteSubscriberDataArg_reset_idsWithdraw),
        (u'iab-OperationWithdraw', _DeleteSubscriberDataArg_iab_OperationWithdraw),
        ])
    DeleteSubscriberDataArg._ext = [u'gprsSubscriptionDataWithdraw', u'roamingRestrictedInSgsnDueToUnsuppportedFeature', u'lsaInformationWithdraw', u'gmlc-ListWithdraw', u'istInformationWithdraw', u'specificCSI-Withdraw', u'chargingCharacteristicsWithdraw', u'stn-srWithdraw', u'epsSubscriptionDataWithdraw', u'apn-oi-replacementWithdraw', u'csg-SubscriptionDeleted', u'subscribedPeriodicTAU-RAU-TimerWithdraw', u'subscribedPeriodicLAU-TimerWithdraw', u'subscribed-vsrvccWithdraw', u'vplmn-Csg-SubscriptionDeleted', u'additionalMSISDN-Withdraw', u'cs-to-ps-SRVCC-Withdraw', u'imsiGroupIdList-Withdraw', u'userPlaneIntegrityProtectionWithdraw', u'dl-Buffering-Suggested-Packet-Count-Withdraw', u'ue-UsageTypeWithdraw', u'reset-idsWithdraw', u'iab-OperationWithdraw']
    
    #-----< SpecificCSI-Withdraw >-----#
    SpecificCSI_Withdraw = BIT_STR(name=u'SpecificCSI-Withdraw', mode=MODE_TYPE)
    SpecificCSI_Withdraw._cont = ASN1Dict([(u'o-csi', 0), (u'ss-csi', 1), (u'tif-csi', 2), (u'd-csi', 3), (u'vt-csi', 4), (u'mo-sms-csi', 5), (u'm-csi', 6), (u'gprs-csi', 7), (u't-csi', 8), (u'mt-sms-csi', 9), (u'mg-csi', 10), (u'o-IM-CSI', 11), (u'd-IM-CSI', 12), (u'vt-IM-CSI', 13)])
    SpecificCSI_Withdraw._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=32)], ev=None, er=[])
    
    #-----< GPRSSubscriptionDataWithdraw >-----#
    GPRSSubscriptionDataWithdraw = CHOICE(name=u'GPRSSubscriptionDataWithdraw', mode=MODE_TYPE)
    _GPRSSubscriptionDataWithdraw_allGPRSData = NULL(name=u'allGPRSData', mode=MODE_TYPE)
    _GPRSSubscriptionDataWithdraw_contextIdList = SEQ_OF(name=u'contextIdList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextIdList')))
    GPRSSubscriptionDataWithdraw._cont = ASN1Dict([
        (u'allGPRSData', _GPRSSubscriptionDataWithdraw_allGPRSData),
        (u'contextIdList', _GPRSSubscriptionDataWithdraw_contextIdList),
        ])
    GPRSSubscriptionDataWithdraw._ext = None
    
    #-----< EPS-SubscriptionDataWithdraw >-----#
    EPS_SubscriptionDataWithdraw = CHOICE(name=u'EPS-SubscriptionDataWithdraw', mode=MODE_TYPE)
    _EPS_SubscriptionDataWithdraw_allEPS_Data = NULL(name=u'allEPS-Data', mode=MODE_TYPE)
    _EPS_SubscriptionDataWithdraw_contextIdList = SEQ_OF(name=u'contextIdList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextIdList')))
    EPS_SubscriptionDataWithdraw._cont = ASN1Dict([
        (u'allEPS-Data', _EPS_SubscriptionDataWithdraw_allEPS_Data),
        (u'contextIdList', _EPS_SubscriptionDataWithdraw_contextIdList),
        ])
    EPS_SubscriptionDataWithdraw._ext = None
    
    #-----< ContextIdList >-----#
    ContextIdList = SEQ_OF(name=u'ContextIdList', mode=MODE_TYPE)
    _ContextIdList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    ContextIdList._cont = _ContextIdList__item_
    ContextIdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< LSAInformationWithdraw >-----#
    LSAInformationWithdraw = CHOICE(name=u'LSAInformationWithdraw', mode=MODE_TYPE)
    _LSAInformationWithdraw_allLSAData = NULL(name=u'allLSAData', mode=MODE_TYPE)
    _LSAInformationWithdraw_lsaIdentityList = SEQ_OF(name=u'lsaIdentityList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentityList')))
    LSAInformationWithdraw._cont = ASN1Dict([
        (u'allLSAData', _LSAInformationWithdraw_allLSAData),
        (u'lsaIdentityList', _LSAInformationWithdraw_lsaIdentityList),
        ])
    LSAInformationWithdraw._ext = None
    
    #-----< LSAIdentityList >-----#
    LSAIdentityList = SEQ_OF(name=u'LSAIdentityList', mode=MODE_TYPE)
    _LSAIdentityList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')))
    LSAIdentityList._cont = _LSAIdentityList__item_
    LSAIdentityList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=20)], ev=None, er=[])
    
    #-----< BasicServiceList >-----#
    BasicServiceList = SEQ_OF(name=u'BasicServiceList', mode=MODE_TYPE)
    _BasicServiceList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    BasicServiceList._cont = _BasicServiceList__item_
    BasicServiceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=70)], ev=None, er=[])
    
    #-----< maxNumOfBasicServices >-----#
    maxNumOfBasicServices = INT(name=u'maxNumOfBasicServices', mode=MODE_VALUE)
    maxNumOfBasicServices._val = 70
    
    #-----< DeleteSubscriberDataRes >-----#
    DeleteSubscriberDataRes = SEQ(name=u'DeleteSubscriberDataRes', mode=MODE_TYPE)
    _DeleteSubscriberDataRes_regionalSubscriptionResponse = ENUM(name=u'regionalSubscriptionResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RegionalSubscriptionResponse')), opt=True)
    _DeleteSubscriberDataRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DeleteSubscriberDataRes._cont = ASN1Dict([
        (u'regionalSubscriptionResponse', _DeleteSubscriberDataRes_regionalSubscriptionResponse),
        (u'extensionContainer', _DeleteSubscriberDataRes_extensionContainer),
        ])
    DeleteSubscriberDataRes._ext = []
    
    #-----< VlrCamelSubscriptionInfo >-----#
    VlrCamelSubscriptionInfo = SEQ(name=u'VlrCamelSubscriptionInfo', mode=MODE_TYPE)
    _VlrCamelSubscriptionInfo_o_CSI = SEQ(name=u'o-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VlrCamelSubscriptionInfo_ss_CSI = SEQ(name=u'ss-CSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList = SEQ_OF(name=u'o-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _VlrCamelSubscriptionInfo_tif_CSI = NULL(name=u'tif-CSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _VlrCamelSubscriptionInfo_m_CSI = SEQ(name=u'm-CSI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'M-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_mo_sms_CSI = SEQ(name=u'mo-sms-CSI', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_vt_CSI = SEQ(name=u'vt-CSI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name=u't-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _VlrCamelSubscriptionInfo_d_CSI = SEQ(name=u'd-CSI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_mt_sms_CSI = SEQ(name=u'mt-sms-CSI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _VlrCamelSubscriptionInfo_mt_smsCAMELTDP_CriteriaList = SEQ_OF(name=u'mt-smsCAMELTDP-CriteriaList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-CriteriaList')), opt=True)
    VlrCamelSubscriptionInfo._cont = ASN1Dict([
        (u'o-CSI', _VlrCamelSubscriptionInfo_o_CSI),
        (u'extensionContainer', _VlrCamelSubscriptionInfo_extensionContainer),
        (u'ss-CSI', _VlrCamelSubscriptionInfo_ss_CSI),
        (u'o-BcsmCamelTDP-CriteriaList', _VlrCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList),
        (u'tif-CSI', _VlrCamelSubscriptionInfo_tif_CSI),
        (u'm-CSI', _VlrCamelSubscriptionInfo_m_CSI),
        (u'mo-sms-CSI', _VlrCamelSubscriptionInfo_mo_sms_CSI),
        (u'vt-CSI', _VlrCamelSubscriptionInfo_vt_CSI),
        (u't-BCSM-CAMEL-TDP-CriteriaList', _VlrCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList),
        (u'd-CSI', _VlrCamelSubscriptionInfo_d_CSI),
        (u'mt-sms-CSI', _VlrCamelSubscriptionInfo_mt_sms_CSI),
        (u'mt-smsCAMELTDP-CriteriaList', _VlrCamelSubscriptionInfo_mt_smsCAMELTDP_CriteriaList),
        ])
    VlrCamelSubscriptionInfo._ext = [u'ss-CSI', u'o-BcsmCamelTDP-CriteriaList', u'tif-CSI', u'm-CSI', u'mo-sms-CSI', u'vt-CSI', u't-BCSM-CAMEL-TDP-CriteriaList', u'd-CSI', u'mt-sms-CSI', u'mt-smsCAMELTDP-CriteriaList']
    
    #-----< MT-smsCAMELTDP-CriteriaList >-----#
    MT_smsCAMELTDP_CriteriaList = SEQ_OF(name=u'MT-smsCAMELTDP-CriteriaList', mode=MODE_TYPE)
    _MT_smsCAMELTDP_CriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-Criteria')))
    MT_smsCAMELTDP_CriteriaList._cont = _MT_smsCAMELTDP_CriteriaList__item_
    MT_smsCAMELTDP_CriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< MT-smsCAMELTDP-Criteria >-----#
    MT_smsCAMELTDP_Criteria = SEQ(name=u'MT-smsCAMELTDP-Criteria', mode=MODE_TYPE)
    _MT_smsCAMELTDP_Criteria_sms_TriggerDetectionPoint = ENUM(name=u'sms-TriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-TriggerDetectionPoint')))
    _MT_smsCAMELTDP_Criteria_tpdu_TypeCriterion = SEQ_OF(name=u'tpdu-TypeCriterion', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TPDU-TypeCriterion')), opt=True)
    MT_smsCAMELTDP_Criteria._cont = ASN1Dict([
        (u'sms-TriggerDetectionPoint', _MT_smsCAMELTDP_Criteria_sms_TriggerDetectionPoint),
        (u'tpdu-TypeCriterion', _MT_smsCAMELTDP_Criteria_tpdu_TypeCriterion),
        ])
    MT_smsCAMELTDP_Criteria._ext = []
    
    #-----< TPDU-TypeCriterion >-----#
    TPDU_TypeCriterion = SEQ_OF(name=u'TPDU-TypeCriterion', mode=MODE_TYPE)
    _TPDU_TypeCriterion__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-SMS-TPDU-Type')))
    TPDU_TypeCriterion._cont = _TPDU_TypeCriterion__item_
    TPDU_TypeCriterion._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfTPDUTypes >-----#
    maxNumOfTPDUTypes = INT(name=u'maxNumOfTPDUTypes', mode=MODE_VALUE)
    maxNumOfTPDUTypes._val = 5
    
    #-----< MT-SMS-TPDU-Type >-----#
    MT_SMS_TPDU_Type = ENUM(name=u'MT-SMS-TPDU-Type', mode=MODE_TYPE)
    MT_SMS_TPDU_Type._cont = ASN1Dict([(u'sms-DELIVER', 0), (u'sms-SUBMIT-REPORT', 1), (u'sms-STATUS-REPORT', 2)])
    MT_SMS_TPDU_Type._ext = []
    
    #-----< D-CSI >-----#
    D_CSI = SEQ(name=u'D-CSI', mode=MODE_TYPE)
    _D_CSI_dp_AnalysedInfoCriteriaList = SEQ_OF(name=u'dp-AnalysedInfoCriteriaList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DP-AnalysedInfoCriteriaList')), opt=True)
    _D_CSI_camelCapabilityHandling = INT(name=u'camelCapabilityHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _D_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _D_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _D_CSI_csi_Active = NULL(name=u'csi-Active', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    D_CSI._cont = ASN1Dict([
        (u'dp-AnalysedInfoCriteriaList', _D_CSI_dp_AnalysedInfoCriteriaList),
        (u'camelCapabilityHandling', _D_CSI_camelCapabilityHandling),
        (u'extensionContainer', _D_CSI_extensionContainer),
        (u'notificationToCSE', _D_CSI_notificationToCSE),
        (u'csi-Active', _D_CSI_csi_Active),
        ])
    D_CSI._ext = []
    
    #-----< DP-AnalysedInfoCriteriaList >-----#
    DP_AnalysedInfoCriteriaList = SEQ_OF(name=u'DP-AnalysedInfoCriteriaList', mode=MODE_TYPE)
    _DP_AnalysedInfoCriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'DP-AnalysedInfoCriterium')))
    DP_AnalysedInfoCriteriaList._cont = _DP_AnalysedInfoCriteriaList__item_
    DP_AnalysedInfoCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfDP-AnalysedInfoCriteria >-----#
    maxNumOfDP_AnalysedInfoCriteria = INT(name=u'maxNumOfDP-AnalysedInfoCriteria', mode=MODE_VALUE)
    maxNumOfDP_AnalysedInfoCriteria._val = 10
    
    #-----< DP-AnalysedInfoCriterium >-----#
    DP_AnalysedInfoCriterium = SEQ(name=u'DP-AnalysedInfoCriterium', mode=MODE_TYPE)
    _DP_AnalysedInfoCriterium_dialledNumber = OCT_STR(name=u'dialledNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _DP_AnalysedInfoCriterium_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _DP_AnalysedInfoCriterium_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _DP_AnalysedInfoCriterium_defaultCallHandling = ENUM(name=u'defaultCallHandling', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')))
    _DP_AnalysedInfoCriterium_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DP_AnalysedInfoCriterium._cont = ASN1Dict([
        (u'dialledNumber', _DP_AnalysedInfoCriterium_dialledNumber),
        (u'serviceKey', _DP_AnalysedInfoCriterium_serviceKey),
        (u'gsmSCF-Address', _DP_AnalysedInfoCriterium_gsmSCF_Address),
        (u'defaultCallHandling', _DP_AnalysedInfoCriterium_defaultCallHandling),
        (u'extensionContainer', _DP_AnalysedInfoCriterium_extensionContainer),
        ])
    DP_AnalysedInfoCriterium._ext = []
    
    #-----< SS-CSI >-----#
    SS_CSI = SEQ(name=u'SS-CSI', mode=MODE_TYPE)
    _SS_CSI_ss_CamelData = SEQ(name=u'ss-CamelData', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-CamelData')))
    _SS_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SS_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SS_CSI_csi_Active = NULL(name=u'csi-Active', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SS_CSI._cont = ASN1Dict([
        (u'ss-CamelData', _SS_CSI_ss_CamelData),
        (u'extensionContainer', _SS_CSI_extensionContainer),
        (u'notificationToCSE', _SS_CSI_notificationToCSE),
        (u'csi-Active', _SS_CSI_csi_Active),
        ])
    SS_CSI._ext = [u'notificationToCSE', u'csi-Active']
    
    #-----< SS-CamelData >-----#
    SS_CamelData = SEQ(name=u'SS-CamelData', mode=MODE_TYPE)
    _SS_CamelData_ss_EventList = SEQ_OF(name=u'ss-EventList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-EventList')))
    _SS_CamelData_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SS_CamelData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_CamelData._cont = ASN1Dict([
        (u'ss-EventList', _SS_CamelData_ss_EventList),
        (u'gsmSCF-Address', _SS_CamelData_gsmSCF_Address),
        (u'extensionContainer', _SS_CamelData_extensionContainer),
        ])
    SS_CamelData._ext = []
    
    #-----< SS-EventList >-----#
    SS_EventList = SEQ_OF(name=u'SS-EventList', mode=MODE_TYPE)
    _SS_EventList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    SS_EventList._cont = _SS_EventList__item_
    SS_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfCamelSSEvents >-----#
    maxNumOfCamelSSEvents = INT(name=u'maxNumOfCamelSSEvents', mode=MODE_VALUE)
    maxNumOfCamelSSEvents._val = 10
    
    #-----< O-CSI >-----#
    O_CSI = SEQ(name=u'O-CSI', mode=MODE_TYPE)
    _O_CSI_o_BcsmCamelTDPDataList = SEQ_OF(name=u'o-BcsmCamelTDPDataList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPDataList')))
    _O_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _O_CSI_camelCapabilityHandling = INT(name=u'camelCapabilityHandling', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _O_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _O_CSI_csiActive = NULL(name=u'csiActive', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    O_CSI._cont = ASN1Dict([
        (u'o-BcsmCamelTDPDataList', _O_CSI_o_BcsmCamelTDPDataList),
        (u'extensionContainer', _O_CSI_extensionContainer),
        (u'camelCapabilityHandling', _O_CSI_camelCapabilityHandling),
        (u'notificationToCSE', _O_CSI_notificationToCSE),
        (u'csiActive', _O_CSI_csiActive),
        ])
    O_CSI._ext = [u'camelCapabilityHandling', u'notificationToCSE', u'csiActive']
    
    #-----< O-BcsmCamelTDPDataList >-----#
    O_BcsmCamelTDPDataList = SEQ_OF(name=u'O-BcsmCamelTDPDataList', mode=MODE_TYPE)
    _O_BcsmCamelTDPDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPData')))
    O_BcsmCamelTDPDataList._cont = _O_BcsmCamelTDPDataList__item_
    O_BcsmCamelTDPDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfCamelTDPData >-----#
    maxNumOfCamelTDPData = INT(name=u'maxNumOfCamelTDPData', mode=MODE_VALUE)
    maxNumOfCamelTDPData._val = 10
    
    #-----< O-BcsmCamelTDPData >-----#
    O_BcsmCamelTDPData = SEQ(name=u'O-BcsmCamelTDPData', mode=MODE_TYPE)
    _O_BcsmCamelTDPData_o_BcsmTriggerDetectionPoint = ENUM(name=u'o-BcsmTriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmTriggerDetectionPoint')))
    _O_BcsmCamelTDPData_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _O_BcsmCamelTDPData_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _O_BcsmCamelTDPData_defaultCallHandling = ENUM(name=u'defaultCallHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')))
    _O_BcsmCamelTDPData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    O_BcsmCamelTDPData._cont = ASN1Dict([
        (u'o-BcsmTriggerDetectionPoint', _O_BcsmCamelTDPData_o_BcsmTriggerDetectionPoint),
        (u'serviceKey', _O_BcsmCamelTDPData_serviceKey),
        (u'gsmSCF-Address', _O_BcsmCamelTDPData_gsmSCF_Address),
        (u'defaultCallHandling', _O_BcsmCamelTDPData_defaultCallHandling),
        (u'extensionContainer', _O_BcsmCamelTDPData_extensionContainer),
        ])
    O_BcsmCamelTDPData._ext = []
    
    #-----< ServiceKey >-----#
    ServiceKey = INT(name=u'ServiceKey', mode=MODE_TYPE)
    ServiceKey._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2147483647)], ev=None, er=[])
    
    #-----< O-BcsmTriggerDetectionPoint >-----#
    O_BcsmTriggerDetectionPoint = ENUM(name=u'O-BcsmTriggerDetectionPoint', mode=MODE_TYPE)
    O_BcsmTriggerDetectionPoint._cont = ASN1Dict([(u'collectedInfo', 2), (u'routeSelectFailure', 4)])
    O_BcsmTriggerDetectionPoint._ext = [u'routeSelectFailure']
    
    #-----< O-BcsmCamelTDPCriteriaList >-----#
    O_BcsmCamelTDPCriteriaList = SEQ_OF(name=u'O-BcsmCamelTDPCriteriaList', mode=MODE_TYPE)
    _O_BcsmCamelTDPCriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDP-Criteria')))
    O_BcsmCamelTDPCriteriaList._cont = _O_BcsmCamelTDPCriteriaList__item_
    O_BcsmCamelTDPCriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< T-BCSM-CAMEL-TDP-CriteriaList >-----#
    T_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name=u'T-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE)
    _T_BCSM_CAMEL_TDP_CriteriaList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-Criteria')))
    T_BCSM_CAMEL_TDP_CriteriaList._cont = _T_BCSM_CAMEL_TDP_CriteriaList__item_
    T_BCSM_CAMEL_TDP_CriteriaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< O-BcsmCamelTDP-Criteria >-----#
    O_BcsmCamelTDP_Criteria = SEQ(name=u'O-BcsmCamelTDP-Criteria', mode=MODE_TYPE)
    _O_BcsmCamelTDP_Criteria_o_BcsmTriggerDetectionPoint = ENUM(name=u'o-BcsmTriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmTriggerDetectionPoint')))
    _O_BcsmCamelTDP_Criteria_destinationNumberCriteria = SEQ(name=u'destinationNumberCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DestinationNumberCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_basicServiceCriteria = SEQ_OF(name=u'basicServiceCriteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_callTypeCriteria = ENUM(name=u'callTypeCriteria', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallTypeCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_o_CauseValueCriteria = SEQ_OF(name=u'o-CauseValueCriteria', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CauseValueCriteria')), opt=True)
    _O_BcsmCamelTDP_Criteria_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    O_BcsmCamelTDP_Criteria._cont = ASN1Dict([
        (u'o-BcsmTriggerDetectionPoint', _O_BcsmCamelTDP_Criteria_o_BcsmTriggerDetectionPoint),
        (u'destinationNumberCriteria', _O_BcsmCamelTDP_Criteria_destinationNumberCriteria),
        (u'basicServiceCriteria', _O_BcsmCamelTDP_Criteria_basicServiceCriteria),
        (u'callTypeCriteria', _O_BcsmCamelTDP_Criteria_callTypeCriteria),
        (u'o-CauseValueCriteria', _O_BcsmCamelTDP_Criteria_o_CauseValueCriteria),
        (u'extensionContainer', _O_BcsmCamelTDP_Criteria_extensionContainer),
        ])
    O_BcsmCamelTDP_Criteria._ext = [u'o-CauseValueCriteria', u'extensionContainer']
    
    #-----< T-BCSM-CAMEL-TDP-Criteria >-----#
    T_BCSM_CAMEL_TDP_Criteria = SEQ(name=u'T-BCSM-CAMEL-TDP-Criteria', mode=MODE_TYPE)
    _T_BCSM_CAMEL_TDP_Criteria_t_BCSM_TriggerDetectionPoint = ENUM(name=u't-BCSM-TriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmTriggerDetectionPoint')))
    _T_BCSM_CAMEL_TDP_Criteria_basicServiceCriteria = SEQ_OF(name=u'basicServiceCriteria', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceCriteria')), opt=True)
    _T_BCSM_CAMEL_TDP_Criteria_t_CauseValueCriteria = SEQ_OF(name=u't-CauseValueCriteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CauseValueCriteria')), opt=True)
    T_BCSM_CAMEL_TDP_Criteria._cont = ASN1Dict([
        (u't-BCSM-TriggerDetectionPoint', _T_BCSM_CAMEL_TDP_Criteria_t_BCSM_TriggerDetectionPoint),
        (u'basicServiceCriteria', _T_BCSM_CAMEL_TDP_Criteria_basicServiceCriteria),
        (u't-CauseValueCriteria', _T_BCSM_CAMEL_TDP_Criteria_t_CauseValueCriteria),
        ])
    T_BCSM_CAMEL_TDP_Criteria._ext = []
    
    #-----< DestinationNumberCriteria >-----#
    DestinationNumberCriteria = SEQ(name=u'DestinationNumberCriteria', mode=MODE_TYPE)
    _DestinationNumberCriteria_matchType = ENUM(name=u'matchType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MatchType')))
    _DestinationNumberCriteria_destinationNumberList = SEQ_OF(name=u'destinationNumberList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DestinationNumberList')), opt=True)
    _DestinationNumberCriteria_destinationNumberLengthList = SEQ_OF(name=u'destinationNumberLengthList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DestinationNumberLengthList')), opt=True)
    DestinationNumberCriteria._cont = ASN1Dict([
        (u'matchType', _DestinationNumberCriteria_matchType),
        (u'destinationNumberList', _DestinationNumberCriteria_destinationNumberList),
        (u'destinationNumberLengthList', _DestinationNumberCriteria_destinationNumberLengthList),
        ])
    DestinationNumberCriteria._ext = []
    
    #-----< DestinationNumberList >-----#
    DestinationNumberList = SEQ_OF(name=u'DestinationNumberList', mode=MODE_TYPE)
    _DestinationNumberList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    DestinationNumberList._cont = _DestinationNumberList__item_
    DestinationNumberList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< DestinationNumberLengthList >-----#
    DestinationNumberLengthList = SEQ_OF(name=u'DestinationNumberLengthList', mode=MODE_TYPE)
    _DestinationNumberLengthList__item_ = INT(name='_item_', mode=MODE_TYPE)
    _DestinationNumberLengthList__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    DestinationNumberLengthList._cont = _DestinationNumberLengthList__item_
    DestinationNumberLengthList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< BasicServiceCriteria >-----#
    BasicServiceCriteria = SEQ_OF(name=u'BasicServiceCriteria', mode=MODE_TYPE)
    _BasicServiceCriteria__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    BasicServiceCriteria._cont = _BasicServiceCriteria__item_
    BasicServiceCriteria._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfISDN-AddressDigits >-----#
    maxNumOfISDN_AddressDigits = INT(name=u'maxNumOfISDN-AddressDigits', mode=MODE_VALUE)
    maxNumOfISDN_AddressDigits._val = 15
    
    #-----< maxNumOfCamelDestinationNumbers >-----#
    maxNumOfCamelDestinationNumbers = INT(name=u'maxNumOfCamelDestinationNumbers', mode=MODE_VALUE)
    maxNumOfCamelDestinationNumbers._val = 10
    
    #-----< maxNumOfCamelDestinationNumberLengths >-----#
    maxNumOfCamelDestinationNumberLengths = INT(name=u'maxNumOfCamelDestinationNumberLengths', mode=MODE_VALUE)
    maxNumOfCamelDestinationNumberLengths._val = 3
    
    #-----< maxNumOfCamelBasicServiceCriteria >-----#
    maxNumOfCamelBasicServiceCriteria = INT(name=u'maxNumOfCamelBasicServiceCriteria', mode=MODE_VALUE)
    maxNumOfCamelBasicServiceCriteria._val = 5
    
    #-----< CallTypeCriteria >-----#
    CallTypeCriteria = ENUM(name=u'CallTypeCriteria', mode=MODE_TYPE)
    CallTypeCriteria._cont = ASN1Dict([(u'forwarded', 0), (u'notForwarded', 1)])
    CallTypeCriteria._ext = None
    
    #-----< MatchType >-----#
    MatchType = ENUM(name=u'MatchType', mode=MODE_TYPE)
    MatchType._cont = ASN1Dict([(u'inhibiting', 0), (u'enabling', 1)])
    MatchType._ext = None
    
    #-----< O-CauseValueCriteria >-----#
    O_CauseValueCriteria = SEQ_OF(name=u'O-CauseValueCriteria', mode=MODE_TYPE)
    _O_CauseValueCriteria__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CauseValue')))
    O_CauseValueCriteria._cont = _O_CauseValueCriteria__item_
    O_CauseValueCriteria._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< T-CauseValueCriteria >-----#
    T_CauseValueCriteria = SEQ_OF(name=u'T-CauseValueCriteria', mode=MODE_TYPE)
    _T_CauseValueCriteria__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'CauseValue')))
    T_CauseValueCriteria._cont = _T_CauseValueCriteria__item_
    T_CauseValueCriteria._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfCAMEL-O-CauseValueCriteria >-----#
    maxNumOfCAMEL_O_CauseValueCriteria = INT(name=u'maxNumOfCAMEL-O-CauseValueCriteria', mode=MODE_VALUE)
    maxNumOfCAMEL_O_CauseValueCriteria._val = 5
    
    #-----< maxNumOfCAMEL-T-CauseValueCriteria >-----#
    maxNumOfCAMEL_T_CauseValueCriteria = INT(name=u'maxNumOfCAMEL-T-CauseValueCriteria', mode=MODE_VALUE)
    maxNumOfCAMEL_T_CauseValueCriteria._val = 5
    
    #-----< CauseValue >-----#
    CauseValue = OCT_STR(name=u'CauseValue', mode=MODE_TYPE)
    CauseValue._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< DefaultCallHandling >-----#
    DefaultCallHandling = ENUM(name=u'DefaultCallHandling', mode=MODE_TYPE)
    DefaultCallHandling._cont = ASN1Dict([(u'continueCall', 0), (u'releaseCall', 1)])
    DefaultCallHandling._ext = []
    
    #-----< CamelCapabilityHandling >-----#
    CamelCapabilityHandling = INT(name=u'CamelCapabilityHandling', mode=MODE_TYPE)
    CamelCapabilityHandling._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< SupportedCamelPhases >-----#
    SupportedCamelPhases = BIT_STR(name=u'SupportedCamelPhases', mode=MODE_TYPE)
    SupportedCamelPhases._cont = ASN1Dict([(u'phase1', 0), (u'phase2', 1), (u'phase3', 2), (u'phase4', 3)])
    SupportedCamelPhases._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OfferedCamel4CSIs >-----#
    OfferedCamel4CSIs = BIT_STR(name=u'OfferedCamel4CSIs', mode=MODE_TYPE)
    OfferedCamel4CSIs._cont = ASN1Dict([(u'o-csi', 0), (u'd-csi', 1), (u'vt-csi', 2), (u't-csi', 3), (u'mt-sms-csi', 4), (u'mg-csi', 5), (u'psi-enhancements', 6)])
    OfferedCamel4CSIs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=7, ub=16)], ev=None, er=[])
    
    #-----< OfferedCamel4Functionalities >-----#
    OfferedCamel4Functionalities = BIT_STR(name=u'OfferedCamel4Functionalities', mode=MODE_TYPE)
    OfferedCamel4Functionalities._cont = ASN1Dict([(u'initiateCallAttempt', 0), (u'splitLeg', 1), (u'moveLeg', 2), (u'disconnectLeg', 3), (u'entityReleased', 4), (u'dfc-WithArgument', 5), (u'playTone', 6), (u'dtmf-MidCall', 7), (u'chargingIndicator', 8), (u'alertingDP', 9), (u'locationAtAlerting', 10), (u'changeOfPositionDP', 11), (u'or-Interactions', 12), (u'warningToneEnhancements', 13), (u'cf-Enhancements', 14), (u'subscribedEnhancedDialledServices', 15), (u'servingNetworkEnhancedDialledServices', 16), (u'criteriaForChangeOfPositionDP', 17), (u'serviceChangeDP', 18), (u'collectInformation', 19)])
    OfferedCamel4Functionalities._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=15, ub=64)], ev=None, er=[])
    
    #-----< SMS-CSI >-----#
    SMS_CSI = SEQ(name=u'SMS-CSI', mode=MODE_TYPE)
    _SMS_CSI_sms_CAMEL_TDP_DataList = SEQ_OF(name=u'sms-CAMEL-TDP-DataList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CAMEL-TDP-DataList')), opt=True)
    _SMS_CSI_camelCapabilityHandling = INT(name=u'camelCapabilityHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _SMS_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SMS_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMS_CSI_csi_Active = NULL(name=u'csi-Active', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SMS_CSI._cont = ASN1Dict([
        (u'sms-CAMEL-TDP-DataList', _SMS_CSI_sms_CAMEL_TDP_DataList),
        (u'camelCapabilityHandling', _SMS_CSI_camelCapabilityHandling),
        (u'extensionContainer', _SMS_CSI_extensionContainer),
        (u'notificationToCSE', _SMS_CSI_notificationToCSE),
        (u'csi-Active', _SMS_CSI_csi_Active),
        ])
    SMS_CSI._ext = []
    
    #-----< SMS-CAMEL-TDP-DataList >-----#
    SMS_CAMEL_TDP_DataList = SEQ_OF(name=u'SMS-CAMEL-TDP-DataList', mode=MODE_TYPE)
    _SMS_CAMEL_TDP_DataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CAMEL-TDP-Data')))
    SMS_CAMEL_TDP_DataList._cont = _SMS_CAMEL_TDP_DataList__item_
    SMS_CAMEL_TDP_DataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< SMS-CAMEL-TDP-Data >-----#
    SMS_CAMEL_TDP_Data = SEQ(name=u'SMS-CAMEL-TDP-Data', mode=MODE_TYPE)
    _SMS_CAMEL_TDP_Data_sms_TriggerDetectionPoint = ENUM(name=u'sms-TriggerDetectionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-TriggerDetectionPoint')))
    _SMS_CAMEL_TDP_Data_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _SMS_CAMEL_TDP_Data_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SMS_CAMEL_TDP_Data_defaultSMS_Handling = ENUM(name=u'defaultSMS-Handling', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultSMS-Handling')))
    _SMS_CAMEL_TDP_Data_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SMS_CAMEL_TDP_Data._cont = ASN1Dict([
        (u'sms-TriggerDetectionPoint', _SMS_CAMEL_TDP_Data_sms_TriggerDetectionPoint),
        (u'serviceKey', _SMS_CAMEL_TDP_Data_serviceKey),
        (u'gsmSCF-Address', _SMS_CAMEL_TDP_Data_gsmSCF_Address),
        (u'defaultSMS-Handling', _SMS_CAMEL_TDP_Data_defaultSMS_Handling),
        (u'extensionContainer', _SMS_CAMEL_TDP_Data_extensionContainer),
        ])
    SMS_CAMEL_TDP_Data._ext = []
    
    #-----< SMS-TriggerDetectionPoint >-----#
    SMS_TriggerDetectionPoint = ENUM(name=u'SMS-TriggerDetectionPoint', mode=MODE_TYPE)
    SMS_TriggerDetectionPoint._cont = ASN1Dict([(u'sms-CollectedInfo', 1), (u'sms-DeliveryRequest', 2)])
    SMS_TriggerDetectionPoint._ext = [u'sms-DeliveryRequest']
    
    #-----< DefaultSMS-Handling >-----#
    DefaultSMS_Handling = ENUM(name=u'DefaultSMS-Handling', mode=MODE_TYPE)
    DefaultSMS_Handling._cont = ASN1Dict([(u'continueTransaction', 0), (u'releaseTransaction', 1)])
    DefaultSMS_Handling._ext = []
    
    #-----< M-CSI >-----#
    M_CSI = SEQ(name=u'M-CSI', mode=MODE_TYPE)
    _M_CSI_mobilityTriggers = SEQ_OF(name=u'mobilityTriggers', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MobilityTriggers')))
    _M_CSI_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _M_CSI_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _M_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _M_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _M_CSI_csi_Active = NULL(name=u'csi-Active', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    M_CSI._cont = ASN1Dict([
        (u'mobilityTriggers', _M_CSI_mobilityTriggers),
        (u'serviceKey', _M_CSI_serviceKey),
        (u'gsmSCF-Address', _M_CSI_gsmSCF_Address),
        (u'extensionContainer', _M_CSI_extensionContainer),
        (u'notificationToCSE', _M_CSI_notificationToCSE),
        (u'csi-Active', _M_CSI_csi_Active),
        ])
    M_CSI._ext = []
    
    #-----< MG-CSI >-----#
    MG_CSI = SEQ(name=u'MG-CSI', mode=MODE_TYPE)
    _MG_CSI_mobilityTriggers = SEQ_OF(name=u'mobilityTriggers', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MobilityTriggers')))
    _MG_CSI_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _MG_CSI_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _MG_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _MG_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MG_CSI_csi_Active = NULL(name=u'csi-Active', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    MG_CSI._cont = ASN1Dict([
        (u'mobilityTriggers', _MG_CSI_mobilityTriggers),
        (u'serviceKey', _MG_CSI_serviceKey),
        (u'gsmSCF-Address', _MG_CSI_gsmSCF_Address),
        (u'extensionContainer', _MG_CSI_extensionContainer),
        (u'notificationToCSE', _MG_CSI_notificationToCSE),
        (u'csi-Active', _MG_CSI_csi_Active),
        ])
    MG_CSI._ext = []
    
    #-----< MobilityTriggers >-----#
    MobilityTriggers = SEQ_OF(name=u'MobilityTriggers', mode=MODE_TYPE)
    _MobilityTriggers__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MM-Code')))
    MobilityTriggers._cont = _MobilityTriggers__item_
    MobilityTriggers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< maxNumOfMobilityTriggers >-----#
    maxNumOfMobilityTriggers = INT(name=u'maxNumOfMobilityTriggers', mode=MODE_VALUE)
    maxNumOfMobilityTriggers._val = 10
    
    #-----< MM-Code >-----#
    MM_Code = OCT_STR(name=u'MM-Code', mode=MODE_TYPE)
    MM_Code._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< T-CSI >-----#
    T_CSI = SEQ(name=u'T-CSI', mode=MODE_TYPE)
    _T_CSI_t_BcsmCamelTDPDataList = SEQ_OF(name=u't-BcsmCamelTDPDataList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmCamelTDPDataList')))
    _T_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _T_CSI_camelCapabilityHandling = INT(name=u'camelCapabilityHandling', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CamelCapabilityHandling')), opt=True)
    _T_CSI_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _T_CSI_csi_Active = NULL(name=u'csi-Active', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    T_CSI._cont = ASN1Dict([
        (u't-BcsmCamelTDPDataList', _T_CSI_t_BcsmCamelTDPDataList),
        (u'extensionContainer', _T_CSI_extensionContainer),
        (u'camelCapabilityHandling', _T_CSI_camelCapabilityHandling),
        (u'notificationToCSE', _T_CSI_notificationToCSE),
        (u'csi-Active', _T_CSI_csi_Active),
        ])
    T_CSI._ext = [u'camelCapabilityHandling', u'notificationToCSE', u'csi-Active']
    
    #-----< T-BcsmCamelTDPDataList >-----#
    T_BcsmCamelTDPDataList = SEQ_OF(name=u'T-BcsmCamelTDPDataList', mode=MODE_TYPE)
    _T_BcsmCamelTDPDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmCamelTDPData')))
    T_BcsmCamelTDPDataList._cont = _T_BcsmCamelTDPDataList__item_
    T_BcsmCamelTDPDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=10)], ev=None, er=[])
    
    #-----< T-BcsmCamelTDPData >-----#
    T_BcsmCamelTDPData = SEQ(name=u'T-BcsmCamelTDPData', mode=MODE_TYPE)
    _T_BcsmCamelTDPData_t_BcsmTriggerDetectionPoint = ENUM(name=u't-BcsmTriggerDetectionPoint', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BcsmTriggerDetectionPoint')))
    _T_BcsmCamelTDPData_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _T_BcsmCamelTDPData_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _T_BcsmCamelTDPData_defaultCallHandling = ENUM(name=u'defaultCallHandling', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DefaultCallHandling')))
    _T_BcsmCamelTDPData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    T_BcsmCamelTDPData._cont = ASN1Dict([
        (u't-BcsmTriggerDetectionPoint', _T_BcsmCamelTDPData_t_BcsmTriggerDetectionPoint),
        (u'serviceKey', _T_BcsmCamelTDPData_serviceKey),
        (u'gsmSCF-Address', _T_BcsmCamelTDPData_gsmSCF_Address),
        (u'defaultCallHandling', _T_BcsmCamelTDPData_defaultCallHandling),
        (u'extensionContainer', _T_BcsmCamelTDPData_extensionContainer),
        ])
    T_BcsmCamelTDPData._ext = []
    
    #-----< T-BcsmTriggerDetectionPoint >-----#
    T_BcsmTriggerDetectionPoint = ENUM(name=u'T-BcsmTriggerDetectionPoint', mode=MODE_TYPE)
    T_BcsmTriggerDetectionPoint._cont = ASN1Dict([(u'termAttemptAuthorized', 12), (u'tBusy', 13), (u'tNoAnswer', 14)])
    T_BcsmTriggerDetectionPoint._ext = [u'tBusy', u'tNoAnswer']
    
    #-----< SendRoutingInfoForGprsArg >-----#
    SendRoutingInfoForGprsArg = SEQ(name=u'SendRoutingInfoForGprsArg', mode=MODE_TYPE)
    _SendRoutingInfoForGprsArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SendRoutingInfoForGprsArg_ggsn_Address = OCT_STR(name=u'ggsn-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _SendRoutingInfoForGprsArg_ggsn_Number = OCT_STR(name=u'ggsn-Number', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendRoutingInfoForGprsArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendRoutingInfoForGprsArg._cont = ASN1Dict([
        (u'imsi', _SendRoutingInfoForGprsArg_imsi),
        (u'ggsn-Address', _SendRoutingInfoForGprsArg_ggsn_Address),
        (u'ggsn-Number', _SendRoutingInfoForGprsArg_ggsn_Number),
        (u'extensionContainer', _SendRoutingInfoForGprsArg_extensionContainer),
        ])
    SendRoutingInfoForGprsArg._ext = []
    
    #-----< SendRoutingInfoForGprsRes >-----#
    SendRoutingInfoForGprsRes = SEQ(name=u'SendRoutingInfoForGprsRes', mode=MODE_TYPE)
    _SendRoutingInfoForGprsRes_sgsn_Address = OCT_STR(name=u'sgsn-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    _SendRoutingInfoForGprsRes_ggsn_Address = OCT_STR(name=u'ggsn-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _SendRoutingInfoForGprsRes_mobileNotReachableReason = INT(name=u'mobileNotReachableReason', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _SendRoutingInfoForGprsRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SendRoutingInfoForGprsRes._cont = ASN1Dict([
        (u'sgsn-Address', _SendRoutingInfoForGprsRes_sgsn_Address),
        (u'ggsn-Address', _SendRoutingInfoForGprsRes_ggsn_Address),
        (u'mobileNotReachableReason', _SendRoutingInfoForGprsRes_mobileNotReachableReason),
        (u'extensionContainer', _SendRoutingInfoForGprsRes_extensionContainer),
        ])
    SendRoutingInfoForGprsRes._ext = []
    
    #-----< FailureReportArg >-----#
    FailureReportArg = SEQ(name=u'FailureReportArg', mode=MODE_TYPE)
    _FailureReportArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _FailureReportArg_ggsn_Number = OCT_STR(name=u'ggsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _FailureReportArg_ggsn_Address = OCT_STR(name=u'ggsn-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _FailureReportArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    FailureReportArg._cont = ASN1Dict([
        (u'imsi', _FailureReportArg_imsi),
        (u'ggsn-Number', _FailureReportArg_ggsn_Number),
        (u'ggsn-Address', _FailureReportArg_ggsn_Address),
        (u'extensionContainer', _FailureReportArg_extensionContainer),
        ])
    FailureReportArg._ext = []
    
    #-----< FailureReportRes >-----#
    FailureReportRes = SEQ(name=u'FailureReportRes', mode=MODE_TYPE)
    _FailureReportRes_ggsn_Address = OCT_STR(name=u'ggsn-Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _FailureReportRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    FailureReportRes._cont = ASN1Dict([
        (u'ggsn-Address', _FailureReportRes_ggsn_Address),
        (u'extensionContainer', _FailureReportRes_extensionContainer),
        ])
    FailureReportRes._ext = []
    
    #-----< NoteMsPresentForGprsArg >-----#
    NoteMsPresentForGprsArg = SEQ(name=u'NoteMsPresentForGprsArg', mode=MODE_TYPE)
    _NoteMsPresentForGprsArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _NoteMsPresentForGprsArg_sgsn_Address = OCT_STR(name=u'sgsn-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    _NoteMsPresentForGprsArg_ggsn_Address = OCT_STR(name=u'ggsn-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _NoteMsPresentForGprsArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteMsPresentForGprsArg._cont = ASN1Dict([
        (u'imsi', _NoteMsPresentForGprsArg_imsi),
        (u'sgsn-Address', _NoteMsPresentForGprsArg_sgsn_Address),
        (u'ggsn-Address', _NoteMsPresentForGprsArg_ggsn_Address),
        (u'extensionContainer', _NoteMsPresentForGprsArg_extensionContainer),
        ])
    NoteMsPresentForGprsArg._ext = []
    
    #-----< NoteMsPresentForGprsRes >-----#
    NoteMsPresentForGprsRes = SEQ(name=u'NoteMsPresentForGprsRes', mode=MODE_TYPE)
    _NoteMsPresentForGprsRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteMsPresentForGprsRes._cont = ASN1Dict([
        (u'extensionContainer', _NoteMsPresentForGprsRes_extensionContainer),
        ])
    NoteMsPresentForGprsRes._ext = []
    
    #-----< ResetArg >-----#
    ResetArg = SEQ(name=u'ResetArg', mode=MODE_TYPE)
    _ResetArg_sendingNodenumber = CHOICE(name=u'sendingNodenumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SendingNode-Number')))
    _ResetArg_hlr_List = SEQ_OF(name=u'hlr-List', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'HLR-List')), opt=True)
    _ResetArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ResetArg_reset_Id_List = SEQ_OF(name=u'reset-Id-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Reset-Id-List')), opt=True)
    _ResetArg_subscriptionData = SEQ(name=u'subscriptionData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'InsertSubscriberDataArg')), opt=True)
    _ResetArg_subscriptionDataDeletion = SEQ(name=u'subscriptionDataDeletion', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DeleteSubscriberDataArg')), opt=True)
    ResetArg._cont = ASN1Dict([
        (u'sendingNodenumber', _ResetArg_sendingNodenumber),
        (u'hlr-List', _ResetArg_hlr_List),
        (u'extensionContainer', _ResetArg_extensionContainer),
        (u'reset-Id-List', _ResetArg_reset_Id_List),
        (u'subscriptionData', _ResetArg_subscriptionData),
        (u'subscriptionDataDeletion', _ResetArg_subscriptionDataDeletion),
        ])
    ResetArg._ext = [u'reset-Id-List', u'subscriptionData', u'subscriptionDataDeletion']
    
    #-----< SendingNode-Number >-----#
    SendingNode_Number = CHOICE(name=u'SendingNode-Number', mode=MODE_TYPE)
    _SendingNode_Number_hlr_Number = OCT_STR(name=u'hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SendingNode_Number_css_Number = OCT_STR(name=u'css-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    SendingNode_Number._cont = ASN1Dict([
        (u'hlr-Number', _SendingNode_Number_hlr_Number),
        (u'css-Number', _SendingNode_Number_css_Number),
        ])
    SendingNode_Number._ext = None
    
    #-----< RestoreDataArg >-----#
    RestoreDataArg = SEQ(name=u'RestoreDataArg', mode=MODE_TYPE)
    _RestoreDataArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _RestoreDataArg_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _RestoreDataArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RestoreDataArg_vlr_Capability = SEQ(name=u'vlr-Capability', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'VLR-Capability')), opt=True)
    _RestoreDataArg_restorationIndicator = NULL(name=u'restorationIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RestoreDataArg._cont = ASN1Dict([
        (u'imsi', _RestoreDataArg_imsi),
        (u'lmsi', _RestoreDataArg_lmsi),
        (u'extensionContainer', _RestoreDataArg_extensionContainer),
        (u'vlr-Capability', _RestoreDataArg_vlr_Capability),
        (u'restorationIndicator', _RestoreDataArg_restorationIndicator),
        ])
    RestoreDataArg._ext = [u'vlr-Capability', u'restorationIndicator']
    
    #-----< RestoreDataRes >-----#
    RestoreDataRes = SEQ(name=u'RestoreDataRes', mode=MODE_TYPE)
    _RestoreDataRes_hlr_Number = OCT_STR(name=u'hlr-Number', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RestoreDataRes_msNotReachable = NULL(name=u'msNotReachable', mode=MODE_TYPE, opt=True)
    _RestoreDataRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    RestoreDataRes._cont = ASN1Dict([
        (u'hlr-Number', _RestoreDataRes_hlr_Number),
        (u'msNotReachable', _RestoreDataRes_msNotReachable),
        (u'extensionContainer', _RestoreDataRes_extensionContainer),
        ])
    RestoreDataRes._ext = []
    
    #-----< VBSDataList >-----#
    VBSDataList = SEQ_OF(name=u'VBSDataList', mode=MODE_TYPE)
    _VBSDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'VoiceBroadcastData')))
    VBSDataList._cont = _VBSDataList__item_
    VBSDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< VGCSDataList >-----#
    VGCSDataList = SEQ_OF(name=u'VGCSDataList', mode=MODE_TYPE)
    _VGCSDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'VoiceGroupCallData')))
    VGCSDataList._cont = _VGCSDataList__item_
    VGCSDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfVBSGroupIds >-----#
    maxNumOfVBSGroupIds = INT(name=u'maxNumOfVBSGroupIds', mode=MODE_VALUE)
    maxNumOfVBSGroupIds._val = 50
    
    #-----< maxNumOfVGCSGroupIds >-----#
    maxNumOfVGCSGroupIds = INT(name=u'maxNumOfVGCSGroupIds', mode=MODE_VALUE)
    maxNumOfVGCSGroupIds._val = 50
    
    #-----< VoiceGroupCallData >-----#
    VoiceGroupCallData = SEQ(name=u'VoiceGroupCallData', mode=MODE_TYPE)
    _VoiceGroupCallData_groupId = OCT_STR(name=u'groupId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'GroupId')))
    _VoiceGroupCallData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VoiceGroupCallData_additionalSubscriptions = BIT_STR(name=u'additionalSubscriptions', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalSubscriptions')), opt=True)
    _VoiceGroupCallData_additionalInfo = BIT_STR(name=u'additionalInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalInfo')), opt=True)
    _VoiceGroupCallData_longGroupId = OCT_STR(name=u'longGroupId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Long-GroupId')), opt=True)
    VoiceGroupCallData._cont = ASN1Dict([
        (u'groupId', _VoiceGroupCallData_groupId),
        (u'extensionContainer', _VoiceGroupCallData_extensionContainer),
        (u'additionalSubscriptions', _VoiceGroupCallData_additionalSubscriptions),
        (u'additionalInfo', _VoiceGroupCallData_additionalInfo),
        (u'longGroupId', _VoiceGroupCallData_longGroupId),
        ])
    VoiceGroupCallData._ext = [u'additionalSubscriptions', u'additionalInfo', u'longGroupId']
    
    #-----< AdditionalInfo >-----#
    AdditionalInfo = BIT_STR(name=u'AdditionalInfo', mode=MODE_TYPE)
    AdditionalInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=136)], ev=None, er=[])
    
    #-----< AdditionalSubscriptions >-----#
    AdditionalSubscriptions = BIT_STR(name=u'AdditionalSubscriptions', mode=MODE_TYPE)
    AdditionalSubscriptions._cont = ASN1Dict([(u'privilegedUplinkRequest', 0), (u'emergencyUplinkRequest', 1), (u'emergencyReset', 2)])
    AdditionalSubscriptions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< VoiceBroadcastData >-----#
    VoiceBroadcastData = SEQ(name=u'VoiceBroadcastData', mode=MODE_TYPE)
    _VoiceBroadcastData_groupid = OCT_STR(name=u'groupid', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'GroupId')))
    _VoiceBroadcastData_broadcastInitEntitlement = NULL(name=u'broadcastInitEntitlement', mode=MODE_TYPE, opt=True)
    _VoiceBroadcastData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _VoiceBroadcastData_longGroupId = OCT_STR(name=u'longGroupId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Long-GroupId')), opt=True)
    VoiceBroadcastData._cont = ASN1Dict([
        (u'groupid', _VoiceBroadcastData_groupid),
        (u'broadcastInitEntitlement', _VoiceBroadcastData_broadcastInitEntitlement),
        (u'extensionContainer', _VoiceBroadcastData_extensionContainer),
        (u'longGroupId', _VoiceBroadcastData_longGroupId),
        ])
    VoiceBroadcastData._ext = [u'longGroupId']
    
    #-----< GroupId >-----#
    GroupId = OCT_STR(name=u'GroupId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    GroupId._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< Long-GroupId >-----#
    Long_GroupId = OCT_STR(name=u'Long-GroupId', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    Long_GroupId._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< ProvideSubscriberInfoArg >-----#
    ProvideSubscriberInfoArg = SEQ(name=u'ProvideSubscriberInfoArg', mode=MODE_TYPE)
    _ProvideSubscriberInfoArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _ProvideSubscriberInfoArg_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _ProvideSubscriberInfoArg_requestedInfo = SEQ(name=u'requestedInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedInfo')))
    _ProvideSubscriberInfoArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ProvideSubscriberInfoArg_callPriority = INT(name=u'callPriority', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    ProvideSubscriberInfoArg._cont = ASN1Dict([
        (u'imsi', _ProvideSubscriberInfoArg_imsi),
        (u'lmsi', _ProvideSubscriberInfoArg_lmsi),
        (u'requestedInfo', _ProvideSubscriberInfoArg_requestedInfo),
        (u'extensionContainer', _ProvideSubscriberInfoArg_extensionContainer),
        (u'callPriority', _ProvideSubscriberInfoArg_callPriority),
        ])
    ProvideSubscriberInfoArg._ext = [u'callPriority']
    
    #-----< ProvideSubscriberInfoRes >-----#
    ProvideSubscriberInfoRes = SEQ(name=u'ProvideSubscriberInfoRes', mode=MODE_TYPE)
    _ProvideSubscriberInfoRes_subscriberInfo = SEQ(name=u'subscriberInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberInfo')))
    _ProvideSubscriberInfoRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ProvideSubscriberInfoRes._cont = ASN1Dict([
        (u'subscriberInfo', _ProvideSubscriberInfoRes_subscriberInfo),
        (u'extensionContainer', _ProvideSubscriberInfoRes_extensionContainer),
        ])
    ProvideSubscriberInfoRes._ext = []
    
    #-----< SubscriberInfo >-----#
    SubscriberInfo = SEQ(name=u'SubscriberInfo', mode=MODE_TYPE)
    _SubscriberInfo_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _SubscriberInfo_subscriberState = CHOICE(name=u'subscriberState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberState')), opt=True)
    _SubscriberInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SubscriberInfo_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationGPRS')), opt=True)
    _SubscriberInfo_ps_SubscriberState = CHOICE(name=u'ps-SubscriberState', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PS-SubscriberState')), opt=True)
    _SubscriberInfo_imei = OCT_STR(name=u'imei', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SubscriberInfo_ms_Classmark2 = OCT_STR(name=u'ms-Classmark2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MS-Classmark2')), opt=True)
    _SubscriberInfo_gprs_MS_Class = SEQ(name=u'gprs-MS-Class', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSMSClass')), opt=True)
    _SubscriberInfo_mnpInfoRes = SEQ(name=u'mnpInfoRes', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MNPInfoRes')), opt=True)
    _SubscriberInfo_imsVoiceOverPS_SessionsIndication = ENUM(name=u'imsVoiceOverPS-SessionsIndication', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'IMS-VoiceOverPS-SessionsInd')), opt=True)
    _SubscriberInfo_lastUE_ActivityTime = OCT_STR(name=u'lastUE-ActivityTime', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _SubscriberInfo_lastRAT_Type = ENUM(name=u'lastRAT-Type', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')), opt=True)
    _SubscriberInfo_eps_SubscriberState = CHOICE(name=u'eps-SubscriberState', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PS-SubscriberState')), opt=True)
    _SubscriberInfo_locationInformationEPS = SEQ(name=u'locationInformationEPS', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationEPS')), opt=True)
    _SubscriberInfo_timeZone = OCT_STR(name=u'timeZone', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TimeZone')), opt=True)
    _SubscriberInfo_daylightSavingTime = ENUM(name=u'daylightSavingTime', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DaylightSavingTime')), opt=True)
    _SubscriberInfo_locationInformation5GS = SEQ(name=u'locationInformation5GS', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation5GS')), opt=True)
    SubscriberInfo._cont = ASN1Dict([
        (u'locationInformation', _SubscriberInfo_locationInformation),
        (u'subscriberState', _SubscriberInfo_subscriberState),
        (u'extensionContainer', _SubscriberInfo_extensionContainer),
        (u'locationInformationGPRS', _SubscriberInfo_locationInformationGPRS),
        (u'ps-SubscriberState', _SubscriberInfo_ps_SubscriberState),
        (u'imei', _SubscriberInfo_imei),
        (u'ms-Classmark2', _SubscriberInfo_ms_Classmark2),
        (u'gprs-MS-Class', _SubscriberInfo_gprs_MS_Class),
        (u'mnpInfoRes', _SubscriberInfo_mnpInfoRes),
        (u'imsVoiceOverPS-SessionsIndication', _SubscriberInfo_imsVoiceOverPS_SessionsIndication),
        (u'lastUE-ActivityTime', _SubscriberInfo_lastUE_ActivityTime),
        (u'lastRAT-Type', _SubscriberInfo_lastRAT_Type),
        (u'eps-SubscriberState', _SubscriberInfo_eps_SubscriberState),
        (u'locationInformationEPS', _SubscriberInfo_locationInformationEPS),
        (u'timeZone', _SubscriberInfo_timeZone),
        (u'daylightSavingTime', _SubscriberInfo_daylightSavingTime),
        (u'locationInformation5GS', _SubscriberInfo_locationInformation5GS),
        ])
    SubscriberInfo._ext = [u'locationInformationGPRS', u'ps-SubscriberState', u'imei', u'ms-Classmark2', u'gprs-MS-Class', u'mnpInfoRes', u'imsVoiceOverPS-SessionsIndication', u'lastUE-ActivityTime', u'lastRAT-Type', u'eps-SubscriberState', u'locationInformationEPS', u'timeZone', u'daylightSavingTime', u'locationInformation5GS']
    
    #-----< IMS-VoiceOverPS-SessionsInd >-----#
    IMS_VoiceOverPS_SessionsInd = ENUM(name=u'IMS-VoiceOverPS-SessionsInd', mode=MODE_TYPE)
    IMS_VoiceOverPS_SessionsInd._cont = ASN1Dict([(u'imsVoiceOverPS-SessionsNotSupported', 0), (u'imsVoiceOverPS-SessionsSupported', 1), (u'unknown', 2)])
    IMS_VoiceOverPS_SessionsInd._ext = None
    
    #-----< TimeZone >-----#
    TimeZone = OCT_STR(name=u'TimeZone', mode=MODE_TYPE)
    TimeZone._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    
    #-----< DaylightSavingTime >-----#
    DaylightSavingTime = ENUM(name=u'DaylightSavingTime', mode=MODE_TYPE)
    DaylightSavingTime._cont = ASN1Dict([(u'noAdjustment', 0), (u'plusOneHourAdjustment', 1), (u'plusTwoHoursAdjustment', 2)])
    DaylightSavingTime._ext = None
    
    #-----< MNPInfoRes >-----#
    MNPInfoRes = SEQ(name=u'MNPInfoRes', mode=MODE_TYPE)
    _MNPInfoRes_routeingNumber = OCT_STR(name=u'routeingNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RouteingNumber')), opt=True)
    _MNPInfoRes_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MNPInfoRes_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _MNPInfoRes_numberPortabilityStatus = ENUM(name=u'numberPortabilityStatus', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NumberPortabilityStatus')), opt=True)
    _MNPInfoRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MNPInfoRes._cont = ASN1Dict([
        (u'routeingNumber', _MNPInfoRes_routeingNumber),
        (u'imsi', _MNPInfoRes_imsi),
        (u'msisdn', _MNPInfoRes_msisdn),
        (u'numberPortabilityStatus', _MNPInfoRes_numberPortabilityStatus),
        (u'extensionContainer', _MNPInfoRes_extensionContainer),
        ])
    MNPInfoRes._ext = []
    
    #-----< RouteingNumber >-----#
    RouteingNumber = OCT_STR(name=u'RouteingNumber', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TBCD-STRING')))
    RouteingNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< NumberPortabilityStatus >-----#
    NumberPortabilityStatus = ENUM(name=u'NumberPortabilityStatus', mode=MODE_TYPE)
    NumberPortabilityStatus._cont = ASN1Dict([(u'notKnownToBePorted', 0), (u'ownNumberPortedOut', 1), (u'foreignNumberPortedToForeignNetwork', 2), (u'ownNumberNotPortedOut', 4), (u'foreignNumberPortedIn', 5)])
    NumberPortabilityStatus._ext = [u'ownNumberNotPortedOut', u'foreignNumberPortedIn']
    
    #-----< MS-Classmark2 >-----#
    MS_Classmark2 = OCT_STR(name=u'MS-Classmark2', mode=MODE_TYPE)
    MS_Classmark2._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< GPRSMSClass >-----#
    GPRSMSClass = SEQ(name=u'GPRSMSClass', mode=MODE_TYPE)
    _GPRSMSClass_mSNetworkCapability = OCT_STR(name=u'mSNetworkCapability', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSNetworkCapability')))
    _GPRSMSClass_mSRadioAccessCapability = OCT_STR(name=u'mSRadioAccessCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSRadioAccessCapability')), opt=True)
    GPRSMSClass._cont = ASN1Dict([
        (u'mSNetworkCapability', _GPRSMSClass_mSNetworkCapability),
        (u'mSRadioAccessCapability', _GPRSMSClass_mSRadioAccessCapability),
        ])
    GPRSMSClass._ext = None
    
    #-----< MSNetworkCapability >-----#
    MSNetworkCapability = OCT_STR(name=u'MSNetworkCapability', mode=MODE_TYPE)
    MSNetworkCapability._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MSRadioAccessCapability >-----#
    MSRadioAccessCapability = OCT_STR(name=u'MSRadioAccessCapability', mode=MODE_TYPE)
    MSRadioAccessCapability._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< RequestedInfo >-----#
    RequestedInfo = SEQ(name=u'RequestedInfo', mode=MODE_TYPE)
    _RequestedInfo_locationInformation = NULL(name=u'locationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_subscriberState = NULL(name=u'subscriberState', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RequestedInfo_currentLocation = NULL(name=u'currentLocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_requestedDomain = ENUM(name=u'requestedDomain', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'DomainType')), opt=True)
    _RequestedInfo_imei = NULL(name=u'imei', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_ms_classmark = NULL(name=u'ms-classmark', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_mnpRequestedInfo = NULL(name=u'mnpRequestedInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_locationInformationEPS_Supported = NULL(name=u'locationInformationEPS-Supported', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_t_adsData = NULL(name=u't-adsData', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_requestedNodes = BIT_STR(name=u'requestedNodes', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedNodes')), opt=True)
    _RequestedInfo_servingNodeIndication = NULL(name=u'servingNodeIndication', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedInfo_localTimeZoneRequest = NULL(name=u'localTimeZoneRequest', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RequestedInfo._cont = ASN1Dict([
        (u'locationInformation', _RequestedInfo_locationInformation),
        (u'subscriberState', _RequestedInfo_subscriberState),
        (u'extensionContainer', _RequestedInfo_extensionContainer),
        (u'currentLocation', _RequestedInfo_currentLocation),
        (u'requestedDomain', _RequestedInfo_requestedDomain),
        (u'imei', _RequestedInfo_imei),
        (u'ms-classmark', _RequestedInfo_ms_classmark),
        (u'mnpRequestedInfo', _RequestedInfo_mnpRequestedInfo),
        (u'locationInformationEPS-Supported', _RequestedInfo_locationInformationEPS_Supported),
        (u't-adsData', _RequestedInfo_t_adsData),
        (u'requestedNodes', _RequestedInfo_requestedNodes),
        (u'servingNodeIndication', _RequestedInfo_servingNodeIndication),
        (u'localTimeZoneRequest', _RequestedInfo_localTimeZoneRequest),
        ])
    RequestedInfo._ext = [u'currentLocation', u'requestedDomain', u'imei', u'ms-classmark', u'mnpRequestedInfo', u'locationInformationEPS-Supported', u't-adsData', u'requestedNodes', u'servingNodeIndication', u'localTimeZoneRequest']
    
    #-----< DomainType >-----#
    DomainType = ENUM(name=u'DomainType', mode=MODE_TYPE)
    DomainType._cont = ASN1Dict([(u'cs-Domain', 0), (u'ps-Domain', 1)])
    DomainType._ext = []
    
    #-----< RequestedNodes >-----#
    RequestedNodes = BIT_STR(name=u'RequestedNodes', mode=MODE_TYPE)
    RequestedNodes._cont = ASN1Dict([(u'mme', 0), (u'sgsn', 1)])
    RequestedNodes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< LocationInformation >-----#
    LocationInformation = SEQ(name=u'LocationInformation', mode=MODE_TYPE)
    _LocationInformation_ageOfLocationInformation = INT(name=u'ageOfLocationInformation', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformation_geographicalInformation = OCT_STR(name=u'geographicalInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformation_vlr_number = OCT_STR(name=u'vlr-number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformation_locationNumber = OCT_STR(name=u'locationNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationNumber')), opt=True)
    _LocationInformation_cellGlobalIdOrServiceAreaIdOrLAI = CHOICE(name=u'cellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdOrLAI')), opt=True)
    _LocationInformation_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformation_selectedLSA_Id = OCT_STR(name=u'selectedLSA-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')), opt=True)
    _LocationInformation_msc_Number = OCT_STR(name=u'msc-Number', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformation_geodeticInformation = OCT_STR(name=u'geodeticInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformation_currentLocationRetrieved = NULL(name=u'currentLocationRetrieved', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformation_sai_Present = NULL(name=u'sai-Present', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformation_locationInformationEPS = SEQ(name=u'locationInformationEPS', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationEPS')), opt=True)
    _LocationInformation_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UserCSGInformation')), opt=True)
    LocationInformation._cont = ASN1Dict([
        (u'ageOfLocationInformation', _LocationInformation_ageOfLocationInformation),
        (u'geographicalInformation', _LocationInformation_geographicalInformation),
        (u'vlr-number', _LocationInformation_vlr_number),
        (u'locationNumber', _LocationInformation_locationNumber),
        (u'cellGlobalIdOrServiceAreaIdOrLAI', _LocationInformation_cellGlobalIdOrServiceAreaIdOrLAI),
        (u'extensionContainer', _LocationInformation_extensionContainer),
        (u'selectedLSA-Id', _LocationInformation_selectedLSA_Id),
        (u'msc-Number', _LocationInformation_msc_Number),
        (u'geodeticInformation', _LocationInformation_geodeticInformation),
        (u'currentLocationRetrieved', _LocationInformation_currentLocationRetrieved),
        (u'sai-Present', _LocationInformation_sai_Present),
        (u'locationInformationEPS', _LocationInformation_locationInformationEPS),
        (u'userCSGInformation', _LocationInformation_userCSGInformation),
        ])
    LocationInformation._ext = [u'selectedLSA-Id', u'msc-Number', u'geodeticInformation', u'currentLocationRetrieved', u'sai-Present', u'locationInformationEPS', u'userCSGInformation']
    
    #-----< LocationInformationEPS >-----#
    LocationInformationEPS = SEQ(name=u'LocationInformationEPS', mode=MODE_TYPE)
    _LocationInformationEPS_e_utranCellGlobalIdentity = OCT_STR(name=u'e-utranCellGlobalIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'E-UTRAN-CGI')), opt=True)
    _LocationInformationEPS_trackingAreaIdentity = OCT_STR(name=u'trackingAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'TA-Id')), opt=True)
    _LocationInformationEPS_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformationEPS_geographicalInformation = OCT_STR(name=u'geographicalInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformationEPS_geodeticInformation = OCT_STR(name=u'geodeticInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformationEPS_currentLocationRetrieved = NULL(name=u'currentLocationRetrieved', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationEPS_ageOfLocationInformation = INT(name=u'ageOfLocationInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformationEPS_mme_Name = OCT_STR(name=u'mme-Name', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'DiameterIdentity')), opt=True)
    LocationInformationEPS._cont = ASN1Dict([
        (u'e-utranCellGlobalIdentity', _LocationInformationEPS_e_utranCellGlobalIdentity),
        (u'trackingAreaIdentity', _LocationInformationEPS_trackingAreaIdentity),
        (u'extensionContainer', _LocationInformationEPS_extensionContainer),
        (u'geographicalInformation', _LocationInformationEPS_geographicalInformation),
        (u'geodeticInformation', _LocationInformationEPS_geodeticInformation),
        (u'currentLocationRetrieved', _LocationInformationEPS_currentLocationRetrieved),
        (u'ageOfLocationInformation', _LocationInformationEPS_ageOfLocationInformation),
        (u'mme-Name', _LocationInformationEPS_mme_Name),
        ])
    LocationInformationEPS._ext = [u'mme-Name']
    
    #-----< LocationInformationGPRS >-----#
    LocationInformationGPRS = SEQ(name=u'LocationInformationGPRS', mode=MODE_TYPE)
    _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI = CHOICE(name=u'cellGlobalIdOrServiceAreaIdOrLAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'CellGlobalIdOrServiceAreaIdOrLAI')), opt=True)
    _LocationInformationGPRS_routeingAreaIdentity = OCT_STR(name=u'routeingAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')), opt=True)
    _LocationInformationGPRS_geographicalInformation = OCT_STR(name=u'geographicalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformationGPRS_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInformationGPRS_selectedLSAIdentity = OCT_STR(name=u'selectedLSAIdentity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LSAIdentity')), opt=True)
    _LocationInformationGPRS_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformationGPRS_sai_Present = NULL(name=u'sai-Present', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_geodeticInformation = OCT_STR(name=u'geodeticInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformationGPRS_currentLocationRetrieved = NULL(name=u'currentLocationRetrieved', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformationGPRS_ageOfLocationInformation = INT(name=u'ageOfLocationInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformationGPRS_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'UserCSGInformation')), opt=True)
    LocationInformationGPRS._cont = ASN1Dict([
        (u'cellGlobalIdOrServiceAreaIdOrLAI', _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI),
        (u'routeingAreaIdentity', _LocationInformationGPRS_routeingAreaIdentity),
        (u'geographicalInformation', _LocationInformationGPRS_geographicalInformation),
        (u'sgsn-Number', _LocationInformationGPRS_sgsn_Number),
        (u'selectedLSAIdentity', _LocationInformationGPRS_selectedLSAIdentity),
        (u'extensionContainer', _LocationInformationGPRS_extensionContainer),
        (u'sai-Present', _LocationInformationGPRS_sai_Present),
        (u'geodeticInformation', _LocationInformationGPRS_geodeticInformation),
        (u'currentLocationRetrieved', _LocationInformationGPRS_currentLocationRetrieved),
        (u'ageOfLocationInformation', _LocationInformationGPRS_ageOfLocationInformation),
        (u'userCSGInformation', _LocationInformationGPRS_userCSGInformation),
        ])
    LocationInformationGPRS._ext = [u'sai-Present', u'geodeticInformation', u'currentLocationRetrieved', u'ageOfLocationInformation', u'userCSGInformation']
    
    #-----< LocationInformation5GS >-----#
    LocationInformation5GS = SEQ(name=u'LocationInformation5GS', mode=MODE_TYPE)
    _LocationInformation5GS_nrCellGlobalIdentity = OCT_STR(name=u'nrCellGlobalIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NR-CGI')), opt=True)
    _LocationInformation5GS_e_utranCellGlobalIdentity = OCT_STR(name=u'e-utranCellGlobalIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'E-UTRAN-CGI')), opt=True)
    _LocationInformation5GS_geographicalInformation = OCT_STR(name=u'geographicalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeographicalInformation')), opt=True)
    _LocationInformation5GS_geodeticInformation = OCT_STR(name=u'geodeticInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GeodeticInformation')), opt=True)
    _LocationInformation5GS_amf_address = OCT_STR(name=u'amf-address', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'FQDN')), opt=True)
    _LocationInformation5GS_trackingAreaIdentity = OCT_STR(name=u'trackingAreaIdentity', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'TA-Id')), opt=True)
    _LocationInformation5GS_currentLocationRetrieved = NULL(name=u'currentLocationRetrieved', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInformation5GS_ageOfLocationInformation = INT(name=u'ageOfLocationInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LocationInformation5GS_vplmnId = OCT_STR(name=u'vplmnId', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')), opt=True)
    _LocationInformation5GS_localtimeZone = OCT_STR(name=u'localtimeZone', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TimeZone')), opt=True)
    _LocationInformation5GS_rat_Type = ENUM(name=u'rat-Type', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Used-RAT-Type')), opt=True)
    _LocationInformation5GS_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInformation5GS_nrTrackingAreaIdentity = OCT_STR(name=u'nrTrackingAreaIdentity', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NR-TA-Id')), opt=True)
    LocationInformation5GS._cont = ASN1Dict([
        (u'nrCellGlobalIdentity', _LocationInformation5GS_nrCellGlobalIdentity),
        (u'e-utranCellGlobalIdentity', _LocationInformation5GS_e_utranCellGlobalIdentity),
        (u'geographicalInformation', _LocationInformation5GS_geographicalInformation),
        (u'geodeticInformation', _LocationInformation5GS_geodeticInformation),
        (u'amf-address', _LocationInformation5GS_amf_address),
        (u'trackingAreaIdentity', _LocationInformation5GS_trackingAreaIdentity),
        (u'currentLocationRetrieved', _LocationInformation5GS_currentLocationRetrieved),
        (u'ageOfLocationInformation', _LocationInformation5GS_ageOfLocationInformation),
        (u'vplmnId', _LocationInformation5GS_vplmnId),
        (u'localtimeZone', _LocationInformation5GS_localtimeZone),
        (u'rat-Type', _LocationInformation5GS_rat_Type),
        (u'extensionContainer', _LocationInformation5GS_extensionContainer),
        (u'nrTrackingAreaIdentity', _LocationInformation5GS_nrTrackingAreaIdentity),
        ])
    LocationInformation5GS._ext = [u'nrTrackingAreaIdentity']
    
    #-----< UserCSGInformation >-----#
    UserCSGInformation = SEQ(name=u'UserCSGInformation', mode=MODE_TYPE)
    _UserCSGInformation_csg_Id = BIT_STR(name=u'csg-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-Id')))
    _UserCSGInformation_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _UserCSGInformation_accessMode = OCT_STR(name=u'accessMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UserCSGInformation_accessMode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _UserCSGInformation_cmi = OCT_STR(name=u'cmi', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UserCSGInformation_cmi._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    UserCSGInformation._cont = ASN1Dict([
        (u'csg-Id', _UserCSGInformation_csg_Id),
        (u'extensionContainer', _UserCSGInformation_extensionContainer),
        (u'accessMode', _UserCSGInformation_accessMode),
        (u'cmi', _UserCSGInformation_cmi),
        ])
    UserCSGInformation._ext = [u'accessMode', u'cmi']
    
    #-----< GeographicalInformation >-----#
    GeographicalInformation = OCT_STR(name=u'GeographicalInformation', mode=MODE_TYPE)
    GeographicalInformation._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< GeodeticInformation >-----#
    GeodeticInformation = OCT_STR(name=u'GeodeticInformation', mode=MODE_TYPE)
    GeodeticInformation._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< LocationNumber >-----#
    LocationNumber = OCT_STR(name=u'LocationNumber', mode=MODE_TYPE)
    LocationNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=10)], ev=None, er=[])
    
    #-----< SubscriberState >-----#
    SubscriberState = CHOICE(name=u'SubscriberState', mode=MODE_TYPE)
    _SubscriberState_assumedIdle = NULL(name=u'assumedIdle', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubscriberState_camelBusy = NULL(name=u'camelBusy', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubscriberState_netDetNotReachable = ENUM(name=u'netDetNotReachable', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotReachableReason')))
    _SubscriberState_notProvidedFromVLR = NULL(name=u'notProvidedFromVLR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SubscriberState._cont = ASN1Dict([
        (u'assumedIdle', _SubscriberState_assumedIdle),
        (u'camelBusy', _SubscriberState_camelBusy),
        (u'netDetNotReachable', _SubscriberState_netDetNotReachable),
        (u'notProvidedFromVLR', _SubscriberState_notProvidedFromVLR),
        ])
    SubscriberState._ext = None
    
    #-----< PS-SubscriberState >-----#
    PS_SubscriberState = CHOICE(name=u'PS-SubscriberState', mode=MODE_TYPE)
    _PS_SubscriberState_notProvidedFromSGSNorMME = NULL(name=u'notProvidedFromSGSNorMME', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_Detached = NULL(name=u'ps-Detached', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_AttachedNotReachableForPaging = NULL(name=u'ps-AttachedNotReachableForPaging', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_AttachedReachableForPaging = NULL(name=u'ps-AttachedReachableForPaging', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PS_SubscriberState_ps_PDP_ActiveNotReachableForPaging = SEQ_OF(name=u'ps-PDP-ActiveNotReachableForPaging', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-ContextInfoList')))
    _PS_SubscriberState_ps_PDP_ActiveReachableForPaging = SEQ_OF(name=u'ps-PDP-ActiveReachableForPaging', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-ContextInfoList')))
    _PS_SubscriberState_netDetNotReachable = ENUM(name=u'netDetNotReachable', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotReachableReason')))
    PS_SubscriberState._cont = ASN1Dict([
        (u'notProvidedFromSGSNorMME', _PS_SubscriberState_notProvidedFromSGSNorMME),
        (u'ps-Detached', _PS_SubscriberState_ps_Detached),
        (u'ps-AttachedNotReachableForPaging', _PS_SubscriberState_ps_AttachedNotReachableForPaging),
        (u'ps-AttachedReachableForPaging', _PS_SubscriberState_ps_AttachedReachableForPaging),
        (u'ps-PDP-ActiveNotReachableForPaging', _PS_SubscriberState_ps_PDP_ActiveNotReachableForPaging),
        (u'ps-PDP-ActiveReachableForPaging', _PS_SubscriberState_ps_PDP_ActiveReachableForPaging),
        (u'netDetNotReachable', _PS_SubscriberState_netDetNotReachable),
        ])
    PS_SubscriberState._ext = None
    
    #-----< PDP-ContextInfoList >-----#
    PDP_ContextInfoList = SEQ_OF(name=u'PDP-ContextInfoList', mode=MODE_TYPE)
    _PDP_ContextInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-ContextInfo')))
    PDP_ContextInfoList._cont = _PDP_ContextInfoList__item_
    PDP_ContextInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< PDP-ContextInfo >-----#
    PDP_ContextInfo = SEQ(name=u'PDP-ContextInfo', mode=MODE_TYPE)
    _PDP_ContextInfo_pdp_ContextIdentifier = INT(name=u'pdp-ContextIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ContextId')))
    _PDP_ContextInfo_pdp_ContextActive = NULL(name=u'pdp-ContextActive', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PDP_ContextInfo_pdp_Type = OCT_STR(name=u'pdp-Type', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Type')))
    _PDP_ContextInfo_pdp_Address = OCT_STR(name=u'pdp-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    _PDP_ContextInfo_apn_Subscribed = OCT_STR(name=u'apn-Subscribed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')), opt=True)
    _PDP_ContextInfo_apn_InUse = OCT_STR(name=u'apn-InUse', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'APN')), opt=True)
    _PDP_ContextInfo_nsapi = INT(name=u'nsapi', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NSAPI')), opt=True)
    _PDP_ContextInfo_transactionId = OCT_STR(name=u'transactionId', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TransactionId')), opt=True)
    _PDP_ContextInfo_teid_ForGnAndGp = OCT_STR(name=u'teid-ForGnAndGp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TEID')), opt=True)
    _PDP_ContextInfo_teid_ForIu = OCT_STR(name=u'teid-ForIu', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'TEID')), opt=True)
    _PDP_ContextInfo_ggsn_Address = OCT_STR(name=u'ggsn-Address', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _PDP_ContextInfo_qos_Subscribed = OCT_STR(name=u'qos-Subscribed', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos_Requested = OCT_STR(name=u'qos-Requested', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos_Negotiated = OCT_STR(name=u'qos-Negotiated', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_chargingId = OCT_STR(name=u'chargingId', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRSChargingID')), opt=True)
    _PDP_ContextInfo_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ChargingCharacteristics')), opt=True)
    _PDP_ContextInfo_rnc_Address = OCT_STR(name=u'rnc-Address', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _PDP_ContextInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _PDP_ContextInfo_qos2_Subscribed = OCT_STR(name=u'qos2-Subscribed', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos2_Requested = OCT_STR(name=u'qos2-Requested', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos2_Negotiated = OCT_STR(name=u'qos2-Negotiated', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext2-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos3_Subscribed = OCT_STR(name=u'qos3-Subscribed', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos3_Requested = OCT_STR(name=u'qos3-Requested', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos3_Negotiated = OCT_STR(name=u'qos3-Negotiated', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext3-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos4_Subscribed = OCT_STR(name=u'qos4-Subscribed', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos4_Requested = OCT_STR(name=u'qos4-Requested', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_qos4_Negotiated = OCT_STR(name=u'qos4-Negotiated', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext4-QoS-Subscribed')), opt=True)
    _PDP_ContextInfo_ext_pdp_Type = OCT_STR(name=u'ext-pdp-Type', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-PDP-Type')), opt=True)
    _PDP_ContextInfo_ext_pdp_Address = OCT_STR(name=u'ext-pdp-Address', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'PDP-Address')), opt=True)
    PDP_ContextInfo._cont = ASN1Dict([
        (u'pdp-ContextIdentifier', _PDP_ContextInfo_pdp_ContextIdentifier),
        (u'pdp-ContextActive', _PDP_ContextInfo_pdp_ContextActive),
        (u'pdp-Type', _PDP_ContextInfo_pdp_Type),
        (u'pdp-Address', _PDP_ContextInfo_pdp_Address),
        (u'apn-Subscribed', _PDP_ContextInfo_apn_Subscribed),
        (u'apn-InUse', _PDP_ContextInfo_apn_InUse),
        (u'nsapi', _PDP_ContextInfo_nsapi),
        (u'transactionId', _PDP_ContextInfo_transactionId),
        (u'teid-ForGnAndGp', _PDP_ContextInfo_teid_ForGnAndGp),
        (u'teid-ForIu', _PDP_ContextInfo_teid_ForIu),
        (u'ggsn-Address', _PDP_ContextInfo_ggsn_Address),
        (u'qos-Subscribed', _PDP_ContextInfo_qos_Subscribed),
        (u'qos-Requested', _PDP_ContextInfo_qos_Requested),
        (u'qos-Negotiated', _PDP_ContextInfo_qos_Negotiated),
        (u'chargingId', _PDP_ContextInfo_chargingId),
        (u'chargingCharacteristics', _PDP_ContextInfo_chargingCharacteristics),
        (u'rnc-Address', _PDP_ContextInfo_rnc_Address),
        (u'extensionContainer', _PDP_ContextInfo_extensionContainer),
        (u'qos2-Subscribed', _PDP_ContextInfo_qos2_Subscribed),
        (u'qos2-Requested', _PDP_ContextInfo_qos2_Requested),
        (u'qos2-Negotiated', _PDP_ContextInfo_qos2_Negotiated),
        (u'qos3-Subscribed', _PDP_ContextInfo_qos3_Subscribed),
        (u'qos3-Requested', _PDP_ContextInfo_qos3_Requested),
        (u'qos3-Negotiated', _PDP_ContextInfo_qos3_Negotiated),
        (u'qos4-Subscribed', _PDP_ContextInfo_qos4_Subscribed),
        (u'qos4-Requested', _PDP_ContextInfo_qos4_Requested),
        (u'qos4-Negotiated', _PDP_ContextInfo_qos4_Negotiated),
        (u'ext-pdp-Type', _PDP_ContextInfo_ext_pdp_Type),
        (u'ext-pdp-Address', _PDP_ContextInfo_ext_pdp_Address),
        ])
    PDP_ContextInfo._ext = [u'qos2-Subscribed', u'qos2-Requested', u'qos2-Negotiated', u'qos3-Subscribed', u'qos3-Requested', u'qos3-Negotiated', u'qos4-Subscribed', u'qos4-Requested', u'qos4-Negotiated', u'ext-pdp-Type', u'ext-pdp-Address']
    
    #-----< NSAPI >-----#
    NSAPI = INT(name=u'NSAPI', mode=MODE_TYPE)
    NSAPI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< TransactionId >-----#
    TransactionId = OCT_STR(name=u'TransactionId', mode=MODE_TYPE)
    TransactionId._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< TEID >-----#
    TEID = OCT_STR(name=u'TEID', mode=MODE_TYPE)
    TEID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GPRSChargingID >-----#
    GPRSChargingID = OCT_STR(name=u'GPRSChargingID', mode=MODE_TYPE)
    GPRSChargingID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< NotReachableReason >-----#
    NotReachableReason = ENUM(name=u'NotReachableReason', mode=MODE_TYPE)
    NotReachableReason._cont = ASN1Dict([(u'msPurged', 0), (u'imsiDetached', 1), (u'restrictedArea', 2), (u'notRegistered', 3)])
    NotReachableReason._ext = None
    
    #-----< AnyTimeInterrogationArg >-----#
    AnyTimeInterrogationArg = SEQ(name=u'AnyTimeInterrogationArg', mode=MODE_TYPE)
    _AnyTimeInterrogationArg_subscriberIdentity = CHOICE(name=u'subscriberIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _AnyTimeInterrogationArg_requestedInfo = SEQ(name=u'requestedInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedInfo')))
    _AnyTimeInterrogationArg_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _AnyTimeInterrogationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AnyTimeInterrogationArg._cont = ASN1Dict([
        (u'subscriberIdentity', _AnyTimeInterrogationArg_subscriberIdentity),
        (u'requestedInfo', _AnyTimeInterrogationArg_requestedInfo),
        (u'gsmSCF-Address', _AnyTimeInterrogationArg_gsmSCF_Address),
        (u'extensionContainer', _AnyTimeInterrogationArg_extensionContainer),
        ])
    AnyTimeInterrogationArg._ext = []
    
    #-----< AnyTimeInterrogationRes >-----#
    AnyTimeInterrogationRes = SEQ(name=u'AnyTimeInterrogationRes', mode=MODE_TYPE)
    _AnyTimeInterrogationRes_subscriberInfo = SEQ(name=u'subscriberInfo', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'SubscriberInfo')))
    _AnyTimeInterrogationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AnyTimeInterrogationRes._cont = ASN1Dict([
        (u'subscriberInfo', _AnyTimeInterrogationRes_subscriberInfo),
        (u'extensionContainer', _AnyTimeInterrogationRes_extensionContainer),
        ])
    AnyTimeInterrogationRes._ext = []
    
    #-----< AnyTimeSubscriptionInterrogationArg >-----#
    AnyTimeSubscriptionInterrogationArg = SEQ(name=u'AnyTimeSubscriptionInterrogationArg', mode=MODE_TYPE)
    _AnyTimeSubscriptionInterrogationArg_subscriberIdentity = CHOICE(name=u'subscriberIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _AnyTimeSubscriptionInterrogationArg_requestedSubscriptionInfo = SEQ(name=u'requestedSubscriptionInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedSubscriptionInfo')))
    _AnyTimeSubscriptionInterrogationArg_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _AnyTimeSubscriptionInterrogationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeSubscriptionInterrogationArg_longFTN_Supported = NULL(name=u'longFTN-Supported', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    AnyTimeSubscriptionInterrogationArg._cont = ASN1Dict([
        (u'subscriberIdentity', _AnyTimeSubscriptionInterrogationArg_subscriberIdentity),
        (u'requestedSubscriptionInfo', _AnyTimeSubscriptionInterrogationArg_requestedSubscriptionInfo),
        (u'gsmSCF-Address', _AnyTimeSubscriptionInterrogationArg_gsmSCF_Address),
        (u'extensionContainer', _AnyTimeSubscriptionInterrogationArg_extensionContainer),
        (u'longFTN-Supported', _AnyTimeSubscriptionInterrogationArg_longFTN_Supported),
        ])
    AnyTimeSubscriptionInterrogationArg._ext = []
    
    #-----< AnyTimeSubscriptionInterrogationRes >-----#
    AnyTimeSubscriptionInterrogationRes = SEQ(name=u'AnyTimeSubscriptionInterrogationRes', mode=MODE_TYPE)
    _AnyTimeSubscriptionInterrogationRes_callForwardingData = SEQ(name=u'callForwardingData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallForwardingData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_callBarringData = SEQ(name=u'callBarringData', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallBarringData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_odb_Info = SEQ(name=u'odb-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Info')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_camel_SubscriptionInfo = SEQ(name=u'camel-SubscriptionInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CAMEL-SubscriptionInfo')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_supportedVLR_CAMEL_Phases = BIT_STR(name=u'supportedVLR-CAMEL-Phases', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_supportedSGSN_CAMEL_Phases = BIT_STR(name=u'supportedSGSN-CAMEL-Phases', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInVLR = BIT_STR(name=u'offeredCamel4CSIsInVLR', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInSGSN = BIT_STR(name=u'offeredCamel4CSIsInSGSN', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4CSIs')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_msisdn_BS_List = SEQ_OF(name=u'msisdn-BS-List', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSISDN-BS-List')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_csg_SubscriptionDataList = SEQ_OF(name=u'csg-SubscriptionDataList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_cw_Data = SEQ(name=u'cw-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallWaitingData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_ch_Data = SEQ(name=u'ch-Data', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallHoldData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_clip_Data = SEQ(name=u'clip-Data', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClipData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_clir_Data = SEQ(name=u'clir-Data', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClirData')), opt=True)
    _AnyTimeSubscriptionInterrogationRes_ect_data = SEQ(name=u'ect-data', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EctData')), opt=True)
    AnyTimeSubscriptionInterrogationRes._cont = ASN1Dict([
        (u'callForwardingData', _AnyTimeSubscriptionInterrogationRes_callForwardingData),
        (u'callBarringData', _AnyTimeSubscriptionInterrogationRes_callBarringData),
        (u'odb-Info', _AnyTimeSubscriptionInterrogationRes_odb_Info),
        (u'camel-SubscriptionInfo', _AnyTimeSubscriptionInterrogationRes_camel_SubscriptionInfo),
        (u'supportedVLR-CAMEL-Phases', _AnyTimeSubscriptionInterrogationRes_supportedVLR_CAMEL_Phases),
        (u'supportedSGSN-CAMEL-Phases', _AnyTimeSubscriptionInterrogationRes_supportedSGSN_CAMEL_Phases),
        (u'extensionContainer', _AnyTimeSubscriptionInterrogationRes_extensionContainer),
        (u'offeredCamel4CSIsInVLR', _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInVLR),
        (u'offeredCamel4CSIsInSGSN', _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInSGSN),
        (u'msisdn-BS-List', _AnyTimeSubscriptionInterrogationRes_msisdn_BS_List),
        (u'csg-SubscriptionDataList', _AnyTimeSubscriptionInterrogationRes_csg_SubscriptionDataList),
        (u'cw-Data', _AnyTimeSubscriptionInterrogationRes_cw_Data),
        (u'ch-Data', _AnyTimeSubscriptionInterrogationRes_ch_Data),
        (u'clip-Data', _AnyTimeSubscriptionInterrogationRes_clip_Data),
        (u'clir-Data', _AnyTimeSubscriptionInterrogationRes_clir_Data),
        (u'ect-data', _AnyTimeSubscriptionInterrogationRes_ect_data),
        ])
    AnyTimeSubscriptionInterrogationRes._ext = [u'offeredCamel4CSIsInVLR', u'offeredCamel4CSIsInSGSN', u'msisdn-BS-List', u'csg-SubscriptionDataList', u'cw-Data', u'ch-Data', u'clip-Data', u'clir-Data', u'ect-data']
    
    #-----< CallWaitingData >-----#
    CallWaitingData = SEQ(name=u'CallWaitingData', mode=MODE_TYPE)
    _CallWaitingData_cwFeatureList = SEQ_OF(name=u'cwFeatureList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CwFeatureList')))
    _CallWaitingData_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CallWaitingData._cont = ASN1Dict([
        (u'cwFeatureList', _CallWaitingData_cwFeatureList),
        (u'notificationToCSE', _CallWaitingData_notificationToCSE),
        ])
    CallWaitingData._ext = []
    
    #-----< Ext-CwFeatureList >-----#
    Ext_CwFeatureList = SEQ_OF(name=u'Ext-CwFeatureList', mode=MODE_TYPE)
    _Ext_CwFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CwFeature')))
    Ext_CwFeatureList._cont = _Ext_CwFeatureList__item_
    Ext_CwFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Ext-CwFeature >-----#
    Ext_CwFeature = SEQ(name=u'Ext-CwFeature', mode=MODE_TYPE)
    _Ext_CwFeature_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')))
    _Ext_CwFeature_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    Ext_CwFeature._cont = ASN1Dict([
        (u'basicService', _Ext_CwFeature_basicService),
        (u'ss-Status', _Ext_CwFeature_ss_Status),
        ])
    Ext_CwFeature._ext = []
    
    #-----< ClipData >-----#
    ClipData = SEQ(name=u'ClipData', mode=MODE_TYPE)
    _ClipData_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _ClipData_overrideCategory = ENUM(name=u'overrideCategory', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'OverrideCategory')))
    _ClipData_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ClipData._cont = ASN1Dict([
        (u'ss-Status', _ClipData_ss_Status),
        (u'overrideCategory', _ClipData_overrideCategory),
        (u'notificationToCSE', _ClipData_notificationToCSE),
        ])
    ClipData._ext = []
    
    #-----< ClirData >-----#
    ClirData = SEQ(name=u'ClirData', mode=MODE_TYPE)
    _ClirData_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _ClirData_cliRestrictionOption = ENUM(name=u'cliRestrictionOption', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')), opt=True)
    _ClirData_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ClirData._cont = ASN1Dict([
        (u'ss-Status', _ClirData_ss_Status),
        (u'cliRestrictionOption', _ClirData_cliRestrictionOption),
        (u'notificationToCSE', _ClirData_notificationToCSE),
        ])
    ClirData._ext = []
    
    #-----< CallHoldData >-----#
    CallHoldData = SEQ(name=u'CallHoldData', mode=MODE_TYPE)
    _CallHoldData_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _CallHoldData_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CallHoldData._cont = ASN1Dict([
        (u'ss-Status', _CallHoldData_ss_Status),
        (u'notificationToCSE', _CallHoldData_notificationToCSE),
        ])
    CallHoldData._ext = []
    
    #-----< EctData >-----#
    EctData = SEQ(name=u'EctData', mode=MODE_TYPE)
    _EctData_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')))
    _EctData_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    EctData._cont = ASN1Dict([
        (u'ss-Status', _EctData_ss_Status),
        (u'notificationToCSE', _EctData_notificationToCSE),
        ])
    EctData._ext = []
    
    #-----< RequestedSubscriptionInfo >-----#
    RequestedSubscriptionInfo = SEQ(name=u'RequestedSubscriptionInfo', mode=MODE_TYPE)
    _RequestedSubscriptionInfo_requestedSS_Info = SEQ(name=u'requestedSS-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-ForBS-Code')), opt=True)
    _RequestedSubscriptionInfo_odb = NULL(name=u'odb', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_requestedCAMEL_SubscriptionInfo = ENUM(name=u'requestedCAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedCAMEL-SubscriptionInfo')), opt=True)
    _RequestedSubscriptionInfo_supportedVLR_CAMEL_Phases = NULL(name=u'supportedVLR-CAMEL-Phases', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_supportedSGSN_CAMEL_Phases = NULL(name=u'supportedSGSN-CAMEL-Phases', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RequestedSubscriptionInfo_additionalRequestedCAMEL_SubscriptionInfo = ENUM(name=u'additionalRequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalRequestedCAMEL-SubscriptionInfo')), opt=True)
    _RequestedSubscriptionInfo_msisdn_BS_List = NULL(name=u'msisdn-BS-List', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_csg_SubscriptionDataRequested = NULL(name=u'csg-SubscriptionDataRequested', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_cw_Info = NULL(name=u'cw-Info', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_clip_Info = NULL(name=u'clip-Info', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_clir_Info = NULL(name=u'clir-Info', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_hold_Info = NULL(name=u'hold-Info', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestedSubscriptionInfo_ect_Info = NULL(name=u'ect-Info', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RequestedSubscriptionInfo._cont = ASN1Dict([
        (u'requestedSS-Info', _RequestedSubscriptionInfo_requestedSS_Info),
        (u'odb', _RequestedSubscriptionInfo_odb),
        (u'requestedCAMEL-SubscriptionInfo', _RequestedSubscriptionInfo_requestedCAMEL_SubscriptionInfo),
        (u'supportedVLR-CAMEL-Phases', _RequestedSubscriptionInfo_supportedVLR_CAMEL_Phases),
        (u'supportedSGSN-CAMEL-Phases', _RequestedSubscriptionInfo_supportedSGSN_CAMEL_Phases),
        (u'extensionContainer', _RequestedSubscriptionInfo_extensionContainer),
        (u'additionalRequestedCAMEL-SubscriptionInfo', _RequestedSubscriptionInfo_additionalRequestedCAMEL_SubscriptionInfo),
        (u'msisdn-BS-List', _RequestedSubscriptionInfo_msisdn_BS_List),
        (u'csg-SubscriptionDataRequested', _RequestedSubscriptionInfo_csg_SubscriptionDataRequested),
        (u'cw-Info', _RequestedSubscriptionInfo_cw_Info),
        (u'clip-Info', _RequestedSubscriptionInfo_clip_Info),
        (u'clir-Info', _RequestedSubscriptionInfo_clir_Info),
        (u'hold-Info', _RequestedSubscriptionInfo_hold_Info),
        (u'ect-Info', _RequestedSubscriptionInfo_ect_Info),
        ])
    RequestedSubscriptionInfo._ext = [u'additionalRequestedCAMEL-SubscriptionInfo', u'msisdn-BS-List', u'csg-SubscriptionDataRequested', u'cw-Info', u'clip-Info', u'clir-Info', u'hold-Info', u'ect-Info']
    
    #-----< MSISDN-BS-List >-----#
    MSISDN_BS_List = SEQ_OF(name=u'MSISDN-BS-List', mode=MODE_TYPE)
    _MSISDN_BS_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'MSISDN-BS')))
    MSISDN_BS_List._cont = _MSISDN_BS_List__item_
    MSISDN_BS_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    
    #-----< maxNumOfMSISDN >-----#
    maxNumOfMSISDN = INT(name=u'maxNumOfMSISDN', mode=MODE_VALUE)
    maxNumOfMSISDN._val = 50
    
    #-----< MSISDN-BS >-----#
    MSISDN_BS = SEQ(name=u'MSISDN-BS', mode=MODE_TYPE)
    _MSISDN_BS_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _MSISDN_BS_basicServiceList = SEQ_OF(name=u'basicServiceList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'BasicServiceList')), opt=True)
    _MSISDN_BS_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MSISDN_BS._cont = ASN1Dict([
        (u'msisdn', _MSISDN_BS_msisdn),
        (u'basicServiceList', _MSISDN_BS_basicServiceList),
        (u'extensionContainer', _MSISDN_BS_extensionContainer),
        ])
    MSISDN_BS._ext = []
    
    #-----< RequestedCAMEL-SubscriptionInfo >-----#
    RequestedCAMEL_SubscriptionInfo = ENUM(name=u'RequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE)
    RequestedCAMEL_SubscriptionInfo._cont = ASN1Dict([(u'o-CSI', 0), (u't-CSI', 1), (u'vt-CSI', 2), (u'tif-CSI', 3), (u'gprs-CSI', 4), (u'mo-sms-CSI', 5), (u'ss-CSI', 6), (u'm-CSI', 7), (u'd-csi', 8)])
    RequestedCAMEL_SubscriptionInfo._ext = None
    
    #-----< AdditionalRequestedCAMEL-SubscriptionInfo >-----#
    AdditionalRequestedCAMEL_SubscriptionInfo = ENUM(name=u'AdditionalRequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE)
    AdditionalRequestedCAMEL_SubscriptionInfo._cont = ASN1Dict([(u'mt-sms-CSI', 0), (u'mg-csi', 1), (u'o-IM-CSI', 2), (u'd-IM-CSI', 3), (u'vt-IM-CSI', 4)])
    AdditionalRequestedCAMEL_SubscriptionInfo._ext = []
    
    #-----< CallForwardingData >-----#
    CallForwardingData = SEQ(name=u'CallForwardingData', mode=MODE_TYPE)
    _CallForwardingData_forwardingFeatureList = SEQ_OF(name=u'forwardingFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeatureList')))
    _CallForwardingData_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, opt=True)
    _CallForwardingData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CallForwardingData._cont = ASN1Dict([
        (u'forwardingFeatureList', _CallForwardingData_forwardingFeatureList),
        (u'notificationToCSE', _CallForwardingData_notificationToCSE),
        (u'extensionContainer', _CallForwardingData_extensionContainer),
        ])
    CallForwardingData._ext = []
    
    #-----< CallBarringData >-----#
    CallBarringData = SEQ(name=u'CallBarringData', mode=MODE_TYPE)
    _CallBarringData_callBarringFeatureList = SEQ_OF(name=u'callBarringFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarFeatureList')))
    _CallBarringData_password = STR_NUM(name=u'password', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'Password')), opt=True)
    _CallBarringData_password._const_alpha = ASN1Set(rv=[u'0', u'1', u'2', u'3', u'4', u'5', u'6', u'7', u'8', u'9'], rr=[], ev=None, er=[])
    _CallBarringData_wrongPasswordAttemptsCounter = INT(name=u'wrongPasswordAttemptsCounter', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'WrongPasswordAttemptsCounter')), opt=True)
    _CallBarringData_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, opt=True)
    _CallBarringData_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CallBarringData._cont = ASN1Dict([
        (u'callBarringFeatureList', _CallBarringData_callBarringFeatureList),
        (u'password', _CallBarringData_password),
        (u'wrongPasswordAttemptsCounter', _CallBarringData_wrongPasswordAttemptsCounter),
        (u'notificationToCSE', _CallBarringData_notificationToCSE),
        (u'extensionContainer', _CallBarringData_extensionContainer),
        ])
    CallBarringData._ext = []
    
    #-----< WrongPasswordAttemptsCounter >-----#
    WrongPasswordAttemptsCounter = INT(name=u'WrongPasswordAttemptsCounter', mode=MODE_TYPE)
    WrongPasswordAttemptsCounter._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4)], ev=None, er=[])
    
    #-----< ODB-Info >-----#
    ODB_Info = SEQ(name=u'ODB-Info', mode=MODE_TYPE)
    _ODB_Info_odb_Data = SEQ(name=u'odb-Data', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')))
    _ODB_Info_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, opt=True)
    _ODB_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ODB_Info._cont = ASN1Dict([
        (u'odb-Data', _ODB_Info_odb_Data),
        (u'notificationToCSE', _ODB_Info_notificationToCSE),
        (u'extensionContainer', _ODB_Info_extensionContainer),
        ])
    ODB_Info._ext = []
    
    #-----< CAMEL-SubscriptionInfo >-----#
    CAMEL_SubscriptionInfo = SEQ(name=u'CAMEL-SubscriptionInfo', mode=MODE_TYPE)
    _CAMEL_SubscriptionInfo_o_CSI = SEQ(name=u'o-CSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_o_BcsmCamelTDP_CriteriaList = SEQ_OF(name=u'o-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_d_CSI = SEQ(name=u'd-CSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_t_CSI = SEQ(name=u't-CSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name=u't-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_vt_CSI = SEQ(name=u'vt-CSI', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_vt_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name=u'vt-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_tif_CSI = NULL(name=u'tif-CSI', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAMEL_SubscriptionInfo_tif_CSI_NotificationToCSE = NULL(name=u'tif-CSI-NotificationToCSE', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CAMEL_SubscriptionInfo_gprs_CSI = SEQ(name=u'gprs-CSI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'GPRS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_mo_sms_CSI = SEQ(name=u'mo-sms-CSI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_ss_CSI = SEQ(name=u'ss-CSI', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_m_CSI = SEQ(name=u'm-CSI', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'M-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _CAMEL_SubscriptionInfo_specificCSIDeletedList = BIT_STR(name=u'specificCSIDeletedList', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SpecificCSI-Withdraw')), opt=True)
    _CAMEL_SubscriptionInfo_mt_sms_CSI = SEQ(name=u'mt-sms-CSI', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SMS-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList = SEQ_OF(name=u'mt-smsCAMELTDP-CriteriaList', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MT-smsCAMELTDP-CriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_mg_csi = SEQ(name=u'mg-csi', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MG-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_o_IM_CSI = SEQ(name=u'o-IM-CSI', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_o_IM_BcsmCamelTDP_CriteriaList = SEQ_OF(name=u'o-IM-BcsmCamelTDP-CriteriaList', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'O-BcsmCamelTDPCriteriaList')), opt=True)
    _CAMEL_SubscriptionInfo_d_IM_CSI = SEQ(name=u'd-IM-CSI', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'D-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_vt_IM_CSI = SEQ(name=u'vt-IM-CSI', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-CSI')), opt=True)
    _CAMEL_SubscriptionInfo_vt_IM_BCSM_CAMEL_TDP_CriteriaList = SEQ_OF(name=u'vt-IM-BCSM-CAMEL-TDP-CriteriaList', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'T-BCSM-CAMEL-TDP-CriteriaList')), opt=True)
    CAMEL_SubscriptionInfo._cont = ASN1Dict([
        (u'o-CSI', _CAMEL_SubscriptionInfo_o_CSI),
        (u'o-BcsmCamelTDP-CriteriaList', _CAMEL_SubscriptionInfo_o_BcsmCamelTDP_CriteriaList),
        (u'd-CSI', _CAMEL_SubscriptionInfo_d_CSI),
        (u't-CSI', _CAMEL_SubscriptionInfo_t_CSI),
        (u't-BCSM-CAMEL-TDP-CriteriaList', _CAMEL_SubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList),
        (u'vt-CSI', _CAMEL_SubscriptionInfo_vt_CSI),
        (u'vt-BCSM-CAMEL-TDP-CriteriaList', _CAMEL_SubscriptionInfo_vt_BCSM_CAMEL_TDP_CriteriaList),
        (u'tif-CSI', _CAMEL_SubscriptionInfo_tif_CSI),
        (u'tif-CSI-NotificationToCSE', _CAMEL_SubscriptionInfo_tif_CSI_NotificationToCSE),
        (u'gprs-CSI', _CAMEL_SubscriptionInfo_gprs_CSI),
        (u'mo-sms-CSI', _CAMEL_SubscriptionInfo_mo_sms_CSI),
        (u'ss-CSI', _CAMEL_SubscriptionInfo_ss_CSI),
        (u'm-CSI', _CAMEL_SubscriptionInfo_m_CSI),
        (u'extensionContainer', _CAMEL_SubscriptionInfo_extensionContainer),
        (u'specificCSIDeletedList', _CAMEL_SubscriptionInfo_specificCSIDeletedList),
        (u'mt-sms-CSI', _CAMEL_SubscriptionInfo_mt_sms_CSI),
        (u'mt-smsCAMELTDP-CriteriaList', _CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList),
        (u'mg-csi', _CAMEL_SubscriptionInfo_mg_csi),
        (u'o-IM-CSI', _CAMEL_SubscriptionInfo_o_IM_CSI),
        (u'o-IM-BcsmCamelTDP-CriteriaList', _CAMEL_SubscriptionInfo_o_IM_BcsmCamelTDP_CriteriaList),
        (u'd-IM-CSI', _CAMEL_SubscriptionInfo_d_IM_CSI),
        (u'vt-IM-CSI', _CAMEL_SubscriptionInfo_vt_IM_CSI),
        (u'vt-IM-BCSM-CAMEL-TDP-CriteriaList', _CAMEL_SubscriptionInfo_vt_IM_BCSM_CAMEL_TDP_CriteriaList),
        ])
    CAMEL_SubscriptionInfo._ext = [u'specificCSIDeletedList', u'mt-sms-CSI', u'mt-smsCAMELTDP-CriteriaList', u'mg-csi', u'o-IM-CSI', u'o-IM-BcsmCamelTDP-CriteriaList', u'd-IM-CSI', u'vt-IM-CSI', u'vt-IM-BCSM-CAMEL-TDP-CriteriaList']
    
    #-----< AnyTimeModificationArg >-----#
    AnyTimeModificationArg = SEQ(name=u'AnyTimeModificationArg', mode=MODE_TYPE)
    _AnyTimeModificationArg_subscriberIdentity = CHOICE(name=u'subscriberIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SubscriberIdentity')))
    _AnyTimeModificationArg_gsmSCF_Address = OCT_STR(name=u'gsmSCF-Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _AnyTimeModificationArg_modificationRequestFor_CF_Info = SEQ(name=u'modificationRequestFor-CF-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CF-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CB_Info = SEQ(name=u'modificationRequestFor-CB-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CB-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CSI = SEQ(name=u'modificationRequestFor-CSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CSI')), opt=True)
    _AnyTimeModificationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeModificationArg_longFTN_Supported = NULL(name=u'longFTN-Supported', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_ODB_data = SEQ(name=u'modificationRequestFor-ODB-data', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-ODB-data')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_IP_SM_GW_Data = SEQ(name=u'modificationRequestFor-IP-SM-GW-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-IP-SM-GW-Data')), opt=True)
    _AnyTimeModificationArg_activationRequestForUE_reachability = BIT_STR(name=u'activationRequestForUE-reachability', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedServingNode')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CSG = SEQ(name=u'modificationRequestFor-CSG', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CSG')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CW_Data = SEQ(name=u'modificationRequestFor-CW-Data', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CW-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CLIP_Data = SEQ(name=u'modificationRequestFor-CLIP-Data', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CLIP-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_CLIR_Data = SEQ(name=u'modificationRequestFor-CLIR-Data', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CLIR-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_HOLD_Data = SEQ(name=u'modificationRequestFor-HOLD-Data', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-CH-Info')), opt=True)
    _AnyTimeModificationArg_modificationRequestFor_ECT_Data = SEQ(name=u'modificationRequestFor-ECT-Data', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationRequestFor-ECT-Info')), opt=True)
    AnyTimeModificationArg._cont = ASN1Dict([
        (u'subscriberIdentity', _AnyTimeModificationArg_subscriberIdentity),
        (u'gsmSCF-Address', _AnyTimeModificationArg_gsmSCF_Address),
        (u'modificationRequestFor-CF-Info', _AnyTimeModificationArg_modificationRequestFor_CF_Info),
        (u'modificationRequestFor-CB-Info', _AnyTimeModificationArg_modificationRequestFor_CB_Info),
        (u'modificationRequestFor-CSI', _AnyTimeModificationArg_modificationRequestFor_CSI),
        (u'extensionContainer', _AnyTimeModificationArg_extensionContainer),
        (u'longFTN-Supported', _AnyTimeModificationArg_longFTN_Supported),
        (u'modificationRequestFor-ODB-data', _AnyTimeModificationArg_modificationRequestFor_ODB_data),
        (u'modificationRequestFor-IP-SM-GW-Data', _AnyTimeModificationArg_modificationRequestFor_IP_SM_GW_Data),
        (u'activationRequestForUE-reachability', _AnyTimeModificationArg_activationRequestForUE_reachability),
        (u'modificationRequestFor-CSG', _AnyTimeModificationArg_modificationRequestFor_CSG),
        (u'modificationRequestFor-CW-Data', _AnyTimeModificationArg_modificationRequestFor_CW_Data),
        (u'modificationRequestFor-CLIP-Data', _AnyTimeModificationArg_modificationRequestFor_CLIP_Data),
        (u'modificationRequestFor-CLIR-Data', _AnyTimeModificationArg_modificationRequestFor_CLIR_Data),
        (u'modificationRequestFor-HOLD-Data', _AnyTimeModificationArg_modificationRequestFor_HOLD_Data),
        (u'modificationRequestFor-ECT-Data', _AnyTimeModificationArg_modificationRequestFor_ECT_Data),
        ])
    AnyTimeModificationArg._ext = [u'modificationRequestFor-ODB-data', u'modificationRequestFor-IP-SM-GW-Data', u'activationRequestForUE-reachability', u'modificationRequestFor-CSG', u'modificationRequestFor-CW-Data', u'modificationRequestFor-CLIP-Data', u'modificationRequestFor-CLIR-Data', u'modificationRequestFor-HOLD-Data', u'modificationRequestFor-ECT-Data']
    
    #-----< ModificationRequestFor-CW-Info >-----#
    ModificationRequestFor_CW_Info = SEQ(name=u'ModificationRequestFor-CW-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CW_Info_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ModificationRequestFor_CW_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CW_Info_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CW_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CW_Info._cont = ASN1Dict([
        (u'basicService', _ModificationRequestFor_CW_Info_basicService),
        (u'ss-Status', _ModificationRequestFor_CW_Info_ss_Status),
        (u'modifyNotificationToCSE', _ModificationRequestFor_CW_Info_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_CW_Info_extensionContainer),
        ])
    ModificationRequestFor_CW_Info._ext = []
    
    #-----< ModificationRequestFor-CH-Info >-----#
    ModificationRequestFor_CH_Info = SEQ(name=u'ModificationRequestFor-CH-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CH_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CH_Info_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CH_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CH_Info._cont = ASN1Dict([
        (u'ss-Status', _ModificationRequestFor_CH_Info_ss_Status),
        (u'modifyNotificationToCSE', _ModificationRequestFor_CH_Info_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_CH_Info_extensionContainer),
        ])
    ModificationRequestFor_CH_Info._ext = []
    
    #-----< ModificationRequestFor-ECT-Info >-----#
    ModificationRequestFor_ECT_Info = SEQ(name=u'ModificationRequestFor-ECT-Info', mode=MODE_TYPE)
    _ModificationRequestFor_ECT_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_ECT_Info_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_ECT_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_ECT_Info._cont = ASN1Dict([
        (u'ss-Status', _ModificationRequestFor_ECT_Info_ss_Status),
        (u'modifyNotificationToCSE', _ModificationRequestFor_ECT_Info_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_ECT_Info_extensionContainer),
        ])
    ModificationRequestFor_ECT_Info._ext = []
    
    #-----< ModificationRequestFor-CLIR-Info >-----#
    ModificationRequestFor_CLIR_Info = SEQ(name=u'ModificationRequestFor-CLIR-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CLIR_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CLIR_Info_cliRestrictionOption = ENUM(name=u'cliRestrictionOption', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')), opt=True)
    _ModificationRequestFor_CLIR_Info_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CLIR_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CLIR_Info._cont = ASN1Dict([
        (u'ss-Status', _ModificationRequestFor_CLIR_Info_ss_Status),
        (u'cliRestrictionOption', _ModificationRequestFor_CLIR_Info_cliRestrictionOption),
        (u'modifyNotificationToCSE', _ModificationRequestFor_CLIR_Info_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_CLIR_Info_extensionContainer),
        ])
    ModificationRequestFor_CLIR_Info._ext = []
    
    #-----< ModificationRequestFor-CLIP-Info >-----#
    ModificationRequestFor_CLIP_Info = SEQ(name=u'ModificationRequestFor-CLIP-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CLIP_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CLIP_Info_overrideCategory = ENUM(name=u'overrideCategory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'OverrideCategory')), opt=True)
    _ModificationRequestFor_CLIP_Info_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CLIP_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CLIP_Info._cont = ASN1Dict([
        (u'ss-Status', _ModificationRequestFor_CLIP_Info_ss_Status),
        (u'overrideCategory', _ModificationRequestFor_CLIP_Info_overrideCategory),
        (u'modifyNotificationToCSE', _ModificationRequestFor_CLIP_Info_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_CLIP_Info_extensionContainer),
        ])
    ModificationRequestFor_CLIP_Info._ext = []
    
    #-----< ModificationRequestFor-CSG >-----#
    ModificationRequestFor_CSG = SEQ(name=u'ModificationRequestFor-CSG', mode=MODE_TYPE)
    _ModificationRequestFor_CSG_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CSG_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CSG._cont = ASN1Dict([
        (u'modifyNotificationToCSE', _ModificationRequestFor_CSG_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_CSG_extensionContainer),
        ])
    ModificationRequestFor_CSG._ext = []
    
    #-----< RequestedServingNode >-----#
    RequestedServingNode = BIT_STR(name=u'RequestedServingNode', mode=MODE_TYPE)
    RequestedServingNode._cont = ASN1Dict([(u'mmeAndSgsn', 0)])
    RequestedServingNode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ServingNode >-----#
    ServingNode = BIT_STR(name=u'ServingNode', mode=MODE_TYPE)
    ServingNode._cont = ASN1Dict([(u'mme', 0), (u'sgsn', 1)])
    ServingNode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< AnyTimeModificationRes >-----#
    AnyTimeModificationRes = SEQ(name=u'AnyTimeModificationRes', mode=MODE_TYPE)
    _AnyTimeModificationRes_ss_InfoFor_CSE = CHOICE(name=u'ss-InfoFor-CSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-SS-InfoFor-CSE')), opt=True)
    _AnyTimeModificationRes_camel_SubscriptionInfo = SEQ(name=u'camel-SubscriptionInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CAMEL-SubscriptionInfo')), opt=True)
    _AnyTimeModificationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _AnyTimeModificationRes_odb_Info = SEQ(name=u'odb-Info', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Info')), opt=True)
    _AnyTimeModificationRes_cw_Data = SEQ(name=u'cw-Data', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallWaitingData')), opt=True)
    _AnyTimeModificationRes_ch_Data = SEQ(name=u'ch-Data', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallHoldData')), opt=True)
    _AnyTimeModificationRes_clip_Data = SEQ(name=u'clip-Data', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClipData')), opt=True)
    _AnyTimeModificationRes_clir_Data = SEQ(name=u'clir-Data', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClirData')), opt=True)
    _AnyTimeModificationRes_ect_data = SEQ(name=u'ect-data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EctData')), opt=True)
    _AnyTimeModificationRes_serviceCentreAddress = OCT_STR(name=u'serviceCentreAddress', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    AnyTimeModificationRes._cont = ASN1Dict([
        (u'ss-InfoFor-CSE', _AnyTimeModificationRes_ss_InfoFor_CSE),
        (u'camel-SubscriptionInfo', _AnyTimeModificationRes_camel_SubscriptionInfo),
        (u'extensionContainer', _AnyTimeModificationRes_extensionContainer),
        (u'odb-Info', _AnyTimeModificationRes_odb_Info),
        (u'cw-Data', _AnyTimeModificationRes_cw_Data),
        (u'ch-Data', _AnyTimeModificationRes_ch_Data),
        (u'clip-Data', _AnyTimeModificationRes_clip_Data),
        (u'clir-Data', _AnyTimeModificationRes_clir_Data),
        (u'ect-data', _AnyTimeModificationRes_ect_data),
        (u'serviceCentreAddress', _AnyTimeModificationRes_serviceCentreAddress),
        ])
    AnyTimeModificationRes._ext = [u'odb-Info', u'cw-Data', u'ch-Data', u'clip-Data', u'clir-Data', u'ect-data', u'serviceCentreAddress']
    
    #-----< ModificationRequestFor-CF-Info >-----#
    ModificationRequestFor_CF_Info = SEQ(name=u'ModificationRequestFor-CF-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CF_Info_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _ModificationRequestFor_CF_Info_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ModificationRequestFor_CF_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CF_Info_forwardedToNumber = OCT_STR(name=u'forwardedToNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _ModificationRequestFor_CF_Info_forwardedToSubaddress = OCT_STR(name=u'forwardedToSubaddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _ModificationRequestFor_CF_Info_noReplyConditionTime = INT(name=u'noReplyConditionTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-NoRepCondTime')), opt=True)
    _ModificationRequestFor_CF_Info_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CF_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CF_Info._cont = ASN1Dict([
        (u'ss-Code', _ModificationRequestFor_CF_Info_ss_Code),
        (u'basicService', _ModificationRequestFor_CF_Info_basicService),
        (u'ss-Status', _ModificationRequestFor_CF_Info_ss_Status),
        (u'forwardedToNumber', _ModificationRequestFor_CF_Info_forwardedToNumber),
        (u'forwardedToSubaddress', _ModificationRequestFor_CF_Info_forwardedToSubaddress),
        (u'noReplyConditionTime', _ModificationRequestFor_CF_Info_noReplyConditionTime),
        (u'modifyNotificationToCSE', _ModificationRequestFor_CF_Info_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_CF_Info_extensionContainer),
        ])
    ModificationRequestFor_CF_Info._ext = []
    
    #-----< ModificationRequestFor-CB-Info >-----#
    ModificationRequestFor_CB_Info = SEQ(name=u'ModificationRequestFor-CB-Info', mode=MODE_TYPE)
    _ModificationRequestFor_CB_Info_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _ModificationRequestFor_CB_Info_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-BasicServiceCode')), opt=True)
    _ModificationRequestFor_CB_Info_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Ext-SS-Status')), opt=True)
    _ModificationRequestFor_CB_Info_password = STR_NUM(name=u'password', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'Password')), opt=True)
    _ModificationRequestFor_CB_Info_password._const_alpha = ASN1Set(rv=[u'0', u'1', u'2', u'3', u'4', u'5', u'6', u'7', u'8', u'9'], rr=[], ev=None, er=[])
    _ModificationRequestFor_CB_Info_wrongPasswordAttemptsCounter = INT(name=u'wrongPasswordAttemptsCounter', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WrongPasswordAttemptsCounter')), opt=True)
    _ModificationRequestFor_CB_Info_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CB_Info_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_CB_Info._cont = ASN1Dict([
        (u'ss-Code', _ModificationRequestFor_CB_Info_ss_Code),
        (u'basicService', _ModificationRequestFor_CB_Info_basicService),
        (u'ss-Status', _ModificationRequestFor_CB_Info_ss_Status),
        (u'password', _ModificationRequestFor_CB_Info_password),
        (u'wrongPasswordAttemptsCounter', _ModificationRequestFor_CB_Info_wrongPasswordAttemptsCounter),
        (u'modifyNotificationToCSE', _ModificationRequestFor_CB_Info_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_CB_Info_extensionContainer),
        ])
    ModificationRequestFor_CB_Info._ext = []
    
    #-----< ModificationRequestFor-ODB-data >-----#
    ModificationRequestFor_ODB_data = SEQ(name=u'ModificationRequestFor-ODB-data', mode=MODE_TYPE)
    _ModificationRequestFor_ODB_data_odb_data = SEQ(name=u'odb-data', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Data')), opt=True)
    _ModificationRequestFor_ODB_data_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_ODB_data_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ModificationRequestFor_ODB_data._cont = ASN1Dict([
        (u'odb-data', _ModificationRequestFor_ODB_data_odb_data),
        (u'modifyNotificationToCSE', _ModificationRequestFor_ODB_data_modifyNotificationToCSE),
        (u'extensionContainer', _ModificationRequestFor_ODB_data_extensionContainer),
        ])
    ModificationRequestFor_ODB_data._ext = []
    
    #-----< ModificationRequestFor-CSI >-----#
    ModificationRequestFor_CSI = SEQ(name=u'ModificationRequestFor-CSI', mode=MODE_TYPE)
    _ModificationRequestFor_CSI_requestedCamel_SubscriptionInfo = ENUM(name=u'requestedCamel-SubscriptionInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'RequestedCAMEL-SubscriptionInfo')))
    _ModificationRequestFor_CSI_modifyNotificationToCSE = ENUM(name=u'modifyNotificationToCSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CSI_modifyCSI_State = ENUM(name=u'modifyCSI-State', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_CSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ModificationRequestFor_CSI_additionalRequestedCAMEL_SubscriptionInfo = ENUM(name=u'additionalRequestedCAMEL-SubscriptionInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'AdditionalRequestedCAMEL-SubscriptionInfo')), opt=True)
    ModificationRequestFor_CSI._cont = ASN1Dict([
        (u'requestedCamel-SubscriptionInfo', _ModificationRequestFor_CSI_requestedCamel_SubscriptionInfo),
        (u'modifyNotificationToCSE', _ModificationRequestFor_CSI_modifyNotificationToCSE),
        (u'modifyCSI-State', _ModificationRequestFor_CSI_modifyCSI_State),
        (u'extensionContainer', _ModificationRequestFor_CSI_extensionContainer),
        (u'additionalRequestedCAMEL-SubscriptionInfo', _ModificationRequestFor_CSI_additionalRequestedCAMEL_SubscriptionInfo),
        ])
    ModificationRequestFor_CSI._ext = [u'additionalRequestedCAMEL-SubscriptionInfo']
    
    #-----< ModificationRequestFor-IP-SM-GW-Data >-----#
    ModificationRequestFor_IP_SM_GW_Data = SEQ(name=u'ModificationRequestFor-IP-SM-GW-Data', mode=MODE_TYPE)
    _ModificationRequestFor_IP_SM_GW_Data_modifyRegistrationStatus = ENUM(name=u'modifyRegistrationStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ModificationInstruction')), opt=True)
    _ModificationRequestFor_IP_SM_GW_Data_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ModificationRequestFor_IP_SM_GW_Data_ip_sm_gw_DiameterAddress = SEQ(name=u'ip-sm-gw-DiameterAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    ModificationRequestFor_IP_SM_GW_Data._cont = ASN1Dict([
        (u'modifyRegistrationStatus', _ModificationRequestFor_IP_SM_GW_Data_modifyRegistrationStatus),
        (u'extensionContainer', _ModificationRequestFor_IP_SM_GW_Data_extensionContainer),
        (u'ip-sm-gw-DiameterAddress', _ModificationRequestFor_IP_SM_GW_Data_ip_sm_gw_DiameterAddress),
        ])
    ModificationRequestFor_IP_SM_GW_Data._ext = [u'ip-sm-gw-DiameterAddress']
    
    #-----< ModificationInstruction >-----#
    ModificationInstruction = ENUM(name=u'ModificationInstruction', mode=MODE_TYPE)
    ModificationInstruction._cont = ASN1Dict([(u'deactivate', 0), (u'activate', 1)])
    ModificationInstruction._ext = None
    
    #-----< NoteSubscriberDataModifiedArg >-----#
    NoteSubscriberDataModifiedArg = SEQ(name=u'NoteSubscriberDataModifiedArg', mode=MODE_TYPE)
    _NoteSubscriberDataModifiedArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _NoteSubscriberDataModifiedArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _NoteSubscriberDataModifiedArg_forwardingInfoFor_CSE = SEQ(name=u'forwardingInfoFor-CSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwardingInfoFor-CSE')), opt=True)
    _NoteSubscriberDataModifiedArg_callBarringInfoFor_CSE = SEQ(name=u'callBarringInfoFor-CSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarringInfoFor-CSE')), opt=True)
    _NoteSubscriberDataModifiedArg_odb_Info = SEQ(name=u'odb-Info', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ODB-Info')), opt=True)
    _NoteSubscriberDataModifiedArg_camel_SubscriptionInfo = SEQ(name=u'camel-SubscriptionInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CAMEL-SubscriptionInfo')), opt=True)
    _NoteSubscriberDataModifiedArg_allInformationSent = NULL(name=u'allInformationSent', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NoteSubscriberDataModifiedArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _NoteSubscriberDataModifiedArg_ue_reachable = BIT_STR(name=u'ue-reachable', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServingNode')), opt=True)
    _NoteSubscriberDataModifiedArg_csg_SubscriptionDataList = SEQ_OF(name=u'csg-SubscriptionDataList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CSG-SubscriptionDataList')), opt=True)
    _NoteSubscriberDataModifiedArg_cw_Data = SEQ(name=u'cw-Data', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallWaitingData')), opt=True)
    _NoteSubscriberDataModifiedArg_ch_Data = SEQ(name=u'ch-Data', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CallHoldData')), opt=True)
    _NoteSubscriberDataModifiedArg_clip_Data = SEQ(name=u'clip-Data', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClipData')), opt=True)
    _NoteSubscriberDataModifiedArg_clir_Data = SEQ(name=u'clir-Data', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'ClirData')), opt=True)
    _NoteSubscriberDataModifiedArg_ect_data = SEQ(name=u'ect-data', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'EctData')), opt=True)
    NoteSubscriberDataModifiedArg._cont = ASN1Dict([
        (u'imsi', _NoteSubscriberDataModifiedArg_imsi),
        (u'msisdn', _NoteSubscriberDataModifiedArg_msisdn),
        (u'forwardingInfoFor-CSE', _NoteSubscriberDataModifiedArg_forwardingInfoFor_CSE),
        (u'callBarringInfoFor-CSE', _NoteSubscriberDataModifiedArg_callBarringInfoFor_CSE),
        (u'odb-Info', _NoteSubscriberDataModifiedArg_odb_Info),
        (u'camel-SubscriptionInfo', _NoteSubscriberDataModifiedArg_camel_SubscriptionInfo),
        (u'allInformationSent', _NoteSubscriberDataModifiedArg_allInformationSent),
        (u'extensionContainer', _NoteSubscriberDataModifiedArg_extensionContainer),
        (u'ue-reachable', _NoteSubscriberDataModifiedArg_ue_reachable),
        (u'csg-SubscriptionDataList', _NoteSubscriberDataModifiedArg_csg_SubscriptionDataList),
        (u'cw-Data', _NoteSubscriberDataModifiedArg_cw_Data),
        (u'ch-Data', _NoteSubscriberDataModifiedArg_ch_Data),
        (u'clip-Data', _NoteSubscriberDataModifiedArg_clip_Data),
        (u'clir-Data', _NoteSubscriberDataModifiedArg_clir_Data),
        (u'ect-data', _NoteSubscriberDataModifiedArg_ect_data),
        ])
    NoteSubscriberDataModifiedArg._ext = [u'ue-reachable', u'csg-SubscriptionDataList', u'cw-Data', u'ch-Data', u'clip-Data', u'clir-Data', u'ect-data']
    
    #-----< NoteSubscriberDataModifiedRes >-----#
    NoteSubscriberDataModifiedRes = SEQ(name=u'NoteSubscriberDataModifiedRes', mode=MODE_TYPE)
    _NoteSubscriberDataModifiedRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteSubscriberDataModifiedRes._cont = ASN1Dict([
        (u'extensionContainer', _NoteSubscriberDataModifiedRes_extensionContainer),
        ])
    NoteSubscriberDataModifiedRes._ext = []
    
    #-----< NoteMM-EventArg >-----#
    NoteMM_EventArg = SEQ(name=u'NoteMM-EventArg', mode=MODE_TYPE)
    _NoteMM_EventArg_serviceKey = INT(name=u'serviceKey', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-MS-DataTypes', 'ServiceKey')))
    _NoteMM_EventArg_eventMet = OCT_STR(name=u'eventMet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'MM-Code')))
    _NoteMM_EventArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _NoteMM_EventArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _NoteMM_EventArg_locationInformation = SEQ(name=u'locationInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformation')), opt=True)
    _NoteMM_EventArg_supportedCAMELPhases = BIT_STR(name=u'supportedCAMELPhases', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'SupportedCamelPhases')), opt=True)
    _NoteMM_EventArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _NoteMM_EventArg_locationInformationGPRS = SEQ(name=u'locationInformationGPRS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'LocationInformationGPRS')), opt=True)
    _NoteMM_EventArg_offeredCamel4Functionalities = BIT_STR(name=u'offeredCamel4Functionalities', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'OfferedCamel4Functionalities')), opt=True)
    NoteMM_EventArg._cont = ASN1Dict([
        (u'serviceKey', _NoteMM_EventArg_serviceKey),
        (u'eventMet', _NoteMM_EventArg_eventMet),
        (u'imsi', _NoteMM_EventArg_imsi),
        (u'msisdn', _NoteMM_EventArg_msisdn),
        (u'locationInformation', _NoteMM_EventArg_locationInformation),
        (u'supportedCAMELPhases', _NoteMM_EventArg_supportedCAMELPhases),
        (u'extensionContainer', _NoteMM_EventArg_extensionContainer),
        (u'locationInformationGPRS', _NoteMM_EventArg_locationInformationGPRS),
        (u'offeredCamel4Functionalities', _NoteMM_EventArg_offeredCamel4Functionalities),
        ])
    NoteMM_EventArg._ext = [u'locationInformationGPRS', u'offeredCamel4Functionalities']
    
    #-----< NoteMM-EventRes >-----#
    NoteMM_EventRes = SEQ(name=u'NoteMM-EventRes', mode=MODE_TYPE)
    _NoteMM_EventRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    NoteMM_EventRes._cont = ASN1Dict([
        (u'extensionContainer', _NoteMM_EventRes_extensionContainer),
        ])
    NoteMM_EventRes._ext = []
    
    #-----< Ext-SS-InfoFor-CSE >-----#
    Ext_SS_InfoFor_CSE = CHOICE(name=u'Ext-SS-InfoFor-CSE', mode=MODE_TYPE)
    _Ext_SS_InfoFor_CSE_forwardingInfoFor_CSE = SEQ(name=u'forwardingInfoFor-CSE', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwardingInfoFor-CSE')))
    _Ext_SS_InfoFor_CSE_callBarringInfoFor_CSE = SEQ(name=u'callBarringInfoFor-CSE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarringInfoFor-CSE')))
    Ext_SS_InfoFor_CSE._cont = ASN1Dict([
        (u'forwardingInfoFor-CSE', _Ext_SS_InfoFor_CSE_forwardingInfoFor_CSE),
        (u'callBarringInfoFor-CSE', _Ext_SS_InfoFor_CSE_callBarringInfoFor_CSE),
        ])
    Ext_SS_InfoFor_CSE._ext = None
    
    #-----< Ext-ForwardingInfoFor-CSE >-----#
    Ext_ForwardingInfoFor_CSE = SEQ(name=u'Ext-ForwardingInfoFor-CSE', mode=MODE_TYPE)
    _Ext_ForwardingInfoFor_CSE_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_ForwardingInfoFor_CSE_forwardingFeatureList = SEQ_OF(name=u'forwardingFeatureList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-ForwFeatureList')))
    _Ext_ForwardingInfoFor_CSE_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Ext_ForwardingInfoFor_CSE_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_ForwardingInfoFor_CSE._cont = ASN1Dict([
        (u'ss-Code', _Ext_ForwardingInfoFor_CSE_ss_Code),
        (u'forwardingFeatureList', _Ext_ForwardingInfoFor_CSE_forwardingFeatureList),
        (u'notificationToCSE', _Ext_ForwardingInfoFor_CSE_notificationToCSE),
        (u'extensionContainer', _Ext_ForwardingInfoFor_CSE_extensionContainer),
        ])
    Ext_ForwardingInfoFor_CSE._ext = []
    
    #-----< Ext-CallBarringInfoFor-CSE >-----#
    Ext_CallBarringInfoFor_CSE = SEQ(name=u'Ext-CallBarringInfoFor-CSE', mode=MODE_TYPE)
    _Ext_CallBarringInfoFor_CSE_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _Ext_CallBarringInfoFor_CSE_callBarringFeatureList = SEQ_OF(name=u'callBarringFeatureList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'Ext-CallBarFeatureList')))
    _Ext_CallBarringInfoFor_CSE_password = STR_NUM(name=u'password', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'Password')), opt=True)
    _Ext_CallBarringInfoFor_CSE_password._const_alpha = ASN1Set(rv=[u'0', u'1', u'2', u'3', u'4', u'5', u'6', u'7', u'8', u'9'], rr=[], ev=None, er=[])
    _Ext_CallBarringInfoFor_CSE_wrongPasswordAttemptsCounter = INT(name=u'wrongPasswordAttemptsCounter', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'WrongPasswordAttemptsCounter')), opt=True)
    _Ext_CallBarringInfoFor_CSE_notificationToCSE = NULL(name=u'notificationToCSE', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Ext_CallBarringInfoFor_CSE_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    Ext_CallBarringInfoFor_CSE._cont = ASN1Dict([
        (u'ss-Code', _Ext_CallBarringInfoFor_CSE_ss_Code),
        (u'callBarringFeatureList', _Ext_CallBarringInfoFor_CSE_callBarringFeatureList),
        (u'password', _Ext_CallBarringInfoFor_CSE_password),
        (u'wrongPasswordAttemptsCounter', _Ext_CallBarringInfoFor_CSE_wrongPasswordAttemptsCounter),
        (u'notificationToCSE', _Ext_CallBarringInfoFor_CSE_notificationToCSE),
        (u'extensionContainer', _Ext_CallBarringInfoFor_CSE_extensionContainer),
        ])
    Ext_CallBarringInfoFor_CSE._ext = []
    
    #-----< UpdateVcsgLocationArg >-----#
    UpdateVcsgLocationArg = SEQ(name=u'UpdateVcsgLocationArg', mode=MODE_TYPE)
    _UpdateVcsgLocationArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _UpdateVcsgLocationArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateVcsgLocationArg_vlr_Number = OCT_STR(name=u'vlr-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateVcsgLocationArg_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _UpdateVcsgLocationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UpdateVcsgLocationArg._cont = ASN1Dict([
        (u'imsi', _UpdateVcsgLocationArg_imsi),
        (u'msisdn', _UpdateVcsgLocationArg_msisdn),
        (u'vlr-Number', _UpdateVcsgLocationArg_vlr_Number),
        (u'sgsn-Number', _UpdateVcsgLocationArg_sgsn_Number),
        (u'extensionContainer', _UpdateVcsgLocationArg_extensionContainer),
        ])
    UpdateVcsgLocationArg._ext = []
    
    #-----< UpdateVcsgLocationRes >-----#
    UpdateVcsgLocationRes = SEQ(name=u'UpdateVcsgLocationRes', mode=MODE_TYPE)
    _UpdateVcsgLocationRes_temporaryEmptySubscriptiondataIndicator = NULL(name=u'temporaryEmptySubscriptiondataIndicator', mode=MODE_TYPE, opt=True)
    _UpdateVcsgLocationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    UpdateVcsgLocationRes._cont = ASN1Dict([
        (u'temporaryEmptySubscriptiondataIndicator', _UpdateVcsgLocationRes_temporaryEmptySubscriptiondataIndicator),
        (u'extensionContainer', _UpdateVcsgLocationRes_extensionContainer),
        ])
    UpdateVcsgLocationRes._ext = []
    
    #-----< CancelVcsgLocationArg >-----#
    CancelVcsgLocationArg = SEQ(name=u'CancelVcsgLocationArg', mode=MODE_TYPE)
    _CancelVcsgLocationArg_identity = CHOICE(name=u'identity', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Identity')))
    _CancelVcsgLocationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CancelVcsgLocationArg._cont = ASN1Dict([
        (u'identity', _CancelVcsgLocationArg_identity),
        (u'extensionContainer', _CancelVcsgLocationArg_extensionContainer),
        ])
    CancelVcsgLocationArg._ext = []
    
    #-----< CancelVcsgLocationRes >-----#
    CancelVcsgLocationRes = SEQ(name=u'CancelVcsgLocationRes', mode=MODE_TYPE)
    _CancelVcsgLocationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    CancelVcsgLocationRes._cont = ASN1Dict([
        (u'extensionContainer', _CancelVcsgLocationRes_extensionContainer),
        ])
    CancelVcsgLocationRes._ext = []
    
    _all_ = [
        _UpdateLocationArg_imsi,
        _UpdateLocationArg_msc_Number,
        _UpdateLocationArg_vlr_Number,
        _UpdateLocationArg_lmsi,
        _UpdateLocationArg_extensionContainer,
        _UpdateLocationArg_vlr_Capability,
        _UpdateLocationArg_informPreviousNetworkEntity,
        _UpdateLocationArg_cs_LCS_NotSupportedByUE,
        _UpdateLocationArg_v_gmlc_Address,
        _UpdateLocationArg_add_info,
        _UpdateLocationArg_pagingArea,
        _UpdateLocationArg_skipSubscriberDataUpdate,
        _UpdateLocationArg_restorationIndicator,
        _UpdateLocationArg_eplmn_List,
        _UpdateLocationArg_mme_DiameterAddress,
        UpdateLocationArg,
        _VLR_Capability_supportedCamelPhases,
        _VLR_Capability_extensionContainer,
        _VLR_Capability_solsaSupportIndicator,
        _VLR_Capability_istSupportIndicator,
        _VLR_Capability_superChargerSupportedInServingNetworkEntity,
        _VLR_Capability_longFTN_Supported,
        _VLR_Capability_supportedLCS_CapabilitySets,
        _VLR_Capability_offeredCamel4CSIs,
        _VLR_Capability_supportedRAT_TypesIndicator,
        _VLR_Capability_longGroupID_Supported,
        _VLR_Capability_mtRoamingForwardingSupported,
        _VLR_Capability_msisdn_lessOperation_Supported,
        _VLR_Capability_reset_ids_Supported,
        VLR_Capability,
        SupportedRAT_Types,
        _SuperChargerInfo_sendSubscriberData,
        _SuperChargerInfo_subscriberDataStored,
        SuperChargerInfo,
        AgeIndicator,
        IST_SupportIndicator,
        SupportedLCS_CapabilitySets,
        _UpdateLocationRes_hlr_Number,
        _UpdateLocationRes_extensionContainer,
        _UpdateLocationRes_add_Capability,
        _UpdateLocationRes_pagingArea_Capability,
        UpdateLocationRes,
        _ADD_Info_imeisv,
        _ADD_Info_skipSubscriberDataUpdate,
        ADD_Info,
        _PagingArea__item_,
        PagingArea,
        _LocationArea_laiFixedLength,
        _LocationArea_lac,
        LocationArea,
        LAC,
        _CancelLocationArg_identity,
        _CancelLocationArg_cancellationType,
        _CancelLocationArg_extensionContainer,
        _CancelLocationArg_typeOfUpdate,
        _CancelLocationArg_mtrf_SupportedAndAuthorized,
        _CancelLocationArg_mtrf_SupportedAndNotAuthorized,
        _CancelLocationArg_newMSC_Number,
        _CancelLocationArg_newVLR_Number,
        _CancelLocationArg_new_lmsi,
        _CancelLocationArg_reattach_Required,
        CancelLocationArg,
        TypeOfUpdate,
        CancellationType,
        _CancelLocationRes_extensionContainer,
        CancelLocationRes,
        _PurgeMS_Arg_imsi,
        _PurgeMS_Arg_vlr_Number,
        _PurgeMS_Arg_sgsn_Number,
        _PurgeMS_Arg_extensionContainer,
        _PurgeMS_Arg_locationInformation,
        _PurgeMS_Arg_locationInformationGPRS,
        _PurgeMS_Arg_locationInformationEPS,
        PurgeMS_Arg,
        _PurgeMS_Res_freezeTMSI,
        _PurgeMS_Res_freezeP_TMSI,
        _PurgeMS_Res_extensionContainer,
        _PurgeMS_Res_freezeM_TMSI,
        PurgeMS_Res,
        _SendIdentificationArg_tmsi,
        _SendIdentificationArg_numberOfRequestedVectors,
        _SendIdentificationArg_segmentationProhibited,
        _SendIdentificationArg_extensionContainer,
        _SendIdentificationArg_msc_Number,
        _SendIdentificationArg_previous_LAI,
        _SendIdentificationArg_hopCounter,
        _SendIdentificationArg_mtRoamingForwardingSupported,
        _SendIdentificationArg_newVLR_Number,
        _SendIdentificationArg_new_lmsi,
        SendIdentificationArg,
        HopCounter,
        _SendIdentificationRes_imsi,
        _SendIdentificationRes_authenticationSetList,
        _SendIdentificationRes_currentSecurityContext,
        _SendIdentificationRes_extensionContainer,
        _SendIdentificationRes_lastUsedLtePLMN_Id,
        _SendIdentificationRes_mtCallPendingFlag,
        SendIdentificationRes,
        _AuthenticationSetList_tripletList,
        _AuthenticationSetList_quintupletList,
        AuthenticationSetList,
        _TripletList__item_,
        TripletList,
        _QuintupletList__item_,
        QuintupletList,
        _AuthenticationTriplet_rand,
        _AuthenticationTriplet_sres,
        _AuthenticationTriplet_kc,
        AuthenticationTriplet,
        _AuthenticationQuintuplet_rand,
        _AuthenticationQuintuplet_xres,
        _AuthenticationQuintuplet_ck,
        _AuthenticationQuintuplet_ik,
        _AuthenticationQuintuplet_autn,
        AuthenticationQuintuplet,
        _CurrentSecurityContext_gsm_SecurityContextData,
        _CurrentSecurityContext_umts_SecurityContextData,
        CurrentSecurityContext,
        _GSM_SecurityContextData_kc,
        _GSM_SecurityContextData_cksn,
        GSM_SecurityContextData,
        _UMTS_SecurityContextData_ck,
        _UMTS_SecurityContextData_ik,
        _UMTS_SecurityContextData_ksi,
        UMTS_SecurityContextData,
        RAND,
        SRES,
        Kc,
        XRES,
        CK,
        IK,
        AUTN,
        AUTS,
        Cksn,
        KSI,
        _AuthenticationFailureReportArg_imsi,
        _AuthenticationFailureReportArg_failureCause,
        _AuthenticationFailureReportArg_extensionContainer,
        _AuthenticationFailureReportArg_re_attempt,
        _AuthenticationFailureReportArg_accessType,
        _AuthenticationFailureReportArg_rand,
        _AuthenticationFailureReportArg_vlr_Number,
        _AuthenticationFailureReportArg_sgsn_Number,
        AuthenticationFailureReportArg,
        AccessType,
        _AuthenticationFailureReportRes_extensionContainer,
        AuthenticationFailureReportRes,
        FailureCause,
        _UpdateGprsLocationArg_imsi,
        _UpdateGprsLocationArg_sgsn_Number,
        _UpdateGprsLocationArg_sgsn_Address,
        _UpdateGprsLocationArg_extensionContainer,
        _UpdateGprsLocationArg_sgsn_Capability,
        _UpdateGprsLocationArg_informPreviousNetworkEntity,
        _UpdateGprsLocationArg_ps_LCS_NotSupportedByUE,
        _UpdateGprsLocationArg_v_gmlc_Address,
        _UpdateGprsLocationArg_add_info,
        _UpdateGprsLocationArg_eps_info,
        _UpdateGprsLocationArg_servingNodeTypeIndicator,
        _UpdateGprsLocationArg_skipSubscriberDataUpdate,
        _UpdateGprsLocationArg_usedRAT_Type,
        _UpdateGprsLocationArg_gprsSubscriptionDataNotNeeded,
        _UpdateGprsLocationArg_nodeTypeIndicator,
        _UpdateGprsLocationArg_areaRestricted,
        _UpdateGprsLocationArg_ue_reachableIndicator,
        _UpdateGprsLocationArg_epsSubscriptionDataNotNeeded,
        _UpdateGprsLocationArg_ue_srvcc_Capability,
        _UpdateGprsLocationArg_eplmn_List,
        _UpdateGprsLocationArg_mmeNumberforMTSMS,
        _UpdateGprsLocationArg_smsRegisterRequest,
        _UpdateGprsLocationArg_sms_Only,
        _UpdateGprsLocationArg_removalofMMERegistrationforSMS,
        _UpdateGprsLocationArg_sgsn_Name,
        _UpdateGprsLocationArg_sgsn_Realm,
        _UpdateGprsLocationArg_lgd_supportIndicator,
        _UpdateGprsLocationArg_adjacentPLMN_List,
        UpdateGprsLocationArg,
        SMSRegisterRequest,
        Used_RAT_Type,
        _EPS_Info_pdn_gw_update,
        _EPS_Info_isr_Information,
        EPS_Info,
        _PDN_GW_Update_apn,
        _PDN_GW_Update_pdn_gw_Identity,
        _PDN_GW_Update_contextId,
        _PDN_GW_Update_extensionContainer,
        PDN_GW_Update,
        ISR_Information,
        _SGSN_Capability_solsaSupportIndicator,
        _SGSN_Capability_extensionContainer,
        _SGSN_Capability_superChargerSupportedInServingNetworkEntity,
        _SGSN_Capability_gprsEnhancementsSupportIndicator,
        _SGSN_Capability_supportedCamelPhases,
        _SGSN_Capability_supportedLCS_CapabilitySets,
        _SGSN_Capability_offeredCamel4CSIs,
        _SGSN_Capability_smsCallBarringSupportIndicator,
        _SGSN_Capability_supportedRAT_TypesIndicator,
        _SGSN_Capability_supportedFeatures,
        _SGSN_Capability_t_adsDataRetrieval,
        _SGSN_Capability_homogeneousSupportOfIMSVoiceOverPSSessions,
        _SGSN_Capability_cancellationTypeInitialAttach,
        _SGSN_Capability_msisdn_lessOperation_Supported,
        _SGSN_Capability_updateofHomogeneousSupportOfIMSVoiceOverPSSessions,
        _SGSN_Capability_reset_ids_Supported,
        _SGSN_Capability_ext_SupportedFeatures,
        SGSN_Capability,
        SupportedFeatures,
        Ext_SupportedFeatures,
        UE_SRVCC_Capability,
        _UpdateGprsLocationRes_hlr_Number,
        _UpdateGprsLocationRes_extensionContainer,
        _UpdateGprsLocationRes_add_Capability,
        _UpdateGprsLocationRes_sgsn_mmeSeparationSupported,
        _UpdateGprsLocationRes_mmeRegisteredforSMS,
        UpdateGprsLocationRes,
        _EPLMN_List__item_,
        EPLMN_List,
        _AdjacentPLMN_List__item_,
        AdjacentPLMN_List,
        _ForwardAccessSignalling_Arg_an_APDU,
        _ForwardAccessSignalling_Arg_integrityProtectionInfo,
        _ForwardAccessSignalling_Arg_encryptionInfo,
        _ForwardAccessSignalling_Arg_keyStatus,
        _ForwardAccessSignalling_Arg_allowedGSM_Algorithms,
        _ForwardAccessSignalling_Arg_allowedUMTS_Algorithms,
        _ForwardAccessSignalling_Arg_radioResourceInformation,
        _ForwardAccessSignalling_Arg_extensionContainer,
        _ForwardAccessSignalling_Arg_radioResourceList,
        _ForwardAccessSignalling_Arg_bssmap_ServiceHandover,
        _ForwardAccessSignalling_Arg_ranap_ServiceHandover,
        _ForwardAccessSignalling_Arg_bssmap_ServiceHandoverList,
        _ForwardAccessSignalling_Arg_currentlyUsedCodec,
        _ForwardAccessSignalling_Arg_iuSupportedCodecsList,
        _ForwardAccessSignalling_Arg_rab_ConfigurationIndicator,
        _ForwardAccessSignalling_Arg_iuSelectedCodec,
        _ForwardAccessSignalling_Arg_alternativeChannelType,
        _ForwardAccessSignalling_Arg_tracePropagationList,
        _ForwardAccessSignalling_Arg_aoipSupportedCodecsListAnchor,
        _ForwardAccessSignalling_Arg_aoipSelectedCodecTarget,
        _ForwardAccessSignalling_Arg_uesbi_Iu,
        _ForwardAccessSignalling_Arg_imeisv,
        ForwardAccessSignalling_Arg,
        AllowedGSM_Algorithms,
        _AllowedUMTS_Algorithms_integrityProtectionAlgorithms,
        _AllowedUMTS_Algorithms_encryptionAlgorithms,
        _AllowedUMTS_Algorithms_extensionContainer,
        AllowedUMTS_Algorithms,
        PermittedIntegrityProtectionAlgorithms,
        maxPermittedIntegrityProtectionAlgorithmsLength,
        PermittedEncryptionAlgorithms,
        maxPermittedEncryptionAlgorithmsLength,
        KeyStatus,
        _PrepareHO_Arg_targetCellId,
        _PrepareHO_Arg_ho_NumberNotRequired,
        _PrepareHO_Arg_targetRNCId,
        _PrepareHO_Arg_an_APDU,
        _PrepareHO_Arg_multipleBearerRequested,
        _PrepareHO_Arg_imsi,
        _PrepareHO_Arg_integrityProtectionInfo,
        _PrepareHO_Arg_encryptionInfo,
        _PrepareHO_Arg_radioResourceInformation,
        _PrepareHO_Arg_allowedGSM_Algorithms,
        _PrepareHO_Arg_allowedUMTS_Algorithms,
        _PrepareHO_Arg_radioResourceList,
        _PrepareHO_Arg_extensionContainer,
        _PrepareHO_Arg_rab_Id,
        _PrepareHO_Arg_bssmap_ServiceHandover,
        _PrepareHO_Arg_ranap_ServiceHandover,
        _PrepareHO_Arg_bssmap_ServiceHandoverList,
        _PrepareHO_Arg_asciCallReference,
        _PrepareHO_Arg_geran_classmark,
        _PrepareHO_Arg_iuCurrentlyUsedCodec,
        _PrepareHO_Arg_iuSupportedCodecsList,
        _PrepareHO_Arg_rab_ConfigurationIndicator,
        _PrepareHO_Arg_uesbi_Iu,
        _PrepareHO_Arg_imeisv,
        _PrepareHO_Arg_alternativeChannelType,
        _PrepareHO_Arg_tracePropagationList,
        _PrepareHO_Arg_aoipSupportedCodecsListAnchor,
        _PrepareHO_Arg_regionalSubscriptionData,
        _PrepareHO_Arg_lclsGlobalCallReference,
        _PrepareHO_Arg_lcls_Negotiation,
        _PrepareHO_Arg_lcls_Configuration_Preference,
        _PrepareHO_Arg_csg_SubscriptionDataList,
        PrepareHO_Arg,
        LCLS_GlobalCallReference,
        LCLS_Negotiation,
        LCLS_ConfigurationPreference,
        _BSSMAP_ServiceHandoverList__item_,
        BSSMAP_ServiceHandoverList,
        _BSSMAP_ServiceHandoverInfo_bssmap_ServiceHandover,
        _BSSMAP_ServiceHandoverInfo_rab_Id,
        BSSMAP_ServiceHandoverInfo,
        maxNumOfServiceHandovers,
        BSSMAP_ServiceHandover,
        RANAP_ServiceHandover,
        _RadioResourceList__item_,
        RadioResourceList,
        _RadioResource_radioResourceInformation,
        _RadioResource_rab_Id,
        RadioResource,
        maxNumOfRadioResources,
        _PrepareHO_Res_handoverNumber,
        _PrepareHO_Res_relocationNumberList,
        _PrepareHO_Res_an_APDU,
        _PrepareHO_Res_multicallBearerInfo,
        _PrepareHO_Res_multipleBearerNotSupported,
        _PrepareHO_Res_selectedUMTS_Algorithms,
        _PrepareHO_Res_chosenRadioResourceInformation,
        _PrepareHO_Res_extensionContainer,
        _PrepareHO_Res_iuSelectedCodec,
        _PrepareHO_Res_iuAvailableCodecsList,
        _PrepareHO_Res_aoipSelectedCodecTarget,
        _PrepareHO_Res_aoipAvailableCodecsListMap,
        PrepareHO_Res,
        _SelectedUMTS_Algorithms_integrityProtectionAlgorithm,
        _SelectedUMTS_Algorithms_encryptionAlgorithm,
        _SelectedUMTS_Algorithms_extensionContainer,
        SelectedUMTS_Algorithms,
        ChosenIntegrityProtectionAlgorithm,
        ChosenEncryptionAlgorithm,
        _ChosenRadioResourceInformation_chosenChannelInfo,
        _ChosenRadioResourceInformation_chosenSpeechVersion,
        ChosenRadioResourceInformation,
        ChosenChannelInfo,
        ChosenSpeechVersion,
        _PrepareSubsequentHO_Arg_targetCellId,
        _PrepareSubsequentHO_Arg_targetMSC_Number,
        _PrepareSubsequentHO_Arg_targetRNCId,
        _PrepareSubsequentHO_Arg_an_APDU,
        _PrepareSubsequentHO_Arg_selectedRab_Id,
        _PrepareSubsequentHO_Arg_extensionContainer,
        _PrepareSubsequentHO_Arg_geran_classmark,
        _PrepareSubsequentHO_Arg_rab_ConfigurationIndicator,
        PrepareSubsequentHO_Arg,
        _PrepareSubsequentHO_Res_an_APDU,
        _PrepareSubsequentHO_Res_extensionContainer,
        PrepareSubsequentHO_Res,
        _ProcessAccessSignalling_Arg_an_APDU,
        _ProcessAccessSignalling_Arg_selectedUMTS_Algorithms,
        _ProcessAccessSignalling_Arg_selectedGSM_Algorithm,
        _ProcessAccessSignalling_Arg_chosenRadioResourceInformation,
        _ProcessAccessSignalling_Arg_selectedRab_Id,
        _ProcessAccessSignalling_Arg_extensionContainer,
        _ProcessAccessSignalling_Arg_iUSelectedCodec,
        _ProcessAccessSignalling_Arg_iuAvailableCodecsList,
        _ProcessAccessSignalling_Arg_aoipSelectedCodecTarget,
        _ProcessAccessSignalling_Arg_aoipAvailableCodecsListMap,
        ProcessAccessSignalling_Arg,
        _AoIPCodecsList_codec1,
        _AoIPCodecsList_codec2,
        _AoIPCodecsList_codec3,
        _AoIPCodecsList_codec4,
        _AoIPCodecsList_codec5,
        _AoIPCodecsList_codec6,
        _AoIPCodecsList_codec7,
        _AoIPCodecsList_codec8,
        _AoIPCodecsList_extensionContainer,
        AoIPCodecsList,
        AoIPCodec,
        _SupportedCodecsList_utranCodecList,
        _SupportedCodecsList_geranCodecList,
        _SupportedCodecsList_extensionContainer,
        SupportedCodecsList,
        _CodecList_codec1,
        _CodecList_codec2,
        _CodecList_codec3,
        _CodecList_codec4,
        _CodecList_codec5,
        _CodecList_codec6,
        _CodecList_codec7,
        _CodecList_codec8,
        _CodecList_extensionContainer,
        CodecList,
        Codec,
        GERAN_Classmark,
        SelectedGSM_Algorithm,
        _SendEndSignal_Arg_an_APDU,
        _SendEndSignal_Arg_extensionContainer,
        SendEndSignal_Arg,
        _SendEndSignal_Res_extensionContainer,
        SendEndSignal_Res,
        RNCId,
        _RelocationNumberList__item_,
        RelocationNumberList,
        MulticallBearerInfo,
        _RelocationNumber_handoverNumber,
        _RelocationNumber_rab_Id,
        RelocationNumber,
        RAB_Id,
        maxNrOfRABs,
        maxNumOfRelocationNumber,
        RadioResourceInformation,
        IntegrityProtectionInformation,
        maxNumOfIntegrityInfo,
        EncryptionInformation,
        maxNumOfEncryptionInfo,
        _SendAuthenticationInfoArg_imsi,
        _SendAuthenticationInfoArg_numberOfRequestedVectors,
        _SendAuthenticationInfoArg_segmentationProhibited,
        _SendAuthenticationInfoArg_immediateResponsePreferred,
        _SendAuthenticationInfoArg_re_synchronisationInfo,
        _SendAuthenticationInfoArg_extensionContainer,
        _SendAuthenticationInfoArg_requestingNodeType,
        _SendAuthenticationInfoArg_requestingPLMN_Id,
        _SendAuthenticationInfoArg_numberOfRequestedAdditional_Vectors,
        _SendAuthenticationInfoArg_additionalVectorsAreForEPS,
        _SendAuthenticationInfoArg_ueUsageTypeRequestIndication,
        SendAuthenticationInfoArg,
        NumberOfRequestedVectors,
        _Re_synchronisationInfo_rand,
        _Re_synchronisationInfo_auts,
        Re_synchronisationInfo,
        _SendAuthenticationInfoRes_authenticationSetList,
        _SendAuthenticationInfoRes_extensionContainer,
        _SendAuthenticationInfoRes_eps_AuthenticationSetList,
        _SendAuthenticationInfoRes_ueUsageType,
        SendAuthenticationInfoRes,
        _EPS_AuthenticationSetList__item_,
        EPS_AuthenticationSetList,
        UE_UsageType,
        _EPC_AV_rand,
        _EPC_AV_xres,
        _EPC_AV_autn,
        _EPC_AV_kasme,
        _EPC_AV_extensionContainer,
        EPC_AV,
        KASME,
        RequestingNodeType,
        _CheckIMEI_Arg_imei,
        _CheckIMEI_Arg_requestedEquipmentInfo,
        _CheckIMEI_Arg_extensionContainer,
        CheckIMEI_Arg,
        _CheckIMEI_Res_equipmentStatus,
        _CheckIMEI_Res_bmuef,
        _CheckIMEI_Res_extensionContainer,
        CheckIMEI_Res,
        RequestedEquipmentInfo,
        _UESBI_Iu_uesbi_IuA,
        _UESBI_Iu_uesbi_IuB,
        UESBI_Iu,
        UESBI_IuA,
        UESBI_IuB,
        EquipmentStatus,
        _InsertSubscriberDataArg_imsi,
        _InsertSubscriberDataArg_msisdn,
        _InsertSubscriberDataArg_category,
        _InsertSubscriberDataArg_subscriberStatus,
        _InsertSubscriberDataArg_bearerServiceList,
        _InsertSubscriberDataArg_teleserviceList,
        _InsertSubscriberDataArg_provisionedSS,
        _InsertSubscriberDataArg_odb_Data,
        _InsertSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature,
        _InsertSubscriberDataArg_regionalSubscriptionData,
        _InsertSubscriberDataArg_vbsSubscriptionData,
        _InsertSubscriberDataArg_vgcsSubscriptionData,
        _InsertSubscriberDataArg_vlrCamelSubscriptionInfo,
        _InsertSubscriberDataArg_extensionContainer,
        _InsertSubscriberDataArg_naea_PreferredCI,
        _InsertSubscriberDataArg_gprsSubscriptionData,
        _InsertSubscriberDataArg_roamingRestrictedInSgsnDueToUnsupportedFeature,
        _InsertSubscriberDataArg_networkAccessMode,
        _InsertSubscriberDataArg_lsaInformation,
        _InsertSubscriberDataArg_lmu_Indicator,
        _InsertSubscriberDataArg_lcsInformation,
        _InsertSubscriberDataArg_istAlertTimer,
        _InsertSubscriberDataArg_superChargerSupportedInHLR,
        _InsertSubscriberDataArg_mc_SS_Info,
        _InsertSubscriberDataArg_cs_AllocationRetentionPriority,
        _InsertSubscriberDataArg_sgsn_CAMEL_SubscriptionInfo,
        _InsertSubscriberDataArg_chargingCharacteristics,
        _InsertSubscriberDataArg_accessRestrictionData,
        _InsertSubscriberDataArg_ics_Indicator,
        _InsertSubscriberDataArg_eps_SubscriptionData,
        _InsertSubscriberDataArg_csg_SubscriptionDataList,
        _InsertSubscriberDataArg_ue_ReachabilityRequestIndicator,
        _InsertSubscriberDataArg_sgsn_Number,
        _InsertSubscriberDataArg_mme_Name,
        _InsertSubscriberDataArg_subscribedPeriodicRAUTAUtimer,
        _InsertSubscriberDataArg_vplmnLIPAAllowed,
        _InsertSubscriberDataArg_mdtUserConsent,
        _InsertSubscriberDataArg_subscribedPeriodicLAUtimer,
        _InsertSubscriberDataArg_vplmn_Csg_SubscriptionDataList,
        _InsertSubscriberDataArg_additionalMSISDN,
        _InsertSubscriberDataArg_psAndSMS_OnlyServiceProvision,
        _InsertSubscriberDataArg_smsInSGSNAllowed,
        _InsertSubscriberDataArg_cs_to_ps_SRVCC_Allowed_Indicator,
        _InsertSubscriberDataArg_pcscf_Restoration_Request,
        _InsertSubscriberDataArg_adjacentAccessRestrictionDataList,
        _InsertSubscriberDataArg_imsi_Group_Id_List,
        _InsertSubscriberDataArg_ueUsageType,
        _InsertSubscriberDataArg_userPlaneIntegrityProtectionIndicator,
        _InsertSubscriberDataArg_dl_Buffering_Suggested_Packet_Count,
        _InsertSubscriberDataArg_reset_Id_List,
        _InsertSubscriberDataArg_eDRX_Cycle_Length_List,
        _InsertSubscriberDataArg_ext_AccessRestrictionData,
        _InsertSubscriberDataArg_iab_Operation_Allowed_Indicator,
        InsertSubscriberDataArg,
        _EDRX_Cycle_Length_List__item_,
        EDRX_Cycle_Length_List,
        _EDRX_Cycle_Length_rat_Type,
        _EDRX_Cycle_Length_eDRX_Cycle_Length_Value,
        EDRX_Cycle_Length,
        EDRX_Cycle_Length_Value,
        _Reset_Id_List__item_,
        Reset_Id_List,
        Reset_Id,
        DL_Buffering_Suggested_Packet_Count,
        Group_Service_ID,
        Local_GroupID,
        _IMSI_GroupIdList__item_,
        IMSI_GroupIdList,
        _IMSI_GroupId_group_Service_Id,
        _IMSI_GroupId_plmnId,
        _IMSI_GroupId_local_Group_ID,
        IMSI_GroupId,
        SubscribedPeriodicRAUTAUtimer,
        SubscribedPeriodicLAUtimer,
        _CSG_SubscriptionDataList__item_,
        CSG_SubscriptionDataList,
        _CSG_SubscriptionData_csg_Id,
        _CSG_SubscriptionData_expirationDate,
        _CSG_SubscriptionData_extensionContainer,
        _CSG_SubscriptionData_lipa_AllowedAPNList,
        _CSG_SubscriptionData_plmn_Id,
        CSG_SubscriptionData,
        _VPLMN_CSG_SubscriptionDataList__item_,
        VPLMN_CSG_SubscriptionDataList,
        CSG_Id,
        _LIPA_AllowedAPNList__item_,
        LIPA_AllowedAPNList,
        maxNumOfLIPAAllowedAPN,
        _EPS_SubscriptionData_apn_oi_Replacement,
        _EPS_SubscriptionData_rfsp_id,
        _EPS_SubscriptionData_ambr,
        _EPS_SubscriptionData_apn_ConfigurationProfile,
        _EPS_SubscriptionData_stn_sr,
        _EPS_SubscriptionData_extensionContainer,
        _EPS_SubscriptionData_mps_CSPriority,
        _EPS_SubscriptionData_mps_EPSPriority,
        _EPS_SubscriptionData_subscribed_vsrvcc,
        EPS_SubscriptionData,
        APN_OI_Replacement,
        RFSP_ID,
        _APN_ConfigurationProfile_defaultContext,
        _APN_ConfigurationProfile_completeDataListIncluded,
        _APN_ConfigurationProfile_epsDataList,
        _APN_ConfigurationProfile_extensionContainer,
        _APN_ConfigurationProfile_additionalDefaultContext,
        APN_ConfigurationProfile,
        _EPS_DataList__item_,
        EPS_DataList,
        maxNumOfAPN_Configurations,
        _APN_Configuration_contextId,
        _APN_Configuration_pdn_Type,
        _APN_Configuration_servedPartyIP_IPv4_Address,
        _APN_Configuration_apn,
        _APN_Configuration_eps_qos_Subscribed,
        _APN_Configuration_pdn_gw_Identity,
        _APN_Configuration_pdn_gw_AllocationType,
        _APN_Configuration_vplmnAddressAllowed,
        _APN_Configuration_chargingCharacteristics,
        _APN_Configuration_ambr,
        _APN_Configuration_specificAPNInfoList,
        _APN_Configuration_extensionContainer,
        _APN_Configuration_servedPartyIP_IPv6_Address,
        _APN_Configuration_apn_oi_Replacement,
        _APN_Configuration_sipto_Permission,
        _APN_Configuration_lipa_Permission,
        _APN_Configuration_restoration_Priority,
        _APN_Configuration_sipto_local_network_Permission,
        _APN_Configuration_wlan_offloadability,
        _APN_Configuration_non_IP_PDN_Type_Indicator,
        _APN_Configuration_nIDD_Mechanism,
        _APN_Configuration_sCEF_ID,
        _APN_Configuration_pdn_ConnectionContinuity,
        APN_Configuration,
        PDN_ConnectionContinuity,
        NIDD_Mechanism,
        PDN_Type,
        _EPS_QoS_Subscribed_qos_Class_Identifier,
        _EPS_QoS_Subscribed_allocation_Retention_Priority,
        _EPS_QoS_Subscribed_extensionContainer,
        EPS_QoS_Subscribed,
        _AMBR_max_RequestedBandwidth_UL,
        _AMBR_max_RequestedBandwidth_DL,
        _AMBR_extensionContainer,
        _AMBR_extended_Max_RequestedBandwidth_UL,
        _AMBR_extended_Max_RequestedBandwidth_DL,
        AMBR,
        _SpecificAPNInfoList__item_,
        SpecificAPNInfoList,
        maxNumOfSpecificAPNInfos,
        _SpecificAPNInfo_apn,
        _SpecificAPNInfo_pdn_gw_Identity,
        _SpecificAPNInfo_extensionContainer,
        SpecificAPNInfo,
        Bandwidth,
        BandwidthExt,
        QoS_Class_Identifier,
        _Allocation_Retention_Priority_priority_level,
        _Allocation_Retention_Priority_pre_emption_capability,
        _Allocation_Retention_Priority_pre_emption_vulnerability,
        _Allocation_Retention_Priority_extensionContainer,
        Allocation_Retention_Priority,
        _PDN_GW_Identity_pdn_gw_ipv4_Address,
        _PDN_GW_Identity_pdn_gw_ipv6_Address,
        _PDN_GW_Identity_pdn_gw_name,
        _PDN_GW_Identity_extensionContainer,
        PDN_GW_Identity,
        FQDN,
        PDN_GW_AllocationType,
        _WLAN_Offloadability_wlan_offloadability_EUTRAN,
        _WLAN_Offloadability_wlan_offloadability_UTRAN,
        _WLAN_Offloadability_extensionContainer,
        WLAN_Offloadability,
        WLAN_Offloadability_Indication,
        AccessRestrictionData,
        Ext_AccessRestrictionData,
        _AdjacentAccessRestrictionDataList__item_,
        AdjacentAccessRestrictionDataList,
        _AdjacentAccessRestrictionData_plmnId,
        _AdjacentAccessRestrictionData_accessRestrictionData,
        _AdjacentAccessRestrictionData_ext_AccessRestrictionData,
        AdjacentAccessRestrictionData,
        CS_AllocationRetentionPriority,
        IST_AlertTimerValue,
        _LCSInformation_gmlc_List,
        _LCSInformation_lcs_PrivacyExceptionList,
        _LCSInformation_molr_List,
        _LCSInformation_add_lcs_PrivacyExceptionList,
        LCSInformation,
        _GMLC_List__item_,
        GMLC_List,
        maxNumOfGMLC,
        NetworkAccessMode,
        _GPRSDataList__item_,
        GPRSDataList,
        maxNumOfPDP_Contexts,
        _PDP_Context_pdp_ContextId,
        _PDP_Context_pdp_Type,
        _PDP_Context_pdp_Address,
        _PDP_Context_qos_Subscribed,
        _PDP_Context_vplmnAddressAllowed,
        _PDP_Context_apn,
        _PDP_Context_extensionContainer,
        _PDP_Context_ext_QoS_Subscribed,
        _PDP_Context_pdp_ChargingCharacteristics,
        _PDP_Context_ext2_QoS_Subscribed,
        _PDP_Context_ext3_QoS_Subscribed,
        _PDP_Context_ext4_QoS_Subscribed,
        _PDP_Context_apn_oi_Replacement,
        _PDP_Context_ext_pdp_Type,
        _PDP_Context_ext_pdp_Address,
        _PDP_Context_ambr,
        _PDP_Context_sipto_Permission,
        _PDP_Context_lipa_Permission,
        _PDP_Context_restoration_Priority,
        _PDP_Context_sipto_local_network_Permission,
        _PDP_Context_nIDD_Mechanism,
        _PDP_Context_sCEF_ID,
        PDP_Context,
        Restoration_Priority,
        SIPTO_Permission,
        SIPTO_Local_Network_Permission,
        LIPA_Permission,
        ContextId,
        _GPRSSubscriptionData_completeDataListIncluded,
        _GPRSSubscriptionData_gprsDataList,
        _GPRSSubscriptionData_extensionContainer,
        _GPRSSubscriptionData_apn_oi_Replacement,
        GPRSSubscriptionData,
        _SGSN_CAMEL_SubscriptionInfo_gprs_CSI,
        _SGSN_CAMEL_SubscriptionInfo_mo_sms_CSI,
        _SGSN_CAMEL_SubscriptionInfo_extensionContainer,
        _SGSN_CAMEL_SubscriptionInfo_mt_sms_CSI,
        _SGSN_CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList,
        _SGSN_CAMEL_SubscriptionInfo_mg_csi,
        SGSN_CAMEL_SubscriptionInfo,
        _GPRS_CSI_gprs_CamelTDPDataList,
        _GPRS_CSI_camelCapabilityHandling,
        _GPRS_CSI_extensionContainer,
        _GPRS_CSI_notificationToCSE,
        _GPRS_CSI_csi_Active,
        GPRS_CSI,
        _GPRS_CamelTDPDataList__item_,
        GPRS_CamelTDPDataList,
        _GPRS_CamelTDPData_gprs_TriggerDetectionPoint,
        _GPRS_CamelTDPData_serviceKey,
        _GPRS_CamelTDPData_gsmSCF_Address,
        _GPRS_CamelTDPData_defaultSessionHandling,
        _GPRS_CamelTDPData_extensionContainer,
        GPRS_CamelTDPData,
        DefaultGPRS_Handling,
        GPRS_TriggerDetectionPoint,
        APN,
        PDP_Type,
        Ext_PDP_Type,
        PDP_Address,
        QoS_Subscribed,
        Ext_QoS_Subscribed,
        Ext2_QoS_Subscribed,
        Ext3_QoS_Subscribed,
        Ext4_QoS_Subscribed,
        ChargingCharacteristics,
        LSAOnlyAccessIndicator,
        _LSADataList__item_,
        LSADataList,
        maxNumOfLSAs,
        _LSAData_lsaIdentity,
        _LSAData_lsaAttributes,
        _LSAData_lsaActiveModeIndicator,
        _LSAData_extensionContainer,
        LSAData,
        _LSAInformation_completeDataListIncluded,
        _LSAInformation_lsaOnlyAccessIndicator,
        _LSAInformation_lsaDataList,
        _LSAInformation_extensionContainer,
        LSAInformation,
        LSAIdentity,
        LSAAttributes,
        _SubscriberData_msisdn,
        _SubscriberData_category,
        _SubscriberData_subscriberStatus,
        _SubscriberData_bearerServiceList,
        _SubscriberData_teleserviceList,
        _SubscriberData_provisionedSS,
        _SubscriberData_odb_Data,
        _SubscriberData_roamingRestrictionDueToUnsupportedFeature,
        _SubscriberData_regionalSubscriptionData,
        _SubscriberData_vbsSubscriptionData,
        _SubscriberData_vgcsSubscriptionData,
        _SubscriberData_vlrCamelSubscriptionInfo,
        SubscriberData,
        Category,
        SubscriberStatus,
        _BearerServiceList__item_,
        BearerServiceList,
        maxNumOfBearerServices,
        _TeleserviceList__item_,
        TeleserviceList,
        maxNumOfTeleservices,
        _ODB_Data_odb_GeneralData,
        _ODB_Data_odb_HPLMN_Data,
        _ODB_Data_extensionContainer,
        ODB_Data,
        ODB_GeneralData,
        ODB_HPLMN_Data,
        _Ext_SS_InfoList__item_,
        Ext_SS_InfoList,
        _Ext_SS_Info_forwardingInfo,
        _Ext_SS_Info_callBarringInfo,
        _Ext_SS_Info_cug_Info,
        _Ext_SS_Info_ss_Data,
        _Ext_SS_Info_emlpp_Info,
        Ext_SS_Info,
        _Ext_ForwInfo_ss_Code,
        _Ext_ForwInfo_forwardingFeatureList,
        _Ext_ForwInfo_extensionContainer,
        Ext_ForwInfo,
        _Ext_ForwFeatureList__item_,
        Ext_ForwFeatureList,
        _Ext_ForwFeature_basicService,
        _Ext_ForwFeature_ss_Status,
        _Ext_ForwFeature_forwardedToNumber,
        _Ext_ForwFeature_forwardedToSubaddress,
        _Ext_ForwFeature_forwardingOptions,
        _Ext_ForwFeature_noReplyConditionTime,
        _Ext_ForwFeature_extensionContainer,
        _Ext_ForwFeature_longForwardedToNumber,
        Ext_ForwFeature,
        Ext_ForwOptions,
        Ext_NoRepCondTime,
        _Ext_CallBarInfo_ss_Code,
        _Ext_CallBarInfo_callBarringFeatureList,
        _Ext_CallBarInfo_extensionContainer,
        Ext_CallBarInfo,
        _Ext_CallBarFeatureList__item_,
        Ext_CallBarFeatureList,
        _Ext_CallBarringFeature_basicService,
        _Ext_CallBarringFeature_ss_Status,
        _Ext_CallBarringFeature_extensionContainer,
        Ext_CallBarringFeature,
        _CUG_Info_cug_SubscriptionList,
        _CUG_Info_cug_FeatureList,
        _CUG_Info_extensionContainer,
        CUG_Info,
        _CUG_SubscriptionList__item_,
        CUG_SubscriptionList,
        _CUG_Subscription_cug_Index,
        _CUG_Subscription_cug_Interlock,
        _CUG_Subscription_intraCUG_Options,
        _CUG_Subscription_basicServiceGroupList,
        _CUG_Subscription_extensionContainer,
        CUG_Subscription,
        CUG_Index,
        CUG_Interlock,
        IntraCUG_Options,
        maxNumOfCUG,
        _CUG_FeatureList__item_,
        CUG_FeatureList,
        _Ext_BasicServiceGroupList__item_,
        Ext_BasicServiceGroupList,
        maxNumOfExt_BasicServiceGroups,
        _CUG_Feature_basicService,
        _CUG_Feature_preferentialCUG_Indicator,
        _CUG_Feature_interCUG_Restrictions,
        _CUG_Feature_extensionContainer,
        CUG_Feature,
        InterCUG_Restrictions,
        _Ext_SS_Data_ss_Code,
        _Ext_SS_Data_ss_Status,
        _Ext_SS_Data_ss_SubscriptionOption,
        _Ext_SS_Data_basicServiceGroupList,
        _Ext_SS_Data_extensionContainer,
        Ext_SS_Data,
        _LCS_PrivacyExceptionList__item_,
        LCS_PrivacyExceptionList,
        maxNumOfPrivacyClass,
        _LCS_PrivacyClass_ss_Code,
        _LCS_PrivacyClass_ss_Status,
        _LCS_PrivacyClass_notificationToMSUser,
        _LCS_PrivacyClass_externalClientList,
        _LCS_PrivacyClass_plmnClientList,
        _LCS_PrivacyClass_extensionContainer,
        _LCS_PrivacyClass_ext_externalClientList,
        _LCS_PrivacyClass_serviceTypeList,
        LCS_PrivacyClass,
        _ExternalClientList__item_,
        ExternalClientList,
        maxNumOfExternalClient,
        _PLMNClientList__item_,
        PLMNClientList,
        maxNumOfPLMNClient,
        _Ext_ExternalClientList__item_,
        Ext_ExternalClientList,
        maxNumOfExt_ExternalClient,
        _ExternalClient_clientIdentity,
        _ExternalClient_gmlc_Restriction,
        _ExternalClient_notificationToMSUser,
        _ExternalClient_extensionContainer,
        ExternalClient,
        GMLC_Restriction,
        NotificationToMSUser,
        _ServiceTypeList__item_,
        ServiceTypeList,
        maxNumOfServiceType,
        _ServiceType_serviceTypeIdentity,
        _ServiceType_gmlc_Restriction,
        _ServiceType_notificationToMSUser,
        _ServiceType_extensionContainer,
        ServiceType,
        _MOLR_List__item_,
        MOLR_List,
        maxNumOfMOLR_Class,
        _MOLR_Class_ss_Code,
        _MOLR_Class_ss_Status,
        _MOLR_Class_extensionContainer,
        MOLR_Class,
        _ZoneCodeList__item_,
        ZoneCodeList,
        ZoneCode,
        maxNumOfZoneCodes,
        _InsertSubscriberDataRes_teleserviceList,
        _InsertSubscriberDataRes_bearerServiceList,
        _InsertSubscriberDataRes_ss_List,
        _InsertSubscriberDataRes_odb_GeneralData,
        _InsertSubscriberDataRes_regionalSubscriptionResponse,
        _InsertSubscriberDataRes_supportedCamelPhases,
        _InsertSubscriberDataRes_extensionContainer,
        _InsertSubscriberDataRes_offeredCamel4CSIs,
        _InsertSubscriberDataRes_supportedFeatures,
        _InsertSubscriberDataRes_ext_SupportedFeatures,
        InsertSubscriberDataRes,
        RegionalSubscriptionResponse,
        _DeleteSubscriberDataArg_imsi,
        _DeleteSubscriberDataArg_basicServiceList,
        _DeleteSubscriberDataArg_ss_List,
        _DeleteSubscriberDataArg_roamingRestrictionDueToUnsupportedFeature,
        _DeleteSubscriberDataArg_regionalSubscriptionIdentifier,
        _DeleteSubscriberDataArg_vbsGroupIndication,
        _DeleteSubscriberDataArg_vgcsGroupIndication,
        _DeleteSubscriberDataArg_camelSubscriptionInfoWithdraw,
        _DeleteSubscriberDataArg_extensionContainer,
        _DeleteSubscriberDataArg_gprsSubscriptionDataWithdraw,
        _DeleteSubscriberDataArg_roamingRestrictedInSgsnDueToUnsuppportedFeature,
        _DeleteSubscriberDataArg_lsaInformationWithdraw,
        _DeleteSubscriberDataArg_gmlc_ListWithdraw,
        _DeleteSubscriberDataArg_istInformationWithdraw,
        _DeleteSubscriberDataArg_specificCSI_Withdraw,
        _DeleteSubscriberDataArg_chargingCharacteristicsWithdraw,
        _DeleteSubscriberDataArg_stn_srWithdraw,
        _DeleteSubscriberDataArg_epsSubscriptionDataWithdraw,
        _DeleteSubscriberDataArg_apn_oi_replacementWithdraw,
        _DeleteSubscriberDataArg_csg_SubscriptionDeleted,
        _DeleteSubscriberDataArg_subscribedPeriodicTAU_RAU_TimerWithdraw,
        _DeleteSubscriberDataArg_subscribedPeriodicLAU_TimerWithdraw,
        _DeleteSubscriberDataArg_subscribed_vsrvccWithdraw,
        _DeleteSubscriberDataArg_vplmn_Csg_SubscriptionDeleted,
        _DeleteSubscriberDataArg_additionalMSISDN_Withdraw,
        _DeleteSubscriberDataArg_cs_to_ps_SRVCC_Withdraw,
        _DeleteSubscriberDataArg_imsiGroupIdList_Withdraw,
        _DeleteSubscriberDataArg_userPlaneIntegrityProtectionWithdraw,
        _DeleteSubscriberDataArg_dl_Buffering_Suggested_Packet_Count_Withdraw,
        _DeleteSubscriberDataArg_ue_UsageTypeWithdraw,
        _DeleteSubscriberDataArg_reset_idsWithdraw,
        _DeleteSubscriberDataArg_iab_OperationWithdraw,
        DeleteSubscriberDataArg,
        SpecificCSI_Withdraw,
        _GPRSSubscriptionDataWithdraw_allGPRSData,
        _GPRSSubscriptionDataWithdraw_contextIdList,
        GPRSSubscriptionDataWithdraw,
        _EPS_SubscriptionDataWithdraw_allEPS_Data,
        _EPS_SubscriptionDataWithdraw_contextIdList,
        EPS_SubscriptionDataWithdraw,
        _ContextIdList__item_,
        ContextIdList,
        _LSAInformationWithdraw_allLSAData,
        _LSAInformationWithdraw_lsaIdentityList,
        LSAInformationWithdraw,
        _LSAIdentityList__item_,
        LSAIdentityList,
        _BasicServiceList__item_,
        BasicServiceList,
        maxNumOfBasicServices,
        _DeleteSubscriberDataRes_regionalSubscriptionResponse,
        _DeleteSubscriberDataRes_extensionContainer,
        DeleteSubscriberDataRes,
        _VlrCamelSubscriptionInfo_o_CSI,
        _VlrCamelSubscriptionInfo_extensionContainer,
        _VlrCamelSubscriptionInfo_ss_CSI,
        _VlrCamelSubscriptionInfo_o_BcsmCamelTDP_CriteriaList,
        _VlrCamelSubscriptionInfo_tif_CSI,
        _VlrCamelSubscriptionInfo_m_CSI,
        _VlrCamelSubscriptionInfo_mo_sms_CSI,
        _VlrCamelSubscriptionInfo_vt_CSI,
        _VlrCamelSubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList,
        _VlrCamelSubscriptionInfo_d_CSI,
        _VlrCamelSubscriptionInfo_mt_sms_CSI,
        _VlrCamelSubscriptionInfo_mt_smsCAMELTDP_CriteriaList,
        VlrCamelSubscriptionInfo,
        _MT_smsCAMELTDP_CriteriaList__item_,
        MT_smsCAMELTDP_CriteriaList,
        _MT_smsCAMELTDP_Criteria_sms_TriggerDetectionPoint,
        _MT_smsCAMELTDP_Criteria_tpdu_TypeCriterion,
        MT_smsCAMELTDP_Criteria,
        _TPDU_TypeCriterion__item_,
        TPDU_TypeCriterion,
        maxNumOfTPDUTypes,
        MT_SMS_TPDU_Type,
        _D_CSI_dp_AnalysedInfoCriteriaList,
        _D_CSI_camelCapabilityHandling,
        _D_CSI_extensionContainer,
        _D_CSI_notificationToCSE,
        _D_CSI_csi_Active,
        D_CSI,
        _DP_AnalysedInfoCriteriaList__item_,
        DP_AnalysedInfoCriteriaList,
        maxNumOfDP_AnalysedInfoCriteria,
        _DP_AnalysedInfoCriterium_dialledNumber,
        _DP_AnalysedInfoCriterium_serviceKey,
        _DP_AnalysedInfoCriterium_gsmSCF_Address,
        _DP_AnalysedInfoCriterium_defaultCallHandling,
        _DP_AnalysedInfoCriterium_extensionContainer,
        DP_AnalysedInfoCriterium,
        _SS_CSI_ss_CamelData,
        _SS_CSI_extensionContainer,
        _SS_CSI_notificationToCSE,
        _SS_CSI_csi_Active,
        SS_CSI,
        _SS_CamelData_ss_EventList,
        _SS_CamelData_gsmSCF_Address,
        _SS_CamelData_extensionContainer,
        SS_CamelData,
        _SS_EventList__item_,
        SS_EventList,
        maxNumOfCamelSSEvents,
        _O_CSI_o_BcsmCamelTDPDataList,
        _O_CSI_extensionContainer,
        _O_CSI_camelCapabilityHandling,
        _O_CSI_notificationToCSE,
        _O_CSI_csiActive,
        O_CSI,
        _O_BcsmCamelTDPDataList__item_,
        O_BcsmCamelTDPDataList,
        maxNumOfCamelTDPData,
        _O_BcsmCamelTDPData_o_BcsmTriggerDetectionPoint,
        _O_BcsmCamelTDPData_serviceKey,
        _O_BcsmCamelTDPData_gsmSCF_Address,
        _O_BcsmCamelTDPData_defaultCallHandling,
        _O_BcsmCamelTDPData_extensionContainer,
        O_BcsmCamelTDPData,
        ServiceKey,
        O_BcsmTriggerDetectionPoint,
        _O_BcsmCamelTDPCriteriaList__item_,
        O_BcsmCamelTDPCriteriaList,
        _T_BCSM_CAMEL_TDP_CriteriaList__item_,
        T_BCSM_CAMEL_TDP_CriteriaList,
        _O_BcsmCamelTDP_Criteria_o_BcsmTriggerDetectionPoint,
        _O_BcsmCamelTDP_Criteria_destinationNumberCriteria,
        _O_BcsmCamelTDP_Criteria_basicServiceCriteria,
        _O_BcsmCamelTDP_Criteria_callTypeCriteria,
        _O_BcsmCamelTDP_Criteria_o_CauseValueCriteria,
        _O_BcsmCamelTDP_Criteria_extensionContainer,
        O_BcsmCamelTDP_Criteria,
        _T_BCSM_CAMEL_TDP_Criteria_t_BCSM_TriggerDetectionPoint,
        _T_BCSM_CAMEL_TDP_Criteria_basicServiceCriteria,
        _T_BCSM_CAMEL_TDP_Criteria_t_CauseValueCriteria,
        T_BCSM_CAMEL_TDP_Criteria,
        _DestinationNumberCriteria_matchType,
        _DestinationNumberCriteria_destinationNumberList,
        _DestinationNumberCriteria_destinationNumberLengthList,
        DestinationNumberCriteria,
        _DestinationNumberList__item_,
        DestinationNumberList,
        _DestinationNumberLengthList__item_,
        DestinationNumberLengthList,
        _BasicServiceCriteria__item_,
        BasicServiceCriteria,
        maxNumOfISDN_AddressDigits,
        maxNumOfCamelDestinationNumbers,
        maxNumOfCamelDestinationNumberLengths,
        maxNumOfCamelBasicServiceCriteria,
        CallTypeCriteria,
        MatchType,
        _O_CauseValueCriteria__item_,
        O_CauseValueCriteria,
        _T_CauseValueCriteria__item_,
        T_CauseValueCriteria,
        maxNumOfCAMEL_O_CauseValueCriteria,
        maxNumOfCAMEL_T_CauseValueCriteria,
        CauseValue,
        DefaultCallHandling,
        CamelCapabilityHandling,
        SupportedCamelPhases,
        OfferedCamel4CSIs,
        OfferedCamel4Functionalities,
        _SMS_CSI_sms_CAMEL_TDP_DataList,
        _SMS_CSI_camelCapabilityHandling,
        _SMS_CSI_extensionContainer,
        _SMS_CSI_notificationToCSE,
        _SMS_CSI_csi_Active,
        SMS_CSI,
        _SMS_CAMEL_TDP_DataList__item_,
        SMS_CAMEL_TDP_DataList,
        _SMS_CAMEL_TDP_Data_sms_TriggerDetectionPoint,
        _SMS_CAMEL_TDP_Data_serviceKey,
        _SMS_CAMEL_TDP_Data_gsmSCF_Address,
        _SMS_CAMEL_TDP_Data_defaultSMS_Handling,
        _SMS_CAMEL_TDP_Data_extensionContainer,
        SMS_CAMEL_TDP_Data,
        SMS_TriggerDetectionPoint,
        DefaultSMS_Handling,
        _M_CSI_mobilityTriggers,
        _M_CSI_serviceKey,
        _M_CSI_gsmSCF_Address,
        _M_CSI_extensionContainer,
        _M_CSI_notificationToCSE,
        _M_CSI_csi_Active,
        M_CSI,
        _MG_CSI_mobilityTriggers,
        _MG_CSI_serviceKey,
        _MG_CSI_gsmSCF_Address,
        _MG_CSI_extensionContainer,
        _MG_CSI_notificationToCSE,
        _MG_CSI_csi_Active,
        MG_CSI,
        _MobilityTriggers__item_,
        MobilityTriggers,
        maxNumOfMobilityTriggers,
        MM_Code,
        _T_CSI_t_BcsmCamelTDPDataList,
        _T_CSI_extensionContainer,
        _T_CSI_camelCapabilityHandling,
        _T_CSI_notificationToCSE,
        _T_CSI_csi_Active,
        T_CSI,
        _T_BcsmCamelTDPDataList__item_,
        T_BcsmCamelTDPDataList,
        _T_BcsmCamelTDPData_t_BcsmTriggerDetectionPoint,
        _T_BcsmCamelTDPData_serviceKey,
        _T_BcsmCamelTDPData_gsmSCF_Address,
        _T_BcsmCamelTDPData_defaultCallHandling,
        _T_BcsmCamelTDPData_extensionContainer,
        T_BcsmCamelTDPData,
        T_BcsmTriggerDetectionPoint,
        _SendRoutingInfoForGprsArg_imsi,
        _SendRoutingInfoForGprsArg_ggsn_Address,
        _SendRoutingInfoForGprsArg_ggsn_Number,
        _SendRoutingInfoForGprsArg_extensionContainer,
        SendRoutingInfoForGprsArg,
        _SendRoutingInfoForGprsRes_sgsn_Address,
        _SendRoutingInfoForGprsRes_ggsn_Address,
        _SendRoutingInfoForGprsRes_mobileNotReachableReason,
        _SendRoutingInfoForGprsRes_extensionContainer,
        SendRoutingInfoForGprsRes,
        _FailureReportArg_imsi,
        _FailureReportArg_ggsn_Number,
        _FailureReportArg_ggsn_Address,
        _FailureReportArg_extensionContainer,
        FailureReportArg,
        _FailureReportRes_ggsn_Address,
        _FailureReportRes_extensionContainer,
        FailureReportRes,
        _NoteMsPresentForGprsArg_imsi,
        _NoteMsPresentForGprsArg_sgsn_Address,
        _NoteMsPresentForGprsArg_ggsn_Address,
        _NoteMsPresentForGprsArg_extensionContainer,
        NoteMsPresentForGprsArg,
        _NoteMsPresentForGprsRes_extensionContainer,
        NoteMsPresentForGprsRes,
        _ResetArg_sendingNodenumber,
        _ResetArg_hlr_List,
        _ResetArg_extensionContainer,
        _ResetArg_reset_Id_List,
        _ResetArg_subscriptionData,
        _ResetArg_subscriptionDataDeletion,
        ResetArg,
        _SendingNode_Number_hlr_Number,
        _SendingNode_Number_css_Number,
        SendingNode_Number,
        _RestoreDataArg_imsi,
        _RestoreDataArg_lmsi,
        _RestoreDataArg_extensionContainer,
        _RestoreDataArg_vlr_Capability,
        _RestoreDataArg_restorationIndicator,
        RestoreDataArg,
        _RestoreDataRes_hlr_Number,
        _RestoreDataRes_msNotReachable,
        _RestoreDataRes_extensionContainer,
        RestoreDataRes,
        _VBSDataList__item_,
        VBSDataList,
        _VGCSDataList__item_,
        VGCSDataList,
        maxNumOfVBSGroupIds,
        maxNumOfVGCSGroupIds,
        _VoiceGroupCallData_groupId,
        _VoiceGroupCallData_extensionContainer,
        _VoiceGroupCallData_additionalSubscriptions,
        _VoiceGroupCallData_additionalInfo,
        _VoiceGroupCallData_longGroupId,
        VoiceGroupCallData,
        AdditionalInfo,
        AdditionalSubscriptions,
        _VoiceBroadcastData_groupid,
        _VoiceBroadcastData_broadcastInitEntitlement,
        _VoiceBroadcastData_extensionContainer,
        _VoiceBroadcastData_longGroupId,
        VoiceBroadcastData,
        GroupId,
        Long_GroupId,
        _ProvideSubscriberInfoArg_imsi,
        _ProvideSubscriberInfoArg_lmsi,
        _ProvideSubscriberInfoArg_requestedInfo,
        _ProvideSubscriberInfoArg_extensionContainer,
        _ProvideSubscriberInfoArg_callPriority,
        ProvideSubscriberInfoArg,
        _ProvideSubscriberInfoRes_subscriberInfo,
        _ProvideSubscriberInfoRes_extensionContainer,
        ProvideSubscriberInfoRes,
        _SubscriberInfo_locationInformation,
        _SubscriberInfo_subscriberState,
        _SubscriberInfo_extensionContainer,
        _SubscriberInfo_locationInformationGPRS,
        _SubscriberInfo_ps_SubscriberState,
        _SubscriberInfo_imei,
        _SubscriberInfo_ms_Classmark2,
        _SubscriberInfo_gprs_MS_Class,
        _SubscriberInfo_mnpInfoRes,
        _SubscriberInfo_imsVoiceOverPS_SessionsIndication,
        _SubscriberInfo_lastUE_ActivityTime,
        _SubscriberInfo_lastRAT_Type,
        _SubscriberInfo_eps_SubscriberState,
        _SubscriberInfo_locationInformationEPS,
        _SubscriberInfo_timeZone,
        _SubscriberInfo_daylightSavingTime,
        _SubscriberInfo_locationInformation5GS,
        SubscriberInfo,
        IMS_VoiceOverPS_SessionsInd,
        TimeZone,
        DaylightSavingTime,
        _MNPInfoRes_routeingNumber,
        _MNPInfoRes_imsi,
        _MNPInfoRes_msisdn,
        _MNPInfoRes_numberPortabilityStatus,
        _MNPInfoRes_extensionContainer,
        MNPInfoRes,
        RouteingNumber,
        NumberPortabilityStatus,
        MS_Classmark2,
        _GPRSMSClass_mSNetworkCapability,
        _GPRSMSClass_mSRadioAccessCapability,
        GPRSMSClass,
        MSNetworkCapability,
        MSRadioAccessCapability,
        _RequestedInfo_locationInformation,
        _RequestedInfo_subscriberState,
        _RequestedInfo_extensionContainer,
        _RequestedInfo_currentLocation,
        _RequestedInfo_requestedDomain,
        _RequestedInfo_imei,
        _RequestedInfo_ms_classmark,
        _RequestedInfo_mnpRequestedInfo,
        _RequestedInfo_locationInformationEPS_Supported,
        _RequestedInfo_t_adsData,
        _RequestedInfo_requestedNodes,
        _RequestedInfo_servingNodeIndication,
        _RequestedInfo_localTimeZoneRequest,
        RequestedInfo,
        DomainType,
        RequestedNodes,
        _LocationInformation_ageOfLocationInformation,
        _LocationInformation_geographicalInformation,
        _LocationInformation_vlr_number,
        _LocationInformation_locationNumber,
        _LocationInformation_cellGlobalIdOrServiceAreaIdOrLAI,
        _LocationInformation_extensionContainer,
        _LocationInformation_selectedLSA_Id,
        _LocationInformation_msc_Number,
        _LocationInformation_geodeticInformation,
        _LocationInformation_currentLocationRetrieved,
        _LocationInformation_sai_Present,
        _LocationInformation_locationInformationEPS,
        _LocationInformation_userCSGInformation,
        LocationInformation,
        _LocationInformationEPS_e_utranCellGlobalIdentity,
        _LocationInformationEPS_trackingAreaIdentity,
        _LocationInformationEPS_extensionContainer,
        _LocationInformationEPS_geographicalInformation,
        _LocationInformationEPS_geodeticInformation,
        _LocationInformationEPS_currentLocationRetrieved,
        _LocationInformationEPS_ageOfLocationInformation,
        _LocationInformationEPS_mme_Name,
        LocationInformationEPS,
        _LocationInformationGPRS_cellGlobalIdOrServiceAreaIdOrLAI,
        _LocationInformationGPRS_routeingAreaIdentity,
        _LocationInformationGPRS_geographicalInformation,
        _LocationInformationGPRS_sgsn_Number,
        _LocationInformationGPRS_selectedLSAIdentity,
        _LocationInformationGPRS_extensionContainer,
        _LocationInformationGPRS_sai_Present,
        _LocationInformationGPRS_geodeticInformation,
        _LocationInformationGPRS_currentLocationRetrieved,
        _LocationInformationGPRS_ageOfLocationInformation,
        _LocationInformationGPRS_userCSGInformation,
        LocationInformationGPRS,
        _LocationInformation5GS_nrCellGlobalIdentity,
        _LocationInformation5GS_e_utranCellGlobalIdentity,
        _LocationInformation5GS_geographicalInformation,
        _LocationInformation5GS_geodeticInformation,
        _LocationInformation5GS_amf_address,
        _LocationInformation5GS_trackingAreaIdentity,
        _LocationInformation5GS_currentLocationRetrieved,
        _LocationInformation5GS_ageOfLocationInformation,
        _LocationInformation5GS_vplmnId,
        _LocationInformation5GS_localtimeZone,
        _LocationInformation5GS_rat_Type,
        _LocationInformation5GS_extensionContainer,
        _LocationInformation5GS_nrTrackingAreaIdentity,
        LocationInformation5GS,
        _UserCSGInformation_csg_Id,
        _UserCSGInformation_extensionContainer,
        _UserCSGInformation_accessMode,
        _UserCSGInformation_cmi,
        UserCSGInformation,
        GeographicalInformation,
        GeodeticInformation,
        LocationNumber,
        _SubscriberState_assumedIdle,
        _SubscriberState_camelBusy,
        _SubscriberState_netDetNotReachable,
        _SubscriberState_notProvidedFromVLR,
        SubscriberState,
        _PS_SubscriberState_notProvidedFromSGSNorMME,
        _PS_SubscriberState_ps_Detached,
        _PS_SubscriberState_ps_AttachedNotReachableForPaging,
        _PS_SubscriberState_ps_AttachedReachableForPaging,
        _PS_SubscriberState_ps_PDP_ActiveNotReachableForPaging,
        _PS_SubscriberState_ps_PDP_ActiveReachableForPaging,
        _PS_SubscriberState_netDetNotReachable,
        PS_SubscriberState,
        _PDP_ContextInfoList__item_,
        PDP_ContextInfoList,
        _PDP_ContextInfo_pdp_ContextIdentifier,
        _PDP_ContextInfo_pdp_ContextActive,
        _PDP_ContextInfo_pdp_Type,
        _PDP_ContextInfo_pdp_Address,
        _PDP_ContextInfo_apn_Subscribed,
        _PDP_ContextInfo_apn_InUse,
        _PDP_ContextInfo_nsapi,
        _PDP_ContextInfo_transactionId,
        _PDP_ContextInfo_teid_ForGnAndGp,
        _PDP_ContextInfo_teid_ForIu,
        _PDP_ContextInfo_ggsn_Address,
        _PDP_ContextInfo_qos_Subscribed,
        _PDP_ContextInfo_qos_Requested,
        _PDP_ContextInfo_qos_Negotiated,
        _PDP_ContextInfo_chargingId,
        _PDP_ContextInfo_chargingCharacteristics,
        _PDP_ContextInfo_rnc_Address,
        _PDP_ContextInfo_extensionContainer,
        _PDP_ContextInfo_qos2_Subscribed,
        _PDP_ContextInfo_qos2_Requested,
        _PDP_ContextInfo_qos2_Negotiated,
        _PDP_ContextInfo_qos3_Subscribed,
        _PDP_ContextInfo_qos3_Requested,
        _PDP_ContextInfo_qos3_Negotiated,
        _PDP_ContextInfo_qos4_Subscribed,
        _PDP_ContextInfo_qos4_Requested,
        _PDP_ContextInfo_qos4_Negotiated,
        _PDP_ContextInfo_ext_pdp_Type,
        _PDP_ContextInfo_ext_pdp_Address,
        PDP_ContextInfo,
        NSAPI,
        TransactionId,
        TEID,
        GPRSChargingID,
        NotReachableReason,
        _AnyTimeInterrogationArg_subscriberIdentity,
        _AnyTimeInterrogationArg_requestedInfo,
        _AnyTimeInterrogationArg_gsmSCF_Address,
        _AnyTimeInterrogationArg_extensionContainer,
        AnyTimeInterrogationArg,
        _AnyTimeInterrogationRes_subscriberInfo,
        _AnyTimeInterrogationRes_extensionContainer,
        AnyTimeInterrogationRes,
        _AnyTimeSubscriptionInterrogationArg_subscriberIdentity,
        _AnyTimeSubscriptionInterrogationArg_requestedSubscriptionInfo,
        _AnyTimeSubscriptionInterrogationArg_gsmSCF_Address,
        _AnyTimeSubscriptionInterrogationArg_extensionContainer,
        _AnyTimeSubscriptionInterrogationArg_longFTN_Supported,
        AnyTimeSubscriptionInterrogationArg,
        _AnyTimeSubscriptionInterrogationRes_callForwardingData,
        _AnyTimeSubscriptionInterrogationRes_callBarringData,
        _AnyTimeSubscriptionInterrogationRes_odb_Info,
        _AnyTimeSubscriptionInterrogationRes_camel_SubscriptionInfo,
        _AnyTimeSubscriptionInterrogationRes_supportedVLR_CAMEL_Phases,
        _AnyTimeSubscriptionInterrogationRes_supportedSGSN_CAMEL_Phases,
        _AnyTimeSubscriptionInterrogationRes_extensionContainer,
        _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInVLR,
        _AnyTimeSubscriptionInterrogationRes_offeredCamel4CSIsInSGSN,
        _AnyTimeSubscriptionInterrogationRes_msisdn_BS_List,
        _AnyTimeSubscriptionInterrogationRes_csg_SubscriptionDataList,
        _AnyTimeSubscriptionInterrogationRes_cw_Data,
        _AnyTimeSubscriptionInterrogationRes_ch_Data,
        _AnyTimeSubscriptionInterrogationRes_clip_Data,
        _AnyTimeSubscriptionInterrogationRes_clir_Data,
        _AnyTimeSubscriptionInterrogationRes_ect_data,
        AnyTimeSubscriptionInterrogationRes,
        _CallWaitingData_cwFeatureList,
        _CallWaitingData_notificationToCSE,
        CallWaitingData,
        _Ext_CwFeatureList__item_,
        Ext_CwFeatureList,
        _Ext_CwFeature_basicService,
        _Ext_CwFeature_ss_Status,
        Ext_CwFeature,
        _ClipData_ss_Status,
        _ClipData_overrideCategory,
        _ClipData_notificationToCSE,
        ClipData,
        _ClirData_ss_Status,
        _ClirData_cliRestrictionOption,
        _ClirData_notificationToCSE,
        ClirData,
        _CallHoldData_ss_Status,
        _CallHoldData_notificationToCSE,
        CallHoldData,
        _EctData_ss_Status,
        _EctData_notificationToCSE,
        EctData,
        _RequestedSubscriptionInfo_requestedSS_Info,
        _RequestedSubscriptionInfo_odb,
        _RequestedSubscriptionInfo_requestedCAMEL_SubscriptionInfo,
        _RequestedSubscriptionInfo_supportedVLR_CAMEL_Phases,
        _RequestedSubscriptionInfo_supportedSGSN_CAMEL_Phases,
        _RequestedSubscriptionInfo_extensionContainer,
        _RequestedSubscriptionInfo_additionalRequestedCAMEL_SubscriptionInfo,
        _RequestedSubscriptionInfo_msisdn_BS_List,
        _RequestedSubscriptionInfo_csg_SubscriptionDataRequested,
        _RequestedSubscriptionInfo_cw_Info,
        _RequestedSubscriptionInfo_clip_Info,
        _RequestedSubscriptionInfo_clir_Info,
        _RequestedSubscriptionInfo_hold_Info,
        _RequestedSubscriptionInfo_ect_Info,
        RequestedSubscriptionInfo,
        _MSISDN_BS_List__item_,
        MSISDN_BS_List,
        maxNumOfMSISDN,
        _MSISDN_BS_msisdn,
        _MSISDN_BS_basicServiceList,
        _MSISDN_BS_extensionContainer,
        MSISDN_BS,
        RequestedCAMEL_SubscriptionInfo,
        AdditionalRequestedCAMEL_SubscriptionInfo,
        _CallForwardingData_forwardingFeatureList,
        _CallForwardingData_notificationToCSE,
        _CallForwardingData_extensionContainer,
        CallForwardingData,
        _CallBarringData_callBarringFeatureList,
        _CallBarringData_password,
        _CallBarringData_wrongPasswordAttemptsCounter,
        _CallBarringData_notificationToCSE,
        _CallBarringData_extensionContainer,
        CallBarringData,
        WrongPasswordAttemptsCounter,
        _ODB_Info_odb_Data,
        _ODB_Info_notificationToCSE,
        _ODB_Info_extensionContainer,
        ODB_Info,
        _CAMEL_SubscriptionInfo_o_CSI,
        _CAMEL_SubscriptionInfo_o_BcsmCamelTDP_CriteriaList,
        _CAMEL_SubscriptionInfo_d_CSI,
        _CAMEL_SubscriptionInfo_t_CSI,
        _CAMEL_SubscriptionInfo_t_BCSM_CAMEL_TDP_CriteriaList,
        _CAMEL_SubscriptionInfo_vt_CSI,
        _CAMEL_SubscriptionInfo_vt_BCSM_CAMEL_TDP_CriteriaList,
        _CAMEL_SubscriptionInfo_tif_CSI,
        _CAMEL_SubscriptionInfo_tif_CSI_NotificationToCSE,
        _CAMEL_SubscriptionInfo_gprs_CSI,
        _CAMEL_SubscriptionInfo_mo_sms_CSI,
        _CAMEL_SubscriptionInfo_ss_CSI,
        _CAMEL_SubscriptionInfo_m_CSI,
        _CAMEL_SubscriptionInfo_extensionContainer,
        _CAMEL_SubscriptionInfo_specificCSIDeletedList,
        _CAMEL_SubscriptionInfo_mt_sms_CSI,
        _CAMEL_SubscriptionInfo_mt_smsCAMELTDP_CriteriaList,
        _CAMEL_SubscriptionInfo_mg_csi,
        _CAMEL_SubscriptionInfo_o_IM_CSI,
        _CAMEL_SubscriptionInfo_o_IM_BcsmCamelTDP_CriteriaList,
        _CAMEL_SubscriptionInfo_d_IM_CSI,
        _CAMEL_SubscriptionInfo_vt_IM_CSI,
        _CAMEL_SubscriptionInfo_vt_IM_BCSM_CAMEL_TDP_CriteriaList,
        CAMEL_SubscriptionInfo,
        _AnyTimeModificationArg_subscriberIdentity,
        _AnyTimeModificationArg_gsmSCF_Address,
        _AnyTimeModificationArg_modificationRequestFor_CF_Info,
        _AnyTimeModificationArg_modificationRequestFor_CB_Info,
        _AnyTimeModificationArg_modificationRequestFor_CSI,
        _AnyTimeModificationArg_extensionContainer,
        _AnyTimeModificationArg_longFTN_Supported,
        _AnyTimeModificationArg_modificationRequestFor_ODB_data,
        _AnyTimeModificationArg_modificationRequestFor_IP_SM_GW_Data,
        _AnyTimeModificationArg_activationRequestForUE_reachability,
        _AnyTimeModificationArg_modificationRequestFor_CSG,
        _AnyTimeModificationArg_modificationRequestFor_CW_Data,
        _AnyTimeModificationArg_modificationRequestFor_CLIP_Data,
        _AnyTimeModificationArg_modificationRequestFor_CLIR_Data,
        _AnyTimeModificationArg_modificationRequestFor_HOLD_Data,
        _AnyTimeModificationArg_modificationRequestFor_ECT_Data,
        AnyTimeModificationArg,
        _ModificationRequestFor_CW_Info_basicService,
        _ModificationRequestFor_CW_Info_ss_Status,
        _ModificationRequestFor_CW_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CW_Info_extensionContainer,
        ModificationRequestFor_CW_Info,
        _ModificationRequestFor_CH_Info_ss_Status,
        _ModificationRequestFor_CH_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CH_Info_extensionContainer,
        ModificationRequestFor_CH_Info,
        _ModificationRequestFor_ECT_Info_ss_Status,
        _ModificationRequestFor_ECT_Info_modifyNotificationToCSE,
        _ModificationRequestFor_ECT_Info_extensionContainer,
        ModificationRequestFor_ECT_Info,
        _ModificationRequestFor_CLIR_Info_ss_Status,
        _ModificationRequestFor_CLIR_Info_cliRestrictionOption,
        _ModificationRequestFor_CLIR_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CLIR_Info_extensionContainer,
        ModificationRequestFor_CLIR_Info,
        _ModificationRequestFor_CLIP_Info_ss_Status,
        _ModificationRequestFor_CLIP_Info_overrideCategory,
        _ModificationRequestFor_CLIP_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CLIP_Info_extensionContainer,
        ModificationRequestFor_CLIP_Info,
        _ModificationRequestFor_CSG_modifyNotificationToCSE,
        _ModificationRequestFor_CSG_extensionContainer,
        ModificationRequestFor_CSG,
        RequestedServingNode,
        ServingNode,
        _AnyTimeModificationRes_ss_InfoFor_CSE,
        _AnyTimeModificationRes_camel_SubscriptionInfo,
        _AnyTimeModificationRes_extensionContainer,
        _AnyTimeModificationRes_odb_Info,
        _AnyTimeModificationRes_cw_Data,
        _AnyTimeModificationRes_ch_Data,
        _AnyTimeModificationRes_clip_Data,
        _AnyTimeModificationRes_clir_Data,
        _AnyTimeModificationRes_ect_data,
        _AnyTimeModificationRes_serviceCentreAddress,
        AnyTimeModificationRes,
        _ModificationRequestFor_CF_Info_ss_Code,
        _ModificationRequestFor_CF_Info_basicService,
        _ModificationRequestFor_CF_Info_ss_Status,
        _ModificationRequestFor_CF_Info_forwardedToNumber,
        _ModificationRequestFor_CF_Info_forwardedToSubaddress,
        _ModificationRequestFor_CF_Info_noReplyConditionTime,
        _ModificationRequestFor_CF_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CF_Info_extensionContainer,
        ModificationRequestFor_CF_Info,
        _ModificationRequestFor_CB_Info_ss_Code,
        _ModificationRequestFor_CB_Info_basicService,
        _ModificationRequestFor_CB_Info_ss_Status,
        _ModificationRequestFor_CB_Info_password,
        _ModificationRequestFor_CB_Info_wrongPasswordAttemptsCounter,
        _ModificationRequestFor_CB_Info_modifyNotificationToCSE,
        _ModificationRequestFor_CB_Info_extensionContainer,
        ModificationRequestFor_CB_Info,
        _ModificationRequestFor_ODB_data_odb_data,
        _ModificationRequestFor_ODB_data_modifyNotificationToCSE,
        _ModificationRequestFor_ODB_data_extensionContainer,
        ModificationRequestFor_ODB_data,
        _ModificationRequestFor_CSI_requestedCamel_SubscriptionInfo,
        _ModificationRequestFor_CSI_modifyNotificationToCSE,
        _ModificationRequestFor_CSI_modifyCSI_State,
        _ModificationRequestFor_CSI_extensionContainer,
        _ModificationRequestFor_CSI_additionalRequestedCAMEL_SubscriptionInfo,
        ModificationRequestFor_CSI,
        _ModificationRequestFor_IP_SM_GW_Data_modifyRegistrationStatus,
        _ModificationRequestFor_IP_SM_GW_Data_extensionContainer,
        _ModificationRequestFor_IP_SM_GW_Data_ip_sm_gw_DiameterAddress,
        ModificationRequestFor_IP_SM_GW_Data,
        ModificationInstruction,
        _NoteSubscriberDataModifiedArg_imsi,
        _NoteSubscriberDataModifiedArg_msisdn,
        _NoteSubscriberDataModifiedArg_forwardingInfoFor_CSE,
        _NoteSubscriberDataModifiedArg_callBarringInfoFor_CSE,
        _NoteSubscriberDataModifiedArg_odb_Info,
        _NoteSubscriberDataModifiedArg_camel_SubscriptionInfo,
        _NoteSubscriberDataModifiedArg_allInformationSent,
        _NoteSubscriberDataModifiedArg_extensionContainer,
        _NoteSubscriberDataModifiedArg_ue_reachable,
        _NoteSubscriberDataModifiedArg_csg_SubscriptionDataList,
        _NoteSubscriberDataModifiedArg_cw_Data,
        _NoteSubscriberDataModifiedArg_ch_Data,
        _NoteSubscriberDataModifiedArg_clip_Data,
        _NoteSubscriberDataModifiedArg_clir_Data,
        _NoteSubscriberDataModifiedArg_ect_data,
        NoteSubscriberDataModifiedArg,
        _NoteSubscriberDataModifiedRes_extensionContainer,
        NoteSubscriberDataModifiedRes,
        _NoteMM_EventArg_serviceKey,
        _NoteMM_EventArg_eventMet,
        _NoteMM_EventArg_imsi,
        _NoteMM_EventArg_msisdn,
        _NoteMM_EventArg_locationInformation,
        _NoteMM_EventArg_supportedCAMELPhases,
        _NoteMM_EventArg_extensionContainer,
        _NoteMM_EventArg_locationInformationGPRS,
        _NoteMM_EventArg_offeredCamel4Functionalities,
        NoteMM_EventArg,
        _NoteMM_EventRes_extensionContainer,
        NoteMM_EventRes,
        _Ext_SS_InfoFor_CSE_forwardingInfoFor_CSE,
        _Ext_SS_InfoFor_CSE_callBarringInfoFor_CSE,
        Ext_SS_InfoFor_CSE,
        _Ext_ForwardingInfoFor_CSE_ss_Code,
        _Ext_ForwardingInfoFor_CSE_forwardingFeatureList,
        _Ext_ForwardingInfoFor_CSE_notificationToCSE,
        _Ext_ForwardingInfoFor_CSE_extensionContainer,
        Ext_ForwardingInfoFor_CSE,
        _Ext_CallBarringInfoFor_CSE_ss_Code,
        _Ext_CallBarringInfoFor_CSE_callBarringFeatureList,
        _Ext_CallBarringInfoFor_CSE_password,
        _Ext_CallBarringInfoFor_CSE_wrongPasswordAttemptsCounter,
        _Ext_CallBarringInfoFor_CSE_notificationToCSE,
        _Ext_CallBarringInfoFor_CSE_extensionContainer,
        Ext_CallBarringInfoFor_CSE,
        _UpdateVcsgLocationArg_imsi,
        _UpdateVcsgLocationArg_msisdn,
        _UpdateVcsgLocationArg_vlr_Number,
        _UpdateVcsgLocationArg_sgsn_Number,
        _UpdateVcsgLocationArg_extensionContainer,
        UpdateVcsgLocationArg,
        _UpdateVcsgLocationRes_temporaryEmptySubscriptiondataIndicator,
        _UpdateVcsgLocationRes_extensionContainer,
        UpdateVcsgLocationRes,
        _CancelVcsgLocationArg_identity,
        _CancelVcsgLocationArg_extensionContainer,
        CancelVcsgLocationArg,
        _CancelVcsgLocationRes_extensionContainer,
        CancelVcsgLocationRes,
    ]

class MAP_OM_DataTypes:

    _name_  = u'MAP-OM-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 12, 19]
    
    _obj_ = [
        u'ActivateTraceModeArg',
        u'MDT-Configuration',
        u'MDT-Allowed-PLMNId-List',
        u'PeriodUMTS',
        u'PeriodLTE',
        u'PositioningMethod',
        u'MeasurementQuantity',
        u'EventThreshold1F',
        u'EventThreshold1I',
        u'JobType',
        u'AreaScope',
        u'CGI-List',
        u'E-UTRAN-CGI-List',
        u'RoutingAreaId-List',
        u'LocationAreaId-List',
        u'TrackingAreaId-List',
        u'ListOfMeasurements',
        u'ReportingTrigger',
        u'ReportInterval',
        u'ReportAmount',
        u'EventThresholdRSRP',
        u'EventThresholdRSRQ',
        u'LoggingInterval',
        u'LoggingDuration',
        u'TraceReference',
        u'TraceReference2',
        u'TraceRecordingSessionReference',
        u'TraceType',
        u'TraceDepthList',
        u'TraceDepth',
        u'TraceDepthExtension',
        u'TraceNE-TypeList',
        u'TraceInterfaceList',
        u'MSC-S-InterfaceList',
        u'MGW-InterfaceList',
        u'SGSN-InterfaceList',
        u'GGSN-InterfaceList',
        u'RNC-InterfaceList',
        u'BMSC-InterfaceList',
        u'MME-InterfaceList',
        u'SGW-InterfaceList',
        u'PGW-InterfaceList',
        u'ENB-InterfaceList',
        u'TraceEventList',
        u'MSC-S-EventList',
        u'MGW-EventList',
        u'SGSN-EventList',
        u'GGSN-EventList',
        u'BMSC-EventList',
        u'MME-EventList',
        u'SGW-EventList',
        u'PGW-EventList',
        u'TracePropagationList',
        u'ActivateTraceModeRes',
        u'DeactivateTraceModeArg',
        u'DeactivateTraceModeRes',
        ]
    _type_ = [
        u'ActivateTraceModeArg',
        u'MDT-Configuration',
        u'MDT-Allowed-PLMNId-List',
        u'PeriodUMTS',
        u'PeriodLTE',
        u'PositioningMethod',
        u'MeasurementQuantity',
        u'EventThreshold1F',
        u'EventThreshold1I',
        u'JobType',
        u'AreaScope',
        u'CGI-List',
        u'E-UTRAN-CGI-List',
        u'RoutingAreaId-List',
        u'LocationAreaId-List',
        u'TrackingAreaId-List',
        u'ListOfMeasurements',
        u'ReportingTrigger',
        u'ReportInterval',
        u'ReportAmount',
        u'EventThresholdRSRP',
        u'EventThresholdRSRQ',
        u'LoggingInterval',
        u'LoggingDuration',
        u'TraceReference',
        u'TraceReference2',
        u'TraceRecordingSessionReference',
        u'TraceType',
        u'TraceDepthList',
        u'TraceDepth',
        u'TraceDepthExtension',
        u'TraceNE-TypeList',
        u'TraceInterfaceList',
        u'MSC-S-InterfaceList',
        u'MGW-InterfaceList',
        u'SGSN-InterfaceList',
        u'GGSN-InterfaceList',
        u'RNC-InterfaceList',
        u'BMSC-InterfaceList',
        u'MME-InterfaceList',
        u'SGW-InterfaceList',
        u'PGW-InterfaceList',
        u'ENB-InterfaceList',
        u'TraceEventList',
        u'MSC-S-EventList',
        u'MGW-EventList',
        u'SGSN-EventList',
        u'GGSN-EventList',
        u'BMSC-EventList',
        u'MME-EventList',
        u'SGW-EventList',
        u'PGW-EventList',
        u'TracePropagationList',
        u'ActivateTraceModeRes',
        u'DeactivateTraceModeArg',
        u'DeactivateTraceModeRes',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< ActivateTraceModeArg >-----#
    ActivateTraceModeArg = SEQ(name=u'ActivateTraceModeArg', mode=MODE_TYPE)
    _ActivateTraceModeArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _ActivateTraceModeArg_traceReference = OCT_STR(name=u'traceReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference')))
    _ActivateTraceModeArg_traceType = INT(name=u'traceType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceType')))
    _ActivateTraceModeArg_omc_Id = OCT_STR(name=u'omc-Id', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _ActivateTraceModeArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ActivateTraceModeArg_traceReference2 = OCT_STR(name=u'traceReference2', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference2')), opt=True)
    _ActivateTraceModeArg_traceDepthList = SEQ(name=u'traceDepthList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthList')), opt=True)
    _ActivateTraceModeArg_traceNE_TypeList = BIT_STR(name=u'traceNE-TypeList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceNE-TypeList')), opt=True)
    _ActivateTraceModeArg_traceInterfaceList = SEQ(name=u'traceInterfaceList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceInterfaceList')), opt=True)
    _ActivateTraceModeArg_traceEventList = SEQ(name=u'traceEventList', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceEventList')), opt=True)
    _ActivateTraceModeArg_traceCollectionEntity = OCT_STR(name=u'traceCollectionEntity', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _ActivateTraceModeArg_mdt_Configuration = SEQ(name=u'mdt-Configuration', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MDT-Configuration')), opt=True)
    ActivateTraceModeArg._cont = ASN1Dict([
        (u'imsi', _ActivateTraceModeArg_imsi),
        (u'traceReference', _ActivateTraceModeArg_traceReference),
        (u'traceType', _ActivateTraceModeArg_traceType),
        (u'omc-Id', _ActivateTraceModeArg_omc_Id),
        (u'extensionContainer', _ActivateTraceModeArg_extensionContainer),
        (u'traceReference2', _ActivateTraceModeArg_traceReference2),
        (u'traceDepthList', _ActivateTraceModeArg_traceDepthList),
        (u'traceNE-TypeList', _ActivateTraceModeArg_traceNE_TypeList),
        (u'traceInterfaceList', _ActivateTraceModeArg_traceInterfaceList),
        (u'traceEventList', _ActivateTraceModeArg_traceEventList),
        (u'traceCollectionEntity', _ActivateTraceModeArg_traceCollectionEntity),
        (u'mdt-Configuration', _ActivateTraceModeArg_mdt_Configuration),
        ])
    ActivateTraceModeArg._ext = [u'traceReference2', u'traceDepthList', u'traceNE-TypeList', u'traceInterfaceList', u'traceEventList', u'traceCollectionEntity', u'mdt-Configuration']
    
    #-----< MDT-Configuration >-----#
    MDT_Configuration = SEQ(name=u'MDT-Configuration', mode=MODE_TYPE)
    _MDT_Configuration_jobType = ENUM(name=u'jobType', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'JobType')))
    _MDT_Configuration_areaScope = SEQ(name=u'areaScope', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'AreaScope')), opt=True)
    _MDT_Configuration_listOfMeasurements = OCT_STR(name=u'listOfMeasurements', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'ListOfMeasurements')), opt=True)
    _MDT_Configuration_reportingTrigger = OCT_STR(name=u'reportingTrigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'ReportingTrigger')), opt=True)
    _MDT_Configuration_reportInterval = ENUM(name=u'reportInterval', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'ReportInterval')), opt=True)
    _MDT_Configuration_reportAmount = ENUM(name=u'reportAmount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'ReportAmount')), opt=True)
    _MDT_Configuration_eventThresholdRSRP = INT(name=u'eventThresholdRSRP', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThresholdRSRP')), opt=True)
    _MDT_Configuration_eventThresholdRSRQ = INT(name=u'eventThresholdRSRQ', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThresholdRSRQ')), opt=True)
    _MDT_Configuration_loggingInterval = ENUM(name=u'loggingInterval', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'LoggingInterval')), opt=True)
    _MDT_Configuration_loggingDuration = ENUM(name=u'loggingDuration', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'LoggingDuration')), opt=True)
    _MDT_Configuration_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _MDT_Configuration_measurementPeriodUMTS = ENUM(name=u'measurementPeriodUMTS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodUMTS')), opt=True)
    _MDT_Configuration_measurementPeriodLTE = ENUM(name=u'measurementPeriodLTE', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodLTE')), opt=True)
    _MDT_Configuration_collectionPeriodRRM_UMTS = ENUM(name=u'collectionPeriodRRM-UMTS', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodUMTS')), opt=True)
    _MDT_Configuration_collectionPeriodRRM_LTE = ENUM(name=u'collectionPeriodRRM-LTE', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PeriodLTE')), opt=True)
    _MDT_Configuration_positioningMethod = OCT_STR(name=u'positioningMethod', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PositioningMethod')), opt=True)
    _MDT_Configuration_measurementQuantity = OCT_STR(name=u'measurementQuantity', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MeasurementQuantity')), opt=True)
    _MDT_Configuration_eventThreshold1F = INT(name=u'eventThreshold1F', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThreshold1F')), opt=True)
    _MDT_Configuration_eventThreshold1I = INT(name=u'eventThreshold1I', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'EventThreshold1I')), opt=True)
    _MDT_Configuration_mdt_Allowed_PLMN_List = SEQ_OF(name=u'mdt-Allowed-PLMN-List', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MDT-Allowed-PLMNId-List')), opt=True)
    MDT_Configuration._cont = ASN1Dict([
        (u'jobType', _MDT_Configuration_jobType),
        (u'areaScope', _MDT_Configuration_areaScope),
        (u'listOfMeasurements', _MDT_Configuration_listOfMeasurements),
        (u'reportingTrigger', _MDT_Configuration_reportingTrigger),
        (u'reportInterval', _MDT_Configuration_reportInterval),
        (u'reportAmount', _MDT_Configuration_reportAmount),
        (u'eventThresholdRSRP', _MDT_Configuration_eventThresholdRSRP),
        (u'eventThresholdRSRQ', _MDT_Configuration_eventThresholdRSRQ),
        (u'loggingInterval', _MDT_Configuration_loggingInterval),
        (u'loggingDuration', _MDT_Configuration_loggingDuration),
        (u'extensionContainer', _MDT_Configuration_extensionContainer),
        (u'measurementPeriodUMTS', _MDT_Configuration_measurementPeriodUMTS),
        (u'measurementPeriodLTE', _MDT_Configuration_measurementPeriodLTE),
        (u'collectionPeriodRRM-UMTS', _MDT_Configuration_collectionPeriodRRM_UMTS),
        (u'collectionPeriodRRM-LTE', _MDT_Configuration_collectionPeriodRRM_LTE),
        (u'positioningMethod', _MDT_Configuration_positioningMethod),
        (u'measurementQuantity', _MDT_Configuration_measurementQuantity),
        (u'eventThreshold1F', _MDT_Configuration_eventThreshold1F),
        (u'eventThreshold1I', _MDT_Configuration_eventThreshold1I),
        (u'mdt-Allowed-PLMN-List', _MDT_Configuration_mdt_Allowed_PLMN_List),
        ])
    MDT_Configuration._ext = [u'measurementPeriodUMTS', u'measurementPeriodLTE', u'collectionPeriodRRM-UMTS', u'collectionPeriodRRM-LTE', u'positioningMethod', u'measurementQuantity', u'eventThreshold1F', u'eventThreshold1I', u'mdt-Allowed-PLMN-List']
    
    #-----< MDT-Allowed-PLMNId-List >-----#
    MDT_Allowed_PLMNId_List = SEQ_OF(name=u'MDT-Allowed-PLMNId-List', mode=MODE_TYPE)
    _MDT_Allowed_PLMNId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'PLMN-Id')))
    MDT_Allowed_PLMNId_List._cont = _MDT_Allowed_PLMNId_List__item_
    MDT_Allowed_PLMNId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PeriodUMTS >-----#
    PeriodUMTS = ENUM(name=u'PeriodUMTS', mode=MODE_TYPE)
    PeriodUMTS._cont = ASN1Dict([(u'd250ms', 0), (u'd500ms', 1), (u'd1000ms', 2), (u'd2000ms', 3), (u'd3000ms', 4), (u'd4000ms', 5), (u'd6000ms', 6), (u'd8000ms', 7), (u'd12000ms', 8), (u'd16000ms', 9), (u'd20000ms', 10), (u'd24000ms', 11), (u'd28000ms', 12), (u'd32000ms', 13), (u'd64000ms', 14)])
    PeriodUMTS._ext = None
    
    #-----< PeriodLTE >-----#
    PeriodLTE = ENUM(name=u'PeriodLTE', mode=MODE_TYPE)
    PeriodLTE._cont = ASN1Dict([(u'd1024ms', 0), (u'd1280ms', 1), (u'd2048ms', 2), (u'd2560ms', 3), (u'd5120ms', 4), (u'd10240ms', 5), (u'd1min', 6)])
    PeriodLTE._ext = None
    
    #-----< PositioningMethod >-----#
    PositioningMethod = OCT_STR(name=u'PositioningMethod', mode=MODE_TYPE)
    PositioningMethod._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< MeasurementQuantity >-----#
    MeasurementQuantity = OCT_STR(name=u'MeasurementQuantity', mode=MODE_TYPE)
    MeasurementQuantity._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< EventThreshold1F >-----#
    EventThreshold1F = INT(name=u'EventThreshold1F', mode=MODE_TYPE)
    EventThreshold1F._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-120, ub=165)], ev=None, er=[])
    
    #-----< EventThreshold1I >-----#
    EventThreshold1I = INT(name=u'EventThreshold1I', mode=MODE_TYPE)
    EventThreshold1I._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-120, ub=-25)], ev=None, er=[])
    
    #-----< JobType >-----#
    JobType = ENUM(name=u'JobType', mode=MODE_TYPE)
    JobType._cont = ASN1Dict([(u'immediate-MDT-only', 0), (u'logged-MDT-only', 1), (u'trace-only', 2), (u'immediate-MDT-and-trace', 3)])
    JobType._ext = None
    
    #-----< AreaScope >-----#
    AreaScope = SEQ(name=u'AreaScope', mode=MODE_TYPE)
    _AreaScope_cgi_List = SEQ_OF(name=u'cgi-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'CGI-List')), opt=True)
    _AreaScope_e_utran_cgi_List = SEQ_OF(name=u'e-utran-cgi-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'E-UTRAN-CGI-List')), opt=True)
    _AreaScope_routingAreaId_List = SEQ_OF(name=u'routingAreaId-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'RoutingAreaId-List')), opt=True)
    _AreaScope_locationAreaId_List = SEQ_OF(name=u'locationAreaId-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'LocationAreaId-List')), opt=True)
    _AreaScope_trackingAreaId_List = SEQ_OF(name=u'trackingAreaId-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TrackingAreaId-List')), opt=True)
    _AreaScope_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    AreaScope._cont = ASN1Dict([
        (u'cgi-List', _AreaScope_cgi_List),
        (u'e-utran-cgi-List', _AreaScope_e_utran_cgi_List),
        (u'routingAreaId-List', _AreaScope_routingAreaId_List),
        (u'locationAreaId-List', _AreaScope_locationAreaId_List),
        (u'trackingAreaId-List', _AreaScope_trackingAreaId_List),
        (u'extensionContainer', _AreaScope_extensionContainer),
        ])
    AreaScope._ext = []
    
    #-----< CGI-List >-----#
    CGI_List = SEQ_OF(name=u'CGI-List', mode=MODE_TYPE)
    _CGI_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'GlobalCellId')))
    CGI_List._cont = _CGI_List__item_
    CGI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< E-UTRAN-CGI-List >-----#
    E_UTRAN_CGI_List = SEQ_OF(name=u'E-UTRAN-CGI-List', mode=MODE_TYPE)
    _E_UTRAN_CGI_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'E-UTRAN-CGI')))
    E_UTRAN_CGI_List._cont = _E_UTRAN_CGI_List__item_
    E_UTRAN_CGI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< RoutingAreaId-List >-----#
    RoutingAreaId_List = SEQ_OF(name=u'RoutingAreaId-List', mode=MODE_TYPE)
    _RoutingAreaId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'RAIdentity')))
    RoutingAreaId_List._cont = _RoutingAreaId_List__item_
    RoutingAreaId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< LocationAreaId-List >-----#
    LocationAreaId_List = SEQ_OF(name=u'LocationAreaId-List', mode=MODE_TYPE)
    _LocationAreaId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LAIFixedLength')))
    LocationAreaId_List._cont = _LocationAreaId_List__item_
    LocationAreaId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< TrackingAreaId-List >-----#
    TrackingAreaId_List = SEQ_OF(name=u'TrackingAreaId-List', mode=MODE_TYPE)
    _TrackingAreaId_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'TA-Id')))
    TrackingAreaId_List._cont = _TrackingAreaId_List__item_
    TrackingAreaId_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< ListOfMeasurements >-----#
    ListOfMeasurements = OCT_STR(name=u'ListOfMeasurements', mode=MODE_TYPE)
    ListOfMeasurements._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< ReportingTrigger >-----#
    ReportingTrigger = OCT_STR(name=u'ReportingTrigger', mode=MODE_TYPE)
    ReportingTrigger._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ReportInterval >-----#
    ReportInterval = ENUM(name=u'ReportInterval', mode=MODE_TYPE)
    ReportInterval._cont = ASN1Dict([(u'umts250ms', 0), (u'umts500ms', 1), (u'umts1000ms', 2), (u'umts2000ms', 3), (u'umts3000ms', 4), (u'umts4000ms', 5), (u'umts6000ms', 6), (u'umts8000ms', 7), (u'umts12000ms', 8), (u'umts16000ms', 9), (u'umts20000ms', 10), (u'umts24000ms', 11), (u'umts28000ms', 12), (u'umts32000ms', 13), (u'umts64000ms', 14), (u'lte120ms', 15), (u'lte240ms', 16), (u'lte480ms', 17), (u'lte640ms', 18), (u'lte1024ms', 19), (u'lte2048ms', 20), (u'lte5120ms', 21), (u'lte10240ms', 22), (u'lte1min', 23), (u'lte6min', 24), (u'lte12min', 25), (u'lte30min', 26), (u'lte60min', 27)])
    ReportInterval._ext = None
    
    #-----< ReportAmount >-----#
    ReportAmount = ENUM(name=u'ReportAmount', mode=MODE_TYPE)
    ReportAmount._cont = ASN1Dict([(u'd1', 0), (u'd2', 1), (u'd4', 2), (u'd8', 3), (u'd16', 4), (u'd32', 5), (u'd64', 6), (u'infinity', 7)])
    ReportAmount._ext = None
    
    #-----< EventThresholdRSRP >-----#
    EventThresholdRSRP = INT(name=u'EventThresholdRSRP', mode=MODE_TYPE)
    EventThresholdRSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=None, er=[])
    
    #-----< EventThresholdRSRQ >-----#
    EventThresholdRSRQ = INT(name=u'EventThresholdRSRQ', mode=MODE_TYPE)
    EventThresholdRSRQ._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=34)], ev=None, er=[])
    
    #-----< LoggingInterval >-----#
    LoggingInterval = ENUM(name=u'LoggingInterval', mode=MODE_TYPE)
    LoggingInterval._cont = ASN1Dict([(u'd1dot28', 0), (u'd2dot56', 1), (u'd5dot12', 2), (u'd10dot24', 3), (u'd20dot48', 4), (u'd30dot72', 5), (u'd40dot96', 6), (u'd61dot44', 7)])
    LoggingInterval._ext = None
    
    #-----< LoggingDuration >-----#
    LoggingDuration = ENUM(name=u'LoggingDuration', mode=MODE_TYPE)
    LoggingDuration._cont = ASN1Dict([(u'd600sec', 0), (u'd1200sec', 1), (u'd2400sec', 2), (u'd3600sec', 3), (u'd5400sec', 4), (u'd7200sec', 5)])
    LoggingDuration._ext = None
    
    #-----< TraceReference >-----#
    TraceReference = OCT_STR(name=u'TraceReference', mode=MODE_TYPE)
    TraceReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< TraceReference2 >-----#
    TraceReference2 = OCT_STR(name=u'TraceReference2', mode=MODE_TYPE)
    TraceReference2._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< TraceRecordingSessionReference >-----#
    TraceRecordingSessionReference = OCT_STR(name=u'TraceRecordingSessionReference', mode=MODE_TYPE)
    TraceRecordingSessionReference._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< TraceType >-----#
    TraceType = INT(name=u'TraceType', mode=MODE_TYPE)
    TraceType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< TraceDepthList >-----#
    TraceDepthList = SEQ(name=u'TraceDepthList', mode=MODE_TYPE)
    _TraceDepthList_msc_s_TraceDepth = ENUM(name=u'msc-s-TraceDepth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_mgw_TraceDepth = ENUM(name=u'mgw-TraceDepth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_sgsn_TraceDepth = ENUM(name=u'sgsn-TraceDepth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_ggsn_TraceDepth = ENUM(name=u'ggsn-TraceDepth', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_rnc_TraceDepth = ENUM(name=u'rnc-TraceDepth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_bmsc_TraceDepth = ENUM(name=u'bmsc-TraceDepth', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_mme_TraceDepth = ENUM(name=u'mme-TraceDepth', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_sgw_TraceDepth = ENUM(name=u'sgw-TraceDepth', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_pgw_TraceDepth = ENUM(name=u'pgw-TraceDepth', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_eNB_TraceDepth = ENUM(name=u'eNB-TraceDepth', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TraceDepthList_msc_s_TraceDepthExtension = ENUM(name=u'msc-s-TraceDepthExtension', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_mgw_TraceDepthExtension = ENUM(name=u'mgw-TraceDepthExtension', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_sgsn_TraceDepthExtension = ENUM(name=u'sgsn-TraceDepthExtension', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_ggsn_TraceDepthExtension = ENUM(name=u'ggsn-TraceDepthExtension', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_rnc_TraceDepthExtension = ENUM(name=u'rnc-TraceDepthExtension', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_bmsc_TraceDepthExtension = ENUM(name=u'bmsc-TraceDepthExtension', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_mme_TraceDepthExtension = ENUM(name=u'mme-TraceDepthExtension', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_sgw_TraceDepthExtension = ENUM(name=u'sgw-TraceDepthExtension', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_pgw_TraceDepthExtension = ENUM(name=u'pgw-TraceDepthExtension', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TraceDepthList_eNB_TraceDepthExtension = ENUM(name=u'eNB-TraceDepthExtension', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    TraceDepthList._cont = ASN1Dict([
        (u'msc-s-TraceDepth', _TraceDepthList_msc_s_TraceDepth),
        (u'mgw-TraceDepth', _TraceDepthList_mgw_TraceDepth),
        (u'sgsn-TraceDepth', _TraceDepthList_sgsn_TraceDepth),
        (u'ggsn-TraceDepth', _TraceDepthList_ggsn_TraceDepth),
        (u'rnc-TraceDepth', _TraceDepthList_rnc_TraceDepth),
        (u'bmsc-TraceDepth', _TraceDepthList_bmsc_TraceDepth),
        (u'mme-TraceDepth', _TraceDepthList_mme_TraceDepth),
        (u'sgw-TraceDepth', _TraceDepthList_sgw_TraceDepth),
        (u'pgw-TraceDepth', _TraceDepthList_pgw_TraceDepth),
        (u'eNB-TraceDepth', _TraceDepthList_eNB_TraceDepth),
        (u'msc-s-TraceDepthExtension', _TraceDepthList_msc_s_TraceDepthExtension),
        (u'mgw-TraceDepthExtension', _TraceDepthList_mgw_TraceDepthExtension),
        (u'sgsn-TraceDepthExtension', _TraceDepthList_sgsn_TraceDepthExtension),
        (u'ggsn-TraceDepthExtension', _TraceDepthList_ggsn_TraceDepthExtension),
        (u'rnc-TraceDepthExtension', _TraceDepthList_rnc_TraceDepthExtension),
        (u'bmsc-TraceDepthExtension', _TraceDepthList_bmsc_TraceDepthExtension),
        (u'mme-TraceDepthExtension', _TraceDepthList_mme_TraceDepthExtension),
        (u'sgw-TraceDepthExtension', _TraceDepthList_sgw_TraceDepthExtension),
        (u'pgw-TraceDepthExtension', _TraceDepthList_pgw_TraceDepthExtension),
        (u'eNB-TraceDepthExtension', _TraceDepthList_eNB_TraceDepthExtension),
        ])
    TraceDepthList._ext = [u'mme-TraceDepth', u'sgw-TraceDepth', u'pgw-TraceDepth', u'eNB-TraceDepth', u'msc-s-TraceDepthExtension', u'mgw-TraceDepthExtension', u'sgsn-TraceDepthExtension', u'ggsn-TraceDepthExtension', u'rnc-TraceDepthExtension', u'bmsc-TraceDepthExtension', u'mme-TraceDepthExtension', u'sgw-TraceDepthExtension', u'pgw-TraceDepthExtension', u'eNB-TraceDepthExtension']
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name=u'TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([(u'minimum', 0), (u'medium', 1), (u'maximum', 2)])
    TraceDepth._ext = []
    
    #-----< TraceDepthExtension >-----#
    TraceDepthExtension = ENUM(name=u'TraceDepthExtension', mode=MODE_TYPE)
    TraceDepthExtension._cont = ASN1Dict([(u'minimumWithoutVendorSpecificExtension', 0), (u'mediumWithoutVendorSpecificExtension', 1), (u'maximumWithoutVendorSpecificExtension', 2)])
    TraceDepthExtension._ext = []
    
    #-----< TraceNE-TypeList >-----#
    TraceNE_TypeList = BIT_STR(name=u'TraceNE-TypeList', mode=MODE_TYPE)
    TraceNE_TypeList._cont = ASN1Dict([(u'msc-s', 0), (u'mgw', 1), (u'sgsn', 2), (u'ggsn', 3), (u'rnc', 4), (u'bm-sc', 5), (u'mme', 6), (u'sgw', 7), (u'pgw', 8), (u'eNB', 9)])
    TraceNE_TypeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=16)], ev=None, er=[])
    
    #-----< TraceInterfaceList >-----#
    TraceInterfaceList = SEQ(name=u'TraceInterfaceList', mode=MODE_TYPE)
    _TraceInterfaceList_msc_s_List = BIT_STR(name=u'msc-s-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-InterfaceList')), opt=True)
    _TraceInterfaceList_mgw_List = BIT_STR(name=u'mgw-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-InterfaceList')), opt=True)
    _TraceInterfaceList_sgsn_List = BIT_STR(name=u'sgsn-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGSN-InterfaceList')), opt=True)
    _TraceInterfaceList_ggsn_List = BIT_STR(name=u'ggsn-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'GGSN-InterfaceList')), opt=True)
    _TraceInterfaceList_rnc_List = BIT_STR(name=u'rnc-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'RNC-InterfaceList')), opt=True)
    _TraceInterfaceList_bmsc_List = BIT_STR(name=u'bmsc-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'BMSC-InterfaceList')), opt=True)
    _TraceInterfaceList_mme_List = BIT_STR(name=u'mme-List', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MME-InterfaceList')), opt=True)
    _TraceInterfaceList_sgw_List = BIT_STR(name=u'sgw-List', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGW-InterfaceList')), opt=True)
    _TraceInterfaceList_pgw_List = BIT_STR(name=u'pgw-List', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PGW-InterfaceList')), opt=True)
    _TraceInterfaceList_eNB_List = BIT_STR(name=u'eNB-List', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'ENB-InterfaceList')), opt=True)
    TraceInterfaceList._cont = ASN1Dict([
        (u'msc-s-List', _TraceInterfaceList_msc_s_List),
        (u'mgw-List', _TraceInterfaceList_mgw_List),
        (u'sgsn-List', _TraceInterfaceList_sgsn_List),
        (u'ggsn-List', _TraceInterfaceList_ggsn_List),
        (u'rnc-List', _TraceInterfaceList_rnc_List),
        (u'bmsc-List', _TraceInterfaceList_bmsc_List),
        (u'mme-List', _TraceInterfaceList_mme_List),
        (u'sgw-List', _TraceInterfaceList_sgw_List),
        (u'pgw-List', _TraceInterfaceList_pgw_List),
        (u'eNB-List', _TraceInterfaceList_eNB_List),
        ])
    TraceInterfaceList._ext = [u'mme-List', u'sgw-List', u'pgw-List', u'eNB-List']
    
    #-----< MSC-S-InterfaceList >-----#
    MSC_S_InterfaceList = BIT_STR(name=u'MSC-S-InterfaceList', mode=MODE_TYPE)
    MSC_S_InterfaceList._cont = ASN1Dict([(u'a', 0), (u'iu', 1), (u'mc', 2), (u'map-g', 3), (u'map-b', 4), (u'map-e', 5), (u'map-f', 6), (u'cap', 7), (u'map-d', 8), (u'map-c', 9)])
    MSC_S_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=10, ub=16)], ev=None, er=[])
    
    #-----< MGW-InterfaceList >-----#
    MGW_InterfaceList = BIT_STR(name=u'MGW-InterfaceList', mode=MODE_TYPE)
    MGW_InterfaceList._cont = ASN1Dict([(u'mc', 0), (u'nb-up', 1), (u'iu-up', 2)])
    MGW_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< SGSN-InterfaceList >-----#
    SGSN_InterfaceList = BIT_STR(name=u'SGSN-InterfaceList', mode=MODE_TYPE)
    SGSN_InterfaceList._cont = ASN1Dict([(u'gb', 0), (u'iu', 1), (u'gn', 2), (u'map-gr', 3), (u'map-gd', 4), (u'map-gf', 5), (u'gs', 6), (u'ge', 7), (u's3', 8), (u's4', 9), (u's6d', 10)])
    SGSN_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=16)], ev=None, er=[])
    
    #-----< GGSN-InterfaceList >-----#
    GGSN_InterfaceList = BIT_STR(name=u'GGSN-InterfaceList', mode=MODE_TYPE)
    GGSN_InterfaceList._cont = ASN1Dict([(u'gn', 0), (u'gi', 1), (u'gmb', 2)])
    GGSN_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< RNC-InterfaceList >-----#
    RNC_InterfaceList = BIT_STR(name=u'RNC-InterfaceList', mode=MODE_TYPE)
    RNC_InterfaceList._cont = ASN1Dict([(u'iu', 0), (u'iur', 1), (u'iub', 2), (u'uu', 3)])
    RNC_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=8)], ev=None, er=[])
    
    #-----< BMSC-InterfaceList >-----#
    BMSC_InterfaceList = BIT_STR(name=u'BMSC-InterfaceList', mode=MODE_TYPE)
    BMSC_InterfaceList._cont = ASN1Dict([(u'gmb', 0)])
    BMSC_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MME-InterfaceList >-----#
    MME_InterfaceList = BIT_STR(name=u'MME-InterfaceList', mode=MODE_TYPE)
    MME_InterfaceList._cont = ASN1Dict([(u's1-mme', 0), (u's3', 1), (u's6a', 2), (u's10', 3), (u's11', 4)])
    MME_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=8)], ev=None, er=[])
    
    #-----< SGW-InterfaceList >-----#
    SGW_InterfaceList = BIT_STR(name=u'SGW-InterfaceList', mode=MODE_TYPE)
    SGW_InterfaceList._cont = ASN1Dict([(u's4', 0), (u's5', 1), (u's8b', 2), (u's11', 3), (u'gxc', 4)])
    SGW_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=8)], ev=None, er=[])
    
    #-----< PGW-InterfaceList >-----#
    PGW_InterfaceList = BIT_STR(name=u'PGW-InterfaceList', mode=MODE_TYPE)
    PGW_InterfaceList._cont = ASN1Dict([(u's2a', 0), (u's2b', 1), (u's2c', 2), (u's5', 3), (u's6b', 4), (u'gx', 5), (u's8b', 6), (u'sgi', 7)])
    PGW_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=8, ub=16)], ev=None, er=[])
    
    #-----< ENB-InterfaceList >-----#
    ENB_InterfaceList = BIT_STR(name=u'ENB-InterfaceList', mode=MODE_TYPE)
    ENB_InterfaceList._cont = ASN1Dict([(u's1-mme', 0), (u'x2', 1), (u'uu', 2)])
    ENB_InterfaceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< TraceEventList >-----#
    TraceEventList = SEQ(name=u'TraceEventList', mode=MODE_TYPE)
    _TraceEventList_msc_s_List = BIT_STR(name=u'msc-s-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-EventList')), opt=True)
    _TraceEventList_mgw_List = BIT_STR(name=u'mgw-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-EventList')), opt=True)
    _TraceEventList_sgsn_List = BIT_STR(name=u'sgsn-List', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGSN-EventList')), opt=True)
    _TraceEventList_ggsn_List = BIT_STR(name=u'ggsn-List', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'GGSN-EventList')), opt=True)
    _TraceEventList_bmsc_List = BIT_STR(name=u'bmsc-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'BMSC-EventList')), opt=True)
    _TraceEventList_mme_List = BIT_STR(name=u'mme-List', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MME-EventList')), opt=True)
    _TraceEventList_sgw_List = BIT_STR(name=u'sgw-List', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'SGW-EventList')), opt=True)
    _TraceEventList_pgw_List = BIT_STR(name=u'pgw-List', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'PGW-EventList')), opt=True)
    TraceEventList._cont = ASN1Dict([
        (u'msc-s-List', _TraceEventList_msc_s_List),
        (u'mgw-List', _TraceEventList_mgw_List),
        (u'sgsn-List', _TraceEventList_sgsn_List),
        (u'ggsn-List', _TraceEventList_ggsn_List),
        (u'bmsc-List', _TraceEventList_bmsc_List),
        (u'mme-List', _TraceEventList_mme_List),
        (u'sgw-List', _TraceEventList_sgw_List),
        (u'pgw-List', _TraceEventList_pgw_List),
        ])
    TraceEventList._ext = [u'mme-List', u'sgw-List', u'pgw-List']
    
    #-----< MSC-S-EventList >-----#
    MSC_S_EventList = BIT_STR(name=u'MSC-S-EventList', mode=MODE_TYPE)
    MSC_S_EventList._cont = ASN1Dict([(u'mo-mtCall', 0), (u'mo-mt-sms', 1), (u'lu-imsiAttach-imsiDetach', 2), (u'handovers', 3), (u'ss', 4)])
    MSC_S_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=16)], ev=None, er=[])
    
    #-----< MGW-EventList >-----#
    MGW_EventList = BIT_STR(name=u'MGW-EventList', mode=MODE_TYPE)
    MGW_EventList._cont = ASN1Dict([(u'context', 0)])
    MGW_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< SGSN-EventList >-----#
    SGSN_EventList = BIT_STR(name=u'SGSN-EventList', mode=MODE_TYPE)
    SGSN_EventList._cont = ASN1Dict([(u'pdpContext', 0), (u'mo-mt-sms', 1), (u'rau-gprsAttach-gprsDetach', 2), (u'mbmsContext', 3)])
    SGSN_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=16)], ev=None, er=[])
    
    #-----< GGSN-EventList >-----#
    GGSN_EventList = BIT_STR(name=u'GGSN-EventList', mode=MODE_TYPE)
    GGSN_EventList._cont = ASN1Dict([(u'pdpContext', 0), (u'mbmsContext', 1)])
    GGSN_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=8)], ev=None, er=[])
    
    #-----< BMSC-EventList >-----#
    BMSC_EventList = BIT_STR(name=u'BMSC-EventList', mode=MODE_TYPE)
    BMSC_EventList._cont = ASN1Dict([(u'mbmsMulticastServiceActivation', 0)])
    BMSC_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MME-EventList >-----#
    MME_EventList = BIT_STR(name=u'MME-EventList', mode=MODE_TYPE)
    MME_EventList._cont = ASN1Dict([(u'ue-initiatedPDNconectivityRequest', 0), (u'serviceRequestts', 1), (u'initialAttachTrackingAreaUpdateDetach', 2), (u'ue-initiatedPDNdisconnection', 3), (u'bearerActivationModificationDeletion', 4), (u'handover', 5)])
    MME_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=8)], ev=None, er=[])
    
    #-----< SGW-EventList >-----#
    SGW_EventList = BIT_STR(name=u'SGW-EventList', mode=MODE_TYPE)
    SGW_EventList._cont = ASN1Dict([(u'pdn-connectionCreation', 0), (u'pdn-connectionTermination', 1), (u'bearerActivationModificationDeletion', 2)])
    SGW_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< PGW-EventList >-----#
    PGW_EventList = BIT_STR(name=u'PGW-EventList', mode=MODE_TYPE)
    PGW_EventList._cont = ASN1Dict([(u'pdn-connectionCreation', 0), (u'pdn-connectionTermination', 1), (u'bearerActivationModificationDeletion', 2)])
    PGW_EventList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< TracePropagationList >-----#
    TracePropagationList = SEQ(name=u'TracePropagationList', mode=MODE_TYPE)
    _TracePropagationList_traceReference = OCT_STR(name=u'traceReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference')), opt=True)
    _TracePropagationList_traceType = INT(name=u'traceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceType')), opt=True)
    _TracePropagationList_traceReference2 = OCT_STR(name=u'traceReference2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference2')), opt=True)
    _TracePropagationList_traceRecordingSessionReference = OCT_STR(name=u'traceRecordingSessionReference', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceRecordingSessionReference')), opt=True)
    _TracePropagationList_rnc_TraceDepth = ENUM(name=u'rnc-TraceDepth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TracePropagationList_rnc_InterfaceList = BIT_STR(name=u'rnc-InterfaceList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'RNC-InterfaceList')), opt=True)
    _TracePropagationList_msc_s_TraceDepth = ENUM(name=u'msc-s-TraceDepth', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TracePropagationList_msc_s_InterfaceList = BIT_STR(name=u'msc-s-InterfaceList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-InterfaceList')), opt=True)
    _TracePropagationList_msc_s_EventList = BIT_STR(name=u'msc-s-EventList', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MSC-S-EventList')), opt=True)
    _TracePropagationList_mgw_TraceDepth = ENUM(name=u'mgw-TraceDepth', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepth')), opt=True)
    _TracePropagationList_mgw_InterfaceList = BIT_STR(name=u'mgw-InterfaceList', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-InterfaceList')), opt=True)
    _TracePropagationList_mgw_EventList = BIT_STR(name=u'mgw-EventList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'MGW-EventList')), opt=True)
    _TracePropagationList_rnc_TraceDepthExtension = ENUM(name=u'rnc-TraceDepthExtension', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TracePropagationList_msc_s_TraceDepthExtension = ENUM(name=u'msc-s-TraceDepthExtension', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    _TracePropagationList_mgw_TraceDepthExtension = ENUM(name=u'mgw-TraceDepthExtension', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceDepthExtension')), opt=True)
    TracePropagationList._cont = ASN1Dict([
        (u'traceReference', _TracePropagationList_traceReference),
        (u'traceType', _TracePropagationList_traceType),
        (u'traceReference2', _TracePropagationList_traceReference2),
        (u'traceRecordingSessionReference', _TracePropagationList_traceRecordingSessionReference),
        (u'rnc-TraceDepth', _TracePropagationList_rnc_TraceDepth),
        (u'rnc-InterfaceList', _TracePropagationList_rnc_InterfaceList),
        (u'msc-s-TraceDepth', _TracePropagationList_msc_s_TraceDepth),
        (u'msc-s-InterfaceList', _TracePropagationList_msc_s_InterfaceList),
        (u'msc-s-EventList', _TracePropagationList_msc_s_EventList),
        (u'mgw-TraceDepth', _TracePropagationList_mgw_TraceDepth),
        (u'mgw-InterfaceList', _TracePropagationList_mgw_InterfaceList),
        (u'mgw-EventList', _TracePropagationList_mgw_EventList),
        (u'rnc-TraceDepthExtension', _TracePropagationList_rnc_TraceDepthExtension),
        (u'msc-s-TraceDepthExtension', _TracePropagationList_msc_s_TraceDepthExtension),
        (u'mgw-TraceDepthExtension', _TracePropagationList_mgw_TraceDepthExtension),
        ])
    TracePropagationList._ext = [u'rnc-TraceDepthExtension', u'msc-s-TraceDepthExtension', u'mgw-TraceDepthExtension']
    
    #-----< ActivateTraceModeRes >-----#
    ActivateTraceModeRes = SEQ(name=u'ActivateTraceModeRes', mode=MODE_TYPE)
    _ActivateTraceModeRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ActivateTraceModeRes_traceSupportIndicator = NULL(name=u'traceSupportIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ActivateTraceModeRes._cont = ASN1Dict([
        (u'extensionContainer', _ActivateTraceModeRes_extensionContainer),
        (u'traceSupportIndicator', _ActivateTraceModeRes_traceSupportIndicator),
        ])
    ActivateTraceModeRes._ext = [u'traceSupportIndicator']
    
    #-----< DeactivateTraceModeArg >-----#
    DeactivateTraceModeArg = SEQ(name=u'DeactivateTraceModeArg', mode=MODE_TYPE)
    _DeactivateTraceModeArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _DeactivateTraceModeArg_traceReference = OCT_STR(name=u'traceReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference')))
    _DeactivateTraceModeArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _DeactivateTraceModeArg_traceReference2 = OCT_STR(name=u'traceReference2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-OM-DataTypes', 'TraceReference2')), opt=True)
    DeactivateTraceModeArg._cont = ASN1Dict([
        (u'imsi', _DeactivateTraceModeArg_imsi),
        (u'traceReference', _DeactivateTraceModeArg_traceReference),
        (u'extensionContainer', _DeactivateTraceModeArg_extensionContainer),
        (u'traceReference2', _DeactivateTraceModeArg_traceReference2),
        ])
    DeactivateTraceModeArg._ext = [u'traceReference2']
    
    #-----< DeactivateTraceModeRes >-----#
    DeactivateTraceModeRes = SEQ(name=u'DeactivateTraceModeRes', mode=MODE_TYPE)
    _DeactivateTraceModeRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    DeactivateTraceModeRes._cont = ASN1Dict([
        (u'extensionContainer', _DeactivateTraceModeRes_extensionContainer),
        ])
    DeactivateTraceModeRes._ext = []
    
    _all_ = [
        _ActivateTraceModeArg_imsi,
        _ActivateTraceModeArg_traceReference,
        _ActivateTraceModeArg_traceType,
        _ActivateTraceModeArg_omc_Id,
        _ActivateTraceModeArg_extensionContainer,
        _ActivateTraceModeArg_traceReference2,
        _ActivateTraceModeArg_traceDepthList,
        _ActivateTraceModeArg_traceNE_TypeList,
        _ActivateTraceModeArg_traceInterfaceList,
        _ActivateTraceModeArg_traceEventList,
        _ActivateTraceModeArg_traceCollectionEntity,
        _ActivateTraceModeArg_mdt_Configuration,
        ActivateTraceModeArg,
        _MDT_Configuration_jobType,
        _MDT_Configuration_areaScope,
        _MDT_Configuration_listOfMeasurements,
        _MDT_Configuration_reportingTrigger,
        _MDT_Configuration_reportInterval,
        _MDT_Configuration_reportAmount,
        _MDT_Configuration_eventThresholdRSRP,
        _MDT_Configuration_eventThresholdRSRQ,
        _MDT_Configuration_loggingInterval,
        _MDT_Configuration_loggingDuration,
        _MDT_Configuration_extensionContainer,
        _MDT_Configuration_measurementPeriodUMTS,
        _MDT_Configuration_measurementPeriodLTE,
        _MDT_Configuration_collectionPeriodRRM_UMTS,
        _MDT_Configuration_collectionPeriodRRM_LTE,
        _MDT_Configuration_positioningMethod,
        _MDT_Configuration_measurementQuantity,
        _MDT_Configuration_eventThreshold1F,
        _MDT_Configuration_eventThreshold1I,
        _MDT_Configuration_mdt_Allowed_PLMN_List,
        MDT_Configuration,
        _MDT_Allowed_PLMNId_List__item_,
        MDT_Allowed_PLMNId_List,
        PeriodUMTS,
        PeriodLTE,
        PositioningMethod,
        MeasurementQuantity,
        EventThreshold1F,
        EventThreshold1I,
        JobType,
        _AreaScope_cgi_List,
        _AreaScope_e_utran_cgi_List,
        _AreaScope_routingAreaId_List,
        _AreaScope_locationAreaId_List,
        _AreaScope_trackingAreaId_List,
        _AreaScope_extensionContainer,
        AreaScope,
        _CGI_List__item_,
        CGI_List,
        _E_UTRAN_CGI_List__item_,
        E_UTRAN_CGI_List,
        _RoutingAreaId_List__item_,
        RoutingAreaId_List,
        _LocationAreaId_List__item_,
        LocationAreaId_List,
        _TrackingAreaId_List__item_,
        TrackingAreaId_List,
        ListOfMeasurements,
        ReportingTrigger,
        ReportInterval,
        ReportAmount,
        EventThresholdRSRP,
        EventThresholdRSRQ,
        LoggingInterval,
        LoggingDuration,
        TraceReference,
        TraceReference2,
        TraceRecordingSessionReference,
        TraceType,
        _TraceDepthList_msc_s_TraceDepth,
        _TraceDepthList_mgw_TraceDepth,
        _TraceDepthList_sgsn_TraceDepth,
        _TraceDepthList_ggsn_TraceDepth,
        _TraceDepthList_rnc_TraceDepth,
        _TraceDepthList_bmsc_TraceDepth,
        _TraceDepthList_mme_TraceDepth,
        _TraceDepthList_sgw_TraceDepth,
        _TraceDepthList_pgw_TraceDepth,
        _TraceDepthList_eNB_TraceDepth,
        _TraceDepthList_msc_s_TraceDepthExtension,
        _TraceDepthList_mgw_TraceDepthExtension,
        _TraceDepthList_sgsn_TraceDepthExtension,
        _TraceDepthList_ggsn_TraceDepthExtension,
        _TraceDepthList_rnc_TraceDepthExtension,
        _TraceDepthList_bmsc_TraceDepthExtension,
        _TraceDepthList_mme_TraceDepthExtension,
        _TraceDepthList_sgw_TraceDepthExtension,
        _TraceDepthList_pgw_TraceDepthExtension,
        _TraceDepthList_eNB_TraceDepthExtension,
        TraceDepthList,
        TraceDepth,
        TraceDepthExtension,
        TraceNE_TypeList,
        _TraceInterfaceList_msc_s_List,
        _TraceInterfaceList_mgw_List,
        _TraceInterfaceList_sgsn_List,
        _TraceInterfaceList_ggsn_List,
        _TraceInterfaceList_rnc_List,
        _TraceInterfaceList_bmsc_List,
        _TraceInterfaceList_mme_List,
        _TraceInterfaceList_sgw_List,
        _TraceInterfaceList_pgw_List,
        _TraceInterfaceList_eNB_List,
        TraceInterfaceList,
        MSC_S_InterfaceList,
        MGW_InterfaceList,
        SGSN_InterfaceList,
        GGSN_InterfaceList,
        RNC_InterfaceList,
        BMSC_InterfaceList,
        MME_InterfaceList,
        SGW_InterfaceList,
        PGW_InterfaceList,
        ENB_InterfaceList,
        _TraceEventList_msc_s_List,
        _TraceEventList_mgw_List,
        _TraceEventList_sgsn_List,
        _TraceEventList_ggsn_List,
        _TraceEventList_bmsc_List,
        _TraceEventList_mme_List,
        _TraceEventList_sgw_List,
        _TraceEventList_pgw_List,
        TraceEventList,
        MSC_S_EventList,
        MGW_EventList,
        SGSN_EventList,
        GGSN_EventList,
        BMSC_EventList,
        MME_EventList,
        SGW_EventList,
        PGW_EventList,
        _TracePropagationList_traceReference,
        _TracePropagationList_traceType,
        _TracePropagationList_traceReference2,
        _TracePropagationList_traceRecordingSessionReference,
        _TracePropagationList_rnc_TraceDepth,
        _TracePropagationList_rnc_InterfaceList,
        _TracePropagationList_msc_s_TraceDepth,
        _TracePropagationList_msc_s_InterfaceList,
        _TracePropagationList_msc_s_EventList,
        _TracePropagationList_mgw_TraceDepth,
        _TracePropagationList_mgw_InterfaceList,
        _TracePropagationList_mgw_EventList,
        _TracePropagationList_rnc_TraceDepthExtension,
        _TracePropagationList_msc_s_TraceDepthExtension,
        _TracePropagationList_mgw_TraceDepthExtension,
        TracePropagationList,
        _ActivateTraceModeRes_extensionContainer,
        _ActivateTraceModeRes_traceSupportIndicator,
        ActivateTraceModeRes,
        _DeactivateTraceModeArg_imsi,
        _DeactivateTraceModeArg_traceReference,
        _DeactivateTraceModeArg_extensionContainer,
        _DeactivateTraceModeArg_traceReference2,
        DeactivateTraceModeArg,
        _DeactivateTraceModeRes_extensionContainer,
        DeactivateTraceModeRes,
    ]

class MAP_SM_DataTypes:

    _name_  = u'MAP-SM-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 16, 19]
    
    _obj_ = [
        u'RoutingInfoForSM-Arg',
        u'SM-DeliveryNotIntended',
        u'SM-RP-MTI',
        u'SM-RP-SMEA',
        u'RoutingInfoForSM-Res',
        u'IP-SM-GW-Guidance',
        u'LocationInfoWithLMSI',
        u'Additional-Number',
        u'MO-ForwardSM-Arg',
        u'MO-ForwardSM-Res',
        u'MT-ForwardSM-Arg',
        u'CorrelationID',
        u'SIP-URI',
        u'MT-ForwardSM-Res',
        u'SM-RP-DA',
        u'SM-RP-OA',
        u'SM-DeliveryTimerValue',
        u'ReportSM-DeliveryStatusArg',
        u'SM-DeliveryOutcome',
        u'ReportSM-DeliveryStatusRes',
        u'AlertServiceCentreArg',
        u'SmsGmsc-Alert-Event',
        u'InformServiceCentreArg',
        u'MW-Status',
        u'ReadyForSM-Arg',
        u'ReadyForSM-Res',
        u'AlertReason',
        u'MT-ForwardSM-VGCS-Arg',
        u'MT-ForwardSM-VGCS-Res',
        u'DispatcherList',
        u'maxNumOfDispatchers',
        u'AdditionalDispatcherList',
        u'maxNumOfAdditionalDispatchers',
        ]
    _type_ = [
        u'RoutingInfoForSM-Arg',
        u'SM-DeliveryNotIntended',
        u'SM-RP-MTI',
        u'SM-RP-SMEA',
        u'RoutingInfoForSM-Res',
        u'IP-SM-GW-Guidance',
        u'LocationInfoWithLMSI',
        u'Additional-Number',
        u'MO-ForwardSM-Arg',
        u'MO-ForwardSM-Res',
        u'MT-ForwardSM-Arg',
        u'CorrelationID',
        u'SIP-URI',
        u'MT-ForwardSM-Res',
        u'SM-RP-DA',
        u'SM-RP-OA',
        u'SM-DeliveryTimerValue',
        u'ReportSM-DeliveryStatusArg',
        u'SM-DeliveryOutcome',
        u'ReportSM-DeliveryStatusRes',
        u'AlertServiceCentreArg',
        u'SmsGmsc-Alert-Event',
        u'InformServiceCentreArg',
        u'MW-Status',
        u'ReadyForSM-Arg',
        u'ReadyForSM-Res',
        u'AlertReason',
        u'MT-ForwardSM-VGCS-Arg',
        u'MT-ForwardSM-VGCS-Res',
        u'DispatcherList',
        u'AdditionalDispatcherList',
        ]
    _set_ = [
        ]
    _val_ = [
        u'maxNumOfDispatchers',
        u'maxNumOfAdditionalDispatchers',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< RoutingInfoForSM-Arg >-----#
    RoutingInfoForSM_Arg = SEQ(name=u'RoutingInfoForSM-Arg', mode=MODE_TYPE)
    _RoutingInfoForSM_Arg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RoutingInfoForSM_Arg_sm_RP_PRI = BOOL(name=u'sm-RP-PRI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RoutingInfoForSM_Arg_serviceCentreAddress = OCT_STR(name=u'serviceCentreAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _RoutingInfoForSM_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RoutingInfoForSM_Arg_gprsSupportIndicator = NULL(name=u'gprsSupportIndicator', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RoutingInfoForSM_Arg_sm_RP_MTI = INT(name=u'sm-RP-MTI', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-RP-MTI')), opt=True)
    _RoutingInfoForSM_Arg_sm_RP_SMEA = OCT_STR(name=u'sm-RP-SMEA', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-RP-SMEA')), opt=True)
    _RoutingInfoForSM_Arg_sm_deliveryNotIntended = ENUM(name=u'sm-deliveryNotIntended', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryNotIntended')), opt=True)
    _RoutingInfoForSM_Arg_ip_sm_gwGuidanceIndicator = NULL(name=u'ip-sm-gwGuidanceIndicator', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RoutingInfoForSM_Arg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _RoutingInfoForSM_Arg_t4_Trigger_Indicator = NULL(name=u't4-Trigger-Indicator', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RoutingInfoForSM_Arg_singleAttemptDelivery = NULL(name=u'singleAttemptDelivery', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RoutingInfoForSM_Arg_correlationID = SEQ(name=u'correlationID', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'CorrelationID')), opt=True)
    _RoutingInfoForSM_Arg_smsf_supportIndicator = NULL(name=u'smsf-supportIndicator', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RoutingInfoForSM_Arg._cont = ASN1Dict([
        (u'msisdn', _RoutingInfoForSM_Arg_msisdn),
        (u'sm-RP-PRI', _RoutingInfoForSM_Arg_sm_RP_PRI),
        (u'serviceCentreAddress', _RoutingInfoForSM_Arg_serviceCentreAddress),
        (u'extensionContainer', _RoutingInfoForSM_Arg_extensionContainer),
        (u'gprsSupportIndicator', _RoutingInfoForSM_Arg_gprsSupportIndicator),
        (u'sm-RP-MTI', _RoutingInfoForSM_Arg_sm_RP_MTI),
        (u'sm-RP-SMEA', _RoutingInfoForSM_Arg_sm_RP_SMEA),
        (u'sm-deliveryNotIntended', _RoutingInfoForSM_Arg_sm_deliveryNotIntended),
        (u'ip-sm-gwGuidanceIndicator', _RoutingInfoForSM_Arg_ip_sm_gwGuidanceIndicator),
        (u'imsi', _RoutingInfoForSM_Arg_imsi),
        (u't4-Trigger-Indicator', _RoutingInfoForSM_Arg_t4_Trigger_Indicator),
        (u'singleAttemptDelivery', _RoutingInfoForSM_Arg_singleAttemptDelivery),
        (u'correlationID', _RoutingInfoForSM_Arg_correlationID),
        (u'smsf-supportIndicator', _RoutingInfoForSM_Arg_smsf_supportIndicator),
        ])
    RoutingInfoForSM_Arg._ext = [u'gprsSupportIndicator', u'sm-RP-MTI', u'sm-RP-SMEA', u'sm-deliveryNotIntended', u'ip-sm-gwGuidanceIndicator', u'imsi', u't4-Trigger-Indicator', u'singleAttemptDelivery', u'correlationID', u'smsf-supportIndicator']
    
    #-----< SM-DeliveryNotIntended >-----#
    SM_DeliveryNotIntended = ENUM(name=u'SM-DeliveryNotIntended', mode=MODE_TYPE)
    SM_DeliveryNotIntended._cont = ASN1Dict([(u'onlyIMSI-requested', 0), (u'onlyMCC-MNC-requested', 1)])
    SM_DeliveryNotIntended._ext = []
    
    #-----< SM-RP-MTI >-----#
    SM_RP_MTI = INT(name=u'SM-RP-MTI', mode=MODE_TYPE)
    SM_RP_MTI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    
    #-----< SM-RP-SMEA >-----#
    SM_RP_SMEA = OCT_STR(name=u'SM-RP-SMEA', mode=MODE_TYPE)
    SM_RP_SMEA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=12)], ev=None, er=[])
    
    #-----< RoutingInfoForSM-Res >-----#
    RoutingInfoForSM_Res = SEQ(name=u'RoutingInfoForSM-Res', mode=MODE_TYPE)
    _RoutingInfoForSM_Res_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _RoutingInfoForSM_Res_locationInfoWithLMSI = SEQ(name=u'locationInfoWithLMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'LocationInfoWithLMSI')))
    _RoutingInfoForSM_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _RoutingInfoForSM_Res_ip_sm_gwGuidance = SEQ(name=u'ip-sm-gwGuidance', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'IP-SM-GW-Guidance')), opt=True)
    RoutingInfoForSM_Res._cont = ASN1Dict([
        (u'imsi', _RoutingInfoForSM_Res_imsi),
        (u'locationInfoWithLMSI', _RoutingInfoForSM_Res_locationInfoWithLMSI),
        (u'extensionContainer', _RoutingInfoForSM_Res_extensionContainer),
        (u'ip-sm-gwGuidance', _RoutingInfoForSM_Res_ip_sm_gwGuidance),
        ])
    RoutingInfoForSM_Res._ext = [u'ip-sm-gwGuidance']
    
    #-----< IP-SM-GW-Guidance >-----#
    IP_SM_GW_Guidance = SEQ(name=u'IP-SM-GW-Guidance', mode=MODE_TYPE)
    _IP_SM_GW_Guidance_minimumDeliveryTimeValue = INT(name=u'minimumDeliveryTimeValue', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryTimerValue')))
    _IP_SM_GW_Guidance_recommendedDeliveryTimeValue = INT(name=u'recommendedDeliveryTimeValue', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryTimerValue')))
    _IP_SM_GW_Guidance_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    IP_SM_GW_Guidance._cont = ASN1Dict([
        (u'minimumDeliveryTimeValue', _IP_SM_GW_Guidance_minimumDeliveryTimeValue),
        (u'recommendedDeliveryTimeValue', _IP_SM_GW_Guidance_recommendedDeliveryTimeValue),
        (u'extensionContainer', _IP_SM_GW_Guidance_extensionContainer),
        ])
    IP_SM_GW_Guidance._ext = []
    
    #-----< LocationInfoWithLMSI >-----#
    LocationInfoWithLMSI = SEQ(name=u'LocationInfoWithLMSI', mode=MODE_TYPE)
    _LocationInfoWithLMSI_networkNode_Number = OCT_STR(name=u'networkNode-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _LocationInfoWithLMSI_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')), opt=True)
    _LocationInfoWithLMSI_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _LocationInfoWithLMSI_gprsNodeIndicator = NULL(name=u'gprsNodeIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInfoWithLMSI_additional_Number = CHOICE(name=u'additional-Number', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'Additional-Number')), opt=True)
    _LocationInfoWithLMSI_networkNodeDiameterAddress = SEQ(name=u'networkNodeDiameterAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _LocationInfoWithLMSI_additionalNetworkNodeDiameterAddress = SEQ(name=u'additionalNetworkNodeDiameterAddress', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _LocationInfoWithLMSI_thirdNumber = CHOICE(name=u'thirdNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'Additional-Number')), opt=True)
    _LocationInfoWithLMSI_thirdNetworkNodeDiameterAddress = SEQ(name=u'thirdNetworkNodeDiameterAddress', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _LocationInfoWithLMSI_imsNodeIndicator = NULL(name=u'imsNodeIndicator', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInfoWithLMSI_smsf_3gpp_Number = OCT_STR(name=u'smsf-3gpp-Number', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInfoWithLMSI_smsf_3gpp_DiameterAddress = SEQ(name=u'smsf-3gpp-DiameterAddress', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _LocationInfoWithLMSI_smsf_non_3gpp_Number = OCT_STR(name=u'smsf-non-3gpp-Number', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LocationInfoWithLMSI_smsf_non_3gpp_DiameterAddress = SEQ(name=u'smsf-non-3gpp-DiameterAddress', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _LocationInfoWithLMSI_smsf_3gpp_address_indicator = NULL(name=u'smsf-3gpp-address-indicator', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInfoWithLMSI_smsf_non_3gpp_address_indicator = NULL(name=u'smsf-non-3gpp-address-indicator', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    LocationInfoWithLMSI._cont = ASN1Dict([
        (u'networkNode-Number', _LocationInfoWithLMSI_networkNode_Number),
        (u'lmsi', _LocationInfoWithLMSI_lmsi),
        (u'extensionContainer', _LocationInfoWithLMSI_extensionContainer),
        (u'gprsNodeIndicator', _LocationInfoWithLMSI_gprsNodeIndicator),
        (u'additional-Number', _LocationInfoWithLMSI_additional_Number),
        (u'networkNodeDiameterAddress', _LocationInfoWithLMSI_networkNodeDiameterAddress),
        (u'additionalNetworkNodeDiameterAddress', _LocationInfoWithLMSI_additionalNetworkNodeDiameterAddress),
        (u'thirdNumber', _LocationInfoWithLMSI_thirdNumber),
        (u'thirdNetworkNodeDiameterAddress', _LocationInfoWithLMSI_thirdNetworkNodeDiameterAddress),
        (u'imsNodeIndicator', _LocationInfoWithLMSI_imsNodeIndicator),
        (u'smsf-3gpp-Number', _LocationInfoWithLMSI_smsf_3gpp_Number),
        (u'smsf-3gpp-DiameterAddress', _LocationInfoWithLMSI_smsf_3gpp_DiameterAddress),
        (u'smsf-non-3gpp-Number', _LocationInfoWithLMSI_smsf_non_3gpp_Number),
        (u'smsf-non-3gpp-DiameterAddress', _LocationInfoWithLMSI_smsf_non_3gpp_DiameterAddress),
        (u'smsf-3gpp-address-indicator', _LocationInfoWithLMSI_smsf_3gpp_address_indicator),
        (u'smsf-non-3gpp-address-indicator', _LocationInfoWithLMSI_smsf_non_3gpp_address_indicator),
        ])
    LocationInfoWithLMSI._ext = [u'gprsNodeIndicator', u'additional-Number', u'networkNodeDiameterAddress', u'additionalNetworkNodeDiameterAddress', u'thirdNumber', u'thirdNetworkNodeDiameterAddress', u'imsNodeIndicator', u'smsf-3gpp-Number', u'smsf-3gpp-DiameterAddress', u'smsf-non-3gpp-Number', u'smsf-non-3gpp-DiameterAddress', u'smsf-3gpp-address-indicator', u'smsf-non-3gpp-address-indicator']
    
    #-----< Additional-Number >-----#
    Additional_Number = CHOICE(name=u'Additional-Number', mode=MODE_TYPE)
    _Additional_Number_msc_Number = OCT_STR(name=u'msc-Number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _Additional_Number_sgsn_Number = OCT_STR(name=u'sgsn-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    Additional_Number._cont = ASN1Dict([
        (u'msc-Number', _Additional_Number_msc_Number),
        (u'sgsn-Number', _Additional_Number_sgsn_Number),
        ])
    Additional_Number._ext = None
    
    #-----< MO-ForwardSM-Arg >-----#
    MO_ForwardSM_Arg = SEQ(name=u'MO-ForwardSM-Arg', mode=MODE_TYPE)
    _MO_ForwardSM_Arg_sm_RP_DA = CHOICE(name=u'sm-RP-DA', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-RP-DA')))
    _MO_ForwardSM_Arg_sm_RP_OA = CHOICE(name=u'sm-RP-OA', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-RP-OA')))
    _MO_ForwardSM_Arg_sm_RP_UI = OCT_STR(name=u'sm-RP-UI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')))
    _MO_ForwardSM_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _MO_ForwardSM_Arg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MO_ForwardSM_Arg_correlationID = SEQ(name=u'correlationID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'CorrelationID')), opt=True)
    _MO_ForwardSM_Arg_sm_DeliveryOutcome = ENUM(name=u'sm-DeliveryOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryOutcome')), opt=True)
    MO_ForwardSM_Arg._cont = ASN1Dict([
        (u'sm-RP-DA', _MO_ForwardSM_Arg_sm_RP_DA),
        (u'sm-RP-OA', _MO_ForwardSM_Arg_sm_RP_OA),
        (u'sm-RP-UI', _MO_ForwardSM_Arg_sm_RP_UI),
        (u'extensionContainer', _MO_ForwardSM_Arg_extensionContainer),
        (u'imsi', _MO_ForwardSM_Arg_imsi),
        (u'correlationID', _MO_ForwardSM_Arg_correlationID),
        (u'sm-DeliveryOutcome', _MO_ForwardSM_Arg_sm_DeliveryOutcome),
        ])
    MO_ForwardSM_Arg._ext = [u'imsi', u'correlationID', u'sm-DeliveryOutcome']
    
    #-----< MO-ForwardSM-Res >-----#
    MO_ForwardSM_Res = SEQ(name=u'MO-ForwardSM-Res', mode=MODE_TYPE)
    _MO_ForwardSM_Res_sm_RP_UI = OCT_STR(name=u'sm-RP-UI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')), opt=True)
    _MO_ForwardSM_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MO_ForwardSM_Res._cont = ASN1Dict([
        (u'sm-RP-UI', _MO_ForwardSM_Res_sm_RP_UI),
        (u'extensionContainer', _MO_ForwardSM_Res_extensionContainer),
        ])
    MO_ForwardSM_Res._ext = []
    
    #-----< MT-ForwardSM-Arg >-----#
    MT_ForwardSM_Arg = SEQ(name=u'MT-ForwardSM-Arg', mode=MODE_TYPE)
    _MT_ForwardSM_Arg_sm_RP_DA = CHOICE(name=u'sm-RP-DA', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-RP-DA')))
    _MT_ForwardSM_Arg_sm_RP_OA = CHOICE(name=u'sm-RP-OA', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-RP-OA')))
    _MT_ForwardSM_Arg_sm_RP_UI = OCT_STR(name=u'sm-RP-UI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')))
    _MT_ForwardSM_Arg_moreMessagesToSend = NULL(name=u'moreMessagesToSend', mode=MODE_TYPE, opt=True)
    _MT_ForwardSM_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _MT_ForwardSM_Arg_smDeliveryTimer = INT(name=u'smDeliveryTimer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryTimerValue')), opt=True)
    _MT_ForwardSM_Arg_smDeliveryStartTime = OCT_STR(name=u'smDeliveryStartTime', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _MT_ForwardSM_Arg_smsOverIP_OnlyIndicator = NULL(name=u'smsOverIP-OnlyIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MT_ForwardSM_Arg_correlationID = SEQ(name=u'correlationID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'CorrelationID')), opt=True)
    _MT_ForwardSM_Arg_maximumRetransmissionTime = OCT_STR(name=u'maximumRetransmissionTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _MT_ForwardSM_Arg_smsGmscAddress = OCT_STR(name=u'smsGmscAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _MT_ForwardSM_Arg_smsGmscDiameterAddress = SEQ(name=u'smsGmscDiameterAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    MT_ForwardSM_Arg._cont = ASN1Dict([
        (u'sm-RP-DA', _MT_ForwardSM_Arg_sm_RP_DA),
        (u'sm-RP-OA', _MT_ForwardSM_Arg_sm_RP_OA),
        (u'sm-RP-UI', _MT_ForwardSM_Arg_sm_RP_UI),
        (u'moreMessagesToSend', _MT_ForwardSM_Arg_moreMessagesToSend),
        (u'extensionContainer', _MT_ForwardSM_Arg_extensionContainer),
        (u'smDeliveryTimer', _MT_ForwardSM_Arg_smDeliveryTimer),
        (u'smDeliveryStartTime', _MT_ForwardSM_Arg_smDeliveryStartTime),
        (u'smsOverIP-OnlyIndicator', _MT_ForwardSM_Arg_smsOverIP_OnlyIndicator),
        (u'correlationID', _MT_ForwardSM_Arg_correlationID),
        (u'maximumRetransmissionTime', _MT_ForwardSM_Arg_maximumRetransmissionTime),
        (u'smsGmscAddress', _MT_ForwardSM_Arg_smsGmscAddress),
        (u'smsGmscDiameterAddress', _MT_ForwardSM_Arg_smsGmscDiameterAddress),
        ])
    MT_ForwardSM_Arg._ext = [u'smDeliveryTimer', u'smDeliveryStartTime', u'smsOverIP-OnlyIndicator', u'correlationID', u'maximumRetransmissionTime', u'smsGmscAddress', u'smsGmscDiameterAddress']
    
    #-----< CorrelationID >-----#
    CorrelationID = SEQ(name=u'CorrelationID', mode=MODE_TYPE)
    _CorrelationID_hlr_id = OCT_STR(name=u'hlr-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'HLR-Id')), opt=True)
    _CorrelationID_sip_uri_A = OCT_STR(name=u'sip-uri-A', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SIP-URI')), opt=True)
    _CorrelationID_sip_uri_B = OCT_STR(name=u'sip-uri-B', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SIP-URI')))
    CorrelationID._cont = ASN1Dict([
        (u'hlr-id', _CorrelationID_hlr_id),
        (u'sip-uri-A', _CorrelationID_sip_uri_A),
        (u'sip-uri-B', _CorrelationID_sip_uri_B),
        ])
    CorrelationID._ext = None
    
    #-----< SIP-URI >-----#
    SIP_URI = OCT_STR(name=u'SIP-URI', mode=MODE_TYPE)
    
    #-----< MT-ForwardSM-Res >-----#
    MT_ForwardSM_Res = SEQ(name=u'MT-ForwardSM-Res', mode=MODE_TYPE)
    _MT_ForwardSM_Res_sm_RP_UI = OCT_STR(name=u'sm-RP-UI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')), opt=True)
    _MT_ForwardSM_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MT_ForwardSM_Res._cont = ASN1Dict([
        (u'sm-RP-UI', _MT_ForwardSM_Res_sm_RP_UI),
        (u'extensionContainer', _MT_ForwardSM_Res_extensionContainer),
        ])
    MT_ForwardSM_Res._ext = []
    
    #-----< SM-RP-DA >-----#
    SM_RP_DA = CHOICE(name=u'SM-RP-DA', mode=MODE_TYPE)
    _SM_RP_DA_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SM_RP_DA_lmsi = OCT_STR(name=u'lmsi', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LMSI')))
    _SM_RP_DA_serviceCentreAddressDA = OCT_STR(name=u'serviceCentreAddressDA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _SM_RP_DA_noSM_RP_DA = NULL(name=u'noSM-RP-DA', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SM_RP_DA._cont = ASN1Dict([
        (u'imsi', _SM_RP_DA_imsi),
        (u'lmsi', _SM_RP_DA_lmsi),
        (u'serviceCentreAddressDA', _SM_RP_DA_serviceCentreAddressDA),
        (u'noSM-RP-DA', _SM_RP_DA_noSM_RP_DA),
        ])
    SM_RP_DA._ext = None
    
    #-----< SM-RP-OA >-----#
    SM_RP_OA = CHOICE(name=u'SM-RP-OA', mode=MODE_TYPE)
    _SM_RP_OA_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SM_RP_OA_serviceCentreAddressOA = OCT_STR(name=u'serviceCentreAddressOA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _SM_RP_OA_noSM_RP_OA = NULL(name=u'noSM-RP-OA', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SM_RP_OA._cont = ASN1Dict([
        (u'msisdn', _SM_RP_OA_msisdn),
        (u'serviceCentreAddressOA', _SM_RP_OA_serviceCentreAddressOA),
        (u'noSM-RP-OA', _SM_RP_OA_noSM_RP_OA),
        ])
    SM_RP_OA._ext = None
    
    #-----< SM-DeliveryTimerValue >-----#
    SM_DeliveryTimerValue = INT(name=u'SM-DeliveryTimerValue', mode=MODE_TYPE)
    SM_DeliveryTimerValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=30, ub=600)], ev=None, er=[])
    
    #-----< ReportSM-DeliveryStatusArg >-----#
    ReportSM_DeliveryStatusArg = SEQ(name=u'ReportSM-DeliveryStatusArg', mode=MODE_TYPE)
    _ReportSM_DeliveryStatusArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _ReportSM_DeliveryStatusArg_serviceCentreAddress = OCT_STR(name=u'serviceCentreAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _ReportSM_DeliveryStatusArg_sm_DeliveryOutcome = ENUM(name=u'sm-DeliveryOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryOutcome')))
    _ReportSM_DeliveryStatusArg_absentSubscriberDiagnosticSM = INT(name=u'absentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _ReportSM_DeliveryStatusArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ReportSM_DeliveryStatusArg_gprsSupportIndicator = NULL(name=u'gprsSupportIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportSM_DeliveryStatusArg_deliveryOutcomeIndicator = NULL(name=u'deliveryOutcomeIndicator', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportSM_DeliveryStatusArg_additionalSM_DeliveryOutcome = ENUM(name=u'additionalSM-DeliveryOutcome', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryOutcome')), opt=True)
    _ReportSM_DeliveryStatusArg_additionalAbsentSubscriberDiagnosticSM = INT(name=u'additionalAbsentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _ReportSM_DeliveryStatusArg_ip_sm_gw_Indicator = NULL(name=u'ip-sm-gw-Indicator', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportSM_DeliveryStatusArg_ip_sm_gw_sm_deliveryOutcome = ENUM(name=u'ip-sm-gw-sm-deliveryOutcome', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryOutcome')), opt=True)
    _ReportSM_DeliveryStatusArg_ip_sm_gw_absentSubscriberDiagnosticSM = INT(name=u'ip-sm-gw-absentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _ReportSM_DeliveryStatusArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _ReportSM_DeliveryStatusArg_singleAttemptDelivery = NULL(name=u'singleAttemptDelivery', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportSM_DeliveryStatusArg_correlationID = SEQ(name=u'correlationID', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'CorrelationID')), opt=True)
    _ReportSM_DeliveryStatusArg_smsf_3gpp_deliveryOutcomeIndicator = NULL(name=u'smsf-3gpp-deliveryOutcomeIndicator', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportSM_DeliveryStatusArg_smsf_3gpp_deliveryOutcome = ENUM(name=u'smsf-3gpp-deliveryOutcome', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryOutcome')), opt=True)
    _ReportSM_DeliveryStatusArg_smsf_3gpp_absentSubscriberDiagSM = INT(name=u'smsf-3gpp-absentSubscriberDiagSM', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _ReportSM_DeliveryStatusArg_smsf_non_3gpp_deliveryOutcomeIndicator = NULL(name=u'smsf-non-3gpp-deliveryOutcomeIndicator', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportSM_DeliveryStatusArg_smsf_non_3gpp_deliveryOutcome = ENUM(name=u'smsf-non-3gpp-deliveryOutcome', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-DeliveryOutcome')), opt=True)
    _ReportSM_DeliveryStatusArg_smsf_non_3gpp_absentSubscriberDiagSM = INT(name=u'smsf-non-3gpp-absentSubscriberDiagSM', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    ReportSM_DeliveryStatusArg._cont = ASN1Dict([
        (u'msisdn', _ReportSM_DeliveryStatusArg_msisdn),
        (u'serviceCentreAddress', _ReportSM_DeliveryStatusArg_serviceCentreAddress),
        (u'sm-DeliveryOutcome', _ReportSM_DeliveryStatusArg_sm_DeliveryOutcome),
        (u'absentSubscriberDiagnosticSM', _ReportSM_DeliveryStatusArg_absentSubscriberDiagnosticSM),
        (u'extensionContainer', _ReportSM_DeliveryStatusArg_extensionContainer),
        (u'gprsSupportIndicator', _ReportSM_DeliveryStatusArg_gprsSupportIndicator),
        (u'deliveryOutcomeIndicator', _ReportSM_DeliveryStatusArg_deliveryOutcomeIndicator),
        (u'additionalSM-DeliveryOutcome', _ReportSM_DeliveryStatusArg_additionalSM_DeliveryOutcome),
        (u'additionalAbsentSubscriberDiagnosticSM', _ReportSM_DeliveryStatusArg_additionalAbsentSubscriberDiagnosticSM),
        (u'ip-sm-gw-Indicator', _ReportSM_DeliveryStatusArg_ip_sm_gw_Indicator),
        (u'ip-sm-gw-sm-deliveryOutcome', _ReportSM_DeliveryStatusArg_ip_sm_gw_sm_deliveryOutcome),
        (u'ip-sm-gw-absentSubscriberDiagnosticSM', _ReportSM_DeliveryStatusArg_ip_sm_gw_absentSubscriberDiagnosticSM),
        (u'imsi', _ReportSM_DeliveryStatusArg_imsi),
        (u'singleAttemptDelivery', _ReportSM_DeliveryStatusArg_singleAttemptDelivery),
        (u'correlationID', _ReportSM_DeliveryStatusArg_correlationID),
        (u'smsf-3gpp-deliveryOutcomeIndicator', _ReportSM_DeliveryStatusArg_smsf_3gpp_deliveryOutcomeIndicator),
        (u'smsf-3gpp-deliveryOutcome', _ReportSM_DeliveryStatusArg_smsf_3gpp_deliveryOutcome),
        (u'smsf-3gpp-absentSubscriberDiagSM', _ReportSM_DeliveryStatusArg_smsf_3gpp_absentSubscriberDiagSM),
        (u'smsf-non-3gpp-deliveryOutcomeIndicator', _ReportSM_DeliveryStatusArg_smsf_non_3gpp_deliveryOutcomeIndicator),
        (u'smsf-non-3gpp-deliveryOutcome', _ReportSM_DeliveryStatusArg_smsf_non_3gpp_deliveryOutcome),
        (u'smsf-non-3gpp-absentSubscriberDiagSM', _ReportSM_DeliveryStatusArg_smsf_non_3gpp_absentSubscriberDiagSM),
        ])
    ReportSM_DeliveryStatusArg._ext = [u'gprsSupportIndicator', u'deliveryOutcomeIndicator', u'additionalSM-DeliveryOutcome', u'additionalAbsentSubscriberDiagnosticSM', u'ip-sm-gw-Indicator', u'ip-sm-gw-sm-deliveryOutcome', u'ip-sm-gw-absentSubscriberDiagnosticSM', u'imsi', u'singleAttemptDelivery', u'correlationID', u'smsf-3gpp-deliveryOutcomeIndicator', u'smsf-3gpp-deliveryOutcome', u'smsf-3gpp-absentSubscriberDiagSM', u'smsf-non-3gpp-deliveryOutcomeIndicator', u'smsf-non-3gpp-deliveryOutcome', u'smsf-non-3gpp-absentSubscriberDiagSM']
    
    #-----< SM-DeliveryOutcome >-----#
    SM_DeliveryOutcome = ENUM(name=u'SM-DeliveryOutcome', mode=MODE_TYPE)
    SM_DeliveryOutcome._cont = ASN1Dict([(u'memoryCapacityExceeded', 0), (u'absentSubscriber', 1), (u'successfulTransfer', 2)])
    SM_DeliveryOutcome._ext = None
    
    #-----< ReportSM-DeliveryStatusRes >-----#
    ReportSM_DeliveryStatusRes = SEQ(name=u'ReportSM-DeliveryStatusRes', mode=MODE_TYPE)
    _ReportSM_DeliveryStatusRes_storedMSISDN = OCT_STR(name=u'storedMSISDN', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ReportSM_DeliveryStatusRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ReportSM_DeliveryStatusRes._cont = ASN1Dict([
        (u'storedMSISDN', _ReportSM_DeliveryStatusRes_storedMSISDN),
        (u'extensionContainer', _ReportSM_DeliveryStatusRes_extensionContainer),
        ])
    ReportSM_DeliveryStatusRes._ext = []
    
    #-----< AlertServiceCentreArg >-----#
    AlertServiceCentreArg = SEQ(name=u'AlertServiceCentreArg', mode=MODE_TYPE)
    _AlertServiceCentreArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _AlertServiceCentreArg_serviceCentreAddress = OCT_STR(name=u'serviceCentreAddress', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _AlertServiceCentreArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _AlertServiceCentreArg_correlationID = SEQ(name=u'correlationID', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'CorrelationID')), opt=True)
    _AlertServiceCentreArg_maximumUeAvailabilityTime = OCT_STR(name=u'maximumUeAvailabilityTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    _AlertServiceCentreArg_smsGmscAlertEvent = ENUM(name=u'smsGmscAlertEvent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'SmsGmsc-Alert-Event')), opt=True)
    _AlertServiceCentreArg_smsGmscDiameterAddress = SEQ(name=u'smsGmscDiameterAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _AlertServiceCentreArg_newSGSNNumber = OCT_STR(name=u'newSGSNNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _AlertServiceCentreArg_newSGSNDiameterAddress = SEQ(name=u'newSGSNDiameterAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _AlertServiceCentreArg_newMMENumber = OCT_STR(name=u'newMMENumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _AlertServiceCentreArg_newMMEDiameterAddress = SEQ(name=u'newMMEDiameterAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'NetworkNodeDiameterAddress')), opt=True)
    _AlertServiceCentreArg_newMSCNumber = OCT_STR(name=u'newMSCNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    AlertServiceCentreArg._cont = ASN1Dict([
        (u'msisdn', _AlertServiceCentreArg_msisdn),
        (u'serviceCentreAddress', _AlertServiceCentreArg_serviceCentreAddress),
        (u'imsi', _AlertServiceCentreArg_imsi),
        (u'correlationID', _AlertServiceCentreArg_correlationID),
        (u'maximumUeAvailabilityTime', _AlertServiceCentreArg_maximumUeAvailabilityTime),
        (u'smsGmscAlertEvent', _AlertServiceCentreArg_smsGmscAlertEvent),
        (u'smsGmscDiameterAddress', _AlertServiceCentreArg_smsGmscDiameterAddress),
        (u'newSGSNNumber', _AlertServiceCentreArg_newSGSNNumber),
        (u'newSGSNDiameterAddress', _AlertServiceCentreArg_newSGSNDiameterAddress),
        (u'newMMENumber', _AlertServiceCentreArg_newMMENumber),
        (u'newMMEDiameterAddress', _AlertServiceCentreArg_newMMEDiameterAddress),
        (u'newMSCNumber', _AlertServiceCentreArg_newMSCNumber),
        ])
    AlertServiceCentreArg._ext = [u'imsi', u'correlationID', u'maximumUeAvailabilityTime', u'smsGmscAlertEvent', u'smsGmscDiameterAddress', u'newSGSNNumber', u'newSGSNDiameterAddress', u'newMMENumber', u'newMMEDiameterAddress', u'newMSCNumber']
    
    #-----< SmsGmsc-Alert-Event >-----#
    SmsGmsc_Alert_Event = ENUM(name=u'SmsGmsc-Alert-Event', mode=MODE_TYPE)
    SmsGmsc_Alert_Event._cont = ASN1Dict([(u'msAvailableForMtSms', 0), (u'msUnderNewServingNode', 1)])
    SmsGmsc_Alert_Event._ext = None
    
    #-----< InformServiceCentreArg >-----#
    InformServiceCentreArg = SEQ(name=u'InformServiceCentreArg', mode=MODE_TYPE)
    _InformServiceCentreArg_storedMSISDN = OCT_STR(name=u'storedMSISDN', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _InformServiceCentreArg_mw_Status = BIT_STR(name=u'mw-Status', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'MW-Status')), opt=True)
    _InformServiceCentreArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _InformServiceCentreArg_absentSubscriberDiagnosticSM = INT(name=u'absentSubscriberDiagnosticSM', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _InformServiceCentreArg_additionalAbsentSubscriberDiagnosticSM = INT(name=u'additionalAbsentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _InformServiceCentreArg_smsf3gppAbsentSubscriberDiagnosticSM = INT(name=u'smsf3gppAbsentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    _InformServiceCentreArg_smsfNon3gppAbsentSubscriberDiagnosticSM = INT(name=u'smsfNon3gppAbsentSubscriberDiagnosticSM', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ER-DataTypes', 'AbsentSubscriberDiagnosticSM')), opt=True)
    InformServiceCentreArg._cont = ASN1Dict([
        (u'storedMSISDN', _InformServiceCentreArg_storedMSISDN),
        (u'mw-Status', _InformServiceCentreArg_mw_Status),
        (u'extensionContainer', _InformServiceCentreArg_extensionContainer),
        (u'absentSubscriberDiagnosticSM', _InformServiceCentreArg_absentSubscriberDiagnosticSM),
        (u'additionalAbsentSubscriberDiagnosticSM', _InformServiceCentreArg_additionalAbsentSubscriberDiagnosticSM),
        (u'smsf3gppAbsentSubscriberDiagnosticSM', _InformServiceCentreArg_smsf3gppAbsentSubscriberDiagnosticSM),
        (u'smsfNon3gppAbsentSubscriberDiagnosticSM', _InformServiceCentreArg_smsfNon3gppAbsentSubscriberDiagnosticSM),
        ])
    InformServiceCentreArg._ext = [u'absentSubscriberDiagnosticSM', u'additionalAbsentSubscriberDiagnosticSM', u'smsf3gppAbsentSubscriberDiagnosticSM', u'smsfNon3gppAbsentSubscriberDiagnosticSM']
    
    #-----< MW-Status >-----#
    MW_Status = BIT_STR(name=u'MW-Status', mode=MODE_TYPE)
    MW_Status._cont = ASN1Dict([(u'sc-AddressNotIncluded', 0), (u'mnrf-Set', 1), (u'mcef-Set', 2), (u'mnrg-Set', 3), (u'mnr5g-Set', 4), (u'mnr5gn3g-Set', 5)])
    MW_Status._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=16)], ev=None, er=[])
    
    #-----< ReadyForSM-Arg >-----#
    ReadyForSM_Arg = SEQ(name=u'ReadyForSM-Arg', mode=MODE_TYPE)
    _ReadyForSM_Arg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _ReadyForSM_Arg_alertReason = ENUM(name=u'alertReason', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'AlertReason')))
    _ReadyForSM_Arg_alertReasonIndicator = NULL(name=u'alertReasonIndicator', mode=MODE_TYPE, opt=True)
    _ReadyForSM_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _ReadyForSM_Arg_additionalAlertReasonIndicator = NULL(name=u'additionalAlertReasonIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReadyForSM_Arg_maximumUeAvailabilityTime = OCT_STR(name=u'maximumUeAvailabilityTime', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'Time')), opt=True)
    ReadyForSM_Arg._cont = ASN1Dict([
        (u'imsi', _ReadyForSM_Arg_imsi),
        (u'alertReason', _ReadyForSM_Arg_alertReason),
        (u'alertReasonIndicator', _ReadyForSM_Arg_alertReasonIndicator),
        (u'extensionContainer', _ReadyForSM_Arg_extensionContainer),
        (u'additionalAlertReasonIndicator', _ReadyForSM_Arg_additionalAlertReasonIndicator),
        (u'maximumUeAvailabilityTime', _ReadyForSM_Arg_maximumUeAvailabilityTime),
        ])
    ReadyForSM_Arg._ext = [u'additionalAlertReasonIndicator', u'maximumUeAvailabilityTime']
    
    #-----< ReadyForSM-Res >-----#
    ReadyForSM_Res = SEQ(name=u'ReadyForSM-Res', mode=MODE_TYPE)
    _ReadyForSM_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    ReadyForSM_Res._cont = ASN1Dict([
        (u'extensionContainer', _ReadyForSM_Res_extensionContainer),
        ])
    ReadyForSM_Res._ext = []
    
    #-----< AlertReason >-----#
    AlertReason = ENUM(name=u'AlertReason', mode=MODE_TYPE)
    AlertReason._cont = ASN1Dict([(u'ms-Present', 0), (u'memoryAvailable', 1)])
    AlertReason._ext = None
    
    #-----< MT-ForwardSM-VGCS-Arg >-----#
    MT_ForwardSM_VGCS_Arg = SEQ(name=u'MT-ForwardSM-VGCS-Arg', mode=MODE_TYPE)
    _MT_ForwardSM_VGCS_Arg_asciCallReference = OCT_STR(name=u'asciCallReference', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ASCI-CallReference')))
    _MT_ForwardSM_VGCS_Arg_sm_RP_OA = CHOICE(name=u'sm-RP-OA', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SM-DataTypes', 'SM-RP-OA')))
    _MT_ForwardSM_VGCS_Arg_sm_RP_UI = OCT_STR(name=u'sm-RP-UI', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')))
    _MT_ForwardSM_VGCS_Arg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    MT_ForwardSM_VGCS_Arg._cont = ASN1Dict([
        (u'asciCallReference', _MT_ForwardSM_VGCS_Arg_asciCallReference),
        (u'sm-RP-OA', _MT_ForwardSM_VGCS_Arg_sm_RP_OA),
        (u'sm-RP-UI', _MT_ForwardSM_VGCS_Arg_sm_RP_UI),
        (u'extensionContainer', _MT_ForwardSM_VGCS_Arg_extensionContainer),
        ])
    MT_ForwardSM_VGCS_Arg._ext = []
    
    #-----< MT-ForwardSM-VGCS-Res >-----#
    MT_ForwardSM_VGCS_Res = SEQ(name=u'MT-ForwardSM-VGCS-Res', mode=MODE_TYPE)
    _MT_ForwardSM_VGCS_Res_sm_RP_UI = OCT_STR(name=u'sm-RP-UI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'SignalInfo')), opt=True)
    _MT_ForwardSM_VGCS_Res_dispatcherList = SEQ_OF(name=u'dispatcherList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'DispatcherList')), opt=True)
    _MT_ForwardSM_VGCS_Res_ongoingCall = NULL(name=u'ongoingCall', mode=MODE_TYPE, opt=True)
    _MT_ForwardSM_VGCS_Res_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _MT_ForwardSM_VGCS_Res_additionalDispatcherList = SEQ_OF(name=u'additionalDispatcherList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SM-DataTypes', 'AdditionalDispatcherList')), opt=True)
    MT_ForwardSM_VGCS_Res._cont = ASN1Dict([
        (u'sm-RP-UI', _MT_ForwardSM_VGCS_Res_sm_RP_UI),
        (u'dispatcherList', _MT_ForwardSM_VGCS_Res_dispatcherList),
        (u'ongoingCall', _MT_ForwardSM_VGCS_Res_ongoingCall),
        (u'extensionContainer', _MT_ForwardSM_VGCS_Res_extensionContainer),
        (u'additionalDispatcherList', _MT_ForwardSM_VGCS_Res_additionalDispatcherList),
        ])
    MT_ForwardSM_VGCS_Res._ext = [u'additionalDispatcherList']
    
    #-----< DispatcherList >-----#
    DispatcherList = SEQ_OF(name=u'DispatcherList', mode=MODE_TYPE)
    _DispatcherList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    DispatcherList._cont = _DispatcherList__item_
    DispatcherList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfDispatchers >-----#
    maxNumOfDispatchers = INT(name=u'maxNumOfDispatchers', mode=MODE_VALUE)
    maxNumOfDispatchers._val = 5
    
    #-----< AdditionalDispatcherList >-----#
    AdditionalDispatcherList = SEQ_OF(name=u'AdditionalDispatcherList', mode=MODE_TYPE)
    _AdditionalDispatcherList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    AdditionalDispatcherList._cont = _AdditionalDispatcherList__item_
    AdditionalDispatcherList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< maxNumOfAdditionalDispatchers >-----#
    maxNumOfAdditionalDispatchers = INT(name=u'maxNumOfAdditionalDispatchers', mode=MODE_VALUE)
    maxNumOfAdditionalDispatchers._val = 15
    
    _all_ = [
        _RoutingInfoForSM_Arg_msisdn,
        _RoutingInfoForSM_Arg_sm_RP_PRI,
        _RoutingInfoForSM_Arg_serviceCentreAddress,
        _RoutingInfoForSM_Arg_extensionContainer,
        _RoutingInfoForSM_Arg_gprsSupportIndicator,
        _RoutingInfoForSM_Arg_sm_RP_MTI,
        _RoutingInfoForSM_Arg_sm_RP_SMEA,
        _RoutingInfoForSM_Arg_sm_deliveryNotIntended,
        _RoutingInfoForSM_Arg_ip_sm_gwGuidanceIndicator,
        _RoutingInfoForSM_Arg_imsi,
        _RoutingInfoForSM_Arg_t4_Trigger_Indicator,
        _RoutingInfoForSM_Arg_singleAttemptDelivery,
        _RoutingInfoForSM_Arg_correlationID,
        _RoutingInfoForSM_Arg_smsf_supportIndicator,
        RoutingInfoForSM_Arg,
        SM_DeliveryNotIntended,
        SM_RP_MTI,
        SM_RP_SMEA,
        _RoutingInfoForSM_Res_imsi,
        _RoutingInfoForSM_Res_locationInfoWithLMSI,
        _RoutingInfoForSM_Res_extensionContainer,
        _RoutingInfoForSM_Res_ip_sm_gwGuidance,
        RoutingInfoForSM_Res,
        _IP_SM_GW_Guidance_minimumDeliveryTimeValue,
        _IP_SM_GW_Guidance_recommendedDeliveryTimeValue,
        _IP_SM_GW_Guidance_extensionContainer,
        IP_SM_GW_Guidance,
        _LocationInfoWithLMSI_networkNode_Number,
        _LocationInfoWithLMSI_lmsi,
        _LocationInfoWithLMSI_extensionContainer,
        _LocationInfoWithLMSI_gprsNodeIndicator,
        _LocationInfoWithLMSI_additional_Number,
        _LocationInfoWithLMSI_networkNodeDiameterAddress,
        _LocationInfoWithLMSI_additionalNetworkNodeDiameterAddress,
        _LocationInfoWithLMSI_thirdNumber,
        _LocationInfoWithLMSI_thirdNetworkNodeDiameterAddress,
        _LocationInfoWithLMSI_imsNodeIndicator,
        _LocationInfoWithLMSI_smsf_3gpp_Number,
        _LocationInfoWithLMSI_smsf_3gpp_DiameterAddress,
        _LocationInfoWithLMSI_smsf_non_3gpp_Number,
        _LocationInfoWithLMSI_smsf_non_3gpp_DiameterAddress,
        _LocationInfoWithLMSI_smsf_3gpp_address_indicator,
        _LocationInfoWithLMSI_smsf_non_3gpp_address_indicator,
        LocationInfoWithLMSI,
        _Additional_Number_msc_Number,
        _Additional_Number_sgsn_Number,
        Additional_Number,
        _MO_ForwardSM_Arg_sm_RP_DA,
        _MO_ForwardSM_Arg_sm_RP_OA,
        _MO_ForwardSM_Arg_sm_RP_UI,
        _MO_ForwardSM_Arg_extensionContainer,
        _MO_ForwardSM_Arg_imsi,
        _MO_ForwardSM_Arg_correlationID,
        _MO_ForwardSM_Arg_sm_DeliveryOutcome,
        MO_ForwardSM_Arg,
        _MO_ForwardSM_Res_sm_RP_UI,
        _MO_ForwardSM_Res_extensionContainer,
        MO_ForwardSM_Res,
        _MT_ForwardSM_Arg_sm_RP_DA,
        _MT_ForwardSM_Arg_sm_RP_OA,
        _MT_ForwardSM_Arg_sm_RP_UI,
        _MT_ForwardSM_Arg_moreMessagesToSend,
        _MT_ForwardSM_Arg_extensionContainer,
        _MT_ForwardSM_Arg_smDeliveryTimer,
        _MT_ForwardSM_Arg_smDeliveryStartTime,
        _MT_ForwardSM_Arg_smsOverIP_OnlyIndicator,
        _MT_ForwardSM_Arg_correlationID,
        _MT_ForwardSM_Arg_maximumRetransmissionTime,
        _MT_ForwardSM_Arg_smsGmscAddress,
        _MT_ForwardSM_Arg_smsGmscDiameterAddress,
        MT_ForwardSM_Arg,
        _CorrelationID_hlr_id,
        _CorrelationID_sip_uri_A,
        _CorrelationID_sip_uri_B,
        CorrelationID,
        SIP_URI,
        _MT_ForwardSM_Res_sm_RP_UI,
        _MT_ForwardSM_Res_extensionContainer,
        MT_ForwardSM_Res,
        _SM_RP_DA_imsi,
        _SM_RP_DA_lmsi,
        _SM_RP_DA_serviceCentreAddressDA,
        _SM_RP_DA_noSM_RP_DA,
        SM_RP_DA,
        _SM_RP_OA_msisdn,
        _SM_RP_OA_serviceCentreAddressOA,
        _SM_RP_OA_noSM_RP_OA,
        SM_RP_OA,
        SM_DeliveryTimerValue,
        _ReportSM_DeliveryStatusArg_msisdn,
        _ReportSM_DeliveryStatusArg_serviceCentreAddress,
        _ReportSM_DeliveryStatusArg_sm_DeliveryOutcome,
        _ReportSM_DeliveryStatusArg_absentSubscriberDiagnosticSM,
        _ReportSM_DeliveryStatusArg_extensionContainer,
        _ReportSM_DeliveryStatusArg_gprsSupportIndicator,
        _ReportSM_DeliveryStatusArg_deliveryOutcomeIndicator,
        _ReportSM_DeliveryStatusArg_additionalSM_DeliveryOutcome,
        _ReportSM_DeliveryStatusArg_additionalAbsentSubscriberDiagnosticSM,
        _ReportSM_DeliveryStatusArg_ip_sm_gw_Indicator,
        _ReportSM_DeliveryStatusArg_ip_sm_gw_sm_deliveryOutcome,
        _ReportSM_DeliveryStatusArg_ip_sm_gw_absentSubscriberDiagnosticSM,
        _ReportSM_DeliveryStatusArg_imsi,
        _ReportSM_DeliveryStatusArg_singleAttemptDelivery,
        _ReportSM_DeliveryStatusArg_correlationID,
        _ReportSM_DeliveryStatusArg_smsf_3gpp_deliveryOutcomeIndicator,
        _ReportSM_DeliveryStatusArg_smsf_3gpp_deliveryOutcome,
        _ReportSM_DeliveryStatusArg_smsf_3gpp_absentSubscriberDiagSM,
        _ReportSM_DeliveryStatusArg_smsf_non_3gpp_deliveryOutcomeIndicator,
        _ReportSM_DeliveryStatusArg_smsf_non_3gpp_deliveryOutcome,
        _ReportSM_DeliveryStatusArg_smsf_non_3gpp_absentSubscriberDiagSM,
        ReportSM_DeliveryStatusArg,
        SM_DeliveryOutcome,
        _ReportSM_DeliveryStatusRes_storedMSISDN,
        _ReportSM_DeliveryStatusRes_extensionContainer,
        ReportSM_DeliveryStatusRes,
        _AlertServiceCentreArg_msisdn,
        _AlertServiceCentreArg_serviceCentreAddress,
        _AlertServiceCentreArg_imsi,
        _AlertServiceCentreArg_correlationID,
        _AlertServiceCentreArg_maximumUeAvailabilityTime,
        _AlertServiceCentreArg_smsGmscAlertEvent,
        _AlertServiceCentreArg_smsGmscDiameterAddress,
        _AlertServiceCentreArg_newSGSNNumber,
        _AlertServiceCentreArg_newSGSNDiameterAddress,
        _AlertServiceCentreArg_newMMENumber,
        _AlertServiceCentreArg_newMMEDiameterAddress,
        _AlertServiceCentreArg_newMSCNumber,
        AlertServiceCentreArg,
        SmsGmsc_Alert_Event,
        _InformServiceCentreArg_storedMSISDN,
        _InformServiceCentreArg_mw_Status,
        _InformServiceCentreArg_extensionContainer,
        _InformServiceCentreArg_absentSubscriberDiagnosticSM,
        _InformServiceCentreArg_additionalAbsentSubscriberDiagnosticSM,
        _InformServiceCentreArg_smsf3gppAbsentSubscriberDiagnosticSM,
        _InformServiceCentreArg_smsfNon3gppAbsentSubscriberDiagnosticSM,
        InformServiceCentreArg,
        MW_Status,
        _ReadyForSM_Arg_imsi,
        _ReadyForSM_Arg_alertReason,
        _ReadyForSM_Arg_alertReasonIndicator,
        _ReadyForSM_Arg_extensionContainer,
        _ReadyForSM_Arg_additionalAlertReasonIndicator,
        _ReadyForSM_Arg_maximumUeAvailabilityTime,
        ReadyForSM_Arg,
        _ReadyForSM_Res_extensionContainer,
        ReadyForSM_Res,
        AlertReason,
        _MT_ForwardSM_VGCS_Arg_asciCallReference,
        _MT_ForwardSM_VGCS_Arg_sm_RP_OA,
        _MT_ForwardSM_VGCS_Arg_sm_RP_UI,
        _MT_ForwardSM_VGCS_Arg_extensionContainer,
        MT_ForwardSM_VGCS_Arg,
        _MT_ForwardSM_VGCS_Res_sm_RP_UI,
        _MT_ForwardSM_VGCS_Res_dispatcherList,
        _MT_ForwardSM_VGCS_Res_ongoingCall,
        _MT_ForwardSM_VGCS_Res_extensionContainer,
        _MT_ForwardSM_VGCS_Res_additionalDispatcherList,
        MT_ForwardSM_VGCS_Res,
        _DispatcherList__item_,
        DispatcherList,
        maxNumOfDispatchers,
        _AdditionalDispatcherList__item_,
        AdditionalDispatcherList,
        maxNumOfAdditionalDispatchers,
    ]

class MAP_SS_Code:

    _name_  = u'MAP-SS-Code'
    _oid_   = [0, 4, 0, 0, 1, 3, 15, 19]
    
    _obj_ = [
        u'SS-Code',
        u'allSS',
        u'allLineIdentificationSS',
        u'clip',
        u'clir',
        u'colp',
        u'colr',
        u'mci',
        u'allNameIdentificationSS',
        u'cnap',
        u'allForwardingSS',
        u'cfu',
        u'allCondForwardingSS',
        u'cfb',
        u'cfnry',
        u'cfnrc',
        u'cd',
        u'allCallOfferingSS',
        u'ect',
        u'mah',
        u'allCallCompletionSS',
        u'cw',
        u'hold',
        u'ccbs-A',
        u'ccbs-B',
        u'mc',
        u'allMultiPartySS',
        u'multiPTY',
        u'allCommunityOfInterest-SS',
        u'cug',
        u'allChargingSS',
        u'aoci',
        u'aocc',
        u'allAdditionalInfoTransferSS',
        u'uus1',
        u'uus2',
        u'uus3',
        u'allBarringSS',
        u'barringOfOutgoingCalls',
        u'baoc',
        u'boic',
        u'boicExHC',
        u'barringOfIncomingCalls',
        u'baic',
        u'bicRoam',
        u'allPLMN-specificSS',
        u'plmn-specificSS-1',
        u'plmn-specificSS-2',
        u'plmn-specificSS-3',
        u'plmn-specificSS-4',
        u'plmn-specificSS-5',
        u'plmn-specificSS-6',
        u'plmn-specificSS-7',
        u'plmn-specificSS-8',
        u'plmn-specificSS-9',
        u'plmn-specificSS-A',
        u'plmn-specificSS-B',
        u'plmn-specificSS-C',
        u'plmn-specificSS-D',
        u'plmn-specificSS-E',
        u'plmn-specificSS-F',
        u'allCallPrioritySS',
        u'emlpp',
        u'allLCSPrivacyException',
        u'universal',
        u'callSessionRelated',
        u'callSessionUnrelated',
        u'plmnoperator',
        u'serviceType',
        u'allMOLR-SS',
        u'basicSelfLocation',
        u'autonomousSelfLocation',
        u'transferToThirdParty',
        ]
    _type_ = [
        u'SS-Code',
        ]
    _set_ = [
        ]
    _val_ = [
        u'allSS',
        u'allLineIdentificationSS',
        u'clip',
        u'clir',
        u'colp',
        u'colr',
        u'mci',
        u'allNameIdentificationSS',
        u'cnap',
        u'allForwardingSS',
        u'cfu',
        u'allCondForwardingSS',
        u'cfb',
        u'cfnry',
        u'cfnrc',
        u'cd',
        u'allCallOfferingSS',
        u'ect',
        u'mah',
        u'allCallCompletionSS',
        u'cw',
        u'hold',
        u'ccbs-A',
        u'ccbs-B',
        u'mc',
        u'allMultiPartySS',
        u'multiPTY',
        u'allCommunityOfInterest-SS',
        u'cug',
        u'allChargingSS',
        u'aoci',
        u'aocc',
        u'allAdditionalInfoTransferSS',
        u'uus1',
        u'uus2',
        u'uus3',
        u'allBarringSS',
        u'barringOfOutgoingCalls',
        u'baoc',
        u'boic',
        u'boicExHC',
        u'barringOfIncomingCalls',
        u'baic',
        u'bicRoam',
        u'allPLMN-specificSS',
        u'plmn-specificSS-1',
        u'plmn-specificSS-2',
        u'plmn-specificSS-3',
        u'plmn-specificSS-4',
        u'plmn-specificSS-5',
        u'plmn-specificSS-6',
        u'plmn-specificSS-7',
        u'plmn-specificSS-8',
        u'plmn-specificSS-9',
        u'plmn-specificSS-A',
        u'plmn-specificSS-B',
        u'plmn-specificSS-C',
        u'plmn-specificSS-D',
        u'plmn-specificSS-E',
        u'plmn-specificSS-F',
        u'allCallPrioritySS',
        u'emlpp',
        u'allLCSPrivacyException',
        u'universal',
        u'callSessionRelated',
        u'callSessionUnrelated',
        u'plmnoperator',
        u'serviceType',
        u'allMOLR-SS',
        u'basicSelfLocation',
        u'autonomousSelfLocation',
        u'transferToThirdParty',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SS-Code >-----#
    SS_Code = OCT_STR(name=u'SS-Code', mode=MODE_TYPE)
    SS_Code._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< allSS >-----#
    allSS = OCT_STR(name=u'allSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allSS._val = b'\x00'
    
    #-----< allLineIdentificationSS >-----#
    allLineIdentificationSS = OCT_STR(name=u'allLineIdentificationSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allLineIdentificationSS._val = b'\x10'
    
    #-----< clip >-----#
    clip = OCT_STR(name=u'clip', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    clip._val = b'\x11'
    
    #-----< clir >-----#
    clir = OCT_STR(name=u'clir', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    clir._val = b'\x12'
    
    #-----< colp >-----#
    colp = OCT_STR(name=u'colp', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    colp._val = b'\x13'
    
    #-----< colr >-----#
    colr = OCT_STR(name=u'colr', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    colr._val = b'\x14'
    
    #-----< mci >-----#
    mci = OCT_STR(name=u'mci', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    mci._val = b'\x15'
    
    #-----< allNameIdentificationSS >-----#
    allNameIdentificationSS = OCT_STR(name=u'allNameIdentificationSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allNameIdentificationSS._val = b'\x18'
    
    #-----< cnap >-----#
    cnap = OCT_STR(name=u'cnap', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cnap._val = b'\x19'
    
    #-----< allForwardingSS >-----#
    allForwardingSS = OCT_STR(name=u'allForwardingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allForwardingSS._val = b' '
    
    #-----< cfu >-----#
    cfu = OCT_STR(name=u'cfu', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfu._val = b'!'
    
    #-----< allCondForwardingSS >-----#
    allCondForwardingSS = OCT_STR(name=u'allCondForwardingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCondForwardingSS._val = b'('
    
    #-----< cfb >-----#
    cfb = OCT_STR(name=u'cfb', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfb._val = b')'
    
    #-----< cfnry >-----#
    cfnry = OCT_STR(name=u'cfnry', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfnry._val = b'*'
    
    #-----< cfnrc >-----#
    cfnrc = OCT_STR(name=u'cfnrc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cfnrc._val = b'+'
    
    #-----< cd >-----#
    cd = OCT_STR(name=u'cd', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cd._val = b'$'
    
    #-----< allCallOfferingSS >-----#
    allCallOfferingSS = OCT_STR(name=u'allCallOfferingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCallOfferingSS._val = b'0'
    
    #-----< ect >-----#
    ect = OCT_STR(name=u'ect', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    ect._val = b'1'
    
    #-----< mah >-----#
    mah = OCT_STR(name=u'mah', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    mah._val = b'2'
    
    #-----< allCallCompletionSS >-----#
    allCallCompletionSS = OCT_STR(name=u'allCallCompletionSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCallCompletionSS._val = b'@'
    
    #-----< cw >-----#
    cw = OCT_STR(name=u'cw', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cw._val = b'A'
    
    #-----< hold >-----#
    hold = OCT_STR(name=u'hold', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    hold._val = b'B'
    
    #-----< ccbs-A >-----#
    ccbs_A = OCT_STR(name=u'ccbs-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    ccbs_A._val = b'C'
    
    #-----< ccbs-B >-----#
    ccbs_B = OCT_STR(name=u'ccbs-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    ccbs_B._val = b'D'
    
    #-----< mc >-----#
    mc = OCT_STR(name=u'mc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    mc._val = b'E'
    
    #-----< allMultiPartySS >-----#
    allMultiPartySS = OCT_STR(name=u'allMultiPartySS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allMultiPartySS._val = b'P'
    
    #-----< multiPTY >-----#
    multiPTY = OCT_STR(name=u'multiPTY', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    multiPTY._val = b'Q'
    
    #-----< allCommunityOfInterest-SS >-----#
    allCommunityOfInterest_SS = OCT_STR(name=u'allCommunityOfInterest-SS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCommunityOfInterest_SS._val = b'`'
    
    #-----< cug >-----#
    cug = OCT_STR(name=u'cug', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    cug._val = b'a'
    
    #-----< allChargingSS >-----#
    allChargingSS = OCT_STR(name=u'allChargingSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allChargingSS._val = b'p'
    
    #-----< aoci >-----#
    aoci = OCT_STR(name=u'aoci', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    aoci._val = b'q'
    
    #-----< aocc >-----#
    aocc = OCT_STR(name=u'aocc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    aocc._val = b'r'
    
    #-----< allAdditionalInfoTransferSS >-----#
    allAdditionalInfoTransferSS = OCT_STR(name=u'allAdditionalInfoTransferSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allAdditionalInfoTransferSS._val = b'\x80'
    
    #-----< uus1 >-----#
    uus1 = OCT_STR(name=u'uus1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    uus1._val = b'\x81'
    
    #-----< uus2 >-----#
    uus2 = OCT_STR(name=u'uus2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    uus2._val = b'\x82'
    
    #-----< uus3 >-----#
    uus3 = OCT_STR(name=u'uus3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    uus3._val = b'\x83'
    
    #-----< allBarringSS >-----#
    allBarringSS = OCT_STR(name=u'allBarringSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allBarringSS._val = b'\x90'
    
    #-----< barringOfOutgoingCalls >-----#
    barringOfOutgoingCalls = OCT_STR(name=u'barringOfOutgoingCalls', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    barringOfOutgoingCalls._val = b'\x91'
    
    #-----< baoc >-----#
    baoc = OCT_STR(name=u'baoc', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    baoc._val = b'\x92'
    
    #-----< boic >-----#
    boic = OCT_STR(name=u'boic', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    boic._val = b'\x93'
    
    #-----< boicExHC >-----#
    boicExHC = OCT_STR(name=u'boicExHC', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    boicExHC._val = b'\x94'
    
    #-----< barringOfIncomingCalls >-----#
    barringOfIncomingCalls = OCT_STR(name=u'barringOfIncomingCalls', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    barringOfIncomingCalls._val = b'\x99'
    
    #-----< baic >-----#
    baic = OCT_STR(name=u'baic', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    baic._val = b'\x9a'
    
    #-----< bicRoam >-----#
    bicRoam = OCT_STR(name=u'bicRoam', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    bicRoam._val = b'\x9b'
    
    #-----< allPLMN-specificSS >-----#
    allPLMN_specificSS = OCT_STR(name=u'allPLMN-specificSS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allPLMN_specificSS._val = b'\xf0'
    
    #-----< plmn-specificSS-1 >-----#
    plmn_specificSS_1 = OCT_STR(name=u'plmn-specificSS-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_1._val = b'\xf1'
    
    #-----< plmn-specificSS-2 >-----#
    plmn_specificSS_2 = OCT_STR(name=u'plmn-specificSS-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_2._val = b'\xf2'
    
    #-----< plmn-specificSS-3 >-----#
    plmn_specificSS_3 = OCT_STR(name=u'plmn-specificSS-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_3._val = b'\xf3'
    
    #-----< plmn-specificSS-4 >-----#
    plmn_specificSS_4 = OCT_STR(name=u'plmn-specificSS-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_4._val = b'\xf4'
    
    #-----< plmn-specificSS-5 >-----#
    plmn_specificSS_5 = OCT_STR(name=u'plmn-specificSS-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_5._val = b'\xf5'
    
    #-----< plmn-specificSS-6 >-----#
    plmn_specificSS_6 = OCT_STR(name=u'plmn-specificSS-6', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_6._val = b'\xf6'
    
    #-----< plmn-specificSS-7 >-----#
    plmn_specificSS_7 = OCT_STR(name=u'plmn-specificSS-7', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_7._val = b'\xf7'
    
    #-----< plmn-specificSS-8 >-----#
    plmn_specificSS_8 = OCT_STR(name=u'plmn-specificSS-8', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_8._val = b'\xf8'
    
    #-----< plmn-specificSS-9 >-----#
    plmn_specificSS_9 = OCT_STR(name=u'plmn-specificSS-9', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_9._val = b'\xf9'
    
    #-----< plmn-specificSS-A >-----#
    plmn_specificSS_A = OCT_STR(name=u'plmn-specificSS-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_A._val = b'\xfa'
    
    #-----< plmn-specificSS-B >-----#
    plmn_specificSS_B = OCT_STR(name=u'plmn-specificSS-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_B._val = b'\xfb'
    
    #-----< plmn-specificSS-C >-----#
    plmn_specificSS_C = OCT_STR(name=u'plmn-specificSS-C', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_C._val = b'\xfc'
    
    #-----< plmn-specificSS-D >-----#
    plmn_specificSS_D = OCT_STR(name=u'plmn-specificSS-D', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_D._val = b'\xfd'
    
    #-----< plmn-specificSS-E >-----#
    plmn_specificSS_E = OCT_STR(name=u'plmn-specificSS-E', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_E._val = b'\xfe'
    
    #-----< plmn-specificSS-F >-----#
    plmn_specificSS_F = OCT_STR(name=u'plmn-specificSS-F', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmn_specificSS_F._val = b'\xff'
    
    #-----< allCallPrioritySS >-----#
    allCallPrioritySS = OCT_STR(name=u'allCallPrioritySS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allCallPrioritySS._val = b'\xa0'
    
    #-----< emlpp >-----#
    emlpp = OCT_STR(name=u'emlpp', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    emlpp._val = b'\xa1'
    
    #-----< allLCSPrivacyException >-----#
    allLCSPrivacyException = OCT_STR(name=u'allLCSPrivacyException', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allLCSPrivacyException._val = b'\xb0'
    
    #-----< universal >-----#
    universal = OCT_STR(name=u'universal', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    universal._val = b'\xb1'
    
    #-----< callSessionRelated >-----#
    callSessionRelated = OCT_STR(name=u'callSessionRelated', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    callSessionRelated._val = b'\xb2'
    
    #-----< callSessionUnrelated >-----#
    callSessionUnrelated = OCT_STR(name=u'callSessionUnrelated', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    callSessionUnrelated._val = b'\xb3'
    
    #-----< plmnoperator >-----#
    plmnoperator = OCT_STR(name=u'plmnoperator', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    plmnoperator._val = b'\xb4'
    
    #-----< serviceType >-----#
    serviceType = OCT_STR(name=u'serviceType', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    serviceType._val = b'\xb5'
    
    #-----< allMOLR-SS >-----#
    allMOLR_SS = OCT_STR(name=u'allMOLR-SS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    allMOLR_SS._val = b'\xc0'
    
    #-----< basicSelfLocation >-----#
    basicSelfLocation = OCT_STR(name=u'basicSelfLocation', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    basicSelfLocation._val = b'\xc1'
    
    #-----< autonomousSelfLocation >-----#
    autonomousSelfLocation = OCT_STR(name=u'autonomousSelfLocation', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    autonomousSelfLocation._val = b'\xc2'
    
    #-----< transferToThirdParty >-----#
    transferToThirdParty = OCT_STR(name=u'transferToThirdParty', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    transferToThirdParty._val = b'\xc3'
    
    _all_ = [
        SS_Code,
        allSS,
        allLineIdentificationSS,
        clip,
        clir,
        colp,
        colr,
        mci,
        allNameIdentificationSS,
        cnap,
        allForwardingSS,
        cfu,
        allCondForwardingSS,
        cfb,
        cfnry,
        cfnrc,
        cd,
        allCallOfferingSS,
        ect,
        mah,
        allCallCompletionSS,
        cw,
        hold,
        ccbs_A,
        ccbs_B,
        mc,
        allMultiPartySS,
        multiPTY,
        allCommunityOfInterest_SS,
        cug,
        allChargingSS,
        aoci,
        aocc,
        allAdditionalInfoTransferSS,
        uus1,
        uus2,
        uus3,
        allBarringSS,
        barringOfOutgoingCalls,
        baoc,
        boic,
        boicExHC,
        barringOfIncomingCalls,
        baic,
        bicRoam,
        allPLMN_specificSS,
        plmn_specificSS_1,
        plmn_specificSS_2,
        plmn_specificSS_3,
        plmn_specificSS_4,
        plmn_specificSS_5,
        plmn_specificSS_6,
        plmn_specificSS_7,
        plmn_specificSS_8,
        plmn_specificSS_9,
        plmn_specificSS_A,
        plmn_specificSS_B,
        plmn_specificSS_C,
        plmn_specificSS_D,
        plmn_specificSS_E,
        plmn_specificSS_F,
        allCallPrioritySS,
        emlpp,
        allLCSPrivacyException,
        universal,
        callSessionRelated,
        callSessionUnrelated,
        plmnoperator,
        serviceType,
        allMOLR_SS,
        basicSelfLocation,
        autonomousSelfLocation,
        transferToThirdParty,
    ]

class MAP_SS_DataTypes:

    _name_  = u'MAP-SS-DataTypes'
    _oid_   = [0, 4, 0, 0, 1, 3, 14, 19]
    
    _obj_ = [
        u'RegisterSS-Arg',
        u'NoReplyConditionTime',
        u'SS-Info',
        u'ForwardingInfo',
        u'ForwardingFeatureList',
        u'ForwardingFeature',
        u'SS-Status',
        u'ForwardingOptions',
        u'CallBarringInfo',
        u'CallBarringFeatureList',
        u'CallBarringFeature',
        u'SS-Data',
        u'SS-SubscriptionOption',
        u'CliRestrictionOption',
        u'OverrideCategory',
        u'SS-ForBS-Code',
        u'GenericServiceInfo',
        u'CCBS-FeatureList',
        u'maxNumOfCCBS-Requests',
        u'CCBS-Feature',
        u'CCBS-Index',
        u'InterrogateSS-Res',
        u'USSD-Arg',
        u'USSD-Res',
        u'USSD-DataCodingScheme',
        u'USSD-String',
        u'maxUSSD-StringLength',
        u'Password',
        u'GuidanceInfo',
        u'SS-List',
        u'maxNumOfSS',
        u'SS-InfoList',
        u'BasicServiceGroupList',
        u'maxNumOfBasicServiceGroups',
        u'SS-InvocationNotificationArg',
        u'CCBS-RequestState',
        u'SS-InvocationNotificationRes',
        u'SS-EventSpecification',
        u'maxEventSpecification',
        u'RegisterCC-EntryArg',
        u'CCBS-Data',
        u'ServiceIndicator',
        u'RegisterCC-EntryRes',
        u'EraseCC-EntryArg',
        u'EraseCC-EntryRes',
        ]
    _type_ = [
        u'RegisterSS-Arg',
        u'NoReplyConditionTime',
        u'SS-Info',
        u'ForwardingInfo',
        u'ForwardingFeatureList',
        u'ForwardingFeature',
        u'SS-Status',
        u'ForwardingOptions',
        u'CallBarringInfo',
        u'CallBarringFeatureList',
        u'CallBarringFeature',
        u'SS-Data',
        u'SS-SubscriptionOption',
        u'CliRestrictionOption',
        u'OverrideCategory',
        u'SS-ForBS-Code',
        u'GenericServiceInfo',
        u'CCBS-FeatureList',
        u'CCBS-Feature',
        u'CCBS-Index',
        u'InterrogateSS-Res',
        u'USSD-Arg',
        u'USSD-Res',
        u'USSD-DataCodingScheme',
        u'USSD-String',
        u'Password',
        u'GuidanceInfo',
        u'SS-List',
        u'SS-InfoList',
        u'BasicServiceGroupList',
        u'SS-InvocationNotificationArg',
        u'CCBS-RequestState',
        u'SS-InvocationNotificationRes',
        u'SS-EventSpecification',
        u'RegisterCC-EntryArg',
        u'CCBS-Data',
        u'ServiceIndicator',
        u'RegisterCC-EntryRes',
        u'EraseCC-EntryArg',
        u'EraseCC-EntryRes',
        ]
    _set_ = [
        ]
    _val_ = [
        u'maxNumOfCCBS-Requests',
        u'maxUSSD-StringLength',
        u'maxNumOfSS',
        u'maxNumOfBasicServiceGroups',
        u'maxEventSpecification',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< RegisterSS-Arg >-----#
    RegisterSS_Arg = SEQ(name=u'RegisterSS-Arg', mode=MODE_TYPE)
    _RegisterSS_Arg_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _RegisterSS_Arg_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _RegisterSS_Arg_forwardedToNumber = OCT_STR(name=u'forwardedToNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _RegisterSS_Arg_forwardedToSubaddress = OCT_STR(name=u'forwardedToSubaddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _RegisterSS_Arg_noReplyConditionTime = INT(name=u'noReplyConditionTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'NoReplyConditionTime')), opt=True)
    _RegisterSS_Arg_defaultPriority = INT(name=u'defaultPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _RegisterSS_Arg_nbrUser = INT(name=u'nbrUser', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    _RegisterSS_Arg_longFTN_Supported = NULL(name=u'longFTN-Supported', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RegisterSS_Arg._cont = ASN1Dict([
        (u'ss-Code', _RegisterSS_Arg_ss_Code),
        (u'basicService', _RegisterSS_Arg_basicService),
        (u'forwardedToNumber', _RegisterSS_Arg_forwardedToNumber),
        (u'forwardedToSubaddress', _RegisterSS_Arg_forwardedToSubaddress),
        (u'noReplyConditionTime', _RegisterSS_Arg_noReplyConditionTime),
        (u'defaultPriority', _RegisterSS_Arg_defaultPriority),
        (u'nbrUser', _RegisterSS_Arg_nbrUser),
        (u'longFTN-Supported', _RegisterSS_Arg_longFTN_Supported),
        ])
    RegisterSS_Arg._ext = [u'defaultPriority', u'nbrUser', u'longFTN-Supported']
    
    #-----< NoReplyConditionTime >-----#
    NoReplyConditionTime = INT(name=u'NoReplyConditionTime', mode=MODE_TYPE)
    NoReplyConditionTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=5, ub=30)], ev=None, er=[])
    
    #-----< SS-Info >-----#
    SS_Info = CHOICE(name=u'SS-Info', mode=MODE_TYPE)
    _SS_Info_forwardingInfo = SEQ(name=u'forwardingInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingInfo')))
    _SS_Info_callBarringInfo = SEQ(name=u'callBarringInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CallBarringInfo')))
    _SS_Info_ss_Data = SEQ(name=u'ss-Data', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Data')))
    SS_Info._cont = ASN1Dict([
        (u'forwardingInfo', _SS_Info_forwardingInfo),
        (u'callBarringInfo', _SS_Info_callBarringInfo),
        (u'ss-Data', _SS_Info_ss_Data),
        ])
    SS_Info._ext = None
    
    #-----< ForwardingInfo >-----#
    ForwardingInfo = SEQ(name=u'ForwardingInfo', mode=MODE_TYPE)
    _ForwardingInfo_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _ForwardingInfo_forwardingFeatureList = SEQ_OF(name=u'forwardingFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingFeatureList')))
    ForwardingInfo._cont = ASN1Dict([
        (u'ss-Code', _ForwardingInfo_ss_Code),
        (u'forwardingFeatureList', _ForwardingInfo_forwardingFeatureList),
        ])
    ForwardingInfo._ext = []
    
    #-----< ForwardingFeatureList >-----#
    ForwardingFeatureList = SEQ_OF(name=u'ForwardingFeatureList', mode=MODE_TYPE)
    _ForwardingFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingFeature')))
    ForwardingFeatureList._cont = _ForwardingFeatureList__item_
    ForwardingFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=13)], ev=None, er=[])
    
    #-----< ForwardingFeature >-----#
    ForwardingFeature = SEQ(name=u'ForwardingFeature', mode=MODE_TYPE)
    _ForwardingFeature_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _ForwardingFeature_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    _ForwardingFeature_forwardedToNumber = OCT_STR(name=u'forwardedToNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _ForwardingFeature_forwardedToSubaddress = OCT_STR(name=u'forwardedToSubaddress', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _ForwardingFeature_forwardingOptions = OCT_STR(name=u'forwardingOptions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingOptions')), opt=True)
    _ForwardingFeature_noReplyConditionTime = INT(name=u'noReplyConditionTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'NoReplyConditionTime')), opt=True)
    _ForwardingFeature_longForwardedToNumber = OCT_STR(name=u'longForwardedToNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'FTN-AddressString')), opt=True)
    ForwardingFeature._cont = ASN1Dict([
        (u'basicService', _ForwardingFeature_basicService),
        (u'ss-Status', _ForwardingFeature_ss_Status),
        (u'forwardedToNumber', _ForwardingFeature_forwardedToNumber),
        (u'forwardedToSubaddress', _ForwardingFeature_forwardedToSubaddress),
        (u'forwardingOptions', _ForwardingFeature_forwardingOptions),
        (u'noReplyConditionTime', _ForwardingFeature_noReplyConditionTime),
        (u'longForwardedToNumber', _ForwardingFeature_longForwardedToNumber),
        ])
    ForwardingFeature._ext = [u'longForwardedToNumber']
    
    #-----< SS-Status >-----#
    SS_Status = OCT_STR(name=u'SS-Status', mode=MODE_TYPE)
    SS_Status._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ForwardingOptions >-----#
    ForwardingOptions = OCT_STR(name=u'ForwardingOptions', mode=MODE_TYPE)
    ForwardingOptions._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< CallBarringInfo >-----#
    CallBarringInfo = SEQ(name=u'CallBarringInfo', mode=MODE_TYPE)
    _CallBarringInfo_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _CallBarringInfo_callBarringFeatureList = SEQ_OF(name=u'callBarringFeatureList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CallBarringFeatureList')))
    CallBarringInfo._cont = ASN1Dict([
        (u'ss-Code', _CallBarringInfo_ss_Code),
        (u'callBarringFeatureList', _CallBarringInfo_callBarringFeatureList),
        ])
    CallBarringInfo._ext = []
    
    #-----< CallBarringFeatureList >-----#
    CallBarringFeatureList = SEQ_OF(name=u'CallBarringFeatureList', mode=MODE_TYPE)
    _CallBarringFeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CallBarringFeature')))
    CallBarringFeatureList._cont = _CallBarringFeatureList__item_
    CallBarringFeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=13)], ev=None, er=[])
    
    #-----< CallBarringFeature >-----#
    CallBarringFeature = SEQ(name=u'CallBarringFeature', mode=MODE_TYPE)
    _CallBarringFeature_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _CallBarringFeature_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    CallBarringFeature._cont = ASN1Dict([
        (u'basicService', _CallBarringFeature_basicService),
        (u'ss-Status', _CallBarringFeature_ss_Status),
        ])
    CallBarringFeature._ext = []
    
    #-----< SS-Data >-----#
    SS_Data = SEQ(name=u'SS-Data', mode=MODE_TYPE)
    _SS_Data_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _SS_Data_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    _SS_Data_ss_SubscriptionOption = CHOICE(name=u'ss-SubscriptionOption', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-SubscriptionOption')), opt=True)
    _SS_Data_basicServiceGroupList = SEQ_OF(name=u'basicServiceGroupList', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'BasicServiceGroupList')), opt=True)
    _SS_Data_defaultPriority = INT(name=u'defaultPriority', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _SS_Data_nbrUser = INT(name=u'nbrUser', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    SS_Data._cont = ASN1Dict([
        (u'ss-Code', _SS_Data_ss_Code),
        (u'ss-Status', _SS_Data_ss_Status),
        (u'ss-SubscriptionOption', _SS_Data_ss_SubscriptionOption),
        (u'basicServiceGroupList', _SS_Data_basicServiceGroupList),
        (u'defaultPriority', _SS_Data_defaultPriority),
        (u'nbrUser', _SS_Data_nbrUser),
        ])
    SS_Data._ext = [u'defaultPriority', u'nbrUser']
    
    #-----< SS-SubscriptionOption >-----#
    SS_SubscriptionOption = CHOICE(name=u'SS-SubscriptionOption', mode=MODE_TYPE)
    _SS_SubscriptionOption_cliRestrictionOption = ENUM(name=u'cliRestrictionOption', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')))
    _SS_SubscriptionOption_overrideCategory = ENUM(name=u'overrideCategory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'OverrideCategory')))
    SS_SubscriptionOption._cont = ASN1Dict([
        (u'cliRestrictionOption', _SS_SubscriptionOption_cliRestrictionOption),
        (u'overrideCategory', _SS_SubscriptionOption_overrideCategory),
        ])
    SS_SubscriptionOption._ext = None
    
    #-----< CliRestrictionOption >-----#
    CliRestrictionOption = ENUM(name=u'CliRestrictionOption', mode=MODE_TYPE)
    CliRestrictionOption._cont = ASN1Dict([(u'permanent', 0), (u'temporaryDefaultRestricted', 1), (u'temporaryDefaultAllowed', 2)])
    CliRestrictionOption._ext = None
    
    #-----< OverrideCategory >-----#
    OverrideCategory = ENUM(name=u'OverrideCategory', mode=MODE_TYPE)
    OverrideCategory._cont = ASN1Dict([(u'overrideEnabled', 0), (u'overrideDisabled', 1)])
    OverrideCategory._ext = None
    
    #-----< SS-ForBS-Code >-----#
    SS_ForBS_Code = SEQ(name=u'SS-ForBS-Code', mode=MODE_TYPE)
    _SS_ForBS_Code_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _SS_ForBS_Code_basicService = CHOICE(name=u'basicService', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    _SS_ForBS_Code_longFTN_Supported = NULL(name=u'longFTN-Supported', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SS_ForBS_Code._cont = ASN1Dict([
        (u'ss-Code', _SS_ForBS_Code_ss_Code),
        (u'basicService', _SS_ForBS_Code_basicService),
        (u'longFTN-Supported', _SS_ForBS_Code_longFTN_Supported),
        ])
    SS_ForBS_Code._ext = [u'longFTN-Supported']
    
    #-----< GenericServiceInfo >-----#
    GenericServiceInfo = SEQ(name=u'GenericServiceInfo', mode=MODE_TYPE)
    _GenericServiceInfo_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')))
    _GenericServiceInfo_cliRestrictionOption = ENUM(name=u'cliRestrictionOption', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CliRestrictionOption')), opt=True)
    _GenericServiceInfo_maximumEntitledPriority = INT(name=u'maximumEntitledPriority', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _GenericServiceInfo_defaultPriority = INT(name=u'defaultPriority', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'EMLPP-Priority')), opt=True)
    _GenericServiceInfo_ccbs_FeatureList = SEQ_OF(name=u'ccbs-FeatureList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-FeatureList')), opt=True)
    _GenericServiceInfo_nbrSB = INT(name=u'nbrSB', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MaxMC-Bearers')), opt=True)
    _GenericServiceInfo_nbrUser = INT(name=u'nbrUser', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    _GenericServiceInfo_nbrSN = INT(name=u'nbrSN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'MC-Bearers')), opt=True)
    GenericServiceInfo._cont = ASN1Dict([
        (u'ss-Status', _GenericServiceInfo_ss_Status),
        (u'cliRestrictionOption', _GenericServiceInfo_cliRestrictionOption),
        (u'maximumEntitledPriority', _GenericServiceInfo_maximumEntitledPriority),
        (u'defaultPriority', _GenericServiceInfo_defaultPriority),
        (u'ccbs-FeatureList', _GenericServiceInfo_ccbs_FeatureList),
        (u'nbrSB', _GenericServiceInfo_nbrSB),
        (u'nbrUser', _GenericServiceInfo_nbrUser),
        (u'nbrSN', _GenericServiceInfo_nbrSN),
        ])
    GenericServiceInfo._ext = [u'maximumEntitledPriority', u'defaultPriority', u'ccbs-FeatureList', u'nbrSB', u'nbrUser', u'nbrSN']
    
    #-----< CCBS-FeatureList >-----#
    CCBS_FeatureList = SEQ_OF(name=u'CCBS-FeatureList', mode=MODE_TYPE)
    _CCBS_FeatureList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')))
    CCBS_FeatureList._cont = _CCBS_FeatureList__item_
    CCBS_FeatureList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< maxNumOfCCBS-Requests >-----#
    maxNumOfCCBS_Requests = INT(name=u'maxNumOfCCBS-Requests', mode=MODE_VALUE)
    maxNumOfCCBS_Requests._val = 5
    
    #-----< CCBS-Feature >-----#
    CCBS_Feature = SEQ(name=u'CCBS-Feature', mode=MODE_TYPE)
    _CCBS_Feature_ccbs_Index = INT(name=u'ccbs-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Index')), opt=True)
    _CCBS_Feature_b_subscriberNumber = OCT_STR(name=u'b-subscriberNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _CCBS_Feature_b_subscriberSubaddress = OCT_STR(name=u'b-subscriberSubaddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    _CCBS_Feature_basicServiceGroup = CHOICE(name=u'basicServiceGroup', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')), opt=True)
    CCBS_Feature._cont = ASN1Dict([
        (u'ccbs-Index', _CCBS_Feature_ccbs_Index),
        (u'b-subscriberNumber', _CCBS_Feature_b_subscriberNumber),
        (u'b-subscriberSubaddress', _CCBS_Feature_b_subscriberSubaddress),
        (u'basicServiceGroup', _CCBS_Feature_basicServiceGroup),
        ])
    CCBS_Feature._ext = []
    
    #-----< CCBS-Index >-----#
    CCBS_Index = INT(name=u'CCBS-Index', mode=MODE_TYPE)
    CCBS_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< InterrogateSS-Res >-----#
    InterrogateSS_Res = CHOICE(name=u'InterrogateSS-Res', mode=MODE_TYPE)
    _InterrogateSS_Res_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')))
    _InterrogateSS_Res_basicServiceGroupList = SEQ_OF(name=u'basicServiceGroupList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'BasicServiceGroupList')))
    _InterrogateSS_Res_forwardingFeatureList = SEQ_OF(name=u'forwardingFeatureList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ForwardingFeatureList')))
    _InterrogateSS_Res_genericServiceInfo = SEQ(name=u'genericServiceInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'GenericServiceInfo')))
    InterrogateSS_Res._cont = ASN1Dict([
        (u'ss-Status', _InterrogateSS_Res_ss_Status),
        (u'basicServiceGroupList', _InterrogateSS_Res_basicServiceGroupList),
        (u'forwardingFeatureList', _InterrogateSS_Res_forwardingFeatureList),
        (u'genericServiceInfo', _InterrogateSS_Res_genericServiceInfo),
        ])
    InterrogateSS_Res._ext = None
    
    #-----< USSD-Arg >-----#
    USSD_Arg = SEQ(name=u'USSD-Arg', mode=MODE_TYPE)
    _USSD_Arg_ussd_DataCodingScheme = OCT_STR(name=u'ussd-DataCodingScheme', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _USSD_Arg_ussd_String = OCT_STR(name=u'ussd-String', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    _USSD_Arg_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _USSD_Arg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    USSD_Arg._cont = ASN1Dict([
        (u'ussd-DataCodingScheme', _USSD_Arg_ussd_DataCodingScheme),
        (u'ussd-String', _USSD_Arg_ussd_String),
        (u'alertingPattern', _USSD_Arg_alertingPattern),
        (u'msisdn', _USSD_Arg_msisdn),
        ])
    USSD_Arg._ext = [u'alertingPattern', u'msisdn']
    
    #-----< USSD-Res >-----#
    USSD_Res = SEQ(name=u'USSD-Res', mode=MODE_TYPE)
    _USSD_Res_ussd_DataCodingScheme = OCT_STR(name=u'ussd-DataCodingScheme', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _USSD_Res_ussd_String = OCT_STR(name=u'ussd-String', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    USSD_Res._cont = ASN1Dict([
        (u'ussd-DataCodingScheme', _USSD_Res_ussd_DataCodingScheme),
        (u'ussd-String', _USSD_Res_ussd_String),
        ])
    USSD_Res._ext = []
    
    #-----< USSD-DataCodingScheme >-----#
    USSD_DataCodingScheme = OCT_STR(name=u'USSD-DataCodingScheme', mode=MODE_TYPE)
    USSD_DataCodingScheme._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< USSD-String >-----#
    USSD_String = OCT_STR(name=u'USSD-String', mode=MODE_TYPE)
    USSD_String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=None, er=[])
    
    #-----< maxUSSD-StringLength >-----#
    maxUSSD_StringLength = INT(name=u'maxUSSD-StringLength', mode=MODE_VALUE)
    maxUSSD_StringLength._val = 160
    
    #-----< Password >-----#
    Password = STR_NUM(name=u'Password', mode=MODE_TYPE)
    Password._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    Password._const_alpha = ASN1Set(rv=[u'0', u'1', u'2', u'3', u'4', u'5', u'6', u'7', u'8', u'9'], rr=[], ev=None, er=[])
    
    #-----< GuidanceInfo >-----#
    GuidanceInfo = ENUM(name=u'GuidanceInfo', mode=MODE_TYPE)
    GuidanceInfo._cont = ASN1Dict([(u'enterPW', 0), (u'enterNewPW', 1), (u'enterNewPW-Again', 2)])
    GuidanceInfo._ext = None
    
    #-----< SS-List >-----#
    SS_List = SEQ_OF(name=u'SS-List', mode=MODE_TYPE)
    _SS_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    SS_List._cont = _SS_List__item_
    SS_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    
    #-----< maxNumOfSS >-----#
    maxNumOfSS = INT(name=u'maxNumOfSS', mode=MODE_VALUE)
    maxNumOfSS._val = 30
    
    #-----< SS-InfoList >-----#
    SS_InfoList = SEQ_OF(name=u'SS-InfoList', mode=MODE_TYPE)
    _SS_InfoList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Info')))
    SS_InfoList._cont = _SS_InfoList__item_
    SS_InfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    
    #-----< BasicServiceGroupList >-----#
    BasicServiceGroupList = SEQ_OF(name=u'BasicServiceGroupList', mode=MODE_TYPE)
    _BasicServiceGroupList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'BasicServiceCode')))
    BasicServiceGroupList._cont = _BasicServiceGroupList__item_
    BasicServiceGroupList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=13)], ev=None, er=[])
    
    #-----< maxNumOfBasicServiceGroups >-----#
    maxNumOfBasicServiceGroups = INT(name=u'maxNumOfBasicServiceGroups', mode=MODE_VALUE)
    maxNumOfBasicServiceGroups._val = 13
    
    #-----< SS-InvocationNotificationArg >-----#
    SS_InvocationNotificationArg = SEQ(name=u'SS-InvocationNotificationArg', mode=MODE_TYPE)
    _SS_InvocationNotificationArg_imsi = OCT_STR(name=u'imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SS_InvocationNotificationArg_msisdn = OCT_STR(name=u'msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _SS_InvocationNotificationArg_ss_Event = OCT_STR(name=u'ss-Event', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _SS_InvocationNotificationArg_ss_EventSpecification = SEQ_OF(name=u'ss-EventSpecification', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-EventSpecification')), opt=True)
    _SS_InvocationNotificationArg_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    _SS_InvocationNotificationArg_b_subscriberNumber = OCT_STR(name=u'b-subscriberNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _SS_InvocationNotificationArg_ccbs_RequestState = ENUM(name=u'ccbs-RequestState', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-RequestState')), opt=True)
    SS_InvocationNotificationArg._cont = ASN1Dict([
        (u'imsi', _SS_InvocationNotificationArg_imsi),
        (u'msisdn', _SS_InvocationNotificationArg_msisdn),
        (u'ss-Event', _SS_InvocationNotificationArg_ss_Event),
        (u'ss-EventSpecification', _SS_InvocationNotificationArg_ss_EventSpecification),
        (u'extensionContainer', _SS_InvocationNotificationArg_extensionContainer),
        (u'b-subscriberNumber', _SS_InvocationNotificationArg_b_subscriberNumber),
        (u'ccbs-RequestState', _SS_InvocationNotificationArg_ccbs_RequestState),
        ])
    SS_InvocationNotificationArg._ext = [u'b-subscriberNumber', u'ccbs-RequestState']
    
    #-----< CCBS-RequestState >-----#
    CCBS_RequestState = ENUM(name=u'CCBS-RequestState', mode=MODE_TYPE)
    CCBS_RequestState._cont = ASN1Dict([(u'request', 0), (u'recall', 1), (u'active', 2), (u'completed', 3), (u'suspended', 4), (u'frozen', 5), (u'deleted', 6)])
    CCBS_RequestState._ext = None
    
    #-----< SS-InvocationNotificationRes >-----#
    SS_InvocationNotificationRes = SEQ(name=u'SS-InvocationNotificationRes', mode=MODE_TYPE)
    _SS_InvocationNotificationRes_extensionContainer = SEQ(name=u'extensionContainer', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-ExtensionDataTypes', 'ExtensionContainer')), opt=True)
    SS_InvocationNotificationRes._cont = ASN1Dict([
        (u'extensionContainer', _SS_InvocationNotificationRes_extensionContainer),
        ])
    SS_InvocationNotificationRes._ext = []
    
    #-----< SS-EventSpecification >-----#
    SS_EventSpecification = SEQ_OF(name=u'SS-EventSpecification', mode=MODE_TYPE)
    _SS_EventSpecification__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    SS_EventSpecification._cont = _SS_EventSpecification__item_
    SS_EventSpecification._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< maxEventSpecification >-----#
    maxEventSpecification = INT(name=u'maxEventSpecification', mode=MODE_VALUE)
    maxEventSpecification._val = 2
    
    #-----< RegisterCC-EntryArg >-----#
    RegisterCC_EntryArg = SEQ(name=u'RegisterCC-EntryArg', mode=MODE_TYPE)
    _RegisterCC_EntryArg_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _RegisterCC_EntryArg_ccbs_Data = SEQ(name=u'ccbs-Data', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Data')), opt=True)
    RegisterCC_EntryArg._cont = ASN1Dict([
        (u'ss-Code', _RegisterCC_EntryArg_ss_Code),
        (u'ccbs-Data', _RegisterCC_EntryArg_ccbs_Data),
        ])
    RegisterCC_EntryArg._ext = []
    
    #-----< CCBS-Data >-----#
    CCBS_Data = SEQ(name=u'CCBS-Data', mode=MODE_TYPE)
    _CCBS_Data_ccbs_Feature = SEQ(name=u'ccbs-Feature', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')))
    _CCBS_Data_translatedB_Number = OCT_STR(name=u'translatedB-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _CCBS_Data_serviceIndicator = BIT_STR(name=u'serviceIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'ServiceIndicator')), opt=True)
    _CCBS_Data_callInfo = SEQ(name=u'callInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')))
    _CCBS_Data_networkSignalInfo = SEQ(name=u'networkSignalInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ExternalSignalInfo')))
    CCBS_Data._cont = ASN1Dict([
        (u'ccbs-Feature', _CCBS_Data_ccbs_Feature),
        (u'translatedB-Number', _CCBS_Data_translatedB_Number),
        (u'serviceIndicator', _CCBS_Data_serviceIndicator),
        (u'callInfo', _CCBS_Data_callInfo),
        (u'networkSignalInfo', _CCBS_Data_networkSignalInfo),
        ])
    CCBS_Data._ext = []
    
    #-----< ServiceIndicator >-----#
    ServiceIndicator = BIT_STR(name=u'ServiceIndicator', mode=MODE_TYPE)
    ServiceIndicator._cont = ASN1Dict([(u'clir-invoked', 0), (u'camel-invoked', 1)])
    ServiceIndicator._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=32)], ev=None, er=[])
    
    #-----< RegisterCC-EntryRes >-----#
    RegisterCC_EntryRes = SEQ(name=u'RegisterCC-EntryRes', mode=MODE_TYPE)
    _RegisterCC_EntryRes_ccbs_Feature = SEQ(name=u'ccbs-Feature', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')), opt=True)
    RegisterCC_EntryRes._cont = ASN1Dict([
        (u'ccbs-Feature', _RegisterCC_EntryRes_ccbs_Feature),
        ])
    RegisterCC_EntryRes._ext = []
    
    #-----< EraseCC-EntryArg >-----#
    EraseCC_EntryArg = SEQ(name=u'EraseCC-EntryArg', mode=MODE_TYPE)
    _EraseCC_EntryArg_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _EraseCC_EntryArg_ccbs_Index = INT(name=u'ccbs-Index', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Index')), opt=True)
    EraseCC_EntryArg._cont = ASN1Dict([
        (u'ss-Code', _EraseCC_EntryArg_ss_Code),
        (u'ccbs-Index', _EraseCC_EntryArg_ccbs_Index),
        ])
    EraseCC_EntryArg._ext = []
    
    #-----< EraseCC-EntryRes >-----#
    EraseCC_EntryRes = SEQ(name=u'EraseCC-EntryRes', mode=MODE_TYPE)
    _EraseCC_EntryRes_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _EraseCC_EntryRes_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    EraseCC_EntryRes._cont = ASN1Dict([
        (u'ss-Code', _EraseCC_EntryRes_ss_Code),
        (u'ss-Status', _EraseCC_EntryRes_ss_Status),
        ])
    EraseCC_EntryRes._ext = []
    
    _all_ = [
        _RegisterSS_Arg_ss_Code,
        _RegisterSS_Arg_basicService,
        _RegisterSS_Arg_forwardedToNumber,
        _RegisterSS_Arg_forwardedToSubaddress,
        _RegisterSS_Arg_noReplyConditionTime,
        _RegisterSS_Arg_defaultPriority,
        _RegisterSS_Arg_nbrUser,
        _RegisterSS_Arg_longFTN_Supported,
        RegisterSS_Arg,
        NoReplyConditionTime,
        _SS_Info_forwardingInfo,
        _SS_Info_callBarringInfo,
        _SS_Info_ss_Data,
        SS_Info,
        _ForwardingInfo_ss_Code,
        _ForwardingInfo_forwardingFeatureList,
        ForwardingInfo,
        _ForwardingFeatureList__item_,
        ForwardingFeatureList,
        _ForwardingFeature_basicService,
        _ForwardingFeature_ss_Status,
        _ForwardingFeature_forwardedToNumber,
        _ForwardingFeature_forwardedToSubaddress,
        _ForwardingFeature_forwardingOptions,
        _ForwardingFeature_noReplyConditionTime,
        _ForwardingFeature_longForwardedToNumber,
        ForwardingFeature,
        SS_Status,
        ForwardingOptions,
        _CallBarringInfo_ss_Code,
        _CallBarringInfo_callBarringFeatureList,
        CallBarringInfo,
        _CallBarringFeatureList__item_,
        CallBarringFeatureList,
        _CallBarringFeature_basicService,
        _CallBarringFeature_ss_Status,
        CallBarringFeature,
        _SS_Data_ss_Code,
        _SS_Data_ss_Status,
        _SS_Data_ss_SubscriptionOption,
        _SS_Data_basicServiceGroupList,
        _SS_Data_defaultPriority,
        _SS_Data_nbrUser,
        SS_Data,
        _SS_SubscriptionOption_cliRestrictionOption,
        _SS_SubscriptionOption_overrideCategory,
        SS_SubscriptionOption,
        CliRestrictionOption,
        OverrideCategory,
        _SS_ForBS_Code_ss_Code,
        _SS_ForBS_Code_basicService,
        _SS_ForBS_Code_longFTN_Supported,
        SS_ForBS_Code,
        _GenericServiceInfo_ss_Status,
        _GenericServiceInfo_cliRestrictionOption,
        _GenericServiceInfo_maximumEntitledPriority,
        _GenericServiceInfo_defaultPriority,
        _GenericServiceInfo_ccbs_FeatureList,
        _GenericServiceInfo_nbrSB,
        _GenericServiceInfo_nbrUser,
        _GenericServiceInfo_nbrSN,
        GenericServiceInfo,
        _CCBS_FeatureList__item_,
        CCBS_FeatureList,
        maxNumOfCCBS_Requests,
        _CCBS_Feature_ccbs_Index,
        _CCBS_Feature_b_subscriberNumber,
        _CCBS_Feature_b_subscriberSubaddress,
        _CCBS_Feature_basicServiceGroup,
        CCBS_Feature,
        CCBS_Index,
        _InterrogateSS_Res_ss_Status,
        _InterrogateSS_Res_basicServiceGroupList,
        _InterrogateSS_Res_forwardingFeatureList,
        _InterrogateSS_Res_genericServiceInfo,
        InterrogateSS_Res,
        _USSD_Arg_ussd_DataCodingScheme,
        _USSD_Arg_ussd_String,
        _USSD_Arg_alertingPattern,
        _USSD_Arg_msisdn,
        USSD_Arg,
        _USSD_Res_ussd_DataCodingScheme,
        _USSD_Res_ussd_String,
        USSD_Res,
        USSD_DataCodingScheme,
        USSD_String,
        maxUSSD_StringLength,
        Password,
        GuidanceInfo,
        _SS_List__item_,
        SS_List,
        maxNumOfSS,
        _SS_InfoList__item_,
        SS_InfoList,
        _BasicServiceGroupList__item_,
        BasicServiceGroupList,
        maxNumOfBasicServiceGroups,
        _SS_InvocationNotificationArg_imsi,
        _SS_InvocationNotificationArg_msisdn,
        _SS_InvocationNotificationArg_ss_Event,
        _SS_InvocationNotificationArg_ss_EventSpecification,
        _SS_InvocationNotificationArg_extensionContainer,
        _SS_InvocationNotificationArg_b_subscriberNumber,
        _SS_InvocationNotificationArg_ccbs_RequestState,
        SS_InvocationNotificationArg,
        CCBS_RequestState,
        _SS_InvocationNotificationRes_extensionContainer,
        SS_InvocationNotificationRes,
        _SS_EventSpecification__item_,
        SS_EventSpecification,
        maxEventSpecification,
        _RegisterCC_EntryArg_ss_Code,
        _RegisterCC_EntryArg_ccbs_Data,
        RegisterCC_EntryArg,
        _CCBS_Data_ccbs_Feature,
        _CCBS_Data_translatedB_Number,
        _CCBS_Data_serviceIndicator,
        _CCBS_Data_callInfo,
        _CCBS_Data_networkSignalInfo,
        CCBS_Data,
        ServiceIndicator,
        _RegisterCC_EntryRes_ccbs_Feature,
        RegisterCC_EntryRes,
        _EraseCC_EntryArg_ss_Code,
        _EraseCC_EntryArg_ccbs_Index,
        EraseCC_EntryArg,
        _EraseCC_EntryRes_ss_Code,
        _EraseCC_EntryRes_ss_Status,
        EraseCC_EntryRes,
    ]

class MAP_TS_Code:

    _name_  = u'MAP-TS-Code'
    _oid_   = [0, 4, 0, 0, 1, 3, 19, 19]
    
    _obj_ = [
        u'TeleserviceCode',
        u'Ext-TeleserviceCode',
        u'allTeleservices',
        u'allSpeechTransmissionServices',
        u'telephony',
        u'emergencyCalls',
        u'allShortMessageServices',
        u'shortMessageMT-PP',
        u'shortMessageMO-PP',
        u'allFacsimileTransmissionServices',
        u'facsimileGroup3AndAlterSpeech',
        u'automaticFacsimileGroup3',
        u'facsimileGroup4',
        u'allDataTeleservices',
        u'allTeleservices-ExeptSMS',
        u'allVoiceGroupCallServices',
        u'voiceGroupCall',
        u'voiceBroadcastCall',
        u'allPLMN-specificTS',
        u'plmn-specificTS-1',
        u'plmn-specificTS-2',
        u'plmn-specificTS-3',
        u'plmn-specificTS-4',
        u'plmn-specificTS-5',
        u'plmn-specificTS-6',
        u'plmn-specificTS-7',
        u'plmn-specificTS-8',
        u'plmn-specificTS-9',
        u'plmn-specificTS-A',
        u'plmn-specificTS-B',
        u'plmn-specificTS-C',
        u'plmn-specificTS-D',
        u'plmn-specificTS-E',
        u'plmn-specificTS-F',
        ]
    _type_ = [
        u'TeleserviceCode',
        u'Ext-TeleserviceCode',
        ]
    _set_ = [
        ]
    _val_ = [
        u'allTeleservices',
        u'allSpeechTransmissionServices',
        u'telephony',
        u'emergencyCalls',
        u'allShortMessageServices',
        u'shortMessageMT-PP',
        u'shortMessageMO-PP',
        u'allFacsimileTransmissionServices',
        u'facsimileGroup3AndAlterSpeech',
        u'automaticFacsimileGroup3',
        u'facsimileGroup4',
        u'allDataTeleservices',
        u'allTeleservices-ExeptSMS',
        u'allVoiceGroupCallServices',
        u'voiceGroupCall',
        u'voiceBroadcastCall',
        u'allPLMN-specificTS',
        u'plmn-specificTS-1',
        u'plmn-specificTS-2',
        u'plmn-specificTS-3',
        u'plmn-specificTS-4',
        u'plmn-specificTS-5',
        u'plmn-specificTS-6',
        u'plmn-specificTS-7',
        u'plmn-specificTS-8',
        u'plmn-specificTS-9',
        u'plmn-specificTS-A',
        u'plmn-specificTS-B',
        u'plmn-specificTS-C',
        u'plmn-specificTS-D',
        u'plmn-specificTS-E',
        u'plmn-specificTS-F',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< TeleserviceCode >-----#
    TeleserviceCode = OCT_STR(name=u'TeleserviceCode', mode=MODE_TYPE)
    TeleserviceCode._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Ext-TeleserviceCode >-----#
    Ext_TeleserviceCode = OCT_STR(name=u'Ext-TeleserviceCode', mode=MODE_TYPE)
    Ext_TeleserviceCode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    
    #-----< allTeleservices >-----#
    allTeleservices = OCT_STR(name=u'allTeleservices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allTeleservices._val = b'\x00'
    
    #-----< allSpeechTransmissionServices >-----#
    allSpeechTransmissionServices = OCT_STR(name=u'allSpeechTransmissionServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allSpeechTransmissionServices._val = b'\x10'
    
    #-----< telephony >-----#
    telephony = OCT_STR(name=u'telephony', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    telephony._val = b'\x11'
    
    #-----< emergencyCalls >-----#
    emergencyCalls = OCT_STR(name=u'emergencyCalls', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    emergencyCalls._val = b'\x12'
    
    #-----< allShortMessageServices >-----#
    allShortMessageServices = OCT_STR(name=u'allShortMessageServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allShortMessageServices._val = b' '
    
    #-----< shortMessageMT-PP >-----#
    shortMessageMT_PP = OCT_STR(name=u'shortMessageMT-PP', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    shortMessageMT_PP._val = b'!'
    
    #-----< shortMessageMO-PP >-----#
    shortMessageMO_PP = OCT_STR(name=u'shortMessageMO-PP', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    shortMessageMO_PP._val = b'"'
    
    #-----< allFacsimileTransmissionServices >-----#
    allFacsimileTransmissionServices = OCT_STR(name=u'allFacsimileTransmissionServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allFacsimileTransmissionServices._val = b'`'
    
    #-----< facsimileGroup3AndAlterSpeech >-----#
    facsimileGroup3AndAlterSpeech = OCT_STR(name=u'facsimileGroup3AndAlterSpeech', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    facsimileGroup3AndAlterSpeech._val = b'a'
    
    #-----< automaticFacsimileGroup3 >-----#
    automaticFacsimileGroup3 = OCT_STR(name=u'automaticFacsimileGroup3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    automaticFacsimileGroup3._val = b'b'
    
    #-----< facsimileGroup4 >-----#
    facsimileGroup4 = OCT_STR(name=u'facsimileGroup4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    facsimileGroup4._val = b'c'
    
    #-----< allDataTeleservices >-----#
    allDataTeleservices = OCT_STR(name=u'allDataTeleservices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allDataTeleservices._val = b'p'
    
    #-----< allTeleservices-ExeptSMS >-----#
    allTeleservices_ExeptSMS = OCT_STR(name=u'allTeleservices-ExeptSMS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allTeleservices_ExeptSMS._val = b'\x80'
    
    #-----< allVoiceGroupCallServices >-----#
    allVoiceGroupCallServices = OCT_STR(name=u'allVoiceGroupCallServices', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allVoiceGroupCallServices._val = b'\x90'
    
    #-----< voiceGroupCall >-----#
    voiceGroupCall = OCT_STR(name=u'voiceGroupCall', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    voiceGroupCall._val = b'\x91'
    
    #-----< voiceBroadcastCall >-----#
    voiceBroadcastCall = OCT_STR(name=u'voiceBroadcastCall', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    voiceBroadcastCall._val = b'\x92'
    
    #-----< allPLMN-specificTS >-----#
    allPLMN_specificTS = OCT_STR(name=u'allPLMN-specificTS', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    allPLMN_specificTS._val = b'\xd0'
    
    #-----< plmn-specificTS-1 >-----#
    plmn_specificTS_1 = OCT_STR(name=u'plmn-specificTS-1', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_1._val = b'\xd1'
    
    #-----< plmn-specificTS-2 >-----#
    plmn_specificTS_2 = OCT_STR(name=u'plmn-specificTS-2', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_2._val = b'\xd2'
    
    #-----< plmn-specificTS-3 >-----#
    plmn_specificTS_3 = OCT_STR(name=u'plmn-specificTS-3', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_3._val = b'\xd3'
    
    #-----< plmn-specificTS-4 >-----#
    plmn_specificTS_4 = OCT_STR(name=u'plmn-specificTS-4', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_4._val = b'\xd4'
    
    #-----< plmn-specificTS-5 >-----#
    plmn_specificTS_5 = OCT_STR(name=u'plmn-specificTS-5', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_5._val = b'\xd5'
    
    #-----< plmn-specificTS-6 >-----#
    plmn_specificTS_6 = OCT_STR(name=u'plmn-specificTS-6', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_6._val = b'\xd6'
    
    #-----< plmn-specificTS-7 >-----#
    plmn_specificTS_7 = OCT_STR(name=u'plmn-specificTS-7', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_7._val = b'\xd7'
    
    #-----< plmn-specificTS-8 >-----#
    plmn_specificTS_8 = OCT_STR(name=u'plmn-specificTS-8', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_8._val = b'\xd8'
    
    #-----< plmn-specificTS-9 >-----#
    plmn_specificTS_9 = OCT_STR(name=u'plmn-specificTS-9', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_9._val = b'\xd9'
    
    #-----< plmn-specificTS-A >-----#
    plmn_specificTS_A = OCT_STR(name=u'plmn-specificTS-A', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_A._val = b'\xda'
    
    #-----< plmn-specificTS-B >-----#
    plmn_specificTS_B = OCT_STR(name=u'plmn-specificTS-B', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_B._val = b'\xdb'
    
    #-----< plmn-specificTS-C >-----#
    plmn_specificTS_C = OCT_STR(name=u'plmn-specificTS-C', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_C._val = b'\xdc'
    
    #-----< plmn-specificTS-D >-----#
    plmn_specificTS_D = OCT_STR(name=u'plmn-specificTS-D', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_D._val = b'\xdd'
    
    #-----< plmn-specificTS-E >-----#
    plmn_specificTS_E = OCT_STR(name=u'plmn-specificTS-E', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_E._val = b'\xde'
    
    #-----< plmn-specificTS-F >-----#
    plmn_specificTS_F = OCT_STR(name=u'plmn-specificTS-F', mode=MODE_VALUE, typeref=ASN1RefType(('MAP-TS-Code', 'TeleserviceCode')))
    plmn_specificTS_F._val = b'\xdf'
    
    _all_ = [
        TeleserviceCode,
        Ext_TeleserviceCode,
        allTeleservices,
        allSpeechTransmissionServices,
        telephony,
        emergencyCalls,
        allShortMessageServices,
        shortMessageMT_PP,
        shortMessageMO_PP,
        allFacsimileTransmissionServices,
        facsimileGroup3AndAlterSpeech,
        automaticFacsimileGroup3,
        facsimileGroup4,
        allDataTeleservices,
        allTeleservices_ExeptSMS,
        allVoiceGroupCallServices,
        voiceGroupCall,
        voiceBroadcastCall,
        allPLMN_specificTS,
        plmn_specificTS_1,
        plmn_specificTS_2,
        plmn_specificTS_3,
        plmn_specificTS_4,
        plmn_specificTS_5,
        plmn_specificTS_6,
        plmn_specificTS_7,
        plmn_specificTS_8,
        plmn_specificTS_9,
        plmn_specificTS_A,
        plmn_specificTS_B,
        plmn_specificTS_C,
        plmn_specificTS_D,
        plmn_specificTS_E,
        plmn_specificTS_F,
    ]

class MBMSChargingDataTypes:

    _name_  = u'MBMSChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 8, 0, 1]
    
    _obj_ = [
        u'MBMSRecord',
        u'SUBBMSCRecord',
        u'CONTENTBMSCRecord',
        u'MBMSCauseForRecClosing',
        ]
    _type_ = [
        u'MBMSRecord',
        u'SUBBMSCRecord',
        u'CONTENTBMSCRecord',
        u'MBMSCauseForRecClosing',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< MBMSRecord >-----#
    MBMSRecord = CHOICE(name=u'MBMSRecord', mode=MODE_TYPE)
    _MBMSRecord_sUBBMSCRecord = SET(name=u'sUBBMSCRecord', mode=MODE_TYPE, tag=(78, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSChargingDataTypes', 'SUBBMSCRecord')))
    _MBMSRecord_cONTENTBMSCRecord = SET(name=u'cONTENTBMSCRecord', mode=MODE_TYPE, tag=(79, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSChargingDataTypes', 'CONTENTBMSCRecord')))
    MBMSRecord._cont = ASN1Dict([
        (u'sUBBMSCRecord', _MBMSRecord_sUBBMSCRecord),
        (u'cONTENTBMSCRecord', _MBMSRecord_cONTENTBMSCRecord),
        ])
    MBMSRecord._ext = None
    
    #-----< SUBBMSCRecord >-----#
    SUBBMSCRecord = SET(name=u'SUBBMSCRecord', mode=MODE_TYPE)
    _SUBBMSCRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SUBBMSCRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')))
    _SUBBMSCRecord_ggsnAddress = CHOICE(name=u'ggsnAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')), opt=True)
    _SUBBMSCRecord_accessPointNameNI = STR_IA5(name=u'accessPointNameNI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _SUBBMSCRecord_servedPDPAddress = CHOICE(name=u'servedPDPAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _SUBBMSCRecord_listOfTrafficVolumes = SEQ_OF(name=u'listOfTrafficVolumes', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SUBBMSCRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfMBMSCondition')))
    _SUBBMSCRecord_listOfTrafficVolumes._cont = __SUBBMSCRecord_listOfTrafficVolumes__item_
    _SUBBMSCRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SUBBMSCRecord_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _SUBBMSCRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSChargingDataTypes', 'MBMSCauseForRecClosing')))
    _SUBBMSCRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _SUBBMSCRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SUBBMSCRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _SUBBMSCRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _SUBBMSCRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SUBBMSCRecord_servedMSISDN = OCT_STR(name=u'servedMSISDN', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _SUBBMSCRecord_bearerServiceDescription = SEQ(name=u'bearerServiceDescription', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')), opt=True)
    _SUBBMSCRecord_mbmsInformation = SET(name=u'mbmsInformation', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSInformation')), opt=True)
    _SUBBMSCRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    SUBBMSCRecord._cont = ASN1Dict([
        (u'recordType', _SUBBMSCRecord_recordType),
        (u'servedIMSI', _SUBBMSCRecord_servedIMSI),
        (u'ggsnAddress', _SUBBMSCRecord_ggsnAddress),
        (u'accessPointNameNI', _SUBBMSCRecord_accessPointNameNI),
        (u'servedPDPAddress', _SUBBMSCRecord_servedPDPAddress),
        (u'listOfTrafficVolumes', _SUBBMSCRecord_listOfTrafficVolumes),
        (u'recordOpeningTime', _SUBBMSCRecord_recordOpeningTime),
        (u'duration', _SUBBMSCRecord_duration),
        (u'causeForRecClosing', _SUBBMSCRecord_causeForRecClosing),
        (u'diagnostics', _SUBBMSCRecord_diagnostics),
        (u'recordSequenceNumber', _SUBBMSCRecord_recordSequenceNumber),
        (u'nodeID', _SUBBMSCRecord_nodeID),
        (u'recordExtensions', _SUBBMSCRecord_recordExtensions),
        (u'localSequenceNumber', _SUBBMSCRecord_localSequenceNumber),
        (u'servedMSISDN', _SUBBMSCRecord_servedMSISDN),
        (u'bearerServiceDescription', _SUBBMSCRecord_bearerServiceDescription),
        (u'mbmsInformation', _SUBBMSCRecord_mbmsInformation),
        (u'serviceContextID', _SUBBMSCRecord_serviceContextID),
        ])
    SUBBMSCRecord._ext = None
    
    #-----< CONTENTBMSCRecord >-----#
    CONTENTBMSCRecord = SET(name=u'CONTENTBMSCRecord', mode=MODE_TYPE)
    _CONTENTBMSCRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _CONTENTBMSCRecord_contentProviderId = STR_GRAPH(name=u'contentProviderId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CONTENTBMSCRecord_listofDownstreamNodes = SEQ_OF(name=u'listofDownstreamNodes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CONTENTBMSCRecord_listofDownstreamNodes__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _CONTENTBMSCRecord_listofDownstreamNodes._cont = __CONTENTBMSCRecord_listofDownstreamNodes__item_
    _CONTENTBMSCRecord_accessPointNameNI = STR_IA5(name=u'accessPointNameNI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'AccessPointNameNI')), opt=True)
    _CONTENTBMSCRecord_servedPDPAddress = CHOICE(name=u'servedPDPAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _CONTENTBMSCRecord_listOfTrafficVolumes = SEQ_OF(name=u'listOfTrafficVolumes', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CONTENTBMSCRecord_listOfTrafficVolumes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChangeOfMBMSCondition')))
    _CONTENTBMSCRecord_listOfTrafficVolumes._cont = __CONTENTBMSCRecord_listOfTrafficVolumes__item_
    _CONTENTBMSCRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _CONTENTBMSCRecord_duration = INT(name=u'duration', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')))
    _CONTENTBMSCRecord_causeForRecClosing = INT(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MBMSChargingDataTypes', 'MBMSCauseForRecClosing')))
    _CONTENTBMSCRecord_diagnostics = CHOICE(name=u'diagnostics', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Diagnostics')), opt=True)
    _CONTENTBMSCRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CONTENTBMSCRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _CONTENTBMSCRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _CONTENTBMSCRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _CONTENTBMSCRecord_recipientAddressList = SEQ_OF(name=u'recipientAddressList', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CONTENTBMSCRecord_recipientAddressList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')))
    _CONTENTBMSCRecord_recipientAddressList._cont = __CONTENTBMSCRecord_recipientAddressList__item_
    _CONTENTBMSCRecord_bearerServiceDescription = SEQ(name=u'bearerServiceDescription', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')), opt=True)
    _CONTENTBMSCRecord_mbmsInformation = SET(name=u'mbmsInformation', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MBMSInformation')), opt=True)
    _CONTENTBMSCRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _CONTENTBMSCRecord_servedpdpPDNType = OCT_STR(name=u'servedpdpPDNType', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'PDPType')), opt=True)
    CONTENTBMSCRecord._cont = ASN1Dict([
        (u'recordType', _CONTENTBMSCRecord_recordType),
        (u'contentProviderId', _CONTENTBMSCRecord_contentProviderId),
        (u'listofDownstreamNodes', _CONTENTBMSCRecord_listofDownstreamNodes),
        (u'accessPointNameNI', _CONTENTBMSCRecord_accessPointNameNI),
        (u'servedPDPAddress', _CONTENTBMSCRecord_servedPDPAddress),
        (u'listOfTrafficVolumes', _CONTENTBMSCRecord_listOfTrafficVolumes),
        (u'recordOpeningTime', _CONTENTBMSCRecord_recordOpeningTime),
        (u'duration', _CONTENTBMSCRecord_duration),
        (u'causeForRecClosing', _CONTENTBMSCRecord_causeForRecClosing),
        (u'diagnostics', _CONTENTBMSCRecord_diagnostics),
        (u'recordSequenceNumber', _CONTENTBMSCRecord_recordSequenceNumber),
        (u'nodeID', _CONTENTBMSCRecord_nodeID),
        (u'recordExtensions', _CONTENTBMSCRecord_recordExtensions),
        (u'localSequenceNumber', _CONTENTBMSCRecord_localSequenceNumber),
        (u'recipientAddressList', _CONTENTBMSCRecord_recipientAddressList),
        (u'bearerServiceDescription', _CONTENTBMSCRecord_bearerServiceDescription),
        (u'mbmsInformation', _CONTENTBMSCRecord_mbmsInformation),
        (u'serviceContextID', _CONTENTBMSCRecord_serviceContextID),
        (u'servedpdpPDNType', _CONTENTBMSCRecord_servedpdpPDNType),
        ])
    CONTENTBMSCRecord._ext = None
    
    #-----< MBMSCauseForRecClosing >-----#
    MBMSCauseForRecClosing = INT(name=u'MBMSCauseForRecClosing', mode=MODE_TYPE)
    MBMSCauseForRecClosing._cont = ASN1Dict([(u'normalRelease', 0), (u'abnormalRelease', 4), (u'volumeLimit', 16), (u'timeLimit', 17), (u'maxChangeCond', 19), (u'managementIntervention', 20), (u'listofDownstreamNodeChange', 59)])
    
    _all_ = [
        _MBMSRecord_sUBBMSCRecord,
        _MBMSRecord_cONTENTBMSCRecord,
        MBMSRecord,
        _SUBBMSCRecord_recordType,
        _SUBBMSCRecord_servedIMSI,
        _SUBBMSCRecord_ggsnAddress,
        _SUBBMSCRecord_accessPointNameNI,
        _SUBBMSCRecord_servedPDPAddress,
        __SUBBMSCRecord_listOfTrafficVolumes__item_,
        _SUBBMSCRecord_listOfTrafficVolumes,
        _SUBBMSCRecord_recordOpeningTime,
        _SUBBMSCRecord_duration,
        _SUBBMSCRecord_causeForRecClosing,
        _SUBBMSCRecord_diagnostics,
        _SUBBMSCRecord_recordSequenceNumber,
        _SUBBMSCRecord_nodeID,
        _SUBBMSCRecord_recordExtensions,
        _SUBBMSCRecord_localSequenceNumber,
        _SUBBMSCRecord_servedMSISDN,
        _SUBBMSCRecord_bearerServiceDescription,
        _SUBBMSCRecord_mbmsInformation,
        _SUBBMSCRecord_serviceContextID,
        SUBBMSCRecord,
        _CONTENTBMSCRecord_recordType,
        _CONTENTBMSCRecord_contentProviderId,
        __CONTENTBMSCRecord_listofDownstreamNodes__item_,
        _CONTENTBMSCRecord_listofDownstreamNodes,
        _CONTENTBMSCRecord_accessPointNameNI,
        _CONTENTBMSCRecord_servedPDPAddress,
        __CONTENTBMSCRecord_listOfTrafficVolumes__item_,
        _CONTENTBMSCRecord_listOfTrafficVolumes,
        _CONTENTBMSCRecord_recordOpeningTime,
        _CONTENTBMSCRecord_duration,
        _CONTENTBMSCRecord_causeForRecClosing,
        _CONTENTBMSCRecord_diagnostics,
        _CONTENTBMSCRecord_recordSequenceNumber,
        _CONTENTBMSCRecord_nodeID,
        _CONTENTBMSCRecord_recordExtensions,
        _CONTENTBMSCRecord_localSequenceNumber,
        __CONTENTBMSCRecord_recipientAddressList__item_,
        _CONTENTBMSCRecord_recipientAddressList,
        _CONTENTBMSCRecord_bearerServiceDescription,
        _CONTENTBMSCRecord_mbmsInformation,
        _CONTENTBMSCRecord_serviceContextID,
        _CONTENTBMSCRecord_servedpdpPDNType,
        CONTENTBMSCRecord,
        MBMSCauseForRecClosing,
    ]

class MMSChargingDataTypes:

    _name_  = u'MMSChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 5, 0, 1]
    
    _obj_ = [
        u'MMSRecordType',
        u'MMO1SRecord',
        u'MMO4FRqRecord',
        u'MMO4FRsRecord',
        u'MMO4DRecord',
        u'MMO1DRecord',
        u'MMO4RRecord',
        u'MMO1RRecord',
        u'MMOMDRecord',
        u'MMR4FRecord',
        u'MMR1NRqRecord',
        u'MMR1NRsRecord',
        u'MMR1RtRecord',
        u'MMR1ARecord',
        u'MMR4DRqRecord',
        u'MMR4DRsRecord',
        u'MMR1RRRecord',
        u'MMR4RRqRecord',
        u'MMR4RRsRecord',
        u'MMRMDRecord',
        u'MMFRecord',
        u'MMBx1SRecord',
        u'MMBx1VRecord',
        u'MMBx1URecord',
        u'MMBx1DRecord',
        u'MM7SRecord',
        u'MM7DRqRecord',
        u'MM7DRsRecord',
        u'MM7CRecord',
        u'MM7RRecord',
        u'MM7DRRqRecord',
        u'MM7DRRsRecord',
        u'MM7RRqRecord',
        u'MM7RRsRecord',
        u'AccessCorrelation',
        u'AttributesList',
        u'ChargeInformation',
        u'ChargedParty',
        u'ChargeType',
        u'CircuitSwitchedAccess',
        u'ContentType',
        u'DataVolume',
        u'DeltaSeconds',
        u'MediaComponent',
        u'MediaComponents',
        u'MessageSelection',
        u'MMBoxStorageInformation',
        u'MMComponentType',
        u'MMSAgentAddress',
        u'MMSAgentAddresses',
        u'MMSAgentAddressData',
        u'MMSRecipientType',
        u'MMSRSAddress',
        u'MMState',
        u'MMStatusCodeType',
        u'MSCFInformation',
        u'PacketSwitchedAccess',
        u'Quotas',
        u'RequestStatusCodeType',
        u'RouteingAddress',
        u'RouteingAddressList',
        u'StatusTextType',
        u'StoreStatus',
        u'SubjectComponent',
        u'Totals',
        u'WaitTime',
        ]
    _type_ = [
        u'MMSRecordType',
        u'MMO1SRecord',
        u'MMO4FRqRecord',
        u'MMO4FRsRecord',
        u'MMO4DRecord',
        u'MMO1DRecord',
        u'MMO4RRecord',
        u'MMO1RRecord',
        u'MMOMDRecord',
        u'MMR4FRecord',
        u'MMR1NRqRecord',
        u'MMR1NRsRecord',
        u'MMR1RtRecord',
        u'MMR1ARecord',
        u'MMR4DRqRecord',
        u'MMR4DRsRecord',
        u'MMR1RRRecord',
        u'MMR4RRqRecord',
        u'MMR4RRsRecord',
        u'MMRMDRecord',
        u'MMFRecord',
        u'MMBx1SRecord',
        u'MMBx1VRecord',
        u'MMBx1URecord',
        u'MMBx1DRecord',
        u'MM7SRecord',
        u'MM7DRqRecord',
        u'MM7DRsRecord',
        u'MM7CRecord',
        u'MM7RRecord',
        u'MM7DRRqRecord',
        u'MM7DRRsRecord',
        u'MM7RRqRecord',
        u'MM7RRsRecord',
        u'AccessCorrelation',
        u'AttributesList',
        u'ChargeInformation',
        u'ChargedParty',
        u'ChargeType',
        u'CircuitSwitchedAccess',
        u'ContentType',
        u'DataVolume',
        u'DeltaSeconds',
        u'MediaComponent',
        u'MediaComponents',
        u'MessageSelection',
        u'MMBoxStorageInformation',
        u'MMComponentType',
        u'MMSAgentAddress',
        u'MMSAgentAddresses',
        u'MMSAgentAddressData',
        u'MMSRecipientType',
        u'MMSRSAddress',
        u'MMState',
        u'MMStatusCodeType',
        u'MSCFInformation',
        u'PacketSwitchedAccess',
        u'Quotas',
        u'RequestStatusCodeType',
        u'RouteingAddress',
        u'RouteingAddressList',
        u'StatusTextType',
        u'StoreStatus',
        u'SubjectComponent',
        u'Totals',
        u'WaitTime',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< MMSRecordType >-----#
    MMSRecordType = CHOICE(name=u'MMSRecordType', mode=MODE_TYPE)
    _MMSRecordType_mMO1SRecord = SET(name=u'mMO1SRecord', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMO1SRecord')))
    _MMSRecordType_mMO4FRqRecord = SET(name=u'mMO4FRqRecord', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMO4FRqRecord')))
    _MMSRecordType_mMO4FRsRecord = SET(name=u'mMO4FRsRecord', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMO4FRsRecord')))
    _MMSRecordType_mMO4DRecord = SET(name=u'mMO4DRecord', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMO4DRecord')))
    _MMSRecordType_mMO1DRecord = SET(name=u'mMO1DRecord', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMO1DRecord')))
    _MMSRecordType_mMO4RRecord = SET(name=u'mMO4RRecord', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMO4RRecord')))
    _MMSRecordType_mMO1RRecord = SET(name=u'mMO1RRecord', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMO1RRecord')))
    _MMSRecordType_mMOMDRecord = SET(name=u'mMOMDRecord', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMOMDRecord')))
    _MMSRecordType_mMR4FRecord = SET(name=u'mMR4FRecord', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR4FRecord')))
    _MMSRecordType_mMR1NRqRecord = SET(name=u'mMR1NRqRecord', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR1NRqRecord')))
    _MMSRecordType_mMR1NRsRecord = SET(name=u'mMR1NRsRecord', mode=MODE_TYPE, tag=(40, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR1NRsRecord')))
    _MMSRecordType_mMR1RtRqRecord = SET(name=u'mMR1RtRqRecord', mode=MODE_TYPE, tag=(41, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR1RtRecord')))
    _MMSRecordType_mMR1ARecord = SET(name=u'mMR1ARecord', mode=MODE_TYPE, tag=(42, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR1ARecord')))
    _MMSRecordType_mMR4DRqRecord = SET(name=u'mMR4DRqRecord', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR4DRqRecord')))
    _MMSRecordType_mMR4DRsRecord = SET(name=u'mMR4DRsRecord', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR4DRsRecord')))
    _MMSRecordType_mMR1RRRecord = SET(name=u'mMR1RRRecord', mode=MODE_TYPE, tag=(45, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR1RRRecord')))
    _MMSRecordType_mMR4RRqRecord = SET(name=u'mMR4RRqRecord', mode=MODE_TYPE, tag=(46, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR4RRqRecord')))
    _MMSRecordType_mMR4RRsRecord = SET(name=u'mMR4RRsRecord', mode=MODE_TYPE, tag=(47, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMR4RRsRecord')))
    _MMSRecordType_mMRMDRecord = SET(name=u'mMRMDRecord', mode=MODE_TYPE, tag=(48, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMRMDRecord')))
    _MMSRecordType_mMFRecord = SET(name=u'mMFRecord', mode=MODE_TYPE, tag=(49, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMFRecord')))
    _MMSRecordType_mMBx1SRecord = SET(name=u'mMBx1SRecord', mode=MODE_TYPE, tag=(50, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMBx1SRecord')))
    _MMSRecordType_mMBx1VRecord = SET(name=u'mMBx1VRecord', mode=MODE_TYPE, tag=(51, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMBx1VRecord')))
    _MMSRecordType_mMBx1URecord = SET(name=u'mMBx1URecord', mode=MODE_TYPE, tag=(52, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMBx1URecord')))
    _MMSRecordType_mMBx1DRecord = SET(name=u'mMBx1DRecord', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMBx1DRecord')))
    _MMSRecordType_mM7SRecord = SET(name=u'mM7SRecord', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7SRecord')))
    _MMSRecordType_mM7DRqRecord = SET(name=u'mM7DRqRecord', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7DRqRecord')))
    _MMSRecordType_mM7DRsRecord = SET(name=u'mM7DRsRecord', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7DRsRecord')))
    _MMSRecordType_mM7CRecord = SET(name=u'mM7CRecord', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7CRecord')))
    _MMSRecordType_mM7RRecord = SET(name=u'mM7RRecord', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7RRecord')))
    _MMSRecordType_mM7DRRqRecord = SET(name=u'mM7DRRqRecord', mode=MODE_TYPE, tag=(59, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7DRRqRecord')))
    _MMSRecordType_mM7DRRsRecord = SET(name=u'mM7DRRsRecord', mode=MODE_TYPE, tag=(60, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7DRRsRecord')))
    _MMSRecordType_mM7RRqRecord = SET(name=u'mM7RRqRecord', mode=MODE_TYPE, tag=(61, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7RRqRecord')))
    _MMSRecordType_mM7RRsRecord = SET(name=u'mM7RRsRecord', mode=MODE_TYPE, tag=(62, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MM7RRsRecord')))
    MMSRecordType._cont = ASN1Dict([
        (u'mMO1SRecord', _MMSRecordType_mMO1SRecord),
        (u'mMO4FRqRecord', _MMSRecordType_mMO4FRqRecord),
        (u'mMO4FRsRecord', _MMSRecordType_mMO4FRsRecord),
        (u'mMO4DRecord', _MMSRecordType_mMO4DRecord),
        (u'mMO1DRecord', _MMSRecordType_mMO1DRecord),
        (u'mMO4RRecord', _MMSRecordType_mMO4RRecord),
        (u'mMO1RRecord', _MMSRecordType_mMO1RRecord),
        (u'mMOMDRecord', _MMSRecordType_mMOMDRecord),
        (u'mMR4FRecord', _MMSRecordType_mMR4FRecord),
        (u'mMR1NRqRecord', _MMSRecordType_mMR1NRqRecord),
        (u'mMR1NRsRecord', _MMSRecordType_mMR1NRsRecord),
        (u'mMR1RtRqRecord', _MMSRecordType_mMR1RtRqRecord),
        (u'mMR1ARecord', _MMSRecordType_mMR1ARecord),
        (u'mMR4DRqRecord', _MMSRecordType_mMR4DRqRecord),
        (u'mMR4DRsRecord', _MMSRecordType_mMR4DRsRecord),
        (u'mMR1RRRecord', _MMSRecordType_mMR1RRRecord),
        (u'mMR4RRqRecord', _MMSRecordType_mMR4RRqRecord),
        (u'mMR4RRsRecord', _MMSRecordType_mMR4RRsRecord),
        (u'mMRMDRecord', _MMSRecordType_mMRMDRecord),
        (u'mMFRecord', _MMSRecordType_mMFRecord),
        (u'mMBx1SRecord', _MMSRecordType_mMBx1SRecord),
        (u'mMBx1VRecord', _MMSRecordType_mMBx1VRecord),
        (u'mMBx1URecord', _MMSRecordType_mMBx1URecord),
        (u'mMBx1DRecord', _MMSRecordType_mMBx1DRecord),
        (u'mM7SRecord', _MMSRecordType_mM7SRecord),
        (u'mM7DRqRecord', _MMSRecordType_mM7DRqRecord),
        (u'mM7DRsRecord', _MMSRecordType_mM7DRsRecord),
        (u'mM7CRecord', _MMSRecordType_mM7CRecord),
        (u'mM7RRecord', _MMSRecordType_mM7RRecord),
        (u'mM7DRRqRecord', _MMSRecordType_mM7DRRqRecord),
        (u'mM7DRRsRecord', _MMSRecordType_mM7DRRsRecord),
        (u'mM7RRqRecord', _MMSRecordType_mM7RRqRecord),
        (u'mM7RRsRecord', _MMSRecordType_mM7RRsRecord),
        ])
    MMSRecordType._ext = None
    
    #-----< MMO1SRecord >-----#
    MMO1SRecord = SET(name=u'MMO1SRecord', mode=MODE_TYPE)
    _MMO1SRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMO1SRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMO1SRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO1SRecord_replyChargingID = OCT_STR(name=u'replyChargingID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1SRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMO1SRecord_recipientAddresses = SET_OF(name=u'recipientAddresses', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')))
    _MMO1SRecord_accessCorrelation = CHOICE(name=u'accessCorrelation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMO1SRecord_contentType = OCT_STR(name=u'contentType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')))
    _MMO1SRecord_mmComponentType = SEQ(name=u'mmComponentType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMComponentType')), opt=True)
    _MMO1SRecord_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _MMO1SRecord_messageClass = ENUM(name=u'messageClass', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _MMO1SRecord_chargeInformation = SEQ(name=u'chargeInformation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ChargeInformation')), opt=True)
    _MMO1SRecord_submissionTime = OCT_STR(name=u'submissionTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMO1SRecord_timeOfExpiry = CHOICE(name=u'timeOfExpiry', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMO1SRecord_earliestTimeOfDelivery = CHOICE(name=u'earliestTimeOfDelivery', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMO1SRecord_durationOfTransmission = INT(name=u'durationOfTransmission', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1SRecord_requestStatusCode = INT(name=u'requestStatusCode', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MMO1SRecord_deliveryReportRequested = BOOL(name=u'deliveryReportRequested', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1SRecord_replyCharging = BOOL(name=u'replyCharging', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1SRecord_replyDeadline = CHOICE(name=u'replyDeadline', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMO1SRecord_replyChargingSize = INT(name=u'replyChargingSize', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MMO1SRecord_priority = ENUM(name=u'priority', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _MMO1SRecord_senderVisibility = BOOL(name=u'senderVisibility', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1SRecord_readReplyRequested = BOOL(name=u'readReplyRequested', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1SRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')))
    _MMO1SRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MMO1SRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMO1SRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMO1SRecord_mMBoxstorageInformation = SET(name=u'mMBoxstorageInformation', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMBoxStorageInformation')), opt=True)
    _MMO1SRecord_mscfInformation = SET(name=u'mscfInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MSCFInformation')), opt=True)
    _MMO1SRecord_sGSNPLMNIdentifier = OCT_STR(name=u'sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMO1SRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMO1SRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMO1SRecord._cont = ASN1Dict([
        (u'recordType', _MMO1SRecord_recordType),
        (u'originatorMmsRSAddress', _MMO1SRecord_originatorMmsRSAddress),
        (u'messageID', _MMO1SRecord_messageID),
        (u'replyChargingID', _MMO1SRecord_replyChargingID),
        (u'originatorAddress', _MMO1SRecord_originatorAddress),
        (u'recipientAddresses', _MMO1SRecord_recipientAddresses),
        (u'accessCorrelation', _MMO1SRecord_accessCorrelation),
        (u'contentType', _MMO1SRecord_contentType),
        (u'mmComponentType', _MMO1SRecord_mmComponentType),
        (u'messageSize', _MMO1SRecord_messageSize),
        (u'messageClass', _MMO1SRecord_messageClass),
        (u'chargeInformation', _MMO1SRecord_chargeInformation),
        (u'submissionTime', _MMO1SRecord_submissionTime),
        (u'timeOfExpiry', _MMO1SRecord_timeOfExpiry),
        (u'earliestTimeOfDelivery', _MMO1SRecord_earliestTimeOfDelivery),
        (u'durationOfTransmission', _MMO1SRecord_durationOfTransmission),
        (u'requestStatusCode', _MMO1SRecord_requestStatusCode),
        (u'deliveryReportRequested', _MMO1SRecord_deliveryReportRequested),
        (u'replyCharging', _MMO1SRecord_replyCharging),
        (u'replyDeadline', _MMO1SRecord_replyDeadline),
        (u'replyChargingSize', _MMO1SRecord_replyChargingSize),
        (u'priority', _MMO1SRecord_priority),
        (u'senderVisibility', _MMO1SRecord_senderVisibility),
        (u'readReplyRequested', _MMO1SRecord_readReplyRequested),
        (u'statusText', _MMO1SRecord_statusText),
        (u'recordTimeStamp', _MMO1SRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMO1SRecord_localSequenceNumber),
        (u'recordExtensions', _MMO1SRecord_recordExtensions),
        (u'mMBoxstorageInformation', _MMO1SRecord_mMBoxstorageInformation),
        (u'mscfInformation', _MMO1SRecord_mscfInformation),
        (u'sGSNPLMNIdentifier', _MMO1SRecord_sGSNPLMNIdentifier),
        (u'rATType', _MMO1SRecord_rATType),
        (u'mSTimeZone', _MMO1SRecord_mSTimeZone),
        ])
    MMO1SRecord._ext = None
    
    #-----< MMO4FRqRecord >-----#
    MMO4FRqRecord = SET(name=u'MMO4FRqRecord', mode=MODE_TYPE)
    _MMO4FRqRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMO4FRqRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMO4FRqRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMO4FRqRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4FRqRecord_mms3GPPVersion = OCT_STR(name=u'mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO4FRqRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMO4FRqRecord_recipientAddresses = SET_OF(name=u'recipientAddresses', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')))
    _MMO4FRqRecord_contentType = OCT_STR(name=u'contentType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')))
    _MMO4FRqRecord_mmComponentType = SEQ(name=u'mmComponentType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMComponentType')), opt=True)
    _MMO4FRqRecord_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _MMO4FRqRecord_messageClass = ENUM(name=u'messageClass', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _MMO4FRqRecord_submissionTime = OCT_STR(name=u'submissionTime', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MMO4FRqRecord_timeOfExpiry = CHOICE(name=u'timeOfExpiry', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMO4FRqRecord_deliveryReportRequested = BOOL(name=u'deliveryReportRequested', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4FRqRecord_priority = ENUM(name=u'priority', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _MMO4FRqRecord_senderVisibility = BOOL(name=u'senderVisibility', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4FRqRecord_readReplyRequested = BOOL(name=u'readReplyRequested', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4FRqRecord_acknowledgementRequest = BOOL(name=u'acknowledgementRequest', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4FRqRecord_forwardCounter = INT(name=u'forwardCounter', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO4FRqRecord_forwardingAddress = SET_OF(name=u'forwardingAddress', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')), opt=True)
    _MMO4FRqRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MMO4FRqRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMO4FRqRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMO4FRqRecord._cont = ASN1Dict([
        (u'recordType', _MMO4FRqRecord_recordType),
        (u'originatorMmsRSAddress', _MMO4FRqRecord_originatorMmsRSAddress),
        (u'recipientMmsRSAddress', _MMO4FRqRecord_recipientMmsRSAddress),
        (u'messageID', _MMO4FRqRecord_messageID),
        (u'mms3GPPVersion', _MMO4FRqRecord_mms3GPPVersion),
        (u'originatorAddress', _MMO4FRqRecord_originatorAddress),
        (u'recipientAddresses', _MMO4FRqRecord_recipientAddresses),
        (u'contentType', _MMO4FRqRecord_contentType),
        (u'mmComponentType', _MMO4FRqRecord_mmComponentType),
        (u'messageSize', _MMO4FRqRecord_messageSize),
        (u'messageClass', _MMO4FRqRecord_messageClass),
        (u'submissionTime', _MMO4FRqRecord_submissionTime),
        (u'timeOfExpiry', _MMO4FRqRecord_timeOfExpiry),
        (u'deliveryReportRequested', _MMO4FRqRecord_deliveryReportRequested),
        (u'priority', _MMO4FRqRecord_priority),
        (u'senderVisibility', _MMO4FRqRecord_senderVisibility),
        (u'readReplyRequested', _MMO4FRqRecord_readReplyRequested),
        (u'acknowledgementRequest', _MMO4FRqRecord_acknowledgementRequest),
        (u'forwardCounter', _MMO4FRqRecord_forwardCounter),
        (u'forwardingAddress', _MMO4FRqRecord_forwardingAddress),
        (u'recordTimeStamp', _MMO4FRqRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMO4FRqRecord_localSequenceNumber),
        (u'recordExtensions', _MMO4FRqRecord_recordExtensions),
        ])
    MMO4FRqRecord._ext = None
    
    #-----< MMO4FRsRecord >-----#
    MMO4FRsRecord = SET(name=u'MMO4FRsRecord', mode=MODE_TYPE)
    _MMO4FRsRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMO4FRsRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO4FRsRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMO4FRsRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4FRsRecord_mms3GPPVersion = OCT_STR(name=u'mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO4FRsRecord_requestStatusCode = INT(name=u'requestStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MMO4FRsRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMO4FRsRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMO4FRsRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMO4FRsRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMO4FRsRecord._cont = ASN1Dict([
        (u'recordType', _MMO4FRsRecord_recordType),
        (u'originatorMmsRSAddress', _MMO4FRsRecord_originatorMmsRSAddress),
        (u'recipientMmsRSAddress', _MMO4FRsRecord_recipientMmsRSAddress),
        (u'messageID', _MMO4FRsRecord_messageID),
        (u'mms3GPPVersion', _MMO4FRsRecord_mms3GPPVersion),
        (u'requestStatusCode', _MMO4FRsRecord_requestStatusCode),
        (u'statusText', _MMO4FRsRecord_statusText),
        (u'recordTimeStamp', _MMO4FRsRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMO4FRsRecord_localSequenceNumber),
        (u'recordExtensions', _MMO4FRsRecord_recordExtensions),
        ])
    MMO4FRsRecord._ext = None
    
    #-----< MMO4DRecord >-----#
    MMO4DRecord = SET(name=u'MMO4DRecord', mode=MODE_TYPE)
    _MMO4DRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMO4DRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO4DRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO4DRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4DRecord_mms3GPPVersion = OCT_STR(name=u'mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO4DRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MMO4DRecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMO4DRecord_mmDateAndTime = OCT_STR(name=u'mmDateAndTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MMO4DRecord_acknowledgementRequest = BOOL(name=u'acknowledgementRequest', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4DRecord_mmStatusCode = ENUM(name=u'mmStatusCode', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')))
    _MMO4DRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMO4DRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMO4DRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMO4DRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMO4DRecord._cont = ASN1Dict([
        (u'recordType', _MMO4DRecord_recordType),
        (u'recipientMmsRSAddress', _MMO4DRecord_recipientMmsRSAddress),
        (u'originatorMmsRSAddress', _MMO4DRecord_originatorMmsRSAddress),
        (u'messageID', _MMO4DRecord_messageID),
        (u'mms3GPPVersion', _MMO4DRecord_mms3GPPVersion),
        (u'originatorAddress', _MMO4DRecord_originatorAddress),
        (u'recipientAddress', _MMO4DRecord_recipientAddress),
        (u'mmDateAndTime', _MMO4DRecord_mmDateAndTime),
        (u'acknowledgementRequest', _MMO4DRecord_acknowledgementRequest),
        (u'mmStatusCode', _MMO4DRecord_mmStatusCode),
        (u'statusText', _MMO4DRecord_statusText),
        (u'recordTimeStamp', _MMO4DRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMO4DRecord_localSequenceNumber),
        (u'recordExtensions', _MMO4DRecord_recordExtensions),
        ])
    MMO4DRecord._ext = None
    
    #-----< MMO1DRecord >-----#
    MMO1DRecord = SET(name=u'MMO1DRecord', mode=MODE_TYPE)
    _MMO1DRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMO1DRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO1DRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO1DRecord_accessCorrelation = CHOICE(name=u'accessCorrelation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMO1DRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO1DRecord_mms3GPPVersion = OCT_STR(name=u'mms3GPPVersion', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1DRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MMO1DRecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMO1DRecord_mmStatusCode = ENUM(name=u'mmStatusCode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMO1DRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMO1DRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMO1DRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMO1DRecord_sGSNPLMNIdentifier = OCT_STR(name=u'sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMO1DRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMO1DRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMO1DRecord._cont = ASN1Dict([
        (u'recordType', _MMO1DRecord_recordType),
        (u'recipientMmsRSAddress', _MMO1DRecord_recipientMmsRSAddress),
        (u'originatorMmsRSAddress', _MMO1DRecord_originatorMmsRSAddress),
        (u'accessCorrelation', _MMO1DRecord_accessCorrelation),
        (u'messageID', _MMO1DRecord_messageID),
        (u'mms3GPPVersion', _MMO1DRecord_mms3GPPVersion),
        (u'originatorAddress', _MMO1DRecord_originatorAddress),
        (u'recipientAddress', _MMO1DRecord_recipientAddress),
        (u'mmStatusCode', _MMO1DRecord_mmStatusCode),
        (u'recordTimeStamp', _MMO1DRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMO1DRecord_localSequenceNumber),
        (u'recordExtensions', _MMO1DRecord_recordExtensions),
        (u'sGSNPLMNIdentifier', _MMO1DRecord_sGSNPLMNIdentifier),
        (u'rATType', _MMO1DRecord_rATType),
        (u'mSTimeZone', _MMO1DRecord_mSTimeZone),
        ])
    MMO1DRecord._ext = None
    
    #-----< MMO4RRecord >-----#
    MMO4RRecord = SET(name=u'MMO4RRecord', mode=MODE_TYPE)
    _MMO4RRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMO4RRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO4RRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO4RRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4RRecord_mms3GPPVersion = OCT_STR(name=u'mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO4RRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MMO4RRecord_recipientAddresses = SET_OF(name=u'recipientAddresses', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')), opt=True)
    _MMO4RRecord_mmDateAndTime = OCT_STR(name=u'mmDateAndTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMO4RRecord_acknowledgementRequest = BOOL(name=u'acknowledgementRequest', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO4RRecord_readStatus = ENUM(name=u'readStatus', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMO4RRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMO4RRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMO4RRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMO4RRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMO4RRecord._cont = ASN1Dict([
        (u'recordType', _MMO4RRecord_recordType),
        (u'recipientMmsRSAddress', _MMO4RRecord_recipientMmsRSAddress),
        (u'originatorMmsRSAddress', _MMO4RRecord_originatorMmsRSAddress),
        (u'messageID', _MMO4RRecord_messageID),
        (u'mms3GPPVersion', _MMO4RRecord_mms3GPPVersion),
        (u'originatorAddress', _MMO4RRecord_originatorAddress),
        (u'recipientAddresses', _MMO4RRecord_recipientAddresses),
        (u'mmDateAndTime', _MMO4RRecord_mmDateAndTime),
        (u'acknowledgementRequest', _MMO4RRecord_acknowledgementRequest),
        (u'readStatus', _MMO4RRecord_readStatus),
        (u'statusText', _MMO4RRecord_statusText),
        (u'recordTimeStamp', _MMO4RRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMO4RRecord_localSequenceNumber),
        (u'recordExtensions', _MMO4RRecord_recordExtensions),
        ])
    MMO4RRecord._ext = None
    
    #-----< MMO1RRecord >-----#
    MMO1RRecord = SET(name=u'MMO1RRecord', mode=MODE_TYPE)
    _MMO1RRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMO1RRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO1RRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMO1RRecord_accessCorrelation = CHOICE(name=u'accessCorrelation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMO1RRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMO1RRecord_mms3GPPVersion = OCT_STR(name=u'mms3GPPVersion', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMO1RRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MMO1RRecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MMO1RRecord_readStatus = ENUM(name=u'readStatus', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMO1RRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMO1RRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMO1RRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMO1RRecord_sGSNPLMNIdentifier = OCT_STR(name=u'sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMO1RRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMO1RRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMO1RRecord._cont = ASN1Dict([
        (u'recordType', _MMO1RRecord_recordType),
        (u'recipientMmsRSAddress', _MMO1RRecord_recipientMmsRSAddress),
        (u'originatorMmsRSAddress', _MMO1RRecord_originatorMmsRSAddress),
        (u'accessCorrelation', _MMO1RRecord_accessCorrelation),
        (u'messageID', _MMO1RRecord_messageID),
        (u'mms3GPPVersion', _MMO1RRecord_mms3GPPVersion),
        (u'originatorAddress', _MMO1RRecord_originatorAddress),
        (u'recipientAddress', _MMO1RRecord_recipientAddress),
        (u'readStatus', _MMO1RRecord_readStatus),
        (u'recordTimeStamp', _MMO1RRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMO1RRecord_localSequenceNumber),
        (u'recordExtensions', _MMO1RRecord_recordExtensions),
        (u'sGSNPLMNIdentifier', _MMO1RRecord_sGSNPLMNIdentifier),
        (u'rATType', _MMO1RRecord_rATType),
        (u'mSTimeZone', _MMO1RRecord_mSTimeZone),
        ])
    MMO1RRecord._ext = None
    
    #-----< MMOMDRecord >-----#
    MMOMDRecord = SET(name=u'MMOMDRecord', mode=MODE_TYPE)
    _MMOMDRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMOMDRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMOMDRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMOMDRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMOMDRecord_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MMOMDRecord_mmStatusCode = ENUM(name=u'mmStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMOMDRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMOMDRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMOMDRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMOMDRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMOMDRecord._cont = ASN1Dict([
        (u'recordType', _MMOMDRecord_recordType),
        (u'originatorMmsRSAddress', _MMOMDRecord_originatorMmsRSAddress),
        (u'recipientMmsRSAddress', _MMOMDRecord_recipientMmsRSAddress),
        (u'messageID', _MMOMDRecord_messageID),
        (u'messageSize', _MMOMDRecord_messageSize),
        (u'mmStatusCode', _MMOMDRecord_mmStatusCode),
        (u'statusText', _MMOMDRecord_statusText),
        (u'recordTimeStamp', _MMOMDRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMOMDRecord_localSequenceNumber),
        (u'recordExtensions', _MMOMDRecord_recordExtensions),
        ])
    MMOMDRecord._ext = None
    
    #-----< MMR4FRecord >-----#
    MMR4FRecord = SET(name=u'MMR4FRecord', mode=MODE_TYPE)
    _MMR4FRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR4FRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4FRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4FRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4FRecord_mms3GPPVersion = OCT_STR(name=u'mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR4FRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR4FRecord_recipientAddresses = SET_OF(name=u'recipientAddresses', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')))
    _MMR4FRecord_contentType = OCT_STR(name=u'contentType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')))
    _MMR4FRecord_mmComponentType = SEQ(name=u'mmComponentType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMComponentType')), opt=True)
    _MMR4FRecord_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _MMR4FRecord_messageClass = ENUM(name=u'messageClass', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _MMR4FRecord_submissionTime = OCT_STR(name=u'submissionTime', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MMR4FRecord_timeOfExpiry = CHOICE(name=u'timeOfExpiry', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMR4FRecord_deliveryReportRequested = BOOL(name=u'deliveryReportRequested', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4FRecord_priority = ENUM(name=u'priority', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _MMR4FRecord_senderVisibility = BOOL(name=u'senderVisibility', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4FRecord_readReplyRequested = BOOL(name=u'readReplyRequested', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4FRecord_requestStatusCode = INT(name=u'requestStatusCode', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')))
    _MMR4FRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')))
    _MMR4FRecord_acknowledgementRequest = BOOL(name=u'acknowledgementRequest', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4FRecord_forwardCounter = INT(name=u'forwardCounter', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR4FRecord_forwardingAddress = SET_OF(name=u'forwardingAddress', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')), opt=True)
    _MMR4FRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MMR4FRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR4FRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMR4FRecord._cont = ASN1Dict([
        (u'recordType', _MMR4FRecord_recordType),
        (u'recipientMmsRSAddress', _MMR4FRecord_recipientMmsRSAddress),
        (u'originatorMmsRSAddress', _MMR4FRecord_originatorMmsRSAddress),
        (u'messageID', _MMR4FRecord_messageID),
        (u'mms3GPPVersion', _MMR4FRecord_mms3GPPVersion),
        (u'originatorAddress', _MMR4FRecord_originatorAddress),
        (u'recipientAddresses', _MMR4FRecord_recipientAddresses),
        (u'contentType', _MMR4FRecord_contentType),
        (u'mmComponentType', _MMR4FRecord_mmComponentType),
        (u'messageSize', _MMR4FRecord_messageSize),
        (u'messageClass', _MMR4FRecord_messageClass),
        (u'submissionTime', _MMR4FRecord_submissionTime),
        (u'timeOfExpiry', _MMR4FRecord_timeOfExpiry),
        (u'deliveryReportRequested', _MMR4FRecord_deliveryReportRequested),
        (u'priority', _MMR4FRecord_priority),
        (u'senderVisibility', _MMR4FRecord_senderVisibility),
        (u'readReplyRequested', _MMR4FRecord_readReplyRequested),
        (u'requestStatusCode', _MMR4FRecord_requestStatusCode),
        (u'statusText', _MMR4FRecord_statusText),
        (u'acknowledgementRequest', _MMR4FRecord_acknowledgementRequest),
        (u'forwardCounter', _MMR4FRecord_forwardCounter),
        (u'forwardingAddress', _MMR4FRecord_forwardingAddress),
        (u'recordTimeStamp', _MMR4FRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMR4FRecord_localSequenceNumber),
        (u'recordExtensions', _MMR4FRecord_recordExtensions),
        ])
    MMR4FRecord._ext = None
    
    #-----< MMR1NRqRecord >-----#
    MMR1NRqRecord = SET(name=u'MMR1NRqRecord', mode=MODE_TYPE)
    _MMR1NRqRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR1NRqRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR1NRqRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR1NRqRecord_replyChargingID = OCT_STR(name=u'replyChargingID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1NRqRecord_senderAddress = SEQ(name=u'senderAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR1NRqRecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR1NRqRecord_accessCorrelation = CHOICE(name=u'accessCorrelation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMR1NRqRecord_messageClass = ENUM(name=u'messageClass', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _MMR1NRqRecord_mmComponentType = SEQ(name=u'mmComponentType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMComponentType')), opt=True)
    _MMR1NRqRecord_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _MMR1NRqRecord_timeOfExpiry = CHOICE(name=u'timeOfExpiry', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMR1NRqRecord_messageReference = OCT_STR(name=u'messageReference', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR1NRqRecord_deliveryReportRequested = BOOL(name=u'deliveryReportRequested', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1NRqRecord_replyCharging = BOOL(name=u'replyCharging', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1NRqRecord_replyDeadline = CHOICE(name=u'replyDeadline', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMR1NRqRecord_replyChargingSize = INT(name=u'replyChargingSize', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MMR1NRqRecord_mmStatusCode = ENUM(name=u'mmStatusCode', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMR1NRqRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR1NRqRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR1NRqRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR1NRqRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMR1NRqRecord_mscfInformation = SET(name=u'mscfInformation', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MSCFInformation')), opt=True)
    _MMR1NRqRecord_vaspID = OCT_STR(name=u'vaspID', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1NRqRecord_vasID = OCT_STR(name=u'vasID', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1NRqRecord_sGSNPLMNIdentifier = OCT_STR(name=u'sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMR1NRqRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMR1NRqRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMR1NRqRecord._cont = ASN1Dict([
        (u'recordType', _MMR1NRqRecord_recordType),
        (u'recipientMmsRSAddress', _MMR1NRqRecord_recipientMmsRSAddress),
        (u'messageID', _MMR1NRqRecord_messageID),
        (u'replyChargingID', _MMR1NRqRecord_replyChargingID),
        (u'senderAddress', _MMR1NRqRecord_senderAddress),
        (u'recipientAddress', _MMR1NRqRecord_recipientAddress),
        (u'accessCorrelation', _MMR1NRqRecord_accessCorrelation),
        (u'messageClass', _MMR1NRqRecord_messageClass),
        (u'mmComponentType', _MMR1NRqRecord_mmComponentType),
        (u'messageSize', _MMR1NRqRecord_messageSize),
        (u'timeOfExpiry', _MMR1NRqRecord_timeOfExpiry),
        (u'messageReference', _MMR1NRqRecord_messageReference),
        (u'deliveryReportRequested', _MMR1NRqRecord_deliveryReportRequested),
        (u'replyCharging', _MMR1NRqRecord_replyCharging),
        (u'replyDeadline', _MMR1NRqRecord_replyDeadline),
        (u'replyChargingSize', _MMR1NRqRecord_replyChargingSize),
        (u'mmStatusCode', _MMR1NRqRecord_mmStatusCode),
        (u'statusText', _MMR1NRqRecord_statusText),
        (u'recordTimeStamp', _MMR1NRqRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMR1NRqRecord_localSequenceNumber),
        (u'recordExtensions', _MMR1NRqRecord_recordExtensions),
        (u'mscfInformation', _MMR1NRqRecord_mscfInformation),
        (u'vaspID', _MMR1NRqRecord_vaspID),
        (u'vasID', _MMR1NRqRecord_vasID),
        (u'sGSNPLMNIdentifier', _MMR1NRqRecord_sGSNPLMNIdentifier),
        (u'rATType', _MMR1NRqRecord_rATType),
        (u'mSTimeZone', _MMR1NRqRecord_mSTimeZone),
        ])
    MMR1NRqRecord._ext = None
    
    #-----< MMR1NRsRecord >-----#
    MMR1NRsRecord = SET(name=u'MMR1NRsRecord', mode=MODE_TYPE)
    _MMR1NRsRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR1NRsRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR1NRsRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR1NRsRecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR1NRsRecord_accessCorrelation = CHOICE(name=u'accessCorrelation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMR1NRsRecord_reportAllowed = BOOL(name=u'reportAllowed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1NRsRecord_mmStatusCode = ENUM(name=u'mmStatusCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMR1NRsRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR1NRsRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR1NRsRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR1NRsRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMR1NRsRecord_sGSNPLMNIdentifier = OCT_STR(name=u'sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMR1NRsRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMR1NRsRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMR1NRsRecord._cont = ASN1Dict([
        (u'recordType', _MMR1NRsRecord_recordType),
        (u'recipientMmsRSAddress', _MMR1NRsRecord_recipientMmsRSAddress),
        (u'messageID', _MMR1NRsRecord_messageID),
        (u'recipientAddress', _MMR1NRsRecord_recipientAddress),
        (u'accessCorrelation', _MMR1NRsRecord_accessCorrelation),
        (u'reportAllowed', _MMR1NRsRecord_reportAllowed),
        (u'mmStatusCode', _MMR1NRsRecord_mmStatusCode),
        (u'statusText', _MMR1NRsRecord_statusText),
        (u'recordTimeStamp', _MMR1NRsRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMR1NRsRecord_localSequenceNumber),
        (u'recordExtensions', _MMR1NRsRecord_recordExtensions),
        (u'sGSNPLMNIdentifier', _MMR1NRsRecord_sGSNPLMNIdentifier),
        (u'rATType', _MMR1NRsRecord_rATType),
        (u'mSTimeZone', _MMR1NRsRecord_mSTimeZone),
        ])
    MMR1NRsRecord._ext = None
    
    #-----< MMR1RtRecord >-----#
    MMR1RtRecord = SET(name=u'MMR1RtRecord', mode=MODE_TYPE)
    _MMR1RtRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR1RtRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR1RtRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR1RtRecord_replyChargingID = OCT_STR(name=u'replyChargingID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1RtRecord_senderAddress = SEQ(name=u'senderAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MMR1RtRecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR1RtRecord_accessCorrelation = CHOICE(name=u'accessCorrelation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMR1RtRecord_contentType = OCT_STR(name=u'contentType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')))
    _MMR1RtRecord_mmComponentType = SEQ(name=u'mmComponentType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMComponentType')), opt=True)
    _MMR1RtRecord_messageClass = ENUM(name=u'messageClass', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _MMR1RtRecord_submissionTime = OCT_STR(name=u'submissionTime', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MMR1RtRecord_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MMR1RtRecord_deliveryReportRequested = BOOL(name=u'deliveryReportRequested', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1RtRecord_priority = ENUM(name=u'priority', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _MMR1RtRecord_readReplyRequested = BOOL(name=u'readReplyRequested', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1RtRecord_mmStatusCode = ENUM(name=u'mmStatusCode', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMR1RtRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR1RtRecord_replyDeadline = CHOICE(name=u'replyDeadline', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMR1RtRecord_replyChargingSize = INT(name=u'replyChargingSize', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MMR1RtRecord_durationOfTransmission = INT(name=u'durationOfTransmission', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1RtRecord_timeOfExpiry = CHOICE(name=u'timeOfExpiry', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMR1RtRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR1RtRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR1RtRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMR1RtRecord_messageReference = OCT_STR(name=u'messageReference', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR1RtRecord_vaspID = OCT_STR(name=u'vaspID', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1RtRecord_vasID = OCT_STR(name=u'vasID', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1RtRecord_sGSNPLMNIdentifier = OCT_STR(name=u'sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMR1RtRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMR1RtRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMR1RtRecord._cont = ASN1Dict([
        (u'recordType', _MMR1RtRecord_recordType),
        (u'recipientMmsRSAddress', _MMR1RtRecord_recipientMmsRSAddress),
        (u'messageID', _MMR1RtRecord_messageID),
        (u'replyChargingID', _MMR1RtRecord_replyChargingID),
        (u'senderAddress', _MMR1RtRecord_senderAddress),
        (u'recipientAddress', _MMR1RtRecord_recipientAddress),
        (u'accessCorrelation', _MMR1RtRecord_accessCorrelation),
        (u'contentType', _MMR1RtRecord_contentType),
        (u'mmComponentType', _MMR1RtRecord_mmComponentType),
        (u'messageClass', _MMR1RtRecord_messageClass),
        (u'submissionTime', _MMR1RtRecord_submissionTime),
        (u'messageSize', _MMR1RtRecord_messageSize),
        (u'deliveryReportRequested', _MMR1RtRecord_deliveryReportRequested),
        (u'priority', _MMR1RtRecord_priority),
        (u'readReplyRequested', _MMR1RtRecord_readReplyRequested),
        (u'mmStatusCode', _MMR1RtRecord_mmStatusCode),
        (u'statusText', _MMR1RtRecord_statusText),
        (u'replyDeadline', _MMR1RtRecord_replyDeadline),
        (u'replyChargingSize', _MMR1RtRecord_replyChargingSize),
        (u'durationOfTransmission', _MMR1RtRecord_durationOfTransmission),
        (u'timeOfExpiry', _MMR1RtRecord_timeOfExpiry),
        (u'recordTimeStamp', _MMR1RtRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMR1RtRecord_localSequenceNumber),
        (u'recordExtensions', _MMR1RtRecord_recordExtensions),
        (u'messageReference', _MMR1RtRecord_messageReference),
        (u'vaspID', _MMR1RtRecord_vaspID),
        (u'vasID', _MMR1RtRecord_vasID),
        (u'sGSNPLMNIdentifier', _MMR1RtRecord_sGSNPLMNIdentifier),
        (u'rATType', _MMR1RtRecord_rATType),
        (u'mSTimeZone', _MMR1RtRecord_mSTimeZone),
        ])
    MMR1RtRecord._ext = None
    
    #-----< MMR1ARecord >-----#
    MMR1ARecord = SET(name=u'MMR1ARecord', mode=MODE_TYPE)
    _MMR1ARecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR1ARecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR1ARecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR1ARecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR1ARecord_accessCorrelation = CHOICE(name=u'accessCorrelation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMR1ARecord_reportAllowed = BOOL(name=u'reportAllowed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR1ARecord_mmStatusCode = ENUM(name=u'mmStatusCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMR1ARecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR1ARecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR1ARecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR1ARecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMR1ARecord_sGSNPLMNIdentifier = OCT_STR(name=u'sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMR1ARecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMR1ARecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMR1ARecord._cont = ASN1Dict([
        (u'recordType', _MMR1ARecord_recordType),
        (u'recipientMmsRSAddress', _MMR1ARecord_recipientMmsRSAddress),
        (u'messageID', _MMR1ARecord_messageID),
        (u'recipientAddress', _MMR1ARecord_recipientAddress),
        (u'accessCorrelation', _MMR1ARecord_accessCorrelation),
        (u'reportAllowed', _MMR1ARecord_reportAllowed),
        (u'mmStatusCode', _MMR1ARecord_mmStatusCode),
        (u'statusText', _MMR1ARecord_statusText),
        (u'recordTimeStamp', _MMR1ARecord_recordTimeStamp),
        (u'localSequenceNumber', _MMR1ARecord_localSequenceNumber),
        (u'recordExtensions', _MMR1ARecord_recordExtensions),
        (u'sGSNPLMNIdentifier', _MMR1ARecord_sGSNPLMNIdentifier),
        (u'rATType', _MMR1ARecord_rATType),
        (u'mSTimeZone', _MMR1ARecord_mSTimeZone),
        ])
    MMR1ARecord._ext = None
    
    #-----< MMR4DRqRecord >-----#
    MMR4DRqRecord = SET(name=u'MMR4DRqRecord', mode=MODE_TYPE)
    _MMR4DRqRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR4DRqRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4DRqRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4DRqRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4DRqRecord_mms3GPPVersion = OCT_STR(name=u'mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR4DRqRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR4DRqRecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR4DRqRecord_mmDateAndTime = OCT_STR(name=u'mmDateAndTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR4DRqRecord_acknowledgementRequest = BOOL(name=u'acknowledgementRequest', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4DRqRecord_mmStatusCode = ENUM(name=u'mmStatusCode', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMR4DRqRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR4DRqRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR4DRqRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR4DRqRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMR4DRqRecord._cont = ASN1Dict([
        (u'recordType', _MMR4DRqRecord_recordType),
        (u'recipientMmsRSAddress', _MMR4DRqRecord_recipientMmsRSAddress),
        (u'originatorMmsRSAddress', _MMR4DRqRecord_originatorMmsRSAddress),
        (u'messageID', _MMR4DRqRecord_messageID),
        (u'mms3GPPVersion', _MMR4DRqRecord_mms3GPPVersion),
        (u'originatorAddress', _MMR4DRqRecord_originatorAddress),
        (u'recipientAddress', _MMR4DRqRecord_recipientAddress),
        (u'mmDateAndTime', _MMR4DRqRecord_mmDateAndTime),
        (u'acknowledgementRequest', _MMR4DRqRecord_acknowledgementRequest),
        (u'mmStatusCode', _MMR4DRqRecord_mmStatusCode),
        (u'statusText', _MMR4DRqRecord_statusText),
        (u'recordTimeStamp', _MMR4DRqRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMR4DRqRecord_localSequenceNumber),
        (u'recordExtensions', _MMR4DRqRecord_recordExtensions),
        ])
    MMR4DRqRecord._ext = None
    
    #-----< MMR4DRsRecord >-----#
    MMR4DRsRecord = SET(name=u'MMR4DRsRecord', mode=MODE_TYPE)
    _MMR4DRsRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR4DRsRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4DRsRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4DRsRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4DRsRecord_mms3GPPVersion = OCT_STR(name=u'mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR4DRsRecord_requestStatusCode = INT(name=u'requestStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MMR4DRsRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR4DRsRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR4DRsRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR4DRsRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMR4DRsRecord._cont = ASN1Dict([
        (u'recordType', _MMR4DRsRecord_recordType),
        (u'recipientMmsRSAddress', _MMR4DRsRecord_recipientMmsRSAddress),
        (u'originatorMmsRSAddress', _MMR4DRsRecord_originatorMmsRSAddress),
        (u'messageID', _MMR4DRsRecord_messageID),
        (u'mms3GPPVersion', _MMR4DRsRecord_mms3GPPVersion),
        (u'requestStatusCode', _MMR4DRsRecord_requestStatusCode),
        (u'statusText', _MMR4DRsRecord_statusText),
        (u'recordTimeStamp', _MMR4DRsRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMR4DRsRecord_localSequenceNumber),
        (u'recordExtensions', _MMR4DRsRecord_recordExtensions),
        ])
    MMR4DRsRecord._ext = None
    
    #-----< MMR1RRRecord >-----#
    MMR1RRRecord = SET(name=u'MMR1RRRecord', mode=MODE_TYPE)
    _MMR1RRRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR1RRRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR1RRRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR1RRRecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR1RRRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR1RRRecord_accessCorrelation = CHOICE(name=u'accessCorrelation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMR1RRRecord_mmStatusCode = ENUM(name=u'mmStatusCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMR1RRRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR1RRRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR1RRRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR1RRRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMR1RRRecord_sGSNPLMNIdentifier = OCT_STR(name=u'sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMR1RRRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMR1RRRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMR1RRRecord._cont = ASN1Dict([
        (u'recordType', _MMR1RRRecord_recordType),
        (u'recipientMmsRSAddress', _MMR1RRRecord_recipientMmsRSAddress),
        (u'messageID', _MMR1RRRecord_messageID),
        (u'recipientAddress', _MMR1RRRecord_recipientAddress),
        (u'originatorAddress', _MMR1RRRecord_originatorAddress),
        (u'accessCorrelation', _MMR1RRRecord_accessCorrelation),
        (u'mmStatusCode', _MMR1RRRecord_mmStatusCode),
        (u'statusText', _MMR1RRRecord_statusText),
        (u'recordTimeStamp', _MMR1RRRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMR1RRRecord_localSequenceNumber),
        (u'recordExtensions', _MMR1RRRecord_recordExtensions),
        (u'sGSNPLMNIdentifier', _MMR1RRRecord_sGSNPLMNIdentifier),
        (u'rATType', _MMR1RRRecord_rATType),
        (u'mSTimeZone', _MMR1RRRecord_mSTimeZone),
        ])
    MMR1RRRecord._ext = None
    
    #-----< MMR4RRqRecord >-----#
    MMR4RRqRecord = SET(name=u'MMR4RRqRecord', mode=MODE_TYPE)
    _MMR4RRqRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR4RRqRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4RRqRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4RRqRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4RRqRecord_mms3GPPVersion = OCT_STR(name=u'mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR4RRqRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR4RRqRecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMR4RRqRecord_mmDateAndTime = OCT_STR(name=u'mmDateAndTime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR4RRqRecord_acknowledgementRequest = BOOL(name=u'acknowledgementRequest', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4RRqRecord_mmStatusCode = ENUM(name=u'mmStatusCode', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMR4RRqRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR4RRqRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR4RRqRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR4RRqRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMR4RRqRecord._cont = ASN1Dict([
        (u'recordType', _MMR4RRqRecord_recordType),
        (u'recipientMmsRSAddress', _MMR4RRqRecord_recipientMmsRSAddress),
        (u'originatorMmsRSAddress', _MMR4RRqRecord_originatorMmsRSAddress),
        (u'messageID', _MMR4RRqRecord_messageID),
        (u'mms3GPPVersion', _MMR4RRqRecord_mms3GPPVersion),
        (u'originatorAddress', _MMR4RRqRecord_originatorAddress),
        (u'recipientAddress', _MMR4RRqRecord_recipientAddress),
        (u'mmDateAndTime', _MMR4RRqRecord_mmDateAndTime),
        (u'acknowledgementRequest', _MMR4RRqRecord_acknowledgementRequest),
        (u'mmStatusCode', _MMR4RRqRecord_mmStatusCode),
        (u'statusText', _MMR4RRqRecord_statusText),
        (u'recordTimeStamp', _MMR4RRqRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMR4RRqRecord_localSequenceNumber),
        (u'recordExtensions', _MMR4RRqRecord_recordExtensions),
        ])
    MMR4RRqRecord._ext = None
    
    #-----< MMR4RRsRecord >-----#
    MMR4RRsRecord = SET(name=u'MMR4RRsRecord', mode=MODE_TYPE)
    _MMR4RRsRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMR4RRsRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4RRsRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMR4RRsRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMR4RRsRecord_mms3GPPVersion = OCT_STR(name=u'mms3GPPVersion', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMR4RRsRecord_requestStatusCode = INT(name=u'requestStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MMR4RRsRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMR4RRsRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMR4RRsRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMR4RRsRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMR4RRsRecord._cont = ASN1Dict([
        (u'recordType', _MMR4RRsRecord_recordType),
        (u'recipientMmsRSAddress', _MMR4RRsRecord_recipientMmsRSAddress),
        (u'originatorMmsRSAddress', _MMR4RRsRecord_originatorMmsRSAddress),
        (u'messageID', _MMR4RRsRecord_messageID),
        (u'mms3GPPVersion', _MMR4RRsRecord_mms3GPPVersion),
        (u'requestStatusCode', _MMR4RRsRecord_requestStatusCode),
        (u'statusText', _MMR4RRsRecord_statusText),
        (u'recordTimeStamp', _MMR4RRsRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMR4RRsRecord_localSequenceNumber),
        (u'recordExtensions', _MMR4RRsRecord_recordExtensions),
        ])
    MMR4RRsRecord._ext = None
    
    #-----< MMRMDRecord >-----#
    MMRMDRecord = SET(name=u'MMRMDRecord', mode=MODE_TYPE)
    _MMRMDRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMRMDRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMRMDRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MMRMDRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMRMDRecord_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _MMRMDRecord_mmStatusCode = ENUM(name=u'mmStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMRMDRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMRMDRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMRMDRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMRMDRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MMRMDRecord._cont = ASN1Dict([
        (u'recordType', _MMRMDRecord_recordType),
        (u'originatorMmsRSAddress', _MMRMDRecord_originatorMmsRSAddress),
        (u'recipientMmsRSAddress', _MMRMDRecord_recipientMmsRSAddress),
        (u'messageID', _MMRMDRecord_messageID),
        (u'messageSize', _MMRMDRecord_messageSize),
        (u'mmStatusCode', _MMRMDRecord_mmStatusCode),
        (u'statusText', _MMRMDRecord_statusText),
        (u'recordTimeStamp', _MMRMDRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMRMDRecord_localSequenceNumber),
        (u'recordExtensions', _MMRMDRecord_recordExtensions),
        ])
    MMRMDRecord._ext = None
    
    #-----< MMFRecord >-----#
    MMFRecord = SET(name=u'MMFRecord', mode=MODE_TYPE)
    _MMFRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMFRecord_forwardingMmsRSAddress = SEQ(name=u'forwardingMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MMFRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMFRecord_forwardingAddress = SEQ(name=u'forwardingAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMFRecord_recipientAddresses = SET_OF(name=u'recipientAddresses', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')))
    _MMFRecord_chargeInformation = SEQ(name=u'chargeInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ChargeInformation')), opt=True)
    _MMFRecord_timeOfExpiry = CHOICE(name=u'timeOfExpiry', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMFRecord_earliestTimeOfDelivery = CHOICE(name=u'earliestTimeOfDelivery', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMFRecord_deliveryReportRequested = BOOL(name=u'deliveryReportRequested', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMFRecord_readReplyRequested = BOOL(name=u'readReplyRequested', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMFRecord_messageReference = OCT_STR(name=u'messageReference', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMFRecord_mmStatusCode = ENUM(name=u'mmStatusCode', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')), opt=True)
    _MMFRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMFRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMFRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMFRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMFRecord_mMBoxstorageInformation = SET(name=u'mMBoxstorageInformation', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMBoxStorageInformation')), opt=True)
    MMFRecord._cont = ASN1Dict([
        (u'recordType', _MMFRecord_recordType),
        (u'forwardingMmsRSAddress', _MMFRecord_forwardingMmsRSAddress),
        (u'messageID', _MMFRecord_messageID),
        (u'forwardingAddress', _MMFRecord_forwardingAddress),
        (u'recipientAddresses', _MMFRecord_recipientAddresses),
        (u'chargeInformation', _MMFRecord_chargeInformation),
        (u'timeOfExpiry', _MMFRecord_timeOfExpiry),
        (u'earliestTimeOfDelivery', _MMFRecord_earliestTimeOfDelivery),
        (u'deliveryReportRequested', _MMFRecord_deliveryReportRequested),
        (u'readReplyRequested', _MMFRecord_readReplyRequested),
        (u'messageReference', _MMFRecord_messageReference),
        (u'mmStatusCode', _MMFRecord_mmStatusCode),
        (u'statusText', _MMFRecord_statusText),
        (u'recordTimeStamp', _MMFRecord_recordTimeStamp),
        (u'localSequenceNumber', _MMFRecord_localSequenceNumber),
        (u'recordExtensions', _MMFRecord_recordExtensions),
        (u'mMBoxstorageInformation', _MMFRecord_mMBoxstorageInformation),
        ])
    MMFRecord._ext = None
    
    #-----< MMBx1SRecord >-----#
    MMBx1SRecord = SET(name=u'MMBx1SRecord', mode=MODE_TYPE)
    _MMBx1SRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMBx1SRecord_mmsRelayAddress = CHOICE(name=u'mmsRelayAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _MMBx1SRecord_managingAddress = SEQ(name=u'managingAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMBx1SRecord_accessCorrelation = CHOICE(name=u'accessCorrelation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMBx1SRecord_contentType = OCT_STR(name=u'contentType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')), opt=True)
    _MMBx1SRecord_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MMBx1SRecord_messageReference = OCT_STR(name=u'messageReference', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1SRecord_mmState = OCT_STR(name=u'mmState', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1SRecord_mmFlags = OCT_STR(name=u'mmFlags', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1SRecord_storeStatus = INT(name=u'storeStatus', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StoreStatus')), opt=True)
    _MMBx1SRecord_storeStatusText = OCT_STR(name=u'storeStatusText', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMBx1SRecord_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1SRecord_timeStamp = OCT_STR(name=u'timeStamp', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMBx1SRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMBx1SRecord_sGSNPLMNIdentifier = OCT_STR(name=u'sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMBx1SRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMBx1SRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMBx1SRecord._cont = ASN1Dict([
        (u'recordType', _MMBx1SRecord_recordType),
        (u'mmsRelayAddress', _MMBx1SRecord_mmsRelayAddress),
        (u'managingAddress', _MMBx1SRecord_managingAddress),
        (u'accessCorrelation', _MMBx1SRecord_accessCorrelation),
        (u'contentType', _MMBx1SRecord_contentType),
        (u'messageSize', _MMBx1SRecord_messageSize),
        (u'messageReference', _MMBx1SRecord_messageReference),
        (u'mmState', _MMBx1SRecord_mmState),
        (u'mmFlags', _MMBx1SRecord_mmFlags),
        (u'storeStatus', _MMBx1SRecord_storeStatus),
        (u'storeStatusText', _MMBx1SRecord_storeStatusText),
        (u'sequenceNumber', _MMBx1SRecord_sequenceNumber),
        (u'timeStamp', _MMBx1SRecord_timeStamp),
        (u'recordExtensions', _MMBx1SRecord_recordExtensions),
        (u'sGSNPLMNIdentifier', _MMBx1SRecord_sGSNPLMNIdentifier),
        (u'rATType', _MMBx1SRecord_rATType),
        (u'mSTimeZone', _MMBx1SRecord_mSTimeZone),
        ])
    MMBx1SRecord._ext = None
    
    #-----< MMBx1VRecord >-----#
    MMBx1VRecord = SET(name=u'MMBx1VRecord', mode=MODE_TYPE)
    _MMBx1VRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMBx1VRecord_mmsRelayAddress = CHOICE(name=u'mmsRelayAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _MMBx1VRecord_managingAddress = SEQ(name=u'managingAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMBx1VRecord_accessCorrelation = CHOICE(name=u'accessCorrelation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMBx1VRecord_attributesList = SEQ(name=u'attributesList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AttributesList')), opt=True)
    _MMBx1VRecord_messageSelection = INT(name=u'messageSelection', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MessageSelection')), opt=True)
    _MMBx1VRecord_start = INT(name=u'start', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1VRecord_limit = INT(name=u'limit', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1VRecord_totalsRequested = BOOL(name=u'totalsRequested', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1VRecord_quotasRequested = BOOL(name=u'quotasRequested', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1VRecord_mmListing = SEQ(name=u'mmListing', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AttributesList')), opt=True)
    _MMBx1VRecord_requestStatusCode = INT(name=u'requestStatusCode', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MMBx1VRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMBx1VRecord_totals = SEQ(name=u'totals', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'Totals')), opt=True)
    _MMBx1VRecord_quotas = SEQ(name=u'quotas', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'Quotas')), opt=True)
    _MMBx1VRecord_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1VRecord_timeStamp = OCT_STR(name=u'timeStamp', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMBx1VRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMBx1VRecord_sGSNPLMNIdentifier = OCT_STR(name=u'sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMBx1VRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMBx1VRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMBx1VRecord._cont = ASN1Dict([
        (u'recordType', _MMBx1VRecord_recordType),
        (u'mmsRelayAddress', _MMBx1VRecord_mmsRelayAddress),
        (u'managingAddress', _MMBx1VRecord_managingAddress),
        (u'accessCorrelation', _MMBx1VRecord_accessCorrelation),
        (u'attributesList', _MMBx1VRecord_attributesList),
        (u'messageSelection', _MMBx1VRecord_messageSelection),
        (u'start', _MMBx1VRecord_start),
        (u'limit', _MMBx1VRecord_limit),
        (u'totalsRequested', _MMBx1VRecord_totalsRequested),
        (u'quotasRequested', _MMBx1VRecord_quotasRequested),
        (u'mmListing', _MMBx1VRecord_mmListing),
        (u'requestStatusCode', _MMBx1VRecord_requestStatusCode),
        (u'statusText', _MMBx1VRecord_statusText),
        (u'totals', _MMBx1VRecord_totals),
        (u'quotas', _MMBx1VRecord_quotas),
        (u'sequenceNumber', _MMBx1VRecord_sequenceNumber),
        (u'timeStamp', _MMBx1VRecord_timeStamp),
        (u'recordExtensions', _MMBx1VRecord_recordExtensions),
        (u'sGSNPLMNIdentifier', _MMBx1VRecord_sGSNPLMNIdentifier),
        (u'rATType', _MMBx1VRecord_rATType),
        (u'mSTimeZone', _MMBx1VRecord_mSTimeZone),
        ])
    MMBx1VRecord._ext = None
    
    #-----< MMBx1URecord >-----#
    MMBx1URecord = SET(name=u'MMBx1URecord', mode=MODE_TYPE)
    _MMBx1URecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMBx1URecord_mmsRelayAddress = CHOICE(name=u'mmsRelayAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _MMBx1URecord_managingAddress = SEQ(name=u'managingAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMBx1URecord_accessCorrelation = CHOICE(name=u'accessCorrelation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMBx1URecord_recipientsAddressList = SET_OF(name=u'recipientsAddressList', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')))
    _MMBx1URecord_messageClass = ENUM(name=u'messageClass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _MMBx1URecord_uploadTime = OCT_STR(name=u'uploadTime', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMBx1URecord_timeOfExpiry = CHOICE(name=u'timeOfExpiry', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMBx1URecord_earliestTimeOfDelivery = CHOICE(name=u'earliestTimeOfDelivery', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MMBx1URecord_priority = ENUM(name=u'priority', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _MMBx1URecord_mmState = OCT_STR(name=u'mmState', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1URecord_mmFlags = OCT_STR(name=u'mmFlags', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1URecord_contentType = OCT_STR(name=u'contentType', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')), opt=True)
    _MMBx1URecord_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MMBx1URecord_messageReference = OCT_STR(name=u'messageReference', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1URecord_requestStatusCode = INT(name=u'requestStatusCode', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MMBx1URecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMBx1URecord_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1URecord_timeStamp = OCT_STR(name=u'timeStamp', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMBx1URecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMBx1URecord_sGSNPLMNIdentifier = OCT_STR(name=u'sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMBx1URecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMBx1URecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMBx1URecord._cont = ASN1Dict([
        (u'recordType', _MMBx1URecord_recordType),
        (u'mmsRelayAddress', _MMBx1URecord_mmsRelayAddress),
        (u'managingAddress', _MMBx1URecord_managingAddress),
        (u'accessCorrelation', _MMBx1URecord_accessCorrelation),
        (u'recipientsAddressList', _MMBx1URecord_recipientsAddressList),
        (u'messageClass', _MMBx1URecord_messageClass),
        (u'uploadTime', _MMBx1URecord_uploadTime),
        (u'timeOfExpiry', _MMBx1URecord_timeOfExpiry),
        (u'earliestTimeOfDelivery', _MMBx1URecord_earliestTimeOfDelivery),
        (u'priority', _MMBx1URecord_priority),
        (u'mmState', _MMBx1URecord_mmState),
        (u'mmFlags', _MMBx1URecord_mmFlags),
        (u'contentType', _MMBx1URecord_contentType),
        (u'messageSize', _MMBx1URecord_messageSize),
        (u'messageReference', _MMBx1URecord_messageReference),
        (u'requestStatusCode', _MMBx1URecord_requestStatusCode),
        (u'statusText', _MMBx1URecord_statusText),
        (u'sequenceNumber', _MMBx1URecord_sequenceNumber),
        (u'timeStamp', _MMBx1URecord_timeStamp),
        (u'recordExtensions', _MMBx1URecord_recordExtensions),
        (u'sGSNPLMNIdentifier', _MMBx1URecord_sGSNPLMNIdentifier),
        (u'rATType', _MMBx1URecord_rATType),
        (u'mSTimeZone', _MMBx1URecord_mSTimeZone),
        ])
    MMBx1URecord._ext = None
    
    #-----< MMBx1DRecord >-----#
    MMBx1DRecord = SET(name=u'MMBx1DRecord', mode=MODE_TYPE)
    _MMBx1DRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMBx1DRecord_mmsRelayAddress = CHOICE(name=u'mmsRelayAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _MMBx1DRecord_managingAddress = SEQ(name=u'managingAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MMBx1DRecord_accessCorrelation = CHOICE(name=u'accessCorrelation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'AccessCorrelation')), opt=True)
    _MMBx1DRecord_messageReference = OCT_STR(name=u'messageReference', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1DRecord_requestStatusCode = INT(name=u'requestStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MMBx1DRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MMBx1DRecord_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMBx1DRecord_timeStamp = OCT_STR(name=u'timeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMBx1DRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMBx1DRecord_sGSNPLMNIdentifier = OCT_STR(name=u'sGSNPLMNIdentifier', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _MMBx1DRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _MMBx1DRecord_mSTimeZone = OCT_STR(name=u'mSTimeZone', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    MMBx1DRecord._cont = ASN1Dict([
        (u'recordType', _MMBx1DRecord_recordType),
        (u'mmsRelayAddress', _MMBx1DRecord_mmsRelayAddress),
        (u'managingAddress', _MMBx1DRecord_managingAddress),
        (u'accessCorrelation', _MMBx1DRecord_accessCorrelation),
        (u'messageReference', _MMBx1DRecord_messageReference),
        (u'requestStatusCode', _MMBx1DRecord_requestStatusCode),
        (u'statusText', _MMBx1DRecord_statusText),
        (u'sequenceNumber', _MMBx1DRecord_sequenceNumber),
        (u'timeStamp', _MMBx1DRecord_timeStamp),
        (u'recordExtensions', _MMBx1DRecord_recordExtensions),
        (u'sGSNPLMNIdentifier', _MMBx1DRecord_sGSNPLMNIdentifier),
        (u'rATType', _MMBx1DRecord_rATType),
        (u'mSTimeZone', _MMBx1DRecord_mSTimeZone),
        ])
    MMBx1DRecord._ext = None
    
    #-----< MM7SRecord >-----#
    MM7SRecord = SET(name=u'MM7SRecord', mode=MODE_TYPE)
    _MM7SRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7SRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MM7SRecord_linkedID = OCT_STR(name=u'linkedID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7SRecord_vaspID = OCT_STR(name=u'vaspID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7SRecord_vasID = OCT_STR(name=u'vasID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7SRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7SRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7SRecord_recipientAddresses = SET_OF(name=u'recipientAddresses', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddresses')))
    _MM7SRecord_serviceCode = OCT_STR(name=u'serviceCode', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7SRecord_contentType = OCT_STR(name=u'contentType', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')))
    _MM7SRecord_mmComponentType = SEQ(name=u'mmComponentType', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMComponentType')), opt=True)
    _MM7SRecord_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _MM7SRecord_messageClass = ENUM(name=u'messageClass', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _MM7SRecord_chargeInformation = SEQ(name=u'chargeInformation', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ChargeInformation')), opt=True)
    _MM7SRecord_submissionTime = OCT_STR(name=u'submissionTime', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7SRecord_timeOfExpiry = CHOICE(name=u'timeOfExpiry', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MM7SRecord_earliestTimeOfDelivery = CHOICE(name=u'earliestTimeOfDelivery', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MM7SRecord_deliveryReportRequested = BOOL(name=u'deliveryReportRequested', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7SRecord_readReplyRequested = BOOL(name=u'readReplyRequested', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7SRecord_replyCharging = BOOL(name=u'replyCharging', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7SRecord_replyDeadline = CHOICE(name=u'replyDeadline', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MM7SRecord_replyChargingSize = INT(name=u'replyChargingSize', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')), opt=True)
    _MM7SRecord_priority = ENUM(name=u'priority', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _MM7SRecord_messageDistributionIndicator = BOOL(name=u'messageDistributionIndicator', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7SRecord_requestStatusCode = INT(name=u'requestStatusCode', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MM7SRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7SRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _MM7SRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7SRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MM7SRecord_mscfInformation = SET(name=u'mscfInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MSCFInformation')), opt=True)
    MM7SRecord._cont = ASN1Dict([
        (u'recordType', _MM7SRecord_recordType),
        (u'originatorMmsRSAddress', _MM7SRecord_originatorMmsRSAddress),
        (u'linkedID', _MM7SRecord_linkedID),
        (u'vaspID', _MM7SRecord_vaspID),
        (u'vasID', _MM7SRecord_vasID),
        (u'messageID', _MM7SRecord_messageID),
        (u'originatorAddress', _MM7SRecord_originatorAddress),
        (u'recipientAddresses', _MM7SRecord_recipientAddresses),
        (u'serviceCode', _MM7SRecord_serviceCode),
        (u'contentType', _MM7SRecord_contentType),
        (u'mmComponentType', _MM7SRecord_mmComponentType),
        (u'messageSize', _MM7SRecord_messageSize),
        (u'messageClass', _MM7SRecord_messageClass),
        (u'chargeInformation', _MM7SRecord_chargeInformation),
        (u'submissionTime', _MM7SRecord_submissionTime),
        (u'timeOfExpiry', _MM7SRecord_timeOfExpiry),
        (u'earliestTimeOfDelivery', _MM7SRecord_earliestTimeOfDelivery),
        (u'deliveryReportRequested', _MM7SRecord_deliveryReportRequested),
        (u'readReplyRequested', _MM7SRecord_readReplyRequested),
        (u'replyCharging', _MM7SRecord_replyCharging),
        (u'replyDeadline', _MM7SRecord_replyDeadline),
        (u'replyChargingSize', _MM7SRecord_replyChargingSize),
        (u'priority', _MM7SRecord_priority),
        (u'messageDistributionIndicator', _MM7SRecord_messageDistributionIndicator),
        (u'requestStatusCode', _MM7SRecord_requestStatusCode),
        (u'statusText', _MM7SRecord_statusText),
        (u'recordTimeStamp', _MM7SRecord_recordTimeStamp),
        (u'localSequenceNumber', _MM7SRecord_localSequenceNumber),
        (u'recordExtensions', _MM7SRecord_recordExtensions),
        (u'mscfInformation', _MM7SRecord_mscfInformation),
        ])
    MM7SRecord._ext = None
    
    #-----< MM7DRqRecord >-----#
    MM7DRqRecord = SET(name=u'MM7DRqRecord', mode=MODE_TYPE)
    _MM7DRqRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7DRqRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MM7DRqRecord_linkedID = OCT_STR(name=u'linkedID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7DRqRecord_replyChargingID = OCT_STR(name=u'replyChargingID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7DRqRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7DRqRecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7DRqRecord_mmComponentType = SEQ(name=u'mmComponentType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMComponentType')), opt=True)
    _MM7DRqRecord_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _MM7DRqRecord_contentType = OCT_STR(name=u'contentType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')))
    _MM7DRqRecord_priority = ENUM(name=u'priority', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _MM7DRqRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7DRqRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7DRqRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7DRqRecord._cont = ASN1Dict([
        (u'recordType', _MM7DRqRecord_recordType),
        (u'recipientMmsRSAddress', _MM7DRqRecord_recipientMmsRSAddress),
        (u'linkedID', _MM7DRqRecord_linkedID),
        (u'replyChargingID', _MM7DRqRecord_replyChargingID),
        (u'originatorAddress', _MM7DRqRecord_originatorAddress),
        (u'recipientAddress', _MM7DRqRecord_recipientAddress),
        (u'mmComponentType', _MM7DRqRecord_mmComponentType),
        (u'messageSize', _MM7DRqRecord_messageSize),
        (u'contentType', _MM7DRqRecord_contentType),
        (u'priority', _MM7DRqRecord_priority),
        (u'recordTimeStamp', _MM7DRqRecord_recordTimeStamp),
        (u'localSequenceNumber', _MM7DRqRecord_localSequenceNumber),
        (u'recordExtensions', _MM7DRqRecord_recordExtensions),
        ])
    MM7DRqRecord._ext = None
    
    #-----< MM7DRsRecord >-----#
    MM7DRsRecord = SET(name=u'MM7DRsRecord', mode=MODE_TYPE)
    _MM7DRsRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7DRsRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MM7DRsRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7DRsRecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7DRsRecord_serviceCode = OCT_STR(name=u'serviceCode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7DRsRecord_requestStatusCode = INT(name=u'requestStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MM7DRsRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7DRsRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7DRsRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7DRsRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7DRsRecord._cont = ASN1Dict([
        (u'recordType', _MM7DRsRecord_recordType),
        (u'recipientMmsRSAddress', _MM7DRsRecord_recipientMmsRSAddress),
        (u'messageID', _MM7DRsRecord_messageID),
        (u'recipientAddress', _MM7DRsRecord_recipientAddress),
        (u'serviceCode', _MM7DRsRecord_serviceCode),
        (u'requestStatusCode', _MM7DRsRecord_requestStatusCode),
        (u'statusText', _MM7DRsRecord_statusText),
        (u'recordTimeStamp', _MM7DRsRecord_recordTimeStamp),
        (u'localSequenceNumber', _MM7DRsRecord_localSequenceNumber),
        (u'recordExtensions', _MM7DRsRecord_recordExtensions),
        ])
    MM7DRsRecord._ext = None
    
    #-----< MM7CRecord >-----#
    MM7CRecord = SET(name=u'MM7CRecord', mode=MODE_TYPE)
    _MM7CRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7CRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MM7CRecord_vaspID = OCT_STR(name=u'vaspID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7CRecord_vasID = OCT_STR(name=u'vasID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7CRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7CRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7CRecord_serviceCode = OCT_STR(name=u'serviceCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7CRecord_requestStatusCode = INT(name=u'requestStatusCode', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MM7CRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7CRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7CRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7CRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7CRecord._cont = ASN1Dict([
        (u'recordType', _MM7CRecord_recordType),
        (u'originatorMmsRSAddress', _MM7CRecord_originatorMmsRSAddress),
        (u'vaspID', _MM7CRecord_vaspID),
        (u'vasID', _MM7CRecord_vasID),
        (u'messageID', _MM7CRecord_messageID),
        (u'originatorAddress', _MM7CRecord_originatorAddress),
        (u'serviceCode', _MM7CRecord_serviceCode),
        (u'requestStatusCode', _MM7CRecord_requestStatusCode),
        (u'statusText', _MM7CRecord_statusText),
        (u'recordTimeStamp', _MM7CRecord_recordTimeStamp),
        (u'localSequenceNumber', _MM7CRecord_localSequenceNumber),
        (u'recordExtensions', _MM7CRecord_recordExtensions),
        ])
    MM7CRecord._ext = None
    
    #-----< MM7RRecord >-----#
    MM7RRecord = SET(name=u'MM7RRecord', mode=MODE_TYPE)
    _MM7RRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7RRecord_originatorMmsRSAddress = SEQ(name=u'originatorMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _MM7RRecord_vaspID = OCT_STR(name=u'vaspID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7RRecord_vasID = OCT_STR(name=u'vasID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7RRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7RRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7RRecord_serviceCode = OCT_STR(name=u'serviceCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MM7RRecord_contentType = OCT_STR(name=u'contentType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ContentType')))
    _MM7RRecord_submissionTime = OCT_STR(name=u'submissionTime', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7RRecord_timeOfExpiry = CHOICE(name=u'timeOfExpiry', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MM7RRecord_earliestTimeOfDelivery = CHOICE(name=u'earliestTimeOfDelivery', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'WaitTime')), opt=True)
    _MM7RRecord_requestStatusCode = INT(name=u'requestStatusCode', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MM7RRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7RRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7RRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7RRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7RRecord._cont = ASN1Dict([
        (u'recordType', _MM7RRecord_recordType),
        (u'originatorMmsRSAddress', _MM7RRecord_originatorMmsRSAddress),
        (u'vaspID', _MM7RRecord_vaspID),
        (u'vasID', _MM7RRecord_vasID),
        (u'messageID', _MM7RRecord_messageID),
        (u'originatorAddress', _MM7RRecord_originatorAddress),
        (u'serviceCode', _MM7RRecord_serviceCode),
        (u'contentType', _MM7RRecord_contentType),
        (u'submissionTime', _MM7RRecord_submissionTime),
        (u'timeOfExpiry', _MM7RRecord_timeOfExpiry),
        (u'earliestTimeOfDelivery', _MM7RRecord_earliestTimeOfDelivery),
        (u'requestStatusCode', _MM7RRecord_requestStatusCode),
        (u'statusText', _MM7RRecord_statusText),
        (u'recordTimeStamp', _MM7RRecord_recordTimeStamp),
        (u'localSequenceNumber', _MM7RRecord_localSequenceNumber),
        (u'recordExtensions', _MM7RRecord_recordExtensions),
        ])
    MM7RRecord._ext = None
    
    #-----< MM7DRRqRecord >-----#
    MM7DRRqRecord = SET(name=u'MM7DRRqRecord', mode=MODE_TYPE)
    _MM7DRRqRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7DRRqRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MM7DRRqRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7DRRqRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MM7DRRqRecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7DRRqRecord_mmDateAndTime = OCT_STR(name=u'mmDateAndTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7DRRqRecord_mmStatusCode = ENUM(name=u'mmStatusCode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')))
    _MM7DRRqRecord_mmStatusText = OCT_STR(name=u'mmStatusText', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7DRRqRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7DRRqRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7DRRqRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7DRRqRecord._cont = ASN1Dict([
        (u'recordType', _MM7DRRqRecord_recordType),
        (u'recipientMmsRSAddress', _MM7DRRqRecord_recipientMmsRSAddress),
        (u'messageID', _MM7DRRqRecord_messageID),
        (u'originatorAddress', _MM7DRRqRecord_originatorAddress),
        (u'recipientAddress', _MM7DRRqRecord_recipientAddress),
        (u'mmDateAndTime', _MM7DRRqRecord_mmDateAndTime),
        (u'mmStatusCode', _MM7DRRqRecord_mmStatusCode),
        (u'mmStatusText', _MM7DRRqRecord_mmStatusText),
        (u'recordTimeStamp', _MM7DRRqRecord_recordTimeStamp),
        (u'localSequenceNumber', _MM7DRRqRecord_localSequenceNumber),
        (u'recordExtensions', _MM7DRRqRecord_recordExtensions),
        ])
    MM7DRRqRecord._ext = None
    
    #-----< MM7DRRsRecord >-----#
    MM7DRRsRecord = SET(name=u'MM7DRRsRecord', mode=MODE_TYPE)
    _MM7DRRsRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7DRRsRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MM7DRRsRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7DRRsRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MM7DRRsRecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7DRRsRecord_requestStatusCode = INT(name=u'requestStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MM7DRRsRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7DRRsRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7DRRsRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7DRRsRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7DRRsRecord._cont = ASN1Dict([
        (u'recordType', _MM7DRRsRecord_recordType),
        (u'recipientMmsRSAddress', _MM7DRRsRecord_recipientMmsRSAddress),
        (u'messageID', _MM7DRRsRecord_messageID),
        (u'originatorAddress', _MM7DRRsRecord_originatorAddress),
        (u'recipientAddress', _MM7DRRsRecord_recipientAddress),
        (u'requestStatusCode', _MM7DRRsRecord_requestStatusCode),
        (u'statusText', _MM7DRRsRecord_statusText),
        (u'recordTimeStamp', _MM7DRRsRecord_recordTimeStamp),
        (u'localSequenceNumber', _MM7DRRsRecord_localSequenceNumber),
        (u'recordExtensions', _MM7DRRsRecord_recordExtensions),
        ])
    MM7DRRsRecord._ext = None
    
    #-----< MM7RRqRecord >-----#
    MM7RRqRecord = SET(name=u'MM7RRqRecord', mode=MODE_TYPE)
    _MM7RRqRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7RRqRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MM7RRqRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7RRqRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MM7RRqRecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7RRqRecord_mmDateAndTime = OCT_STR(name=u'mmDateAndTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7RRqRecord_readStatus = ENUM(name=u'readStatus', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMStatusCodeType')))
    _MM7RRqRecord_mmStatusText = OCT_STR(name=u'mmStatusText', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7RRqRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7RRqRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7RRqRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7RRqRecord._cont = ASN1Dict([
        (u'recordType', _MM7RRqRecord_recordType),
        (u'recipientMmsRSAddress', _MM7RRqRecord_recipientMmsRSAddress),
        (u'messageID', _MM7RRqRecord_messageID),
        (u'originatorAddress', _MM7RRqRecord_originatorAddress),
        (u'recipientAddress', _MM7RRqRecord_recipientAddress),
        (u'mmDateAndTime', _MM7RRqRecord_mmDateAndTime),
        (u'readStatus', _MM7RRqRecord_readStatus),
        (u'mmStatusText', _MM7RRqRecord_mmStatusText),
        (u'recordTimeStamp', _MM7RRqRecord_recordTimeStamp),
        (u'localSequenceNumber', _MM7RRqRecord_localSequenceNumber),
        (u'recordExtensions', _MM7RRqRecord_recordExtensions),
        ])
    MM7RRqRecord._ext = None
    
    #-----< MM7RRsRecord >-----#
    MM7RRsRecord = SET(name=u'MM7RRsRecord', mode=MODE_TYPE)
    _MM7RRsRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MM7RRsRecord_recipientMmsRSAddress = SEQ(name=u'recipientMmsRSAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')), opt=True)
    _MM7RRsRecord_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MM7RRsRecord_originatorAddress = SEQ(name=u'originatorAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')), opt=True)
    _MM7RRsRecord_recipientAddress = SEQ(name=u'recipientAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    _MM7RRsRecord_requestStatusCode = INT(name=u'requestStatusCode', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RequestStatusCodeType')), opt=True)
    _MM7RRsRecord_statusText = OCT_STR(name=u'statusText', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')), opt=True)
    _MM7RRsRecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MM7RRsRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MM7RRsRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MM7RRsRecord._cont = ASN1Dict([
        (u'recordType', _MM7RRsRecord_recordType),
        (u'recipientMmsRSAddress', _MM7RRsRecord_recipientMmsRSAddress),
        (u'messageID', _MM7RRsRecord_messageID),
        (u'originatorAddress', _MM7RRsRecord_originatorAddress),
        (u'recipientAddress', _MM7RRsRecord_recipientAddress),
        (u'requestStatusCode', _MM7RRsRecord_requestStatusCode),
        (u'statusText', _MM7RRsRecord_statusText),
        (u'recordTimeStamp', _MM7RRsRecord_recordTimeStamp),
        (u'localSequenceNumber', _MM7RRsRecord_localSequenceNumber),
        (u'recordExtensions', _MM7RRsRecord_recordExtensions),
        ])
    MM7RRsRecord._ext = None
    
    #-----< AccessCorrelation >-----#
    AccessCorrelation = CHOICE(name=u'AccessCorrelation', mode=MODE_TYPE)
    _AccessCorrelation_circuitSwitched = SEQ(name=u'circuitSwitched', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'CircuitSwitchedAccess')))
    _AccessCorrelation_packetSwitched = SEQ(name=u'packetSwitched', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'PacketSwitchedAccess')))
    AccessCorrelation._cont = ASN1Dict([
        (u'circuitSwitched', _AccessCorrelation_circuitSwitched),
        (u'packetSwitched', _AccessCorrelation_packetSwitched),
        ])
    AccessCorrelation._ext = None
    
    #-----< AttributesList >-----#
    AttributesList = SEQ(name=u'AttributesList', mode=MODE_TYPE)
    _AttributesList_messageID = OCT_STR(name=u'messageID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AttributesList_dateAndTime = OCT_STR(name=u'dateAndTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _AttributesList_senderAddress = SEQ(name=u'senderAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRSAddress')))
    _AttributesList_subject = OCT_STR(name=u'subject', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AttributesList_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    _AttributesList_mmFlags = OCT_STR(name=u'mmFlags', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AttributesList_mmState = ENUM(name=u'mmState', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMState')))
    AttributesList._cont = ASN1Dict([
        (u'messageID', _AttributesList_messageID),
        (u'dateAndTime', _AttributesList_dateAndTime),
        (u'senderAddress', _AttributesList_senderAddress),
        (u'subject', _AttributesList_subject),
        (u'messageSize', _AttributesList_messageSize),
        (u'mmFlags', _AttributesList_mmFlags),
        (u'mmState', _AttributesList_mmState),
        ])
    AttributesList._ext = None
    
    #-----< ChargeInformation >-----#
    ChargeInformation = SEQ(name=u'ChargeInformation', mode=MODE_TYPE)
    _ChargeInformation_chargedparty = ENUM(name=u'chargedparty', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ChargedParty')), opt=True)
    _ChargeInformation_chargetype = ENUM(name=u'chargetype', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'ChargeType')), opt=True)
    ChargeInformation._cont = ASN1Dict([
        (u'chargedparty', _ChargeInformation_chargedparty),
        (u'chargetype', _ChargeInformation_chargetype),
        ])
    ChargeInformation._ext = None
    
    #-----< ChargedParty >-----#
    ChargedParty = ENUM(name=u'ChargedParty', mode=MODE_TYPE)
    ChargedParty._cont = ASN1Dict([(u'sender', 0), (u'recipient', 1), (u'both', 2), (u'neither', 3), (u'notspecifiedbyVASP', 99)])
    ChargedParty._ext = None
    
    #-----< ChargeType >-----#
    ChargeType = ENUM(name=u'ChargeType', mode=MODE_TYPE)
    ChargeType._cont = ASN1Dict([(u'postpaid', 0), (u'pre-paid', 1)])
    ChargeType._ext = None
    
    #-----< CircuitSwitchedAccess >-----#
    CircuitSwitchedAccess = SEQ(name=u'CircuitSwitchedAccess', mode=MODE_TYPE)
    _CircuitSwitchedAccess_mSCIdentifier = OCT_STR(name=u'mSCIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MscNo')))
    _CircuitSwitchedAccess_callReferenceNumber = OCT_STR(name=u'callReferenceNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CH-DataTypes', 'CallReferenceNumber')))
    CircuitSwitchedAccess._cont = ASN1Dict([
        (u'mSCIdentifier', _CircuitSwitchedAccess_mSCIdentifier),
        (u'callReferenceNumber', _CircuitSwitchedAccess_callReferenceNumber),
        ])
    CircuitSwitchedAccess._ext = None
    
    #-----< ContentType >-----#
    ContentType = OCT_STR(name=u'ContentType', mode=MODE_TYPE)
    
    #-----< DataVolume >-----#
    DataVolume = INT(name=u'DataVolume', mode=MODE_TYPE)
    
    #-----< DeltaSeconds >-----#
    DeltaSeconds = OCT_STR(name=u'DeltaSeconds', mode=MODE_TYPE)
    DeltaSeconds._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MediaComponent >-----#
    MediaComponent = SEQ(name=u'MediaComponent', mode=MODE_TYPE)
    _MediaComponent_mediaType = OCT_STR(name=u'mediaType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MediaComponent_mediaSize = INT(name=u'mediaSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    MediaComponent._cont = ASN1Dict([
        (u'mediaType', _MediaComponent_mediaType),
        (u'mediaSize', _MediaComponent_mediaSize),
        ])
    MediaComponent._ext = None
    
    #-----< MediaComponents >-----#
    MediaComponents = SET_OF(name=u'MediaComponents', mode=MODE_TYPE)
    _MediaComponents__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MMSChargingDataTypes', 'MediaComponent')))
    MediaComponents._cont = _MediaComponents__item_
    
    #-----< MessageSelection >-----#
    MessageSelection = INT(name=u'MessageSelection', mode=MODE_TYPE)
    
    #-----< MMBoxStorageInformation >-----#
    MMBoxStorageInformation = SET(name=u'MMBoxStorageInformation', mode=MODE_TYPE)
    _MMBoxStorageInformation_mmState = ENUM(name=u'mmState', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMState')))
    _MMBoxStorageInformation_mmFlag = OCT_STR(name=u'mmFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMBoxStorageInformation_storeStatus = INT(name=u'storeStatus', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StoreStatus')))
    _MMBoxStorageInformation_storeStatusText = OCT_STR(name=u'storeStatusText', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'StatusTextType')))
    _MMBoxStorageInformation_storedMessageReference = OCT_STR(name=u'storedMessageReference', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    MMBoxStorageInformation._cont = ASN1Dict([
        (u'mmState', _MMBoxStorageInformation_mmState),
        (u'mmFlag', _MMBoxStorageInformation_mmFlag),
        (u'storeStatus', _MMBoxStorageInformation_storeStatus),
        (u'storeStatusText', _MMBoxStorageInformation_storeStatusText),
        (u'storedMessageReference', _MMBoxStorageInformation_storedMessageReference),
        ])
    MMBoxStorageInformation._ext = None
    
    #-----< MMComponentType >-----#
    MMComponentType = SEQ(name=u'MMComponentType', mode=MODE_TYPE)
    _MMComponentType_subject = SEQ(name=u'subject', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'SubjectComponent')))
    _MMComponentType_media = SET_OF(name=u'media', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MediaComponents')))
    MMComponentType._cont = ASN1Dict([
        (u'subject', _MMComponentType_subject),
        (u'media', _MMComponentType_media),
        ])
    MMComponentType._ext = None
    
    #-----< MMSAgentAddress >-----#
    MMSAgentAddress = SEQ(name=u'MMSAgentAddress', mode=MODE_TYPE)
    _MMSAgentAddress_mMSAgentAddressData = CHOICE(name=u'mMSAgentAddressData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddressData')))
    _MMSAgentAddress_mMSRecipientType = SEQ_OF(name=u'mMSRecipientType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MMSAgentAddress_mMSRecipientType__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSRecipientType')))
    _MMSAgentAddress_mMSRecipientType._cont = __MMSAgentAddress_mMSRecipientType__item_
    MMSAgentAddress._cont = ASN1Dict([
        (u'mMSAgentAddressData', _MMSAgentAddress_mMSAgentAddressData),
        (u'mMSRecipientType', _MMSAgentAddress_mMSRecipientType),
        ])
    MMSAgentAddress._ext = None
    
    #-----< MMSAgentAddresses >-----#
    MMSAgentAddresses = SET_OF(name=u'MMSAgentAddresses', mode=MODE_TYPE)
    _MMSAgentAddresses__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    MMSAgentAddresses._cont = _MMSAgentAddresses__item_
    
    #-----< MMSAgentAddressData >-----#
    MMSAgentAddressData = CHOICE(name=u'MMSAgentAddressData', mode=MODE_TYPE)
    _MMSAgentAddressData_eMail_address = OCT_STR(name=u'eMail-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MMSAgentAddressData_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')))
    _MMSAgentAddressData_shortCode = OCT_STR(name=u'shortCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    MMSAgentAddressData._cont = ASN1Dict([
        (u'eMail-address', _MMSAgentAddressData_eMail_address),
        (u'mSISDN', _MMSAgentAddressData_mSISDN),
        (u'shortCode', _MMSAgentAddressData_shortCode),
        ])
    MMSAgentAddressData._ext = None
    
    #-----< MMSRecipientType >-----#
    MMSRecipientType = ENUM(name=u'MMSRecipientType', mode=MODE_TYPE)
    MMSRecipientType._cont = ASN1Dict([(u'tO', 0), (u'cC', 1), (u'bCC', 2)])
    MMSRecipientType._ext = None
    
    #-----< MMSRSAddress >-----#
    MMSRSAddress = SEQ(name=u'MMSRSAddress', mode=MODE_TYPE)
    _MMSRSAddress_domainName = OCT_STR(name=u'domainName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMSRSAddress_iPAddress = CHOICE(name=u'iPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    MMSRSAddress._cont = ASN1Dict([
        (u'domainName', _MMSRSAddress_domainName),
        (u'iPAddress', _MMSRSAddress_iPAddress),
        ])
    MMSRSAddress._ext = None
    
    #-----< MMState >-----#
    MMState = ENUM(name=u'MMState', mode=MODE_TYPE)
    MMState._cont = ASN1Dict([(u'draft', 0), (u'sent', 1), (u'new', 2), (u'retrieved', 3), (u'forwarded', 4)])
    MMState._ext = None
    
    #-----< MMStatusCodeType >-----#
    MMStatusCodeType = ENUM(name=u'MMStatusCodeType', mode=MODE_TYPE)
    MMStatusCodeType._cont = ASN1Dict([(u'retrieved', 0), (u'forwarded', 1), (u'expired', 2), (u'rejected', 3), (u'deferred', 4), (u'unrecognised', 5), (u'read', 6), (u'deletedWithoutBeingRead', 7)])
    MMStatusCodeType._ext = None
    
    #-----< MSCFInformation >-----#
    MSCFInformation = SET(name=u'MSCFInformation', mode=MODE_TYPE)
    _MSCFInformation_billingInformation = OCT_STR(name=u'billingInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MSCFInformation_routeingAddressList = SET_OF(name=u'routeingAddressList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'RouteingAddressList')), opt=True)
    MSCFInformation._cont = ASN1Dict([
        (u'billingInformation', _MSCFInformation_billingInformation),
        (u'routeingAddressList', _MSCFInformation_routeingAddressList),
        ])
    MSCFInformation._ext = None
    
    #-----< PacketSwitchedAccess >-----#
    PacketSwitchedAccess = SEQ(name=u'PacketSwitchedAccess', mode=MODE_TYPE)
    _PacketSwitchedAccess_gSNAddress = CHOICE(name=u'gSNAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'GSNAddress')))
    _PacketSwitchedAccess_chargingID = INT(name=u'chargingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ChargingID')))
    PacketSwitchedAccess._cont = ASN1Dict([
        (u'gSNAddress', _PacketSwitchedAccess_gSNAddress),
        (u'chargingID', _PacketSwitchedAccess_chargingID),
        ])
    PacketSwitchedAccess._ext = None
    
    #-----< Quotas >-----#
    Quotas = SEQ(name=u'Quotas', mode=MODE_TYPE)
    _Quotas_numberOfMessages = INT(name=u'numberOfMessages', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Quotas_numberOfOctets = INT(name=u'numberOfOctets', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    Quotas._cont = ASN1Dict([
        (u'numberOfMessages', _Quotas_numberOfMessages),
        (u'numberOfOctets', _Quotas_numberOfOctets),
        ])
    Quotas._ext = None
    
    #-----< RequestStatusCodeType >-----#
    RequestStatusCodeType = INT(name=u'RequestStatusCodeType', mode=MODE_TYPE)
    RequestStatusCodeType._cont = ASN1Dict([(u'normalRelease', 0), (u'abnormalRelease', 4), (u'serviceDenied', 30), (u'messageFormatCorrupt', 31), (u'sendingAddressUnresolved', 32), (u'messageNotFound', 33), (u'networkProblem', 34), (u'contentNotAccepted', 35), (u'unsupportedMessage', 36)])
    
    #-----< RouteingAddress >-----#
    RouteingAddress = SEQ(name=u'RouteingAddress', mode=MODE_TYPE)
    _RouteingAddress_eMail_address = OCT_STR(name=u'eMail-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RouteingAddress_mSISDN = OCT_STR(name=u'mSISDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _RouteingAddress_shortCode = OCT_STR(name=u'shortCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    RouteingAddress._cont = ASN1Dict([
        (u'eMail-address', _RouteingAddress_eMail_address),
        (u'mSISDN', _RouteingAddress_mSISDN),
        (u'shortCode', _RouteingAddress_shortCode),
        ])
    RouteingAddress._ext = None
    
    #-----< RouteingAddressList >-----#
    RouteingAddressList = SET_OF(name=u'RouteingAddressList', mode=MODE_TYPE)
    _RouteingAddressList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MMSChargingDataTypes', 'MMSAgentAddress')))
    RouteingAddressList._cont = _RouteingAddressList__item_
    
    #-----< StatusTextType >-----#
    StatusTextType = OCT_STR(name=u'StatusTextType', mode=MODE_TYPE)
    
    #-----< StoreStatus >-----#
    StoreStatus = INT(name=u'StoreStatus', mode=MODE_TYPE)
    StoreStatus._cont = ASN1Dict([(u'stored', 0), (u'errorTransientFailure', 1), (u'errorTransientMailboxFull', 2), (u'errorTransientNetworkProblems', 3), (u'errorPermanentFailure', 4), (u'errorPermanentPermissionDenied', 5), (u'errorPermanentMessageFormat', 6), (u'errorPermanentMessageNotFound', 7)])
    
    #-----< SubjectComponent >-----#
    SubjectComponent = SEQ(name=u'SubjectComponent', mode=MODE_TYPE)
    _SubjectComponent_subjectType = OCT_STR(name=u'subjectType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubjectComponent_subjectSize = INT(name=u'subjectSize', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DataVolume')))
    SubjectComponent._cont = ASN1Dict([
        (u'subjectType', _SubjectComponent_subjectType),
        (u'subjectSize', _SubjectComponent_subjectSize),
        ])
    SubjectComponent._ext = None
    
    #-----< Totals >-----#
    Totals = SEQ(name=u'Totals', mode=MODE_TYPE)
    _Totals_numberOfMessages = INT(name=u'numberOfMessages', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Totals_numberOfOctets = INT(name=u'numberOfOctets', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    Totals._cont = ASN1Dict([
        (u'numberOfMessages', _Totals_numberOfMessages),
        (u'numberOfOctets', _Totals_numberOfOctets),
        ])
    Totals._ext = None
    
    #-----< WaitTime >-----#
    WaitTime = CHOICE(name=u'WaitTime', mode=MODE_TYPE)
    _WaitTime_http_date = OCT_STR(name=u'http-date', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _WaitTime_delta_seconds = OCT_STR(name=u'delta-seconds', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMSChargingDataTypes', 'DeltaSeconds')))
    WaitTime._cont = ASN1Dict([
        (u'http-date', _WaitTime_http_date),
        (u'delta-seconds', _WaitTime_delta_seconds),
        ])
    WaitTime._ext = None
    
    _all_ = [
        _MMSRecordType_mMO1SRecord,
        _MMSRecordType_mMO4FRqRecord,
        _MMSRecordType_mMO4FRsRecord,
        _MMSRecordType_mMO4DRecord,
        _MMSRecordType_mMO1DRecord,
        _MMSRecordType_mMO4RRecord,
        _MMSRecordType_mMO1RRecord,
        _MMSRecordType_mMOMDRecord,
        _MMSRecordType_mMR4FRecord,
        _MMSRecordType_mMR1NRqRecord,
        _MMSRecordType_mMR1NRsRecord,
        _MMSRecordType_mMR1RtRqRecord,
        _MMSRecordType_mMR1ARecord,
        _MMSRecordType_mMR4DRqRecord,
        _MMSRecordType_mMR4DRsRecord,
        _MMSRecordType_mMR1RRRecord,
        _MMSRecordType_mMR4RRqRecord,
        _MMSRecordType_mMR4RRsRecord,
        _MMSRecordType_mMRMDRecord,
        _MMSRecordType_mMFRecord,
        _MMSRecordType_mMBx1SRecord,
        _MMSRecordType_mMBx1VRecord,
        _MMSRecordType_mMBx1URecord,
        _MMSRecordType_mMBx1DRecord,
        _MMSRecordType_mM7SRecord,
        _MMSRecordType_mM7DRqRecord,
        _MMSRecordType_mM7DRsRecord,
        _MMSRecordType_mM7CRecord,
        _MMSRecordType_mM7RRecord,
        _MMSRecordType_mM7DRRqRecord,
        _MMSRecordType_mM7DRRsRecord,
        _MMSRecordType_mM7RRqRecord,
        _MMSRecordType_mM7RRsRecord,
        MMSRecordType,
        _MMO1SRecord_recordType,
        _MMO1SRecord_originatorMmsRSAddress,
        _MMO1SRecord_messageID,
        _MMO1SRecord_replyChargingID,
        _MMO1SRecord_originatorAddress,
        _MMO1SRecord_recipientAddresses,
        _MMO1SRecord_accessCorrelation,
        _MMO1SRecord_contentType,
        _MMO1SRecord_mmComponentType,
        _MMO1SRecord_messageSize,
        _MMO1SRecord_messageClass,
        _MMO1SRecord_chargeInformation,
        _MMO1SRecord_submissionTime,
        _MMO1SRecord_timeOfExpiry,
        _MMO1SRecord_earliestTimeOfDelivery,
        _MMO1SRecord_durationOfTransmission,
        _MMO1SRecord_requestStatusCode,
        _MMO1SRecord_deliveryReportRequested,
        _MMO1SRecord_replyCharging,
        _MMO1SRecord_replyDeadline,
        _MMO1SRecord_replyChargingSize,
        _MMO1SRecord_priority,
        _MMO1SRecord_senderVisibility,
        _MMO1SRecord_readReplyRequested,
        _MMO1SRecord_statusText,
        _MMO1SRecord_recordTimeStamp,
        _MMO1SRecord_localSequenceNumber,
        _MMO1SRecord_recordExtensions,
        _MMO1SRecord_mMBoxstorageInformation,
        _MMO1SRecord_mscfInformation,
        _MMO1SRecord_sGSNPLMNIdentifier,
        _MMO1SRecord_rATType,
        _MMO1SRecord_mSTimeZone,
        MMO1SRecord,
        _MMO4FRqRecord_recordType,
        _MMO4FRqRecord_originatorMmsRSAddress,
        _MMO4FRqRecord_recipientMmsRSAddress,
        _MMO4FRqRecord_messageID,
        _MMO4FRqRecord_mms3GPPVersion,
        _MMO4FRqRecord_originatorAddress,
        _MMO4FRqRecord_recipientAddresses,
        _MMO4FRqRecord_contentType,
        _MMO4FRqRecord_mmComponentType,
        _MMO4FRqRecord_messageSize,
        _MMO4FRqRecord_messageClass,
        _MMO4FRqRecord_submissionTime,
        _MMO4FRqRecord_timeOfExpiry,
        _MMO4FRqRecord_deliveryReportRequested,
        _MMO4FRqRecord_priority,
        _MMO4FRqRecord_senderVisibility,
        _MMO4FRqRecord_readReplyRequested,
        _MMO4FRqRecord_acknowledgementRequest,
        _MMO4FRqRecord_forwardCounter,
        _MMO4FRqRecord_forwardingAddress,
        _MMO4FRqRecord_recordTimeStamp,
        _MMO4FRqRecord_localSequenceNumber,
        _MMO4FRqRecord_recordExtensions,
        MMO4FRqRecord,
        _MMO4FRsRecord_recordType,
        _MMO4FRsRecord_originatorMmsRSAddress,
        _MMO4FRsRecord_recipientMmsRSAddress,
        _MMO4FRsRecord_messageID,
        _MMO4FRsRecord_mms3GPPVersion,
        _MMO4FRsRecord_requestStatusCode,
        _MMO4FRsRecord_statusText,
        _MMO4FRsRecord_recordTimeStamp,
        _MMO4FRsRecord_localSequenceNumber,
        _MMO4FRsRecord_recordExtensions,
        MMO4FRsRecord,
        _MMO4DRecord_recordType,
        _MMO4DRecord_recipientMmsRSAddress,
        _MMO4DRecord_originatorMmsRSAddress,
        _MMO4DRecord_messageID,
        _MMO4DRecord_mms3GPPVersion,
        _MMO4DRecord_originatorAddress,
        _MMO4DRecord_recipientAddress,
        _MMO4DRecord_mmDateAndTime,
        _MMO4DRecord_acknowledgementRequest,
        _MMO4DRecord_mmStatusCode,
        _MMO4DRecord_statusText,
        _MMO4DRecord_recordTimeStamp,
        _MMO4DRecord_localSequenceNumber,
        _MMO4DRecord_recordExtensions,
        MMO4DRecord,
        _MMO1DRecord_recordType,
        _MMO1DRecord_recipientMmsRSAddress,
        _MMO1DRecord_originatorMmsRSAddress,
        _MMO1DRecord_accessCorrelation,
        _MMO1DRecord_messageID,
        _MMO1DRecord_mms3GPPVersion,
        _MMO1DRecord_originatorAddress,
        _MMO1DRecord_recipientAddress,
        _MMO1DRecord_mmStatusCode,
        _MMO1DRecord_recordTimeStamp,
        _MMO1DRecord_localSequenceNumber,
        _MMO1DRecord_recordExtensions,
        _MMO1DRecord_sGSNPLMNIdentifier,
        _MMO1DRecord_rATType,
        _MMO1DRecord_mSTimeZone,
        MMO1DRecord,
        _MMO4RRecord_recordType,
        _MMO4RRecord_recipientMmsRSAddress,
        _MMO4RRecord_originatorMmsRSAddress,
        _MMO4RRecord_messageID,
        _MMO4RRecord_mms3GPPVersion,
        _MMO4RRecord_originatorAddress,
        _MMO4RRecord_recipientAddresses,
        _MMO4RRecord_mmDateAndTime,
        _MMO4RRecord_acknowledgementRequest,
        _MMO4RRecord_readStatus,
        _MMO4RRecord_statusText,
        _MMO4RRecord_recordTimeStamp,
        _MMO4RRecord_localSequenceNumber,
        _MMO4RRecord_recordExtensions,
        MMO4RRecord,
        _MMO1RRecord_recordType,
        _MMO1RRecord_recipientMmsRSAddress,
        _MMO1RRecord_originatorMmsRSAddress,
        _MMO1RRecord_accessCorrelation,
        _MMO1RRecord_messageID,
        _MMO1RRecord_mms3GPPVersion,
        _MMO1RRecord_originatorAddress,
        _MMO1RRecord_recipientAddress,
        _MMO1RRecord_readStatus,
        _MMO1RRecord_recordTimeStamp,
        _MMO1RRecord_localSequenceNumber,
        _MMO1RRecord_recordExtensions,
        _MMO1RRecord_sGSNPLMNIdentifier,
        _MMO1RRecord_rATType,
        _MMO1RRecord_mSTimeZone,
        MMO1RRecord,
        _MMOMDRecord_recordType,
        _MMOMDRecord_originatorMmsRSAddress,
        _MMOMDRecord_recipientMmsRSAddress,
        _MMOMDRecord_messageID,
        _MMOMDRecord_messageSize,
        _MMOMDRecord_mmStatusCode,
        _MMOMDRecord_statusText,
        _MMOMDRecord_recordTimeStamp,
        _MMOMDRecord_localSequenceNumber,
        _MMOMDRecord_recordExtensions,
        MMOMDRecord,
        _MMR4FRecord_recordType,
        _MMR4FRecord_recipientMmsRSAddress,
        _MMR4FRecord_originatorMmsRSAddress,
        _MMR4FRecord_messageID,
        _MMR4FRecord_mms3GPPVersion,
        _MMR4FRecord_originatorAddress,
        _MMR4FRecord_recipientAddresses,
        _MMR4FRecord_contentType,
        _MMR4FRecord_mmComponentType,
        _MMR4FRecord_messageSize,
        _MMR4FRecord_messageClass,
        _MMR4FRecord_submissionTime,
        _MMR4FRecord_timeOfExpiry,
        _MMR4FRecord_deliveryReportRequested,
        _MMR4FRecord_priority,
        _MMR4FRecord_senderVisibility,
        _MMR4FRecord_readReplyRequested,
        _MMR4FRecord_requestStatusCode,
        _MMR4FRecord_statusText,
        _MMR4FRecord_acknowledgementRequest,
        _MMR4FRecord_forwardCounter,
        _MMR4FRecord_forwardingAddress,
        _MMR4FRecord_recordTimeStamp,
        _MMR4FRecord_localSequenceNumber,
        _MMR4FRecord_recordExtensions,
        MMR4FRecord,
        _MMR1NRqRecord_recordType,
        _MMR1NRqRecord_recipientMmsRSAddress,
        _MMR1NRqRecord_messageID,
        _MMR1NRqRecord_replyChargingID,
        _MMR1NRqRecord_senderAddress,
        _MMR1NRqRecord_recipientAddress,
        _MMR1NRqRecord_accessCorrelation,
        _MMR1NRqRecord_messageClass,
        _MMR1NRqRecord_mmComponentType,
        _MMR1NRqRecord_messageSize,
        _MMR1NRqRecord_timeOfExpiry,
        _MMR1NRqRecord_messageReference,
        _MMR1NRqRecord_deliveryReportRequested,
        _MMR1NRqRecord_replyCharging,
        _MMR1NRqRecord_replyDeadline,
        _MMR1NRqRecord_replyChargingSize,
        _MMR1NRqRecord_mmStatusCode,
        _MMR1NRqRecord_statusText,
        _MMR1NRqRecord_recordTimeStamp,
        _MMR1NRqRecord_localSequenceNumber,
        _MMR1NRqRecord_recordExtensions,
        _MMR1NRqRecord_mscfInformation,
        _MMR1NRqRecord_vaspID,
        _MMR1NRqRecord_vasID,
        _MMR1NRqRecord_sGSNPLMNIdentifier,
        _MMR1NRqRecord_rATType,
        _MMR1NRqRecord_mSTimeZone,
        MMR1NRqRecord,
        _MMR1NRsRecord_recordType,
        _MMR1NRsRecord_recipientMmsRSAddress,
        _MMR1NRsRecord_messageID,
        _MMR1NRsRecord_recipientAddress,
        _MMR1NRsRecord_accessCorrelation,
        _MMR1NRsRecord_reportAllowed,
        _MMR1NRsRecord_mmStatusCode,
        _MMR1NRsRecord_statusText,
        _MMR1NRsRecord_recordTimeStamp,
        _MMR1NRsRecord_localSequenceNumber,
        _MMR1NRsRecord_recordExtensions,
        _MMR1NRsRecord_sGSNPLMNIdentifier,
        _MMR1NRsRecord_rATType,
        _MMR1NRsRecord_mSTimeZone,
        MMR1NRsRecord,
        _MMR1RtRecord_recordType,
        _MMR1RtRecord_recipientMmsRSAddress,
        _MMR1RtRecord_messageID,
        _MMR1RtRecord_replyChargingID,
        _MMR1RtRecord_senderAddress,
        _MMR1RtRecord_recipientAddress,
        _MMR1RtRecord_accessCorrelation,
        _MMR1RtRecord_contentType,
        _MMR1RtRecord_mmComponentType,
        _MMR1RtRecord_messageClass,
        _MMR1RtRecord_submissionTime,
        _MMR1RtRecord_messageSize,
        _MMR1RtRecord_deliveryReportRequested,
        _MMR1RtRecord_priority,
        _MMR1RtRecord_readReplyRequested,
        _MMR1RtRecord_mmStatusCode,
        _MMR1RtRecord_statusText,
        _MMR1RtRecord_replyDeadline,
        _MMR1RtRecord_replyChargingSize,
        _MMR1RtRecord_durationOfTransmission,
        _MMR1RtRecord_timeOfExpiry,
        _MMR1RtRecord_recordTimeStamp,
        _MMR1RtRecord_localSequenceNumber,
        _MMR1RtRecord_recordExtensions,
        _MMR1RtRecord_messageReference,
        _MMR1RtRecord_vaspID,
        _MMR1RtRecord_vasID,
        _MMR1RtRecord_sGSNPLMNIdentifier,
        _MMR1RtRecord_rATType,
        _MMR1RtRecord_mSTimeZone,
        MMR1RtRecord,
        _MMR1ARecord_recordType,
        _MMR1ARecord_recipientMmsRSAddress,
        _MMR1ARecord_messageID,
        _MMR1ARecord_recipientAddress,
        _MMR1ARecord_accessCorrelation,
        _MMR1ARecord_reportAllowed,
        _MMR1ARecord_mmStatusCode,
        _MMR1ARecord_statusText,
        _MMR1ARecord_recordTimeStamp,
        _MMR1ARecord_localSequenceNumber,
        _MMR1ARecord_recordExtensions,
        _MMR1ARecord_sGSNPLMNIdentifier,
        _MMR1ARecord_rATType,
        _MMR1ARecord_mSTimeZone,
        MMR1ARecord,
        _MMR4DRqRecord_recordType,
        _MMR4DRqRecord_recipientMmsRSAddress,
        _MMR4DRqRecord_originatorMmsRSAddress,
        _MMR4DRqRecord_messageID,
        _MMR4DRqRecord_mms3GPPVersion,
        _MMR4DRqRecord_originatorAddress,
        _MMR4DRqRecord_recipientAddress,
        _MMR4DRqRecord_mmDateAndTime,
        _MMR4DRqRecord_acknowledgementRequest,
        _MMR4DRqRecord_mmStatusCode,
        _MMR4DRqRecord_statusText,
        _MMR4DRqRecord_recordTimeStamp,
        _MMR4DRqRecord_localSequenceNumber,
        _MMR4DRqRecord_recordExtensions,
        MMR4DRqRecord,
        _MMR4DRsRecord_recordType,
        _MMR4DRsRecord_recipientMmsRSAddress,
        _MMR4DRsRecord_originatorMmsRSAddress,
        _MMR4DRsRecord_messageID,
        _MMR4DRsRecord_mms3GPPVersion,
        _MMR4DRsRecord_requestStatusCode,
        _MMR4DRsRecord_statusText,
        _MMR4DRsRecord_recordTimeStamp,
        _MMR4DRsRecord_localSequenceNumber,
        _MMR4DRsRecord_recordExtensions,
        MMR4DRsRecord,
        _MMR1RRRecord_recordType,
        _MMR1RRRecord_recipientMmsRSAddress,
        _MMR1RRRecord_messageID,
        _MMR1RRRecord_recipientAddress,
        _MMR1RRRecord_originatorAddress,
        _MMR1RRRecord_accessCorrelation,
        _MMR1RRRecord_mmStatusCode,
        _MMR1RRRecord_statusText,
        _MMR1RRRecord_recordTimeStamp,
        _MMR1RRRecord_localSequenceNumber,
        _MMR1RRRecord_recordExtensions,
        _MMR1RRRecord_sGSNPLMNIdentifier,
        _MMR1RRRecord_rATType,
        _MMR1RRRecord_mSTimeZone,
        MMR1RRRecord,
        _MMR4RRqRecord_recordType,
        _MMR4RRqRecord_recipientMmsRSAddress,
        _MMR4RRqRecord_originatorMmsRSAddress,
        _MMR4RRqRecord_messageID,
        _MMR4RRqRecord_mms3GPPVersion,
        _MMR4RRqRecord_originatorAddress,
        _MMR4RRqRecord_recipientAddress,
        _MMR4RRqRecord_mmDateAndTime,
        _MMR4RRqRecord_acknowledgementRequest,
        _MMR4RRqRecord_mmStatusCode,
        _MMR4RRqRecord_statusText,
        _MMR4RRqRecord_recordTimeStamp,
        _MMR4RRqRecord_localSequenceNumber,
        _MMR4RRqRecord_recordExtensions,
        MMR4RRqRecord,
        _MMR4RRsRecord_recordType,
        _MMR4RRsRecord_recipientMmsRSAddress,
        _MMR4RRsRecord_originatorMmsRSAddress,
        _MMR4RRsRecord_messageID,
        _MMR4RRsRecord_mms3GPPVersion,
        _MMR4RRsRecord_requestStatusCode,
        _MMR4RRsRecord_statusText,
        _MMR4RRsRecord_recordTimeStamp,
        _MMR4RRsRecord_localSequenceNumber,
        _MMR4RRsRecord_recordExtensions,
        MMR4RRsRecord,
        _MMRMDRecord_recordType,
        _MMRMDRecord_originatorMmsRSAddress,
        _MMRMDRecord_recipientMmsRSAddress,
        _MMRMDRecord_messageID,
        _MMRMDRecord_messageSize,
        _MMRMDRecord_mmStatusCode,
        _MMRMDRecord_statusText,
        _MMRMDRecord_recordTimeStamp,
        _MMRMDRecord_localSequenceNumber,
        _MMRMDRecord_recordExtensions,
        MMRMDRecord,
        _MMFRecord_recordType,
        _MMFRecord_forwardingMmsRSAddress,
        _MMFRecord_messageID,
        _MMFRecord_forwardingAddress,
        _MMFRecord_recipientAddresses,
        _MMFRecord_chargeInformation,
        _MMFRecord_timeOfExpiry,
        _MMFRecord_earliestTimeOfDelivery,
        _MMFRecord_deliveryReportRequested,
        _MMFRecord_readReplyRequested,
        _MMFRecord_messageReference,
        _MMFRecord_mmStatusCode,
        _MMFRecord_statusText,
        _MMFRecord_recordTimeStamp,
        _MMFRecord_localSequenceNumber,
        _MMFRecord_recordExtensions,
        _MMFRecord_mMBoxstorageInformation,
        MMFRecord,
        _MMBx1SRecord_recordType,
        _MMBx1SRecord_mmsRelayAddress,
        _MMBx1SRecord_managingAddress,
        _MMBx1SRecord_accessCorrelation,
        _MMBx1SRecord_contentType,
        _MMBx1SRecord_messageSize,
        _MMBx1SRecord_messageReference,
        _MMBx1SRecord_mmState,
        _MMBx1SRecord_mmFlags,
        _MMBx1SRecord_storeStatus,
        _MMBx1SRecord_storeStatusText,
        _MMBx1SRecord_sequenceNumber,
        _MMBx1SRecord_timeStamp,
        _MMBx1SRecord_recordExtensions,
        _MMBx1SRecord_sGSNPLMNIdentifier,
        _MMBx1SRecord_rATType,
        _MMBx1SRecord_mSTimeZone,
        MMBx1SRecord,
        _MMBx1VRecord_recordType,
        _MMBx1VRecord_mmsRelayAddress,
        _MMBx1VRecord_managingAddress,
        _MMBx1VRecord_accessCorrelation,
        _MMBx1VRecord_attributesList,
        _MMBx1VRecord_messageSelection,
        _MMBx1VRecord_start,
        _MMBx1VRecord_limit,
        _MMBx1VRecord_totalsRequested,
        _MMBx1VRecord_quotasRequested,
        _MMBx1VRecord_mmListing,
        _MMBx1VRecord_requestStatusCode,
        _MMBx1VRecord_statusText,
        _MMBx1VRecord_totals,
        _MMBx1VRecord_quotas,
        _MMBx1VRecord_sequenceNumber,
        _MMBx1VRecord_timeStamp,
        _MMBx1VRecord_recordExtensions,
        _MMBx1VRecord_sGSNPLMNIdentifier,
        _MMBx1VRecord_rATType,
        _MMBx1VRecord_mSTimeZone,
        MMBx1VRecord,
        _MMBx1URecord_recordType,
        _MMBx1URecord_mmsRelayAddress,
        _MMBx1URecord_managingAddress,
        _MMBx1URecord_accessCorrelation,
        _MMBx1URecord_recipientsAddressList,
        _MMBx1URecord_messageClass,
        _MMBx1URecord_uploadTime,
        _MMBx1URecord_timeOfExpiry,
        _MMBx1URecord_earliestTimeOfDelivery,
        _MMBx1URecord_priority,
        _MMBx1URecord_mmState,
        _MMBx1URecord_mmFlags,
        _MMBx1URecord_contentType,
        _MMBx1URecord_messageSize,
        _MMBx1URecord_messageReference,
        _MMBx1URecord_requestStatusCode,
        _MMBx1URecord_statusText,
        _MMBx1URecord_sequenceNumber,
        _MMBx1URecord_timeStamp,
        _MMBx1URecord_recordExtensions,
        _MMBx1URecord_sGSNPLMNIdentifier,
        _MMBx1URecord_rATType,
        _MMBx1URecord_mSTimeZone,
        MMBx1URecord,
        _MMBx1DRecord_recordType,
        _MMBx1DRecord_mmsRelayAddress,
        _MMBx1DRecord_managingAddress,
        _MMBx1DRecord_accessCorrelation,
        _MMBx1DRecord_messageReference,
        _MMBx1DRecord_requestStatusCode,
        _MMBx1DRecord_statusText,
        _MMBx1DRecord_sequenceNumber,
        _MMBx1DRecord_timeStamp,
        _MMBx1DRecord_recordExtensions,
        _MMBx1DRecord_sGSNPLMNIdentifier,
        _MMBx1DRecord_rATType,
        _MMBx1DRecord_mSTimeZone,
        MMBx1DRecord,
        _MM7SRecord_recordType,
        _MM7SRecord_originatorMmsRSAddress,
        _MM7SRecord_linkedID,
        _MM7SRecord_vaspID,
        _MM7SRecord_vasID,
        _MM7SRecord_messageID,
        _MM7SRecord_originatorAddress,
        _MM7SRecord_recipientAddresses,
        _MM7SRecord_serviceCode,
        _MM7SRecord_contentType,
        _MM7SRecord_mmComponentType,
        _MM7SRecord_messageSize,
        _MM7SRecord_messageClass,
        _MM7SRecord_chargeInformation,
        _MM7SRecord_submissionTime,
        _MM7SRecord_timeOfExpiry,
        _MM7SRecord_earliestTimeOfDelivery,
        _MM7SRecord_deliveryReportRequested,
        _MM7SRecord_readReplyRequested,
        _MM7SRecord_replyCharging,
        _MM7SRecord_replyDeadline,
        _MM7SRecord_replyChargingSize,
        _MM7SRecord_priority,
        _MM7SRecord_messageDistributionIndicator,
        _MM7SRecord_requestStatusCode,
        _MM7SRecord_statusText,
        _MM7SRecord_recordTimeStamp,
        _MM7SRecord_localSequenceNumber,
        _MM7SRecord_recordExtensions,
        _MM7SRecord_mscfInformation,
        MM7SRecord,
        _MM7DRqRecord_recordType,
        _MM7DRqRecord_recipientMmsRSAddress,
        _MM7DRqRecord_linkedID,
        _MM7DRqRecord_replyChargingID,
        _MM7DRqRecord_originatorAddress,
        _MM7DRqRecord_recipientAddress,
        _MM7DRqRecord_mmComponentType,
        _MM7DRqRecord_messageSize,
        _MM7DRqRecord_contentType,
        _MM7DRqRecord_priority,
        _MM7DRqRecord_recordTimeStamp,
        _MM7DRqRecord_localSequenceNumber,
        _MM7DRqRecord_recordExtensions,
        MM7DRqRecord,
        _MM7DRsRecord_recordType,
        _MM7DRsRecord_recipientMmsRSAddress,
        _MM7DRsRecord_messageID,
        _MM7DRsRecord_recipientAddress,
        _MM7DRsRecord_serviceCode,
        _MM7DRsRecord_requestStatusCode,
        _MM7DRsRecord_statusText,
        _MM7DRsRecord_recordTimeStamp,
        _MM7DRsRecord_localSequenceNumber,
        _MM7DRsRecord_recordExtensions,
        MM7DRsRecord,
        _MM7CRecord_recordType,
        _MM7CRecord_originatorMmsRSAddress,
        _MM7CRecord_vaspID,
        _MM7CRecord_vasID,
        _MM7CRecord_messageID,
        _MM7CRecord_originatorAddress,
        _MM7CRecord_serviceCode,
        _MM7CRecord_requestStatusCode,
        _MM7CRecord_statusText,
        _MM7CRecord_recordTimeStamp,
        _MM7CRecord_localSequenceNumber,
        _MM7CRecord_recordExtensions,
        MM7CRecord,
        _MM7RRecord_recordType,
        _MM7RRecord_originatorMmsRSAddress,
        _MM7RRecord_vaspID,
        _MM7RRecord_vasID,
        _MM7RRecord_messageID,
        _MM7RRecord_originatorAddress,
        _MM7RRecord_serviceCode,
        _MM7RRecord_contentType,
        _MM7RRecord_submissionTime,
        _MM7RRecord_timeOfExpiry,
        _MM7RRecord_earliestTimeOfDelivery,
        _MM7RRecord_requestStatusCode,
        _MM7RRecord_statusText,
        _MM7RRecord_recordTimeStamp,
        _MM7RRecord_localSequenceNumber,
        _MM7RRecord_recordExtensions,
        MM7RRecord,
        _MM7DRRqRecord_recordType,
        _MM7DRRqRecord_recipientMmsRSAddress,
        _MM7DRRqRecord_messageID,
        _MM7DRRqRecord_originatorAddress,
        _MM7DRRqRecord_recipientAddress,
        _MM7DRRqRecord_mmDateAndTime,
        _MM7DRRqRecord_mmStatusCode,
        _MM7DRRqRecord_mmStatusText,
        _MM7DRRqRecord_recordTimeStamp,
        _MM7DRRqRecord_localSequenceNumber,
        _MM7DRRqRecord_recordExtensions,
        MM7DRRqRecord,
        _MM7DRRsRecord_recordType,
        _MM7DRRsRecord_recipientMmsRSAddress,
        _MM7DRRsRecord_messageID,
        _MM7DRRsRecord_originatorAddress,
        _MM7DRRsRecord_recipientAddress,
        _MM7DRRsRecord_requestStatusCode,
        _MM7DRRsRecord_statusText,
        _MM7DRRsRecord_recordTimeStamp,
        _MM7DRRsRecord_localSequenceNumber,
        _MM7DRRsRecord_recordExtensions,
        MM7DRRsRecord,
        _MM7RRqRecord_recordType,
        _MM7RRqRecord_recipientMmsRSAddress,
        _MM7RRqRecord_messageID,
        _MM7RRqRecord_originatorAddress,
        _MM7RRqRecord_recipientAddress,
        _MM7RRqRecord_mmDateAndTime,
        _MM7RRqRecord_readStatus,
        _MM7RRqRecord_mmStatusText,
        _MM7RRqRecord_recordTimeStamp,
        _MM7RRqRecord_localSequenceNumber,
        _MM7RRqRecord_recordExtensions,
        MM7RRqRecord,
        _MM7RRsRecord_recordType,
        _MM7RRsRecord_recipientMmsRSAddress,
        _MM7RRsRecord_messageID,
        _MM7RRsRecord_originatorAddress,
        _MM7RRsRecord_recipientAddress,
        _MM7RRsRecord_requestStatusCode,
        _MM7RRsRecord_statusText,
        _MM7RRsRecord_recordTimeStamp,
        _MM7RRsRecord_localSequenceNumber,
        _MM7RRsRecord_recordExtensions,
        MM7RRsRecord,
        _AccessCorrelation_circuitSwitched,
        _AccessCorrelation_packetSwitched,
        AccessCorrelation,
        _AttributesList_messageID,
        _AttributesList_dateAndTime,
        _AttributesList_senderAddress,
        _AttributesList_subject,
        _AttributesList_messageSize,
        _AttributesList_mmFlags,
        _AttributesList_mmState,
        AttributesList,
        _ChargeInformation_chargedparty,
        _ChargeInformation_chargetype,
        ChargeInformation,
        ChargedParty,
        ChargeType,
        _CircuitSwitchedAccess_mSCIdentifier,
        _CircuitSwitchedAccess_callReferenceNumber,
        CircuitSwitchedAccess,
        ContentType,
        DataVolume,
        DeltaSeconds,
        _MediaComponent_mediaType,
        _MediaComponent_mediaSize,
        MediaComponent,
        _MediaComponents__item_,
        MediaComponents,
        MessageSelection,
        _MMBoxStorageInformation_mmState,
        _MMBoxStorageInformation_mmFlag,
        _MMBoxStorageInformation_storeStatus,
        _MMBoxStorageInformation_storeStatusText,
        _MMBoxStorageInformation_storedMessageReference,
        MMBoxStorageInformation,
        _MMComponentType_subject,
        _MMComponentType_media,
        MMComponentType,
        _MMSAgentAddress_mMSAgentAddressData,
        __MMSAgentAddress_mMSRecipientType__item_,
        _MMSAgentAddress_mMSRecipientType,
        MMSAgentAddress,
        _MMSAgentAddresses__item_,
        MMSAgentAddresses,
        _MMSAgentAddressData_eMail_address,
        _MMSAgentAddressData_mSISDN,
        _MMSAgentAddressData_shortCode,
        MMSAgentAddressData,
        MMSRecipientType,
        _MMSRSAddress_domainName,
        _MMSRSAddress_iPAddress,
        MMSRSAddress,
        MMState,
        MMStatusCodeType,
        _MSCFInformation_billingInformation,
        _MSCFInformation_routeingAddressList,
        MSCFInformation,
        _PacketSwitchedAccess_gSNAddress,
        _PacketSwitchedAccess_chargingID,
        PacketSwitchedAccess,
        _Quotas_numberOfMessages,
        _Quotas_numberOfOctets,
        Quotas,
        RequestStatusCodeType,
        _RouteingAddress_eMail_address,
        _RouteingAddress_mSISDN,
        _RouteingAddress_shortCode,
        RouteingAddress,
        _RouteingAddressList__item_,
        RouteingAddressList,
        StatusTextType,
        StoreStatus,
        _SubjectComponent_subjectType,
        _SubjectComponent_subjectSize,
        SubjectComponent,
        _Totals_numberOfMessages,
        _Totals_numberOfOctets,
        Totals,
        _WaitTime_http_date,
        _WaitTime_delta_seconds,
        WaitTime,
    ]

class MMTelChargingDataTypes:

    _name_  = u'MMTelChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 9, 0, 1]
    
    _obj_ = [
        u'MMTelServiceRecord',
        u'MMTelRecord',
        u'MMTelInformation',
        u'ParticipantActionType',
        u'SupplService',
        u'ServiceType',
        u'ServiceMode',
        ]
    _type_ = [
        u'MMTelServiceRecord',
        u'MMTelRecord',
        u'MMTelInformation',
        u'ParticipantActionType',
        u'SupplService',
        u'ServiceType',
        u'ServiceMode',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< MMTelServiceRecord >-----#
    MMTelServiceRecord = CHOICE(name=u'MMTelServiceRecord', mode=MODE_TYPE)
    _MMTelServiceRecord_mMTelRecord = SET(name=u'mMTelRecord', mode=MODE_TYPE, tag=(83, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMTelChargingDataTypes', 'MMTelRecord')))
    MMTelServiceRecord._cont = ASN1Dict([
        (u'mMTelRecord', _MMTelServiceRecord_mMTelRecord),
        ])
    MMTelServiceRecord._ext = None
    
    #-----< MMTelRecord >-----#
    MMTelRecord = SET(name=u'MMTelRecord', mode=MODE_TYPE)
    _MMTelRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MMTelRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_sIP_Method = STR_GRAPH(name=u'sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _MMTelRecord_role_of_Node = ENUM(name=u'role-of-Node', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Role-of-Node')), opt=True)
    _MMTelRecord_nodeAddress = CHOICE(name=u'nodeAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _MMTelRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _MMTelRecord_list_Of_Calling_Party_Address = SEQ_OF(name=u'list-Of-Calling-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _MMTelRecord_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _MMTelRecord_serviceRequestTimeStamp = OCT_STR(name=u'serviceRequestTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMTelRecord_serviceDeliveryStartTimeStamp = OCT_STR(name=u'serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMTelRecord_serviceDeliveryEndTimeStamp = OCT_STR(name=u'serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMTelRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMTelRecord_recordClosureTime = OCT_STR(name=u'recordClosureTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MMTelRecord_interOperatorIdentifiers = SEQ_OF(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifierList')), opt=True)
    _MMTelRecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MMTelRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_causeForRecordClosing = ENUM(name=u'causeForRecordClosing', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _MMTelRecord_incomplete_CDR_Indication = SET(name=u'incomplete-CDR-Indication', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _MMTelRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _MMTelRecord_list_Of_SDP_Media_Components = SEQ_OF(name=u'list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MMTelRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _MMTelRecord_list_Of_SDP_Media_Components._cont = __MMTelRecord_list_Of_SDP_Media_Components__item_
    _MMTelRecord_gGSNaddress = CHOICE(name=u'gGSNaddress', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _MMTelRecord_serviceReasonReturnCode = STR_UTF8(name=u'serviceReasonReturnCode', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_list_Of_Message_Bodies = SEQ_OF(name=u'list-Of-Message-Bodies', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MMTelRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _MMTelRecord_list_Of_Message_Bodies._cont = __MMTelRecord_list_Of_Message_Bodies__item_
    _MMTelRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _MMTelRecord_expiresInformation = INT(name=u'expiresInformation', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_event = STR_UTF8(name=u'event', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_accessNetworkInformation = OCT_STR(name=u'accessNetworkInformation', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _MMTelRecord_list_of_subscription_ID = SEQ_OF(name=u'list-of-subscription-ID', mode=MODE_TYPE, tag=(31, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MMTelRecord_list_of_subscription_ID__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')))
    _MMTelRecord_list_of_subscription_ID._cont = __MMTelRecord_list_of_subscription_ID__item_
    _MMTelRecord_list_Of_Early_SDP_Media_Components = SEQ_OF(name=u'list-Of-Early-SDP-Media-Components', mode=MODE_TYPE, tag=(32, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MMTelRecord_list_Of_Early_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Early-Media-Components-List')))
    _MMTelRecord_list_Of_Early_SDP_Media_Components._cont = __MMTelRecord_list_Of_Early_SDP_Media_Components__item_
    _MMTelRecord_iMSCommunicationServiceIdentifier = OCT_STR(name=u'iMSCommunicationServiceIdentifier', mode=MODE_TYPE, tag=(33, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMSCommunicationServiceIdentifier')), opt=True)
    _MMTelRecord_numberPortabilityRouting = STR_GRAPH(name=u'numberPortabilityRouting', mode=MODE_TYPE, tag=(34, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _MMTelRecord_carrierSelectRouting = STR_GRAPH(name=u'carrierSelectRouting', mode=MODE_TYPE, tag=(35, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _MMTelRecord_sessionPriority = ENUM(name=u'sessionPriority', mode=MODE_TYPE, tag=(36, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SessionPriority')), opt=True)
    _MMTelRecord_serviceRequestTimeStampFraction = INT(name=u'serviceRequestTimeStampFraction', mode=MODE_TYPE, tag=(37, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MMTelRecord_serviceDeliveryStartTimeStampFraction = INT(name=u'serviceDeliveryStartTimeStampFraction', mode=MODE_TYPE, tag=(38, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MMTelRecord_serviceDeliveryEndTimeStampFraction = INT(name=u'serviceDeliveryEndTimeStampFraction', mode=MODE_TYPE, tag=(39, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Milliseconds')), opt=True)
    _MMTelRecord_online_charging_flag = NULL(name=u'online-charging-flag', mode=MODE_TYPE, tag=(43, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_realTimeTariffInformation = SEQ_OF(name=u'realTimeTariffInformation', mode=MODE_TYPE, tag=(44, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MMTelRecord_realTimeTariffInformation__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'RealTimeTariffInformation')))
    _MMTelRecord_realTimeTariffInformation._cont = __MMTelRecord_realTimeTariffInformation__item_
    _MMTelRecord_transit_IOI_Lists = SEQ_OF(name=u'transit-IOI-Lists', mode=MODE_TYPE, tag=(53, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'TransitIOILists')), opt=True)
    _MMTelRecord_iMSVisitedNetworkIdentifier = OCT_STR(name=u'iMSVisitedNetworkIdentifier', mode=MODE_TYPE, tag=(54, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_listOfReasonHeader = SEQ_OF(name=u'listOfReasonHeader', mode=MODE_TYPE, tag=(55, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfReasonHeader')), opt=True)
    _MMTelRecord_additionalAccessNetworkInformation = OCT_STR(name=u'additionalAccessNetworkInformation', mode=MODE_TYPE, tag=(56, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_instanceId = OCT_STR(name=u'instanceId', mode=MODE_TYPE, tag=(57, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_subscriberEquipmentNumber = SET(name=u'subscriberEquipmentNumber', mode=MODE_TYPE, tag=(58, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentNumber')), opt=True)
    _MMTelRecord_cellularNetworkInformation = OCT_STR(name=u'cellularNetworkInformation', mode=MODE_TYPE, tag=(64, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMTelRecord_requested_Party_Address = CHOICE(name=u'requested-Party-Address', mode=MODE_TYPE, tag=(101, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _MMTelRecord_list_Of_Called_Asserted_Identity = SEQ_OF(name=u'list-Of-Called-Asserted-Identity', mode=MODE_TYPE, tag=(102, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'ListOfInvolvedParties')), opt=True)
    _MMTelRecord_outgoingSessionId = STR_GRAPH(name=u'outgoingSessionId', mode=MODE_TYPE, tag=(104, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _MMTelRecord_mMTelInformation = SET(name=u'mMTelInformation', mode=MODE_TYPE, tag=(110, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMTelChargingDataTypes', 'MMTelInformation')), opt=True)
    _MMTelRecord_threeGPPPSDataOffStatus = ENUM(name=u'threeGPPPSDataOffStatus', mode=MODE_TYPE, tag=(112, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ThreeGPPPSDataOffStatus')), opt=True)
    _MMTelRecord_fEIdentifierList = SEQ_OF(name=u'fEIdentifierList', mode=MODE_TYPE, tag=(113, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'FEIdentifierList')), opt=True)
    MMTelRecord._cont = ASN1Dict([
        (u'recordType', _MMTelRecord_recordType),
        (u'retransmission', _MMTelRecord_retransmission),
        (u'sIP-Method', _MMTelRecord_sIP_Method),
        (u'role-of-Node', _MMTelRecord_role_of_Node),
        (u'nodeAddress', _MMTelRecord_nodeAddress),
        (u'session-Id', _MMTelRecord_session_Id),
        (u'list-Of-Calling-Party-Address', _MMTelRecord_list_Of_Calling_Party_Address),
        (u'called-Party-Address', _MMTelRecord_called_Party_Address),
        (u'serviceRequestTimeStamp', _MMTelRecord_serviceRequestTimeStamp),
        (u'serviceDeliveryStartTimeStamp', _MMTelRecord_serviceDeliveryStartTimeStamp),
        (u'serviceDeliveryEndTimeStamp', _MMTelRecord_serviceDeliveryEndTimeStamp),
        (u'recordOpeningTime', _MMTelRecord_recordOpeningTime),
        (u'recordClosureTime', _MMTelRecord_recordClosureTime),
        (u'interOperatorIdentifiers', _MMTelRecord_interOperatorIdentifiers),
        (u'localRecordSequenceNumber', _MMTelRecord_localRecordSequenceNumber),
        (u'recordSequenceNumber', _MMTelRecord_recordSequenceNumber),
        (u'causeForRecordClosing', _MMTelRecord_causeForRecordClosing),
        (u'incomplete-CDR-Indication', _MMTelRecord_incomplete_CDR_Indication),
        (u'iMS-Charging-Identifier', _MMTelRecord_iMS_Charging_Identifier),
        (u'list-Of-SDP-Media-Components', _MMTelRecord_list_Of_SDP_Media_Components),
        (u'gGSNaddress', _MMTelRecord_gGSNaddress),
        (u'serviceReasonReturnCode', _MMTelRecord_serviceReasonReturnCode),
        (u'list-Of-Message-Bodies', _MMTelRecord_list_Of_Message_Bodies),
        (u'recordExtensions', _MMTelRecord_recordExtensions),
        (u'expiresInformation', _MMTelRecord_expiresInformation),
        (u'event', _MMTelRecord_event),
        (u'accessNetworkInformation', _MMTelRecord_accessNetworkInformation),
        (u'serviceContextID', _MMTelRecord_serviceContextID),
        (u'list-of-subscription-ID', _MMTelRecord_list_of_subscription_ID),
        (u'list-Of-Early-SDP-Media-Components', _MMTelRecord_list_Of_Early_SDP_Media_Components),
        (u'iMSCommunicationServiceIdentifier', _MMTelRecord_iMSCommunicationServiceIdentifier),
        (u'numberPortabilityRouting', _MMTelRecord_numberPortabilityRouting),
        (u'carrierSelectRouting', _MMTelRecord_carrierSelectRouting),
        (u'sessionPriority', _MMTelRecord_sessionPriority),
        (u'serviceRequestTimeStampFraction', _MMTelRecord_serviceRequestTimeStampFraction),
        (u'serviceDeliveryStartTimeStampFraction', _MMTelRecord_serviceDeliveryStartTimeStampFraction),
        (u'serviceDeliveryEndTimeStampFraction', _MMTelRecord_serviceDeliveryEndTimeStampFraction),
        (u'online-charging-flag', _MMTelRecord_online_charging_flag),
        (u'realTimeTariffInformation', _MMTelRecord_realTimeTariffInformation),
        (u'transit-IOI-Lists', _MMTelRecord_transit_IOI_Lists),
        (u'iMSVisitedNetworkIdentifier', _MMTelRecord_iMSVisitedNetworkIdentifier),
        (u'listOfReasonHeader', _MMTelRecord_listOfReasonHeader),
        (u'additionalAccessNetworkInformation', _MMTelRecord_additionalAccessNetworkInformation),
        (u'instanceId', _MMTelRecord_instanceId),
        (u'subscriberEquipmentNumber', _MMTelRecord_subscriberEquipmentNumber),
        (u'cellularNetworkInformation', _MMTelRecord_cellularNetworkInformation),
        (u'requested-Party-Address', _MMTelRecord_requested_Party_Address),
        (u'list-Of-Called-Asserted-Identity', _MMTelRecord_list_Of_Called_Asserted_Identity),
        (u'outgoingSessionId', _MMTelRecord_outgoingSessionId),
        (u'mMTelInformation', _MMTelRecord_mMTelInformation),
        (u'threeGPPPSDataOffStatus', _MMTelRecord_threeGPPPSDataOffStatus),
        (u'fEIdentifierList', _MMTelRecord_fEIdentifierList),
        ])
    MMTelRecord._ext = None
    
    #-----< MMTelInformation >-----#
    MMTelInformation = SET(name=u'MMTelInformation', mode=MODE_TYPE)
    _MMTelInformation_listOfSupplServices = SEQ_OF(name=u'listOfSupplServices', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MMTelInformation_listOfSupplServices__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MMTelChargingDataTypes', 'SupplService')))
    _MMTelInformation_listOfSupplServices._cont = __MMTelInformation_listOfSupplServices__item_
    MMTelInformation._cont = ASN1Dict([
        (u'listOfSupplServices', _MMTelInformation_listOfSupplServices),
        ])
    MMTelInformation._ext = None
    
    #-----< ParticipantActionType >-----#
    ParticipantActionType = ENUM(name=u'ParticipantActionType', mode=MODE_TYPE)
    ParticipantActionType._cont = ASN1Dict([(u'cREATE-CONF', 0), (u'jOIN-CONF', 1), (u'iNVITED-INTO-CONF', 2), (u'qUIT-CONF', 3)])
    ParticipantActionType._ext = None
    
    #-----< SupplService >-----#
    SupplService = SET(name=u'SupplService', mode=MODE_TYPE)
    _SupplService_serviceType = INT(name=u'serviceType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMTelChargingDataTypes', 'ServiceType')))
    _SupplService_serviceMode = INT(name=u'serviceMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMTelChargingDataTypes', 'ServiceMode')), opt=True)
    _SupplService_numberOfDiversions = INT(name=u'numberOfDiversions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SupplService_associated_Party_Address = CHOICE(name=u'associated-Party-Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _SupplService_serviceId = STR_GRAPH(name=u'serviceId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Service-Id')), opt=True)
    _SupplService_changeTime = OCT_STR(name=u'changeTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SupplService_numberOfParticipants = INT(name=u'numberOfParticipants', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SupplService_participantActionType = ENUM(name=u'participantActionType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MMTelChargingDataTypes', 'ParticipantActionType')), opt=True)
    _SupplService_cUGInformation = OCT_STR(name=u'cUGInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SupplService_aoCInformation = SEQ_OF(name=u'aoCInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SupplService_aoCInformation__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'AoCInformation')))
    _SupplService_aoCInformation._cont = __SupplService_aoCInformation__item_
    SupplService._cont = ASN1Dict([
        (u'serviceType', _SupplService_serviceType),
        (u'serviceMode', _SupplService_serviceMode),
        (u'numberOfDiversions', _SupplService_numberOfDiversions),
        (u'associated-Party-Address', _SupplService_associated_Party_Address),
        (u'serviceId', _SupplService_serviceId),
        (u'changeTime', _SupplService_changeTime),
        (u'numberOfParticipants', _SupplService_numberOfParticipants),
        (u'participantActionType', _SupplService_participantActionType),
        (u'cUGInformation', _SupplService_cUGInformation),
        (u'aoCInformation', _SupplService_aoCInformation),
        ])
    SupplService._ext = None
    
    #-----< ServiceType >-----#
    ServiceType = INT(name=u'ServiceType', mode=MODE_TYPE)
    ServiceType._cont = ASN1Dict([(u'oIPresentation', 0), (u'oIRestriction', 1), (u'tIPresentation', 2), (u'tIRestriction', 3), (u'hOLD', 4), (u'cBarring', 5), (u'cDIVersion', 6), (u'cWaiting', 8), (u'mWaitingIndic', 9), (u'cONF', 10), (u'fLexibleAlerting', 11), (u'cCBS', 12), (u'cCNR', 13), (u'mCID', 14), (u'cAT', 15), (u'cUG', 16), (u'pNM', 17), (u'cRS', 18), (u'aoC', 19), (u'eCT', 20)])
    
    #-----< ServiceMode >-----#
    ServiceMode = INT(name=u'ServiceMode', mode=MODE_TYPE)
    ServiceMode._cont = ASN1Dict([(u'cFunCond', 0), (u'cFbusy', 1), (u'cFnoReply', 2), (u'cFnotLogged', 3), (u'deflection', 4), (u'notReach', 5), (u'iCBarring', 6), (u'oCBarring', 7), (u'aCRejection', 8), (u'eCTBlind', 9), (u'eCTConsultative', 10), (u'threePTY', 11), (u'aoC-S', 12), (u'aoC-D', 13), (u'aoC-E', 14)])
    
    _all_ = [
        _MMTelServiceRecord_mMTelRecord,
        MMTelServiceRecord,
        _MMTelRecord_recordType,
        _MMTelRecord_retransmission,
        _MMTelRecord_sIP_Method,
        _MMTelRecord_role_of_Node,
        _MMTelRecord_nodeAddress,
        _MMTelRecord_session_Id,
        _MMTelRecord_list_Of_Calling_Party_Address,
        _MMTelRecord_called_Party_Address,
        _MMTelRecord_serviceRequestTimeStamp,
        _MMTelRecord_serviceDeliveryStartTimeStamp,
        _MMTelRecord_serviceDeliveryEndTimeStamp,
        _MMTelRecord_recordOpeningTime,
        _MMTelRecord_recordClosureTime,
        _MMTelRecord_interOperatorIdentifiers,
        _MMTelRecord_localRecordSequenceNumber,
        _MMTelRecord_recordSequenceNumber,
        _MMTelRecord_causeForRecordClosing,
        _MMTelRecord_incomplete_CDR_Indication,
        _MMTelRecord_iMS_Charging_Identifier,
        __MMTelRecord_list_Of_SDP_Media_Components__item_,
        _MMTelRecord_list_Of_SDP_Media_Components,
        _MMTelRecord_gGSNaddress,
        _MMTelRecord_serviceReasonReturnCode,
        __MMTelRecord_list_Of_Message_Bodies__item_,
        _MMTelRecord_list_Of_Message_Bodies,
        _MMTelRecord_recordExtensions,
        _MMTelRecord_expiresInformation,
        _MMTelRecord_event,
        _MMTelRecord_accessNetworkInformation,
        _MMTelRecord_serviceContextID,
        __MMTelRecord_list_of_subscription_ID__item_,
        _MMTelRecord_list_of_subscription_ID,
        __MMTelRecord_list_Of_Early_SDP_Media_Components__item_,
        _MMTelRecord_list_Of_Early_SDP_Media_Components,
        _MMTelRecord_iMSCommunicationServiceIdentifier,
        _MMTelRecord_numberPortabilityRouting,
        _MMTelRecord_carrierSelectRouting,
        _MMTelRecord_sessionPriority,
        _MMTelRecord_serviceRequestTimeStampFraction,
        _MMTelRecord_serviceDeliveryStartTimeStampFraction,
        _MMTelRecord_serviceDeliveryEndTimeStampFraction,
        _MMTelRecord_online_charging_flag,
        __MMTelRecord_realTimeTariffInformation__item_,
        _MMTelRecord_realTimeTariffInformation,
        _MMTelRecord_transit_IOI_Lists,
        _MMTelRecord_iMSVisitedNetworkIdentifier,
        _MMTelRecord_listOfReasonHeader,
        _MMTelRecord_additionalAccessNetworkInformation,
        _MMTelRecord_instanceId,
        _MMTelRecord_subscriberEquipmentNumber,
        _MMTelRecord_cellularNetworkInformation,
        _MMTelRecord_requested_Party_Address,
        _MMTelRecord_list_Of_Called_Asserted_Identity,
        _MMTelRecord_outgoingSessionId,
        _MMTelRecord_mMTelInformation,
        _MMTelRecord_threeGPPPSDataOffStatus,
        _MMTelRecord_fEIdentifierList,
        MMTelRecord,
        __MMTelInformation_listOfSupplServices__item_,
        _MMTelInformation_listOfSupplServices,
        MMTelInformation,
        ParticipantActionType,
        _SupplService_serviceType,
        _SupplService_serviceMode,
        _SupplService_numberOfDiversions,
        _SupplService_associated_Party_Address,
        _SupplService_serviceId,
        _SupplService_changeTime,
        _SupplService_numberOfParticipants,
        _SupplService_participantActionType,
        _SupplService_cUGInformation,
        __SupplService_aoCInformation__item_,
        _SupplService_aoCInformation,
        SupplService,
        ServiceType,
        ServiceMode,
    ]

class MONTEChargingDataTypes:

    _name_  = u'MONTEChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 12, 0, 1]
    
    _obj_ = [
        u'MERecordType',
        u'MECORecord',
        u'MERERecord',
        u'Accuracy',
        u'CauseType',
        u'CommunicationFailureInfo',
        u'CurrentLocationRetrieved',
        u'EPSLocationInfo',
        u'LocationType',
        u'MMELocationInformation',
        u'MonitoringEventConfigStatus',
        u'MonitoringEventConfigurationActivity',
        u'MonitoringEventReportData',
        u'MonitoringType',
        u'NumberOfUEPerLocationReport',
        u'ReachabilityConfiguration',
        u'ReachabilityType',
        u'SGSNLocationInformation',
        u'SCEFReferenceID',
        u'ServiceResult',
        ]
    _type_ = [
        u'MERecordType',
        u'MECORecord',
        u'MERERecord',
        u'Accuracy',
        u'CauseType',
        u'CommunicationFailureInfo',
        u'CurrentLocationRetrieved',
        u'EPSLocationInfo',
        u'LocationType',
        u'MMELocationInformation',
        u'MonitoringEventConfigStatus',
        u'MonitoringEventConfigurationActivity',
        u'MonitoringEventReportData',
        u'MonitoringType',
        u'NumberOfUEPerLocationReport',
        u'ReachabilityConfiguration',
        u'ReachabilityType',
        u'SGSNLocationInformation',
        u'SCEFReferenceID',
        u'ServiceResult',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< MERecordType >-----#
    MERecordType = CHOICE(name=u'MERecordType', mode=MODE_TYPE)
    _MERecordType_mECORecord = SET(name=u'mECORecord', mode=MODE_TYPE, tag=(103, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'MECORecord')))
    _MERecordType_mERERecord = SET(name=u'mERERecord', mode=MODE_TYPE, tag=(104, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'MERERecord')))
    MERecordType._cont = ASN1Dict([
        (u'mECORecord', _MERecordType_mECORecord),
        (u'mERERecord', _MERecordType_mERERecord),
        ])
    MERecordType._ext = None
    
    #-----< MECORecord >-----#
    MECORecord = SET(name=u'MECORecord', mode=MODE_TYPE)
    _MECORecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MECORecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MECORecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _MECORecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _MECORecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MECORecord_eventTimestamp = OCT_STR(name=u'eventTimestamp', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MECORecord_monitoringEventConfigurationActivity = ENUM(name=u'monitoringEventConfigurationActivity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'MonitoringEventConfigurationActivity')), opt=True)
    _MECORecord_sCEFReferenceID = INT(name=u'sCEFReferenceID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'SCEFReferenceID')), opt=True)
    _MECORecord_sCEFID = OCT_STR(name=u'sCEFID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _MECORecord_monitoringType = ENUM(name=u'monitoringType', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'MonitoringType')), opt=True)
    _MECORecord_maximumNumberofReports = INT(name=u'maximumNumberofReports', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MECORecord_monitoringDuration = OCT_STR(name=u'monitoringDuration', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MECORecord_chargeablePartyIdentifier = STR_UTF8(name=u'chargeablePartyIdentifier', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MECORecord_monitoredUser = OCT_STR(name=u'monitoredUser', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MECORecord_maximumDetectionTime = INT(name=u'maximumDetectionTime', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MECORecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MECORecord_reachabilityConfiguration = SEQ(name=u'reachabilityConfiguration', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'ReachabilityConfiguration')), opt=True)
    _MECORecord_locationType = ENUM(name=u'locationType', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'LocationType')), opt=True)
    _MECORecord_accuracy = ENUM(name=u'accuracy', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'Accuracy')), opt=True)
    _MECORecord_listofLocations = SEQ_OF(name=u'listofLocations', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MECORecord_listofLocations__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MONTEChargingDataTypes', 'EPSLocationInfo')))
    _MECORecord_listofLocations._cont = __MECORecord_listofLocations__item_
    _MECORecord_monitoringEventConfigStatus = SEQ(name=u'monitoringEventConfigStatus', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'MonitoringEventConfigStatus')), opt=True)
    _MECORecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MECORecord._cont = ASN1Dict([
        (u'recordType', _MECORecord_recordType),
        (u'retransmission', _MECORecord_retransmission),
        (u'serviceContextID', _MECORecord_serviceContextID),
        (u'nodeID', _MECORecord_nodeID),
        (u'recordTimeStamp', _MECORecord_recordTimeStamp),
        (u'eventTimestamp', _MECORecord_eventTimestamp),
        (u'monitoringEventConfigurationActivity', _MECORecord_monitoringEventConfigurationActivity),
        (u'sCEFReferenceID', _MECORecord_sCEFReferenceID),
        (u'sCEFID', _MECORecord_sCEFID),
        (u'monitoringType', _MECORecord_monitoringType),
        (u'maximumNumberofReports', _MECORecord_maximumNumberofReports),
        (u'monitoringDuration', _MECORecord_monitoringDuration),
        (u'chargeablePartyIdentifier', _MECORecord_chargeablePartyIdentifier),
        (u'monitoredUser', _MECORecord_monitoredUser),
        (u'maximumDetectionTime', _MECORecord_maximumDetectionTime),
        (u'localRecordSequenceNumber', _MECORecord_localRecordSequenceNumber),
        (u'reachabilityConfiguration', _MECORecord_reachabilityConfiguration),
        (u'locationType', _MECORecord_locationType),
        (u'accuracy', _MECORecord_accuracy),
        (u'listofLocations', _MECORecord_listofLocations),
        (u'monitoringEventConfigStatus', _MECORecord_monitoringEventConfigStatus),
        (u'recordExtensions', _MECORecord_recordExtensions),
        ])
    MECORecord._ext = None
    
    #-----< MERERecord >-----#
    MERERecord = SET(name=u'MERERecord', mode=MODE_TYPE)
    _MERERecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _MERERecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MERERecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _MERERecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _MERERecord_recordTimeStamp = OCT_STR(name=u'recordTimeStamp', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MERERecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _MERERecord_listofMonitoringEventReportData = SEQ_OF(name=u'listofMonitoringEventReportData', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MERERecord_listofMonitoringEventReportData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MONTEChargingDataTypes', 'MonitoringEventReportData')))
    _MERERecord_listofMonitoringEventReportData._cont = __MERERecord_listofMonitoringEventReportData__item_
    _MERERecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    MERERecord._cont = ASN1Dict([
        (u'recordType', _MERERecord_recordType),
        (u'retransmission', _MERERecord_retransmission),
        (u'serviceContextID', _MERERecord_serviceContextID),
        (u'nodeID', _MERERecord_nodeID),
        (u'recordTimeStamp', _MERERecord_recordTimeStamp),
        (u'localRecordSequenceNumber', _MERERecord_localRecordSequenceNumber),
        (u'listofMonitoringEventReportData', _MERERecord_listofMonitoringEventReportData),
        (u'recordExtensions', _MERERecord_recordExtensions),
        ])
    MERERecord._ext = None
    
    #-----< Accuracy >-----#
    Accuracy = ENUM(name=u'Accuracy', mode=MODE_TYPE)
    Accuracy._cont = ASN1Dict([(u'cGIECGI', 0), (u'eNB', 1), (u'lATARA', 2), (u'pRA', 3)])
    Accuracy._ext = None
    
    #-----< CauseType >-----#
    CauseType = ENUM(name=u'CauseType', mode=MODE_TYPE)
    CauseType._cont = ASN1Dict([(u'radioNetworkLayer', 0), (u'transportLayer', 1), (u'nAS', 2), (u'protocol', 3), (u'miscellaneous', 4)])
    CauseType._ext = None
    
    #-----< CommunicationFailureInfo >-----#
    CommunicationFailureInfo = SEQ(name=u'CommunicationFailureInfo', mode=MODE_TYPE)
    _CommunicationFailureInfo_causeType = ENUM(name=u'causeType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'CauseType')), opt=True)
    _CommunicationFailureInfo_s1APCause = INT(name=u's1APCause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CommunicationFailureInfo_rANAPCause = INT(name=u'rANAPCause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CommunicationFailureInfo_bSSGPCause = INT(name=u'bSSGPCause', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CommunicationFailureInfo_gMMCause = INT(name=u'gMMCause', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CommunicationFailureInfo_sMCause = INT(name=u'sMCause', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    CommunicationFailureInfo._cont = ASN1Dict([
        (u'causeType', _CommunicationFailureInfo_causeType),
        (u's1APCause', _CommunicationFailureInfo_s1APCause),
        (u'rANAPCause', _CommunicationFailureInfo_rANAPCause),
        (u'bSSGPCause', _CommunicationFailureInfo_bSSGPCause),
        (u'gMMCause', _CommunicationFailureInfo_gMMCause),
        (u'sMCause', _CommunicationFailureInfo_sMCause),
        ])
    CommunicationFailureInfo._ext = None
    
    #-----< CurrentLocationRetrieved >-----#
    CurrentLocationRetrieved = ENUM(name=u'CurrentLocationRetrieved', mode=MODE_TYPE)
    CurrentLocationRetrieved._cont = ASN1Dict([(u'activeLocationRetrieval', 0)])
    CurrentLocationRetrieved._ext = None
    
    #-----< EPSLocationInfo >-----#
    EPSLocationInfo = SEQ(name=u'EPSLocationInfo', mode=MODE_TYPE)
    _EPSLocationInfo_mMELocationInformation = SEQ(name=u'mMELocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'MMELocationInformation')), opt=True)
    _EPSLocationInfo_sGSNLocationInformation = SEQ(name=u'sGSNLocationInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'SGSNLocationInformation')), opt=True)
    EPSLocationInfo._cont = ASN1Dict([
        (u'mMELocationInformation', _EPSLocationInfo_mMELocationInformation),
        (u'sGSNLocationInformation', _EPSLocationInfo_sGSNLocationInformation),
        ])
    EPSLocationInfo._ext = None
    
    #-----< LocationType >-----#
    LocationType = ENUM(name=u'LocationType', mode=MODE_TYPE)
    LocationType._cont = ASN1Dict([(u'currentLocation', 0), (u'lastKnownLocation', 1)])
    LocationType._ext = None
    
    #-----< MMELocationInformation >-----#
    MMELocationInformation = SEQ(name=u'MMELocationInformation', mode=MODE_TYPE)
    _MMELocationInformation_eUTRANCellGlobalIdentity = OCT_STR(name=u'eUTRANCellGlobalIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMELocationInformation_trackingAreaIdentity = OCT_STR(name=u'trackingAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMELocationInformation_geographicalInformation = OCT_STR(name=u'geographicalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMELocationInformation_geodeticInformation = OCT_STR(name=u'geodeticInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMELocationInformation_currentLocationRetrieved = ENUM(name=u'currentLocationRetrieved', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'CurrentLocationRetrieved')), opt=True)
    _MMELocationInformation_ageOfLocationInformation = INT(name=u'ageOfLocationInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MMELocationInformation_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    _MMELocationInformation_eNodeBID = OCT_STR(name=u'eNodeBID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    MMELocationInformation._cont = ASN1Dict([
        (u'eUTRANCellGlobalIdentity', _MMELocationInformation_eUTRANCellGlobalIdentity),
        (u'trackingAreaIdentity', _MMELocationInformation_trackingAreaIdentity),
        (u'geographicalInformation', _MMELocationInformation_geographicalInformation),
        (u'geodeticInformation', _MMELocationInformation_geodeticInformation),
        (u'currentLocationRetrieved', _MMELocationInformation_currentLocationRetrieved),
        (u'ageOfLocationInformation', _MMELocationInformation_ageOfLocationInformation),
        (u'userCSGInformation', _MMELocationInformation_userCSGInformation),
        (u'eNodeBID', _MMELocationInformation_eNodeBID),
        ])
    MMELocationInformation._ext = None
    
    #-----< MonitoringEventConfigStatus >-----#
    MonitoringEventConfigStatus = SEQ(name=u'MonitoringEventConfigStatus', mode=MODE_TYPE)
    _MonitoringEventConfigStatus_serviceResult = SEQ(name=u'serviceResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'ServiceResult')), opt=True)
    _MonitoringEventConfigStatus_sCEFReferenceID = INT(name=u'sCEFReferenceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'SCEFReferenceID')), opt=True)
    _MonitoringEventConfigStatus_sCEFID = OCT_STR(name=u'sCEFID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    MonitoringEventConfigStatus._cont = ASN1Dict([
        (u'serviceResult', _MonitoringEventConfigStatus_serviceResult),
        (u'sCEFReferenceID', _MonitoringEventConfigStatus_sCEFReferenceID),
        (u'sCEFID', _MonitoringEventConfigStatus_sCEFID),
        ])
    MonitoringEventConfigStatus._ext = None
    
    #-----< MonitoringEventConfigurationActivity >-----#
    MonitoringEventConfigurationActivity = ENUM(name=u'MonitoringEventConfigurationActivity', mode=MODE_TYPE)
    MonitoringEventConfigurationActivity._cont = ASN1Dict([(u'create', 0), (u'transfer', 1), (u'update', 2), (u'delete', 3)])
    MonitoringEventConfigurationActivity._ext = None
    
    #-----< MonitoringEventReportData >-----#
    MonitoringEventReportData = SEQ(name=u'MonitoringEventReportData', mode=MODE_TYPE)
    _MonitoringEventReportData_eventTimestamp = OCT_STR(name=u'eventTimestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _MonitoringEventReportData_sCEFReferenceID = INT(name=u'sCEFReferenceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'SCEFReferenceID')), opt=True)
    _MonitoringEventReportData_sCEFID = OCT_STR(name=u'sCEFID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _MonitoringEventReportData_monitoringEventReportNumber = INT(name=u'monitoringEventReportNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MonitoringEventReportData_chargeablePartyIdentifier = STR_UTF8(name=u'chargeablePartyIdentifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _MonitoringEventReportData_monitoredUser = OCT_STR(name=u'monitoredUser', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _MonitoringEventReportData_monitoringType = ENUM(name=u'monitoringType', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'MonitoringType')), opt=True)
    _MonitoringEventReportData_reachabilityInformation = ENUM(name=u'reachabilityInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'ReachabilityType')), opt=True)
    _MonitoringEventReportData_reportedLocation = SEQ(name=u'reportedLocation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'EPSLocationInfo')), opt=True)
    _MonitoringEventReportData_communicationFailureInformation = SEQ_OF(name=u'communicationFailureInformation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MonitoringEventReportData_communicationFailureInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MONTEChargingDataTypes', 'CommunicationFailureInfo')))
    _MonitoringEventReportData_communicationFailureInformation._cont = __MonitoringEventReportData_communicationFailureInformation__item_
    _MonitoringEventReportData_listOfNumberOfUEPerLocationReport = SEQ_OF(name=u'listOfNumberOfUEPerLocationReport', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MonitoringEventReportData_listOfNumberOfUEPerLocationReport__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('MONTEChargingDataTypes', 'NumberOfUEPerLocationReport')))
    _MonitoringEventReportData_listOfNumberOfUEPerLocationReport._cont = __MonitoringEventReportData_listOfNumberOfUEPerLocationReport__item_
    MonitoringEventReportData._cont = ASN1Dict([
        (u'eventTimestamp', _MonitoringEventReportData_eventTimestamp),
        (u'sCEFReferenceID', _MonitoringEventReportData_sCEFReferenceID),
        (u'sCEFID', _MonitoringEventReportData_sCEFID),
        (u'monitoringEventReportNumber', _MonitoringEventReportData_monitoringEventReportNumber),
        (u'chargeablePartyIdentifier', _MonitoringEventReportData_chargeablePartyIdentifier),
        (u'monitoredUser', _MonitoringEventReportData_monitoredUser),
        (u'monitoringType', _MonitoringEventReportData_monitoringType),
        (u'reachabilityInformation', _MonitoringEventReportData_reachabilityInformation),
        (u'reportedLocation', _MonitoringEventReportData_reportedLocation),
        (u'communicationFailureInformation', _MonitoringEventReportData_communicationFailureInformation),
        (u'listOfNumberOfUEPerLocationReport', _MonitoringEventReportData_listOfNumberOfUEPerLocationReport),
        ])
    MonitoringEventReportData._ext = None
    
    #-----< MonitoringType >-----#
    MonitoringType = ENUM(name=u'MonitoringType', mode=MODE_TYPE)
    MonitoringType._cont = ASN1Dict([(u'lossOfConnectivity', 0), (u'ueReachability', 1), (u'locationReporting', 2), (u'changeOfIMSIIMEISVAssociation', 3), (u'roamingStatus', 4), (u'communicationFailure', 5), (u'availabilityAfterDDNFailure', 6), (u'numberOfUEPerLocation', 7)])
    MonitoringType._ext = None
    
    #-----< NumberOfUEPerLocationReport >-----#
    NumberOfUEPerLocationReport = SEQ(name=u'NumberOfUEPerLocationReport', mode=MODE_TYPE)
    _NumberOfUEPerLocationReport_ePSLocationInformation = SEQ(name=u'ePSLocationInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'EPSLocationInfo')), opt=True)
    _NumberOfUEPerLocationReport_uECount = INT(name=u'uECount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    NumberOfUEPerLocationReport._cont = ASN1Dict([
        (u'ePSLocationInformation', _NumberOfUEPerLocationReport_ePSLocationInformation),
        (u'uECount', _NumberOfUEPerLocationReport_uECount),
        ])
    NumberOfUEPerLocationReport._ext = None
    
    #-----< ReachabilityConfiguration >-----#
    ReachabilityConfiguration = SEQ(name=u'ReachabilityConfiguration', mode=MODE_TYPE)
    _ReachabilityConfiguration_reachabilityType = ENUM(name=u'reachabilityType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'ReachabilityType')), opt=True)
    _ReachabilityConfiguration_maximumLatency = INT(name=u'maximumLatency', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReachabilityConfiguration_maximumResponseTime = INT(name=u'maximumResponseTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ReachabilityConfiguration._cont = ASN1Dict([
        (u'reachabilityType', _ReachabilityConfiguration_reachabilityType),
        (u'maximumLatency', _ReachabilityConfiguration_maximumLatency),
        (u'maximumResponseTime', _ReachabilityConfiguration_maximumResponseTime),
        ])
    ReachabilityConfiguration._ext = None
    
    #-----< ReachabilityType >-----#
    ReachabilityType = ENUM(name=u'ReachabilityType', mode=MODE_TYPE)
    ReachabilityType._cont = ASN1Dict([(u'reachabilityforSMS', 0), (u'reachabilityforData', 1)])
    ReachabilityType._ext = None
    
    #-----< SGSNLocationInformation >-----#
    SGSNLocationInformation = SEQ(name=u'SGSNLocationInformation', mode=MODE_TYPE)
    _SGSNLocationInformation_cellGlobalIdentity = OCT_STR(name=u'cellGlobalIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNLocationInformation_locationAreaIdentity = OCT_STR(name=u'locationAreaIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNLocationInformation_serviceAreaIdentity = OCT_STR(name=u'serviceAreaIdentity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNLocationInformation_routingAreaIdentity = OCT_STR(name=u'routingAreaIdentity', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNLocationInformation_geographicalInformation = OCT_STR(name=u'geographicalInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNLocationInformation_geodeticInformation = OCT_STR(name=u'geodeticInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNLocationInformation_currentLocationRetrieved = ENUM(name=u'currentLocationRetrieved', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MONTEChargingDataTypes', 'CurrentLocationRetrieved')), opt=True)
    _SGSNLocationInformation_ageOfLocationInformation = INT(name=u'ageOfLocationInformation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SGSNLocationInformation_userCSGInformation = SEQ(name=u'userCSGInformation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'UserCSGInformation')), opt=True)
    SGSNLocationInformation._cont = ASN1Dict([
        (u'cellGlobalIdentity', _SGSNLocationInformation_cellGlobalIdentity),
        (u'locationAreaIdentity', _SGSNLocationInformation_locationAreaIdentity),
        (u'serviceAreaIdentity', _SGSNLocationInformation_serviceAreaIdentity),
        (u'routingAreaIdentity', _SGSNLocationInformation_routingAreaIdentity),
        (u'geographicalInformation', _SGSNLocationInformation_geographicalInformation),
        (u'geodeticInformation', _SGSNLocationInformation_geodeticInformation),
        (u'currentLocationRetrieved', _SGSNLocationInformation_currentLocationRetrieved),
        (u'ageOfLocationInformation', _SGSNLocationInformation_ageOfLocationInformation),
        (u'userCSGInformation', _SGSNLocationInformation_userCSGInformation),
        ])
    SGSNLocationInformation._ext = None
    
    #-----< SCEFReferenceID >-----#
    SCEFReferenceID = INT(name=u'SCEFReferenceID', mode=MODE_TYPE)
    SCEFReferenceID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< ServiceResult >-----#
    ServiceResult = SEQ(name=u'ServiceResult', mode=MODE_TYPE)
    _ServiceResult_vendorId = INT(name=u'vendorId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ServiceResult_serviceResultCode = INT(name=u'serviceResultCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ServiceResult._cont = ASN1Dict([
        (u'vendorId', _ServiceResult_vendorId),
        (u'serviceResultCode', _ServiceResult_serviceResultCode),
        ])
    ServiceResult._ext = None
    
    _all_ = [
        _MERecordType_mECORecord,
        _MERecordType_mERERecord,
        MERecordType,
        _MECORecord_recordType,
        _MECORecord_retransmission,
        _MECORecord_serviceContextID,
        _MECORecord_nodeID,
        _MECORecord_recordTimeStamp,
        _MECORecord_eventTimestamp,
        _MECORecord_monitoringEventConfigurationActivity,
        _MECORecord_sCEFReferenceID,
        _MECORecord_sCEFID,
        _MECORecord_monitoringType,
        _MECORecord_maximumNumberofReports,
        _MECORecord_monitoringDuration,
        _MECORecord_chargeablePartyIdentifier,
        _MECORecord_monitoredUser,
        _MECORecord_maximumDetectionTime,
        _MECORecord_localRecordSequenceNumber,
        _MECORecord_reachabilityConfiguration,
        _MECORecord_locationType,
        _MECORecord_accuracy,
        __MECORecord_listofLocations__item_,
        _MECORecord_listofLocations,
        _MECORecord_monitoringEventConfigStatus,
        _MECORecord_recordExtensions,
        MECORecord,
        _MERERecord_recordType,
        _MERERecord_retransmission,
        _MERERecord_serviceContextID,
        _MERERecord_nodeID,
        _MERERecord_recordTimeStamp,
        _MERERecord_localRecordSequenceNumber,
        __MERERecord_listofMonitoringEventReportData__item_,
        _MERERecord_listofMonitoringEventReportData,
        _MERERecord_recordExtensions,
        MERERecord,
        Accuracy,
        CauseType,
        _CommunicationFailureInfo_causeType,
        _CommunicationFailureInfo_s1APCause,
        _CommunicationFailureInfo_rANAPCause,
        _CommunicationFailureInfo_bSSGPCause,
        _CommunicationFailureInfo_gMMCause,
        _CommunicationFailureInfo_sMCause,
        CommunicationFailureInfo,
        CurrentLocationRetrieved,
        _EPSLocationInfo_mMELocationInformation,
        _EPSLocationInfo_sGSNLocationInformation,
        EPSLocationInfo,
        LocationType,
        _MMELocationInformation_eUTRANCellGlobalIdentity,
        _MMELocationInformation_trackingAreaIdentity,
        _MMELocationInformation_geographicalInformation,
        _MMELocationInformation_geodeticInformation,
        _MMELocationInformation_currentLocationRetrieved,
        _MMELocationInformation_ageOfLocationInformation,
        _MMELocationInformation_userCSGInformation,
        _MMELocationInformation_eNodeBID,
        MMELocationInformation,
        _MonitoringEventConfigStatus_serviceResult,
        _MonitoringEventConfigStatus_sCEFReferenceID,
        _MonitoringEventConfigStatus_sCEFID,
        MonitoringEventConfigStatus,
        MonitoringEventConfigurationActivity,
        _MonitoringEventReportData_eventTimestamp,
        _MonitoringEventReportData_sCEFReferenceID,
        _MonitoringEventReportData_sCEFID,
        _MonitoringEventReportData_monitoringEventReportNumber,
        _MonitoringEventReportData_chargeablePartyIdentifier,
        _MonitoringEventReportData_monitoredUser,
        _MonitoringEventReportData_monitoringType,
        _MonitoringEventReportData_reachabilityInformation,
        _MonitoringEventReportData_reportedLocation,
        __MonitoringEventReportData_communicationFailureInformation__item_,
        _MonitoringEventReportData_communicationFailureInformation,
        __MonitoringEventReportData_listOfNumberOfUEPerLocationReport__item_,
        _MonitoringEventReportData_listOfNumberOfUEPerLocationReport,
        MonitoringEventReportData,
        MonitoringType,
        _NumberOfUEPerLocationReport_ePSLocationInformation,
        _NumberOfUEPerLocationReport_uECount,
        NumberOfUEPerLocationReport,
        _ReachabilityConfiguration_reachabilityType,
        _ReachabilityConfiguration_maximumLatency,
        _ReachabilityConfiguration_maximumResponseTime,
        ReachabilityConfiguration,
        ReachabilityType,
        _SGSNLocationInformation_cellGlobalIdentity,
        _SGSNLocationInformation_locationAreaIdentity,
        _SGSNLocationInformation_serviceAreaIdentity,
        _SGSNLocationInformation_routingAreaIdentity,
        _SGSNLocationInformation_geographicalInformation,
        _SGSNLocationInformation_geodeticInformation,
        _SGSNLocationInformation_currentLocationRetrieved,
        _SGSNLocationInformation_ageOfLocationInformation,
        _SGSNLocationInformation_userCSGInformation,
        SGSNLocationInformation,
        SCEFReferenceID,
        _ServiceResult_vendorId,
        _ServiceResult_serviceResultCode,
        ServiceResult,
    ]

class OperationalBindingManagement:

    _name_  = u'OperationalBindingManagement'
    _oid_   = [2, 5, 1, 18, 8]
    
    _obj_ = [
        u'dSAOperationalBindingManagementBind',
        u'OPERATIONAL-BINDING',
        u'OP-BINDING-COOP',
        u'OP-BIND-ROLE',
        u'establishOperationalBinding',
        u'EstablishOperationalBindingArgument',
        u'EstablishOperationalBindingArgumentData',
        u'OpBindingSet',
        u'OperationalBindingID',
        u'Validity',
        u'Time',
        u'EstablishOperationalBindingResult',
        u'EstablishOperationalBindingResultData',
        u'modifyOperationalBinding',
        u'ModifyOperationalBindingArgument',
        u'ModifyOperationalBindingArgumentData',
        u'ModifiedValidity',
        u'ModifyOperationalBindingResult',
        u'ModifyOperationalBindingResultData',
        u'terminateOperationalBinding',
        u'TerminateOperationalBindingArgument',
        u'TerminateOperationalBindingArgumentData',
        u'TerminateOperationalBindingResult',
        u'TerminateOperationalBindingResultData',
        u'operationalBindingError',
        u'OpBindingErrorParam',
        ]
    _type_ = [
        u'OPERATIONAL-BINDING',
        u'OP-BINDING-COOP',
        u'OP-BIND-ROLE',
        u'EstablishOperationalBindingArgument',
        u'EstablishOperationalBindingArgumentData',
        u'OperationalBindingID',
        u'Validity',
        u'Time',
        u'EstablishOperationalBindingResult',
        u'EstablishOperationalBindingResultData',
        u'ModifyOperationalBindingArgument',
        u'ModifyOperationalBindingArgumentData',
        u'ModifiedValidity',
        u'ModifyOperationalBindingResult',
        u'ModifyOperationalBindingResultData',
        u'TerminateOperationalBindingArgument',
        u'TerminateOperationalBindingArgumentData',
        u'TerminateOperationalBindingResult',
        u'TerminateOperationalBindingResultData',
        u'OpBindingErrorParam',
        ]
    _set_ = [
        u'OpBindingSet',
        ]
    _val_ = [
        u'dSAOperationalBindingManagementBind',
        u'establishOperationalBinding',
        u'modifyOperationalBinding',
        u'terminateOperationalBinding',
        u'operationalBindingError',
        ]
    _class_ = [
        u'dSAOperationalBindingManagementBind',
        u'OPERATIONAL-BINDING',
        u'OP-BINDING-COOP',
        u'OP-BIND-ROLE',
        u'establishOperationalBinding',
        u'OpBindingSet',
        u'modifyOperationalBinding',
        u'terminateOperationalBinding',
        u'operationalBindingError',
        ]
    _param_ = [
        ]
    
    #-----< dSAOperationalBindingManagementBind >-----#
    dSAOperationalBindingManagementBind = CLASS(name=u'dSAOperationalBindingManagementBind', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _dSAOperationalBindingManagementBind_val_ArgumentType = SET(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    _dSAOperationalBindingManagementBind_val_ResultType = SET(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __OPERATION_Errors_val_ParameterType_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____OPERATION_Errors_val_ParameterType_0_unsigned_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error = CHOICE(name=u'error', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError = INT(name=u'serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError = INT(name=u'securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._cont = ASN1Dict([
        (u'serviceError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError),
        (u'securityError', _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError),
        ])
    ____OPERATION_Errors_val_ParameterType_0_unsigned_error._ext = []
    ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ___OPERATION_Errors_val_ParameterType_0_unsigned._cont = ASN1Dict([
        (u'versions', ____OPERATION_Errors_val_ParameterType_0_unsigned_versions),
        (u'error', ____OPERATION_Errors_val_ParameterType_0_unsigned_error),
        (u'securityParameters', ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters),
        ])
    ___OPERATION_Errors_val_ParameterType_0_unsigned._ext = None
    ___OPERATION_Errors_val_ParameterType_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions = BIT_STR(name=u'versions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'Versions')), default=(1, 1))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error = CHOICE(name=u'error', mode=MODE_TYPE)
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError = INT(name=u'serviceError', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceProblem')))
    ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError = INT(name=u'securityError', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityProblem')))
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._cont = ASN1Dict([
        (u'serviceError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError),
        (u'securityError', ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError),
        ])
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error._ext = []
    _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._cont = ASN1Dict([
        (u'versions', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions),
        (u'error', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error),
        (u'securityParameters', _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned._ext = None
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0._ext = None
    dSAOperationalBindingManagementBind._val = dict([(u'ArgumentType', _dSAOperationalBindingManagementBind_val_ArgumentType), (u'ResultType', _dSAOperationalBindingManagementBind_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])
    
    #-----< OPERATIONAL-BINDING >-----#
    OPERATIONAL_BINDING = CLASS(name=u'OPERATIONAL-BINDING', mode=MODE_TYPE)
    _OPERATIONAL_BINDING_Agreement = OPEN(name=u'Agreement', mode=MODE_TYPE)
    _OPERATIONAL_BINDING_Cooperation = CLASS(name=u'Cooperation', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OP-BINDING-COOP')))
    _OPERATIONAL_BINDING_both = CLASS(name=u'both', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OP-BIND-ROLE')), opt=True)
    _OPERATIONAL_BINDING_roleA = CLASS(name=u'roleA', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OP-BIND-ROLE')), opt=True)
    _OPERATIONAL_BINDING_roleB = CLASS(name=u'roleB', mode=MODE_VALUE, typeref=ASN1RefType(('OperationalBindingManagement', 'OP-BIND-ROLE')), opt=True)
    _OPERATIONAL_BINDING_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    OPERATIONAL_BINDING._cont = ASN1Dict([
        (u'Agreement', _OPERATIONAL_BINDING_Agreement),
        (u'Cooperation', _OPERATIONAL_BINDING_Cooperation),
        (u'both', _OPERATIONAL_BINDING_both),
        (u'roleA', _OPERATIONAL_BINDING_roleA),
        (u'roleB', _OPERATIONAL_BINDING_roleB),
        (u'id', _OPERATIONAL_BINDING_id),
        ])
    
    #-----< OP-BINDING-COOP >-----#
    OP_BINDING_COOP = CLASS(name=u'OP-BINDING-COOP', mode=MODE_TYPE)
    _OP_BINDING_COOP_applContext = CLASS(name=u'applContext', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT')))
    _OP_BINDING_COOP_Operations = CLASS(name=u'Operations', mode=MODE_SET, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')), opt=True)
    OP_BINDING_COOP._cont = ASN1Dict([
        (u'applContext', _OP_BINDING_COOP_applContext),
        (u'Operations', _OP_BINDING_COOP_Operations),
        ])
    
    #-----< OP-BIND-ROLE >-----#
    OP_BIND_ROLE = CLASS(name=u'OP-BIND-ROLE', mode=MODE_TYPE)
    _OP_BIND_ROLE_establish = BOOL(name=u'establish', mode=MODE_VALUE, default=False)
    _OP_BIND_ROLE_EstablishParam = OPEN(name=u'EstablishParam', mode=MODE_TYPE)
    _OP_BIND_ROLE_modify = BOOL(name=u'modify', mode=MODE_VALUE, default=False)
    _OP_BIND_ROLE_ModifyParam = OPEN(name=u'ModifyParam', mode=MODE_TYPE, opt=True)
    _OP_BIND_ROLE_terminate = BOOL(name=u'terminate', mode=MODE_VALUE, default=False)
    _OP_BIND_ROLE_TerminateParam = OPEN(name=u'TerminateParam', mode=MODE_TYPE, opt=True)
    OP_BIND_ROLE._cont = ASN1Dict([
        (u'establish', _OP_BIND_ROLE_establish),
        (u'EstablishParam', _OP_BIND_ROLE_EstablishParam),
        (u'modify', _OP_BIND_ROLE_modify),
        (u'ModifyParam', _OP_BIND_ROLE_ModifyParam),
        (u'terminate', _OP_BIND_ROLE_terminate),
        (u'TerminateParam', _OP_BIND_ROLE_TerminateParam),
        ])
    
    #-----< establishOperationalBinding >-----#
    establishOperationalBinding = CLASS(name=u'establishOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _establishOperationalBinding_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgument')))
    _establishOperationalBinding_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResult')))
    __OPERATION_Errors_val_ParameterType_0_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_0_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ___OPERATION_Errors_val_ParameterType_0_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_0._ext = None
    __OPERATION_Errors_val_ParameterType_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1._ext = None
    establishOperationalBinding._val = dict([(u'ArgumentType', _establishOperationalBinding_val_ArgumentType), (u'ResultType', _establishOperationalBinding_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 100))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 100))])
    
    #-----< EstablishOperationalBindingArgument >-----#
    EstablishOperationalBindingArgument = CHOICE(name=u'EstablishOperationalBindingArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _EstablishOperationalBindingArgument_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgumentData')))
    _EstablishOperationalBindingArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __EstablishOperationalBindingArgument_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingArgumentData')))
    __EstablishOperationalBindingArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab = ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab = ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __EstablishOperationalBindingArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters),
        ])
    __EstablishOperationalBindingArgument_signed_algorithmIdentifier._ext = []
    __EstablishOperationalBindingArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _EstablishOperationalBindingArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __EstablishOperationalBindingArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __EstablishOperationalBindingArgument_signed_algorithmIdentifier),
        (u'signature', __EstablishOperationalBindingArgument_signed_signature),
        ])
    _EstablishOperationalBindingArgument_signed._ext = []
    EstablishOperationalBindingArgument._cont = ASN1Dict([
        (u'unsigned', _EstablishOperationalBindingArgument_unsigned),
        (u'signed', _EstablishOperationalBindingArgument_signed),
        ])
    EstablishOperationalBindingArgument._ext = None
    
    #-----< EstablishOperationalBindingArgumentData >-----#
    EstablishOperationalBindingArgumentData = SEQ(name=u'EstablishOperationalBindingArgumentData', mode=MODE_TYPE)
    _EstablishOperationalBindingArgumentData_bindingType = OID(name=u'bindingType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'id']))
    __EstablishOperationalBindingArgumentData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_0 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    __APPLICATION_CONTEXT_bind_operation_val_ArgumentType = SET(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindArgument')))
    __APPLICATION_CONTEXT_bind_operation_val_ResultType = SET(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DSABindResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __OPERATION_Errors_val_ParameterType_0_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    ___OPERATION_Errors_val_ParameterType_0_1_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ___OPERATION_Errors_val_ParameterType_0_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowErrorData')))
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    __OP_BINDING_COOP_Operations_val_ArgumentType_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateArgument')))
    __OP_BINDING_COOP_Operations_val_ResultType_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'CoordinateShadowUpdateResult')))
    __OP_BINDING_COOP_Operations_val_ArgumentType_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __OP_BINDING_COOP_Operations_val_ResultType_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'UpdateShadowResult')))
    __OP_BINDING_COOP_Operations_val_ArgumentType_0_0 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateArgument')))
    __OP_BINDING_COOP_Operations_val_ResultType_0_0 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'RequestShadowUpdateResult')))
    __OPERATIONAL_BINDING_roleA_val_EstablishParam = NULL(name=u'EstablishParam', mode=MODE_TYPE)
    __OPERATIONAL_BINDING_roleB_val_EstablishParam = NULL(name=u'EstablishParam', mode=MODE_TYPE)
    __OPERATIONAL_BINDING_roleB_val_ModifyParam = SEQ(name=u'ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ModificationParameter')))
    ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_1 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ReadResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_1._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_0_1._ext = None
    __OPERATION_Errors_val_ParameterType_0_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ___OPERATION_Errors_val_ParameterType_0_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'DsaReferralData')))
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_2._ext = None
    __OPERATION_Errors_val_ParameterType_1_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AttributeErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_0._ext = None
    __OPERATION_Errors_val_ParameterType_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2._ext = None
    __OPERATION_Errors_val_ParameterType_3 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_3_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3._ext = None
    __OPERATION_Errors_val_ParameterType_4 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_4_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4._ext = None
    __OPERATION_Errors_val_ParameterType_5 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_5_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_5_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_5_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_5_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_6_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_6_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_6_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_1 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'CompareResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_1._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_1_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_2 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonArgument')))
    __APPLICATION_CONTEXT_Operations_val_ResultType_2 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonResult')))
    __OPERATION_Errors_val_ParameterType_0_3 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_0_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_0_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_0_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_0_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_0_3_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_0_3_signed._ext = []
    __OPERATION_Errors_val_ParameterType_0_3._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_0_3_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_0_3_signed),
        ])
    __OPERATION_Errors_val_ParameterType_0_3._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_3._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_3 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ListResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_3._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_3._ext = None
    __OPERATION_Errors_val_ParameterType_1_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ___OPERATION_Errors_val_ParameterType_1_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'NameErrorData')))
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_1._ext = None
    __OPERATION_Errors_val_ParameterType_2_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_0._ext = None
    __OPERATION_Errors_val_ParameterType_3_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_3_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ___OPERATION_Errors_val_ParameterType_3_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ReferralData')))
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_3_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_3_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_3_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_3_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_3_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_3_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_3_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_3_0._ext = None
    __OPERATION_Errors_val_ParameterType_4_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_4_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_0._ext = None
    __OPERATION_Errors_val_ParameterType_5_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_5_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_5_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_5_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_4._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_4 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_4._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_4._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_5._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_5 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AddEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_5._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_5._ext = None
    __OPERATION_Errors_val_ParameterType_6_0 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_6_0_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_6_0_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_6_0_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_6_0_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_6_0_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_6_0_signed._ext = []
    __OPERATION_Errors_val_ParameterType_6_0._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_6_0_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_6_0_signed),
        ])
    __OPERATION_Errors_val_ParameterType_6_0._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_6._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_6 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'RemoveEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_6._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_6._ext = None
    __OPERATION_Errors_val_ParameterType_4_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_4_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ___OPERATION_Errors_val_ParameterType_4_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityErrorData')))
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_4_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_4_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_4_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_4_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_4_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_4_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_4_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_4_1._ext = None
    __OPERATION_Errors_val_ParameterType_5_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_5_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_5_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_5_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_5_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_5_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_5_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_5_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_5_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_5_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_5_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_7._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_7 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyEntryResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_7._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_7._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_8._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_8 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ModifyDNResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_8._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_8._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_9._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_9 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'AdministerPasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_9._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_9._ext = None
    __OPERATION_Errors_val_ParameterType_2_1 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_1_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ___OPERATION_Errors_val_ParameterType_2_1_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'UpdateErrorData')))
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_1_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_1_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_1_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_1_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_1._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_1_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_1_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_1._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_10._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_10 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ChangePasswordResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_10._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_10._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LdapArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_11._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_11 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType = SEQ_OF(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType._cont = _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType = SEQ_OF(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Lightweight-Directory-Access-Protocol-V3', 'LDAPMessage')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType._cont = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_11._ext = None
    __OPERATION_Errors_val_ParameterType_1_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_1_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ___OPERATION_Errors_val_ParameterType_1_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonFailedData')))
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_1_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_1_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_1_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_1_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_1_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_1_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_1_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_1_2._ext = None
    __OPERATION_Errors_val_ParameterType_2_2 = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___OPERATION_Errors_val_ParameterType_2_2_unsigned = SET(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ___OPERATION_Errors_val_ParameterType_2_2_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'AbandonedData')))
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab = ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters),
        ])
    ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier._ext = []
    ____OPERATION_Errors_val_ParameterType_2_2_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___OPERATION_Errors_val_ParameterType_2_2_signed._cont = ASN1Dict([
        (u'toBeSigned', ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned),
        (u'algorithmIdentifier', ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier),
        (u'signature', ____OPERATION_Errors_val_ParameterType_2_2_signed_signature),
        ])
    ___OPERATION_Errors_val_ParameterType_2_2_signed._ext = []
    __OPERATION_Errors_val_ParameterType_2_2._cont = ASN1Dict([
        (u'unsigned', ___OPERATION_Errors_val_ParameterType_2_2_unsigned),
        (u'signed', ___OPERATION_Errors_val_ParameterType_2_2_signed),
        ])
    __OPERATION_Errors_val_ParameterType_2_2._ext = None
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12 = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._cont = ASN1Dict([
        (u'chainedArgument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument),
        (u'argument', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument = SET(name=u'chainedArgument', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingArguments')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedArgument')))
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedArgument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument),
        (u'argument', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ArgumentType_12._ext = None
    __APPLICATION_CONTEXT_Operations_val_ResultType_12 = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned = SET(name=u'unsigned', mode=MODE_TYPE)
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType = NULL(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._cont = ASN1Dict([
        (u'chainedResult', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult),
        (u'result', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned._ext = None
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed = SEQ(name=u'signed', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned = SET(name=u'toBeSigned', mode=MODE_TYPE)
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult = SET(name=u'chainedResult', mode=MODE_TYPE, typeref=ASN1RefType(('DistributedOperations', 'ChainingResults')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType = NULL(name=u'ResultType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'LinkedResult')))
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._cont = ASN1Dict([
        (u'chainedResult', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult),
        (u'result', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned._ext = None
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_at = None
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab = ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm),
        (u'parameters', _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters),
        ])
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier._ext = []
    ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._cont = ASN1Dict([
        (u'toBeSigned', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned),
        (u'algorithmIdentifier', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier),
        (u'signature', ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature),
        ])
    ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed._ext = []
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._cont = ASN1Dict([
        (u'unsigned', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned),
        (u'signed', ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed),
        ])
    __APPLICATION_CONTEXT_Operations_val_ResultType_12._ext = None
    __OPERATIONAL_BINDING_roleA_val_EstablishParam_0 = SEQ(name=u'EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinate')))
    __OPERATIONAL_BINDING_roleA_val_ModifyParam = SEQ(name=u'ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SuperiorToSubordinateModification')))
    __OPERATIONAL_BINDING_roleB_val_EstablishParam_0 = SEQ(name=u'EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubordinateToSuperior')))
    __OPERATIONAL_BINDING_roleB_val_ModifyParam_0 = SEQ(name=u'ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'SubordinateToSuperior')))
    ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_2 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __OPERATIONAL_BINDING_roleA_val_EstablishParam_1 = SEQ(name=u'EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSuperiorToSubordinate')))
    __OPERATIONAL_BINDING_roleA_val_ModifyParam_0 = SEQ(name=u'ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSuperiorToSubordinate')))
    __OPERATIONAL_BINDING_roleB_val_EstablishParam_1 = SEQ(name=u'EstablishParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSubordinateToSuperior')))
    __OPERATIONAL_BINDING_roleB_val_ModifyParam_1 = SEQ(name=u'ModifyParam', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NHOBSubordinateToSuperior')))
    __EstablishOperationalBindingArgumentData_bindingType_tab._val = ASN1Set(rv=[dict([(u'Agreement', ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_0), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 5))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))]), dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 4))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), (u'modify', True), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), (u'terminate', True)])), (u'id', (2, 5, 19, 1))]), dict([(u'Agreement', ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_1), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), (u'terminate', True)])), (u'id', (2, 5, 19, 2))]), dict([(u'Agreement', ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_2), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), (u'terminate', True)])), (u'id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _EstablishOperationalBindingArgumentData_bindingType._const_tab = __EstablishOperationalBindingArgumentData_bindingType_tab
    _EstablishOperationalBindingArgumentData_bindingType._const_tab_at = None
    _EstablishOperationalBindingArgumentData_bindingType._const_tab_id = u'id'
    _EstablishOperationalBindingArgumentData_bindingID = SEQ(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')), opt=True)
    _EstablishOperationalBindingArgumentData_accessPoint = SET(name=u'accessPoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')))
    _EstablishOperationalBindingArgumentData_initiator = CHOICE(name=u'initiator', mode=MODE_TYPE)
    __EstablishOperationalBindingArgumentData_initiator_symmetric = OPEN(name=u'symmetric', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'both', u'EstablishParam']))
    __EstablishOperationalBindingArgumentData_initiator_symmetric._const_tab = __EstablishOperationalBindingArgumentData_bindingType_tab
    __EstablishOperationalBindingArgumentData_initiator_symmetric._const_tab_at = ('..', '..', u'bindingType')
    __EstablishOperationalBindingArgumentData_initiator_symmetric._const_tab_id = u'EstablishParam'
    __EstablishOperationalBindingArgumentData_initiator_roleA_initiates = OPEN(name=u'roleA-initiates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'roleA', u'EstablishParam']))
    __EstablishOperationalBindingArgumentData_initiator_roleA_initiates._const_tab = __EstablishOperationalBindingArgumentData_bindingType_tab
    __EstablishOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_at = ('..', '..', u'bindingType')
    __EstablishOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_id = u'EstablishParam'
    __EstablishOperationalBindingArgumentData_initiator_roleB_initiates = OPEN(name=u'roleB-initiates', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'roleB', u'EstablishParam']))
    __EstablishOperationalBindingArgumentData_initiator_roleB_initiates._const_tab = __EstablishOperationalBindingArgumentData_bindingType_tab
    __EstablishOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_at = ('..', '..', u'bindingType')
    __EstablishOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_id = u'EstablishParam'
    _EstablishOperationalBindingArgumentData_initiator._cont = ASN1Dict([
        (u'symmetric', __EstablishOperationalBindingArgumentData_initiator_symmetric),
        (u'roleA-initiates', __EstablishOperationalBindingArgumentData_initiator_roleA_initiates),
        (u'roleB-initiates', __EstablishOperationalBindingArgumentData_initiator_roleB_initiates),
        ])
    _EstablishOperationalBindingArgumentData_initiator._ext = None
    _EstablishOperationalBindingArgumentData_agreement = OPEN(name=u'agreement', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'Agreement']))
    _EstablishOperationalBindingArgumentData_agreement._const_tab = __EstablishOperationalBindingArgumentData_bindingType_tab
    _EstablishOperationalBindingArgumentData_agreement._const_tab_at = ('..', u'bindingType')
    _EstablishOperationalBindingArgumentData_agreement._const_tab_id = u'Agreement'
    _EstablishOperationalBindingArgumentData_valid = SEQ(name=u'valid', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Validity')), default=dict([]))
    _EstablishOperationalBindingArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    EstablishOperationalBindingArgumentData._cont = ASN1Dict([
        (u'bindingType', _EstablishOperationalBindingArgumentData_bindingType),
        (u'bindingID', _EstablishOperationalBindingArgumentData_bindingID),
        (u'accessPoint', _EstablishOperationalBindingArgumentData_accessPoint),
        (u'initiator', _EstablishOperationalBindingArgumentData_initiator),
        (u'agreement', _EstablishOperationalBindingArgumentData_agreement),
        (u'valid', _EstablishOperationalBindingArgumentData_valid),
        (u'securityParameters', _EstablishOperationalBindingArgumentData_securityParameters),
        ])
    EstablishOperationalBindingArgumentData._ext = []
    
    #-----< OpBindingSet >-----#
    OpBindingSet = CLASS(name=u'OpBindingSet', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    _OpBindingSet_val_Agreement_0 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    _OpBindingSet_val_Agreement_1 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    _OpBindingSet_val_Agreement_2 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    OpBindingSet._val = ASN1Set(rv=[dict([(u'Agreement', _OpBindingSet_val_Agreement_0), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 5))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))]), dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 4))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), (u'modify', True), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), (u'terminate', True)])), (u'id', (2, 5, 19, 1))]), dict([(u'Agreement', _OpBindingSet_val_Agreement_1), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), (u'terminate', True)])), (u'id', (2, 5, 19, 2))]), dict([(u'Agreement', _OpBindingSet_val_Agreement_2), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), (u'terminate', True)])), (u'id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    
    #-----< OperationalBindingID >-----#
    OperationalBindingID = SEQ(name=u'OperationalBindingID', mode=MODE_TYPE)
    _OperationalBindingID_identifier = INT(name=u'identifier', mode=MODE_TYPE)
    _OperationalBindingID_version = INT(name=u'version', mode=MODE_TYPE)
    OperationalBindingID._cont = ASN1Dict([
        (u'identifier', _OperationalBindingID_identifier),
        (u'version', _OperationalBindingID_version),
        ])
    OperationalBindingID._ext = []
    
    #-----< Validity >-----#
    Validity = SEQ(name=u'Validity', mode=MODE_TYPE)
    _Validity_validFrom = CHOICE(name=u'validFrom', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=(u'now', 0))
    __Validity_validFrom_now = NULL(name=u'now', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Validity_validFrom_time = CHOICE(name=u'time', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')))
    _Validity_validFrom._cont = ASN1Dict([
        (u'now', __Validity_validFrom_now),
        (u'time', __Validity_validFrom_time),
        ])
    _Validity_validFrom._ext = []
    _Validity_validUntil = CHOICE(name=u'validUntil', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=(u'explicitTermination', 0))
    __Validity_validUntil_explicitTermination = NULL(name=u'explicitTermination', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Validity_validUntil_time = CHOICE(name=u'time', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')))
    _Validity_validUntil._cont = ASN1Dict([
        (u'explicitTermination', __Validity_validUntil_explicitTermination),
        (u'time', __Validity_validUntil_time),
        ])
    _Validity_validUntil._ext = []
    Validity._cont = ASN1Dict([
        (u'validFrom', _Validity_validFrom),
        (u'validUntil', _Validity_validUntil),
        ])
    Validity._ext = []
    
    #-----< Time >-----#
    Time = CHOICE(name=u'Time', mode=MODE_TYPE)
    _Time_utcTime = TIME_UTC(name=u'utcTime', mode=MODE_TYPE)
    _Time_generalizedTime = TIME_GEN(name=u'generalizedTime', mode=MODE_TYPE)
    Time._cont = ASN1Dict([
        (u'utcTime', _Time_utcTime),
        (u'generalizedTime', _Time_generalizedTime),
        ])
    Time._ext = []
    
    #-----< EstablishOperationalBindingResult >-----#
    EstablishOperationalBindingResult = CHOICE(name=u'EstablishOperationalBindingResult', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _EstablishOperationalBindingResult_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResultData')))
    _EstablishOperationalBindingResult_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __EstablishOperationalBindingResult_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'EstablishOperationalBindingResultData')))
    __EstablishOperationalBindingResult_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm._const_tab = ____EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm_tab
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters._const_tab = ____EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters_tab
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __EstablishOperationalBindingResult_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters),
        ])
    __EstablishOperationalBindingResult_signed_algorithmIdentifier._ext = []
    __EstablishOperationalBindingResult_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _EstablishOperationalBindingResult_signed._cont = ASN1Dict([
        (u'toBeSigned', __EstablishOperationalBindingResult_signed_toBeSigned),
        (u'algorithmIdentifier', __EstablishOperationalBindingResult_signed_algorithmIdentifier),
        (u'signature', __EstablishOperationalBindingResult_signed_signature),
        ])
    _EstablishOperationalBindingResult_signed._ext = []
    EstablishOperationalBindingResult._cont = ASN1Dict([
        (u'unsigned', _EstablishOperationalBindingResult_unsigned),
        (u'signed', _EstablishOperationalBindingResult_signed),
        ])
    EstablishOperationalBindingResult._ext = None
    
    #-----< EstablishOperationalBindingResultData >-----#
    EstablishOperationalBindingResultData = SEQ(name=u'EstablishOperationalBindingResultData', mode=MODE_TYPE)
    _EstablishOperationalBindingResultData_bindingType = OID(name=u'bindingType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'id']))
    __EstablishOperationalBindingResultData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_0 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_1 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_2 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __EstablishOperationalBindingResultData_bindingType_tab._val = ASN1Set(rv=[dict([(u'Agreement', ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_0), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 5))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))]), dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 4))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), (u'modify', True), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), (u'terminate', True)])), (u'id', (2, 5, 19, 1))]), dict([(u'Agreement', ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_1), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), (u'terminate', True)])), (u'id', (2, 5, 19, 2))]), dict([(u'Agreement', ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_2), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), (u'terminate', True)])), (u'id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _EstablishOperationalBindingResultData_bindingType._const_tab = __EstablishOperationalBindingResultData_bindingType_tab
    _EstablishOperationalBindingResultData_bindingType._const_tab_at = None
    _EstablishOperationalBindingResultData_bindingType._const_tab_id = u'id'
    _EstablishOperationalBindingResultData_bindingID = SEQ(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')), opt=True)
    _EstablishOperationalBindingResultData_accessPoint = SET(name=u'accessPoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')))
    _EstablishOperationalBindingResultData_initiator = CHOICE(name=u'initiator', mode=MODE_TYPE)
    __EstablishOperationalBindingResultData_initiator_symmetric = OPEN(name=u'symmetric', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'both', u'EstablishParam']))
    __EstablishOperationalBindingResultData_initiator_symmetric._const_tab = __EstablishOperationalBindingResultData_bindingType_tab
    __EstablishOperationalBindingResultData_initiator_symmetric._const_tab_at = ('..', '..', u'bindingType')
    __EstablishOperationalBindingResultData_initiator_symmetric._const_tab_id = u'EstablishParam'
    __EstablishOperationalBindingResultData_initiator_roleA_replies = OPEN(name=u'roleA-replies', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'roleA', u'EstablishParam']))
    __EstablishOperationalBindingResultData_initiator_roleA_replies._const_tab = __EstablishOperationalBindingResultData_bindingType_tab
    __EstablishOperationalBindingResultData_initiator_roleA_replies._const_tab_at = ('..', '..', u'bindingType')
    __EstablishOperationalBindingResultData_initiator_roleA_replies._const_tab_id = u'EstablishParam'
    __EstablishOperationalBindingResultData_initiator_roleB_replies = OPEN(name=u'roleB-replies', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'roleB', u'EstablishParam']))
    __EstablishOperationalBindingResultData_initiator_roleB_replies._const_tab = __EstablishOperationalBindingResultData_bindingType_tab
    __EstablishOperationalBindingResultData_initiator_roleB_replies._const_tab_at = ('..', '..', u'bindingType')
    __EstablishOperationalBindingResultData_initiator_roleB_replies._const_tab_id = u'EstablishParam'
    _EstablishOperationalBindingResultData_initiator._cont = ASN1Dict([
        (u'symmetric', __EstablishOperationalBindingResultData_initiator_symmetric),
        (u'roleA-replies', __EstablishOperationalBindingResultData_initiator_roleA_replies),
        (u'roleB-replies', __EstablishOperationalBindingResultData_initiator_roleB_replies),
        ])
    _EstablishOperationalBindingResultData_initiator._ext = None
    _EstablishOperationalBindingResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _EstablishOperationalBindingResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _EstablishOperationalBindingResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _EstablishOperationalBindingResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __EstablishOperationalBindingResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___EstablishOperationalBindingResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____EstablishOperationalBindingResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __ATTRIBUTE_equality_match_val_AssertionType_0 = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____EstablishOperationalBindingResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___EstablishOperationalBindingResultData_notification__item__type._const_tab = ____EstablishOperationalBindingResultData_notification__item__type_tab
    ___EstablishOperationalBindingResultData_notification__item__type._const_tab_at = None
    ___EstablishOperationalBindingResultData_notification__item__type._const_tab_id = u'id'
    ___EstablishOperationalBindingResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____EstablishOperationalBindingResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____EstablishOperationalBindingResultData_notification__item__values__item_._const_tab = ____EstablishOperationalBindingResultData_notification__item__type_tab
    ____EstablishOperationalBindingResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____EstablishOperationalBindingResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___EstablishOperationalBindingResultData_notification__item__values._cont = ____EstablishOperationalBindingResultData_notification__item__values__item_
    ___EstablishOperationalBindingResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___EstablishOperationalBindingResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab = ____EstablishOperationalBindingResultData_notification__item__type_tab
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._cont = ______EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_
    _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item_._ext = []
    ___EstablishOperationalBindingResultData_notification__item__valuesWithContext._cont = ____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item_
    ___EstablishOperationalBindingResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __EstablishOperationalBindingResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___EstablishOperationalBindingResultData_notification__item__type),
        (u'values', ___EstablishOperationalBindingResultData_notification__item__values),
        (u'valuesWithContext', ___EstablishOperationalBindingResultData_notification__item__valuesWithContext),
        ])
    __EstablishOperationalBindingResultData_notification__item_._ext = []
    _EstablishOperationalBindingResultData_notification._cont = __EstablishOperationalBindingResultData_notification__item_
    EstablishOperationalBindingResultData._cont = ASN1Dict([
        (u'bindingType', _EstablishOperationalBindingResultData_bindingType),
        (u'bindingID', _EstablishOperationalBindingResultData_bindingID),
        (u'accessPoint', _EstablishOperationalBindingResultData_accessPoint),
        (u'initiator', _EstablishOperationalBindingResultData_initiator),
        (u'securityParameters', _EstablishOperationalBindingResultData_securityParameters),
        (u'performer', _EstablishOperationalBindingResultData_performer),
        (u'aliasDereferenced', _EstablishOperationalBindingResultData_aliasDereferenced),
        (u'notification', _EstablishOperationalBindingResultData_notification),
        ])
    EstablishOperationalBindingResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< modifyOperationalBinding >-----#
    modifyOperationalBinding = CLASS(name=u'modifyOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _modifyOperationalBinding_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgument')))
    _modifyOperationalBinding_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResult')))
    modifyOperationalBinding._val = dict([(u'ArgumentType', _modifyOperationalBinding_val_ArgumentType), (u'ResultType', _modifyOperationalBinding_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 100))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 102))])
    
    #-----< ModifyOperationalBindingArgument >-----#
    ModifyOperationalBindingArgument = CHOICE(name=u'ModifyOperationalBindingArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _ModifyOperationalBindingArgument_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgumentData')))
    _ModifyOperationalBindingArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __ModifyOperationalBindingArgument_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingArgumentData')))
    __ModifyOperationalBindingArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab = ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab = ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __ModifyOperationalBindingArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters),
        ])
    __ModifyOperationalBindingArgument_signed_algorithmIdentifier._ext = []
    __ModifyOperationalBindingArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _ModifyOperationalBindingArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __ModifyOperationalBindingArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __ModifyOperationalBindingArgument_signed_algorithmIdentifier),
        (u'signature', __ModifyOperationalBindingArgument_signed_signature),
        ])
    _ModifyOperationalBindingArgument_signed._ext = []
    ModifyOperationalBindingArgument._cont = ASN1Dict([
        (u'unsigned', _ModifyOperationalBindingArgument_unsigned),
        (u'signed', _ModifyOperationalBindingArgument_signed),
        ])
    ModifyOperationalBindingArgument._ext = None
    
    #-----< ModifyOperationalBindingArgumentData >-----#
    ModifyOperationalBindingArgumentData = SEQ(name=u'ModifyOperationalBindingArgumentData', mode=MODE_TYPE)
    _ModifyOperationalBindingArgumentData_bindingType = OID(name=u'bindingType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'id']))
    __ModifyOperationalBindingArgumentData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_0 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_1 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_2 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __ModifyOperationalBindingArgumentData_bindingType_tab._val = ASN1Set(rv=[dict([(u'Agreement', ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_0), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 5))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))]), dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 4))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), (u'modify', True), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), (u'terminate', True)])), (u'id', (2, 5, 19, 1))]), dict([(u'Agreement', ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_1), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), (u'terminate', True)])), (u'id', (2, 5, 19, 2))]), dict([(u'Agreement', ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_2), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), (u'terminate', True)])), (u'id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _ModifyOperationalBindingArgumentData_bindingType._const_tab = __ModifyOperationalBindingArgumentData_bindingType_tab
    _ModifyOperationalBindingArgumentData_bindingType._const_tab_at = None
    _ModifyOperationalBindingArgumentData_bindingType._const_tab_id = u'id'
    _ModifyOperationalBindingArgumentData_bindingID = SEQ(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _ModifyOperationalBindingArgumentData_accessPoint = SET(name=u'accessPoint', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DistributedOperations', 'AccessPoint')), opt=True)
    _ModifyOperationalBindingArgumentData_initiator = CHOICE(name=u'initiator', mode=MODE_TYPE, opt=True)
    __ModifyOperationalBindingArgumentData_initiator_symmetric = OPEN(name=u'symmetric', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'both', u'ModifyParam']))
    __ModifyOperationalBindingArgumentData_initiator_symmetric._const_tab = __ModifyOperationalBindingArgumentData_bindingType_tab
    __ModifyOperationalBindingArgumentData_initiator_symmetric._const_tab_at = ('..', '..', u'bindingType')
    __ModifyOperationalBindingArgumentData_initiator_symmetric._const_tab_id = u'ModifyParam'
    __ModifyOperationalBindingArgumentData_initiator_roleA_initiates = OPEN(name=u'roleA-initiates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'roleA', u'ModifyParam']))
    __ModifyOperationalBindingArgumentData_initiator_roleA_initiates._const_tab = __ModifyOperationalBindingArgumentData_bindingType_tab
    __ModifyOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_at = ('..', '..', u'bindingType')
    __ModifyOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_id = u'ModifyParam'
    __ModifyOperationalBindingArgumentData_initiator_roleB_initiates = OPEN(name=u'roleB-initiates', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'roleB', u'ModifyParam']))
    __ModifyOperationalBindingArgumentData_initiator_roleB_initiates._const_tab = __ModifyOperationalBindingArgumentData_bindingType_tab
    __ModifyOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_at = ('..', '..', u'bindingType')
    __ModifyOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_id = u'ModifyParam'
    _ModifyOperationalBindingArgumentData_initiator._cont = ASN1Dict([
        (u'symmetric', __ModifyOperationalBindingArgumentData_initiator_symmetric),
        (u'roleA-initiates', __ModifyOperationalBindingArgumentData_initiator_roleA_initiates),
        (u'roleB-initiates', __ModifyOperationalBindingArgumentData_initiator_roleB_initiates),
        ])
    _ModifyOperationalBindingArgumentData_initiator._ext = None
    _ModifyOperationalBindingArgumentData_newBindingID = SEQ(name=u'newBindingID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _ModifyOperationalBindingArgumentData_newAgreement = OPEN(name=u'newAgreement', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'Agreement']), opt=True)
    _ModifyOperationalBindingArgumentData_newAgreement._const_tab = __ModifyOperationalBindingArgumentData_bindingType_tab
    _ModifyOperationalBindingArgumentData_newAgreement._const_tab_at = ('..', u'bindingType')
    _ModifyOperationalBindingArgumentData_newAgreement._const_tab_id = u'Agreement'
    _ModifyOperationalBindingArgumentData_valid = SEQ(name=u'valid', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'ModifiedValidity')), opt=True)
    _ModifyOperationalBindingArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    ModifyOperationalBindingArgumentData._cont = ASN1Dict([
        (u'bindingType', _ModifyOperationalBindingArgumentData_bindingType),
        (u'bindingID', _ModifyOperationalBindingArgumentData_bindingID),
        (u'accessPoint', _ModifyOperationalBindingArgumentData_accessPoint),
        (u'initiator', _ModifyOperationalBindingArgumentData_initiator),
        (u'newBindingID', _ModifyOperationalBindingArgumentData_newBindingID),
        (u'newAgreement', _ModifyOperationalBindingArgumentData_newAgreement),
        (u'valid', _ModifyOperationalBindingArgumentData_valid),
        (u'securityParameters', _ModifyOperationalBindingArgumentData_securityParameters),
        ])
    ModifyOperationalBindingArgumentData._ext = []
    
    #-----< ModifiedValidity >-----#
    ModifiedValidity = SEQ(name=u'ModifiedValidity', mode=MODE_TYPE)
    _ModifiedValidity_validFrom = CHOICE(name=u'validFrom', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=(u'now', 0))
    __ModifiedValidity_validFrom_now = NULL(name=u'now', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ModifiedValidity_validFrom_time = CHOICE(name=u'time', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')))
    _ModifiedValidity_validFrom._cont = ASN1Dict([
        (u'now', __ModifiedValidity_validFrom_now),
        (u'time', __ModifiedValidity_validFrom_time),
        ])
    _ModifiedValidity_validFrom._ext = []
    _ModifiedValidity_validUntil = CHOICE(name=u'validUntil', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=(u'unchanged', 0))
    __ModifiedValidity_validUntil_explicitTermination = NULL(name=u'explicitTermination', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ModifiedValidity_validUntil_time = CHOICE(name=u'time', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')))
    __ModifiedValidity_validUntil_unchanged = NULL(name=u'unchanged', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _ModifiedValidity_validUntil._cont = ASN1Dict([
        (u'explicitTermination', __ModifiedValidity_validUntil_explicitTermination),
        (u'time', __ModifiedValidity_validUntil_time),
        (u'unchanged', __ModifiedValidity_validUntil_unchanged),
        ])
    _ModifiedValidity_validUntil._ext = []
    ModifiedValidity._cont = ASN1Dict([
        (u'validFrom', _ModifiedValidity_validFrom),
        (u'validUntil', _ModifiedValidity_validUntil),
        ])
    ModifiedValidity._ext = []
    
    #-----< ModifyOperationalBindingResult >-----#
    ModifyOperationalBindingResult = CHOICE(name=u'ModifyOperationalBindingResult', mode=MODE_TYPE)
    _ModifyOperationalBindingResult_null = NULL(name=u'null', mode=MODE_TYPE)
    _ModifyOperationalBindingResult_protected = CHOICE(name=u'protected', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __ModifyOperationalBindingResult_protected_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResultData')))
    __ModifyOperationalBindingResult_protected_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___ModifyOperationalBindingResult_protected_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'ModifyOperationalBindingResultData')))
    ___ModifyOperationalBindingResult_protected_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab = _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab = _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___ModifyOperationalBindingResult_protected_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters),
        ])
    ___ModifyOperationalBindingResult_protected_signed_algorithmIdentifier._ext = []
    ___ModifyOperationalBindingResult_protected_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __ModifyOperationalBindingResult_protected_signed._cont = ASN1Dict([
        (u'toBeSigned', ___ModifyOperationalBindingResult_protected_signed_toBeSigned),
        (u'algorithmIdentifier', ___ModifyOperationalBindingResult_protected_signed_algorithmIdentifier),
        (u'signature', ___ModifyOperationalBindingResult_protected_signed_signature),
        ])
    __ModifyOperationalBindingResult_protected_signed._ext = []
    _ModifyOperationalBindingResult_protected._cont = ASN1Dict([
        (u'unsigned', __ModifyOperationalBindingResult_protected_unsigned),
        (u'signed', __ModifyOperationalBindingResult_protected_signed),
        ])
    _ModifyOperationalBindingResult_protected._ext = None
    ModifyOperationalBindingResult._cont = ASN1Dict([
        (u'null', _ModifyOperationalBindingResult_null),
        (u'protected', _ModifyOperationalBindingResult_protected),
        ])
    ModifyOperationalBindingResult._ext = []
    
    #-----< ModifyOperationalBindingResultData >-----#
    ModifyOperationalBindingResultData = SEQ(name=u'ModifyOperationalBindingResultData', mode=MODE_TYPE)
    _ModifyOperationalBindingResultData_newBindingID = SEQ(name=u'newBindingID', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _ModifyOperationalBindingResultData_bindingType = OID(name=u'bindingType', mode=MODE_TYPE, typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'id']))
    __ModifyOperationalBindingResultData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_0 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_1 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_2 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __ModifyOperationalBindingResultData_bindingType_tab._val = ASN1Set(rv=[dict([(u'Agreement', ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_0), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 5))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))]), dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 4))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), (u'modify', True), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), (u'terminate', True)])), (u'id', (2, 5, 19, 1))]), dict([(u'Agreement', ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_1), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), (u'terminate', True)])), (u'id', (2, 5, 19, 2))]), dict([(u'Agreement', ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_2), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), (u'terminate', True)])), (u'id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _ModifyOperationalBindingResultData_bindingType._const_tab = __ModifyOperationalBindingResultData_bindingType_tab
    _ModifyOperationalBindingResultData_bindingType._const_tab_at = None
    _ModifyOperationalBindingResultData_bindingType._const_tab_id = u'id'
    _ModifyOperationalBindingResultData_newAgreement = OPEN(name=u'newAgreement', mode=MODE_TYPE, typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'Agreement']))
    _ModifyOperationalBindingResultData_newAgreement._const_tab = __ModifyOperationalBindingResultData_bindingType_tab
    _ModifyOperationalBindingResultData_newAgreement._const_tab_at = ('..', u'bindingType')
    _ModifyOperationalBindingResultData_newAgreement._const_tab_id = u'Agreement'
    _ModifyOperationalBindingResultData_valid = SEQ(name=u'valid', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'Validity')), opt=True)
    _ModifyOperationalBindingResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _ModifyOperationalBindingResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _ModifyOperationalBindingResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _ModifyOperationalBindingResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ModifyOperationalBindingResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___ModifyOperationalBindingResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____ModifyOperationalBindingResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____ModifyOperationalBindingResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___ModifyOperationalBindingResultData_notification__item__type._const_tab = ____ModifyOperationalBindingResultData_notification__item__type_tab
    ___ModifyOperationalBindingResultData_notification__item__type._const_tab_at = None
    ___ModifyOperationalBindingResultData_notification__item__type._const_tab_id = u'id'
    ___ModifyOperationalBindingResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____ModifyOperationalBindingResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____ModifyOperationalBindingResultData_notification__item__values__item_._const_tab = ____ModifyOperationalBindingResultData_notification__item__type_tab
    ____ModifyOperationalBindingResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____ModifyOperationalBindingResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___ModifyOperationalBindingResultData_notification__item__values._cont = ____ModifyOperationalBindingResultData_notification__item__values__item_
    ___ModifyOperationalBindingResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___ModifyOperationalBindingResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab = ____ModifyOperationalBindingResultData_notification__item__type_tab
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._cont = ______ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_
    _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item_._ext = []
    ___ModifyOperationalBindingResultData_notification__item__valuesWithContext._cont = ____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item_
    ___ModifyOperationalBindingResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ModifyOperationalBindingResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___ModifyOperationalBindingResultData_notification__item__type),
        (u'values', ___ModifyOperationalBindingResultData_notification__item__values),
        (u'valuesWithContext', ___ModifyOperationalBindingResultData_notification__item__valuesWithContext),
        ])
    __ModifyOperationalBindingResultData_notification__item_._ext = []
    _ModifyOperationalBindingResultData_notification._cont = __ModifyOperationalBindingResultData_notification__item_
    ModifyOperationalBindingResultData._cont = ASN1Dict([
        (u'newBindingID', _ModifyOperationalBindingResultData_newBindingID),
        (u'bindingType', _ModifyOperationalBindingResultData_bindingType),
        (u'newAgreement', _ModifyOperationalBindingResultData_newAgreement),
        (u'valid', _ModifyOperationalBindingResultData_valid),
        (u'securityParameters', _ModifyOperationalBindingResultData_securityParameters),
        (u'performer', _ModifyOperationalBindingResultData_performer),
        (u'aliasDereferenced', _ModifyOperationalBindingResultData_aliasDereferenced),
        (u'notification', _ModifyOperationalBindingResultData_notification),
        ])
    ModifyOperationalBindingResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< terminateOperationalBinding >-----#
    terminateOperationalBinding = CLASS(name=u'terminateOperationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'OPERATION')))
    _terminateOperationalBinding_val_ArgumentType = CHOICE(name=u'ArgumentType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgument')))
    _terminateOperationalBinding_val_ResultType = CHOICE(name=u'ResultType', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResult')))
    terminateOperationalBinding._val = dict([(u'ArgumentType', _terminateOperationalBinding_val_ArgumentType), (u'ResultType', _terminateOperationalBinding_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_0), (u'errorCode', (u'local', 100))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 101))])
    
    #-----< TerminateOperationalBindingArgument >-----#
    TerminateOperationalBindingArgument = CHOICE(name=u'TerminateOperationalBindingArgument', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    _TerminateOperationalBindingArgument_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgumentData')))
    _TerminateOperationalBindingArgument_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    __TerminateOperationalBindingArgument_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingArgumentData')))
    __TerminateOperationalBindingArgument_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab = ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab = ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __TerminateOperationalBindingArgument_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm),
        (u'parameters', ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters),
        ])
    __TerminateOperationalBindingArgument_signed_algorithmIdentifier._ext = []
    __TerminateOperationalBindingArgument_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    _TerminateOperationalBindingArgument_signed._cont = ASN1Dict([
        (u'toBeSigned', __TerminateOperationalBindingArgument_signed_toBeSigned),
        (u'algorithmIdentifier', __TerminateOperationalBindingArgument_signed_algorithmIdentifier),
        (u'signature', __TerminateOperationalBindingArgument_signed_signature),
        ])
    _TerminateOperationalBindingArgument_signed._ext = []
    TerminateOperationalBindingArgument._cont = ASN1Dict([
        (u'unsigned', _TerminateOperationalBindingArgument_unsigned),
        (u'signed', _TerminateOperationalBindingArgument_signed),
        ])
    TerminateOperationalBindingArgument._ext = None
    
    #-----< TerminateOperationalBindingArgumentData >-----#
    TerminateOperationalBindingArgumentData = SEQ(name=u'TerminateOperationalBindingArgumentData', mode=MODE_TYPE)
    _TerminateOperationalBindingArgumentData_bindingType = OID(name=u'bindingType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'id']))
    __TerminateOperationalBindingArgumentData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_0 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_1 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_2 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __TerminateOperationalBindingArgumentData_bindingType_tab._val = ASN1Set(rv=[dict([(u'Agreement', ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_0), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 5))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))]), dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 4))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), (u'modify', True), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), (u'terminate', True)])), (u'id', (2, 5, 19, 1))]), dict([(u'Agreement', ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_1), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), (u'terminate', True)])), (u'id', (2, 5, 19, 2))]), dict([(u'Agreement', ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_2), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), (u'terminate', True)])), (u'id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _TerminateOperationalBindingArgumentData_bindingType._const_tab = __TerminateOperationalBindingArgumentData_bindingType_tab
    _TerminateOperationalBindingArgumentData_bindingType._const_tab_at = None
    _TerminateOperationalBindingArgumentData_bindingType._const_tab_id = u'id'
    _TerminateOperationalBindingArgumentData_bindingID = SEQ(name=u'bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _TerminateOperationalBindingArgumentData_initiator = CHOICE(name=u'initiator', mode=MODE_TYPE, opt=True)
    __TerminateOperationalBindingArgumentData_initiator_symmetric = OPEN(name=u'symmetric', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'both', u'TerminateParam']))
    __TerminateOperationalBindingArgumentData_initiator_symmetric._const_tab = __TerminateOperationalBindingArgumentData_bindingType_tab
    __TerminateOperationalBindingArgumentData_initiator_symmetric._const_tab_at = ('..', '..', u'bindingType')
    __TerminateOperationalBindingArgumentData_initiator_symmetric._const_tab_id = u'TerminateParam'
    __TerminateOperationalBindingArgumentData_initiator_roleA_initiates = OPEN(name=u'roleA-initiates', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'roleA', u'TerminateParam']))
    __TerminateOperationalBindingArgumentData_initiator_roleA_initiates._const_tab = __TerminateOperationalBindingArgumentData_bindingType_tab
    __TerminateOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_at = ('..', '..', u'bindingType')
    __TerminateOperationalBindingArgumentData_initiator_roleA_initiates._const_tab_id = u'TerminateParam'
    __TerminateOperationalBindingArgumentData_initiator_roleB_initiates = OPEN(name=u'roleB-initiates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'roleB', u'TerminateParam']))
    __TerminateOperationalBindingArgumentData_initiator_roleB_initiates._const_tab = __TerminateOperationalBindingArgumentData_bindingType_tab
    __TerminateOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_at = ('..', '..', u'bindingType')
    __TerminateOperationalBindingArgumentData_initiator_roleB_initiates._const_tab_id = u'TerminateParam'
    _TerminateOperationalBindingArgumentData_initiator._cont = ASN1Dict([
        (u'symmetric', __TerminateOperationalBindingArgumentData_initiator_symmetric),
        (u'roleA-initiates', __TerminateOperationalBindingArgumentData_initiator_roleA_initiates),
        (u'roleB-initiates', __TerminateOperationalBindingArgumentData_initiator_roleB_initiates),
        ])
    _TerminateOperationalBindingArgumentData_initiator._ext = None
    _TerminateOperationalBindingArgumentData_terminateAt = CHOICE(name=u'terminateAt', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')), opt=True)
    _TerminateOperationalBindingArgumentData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    TerminateOperationalBindingArgumentData._cont = ASN1Dict([
        (u'bindingType', _TerminateOperationalBindingArgumentData_bindingType),
        (u'bindingID', _TerminateOperationalBindingArgumentData_bindingID),
        (u'initiator', _TerminateOperationalBindingArgumentData_initiator),
        (u'terminateAt', _TerminateOperationalBindingArgumentData_terminateAt),
        (u'securityParameters', _TerminateOperationalBindingArgumentData_securityParameters),
        ])
    TerminateOperationalBindingArgumentData._ext = []
    
    #-----< TerminateOperationalBindingResult >-----#
    TerminateOperationalBindingResult = CHOICE(name=u'TerminateOperationalBindingResult', mode=MODE_TYPE)
    _TerminateOperationalBindingResult_null = NULL(name=u'null', mode=MODE_TYPE)
    _TerminateOperationalBindingResult_protected = CHOICE(name=u'protected', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __TerminateOperationalBindingResult_protected_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResultData')))
    __TerminateOperationalBindingResult_protected_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___TerminateOperationalBindingResult_protected_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'TerminateOperationalBindingResultData')))
    ___TerminateOperationalBindingResult_protected_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab = _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab = _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___TerminateOperationalBindingResult_protected_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters),
        ])
    ___TerminateOperationalBindingResult_protected_signed_algorithmIdentifier._ext = []
    ___TerminateOperationalBindingResult_protected_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __TerminateOperationalBindingResult_protected_signed._cont = ASN1Dict([
        (u'toBeSigned', ___TerminateOperationalBindingResult_protected_signed_toBeSigned),
        (u'algorithmIdentifier', ___TerminateOperationalBindingResult_protected_signed_algorithmIdentifier),
        (u'signature', ___TerminateOperationalBindingResult_protected_signed_signature),
        ])
    __TerminateOperationalBindingResult_protected_signed._ext = []
    _TerminateOperationalBindingResult_protected._cont = ASN1Dict([
        (u'unsigned', __TerminateOperationalBindingResult_protected_unsigned),
        (u'signed', __TerminateOperationalBindingResult_protected_signed),
        ])
    _TerminateOperationalBindingResult_protected._ext = None
    TerminateOperationalBindingResult._cont = ASN1Dict([
        (u'null', _TerminateOperationalBindingResult_null),
        (u'protected', _TerminateOperationalBindingResult_protected),
        ])
    TerminateOperationalBindingResult._ext = []
    
    #-----< TerminateOperationalBindingResultData >-----#
    TerminateOperationalBindingResultData = SEQ(name=u'TerminateOperationalBindingResultData', mode=MODE_TYPE)
    _TerminateOperationalBindingResultData_bindingID = SEQ(name=u'bindingID', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OperationalBindingID')))
    _TerminateOperationalBindingResultData_bindingType = OID(name=u'bindingType', mode=MODE_TYPE, typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'id']))
    __TerminateOperationalBindingResultData_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_0 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_1 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_2 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __TerminateOperationalBindingResultData_bindingType_tab._val = ASN1Set(rv=[dict([(u'Agreement', ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_0), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 5))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))]), dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 4))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), (u'modify', True), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), (u'terminate', True)])), (u'id', (2, 5, 19, 1))]), dict([(u'Agreement', ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_1), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), (u'terminate', True)])), (u'id', (2, 5, 19, 2))]), dict([(u'Agreement', ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_2), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), (u'terminate', True)])), (u'id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _TerminateOperationalBindingResultData_bindingType._const_tab = __TerminateOperationalBindingResultData_bindingType_tab
    _TerminateOperationalBindingResultData_bindingType._const_tab_at = None
    _TerminateOperationalBindingResultData_bindingType._const_tab_id = u'id'
    _TerminateOperationalBindingResultData_terminateAt = TIME_GEN(name=u'terminateAt', mode=MODE_TYPE, opt=True)
    _TerminateOperationalBindingResultData_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _TerminateOperationalBindingResultData_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _TerminateOperationalBindingResultData_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _TerminateOperationalBindingResultData_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __TerminateOperationalBindingResultData_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___TerminateOperationalBindingResultData_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____TerminateOperationalBindingResultData_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____TerminateOperationalBindingResultData_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___TerminateOperationalBindingResultData_notification__item__type._const_tab = ____TerminateOperationalBindingResultData_notification__item__type_tab
    ___TerminateOperationalBindingResultData_notification__item__type._const_tab_at = None
    ___TerminateOperationalBindingResultData_notification__item__type._const_tab_id = u'id'
    ___TerminateOperationalBindingResultData_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____TerminateOperationalBindingResultData_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____TerminateOperationalBindingResultData_notification__item__values__item_._const_tab = ____TerminateOperationalBindingResultData_notification__item__type_tab
    ____TerminateOperationalBindingResultData_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____TerminateOperationalBindingResultData_notification__item__values__item_._const_tab_id = u'Type'
    ___TerminateOperationalBindingResultData_notification__item__values._cont = ____TerminateOperationalBindingResultData_notification__item__values__item_
    ___TerminateOperationalBindingResultData_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___TerminateOperationalBindingResultData_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab = ____TerminateOperationalBindingResultData_notification__item__type_tab
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._cont = ______TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_
    _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value),
        (u'contextList', _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList),
        ])
    ____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item_._ext = []
    ___TerminateOperationalBindingResultData_notification__item__valuesWithContext._cont = ____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item_
    ___TerminateOperationalBindingResultData_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __TerminateOperationalBindingResultData_notification__item_._cont = ASN1Dict([
        (u'type', ___TerminateOperationalBindingResultData_notification__item__type),
        (u'values', ___TerminateOperationalBindingResultData_notification__item__values),
        (u'valuesWithContext', ___TerminateOperationalBindingResultData_notification__item__valuesWithContext),
        ])
    __TerminateOperationalBindingResultData_notification__item_._ext = []
    _TerminateOperationalBindingResultData_notification._cont = __TerminateOperationalBindingResultData_notification__item_
    TerminateOperationalBindingResultData._cont = ASN1Dict([
        (u'bindingID', _TerminateOperationalBindingResultData_bindingID),
        (u'bindingType', _TerminateOperationalBindingResultData_bindingType),
        (u'terminateAt', _TerminateOperationalBindingResultData_terminateAt),
        (u'securityParameters', _TerminateOperationalBindingResultData_securityParameters),
        (u'performer', _TerminateOperationalBindingResultData_performer),
        (u'aliasDereferenced', _TerminateOperationalBindingResultData_aliasDereferenced),
        (u'notification', _TerminateOperationalBindingResultData_notification),
        ])
    TerminateOperationalBindingResultData._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    #-----< operationalBindingError >-----#
    operationalBindingError = CLASS(name=u'operationalBindingError', mode=MODE_VALUE, typeref=ASN1RefType(('CommonProtocolSpecification', 'ERROR')))
    _operationalBindingError_val_ParameterType = CHOICE(name=u'ParameterType', mode=MODE_TYPE, typeref=ASN1RefType(('EnhancedSecurity', 'OPTIONALLY-PROTECTED-SEQ')))
    __operationalBindingError_val_ParameterType_unsigned = SEQ(name=u'unsigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    __operationalBindingError_val_ParameterType_signed = SEQ(name=u'signed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'SIGNED')))
    ___operationalBindingError_val_ParameterType_signed_toBeSigned = SEQ(name=u'toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('OperationalBindingManagement', 'OpBindingErrorParam')))
    ___operationalBindingError_val_ParameterType_signed_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab = _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_at = None
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab = _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters_tab
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters._const_tab_id = u'Type'
    ___operationalBindingError_val_ParameterType_signed_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm),
        (u'parameters', ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters),
        ])
    ___operationalBindingError_val_ParameterType_signed_algorithmIdentifier._ext = []
    ___operationalBindingError_val_ParameterType_signed_signature = BIT_STR(name=u'signature', mode=MODE_TYPE)
    __operationalBindingError_val_ParameterType_signed._cont = ASN1Dict([
        (u'toBeSigned', ___operationalBindingError_val_ParameterType_signed_toBeSigned),
        (u'algorithmIdentifier', ___operationalBindingError_val_ParameterType_signed_algorithmIdentifier),
        (u'signature', ___operationalBindingError_val_ParameterType_signed_signature),
        ])
    __operationalBindingError_val_ParameterType_signed._ext = []
    _operationalBindingError_val_ParameterType._cont = ASN1Dict([
        (u'unsigned', __operationalBindingError_val_ParameterType_unsigned),
        (u'signed', __operationalBindingError_val_ParameterType_signed),
        ])
    _operationalBindingError_val_ParameterType._ext = None
    operationalBindingError._val = dict([(u'ParameterType', _operationalBindingError_val_ParameterType), (u'errorCode', (u'local', 100))])
    
    #-----< OpBindingErrorParam >-----#
    OpBindingErrorParam = SEQ(name=u'OpBindingErrorParam', mode=MODE_TYPE)
    _OpBindingErrorParam_problem = ENUM(name=u'problem', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _OpBindingErrorParam_problem._cont = ASN1Dict([(u'invalidID', 0), (u'duplicateID', 1), (u'unsupportedBindingType', 2), (u'notAllowedForRole', 3), (u'parametersMissing', 4), (u'roleAssignment', 5), (u'invalidStartTime', 6), (u'invalidEndTime', 7), (u'invalidAgreement', 8), (u'currentlyNotDecidable', 9), (u'modificationNotAllowed', 10), (u'invalidBindingType', 11), (u'invalidNewID', 12)])
    _OpBindingErrorParam_problem._ext = []
    _OpBindingErrorParam_bindingType = OID(name=u'bindingType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'id']), opt=True)
    __OpBindingErrorParam_bindingType_tab = CLASS(name='_tab_OPERATIONAL-BINDING', mode=MODE_SET, typeref=ASN1RefType(('OperationalBindingManagement', 'OPERATIONAL-BINDING')))
    ___OpBindingErrorParam_bindingType_tab_val_Agreement_0 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryShadowAbstractService', 'ShadowingAgreementInfo')))
    ___OpBindingErrorParam_bindingType_tab_val_Agreement_1 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'HierarchicalAgreement')))
    ___OpBindingErrorParam_bindingType_tab_val_Agreement_2 = SEQ(name=u'Agreement', mode=MODE_TYPE, typeref=ASN1RefType(('HierarchicalOperationalBindings', 'NonSpecificHierarchicalAgreement')))
    __OpBindingErrorParam_bindingType_tab._val = ASN1Set(rv=[dict([(u'Agreement', ___OpBindingErrorParam_bindingType_tab_val_Agreement_0), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 5))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))]), dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 4))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_0_0), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_0_0), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __OP_BINDING_COOP_Operations_val_ArgumentType_1), (u'ResultType', __OP_BINDING_COOP_Operations_val_ResultType_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_1), (u'errorCode', (u'local', 1))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam), (u'modify', True), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam), (u'terminate', True)])), (u'id', (2, 5, 19, 1))]), dict([(u'Agreement', ___OpBindingErrorParam_bindingType_tab_val_Agreement_1), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_0), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_0), (u'terminate', True)])), (u'id', (2, 5, 19, 2))]), dict([(u'Agreement', ___OpBindingErrorParam_bindingType_tab_val_Agreement_2), (u'Cooperation', ASN1Set(rv=[dict([(u'applContext', dict([(u'bind-operation', dict([(u'ArgumentType', __APPLICATION_CONTEXT_bind_operation_val_ArgumentType), (u'ResultType', __APPLICATION_CONTEXT_bind_operation_val_ResultType), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0)])], rr=[], ev=None, er=[]))])), (u'Operations', ASN1Set(rv=[dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_0_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 1))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_1_1), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 2))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_2), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_2), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_3), (u'errorCode', (u'local', 7))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 3))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_3), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_3), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_0), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 4))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_4), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_4), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5), (u'errorCode', (u'local', 5))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6), (u'errorCode', (u'local', 6))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 5))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_5), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_5), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 6))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_6), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_6), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 7))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_7), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_7), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_0), (u'errorCode', (u'local', 1))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_0), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_6_0), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 8))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_8), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_8), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_1), (u'errorCode', (u'local', 2))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_0), (u'errorCode', (u'local', 3))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_3_0), (u'errorCode', (u'local', 4))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_4_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_5_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 9))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_9), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_9), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 11))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_10), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_10), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1), (u'errorCode', (u'local', 6))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_1), (u'errorCode', (u'local', 8))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 10))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_11), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_11), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_1_2), (u'errorCode', (u'local', 7))]), dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_2_2), (u'errorCode', (u'local', 5))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 12))]), dict([(u'ArgumentType', __APPLICATION_CONTEXT_Operations_val_ArgumentType_12), (u'ResultType', __APPLICATION_CONTEXT_Operations_val_ResultType_12), (u'Errors', ASN1Set(rv=[dict([(u'ParameterType', __OPERATION_Errors_val_ParameterType_0_2), (u'errorCode', (u'local', 9))])], rr=[], ev=None, er=[])), (u'operationCode', (u'local', 13))])], rr=[], ev=None, er=[])), (u'applicationContextName', (2, 5, 3, 2))]))])], rr=[], ev=None, er=[])), (u'roleA', dict([(u'EstablishParam', __OPERATIONAL_BINDING_roleA_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleA_val_ModifyParam_0), (u'terminate', True)])), (u'roleB', dict([(u'establish', True), (u'EstablishParam', __OPERATIONAL_BINDING_roleB_val_EstablishParam_1), (u'modify', True), (u'ModifyParam', __OPERATIONAL_BINDING_roleB_val_ModifyParam_1), (u'terminate', True)])), (u'id', (2, 5, 19, 3))])], rr=[], ev=None, er=[])
    _OpBindingErrorParam_bindingType._const_tab = __OpBindingErrorParam_bindingType_tab
    _OpBindingErrorParam_bindingType._const_tab_at = None
    _OpBindingErrorParam_bindingType._const_tab_id = u'id'
    _OpBindingErrorParam_agreementProposal = OPEN(name=u'agreementProposal', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('OperationalBindingManagement', 'OPERATIONAL-BINDING'), [u'Agreement']), opt=True)
    _OpBindingErrorParam_agreementProposal._const_tab = __OpBindingErrorParam_bindingType_tab
    _OpBindingErrorParam_agreementProposal._const_tab_at = ('..', u'bindingType')
    _OpBindingErrorParam_agreementProposal._const_tab_id = u'Agreement'
    _OpBindingErrorParam_retryAt = CHOICE(name=u'retryAt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OperationalBindingManagement', 'Time')), opt=True)
    _OpBindingErrorParam_securityParameters = SET(name=u'securityParameters', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SecurityParameters')), opt=True)
    _OpBindingErrorParam_performer = SEQ_OF(name=u'performer', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')), opt=True)
    _OpBindingErrorParam_aliasDereferenced = BOOL(name=u'aliasDereferenced', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _OpBindingErrorParam_notification = SEQ_OF(name=u'notification', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __OpBindingErrorParam_notification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___OpBindingErrorParam_notification__item__type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____OpBindingErrorParam_notification__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____OpBindingErrorParam_notification__item__type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____OpBindingErrorParam_notification__item__type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____OpBindingErrorParam_notification__item__type_tab._val = ASN1Set(rv=[dict([(u'Type', _____OpBindingErrorParam_notification__item__type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____OpBindingErrorParam_notification__item__type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___OpBindingErrorParam_notification__item__type._const_tab = ____OpBindingErrorParam_notification__item__type_tab
    ___OpBindingErrorParam_notification__item__type._const_tab_at = None
    ___OpBindingErrorParam_notification__item__type._const_tab_id = u'id'
    ___OpBindingErrorParam_notification__item__values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____OpBindingErrorParam_notification__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____OpBindingErrorParam_notification__item__values__item_._const_tab = ____OpBindingErrorParam_notification__item__type_tab
    ____OpBindingErrorParam_notification__item__values__item_._const_tab_at = ('..', '..', u'type')
    ____OpBindingErrorParam_notification__item__values__item_._const_tab_id = u'Type'
    ___OpBindingErrorParam_notification__item__values._cont = ____OpBindingErrorParam_notification__item__values__item_
    ___OpBindingErrorParam_notification__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___OpBindingErrorParam_notification__item__valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____OpBindingErrorParam_notification__item__valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__value._const_tab = ____OpBindingErrorParam_notification__item__type_tab
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__value._const_tab_id = u'Type'
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______OpBindingErrorParam_notification__item__valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__contextList._cont = ______OpBindingErrorParam_notification__item__valuesWithContext__item__contextList__item_
    _____OpBindingErrorParam_notification__item__valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____OpBindingErrorParam_notification__item__valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____OpBindingErrorParam_notification__item__valuesWithContext__item__value),
        (u'contextList', _____OpBindingErrorParam_notification__item__valuesWithContext__item__contextList),
        ])
    ____OpBindingErrorParam_notification__item__valuesWithContext__item_._ext = []
    ___OpBindingErrorParam_notification__item__valuesWithContext._cont = ____OpBindingErrorParam_notification__item__valuesWithContext__item_
    ___OpBindingErrorParam_notification__item__valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __OpBindingErrorParam_notification__item_._cont = ASN1Dict([
        (u'type', ___OpBindingErrorParam_notification__item__type),
        (u'values', ___OpBindingErrorParam_notification__item__values),
        (u'valuesWithContext', ___OpBindingErrorParam_notification__item__valuesWithContext),
        ])
    __OpBindingErrorParam_notification__item_._ext = []
    _OpBindingErrorParam_notification._cont = __OpBindingErrorParam_notification__item_
    OpBindingErrorParam._cont = ASN1Dict([
        (u'problem', _OpBindingErrorParam_problem),
        (u'bindingType', _OpBindingErrorParam_bindingType),
        (u'agreementProposal', _OpBindingErrorParam_agreementProposal),
        (u'retryAt', _OpBindingErrorParam_retryAt),
        (u'securityParameters', _OpBindingErrorParam_securityParameters),
        (u'performer', _OpBindingErrorParam_performer),
        (u'aliasDereferenced', _OpBindingErrorParam_aliasDereferenced),
        (u'notification', _OpBindingErrorParam_notification),
        ])
    OpBindingErrorParam._ext = [u'securityParameters', u'performer', u'aliasDereferenced', u'notification']
    
    _all_ = [
        dSAOperationalBindingManagementBind,
        _dSAOperationalBindingManagementBind_val_ArgumentType,
        _dSAOperationalBindingManagementBind_val_ResultType,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_versions,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_serviceError,
        _____OPERATION_Errors_val_ParameterType_0_unsigned_error_securityError,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_error,
        ____OPERATION_Errors_val_ParameterType_0_unsigned_securityParameters,
        ___OPERATION_Errors_val_ParameterType_0_unsigned,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_versions,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_serviceError,
        ______OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error_securityError,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_error,
        _____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned_securityParameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_signed,
        __OPERATION_Errors_val_ParameterType_0,
        _OPERATIONAL_BINDING_Agreement,
        _OPERATIONAL_BINDING_Cooperation,
        _OPERATIONAL_BINDING_both,
        _OPERATIONAL_BINDING_roleA,
        _OPERATIONAL_BINDING_roleB,
        _OPERATIONAL_BINDING_id,
        OPERATIONAL_BINDING,
        _OP_BINDING_COOP_applContext,
        _OP_BINDING_COOP_Operations,
        OP_BINDING_COOP,
        _OP_BIND_ROLE_establish,
        _OP_BIND_ROLE_EstablishParam,
        _OP_BIND_ROLE_modify,
        _OP_BIND_ROLE_ModifyParam,
        _OP_BIND_ROLE_terminate,
        _OP_BIND_ROLE_TerminateParam,
        OP_BIND_ROLE,
        establishOperationalBinding,
        _establishOperationalBinding_val_ArgumentType,
        _establishOperationalBinding_val_ResultType,
        ___OPERATION_Errors_val_ParameterType_0_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_0_signed,
        __OPERATION_Errors_val_ParameterType_0_0,
        ___OPERATION_Errors_val_ParameterType_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_signed,
        __OPERATION_Errors_val_ParameterType_1,
        _EstablishOperationalBindingArgument_unsigned,
        __EstablishOperationalBindingArgument_signed_toBeSigned,
        ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab,
        ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_algorithm,
        ____EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab,
        ___EstablishOperationalBindingArgument_signed_algorithmIdentifier_parameters,
        __EstablishOperationalBindingArgument_signed_algorithmIdentifier,
        __EstablishOperationalBindingArgument_signed_signature,
        _EstablishOperationalBindingArgument_signed,
        EstablishOperationalBindingArgument,
        __EstablishOperationalBindingArgumentData_bindingType_tab,
        ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_0,
        __APPLICATION_CONTEXT_bind_operation_val_ArgumentType,
        __APPLICATION_CONTEXT_bind_operation_val_ResultType,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0,
        ___OPERATION_Errors_val_ParameterType_0_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_1_signed,
        __OPERATION_Errors_val_ParameterType_0_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1,
        __OP_BINDING_COOP_Operations_val_ArgumentType_0,
        __OP_BINDING_COOP_Operations_val_ResultType_0,
        __OP_BINDING_COOP_Operations_val_ArgumentType_1,
        __OP_BINDING_COOP_Operations_val_ResultType_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_0,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_0,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_0,
        __OP_BINDING_COOP_Operations_val_ArgumentType_0_0,
        __OP_BINDING_COOP_Operations_val_ResultType_0_0,
        __OPERATIONAL_BINDING_roleA_val_EstablishParam,
        __OPERATIONAL_BINDING_roleB_val_EstablishParam,
        __OPERATIONAL_BINDING_roleB_val_ModifyParam,
        ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_0_1,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_0_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_0_1,
        ___OPERATION_Errors_val_ParameterType_0_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_2_signed,
        __OPERATION_Errors_val_ParameterType_0_2,
        ___OPERATION_Errors_val_ParameterType_1_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_0_signed,
        __OPERATION_Errors_val_ParameterType_1_0,
        ___OPERATION_Errors_val_ParameterType_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_signed,
        __OPERATION_Errors_val_ParameterType_2,
        ___OPERATION_Errors_val_ParameterType_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_signed,
        __OPERATION_Errors_val_ParameterType_3,
        ___OPERATION_Errors_val_ParameterType_4_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_signed,
        __OPERATION_Errors_val_ParameterType_4,
        ___OPERATION_Errors_val_ParameterType_5_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_signed,
        __OPERATION_Errors_val_ParameterType_5,
        ___OPERATION_Errors_val_ParameterType_6_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_signed,
        __OPERATION_Errors_val_ParameterType_6,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_1_1,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_1_1_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_1_1,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_2,
        __APPLICATION_CONTEXT_Operations_val_ResultType_2,
        ___OPERATION_Errors_val_ParameterType_0_3_unsigned,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_0_3_signed_signature,
        ___OPERATION_Errors_val_ParameterType_0_3_signed,
        __OPERATION_Errors_val_ParameterType_0_3,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_3_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_3,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_3_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_3_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_3,
        ___OPERATION_Errors_val_ParameterType_1_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_1_signed,
        __OPERATION_Errors_val_ParameterType_1_1,
        ___OPERATION_Errors_val_ParameterType_2_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_0_signed,
        __OPERATION_Errors_val_ParameterType_2_0,
        ___OPERATION_Errors_val_ParameterType_3_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_3_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_3_0_signed,
        __OPERATION_Errors_val_ParameterType_3_0,
        ___OPERATION_Errors_val_ParameterType_4_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_0_signed,
        __OPERATION_Errors_val_ParameterType_4_0,
        ___OPERATION_Errors_val_ParameterType_5_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_0_signed,
        __OPERATION_Errors_val_ParameterType_5_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_4_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_4,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_4_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_4_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_4,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_5_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_5,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_5_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_5_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_5,
        ___OPERATION_Errors_val_ParameterType_6_0_unsigned,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_6_0_signed_signature,
        ___OPERATION_Errors_val_ParameterType_6_0_signed,
        __OPERATION_Errors_val_ParameterType_6_0,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_6_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_6,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_6_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_6_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_6,
        ___OPERATION_Errors_val_ParameterType_4_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_4_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_4_1_signed,
        __OPERATION_Errors_val_ParameterType_4_1,
        ___OPERATION_Errors_val_ParameterType_5_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_5_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_5_1_signed,
        __OPERATION_Errors_val_ParameterType_5_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_7_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_7,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_7_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_7_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_7,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_8_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_8,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_8_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_8_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_8,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_9_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_9,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_9_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_9_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_9,
        ___OPERATION_Errors_val_ParameterType_2_1_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_1_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_1_signed,
        __OPERATION_Errors_val_ParameterType_2_1,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_10_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_10,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_10_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_10_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_10,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_11,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType__item_,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_chainedResult,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType__item_,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_11_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_11_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_11,
        ___OPERATION_Errors_val_ParameterType_1_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_1_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_1_2_signed,
        __OPERATION_Errors_val_ParameterType_1_2,
        ___OPERATION_Errors_val_ParameterType_2_2_unsigned,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_toBeSigned,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_algorithm,
        ______OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters_tab,
        _____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier_parameters,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_algorithmIdentifier,
        ____OPERATION_Errors_val_ParameterType_2_2_signed_signature,
        ___OPERATION_Errors_val_ParameterType_2_2_signed,
        __OPERATION_Errors_val_ParameterType_2_2,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_chainedArgument,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned_ArgumentType,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_chainedArgument,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned_ArgumentType,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ArgumentType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ArgumentType_12,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_chainedResult,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned_ResultType,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_unsigned,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_chainedResult,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned_ResultType,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_toBeSigned,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_algorithm,
        ______APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters_tab,
        _____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier_parameters,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_algorithmIdentifier,
        ____APPLICATION_CONTEXT_Operations_val_ResultType_12_signed_signature,
        ___APPLICATION_CONTEXT_Operations_val_ResultType_12_signed,
        __APPLICATION_CONTEXT_Operations_val_ResultType_12,
        __OPERATIONAL_BINDING_roleA_val_EstablishParam_0,
        __OPERATIONAL_BINDING_roleA_val_ModifyParam,
        __OPERATIONAL_BINDING_roleB_val_EstablishParam_0,
        __OPERATIONAL_BINDING_roleB_val_ModifyParam_0,
        ___EstablishOperationalBindingArgumentData_bindingType_tab_val_Agreement_2,
        __OPERATIONAL_BINDING_roleA_val_EstablishParam_1,
        __OPERATIONAL_BINDING_roleA_val_ModifyParam_0,
        __OPERATIONAL_BINDING_roleB_val_EstablishParam_1,
        __OPERATIONAL_BINDING_roleB_val_ModifyParam_1,
        _EstablishOperationalBindingArgumentData_bindingType,
        _EstablishOperationalBindingArgumentData_bindingID,
        _EstablishOperationalBindingArgumentData_accessPoint,
        __EstablishOperationalBindingArgumentData_initiator_symmetric,
        __EstablishOperationalBindingArgumentData_initiator_roleA_initiates,
        __EstablishOperationalBindingArgumentData_initiator_roleB_initiates,
        _EstablishOperationalBindingArgumentData_initiator,
        _EstablishOperationalBindingArgumentData_agreement,
        _EstablishOperationalBindingArgumentData_valid,
        _EstablishOperationalBindingArgumentData_securityParameters,
        EstablishOperationalBindingArgumentData,
        OpBindingSet,
        _OpBindingSet_val_Agreement_0,
        _OpBindingSet_val_Agreement_1,
        _OpBindingSet_val_Agreement_2,
        _OperationalBindingID_identifier,
        _OperationalBindingID_version,
        OperationalBindingID,
        __Validity_validFrom_now,
        __Validity_validFrom_time,
        _Validity_validFrom,
        __Validity_validUntil_explicitTermination,
        __Validity_validUntil_time,
        _Validity_validUntil,
        Validity,
        _Time_utcTime,
        _Time_generalizedTime,
        Time,
        _EstablishOperationalBindingResult_unsigned,
        __EstablishOperationalBindingResult_signed_toBeSigned,
        ____EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm_tab,
        ___EstablishOperationalBindingResult_signed_algorithmIdentifier_algorithm,
        ____EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters_tab,
        ___EstablishOperationalBindingResult_signed_algorithmIdentifier_parameters,
        __EstablishOperationalBindingResult_signed_algorithmIdentifier,
        __EstablishOperationalBindingResult_signed_signature,
        _EstablishOperationalBindingResult_signed,
        EstablishOperationalBindingResult,
        __EstablishOperationalBindingResultData_bindingType_tab,
        ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_0,
        ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_1,
        ___EstablishOperationalBindingResultData_bindingType_tab_val_Agreement_2,
        _EstablishOperationalBindingResultData_bindingType,
        _EstablishOperationalBindingResultData_bindingID,
        _EstablishOperationalBindingResultData_accessPoint,
        __EstablishOperationalBindingResultData_initiator_symmetric,
        __EstablishOperationalBindingResultData_initiator_roleA_replies,
        __EstablishOperationalBindingResultData_initiator_roleB_replies,
        _EstablishOperationalBindingResultData_initiator,
        _EstablishOperationalBindingResultData_securityParameters,
        _EstablishOperationalBindingResultData_performer,
        _EstablishOperationalBindingResultData_aliasDereferenced,
        ____EstablishOperationalBindingResultData_notification__item__type_tab,
        _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_0,
        __ATTRIBUTE_equality_match_val_AssertionType,
        _____EstablishOperationalBindingResultData_notification__item__type_tab_val_Type_1,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        ___EstablishOperationalBindingResultData_notification__item__type,
        ____EstablishOperationalBindingResultData_notification__item__values__item_,
        ___EstablishOperationalBindingResultData_notification__item__values,
        _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__value,
        ______EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item__contextList,
        ____EstablishOperationalBindingResultData_notification__item__valuesWithContext__item_,
        ___EstablishOperationalBindingResultData_notification__item__valuesWithContext,
        __EstablishOperationalBindingResultData_notification__item_,
        _EstablishOperationalBindingResultData_notification,
        EstablishOperationalBindingResultData,
        modifyOperationalBinding,
        _modifyOperationalBinding_val_ArgumentType,
        _modifyOperationalBinding_val_ResultType,
        _ModifyOperationalBindingArgument_unsigned,
        __ModifyOperationalBindingArgument_signed_toBeSigned,
        ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab,
        ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_algorithm,
        ____ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab,
        ___ModifyOperationalBindingArgument_signed_algorithmIdentifier_parameters,
        __ModifyOperationalBindingArgument_signed_algorithmIdentifier,
        __ModifyOperationalBindingArgument_signed_signature,
        _ModifyOperationalBindingArgument_signed,
        ModifyOperationalBindingArgument,
        __ModifyOperationalBindingArgumentData_bindingType_tab,
        ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_0,
        ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_1,
        ___ModifyOperationalBindingArgumentData_bindingType_tab_val_Agreement_2,
        _ModifyOperationalBindingArgumentData_bindingType,
        _ModifyOperationalBindingArgumentData_bindingID,
        _ModifyOperationalBindingArgumentData_accessPoint,
        __ModifyOperationalBindingArgumentData_initiator_symmetric,
        __ModifyOperationalBindingArgumentData_initiator_roleA_initiates,
        __ModifyOperationalBindingArgumentData_initiator_roleB_initiates,
        _ModifyOperationalBindingArgumentData_initiator,
        _ModifyOperationalBindingArgumentData_newBindingID,
        _ModifyOperationalBindingArgumentData_newAgreement,
        _ModifyOperationalBindingArgumentData_valid,
        _ModifyOperationalBindingArgumentData_securityParameters,
        ModifyOperationalBindingArgumentData,
        __ModifiedValidity_validFrom_now,
        __ModifiedValidity_validFrom_time,
        _ModifiedValidity_validFrom,
        __ModifiedValidity_validUntil_explicitTermination,
        __ModifiedValidity_validUntil_time,
        __ModifiedValidity_validUntil_unchanged,
        _ModifiedValidity_validUntil,
        ModifiedValidity,
        _ModifyOperationalBindingResult_null,
        __ModifyOperationalBindingResult_protected_unsigned,
        ___ModifyOperationalBindingResult_protected_signed_toBeSigned,
        _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab,
        ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm,
        _____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab,
        ____ModifyOperationalBindingResult_protected_signed_algorithmIdentifier_parameters,
        ___ModifyOperationalBindingResult_protected_signed_algorithmIdentifier,
        ___ModifyOperationalBindingResult_protected_signed_signature,
        __ModifyOperationalBindingResult_protected_signed,
        _ModifyOperationalBindingResult_protected,
        ModifyOperationalBindingResult,
        _ModifyOperationalBindingResultData_newBindingID,
        __ModifyOperationalBindingResultData_bindingType_tab,
        ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_0,
        ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_1,
        ___ModifyOperationalBindingResultData_bindingType_tab_val_Agreement_2,
        _ModifyOperationalBindingResultData_bindingType,
        _ModifyOperationalBindingResultData_newAgreement,
        _ModifyOperationalBindingResultData_valid,
        _ModifyOperationalBindingResultData_securityParameters,
        _ModifyOperationalBindingResultData_performer,
        _ModifyOperationalBindingResultData_aliasDereferenced,
        ____ModifyOperationalBindingResultData_notification__item__type_tab,
        _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_0,
        _____ModifyOperationalBindingResultData_notification__item__type_tab_val_Type_1,
        ___ModifyOperationalBindingResultData_notification__item__type,
        ____ModifyOperationalBindingResultData_notification__item__values__item_,
        ___ModifyOperationalBindingResultData_notification__item__values,
        _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__value,
        ______ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item__contextList,
        ____ModifyOperationalBindingResultData_notification__item__valuesWithContext__item_,
        ___ModifyOperationalBindingResultData_notification__item__valuesWithContext,
        __ModifyOperationalBindingResultData_notification__item_,
        _ModifyOperationalBindingResultData_notification,
        ModifyOperationalBindingResultData,
        terminateOperationalBinding,
        _terminateOperationalBinding_val_ArgumentType,
        _terminateOperationalBinding_val_ResultType,
        _TerminateOperationalBindingArgument_unsigned,
        __TerminateOperationalBindingArgument_signed_toBeSigned,
        ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm_tab,
        ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_algorithm,
        ____TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters_tab,
        ___TerminateOperationalBindingArgument_signed_algorithmIdentifier_parameters,
        __TerminateOperationalBindingArgument_signed_algorithmIdentifier,
        __TerminateOperationalBindingArgument_signed_signature,
        _TerminateOperationalBindingArgument_signed,
        TerminateOperationalBindingArgument,
        __TerminateOperationalBindingArgumentData_bindingType_tab,
        ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_0,
        ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_1,
        ___TerminateOperationalBindingArgumentData_bindingType_tab_val_Agreement_2,
        _TerminateOperationalBindingArgumentData_bindingType,
        _TerminateOperationalBindingArgumentData_bindingID,
        __TerminateOperationalBindingArgumentData_initiator_symmetric,
        __TerminateOperationalBindingArgumentData_initiator_roleA_initiates,
        __TerminateOperationalBindingArgumentData_initiator_roleB_initiates,
        _TerminateOperationalBindingArgumentData_initiator,
        _TerminateOperationalBindingArgumentData_terminateAt,
        _TerminateOperationalBindingArgumentData_securityParameters,
        TerminateOperationalBindingArgumentData,
        _TerminateOperationalBindingResult_null,
        __TerminateOperationalBindingResult_protected_unsigned,
        ___TerminateOperationalBindingResult_protected_signed_toBeSigned,
        _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm_tab,
        ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_algorithm,
        _____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters_tab,
        ____TerminateOperationalBindingResult_protected_signed_algorithmIdentifier_parameters,
        ___TerminateOperationalBindingResult_protected_signed_algorithmIdentifier,
        ___TerminateOperationalBindingResult_protected_signed_signature,
        __TerminateOperationalBindingResult_protected_signed,
        _TerminateOperationalBindingResult_protected,
        TerminateOperationalBindingResult,
        _TerminateOperationalBindingResultData_bindingID,
        __TerminateOperationalBindingResultData_bindingType_tab,
        ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_0,
        ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_1,
        ___TerminateOperationalBindingResultData_bindingType_tab_val_Agreement_2,
        _TerminateOperationalBindingResultData_bindingType,
        _TerminateOperationalBindingResultData_terminateAt,
        _TerminateOperationalBindingResultData_securityParameters,
        _TerminateOperationalBindingResultData_performer,
        _TerminateOperationalBindingResultData_aliasDereferenced,
        ____TerminateOperationalBindingResultData_notification__item__type_tab,
        _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_0,
        _____TerminateOperationalBindingResultData_notification__item__type_tab_val_Type_1,
        ___TerminateOperationalBindingResultData_notification__item__type,
        ____TerminateOperationalBindingResultData_notification__item__values__item_,
        ___TerminateOperationalBindingResultData_notification__item__values,
        _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__value,
        ______TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList__item_,
        _____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item__contextList,
        ____TerminateOperationalBindingResultData_notification__item__valuesWithContext__item_,
        ___TerminateOperationalBindingResultData_notification__item__valuesWithContext,
        __TerminateOperationalBindingResultData_notification__item_,
        _TerminateOperationalBindingResultData_notification,
        TerminateOperationalBindingResultData,
        operationalBindingError,
        __operationalBindingError_val_ParameterType_unsigned,
        ___operationalBindingError_val_ParameterType_signed_toBeSigned,
        _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm_tab,
        ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_algorithm,
        _____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters_tab,
        ____operationalBindingError_val_ParameterType_signed_algorithmIdentifier_parameters,
        ___operationalBindingError_val_ParameterType_signed_algorithmIdentifier,
        ___operationalBindingError_val_ParameterType_signed_signature,
        __operationalBindingError_val_ParameterType_signed,
        _operationalBindingError_val_ParameterType,
        _OpBindingErrorParam_problem,
        __OpBindingErrorParam_bindingType_tab,
        ___OpBindingErrorParam_bindingType_tab_val_Agreement_0,
        ___OpBindingErrorParam_bindingType_tab_val_Agreement_1,
        ___OpBindingErrorParam_bindingType_tab_val_Agreement_2,
        _OpBindingErrorParam_bindingType,
        _OpBindingErrorParam_agreementProposal,
        _OpBindingErrorParam_retryAt,
        _OpBindingErrorParam_securityParameters,
        _OpBindingErrorParam_performer,
        _OpBindingErrorParam_aliasDereferenced,
        ____OpBindingErrorParam_notification__item__type_tab,
        _____OpBindingErrorParam_notification__item__type_tab_val_Type_0,
        _____OpBindingErrorParam_notification__item__type_tab_val_Type_1,
        ___OpBindingErrorParam_notification__item__type,
        ____OpBindingErrorParam_notification__item__values__item_,
        ___OpBindingErrorParam_notification__item__values,
        _____OpBindingErrorParam_notification__item__valuesWithContext__item__value,
        ______OpBindingErrorParam_notification__item__valuesWithContext__item__contextList__item_,
        _____OpBindingErrorParam_notification__item__valuesWithContext__item__contextList,
        ____OpBindingErrorParam_notification__item__valuesWithContext__item_,
        ___OpBindingErrorParam_notification__item__valuesWithContext,
        __OpBindingErrorParam_notification__item_,
        _OpBindingErrorParam_notification,
        OpBindingErrorParam,
    ]

class OSIProtocolSpecification:

    _name_  = u'OSIProtocolSpecification'
    _oid_   = [2, 5, 1, 36, 8]
    
    _obj_ = [
        u'OSI-PDU',
        u'OsiBind',
        u'Presentation-selector',
        u'Context-list',
        u'Presentation-context-identifier',
        u'Abstract-syntax-name',
        u'Transfer-syntax-name',
        u'AARQ-apdu',
        u'Association-informationBind',
        u'Application-context-name',
        u'AP-invocation-identifier',
        u'AE-invocation-identifier',
        u'Implementation-data',
        u'TheOsiBind',
        u'OsiBindResult',
        u'Result',
        u'AARE-apdu',
        u'Association-informationBindRes',
        u'Associate-result',
        u'Associate-source-diagnostic',
        u'TheOsiBindRes',
        u'OsiBindError',
        u'Result-list',
        u'Provider-reason',
        u'AAREerr-apdu',
        u'Association-informationBindErr',
        u'TheOsiBindErr',
        u'OsiUnbind',
        u'TheOsiUnbind',
        u'Release-request-reason',
        u'OsiUnbindResult',
        u'TheOsiUnbindRes',
        u'Release-response-reason',
        u'OsiOperation',
        u'OsiDirectoryOperation',
        u'OsiReq',
        u'OsiRes',
        u'OsiErr',
        u'OsiRej',
        u'GeneralProblem',
        u'InvokeProblem',
        u'ReturnResultProblem',
        u'ReturnErrorProblem',
        u'PresentationAbort',
        u'ARU-PPDU',
        u'Presentation-context-identifier-list',
        u'ABRT-apdu',
        u'ABRT-source',
        u'ARP-PPDU',
        u'Abort-reason',
        u'Event-identifier',
        ]
    _type_ = [
        u'OSI-PDU',
        u'OsiBind',
        u'Presentation-selector',
        u'Context-list',
        u'Presentation-context-identifier',
        u'Abstract-syntax-name',
        u'Transfer-syntax-name',
        u'AARQ-apdu',
        u'Association-informationBind',
        u'Application-context-name',
        u'AP-invocation-identifier',
        u'AE-invocation-identifier',
        u'Implementation-data',
        u'TheOsiBind',
        u'OsiBindResult',
        u'Result',
        u'AARE-apdu',
        u'Association-informationBindRes',
        u'Associate-result',
        u'Associate-source-diagnostic',
        u'TheOsiBindRes',
        u'OsiBindError',
        u'Result-list',
        u'Provider-reason',
        u'AAREerr-apdu',
        u'Association-informationBindErr',
        u'TheOsiBindErr',
        u'OsiUnbind',
        u'TheOsiUnbind',
        u'Release-request-reason',
        u'OsiUnbindResult',
        u'TheOsiUnbindRes',
        u'Release-response-reason',
        u'OsiOperation',
        u'OsiDirectoryOperation',
        u'OsiReq',
        u'OsiRes',
        u'OsiErr',
        u'OsiRej',
        u'GeneralProblem',
        u'InvokeProblem',
        u'ReturnResultProblem',
        u'ReturnErrorProblem',
        u'PresentationAbort',
        u'ARU-PPDU',
        u'Presentation-context-identifier-list',
        u'ABRT-apdu',
        u'ABRT-source',
        u'ARP-PPDU',
        u'Abort-reason',
        u'Event-identifier',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        u'OSI-PDU',
        u'OsiBind',
        u'AARQ-apdu',
        u'Association-informationBind',
        u'TheOsiBind',
        u'OsiBindResult',
        u'AARE-apdu',
        u'Association-informationBindRes',
        u'TheOsiBindRes',
        u'OsiBindError',
        u'AAREerr-apdu',
        u'Association-informationBindErr',
        u'TheOsiBindErr',
        u'OsiOperation',
        u'OsiDirectoryOperation',
        u'OsiReq',
        u'OsiRes',
        u'OsiErr',
        ]
    
    #-----< OSI-PDU >-----#
    OSI_PDU = OPEN(name=u'OSI-PDU', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', u'TYPE-IDENTIFIER'), [u'Type']), param=True)
    
    #-----< OsiBind >-----#
    OsiBind = SET(name=u'OsiBind', mode=MODE_TYPE, param=True)
    
    #-----< Presentation-selector >-----#
    Presentation_selector = OCT_STR(name=u'Presentation-selector', mode=MODE_TYPE)
    Presentation_selector._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=[], er=[ASN1RangeInt(lb=5, ub=None)])
    
    #-----< Context-list >-----#
    Context_list = SEQ_OF(name=u'Context-list', mode=MODE_TYPE)
    _Context_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Context_list__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    __Context_list__item__abstract_syntax_name = OID(name=u'abstract-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Abstract-syntax-name')))
    __Context_list__item__transfer_syntax_name_list = SEQ_OF(name=u'transfer-syntax-name-list', mode=MODE_TYPE)
    ___Context_list__item__transfer_syntax_name_list__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    __Context_list__item__transfer_syntax_name_list._cont = ___Context_list__item__transfer_syntax_name_list__item_
    _Context_list__item_._cont = ASN1Dict([
        (u'presentation-context-identifier', __Context_list__item__presentation_context_identifier),
        (u'abstract-syntax-name', __Context_list__item__abstract_syntax_name),
        (u'transfer-syntax-name-list', __Context_list__item__transfer_syntax_name_list),
        ])
    _Context_list__item_._ext = None
    Context_list._cont = _Context_list__item_
    Context_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< Presentation-context-identifier >-----#
    Presentation_context_identifier = INT(name=u'Presentation-context-identifier', mode=MODE_TYPE)
    Presentation_context_identifier._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=127)], ev=[], er=[ASN1RangeInt(lb=128, ub=None)])
    
    #-----< Abstract-syntax-name >-----#
    Abstract_syntax_name = OID(name=u'Abstract-syntax-name', mode=MODE_TYPE)
    
    #-----< Transfer-syntax-name >-----#
    Transfer_syntax_name = OID(name=u'Transfer-syntax-name', mode=MODE_TYPE)
    
    #-----< AARQ-apdu >-----#
    AARQ_apdu = SEQ(name=u'AARQ-apdu', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT), param=True)
    
    #-----< Association-informationBind >-----#
    Association_informationBind = SEQ_OF(name=u'Association-informationBind', mode=MODE_TYPE, param=True)
    
    #-----< Application-context-name >-----#
    Application_context_name = OID(name=u'Application-context-name', mode=MODE_TYPE)
    
    #-----< AP-invocation-identifier >-----#
    AP_invocation_identifier = INT(name=u'AP-invocation-identifier', mode=MODE_TYPE)
    
    #-----< AE-invocation-identifier >-----#
    AE_invocation_identifier = INT(name=u'AE-invocation-identifier', mode=MODE_TYPE)
    
    #-----< Implementation-data >-----#
    Implementation_data = STR_GRAPH(name=u'Implementation-data', mode=MODE_TYPE)
    
    #-----< TheOsiBind >-----#
    TheOsiBind = OPEN(name=u'TheOsiBind', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT'), [u'bind-operation', u'ArgumentType']), param=True)
    
    #-----< OsiBindResult >-----#
    OsiBindResult = SET(name=u'OsiBindResult', mode=MODE_TYPE, param=True)
    
    #-----< Result >-----#
    Result = INT(name=u'Result', mode=MODE_TYPE)
    Result._cont = ASN1Dict([(u'acceptance', 0), (u'user-rejection', 1), (u'provider-rejection', 2)])
    
    #-----< AARE-apdu >-----#
    AARE_apdu = SEQ(name=u'AARE-apdu', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), param=True)
    
    #-----< Association-informationBindRes >-----#
    Association_informationBindRes = SEQ_OF(name=u'Association-informationBindRes', mode=MODE_TYPE, param=True)
    
    #-----< Associate-result >-----#
    Associate_result = INT(name=u'Associate-result', mode=MODE_TYPE)
    Associate_result._cont = ASN1Dict([(u'accepted', 0), (u'rejected-permanent', 1), (u'rejected-transient', 2)])
    Associate_result._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2)], ev=[], er=[])
    
    #-----< Associate-source-diagnostic >-----#
    Associate_source_diagnostic = CHOICE(name=u'Associate-source-diagnostic', mode=MODE_TYPE)
    _Associate_source_diagnostic_acse_service_user = INT(name=u'acse-service-user', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_acse_service_user._cont = ASN1Dict([(u'null', 0), (u'no-reason-given', 1), (u'application-context-name-not-supported', 2), (u'calling-AP-title-not-recognized', 3), (u'calling-AP-invocation-identifier-not-recognized', 4), (u'calling-AE-qualifier-not-recognized', 5), (u'calling-AE-invocation-identifier-not-recognized', 6), (u'called-AP-title-not-recognized', 7), (u'called-AP-invocation-identifier-not-recognized', 8), (u'called-AE-qualifier-not-recognized', 9), (u'called-AE-invocation-identifier-not-recognized', 10)])
    _Associate_source_diagnostic_acse_service_user._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=[], er=[])
    _Associate_source_diagnostic_acse_service_provider = INT(name=u'acse-service-provider', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _Associate_source_diagnostic_acse_service_provider._cont = ASN1Dict([(u'null', 0), (u'no-reason-given', 1), (u'no-common-acse-version', 2)])
    _Associate_source_diagnostic_acse_service_provider._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2)], ev=[], er=[])
    Associate_source_diagnostic._cont = ASN1Dict([
        (u'acse-service-user', _Associate_source_diagnostic_acse_service_user),
        (u'acse-service-provider', _Associate_source_diagnostic_acse_service_provider),
        ])
    Associate_source_diagnostic._ext = None
    
    #-----< TheOsiBindRes >-----#
    TheOsiBindRes = OPEN(name=u'TheOsiBindRes', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT'), [u'bind-operation', u'ResultType']), param=True)
    
    #-----< OsiBindError >-----#
    OsiBindError = CHOICE(name=u'OsiBindError', mode=MODE_TYPE, param=True)
    
    #-----< Result-list >-----#
    Result_list = SEQ_OF(name=u'Result-list', mode=MODE_TYPE)
    _Result_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Result_list__item__result = INT(name=u'result', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Result')))
    __Result_list__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')), opt=True)
    __Result_list__item__provider_reason = INT(name=u'provider-reason', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Result_list__item__provider_reason._cont = ASN1Dict([(u'reason-not-specified', 0), (u'abstract-syntax-not-supported', 1), (u'proposed-transfer-syntaxes-not-supported', 2)])
    _Result_list__item_._cont = ASN1Dict([
        (u'result', __Result_list__item__result),
        (u'transfer-syntax-name', __Result_list__item__transfer_syntax_name),
        (u'provider-reason', __Result_list__item__provider_reason),
        ])
    _Result_list__item_._ext = None
    Result_list._cont = _Result_list__item_
    Result_list._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< Provider-reason >-----#
    Provider_reason = INT(name=u'Provider-reason', mode=MODE_TYPE)
    Provider_reason._cont = ASN1Dict([(u'reason-not-specified', 0), (u'temporary-congestion', 1), (u'local-limit-exceeded', 2), (u'called-presentation-address-unknown', 3), (u'protocol-version-not-supported', 4), (u'default-context-not-supported', 5), (u'user-data-not-readable', 6), (u'no-PSAP-available', 7)])
    
    #-----< AAREerr-apdu >-----#
    AAREerr_apdu = SEQ(name=u'AAREerr-apdu', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT), param=True)
    
    #-----< Association-informationBindErr >-----#
    Association_informationBindErr = SEQ_OF(name=u'Association-informationBindErr', mode=MODE_TYPE, param=True)
    
    #-----< TheOsiBindErr >-----#
    TheOsiBindErr = OPEN(name=u'TheOsiBindErr', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('DirectoryOSIProtocols', 'APPLICATION-CONTEXT'), [u'bind-operation', u'Errors', u'ParameterType']), param=True)
    
    #-----< OsiUnbind >-----#
    OsiUnbind = CHOICE(name=u'OsiUnbind', mode=MODE_TYPE)
    _OsiUnbind_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    __OsiUnbind_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___OsiUnbind_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ___OsiUnbind_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    ____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    _____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'TheOsiUnbind')))
    ____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[_____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ___OsiUnbind_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', ____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ___OsiUnbind_fully_encoded_data__item__presentation_data_values._ext = None
    __OsiUnbind_fully_encoded_data__item_._cont = ASN1Dict([
        (u'presentation-context-identifier', ___OsiUnbind_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ___OsiUnbind_fully_encoded_data__item__presentation_data_values),
        ])
    __OsiUnbind_fully_encoded_data__item_._ext = None
    _OsiUnbind_fully_encoded_data._cont = __OsiUnbind_fully_encoded_data__item_
    _OsiUnbind_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    OsiUnbind._cont = ASN1Dict([
        (u'fully-encoded-data', _OsiUnbind_fully_encoded_data),
        ])
    OsiUnbind._ext = None
    
    #-----< TheOsiUnbind >-----#
    TheOsiUnbind = SEQ(name=u'TheOsiUnbind', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_IMPLICIT))
    _TheOsiUnbind_reason = INT(name=u'reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Release-request-reason')), opt=True)
    TheOsiUnbind._cont = ASN1Dict([
        (u'reason', _TheOsiUnbind_reason),
        ])
    TheOsiUnbind._ext = None
    
    #-----< Release-request-reason >-----#
    Release_request_reason = INT(name=u'Release-request-reason', mode=MODE_TYPE)
    Release_request_reason._cont = ASN1Dict([(u'normal', 0)])
    
    #-----< OsiUnbindResult >-----#
    OsiUnbindResult = CHOICE(name=u'OsiUnbindResult', mode=MODE_TYPE)
    _OsiUnbindResult_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    __OsiUnbindResult_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___OsiUnbindResult_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    ___OsiUnbindResult_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    ____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    _____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'TheOsiUnbindRes')))
    ____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[_____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    ___OsiUnbindResult_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', ____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    ___OsiUnbindResult_fully_encoded_data__item__presentation_data_values._ext = None
    __OsiUnbindResult_fully_encoded_data__item_._cont = ASN1Dict([
        (u'presentation-context-identifier', ___OsiUnbindResult_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', ___OsiUnbindResult_fully_encoded_data__item__presentation_data_values),
        ])
    __OsiUnbindResult_fully_encoded_data__item_._ext = None
    _OsiUnbindResult_fully_encoded_data._cont = __OsiUnbindResult_fully_encoded_data__item_
    _OsiUnbindResult_fully_encoded_data._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    OsiUnbindResult._cont = ASN1Dict([
        (u'fully-encoded-data', _OsiUnbindResult_fully_encoded_data),
        ])
    OsiUnbindResult._ext = None
    
    #-----< TheOsiUnbindRes >-----#
    TheOsiUnbindRes = SEQ(name=u'TheOsiUnbindRes', mode=MODE_TYPE, tag=(3, TAG_APPLICATION, TAG_IMPLICIT))
    _TheOsiUnbindRes_reason = INT(name=u'reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Release-response-reason')), opt=True)
    TheOsiUnbindRes._cont = ASN1Dict([
        (u'reason', _TheOsiUnbindRes_reason),
        ])
    TheOsiUnbindRes._ext = None
    
    #-----< Release-response-reason >-----#
    Release_response_reason = INT(name=u'Release-response-reason', mode=MODE_TYPE)
    Release_response_reason._cont = ASN1Dict([(u'normal', 0)])
    
    #-----< OsiOperation >-----#
    OsiOperation = CHOICE(name=u'OsiOperation', mode=MODE_TYPE, param=True)
    
    #-----< OsiDirectoryOperation >-----#
    OsiDirectoryOperation = CHOICE(name=u'OsiDirectoryOperation', mode=MODE_TYPE, param=True)
    
    #-----< OsiReq >-----#
    OsiReq = SEQ(name=u'OsiReq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), param=True)
    
    #-----< OsiRes >-----#
    OsiRes = SEQ(name=u'OsiRes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), param=True)
    
    #-----< OsiErr >-----#
    OsiErr = SEQ(name=u'OsiErr', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), param=True)
    
    #-----< OsiRej >-----#
    OsiRej = SEQ(name=u'OsiRej', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _OsiRej_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('CommonProtocolSpecification', 'InvokeId')))
    _OsiRej_problem = CHOICE(name=u'problem', mode=MODE_TYPE)
    __OsiRej_problem_general = INT(name=u'general', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'GeneralProblem')))
    __OsiRej_problem_invoke = INT(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'InvokeProblem')))
    __OsiRej_problem_returnResult = INT(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'ReturnResultProblem')))
    __OsiRej_problem_returnError = INT(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'ReturnErrorProblem')))
    _OsiRej_problem._cont = ASN1Dict([
        (u'general', __OsiRej_problem_general),
        (u'invoke', __OsiRej_problem_invoke),
        (u'returnResult', __OsiRej_problem_returnResult),
        (u'returnError', __OsiRej_problem_returnError),
        ])
    _OsiRej_problem._ext = []
    OsiRej._cont = ASN1Dict([
        (u'invokeId', _OsiRej_invokeId),
        (u'problem', _OsiRej_problem),
        ])
    OsiRej._ext = []
    
    #-----< GeneralProblem >-----#
    GeneralProblem = INT(name=u'GeneralProblem', mode=MODE_TYPE)
    GeneralProblem._cont = ASN1Dict([(u'unrecognizedPDU', 0), (u'mistypedPDU', 1), (u'badlyStructuredPDU', 2)])
    
    #-----< InvokeProblem >-----#
    InvokeProblem = INT(name=u'InvokeProblem', mode=MODE_TYPE)
    InvokeProblem._cont = ASN1Dict([(u'duplicateInvocation', 0), (u'unrecognizedOperation', 1), (u'mistypedArgument', 2), (u'resourceLimitation', 3), (u'releaseInProgress', 4)])
    
    #-----< ReturnResultProblem >-----#
    ReturnResultProblem = INT(name=u'ReturnResultProblem', mode=MODE_TYPE)
    ReturnResultProblem._cont = ASN1Dict([(u'unrecognizedInvocation', 0), (u'resultResponseUnexpected', 1), (u'mistypedResult', 2)])
    
    #-----< ReturnErrorProblem >-----#
    ReturnErrorProblem = INT(name=u'ReturnErrorProblem', mode=MODE_TYPE)
    ReturnErrorProblem._cont = ASN1Dict([(u'unrecognizedInvocation', 0), (u'errorResponseUnexpected', 1), (u'unrecognizedError', 2), (u'unexpectedError', 3), (u'mistypedParameter', 4)])
    
    #-----< PresentationAbort >-----#
    PresentationAbort = CHOICE(name=u'PresentationAbort', mode=MODE_TYPE)
    _PresentationAbort_aru_ppdu = CHOICE(name=u'aru-ppdu', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'ARU-PPDU')))
    _PresentationAbort_arp_ppdu = SEQ(name=u'arp-ppdu', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'ARP-PPDU')))
    PresentationAbort._cont = ASN1Dict([
        (u'aru-ppdu', _PresentationAbort_aru_ppdu),
        (u'arp-ppdu', _PresentationAbort_arp_ppdu),
        ])
    PresentationAbort._ext = None
    
    #-----< ARU-PPDU >-----#
    ARU_PPDU = CHOICE(name=u'ARU-PPDU', mode=MODE_TYPE)
    _ARU_PPDU_normal_mode_parameters = SEQ(name=u'normal-mode-parameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ARU_PPDU_normal_mode_parameters_presentation_context_identifier_list = SEQ_OF(name=u'presentation-context-identifier-list', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier-list')))
    __ARU_PPDU_normal_mode_parameters_user_data = CHOICE(name=u'user-data', mode=MODE_TYPE)
    ___ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data = SEQ_OF(name=u'fully-encoded-data', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_IMPLICIT))
    ____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values = CHOICE(name=u'presentation-data-values', mode=MODE_TYPE)
    ______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type = OPEN(name=u'single-ASN1-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('_IMPL_', u'ABSTRACT-SYNTAX'), [u'Type']))
    _______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0 = SEQ(name=u'single-ASN1-type', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'ABRT-apdu')))
    ______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type._const_val = ASN1Set(rv=[_______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0], ev=None)
    _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._cont = ASN1Dict([
        (u'single-ASN1-type', ______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type),
        ])
    _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values._ext = None
    ____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item_._cont = ASN1Dict([
        (u'presentation-context-identifier', _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier),
        (u'presentation-data-values', _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values),
        ])
    ____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item_._ext = None
    ___ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data._cont = ____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item_
    ___ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ARU_PPDU_normal_mode_parameters_user_data._cont = ASN1Dict([
        (u'fully-encoded-data', ___ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data),
        ])
    __ARU_PPDU_normal_mode_parameters_user_data._ext = None
    _ARU_PPDU_normal_mode_parameters._cont = ASN1Dict([
        (u'presentation-context-identifier-list', __ARU_PPDU_normal_mode_parameters_presentation_context_identifier_list),
        (u'user-data', __ARU_PPDU_normal_mode_parameters_user_data),
        ])
    _ARU_PPDU_normal_mode_parameters._ext = None
    ARU_PPDU._cont = ASN1Dict([
        (u'normal-mode-parameters', _ARU_PPDU_normal_mode_parameters),
        ])
    ARU_PPDU._ext = None
    
    #-----< Presentation-context-identifier-list >-----#
    Presentation_context_identifier_list = SEQ_OF(name=u'Presentation-context-identifier-list', mode=MODE_TYPE)
    _Presentation_context_identifier_list__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Presentation_context_identifier_list__item__presentation_context_identifier = INT(name=u'presentation-context-identifier', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Presentation-context-identifier')))
    __Presentation_context_identifier_list__item__transfer_syntax_name = OID(name=u'transfer-syntax-name', mode=MODE_TYPE, typeref=ASN1RefType(('OSIProtocolSpecification', 'Transfer-syntax-name')))
    _Presentation_context_identifier_list__item_._cont = ASN1Dict([
        (u'presentation-context-identifier', __Presentation_context_identifier_list__item__presentation_context_identifier),
        (u'transfer-syntax-name', __Presentation_context_identifier_list__item__transfer_syntax_name),
        ])
    _Presentation_context_identifier_list__item_._ext = None
    Presentation_context_identifier_list._cont = _Presentation_context_identifier_list__item_
    Presentation_context_identifier_list._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ABRT-apdu >-----#
    ABRT_apdu = SEQ(name=u'ABRT-apdu', mode=MODE_TYPE, tag=(4, TAG_APPLICATION, TAG_IMPLICIT))
    _ABRT_apdu_abort_source = INT(name=u'abort-source', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'ABRT-source')))
    ABRT_apdu._cont = ASN1Dict([
        (u'abort-source', _ABRT_apdu_abort_source),
        ])
    ABRT_apdu._ext = None
    
    #-----< ABRT-source >-----#
    ABRT_source = INT(name=u'ABRT-source', mode=MODE_TYPE)
    ABRT_source._cont = ASN1Dict([(u'acse-service-user', 0), (u'acse-service-provider', 1)])
    
    #-----< ARP-PPDU >-----#
    ARP_PPDU = SEQ(name=u'ARP-PPDU', mode=MODE_TYPE)
    _ARP_PPDU_provider_reason = INT(name=u'provider-reason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Abort-reason')), opt=True)
    _ARP_PPDU_event_identifier = INT(name=u'event-identifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OSIProtocolSpecification', 'Event-identifier')), opt=True)
    ARP_PPDU._cont = ASN1Dict([
        (u'provider-reason', _ARP_PPDU_provider_reason),
        (u'event-identifier', _ARP_PPDU_event_identifier),
        ])
    ARP_PPDU._ext = None
    
    #-----< Abort-reason >-----#
    Abort_reason = INT(name=u'Abort-reason', mode=MODE_TYPE)
    Abort_reason._cont = ASN1Dict([(u'reason-not-specified', 0), (u'unrecognized-ppdu', 1), (u'unexpected-ppdu', 2), (u'unexpected-session-service-primitive', 3), (u'unrecognized-ppdu-parameter', 4), (u'unexpected-ppdu-parameter', 5), (u'invalid-ppdu-parameter-value', 6)])
    
    #-----< Event-identifier >-----#
    Event_identifier = INT(name=u'Event-identifier', mode=MODE_TYPE)
    Event_identifier._cont = ASN1Dict([(u'cp-PPDU', 0), (u'cpa-PPDU', 1), (u'cpr-PPDU', 2), (u'aru-PPDU', 3), (u'arp-PPDU', 4), (u'td-PPDU', 7), (u's-release-indication', 14), (u's-release-confirm', 15)])
    
    _all_ = [
        Presentation_selector,
        __Context_list__item__presentation_context_identifier,
        __Context_list__item__abstract_syntax_name,
        ___Context_list__item__transfer_syntax_name_list__item_,
        __Context_list__item__transfer_syntax_name_list,
        _Context_list__item_,
        Context_list,
        Presentation_context_identifier,
        Abstract_syntax_name,
        Transfer_syntax_name,
        Application_context_name,
        AP_invocation_identifier,
        AE_invocation_identifier,
        Implementation_data,
        Result,
        Associate_result,
        _Associate_source_diagnostic_acse_service_user,
        _Associate_source_diagnostic_acse_service_provider,
        Associate_source_diagnostic,
        __Result_list__item__result,
        __Result_list__item__transfer_syntax_name,
        __Result_list__item__provider_reason,
        _Result_list__item_,
        Result_list,
        Provider_reason,
        ___OsiUnbind_fully_encoded_data__item__presentation_context_identifier,
        _____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        ____OsiUnbind_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ___OsiUnbind_fully_encoded_data__item__presentation_data_values,
        __OsiUnbind_fully_encoded_data__item_,
        _OsiUnbind_fully_encoded_data,
        OsiUnbind,
        _TheOsiUnbind_reason,
        TheOsiUnbind,
        Release_request_reason,
        ___OsiUnbindResult_fully_encoded_data__item__presentation_context_identifier,
        _____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        ____OsiUnbindResult_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        ___OsiUnbindResult_fully_encoded_data__item__presentation_data_values,
        __OsiUnbindResult_fully_encoded_data__item_,
        _OsiUnbindResult_fully_encoded_data,
        OsiUnbindResult,
        _TheOsiUnbindRes_reason,
        TheOsiUnbindRes,
        Release_response_reason,
        _OsiRej_invokeId,
        __OsiRej_problem_general,
        __OsiRej_problem_invoke,
        __OsiRej_problem_returnResult,
        __OsiRej_problem_returnError,
        _OsiRej_problem,
        OsiRej,
        GeneralProblem,
        InvokeProblem,
        ReturnResultProblem,
        ReturnErrorProblem,
        _PresentationAbort_aru_ppdu,
        _PresentationAbort_arp_ppdu,
        PresentationAbort,
        __ARU_PPDU_normal_mode_parameters_presentation_context_identifier_list,
        _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_context_identifier,
        _______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type_val_0,
        ______ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values_single_ASN1_type,
        _____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item__presentation_data_values,
        ____ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data__item_,
        ___ARU_PPDU_normal_mode_parameters_user_data_fully_encoded_data,
        __ARU_PPDU_normal_mode_parameters_user_data,
        _ARU_PPDU_normal_mode_parameters,
        ARU_PPDU,
        __Presentation_context_identifier_list__item__presentation_context_identifier,
        __Presentation_context_identifier_list__item__transfer_syntax_name,
        _Presentation_context_identifier_list__item_,
        Presentation_context_identifier_list,
        _ABRT_apdu_abort_source,
        ABRT_apdu,
        ABRT_source,
        _ARP_PPDU_provider_reason,
        _ARP_PPDU_event_identifier,
        ARP_PPDU,
        Abort_reason,
        Event_identifier,
    ]

class PasswordPolicy:

    _name_  = u'PasswordPolicy'
    _oid_   = [2, 5, 1, 39, 8]
    
    _obj_ = [
        u'userPwd',
        u'UserPwd',
        u'pwdStartTime',
        u'pwdExpiryTime',
        u'pwdEndTime',
        u'pwdFails',
        u'pwdFailureTime',
        u'pwdGracesUsed',
        u'userPwdHistory',
        u'userPwdRecentlyExpired',
        u'pwdModifyEntryAllowed',
        u'pwdChangeAllowed',
        u'pwdMaxAge',
        u'pwdExpiryAge',
        u'pwdMinLength',
        u'pwdVocabulary',
        u'PwdVocabulary',
        u'pwdAlphabet',
        u'PwdAlphabet',
        u'pwdDictionaries',
        u'pwdExpiryWarning',
        u'pwdGraces',
        u'pwdFailureDuration',
        u'pwdLockoutDuration',
        u'pwdMaxFailures',
        u'pwdMaxTimeInHistory',
        u'pwdMinTimeInHistory',
        u'pwdHistorySlots',
        u'pwdRecentlyExpiredDuration',
        u'pwdEncAlg',
        u'PwdEncAlg',
        u'userPwdMatch',
        u'pwdEncAlgMatch',
        u'userPwdHistoryMatch',
        u'userPwdDescription',
        u'pwdVocabularyDescription',
        u'pwdAlphabetDescription',
        u'pwdEncAlgDescription',
        u'id-at-userPwd',
        u'id-oa-pwdStartTime',
        u'id-oa-pwdExpiryTime',
        u'id-oa-pwdEndTime',
        u'id-oa-pwdFails',
        u'id-oa-pwdFailureTime',
        u'id-oa-pwdGracesUsed',
        u'id-oa-userPwdHistory',
        u'id-oa-userPwdRecentlyExpired',
        u'id-oa-pwdModifyEntryAllowed',
        u'id-oa-pwdChangeAllowed',
        u'id-oa-pwdMaxAge',
        u'id-oa-pwdExpiryAge',
        u'id-oa-pwdMinLength',
        u'id-oa-pwdVocabulary',
        u'id-oa-pwdAlphabet',
        u'id-oa-pwdDictionaries',
        u'id-oa-pwdExpiryWarning',
        u'id-oa-pwdGraces',
        u'id-oa-pwdFailureDuration',
        u'id-oa-pwdLockoutDuration',
        u'id-oa-pwdMaxFailures',
        u'id-oa-pwdMaxTimeInHistory',
        u'id-oa-pwdMinTimeInHistory',
        u'id-oa-pwdHistorySlots',
        u'id-oa-pwdRecentlyExpiredDuration',
        u'id-oa-pwdEncAlg',
        u'id-mr-userPwdMatch',
        u'id-mr-userPwdHistoryMatch',
        u'id-mr-pwdEncAlgMatch',
        u'id-asx-userPwdDescription',
        u'id-asx-pwdVocabularyDescription',
        u'id-asx-pwdAlphabetDescription',
        u'id-asx-pwdEncAlgDescription',
        ]
    _type_ = [
        u'UserPwd',
        u'PwdVocabulary',
        u'PwdAlphabet',
        u'PwdEncAlg',
        ]
    _set_ = [
        ]
    _val_ = [
        u'userPwd',
        u'pwdStartTime',
        u'pwdExpiryTime',
        u'pwdEndTime',
        u'pwdFails',
        u'pwdFailureTime',
        u'pwdGracesUsed',
        u'userPwdHistory',
        u'userPwdRecentlyExpired',
        u'pwdModifyEntryAllowed',
        u'pwdChangeAllowed',
        u'pwdMaxAge',
        u'pwdExpiryAge',
        u'pwdMinLength',
        u'pwdVocabulary',
        u'pwdAlphabet',
        u'pwdDictionaries',
        u'pwdExpiryWarning',
        u'pwdGraces',
        u'pwdFailureDuration',
        u'pwdLockoutDuration',
        u'pwdMaxFailures',
        u'pwdMaxTimeInHistory',
        u'pwdMinTimeInHistory',
        u'pwdHistorySlots',
        u'pwdRecentlyExpiredDuration',
        u'pwdEncAlg',
        u'userPwdMatch',
        u'pwdEncAlgMatch',
        u'userPwdHistoryMatch',
        u'userPwdDescription',
        u'pwdVocabularyDescription',
        u'pwdAlphabetDescription',
        u'pwdEncAlgDescription',
        u'id-at-userPwd',
        u'id-oa-pwdStartTime',
        u'id-oa-pwdExpiryTime',
        u'id-oa-pwdEndTime',
        u'id-oa-pwdFails',
        u'id-oa-pwdFailureTime',
        u'id-oa-pwdGracesUsed',
        u'id-oa-userPwdHistory',
        u'id-oa-userPwdRecentlyExpired',
        u'id-oa-pwdModifyEntryAllowed',
        u'id-oa-pwdChangeAllowed',
        u'id-oa-pwdMaxAge',
        u'id-oa-pwdExpiryAge',
        u'id-oa-pwdMinLength',
        u'id-oa-pwdVocabulary',
        u'id-oa-pwdAlphabet',
        u'id-oa-pwdDictionaries',
        u'id-oa-pwdExpiryWarning',
        u'id-oa-pwdGraces',
        u'id-oa-pwdFailureDuration',
        u'id-oa-pwdLockoutDuration',
        u'id-oa-pwdMaxFailures',
        u'id-oa-pwdMaxTimeInHistory',
        u'id-oa-pwdMinTimeInHistory',
        u'id-oa-pwdHistorySlots',
        u'id-oa-pwdRecentlyExpiredDuration',
        u'id-oa-pwdEncAlg',
        u'id-mr-userPwdMatch',
        u'id-mr-userPwdHistoryMatch',
        u'id-mr-pwdEncAlgMatch',
        u'id-asx-userPwdDescription',
        u'id-asx-pwdVocabularyDescription',
        u'id-asx-pwdAlphabetDescription',
        u'id-asx-pwdEncAlgDescription',
        ]
    _class_ = [
        u'userPwd',
        u'pwdStartTime',
        u'pwdExpiryTime',
        u'pwdEndTime',
        u'pwdFails',
        u'pwdFailureTime',
        u'pwdGracesUsed',
        u'userPwdHistory',
        u'userPwdRecentlyExpired',
        u'pwdModifyEntryAllowed',
        u'pwdChangeAllowed',
        u'pwdMaxAge',
        u'pwdExpiryAge',
        u'pwdMinLength',
        u'pwdVocabulary',
        u'pwdAlphabet',
        u'pwdDictionaries',
        u'pwdExpiryWarning',
        u'pwdGraces',
        u'pwdFailureDuration',
        u'pwdLockoutDuration',
        u'pwdMaxFailures',
        u'pwdMaxTimeInHistory',
        u'pwdMinTimeInHistory',
        u'pwdHistorySlots',
        u'pwdRecentlyExpiredDuration',
        u'pwdEncAlg',
        u'userPwdMatch',
        u'pwdEncAlgMatch',
        u'userPwdHistoryMatch',
        u'userPwdDescription',
        u'pwdVocabularyDescription',
        u'pwdAlphabetDescription',
        u'pwdEncAlgDescription',
        ]
    _param_ = [
        ]
    
    #-----< userPwd >-----#
    userPwd = CLASS(name=u'userPwd', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _userPwd_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    __ATTRIBUTE_equality_match_val_AssertionType = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    userPwd._val = dict([(u'Type', _userPwd_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (2, 5, 40, 0)), (u'ldapName', [u'userPwdMatch']), (u'id', (2, 5, 13, 71))])), (u'single-valued', True), (u'ldapSyntax', (2, 5, 40, 0)), (u'ldapName', [u'userPwd']), (u'id', (2, 5, 4, 85))])
    
    #-----< UserPwd >-----#
    UserPwd = CHOICE(name=u'UserPwd', mode=MODE_TYPE)
    _UserPwd_clear = STR_UTF8(name=u'clear', mode=MODE_TYPE)
    _UserPwd_encrypted = SEQ(name=u'encrypted', mode=MODE_TYPE)
    __UserPwd_encrypted_algorithmIdentifier = SEQ(name=u'algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___UserPwd_encrypted_algorithmIdentifier_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____UserPwd_encrypted_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____UserPwd_encrypted_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPwd_encrypted_algorithmIdentifier_algorithm._const_tab = ____UserPwd_encrypted_algorithmIdentifier_algorithm_tab
    ___UserPwd_encrypted_algorithmIdentifier_algorithm._const_tab_at = None
    ___UserPwd_encrypted_algorithmIdentifier_algorithm._const_tab_id = u'id'
    ___UserPwd_encrypted_algorithmIdentifier_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____UserPwd_encrypted_algorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____UserPwd_encrypted_algorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPwd_encrypted_algorithmIdentifier_parameters._const_tab = ____UserPwd_encrypted_algorithmIdentifier_parameters_tab
    ___UserPwd_encrypted_algorithmIdentifier_parameters._const_tab_at = ('..', u'algorithm')
    ___UserPwd_encrypted_algorithmIdentifier_parameters._const_tab_id = u'Type'
    __UserPwd_encrypted_algorithmIdentifier._cont = ASN1Dict([
        (u'algorithm', ___UserPwd_encrypted_algorithmIdentifier_algorithm),
        (u'parameters', ___UserPwd_encrypted_algorithmIdentifier_parameters),
        ])
    __UserPwd_encrypted_algorithmIdentifier._ext = []
    __UserPwd_encrypted_encryptedString = OCT_STR(name=u'encryptedString', mode=MODE_TYPE)
    _UserPwd_encrypted._cont = ASN1Dict([
        (u'algorithmIdentifier', __UserPwd_encrypted_algorithmIdentifier),
        (u'encryptedString', __UserPwd_encrypted_encryptedString),
        ])
    _UserPwd_encrypted._ext = []
    UserPwd._cont = ASN1Dict([
        (u'clear', _UserPwd_clear),
        (u'encrypted', _UserPwd_encrypted),
        ])
    UserPwd._ext = []
    
    #-----< pwdStartTime >-----#
    pwdStartTime = CLASS(name=u'pwdStartTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdStartTime_val_Type = TIME_GEN(name=u'Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType_0 = TIME_GEN(name=u'AssertionType', mode=MODE_TYPE)
    __ATTRIBUTE_ordering_match_val_AssertionType = TIME_GEN(name=u'AssertionType', mode=MODE_TYPE)
    pwdStartTime._val = dict([(u'Type', _pwdStartTime_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeMatch']), (u'id', (2, 5, 13, 27))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeOrderingMatch']), (u'id', (2, 5, 13, 28))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'pwdStartTime']), (u'id', (2, 5, 18, 22))])
    
    #-----< pwdExpiryTime >-----#
    pwdExpiryTime = CLASS(name=u'pwdExpiryTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdExpiryTime_val_Type = TIME_GEN(name=u'Type', mode=MODE_TYPE)
    pwdExpiryTime._val = dict([(u'Type', _pwdExpiryTime_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeMatch']), (u'id', (2, 5, 13, 27))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeOrderingMatch']), (u'id', (2, 5, 13, 28))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'pwdExpiryTime']), (u'id', (2, 5, 18, 23))])
    
    #-----< pwdEndTime >-----#
    pwdEndTime = CLASS(name=u'pwdEndTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdEndTime_val_Type = TIME_GEN(name=u'Type', mode=MODE_TYPE)
    pwdEndTime._val = dict([(u'Type', _pwdEndTime_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeMatch']), (u'id', (2, 5, 13, 27))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeOrderingMatch']), (u'id', (2, 5, 13, 28))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'pwdEndTime']), (u'id', (2, 5, 18, 24))])
    
    #-----< pwdFails >-----#
    pwdFails = CLASS(name=u'pwdFails', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdFails_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    _pwdFails_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __ATTRIBUTE_equality_match_val_AssertionType_1 = INT(name=u'AssertionType', mode=MODE_TYPE)
    __ATTRIBUTE_ordering_match_val_AssertionType_0 = INT(name=u'AssertionType', mode=MODE_TYPE)
    pwdFails._val = dict([(u'Type', _pwdFails_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerOrderingMatch']), (u'id', (2, 5, 13, 15))])), (u'single-valued', True), (u'usage', u'dSAOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'pwdFails']), (u'id', (2, 5, 18, 25))])
    
    #-----< pwdFailureTime >-----#
    pwdFailureTime = CLASS(name=u'pwdFailureTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdFailureTime_val_Type = TIME_GEN(name=u'Type', mode=MODE_TYPE)
    pwdFailureTime._val = dict([(u'Type', _pwdFailureTime_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeMatch']), (u'id', (2, 5, 13, 27))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeOrderingMatch']), (u'id', (2, 5, 13, 28))])), (u'single-valued', True), (u'usage', u'dSAOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'pwdFailureTime']), (u'id', (2, 5, 18, 26))])
    
    #-----< pwdGracesUsed >-----#
    pwdGracesUsed = CLASS(name=u'pwdGracesUsed', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdGracesUsed_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    _pwdGracesUsed_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdGracesUsed._val = dict([(u'Type', _pwdGracesUsed_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerOrderingMatch']), (u'id', (2, 5, 13, 15))])), (u'single-valued', True), (u'usage', u'dSAOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'pwdGracesUsed']), (u'id', (2, 5, 18, 27))])
    
    #-----< userPwdHistory >-----#
    userPwdHistory = CLASS(name=u'userPwdHistory', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _userPwdHistory_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'PwdHistory')))
    __userPwdHistory_val_Type_time = TIME_GEN(name=u'time', mode=MODE_TYPE)
    __userPwdHistory_val_Type_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    _userPwdHistory_val_Type._cont = ASN1Dict([
        (u'time', __userPwdHistory_val_Type_time),
        (u'password', __userPwdHistory_val_Type_Type),
        ])
    _userPwdHistory_val_Type._ext = []
    __ATTRIBUTE_equality_match_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    userPwdHistory._val = dict([(u'Type', _userPwdHistory_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_Type), (u'id', (2, 5, 13, 72))])), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 28))])
    
    #-----< userPwdRecentlyExpired >-----#
    userPwdRecentlyExpired = CLASS(name=u'userPwdRecentlyExpired', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _userPwdRecentlyExpired_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    userPwdRecentlyExpired._val = dict([(u'Type', _userPwdRecentlyExpired_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (2, 5, 40, 0)), (u'ldapName', [u'userPwdMatch']), (u'id', (2, 5, 13, 71))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'id', (2, 5, 18, 29))])
    
    #-----< pwdModifyEntryAllowed >-----#
    pwdModifyEntryAllowed = CLASS(name=u'pwdModifyEntryAllowed', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdModifyEntryAllowed_val_Type = BOOL(name=u'Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType_2 = BOOL(name=u'AssertionType', mode=MODE_TYPE)
    pwdModifyEntryAllowed._val = dict([(u'Type', _pwdModifyEntryAllowed_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), (u'ldapName', [u'booleanMatch']), (u'id', (2, 5, 13, 13))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 7)), (u'ldapName', [u'pwdModifyEntryAllowed']), (u'id', (2, 5, 18, 30))])
    
    #-----< pwdChangeAllowed >-----#
    pwdChangeAllowed = CLASS(name=u'pwdChangeAllowed', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdChangeAllowed_val_Type = BOOL(name=u'Type', mode=MODE_TYPE)
    pwdChangeAllowed._val = dict([(u'Type', _pwdChangeAllowed_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), (u'ldapName', [u'booleanMatch']), (u'id', (2, 5, 13, 13))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 7)), (u'ldapName', [u'pwdChangeAllowed']), (u'id', (2, 5, 18, 31))])
    
    #-----< pwdMaxAge >-----#
    pwdMaxAge = CLASS(name=u'pwdMaxAge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdMaxAge_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    _pwdMaxAge_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    pwdMaxAge._val = dict([(u'Type', _pwdMaxAge_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerOrderingMatch']), (u'id', (2, 5, 13, 15))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'pwdMaxAge']), (u'id', (2, 5, 18, 32))])
    
    #-----< pwdExpiryAge >-----#
    pwdExpiryAge = CLASS(name=u'pwdExpiryAge', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdExpiryAge_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    _pwdExpiryAge_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    pwdExpiryAge._val = dict([(u'Type', _pwdExpiryAge_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerOrderingMatch']), (u'id', (2, 5, 13, 15))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'pwdExpiryAge']), (u'id', (2, 5, 18, 33))])
    
    #-----< pwdMinLength >-----#
    pwdMinLength = CLASS(name=u'pwdMinLength', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdMinLength_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    _pwdMinLength_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdMinLength._val = dict([(u'Type', _pwdMinLength_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'pwdMinLength']), (u'id', (2, 5, 18, 34))])
    
    #-----< pwdVocabulary >-----#
    pwdVocabulary = CLASS(name=u'pwdVocabulary', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdVocabulary_val_Type = BIT_STR(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdVocabulary')))
    __ATTRIBUTE_equality_match_val_AssertionType_3 = BIT_STR(name=u'AssertionType', mode=MODE_TYPE)
    pwdVocabulary._val = dict([(u'Type', _pwdVocabulary_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_3), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), (u'ldapName', [u'bitStringMatch']), (u'id', (2, 5, 13, 16))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (2, 5, 40, 1)), (u'ldapName', [u'pwdVocabulary']), (u'id', (2, 5, 18, 35))])
    
    #-----< PwdVocabulary >-----#
    PwdVocabulary = BIT_STR(name=u'PwdVocabulary', mode=MODE_TYPE)
    PwdVocabulary._cont = ASN1Dict([(u'noDictionaryWords', 0), (u'noPersonNames', 1), (u'noGeographicalNames', 2)])
    
    #-----< pwdAlphabet >-----#
    pwdAlphabet = CLASS(name=u'pwdAlphabet', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdAlphabet_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdAlphabet')))
    pwdAlphabet._val = dict([(u'Type', _pwdAlphabet_val_Type), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (2, 5, 40, 2)), (u'ldapName', [u'pwdAlphabet']), (u'id', (2, 5, 18, 36))])
    
    #-----< PwdAlphabet >-----#
    PwdAlphabet = SEQ_OF(name=u'PwdAlphabet', mode=MODE_TYPE)
    _PwdAlphabet__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    PwdAlphabet._cont = _PwdAlphabet__item_
    
    #-----< pwdDictionaries >-----#
    pwdDictionaries = CLASS(name=u'pwdDictionaries', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type = STR_UTF8(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'URI')))
    __ATTRIBUTE_equality_match_val_AssertionType_4 = STR_UTF8(name=u'AssertionType', mode=MODE_TYPE)
    pwdDictionaries._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uriMatch']), (u'id', (2, 5, 13, 70))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uri']), (u'id', (2, 5, 4, 83))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'pwdDictionaries']), (u'id', (2, 5, 18, 37))])
    
    #-----< pwdExpiryWarning >-----#
    pwdExpiryWarning = CLASS(name=u'pwdExpiryWarning', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdExpiryWarning_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    _pwdExpiryWarning_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    pwdExpiryWarning._val = dict([(u'Type', _pwdExpiryWarning_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerOrderingMatch']), (u'id', (2, 5, 13, 15))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'pwdExpiryWarning']), (u'id', (2, 5, 18, 38))])
    
    #-----< pwdGraces >-----#
    pwdGraces = CLASS(name=u'pwdGraces', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdGraces_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    _pwdGraces_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdGraces._val = dict([(u'Type', _pwdGraces_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerOrderingMatch']), (u'id', (2, 5, 13, 15))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'pwdGraces']), (u'id', (2, 5, 18, 39))])
    
    #-----< pwdFailureDuration >-----#
    pwdFailureDuration = CLASS(name=u'pwdFailureDuration', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdFailureDuration_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    _pwdFailureDuration_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdFailureDuration._val = dict([(u'Type', _pwdFailureDuration_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerOrderingMatch']), (u'id', (2, 5, 13, 15))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'pwdFailureDuration']), (u'id', (2, 5, 18, 40))])
    
    #-----< pwdLockoutDuration >-----#
    pwdLockoutDuration = CLASS(name=u'pwdLockoutDuration', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdLockoutDuration_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    _pwdLockoutDuration_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdLockoutDuration._val = dict([(u'Type', _pwdLockoutDuration_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerOrderingMatch']), (u'id', (2, 5, 13, 15))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'pwdLockoutDuration']), (u'id', (2, 5, 18, 41))])
    
    #-----< pwdMaxFailures >-----#
    pwdMaxFailures = CLASS(name=u'pwdMaxFailures', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdMaxFailures_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    _pwdMaxFailures_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    pwdMaxFailures._val = dict([(u'Type', _pwdMaxFailures_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerOrderingMatch']), (u'id', (2, 5, 13, 15))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'pwdMaxFailures']), (u'id', (2, 5, 18, 42))])
    
    #-----< pwdMaxTimeInHistory >-----#
    pwdMaxTimeInHistory = CLASS(name=u'pwdMaxTimeInHistory', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdMaxTimeInHistory_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    _pwdMaxTimeInHistory_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    pwdMaxTimeInHistory._val = dict([(u'Type', _pwdMaxTimeInHistory_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerOrderingMatch']), (u'id', (2, 5, 13, 15))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'pwdMaxTimeInHistory']), (u'id', (2, 5, 18, 43))])
    
    #-----< pwdMinTimeInHistory >-----#
    pwdMinTimeInHistory = CLASS(name=u'pwdMinTimeInHistory', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdMinTimeInHistory_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    _pwdMinTimeInHistory_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdMinTimeInHistory._val = dict([(u'Type', _pwdMinTimeInHistory_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerOrderingMatch']), (u'id', (2, 5, 13, 15))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'pwdMinTimeInHistory']), (u'id', (2, 5, 18, 44))])
    
    #-----< pwdHistorySlots >-----#
    pwdHistorySlots = CLASS(name=u'pwdHistorySlots', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdHistorySlots_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    _pwdHistorySlots_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=None)], ev=None, er=[])
    pwdHistorySlots._val = dict([(u'Type', _pwdHistorySlots_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerOrderingMatch']), (u'id', (2, 5, 13, 15))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'pwdHistorySlots']), (u'id', (2, 5, 18, 45))])
    
    #-----< pwdRecentlyExpiredDuration >-----#
    pwdRecentlyExpiredDuration = CLASS(name=u'pwdRecentlyExpiredDuration', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdRecentlyExpiredDuration_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    _pwdRecentlyExpiredDuration_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    pwdRecentlyExpiredDuration._val = dict([(u'Type', _pwdRecentlyExpiredDuration_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerOrderingMatch']), (u'id', (2, 5, 13, 15))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'pwdRecentlyExpiredDuration']), (u'id', (2, 5, 18, 46))])
    
    #-----< pwdEncAlg >-----#
    pwdEncAlg = CLASS(name=u'pwdEncAlg', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdEncAlg_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdEncAlg')))
    __ATTRIBUTE_equality_match_val_AssertionType_5 = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdEncAlg')))
    pwdEncAlg._val = dict([(u'Type', _pwdEncAlg_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_5), (u'ldapSyntax', (2, 5, 40, 3)), (u'ldapName', [u'pwdEncAlgMatch']), (u'id', (2, 5, 13, 73))])), (u'single-valued', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (2, 5, 40, 3)), (u'ldapName', [u'pwdEncAlg']), (u'id', (2, 5, 18, 47))])
    
    #-----< PwdEncAlg >-----#
    PwdEncAlg = SEQ(name=u'PwdEncAlg', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    _PwdEncAlg_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    __PwdEncAlg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    __PwdEncAlg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PwdEncAlg_algorithm._const_tab = __PwdEncAlg_algorithm_tab
    _PwdEncAlg_algorithm._const_tab_at = None
    _PwdEncAlg_algorithm._const_tab_id = u'id'
    _PwdEncAlg_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    __PwdEncAlg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    __PwdEncAlg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PwdEncAlg_parameters._const_tab = __PwdEncAlg_parameters_tab
    _PwdEncAlg_parameters._const_tab_at = ('..', u'algorithm')
    _PwdEncAlg_parameters._const_tab_id = u'Type'
    PwdEncAlg._cont = ASN1Dict([
        (u'algorithm', _PwdEncAlg_algorithm),
        (u'parameters', _PwdEncAlg_parameters),
        ])
    PwdEncAlg._ext = []
    
    #-----< userPwdMatch >-----#
    userPwdMatch = CLASS(name=u'userPwdMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _userPwdMatch_val_AssertionType = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    userPwdMatch._val = dict([(u'AssertionType', _userPwdMatch_val_AssertionType), (u'ldapSyntax', (2, 5, 40, 0)), (u'ldapName', [u'userPwdMatch']), (u'id', (2, 5, 13, 71))])
    
    #-----< pwdEncAlgMatch >-----#
    pwdEncAlgMatch = CLASS(name=u'pwdEncAlgMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _pwdEncAlgMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdEncAlg')))
    pwdEncAlgMatch._val = dict([(u'AssertionType', _pwdEncAlgMatch_val_AssertionType), (u'ldapSyntax', (2, 5, 40, 3)), (u'ldapName', [u'pwdEncAlgMatch']), (u'id', (2, 5, 13, 73))])
    
    #-----< userPwdHistoryMatch >-----#
    userPwdHistoryMatch = CLASS(name=u'userPwdHistoryMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _userPwdHistoryMatch_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    userPwdHistoryMatch._val = dict([(u'AssertionType', _userPwdHistoryMatch_val_Type), (u'id', (2, 5, 13, 72))])
    
    #-----< userPwdDescription >-----#
    userPwdDescription = CLASS(name=u'userPwdDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _userPwdDescription_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'UserPwd')))
    userPwdDescription._val = dict([(u'ldapDesc', u'User Password Description'), (u'Type', _userPwdDescription_val_Type), (u'id', (2, 5, 40, 0))])
    
    #-----< pwdVocabularyDescription >-----#
    pwdVocabularyDescription = CLASS(name=u'pwdVocabularyDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _pwdVocabularyDescription_val_Type = BIT_STR(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdVocabulary')))
    pwdVocabularyDescription._val = dict([(u'ldapDesc', u'Password Vocabulary Description'), (u'Type', _pwdVocabularyDescription_val_Type), (u'id', (2, 5, 40, 1))])
    
    #-----< pwdAlphabetDescription >-----#
    pwdAlphabetDescription = CLASS(name=u'pwdAlphabetDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _pwdAlphabetDescription_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdAlphabet')))
    pwdAlphabetDescription._val = dict([(u'ldapDesc', u'Password Alphabet Description'), (u'Type', _pwdAlphabetDescription_val_Type), (u'id', (2, 5, 40, 2))])
    
    #-----< pwdEncAlgDescription >-----#
    pwdEncAlgDescription = CLASS(name=u'pwdEncAlgDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _pwdEncAlgDescription_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PasswordPolicy', 'PwdEncAlg')))
    pwdEncAlgDescription._val = dict([(u'ldapDesc', u'Password Alphabet Description'), (u'Type', _pwdEncAlgDescription_val_Type), (u'id', (2, 5, 40, 3))])
    
    #-----< id-at-userPwd >-----#
    id_at_userPwd = OID(name=u'id-at-userPwd', mode=MODE_VALUE)
    id_at_userPwd._val = (2, 5, 4, 85)
    
    #-----< id-oa-pwdStartTime >-----#
    id_oa_pwdStartTime = OID(name=u'id-oa-pwdStartTime', mode=MODE_VALUE)
    id_oa_pwdStartTime._val = (2, 5, 18, 22)
    
    #-----< id-oa-pwdExpiryTime >-----#
    id_oa_pwdExpiryTime = OID(name=u'id-oa-pwdExpiryTime', mode=MODE_VALUE)
    id_oa_pwdExpiryTime._val = (2, 5, 18, 23)
    
    #-----< id-oa-pwdEndTime >-----#
    id_oa_pwdEndTime = OID(name=u'id-oa-pwdEndTime', mode=MODE_VALUE)
    id_oa_pwdEndTime._val = (2, 5, 18, 24)
    
    #-----< id-oa-pwdFails >-----#
    id_oa_pwdFails = OID(name=u'id-oa-pwdFails', mode=MODE_VALUE)
    id_oa_pwdFails._val = (2, 5, 18, 25)
    
    #-----< id-oa-pwdFailureTime >-----#
    id_oa_pwdFailureTime = OID(name=u'id-oa-pwdFailureTime', mode=MODE_VALUE)
    id_oa_pwdFailureTime._val = (2, 5, 18, 26)
    
    #-----< id-oa-pwdGracesUsed >-----#
    id_oa_pwdGracesUsed = OID(name=u'id-oa-pwdGracesUsed', mode=MODE_VALUE)
    id_oa_pwdGracesUsed._val = (2, 5, 18, 27)
    
    #-----< id-oa-userPwdHistory >-----#
    id_oa_userPwdHistory = OID(name=u'id-oa-userPwdHistory', mode=MODE_VALUE)
    id_oa_userPwdHistory._val = (2, 5, 18, 28)
    
    #-----< id-oa-userPwdRecentlyExpired >-----#
    id_oa_userPwdRecentlyExpired = OID(name=u'id-oa-userPwdRecentlyExpired', mode=MODE_VALUE)
    id_oa_userPwdRecentlyExpired._val = (2, 5, 18, 29)
    
    #-----< id-oa-pwdModifyEntryAllowed >-----#
    id_oa_pwdModifyEntryAllowed = OID(name=u'id-oa-pwdModifyEntryAllowed', mode=MODE_VALUE)
    id_oa_pwdModifyEntryAllowed._val = (2, 5, 18, 30)
    
    #-----< id-oa-pwdChangeAllowed >-----#
    id_oa_pwdChangeAllowed = OID(name=u'id-oa-pwdChangeAllowed', mode=MODE_VALUE)
    id_oa_pwdChangeAllowed._val = (2, 5, 18, 31)
    
    #-----< id-oa-pwdMaxAge >-----#
    id_oa_pwdMaxAge = OID(name=u'id-oa-pwdMaxAge', mode=MODE_VALUE)
    id_oa_pwdMaxAge._val = (2, 5, 18, 32)
    
    #-----< id-oa-pwdExpiryAge >-----#
    id_oa_pwdExpiryAge = OID(name=u'id-oa-pwdExpiryAge', mode=MODE_VALUE)
    id_oa_pwdExpiryAge._val = (2, 5, 18, 33)
    
    #-----< id-oa-pwdMinLength >-----#
    id_oa_pwdMinLength = OID(name=u'id-oa-pwdMinLength', mode=MODE_VALUE)
    id_oa_pwdMinLength._val = (2, 5, 18, 34)
    
    #-----< id-oa-pwdVocabulary >-----#
    id_oa_pwdVocabulary = OID(name=u'id-oa-pwdVocabulary', mode=MODE_VALUE)
    id_oa_pwdVocabulary._val = (2, 5, 18, 35)
    
    #-----< id-oa-pwdAlphabet >-----#
    id_oa_pwdAlphabet = OID(name=u'id-oa-pwdAlphabet', mode=MODE_VALUE)
    id_oa_pwdAlphabet._val = (2, 5, 18, 36)
    
    #-----< id-oa-pwdDictionaries >-----#
    id_oa_pwdDictionaries = OID(name=u'id-oa-pwdDictionaries', mode=MODE_VALUE)
    id_oa_pwdDictionaries._val = (2, 5, 18, 37)
    
    #-----< id-oa-pwdExpiryWarning >-----#
    id_oa_pwdExpiryWarning = OID(name=u'id-oa-pwdExpiryWarning', mode=MODE_VALUE)
    id_oa_pwdExpiryWarning._val = (2, 5, 18, 38)
    
    #-----< id-oa-pwdGraces >-----#
    id_oa_pwdGraces = OID(name=u'id-oa-pwdGraces', mode=MODE_VALUE)
    id_oa_pwdGraces._val = (2, 5, 18, 39)
    
    #-----< id-oa-pwdFailureDuration >-----#
    id_oa_pwdFailureDuration = OID(name=u'id-oa-pwdFailureDuration', mode=MODE_VALUE)
    id_oa_pwdFailureDuration._val = (2, 5, 18, 40)
    
    #-----< id-oa-pwdLockoutDuration >-----#
    id_oa_pwdLockoutDuration = OID(name=u'id-oa-pwdLockoutDuration', mode=MODE_VALUE)
    id_oa_pwdLockoutDuration._val = (2, 5, 18, 41)
    
    #-----< id-oa-pwdMaxFailures >-----#
    id_oa_pwdMaxFailures = OID(name=u'id-oa-pwdMaxFailures', mode=MODE_VALUE)
    id_oa_pwdMaxFailures._val = (2, 5, 18, 42)
    
    #-----< id-oa-pwdMaxTimeInHistory >-----#
    id_oa_pwdMaxTimeInHistory = OID(name=u'id-oa-pwdMaxTimeInHistory', mode=MODE_VALUE)
    id_oa_pwdMaxTimeInHistory._val = (2, 5, 18, 43)
    
    #-----< id-oa-pwdMinTimeInHistory >-----#
    id_oa_pwdMinTimeInHistory = OID(name=u'id-oa-pwdMinTimeInHistory', mode=MODE_VALUE)
    id_oa_pwdMinTimeInHistory._val = (2, 5, 18, 44)
    
    #-----< id-oa-pwdHistorySlots >-----#
    id_oa_pwdHistorySlots = OID(name=u'id-oa-pwdHistorySlots', mode=MODE_VALUE)
    id_oa_pwdHistorySlots._val = (2, 5, 18, 45)
    
    #-----< id-oa-pwdRecentlyExpiredDuration >-----#
    id_oa_pwdRecentlyExpiredDuration = OID(name=u'id-oa-pwdRecentlyExpiredDuration', mode=MODE_VALUE)
    id_oa_pwdRecentlyExpiredDuration._val = (2, 5, 18, 46)
    
    #-----< id-oa-pwdEncAlg >-----#
    id_oa_pwdEncAlg = OID(name=u'id-oa-pwdEncAlg', mode=MODE_VALUE)
    id_oa_pwdEncAlg._val = (2, 5, 18, 47)
    
    #-----< id-mr-userPwdMatch >-----#
    id_mr_userPwdMatch = OID(name=u'id-mr-userPwdMatch', mode=MODE_VALUE)
    id_mr_userPwdMatch._val = (2, 5, 13, 71)
    
    #-----< id-mr-userPwdHistoryMatch >-----#
    id_mr_userPwdHistoryMatch = OID(name=u'id-mr-userPwdHistoryMatch', mode=MODE_VALUE)
    id_mr_userPwdHistoryMatch._val = (2, 5, 13, 72)
    
    #-----< id-mr-pwdEncAlgMatch >-----#
    id_mr_pwdEncAlgMatch = OID(name=u'id-mr-pwdEncAlgMatch', mode=MODE_VALUE)
    id_mr_pwdEncAlgMatch._val = (2, 5, 13, 73)
    
    #-----< id-asx-userPwdDescription >-----#
    id_asx_userPwdDescription = OID(name=u'id-asx-userPwdDescription', mode=MODE_VALUE)
    id_asx_userPwdDescription._val = (2, 5, 40, 0)
    
    #-----< id-asx-pwdVocabularyDescription >-----#
    id_asx_pwdVocabularyDescription = OID(name=u'id-asx-pwdVocabularyDescription', mode=MODE_VALUE)
    id_asx_pwdVocabularyDescription._val = (2, 5, 40, 1)
    
    #-----< id-asx-pwdAlphabetDescription >-----#
    id_asx_pwdAlphabetDescription = OID(name=u'id-asx-pwdAlphabetDescription', mode=MODE_VALUE)
    id_asx_pwdAlphabetDescription._val = (2, 5, 40, 2)
    
    #-----< id-asx-pwdEncAlgDescription >-----#
    id_asx_pwdEncAlgDescription = OID(name=u'id-asx-pwdEncAlgDescription', mode=MODE_VALUE)
    id_asx_pwdEncAlgDescription._val = (2, 5, 40, 3)
    
    _all_ = [
        userPwd,
        _userPwd_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType,
        _UserPwd_clear,
        ____UserPwd_encrypted_algorithmIdentifier_algorithm_tab,
        ___UserPwd_encrypted_algorithmIdentifier_algorithm,
        ____UserPwd_encrypted_algorithmIdentifier_parameters_tab,
        ___UserPwd_encrypted_algorithmIdentifier_parameters,
        __UserPwd_encrypted_algorithmIdentifier,
        __UserPwd_encrypted_encryptedString,
        _UserPwd_encrypted,
        UserPwd,
        pwdStartTime,
        _pwdStartTime_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        __ATTRIBUTE_ordering_match_val_AssertionType,
        pwdExpiryTime,
        _pwdExpiryTime_val_Type,
        pwdEndTime,
        _pwdEndTime_val_Type,
        pwdFails,
        _pwdFails_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_1,
        __ATTRIBUTE_ordering_match_val_AssertionType_0,
        pwdFailureTime,
        _pwdFailureTime_val_Type,
        pwdGracesUsed,
        _pwdGracesUsed_val_Type,
        userPwdHistory,
        __userPwdHistory_val_Type_time,
        __userPwdHistory_val_Type_Type,
        _userPwdHistory_val_Type,
        __ATTRIBUTE_equality_match_val_Type,
        userPwdRecentlyExpired,
        _userPwdRecentlyExpired_val_Type,
        pwdModifyEntryAllowed,
        _pwdModifyEntryAllowed_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_2,
        pwdChangeAllowed,
        _pwdChangeAllowed_val_Type,
        pwdMaxAge,
        _pwdMaxAge_val_Type,
        pwdExpiryAge,
        _pwdExpiryAge_val_Type,
        pwdMinLength,
        _pwdMinLength_val_Type,
        pwdVocabulary,
        _pwdVocabulary_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_3,
        PwdVocabulary,
        pwdAlphabet,
        _pwdAlphabet_val_Type,
        _PwdAlphabet__item_,
        PwdAlphabet,
        pwdDictionaries,
        __ATTRIBUTE_derivation_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_4,
        pwdExpiryWarning,
        _pwdExpiryWarning_val_Type,
        pwdGraces,
        _pwdGraces_val_Type,
        pwdFailureDuration,
        _pwdFailureDuration_val_Type,
        pwdLockoutDuration,
        _pwdLockoutDuration_val_Type,
        pwdMaxFailures,
        _pwdMaxFailures_val_Type,
        pwdMaxTimeInHistory,
        _pwdMaxTimeInHistory_val_Type,
        pwdMinTimeInHistory,
        _pwdMinTimeInHistory_val_Type,
        pwdHistorySlots,
        _pwdHistorySlots_val_Type,
        pwdRecentlyExpiredDuration,
        _pwdRecentlyExpiredDuration_val_Type,
        pwdEncAlg,
        _pwdEncAlg_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_5,
        __PwdEncAlg_algorithm_tab,
        _PwdEncAlg_algorithm,
        __PwdEncAlg_parameters_tab,
        _PwdEncAlg_parameters,
        PwdEncAlg,
        userPwdMatch,
        _userPwdMatch_val_AssertionType,
        pwdEncAlgMatch,
        _pwdEncAlgMatch_val_AssertionType,
        userPwdHistoryMatch,
        _userPwdHistoryMatch_val_Type,
        userPwdDescription,
        _userPwdDescription_val_Type,
        pwdVocabularyDescription,
        _pwdVocabularyDescription_val_Type,
        pwdAlphabetDescription,
        _pwdAlphabetDescription_val_Type,
        pwdEncAlgDescription,
        _pwdEncAlgDescription_val_Type,
        id_at_userPwd,
        id_oa_pwdStartTime,
        id_oa_pwdExpiryTime,
        id_oa_pwdEndTime,
        id_oa_pwdFails,
        id_oa_pwdFailureTime,
        id_oa_pwdGracesUsed,
        id_oa_userPwdHistory,
        id_oa_userPwdRecentlyExpired,
        id_oa_pwdModifyEntryAllowed,
        id_oa_pwdChangeAllowed,
        id_oa_pwdMaxAge,
        id_oa_pwdExpiryAge,
        id_oa_pwdMinLength,
        id_oa_pwdVocabulary,
        id_oa_pwdAlphabet,
        id_oa_pwdDictionaries,
        id_oa_pwdExpiryWarning,
        id_oa_pwdGraces,
        id_oa_pwdFailureDuration,
        id_oa_pwdLockoutDuration,
        id_oa_pwdMaxFailures,
        id_oa_pwdMaxTimeInHistory,
        id_oa_pwdMinTimeInHistory,
        id_oa_pwdHistorySlots,
        id_oa_pwdRecentlyExpiredDuration,
        id_oa_pwdEncAlg,
        id_mr_userPwdMatch,
        id_mr_userPwdHistoryMatch,
        id_mr_pwdEncAlgMatch,
        id_asx_userPwdDescription,
        id_asx_pwdVocabularyDescription,
        id_asx_pwdAlphabetDescription,
        id_asx_pwdEncAlgDescription,
    ]

class PkiPmiExternalDataTypes:

    _name_  = u'PkiPmiExternalDataTypes'
    _oid_   = [2, 5, 1, 40, 8]
    
    _obj_ = [
        u'UserNotice',
        u'NoticeReference',
        u'DisplayText',
        u'authorityInfoAccess',
        u'AuthorityInfoAccessSyntax',
        u'AccessDescription',
        u'subjectInfoAccess',
        u'SubjectInfoAccessSyntax',
        u'id-pkix',
        u'id-pe',
        u'id-ad',
        u'id-pe-authorityInfoAccess',
        u'id-pe-subjectInfoAccess',
        u'id-ad-caIssuers',
        u'id-ad-ocsp',
        u'G3FacsimileNonBasicParameters',
        u'ORAddress',
        u'BuiltInStandardAttributes',
        u'CountryName',
        u'AdministrationDomainName',
        u'NetworkAddress',
        u'X121Address',
        u'TerminalIdentifier',
        u'PrivateDomainName',
        u'OrganizationName',
        u'NumericUserIdentifier',
        u'PersonalName',
        u'OrganizationalUnitNames',
        u'OrganizationalUnitName',
        u'BuiltInDomainDefinedAttributes',
        u'BuiltInDomainDefinedAttribute',
        u'ExtensionAttributes',
        u'ExtensionAttribute',
        u'EXTENSION-ATTRIBUTE',
        u'ExtensionAttributeTable',
        u'common-name',
        u'CommonName',
        u'teletex-common-name',
        u'TeletexCommonName',
        u'universal-common-name',
        u'UniversalCommonName',
        u'teletex-organization-name',
        u'TeletexOrganizationName',
        u'universal-organization-name',
        u'UniversalOrganizationName',
        u'teletex-personal-name',
        u'TeletexPersonalName',
        u'universal-personal-name',
        u'UniversalPersonalName',
        u'teletex-organizational-unit-names',
        u'TeletexOrganizationalUnitNames',
        u'TeletexOrganizationalUnitName',
        u'universal-organizational-unit-names',
        u'UniversalOrganizationalUnitNames',
        u'UniversalOrganizationalUnitName',
        u'UniversalOrBMPString',
        u'pds-name',
        u'PDSName',
        u'physical-delivery-country-name',
        u'PhysicalDeliveryCountryName',
        u'postal-code',
        u'PostalCode',
        u'physical-delivery-office-name',
        u'PhysicalDeliveryOfficeName',
        u'universal-physical-delivery-office-name',
        u'UniversalPhysicalDeliveryOfficeName',
        u'physical-delivery-office-number',
        u'PhysicalDeliveryOfficeNumber',
        u'universal-physical-delivery-office-number',
        u'UniversalPhysicalDeliveryOfficeNumber',
        u'extension-OR-address-components',
        u'ExtensionORAddressComponents',
        u'universal-extension-OR-address-components',
        u'UniversalExtensionORAddressComponents',
        u'physical-delivery-personal-name',
        u'PhysicalDeliveryPersonalName',
        u'universal-physical-delivery-personal-name',
        u'UniversalPhysicalDeliveryPersonalName',
        u'physical-delivery-organization-name',
        u'PhysicalDeliveryOrganizationName',
        u'universal-physical-delivery-organization-name',
        u'UniversalPhysicalDeliveryOrganizationName',
        u'extension-physical-delivery-address-components',
        u'ExtensionPhysicalDeliveryAddressComponents',
        u'universal-extension-physical-delivery-address-components',
        u'UniversalExtensionPhysicalDeliveryAddressComponents',
        u'unformatted-postal-address',
        u'UnformattedPostalAddress',
        u'universal-unformatted-postal-address',
        u'UniversalUnformattedPostalAddress',
        u'street-address',
        u'StreetAddress',
        u'universal-street-address',
        u'UniversalStreetAddress',
        u'post-office-box-address',
        u'PostOfficeBoxAddress',
        u'universal-post-office-box-address',
        u'UniversalPostOfficeBoxAddress',
        u'poste-restante-address',
        u'PosteRestanteAddress',
        u'universal-poste-restante-address',
        u'UniversalPosteRestanteAddress',
        u'unique-postal-name',
        u'UniquePostalName',
        u'universal-unique-postal-name',
        u'UniversalUniquePostalName',
        u'local-postal-attributes',
        u'LocalPostalAttributes',
        u'universal-local-postal-attributes',
        u'UniversalLocalPostalAttributes',
        u'PDSParameter',
        u'UniversalPDSParameter',
        u'extended-network-address',
        u'ExtendedNetworkAddress',
        u'terminal-type',
        u'TerminalType',
        u'teletex-domain-defined-attributes',
        u'TeletexDomainDefinedAttributes',
        u'TeletexDomainDefinedAttribute',
        u'universal-domain-defined-attributes',
        u'UniversalDomainDefinedAttributes',
        u'UniversalDomainDefinedAttribute',
        u'ub-integer-options',
        u'ub-e163-4-number-length',
        u'ub-e163-4-sub-address-length',
        u'ub-unformatted-address-length',
        u'ub-pds-parameter-length',
        u'ub-pds-physical-address-lines',
        u'ub-postal-code-length',
        u'ub-pds-name-length',
        u'ub-universal-surname-length',
        u'ub-universal-given-name-length',
        u'ub-universal-initials-length',
        u'ub-universal-generation-qualifier-length',
        u'ub-common-name-length',
        u'ub-extension-attributes',
        u'ub-domain-defined-attribute-type-length',
        u'ub-domain-defined-attribute-value-length',
        u'ub-domain-defined-attributes',
        u'ub-organizational-unit-name-length',
        u'ub-organizational-units',
        u'ub-generation-qualifier-length',
        u'ub-initials-length',
        u'ub-given-name-length',
        u'ub-surname-length',
        u'ub-numeric-user-id-length',
        u'ub-organization-name-length',
        u'ub-terminal-id-length',
        u'ub-x121-address-length',
        u'ub-domain-name-length',
        u'ub-country-name-alpha-length',
        u'ub-country-name-numeric-length',
        ]
    _type_ = [
        u'UserNotice',
        u'NoticeReference',
        u'DisplayText',
        u'AuthorityInfoAccessSyntax',
        u'AccessDescription',
        u'SubjectInfoAccessSyntax',
        u'G3FacsimileNonBasicParameters',
        u'ORAddress',
        u'BuiltInStandardAttributes',
        u'CountryName',
        u'AdministrationDomainName',
        u'NetworkAddress',
        u'X121Address',
        u'TerminalIdentifier',
        u'PrivateDomainName',
        u'OrganizationName',
        u'NumericUserIdentifier',
        u'PersonalName',
        u'OrganizationalUnitNames',
        u'OrganizationalUnitName',
        u'BuiltInDomainDefinedAttributes',
        u'BuiltInDomainDefinedAttribute',
        u'ExtensionAttributes',
        u'ExtensionAttribute',
        u'EXTENSION-ATTRIBUTE',
        u'CommonName',
        u'TeletexCommonName',
        u'UniversalCommonName',
        u'TeletexOrganizationName',
        u'UniversalOrganizationName',
        u'TeletexPersonalName',
        u'UniversalPersonalName',
        u'TeletexOrganizationalUnitNames',
        u'TeletexOrganizationalUnitName',
        u'UniversalOrganizationalUnitNames',
        u'UniversalOrganizationalUnitName',
        u'UniversalOrBMPString',
        u'PDSName',
        u'PhysicalDeliveryCountryName',
        u'PostalCode',
        u'PhysicalDeliveryOfficeName',
        u'UniversalPhysicalDeliveryOfficeName',
        u'PhysicalDeliveryOfficeNumber',
        u'UniversalPhysicalDeliveryOfficeNumber',
        u'ExtensionORAddressComponents',
        u'UniversalExtensionORAddressComponents',
        u'PhysicalDeliveryPersonalName',
        u'UniversalPhysicalDeliveryPersonalName',
        u'PhysicalDeliveryOrganizationName',
        u'UniversalPhysicalDeliveryOrganizationName',
        u'ExtensionPhysicalDeliveryAddressComponents',
        u'UniversalExtensionPhysicalDeliveryAddressComponents',
        u'UnformattedPostalAddress',
        u'UniversalUnformattedPostalAddress',
        u'StreetAddress',
        u'UniversalStreetAddress',
        u'PostOfficeBoxAddress',
        u'UniversalPostOfficeBoxAddress',
        u'PosteRestanteAddress',
        u'UniversalPosteRestanteAddress',
        u'UniquePostalName',
        u'UniversalUniquePostalName',
        u'LocalPostalAttributes',
        u'UniversalLocalPostalAttributes',
        u'PDSParameter',
        u'UniversalPDSParameter',
        u'ExtendedNetworkAddress',
        u'TerminalType',
        u'TeletexDomainDefinedAttributes',
        u'TeletexDomainDefinedAttribute',
        u'UniversalDomainDefinedAttributes',
        u'UniversalDomainDefinedAttribute',
        ]
    _set_ = [
        u'ExtensionAttributeTable',
        ]
    _val_ = [
        u'authorityInfoAccess',
        u'subjectInfoAccess',
        u'id-pkix',
        u'id-pe',
        u'id-ad',
        u'id-pe-authorityInfoAccess',
        u'id-pe-subjectInfoAccess',
        u'id-ad-caIssuers',
        u'id-ad-ocsp',
        u'common-name',
        u'teletex-common-name',
        u'universal-common-name',
        u'teletex-organization-name',
        u'universal-organization-name',
        u'teletex-personal-name',
        u'universal-personal-name',
        u'teletex-organizational-unit-names',
        u'universal-organizational-unit-names',
        u'pds-name',
        u'physical-delivery-country-name',
        u'postal-code',
        u'physical-delivery-office-name',
        u'universal-physical-delivery-office-name',
        u'physical-delivery-office-number',
        u'universal-physical-delivery-office-number',
        u'extension-OR-address-components',
        u'universal-extension-OR-address-components',
        u'physical-delivery-personal-name',
        u'universal-physical-delivery-personal-name',
        u'physical-delivery-organization-name',
        u'universal-physical-delivery-organization-name',
        u'extension-physical-delivery-address-components',
        u'universal-extension-physical-delivery-address-components',
        u'unformatted-postal-address',
        u'universal-unformatted-postal-address',
        u'street-address',
        u'universal-street-address',
        u'post-office-box-address',
        u'universal-post-office-box-address',
        u'poste-restante-address',
        u'universal-poste-restante-address',
        u'unique-postal-name',
        u'universal-unique-postal-name',
        u'local-postal-attributes',
        u'universal-local-postal-attributes',
        u'extended-network-address',
        u'terminal-type',
        u'teletex-domain-defined-attributes',
        u'universal-domain-defined-attributes',
        u'ub-integer-options',
        u'ub-e163-4-number-length',
        u'ub-e163-4-sub-address-length',
        u'ub-unformatted-address-length',
        u'ub-pds-parameter-length',
        u'ub-pds-physical-address-lines',
        u'ub-postal-code-length',
        u'ub-pds-name-length',
        u'ub-universal-surname-length',
        u'ub-universal-given-name-length',
        u'ub-universal-initials-length',
        u'ub-universal-generation-qualifier-length',
        u'ub-common-name-length',
        u'ub-extension-attributes',
        u'ub-domain-defined-attribute-type-length',
        u'ub-domain-defined-attribute-value-length',
        u'ub-domain-defined-attributes',
        u'ub-organizational-unit-name-length',
        u'ub-organizational-units',
        u'ub-generation-qualifier-length',
        u'ub-initials-length',
        u'ub-given-name-length',
        u'ub-surname-length',
        u'ub-numeric-user-id-length',
        u'ub-organization-name-length',
        u'ub-terminal-id-length',
        u'ub-x121-address-length',
        u'ub-domain-name-length',
        u'ub-country-name-alpha-length',
        u'ub-country-name-numeric-length',
        ]
    _class_ = [
        u'authorityInfoAccess',
        u'subjectInfoAccess',
        u'EXTENSION-ATTRIBUTE',
        u'ExtensionAttributeTable',
        u'common-name',
        u'teletex-common-name',
        u'universal-common-name',
        u'teletex-organization-name',
        u'universal-organization-name',
        u'teletex-personal-name',
        u'universal-personal-name',
        u'teletex-organizational-unit-names',
        u'universal-organizational-unit-names',
        u'pds-name',
        u'physical-delivery-country-name',
        u'postal-code',
        u'physical-delivery-office-name',
        u'universal-physical-delivery-office-name',
        u'physical-delivery-office-number',
        u'universal-physical-delivery-office-number',
        u'extension-OR-address-components',
        u'universal-extension-OR-address-components',
        u'physical-delivery-personal-name',
        u'universal-physical-delivery-personal-name',
        u'physical-delivery-organization-name',
        u'universal-physical-delivery-organization-name',
        u'extension-physical-delivery-address-components',
        u'universal-extension-physical-delivery-address-components',
        u'unformatted-postal-address',
        u'universal-unformatted-postal-address',
        u'street-address',
        u'universal-street-address',
        u'post-office-box-address',
        u'universal-post-office-box-address',
        u'poste-restante-address',
        u'universal-poste-restante-address',
        u'unique-postal-name',
        u'universal-unique-postal-name',
        u'local-postal-attributes',
        u'universal-local-postal-attributes',
        u'extended-network-address',
        u'terminal-type',
        u'teletex-domain-defined-attributes',
        u'universal-domain-defined-attributes',
        ]
    _param_ = [
        u'UniversalOrBMPString',
        ]
    
    #-----< UserNotice >-----#
    UserNotice = SEQ(name=u'UserNotice', mode=MODE_TYPE)
    _UserNotice_noticeRef = SEQ(name=u'noticeRef', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'NoticeReference')), opt=True)
    _UserNotice_explicitText = CHOICE(name=u'explicitText', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'DisplayText')), opt=True)
    UserNotice._cont = ASN1Dict([
        (u'noticeRef', _UserNotice_noticeRef),
        (u'explicitText', _UserNotice_explicitText),
        ])
    UserNotice._ext = None
    
    #-----< NoticeReference >-----#
    NoticeReference = SEQ(name=u'NoticeReference', mode=MODE_TYPE)
    _NoticeReference_organization = CHOICE(name=u'organization', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'DisplayText')))
    _NoticeReference_noticeNumbers = SEQ_OF(name=u'noticeNumbers', mode=MODE_TYPE)
    __NoticeReference_noticeNumbers__item_ = INT(name='_item_', mode=MODE_TYPE)
    _NoticeReference_noticeNumbers._cont = __NoticeReference_noticeNumbers__item_
    NoticeReference._cont = ASN1Dict([
        (u'organization', _NoticeReference_organization),
        (u'noticeNumbers', _NoticeReference_noticeNumbers),
        ])
    NoticeReference._ext = None
    
    #-----< DisplayText >-----#
    DisplayText = CHOICE(name=u'DisplayText', mode=MODE_TYPE)
    _DisplayText_visibleString = STR_VIS(name=u'visibleString', mode=MODE_TYPE)
    _DisplayText_visibleString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    _DisplayText_bmpString = STR_BMP(name=u'bmpString', mode=MODE_TYPE)
    _DisplayText_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    _DisplayText_utf8String = STR_UTF8(name=u'utf8String', mode=MODE_TYPE)
    _DisplayText_utf8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    DisplayText._cont = ASN1Dict([
        (u'visibleString', _DisplayText_visibleString),
        (u'bmpString', _DisplayText_bmpString),
        (u'utf8String', _DisplayText_utf8String),
        ])
    DisplayText._ext = None
    
    #-----< authorityInfoAccess >-----#
    authorityInfoAccess = CLASS(name=u'authorityInfoAccess', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _authorityInfoAccess_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'AuthorityInfoAccessSyntax')))
    authorityInfoAccess._val = dict([(u'ExtnType', _authorityInfoAccess_val_ExtnType), (u'id', (1, 3, 6, 1, 5, 5, 7, 1, 1))])
    
    #-----< AuthorityInfoAccessSyntax >-----#
    AuthorityInfoAccessSyntax = SEQ_OF(name=u'AuthorityInfoAccessSyntax', mode=MODE_TYPE)
    _AuthorityInfoAccessSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'AccessDescription')))
    AuthorityInfoAccessSyntax._cont = _AuthorityInfoAccessSyntax__item_
    AuthorityInfoAccessSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AccessDescription >-----#
    AccessDescription = SEQ(name=u'AccessDescription', mode=MODE_TYPE)
    _AccessDescription_accessMethod = OID(name=u'accessMethod', mode=MODE_TYPE)
    _AccessDescription_accessLocation = CHOICE(name=u'accessLocation', mode=MODE_TYPE, typeref=ASN1RefType(('CertificateExtensions', 'GeneralName')))
    AccessDescription._cont = ASN1Dict([
        (u'accessMethod', _AccessDescription_accessMethod),
        (u'accessLocation', _AccessDescription_accessLocation),
        ])
    AccessDescription._ext = None
    
    #-----< subjectInfoAccess >-----#
    subjectInfoAccess = CLASS(name=u'subjectInfoAccess', mode=MODE_VALUE, typeref=ASN1RefType(('AuthenticationFramework', 'EXTENSION')))
    _subjectInfoAccess_val_ExtnType = SEQ_OF(name=u'ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'SubjectInfoAccessSyntax')))
    subjectInfoAccess._val = dict([(u'ExtnType', _subjectInfoAccess_val_ExtnType), (u'id', (1, 3, 6, 1, 5, 5, 7, 1, 11))])
    
    #-----< SubjectInfoAccessSyntax >-----#
    SubjectInfoAccessSyntax = SEQ_OF(name=u'SubjectInfoAccessSyntax', mode=MODE_TYPE)
    _SubjectInfoAccessSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'AccessDescription')))
    SubjectInfoAccessSyntax._cont = _SubjectInfoAccessSyntax__item_
    SubjectInfoAccessSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< id-pkix >-----#
    id_pkix = OID(name=u'id-pkix', mode=MODE_VALUE)
    id_pkix._val = (1, 3, 6, 1, 5, 5, 7)
    
    #-----< id-pe >-----#
    id_pe = OID(name=u'id-pe', mode=MODE_VALUE)
    id_pe._val = (1, 3, 6, 1, 5, 5, 7, 1)
    
    #-----< id-ad >-----#
    id_ad = OID(name=u'id-ad', mode=MODE_VALUE)
    id_ad._val = (1, 3, 6, 1, 5, 5, 7, 48)
    
    #-----< id-pe-authorityInfoAccess >-----#
    id_pe_authorityInfoAccess = OID(name=u'id-pe-authorityInfoAccess', mode=MODE_VALUE)
    id_pe_authorityInfoAccess._val = (1, 3, 6, 1, 5, 5, 7, 1, 1)
    
    #-----< id-pe-subjectInfoAccess >-----#
    id_pe_subjectInfoAccess = OID(name=u'id-pe-subjectInfoAccess', mode=MODE_VALUE)
    id_pe_subjectInfoAccess._val = (1, 3, 6, 1, 5, 5, 7, 1, 11)
    
    #-----< id-ad-caIssuers >-----#
    id_ad_caIssuers = OID(name=u'id-ad-caIssuers', mode=MODE_VALUE)
    id_ad_caIssuers._val = (1, 3, 6, 1, 5, 5, 7, 48, 2)
    
    #-----< id-ad-ocsp >-----#
    id_ad_ocsp = OID(name=u'id-ad-ocsp', mode=MODE_VALUE)
    id_ad_ocsp._val = (1, 3, 6, 1, 5, 5, 7, 48, 1)
    
    #-----< G3FacsimileNonBasicParameters >-----#
    G3FacsimileNonBasicParameters = BIT_STR(name=u'G3FacsimileNonBasicParameters', mode=MODE_TYPE)
    G3FacsimileNonBasicParameters._cont = ASN1Dict([(u'two-dimensional', 8), (u'fine-resolution', 9), (u'unlimited-length', 20), (u'b4-length', 21), (u'a3-width', 22), (u'b4-width', 23), (u't6-coding', 25), (u'uncompressed', 30), (u'width-middle-864-of-1728', 37), (u'width-middle-1216-of-1728', 38), (u'resolution-type', 44), (u'resolution-400x400', 45), (u'resolution-300x300', 46), (u'resolution-8x15', 47), (u'edi', 49), (u'dtm', 50), (u'bft', 51), (u'mixed-mode', 58), (u'character-mode', 60), (u'twelve-bits', 65), (u'preferred-huffmann', 66), (u'full-colour', 67), (u'jpeg', 68), (u'processable-mode-26', 71)])
    
    #-----< ORAddress >-----#
    ORAddress = SEQ(name=u'ORAddress', mode=MODE_TYPE)
    _ORAddress_built_in_standard_attributes = SEQ(name=u'built-in-standard-attributes', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'BuiltInStandardAttributes')))
    _ORAddress_built_in_domain_defined_attributes = SEQ_OF(name=u'built-in-domain-defined-attributes', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'BuiltInDomainDefinedAttributes')), opt=True)
    _ORAddress_extension_attributes = SET_OF(name=u'extension-attributes', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionAttributes')), opt=True)
    ORAddress._cont = ASN1Dict([
        (u'built-in-standard-attributes', _ORAddress_built_in_standard_attributes),
        (u'built-in-domain-defined-attributes', _ORAddress_built_in_domain_defined_attributes),
        (u'extension-attributes', _ORAddress_extension_attributes),
        ])
    ORAddress._ext = None
    
    #-----< BuiltInStandardAttributes >-----#
    BuiltInStandardAttributes = SEQ(name=u'BuiltInStandardAttributes', mode=MODE_TYPE)
    _BuiltInStandardAttributes_country_name = CHOICE(name=u'country-name', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'CountryName')), opt=True)
    _BuiltInStandardAttributes_administration_domain_name = CHOICE(name=u'administration-domain-name', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'AdministrationDomainName')), opt=True)
    _BuiltInStandardAttributes_network_address = STR_NUM(name=u'network-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'NetworkAddress')), opt=True)
    _BuiltInStandardAttributes_terminal_identifier = STR_PRINT(name=u'terminal-identifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TerminalIdentifier')), opt=True)
    _BuiltInStandardAttributes_private_domain_name = CHOICE(name=u'private-domain-name', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PrivateDomainName')), opt=True)
    _BuiltInStandardAttributes_organization_name = STR_PRINT(name=u'organization-name', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'OrganizationName')), opt=True)
    _BuiltInStandardAttributes_numeric_user_identifier = STR_NUM(name=u'numeric-user-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'NumericUserIdentifier')), opt=True)
    _BuiltInStandardAttributes_personal_name = SET(name=u'personal-name', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PersonalName')), opt=True)
    _BuiltInStandardAttributes_organizational_unit_names = SEQ_OF(name=u'organizational-unit-names', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'OrganizationalUnitNames')), opt=True)
    BuiltInStandardAttributes._cont = ASN1Dict([
        (u'country-name', _BuiltInStandardAttributes_country_name),
        (u'administration-domain-name', _BuiltInStandardAttributes_administration_domain_name),
        (u'network-address', _BuiltInStandardAttributes_network_address),
        (u'terminal-identifier', _BuiltInStandardAttributes_terminal_identifier),
        (u'private-domain-name', _BuiltInStandardAttributes_private_domain_name),
        (u'organization-name', _BuiltInStandardAttributes_organization_name),
        (u'numeric-user-identifier', _BuiltInStandardAttributes_numeric_user_identifier),
        (u'personal-name', _BuiltInStandardAttributes_personal_name),
        (u'organizational-unit-names', _BuiltInStandardAttributes_organizational_unit_names),
        ])
    BuiltInStandardAttributes._ext = None
    
    #-----< CountryName >-----#
    CountryName = CHOICE(name=u'CountryName', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_EXPLICIT))
    _CountryName_x121_dcc_code = STR_NUM(name=u'x121-dcc-code', mode=MODE_TYPE)
    _CountryName_x121_dcc_code._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _CountryName_iso_3166_alpha2_code = STR_PRINT(name=u'iso-3166-alpha2-code', mode=MODE_TYPE)
    _CountryName_iso_3166_alpha2_code._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    CountryName._cont = ASN1Dict([
        (u'x121-dcc-code', _CountryName_x121_dcc_code),
        (u'iso-3166-alpha2-code', _CountryName_iso_3166_alpha2_code),
        ])
    CountryName._ext = None
    
    #-----< AdministrationDomainName >-----#
    AdministrationDomainName = CHOICE(name=u'AdministrationDomainName', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_EXPLICIT))
    _AdministrationDomainName_numeric = STR_NUM(name=u'numeric', mode=MODE_TYPE)
    _AdministrationDomainName_numeric._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    _AdministrationDomainName_printable = STR_PRINT(name=u'printable', mode=MODE_TYPE)
    _AdministrationDomainName_printable._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    AdministrationDomainName._cont = ASN1Dict([
        (u'numeric', _AdministrationDomainName_numeric),
        (u'printable', _AdministrationDomainName_printable),
        ])
    AdministrationDomainName._ext = None
    
    #-----< NetworkAddress >-----#
    NetworkAddress = STR_NUM(name=u'NetworkAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'X121Address')))
    
    #-----< X121Address >-----#
    X121Address = STR_NUM(name=u'X121Address', mode=MODE_TYPE)
    X121Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< TerminalIdentifier >-----#
    TerminalIdentifier = STR_PRINT(name=u'TerminalIdentifier', mode=MODE_TYPE)
    TerminalIdentifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=24)], ev=None, er=[])
    
    #-----< PrivateDomainName >-----#
    PrivateDomainName = CHOICE(name=u'PrivateDomainName', mode=MODE_TYPE)
    _PrivateDomainName_numeric = STR_NUM(name=u'numeric', mode=MODE_TYPE)
    _PrivateDomainName_numeric._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _PrivateDomainName_printable = STR_PRINT(name=u'printable', mode=MODE_TYPE)
    _PrivateDomainName_printable._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    PrivateDomainName._cont = ASN1Dict([
        (u'numeric', _PrivateDomainName_numeric),
        (u'printable', _PrivateDomainName_printable),
        ])
    PrivateDomainName._ext = None
    
    #-----< OrganizationName >-----#
    OrganizationName = STR_PRINT(name=u'OrganizationName', mode=MODE_TYPE)
    OrganizationName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< NumericUserIdentifier >-----#
    NumericUserIdentifier = STR_NUM(name=u'NumericUserIdentifier', mode=MODE_TYPE)
    NumericUserIdentifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< PersonalName >-----#
    PersonalName = SET(name=u'PersonalName', mode=MODE_TYPE)
    _PersonalName_surname = STR_PRINT(name=u'surname', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _PersonalName_surname._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    _PersonalName_given_name = STR_PRINT(name=u'given-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PersonalName_given_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _PersonalName_initials = STR_PRINT(name=u'initials', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PersonalName_initials._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _PersonalName_generation_qualifier = STR_PRINT(name=u'generation-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PersonalName_generation_qualifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    PersonalName._cont = ASN1Dict([
        (u'surname', _PersonalName_surname),
        (u'given-name', _PersonalName_given_name),
        (u'initials', _PersonalName_initials),
        (u'generation-qualifier', _PersonalName_generation_qualifier),
        ])
    PersonalName._ext = None
    
    #-----< OrganizationalUnitNames >-----#
    OrganizationalUnitNames = SEQ_OF(name=u'OrganizationalUnitNames', mode=MODE_TYPE)
    _OrganizationalUnitNames__item_ = STR_PRINT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'OrganizationalUnitName')))
    OrganizationalUnitNames._cont = _OrganizationalUnitNames__item_
    OrganizationalUnitNames._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< OrganizationalUnitName >-----#
    OrganizationalUnitName = STR_PRINT(name=u'OrganizationalUnitName', mode=MODE_TYPE)
    OrganizationalUnitName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BuiltInDomainDefinedAttributes >-----#
    BuiltInDomainDefinedAttributes = SEQ_OF(name=u'BuiltInDomainDefinedAttributes', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'BuiltInDomainDefinedAttribute')))
    BuiltInDomainDefinedAttributes._cont = _BuiltInDomainDefinedAttributes__item_
    BuiltInDomainDefinedAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< BuiltInDomainDefinedAttribute >-----#
    BuiltInDomainDefinedAttribute = SEQ(name=u'BuiltInDomainDefinedAttribute', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttribute_type = STR_PRINT(name=u'type', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttribute_type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _BuiltInDomainDefinedAttribute_value = STR_PRINT(name=u'value', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttribute_value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    BuiltInDomainDefinedAttribute._cont = ASN1Dict([
        (u'type', _BuiltInDomainDefinedAttribute_type),
        (u'value', _BuiltInDomainDefinedAttribute_value),
        ])
    BuiltInDomainDefinedAttribute._ext = None
    
    #-----< ExtensionAttributes >-----#
    ExtensionAttributes = SET_OF(name=u'ExtensionAttributes', mode=MODE_TYPE)
    _ExtensionAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionAttribute')))
    ExtensionAttributes._cont = _ExtensionAttributes__item_
    ExtensionAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ExtensionAttribute >-----#
    ExtensionAttribute = SEQ(name=u'ExtensionAttribute', mode=MODE_TYPE)
    _ExtensionAttribute_extension_attribute_type = INT(name=u'extension-attribute-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE'), [u'id']))
    __ExtensionAttribute_extension_attribute_type_tab = CLASS(name='_tab_EXTENSION-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_0 = STR_PRINT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'CommonName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_1 = STR_TELE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexCommonName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_2 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalCommonName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_3 = STR_TELE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexOrganizationName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_4 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrganizationName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_5 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexPersonalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_6 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPersonalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_7 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexOrganizationalUnitNames')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_8 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrganizationalUnitNames')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_9 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexDomainDefinedAttributes')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_10 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalDomainDefinedAttributes')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_11 = STR_PRINT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_12 = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryCountryName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_13 = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PostalCode')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_14 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOfficeName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_15 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOfficeName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_16 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOfficeNumber')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_17 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOfficeNumber')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_18 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionORAddressComponents')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_19 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalExtensionORAddressComponents')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_20 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryPersonalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_21 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryPersonalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_22 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOrganizationName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_23 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOrganizationName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_24 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionPhysicalDeliveryAddressComponents')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_25 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalExtensionPhysicalDeliveryAddressComponents')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_26 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UnformattedPostalAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_27 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalUnformattedPostalAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_28 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'StreetAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_29 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalStreetAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_30 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PostOfficeBoxAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_31 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPostOfficeBoxAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_32 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PosteRestanteAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_33 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPosteRestanteAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_34 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniquePostalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_35 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalUniquePostalName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_36 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'LocalPostalAttributes')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_37 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalLocalPostalAttributes')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_38 = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtendedNetworkAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_39 = INT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TerminalType')))
    __ExtensionAttribute_extension_attribute_type_tab._val = ASN1Set(rv=[dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_0), (u'id', 1)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_1), (u'id', 2)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_2), (u'id', 24)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_3), (u'id', 3)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_4), (u'id', 25)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_5), (u'id', 4)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_6), (u'id', 26)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_7), (u'id', 5)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_8), (u'id', 27)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_9), (u'id', 6)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_10), (u'id', 28)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_11), (u'id', 7)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_12), (u'id', 8)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_13), (u'id', 9)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_14), (u'id', 10)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_15), (u'id', 29)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_16), (u'id', 11)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_17), (u'id', 30)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_18), (u'id', 12)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_19), (u'id', 31)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_20), (u'id', 13)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_21), (u'id', 32)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_22), (u'id', 14)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_23), (u'id', 33)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_24), (u'id', 15)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_25), (u'id', 34)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_26), (u'id', 16)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_27), (u'id', 35)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_28), (u'id', 17)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_29), (u'id', 36)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_30), (u'id', 18)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_31), (u'id', 37)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_32), (u'id', 19)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_33), (u'id', 38)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_34), (u'id', 20)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_35), (u'id', 39)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_36), (u'id', 21)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_37), (u'id', 40)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_38), (u'id', 22)]), dict([(u'Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_39), (u'id', 23)])], rr=[], ev=None, er=[])
    _ExtensionAttribute_extension_attribute_type._const_tab = __ExtensionAttribute_extension_attribute_type_tab
    _ExtensionAttribute_extension_attribute_type._const_tab_at = None
    _ExtensionAttribute_extension_attribute_type._const_tab_id = u'id'
    _ExtensionAttribute_extension_attribute_value = OPEN(name=u'extension-attribute-value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE'), [u'Type']))
    _ExtensionAttribute_extension_attribute_value._const_tab = __ExtensionAttribute_extension_attribute_type_tab
    _ExtensionAttribute_extension_attribute_value._const_tab_at = ('..', u'extension-attribute-type')
    _ExtensionAttribute_extension_attribute_value._const_tab_id = u'Type'
    ExtensionAttribute._cont = ASN1Dict([
        (u'extension-attribute-type', _ExtensionAttribute_extension_attribute_type),
        (u'extension-attribute-value', _ExtensionAttribute_extension_attribute_value),
        ])
    ExtensionAttribute._ext = None
    
    #-----< EXTENSION-ATTRIBUTE >-----#
    EXTENSION_ATTRIBUTE = CLASS(name=u'EXTENSION-ATTRIBUTE', mode=MODE_TYPE)
    _EXTENSION_ATTRIBUTE_id = INT(name=u'id', mode=MODE_VALUE, uniq=True)
    _EXTENSION_ATTRIBUTE_id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    _EXTENSION_ATTRIBUTE_Type = OPEN(name=u'Type', mode=MODE_TYPE)
    EXTENSION_ATTRIBUTE._cont = ASN1Dict([
        (u'id', _EXTENSION_ATTRIBUTE_id),
        (u'Type', _EXTENSION_ATTRIBUTE_Type),
        ])
    
    #-----< ExtensionAttributeTable >-----#
    ExtensionAttributeTable = CLASS(name=u'ExtensionAttributeTable', mode=MODE_SET, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _ExtensionAttributeTable_val_Type_0 = STR_PRINT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'CommonName')))
    _ExtensionAttributeTable_val_Type_1 = STR_TELE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexCommonName')))
    _ExtensionAttributeTable_val_Type_2 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalCommonName')))
    _ExtensionAttributeTable_val_Type_3 = STR_TELE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexOrganizationName')))
    _ExtensionAttributeTable_val_Type_4 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrganizationName')))
    _ExtensionAttributeTable_val_Type_5 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexPersonalName')))
    _ExtensionAttributeTable_val_Type_6 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPersonalName')))
    _ExtensionAttributeTable_val_Type_7 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexOrganizationalUnitNames')))
    _ExtensionAttributeTable_val_Type_8 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrganizationalUnitNames')))
    _ExtensionAttributeTable_val_Type_9 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexDomainDefinedAttributes')))
    _ExtensionAttributeTable_val_Type_10 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalDomainDefinedAttributes')))
    _ExtensionAttributeTable_val_Type_11 = STR_PRINT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSName')))
    _ExtensionAttributeTable_val_Type_12 = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryCountryName')))
    _ExtensionAttributeTable_val_Type_13 = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PostalCode')))
    _ExtensionAttributeTable_val_Type_14 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOfficeName')))
    _ExtensionAttributeTable_val_Type_15 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOfficeName')))
    _ExtensionAttributeTable_val_Type_16 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOfficeNumber')))
    _ExtensionAttributeTable_val_Type_17 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOfficeNumber')))
    _ExtensionAttributeTable_val_Type_18 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionORAddressComponents')))
    _ExtensionAttributeTable_val_Type_19 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalExtensionORAddressComponents')))
    _ExtensionAttributeTable_val_Type_20 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryPersonalName')))
    _ExtensionAttributeTable_val_Type_21 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryPersonalName')))
    _ExtensionAttributeTable_val_Type_22 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOrganizationName')))
    _ExtensionAttributeTable_val_Type_23 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOrganizationName')))
    _ExtensionAttributeTable_val_Type_24 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionPhysicalDeliveryAddressComponents')))
    _ExtensionAttributeTable_val_Type_25 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalExtensionPhysicalDeliveryAddressComponents')))
    _ExtensionAttributeTable_val_Type_26 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UnformattedPostalAddress')))
    _ExtensionAttributeTable_val_Type_27 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalUnformattedPostalAddress')))
    _ExtensionAttributeTable_val_Type_28 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'StreetAddress')))
    _ExtensionAttributeTable_val_Type_29 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalStreetAddress')))
    _ExtensionAttributeTable_val_Type_30 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PostOfficeBoxAddress')))
    _ExtensionAttributeTable_val_Type_31 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPostOfficeBoxAddress')))
    _ExtensionAttributeTable_val_Type_32 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PosteRestanteAddress')))
    _ExtensionAttributeTable_val_Type_33 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPosteRestanteAddress')))
    _ExtensionAttributeTable_val_Type_34 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniquePostalName')))
    _ExtensionAttributeTable_val_Type_35 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalUniquePostalName')))
    _ExtensionAttributeTable_val_Type_36 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'LocalPostalAttributes')))
    _ExtensionAttributeTable_val_Type_37 = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalLocalPostalAttributes')))
    _ExtensionAttributeTable_val_Type_38 = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtendedNetworkAddress')))
    _ExtensionAttributeTable_val_Type_39 = INT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TerminalType')))
    ExtensionAttributeTable._val = ASN1Set(rv=[dict([(u'Type', _ExtensionAttributeTable_val_Type_0), (u'id', 1)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_1), (u'id', 2)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_2), (u'id', 24)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_3), (u'id', 3)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_4), (u'id', 25)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_5), (u'id', 4)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_6), (u'id', 26)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_7), (u'id', 5)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_8), (u'id', 27)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_9), (u'id', 6)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_10), (u'id', 28)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_11), (u'id', 7)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_12), (u'id', 8)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_13), (u'id', 9)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_14), (u'id', 10)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_15), (u'id', 29)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_16), (u'id', 11)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_17), (u'id', 30)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_18), (u'id', 12)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_19), (u'id', 31)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_20), (u'id', 13)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_21), (u'id', 32)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_22), (u'id', 14)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_23), (u'id', 33)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_24), (u'id', 15)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_25), (u'id', 34)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_26), (u'id', 16)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_27), (u'id', 35)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_28), (u'id', 17)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_29), (u'id', 36)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_30), (u'id', 18)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_31), (u'id', 37)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_32), (u'id', 19)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_33), (u'id', 38)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_34), (u'id', 20)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_35), (u'id', 39)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_36), (u'id', 21)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_37), (u'id', 40)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_38), (u'id', 22)]), dict([(u'Type', _ExtensionAttributeTable_val_Type_39), (u'id', 23)])], rr=[], ev=None, er=[])
    
    #-----< common-name >-----#
    common_name = CLASS(name=u'common-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _common_name_val_Type = STR_PRINT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'CommonName')))
    common_name._val = dict([(u'Type', _common_name_val_Type), (u'id', 1)])
    
    #-----< CommonName >-----#
    CommonName = STR_PRINT(name=u'CommonName', mode=MODE_TYPE)
    CommonName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< teletex-common-name >-----#
    teletex_common_name = CLASS(name=u'teletex-common-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _teletex_common_name_val_Type = STR_TELE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexCommonName')))
    teletex_common_name._val = dict([(u'Type', _teletex_common_name_val_Type), (u'id', 2)])
    
    #-----< TeletexCommonName >-----#
    TeletexCommonName = STR_TELE(name=u'TeletexCommonName', mode=MODE_TYPE)
    TeletexCommonName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< universal-common-name >-----#
    universal_common_name = CLASS(name=u'universal-common-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_common_name_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalCommonName')))
    universal_common_name._val = dict([(u'Type', _universal_common_name_val_Type), (u'id', 24)])
    
    #-----< UniversalCommonName >-----#
    UniversalCommonName = SET(name=u'UniversalCommonName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    _UniversalCommonName_character_encoding = CHOICE(name=u'character-encoding', mode=MODE_TYPE)
    __UniversalCommonName_character_encoding_two_octets = STR_BMP(name=u'two-octets', mode=MODE_TYPE)
    __UniversalCommonName_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __UniversalCommonName_character_encoding_four_octets = STR_UNIV(name=u'four-octets', mode=MODE_TYPE)
    __UniversalCommonName_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _UniversalCommonName_character_encoding._cont = ASN1Dict([
        (u'two-octets', __UniversalCommonName_character_encoding_two_octets),
        (u'four-octets', __UniversalCommonName_character_encoding_four_octets),
        ])
    _UniversalCommonName_character_encoding._ext = None
    _UniversalCommonName_iso_639_language_code = STR_PRINT(name=u'iso-639-language-code', mode=MODE_TYPE, opt=True)
    _UniversalCommonName_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    UniversalCommonName._cont = ASN1Dict([
        (u'character-encoding', _UniversalCommonName_character_encoding),
        (u'iso-639-language-code', _UniversalCommonName_iso_639_language_code),
        ])
    UniversalCommonName._ext = None
    
    #-----< teletex-organization-name >-----#
    teletex_organization_name = CLASS(name=u'teletex-organization-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _teletex_organization_name_val_Type = STR_TELE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexOrganizationName')))
    teletex_organization_name._val = dict([(u'Type', _teletex_organization_name_val_Type), (u'id', 3)])
    
    #-----< TeletexOrganizationName >-----#
    TeletexOrganizationName = STR_TELE(name=u'TeletexOrganizationName', mode=MODE_TYPE)
    TeletexOrganizationName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< universal-organization-name >-----#
    universal_organization_name = CLASS(name=u'universal-organization-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_organization_name_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrganizationName')))
    universal_organization_name._val = dict([(u'Type', _universal_organization_name_val_Type), (u'id', 25)])
    
    #-----< UniversalOrganizationName >-----#
    UniversalOrganizationName = SET(name=u'UniversalOrganizationName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    _UniversalOrganizationName_character_encoding = CHOICE(name=u'character-encoding', mode=MODE_TYPE)
    __UniversalOrganizationName_character_encoding_two_octets = STR_BMP(name=u'two-octets', mode=MODE_TYPE)
    __UniversalOrganizationName_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __UniversalOrganizationName_character_encoding_four_octets = STR_UNIV(name=u'four-octets', mode=MODE_TYPE)
    __UniversalOrganizationName_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _UniversalOrganizationName_character_encoding._cont = ASN1Dict([
        (u'two-octets', __UniversalOrganizationName_character_encoding_two_octets),
        (u'four-octets', __UniversalOrganizationName_character_encoding_four_octets),
        ])
    _UniversalOrganizationName_character_encoding._ext = None
    _UniversalOrganizationName_iso_639_language_code = STR_PRINT(name=u'iso-639-language-code', mode=MODE_TYPE, opt=True)
    _UniversalOrganizationName_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    UniversalOrganizationName._cont = ASN1Dict([
        (u'character-encoding', _UniversalOrganizationName_character_encoding),
        (u'iso-639-language-code', _UniversalOrganizationName_iso_639_language_code),
        ])
    UniversalOrganizationName._ext = None
    
    #-----< teletex-personal-name >-----#
    teletex_personal_name = CLASS(name=u'teletex-personal-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _teletex_personal_name_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexPersonalName')))
    teletex_personal_name._val = dict([(u'Type', _teletex_personal_name_val_Type), (u'id', 4)])
    
    #-----< TeletexPersonalName >-----#
    TeletexPersonalName = SET(name=u'TeletexPersonalName', mode=MODE_TYPE)
    _TeletexPersonalName_surname = STR_TELE(name=u'surname', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _TeletexPersonalName_surname._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    _TeletexPersonalName_given_name = STR_TELE(name=u'given-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _TeletexPersonalName_given_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _TeletexPersonalName_initials = STR_TELE(name=u'initials', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _TeletexPersonalName_initials._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _TeletexPersonalName_generation_qualifier = STR_TELE(name=u'generation-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _TeletexPersonalName_generation_qualifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    TeletexPersonalName._cont = ASN1Dict([
        (u'surname', _TeletexPersonalName_surname),
        (u'given-name', _TeletexPersonalName_given_name),
        (u'initials', _TeletexPersonalName_initials),
        (u'generation-qualifier', _TeletexPersonalName_generation_qualifier),
        ])
    TeletexPersonalName._ext = None
    
    #-----< universal-personal-name >-----#
    universal_personal_name = CLASS(name=u'universal-personal-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_personal_name_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPersonalName')))
    universal_personal_name._val = dict([(u'Type', _universal_personal_name_val_Type), (u'id', 26)])
    
    #-----< UniversalPersonalName >-----#
    UniversalPersonalName = SET(name=u'UniversalPersonalName', mode=MODE_TYPE)
    _UniversalPersonalName_surname = SET(name=u'surname', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    __UniversalPersonalName_surname_character_encoding = CHOICE(name=u'character-encoding', mode=MODE_TYPE)
    ___UniversalPersonalName_surname_character_encoding_two_octets = STR_BMP(name=u'two-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_surname_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ___UniversalPersonalName_surname_character_encoding_four_octets = STR_UNIV(name=u'four-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_surname_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __UniversalPersonalName_surname_character_encoding._cont = ASN1Dict([
        (u'two-octets', ___UniversalPersonalName_surname_character_encoding_two_octets),
        (u'four-octets', ___UniversalPersonalName_surname_character_encoding_four_octets),
        ])
    __UniversalPersonalName_surname_character_encoding._ext = None
    __UniversalPersonalName_surname_iso_639_language_code = STR_PRINT(name=u'iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalPersonalName_surname_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalPersonalName_surname._cont = ASN1Dict([
        (u'character-encoding', __UniversalPersonalName_surname_character_encoding),
        (u'iso-639-language-code', __UniversalPersonalName_surname_iso_639_language_code),
        ])
    _UniversalPersonalName_surname._ext = None
    _UniversalPersonalName_given_name = SET(name=u'given-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')), opt=True)
    __UniversalPersonalName_given_name_character_encoding = CHOICE(name=u'character-encoding', mode=MODE_TYPE)
    ___UniversalPersonalName_given_name_character_encoding_two_octets = STR_BMP(name=u'two-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_given_name_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    ___UniversalPersonalName_given_name_character_encoding_four_octets = STR_UNIV(name=u'four-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_given_name_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    __UniversalPersonalName_given_name_character_encoding._cont = ASN1Dict([
        (u'two-octets', ___UniversalPersonalName_given_name_character_encoding_two_octets),
        (u'four-octets', ___UniversalPersonalName_given_name_character_encoding_four_octets),
        ])
    __UniversalPersonalName_given_name_character_encoding._ext = None
    __UniversalPersonalName_given_name_iso_639_language_code = STR_PRINT(name=u'iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalPersonalName_given_name_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalPersonalName_given_name._cont = ASN1Dict([
        (u'character-encoding', __UniversalPersonalName_given_name_character_encoding),
        (u'iso-639-language-code', __UniversalPersonalName_given_name_iso_639_language_code),
        ])
    _UniversalPersonalName_given_name._ext = None
    _UniversalPersonalName_initials = SET(name=u'initials', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')), opt=True)
    __UniversalPersonalName_initials_character_encoding = CHOICE(name=u'character-encoding', mode=MODE_TYPE)
    ___UniversalPersonalName_initials_character_encoding_two_octets = STR_BMP(name=u'two-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_initials_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___UniversalPersonalName_initials_character_encoding_four_octets = STR_UNIV(name=u'four-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_initials_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __UniversalPersonalName_initials_character_encoding._cont = ASN1Dict([
        (u'two-octets', ___UniversalPersonalName_initials_character_encoding_two_octets),
        (u'four-octets', ___UniversalPersonalName_initials_character_encoding_four_octets),
        ])
    __UniversalPersonalName_initials_character_encoding._ext = None
    __UniversalPersonalName_initials_iso_639_language_code = STR_PRINT(name=u'iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalPersonalName_initials_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalPersonalName_initials._cont = ASN1Dict([
        (u'character-encoding', __UniversalPersonalName_initials_character_encoding),
        (u'iso-639-language-code', __UniversalPersonalName_initials_iso_639_language_code),
        ])
    _UniversalPersonalName_initials._ext = None
    _UniversalPersonalName_generation_qualifier = SET(name=u'generation-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')), opt=True)
    __UniversalPersonalName_generation_qualifier_character_encoding = CHOICE(name=u'character-encoding', mode=MODE_TYPE)
    ___UniversalPersonalName_generation_qualifier_character_encoding_two_octets = STR_BMP(name=u'two-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_generation_qualifier_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___UniversalPersonalName_generation_qualifier_character_encoding_four_octets = STR_UNIV(name=u'four-octets', mode=MODE_TYPE)
    ___UniversalPersonalName_generation_qualifier_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __UniversalPersonalName_generation_qualifier_character_encoding._cont = ASN1Dict([
        (u'two-octets', ___UniversalPersonalName_generation_qualifier_character_encoding_two_octets),
        (u'four-octets', ___UniversalPersonalName_generation_qualifier_character_encoding_four_octets),
        ])
    __UniversalPersonalName_generation_qualifier_character_encoding._ext = None
    __UniversalPersonalName_generation_qualifier_iso_639_language_code = STR_PRINT(name=u'iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalPersonalName_generation_qualifier_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalPersonalName_generation_qualifier._cont = ASN1Dict([
        (u'character-encoding', __UniversalPersonalName_generation_qualifier_character_encoding),
        (u'iso-639-language-code', __UniversalPersonalName_generation_qualifier_iso_639_language_code),
        ])
    _UniversalPersonalName_generation_qualifier._ext = None
    UniversalPersonalName._cont = ASN1Dict([
        (u'surname', _UniversalPersonalName_surname),
        (u'given-name', _UniversalPersonalName_given_name),
        (u'initials', _UniversalPersonalName_initials),
        (u'generation-qualifier', _UniversalPersonalName_generation_qualifier),
        ])
    UniversalPersonalName._ext = None
    
    #-----< teletex-organizational-unit-names >-----#
    teletex_organizational_unit_names = CLASS(name=u'teletex-organizational-unit-names', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _teletex_organizational_unit_names_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexOrganizationalUnitNames')))
    teletex_organizational_unit_names._val = dict([(u'Type', _teletex_organizational_unit_names_val_Type), (u'id', 5)])
    
    #-----< TeletexOrganizationalUnitNames >-----#
    TeletexOrganizationalUnitNames = SEQ_OF(name=u'TeletexOrganizationalUnitNames', mode=MODE_TYPE)
    _TeletexOrganizationalUnitNames__item_ = STR_TELE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexOrganizationalUnitName')))
    TeletexOrganizationalUnitNames._cont = _TeletexOrganizationalUnitNames__item_
    TeletexOrganizationalUnitNames._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< TeletexOrganizationalUnitName >-----#
    TeletexOrganizationalUnitName = STR_TELE(name=u'TeletexOrganizationalUnitName', mode=MODE_TYPE)
    TeletexOrganizationalUnitName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< universal-organizational-unit-names >-----#
    universal_organizational_unit_names = CLASS(name=u'universal-organizational-unit-names', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_organizational_unit_names_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrganizationalUnitNames')))
    universal_organizational_unit_names._val = dict([(u'Type', _universal_organizational_unit_names_val_Type), (u'id', 27)])
    
    #-----< UniversalOrganizationalUnitNames >-----#
    UniversalOrganizationalUnitNames = SEQ_OF(name=u'UniversalOrganizationalUnitNames', mode=MODE_TYPE)
    _UniversalOrganizationalUnitNames__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrganizationalUnitName')))
    UniversalOrganizationalUnitNames._cont = _UniversalOrganizationalUnitNames__item_
    UniversalOrganizationalUnitNames._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< UniversalOrganizationalUnitName >-----#
    UniversalOrganizationalUnitName = SET(name=u'UniversalOrganizationalUnitName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    _UniversalOrganizationalUnitName_character_encoding = CHOICE(name=u'character-encoding', mode=MODE_TYPE)
    __UniversalOrganizationalUnitName_character_encoding_two_octets = STR_BMP(name=u'two-octets', mode=MODE_TYPE)
    __UniversalOrganizationalUnitName_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    __UniversalOrganizationalUnitName_character_encoding_four_octets = STR_UNIV(name=u'four-octets', mode=MODE_TYPE)
    __UniversalOrganizationalUnitName_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _UniversalOrganizationalUnitName_character_encoding._cont = ASN1Dict([
        (u'two-octets', __UniversalOrganizationalUnitName_character_encoding_two_octets),
        (u'four-octets', __UniversalOrganizationalUnitName_character_encoding_four_octets),
        ])
    _UniversalOrganizationalUnitName_character_encoding._ext = None
    _UniversalOrganizationalUnitName_iso_639_language_code = STR_PRINT(name=u'iso-639-language-code', mode=MODE_TYPE, opt=True)
    _UniversalOrganizationalUnitName_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    UniversalOrganizationalUnitName._cont = ASN1Dict([
        (u'character-encoding', _UniversalOrganizationalUnitName_character_encoding),
        (u'iso-639-language-code', _UniversalOrganizationalUnitName_iso_639_language_code),
        ])
    UniversalOrganizationalUnitName._ext = None
    
    #-----< UniversalOrBMPString >-----#
    UniversalOrBMPString = SET(name=u'UniversalOrBMPString', mode=MODE_TYPE, param=True)
    
    #-----< pds-name >-----#
    pds_name = CLASS(name=u'pds-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _pds_name_val_Type = STR_PRINT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSName')))
    pds_name._val = dict([(u'Type', _pds_name_val_Type), (u'id', 7)])
    
    #-----< PDSName >-----#
    PDSName = STR_PRINT(name=u'PDSName', mode=MODE_TYPE)
    PDSName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< physical-delivery-country-name >-----#
    physical_delivery_country_name = CLASS(name=u'physical-delivery-country-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _physical_delivery_country_name_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryCountryName')))
    physical_delivery_country_name._val = dict([(u'Type', _physical_delivery_country_name_val_Type), (u'id', 8)])
    
    #-----< PhysicalDeliveryCountryName >-----#
    PhysicalDeliveryCountryName = CHOICE(name=u'PhysicalDeliveryCountryName', mode=MODE_TYPE)
    _PhysicalDeliveryCountryName_x121_dcc_code = STR_NUM(name=u'x121-dcc-code', mode=MODE_TYPE)
    _PhysicalDeliveryCountryName_x121_dcc_code._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _PhysicalDeliveryCountryName_iso_3166_alpha2_code = STR_PRINT(name=u'iso-3166-alpha2-code', mode=MODE_TYPE)
    _PhysicalDeliveryCountryName_iso_3166_alpha2_code._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    PhysicalDeliveryCountryName._cont = ASN1Dict([
        (u'x121-dcc-code', _PhysicalDeliveryCountryName_x121_dcc_code),
        (u'iso-3166-alpha2-code', _PhysicalDeliveryCountryName_iso_3166_alpha2_code),
        ])
    PhysicalDeliveryCountryName._ext = None
    
    #-----< postal-code >-----#
    postal_code = CLASS(name=u'postal-code', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _postal_code_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PostalCode')))
    postal_code._val = dict([(u'Type', _postal_code_val_Type), (u'id', 9)])
    
    #-----< PostalCode >-----#
    PostalCode = CHOICE(name=u'PostalCode', mode=MODE_TYPE)
    _PostalCode_numeric_code = STR_NUM(name=u'numeric-code', mode=MODE_TYPE)
    _PostalCode_numeric_code._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _PostalCode_printable_code = STR_PRINT(name=u'printable-code', mode=MODE_TYPE)
    _PostalCode_printable_code._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    PostalCode._cont = ASN1Dict([
        (u'numeric-code', _PostalCode_numeric_code),
        (u'printable-code', _PostalCode_printable_code),
        ])
    PostalCode._ext = None
    
    #-----< physical-delivery-office-name >-----#
    physical_delivery_office_name = CLASS(name=u'physical-delivery-office-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _physical_delivery_office_name_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOfficeName')))
    physical_delivery_office_name._val = dict([(u'Type', _physical_delivery_office_name_val_Type), (u'id', 10)])
    
    #-----< PhysicalDeliveryOfficeName >-----#
    PhysicalDeliveryOfficeName = SET(name=u'PhysicalDeliveryOfficeName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-physical-delivery-office-name >-----#
    universal_physical_delivery_office_name = CLASS(name=u'universal-physical-delivery-office-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_physical_delivery_office_name_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOfficeName')))
    universal_physical_delivery_office_name._val = dict([(u'Type', _universal_physical_delivery_office_name_val_Type), (u'id', 29)])
    
    #-----< UniversalPhysicalDeliveryOfficeName >-----#
    UniversalPhysicalDeliveryOfficeName = SET(name=u'UniversalPhysicalDeliveryOfficeName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< physical-delivery-office-number >-----#
    physical_delivery_office_number = CLASS(name=u'physical-delivery-office-number', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _physical_delivery_office_number_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOfficeNumber')))
    physical_delivery_office_number._val = dict([(u'Type', _physical_delivery_office_number_val_Type), (u'id', 11)])
    
    #-----< PhysicalDeliveryOfficeNumber >-----#
    PhysicalDeliveryOfficeNumber = SET(name=u'PhysicalDeliveryOfficeNumber', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-physical-delivery-office-number >-----#
    universal_physical_delivery_office_number = CLASS(name=u'universal-physical-delivery-office-number', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_physical_delivery_office_number_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOfficeNumber')))
    universal_physical_delivery_office_number._val = dict([(u'Type', _universal_physical_delivery_office_number_val_Type), (u'id', 30)])
    
    #-----< UniversalPhysicalDeliveryOfficeNumber >-----#
    UniversalPhysicalDeliveryOfficeNumber = SET(name=u'UniversalPhysicalDeliveryOfficeNumber', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< extension-OR-address-components >-----#
    extension_OR_address_components = CLASS(name=u'extension-OR-address-components', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _extension_OR_address_components_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionORAddressComponents')))
    extension_OR_address_components._val = dict([(u'Type', _extension_OR_address_components_val_Type), (u'id', 12)])
    
    #-----< ExtensionORAddressComponents >-----#
    ExtensionORAddressComponents = SET(name=u'ExtensionORAddressComponents', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-extension-OR-address-components >-----#
    universal_extension_OR_address_components = CLASS(name=u'universal-extension-OR-address-components', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_extension_OR_address_components_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalExtensionORAddressComponents')))
    universal_extension_OR_address_components._val = dict([(u'Type', _universal_extension_OR_address_components_val_Type), (u'id', 31)])
    
    #-----< UniversalExtensionORAddressComponents >-----#
    UniversalExtensionORAddressComponents = SET(name=u'UniversalExtensionORAddressComponents', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< physical-delivery-personal-name >-----#
    physical_delivery_personal_name = CLASS(name=u'physical-delivery-personal-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _physical_delivery_personal_name_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryPersonalName')))
    physical_delivery_personal_name._val = dict([(u'Type', _physical_delivery_personal_name_val_Type), (u'id', 13)])
    
    #-----< PhysicalDeliveryPersonalName >-----#
    PhysicalDeliveryPersonalName = SET(name=u'PhysicalDeliveryPersonalName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-physical-delivery-personal-name >-----#
    universal_physical_delivery_personal_name = CLASS(name=u'universal-physical-delivery-personal-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_physical_delivery_personal_name_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryPersonalName')))
    universal_physical_delivery_personal_name._val = dict([(u'Type', _universal_physical_delivery_personal_name_val_Type), (u'id', 32)])
    
    #-----< UniversalPhysicalDeliveryPersonalName >-----#
    UniversalPhysicalDeliveryPersonalName = SET(name=u'UniversalPhysicalDeliveryPersonalName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< physical-delivery-organization-name >-----#
    physical_delivery_organization_name = CLASS(name=u'physical-delivery-organization-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _physical_delivery_organization_name_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PhysicalDeliveryOrganizationName')))
    physical_delivery_organization_name._val = dict([(u'Type', _physical_delivery_organization_name_val_Type), (u'id', 14)])
    
    #-----< PhysicalDeliveryOrganizationName >-----#
    PhysicalDeliveryOrganizationName = SET(name=u'PhysicalDeliveryOrganizationName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-physical-delivery-organization-name >-----#
    universal_physical_delivery_organization_name = CLASS(name=u'universal-physical-delivery-organization-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_physical_delivery_organization_name_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPhysicalDeliveryOrganizationName')))
    universal_physical_delivery_organization_name._val = dict([(u'Type', _universal_physical_delivery_organization_name_val_Type), (u'id', 33)])
    
    #-----< UniversalPhysicalDeliveryOrganizationName >-----#
    UniversalPhysicalDeliveryOrganizationName = SET(name=u'UniversalPhysicalDeliveryOrganizationName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< extension-physical-delivery-address-components >-----#
    extension_physical_delivery_address_components = CLASS(name=u'extension-physical-delivery-address-components', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _extension_physical_delivery_address_components_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtensionPhysicalDeliveryAddressComponents')))
    extension_physical_delivery_address_components._val = dict([(u'Type', _extension_physical_delivery_address_components_val_Type), (u'id', 15)])
    
    #-----< ExtensionPhysicalDeliveryAddressComponents >-----#
    ExtensionPhysicalDeliveryAddressComponents = SET(name=u'ExtensionPhysicalDeliveryAddressComponents', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-extension-physical-delivery-address-components >-----#
    universal_extension_physical_delivery_address_components = CLASS(name=u'universal-extension-physical-delivery-address-components', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_extension_physical_delivery_address_components_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalExtensionPhysicalDeliveryAddressComponents')))
    universal_extension_physical_delivery_address_components._val = dict([(u'Type', _universal_extension_physical_delivery_address_components_val_Type), (u'id', 34)])
    
    #-----< UniversalExtensionPhysicalDeliveryAddressComponents >-----#
    UniversalExtensionPhysicalDeliveryAddressComponents = SET(name=u'UniversalExtensionPhysicalDeliveryAddressComponents', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< unformatted-postal-address >-----#
    unformatted_postal_address = CLASS(name=u'unformatted-postal-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _unformatted_postal_address_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UnformattedPostalAddress')))
    unformatted_postal_address._val = dict([(u'Type', _unformatted_postal_address_val_Type), (u'id', 16)])
    
    #-----< UnformattedPostalAddress >-----#
    UnformattedPostalAddress = SET(name=u'UnformattedPostalAddress', mode=MODE_TYPE)
    _UnformattedPostalAddress_printable_address = SEQ_OF(name=u'printable-address', mode=MODE_TYPE, opt=True)
    __UnformattedPostalAddress_printable_address__item_ = STR_PRINT(name='_item_', mode=MODE_TYPE)
    __UnformattedPostalAddress_printable_address__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _UnformattedPostalAddress_printable_address._cont = __UnformattedPostalAddress_printable_address__item_
    _UnformattedPostalAddress_printable_address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    _UnformattedPostalAddress_teletex_string = STR_TELE(name=u'teletex-string', mode=MODE_TYPE, opt=True)
    _UnformattedPostalAddress_teletex_string._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=180)], ev=None, er=[])
    UnformattedPostalAddress._cont = ASN1Dict([
        (u'printable-address', _UnformattedPostalAddress_printable_address),
        (u'teletex-string', _UnformattedPostalAddress_teletex_string),
        ])
    UnformattedPostalAddress._ext = None
    
    #-----< universal-unformatted-postal-address >-----#
    universal_unformatted_postal_address = CLASS(name=u'universal-unformatted-postal-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_unformatted_postal_address_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalUnformattedPostalAddress')))
    universal_unformatted_postal_address._val = dict([(u'Type', _universal_unformatted_postal_address_val_Type), (u'id', 35)])
    
    #-----< UniversalUnformattedPostalAddress >-----#
    UniversalUnformattedPostalAddress = SET(name=u'UniversalUnformattedPostalAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    _UniversalUnformattedPostalAddress_character_encoding = CHOICE(name=u'character-encoding', mode=MODE_TYPE)
    __UniversalUnformattedPostalAddress_character_encoding_two_octets = STR_BMP(name=u'two-octets', mode=MODE_TYPE)
    __UniversalUnformattedPostalAddress_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=180)], ev=None, er=[])
    __UniversalUnformattedPostalAddress_character_encoding_four_octets = STR_UNIV(name=u'four-octets', mode=MODE_TYPE)
    __UniversalUnformattedPostalAddress_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=180)], ev=None, er=[])
    _UniversalUnformattedPostalAddress_character_encoding._cont = ASN1Dict([
        (u'two-octets', __UniversalUnformattedPostalAddress_character_encoding_two_octets),
        (u'four-octets', __UniversalUnformattedPostalAddress_character_encoding_four_octets),
        ])
    _UniversalUnformattedPostalAddress_character_encoding._ext = None
    _UniversalUnformattedPostalAddress_iso_639_language_code = STR_PRINT(name=u'iso-639-language-code', mode=MODE_TYPE, opt=True)
    _UniversalUnformattedPostalAddress_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    UniversalUnformattedPostalAddress._cont = ASN1Dict([
        (u'character-encoding', _UniversalUnformattedPostalAddress_character_encoding),
        (u'iso-639-language-code', _UniversalUnformattedPostalAddress_iso_639_language_code),
        ])
    UniversalUnformattedPostalAddress._ext = None
    
    #-----< street-address >-----#
    street_address = CLASS(name=u'street-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _street_address_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'StreetAddress')))
    street_address._val = dict([(u'Type', _street_address_val_Type), (u'id', 17)])
    
    #-----< StreetAddress >-----#
    StreetAddress = SET(name=u'StreetAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-street-address >-----#
    universal_street_address = CLASS(name=u'universal-street-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_street_address_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalStreetAddress')))
    universal_street_address._val = dict([(u'Type', _universal_street_address_val_Type), (u'id', 36)])
    
    #-----< UniversalStreetAddress >-----#
    UniversalStreetAddress = SET(name=u'UniversalStreetAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< post-office-box-address >-----#
    post_office_box_address = CLASS(name=u'post-office-box-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _post_office_box_address_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PostOfficeBoxAddress')))
    post_office_box_address._val = dict([(u'Type', _post_office_box_address_val_Type), (u'id', 18)])
    
    #-----< PostOfficeBoxAddress >-----#
    PostOfficeBoxAddress = SET(name=u'PostOfficeBoxAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-post-office-box-address >-----#
    universal_post_office_box_address = CLASS(name=u'universal-post-office-box-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_post_office_box_address_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPostOfficeBoxAddress')))
    universal_post_office_box_address._val = dict([(u'Type', _universal_post_office_box_address_val_Type), (u'id', 37)])
    
    #-----< UniversalPostOfficeBoxAddress >-----#
    UniversalPostOfficeBoxAddress = SET(name=u'UniversalPostOfficeBoxAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< poste-restante-address >-----#
    poste_restante_address = CLASS(name=u'poste-restante-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _poste_restante_address_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PosteRestanteAddress')))
    poste_restante_address._val = dict([(u'Type', _poste_restante_address_val_Type), (u'id', 19)])
    
    #-----< PosteRestanteAddress >-----#
    PosteRestanteAddress = SET(name=u'PosteRestanteAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-poste-restante-address >-----#
    universal_poste_restante_address = CLASS(name=u'universal-poste-restante-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_poste_restante_address_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPosteRestanteAddress')))
    universal_poste_restante_address._val = dict([(u'Type', _universal_poste_restante_address_val_Type), (u'id', 38)])
    
    #-----< UniversalPosteRestanteAddress >-----#
    UniversalPosteRestanteAddress = SET(name=u'UniversalPosteRestanteAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< unique-postal-name >-----#
    unique_postal_name = CLASS(name=u'unique-postal-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _unique_postal_name_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniquePostalName')))
    unique_postal_name._val = dict([(u'Type', _unique_postal_name_val_Type), (u'id', 20)])
    
    #-----< UniquePostalName >-----#
    UniquePostalName = SET(name=u'UniquePostalName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-unique-postal-name >-----#
    universal_unique_postal_name = CLASS(name=u'universal-unique-postal-name', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_unique_postal_name_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalUniquePostalName')))
    universal_unique_postal_name._val = dict([(u'Type', _universal_unique_postal_name_val_Type), (u'id', 39)])
    
    #-----< UniversalUniquePostalName >-----#
    UniversalUniquePostalName = SET(name=u'UniversalUniquePostalName', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< local-postal-attributes >-----#
    local_postal_attributes = CLASS(name=u'local-postal-attributes', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _local_postal_attributes_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'LocalPostalAttributes')))
    local_postal_attributes._val = dict([(u'Type', _local_postal_attributes_val_Type), (u'id', 21)])
    
    #-----< LocalPostalAttributes >-----#
    LocalPostalAttributes = SET(name=u'LocalPostalAttributes', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'PDSParameter')))
    
    #-----< universal-local-postal-attributes >-----#
    universal_local_postal_attributes = CLASS(name=u'universal-local-postal-attributes', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_local_postal_attributes_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalLocalPostalAttributes')))
    universal_local_postal_attributes._val = dict([(u'Type', _universal_local_postal_attributes_val_Type), (u'id', 40)])
    
    #-----< UniversalLocalPostalAttributes >-----#
    UniversalLocalPostalAttributes = SET(name=u'UniversalLocalPostalAttributes', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalPDSParameter')))
    
    #-----< PDSParameter >-----#
    PDSParameter = SET(name=u'PDSParameter', mode=MODE_TYPE)
    _PDSParameter_printable_string = STR_PRINT(name=u'printable-string', mode=MODE_TYPE, opt=True)
    _PDSParameter_printable_string._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _PDSParameter_teletex_string = STR_TELE(name=u'teletex-string', mode=MODE_TYPE, opt=True)
    _PDSParameter_teletex_string._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    PDSParameter._cont = ASN1Dict([
        (u'printable-string', _PDSParameter_printable_string),
        (u'teletex-string', _PDSParameter_teletex_string),
        ])
    PDSParameter._ext = None
    
    #-----< UniversalPDSParameter >-----#
    UniversalPDSParameter = SET(name=u'UniversalPDSParameter', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    _UniversalPDSParameter_character_encoding = CHOICE(name=u'character-encoding', mode=MODE_TYPE)
    __UniversalPDSParameter_character_encoding_two_octets = STR_BMP(name=u'two-octets', mode=MODE_TYPE)
    __UniversalPDSParameter_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __UniversalPDSParameter_character_encoding_four_octets = STR_UNIV(name=u'four-octets', mode=MODE_TYPE)
    __UniversalPDSParameter_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _UniversalPDSParameter_character_encoding._cont = ASN1Dict([
        (u'two-octets', __UniversalPDSParameter_character_encoding_two_octets),
        (u'four-octets', __UniversalPDSParameter_character_encoding_four_octets),
        ])
    _UniversalPDSParameter_character_encoding._ext = None
    _UniversalPDSParameter_iso_639_language_code = STR_PRINT(name=u'iso-639-language-code', mode=MODE_TYPE, opt=True)
    _UniversalPDSParameter_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    UniversalPDSParameter._cont = ASN1Dict([
        (u'character-encoding', _UniversalPDSParameter_character_encoding),
        (u'iso-639-language-code', _UniversalPDSParameter_iso_639_language_code),
        ])
    UniversalPDSParameter._ext = None
    
    #-----< extended-network-address >-----#
    extended_network_address = CLASS(name=u'extended-network-address', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _extended_network_address_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'ExtendedNetworkAddress')))
    extended_network_address._val = dict([(u'Type', _extended_network_address_val_Type), (u'id', 22)])
    
    #-----< ExtendedNetworkAddress >-----#
    ExtendedNetworkAddress = CHOICE(name=u'ExtendedNetworkAddress', mode=MODE_TYPE)
    _ExtendedNetworkAddress_e163_4_address = SEQ(name=u'e163-4-address', mode=MODE_TYPE)
    __ExtendedNetworkAddress_e163_4_address_number = STR_NUM(name=u'number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ExtendedNetworkAddress_e163_4_address_number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    __ExtendedNetworkAddress_e163_4_address_sub_address = STR_NUM(name=u'sub-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ExtendedNetworkAddress_e163_4_address_sub_address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    _ExtendedNetworkAddress_e163_4_address._cont = ASN1Dict([
        (u'number', __ExtendedNetworkAddress_e163_4_address_number),
        (u'sub-address', __ExtendedNetworkAddress_e163_4_address_sub_address),
        ])
    _ExtendedNetworkAddress_e163_4_address._ext = None
    _ExtendedNetworkAddress_psap_address = SEQ(name=u'psap-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    ExtendedNetworkAddress._cont = ASN1Dict([
        (u'e163-4-address', _ExtendedNetworkAddress_e163_4_address),
        (u'psap-address', _ExtendedNetworkAddress_psap_address),
        ])
    ExtendedNetworkAddress._ext = None
    
    #-----< terminal-type >-----#
    terminal_type = CLASS(name=u'terminal-type', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _terminal_type_val_Type = INT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TerminalType')))
    terminal_type._val = dict([(u'Type', _terminal_type_val_Type), (u'id', 23)])
    
    #-----< TerminalType >-----#
    TerminalType = INT(name=u'TerminalType', mode=MODE_TYPE)
    TerminalType._cont = ASN1Dict([(u'telex', 3), (u'teletex', 4), (u'g3-facsimile', 5), (u'g4-facsimile', 6), (u'ia5-terminal', 7), (u'videotex', 8)])
    TerminalType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    
    #-----< teletex-domain-defined-attributes >-----#
    teletex_domain_defined_attributes = CLASS(name=u'teletex-domain-defined-attributes', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _teletex_domain_defined_attributes_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexDomainDefinedAttributes')))
    teletex_domain_defined_attributes._val = dict([(u'Type', _teletex_domain_defined_attributes_val_Type), (u'id', 6)])
    
    #-----< TeletexDomainDefinedAttributes >-----#
    TeletexDomainDefinedAttributes = SEQ_OF(name=u'TeletexDomainDefinedAttributes', mode=MODE_TYPE)
    _TeletexDomainDefinedAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'TeletexDomainDefinedAttribute')))
    TeletexDomainDefinedAttributes._cont = _TeletexDomainDefinedAttributes__item_
    TeletexDomainDefinedAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< TeletexDomainDefinedAttribute >-----#
    TeletexDomainDefinedAttribute = SEQ(name=u'TeletexDomainDefinedAttribute', mode=MODE_TYPE)
    _TeletexDomainDefinedAttribute_type = STR_TELE(name=u'type', mode=MODE_TYPE)
    _TeletexDomainDefinedAttribute_type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _TeletexDomainDefinedAttribute_value = STR_TELE(name=u'value', mode=MODE_TYPE)
    _TeletexDomainDefinedAttribute_value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    TeletexDomainDefinedAttribute._cont = ASN1Dict([
        (u'type', _TeletexDomainDefinedAttribute_type),
        (u'value', _TeletexDomainDefinedAttribute_value),
        ])
    TeletexDomainDefinedAttribute._ext = None
    
    #-----< universal-domain-defined-attributes >-----#
    universal_domain_defined_attributes = CLASS(name=u'universal-domain-defined-attributes', mode=MODE_VALUE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'EXTENSION-ATTRIBUTE')))
    _universal_domain_defined_attributes_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalDomainDefinedAttributes')))
    universal_domain_defined_attributes._val = dict([(u'Type', _universal_domain_defined_attributes_val_Type), (u'id', 28)])
    
    #-----< UniversalDomainDefinedAttributes >-----#
    UniversalDomainDefinedAttributes = SEQ_OF(name=u'UniversalDomainDefinedAttributes', mode=MODE_TYPE)
    _UniversalDomainDefinedAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalDomainDefinedAttribute')))
    UniversalDomainDefinedAttributes._cont = _UniversalDomainDefinedAttributes__item_
    UniversalDomainDefinedAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< UniversalDomainDefinedAttribute >-----#
    UniversalDomainDefinedAttribute = SEQ(name=u'UniversalDomainDefinedAttribute', mode=MODE_TYPE)
    _UniversalDomainDefinedAttribute_type = SET(name=u'type', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    __UniversalDomainDefinedAttribute_type_character_encoding = CHOICE(name=u'character-encoding', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_type_character_encoding_two_octets = STR_BMP(name=u'two-octets', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_type_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    ___UniversalDomainDefinedAttribute_type_character_encoding_four_octets = STR_UNIV(name=u'four-octets', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_type_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    __UniversalDomainDefinedAttribute_type_character_encoding._cont = ASN1Dict([
        (u'two-octets', ___UniversalDomainDefinedAttribute_type_character_encoding_two_octets),
        (u'four-octets', ___UniversalDomainDefinedAttribute_type_character_encoding_four_octets),
        ])
    __UniversalDomainDefinedAttribute_type_character_encoding._ext = None
    __UniversalDomainDefinedAttribute_type_iso_639_language_code = STR_PRINT(name=u'iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalDomainDefinedAttribute_type_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalDomainDefinedAttribute_type._cont = ASN1Dict([
        (u'character-encoding', __UniversalDomainDefinedAttribute_type_character_encoding),
        (u'iso-639-language-code', __UniversalDomainDefinedAttribute_type_iso_639_language_code),
        ])
    _UniversalDomainDefinedAttribute_type._ext = None
    _UniversalDomainDefinedAttribute_value = SET(name=u'value', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'UniversalOrBMPString')))
    __UniversalDomainDefinedAttribute_value_character_encoding = CHOICE(name=u'character-encoding', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_value_character_encoding_two_octets = STR_BMP(name=u'two-octets', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_value_character_encoding_two_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    ___UniversalDomainDefinedAttribute_value_character_encoding_four_octets = STR_UNIV(name=u'four-octets', mode=MODE_TYPE)
    ___UniversalDomainDefinedAttribute_value_character_encoding_four_octets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __UniversalDomainDefinedAttribute_value_character_encoding._cont = ASN1Dict([
        (u'two-octets', ___UniversalDomainDefinedAttribute_value_character_encoding_two_octets),
        (u'four-octets', ___UniversalDomainDefinedAttribute_value_character_encoding_four_octets),
        ])
    __UniversalDomainDefinedAttribute_value_character_encoding._ext = None
    __UniversalDomainDefinedAttribute_value_iso_639_language_code = STR_PRINT(name=u'iso-639-language-code', mode=MODE_TYPE, opt=True)
    __UniversalDomainDefinedAttribute_value_iso_639_language_code._const_sz = ASN1Set(rv=[2, 5], rr=[], ev=None, er=[])
    _UniversalDomainDefinedAttribute_value._cont = ASN1Dict([
        (u'character-encoding', __UniversalDomainDefinedAttribute_value_character_encoding),
        (u'iso-639-language-code', __UniversalDomainDefinedAttribute_value_iso_639_language_code),
        ])
    _UniversalDomainDefinedAttribute_value._ext = None
    UniversalDomainDefinedAttribute._cont = ASN1Dict([
        (u'type', _UniversalDomainDefinedAttribute_type),
        (u'value', _UniversalDomainDefinedAttribute_value),
        ])
    UniversalDomainDefinedAttribute._ext = None
    
    #-----< ub-integer-options >-----#
    ub_integer_options = INT(name=u'ub-integer-options', mode=MODE_VALUE)
    ub_integer_options._val = 256
    
    #-----< ub-e163-4-number-length >-----#
    ub_e163_4_number_length = INT(name=u'ub-e163-4-number-length', mode=MODE_VALUE)
    ub_e163_4_number_length._val = 15
    
    #-----< ub-e163-4-sub-address-length >-----#
    ub_e163_4_sub_address_length = INT(name=u'ub-e163-4-sub-address-length', mode=MODE_VALUE)
    ub_e163_4_sub_address_length._val = 40
    
    #-----< ub-unformatted-address-length >-----#
    ub_unformatted_address_length = INT(name=u'ub-unformatted-address-length', mode=MODE_VALUE)
    ub_unformatted_address_length._val = 180
    
    #-----< ub-pds-parameter-length >-----#
    ub_pds_parameter_length = INT(name=u'ub-pds-parameter-length', mode=MODE_VALUE)
    ub_pds_parameter_length._val = 30
    
    #-----< ub-pds-physical-address-lines >-----#
    ub_pds_physical_address_lines = INT(name=u'ub-pds-physical-address-lines', mode=MODE_VALUE)
    ub_pds_physical_address_lines._val = 6
    
    #-----< ub-postal-code-length >-----#
    ub_postal_code_length = INT(name=u'ub-postal-code-length', mode=MODE_VALUE)
    ub_postal_code_length._val = 16
    
    #-----< ub-pds-name-length >-----#
    ub_pds_name_length = INT(name=u'ub-pds-name-length', mode=MODE_VALUE)
    ub_pds_name_length._val = 16
    
    #-----< ub-universal-surname-length >-----#
    ub_universal_surname_length = INT(name=u'ub-universal-surname-length', mode=MODE_VALUE)
    ub_universal_surname_length._val = 64
    
    #-----< ub-universal-given-name-length >-----#
    ub_universal_given_name_length = INT(name=u'ub-universal-given-name-length', mode=MODE_VALUE)
    ub_universal_given_name_length._val = 40
    
    #-----< ub-universal-initials-length >-----#
    ub_universal_initials_length = INT(name=u'ub-universal-initials-length', mode=MODE_VALUE)
    ub_universal_initials_length._val = 16
    
    #-----< ub-universal-generation-qualifier-length >-----#
    ub_universal_generation_qualifier_length = INT(name=u'ub-universal-generation-qualifier-length', mode=MODE_VALUE)
    ub_universal_generation_qualifier_length._val = 16
    
    #-----< ub-common-name-length >-----#
    ub_common_name_length = INT(name=u'ub-common-name-length', mode=MODE_VALUE)
    ub_common_name_length._val = 64
    
    #-----< ub-extension-attributes >-----#
    ub_extension_attributes = INT(name=u'ub-extension-attributes', mode=MODE_VALUE)
    ub_extension_attributes._val = 256
    
    #-----< ub-domain-defined-attribute-type-length >-----#
    ub_domain_defined_attribute_type_length = INT(name=u'ub-domain-defined-attribute-type-length', mode=MODE_VALUE)
    ub_domain_defined_attribute_type_length._val = 8
    
    #-----< ub-domain-defined-attribute-value-length >-----#
    ub_domain_defined_attribute_value_length = INT(name=u'ub-domain-defined-attribute-value-length', mode=MODE_VALUE)
    ub_domain_defined_attribute_value_length._val = 128
    
    #-----< ub-domain-defined-attributes >-----#
    ub_domain_defined_attributes = INT(name=u'ub-domain-defined-attributes', mode=MODE_VALUE)
    ub_domain_defined_attributes._val = 4
    
    #-----< ub-organizational-unit-name-length >-----#
    ub_organizational_unit_name_length = INT(name=u'ub-organizational-unit-name-length', mode=MODE_VALUE)
    ub_organizational_unit_name_length._val = 32
    
    #-----< ub-organizational-units >-----#
    ub_organizational_units = INT(name=u'ub-organizational-units', mode=MODE_VALUE)
    ub_organizational_units._val = 4
    
    #-----< ub-generation-qualifier-length >-----#
    ub_generation_qualifier_length = INT(name=u'ub-generation-qualifier-length', mode=MODE_VALUE)
    ub_generation_qualifier_length._val = 3
    
    #-----< ub-initials-length >-----#
    ub_initials_length = INT(name=u'ub-initials-length', mode=MODE_VALUE)
    ub_initials_length._val = 5
    
    #-----< ub-given-name-length >-----#
    ub_given_name_length = INT(name=u'ub-given-name-length', mode=MODE_VALUE)
    ub_given_name_length._val = 16
    
    #-----< ub-surname-length >-----#
    ub_surname_length = INT(name=u'ub-surname-length', mode=MODE_VALUE)
    ub_surname_length._val = 40
    
    #-----< ub-numeric-user-id-length >-----#
    ub_numeric_user_id_length = INT(name=u'ub-numeric-user-id-length', mode=MODE_VALUE)
    ub_numeric_user_id_length._val = 32
    
    #-----< ub-organization-name-length >-----#
    ub_organization_name_length = INT(name=u'ub-organization-name-length', mode=MODE_VALUE)
    ub_organization_name_length._val = 64
    
    #-----< ub-terminal-id-length >-----#
    ub_terminal_id_length = INT(name=u'ub-terminal-id-length', mode=MODE_VALUE)
    ub_terminal_id_length._val = 24
    
    #-----< ub-x121-address-length >-----#
    ub_x121_address_length = INT(name=u'ub-x121-address-length', mode=MODE_VALUE)
    ub_x121_address_length._val = 16
    
    #-----< ub-domain-name-length >-----#
    ub_domain_name_length = INT(name=u'ub-domain-name-length', mode=MODE_VALUE)
    ub_domain_name_length._val = 16
    
    #-----< ub-country-name-alpha-length >-----#
    ub_country_name_alpha_length = INT(name=u'ub-country-name-alpha-length', mode=MODE_VALUE)
    ub_country_name_alpha_length._val = 2
    
    #-----< ub-country-name-numeric-length >-----#
    ub_country_name_numeric_length = INT(name=u'ub-country-name-numeric-length', mode=MODE_VALUE)
    ub_country_name_numeric_length._val = 3
    
    _all_ = [
        _UserNotice_noticeRef,
        _UserNotice_explicitText,
        UserNotice,
        _NoticeReference_organization,
        __NoticeReference_noticeNumbers__item_,
        _NoticeReference_noticeNumbers,
        NoticeReference,
        _DisplayText_visibleString,
        _DisplayText_bmpString,
        _DisplayText_utf8String,
        DisplayText,
        authorityInfoAccess,
        _authorityInfoAccess_val_ExtnType,
        _AuthorityInfoAccessSyntax__item_,
        AuthorityInfoAccessSyntax,
        _AccessDescription_accessMethod,
        _AccessDescription_accessLocation,
        AccessDescription,
        subjectInfoAccess,
        _subjectInfoAccess_val_ExtnType,
        _SubjectInfoAccessSyntax__item_,
        SubjectInfoAccessSyntax,
        id_pkix,
        id_pe,
        id_ad,
        id_pe_authorityInfoAccess,
        id_pe_subjectInfoAccess,
        id_ad_caIssuers,
        id_ad_ocsp,
        G3FacsimileNonBasicParameters,
        _ORAddress_built_in_standard_attributes,
        _ORAddress_built_in_domain_defined_attributes,
        _ORAddress_extension_attributes,
        ORAddress,
        _BuiltInStandardAttributes_country_name,
        _BuiltInStandardAttributes_administration_domain_name,
        _BuiltInStandardAttributes_network_address,
        _BuiltInStandardAttributes_terminal_identifier,
        _BuiltInStandardAttributes_private_domain_name,
        _BuiltInStandardAttributes_organization_name,
        _BuiltInStandardAttributes_numeric_user_identifier,
        _BuiltInStandardAttributes_personal_name,
        _BuiltInStandardAttributes_organizational_unit_names,
        BuiltInStandardAttributes,
        _CountryName_x121_dcc_code,
        _CountryName_iso_3166_alpha2_code,
        CountryName,
        _AdministrationDomainName_numeric,
        _AdministrationDomainName_printable,
        AdministrationDomainName,
        NetworkAddress,
        X121Address,
        TerminalIdentifier,
        _PrivateDomainName_numeric,
        _PrivateDomainName_printable,
        PrivateDomainName,
        OrganizationName,
        NumericUserIdentifier,
        _PersonalName_surname,
        _PersonalName_given_name,
        _PersonalName_initials,
        _PersonalName_generation_qualifier,
        PersonalName,
        _OrganizationalUnitNames__item_,
        OrganizationalUnitNames,
        OrganizationalUnitName,
        _BuiltInDomainDefinedAttributes__item_,
        BuiltInDomainDefinedAttributes,
        _BuiltInDomainDefinedAttribute_type,
        _BuiltInDomainDefinedAttribute_value,
        BuiltInDomainDefinedAttribute,
        _ExtensionAttributes__item_,
        ExtensionAttributes,
        __ExtensionAttribute_extension_attribute_type_tab,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_0,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_1,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_2,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_3,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_4,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_5,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_6,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_7,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_8,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_9,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_10,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_11,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_12,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_13,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_14,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_15,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_16,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_17,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_18,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_19,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_20,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_21,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_22,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_23,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_24,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_25,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_26,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_27,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_28,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_29,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_30,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_31,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_32,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_33,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_34,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_35,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_36,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_37,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_38,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_39,
        _ExtensionAttribute_extension_attribute_type,
        _ExtensionAttribute_extension_attribute_value,
        ExtensionAttribute,
        _EXTENSION_ATTRIBUTE_id,
        _EXTENSION_ATTRIBUTE_Type,
        EXTENSION_ATTRIBUTE,
        ExtensionAttributeTable,
        _ExtensionAttributeTable_val_Type_0,
        _ExtensionAttributeTable_val_Type_1,
        _ExtensionAttributeTable_val_Type_2,
        _ExtensionAttributeTable_val_Type_3,
        _ExtensionAttributeTable_val_Type_4,
        _ExtensionAttributeTable_val_Type_5,
        _ExtensionAttributeTable_val_Type_6,
        _ExtensionAttributeTable_val_Type_7,
        _ExtensionAttributeTable_val_Type_8,
        _ExtensionAttributeTable_val_Type_9,
        _ExtensionAttributeTable_val_Type_10,
        _ExtensionAttributeTable_val_Type_11,
        _ExtensionAttributeTable_val_Type_12,
        _ExtensionAttributeTable_val_Type_13,
        _ExtensionAttributeTable_val_Type_14,
        _ExtensionAttributeTable_val_Type_15,
        _ExtensionAttributeTable_val_Type_16,
        _ExtensionAttributeTable_val_Type_17,
        _ExtensionAttributeTable_val_Type_18,
        _ExtensionAttributeTable_val_Type_19,
        _ExtensionAttributeTable_val_Type_20,
        _ExtensionAttributeTable_val_Type_21,
        _ExtensionAttributeTable_val_Type_22,
        _ExtensionAttributeTable_val_Type_23,
        _ExtensionAttributeTable_val_Type_24,
        _ExtensionAttributeTable_val_Type_25,
        _ExtensionAttributeTable_val_Type_26,
        _ExtensionAttributeTable_val_Type_27,
        _ExtensionAttributeTable_val_Type_28,
        _ExtensionAttributeTable_val_Type_29,
        _ExtensionAttributeTable_val_Type_30,
        _ExtensionAttributeTable_val_Type_31,
        _ExtensionAttributeTable_val_Type_32,
        _ExtensionAttributeTable_val_Type_33,
        _ExtensionAttributeTable_val_Type_34,
        _ExtensionAttributeTable_val_Type_35,
        _ExtensionAttributeTable_val_Type_36,
        _ExtensionAttributeTable_val_Type_37,
        _ExtensionAttributeTable_val_Type_38,
        _ExtensionAttributeTable_val_Type_39,
        common_name,
        _common_name_val_Type,
        CommonName,
        teletex_common_name,
        _teletex_common_name_val_Type,
        TeletexCommonName,
        universal_common_name,
        _universal_common_name_val_Type,
        __UniversalCommonName_character_encoding_two_octets,
        __UniversalCommonName_character_encoding_four_octets,
        _UniversalCommonName_character_encoding,
        _UniversalCommonName_iso_639_language_code,
        UniversalCommonName,
        teletex_organization_name,
        _teletex_organization_name_val_Type,
        TeletexOrganizationName,
        universal_organization_name,
        _universal_organization_name_val_Type,
        __UniversalOrganizationName_character_encoding_two_octets,
        __UniversalOrganizationName_character_encoding_four_octets,
        _UniversalOrganizationName_character_encoding,
        _UniversalOrganizationName_iso_639_language_code,
        UniversalOrganizationName,
        teletex_personal_name,
        _teletex_personal_name_val_Type,
        _TeletexPersonalName_surname,
        _TeletexPersonalName_given_name,
        _TeletexPersonalName_initials,
        _TeletexPersonalName_generation_qualifier,
        TeletexPersonalName,
        universal_personal_name,
        _universal_personal_name_val_Type,
        ___UniversalPersonalName_surname_character_encoding_two_octets,
        ___UniversalPersonalName_surname_character_encoding_four_octets,
        __UniversalPersonalName_surname_character_encoding,
        __UniversalPersonalName_surname_iso_639_language_code,
        _UniversalPersonalName_surname,
        ___UniversalPersonalName_given_name_character_encoding_two_octets,
        ___UniversalPersonalName_given_name_character_encoding_four_octets,
        __UniversalPersonalName_given_name_character_encoding,
        __UniversalPersonalName_given_name_iso_639_language_code,
        _UniversalPersonalName_given_name,
        ___UniversalPersonalName_initials_character_encoding_two_octets,
        ___UniversalPersonalName_initials_character_encoding_four_octets,
        __UniversalPersonalName_initials_character_encoding,
        __UniversalPersonalName_initials_iso_639_language_code,
        _UniversalPersonalName_initials,
        ___UniversalPersonalName_generation_qualifier_character_encoding_two_octets,
        ___UniversalPersonalName_generation_qualifier_character_encoding_four_octets,
        __UniversalPersonalName_generation_qualifier_character_encoding,
        __UniversalPersonalName_generation_qualifier_iso_639_language_code,
        _UniversalPersonalName_generation_qualifier,
        UniversalPersonalName,
        teletex_organizational_unit_names,
        _teletex_organizational_unit_names_val_Type,
        _TeletexOrganizationalUnitNames__item_,
        TeletexOrganizationalUnitNames,
        TeletexOrganizationalUnitName,
        universal_organizational_unit_names,
        _universal_organizational_unit_names_val_Type,
        _UniversalOrganizationalUnitNames__item_,
        UniversalOrganizationalUnitNames,
        __UniversalOrganizationalUnitName_character_encoding_two_octets,
        __UniversalOrganizationalUnitName_character_encoding_four_octets,
        _UniversalOrganizationalUnitName_character_encoding,
        _UniversalOrganizationalUnitName_iso_639_language_code,
        UniversalOrganizationalUnitName,
        pds_name,
        _pds_name_val_Type,
        PDSName,
        physical_delivery_country_name,
        _physical_delivery_country_name_val_Type,
        _PhysicalDeliveryCountryName_x121_dcc_code,
        _PhysicalDeliveryCountryName_iso_3166_alpha2_code,
        PhysicalDeliveryCountryName,
        postal_code,
        _postal_code_val_Type,
        _PostalCode_numeric_code,
        _PostalCode_printable_code,
        PostalCode,
        physical_delivery_office_name,
        _physical_delivery_office_name_val_Type,
        PhysicalDeliveryOfficeName,
        universal_physical_delivery_office_name,
        _universal_physical_delivery_office_name_val_Type,
        UniversalPhysicalDeliveryOfficeName,
        physical_delivery_office_number,
        _physical_delivery_office_number_val_Type,
        PhysicalDeliveryOfficeNumber,
        universal_physical_delivery_office_number,
        _universal_physical_delivery_office_number_val_Type,
        UniversalPhysicalDeliveryOfficeNumber,
        extension_OR_address_components,
        _extension_OR_address_components_val_Type,
        ExtensionORAddressComponents,
        universal_extension_OR_address_components,
        _universal_extension_OR_address_components_val_Type,
        UniversalExtensionORAddressComponents,
        physical_delivery_personal_name,
        _physical_delivery_personal_name_val_Type,
        PhysicalDeliveryPersonalName,
        universal_physical_delivery_personal_name,
        _universal_physical_delivery_personal_name_val_Type,
        UniversalPhysicalDeliveryPersonalName,
        physical_delivery_organization_name,
        _physical_delivery_organization_name_val_Type,
        PhysicalDeliveryOrganizationName,
        universal_physical_delivery_organization_name,
        _universal_physical_delivery_organization_name_val_Type,
        UniversalPhysicalDeliveryOrganizationName,
        extension_physical_delivery_address_components,
        _extension_physical_delivery_address_components_val_Type,
        ExtensionPhysicalDeliveryAddressComponents,
        universal_extension_physical_delivery_address_components,
        _universal_extension_physical_delivery_address_components_val_Type,
        UniversalExtensionPhysicalDeliveryAddressComponents,
        unformatted_postal_address,
        _unformatted_postal_address_val_Type,
        __UnformattedPostalAddress_printable_address__item_,
        _UnformattedPostalAddress_printable_address,
        _UnformattedPostalAddress_teletex_string,
        UnformattedPostalAddress,
        universal_unformatted_postal_address,
        _universal_unformatted_postal_address_val_Type,
        __UniversalUnformattedPostalAddress_character_encoding_two_octets,
        __UniversalUnformattedPostalAddress_character_encoding_four_octets,
        _UniversalUnformattedPostalAddress_character_encoding,
        _UniversalUnformattedPostalAddress_iso_639_language_code,
        UniversalUnformattedPostalAddress,
        street_address,
        _street_address_val_Type,
        StreetAddress,
        universal_street_address,
        _universal_street_address_val_Type,
        UniversalStreetAddress,
        post_office_box_address,
        _post_office_box_address_val_Type,
        PostOfficeBoxAddress,
        universal_post_office_box_address,
        _universal_post_office_box_address_val_Type,
        UniversalPostOfficeBoxAddress,
        poste_restante_address,
        _poste_restante_address_val_Type,
        PosteRestanteAddress,
        universal_poste_restante_address,
        _universal_poste_restante_address_val_Type,
        UniversalPosteRestanteAddress,
        unique_postal_name,
        _unique_postal_name_val_Type,
        UniquePostalName,
        universal_unique_postal_name,
        _universal_unique_postal_name_val_Type,
        UniversalUniquePostalName,
        local_postal_attributes,
        _local_postal_attributes_val_Type,
        LocalPostalAttributes,
        universal_local_postal_attributes,
        _universal_local_postal_attributes_val_Type,
        UniversalLocalPostalAttributes,
        _PDSParameter_printable_string,
        _PDSParameter_teletex_string,
        PDSParameter,
        __UniversalPDSParameter_character_encoding_two_octets,
        __UniversalPDSParameter_character_encoding_four_octets,
        _UniversalPDSParameter_character_encoding,
        _UniversalPDSParameter_iso_639_language_code,
        UniversalPDSParameter,
        extended_network_address,
        _extended_network_address_val_Type,
        __ExtendedNetworkAddress_e163_4_address_number,
        __ExtendedNetworkAddress_e163_4_address_sub_address,
        _ExtendedNetworkAddress_e163_4_address,
        _ExtendedNetworkAddress_psap_address,
        ExtendedNetworkAddress,
        terminal_type,
        _terminal_type_val_Type,
        TerminalType,
        teletex_domain_defined_attributes,
        _teletex_domain_defined_attributes_val_Type,
        _TeletexDomainDefinedAttributes__item_,
        TeletexDomainDefinedAttributes,
        _TeletexDomainDefinedAttribute_type,
        _TeletexDomainDefinedAttribute_value,
        TeletexDomainDefinedAttribute,
        universal_domain_defined_attributes,
        _universal_domain_defined_attributes_val_Type,
        _UniversalDomainDefinedAttributes__item_,
        UniversalDomainDefinedAttributes,
        ___UniversalDomainDefinedAttribute_type_character_encoding_two_octets,
        ___UniversalDomainDefinedAttribute_type_character_encoding_four_octets,
        __UniversalDomainDefinedAttribute_type_character_encoding,
        __UniversalDomainDefinedAttribute_type_iso_639_language_code,
        _UniversalDomainDefinedAttribute_type,
        ___UniversalDomainDefinedAttribute_value_character_encoding_two_octets,
        ___UniversalDomainDefinedAttribute_value_character_encoding_four_octets,
        __UniversalDomainDefinedAttribute_value_character_encoding,
        __UniversalDomainDefinedAttribute_value_iso_639_language_code,
        _UniversalDomainDefinedAttribute_value,
        UniversalDomainDefinedAttribute,
        ub_integer_options,
        ub_e163_4_number_length,
        ub_e163_4_sub_address_length,
        ub_unformatted_address_length,
        ub_pds_parameter_length,
        ub_pds_physical_address_lines,
        ub_postal_code_length,
        ub_pds_name_length,
        ub_universal_surname_length,
        ub_universal_given_name_length,
        ub_universal_initials_length,
        ub_universal_generation_qualifier_length,
        ub_common_name_length,
        ub_extension_attributes,
        ub_domain_defined_attribute_type_length,
        ub_domain_defined_attribute_value_length,
        ub_domain_defined_attributes,
        ub_organizational_unit_name_length,
        ub_organizational_units,
        ub_generation_qualifier_length,
        ub_initials_length,
        ub_given_name_length,
        ub_surname_length,
        ub_numeric_user_id_length,
        ub_organization_name_length,
        ub_terminal_id_length,
        ub_x121_address_length,
        ub_domain_name_length,
        ub_country_name_alpha_length,
        ub_country_name_numeric_length,
    ]

class POCChargingDataTypes:

    _name_  = u'POCChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 7, 0, 1]
    
    _obj_ = [
        u'POCRecord',
        u'PPFRecord',
        u'CPFRecord',
        u'AccessPriority',
        u'CauseForRecordClosing',
        u'ChangeCondition',
        u'ListofTalkBurstExchange',
        u'ParticipatingType',
        u'POCEventType',
        u'POCInformation',
        u'POCParticipant',
        u'POCSessionInitType',
        u'POCSessionType',
        ]
    _type_ = [
        u'POCRecord',
        u'PPFRecord',
        u'CPFRecord',
        u'AccessPriority',
        u'CauseForRecordClosing',
        u'ChangeCondition',
        u'ListofTalkBurstExchange',
        u'ParticipatingType',
        u'POCEventType',
        u'POCInformation',
        u'POCParticipant',
        u'POCSessionInitType',
        u'POCSessionType',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< POCRecord >-----#
    POCRecord = CHOICE(name=u'POCRecord', mode=MODE_TYPE)
    _POCRecord_pPFRecord = SET(name=u'pPFRecord', mode=MODE_TYPE, tag=(80, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'PPFRecord')))
    _POCRecord_cPFRecord = SET(name=u'cPFRecord', mode=MODE_TYPE, tag=(81, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'CPFRecord')))
    POCRecord._cont = ASN1Dict([
        (u'pPFRecord', _POCRecord_pPFRecord),
        (u'cPFRecord', _POCRecord_cPFRecord),
        ])
    POCRecord._ext = None
    
    #-----< PPFRecord >-----#
    PPFRecord = SET(name=u'PPFRecord', mode=MODE_TYPE)
    _PPFRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _PPFRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PPFRecord_sIP_Method = STR_GRAPH(name=u'sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _PPFRecord_nodeAddress = CHOICE(name=u'nodeAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _PPFRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _PPFRecord_calling_Party_Address = CHOICE(name=u'calling-Party-Address', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _PPFRecord_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _PPFRecord_servedParty = STR_GRAPH(name=u'servedParty', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PPFRecord_serviceRequestTimeStamp = OCT_STR(name=u'serviceRequestTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PPFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name=u'serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PPFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name=u'serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PPFRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PPFRecord_recordClosureTime = OCT_STR(name=u'recordClosureTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PPFRecord_interOperatorIdentifiers = SEQ(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _PPFRecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _PPFRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PPFRecord_causeForRecordClosing = ENUM(name=u'causeForRecordClosing', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _PPFRecord_incomplete_CDR_Indication = SET(name=u'incomplete-CDR-Indication', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _PPFRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _PPFRecord_list_Of_SDP_Media_Components = SEQ_OF(name=u'list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PPFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _PPFRecord_list_Of_SDP_Media_Components._cont = __PPFRecord_list_Of_SDP_Media_Components__item_
    _PPFRecord_gGSNaddress = CHOICE(name=u'gGSNaddress', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _PPFRecord_serviceReasonReturnCode = STR_UTF8(name=u'serviceReasonReturnCode', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PPFRecord_list_Of_Message_Bodies = SEQ_OF(name=u'list-Of-Message-Bodies', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PPFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _PPFRecord_list_Of_Message_Bodies._cont = __PPFRecord_list_Of_Message_Bodies__item_
    _PPFRecord_userLocationInfo = OCT_STR(name=u'userLocationInfo', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PPFRecord_poCInformation = SET(name=u'poCInformation', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'POCInformation')), opt=True)
    _PPFRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _PPFRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    PPFRecord._cont = ASN1Dict([
        (u'recordType', _PPFRecord_recordType),
        (u'retransmission', _PPFRecord_retransmission),
        (u'sIP-Method', _PPFRecord_sIP_Method),
        (u'nodeAddress', _PPFRecord_nodeAddress),
        (u'session-Id', _PPFRecord_session_Id),
        (u'calling-Party-Address', _PPFRecord_calling_Party_Address),
        (u'called-Party-Address', _PPFRecord_called_Party_Address),
        (u'servedParty', _PPFRecord_servedParty),
        (u'serviceRequestTimeStamp', _PPFRecord_serviceRequestTimeStamp),
        (u'serviceDeliveryStartTimeStamp', _PPFRecord_serviceDeliveryStartTimeStamp),
        (u'serviceDeliveryEndTimeStamp', _PPFRecord_serviceDeliveryEndTimeStamp),
        (u'recordOpeningTime', _PPFRecord_recordOpeningTime),
        (u'recordClosureTime', _PPFRecord_recordClosureTime),
        (u'interOperatorIdentifiers', _PPFRecord_interOperatorIdentifiers),
        (u'localRecordSequenceNumber', _PPFRecord_localRecordSequenceNumber),
        (u'recordSequenceNumber', _PPFRecord_recordSequenceNumber),
        (u'causeForRecordClosing', _PPFRecord_causeForRecordClosing),
        (u'incomplete-CDR-Indication', _PPFRecord_incomplete_CDR_Indication),
        (u'iMS-Charging-Identifier', _PPFRecord_iMS_Charging_Identifier),
        (u'list-Of-SDP-Media-Components', _PPFRecord_list_Of_SDP_Media_Components),
        (u'gGSNaddress', _PPFRecord_gGSNaddress),
        (u'serviceReasonReturnCode', _PPFRecord_serviceReasonReturnCode),
        (u'list-Of-Message-Bodies', _PPFRecord_list_Of_Message_Bodies),
        (u'userLocationInfo', _PPFRecord_userLocationInfo),
        (u'poCInformation', _PPFRecord_poCInformation),
        (u'recordExtensions', _PPFRecord_recordExtensions),
        (u'serviceContextID', _PPFRecord_serviceContextID),
        ])
    PPFRecord._ext = None
    
    #-----< CPFRecord >-----#
    CPFRecord = SET(name=u'CPFRecord', mode=MODE_TYPE)
    _CPFRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _CPFRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPFRecord_sIP_Method = STR_GRAPH(name=u'sIP-Method', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'SIP-Method')), opt=True)
    _CPFRecord_nodeAddress = CHOICE(name=u'nodeAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _CPFRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _CPFRecord_calling_Party_Address = CHOICE(name=u'calling-Party-Address', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _CPFRecord_called_Party_Address = CHOICE(name=u'called-Party-Address', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')), opt=True)
    _CPFRecord_servedParty = STR_GRAPH(name=u'servedParty', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPFRecord_serviceRequestTimeStamp = OCT_STR(name=u'serviceRequestTimeStamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CPFRecord_serviceDeliveryStartTimeStamp = OCT_STR(name=u'serviceDeliveryStartTimeStamp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CPFRecord_serviceDeliveryEndTimeStamp = OCT_STR(name=u'serviceDeliveryEndTimeStamp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CPFRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CPFRecord_recordClosureTime = OCT_STR(name=u'recordClosureTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CPFRecord_interOperatorIdentifiers = SEQ(name=u'interOperatorIdentifiers', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'InterOperatorIdentifiers')), opt=True)
    _CPFRecord_localRecordSequenceNumber = INT(name=u'localRecordSequenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _CPFRecord_recordSequenceNumber = INT(name=u'recordSequenceNumber', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPFRecord_causeForRecordClosing = ENUM(name=u'causeForRecordClosing', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'CauseForRecordClosing')), opt=True)
    _CPFRecord_incomplete_CDR_Indication = SET(name=u'incomplete-CDR-Indication', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'Incomplete-CDR-Indication')), opt=True)
    _CPFRecord_iMS_Charging_Identifier = OCT_STR(name=u'iMS-Charging-Identifier', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'IMS-Charging-Identifier')), opt=True)
    _CPFRecord_list_Of_SDP_Media_Components = SEQ_OF(name=u'list-Of-SDP-Media-Components', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CPFRecord_list_Of_SDP_Media_Components__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'Media-Components-List')))
    _CPFRecord_list_Of_SDP_Media_Components._cont = __CPFRecord_list_Of_SDP_Media_Components__item_
    _CPFRecord_gGSNaddress = CHOICE(name=u'gGSNaddress', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _CPFRecord_serviceReasonReturnCode = STR_UTF8(name=u'serviceReasonReturnCode', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPFRecord_list_Of_Message_Bodies = SEQ_OF(name=u'list-Of-Message-Bodies', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CPFRecord_list_Of_Message_Bodies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('IMSChargingDataTypes', 'MessageBody')))
    _CPFRecord_list_Of_Message_Bodies._cont = __CPFRecord_list_Of_Message_Bodies__item_
    _CPFRecord_userLocationInfo = OCT_STR(name=u'userLocationInfo', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CPFRecord_poCInformation = SET(name=u'poCInformation', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'POCInformation')), opt=True)
    _CPFRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _CPFRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    CPFRecord._cont = ASN1Dict([
        (u'recordType', _CPFRecord_recordType),
        (u'retransmission', _CPFRecord_retransmission),
        (u'sIP-Method', _CPFRecord_sIP_Method),
        (u'nodeAddress', _CPFRecord_nodeAddress),
        (u'session-Id', _CPFRecord_session_Id),
        (u'calling-Party-Address', _CPFRecord_calling_Party_Address),
        (u'called-Party-Address', _CPFRecord_called_Party_Address),
        (u'servedParty', _CPFRecord_servedParty),
        (u'serviceRequestTimeStamp', _CPFRecord_serviceRequestTimeStamp),
        (u'serviceDeliveryStartTimeStamp', _CPFRecord_serviceDeliveryStartTimeStamp),
        (u'serviceDeliveryEndTimeStamp', _CPFRecord_serviceDeliveryEndTimeStamp),
        (u'recordOpeningTime', _CPFRecord_recordOpeningTime),
        (u'recordClosureTime', _CPFRecord_recordClosureTime),
        (u'interOperatorIdentifiers', _CPFRecord_interOperatorIdentifiers),
        (u'localRecordSequenceNumber', _CPFRecord_localRecordSequenceNumber),
        (u'recordSequenceNumber', _CPFRecord_recordSequenceNumber),
        (u'causeForRecordClosing', _CPFRecord_causeForRecordClosing),
        (u'incomplete-CDR-Indication', _CPFRecord_incomplete_CDR_Indication),
        (u'iMS-Charging-Identifier', _CPFRecord_iMS_Charging_Identifier),
        (u'list-Of-SDP-Media-Components', _CPFRecord_list_Of_SDP_Media_Components),
        (u'gGSNaddress', _CPFRecord_gGSNaddress),
        (u'serviceReasonReturnCode', _CPFRecord_serviceReasonReturnCode),
        (u'list-Of-Message-Bodies', _CPFRecord_list_Of_Message_Bodies),
        (u'userLocationInfo', _CPFRecord_userLocationInfo),
        (u'poCInformation', _CPFRecord_poCInformation),
        (u'recordExtensions', _CPFRecord_recordExtensions),
        (u'serviceContextID', _CPFRecord_serviceContextID),
        ])
    CPFRecord._ext = None
    
    #-----< AccessPriority >-----#
    AccessPriority = ENUM(name=u'AccessPriority', mode=MODE_TYPE)
    AccessPriority._cont = ASN1Dict([(u'pre-emptive', 0), (u'high', 1), (u'normal', 2), (u'low', 3)])
    AccessPriority._ext = None
    
    #-----< CauseForRecordClosing >-----#
    CauseForRecordClosing = ENUM(name=u'CauseForRecordClosing', mode=MODE_TYPE)
    CauseForRecordClosing._cont = ASN1Dict([(u'normalRelease', 0), (u'abnormalRelease', 1), (u'serviceChange', 2), (u'volumeLimit', 3), (u'timeLimit', 4), (u'numberofTalkBurstLimit', 5), (u'maxChangeCond', 6), (u'sessionTypeChange', 7), (u'managementIntervention', 8)])
    CauseForRecordClosing._ext = None
    
    #-----< ChangeCondition >-----#
    ChangeCondition = ENUM(name=u'ChangeCondition', mode=MODE_TYPE)
    ChangeCondition._cont = ASN1Dict([(u'serviceChange', 0), (u'volumeLimit', 1), (u'timeLimit', 2), (u'numberofTalkBurstLimit', 3), (u'numberofActiveParticipants', 4), (u'tariffTime', 5)])
    ChangeCondition._ext = None
    
    #-----< ListofTalkBurstExchange >-----#
    ListofTalkBurstExchange = SET(name=u'ListofTalkBurstExchange', mode=MODE_TYPE)
    _ListofTalkBurstExchange_number_Of_Talk_Bursts = INT(name=u'number-Of-Talk-Bursts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ListofTalkBurstExchange_talk_Burst_Volume = INT(name=u'talk-Burst-Volume', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ListofTalkBurstExchange_talk_Bursts_Time = INT(name=u'talk-Bursts-Time', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _ListofTalkBurstExchange_number_Of_Received_Talk_Bursts = INT(name=u'number-Of-Received-Talk-Bursts', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ListofTalkBurstExchange_received_Talk_Burst_Volume = INT(name=u'received-Talk-Burst-Volume', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ListofTalkBurstExchange_received_Talk_Burst_Time = INT(name=u'received-Talk-Burst-Time', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'CallDuration')), opt=True)
    _ListofTalkBurstExchange_changeCondition = ENUM(name=u'changeCondition', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'ChangeCondition')), opt=True)
    _ListofTalkBurstExchange_changeTime = OCT_STR(name=u'changeTime', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ListofTalkBurstExchange_numberofParticipants = INT(name=u'numberofParticipants', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ListofTalkBurstExchange._cont = ASN1Dict([
        (u'number-Of-Talk-Bursts', _ListofTalkBurstExchange_number_Of_Talk_Bursts),
        (u'talk-Burst-Volume', _ListofTalkBurstExchange_talk_Burst_Volume),
        (u'talk-Bursts-Time', _ListofTalkBurstExchange_talk_Bursts_Time),
        (u'number-Of-Received-Talk-Bursts', _ListofTalkBurstExchange_number_Of_Received_Talk_Bursts),
        (u'received-Talk-Burst-Volume', _ListofTalkBurstExchange_received_Talk_Burst_Volume),
        (u'received-Talk-Burst-Time', _ListofTalkBurstExchange_received_Talk_Burst_Time),
        (u'changeCondition', _ListofTalkBurstExchange_changeCondition),
        (u'changeTime', _ListofTalkBurstExchange_changeTime),
        (u'numberofParticipants', _ListofTalkBurstExchange_numberofParticipants),
        ])
    ListofTalkBurstExchange._ext = None
    
    #-----< ParticipatingType >-----#
    ParticipatingType = ENUM(name=u'ParticipatingType', mode=MODE_TYPE)
    ParticipatingType._cont = ASN1Dict([(u'normal', 0), (u'nW-PoC-Box', 1), (u'uE-PoC-Box', 2)])
    ParticipatingType._ext = None
    
    #-----< POCEventType >-----#
    POCEventType = ENUM(name=u'POCEventType', mode=MODE_TYPE)
    POCEventType._cont = ASN1Dict([(u'normal', 0), (u'instantPersonalAlert', 1), (u'pOCGroupAdvertisement', 2), (u'earlySessionSettingup', 3), (u'pOCTalkBurst', 4)])
    POCEventType._ext = None
    
    #-----< POCInformation >-----#
    POCInformation = SET(name=u'POCInformation', mode=MODE_TYPE)
    _POCInformation_pOCSessionType = ENUM(name=u'pOCSessionType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'POCSessionType')), opt=True)
    _POCInformation_numberofParticipants = INT(name=u'numberofParticipants', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _POCInformation_listofParticipants = SEQ_OF(name=u'listofParticipants', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __POCInformation_listofParticipants__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('POCChargingDataTypes', 'POCParticipant')))
    _POCInformation_listofParticipants._cont = __POCInformation_listofParticipants__item_
    _POCInformation_listofTalkBurstExchange = SEQ_OF(name=u'listofTalkBurstExchange', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __POCInformation_listofTalkBurstExchange__item_ = SET(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('POCChargingDataTypes', 'ListofTalkBurstExchange')))
    _POCInformation_listofTalkBurstExchange._cont = __POCInformation_listofTalkBurstExchange__item_
    _POCInformation_pOCControllingAddress = STR_UTF8(name=u'pOCControllingAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _POCInformation_pOCGroupName = STR_UTF8(name=u'pOCGroupName', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _POCInformation_pOCSessionId = STR_UTF8(name=u'pOCSessionId', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _POCInformation_pOCSessionInitiationType = ENUM(name=u'pOCSessionInitiationType', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'POCSessionInitType')), opt=True)
    _POCInformation_pOCEventType = ENUM(name=u'pOCEventType', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'POCEventType')), opt=True)
    POCInformation._cont = ASN1Dict([
        (u'pOCSessionType', _POCInformation_pOCSessionType),
        (u'numberofParticipants', _POCInformation_numberofParticipants),
        (u'listofParticipants', _POCInformation_listofParticipants),
        (u'listofTalkBurstExchange', _POCInformation_listofTalkBurstExchange),
        (u'pOCControllingAddress', _POCInformation_pOCControllingAddress),
        (u'pOCGroupName', _POCInformation_pOCGroupName),
        (u'pOCSessionId', _POCInformation_pOCSessionId),
        (u'pOCSessionInitiationType', _POCInformation_pOCSessionInitiationType),
        (u'pOCEventType', _POCInformation_pOCEventType),
        ])
    POCInformation._ext = None
    
    #-----< POCParticipant >-----#
    POCParticipant = SET(name=u'POCParticipant', mode=MODE_TYPE)
    _POCParticipant_called_party_address = CHOICE(name=u'called-party-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'InvolvedParty')))
    _POCParticipant_participant_access_priority = ENUM(name=u'participant-access-priority', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'AccessPriority')), opt=True)
    _POCParticipant_user_participating_type = ENUM(name=u'user-participating-type', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('POCChargingDataTypes', 'ParticipatingType')), opt=True)
    POCParticipant._cont = ASN1Dict([
        (u'called-party-address', _POCParticipant_called_party_address),
        (u'participant-access-priority', _POCParticipant_participant_access_priority),
        (u'user-participating-type', _POCParticipant_user_participating_type),
        ])
    POCParticipant._ext = None
    
    #-----< POCSessionInitType >-----#
    POCSessionInitType = ENUM(name=u'POCSessionInitType', mode=MODE_TYPE)
    POCSessionInitType._cont = ASN1Dict([(u'pre-established', 0), (u'on-demand', 1)])
    POCSessionInitType._ext = None
    
    #-----< POCSessionType >-----#
    POCSessionType = ENUM(name=u'POCSessionType', mode=MODE_TYPE)
    POCSessionType._cont = ASN1Dict([(u'one-to-one-session', 0), (u'chat-group-session', 1), (u'pre-arranged-group-session', 2), (u'ad-hoc-group-session', 3)])
    POCSessionType._ext = None
    
    _all_ = [
        _POCRecord_pPFRecord,
        _POCRecord_cPFRecord,
        POCRecord,
        _PPFRecord_recordType,
        _PPFRecord_retransmission,
        _PPFRecord_sIP_Method,
        _PPFRecord_nodeAddress,
        _PPFRecord_session_Id,
        _PPFRecord_calling_Party_Address,
        _PPFRecord_called_Party_Address,
        _PPFRecord_servedParty,
        _PPFRecord_serviceRequestTimeStamp,
        _PPFRecord_serviceDeliveryStartTimeStamp,
        _PPFRecord_serviceDeliveryEndTimeStamp,
        _PPFRecord_recordOpeningTime,
        _PPFRecord_recordClosureTime,
        _PPFRecord_interOperatorIdentifiers,
        _PPFRecord_localRecordSequenceNumber,
        _PPFRecord_recordSequenceNumber,
        _PPFRecord_causeForRecordClosing,
        _PPFRecord_incomplete_CDR_Indication,
        _PPFRecord_iMS_Charging_Identifier,
        __PPFRecord_list_Of_SDP_Media_Components__item_,
        _PPFRecord_list_Of_SDP_Media_Components,
        _PPFRecord_gGSNaddress,
        _PPFRecord_serviceReasonReturnCode,
        __PPFRecord_list_Of_Message_Bodies__item_,
        _PPFRecord_list_Of_Message_Bodies,
        _PPFRecord_userLocationInfo,
        _PPFRecord_poCInformation,
        _PPFRecord_recordExtensions,
        _PPFRecord_serviceContextID,
        PPFRecord,
        _CPFRecord_recordType,
        _CPFRecord_retransmission,
        _CPFRecord_sIP_Method,
        _CPFRecord_nodeAddress,
        _CPFRecord_session_Id,
        _CPFRecord_calling_Party_Address,
        _CPFRecord_called_Party_Address,
        _CPFRecord_servedParty,
        _CPFRecord_serviceRequestTimeStamp,
        _CPFRecord_serviceDeliveryStartTimeStamp,
        _CPFRecord_serviceDeliveryEndTimeStamp,
        _CPFRecord_recordOpeningTime,
        _CPFRecord_recordClosureTime,
        _CPFRecord_interOperatorIdentifiers,
        _CPFRecord_localRecordSequenceNumber,
        _CPFRecord_recordSequenceNumber,
        _CPFRecord_causeForRecordClosing,
        _CPFRecord_incomplete_CDR_Indication,
        _CPFRecord_iMS_Charging_Identifier,
        __CPFRecord_list_Of_SDP_Media_Components__item_,
        _CPFRecord_list_Of_SDP_Media_Components,
        _CPFRecord_gGSNaddress,
        _CPFRecord_serviceReasonReturnCode,
        __CPFRecord_list_Of_Message_Bodies__item_,
        _CPFRecord_list_Of_Message_Bodies,
        _CPFRecord_userLocationInfo,
        _CPFRecord_poCInformation,
        _CPFRecord_recordExtensions,
        _CPFRecord_serviceContextID,
        CPFRecord,
        AccessPriority,
        CauseForRecordClosing,
        ChangeCondition,
        _ListofTalkBurstExchange_number_Of_Talk_Bursts,
        _ListofTalkBurstExchange_talk_Burst_Volume,
        _ListofTalkBurstExchange_talk_Bursts_Time,
        _ListofTalkBurstExchange_number_Of_Received_Talk_Bursts,
        _ListofTalkBurstExchange_received_Talk_Burst_Volume,
        _ListofTalkBurstExchange_received_Talk_Burst_Time,
        _ListofTalkBurstExchange_changeCondition,
        _ListofTalkBurstExchange_changeTime,
        _ListofTalkBurstExchange_numberofParticipants,
        ListofTalkBurstExchange,
        ParticipatingType,
        POCEventType,
        _POCInformation_pOCSessionType,
        _POCInformation_numberofParticipants,
        __POCInformation_listofParticipants__item_,
        _POCInformation_listofParticipants,
        __POCInformation_listofTalkBurstExchange__item_,
        _POCInformation_listofTalkBurstExchange,
        _POCInformation_pOCControllingAddress,
        _POCInformation_pOCGroupName,
        _POCInformation_pOCSessionId,
        _POCInformation_pOCSessionInitiationType,
        _POCInformation_pOCEventType,
        POCInformation,
        _POCParticipant_called_party_address,
        _POCParticipant_participant_access_priority,
        _POCParticipant_user_participating_type,
        POCParticipant,
        POCSessionInitType,
        POCSessionType,
    ]

class ProSeChargingDataTypes:

    _name_  = u'ProSeChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 11, 0, 1]
    
    _obj_ = [
        u'ProSeRecordType',
        u'PFDDRecord',
        u'PFEDRecord',
        u'PFDCRecord',
        u'AppSpecificData',
        u'ChangeOfProSeCondition',
        u'CoverageInfo',
        u'CoverageStatus',
        u'LocationInfo',
        u'PC5RadioTechnology',
        u'ProSeCauseForRecClosing',
        u'ProSeEventType',
        u'ProSeFunctionRole',
        u'ProSeUERole',
        u'ProximityAlertIndication',
        u'ProximityRequestRenewalInfoBlock',
        u'RadioFrequency',
        u'RadioParameterSetInfo',
        u'RadioResourcesIndicator',
        u'RangeClass',
        u'ReasonforCancellation',
        u'ServiceChangeCondition',
        u'TransmitterInfo',
        ]
    _type_ = [
        u'ProSeRecordType',
        u'PFDDRecord',
        u'PFEDRecord',
        u'PFDCRecord',
        u'AppSpecificData',
        u'ChangeOfProSeCondition',
        u'CoverageInfo',
        u'CoverageStatus',
        u'LocationInfo',
        u'PC5RadioTechnology',
        u'ProSeCauseForRecClosing',
        u'ProSeEventType',
        u'ProSeFunctionRole',
        u'ProSeUERole',
        u'ProximityAlertIndication',
        u'ProximityRequestRenewalInfoBlock',
        u'RadioFrequency',
        u'RadioParameterSetInfo',
        u'RadioResourcesIndicator',
        u'RangeClass',
        u'ReasonforCancellation',
        u'ServiceChangeCondition',
        u'TransmitterInfo',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< ProSeRecordType >-----#
    ProSeRecordType = CHOICE(name=u'ProSeRecordType', mode=MODE_TYPE)
    _ProSeRecordType_pFDDRecord = SET(name=u'pFDDRecord', mode=MODE_TYPE, tag=(100, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'PFDDRecord')))
    _ProSeRecordType_pFEDRecord = SET(name=u'pFEDRecord', mode=MODE_TYPE, tag=(101, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'PFEDRecord')))
    _ProSeRecordType_pFDCRecord = SET(name=u'pFDCRecord', mode=MODE_TYPE, tag=(102, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'PFDCRecord')))
    ProSeRecordType._cont = ASN1Dict([
        (u'pFDDRecord', _ProSeRecordType_pFDDRecord),
        (u'pFEDRecord', _ProSeRecordType_pFEDRecord),
        (u'pFDCRecord', _ProSeRecordType_pFDCRecord),
        ])
    ProSeRecordType._ext = None
    
    #-----< PFDDRecord >-----#
    PFDDRecord = SET(name=u'PFDDRecord', mode=MODE_TYPE)
    _PFDDRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _PFDDRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDDRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _PFDDRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _PFDDRecord_proSeFunctionIPAddress = CHOICE(name=u'proSeFunctionIPAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _PFDDRecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _PFDDRecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _PFDDRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _PFDDRecord_proSeRequestTimestamp = OCT_STR(name=u'proSeRequestTimestamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFDDRecord_roleofUE = ENUM(name=u'roleofUE', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProSeUERole')), opt=True)
    _PFDDRecord_pCThreeControlProtocolCause = INT(name=u'pCThreeControlProtocolCause', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDDRecord_roleofProSeFunction = ENUM(name=u'roleofProSeFunction', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProSeFunctionRole')), opt=True)
    _PFDDRecord_proSeApplicationID = STR_UTF8(name=u'proSeApplicationID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDDRecord_proSeEventType = ENUM(name=u'proSeEventType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProSeEventType')), opt=True)
    _PFDDRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _PFDDRecord_proseFunctionId = STR_UTF8(name=u'proseFunctionId', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDDRecord_announcingUEHPLMNIdentifier = OCT_STR(name=u'announcingUEHPLMNIdentifier', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_announcingUEVPLMNIdentifier = OCT_STR(name=u'announcingUEVPLMNIdentifier', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_monitoringUEHPLMNIdentifier = OCT_STR(name=u'monitoringUEHPLMNIdentifier', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_monitoringUEVPLMNIdentifier = OCT_STR(name=u'monitoringUEVPLMNIdentifier', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_monitoredPLMNIdentifier = OCT_STR(name=u'monitoredPLMNIdentifier', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_applicationID = STR_UTF8(name=u'applicationID', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDDRecord_directDiscoveryModel = STR_UTF8(name=u'directDiscoveryModel', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDDRecord_validityPeriod = INT(name=u'validityPeriod', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDDRecord_monitoringUEIdentifier = OCT_STR(name=u'monitoringUEIdentifier', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _PFDDRecord_discovererUEHPLMNIdentifier = OCT_STR(name=u'discovererUEHPLMNIdentifier', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_discovererUEVPLMNIdentifier = OCT_STR(name=u'discovererUEVPLMNIdentifier', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_discovereeUEHPLMNIdentifier = OCT_STR(name=u'discovereeUEHPLMNIdentifier', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_discovereeUEVPLMNIdentifier = OCT_STR(name=u'discovereeUEVPLMNIdentifier', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_announcingPLMNID = OCT_STR(name=u'announcingPLMNID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDDRecord_pc5RadioTechnology = ENUM(name=u'pc5RadioTechnology', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'PC5RadioTechnology')), opt=True)
    PFDDRecord._cont = ASN1Dict([
        (u'recordType', _PFDDRecord_recordType),
        (u'retransmission', _PFDDRecord_retransmission),
        (u'serviceContextID', _PFDDRecord_serviceContextID),
        (u'servedIMSI', _PFDDRecord_servedIMSI),
        (u'proSeFunctionIPAddress', _PFDDRecord_proSeFunctionIPAddress),
        (u'chargingCharacteristics', _PFDDRecord_chargingCharacteristics),
        (u'chChSelectionMode', _PFDDRecord_chChSelectionMode),
        (u'recordExtensions', _PFDDRecord_recordExtensions),
        (u'proSeRequestTimestamp', _PFDDRecord_proSeRequestTimestamp),
        (u'roleofUE', _PFDDRecord_roleofUE),
        (u'pCThreeControlProtocolCause', _PFDDRecord_pCThreeControlProtocolCause),
        (u'roleofProSeFunction', _PFDDRecord_roleofProSeFunction),
        (u'proSeApplicationID', _PFDDRecord_proSeApplicationID),
        (u'proSeEventType', _PFDDRecord_proSeEventType),
        (u'nodeID', _PFDDRecord_nodeID),
        (u'proseFunctionId', _PFDDRecord_proseFunctionId),
        (u'announcingUEHPLMNIdentifier', _PFDDRecord_announcingUEHPLMNIdentifier),
        (u'announcingUEVPLMNIdentifier', _PFDDRecord_announcingUEVPLMNIdentifier),
        (u'monitoringUEHPLMNIdentifier', _PFDDRecord_monitoringUEHPLMNIdentifier),
        (u'monitoringUEVPLMNIdentifier', _PFDDRecord_monitoringUEVPLMNIdentifier),
        (u'monitoredPLMNIdentifier', _PFDDRecord_monitoredPLMNIdentifier),
        (u'applicationID', _PFDDRecord_applicationID),
        (u'directDiscoveryModel', _PFDDRecord_directDiscoveryModel),
        (u'validityPeriod', _PFDDRecord_validityPeriod),
        (u'monitoringUEIdentifier', _PFDDRecord_monitoringUEIdentifier),
        (u'discovererUEHPLMNIdentifier', _PFDDRecord_discovererUEHPLMNIdentifier),
        (u'discovererUEVPLMNIdentifier', _PFDDRecord_discovererUEVPLMNIdentifier),
        (u'discovereeUEHPLMNIdentifier', _PFDDRecord_discovereeUEHPLMNIdentifier),
        (u'discovereeUEVPLMNIdentifier', _PFDDRecord_discovereeUEVPLMNIdentifier),
        (u'announcingPLMNID', _PFDDRecord_announcingPLMNID),
        (u'pc5RadioTechnology', _PFDDRecord_pc5RadioTechnology),
        ])
    PFDDRecord._ext = None
    
    #-----< PFEDRecord >-----#
    PFEDRecord = SET(name=u'PFEDRecord', mode=MODE_TYPE)
    _PFEDRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _PFEDRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _PFEDRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _PFEDRecord_proSeFunctionIPAddress = CHOICE(name=u'proSeFunctionIPAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _PFEDRecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _PFEDRecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _PFEDRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _PFEDRecord_proSeRequestTimestamp = OCT_STR(name=u'proSeRequestTimestamp', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFEDRecord_roleofUE = ENUM(name=u'roleofUE', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProSeUERole')), opt=True)
    _PFEDRecord_pCThreeEPCControlProtocolCause = INT(name=u'pCThreeEPCControlProtocolCause', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_proseFunctionPLMNIdentifier = OCT_STR(name=u'proseFunctionPLMNIdentifier', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFEDRecord_proseFunctionId = STR_UTF8(name=u'proseFunctionId', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFEDRecord_recordClosureTime = OCT_STR(name=u'recordClosureTime', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFEDRecord_applicationID = STR_UTF8(name=u'applicationID', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_requestorApplicationLayerUserID = STR_UTF8(name=u'requestorApplicationLayerUserID', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_wLANLinkLayerID = STR_UTF8(name=u'wLANLinkLayerID', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_requestorEPCProSeUserID = STR_UTF8(name=u'requestorEPCProSeUserID', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_requestedApplicationLayerUserID = STR_UTF8(name=u'requestedApplicationLayerUserID', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_requestedPLMNIdentifier = OCT_STR(name=u'requestedPLMNIdentifier', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFEDRecord_timeWindow = INT(name=u'timeWindow', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_rangeClass = ENUM(name=u'rangeClass', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'RangeClass')), opt=True)
    _PFEDRecord_uELocation = OCT_STR(name=u'uELocation', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFEDRecord_proximityAlertIndication = ENUM(name=u'proximityAlertIndication', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProximityAlertIndication')), opt=True)
    _PFEDRecord_proximityAlertTimestamp = OCT_STR(name=u'proximityAlertTimestamp', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFEDRecord_proximityCancellationTimestamp = OCT_STR(name=u'proximityCancellationTimestamp', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFEDRecord_reasonforCancellation = ENUM(name=u'reasonforCancellation', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ReasonforCancellation')), opt=True)
    _PFEDRecord_causeForRecClosing = ENUM(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProSeCauseForRecClosing')))
    _PFEDRecord_proximityRequestRenewalInfoBlockList = SEQ_OF(name=u'proximityRequestRenewalInfoBlockList', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PFEDRecord_proximityRequestRenewalInfoBlockList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProximityRequestRenewalInfoBlock')))
    _PFEDRecord_proximityRequestRenewalInfoBlockList._cont = __PFEDRecord_proximityRequestRenewalInfoBlockList__item_
    PFEDRecord._cont = ASN1Dict([
        (u'recordType', _PFEDRecord_recordType),
        (u'retransmission', _PFEDRecord_retransmission),
        (u'serviceContextID', _PFEDRecord_serviceContextID),
        (u'servedIMSI', _PFEDRecord_servedIMSI),
        (u'proSeFunctionIPAddress', _PFEDRecord_proSeFunctionIPAddress),
        (u'chargingCharacteristics', _PFEDRecord_chargingCharacteristics),
        (u'chChSelectionMode', _PFEDRecord_chChSelectionMode),
        (u'recordExtensions', _PFEDRecord_recordExtensions),
        (u'proSeRequestTimestamp', _PFEDRecord_proSeRequestTimestamp),
        (u'roleofUE', _PFEDRecord_roleofUE),
        (u'pCThreeEPCControlProtocolCause', _PFEDRecord_pCThreeEPCControlProtocolCause),
        (u'proseFunctionPLMNIdentifier', _PFEDRecord_proseFunctionPLMNIdentifier),
        (u'proseFunctionId', _PFEDRecord_proseFunctionId),
        (u'recordOpeningTime', _PFEDRecord_recordOpeningTime),
        (u'recordClosureTime', _PFEDRecord_recordClosureTime),
        (u'applicationID', _PFEDRecord_applicationID),
        (u'requestorApplicationLayerUserID', _PFEDRecord_requestorApplicationLayerUserID),
        (u'wLANLinkLayerID', _PFEDRecord_wLANLinkLayerID),
        (u'requestorEPCProSeUserID', _PFEDRecord_requestorEPCProSeUserID),
        (u'requestedApplicationLayerUserID', _PFEDRecord_requestedApplicationLayerUserID),
        (u'requestedPLMNIdentifier', _PFEDRecord_requestedPLMNIdentifier),
        (u'timeWindow', _PFEDRecord_timeWindow),
        (u'rangeClass', _PFEDRecord_rangeClass),
        (u'uELocation', _PFEDRecord_uELocation),
        (u'proximityAlertIndication', _PFEDRecord_proximityAlertIndication),
        (u'proximityAlertTimestamp', _PFEDRecord_proximityAlertTimestamp),
        (u'proximityCancellationTimestamp', _PFEDRecord_proximityCancellationTimestamp),
        (u'reasonforCancellation', _PFEDRecord_reasonforCancellation),
        (u'causeForRecClosing', _PFEDRecord_causeForRecClosing),
        (u'proximityRequestRenewalInfoBlockList', _PFEDRecord_proximityRequestRenewalInfoBlockList),
        ])
    PFEDRecord._ext = None
    
    #-----< PFDCRecord >-----#
    PFDCRecord = SET(name=u'PFDCRecord', mode=MODE_TYPE)
    _PFDCRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _PFDCRecord_retransmission = NULL(name=u'retransmission', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDCRecord_serviceContextID = STR_UTF8(name=u'serviceContextID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ServiceContextID')), opt=True)
    _PFDCRecord_servedIMSI = OCT_STR(name=u'servedIMSI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _PFDCRecord_proSeFunctionIPAddress = CHOICE(name=u'proSeFunctionIPAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _PFDCRecord_chargingCharacteristics = OCT_STR(name=u'chargingCharacteristics', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChargingCharacteristics')))
    _PFDCRecord_chChSelectionMode = ENUM(name=u'chChSelectionMode', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'ChChSelectionMode')), opt=True)
    _PFDCRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    _PFDCRecord_nodeID = STR_IA5(name=u'nodeID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeID')), opt=True)
    _PFDCRecord_proseFunctionPLMNIdentifier = OCT_STR(name=u'proseFunctionPLMNIdentifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    _PFDCRecord_proseFunctionId = STR_UTF8(name=u'proseFunctionId', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDCRecord_recordOpeningTime = OCT_STR(name=u'recordOpeningTime', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFDCRecord_recordClosureTime = OCT_STR(name=u'recordClosureTime', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFDCRecord_listOfCoverageInfo = SEQ_OF(name=u'listOfCoverageInfo', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PFDCRecord_listOfCoverageInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'CoverageInfo')))
    _PFDCRecord_listOfCoverageInfo._cont = __PFDCRecord_listOfCoverageInfo__item_
    _PFDCRecord_listOfRadioParameterSet = SEQ_OF(name=u'listOfRadioParameterSet', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PFDCRecord_listOfRadioParameterSet__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'RadioParameterSetInfo')))
    _PFDCRecord_listOfRadioParameterSet._cont = __PFDCRecord_listOfRadioParameterSet__item_
    _PFDCRecord_proSeUEID = OCT_STR(name=u'proSeUEID', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDCRecord_sourceIPaddress = CHOICE(name=u'sourceIPaddress', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _PFDCRecord_layerTwoGroupID = OCT_STR(name=u'layerTwoGroupID', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDCRecord_proSeGroupIPmulticastaddress = CHOICE(name=u'proSeGroupIPmulticastaddress', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _PFDCRecord_timeOfFirstTransmission = OCT_STR(name=u'timeOfFirstTransmission', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFDCRecord_timeOfFirstReception = OCT_STR(name=u'timeOfFirstReception', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _PFDCRecord_listOfTransmitters = SEQ_OF(name=u'listOfTransmitters', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PFDCRecord_listOfTransmitters__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'TransmitterInfo')))
    _PFDCRecord_listOfTransmitters._cont = __PFDCRecord_listOfTransmitters__item_
    _PFDCRecord_listOfTransmissionData = SEQ_OF(name=u'listOfTransmissionData', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PFDCRecord_listOfTransmissionData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'ChangeOfProSeCondition')))
    _PFDCRecord_listOfTransmissionData._cont = __PFDCRecord_listOfTransmissionData__item_
    _PFDCRecord_listOfReceptionData = SEQ_OF(name=u'listOfReceptionData', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PFDCRecord_listOfReceptionData__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'ChangeOfProSeCondition')))
    _PFDCRecord_listOfReceptionData._cont = __PFDCRecord_listOfReceptionData__item_
    _PFDCRecord_causeForRecClosing = ENUM(name=u'causeForRecClosing', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ProSeCauseForRecClosing')))
    _PFDCRecord_listOfAppSpecificData = SEQ_OF(name=u'listOfAppSpecificData', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PFDCRecord_listOfAppSpecificData__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'AppSpecificData')))
    _PFDCRecord_listOfAppSpecificData._cont = __PFDCRecord_listOfAppSpecificData__item_
    _PFDCRecord_targetIPaddress = CHOICE(name=u'targetIPaddress', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _PFDCRecord_relayIPaddress = CHOICE(name=u'relayIPaddress', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')), opt=True)
    _PFDCRecord_proSeUEtoNetworkRelayUEID = OCT_STR(name=u'proSeUEtoNetworkRelayUEID', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PFDCRecord_proSeTargetLayerTwoID = OCT_STR(name=u'proSeTargetLayerTwoID', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PFDCRecord._cont = ASN1Dict([
        (u'recordType', _PFDCRecord_recordType),
        (u'retransmission', _PFDCRecord_retransmission),
        (u'serviceContextID', _PFDCRecord_serviceContextID),
        (u'servedIMSI', _PFDCRecord_servedIMSI),
        (u'proSeFunctionIPAddress', _PFDCRecord_proSeFunctionIPAddress),
        (u'chargingCharacteristics', _PFDCRecord_chargingCharacteristics),
        (u'chChSelectionMode', _PFDCRecord_chChSelectionMode),
        (u'recordExtensions', _PFDCRecord_recordExtensions),
        (u'nodeID', _PFDCRecord_nodeID),
        (u'proseFunctionPLMNIdentifier', _PFDCRecord_proseFunctionPLMNIdentifier),
        (u'proseFunctionId', _PFDCRecord_proseFunctionId),
        (u'recordOpeningTime', _PFDCRecord_recordOpeningTime),
        (u'recordClosureTime', _PFDCRecord_recordClosureTime),
        (u'listOfCoverageInfo', _PFDCRecord_listOfCoverageInfo),
        (u'listOfRadioParameterSet', _PFDCRecord_listOfRadioParameterSet),
        (u'proSeUEID', _PFDCRecord_proSeUEID),
        (u'sourceIPaddress', _PFDCRecord_sourceIPaddress),
        (u'layerTwoGroupID', _PFDCRecord_layerTwoGroupID),
        (u'proSeGroupIPmulticastaddress', _PFDCRecord_proSeGroupIPmulticastaddress),
        (u'timeOfFirstTransmission', _PFDCRecord_timeOfFirstTransmission),
        (u'timeOfFirstReception', _PFDCRecord_timeOfFirstReception),
        (u'listOfTransmitters', _PFDCRecord_listOfTransmitters),
        (u'listOfTransmissionData', _PFDCRecord_listOfTransmissionData),
        (u'listOfReceptionData', _PFDCRecord_listOfReceptionData),
        (u'causeForRecClosing', _PFDCRecord_causeForRecClosing),
        (u'listOfAppSpecificData', _PFDCRecord_listOfAppSpecificData),
        (u'targetIPaddress', _PFDCRecord_targetIPaddress),
        (u'relayIPaddress', _PFDCRecord_relayIPaddress),
        (u'proSeUEtoNetworkRelayUEID', _PFDCRecord_proSeUEtoNetworkRelayUEID),
        (u'proSeTargetLayerTwoID', _PFDCRecord_proSeTargetLayerTwoID),
        ])
    PFDCRecord._ext = None
    
    #-----< AppSpecificData >-----#
    AppSpecificData = OCT_STR(name=u'AppSpecificData', mode=MODE_TYPE)
    
    #-----< ChangeOfProSeCondition >-----#
    ChangeOfProSeCondition = SEQ(name=u'ChangeOfProSeCondition', mode=MODE_TYPE)
    _ChangeOfProSeCondition_changeConditionTimestamp = OCT_STR(name=u'changeConditionTimestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ChangeOfProSeCondition_coverageStatus = ENUM(name=u'coverageStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'CoverageStatus')), opt=True)
    _ChangeOfProSeCondition_uELocation = OCT_STR(name=u'uELocation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ChangeOfProSeCondition_dataVolume = INT(name=u'dataVolume', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GPRSChargingDataTypes', 'DataVolumeGPRS')), opt=True)
    _ChangeOfProSeCondition_serviceChangeCondition = BIT_STR(name=u'serviceChangeCondition', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'ServiceChangeCondition')), opt=True)
    _ChangeOfProSeCondition_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ChangeOfProSeCondition_usageInformationReportSequenceNumber = INT(name=u'usageInformationReportSequenceNumber', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ChangeOfProSeCondition_radioResourcesInd = INT(name=u'radioResourcesInd', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'RadioResourcesIndicator')), opt=True)
    _ChangeOfProSeCondition_radiofrequency = OCT_STR(name=u'radiofrequency', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'RadioFrequency')), opt=True)
    _ChangeOfProSeCondition_vPLMNIdentifier = OCT_STR(name=u'vPLMNIdentifier', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    ChangeOfProSeCondition._cont = ASN1Dict([
        (u'changeConditionTimestamp', _ChangeOfProSeCondition_changeConditionTimestamp),
        (u'coverageStatus', _ChangeOfProSeCondition_coverageStatus),
        (u'uELocation', _ChangeOfProSeCondition_uELocation),
        (u'dataVolume', _ChangeOfProSeCondition_dataVolume),
        (u'serviceChangeCondition', _ChangeOfProSeCondition_serviceChangeCondition),
        (u'localSequenceNumber', _ChangeOfProSeCondition_localSequenceNumber),
        (u'usageInformationReportSequenceNumber', _ChangeOfProSeCondition_usageInformationReportSequenceNumber),
        (u'radioResourcesInd', _ChangeOfProSeCondition_radioResourcesInd),
        (u'radiofrequency', _ChangeOfProSeCondition_radiofrequency),
        (u'vPLMNIdentifier', _ChangeOfProSeCondition_vPLMNIdentifier),
        ])
    ChangeOfProSeCondition._ext = None
    
    #-----< CoverageInfo >-----#
    CoverageInfo = SEQ(name=u'CoverageInfo', mode=MODE_TYPE)
    _CoverageInfo_coverageStatus = ENUM(name=u'coverageStatus', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'CoverageStatus')))
    _CoverageInfo_timeStamp = OCT_STR(name=u'timeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _CoverageInfo_listOfLocation = SEQ_OF(name=u'listOfLocation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CoverageInfo_listOfLocation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ProSeChargingDataTypes', 'LocationInfo')))
    _CoverageInfo_listOfLocation._cont = __CoverageInfo_listOfLocation__item_
    CoverageInfo._cont = ASN1Dict([
        (u'coverageStatus', _CoverageInfo_coverageStatus),
        (u'timeStamp', _CoverageInfo_timeStamp),
        (u'listOfLocation', _CoverageInfo_listOfLocation),
        ])
    CoverageInfo._ext = None
    
    #-----< CoverageStatus >-----#
    CoverageStatus = ENUM(name=u'CoverageStatus', mode=MODE_TYPE)
    CoverageStatus._cont = ASN1Dict([(u'outOfCoverage', 0), (u'inCoverage', 1)])
    CoverageStatus._ext = None
    
    #-----< LocationInfo >-----#
    LocationInfo = SEQ(name=u'LocationInfo', mode=MODE_TYPE)
    _LocationInfo_uELocation = OCT_STR(name=u'uELocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationInfo_timeStamp = OCT_STR(name=u'timeStamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    LocationInfo._cont = ASN1Dict([
        (u'uELocation', _LocationInfo_uELocation),
        (u'timeStamp', _LocationInfo_timeStamp),
        ])
    LocationInfo._ext = None
    
    #-----< PC5RadioTechnology >-----#
    PC5RadioTechnology = ENUM(name=u'PC5RadioTechnology', mode=MODE_TYPE)
    PC5RadioTechnology._cont = ASN1Dict([(u'eUTRA', 0), (u'wLAN', 1), (u'bothEUTRAAndWLAN', 2)])
    PC5RadioTechnology._ext = None
    
    #-----< ProSeCauseForRecClosing >-----#
    ProSeCauseForRecClosing = ENUM(name=u'ProSeCauseForRecClosing', mode=MODE_TYPE)
    ProSeCauseForRecClosing._cont = ASN1Dict([(u'proximityAlerted', 0), (u'timeExpiredWithNoRrenewal', 1), (u'requestorCancellation', 2), (u'timeLimited', 3), (u'maxNumberOfReports', 4), (u'abnormalRelease', 5)])
    ProSeCauseForRecClosing._ext = None
    
    #-----< ProSeEventType >-----#
    ProSeEventType = ENUM(name=u'ProSeEventType', mode=MODE_TYPE)
    ProSeEventType._cont = ASN1Dict([(u'openAnnouncing', 0), (u'openMonitoring', 1), (u'openMatchReport', 2), (u'restrictedAnnouncing', 3), (u'restrictedMonitoring', 4), (u'restrictedMatchReport', 5), (u'restrictedDiscoveryRequest', 6), (u'restrictedDiscoveryReporting', 7)])
    ProSeEventType._ext = None
    
    #-----< ProSeFunctionRole >-----#
    ProSeFunctionRole = ENUM(name=u'ProSeFunctionRole', mode=MODE_TYPE)
    ProSeFunctionRole._cont = ASN1Dict([(u'hPLMN', 0), (u'vPLMN', 1), (u'localPLMN', 2)])
    ProSeFunctionRole._ext = None
    
    #-----< ProSeUERole >-----#
    ProSeUERole = ENUM(name=u'ProSeUERole', mode=MODE_TYPE)
    ProSeUERole._cont = ASN1Dict([(u'annoucingUE', 0), (u'monitoringUE', 1), (u'requestorUE', 2), (u'requestedUE', 3), (u'discovererUE', 4), (u'discovereeUE', 5)])
    ProSeUERole._ext = None
    
    #-----< ProximityAlertIndication >-----#
    ProximityAlertIndication = ENUM(name=u'ProximityAlertIndication', mode=MODE_TYPE)
    ProximityAlertIndication._cont = ASN1Dict([(u'alerted', 0), (u'noAlert', 1)])
    ProximityAlertIndication._ext = None
    
    #-----< ProximityRequestRenewalInfoBlock >-----#
    ProximityRequestRenewalInfoBlock = SEQ(name=u'ProximityRequestRenewalInfoBlock', mode=MODE_TYPE)
    _ProximityRequestRenewalInfoBlock_proSeRequestTimestamp = OCT_STR(name=u'proSeRequestTimestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ProximityRequestRenewalInfoBlock_timeWindow = INT(name=u'timeWindow', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ProximityRequestRenewalInfoBlock_rangeClass = ENUM(name=u'rangeClass', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ProSeChargingDataTypes', 'RangeClass')), opt=True)
    _ProximityRequestRenewalInfoBlock_uELocation = OCT_STR(name=u'uELocation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ProximityRequestRenewalInfoBlock._cont = ASN1Dict([
        (u'proSeRequestTimestamp', _ProximityRequestRenewalInfoBlock_proSeRequestTimestamp),
        (u'timeWindow', _ProximityRequestRenewalInfoBlock_timeWindow),
        (u'rangeClass', _ProximityRequestRenewalInfoBlock_rangeClass),
        (u'uELocation', _ProximityRequestRenewalInfoBlock_uELocation),
        ])
    ProximityRequestRenewalInfoBlock._ext = None
    
    #-----< RadioFrequency >-----#
    RadioFrequency = OCT_STR(name=u'RadioFrequency', mode=MODE_TYPE)
    
    #-----< RadioParameterSetInfo >-----#
    RadioParameterSetInfo = SEQ(name=u'RadioParameterSetInfo', mode=MODE_TYPE)
    _RadioParameterSetInfo_timeStamp = OCT_STR(name=u'timeStamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _RadioParameterSetInfo_params = OCT_STR(name=u'params', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    RadioParameterSetInfo._cont = ASN1Dict([
        (u'timeStamp', _RadioParameterSetInfo_timeStamp),
        (u'params', _RadioParameterSetInfo_params),
        ])
    RadioParameterSetInfo._ext = None
    
    #-----< RadioResourcesIndicator >-----#
    RadioResourcesIndicator = INT(name=u'RadioResourcesIndicator', mode=MODE_TYPE)
    RadioResourcesIndicator._cont = ASN1Dict([(u'operatorProvided', 1), (u'configured', 2)])
    
    #-----< RangeClass >-----#
    RangeClass = ENUM(name=u'RangeClass', mode=MODE_TYPE)
    RangeClass._cont = ASN1Dict([(u'reserved', 0), (u'fiftyMeter', 1), (u'onehundredMeter', 2), (u'twohundredMeter', 3), (u'fivehundredMeter', 4), (u'onethousandMeter', 5)])
    RangeClass._ext = None
    
    #-----< ReasonforCancellation >-----#
    ReasonforCancellation = ENUM(name=u'ReasonforCancellation', mode=MODE_TYPE)
    ReasonforCancellation._cont = ASN1Dict([(u'proximityAlerted', 0), (u'timeExpiredWithNoRrenewal', 1), (u'requestorCancellation', 2)])
    ReasonforCancellation._ext = None
    
    #-----< ServiceChangeCondition >-----#
    ServiceChangeCondition = BIT_STR(name=u'ServiceChangeCondition', mode=MODE_TYPE)
    ServiceChangeCondition._cont = ASN1Dict([(u'pLMNchange', 0), (u'coverageStatusChange', 1), (u'locationChange', 2)])
    
    #-----< TransmitterInfo >-----#
    TransmitterInfo = SEQ(name=u'TransmitterInfo', mode=MODE_TYPE)
    _TransmitterInfo_sourceIPaddress = CHOICE(name=u'sourceIPaddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'IPAddress')))
    _TransmitterInfo_proSeUEID = OCT_STR(name=u'proSeUEID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    TransmitterInfo._cont = ASN1Dict([
        (u'sourceIPaddress', _TransmitterInfo_sourceIPaddress),
        (u'proSeUEID', _TransmitterInfo_proSeUEID),
        ])
    TransmitterInfo._ext = None
    
    _all_ = [
        _ProSeRecordType_pFDDRecord,
        _ProSeRecordType_pFEDRecord,
        _ProSeRecordType_pFDCRecord,
        ProSeRecordType,
        _PFDDRecord_recordType,
        _PFDDRecord_retransmission,
        _PFDDRecord_serviceContextID,
        _PFDDRecord_servedIMSI,
        _PFDDRecord_proSeFunctionIPAddress,
        _PFDDRecord_chargingCharacteristics,
        _PFDDRecord_chChSelectionMode,
        _PFDDRecord_recordExtensions,
        _PFDDRecord_proSeRequestTimestamp,
        _PFDDRecord_roleofUE,
        _PFDDRecord_pCThreeControlProtocolCause,
        _PFDDRecord_roleofProSeFunction,
        _PFDDRecord_proSeApplicationID,
        _PFDDRecord_proSeEventType,
        _PFDDRecord_nodeID,
        _PFDDRecord_proseFunctionId,
        _PFDDRecord_announcingUEHPLMNIdentifier,
        _PFDDRecord_announcingUEVPLMNIdentifier,
        _PFDDRecord_monitoringUEHPLMNIdentifier,
        _PFDDRecord_monitoringUEVPLMNIdentifier,
        _PFDDRecord_monitoredPLMNIdentifier,
        _PFDDRecord_applicationID,
        _PFDDRecord_directDiscoveryModel,
        _PFDDRecord_validityPeriod,
        _PFDDRecord_monitoringUEIdentifier,
        _PFDDRecord_discovererUEHPLMNIdentifier,
        _PFDDRecord_discovererUEVPLMNIdentifier,
        _PFDDRecord_discovereeUEHPLMNIdentifier,
        _PFDDRecord_discovereeUEVPLMNIdentifier,
        _PFDDRecord_announcingPLMNID,
        _PFDDRecord_pc5RadioTechnology,
        PFDDRecord,
        _PFEDRecord_recordType,
        _PFEDRecord_retransmission,
        _PFEDRecord_serviceContextID,
        _PFEDRecord_servedIMSI,
        _PFEDRecord_proSeFunctionIPAddress,
        _PFEDRecord_chargingCharacteristics,
        _PFEDRecord_chChSelectionMode,
        _PFEDRecord_recordExtensions,
        _PFEDRecord_proSeRequestTimestamp,
        _PFEDRecord_roleofUE,
        _PFEDRecord_pCThreeEPCControlProtocolCause,
        _PFEDRecord_proseFunctionPLMNIdentifier,
        _PFEDRecord_proseFunctionId,
        _PFEDRecord_recordOpeningTime,
        _PFEDRecord_recordClosureTime,
        _PFEDRecord_applicationID,
        _PFEDRecord_requestorApplicationLayerUserID,
        _PFEDRecord_wLANLinkLayerID,
        _PFEDRecord_requestorEPCProSeUserID,
        _PFEDRecord_requestedApplicationLayerUserID,
        _PFEDRecord_requestedPLMNIdentifier,
        _PFEDRecord_timeWindow,
        _PFEDRecord_rangeClass,
        _PFEDRecord_uELocation,
        _PFEDRecord_proximityAlertIndication,
        _PFEDRecord_proximityAlertTimestamp,
        _PFEDRecord_proximityCancellationTimestamp,
        _PFEDRecord_reasonforCancellation,
        _PFEDRecord_causeForRecClosing,
        __PFEDRecord_proximityRequestRenewalInfoBlockList__item_,
        _PFEDRecord_proximityRequestRenewalInfoBlockList,
        PFEDRecord,
        _PFDCRecord_recordType,
        _PFDCRecord_retransmission,
        _PFDCRecord_serviceContextID,
        _PFDCRecord_servedIMSI,
        _PFDCRecord_proSeFunctionIPAddress,
        _PFDCRecord_chargingCharacteristics,
        _PFDCRecord_chChSelectionMode,
        _PFDCRecord_recordExtensions,
        _PFDCRecord_nodeID,
        _PFDCRecord_proseFunctionPLMNIdentifier,
        _PFDCRecord_proseFunctionId,
        _PFDCRecord_recordOpeningTime,
        _PFDCRecord_recordClosureTime,
        __PFDCRecord_listOfCoverageInfo__item_,
        _PFDCRecord_listOfCoverageInfo,
        __PFDCRecord_listOfRadioParameterSet__item_,
        _PFDCRecord_listOfRadioParameterSet,
        _PFDCRecord_proSeUEID,
        _PFDCRecord_sourceIPaddress,
        _PFDCRecord_layerTwoGroupID,
        _PFDCRecord_proSeGroupIPmulticastaddress,
        _PFDCRecord_timeOfFirstTransmission,
        _PFDCRecord_timeOfFirstReception,
        __PFDCRecord_listOfTransmitters__item_,
        _PFDCRecord_listOfTransmitters,
        __PFDCRecord_listOfTransmissionData__item_,
        _PFDCRecord_listOfTransmissionData,
        __PFDCRecord_listOfReceptionData__item_,
        _PFDCRecord_listOfReceptionData,
        _PFDCRecord_causeForRecClosing,
        __PFDCRecord_listOfAppSpecificData__item_,
        _PFDCRecord_listOfAppSpecificData,
        _PFDCRecord_targetIPaddress,
        _PFDCRecord_relayIPaddress,
        _PFDCRecord_proSeUEtoNetworkRelayUEID,
        _PFDCRecord_proSeTargetLayerTwoID,
        PFDCRecord,
        AppSpecificData,
        _ChangeOfProSeCondition_changeConditionTimestamp,
        _ChangeOfProSeCondition_coverageStatus,
        _ChangeOfProSeCondition_uELocation,
        _ChangeOfProSeCondition_dataVolume,
        _ChangeOfProSeCondition_serviceChangeCondition,
        _ChangeOfProSeCondition_localSequenceNumber,
        _ChangeOfProSeCondition_usageInformationReportSequenceNumber,
        _ChangeOfProSeCondition_radioResourcesInd,
        _ChangeOfProSeCondition_radiofrequency,
        _ChangeOfProSeCondition_vPLMNIdentifier,
        ChangeOfProSeCondition,
        _CoverageInfo_coverageStatus,
        _CoverageInfo_timeStamp,
        __CoverageInfo_listOfLocation__item_,
        _CoverageInfo_listOfLocation,
        CoverageInfo,
        CoverageStatus,
        _LocationInfo_uELocation,
        _LocationInfo_timeStamp,
        LocationInfo,
        PC5RadioTechnology,
        ProSeCauseForRecClosing,
        ProSeEventType,
        ProSeFunctionRole,
        ProSeUERole,
        ProximityAlertIndication,
        _ProximityRequestRenewalInfoBlock_proSeRequestTimestamp,
        _ProximityRequestRenewalInfoBlock_timeWindow,
        _ProximityRequestRenewalInfoBlock_rangeClass,
        _ProximityRequestRenewalInfoBlock_uELocation,
        ProximityRequestRenewalInfoBlock,
        RadioFrequency,
        _RadioParameterSetInfo_timeStamp,
        _RadioParameterSetInfo_params,
        RadioParameterSetInfo,
        RadioResourcesIndicator,
        RangeClass,
        ReasonforCancellation,
        ServiceChangeCondition,
        _TransmitterInfo_sourceIPaddress,
        _TransmitterInfo_proSeUEID,
        TransmitterInfo,
    ]

class Remote_Operations_Generic_ROS_PDUs:

    _name_  = u'Remote-Operations-Generic-ROS-PDUs'
    _oid_   = [2, 4, 6, 0]
    
    _obj_ = [
        u'ROS',
        u'Invoke',
        u'ReturnResult',
        u'ReturnError',
        u'Reject',
        u'GeneralProblem',
        u'InvokeProblem',
        u'ReturnResultProblem',
        u'ReturnErrorProblem',
        u'RejectProblem',
        u'InvokeId',
        u'noInvokeId',
        u'NoInvokeId',
        u'Errors',
        u'Bind',
        u'Unbind',
        ]
    _type_ = [
        u'ROS',
        u'Invoke',
        u'ReturnResult',
        u'ReturnError',
        u'Reject',
        u'GeneralProblem',
        u'InvokeProblem',
        u'ReturnResultProblem',
        u'ReturnErrorProblem',
        u'RejectProblem',
        u'InvokeId',
        u'Bind',
        u'Unbind',
        ]
    _set_ = [
        u'NoInvokeId',
        u'Errors',
        ]
    _val_ = [
        u'noInvokeId',
        ]
    _class_ = [
        u'Errors',
        ]
    _param_ = [
        u'ROS',
        u'Invoke',
        u'ReturnResult',
        u'ReturnError',
        u'Errors',
        u'Bind',
        u'Unbind',
        ]
    
    #-----< ROS >-----#
    ROS = CHOICE(name=u'ROS', mode=MODE_TYPE, param=True)
    
    #-----< Invoke >-----#
    Invoke = SEQ(name=u'Invoke', mode=MODE_TYPE, param=True)
    
    #-----< ReturnResult >-----#
    ReturnResult = SEQ(name=u'ReturnResult', mode=MODE_TYPE, param=True)
    
    #-----< ReturnError >-----#
    ReturnError = SEQ(name=u'ReturnError', mode=MODE_TYPE, param=True)
    
    #-----< Reject >-----#
    Reject = SEQ(name=u'Reject', mode=MODE_TYPE)
    _Reject_invokeId = CHOICE(name=u'invokeId', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    _Reject_problem = CHOICE(name=u'problem', mode=MODE_TYPE)
    __Reject_problem_general = INT(name=u'general', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'GeneralProblem')))
    __Reject_problem_invoke = INT(name=u'invoke', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeProblem')))
    __Reject_problem_returnResult = INT(name=u'returnResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnResultProblem')))
    __Reject_problem_returnError = INT(name=u'returnError', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ReturnErrorProblem')))
    _Reject_problem._cont = ASN1Dict([
        (u'general', __Reject_problem_general),
        (u'invoke', __Reject_problem_invoke),
        (u'returnResult', __Reject_problem_returnResult),
        (u'returnError', __Reject_problem_returnError),
        ])
    _Reject_problem._ext = None
    Reject._cont = ASN1Dict([
        (u'invokeId', _Reject_invokeId),
        (u'problem', _Reject_problem),
        ])
    Reject._ext = None
    
    #-----< GeneralProblem >-----#
    GeneralProblem = INT(name=u'GeneralProblem', mode=MODE_TYPE)
    GeneralProblem._cont = ASN1Dict([(u'unrecognizedPDU', 0), (u'mistypedPDU', 1), (u'badlyStructuredPDU', 2)])
    
    #-----< InvokeProblem >-----#
    InvokeProblem = INT(name=u'InvokeProblem', mode=MODE_TYPE)
    InvokeProblem._cont = ASN1Dict([(u'duplicateInvocation', 0), (u'unrecognizedOperation', 1), (u'mistypedArgument', 2), (u'resourceLimitation', 3), (u'releaseInProgress', 4), (u'unrecognizedLinkedId', 5), (u'linkedResponseUnexpected', 6), (u'unexpectedLinkedOperation', 7)])
    
    #-----< ReturnResultProblem >-----#
    ReturnResultProblem = INT(name=u'ReturnResultProblem', mode=MODE_TYPE)
    ReturnResultProblem._cont = ASN1Dict([(u'unrecognizedInvocation', 0), (u'resultResponseUnexpected', 1), (u'mistypedResult', 2)])
    
    #-----< ReturnErrorProblem >-----#
    ReturnErrorProblem = INT(name=u'ReturnErrorProblem', mode=MODE_TYPE)
    ReturnErrorProblem._cont = ASN1Dict([(u'unrecognizedInvocation', 0), (u'errorResponseUnexpected', 1), (u'unrecognizedError', 2), (u'unexpectedError', 3), (u'mistypedParameter', 4)])
    
    #-----< RejectProblem >-----#
    RejectProblem = INT(name=u'RejectProblem', mode=MODE_TYPE)
    RejectProblem._cont = ASN1Dict([(u'general-unrecognizedPDU', 0), (u'general-mistypedPDU', 1), (u'general-badlyStructuredPDU', 2), (u'invoke-duplicateInvocation', 10), (u'invoke-unrecognizedOperation', 11), (u'invoke-mistypedArgument', 12), (u'invoke-resourceLimitation', 13), (u'invoke-releaseInProgress', 14), (u'invoke-unrecognizedLinkedId', 15), (u'invoke-linkedResponseUnexpected', 16), (u'invoke-unexpectedLinkedOperation', 17), (u'returnResult-unrecognizedInvocation', 20), (u'returnResult-resultResponseUnexpected', 21), (u'returnResult-mistypedResult', 22), (u'returnError-unrecognizedInvocation', 30), (u'returnError-errorResponseUnexpected', 31), (u'returnError-unrecognizedError', 32), (u'returnError-unexpectedError', 33), (u'returnError-mistypedParameter', 34)])
    
    #-----< InvokeId >-----#
    InvokeId = CHOICE(name=u'InvokeId', mode=MODE_TYPE)
    _InvokeId_present = INT(name=u'present', mode=MODE_TYPE)
    _InvokeId_absent = NULL(name=u'absent', mode=MODE_TYPE)
    InvokeId._cont = ASN1Dict([
        (u'present', _InvokeId_present),
        (u'absent', _InvokeId_absent),
        ])
    InvokeId._ext = None
    
    #-----< noInvokeId >-----#
    noInvokeId = CHOICE(name=u'noInvokeId', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    noInvokeId._val = (u'absent', 0)
    
    #-----< NoInvokeId >-----#
    NoInvokeId = CHOICE(name=u'NoInvokeId', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    NoInvokeId._val = ASN1Set(rv=[(u'absent', 0)], rr=[], ev=None, er=[])
    
    #-----< Errors >-----#
    Errors = CLASS(name=u'Errors', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')), param=True)
    
    #-----< Bind >-----#
    Bind = CHOICE(name=u'Bind', mode=MODE_TYPE, param=True)
    
    #-----< Unbind >-----#
    Unbind = CHOICE(name=u'Unbind', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _Reject_invokeId,
        __Reject_problem_general,
        __Reject_problem_invoke,
        __Reject_problem_returnResult,
        __Reject_problem_returnError,
        _Reject_problem,
        Reject,
        GeneralProblem,
        InvokeProblem,
        ReturnResultProblem,
        ReturnErrorProblem,
        RejectProblem,
        _InvokeId_present,
        _InvokeId_absent,
        InvokeId,
        noInvokeId,
        NoInvokeId,
    ]

class Remote_Operations_Information_Objects:

    _name_  = u'Remote-Operations-Information-Objects'
    _oid_   = [2, 4, 5, 0]
    
    _obj_ = [
        u'OPERATION',
        u'ERROR',
        u'OPERATION-PACKAGE',
        u'CONNECTION-PACKAGE',
        u'CONTRACT',
        u'ROS-OBJECT-CLASS',
        u'Code',
        u'Priority',
        ]
    _type_ = [
        u'OPERATION',
        u'ERROR',
        u'OPERATION-PACKAGE',
        u'CONNECTION-PACKAGE',
        u'CONTRACT',
        u'ROS-OBJECT-CLASS',
        u'Code',
        u'Priority',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        u'OPERATION',
        u'ERROR',
        u'OPERATION-PACKAGE',
        u'CONNECTION-PACKAGE',
        u'CONTRACT',
        u'ROS-OBJECT-CLASS',
        ]
    _param_ = [
        ]
    
    #-----< OPERATION >-----#
    OPERATION = CLASS(name=u'OPERATION', mode=MODE_TYPE)
    _OPERATION_ArgumentType = OPEN(name=u'ArgumentType', mode=MODE_TYPE, opt=True)
    _OPERATION_argumentTypeOptional = BOOL(name=u'argumentTypeOptional', mode=MODE_VALUE, opt=True)
    _OPERATION_returnResult = BOOL(name=u'returnResult', mode=MODE_VALUE, default=True)
    _OPERATION_ResultType = OPEN(name=u'ResultType', mode=MODE_TYPE, opt=True)
    _OPERATION_resultTypeOptional = BOOL(name=u'resultTypeOptional', mode=MODE_VALUE, opt=True)
    _OPERATION_Errors = CLASS(name=u'Errors', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')), opt=True)
    _OPERATION_Linked = CLASS(name=u'Linked', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_synchronous = BOOL(name=u'synchronous', mode=MODE_VALUE, default=False)
    _OPERATION_alwaysReturns = BOOL(name=u'alwaysReturns', mode=MODE_VALUE, default=True)
    _OPERATION_InvokePriority = INT(name=u'InvokePriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _OPERATION_ResultPriority = INT(name=u'ResultPriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _OPERATION_operationCode = CHOICE(name=u'operationCode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')), opt=True, uniq=True)
    OPERATION._cont = ASN1Dict([
        (u'ArgumentType', _OPERATION_ArgumentType),
        (u'argumentTypeOptional', _OPERATION_argumentTypeOptional),
        (u'returnResult', _OPERATION_returnResult),
        (u'ResultType', _OPERATION_ResultType),
        (u'resultTypeOptional', _OPERATION_resultTypeOptional),
        (u'Errors', _OPERATION_Errors),
        (u'Linked', _OPERATION_Linked),
        (u'synchronous', _OPERATION_synchronous),
        (u'alwaysReturns', _OPERATION_alwaysReturns),
        (u'InvokePriority', _OPERATION_InvokePriority),
        (u'ResultPriority', _OPERATION_ResultPriority),
        (u'operationCode', _OPERATION_operationCode),
        ])
    
    #-----< ERROR >-----#
    ERROR = CLASS(name=u'ERROR', mode=MODE_TYPE)
    _ERROR_ParameterType = OPEN(name=u'ParameterType', mode=MODE_TYPE, opt=True)
    _ERROR_parameterTypeOptional = BOOL(name=u'parameterTypeOptional', mode=MODE_VALUE, opt=True)
    _ERROR_ErrorPriority = INT(name=u'ErrorPriority', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Priority')), opt=True)
    _ERROR_errorCode = CHOICE(name=u'errorCode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'Code')), opt=True, uniq=True)
    ERROR._cont = ASN1Dict([
        (u'ParameterType', _ERROR_ParameterType),
        (u'parameterTypeOptional', _ERROR_parameterTypeOptional),
        (u'ErrorPriority', _ERROR_ErrorPriority),
        (u'errorCode', _ERROR_errorCode),
        ])
    
    #-----< OPERATION-PACKAGE >-----#
    OPERATION_PACKAGE = CLASS(name=u'OPERATION-PACKAGE', mode=MODE_TYPE)
    _OPERATION_PACKAGE_Both = CLASS(name=u'Both', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_Consumer = CLASS(name=u'Consumer', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_Supplier = CLASS(name=u'Supplier', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), opt=True)
    _OPERATION_PACKAGE_id = OID(name=u'id', mode=MODE_VALUE, opt=True, uniq=True)
    OPERATION_PACKAGE._cont = ASN1Dict([
        (u'Both', _OPERATION_PACKAGE_Both),
        (u'Consumer', _OPERATION_PACKAGE_Consumer),
        (u'Supplier', _OPERATION_PACKAGE_Supplier),
        (u'id', _OPERATION_PACKAGE_id),
        ])
    
    #-----< CONNECTION-PACKAGE >-----#
    CONNECTION_PACKAGE = CLASS(name=u'CONNECTION-PACKAGE', mode=MODE_TYPE)
    _CONNECTION_PACKAGE_bind = CLASS(name=u'bind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), default=dict([(u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', -1))])], rr=[], ev=None, er=[])), (u'synchronous', True)]))
    _CONNECTION_PACKAGE_unbind = CLASS(name=u'unbind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), default=dict([(u'synchronous', True)]))
    _CONNECTION_PACKAGE_responderCanUnbind = BOOL(name=u'responderCanUnbind', mode=MODE_VALUE, default=False)
    _CONNECTION_PACKAGE_unbindCanFail = BOOL(name=u'unbindCanFail', mode=MODE_VALUE, default=False)
    _CONNECTION_PACKAGE_id = OID(name=u'id', mode=MODE_VALUE, opt=True, uniq=True)
    CONNECTION_PACKAGE._cont = ASN1Dict([
        (u'bind', _CONNECTION_PACKAGE_bind),
        (u'unbind', _CONNECTION_PACKAGE_unbind),
        (u'responderCanUnbind', _CONNECTION_PACKAGE_responderCanUnbind),
        (u'unbindCanFail', _CONNECTION_PACKAGE_unbindCanFail),
        (u'id', _CONNECTION_PACKAGE_id),
        ])
    
    #-----< CONTRACT >-----#
    CONTRACT = CLASS(name=u'CONTRACT', mode=MODE_TYPE)
    _CONTRACT_connection = CLASS(name=u'connection', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONNECTION-PACKAGE')), opt=True)
    _CONTRACT_OperationsOf = CLASS(name=u'OperationsOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_InitiatorConsumerOf = CLASS(name=u'InitiatorConsumerOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_InitiatorSupplierOf = CLASS(name=u'InitiatorSupplierOf', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), opt=True)
    _CONTRACT_id = OID(name=u'id', mode=MODE_VALUE, opt=True, uniq=True)
    CONTRACT._cont = ASN1Dict([
        (u'connection', _CONTRACT_connection),
        (u'OperationsOf', _CONTRACT_OperationsOf),
        (u'InitiatorConsumerOf', _CONTRACT_InitiatorConsumerOf),
        (u'InitiatorSupplierOf', _CONTRACT_InitiatorSupplierOf),
        (u'id', _CONTRACT_id),
        ])
    
    #-----< ROS-OBJECT-CLASS >-----#
    ROS_OBJECT_CLASS = CLASS(name=u'ROS-OBJECT-CLASS', mode=MODE_TYPE)
    _ROS_OBJECT_CLASS_Is = CLASS(name=u'Is', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ROS-OBJECT-CLASS')), opt=True)
    _ROS_OBJECT_CLASS_Initiates = CLASS(name=u'Initiates', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_Responds = CLASS(name=u'Responds', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_InitiatesAndResponds = CLASS(name=u'InitiatesAndResponds', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')), opt=True)
    _ROS_OBJECT_CLASS_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    ROS_OBJECT_CLASS._cont = ASN1Dict([
        (u'Is', _ROS_OBJECT_CLASS_Is),
        (u'Initiates', _ROS_OBJECT_CLASS_Initiates),
        (u'Responds', _ROS_OBJECT_CLASS_Responds),
        (u'InitiatesAndResponds', _ROS_OBJECT_CLASS_InitiatesAndResponds),
        (u'id', _ROS_OBJECT_CLASS_id),
        ])
    
    #-----< Code >-----#
    Code = CHOICE(name=u'Code', mode=MODE_TYPE)
    _Code_local = INT(name=u'local', mode=MODE_TYPE)
    _Code_global_ = OID(name=u'global', mode=MODE_TYPE)
    Code._cont = ASN1Dict([
        (u'local', _Code_local),
        (u'global', _Code_global_),
        ])
    Code._ext = None
    
    #-----< Priority >-----#
    Priority = INT(name=u'Priority', mode=MODE_TYPE)
    Priority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    _all_ = [
        _OPERATION_ArgumentType,
        _OPERATION_argumentTypeOptional,
        _OPERATION_returnResult,
        _OPERATION_ResultType,
        _OPERATION_resultTypeOptional,
        _OPERATION_Errors,
        _OPERATION_Linked,
        _OPERATION_synchronous,
        _OPERATION_alwaysReturns,
        _OPERATION_InvokePriority,
        _OPERATION_ResultPriority,
        _OPERATION_operationCode,
        OPERATION,
        _ERROR_ParameterType,
        _ERROR_parameterTypeOptional,
        _ERROR_ErrorPriority,
        _ERROR_errorCode,
        ERROR,
        _OPERATION_PACKAGE_Both,
        _OPERATION_PACKAGE_Consumer,
        _OPERATION_PACKAGE_Supplier,
        _OPERATION_PACKAGE_id,
        OPERATION_PACKAGE,
        _CONNECTION_PACKAGE_bind,
        _CONNECTION_PACKAGE_unbind,
        _CONNECTION_PACKAGE_responderCanUnbind,
        _CONNECTION_PACKAGE_unbindCanFail,
        _CONNECTION_PACKAGE_id,
        CONNECTION_PACKAGE,
        _CONTRACT_connection,
        _CONTRACT_OperationsOf,
        _CONTRACT_InitiatorConsumerOf,
        _CONTRACT_InitiatorSupplierOf,
        _CONTRACT_id,
        CONTRACT,
        _ROS_OBJECT_CLASS_Is,
        _ROS_OBJECT_CLASS_Initiates,
        _ROS_OBJECT_CLASS_Responds,
        _ROS_OBJECT_CLASS_InitiatesAndResponds,
        _ROS_OBJECT_CLASS_id,
        ROS_OBJECT_CLASS,
        _Code_local,
        _Code_global_,
        Code,
        Priority,
    ]

class Remote_Operations_Useful_Definitions:

    _name_  = u'Remote-Operations-Useful-Definitions'
    _oid_   = [2, 4, 7, 0]
    
    _obj_ = [
        u'emptyBind',
        u'emptyUnbind',
        u'refuse',
        u'no-op',
        u'Forward',
        u'Reverse',
        u'ConsumerPerforms',
        u'SupplierPerforms',
        u'AllOperations',
        u'recode',
        u'switch',
        u'combine',
        u'ROS-SingleAS',
        u'ROS-ConsumerAS',
        u'ROS-SupplierAS',
        ]
    _type_ = [
        u'ROS-SingleAS',
        u'ROS-ConsumerAS',
        u'ROS-SupplierAS',
        ]
    _set_ = [
        u'Forward',
        u'Reverse',
        u'ConsumerPerforms',
        u'SupplierPerforms',
        u'AllOperations',
        ]
    _val_ = [
        u'emptyBind',
        u'emptyUnbind',
        u'refuse',
        u'no-op',
        u'recode',
        u'switch',
        u'combine',
        ]
    _class_ = [
        u'emptyBind',
        u'emptyUnbind',
        u'refuse',
        u'no-op',
        u'Forward',
        u'Reverse',
        u'ConsumerPerforms',
        u'SupplierPerforms',
        u'AllOperations',
        u'recode',
        u'switch',
        u'combine',
        ]
    _param_ = [
        u'Forward',
        u'Reverse',
        u'ConsumerPerforms',
        u'SupplierPerforms',
        u'AllOperations',
        u'recode',
        u'switch',
        u'combine',
        u'ROS-SingleAS',
        u'ROS-ConsumerAS',
        u'ROS-SupplierAS',
        ]
    
    #-----< emptyBind >-----#
    emptyBind = CLASS(name=u'emptyBind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    emptyBind._val = dict([(u'Errors', ASN1Set(rv=[dict([(u'errorCode', (u'local', -1))])], rr=[], ev=None, er=[])), (u'synchronous', True)])
    
    #-----< emptyUnbind >-----#
    emptyUnbind = CLASS(name=u'emptyUnbind', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    emptyUnbind._val = dict([(u'synchronous', True)])
    
    #-----< refuse >-----#
    refuse = CLASS(name=u'refuse', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'ERROR')))
    refuse._val = dict([(u'errorCode', (u'local', -1))])
    
    #-----< no-op >-----#
    no_op = CLASS(name=u'no-op', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')))
    no_op._val = dict([(u'alwaysReturns', False), (u'operationCode', (u'local', -1))])
    
    #-----< Forward >-----#
    Forward = CLASS(name=u'Forward', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< Reverse >-----#
    Reverse = CLASS(name=u'Reverse', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< ConsumerPerforms >-----#
    ConsumerPerforms = CLASS(name=u'ConsumerPerforms', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< SupplierPerforms >-----#
    SupplierPerforms = CLASS(name=u'SupplierPerforms', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< AllOperations >-----#
    AllOperations = CLASS(name=u'AllOperations', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< recode >-----#
    recode = CLASS(name=u'recode', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION')), param=True)
    
    #-----< switch >-----#
    switch = CLASS(name=u'switch', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< combine >-----#
    combine = CLASS(name=u'combine', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'OPERATION-PACKAGE')), param=True)
    
    #-----< ROS-SingleAS >-----#
    ROS_SingleAS = CHOICE(name=u'ROS-SingleAS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')), param=True)
    
    #-----< ROS-ConsumerAS >-----#
    ROS_ConsumerAS = CHOICE(name=u'ROS-ConsumerAS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')), param=True)
    
    #-----< ROS-SupplierAS >-----#
    ROS_SupplierAS = CHOICE(name=u'ROS-SupplierAS', mode=MODE_TYPE, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'ROS')), param=True)
    
    _all_ = [
        emptyBind,
        emptyUnbind,
        refuse,
        no_op,
    ]

class SchemaAdministration:

    _name_  = u'SchemaAdministration'
    _oid_   = [2, 5, 1, 23, 8]
    
    _obj_ = [
        u'subschema',
        u'dITStructureRules',
        u'DITStructureRuleDescription',
        u'dITContentRules',
        u'DITContentRuleDescription',
        u'matchingRules',
        u'MatchingRuleDescription',
        u'attributeTypes',
        u'AttributeTypeDescription',
        u'AttributeTypeInformation',
        u'objectClasses',
        u'ObjectClassDescription',
        u'ObjectClassInformation',
        u'nameForms',
        u'NameFormDescription',
        u'NameFormInformation',
        u'matchingRuleUse',
        u'MatchingRuleUseDescription',
        u'structuralObjectClass',
        u'governingStructureRule',
        u'contextTypes',
        u'ContextDescription',
        u'ContextInformation',
        u'dITContextUse',
        u'DITContextUseDescription',
        u'DITContextUseInformation',
        u'friends',
        u'FriendsDescription',
        u'id-soc-subschema',
        u'id-soa-dITStructureRule',
        u'id-soa-dITContentRules',
        u'id-soa-matchingRules',
        u'id-soa-attributeTypes',
        u'id-soa-objectClasses',
        u'id-soa-nameForms',
        u'id-soa-matchingRuleUse',
        u'id-soa-structuralObjectClass',
        u'id-soa-governingStructureRule',
        u'id-soa-contextTypes',
        u'id-soa-dITContextUse',
        u'id-soa-friends',
        ]
    _type_ = [
        u'DITStructureRuleDescription',
        u'DITContentRuleDescription',
        u'MatchingRuleDescription',
        u'AttributeTypeDescription',
        u'AttributeTypeInformation',
        u'ObjectClassDescription',
        u'ObjectClassInformation',
        u'NameFormDescription',
        u'NameFormInformation',
        u'MatchingRuleUseDescription',
        u'ContextDescription',
        u'ContextInformation',
        u'DITContextUseDescription',
        u'DITContextUseInformation',
        u'FriendsDescription',
        ]
    _set_ = [
        ]
    _val_ = [
        u'subschema',
        u'dITStructureRules',
        u'dITContentRules',
        u'matchingRules',
        u'attributeTypes',
        u'objectClasses',
        u'nameForms',
        u'matchingRuleUse',
        u'structuralObjectClass',
        u'governingStructureRule',
        u'contextTypes',
        u'dITContextUse',
        u'friends',
        u'id-soc-subschema',
        u'id-soa-dITStructureRule',
        u'id-soa-dITContentRules',
        u'id-soa-matchingRules',
        u'id-soa-attributeTypes',
        u'id-soa-objectClasses',
        u'id-soa-nameForms',
        u'id-soa-matchingRuleUse',
        u'id-soa-structuralObjectClass',
        u'id-soa-governingStructureRule',
        u'id-soa-contextTypes',
        u'id-soa-dITContextUse',
        u'id-soa-friends',
        ]
    _class_ = [
        u'subschema',
        u'dITStructureRules',
        u'dITContentRules',
        u'matchingRules',
        u'attributeTypes',
        u'objectClasses',
        u'nameForms',
        u'matchingRuleUse',
        u'structuralObjectClass',
        u'governingStructureRule',
        u'contextTypes',
        u'dITContextUse',
        u'friends',
        ]
    _param_ = [
        ]
    
    #-----< subschema >-----#
    subschema = CLASS(name=u'subschema', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'OBJECT-CLASS')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_0 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITStructureRuleDescription')))
    __ATTRIBUTE_equality_match_val_AssertionType = INT(name=u'AssertionType', mode=MODE_TYPE)
    __OBJECT_CLASS_OptionalAttributes_val_Type_1 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'NameFormDescription')))
    __ATTRIBUTE_equality_match_val_AssertionType_0 = OID(name=u'AssertionType', mode=MODE_TYPE)
    __OBJECT_CLASS_OptionalAttributes_val_Type_2 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITContentRuleDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_3 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'ObjectClassDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_4 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'AttributeTypeDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_5 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'FriendsDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_6 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'ContextDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_7 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITContextUseDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_8 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_9 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleUseDescription')))
    __OBJECT_CLASS_OptionalAttributes_val_Type_10 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('LdapSystemSchema', 'LdapSyntaxDescription')))
    subschema._val = dict([(u'kind', u'auxiliary'), (u'OptionalAttributes', ASN1Set(rv=[dict([(u'Type', __OBJECT_CLASS_OptionalAttributes_val_Type_0), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerFirstComponentMatch']), (u'id', (2, 5, 13, 29))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 17)), (u'ldapName', [u'dITStructureRules']), (u'id', (2, 5, 21, 1))]), dict([(u'Type', __OBJECT_CLASS_OptionalAttributes_val_Type_1), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 35)), (u'ldapName', [u'nameForms']), (u'id', (2, 5, 21, 7))]), dict([(u'Type', __OBJECT_CLASS_OptionalAttributes_val_Type_2), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 16)), (u'ldapName', [u'dITContentRules']), (u'id', (2, 5, 21, 2))]), dict([(u'Type', __OBJECT_CLASS_OptionalAttributes_val_Type_3), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 37)), (u'ldapName', [u'objectClasses']), (u'id', (2, 5, 21, 6))]), dict([(u'Type', __OBJECT_CLASS_OptionalAttributes_val_Type_4), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 3)), (u'ldapName', [u'attributeTypes']), (u'id', (2, 5, 21, 5))]), dict([(u'Type', __OBJECT_CLASS_OptionalAttributes_val_Type_5), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'id', (2, 5, 21, 13))]), dict([(u'Type', __OBJECT_CLASS_OptionalAttributes_val_Type_6), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'id', (2, 5, 21, 11))]), dict([(u'Type', __OBJECT_CLASS_OptionalAttributes_val_Type_7), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'id', (2, 5, 21, 12))]), dict([(u'Type', __OBJECT_CLASS_OptionalAttributes_val_Type_8), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 30)), (u'ldapName', [u'matchingRules']), (u'id', (2, 5, 21, 4))]), dict([(u'Type', __OBJECT_CLASS_OptionalAttributes_val_Type_9), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 31)), (u'ldapName', [u'matchingRuleUse']), (u'id', (2, 5, 21, 8))]), dict([(u'Type', __OBJECT_CLASS_OptionalAttributes_val_Type_10), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 54)), (u'ldapName', [u'ldapSyntax']), (u'id', (1, 3, 6, 1, 4, 1, 1466, 101, 120, 16))])], rr=[], ev=None, er=[])), (u'ldapName', [u'subschema']), (u'id', (2, 5, 20, 1))])
    
    #-----< dITStructureRules >-----#
    dITStructureRules = CLASS(name=u'dITStructureRules', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dITStructureRules_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITStructureRuleDescription')))
    dITStructureRules._val = dict([(u'Type', _dITStructureRules_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerFirstComponentMatch']), (u'id', (2, 5, 13, 29))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 17)), (u'ldapName', [u'dITStructureRules']), (u'id', (2, 5, 21, 1))])
    
    #-----< DITStructureRuleDescription >-----#
    DITStructureRuleDescription = SEQ(name=u'DITStructureRuleDescription', mode=MODE_TYPE)
    _DITStructureRuleDescription_ruleIdentifier = INT(name=u'ruleIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RuleIdentifier')))
    _DITStructureRuleDescription_nameForm = OID(name=u'nameForm', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'NAME-FORM'), [u'id']))
    _DITStructureRuleDescription_superiorStructureRules = SET_OF(name=u'superiorStructureRules', mode=MODE_TYPE, opt=True)
    __DITStructureRuleDescription_superiorStructureRules__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'RuleIdentifier')))
    _DITStructureRuleDescription_superiorStructureRules._cont = __DITStructureRuleDescription_superiorStructureRules__item_
    _DITStructureRuleDescription_name = SET_OF(name=u'name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITStructureRuleDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _DITStructureRuleDescription_name._cont = __DITStructureRuleDescription_name__item_
    _DITStructureRuleDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITStructureRuleDescription_description = CHOICE(name=u'description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _DITStructureRuleDescription_obsolete = BOOL(name=u'obsolete', mode=MODE_TYPE, default=False)
    DITStructureRuleDescription._cont = ASN1Dict([
        (u'ruleIdentifier', _DITStructureRuleDescription_ruleIdentifier),
        (u'nameForm', _DITStructureRuleDescription_nameForm),
        (u'superiorStructureRules', _DITStructureRuleDescription_superiorStructureRules),
        (u'name', _DITStructureRuleDescription_name),
        (u'description', _DITStructureRuleDescription_description),
        (u'obsolete', _DITStructureRuleDescription_obsolete),
        ])
    DITStructureRuleDescription._ext = []
    
    #-----< dITContentRules >-----#
    dITContentRules = CLASS(name=u'dITContentRules', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dITContentRules_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITContentRuleDescription')))
    dITContentRules._val = dict([(u'Type', _dITContentRules_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 16)), (u'ldapName', [u'dITContentRules']), (u'id', (2, 5, 21, 2))])
    
    #-----< DITContentRuleDescription >-----#
    DITContentRuleDescription = SEQ(name=u'DITContentRuleDescription', mode=MODE_TYPE)
    _DITContentRuleDescription_structuralObjectClass = OID(name=u'structuralObjectClass', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']))
    _DITContentRuleDescription_auxiliaries = SET_OF(name=u'auxiliaries', mode=MODE_TYPE, opt=True)
    __DITContentRuleDescription_auxiliaries__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']))
    _DITContentRuleDescription_auxiliaries._cont = __DITContentRuleDescription_auxiliaries__item_
    _DITContentRuleDescription_mandatory = SET_OF(name=u'mandatory', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRuleDescription_mandatory__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _DITContentRuleDescription_mandatory._cont = __DITContentRuleDescription_mandatory__item_
    _DITContentRuleDescription_optional = SET_OF(name=u'optional', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRuleDescription_optional__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _DITContentRuleDescription_optional._cont = __DITContentRuleDescription_optional__item_
    _DITContentRuleDescription_precluded = SET_OF(name=u'precluded', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRuleDescription_precluded__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _DITContentRuleDescription_precluded._cont = __DITContentRuleDescription_precluded__item_
    _DITContentRuleDescription_name = SET_OF(name=u'name', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContentRuleDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _DITContentRuleDescription_name._cont = __DITContentRuleDescription_name__item_
    _DITContentRuleDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContentRuleDescription_description = CHOICE(name=u'description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _DITContentRuleDescription_obsolete = BOOL(name=u'obsolete', mode=MODE_TYPE, default=False)
    DITContentRuleDescription._cont = ASN1Dict([
        (u'structuralObjectClass', _DITContentRuleDescription_structuralObjectClass),
        (u'auxiliaries', _DITContentRuleDescription_auxiliaries),
        (u'mandatory', _DITContentRuleDescription_mandatory),
        (u'optional', _DITContentRuleDescription_optional),
        (u'precluded', _DITContentRuleDescription_precluded),
        (u'name', _DITContentRuleDescription_name),
        (u'description', _DITContentRuleDescription_description),
        (u'obsolete', _DITContentRuleDescription_obsolete),
        ])
    DITContentRuleDescription._ext = []
    
    #-----< matchingRules >-----#
    matchingRules = CLASS(name=u'matchingRules', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _matchingRules_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleDescription')))
    matchingRules._val = dict([(u'Type', _matchingRules_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 30)), (u'ldapName', [u'matchingRules']), (u'id', (2, 5, 21, 4))])
    
    #-----< MatchingRuleDescription >-----#
    MatchingRuleDescription = SEQ(name=u'MatchingRuleDescription', mode=MODE_TYPE)
    _MatchingRuleDescription_identifier = OID(name=u'identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), [u'id']))
    _MatchingRuleDescription_name = SET_OF(name=u'name', mode=MODE_TYPE, opt=True)
    __MatchingRuleDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _MatchingRuleDescription_name._cont = __MatchingRuleDescription_name__item_
    _MatchingRuleDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _MatchingRuleDescription_description = CHOICE(name=u'description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _MatchingRuleDescription_obsolete = BOOL(name=u'obsolete', mode=MODE_TYPE, default=False)
    _MatchingRuleDescription_information = CHOICE(name=u'information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    MatchingRuleDescription._cont = ASN1Dict([
        (u'identifier', _MatchingRuleDescription_identifier),
        (u'name', _MatchingRuleDescription_name),
        (u'description', _MatchingRuleDescription_description),
        (u'obsolete', _MatchingRuleDescription_obsolete),
        (u'information', _MatchingRuleDescription_information),
        ])
    MatchingRuleDescription._ext = []
    
    #-----< attributeTypes >-----#
    attributeTypes = CLASS(name=u'attributeTypes', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeTypes_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'AttributeTypeDescription')))
    attributeTypes._val = dict([(u'Type', _attributeTypes_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 3)), (u'ldapName', [u'attributeTypes']), (u'id', (2, 5, 21, 5))])
    
    #-----< AttributeTypeDescription >-----#
    AttributeTypeDescription = SEQ(name=u'AttributeTypeDescription', mode=MODE_TYPE)
    _AttributeTypeDescription_identifier = OID(name=u'identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _AttributeTypeDescription_name = SET_OF(name=u'name', mode=MODE_TYPE, opt=True)
    __AttributeTypeDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _AttributeTypeDescription_name._cont = __AttributeTypeDescription_name__item_
    _AttributeTypeDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _AttributeTypeDescription_description = CHOICE(name=u'description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _AttributeTypeDescription_obsolete = BOOL(name=u'obsolete', mode=MODE_TYPE, default=False)
    _AttributeTypeDescription_information = SEQ(name=u'information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SchemaAdministration', 'AttributeTypeInformation')))
    AttributeTypeDescription._cont = ASN1Dict([
        (u'identifier', _AttributeTypeDescription_identifier),
        (u'name', _AttributeTypeDescription_name),
        (u'description', _AttributeTypeDescription_description),
        (u'obsolete', _AttributeTypeDescription_obsolete),
        (u'information', _AttributeTypeDescription_information),
        ])
    AttributeTypeDescription._ext = []
    
    #-----< AttributeTypeInformation >-----#
    AttributeTypeInformation = SEQ(name=u'AttributeTypeInformation', mode=MODE_TYPE)
    _AttributeTypeInformation_derivation = OID(name=u'derivation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']), opt=True)
    _AttributeTypeInformation_equalityMatch = OID(name=u'equalityMatch', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), [u'id']), opt=True)
    _AttributeTypeInformation_orderingMatch = OID(name=u'orderingMatch', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), [u'id']), opt=True)
    _AttributeTypeInformation_substringsMatch = OID(name=u'substringsMatch', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), [u'id']), opt=True)
    _AttributeTypeInformation_attributeSyntax = CHOICE(name=u'attributeSyntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _AttributeTypeInformation_multi_valued = BOOL(name=u'multi-valued', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _AttributeTypeInformation_collective = BOOL(name=u'collective', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _AttributeTypeInformation_userModifiable = BOOL(name=u'userModifiable', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=True)
    _AttributeTypeInformation_application = ENUM(name=u'application', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeUsage')), default=u'userApplications')
    AttributeTypeInformation._cont = ASN1Dict([
        (u'derivation', _AttributeTypeInformation_derivation),
        (u'equalityMatch', _AttributeTypeInformation_equalityMatch),
        (u'orderingMatch', _AttributeTypeInformation_orderingMatch),
        (u'substringsMatch', _AttributeTypeInformation_substringsMatch),
        (u'attributeSyntax', _AttributeTypeInformation_attributeSyntax),
        (u'multi-valued', _AttributeTypeInformation_multi_valued),
        (u'collective', _AttributeTypeInformation_collective),
        (u'userModifiable', _AttributeTypeInformation_userModifiable),
        (u'application', _AttributeTypeInformation_application),
        ])
    AttributeTypeInformation._ext = []
    
    #-----< objectClasses >-----#
    objectClasses = CLASS(name=u'objectClasses', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _objectClasses_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'ObjectClassDescription')))
    objectClasses._val = dict([(u'Type', _objectClasses_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 37)), (u'ldapName', [u'objectClasses']), (u'id', (2, 5, 21, 6))])
    
    #-----< ObjectClassDescription >-----#
    ObjectClassDescription = SEQ(name=u'ObjectClassDescription', mode=MODE_TYPE)
    _ObjectClassDescription_identifier = OID(name=u'identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']))
    _ObjectClassDescription_name = SET_OF(name=u'name', mode=MODE_TYPE, opt=True)
    __ObjectClassDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _ObjectClassDescription_name._cont = __ObjectClassDescription_name__item_
    _ObjectClassDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ObjectClassDescription_description = CHOICE(name=u'description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _ObjectClassDescription_obsolete = BOOL(name=u'obsolete', mode=MODE_TYPE, default=False)
    _ObjectClassDescription_information = SEQ(name=u'information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SchemaAdministration', 'ObjectClassInformation')))
    ObjectClassDescription._cont = ASN1Dict([
        (u'identifier', _ObjectClassDescription_identifier),
        (u'name', _ObjectClassDescription_name),
        (u'description', _ObjectClassDescription_description),
        (u'obsolete', _ObjectClassDescription_obsolete),
        (u'information', _ObjectClassDescription_information),
        ])
    ObjectClassDescription._ext = []
    
    #-----< ObjectClassInformation >-----#
    ObjectClassInformation = SEQ(name=u'ObjectClassInformation', mode=MODE_TYPE)
    _ObjectClassInformation_subclassOf = SET_OF(name=u'subclassOf', mode=MODE_TYPE, opt=True)
    __ObjectClassInformation_subclassOf__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']))
    _ObjectClassInformation_subclassOf._cont = __ObjectClassInformation_subclassOf__item_
    _ObjectClassInformation_subclassOf._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ObjectClassInformation_kind = ENUM(name=u'kind', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ObjectClassKind')), default=u'structural')
    _ObjectClassInformation_mandatories = SET_OF(name=u'mandatories', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ObjectClassInformation_mandatories__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _ObjectClassInformation_mandatories._cont = __ObjectClassInformation_mandatories__item_
    _ObjectClassInformation_mandatories._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ObjectClassInformation_optionals = SET_OF(name=u'optionals', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ObjectClassInformation_optionals__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _ObjectClassInformation_optionals._cont = __ObjectClassInformation_optionals__item_
    _ObjectClassInformation_optionals._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ObjectClassInformation._cont = ASN1Dict([
        (u'subclassOf', _ObjectClassInformation_subclassOf),
        (u'kind', _ObjectClassInformation_kind),
        (u'mandatories', _ObjectClassInformation_mandatories),
        (u'optionals', _ObjectClassInformation_optionals),
        ])
    ObjectClassInformation._ext = []
    
    #-----< nameForms >-----#
    nameForms = CLASS(name=u'nameForms', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _nameForms_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'NameFormDescription')))
    nameForms._val = dict([(u'Type', _nameForms_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 35)), (u'ldapName', [u'nameForms']), (u'id', (2, 5, 21, 7))])
    
    #-----< NameFormDescription >-----#
    NameFormDescription = SEQ(name=u'NameFormDescription', mode=MODE_TYPE)
    _NameFormDescription_identifier = OID(name=u'identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'NAME-FORM'), [u'id']))
    _NameFormDescription_name = SET_OF(name=u'name', mode=MODE_TYPE, opt=True)
    __NameFormDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _NameFormDescription_name._cont = __NameFormDescription_name__item_
    _NameFormDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _NameFormDescription_description = CHOICE(name=u'description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _NameFormDescription_obsolete = BOOL(name=u'obsolete', mode=MODE_TYPE, default=False)
    _NameFormDescription_information = SEQ(name=u'information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SchemaAdministration', 'NameFormInformation')))
    NameFormDescription._cont = ASN1Dict([
        (u'identifier', _NameFormDescription_identifier),
        (u'name', _NameFormDescription_name),
        (u'description', _NameFormDescription_description),
        (u'obsolete', _NameFormDescription_obsolete),
        (u'information', _NameFormDescription_information),
        ])
    NameFormDescription._ext = []
    
    #-----< NameFormInformation >-----#
    NameFormInformation = SEQ(name=u'NameFormInformation', mode=MODE_TYPE)
    _NameFormInformation_subordinate = OID(name=u'subordinate', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']))
    _NameFormInformation_namingMandatories = SET_OF(name=u'namingMandatories', mode=MODE_TYPE)
    __NameFormInformation_namingMandatories__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _NameFormInformation_namingMandatories._cont = __NameFormInformation_namingMandatories__item_
    _NameFormInformation_namingOptionals = SET_OF(name=u'namingOptionals', mode=MODE_TYPE, opt=True)
    __NameFormInformation_namingOptionals__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _NameFormInformation_namingOptionals._cont = __NameFormInformation_namingOptionals__item_
    _NameFormInformation_namingOptionals._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    NameFormInformation._cont = ASN1Dict([
        (u'subordinate', _NameFormInformation_subordinate),
        (u'namingMandatories', _NameFormInformation_namingMandatories),
        (u'namingOptionals', _NameFormInformation_namingOptionals),
        ])
    NameFormInformation._ext = []
    
    #-----< matchingRuleUse >-----#
    matchingRuleUse = CLASS(name=u'matchingRuleUse', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _matchingRuleUse_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleUseDescription')))
    matchingRuleUse._val = dict([(u'Type', _matchingRuleUse_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 31)), (u'ldapName', [u'matchingRuleUse']), (u'id', (2, 5, 21, 8))])
    
    #-----< MatchingRuleUseDescription >-----#
    MatchingRuleUseDescription = SEQ(name=u'MatchingRuleUseDescription', mode=MODE_TYPE)
    _MatchingRuleUseDescription_identifier = OID(name=u'identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), [u'id']))
    _MatchingRuleUseDescription_name = SET_OF(name=u'name', mode=MODE_TYPE, opt=True)
    __MatchingRuleUseDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _MatchingRuleUseDescription_name._cont = __MatchingRuleUseDescription_name__item_
    _MatchingRuleUseDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _MatchingRuleUseDescription_description = CHOICE(name=u'description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _MatchingRuleUseDescription_obsolete = BOOL(name=u'obsolete', mode=MODE_TYPE, default=False)
    _MatchingRuleUseDescription_information = SET_OF(name=u'information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __MatchingRuleUseDescription_information__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _MatchingRuleUseDescription_information._cont = __MatchingRuleUseDescription_information__item_
    MatchingRuleUseDescription._cont = ASN1Dict([
        (u'identifier', _MatchingRuleUseDescription_identifier),
        (u'name', _MatchingRuleUseDescription_name),
        (u'description', _MatchingRuleUseDescription_description),
        (u'obsolete', _MatchingRuleUseDescription_obsolete),
        (u'information', _MatchingRuleUseDescription_information),
        ])
    MatchingRuleUseDescription._ext = []
    
    #-----< structuralObjectClass >-----#
    structuralObjectClass = CLASS(name=u'structuralObjectClass', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _structuralObjectClass_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    structuralObjectClass._val = dict([(u'Type', _structuralObjectClass_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'single-valued', True), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'structuralObjectClass']), (u'id', (2, 5, 21, 9))])
    
    #-----< governingStructureRule >-----#
    governingStructureRule = CLASS(name=u'governingStructureRule', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _governingStructureRule_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    governingStructureRule._val = dict([(u'Type', _governingStructureRule_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'single-valued', True), (u'no-user-modification', True), (u'usage', u'directoryOperation'), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'governingStructureRule']), (u'id', (2, 5, 21, 10))])
    
    #-----< contextTypes >-----#
    contextTypes = CLASS(name=u'contextTypes', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextTypes_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'ContextDescription')))
    contextTypes._val = dict([(u'Type', _contextTypes_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'id', (2, 5, 21, 11))])
    
    #-----< ContextDescription >-----#
    ContextDescription = SEQ(name=u'ContextDescription', mode=MODE_TYPE)
    _ContextDescription_identifier = OID(name=u'identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), [u'id']))
    _ContextDescription_name = SET_OF(name=u'name', mode=MODE_TYPE, opt=True)
    __ContextDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _ContextDescription_name._cont = __ContextDescription_name__item_
    _ContextDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ContextDescription_description = CHOICE(name=u'description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _ContextDescription_obsolete = BOOL(name=u'obsolete', mode=MODE_TYPE, default=False)
    _ContextDescription_information = SEQ(name=u'information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SchemaAdministration', 'ContextInformation')))
    ContextDescription._cont = ASN1Dict([
        (u'identifier', _ContextDescription_identifier),
        (u'name', _ContextDescription_name),
        (u'description', _ContextDescription_description),
        (u'obsolete', _ContextDescription_obsolete),
        (u'information', _ContextDescription_information),
        ])
    ContextDescription._ext = []
    
    #-----< ContextInformation >-----#
    ContextInformation = SEQ(name=u'ContextInformation', mode=MODE_TYPE)
    _ContextInformation_syntax = CHOICE(name=u'syntax', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _ContextInformation_assertionSyntax = CHOICE(name=u'assertionSyntax', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    ContextInformation._cont = ASN1Dict([
        (u'syntax', _ContextInformation_syntax),
        (u'assertionSyntax', _ContextInformation_assertionSyntax),
        ])
    ContextInformation._ext = []
    
    #-----< dITContextUse >-----#
    dITContextUse = CLASS(name=u'dITContextUse', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dITContextUse_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITContextUseDescription')))
    dITContextUse._val = dict([(u'Type', _dITContextUse_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'id', (2, 5, 21, 12))])
    
    #-----< DITContextUseDescription >-----#
    DITContextUseDescription = SEQ(name=u'DITContextUseDescription', mode=MODE_TYPE)
    _DITContextUseDescription_identifier = OID(name=u'identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _DITContextUseDescription_name = SET_OF(name=u'name', mode=MODE_TYPE, opt=True)
    __DITContextUseDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _DITContextUseDescription_name._cont = __DITContextUseDescription_name__item_
    _DITContextUseDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContextUseDescription_description = CHOICE(name=u'description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _DITContextUseDescription_obsolete = BOOL(name=u'obsolete', mode=MODE_TYPE, default=False)
    _DITContextUseDescription_information = SEQ(name=u'information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SchemaAdministration', 'DITContextUseInformation')))
    DITContextUseDescription._cont = ASN1Dict([
        (u'identifier', _DITContextUseDescription_identifier),
        (u'name', _DITContextUseDescription_name),
        (u'description', _DITContextUseDescription_description),
        (u'obsolete', _DITContextUseDescription_obsolete),
        (u'information', _DITContextUseDescription_information),
        ])
    DITContextUseDescription._ext = []
    
    #-----< DITContextUseInformation >-----#
    DITContextUseInformation = SEQ(name=u'DITContextUseInformation', mode=MODE_TYPE)
    _DITContextUseInformation_mandatoryContexts = SET_OF(name=u'mandatoryContexts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContextUseInformation_mandatoryContexts__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), [u'id']))
    _DITContextUseInformation_mandatoryContexts._cont = __DITContextUseInformation_mandatoryContexts__item_
    _DITContextUseInformation_mandatoryContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _DITContextUseInformation_optionalContexts = SET_OF(name=u'optionalContexts', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __DITContextUseInformation_optionalContexts__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), [u'id']))
    _DITContextUseInformation_optionalContexts._cont = __DITContextUseInformation_optionalContexts__item_
    _DITContextUseInformation_optionalContexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    DITContextUseInformation._cont = ASN1Dict([
        (u'mandatoryContexts', _DITContextUseInformation_mandatoryContexts),
        (u'optionalContexts', _DITContextUseInformation_optionalContexts),
        ])
    DITContextUseInformation._ext = []
    
    #-----< friends >-----#
    friends = CLASS(name=u'friends', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _friends_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'FriendsDescription')))
    friends._val = dict([(u'Type', _friends_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])), (u'usage', u'directoryOperation'), (u'id', (2, 5, 21, 13))])
    
    #-----< FriendsDescription >-----#
    FriendsDescription = SEQ(name=u'FriendsDescription', mode=MODE_TYPE)
    _FriendsDescription_anchor = OID(name=u'anchor', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _FriendsDescription_name = SET_OF(name=u'name', mode=MODE_TYPE, opt=True)
    __FriendsDescription_name__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _FriendsDescription_name._cont = __FriendsDescription_name__item_
    _FriendsDescription_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _FriendsDescription_description = CHOICE(name=u'description', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')), opt=True)
    _FriendsDescription_obsolete = BOOL(name=u'obsolete', mode=MODE_TYPE, default=False)
    _FriendsDescription_friends = SET_OF(name=u'friends', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __FriendsDescription_friends__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _FriendsDescription_friends._cont = __FriendsDescription_friends__item_
    _FriendsDescription_friends._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    FriendsDescription._cont = ASN1Dict([
        (u'anchor', _FriendsDescription_anchor),
        (u'name', _FriendsDescription_name),
        (u'description', _FriendsDescription_description),
        (u'obsolete', _FriendsDescription_obsolete),
        (u'friends', _FriendsDescription_friends),
        ])
    FriendsDescription._ext = []
    
    #-----< id-soc-subschema >-----#
    id_soc_subschema = OID(name=u'id-soc-subschema', mode=MODE_VALUE)
    id_soc_subschema._val = (2, 5, 20, 1)
    
    #-----< id-soa-dITStructureRule >-----#
    id_soa_dITStructureRule = OID(name=u'id-soa-dITStructureRule', mode=MODE_VALUE)
    id_soa_dITStructureRule._val = (2, 5, 21, 1)
    
    #-----< id-soa-dITContentRules >-----#
    id_soa_dITContentRules = OID(name=u'id-soa-dITContentRules', mode=MODE_VALUE)
    id_soa_dITContentRules._val = (2, 5, 21, 2)
    
    #-----< id-soa-matchingRules >-----#
    id_soa_matchingRules = OID(name=u'id-soa-matchingRules', mode=MODE_VALUE)
    id_soa_matchingRules._val = (2, 5, 21, 4)
    
    #-----< id-soa-attributeTypes >-----#
    id_soa_attributeTypes = OID(name=u'id-soa-attributeTypes', mode=MODE_VALUE)
    id_soa_attributeTypes._val = (2, 5, 21, 5)
    
    #-----< id-soa-objectClasses >-----#
    id_soa_objectClasses = OID(name=u'id-soa-objectClasses', mode=MODE_VALUE)
    id_soa_objectClasses._val = (2, 5, 21, 6)
    
    #-----< id-soa-nameForms >-----#
    id_soa_nameForms = OID(name=u'id-soa-nameForms', mode=MODE_VALUE)
    id_soa_nameForms._val = (2, 5, 21, 7)
    
    #-----< id-soa-matchingRuleUse >-----#
    id_soa_matchingRuleUse = OID(name=u'id-soa-matchingRuleUse', mode=MODE_VALUE)
    id_soa_matchingRuleUse._val = (2, 5, 21, 8)
    
    #-----< id-soa-structuralObjectClass >-----#
    id_soa_structuralObjectClass = OID(name=u'id-soa-structuralObjectClass', mode=MODE_VALUE)
    id_soa_structuralObjectClass._val = (2, 5, 21, 9)
    
    #-----< id-soa-governingStructureRule >-----#
    id_soa_governingStructureRule = OID(name=u'id-soa-governingStructureRule', mode=MODE_VALUE)
    id_soa_governingStructureRule._val = (2, 5, 21, 10)
    
    #-----< id-soa-contextTypes >-----#
    id_soa_contextTypes = OID(name=u'id-soa-contextTypes', mode=MODE_VALUE)
    id_soa_contextTypes._val = (2, 5, 21, 11)
    
    #-----< id-soa-dITContextUse >-----#
    id_soa_dITContextUse = OID(name=u'id-soa-dITContextUse', mode=MODE_VALUE)
    id_soa_dITContextUse._val = (2, 5, 21, 12)
    
    #-----< id-soa-friends >-----#
    id_soa_friends = OID(name=u'id-soa-friends', mode=MODE_VALUE)
    id_soa_friends._val = (2, 5, 21, 13)
    
    _all_ = [
        subschema,
        __OBJECT_CLASS_OptionalAttributes_val_Type_0,
        __ATTRIBUTE_equality_match_val_AssertionType,
        __OBJECT_CLASS_OptionalAttributes_val_Type_1,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        __OBJECT_CLASS_OptionalAttributes_val_Type_2,
        __OBJECT_CLASS_OptionalAttributes_val_Type_3,
        __OBJECT_CLASS_OptionalAttributes_val_Type_4,
        __OBJECT_CLASS_OptionalAttributes_val_Type_5,
        __OBJECT_CLASS_OptionalAttributes_val_Type_6,
        __OBJECT_CLASS_OptionalAttributes_val_Type_7,
        __OBJECT_CLASS_OptionalAttributes_val_Type_8,
        __OBJECT_CLASS_OptionalAttributes_val_Type_9,
        __OBJECT_CLASS_OptionalAttributes_val_Type_10,
        dITStructureRules,
        _dITStructureRules_val_Type,
        _DITStructureRuleDescription_ruleIdentifier,
        _DITStructureRuleDescription_nameForm,
        __DITStructureRuleDescription_superiorStructureRules__item_,
        _DITStructureRuleDescription_superiorStructureRules,
        __DITStructureRuleDescription_name__item_,
        _DITStructureRuleDescription_name,
        _DITStructureRuleDescription_description,
        _DITStructureRuleDescription_obsolete,
        DITStructureRuleDescription,
        dITContentRules,
        _dITContentRules_val_Type,
        _DITContentRuleDescription_structuralObjectClass,
        __DITContentRuleDescription_auxiliaries__item_,
        _DITContentRuleDescription_auxiliaries,
        __DITContentRuleDescription_mandatory__item_,
        _DITContentRuleDescription_mandatory,
        __DITContentRuleDescription_optional__item_,
        _DITContentRuleDescription_optional,
        __DITContentRuleDescription_precluded__item_,
        _DITContentRuleDescription_precluded,
        __DITContentRuleDescription_name__item_,
        _DITContentRuleDescription_name,
        _DITContentRuleDescription_description,
        _DITContentRuleDescription_obsolete,
        DITContentRuleDescription,
        matchingRules,
        _matchingRules_val_Type,
        _MatchingRuleDescription_identifier,
        __MatchingRuleDescription_name__item_,
        _MatchingRuleDescription_name,
        _MatchingRuleDescription_description,
        _MatchingRuleDescription_obsolete,
        _MatchingRuleDescription_information,
        MatchingRuleDescription,
        attributeTypes,
        _attributeTypes_val_Type,
        _AttributeTypeDescription_identifier,
        __AttributeTypeDescription_name__item_,
        _AttributeTypeDescription_name,
        _AttributeTypeDescription_description,
        _AttributeTypeDescription_obsolete,
        _AttributeTypeDescription_information,
        AttributeTypeDescription,
        _AttributeTypeInformation_derivation,
        _AttributeTypeInformation_equalityMatch,
        _AttributeTypeInformation_orderingMatch,
        _AttributeTypeInformation_substringsMatch,
        _AttributeTypeInformation_attributeSyntax,
        _AttributeTypeInformation_multi_valued,
        _AttributeTypeInformation_collective,
        _AttributeTypeInformation_userModifiable,
        _AttributeTypeInformation_application,
        AttributeTypeInformation,
        objectClasses,
        _objectClasses_val_Type,
        _ObjectClassDescription_identifier,
        __ObjectClassDescription_name__item_,
        _ObjectClassDescription_name,
        _ObjectClassDescription_description,
        _ObjectClassDescription_obsolete,
        _ObjectClassDescription_information,
        ObjectClassDescription,
        __ObjectClassInformation_subclassOf__item_,
        _ObjectClassInformation_subclassOf,
        _ObjectClassInformation_kind,
        __ObjectClassInformation_mandatories__item_,
        _ObjectClassInformation_mandatories,
        __ObjectClassInformation_optionals__item_,
        _ObjectClassInformation_optionals,
        ObjectClassInformation,
        nameForms,
        _nameForms_val_Type,
        _NameFormDescription_identifier,
        __NameFormDescription_name__item_,
        _NameFormDescription_name,
        _NameFormDescription_description,
        _NameFormDescription_obsolete,
        _NameFormDescription_information,
        NameFormDescription,
        _NameFormInformation_subordinate,
        __NameFormInformation_namingMandatories__item_,
        _NameFormInformation_namingMandatories,
        __NameFormInformation_namingOptionals__item_,
        _NameFormInformation_namingOptionals,
        NameFormInformation,
        matchingRuleUse,
        _matchingRuleUse_val_Type,
        _MatchingRuleUseDescription_identifier,
        __MatchingRuleUseDescription_name__item_,
        _MatchingRuleUseDescription_name,
        _MatchingRuleUseDescription_description,
        _MatchingRuleUseDescription_obsolete,
        __MatchingRuleUseDescription_information__item_,
        _MatchingRuleUseDescription_information,
        MatchingRuleUseDescription,
        structuralObjectClass,
        _structuralObjectClass_val_Type,
        governingStructureRule,
        _governingStructureRule_val_Type,
        contextTypes,
        _contextTypes_val_Type,
        _ContextDescription_identifier,
        __ContextDescription_name__item_,
        _ContextDescription_name,
        _ContextDescription_description,
        _ContextDescription_obsolete,
        _ContextDescription_information,
        ContextDescription,
        _ContextInformation_syntax,
        _ContextInformation_assertionSyntax,
        ContextInformation,
        dITContextUse,
        _dITContextUse_val_Type,
        _DITContextUseDescription_identifier,
        __DITContextUseDescription_name__item_,
        _DITContextUseDescription_name,
        _DITContextUseDescription_description,
        _DITContextUseDescription_obsolete,
        _DITContextUseDescription_information,
        DITContextUseDescription,
        __DITContextUseInformation_mandatoryContexts__item_,
        _DITContextUseInformation_mandatoryContexts,
        __DITContextUseInformation_optionalContexts__item_,
        _DITContextUseInformation_optionalContexts,
        DITContextUseInformation,
        friends,
        _friends_val_Type,
        _FriendsDescription_anchor,
        __FriendsDescription_name__item_,
        _FriendsDescription_name,
        _FriendsDescription_description,
        _FriendsDescription_obsolete,
        __FriendsDescription_friends__item_,
        _FriendsDescription_friends,
        FriendsDescription,
        id_soc_subschema,
        id_soa_dITStructureRule,
        id_soa_dITContentRules,
        id_soa_matchingRules,
        id_soa_attributeTypes,
        id_soa_objectClasses,
        id_soa_nameForms,
        id_soa_matchingRuleUse,
        id_soa_structuralObjectClass,
        id_soa_governingStructureRule,
        id_soa_contextTypes,
        id_soa_dITContextUse,
        id_soa_friends,
    ]

class SelectedAttributeTypes:

    _name_  = u'SelectedAttributeTypes'
    _oid_   = [2, 5, 1, 5, 8]
    
    _obj_ = [
        u'UnboundedDirectoryString',
        u'DirectoryString',
        u'knowledgeInformation',
        u'name',
        u'commonName',
        u'surname',
        u'givenName',
        u'initials',
        u'generationQualifier',
        u'uniqueIdentifier',
        u'UniqueIdentifier',
        u'dnQualifier',
        u'serialNumber',
        u'pseudonym',
        u'uUIDPair',
        u'UUIDPair',
        u'UUID',
        u'uri',
        u'URI',
        u'urn',
        u'url',
        u'dnsName',
        u'DomainName',
        u'countryName',
        u'CountryName',
        u'countryCode3c',
        u'CountryCode3c',
        u'countryCode3n',
        u'CountryCode3n',
        u'localityName',
        u'collectiveLocalityName',
        u'stateOrProvinceName',
        u'collectiveStateOrProvinceName',
        u'streetAddress',
        u'collectiveStreetAddress',
        u'houseIdentifier',
        u'utmCoordinates',
        u'UtmCoordinates',
        u'organizationName',
        u'collectiveOrganizationName',
        u'organizationalUnitName',
        u'collectiveOrganizationalUnitName',
        u'title',
        u'organizationIdentifier',
        u'description',
        u'searchGuide',
        u'Guide',
        u'Criteria',
        u'CriteriaItem',
        u'enhancedSearchGuide',
        u'EnhancedGuide',
        u'businessCategory',
        u'postalAddress',
        u'PostalAddress',
        u'collectivePostalAddress',
        u'postalCode',
        u'collectivePostalCode',
        u'postOfficeBox',
        u'collectivePostOfficeBox',
        u'physicalDeliveryOfficeName',
        u'collectivePhysicalDeliveryOfficeName',
        u'telephoneNumber',
        u'TelephoneNumber',
        u'ub-telephone-number',
        u'collectiveTelephoneNumber',
        u'telexNumber',
        u'TelexNumber',
        u'ub-telex-number',
        u'ub-country-code',
        u'ub-answerback',
        u'collectiveTelexNumber',
        u'facsimileTelephoneNumber',
        u'FacsimileTelephoneNumber',
        u'collectiveFacsimileTelephoneNumber',
        u'x121Address',
        u'X121Address',
        u'ub-x121-address',
        u'internationalISDNNumber',
        u'InternationalISDNNumber',
        u'ub-international-isdn-number',
        u'collectiveInternationalISDNNumber',
        u'registeredAddress',
        u'destinationIndicator',
        u'DestinationIndicator',
        u'communicationsService',
        u'CommunicationsService',
        u'communicationsNetwork',
        u'CommunicationsNetwork',
        u'preferredDeliveryMethod',
        u'PreferredDeliveryMethod',
        u'presentationAddress',
        u'PresentationAddress',
        u'supportedApplicationContext',
        u'protocolInformation',
        u'ProtocolInformation',
        u'distinguishedName',
        u'member',
        u'uniqueMember',
        u'NameAndOptionalUID',
        u'owner',
        u'roleOccupant',
        u'seeAlso',
        u'dmdName',
        u'oidC1',
        u'oidC2',
        u'oidC',
        u'urnC',
        u'tagOid',
        u'uiiFormat',
        u'UiiFormat',
        u'UiiFilter',
        u'UiiItem',
        u'uiiInUrn',
        u'contentUrl',
        u'uii',
        u'epc',
        u'tagAfi',
        u'epcFormat',
        u'EpcFormat',
        u'epcInUrn',
        u'ldapUrl',
        u'tagLocation',
        u'dSAProblem',
        u'searchServiceProblem',
        u'serviceType',
        u'attributeTypeList',
        u'matchingRuleList',
        u'filterItem',
        u'attributeCombinations',
        u'contextTypeList',
        u'contextList',
        u'contextCombinations',
        u'hierarchySelectList',
        u'searchControlOptionsList',
        u'serviceControlOptionsList',
        u'multipleMatchingLocalities',
        u'MultipleMatchingLocalities',
        u'proposedRelaxation',
        u'MRMappings',
        u'appliedRelaxation',
        u'pwdResponseValue',
        u'PwdResponse',
        u'ldapDiagnosticMsg',
        u'uid',
        u'dc',
        u'caseExactMatch',
        u'caseIgnoreMatch',
        u'caseExactOrderingMatch',
        u'caseIgnoreOrderingMatch',
        u'caseExactSubstringsMatch',
        u'caseIgnoreSubstringsMatch',
        u'SubstringAssertion',
        u'numericStringMatch',
        u'numericStringOrderingMatch',
        u'numericStringSubstringsMatch',
        u'caseIgnoreListMatch',
        u'CaseIgnoreList',
        u'caseIgnoreListSubstringsMatch',
        u'storedPrefixMatch',
        u'booleanMatch',
        u'integerMatch',
        u'integerOrderingMatch',
        u'bitStringMatch',
        u'octetStringMatch',
        u'octetStringOrderingMatch',
        u'octetStringSubstringsMatch',
        u'OctetSubstringAssertion',
        u'telephoneNumberMatch',
        u'telephoneNumberSubstringsMatch',
        u'presentationAddressMatch',
        u'uniqueMemberMatch',
        u'protocolInformationMatch',
        u'facsimileNumberMatch',
        u'facsimileNumberSubstringsMatch',
        u'uUIDPairMatch',
        u'uTCTimeMatch',
        u'uTCTimeOrderingMatch',
        u'generalizedTimeMatch',
        u'generalizedTimeOrderingMatch',
        u'systemProposedMatch',
        u'integerFirstComponentMatch',
        u'objectIdentifierFirstComponentMatch',
        u'directoryStringFirstComponentMatch',
        u'wordMatch',
        u'keywordMatch',
        u'generalWordMatch',
        u'sequenceMatchType',
        u'SequenceMatchType',
        u'wordMatchTypes',
        u'WordMatchTypes',
        u'characterMatchTypes',
        u'CharacterMatchTypes',
        u'selectedContexts',
        u'approximateStringMatch',
        u'ignoreIfAbsentMatch',
        u'nullMatch',
        u'ZONAL-MATCHING',
        u'ZonalSelect',
        u'ZonalResult',
        u'zonalMatch',
        u'uriMatch',
        u'dnsNameMatch',
        u'caseExactIA5Match',
        u'caseIgnoreIA5Match',
        u'caseIgnoreIA5SubstringsMatch',
        u'utmCoords',
        u'uiiForm',
        u'epcForm',
        u'countryString3c',
        u'countryString3n',
        u'dnsString',
        u'attributeTypeDescription',
        u'bitString',
        u'boolean',
        u'countryString',
        u'dn',
        u'deliveryMethod',
        u'directoryString',
        u'dITContentRuleDescription',
        u'dITStructureRuleDescription',
        u'enhancedGuide',
        u'facsimileTelephoneNr',
        u'fax',
        u'generalizedTime',
        u'guide',
        u'ia5String',
        u'integer',
        u'jpeg',
        u'matchingRuleDescription',
        u'matchingRuleUseDescription',
        u'nameAndOptionalUID',
        u'nameFormDescription',
        u'numericString',
        u'objectClassDescription',
        u'oid',
        u'otherMailbox',
        u'octetString',
        u'postalAddr',
        u'presentationAddr',
        u'printableString',
        u'subtreeSpec',
        u'telephoneNr',
        u'telexNr',
        u'utcTime',
        u'ldapSyntaxDescription',
        u'substringAssertion',
        u'languageContext',
        u'LanguageContextSyntax',
        u'temporalContext',
        u'TimeSpecification',
        u'Period',
        u'XDayOf',
        u'NamedDay',
        u'DayTimeBand',
        u'DayTime',
        u'TimeZone',
        u'TimeAssertion',
        u'localeContext',
        u'LocaleContextSyntax',
        u'ldapAttributeOptionContext',
        u'AttributeOptionList',
        u'id-at-knowledgeInformation',
        u'id-at-commonName',
        u'id-at-surname',
        u'id-at-serialNumber',
        u'id-at-countryName',
        u'id-at-localityName',
        u'id-at-collectiveLocalityName',
        u'id-at-stateOrProvinceName',
        u'id-at-collectiveStateOrProvinceName',
        u'id-at-streetAddress',
        u'id-at-collectiveStreetAddress',
        u'id-at-organizationName',
        u'id-at-collectiveOrganizationName',
        u'id-at-organizationalUnitName',
        u'id-at-collectiveOrganizationalUnitName',
        u'id-at-title',
        u'id-at-description',
        u'id-at-searchGuide',
        u'id-at-businessCategory',
        u'id-at-postalAddress',
        u'id-at-collectivePostalAddress',
        u'id-at-postalCode',
        u'id-at-collectivePostalCode',
        u'id-at-postOfficeBox',
        u'id-at-collectivePostOfficeBox',
        u'id-at-physicalDeliveryOfficeName',
        u'id-at-collectivePhysicalDeliveryOfficeName',
        u'id-at-telephoneNumber',
        u'id-at-collectiveTelephoneNumber',
        u'id-at-telexNumber',
        u'id-at-collectiveTelexNumber',
        u'id-at-facsimileTelephoneNumber',
        u'id-at-collectiveFacsimileTelephoneNumber',
        u'id-at-x121Address',
        u'id-at-internationalISDNNumber',
        u'id-at-collectiveInternationalISDNNumber',
        u'id-at-registeredAddress',
        u'id-at-destinationIndicator',
        u'id-at-preferredDeliveryMethod',
        u'id-at-presentationAddress',
        u'id-at-supportedApplicationContext',
        u'id-at-member',
        u'id-at-owner',
        u'id-at-roleOccupant',
        u'id-at-seeAlso',
        u'id-at-name',
        u'id-at-givenName',
        u'id-at-initials',
        u'id-at-generationQualifier',
        u'id-at-uniqueIdentifier',
        u'id-at-dnQualifier',
        u'id-at-enhancedSearchGuide',
        u'id-at-protocolInformation',
        u'id-at-distinguishedName',
        u'id-at-uniqueMember',
        u'id-at-houseIdentifier',
        u'id-at-dmdName',
        u'id-at-pseudonym',
        u'id-at-communicationsService',
        u'id-at-communicationsNetwork',
        u'id-at-uuidpair',
        u'id-at-tagOid',
        u'id-at-uiiFormat',
        u'id-at-uiiInUrn',
        u'id-at-contentUrl',
        u'id-at-uri',
        u'id-at-urn',
        u'id-at-url',
        u'id-at-utmCoordinates',
        u'id-at-urnC',
        u'id-at-uii',
        u'id-at-epc',
        u'id-at-tagAfi',
        u'id-at-epcFormat',
        u'id-at-epcInUrn',
        u'id-at-ldapUrl',
        u'id-at-tagLocation',
        u'id-at-organizationIdentifier',
        u'id-at-countryCode3c',
        u'id-at-countryCode3n',
        u'id-at-dnsName',
        u'id-asx-utmCoords',
        u'id-asx-uiiForm',
        u'id-asx-epcForm',
        u'id-asx-countryString3c',
        u'id-asx-countryString3n',
        u'id-asx-dnsString',
        u'id-lsx-attributeTypeDescription',
        u'id-lsx-bitString',
        u'id-lsx-boolean',
        u'id-lsx-countryString',
        u'id-lsx-dn',
        u'id-lsx-deliveryMethod',
        u'id-lsx-directoryString',
        u'id-lsx-dITContentRuleDescription',
        u'id-lsx-dITStructureRuleDescription',
        u'id-lsx-enhancedGuide',
        u'id-lsx-facsimileTelephoneNr',
        u'id-lsx-fax',
        u'id-lsx-generalizedTime',
        u'id-lsx-guide',
        u'id-lsx-ia5String',
        u'id-lsx-integer',
        u'id-lsx-jpeg',
        u'id-lsx-matchingRuleDescription',
        u'id-lsx-matchingRuleUseDescription',
        u'id-lsx-nameAndOptionalUID',
        u'id-lsx-nameFormDescription',
        u'id-lsx-numericString',
        u'id-lsx-objectClassDescription',
        u'id-lsx-oid',
        u'id-lsx-otherMailbox',
        u'id-lsx-octetString',
        u'id-lsx-postalAddr',
        u'id-lsx-presentationAddr',
        u'id-lsx-printableString',
        u'id-lsx-subtreeSpec',
        u'id-lsx-telephoneNr',
        u'id-lsx-telexNr',
        u'id-lsx-utcTime',
        u'id-lsx-ldapSyntaxDescription',
        u'id-lsx-substringAssertion',
        u'id-oidC1',
        u'id-oidC2',
        u'id-oidC',
        u'id-cat-sequenceMatchType',
        u'id-cat-wordMatchType',
        u'id-cat-characterMatchTypes',
        u'id-cat-selectedContexts',
        u'id-not-dSAProblem',
        u'id-not-searchServiceProblem',
        u'id-not-serviceType',
        u'id-not-attributeTypeList',
        u'id-not-matchingRuleList',
        u'id-not-filterItem',
        u'id-not-attributeCombinations',
        u'id-not-contextTypeList',
        u'id-not-contextList',
        u'id-not-contextCombinations',
        u'id-not-hierarchySelectList',
        u'id-not-searchControlOptionsList',
        u'id-not-serviceControlOptionsList',
        u'id-not-multipleMatchingLocalities',
        u'id-not-proposedRelaxation',
        u'id-not-appliedRelaxation',
        u'id-not-pwdResponse',
        u'id-not-ldapDiagnosticMsg',
        u'id-pr-targetDsaUnavailable',
        u'id-pr-dataSourceUnavailable',
        u'id-pr-unidentifiedOperation',
        u'id-pr-unavailableOperation',
        u'id-pr-searchAttributeViolation',
        u'id-pr-searchAttributeCombinationViolation',
        u'id-pr-searchValueNotAllowed',
        u'id-pr-missingSearchAttribute',
        u'id-pr-searchValueViolation',
        u'id-pr-attributeNegationViolation',
        u'id-pr-searchValueRequired',
        u'id-pr-invalidSearchValue',
        u'id-pr-searchContextViolation',
        u'id-pr-searchContextCombinationViolation',
        u'id-pr-missingSearchContext',
        u'id-pr-searchContextValueViolation',
        u'id-pr-searchContextValueRequired',
        u'id-pr-invalidContextSearchValue',
        u'id-pr-unsupportedMatchingRule',
        u'id-pr-attributeMatchingViolation',
        u'id-pr-unsupportedMatchingUse',
        u'id-pr-matchingUseViolation',
        u'id-pr-hierarchySelectForbidden',
        u'id-pr-invalidHierarchySelect',
        u'id-pr-unavailableHierarchySelect',
        u'id-pr-invalidSearchControlOptions',
        u'id-pr-invalidServiceControlOptions',
        u'id-pr-searchSubsetViolation',
        u'id-pr-unmatchedKeyAttributes',
        u'id-pr-ambiguousKeyAttributes',
        u'id-pr-unavailableRelaxationLevel',
        u'id-pr-emptyHierarchySelection',
        u'id-pr-administratorImposedLimit',
        u'id-pr-permanentRestriction',
        u'id-pr-temporaryRestriction',
        u'id-pr-relaxationNotSupported',
        u'id-coat-uid',
        u'id-coat-dc',
        u'id-mr-caseIgnoreMatch',
        u'id-mr-caseIgnoreOrderingMatch',
        u'id-mr-caseIgnoreSubstringsMatch',
        u'id-mr-caseExactMatch',
        u'id-mr-caseExactOrderingMatch',
        u'id-mr-caseExactSubstringsMatch',
        u'id-mr-numericStringMatch',
        u'id-mr-numericStringOrderingMatch',
        u'id-mr-numericStringSubstringsMatch',
        u'id-mr-caseIgnoreListMatch',
        u'id-mr-caseIgnoreListSubstringsMatch',
        u'id-mr-booleanMatch',
        u'id-mr-integerMatch',
        u'id-mr-integerOrderingMatch',
        u'id-mr-bitStringMatch',
        u'id-mr-octetStringMatch',
        u'id-mr-octetStringOrderingMatch',
        u'id-mr-octetStringSubstringsMatch',
        u'id-mr-telephoneNumberMatch',
        u'id-mr-telephoneNumberSubstringsMatch',
        u'id-mr-presentationAddressMatch',
        u'id-mr-uniqueMemberMatch',
        u'id-mr-protocolInformationMatch',
        u'id-mr-uTCTimeMatch',
        u'id-mr-uTCTimeOrderingMatch',
        u'id-mr-generalizedTimeMatch',
        u'id-mr-generalizedTimeOrderingMatch',
        u'id-mr-integerFirstComponentMatch',
        u'id-mr-objectIdentifierFirstComponentMatch',
        u'id-mr-directoryStringFirstComponentMatch',
        u'id-mr-wordMatch',
        u'id-mr-keywordMatch',
        u'id-mr-storedPrefixMatch',
        u'id-mr-systemProposedMatch',
        u'id-mr-generalWordMatch',
        u'id-mr-approximateStringMatch',
        u'id-mr-ignoreIfAbsentMatch',
        u'id-mr-nullMatch',
        u'id-mr-zonalMatch',
        u'id-mr-facsimileNumberMatch',
        u'id-mr-facsimileNumberSubstringsMatch',
        u'id-mr-uuidpairmatch',
        u'id-mr-uriMatch',
        u'id-mr-dnsNameMatch',
        u'id-lmr-caseExactIA5Match',
        u'id-lmr-caseIgnoreIA5Match',
        u'id-lmr-caseIgnoreIA5SubstringsMatch',
        u'id-avc-language',
        u'id-avc-temporal',
        u'id-avc-locale',
        u'id-avc-ldapAttributeOption',
        ]
    _type_ = [
        u'UnboundedDirectoryString',
        u'DirectoryString',
        u'UniqueIdentifier',
        u'UUIDPair',
        u'UUID',
        u'URI',
        u'DomainName',
        u'CountryName',
        u'CountryCode3c',
        u'CountryCode3n',
        u'UtmCoordinates',
        u'Guide',
        u'Criteria',
        u'CriteriaItem',
        u'EnhancedGuide',
        u'PostalAddress',
        u'TelephoneNumber',
        u'TelexNumber',
        u'FacsimileTelephoneNumber',
        u'X121Address',
        u'InternationalISDNNumber',
        u'DestinationIndicator',
        u'CommunicationsService',
        u'CommunicationsNetwork',
        u'PreferredDeliveryMethod',
        u'PresentationAddress',
        u'ProtocolInformation',
        u'NameAndOptionalUID',
        u'UiiFormat',
        u'UiiFilter',
        u'UiiItem',
        u'EpcFormat',
        u'MultipleMatchingLocalities',
        u'MRMappings',
        u'PwdResponse',
        u'SubstringAssertion',
        u'CaseIgnoreList',
        u'OctetSubstringAssertion',
        u'SequenceMatchType',
        u'WordMatchTypes',
        u'CharacterMatchTypes',
        u'ZONAL-MATCHING',
        u'ZonalSelect',
        u'ZonalResult',
        u'LanguageContextSyntax',
        u'TimeSpecification',
        u'Period',
        u'XDayOf',
        u'NamedDay',
        u'DayTimeBand',
        u'DayTime',
        u'TimeZone',
        u'TimeAssertion',
        u'LocaleContextSyntax',
        u'AttributeOptionList',
        ]
    _set_ = [
        ]
    _val_ = [
        u'knowledgeInformation',
        u'name',
        u'commonName',
        u'surname',
        u'givenName',
        u'initials',
        u'generationQualifier',
        u'uniqueIdentifier',
        u'dnQualifier',
        u'serialNumber',
        u'pseudonym',
        u'uUIDPair',
        u'uri',
        u'urn',
        u'url',
        u'dnsName',
        u'countryName',
        u'countryCode3c',
        u'countryCode3n',
        u'localityName',
        u'collectiveLocalityName',
        u'stateOrProvinceName',
        u'collectiveStateOrProvinceName',
        u'streetAddress',
        u'collectiveStreetAddress',
        u'houseIdentifier',
        u'utmCoordinates',
        u'organizationName',
        u'collectiveOrganizationName',
        u'organizationalUnitName',
        u'collectiveOrganizationalUnitName',
        u'title',
        u'organizationIdentifier',
        u'description',
        u'searchGuide',
        u'enhancedSearchGuide',
        u'businessCategory',
        u'postalAddress',
        u'collectivePostalAddress',
        u'postalCode',
        u'collectivePostalCode',
        u'postOfficeBox',
        u'collectivePostOfficeBox',
        u'physicalDeliveryOfficeName',
        u'collectivePhysicalDeliveryOfficeName',
        u'telephoneNumber',
        u'ub-telephone-number',
        u'collectiveTelephoneNumber',
        u'telexNumber',
        u'ub-telex-number',
        u'ub-country-code',
        u'ub-answerback',
        u'collectiveTelexNumber',
        u'facsimileTelephoneNumber',
        u'collectiveFacsimileTelephoneNumber',
        u'x121Address',
        u'ub-x121-address',
        u'internationalISDNNumber',
        u'ub-international-isdn-number',
        u'collectiveInternationalISDNNumber',
        u'registeredAddress',
        u'destinationIndicator',
        u'communicationsService',
        u'communicationsNetwork',
        u'preferredDeliveryMethod',
        u'presentationAddress',
        u'supportedApplicationContext',
        u'protocolInformation',
        u'distinguishedName',
        u'member',
        u'uniqueMember',
        u'owner',
        u'roleOccupant',
        u'seeAlso',
        u'dmdName',
        u'oidC1',
        u'oidC2',
        u'oidC',
        u'urnC',
        u'tagOid',
        u'uiiFormat',
        u'uiiInUrn',
        u'contentUrl',
        u'uii',
        u'epc',
        u'tagAfi',
        u'epcFormat',
        u'epcInUrn',
        u'ldapUrl',
        u'tagLocation',
        u'dSAProblem',
        u'searchServiceProblem',
        u'serviceType',
        u'attributeTypeList',
        u'matchingRuleList',
        u'filterItem',
        u'attributeCombinations',
        u'contextTypeList',
        u'contextList',
        u'contextCombinations',
        u'hierarchySelectList',
        u'searchControlOptionsList',
        u'serviceControlOptionsList',
        u'multipleMatchingLocalities',
        u'proposedRelaxation',
        u'appliedRelaxation',
        u'pwdResponseValue',
        u'ldapDiagnosticMsg',
        u'uid',
        u'dc',
        u'caseExactMatch',
        u'caseIgnoreMatch',
        u'caseExactOrderingMatch',
        u'caseIgnoreOrderingMatch',
        u'caseExactSubstringsMatch',
        u'caseIgnoreSubstringsMatch',
        u'numericStringMatch',
        u'numericStringOrderingMatch',
        u'numericStringSubstringsMatch',
        u'caseIgnoreListMatch',
        u'caseIgnoreListSubstringsMatch',
        u'storedPrefixMatch',
        u'booleanMatch',
        u'integerMatch',
        u'integerOrderingMatch',
        u'bitStringMatch',
        u'octetStringMatch',
        u'octetStringOrderingMatch',
        u'octetStringSubstringsMatch',
        u'telephoneNumberMatch',
        u'telephoneNumberSubstringsMatch',
        u'presentationAddressMatch',
        u'uniqueMemberMatch',
        u'protocolInformationMatch',
        u'facsimileNumberMatch',
        u'facsimileNumberSubstringsMatch',
        u'uUIDPairMatch',
        u'uTCTimeMatch',
        u'uTCTimeOrderingMatch',
        u'generalizedTimeMatch',
        u'generalizedTimeOrderingMatch',
        u'systemProposedMatch',
        u'integerFirstComponentMatch',
        u'objectIdentifierFirstComponentMatch',
        u'directoryStringFirstComponentMatch',
        u'wordMatch',
        u'keywordMatch',
        u'generalWordMatch',
        u'sequenceMatchType',
        u'wordMatchTypes',
        u'characterMatchTypes',
        u'selectedContexts',
        u'approximateStringMatch',
        u'ignoreIfAbsentMatch',
        u'nullMatch',
        u'zonalMatch',
        u'uriMatch',
        u'dnsNameMatch',
        u'caseExactIA5Match',
        u'caseIgnoreIA5Match',
        u'caseIgnoreIA5SubstringsMatch',
        u'utmCoords',
        u'uiiForm',
        u'epcForm',
        u'countryString3c',
        u'countryString3n',
        u'dnsString',
        u'attributeTypeDescription',
        u'bitString',
        u'boolean',
        u'countryString',
        u'dn',
        u'deliveryMethod',
        u'directoryString',
        u'dITContentRuleDescription',
        u'dITStructureRuleDescription',
        u'enhancedGuide',
        u'facsimileTelephoneNr',
        u'fax',
        u'generalizedTime',
        u'guide',
        u'ia5String',
        u'integer',
        u'jpeg',
        u'matchingRuleDescription',
        u'matchingRuleUseDescription',
        u'nameAndOptionalUID',
        u'nameFormDescription',
        u'numericString',
        u'objectClassDescription',
        u'oid',
        u'otherMailbox',
        u'octetString',
        u'postalAddr',
        u'presentationAddr',
        u'printableString',
        u'subtreeSpec',
        u'telephoneNr',
        u'telexNr',
        u'utcTime',
        u'ldapSyntaxDescription',
        u'substringAssertion',
        u'languageContext',
        u'temporalContext',
        u'localeContext',
        u'ldapAttributeOptionContext',
        u'id-at-knowledgeInformation',
        u'id-at-commonName',
        u'id-at-surname',
        u'id-at-serialNumber',
        u'id-at-countryName',
        u'id-at-localityName',
        u'id-at-collectiveLocalityName',
        u'id-at-stateOrProvinceName',
        u'id-at-collectiveStateOrProvinceName',
        u'id-at-streetAddress',
        u'id-at-collectiveStreetAddress',
        u'id-at-organizationName',
        u'id-at-collectiveOrganizationName',
        u'id-at-organizationalUnitName',
        u'id-at-collectiveOrganizationalUnitName',
        u'id-at-title',
        u'id-at-description',
        u'id-at-searchGuide',
        u'id-at-businessCategory',
        u'id-at-postalAddress',
        u'id-at-collectivePostalAddress',
        u'id-at-postalCode',
        u'id-at-collectivePostalCode',
        u'id-at-postOfficeBox',
        u'id-at-collectivePostOfficeBox',
        u'id-at-physicalDeliveryOfficeName',
        u'id-at-collectivePhysicalDeliveryOfficeName',
        u'id-at-telephoneNumber',
        u'id-at-collectiveTelephoneNumber',
        u'id-at-telexNumber',
        u'id-at-collectiveTelexNumber',
        u'id-at-facsimileTelephoneNumber',
        u'id-at-collectiveFacsimileTelephoneNumber',
        u'id-at-x121Address',
        u'id-at-internationalISDNNumber',
        u'id-at-collectiveInternationalISDNNumber',
        u'id-at-registeredAddress',
        u'id-at-destinationIndicator',
        u'id-at-preferredDeliveryMethod',
        u'id-at-presentationAddress',
        u'id-at-supportedApplicationContext',
        u'id-at-member',
        u'id-at-owner',
        u'id-at-roleOccupant',
        u'id-at-seeAlso',
        u'id-at-name',
        u'id-at-givenName',
        u'id-at-initials',
        u'id-at-generationQualifier',
        u'id-at-uniqueIdentifier',
        u'id-at-dnQualifier',
        u'id-at-enhancedSearchGuide',
        u'id-at-protocolInformation',
        u'id-at-distinguishedName',
        u'id-at-uniqueMember',
        u'id-at-houseIdentifier',
        u'id-at-dmdName',
        u'id-at-pseudonym',
        u'id-at-communicationsService',
        u'id-at-communicationsNetwork',
        u'id-at-uuidpair',
        u'id-at-tagOid',
        u'id-at-uiiFormat',
        u'id-at-uiiInUrn',
        u'id-at-contentUrl',
        u'id-at-uri',
        u'id-at-urn',
        u'id-at-url',
        u'id-at-utmCoordinates',
        u'id-at-urnC',
        u'id-at-uii',
        u'id-at-epc',
        u'id-at-tagAfi',
        u'id-at-epcFormat',
        u'id-at-epcInUrn',
        u'id-at-ldapUrl',
        u'id-at-tagLocation',
        u'id-at-organizationIdentifier',
        u'id-at-countryCode3c',
        u'id-at-countryCode3n',
        u'id-at-dnsName',
        u'id-asx-utmCoords',
        u'id-asx-uiiForm',
        u'id-asx-epcForm',
        u'id-asx-countryString3c',
        u'id-asx-countryString3n',
        u'id-asx-dnsString',
        u'id-lsx-attributeTypeDescription',
        u'id-lsx-bitString',
        u'id-lsx-boolean',
        u'id-lsx-countryString',
        u'id-lsx-dn',
        u'id-lsx-deliveryMethod',
        u'id-lsx-directoryString',
        u'id-lsx-dITContentRuleDescription',
        u'id-lsx-dITStructureRuleDescription',
        u'id-lsx-enhancedGuide',
        u'id-lsx-facsimileTelephoneNr',
        u'id-lsx-fax',
        u'id-lsx-generalizedTime',
        u'id-lsx-guide',
        u'id-lsx-ia5String',
        u'id-lsx-integer',
        u'id-lsx-jpeg',
        u'id-lsx-matchingRuleDescription',
        u'id-lsx-matchingRuleUseDescription',
        u'id-lsx-nameAndOptionalUID',
        u'id-lsx-nameFormDescription',
        u'id-lsx-numericString',
        u'id-lsx-objectClassDescription',
        u'id-lsx-oid',
        u'id-lsx-otherMailbox',
        u'id-lsx-octetString',
        u'id-lsx-postalAddr',
        u'id-lsx-presentationAddr',
        u'id-lsx-printableString',
        u'id-lsx-subtreeSpec',
        u'id-lsx-telephoneNr',
        u'id-lsx-telexNr',
        u'id-lsx-utcTime',
        u'id-lsx-ldapSyntaxDescription',
        u'id-lsx-substringAssertion',
        u'id-oidC1',
        u'id-oidC2',
        u'id-oidC',
        u'id-cat-sequenceMatchType',
        u'id-cat-wordMatchType',
        u'id-cat-characterMatchTypes',
        u'id-cat-selectedContexts',
        u'id-not-dSAProblem',
        u'id-not-searchServiceProblem',
        u'id-not-serviceType',
        u'id-not-attributeTypeList',
        u'id-not-matchingRuleList',
        u'id-not-filterItem',
        u'id-not-attributeCombinations',
        u'id-not-contextTypeList',
        u'id-not-contextList',
        u'id-not-contextCombinations',
        u'id-not-hierarchySelectList',
        u'id-not-searchControlOptionsList',
        u'id-not-serviceControlOptionsList',
        u'id-not-multipleMatchingLocalities',
        u'id-not-proposedRelaxation',
        u'id-not-appliedRelaxation',
        u'id-not-pwdResponse',
        u'id-not-ldapDiagnosticMsg',
        u'id-pr-targetDsaUnavailable',
        u'id-pr-dataSourceUnavailable',
        u'id-pr-unidentifiedOperation',
        u'id-pr-unavailableOperation',
        u'id-pr-searchAttributeViolation',
        u'id-pr-searchAttributeCombinationViolation',
        u'id-pr-searchValueNotAllowed',
        u'id-pr-missingSearchAttribute',
        u'id-pr-searchValueViolation',
        u'id-pr-attributeNegationViolation',
        u'id-pr-searchValueRequired',
        u'id-pr-invalidSearchValue',
        u'id-pr-searchContextViolation',
        u'id-pr-searchContextCombinationViolation',
        u'id-pr-missingSearchContext',
        u'id-pr-searchContextValueViolation',
        u'id-pr-searchContextValueRequired',
        u'id-pr-invalidContextSearchValue',
        u'id-pr-unsupportedMatchingRule',
        u'id-pr-attributeMatchingViolation',
        u'id-pr-unsupportedMatchingUse',
        u'id-pr-matchingUseViolation',
        u'id-pr-hierarchySelectForbidden',
        u'id-pr-invalidHierarchySelect',
        u'id-pr-unavailableHierarchySelect',
        u'id-pr-invalidSearchControlOptions',
        u'id-pr-invalidServiceControlOptions',
        u'id-pr-searchSubsetViolation',
        u'id-pr-unmatchedKeyAttributes',
        u'id-pr-ambiguousKeyAttributes',
        u'id-pr-unavailableRelaxationLevel',
        u'id-pr-emptyHierarchySelection',
        u'id-pr-administratorImposedLimit',
        u'id-pr-permanentRestriction',
        u'id-pr-temporaryRestriction',
        u'id-pr-relaxationNotSupported',
        u'id-coat-uid',
        u'id-coat-dc',
        u'id-mr-caseIgnoreMatch',
        u'id-mr-caseIgnoreOrderingMatch',
        u'id-mr-caseIgnoreSubstringsMatch',
        u'id-mr-caseExactMatch',
        u'id-mr-caseExactOrderingMatch',
        u'id-mr-caseExactSubstringsMatch',
        u'id-mr-numericStringMatch',
        u'id-mr-numericStringOrderingMatch',
        u'id-mr-numericStringSubstringsMatch',
        u'id-mr-caseIgnoreListMatch',
        u'id-mr-caseIgnoreListSubstringsMatch',
        u'id-mr-booleanMatch',
        u'id-mr-integerMatch',
        u'id-mr-integerOrderingMatch',
        u'id-mr-bitStringMatch',
        u'id-mr-octetStringMatch',
        u'id-mr-octetStringOrderingMatch',
        u'id-mr-octetStringSubstringsMatch',
        u'id-mr-telephoneNumberMatch',
        u'id-mr-telephoneNumberSubstringsMatch',
        u'id-mr-presentationAddressMatch',
        u'id-mr-uniqueMemberMatch',
        u'id-mr-protocolInformationMatch',
        u'id-mr-uTCTimeMatch',
        u'id-mr-uTCTimeOrderingMatch',
        u'id-mr-generalizedTimeMatch',
        u'id-mr-generalizedTimeOrderingMatch',
        u'id-mr-integerFirstComponentMatch',
        u'id-mr-objectIdentifierFirstComponentMatch',
        u'id-mr-directoryStringFirstComponentMatch',
        u'id-mr-wordMatch',
        u'id-mr-keywordMatch',
        u'id-mr-storedPrefixMatch',
        u'id-mr-systemProposedMatch',
        u'id-mr-generalWordMatch',
        u'id-mr-approximateStringMatch',
        u'id-mr-ignoreIfAbsentMatch',
        u'id-mr-nullMatch',
        u'id-mr-zonalMatch',
        u'id-mr-facsimileNumberMatch',
        u'id-mr-facsimileNumberSubstringsMatch',
        u'id-mr-uuidpairmatch',
        u'id-mr-uriMatch',
        u'id-mr-dnsNameMatch',
        u'id-lmr-caseExactIA5Match',
        u'id-lmr-caseIgnoreIA5Match',
        u'id-lmr-caseIgnoreIA5SubstringsMatch',
        u'id-avc-language',
        u'id-avc-temporal',
        u'id-avc-locale',
        u'id-avc-ldapAttributeOption',
        ]
    _class_ = [
        u'knowledgeInformation',
        u'name',
        u'commonName',
        u'surname',
        u'givenName',
        u'initials',
        u'generationQualifier',
        u'uniqueIdentifier',
        u'dnQualifier',
        u'serialNumber',
        u'pseudonym',
        u'uUIDPair',
        u'uri',
        u'urn',
        u'url',
        u'dnsName',
        u'countryName',
        u'countryCode3c',
        u'countryCode3n',
        u'localityName',
        u'collectiveLocalityName',
        u'stateOrProvinceName',
        u'collectiveStateOrProvinceName',
        u'streetAddress',
        u'collectiveStreetAddress',
        u'houseIdentifier',
        u'utmCoordinates',
        u'organizationName',
        u'collectiveOrganizationName',
        u'organizationalUnitName',
        u'collectiveOrganizationalUnitName',
        u'title',
        u'organizationIdentifier',
        u'description',
        u'searchGuide',
        u'enhancedSearchGuide',
        u'businessCategory',
        u'postalAddress',
        u'collectivePostalAddress',
        u'postalCode',
        u'collectivePostalCode',
        u'postOfficeBox',
        u'collectivePostOfficeBox',
        u'physicalDeliveryOfficeName',
        u'collectivePhysicalDeliveryOfficeName',
        u'telephoneNumber',
        u'collectiveTelephoneNumber',
        u'telexNumber',
        u'collectiveTelexNumber',
        u'facsimileTelephoneNumber',
        u'collectiveFacsimileTelephoneNumber',
        u'x121Address',
        u'internationalISDNNumber',
        u'collectiveInternationalISDNNumber',
        u'registeredAddress',
        u'destinationIndicator',
        u'communicationsService',
        u'communicationsNetwork',
        u'preferredDeliveryMethod',
        u'presentationAddress',
        u'supportedApplicationContext',
        u'protocolInformation',
        u'distinguishedName',
        u'member',
        u'uniqueMember',
        u'owner',
        u'roleOccupant',
        u'seeAlso',
        u'dmdName',
        u'oidC1',
        u'oidC2',
        u'oidC',
        u'urnC',
        u'tagOid',
        u'uiiFormat',
        u'uiiInUrn',
        u'contentUrl',
        u'uii',
        u'epc',
        u'tagAfi',
        u'epcFormat',
        u'epcInUrn',
        u'ldapUrl',
        u'tagLocation',
        u'dSAProblem',
        u'searchServiceProblem',
        u'serviceType',
        u'attributeTypeList',
        u'matchingRuleList',
        u'filterItem',
        u'attributeCombinations',
        u'contextTypeList',
        u'contextList',
        u'contextCombinations',
        u'hierarchySelectList',
        u'searchControlOptionsList',
        u'serviceControlOptionsList',
        u'multipleMatchingLocalities',
        u'proposedRelaxation',
        u'appliedRelaxation',
        u'pwdResponseValue',
        u'ldapDiagnosticMsg',
        u'uid',
        u'dc',
        u'caseExactMatch',
        u'caseIgnoreMatch',
        u'caseExactOrderingMatch',
        u'caseIgnoreOrderingMatch',
        u'caseExactSubstringsMatch',
        u'caseIgnoreSubstringsMatch',
        u'numericStringMatch',
        u'numericStringOrderingMatch',
        u'numericStringSubstringsMatch',
        u'caseIgnoreListMatch',
        u'caseIgnoreListSubstringsMatch',
        u'storedPrefixMatch',
        u'booleanMatch',
        u'integerMatch',
        u'integerOrderingMatch',
        u'bitStringMatch',
        u'octetStringMatch',
        u'octetStringOrderingMatch',
        u'octetStringSubstringsMatch',
        u'telephoneNumberMatch',
        u'telephoneNumberSubstringsMatch',
        u'presentationAddressMatch',
        u'uniqueMemberMatch',
        u'protocolInformationMatch',
        u'facsimileNumberMatch',
        u'facsimileNumberSubstringsMatch',
        u'uUIDPairMatch',
        u'uTCTimeMatch',
        u'uTCTimeOrderingMatch',
        u'generalizedTimeMatch',
        u'generalizedTimeOrderingMatch',
        u'systemProposedMatch',
        u'integerFirstComponentMatch',
        u'objectIdentifierFirstComponentMatch',
        u'directoryStringFirstComponentMatch',
        u'wordMatch',
        u'keywordMatch',
        u'generalWordMatch',
        u'sequenceMatchType',
        u'wordMatchTypes',
        u'characterMatchTypes',
        u'selectedContexts',
        u'approximateStringMatch',
        u'ignoreIfAbsentMatch',
        u'nullMatch',
        u'ZONAL-MATCHING',
        u'zonalMatch',
        u'uriMatch',
        u'dnsNameMatch',
        u'caseExactIA5Match',
        u'caseIgnoreIA5Match',
        u'caseIgnoreIA5SubstringsMatch',
        u'utmCoords',
        u'uiiForm',
        u'epcForm',
        u'countryString3c',
        u'countryString3n',
        u'dnsString',
        u'attributeTypeDescription',
        u'bitString',
        u'boolean',
        u'countryString',
        u'dn',
        u'deliveryMethod',
        u'directoryString',
        u'dITContentRuleDescription',
        u'dITStructureRuleDescription',
        u'enhancedGuide',
        u'facsimileTelephoneNr',
        u'fax',
        u'generalizedTime',
        u'guide',
        u'ia5String',
        u'integer',
        u'jpeg',
        u'matchingRuleDescription',
        u'matchingRuleUseDescription',
        u'nameAndOptionalUID',
        u'nameFormDescription',
        u'numericString',
        u'objectClassDescription',
        u'oid',
        u'otherMailbox',
        u'octetString',
        u'postalAddr',
        u'presentationAddr',
        u'printableString',
        u'subtreeSpec',
        u'telephoneNr',
        u'telexNr',
        u'utcTime',
        u'ldapSyntaxDescription',
        u'substringAssertion',
        u'languageContext',
        u'temporalContext',
        u'localeContext',
        u'ldapAttributeOptionContext',
        ]
    _param_ = [
        u'DirectoryString',
        ]
    
    #-----< UnboundedDirectoryString >-----#
    UnboundedDirectoryString = CHOICE(name=u'UnboundedDirectoryString', mode=MODE_TYPE)
    _UnboundedDirectoryString_teletexString = STR_TELE(name=u'teletexString', mode=MODE_TYPE)
    _UnboundedDirectoryString_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UnboundedDirectoryString_printableString = STR_PRINT(name=u'printableString', mode=MODE_TYPE)
    _UnboundedDirectoryString_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UnboundedDirectoryString_bmpString = STR_BMP(name=u'bmpString', mode=MODE_TYPE)
    _UnboundedDirectoryString_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UnboundedDirectoryString_universalString = STR_UNIV(name=u'universalString', mode=MODE_TYPE)
    _UnboundedDirectoryString_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _UnboundedDirectoryString_uTF8String = STR_UTF8(name=u'uTF8String', mode=MODE_TYPE)
    _UnboundedDirectoryString_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    UnboundedDirectoryString._cont = ASN1Dict([
        (u'teletexString', _UnboundedDirectoryString_teletexString),
        (u'printableString', _UnboundedDirectoryString_printableString),
        (u'bmpString', _UnboundedDirectoryString_bmpString),
        (u'universalString', _UnboundedDirectoryString_universalString),
        (u'uTF8String', _UnboundedDirectoryString_uTF8String),
        ])
    UnboundedDirectoryString._ext = None
    
    #-----< DirectoryString >-----#
    DirectoryString = CHOICE(name=u'DirectoryString', mode=MODE_TYPE, param=True)
    
    #-----< knowledgeInformation >-----#
    knowledgeInformation = CLASS(name=u'knowledgeInformation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _knowledgeInformation_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __ATTRIBUTE_equality_match_val_AssertionType = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    knowledgeInformation._val = dict([(u'Type', _knowledgeInformation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'obsolete', True), (u'id', (2, 5, 4, 2))])
    
    #-----< name >-----#
    name = CLASS(name=u'name', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _name_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __ATTRIBUTE_substrings_match_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    name._val = dict([(u'Type', _name_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])
    
    #-----< commonName >-----#
    commonName = CLASS(name=u'commonName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    _commonName_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    commonName._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', _commonName_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'cn', u'commonName']), (u'id', (2, 5, 4, 3))])
    
    #-----< surname >-----#
    surname = CLASS(name=u'surname', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _surname_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    surname._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', _surname_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'sn']), (u'id', (2, 5, 4, 4))])
    
    #-----< givenName >-----#
    givenName = CLASS(name=u'givenName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _givenName_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    givenName._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', _givenName_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'givenName']), (u'id', (2, 5, 4, 42))])
    
    #-----< initials >-----#
    initials = CLASS(name=u'initials', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _initials_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    initials._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', _initials_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'initials']), (u'id', (2, 5, 4, 43))])
    
    #-----< generationQualifier >-----#
    generationQualifier = CLASS(name=u'generationQualifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _generationQualifier_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    generationQualifier._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', _generationQualifier_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'generationQualifier']), (u'id', (2, 5, 4, 44))])
    
    #-----< uniqueIdentifier >-----#
    uniqueIdentifier = CLASS(name=u'uniqueIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uniqueIdentifier_val_Type = BIT_STR(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')))
    __ATTRIBUTE_equality_match_val_AssertionType_0 = BIT_STR(name=u'AssertionType', mode=MODE_TYPE)
    uniqueIdentifier._val = dict([(u'Type', _uniqueIdentifier_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), (u'ldapName', [u'bitStringMatch']), (u'id', (2, 5, 13, 16))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), (u'ldapName', [u'x500UniqueIdentifier']), (u'id', (2, 5, 4, 45))])
    
    #-----< UniqueIdentifier >-----#
    UniqueIdentifier = BIT_STR(name=u'UniqueIdentifier', mode=MODE_TYPE)
    
    #-----< dnQualifier >-----#
    dnQualifier = CLASS(name=u'dnQualifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dnQualifier_val_Type = STR_PRINT(name=u'Type', mode=MODE_TYPE)
    __ATTRIBUTE_ordering_match_val_AssertionType = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    dnQualifier._val = dict([(u'Type', _dnQualifier_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'ordering-match', dict([(u'AssertionType', __ATTRIBUTE_ordering_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreOrderingMatch']), (u'id', (2, 5, 13, 3))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), (u'ldapName', [u'dnQualifier']), (u'id', (2, 5, 4, 46))])
    
    #-----< serialNumber >-----#
    serialNumber = CLASS(name=u'serialNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _serialNumber_val_Type = STR_PRINT(name=u'Type', mode=MODE_TYPE)
    _serialNumber_val_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    serialNumber._val = dict([(u'Type', _serialNumber_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), (u'ldapName', [u'serialNumber']), (u'id', (2, 5, 4, 5))])
    
    #-----< pseudonym >-----#
    pseudonym = CLASS(name=u'pseudonym', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pseudonym_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    pseudonym._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', _pseudonym_val_Type), (u'id', (2, 5, 4, 65))])
    
    #-----< uUIDPair >-----#
    uUIDPair = CLASS(name=u'uUIDPair', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uUIDPair_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UUIDPair')))
    __ATTRIBUTE_equality_match_val_AssertionType_1 = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UUIDPair')))
    uUIDPair._val = dict([(u'Type', _uUIDPair_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_1), (u'id', (2, 5, 13, 68))])), (u'id', (2, 5, 4, 77))])
    
    #-----< UUIDPair >-----#
    UUIDPair = SEQ(name=u'UUIDPair', mode=MODE_TYPE)
    _UUIDPair_issuerUUID = OCT_STR(name=u'issuerUUID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UUID')))
    _UUIDPair_subjectUUID = OCT_STR(name=u'subjectUUID', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UUID')))
    UUIDPair._cont = ASN1Dict([
        (u'issuerUUID', _UUIDPair_issuerUUID),
        (u'subjectUUID', _UUIDPair_subjectUUID),
        ])
    UUIDPair._ext = []
    
    #-----< UUID >-----#
    UUID = OCT_STR(name=u'UUID', mode=MODE_TYPE)
    UUID._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< uri >-----#
    uri = CLASS(name=u'uri', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uri_val_Type = STR_UTF8(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'URI')))
    __ATTRIBUTE_equality_match_val_AssertionType_2 = STR_UTF8(name=u'AssertionType', mode=MODE_TYPE)
    uri._val = dict([(u'Type', _uri_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uriMatch']), (u'id', (2, 5, 13, 70))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uri']), (u'id', (2, 5, 4, 83))])
    
    #-----< URI >-----#
    URI = STR_UTF8(name=u'URI', mode=MODE_TYPE)
    
    #-----< urn >-----#
    urn = CLASS(name=u'urn', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_0 = STR_UTF8(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'URI')))
    urn._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_0), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uriMatch']), (u'id', (2, 5, 13, 70))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uri']), (u'id', (2, 5, 4, 83))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'urn']), (u'id', (2, 5, 4, 86))])
    
    #-----< url >-----#
    url = CLASS(name=u'url', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    url._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_0), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uriMatch']), (u'id', (2, 5, 13, 70))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uri']), (u'id', (2, 5, 4, 83))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'url']), (u'id', (2, 5, 4, 87))])
    
    #-----< dnsName >-----#
    dnsName = CLASS(name=u'dnsName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dnsName_val_Type = STR_UTF8(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DomainName')))
    __ATTRIBUTE_equality_match_val_AssertionType_3 = STR_UTF8(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DomainName')))
    dnsName._val = dict([(u'Type', _dnsName_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_3), (u'ldapSyntax', (2, 5, 40, 9)), (u'ldapName', [u'dnsNameMatch']), (u'id', (2, 5, 13, 74))])), (u'ldapSyntax', (2, 5, 40, 9)), (u'ldapName', [u'DNS name']), (u'id', (2, 5, 4, 100))])
    
    #-----< DomainName >-----#
    DomainName = STR_UTF8(name=u'DomainName', mode=MODE_TYPE)
    
    #-----< countryName >-----#
    countryName = CLASS(name=u'countryName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _countryName_val_Type = STR_PRINT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CountryName')))
    countryName._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', _countryName_val_Type), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 11)), (u'ldapName', [u'c']), (u'id', (2, 5, 4, 6))])
    
    #-----< CountryName >-----#
    CountryName = STR_PRINT(name=u'CountryName', mode=MODE_TYPE)
    CountryName._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< countryCode3c >-----#
    countryCode3c = CLASS(name=u'countryCode3c', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _countryCode3c_val_Type = STR_PRINT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CountryCode3c')))
    countryCode3c._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', _countryCode3c_val_Type), (u'single-valued', True), (u'ldapSyntax', (2, 5, 40, 7)), (u'ldapName', [u'c3']), (u'id', (2, 5, 4, 98))])
    
    #-----< CountryCode3c >-----#
    CountryCode3c = STR_PRINT(name=u'CountryCode3c', mode=MODE_TYPE)
    CountryCode3c._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< countryCode3n >-----#
    countryCode3n = CLASS(name=u'countryCode3n', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _countryCode3n_val_Type = STR_NUM(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CountryCode3n')))
    countryCode3n._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', _countryCode3n_val_Type), (u'single-valued', True), (u'ldapSyntax', (2, 5, 40, 8)), (u'ldapName', [u'n3']), (u'id', (2, 5, 4, 99))])
    
    #-----< CountryCode3n >-----#
    CountryCode3n = STR_NUM(name=u'CountryCode3n', mode=MODE_TYPE)
    CountryCode3n._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< localityName >-----#
    localityName = CLASS(name=u'localityName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _localityName_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    localityName._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', _localityName_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'l']), (u'id', (2, 5, 4, 7))])
    
    #-----< collectiveLocalityName >-----#
    collectiveLocalityName = CLASS(name=u'collectiveLocalityName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectiveLocalityName._val = dict([(u'derivation', dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', __ATTRIBUTE_derivation_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'l']), (u'id', (2, 5, 4, 7))])), (u'collective', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'c-l']), (u'id', (2, 5, 4, 7, 1))])
    
    #-----< stateOrProvinceName >-----#
    stateOrProvinceName = CLASS(name=u'stateOrProvinceName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _stateOrProvinceName_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    stateOrProvinceName._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', _stateOrProvinceName_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'st']), (u'id', (2, 5, 4, 8))])
    
    #-----< collectiveStateOrProvinceName >-----#
    collectiveStateOrProvinceName = CLASS(name=u'collectiveStateOrProvinceName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectiveStateOrProvinceName._val = dict([(u'derivation', dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', __ATTRIBUTE_derivation_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'st']), (u'id', (2, 5, 4, 8))])), (u'collective', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'c-st']), (u'id', (2, 5, 4, 8, 1))])
    
    #-----< streetAddress >-----#
    streetAddress = CLASS(name=u'streetAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _streetAddress_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    streetAddress._val = dict([(u'Type', _streetAddress_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'street']), (u'id', (2, 5, 4, 9))])
    
    #-----< collectiveStreetAddress >-----#
    collectiveStreetAddress = CLASS(name=u'collectiveStreetAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectiveStreetAddress._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'street']), (u'id', (2, 5, 4, 9))])), (u'collective', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'c-street']), (u'id', (2, 5, 4, 9, 1))])
    
    #-----< houseIdentifier >-----#
    houseIdentifier = CLASS(name=u'houseIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _houseIdentifier_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    houseIdentifier._val = dict([(u'Type', _houseIdentifier_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'houseIdentifier']), (u'id', (2, 5, 4, 51))])
    
    #-----< utmCoordinates >-----#
    utmCoordinates = CLASS(name=u'utmCoordinates', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _utmCoordinates_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UtmCoordinates')))
    utmCoordinates._val = dict([(u'Type', _utmCoordinates_val_Type), (u'single-valued', True), (u'ldapSyntax', (2, 5, 40, 4)), (u'ldapName', [u'utmCoordinates']), (u'id', (2, 5, 4, 88))])
    
    #-----< UtmCoordinates >-----#
    UtmCoordinates = SEQ(name=u'UtmCoordinates', mode=MODE_TYPE)
    _UtmCoordinates_zone = STR_PRINT(name=u'zone', mode=MODE_TYPE)
    _UtmCoordinates_easting = STR_NUM(name=u'easting', mode=MODE_TYPE)
    _UtmCoordinates_northing = STR_NUM(name=u'northing', mode=MODE_TYPE)
    UtmCoordinates._cont = ASN1Dict([
        (u'zone', _UtmCoordinates_zone),
        (u'easting', _UtmCoordinates_easting),
        (u'northing', _UtmCoordinates_northing),
        ])
    UtmCoordinates._ext = None
    
    #-----< organizationName >-----#
    organizationName = CLASS(name=u'organizationName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _organizationName_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    organizationName._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', _organizationName_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'o']), (u'id', (2, 5, 4, 10))])
    
    #-----< collectiveOrganizationName >-----#
    collectiveOrganizationName = CLASS(name=u'collectiveOrganizationName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectiveOrganizationName._val = dict([(u'derivation', dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', __ATTRIBUTE_derivation_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'o']), (u'id', (2, 5, 4, 10))])), (u'collective', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'c-o']), (u'id', (2, 5, 4, 10, 1))])
    
    #-----< organizationalUnitName >-----#
    organizationalUnitName = CLASS(name=u'organizationalUnitName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _organizationalUnitName_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    organizationalUnitName._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', _organizationalUnitName_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'ou']), (u'id', (2, 5, 4, 11))])
    
    #-----< collectiveOrganizationalUnitName >-----#
    collectiveOrganizationalUnitName = CLASS(name=u'collectiveOrganizationalUnitName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectiveOrganizationalUnitName._val = dict([(u'derivation', dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', __ATTRIBUTE_derivation_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'ou']), (u'id', (2, 5, 4, 11))])), (u'collective', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'c-ou']), (u'id', (2, 5, 4, 11, 1))])
    
    #-----< title >-----#
    title = CLASS(name=u'title', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _title_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    title._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', _title_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'title']), (u'id', (2, 5, 4, 12))])
    
    #-----< organizationIdentifier >-----#
    organizationIdentifier = CLASS(name=u'organizationIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _organizationIdentifier_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    organizationIdentifier._val = dict([(u'Type', _organizationIdentifier_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'organizationIdentifier']), (u'id', (2, 5, 4, 97))])
    
    #-----< description >-----#
    description = CLASS(name=u'description', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _description_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    description._val = dict([(u'Type', _description_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'description']), (u'id', (2, 5, 4, 13))])
    
    #-----< searchGuide >-----#
    searchGuide = CLASS(name=u'searchGuide', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _searchGuide_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'Guide')))
    searchGuide._val = dict([(u'Type', _searchGuide_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 25)), (u'ldapName', [u'searchGuide']), (u'id', (2, 5, 4, 14))])
    
    #-----< Guide >-----#
    Guide = SET(name=u'Guide', mode=MODE_TYPE)
    _Guide_objectClass = OID(name=u'objectClass', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']), opt=True)
    _Guide_criteria = CHOICE(name=u'criteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'Criteria')))
    Guide._cont = ASN1Dict([
        (u'objectClass', _Guide_objectClass),
        (u'criteria', _Guide_criteria),
        ])
    Guide._ext = []
    
    #-----< Criteria >-----#
    Criteria = CHOICE(name=u'Criteria', mode=MODE_TYPE)
    _Criteria_type = CHOICE(name=u'type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'CriteriaItem')))
    _Criteria_and_ = SET_OF(name=u'and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Criteria_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'Criteria')))
    _Criteria_and_._cont = __Criteria_and___item_
    _Criteria_or_ = SET_OF(name=u'or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __Criteria_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'Criteria')))
    _Criteria_or_._cont = __Criteria_or___item_
    _Criteria_not_ = CHOICE(name=u'not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'Criteria')))
    Criteria._cont = ASN1Dict([
        (u'type', _Criteria_type),
        (u'and', _Criteria_and_),
        (u'or', _Criteria_or_),
        (u'not', _Criteria_not_),
        ])
    Criteria._ext = []
    
    #-----< CriteriaItem >-----#
    CriteriaItem = CHOICE(name=u'CriteriaItem', mode=MODE_TYPE)
    _CriteriaItem_equality = OID(name=u'equality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _CriteriaItem_substrings = OID(name=u'substrings', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _CriteriaItem_greaterOrEqual = OID(name=u'greaterOrEqual', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _CriteriaItem_lessOrEqual = OID(name=u'lessOrEqual', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _CriteriaItem_approximateMatch = OID(name=u'approximateMatch', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    CriteriaItem._cont = ASN1Dict([
        (u'equality', _CriteriaItem_equality),
        (u'substrings', _CriteriaItem_substrings),
        (u'greaterOrEqual', _CriteriaItem_greaterOrEqual),
        (u'lessOrEqual', _CriteriaItem_lessOrEqual),
        (u'approximateMatch', _CriteriaItem_approximateMatch),
        ])
    CriteriaItem._ext = []
    
    #-----< enhancedSearchGuide >-----#
    enhancedSearchGuide = CLASS(name=u'enhancedSearchGuide', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _enhancedSearchGuide_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'EnhancedGuide')))
    enhancedSearchGuide._val = dict([(u'Type', _enhancedSearchGuide_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 21)), (u'ldapName', [u'enhancedSearchGuide']), (u'id', (2, 5, 4, 47))])
    
    #-----< EnhancedGuide >-----#
    EnhancedGuide = SEQ(name=u'EnhancedGuide', mode=MODE_TYPE)
    _EnhancedGuide_objectClass = OID(name=u'objectClass', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']))
    _EnhancedGuide_criteria = CHOICE(name=u'criteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'Criteria')))
    _EnhancedGuide_subset = INT(name=u'subset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=1)
    _EnhancedGuide_subset._cont = ASN1Dict([(u'baseObject', 0), (u'oneLevel', 1), (u'wholeSubtree', 2)])
    EnhancedGuide._cont = ASN1Dict([
        (u'objectClass', _EnhancedGuide_objectClass),
        (u'criteria', _EnhancedGuide_criteria),
        (u'subset', _EnhancedGuide_subset),
        ])
    EnhancedGuide._ext = []
    
    #-----< businessCategory >-----#
    businessCategory = CLASS(name=u'businessCategory', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _businessCategory_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    businessCategory._val = dict([(u'Type', _businessCategory_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'businessCategory']), (u'id', (2, 5, 4, 15))])
    
    #-----< postalAddress >-----#
    postalAddress = CLASS(name=u'postalAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _postalAddress_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PostalAddress')))
    __ATTRIBUTE_equality_match_val_AssertionType_4 = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CaseIgnoreList')))
    postalAddress._val = dict([(u'Type', _postalAddress_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), (u'ldapName', [u'caseIgnoreListMatch']), (u'id', (2, 5, 13, 11))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreListSubstringsMatch']), (u'id', (2, 5, 13, 12))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), (u'ldapName', [u'postalAddress']), (u'id', (2, 5, 4, 16))])
    
    #-----< PostalAddress >-----#
    PostalAddress = SEQ_OF(name=u'PostalAddress', mode=MODE_TYPE)
    _PostalAddress__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    PostalAddress._cont = _PostalAddress__item_
    PostalAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< collectivePostalAddress >-----#
    collectivePostalAddress = CLASS(name=u'collectivePostalAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PostalAddress')))
    collectivePostalAddress._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_1), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), (u'ldapName', [u'caseIgnoreListMatch']), (u'id', (2, 5, 13, 11))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreListSubstringsMatch']), (u'id', (2, 5, 13, 12))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), (u'ldapName', [u'postalAddress']), (u'id', (2, 5, 4, 16))])), (u'collective', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), (u'ldapName', [u'c-PostalAddress']), (u'id', (2, 5, 4, 16, 1))])
    
    #-----< postalCode >-----#
    postalCode = CLASS(name=u'postalCode', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _postalCode_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    postalCode._val = dict([(u'Type', _postalCode_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'postalCode']), (u'id', (2, 5, 4, 17))])
    
    #-----< collectivePostalCode >-----#
    collectivePostalCode = CLASS(name=u'collectivePostalCode', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectivePostalCode._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'postalCode']), (u'id', (2, 5, 4, 17))])), (u'collective', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'c-PostalCode']), (u'id', (2, 5, 4, 17, 1))])
    
    #-----< postOfficeBox >-----#
    postOfficeBox = CLASS(name=u'postOfficeBox', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _postOfficeBox_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    postOfficeBox._val = dict([(u'Type', _postOfficeBox_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'postOfficeBox']), (u'id', (2, 5, 4, 18))])
    
    #-----< collectivePostOfficeBox >-----#
    collectivePostOfficeBox = CLASS(name=u'collectivePostOfficeBox', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectivePostOfficeBox._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'postOfficeBox']), (u'id', (2, 5, 4, 18))])), (u'collective', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'c-PostOfficeBox']), (u'id', (2, 5, 4, 18, 1))])
    
    #-----< physicalDeliveryOfficeName >-----#
    physicalDeliveryOfficeName = CLASS(name=u'physicalDeliveryOfficeName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _physicalDeliveryOfficeName_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    physicalDeliveryOfficeName._val = dict([(u'Type', _physicalDeliveryOfficeName_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'physicalDeliveryOfficeName']), (u'id', (2, 5, 4, 19))])
    
    #-----< collectivePhysicalDeliveryOfficeName >-----#
    collectivePhysicalDeliveryOfficeName = CLASS(name=u'collectivePhysicalDeliveryOfficeName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    collectivePhysicalDeliveryOfficeName._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'physicalDeliveryOfficeName']), (u'id', (2, 5, 4, 19))])), (u'collective', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'c-PhysicalDeliveryOfficeName']), (u'id', (2, 5, 4, 19, 1))])
    
    #-----< telephoneNumber >-----#
    telephoneNumber = CLASS(name=u'telephoneNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _telephoneNumber_val_Type = STR_PRINT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    __ATTRIBUTE_equality_match_val_AssertionType_5 = STR_PRINT(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    telephoneNumber._val = dict([(u'Type', _telephoneNumber_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_5), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 50)), (u'ldapName', [u'telephoneNumberMatch']), (u'id', (2, 5, 13, 20))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'telephoneNumberSubstringsMatch']), (u'id', (2, 5, 13, 21))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), (u'ldapName', [u'telephoneNumber']), (u'id', (2, 5, 4, 20))])
    
    #-----< TelephoneNumber >-----#
    TelephoneNumber = STR_PRINT(name=u'TelephoneNumber', mode=MODE_TYPE)
    TelephoneNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< ub-telephone-number >-----#
    ub_telephone_number = INT(name=u'ub-telephone-number', mode=MODE_VALUE)
    ub_telephone_number._val = 32
    
    #-----< collectiveTelephoneNumber >-----#
    collectiveTelephoneNumber = CLASS(name=u'collectiveTelephoneNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_2 = STR_PRINT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    collectiveTelephoneNumber._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_2), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_5), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 50)), (u'ldapName', [u'telephoneNumberMatch']), (u'id', (2, 5, 13, 20))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'telephoneNumberSubstringsMatch']), (u'id', (2, 5, 13, 21))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), (u'ldapName', [u'telephoneNumber']), (u'id', (2, 5, 4, 20))])), (u'collective', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), (u'ldapName', [u'c-TelephoneNumber']), (u'id', (2, 5, 4, 20, 1))])
    
    #-----< telexNumber >-----#
    telexNumber = CLASS(name=u'telexNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _telexNumber_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelexNumber')))
    telexNumber._val = dict([(u'Type', _telexNumber_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 52)), (u'ldapName', [u'telexNumber']), (u'id', (2, 5, 4, 21))])
    
    #-----< TelexNumber >-----#
    TelexNumber = SEQ(name=u'TelexNumber', mode=MODE_TYPE)
    _TelexNumber_telexNumber = STR_PRINT(name=u'telexNumber', mode=MODE_TYPE)
    _TelexNumber_telexNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    _TelexNumber_countryCode = STR_PRINT(name=u'countryCode', mode=MODE_TYPE)
    _TelexNumber_countryCode._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _TelexNumber_answerback = STR_PRINT(name=u'answerback', mode=MODE_TYPE)
    _TelexNumber_answerback._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    TelexNumber._cont = ASN1Dict([
        (u'telexNumber', _TelexNumber_telexNumber),
        (u'countryCode', _TelexNumber_countryCode),
        (u'answerback', _TelexNumber_answerback),
        ])
    TelexNumber._ext = []
    
    #-----< ub-telex-number >-----#
    ub_telex_number = INT(name=u'ub-telex-number', mode=MODE_VALUE)
    ub_telex_number._val = 14
    
    #-----< ub-country-code >-----#
    ub_country_code = INT(name=u'ub-country-code', mode=MODE_VALUE)
    ub_country_code._val = 4
    
    #-----< ub-answerback >-----#
    ub_answerback = INT(name=u'ub-answerback', mode=MODE_VALUE)
    ub_answerback._val = 8
    
    #-----< collectiveTelexNumber >-----#
    collectiveTelexNumber = CLASS(name=u'collectiveTelexNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_3 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelexNumber')))
    collectiveTelexNumber._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_3), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 52)), (u'ldapName', [u'telexNumber']), (u'id', (2, 5, 4, 21))])), (u'collective', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 52)), (u'ldapName', [u'c-TelexNumber']), (u'id', (2, 5, 4, 21, 1))])
    
    #-----< facsimileTelephoneNumber >-----#
    facsimileTelephoneNumber = CLASS(name=u'facsimileTelephoneNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _facsimileTelephoneNumber_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'FacsimileTelephoneNumber')))
    facsimileTelephoneNumber._val = dict([(u'Type', _facsimileTelephoneNumber_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_5), (u'id', (2, 5, 13, 63))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'id', (2, 5, 13, 64))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 22)), (u'ldapName', [u'facsimileTelephoneNumber']), (u'id', (2, 5, 4, 23))])
    
    #-----< FacsimileTelephoneNumber >-----#
    FacsimileTelephoneNumber = SEQ(name=u'FacsimileTelephoneNumber', mode=MODE_TYPE)
    _FacsimileTelephoneNumber_telephoneNumber = STR_PRINT(name=u'telephoneNumber', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    _FacsimileTelephoneNumber_parameters = BIT_STR(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefType(('PkiPmiExternalDataTypes', 'G3FacsimileNonBasicParameters')), opt=True)
    FacsimileTelephoneNumber._cont = ASN1Dict([
        (u'telephoneNumber', _FacsimileTelephoneNumber_telephoneNumber),
        (u'parameters', _FacsimileTelephoneNumber_parameters),
        ])
    FacsimileTelephoneNumber._ext = []
    
    #-----< collectiveFacsimileTelephoneNumber >-----#
    collectiveFacsimileTelephoneNumber = CLASS(name=u'collectiveFacsimileTelephoneNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_4 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'FacsimileTelephoneNumber')))
    collectiveFacsimileTelephoneNumber._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_4), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_5), (u'id', (2, 5, 13, 63))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'id', (2, 5, 13, 64))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 22)), (u'ldapName', [u'facsimileTelephoneNumber']), (u'id', (2, 5, 4, 23))])), (u'collective', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 22)), (u'ldapName', [u'c-FacsimileTelephoneNumber']), (u'id', (2, 5, 4, 23, 1))])
    
    #-----< x121Address >-----#
    x121Address = CLASS(name=u'x121Address', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _x121Address_val_Type = STR_NUM(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'X121Address')))
    __ATTRIBUTE_equality_match_val_AssertionType_6 = STR_NUM(name=u'AssertionType', mode=MODE_TYPE)
    x121Address._val = dict([(u'Type', _x121Address_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), (u'ldapName', [u'numericStringMatch']), (u'id', (2, 5, 13, 8))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'numericStringSubstringsMatch']), (u'id', (2, 5, 13, 10))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), (u'ldapName', [u'x121Address']), (u'id', (2, 5, 4, 24))])
    
    #-----< X121Address >-----#
    X121Address = STR_NUM(name=u'X121Address', mode=MODE_TYPE)
    X121Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< ub-x121-address >-----#
    ub_x121_address = INT(name=u'ub-x121-address', mode=MODE_VALUE)
    ub_x121_address._val = 15
    
    #-----< internationalISDNNumber >-----#
    internationalISDNNumber = CLASS(name=u'internationalISDNNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _internationalISDNNumber_val_Type = STR_NUM(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'InternationalISDNNumber')))
    internationalISDNNumber._val = dict([(u'Type', _internationalISDNNumber_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), (u'ldapName', [u'numericStringMatch']), (u'id', (2, 5, 13, 8))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'numericStringSubstringsMatch']), (u'id', (2, 5, 13, 10))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), (u'ldapName', [u'internationalISDNNumber']), (u'id', (2, 5, 4, 25))])
    
    #-----< InternationalISDNNumber >-----#
    InternationalISDNNumber = STR_NUM(name=u'InternationalISDNNumber', mode=MODE_TYPE)
    InternationalISDNNumber._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< ub-international-isdn-number >-----#
    ub_international_isdn_number = INT(name=u'ub-international-isdn-number', mode=MODE_VALUE)
    ub_international_isdn_number._val = 16
    
    #-----< collectiveInternationalISDNNumber >-----#
    collectiveInternationalISDNNumber = CLASS(name=u'collectiveInternationalISDNNumber', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_5 = STR_NUM(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'InternationalISDNNumber')))
    collectiveInternationalISDNNumber._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_5), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_6), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), (u'ldapName', [u'numericStringMatch']), (u'id', (2, 5, 13, 8))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'numericStringSubstringsMatch']), (u'id', (2, 5, 13, 10))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), (u'ldapName', [u'internationalISDNNumber']), (u'id', (2, 5, 4, 25))])), (u'collective', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), (u'ldapName', [u'c-InternationalISDNNumber']), (u'id', (2, 5, 4, 25, 1))])
    
    #-----< registeredAddress >-----#
    registeredAddress = CLASS(name=u'registeredAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _registeredAddress_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PostalAddress')))
    registeredAddress._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_1), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_4), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), (u'ldapName', [u'caseIgnoreListMatch']), (u'id', (2, 5, 13, 11))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreListSubstringsMatch']), (u'id', (2, 5, 13, 12))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), (u'ldapName', [u'postalAddress']), (u'id', (2, 5, 4, 16))])), (u'Type', _registeredAddress_val_Type), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), (u'ldapName', [u'registeredAddress']), (u'id', (2, 5, 4, 26))])
    
    #-----< destinationIndicator >-----#
    destinationIndicator = CLASS(name=u'destinationIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _destinationIndicator_val_Type = STR_PRINT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DestinationIndicator')))
    destinationIndicator._val = dict([(u'Type', _destinationIndicator_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), (u'ldapName', [u'destinationIndicator']), (u'id', (2, 5, 4, 27))])
    
    #-----< DestinationIndicator >-----#
    DestinationIndicator = STR_PRINT(name=u'DestinationIndicator', mode=MODE_TYPE)
    DestinationIndicator._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< communicationsService >-----#
    communicationsService = CLASS(name=u'communicationsService', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _communicationsService_val_Type = OID(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CommunicationsService')))
    __ATTRIBUTE_equality_match_val_AssertionType_7 = OID(name=u'AssertionType', mode=MODE_TYPE)
    communicationsService._val = dict([(u'Type', _communicationsService_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'communicationsService']), (u'id', (2, 5, 4, 66))])
    
    #-----< CommunicationsService >-----#
    CommunicationsService = OID(name=u'CommunicationsService', mode=MODE_TYPE)
    
    #-----< communicationsNetwork >-----#
    communicationsNetwork = CLASS(name=u'communicationsNetwork', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _communicationsNetwork_val_Type = OID(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CommunicationsNetwork')))
    communicationsNetwork._val = dict([(u'Type', _communicationsNetwork_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'communicationsNetwork']), (u'id', (2, 5, 4, 67))])
    
    #-----< CommunicationsNetwork >-----#
    CommunicationsNetwork = OID(name=u'CommunicationsNetwork', mode=MODE_TYPE)
    
    #-----< preferredDeliveryMethod >-----#
    preferredDeliveryMethod = CLASS(name=u'preferredDeliveryMethod', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _preferredDeliveryMethod_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PreferredDeliveryMethod')))
    preferredDeliveryMethod._val = dict([(u'Type', _preferredDeliveryMethod_val_Type), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 14)), (u'ldapName', [u'preferredDeliveryMethod']), (u'id', (2, 5, 4, 28))])
    
    #-----< PreferredDeliveryMethod >-----#
    PreferredDeliveryMethod = SEQ_OF(name=u'PreferredDeliveryMethod', mode=MODE_TYPE)
    _PreferredDeliveryMethod__item_ = INT(name='_item_', mode=MODE_TYPE)
    _PreferredDeliveryMethod__item_._cont = ASN1Dict([(u'any-delivery-method', 0), (u'mhs-delivery', 1), (u'physical-delivery', 2), (u'telex-delivery', 3), (u'teletex-delivery', 4), (u'g3-facsimile-delivery', 5), (u'g4-facsimile-delivery', 6), (u'ia5-terminal-delivery', 7), (u'videotex-delivery', 8), (u'telephone-delivery', 9)])
    PreferredDeliveryMethod._cont = _PreferredDeliveryMethod__item_
    
    #-----< presentationAddress >-----#
    presentationAddress = CLASS(name=u'presentationAddress', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _presentationAddress_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    __ATTRIBUTE_equality_match_val_AssertionType_8 = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    presentationAddress._val = dict([(u'Type', _presentationAddress_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_8), (u'id', (2, 5, 13, 22))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 43)), (u'ldapName', [u'presentationAddress']), (u'id', (2, 5, 4, 29))])
    
    #-----< PresentationAddress >-----#
    PresentationAddress = SEQ(name=u'PresentationAddress', mode=MODE_TYPE)
    _PresentationAddress_pSelector = OCT_STR(name=u'pSelector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PresentationAddress_sSelector = OCT_STR(name=u'sSelector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PresentationAddress_tSelector = OCT_STR(name=u'tSelector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PresentationAddress_nAddresses = SET_OF(name=u'nAddresses', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PresentationAddress_nAddresses__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _PresentationAddress_nAddresses._cont = __PresentationAddress_nAddresses__item_
    _PresentationAddress_nAddresses._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    PresentationAddress._cont = ASN1Dict([
        (u'pSelector', _PresentationAddress_pSelector),
        (u'sSelector', _PresentationAddress_sSelector),
        (u'tSelector', _PresentationAddress_tSelector),
        (u'nAddresses', _PresentationAddress_nAddresses),
        ])
    PresentationAddress._ext = []
    
    #-----< supportedApplicationContext >-----#
    supportedApplicationContext = CLASS(name=u'supportedApplicationContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _supportedApplicationContext_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    supportedApplicationContext._val = dict([(u'Type', _supportedApplicationContext_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'supportedApplicationContext']), (u'id', (2, 5, 4, 30))])
    
    #-----< protocolInformation >-----#
    protocolInformation = CLASS(name=u'protocolInformation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _protocolInformation_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ProtocolInformation')))
    __ATTRIBUTE_equality_match_val_AssertionType_9 = OCT_STR(name=u'AssertionType', mode=MODE_TYPE)
    protocolInformation._val = dict([(u'Type', _protocolInformation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_9), (u'id', (2, 5, 13, 24))])), (u'id', (2, 5, 4, 48))])
    
    #-----< ProtocolInformation >-----#
    ProtocolInformation = SEQ(name=u'ProtocolInformation', mode=MODE_TYPE)
    _ProtocolInformation_nAddress = OCT_STR(name=u'nAddress', mode=MODE_TYPE)
    _ProtocolInformation_profiles = SET_OF(name=u'profiles', mode=MODE_TYPE)
    __ProtocolInformation_profiles__item_ = OID(name='_item_', mode=MODE_TYPE)
    _ProtocolInformation_profiles._cont = __ProtocolInformation_profiles__item_
    ProtocolInformation._cont = ASN1Dict([
        (u'nAddress', _ProtocolInformation_nAddress),
        (u'profiles', _ProtocolInformation_profiles),
        ])
    ProtocolInformation._ext = None
    
    #-----< distinguishedName >-----#
    distinguishedName = CLASS(name=u'distinguishedName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _distinguishedName_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __ATTRIBUTE_equality_match_val_AssertionType_10 = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    distinguishedName._val = dict([(u'Type', _distinguishedName_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_10), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedName']), (u'id', (2, 5, 4, 49))])
    
    #-----< member >-----#
    member = CLASS(name=u'member', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_6 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    member._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_6), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_10), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedName']), (u'id', (2, 5, 4, 49))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'member']), (u'id', (2, 5, 4, 31))])
    
    #-----< uniqueMember >-----#
    uniqueMember = CLASS(name=u'uniqueMember', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uniqueMember_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    __ATTRIBUTE_equality_match_val_AssertionType__11 = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    uniqueMember._val = dict([(u'Type', _uniqueMember_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType__11), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 34)), (u'ldapName', [u'uniqueMemberMatch']), (u'id', (2, 5, 13, 23))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 34)), (u'ldapName', [u'uniqueMember']), (u'id', (2, 5, 4, 50))])
    
    #-----< NameAndOptionalUID >-----#
    NameAndOptionalUID = SEQ(name=u'NameAndOptionalUID', mode=MODE_TYPE)
    _NameAndOptionalUID_dn = SEQ_OF(name=u'dn', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    _NameAndOptionalUID_uid = BIT_STR(name=u'uid', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UniqueIdentifier')), opt=True)
    NameAndOptionalUID._cont = ASN1Dict([
        (u'dn', _NameAndOptionalUID_dn),
        (u'uid', _NameAndOptionalUID_uid),
        ])
    NameAndOptionalUID._ext = []
    
    #-----< owner >-----#
    owner = CLASS(name=u'owner', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    owner._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_6), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_10), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedName']), (u'id', (2, 5, 4, 49))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'owner']), (u'id', (2, 5, 4, 32))])
    
    #-----< roleOccupant >-----#
    roleOccupant = CLASS(name=u'roleOccupant', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    roleOccupant._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_6), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_10), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedName']), (u'id', (2, 5, 4, 49))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'roleOccupant']), (u'id', (2, 5, 4, 33))])
    
    #-----< seeAlso >-----#
    seeAlso = CLASS(name=u'seeAlso', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    seeAlso._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_6), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_10), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedName']), (u'id', (2, 5, 4, 49))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'seeAlso']), (u'id', (2, 5, 4, 34))])
    
    #-----< dmdName >-----#
    dmdName = CLASS(name=u'dmdName', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dmdName_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    dmdName._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'name']), (u'id', (2, 5, 4, 41))])), (u'Type', _dmdName_val_Type), (u'id', (2, 5, 4, 54))])
    
    #-----< oidC1 >-----#
    oidC1 = CLASS(name=u'oidC1', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _oidC1_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType___12 = INT(name=u'AssertionType', mode=MODE_TYPE)
    oidC1._val = dict([(u'Type', _oidC1_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType___12), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'single-valued', True), (u'id', (2, 17, 1, 2, 0))])
    
    #-----< oidC2 >-----#
    oidC2 = CLASS(name=u'oidC2', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _oidC2_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    oidC2._val = dict([(u'Type', _oidC2_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType___12), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'single-valued', True), (u'id', (2, 17, 1, 2, 1))])
    
    #-----< oidC >-----#
    oidC = CLASS(name=u'oidC', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _oidC_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    oidC._val = dict([(u'Type', _oidC_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType___12), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])), (u'single-valued', True), (u'id', (2, 17, 1, 2, 2))])
    
    #-----< urnC >-----#
    urnC = CLASS(name=u'urnC', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _urnC_val_Type = STR_PRINT(name=u'Type', mode=MODE_TYPE)
    urnC._val = dict([(u'Type', _urnC_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseExactMatch']), (u'id', (2, 5, 13, 5))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)), (u'ldapName', [u'urnC']), (u'id', (2, 5, 4, 89))])
    
    #-----< tagOid >-----#
    tagOid = CLASS(name=u'tagOid', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _tagOid_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    tagOid._val = dict([(u'Type', _tagOid_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'tagOid']), (u'id', (2, 5, 4, 78))])
    
    #-----< uiiFormat >-----#
    uiiFormat = CLASS(name=u'uiiFormat', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uiiFormat_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFormat')))
    uiiFormat._val = dict([(u'Type', _uiiFormat_val_Type), (u'single-valued', True), (u'ldapSyntax', (2, 5, 40, 5)), (u'ldapName', [u'uiiFormat']), (u'id', (2, 5, 4, 79))])
    
    #-----< UiiFormat >-----#
    UiiFormat = SEQ(name=u'UiiFormat', mode=MODE_TYPE)
    _UiiFormat_baseObject = STR_UTF8(name=u'baseObject', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'URI')), opt=True)
    _UiiFormat_subset = ENUM(name=u'subset', mode=MODE_TYPE, default=u'baseObject')
    _UiiFormat_subset._cont = ASN1Dict([(u'baseObject', 0), (u'oneLevel', 1), (u'wholeSubtree', 2)])
    _UiiFormat_subset._ext = None
    _UiiFormat_next = CHOICE(name=u'next', mode=MODE_TYPE)
    __UiiFormat_next_length = INT(name=u'length', mode=MODE_TYPE)
    __UiiFormat_next_filter = CHOICE(name=u'filter', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFilter')))
    _UiiFormat_next._cont = ASN1Dict([
        (u'length', __UiiFormat_next_length),
        (u'filter', __UiiFormat_next_filter),
        ])
    _UiiFormat_next._ext = None
    UiiFormat._cont = ASN1Dict([
        (u'baseObject', _UiiFormat_baseObject),
        (u'subset', _UiiFormat_subset),
        (u'next', _UiiFormat_next),
        ])
    UiiFormat._ext = None
    
    #-----< UiiFilter >-----#
    UiiFilter = CHOICE(name=u'UiiFilter', mode=MODE_TYPE)
    _UiiFilter_item = SEQ(name=u'item', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiItem')))
    _UiiFilter_and_ = SET_OF(name=u'and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __UiiFilter_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFilter')))
    _UiiFilter_and_._cont = __UiiFilter_and___item_
    _UiiFilter_or_ = SET_OF(name=u'or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __UiiFilter_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFilter')))
    _UiiFilter_or_._cont = __UiiFilter_or___item_
    _UiiFilter_not_ = CHOICE(name=u'not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFilter')))
    UiiFilter._cont = ASN1Dict([
        (u'item', _UiiFilter_item),
        (u'and', _UiiFilter_and_),
        (u'or', _UiiFilter_or_),
        (u'not', _UiiFilter_not_),
        ])
    UiiFilter._ext = None
    
    #-----< UiiItem >-----#
    UiiItem = SEQ(name=u'UiiItem', mode=MODE_TYPE)
    _UiiItem_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _UiiItem_length = INT(name=u'length', mode=MODE_TYPE, opt=True)
    UiiItem._cont = ASN1Dict([
        (u'type', _UiiItem_type),
        (u'length', _UiiItem_length),
        ])
    UiiItem._ext = None
    
    #-----< uiiInUrn >-----#
    uiiInUrn = CLASS(name=u'uiiInUrn', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uiiInUrn_val_Type = STR_UTF8(name=u'Type', mode=MODE_TYPE)
    uiiInUrn._val = dict([(u'Type', _uiiInUrn_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseExactMatch']), (u'id', (2, 5, 13, 5))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uiiInUrn']), (u'id', (2, 5, 4, 80))])
    
    #-----< contentUrl >-----#
    contentUrl = CLASS(name=u'contentUrl', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    contentUrl._val = dict([(u'derivation', dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_0), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uriMatch']), (u'id', (2, 5, 13, 70))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uri']), (u'id', (2, 5, 4, 83))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'url']), (u'id', (2, 5, 4, 87))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'contentUrl']), (u'id', (2, 5, 4, 81))])
    
    #-----< uii >-----#
    uii = CLASS(name=u'uii', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uii_val_Type = BIT_STR(name=u'Type', mode=MODE_TYPE)
    uii._val = dict([(u'Type', _uii_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), (u'ldapName', [u'bitStringMatch']), (u'id', (2, 5, 13, 16))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), (u'ldapName', [u'uii']), (u'id', (2, 5, 4, 90))])
    
    #-----< epc >-----#
    epc = CLASS(name=u'epc', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _epc_val_Type = BIT_STR(name=u'Type', mode=MODE_TYPE)
    epc._val = dict([(u'Type', _epc_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), (u'ldapName', [u'bitStringMatch']), (u'id', (2, 5, 13, 16))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), (u'ldapName', [u'epc']), (u'id', (2, 5, 4, 91))])
    
    #-----< tagAfi >-----#
    tagAfi = CLASS(name=u'tagAfi', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _tagAfi_val_Type = OCT_STR(name=u'Type', mode=MODE_TYPE)
    tagAfi._val = dict([(u'Type', _tagAfi_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_9), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), (u'ldapName', [u'octetStringMatch']), (u'id', (2, 5, 13, 17))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), (u'ldapName', [u'tagAfi']), (u'id', (2, 5, 4, 92))])
    
    #-----< epcFormat >-----#
    epcFormat = CLASS(name=u'epcFormat', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _epcFormat_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'EpcFormat')))
    epcFormat._val = dict([(u'Type', _epcFormat_val_Type), (u'single-valued', True), (u'ldapSyntax', (2, 5, 40, 6)), (u'ldapName', [u'epcFormat']), (u'id', (2, 5, 4, 93))])
    
    #-----< EpcFormat >-----#
    EpcFormat = SEQ(name=u'EpcFormat', mode=MODE_TYPE)
    _EpcFormat_fields = SEQ_OF(name=u'fields', mode=MODE_TYPE)
    __EpcFormat_fields__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___EpcFormat_fields__item__bits = INT(name=u'bits', mode=MODE_TYPE)
    ___EpcFormat_fields__item__charField = CHOICE(name=u'charField', mode=MODE_TYPE)
    ____EpcFormat_fields__item__charField_characters = INT(name=u'characters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ____EpcFormat_fields__item__charField_maxValue = INT(name=u'maxValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EpcFormat_fields__item__charField._cont = ASN1Dict([
        (u'characters', ____EpcFormat_fields__item__charField_characters),
        (u'maxValue', ____EpcFormat_fields__item__charField_maxValue),
        ])
    ___EpcFormat_fields__item__charField._ext = None
    ___EpcFormat_fields__item__result = ENUM(name=u'result', mode=MODE_TYPE, default=u'numericPad')
    ___EpcFormat_fields__item__result._cont = ASN1Dict([(u'numericPad', 0), (u'numeric', 1), (u'alpha7bits', 2)])
    ___EpcFormat_fields__item__result._ext = None
    __EpcFormat_fields__item_._cont = ASN1Dict([
        (u'bits', ___EpcFormat_fields__item__bits),
        (u'charField', ___EpcFormat_fields__item__charField),
        (u'result', ___EpcFormat_fields__item__result),
        ])
    __EpcFormat_fields__item_._ext = None
    _EpcFormat_fields._cont = __EpcFormat_fields__item_
    _EpcFormat_fields._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _EpcFormat_digitShift = INT(name=u'digitShift', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EpcFormat_checkCalc = INT(name=u'checkCalc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EpcFormat_urnPrefix = STR_UTF8(name=u'urnPrefix', mode=MODE_TYPE, opt=True)
    EpcFormat._cont = ASN1Dict([
        (u'fields', _EpcFormat_fields),
        (u'digitShift', _EpcFormat_digitShift),
        (u'checkCalc', _EpcFormat_checkCalc),
        (u'urnPrefix', _EpcFormat_urnPrefix),
        ])
    EpcFormat._ext = None
    
    #-----< epcInUrn >-----#
    epcInUrn = CLASS(name=u'epcInUrn', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    epcInUrn._val = dict([(u'derivation', dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_0), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uriMatch']), (u'id', (2, 5, 13, 70))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uri']), (u'id', (2, 5, 4, 83))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'urn']), (u'id', (2, 5, 4, 86))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'epcInUrn']), (u'id', (2, 5, 4, 94))])
    
    #-----< ldapUrl >-----#
    ldapUrl = CLASS(name=u'ldapUrl', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ldapUrl._val = dict([(u'derivation', dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_0), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_2), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uriMatch']), (u'id', (2, 5, 13, 70))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uri']), (u'id', (2, 5, 4, 83))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'url']), (u'id', (2, 5, 4, 87))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'ldapUrl']), (u'id', (2, 5, 4, 95))])
    
    #-----< tagLocation >-----#
    tagLocation = CLASS(name=u'tagLocation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    __ATTRIBUTE_derivation_val_Type_7 = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UtmCoordinates')))
    tagLocation._val = dict([(u'derivation', dict([(u'Type', __ATTRIBUTE_derivation_val_Type_7), (u'single-valued', True), (u'ldapSyntax', (2, 5, 40, 4)), (u'ldapName', [u'utmCoordinates']), (u'id', (2, 5, 4, 88))])), (u'single-valued', True), (u'ldapSyntax', (2, 5, 40, 4)), (u'ldapName', [u'tagLocation']), (u'id', (2, 5, 4, 96))])
    
    #-----< dSAProblem >-----#
    dSAProblem = CLASS(name=u'dSAProblem', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dSAProblem_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    dSAProblem._val = dict([(u'Type', _dSAProblem_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'id', (2, 5, 35, 0))])
    
    #-----< searchServiceProblem >-----#
    searchServiceProblem = CLASS(name=u'searchServiceProblem', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _searchServiceProblem_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    searchServiceProblem._val = dict([(u'Type', _searchServiceProblem_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'single-valued', True), (u'id', (2, 5, 35, 1))])
    
    #-----< serviceType >-----#
    serviceType = CLASS(name=u'serviceType', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _serviceType_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    serviceType._val = dict([(u'Type', _serviceType_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'single-valued', True), (u'id', (2, 5, 35, 2))])
    
    #-----< attributeTypeList >-----#
    attributeTypeList = CLASS(name=u'attributeTypeList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeTypeList_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    attributeTypeList._val = dict([(u'Type', _attributeTypeList_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'id', (2, 5, 35, 3))])
    
    #-----< matchingRuleList >-----#
    matchingRuleList = CLASS(name=u'matchingRuleList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _matchingRuleList_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    matchingRuleList._val = dict([(u'Type', _matchingRuleList_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'id', (2, 5, 35, 4))])
    
    #-----< filterItem >-----#
    filterItem = CLASS(name=u'filterItem', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _filterItem_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'FilterItem')))
    filterItem._val = dict([(u'Type', _filterItem_val_Type), (u'id', (2, 5, 35, 5))])
    
    #-----< attributeCombinations >-----#
    attributeCombinations = CLASS(name=u'attributeCombinations', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _attributeCombinations_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')))
    attributeCombinations._val = dict([(u'Type', _attributeCombinations_val_Type), (u'id', (2, 5, 35, 6))])
    
    #-----< contextTypeList >-----#
    contextTypeList = CLASS(name=u'contextTypeList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextTypeList_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    contextTypeList._val = dict([(u'Type', _contextTypeList_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'id', (2, 5, 35, 7))])
    
    #-----< contextList >-----#
    contextList = CLASS(name=u'contextList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextList_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    contextList._val = dict([(u'Type', _contextList_val_Type), (u'id', (2, 5, 35, 8))])
    
    #-----< contextCombinations >-----#
    contextCombinations = CLASS(name=u'contextCombinations', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _contextCombinations_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')))
    contextCombinations._val = dict([(u'Type', _contextCombinations_val_Type), (u'id', (2, 5, 35, 9))])
    
    #-----< hierarchySelectList >-----#
    hierarchySelectList = CLASS(name=u'hierarchySelectList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _hierarchySelectList_val_Type = BIT_STR(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'HierarchySelections')))
    hierarchySelectList._val = dict([(u'Type', _hierarchySelectList_val_Type), (u'single-valued', True), (u'id', (2, 5, 35, 10))])
    
    #-----< searchControlOptionsList >-----#
    searchControlOptionsList = CLASS(name=u'searchControlOptionsList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _searchControlOptionsList_val_Type = BIT_STR(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'SearchControlOptions')))
    searchControlOptionsList._val = dict([(u'Type', _searchControlOptionsList_val_Type), (u'single-valued', True), (u'id', (2, 5, 35, 11))])
    
    #-----< serviceControlOptionsList >-----#
    serviceControlOptionsList = CLASS(name=u'serviceControlOptionsList', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _serviceControlOptionsList_val_Type = BIT_STR(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControlOptions')))
    serviceControlOptionsList._val = dict([(u'Type', _serviceControlOptionsList_val_Type), (u'single-valued', True), (u'id', (2, 5, 35, 12))])
    
    #-----< multipleMatchingLocalities >-----#
    multipleMatchingLocalities = CLASS(name=u'multipleMatchingLocalities', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _multipleMatchingLocalities_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'MultipleMatchingLocalities')))
    multipleMatchingLocalities._val = dict([(u'Type', _multipleMatchingLocalities_val_Type), (u'id', (2, 5, 35, 13))])
    
    #-----< MultipleMatchingLocalities >-----#
    MultipleMatchingLocalities = SEQ(name=u'MultipleMatchingLocalities', mode=MODE_TYPE)
    _MultipleMatchingLocalities_matchingRuleUsed = OID(name=u'matchingRuleUsed', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), [u'id']), opt=True)
    _MultipleMatchingLocalities_attributeList = SEQ_OF(name=u'attributeList', mode=MODE_TYPE)
    __MultipleMatchingLocalities_attributeList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeValueAssertion')))
    _MultipleMatchingLocalities_attributeList._cont = __MultipleMatchingLocalities_attributeList__item_
    MultipleMatchingLocalities._cont = ASN1Dict([
        (u'matchingRuleUsed', _MultipleMatchingLocalities_matchingRuleUsed),
        (u'attributeList', _MultipleMatchingLocalities_attributeList),
        ])
    MultipleMatchingLocalities._ext = []
    
    #-----< proposedRelaxation >-----#
    proposedRelaxation = CLASS(name=u'proposedRelaxation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _proposedRelaxation_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'MRMappings')))
    proposedRelaxation._val = dict([(u'Type', _proposedRelaxation_val_Type), (u'id', (2, 5, 35, 14))])
    
    #-----< MRMappings >-----#
    MRMappings = SEQ_OF(name=u'MRMappings', mode=MODE_TYPE)
    _MRMappings__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'MRMapping')))
    MRMappings._cont = _MRMappings__item_
    
    #-----< appliedRelaxation >-----#
    appliedRelaxation = CLASS(name=u'appliedRelaxation', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _appliedRelaxation_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    appliedRelaxation._val = dict([(u'Type', _appliedRelaxation_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'id', (2, 5, 35, 15))])
    
    #-----< pwdResponseValue >-----#
    pwdResponseValue = CLASS(name=u'pwdResponseValue', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _pwdResponseValue_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PwdResponse')))
    pwdResponseValue._val = dict([(u'Type', _pwdResponseValue_val_Type), (u'id', (2, 5, 35, 16))])
    
    #-----< PwdResponse >-----#
    PwdResponse = SEQ(name=u'PwdResponse', mode=MODE_TYPE)
    _PwdResponse_warning = CHOICE(name=u'warning', mode=MODE_TYPE, opt=True)
    __PwdResponse_warning_timeleft = INT(name=u'timeleft', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PwdResponse_warning_timeleft._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    __PwdResponse_warning_graceRemaining = INT(name=u'graceRemaining', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PwdResponse_warning_graceRemaining._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _PwdResponse_warning._cont = ASN1Dict([
        (u'timeleft', __PwdResponse_warning_timeleft),
        (u'graceRemaining', __PwdResponse_warning_graceRemaining),
        ])
    _PwdResponse_warning._ext = []
    _PwdResponse_error = ENUM(name=u'error', mode=MODE_TYPE, opt=True)
    _PwdResponse_error._cont = ASN1Dict([(u'passwordExpired', 0), (u'changeAfterReset', 1)])
    _PwdResponse_error._ext = []
    PwdResponse._cont = ASN1Dict([
        (u'warning', _PwdResponse_warning),
        (u'error', _PwdResponse_error),
        ])
    PwdResponse._ext = None
    
    #-----< ldapDiagnosticMsg >-----#
    ldapDiagnosticMsg = CLASS(name=u'ldapDiagnosticMsg', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _ldapDiagnosticMsg_val_Type = STR_UTF8(name=u'Type', mode=MODE_TYPE)
    ldapDiagnosticMsg._val = dict([(u'Type', _ldapDiagnosticMsg_val_Type), (u'single-valued', True), (u'id', (2, 5, 35, 17))])
    
    #-----< uid >-----#
    uid = CLASS(name=u'uid', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _uid_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    uid._val = dict([(u'Type', _uid_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uid']), (u'id', (0, 9, 2342, 19200300, 100, 1, 1))])
    
    #-----< dc >-----#
    dc = CLASS(name=u'dc', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _dc_val_Type = STR_IA5(name=u'Type', mode=MODE_TYPE)
    dc._val = dict([(u'Type', _dc_val_Type), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])), (u'substrings-match', dict([(u'AssertionType', __ATTRIBUTE_substrings_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26)), (u'ldapName', [u'dc']), (u'id', (0, 9, 2342, 19200300, 100, 1, 25))])
    
    #-----< caseExactMatch >-----#
    caseExactMatch = CLASS(name=u'caseExactMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseExactMatch_val_AssertionType = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    caseExactMatch._val = dict([(u'AssertionType', _caseExactMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseExactMatch']), (u'id', (2, 5, 13, 5))])
    
    #-----< caseIgnoreMatch >-----#
    caseIgnoreMatch = CLASS(name=u'caseIgnoreMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreMatch_val_AssertionType = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    caseIgnoreMatch._val = dict([(u'AssertionType', _caseIgnoreMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreMatch']), (u'id', (2, 5, 13, 2))])
    
    #-----< caseExactOrderingMatch >-----#
    caseExactOrderingMatch = CLASS(name=u'caseExactOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseExactOrderingMatch_val_AssertionType = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    caseExactOrderingMatch._val = dict([(u'AssertionType', _caseExactOrderingMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseExactOrderingMatch']), (u'id', (2, 5, 13, 6))])
    
    #-----< caseIgnoreOrderingMatch >-----#
    caseIgnoreOrderingMatch = CLASS(name=u'caseIgnoreOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreOrderingMatch_val_AssertionType = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    caseIgnoreOrderingMatch._val = dict([(u'AssertionType', _caseIgnoreOrderingMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'caseIgnoreOrderingMatch']), (u'id', (2, 5, 13, 3))])
    
    #-----< caseExactSubstringsMatch >-----#
    caseExactSubstringsMatch = CLASS(name=u'caseExactSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseExactSubstringsMatch_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    caseExactSubstringsMatch._val = dict([(u'AssertionType', _caseExactSubstringsMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseExactSubstringsMatch']), (u'id', (2, 5, 13, 7))])
    
    #-----< caseIgnoreSubstringsMatch >-----#
    caseIgnoreSubstringsMatch = CLASS(name=u'caseIgnoreSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreSubstringsMatch_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    caseIgnoreSubstringsMatch._val = dict([(u'AssertionType', _caseIgnoreSubstringsMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreSubstringsMatch']), (u'id', (2, 5, 13, 4))])
    
    #-----< SubstringAssertion >-----#
    SubstringAssertion = SEQ_OF(name=u'SubstringAssertion', mode=MODE_TYPE)
    _SubstringAssertion__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    __SubstringAssertion__item__initial = CHOICE(name=u'initial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __SubstringAssertion__item__any = CHOICE(name=u'any', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __SubstringAssertion__item__final = CHOICE(name=u'final', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    __SubstringAssertion__item__control = SEQ(name=u'control', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Attribute')))
    ___SubstringAssertion__item__control_type = OID(name=u'type', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    ____SubstringAssertion__item__control_type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _____SubstringAssertion__item__control_type_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    _____SubstringAssertion__item__control_type_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    ____SubstringAssertion__item__control_type_tab._val = ASN1Set(rv=[dict([(u'Type', _____SubstringAssertion__item__control_type_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_7), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', _____SubstringAssertion__item__control_type_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_10), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    ___SubstringAssertion__item__control_type._const_tab = ____SubstringAssertion__item__control_type_tab
    ___SubstringAssertion__item__control_type._const_tab_at = None
    ___SubstringAssertion__item__control_type._const_tab_id = u'id'
    ___SubstringAssertion__item__control_values = SET_OF(name=u'values', mode=MODE_TYPE)
    ____SubstringAssertion__item__control_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____SubstringAssertion__item__control_values__item_._const_tab = ____SubstringAssertion__item__control_type_tab
    ____SubstringAssertion__item__control_values__item_._const_tab_at = ('..', '..', u'type')
    ____SubstringAssertion__item__control_values__item_._const_tab_id = u'Type'
    ___SubstringAssertion__item__control_values._cont = ____SubstringAssertion__item__control_values__item_
    ___SubstringAssertion__item__control_values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ___SubstringAssertion__item__control_valuesWithContext = SET_OF(name=u'valuesWithContext', mode=MODE_TYPE, opt=True)
    ____SubstringAssertion__item__control_valuesWithContext__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    _____SubstringAssertion__item__control_valuesWithContext__item__value = OPEN(name=u'value', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    _____SubstringAssertion__item__control_valuesWithContext__item__value._const_tab = ____SubstringAssertion__item__control_type_tab
    _____SubstringAssertion__item__control_valuesWithContext__item__value._const_tab_at = ('..', '..', '..', u'type')
    _____SubstringAssertion__item__control_valuesWithContext__item__value._const_tab_id = u'Type'
    _____SubstringAssertion__item__control_valuesWithContext__item__contextList = SET_OF(name=u'contextList', mode=MODE_TYPE)
    ______SubstringAssertion__item__control_valuesWithContext__item__contextList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Context')))
    _____SubstringAssertion__item__control_valuesWithContext__item__contextList._cont = ______SubstringAssertion__item__control_valuesWithContext__item__contextList__item_
    _____SubstringAssertion__item__control_valuesWithContext__item__contextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ____SubstringAssertion__item__control_valuesWithContext__item_._cont = ASN1Dict([
        (u'value', _____SubstringAssertion__item__control_valuesWithContext__item__value),
        (u'contextList', _____SubstringAssertion__item__control_valuesWithContext__item__contextList),
        ])
    ____SubstringAssertion__item__control_valuesWithContext__item_._ext = []
    ___SubstringAssertion__item__control_valuesWithContext._cont = ____SubstringAssertion__item__control_valuesWithContext__item_
    ___SubstringAssertion__item__control_valuesWithContext._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __SubstringAssertion__item__control._cont = ASN1Dict([
        (u'type', ___SubstringAssertion__item__control_type),
        (u'values', ___SubstringAssertion__item__control_values),
        (u'valuesWithContext', ___SubstringAssertion__item__control_valuesWithContext),
        ])
    __SubstringAssertion__item__control._ext = []
    _SubstringAssertion__item_._cont = ASN1Dict([
        (u'initial', __SubstringAssertion__item__initial),
        (u'any', __SubstringAssertion__item__any),
        (u'final', __SubstringAssertion__item__final),
        (u'control', __SubstringAssertion__item__control),
        ])
    _SubstringAssertion__item_._ext = []
    SubstringAssertion._cont = _SubstringAssertion__item_
    
    #-----< numericStringMatch >-----#
    numericStringMatch = CLASS(name=u'numericStringMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _numericStringMatch_val_AssertionType = STR_NUM(name=u'AssertionType', mode=MODE_TYPE)
    numericStringMatch._val = dict([(u'AssertionType', _numericStringMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), (u'ldapName', [u'numericStringMatch']), (u'id', (2, 5, 13, 8))])
    
    #-----< numericStringOrderingMatch >-----#
    numericStringOrderingMatch = CLASS(name=u'numericStringOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _numericStringOrderingMatch_val_AssertionType = STR_NUM(name=u'AssertionType', mode=MODE_TYPE)
    numericStringOrderingMatch._val = dict([(u'AssertionType', _numericStringOrderingMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)), (u'ldapName', [u'numericStringOrderingMatch']), (u'id', (2, 5, 13, 9))])
    
    #-----< numericStringSubstringsMatch >-----#
    numericStringSubstringsMatch = CLASS(name=u'numericStringSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _numericStringSubstringsMatch_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    numericStringSubstringsMatch._val = dict([(u'AssertionType', _numericStringSubstringsMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'numericStringSubstringsMatch']), (u'id', (2, 5, 13, 10))])
    
    #-----< caseIgnoreListMatch >-----#
    caseIgnoreListMatch = CLASS(name=u'caseIgnoreListMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreListMatch_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CaseIgnoreList')))
    caseIgnoreListMatch._val = dict([(u'AssertionType', _caseIgnoreListMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)), (u'ldapName', [u'caseIgnoreListMatch']), (u'id', (2, 5, 13, 11))])
    
    #-----< CaseIgnoreList >-----#
    CaseIgnoreList = SEQ_OF(name=u'CaseIgnoreList', mode=MODE_TYPE)
    _CaseIgnoreList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    CaseIgnoreList._cont = _CaseIgnoreList__item_
    
    #-----< caseIgnoreListSubstringsMatch >-----#
    caseIgnoreListSubstringsMatch = CLASS(name=u'caseIgnoreListSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreListSubstringsMatch_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    caseIgnoreListSubstringsMatch._val = dict([(u'AssertionType', _caseIgnoreListSubstringsMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreListSubstringsMatch']), (u'id', (2, 5, 13, 12))])
    
    #-----< storedPrefixMatch >-----#
    storedPrefixMatch = CLASS(name=u'storedPrefixMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _storedPrefixMatch_val_AssertionType = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    storedPrefixMatch._val = dict([(u'AssertionType', _storedPrefixMatch_val_AssertionType), (u'id', (2, 5, 13, 41))])
    
    #-----< booleanMatch >-----#
    booleanMatch = CLASS(name=u'booleanMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _booleanMatch_val_AssertionType = BOOL(name=u'AssertionType', mode=MODE_TYPE)
    booleanMatch._val = dict([(u'AssertionType', _booleanMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), (u'ldapName', [u'booleanMatch']), (u'id', (2, 5, 13, 13))])
    
    #-----< integerMatch >-----#
    integerMatch = CLASS(name=u'integerMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _integerMatch_val_AssertionType = INT(name=u'AssertionType', mode=MODE_TYPE)
    integerMatch._val = dict([(u'AssertionType', _integerMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerMatch']), (u'id', (2, 5, 13, 14))])
    
    #-----< integerOrderingMatch >-----#
    integerOrderingMatch = CLASS(name=u'integerOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _integerOrderingMatch_val_AssertionType = INT(name=u'AssertionType', mode=MODE_TYPE)
    integerOrderingMatch._val = dict([(u'AssertionType', _integerOrderingMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerOrderingMatch']), (u'id', (2, 5, 13, 15))])
    
    #-----< bitStringMatch >-----#
    bitStringMatch = CLASS(name=u'bitStringMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _bitStringMatch_val_AssertionType = BIT_STR(name=u'AssertionType', mode=MODE_TYPE)
    bitStringMatch._val = dict([(u'AssertionType', _bitStringMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)), (u'ldapName', [u'bitStringMatch']), (u'id', (2, 5, 13, 16))])
    
    #-----< octetStringMatch >-----#
    octetStringMatch = CLASS(name=u'octetStringMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _octetStringMatch_val_AssertionType = OCT_STR(name=u'AssertionType', mode=MODE_TYPE)
    octetStringMatch._val = dict([(u'AssertionType', _octetStringMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), (u'ldapName', [u'octetStringMatch']), (u'id', (2, 5, 13, 17))])
    
    #-----< octetStringOrderingMatch >-----#
    octetStringOrderingMatch = CLASS(name=u'octetStringOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _octetStringOrderingMatch_val_AssertionType = OCT_STR(name=u'AssertionType', mode=MODE_TYPE)
    octetStringOrderingMatch._val = dict([(u'AssertionType', _octetStringOrderingMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)), (u'ldapName', [u'octetStringOrderingMatch']), (u'id', (2, 5, 13, 18))])
    
    #-----< octetStringSubstringsMatch >-----#
    octetStringSubstringsMatch = CLASS(name=u'octetStringSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _octetStringSubstringsMatch_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'OctetSubstringAssertion')))
    octetStringSubstringsMatch._val = dict([(u'AssertionType', _octetStringSubstringsMatch_val_AssertionType), (u'id', (2, 5, 13, 19))])
    
    #-----< OctetSubstringAssertion >-----#
    OctetSubstringAssertion = SEQ_OF(name=u'OctetSubstringAssertion', mode=MODE_TYPE)
    _OctetSubstringAssertion__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    __OctetSubstringAssertion__item__initial = OCT_STR(name=u'initial', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OctetSubstringAssertion__item__any = OCT_STR(name=u'any', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __OctetSubstringAssertion__item__final = OCT_STR(name=u'final', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _OctetSubstringAssertion__item_._cont = ASN1Dict([
        (u'initial', __OctetSubstringAssertion__item__initial),
        (u'any', __OctetSubstringAssertion__item__any),
        (u'final', __OctetSubstringAssertion__item__final),
        ])
    _OctetSubstringAssertion__item_._ext = []
    OctetSubstringAssertion._cont = _OctetSubstringAssertion__item_
    
    #-----< telephoneNumberMatch >-----#
    telephoneNumberMatch = CLASS(name=u'telephoneNumberMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _telephoneNumberMatch_val_AssertionType = STR_PRINT(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    telephoneNumberMatch._val = dict([(u'AssertionType', _telephoneNumberMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 50)), (u'ldapName', [u'telephoneNumberMatch']), (u'id', (2, 5, 13, 20))])
    
    #-----< telephoneNumberSubstringsMatch >-----#
    telephoneNumberSubstringsMatch = CLASS(name=u'telephoneNumberSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _telephoneNumberSubstringsMatch_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    telephoneNumberSubstringsMatch._val = dict([(u'AssertionType', _telephoneNumberSubstringsMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'telephoneNumberSubstringsMatch']), (u'id', (2, 5, 13, 21))])
    
    #-----< presentationAddressMatch >-----#
    presentationAddressMatch = CLASS(name=u'presentationAddressMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _presentationAddressMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    presentationAddressMatch._val = dict([(u'AssertionType', _presentationAddressMatch_val_AssertionType), (u'id', (2, 5, 13, 22))])
    
    #-----< uniqueMemberMatch >-----#
    uniqueMemberMatch = CLASS(name=u'uniqueMemberMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _uniqueMemberMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    uniqueMemberMatch._val = dict([(u'AssertionType', _uniqueMemberMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 34)), (u'ldapName', [u'uniqueMemberMatch']), (u'id', (2, 5, 13, 23))])
    
    #-----< protocolInformationMatch >-----#
    protocolInformationMatch = CLASS(name=u'protocolInformationMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _protocolInformationMatch_val_AssertionType = OCT_STR(name=u'AssertionType', mode=MODE_TYPE)
    protocolInformationMatch._val = dict([(u'AssertionType', _protocolInformationMatch_val_AssertionType), (u'id', (2, 5, 13, 24))])
    
    #-----< facsimileNumberMatch >-----#
    facsimileNumberMatch = CLASS(name=u'facsimileNumberMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _facsimileNumberMatch_val_AssertionType = STR_PRINT(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    facsimileNumberMatch._val = dict([(u'AssertionType', _facsimileNumberMatch_val_AssertionType), (u'id', (2, 5, 13, 63))])
    
    #-----< facsimileNumberSubstringsMatch >-----#
    facsimileNumberSubstringsMatch = CLASS(name=u'facsimileNumberSubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _facsimileNumberSubstringsMatch_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    facsimileNumberSubstringsMatch._val = dict([(u'AssertionType', _facsimileNumberSubstringsMatch_val_AssertionType), (u'id', (2, 5, 13, 64))])
    
    #-----< uUIDPairMatch >-----#
    uUIDPairMatch = CLASS(name=u'uUIDPairMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _uUIDPairMatch_val_AssertionType = SEQ(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UUIDPair')))
    uUIDPairMatch._val = dict([(u'AssertionType', _uUIDPairMatch_val_AssertionType), (u'id', (2, 5, 13, 68))])
    
    #-----< uTCTimeMatch >-----#
    uTCTimeMatch = CLASS(name=u'uTCTimeMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _uTCTimeMatch_val_AssertionType = TIME_UTC(name=u'AssertionType', mode=MODE_TYPE)
    uTCTimeMatch._val = dict([(u'AssertionType', _uTCTimeMatch_val_AssertionType), (u'id', (2, 5, 13, 25))])
    
    #-----< uTCTimeOrderingMatch >-----#
    uTCTimeOrderingMatch = CLASS(name=u'uTCTimeOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _uTCTimeOrderingMatch_val_AssertionType = TIME_UTC(name=u'AssertionType', mode=MODE_TYPE)
    uTCTimeOrderingMatch._val = dict([(u'AssertionType', _uTCTimeOrderingMatch_val_AssertionType), (u'id', (2, 5, 13, 26))])
    
    #-----< generalizedTimeMatch >-----#
    generalizedTimeMatch = CLASS(name=u'generalizedTimeMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _generalizedTimeMatch_val_AssertionType = TIME_GEN(name=u'AssertionType', mode=MODE_TYPE)
    generalizedTimeMatch._val = dict([(u'AssertionType', _generalizedTimeMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeMatch']), (u'id', (2, 5, 13, 27))])
    
    #-----< generalizedTimeOrderingMatch >-----#
    generalizedTimeOrderingMatch = CLASS(name=u'generalizedTimeOrderingMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _generalizedTimeOrderingMatch_val_AssertionType = TIME_GEN(name=u'AssertionType', mode=MODE_TYPE)
    generalizedTimeOrderingMatch._val = dict([(u'AssertionType', _generalizedTimeOrderingMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)), (u'ldapName', [u'generalizedTimeOrderingMatch']), (u'id', (2, 5, 13, 28))])
    
    #-----< systemProposedMatch >-----#
    systemProposedMatch = CLASS(name=u'systemProposedMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    systemProposedMatch._val = dict([(u'id', (2, 5, 13, 47))])
    
    #-----< integerFirstComponentMatch >-----#
    integerFirstComponentMatch = CLASS(name=u'integerFirstComponentMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _integerFirstComponentMatch_val_AssertionType = INT(name=u'AssertionType', mode=MODE_TYPE)
    integerFirstComponentMatch._val = dict([(u'AssertionType', _integerFirstComponentMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)), (u'ldapName', [u'integerFirstComponentMatch']), (u'id', (2, 5, 13, 29))])
    
    #-----< objectIdentifierFirstComponentMatch >-----#
    objectIdentifierFirstComponentMatch = CLASS(name=u'objectIdentifierFirstComponentMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _objectIdentifierFirstComponentMatch_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    objectIdentifierFirstComponentMatch._val = dict([(u'AssertionType', _objectIdentifierFirstComponentMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierFirstComponentMatch']), (u'id', (2, 5, 13, 30))])
    
    #-----< directoryStringFirstComponentMatch >-----#
    directoryStringFirstComponentMatch = CLASS(name=u'directoryStringFirstComponentMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _directoryStringFirstComponentMatch_val_AssertionType = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    directoryStringFirstComponentMatch._val = dict([(u'AssertionType', _directoryStringFirstComponentMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'directoryStringFirstComponentMatch']), (u'id', (2, 5, 13, 31))])
    
    #-----< wordMatch >-----#
    wordMatch = CLASS(name=u'wordMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _wordMatch_val_AssertionType = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    wordMatch._val = dict([(u'AssertionType', _wordMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'wordMatch']), (u'id', (2, 5, 13, 32))])
    
    #-----< keywordMatch >-----#
    keywordMatch = CLASS(name=u'keywordMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _keywordMatch_val_AssertionType = CHOICE(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    keywordMatch._val = dict([(u'AssertionType', _keywordMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'keywordMatch']), (u'id', (2, 5, 13, 33))])
    
    #-----< generalWordMatch >-----#
    generalWordMatch = CLASS(name=u'generalWordMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _generalWordMatch_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    generalWordMatch._val = dict([(u'AssertionType', _generalWordMatch_val_AssertionType), (u'id', (2, 5, 13, 48))])
    
    #-----< sequenceMatchType >-----#
    sequenceMatchType = CLASS(name=u'sequenceMatchType', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _sequenceMatchType_val_Type = ENUM(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SequenceMatchType')))
    sequenceMatchType._val = dict([(u'Type', _sequenceMatchType_val_Type), (u'single-valued', True), (u'id', (2, 5, 37, 1))])
    
    #-----< SequenceMatchType >-----#
    SequenceMatchType = ENUM(name=u'SequenceMatchType', mode=MODE_TYPE)
    SequenceMatchType._cont = ASN1Dict([(u'sequenceExact', 0), (u'sequenceDeletion', 1), (u'sequenceRestrictedDeletion', 2), (u'sequencePermutation', 3), (u'sequencePermutationAndDeletion', 4), (u'sequenceProviderDefined', 5)])
    SequenceMatchType._ext = []
    
    #-----< wordMatchTypes >-----#
    wordMatchTypes = CLASS(name=u'wordMatchTypes', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _wordMatchTypes_val_Type = ENUM(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'WordMatchTypes')))
    wordMatchTypes._val = dict([(u'Type', _wordMatchTypes_val_Type), (u'single-valued', True), (u'id', (2, 5, 37, 2))])
    
    #-----< WordMatchTypes >-----#
    WordMatchTypes = ENUM(name=u'WordMatchTypes', mode=MODE_TYPE)
    WordMatchTypes._cont = ASN1Dict([(u'wordExact', 0), (u'wordTruncated', 1), (u'wordPhonetic', 2), (u'wordProviderDefined', 3)])
    WordMatchTypes._ext = []
    
    #-----< characterMatchTypes >-----#
    characterMatchTypes = CLASS(name=u'characterMatchTypes', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _characterMatchTypes_val_Type = ENUM(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CharacterMatchTypes')))
    characterMatchTypes._val = dict([(u'Type', _characterMatchTypes_val_Type), (u'single-valued', True), (u'id', (2, 5, 37, 3))])
    
    #-----< CharacterMatchTypes >-----#
    CharacterMatchTypes = ENUM(name=u'CharacterMatchTypes', mode=MODE_TYPE)
    CharacterMatchTypes._cont = ASN1Dict([(u'characterExact', 0), (u'characterCaseIgnore', 1), (u'characterMapped', 2)])
    CharacterMatchTypes._ext = []
    
    #-----< selectedContexts >-----#
    selectedContexts = CLASS(name=u'selectedContexts', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _selectedContexts_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'ContextAssertion')))
    selectedContexts._val = dict([(u'Type', _selectedContexts_val_Type), (u'id', (2, 5, 37, 4))])
    
    #-----< approximateStringMatch >-----#
    approximateStringMatch = CLASS(name=u'approximateStringMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    approximateStringMatch._val = dict([(u'id', (2, 5, 13, 49))])
    
    #-----< ignoreIfAbsentMatch >-----#
    ignoreIfAbsentMatch = CLASS(name=u'ignoreIfAbsentMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    ignoreIfAbsentMatch._val = dict([(u'id', (2, 5, 13, 50))])
    
    #-----< nullMatch >-----#
    nullMatch = CLASS(name=u'nullMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    nullMatch._val = dict([(u'id', (2, 5, 13, 51))])
    
    #-----< ZONAL-MATCHING >-----#
    ZONAL_MATCHING = CLASS(name=u'ZONAL-MATCHING', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'MAPPING-BASED-MATCHING')))
    _ZONAL_MATCHING_selectBy = SEQ_OF(name=u'selectBy', mode=MODE_VALUE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ZonalSelect')), opt=True)
    _ZONAL_MATCHING_ApplicableTo = CLASS(name=u'ApplicableTo', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    _ZONAL_MATCHING_subtypesIncluded = BOOL(name=u'subtypesIncluded', mode=MODE_VALUE, default=True)
    _ZONAL_MATCHING_combinable = BOOL(name=u'combinable', mode=MODE_VALUE)
    _ZONAL_MATCHING_combinable._const_val = ASN1Set(rv=[True], rr=[], ev=None, er=[])
    _ZONAL_MATCHING_mappingResults = ENUM(name=u'mappingResults', mode=MODE_VALUE, typeref=ASN1RefType(('SelectedAttributeTypes', 'ZonalResult')), opt=True)
    _ZONAL_MATCHING_userControl = BOOL(name=u'userControl', mode=MODE_VALUE, default=False)
    _ZONAL_MATCHING_exclusive = BOOL(name=u'exclusive', mode=MODE_VALUE, default=True)
    _ZONAL_MATCHING_matching_rule = OID(name=u'matching-rule', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), [u'id']))
    _ZONAL_MATCHING_matching_rule._const_val = ASN1Set(rv=[(2, 5, 13, 52)], rr=[], ev=None, er=[])
    _ZONAL_MATCHING_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    ZONAL_MATCHING._cont = ASN1Dict([
        (u'selectBy', _ZONAL_MATCHING_selectBy),
        (u'ApplicableTo', _ZONAL_MATCHING_ApplicableTo),
        (u'subtypesIncluded', _ZONAL_MATCHING_subtypesIncluded),
        (u'combinable', _ZONAL_MATCHING_combinable),
        (u'mappingResults', _ZONAL_MATCHING_mappingResults),
        (u'userControl', _ZONAL_MATCHING_userControl),
        (u'exclusive', _ZONAL_MATCHING_exclusive),
        (u'matching-rule', _ZONAL_MATCHING_matching_rule),
        (u'id', _ZONAL_MATCHING_id),
        ])
    
    #-----< ZonalSelect >-----#
    ZonalSelect = SEQ_OF(name=u'ZonalSelect', mode=MODE_TYPE)
    _ZonalSelect__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    ZonalSelect._cont = _ZonalSelect__item_
    
    #-----< ZonalResult >-----#
    ZonalResult = ENUM(name=u'ZonalResult', mode=MODE_TYPE)
    ZonalResult._cont = ASN1Dict([(u'cannot-select-mapping', 0), (u'zero-mappings', 2), (u'multiple-mappings', 3)])
    ZonalResult._ext = []
    
    #-----< zonalMatch >-----#
    zonalMatch = CLASS(name=u'zonalMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    __MATCHING_RULE_uniqueMatchIndicator_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'MultipleMatchingLocalities')))
    zonalMatch._val = dict([(u'uniqueMatchIndicator', dict([(u'Type', __MATCHING_RULE_uniqueMatchIndicator_val_Type), (u'id', (2, 5, 35, 13))])), (u'id', (2, 5, 13, 52))])
    
    #-----< uriMatch >-----#
    uriMatch = CLASS(name=u'uriMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _uriMatch_val_AssertionType = STR_UTF8(name=u'AssertionType', mode=MODE_TYPE)
    uriMatch._val = dict([(u'AssertionType', _uriMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)), (u'ldapName', [u'uriMatch']), (u'id', (2, 5, 13, 70))])
    
    #-----< dnsNameMatch >-----#
    dnsNameMatch = CLASS(name=u'dnsNameMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _dnsNameMatch_val_AssertionType = STR_UTF8(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DomainName')))
    dnsNameMatch._val = dict([(u'AssertionType', _dnsNameMatch_val_AssertionType), (u'ldapSyntax', (2, 5, 40, 9)), (u'ldapName', [u'dnsNameMatch']), (u'id', (2, 5, 13, 74))])
    
    #-----< caseExactIA5Match >-----#
    caseExactIA5Match = CLASS(name=u'caseExactIA5Match', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseExactIA5Match_val_AssertionType = STR_IA5(name=u'AssertionType', mode=MODE_TYPE)
    caseExactIA5Match._val = dict([(u'AssertionType', _caseExactIA5Match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26)), (u'ldapName', [u'caseExactIA5Match']), (u'id', (1, 3, 6, 1, 4, 1, 1466, 109, 114, 1))])
    
    #-----< caseIgnoreIA5Match >-----#
    caseIgnoreIA5Match = CLASS(name=u'caseIgnoreIA5Match', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreIA5Match_val_AssertionType = STR_IA5(name=u'AssertionType', mode=MODE_TYPE)
    caseIgnoreIA5Match._val = dict([(u'AssertionType', _caseIgnoreIA5Match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26)), (u'ldapName', [u'caseIgnoreIA5Match']), (u'id', (1, 3, 6, 1, 4, 1, 1466, 109, 114, 2))])
    
    #-----< caseIgnoreIA5SubstringsMatch >-----#
    caseIgnoreIA5SubstringsMatch = CLASS(name=u'caseIgnoreIA5SubstringsMatch', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'MATCHING-RULE')))
    _caseIgnoreIA5SubstringsMatch_val_AssertionType = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    caseIgnoreIA5SubstringsMatch._val = dict([(u'AssertionType', _caseIgnoreIA5SubstringsMatch_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)), (u'ldapName', [u'caseIgnoreIA5SubstringsMatch']), (u'id', (1, 3, 6, 1, 4, 1, 1466, 109, 114, 2))])
    
    #-----< utmCoords >-----#
    utmCoords = CLASS(name=u'utmCoords', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _utmCoords_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UtmCoordinates')))
    utmCoords._val = dict([(u'ldapDesc', u'UTM Coordinates'), (u'Type', _utmCoords_val_Type), (u'id', (2, 5, 40, 4))])
    
    #-----< uiiForm >-----#
    uiiForm = CLASS(name=u'uiiForm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _uiiForm_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UiiFormat')))
    uiiForm._val = dict([(u'ldapDesc', u'UII Format'), (u'Type', _uiiForm_val_Type), (u'id', (2, 5, 40, 5))])
    
    #-----< epcForm >-----#
    epcForm = CLASS(name=u'epcForm', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _epcForm_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'EpcFormat')))
    epcForm._val = dict([(u'ldapDesc', u'EPC Format'), (u'Type', _epcForm_val_Type), (u'id', (2, 5, 40, 6))])
    
    #-----< countryString3c >-----#
    countryString3c = CLASS(name=u'countryString3c', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _countryString3c_val_Type = STR_PRINT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CountryCode3c')))
    countryString3c._val = dict([(u'ldapDesc', u'Country String 3 characters'), (u'Type', _countryString3c_val_Type), (u'id', (2, 5, 40, 7))])
    
    #-----< countryString3n >-----#
    countryString3n = CLASS(name=u'countryString3n', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _countryString3n_val_Type = STR_NUM(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CountryCode3n')))
    countryString3n._val = dict([(u'ldapDesc', u'Country String 3 numeric characters'), (u'Type', _countryString3n_val_Type), (u'id', (2, 5, 40, 8))])
    
    #-----< dnsString >-----#
    dnsString = CLASS(name=u'dnsString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _dnsString_val_Type = STR_UTF8(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DomainName')))
    dnsString._val = dict([(u'ldapDesc', u'DNS Name String'), (u'Type', _dnsString_val_Type), (u'id', (2, 5, 40, 9))])
    
    #-----< attributeTypeDescription >-----#
    attributeTypeDescription = CLASS(name=u'attributeTypeDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _attributeTypeDescription_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'AttributeTypeDescription')))
    attributeTypeDescription._val = dict([(u'ldapDesc', u'Attribute Type Description'), (u'Type', _attributeTypeDescription_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 3))])
    
    #-----< bitString >-----#
    bitString = CLASS(name=u'bitString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _bitString_val_Type = BIT_STR(name=u'Type', mode=MODE_TYPE)
    bitString._val = dict([(u'ldapDesc', u'Bit String'), (u'Type', _bitString_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6))])
    
    #-----< boolean >-----#
    boolean = CLASS(name=u'boolean', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _boolean_val_Type = BOOL(name=u'Type', mode=MODE_TYPE)
    boolean._val = dict([(u'ldapDesc', u'Boolean'), (u'Type', _boolean_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 7))])
    
    #-----< countryString >-----#
    countryString = CLASS(name=u'countryString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _countryString_val_Type = STR_PRINT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'CountryName')))
    countryString._val = dict([(u'ldapDesc', u'Country String'), (u'Type', _countryString_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 11))])
    
    #-----< dn >-----#
    dn = CLASS(name=u'dn', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _dn_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    dn._val = dict([(u'ldapDesc', u'DN'), (u'Type', _dn_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12))])
    
    #-----< deliveryMethod >-----#
    deliveryMethod = CLASS(name=u'deliveryMethod', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _deliveryMethod_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PreferredDeliveryMethod')))
    deliveryMethod._val = dict([(u'ldapDesc', u'Delevery Method'), (u'Type', _deliveryMethod_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 14))])
    
    #-----< directoryString >-----#
    directoryString = CLASS(name=u'directoryString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _directoryString_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    directoryString._val = dict([(u'ldapDesc', u'Directory String'), (u'Type', _directoryString_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15))])
    
    #-----< dITContentRuleDescription >-----#
    dITContentRuleDescription = CLASS(name=u'dITContentRuleDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _dITContentRuleDescription_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITContentRuleDescription')))
    dITContentRuleDescription._val = dict([(u'ldapDesc', u'DIT Content Rule Description'), (u'Type', _dITContentRuleDescription_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 16))])
    
    #-----< dITStructureRuleDescription >-----#
    dITStructureRuleDescription = CLASS(name=u'dITStructureRuleDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _dITStructureRuleDescription_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'DITStructureRuleDescription')))
    dITStructureRuleDescription._val = dict([(u'ldapDesc', u'DIT StructureRule Description'), (u'Type', _dITStructureRuleDescription_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 17))])
    
    #-----< enhancedGuide >-----#
    enhancedGuide = CLASS(name=u'enhancedGuide', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _enhancedGuide_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'EnhancedGuide')))
    enhancedGuide._val = dict([(u'ldapDesc', u'Enhanced Guide'), (u'Type', _enhancedGuide_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 21))])
    
    #-----< facsimileTelephoneNr >-----#
    facsimileTelephoneNr = CLASS(name=u'facsimileTelephoneNr', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _facsimileTelephoneNr_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'FacsimileTelephoneNumber')))
    facsimileTelephoneNr._val = dict([(u'ldapDesc', u'Facsimile Telephone Number'), (u'Type', _facsimileTelephoneNr_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 22))])
    
    #-----< fax >-----#
    fax = CLASS(name=u'fax', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _fax_val_Type = NULL(name=u'Type', mode=MODE_TYPE)
    fax._val = dict([(u'ldapDesc', u'Fax'), (u'Type', _fax_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 23))])
    
    #-----< generalizedTime >-----#
    generalizedTime = CLASS(name=u'generalizedTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _generalizedTime_val_Type = TIME_GEN(name=u'Type', mode=MODE_TYPE)
    generalizedTime._val = dict([(u'ldapDesc', u'Generalized Time'), (u'Type', _generalizedTime_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24))])
    
    #-----< guide >-----#
    guide = CLASS(name=u'guide', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _guide_val_Type = SET(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'Guide')))
    guide._val = dict([(u'ldapDesc', u'Guide'), (u'Type', _guide_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 25))])
    
    #-----< ia5String >-----#
    ia5String = CLASS(name=u'ia5String', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _ia5String_val_Type = STR_IA5(name=u'Type', mode=MODE_TYPE)
    ia5String._val = dict([(u'ldapDesc', u'IA5 String'), (u'Type', _ia5String_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26))])
    
    #-----< integer >-----#
    integer = CLASS(name=u'integer', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _integer_val_Type = INT(name=u'Type', mode=MODE_TYPE)
    integer._val = dict([(u'ldapDesc', u'INTEGER'), (u'Type', _integer_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27))])
    
    #-----< jpeg >-----#
    jpeg = CLASS(name=u'jpeg', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _jpeg_val_Type = NULL(name=u'Type', mode=MODE_TYPE)
    jpeg._val = dict([(u'ldapDesc', u'JPEG'), (u'Type', _jpeg_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 28))])
    
    #-----< matchingRuleDescription >-----#
    matchingRuleDescription = CLASS(name=u'matchingRuleDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _matchingRuleDescription_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleDescription')))
    matchingRuleDescription._val = dict([(u'ldapDesc', u'Matching Rule Description'), (u'Type', _matchingRuleDescription_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 30))])
    
    #-----< matchingRuleUseDescription >-----#
    matchingRuleUseDescription = CLASS(name=u'matchingRuleUseDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _matchingRuleUseDescription_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'MatchingRuleUseDescription')))
    matchingRuleUseDescription._val = dict([(u'ldapDesc', u'Matching Rule Use Description'), (u'Type', _matchingRuleUseDescription_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 31))])
    
    #-----< nameAndOptionalUID >-----#
    nameAndOptionalUID = CLASS(name=u'nameAndOptionalUID', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _nameAndOptionalUID_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'NameAndOptionalUID')))
    nameAndOptionalUID._val = dict([(u'ldapDesc', u'Name And Optional UID'), (u'Type', _nameAndOptionalUID_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 34))])
    
    #-----< nameFormDescription >-----#
    nameFormDescription = CLASS(name=u'nameFormDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _nameFormDescription_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'NameFormDescription')))
    nameFormDescription._val = dict([(u'ldapDesc', u'Name Form Description'), (u'Type', _nameFormDescription_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 35))])
    
    #-----< numericString >-----#
    numericString = CLASS(name=u'numericString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _numericString_val_Type = STR_NUM(name=u'Type', mode=MODE_TYPE)
    numericString._val = dict([(u'ldapDesc', u'Numeric String'), (u'Type', _numericString_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36))])
    
    #-----< objectClassDescription >-----#
    objectClassDescription = CLASS(name=u'objectClassDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _objectClassDescription_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SchemaAdministration', 'ObjectClassDescription')))
    objectClassDescription._val = dict([(u'ldapDesc', u'Object Class Description'), (u'Type', _objectClassDescription_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 37))])
    
    #-----< oid >-----#
    oid = CLASS(name=u'oid', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _oid_val_Type = OID(name=u'Type', mode=MODE_TYPE)
    oid._val = dict([(u'ldapDesc', u'OID'), (u'Type', _oid_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38))])
    
    #-----< otherMailbox >-----#
    otherMailbox = CLASS(name=u'otherMailbox', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _otherMailbox_val_Type = NULL(name=u'Type', mode=MODE_TYPE)
    otherMailbox._val = dict([(u'ldapDesc', u'Other Mailbox'), (u'Type', _otherMailbox_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 39))])
    
    #-----< octetString >-----#
    octetString = CLASS(name=u'octetString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _octetString_val_Type = OCT_STR(name=u'Type', mode=MODE_TYPE)
    octetString._val = dict([(u'ldapDesc', u'Octet String'), (u'Type', _octetString_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40))])
    
    #-----< postalAddr >-----#
    postalAddr = CLASS(name=u'postalAddr', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _postalAddr_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PostalAddress')))
    postalAddr._val = dict([(u'ldapDesc', u'Postal Address'), (u'Type', _postalAddr_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41))])
    
    #-----< presentationAddr >-----#
    presentationAddr = CLASS(name=u'presentationAddr', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _presentationAddr_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'PresentationAddress')))
    presentationAddr._val = dict([(u'ldapDesc', u'Presentation Address'), (u'Type', _presentationAddr_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 43))])
    
    #-----< printableString >-----#
    printableString = CLASS(name=u'printableString', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _printableString_val_Type = STR_PRINT(name=u'Type', mode=MODE_TYPE)
    printableString._val = dict([(u'ldapDesc', u'Printable String'), (u'Type', _printableString_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44))])
    
    #-----< subtreeSpec >-----#
    subtreeSpec = CLASS(name=u'subtreeSpec', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _subtreeSpec_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'SubtreeSpecification')))
    subtreeSpec._val = dict([(u'ldapDesc', u'SubtreeSpecification'), (u'Type', _subtreeSpec_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 45))])
    
    #-----< telephoneNr >-----#
    telephoneNr = CLASS(name=u'telephoneNr', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _telephoneNr_val_Type = STR_PRINT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelephoneNumber')))
    telephoneNr._val = dict([(u'ldapDesc', u'Telephone Number'), (u'Type', _telephoneNr_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 50))])
    
    #-----< telexNr >-----#
    telexNr = CLASS(name=u'telexNr', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _telexNr_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TelexNumber')))
    telexNr._val = dict([(u'ldapDesc', u'Telex Number'), (u'Type', _telexNr_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 52))])
    
    #-----< utcTime >-----#
    utcTime = CLASS(name=u'utcTime', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _utcTime_val_Type = TIME_UTC(name=u'Type', mode=MODE_TYPE)
    utcTime._val = dict([(u'ldapDesc', u'UTC Time'), (u'Type', _utcTime_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 53))])
    
    #-----< ldapSyntaxDescription >-----#
    ldapSyntaxDescription = CLASS(name=u'ldapSyntaxDescription', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _ldapSyntaxDescription_val_Type = NULL(name=u'Type', mode=MODE_TYPE)
    ldapSyntaxDescription._val = dict([(u'ldapDesc', u'LDAP Syntax Description'), (u'Type', _ldapSyntaxDescription_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 54))])
    
    #-----< substringAssertion >-----#
    substringAssertion = CLASS(name=u'substringAssertion', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'SYNTAX-NAME')))
    _substringAssertion_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'SubstringAssertion')))
    substringAssertion._val = dict([(u'ldapDesc', u'Substring Assertion'), (u'Type', _substringAssertion_val_Type), (u'id', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58))])
    
    #-----< languageContext >-----#
    languageContext = CLASS(name=u'languageContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _languageContext_val_Type = STR_PRINT(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'LanguageContextSyntax')))
    languageContext._val = dict([(u'Type', _languageContext_val_Type), (u'id', (2, 5, 31, 0))])
    
    #-----< LanguageContextSyntax >-----#
    LanguageContextSyntax = STR_PRINT(name=u'LanguageContextSyntax', mode=MODE_TYPE)
    LanguageContextSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    
    #-----< temporalContext >-----#
    temporalContext = CLASS(name=u'temporalContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _temporalContext_val_Type = SEQ(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TimeSpecification')))
    _temporalContext_val_Assertion = CHOICE(name=u'Assertion', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TimeAssertion')))
    temporalContext._val = dict([(u'Type', _temporalContext_val_Type), (u'Assertion', _temporalContext_val_Assertion), (u'id', (2, 5, 31, 1))])
    
    #-----< TimeSpecification >-----#
    TimeSpecification = SEQ(name=u'TimeSpecification', mode=MODE_TYPE)
    _TimeSpecification_time = CHOICE(name=u'time', mode=MODE_TYPE)
    __TimeSpecification_time_absolute = SEQ(name=u'absolute', mode=MODE_TYPE)
    ___TimeSpecification_time_absolute_startTime = TIME_GEN(name=u'startTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    ___TimeSpecification_time_absolute_endTime = TIME_GEN(name=u'endTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __TimeSpecification_time_absolute._cont = ASN1Dict([
        (u'startTime', ___TimeSpecification_time_absolute_startTime),
        (u'endTime', ___TimeSpecification_time_absolute_endTime),
        ])
    __TimeSpecification_time_absolute._ext = []
    __TimeSpecification_time_periodic = SET_OF(name=u'periodic', mode=MODE_TYPE)
    ___TimeSpecification_time_periodic__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'Period')))
    __TimeSpecification_time_periodic._cont = ___TimeSpecification_time_periodic__item_
    __TimeSpecification_time_periodic._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _TimeSpecification_time._cont = ASN1Dict([
        (u'absolute', __TimeSpecification_time_absolute),
        (u'periodic', __TimeSpecification_time_periodic),
        ])
    _TimeSpecification_time._ext = None
    _TimeSpecification_notThisTime = BOOL(name=u'notThisTime', mode=MODE_TYPE, default=False)
    _TimeSpecification_timeZone = INT(name=u'timeZone', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'TimeZone')), opt=True)
    TimeSpecification._cont = ASN1Dict([
        (u'time', _TimeSpecification_time),
        (u'notThisTime', _TimeSpecification_notThisTime),
        (u'timeZone', _TimeSpecification_timeZone),
        ])
    TimeSpecification._ext = []
    
    #-----< Period >-----#
    Period = SEQ(name=u'Period', mode=MODE_TYPE)
    _Period_timesOfDay = SET_OF(name=u'timesOfDay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Period_timesOfDay__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'DayTimeBand')))
    _Period_timesOfDay._cont = __Period_timesOfDay__item_
    _Period_timesOfDay._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Period_days = CHOICE(name=u'days', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Period_days_intDay = SET_OF(name=u'intDay', mode=MODE_TYPE)
    ___Period_days_intDay__item_ = INT(name='_item_', mode=MODE_TYPE)
    __Period_days_intDay._cont = ___Period_days_intDay__item_
    __Period_days_bitDay = BIT_STR(name=u'bitDay', mode=MODE_TYPE)
    __Period_days_bitDay._cont = ASN1Dict([(u'sunday', 0), (u'monday', 1), (u'tuesday', 2), (u'wednesday', 3), (u'thursday', 4), (u'friday', 5), (u'saturday', 6)])
    __Period_days_dayOf = CHOICE(name=u'dayOf', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'XDayOf')))
    _Period_days._cont = ASN1Dict([
        (u'intDay', __Period_days_intDay),
        (u'bitDay', __Period_days_bitDay),
        (u'dayOf', __Period_days_dayOf),
        ])
    _Period_days._ext = []
    _Period_weeks = CHOICE(name=u'weeks', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Period_weeks_allWeeks = NULL(name=u'allWeeks', mode=MODE_TYPE)
    __Period_weeks_intWeek = SET_OF(name=u'intWeek', mode=MODE_TYPE)
    ___Period_weeks_intWeek__item_ = INT(name='_item_', mode=MODE_TYPE)
    __Period_weeks_intWeek._cont = ___Period_weeks_intWeek__item_
    __Period_weeks_bitWeek = BIT_STR(name=u'bitWeek', mode=MODE_TYPE)
    __Period_weeks_bitWeek._cont = ASN1Dict([(u'week1', 0), (u'week2', 1), (u'week3', 2), (u'week4', 3), (u'week5', 4)])
    _Period_weeks._cont = ASN1Dict([
        (u'allWeeks', __Period_weeks_allWeeks),
        (u'intWeek', __Period_weeks_intWeek),
        (u'bitWeek', __Period_weeks_bitWeek),
        ])
    _Period_weeks._ext = []
    _Period_months = CHOICE(name=u'months', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Period_months_allMonths = NULL(name=u'allMonths', mode=MODE_TYPE)
    __Period_months_intMonth = SET_OF(name=u'intMonth', mode=MODE_TYPE)
    ___Period_months_intMonth__item_ = INT(name='_item_', mode=MODE_TYPE)
    __Period_months_intMonth._cont = ___Period_months_intMonth__item_
    __Period_months_bitMonth = BIT_STR(name=u'bitMonth', mode=MODE_TYPE)
    __Period_months_bitMonth._cont = ASN1Dict([(u'january', 0), (u'february', 1), (u'march', 2), (u'april', 3), (u'may', 4), (u'june', 5), (u'july', 6), (u'august', 7), (u'september', 8), (u'october', 9), (u'november', 10), (u'december', 11)])
    _Period_months._cont = ASN1Dict([
        (u'allMonths', __Period_months_allMonths),
        (u'intMonth', __Period_months_intMonth),
        (u'bitMonth', __Period_months_bitMonth),
        ])
    _Period_months._ext = []
    _Period_years = SET_OF(name=u'years', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Period_years__item_ = INT(name='_item_', mode=MODE_TYPE)
    __Period_years__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1000, ub=None)], ev=None, er=[])
    _Period_years._cont = __Period_years__item_
    Period._cont = ASN1Dict([
        (u'timesOfDay', _Period_timesOfDay),
        (u'days', _Period_days),
        (u'weeks', _Period_weeks),
        (u'months', _Period_months),
        (u'years', _Period_years),
        ])
    Period._ext = []
    
    #-----< XDayOf >-----#
    XDayOf = CHOICE(name=u'XDayOf', mode=MODE_TYPE)
    _XDayOf_first = CHOICE(name=u'first', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'NamedDay')))
    _XDayOf_second = CHOICE(name=u'second', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'NamedDay')))
    _XDayOf_third = CHOICE(name=u'third', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'NamedDay')))
    _XDayOf_fourth = CHOICE(name=u'fourth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'NamedDay')))
    _XDayOf_fifth = CHOICE(name=u'fifth', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'NamedDay')))
    XDayOf._cont = ASN1Dict([
        (u'first', _XDayOf_first),
        (u'second', _XDayOf_second),
        (u'third', _XDayOf_third),
        (u'fourth', _XDayOf_fourth),
        (u'fifth', _XDayOf_fifth),
        ])
    XDayOf._ext = None
    
    #-----< NamedDay >-----#
    NamedDay = CHOICE(name=u'NamedDay', mode=MODE_TYPE)
    _NamedDay_intNamedDays = ENUM(name=u'intNamedDays', mode=MODE_TYPE)
    _NamedDay_intNamedDays._cont = ASN1Dict([(u'sunday', 1), (u'monday', 2), (u'tuesday', 3), (u'wednesday', 4), (u'thursday', 5), (u'friday', 6), (u'saturday', 7)])
    _NamedDay_intNamedDays._ext = None
    _NamedDay_bitNamedDays = BIT_STR(name=u'bitNamedDays', mode=MODE_TYPE)
    _NamedDay_bitNamedDays._cont = ASN1Dict([(u'sunday', 0), (u'monday', 1), (u'tuesday', 2), (u'wednesday', 3), (u'thursday', 4), (u'friday', 5), (u'saturday', 6)])
    NamedDay._cont = ASN1Dict([
        (u'intNamedDays', _NamedDay_intNamedDays),
        (u'bitNamedDays', _NamedDay_bitNamedDays),
        ])
    NamedDay._ext = None
    
    #-----< DayTimeBand >-----#
    DayTimeBand = SEQ(name=u'DayTimeBand', mode=MODE_TYPE)
    _DayTimeBand_startDayTime = SEQ(name=u'startDayTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'DayTime')), default=dict([(u'hour', 0)]))
    _DayTimeBand_endDayTime = SEQ(name=u'endDayTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SelectedAttributeTypes', 'DayTime')), default=dict([(u'hour', 23), (u'minute', 59), (u'second', 59)]))
    DayTimeBand._cont = ASN1Dict([
        (u'startDayTime', _DayTimeBand_startDayTime),
        (u'endDayTime', _DayTimeBand_endDayTime),
        ])
    DayTimeBand._ext = []
    
    #-----< DayTime >-----#
    DayTime = SEQ(name=u'DayTime', mode=MODE_TYPE)
    _DayTime_hour = INT(name=u'hour', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _DayTime_hour._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=23)], ev=None, er=[])
    _DayTime_minute = INT(name=u'minute', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=0)
    _DayTime_minute._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=None, er=[])
    _DayTime_second = INT(name=u'second', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=0)
    _DayTime_second._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=None, er=[])
    DayTime._cont = ASN1Dict([
        (u'hour', _DayTime_hour),
        (u'minute', _DayTime_minute),
        (u'second', _DayTime_second),
        ])
    DayTime._ext = []
    
    #-----< TimeZone >-----#
    TimeZone = INT(name=u'TimeZone', mode=MODE_TYPE)
    TimeZone._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-12, ub=12)], ev=None, er=[])
    
    #-----< TimeAssertion >-----#
    TimeAssertion = CHOICE(name=u'TimeAssertion', mode=MODE_TYPE)
    _TimeAssertion_now = NULL(name=u'now', mode=MODE_TYPE)
    _TimeAssertion_at = TIME_GEN(name=u'at', mode=MODE_TYPE)
    _TimeAssertion_between = SEQ(name=u'between', mode=MODE_TYPE)
    __TimeAssertion_between_startTime = TIME_GEN(name=u'startTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __TimeAssertion_between_endTime = TIME_GEN(name=u'endTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __TimeAssertion_between_entirely = BOOL(name=u'entirely', mode=MODE_TYPE, default=False)
    _TimeAssertion_between._cont = ASN1Dict([
        (u'startTime', __TimeAssertion_between_startTime),
        (u'endTime', __TimeAssertion_between_endTime),
        (u'entirely', __TimeAssertion_between_entirely),
        ])
    _TimeAssertion_between._ext = []
    TimeAssertion._cont = ASN1Dict([
        (u'now', _TimeAssertion_now),
        (u'at', _TimeAssertion_at),
        (u'between', _TimeAssertion_between),
        ])
    TimeAssertion._ext = []
    
    #-----< localeContext >-----#
    localeContext = CLASS(name=u'localeContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _localeContext_val_Type = CHOICE(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'LocaleContextSyntax')))
    localeContext._val = dict([(u'Type', _localeContext_val_Type), (u'id', (2, 5, 31, 2))])
    
    #-----< LocaleContextSyntax >-----#
    LocaleContextSyntax = CHOICE(name=u'LocaleContextSyntax', mode=MODE_TYPE)
    _LocaleContextSyntax_localeID1 = OID(name=u'localeID1', mode=MODE_TYPE)
    _LocaleContextSyntax_localeID2 = CHOICE(name=u'localeID2', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'UnboundedDirectoryString')))
    LocaleContextSyntax._cont = ASN1Dict([
        (u'localeID1', _LocaleContextSyntax_localeID1),
        (u'localeID2', _LocaleContextSyntax_localeID2),
        ])
    LocaleContextSyntax._ext = []
    
    #-----< ldapAttributeOptionContext >-----#
    ldapAttributeOptionContext = CLASS(name=u'ldapAttributeOptionContext', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    _ldapAttributeOptionContext_val_Type = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'AttributeOptionList')))
    _ldapAttributeOptionContext_val_Assertion = SEQ_OF(name=u'Assertion', mode=MODE_TYPE, typeref=ASN1RefType(('SelectedAttributeTypes', 'AttributeOptionList')))
    ldapAttributeOptionContext._val = dict([(u'Type', _ldapAttributeOptionContext_val_Type), (u'Assertion', _ldapAttributeOptionContext_val_Assertion), (u'absentMatch', False), (u'id', (2, 5, 31, 5))])
    
    #-----< AttributeOptionList >-----#
    AttributeOptionList = SEQ_OF(name=u'AttributeOptionList', mode=MODE_TYPE)
    _AttributeOptionList__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    AttributeOptionList._cont = _AttributeOptionList__item_
    
    #-----< id-at-knowledgeInformation >-----#
    id_at_knowledgeInformation = OID(name=u'id-at-knowledgeInformation', mode=MODE_VALUE)
    id_at_knowledgeInformation._val = (2, 5, 4, 2)
    
    #-----< id-at-commonName >-----#
    id_at_commonName = OID(name=u'id-at-commonName', mode=MODE_VALUE)
    id_at_commonName._val = (2, 5, 4, 3)
    
    #-----< id-at-surname >-----#
    id_at_surname = OID(name=u'id-at-surname', mode=MODE_VALUE)
    id_at_surname._val = (2, 5, 4, 4)
    
    #-----< id-at-serialNumber >-----#
    id_at_serialNumber = OID(name=u'id-at-serialNumber', mode=MODE_VALUE)
    id_at_serialNumber._val = (2, 5, 4, 5)
    
    #-----< id-at-countryName >-----#
    id_at_countryName = OID(name=u'id-at-countryName', mode=MODE_VALUE)
    id_at_countryName._val = (2, 5, 4, 6)
    
    #-----< id-at-localityName >-----#
    id_at_localityName = OID(name=u'id-at-localityName', mode=MODE_VALUE)
    id_at_localityName._val = (2, 5, 4, 7)
    
    #-----< id-at-collectiveLocalityName >-----#
    id_at_collectiveLocalityName = OID(name=u'id-at-collectiveLocalityName', mode=MODE_VALUE)
    id_at_collectiveLocalityName._val = (2, 5, 4, 7, 1)
    
    #-----< id-at-stateOrProvinceName >-----#
    id_at_stateOrProvinceName = OID(name=u'id-at-stateOrProvinceName', mode=MODE_VALUE)
    id_at_stateOrProvinceName._val = (2, 5, 4, 8)
    
    #-----< id-at-collectiveStateOrProvinceName >-----#
    id_at_collectiveStateOrProvinceName = OID(name=u'id-at-collectiveStateOrProvinceName', mode=MODE_VALUE)
    id_at_collectiveStateOrProvinceName._val = (2, 5, 4, 8, 1)
    
    #-----< id-at-streetAddress >-----#
    id_at_streetAddress = OID(name=u'id-at-streetAddress', mode=MODE_VALUE)
    id_at_streetAddress._val = (2, 5, 4, 9)
    
    #-----< id-at-collectiveStreetAddress >-----#
    id_at_collectiveStreetAddress = OID(name=u'id-at-collectiveStreetAddress', mode=MODE_VALUE)
    id_at_collectiveStreetAddress._val = (2, 5, 4, 9, 1)
    
    #-----< id-at-organizationName >-----#
    id_at_organizationName = OID(name=u'id-at-organizationName', mode=MODE_VALUE)
    id_at_organizationName._val = (2, 5, 4, 10)
    
    #-----< id-at-collectiveOrganizationName >-----#
    id_at_collectiveOrganizationName = OID(name=u'id-at-collectiveOrganizationName', mode=MODE_VALUE)
    id_at_collectiveOrganizationName._val = (2, 5, 4, 10, 1)
    
    #-----< id-at-organizationalUnitName >-----#
    id_at_organizationalUnitName = OID(name=u'id-at-organizationalUnitName', mode=MODE_VALUE)
    id_at_organizationalUnitName._val = (2, 5, 4, 11)
    
    #-----< id-at-collectiveOrganizationalUnitName >-----#
    id_at_collectiveOrganizationalUnitName = OID(name=u'id-at-collectiveOrganizationalUnitName', mode=MODE_VALUE)
    id_at_collectiveOrganizationalUnitName._val = (2, 5, 4, 11, 1)
    
    #-----< id-at-title >-----#
    id_at_title = OID(name=u'id-at-title', mode=MODE_VALUE)
    id_at_title._val = (2, 5, 4, 12)
    
    #-----< id-at-description >-----#
    id_at_description = OID(name=u'id-at-description', mode=MODE_VALUE)
    id_at_description._val = (2, 5, 4, 13)
    
    #-----< id-at-searchGuide >-----#
    id_at_searchGuide = OID(name=u'id-at-searchGuide', mode=MODE_VALUE)
    id_at_searchGuide._val = (2, 5, 4, 14)
    
    #-----< id-at-businessCategory >-----#
    id_at_businessCategory = OID(name=u'id-at-businessCategory', mode=MODE_VALUE)
    id_at_businessCategory._val = (2, 5, 4, 15)
    
    #-----< id-at-postalAddress >-----#
    id_at_postalAddress = OID(name=u'id-at-postalAddress', mode=MODE_VALUE)
    id_at_postalAddress._val = (2, 5, 4, 16)
    
    #-----< id-at-collectivePostalAddress >-----#
    id_at_collectivePostalAddress = OID(name=u'id-at-collectivePostalAddress', mode=MODE_VALUE)
    id_at_collectivePostalAddress._val = (2, 5, 4, 16, 1)
    
    #-----< id-at-postalCode >-----#
    id_at_postalCode = OID(name=u'id-at-postalCode', mode=MODE_VALUE)
    id_at_postalCode._val = (2, 5, 4, 17)
    
    #-----< id-at-collectivePostalCode >-----#
    id_at_collectivePostalCode = OID(name=u'id-at-collectivePostalCode', mode=MODE_VALUE)
    id_at_collectivePostalCode._val = (2, 5, 4, 17, 1)
    
    #-----< id-at-postOfficeBox >-----#
    id_at_postOfficeBox = OID(name=u'id-at-postOfficeBox', mode=MODE_VALUE)
    id_at_postOfficeBox._val = (2, 5, 4, 18)
    
    #-----< id-at-collectivePostOfficeBox >-----#
    id_at_collectivePostOfficeBox = OID(name=u'id-at-collectivePostOfficeBox', mode=MODE_VALUE)
    id_at_collectivePostOfficeBox._val = (2, 5, 4, 18, 1)
    
    #-----< id-at-physicalDeliveryOfficeName >-----#
    id_at_physicalDeliveryOfficeName = OID(name=u'id-at-physicalDeliveryOfficeName', mode=MODE_VALUE)
    id_at_physicalDeliveryOfficeName._val = (2, 5, 4, 19)
    
    #-----< id-at-collectivePhysicalDeliveryOfficeName >-----#
    id_at_collectivePhysicalDeliveryOfficeName = OID(name=u'id-at-collectivePhysicalDeliveryOfficeName', mode=MODE_VALUE)
    id_at_collectivePhysicalDeliveryOfficeName._val = (2, 5, 4, 19, 1)
    
    #-----< id-at-telephoneNumber >-----#
    id_at_telephoneNumber = OID(name=u'id-at-telephoneNumber', mode=MODE_VALUE)
    id_at_telephoneNumber._val = (2, 5, 4, 20)
    
    #-----< id-at-collectiveTelephoneNumber >-----#
    id_at_collectiveTelephoneNumber = OID(name=u'id-at-collectiveTelephoneNumber', mode=MODE_VALUE)
    id_at_collectiveTelephoneNumber._val = (2, 5, 4, 20, 1)
    
    #-----< id-at-telexNumber >-----#
    id_at_telexNumber = OID(name=u'id-at-telexNumber', mode=MODE_VALUE)
    id_at_telexNumber._val = (2, 5, 4, 21)
    
    #-----< id-at-collectiveTelexNumber >-----#
    id_at_collectiveTelexNumber = OID(name=u'id-at-collectiveTelexNumber', mode=MODE_VALUE)
    id_at_collectiveTelexNumber._val = (2, 5, 4, 21, 1)
    
    #-----< id-at-facsimileTelephoneNumber >-----#
    id_at_facsimileTelephoneNumber = OID(name=u'id-at-facsimileTelephoneNumber', mode=MODE_VALUE)
    id_at_facsimileTelephoneNumber._val = (2, 5, 4, 23)
    
    #-----< id-at-collectiveFacsimileTelephoneNumber >-----#
    id_at_collectiveFacsimileTelephoneNumber = OID(name=u'id-at-collectiveFacsimileTelephoneNumber', mode=MODE_VALUE)
    id_at_collectiveFacsimileTelephoneNumber._val = (2, 5, 4, 23, 1)
    
    #-----< id-at-x121Address >-----#
    id_at_x121Address = OID(name=u'id-at-x121Address', mode=MODE_VALUE)
    id_at_x121Address._val = (2, 5, 4, 24)
    
    #-----< id-at-internationalISDNNumber >-----#
    id_at_internationalISDNNumber = OID(name=u'id-at-internationalISDNNumber', mode=MODE_VALUE)
    id_at_internationalISDNNumber._val = (2, 5, 4, 25)
    
    #-----< id-at-collectiveInternationalISDNNumber >-----#
    id_at_collectiveInternationalISDNNumber = OID(name=u'id-at-collectiveInternationalISDNNumber', mode=MODE_VALUE)
    id_at_collectiveInternationalISDNNumber._val = (2, 5, 4, 25, 1)
    
    #-----< id-at-registeredAddress >-----#
    id_at_registeredAddress = OID(name=u'id-at-registeredAddress', mode=MODE_VALUE)
    id_at_registeredAddress._val = (2, 5, 4, 26)
    
    #-----< id-at-destinationIndicator >-----#
    id_at_destinationIndicator = OID(name=u'id-at-destinationIndicator', mode=MODE_VALUE)
    id_at_destinationIndicator._val = (2, 5, 4, 27)
    
    #-----< id-at-preferredDeliveryMethod >-----#
    id_at_preferredDeliveryMethod = OID(name=u'id-at-preferredDeliveryMethod', mode=MODE_VALUE)
    id_at_preferredDeliveryMethod._val = (2, 5, 4, 28)
    
    #-----< id-at-presentationAddress >-----#
    id_at_presentationAddress = OID(name=u'id-at-presentationAddress', mode=MODE_VALUE)
    id_at_presentationAddress._val = (2, 5, 4, 29)
    
    #-----< id-at-supportedApplicationContext >-----#
    id_at_supportedApplicationContext = OID(name=u'id-at-supportedApplicationContext', mode=MODE_VALUE)
    id_at_supportedApplicationContext._val = (2, 5, 4, 30)
    
    #-----< id-at-member >-----#
    id_at_member = OID(name=u'id-at-member', mode=MODE_VALUE)
    id_at_member._val = (2, 5, 4, 31)
    
    #-----< id-at-owner >-----#
    id_at_owner = OID(name=u'id-at-owner', mode=MODE_VALUE)
    id_at_owner._val = (2, 5, 4, 32)
    
    #-----< id-at-roleOccupant >-----#
    id_at_roleOccupant = OID(name=u'id-at-roleOccupant', mode=MODE_VALUE)
    id_at_roleOccupant._val = (2, 5, 4, 33)
    
    #-----< id-at-seeAlso >-----#
    id_at_seeAlso = OID(name=u'id-at-seeAlso', mode=MODE_VALUE)
    id_at_seeAlso._val = (2, 5, 4, 34)
    
    #-----< id-at-name >-----#
    id_at_name = OID(name=u'id-at-name', mode=MODE_VALUE)
    id_at_name._val = (2, 5, 4, 41)
    
    #-----< id-at-givenName >-----#
    id_at_givenName = OID(name=u'id-at-givenName', mode=MODE_VALUE)
    id_at_givenName._val = (2, 5, 4, 42)
    
    #-----< id-at-initials >-----#
    id_at_initials = OID(name=u'id-at-initials', mode=MODE_VALUE)
    id_at_initials._val = (2, 5, 4, 43)
    
    #-----< id-at-generationQualifier >-----#
    id_at_generationQualifier = OID(name=u'id-at-generationQualifier', mode=MODE_VALUE)
    id_at_generationQualifier._val = (2, 5, 4, 44)
    
    #-----< id-at-uniqueIdentifier >-----#
    id_at_uniqueIdentifier = OID(name=u'id-at-uniqueIdentifier', mode=MODE_VALUE)
    id_at_uniqueIdentifier._val = (2, 5, 4, 45)
    
    #-----< id-at-dnQualifier >-----#
    id_at_dnQualifier = OID(name=u'id-at-dnQualifier', mode=MODE_VALUE)
    id_at_dnQualifier._val = (2, 5, 4, 46)
    
    #-----< id-at-enhancedSearchGuide >-----#
    id_at_enhancedSearchGuide = OID(name=u'id-at-enhancedSearchGuide', mode=MODE_VALUE)
    id_at_enhancedSearchGuide._val = (2, 5, 4, 47)
    
    #-----< id-at-protocolInformation >-----#
    id_at_protocolInformation = OID(name=u'id-at-protocolInformation', mode=MODE_VALUE)
    id_at_protocolInformation._val = (2, 5, 4, 48)
    
    #-----< id-at-distinguishedName >-----#
    id_at_distinguishedName = OID(name=u'id-at-distinguishedName', mode=MODE_VALUE)
    id_at_distinguishedName._val = (2, 5, 4, 49)
    
    #-----< id-at-uniqueMember >-----#
    id_at_uniqueMember = OID(name=u'id-at-uniqueMember', mode=MODE_VALUE)
    id_at_uniqueMember._val = (2, 5, 4, 50)
    
    #-----< id-at-houseIdentifier >-----#
    id_at_houseIdentifier = OID(name=u'id-at-houseIdentifier', mode=MODE_VALUE)
    id_at_houseIdentifier._val = (2, 5, 4, 51)
    
    #-----< id-at-dmdName >-----#
    id_at_dmdName = OID(name=u'id-at-dmdName', mode=MODE_VALUE)
    id_at_dmdName._val = (2, 5, 4, 54)
    
    #-----< id-at-pseudonym >-----#
    id_at_pseudonym = OID(name=u'id-at-pseudonym', mode=MODE_VALUE)
    id_at_pseudonym._val = (2, 5, 4, 65)
    
    #-----< id-at-communicationsService >-----#
    id_at_communicationsService = OID(name=u'id-at-communicationsService', mode=MODE_VALUE)
    id_at_communicationsService._val = (2, 5, 4, 66)
    
    #-----< id-at-communicationsNetwork >-----#
    id_at_communicationsNetwork = OID(name=u'id-at-communicationsNetwork', mode=MODE_VALUE)
    id_at_communicationsNetwork._val = (2, 5, 4, 67)
    
    #-----< id-at-uuidpair >-----#
    id_at_uuidpair = OID(name=u'id-at-uuidpair', mode=MODE_VALUE)
    id_at_uuidpair._val = (2, 5, 4, 77)
    
    #-----< id-at-tagOid >-----#
    id_at_tagOid = OID(name=u'id-at-tagOid', mode=MODE_VALUE)
    id_at_tagOid._val = (2, 5, 4, 78)
    
    #-----< id-at-uiiFormat >-----#
    id_at_uiiFormat = OID(name=u'id-at-uiiFormat', mode=MODE_VALUE)
    id_at_uiiFormat._val = (2, 5, 4, 79)
    
    #-----< id-at-uiiInUrn >-----#
    id_at_uiiInUrn = OID(name=u'id-at-uiiInUrn', mode=MODE_VALUE)
    id_at_uiiInUrn._val = (2, 5, 4, 80)
    
    #-----< id-at-contentUrl >-----#
    id_at_contentUrl = OID(name=u'id-at-contentUrl', mode=MODE_VALUE)
    id_at_contentUrl._val = (2, 5, 4, 81)
    
    #-----< id-at-uri >-----#
    id_at_uri = OID(name=u'id-at-uri', mode=MODE_VALUE)
    id_at_uri._val = (2, 5, 4, 83)
    
    #-----< id-at-urn >-----#
    id_at_urn = OID(name=u'id-at-urn', mode=MODE_VALUE)
    id_at_urn._val = (2, 5, 4, 86)
    
    #-----< id-at-url >-----#
    id_at_url = OID(name=u'id-at-url', mode=MODE_VALUE)
    id_at_url._val = (2, 5, 4, 87)
    
    #-----< id-at-utmCoordinates >-----#
    id_at_utmCoordinates = OID(name=u'id-at-utmCoordinates', mode=MODE_VALUE)
    id_at_utmCoordinates._val = (2, 5, 4, 88)
    
    #-----< id-at-urnC >-----#
    id_at_urnC = OID(name=u'id-at-urnC', mode=MODE_VALUE)
    id_at_urnC._val = (2, 5, 4, 89)
    
    #-----< id-at-uii >-----#
    id_at_uii = OID(name=u'id-at-uii', mode=MODE_VALUE)
    id_at_uii._val = (2, 5, 4, 90)
    
    #-----< id-at-epc >-----#
    id_at_epc = OID(name=u'id-at-epc', mode=MODE_VALUE)
    id_at_epc._val = (2, 5, 4, 91)
    
    #-----< id-at-tagAfi >-----#
    id_at_tagAfi = OID(name=u'id-at-tagAfi', mode=MODE_VALUE)
    id_at_tagAfi._val = (2, 5, 4, 92)
    
    #-----< id-at-epcFormat >-----#
    id_at_epcFormat = OID(name=u'id-at-epcFormat', mode=MODE_VALUE)
    id_at_epcFormat._val = (2, 5, 4, 93)
    
    #-----< id-at-epcInUrn >-----#
    id_at_epcInUrn = OID(name=u'id-at-epcInUrn', mode=MODE_VALUE)
    id_at_epcInUrn._val = (2, 5, 4, 94)
    
    #-----< id-at-ldapUrl >-----#
    id_at_ldapUrl = OID(name=u'id-at-ldapUrl', mode=MODE_VALUE)
    id_at_ldapUrl._val = (2, 5, 4, 95)
    
    #-----< id-at-tagLocation >-----#
    id_at_tagLocation = OID(name=u'id-at-tagLocation', mode=MODE_VALUE)
    id_at_tagLocation._val = (2, 5, 4, 96)
    
    #-----< id-at-organizationIdentifier >-----#
    id_at_organizationIdentifier = OID(name=u'id-at-organizationIdentifier', mode=MODE_VALUE)
    id_at_organizationIdentifier._val = (2, 5, 4, 97)
    
    #-----< id-at-countryCode3c >-----#
    id_at_countryCode3c = OID(name=u'id-at-countryCode3c', mode=MODE_VALUE)
    id_at_countryCode3c._val = (2, 5, 4, 98)
    
    #-----< id-at-countryCode3n >-----#
    id_at_countryCode3n = OID(name=u'id-at-countryCode3n', mode=MODE_VALUE)
    id_at_countryCode3n._val = (2, 5, 4, 99)
    
    #-----< id-at-dnsName >-----#
    id_at_dnsName = OID(name=u'id-at-dnsName', mode=MODE_VALUE)
    id_at_dnsName._val = (2, 5, 4, 100)
    
    #-----< id-asx-utmCoords >-----#
    id_asx_utmCoords = OID(name=u'id-asx-utmCoords', mode=MODE_VALUE)
    id_asx_utmCoords._val = (2, 5, 40, 4)
    
    #-----< id-asx-uiiForm >-----#
    id_asx_uiiForm = OID(name=u'id-asx-uiiForm', mode=MODE_VALUE)
    id_asx_uiiForm._val = (2, 5, 40, 5)
    
    #-----< id-asx-epcForm >-----#
    id_asx_epcForm = OID(name=u'id-asx-epcForm', mode=MODE_VALUE)
    id_asx_epcForm._val = (2, 5, 40, 6)
    
    #-----< id-asx-countryString3c >-----#
    id_asx_countryString3c = OID(name=u'id-asx-countryString3c', mode=MODE_VALUE)
    id_asx_countryString3c._val = (2, 5, 40, 7)
    
    #-----< id-asx-countryString3n >-----#
    id_asx_countryString3n = OID(name=u'id-asx-countryString3n', mode=MODE_VALUE)
    id_asx_countryString3n._val = (2, 5, 40, 8)
    
    #-----< id-asx-dnsString >-----#
    id_asx_dnsString = OID(name=u'id-asx-dnsString', mode=MODE_VALUE)
    id_asx_dnsString._val = (2, 5, 40, 9)
    
    #-----< id-lsx-attributeTypeDescription >-----#
    id_lsx_attributeTypeDescription = OID(name=u'id-lsx-attributeTypeDescription', mode=MODE_VALUE)
    id_lsx_attributeTypeDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 3)
    
    #-----< id-lsx-bitString >-----#
    id_lsx_bitString = OID(name=u'id-lsx-bitString', mode=MODE_VALUE)
    id_lsx_bitString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 6)
    
    #-----< id-lsx-boolean >-----#
    id_lsx_boolean = OID(name=u'id-lsx-boolean', mode=MODE_VALUE)
    id_lsx_boolean._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 7)
    
    #-----< id-lsx-countryString >-----#
    id_lsx_countryString = OID(name=u'id-lsx-countryString', mode=MODE_VALUE)
    id_lsx_countryString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 11)
    
    #-----< id-lsx-dn >-----#
    id_lsx_dn = OID(name=u'id-lsx-dn', mode=MODE_VALUE)
    id_lsx_dn._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)
    
    #-----< id-lsx-deliveryMethod >-----#
    id_lsx_deliveryMethod = OID(name=u'id-lsx-deliveryMethod', mode=MODE_VALUE)
    id_lsx_deliveryMethod._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 14)
    
    #-----< id-lsx-directoryString >-----#
    id_lsx_directoryString = OID(name=u'id-lsx-directoryString', mode=MODE_VALUE)
    id_lsx_directoryString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 15)
    
    #-----< id-lsx-dITContentRuleDescription >-----#
    id_lsx_dITContentRuleDescription = OID(name=u'id-lsx-dITContentRuleDescription', mode=MODE_VALUE)
    id_lsx_dITContentRuleDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 16)
    
    #-----< id-lsx-dITStructureRuleDescription >-----#
    id_lsx_dITStructureRuleDescription = OID(name=u'id-lsx-dITStructureRuleDescription', mode=MODE_VALUE)
    id_lsx_dITStructureRuleDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 17)
    
    #-----< id-lsx-enhancedGuide >-----#
    id_lsx_enhancedGuide = OID(name=u'id-lsx-enhancedGuide', mode=MODE_VALUE)
    id_lsx_enhancedGuide._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 21)
    
    #-----< id-lsx-facsimileTelephoneNr >-----#
    id_lsx_facsimileTelephoneNr = OID(name=u'id-lsx-facsimileTelephoneNr', mode=MODE_VALUE)
    id_lsx_facsimileTelephoneNr._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 22)
    
    #-----< id-lsx-fax >-----#
    id_lsx_fax = OID(name=u'id-lsx-fax', mode=MODE_VALUE)
    id_lsx_fax._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 23)
    
    #-----< id-lsx-generalizedTime >-----#
    id_lsx_generalizedTime = OID(name=u'id-lsx-generalizedTime', mode=MODE_VALUE)
    id_lsx_generalizedTime._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 24)
    
    #-----< id-lsx-guide >-----#
    id_lsx_guide = OID(name=u'id-lsx-guide', mode=MODE_VALUE)
    id_lsx_guide._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 25)
    
    #-----< id-lsx-ia5String >-----#
    id_lsx_ia5String = OID(name=u'id-lsx-ia5String', mode=MODE_VALUE)
    id_lsx_ia5String._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 26)
    
    #-----< id-lsx-integer >-----#
    id_lsx_integer = OID(name=u'id-lsx-integer', mode=MODE_VALUE)
    id_lsx_integer._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 27)
    
    #-----< id-lsx-jpeg >-----#
    id_lsx_jpeg = OID(name=u'id-lsx-jpeg', mode=MODE_VALUE)
    id_lsx_jpeg._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 28)
    
    #-----< id-lsx-matchingRuleDescription >-----#
    id_lsx_matchingRuleDescription = OID(name=u'id-lsx-matchingRuleDescription', mode=MODE_VALUE)
    id_lsx_matchingRuleDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 30)
    
    #-----< id-lsx-matchingRuleUseDescription >-----#
    id_lsx_matchingRuleUseDescription = OID(name=u'id-lsx-matchingRuleUseDescription', mode=MODE_VALUE)
    id_lsx_matchingRuleUseDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 31)
    
    #-----< id-lsx-nameAndOptionalUID >-----#
    id_lsx_nameAndOptionalUID = OID(name=u'id-lsx-nameAndOptionalUID', mode=MODE_VALUE)
    id_lsx_nameAndOptionalUID._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 34)
    
    #-----< id-lsx-nameFormDescription >-----#
    id_lsx_nameFormDescription = OID(name=u'id-lsx-nameFormDescription', mode=MODE_VALUE)
    id_lsx_nameFormDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 35)
    
    #-----< id-lsx-numericString >-----#
    id_lsx_numericString = OID(name=u'id-lsx-numericString', mode=MODE_VALUE)
    id_lsx_numericString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 36)
    
    #-----< id-lsx-objectClassDescription >-----#
    id_lsx_objectClassDescription = OID(name=u'id-lsx-objectClassDescription', mode=MODE_VALUE)
    id_lsx_objectClassDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 37)
    
    #-----< id-lsx-oid >-----#
    id_lsx_oid = OID(name=u'id-lsx-oid', mode=MODE_VALUE)
    id_lsx_oid._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)
    
    #-----< id-lsx-otherMailbox >-----#
    id_lsx_otherMailbox = OID(name=u'id-lsx-otherMailbox', mode=MODE_VALUE)
    id_lsx_otherMailbox._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 39)
    
    #-----< id-lsx-octetString >-----#
    id_lsx_octetString = OID(name=u'id-lsx-octetString', mode=MODE_VALUE)
    id_lsx_octetString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 40)
    
    #-----< id-lsx-postalAddr >-----#
    id_lsx_postalAddr = OID(name=u'id-lsx-postalAddr', mode=MODE_VALUE)
    id_lsx_postalAddr._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 41)
    
    #-----< id-lsx-presentationAddr >-----#
    id_lsx_presentationAddr = OID(name=u'id-lsx-presentationAddr', mode=MODE_VALUE)
    id_lsx_presentationAddr._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 43)
    
    #-----< id-lsx-printableString >-----#
    id_lsx_printableString = OID(name=u'id-lsx-printableString', mode=MODE_VALUE)
    id_lsx_printableString._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 44)
    
    #-----< id-lsx-subtreeSpec >-----#
    id_lsx_subtreeSpec = OID(name=u'id-lsx-subtreeSpec', mode=MODE_VALUE)
    id_lsx_subtreeSpec._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 45)
    
    #-----< id-lsx-telephoneNr >-----#
    id_lsx_telephoneNr = OID(name=u'id-lsx-telephoneNr', mode=MODE_VALUE)
    id_lsx_telephoneNr._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 50)
    
    #-----< id-lsx-telexNr >-----#
    id_lsx_telexNr = OID(name=u'id-lsx-telexNr', mode=MODE_VALUE)
    id_lsx_telexNr._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 52)
    
    #-----< id-lsx-utcTime >-----#
    id_lsx_utcTime = OID(name=u'id-lsx-utcTime', mode=MODE_VALUE)
    id_lsx_utcTime._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 53)
    
    #-----< id-lsx-ldapSyntaxDescription >-----#
    id_lsx_ldapSyntaxDescription = OID(name=u'id-lsx-ldapSyntaxDescription', mode=MODE_VALUE)
    id_lsx_ldapSyntaxDescription._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 54)
    
    #-----< id-lsx-substringAssertion >-----#
    id_lsx_substringAssertion = OID(name=u'id-lsx-substringAssertion', mode=MODE_VALUE)
    id_lsx_substringAssertion._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 58)
    
    #-----< id-oidC1 >-----#
    id_oidC1 = OID(name=u'id-oidC1', mode=MODE_VALUE)
    id_oidC1._val = (2, 17, 1, 2, 0)
    
    #-----< id-oidC2 >-----#
    id_oidC2 = OID(name=u'id-oidC2', mode=MODE_VALUE)
    id_oidC2._val = (2, 17, 1, 2, 1)
    
    #-----< id-oidC >-----#
    id_oidC = OID(name=u'id-oidC', mode=MODE_VALUE)
    id_oidC._val = (2, 17, 1, 2, 2)
    
    #-----< id-cat-sequenceMatchType >-----#
    id_cat_sequenceMatchType = OID(name=u'id-cat-sequenceMatchType', mode=MODE_VALUE)
    id_cat_sequenceMatchType._val = (2, 5, 37, 1)
    
    #-----< id-cat-wordMatchType >-----#
    id_cat_wordMatchType = OID(name=u'id-cat-wordMatchType', mode=MODE_VALUE)
    id_cat_wordMatchType._val = (2, 5, 37, 2)
    
    #-----< id-cat-characterMatchTypes >-----#
    id_cat_characterMatchTypes = OID(name=u'id-cat-characterMatchTypes', mode=MODE_VALUE)
    id_cat_characterMatchTypes._val = (2, 5, 37, 3)
    
    #-----< id-cat-selectedContexts >-----#
    id_cat_selectedContexts = OID(name=u'id-cat-selectedContexts', mode=MODE_VALUE)
    id_cat_selectedContexts._val = (2, 5, 37, 4)
    
    #-----< id-not-dSAProblem >-----#
    id_not_dSAProblem = OID(name=u'id-not-dSAProblem', mode=MODE_VALUE)
    id_not_dSAProblem._val = (2, 5, 35, 0)
    
    #-----< id-not-searchServiceProblem >-----#
    id_not_searchServiceProblem = OID(name=u'id-not-searchServiceProblem', mode=MODE_VALUE)
    id_not_searchServiceProblem._val = (2, 5, 35, 1)
    
    #-----< id-not-serviceType >-----#
    id_not_serviceType = OID(name=u'id-not-serviceType', mode=MODE_VALUE)
    id_not_serviceType._val = (2, 5, 35, 2)
    
    #-----< id-not-attributeTypeList >-----#
    id_not_attributeTypeList = OID(name=u'id-not-attributeTypeList', mode=MODE_VALUE)
    id_not_attributeTypeList._val = (2, 5, 35, 3)
    
    #-----< id-not-matchingRuleList >-----#
    id_not_matchingRuleList = OID(name=u'id-not-matchingRuleList', mode=MODE_VALUE)
    id_not_matchingRuleList._val = (2, 5, 35, 4)
    
    #-----< id-not-filterItem >-----#
    id_not_filterItem = OID(name=u'id-not-filterItem', mode=MODE_VALUE)
    id_not_filterItem._val = (2, 5, 35, 5)
    
    #-----< id-not-attributeCombinations >-----#
    id_not_attributeCombinations = OID(name=u'id-not-attributeCombinations', mode=MODE_VALUE)
    id_not_attributeCombinations._val = (2, 5, 35, 6)
    
    #-----< id-not-contextTypeList >-----#
    id_not_contextTypeList = OID(name=u'id-not-contextTypeList', mode=MODE_VALUE)
    id_not_contextTypeList._val = (2, 5, 35, 7)
    
    #-----< id-not-contextList >-----#
    id_not_contextList = OID(name=u'id-not-contextList', mode=MODE_VALUE)
    id_not_contextList._val = (2, 5, 35, 8)
    
    #-----< id-not-contextCombinations >-----#
    id_not_contextCombinations = OID(name=u'id-not-contextCombinations', mode=MODE_VALUE)
    id_not_contextCombinations._val = (2, 5, 35, 9)
    
    #-----< id-not-hierarchySelectList >-----#
    id_not_hierarchySelectList = OID(name=u'id-not-hierarchySelectList', mode=MODE_VALUE)
    id_not_hierarchySelectList._val = (2, 5, 35, 10)
    
    #-----< id-not-searchControlOptionsList >-----#
    id_not_searchControlOptionsList = OID(name=u'id-not-searchControlOptionsList', mode=MODE_VALUE)
    id_not_searchControlOptionsList._val = (2, 5, 35, 11)
    
    #-----< id-not-serviceControlOptionsList >-----#
    id_not_serviceControlOptionsList = OID(name=u'id-not-serviceControlOptionsList', mode=MODE_VALUE)
    id_not_serviceControlOptionsList._val = (2, 5, 35, 12)
    
    #-----< id-not-multipleMatchingLocalities >-----#
    id_not_multipleMatchingLocalities = OID(name=u'id-not-multipleMatchingLocalities', mode=MODE_VALUE)
    id_not_multipleMatchingLocalities._val = (2, 5, 35, 13)
    
    #-----< id-not-proposedRelaxation >-----#
    id_not_proposedRelaxation = OID(name=u'id-not-proposedRelaxation', mode=MODE_VALUE)
    id_not_proposedRelaxation._val = (2, 5, 35, 14)
    
    #-----< id-not-appliedRelaxation >-----#
    id_not_appliedRelaxation = OID(name=u'id-not-appliedRelaxation', mode=MODE_VALUE)
    id_not_appliedRelaxation._val = (2, 5, 35, 15)
    
    #-----< id-not-pwdResponse >-----#
    id_not_pwdResponse = OID(name=u'id-not-pwdResponse', mode=MODE_VALUE)
    id_not_pwdResponse._val = (2, 5, 35, 16)
    
    #-----< id-not-ldapDiagnosticMsg >-----#
    id_not_ldapDiagnosticMsg = OID(name=u'id-not-ldapDiagnosticMsg', mode=MODE_VALUE)
    id_not_ldapDiagnosticMsg._val = (2, 5, 35, 17)
    
    #-----< id-pr-targetDsaUnavailable >-----#
    id_pr_targetDsaUnavailable = OID(name=u'id-pr-targetDsaUnavailable', mode=MODE_VALUE)
    id_pr_targetDsaUnavailable._val = (2, 5, 34, 1)
    
    #-----< id-pr-dataSourceUnavailable >-----#
    id_pr_dataSourceUnavailable = OID(name=u'id-pr-dataSourceUnavailable', mode=MODE_VALUE)
    id_pr_dataSourceUnavailable._val = (2, 5, 34, 2)
    
    #-----< id-pr-unidentifiedOperation >-----#
    id_pr_unidentifiedOperation = OID(name=u'id-pr-unidentifiedOperation', mode=MODE_VALUE)
    id_pr_unidentifiedOperation._val = (2, 5, 34, 3)
    
    #-----< id-pr-unavailableOperation >-----#
    id_pr_unavailableOperation = OID(name=u'id-pr-unavailableOperation', mode=MODE_VALUE)
    id_pr_unavailableOperation._val = (2, 5, 34, 4)
    
    #-----< id-pr-searchAttributeViolation >-----#
    id_pr_searchAttributeViolation = OID(name=u'id-pr-searchAttributeViolation', mode=MODE_VALUE)
    id_pr_searchAttributeViolation._val = (2, 5, 34, 5)
    
    #-----< id-pr-searchAttributeCombinationViolation >-----#
    id_pr_searchAttributeCombinationViolation = OID(name=u'id-pr-searchAttributeCombinationViolation', mode=MODE_VALUE)
    id_pr_searchAttributeCombinationViolation._val = (2, 5, 34, 6)
    
    #-----< id-pr-searchValueNotAllowed >-----#
    id_pr_searchValueNotAllowed = OID(name=u'id-pr-searchValueNotAllowed', mode=MODE_VALUE)
    id_pr_searchValueNotAllowed._val = (2, 5, 34, 7)
    
    #-----< id-pr-missingSearchAttribute >-----#
    id_pr_missingSearchAttribute = OID(name=u'id-pr-missingSearchAttribute', mode=MODE_VALUE)
    id_pr_missingSearchAttribute._val = (2, 5, 34, 8)
    
    #-----< id-pr-searchValueViolation >-----#
    id_pr_searchValueViolation = OID(name=u'id-pr-searchValueViolation', mode=MODE_VALUE)
    id_pr_searchValueViolation._val = (2, 5, 34, 9)
    
    #-----< id-pr-attributeNegationViolation >-----#
    id_pr_attributeNegationViolation = OID(name=u'id-pr-attributeNegationViolation', mode=MODE_VALUE)
    id_pr_attributeNegationViolation._val = (2, 5, 34, 10)
    
    #-----< id-pr-searchValueRequired >-----#
    id_pr_searchValueRequired = OID(name=u'id-pr-searchValueRequired', mode=MODE_VALUE)
    id_pr_searchValueRequired._val = (2, 5, 34, 11)
    
    #-----< id-pr-invalidSearchValue >-----#
    id_pr_invalidSearchValue = OID(name=u'id-pr-invalidSearchValue', mode=MODE_VALUE)
    id_pr_invalidSearchValue._val = (2, 5, 34, 12)
    
    #-----< id-pr-searchContextViolation >-----#
    id_pr_searchContextViolation = OID(name=u'id-pr-searchContextViolation', mode=MODE_VALUE)
    id_pr_searchContextViolation._val = (2, 5, 34, 13)
    
    #-----< id-pr-searchContextCombinationViolation >-----#
    id_pr_searchContextCombinationViolation = OID(name=u'id-pr-searchContextCombinationViolation', mode=MODE_VALUE)
    id_pr_searchContextCombinationViolation._val = (2, 5, 34, 14)
    
    #-----< id-pr-missingSearchContext >-----#
    id_pr_missingSearchContext = OID(name=u'id-pr-missingSearchContext', mode=MODE_VALUE)
    id_pr_missingSearchContext._val = (2, 5, 34, 15)
    
    #-----< id-pr-searchContextValueViolation >-----#
    id_pr_searchContextValueViolation = OID(name=u'id-pr-searchContextValueViolation', mode=MODE_VALUE)
    id_pr_searchContextValueViolation._val = (2, 5, 34, 16)
    
    #-----< id-pr-searchContextValueRequired >-----#
    id_pr_searchContextValueRequired = OID(name=u'id-pr-searchContextValueRequired', mode=MODE_VALUE)
    id_pr_searchContextValueRequired._val = (2, 5, 34, 17)
    
    #-----< id-pr-invalidContextSearchValue >-----#
    id_pr_invalidContextSearchValue = OID(name=u'id-pr-invalidContextSearchValue', mode=MODE_VALUE)
    id_pr_invalidContextSearchValue._val = (2, 5, 34, 18)
    
    #-----< id-pr-unsupportedMatchingRule >-----#
    id_pr_unsupportedMatchingRule = OID(name=u'id-pr-unsupportedMatchingRule', mode=MODE_VALUE)
    id_pr_unsupportedMatchingRule._val = (2, 5, 34, 19)
    
    #-----< id-pr-attributeMatchingViolation >-----#
    id_pr_attributeMatchingViolation = OID(name=u'id-pr-attributeMatchingViolation', mode=MODE_VALUE)
    id_pr_attributeMatchingViolation._val = (2, 5, 34, 20)
    
    #-----< id-pr-unsupportedMatchingUse >-----#
    id_pr_unsupportedMatchingUse = OID(name=u'id-pr-unsupportedMatchingUse', mode=MODE_VALUE)
    id_pr_unsupportedMatchingUse._val = (2, 5, 34, 21)
    
    #-----< id-pr-matchingUseViolation >-----#
    id_pr_matchingUseViolation = OID(name=u'id-pr-matchingUseViolation', mode=MODE_VALUE)
    id_pr_matchingUseViolation._val = (2, 5, 34, 22)
    
    #-----< id-pr-hierarchySelectForbidden >-----#
    id_pr_hierarchySelectForbidden = OID(name=u'id-pr-hierarchySelectForbidden', mode=MODE_VALUE)
    id_pr_hierarchySelectForbidden._val = (2, 5, 34, 23)
    
    #-----< id-pr-invalidHierarchySelect >-----#
    id_pr_invalidHierarchySelect = OID(name=u'id-pr-invalidHierarchySelect', mode=MODE_VALUE)
    id_pr_invalidHierarchySelect._val = (2, 5, 34, 24)
    
    #-----< id-pr-unavailableHierarchySelect >-----#
    id_pr_unavailableHierarchySelect = OID(name=u'id-pr-unavailableHierarchySelect', mode=MODE_VALUE)
    id_pr_unavailableHierarchySelect._val = (2, 5, 34, 25)
    
    #-----< id-pr-invalidSearchControlOptions >-----#
    id_pr_invalidSearchControlOptions = OID(name=u'id-pr-invalidSearchControlOptions', mode=MODE_VALUE)
    id_pr_invalidSearchControlOptions._val = (2, 5, 34, 26)
    
    #-----< id-pr-invalidServiceControlOptions >-----#
    id_pr_invalidServiceControlOptions = OID(name=u'id-pr-invalidServiceControlOptions', mode=MODE_VALUE)
    id_pr_invalidServiceControlOptions._val = (2, 5, 34, 27)
    
    #-----< id-pr-searchSubsetViolation >-----#
    id_pr_searchSubsetViolation = OID(name=u'id-pr-searchSubsetViolation', mode=MODE_VALUE)
    id_pr_searchSubsetViolation._val = (2, 5, 34, 28)
    
    #-----< id-pr-unmatchedKeyAttributes >-----#
    id_pr_unmatchedKeyAttributes = OID(name=u'id-pr-unmatchedKeyAttributes', mode=MODE_VALUE)
    id_pr_unmatchedKeyAttributes._val = (2, 5, 34, 29)
    
    #-----< id-pr-ambiguousKeyAttributes >-----#
    id_pr_ambiguousKeyAttributes = OID(name=u'id-pr-ambiguousKeyAttributes', mode=MODE_VALUE)
    id_pr_ambiguousKeyAttributes._val = (2, 5, 34, 30)
    
    #-----< id-pr-unavailableRelaxationLevel >-----#
    id_pr_unavailableRelaxationLevel = OID(name=u'id-pr-unavailableRelaxationLevel', mode=MODE_VALUE)
    id_pr_unavailableRelaxationLevel._val = (2, 5, 34, 31)
    
    #-----< id-pr-emptyHierarchySelection >-----#
    id_pr_emptyHierarchySelection = OID(name=u'id-pr-emptyHierarchySelection', mode=MODE_VALUE)
    id_pr_emptyHierarchySelection._val = (2, 5, 34, 32)
    
    #-----< id-pr-administratorImposedLimit >-----#
    id_pr_administratorImposedLimit = OID(name=u'id-pr-administratorImposedLimit', mode=MODE_VALUE)
    id_pr_administratorImposedLimit._val = (2, 5, 34, 33)
    
    #-----< id-pr-permanentRestriction >-----#
    id_pr_permanentRestriction = OID(name=u'id-pr-permanentRestriction', mode=MODE_VALUE)
    id_pr_permanentRestriction._val = (2, 5, 34, 34)
    
    #-----< id-pr-temporaryRestriction >-----#
    id_pr_temporaryRestriction = OID(name=u'id-pr-temporaryRestriction', mode=MODE_VALUE)
    id_pr_temporaryRestriction._val = (2, 5, 34, 35)
    
    #-----< id-pr-relaxationNotSupported >-----#
    id_pr_relaxationNotSupported = OID(name=u'id-pr-relaxationNotSupported', mode=MODE_VALUE)
    id_pr_relaxationNotSupported._val = (2, 5, 34, 36)
    
    #-----< id-coat-uid >-----#
    id_coat_uid = OID(name=u'id-coat-uid', mode=MODE_VALUE)
    id_coat_uid._val = (0, 9, 2342, 19200300, 100, 1, 1)
    
    #-----< id-coat-dc >-----#
    id_coat_dc = OID(name=u'id-coat-dc', mode=MODE_VALUE)
    id_coat_dc._val = (0, 9, 2342, 19200300, 100, 1, 25)
    
    #-----< id-mr-caseIgnoreMatch >-----#
    id_mr_caseIgnoreMatch = OID(name=u'id-mr-caseIgnoreMatch', mode=MODE_VALUE)
    id_mr_caseIgnoreMatch._val = (2, 5, 13, 2)
    
    #-----< id-mr-caseIgnoreOrderingMatch >-----#
    id_mr_caseIgnoreOrderingMatch = OID(name=u'id-mr-caseIgnoreOrderingMatch', mode=MODE_VALUE)
    id_mr_caseIgnoreOrderingMatch._val = (2, 5, 13, 3)
    
    #-----< id-mr-caseIgnoreSubstringsMatch >-----#
    id_mr_caseIgnoreSubstringsMatch = OID(name=u'id-mr-caseIgnoreSubstringsMatch', mode=MODE_VALUE)
    id_mr_caseIgnoreSubstringsMatch._val = (2, 5, 13, 4)
    
    #-----< id-mr-caseExactMatch >-----#
    id_mr_caseExactMatch = OID(name=u'id-mr-caseExactMatch', mode=MODE_VALUE)
    id_mr_caseExactMatch._val = (2, 5, 13, 5)
    
    #-----< id-mr-caseExactOrderingMatch >-----#
    id_mr_caseExactOrderingMatch = OID(name=u'id-mr-caseExactOrderingMatch', mode=MODE_VALUE)
    id_mr_caseExactOrderingMatch._val = (2, 5, 13, 6)
    
    #-----< id-mr-caseExactSubstringsMatch >-----#
    id_mr_caseExactSubstringsMatch = OID(name=u'id-mr-caseExactSubstringsMatch', mode=MODE_VALUE)
    id_mr_caseExactSubstringsMatch._val = (2, 5, 13, 7)
    
    #-----< id-mr-numericStringMatch >-----#
    id_mr_numericStringMatch = OID(name=u'id-mr-numericStringMatch', mode=MODE_VALUE)
    id_mr_numericStringMatch._val = (2, 5, 13, 8)
    
    #-----< id-mr-numericStringOrderingMatch >-----#
    id_mr_numericStringOrderingMatch = OID(name=u'id-mr-numericStringOrderingMatch', mode=MODE_VALUE)
    id_mr_numericStringOrderingMatch._val = (2, 5, 13, 9)
    
    #-----< id-mr-numericStringSubstringsMatch >-----#
    id_mr_numericStringSubstringsMatch = OID(name=u'id-mr-numericStringSubstringsMatch', mode=MODE_VALUE)
    id_mr_numericStringSubstringsMatch._val = (2, 5, 13, 10)
    
    #-----< id-mr-caseIgnoreListMatch >-----#
    id_mr_caseIgnoreListMatch = OID(name=u'id-mr-caseIgnoreListMatch', mode=MODE_VALUE)
    id_mr_caseIgnoreListMatch._val = (2, 5, 13, 11)
    
    #-----< id-mr-caseIgnoreListSubstringsMatch >-----#
    id_mr_caseIgnoreListSubstringsMatch = OID(name=u'id-mr-caseIgnoreListSubstringsMatch', mode=MODE_VALUE)
    id_mr_caseIgnoreListSubstringsMatch._val = (2, 5, 13, 12)
    
    #-----< id-mr-booleanMatch >-----#
    id_mr_booleanMatch = OID(name=u'id-mr-booleanMatch', mode=MODE_VALUE)
    id_mr_booleanMatch._val = (2, 5, 13, 13)
    
    #-----< id-mr-integerMatch >-----#
    id_mr_integerMatch = OID(name=u'id-mr-integerMatch', mode=MODE_VALUE)
    id_mr_integerMatch._val = (2, 5, 13, 14)
    
    #-----< id-mr-integerOrderingMatch >-----#
    id_mr_integerOrderingMatch = OID(name=u'id-mr-integerOrderingMatch', mode=MODE_VALUE)
    id_mr_integerOrderingMatch._val = (2, 5, 13, 15)
    
    #-----< id-mr-bitStringMatch >-----#
    id_mr_bitStringMatch = OID(name=u'id-mr-bitStringMatch', mode=MODE_VALUE)
    id_mr_bitStringMatch._val = (2, 5, 13, 16)
    
    #-----< id-mr-octetStringMatch >-----#
    id_mr_octetStringMatch = OID(name=u'id-mr-octetStringMatch', mode=MODE_VALUE)
    id_mr_octetStringMatch._val = (2, 5, 13, 17)
    
    #-----< id-mr-octetStringOrderingMatch >-----#
    id_mr_octetStringOrderingMatch = OID(name=u'id-mr-octetStringOrderingMatch', mode=MODE_VALUE)
    id_mr_octetStringOrderingMatch._val = (2, 5, 13, 18)
    
    #-----< id-mr-octetStringSubstringsMatch >-----#
    id_mr_octetStringSubstringsMatch = OID(name=u'id-mr-octetStringSubstringsMatch', mode=MODE_VALUE)
    id_mr_octetStringSubstringsMatch._val = (2, 5, 13, 19)
    
    #-----< id-mr-telephoneNumberMatch >-----#
    id_mr_telephoneNumberMatch = OID(name=u'id-mr-telephoneNumberMatch', mode=MODE_VALUE)
    id_mr_telephoneNumberMatch._val = (2, 5, 13, 20)
    
    #-----< id-mr-telephoneNumberSubstringsMatch >-----#
    id_mr_telephoneNumberSubstringsMatch = OID(name=u'id-mr-telephoneNumberSubstringsMatch', mode=MODE_VALUE)
    id_mr_telephoneNumberSubstringsMatch._val = (2, 5, 13, 21)
    
    #-----< id-mr-presentationAddressMatch >-----#
    id_mr_presentationAddressMatch = OID(name=u'id-mr-presentationAddressMatch', mode=MODE_VALUE)
    id_mr_presentationAddressMatch._val = (2, 5, 13, 22)
    
    #-----< id-mr-uniqueMemberMatch >-----#
    id_mr_uniqueMemberMatch = OID(name=u'id-mr-uniqueMemberMatch', mode=MODE_VALUE)
    id_mr_uniqueMemberMatch._val = (2, 5, 13, 23)
    
    #-----< id-mr-protocolInformationMatch >-----#
    id_mr_protocolInformationMatch = OID(name=u'id-mr-protocolInformationMatch', mode=MODE_VALUE)
    id_mr_protocolInformationMatch._val = (2, 5, 13, 24)
    
    #-----< id-mr-uTCTimeMatch >-----#
    id_mr_uTCTimeMatch = OID(name=u'id-mr-uTCTimeMatch', mode=MODE_VALUE)
    id_mr_uTCTimeMatch._val = (2, 5, 13, 25)
    
    #-----< id-mr-uTCTimeOrderingMatch >-----#
    id_mr_uTCTimeOrderingMatch = OID(name=u'id-mr-uTCTimeOrderingMatch', mode=MODE_VALUE)
    id_mr_uTCTimeOrderingMatch._val = (2, 5, 13, 26)
    
    #-----< id-mr-generalizedTimeMatch >-----#
    id_mr_generalizedTimeMatch = OID(name=u'id-mr-generalizedTimeMatch', mode=MODE_VALUE)
    id_mr_generalizedTimeMatch._val = (2, 5, 13, 27)
    
    #-----< id-mr-generalizedTimeOrderingMatch >-----#
    id_mr_generalizedTimeOrderingMatch = OID(name=u'id-mr-generalizedTimeOrderingMatch', mode=MODE_VALUE)
    id_mr_generalizedTimeOrderingMatch._val = (2, 5, 13, 28)
    
    #-----< id-mr-integerFirstComponentMatch >-----#
    id_mr_integerFirstComponentMatch = OID(name=u'id-mr-integerFirstComponentMatch', mode=MODE_VALUE)
    id_mr_integerFirstComponentMatch._val = (2, 5, 13, 29)
    
    #-----< id-mr-objectIdentifierFirstComponentMatch >-----#
    id_mr_objectIdentifierFirstComponentMatch = OID(name=u'id-mr-objectIdentifierFirstComponentMatch', mode=MODE_VALUE)
    id_mr_objectIdentifierFirstComponentMatch._val = (2, 5, 13, 30)
    
    #-----< id-mr-directoryStringFirstComponentMatch >-----#
    id_mr_directoryStringFirstComponentMatch = OID(name=u'id-mr-directoryStringFirstComponentMatch', mode=MODE_VALUE)
    id_mr_directoryStringFirstComponentMatch._val = (2, 5, 13, 31)
    
    #-----< id-mr-wordMatch >-----#
    id_mr_wordMatch = OID(name=u'id-mr-wordMatch', mode=MODE_VALUE)
    id_mr_wordMatch._val = (2, 5, 13, 32)
    
    #-----< id-mr-keywordMatch >-----#
    id_mr_keywordMatch = OID(name=u'id-mr-keywordMatch', mode=MODE_VALUE)
    id_mr_keywordMatch._val = (2, 5, 13, 33)
    
    #-----< id-mr-storedPrefixMatch >-----#
    id_mr_storedPrefixMatch = OID(name=u'id-mr-storedPrefixMatch', mode=MODE_VALUE)
    id_mr_storedPrefixMatch._val = (2, 5, 13, 41)
    
    #-----< id-mr-systemProposedMatch >-----#
    id_mr_systemProposedMatch = OID(name=u'id-mr-systemProposedMatch', mode=MODE_VALUE)
    id_mr_systemProposedMatch._val = (2, 5, 13, 47)
    
    #-----< id-mr-generalWordMatch >-----#
    id_mr_generalWordMatch = OID(name=u'id-mr-generalWordMatch', mode=MODE_VALUE)
    id_mr_generalWordMatch._val = (2, 5, 13, 48)
    
    #-----< id-mr-approximateStringMatch >-----#
    id_mr_approximateStringMatch = OID(name=u'id-mr-approximateStringMatch', mode=MODE_VALUE)
    id_mr_approximateStringMatch._val = (2, 5, 13, 49)
    
    #-----< id-mr-ignoreIfAbsentMatch >-----#
    id_mr_ignoreIfAbsentMatch = OID(name=u'id-mr-ignoreIfAbsentMatch', mode=MODE_VALUE)
    id_mr_ignoreIfAbsentMatch._val = (2, 5, 13, 50)
    
    #-----< id-mr-nullMatch >-----#
    id_mr_nullMatch = OID(name=u'id-mr-nullMatch', mode=MODE_VALUE)
    id_mr_nullMatch._val = (2, 5, 13, 51)
    
    #-----< id-mr-zonalMatch >-----#
    id_mr_zonalMatch = OID(name=u'id-mr-zonalMatch', mode=MODE_VALUE)
    id_mr_zonalMatch._val = (2, 5, 13, 52)
    
    #-----< id-mr-facsimileNumberMatch >-----#
    id_mr_facsimileNumberMatch = OID(name=u'id-mr-facsimileNumberMatch', mode=MODE_VALUE)
    id_mr_facsimileNumberMatch._val = (2, 5, 13, 63)
    
    #-----< id-mr-facsimileNumberSubstringsMatch >-----#
    id_mr_facsimileNumberSubstringsMatch = OID(name=u'id-mr-facsimileNumberSubstringsMatch', mode=MODE_VALUE)
    id_mr_facsimileNumberSubstringsMatch._val = (2, 5, 13, 64)
    
    #-----< id-mr-uuidpairmatch >-----#
    id_mr_uuidpairmatch = OID(name=u'id-mr-uuidpairmatch', mode=MODE_VALUE)
    id_mr_uuidpairmatch._val = (2, 5, 13, 68)
    
    #-----< id-mr-uriMatch >-----#
    id_mr_uriMatch = OID(name=u'id-mr-uriMatch', mode=MODE_VALUE)
    id_mr_uriMatch._val = (2, 5, 13, 70)
    
    #-----< id-mr-dnsNameMatch >-----#
    id_mr_dnsNameMatch = OID(name=u'id-mr-dnsNameMatch', mode=MODE_VALUE)
    id_mr_dnsNameMatch._val = (2, 5, 13, 74)
    
    #-----< id-lmr-caseExactIA5Match >-----#
    id_lmr_caseExactIA5Match = OID(name=u'id-lmr-caseExactIA5Match', mode=MODE_VALUE)
    id_lmr_caseExactIA5Match._val = (1, 3, 6, 1, 4, 1, 1466, 109, 114, 1)
    
    #-----< id-lmr-caseIgnoreIA5Match >-----#
    id_lmr_caseIgnoreIA5Match = OID(name=u'id-lmr-caseIgnoreIA5Match', mode=MODE_VALUE)
    id_lmr_caseIgnoreIA5Match._val = (1, 3, 6, 1, 4, 1, 1466, 109, 114, 2)
    
    #-----< id-lmr-caseIgnoreIA5SubstringsMatch >-----#
    id_lmr_caseIgnoreIA5SubstringsMatch = OID(name=u'id-lmr-caseIgnoreIA5SubstringsMatch', mode=MODE_VALUE)
    id_lmr_caseIgnoreIA5SubstringsMatch._val = (1, 3, 6, 1, 4, 1, 1466, 109, 114, 3)
    
    #-----< id-avc-language >-----#
    id_avc_language = OID(name=u'id-avc-language', mode=MODE_VALUE)
    id_avc_language._val = (2, 5, 31, 0)
    
    #-----< id-avc-temporal >-----#
    id_avc_temporal = OID(name=u'id-avc-temporal', mode=MODE_VALUE)
    id_avc_temporal._val = (2, 5, 31, 1)
    
    #-----< id-avc-locale >-----#
    id_avc_locale = OID(name=u'id-avc-locale', mode=MODE_VALUE)
    id_avc_locale._val = (2, 5, 31, 2)
    
    #-----< id-avc-ldapAttributeOption >-----#
    id_avc_ldapAttributeOption = OID(name=u'id-avc-ldapAttributeOption', mode=MODE_VALUE)
    id_avc_ldapAttributeOption._val = (2, 5, 31, 5)
    
    _all_ = [
        _UnboundedDirectoryString_teletexString,
        _UnboundedDirectoryString_printableString,
        _UnboundedDirectoryString_bmpString,
        _UnboundedDirectoryString_universalString,
        _UnboundedDirectoryString_uTF8String,
        UnboundedDirectoryString,
        knowledgeInformation,
        _knowledgeInformation_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType,
        name,
        _name_val_Type,
        __ATTRIBUTE_substrings_match_val_AssertionType,
        commonName,
        __ATTRIBUTE_derivation_val_Type,
        _commonName_val_Type,
        surname,
        _surname_val_Type,
        givenName,
        _givenName_val_Type,
        initials,
        _initials_val_Type,
        generationQualifier,
        _generationQualifier_val_Type,
        uniqueIdentifier,
        _uniqueIdentifier_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        UniqueIdentifier,
        dnQualifier,
        _dnQualifier_val_Type,
        __ATTRIBUTE_ordering_match_val_AssertionType,
        serialNumber,
        _serialNumber_val_Type,
        pseudonym,
        _pseudonym_val_Type,
        uUIDPair,
        _uUIDPair_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_1,
        _UUIDPair_issuerUUID,
        _UUIDPair_subjectUUID,
        UUIDPair,
        UUID,
        uri,
        _uri_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_2,
        URI,
        urn,
        __ATTRIBUTE_derivation_val_Type_0,
        url,
        dnsName,
        _dnsName_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_3,
        DomainName,
        countryName,
        _countryName_val_Type,
        CountryName,
        countryCode3c,
        _countryCode3c_val_Type,
        CountryCode3c,
        countryCode3n,
        _countryCode3n_val_Type,
        CountryCode3n,
        localityName,
        _localityName_val_Type,
        collectiveLocalityName,
        stateOrProvinceName,
        _stateOrProvinceName_val_Type,
        collectiveStateOrProvinceName,
        streetAddress,
        _streetAddress_val_Type,
        collectiveStreetAddress,
        houseIdentifier,
        _houseIdentifier_val_Type,
        utmCoordinates,
        _utmCoordinates_val_Type,
        _UtmCoordinates_zone,
        _UtmCoordinates_easting,
        _UtmCoordinates_northing,
        UtmCoordinates,
        organizationName,
        _organizationName_val_Type,
        collectiveOrganizationName,
        organizationalUnitName,
        _organizationalUnitName_val_Type,
        collectiveOrganizationalUnitName,
        title,
        _title_val_Type,
        organizationIdentifier,
        _organizationIdentifier_val_Type,
        description,
        _description_val_Type,
        searchGuide,
        _searchGuide_val_Type,
        _Guide_objectClass,
        _Guide_criteria,
        Guide,
        _Criteria_type,
        __Criteria_and___item_,
        _Criteria_and_,
        __Criteria_or___item_,
        _Criteria_or_,
        _Criteria_not_,
        Criteria,
        _CriteriaItem_equality,
        _CriteriaItem_substrings,
        _CriteriaItem_greaterOrEqual,
        _CriteriaItem_lessOrEqual,
        _CriteriaItem_approximateMatch,
        CriteriaItem,
        enhancedSearchGuide,
        _enhancedSearchGuide_val_Type,
        _EnhancedGuide_objectClass,
        _EnhancedGuide_criteria,
        _EnhancedGuide_subset,
        EnhancedGuide,
        businessCategory,
        _businessCategory_val_Type,
        postalAddress,
        _postalAddress_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_4,
        _PostalAddress__item_,
        PostalAddress,
        collectivePostalAddress,
        __ATTRIBUTE_derivation_val_Type_1,
        postalCode,
        _postalCode_val_Type,
        collectivePostalCode,
        postOfficeBox,
        _postOfficeBox_val_Type,
        collectivePostOfficeBox,
        physicalDeliveryOfficeName,
        _physicalDeliveryOfficeName_val_Type,
        collectivePhysicalDeliveryOfficeName,
        telephoneNumber,
        _telephoneNumber_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_5,
        TelephoneNumber,
        ub_telephone_number,
        collectiveTelephoneNumber,
        __ATTRIBUTE_derivation_val_Type_2,
        telexNumber,
        _telexNumber_val_Type,
        _TelexNumber_telexNumber,
        _TelexNumber_countryCode,
        _TelexNumber_answerback,
        TelexNumber,
        ub_telex_number,
        ub_country_code,
        ub_answerback,
        collectiveTelexNumber,
        __ATTRIBUTE_derivation_val_Type_3,
        facsimileTelephoneNumber,
        _facsimileTelephoneNumber_val_Type,
        _FacsimileTelephoneNumber_telephoneNumber,
        _FacsimileTelephoneNumber_parameters,
        FacsimileTelephoneNumber,
        collectiveFacsimileTelephoneNumber,
        __ATTRIBUTE_derivation_val_Type_4,
        x121Address,
        _x121Address_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_6,
        X121Address,
        ub_x121_address,
        internationalISDNNumber,
        _internationalISDNNumber_val_Type,
        InternationalISDNNumber,
        ub_international_isdn_number,
        collectiveInternationalISDNNumber,
        __ATTRIBUTE_derivation_val_Type_5,
        registeredAddress,
        _registeredAddress_val_Type,
        destinationIndicator,
        _destinationIndicator_val_Type,
        DestinationIndicator,
        communicationsService,
        _communicationsService_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_7,
        CommunicationsService,
        communicationsNetwork,
        _communicationsNetwork_val_Type,
        CommunicationsNetwork,
        preferredDeliveryMethod,
        _preferredDeliveryMethod_val_Type,
        _PreferredDeliveryMethod__item_,
        PreferredDeliveryMethod,
        presentationAddress,
        _presentationAddress_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_8,
        _PresentationAddress_pSelector,
        _PresentationAddress_sSelector,
        _PresentationAddress_tSelector,
        __PresentationAddress_nAddresses__item_,
        _PresentationAddress_nAddresses,
        PresentationAddress,
        supportedApplicationContext,
        _supportedApplicationContext_val_Type,
        protocolInformation,
        _protocolInformation_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_9,
        _ProtocolInformation_nAddress,
        __ProtocolInformation_profiles__item_,
        _ProtocolInformation_profiles,
        ProtocolInformation,
        distinguishedName,
        _distinguishedName_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType_10,
        member,
        __ATTRIBUTE_derivation_val_Type_6,
        uniqueMember,
        _uniqueMember_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType__11,
        _NameAndOptionalUID_dn,
        _NameAndOptionalUID_uid,
        NameAndOptionalUID,
        owner,
        roleOccupant,
        seeAlso,
        dmdName,
        _dmdName_val_Type,
        oidC1,
        _oidC1_val_Type,
        __ATTRIBUTE_equality_match_val_AssertionType___12,
        oidC2,
        _oidC2_val_Type,
        oidC,
        _oidC_val_Type,
        urnC,
        _urnC_val_Type,
        tagOid,
        _tagOid_val_Type,
        uiiFormat,
        _uiiFormat_val_Type,
        _UiiFormat_baseObject,
        _UiiFormat_subset,
        __UiiFormat_next_length,
        __UiiFormat_next_filter,
        _UiiFormat_next,
        UiiFormat,
        _UiiFilter_item,
        __UiiFilter_and___item_,
        _UiiFilter_and_,
        __UiiFilter_or___item_,
        _UiiFilter_or_,
        _UiiFilter_not_,
        UiiFilter,
        _UiiItem_type,
        _UiiItem_length,
        UiiItem,
        uiiInUrn,
        _uiiInUrn_val_Type,
        contentUrl,
        uii,
        _uii_val_Type,
        epc,
        _epc_val_Type,
        tagAfi,
        _tagAfi_val_Type,
        epcFormat,
        _epcFormat_val_Type,
        ___EpcFormat_fields__item__bits,
        ____EpcFormat_fields__item__charField_characters,
        ____EpcFormat_fields__item__charField_maxValue,
        ___EpcFormat_fields__item__charField,
        ___EpcFormat_fields__item__result,
        __EpcFormat_fields__item_,
        _EpcFormat_fields,
        _EpcFormat_digitShift,
        _EpcFormat_checkCalc,
        _EpcFormat_urnPrefix,
        EpcFormat,
        epcInUrn,
        ldapUrl,
        tagLocation,
        __ATTRIBUTE_derivation_val_Type_7,
        dSAProblem,
        _dSAProblem_val_Type,
        searchServiceProblem,
        _searchServiceProblem_val_Type,
        serviceType,
        _serviceType_val_Type,
        attributeTypeList,
        _attributeTypeList_val_Type,
        matchingRuleList,
        _matchingRuleList_val_Type,
        filterItem,
        _filterItem_val_Type,
        attributeCombinations,
        _attributeCombinations_val_Type,
        contextTypeList,
        _contextTypeList_val_Type,
        contextList,
        _contextList_val_Type,
        contextCombinations,
        _contextCombinations_val_Type,
        hierarchySelectList,
        _hierarchySelectList_val_Type,
        searchControlOptionsList,
        _searchControlOptionsList_val_Type,
        serviceControlOptionsList,
        _serviceControlOptionsList_val_Type,
        multipleMatchingLocalities,
        _multipleMatchingLocalities_val_Type,
        _MultipleMatchingLocalities_matchingRuleUsed,
        __MultipleMatchingLocalities_attributeList__item_,
        _MultipleMatchingLocalities_attributeList,
        MultipleMatchingLocalities,
        proposedRelaxation,
        _proposedRelaxation_val_Type,
        _MRMappings__item_,
        MRMappings,
        appliedRelaxation,
        _appliedRelaxation_val_Type,
        pwdResponseValue,
        _pwdResponseValue_val_Type,
        __PwdResponse_warning_timeleft,
        __PwdResponse_warning_graceRemaining,
        _PwdResponse_warning,
        _PwdResponse_error,
        PwdResponse,
        ldapDiagnosticMsg,
        _ldapDiagnosticMsg_val_Type,
        uid,
        _uid_val_Type,
        dc,
        _dc_val_Type,
        caseExactMatch,
        _caseExactMatch_val_AssertionType,
        caseIgnoreMatch,
        _caseIgnoreMatch_val_AssertionType,
        caseExactOrderingMatch,
        _caseExactOrderingMatch_val_AssertionType,
        caseIgnoreOrderingMatch,
        _caseIgnoreOrderingMatch_val_AssertionType,
        caseExactSubstringsMatch,
        _caseExactSubstringsMatch_val_AssertionType,
        caseIgnoreSubstringsMatch,
        _caseIgnoreSubstringsMatch_val_AssertionType,
        __SubstringAssertion__item__initial,
        __SubstringAssertion__item__any,
        __SubstringAssertion__item__final,
        ____SubstringAssertion__item__control_type_tab,
        _____SubstringAssertion__item__control_type_tab_val_Type_0,
        _____SubstringAssertion__item__control_type_tab_val_Type_1,
        ___SubstringAssertion__item__control_type,
        ____SubstringAssertion__item__control_values__item_,
        ___SubstringAssertion__item__control_values,
        _____SubstringAssertion__item__control_valuesWithContext__item__value,
        ______SubstringAssertion__item__control_valuesWithContext__item__contextList__item_,
        _____SubstringAssertion__item__control_valuesWithContext__item__contextList,
        ____SubstringAssertion__item__control_valuesWithContext__item_,
        ___SubstringAssertion__item__control_valuesWithContext,
        __SubstringAssertion__item__control,
        _SubstringAssertion__item_,
        SubstringAssertion,
        numericStringMatch,
        _numericStringMatch_val_AssertionType,
        numericStringOrderingMatch,
        _numericStringOrderingMatch_val_AssertionType,
        numericStringSubstringsMatch,
        _numericStringSubstringsMatch_val_AssertionType,
        caseIgnoreListMatch,
        _caseIgnoreListMatch_val_AssertionType,
        _CaseIgnoreList__item_,
        CaseIgnoreList,
        caseIgnoreListSubstringsMatch,
        _caseIgnoreListSubstringsMatch_val_AssertionType,
        storedPrefixMatch,
        _storedPrefixMatch_val_AssertionType,
        booleanMatch,
        _booleanMatch_val_AssertionType,
        integerMatch,
        _integerMatch_val_AssertionType,
        integerOrderingMatch,
        _integerOrderingMatch_val_AssertionType,
        bitStringMatch,
        _bitStringMatch_val_AssertionType,
        octetStringMatch,
        _octetStringMatch_val_AssertionType,
        octetStringOrderingMatch,
        _octetStringOrderingMatch_val_AssertionType,
        octetStringSubstringsMatch,
        _octetStringSubstringsMatch_val_AssertionType,
        __OctetSubstringAssertion__item__initial,
        __OctetSubstringAssertion__item__any,
        __OctetSubstringAssertion__item__final,
        _OctetSubstringAssertion__item_,
        OctetSubstringAssertion,
        telephoneNumberMatch,
        _telephoneNumberMatch_val_AssertionType,
        telephoneNumberSubstringsMatch,
        _telephoneNumberSubstringsMatch_val_AssertionType,
        presentationAddressMatch,
        _presentationAddressMatch_val_AssertionType,
        uniqueMemberMatch,
        _uniqueMemberMatch_val_AssertionType,
        protocolInformationMatch,
        _protocolInformationMatch_val_AssertionType,
        facsimileNumberMatch,
        _facsimileNumberMatch_val_AssertionType,
        facsimileNumberSubstringsMatch,
        _facsimileNumberSubstringsMatch_val_AssertionType,
        uUIDPairMatch,
        _uUIDPairMatch_val_AssertionType,
        uTCTimeMatch,
        _uTCTimeMatch_val_AssertionType,
        uTCTimeOrderingMatch,
        _uTCTimeOrderingMatch_val_AssertionType,
        generalizedTimeMatch,
        _generalizedTimeMatch_val_AssertionType,
        generalizedTimeOrderingMatch,
        _generalizedTimeOrderingMatch_val_AssertionType,
        systemProposedMatch,
        integerFirstComponentMatch,
        _integerFirstComponentMatch_val_AssertionType,
        objectIdentifierFirstComponentMatch,
        _objectIdentifierFirstComponentMatch_val_AssertionType,
        directoryStringFirstComponentMatch,
        _directoryStringFirstComponentMatch_val_AssertionType,
        wordMatch,
        _wordMatch_val_AssertionType,
        keywordMatch,
        _keywordMatch_val_AssertionType,
        generalWordMatch,
        _generalWordMatch_val_AssertionType,
        sequenceMatchType,
        _sequenceMatchType_val_Type,
        SequenceMatchType,
        wordMatchTypes,
        _wordMatchTypes_val_Type,
        WordMatchTypes,
        characterMatchTypes,
        _characterMatchTypes_val_Type,
        CharacterMatchTypes,
        selectedContexts,
        _selectedContexts_val_Type,
        approximateStringMatch,
        ignoreIfAbsentMatch,
        nullMatch,
        _ZONAL_MATCHING_selectBy,
        _ZONAL_MATCHING_ApplicableTo,
        _ZONAL_MATCHING_subtypesIncluded,
        _ZONAL_MATCHING_combinable,
        _ZONAL_MATCHING_mappingResults,
        _ZONAL_MATCHING_userControl,
        _ZONAL_MATCHING_exclusive,
        _ZONAL_MATCHING_matching_rule,
        _ZONAL_MATCHING_id,
        ZONAL_MATCHING,
        _ZonalSelect__item_,
        ZonalSelect,
        ZonalResult,
        zonalMatch,
        __MATCHING_RULE_uniqueMatchIndicator_val_Type,
        uriMatch,
        _uriMatch_val_AssertionType,
        dnsNameMatch,
        _dnsNameMatch_val_AssertionType,
        caseExactIA5Match,
        _caseExactIA5Match_val_AssertionType,
        caseIgnoreIA5Match,
        _caseIgnoreIA5Match_val_AssertionType,
        caseIgnoreIA5SubstringsMatch,
        _caseIgnoreIA5SubstringsMatch_val_AssertionType,
        utmCoords,
        _utmCoords_val_Type,
        uiiForm,
        _uiiForm_val_Type,
        epcForm,
        _epcForm_val_Type,
        countryString3c,
        _countryString3c_val_Type,
        countryString3n,
        _countryString3n_val_Type,
        dnsString,
        _dnsString_val_Type,
        attributeTypeDescription,
        _attributeTypeDescription_val_Type,
        bitString,
        _bitString_val_Type,
        boolean,
        _boolean_val_Type,
        countryString,
        _countryString_val_Type,
        dn,
        _dn_val_Type,
        deliveryMethod,
        _deliveryMethod_val_Type,
        directoryString,
        _directoryString_val_Type,
        dITContentRuleDescription,
        _dITContentRuleDescription_val_Type,
        dITStructureRuleDescription,
        _dITStructureRuleDescription_val_Type,
        enhancedGuide,
        _enhancedGuide_val_Type,
        facsimileTelephoneNr,
        _facsimileTelephoneNr_val_Type,
        fax,
        _fax_val_Type,
        generalizedTime,
        _generalizedTime_val_Type,
        guide,
        _guide_val_Type,
        ia5String,
        _ia5String_val_Type,
        integer,
        _integer_val_Type,
        jpeg,
        _jpeg_val_Type,
        matchingRuleDescription,
        _matchingRuleDescription_val_Type,
        matchingRuleUseDescription,
        _matchingRuleUseDescription_val_Type,
        nameAndOptionalUID,
        _nameAndOptionalUID_val_Type,
        nameFormDescription,
        _nameFormDescription_val_Type,
        numericString,
        _numericString_val_Type,
        objectClassDescription,
        _objectClassDescription_val_Type,
        oid,
        _oid_val_Type,
        otherMailbox,
        _otherMailbox_val_Type,
        octetString,
        _octetString_val_Type,
        postalAddr,
        _postalAddr_val_Type,
        presentationAddr,
        _presentationAddr_val_Type,
        printableString,
        _printableString_val_Type,
        subtreeSpec,
        _subtreeSpec_val_Type,
        telephoneNr,
        _telephoneNr_val_Type,
        telexNr,
        _telexNr_val_Type,
        utcTime,
        _utcTime_val_Type,
        ldapSyntaxDescription,
        _ldapSyntaxDescription_val_Type,
        substringAssertion,
        _substringAssertion_val_Type,
        languageContext,
        _languageContext_val_Type,
        LanguageContextSyntax,
        temporalContext,
        _temporalContext_val_Type,
        _temporalContext_val_Assertion,
        ___TimeSpecification_time_absolute_startTime,
        ___TimeSpecification_time_absolute_endTime,
        __TimeSpecification_time_absolute,
        ___TimeSpecification_time_periodic__item_,
        __TimeSpecification_time_periodic,
        _TimeSpecification_time,
        _TimeSpecification_notThisTime,
        _TimeSpecification_timeZone,
        TimeSpecification,
        __Period_timesOfDay__item_,
        _Period_timesOfDay,
        ___Period_days_intDay__item_,
        __Period_days_intDay,
        __Period_days_bitDay,
        __Period_days_dayOf,
        _Period_days,
        __Period_weeks_allWeeks,
        ___Period_weeks_intWeek__item_,
        __Period_weeks_intWeek,
        __Period_weeks_bitWeek,
        _Period_weeks,
        __Period_months_allMonths,
        ___Period_months_intMonth__item_,
        __Period_months_intMonth,
        __Period_months_bitMonth,
        _Period_months,
        __Period_years__item_,
        _Period_years,
        Period,
        _XDayOf_first,
        _XDayOf_second,
        _XDayOf_third,
        _XDayOf_fourth,
        _XDayOf_fifth,
        XDayOf,
        _NamedDay_intNamedDays,
        _NamedDay_bitNamedDays,
        NamedDay,
        _DayTimeBand_startDayTime,
        _DayTimeBand_endDayTime,
        DayTimeBand,
        _DayTime_hour,
        _DayTime_minute,
        _DayTime_second,
        DayTime,
        TimeZone,
        _TimeAssertion_now,
        _TimeAssertion_at,
        __TimeAssertion_between_startTime,
        __TimeAssertion_between_endTime,
        __TimeAssertion_between_entirely,
        _TimeAssertion_between,
        TimeAssertion,
        localeContext,
        _localeContext_val_Type,
        _LocaleContextSyntax_localeID1,
        _LocaleContextSyntax_localeID2,
        LocaleContextSyntax,
        ldapAttributeOptionContext,
        _ldapAttributeOptionContext_val_Type,
        _ldapAttributeOptionContext_val_Assertion,
        _AttributeOptionList__item_,
        AttributeOptionList,
        id_at_knowledgeInformation,
        id_at_commonName,
        id_at_surname,
        id_at_serialNumber,
        id_at_countryName,
        id_at_localityName,
        id_at_collectiveLocalityName,
        id_at_stateOrProvinceName,
        id_at_collectiveStateOrProvinceName,
        id_at_streetAddress,
        id_at_collectiveStreetAddress,
        id_at_organizationName,
        id_at_collectiveOrganizationName,
        id_at_organizationalUnitName,
        id_at_collectiveOrganizationalUnitName,
        id_at_title,
        id_at_description,
        id_at_searchGuide,
        id_at_businessCategory,
        id_at_postalAddress,
        id_at_collectivePostalAddress,
        id_at_postalCode,
        id_at_collectivePostalCode,
        id_at_postOfficeBox,
        id_at_collectivePostOfficeBox,
        id_at_physicalDeliveryOfficeName,
        id_at_collectivePhysicalDeliveryOfficeName,
        id_at_telephoneNumber,
        id_at_collectiveTelephoneNumber,
        id_at_telexNumber,
        id_at_collectiveTelexNumber,
        id_at_facsimileTelephoneNumber,
        id_at_collectiveFacsimileTelephoneNumber,
        id_at_x121Address,
        id_at_internationalISDNNumber,
        id_at_collectiveInternationalISDNNumber,
        id_at_registeredAddress,
        id_at_destinationIndicator,
        id_at_preferredDeliveryMethod,
        id_at_presentationAddress,
        id_at_supportedApplicationContext,
        id_at_member,
        id_at_owner,
        id_at_roleOccupant,
        id_at_seeAlso,
        id_at_name,
        id_at_givenName,
        id_at_initials,
        id_at_generationQualifier,
        id_at_uniqueIdentifier,
        id_at_dnQualifier,
        id_at_enhancedSearchGuide,
        id_at_protocolInformation,
        id_at_distinguishedName,
        id_at_uniqueMember,
        id_at_houseIdentifier,
        id_at_dmdName,
        id_at_pseudonym,
        id_at_communicationsService,
        id_at_communicationsNetwork,
        id_at_uuidpair,
        id_at_tagOid,
        id_at_uiiFormat,
        id_at_uiiInUrn,
        id_at_contentUrl,
        id_at_uri,
        id_at_urn,
        id_at_url,
        id_at_utmCoordinates,
        id_at_urnC,
        id_at_uii,
        id_at_epc,
        id_at_tagAfi,
        id_at_epcFormat,
        id_at_epcInUrn,
        id_at_ldapUrl,
        id_at_tagLocation,
        id_at_organizationIdentifier,
        id_at_countryCode3c,
        id_at_countryCode3n,
        id_at_dnsName,
        id_asx_utmCoords,
        id_asx_uiiForm,
        id_asx_epcForm,
        id_asx_countryString3c,
        id_asx_countryString3n,
        id_asx_dnsString,
        id_lsx_attributeTypeDescription,
        id_lsx_bitString,
        id_lsx_boolean,
        id_lsx_countryString,
        id_lsx_dn,
        id_lsx_deliveryMethod,
        id_lsx_directoryString,
        id_lsx_dITContentRuleDescription,
        id_lsx_dITStructureRuleDescription,
        id_lsx_enhancedGuide,
        id_lsx_facsimileTelephoneNr,
        id_lsx_fax,
        id_lsx_generalizedTime,
        id_lsx_guide,
        id_lsx_ia5String,
        id_lsx_integer,
        id_lsx_jpeg,
        id_lsx_matchingRuleDescription,
        id_lsx_matchingRuleUseDescription,
        id_lsx_nameAndOptionalUID,
        id_lsx_nameFormDescription,
        id_lsx_numericString,
        id_lsx_objectClassDescription,
        id_lsx_oid,
        id_lsx_otherMailbox,
        id_lsx_octetString,
        id_lsx_postalAddr,
        id_lsx_presentationAddr,
        id_lsx_printableString,
        id_lsx_subtreeSpec,
        id_lsx_telephoneNr,
        id_lsx_telexNr,
        id_lsx_utcTime,
        id_lsx_ldapSyntaxDescription,
        id_lsx_substringAssertion,
        id_oidC1,
        id_oidC2,
        id_oidC,
        id_cat_sequenceMatchType,
        id_cat_wordMatchType,
        id_cat_characterMatchTypes,
        id_cat_selectedContexts,
        id_not_dSAProblem,
        id_not_searchServiceProblem,
        id_not_serviceType,
        id_not_attributeTypeList,
        id_not_matchingRuleList,
        id_not_filterItem,
        id_not_attributeCombinations,
        id_not_contextTypeList,
        id_not_contextList,
        id_not_contextCombinations,
        id_not_hierarchySelectList,
        id_not_searchControlOptionsList,
        id_not_serviceControlOptionsList,
        id_not_multipleMatchingLocalities,
        id_not_proposedRelaxation,
        id_not_appliedRelaxation,
        id_not_pwdResponse,
        id_not_ldapDiagnosticMsg,
        id_pr_targetDsaUnavailable,
        id_pr_dataSourceUnavailable,
        id_pr_unidentifiedOperation,
        id_pr_unavailableOperation,
        id_pr_searchAttributeViolation,
        id_pr_searchAttributeCombinationViolation,
        id_pr_searchValueNotAllowed,
        id_pr_missingSearchAttribute,
        id_pr_searchValueViolation,
        id_pr_attributeNegationViolation,
        id_pr_searchValueRequired,
        id_pr_invalidSearchValue,
        id_pr_searchContextViolation,
        id_pr_searchContextCombinationViolation,
        id_pr_missingSearchContext,
        id_pr_searchContextValueViolation,
        id_pr_searchContextValueRequired,
        id_pr_invalidContextSearchValue,
        id_pr_unsupportedMatchingRule,
        id_pr_attributeMatchingViolation,
        id_pr_unsupportedMatchingUse,
        id_pr_matchingUseViolation,
        id_pr_hierarchySelectForbidden,
        id_pr_invalidHierarchySelect,
        id_pr_unavailableHierarchySelect,
        id_pr_invalidSearchControlOptions,
        id_pr_invalidServiceControlOptions,
        id_pr_searchSubsetViolation,
        id_pr_unmatchedKeyAttributes,
        id_pr_ambiguousKeyAttributes,
        id_pr_unavailableRelaxationLevel,
        id_pr_emptyHierarchySelection,
        id_pr_administratorImposedLimit,
        id_pr_permanentRestriction,
        id_pr_temporaryRestriction,
        id_pr_relaxationNotSupported,
        id_coat_uid,
        id_coat_dc,
        id_mr_caseIgnoreMatch,
        id_mr_caseIgnoreOrderingMatch,
        id_mr_caseIgnoreSubstringsMatch,
        id_mr_caseExactMatch,
        id_mr_caseExactOrderingMatch,
        id_mr_caseExactSubstringsMatch,
        id_mr_numericStringMatch,
        id_mr_numericStringOrderingMatch,
        id_mr_numericStringSubstringsMatch,
        id_mr_caseIgnoreListMatch,
        id_mr_caseIgnoreListSubstringsMatch,
        id_mr_booleanMatch,
        id_mr_integerMatch,
        id_mr_integerOrderingMatch,
        id_mr_bitStringMatch,
        id_mr_octetStringMatch,
        id_mr_octetStringOrderingMatch,
        id_mr_octetStringSubstringsMatch,
        id_mr_telephoneNumberMatch,
        id_mr_telephoneNumberSubstringsMatch,
        id_mr_presentationAddressMatch,
        id_mr_uniqueMemberMatch,
        id_mr_protocolInformationMatch,
        id_mr_uTCTimeMatch,
        id_mr_uTCTimeOrderingMatch,
        id_mr_generalizedTimeMatch,
        id_mr_generalizedTimeOrderingMatch,
        id_mr_integerFirstComponentMatch,
        id_mr_objectIdentifierFirstComponentMatch,
        id_mr_directoryStringFirstComponentMatch,
        id_mr_wordMatch,
        id_mr_keywordMatch,
        id_mr_storedPrefixMatch,
        id_mr_systemProposedMatch,
        id_mr_generalWordMatch,
        id_mr_approximateStringMatch,
        id_mr_ignoreIfAbsentMatch,
        id_mr_nullMatch,
        id_mr_zonalMatch,
        id_mr_facsimileNumberMatch,
        id_mr_facsimileNumberSubstringsMatch,
        id_mr_uuidpairmatch,
        id_mr_uriMatch,
        id_mr_dnsNameMatch,
        id_lmr_caseExactIA5Match,
        id_lmr_caseIgnoreIA5Match,
        id_lmr_caseIgnoreIA5SubstringsMatch,
        id_avc_language,
        id_avc_temporal,
        id_avc_locale,
        id_avc_ldapAttributeOption,
    ]

class ServiceAdministration:

    _name_  = u'ServiceAdministration'
    _oid_   = [2, 5, 1, 33, 8]
    
    _obj_ = [
        u'SearchRule',
        u'SearchRuleId',
        u'AllowedSubset',
        u'ImposedSubset',
        u'RequestAttribute',
        u'ContextProfile',
        u'ContextCombination',
        u'MatchingUse',
        u'SupportedMatchingRestrictions',
        u'AttributeCombination',
        u'ResultAttribute',
        u'ControlOptions',
        u'EntryLimit',
        u'RelaxationPolicy',
        u'MRMapping',
        u'Mapping',
        u'MRSubstitution',
        u'SEARCH-RULE',
        u'REQUEST-ATTRIBUTE',
        u'RESULT-ATTRIBUTE',
        u'MATCHING-RESTRICTION',
        ]
    _type_ = [
        u'SearchRule',
        u'SearchRuleId',
        u'AllowedSubset',
        u'ImposedSubset',
        u'RequestAttribute',
        u'ContextProfile',
        u'ContextCombination',
        u'MatchingUse',
        u'AttributeCombination',
        u'ResultAttribute',
        u'ControlOptions',
        u'EntryLimit',
        u'RelaxationPolicy',
        u'MRMapping',
        u'Mapping',
        u'MRSubstitution',
        u'SEARCH-RULE',
        u'REQUEST-ATTRIBUTE',
        u'RESULT-ATTRIBUTE',
        u'MATCHING-RESTRICTION',
        ]
    _set_ = [
        u'SupportedMatchingRestrictions',
        ]
    _val_ = [
        ]
    _class_ = [
        u'SupportedMatchingRestrictions',
        u'SEARCH-RULE',
        u'REQUEST-ATTRIBUTE',
        u'RESULT-ATTRIBUTE',
        u'MATCHING-RESTRICTION',
        ]
    _param_ = [
        ]
    
    #-----< SearchRule >-----#
    SearchRule = SEQ(name=u'SearchRule', mode=MODE_TYPE)
    _SearchRule_id = INT(name=u'id', mode=MODE_TYPE)
    _SearchRule_dmdId = OID(name=u'dmdId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _SearchRule_serviceType = OID(name=u'serviceType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchRule_userClass = INT(name=u'userClass', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SearchRule_inputAttributeTypes = SEQ_OF(name=u'inputAttributeTypes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRule_inputAttributeTypes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'RequestAttribute')))
    _SearchRule_inputAttributeTypes._cont = __SearchRule_inputAttributeTypes__item_
    _SearchRule_inputAttributeTypes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _SearchRule_attributeCombination = CHOICE(name=u'attributeCombination', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')), default=(u'and', []))
    _SearchRule_outputAttributeTypes = SEQ_OF(name=u'outputAttributeTypes', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRule_outputAttributeTypes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ResultAttribute')))
    _SearchRule_outputAttributeTypes._cont = __SearchRule_outputAttributeTypes__item_
    _SearchRule_outputAttributeTypes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SearchRule_defaultControls = SEQ(name=u'defaultControls', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRule_mandatoryControls = SEQ(name=u'mandatoryControls', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRule_searchRuleControls = SEQ(name=u'searchRuleControls', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SearchRule_familyGrouping = ENUM(name=u'familyGrouping', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), opt=True)
    _SearchRule_familyReturn = SEQ(name=u'familyReturn', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyReturn')), opt=True)
    _SearchRule_relaxation = SEQ(name=u'relaxation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'RelaxationPolicy')), opt=True)
    _SearchRule_additionalControl = SEQ_OF(name=u'additionalControl', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SearchRule_additionalControl__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _SearchRule_additionalControl._cont = __SearchRule_additionalControl__item_
    _SearchRule_additionalControl._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SearchRule_allowedSubset = BIT_STR(name=u'allowedSubset', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'AllowedSubset')), default=(7, 3))
    _SearchRule_imposedSubset = ENUM(name=u'imposedSubset', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ImposedSubset')), opt=True)
    _SearchRule_entryLimit = SEQ(name=u'entryLimit', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'EntryLimit')), opt=True)
    SearchRule._cont = ASN1Dict([
        (u'id', _SearchRule_id),
        (u'dmdId', _SearchRule_dmdId),
        (u'serviceType', _SearchRule_serviceType),
        (u'userClass', _SearchRule_userClass),
        (u'inputAttributeTypes', _SearchRule_inputAttributeTypes),
        (u'attributeCombination', _SearchRule_attributeCombination),
        (u'outputAttributeTypes', _SearchRule_outputAttributeTypes),
        (u'defaultControls', _SearchRule_defaultControls),
        (u'mandatoryControls', _SearchRule_mandatoryControls),
        (u'searchRuleControls', _SearchRule_searchRuleControls),
        (u'familyGrouping', _SearchRule_familyGrouping),
        (u'familyReturn', _SearchRule_familyReturn),
        (u'relaxation', _SearchRule_relaxation),
        (u'additionalControl', _SearchRule_additionalControl),
        (u'allowedSubset', _SearchRule_allowedSubset),
        (u'imposedSubset', _SearchRule_imposedSubset),
        (u'entryLimit', _SearchRule_entryLimit),
        ])
    SearchRule._ext = []
    
    #-----< SearchRuleId >-----#
    SearchRuleId = SEQ(name=u'SearchRuleId', mode=MODE_TYPE)
    _SearchRuleId_id = INT(name=u'id', mode=MODE_TYPE)
    _SearchRuleId_dmdId = OID(name=u'dmdId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    SearchRuleId._cont = ASN1Dict([
        (u'id', _SearchRuleId_id),
        (u'dmdId', _SearchRuleId_dmdId),
        ])
    SearchRuleId._ext = None
    
    #-----< AllowedSubset >-----#
    AllowedSubset = BIT_STR(name=u'AllowedSubset', mode=MODE_TYPE)
    AllowedSubset._cont = ASN1Dict([(u'baseObject', 0), (u'oneLevel', 1), (u'wholeSubtree', 2)])
    
    #-----< ImposedSubset >-----#
    ImposedSubset = ENUM(name=u'ImposedSubset', mode=MODE_TYPE)
    ImposedSubset._cont = ASN1Dict([(u'baseObject', 0), (u'oneLevel', 1), (u'wholeSubtree', 2)])
    ImposedSubset._ext = []
    
    #-----< RequestAttribute >-----#
    RequestAttribute = SEQ(name=u'RequestAttribute', mode=MODE_TYPE)
    _RequestAttribute_attributeType = OID(name=u'attributeType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    __RequestAttribute_attributeType_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___RequestAttribute_attributeType_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    __ATTRIBUTE_equality_match_val_AssertionType = OID(name=u'AssertionType', mode=MODE_TYPE)
    ___RequestAttribute_attributeType_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __ATTRIBUTE_equality_match_val_AssertionType_0 = SEQ_OF(name=u'AssertionType', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __RequestAttribute_attributeType_tab._val = ASN1Set(rv=[dict([(u'Type', ___RequestAttribute_attributeType_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ___RequestAttribute_attributeType_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _RequestAttribute_attributeType._const_tab = __RequestAttribute_attributeType_tab
    _RequestAttribute_attributeType._const_tab_at = None
    _RequestAttribute_attributeType._const_tab_id = u'id'
    _RequestAttribute_includeSubtypes = BOOL(name=u'includeSubtypes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=False)
    _RequestAttribute_selectedValues = SEQ_OF(name=u'selectedValues', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RequestAttribute_selectedValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    __RequestAttribute_selectedValues__item_._const_tab = __RequestAttribute_attributeType_tab
    __RequestAttribute_selectedValues__item_._const_tab_at = ('..', '..', u'attributeType')
    __RequestAttribute_selectedValues__item_._const_tab_id = u'Type'
    _RequestAttribute_selectedValues._cont = __RequestAttribute_selectedValues__item_
    _RequestAttribute_selectedValues._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _RequestAttribute_defaultValues = SEQ_OF(name=u'defaultValues', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RequestAttribute_defaultValues__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___RequestAttribute_defaultValues__item__entryType = OID(name=u'entryType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']), opt=True)
    ___RequestAttribute_defaultValues__item__values = SEQ_OF(name=u'values', mode=MODE_TYPE)
    ____RequestAttribute_defaultValues__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ____RequestAttribute_defaultValues__item__values__item_._const_tab = __RequestAttribute_attributeType_tab
    ____RequestAttribute_defaultValues__item__values__item_._const_tab_at = ('..', '..', '..', '..', u'attributeType')
    ____RequestAttribute_defaultValues__item__values__item_._const_tab_id = u'Type'
    ___RequestAttribute_defaultValues__item__values._cont = ____RequestAttribute_defaultValues__item__values__item_
    __RequestAttribute_defaultValues__item_._cont = ASN1Dict([
        (u'entryType', ___RequestAttribute_defaultValues__item__entryType),
        (u'values', ___RequestAttribute_defaultValues__item__values),
        ])
    __RequestAttribute_defaultValues__item_._ext = []
    _RequestAttribute_defaultValues._cont = __RequestAttribute_defaultValues__item_
    _RequestAttribute_defaultValues._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _RequestAttribute_contexts = SEQ_OF(name=u'contexts', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RequestAttribute_contexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextProfile')))
    _RequestAttribute_contexts._cont = __RequestAttribute_contexts__item_
    _RequestAttribute_contexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _RequestAttribute_contextCombination = CHOICE(name=u'contextCombination', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')), default=(u'and', []))
    _RequestAttribute_matchingUse = SEQ_OF(name=u'matchingUse', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RequestAttribute_matchingUse__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'MatchingUse')))
    _RequestAttribute_matchingUse._cont = __RequestAttribute_matchingUse__item_
    _RequestAttribute_matchingUse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    RequestAttribute._cont = ASN1Dict([
        (u'attributeType', _RequestAttribute_attributeType),
        (u'includeSubtypes', _RequestAttribute_includeSubtypes),
        (u'selectedValues', _RequestAttribute_selectedValues),
        (u'defaultValues', _RequestAttribute_defaultValues),
        (u'contexts', _RequestAttribute_contexts),
        (u'contextCombination', _RequestAttribute_contextCombination),
        (u'matchingUse', _RequestAttribute_matchingUse),
        ])
    RequestAttribute._ext = []
    
    #-----< ContextProfile >-----#
    ContextProfile = SEQ(name=u'ContextProfile', mode=MODE_TYPE)
    _ContextProfile_contextType = OID(name=u'contextType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), [u'id']))
    __ContextProfile_contextType_tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    __ContextProfile_contextType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ContextProfile_contextType._const_tab = __ContextProfile_contextType_tab
    _ContextProfile_contextType._const_tab_at = None
    _ContextProfile_contextType._const_tab_id = u'id'
    _ContextProfile_contextValue = SEQ_OF(name=u'contextValue', mode=MODE_TYPE, opt=True)
    __ContextProfile_contextValue__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), [u'Assertion']))
    ___ContextProfile_contextValue__item__tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    ___ContextProfile_contextValue__item__tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __ContextProfile_contextValue__item_._const_tab = ___ContextProfile_contextValue__item__tab
    __ContextProfile_contextValue__item_._const_tab_at = ('..', '..', u'contextType')
    __ContextProfile_contextValue__item_._const_tab_id = u'Assertion'
    _ContextProfile_contextValue._cont = __ContextProfile_contextValue__item_
    _ContextProfile_contextValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ContextProfile._cont = ASN1Dict([
        (u'contextType', _ContextProfile_contextType),
        (u'contextValue', _ContextProfile_contextValue),
        ])
    ContextProfile._ext = []
    
    #-----< ContextCombination >-----#
    ContextCombination = CHOICE(name=u'ContextCombination', mode=MODE_TYPE)
    _ContextCombination_context = OID(name=u'context', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'CONTEXT'), [u'id']))
    __ContextCombination_context_tab = CLASS(name='_tab_CONTEXT', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'CONTEXT')))
    __ContextCombination_context_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _ContextCombination_context._const_tab = __ContextCombination_context_tab
    _ContextCombination_context._const_tab_at = None
    _ContextCombination_context._const_tab_id = u'id'
    _ContextCombination_and_ = SEQ_OF(name=u'and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ContextCombination_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')))
    _ContextCombination_and_._cont = __ContextCombination_and___item_
    _ContextCombination_or_ = SEQ_OF(name=u'or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __ContextCombination_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')))
    _ContextCombination_or_._cont = __ContextCombination_or___item_
    _ContextCombination_not_ = CHOICE(name=u'not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')))
    ContextCombination._cont = ASN1Dict([
        (u'context', _ContextCombination_context),
        (u'and', _ContextCombination_and_),
        (u'or', _ContextCombination_or_),
        (u'not', _ContextCombination_not_),
        ])
    ContextCombination._ext = []
    
    #-----< MatchingUse >-----#
    MatchingUse = SEQ(name=u'MatchingUse', mode=MODE_TYPE)
    _MatchingUse_restrictionType = OID(name=u'restrictionType', mode=MODE_TYPE, typeref=ASN1RefClassField(('ServiceAdministration', 'MATCHING-RESTRICTION'), [u'id']))
    __MatchingUse_restrictionType_tab = CLASS(name='_tab_MATCHING-RESTRICTION', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'MATCHING-RESTRICTION')))
    __MatchingUse_restrictionType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _MatchingUse_restrictionType._const_tab = __MatchingUse_restrictionType_tab
    _MatchingUse_restrictionType._const_tab_at = None
    _MatchingUse_restrictionType._const_tab_id = u'id'
    _MatchingUse_restrictionValue = OPEN(name=u'restrictionValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('ServiceAdministration', 'MATCHING-RESTRICTION'), [u'Restriction']))
    __MatchingUse_restrictionValue_tab = CLASS(name='_tab_MATCHING-RESTRICTION', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'MATCHING-RESTRICTION')))
    __MatchingUse_restrictionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _MatchingUse_restrictionValue._const_tab = __MatchingUse_restrictionValue_tab
    _MatchingUse_restrictionValue._const_tab_at = ('..', u'restrictionType')
    _MatchingUse_restrictionValue._const_tab_id = u'Restriction'
    MatchingUse._cont = ASN1Dict([
        (u'restrictionType', _MatchingUse_restrictionType),
        (u'restrictionValue', _MatchingUse_restrictionValue),
        ])
    MatchingUse._ext = []
    
    #-----< SupportedMatchingRestrictions >-----#
    SupportedMatchingRestrictions = CLASS(name=u'SupportedMatchingRestrictions', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'MATCHING-RESTRICTION')))
    SupportedMatchingRestrictions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AttributeCombination >-----#
    AttributeCombination = CHOICE(name=u'AttributeCombination', mode=MODE_TYPE)
    _AttributeCombination_attribute = OID(name=u'attribute', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _AttributeCombination_and_ = SEQ_OF(name=u'and', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AttributeCombination_and___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')))
    _AttributeCombination_and_._cont = __AttributeCombination_and___item_
    _AttributeCombination_or_ = SEQ_OF(name=u'or', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AttributeCombination_or___item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')))
    _AttributeCombination_or_._cont = __AttributeCombination_or___item_
    _AttributeCombination_not_ = CHOICE(name=u'not', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')))
    AttributeCombination._cont = ASN1Dict([
        (u'attribute', _AttributeCombination_attribute),
        (u'and', _AttributeCombination_and_),
        (u'or', _AttributeCombination_or_),
        (u'not', _AttributeCombination_not_),
        ])
    AttributeCombination._ext = []
    
    #-----< ResultAttribute >-----#
    ResultAttribute = SEQ(name=u'ResultAttribute', mode=MODE_TYPE)
    _ResultAttribute_attributeType = OID(name=u'attributeType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    __ResultAttribute_attributeType_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('InformationFramework', 'ATTRIBUTE')))
    ___ResultAttribute_attributeType_tab_val_Type_0 = OID(name=u'Type', mode=MODE_TYPE)
    ___ResultAttribute_attributeType_tab_val_Type_1 = SEQ_OF(name=u'Type', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'DistinguishedName')))
    __ResultAttribute_attributeType_tab._val = ASN1Set(rv=[dict([(u'Type', ___ResultAttribute_attributeType_tab_val_Type_0), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectIdentifierMatch']), (u'id', (2, 5, 13, 0))])), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 38)), (u'ldapName', [u'objectClass']), (u'id', (2, 5, 4, 0))]), dict([(u'Type', ___ResultAttribute_attributeType_tab_val_Type_1), (u'equality-match', dict([(u'AssertionType', __ATTRIBUTE_equality_match_val_AssertionType_0), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'distinguishedNameMatch']), (u'id', (2, 5, 13, 1))])), (u'single-valued', True), (u'ldapSyntax', (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1, 12)), (u'ldapName', [u'aliasedObjectName']), (u'id', (2, 5, 4, 1))])], rr=[], ev=None, er=[])
    _ResultAttribute_attributeType._const_tab = __ResultAttribute_attributeType_tab
    _ResultAttribute_attributeType._const_tab_at = None
    _ResultAttribute_attributeType._const_tab_id = u'id'
    _ResultAttribute_outputValues = CHOICE(name=u'outputValues', mode=MODE_TYPE, opt=True)
    __ResultAttribute_outputValues_selectedValues = SEQ_OF(name=u'selectedValues', mode=MODE_TYPE)
    ___ResultAttribute_outputValues_selectedValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    ___ResultAttribute_outputValues_selectedValues__item_._const_tab = __ResultAttribute_attributeType_tab
    ___ResultAttribute_outputValues_selectedValues__item_._const_tab_at = ('..', '..', '..', u'attributeType')
    ___ResultAttribute_outputValues_selectedValues__item_._const_tab_id = u'Type'
    __ResultAttribute_outputValues_selectedValues._cont = ___ResultAttribute_outputValues_selectedValues__item_
    __ResultAttribute_outputValues_matchedValuesOnly = NULL(name=u'matchedValuesOnly', mode=MODE_TYPE)
    _ResultAttribute_outputValues._cont = ASN1Dict([
        (u'selectedValues', __ResultAttribute_outputValues_selectedValues),
        (u'matchedValuesOnly', __ResultAttribute_outputValues_matchedValuesOnly),
        ])
    _ResultAttribute_outputValues._ext = None
    _ResultAttribute_contexts = SEQ_OF(name=u'contexts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __ResultAttribute_contexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextProfile')))
    _ResultAttribute_contexts._cont = __ResultAttribute_contexts__item_
    _ResultAttribute_contexts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ResultAttribute._cont = ASN1Dict([
        (u'attributeType', _ResultAttribute_attributeType),
        (u'outputValues', _ResultAttribute_outputValues),
        (u'contexts', _ResultAttribute_contexts),
        ])
    ResultAttribute._ext = []
    
    #-----< ControlOptions >-----#
    ControlOptions = SEQ(name=u'ControlOptions', mode=MODE_TYPE)
    _ControlOptions_serviceControls = BIT_STR(name=u'serviceControls', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'ServiceControlOptions')), default=(0, 0))
    _ControlOptions_searchOptions = BIT_STR(name=u'searchOptions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'SearchControlOptions')), default=(1, 1))
    _ControlOptions_hierarchyOptions = BIT_STR(name=u'hierarchyOptions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('DirectoryAbstractService', 'HierarchySelections')), opt=True)
    ControlOptions._cont = ASN1Dict([
        (u'serviceControls', _ControlOptions_serviceControls),
        (u'searchOptions', _ControlOptions_searchOptions),
        (u'hierarchyOptions', _ControlOptions_hierarchyOptions),
        ])
    ControlOptions._ext = []
    
    #-----< EntryLimit >-----#
    EntryLimit = SEQ(name=u'EntryLimit', mode=MODE_TYPE)
    _EntryLimit_default = INT(name=u'default', mode=MODE_TYPE)
    _EntryLimit_max = INT(name=u'max', mode=MODE_TYPE)
    EntryLimit._cont = ASN1Dict([
        (u'default', _EntryLimit_default),
        (u'max', _EntryLimit_max),
        ])
    EntryLimit._ext = []
    
    #-----< RelaxationPolicy >-----#
    RelaxationPolicy = SEQ(name=u'RelaxationPolicy', mode=MODE_TYPE)
    _RelaxationPolicy_basic = SEQ(name=u'basic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ServiceAdministration', 'MRMapping')), default=dict([]))
    _RelaxationPolicy_tightenings = SEQ_OF(name=u'tightenings', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RelaxationPolicy_tightenings__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'MRMapping')))
    _RelaxationPolicy_tightenings._cont = __RelaxationPolicy_tightenings__item_
    _RelaxationPolicy_tightenings._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _RelaxationPolicy_relaxations = SEQ_OF(name=u'relaxations', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RelaxationPolicy_relaxations__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'MRMapping')))
    _RelaxationPolicy_relaxations._cont = __RelaxationPolicy_relaxations__item_
    _RelaxationPolicy_relaxations._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _RelaxationPolicy_maximum = INT(name=u'maximum', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _RelaxationPolicy_minimum = INT(name=u'minimum', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=1)
    RelaxationPolicy._cont = ASN1Dict([
        (u'basic', _RelaxationPolicy_basic),
        (u'tightenings', _RelaxationPolicy_tightenings),
        (u'relaxations', _RelaxationPolicy_relaxations),
        (u'maximum', _RelaxationPolicy_maximum),
        (u'minimum', _RelaxationPolicy_minimum),
        ])
    RelaxationPolicy._ext = []
    
    #-----< MRMapping >-----#
    MRMapping = SEQ(name=u'MRMapping', mode=MODE_TYPE)
    _MRMapping_mapping = SEQ_OF(name=u'mapping', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __MRMapping_mapping__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'Mapping')))
    _MRMapping_mapping._cont = __MRMapping_mapping__item_
    _MRMapping_mapping._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _MRMapping_substitution = SEQ_OF(name=u'substitution', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __MRMapping_substitution__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'MRSubstitution')))
    _MRMapping_substitution._cont = __MRMapping_substitution__item_
    _MRMapping_substitution._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    MRMapping._cont = ASN1Dict([
        (u'mapping', _MRMapping_mapping),
        (u'substitution', _MRMapping_substitution),
        ])
    MRMapping._ext = []
    
    #-----< Mapping >-----#
    Mapping = SEQ(name=u'Mapping', mode=MODE_TYPE)
    _Mapping_mappingFunction = OID(name=u'mappingFunction', mode=MODE_TYPE)
    _Mapping_level = INT(name=u'level', mode=MODE_TYPE, default=0)
    Mapping._cont = ASN1Dict([
        (u'mappingFunction', _Mapping_mappingFunction),
        (u'level', _Mapping_level),
        ])
    Mapping._ext = []
    
    #-----< MRSubstitution >-----#
    MRSubstitution = SEQ(name=u'MRSubstitution', mode=MODE_TYPE)
    _MRSubstitution_attribute = OID(name=u'attribute', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')))
    _MRSubstitution_oldMatchingRule = OID(name=u'oldMatchingRule', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), [u'id']), opt=True)
    _MRSubstitution_newMatchingRule = OID(name=u'newMatchingRule', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), [u'id']), opt=True)
    MRSubstitution._cont = ASN1Dict([
        (u'attribute', _MRSubstitution_attribute),
        (u'oldMatchingRule', _MRSubstitution_oldMatchingRule),
        (u'newMatchingRule', _MRSubstitution_newMatchingRule),
        ])
    MRSubstitution._ext = []
    
    #-----< SEARCH-RULE >-----#
    SEARCH_RULE = CLASS(name=u'SEARCH-RULE', mode=MODE_TYPE)
    _SEARCH_RULE_dmdId = OID(name=u'dmdId', mode=MODE_VALUE)
    _SEARCH_RULE_serviceType = OID(name=u'serviceType', mode=MODE_VALUE, opt=True)
    _SEARCH_RULE_userClass = INT(name=u'userClass', mode=MODE_VALUE, opt=True)
    _SEARCH_RULE_InputAttributeTypes = CLASS(name=u'InputAttributeTypes', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'REQUEST-ATTRIBUTE')), opt=True)
    _SEARCH_RULE_combination = CHOICE(name=u'combination', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'AttributeCombination')), opt=True)
    _SEARCH_RULE_OutputAttributeTypes = CLASS(name=u'OutputAttributeTypes', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'RESULT-ATTRIBUTE')), opt=True)
    _SEARCH_RULE_defaultControls = SEQ(name=u'defaultControls', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SEARCH_RULE_mandatoryControls = SEQ(name=u'mandatoryControls', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SEARCH_RULE_searchRuleControls = SEQ(name=u'searchRuleControls', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ControlOptions')), opt=True)
    _SEARCH_RULE_familyGrouping = ENUM(name=u'familyGrouping', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyGrouping')), opt=True)
    _SEARCH_RULE_familyReturn = SEQ(name=u'familyReturn', mode=MODE_VALUE, typeref=ASN1RefType(('DirectoryAbstractService', 'FamilyReturn')), opt=True)
    _SEARCH_RULE_additionalControl = OID(name=u'additionalControl', mode=MODE_VALUE, typeref=ASN1RefType(('InformationFramework', 'AttributeType')), opt=True)
    _SEARCH_RULE_relaxation = SEQ(name=u'relaxation', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'RelaxationPolicy')), opt=True)
    _SEARCH_RULE_allowedSubset = BIT_STR(name=u'allowedSubset', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'AllowedSubset')), default=(7, 3))
    _SEARCH_RULE_imposedSubset = ENUM(name=u'imposedSubset', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ImposedSubset')), opt=True)
    _SEARCH_RULE_entryLimit = SEQ(name=u'entryLimit', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'EntryLimit')), opt=True)
    _SEARCH_RULE_id = INT(name=u'id', mode=MODE_VALUE, uniq=True)
    SEARCH_RULE._cont = ASN1Dict([
        (u'dmdId', _SEARCH_RULE_dmdId),
        (u'serviceType', _SEARCH_RULE_serviceType),
        (u'userClass', _SEARCH_RULE_userClass),
        (u'InputAttributeTypes', _SEARCH_RULE_InputAttributeTypes),
        (u'combination', _SEARCH_RULE_combination),
        (u'OutputAttributeTypes', _SEARCH_RULE_OutputAttributeTypes),
        (u'defaultControls', _SEARCH_RULE_defaultControls),
        (u'mandatoryControls', _SEARCH_RULE_mandatoryControls),
        (u'searchRuleControls', _SEARCH_RULE_searchRuleControls),
        (u'familyGrouping', _SEARCH_RULE_familyGrouping),
        (u'familyReturn', _SEARCH_RULE_familyReturn),
        (u'additionalControl', _SEARCH_RULE_additionalControl),
        (u'relaxation', _SEARCH_RULE_relaxation),
        (u'allowedSubset', _SEARCH_RULE_allowedSubset),
        (u'imposedSubset', _SEARCH_RULE_imposedSubset),
        (u'entryLimit', _SEARCH_RULE_entryLimit),
        (u'id', _SEARCH_RULE_id),
        ])
    
    #-----< REQUEST-ATTRIBUTE >-----#
    REQUEST_ATTRIBUTE = CLASS(name=u'REQUEST-ATTRIBUTE', mode=MODE_TYPE)
    _REQUEST_ATTRIBUTE_attributeType = OID(name=u'attributeType', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _REQUEST_ATTRIBUTE_SelectedValues = OPEN(name=u'SelectedValues', mode=MODE_SET, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']), opt=True)
    _REQUEST_ATTRIBUTE_DefaultValues = SEQ(name=u'DefaultValues', mode=MODE_SET, opt=True)
    __REQUEST_ATTRIBUTE_DefaultValues_entryType = OID(name=u'entryType', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'OBJECT-CLASS'), [u'id']), opt=True)
    __REQUEST_ATTRIBUTE_DefaultValues_values = SEQ_OF(name=u'values', mode=MODE_TYPE)
    ___REQUEST_ATTRIBUTE_DefaultValues_values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    __REQUEST_ATTRIBUTE_DefaultValues_values._cont = ___REQUEST_ATTRIBUTE_DefaultValues_values__item_
    _REQUEST_ATTRIBUTE_DefaultValues._cont = ASN1Dict([
        (u'entryType', __REQUEST_ATTRIBUTE_DefaultValues_entryType),
        (u'values', __REQUEST_ATTRIBUTE_DefaultValues_values),
        ])
    _REQUEST_ATTRIBUTE_DefaultValues._ext = None
    _REQUEST_ATTRIBUTE_contexts = SEQ_OF(name=u'contexts', mode=MODE_VALUE, opt=True)
    __REQUEST_ATTRIBUTE_contexts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ServiceAdministration', 'ContextProfile')))
    _REQUEST_ATTRIBUTE_contexts._cont = __REQUEST_ATTRIBUTE_contexts__item_
    _REQUEST_ATTRIBUTE_contextCombination = CHOICE(name=u'contextCombination', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ContextCombination')), opt=True)
    _REQUEST_ATTRIBUTE_MatchingUse = SEQ(name=u'MatchingUse', mode=MODE_SET, typeref=ASN1RefType(('ServiceAdministration', 'MatchingUse')), opt=True)
    _REQUEST_ATTRIBUTE_includeSubtypes = BOOL(name=u'includeSubtypes', mode=MODE_VALUE, default=False)
    REQUEST_ATTRIBUTE._cont = ASN1Dict([
        (u'attributeType', _REQUEST_ATTRIBUTE_attributeType),
        (u'SelectedValues', _REQUEST_ATTRIBUTE_SelectedValues),
        (u'DefaultValues', _REQUEST_ATTRIBUTE_DefaultValues),
        (u'contexts', _REQUEST_ATTRIBUTE_contexts),
        (u'contextCombination', _REQUEST_ATTRIBUTE_contextCombination),
        (u'MatchingUse', _REQUEST_ATTRIBUTE_MatchingUse),
        (u'includeSubtypes', _REQUEST_ATTRIBUTE_includeSubtypes),
        ])
    
    #-----< RESULT-ATTRIBUTE >-----#
    RESULT_ATTRIBUTE = CLASS(name=u'RESULT-ATTRIBUTE', mode=MODE_TYPE)
    _RESULT_ATTRIBUTE_attributeType = OID(name=u'attributeType', mode=MODE_VALUE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'id']))
    _RESULT_ATTRIBUTE_outputValues = CHOICE(name=u'outputValues', mode=MODE_VALUE, opt=True)
    __RESULT_ATTRIBUTE_outputValues_selectedValues = SEQ_OF(name=u'selectedValues', mode=MODE_TYPE)
    ___RESULT_ATTRIBUTE_outputValues_selectedValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('InformationFramework', 'ATTRIBUTE'), [u'Type']))
    __RESULT_ATTRIBUTE_outputValues_selectedValues._cont = ___RESULT_ATTRIBUTE_outputValues_selectedValues__item_
    __RESULT_ATTRIBUTE_outputValues_matchedValuesOnly = NULL(name=u'matchedValuesOnly', mode=MODE_TYPE)
    _RESULT_ATTRIBUTE_outputValues._cont = ASN1Dict([
        (u'selectedValues', __RESULT_ATTRIBUTE_outputValues_selectedValues),
        (u'matchedValuesOnly', __RESULT_ATTRIBUTE_outputValues_matchedValuesOnly),
        ])
    _RESULT_ATTRIBUTE_outputValues._ext = None
    _RESULT_ATTRIBUTE_contexts = SEQ(name=u'contexts', mode=MODE_VALUE, typeref=ASN1RefType(('ServiceAdministration', 'ContextProfile')), opt=True)
    RESULT_ATTRIBUTE._cont = ASN1Dict([
        (u'attributeType', _RESULT_ATTRIBUTE_attributeType),
        (u'outputValues', _RESULT_ATTRIBUTE_outputValues),
        (u'contexts', _RESULT_ATTRIBUTE_contexts),
        ])
    
    #-----< MATCHING-RESTRICTION >-----#
    MATCHING_RESTRICTION = CLASS(name=u'MATCHING-RESTRICTION', mode=MODE_TYPE)
    _MATCHING_RESTRICTION_Restriction = OPEN(name=u'Restriction', mode=MODE_TYPE)
    _MATCHING_RESTRICTION_Rules = OID(name=u'Rules', mode=MODE_SET, typeref=ASN1RefClassField(('InformationFramework', 'MATCHING-RULE'), [u'id']))
    _MATCHING_RESTRICTION_id = OID(name=u'id', mode=MODE_VALUE, uniq=True)
    MATCHING_RESTRICTION._cont = ASN1Dict([
        (u'Restriction', _MATCHING_RESTRICTION_Restriction),
        (u'Rules', _MATCHING_RESTRICTION_Rules),
        (u'id', _MATCHING_RESTRICTION_id),
        ])
    
    _all_ = [
        _SearchRule_id,
        _SearchRule_dmdId,
        _SearchRule_serviceType,
        _SearchRule_userClass,
        __SearchRule_inputAttributeTypes__item_,
        _SearchRule_inputAttributeTypes,
        _SearchRule_attributeCombination,
        __SearchRule_outputAttributeTypes__item_,
        _SearchRule_outputAttributeTypes,
        _SearchRule_defaultControls,
        _SearchRule_mandatoryControls,
        _SearchRule_searchRuleControls,
        _SearchRule_familyGrouping,
        _SearchRule_familyReturn,
        _SearchRule_relaxation,
        __SearchRule_additionalControl__item_,
        _SearchRule_additionalControl,
        _SearchRule_allowedSubset,
        _SearchRule_imposedSubset,
        _SearchRule_entryLimit,
        SearchRule,
        _SearchRuleId_id,
        _SearchRuleId_dmdId,
        SearchRuleId,
        AllowedSubset,
        ImposedSubset,
        __RequestAttribute_attributeType_tab,
        ___RequestAttribute_attributeType_tab_val_Type_0,
        __ATTRIBUTE_equality_match_val_AssertionType,
        ___RequestAttribute_attributeType_tab_val_Type_1,
        __ATTRIBUTE_equality_match_val_AssertionType_0,
        _RequestAttribute_attributeType,
        _RequestAttribute_includeSubtypes,
        __RequestAttribute_selectedValues__item_,
        _RequestAttribute_selectedValues,
        ___RequestAttribute_defaultValues__item__entryType,
        ____RequestAttribute_defaultValues__item__values__item_,
        ___RequestAttribute_defaultValues__item__values,
        __RequestAttribute_defaultValues__item_,
        _RequestAttribute_defaultValues,
        __RequestAttribute_contexts__item_,
        _RequestAttribute_contexts,
        _RequestAttribute_contextCombination,
        __RequestAttribute_matchingUse__item_,
        _RequestAttribute_matchingUse,
        RequestAttribute,
        __ContextProfile_contextType_tab,
        _ContextProfile_contextType,
        ___ContextProfile_contextValue__item__tab,
        __ContextProfile_contextValue__item_,
        _ContextProfile_contextValue,
        ContextProfile,
        __ContextCombination_context_tab,
        _ContextCombination_context,
        __ContextCombination_and___item_,
        _ContextCombination_and_,
        __ContextCombination_or___item_,
        _ContextCombination_or_,
        _ContextCombination_not_,
        ContextCombination,
        __MatchingUse_restrictionType_tab,
        _MatchingUse_restrictionType,
        __MatchingUse_restrictionValue_tab,
        _MatchingUse_restrictionValue,
        MatchingUse,
        SupportedMatchingRestrictions,
        _AttributeCombination_attribute,
        __AttributeCombination_and___item_,
        _AttributeCombination_and_,
        __AttributeCombination_or___item_,
        _AttributeCombination_or_,
        _AttributeCombination_not_,
        AttributeCombination,
        __ResultAttribute_attributeType_tab,
        ___ResultAttribute_attributeType_tab_val_Type_0,
        ___ResultAttribute_attributeType_tab_val_Type_1,
        _ResultAttribute_attributeType,
        ___ResultAttribute_outputValues_selectedValues__item_,
        __ResultAttribute_outputValues_selectedValues,
        __ResultAttribute_outputValues_matchedValuesOnly,
        _ResultAttribute_outputValues,
        __ResultAttribute_contexts__item_,
        _ResultAttribute_contexts,
        ResultAttribute,
        _ControlOptions_serviceControls,
        _ControlOptions_searchOptions,
        _ControlOptions_hierarchyOptions,
        ControlOptions,
        _EntryLimit_default,
        _EntryLimit_max,
        EntryLimit,
        _RelaxationPolicy_basic,
        __RelaxationPolicy_tightenings__item_,
        _RelaxationPolicy_tightenings,
        __RelaxationPolicy_relaxations__item_,
        _RelaxationPolicy_relaxations,
        _RelaxationPolicy_maximum,
        _RelaxationPolicy_minimum,
        RelaxationPolicy,
        __MRMapping_mapping__item_,
        _MRMapping_mapping,
        __MRMapping_substitution__item_,
        _MRMapping_substitution,
        MRMapping,
        _Mapping_mappingFunction,
        _Mapping_level,
        Mapping,
        _MRSubstitution_attribute,
        _MRSubstitution_oldMatchingRule,
        _MRSubstitution_newMatchingRule,
        MRSubstitution,
        _SEARCH_RULE_dmdId,
        _SEARCH_RULE_serviceType,
        _SEARCH_RULE_userClass,
        _SEARCH_RULE_InputAttributeTypes,
        _SEARCH_RULE_combination,
        _SEARCH_RULE_OutputAttributeTypes,
        _SEARCH_RULE_defaultControls,
        _SEARCH_RULE_mandatoryControls,
        _SEARCH_RULE_searchRuleControls,
        _SEARCH_RULE_familyGrouping,
        _SEARCH_RULE_familyReturn,
        _SEARCH_RULE_additionalControl,
        _SEARCH_RULE_relaxation,
        _SEARCH_RULE_allowedSubset,
        _SEARCH_RULE_imposedSubset,
        _SEARCH_RULE_entryLimit,
        _SEARCH_RULE_id,
        SEARCH_RULE,
        _REQUEST_ATTRIBUTE_attributeType,
        _REQUEST_ATTRIBUTE_SelectedValues,
        __REQUEST_ATTRIBUTE_DefaultValues_entryType,
        ___REQUEST_ATTRIBUTE_DefaultValues_values__item_,
        __REQUEST_ATTRIBUTE_DefaultValues_values,
        _REQUEST_ATTRIBUTE_DefaultValues,
        __REQUEST_ATTRIBUTE_contexts__item_,
        _REQUEST_ATTRIBUTE_contexts,
        _REQUEST_ATTRIBUTE_contextCombination,
        _REQUEST_ATTRIBUTE_MatchingUse,
        _REQUEST_ATTRIBUTE_includeSubtypes,
        REQUEST_ATTRIBUTE,
        _RESULT_ATTRIBUTE_attributeType,
        ___RESULT_ATTRIBUTE_outputValues_selectedValues__item_,
        __RESULT_ATTRIBUTE_outputValues_selectedValues,
        __RESULT_ATTRIBUTE_outputValues_matchedValuesOnly,
        _RESULT_ATTRIBUTE_outputValues,
        _RESULT_ATTRIBUTE_contexts,
        RESULT_ATTRIBUTE,
        _MATCHING_RESTRICTION_Restriction,
        _MATCHING_RESTRICTION_Rules,
        _MATCHING_RESTRICTION_id,
        MATCHING_RESTRICTION,
    ]

class SMSChargingDataTypes:

    _name_  = u'SMSChargingDataTypes'
    _oid_   = [0, 4, 0, 0, 5, 10, 0, 1]
    
    _obj_ = [
        u'SMSRecordType',
        u'SCSMORecord',
        u'SCSMOT4Record',
        u'SCSMTRecord',
        u'SCDVTT4Record',
        u'ISMSMORecord',
        u'ISMSMTRecord',
        u'OriginatorInfo',
        u'RecipientInfo',
        u'SMAddressDomain',
        u'SMAddressInfo',
        u'SMAddressType',
        u'SMDeviceTriggerIndicator',
        u'SMDeviceTriggerInformation',
        u'SMDTPriorityIndication',
        u'SMInterface',
        u'SMInterfaceType',
        u'SMMessageType',
        u'SMServingNode',
        u'SMSStatus',
        ]
    _type_ = [
        u'SMSRecordType',
        u'SCSMORecord',
        u'SCSMOT4Record',
        u'SCSMTRecord',
        u'SCDVTT4Record',
        u'ISMSMORecord',
        u'ISMSMTRecord',
        u'OriginatorInfo',
        u'RecipientInfo',
        u'SMAddressDomain',
        u'SMAddressInfo',
        u'SMAddressType',
        u'SMDeviceTriggerIndicator',
        u'SMDeviceTriggerInformation',
        u'SMDTPriorityIndication',
        u'SMInterface',
        u'SMInterfaceType',
        u'SMMessageType',
        u'SMServingNode',
        u'SMSStatus',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SMSRecordType >-----#
    SMSRecordType = CHOICE(name=u'SMSRecordType', mode=MODE_TYPE)
    _SMSRecordType_sCSMORecord = SET(name=u'sCSMORecord', mode=MODE_TYPE, tag=(93, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SCSMORecord')))
    _SMSRecordType_sCSMTRecord = SET(name=u'sCSMTRecord', mode=MODE_TYPE, tag=(94, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SCSMTRecord')))
    _SMSRecordType_sCDVTT4Record = SET(name=u'sCDVTT4Record', mode=MODE_TYPE, tag=(110, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SCDVTT4Record')))
    _SMSRecordType_sCSMOT4Record = SET(name=u'sCSMOT4Record', mode=MODE_TYPE, tag=(111, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SCSMTRecord')))
    _SMSRecordType_iSMSMORecord = SET(name=u'iSMSMORecord', mode=MODE_TYPE, tag=(112, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'ISMSMORecord')))
    _SMSRecordType_iSMSMTRecord = SET(name=u'iSMSMTRecord', mode=MODE_TYPE, tag=(113, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'ISMSMTRecord')))
    SMSRecordType._cont = ASN1Dict([
        (u'sCSMORecord', _SMSRecordType_sCSMORecord),
        (u'sCSMTRecord', _SMSRecordType_sCSMTRecord),
        (u'sCDVTT4Record', _SMSRecordType_sCDVTT4Record),
        (u'sCSMOT4Record', _SMSRecordType_sCSMOT4Record),
        (u'iSMSMORecord', _SMSRecordType_iSMSMORecord),
        (u'iSMSMTRecord', _SMSRecordType_iSMSMTRecord),
        ])
    SMSRecordType._ext = None
    
    #-----< SCSMORecord >-----#
    SCSMORecord = SET(name=u'SCSMORecord', mode=MODE_TYPE)
    _SCSMORecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SCSMORecord_sMSNodeAddress = OCT_STR(name=u'sMSNodeAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _SCSMORecord_originatorInfo = SEQ(name=u'originatorInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'OriginatorInfo')), opt=True)
    _SCSMORecord_recipientInfo = SEQ_OF(name=u'recipientInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SCSMORecord_recipientInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SMSChargingDataTypes', 'RecipientInfo')))
    _SCSMORecord_recipientInfo._cont = __SCSMORecord_recipientInfo__item_
    _SCSMORecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SCSMORecord_eventtimestamp = OCT_STR(name=u'eventtimestamp', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SCSMORecord_messageReference = OCT_STR(name=u'messageReference', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageReference')))
    _SCSMORecord_sMTotalNumber = INT(name=u'sMTotalNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMORecord_sMSequenceNumber = INT(name=u'sMSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMORecord_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _SCSMORecord_messageClass = ENUM(name=u'messageClass', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _SCSMORecord_sMdeliveryReportRequested = BOOL(name=u'sMdeliveryReportRequested', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMORecord_sMDataCodingScheme = INT(name=u'sMDataCodingScheme', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMORecord_sMMessageType = ENUM(name=u'sMMessageType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMMessageType')), opt=True)
    _SCSMORecord_sMReplyPathRequested = NULL(name=u'sMReplyPathRequested', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMORecord_sMUserDataHeader = OCT_STR(name=u'sMUserDataHeader', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMORecord_userLocationInfo = OCT_STR(name=u'userLocationInfo', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMORecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SCSMORecord_uETimeZone = OCT_STR(name=u'uETimeZone', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _SCSMORecord_sMSResult = CHOICE(name=u'sMSResult', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _SCSMORecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SCSMORecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    SCSMORecord._cont = ASN1Dict([
        (u'recordType', _SCSMORecord_recordType),
        (u'sMSNodeAddress', _SCSMORecord_sMSNodeAddress),
        (u'originatorInfo', _SCSMORecord_originatorInfo),
        (u'recipientInfo', _SCSMORecord_recipientInfo),
        (u'servedIMEI', _SCSMORecord_servedIMEI),
        (u'eventtimestamp', _SCSMORecord_eventtimestamp),
        (u'messageReference', _SCSMORecord_messageReference),
        (u'sMTotalNumber', _SCSMORecord_sMTotalNumber),
        (u'sMSequenceNumber', _SCSMORecord_sMSequenceNumber),
        (u'messageSize', _SCSMORecord_messageSize),
        (u'messageClass', _SCSMORecord_messageClass),
        (u'sMdeliveryReportRequested', _SCSMORecord_sMdeliveryReportRequested),
        (u'sMDataCodingScheme', _SCSMORecord_sMDataCodingScheme),
        (u'sMMessageType', _SCSMORecord_sMMessageType),
        (u'sMReplyPathRequested', _SCSMORecord_sMReplyPathRequested),
        (u'sMUserDataHeader', _SCSMORecord_sMUserDataHeader),
        (u'userLocationInfo', _SCSMORecord_userLocationInfo),
        (u'rATType', _SCSMORecord_rATType),
        (u'uETimeZone', _SCSMORecord_uETimeZone),
        (u'sMSResult', _SCSMORecord_sMSResult),
        (u'localSequenceNumber', _SCSMORecord_localSequenceNumber),
        (u'recordExtensions', _SCSMORecord_recordExtensions),
        ])
    SCSMORecord._ext = None
    
    #-----< SCSMOT4Record >-----#
    SCSMOT4Record = SET(name=u'SCSMOT4Record', mode=MODE_TYPE)
    _SCSMOT4Record_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SCSMOT4Record_sMSNodeAddress = OCT_STR(name=u'sMSNodeAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _SCSMOT4Record_originatorInfo = SEQ(name=u'originatorInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'OriginatorInfo')), opt=True)
    _SCSMOT4Record_recipientInfo = SEQ(name=u'recipientInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'RecipientInfo')), opt=True)
    _SCSMOT4Record_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SCSMOT4Record_eventtimestamp = OCT_STR(name=u'eventtimestamp', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SCSMOT4Record_messageReference = OCT_STR(name=u'messageReference', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageReference')))
    _SCSMOT4Record_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _SCSMOT4Record_messageClass = ENUM(name=u'messageClass', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _SCSMOT4Record_sMdeliveryReportRequested = BOOL(name=u'sMdeliveryReportRequested', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMOT4Record_sMDataCodingScheme = INT(name=u'sMDataCodingScheme', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMOT4Record_sMMessageType = ENUM(name=u'sMMessageType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMMessageType')), opt=True)
    _SCSMOT4Record_sMReplyPathRequested = NULL(name=u'sMReplyPathRequested', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMOT4Record_sMUserDataHeader = OCT_STR(name=u'sMUserDataHeader', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMOT4Record_userLocationInfo = OCT_STR(name=u'userLocationInfo', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMOT4Record_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SCSMOT4Record_uETimeZone = OCT_STR(name=u'uETimeZone', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _SCSMOT4Record_sMSResult = CHOICE(name=u'sMSResult', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _SCSMOT4Record_mTCIWFAddress = CHOICE(name=u'mTCIWFAddress', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _SCSMOT4Record_sMSApplicationPortID = INT(name=u'sMSApplicationPortID', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMOT4Record_externalIdentifier = SET(name=u'externalIdentifier', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriptionID')), opt=True)
    _SCSMOT4Record_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SCSMOT4Record_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    SCSMOT4Record._cont = ASN1Dict([
        (u'recordType', _SCSMOT4Record_recordType),
        (u'sMSNodeAddress', _SCSMOT4Record_sMSNodeAddress),
        (u'originatorInfo', _SCSMOT4Record_originatorInfo),
        (u'recipientInfo', _SCSMOT4Record_recipientInfo),
        (u'servedIMEI', _SCSMOT4Record_servedIMEI),
        (u'eventtimestamp', _SCSMOT4Record_eventtimestamp),
        (u'messageReference', _SCSMOT4Record_messageReference),
        (u'messageSize', _SCSMOT4Record_messageSize),
        (u'messageClass', _SCSMOT4Record_messageClass),
        (u'sMdeliveryReportRequested', _SCSMOT4Record_sMdeliveryReportRequested),
        (u'sMDataCodingScheme', _SCSMOT4Record_sMDataCodingScheme),
        (u'sMMessageType', _SCSMOT4Record_sMMessageType),
        (u'sMReplyPathRequested', _SCSMOT4Record_sMReplyPathRequested),
        (u'sMUserDataHeader', _SCSMOT4Record_sMUserDataHeader),
        (u'userLocationInfo', _SCSMOT4Record_userLocationInfo),
        (u'rATType', _SCSMOT4Record_rATType),
        (u'uETimeZone', _SCSMOT4Record_uETimeZone),
        (u'sMSResult', _SCSMOT4Record_sMSResult),
        (u'mTCIWFAddress', _SCSMOT4Record_mTCIWFAddress),
        (u'sMSApplicationPortID', _SCSMOT4Record_sMSApplicationPortID),
        (u'externalIdentifier', _SCSMOT4Record_externalIdentifier),
        (u'localSequenceNumber', _SCSMOT4Record_localSequenceNumber),
        (u'recordExtensions', _SCSMOT4Record_recordExtensions),
        ])
    SCSMOT4Record._ext = None
    
    #-----< SCSMTRecord >-----#
    SCSMTRecord = SET(name=u'SCSMTRecord', mode=MODE_TYPE)
    _SCSMTRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SCSMTRecord_sMSNodeAddress = OCT_STR(name=u'sMSNodeAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _SCSMTRecord_recipientInfo = SEQ(name=u'recipientInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'RecipientInfo')), opt=True)
    _SCSMTRecord_originatorInfo = SEQ(name=u'originatorInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'OriginatorInfo')), opt=True)
    _SCSMTRecord_servedIMEI = OCT_STR(name=u'servedIMEI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMEI')), opt=True)
    _SCSMTRecord_submissionTime = OCT_STR(name=u'submissionTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SCSMTRecord_eventtimestamp = OCT_STR(name=u'eventtimestamp', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SCSMTRecord_sMPriority = ENUM(name=u'sMPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _SCSMTRecord_messageReference = OCT_STR(name=u'messageReference', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageReference')), opt=True)
    _SCSMTRecord_sMTotalNumber = INT(name=u'sMTotalNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMTRecord_sMSequenceNumber = INT(name=u'sMSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMTRecord_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _SCSMTRecord_messageClass = ENUM(name=u'messageClass', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _SCSMTRecord_sMdeliveryReportRequested = BOOL(name=u'sMdeliveryReportRequested', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMTRecord_sMDataCodingScheme = INT(name=u'sMDataCodingScheme', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMTRecord_sMMessageType = ENUM(name=u'sMMessageType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMMessageType')), opt=True)
    _SCSMTRecord_sMReplyPathRequested = NULL(name=u'sMReplyPathRequested', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMTRecord_sMUserDataHeader = OCT_STR(name=u'sMUserDataHeader', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMTRecord_sMSStatus = OCT_STR(name=u'sMSStatus', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMSStatus')), opt=True)
    _SCSMTRecord_sMDischargeTime = OCT_STR(name=u'sMDischargeTime', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _SCSMTRecord_userLocationInfo = OCT_STR(name=u'userLocationInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SCSMTRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _SCSMTRecord_uETimeZone = OCT_STR(name=u'uETimeZone', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _SCSMTRecord_sMSResult = CHOICE(name=u'sMSResult', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _SCSMTRecord_sMDeviceTriggerInformation = SEQ(name=u'sMDeviceTriggerInformation', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMDeviceTriggerInformation')), opt=True)
    _SCSMTRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SCSMTRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    SCSMTRecord._cont = ASN1Dict([
        (u'recordType', _SCSMTRecord_recordType),
        (u'sMSNodeAddress', _SCSMTRecord_sMSNodeAddress),
        (u'recipientInfo', _SCSMTRecord_recipientInfo),
        (u'originatorInfo', _SCSMTRecord_originatorInfo),
        (u'servedIMEI', _SCSMTRecord_servedIMEI),
        (u'submissionTime', _SCSMTRecord_submissionTime),
        (u'eventtimestamp', _SCSMTRecord_eventtimestamp),
        (u'sMPriority', _SCSMTRecord_sMPriority),
        (u'messageReference', _SCSMTRecord_messageReference),
        (u'sMTotalNumber', _SCSMTRecord_sMTotalNumber),
        (u'sMSequenceNumber', _SCSMTRecord_sMSequenceNumber),
        (u'messageSize', _SCSMTRecord_messageSize),
        (u'messageClass', _SCSMTRecord_messageClass),
        (u'sMdeliveryReportRequested', _SCSMTRecord_sMdeliveryReportRequested),
        (u'sMDataCodingScheme', _SCSMTRecord_sMDataCodingScheme),
        (u'sMMessageType', _SCSMTRecord_sMMessageType),
        (u'sMReplyPathRequested', _SCSMTRecord_sMReplyPathRequested),
        (u'sMUserDataHeader', _SCSMTRecord_sMUserDataHeader),
        (u'sMSStatus', _SCSMTRecord_sMSStatus),
        (u'sMDischargeTime', _SCSMTRecord_sMDischargeTime),
        (u'userLocationInfo', _SCSMTRecord_userLocationInfo),
        (u'rATType', _SCSMTRecord_rATType),
        (u'uETimeZone', _SCSMTRecord_uETimeZone),
        (u'sMSResult', _SCSMTRecord_sMSResult),
        (u'sMDeviceTriggerInformation', _SCSMTRecord_sMDeviceTriggerInformation),
        (u'localSequenceNumber', _SCSMTRecord_localSequenceNumber),
        (u'recordExtensions', _SCSMTRecord_recordExtensions),
        ])
    SCSMTRecord._ext = None
    
    #-----< SCDVTT4Record >-----#
    SCDVTT4Record = SET(name=u'SCDVTT4Record', mode=MODE_TYPE)
    _SCDVTT4Record_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _SCDVTT4Record_sMSNodeAddress = OCT_STR(name=u'sMSNodeAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _SCDVTT4Record_eventtimestamp = OCT_STR(name=u'eventtimestamp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _SCDVTT4Record_originatorInfo = SEQ(name=u'originatorInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'OriginatorInfo')), opt=True)
    _SCDVTT4Record_recipientInfo = SEQ(name=u'recipientInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'RecipientInfo')), opt=True)
    _SCDVTT4Record_sMDeviceTriggerIndicator = ENUM(name=u'sMDeviceTriggerIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMDeviceTriggerIndicator')), opt=True)
    _SCDVTT4Record_sMDeviceTriggerInformation = SEQ(name=u'sMDeviceTriggerInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMDeviceTriggerInformation')), opt=True)
    _SCDVTT4Record_sMSResult = CHOICE(name=u'sMSResult', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _SCDVTT4Record_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _SCDVTT4Record_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    SCDVTT4Record._cont = ASN1Dict([
        (u'recordType', _SCDVTT4Record_recordType),
        (u'sMSNodeAddress', _SCDVTT4Record_sMSNodeAddress),
        (u'eventtimestamp', _SCDVTT4Record_eventtimestamp),
        (u'originatorInfo', _SCDVTT4Record_originatorInfo),
        (u'recipientInfo', _SCDVTT4Record_recipientInfo),
        (u'sMDeviceTriggerIndicator', _SCDVTT4Record_sMDeviceTriggerIndicator),
        (u'sMDeviceTriggerInformation', _SCDVTT4Record_sMDeviceTriggerInformation),
        (u'sMSResult', _SCDVTT4Record_sMSResult),
        (u'localSequenceNumber', _SCDVTT4Record_localSequenceNumber),
        (u'recordExtensions', _SCDVTT4Record_recordExtensions),
        ])
    SCDVTT4Record._ext = None
    
    #-----< ISMSMORecord >-----#
    ISMSMORecord = SET(name=u'ISMSMORecord', mode=MODE_TYPE)
    _ISMSMORecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _ISMSMORecord_sMSNodeAddress = CHOICE(name=u'sMSNodeAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')))
    _ISMSMORecord_originatorInfo = SEQ(name=u'originatorInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'OriginatorInfo')), opt=True)
    _ISMSMORecord_recipientInfo = SEQ_OF(name=u'recipientInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ISMSMORecord_recipientInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SMSChargingDataTypes', 'RecipientInfo')))
    _ISMSMORecord_recipientInfo._cont = __ISMSMORecord_recipientInfo__item_
    _ISMSMORecord_subscriberEquipmentNumber = SET(name=u'subscriberEquipmentNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentNumber')), opt=True)
    _ISMSMORecord_eventtimestamp = OCT_STR(name=u'eventtimestamp', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ISMSMORecord_messageReference = OCT_STR(name=u'messageReference', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageReference')))
    _ISMSMORecord_sMTotalNumber = INT(name=u'sMTotalNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMORecord_sMSequenceNumber = INT(name=u'sMSequenceNumber', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMORecord_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _ISMSMORecord_messageClass = ENUM(name=u'messageClass', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _ISMSMORecord_sMdeliveryReportRequested = BOOL(name=u'sMdeliveryReportRequested', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMORecord_sMDataCodingScheme = INT(name=u'sMDataCodingScheme', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMORecord_sMMessageType = ENUM(name=u'sMMessageType', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMMessageType')), opt=True)
    _ISMSMORecord_sMReplyPathRequested = NULL(name=u'sMReplyPathRequested', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMORecord_sMUserDataHeader = OCT_STR(name=u'sMUserDataHeader', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMORecord_sMSResult = CHOICE(name=u'sMSResult', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _ISMSMORecord_userLocationInfo = OCT_STR(name=u'userLocationInfo', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMORecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _ISMSMORecord_uETimeZone = OCT_STR(name=u'uETimeZone', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _ISMSMORecord_pDPAddress = CHOICE(name=u'pDPAddress', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _ISMSMORecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _ISMSMORecord_numberPortabilityRouting = STR_GRAPH(name=u'numberPortabilityRouting', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _ISMSMORecord_carrierSelectRouting = STR_GRAPH(name=u'carrierSelectRouting', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _ISMSMORecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ISMSMORecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    ISMSMORecord._cont = ASN1Dict([
        (u'recordType', _ISMSMORecord_recordType),
        (u'sMSNodeAddress', _ISMSMORecord_sMSNodeAddress),
        (u'originatorInfo', _ISMSMORecord_originatorInfo),
        (u'recipientInfo', _ISMSMORecord_recipientInfo),
        (u'subscriberEquipmentNumber', _ISMSMORecord_subscriberEquipmentNumber),
        (u'eventtimestamp', _ISMSMORecord_eventtimestamp),
        (u'messageReference', _ISMSMORecord_messageReference),
        (u'sMTotalNumber', _ISMSMORecord_sMTotalNumber),
        (u'sMSequenceNumber', _ISMSMORecord_sMSequenceNumber),
        (u'messageSize', _ISMSMORecord_messageSize),
        (u'messageClass', _ISMSMORecord_messageClass),
        (u'sMdeliveryReportRequested', _ISMSMORecord_sMdeliveryReportRequested),
        (u'sMDataCodingScheme', _ISMSMORecord_sMDataCodingScheme),
        (u'sMMessageType', _ISMSMORecord_sMMessageType),
        (u'sMReplyPathRequested', _ISMSMORecord_sMReplyPathRequested),
        (u'sMUserDataHeader', _ISMSMORecord_sMUserDataHeader),
        (u'sMSResult', _ISMSMORecord_sMSResult),
        (u'userLocationInfo', _ISMSMORecord_userLocationInfo),
        (u'rATType', _ISMSMORecord_rATType),
        (u'uETimeZone', _ISMSMORecord_uETimeZone),
        (u'pDPAddress', _ISMSMORecord_pDPAddress),
        (u'session-Id', _ISMSMORecord_session_Id),
        (u'numberPortabilityRouting', _ISMSMORecord_numberPortabilityRouting),
        (u'carrierSelectRouting', _ISMSMORecord_carrierSelectRouting),
        (u'localSequenceNumber', _ISMSMORecord_localSequenceNumber),
        (u'recordExtensions', _ISMSMORecord_recordExtensions),
        ])
    ISMSMORecord._ext = None
    
    #-----< ISMSMTRecord >-----#
    ISMSMTRecord = SET(name=u'ISMSMTRecord', mode=MODE_TYPE)
    _ISMSMTRecord_recordType = INT(name=u'recordType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RecordType')))
    _ISMSMTRecord_sMSNodeAddress = CHOICE(name=u'sMSNodeAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')))
    _ISMSMTRecord_recipientInfo = SEQ(name=u'recipientInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'RecipientInfo')), opt=True)
    _ISMSMTRecord_originatorInfo = SEQ(name=u'originatorInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'OriginatorInfo')), opt=True)
    _ISMSMTRecord_subscriberEquipmentNumber = SET(name=u'subscriberEquipmentNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SubscriberEquipmentNumber')), opt=True)
    _ISMSMTRecord_submissionTime = OCT_STR(name=u'submissionTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ISMSMTRecord_eventtimestamp = OCT_STR(name=u'eventtimestamp', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')))
    _ISMSMTRecord_sMPriority = ENUM(name=u'sMPriority', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PriorityType')), opt=True)
    _ISMSMTRecord_messageReference = OCT_STR(name=u'messageReference', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageReference')))
    _ISMSMTRecord_sMTotalNumber = INT(name=u'sMTotalNumber', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMTRecord_sMSequenceNumber = INT(name=u'sMSequenceNumber', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMTRecord_messageSize = INT(name=u'messageSize', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CSChargingDataTypes', 'DataVolume')), opt=True)
    _ISMSMTRecord_messageClass = ENUM(name=u'messageClass', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MessageClass')), opt=True)
    _ISMSMTRecord_sMdeliveryReportRequested = BOOL(name=u'sMdeliveryReportRequested', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMTRecord_sMDataCodingScheme = INT(name=u'sMDataCodingScheme', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMTRecord_sMMessageType = ENUM(name=u'sMMessageType', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMMessageType')), opt=True)
    _ISMSMTRecord_sMReplyPathRequested = NULL(name=u'sMReplyPathRequested', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMTRecord_sMUserDataHeader = OCT_STR(name=u'sMUserDataHeader', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMTRecord_sMSStatus = OCT_STR(name=u'sMSStatus', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMSStatus')), opt=True)
    _ISMSMTRecord_sMDischargeTime = OCT_STR(name=u'sMDischargeTime', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'TimeStamp')), opt=True)
    _ISMSMTRecord_userLocationInfo = OCT_STR(name=u'userLocationInfo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ISMSMTRecord_rATType = INT(name=u'rATType', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'RATType')), opt=True)
    _ISMSMTRecord_uETimeZone = OCT_STR(name=u'uETimeZone', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSTimeZone')), opt=True)
    _ISMSMTRecord_sMSResult = CHOICE(name=u'sMSResult', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'SMSResult')), opt=True)
    _ISMSMTRecord_pDPAddress = CHOICE(name=u'pDPAddress', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PDPAddress')), opt=True)
    _ISMSMTRecord_session_Id = STR_GRAPH(name=u'session-Id', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'Session-Id')), opt=True)
    _ISMSMTRecord_numberPortabilityRouting = STR_GRAPH(name=u'numberPortabilityRouting', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'NumberPortabilityRouting')), opt=True)
    _ISMSMTRecord_carrierSelectRouting = STR_GRAPH(name=u'carrierSelectRouting', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('IMSChargingDataTypes', 'CarrierSelectRouting')), opt=True)
    _ISMSMTRecord_localSequenceNumber = INT(name=u'localSequenceNumber', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'LocalSequenceNumber')), opt=True)
    _ISMSMTRecord_recordExtensions = SET_OF(name=u'recordExtensions', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'ManagementExtensions')), opt=True)
    ISMSMTRecord._cont = ASN1Dict([
        (u'recordType', _ISMSMTRecord_recordType),
        (u'sMSNodeAddress', _ISMSMTRecord_sMSNodeAddress),
        (u'recipientInfo', _ISMSMTRecord_recipientInfo),
        (u'originatorInfo', _ISMSMTRecord_originatorInfo),
        (u'subscriberEquipmentNumber', _ISMSMTRecord_subscriberEquipmentNumber),
        (u'submissionTime', _ISMSMTRecord_submissionTime),
        (u'eventtimestamp', _ISMSMTRecord_eventtimestamp),
        (u'sMPriority', _ISMSMTRecord_sMPriority),
        (u'messageReference', _ISMSMTRecord_messageReference),
        (u'sMTotalNumber', _ISMSMTRecord_sMTotalNumber),
        (u'sMSequenceNumber', _ISMSMTRecord_sMSequenceNumber),
        (u'messageSize', _ISMSMTRecord_messageSize),
        (u'messageClass', _ISMSMTRecord_messageClass),
        (u'sMdeliveryReportRequested', _ISMSMTRecord_sMdeliveryReportRequested),
        (u'sMDataCodingScheme', _ISMSMTRecord_sMDataCodingScheme),
        (u'sMMessageType', _ISMSMTRecord_sMMessageType),
        (u'sMReplyPathRequested', _ISMSMTRecord_sMReplyPathRequested),
        (u'sMUserDataHeader', _ISMSMTRecord_sMUserDataHeader),
        (u'sMSStatus', _ISMSMTRecord_sMSStatus),
        (u'sMDischargeTime', _ISMSMTRecord_sMDischargeTime),
        (u'userLocationInfo', _ISMSMTRecord_userLocationInfo),
        (u'rATType', _ISMSMTRecord_rATType),
        (u'uETimeZone', _ISMSMTRecord_uETimeZone),
        (u'sMSResult', _ISMSMTRecord_sMSResult),
        (u'pDPAddress', _ISMSMTRecord_pDPAddress),
        (u'session-Id', _ISMSMTRecord_session_Id),
        (u'numberPortabilityRouting', _ISMSMTRecord_numberPortabilityRouting),
        (u'carrierSelectRouting', _ISMSMTRecord_carrierSelectRouting),
        (u'localSequenceNumber', _ISMSMTRecord_localSequenceNumber),
        (u'recordExtensions', _ISMSMTRecord_recordExtensions),
        ])
    ISMSMTRecord._ext = None
    
    #-----< OriginatorInfo >-----#
    OriginatorInfo = SEQ(name=u'OriginatorInfo', mode=MODE_TYPE)
    _OriginatorInfo_originatorIMSI = OCT_STR(name=u'originatorIMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _OriginatorInfo_originatorMSISDN = OCT_STR(name=u'originatorMSISDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _OriginatorInfo_originatorOtherAddress = SEQ(name=u'originatorOtherAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressInfo')), opt=True)
    _OriginatorInfo_originatorSCCPAddress = OCT_STR(name=u'originatorSCCPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _OriginatorInfo_originatorReceivedAddress = SEQ(name=u'originatorReceivedAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressInfo')), opt=True)
    _OriginatorInfo_sMOriginatorInterface = SEQ(name=u'sMOriginatorInterface', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMInterface')), opt=True)
    _OriginatorInfo_sMOriginatorProtocolID = OCT_STR(name=u'sMOriginatorProtocolID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _OriginatorInfo_originatorOtherAddresses = SEQ_OF(name=u'originatorOtherAddresses', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __OriginatorInfo_originatorOtherAddresses__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressInfo')))
    _OriginatorInfo_originatorOtherAddresses._cont = __OriginatorInfo_originatorOtherAddresses__item_
    OriginatorInfo._cont = ASN1Dict([
        (u'originatorIMSI', _OriginatorInfo_originatorIMSI),
        (u'originatorMSISDN', _OriginatorInfo_originatorMSISDN),
        (u'originatorOtherAddress', _OriginatorInfo_originatorOtherAddress),
        (u'originatorSCCPAddress', _OriginatorInfo_originatorSCCPAddress),
        (u'originatorReceivedAddress', _OriginatorInfo_originatorReceivedAddress),
        (u'sMOriginatorInterface', _OriginatorInfo_sMOriginatorInterface),
        (u'sMOriginatorProtocolID', _OriginatorInfo_sMOriginatorProtocolID),
        (u'originatorOtherAddresses', _OriginatorInfo_originatorOtherAddresses),
        ])
    OriginatorInfo._ext = None
    
    #-----< RecipientInfo >-----#
    RecipientInfo = SEQ(name=u'RecipientInfo', mode=MODE_TYPE)
    _RecipientInfo_recipientIMSI = OCT_STR(name=u'recipientIMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'IMSI')), opt=True)
    _RecipientInfo_recipientMSISDN = OCT_STR(name=u'recipientMSISDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'MSISDN')), opt=True)
    _RecipientInfo_recipientOtherAddress = SEQ(name=u'recipientOtherAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressInfo')), opt=True)
    _RecipientInfo_recipientSCCPAddress = OCT_STR(name=u'recipientSCCPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _RecipientInfo_recipientReceivedAddress = SEQ(name=u'recipientReceivedAddress', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressInfo')), opt=True)
    _RecipientInfo_sMDestinationInterface = SEQ(name=u'sMDestinationInterface', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMInterface')), opt=True)
    _RecipientInfo_sMRecipientProtocolID = OCT_STR(name=u'sMRecipientProtocolID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RecipientInfo_recipientOtherAddresses = SEQ_OF(name=u'recipientOtherAddresses', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __RecipientInfo_recipientOtherAddresses__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressInfo')))
    _RecipientInfo_recipientOtherAddresses._cont = __RecipientInfo_recipientOtherAddresses__item_
    RecipientInfo._cont = ASN1Dict([
        (u'recipientIMSI', _RecipientInfo_recipientIMSI),
        (u'recipientMSISDN', _RecipientInfo_recipientMSISDN),
        (u'recipientOtherAddress', _RecipientInfo_recipientOtherAddress),
        (u'recipientSCCPAddress', _RecipientInfo_recipientSCCPAddress),
        (u'recipientReceivedAddress', _RecipientInfo_recipientReceivedAddress),
        (u'sMDestinationInterface', _RecipientInfo_sMDestinationInterface),
        (u'sMRecipientProtocolID', _RecipientInfo_sMRecipientProtocolID),
        (u'recipientOtherAddresses', _RecipientInfo_recipientOtherAddresses),
        ])
    RecipientInfo._ext = None
    
    #-----< SMAddressDomain >-----#
    SMAddressDomain = SEQ(name=u'SMAddressDomain', mode=MODE_TYPE)
    _SMAddressDomain_sMDomainName = STR_GRAPH(name=u'sMDomainName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMAddressDomain_threeGPPIMSI_MCC_MNC = OCT_STR(name=u'threeGPPIMSI-MCC-MNC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'PLMN-Id')), opt=True)
    SMAddressDomain._cont = ASN1Dict([
        (u'sMDomainName', _SMAddressDomain_sMDomainName),
        (u'threeGPPIMSI-MCC-MNC', _SMAddressDomain_threeGPPIMSI_MCC_MNC),
        ])
    SMAddressDomain._ext = None
    
    #-----< SMAddressInfo >-----#
    SMAddressInfo = SEQ(name=u'SMAddressInfo', mode=MODE_TYPE)
    _SMAddressInfo_sMAddressType = ENUM(name=u'sMAddressType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressType')), opt=True)
    _SMAddressInfo_sMAddressData = STR_GRAPH(name=u'sMAddressData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMAddressInfo_sMAddressDomain = SEQ(name=u'sMAddressDomain', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMAddressDomain')), opt=True)
    SMAddressInfo._cont = ASN1Dict([
        (u'sMAddressType', _SMAddressInfo_sMAddressType),
        (u'sMAddressData', _SMAddressInfo_sMAddressData),
        (u'sMAddressDomain', _SMAddressInfo_sMAddressDomain),
        ])
    SMAddressInfo._ext = None
    
    #-----< SMAddressType >-----#
    SMAddressType = ENUM(name=u'SMAddressType', mode=MODE_TYPE)
    SMAddressType._cont = ASN1Dict([(u'emailAddress', 0), (u'mSISDN', 1), (u'iPv4Address', 2), (u'iPv6Address', 3), (u'numericShortCode', 4), (u'alphanumericShortCode', 5), (u'other', 6), (u'iMSI', 7), (u'nAI', 8), (u'externalId', 9)])
    SMAddressType._ext = None
    
    #-----< SMDeviceTriggerIndicator >-----#
    SMDeviceTriggerIndicator = ENUM(name=u'SMDeviceTriggerIndicator', mode=MODE_TYPE)
    SMDeviceTriggerIndicator._cont = ASN1Dict([(u'notDeviceTrigger', 0), (u'deviceTriggerRequest', 1), (u'deviceTriggerReplace', 2), (u'deviceTriggerRecall', 3)])
    SMDeviceTriggerIndicator._ext = None
    
    #-----< SMDeviceTriggerInformation >-----#
    SMDeviceTriggerInformation = SEQ(name=u'SMDeviceTriggerInformation', mode=MODE_TYPE)
    _SMDeviceTriggerInformation_mTCIWFAddress = CHOICE(name=u'mTCIWFAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'NodeAddress')), opt=True)
    _SMDeviceTriggerInformation_sMDTReferenceNumber = INT(name=u'sMDTReferenceNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMDeviceTriggerInformation_sMServingNode = SEQ(name=u'sMServingNode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMServingNode')), opt=True)
    _SMDeviceTriggerInformation_sMDTValidityPeriod = INT(name=u'sMDTValidityPeriod', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMDeviceTriggerInformation_sMDTPriorityIndication = ENUM(name=u'sMDTPriorityIndication', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMDTPriorityIndication')), opt=True)
    _SMDeviceTriggerInformation_sMSApplicationPortID = INT(name=u'sMSApplicationPortID', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    SMDeviceTriggerInformation._cont = ASN1Dict([
        (u'mTCIWFAddress', _SMDeviceTriggerInformation_mTCIWFAddress),
        (u'sMDTReferenceNumber', _SMDeviceTriggerInformation_sMDTReferenceNumber),
        (u'sMServingNode', _SMDeviceTriggerInformation_sMServingNode),
        (u'sMDTValidityPeriod', _SMDeviceTriggerInformation_sMDTValidityPeriod),
        (u'sMDTPriorityIndication', _SMDeviceTriggerInformation_sMDTPriorityIndication),
        (u'sMSApplicationPortID', _SMDeviceTriggerInformation_sMSApplicationPortID),
        ])
    SMDeviceTriggerInformation._ext = None
    
    #-----< SMDTPriorityIndication >-----#
    SMDTPriorityIndication = ENUM(name=u'SMDTPriorityIndication', mode=MODE_TYPE)
    SMDTPriorityIndication._cont = ASN1Dict([(u'nonpriority', 0), (u'priority', 1)])
    SMDTPriorityIndication._ext = None
    
    #-----< SMInterface >-----#
    SMInterface = SEQ(name=u'SMInterface', mode=MODE_TYPE)
    _SMInterface_interfaceId = STR_GRAPH(name=u'interfaceId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMInterface_interfaceText = STR_GRAPH(name=u'interfaceText', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMInterface_interfacePort = STR_GRAPH(name=u'interfacePort', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SMInterface_interfaceType = ENUM(name=u'interfaceType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SMSChargingDataTypes', 'SMInterfaceType')), opt=True)
    SMInterface._cont = ASN1Dict([
        (u'interfaceId', _SMInterface_interfaceId),
        (u'interfaceText', _SMInterface_interfaceText),
        (u'interfacePort', _SMInterface_interfacePort),
        (u'interfaceType', _SMInterface_interfaceType),
        ])
    SMInterface._ext = None
    
    #-----< SMInterfaceType >-----#
    SMInterfaceType = ENUM(name=u'SMInterfaceType', mode=MODE_TYPE)
    SMInterfaceType._cont = ASN1Dict([(u'unkown', 0), (u'mobileOriginating', 1), (u'mobileTerminating', 2), (u'applicationOriginating', 3), (u'applicationTerminating', 4), (u'deviceTrigger', 5)])
    SMInterfaceType._ext = None
    
    #-----< SMMessageType >-----#
    SMMessageType = ENUM(name=u'SMMessageType', mode=MODE_TYPE)
    SMMessageType._cont = ASN1Dict([(u'submission', 0), (u'deliveryReport', 1), (u'sMServiceRequest', 2), (u'delivery', 3), (u't4DeviceTrigger', 4), (u'sMDeviceTrigger', 5)])
    SMMessageType._ext = None
    
    #-----< SMServingNode >-----#
    SMServingNode = SEQ(name=u'SMServingNode', mode=MODE_TYPE)
    _SMServingNode_sGSNName = OCT_STR(name=u'sGSNName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SMServingNode_sGSNRealm = OCT_STR(name=u'sGSNRealm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SMServingNode_sGSNNumber = OCT_STR(name=u'sGSNNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _SMServingNode_mMEName = OCT_STR(name=u'mMEName', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SMServingNode_mMERealm = OCT_STR(name=u'mMERealm', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    _SMServingNode_mMENumberForMTSMS = OCT_STR(name=u'mMENumberForMTSMS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _SMServingNode_mSCNumber = OCT_STR(name=u'mSCNumber', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _SMServingNode_iPSMGWNumber = OCT_STR(name=u'iPSMGWNumber', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')), opt=True)
    _SMServingNode_iPSMGWName = OCT_STR(name=u'iPSMGWName', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('GenericChargingDataTypes', 'DiameterIdentity')), opt=True)
    SMServingNode._cont = ASN1Dict([
        (u'sGSNName', _SMServingNode_sGSNName),
        (u'sGSNRealm', _SMServingNode_sGSNRealm),
        (u'sGSNNumber', _SMServingNode_sGSNNumber),
        (u'mMEName', _SMServingNode_mMEName),
        (u'mMERealm', _SMServingNode_mMERealm),
        (u'mMENumberForMTSMS', _SMServingNode_mMENumberForMTSMS),
        (u'mSCNumber', _SMServingNode_mSCNumber),
        (u'iPSMGWNumber', _SMServingNode_iPSMGWNumber),
        (u'iPSMGWName', _SMServingNode_iPSMGWName),
        ])
    SMServingNode._ext = None
    
    #-----< SMSStatus >-----#
    SMSStatus = OCT_STR(name=u'SMSStatus', mode=MODE_TYPE)
    SMSStatus._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    _all_ = [
        _SMSRecordType_sCSMORecord,
        _SMSRecordType_sCSMTRecord,
        _SMSRecordType_sCDVTT4Record,
        _SMSRecordType_sCSMOT4Record,
        _SMSRecordType_iSMSMORecord,
        _SMSRecordType_iSMSMTRecord,
        SMSRecordType,
        _SCSMORecord_recordType,
        _SCSMORecord_sMSNodeAddress,
        _SCSMORecord_originatorInfo,
        __SCSMORecord_recipientInfo__item_,
        _SCSMORecord_recipientInfo,
        _SCSMORecord_servedIMEI,
        _SCSMORecord_eventtimestamp,
        _SCSMORecord_messageReference,
        _SCSMORecord_sMTotalNumber,
        _SCSMORecord_sMSequenceNumber,
        _SCSMORecord_messageSize,
        _SCSMORecord_messageClass,
        _SCSMORecord_sMdeliveryReportRequested,
        _SCSMORecord_sMDataCodingScheme,
        _SCSMORecord_sMMessageType,
        _SCSMORecord_sMReplyPathRequested,
        _SCSMORecord_sMUserDataHeader,
        _SCSMORecord_userLocationInfo,
        _SCSMORecord_rATType,
        _SCSMORecord_uETimeZone,
        _SCSMORecord_sMSResult,
        _SCSMORecord_localSequenceNumber,
        _SCSMORecord_recordExtensions,
        SCSMORecord,
        _SCSMOT4Record_recordType,
        _SCSMOT4Record_sMSNodeAddress,
        _SCSMOT4Record_originatorInfo,
        _SCSMOT4Record_recipientInfo,
        _SCSMOT4Record_servedIMEI,
        _SCSMOT4Record_eventtimestamp,
        _SCSMOT4Record_messageReference,
        _SCSMOT4Record_messageSize,
        _SCSMOT4Record_messageClass,
        _SCSMOT4Record_sMdeliveryReportRequested,
        _SCSMOT4Record_sMDataCodingScheme,
        _SCSMOT4Record_sMMessageType,
        _SCSMOT4Record_sMReplyPathRequested,
        _SCSMOT4Record_sMUserDataHeader,
        _SCSMOT4Record_userLocationInfo,
        _SCSMOT4Record_rATType,
        _SCSMOT4Record_uETimeZone,
        _SCSMOT4Record_sMSResult,
        _SCSMOT4Record_mTCIWFAddress,
        _SCSMOT4Record_sMSApplicationPortID,
        _SCSMOT4Record_externalIdentifier,
        _SCSMOT4Record_localSequenceNumber,
        _SCSMOT4Record_recordExtensions,
        SCSMOT4Record,
        _SCSMTRecord_recordType,
        _SCSMTRecord_sMSNodeAddress,
        _SCSMTRecord_recipientInfo,
        _SCSMTRecord_originatorInfo,
        _SCSMTRecord_servedIMEI,
        _SCSMTRecord_submissionTime,
        _SCSMTRecord_eventtimestamp,
        _SCSMTRecord_sMPriority,
        _SCSMTRecord_messageReference,
        _SCSMTRecord_sMTotalNumber,
        _SCSMTRecord_sMSequenceNumber,
        _SCSMTRecord_messageSize,
        _SCSMTRecord_messageClass,
        _SCSMTRecord_sMdeliveryReportRequested,
        _SCSMTRecord_sMDataCodingScheme,
        _SCSMTRecord_sMMessageType,
        _SCSMTRecord_sMReplyPathRequested,
        _SCSMTRecord_sMUserDataHeader,
        _SCSMTRecord_sMSStatus,
        _SCSMTRecord_sMDischargeTime,
        _SCSMTRecord_userLocationInfo,
        _SCSMTRecord_rATType,
        _SCSMTRecord_uETimeZone,
        _SCSMTRecord_sMSResult,
        _SCSMTRecord_sMDeviceTriggerInformation,
        _SCSMTRecord_localSequenceNumber,
        _SCSMTRecord_recordExtensions,
        SCSMTRecord,
        _SCDVTT4Record_recordType,
        _SCDVTT4Record_sMSNodeAddress,
        _SCDVTT4Record_eventtimestamp,
        _SCDVTT4Record_originatorInfo,
        _SCDVTT4Record_recipientInfo,
        _SCDVTT4Record_sMDeviceTriggerIndicator,
        _SCDVTT4Record_sMDeviceTriggerInformation,
        _SCDVTT4Record_sMSResult,
        _SCDVTT4Record_localSequenceNumber,
        _SCDVTT4Record_recordExtensions,
        SCDVTT4Record,
        _ISMSMORecord_recordType,
        _ISMSMORecord_sMSNodeAddress,
        _ISMSMORecord_originatorInfo,
        __ISMSMORecord_recipientInfo__item_,
        _ISMSMORecord_recipientInfo,
        _ISMSMORecord_subscriberEquipmentNumber,
        _ISMSMORecord_eventtimestamp,
        _ISMSMORecord_messageReference,
        _ISMSMORecord_sMTotalNumber,
        _ISMSMORecord_sMSequenceNumber,
        _ISMSMORecord_messageSize,
        _ISMSMORecord_messageClass,
        _ISMSMORecord_sMdeliveryReportRequested,
        _ISMSMORecord_sMDataCodingScheme,
        _ISMSMORecord_sMMessageType,
        _ISMSMORecord_sMReplyPathRequested,
        _ISMSMORecord_sMUserDataHeader,
        _ISMSMORecord_sMSResult,
        _ISMSMORecord_userLocationInfo,
        _ISMSMORecord_rATType,
        _ISMSMORecord_uETimeZone,
        _ISMSMORecord_pDPAddress,
        _ISMSMORecord_session_Id,
        _ISMSMORecord_numberPortabilityRouting,
        _ISMSMORecord_carrierSelectRouting,
        _ISMSMORecord_localSequenceNumber,
        _ISMSMORecord_recordExtensions,
        ISMSMORecord,
        _ISMSMTRecord_recordType,
        _ISMSMTRecord_sMSNodeAddress,
        _ISMSMTRecord_recipientInfo,
        _ISMSMTRecord_originatorInfo,
        _ISMSMTRecord_subscriberEquipmentNumber,
        _ISMSMTRecord_submissionTime,
        _ISMSMTRecord_eventtimestamp,
        _ISMSMTRecord_sMPriority,
        _ISMSMTRecord_messageReference,
        _ISMSMTRecord_sMTotalNumber,
        _ISMSMTRecord_sMSequenceNumber,
        _ISMSMTRecord_messageSize,
        _ISMSMTRecord_messageClass,
        _ISMSMTRecord_sMdeliveryReportRequested,
        _ISMSMTRecord_sMDataCodingScheme,
        _ISMSMTRecord_sMMessageType,
        _ISMSMTRecord_sMReplyPathRequested,
        _ISMSMTRecord_sMUserDataHeader,
        _ISMSMTRecord_sMSStatus,
        _ISMSMTRecord_sMDischargeTime,
        _ISMSMTRecord_userLocationInfo,
        _ISMSMTRecord_rATType,
        _ISMSMTRecord_uETimeZone,
        _ISMSMTRecord_sMSResult,
        _ISMSMTRecord_pDPAddress,
        _ISMSMTRecord_session_Id,
        _ISMSMTRecord_numberPortabilityRouting,
        _ISMSMTRecord_carrierSelectRouting,
        _ISMSMTRecord_localSequenceNumber,
        _ISMSMTRecord_recordExtensions,
        ISMSMTRecord,
        _OriginatorInfo_originatorIMSI,
        _OriginatorInfo_originatorMSISDN,
        _OriginatorInfo_originatorOtherAddress,
        _OriginatorInfo_originatorSCCPAddress,
        _OriginatorInfo_originatorReceivedAddress,
        _OriginatorInfo_sMOriginatorInterface,
        _OriginatorInfo_sMOriginatorProtocolID,
        __OriginatorInfo_originatorOtherAddresses__item_,
        _OriginatorInfo_originatorOtherAddresses,
        OriginatorInfo,
        _RecipientInfo_recipientIMSI,
        _RecipientInfo_recipientMSISDN,
        _RecipientInfo_recipientOtherAddress,
        _RecipientInfo_recipientSCCPAddress,
        _RecipientInfo_recipientReceivedAddress,
        _RecipientInfo_sMDestinationInterface,
        _RecipientInfo_sMRecipientProtocolID,
        __RecipientInfo_recipientOtherAddresses__item_,
        _RecipientInfo_recipientOtherAddresses,
        RecipientInfo,
        _SMAddressDomain_sMDomainName,
        _SMAddressDomain_threeGPPIMSI_MCC_MNC,
        SMAddressDomain,
        _SMAddressInfo_sMAddressType,
        _SMAddressInfo_sMAddressData,
        _SMAddressInfo_sMAddressDomain,
        SMAddressInfo,
        SMAddressType,
        SMDeviceTriggerIndicator,
        _SMDeviceTriggerInformation_mTCIWFAddress,
        _SMDeviceTriggerInformation_sMDTReferenceNumber,
        _SMDeviceTriggerInformation_sMServingNode,
        _SMDeviceTriggerInformation_sMDTValidityPeriod,
        _SMDeviceTriggerInformation_sMDTPriorityIndication,
        _SMDeviceTriggerInformation_sMSApplicationPortID,
        SMDeviceTriggerInformation,
        SMDTPriorityIndication,
        _SMInterface_interfaceId,
        _SMInterface_interfaceText,
        _SMInterface_interfacePort,
        _SMInterface_interfaceType,
        SMInterface,
        SMInterfaceType,
        SMMessageType,
        _SMServingNode_sGSNName,
        _SMServingNode_sGSNRealm,
        _SMServingNode_sGSNNumber,
        _SMServingNode_mMEName,
        _SMServingNode_mMERealm,
        _SMServingNode_mMENumberForMTSMS,
        _SMServingNode_mSCNumber,
        _SMServingNode_iPSMGWNumber,
        _SMServingNode_iPSMGWName,
        SMServingNode,
        SMSStatus,
    ]

class SpkmGssTokens:

    _name_  = u'SpkmGssTokens'
    _oid_   = [1, 3, 6, 1, 5, 5, 1, 10]
    
    _obj_ = [
        u'SPKM-REQ',
        u'CertificationData',
        u'CertificationPath',
        u'REQ-TOKEN',
        u'Integrity',
        u'Req-contents',
        u'Random-Integer',
        u'Context-Data',
        u'ChannelId',
        u'Options',
        u'Conf-Algs',
        u'Intg-Algs',
        u'OWF-Algs',
        u'Key-Estb-Algs',
        u'SPKM-REP-TI',
        u'REP-TI-TOKEN',
        u'Rep-ti-contents',
        u'SPKM-REP-IT',
        u'REP-IT-TOKEN',
        u'SPKM-ERROR',
        u'ERROR-TOKEN',
        u'SPKM-MIC',
        u'Mic-Header',
        u'SeqNum',
        u'SPKM-WRAP',
        u'Wrap-Header',
        u'Wrap-Body',
        u'Conf-Alg',
        u'SPKM-DEL',
        u'Del-Header',
        u'MechType',
        u'InitialContextToken',
        u'SPKMInnerContextToken',
        u'AuthorizationData',
        u'md5-DES-CBC',
        u'sum64-DES-CBC',
        u'spkm-1',
        u'spkm-2',
        ]
    _type_ = [
        u'SPKM-REQ',
        u'CertificationData',
        u'CertificationPath',
        u'REQ-TOKEN',
        u'Integrity',
        u'Req-contents',
        u'Random-Integer',
        u'Context-Data',
        u'ChannelId',
        u'Options',
        u'Conf-Algs',
        u'Intg-Algs',
        u'OWF-Algs',
        u'Key-Estb-Algs',
        u'SPKM-REP-TI',
        u'REP-TI-TOKEN',
        u'Rep-ti-contents',
        u'SPKM-REP-IT',
        u'REP-IT-TOKEN',
        u'SPKM-ERROR',
        u'ERROR-TOKEN',
        u'SPKM-MIC',
        u'Mic-Header',
        u'SeqNum',
        u'SPKM-WRAP',
        u'Wrap-Header',
        u'Wrap-Body',
        u'Conf-Alg',
        u'SPKM-DEL',
        u'Del-Header',
        u'MechType',
        u'InitialContextToken',
        u'SPKMInnerContextToken',
        u'AuthorizationData',
        ]
    _set_ = [
        ]
    _val_ = [
        u'md5-DES-CBC',
        u'sum64-DES-CBC',
        u'spkm-1',
        u'spkm-2',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SPKM-REQ >-----#
    SPKM_REQ = SEQ(name=u'SPKM-REQ', mode=MODE_TYPE)
    _SPKM_REQ_requestToken = SEQ(name=u'requestToken', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'REQ-TOKEN')))
    _SPKM_REQ_certif_data = SEQ(name=u'certif-data', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'CertificationData')), opt=True)
    _SPKM_REQ_auth_data = SEQ_OF(name=u'auth-data', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'AuthorizationData')), opt=True)
    SPKM_REQ._cont = ASN1Dict([
        (u'requestToken', _SPKM_REQ_requestToken),
        (u'certif-data', _SPKM_REQ_certif_data),
        (u'auth-data', _SPKM_REQ_auth_data),
        ])
    SPKM_REQ._ext = None
    
    #-----< CertificationData >-----#
    CertificationData = SEQ(name=u'CertificationData', mode=MODE_TYPE)
    _CertificationData_certificationPath = SEQ(name=u'certificationPath', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'CertificationPath')), opt=True)
    _CertificationData_certificateRevocationList = SEQ(name=u'certificateRevocationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'CertificateList')), opt=True)
    CertificationData._cont = ASN1Dict([
        (u'certificationPath', _CertificationData_certificationPath),
        (u'certificateRevocationList', _CertificationData_certificateRevocationList),
        ])
    CertificationData._ext = None
    
    #-----< CertificationPath >-----#
    CertificationPath = SEQ(name=u'CertificationPath', mode=MODE_TYPE)
    _CertificationPath_userKeyId = OCT_STR(name=u'userKeyId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CertificationPath_userCertif = SEQ(name=u'userCertif', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')), opt=True)
    _CertificationPath_verifKeyId = OCT_STR(name=u'verifKeyId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CertificationPath_userVerifCertif = SEQ(name=u'userVerifCertif', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Certificate')), opt=True)
    _CertificationPath_theCACertificates = SEQ_OF(name=u'theCACertificates', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CertificationPath_theCACertificates__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'CertificatePair')))
    _CertificationPath_theCACertificates._cont = __CertificationPath_theCACertificates__item_
    CertificationPath._cont = ASN1Dict([
        (u'userKeyId', _CertificationPath_userKeyId),
        (u'userCertif', _CertificationPath_userCertif),
        (u'verifKeyId', _CertificationPath_verifKeyId),
        (u'userVerifCertif', _CertificationPath_userVerifCertif),
        (u'theCACertificates', _CertificationPath_theCACertificates),
        ])
    CertificationPath._ext = None
    
    #-----< REQ-TOKEN >-----#
    REQ_TOKEN = SEQ(name=u'REQ-TOKEN', mode=MODE_TYPE)
    _REQ_TOKEN_req_contents = SEQ(name=u'req-contents', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Req-contents')))
    _REQ_TOKEN_algId = SEQ(name=u'algId', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __REQ_TOKEN_algId_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___REQ_TOKEN_algId_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___REQ_TOKEN_algId_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __REQ_TOKEN_algId_algorithm._const_tab = ___REQ_TOKEN_algId_algorithm_tab
    __REQ_TOKEN_algId_algorithm._const_tab_at = None
    __REQ_TOKEN_algId_algorithm._const_tab_id = u'id'
    __REQ_TOKEN_algId_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___REQ_TOKEN_algId_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___REQ_TOKEN_algId_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __REQ_TOKEN_algId_parameters._const_tab = ___REQ_TOKEN_algId_parameters_tab
    __REQ_TOKEN_algId_parameters._const_tab_at = ('..', u'algorithm')
    __REQ_TOKEN_algId_parameters._const_tab_id = u'Type'
    _REQ_TOKEN_algId._cont = ASN1Dict([
        (u'algorithm', __REQ_TOKEN_algId_algorithm),
        (u'parameters', __REQ_TOKEN_algId_parameters),
        ])
    _REQ_TOKEN_algId._ext = []
    _REQ_TOKEN_req_integrity = BIT_STR(name=u'req-integrity', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Integrity')))
    REQ_TOKEN._cont = ASN1Dict([
        (u'req-contents', _REQ_TOKEN_req_contents),
        (u'algId', _REQ_TOKEN_algId),
        (u'req-integrity', _REQ_TOKEN_req_integrity),
        ])
    REQ_TOKEN._ext = None
    
    #-----< Integrity >-----#
    Integrity = BIT_STR(name=u'Integrity', mode=MODE_TYPE)
    
    #-----< Req-contents >-----#
    Req_contents = SEQ(name=u'Req-contents', mode=MODE_TYPE)
    _Req_contents_tok_id = INT(name=u'tok-id', mode=MODE_TYPE)
    _Req_contents_tok_id._const_val = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    _Req_contents_context_id = BIT_STR(name=u'context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Req_contents_pvno = BIT_STR(name=u'pvno', mode=MODE_TYPE)
    _Req_contents_timestamp = TIME_UTC(name=u'timestamp', mode=MODE_TYPE, opt=True)
    _Req_contents_randSrc = BIT_STR(name=u'randSrc', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Req_contents_targ_name = CHOICE(name=u'targ-name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _Req_contents_src_name = CHOICE(name=u'src-name', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _Req_contents_req_data = SEQ(name=u'req-data', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Context-Data')))
    _Req_contents_validity = SEQ(name=u'validity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Validity')), opt=True)
    _Req_contents_key_estb_set = SEQ_OF(name=u'key-estb-set', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Key-Estb-Algs')))
    _Req_contents_key_estb_req = BIT_STR(name=u'key-estb-req', mode=MODE_TYPE, opt=True)
    _Req_contents_key_src_bind = OCT_STR(name=u'key-src-bind', mode=MODE_TYPE, opt=True)
    Req_contents._cont = ASN1Dict([
        (u'tok-id', _Req_contents_tok_id),
        (u'context-id', _Req_contents_context_id),
        (u'pvno', _Req_contents_pvno),
        (u'timestamp', _Req_contents_timestamp),
        (u'randSrc', _Req_contents_randSrc),
        (u'targ-name', _Req_contents_targ_name),
        (u'src-name', _Req_contents_src_name),
        (u'req-data', _Req_contents_req_data),
        (u'validity', _Req_contents_validity),
        (u'key-estb-set', _Req_contents_key_estb_set),
        (u'key-estb-req', _Req_contents_key_estb_req),
        (u'key-src-bind', _Req_contents_key_src_bind),
        ])
    Req_contents._ext = None
    
    #-----< Random-Integer >-----#
    Random_Integer = BIT_STR(name=u'Random-Integer', mode=MODE_TYPE)
    
    #-----< Context-Data >-----#
    Context_Data = SEQ(name=u'Context-Data', mode=MODE_TYPE)
    _Context_Data_channelId = OCT_STR(name=u'channelId', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'ChannelId')), opt=True)
    _Context_Data_seq_number = INT(name=u'seq-number', mode=MODE_TYPE, opt=True)
    _Context_Data_options = BIT_STR(name=u'options', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Options')))
    _Context_Data_conf_alg = CHOICE(name=u'conf-alg', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Conf-Algs')))
    _Context_Data_intg_alg = SEQ_OF(name=u'intg-alg', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Intg-Algs')))
    _Context_Data_owf_alg = SEQ_OF(name=u'owf-alg', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'OWF-Algs')))
    Context_Data._cont = ASN1Dict([
        (u'channelId', _Context_Data_channelId),
        (u'seq-number', _Context_Data_seq_number),
        (u'options', _Context_Data_options),
        (u'conf-alg', _Context_Data_conf_alg),
        (u'intg-alg', _Context_Data_intg_alg),
        (u'owf-alg', _Context_Data_owf_alg),
        ])
    Context_Data._ext = None
    
    #-----< ChannelId >-----#
    ChannelId = OCT_STR(name=u'ChannelId', mode=MODE_TYPE)
    
    #-----< Options >-----#
    Options = BIT_STR(name=u'Options', mode=MODE_TYPE)
    Options._cont = ASN1Dict([(u'delegation-state', 0), (u'mutual-state', 1), (u'replay-det-state', 2), (u'sequence-state', 3), (u'conf-avail', 4), (u'integ-avail', 5), (u'target-certif-data-required', 6)])
    
    #-----< Conf-Algs >-----#
    Conf_Algs = CHOICE(name=u'Conf-Algs', mode=MODE_TYPE)
    _Conf_Algs_algs = SEQ_OF(name=u'algs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Conf_Algs_algs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    ___Conf_Algs_algs__item__algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ____Conf_Algs_algs__item__algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____Conf_Algs_algs__item__algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Conf_Algs_algs__item__algorithm._const_tab = ____Conf_Algs_algs__item__algorithm_tab
    ___Conf_Algs_algs__item__algorithm._const_tab_at = None
    ___Conf_Algs_algs__item__algorithm._const_tab_id = u'id'
    ___Conf_Algs_algs__item__parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ____Conf_Algs_algs__item__parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ____Conf_Algs_algs__item__parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Conf_Algs_algs__item__parameters._const_tab = ____Conf_Algs_algs__item__parameters_tab
    ___Conf_Algs_algs__item__parameters._const_tab_at = ('..', u'algorithm')
    ___Conf_Algs_algs__item__parameters._const_tab_id = u'Type'
    __Conf_Algs_algs__item_._cont = ASN1Dict([
        (u'algorithm', ___Conf_Algs_algs__item__algorithm),
        (u'parameters', ___Conf_Algs_algs__item__parameters),
        ])
    __Conf_Algs_algs__item_._ext = []
    _Conf_Algs_algs._cont = __Conf_Algs_algs__item_
    _Conf_Algs_null = NULL(name=u'null', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Conf_Algs._cont = ASN1Dict([
        (u'algs', _Conf_Algs_algs),
        (u'null', _Conf_Algs_null),
        ])
    Conf_Algs._ext = None
    
    #-----< Intg-Algs >-----#
    Intg_Algs = SEQ_OF(name=u'Intg-Algs', mode=MODE_TYPE)
    _Intg_Algs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __Intg_Algs__item__algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___Intg_Algs__item__algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Intg_Algs__item__algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Intg_Algs__item__algorithm._const_tab = ___Intg_Algs__item__algorithm_tab
    __Intg_Algs__item__algorithm._const_tab_at = None
    __Intg_Algs__item__algorithm._const_tab_id = u'id'
    __Intg_Algs__item__parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___Intg_Algs__item__parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Intg_Algs__item__parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Intg_Algs__item__parameters._const_tab = ___Intg_Algs__item__parameters_tab
    __Intg_Algs__item__parameters._const_tab_at = ('..', u'algorithm')
    __Intg_Algs__item__parameters._const_tab_id = u'Type'
    _Intg_Algs__item_._cont = ASN1Dict([
        (u'algorithm', __Intg_Algs__item__algorithm),
        (u'parameters', __Intg_Algs__item__parameters),
        ])
    _Intg_Algs__item_._ext = []
    Intg_Algs._cont = _Intg_Algs__item_
    
    #-----< OWF-Algs >-----#
    OWF_Algs = SEQ_OF(name=u'OWF-Algs', mode=MODE_TYPE)
    _OWF_Algs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __OWF_Algs__item__algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___OWF_Algs__item__algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___OWF_Algs__item__algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __OWF_Algs__item__algorithm._const_tab = ___OWF_Algs__item__algorithm_tab
    __OWF_Algs__item__algorithm._const_tab_at = None
    __OWF_Algs__item__algorithm._const_tab_id = u'id'
    __OWF_Algs__item__parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___OWF_Algs__item__parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___OWF_Algs__item__parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __OWF_Algs__item__parameters._const_tab = ___OWF_Algs__item__parameters_tab
    __OWF_Algs__item__parameters._const_tab_at = ('..', u'algorithm')
    __OWF_Algs__item__parameters._const_tab_id = u'Type'
    _OWF_Algs__item_._cont = ASN1Dict([
        (u'algorithm', __OWF_Algs__item__algorithm),
        (u'parameters', __OWF_Algs__item__parameters),
        ])
    _OWF_Algs__item_._ext = []
    OWF_Algs._cont = _OWF_Algs__item_
    
    #-----< Key-Estb-Algs >-----#
    Key_Estb_Algs = SEQ_OF(name=u'Key-Estb-Algs', mode=MODE_TYPE)
    _Key_Estb_Algs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __Key_Estb_Algs__item__algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___Key_Estb_Algs__item__algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Key_Estb_Algs__item__algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Key_Estb_Algs__item__algorithm._const_tab = ___Key_Estb_Algs__item__algorithm_tab
    __Key_Estb_Algs__item__algorithm._const_tab_at = None
    __Key_Estb_Algs__item__algorithm._const_tab_id = u'id'
    __Key_Estb_Algs__item__parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___Key_Estb_Algs__item__parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Key_Estb_Algs__item__parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Key_Estb_Algs__item__parameters._const_tab = ___Key_Estb_Algs__item__parameters_tab
    __Key_Estb_Algs__item__parameters._const_tab_at = ('..', u'algorithm')
    __Key_Estb_Algs__item__parameters._const_tab_id = u'Type'
    _Key_Estb_Algs__item_._cont = ASN1Dict([
        (u'algorithm', __Key_Estb_Algs__item__algorithm),
        (u'parameters', __Key_Estb_Algs__item__parameters),
        ])
    _Key_Estb_Algs__item_._ext = []
    Key_Estb_Algs._cont = _Key_Estb_Algs__item_
    
    #-----< SPKM-REP-TI >-----#
    SPKM_REP_TI = SEQ(name=u'SPKM-REP-TI', mode=MODE_TYPE)
    _SPKM_REP_TI_responseToken = SEQ(name=u'responseToken', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'REP-TI-TOKEN')))
    _SPKM_REP_TI_certif_data = SEQ(name=u'certif-data', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'CertificationData')), opt=True)
    SPKM_REP_TI._cont = ASN1Dict([
        (u'responseToken', _SPKM_REP_TI_responseToken),
        (u'certif-data', _SPKM_REP_TI_certif_data),
        ])
    SPKM_REP_TI._ext = None
    
    #-----< REP-TI-TOKEN >-----#
    REP_TI_TOKEN = SEQ(name=u'REP-TI-TOKEN', mode=MODE_TYPE)
    _REP_TI_TOKEN_rep_ti_contents = SEQ(name=u'rep-ti-contents', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Rep-ti-contents')))
    _REP_TI_TOKEN_algId = SEQ(name=u'algId', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __REP_TI_TOKEN_algId_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___REP_TI_TOKEN_algId_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___REP_TI_TOKEN_algId_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __REP_TI_TOKEN_algId_algorithm._const_tab = ___REP_TI_TOKEN_algId_algorithm_tab
    __REP_TI_TOKEN_algId_algorithm._const_tab_at = None
    __REP_TI_TOKEN_algId_algorithm._const_tab_id = u'id'
    __REP_TI_TOKEN_algId_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___REP_TI_TOKEN_algId_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___REP_TI_TOKEN_algId_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __REP_TI_TOKEN_algId_parameters._const_tab = ___REP_TI_TOKEN_algId_parameters_tab
    __REP_TI_TOKEN_algId_parameters._const_tab_at = ('..', u'algorithm')
    __REP_TI_TOKEN_algId_parameters._const_tab_id = u'Type'
    _REP_TI_TOKEN_algId._cont = ASN1Dict([
        (u'algorithm', __REP_TI_TOKEN_algId_algorithm),
        (u'parameters', __REP_TI_TOKEN_algId_parameters),
        ])
    _REP_TI_TOKEN_algId._ext = []
    _REP_TI_TOKEN_rep_ti_integ = BIT_STR(name=u'rep-ti-integ', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Integrity')))
    REP_TI_TOKEN._cont = ASN1Dict([
        (u'rep-ti-contents', _REP_TI_TOKEN_rep_ti_contents),
        (u'algId', _REP_TI_TOKEN_algId),
        (u'rep-ti-integ', _REP_TI_TOKEN_rep_ti_integ),
        ])
    REP_TI_TOKEN._ext = None
    
    #-----< Rep-ti-contents >-----#
    Rep_ti_contents = SEQ(name=u'Rep-ti-contents', mode=MODE_TYPE)
    _Rep_ti_contents_tok_id = INT(name=u'tok-id', mode=MODE_TYPE)
    _Rep_ti_contents_tok_id._const_val = ASN1Set(rv=[512], rr=[], ev=None, er=[])
    _Rep_ti_contents_context_id = BIT_STR(name=u'context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Rep_ti_contents_pvno = BIT_STR(name=u'pvno', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Rep_ti_contents_timestamp = TIME_UTC(name=u'timestamp', mode=MODE_TYPE, opt=True)
    _Rep_ti_contents_randTarg = BIT_STR(name=u'randTarg', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Rep_ti_contents_src_name = CHOICE(name=u'src-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _Rep_ti_contents_targ_name = CHOICE(name=u'targ-name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _Rep_ti_contents_randSrc = BIT_STR(name=u'randSrc', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Rep_ti_contents_rep_data = SEQ(name=u'rep-data', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Context-Data')))
    _Rep_ti_contents_validity = SEQ(name=u'validity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'Validity')), opt=True)
    _Rep_ti_contents_key_estb_id = SEQ(name=u'key-estb-id', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')), opt=True)
    __Rep_ti_contents_key_estb_id_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___Rep_ti_contents_key_estb_id_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Rep_ti_contents_key_estb_id_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Rep_ti_contents_key_estb_id_algorithm._const_tab = ___Rep_ti_contents_key_estb_id_algorithm_tab
    __Rep_ti_contents_key_estb_id_algorithm._const_tab_at = None
    __Rep_ti_contents_key_estb_id_algorithm._const_tab_id = u'id'
    __Rep_ti_contents_key_estb_id_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___Rep_ti_contents_key_estb_id_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Rep_ti_contents_key_estb_id_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Rep_ti_contents_key_estb_id_parameters._const_tab = ___Rep_ti_contents_key_estb_id_parameters_tab
    __Rep_ti_contents_key_estb_id_parameters._const_tab_at = ('..', u'algorithm')
    __Rep_ti_contents_key_estb_id_parameters._const_tab_id = u'Type'
    _Rep_ti_contents_key_estb_id._cont = ASN1Dict([
        (u'algorithm', __Rep_ti_contents_key_estb_id_algorithm),
        (u'parameters', __Rep_ti_contents_key_estb_id_parameters),
        ])
    _Rep_ti_contents_key_estb_id._ext = []
    _Rep_ti_contents_key_estb_str = BIT_STR(name=u'key-estb-str', mode=MODE_TYPE, opt=True)
    Rep_ti_contents._cont = ASN1Dict([
        (u'tok-id', _Rep_ti_contents_tok_id),
        (u'context-id', _Rep_ti_contents_context_id),
        (u'pvno', _Rep_ti_contents_pvno),
        (u'timestamp', _Rep_ti_contents_timestamp),
        (u'randTarg', _Rep_ti_contents_randTarg),
        (u'src-name', _Rep_ti_contents_src_name),
        (u'targ-name', _Rep_ti_contents_targ_name),
        (u'randSrc', _Rep_ti_contents_randSrc),
        (u'rep-data', _Rep_ti_contents_rep_data),
        (u'validity', _Rep_ti_contents_validity),
        (u'key-estb-id', _Rep_ti_contents_key_estb_id),
        (u'key-estb-str', _Rep_ti_contents_key_estb_str),
        ])
    Rep_ti_contents._ext = None
    
    #-----< SPKM-REP-IT >-----#
    SPKM_REP_IT = SEQ(name=u'SPKM-REP-IT', mode=MODE_TYPE)
    _SPKM_REP_IT_responseToken = SEQ(name=u'responseToken', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'REP-IT-TOKEN')))
    _SPKM_REP_IT_algId = SEQ(name=u'algId', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SPKM_REP_IT_algId_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___SPKM_REP_IT_algId_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SPKM_REP_IT_algId_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SPKM_REP_IT_algId_algorithm._const_tab = ___SPKM_REP_IT_algId_algorithm_tab
    __SPKM_REP_IT_algId_algorithm._const_tab_at = None
    __SPKM_REP_IT_algId_algorithm._const_tab_id = u'id'
    __SPKM_REP_IT_algId_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___SPKM_REP_IT_algId_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SPKM_REP_IT_algId_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SPKM_REP_IT_algId_parameters._const_tab = ___SPKM_REP_IT_algId_parameters_tab
    __SPKM_REP_IT_algId_parameters._const_tab_at = ('..', u'algorithm')
    __SPKM_REP_IT_algId_parameters._const_tab_id = u'Type'
    _SPKM_REP_IT_algId._cont = ASN1Dict([
        (u'algorithm', __SPKM_REP_IT_algId_algorithm),
        (u'parameters', __SPKM_REP_IT_algId_parameters),
        ])
    _SPKM_REP_IT_algId._ext = []
    _SPKM_REP_IT_rep_it_integ = BIT_STR(name=u'rep-it-integ', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Integrity')))
    SPKM_REP_IT._cont = ASN1Dict([
        (u'responseToken', _SPKM_REP_IT_responseToken),
        (u'algId', _SPKM_REP_IT_algId),
        (u'rep-it-integ', _SPKM_REP_IT_rep_it_integ),
        ])
    SPKM_REP_IT._ext = None
    
    #-----< REP-IT-TOKEN >-----#
    REP_IT_TOKEN = SEQ(name=u'REP-IT-TOKEN', mode=MODE_TYPE)
    _REP_IT_TOKEN_tok_id = INT(name=u'tok-id', mode=MODE_TYPE)
    _REP_IT_TOKEN_tok_id._const_val = ASN1Set(rv=[768], rr=[], ev=None, er=[])
    _REP_IT_TOKEN_context_id = BIT_STR(name=u'context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _REP_IT_TOKEN_randSrc = BIT_STR(name=u'randSrc', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _REP_IT_TOKEN_randTarg = BIT_STR(name=u'randTarg', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _REP_IT_TOKEN_targ_name = CHOICE(name=u'targ-name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')))
    _REP_IT_TOKEN_src_name = CHOICE(name=u'src-name', mode=MODE_TYPE, typeref=ASN1RefType(('InformationFramework', 'Name')), opt=True)
    _REP_IT_TOKEN_key_estb_rep = BIT_STR(name=u'key-estb-rep', mode=MODE_TYPE, opt=True)
    REP_IT_TOKEN._cont = ASN1Dict([
        (u'tok-id', _REP_IT_TOKEN_tok_id),
        (u'context-id', _REP_IT_TOKEN_context_id),
        (u'randSrc', _REP_IT_TOKEN_randSrc),
        (u'randTarg', _REP_IT_TOKEN_randTarg),
        (u'targ-name', _REP_IT_TOKEN_targ_name),
        (u'src-name', _REP_IT_TOKEN_src_name),
        (u'key-estb-rep', _REP_IT_TOKEN_key_estb_rep),
        ])
    REP_IT_TOKEN._ext = None
    
    #-----< SPKM-ERROR >-----#
    SPKM_ERROR = SEQ(name=u'SPKM-ERROR', mode=MODE_TYPE)
    _SPKM_ERROR_errorToken = SEQ(name=u'errorToken', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'ERROR-TOKEN')))
    _SPKM_ERROR_algId = SEQ(name=u'algId', mode=MODE_TYPE, typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __SPKM_ERROR_algId_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___SPKM_ERROR_algId_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SPKM_ERROR_algId_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SPKM_ERROR_algId_algorithm._const_tab = ___SPKM_ERROR_algId_algorithm_tab
    __SPKM_ERROR_algId_algorithm._const_tab_at = None
    __SPKM_ERROR_algId_algorithm._const_tab_id = u'id'
    __SPKM_ERROR_algId_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___SPKM_ERROR_algId_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___SPKM_ERROR_algId_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __SPKM_ERROR_algId_parameters._const_tab = ___SPKM_ERROR_algId_parameters_tab
    __SPKM_ERROR_algId_parameters._const_tab_at = ('..', u'algorithm')
    __SPKM_ERROR_algId_parameters._const_tab_id = u'Type'
    _SPKM_ERROR_algId._cont = ASN1Dict([
        (u'algorithm', __SPKM_ERROR_algId_algorithm),
        (u'parameters', __SPKM_ERROR_algId_parameters),
        ])
    _SPKM_ERROR_algId._ext = []
    _SPKM_ERROR_integrity = BIT_STR(name=u'integrity', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Integrity')))
    SPKM_ERROR._cont = ASN1Dict([
        (u'errorToken', _SPKM_ERROR_errorToken),
        (u'algId', _SPKM_ERROR_algId),
        (u'integrity', _SPKM_ERROR_integrity),
        ])
    SPKM_ERROR._ext = None
    
    #-----< ERROR-TOKEN >-----#
    ERROR_TOKEN = SEQ(name=u'ERROR-TOKEN', mode=MODE_TYPE)
    _ERROR_TOKEN_tok_id = INT(name=u'tok-id', mode=MODE_TYPE)
    _ERROR_TOKEN_tok_id._const_val = ASN1Set(rv=[1024], rr=[], ev=None, er=[])
    _ERROR_TOKEN_context_id = BIT_STR(name=u'context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    ERROR_TOKEN._cont = ASN1Dict([
        (u'tok-id', _ERROR_TOKEN_tok_id),
        (u'context-id', _ERROR_TOKEN_context_id),
        ])
    ERROR_TOKEN._ext = None
    
    #-----< SPKM-MIC >-----#
    SPKM_MIC = SEQ(name=u'SPKM-MIC', mode=MODE_TYPE)
    _SPKM_MIC_mic_header = SEQ(name=u'mic-header', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Mic-Header')))
    _SPKM_MIC_int_cksum = BIT_STR(name=u'int-cksum', mode=MODE_TYPE)
    SPKM_MIC._cont = ASN1Dict([
        (u'mic-header', _SPKM_MIC_mic_header),
        (u'int-cksum', _SPKM_MIC_int_cksum),
        ])
    SPKM_MIC._ext = None
    
    #-----< Mic-Header >-----#
    Mic_Header = SEQ(name=u'Mic-Header', mode=MODE_TYPE)
    _Mic_Header_tok_id = INT(name=u'tok-id', mode=MODE_TYPE)
    _Mic_Header_tok_id._const_val = ASN1Set(rv=[257], rr=[], ev=None, er=[])
    _Mic_Header_context_id = BIT_STR(name=u'context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Mic_Header_int_alg = SEQ(name=u'int-alg', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')), opt=True)
    __Mic_Header_int_alg_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___Mic_Header_int_alg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Mic_Header_int_alg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Mic_Header_int_alg_algorithm._const_tab = ___Mic_Header_int_alg_algorithm_tab
    __Mic_Header_int_alg_algorithm._const_tab_at = None
    __Mic_Header_int_alg_algorithm._const_tab_id = u'id'
    __Mic_Header_int_alg_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___Mic_Header_int_alg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Mic_Header_int_alg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Mic_Header_int_alg_parameters._const_tab = ___Mic_Header_int_alg_parameters_tab
    __Mic_Header_int_alg_parameters._const_tab_at = ('..', u'algorithm')
    __Mic_Header_int_alg_parameters._const_tab_id = u'Type'
    _Mic_Header_int_alg._cont = ASN1Dict([
        (u'algorithm', __Mic_Header_int_alg_algorithm),
        (u'parameters', __Mic_Header_int_alg_parameters),
        ])
    _Mic_Header_int_alg._ext = []
    _Mic_Header_snd_seq = SEQ(name=u'snd-seq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SeqNum')), opt=True)
    Mic_Header._cont = ASN1Dict([
        (u'tok-id', _Mic_Header_tok_id),
        (u'context-id', _Mic_Header_context_id),
        (u'int-alg', _Mic_Header_int_alg),
        (u'snd-seq', _Mic_Header_snd_seq),
        ])
    Mic_Header._ext = None
    
    #-----< SeqNum >-----#
    SeqNum = SEQ(name=u'SeqNum', mode=MODE_TYPE)
    _SeqNum_num = INT(name=u'num', mode=MODE_TYPE)
    _SeqNum_dir_ind = BOOL(name=u'dir-ind', mode=MODE_TYPE)
    SeqNum._cont = ASN1Dict([
        (u'num', _SeqNum_num),
        (u'dir-ind', _SeqNum_dir_ind),
        ])
    SeqNum._ext = None
    
    #-----< SPKM-WRAP >-----#
    SPKM_WRAP = SEQ(name=u'SPKM-WRAP', mode=MODE_TYPE)
    _SPKM_WRAP_wrap_header = SEQ(name=u'wrap-header', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Wrap-Header')))
    _SPKM_WRAP_wrap_body = SEQ(name=u'wrap-body', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Wrap-Body')))
    SPKM_WRAP._cont = ASN1Dict([
        (u'wrap-header', _SPKM_WRAP_wrap_header),
        (u'wrap-body', _SPKM_WRAP_wrap_body),
        ])
    SPKM_WRAP._ext = None
    
    #-----< Wrap-Header >-----#
    Wrap_Header = SEQ(name=u'Wrap-Header', mode=MODE_TYPE)
    _Wrap_Header_tok_id = INT(name=u'tok-id', mode=MODE_TYPE)
    _Wrap_Header_tok_id._const_val = ASN1Set(rv=[513], rr=[], ev=None, er=[])
    _Wrap_Header_context_id = BIT_STR(name=u'context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Wrap_Header_int_alg = SEQ(name=u'int-alg', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')), opt=True)
    __Wrap_Header_int_alg_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___Wrap_Header_int_alg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Wrap_Header_int_alg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Wrap_Header_int_alg_algorithm._const_tab = ___Wrap_Header_int_alg_algorithm_tab
    __Wrap_Header_int_alg_algorithm._const_tab_at = None
    __Wrap_Header_int_alg_algorithm._const_tab_id = u'id'
    __Wrap_Header_int_alg_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___Wrap_Header_int_alg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Wrap_Header_int_alg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Wrap_Header_int_alg_parameters._const_tab = ___Wrap_Header_int_alg_parameters_tab
    __Wrap_Header_int_alg_parameters._const_tab_at = ('..', u'algorithm')
    __Wrap_Header_int_alg_parameters._const_tab_id = u'Type'
    _Wrap_Header_int_alg._cont = ASN1Dict([
        (u'algorithm', __Wrap_Header_int_alg_algorithm),
        (u'parameters', __Wrap_Header_int_alg_parameters),
        ])
    _Wrap_Header_int_alg._ext = []
    _Wrap_Header_conf_alg = CHOICE(name=u'conf-alg', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'Conf-Alg')), opt=True)
    _Wrap_Header_snd_seq = SEQ(name=u'snd-seq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SeqNum')), opt=True)
    Wrap_Header._cont = ASN1Dict([
        (u'tok-id', _Wrap_Header_tok_id),
        (u'context-id', _Wrap_Header_context_id),
        (u'int-alg', _Wrap_Header_int_alg),
        (u'conf-alg', _Wrap_Header_conf_alg),
        (u'snd-seq', _Wrap_Header_snd_seq),
        ])
    Wrap_Header._ext = None
    
    #-----< Wrap-Body >-----#
    Wrap_Body = SEQ(name=u'Wrap-Body', mode=MODE_TYPE)
    _Wrap_Body_int_cksum = BIT_STR(name=u'int-cksum', mode=MODE_TYPE)
    _Wrap_Body_data = BIT_STR(name=u'data', mode=MODE_TYPE)
    Wrap_Body._cont = ASN1Dict([
        (u'int-cksum', _Wrap_Body_int_cksum),
        (u'data', _Wrap_Body_data),
        ])
    Wrap_Body._ext = None
    
    #-----< Conf-Alg >-----#
    Conf_Alg = CHOICE(name=u'Conf-Alg', mode=MODE_TYPE)
    _Conf_Alg_algId = SEQ(name=u'algId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')))
    __Conf_Alg_algId_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___Conf_Alg_algId_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Conf_Alg_algId_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Conf_Alg_algId_algorithm._const_tab = ___Conf_Alg_algId_algorithm_tab
    __Conf_Alg_algId_algorithm._const_tab_at = None
    __Conf_Alg_algId_algorithm._const_tab_id = u'id'
    __Conf_Alg_algId_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___Conf_Alg_algId_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Conf_Alg_algId_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Conf_Alg_algId_parameters._const_tab = ___Conf_Alg_algId_parameters_tab
    __Conf_Alg_algId_parameters._const_tab_at = ('..', u'algorithm')
    __Conf_Alg_algId_parameters._const_tab_id = u'Type'
    _Conf_Alg_algId._cont = ASN1Dict([
        (u'algorithm', __Conf_Alg_algId_algorithm),
        (u'parameters', __Conf_Alg_algId_parameters),
        ])
    _Conf_Alg_algId._ext = []
    _Conf_Alg_null = NULL(name=u'null', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    Conf_Alg._cont = ASN1Dict([
        (u'algId', _Conf_Alg_algId),
        (u'null', _Conf_Alg_null),
        ])
    Conf_Alg._ext = None
    
    #-----< SPKM-DEL >-----#
    SPKM_DEL = SEQ(name=u'SPKM-DEL', mode=MODE_TYPE)
    _SPKM_DEL_del_header = SEQ(name=u'del-header', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Del-Header')))
    _SPKM_DEL_int_cksum = BIT_STR(name=u'int-cksum', mode=MODE_TYPE)
    SPKM_DEL._cont = ASN1Dict([
        (u'del-header', _SPKM_DEL_del_header),
        (u'int-cksum', _SPKM_DEL_int_cksum),
        ])
    SPKM_DEL._ext = None
    
    #-----< Del-Header >-----#
    Del_Header = SEQ(name=u'Del-Header', mode=MODE_TYPE)
    _Del_Header_tok_id = INT(name=u'tok-id', mode=MODE_TYPE)
    _Del_Header_tok_id._const_val = ASN1Set(rv=[769], rr=[], ev=None, er=[])
    _Del_Header_context_id = BIT_STR(name=u'context-id', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'Random-Integer')))
    _Del_Header_int_alg = SEQ(name=u'int-alg', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AuthenticationFramework', 'AlgorithmIdentifier')), opt=True)
    __Del_Header_int_alg_algorithm = OID(name=u'algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'id']))
    ___Del_Header_int_alg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Del_Header_int_alg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Del_Header_int_alg_algorithm._const_tab = ___Del_Header_int_alg_algorithm_tab
    __Del_Header_int_alg_algorithm._const_tab_at = None
    __Del_Header_int_alg_algorithm._const_tab_id = u'id'
    __Del_Header_int_alg_parameters = OPEN(name=u'parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AuthenticationFramework', 'ALGORITHM'), [u'Type']), opt=True)
    ___Del_Header_int_alg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AuthenticationFramework', 'ALGORITHM')))
    ___Del_Header_int_alg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Del_Header_int_alg_parameters._const_tab = ___Del_Header_int_alg_parameters_tab
    __Del_Header_int_alg_parameters._const_tab_at = ('..', u'algorithm')
    __Del_Header_int_alg_parameters._const_tab_id = u'Type'
    _Del_Header_int_alg._cont = ASN1Dict([
        (u'algorithm', __Del_Header_int_alg_algorithm),
        (u'parameters', __Del_Header_int_alg_parameters),
        ])
    _Del_Header_int_alg._ext = []
    _Del_Header_snd_seq = SEQ(name=u'snd-seq', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SeqNum')), opt=True)
    Del_Header._cont = ASN1Dict([
        (u'tok-id', _Del_Header_tok_id),
        (u'context-id', _Del_Header_context_id),
        (u'int-alg', _Del_Header_int_alg),
        (u'snd-seq', _Del_Header_snd_seq),
        ])
    Del_Header._ext = None
    
    #-----< MechType >-----#
    MechType = OID(name=u'MechType', mode=MODE_TYPE)
    
    #-----< InitialContextToken >-----#
    InitialContextToken = SEQ(name=u'InitialContextToken', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _InitialContextToken_thisMech = OID(name=u'thisMech', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'MechType')))
    _InitialContextToken_innerContextToken = CHOICE(name=u'innerContextToken', mode=MODE_TYPE, typeref=ASN1RefType(('SpkmGssTokens', 'SPKMInnerContextToken')))
    InitialContextToken._cont = ASN1Dict([
        (u'thisMech', _InitialContextToken_thisMech),
        (u'innerContextToken', _InitialContextToken_innerContextToken),
        ])
    InitialContextToken._ext = None
    
    #-----< SPKMInnerContextToken >-----#
    SPKMInnerContextToken = CHOICE(name=u'SPKMInnerContextToken', mode=MODE_TYPE)
    _SPKMInnerContextToken_req = SEQ(name=u'req', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-REQ')))
    _SPKMInnerContextToken_rep_ti = SEQ(name=u'rep-ti', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-REP-TI')))
    _SPKMInnerContextToken_rep_it = SEQ(name=u'rep-it', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-REP-IT')))
    _SPKMInnerContextToken_error = SEQ(name=u'error', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-ERROR')))
    _SPKMInnerContextToken_mic = SEQ(name=u'mic', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-MIC')))
    _SPKMInnerContextToken_wrap = SEQ(name=u'wrap', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-WRAP')))
    _SPKMInnerContextToken_del_ = SEQ(name=u'del', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SpkmGssTokens', 'SPKM-DEL')))
    SPKMInnerContextToken._cont = ASN1Dict([
        (u'req', _SPKMInnerContextToken_req),
        (u'rep-ti', _SPKMInnerContextToken_rep_ti),
        (u'rep-it', _SPKMInnerContextToken_rep_it),
        (u'error', _SPKMInnerContextToken_error),
        (u'mic', _SPKMInnerContextToken_mic),
        (u'wrap', _SPKMInnerContextToken_wrap),
        (u'del', _SPKMInnerContextToken_del_),
        ])
    SPKMInnerContextToken._ext = None
    
    #-----< AuthorizationData >-----#
    AuthorizationData = SEQ_OF(name=u'AuthorizationData', mode=MODE_TYPE)
    _AuthorizationData__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __AuthorizationData__item__ad_type = INT(name=u'ad-type', mode=MODE_TYPE)
    __AuthorizationData__item__ad_data = OCT_STR(name=u'ad-data', mode=MODE_TYPE)
    _AuthorizationData__item_._cont = ASN1Dict([
        (u'ad-type', __AuthorizationData__item__ad_type),
        (u'ad-data', __AuthorizationData__item__ad_data),
        ])
    _AuthorizationData__item_._ext = None
    AuthorizationData._cont = _AuthorizationData__item_
    
    #-----< md5-DES-CBC >-----#
    md5_DES_CBC = OID(name=u'md5-DES-CBC', mode=MODE_VALUE)
    md5_DES_CBC._val = (1, 3, 6, 1, 5, 3, 1)
    
    #-----< sum64-DES-CBC >-----#
    sum64_DES_CBC = OID(name=u'sum64-DES-CBC', mode=MODE_VALUE)
    sum64_DES_CBC._val = (1, 3, 6, 1, 5, 3, 2)
    
    #-----< spkm-1 >-----#
    spkm_1 = OID(name=u'spkm-1', mode=MODE_VALUE)
    spkm_1._val = (1, 3, 6, 1, 5, 5, 1, 1)
    
    #-----< spkm-2 >-----#
    spkm_2 = OID(name=u'spkm-2', mode=MODE_VALUE)
    spkm_2._val = (1, 3, 6, 1, 5, 5, 1, 2)
    
    _all_ = [
        _SPKM_REQ_requestToken,
        _SPKM_REQ_certif_data,
        _SPKM_REQ_auth_data,
        SPKM_REQ,
        _CertificationData_certificationPath,
        _CertificationData_certificateRevocationList,
        CertificationData,
        _CertificationPath_userKeyId,
        _CertificationPath_userCertif,
        _CertificationPath_verifKeyId,
        _CertificationPath_userVerifCertif,
        __CertificationPath_theCACertificates__item_,
        _CertificationPath_theCACertificates,
        CertificationPath,
        _REQ_TOKEN_req_contents,
        ___REQ_TOKEN_algId_algorithm_tab,
        __REQ_TOKEN_algId_algorithm,
        ___REQ_TOKEN_algId_parameters_tab,
        __REQ_TOKEN_algId_parameters,
        _REQ_TOKEN_algId,
        _REQ_TOKEN_req_integrity,
        REQ_TOKEN,
        Integrity,
        _Req_contents_tok_id,
        _Req_contents_context_id,
        _Req_contents_pvno,
        _Req_contents_timestamp,
        _Req_contents_randSrc,
        _Req_contents_targ_name,
        _Req_contents_src_name,
        _Req_contents_req_data,
        _Req_contents_validity,
        _Req_contents_key_estb_set,
        _Req_contents_key_estb_req,
        _Req_contents_key_src_bind,
        Req_contents,
        Random_Integer,
        _Context_Data_channelId,
        _Context_Data_seq_number,
        _Context_Data_options,
        _Context_Data_conf_alg,
        _Context_Data_intg_alg,
        _Context_Data_owf_alg,
        Context_Data,
        ChannelId,
        Options,
        ____Conf_Algs_algs__item__algorithm_tab,
        ___Conf_Algs_algs__item__algorithm,
        ____Conf_Algs_algs__item__parameters_tab,
        ___Conf_Algs_algs__item__parameters,
        __Conf_Algs_algs__item_,
        _Conf_Algs_algs,
        _Conf_Algs_null,
        Conf_Algs,
        ___Intg_Algs__item__algorithm_tab,
        __Intg_Algs__item__algorithm,
        ___Intg_Algs__item__parameters_tab,
        __Intg_Algs__item__parameters,
        _Intg_Algs__item_,
        Intg_Algs,
        ___OWF_Algs__item__algorithm_tab,
        __OWF_Algs__item__algorithm,
        ___OWF_Algs__item__parameters_tab,
        __OWF_Algs__item__parameters,
        _OWF_Algs__item_,
        OWF_Algs,
        ___Key_Estb_Algs__item__algorithm_tab,
        __Key_Estb_Algs__item__algorithm,
        ___Key_Estb_Algs__item__parameters_tab,
        __Key_Estb_Algs__item__parameters,
        _Key_Estb_Algs__item_,
        Key_Estb_Algs,
        _SPKM_REP_TI_responseToken,
        _SPKM_REP_TI_certif_data,
        SPKM_REP_TI,
        _REP_TI_TOKEN_rep_ti_contents,
        ___REP_TI_TOKEN_algId_algorithm_tab,
        __REP_TI_TOKEN_algId_algorithm,
        ___REP_TI_TOKEN_algId_parameters_tab,
        __REP_TI_TOKEN_algId_parameters,
        _REP_TI_TOKEN_algId,
        _REP_TI_TOKEN_rep_ti_integ,
        REP_TI_TOKEN,
        _Rep_ti_contents_tok_id,
        _Rep_ti_contents_context_id,
        _Rep_ti_contents_pvno,
        _Rep_ti_contents_timestamp,
        _Rep_ti_contents_randTarg,
        _Rep_ti_contents_src_name,
        _Rep_ti_contents_targ_name,
        _Rep_ti_contents_randSrc,
        _Rep_ti_contents_rep_data,
        _Rep_ti_contents_validity,
        ___Rep_ti_contents_key_estb_id_algorithm_tab,
        __Rep_ti_contents_key_estb_id_algorithm,
        ___Rep_ti_contents_key_estb_id_parameters_tab,
        __Rep_ti_contents_key_estb_id_parameters,
        _Rep_ti_contents_key_estb_id,
        _Rep_ti_contents_key_estb_str,
        Rep_ti_contents,
        _SPKM_REP_IT_responseToken,
        ___SPKM_REP_IT_algId_algorithm_tab,
        __SPKM_REP_IT_algId_algorithm,
        ___SPKM_REP_IT_algId_parameters_tab,
        __SPKM_REP_IT_algId_parameters,
        _SPKM_REP_IT_algId,
        _SPKM_REP_IT_rep_it_integ,
        SPKM_REP_IT,
        _REP_IT_TOKEN_tok_id,
        _REP_IT_TOKEN_context_id,
        _REP_IT_TOKEN_randSrc,
        _REP_IT_TOKEN_randTarg,
        _REP_IT_TOKEN_targ_name,
        _REP_IT_TOKEN_src_name,
        _REP_IT_TOKEN_key_estb_rep,
        REP_IT_TOKEN,
        _SPKM_ERROR_errorToken,
        ___SPKM_ERROR_algId_algorithm_tab,
        __SPKM_ERROR_algId_algorithm,
        ___SPKM_ERROR_algId_parameters_tab,
        __SPKM_ERROR_algId_parameters,
        _SPKM_ERROR_algId,
        _SPKM_ERROR_integrity,
        SPKM_ERROR,
        _ERROR_TOKEN_tok_id,
        _ERROR_TOKEN_context_id,
        ERROR_TOKEN,
        _SPKM_MIC_mic_header,
        _SPKM_MIC_int_cksum,
        SPKM_MIC,
        _Mic_Header_tok_id,
        _Mic_Header_context_id,
        ___Mic_Header_int_alg_algorithm_tab,
        __Mic_Header_int_alg_algorithm,
        ___Mic_Header_int_alg_parameters_tab,
        __Mic_Header_int_alg_parameters,
        _Mic_Header_int_alg,
        _Mic_Header_snd_seq,
        Mic_Header,
        _SeqNum_num,
        _SeqNum_dir_ind,
        SeqNum,
        _SPKM_WRAP_wrap_header,
        _SPKM_WRAP_wrap_body,
        SPKM_WRAP,
        _Wrap_Header_tok_id,
        _Wrap_Header_context_id,
        ___Wrap_Header_int_alg_algorithm_tab,
        __Wrap_Header_int_alg_algorithm,
        ___Wrap_Header_int_alg_parameters_tab,
        __Wrap_Header_int_alg_parameters,
        _Wrap_Header_int_alg,
        _Wrap_Header_conf_alg,
        _Wrap_Header_snd_seq,
        Wrap_Header,
        _Wrap_Body_int_cksum,
        _Wrap_Body_data,
        Wrap_Body,
        ___Conf_Alg_algId_algorithm_tab,
        __Conf_Alg_algId_algorithm,
        ___Conf_Alg_algId_parameters_tab,
        __Conf_Alg_algId_parameters,
        _Conf_Alg_algId,
        _Conf_Alg_null,
        Conf_Alg,
        _SPKM_DEL_del_header,
        _SPKM_DEL_int_cksum,
        SPKM_DEL,
        _Del_Header_tok_id,
        _Del_Header_context_id,
        ___Del_Header_int_alg_algorithm_tab,
        __Del_Header_int_alg_algorithm,
        ___Del_Header_int_alg_parameters_tab,
        __Del_Header_int_alg_parameters,
        _Del_Header_int_alg,
        _Del_Header_snd_seq,
        Del_Header,
        MechType,
        _InitialContextToken_thisMech,
        _InitialContextToken_innerContextToken,
        InitialContextToken,
        _SPKMInnerContextToken_req,
        _SPKMInnerContextToken_rep_ti,
        _SPKMInnerContextToken_rep_it,
        _SPKMInnerContextToken_error,
        _SPKMInnerContextToken_mic,
        _SPKMInnerContextToken_wrap,
        _SPKMInnerContextToken_del_,
        SPKMInnerContextToken,
        __AuthorizationData__item__ad_type,
        __AuthorizationData__item__ad_data,
        _AuthorizationData__item_,
        AuthorizationData,
        md5_DES_CBC,
        sum64_DES_CBC,
        spkm_1,
        spkm_2,
    ]

class SS_DataTypes:

    _name_  = u'SS-DataTypes'
    _oid_   = [0, 4, 0, 0, 2, 3, 2, 12]
    
    _obj_ = [
        u'SS-UserData',
        u'NotifySS-Arg',
        u'Multicall-Indicator',
        u'ForwardChargeAdviceArg',
        u'SS-Notification',
        u'ChargingInformation',
        u'E1',
        u'max10TimesUnitsPerTime',
        u'E2',
        u'max10TimesTimeInterval',
        u'E3',
        u'max100TimesScalingFactor',
        u'E4',
        u'max10TimesIncrement',
        u'E5',
        u'max10TimesIncrementPerDataInterval',
        u'E6',
        u'maxNumberOfSegmentsPerDataInterval',
        u'E7',
        u'max10TimesInitialTime',
        u'CallOnHold-Indicator',
        u'ForwardCUG-InfoArg',
        u'ECT-Indicator',
        u'ECT-CallState',
        u'NameIndicator',
        u'Name',
        u'NameSet',
        u'RDN',
        u'RemotePartyNumber',
        u'AccessRegisterCCEntryArg',
        u'CallDeflectionArg',
        u'UserUserServiceArg',
        u'UUS-Service',
        u'LocationNotificationArg',
        u'LocationNotificationRes',
        u'VerificationResponse',
        u'LCS-MOLRArg',
        u'MOLR-Type',
        u'LocationMethod',
        u'GPSAssistanceData',
        u'GANSSAssistanceData',
        u'TerminationCause',
        u'MultiplePositioningProtocolPDUs',
        u'PositioningProtocolPDU',
        u'maxNumLPPMsg',
        u'LCS-MOLRRes',
        u'DecipheringKeys',
        u'LCS-AreaEventRequestArg',
        u'LCS-AreaEventReportArg',
        u'LCS-AreaEventCancellationArg',
        u'LCS-PeriodicLocationRequestArg',
        u'LCS-PeriodicLocationRequestRes',
        u'LCS-LocationUpdateArg',
        u'LCS-LocationUpdateRes',
        u'LCS-PeriodicLocationCancellationArg',
        ]
    _type_ = [
        u'SS-UserData',
        u'NotifySS-Arg',
        u'Multicall-Indicator',
        u'ForwardChargeAdviceArg',
        u'SS-Notification',
        u'ChargingInformation',
        u'E1',
        u'E2',
        u'E3',
        u'E4',
        u'E5',
        u'E6',
        u'E7',
        u'CallOnHold-Indicator',
        u'ForwardCUG-InfoArg',
        u'ECT-Indicator',
        u'ECT-CallState',
        u'NameIndicator',
        u'Name',
        u'NameSet',
        u'RDN',
        u'RemotePartyNumber',
        u'AccessRegisterCCEntryArg',
        u'CallDeflectionArg',
        u'UserUserServiceArg',
        u'UUS-Service',
        u'LocationNotificationArg',
        u'LocationNotificationRes',
        u'VerificationResponse',
        u'LCS-MOLRArg',
        u'MOLR-Type',
        u'LocationMethod',
        u'GPSAssistanceData',
        u'GANSSAssistanceData',
        u'TerminationCause',
        u'MultiplePositioningProtocolPDUs',
        u'PositioningProtocolPDU',
        u'LCS-MOLRRes',
        u'DecipheringKeys',
        u'LCS-AreaEventRequestArg',
        u'LCS-AreaEventReportArg',
        u'LCS-AreaEventCancellationArg',
        u'LCS-PeriodicLocationRequestArg',
        u'LCS-PeriodicLocationRequestRes',
        u'LCS-LocationUpdateArg',
        u'LCS-LocationUpdateRes',
        u'LCS-PeriodicLocationCancellationArg',
        ]
    _set_ = [
        ]
    _val_ = [
        u'max10TimesUnitsPerTime',
        u'max10TimesTimeInterval',
        u'max100TimesScalingFactor',
        u'max10TimesIncrement',
        u'max10TimesIncrementPerDataInterval',
        u'maxNumberOfSegmentsPerDataInterval',
        u'max10TimesInitialTime',
        u'maxNumLPPMsg',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SS-UserData >-----#
    SS_UserData = STR_IA5(name=u'SS-UserData', mode=MODE_TYPE)
    SS_UserData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    
    #-----< NotifySS-Arg >-----#
    NotifySS_Arg = SEQ(name=u'NotifySS-Arg', mode=MODE_TYPE)
    _NotifySS_Arg_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')), opt=True)
    _NotifySS_Arg_ss_Status = OCT_STR(name=u'ss-Status', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'SS-Status')), opt=True)
    _NotifySS_Arg_ss_Notification = OCT_STR(name=u'ss-Notification', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'SS-Notification')), opt=True)
    _NotifySS_Arg_callIsWaiting_Indicator = NULL(name=u'callIsWaiting-Indicator', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NotifySS_Arg_callOnHold_Indicator = ENUM(name=u'callOnHold-Indicator', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'CallOnHold-Indicator')), opt=True)
    _NotifySS_Arg_mpty_Indicator = NULL(name=u'mpty-Indicator', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NotifySS_Arg_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _NotifySS_Arg_clirSuppressionRejected = NULL(name=u'clirSuppressionRejected', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NotifySS_Arg_ect_Indicator = SEQ(name=u'ect-Indicator', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'ECT-Indicator')), opt=True)
    _NotifySS_Arg_nameIndicator = SEQ(name=u'nameIndicator', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'NameIndicator')), opt=True)
    _NotifySS_Arg_ccbs_Feature = SEQ(name=u'ccbs-Feature', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'CCBS-Feature')), opt=True)
    _NotifySS_Arg_alertingPattern = OCT_STR(name=u'alertingPattern', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AlertingPattern')), opt=True)
    _NotifySS_Arg_multicall_Indicator = ENUM(name=u'multicall-Indicator', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'Multicall-Indicator')), opt=True)
    NotifySS_Arg._cont = ASN1Dict([
        (u'ss-Code', _NotifySS_Arg_ss_Code),
        (u'ss-Status', _NotifySS_Arg_ss_Status),
        (u'ss-Notification', _NotifySS_Arg_ss_Notification),
        (u'callIsWaiting-Indicator', _NotifySS_Arg_callIsWaiting_Indicator),
        (u'callOnHold-Indicator', _NotifySS_Arg_callOnHold_Indicator),
        (u'mpty-Indicator', _NotifySS_Arg_mpty_Indicator),
        (u'cug-Index', _NotifySS_Arg_cug_Index),
        (u'clirSuppressionRejected', _NotifySS_Arg_clirSuppressionRejected),
        (u'ect-Indicator', _NotifySS_Arg_ect_Indicator),
        (u'nameIndicator', _NotifySS_Arg_nameIndicator),
        (u'ccbs-Feature', _NotifySS_Arg_ccbs_Feature),
        (u'alertingPattern', _NotifySS_Arg_alertingPattern),
        (u'multicall-Indicator', _NotifySS_Arg_multicall_Indicator),
        ])
    NotifySS_Arg._ext = [u'ect-Indicator', u'nameIndicator', u'ccbs-Feature', u'alertingPattern', u'multicall-Indicator']
    
    #-----< Multicall-Indicator >-----#
    Multicall_Indicator = ENUM(name=u'Multicall-Indicator', mode=MODE_TYPE)
    Multicall_Indicator._cont = ASN1Dict([(u'nbr-SNexceeded', 0), (u'nbr-Userexceeded', 1)])
    Multicall_Indicator._ext = None
    
    #-----< ForwardChargeAdviceArg >-----#
    ForwardChargeAdviceArg = SEQ(name=u'ForwardChargeAdviceArg', mode=MODE_TYPE)
    _ForwardChargeAdviceArg_ss_Code = OCT_STR(name=u'ss-Code', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-Code', 'SS-Code')))
    _ForwardChargeAdviceArg_chargingInformation = SEQ(name=u'chargingInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'ChargingInformation')))
    ForwardChargeAdviceArg._cont = ASN1Dict([
        (u'ss-Code', _ForwardChargeAdviceArg_ss_Code),
        (u'chargingInformation', _ForwardChargeAdviceArg_chargingInformation),
        ])
    ForwardChargeAdviceArg._ext = []
    
    #-----< SS-Notification >-----#
    SS_Notification = OCT_STR(name=u'SS-Notification', mode=MODE_TYPE)
    SS_Notification._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< ChargingInformation >-----#
    ChargingInformation = SEQ(name=u'ChargingInformation', mode=MODE_TYPE)
    _ChargingInformation_e1 = INT(name=u'e1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'E1')), opt=True)
    _ChargingInformation_e2 = INT(name=u'e2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'E2')), opt=True)
    _ChargingInformation_e3 = INT(name=u'e3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'E3')), opt=True)
    _ChargingInformation_e4 = INT(name=u'e4', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'E4')), opt=True)
    _ChargingInformation_e5 = INT(name=u'e5', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'E5')), opt=True)
    _ChargingInformation_e6 = INT(name=u'e6', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'E6')), opt=True)
    _ChargingInformation_e7 = INT(name=u'e7', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'E7')), opt=True)
    ChargingInformation._cont = ASN1Dict([
        (u'e1', _ChargingInformation_e1),
        (u'e2', _ChargingInformation_e2),
        (u'e3', _ChargingInformation_e3),
        (u'e4', _ChargingInformation_e4),
        (u'e5', _ChargingInformation_e5),
        (u'e6', _ChargingInformation_e6),
        (u'e7', _ChargingInformation_e7),
        ])
    ChargingInformation._ext = []
    
    #-----< E1 >-----#
    E1 = INT(name=u'E1', mode=MODE_TYPE)
    E1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< max10TimesUnitsPerTime >-----#
    max10TimesUnitsPerTime = INT(name=u'max10TimesUnitsPerTime', mode=MODE_VALUE)
    max10TimesUnitsPerTime._val = 8191
    
    #-----< E2 >-----#
    E2 = INT(name=u'E2', mode=MODE_TYPE)
    E2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< max10TimesTimeInterval >-----#
    max10TimesTimeInterval = INT(name=u'max10TimesTimeInterval', mode=MODE_VALUE)
    max10TimesTimeInterval._val = 8191
    
    #-----< E3 >-----#
    E3 = INT(name=u'E3', mode=MODE_TYPE)
    E3._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< max100TimesScalingFactor >-----#
    max100TimesScalingFactor = INT(name=u'max100TimesScalingFactor', mode=MODE_VALUE)
    max100TimesScalingFactor._val = 8191
    
    #-----< E4 >-----#
    E4 = INT(name=u'E4', mode=MODE_TYPE)
    E4._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< max10TimesIncrement >-----#
    max10TimesIncrement = INT(name=u'max10TimesIncrement', mode=MODE_VALUE)
    max10TimesIncrement._val = 8191
    
    #-----< E5 >-----#
    E5 = INT(name=u'E5', mode=MODE_TYPE)
    E5._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< max10TimesIncrementPerDataInterval >-----#
    max10TimesIncrementPerDataInterval = INT(name=u'max10TimesIncrementPerDataInterval', mode=MODE_VALUE)
    max10TimesIncrementPerDataInterval._val = 8191
    
    #-----< E6 >-----#
    E6 = INT(name=u'E6', mode=MODE_TYPE)
    E6._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< maxNumberOfSegmentsPerDataInterval >-----#
    maxNumberOfSegmentsPerDataInterval = INT(name=u'maxNumberOfSegmentsPerDataInterval', mode=MODE_VALUE)
    maxNumberOfSegmentsPerDataInterval._val = 8191
    
    #-----< E7 >-----#
    E7 = INT(name=u'E7', mode=MODE_TYPE)
    E7._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< max10TimesInitialTime >-----#
    max10TimesInitialTime = INT(name=u'max10TimesInitialTime', mode=MODE_VALUE)
    max10TimesInitialTime._val = 8191
    
    #-----< CallOnHold-Indicator >-----#
    CallOnHold_Indicator = ENUM(name=u'CallOnHold-Indicator', mode=MODE_TYPE)
    CallOnHold_Indicator._cont = ASN1Dict([(u'callRetrieved', 0), (u'callOnHold', 1)])
    CallOnHold_Indicator._ext = None
    
    #-----< ForwardCUG-InfoArg >-----#
    ForwardCUG_InfoArg = SEQ(name=u'ForwardCUG-InfoArg', mode=MODE_TYPE)
    _ForwardCUG_InfoArg_cug_Index = INT(name=u'cug-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'CUG-Index')), opt=True)
    _ForwardCUG_InfoArg_suppressPrefCUG = NULL(name=u'suppressPrefCUG', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ForwardCUG_InfoArg_suppressOA = NULL(name=u'suppressOA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ForwardCUG_InfoArg._cont = ASN1Dict([
        (u'cug-Index', _ForwardCUG_InfoArg_cug_Index),
        (u'suppressPrefCUG', _ForwardCUG_InfoArg_suppressPrefCUG),
        (u'suppressOA', _ForwardCUG_InfoArg_suppressOA),
        ])
    ForwardCUG_InfoArg._ext = []
    
    #-----< ECT-Indicator >-----#
    ECT_Indicator = SEQ(name=u'ECT-Indicator', mode=MODE_TYPE)
    _ECT_Indicator_ect_CallState = ENUM(name=u'ect-CallState', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'ECT-CallState')))
    _ECT_Indicator_rdn = CHOICE(name=u'rdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'RDN')), opt=True)
    ECT_Indicator._cont = ASN1Dict([
        (u'ect-CallState', _ECT_Indicator_ect_CallState),
        (u'rdn', _ECT_Indicator_rdn),
        ])
    ECT_Indicator._ext = []
    
    #-----< ECT-CallState >-----#
    ECT_CallState = ENUM(name=u'ECT-CallState', mode=MODE_TYPE)
    ECT_CallState._cont = ASN1Dict([(u'alerting', 0), (u'active', 1)])
    ECT_CallState._ext = None
    
    #-----< NameIndicator >-----#
    NameIndicator = SEQ(name=u'NameIndicator', mode=MODE_TYPE)
    _NameIndicator_callingName = CHOICE(name=u'callingName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'Name')), opt=True)
    NameIndicator._cont = ASN1Dict([
        (u'callingName', _NameIndicator_callingName),
        ])
    NameIndicator._ext = []
    
    #-----< Name >-----#
    Name = CHOICE(name=u'Name', mode=MODE_TYPE)
    _Name_namePresentationAllowed = SEQ(name=u'namePresentationAllowed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'NameSet')))
    _Name_presentationRestricted = NULL(name=u'presentationRestricted', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Name_nameUnavailable = NULL(name=u'nameUnavailable', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Name_namePresentationRestricted = SEQ(name=u'namePresentationRestricted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'NameSet')))
    Name._cont = ASN1Dict([
        (u'namePresentationAllowed', _Name_namePresentationAllowed),
        (u'presentationRestricted', _Name_presentationRestricted),
        (u'nameUnavailable', _Name_nameUnavailable),
        (u'namePresentationRestricted', _Name_namePresentationRestricted),
        ])
    Name._ext = None
    
    #-----< NameSet >-----#
    NameSet = SEQ(name=u'NameSet', mode=MODE_TYPE)
    _NameSet_dataCodingScheme = OCT_STR(name=u'dataCodingScheme', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-DataCodingScheme')))
    _NameSet_lengthInCharacters = INT(name=u'lengthInCharacters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NameSet_nameString = OCT_STR(name=u'nameString', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-SS-DataTypes', 'USSD-String')))
    NameSet._cont = ASN1Dict([
        (u'dataCodingScheme', _NameSet_dataCodingScheme),
        (u'lengthInCharacters', _NameSet_lengthInCharacters),
        (u'nameString', _NameSet_nameString),
        ])
    NameSet._ext = []
    
    #-----< RDN >-----#
    RDN = CHOICE(name=u'RDN', mode=MODE_TYPE)
    _RDN_presentationAllowedAddress = SEQ(name=u'presentationAllowedAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'RemotePartyNumber')))
    _RDN_presentationRestricted = NULL(name=u'presentationRestricted', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RDN_numberNotAvailableDueToInterworking = NULL(name=u'numberNotAvailableDueToInterworking', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RDN_presentationRestrictedAddress = SEQ(name=u'presentationRestrictedAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'RemotePartyNumber')))
    RDN._cont = ASN1Dict([
        (u'presentationAllowedAddress', _RDN_presentationAllowedAddress),
        (u'presentationRestricted', _RDN_presentationRestricted),
        (u'numberNotAvailableDueToInterworking', _RDN_numberNotAvailableDueToInterworking),
        (u'presentationRestrictedAddress', _RDN_presentationRestrictedAddress),
        ])
    RDN._ext = None
    
    #-----< RemotePartyNumber >-----#
    RemotePartyNumber = SEQ(name=u'RemotePartyNumber', mode=MODE_TYPE)
    _RemotePartyNumber_partyNumber = OCT_STR(name=u'partyNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')))
    _RemotePartyNumber_partyNumberSubaddress = OCT_STR(name=u'partyNumberSubaddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    RemotePartyNumber._cont = ASN1Dict([
        (u'partyNumber', _RemotePartyNumber_partyNumber),
        (u'partyNumberSubaddress', _RemotePartyNumber_partyNumberSubaddress),
        ])
    RemotePartyNumber._ext = []
    
    #-----< AccessRegisterCCEntryArg >-----#
    AccessRegisterCCEntryArg = SEQ(name=u'AccessRegisterCCEntryArg', mode=MODE_TYPE)
    AccessRegisterCCEntryArg._cont = ASN1Dict([
        ])
    AccessRegisterCCEntryArg._ext = []
    
    #-----< CallDeflectionArg >-----#
    CallDeflectionArg = SEQ(name=u'CallDeflectionArg', mode=MODE_TYPE)
    _CallDeflectionArg_deflectedToNumber = OCT_STR(name=u'deflectedToNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AddressString')))
    _CallDeflectionArg_deflectedToSubaddress = OCT_STR(name=u'deflectedToSubaddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-SubaddressString')), opt=True)
    CallDeflectionArg._cont = ASN1Dict([
        (u'deflectedToNumber', _CallDeflectionArg_deflectedToNumber),
        (u'deflectedToSubaddress', _CallDeflectionArg_deflectedToSubaddress),
        ])
    CallDeflectionArg._ext = []
    
    #-----< UserUserServiceArg >-----#
    UserUserServiceArg = SEQ(name=u'UserUserServiceArg', mode=MODE_TYPE)
    _UserUserServiceArg_uUS_Service = ENUM(name=u'uUS-Service', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'UUS-Service')))
    _UserUserServiceArg_uUS_Required = BOOL(name=u'uUS-Required', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    UserUserServiceArg._cont = ASN1Dict([
        (u'uUS-Service', _UserUserServiceArg_uUS_Service),
        (u'uUS-Required', _UserUserServiceArg_uUS_Required),
        ])
    UserUserServiceArg._ext = []
    
    #-----< UUS-Service >-----#
    UUS_Service = ENUM(name=u'UUS-Service', mode=MODE_TYPE)
    UUS_Service._cont = ASN1Dict([(u'uUS1', 1), (u'uUS2', 2), (u'uUS3', 3)])
    UUS_Service._ext = []
    
    #-----< LocationNotificationArg >-----#
    LocationNotificationArg = SEQ(name=u'LocationNotificationArg', mode=MODE_TYPE)
    _LocationNotificationArg_notificationType = ENUM(name=u'notificationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-MS-DataTypes', 'NotificationToMSUser')))
    _LocationNotificationArg_locationType = SEQ(name=u'locationType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')))
    _LocationNotificationArg_lcsClientExternalID = SEQ(name=u'lcsClientExternalID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientExternalID')), opt=True)
    _LocationNotificationArg_lcsClientName = SEQ(name=u'lcsClientName', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSClientName')), opt=True)
    _LocationNotificationArg_lcsRequestorID = SEQ(name=u'lcsRequestorID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSRequestorID')), opt=True)
    _LocationNotificationArg_lcsCodeword = SEQ(name=u'lcsCodeword', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCSCodeword')), opt=True)
    _LocationNotificationArg_lcsServiceTypeID = INT(name=u'lcsServiceTypeID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')), opt=True)
    LocationNotificationArg._cont = ASN1Dict([
        (u'notificationType', _LocationNotificationArg_notificationType),
        (u'locationType', _LocationNotificationArg_locationType),
        (u'lcsClientExternalID', _LocationNotificationArg_lcsClientExternalID),
        (u'lcsClientName', _LocationNotificationArg_lcsClientName),
        (u'lcsRequestorID', _LocationNotificationArg_lcsRequestorID),
        (u'lcsCodeword', _LocationNotificationArg_lcsCodeword),
        (u'lcsServiceTypeID', _LocationNotificationArg_lcsServiceTypeID),
        ])
    LocationNotificationArg._ext = [u'lcsRequestorID', u'lcsCodeword', u'lcsServiceTypeID']
    
    #-----< LocationNotificationRes >-----#
    LocationNotificationRes = SEQ(name=u'LocationNotificationRes', mode=MODE_TYPE)
    _LocationNotificationRes_verificationResponse = ENUM(name=u'verificationResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'VerificationResponse')), opt=True)
    LocationNotificationRes._cont = ASN1Dict([
        (u'verificationResponse', _LocationNotificationRes_verificationResponse),
        ])
    LocationNotificationRes._ext = []
    
    #-----< VerificationResponse >-----#
    VerificationResponse = ENUM(name=u'VerificationResponse', mode=MODE_TYPE)
    VerificationResponse._cont = ASN1Dict([(u'permissionDenied', 0), (u'permissionGranted', 1)])
    VerificationResponse._ext = []
    
    #-----< LCS-MOLRArg >-----#
    LCS_MOLRArg = SEQ(name=u'LCS-MOLRArg', mode=MODE_TYPE)
    _LCS_MOLRArg_molr_Type = ENUM(name=u'molr-Type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'MOLR-Type')))
    _LCS_MOLRArg_locationMethod = ENUM(name=u'locationMethod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'LocationMethod')), opt=True)
    _LCS_MOLRArg_lcs_QoS = SEQ(name=u'lcs-QoS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-QoS')), opt=True)
    _LCS_MOLRArg_lcsClientExternalID = SEQ(name=u'lcsClientExternalID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientExternalID')), opt=True)
    _LCS_MOLRArg_mlc_Number = OCT_STR(name=u'mlc-Number', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'ISDN-AddressString')), opt=True)
    _LCS_MOLRArg_gpsAssistanceData = OCT_STR(name=u'gpsAssistanceData', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'GPSAssistanceData')), opt=True)
    _LCS_MOLRArg_supportedGADShapes = BIT_STR(name=u'supportedGADShapes', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'SupportedGADShapes')), opt=True)
    _LCS_MOLRArg_lcsServiceTypeID = INT(name=u'lcsServiceTypeID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSServiceTypeID')), opt=True)
    _LCS_MOLRArg_ageOfLocationInfo = INT(name=u'ageOfLocationInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'AgeOfLocationInformation')), opt=True)
    _LCS_MOLRArg_locationType = SEQ(name=u'locationType', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LocationType')), opt=True)
    _LCS_MOLRArg_pseudonymIndicator = NULL(name=u'pseudonymIndicator', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_MOLRArg_h_gmlc_address = OCT_STR(name=u'h-gmlc-address', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _LCS_MOLRArg_locationEstimate = OCT_STR(name=u'locationEstimate', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _LCS_MOLRArg_velocityEstimate = OCT_STR(name=u'velocityEstimate', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'VelocityEstimate')), opt=True)
    _LCS_MOLRArg_referenceNumber = OCT_STR(name=u'referenceNumber', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')), opt=True)
    _LCS_MOLRArg_periodicLDRInfo = SEQ(name=u'periodicLDRInfo', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PeriodicLDRInfo')), opt=True)
    _LCS_MOLRArg_locationUpdateRequest = NULL(name=u'locationUpdateRequest', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_MOLRArg_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'SequenceNumber')), opt=True)
    _LCS_MOLRArg_terminationCause = ENUM(name=u'terminationCause', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'TerminationCause')), opt=True)
    _LCS_MOLRArg_mo_lrShortCircuit = NULL(name=u'mo-lrShortCircuit', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_MOLRArg_ganssAssistanceData = OCT_STR(name=u'ganssAssistanceData', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'GANSSAssistanceData')), opt=True)
    _LCS_MOLRArg_multiplePositioningProtocolPDUs = SEQ_OF(name=u'multiplePositioningProtocolPDUs', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'MultiplePositioningProtocolPDUs')), opt=True)
    LCS_MOLRArg._cont = ASN1Dict([
        (u'molr-Type', _LCS_MOLRArg_molr_Type),
        (u'locationMethod', _LCS_MOLRArg_locationMethod),
        (u'lcs-QoS', _LCS_MOLRArg_lcs_QoS),
        (u'lcsClientExternalID', _LCS_MOLRArg_lcsClientExternalID),
        (u'mlc-Number', _LCS_MOLRArg_mlc_Number),
        (u'gpsAssistanceData', _LCS_MOLRArg_gpsAssistanceData),
        (u'supportedGADShapes', _LCS_MOLRArg_supportedGADShapes),
        (u'lcsServiceTypeID', _LCS_MOLRArg_lcsServiceTypeID),
        (u'ageOfLocationInfo', _LCS_MOLRArg_ageOfLocationInfo),
        (u'locationType', _LCS_MOLRArg_locationType),
        (u'pseudonymIndicator', _LCS_MOLRArg_pseudonymIndicator),
        (u'h-gmlc-address', _LCS_MOLRArg_h_gmlc_address),
        (u'locationEstimate', _LCS_MOLRArg_locationEstimate),
        (u'velocityEstimate', _LCS_MOLRArg_velocityEstimate),
        (u'referenceNumber', _LCS_MOLRArg_referenceNumber),
        (u'periodicLDRInfo', _LCS_MOLRArg_periodicLDRInfo),
        (u'locationUpdateRequest', _LCS_MOLRArg_locationUpdateRequest),
        (u'sequenceNumber', _LCS_MOLRArg_sequenceNumber),
        (u'terminationCause', _LCS_MOLRArg_terminationCause),
        (u'mo-lrShortCircuit', _LCS_MOLRArg_mo_lrShortCircuit),
        (u'ganssAssistanceData', _LCS_MOLRArg_ganssAssistanceData),
        (u'multiplePositioningProtocolPDUs', _LCS_MOLRArg_multiplePositioningProtocolPDUs),
        ])
    LCS_MOLRArg._ext = [u'supportedGADShapes', u'lcsServiceTypeID', u'ageOfLocationInfo', u'locationType', u'pseudonymIndicator', u'h-gmlc-address', u'locationEstimate', u'velocityEstimate', u'referenceNumber', u'periodicLDRInfo', u'locationUpdateRequest', u'sequenceNumber', u'terminationCause', u'mo-lrShortCircuit', u'ganssAssistanceData', u'multiplePositioningProtocolPDUs']
    
    #-----< MOLR-Type >-----#
    MOLR_Type = ENUM(name=u'MOLR-Type', mode=MODE_TYPE)
    MOLR_Type._cont = ASN1Dict([(u'locationEstimate', 0), (u'assistanceData', 1), (u'deCipheringKeys', 2), (u'deferredMo-lrTTTPInitiation', 3), (u'deferredMo-lrSelfLocationInitiation', 4), (u'deferredMt-lrOrmo-lrTTTPLocationEstimate', 5), (u'deferredMt-lrOrmo-lrCancellation', 6)])
    MOLR_Type._ext = [u'deferredMo-lrTTTPInitiation', u'deferredMo-lrSelfLocationInitiation', u'deferredMt-lrOrmo-lrTTTPLocationEstimate', u'deferredMt-lrOrmo-lrCancellation']
    
    #-----< LocationMethod >-----#
    LocationMethod = ENUM(name=u'LocationMethod', mode=MODE_TYPE)
    LocationMethod._cont = ASN1Dict([(u'msBasedEOTD', 0), (u'msAssistedEOTD', 1), (u'assistedGPS', 2), (u'msBasedOTDOA', 3), (u'assistedGANSS', 4), (u'assistedGPSandGANSS', 5)])
    LocationMethod._ext = [u'msBasedOTDOA', u'assistedGANSS', u'assistedGPSandGANSS']
    
    #-----< GPSAssistanceData >-----#
    GPSAssistanceData = OCT_STR(name=u'GPSAssistanceData', mode=MODE_TYPE)
    GPSAssistanceData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=38)], ev=None, er=[])
    
    #-----< GANSSAssistanceData >-----#
    GANSSAssistanceData = OCT_STR(name=u'GANSSAssistanceData', mode=MODE_TYPE)
    GANSSAssistanceData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    
    #-----< TerminationCause >-----#
    TerminationCause = ENUM(name=u'TerminationCause', mode=MODE_TYPE)
    TerminationCause._cont = ASN1Dict([(u'subscriberTermination', 0), (u'uETermination', 1)])
    TerminationCause._ext = []
    
    #-----< MultiplePositioningProtocolPDUs >-----#
    MultiplePositioningProtocolPDUs = SEQ_OF(name=u'MultiplePositioningProtocolPDUs', mode=MODE_TYPE)
    _MultiplePositioningProtocolPDUs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SS-DataTypes', 'PositioningProtocolPDU')))
    MultiplePositioningProtocolPDUs._cont = _MultiplePositioningProtocolPDUs__item_
    MultiplePositioningProtocolPDUs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< PositioningProtocolPDU >-----#
    PositioningProtocolPDU = OCT_STR(name=u'PositioningProtocolPDU', mode=MODE_TYPE)
    
    #-----< maxNumLPPMsg >-----#
    maxNumLPPMsg = INT(name=u'maxNumLPPMsg', mode=MODE_VALUE)
    maxNumLPPMsg._val = 3
    
    #-----< LCS-MOLRRes >-----#
    LCS_MOLRRes = SEQ(name=u'LCS-MOLRRes', mode=MODE_TYPE)
    _LCS_MOLRRes_locationEstimate = OCT_STR(name=u'locationEstimate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Ext-GeographicalInformation')), opt=True)
    _LCS_MOLRRes_decipheringKeys = OCT_STR(name=u'decipheringKeys', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'DecipheringKeys')), opt=True)
    _LCS_MOLRRes_add_LocationEstimate = OCT_STR(name=u'add-LocationEstimate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Add-GeographicalInformation')), opt=True)
    _LCS_MOLRRes_velocityEstimate = OCT_STR(name=u'velocityEstimate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'VelocityEstimate')), opt=True)
    _LCS_MOLRRes_referenceNumber = OCT_STR(name=u'referenceNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')), opt=True)
    _LCS_MOLRRes_h_gmlc_address = OCT_STR(name=u'h-gmlc-address', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _LCS_MOLRRes_mo_lrShortCircuit = NULL(name=u'mo-lrShortCircuit', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_MOLRRes_reportingPLMNList = SEQ(name=u'reportingPLMNList', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ReportingPLMNList')), opt=True)
    LCS_MOLRRes._cont = ASN1Dict([
        (u'locationEstimate', _LCS_MOLRRes_locationEstimate),
        (u'decipheringKeys', _LCS_MOLRRes_decipheringKeys),
        (u'add-LocationEstimate', _LCS_MOLRRes_add_LocationEstimate),
        (u'velocityEstimate', _LCS_MOLRRes_velocityEstimate),
        (u'referenceNumber', _LCS_MOLRRes_referenceNumber),
        (u'h-gmlc-address', _LCS_MOLRRes_h_gmlc_address),
        (u'mo-lrShortCircuit', _LCS_MOLRRes_mo_lrShortCircuit),
        (u'reportingPLMNList', _LCS_MOLRRes_reportingPLMNList),
        ])
    LCS_MOLRRes._ext = [u'add-LocationEstimate', u'velocityEstimate', u'referenceNumber', u'h-gmlc-address', u'mo-lrShortCircuit', u'reportingPLMNList']
    
    #-----< DecipheringKeys >-----#
    DecipheringKeys = OCT_STR(name=u'DecipheringKeys', mode=MODE_TYPE)
    DecipheringKeys._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    
    #-----< LCS-AreaEventRequestArg >-----#
    LCS_AreaEventRequestArg = SEQ(name=u'LCS-AreaEventRequestArg', mode=MODE_TYPE)
    _LCS_AreaEventRequestArg_referenceNumber = OCT_STR(name=u'referenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')))
    _LCS_AreaEventRequestArg_h_gmlc_address = OCT_STR(name=u'h-gmlc-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    _LCS_AreaEventRequestArg_deferredLocationEventType = BIT_STR(name=u'deferredLocationEventType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'DeferredLocationEventType')))
    _LCS_AreaEventRequestArg_areaEventInfo = SEQ(name=u'areaEventInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'AreaEventInfo')))
    LCS_AreaEventRequestArg._cont = ASN1Dict([
        (u'referenceNumber', _LCS_AreaEventRequestArg_referenceNumber),
        (u'h-gmlc-address', _LCS_AreaEventRequestArg_h_gmlc_address),
        (u'deferredLocationEventType', _LCS_AreaEventRequestArg_deferredLocationEventType),
        (u'areaEventInfo', _LCS_AreaEventRequestArg_areaEventInfo),
        ])
    LCS_AreaEventRequestArg._ext = []
    
    #-----< LCS-AreaEventReportArg >-----#
    LCS_AreaEventReportArg = SEQ(name=u'LCS-AreaEventReportArg', mode=MODE_TYPE)
    _LCS_AreaEventReportArg_referenceNumber = OCT_STR(name=u'referenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')))
    _LCS_AreaEventReportArg_h_gmlc_address = OCT_STR(name=u'h-gmlc-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    LCS_AreaEventReportArg._cont = ASN1Dict([
        (u'referenceNumber', _LCS_AreaEventReportArg_referenceNumber),
        (u'h-gmlc-address', _LCS_AreaEventReportArg_h_gmlc_address),
        ])
    LCS_AreaEventReportArg._ext = []
    
    #-----< LCS-AreaEventCancellationArg >-----#
    LCS_AreaEventCancellationArg = SEQ(name=u'LCS-AreaEventCancellationArg', mode=MODE_TYPE)
    _LCS_AreaEventCancellationArg_referenceNumber = OCT_STR(name=u'referenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')))
    _LCS_AreaEventCancellationArg_h_gmlc_address = OCT_STR(name=u'h-gmlc-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')))
    LCS_AreaEventCancellationArg._cont = ASN1Dict([
        (u'referenceNumber', _LCS_AreaEventCancellationArg_referenceNumber),
        (u'h-gmlc-address', _LCS_AreaEventCancellationArg_h_gmlc_address),
        ])
    LCS_AreaEventCancellationArg._ext = []
    
    #-----< LCS-PeriodicLocationRequestArg >-----#
    LCS_PeriodicLocationRequestArg = SEQ(name=u'LCS-PeriodicLocationRequestArg', mode=MODE_TYPE)
    _LCS_PeriodicLocationRequestArg_referenceNumber = OCT_STR(name=u'referenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')))
    _LCS_PeriodicLocationRequestArg_periodicLDRInfo = SEQ(name=u'periodicLDRInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'PeriodicLDRInfo')))
    _LCS_PeriodicLocationRequestArg_lcsClientExternalID = SEQ(name=u'lcsClientExternalID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'LCSClientExternalID')))
    _LCS_PeriodicLocationRequestArg_qoS = SEQ(name=u'qoS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-QoS')), opt=True)
    _LCS_PeriodicLocationRequestArg_h_gmlc_address = OCT_STR(name=u'h-gmlc-address', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    _LCS_PeriodicLocationRequestArg_mo_lrShortCircuit = NULL(name=u'mo-lrShortCircuit', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LCS_PeriodicLocationRequestArg_reportingPLMNList = SEQ(name=u'reportingPLMNList', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'ReportingPLMNList')), opt=True)
    LCS_PeriodicLocationRequestArg._cont = ASN1Dict([
        (u'referenceNumber', _LCS_PeriodicLocationRequestArg_referenceNumber),
        (u'periodicLDRInfo', _LCS_PeriodicLocationRequestArg_periodicLDRInfo),
        (u'lcsClientExternalID', _LCS_PeriodicLocationRequestArg_lcsClientExternalID),
        (u'qoS', _LCS_PeriodicLocationRequestArg_qoS),
        (u'h-gmlc-address', _LCS_PeriodicLocationRequestArg_h_gmlc_address),
        (u'mo-lrShortCircuit', _LCS_PeriodicLocationRequestArg_mo_lrShortCircuit),
        (u'reportingPLMNList', _LCS_PeriodicLocationRequestArg_reportingPLMNList),
        ])
    LCS_PeriodicLocationRequestArg._ext = []
    
    #-----< LCS-PeriodicLocationRequestRes >-----#
    LCS_PeriodicLocationRequestRes = SEQ(name=u'LCS-PeriodicLocationRequestRes', mode=MODE_TYPE)
    _LCS_PeriodicLocationRequestRes_mo_lrShortCircuit = NULL(name=u'mo-lrShortCircuit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    LCS_PeriodicLocationRequestRes._cont = ASN1Dict([
        (u'mo-lrShortCircuit', _LCS_PeriodicLocationRequestRes_mo_lrShortCircuit),
        ])
    LCS_PeriodicLocationRequestRes._ext = []
    
    #-----< LCS-LocationUpdateArg >-----#
    LCS_LocationUpdateArg = SEQ(name=u'LCS-LocationUpdateArg', mode=MODE_TYPE)
    _LCS_LocationUpdateArg_referenceNumber = OCT_STR(name=u'referenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')), opt=True)
    _LCS_LocationUpdateArg_add_LocationEstimate = OCT_STR(name=u'add-LocationEstimate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'Add-GeographicalInformation')), opt=True)
    _LCS_LocationUpdateArg_velocityEstimate = OCT_STR(name=u'velocityEstimate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'VelocityEstimate')), opt=True)
    _LCS_LocationUpdateArg_sequenceNumber = INT(name=u'sequenceNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'SequenceNumber')), opt=True)
    LCS_LocationUpdateArg._cont = ASN1Dict([
        (u'referenceNumber', _LCS_LocationUpdateArg_referenceNumber),
        (u'add-LocationEstimate', _LCS_LocationUpdateArg_add_LocationEstimate),
        (u'velocityEstimate', _LCS_LocationUpdateArg_velocityEstimate),
        (u'sequenceNumber', _LCS_LocationUpdateArg_sequenceNumber),
        ])
    LCS_LocationUpdateArg._ext = []
    
    #-----< LCS-LocationUpdateRes >-----#
    LCS_LocationUpdateRes = SEQ(name=u'LCS-LocationUpdateRes', mode=MODE_TYPE)
    _LCS_LocationUpdateRes_terminationCause = ENUM(name=u'terminationCause', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SS-DataTypes', 'TerminationCause')), opt=True)
    LCS_LocationUpdateRes._cont = ASN1Dict([
        (u'terminationCause', _LCS_LocationUpdateRes_terminationCause),
        ])
    LCS_LocationUpdateRes._ext = []
    
    #-----< LCS-PeriodicLocationCancellationArg >-----#
    LCS_PeriodicLocationCancellationArg = SEQ(name=u'LCS-PeriodicLocationCancellationArg', mode=MODE_TYPE)
    _LCS_PeriodicLocationCancellationArg_referenceNumber = OCT_STR(name=u'referenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-LCS-DataTypes', 'LCS-ReferenceNumber')))
    _LCS_PeriodicLocationCancellationArg_h_gmlc_address = OCT_STR(name=u'h-gmlc-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('MAP-CommonDataTypes', 'GSN-Address')), opt=True)
    LCS_PeriodicLocationCancellationArg._cont = ASN1Dict([
        (u'referenceNumber', _LCS_PeriodicLocationCancellationArg_referenceNumber),
        (u'h-gmlc-address', _LCS_PeriodicLocationCancellationArg_h_gmlc_address),
        ])
    LCS_PeriodicLocationCancellationArg._ext = []
    
    _all_ = [
        SS_UserData,
        _NotifySS_Arg_ss_Code,
        _NotifySS_Arg_ss_Status,
        _NotifySS_Arg_ss_Notification,
        _NotifySS_Arg_callIsWaiting_Indicator,
        _NotifySS_Arg_callOnHold_Indicator,
        _NotifySS_Arg_mpty_Indicator,
        _NotifySS_Arg_cug_Index,
        _NotifySS_Arg_clirSuppressionRejected,
        _NotifySS_Arg_ect_Indicator,
        _NotifySS_Arg_nameIndicator,
        _NotifySS_Arg_ccbs_Feature,
        _NotifySS_Arg_alertingPattern,
        _NotifySS_Arg_multicall_Indicator,
        NotifySS_Arg,
        Multicall_Indicator,
        _ForwardChargeAdviceArg_ss_Code,
        _ForwardChargeAdviceArg_chargingInformation,
        ForwardChargeAdviceArg,
        SS_Notification,
        _ChargingInformation_e1,
        _ChargingInformation_e2,
        _ChargingInformation_e3,
        _ChargingInformation_e4,
        _ChargingInformation_e5,
        _ChargingInformation_e6,
        _ChargingInformation_e7,
        ChargingInformation,
        E1,
        max10TimesUnitsPerTime,
        E2,
        max10TimesTimeInterval,
        E3,
        max100TimesScalingFactor,
        E4,
        max10TimesIncrement,
        E5,
        max10TimesIncrementPerDataInterval,
        E6,
        maxNumberOfSegmentsPerDataInterval,
        E7,
        max10TimesInitialTime,
        CallOnHold_Indicator,
        _ForwardCUG_InfoArg_cug_Index,
        _ForwardCUG_InfoArg_suppressPrefCUG,
        _ForwardCUG_InfoArg_suppressOA,
        ForwardCUG_InfoArg,
        _ECT_Indicator_ect_CallState,
        _ECT_Indicator_rdn,
        ECT_Indicator,
        ECT_CallState,
        _NameIndicator_callingName,
        NameIndicator,
        _Name_namePresentationAllowed,
        _Name_presentationRestricted,
        _Name_nameUnavailable,
        _Name_namePresentationRestricted,
        Name,
        _NameSet_dataCodingScheme,
        _NameSet_lengthInCharacters,
        _NameSet_nameString,
        NameSet,
        _RDN_presentationAllowedAddress,
        _RDN_presentationRestricted,
        _RDN_numberNotAvailableDueToInterworking,
        _RDN_presentationRestrictedAddress,
        RDN,
        _RemotePartyNumber_partyNumber,
        _RemotePartyNumber_partyNumberSubaddress,
        RemotePartyNumber,
        AccessRegisterCCEntryArg,
        _CallDeflectionArg_deflectedToNumber,
        _CallDeflectionArg_deflectedToSubaddress,
        CallDeflectionArg,
        _UserUserServiceArg_uUS_Service,
        _UserUserServiceArg_uUS_Required,
        UserUserServiceArg,
        UUS_Service,
        _LocationNotificationArg_notificationType,
        _LocationNotificationArg_locationType,
        _LocationNotificationArg_lcsClientExternalID,
        _LocationNotificationArg_lcsClientName,
        _LocationNotificationArg_lcsRequestorID,
        _LocationNotificationArg_lcsCodeword,
        _LocationNotificationArg_lcsServiceTypeID,
        LocationNotificationArg,
        _LocationNotificationRes_verificationResponse,
        LocationNotificationRes,
        VerificationResponse,
        _LCS_MOLRArg_molr_Type,
        _LCS_MOLRArg_locationMethod,
        _LCS_MOLRArg_lcs_QoS,
        _LCS_MOLRArg_lcsClientExternalID,
        _LCS_MOLRArg_mlc_Number,
        _LCS_MOLRArg_gpsAssistanceData,
        _LCS_MOLRArg_supportedGADShapes,
        _LCS_MOLRArg_lcsServiceTypeID,
        _LCS_MOLRArg_ageOfLocationInfo,
        _LCS_MOLRArg_locationType,
        _LCS_MOLRArg_pseudonymIndicator,
        _LCS_MOLRArg_h_gmlc_address,
        _LCS_MOLRArg_locationEstimate,
        _LCS_MOLRArg_velocityEstimate,
        _LCS_MOLRArg_referenceNumber,
        _LCS_MOLRArg_periodicLDRInfo,
        _LCS_MOLRArg_locationUpdateRequest,
        _LCS_MOLRArg_sequenceNumber,
        _LCS_MOLRArg_terminationCause,
        _LCS_MOLRArg_mo_lrShortCircuit,
        _LCS_MOLRArg_ganssAssistanceData,
        _LCS_MOLRArg_multiplePositioningProtocolPDUs,
        LCS_MOLRArg,
        MOLR_Type,
        LocationMethod,
        GPSAssistanceData,
        GANSSAssistanceData,
        TerminationCause,
        _MultiplePositioningProtocolPDUs__item_,
        MultiplePositioningProtocolPDUs,
        PositioningProtocolPDU,
        maxNumLPPMsg,
        _LCS_MOLRRes_locationEstimate,
        _LCS_MOLRRes_decipheringKeys,
        _LCS_MOLRRes_add_LocationEstimate,
        _LCS_MOLRRes_velocityEstimate,
        _LCS_MOLRRes_referenceNumber,
        _LCS_MOLRRes_h_gmlc_address,
        _LCS_MOLRRes_mo_lrShortCircuit,
        _LCS_MOLRRes_reportingPLMNList,
        LCS_MOLRRes,
        DecipheringKeys,
        _LCS_AreaEventRequestArg_referenceNumber,
        _LCS_AreaEventRequestArg_h_gmlc_address,
        _LCS_AreaEventRequestArg_deferredLocationEventType,
        _LCS_AreaEventRequestArg_areaEventInfo,
        LCS_AreaEventRequestArg,
        _LCS_AreaEventReportArg_referenceNumber,
        _LCS_AreaEventReportArg_h_gmlc_address,
        LCS_AreaEventReportArg,
        _LCS_AreaEventCancellationArg_referenceNumber,
        _LCS_AreaEventCancellationArg_h_gmlc_address,
        LCS_AreaEventCancellationArg,
        _LCS_PeriodicLocationRequestArg_referenceNumber,
        _LCS_PeriodicLocationRequestArg_periodicLDRInfo,
        _LCS_PeriodicLocationRequestArg_lcsClientExternalID,
        _LCS_PeriodicLocationRequestArg_qoS,
        _LCS_PeriodicLocationRequestArg_h_gmlc_address,
        _LCS_PeriodicLocationRequestArg_mo_lrShortCircuit,
        _LCS_PeriodicLocationRequestArg_reportingPLMNList,
        LCS_PeriodicLocationRequestArg,
        _LCS_PeriodicLocationRequestRes_mo_lrShortCircuit,
        LCS_PeriodicLocationRequestRes,
        _LCS_LocationUpdateArg_referenceNumber,
        _LCS_LocationUpdateArg_add_LocationEstimate,
        _LCS_LocationUpdateArg_velocityEstimate,
        _LCS_LocationUpdateArg_sequenceNumber,
        LCS_LocationUpdateArg,
        _LCS_LocationUpdateRes_terminationCause,
        LCS_LocationUpdateRes,
        _LCS_PeriodicLocationCancellationArg_referenceNumber,
        _LCS_PeriodicLocationCancellationArg_h_gmlc_address,
        LCS_PeriodicLocationCancellationArg,
    ]

class TCAPMessages:

    _name_  = u'TCAPMessages'
    _oid_   = [0, 0, 17, 773, 2, 1, 3]
    
    _obj_ = [
        u'TCMessage',
        u'Unidirectional',
        u'Begin',
        u'End',
        u'Continue',
        u'Abort',
        u'DialoguePortion',
        u'OrigTransactionID',
        u'DestTransactionID',
        u'P-AbortCause',
        u'ComponentPortion',
        u'Component',
        u'TCInvokeIdSet',
        ]
    _type_ = [
        u'TCMessage',
        u'Unidirectional',
        u'Begin',
        u'End',
        u'Continue',
        u'Abort',
        u'DialoguePortion',
        u'OrigTransactionID',
        u'DestTransactionID',
        u'P-AbortCause',
        u'ComponentPortion',
        u'Component',
        ]
    _set_ = [
        u'TCInvokeIdSet',
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        u'TCMessage',
        u'Unidirectional',
        u'Begin',
        u'End',
        u'Continue',
        u'ComponentPortion',
        u'Component',
        ]
    
    #-----< TCMessage >-----#
    TCMessage = CHOICE(name=u'TCMessage', mode=MODE_TYPE, param=True)
    
    #-----< Unidirectional >-----#
    Unidirectional = SEQ(name=u'Unidirectional', mode=MODE_TYPE, param=True)
    
    #-----< Begin >-----#
    Begin = SEQ(name=u'Begin', mode=MODE_TYPE, param=True)
    
    #-----< End >-----#
    End = SEQ(name=u'End', mode=MODE_TYPE, param=True)
    
    #-----< Continue >-----#
    Continue = SEQ(name=u'Continue', mode=MODE_TYPE, param=True)
    
    #-----< Abort >-----#
    Abort = SEQ(name=u'Abort', mode=MODE_TYPE)
    _Abort_dtid = OCT_STR(name=u'dtid', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DestTransactionID')))
    _Abort_reason = CHOICE(name=u'reason', mode=MODE_TYPE, opt=True)
    __Abort_reason_p_abortCause = INT(name=u'p-abortCause', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'P-AbortCause')))
    __Abort_reason_u_abortCause = EXT(name=u'u-abortCause', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'DialoguePortion')))
    _Abort_reason._cont = ASN1Dict([
        (u'p-abortCause', __Abort_reason_p_abortCause),
        (u'u-abortCause', __Abort_reason_u_abortCause),
        ])
    _Abort_reason._ext = None
    Abort._cont = ASN1Dict([
        (u'dtid', _Abort_dtid),
        (u'reason', _Abort_reason),
        ])
    Abort._ext = None
    
    #-----< DialoguePortion >-----#
    DialoguePortion = EXT(name=u'DialoguePortion', mode=MODE_TYPE, tag=(11, TAG_APPLICATION, TAG_EXPLICIT), typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    
    #-----< OrigTransactionID >-----#
    OrigTransactionID = OCT_STR(name=u'OrigTransactionID', mode=MODE_TYPE, tag=(8, TAG_APPLICATION, TAG_IMPLICIT))
    OrigTransactionID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< DestTransactionID >-----#
    DestTransactionID = OCT_STR(name=u'DestTransactionID', mode=MODE_TYPE, tag=(9, TAG_APPLICATION, TAG_IMPLICIT))
    DestTransactionID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< P-AbortCause >-----#
    P_AbortCause = INT(name=u'P-AbortCause', mode=MODE_TYPE, tag=(10, TAG_APPLICATION, TAG_IMPLICIT))
    P_AbortCause._cont = ASN1Dict([(u'unrecognizedMessageType', 0), (u'unrecognizedTransactionID', 1), (u'badlyFormattedTransactionPortion', 2), (u'incorrectTransactionPortion', 3), (u'resourceLimitation', 4)])
    P_AbortCause._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< ComponentPortion >-----#
    ComponentPortion = SEQ_OF(name=u'ComponentPortion', mode=MODE_TYPE, tag=(12, TAG_APPLICATION, TAG_IMPLICIT), param=True)
    
    #-----< Component >-----#
    Component = CHOICE(name=u'Component', mode=MODE_TYPE, param=True)
    
    #-----< TCInvokeIdSet >-----#
    TCInvokeIdSet = CHOICE(name=u'TCInvokeIdSet', mode=MODE_SET, typeref=ASN1RefType(('Remote-Operations-Generic-ROS-PDUs', 'InvokeId')))
    TCInvokeIdSet._val = ASN1Set(rv=[(u'present', -128), (u'present', -127), (u'present', -126), (u'present', -125), (u'present', -124), (u'present', -123), (u'present', -122), (u'present', -121), (u'present', -120), (u'present', -119), (u'present', -118), (u'present', -117), (u'present', -116), (u'present', -115), (u'present', -114), (u'present', -113), (u'present', -112), (u'present', -111), (u'present', -110), (u'present', -109), (u'present', -108), (u'present', -107), (u'present', -106), (u'present', -105), (u'present', -104), (u'present', -103), (u'present', -102), (u'present', -101), (u'present', -100), (u'present', -99), (u'present', -98), (u'present', -97), (u'present', -96), (u'present', -95), (u'present', -94), (u'present', -93), (u'present', -92), (u'present', -91), (u'present', -90), (u'present', -89), (u'present', -88), (u'present', -87), (u'present', -86), (u'present', -85), (u'present', -84), (u'present', -83), (u'present', -82), (u'present', -81), (u'present', -80), (u'present', -79), (u'present', -78), (u'present', -77), (u'present', -76), (u'present', -75), (u'present', -74), (u'present', -73), (u'present', -72), (u'present', -71), (u'present', -70), (u'present', -69), (u'present', -68), (u'present', -67), (u'present', -66), (u'present', -65), (u'present', -64), (u'present', -63), (u'present', -62), (u'present', -61), (u'present', -60), (u'present', -59), (u'present', -58), (u'present', -57), (u'present', -56), (u'present', -55), (u'present', -54), (u'present', -53), (u'present', -52), (u'present', -51), (u'present', -50), (u'present', -49), (u'present', -48), (u'present', -47), (u'present', -46), (u'present', -45), (u'present', -44), (u'present', -43), (u'present', -42), (u'present', -41), (u'present', -40), (u'present', -39), (u'present', -38), (u'present', -37), (u'present', -36), (u'present', -35), (u'present', -34), (u'present', -33), (u'present', -32), (u'present', -31), (u'present', -30), (u'present', -29), (u'present', -28), (u'present', -27), (u'present', -26), (u'present', -25), (u'present', -24), (u'present', -23), (u'present', -22), (u'present', -21), (u'present', -20), (u'present', -19), (u'present', -18), (u'present', -17), (u'present', -16), (u'present', -15), (u'present', -14), (u'present', -13), (u'present', -12), (u'present', -11), (u'present', -10), (u'present', -9), (u'present', -8), (u'present', -7), (u'present', -6), (u'present', -5), (u'present', -4), (u'present', -3), (u'present', -2), (u'present', -1), (u'present', 0), (u'present', 1), (u'present', 2), (u'present', 3), (u'present', 4), (u'present', 5), (u'present', 6), (u'present', 7), (u'present', 8), (u'present', 9), (u'present', 10), (u'present', 11), (u'present', 12), (u'present', 13), (u'present', 14), (u'present', 15), (u'present', 16), (u'present', 17), (u'present', 18), (u'present', 19), (u'present', 20), (u'present', 21), (u'present', 22), (u'present', 23), (u'present', 24), (u'present', 25), (u'present', 26), (u'present', 27), (u'present', 28), (u'present', 29), (u'present', 30), (u'present', 31), (u'present', 32), (u'present', 33), (u'present', 34), (u'present', 35), (u'present', 36), (u'present', 37), (u'present', 38), (u'present', 39), (u'present', 40), (u'present', 41), (u'present', 42), (u'present', 43), (u'present', 44), (u'present', 45), (u'present', 46), (u'present', 47), (u'present', 48), (u'present', 49), (u'present', 50), (u'present', 51), (u'present', 52), (u'present', 53), (u'present', 54), (u'present', 55), (u'present', 56), (u'present', 57), (u'present', 58), (u'present', 59), (u'present', 60), (u'present', 61), (u'present', 62), (u'present', 63), (u'present', 64), (u'present', 65), (u'present', 66), (u'present', 67), (u'present', 68), (u'present', 69), (u'present', 70), (u'present', 71), (u'present', 72), (u'present', 73), (u'present', 74), (u'present', 75), (u'present', 76), (u'present', 77), (u'present', 78), (u'present', 79), (u'present', 80), (u'present', 81), (u'present', 82), (u'present', 83), (u'present', 84), (u'present', 85), (u'present', 86), (u'present', 87), (u'present', 88), (u'present', 89), (u'present', 90), (u'present', 91), (u'present', 92), (u'present', 93), (u'present', 94), (u'present', 95), (u'present', 96), (u'present', 97), (u'present', 98), (u'present', 99), (u'present', 100), (u'present', 101), (u'present', 102), (u'present', 103), (u'present', 104), (u'present', 105), (u'present', 106), (u'present', 107), (u'present', 108), (u'present', 109), (u'present', 110), (u'present', 111), (u'present', 112), (u'present', 113), (u'present', 114), (u'present', 115), (u'present', 116), (u'present', 117), (u'present', 118), (u'present', 119), (u'present', 120), (u'present', 121), (u'present', 122), (u'present', 123), (u'present', 124), (u'present', 125), (u'present', 126), (u'present', 127)], rr=[], ev=None, er=[])
    
    _all_ = [
        _Abort_dtid,
        __Abort_reason_p_abortCause,
        __Abort_reason_u_abortCause,
        _Abort_reason,
        Abort,
        DialoguePortion,
        OrigTransactionID,
        DestTransactionID,
        P_AbortCause,
        TCInvokeIdSet,
    ]

class TC_Notation_Extensions:

    _name_  = u'TC-Notation-Extensions'
    _oid_   = [0, 0, 17, 775, 2, 4, 1]
    
    _obj_ = [
        u'APPLICATION-CONTEXT',
        u'DialogueMode',
        u'Termination',
        u'dialogue-abstract-syntax',
        u'uniDialogue-abstract-syntax',
        u'TCSingleAS',
        u'TCConsumerAS',
        u'TCSupplierAS',
        u'ConnectionAS',
        ]
    _type_ = [
        u'APPLICATION-CONTEXT',
        u'DialogueMode',
        u'Termination',
        u'TCSingleAS',
        u'TCConsumerAS',
        u'TCSupplierAS',
        u'ConnectionAS',
        ]
    _set_ = [
        ]
    _val_ = [
        u'dialogue-abstract-syntax',
        u'uniDialogue-abstract-syntax',
        ]
    _class_ = [
        u'APPLICATION-CONTEXT',
        u'dialogue-abstract-syntax',
        u'uniDialogue-abstract-syntax',
        ]
    _param_ = [
        u'TCSingleAS',
        u'TCConsumerAS',
        u'TCSupplierAS',
        u'ConnectionAS',
        ]
    
    #-----< APPLICATION-CONTEXT >-----#
    APPLICATION_CONTEXT = CLASS(name=u'APPLICATION-CONTEXT', mode=MODE_TYPE)
    _APPLICATION_CONTEXT_associationContract = CLASS(name=u'associationContract', mode=MODE_VALUE, typeref=ASN1RefType(('Remote-Operations-Information-Objects', 'CONTRACT')))
    _APPLICATION_CONTEXT_dialogueMode = ENUM(name=u'dialogueMode', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'DialogueMode')))
    _APPLICATION_CONTEXT_termination = ENUM(name=u'termination', mode=MODE_VALUE, typeref=ASN1RefType(('TC-Notation-Extensions', 'Termination')), opt=True)
    _APPLICATION_CONTEXT_componentGrouping = BOOL(name=u'componentGrouping', mode=MODE_VALUE, default=True)
    _APPLICATION_CONTEXT_dialogueAndComponentGrouping = BOOL(name=u'dialogueAndComponentGrouping', mode=MODE_VALUE, default=True)
    _APPLICATION_CONTEXT_AdditionalASEs = OID(name=u'AdditionalASEs', mode=MODE_SET, opt=True)
    _APPLICATION_CONTEXT_AbstractSyntaxes = CLASS(name=u'AbstractSyntaxes', mode=MODE_SET, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _APPLICATION_CONTEXT_applicationContextName = OID(name=u'applicationContextName', mode=MODE_VALUE, uniq=True)
    APPLICATION_CONTEXT._cont = ASN1Dict([
        (u'associationContract', _APPLICATION_CONTEXT_associationContract),
        (u'dialogueMode', _APPLICATION_CONTEXT_dialogueMode),
        (u'termination', _APPLICATION_CONTEXT_termination),
        (u'componentGrouping', _APPLICATION_CONTEXT_componentGrouping),
        (u'dialogueAndComponentGrouping', _APPLICATION_CONTEXT_dialogueAndComponentGrouping),
        (u'AdditionalASEs', _APPLICATION_CONTEXT_AdditionalASEs),
        (u'AbstractSyntaxes', _APPLICATION_CONTEXT_AbstractSyntaxes),
        (u'applicationContextName', _APPLICATION_CONTEXT_applicationContextName),
        ])
    
    #-----< DialogueMode >-----#
    DialogueMode = ENUM(name=u'DialogueMode', mode=MODE_TYPE)
    DialogueMode._cont = ASN1Dict([(u'structured', 1), (u'unstructured', 2)])
    DialogueMode._ext = None
    
    #-----< Termination >-----#
    Termination = ENUM(name=u'Termination', mode=MODE_TYPE)
    Termination._cont = ASN1Dict([(u'basic', 1), (u'prearranged', 2)])
    Termination._ext = None
    
    #-----< dialogue-abstract-syntax >-----#
    dialogue_abstract_syntax = CLASS(name=u'dialogue-abstract-syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _dialogue_abstract_syntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('DialoguePDUs', 'DialoguePDU')))
    dialogue_abstract_syntax._val = dict([('Type', _dialogue_abstract_syntax_val_Type), ('id', (0, 0, 17, 773, 1, 1, 1))])
    
    #-----< uniDialogue-abstract-syntax >-----#
    uniDialogue_abstract_syntax = CLASS(name=u'uniDialogue-abstract-syntax', mode=MODE_VALUE, typeref=ASN1RefType(('_IMPL_', u'ABSTRACT-SYNTAX'), []))
    _uniDialogue_abstract_syntax_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('UnidialoguePDUs', 'UniDialoguePDU')))
    uniDialogue_abstract_syntax._val = dict([('Type', _uniDialogue_abstract_syntax_val_Type), ('id', (0, 0, 17, 773, 1, 2, 1))])
    
    #-----< TCSingleAS >-----#
    TCSingleAS = CHOICE(name=u'TCSingleAS', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')), param=True)
    
    #-----< TCConsumerAS >-----#
    TCConsumerAS = CHOICE(name=u'TCConsumerAS', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')), param=True)
    
    #-----< TCSupplierAS >-----#
    TCSupplierAS = CHOICE(name=u'TCSupplierAS', mode=MODE_TYPE, typeref=ASN1RefType(('TCAPMessages', 'TCMessage')), param=True)
    
    #-----< ConnectionAS >-----#
    ConnectionAS = CHOICE(name=u'ConnectionAS', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _APPLICATION_CONTEXT_associationContract,
        _APPLICATION_CONTEXT_dialogueMode,
        _APPLICATION_CONTEXT_termination,
        _APPLICATION_CONTEXT_componentGrouping,
        _APPLICATION_CONTEXT_dialogueAndComponentGrouping,
        _APPLICATION_CONTEXT_AdditionalASEs,
        _APPLICATION_CONTEXT_AbstractSyntaxes,
        _APPLICATION_CONTEXT_applicationContextName,
        APPLICATION_CONTEXT,
        DialogueMode,
        Termination,
        dialogue_abstract_syntax,
        _dialogue_abstract_syntax_val_Type,
        uniDialogue_abstract_syntax,
        _uniDialogue_abstract_syntax_val_Type,
    ]

class UnidialoguePDUs:

    _name_  = u'UnidialoguePDUs'
    _oid_   = [0, 0, 17, 773, 2, 3, 1]
    
    _obj_ = [
        u'uniDialogue-as-id',
        u'UniDialoguePDU',
        u'AUDT-apdu',
        ]
    _type_ = [
        u'UniDialoguePDU',
        u'AUDT-apdu',
        ]
    _set_ = [
        ]
    _val_ = [
        u'uniDialogue-as-id',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< uniDialogue-as-id >-----#
    uniDialogue_as_id = OID(name=u'uniDialogue-as-id', mode=MODE_VALUE)
    uniDialogue_as_id._val = (0, 0, 17, 773, 1, 2, 1)
    
    #-----< UniDialoguePDU >-----#
    UniDialoguePDU = CHOICE(name=u'UniDialoguePDU', mode=MODE_TYPE)
    _UniDialoguePDU_unidialoguePDU = SEQ(name=u'unidialoguePDU', mode=MODE_TYPE, typeref=ASN1RefType(('UnidialoguePDUs', 'AUDT-apdu')))
    UniDialoguePDU._cont = ASN1Dict([
        (u'unidialoguePDU', _UniDialoguePDU_unidialoguePDU),
        ])
    UniDialoguePDU._ext = None
    
    #-----< AUDT-apdu >-----#
    AUDT_apdu = SEQ(name=u'AUDT-apdu', mode=MODE_TYPE, tag=(0, TAG_APPLICATION, TAG_IMPLICIT))
    _AUDT_apdu_protocol_version = BIT_STR(name=u'protocol-version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=(1, 1))
    _AUDT_apdu_protocol_version._cont = ASN1Dict([(u'version1', 0)])
    _AUDT_apdu_application_context_name = OID(name=u'application-context-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _AUDT_apdu_user_information = SEQ_OF(name=u'user-information', mode=MODE_TYPE, tag=(30, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AUDT_apdu_user_information__item_ = EXT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'EXTERNAL')))
    _AUDT_apdu_user_information._cont = __AUDT_apdu_user_information__item_
    AUDT_apdu._cont = ASN1Dict([
        (u'protocol-version', _AUDT_apdu_protocol_version),
        (u'application-context-name', _AUDT_apdu_application_context_name),
        (u'user-information', _AUDT_apdu_user_information),
        ])
    AUDT_apdu._ext = None
    
    _all_ = [
        uniDialogue_as_id,
        _UniDialoguePDU_unidialoguePDU,
        UniDialoguePDU,
        _AUDT_apdu_protocol_version,
        _AUDT_apdu_application_context_name,
        __AUDT_apdu_user_information__item_,
        _AUDT_apdu_user_information,
        AUDT_apdu,
    ]

class UsefulDefinitions:

    _name_  = u'UsefulDefinitions'
    _oid_   = [2, 5, 1, 0, 8]
    
    _obj_ = [
        u'ID',
        u'ds',
        u'id',
        u'internet',
        u'ldap-dir',
        u'intSecurity',
        u'ldap-enterprise',
        u'ldap-x509',
        u'ldap-openLDAP',
        u'openLDAP-attributes',
        u'openLDAP-controls',
        u'ldap-wall',
        u'ldap-dynExt',
        u'ldap-attr',
        u'ldap-match',
        u'ldap-syntax',
        u'cosine',
        u'cosineAttr',
        u'module',
        u'serviceElement',
        u'applicationContext',
        u'attributeType',
        u'attributeSyntaxVendor',
        u'objectClass',
        u'algorithm',
        u'abstractSyntax',
        u'dsaOperationalAttribute',
        u'matchingRule',
        u'knowledgeMatchingRule',
        u'nameForm',
        u'group',
        u'subentry',
        u'operationalAttributeType',
        u'operationalBinding',
        u'schemaObjectClass',
        u'schemaOperationalAttribute',
        u'administrativeRoles',
        u'accessControlAttribute',
        u'accessControlSchemes',
        u'certificateExtension',
        u'managementObject',
        u'attributeValueContext',
        u'idmProtocol',
        u'problem',
        u'notification',
        u'matchingRestriction',
        u'controlAttributeType',
        u'keyPurposes',
        u'passwordQuality',
        u'attributeSyntax',
        u'avRestriction',
        u'cmsContentType',
        u'usefulDefinitions',
        u'informationFramework',
        u'directoryAbstractService',
        u'distributedOperations',
        u'selectedAttributeTypes',
        u'selectedObjectClasses',
        u'authenticationFramework',
        u'algorithmObjectIdentifiers',
        u'directoryObjectIdentifiers',
        u'distributedDirectoryOIDs',
        u'directoryShadowOIDs',
        u'directoryShadowAbstractService',
        u'opBindingManagement',
        u'opBindingOIDs',
        u'hierarchicalOperationalBindings',
        u'dsaOperationalAttributeTypes',
        u'schemaAdministration',
        u'basicAccessControl',
        u'directoryOperationalBindingTypes',
        u'certificateExtensions',
        u'directoryManagement',
        u'enhancedSecurity',
        u'iDMProtocolSpecification',
        u'directoryIDMProtocols',
        u'attributeCertificateDefinitions',
        u'serviceAdministration',
        u'ldapAttributes',
        u'commonProtocolSpecification',
        u'oSIProtocolSpecification',
        u'directoryOSIProtocols',
        u'ldapSystemSchema',
        u'passwordPolicy',
        u'pkiPmiExternalDataTypes',
        u'extensionAttributes',
        u'pkiPmiWrapper',
        u'avlManagement',
        u'trustBrokerProtocol',
        u'id-oc',
        u'id-at',
        u'id-as',
        u'id-mr',
        u'id-nf',
        u'id-sc',
        u'id-oa',
        u'id-ob',
        u'id-doa',
        u'id-kmr',
        u'id-soc',
        u'id-soa',
        u'id-ar',
        u'id-aca',
        u'id-ac',
        u'id-acScheme',
        u'id-ce',
        u'id-mgt',
        u'id-avc',
        u'id-idm',
        u'id-pr',
        u'id-not',
        u'id-mre',
        u'id-cat',
        u'id-kp',
        u'id-pq',
        u'id-ats',
        u'id-asx',
        u'id-lsx',
        u'id-ldx',
        u'id-lat',
        u'id-lmr',
        u'id-oat',
        u'id-coat',
        u'id-avr',
        u'id-cmsct',
        ]
    _type_ = [
        u'ID',
        ]
    _set_ = [
        ]
    _val_ = [
        u'ds',
        u'id',
        u'internet',
        u'ldap-dir',
        u'intSecurity',
        u'ldap-enterprise',
        u'ldap-x509',
        u'ldap-openLDAP',
        u'openLDAP-attributes',
        u'openLDAP-controls',
        u'ldap-wall',
        u'ldap-dynExt',
        u'ldap-attr',
        u'ldap-match',
        u'ldap-syntax',
        u'cosine',
        u'cosineAttr',
        u'module',
        u'serviceElement',
        u'applicationContext',
        u'attributeType',
        u'attributeSyntaxVendor',
        u'objectClass',
        u'algorithm',
        u'abstractSyntax',
        u'dsaOperationalAttribute',
        u'matchingRule',
        u'knowledgeMatchingRule',
        u'nameForm',
        u'group',
        u'subentry',
        u'operationalAttributeType',
        u'operationalBinding',
        u'schemaObjectClass',
        u'schemaOperationalAttribute',
        u'administrativeRoles',
        u'accessControlAttribute',
        u'accessControlSchemes',
        u'certificateExtension',
        u'managementObject',
        u'attributeValueContext',
        u'idmProtocol',
        u'problem',
        u'notification',
        u'matchingRestriction',
        u'controlAttributeType',
        u'keyPurposes',
        u'passwordQuality',
        u'attributeSyntax',
        u'avRestriction',
        u'cmsContentType',
        u'usefulDefinitions',
        u'informationFramework',
        u'directoryAbstractService',
        u'distributedOperations',
        u'selectedAttributeTypes',
        u'selectedObjectClasses',
        u'authenticationFramework',
        u'algorithmObjectIdentifiers',
        u'directoryObjectIdentifiers',
        u'distributedDirectoryOIDs',
        u'directoryShadowOIDs',
        u'directoryShadowAbstractService',
        u'opBindingManagement',
        u'opBindingOIDs',
        u'hierarchicalOperationalBindings',
        u'dsaOperationalAttributeTypes',
        u'schemaAdministration',
        u'basicAccessControl',
        u'directoryOperationalBindingTypes',
        u'certificateExtensions',
        u'directoryManagement',
        u'enhancedSecurity',
        u'iDMProtocolSpecification',
        u'directoryIDMProtocols',
        u'attributeCertificateDefinitions',
        u'serviceAdministration',
        u'ldapAttributes',
        u'commonProtocolSpecification',
        u'oSIProtocolSpecification',
        u'directoryOSIProtocols',
        u'ldapSystemSchema',
        u'passwordPolicy',
        u'pkiPmiExternalDataTypes',
        u'extensionAttributes',
        u'pkiPmiWrapper',
        u'avlManagement',
        u'trustBrokerProtocol',
        u'id-oc',
        u'id-at',
        u'id-as',
        u'id-mr',
        u'id-nf',
        u'id-sc',
        u'id-oa',
        u'id-ob',
        u'id-doa',
        u'id-kmr',
        u'id-soc',
        u'id-soa',
        u'id-ar',
        u'id-aca',
        u'id-ac',
        u'id-acScheme',
        u'id-ce',
        u'id-mgt',
        u'id-avc',
        u'id-idm',
        u'id-pr',
        u'id-not',
        u'id-mre',
        u'id-cat',
        u'id-kp',
        u'id-pq',
        u'id-ats',
        u'id-asx',
        u'id-lsx',
        u'id-ldx',
        u'id-lat',
        u'id-lmr',
        u'id-oat',
        u'id-coat',
        u'id-avr',
        u'id-cmsct',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< ID >-----#
    ID = OID(name=u'ID', mode=MODE_TYPE)
    
    #-----< ds >-----#
    ds = OID(name=u'ds', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ds._val = (2, 5)
    
    #-----< id >-----#
    id = OID(name=u'id', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id._val = (2, 17, 1, 2)
    
    #-----< internet >-----#
    internet = OID(name=u'internet', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    internet._val = (1, 3, 6, 1)
    
    #-----< ldap-dir >-----#
    ldap_dir = OID(name=u'ldap-dir', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_dir._val = (1, 3, 6, 1, 1)
    
    #-----< intSecurity >-----#
    intSecurity = OID(name=u'intSecurity', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    intSecurity._val = (1, 3, 6, 1, 5)
    
    #-----< ldap-enterprise >-----#
    ldap_enterprise = OID(name=u'ldap-enterprise', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_enterprise._val = (1, 3, 6, 1, 4, 1)
    
    #-----< ldap-x509 >-----#
    ldap_x509 = OID(name=u'ldap-x509', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_x509._val = (1, 3, 6, 1, 1, 15)
    
    #-----< ldap-openLDAP >-----#
    ldap_openLDAP = OID(name=u'ldap-openLDAP', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_openLDAP._val = (1, 3, 6, 1, 4, 1, 4203, 1)
    
    #-----< openLDAP-attributes >-----#
    openLDAP_attributes = OID(name=u'openLDAP-attributes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    openLDAP_attributes._val = (1, 3, 6, 1, 4, 1, 4203, 1, 3)
    
    #-----< openLDAP-controls >-----#
    openLDAP_controls = OID(name=u'openLDAP-controls', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    openLDAP_controls._val = (1, 3, 6, 1, 4, 1, 4203, 1, 10)
    
    #-----< ldap-wall >-----#
    ldap_wall = OID(name=u'ldap-wall', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_wall._val = (1, 3, 6, 1, 4, 1, 1466)
    
    #-----< ldap-dynExt >-----#
    ldap_dynExt = OID(name=u'ldap-dynExt', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_dynExt._val = (1, 3, 6, 1, 4, 1, 1466, 101, 119)
    
    #-----< ldap-attr >-----#
    ldap_attr = OID(name=u'ldap-attr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_attr._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120)
    
    #-----< ldap-match >-----#
    ldap_match = OID(name=u'ldap-match', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_match._val = (1, 3, 6, 1, 4, 1, 1466, 109, 114)
    
    #-----< ldap-syntax >-----#
    ldap_syntax = OID(name=u'ldap-syntax', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldap_syntax._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1)
    
    #-----< cosine >-----#
    cosine = OID(name=u'cosine', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    cosine._val = (0, 9, 2342, 19200300, 100)
    
    #-----< cosineAttr >-----#
    cosineAttr = OID(name=u'cosineAttr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    cosineAttr._val = (0, 9, 2342, 19200300, 100, 1)
    
    #-----< module >-----#
    module = OID(name=u'module', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    module._val = (2, 5, 1)
    
    #-----< serviceElement >-----#
    serviceElement = OID(name=u'serviceElement', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    serviceElement._val = (2, 5, 2)
    
    #-----< applicationContext >-----#
    applicationContext = OID(name=u'applicationContext', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    applicationContext._val = (2, 5, 3)
    
    #-----< attributeType >-----#
    attributeType = OID(name=u'attributeType', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    attributeType._val = (2, 5, 4)
    
    #-----< attributeSyntaxVendor >-----#
    attributeSyntaxVendor = OID(name=u'attributeSyntaxVendor', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    attributeSyntaxVendor._val = (2, 5, 5)
    
    #-----< objectClass >-----#
    objectClass = OID(name=u'objectClass', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    objectClass._val = (2, 5, 6)
    
    #-----< algorithm >-----#
    algorithm = OID(name=u'algorithm', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    algorithm._val = (2, 5, 8)
    
    #-----< abstractSyntax >-----#
    abstractSyntax = OID(name=u'abstractSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    abstractSyntax._val = (2, 5, 9)
    
    #-----< dsaOperationalAttribute >-----#
    dsaOperationalAttribute = OID(name=u'dsaOperationalAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    dsaOperationalAttribute._val = (2, 5, 12)
    
    #-----< matchingRule >-----#
    matchingRule = OID(name=u'matchingRule', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    matchingRule._val = (2, 5, 13)
    
    #-----< knowledgeMatchingRule >-----#
    knowledgeMatchingRule = OID(name=u'knowledgeMatchingRule', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    knowledgeMatchingRule._val = (2, 5, 14)
    
    #-----< nameForm >-----#
    nameForm = OID(name=u'nameForm', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    nameForm._val = (2, 5, 15)
    
    #-----< group >-----#
    group = OID(name=u'group', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    group._val = (2, 5, 16)
    
    #-----< subentry >-----#
    subentry = OID(name=u'subentry', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    subentry._val = (2, 5, 17)
    
    #-----< operationalAttributeType >-----#
    operationalAttributeType = OID(name=u'operationalAttributeType', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    operationalAttributeType._val = (2, 5, 18)
    
    #-----< operationalBinding >-----#
    operationalBinding = OID(name=u'operationalBinding', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    operationalBinding._val = (2, 5, 19)
    
    #-----< schemaObjectClass >-----#
    schemaObjectClass = OID(name=u'schemaObjectClass', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    schemaObjectClass._val = (2, 5, 20)
    
    #-----< schemaOperationalAttribute >-----#
    schemaOperationalAttribute = OID(name=u'schemaOperationalAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    schemaOperationalAttribute._val = (2, 5, 21)
    
    #-----< administrativeRoles >-----#
    administrativeRoles = OID(name=u'administrativeRoles', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    administrativeRoles._val = (2, 5, 23)
    
    #-----< accessControlAttribute >-----#
    accessControlAttribute = OID(name=u'accessControlAttribute', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    accessControlAttribute._val = (2, 5, 24)
    
    #-----< accessControlSchemes >-----#
    accessControlSchemes = OID(name=u'accessControlSchemes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    accessControlSchemes._val = (2, 5, 28)
    
    #-----< certificateExtension >-----#
    certificateExtension = OID(name=u'certificateExtension', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    certificateExtension._val = (2, 5, 29)
    
    #-----< managementObject >-----#
    managementObject = OID(name=u'managementObject', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    managementObject._val = (2, 5, 30)
    
    #-----< attributeValueContext >-----#
    attributeValueContext = OID(name=u'attributeValueContext', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    attributeValueContext._val = (2, 5, 31)
    
    #-----< idmProtocol >-----#
    idmProtocol = OID(name=u'idmProtocol', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    idmProtocol._val = (2, 5, 33)
    
    #-----< problem >-----#
    problem = OID(name=u'problem', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    problem._val = (2, 5, 34)
    
    #-----< notification >-----#
    notification = OID(name=u'notification', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    notification._val = (2, 5, 35)
    
    #-----< matchingRestriction >-----#
    matchingRestriction = OID(name=u'matchingRestriction', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    matchingRestriction._val = (2, 5, 36)
    
    #-----< controlAttributeType >-----#
    controlAttributeType = OID(name=u'controlAttributeType', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    controlAttributeType._val = (2, 5, 37)
    
    #-----< keyPurposes >-----#
    keyPurposes = OID(name=u'keyPurposes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    keyPurposes._val = (2, 5, 38)
    
    #-----< passwordQuality >-----#
    passwordQuality = OID(name=u'passwordQuality', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    passwordQuality._val = (2, 5, 39)
    
    #-----< attributeSyntax >-----#
    attributeSyntax = OID(name=u'attributeSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    attributeSyntax._val = (2, 5, 40)
    
    #-----< avRestriction >-----#
    avRestriction = OID(name=u'avRestriction', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    avRestriction._val = (2, 5, 41)
    
    #-----< cmsContentType >-----#
    cmsContentType = OID(name=u'cmsContentType', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    cmsContentType._val = (2, 5, 42)
    
    #-----< usefulDefinitions >-----#
    usefulDefinitions = OID(name=u'usefulDefinitions', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    usefulDefinitions._val = (2, 5, 1, 0, 8)
    
    #-----< informationFramework >-----#
    informationFramework = OID(name=u'informationFramework', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    informationFramework._val = (2, 5, 1, 1, 8)
    
    #-----< directoryAbstractService >-----#
    directoryAbstractService = OID(name=u'directoryAbstractService', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryAbstractService._val = (2, 5, 1, 2, 8)
    
    #-----< distributedOperations >-----#
    distributedOperations = OID(name=u'distributedOperations', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    distributedOperations._val = (2, 5, 1, 3, 8)
    
    #-----< selectedAttributeTypes >-----#
    selectedAttributeTypes = OID(name=u'selectedAttributeTypes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    selectedAttributeTypes._val = (2, 5, 1, 5, 8)
    
    #-----< selectedObjectClasses >-----#
    selectedObjectClasses = OID(name=u'selectedObjectClasses', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    selectedObjectClasses._val = (2, 5, 1, 6, 8)
    
    #-----< authenticationFramework >-----#
    authenticationFramework = OID(name=u'authenticationFramework', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    authenticationFramework._val = (2, 5, 1, 7, 8)
    
    #-----< algorithmObjectIdentifiers >-----#
    algorithmObjectIdentifiers = OID(name=u'algorithmObjectIdentifiers', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    algorithmObjectIdentifiers._val = (2, 5, 1, 8, 8)
    
    #-----< directoryObjectIdentifiers >-----#
    directoryObjectIdentifiers = OID(name=u'directoryObjectIdentifiers', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryObjectIdentifiers._val = (2, 5, 1, 9, 8)
    
    #-----< distributedDirectoryOIDs >-----#
    distributedDirectoryOIDs = OID(name=u'distributedDirectoryOIDs', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    distributedDirectoryOIDs._val = (2, 5, 1, 13, 8)
    
    #-----< directoryShadowOIDs >-----#
    directoryShadowOIDs = OID(name=u'directoryShadowOIDs', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryShadowOIDs._val = (2, 5, 1, 14, 8)
    
    #-----< directoryShadowAbstractService >-----#
    directoryShadowAbstractService = OID(name=u'directoryShadowAbstractService', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryShadowAbstractService._val = (2, 5, 1, 15, 8)
    
    #-----< opBindingManagement >-----#
    opBindingManagement = OID(name=u'opBindingManagement', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    opBindingManagement._val = (2, 5, 1, 18, 8)
    
    #-----< opBindingOIDs >-----#
    opBindingOIDs = OID(name=u'opBindingOIDs', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    opBindingOIDs._val = (2, 5, 1, 19, 8)
    
    #-----< hierarchicalOperationalBindings >-----#
    hierarchicalOperationalBindings = OID(name=u'hierarchicalOperationalBindings', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    hierarchicalOperationalBindings._val = (2, 5, 1, 20, 8)
    
    #-----< dsaOperationalAttributeTypes >-----#
    dsaOperationalAttributeTypes = OID(name=u'dsaOperationalAttributeTypes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    dsaOperationalAttributeTypes._val = (2, 5, 1, 22, 8)
    
    #-----< schemaAdministration >-----#
    schemaAdministration = OID(name=u'schemaAdministration', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    schemaAdministration._val = (2, 5, 1, 23, 8)
    
    #-----< basicAccessControl >-----#
    basicAccessControl = OID(name=u'basicAccessControl', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    basicAccessControl._val = (2, 5, 1, 24, 8)
    
    #-----< directoryOperationalBindingTypes >-----#
    directoryOperationalBindingTypes = OID(name=u'directoryOperationalBindingTypes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryOperationalBindingTypes._val = (2, 5, 1, 25, 8)
    
    #-----< certificateExtensions >-----#
    certificateExtensions = OID(name=u'certificateExtensions', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    certificateExtensions._val = (2, 5, 1, 26, 8)
    
    #-----< directoryManagement >-----#
    directoryManagement = OID(name=u'directoryManagement', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryManagement._val = (2, 5, 1, 27, 8)
    
    #-----< enhancedSecurity >-----#
    enhancedSecurity = OID(name=u'enhancedSecurity', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    enhancedSecurity._val = (2, 5, 1, 28, 8)
    
    #-----< iDMProtocolSpecification >-----#
    iDMProtocolSpecification = OID(name=u'iDMProtocolSpecification', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    iDMProtocolSpecification._val = (2, 5, 1, 30, 8)
    
    #-----< directoryIDMProtocols >-----#
    directoryIDMProtocols = OID(name=u'directoryIDMProtocols', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryIDMProtocols._val = (2, 5, 1, 31, 8)
    
    #-----< attributeCertificateDefinitions >-----#
    attributeCertificateDefinitions = OID(name=u'attributeCertificateDefinitions', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    attributeCertificateDefinitions._val = (2, 5, 1, 32, 8)
    
    #-----< serviceAdministration >-----#
    serviceAdministration = OID(name=u'serviceAdministration', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    serviceAdministration._val = (2, 5, 1, 33, 8)
    
    #-----< ldapAttributes >-----#
    ldapAttributes = OID(name=u'ldapAttributes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldapAttributes._val = (2, 5, 1, 34, 8)
    
    #-----< commonProtocolSpecification >-----#
    commonProtocolSpecification = OID(name=u'commonProtocolSpecification', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    commonProtocolSpecification._val = (2, 5, 1, 35, 8)
    
    #-----< oSIProtocolSpecification >-----#
    oSIProtocolSpecification = OID(name=u'oSIProtocolSpecification', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    oSIProtocolSpecification._val = (2, 5, 1, 36, 8)
    
    #-----< directoryOSIProtocols >-----#
    directoryOSIProtocols = OID(name=u'directoryOSIProtocols', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    directoryOSIProtocols._val = (2, 5, 1, 37, 8)
    
    #-----< ldapSystemSchema >-----#
    ldapSystemSchema = OID(name=u'ldapSystemSchema', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    ldapSystemSchema._val = (2, 5, 1, 38, 8)
    
    #-----< passwordPolicy >-----#
    passwordPolicy = OID(name=u'passwordPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    passwordPolicy._val = (2, 5, 1, 39, 8)
    
    #-----< pkiPmiExternalDataTypes >-----#
    pkiPmiExternalDataTypes = OID(name=u'pkiPmiExternalDataTypes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    pkiPmiExternalDataTypes._val = (2, 5, 1, 40, 8)
    
    #-----< extensionAttributes >-----#
    extensionAttributes = OID(name=u'extensionAttributes', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    extensionAttributes._val = (2, 5, 1, 41, 8)
    
    #-----< pkiPmiWrapper >-----#
    pkiPmiWrapper = OID(name=u'pkiPmiWrapper', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    pkiPmiWrapper._val = (2, 5, 1, 42, 8)
    
    #-----< avlManagement >-----#
    avlManagement = OID(name=u'avlManagement', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    avlManagement._val = (2, 5, 1, 43, 8)
    
    #-----< trustBrokerProtocol >-----#
    trustBrokerProtocol = OID(name=u'trustBrokerProtocol', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    trustBrokerProtocol._val = (2, 5, 1, 44, 8)
    
    #-----< id-oc >-----#
    id_oc = OID(name=u'id-oc', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_oc._val = (2, 5, 6)
    
    #-----< id-at >-----#
    id_at = OID(name=u'id-at', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_at._val = (2, 5, 4)
    
    #-----< id-as >-----#
    id_as = OID(name=u'id-as', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_as._val = (2, 5, 9)
    
    #-----< id-mr >-----#
    id_mr = OID(name=u'id-mr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_mr._val = (2, 5, 13)
    
    #-----< id-nf >-----#
    id_nf = OID(name=u'id-nf', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_nf._val = (2, 5, 15)
    
    #-----< id-sc >-----#
    id_sc = OID(name=u'id-sc', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_sc._val = (2, 5, 17)
    
    #-----< id-oa >-----#
    id_oa = OID(name=u'id-oa', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_oa._val = (2, 5, 18)
    
    #-----< id-ob >-----#
    id_ob = OID(name=u'id-ob', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ob._val = (2, 5, 19)
    
    #-----< id-doa >-----#
    id_doa = OID(name=u'id-doa', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_doa._val = (2, 5, 12)
    
    #-----< id-kmr >-----#
    id_kmr = OID(name=u'id-kmr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_kmr._val = (2, 5, 14)
    
    #-----< id-soc >-----#
    id_soc = OID(name=u'id-soc', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_soc._val = (2, 5, 20)
    
    #-----< id-soa >-----#
    id_soa = OID(name=u'id-soa', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_soa._val = (2, 5, 21)
    
    #-----< id-ar >-----#
    id_ar = OID(name=u'id-ar', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ar._val = (2, 5, 23)
    
    #-----< id-aca >-----#
    id_aca = OID(name=u'id-aca', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_aca._val = (2, 5, 24)
    
    #-----< id-ac >-----#
    id_ac = OID(name=u'id-ac', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ac._val = (2, 5, 3)
    
    #-----< id-acScheme >-----#
    id_acScheme = OID(name=u'id-acScheme', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_acScheme._val = (2, 5, 28)
    
    #-----< id-ce >-----#
    id_ce = OID(name=u'id-ce', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ce._val = (2, 5, 29)
    
    #-----< id-mgt >-----#
    id_mgt = OID(name=u'id-mgt', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_mgt._val = (2, 5, 30)
    
    #-----< id-avc >-----#
    id_avc = OID(name=u'id-avc', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_avc._val = (2, 5, 31)
    
    #-----< id-idm >-----#
    id_idm = OID(name=u'id-idm', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_idm._val = (2, 5, 33)
    
    #-----< id-pr >-----#
    id_pr = OID(name=u'id-pr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_pr._val = (2, 5, 34)
    
    #-----< id-not >-----#
    id_not = OID(name=u'id-not', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_not._val = (2, 5, 35)
    
    #-----< id-mre >-----#
    id_mre = OID(name=u'id-mre', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_mre._val = (2, 5, 36)
    
    #-----< id-cat >-----#
    id_cat = OID(name=u'id-cat', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_cat._val = (2, 5, 37)
    
    #-----< id-kp >-----#
    id_kp = OID(name=u'id-kp', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_kp._val = (2, 5, 38)
    
    #-----< id-pq >-----#
    id_pq = OID(name=u'id-pq', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_pq._val = (2, 5, 39)
    
    #-----< id-ats >-----#
    id_ats = OID(name=u'id-ats', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ats._val = (2, 5, 40)
    
    #-----< id-asx >-----#
    id_asx = OID(name=u'id-asx', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_asx._val = (2, 5, 40)
    
    #-----< id-lsx >-----#
    id_lsx = OID(name=u'id-lsx', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_lsx._val = (1, 3, 6, 1, 4, 1, 1466, 115, 121, 1)
    
    #-----< id-ldx >-----#
    id_ldx = OID(name=u'id-ldx', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_ldx._val = (1, 3, 6, 1, 1, 15)
    
    #-----< id-lat >-----#
    id_lat = OID(name=u'id-lat', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_lat._val = (1, 3, 6, 1, 4, 1, 1466, 101, 120)
    
    #-----< id-lmr >-----#
    id_lmr = OID(name=u'id-lmr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_lmr._val = (1, 3, 6, 1, 4, 1, 1466, 109, 114)
    
    #-----< id-oat >-----#
    id_oat = OID(name=u'id-oat', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_oat._val = (1, 3, 6, 1, 4, 1, 4203, 1, 3)
    
    #-----< id-coat >-----#
    id_coat = OID(name=u'id-coat', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_coat._val = (0, 9, 2342, 19200300, 100, 1)
    
    #-----< id-avr >-----#
    id_avr = OID(name=u'id-avr', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_avr._val = (2, 5, 41)
    
    #-----< id-cmsct >-----#
    id_cmsct = OID(name=u'id-cmsct', mode=MODE_VALUE, typeref=ASN1RefType(('UsefulDefinitions', 'ID')))
    id_cmsct._val = (2, 5, 42)
    
    _all_ = [
        ID,
        ds,
        id,
        internet,
        ldap_dir,
        intSecurity,
        ldap_enterprise,
        ldap_x509,
        ldap_openLDAP,
        openLDAP_attributes,
        openLDAP_controls,
        ldap_wall,
        ldap_dynExt,
        ldap_attr,
        ldap_match,
        ldap_syntax,
        cosine,
        cosineAttr,
        module,
        serviceElement,
        applicationContext,
        attributeType,
        attributeSyntaxVendor,
        objectClass,
        algorithm,
        abstractSyntax,
        dsaOperationalAttribute,
        matchingRule,
        knowledgeMatchingRule,
        nameForm,
        group,
        subentry,
        operationalAttributeType,
        operationalBinding,
        schemaObjectClass,
        schemaOperationalAttribute,
        administrativeRoles,
        accessControlAttribute,
        accessControlSchemes,
        certificateExtension,
        managementObject,
        attributeValueContext,
        idmProtocol,
        problem,
        notification,
        matchingRestriction,
        controlAttributeType,
        keyPurposes,
        passwordQuality,
        attributeSyntax,
        avRestriction,
        cmsContentType,
        usefulDefinitions,
        informationFramework,
        directoryAbstractService,
        distributedOperations,
        selectedAttributeTypes,
        selectedObjectClasses,
        authenticationFramework,
        algorithmObjectIdentifiers,
        directoryObjectIdentifiers,
        distributedDirectoryOIDs,
        directoryShadowOIDs,
        directoryShadowAbstractService,
        opBindingManagement,
        opBindingOIDs,
        hierarchicalOperationalBindings,
        dsaOperationalAttributeTypes,
        schemaAdministration,
        basicAccessControl,
        directoryOperationalBindingTypes,
        certificateExtensions,
        directoryManagement,
        enhancedSecurity,
        iDMProtocolSpecification,
        directoryIDMProtocols,
        attributeCertificateDefinitions,
        serviceAdministration,
        ldapAttributes,
        commonProtocolSpecification,
        oSIProtocolSpecification,
        directoryOSIProtocols,
        ldapSystemSchema,
        passwordPolicy,
        pkiPmiExternalDataTypes,
        extensionAttributes,
        pkiPmiWrapper,
        avlManagement,
        trustBrokerProtocol,
        id_oc,
        id_at,
        id_as,
        id_mr,
        id_nf,
        id_sc,
        id_oa,
        id_ob,
        id_doa,
        id_kmr,
        id_soc,
        id_soa,
        id_ar,
        id_aca,
        id_ac,
        id_acScheme,
        id_ce,
        id_mgt,
        id_avc,
        id_idm,
        id_pr,
        id_not,
        id_mre,
        id_cat,
        id_kp,
        id_pq,
        id_ats,
        id_asx,
        id_lsx,
        id_ldx,
        id_lat,
        id_lmr,
        id_oat,
        id_coat,
        id_avr,
        id_cmsct,
    ]

class _IMPL_:

    _name_ = '_IMPL_'
    _oid_  = []
    _obj_  = ['REAL', 'EXTERNAL', 'EMBEDDED PDV', 'CHARACTER STRING', 'TYPE-IDENTIFIER', 'ABSTRACT-SYNTAX']
    
    #-----< REAL >-----#
    REAL = SEQ(name='REAL', mode=MODE_TYPE)
    _REAL_mantissa = INT(name='mantissa', mode=MODE_TYPE)
    _REAL_base = INT(name='base', mode=MODE_TYPE)
    _REAL_base._const_val = ASN1Set(rv=[2, 10], rr=[], ev=None, er=[])
    _REAL_exponent = INT(name='exponent', mode=MODE_TYPE)
    REAL._cont = ASN1Dict([
        ('mantissa', _REAL_mantissa),
        ('base', _REAL_base),
        ('exponent', _REAL_exponent),
        ])
    REAL._ext = None
    
    #-----< EXTERNAL >-----#
    EXTERNAL = SEQ(name='EXTERNAL', mode=MODE_TYPE)
    _EXTERNAL_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___EXTERNAL_identification_syntaxes_abstract),
        ('transfer', ___EXTERNAL_identification_syntaxes_transfer),
        ])
    __EXTERNAL_identification_syntaxes._ext = None
    __EXTERNAL_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___EXTERNAL_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___EXTERNAL_identification_context_negotiation_transfer_syntax),
        ])
    __EXTERNAL_identification_context_negotiation._ext = None
    __EXTERNAL_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _EXTERNAL_identification._cont = ASN1Dict([
        ('syntaxes', __EXTERNAL_identification_syntaxes),
        ('syntax', __EXTERNAL_identification_syntax),
        ('presentation-context-id', __EXTERNAL_identification_presentation_context_id),
        ('context-negotiation', __EXTERNAL_identification_context_negotiation),
        ('transfer-syntax', __EXTERNAL_identification_transfer_syntax),
        ('fixed', __EXTERNAL_identification_fixed),
        ])
    _EXTERNAL_identification._ext = None
    _EXTERNAL_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EXTERNAL_data_value = OCT_STR(name='data-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    EXTERNAL._cont = ASN1Dict([
        ('identification', _EXTERNAL_identification),
        ('data-value-descriptor', _EXTERNAL_data_value_descriptor),
        ('data-value', _EXTERNAL_data_value),
        ])
    EXTERNAL._ext = None
    
    #-----< EMBEDDED PDV >-----#
    EMBEDDED_PDV = SEQ(name='EMBEDDED PDV', mode=MODE_TYPE)
    _EMBEDDED_PDV_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___EMBEDDED_PDV_identification_syntaxes_abstract),
        ('transfer', ___EMBEDDED_PDV_identification_syntaxes_transfer),
        ])
    __EMBEDDED_PDV_identification_syntaxes._ext = None
    __EMBEDDED_PDV_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax),
        ])
    __EMBEDDED_PDV_identification_context_negotiation._ext = None
    __EMBEDDED_PDV_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _EMBEDDED_PDV_identification._cont = ASN1Dict([
        ('syntaxes', __EMBEDDED_PDV_identification_syntaxes),
        ('syntax', __EMBEDDED_PDV_identification_syntax),
        ('presentation-context-id', __EMBEDDED_PDV_identification_presentation_context_id),
        ('context-negotiation', __EMBEDDED_PDV_identification_context_negotiation),
        ('transfer-syntax', __EMBEDDED_PDV_identification_transfer_syntax),
        ('fixed', __EMBEDDED_PDV_identification_fixed),
        ])
    _EMBEDDED_PDV_identification._ext = None
    _EMBEDDED_PDV_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EMBEDDED_PDV_data_value = OCT_STR(name='data-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    EMBEDDED_PDV._cont = ASN1Dict([
        ('identification', _EMBEDDED_PDV_identification),
        ('data-value-descriptor', _EMBEDDED_PDV_data_value_descriptor),
        ('data-value', _EMBEDDED_PDV_data_value),
        ])
    EMBEDDED_PDV._ext = None
    
    #-----< CHARACTER STRING >-----#
    CHARACTER_STRING = SEQ(name='CHARACTER STRING', mode=MODE_TYPE)
    _CHARACTER_STRING_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___CHARACTER_STRING_identification_syntaxes_abstract),
        ('transfer', ___CHARACTER_STRING_identification_syntaxes_transfer),
        ])
    __CHARACTER_STRING_identification_syntaxes._ext = None
    __CHARACTER_STRING_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax),
        ])
    __CHARACTER_STRING_identification_context_negotiation._ext = None
    __CHARACTER_STRING_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _CHARACTER_STRING_identification._cont = ASN1Dict([
        ('syntaxes', __CHARACTER_STRING_identification_syntaxes),
        ('syntax', __CHARACTER_STRING_identification_syntax),
        ('presentation-context-id', __CHARACTER_STRING_identification_presentation_context_id),
        ('context-negotiation', __CHARACTER_STRING_identification_context_negotiation),
        ('transfer-syntax', __CHARACTER_STRING_identification_transfer_syntax),
        ('fixed', __CHARACTER_STRING_identification_fixed),
        ])
    _CHARACTER_STRING_identification._ext = None
    _CHARACTER_STRING_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CHARACTER_STRING_string_value = OCT_STR(name='string-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    CHARACTER_STRING._cont = ASN1Dict([
        ('identification', _CHARACTER_STRING_identification),
        ('data-value-descriptor', _CHARACTER_STRING_data_value_descriptor),
        ('string-value', _CHARACTER_STRING_string_value),
        ])
    CHARACTER_STRING._ext = None
    
    #-----< TYPE-IDENTIFIER >-----#
    TYPE_IDENTIFIER = CLASS(name='TYPE-IDENTIFIER', mode=MODE_TYPE)
    _TYPE_IDENTIFIER_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _TYPE_IDENTIFIER_Type = OPEN(name='Type', mode=MODE_TYPE)
    TYPE_IDENTIFIER._cont = ASN1Dict([
        ('id', _TYPE_IDENTIFIER_id),
        ('Type', _TYPE_IDENTIFIER_Type),
        ])
    
    #-----< ABSTRACT-SYNTAX >-----#
    ABSTRACT_SYNTAX = CLASS(name='ABSTRACT-SYNTAX', mode=MODE_TYPE)
    _ABSTRACT_SYNTAX_id = OID(name='id', mode=MODE_VALUE)
    _ABSTRACT_SYNTAX_Type = OPEN(name='Type', mode=MODE_TYPE)
    _ABSTRACT_SYNTAX_property = BIT_STR(name='property', mode=MODE_VALUE, default=(0, 0))
    _ABSTRACT_SYNTAX_property._cont = ASN1Dict([('handles-invalid-encodings', 0)])
    ABSTRACT_SYNTAX._cont = ASN1Dict([
        ('id', _ABSTRACT_SYNTAX_id),
        ('Type', _ABSTRACT_SYNTAX_Type),
        ('property', _ABSTRACT_SYNTAX_property),
        ])
    
    _all_ = [
        _REAL_mantissa,
        _REAL_base,
        _REAL_exponent,
        REAL,
        ___EXTERNAL_identification_syntaxes_abstract,
        ___EXTERNAL_identification_syntaxes_transfer,
        __EXTERNAL_identification_syntaxes,
        __EXTERNAL_identification_syntax,
        __EXTERNAL_identification_presentation_context_id,
        ___EXTERNAL_identification_context_negotiation_presentation_context_id,
        ___EXTERNAL_identification_context_negotiation_transfer_syntax,
        __EXTERNAL_identification_context_negotiation,
        __EXTERNAL_identification_transfer_syntax,
        __EXTERNAL_identification_fixed,
        _EXTERNAL_identification,
        _EXTERNAL_data_value_descriptor,
        _EXTERNAL_data_value,
        EXTERNAL,
        ___EMBEDDED_PDV_identification_syntaxes_abstract,
        ___EMBEDDED_PDV_identification_syntaxes_transfer,
        __EMBEDDED_PDV_identification_syntaxes,
        __EMBEDDED_PDV_identification_syntax,
        __EMBEDDED_PDV_identification_presentation_context_id,
        ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id,
        ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax,
        __EMBEDDED_PDV_identification_context_negotiation,
        __EMBEDDED_PDV_identification_transfer_syntax,
        __EMBEDDED_PDV_identification_fixed,
        _EMBEDDED_PDV_identification,
        _EMBEDDED_PDV_data_value_descriptor,
        _EMBEDDED_PDV_data_value,
        EMBEDDED_PDV,
        ___CHARACTER_STRING_identification_syntaxes_abstract,
        ___CHARACTER_STRING_identification_syntaxes_transfer,
        __CHARACTER_STRING_identification_syntaxes,
        __CHARACTER_STRING_identification_syntax,
        __CHARACTER_STRING_identification_presentation_context_id,
        ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id,
        ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax,
        __CHARACTER_STRING_identification_context_negotiation,
        __CHARACTER_STRING_identification_transfer_syntax,
        __CHARACTER_STRING_identification_fixed,
        _CHARACTER_STRING_identification,
        _CHARACTER_STRING_data_value_descriptor,
        _CHARACTER_STRING_string_value,
        CHARACTER_STRING,
        _TYPE_IDENTIFIER_id,
        _TYPE_IDENTIFIER_Type,
        TYPE_IDENTIFIER,
        _ABSTRACT_SYNTAX_id,
        _ABSTRACT_SYNTAX_Type,
        _ABSTRACT_SYNTAX_property,
        ABSTRACT_SYNTAX,
    ]

init_modules(ACSE_1, Attribute_ASN1Module, AttributeCertificateDefinitions, AuthenticationFramework, BasicAccessControl, Basic_Service_Elements, CAP_classes, CAP_datatypes, CAP_errorcodes, CAP_errortypes, CAP_gprsSSF_gsmSCF_ops_args, CAP_gprsSSF_gsmSCF_pkgs_contracts_acs, CAP_gsmSCF_gsmSRF_ops_args, CAP_gsmSCF_gsmSRF_pkgs_contracts_acs, CAP_gsmSSF_gsmSCF_ops_args, CAP_gsmSSF_gsmSCF_pkgs_contracts_acs, CAP_object_identifiers, CAP_operationcodes, CAP_SMS_ops_args, CAP_smsSSF_gsmSCF_pkgs_contracts_acs, CertificateExtensions, CMIP_1, CommonProtocolSpecification, CPDTChargingDataTypes, CS1_DataTypes, CS2_datatypes, CSChargingDataTypes, DialoguePDUs, DirectoryAbstractService, DirectoryOperationalBindingTypes, DirectoryOSIProtocols, DirectoryShadowAbstractService, DistributedOperations, DSAOperationalAttributeTypes, EnhancedSecurity, GenericChargingDataTypes, GPRSChargingDataTypes, HierarchicalOperationalBindings, IMSChargingDataTypes, InformationFramework, LCSChargingDataTypes, LdapSystemSchema, Lightweight_Directory_Access_Protocol_V3, MAP_BS_Code, MAP_CH_DataTypes, MAP_CommonDataTypes, MAP_ER_DataTypes, MAP_ExtensionDataTypes, MAP_LCS_DataTypes, MAP_MS_DataTypes, MAP_OM_DataTypes, MAP_SM_DataTypes, MAP_SS_Code, MAP_SS_DataTypes, MAP_TS_Code, MBMSChargingDataTypes, MMSChargingDataTypes, MMTelChargingDataTypes, MONTEChargingDataTypes, OperationalBindingManagement, OSIProtocolSpecification, PasswordPolicy, PkiPmiExternalDataTypes, POCChargingDataTypes, ProSeChargingDataTypes, Remote_Operations_Generic_ROS_PDUs, Remote_Operations_Information_Objects, Remote_Operations_Useful_Definitions, SchemaAdministration, SelectedAttributeTypes, ServiceAdministration, SMSChargingDataTypes, SpkmGssTokens, SS_DataTypes, TCAPMessages, TC_Notation_Extensions, UnidialoguePDUs, UsefulDefinitions, _IMPL_)
